=== modified file '.bzrignore'
--- .bzrignore	2008-09-03 06:31:11 +0000
+++ .bzrignore	2007-10-02 02:54:30 +0000
@@ -38,17 +38,11 @@
 ./api
 doc/**/*.html
 doc/developers/performance.png
-bzrlib/_btree_serializer_c.c
 bzrlib/_dirstate_helpers_c.c
 bzrlib/_knit_load_data_c.c
-bzrlib/_readdir_pyx.c
-bzrlib/_walkdirs_win32.c
 doc/en/release-notes/NEWS.txt
 doc/en/developer-guide/HACKING.txt
 doc/en/user-reference/bzr_man.txt
 # built extension modules
-bzrlib/_*_c.dll
 bzrlib/_*_c.so
 bzrlib/_*_c.pyd
-# generated help topics
-doc/en/user-reference/*.txt

=== modified file 'Makefile'
--- Makefile	2008-08-28 07:11:13 +0000
+++ Makefile	2007-10-20 03:27:12 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2008 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -21,7 +21,6 @@
 ### Core Stuff ###
 
 PYTHON=python
-PYTHON_BUILDFLAGS=
 
 .PHONY: all clean extensions pyflakes api-docs
 
@@ -29,10 +28,10 @@
 
 extensions:
 	@echo "building extension modules."
-	$(PYTHON) setup.py build_ext -i $(PYTHON_BUILDFLAGS)
+	$(PYTHON) setup.py build_ext -i
 
 check: docs extensions
-	$(PYTHON) -Werror -O ./bzr selftest -1v $(tests)
+	python -Werror -O ./bzr selftest -1v $(tests)
 	@echo "Running all tests with no locale."
 	LC_CTYPE= LANG=C LC_ALL= ./bzr selftest -1v $(tests) 2>&1 | sed -e 's/^/[ascii] /'
 
@@ -49,16 +48,16 @@
 	pyflakes bzrlib | grep -v ' imported but unused'
 
 clean:
-	$(PYTHON) setup.py clean
+	python setup.py clean
 	-find . -name "*.pyc" -o -name "*.pyo" -o -name "*.so" | xargs rm -f
 
 # Build API documentation
 docfiles = bzr bzrlib
 api-docs:
 	mkdir -p api/html
-	PYTHONPATH=$(PWD) $(PYTHON) tools/bzr_epydoc --html -o api/html --docformat 'restructuredtext en' $(docfiles)
+	PYTHONPATH=$(PWD) python tools/bzr_epydoc --html -o api/html --docformat 'restructuredtext en' $(docfiles)
 check-api-docs:
-	PYTHONPATH=$(PWD) $(PYTHON) tools/bzr_epydoc --check --docformat 'restructuredtext en' $(docfiles)
+	PYTHONPATH=$(PWD) python tools/bzr_epydoc --check --docformat 'restructuredtext en' $(docfiles)
 
 # build tags for emacs and vim
 TAGS:
@@ -74,9 +73,9 @@
 
 # set PRETTY to get docs that look like the Bazaar web site
 ifdef PRETTY
-rst2html := $(PYTHON) tools/rst2prettyhtml.py doc/bazaar-vcs.org.kid 
+rst2html := python tools/rst2prettyhtml.py doc/bazaar-vcs.org.kid 
 else
-rst2html := $(PYTHON) tools/rst2html.py --link-stylesheet --footnote-references=superscript --halt=warning
+rst2html := python tools/rst2html.py --link-stylesheet --footnote-references=superscript 
 endif
 
 # translate txt docs to html
@@ -84,31 +83,17 @@
 	doc/en/user-reference/bzr_man.txt \
 	doc/en/developer-guide/HACKING.txt \
 	doc/en/release-notes/NEWS.txt
-txt_files := $(wildcard doc/en/tutorials/*.txt) \
-	$(derived_txt_files) \
-	doc/en/user-guide/index.txt \
+doc_dir := doc/en/user-guide
+txt_files := $(wildcard $(addsuffix /*.txt, $(doc_dir))) $(derived_txt_files) \
 	doc/en/mini-tutorial/index.txt \
-	$(wildcard doc/es/guia-usario/*.txt) \
-	doc/es/mini-tutorial/index.txt \
-	doc/index.txt \
-	doc/index.es.txt
+	doc/index.txt
 non_txt_files := \
        doc/default.css \
-       doc/en/quick-reference/quick-start-summary.svg \
-       doc/en/quick-reference/quick-start-summary.png \
-       doc/en/quick-reference/quick-start-summary.pdf \
-       $(wildcard doc/en/user-guide/images/*.png) \
-       doc/es/referencia-rapida/referencia-rapida.svg \
-       doc/es/referencia-rapida/referencia-rapida.png \
-       doc/es/referencia-rapida/referencia-rapida.pdf \
-       $(wildcard doc/es/guia-usuario/images/*.png)
+       doc/en/quick-reference/quick-start-summary.svg
 htm_files := $(patsubst %.txt, %.html, $(txt_files)) 
 dev_txt_files := $(wildcard $(addsuffix /*.txt, doc/developers))
 dev_htm_files := $(patsubst %.txt, %.html, $(dev_txt_files)) 
 
-doc/en/user-guide/index.html: $(wildcard $(addsuffix /*.txt, doc/en/user-guide)) 
-	$(rst2html) --stylesheet=../../default.css doc/en/user-guide/index.txt $@
-
 doc/developers/%.html: doc/developers/%.txt
 	$(rst2html) --stylesheet=../default.css $< $@
 
@@ -121,27 +106,24 @@
 MAN_DEPENDENCIES = bzrlib/builtins.py \
 		 bzrlib/bundle/commands.py \
 		 bzrlib/conflicts.py \
-		 bzrlib/help_topics/__init__.py \
 		 bzrlib/sign_my_commits.py \
-		 bzrlib/bugtracker.py \
 		 generate_docs.py \
 		 tools/doc_generate/__init__.py \
 		 tools/doc_generate/autodoc_man.py \
-		 tools/doc_generate/autodoc_rstx.py \
-		 $(wildcard $(addsuffix /*.txt, bzrlib/help_topics/en)) 
+		 tools/doc_generate/autodoc_rstx.py
 
 doc/en/user-reference/bzr_man.txt: $(MAN_DEPENDENCIES)
-	$(PYTHON) generate_docs.py -o $@ rstx
+	python generate_docs.py -o $@ rstx
 
 doc/en/developer-guide/HACKING.txt: doc/developers/HACKING.txt
-	$(PYTHON) tools/win32/ostools.py copytodir doc/developers/HACKING.txt doc/en/developer-guide
+	python tools/win32/ostools.py copytodir doc/developers/HACKING.txt doc/en/developer-guide
 
 doc/en/release-notes/NEWS.txt: NEWS
-	$(PYTHON) -c "import shutil; shutil.copyfile('$<', '$@')"
+	python -c "import shutil; shutil.copyfile('$<', '$@')"
 
 MAN_PAGES = man1/bzr.1
 man1/bzr.1: $(MAN_DEPENDENCIES)
-	$(PYTHON) generate_docs.py -o $@ man
+	python generate_docs.py -o $@ man
 
 # build a png of our performance task list
 doc/developers/performance.png: doc/developers/performance.dot
@@ -158,11 +140,11 @@
 # produce a tree containing just the final docs, ready for uploading to the web
 HTMLDIR := html_docs
 html-docs: docs
-	$(PYTHON) tools/win32/ostools.py copytree $(WEB_DOCS) $(HTMLDIR)
+	python tools/win32/ostools.py copytree $(WEB_DOCS) $(HTMLDIR)
 
 # clean produced docs
 clean-docs:
-	$(PYTHON) tools/win32/ostools.py remove $(ALL_DOCS) \
+	python tools/win32/ostools.py remove $(ALL_DOCS) \
 	$(HTMLDIR) $(derived_txt_files)
 
 
@@ -171,85 +153,33 @@
 # make bzr.exe for win32 with py2exe
 exe:
 	@echo *** Make bzr.exe
-	$(PYTHON) setup.py build_ext -i -f $(PYTHON_BUILDFLAGS)
-	$(PYTHON) setup.py py2exe > py2exe.log
-	$(PYTHON) tools/win32/ostools.py copytodir tools/win32/start_bzr.bat win32_bzr.exe
-	$(PYTHON) tools/win32/ostools.py copytodir tools/win32/bazaar.url win32_bzr.exe
+	python setup.py build_ext -i -f
+	python setup.py py2exe > py2exe.log
+	python tools/win32/ostools.py copytodir tools/win32/start_bzr.bat win32_bzr.exe
+	python tools/win32/ostools.py copytodir tools/win32/bazaar.url win32_bzr.exe
 
 # win32 installer for bzr.exe
 installer: exe copy-docs
 	@echo *** Make windows installer
-	$(PYTHON) tools/win32/run_script.py cog.py -d -o tools/win32/bzr.iss tools/win32/bzr.iss.cog
+	cog.py -d -o tools/win32/bzr.iss tools/win32/bzr.iss.cog
 	iscc /Q tools/win32/bzr.iss
 
-# win32 Python's distutils-based installer
-# require to have Python interpreter installed on win32
-py-inst-24: docs
+# win32 python's distutils-based installer
+# require to have python interpreter installed on win32
+python-installer: docs
 	python24 setup.py bdist_wininst --install-script="bzr-win32-bdist-postinstall.py" -d .
-
-py-inst-25: docs
 	python25 setup.py bdist_wininst --install-script="bzr-win32-bdist-postinstall.py" -d .
 
-python-installer: py-inst-24 py-inst-25
-
-
 copy-docs: docs
-	$(PYTHON) tools/win32/ostools.py copytodir README win32_bzr.exe/doc
-	$(PYTHON) tools/win32/ostools.py copytree $(WEB_DOCS) win32_bzr.exe
+	python tools/win32/ostools.py copytodir README win32_bzr.exe/doc
+	python tools/win32/ostools.py copytree $(WEB_DOCS) win32_bzr.exe
 
 # clean on win32 all installer-related files and directories
 clean-win32: clean-docs
-	$(PYTHON) tools/win32/ostools.py remove build
-	$(PYTHON) tools/win32/ostools.py remove win32_bzr.exe
-	$(PYTHON) tools/win32/ostools.py remove py2exe.log
-	$(PYTHON) tools/win32/ostools.py remove tools/win32/bzr.iss
-	$(PYTHON) tools/win32/ostools.py remove bzr-setup*.exe
-	$(PYTHON) tools/win32/ostools.py remove bzr-*win32.exe
-	$(PYTHON) tools/win32/ostools.py remove dist
-
-.PHONY: dist dist-upload-escudero check-dist-tarball
-
-# build a distribution tarball.
-#
-# this method of copying the pyrex generated files is a bit ugly; it would be
-# nicer to generate it from distutils.
-#
-# these are a bit ubuntu-specific.
-dist: 
-	version=`./bzr version --short` && \
-	echo Building distribution of bzr $$version && \
-	expbasedir=`mktemp -t -d tmp_bzr_dist.XXXXXXXXXX` && \
-	expdir=$$expbasedir/bzr-$$version && \
-	tarball=$$PWD/../bzr-$$version.tar.gz && \
-	$(MAKE) clean && \
-	$(MAKE) && \
-	bzr export $$expdir && \
-	cp bzrlib/*.c $$expdir/bzrlib/. && \
-	tar cfz $$tarball -C $$expbasedir bzr-$$version && \
-	gpg --detach-sign $$tarball && \
-	echo $$tarball done. && \
-	rm -rf $$expbasedir
-
-# run all tests in a previously built tarball
-check-dist-tarball:
-	tmpdir=`mktemp -t -d tmp_bzr_check_dist.XXXXXXXXXX` && \
-	version=`./bzr version --short` && \
-	tarball=$$PWD/../bzr-$$version.tar.gz && \
-	tar Cxz $$tmpdir -f $$tarball && \
-	$(MAKE) -C $$tmpdir/bzr-$$version check && \
-	rm -rf $$tmpdir
-
-
-# upload previously built tarball to the download directory on bazaar-vcs.org,
-# and verify that it can be downloaded ok.
-dist-upload-escudero:
-	version=`./bzr version --short` && \
-	tarball=../bzr-$$version.tar.gz && \
-	scp $$tarball $$tarball.sig \
-	    escudero.ubuntu.com:/srv/bazaar.canonical.com/www/releases/src \
-		&& \
-	echo verifying over http... && \
-	curl http://bazaar-vcs.org/releases/src/bzr-$$version.tar.gz \
-		| diff -s - $$tarball && \
-	curl http://bazaar-vcs.org/releases/src/bzr-$$version.tar.gz.sig \
-		| diff -s - $$tarball.sig 
+	python tools/win32/ostools.py remove build
+	python tools/win32/ostools.py remove win32_bzr.exe
+	python tools/win32/ostools.py remove py2exe.log
+	python tools/win32/ostools.py remove tools/win32/bzr.iss
+	python tools/win32/ostools.py remove bzr-setup*.exe
+	python tools/win32/ostools.py remove bzr-*win32.exe
+	python tools/win32/ostools.py remove dist

=== modified file 'NEWS'
--- NEWS	2008-09-03 22:30:56 +0000
+++ NEWS	2007-11-04 15:24:27 +0000
@@ -1,2443 +1,11 @@
---------------------
+====================
 Bazaar Release Notes
---------------------
+====================
 
 .. contents::
 
 IN DEVELOPMENT
---------------
-
-  CHANGES:
-
-    * ``bzr export`` can now export a subdirectory of a project.
-      (Robert Collins)
-
-    * ``bzr rm`` will now scan for files that are missing and remove just
-      them automatically, much as ``bzr add`` scans for new files that
-      are not ignored and adds them automatically. (Robert Collins)
-
-  FEATURES
-
-    * Support for GSSAPI authentication when using FTP as documented in 
-      RFC2228. (Jelmer Vernooij, #49623)
-
-  IMPROVEMENTS:
-
-    * A url like ``log+file:///tmp`` will log all access to that Transport 
-      to ``.bzr.log``, which may help in debugging or profiling.
-      (Martin Pool)
-
-    * ``bzr branch`` and ``bzr push`` use the default stacking policy if the
-      branch format supports it. (Aaron Bentley)
-
-    * ``bzr init`` and ``bzr init-repo`` will now print out the same as
-      ``bzr info`` if it completed successfully.
-      (Marius Kruger)
-
-    * ``bzr uncommit`` logs the old tip revision id, and displays how to
-      restore the branch to that tip using ``bzr pull``.  This allows you
-      to recover if you realize you uncommitted the wrong thing.
-      (John Arbash Meinel)
-
-    * When reading index files, if we happen to read the whole file in a
-      single request treat it as a ``_buffer_all`` request. This happens
-      most often on small indexes over remote transports, where we default
-      to reading 64kB. It saves a round trip for each small index during
-      fetch operations. Also, if we have read more than 50% of an index
-      file, trigger a ``_buffer_all`` on the next request. This works
-      around some inefficiencies because reads don't fall neatly on page
-      boundaries, so we would ignore those bytes, but request them again
-      later. This could trigger a total read size of more than the whole
-      file. (John Arbash Meinel)
-
-  BUG FIXES:
-
-    * ``bzr rm`` is now aliased to ``bzr del`` for the convenience of svn
-      users. (Robert Collins, #205416)
-
-    * Catch the infamous "select/poll returned error" which occurs when
-      pycurl try to send a body request to an HTTP/1.0 server which has
-      already refused to handle the request. (Vincent Ladeuil, #225020)
-
-    * ``FTPTransport.stat()`` would return ``0000`` as the permission bits
-      for the containing ``.bzr/`` directory (it does not implement
-      permissions). This would cause us to set all subdirectories to
-      ``0700`` and files to ``0600`` rather than leaving them unmodified.
-      Now we ignore ``0000`` as the permissions and assume they are
-      invalid. (John Arbash Meinel, #259855)
-
-    * Merging from a previously joined branch will no longer cause 
-      a traceback. (Jelmer Vernooij, #203376)
-
-    * Pack operations on windows network shares will work even with large
-      files. (Robert Collins, #255656)
-
-    * Running ``bzr st PATH_TO_TREE`` will no longer suppress merge
-      status. Status is also about 7% faster on mozilla sized trees
-      when the path to the root of the tree has been given. Users of
-      the internal ``show_tree_status`` function should be aware that
-      the show_pending flag is now authoritative for showing pending
-      merges, as it was originally. (Robert Collins, #225204)
-
-    * Set valid default _param_name for Option so that ListOption can embed
-      '-' in names. (Vincent Ladeuil, #263249)
-
-    * Show proper error rather than traceback when an unknown revision 
-      id is specified to ``bzr cat-revision``. (Jelmer Vernooij, #175569)
-
-    * Trailing text in the dirstate file could cause the C dirstate parser
-      to try to allocate an invalid amount of memory. We now properly
-      check and test for parsing a dirstate with invalid trailing data.
-      (John Arbash Meinel, #186014)
-
-    * Use a Windows api function to get a Unicode host name, rather than
-      assuming the host name is ascii.
-      (Mark Hammond, John Arbash Meinel, #256550)
-
-    * ``WorkingTree4`` trees will now correctly report missing-and-new
-      paths in the output of ``iter_changes``. (Robert Collins)
-
-  API CHANGES:
-
-    * Exporters now take 4 parameters. (Robert Collins)
-
-    * ``Tree.iter_changes`` will now return False for the content change
-      field when a file is missing in the basis tree and not present in
-      the target tree. Previously it returned True unconditionally.
-      (Robert Collins)
-
-    * The deprecated ``Branch.abspath`` and unimplemented 
-      ``Branch.rename_one`` and ``Branch.move`` were removed. (Jelmer Vernooij)
-
-    * BzrDir.clone_on_transport implementations must now accept a stacked_on
-      parameter.  (Aaron Bentley)
-
-    * BzrDir.cloning_metadir implementations must now take a require_stacking
-      parameter.  (Aaron Bentley)
-
-  TESTING:
-
-    * ``addCleanup`` now takes ``*arguments`` and ``**keyword_arguments``
-      which are then passed to the cleanup callable as it is run. In
-      addition, addCleanup no longer requires that the callables passed to
-      it be unique. (Jonathan Lange)
-
-    * ``selftest``'s ``--starting-with`` option can now use predefined
-      prefixes so that one can say ``bzr selftest -s bp.loom`` instead of
-      ``bzr selftest -s bzrlib.plugins.loom``. (Vincent Ladeuil)
-
-    * ``selftest``'s ``--starting-with`` option now accepts multiple values.
-      (Vincent Ladeuil)
-
-  INTERNALS:
-
-    * A new plugin interface, ``bzrlib.log.log_adapters``, has been added.
-      This allows dynamic log output filtering by plugins.
-      (Robert Collins)
-
-    * ``bzrlib.btree_index`` is now available, providing a b-tree index
-      layer. The design is memory conservative (limited memory cache),
-      faster to seek (approx 100 nodes per page, gives 100-way fan out),
-      and stores compressed pages allowing more keys per page.
-      (Robert Collins, John Arbash Meinel)
-
-    * ``bzrlib.diff.DiffTree.show_diff`` now skips changes where the kind
-      is unknown in both source and target.
-      (Robert Collins, Aaron Bentley)
-
-    * ``GraphIndexBuilder.add_node`` and ``BTreeBuilder`` have been
-      streamlined a bit. This should make creating large indexes faster.
-      (In benchmarking, it now takes less time to create a BTree index than
-      it takes to read the GraphIndex one.) (John Arbash Meinel)
-
-    * Mail clients for `bzr send` are now listed in a registry.  This
-      allows plugins to add new clients by registering them with
-      ``bzrlib.mail_client.mail_client_registry``.  All of the built-in
-      clients now use this mechanism.  (Neil Martinsen-Burrell)
-
-
-bzr 1.6.1rc2 2008-09-03
------------------------
-
-  BUG FIXES:
-
-    * Copying between ``rich-root`` and ``rich-root-pack`` (and vice
-      versa) was accidentally using the inter-model fetcher, instead of
-      recognizing that both were 'rich root' formats.
-      (John Arbash Meinel, #264321)
-
-
-bzr 1.6.1rc1 2008-08-29
------------------------
-
-This release fixes a few regressions found in the 1.6 client. Fetching
-changes was using an O(N^2) buffering algorithm, so for large projects it
-would cause memory thrashing. There is also a specific problem with the
-``--1.6-rich-root`` format, which prevented stacking on top of
-``--rich-root-pack`` repositories, and could allow users to accidentally
-fetch experimental data (``-subtree``) without representing it properly.
-The ``--1.6-rich-root`` format has been deprecated and users are
-recommended to upgrade to ``--1.6.1-rich-root`` immediately.  Also we
-re-introduced a workaround for users who have repositories with incorrect
-nodes (not possible if you only used official releases).
-I should also clarify that none of this is data loss level issues, but
-still sufficient enough to warrant an updated release.
-
-  BUG FIXES:
-
-    * ``RemoteTransport.readv()`` was being inefficient about how it
-      buffered the readv data and processed it. It would keep appending to
-      the same string (causing many copies) and then pop bytes out of the
-      start of the string (causing more copies).
-      With this patch "bzr+ssh://local" can improve dramatically,
-      especially for projects with large files.
-      (John Arbash Meinel)
-
-    * Revision texts were always meant to be stored as fulltexts. There
-      was a bug in a bzr.dev version that would accidentally create deltas
-      when copying from a Pack repo to a Knit repo. This has been fixed,
-      but to support those repositories, we know always request full texts
-      for Revision texts. (John Arbash Meinel, #261339)
-
-    * The previous ``--1.6-rich-root`` format used an incorrect xml
-      serializer, which would accidentally support fetching from a
-      repository that supported subtrees, even though the local one would
-      not. We deprecated that format, and introduced a new one that uses
-      the correct serializer ``--1.6.1-rich-root``.
-      (John Arbash Meinel, #262333)
-
-
-bzr 1.6 2008-08-25
-------------------
-
-Finally, the long awaited bzr 1.6 has been released. This release includes
-new features like Stacked Branches, improved weave merge, and an updated
-server protocol (now on v3) which will allow for better cross version
-compatibility. With this release we have deprecated Knit format
-repositories, and recommend that users upgrade them, we will continue to
-support reading and writing them for the forseeable future, but we will
-not be tuning them for performance as pack repositories have proven to be
-better at scaling. This will also be the first release to bundle
-TortoiseBzr in the standalone Windows installer.
-
-
-bzr 1.6rc5 2008-08-19
----------------------
-
-  BUG FIXES: 
-
-    * Disable automatic detection of stacking based on a containing
-      directory of the target. It interacted badly with push, and needs a
-      bit more work to get the edges polished before it should happen
-      automatically. (John Arbash Meinel, #259275)
-      (This change was reverted when merged to bzr.dev)
-  
-
-bzr 1.6rc4 2008-08-18
----------------------
-
-  BUG FIXES: 
-
-    * Fix a regression in knit => pack fetching.  We had a logic
-      inversion, causing the fetch to insert fulltexts in random order,
-      rather than preserving deltas.  (John Arbash Meinel, #256757)
-
-
-bzr 1.6rc3 2008-08-14
----------------------
-
-  CHANGES:
-
-    * Disable reading ``.bzrrules`` as a per-branch rule preferences
-      file. The feature was not quite ready for a full release.
-      (Robert Collins)
-
-  IMPROVEMENTS:
-
-    * Update the windows installer to bundle TortoiseBzr and ``qbzr``
-      into the standalone installer. This will be the first official
-      windows release that installs Tortoise by default.
-      (Mark Hammond)
-
-  BUG FIXES: 
-
-    * Fix a regression in ``bzr+http`` support. There was a missing
-      function (``_read_line``) that needed to be carried over from
-      ``bzr+ssh`` support. (Andrew Bennetts)
-
-    * ``GraphIndex`` objects will internally read an entire index if more
-      than 1/20th of their keyspace is requested in a single operation.
-      This largely mitigates a performance regression in ``bzr log FILE``
-      and completely corrects the performance regression in ``bzr log``.
-      The regression was caused by removing an accomodation which had been
-      supporting the index format in use. A newer index format is in
-      development which is substantially faster. (Robert Collins)
-
-
-bzr 1.6rc2 2008-08-13
----------------------
-
-This release candidate has a few minor bug fixes, and some regression
-fixes for Windows.
-
-  BUG FIXES:
-
-    * ``bzr upgrade`` on remote branches accessed via bzr:// and
-      bzr+ssh:// now works.  (Andrew Bennetts)
-
-    * Change the ``get_format_description()`` strings for
-      ``RepositoryFormatKnitPack5`` et al to be single line messages.
-      (Aaron Bentley)
-
-    * Fix for a regression on Win32 where we would try to call
-      ``os.listdir()`` on a file and not catch the exception properly.
-      (Windows raises a different exception.) This would manifest in
-      places like ``bzr rm file`` or ``bzr switch``.
-      (Mark Hammond, John Arbash Meinel)
-
-    * ``Inventory.copy()`` was failing to set the revision property for
-      the root entry. (Jelmer Vernooij)
-
-    * sftp transport: added missing ``FileExists`` case to
-      ``_translate_io_exception`` (Christophe Troestler, #123475)
-
-    * The help for ``bzr ignored`` now suggests ``bzr ls --ignored`` for
-      scripting use. (Robert Collins, #3834)
-
-    * The default ``annotate`` logic will now always assign the
-      last-modified value of a line to one of the revisions that modified
-      it, rather than a merge revision. This would happen when both sides
-      claimed to have modified the line resulting in the same text. The
-      choice is arbitrary but stable, so merges in different directions
-      will get the same results.  (John Arbash Meinel, #232188)
-
-
-bzr 1.6rc1 2008-08-06
----------------------
-
-This release candidate for bzr 1.6 solidifies the new branch stacking
-feature.  Bazaar now recommends that users upgrade all knit repositories,
-because later formats are much faster.  However, we plan to continue read/write and
-upgrade support for knit repostories for the forseeable future.  Several
-other bugs and performance issues were fixed.
-
-  CHANGES:
-
-    * Knit format repositories are deprecated and bzr will now emit
-      warnings whenever it encounters one.  Use ``bzr upgrade`` to upgrade
-      knit repositories to pack format.  (Andrew Bennetts)
-
-  IMPROVEMENTS:
-
-    * ``bzr check`` can now be told which elements at a location it should
-      check.  (Daniel Watkins)
-
-    * Commit now supports ``--exclude`` (or ``-x``) to exclude some files
-      from the commit. (Robert Collins, #3117)
-
-    * Fetching data between repositories that have the same model but no 
-      optimised fetcher will not reserialise all the revisions, increasing
-      performance. (Robert Collins, John Arbash Meinel)
-
-    * Give a more specific error when target branch is not reachable.
-      (James Westby)
-
-    * Implemented a custom ``walkdirs_utf8`` implementation for win32.
-      This uses a pyrex extension to get direct access to the
-      ``FindFirstFileW`` style apis, rather than using ``listdir`` +
-      ``lstat``. Shows a very strong improvement in commands like
-      ``status`` and ``diff`` which have to iterate the working tree.
-      Anywhere from 2x-6x faster depending on the size of the tree (bigger
-      trees, bigger benefit.) (John Arbash Meinel)
-
-    * New registry for log properties handles  and the method in 
-      LongLogFormatter to display the custom properties returned by the 
-      registered handlers. (Guillermo Gonzalez, #162469)
-
-  BUG FIXES:
-
-    * Add more tests that stacking does not create deltas spanning
-      physical repository boundaries.
-      (Martin Pool, #252428)
-
-    * Better message about incompatible repositories.
-      (Martin Pool, #206258)
-
-    * ``bzr branch --stacked`` ensures the destination branch format can
-      support stacking, even if the origin does not.
-      (Martin Pool)
-
-    * ``bzr export`` no longer exports ``.bzrrules``.
-      (Ian Clatworthy)
-
-    * ``bzr serve --directory=/`` now correctly allows the whole
-      filesystem to be accessed on Windows, not just the root of the drive
-      that Python is running from.
-      (Adrian Wilkins, #240910)
-
-    * Deleting directories by hand before running ``bzr rm`` will not
-      cause subsequent errors in ``bzr st`` and ``bzr commit``.
-      (Robert Collins, #150438)
-
-    * Fix a test case that was failing if encoding wasn't UTF-8.
-      (John Arbash Meinel, #247585)
-
-    * Fix "no buffer space available" error when branching with the new
-      smart server protocol to or from Windows.
-      (Andrew Bennetts, #246180)
-
-    * Fixed problem in branching from smart server.
-      (#249256, Michael Hudson, Martin Pool) 
-
-    * Handle a file turning in to a directory in TreeTransform.
-      (James Westby, #248448)
-
-  API CHANGES:
-
-    * ``MutableTree.commit`` has an extra optional keywork parameter
-      ``exclude`` that will be unconditionally supplied by the command
-      line UI - plugins that add tree formats may need an update.
-      (Robert Collins)
-
-    * The API minimum version for plugin compatibility has been raised to
-      1.6 - there are significant changes throughout the code base.
-      (Robert Collins)
-
-    * The generic fetch code now uses three attributes on Repository objects
-      to control fetch. The streams requested are controlled via :
-      ``_fetch_order`` and ``_fetch_uses_deltas``. Setting these
-      appropriately allows different repository implementations to recieve
-      data in their optimial form. If the ``_fetch_reconcile`` is set then
-      a reconcile operation is triggered at the end of the fetch.
-      (Robert Collins)
-
-    * The ``put_on_disk`` and ``get_tar_item`` methods in
-      ``InventoryEntry`` were deprecated. (Ian Clatworthy)
-
-    * ``Repository.is_shared`` doesn't take a read lock. It didn't
-      need one in the first place (nobody cached the value, and
-      ``RemoteRepository`` wasn't taking one either). This saves a round
-      trip when probing Pack repositories, as they read the ``pack-names``
-      file when locked. And during probe, locking the repo isn't very
-      useful. (John Arbash Meinel)
-
-  INTERNALS:
-
-    * ``bzrlib.branchbuilder.BranchBuilder`` is now much more capable of
-      putting together a real history without having to create a full
-      WorkingTree. It is recommended that tests that are not directly
-      testing the WorkingTree use BranchBuilder instead.  See
-      ``BranchBuilder.build_snapshot`` or
-      ``TestCaseWithMemoryTree.make_branch_builder``.  (John Arbash Meinel)
-
-    * ``bzrlib.builtins.internal_tree_files`` broken into two giving a new
-      helper ``safe_relpath_files`` - used by the new ``exclude``
-      parameter to commit. (Robert Collins)
-
-    * Make it easier to introduce new WorkingTree formats.
-      (Ian Clatworthy)
-
-    * The code for exporting trees was refactored not to use the
-      deprecated ``InventoryEntry`` methods. (Ian Clatworthy)
-
-    * RuleSearchers return () instead of [] now when there are no matches.
-      (Ian Clatworthy)
-
-
-bzr 1.6beta3 2008-07-17
------------------------
-
-This release adds a new 'stacked branches' feature allowing branches to
-share storage without being in the same repository or on the same machine.
-(See the user guide for more details.)  It also adds a new hook, improved
-weaves, aliases for related locations, faster bzr+ssh push, and several
-bug fixes.
-
-  FEATURES:
-
-    * New ``pre_change_branch_tip`` hook that is called before the
-      branch tip is moved, while the branch is write-locked.  See the User
-      Reference for signature details.  (Andrew Bennetts)
-
-    * Rule-based preferences can now be defined for selected files in
-      selected branches, allowing commands and plugins to provide
-      custom behaviour for files matching defined patterns.
-      See ``Rule-based preferences`` (part of ``Configuring Bazaar``)
-      in the User Guide and ``bzr help rules`` for more information.
-      (Ian Clatworthy)
-
-    * Sites may suggest a branch to stack new branches on.  (Aaron Bentley)
-
-    * Stacked branches are now supported. See ``bzr help branch`` and 
-      ``bzr help push``.  Branches must be in the ``development1`` format
-      to stack, though the stacked-on branch can be of any format. 
-      (Robert Collins)
-
-  IMPROVEMENTS:
-
-    * ``bzr export --format=tgz --root=NAME -`` to export a gzipped tarball 
-      to stdout; also ``tar`` and ``tbz2``.
-      (Martin Pool)
-
-    * ``bzr (re)merge --weave`` will now use a standard Weave algorithm,
-      rather than the annotation-based merge it was using. It does so by
-      building up a Weave of the important texts, without needing to build
-      the full ancestry. (John Arbash Meinel, #238895)
-
-    * ``bzr send`` documents and better supports ``emacsclient`` (proper
-      escaping of mail headers and handling of the MUA Mew).
-      (Christophe Troestler)
-
-    * Remembered locations can be specified by aliases, e.g. :parent, :public,
-      :submit.  (Aaron Bentley)
-
-    * The smart protocol now has improved support for setting branches'
-      revision info directly.  This makes operations like push
-      faster.  The new request method name is
-      ``Branch.set_last_revision_ex``.  (Andrew Bennetts)
-
-  BUG FIXES:
-
-    * Bazaar is now able to be a client to the web server of IIS 6 and 7.
-      The broken implementations of RFC822 in Python and RFC2046 in IIS
-      combined with boundary-line checking in Bazaar previously made this
-      impossible. (NB, IIS 5 does not suffer from this problem).
-      (Adrian Wilkins, #247585)
-
-    * ``bzr log --long`` with a ghost in your mainline now handles that
-      ghost properly. (John Arbash Meinel, #243536)
-
-    * ``check`` handles the split-up .bzr layout correctly, so no longer
-      requires a branch to be present.
-      (Daniel Watkins, #64783)
-
-    * Clearer message about how to set the PYTHONPATH if bzrlib can't be
-      loaded. 
-      (Martin Pool, #205230)
-
-    * Errors about missing libraries are now shown without a traceback,
-      and with a suggestion to install the library.  The full traceback is 
-      still in ``.bzr.log`` and can be shown with ``-Derror``.
-      (Martin Pool, #240161)
-
-    * Fetch from a stacked branch copies all required data.
-      (Aaron Bentley, #248506)
-
-    * Handle urls such as ftp://user@host.com@www.host.com where the user
-      name contains an @.
-      (Neil Martinsen-Burrell, #228058)
-
-    * ``needs_read_lock`` and ``needs_write_lock`` now suppress an error during
-      ``unlock`` if there was an error in the original function. This helps
-      most when there is a failure with a smart server action, since often the
-      connection closes and we cannot unlock.
-      (Andrew Bennetts, John Arbash Meinel, #125784)
-
-    * Obsolete hidden command ``bzr fetch`` removed.
-      (Martin Pool, #172870)
-
-    * Raise the correct exception when doing ``-rbefore:0`` or ``-c0``.
-      (John Arbash Meinel, #239933)
-
-    * You can now compare file revisions in Windows diff programs from 
-      Cygwin Bazaar.
-      (Matt McClure, #209281)
-
-    * revision_history now tolerates mainline ghosts for Branch format 6.
-      (Aaron Bentley, #235055)
-
-    * Set locale from environment for third party libs.
-      (Martin von Gagern, #128496)
-
-  DOCUMENTATION:
-
-    * Added *Using stacked branches* to the User Guide.
-      (Ian Clatworthy)
-
-    * Updated developer documentation.
-      (Martin Pool)
-
-  TESTING:
-
-   * ``-Dmemory`` will cause /proc/PID/status to be catted before bzr
-     exits, allowing low-key analysis of peak memory use. (Robert Collins)
-
-   * ``TestCaseWithTransport.make_branch_and_tree`` tries harder to return
-     a tree with a ``branch`` attribute of the right format.  This was
-     preventing some ``RemoteBranch`` tests from actually running with
-     ``RemoteBranch`` instances.  (Andrew Bennetts)
-
-  API CHANGES:
-
-    * Removed ``Repository.text_store``, ``control_store``, etc.  Instead,
-      there are new attributes ``texts, inventories, revisions,
-      signatures``, each of which is a ``VersionedFiles``.  See the
-      Repository docstring for more details.
-      (Robert Collins)
-
-    * ``Branch.pull`` now accepts an ``_override_hook_target`` optional
-      parameter.  If you have a subclass of ``Branch`` that overrides
-      ``pull`` then you should add this parameter.  (Andrew Bennetts)
-
-    * ``bzrlib.check.check()`` has been deprecated in favour of the more
-      aptly-named ``bzrlib.check.check_branch()``.
-      (Daniel Watkins)
-
-    * ``Tree.print_file`` and ``Repository.print_file`` are deprecated.
-      These methods are bad APIs because they write directly to sys.stdout.
-      bzrlib does not use them internally, and there are no direct tests
-      for them. (Alexander Belchenko)
-
-  INTERNALS:
-
-    * ``cat`` command no longer uses ``Tree.print_file()`` internally.
-      (Alexander Belchenko)
-
-    * New class method ``BzrDir.open_containing_tree_branch_or_repository``
-      which eases the discovery of the tree, the branch and the repository
-      containing a given location.
-      (Daniel Watkins)
-
-    * New ``versionedfile.KeyMapper`` interface to abstract out the access to
-      underlying .knit/.kndx etc files in repositories with partitioned
-      storage. (Robert Collins)
-
-    * Obsolete developer-use command ``weave-join`` has been removed.
-      (Robert Collins)
-
-    * ``RemoteToOtherFetcher`` and ``get_data_stream_for_search`` removed,
-      to support new ``VersionedFiles`` layering.
-      (Robert Collins)
-
-
-bzr 1.6beta2 2008-06-10
------------------------
-
-This release contains further progress towards our 1.6 goals of shallow
-repositories, and contains a fix for some user-affecting bugs in the
-repository layer.  Building working trees during checkout and branch is
-now faster.
-
-  BUG FIXES:
-
-    * Avoid KnitCorrupt error extracting inventories from some repositories.
-      (The data is not corrupt; an internal check is detecting a problem
-      reading from the repository.)
-      (Martin Pool, Andrew Bennetts, Robert Collins, #234748)
-
-    * ``bzr status`` was breaking if you merged the same revision twice.
-      (John Arbash Meinel, #235407)
-
-    * Fix infinite loop consuming 100% CPU when a connection is lost while
-      reading a response body via the smart protocol v1 or v2.
-      (Andrew Bennetts)
-      
-    * Inserting a bundle which changes the contents of a file with no trailing
-      end of line, causing a knit snapshot in a 'knits' repository will no longer
-      cause KnitCorrupt. (Robert Collins)
-
-    * ``RemoteBranch.pull`` needs to return the ``self._real_branch``'s
-      pull result. It was instead just returning None, which breaks ``bzr
-      pull``. (John Arbash Meinel, #238149)
-
-    * Sanitize branch nick before using it as an attachment filename in
-      ``bzr send``. (Lukáš Lalinský, #210218)
-
-    * Squash ``inv_entry.symlink_target`` to a plain string when
-      generating DirState details. This prevents from getting a
-      ``UnicodeError`` when you have symlinks and non-ascii filenames.
-      (John Arbash Meinel, #135320)
-
-  IMPROVEMENTS:
-
-    * Added the 'alias' command to set/unset and display aliases. (Tim Penhey)
-
-    * ``added``, ``modified``, and ``unknowns`` behaviour made consistent (all three
-      now quote paths where required). Added ``--null`` option to ``added`` and 
-      ``modified`` (for null-separated unknowns, use ``ls --unknown --null``)
-      (Adrian Wilkins)
-
-    * Faster branching (1.09x) and lightweight checkouts (1.06x) on large trees.
-      (Ian Clatworthy, Aaron Bentley)
-
-  DOCUMENTATION:
-
-    * Added *Bazaar Zen* section to the User Guide. (Ian Clatworthy)
-
-  TESTING:
-
-    * Fix the test HTTPServer to be isolated from chdir calls made while it is
-      running, allowing it to be used in blackbox tests. (Robert Collins)
-
-  API CHANGES:
-
-    * ``WorkingTree.set_parent_(ids/trees)`` will now filter out revisions
-      which are in the ancestry of other revisions. So if you merge the same
-      tree twice, or merge an ancestor of an existing merge, it will only
-      record the newest. (If you merge a descendent, it will replace its
-      ancestor). (John Arbash Meinel, #235407)
-
-    * ``RepositoryPolicy.__init__`` now requires stack_on and stack_on_pwd,
-      through the derived classes do not.  (Aaron Bentley)
-
-  INTERNALS:
-
-    * ``bzrlib.bzrdir.BzrDir.sprout`` now accepts ``stacked`` to control
-      creating stacked branches. (Robert Collins)
-
-    * Knit record serialisation is now stricter on what it will accept, to
-      guard against potential internal bugs, or broken input. (Robert Collins)
-
-
-bzr 1.6beta1 2008-06-02
------------------------
-
-
-Commands that work on the revision history such as push, pull, missing,
-uncommit and log are now substantially faster.  This release adds a
-translation of some of the user documentation into Spanish.  (Contributions of
-other translations would be very welcome.)  Bazaar 1.6beta1 adds a new network
-protocol which is used by default and which allows for more efficient transfers
-and future extensions.
-
-
-  NOTES WHEN UPGRADING:
-
-    * There is a new version of the network protocol used for bzr://, bzr+ssh://
-      and bzr+http:// connections.  This will allow more efficient requests and
-      responses, and more graceful fallback when a server is too old to
-      recognise a request from a more recent client.  Bazaar 1.6 will
-      interoperate with 0.16 and later versions, but servers should be upgraded
-      when possible.  Bazaar 1.6 no longer interoperates with 0.15 and earlier via
-      these protocols.  Use alternatives like SFTP or upgrade those servers.
-      (Andrew Bennetts, #83935)
-
-  CHANGES:
-
-    * Deprecation warnings will not be suppressed when running ``bzr selftest``
-      so that developers can see if their code is using deprecated functions.
-      (John Arbash Meinel)
-
-  FEATURES:
-
-    * Adding ``-Derror`` will now display a traceback when a plugin fails to
-      load. (James Westby)
-
-  IMPROVEMENTS:
-
-    * ``bzr branch/push/pull -r XXX`` now have a helper function for finding
-      the revno of the new revision (``Graph.find_distance_to_null``). This
-      should make something like ``bzr branch -r -100`` in a shared, no-trees
-      repository much snappier. (John Arbash Meinel)
-
-    * ``bzr log --short -r X..Y`` no longer needs to access the full revision
-      history. This makes it noticeably faster when logging the last few
-      revisions. (John Arbash Meinel)
-
-    * ``bzr ls`` now accepts ``-V`` as an alias for ``--versioned``. 
-      (Jerad Cramp, #165086)
-
-    * ``bzr missing`` uses the new ``Graph.find_unique_ancestors`` and
-      ``Graph.find_differences`` to determine missing revisions without having
-      to search the whole ancestry. (John Arbash Meinel, #174625)
-
-    * ``bzr uncommit`` now uses partial history access, rather than always
-      extracting the full revision history for a branch. This makes it
-      resolve the appropriate revisions much faster (in testing it drops
-      uncommit from 1.5s => 0.4s). It also means ``bzr log --short`` is one
-      step closer to not using full revision history.
-      (John Arbash Meinel, #172649)
-
-  BUGFIXES:
-
-    * ``bzr merge --lca`` should handle when two revisions have no common
-      ancestor other than NULL_REVISION. (John Arbash Meinel, #235715)
-
-    * ``bzr status`` was breaking if you merged the same revision twice.
-      (John Arbash Meinel, #235407)
-
-    * ``bzr push`` with both ``--overwrite`` and ``-r NNN`` options no longer
-      fails.  (Andrew Bennetts, #234229)
-      
-    * Correctly track the base URL of a smart medium when using bzr+http://
-      URLs, which was causing spurious "No repository present" errors with
-      branches in shared repositories accessed over bzr+http.
-      (Andrew Bennetts, #230550)
-
-    * Define ``_remote_is_at_least_1_2`` on ``SmartClientMedium`` so that all
-      implementations have the attribute.  Fixes 'PyCurlTransport' object has no
-      attribute '_remote_is_at_least_1_2' attribute errors.
-      (Andrew Bennetts, #220806)
-
-    * Failure to delete an obsolete pack file should just give a warning
-      message, not a fatal error.  It may for example fail if the file is still
-      in use by another process.
-      (Martin Pool)
-      
-    * Fix MemoryError during large fetches over HTTP by limiting the amount of
-      data we try to read per ``recv`` call.  The problem was observed with
-      Windows and a proxy, but might affect other environments as well.
-      (Eric Holmberg, #215426)
-
-    * Handle old merge directives correctly in Merger.from_mergeable.  Stricter
-      get_parent_map requirements exposed a latent bug here.  (Aaron Bentley)
-
-    * Issue a warning and ignore passwords declared in authentication.conf when
-      used for an ssh scheme (sftp or bzr+ssh).
-      (Vincent Ladeuil, #203186)
-
-    * Make both http implementations raise appropriate exceptions on 403
-      Forbidden when POSTing smart requests.
-      (Vincent Ladeuil, #230223)
-
-    * Properly *title* header names in http requests instead of capitalizing
-      them.
-      (Vincent Ladeuil, #229076)
-
-    * The "Unable to obtain lock" error message now also suggests using
-      ``bzr break-lock`` to fix it.  (Martin Albisetti, #139202)
-
-    * Treat an encoding of '' as ascii; this can happen when bzr is run
-      under vim on Mac OS X.
-      (Neil Martinsen-Burrell)
-
-    * ``VersionedFile.make_mpdiffs()`` was raising an exception that wasn't in
-      scope. (Daniel Fischer #235687)
-
-  DOCUMENTATION:
-
-    * Added directory structure and started translation of docs in spanish.
-      (Martin Albisetti, Lucio Albenga)
-
-    * Incorporate feedback from Jelmer Vernooij and Neil Martinsen-Burrell
-      on the plugin and integration chapters of the User Guide.
-      (Ian Clatworthy)
-
-    * More Bazaar developer documentation about packaging and release process,
-      and about use of Python reprs.
-      (Martin Pool, Martin Albisetti)
-
-    * Updated Tortise strategy document. (Mark Hammond)
-
-  TESTING:
-
-    * ``bzrlib.tests.adapt_tests`` was broken and unused - it has been fixed.
-      (Robert Collins)
-
-    * Fix the test HTTPServer to be isolated from chdir calls made while it is
-      running, allowing it to be used in blackbox tests. (Robert Collins)
-
-    * New helper function for splitting test suites
-      ``split_suite_by_condition``. (Robert Collins)
-
-  INTERNALS:
-
-    * ``Branch.missing_revisions`` has been deprecated. Similar functionality
-      can be obtained using ``bzrlib.missing.find_unmerged``. The api was
-      fairly broken, and the function was unused, so we are getting rid of it.
-      (John Arbash Meinel)
-
-  API CHANGES:
-
-    * ``Branch.abspath`` is deprecated; use the Tree or Transport 
-      instead.  (Martin Pool)
-
-    * ``Branch.update_revisions`` now takes an optional ``Graph``
-      object. This can be used by ``update_revisions`` when it is
-      checking ancestry, and allows callers to prefer request to go to a
-      local branch.  (John Arbash Meinel)
-
-    * Branch, Repository, Tree and BzrDir should expose a Transport as an
-      attribute if they have one, rather than having it indirectly accessible
-      as ``.control_files._transport``.  This doesn't add a requirement
-      to support a Transport in cases where it was not needed before;
-      it just simplifies the way it is reached.  (Martin Pool)
-
-    * ``bzr missing --mine-only`` will return status code 0 if you have no
-      new revisions, but the remote does. Similarly for ``--theirs-only``.
-      The new code only checks one side, so it doesn't know if the other
-      side has changes. This seems more accurate with the request anyway.
-      It also changes the output to print '[This|Other] branch is up to
-      date.' rather than displaying nothing.  (John Arbash Meinel)
-
-    * ``LockableFiles.put_utf8``, ``put_bytes`` and ``controlfilename``
-      are now deprecated in favor of using Transport operations.
-      (Martin Pool)
-
-    * Many methods on ``VersionedFile``, ``Repository`` and in
-      ``bzrlib.revision``  deprecated before bzrlib 1.5 have been removed.
-      (Robert Collins)
-
-    * ``RevisionSpec.wants_revision_history`` can be set to False for a given
-      ``RevisionSpec``. This will disable the existing behavior of passing in
-      the full revision history to ``self._match_on``. Useful for specs that
-      don't actually need access to the full history. (John Arbash Meinel)
-
-    * The constructors of ``SmartClientMedium`` and its subclasses now require a
-      ``base`` parameter.  ``SmartClientMedium`` implementations now also need
-      to provide a ``remote_path_from_transport`` method.  (Andrew Bennetts)
-      
-    * The default permissions for creating new files and directories 
-      should now be obtained from ``BzrDir._get_file_mode()`` and 
-      ``_get_dir_mode()``, rather than from LockableFiles.  The ``_set_file_mode``
-      and ``_set_dir_mode`` variables on LockableFiles which were advertised
-      as a way for plugins to control this are no longer consulted.
-      (Martin Pool)
-
-    * ``VersionedFile.join`` is deprecated. This method required local
-      instances of both versioned file objects and was thus hostile to being
-      used for streaming from a smart server. The new get_record_stream and
-      insert_record_stream are meant to efficiently replace this method.
-      (Robert Collins)
-
-    * ``WorkingTree.set_parent_(ids/trees)`` will now filter out revisions
-      which are in the ancestry of other revisions. So if you merge the same
-      tree twice, or merge an ancestor of an existing merge, it will only
-      record the newest. (If you merge a descendent, it will replace its
-      ancestor). (John Arbash Meinel, #235407)
-
-    * ``WorkingTreeFormat2.stub_initialize_remote`` is now private.
-      (Martin Pool) 
-
-
-bzr 1.5 2008-05-16
-------------------
-
-This release of Bazaar includes several updates to the documentation, and fixes
-to prepare for making rich root support the default format. Many bugs have been
-squashed, including fixes to log, bzr+ssh inter-operation with older servers.
-
-  CHANGES:
-
-    * Suppress deprecation warnings when bzrlib is a 'final' release. This way
-      users of packaged software won't be bothered with DeprecationWarnings,
-      but developers and testers will still see them. (John Arbash Meinel)
-
-  DOCUMENTATION:
-
-    * Incorporate feedback from Jelmer Vernooij and Neil Martinsen-Burrell
-      on the plugin and integration chapters of the User Guide.
-      (Ian Clatworthy)
-
-
-bzr 1.5rc1 2008-05-09
----------------------
-
-  NOTES WHEN UPGRADING:
-
-  CHANGES:
-
-    * Broader support of GNU Emacs mail clients. Set
-      ``mail_client=emacsclient`` in your bazaar.conf and ``send`` will pop the
-      bundle in a mail buffer according to the value of ``mail-user-agent``
-      variable. (Xavier Maillard)
-
-  FEATURES:
-
-  IMPROVEMENTS:
-
-    * Diff now handles revision specs like "branch:" and "submit:" more
-      efficiently.  (Aaron Bentley, #202928)
-
-    * More friendly error given when attempt to start the smart server
-      on an address already in use. (Andrea Corbellini, #200575)
-
-    * Pull completes much faster when there is nothing to pull.
-      (Aaron Bentley)
-
-  BUGFIXES:
-
-    * Authentication.conf can define sections without password.
-      (Vincent Ladeuil, #199440)
-
-    * Avoid muttering every time a child update does not cause a progress bar
-      update. (John Arbash Meinel, #213771)
-
-    * ``Branch.reconcile()`` is now implemented. This allows ``bzr reconcile``
-      to fix when a Branch has a non-canonical mainline history. ``bzr check``
-      also detects this condition. (John Arbash Meinel, #177855)
-
-    * ``bzr log -r ..X bzr://`` was failing, because it was getting a request
-      for ``revision_id=None`` which was not a string.
-      (John Arbash Meinel, #211661)
-
-    * ``bzr commit`` now works with Microsoft's FTP service.
-      (Andreas Deininger)
-
-    * Catch definitions outside sections in authentication.conf.
-      (Vincent Ladeuil, #217650)
-
-    * Conversion from non-rich-root to rich-root(-pack) updates inventory
-      sha1s, even when bundles are used.  (Aaron Bentley, #181391)
-
-    * Conversion from non-rich-root to rich-root(-pack) works correctly even
-      though search keys are not topologically sorted.  (Aaron Bentley)
-
-    * Conversion from non-rich-root to rich-root(-pack) works even when a
-      parent revision has a different root id.  (Aaron Bentley, #177874)
-
-    * Disable strace testing until strace is fixed (see bug #103133) and emit a
-      warning when selftest ends to remind us of leaking tests.
-      (Vincent Ladeuil, #226769)
-
-    * Fetching all revisions from a repository does not cause pack collisions.
-      (Robert Collins, Aaron Bentley, #212908)
-
-    * Fix error about "attempt to add line-delta in non-delta knit".
-      (Andrew Bennetts, #217701)
-
-    * Pushing a branch in "dirstate" format (Branch5) over bzr+ssh would break
-      if the remote server was < version 1.2. This was due to a bug in the
-      RemoteRepository.get_parent_map() fallback code.
-      (John Arbash Meinel, #214894)
-
-    * Remove leftover code in ``bzr_branch`` that inappropriately creates 
-      a ``branch-name`` file in the branch control directory.
-      (Martin Pool)
-
-    * Set SO_REUSEADDR on server sockets of ``bzr serve`` to avoid problems
-      rebinding the socket when starting the server a second time.
-      (John Arbash Meinel, Martin Pool, #164288)
-
-    * Severe performance degradation in fetching from knit repositories to
-      knits and packs due to parsing the entire revisions.kndx on every graph
-      walk iteration fixed by using the Repository.get_graph API.  There was
-      another regression in knit => knit fetching which re-read the index for
-      every revision each side had in common.
-      (Robert Collins, John Arbash Meinel)
-
-    * When logging the changes to a particular file, there was a bug if there
-      were ghosts in the revision ancestry. (John Arbash Meinel, #209948)
-
-    * xs4all's ftp server returns a temporary error when trying to list an
-      empty directory, rather than returning an empty list. Adding a
-      workaround so that we don't get spurious failures.
-      (John Arbash Meinel, #215522)
-
-  DOCUMENTATION:
-
-    * Expanded the User Guide to include new chapters on popular plugins and
-      integrating Bazaar into your environment. The *Best practices* chapter
-      was renamed to *Miscellaneous topics* as suggested by community
-      feedback as well. (Ian Clatworthy)
-
-    * Document outlining strategies for TortoiseBzr. (Mark Hammond)
-
-    * Improved the documentation on hooks. (Ian Clatworthy)
-
-    * Update authentication docs regarding ssh agents.
-      (Vincent Ladeuil, #183705)
-
-  TESTING:
-
-    * Add ``thread_name_suffix`` parameter to SmartTCPServer_for_testing, to
-      make it easy to identify which test spawned a thread with an unhandled
-      exception. (Andrew Bennetts)
-
-    * New ``--debugflag``/``-E`` option to ``bzr selftest`` for setting
-      options for debugging tests, these are complementary to the the -D
-      options.  The ``-Dselftest_debug`` global option has been replaced by the
-      ``-E=allow_debug`` option for selftest. (Andrew Bennetts)
-
-    * Parameterised test ids are preserved correctly to aid diagnosis of test
-      failures. (Robert Collins, Andrew Bennetts)
-
-    * selftest now accepts --starting-with <id> to load only the tests whose id
-      starts with the one specified. This greatly speeds up running the test
-      suite on a limited set of tests and can be used to run the tests for a
-      single module, a single class or even a single test.  (Vincent Ladeuil)
-
-    * The test suite modules have been modified to define load_tests() instead
-      of test_suite(). That speeds up selective loading (via --load-list)
-      significantly and provides many examples on how to migrate (grep for
-      load_tests).  (Vincent Ladeuil)
-
-  INTERNALS:
-
-    * ``Hooks.install_hook`` is now deprecated in favour of
-      ``Hooks.install_named_hook`` which adds a required ``name`` parameter, to
-      avoid having to call ``Hooks.name_hook``. (Daniel Watkins)
-
-    * Implement xml8 serializer.  (Aaron Bentley)
-
-    * New form ``@deprecated_method(deprecated_in(1, 5, 0))`` for making 
-      deprecation wrappers.  (Martin Pool)
-
-    * ``Repository.revision_parents`` is now deprecated in favour of 
-      ``Repository.get_parent_map([revid])[revid]``. (Jelmer Vernooij)
-
-    * The Python ``assert`` statement is no longer used in Bazaar source, and 
-      a test checks this.  (Martin Pool)
-
-  API CHANGES:
-
-    * ``bzrlib.status.show_pending_merges`` requires the repository to be
-      locked by the caller. Callers should have been doing it anyway, but it
-      will now raise an exception if they do not. (John Arbash Meinel)
-
-    * Repository.get_data_stream, Repository.get_data_stream_for_search(),
-      Repository.get_deltas_for_revsions(), Repository.revision_trees(),
-      Repository.item_keys_introduced_by() no longer take read locks.
-      (Aaron Bentley)
-
-    * ``LockableFiles.get_utf8`` and ``.get`` are deprecated, as a start
-      towards removing LockableFiles and ``.control_files`` entirely.
-      (Martin Pool)
-
-    * Methods deprecated prior to 1.1 have been removed.
-      (Martin Pool)
-
-
-bzr 1.4 2008-04-28
-------------------
-
-This release of Bazaar includes handy improvements to the speed of log and
-status, new options for several commands, improved documentation, and better
-hooks, including initial code for server-side hooks.  A number of bugs have
-been fixed, particularly in interoperability between different formats or
-different releases of Bazaar over there network.  There's been substantial
-internal work in both the repository and network code to enable new features
-and faster performance.
-
-  BUG FIXES:
-
-    * Pushing a branch in "dirstate" format (Branch5) over bzr+ssh would break
-      if the remote server was < version 1.2.  This was due to a bug in the
-      RemoteRepository.get_parent_map() fallback code.
-      (John Arbash Meinel, Andrew Bennetts, #214894)
-
-
-bzr 1.4rc2 2008-04-21
----------------------
-
-  BUG FIXES:
-
-    * ``bzr log -r ..X bzr://`` was failing, because it was getting a request
-      for ``revision_id=None`` which was not a string.
-      (John Arbash Meinel, #211661)
-
-    * Fixed a bug in handling ghost revisions when logging changes in a 
-      particular file.  (John Arbash Meinel, #209948)
-
-    * Fix error about "attempt to add line-delta in non-delta knit".
-      (Andrew Bennetts, #205156)
-
-    * Fixed performance degradation in fetching from knit repositories to
-      knits and packs due to parsing the entire revisions.kndx on every graph
-      walk iteration fixed by using the Repository.get_graph API.  There was
-      another regression in knit => knit fetching which re-read the index for
-      every revision each side had in common.
-      (Robert Collins, John Arbash Meinel)
-
-
-bzr 1.4rc1 2008-04-11
----------------------
-
-  CHANGES:
-
-   * bzr main script cannot be imported (Benjamin Peterson)
-
-   * On Linux bzr additionally looks for plugins in arch-independent site
-     directory. (Toshio Kuratomi)
-
-   * The ``set_rh`` branch hook is now deprecated. Please migrate
-     any plugins using this hook to use an alternative, e.g.
-     ``post_change_branch_tip``. (Ian Clatworthy)
-
-   * When a plugin cannot be loaded as the file path is not a valid
-     python module name bzr will now strip a ``bzr_`` prefix from the
-     front of the suggested name, as many plugins (e.g. bzr-svn)
-     want to be installed without this prefix. It is a common mistake
-     to have a folder named "bzr-svn" for that plugin, especially
-     as this is what bzr branch lp:bzr-svn will give you. (James Westby,
-     Andrew Cowie)
-
-   * UniqueIntegerBugTracker now appends bug-ids instead of joining
-     them to the base URL. Plugins that register bug trackers may
-     need a trailing / added to the base URL if one is not already there.
-     (James Wesby, Andrew Cowie)
-
-  FEATURES:
-
-    * Added start_commit hook for mutable trees. (Jelmer Vernooij, #186422)
-
-    * ``status`` now accepts ``--no-pending`` to show the status without
-      listing pending merges, which speeds up the command a lot on large
-      histories.  (James Westby, #202830)
-
-    * New ``post_change_branch_tip`` hook that is called after the
-      branch tip is moved but while the branch is still write-locked.
-      See the User Reference for signature details.
-      (Ian Clatworthy, James Henstridge)
-
-    * Reconfigure can convert a branch to be standalone or to use a shared
-      repository.  (Aaron Bentley)
-
-  IMPROVEMENTS:
-
-    * The smart protocol now has support for setting branches' revision info
-      directly.  This should make operations like push slightly faster, and is a
-      step towards server-side hooks.  The new request method name is
-      ``Branch.set_last_revision_info``.  (Andrew Bennetts)
-
-    * ``bzr commit --fixes`` now recognises "gnome" as a tag by default.
-      (James Westby, Andrew Cowie)
-
-    * ``bzr switch`` will attempt to find branches to switch to relative to the
-      current branch. E.g. ``bzr switch branchname`` will look for
-      ``current_branch/../branchname``. (Robert Collins, Jelmer Vernooij,
-      Wouter van Heyst)
-
-    * Diff is now more specific about execute-bit changes it describes
-      (Chad Miller)
-
-    * Fetching data over HTTP is a bit faster when urllib is used.  This is done
-      by forcing it to recv 64k at a time when reading lines in HTTP headers,
-      rather than just 1 byte at a time.  (Andrew Bennetts)
-
-    * Log --short and --line are much faster when -r is not specified.
-      (Aaron Bentley)
-
-    * Merge is faster.  We no longer check a file's existence unnecessarily
-      when merging the execute bit.  (Aaron Bentley)
-
-    * ``bzr status`` on an explicit list of files no longer shows pending
-      merges, making it much faster on large trees. (John Arbash Meinel)
-
-    * The launchpad directory service now warns the user if they have not set
-      their launchpad login and are trying to resolve a URL using it, just
-      in case they want to do a write operation with it.  (James Westby)
-
-    * The smart protocol client is slightly faster, because it now only queries
-      the server for the protocol version once per connection.  Also, the HTTP
-      transport will now automatically probe for and use a smart server if
-      one is present.  You can use the new ``nosmart+`` transport decorator
-      to get the old behaviour.  (Andrew Bennetts)
-
-    * The ``version`` command takes a ``--short`` option to print just the
-      version number, for easier use in scripts.  (Martin Pool)
-
-    * Various operations with revision specs and commands that calculate
-      revnos and revision ids are faster.  (John A. Meinel, Aaron Bentley)
-
-  BUGFIXES:
-
-    * Add ``root_client_path`` parameter to SmartWSGIApp and
-      SmartServerRequest.  This makes it possible to publish filesystem
-      locations that don't exactly match URL paths. SmartServerRequest
-      subclasses should use the new ``translate_client_path`` and
-      ``transport_from_client_path`` methods when dealing with paths received
-      from a client to take this into account.  (Andrew Bennetts, #124089)
-
-    * ``bzr mv a b`` can be now used also to rename previously renamed
-      directories, not only files. (Lukáš Lalinský, #107967)
-
-    * ``bzr uncommit --local`` can now remove revisions from the local
-      branch to be symmetric with ``bzr commit --local``.
-      (John Arbash Meinel, #93412)
-
-    * Don't ask for a password if there is no real terminal.
-      (Alexander Belchenko, #69851)
-
-    * Fix a bug causing a ValueError crash in ``parse_line_delta_iter`` when
-      fetching revisions from a knit to pack repository or vice versa using
-      bzr:// (including over http or ssh).
-      (#208418, Andrew Bennetts, Martin Pool, Robert Collins)
-
-    * Fixed ``_get_line`` in ``bzrlib.smart.medium``, which was buggy.  Also
-      fixed ``_get_bytes`` in the same module to use the push back buffer.
-      These bugs had no known impact in normal use, but were problematic for
-      developers working on the code, and were likely to cause real bugs sooner
-      or later.  (Andrew Bennetts)
-
-    * Implement handling of basename parameter for DefaultMail.  (James Westby)
-
-    * Incompatibility with Paramiko versions newer than 1.7.2 was fixed.
-      (Andrew Bennetts, #213425)
-
-    * Launchpad locations (lp: URLs) can be pulled.  (Aaron Bentley, #181945)
-
-    * Merges that add files to deleted root directories complete.  They
-      do create conflicts.  (Aaron Bentley, #210092)
-
-    * vsftp's return ``550 RNFR command failed.`` supported.
-      (Marcus Trautwig, #129786)
-
-  DOCUMENTATION:
-
-    * Improved documentation on send/merge relationship. (Peter Schuller)
-
-    * Minor fixes to the User Guide. (Matthew Fuller)
-
-    * Reduced the evangelism in the User Guide. (Ian Clatworthy)
-
-    * Added Integrating with Bazaar document for developers (Martin Albisetti)
-
-  API BREAKS:
-
-    * Attempting to pull data from a ghost aware repository (e.g. knits) into a
-      non-ghost aware repository such as weaves will now fail if there are
-      ghosts.  (Robert Collins)
-
-    * ``KnitVersionedFile`` no longer accepts an ``access_mode`` parameter, and
-      now requires the ``index`` and ``access_method`` parameters to be
-      supplied. A compatible shim has been kept in the new function
-      ``knit.make_file_knit``. (Robert Collins)
-
-    * Log formatters must now provide log_revision instead of show and
-      show_merge_revno methods. The latter had been deprecated since the 0.17
-      release. (James Westby)
-
-    * ``LoopbackSFTP`` is now called ``SocketAsChannelAdapter``.
-      (Andrew Bennetts)
-
-    * ``osutils.backup_file`` is removed. (Alexander Belchenko)
-
-    * ``Repository.get_revision_graph`` is deprecated, with no replacement
-      method. The method was size(history) and not desirable. (Robert Collins)
-
-    * ``revision.revision_graph`` is deprecated, with no replacement function.
-      The function was size(history) and not desirable. (Robert Collins)
-
-    * ``Transport.get_shared_medium`` is deprecated.  Use
-      ``Transport.get_smart_medium`` instead.  (Andrew Bennetts)
-
-    * ``VersionedFile`` factories now accept a get_scope parameter rather
-      than using a call to ``transaction_finished``, allowing the removal of
-      the fixed list of versioned files per repository. (Robert Collins)
-
-    * ``VersionedFile.annotate_iter`` is deprecated. While in principle this
-      allowed lower memory use, all users of annotations wanted full file 
-      annotations, and there is no storage format suitable for incremental
-      line-by-line annotation. (Robert Collins)
-
-    * ``VersionedFile.clone_text`` is deprecated. This performance optimisation
-      is no longer used - reading the content of a file that is undergoing a
-      file level merge to identical state on two branches is rare enough, and
-      not expensive enough to special case. (Robert Collins)
-
-    * ``VersionedFile.clear_cache`` and ``enable_cache`` are deprecated.
-      These methods added significant complexity to the ``VersionedFile``
-      implementation, but were only used for optimising fetches from knits - 
-      which can be done from outside the knit layer, or via a caching
-      decorator. As knits are not the default format, the complexity is no
-      longer worth paying. (Robert Collins)
-
-    * ``VersionedFile.create_empty`` is removed. This method presupposed a
-      sensible mapping to a transport for individual files, but pack backed
-      versioned files have no such mapping. (Robert Collins)
-
-    * ``VersionedFile.get_graph`` is deprecated, with no replacement method.
-      The method was size(history) and not desirable. (Robert Collins)
-
-    * ``VersionedFile.get_graph_with_ghosts`` is deprecated, with no
-      replacement method.  The method was size(history) and not desirable.
-      (Robert Collins)
-
-    * ``VersionedFile.get_parents`` is deprecated, please use
-      ``VersionedFile.get_parent_map``. (Robert Collins)
-
-    * ``VersionedFile.get_sha1`` is deprecated, please use
-      ``VersionedFile.get_sha1s``. (Robert Collins)
-
-    * ``VersionedFile.has_ghost`` is now deprecated, as it is both expensive
-      and unused outside of a single test. (Robert Collins)
-
-    * ``VersionedFile.iter_parents`` is now deprecated in favour of
-      ``get_parent_map`` which can be used to instantiate a Graph on a
-      VersionedFile. (Robert Collins)
-
-    * ``VersionedFileStore`` no longer uses the transaction parameter given
-      to most methods; amongst other things this means that the
-      get_weave_or_empty method no longer guarantees errors on a missing weave
-      in a readonly transaction, and no longer caches versioned file instances
-      which reduces memory pressure (but requires more careful management by
-      callers to preserve performance). (Robert Collins)
-
-  TESTING:
-
-    * New -Dselftest_debug flag disables clearing of the debug flags during
-      tests.  This is useful if you want to use e.g. -Dhpss to help debug a
-      failing test.  Be aware that using this feature is likely to cause
-      spurious test failures if used with the full suite. (Andrew Bennetts)
-
-    * selftest --load-list now uses a new more agressive test loader that will
-      avoid loading unneeded modules and building their tests. Plugins can use
-      this new loader by defining a load_tests function instead of a test_suite
-      function. (a forthcoming patch will provide many examples on how to
-      implement this).
-      (Vincent Ladeuil)
-
-    * selftest --load-list now does some sanity checks regarding duplicate test
-      IDs and tests present in the list but not found in the actual test suite.
-      (Vincent Ladeuil)
-
-    * Slightly more concise format for the selftest progress bar, so there's
-      more space to show the test name.  (Martin Pool) ::
-
-        [2500/10884, 1fail, 3miss in 1m29s] test_revisionnamespaces.TestRev
-
-    * The test suite takes much less memory to run, and is a bit faster.  This
-      is done by clearing most attributes of TestCases after running them, if
-      they succeeded.  (Andrew Bennetts)
-
-  INTERNALS:
-
-    * Added ``_build_client_protocol`` to ``_SmartClient``.  (Andrew Bennetts)
-
-    * Added basic infrastructure for automatic plugin suggestion.
-      (Martin Albisetti)
-
-    * If a ``LockableFiles`` object is not explicitly unlocked (for example
-      because of a missing ``try/finally`` block, it will give a warning but
-      not automatically unlock itself.  (Previously they did.)  This
-      sometimes caused knock-on errors if for example the network connection
-      had already failed, and should not be relied upon by code. 
-      (Martin Pool, #109520)
-
-    * ``make dist`` target to build a release tarball, and also 
-      ``check-dist-tarball`` and ``dist-upload-escudero``.  (Martin Pool)
-
-    * The ``read_response_tuple`` method of ``SmartClientRequestProtocol*``
-      classes will now raise ``UnknownSmartMethod`` when appropriate, so that
-      callers don't need to try distinguish unknown request errors from other
-      errors.  (Andrew Bennetts)
-
-    * ``set_make_working_trees`` is now implemented provided on all repository
-      implementations (Aaron Bentley)
-
-    * ``VersionedFile`` now has a new method ``get_parent_map`` which, like
-      ``Graph.get_parent_map`` returns a dict of key:parents. (Robert Collins)
-
-
-bzr 1.3.1 2008-04-09
---------------------
-
-  No changes from 1.3.1rc1.
-
-
-bzr 1.3rc1 2008-04-04
----------------------
-
-  BUG FIXES:
-
-    * Fix a bug causing a ValueError crash in ``parse_line_delta_iter`` when
-      fetching revisions from a knit to pack repository or vice versa using
-      bzr:// (including over http or ssh).  
-      (#208418, Andrew Bennetts, Martin Pool, Robert Collins)
-
-
-bzr 1.3 2008-03-20
-------------------
-
-Bazaar has become part of the GNU project <http://www.gnu.org>
-
-Many operations that act on history, including ``log`` and ``annotate`` are now
-substantially faster.  Several bugs have been fixed and several new options and
-features have been added.
-
-  TESTING:
-
-    * Avoid spurious failure of ``TestVersion.test_version`` matching
-      directory names.
-      (#202778, Martin Pool)
-
-
-bzr 1.3rc1 2008-03-16
----------------------
-
-  NOTES WHEN UPGRADING:
-
-    * The backup directory created by ``upgrade`` is now called
-      ``backup.bzr``, not ``.bzr.backup``. (Martin Albisetti)
-
-  CHANGES:
-
-    * A new repository format 'development' has been added. This format will
-      represent the latest 'in-progress' format that the bzr developers are
-      interested in getting early-adopter testing and feedback on.
-      ``doc/developers/development-repo.txt`` has detailed information.
-      (Robert Collins)
-
-    * BZR_LOG environment variable controls location of .bzr.log trace file. 
-      User can suppress writing messages to .bzr.log by using '/dev/null'
-      filename (on Linux) or 'NUL' (on Windows). If BZR_LOG variable 
-      is not defined but BZR_HOME is defined then default location
-      for .bzr.log trace file is ``$BZR_HOME/.bzr.log``.
-      (Alexander Belchenko)
-
-    * ``launchpad`` builtin plugin now shipped as separate part in standalone
-      bzr.exe, installed to ``C:\Program Files\Bazaar\plugins`` directory, 
-      and standalone installer allows user to skip installation of this plugin.
-      (Alexander Belchenko)
-
-    * Restore auto-detection of plink.exe on Windows. (Dmitry Vasiliev)
-
-    * Version number is now shown as "1.2" or "1.2pr2", without zeroed or
-      missing final fields.  (Martin Pool)
-
-  FEATURES:
-
-    * ``branch`` and ``checkout`` can hard-link working tree files, which is
-      faster and saves space.  (Aaron Bentley)
-
-    * ``bzr send`` will now also look at the ``child_submit_to`` setting in
-      the submit branch to determine the email address to send to. 
-      (Jelmer Vernooij)
-
-  IMPROVEMENTS:
-
-    * BzrBranch._lefthand_history is faster on pack repos.  (Aaron Bentley)
-
-    * Branch6.generate_revision_history is faster.  (Aaron Bentley)
-
-    * Directory services can now be registered, allowing special URLs to be
-      dereferenced into real URLs.  This is a generalization and cleanup of
-      the lp: transport lookup.  (Aaron Bentley)
-
-    * Merge directives that are automatically attached to emails have nicer
-      filenames, based on branch-nick + revno. (Aaron Bentley)
-
-    * ``push`` has a ``--revision`` option, to specify what revision to push up
-      to.  (Daniel Watkins)
-
-    * Significantly reducing execution time and network traffic for trivial 
-      case of running ``bzr missing`` command for two identical branches.
-      (Alexander Belchenko)
-
-    * Speed up operations that look at the revision graph (such as 'bzr log').
-      ``KnitPackRepositor.get_revision_graph`` uses ``Graph.iter_ancestry`` to
-      extract the revision history. This allows filtering ghosts while
-      stepping instead of needing to peek ahead. (John Arbash Meinel)
-
-    * The ``hooks`` command lists installed hooks, to assist in debugging.
-      (Daniel Watkins)
-
-    * Updates to how ``annotate`` work. Should see a measurable improvement in
-      performance and memory consumption for file with a lot of merges.
-      Also, correctly handle when a line is introduced by both parents (it
-      should be attributed to the first merge which notices this, and not
-      to all subsequent merges.) (John Arbash Meinel)
-
-  BUGFIXES:
-
-    * Autopacking no longer holds the full set of inventory lines in
-      memory while copying. For large repositories, this can amount to
-      hundreds of MB of ram consumption.
-      (Ian Clatworthy, John Arbash Meinel)
-
-    * Cherrypicking when using ``--format=merge3`` now explictly excludes
-      BASE lines. (John Arbash Meinel, #151731)
-
-    * Disable plink's interactive prompt for password.
-      (#107593, Dmitry Vasiliev)
-
-    * Encode command line arguments from unicode to user_encoding before
-      invoking external mail client in `bzr send` command.
-      (#139318, Alexander Belchenko)
-
-    * Fixed problem connecting to ``bzr+https://`` servers.
-      (#198793, John Ferlito)
-
-    * Improved error reporting in the Launchpad plugin. (Daniel Watkins,
-      #196618)
-
-    * Include quick-start-summary.svg file to python-based installer(s)
-      for Windows. (#192924, Alexander Belchenko)
-
-    * lca merge now respects specified files. (Aaron Bentley)
-
-    * Make version-info --custom imply --all. (#195560, James Westby)
-
-    * ``merge --preview`` now works for merges that add or modify
-      symlinks (James Henstridge)
-
-    * Redirecting the output from ``bzr merge`` (when the remembered
-      location is used) now works. (John Arbash Meinel)
-
-    * setup.py script explicitly checks for Python version.
-      (Jari Aalto, Alexander Belchenko, #200569)
-
-    * UnknownFormatErrors no longer refer to branches regardless of kind of
-      unknown format. (Daniel Watkins, #173980)
-
-    * Upgrade bundled ConfigObj to version 4.5.2, which properly quotes #
-      signs, among other small improvements. (Matt Nordhoff, #86838)
-
-    * Use correct indices when emitting LCA conflicts.  This fixes IndexError
-      errors.  (Aaron Bentley, #196780)
-
-  DOCUMENTATION:
-
-    * Explained how to use ``version-info --custom`` in the User Guide.
-      (Neil Martinsen-Burrell)
-
-  API BREAKS:
-
-    * Support for loading plugins from zip files and
-      ``bzrlib.plugin.load_from_zip()`` function are deprecated.
-      (Alexander Belchenko)
-
-  TESTING:
-    
-    * Added missing blackbox tests for ``modified`` (Adrian Wilkins)
-
-    * The branch interface tests were invalid for branches using rich-root
-      repositories because the empty string is not a valid file-id.
-      (Robert Collins)
-
-  INTERNALS:
-
-    * ``Graph.iter_ancestry`` returns the ancestry of revision ids. Similar to
-      ``Repository.get_revision_graph()`` except it includes ghosts and you can
-      stop part-way through. (John Arbash Meinel)
-
-    * New module ``tools/package_mf.py`` provide custom module finder for
-      python packages (improves standard python library's modulefinder.py)
-      used by ``setup.py`` script while building standalone bzr.exe.
-      (Alexander Belchenko)
-
-    * New remote method ``RemoteBzrDir.find_repositoryV2`` adding support for
-      detecting external lookup support on remote repositories. This method is
-      now attempted first when lookup up repositories, leading to an extra 
-      round trip on older bzr smart servers. (Robert Collins)
- 
-    * Repository formats have a new supported-feature attribute
-      ``supports_external_lookups`` used to indicate repositories which support
-      falling back to other repositories when they have partial data.
-      (Robert Collins)
-
-    * ``Repository.get_revision_graph_with_ghosts`` and
-      ``bzrlib.revision.(common_ancestor,MultipleRevisionSources,common_graph)``
-      have been deprecated.  (John Arbash Meinel)
-
-    * ``Tree.iter_changes`` is now a public API, replacing the work-in-progress
-      ``Tree._iter_changes``. The api is now considered stable and ready for
-      external users.  (Aaron Bentley)
-
-    * The bzrdir format registry now accepts an ``alias`` keyword to
-      register_metadir, used to indicate that a format name is an alias for
-      some other format and thus should not be reported when describing the
-      format. (Robert Collins)
-
-
-bzr 1.2 2008-02-15
-------------------
-
-  BUG FIXES:
-
-    * Fix failing test in Launchpad plugin. (Martin Pool)
-
-
-bzr 1.2rc1 2008-02-13
----------------------
-
-  NOTES WHEN UPGRADING:
-  
-    * Fetching via the smart protocol may need to reconnect once during a fetch
-      if the remote server is running Bazaar 1.1 or earlier, because the client
-      attempts to use more efficient requests that confuse older servers.  You
-      may be required to re-enter a password or passphrase when this happens.
-      This won't happen if the server is upgraded to Bazaar 1.2.
-      (Andrew Bennetts)
-
-  CHANGES:
-
-    * Fetching via bzr+ssh will no longer fill ghosts by default (this is
-      consistent with pack-0.92 fetching over SFTP). (Robert Collins)
-
-    * Formatting of ``bzr plugins`` output is changed to be more human-
-      friendly. Full path of plugins locations will be shown only with
-      ``--verbose`` command-line option. (Alexander Belchenko)
-
-    * ``merge`` now prefers to use the submit branch, but will fall back to
-      parent branch.  For many users, this has no effect.  But some users who
-      pull and merge on the same branch will notice a change.  This change
-      makes it easier to work on a branch on two different machines, pulling
-      between the machines, while merging from the upstream.
-      ``merge --remember`` can now be used to set the submit_branch.
-      (Aaron Bentley)
-
-  FEATURES:
-
-    * ``merge --preview`` produces a diff of the changes merge would make,
-      but does not actually perform the merge.  (Aaron Bentley)
-
-    * New smart method ``Repository.get_parent_map`` for getting revision
-      parent data. This returns additional parent information topologically
-      adjacent to the requested data to reduce round trip latency impacts.
-      (Robert Collins)
-
-    * New smart method, ``Repository.stream_revisions_chunked``, for fetching
-      revision data that streams revision data via a chunked encoding.  This
-      avoids buffering large amounts of revision data on the server and on the
-      client, and sends less data to the server to request the revisions.
-      (Andrew Bennetts, Robert Collins, #178353)
-
-    * The launchpad plugin now handles lp urls of the form
-      ``lp://staging/``, ``lp://demo/``, ``lp://dev/`` to use the appropriate
-      launchpad instance to do the resolution of the branch identities.
-      This is primarily of use to Launchpad developers, but can also
-      be used by other users who want to try out Launchpad as
-      a branch location without messing up their public Launchpad
-      account.  Branches that are pushed to the staging environment
-      have an expected lifetime of one day. (Tim Penhey)
-
-  IMPROVEMENTS:
-
-    * Creating a new branch no longer tries to read the entire revision-history
-      unnecessarily over smart server operations. (Robert Collins)
-
-    * Fetching between different repository formats with compatible models now
-      takes advantage of the smart method to stream revisions.  (Andrew Bennetts)
-
-    * The ``--coverage`` option is now global, rather specific to ``bzr
-      selftest``.  (Andrew Bennetts)
-
-    * The ``register-branch`` command will now use the public url of the branch
-      containing the current directory, if one has been set and no explicit
-      branch is provided.  (Robert Collins)
-
-    * Tweak the ``reannotate`` code path to optimize the 2-parent case.
-      Speeds up ``bzr annotate`` with a pack repository by approx 3:2.
-      (John Arbash Meinel)
-
-  BUGFIXES:
-
-    * Calculate remote path relative to the shared medium in _SmartClient.  This
-      is related to the problem in bug #124089.  (Andrew Bennetts)
-
-    * Cleanly handle connection errors in smart protocol version two, the same
-      way as they are handled by version one.  (Andrew Bennetts)
-
-    * Clearer error when ``version-info --custom`` is used without
-      ``--template`` (Lukáš Lalinský)
-
-    * Don't raise UnavailableFeature during test setup when medusa is not
-      available or tearDown is never called leading to nasty side effects.
-      (#137823, Vincent Ladeuil)
-
-    * If a plugin's test suite cannot be loaded, for example because of a syntax
-      error in the tests, then ``selftest`` fails, rather than just printing 
-      a warning.  (Martin Pool, #189771)
-      
-    * List possible values for BZR_SSH environment variable in env-variables
-      help topic. (Alexander Belchenko, #181842)
-
-    * New methods ``push_log_file`` and ``pop_log_file`` to intercept messages:
-      popping the log redirection now precisely restores the previous state,
-      which makes it easier to use bzr log output from other programs.
-      TestCaseInTempDir no longer depends on a log redirection being established
-      by the test framework, which lets bzr tests cleanly run from a normal
-      unittest runner.
-      (#124153, #124849, Martin Pool, Jonathan Lange)
-
-    * ``pull --quiet`` is now more quiet, in particular a message is no longer
-      printed when the remembered pull location is used. (James Westby,
-      #185907)
-
-    * ``reconfigure`` can safely be interrupted while fetching.
-      (Aaron Bentley, #179316)
-
-    * ``reconfigure`` preserves tags when converting to and from lightweight
-      checkouts.  (Aaron Bentley, #182040)
-
-    * Stop polluting /tmp when running selftest.
-      (Vincent Ladeuil, #123623)
-
-    * Switch from NFKC => NFC for normalization checks. NFC allows a few
-      more characters which should be considered valid.
-      (John Arbash Meinel, #185458)
-
-    * The launchpad plugin now uses the ``edge`` xmlrpc server to avoid
-      interacting badly with a bug on the launchpad side. (Robert Collins)
-
-    * Unknown hostnames when connecting to a ``bzr://`` URL no longer cause
-      tracebacks.  (Andrew Bennetts, #182849)
-
-  API BREAKS:
-
-    * Classes implementing Merge types like Merge3Merger must now accept (and
-      honour) a do_merge flag in their constructor.  (Aaron Bentley)
-
-    * ``Repository.add_inventory`` and ``add_revision`` now require the caller
-      to previously take a write lock (and start a write group.)
-      (Martin Pool)
-
-  TESTING:
-
-    * selftest now accepts --load-list <file> to load a test id list. This
-      speeds up running the test suite on a limited set of tests.
-      (Vincent Ladeuil)
-
-  INTERNALS:
-
-    * Add a new method ``get_result`` to graph search objects. The resulting
-      ``SearchResult`` can be used to recreate the search later, which will
-      be useful in reducing network traffic. (Robert Collins)
-
-    * Use convenience function to check whether two repository handles 
-      are referring to the same repository in ``Repository.get_graph``. 
-      (Jelmer Vernooij, #187162)
-
-    * Fetching now passes the find_ghosts flag through to the 
-      ``InterRepository.missing_revision_ids`` call consistently for all
-      repository types. This will enable faster missing revision discovery with
-      bzr+ssh. (Robert Collins)
-
-    * Fix error handling in Repository.insert_data_stream. (Lukas Lalinsky)
-
-    * ``InterRepository.missing_revision_ids`` is now deprecated in favour of
-      ``InterRepository.search_missing_revision_ids`` which returns a 
-      ``bzrlib.graph.SearchResult`` suitable for making requests from the smart
-      server. (Robert Collins)
-
-    * New error ``NoPublicBranch`` for commands that need a public branch to
-      operate. (Robert Collins)
- 
-    * New method ``iter_inventories`` on Repository for access to many
-      inventories. This is primarily used by the ``revision_trees`` method, as
-      direct access to inventories is discouraged. (Robert Collins)
- 
-    * New method ``next_with_ghosts`` on the Graph breadth-first-search objects
-      which will split out ghosts and present parents into two separate sets,
-      useful for code which needs to be aware of ghosts (e.g. fetching data
-      cares about ghosts during revision selection). (Robert Collins)
-
-    * Record a timestamp against each mutter to the trace file, relative to the
-      first import of bzrlib.  (Andrew Bennetts)
-
-    * ``Repository.get_data_stream`` is now deprecated in favour of
-      ``Repository.get_data_stream_for_search`` which allows less network
-      traffic when requesting data streams over a smart server. (Robert Collins)
-
-    * ``RemoteBzrDir._get_tree_branch`` no longer triggers ``_ensure_real``,
-      removing one round trip on many network operations. (Robert Collins)
-
-    * RemoteTransport's ``recommended_page_size`` method now returns 64k, like
-      SFTPTransport and HttpTransportBase.  (Andrew Bennetts)
-
-    * Repository has a new method ``has_revisions`` which signals the presence
-      of many revisions by returning a set of the revisions listed which are
-      present. This can be done by index queries without reading data for parent
-      revision names etc. (Robert Collins)
-
-
-bzr 1.1 2008-01-15
-------------------
-
-(no changes from 1.1rc1)
-
-bzr 1.1rc1 2008-01-05
----------------------
-
-  CHANGES:
-   
-   * Dotted revision numbers have been revised. Instead of growing longer with
-     nested branches the branch number just increases. (eg instead of 1.1.1.1.1
-     we now report 1.2.1.) This helps scale long lived branches which have many
-     feature branches merged between them. (John Arbash Meinel)
-
-   * The syntax ``bzr diff branch1 branch2`` is no longer supported.
-     Use ``bzr diff branch1 --new branch2`` instead. This change has
-     been made to remove the ambiguity where ``branch2`` is in fact a
-     specific file to diff within ``branch1``.
-
-  FEATURES:
-
-   * New option to use custom template-based formats in  ``bzr version-info``.
-     (Lukáš Lalinský)
-
-   * diff '--using' allows an external diff tool to be used for files.
-     (Aaron Bentley)
-
-   * New "lca" merge-type for fast everyday merging that also supports
-     criss-cross merges.  (Aaron Bentley)
-
-  IMPROVEMENTS:
-
-   * ``annotate`` now doesn't require a working tree. (Lukáš Lalinský,
-     #90049)
-
-   * ``branch`` and ``checkout`` can now use files from a working tree to
-     to speed up the process.  For checkout, this requires the new
-     --files-from flag.  (Aaron Bentley)
-
-   * ``bzr diff`` now sorts files in alphabetical order.  (Aaron Bentley)
-
-   * ``bzr diff`` now works on branches without working trees. Tree-less
-     branches can also be compared to each other and to working trees using
-     the new diff options ``--old`` and ``--new``. Diffing between branches,
-     with or without trees, now supports specific file filtering as well.
-     (Ian Clatworthy, #6700)
-
-   * ``bzr pack`` now orders revision texts in topological order, with newest
-     at the start of the file, promoting linear reads for ``bzr log`` and the
-     like. This partially fixes #154129. (Robert Collins)
-
-   * Merge directives now fetch prerequisites from the target branch if
-     needed.  (Aaron Bentley)
-
-   * pycurl now handles digest authentication.
-     (Vincent Ladeuil)
-
-   * ``reconfigure`` can now convert from repositories.  (Aaron Bentley)
-
-   * ``-l`` is now a short form for ``--limit`` in ``log``.  (Matt Nordhoff)
-
-   * ``merge`` now warns when merge directives cause cherrypicks.
-     (Aaron Bentley)
-
-   * ``split`` now supported, to enable splitting large trees into smaller
-     pieces.  (Aaron Bentley)
-
-  BUGFIXES:
-
-   * Avoid AttributeError when unlocking a pack repository when an error occurs.
-     (Martin Pool, #180208)
-
-   * Better handle short reads when processing multiple range requests.
-     (Vincent Ladeuil, #179368)
-
-   * build_tree acceleration uses the correct path when a file has been moved.
-     (Aaron Bentley)
-
-   * ``commit`` now succeeds when a checkout and its master branch share a
-     repository.  (Aaron Bentley, #177592)
-
-   * Fixed error reporting of unsupported timezone format in
-     ``log --timezone``. (Lukáš Lalinský, #178722)
-
-   * Fixed Unicode encoding error in ``ignored`` when the output is
-     redirected to a pipe. (Lukáš Lalinský)
-
-   * Fix traceback when sending large response bodies over the smart protocol
-     on Windows. (Andrew Bennetts, #115781)
-
-   * Fix ``urlutils.relative_url`` for the case of two ``file:///`` URLs
-     pointed to different logical drives on Windows.
-     (Alexander Belchenko, #90847)
-
-   * HTTP test servers are now compatible with the http protocol version 1.1.
-     (Vincent Ladeuil, #175524)
-
-   * _KnitParentsProvider.get_parent_map now handles requests for ghosts
-     correctly, instead of erroring or attributing incorrect parents to ghosts.
-     (Aaron Bentley)
-
-   * ``merge --weave --uncommitted`` now works.  (Aaron Bentley)
-
-   * pycurl authentication handling was broken and incomplete. Fix handling of
-     user:pass embedded in the urls.
-     (Vincent Ladeuil, #177643)
-
-   * Files inside non-directories are now handled like other conflict types.
-     (Aaron Bentley, #177390)
-
-   * ``reconfigure`` is able to convert trees into lightweight checkouts.
-     (Aaron Bentley)
-
-   * Reduce lockdir timeout to 0 when running ``bzr serve``.  (Andrew Bennetts,
-     #148087)
-
-   * Test that the old ``version_info_format`` functions still work, even
-     though they are deprecated. (John Arbash Meinel, ShenMaq, #177872)
-
-   * Transform failures no longer cause ImmortalLimbo errors (Aaron Bentley,
-     #137681)
-
-   * ``uncommit`` works even when the commit messages of revisions to be
-     removed use characters not supported in the terminal encoding.
-     (Aaron Bentley)
-
-   * When dumb http servers return whole files instead of the requested ranges,
-     read the remaining bytes by chunks to avoid overflowing network buffers.
-     (Vincent Ladeuil, #175886)
-
-  DOCUMENTATION:
-
-   * Minor tweaks made to the bug tracker integration documentation.
-     (Ian Clatworthy)
-
-   * Reference material has now be moved out of the User Guide and added
-     to the User Reference. The User Reference has gained 4 sections as
-     a result: Authenication Settings, Configuration Settings, Conflicts
-     and Hooks. All help topics are now dumped into text format in the
-     doc/en/user-reference directory for those who like browsing that
-     information in their editor. (Ian Clatworthy)
-
-   * *Using Bazaar with Launchpad* tutorial added. (Ian Clatworthy)
-
-  INTERNALS:
-
-    * find_* methods available for BzrDirs, Branches and WorkingTrees.
-      (Aaron Bentley)
-
-    * Help topics can now be loaded from files. 
-      (Ian Clatworthy, Alexander Belchenko)
-
-    * get_parent_map now always provides tuples as its output.  (Aaron Bentley)
-
-    * Parent Providers should now implement ``get_parent_map`` returning a
-      dictionary instead of ``get_parents`` returning a list.
-      ``Graph.get_parents`` is now deprecated. (John Arbash Meinel,
-      Robert Collins)
-
-    * Patience Diff now supports arbitrary python objects, as long as they
-      support ``hash()``. (John Arbash Meinel)
-
-    * Reduce selftest overhead to establish test names by memoization.
-      (Vincent Ladeuil)
-
-  API BREAKS:
-
-  TESTING:
-
-   * Modules can now customise their tests by defining a ``load_tests``
-     attribute. ``pydoc bzrlib.tests.TestUtil.TestLoader.loadTestsFromModule``
-     for the documentation on this attribute. (Robert Collins)
-
-   * New helper function ``bzrlib.tests.condition_id_re`` which helps
-     filter tests based on a regular expression search on the tests id.
-     (Robert Collins)
-    
-   * New helper function ``bzrlib.tests.condition_isinstance`` which helps
-     filter tests based on class. (Robert Collins)
-    
-   * New helper function ``bzrlib.tests.exclude_suite_by_condition`` which
-     generalises the ``exclude_suite_by_re`` function. (Robert Collins)
-
-   * New helper function ``bzrlib.tests.filter_suite_by_condition`` which
-     generalises the ``filter_suite_by_re`` function. (Robert Collins)
-
-   * New helper method ``bzrlib.tests.exclude_tests_by_re`` which gives a new
-     TestSuite that does not contain tests from the input that matched a
-     regular expression. (Robert Collins)
-
-   * New helper method ``bzrlib.tests.randomize_suite`` which returns a
-     randomized copy of the input suite. (Robert Collins)
-
-   * New helper method ``bzrlib.tests.split_suite_by_re`` which splits a test
-     suite into two according to a regular expression. (Robert Collins)
-
-   * Parametrize all http tests for the transport implementations, the http
-     protocol versions (1.0 and 1.1) and the authentication schemes.
-     (Vincent Ladeuil) 
-
-   * The ``exclude_pattern`` and ``random_order`` parameters to the function
-     ``bzrlib.tests.filter_suite_by_re`` have been deprecated. (Robert Collins)
-
-   * The method ``bzrlib.tests.sort_suite_by_re`` has been deprecated. It is 
-     replaced by the new helper methods added in this release. (Robert Collins)
-
-
-bzr 1.0 2007-12-14
-------------------
-
-  DOCUMENTATION:
-
-   * More improvements and fixes to the User Guide.  (Ian Clatworthy)
-
-   * Add information on cherrypicking/rebasing to the User Guide.
-     (Ian Clatworthy)
-
-   * Improve bug tracker integration documentation. (Ian Clatworthy)
-
-   * Minor edits to ``Bazaar in five minutes`` from David Roberts and
-     to the rebasing section of the User Guide from Aaron Bentley.
-     (Ian Clatworthy)
-
-
-bzr 1.0rc3 2007-12-11
----------------------
-
-  CHANGES:
-   
-   * If a traceback occurs, users are now asked to report the bug 
-     through Launchpad (https://bugs.launchpad.net/bzr/), rather than 
-     by mail to the mailing list.
-     (Martin Pool)
-
-  BUGFIXES:
-
-   * Fix Makefile rules for doc generation. (Ian Clatworthy, #175207)
-
-   * Give more feedback during long http downloads by making readv deliver data
-     as it arrives for urllib, and issue more requests for pycurl. High latency
-     networks are better handled by urllib, the pycurl implementation give more
-     feedback but also incur more latency.
-     (Vincent Ladeuil, #173010)
-
-   * Implement _make_parents_provider on RemoteRepository, allowing generating
-     bundles against branches on a smart server.  (Andrew Bennetts, #147836)
-
-  DOCUMENTATION:
-
-   * Improved user guide.  (Ian Clatworthy)
-
-   * The single-page quick reference guide is now available as a PDF.
-     (Ian Clatworthy)
-
-  INTERNALS:
-
-    * readv urllib http implementation is now a real iterator above the
-      underlying socket and deliver data as soon as it arrives. 'get' still
-      wraps its output in a StringIO.
-      (Vincent Ladeuil)
-
-
-bzr 1.0rc2 2007-12-07
----------------------
-
-  IMPROVEMENTS:
-
-   * Added a --coverage option to selftest. (Andrew Bennetts)
-
-   * Annotate merge (merge-type=weave) now supports cherrypicking.
-     (Aaron Bentley)
-
-   * ``bzr commit`` now doesn't print the revision number twice. (Matt
-     Nordhoff, #172612)
-
-   * New configuration option ``bugtracker_<tracker_abbrevation>_url`` to
-     define locations of bug trackers that are not directly supported by
-     bzr or a plugin. The URL will be treated as a template and ``{id}``
-     placeholders will be replaced by specific bug IDs.  (Lukáš Lalinský)
-
-   * Support logging single merge revisions with short and line log formatters.
-     (Kent Gibson)
-
-   * User Guide enhanced with suggested readability improvements from
-     Matt Revell and corrections from John Arbash Meinel. (Ian Clatworthy)
-
-   * Quick Start Guide renamed to Quick Start Card, moved down in
-     the catalog, provided in pdf and png format and updated to refer
-     to ``send`` instead of ``bundle``. (Ian Clatworthy, #165080)
-
-   * ``switch`` can now be used on heavyweight checkouts as well as
-     lightweight ones. After switching a heavyweight checkout, the
-     local branch is a mirror/cache of the new bound branch and
-     uncommitted changes in the working tree are merged. As a safety
-     check, if there are local commits in a checkout which have not
-     been committed to the previously bound branch, then ``switch``
-     fails unless the ``--force`` option is given. This option is
-     now also required if the branch a lightweight checkout is pointing
-     to has been moved. (Ian Clatworthy)
-
-  INTERNALS:
-
-    * New -Dhttp debug option reports http connections, requests and responses.
-      (Vincent Ladeuil)
-
-    * New -Dmerge debug option, which emits merge plans for merge-type=weave.
-
-  BUGFIXES:
-
-   * Better error message when running ``bzr cat`` on a non-existant branch.
-     (Lukáš Lalinský, #133782)
-
-   * Catch OSError 17 (file exists) in final phase of tree transform and show
-     filename to user.
-     (Alexander Belchenko, #111758)
-
-   * Catch ShortReadvErrors while using pycurl. Also make readv more robust by
-     allowing multiple GET requests to be issued if too many ranges are
-     required.
-     (Vincent Ladeuil, #172701)
-
-   * Check for missing basis texts when fetching from packs to packs.
-     (John Arbash Meinel, #165290)
-
-   * Fall back to showing e-mail in ``log --short/--line`` if the 
-     committer/author has only e-mail. (Lukáš Lalinský, #157026)
-
-  API BREAKS:
-
-   * Deprecate not passing a ``location`` argument to commit reporters'
-     ``started`` methods. (Matt Nordhoff)
-
-
-bzr 1.0rc1 2007-11-30
----------------------
-
-  NOTES WHEN UPGRADING:
-
-   * The default repository format is now ``pack-0.92``.  This 
-     default is used when creating new repositories with ``init`` and 
-     ``init-repo``, and when branching over bzr+ssh or bzr+hpss. 
-     (See https://bugs.launchpad.net/bugs/164626)
-
-     This format can be read and written by Bazaar 0.92 and later, and 
-     data can be transferred to and from older formats.
-
-     To upgrade, please reconcile your repository (``bzr reconcile``), and then
-     upgrade (``bzr upgrade``). 
-     
-     ``pack-0.92`` offers substantially better scaling and performance than the
-     previous knits format. Some operations are slower where the code already
-     had bad scaling characteristics under knits, the pack format makes such
-     operations more visible as part of being more scalable overall. We will
-     correct such operations over the coming releases and encourage the filing
-     of bugs on any operation which you observe to be slower in a packs
-     repository. One particular case that we do not intend to fix is pulling
-     data from a pack repository into a knit repository over a high latency
-     link;  downgrading such data requires reinsertion of the file texts, and
-     this is a classic space/time tradeoff. The current implementation is
-     conservative on memory usage because we need to support converting data
-     from any tree without problems.  
-     (Robert Collins, Martin Pool, #164476)
-
-  CHANGES:
-
-   * Disable detection of plink.exe as possible ssh vendor. Plink vendor
-     still available if user selects it explicitly with BZR_SSH environment
-     variable. (Alexander Belchenko, workaround for bug #107593)
-
-   * The pack format is now accessible as "pack-0.92", or "pack-0.92-subtree" 
-     to enable the subtree functions (for example, for bzr-svn).  
-     See http://doc.bazaar-vcs.org/latest/developer/packrepo.html
-     (Martin Pool)
-
-  FEATURES:
-
-   * New ``authentication.conf`` file holding the password or other credentials
-     for remote servers. This can be used for ssh, sftp, smtp and other 
-     supported transports.
-     (Vincent Ladeuil)
-
-   * New rich-root and rich-root-pack formats, recording the same data about
-     tree roots that's recorded for all other directories.
-     (Aaron Bentley, #164639)
-
-   * ``pack-0.92`` repositories can now be reconciled.
-     (Robert Collins, #154173)
-
-   * ``switch`` command added for changing the branch a lightweight checkout
-     is associated with and updating the tree to reflect the latest content
-     accordingly. This command was previously part of the BzrTools plug-in.
-     (Ian Clatworthy, Aaron Bentley, David Allouche)
-
-   * ``reconfigure`` command can now convert branches, trees, or checkouts to
-     lightweight checkouts.  (Aaron Bentley)
-
-  PERFORMANCE:
-
-   * Commit updates the state of the working tree via a delta rather than
-     supplying entirely new basis trees. For commit of a single specified file
-     this reduces the wall clock time for commit by roughly a 30%.
-     (Robert Collins, Martin Pool)
-
-   * Commit with many automatically found deleted paths no longer performs
-     linear scanning for the children of those paths during inventory
-     iteration. This should fix commit performance blowing out when many such
-     paths occur during commit. (Robert Collins, #156491)
-
-   * Fetch with pack repositories will no longer read the entire history graph.
-     (Robert Collins, #88319)
-
-   * Revert takes out an appropriate lock when reverting to a basis tree, and
-     does not read the basis inventory twice. (Robert Collins)
-
-   * Diff does not require an inventory to be generated on dirstate trees.
-     (Aaron Bentley, #149254)
-
-   * New annotate merge (--merge-type=weave) implementation is fast on
-     versionedfiles withough cached annotations, e.g. pack-0.92.
-     (Aaron Bentley)
-
-  IMPROVEMENTS:
-
-   * ``bzr merge`` now warns when it encounters a criss-cross merge.
-     (Aaron Bentley)
-
-   * ``bzr send`` now doesn't require the target e-mail address to be
-     specified on the command line if an interactive e-mail client is used.
-     (Lukáš Lalinský)
-
-   * ``bzr tags`` now prints the revision number for each tag, instead of
-     the revision id, unless --show-ids is passed. In addition, tags can be
-     sorted chronologically instead of lexicographically with --sort=time.
-     (Adeodato Simó, #120231)
-
-   * Windows standalone version of bzr is able to load system-wide plugins from
-     "plugins" subdirectory in installation directory. In addition standalone
-     installer write to the registry (HKLM\SOFTWARE\Bazaar) useful info 
-     about paths and bzr version. (Alexander Belchenko, #129298)
-
-  DOCUMENTATION:
-
-  BUG FIXES:
-
-   * A progress bar has been added for knitpack -> knitpack fetching.
-     (Robert Collins, #157789, #159147)
-
-   * Branching from a branch via smart server now preserves the repository
-     format. (Andrew Bennetts,  #164626)
-     
-   * ``commit`` is now able to invoke an external editor in a non-ascii
-     directory. (Daniel Watkins, #84043)
-
-   * Catch connection errors for ftp.
-     (Vincent Ladeuil, #164567)
-
-   * ``check`` no longer reports spurious unreferenced text versions.
-     (Robert Collins, John A Meinel, #162931, #165071)
-
-   * Conflicts are now resolved recursively by ``revert``.
-     (Aaron Bentley, #102739)
-
-   * Detect invalid transport reuse attempts by catching invalid URLs.
-     (Vincent Ladeuil, #161819)
-
-   * Deleting a file without removing it shows a correct diff, not a traceback.
-     (Aaron Bentley)
-
-   * Do no use timeout in HttpServer anymore.
-     (Vincent Ladeuil, #158972).
-
-   * Don't catch the exceptions related to the http pipeline status before
-     retrying an http request or some programming errors may be masked.
-     (Vincent Ladeuil, #160012)
-
-   * Fix ``bzr rm`` to not delete modified and ignored files.
-     (Lukáš Lalinský, #172598)
-
-   * Fix exception when revisionspec contains merge revisons but log
-     formatter doesn't support merge revisions. (Kent Gibson, #148908)
-
-   * Fix exception when ScopeReplacer is assigned to before any members have
-     been retrieved.  (Aaron Bentley)
-
-   * Fix multiple connections during checkout --lightweight.
-     (Vincent Ladeuil, #159150)
-
-   * Fix possible error in insert_data_stream when copying between 
-     pack repositories over bzr+ssh or bzr+http.  
-     KnitVersionedFile.get_data_stream now makes sure that requested
-     compression parents are sent before any delta hunks that depend 
-     on them.
-     (Martin Pool, #164637)
-
-   * Fix typo in limiting offsets coalescing for http, leading to
-     whole files being downloaded instead of parts.
-     (Vincent Ladeuil, #165061)
-
-   * FTP server errors don't error in the error handling code.
-     (Robert Collins, #161240)
-
-   * Give a clearer message when a pull fails because the source needs
-     to be reconciled.
-     (Martin Pool, #164443)
-
-   * It is clearer when a plugin cannot be loaded because of its name, and a
-     suggestion for an acceptable name is given. (Daniel Watkins, #103023)
-
-   * Leave port as None in transport objects if user doesn't
-     specify a port in urls.
-     (vincent Ladeuil, #150860)
-
-   * Make sure Repository.fetch(self) is properly a no-op for all
-     Repository implementations. (John Arbash Meinel, #158333)
-
-   * Mark .bzr directories as "hidden" on Windows.
-     (Alexander Belchenko, #71147)
-
-   * ``merge --uncommitted`` can now operate on a single file.
-     (Aaron Bentley, Lukáš Lalinský, #136890)
-
-   * Obsolete packs are now cleaned up by pack and autopack operations.
-     (Robert Collins, #153789)
-
-   * Operations pulling data from a smart server where the underlying
-     repositories are not both annotated/both unannotated will now work.
-     (Robert Collins, #165304).
-
-   * Reconcile now shows progress bars. (Robert Collins, #159351)
-
-   * ``RemoteBranch`` was not initializing ``self._revision_id_to_revno_map``
-     properly. (John Arbash Meinel, #162486)
-
-   * Removing an already-removed file reports the file does not exist. (Daniel
-     Watkins, #152811)
-
-   * Rename on Windows is able to change filename case.
-     (Alexander Belchenko, #77740)
-
-   * Return error instead of a traceback for ``bzr log -r0``.
-     (Kent Gibson, #133751)
-
-   * Return error instead of a traceback when bzr is unable to create
-     symlink on some platforms (e.g. on Windows).
-     (Alexander Belchenko, workaround for #81689)
-
-   * Revert doesn't crash when restoring a single file from a deleted
-     directory. (Aaron Bentley)
-
-   * Stderr output via logging mechanism now goes through encoded wrapper
-     and no more uses utf-8, but terminal encoding instead. So all unicode
-     strings now should be readable in non-utf-8 terminal.
-     (Alexander Belchenko, #54173)
-
-   * The error message when ``move --after`` should be used makes how to do so
-     clearer. (Daniel Watkins, #85237)
-
-   * Unicode-safe output from ``bzr info``. The output will be encoded
-     using the terminal encoding and unrepresentable characters will be
-     replaced by '?'. (Lukáš Lalinský, #151844)
-
-   * Working trees are no longer created when pushing into a local no-trees
-     repo. (Daniel Watkins, #50582)
-
-   * Upgrade util/configobj to version 4.4.0.
-     (Vincent Ladeuil, #151208).
-
-   * Wrap medusa ftp test server as an FTPServer feature.
-     (Vincent Ladeuil, #157752)
-
-  API BREAKS:
-
-   * ``osutils.backup_file`` is deprecated. Actually it's not used in bzrlib
-     during very long time. (Alexander Belchenko)
-
-   * The return value of
-     ``VersionedFile.iter_lines_added_or_present_in_versions`` has been
-     changed. Previously it was an iterator of lines, now it is an iterator of
-     (line, version_id) tuples. This change has been made to aid reconcile and
-     fetch operations. (Robert Collins)
-
-   * ``bzrlib.repository.get_versioned_file_checker`` is now private.
-     (Robert Collins)
-
-   * The Repository format registry default has been removed; it was previously
-     obsoleted by the bzrdir format default, which implies a default repository
-     format.
-     (Martin Pool)
-
-  INTERNALS:
-
-   * Added ``ContainerSerialiser`` and ``ContainerPushParser`` to
-     ``bzrlib.pack``.  These classes provide more convenient APIs for generating
-     and parsing containers from streams rather than from files.  (Andrew
-     Bennetts)
-
-   * New module ``lru_cache`` providing a cache for use by tasks that need
-     semi-random access to large amounts of data. (John A Meinel)
-
-   * InventoryEntry.diff is now deprecated.  Please use diff.DiffTree instead.
-
-  TESTING:
-
-
-bzr 0.92 2007-11-05
--------------------
-
-  CHANGES:
-
-  * New uninstaller on Win32.  (Alexander Belchenko)
-
-
-bzr 0.92rc1 2007-10-29
-----------------------
+==============
 
   NOTES WHEN UPGRADING:
 
@@ -2462,17 +30,10 @@
 
   FEATURES:
 
-   * New ``knitpack-experimental`` repository format. This is interoperable with
-     the ``dirstate-tags`` format but uses a smarter storage design that greatly
-     speeds up many operations, both local and remote. This new format can be
-     used as an option to the ``init``, ``init-repository`` and ``upgrade``
-     commands. See http://doc.bazaar-vcs.org/0.92/developers/knitpack.html
-     for further details. (Robert Collins)
-
-   * For users of bzr-svn (and those testing the prototype subtree support) that
-     wish to try packs, a new ``knitpack-subtree-experimental`` format has also
-     been added. This is interoperable with the ``dirstate-subtrees`` format.
-     (Robert Collins)
+   * New ``authentication.conf`` file holding the password or other credentials
+     for remote servers. This can be used for ssh, sftp, smtp and other 
+     supported transports.
+     (Vincent Ladeuil)
 
    * New ``reconfigure`` command. (Aaron Bentley)
 
@@ -2483,10 +44,6 @@
      remote bzr locations than BZR_REMOTE_PATH environment variable.
      (Aaron Bentley)
 
-   * New ``launchpad-login`` command to tell Bazaar your Launchpad
-     user ID.  This can then be used by other functions of the
-     Launchpad plugin. (James Henstridge)
-
   PERFORMANCE:
 
    * Commit in quiet mode is now slightly faster as the information to
@@ -2503,11 +60,6 @@
    * Inventory serialisation no longer double-sha's the content.
      (Robert Collins)
 
-   * Knit text reconstruction now avoids making copies of the lines list for
-     interim texts when building a single text. The new ``apply_delta`` method
-     on ``KnitContent`` aids this by allowing modification of the revision id
-     such objects represent. (Robert Collins)
-
    * Pack indices are now partially parsed for specific key lookup using a
      bisection approach. (Robert Collins)
 
@@ -2517,9 +69,6 @@
    * XML inventory serialisation takes 20% less time while being stricter about
      the contents. (Robert Collins)
 
-   * Graph ``heads()`` queries have been fixed to no longer access all history
-     unnecessarily. (Robert Collins)
-
   IMPROVEMENTS:
 
    * ``bzr+https://`` smart server across https now supported. 
@@ -2534,22 +83,13 @@
    * Show encodings, locale and list of plugins in the traceback message.
      (Martin Pool, #63894)
 
-   * Experimental directory formats can now be marked with
-     ``experimental = True`` during registration. (Ian Clatworthy)
 
   DOCUMENTATION:
 
    * New *Bazaar in Five Minutes* guide.  (Matthew Revell)
 
-   * The hooks reference documentation is now converted to html as expected.
-     (Ian Clatworthy)
-
   BUG FIXES:
 
-   * Connection error reporting for the smart server has been fixed to
-     display a user friendly message instead of a traceback.
-     (Ian Clatworthy, #115601)
-
    * Make sure to use ``O_BINARY`` when opening files to check their
      sha1sum. (Alexander Belchenko, John Arbash Meinel, #153493)
 
@@ -2598,8 +138,6 @@
      some other exceptions on Python 2.5.
      (Martin Pool, #144633)
 
-   * Fix ``Inventory.copy()`` and add test for it. (Jelmer Vernooij)
-
    * Handles default value for ListOption in cmd_commit.
      (Vincent Ladeuil, #140432)
 
@@ -2732,9 +270,6 @@
      boolean indicating whether a new file graph node was recorded.
      (Robert Collins)
 
-   * The python path used in the Makefile can now be overridden.
-     (Andrew Bennetts, Ian Clatworthy)
-
   TESTING:
 
    * New transport implementation ``trace+`` which is useful for testing,
@@ -2746,12 +281,9 @@
      makes this behavior available to other users.
      (Martin Pool)
 
-   * New method ``TestCase.call_catch_warnings`` for testing methods that 
-     raises a Python warning.  (Martin Pool)
-
 
 bzr 0.91 2007-09-26
--------------------
+===================
 
   BUG FIXES:
 
@@ -2772,14 +304,14 @@
 
 
 bzr 0.91rc2 2007-09-11
-----------------------
+======================
 
    * Replaced incorrect tarball for previous release; a debug statement was left 
      in bzrlib/remote.py.
 
 
 bzr 0.91rc1 2007-09-11
-----------------------
+======================
 
   CHANGES:
 
@@ -3100,7 +632,7 @@
 
 
 bzr 0.90 2007-08-28
--------------------
+===================
 
   IMPROVEMENTS:
 
@@ -3122,7 +654,7 @@
 
 
 bzr 0.90rc1 2007-08-14
-----------------------
+======================
 
   BUGFIXES:
 
@@ -3390,7 +922,7 @@
 
 
 bzr 0.18  2007-07-17
---------------------
+====================
 
   BUGFIXES:
 
@@ -3398,7 +930,7 @@
 
 
 bzr 0.18rc1  2007-07-10
------------------------
+=======================
 
   BUGFIXES:
 
@@ -3645,7 +1177,7 @@
 
 
 bzr 0.17  2007-06-18
---------------------
+====================
 
   BUGFIXES:
 
@@ -3657,7 +1189,7 @@
 
 
 bzr 0.17rc1  2007-06-12
------------------------
+=======================
 
   NOTES WHEN UPGRADING:
 
@@ -3755,7 +1287,7 @@
       mainline). (John Arbash Meinel, #115343)
 
 bzr 0.16  2007-05-07
---------------------
+====================
   
   BUGFIXES:
 
@@ -3784,7 +1316,7 @@
       both. (John Arbash Meinel)
 
 bzr 0.16rc2  2007-04-30
------------------------
+=======================
 
   BUGFIXES:
 
@@ -3807,7 +1339,7 @@
       directories. (John Arbash Meinel, #110399)
 
 bzr 0.16rc1  2007-04-26
------------------------
+=======================
 
   NOTES WHEN UPGRADING:
 
@@ -4110,7 +1642,7 @@
       (Vincent Ladeuil)
 
 bzr 0.15 2007-04-01
--------------------
+===================
 
   BUGFIXES:
 
@@ -4122,7 +1654,7 @@
       (Martin Pool)
 
 bzr 0.15rc3  2007-03-26
------------------------
+=======================
 
   CHANGES:
  
@@ -4194,7 +1726,7 @@
       (vila, #88780)
 
 bzr 0.15rc2  2007-03-14
------------------------
+=======================
 
   NOTES WHEN UPGRADING:
         
@@ -4244,7 +1776,7 @@
 
 
 bzr 0.15rc1  2007-03-07
------------------------
+=======================
 
   SURPRISES:
 
@@ -4470,7 +2002,7 @@
 
 
 bzr 0.14  2007-01-23
---------------------
+====================
 
   IMPROVEMENTS:
 
@@ -4488,7 +2020,7 @@
 
 
 bzr 0.14rc1  2007-01-16
------------------------
+=======================
 
   IMPROVEMENTS:
 
@@ -4620,12 +2152,12 @@
 
 
 bzr 0.13  2006-12-05
---------------------
+====================
     
   No changes from 0.13rc1
     
 bzr 0.13rc1  2006-11-27
------------------------
+=======================
 
   IMPROVEMENTS:
 
@@ -4747,7 +2279,7 @@
       (previously it was ignoring it and returning the whole file,).
 
 bzr 0.12  2006-10-30
---------------------
+====================
 
   INTERNALS:
 
@@ -4756,7 +2288,7 @@
       (John Arbash Meinel)
   
 bzr 0.12rc1  2006-10-23
------------------------
+=======================
 
   IMPROVEMENTS:
 
@@ -4873,12 +2405,12 @@
       created objects. (Robert Collins, John Arbash Meinel)
 
 bzr 0.11  2006-10-02
---------------------
+====================
 
     * Smart server transport test failures on windows fixed. (Lukáš Lalinský).
 
 bzr 0.11rc2  2006-09-27
------------------------
+=======================
 
   BUG FIXES:
 
@@ -4888,7 +2420,7 @@
       Arbash Meinel).
 
 bzr 0.11rc1  2006-09-25
------------------------
+=======================
 
   IMPROVEMENTS:
 
@@ -5077,7 +2609,7 @@
       Transport. (Andrew Bennetts, Martin Pool)
 
 bzr 0.10  2006-08-29
---------------------
+====================
   
   IMPROVEMENTS:
     * 'merge' now takes --uncommitted, to apply uncommitted changes from a
@@ -5152,7 +2684,7 @@
       easier. (John Arbash Meinel)
 
 bzr 0.9.0  2006-08-11
----------------------
+=====================
 
   SURPRISES:
 
@@ -5416,14 +2948,14 @@
     * "RevisionTree" is now in bzrlib/revisiontree.py. (Robert Collins)
 
 bzr 0.8.2  2006-05-17
----------------------
+=====================
   
   BUG FIXES:
    
     * setup.py failed to install launchpad plugin.  (Martin Pool)
 
 bzr 0.8.1  2006-05-16
----------------------
+=====================
 
   BUG FIXES:
 
@@ -5471,7 +3003,7 @@
       uses bzrlib api now. (Olaf Conradi)
 
 bzr 0.8  2006-05-08
--------------------
+===================
 
   NOTES WHEN UPGRADING:
 
@@ -5728,7 +3260,7 @@
       parameter which will provide String("foo") to the command as its stdin.
 
 bzr 0.7 2006-01-09
-------------------
+==================
 
   CHANGES:
 
@@ -6019,7 +3551,7 @@
       for functions that need unicode strings. (Robert Collins)
 
 bzr 0.6 2005-10-28
-------------------
+==================
 
   IMPROVEMENTS:
   
@@ -6231,7 +3763,7 @@
 
 
 bzr 0.1.1 2005-10-12
---------------------
+====================
 
   BUG FIXES:
 
@@ -6247,7 +3779,7 @@
 
 
 bzr 0.1 2005-10-11
-------------------
+==================
 
   NOTES:
 
@@ -6372,7 +3904,7 @@
 
       
 bzr 0.0.9 2005-09-23
---------------------
+====================
 
   BUG FIXES:
 
@@ -6411,7 +3943,7 @@
 
 
 bzr 0.0.8 2005-09-20
---------------------
+====================
 
   IMPROVEMENTS:
 
@@ -6458,7 +3990,7 @@
 
 
 bzr-0.0.7 2005-09-02
---------------------
+====================
 
   NEW FEATURES:
 
@@ -6508,7 +4040,7 @@
 
 
 bzr-0.0.6 2005-08-18
---------------------
+====================
 
   NEW FEATURES:
 
@@ -6590,7 +4122,7 @@
 
 
 bzr-0.0.5  2005-06-15
----------------------
+=====================
   
   CHANGES:
 
@@ -6726,7 +4258,7 @@
 
 
 bzr-0.0.4  2005-04-22
----------------------
+=====================
 
   ENHANCEMENTS:
 
@@ -6790,7 +4322,7 @@
 
 
 bzr-0.0.3  2005-04-06
----------------------
+=====================
 
   ENHANCEMENTS:
 
@@ -6831,7 +4363,7 @@
 
 
 bzr-0.0.2.1
------------
+===========
 
   PORTABILITY:
 
@@ -6839,7 +4371,7 @@
 
 
 bzr-0.0.2  "black cube"  2005-03-31
------------------------------------
+===================================
 
   ENHANCEMENTS:
 
@@ -6867,7 +4399,7 @@
 
 
 bzr-0.0.1  2005-03-26
----------------------
+=====================
 
   ENHANCEMENTS:
 
@@ -6894,7 +4426,7 @@
 
 
 bzr-0.0.0.69  2005-03-22
-------------------------
+========================
 
   ENHANCEMENTS:
 
@@ -6902,6 +4434,3 @@
 
     * Storage of local versions: init, add, remove, rm, info, log,
       diff, status, etc.
-
-..
-   vim: tw=74 ft=rst ff=unix

=== modified file 'README'
--- README	2008-03-16 14:01:20 +0000
+++ README	2007-08-09 05:30:39 +0000
@@ -2,9 +2,8 @@
 README for Bazaar
 =================
 
-Bazaar (``bzr``) is a decentralized revision control system, designed to be
-easy for developers and end users alike.  Bazaar is part of the GNU project to
-develop a complete free operating system.
+Bazaar is a decentralized revision control system, designed to be easy
+for developers and end users alike.
 
 To install Bazaar from source, follow the instructions in the INSTALL
 file. Otherwise, you may want to check your distribution package manager
@@ -20,77 +19,62 @@
 founders of Ubuntu and Launchpad. Bazaar is Free Software, and is released
 under the GNU General Public License.
 
-Bazaar was formerly known as Bazaar-NG.  It's the successor to ``baz``, a fork
-of GNU arch, but shares no code.  (To upgrade from Baz, use the ``baz-import``
-command in the bzrtools plugin.)
+Bazaar was formerly known as Bazaar-NG, and some documentation still uses
+that old name. Also, since the Bazaar binary is called "bzr", many times this
+shorter name is used instead (like Subversion/svn and Mercurial/hg).
 
 Bazaar highlights
 =================
 
-* Easy to use and intuitive.
-
-  Only five commands are needed to do all basic operations, and all
-  commands have documentation accessible via 'bzr help command'.
-  Bazaar's interface is also easy to learn for CVS and Subversion users.
-
-* Robust and reliable.
-
-  Bazaar is developed under an extensive test suite. Branches can be
-  checked and verified for integrity at any time, and revisions can be
-  signed with PGP/GnuPG.
-
-* Publish branches with HTTP.
-
-  Branches can be hosted on an HTTP server with no need for special
-  software on the server side. Branches can be uploaded by bzr itself
-  over SSH (SFTP), or with rsync.
-
-* Adapts to multiple environments.
-
-  Bazaar runs on Linux and Windows, fully supports Unicode filenames,
-  and suits different development models, including centralized.
-
-* Easily extended and customized.
-
-  A rich Python interface is provided for extending and embedding,
-  including a plugin interface. There are already many available plugins,
-  most of them registered at http://bazaar-vcs.org/PluginRegistry.
-
-* Smart merging.
-
-  Changes will never be merged more than once, conflicts will be
-  minimized, and identical changes are dealt with well.
-
-* Vibrant and active community.
-
-  Help with Bazaar is obtained easily, via the mailing list, or the IRC
-  channel.
-
+  * Easy to use and intuitive.
+
+    Only five commands are needed to do all basic operations, and all
+    commands have documentation accessible via 'bzr help command'.
+    Bazaar's interface is also easy to learn for CVS and Subversion users.
+
+  * Robust and reliable.
+
+    Bazaar is developed under an extensive test suite. Branches can be
+    checked and verified for integrity at any time, and revisions can be
+    signed with PGP/GnuPG.
+
+ * Publish branches with HTTP.
+
+   Branches can be hosted on an HTTP server with no need for special
+   software on the server side. Branches can be uploaded by bzr itself
+   over SSH (SFTP), or with rsync.
+
+ * Adapts to multiple environments.
+
+   Bazaar runs on Linux and Windows, fully supports Unicode filenames,
+   and suits different development models, including centralized.
+
+ * Easily extended and customized.
+
+   A rich Python interface is provided for extending and embedding,
+   including a plugin interface. There are already many available plugins,
+   most of them registered at http://bazaar-vcs.org/PluginRegistry.
+
+ * Smart merging.
+
+    Changes will never be merged more than once, conflicts will be
+    minimized, and identical changes are dealt with well.
+
+ * Vibrant and active community.
+
+   Help with Bazaar is obtained easily, via the mailing list, or the IRC
+   channel. Check http://bazaar-vcs.org/BzrSupport for details.
 
 Registration and Feedback
 =========================
 
-If you encounter any problems with Bazaar, need help understanding it, or would
-like to offer suggestions or feedback, please get in touch with us:
-
-* Ask a question through our web support interface, at 
-  https://answers.launchpad.net/bzr/
-
-* Report bugs at https://bugs.edge.launchpad.net/bzr/+filebug
-
-* Write to us at bazaar@lists.canonical.com 
-  You can join the list at <https://lists.ubuntu.com/mailman/listinfo/bazaar>.
-  You don't need to subscribe to post, but your first post will be held 
-  briefly for manual moderation.
-
-* Talk to us in irc://irc.ubuntu.com/bzr
-
-* And see http://bazaar-vcs.org/BzrSupport for more.
-
 If you would like to help us improve Bazaar by telling us about yourself and
 what we could do better, please register and complete the online survey here:
-http://www.surveymonkey.com/s.aspx?sm=L94RvLswhKdktrxiHWiX3g_3d_3d.  
-Registration is completely optional. 
+http://www.surveymonkey.com/s.aspx?sm=L94RvLswhKdktrxiHWiX3g_3d_3d.
+
+Registration is completely optional. If you would like to provide feedback
+in other ways, see http://bazaar-vcs.org/BzrSupport for alternative ways of
+getting in contact with us.
 
 Enjoy,
 The Bazaar Team

=== modified file 'bzr'
--- bzr	2008-08-29 19:32:00 +0000
+++ bzr	2007-10-16 16:02:01 +0000
@@ -1,6 +1,6 @@
 #! /usr/bin/env python
 
-# Copyright (C) 2005, 2006, 2007, 2008 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -21,8 +21,6 @@
 import os
 import sys
 
-# update this on each release
-_script_version = (1, 7, 0)
 
 if __doc__ is None:
     print "bzr does not support python -OO."
@@ -59,46 +57,17 @@
     profile_imports.install()
     profiling = True
 
-if sys.platform == 'darwin':
-    # jameinel says this hack is to force python to honor the LANG setting,
-    # even on Darwin.  Otherwise it is apparently hardcoded to Mac-Roman,
-    # which is incorrect for the normal Terminal.app which wants UTF-8.  
-    #
-    # "It might be that I should be setting the "system locale" somewhere else
-    # on the system, rather than setting LANG=en_US.UTF-8 in .bashrc.
-    # Switching to 'posix' and setting LANG worked for me." 
-    #
-    # So we can remove this if someone works out the right way to tell Mac
-    # Python which encoding to use.  -- mbp 20080703
-    sys.platform = 'posix'
-    try:
-        import locale
-    finally:
-        sys.platform = 'darwin'
-else:
-    import locale
-
-try:
-    locale.setlocale(locale.LC_ALL, '')
-except locale.Error, e:
-    sys.stderr.write('bzr: warning: %s\n'
-                     '  bzr could not set the application locale.\n'
-                     '  Although this should be no problem for bzr itself,\n'
-                     '  it might cause problems with some plugins.\n'
-                     '  To investigate the issue, look at the output\n'
-                     '  of the locale(1p) tool available on POSIX systems.\n'
-                     % e)
 
 try:
     import bzrlib
 except ImportError, e:
     sys.stderr.write("bzr: ERROR: "
-        "Couldn't import bzrlib and dependencies.\n"
-        "Please check the directory containing bzrlib is on your PYTHONPATH.\n"
-        "\n")
+                     "Couldn't import bzrlib and dependencies.\n"
+                     "Please check bzrlib is on your PYTHONPATH.\n"
+                     "\n")
     raise
 
-if bzrlib.version_info[:3] != _script_version:
+if bzrlib.version_info[:3] != (0, 92, 0):
     sys.stderr.write("bzr: WARNING: bzrlib version doesn't match the bzr program.\n"
             "This may indicate an installation problem.\n"
             "bzrlib from %s is version %r\n"
@@ -125,7 +94,6 @@
 import bzrlib.commands
 import bzrlib.trace
 
-
 if __name__ == '__main__':
     bzrlib.trace.enable_default_logging()
     exit_val = bzrlib.commands.main(sys.argv)
@@ -158,4 +126,4 @@
         bzrlib.trace._trace_file.flush()
     os._exit(exit_val)
 else:
-    raise ImportError("The bzr script cannot be imported.")
+    pass    # should this give an error? - it can't be used as a lib

=== modified file 'bzr.ico'
Binary files bzr.ico and bzr.ico differ
=== modified file 'bzrlib/__init__.py'
--- bzrlib/__init__.py	2008-09-03 19:54:34 +0000
+++ bzrlib/__init__.py	2007-10-03 05:25:50 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2008 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -16,12 +16,6 @@
 
 """bzr library"""
 
-import time
-
-# Keep track of when bzrlib was first imported, so that we can give rough
-# timestamps relative to program start in the log file kept by bzrlib.trace.
-_start_time = time.time()
-
 from bzrlib.osutils import get_user_encoding
 
 
@@ -32,7 +26,7 @@
 user_encoding = get_user_encoding()
 
 
-__copyright__ = "Copyright 2005, 2006, 2007, 2008 Canonical Ltd."
+__copyright__ = "Copyright 2005, 2006, 2007 Canonical Ltd."
 
 # same format as sys.version_info: "A tuple containing the five components of
 # the version number: major, minor, micro, releaselevel, and serial. All
@@ -41,59 +35,16 @@
 # Python version 2.0 is (2, 0, 0, 'final', 0)."  Additionally we use a
 # releaselevel of 'dev' for unreleased under-development code.
 
-version_info = (1, 7, 0, 'dev', 0)
-
-
-# API compatibility version: bzrlib is currently API compatible with 1.7.
-api_minimum_version = (1, 7, 0)
-
-
-def _format_version_tuple(version_info):
-    """Turn a version number 3-tuple or 5-tuple into a short string.
-
-    This format matches <http://docs.python.org/dist/meta-data.html>
-    and the typical presentation used in Python output.
-
-    This also checks that the version is reasonable: the sub-release must be
-    zero for final releases, and non-zero for alpha, beta and preview.
-
-    >>> print _format_version_tuple((1, 0, 0, 'final', 0))
-    1.0
-    >>> print _format_version_tuple((1, 2, 0, 'dev', 0))
-    1.2dev
-    >>> print _format_version_tuple((1, 1, 1, 'candidate', 2))
-    1.1.1rc2
-    >>> print _format_version_tuple((1, 4, 0))
-    1.4
-    """
-    if version_info[2] == 0:
-        main_version = '%d.%d' % version_info[:2]
-    else:
-        main_version = '%d.%d.%d' % version_info[:3]
-    if len(version_info) <= 3:
-        return main_version
-
-    __release_type = version_info[3]
-    __sub = version_info[4]
-
-    # check they're consistent
-    if __release_type == 'final' and __sub == 0:
-        __sub_string = ''
-    elif __release_type == 'dev' and __sub == 0:
-        __sub_string = 'dev'
-    elif __release_type in ('alpha', 'beta') and __sub != 0:
-        __sub_string = __release_type[0] + str(__sub)
-    elif __release_type == 'candidate' and __sub != 0:
-        __sub_string = 'rc' + str(__sub)
-    else:
-        raise AssertionError("version_info %r not valid" % version_info)
-
+version_info = (0, 92, 0, 'dev', 0)
+
+# API compatibility version: bzrlib is currently API compatible with 0.18.
+api_minimum_version = (0, 18, 0)
+
+if version_info[3] == 'final':
+    version_string = '%d.%d.%d' % version_info[:3]
+else:
     version_string = '%d.%d.%d.%s.%d' % version_info
-    return main_version + __sub_string
-
-__version__ = _format_version_tuple(version_info)
-version_string = __version__
-
+__version__ = version_string
 
 # allow bzrlib plugins to be imported.
 import bzrlib.plugin

=== removed file 'bzrlib/_btree_serializer_c.pyx'
--- bzrlib/_btree_serializer_c.pyx	2008-08-22 03:54:29 +0000
+++ bzrlib/_btree_serializer_c.pyx	1970-01-01 00:00:00 +0000
@@ -1,391 +0,0 @@
-# Copyright (C) 2008 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-#
-
-"""Pyrex extensions to btree node parsing."""
-
-cdef extern from "stdlib.h":
-    ctypedef unsigned size_t
-
-cdef extern from "Python.h":
-    ctypedef int Py_ssize_t # Required for older pyrex versions
-    ctypedef struct PyObject:
-        pass
-    int PyList_Append(object lst, object item) except -1
-
-    char *PyString_AsString(object p) except NULL
-    object PyString_FromStringAndSize(char *, Py_ssize_t)
-    int PyString_CheckExact(object s)
-    int PyString_CheckExact_ptr "PyString_CheckExact" (PyObject *)
-    Py_ssize_t PyString_Size(object p)
-    Py_ssize_t PyString_GET_SIZE_ptr "PyString_GET_SIZE" (PyObject *)
-    char * PyString_AS_STRING_ptr "PyString_AS_STRING" (PyObject *)
-    int PyString_AsStringAndSize_ptr(PyObject *, char **buf, Py_ssize_t *len)
-    int PyTuple_CheckExact(object t)
-    Py_ssize_t PyTuple_GET_SIZE(object t)
-    PyObject *PyTuple_GET_ITEM_ptr_object "PyTuple_GET_ITEM" (object tpl, int index)
-
-cdef extern from "string.h":
-    void *memcpy(void *dest, void *src, size_t n)
-    void *memchr(void *s, int c, size_t n)
-    # GNU extension
-    # void *memrchr(void *s, int c, size_t n)
-    int strncmp(char *s1, char *s2, size_t n)
-
-
-# TODO: Find some way to import this from _dirstate_helpers
-cdef void* _my_memrchr(void *s, int c, size_t n):
-    # memrchr seems to be a GNU extension, so we have to implement it ourselves
-    # It is not present in any win32 standard library
-    cdef char *pos
-    cdef char *start
-
-    start = <char*>s
-    pos = start + n - 1
-    while pos >= start:
-        if pos[0] == c:
-            return <void*>pos
-        pos = pos - 1
-    return NULL
-
-# TODO: Import this from _dirstate_helpers when it is merged
-cdef object safe_string_from_size(char *s, Py_ssize_t size):
-    if size < 0:
-        raise AssertionError(
-            'tried to create a string with an invalid size: %d @0x%x'
-            % (size, <int>s))
-    return PyString_FromStringAndSize(s, size)
-
-
-cdef class BTreeLeafParser:
-    """Parse the leaf nodes of a BTree index.
-
-    :ivar bytes: The PyString object containing the uncompressed text for the
-        node.
-    :ivar key_length: An integer describing how many pieces the keys have for
-        this index.
-    :ivar ref_list_length: An integer describing how many references this index
-        contains.
-    :ivar keys: A PyList of keys found in this node.
-
-    :ivar _cur_str: A pointer to the start of the next line to parse
-    :ivar _end_str: A pointer to the end of bytes
-    :ivar _start: Pointer to the location within the current line while
-        parsing.
-    :ivar _header_found: True when we have parsed the header for this node
-    """
-
-    cdef object bytes
-    cdef int key_length
-    cdef int ref_list_length
-    cdef object keys
-
-    cdef char * _cur_str
-    cdef char * _end_str
-    # The current start point for parsing
-    cdef char * _start
-
-    cdef int _header_found
-
-    def __init__(self, bytes, key_length, ref_list_length):
-        self.bytes = bytes
-        self.key_length = key_length
-        self.ref_list_length = ref_list_length
-        self.keys = []
-        self._cur_str = NULL
-        self._end_str = NULL
-        self._header_found = 0
-
-    cdef extract_key(self, char * last):
-        """Extract a key.
-
-        :param last: points at the byte after the last byte permitted for the
-            key.
-        """
-        cdef char *temp_ptr
-        cdef int loop_counter
-        # keys are tuples
-        loop_counter = 0
-        key_segments = []
-        while loop_counter < self.key_length:
-            loop_counter = loop_counter + 1
-            # grab a key segment
-            temp_ptr = <char*>memchr(self._start, c'\0', last - self._start)
-            if temp_ptr == NULL:
-                if loop_counter == self.key_length:
-                    # capture to last
-                    temp_ptr = last
-                else:
-                    # Invalid line
-                    failure_string = ("invalid key, wanted segment from " +
-                        repr(safe_string_from_size(self._start,
-                                                   last - self._start)))
-                    raise AssertionError(failure_string)
-            # capture the key string
-            # TODO: Consider using PyIntern_FromString, the only caveat is that
-            # it assumes a NULL-terminated string, so we have to check if
-            # temp_ptr[0] == c'\0' or some other char.
-            key_element = safe_string_from_size(self._start,
-                                                temp_ptr - self._start)
-            # advance our pointer
-            self._start = temp_ptr + 1
-            PyList_Append(key_segments, key_element)
-        return tuple(key_segments)
-
-    cdef int process_line(self) except -1:
-        """Process a line in the bytes."""
-        cdef char *last
-        cdef char *temp_ptr
-        cdef char *ref_ptr
-        cdef char *next_start
-        cdef int loop_counter
-
-        self._start = self._cur_str
-        # Find the next newline
-        last = <char*>memchr(self._start, c'\n', self._end_str - self._start)
-        if last == NULL:
-            # Process until the end of the file
-            last = self._end_str
-            self._cur_str = self._end_str
-        else:
-            # And the next string is right after it
-            self._cur_str = last + 1
-            # The last character is right before the '\n'
-            last = last
-
-        if last == self._start:
-            # parsed it all.
-            return 0
-        if last < self._start:
-            # Unexpected error condition - fail
-            return -1
-        if 0 == self._header_found:
-            # The first line in a leaf node is the header "type=leaf\n"
-            if strncmp("type=leaf", self._start, last - self._start) == 0:
-                self._header_found = 1
-                return 0
-            else:
-                raise AssertionError('Node did not start with "type=leaf": %r'
-                    % (safe_string_from_size(self._start, last - self._start)))
-                return -1
-
-        key = self.extract_key(last)
-        # find the value area
-        temp_ptr = <char*>_my_memrchr(self._start, c'\0', last - self._start)
-        if temp_ptr == NULL:
-            # Invalid line
-            return -1
-        else:
-            # capture the value string
-            value = safe_string_from_size(temp_ptr + 1, last - temp_ptr - 1)
-            # shrink the references end point
-            last = temp_ptr
-        if self.ref_list_length:
-            ref_lists = []
-            loop_counter = 0
-            while loop_counter < self.ref_list_length:
-                ref_list = []
-                # extract a reference list
-                loop_counter = loop_counter + 1
-                if last < self._start:
-                    return -1
-                # find the next reference list end point:
-                temp_ptr = <char*>memchr(self._start, c'\t', last - self._start)
-                if temp_ptr == NULL:
-                    # Only valid for the last list
-                    if loop_counter != self.ref_list_length:
-                        # Invalid line
-                        return -1
-                        raise AssertionError("invalid key")
-                    else:
-                        # scan to the end of the ref list area
-                        ref_ptr = last
-                        next_start = last
-                else:
-                    # scan to the end of this ref list
-                    ref_ptr = temp_ptr
-                    next_start = temp_ptr + 1
-                # Now, there may be multiple keys in the ref list.
-                while self._start < ref_ptr:
-                    # loop finding keys and extracting them
-                    temp_ptr = <char*>memchr(self._start, c'\r',
-                                             ref_ptr - self._start)
-                    if temp_ptr == NULL:
-                        # key runs to the end
-                        temp_ptr = ref_ptr
-                    PyList_Append(ref_list, self.extract_key(temp_ptr))
-                PyList_Append(ref_lists, tuple(ref_list))
-                # prepare for the next reference list
-                self._start = next_start
-            ref_lists = tuple(ref_lists)
-            node_value = (value, ref_lists)
-        else:
-            if last != self._start:
-                # unexpected reference data present
-                return -1
-            node_value = (value, ())
-        PyList_Append(self.keys, (key, node_value))
-        return 0
-
-    def parse(self):
-        cdef Py_ssize_t byte_count
-        if not PyString_CheckExact(self.bytes):
-            raise AssertionError('self.bytes is not a string.')
-        byte_count = PyString_Size(self.bytes)
-        self._cur_str = PyString_AsString(self.bytes)
-        # This points to the last character in the string
-        self._end_str = self._cur_str + byte_count
-        while self._cur_str < self._end_str:
-            self.process_line()
-        return self.keys
-
-
-def _parse_leaf_lines(bytes, key_length, ref_list_length):
-    parser = BTreeLeafParser(bytes, key_length, ref_list_length)
-    return parser.parse()
-
-
-def _flatten_node(node, reference_lists):
-    """Convert a node into the serialized form.
-
-    :param node: A tuple representing a node:
-        (index, key_tuple, value, references)
-    :param reference_lists: Does this index have reference lists?
-    :return: (string_key, flattened)
-        string_key  The serialized key for referencing this node
-        flattened   A string with the serialized form for the contents
-    """
-    cdef int have_reference_lists
-    cdef Py_ssize_t flat_len
-    cdef Py_ssize_t key_len
-    cdef Py_ssize_t node_len
-    cdef PyObject * val
-    cdef char * value
-    cdef Py_ssize_t value_len
-    cdef char * out
-    cdef Py_ssize_t refs_len
-    cdef Py_ssize_t next_len
-    cdef int first_ref_list
-    cdef int first_reference
-    cdef int i
-    cdef PyObject *ref_bit
-    cdef Py_ssize_t ref_bit_len
-
-    if not PyTuple_CheckExact(node):
-        raise TypeError('We expected a tuple() for node not: %s'
-            % type(node))
-    node_len = PyTuple_GET_SIZE(node)
-    have_reference_lists = reference_lists
-    if have_reference_lists:
-        if node_len != 4:
-            raise ValueError('With ref_lists, we expected 4 entries not: %s'
-                % len(node))
-    elif node_len < 3:
-        raise ValueError('Without ref_lists, we need at least 3 entries not: %s'
-            % len(node))
-    # I don't expect that we can do faster than string.join()
-    string_key = '\0'.join(<object>PyTuple_GET_ITEM_ptr_object(node, 1))
-
-    # TODO: instead of using string joins, precompute the final string length,
-    #       and then malloc a single string and copy everything in.
-
-    # TODO: We probably want to use PySequenceFast, because we have lists and
-    #       tuples, but we aren't sure which we will get.
-
-    # line := string_key NULL flat_refs NULL value LF
-    # string_key := BYTES (NULL BYTES)*
-    # flat_refs := ref_list (TAB ref_list)*
-    # ref_list := ref (CR ref)*
-    # ref := BYTES (NULL BYTES)*
-    # value := BYTES
-    refs_len = 0
-    if have_reference_lists:
-        # Figure out how many bytes it will take to store the references
-        ref_lists = <object>PyTuple_GET_ITEM_ptr_object(node, 3)
-        next_len = len(ref_lists) # TODO: use a Py function
-        if next_len > 0:
-            # If there are no nodes, we don't need to do any work
-            # Otherwise we will need (len - 1) '\t' characters to separate
-            # the reference lists
-            refs_len = refs_len + (next_len - 1)
-            for ref_list in ref_lists:
-                next_len = len(ref_list)
-                if next_len > 0:
-                    # We will need (len - 1) '\r' characters to separate the
-                    # references
-                    refs_len = refs_len + (next_len - 1)
-                    for reference in ref_list:
-                        if not PyTuple_CheckExact(reference):
-                            raise TypeError(
-                                'We expect references to be tuples not: %s'
-                                % type(reference))
-                        next_len = PyTuple_GET_SIZE(reference)
-                        if next_len > 0:
-                            # We will need (len - 1) '\x00' characters to
-                            # separate the reference key
-                            refs_len = refs_len + (next_len - 1)
-                            for i from 0 <= i < next_len:
-                                ref_bit = PyTuple_GET_ITEM_ptr_object(reference, i)
-                                if not PyString_CheckExact_ptr(ref_bit):
-                                    raise TypeError('We expect reference bits'
-                                        ' to be strings not: %s'
-                                        % type(<object>ref_bit))
-                                refs_len = refs_len + PyString_GET_SIZE_ptr(ref_bit)
-
-    # So we have the (key NULL refs NULL value LF)
-    key_len = PyString_Size(string_key)
-    val = PyTuple_GET_ITEM_ptr_object(node, 2)
-    if not PyString_CheckExact_ptr(val):
-        raise TypeError('Expected a plain str for value not: %s'
-                        % type(<object>val))
-    value = PyString_AS_STRING_ptr(val)
-    value_len = PyString_GET_SIZE_ptr(val)
-    flat_len = (key_len + 1 + refs_len + 1 + value_len + 1)
-    line = PyString_FromStringAndSize(NULL, flat_len)
-    # Get a pointer to the new buffer
-    out = PyString_AsString(line)
-    memcpy(out, PyString_AsString(string_key), key_len)
-    out = out + key_len
-    out[0] = c'\0'
-    out = out + 1
-    if refs_len > 0:
-        first_ref_list = 1
-        for ref_list in ref_lists:
-            if first_ref_list == 0:
-                out[0] = c'\t'
-                out = out + 1
-            first_ref_list = 0
-            first_reference = 1
-            for reference in ref_list:
-                if first_reference == 0:
-                    out[0] = c'\r'
-                    out = out + 1
-                first_reference = 0
-                next_len = PyTuple_GET_SIZE(reference)
-                for i from 0 <= i < next_len:
-                    if i != 0:
-                        out[0] = c'\x00'
-                        out = out + 1
-                    ref_bit = PyTuple_GET_ITEM_ptr_object(reference, i)
-                    ref_bit_len = PyString_GET_SIZE_ptr(ref_bit)
-                    memcpy(out, PyString_AS_STRING_ptr(ref_bit), ref_bit_len)
-                    out = out + ref_bit_len
-    out[0] = c'\0'
-    out = out  + 1
-    memcpy(out, value, value_len)
-    out = out + value_len
-    out[0] = c'\n'
-    return string_key, line

=== removed file 'bzrlib/_btree_serializer_py.py'
--- bzrlib/_btree_serializer_py.py	2008-08-22 02:18:27 +0000
+++ bzrlib/_btree_serializer_py.py	1970-01-01 00:00:00 +0000
@@ -1,66 +0,0 @@
-# Copyright (C) 2008 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-#
-
-"""B+Tree index parsing."""
-
-def _parse_leaf_lines(bytes, key_length, ref_list_length):
-    lines = bytes.split('\n')
-    nodes = []
-    for line in lines[1:]:
-        if line == '':
-            return nodes
-        elements = line.split('\0', key_length)
-        # keys are tuples
-        key = tuple(elements[:key_length])
-        line = elements[-1]
-        references, value = line.rsplit('\0', 1)
-        if ref_list_length:
-            ref_lists = []
-            for ref_string in references.split('\t'):
-                ref_lists.append(tuple([
-                    tuple(ref.split('\0')) for ref in ref_string.split('\r') if ref
-                    ]))
-            ref_lists = tuple(ref_lists)
-            node_value = (value, ref_lists)
-        else:
-            node_value = (value, ())
-        nodes.append((key, node_value))
-    return nodes
-
-
-def _flatten_node(node, reference_lists):
-    """Convert a node into the serialized form.
-
-    :param node: A tuple representing a node (key_tuple, value, references)
-    :param reference_lists: Does this index have reference lists?
-    :return: (string_key, flattened)
-        string_key  The serialized key for referencing this node
-        flattened   A string with the serialized form for the contents
-    """
-    if reference_lists:
-        # TODO: Consider turning this back into the 'unoptimized' nested loop
-        #       form. It is probably more obvious for most people, and this is
-        #       just a reference implementation.
-        flattened_references = ['\r'.join(['\x00'.join(reference)
-                                           for reference in ref_list])
-                                for ref_list in node[3]]
-    else:
-        flattened_references = []
-    string_key = '\x00'.join(node[1])
-    line = ("%s\x00%s\x00%s\n" % (string_key,
-        '\t'.join(flattened_references), node[2]))
-    return string_key, line

=== modified file 'bzrlib/_dirstate_helpers_c.pyx'
--- bzrlib/_dirstate_helpers_c.pyx	2008-09-02 19:15:57 +0000
+++ bzrlib/_dirstate_helpers_c.pyx	2007-10-10 21:18:06 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007, 2008 Canonical Ltd
+# Copyright (C) 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -19,7 +19,6 @@
 This is the python implementation for DirState functions.
 """
 
-from bzrlib import errors
 from bzrlib.dirstate import DirState
 
 
@@ -51,7 +50,6 @@
 # inner loops, we don't need to do that at all, as the reference only lasts for
 # a very short time.
 cdef extern from "Python.h":
-    ctypedef int Py_ssize_t
     int PyList_Append(object lst, object item) except -1
     void *PyList_GetItem_object_void "PyList_GET_ITEM" (object lst, int index)
     int PyList_CheckExact(object)
@@ -61,7 +59,7 @@
     char *PyString_AsString(object p)
     char *PyString_AS_STRING_void "PyString_AS_STRING" (void *p)
     object PyString_FromString(char *)
-    object PyString_FromStringAndSize(char *, Py_ssize_t)
+    object PyString_FromStringAndSize(char *, int)
     int PyString_Size(object p)
     int PyString_GET_SIZE_void "PyString_GET_SIZE" (void *p)
     int PyString_CheckExact(object p)
@@ -112,13 +110,6 @@
         return None
     return <char*>found - <char*>_s
 
-cdef object safe_string_from_size(char *s, Py_ssize_t size):
-    if size < 0:
-        raise AssertionError(
-            'tried to create a string with an invalid size: %d @0x%x'
-            % (size, <int>s))
-    return PyString_FromStringAndSize(s, size)
-
 
 cdef int _is_aligned(void *ptr):
     """Is this pointer aligned to an integer size offset?
@@ -479,7 +470,6 @@
 cdef class Reader:
     """Maintain the current location, and return fields as you parse them."""
 
-    cdef object state # The DirState object
     cdef object text # The overall string object
     cdef char *text_cstr # Pointer to the beginning of text
     cdef int text_size # Length of text
@@ -488,32 +478,18 @@
     cdef char *cur_cstr # Pointer to the current record
     cdef char *next # Pointer to the end of this record
 
-    def __init__(self, text, state):
-        self.state = state
+    def __init__(self, text):
         self.text = text
         self.text_cstr = PyString_AsString(text)
         self.text_size = PyString_Size(text)
         self.end_cstr = self.text_cstr + self.text_size
         self.cur_cstr = self.text_cstr
 
-    cdef char *get_next(self, int *size) except NULL:
+    cdef char *get_next(self, int *size):
         """Return a pointer to the start of the next field."""
         cdef char *next
-        cdef Py_ssize_t extra_len
-
-        if self.cur_cstr == NULL:
-            raise AssertionError('get_next() called when cur_str is NULL')
-        elif self.cur_cstr >= self.end_cstr:
-            raise AssertionError('get_next() called when there are no chars'
-                                 ' left')
         next = self.cur_cstr
-        self.cur_cstr = <char*>memchr(next, c'\0', self.end_cstr - next)
-        if self.cur_cstr == NULL:
-            extra_len = self.end_cstr - next
-            raise errors.DirstateCorrupt(self.state,
-                'failed to find trailing NULL (\\0).'
-                ' Trailing garbage: %r'
-                % safe_string_from_size(next, extra_len))
+        self.cur_cstr = <char*>memchr(next, c'\0', self.end_cstr-next)
         size[0] = self.cur_cstr - next
         self.cur_cstr = self.cur_cstr + 1
         return next
@@ -523,7 +499,7 @@
         cdef int size
         cdef char *next
         next = self.get_next(&size)
-        return safe_string_from_size(next, size)
+        return PyString_FromStringAndSize(next, size)
 
     cdef int _init(self) except -1:
         """Get the pointer ready.
@@ -594,7 +570,7 @@
                        # <object>
                        PyString_AS_STRING_void(p_current_dirname[0]),
                        cur_size+1) != 0):
-            dirname = safe_string_from_size(dirname_cstr, cur_size)
+            dirname = PyString_FromStringAndSize(dirname_cstr, cur_size)
             p_current_dirname[0] = <void*>dirname
             new_block[0] = 1
         else:
@@ -645,13 +621,13 @@
         # marker.
         trailing = self.get_next(&cur_size)
         if cur_size != 1 or trailing[0] != c'\n':
-            raise errors.DirstateCorrupt(self.state,
+            raise AssertionError(
                 'Bad parse, we expected to end on \\n, not: %d %s: %s'
-                % (cur_size, safe_string_from_size(trailing, cur_size),
+                % (cur_size, PyString_FromStringAndSize(trailing, cur_size),
                    ret))
         return ret
 
-    def _parse_dirblocks(self):
+    def _parse_dirblocks(self, state):
         """Parse all dirblocks in the state file."""
         cdef int num_trees
         cdef object current_block
@@ -661,15 +637,14 @@
         cdef int expected_entry_count
         cdef int entry_count
 
-        num_trees = self.state._num_present_parents() + 1
-        expected_entry_count = self.state._num_entries
+        num_trees = state._num_present_parents() + 1
+        expected_entry_count = state._num_entries
 
         # Ignore the first record
         self._init()
 
         current_block = []
-        dirblocks = [('', current_block), ('', [])]
-        self.state._dirblocks = dirblocks
+        state._dirblocks = [('', current_block), ('', [])]
         obj = ''
         current_dirname = <void*>obj
         new_block = 0
@@ -687,16 +662,15 @@
             if new_block:
                 # new block - different dirname
                 current_block = []
-                PyList_Append(dirblocks,
+                PyList_Append(state._dirblocks,
                               (<object>current_dirname, current_block))
             PyList_Append(current_block, entry)
             entry_count = entry_count + 1
         if entry_count != expected_entry_count:
-            raise errors.DirstateCorrupt(self.state,
-                    'We read the wrong number of entries.'
+            raise AssertionError('We read the wrong number of entries.'
                     ' We expected to read %s, but read %s'
                     % (expected_entry_count, entry_count))
-        self.state._split_root_dirblock_into_contents()
+        state._split_root_dirblock_into_contents()
 
 
 def _read_dirblocks_c(state):
@@ -715,7 +689,7 @@
     text = state._state_file.read()
     # TODO: check the crc checksums. crc_measured = zlib.crc32(text)
 
-    reader = Reader(text, state)
+    reader = Reader(text)
 
-    reader._parse_dirblocks()
+    reader._parse_dirblocks(state)
     state._dirblock_state = DirState.IN_MEMORY_UNMODIFIED

=== modified file 'bzrlib/_dirstate_helpers_py.py'
--- bzrlib/_dirstate_helpers_py.py	2008-09-02 18:51:03 +0000
+++ bzrlib/_dirstate_helpers_py.py	2007-10-09 03:35:33 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007, 2008 Canonical Ltd
+# Copyright (C) 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -20,7 +20,6 @@
 
 # We cannot import the dirstate module, because it loads this module
 # All we really need is the IN_MEMORY_MODIFIED constant
-from bzrlib import errors
 from bzrlib.dirstate import DirState
 
 
@@ -201,9 +200,7 @@
     fields = text.split('\0')
     # Remove the last blank entry
     trailing = fields.pop()
-    if trailing != '':
-        raise errors.DirstateCorrupt(state,
-            'trailing garbage: %r' % (trailing,))
+    assert trailing == ''
     # consider turning fields into a tuple.
 
     # skip the first field which is the trailing null from the header.
@@ -220,12 +217,11 @@
     expected_field_count = entry_size * state._num_entries
     field_count = len(fields)
     # this checks our adjustment, and also catches file too short.
-    if field_count - cur != expected_field_count:
-        raise errors.DirstateCorrupt(state,
-            'field count incorrect %s != %s, entry_size=%s, '\
-            'num_entries=%s fields=%r' % (
+    assert field_count - cur == expected_field_count, \
+        'field count incorrect %s != %s, entry_size=%s, '\
+        'num_entries=%s fields=%r' % (
             field_count - cur, expected_field_count, entry_size,
-            state._num_entries, fields))
+            state._num_entries, fields)
 
     if num_present_parents == 1:
         # Bind external functions to local names
@@ -273,8 +269,7 @@
                      ),
                      ])
             trailing = next()
-            if trailing != '\n':
-                raise ValueError("trailing garbage in dirstate: %r" % trailing)
+            assert trailing == '\n'
             # append the entry to the current block
             append_entry(entry)
         state._split_root_dirblock_into_contents()

=== modified file 'bzrlib/_knit_load_data_c.pyx'
--- bzrlib/_knit_load_data_c.pyx	2008-03-20 00:43:25 +0000
+++ bzrlib/_knit_load_data_c.pyx	2007-10-10 21:18:06 +0000
@@ -171,7 +171,7 @@
                 Py_INCREF(parent)
             PyList_Append(parents, parent)
             parent_str = next + 1
-        return tuple(parents)
+        return parents
 
     cdef int process_one_record(self, char *start, char *end) except -1:
         """Take a simple string and split it into an index record."""

=== modified file 'bzrlib/_knit_load_data_py.py'
--- bzrlib/_knit_load_data_py.py	2008-03-20 00:43:25 +0000
+++ bzrlib/_knit_load_data_py.py	2007-07-05 19:39:28 +0000
@@ -90,6 +90,6 @@
                              options.split(','),
                              pos,
                              size,
-                             tuple(parents),
+                             parents,
                              index)
         # end kndx._cache_version

=== modified file 'bzrlib/_patiencediff_c.c'
--- bzrlib/_patiencediff_c.c	2008-08-17 19:39:54 +0000
+++ bzrlib/_patiencediff_c.c	2007-09-04 09:10:35 +0000
@@ -70,10 +70,11 @@
 
 
 struct line {
-    long hash;         /* hash code of the string/object */
+    int hash;          /* hash code of the string */
     Py_ssize_t next;   /* next line from the same equivalence class */
     Py_ssize_t equiv;  /* equivalence class */
-    PyObject *data;
+    Py_ssize_t len;
+    const char *data;
 };
 
 
@@ -150,8 +151,8 @@
 static inline int
 compare_lines(struct line *a, struct line *b)
 {
-    return ((a->hash != b->hash)
-            || PyObject_Compare(a->data, b->data));
+    return ((a->hash != b->hash) || (a->len != b->len) ||
+            memcmp(a->data, b->data, a->len));
 }
 
 
@@ -541,22 +542,12 @@
 }
 
 
-static void
-delete_lines(struct line *lines, Py_ssize_t size)
-{
-    struct line *line = lines;
-    while (size-- > 0) {
-        Py_XDECREF(line->data);
-        line++;
-    }
-    free(lines);
-}
-
-
 static Py_ssize_t
 load_lines(PyObject *orig, struct line **lines)
 {
-    Py_ssize_t size, i;
+    Py_ssize_t size, i, j;
+    int h;
+    char *p;
     struct line *line;
     PyObject *seq, *item;
 
@@ -571,8 +562,7 @@
         return 0;
     }
 
-    /* Allocate a memory block for line data, initialized to 0 */
-    line = *lines = (struct line *)calloc(size, sizeof(struct line));
+    line = *lines = (struct line *)malloc(sizeof(struct line) * size);
     if (line == NULL) {
         PyErr_NoMemory();
         Py_DECREF(seq);
@@ -581,25 +571,30 @@
 
     for (i = 0; i < size; i++) {
         item = PySequence_Fast_GET_ITEM(seq, i);
-        Py_INCREF(item);
-        line->data = item;
-        line->hash = PyObject_Hash(item);
-        if (line->hash == (-1)) {
-            /* Propogate the hash exception */
-            size = -1;
-            goto cleanup;
+        if (!PyString_Check(item)){
+            PyErr_Format(PyExc_TypeError,
+                     "sequence item %zd: expected string,"
+                     " %.80s found",
+                     i, item->ob_type->tp_name);
+            Py_DECREF(seq);
+            return -1;
         }
+        line->len = PyString_GET_SIZE(item);
+        line->data = p = PyString_AS_STRING(item);
+        /* 'djb2' hash. This gives us a nice compromise between fast hash
+            function and a hash with less collisions. The algorithm doesn't
+            use the hash for actual lookups, only for building the table
+            so a better hash function wouldn't bring us much benefit, but
+            would make this loading code slower. */
+        h = 5381;
+        for (j = 0; j < line->len; j++)
+            h = ((h << 5) + h) + *p++;
+        line->hash = h;
         line->next = SENTINEL;
         line++;
     }
 
-    cleanup:
     Py_DECREF(seq);
-    if (size == -1) {
-        /* Error -- cleanup unused object references */
-        delete_lines(*lines, i);
-        *lines = NULL;
-    }
     return size;
 }
 
@@ -652,16 +647,16 @@
     free(backpointers);
     free(matches);
     free(hashtable.table);
-    delete_lines(b, bsize);
-    delete_lines(a, asize);
+    free(b);
+    free(a);
     return res;
 
 error:
     free(backpointers);
     free(matches);
     free(hashtable.table);
-    delete_lines(b, bsize);
-    delete_lines(a, asize);
+    free(b);
+    free(a);
     return NULL;
 }
 
@@ -730,16 +725,16 @@
     free(backpointers);
     free(matches.matches);
     free(hashtable.table);
-    delete_lines(b, bsize);
-    delete_lines(a, asize);
+    free(b);
+    free(a);
     Py_RETURN_NONE;
 
 error:
     free(backpointers);
     free(matches.matches);
     free(hashtable.table);
-    delete_lines(b, bsize);
-    delete_lines(a, asize);
+    free(b);
+    free(a);
     return NULL;
 }
 
@@ -788,8 +783,8 @@
 {
     free(self->backpointers);
     free(self->hashtable.table);
-    delete_lines(self->b, self->bsize);
-    delete_lines(self->a, self->asize);
+    free(self->b);
+    free(self->a);
     self->ob_type->tp_free((PyObject *)self);
 }
 

=== modified file 'bzrlib/_patiencediff_py.py'
--- bzrlib/_patiencediff_py.py	2008-07-28 05:09:54 +0000
+++ bzrlib/_patiencediff_py.py	2007-09-04 09:10:35 +0000
@@ -176,7 +176,7 @@
     length = 0
     for i_a, i_b in matches:
         if (start_a is not None
-            and (i_a == start_a + length)
+            and (i_a == start_a + length) 
             and (i_b == start_b + length)):
             length += 1
         else:
@@ -196,11 +196,9 @@
     # For consistency sake, make sure all matches are only increasing
     next_a = -1
     next_b = -1
-    for (a, b, match_len) in answer:
-        if a < next_a:
-            raise ValueError('Non increasing matches for a')
-        if b < next_b:
-            raise ValueError('Non increasing matches for b')
+    for a,b,match_len in answer:
+        assert a >= next_a, 'Non increasing matches for a'
+        assert b >= next_b, 'Not increasing matches for b'
         next_a = a + match_len
         next_b = b + match_len
 

=== removed file 'bzrlib/_readdir_py.py'
--- bzrlib/_readdir_py.py	2008-09-02 04:45:47 +0000
+++ bzrlib/_readdir_py.py	1970-01-01 00:00:00 +0000
@@ -1,33 +0,0 @@
-# Copyright (C) 2006, 2008 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Python implementation of readdir interface."""
-
-
-import os
-
-
-def read_dir(path):
-    """Like os.listdir, this reads the contents of a directory.
-
-    There is a C module which is recommended which will return
-    a sort key in the first element of the tuple to allow slightly
-    more efficient behaviour on the operating systems part.
-
-    :param path: the directory to list.
-    :return: a list of (None, basename) tuples.
-    """
-    return [(None, name) for name in os.listdir(path)]

=== removed file 'bzrlib/_readdir_pyx.pyx'
--- bzrlib/_readdir_pyx.pyx	2008-09-02 04:45:47 +0000
+++ bzrlib/_readdir_pyx.pyx	1970-01-01 00:00:00 +0000
@@ -1,117 +0,0 @@
-# Copyright (C) 2006, 2008 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Wrapper for readdir which returns files ordered by inode."""
-
-
-import os
-import sys
-
-
-# the opaque C library DIR type.
-cdef extern from 'errno.h':
-    int ENOENT
-    int ENOTDIR
-    int EAGAIN
-    int errno
-    char *strerror(int errno)
-
-cdef extern from 'sys/types.h':
-    ctypedef long ssize_t
-    ctypedef unsigned long size_t
-
-cdef extern from 'dirent.h':
-    int DT_UNKNOWN
-    int DT_REG
-    int DT_DIR
-    int DT_FIFO
-    int DT_SOCK
-    int DT_CHR
-    int DT_BLK
-    ctypedef struct dirent:
-        char d_name[256]
-        # this will fail to compile if d_type is not defined.
-        # if this module fails to compile, use the .py version.
-        unsigned char d_type
-        int d_ino
-    ctypedef struct DIR
-    # should be DIR *, pyrex barfs.
-    DIR * opendir(char * name)
-    int closedir(DIR * dir)
-    dirent *readdir(DIR *dir)
-
-_directory = 'directory'
-_chardev = 'chardev'
-_block = 'block'
-_file = 'file'
-_fifo = 'fifo'
-_symlink = 'symlink'
-_socket = 'socket'
-_unknown = 'unknown'
-
-dot = ord('.')
-
-# add a typedef struct dirent dirent to workaround pyrex
-cdef extern from 'readdir.h':
-    pass
-
-def read_dir(path):
-    """Like os.listdir, this reads the contents of a directory.
-
-    :param path: the directory to list.
-    :return: a list of (sort_key, basename) tuples.
-    """
-    cdef DIR *the_dir
-    # currently this needs a fixup - the C code says 'dirent' but should say
-    # 'struct dirent'
-    cdef dirent * entry
-    cdef dirent sentinel
-    cdef char *name
-    the_dir = opendir(path)
-    if NULL == the_dir:
-        raise OSError(errno, strerror(errno))
-    result = []
-    try:
-        entry = &sentinel
-        while entry != NULL:
-            entry = readdir(the_dir)
-            if entry == NULL:
-                if errno == EAGAIN:
-                    # try again
-                    continue
-                elif errno != ENOTDIR and errno != ENOENT and errno != 0:
-                    # We see ENOTDIR at the end of a normal directory.
-                    # As ENOTDIR for read_dir(file) is triggered on opendir,
-                    # we consider ENOTDIR to be 'no error'.
-                    # ENOENT is listed as 'invalid position in the dir stream' for
-                    # readdir. We swallow this for now and just keep reading.
-                    raise OSError(errno, strerror(errno))
-                else:
-                    # done
-                    continue
-            name = entry.d_name
-            if not (name[0] == dot and (
-                (name[1] == 0) or 
-                (name[1] == dot and name[2] == 0))
-                ):
-                result.append((entry.d_ino, entry.d_name))
-    finally:
-        if -1 == closedir(the_dir):
-            raise OSError(errno, strerror(errno))
-    return result
-
-
-# vim: tw=79 ai expandtab sw=4 sts=4

=== removed file 'bzrlib/_walkdirs_win32.h'
--- bzrlib/_walkdirs_win32.h	2008-07-17 03:46:13 +0000
+++ bzrlib/_walkdirs_win32.h	1970-01-01 00:00:00 +0000
@@ -1,25 +0,0 @@
-/*
- * Copyright (C) 2007 Canonical Ltd
- * 
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
- * 
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- * 
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
- */
-
-/* Header includes, etc for _walkdirs_win32
- * Pyrex doesn't support #define, and defining WIN32_LEAN_AND_MEAN makes
- * importing windows.h a lot less painful.
- */
-
-#define WIN32_LEAN_AND_MEAN
-#include <windows.h>

=== removed file 'bzrlib/_walkdirs_win32.pyx'
--- bzrlib/_walkdirs_win32.pyx	2008-07-17 20:23:45 +0000
+++ bzrlib/_walkdirs_win32.pyx	1970-01-01 00:00:00 +0000
@@ -1,293 +0,0 @@
-# Copyright (C) 2008 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Helper functions for Walkdirs on win32."""
-
-
-cdef extern from "_walkdirs_win32.h":
-    struct _HANDLE:
-        pass
-    ctypedef _HANDLE *HANDLE
-    ctypedef unsigned long DWORD
-    ctypedef long long __int64
-    ctypedef unsigned short WCHAR
-    struct _FILETIME:
-        DWORD dwHighDateTime
-        DWORD dwLowDateTime
-    ctypedef _FILETIME FILETIME
-
-    struct _WIN32_FIND_DATAW:
-        DWORD dwFileAttributes
-        FILETIME ftCreationTime
-        FILETIME ftLastAccessTime
-        FILETIME ftLastWriteTime
-        DWORD nFileSizeHigh
-        DWORD nFileSizeLow
-        # Some reserved stuff here
-        WCHAR cFileName[260] # MAX_PATH
-        WCHAR cAlternateFilename[14]
-
-    # We have to use the typedef trick, otherwise pyrex uses:
-    #  struct WIN32_FIND_DATAW
-    # which fails due to 'incomplete type'
-    ctypedef _WIN32_FIND_DATAW WIN32_FIND_DATAW
-
-    HANDLE INVALID_HANDLE_VALUE
-    HANDLE FindFirstFileW(WCHAR *path, WIN32_FIND_DATAW *data)
-    int FindNextFileW(HANDLE search, WIN32_FIND_DATAW *data)
-    int FindClose(HANDLE search)
-
-    DWORD FILE_ATTRIBUTE_READONLY
-    DWORD FILE_ATTRIBUTE_DIRECTORY
-    int ERROR_NO_MORE_FILES
-
-    int GetLastError()
-
-    # Wide character functions
-    DWORD wcslen(WCHAR *)
-
-
-cdef extern from "Python.h":
-    WCHAR *PyUnicode_AS_UNICODE(object)
-    Py_ssize_t PyUnicode_GET_SIZE(object)
-    object PyUnicode_FromUnicode(WCHAR *, Py_ssize_t)
-    int PyList_Append(object, object) except -1
-    object PyUnicode_AsUTF8String(object)
-
-
-import operator
-import stat
-
-from bzrlib import osutils
-
-
-cdef class _Win32Stat:
-    """Represent a 'stat' result generated from WIN32_FIND_DATA"""
-
-    cdef readonly int st_mode
-    cdef readonly double st_ctime
-    cdef readonly double st_mtime
-    cdef readonly double st_atime
-    cdef readonly __int64 st_size
-
-    # os.stat always returns 0, so we hard code it here
-    cdef readonly int st_dev
-    cdef readonly int st_ino
-
-    def __repr__(self):
-        """Repr is the same as a Stat object.
-
-        (mode, ino, dev, nlink, uid, gid, size, atime, mtime, ctime)
-        """
-        return repr((self.st_mode, 0, 0, 0, 0, 0, self.st_size, self.st_atime,
-                     self.st_mtime, self.st_ctime))
-
-
-cdef object _get_name(WIN32_FIND_DATAW *data):
-    """Extract the Unicode name for this file/dir."""
-    return PyUnicode_FromUnicode(data.cFileName,
-                                 wcslen(data.cFileName))
-
-
-cdef int _get_mode_bits(WIN32_FIND_DATAW *data):
-    cdef int mode_bits
-
-    mode_bits = 0100666 # writeable file, the most common
-    if data.dwFileAttributes & FILE_ATTRIBUTE_READONLY == FILE_ATTRIBUTE_READONLY:
-        mode_bits = mode_bits ^ 0222 # remove the write bits
-    if data.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY == FILE_ATTRIBUTE_DIRECTORY:
-        # Remove the FILE bit, set the DIR bit, and set the EXEC bits
-        mode_bits = mode_bits ^ 0140111
-    return mode_bits
-
-
-cdef __int64 _get_size(WIN32_FIND_DATAW *data):
-    # Pyrex casts a DWORD into a PyLong anyway, so it is safe to do << 32
-    # on a DWORD
-    return ((<__int64>data.nFileSizeHigh) << 32) + data.nFileSizeLow
-
-
-cdef double _ftime_to_timestamp(FILETIME *ft):
-    """Convert from a FILETIME struct into a floating point timestamp.
-
-    The fields of a FILETIME structure are the hi and lo part
-    of a 64-bit value expressed in 100 nanosecond units.
-    1e7 is one second in such units; 1e-7 the inverse.
-    429.4967296 is 2**32 / 1e7 or 2**32 * 1e-7.
-    It also uses the epoch 1601-01-01 rather than 1970-01-01
-    (taken from posixmodule.c)
-    """
-    cdef __int64 val
-    # NB: This gives slightly different results versus casting to a 64-bit
-    #     integer and doing integer math before casting into a floating
-    #     point number. But the difference is in the sub millisecond range,
-    #     which doesn't seem critical here.
-    # secs between epochs: 11,644,473,600
-    val = ((<__int64>ft.dwHighDateTime) << 32) + ft.dwLowDateTime
-    return (val * 1.0e-7) - 11644473600.0
-
-
-cdef int _should_skip(WIN32_FIND_DATAW *data):
-    """Is this '.' or '..' so we should skip it?"""
-    if (data.cFileName[0] != c'.'):
-        return 0
-    if data.cFileName[1] == c'\0':
-        return 1
-    if data.cFileName[1] == c'.' and data.cFileName[2] == c'\0':
-        return 1
-    return 0
-
-
-cdef class Win32Finder:
-    """A class which encapsulates the search of files in a given directory"""
-
-    cdef object _top
-    cdef object _prefix
-
-    cdef object _directory_kind
-    cdef object _file_kind
-
-    cdef object _pending
-    cdef object _last_dirblock
-
-    def __init__(self, top, prefix=""):
-        self._top = top
-        self._prefix = prefix
-
-        self._directory_kind = osutils._directory_kind
-        self._file_kind = osutils._formats[stat.S_IFREG]
-
-        self._pending = [(osutils.safe_utf8(prefix), osutils.safe_unicode(top))]
-        self._last_dirblock = None
-
-    def __iter__(self):
-        return self
-
-    cdef object _get_kind(self, WIN32_FIND_DATAW *data):
-        if data.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY:
-            return self._directory_kind
-        return self._file_kind
-
-    cdef _Win32Stat _get_stat_value(self, WIN32_FIND_DATAW *data):
-        """Get the filename and the stat information."""
-        cdef _Win32Stat statvalue
-
-        statvalue = _Win32Stat()
-        statvalue.st_mode = _get_mode_bits(data)
-        statvalue.st_ctime = _ftime_to_timestamp(&data.ftCreationTime)
-        statvalue.st_mtime = _ftime_to_timestamp(&data.ftLastWriteTime)
-        statvalue.st_atime = _ftime_to_timestamp(&data.ftLastAccessTime)
-        statvalue.st_size = _get_size(data)
-        statvalue.st_ino = 0
-        statvalue.st_dev = 0
-        return statvalue
-
-    def _get_files_in(self, directory, relprefix):
-        """Return the dirblock for all files in the given directory.
-
-        :param directory: A path that can directly access the files on disk.
-            Should be a Unicode object.
-        :param relprefix: A psuedo path for these files (as inherited from the
-            original 'prefix=XXX' when instantiating this class.)
-            It should be a UTF-8 string.
-        :return: A dirblock for all the files of the form
-            [(utf8_relpath, utf8_fname, kind, _Win32Stat, unicode_abspath)]
-        """
-        cdef WIN32_FIND_DATAW search_data
-        cdef HANDLE hFindFile
-        cdef int last_err
-        cdef WCHAR *query
-        cdef int result
-
-        top_star = directory + '*'
-
-        dirblock = []
-
-        query = PyUnicode_AS_UNICODE(top_star)
-        hFindFile = FindFirstFileW(query, &search_data)
-        if hFindFile == INVALID_HANDLE_VALUE:
-            # Raise an exception? This path doesn't seem to exist
-            raise WindowsError(GetLastError(), top_star)
-
-        try:
-            result = 1
-            while result:
-                # Skip '.' and '..'
-                if _should_skip(&search_data):
-                    result = FindNextFileW(hFindFile, &search_data)
-                    continue
-                name_unicode = _get_name(&search_data)
-                name_utf8 = PyUnicode_AsUTF8String(name_unicode)
-                PyList_Append(dirblock, 
-                    (relprefix + name_utf8, name_utf8, 
-                     self._get_kind(&search_data),
-                     self._get_stat_value(&search_data),
-                     directory + name_unicode))
-
-                result = FindNextFileW(hFindFile, &search_data)
-            # FindNextFileW sets GetLastError() == ERROR_NO_MORE_FILES when it
-            # actually finishes. If we have anything else, then we have a
-            # genuine problem
-            last_err = GetLastError()
-            if last_err != ERROR_NO_MORE_FILES:
-                raise WindowsError(last_err)
-        finally:
-            result = FindClose(hFindFile)
-            if result == 0:
-                last_err = GetLastError()
-                # TODO: We should probably raise an exception if FindClose
-                #       returns an error, however, I don't want to supress an
-                #       earlier Exception, so for now, I'm ignoring this
-        return dirblock
-
-    cdef _update_pending(self):
-        """If we had a result before, add the subdirs to pending."""
-        if self._last_dirblock is not None:
-            # push the entries left in the dirblock onto the pending queue
-            # we do this here, because we allow the user to modified the
-            # queue before the next iteration
-            for d in reversed(self._last_dirblock):
-                if d[2] == self._directory_kind:
-                    self._pending.append((d[0], d[-1]))
-            self._last_dirblock = None
-        
-    def __next__(self):
-        self._update_pending()
-        if not self._pending:
-            raise StopIteration()
-        relroot, top = self._pending.pop()
-        # NB: At the moment Pyrex doesn't support Unicode literals, which means
-        # that all of these string literals are going to be upcasted to Unicode
-        # at runtime... :(
-        # Maybe we could use unicode(x) during __init__?
-        if relroot:
-            relprefix = relroot + '/'
-        else:
-            relprefix = ''
-        top_slash = top + '/'
-
-        dirblock = self._get_files_in(top_slash, relprefix)
-        dirblock.sort(key=operator.itemgetter(1))
-        self._last_dirblock = dirblock
-        return (relroot, top), dirblock
-
-
-def _walkdirs_utf8_win32_find_file(top, prefix=""):
-    """Implement a version of walkdirs_utf8 for win32.
-
-    This uses the find files api to both list the files and to stat them.
-    """
-    return Win32Finder(top, prefix=prefix)

=== modified file 'bzrlib/add.py'
--- bzrlib/add.py	2008-05-02 07:31:24 +0000
+++ bzrlib/add.py	2007-07-03 02:33:32 +0000
@@ -110,3 +110,24 @@
 add_action_null = add_action_add
 add_action_add_and_print = AddAction(should_print=True)
 add_action_print = add_action_add_and_print
+
+
+@deprecated_function(zero_eighteen)
+def smart_add(file_list, recurse=True, action=None, save=True):
+    """Add files to version, optionally recursing into directories.
+
+    This is designed more towards DWIM for humans than API simplicity.
+    For the specific behaviour see the help for cmd_add().
+
+    Returns the number of files added.
+    Deprecated in 0.18. Please use MutableTree.smart_add.
+    """
+    tree = WorkingTree.open_containing(file_list[0])[0]
+    return smart_add_tree(tree, file_list, recurse, action=action, save=save)
+
+
+@deprecated_function(zero_eighteen)
+def smart_add_tree(tree, file_list, recurse=True, action=None, save=True):
+    """Deprecated in 0.18. Please use MutableTree.smart_add."""
+    return tree.smart_add(file_list, recurse, action, save)
+

=== modified file 'bzrlib/annotate.py'
--- bzrlib/annotate.py	2008-07-29 16:50:43 +0000
+++ bzrlib/annotate.py	2007-10-16 16:02:01 +0000
@@ -39,20 +39,6 @@
 
 def annotate_file(branch, rev_id, file_id, verbose=False, full=False,
                   to_file=None, show_ids=False):
-    """Annotate file_id at revision rev_id in branch.
-
-    The branch should already be read_locked() when annotate_file is called.
-
-    :param branch: The branch to look for revision numbers and history from.
-    :param rev_id: The revision id to annotate.
-    :param file_id: The file_id to annotate.
-    :param verbose: Show all details rather than truncating to ensure
-        reasonable text width.
-    :param full: XXXX Not sure what this does.
-    :param to_file: The file to output the annotation to; if None stdout is
-        used.
-    :param show_ids: Show revision ids in the annotation output.
-    """
     if to_file is None:
         to_file = sys.stdout
 
@@ -111,10 +97,9 @@
 
 
 def _annotations(repo, file_id, rev_id):
-    """Return the list of (origin_revision_id, line_text) for a revision of a file in a repository."""
-    annotations = repo.texts.annotate((file_id, rev_id))
-    # 
-    return [(key[-1], line) for (key, line) in annotations]
+    """Return the list of (origin,text) for a revision of a file in a repository."""
+    w = repo.weave_store.get_weave(file_id, repo.get_transaction())
+    return list(w.annotate_iter(rev_id))
 
 
 def _annotate_file(branch, rev_id, file_id):
@@ -157,8 +142,7 @@
 
 
 def reannotate(parents_lines, new_lines, new_revision_id,
-               _left_matching_blocks=None,
-               heads_provider=None):
+               _left_matching_blocks=None):
     """Create a new annotated version from new lines and parent annotations.
     
     :param parents_lines: List of annotated lines for all parents
@@ -167,44 +151,28 @@
         (will often be CURRENT_REVISION)
     :param left_matching_blocks: a hint about which areas are common
         between the text and its left-hand-parent.  The format is
-        the SequenceMatcher.get_matching_blocks format
-        (start_left, start_right, length_of_match).
-    :param heads_provider: An object which provids a .heads() call to resolve
-        if any revision ids are children of others.
-        If None, then any ancestry disputes will be resolved with
-        new_revision_id
+        the SequenceMatcher.get_matching_blocks format.
     """
     if len(parents_lines) == 0:
-        lines = [(new_revision_id, line) for line in new_lines]
+        for line in new_lines:
+            yield new_revision_id, line
     elif len(parents_lines) == 1:
-        lines = _reannotate(parents_lines[0], new_lines, new_revision_id,
-                            _left_matching_blocks)
-    elif len(parents_lines) == 2:
-        left = _reannotate(parents_lines[0], new_lines, new_revision_id,
-                           _left_matching_blocks)
-        lines = _reannotate_annotated(parents_lines[1], new_lines,
-                                      new_revision_id, left,
-                                      heads_provider)
+        for data in _reannotate(parents_lines[0], new_lines, new_revision_id,
+                                _left_matching_blocks):
+            yield data
     else:
-        reannotations = [_reannotate(parents_lines[0], new_lines,
-                                     new_revision_id, _left_matching_blocks)]
-        reannotations.extend(_reannotate(p, new_lines, new_revision_id)
-                             for p in parents_lines[1:])
-        lines = []
+        block_list = [_left_matching_blocks] + [None] * len(parents_lines)
+        reannotations = [list(_reannotate(p, new_lines, new_revision_id, b))
+                         for p, b in zip(parents_lines, block_list)]
         for annos in zip(*reannotations):
             origins = set(a for a, l in annos)
+            line = annos[0][1]
             if len(origins) == 1:
-                # All the parents agree, so just return the first one
-                lines.append(annos[0])
+                yield iter(origins).next(), line
+            elif len(origins) == 2 and new_revision_id in origins:
+                yield (x for x in origins if x != new_revision_id).next(), line
             else:
-                line = annos[0][1]
-                if len(origins) == 2 and new_revision_id in origins:
-                    origins.remove(new_revision_id)
-                if len(origins) == 1:
-                    lines.append((origins.pop(), line))
-                else:
-                    lines.append((new_revision_id, line))
-    return lines
+                yield new_revision_id, line
 
 
 def _reannotate(parent_lines, new_lines, new_revision_id,
@@ -215,126 +183,9 @@
         matcher = patiencediff.PatienceSequenceMatcher(None,
             plain_parent_lines, new_lines)
         matching_blocks = matcher.get_matching_blocks()
-    lines = []
     for i, j, n in matching_blocks:
         for line in new_lines[new_cur:j]:
-            lines.append((new_revision_id, line))
-        lines.extend(parent_lines[i:i+n])
+            yield new_revision_id, line
+        for data in parent_lines[i:i+n]:
+            yield data
         new_cur = j + n
-    return lines
-
-
-def _get_matching_blocks(old, new):
-    matcher = patiencediff.PatienceSequenceMatcher(None,
-        old, new)
-    return matcher.get_matching_blocks()
-
-
-def _find_matching_unannotated_lines(output_lines, plain_child_lines,
-                                     child_lines, start_child, end_child,
-                                     right_lines, start_right, end_right,
-                                     heads_provider, revision_id):
-    """Find lines in plain_right_lines that match the existing lines.
-
-    :param output_lines: Append final annotated lines to this list
-    :param plain_child_lines: The unannotated new lines for the child text
-    :param child_lines: Lines for the child text which have been annotated
-        for the left parent
-    :param start_child: Position in plain_child_lines and child_lines to start the
-        match searching
-    :param end_child: Last position in plain_child_lines and child_lines to search
-        for a match
-    :param right_lines: The annotated lines for the whole text for the right
-        parent
-    :param start_right: Position in right_lines to start the match
-    :param end_right: Last position in right_lines to search for a match
-    :param heads_provider: When parents disagree on the lineage of a line, we
-        need to check if one side supersedes the other
-    :param revision_id: The label to give if a line should be labeled 'tip'
-    """
-    output_extend = output_lines.extend
-    output_append = output_lines.append
-    # We need to see if any of the unannotated lines match
-    plain_right_subset = [l for a,l in right_lines[start_right:end_right]]
-    plain_child_subset = plain_child_lines[start_child:end_child]
-    match_blocks = _get_matching_blocks(plain_right_subset, plain_child_subset)
-
-    last_child_idx = 0
-
-    for right_idx, child_idx, match_len in match_blocks:
-        # All the lines that don't match are just passed along
-        if child_idx > last_child_idx:
-            output_extend(child_lines[start_child + last_child_idx
-                                      :start_child + child_idx])
-        for offset in xrange(match_len):
-            left = child_lines[start_child+child_idx+offset]
-            right = right_lines[start_right+right_idx+offset]
-            if left[0] == right[0]:
-                # The annotations match, just return the left one
-                output_append(left)
-            elif left[0] == revision_id:
-                # The left parent marked this as unmatched, so let the
-                # right parent claim it
-                output_append(right)
-            else:
-                # Left and Right both claim this line
-                if heads_provider is None:
-                    output_append((revision_id, left[1]))
-                else:
-                    heads = heads_provider.heads((left[0], right[0]))
-                    if len(heads) == 1:
-                        output_append((iter(heads).next(), left[1]))
-                    else:
-                        # Both claim different origins, sort lexicographically
-                        # so that we always get a stable result.
-                        output_append(sorted([left, right])[0])
-        last_child_idx = child_idx + match_len
-
-
-def _reannotate_annotated(right_parent_lines, new_lines, new_revision_id,
-                          annotated_lines, heads_provider):
-    """Update the annotations for a node based on another parent.
-
-    :param right_parent_lines: A list of annotated lines for the right-hand
-        parent.
-    :param new_lines: The unannotated new lines.
-    :param new_revision_id: The revision_id to attribute to lines which are not
-        present in either parent.
-    :param annotated_lines: A list of annotated lines. This should be the
-        annotation of new_lines based on parents seen so far.
-    :param heads_provider: When parents disagree on the lineage of a line, we
-        need to check if one side supersedes the other.
-    """
-    if len(new_lines) != len(annotated_lines):
-        raise AssertionError("mismatched new_lines and annotated_lines")
-    # First compare the newly annotated lines with the right annotated lines.
-    # Lines which were not changed in left or right should match. This tends to
-    # be the bulk of the lines, and they will need no further processing.
-    lines = []
-    lines_extend = lines.extend
-    last_right_idx = 0 # The line just after the last match from the right side
-    last_left_idx = 0
-    matching_left_and_right = _get_matching_blocks(right_parent_lines,
-                                                   annotated_lines)
-    for right_idx, left_idx, match_len in matching_left_and_right:
-        # annotated lines from last_left_idx to left_idx did not match the lines from
-        # last_right_idx
-        # to right_idx, the raw lines should be compared to determine what annotations
-        # need to be updated
-        if last_right_idx == right_idx or last_left_idx == left_idx:
-            # One of the sides is empty, so this is a pure insertion
-            lines_extend(annotated_lines[last_left_idx:left_idx])
-        else:
-            # We need to see if any of the unannotated lines match
-            _find_matching_unannotated_lines(lines,
-                                             new_lines, annotated_lines,
-                                             last_left_idx, left_idx,
-                                             right_parent_lines,
-                                             last_right_idx, right_idx,
-                                             heads_provider,
-                                             new_revision_id)
-        last_right_idx = right_idx + match_len
-        last_left_idx = left_idx + match_len
-        # If left and right agree on a range, just push that into the output
-        lines_extend(annotated_lines[left_idx:left_idx + match_len])
-    return lines

=== modified file 'bzrlib/atomicfile.py'
--- bzrlib/atomicfile.py	2008-08-16 04:00:54 +0000
+++ bzrlib/atomicfile.py	2006-10-16 01:25:46 +0000
@@ -51,9 +51,11 @@
         global _hostname
 
         self._fd = None
+        assert mode in ('wb', 'wt'), \
+            "invalid AtomicFile mode %r" % mode
 
         if _hostname is None:
-            _hostname = osutils.get_host_name()
+            _hostname = socket.gethostname()
 
         self.tmpfilename = '%s.%d.%s.tmp' % (filename, _pid, _hostname)
 
@@ -62,8 +64,6 @@
         flags = os.O_EXCL | os.O_CREAT | os.O_WRONLY
         if mode == 'wb':
             flags |= osutils.O_BINARY
-        elif mode != 'wt':
-            raise ValueError("invalid AtomicFile mode %r" % mode)
 
         if new_mode is not None:
             local_mode = new_mode

=== modified file 'bzrlib/benchmarks/bench_bundle.py'
--- bzrlib/benchmarks/bench_bundle.py	2008-05-02 07:31:24 +0000
+++ bzrlib/benchmarks/bench_bundle.py	2007-07-22 12:08:19 +0000
@@ -21,6 +21,7 @@
 import shutil
 
 from bzrlib import bzrdir
+from bzrlib.add import smart_add
 from bzrlib.benchmarks import Benchmark
 from bzrlib.branch import Branch
 from bzrlib.bundle.apply_bundle import install_bundle

=== modified file 'bzrlib/benchmarks/bench_osutils.py'
--- bzrlib/benchmarks/bench_osutils.py	2008-08-20 02:07:36 +0000
+++ bzrlib/benchmarks/bench_osutils.py	2007-04-09 22:11:22 +0000
@@ -29,7 +29,6 @@
         self.make_kernel_like_tree(link_working=True)
         # on roberts machine: this originally took:  157ms/4177ms
         # plain os.walk takes 213ms on this tree
-        # with the pyrex readdir module:              77ms/5423ms
         def dowalk():
             for dirblock in osutils.walkdirs('.'):
                 if dirblock[0][1] == '.bzr':

=== modified file 'bzrlib/benchmarks/tree_creator/kernel_like.py'
--- bzrlib/benchmarks/tree_creator/kernel_like.py	2008-04-24 07:22:53 +0000
+++ bzrlib/benchmarks/tree_creator/kernel_like.py	2007-09-13 22:41:38 +0000
@@ -195,6 +195,7 @@
             returns only an in-memory Inventory, so it should always be None.
         :return: An Inventory object.
         """
+        assert root is None, "Cannot create a memory inventory in a on disk."
         cache_dir = self._get_cache_dir()
         if cache_dir is None:
             return self._create_and_return()

=== modified file 'bzrlib/branch.py'
--- bzrlib/branch.py	2008-08-28 18:57:59 +0000
+++ bzrlib/branch.py	2007-10-08 07:29:57 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2008 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -15,11 +15,13 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 
-import sys
+from cStringIO import StringIO
 
 from bzrlib.lazy_import import lazy_import
 lazy_import(globals(), """
-from itertools import chain
+from warnings import warn
+
+import bzrlib
 from bzrlib import (
         bzrdir,
         cache_utf8,
@@ -28,15 +30,16 @@
         errors,
         lockdir,
         lockable_files,
-        repository,
+        osutils,
         revision as _mod_revision,
         transport,
+        tree,
         tsort,
         ui,
         urlutils,
         )
-from bzrlib.config import BranchConfig
-from bzrlib.repofmt.pack_repo import RepositoryFormatPackDevelopment1Subtree
+from bzrlib.config import BranchConfig, TreeConfig
+from bzrlib.lockable_files import LockableFiles, TransportLock
 from bzrlib.tag import (
     BasicTags,
     DisabledTags,
@@ -44,12 +47,22 @@
 """)
 
 from bzrlib.decorators import needs_read_lock, needs_write_lock
+from bzrlib.errors import (BzrError, BzrCheckError, DivergedBranches,
+                           HistoryMissing, InvalidRevisionId,
+                           InvalidRevisionNumber, LockError, NoSuchFile,
+                           NoSuchRevision, NotVersionedError,
+                           NotBranchError, UninitializableFormat,
+                           UnlistableStore, UnlistableBranch,
+                           )
 from bzrlib.hooks import Hooks
-from bzrlib.symbol_versioning import (
-    deprecated_in,
-    deprecated_method,
-    )
-from bzrlib.trace import mutter, mutter_callsite, note, is_quiet
+from bzrlib.symbol_versioning import (deprecated_function,
+                                      deprecated_method,
+                                      DEPRECATED_PARAMETER,
+                                      deprecated_passed,
+                                      zero_eight, zero_nine, zero_sixteen,
+                                      zero_ninetyone,
+                                      )
+from bzrlib.trace import mutter, mutter_callsite, note
 
 
 BZR_BRANCH_FORMAT_4 = "Bazaar-NG branch, format 0.0.4\n"
@@ -89,11 +102,6 @@
         self.tags = self._make_tags()
         self._revision_history_cache = None
         self._revision_id_to_revno_cache = None
-        self._last_revision_info_cache = None
-        self._open_hook()
-
-    def _open_hook(self):
-        """Called by init to allow simpler extension of the base class."""
 
     def break_lock(self):
         """Break a lock if one is present from another instance.
@@ -203,8 +211,7 @@
         :return: A dictionary mapping revision_id => dotted revno.
         """
         last_revision = self.last_revision()
-        revision_graph = repository._old_get_graph(self.repository,
-            last_revision)
+        revision_graph = self.repository.get_revision_graph(last_revision)
         merge_sorted_revisions = tsort.merge_sort(
             revision_graph,
             last_revision,
@@ -231,6 +238,14 @@
         """
         self.control_files.dont_leave_in_place()
 
+    def abspath(self, name):
+        """Return absolute filename for something in the branch
+        
+        XXX: Robert Collins 20051017 what is this used for? why is it a branch
+        method and not a tree method.
+        """
+        raise NotImplementedError(self.abspath)
+
     def bind(self, other):
         """Bind the local branch the other branch.
 
@@ -264,7 +279,8 @@
             if last_revision is None:
                 pb.update('get source history')
                 last_revision = from_branch.last_revision()
-                last_revision = _mod_revision.ensure_null(last_revision)
+                if last_revision is None:
+                    last_revision = _mod_revision.NULL_REVISION
             return self.repository.fetch(from_branch.repository,
                                          revision_id=last_revision,
                                          pb=nested_pb)
@@ -319,19 +335,20 @@
         The delta is relative to its mainline predecessor, or the
         empty tree for revision 1.
         """
+        assert isinstance(revno, int)
         rh = self.revision_history()
         if not (1 <= revno <= len(rh)):
-            raise errors.InvalidRevisionNumber(revno)
+            raise InvalidRevisionNumber(revno)
         return self.repository.get_revision_delta(rh[revno-1])
 
-    def get_stacked_on_url(self):
-        """Get the URL this branch is stacked against.
+    @deprecated_method(zero_sixteen)
+    def get_root_id(self):
+        """Return the id of this branches root
 
-        :raises NotStacked: If the branch is not stacked.
-        :raises UnstackableBranchFormat: If the branch does not support
-            stacking.
+        Deprecated: branches don't have root ids-- trees do.
+        Use basis_tree().get_root_id() instead.
         """
-        raise NotImplementedError(self.get_stacked_on_url)
+        raise NotImplementedError(self.get_root_id)
 
     def print_file(self, file, revision_id):
         """Print `file` to stdout."""
@@ -340,16 +357,6 @@
     def set_revision_history(self, rev_history):
         raise NotImplementedError(self.set_revision_history)
 
-    def set_stacked_on_url(self, url):
-        """Set the URL this branch is stacked against.
-
-        :raises UnstackableBranchFormat: If the branch does not support
-            stacking.
-        :raises UnstackableRepositoryFormat: If the repository does not support
-            stacking.
-        """
-        raise NotImplementedError(self.set_stacked_on_url)
-
     def _cache_revision_history(self, rev_history):
         """Set the cached revision history to rev_history.
 
@@ -380,7 +387,6 @@
         """
         self._revision_history_cache = None
         self._revision_id_to_revno_cache = None
-        self._last_revision_info_cache = None
 
     def _gen_revision_history(self):
         """Return sequence of revision hashes on to this branch.
@@ -419,7 +425,7 @@
         That is equivalent to the number of revisions committed to
         this branch.
         """
-        return self.last_revision_info()[0]
+        return len(self.revision_history())
 
     def unbind(self):
         """Older format branches cannot bind or unbind."""
@@ -430,20 +436,18 @@
         raise errors.UpgradeRequired(self.base)
 
     def last_revision(self):
-        """Return last revision id, or NULL_REVISION."""
-        return self.last_revision_info()[1]
+        """Return last revision id, or None"""
+        ph = self.revision_history()
+        if ph:
+            return ph[-1]
+        else:
+            return _mod_revision.NULL_REVISION
 
-    @needs_read_lock
     def last_revision_info(self):
         """Return information about the last revision.
 
-        :return: A tuple (revno, revision_id).
+        :return: A tuple (revno, last_revision_id).
         """
-        if self._last_revision_info_cache is None:
-            self._last_revision_info_cache = self._last_revision_info()
-        return self._last_revision_info_cache
-
-    def _last_revision_info(self):
         rh = self.revision_history()
         revno = len(rh)
         if revno:
@@ -451,7 +455,6 @@
         else:
             return (0, _mod_revision.NULL_REVISION)
 
-    @deprecated_method(deprecated_in((1, 6, 0)))
     def missing_revisions(self, other, stop_revision=None):
         """Return a list of new revisions that would perfectly fit.
         
@@ -465,66 +468,24 @@
         common_index = min(self_len, other_len) -1
         if common_index >= 0 and \
             self_history[common_index] != other_history[common_index]:
-            raise errors.DivergedBranches(self, other)
+            raise DivergedBranches(self, other)
 
         if stop_revision is None:
             stop_revision = other_len
         else:
+            assert isinstance(stop_revision, int)
             if stop_revision > other_len:
                 raise errors.NoSuchRevision(self, stop_revision)
         return other_history[self_len:stop_revision]
 
-    @needs_write_lock
-    def update_revisions(self, other, stop_revision=None, overwrite=False,
-                         graph=None):
+    def update_revisions(self, other, stop_revision=None):
         """Pull in new perfect-fit revisions.
 
         :param other: Another Branch to pull from
         :param stop_revision: Updated until the given revision
-        :param overwrite: Always set the branch pointer, rather than checking
-            to see if it is a proper descendant.
-        :param graph: A Graph object that can be used to query history
-            information. This can be None.
         :return: None
         """
-        other.lock_read()
-        try:
-            other_revno, other_last_revision = other.last_revision_info()
-            stop_revno = None # unknown
-            if stop_revision is None:
-                stop_revision = other_last_revision
-                if _mod_revision.is_null(stop_revision):
-                    # if there are no commits, we're done.
-                    return
-                stop_revno = other_revno
-
-            # what's the current last revision, before we fetch [and change it
-            # possibly]
-            last_rev = _mod_revision.ensure_null(self.last_revision())
-            # we fetch here so that we don't process data twice in the common
-            # case of having something to pull, and so that the check for 
-            # already merged can operate on the just fetched graph, which will
-            # be cached in memory.
-            self.fetch(other, stop_revision)
-            # Check to see if one is an ancestor of the other
-            if not overwrite:
-                if graph is None:
-                    graph = self.repository.get_graph()
-                if self._check_if_descendant_or_diverged(
-                        stop_revision, last_rev, graph, other):
-                    # stop_revision is a descendant of last_rev, but we aren't
-                    # overwriting, so we're done.
-                    return
-            if stop_revno is None:
-                if graph is None:
-                    graph = self.repository.get_graph()
-                this_revno, this_last_revision = self.last_revision_info()
-                stop_revno = graph.find_distance_to_null(stop_revision,
-                                [(other_last_revision, other_revno),
-                                 (this_last_revision, this_revno)])
-            self.set_last_revision_info(stop_revno, stop_revision)
-        finally:
-            other.unlock()
+        raise NotImplementedError(self.update_revisions)
 
     def revision_id_to_revno(self, revision_id):
         """Given a revision id, return its revno"""
@@ -547,7 +508,7 @@
         return history[revno - 1]
 
     def pull(self, source, overwrite=False, stop_revision=None,
-             possible_transports=None, _override_hook_target=None):
+             possible_transports=None):
         """Mirror source into this branch.
 
         This branch is considered to be 'local', having low latency.
@@ -567,6 +528,29 @@
         """Return `Tree` object for last revision."""
         return self.repository.revision_tree(self.last_revision())
 
+    def rename_one(self, from_rel, to_rel):
+        """Rename one file.
+
+        This can change the directory or the filename or both.
+        """
+        raise NotImplementedError(self.rename_one)
+
+    def move(self, from_paths, to_name):
+        """Rename files.
+
+        to_name must exist as a versioned directory.
+
+        If to_name exists and is a directory, the files are moved into
+        it, keeping their old names.  If it is a directory, 
+
+        Note that to_name is only the last component of the new name;
+        this doesn't change the directory.
+
+        This returns a list of (from_path, to_path) pairs for each
+        entry that is moved.
+        """
+        raise NotImplementedError(self.move)
+
     def get_parent(self):
         """Return the parent location of the branch.
 
@@ -663,7 +647,7 @@
         Zero (the NULL revision) is considered invalid
         """
         if revno < 1 or revno > self.revno():
-            raise errors.InvalidRevisionNumber(revno)
+            raise InvalidRevisionNumber(revno)
 
     @needs_read_lock
     def clone(self, to_bzrdir, revision_id=None):
@@ -672,20 +656,18 @@
         revision_id: if not None, the revision history in the new branch will
                      be truncated to end with revision_id.
         """
-        result = to_bzrdir.create_branch()
+        result = self._format.initialize(to_bzrdir)
         self.copy_content_into(result, revision_id=revision_id)
         return  result
 
     @needs_read_lock
     def sprout(self, to_bzrdir, revision_id=None):
         """Create a new line of development from the branch, into to_bzrdir.
-
-        to_bzrdir controls the branch format.
-
+        
         revision_id: if not None, the revision history in the new branch will
                      be truncated to end with revision_id.
         """
-        result = to_bzrdir.create_branch()
+        result = self._format.initialize(to_bzrdir)
         self.copy_content_into(result, revision_id=revision_id)
         result.set_parent(self.bzrdir.root_transport.base)
         return result
@@ -705,8 +687,7 @@
         """
         if revision_id == _mod_revision.NULL_REVISION:
             new_history = []
-        else:
-            new_history = self.revision_history()
+        new_history = self.revision_history()
         if revision_id is not None and new_history != []:
             try:
                 new_history = new_history[:new_history.index(revision_id) + 1]
@@ -745,16 +726,7 @@
         :return: A BranchCheckResult.
         """
         mainline_parent_id = None
-        last_revno, last_revision_id = self.last_revision_info()
-        real_rev_history = list(self.repository.iter_reverse_revision_history(
-                                last_revision_id))
-        real_rev_history.reverse()
-        if len(real_rev_history) != last_revno:
-            raise errors.BzrCheckError('revno does not match len(mainline)'
-                ' %s != %s' % (last_revno, len(real_rev_history)))
-        # TODO: We should probably also check that real_rev_history actually
-        #       matches self.revision_history()
-        for revision_id in real_rev_history:
+        for revision_id in self.revision_history():
             try:
                 revision = self.repository.get_revision(revision_id)
             except errors.NoSuchRevision, e:
@@ -785,20 +757,13 @@
         return format
 
     def create_checkout(self, to_location, revision_id=None,
-                        lightweight=False, accelerator_tree=None,
-                        hardlink=False):
+                        lightweight=False):
         """Create a checkout of a branch.
         
         :param to_location: The url to produce the checkout at
         :param revision_id: The revision to check out
         :param lightweight: If True, produce a lightweight checkout, otherwise,
         produce a bound branch (heavyweight checkout)
-        :param accelerator_tree: A tree which can be used for retrieving file
-            contents more quickly than the revision tree, i.e. a workingtree.
-            The revision tree will be used for cases where accelerator_tree's
-            content is different.
-        :param hardlink: If true, hard-link files from accelerator_tree,
-            where possible.
         :return: The tree of the created checkout
         """
         t = transport.get_transport(to_location)
@@ -806,7 +771,7 @@
         if lightweight:
             format = self._get_checkout_format()
             checkout = format.initialize_on_transport(t)
-            from_branch = BranchReferenceFormat().initialize(checkout, self)
+            BranchReferenceFormat().initialize(checkout, self)
         else:
             format = self._get_checkout_format()
             checkout_branch = bzrdir.BzrDir.create_branch_convenience(
@@ -816,11 +781,7 @@
             # pull up to the specified revision_id to set the initial 
             # branch tip correctly, and seed it with history.
             checkout_branch.pull(self, stop_revision=revision_id)
-            from_branch=None
-        tree = checkout.create_workingtree(revision_id,
-                                           from_branch=from_branch,
-                                           accelerator_tree=accelerator_tree,
-                                           hardlink=hardlink)
+        tree = checkout.create_workingtree(revision_id)
         basis_tree = tree.basis_tree()
         basis_tree.lock_read()
         try:
@@ -833,14 +794,6 @@
             basis_tree.unlock()
         return tree
 
-    @needs_write_lock
-    def reconcile(self, thorough=True):
-        """Make sure the data stored in this branch is consistent."""
-        from bzrlib.reconcile import BranchReconciler
-        reconciler = BranchReconciler(self, thorough=thorough)
-        reconciler.reconcile()
-        return reconciler
-
     def reference_parent(self, file_id, path):
         """Return the parent branch for a tree-reference file_id
         :param file_id: The file_id of the tree reference
@@ -853,41 +806,6 @@
     def supports_tags(self):
         return self._format.supports_tags()
 
-    def _check_if_descendant_or_diverged(self, revision_a, revision_b, graph,
-                                         other_branch):
-        """Ensure that revision_b is a descendant of revision_a.
-
-        This is a helper function for update_revisions.
-        
-        :raises: DivergedBranches if revision_b has diverged from revision_a.
-        :returns: True if revision_b is a descendant of revision_a.
-        """
-        relation = self._revision_relations(revision_a, revision_b, graph)
-        if relation == 'b_descends_from_a':
-            return True
-        elif relation == 'diverged':
-            raise errors.DivergedBranches(self, other_branch)
-        elif relation == 'a_descends_from_b':
-            return False
-        else:
-            raise AssertionError("invalid relation: %r" % (relation,))
-
-    def _revision_relations(self, revision_a, revision_b, graph):
-        """Determine the relationship between two revisions.
-        
-        :returns: One of: 'a_descends_from_b', 'b_descends_from_a', 'diverged'
-        """
-        heads = graph.heads([revision_a, revision_b])
-        if heads == set([revision_b]):
-            return 'b_descends_from_a'
-        elif heads == set([revision_a, revision_b]):
-            # These branches have diverged
-            return 'diverged'
-        elif heads == set([revision_a]):
-            return 'a_descends_from_b'
-        else:
-            raise AssertionError("invalid heads: %r" % (heads,))
-
 
 class BranchFormat(object):
     """An encapsulation of the initialization and open routines for a format.
@@ -926,10 +844,10 @@
             transport = a_bzrdir.get_branch_transport(None)
             format_string = transport.get("format").read()
             return klass._formats[format_string]
-        except errors.NoSuchFile:
-            raise errors.NotBranchError(path=transport.base)
+        except NoSuchFile:
+            raise NotBranchError(path=transport.base)
         except KeyError:
-            raise errors.UnknownFormatError(format=format_string, kind='branch')
+            raise errors.UnknownFormatError(format=format_string)
 
     @classmethod
     def get_default_format(klass):
@@ -948,19 +866,6 @@
         """
         return None
 
-    @classmethod
-    def set_reference(self, a_bzrdir, to_branch):
-        """Set the target reference of the branch in a_bzrdir.
-
-        format probing must have been completed before calling
-        this method - it is assumed that the format of the branch
-        in a_bzrdir is correct.
-
-        :param a_bzrdir: The bzrdir to set the branch reference for.
-        :param to_branch: branch that the checkout is to reference
-        """
-        raise NotImplementedError(self.set_reference)
-
     def get_format_string(self):
         """Return the ASCII format string that identifies this format."""
         raise NotImplementedError(self.get_format_string)
@@ -993,12 +898,10 @@
         control_files.create_lock()
         control_files.lock_write()
         if set_format:
-            utf8_files += [('format', self.get_format_string())]
+            control_files.put_utf8('format', self.get_format_string())
         try:
-            for (filename, content) in utf8_files:
-                branch_transport.put_bytes(
-                    filename, content,
-                    mode=a_bzrdir._get_file_mode())
+            for file, content in utf8_files:
+                control_files.put_utf8(file, content)
         finally:
             control_files.unlock()
         return self.open(a_bzrdir, _found=True)
@@ -1032,12 +935,9 @@
     def set_default_format(klass, format):
         klass._default_format = format
 
-    def supports_stacking(self):
-        """True if this format records a stacked-on branch."""
-        return False
-
     @classmethod
     def unregister_format(klass, format):
+        assert klass._formats[format.get_format_string()] is format
         del klass._formats[format.get_format_string()]
 
     def __str__(self):
@@ -1047,6 +947,20 @@
         """True if this format supports tags stored in the branch"""
         return False  # by default
 
+    # XXX: Probably doesn't really belong here -- mbp 20070212
+    def _initialize_control_files(self, a_bzrdir, utf8_files, lock_filename,
+            lock_class):
+        branch_transport = a_bzrdir.get_branch_transport(self)
+        control_files = lockable_files.LockableFiles(branch_transport,
+            lock_filename, lock_class)
+        control_files.create_lock()
+        control_files.lock_write()
+        try:
+            for filename, content in utf8_files:
+                control_files.put_utf8(filename, content)
+        finally:
+            control_files.unlock()
+
 
 class BranchHooks(Hooks):
     """A dictionary mapping hook name to a list of callables for branch hooks.
@@ -1109,62 +1023,12 @@
         # local is the local branch or None, master is the target branch,
         # and an empty branch recieves new_revno of 0, new_revid of None.
         self['post_uncommit'] = []
-        # Introduced in 1.6
-        # Invoked before the tip of a branch changes.
-        # the api signature is
-        # (params) where params is a ChangeBranchTipParams with the members
-        # (branch, old_revno, new_revno, old_revid, new_revid)
-        self['pre_change_branch_tip'] = []
-        # Introduced in 1.4
-        # Invoked after the tip of a branch changes.
-        # the api signature is
-        # (params) where params is a ChangeBranchTipParams with the members
-        # (branch, old_revno, new_revno, old_revid, new_revid)
-        self['post_change_branch_tip'] = []
 
 
 # install the default hooks into the Branch class.
 Branch.hooks = BranchHooks()
 
 
-class ChangeBranchTipParams(object):
-    """Object holding parameters passed to *_change_branch_tip hooks.
-
-    There are 5 fields that hooks may wish to access:
-
-    :ivar branch: the branch being changed
-    :ivar old_revno: revision number before the change
-    :ivar new_revno: revision number after the change
-    :ivar old_revid: revision id before the change
-    :ivar new_revid: revision id after the change
-
-    The revid fields are strings. The revno fields are integers.
-    """
-
-    def __init__(self, branch, old_revno, new_revno, old_revid, new_revid):
-        """Create a group of ChangeBranchTip parameters.
-
-        :param branch: The branch being changed.
-        :param old_revno: Revision number before the change.
-        :param new_revno: Revision number after the change.
-        :param old_revid: Tip revision id before the change.
-        :param new_revid: Tip revision id after the change.
-        """
-        self.branch = branch
-        self.old_revno = old_revno
-        self.new_revno = new_revno
-        self.old_revid = old_revid
-        self.new_revid = new_revid
-
-    def __eq__(self, other):
-        return self.__dict__ == other.__dict__
-    
-    def __repr__(self):
-        return "<%s of %s from (%s, %s) to (%s, %s)>" % (
-            self.__class__.__name__, self.branch, 
-            self.old_revno, self.old_revid, self.new_revno, self.new_revid)
-
-
 class BzrBranchFormat4(BranchFormat):
     """Bzr branch format 4.
 
@@ -1207,79 +1071,60 @@
         return "Bazaar-NG branch format 4"
 
 
-class BranchFormatMetadir(BranchFormat):
-    """Common logic for meta-dir based branch formats."""
-
-    def _branch_class(self):
-        """What class to instantiate on open calls."""
-        raise NotImplementedError(self._branch_class)
+class BzrBranchFormat5(BranchFormat):
+    """Bzr branch format 5.
+
+    This format has:
+     - a revision-history file.
+     - a format string
+     - a lock dir guarding the branch itself
+     - all of this stored in a branch/ subdirectory
+     - works with shared repositories.
+
+    This format is new in bzr 0.8.
+    """
+
+    def get_format_string(self):
+        """See BranchFormat.get_format_string()."""
+        return "Bazaar-NG branch format 5\n"
+
+    def get_format_description(self):
+        """See BranchFormat.get_format_description()."""
+        return "Branch format 5"
+        
+    def initialize(self, a_bzrdir):
+        """Create a branch of this format in a_bzrdir."""
+        utf8_files = [('revision-history', ''),
+                      ('branch-name', ''),
+                      ]
+        return self._initialize_helper(a_bzrdir, utf8_files)
+
+    def __init__(self):
+        super(BzrBranchFormat5, self).__init__()
+        self._matchingbzrdir = bzrdir.BzrDirMetaFormat1()
 
     def open(self, a_bzrdir, _found=False):
-        """Return the branch object for a_bzrdir.
+        """Return the branch object for a_bzrdir
 
         _found is a private parameter, do not use it. It is used to indicate
                if format probing has already be done.
         """
         if not _found:
             format = BranchFormat.find_format(a_bzrdir)
-            if format.__class__ != self.__class__:
-                raise AssertionError("wrong format %r found for %r" %
-                    (format, self))
+            assert format.__class__ == self.__class__
         try:
             transport = a_bzrdir.get_branch_transport(None)
             control_files = lockable_files.LockableFiles(transport, 'lock',
                                                          lockdir.LockDir)
-            return self._branch_class()(_format=self,
+            return BzrBranch5(_format=self,
                               _control_files=control_files,
                               a_bzrdir=a_bzrdir,
                               _repository=a_bzrdir.find_repository())
-        except errors.NoSuchFile:
-            raise errors.NotBranchError(path=transport.base)
-
-    def __init__(self):
-        super(BranchFormatMetadir, self).__init__()
-        self._matchingbzrdir = bzrdir.BzrDirMetaFormat1()
-
-    def supports_tags(self):
-        return True
-
-
-class BzrBranchFormat5(BranchFormatMetadir):
-    """Bzr branch format 5.
-
-    This format has:
-     - a revision-history file.
-     - a format string
-     - a lock dir guarding the branch itself
-     - all of this stored in a branch/ subdirectory
-     - works with shared repositories.
-
-    This format is new in bzr 0.8.
-    """
-
-    def _branch_class(self):
-        return BzrBranch5
-
-    def get_format_string(self):
-        """See BranchFormat.get_format_string()."""
-        return "Bazaar-NG branch format 5\n"
-
-    def get_format_description(self):
-        """See BranchFormat.get_format_description()."""
-        return "Branch format 5"
-        
-    def initialize(self, a_bzrdir):
-        """Create a branch of this format in a_bzrdir."""
-        utf8_files = [('revision-history', ''),
-                      ('branch-name', ''),
-                      ]
-        return self._initialize_helper(a_bzrdir, utf8_files)
-
-    def supports_tags(self):
-        return False
-
-
-class BzrBranchFormat6(BranchFormatMetadir):
+        except NoSuchFile:
+            raise NotBranchError(path=transport.base)
+
+
+class BzrBranchFormat6(BzrBranchFormat5):
     """Branch format with last-revision and tags.
 
     Unlike previous formats, this has no explicit revision history. Instead,
@@ -1290,9 +1135,6 @@
     and became the default in 0.91.
     """
 
-    def _branch_class(self):
-        return BzrBranch6
-
     def get_format_string(self):
         """See BranchFormat.get_format_string()."""
         return "Bazaar Branch Format 6 (bzr 0.15)\n"
@@ -1304,46 +1146,30 @@
     def initialize(self, a_bzrdir):
         """Create a branch of this format in a_bzrdir."""
         utf8_files = [('last-revision', '0 null:\n'),
-                      ('branch.conf', ''),
-                      ('tags', ''),
-                      ]
-        return self._initialize_helper(a_bzrdir, utf8_files)
-
-
-class BzrBranchFormat7(BranchFormatMetadir):
-    """Branch format with last-revision, tags, and a stacked location pointer.
-
-    The stacked location pointer is passed down to the repository and requires
-    a repository format with supports_external_lookups = True.
-
-    This format was introduced in bzr 1.6.
-    """
-
-    def _branch_class(self):
-        return BzrBranch7
-
-    def get_format_string(self):
-        """See BranchFormat.get_format_string()."""
-        return "Bazaar Branch Format 7 (needs bzr 1.6)\n"
-
-    def get_format_description(self):
-        """See BranchFormat.get_format_description()."""
-        return "Branch format 7"
-
-    def initialize(self, a_bzrdir):
-        """Create a branch of this format in a_bzrdir."""
-        utf8_files = [('last-revision', '0 null:\n'),
-                      ('branch.conf', ''),
-                      ('tags', ''),
-                      ]
-        return self._initialize_helper(a_bzrdir, utf8_files)
-
-    def __init__(self):
-        super(BzrBranchFormat7, self).__init__()
-        self._matchingbzrdir.repository_format = \
-            RepositoryFormatPackDevelopment1Subtree()
-
-    def supports_stacking(self):
+                      ('branch-name', ''),
+                      ('branch.conf', ''),
+                      ('tags', ''),
+                      ]
+        return self._initialize_helper(a_bzrdir, utf8_files)
+
+    def open(self, a_bzrdir, _found=False):
+        """Return the branch object for a_bzrdir
+
+        _found is a private parameter, do not use it. It is used to indicate
+               if format probing has already be done.
+        """
+        if not _found:
+            format = BranchFormat.find_format(a_bzrdir)
+            assert format.__class__ == self.__class__
+        transport = a_bzrdir.get_branch_transport(None)
+        control_files = lockable_files.LockableFiles(transport, 'lock',
+                                                     lockdir.LockDir)
+        return BzrBranch6(_format=self,
+                          _control_files=control_files,
+                          a_bzrdir=a_bzrdir,
+                          _repository=a_bzrdir.find_repository())
+
+    def supports_tags(self):
         return True
 
 
@@ -1365,17 +1191,12 @@
     def get_format_description(self):
         """See BranchFormat.get_format_description()."""
         return "Checkout reference format 1"
-
+        
     def get_reference(self, a_bzrdir):
         """See BranchFormat.get_reference()."""
         transport = a_bzrdir.get_branch_transport(None)
         return transport.get('location').read()
 
-    def set_reference(self, a_bzrdir, to_branch):
-        """See BranchFormat.set_reference()."""
-        transport = a_bzrdir.get_branch_transport(None)
-        location = transport.put_bytes('location', to_branch.base)
-
     def initialize(self, a_bzrdir, target_branch=None):
         """Create a branch of this format in a_bzrdir."""
         if target_branch is None:
@@ -1387,9 +1208,7 @@
         branch_transport.put_bytes('location',
             target_branch.bzrdir.root_transport.base)
         branch_transport.put_bytes('format', self.get_format_string())
-        return self.open(
-            a_bzrdir, _found=True,
-            possible_transports=[target_branch.bzrdir.root_transport])
+        return self.open(a_bzrdir, _found=True)
 
     def __init__(self):
         super(BranchReferenceFormat, self).__init__()
@@ -1405,8 +1224,7 @@
             # emit some sort of warning/error to the caller ?!
         return clone
 
-    def open(self, a_bzrdir, _found=False, location=None,
-             possible_transports=None):
+    def open(self, a_bzrdir, _found=False, location=None):
         """Return the branch that the branch reference in a_bzrdir points at.
 
         _found is a private parameter, do not use it. It is used to indicate
@@ -1414,13 +1232,10 @@
         """
         if not _found:
             format = BranchFormat.find_format(a_bzrdir)
-            if format.__class__ != self.__class__:
-                raise AssertionError("wrong format %r found for %r" %
-                    (format, self))
+            assert format.__class__ == self.__class__
         if location is None:
             location = self.get_reference(a_bzrdir)
-        real_bzrdir = bzrdir.BzrDir.open(
-            location, possible_transports=possible_transports)
+        real_bzrdir = bzrdir.BzrDir.open(location)
         result = real_bzrdir.open_branch()
         # this changes the behaviour of result.clone to create a new reference
         # rather than a copy of the content of the branch.
@@ -1438,11 +1253,9 @@
 # and not independently creatable, so are not registered.
 __format5 = BzrBranchFormat5()
 __format6 = BzrBranchFormat6()
-__format7 = BzrBranchFormat7()
 BranchFormat.register_format(__format5)
 BranchFormat.register_format(BranchReferenceFormat())
 BranchFormat.register_format(__format6)
-BranchFormat.register_format(__format7)
 BranchFormat.set_default_format(__format6)
 _legacy_formats = [BzrBranchFormat4(),
                    ]
@@ -1453,32 +1266,26 @@
     Note that it's "local" in the context of the filesystem; it doesn't
     really matter if it's on an nfs/smb/afs/coda/... share, as long as
     it's writable, and can be accessed via the normal filesystem API.
-
-    :ivar _transport: Transport for file operations on this branch's 
-        control files, typically pointing to the .bzr/branch directory.
-    :ivar repository: Repository for this branch.
-    :ivar base: The url of the base directory for this branch; the one 
-        containing the .bzr directory.
     """
     
     def __init__(self, _format=None,
                  _control_files=None, a_bzrdir=None, _repository=None):
         """Create new branch object at a particular location."""
+        Branch.__init__(self)
         if a_bzrdir is None:
             raise ValueError('a_bzrdir must be supplied')
         else:
             self.bzrdir = a_bzrdir
+        # self._transport used to point to the directory containing the
+        # control directory, but was not used - now it's just the transport
+        # for the branch control files.  mbp 20070212
         self._base = self.bzrdir.transport.clone('..').base
-        # XXX: We should be able to just do
-        #   self.base = self.bzrdir.root_transport.base
-        # but this does not quite work yet -- mbp 20080522
         self._format = _format
         if _control_files is None:
             raise ValueError('BzrBranch _control_files is None')
         self.control_files = _control_files
         self._transport = _control_files._transport
         self.repository = _repository
-        Branch.__init__(self)
 
     def __str__(self):
         return '%s(%r)' % (self.__class__.__name__, self.base)
@@ -1491,6 +1298,18 @@
 
     base = property(_get_base, doc="The URL for the root of this branch.")
 
+    def abspath(self, name):
+        """See Branch.abspath."""
+        return self.control_files._transport.abspath(name)
+
+
+    @deprecated_method(zero_sixteen)
+    @needs_read_lock
+    def get_root_id(self):
+        """See Branch.get_root_id."""
+        tree = self.repository.revision_tree(self.last_revision())
+        return tree.inventory.root.file_id
+
     def is_locked(self):
         return self.control_files.is_locked()
 
@@ -1540,65 +1359,20 @@
 
         This performs the actual writing to disk.
         It is intended to be called by BzrBranch5.set_revision_history."""
-        self._transport.put_bytes(
-            'revision-history', '\n'.join(history),
-            mode=self.bzrdir._get_file_mode())
+        self.control_files.put_bytes(
+            'revision-history', '\n'.join(history))
 
     @needs_write_lock
     def set_revision_history(self, rev_history):
         """See Branch.set_revision_history."""
         if 'evil' in debug.debug_flags:
             mutter_callsite(3, "set_revision_history scales with history.")
-        check_not_reserved_id = _mod_revision.check_not_reserved_id
-        for rev_id in rev_history:
-            check_not_reserved_id(rev_id)
-        if Branch.hooks['post_change_branch_tip']:
-            # Don't calculate the last_revision_info() if there are no hooks
-            # that will use it.
-            old_revno, old_revid = self.last_revision_info()
-        if len(rev_history) == 0:
-            revid = _mod_revision.NULL_REVISION
-        else:
-            revid = rev_history[-1]
-        self._run_pre_change_branch_tip_hooks(len(rev_history), revid)
+        self._clear_cached_state()
         self._write_revision_history(rev_history)
-        self._clear_cached_state()
         self._cache_revision_history(rev_history)
         for hook in Branch.hooks['set_rh']:
             hook(self, rev_history)
-        if Branch.hooks['post_change_branch_tip']:
-            self._run_post_change_branch_tip_hooks(old_revno, old_revid)
 
-    def _run_pre_change_branch_tip_hooks(self, new_revno, new_revid):
-        """Run the pre_change_branch_tip hooks."""
-        hooks = Branch.hooks['pre_change_branch_tip']
-        if not hooks:
-            return
-        old_revno, old_revid = self.last_revision_info()
-        params = ChangeBranchTipParams(
-            self, old_revno, new_revno, old_revid, new_revid)
-        for hook in hooks:
-            try:
-                hook(params)
-            except errors.TipChangeRejected:
-                raise
-            except Exception:
-                exc_info = sys.exc_info()
-                hook_name = Branch.hooks.get_hook_name(hook)
-                raise errors.HookFailed(
-                    'pre_change_branch_tip', hook_name, exc_info)
- 
-    def _run_post_change_branch_tip_hooks(self, old_revno, old_revid):
-        """Run the post_change_branch_tip hooks."""
-        hooks = Branch.hooks['post_change_branch_tip']
-        if not hooks:
-            return
-        new_revno, new_revid = self.last_revision_info()
-        params = ChangeBranchTipParams(
-            self, old_revno, new_revno, old_revid, new_revid)
-        for hook in hooks:
-            hook(params)
- 
     @needs_write_lock
     def set_last_revision_info(self, revno, revision_id):
         """Set the last revision of this branch.
@@ -1611,17 +1385,12 @@
         configured to check constraints on history, in which case this may not
         be permitted.
         """
-        revision_id = _mod_revision.ensure_null(revision_id)
-        # this old format stores the full history, but this api doesn't
-        # provide it, so we must generate, and might as well check it's
-        # correct
         history = self._lefthand_history(revision_id)
-        if len(history) != revno:
-            raise AssertionError('%d != %d' % (len(history), revno))
+        assert len(history) == revno, '%d != %d' % (len(history), revno)
         self.set_revision_history(history)
 
     def _gen_revision_history(self):
-        history = self._transport.get_bytes('revision-history').split('\n')
+        history = self.control_files.get('revision-history').read().split('\n')
         if history[-1:] == ['']:
             # There shouldn't be a trailing newline, but just in case.
             history.pop()
@@ -1632,25 +1401,21 @@
         if 'evil' in debug.debug_flags:
             mutter_callsite(4, "_lefthand_history scales with history.")
         # stop_revision must be a descendant of last_revision
-        graph = self.repository.get_graph()
-        if last_rev is not None:
-            if not graph.is_ancestor(last_rev, revision_id):
-                # our previous tip is not merged into stop_revision
-                raise errors.DivergedBranches(self, other_branch)
+        stop_graph = self.repository.get_revision_graph(revision_id)
+        if (last_rev is not None and last_rev != _mod_revision.NULL_REVISION
+            and last_rev not in stop_graph):
+            # our previous tip is not merged into stop_revision
+            raise errors.DivergedBranches(self, other_branch)
         # make a new revision history from the graph
-        parents_map = graph.get_parent_map([revision_id])
-        if revision_id not in parents_map:
-            raise errors.NoSuchRevision(self, revision_id)
         current_rev_id = revision_id
         new_history = []
-        check_not_reserved_id = _mod_revision.check_not_reserved_id
-        # Do not include ghosts or graph origin in revision_history
-        while (current_rev_id in parents_map and
-               len(parents_map[current_rev_id]) > 0):
-            check_not_reserved_id(current_rev_id)
+        while current_rev_id not in (None, _mod_revision.NULL_REVISION):
             new_history.append(current_rev_id)
-            current_rev_id = parents_map[current_rev_id][0]
-            parents_map = graph.get_parent_map([current_rev_id])
+            current_rev_id_parents = stop_graph[current_rev_id]
+            try:
+                current_rev_id = current_rev_id_parents[0]
+            except IndexError:
+                current_rev_id = None
         new_history.reverse()
         return new_history
 
@@ -1668,45 +1433,69 @@
         self.set_revision_history(self._lefthand_history(revision_id,
             last_rev, other_branch))
 
+    @needs_write_lock
+    def update_revisions(self, other, stop_revision=None):
+        """See Branch.update_revisions."""
+        other.lock_read()
+        try:
+            if stop_revision is None:
+                stop_revision = other.last_revision()
+                if stop_revision is None:
+                    # if there are no commits, we're done.
+                    return
+            # whats the current last revision, before we fetch [and change it
+            # possibly]
+            last_rev = _mod_revision.ensure_null(self.last_revision())
+            # we fetch here so that we don't process data twice in the common
+            # case of having something to pull, and so that the check for 
+            # already merged can operate on the just fetched graph, which will
+            # be cached in memory.
+            self.fetch(other, stop_revision)
+            if self.repository.get_graph().is_ancestor(stop_revision,
+                                                       last_rev):
+                return
+            self.generate_revision_history(stop_revision, last_rev=last_rev,
+                other_branch=other)
+        finally:
+            other.unlock()
+
     def basis_tree(self):
         """See Branch.basis_tree."""
         return self.repository.revision_tree(self.last_revision())
 
     @needs_write_lock
     def pull(self, source, overwrite=False, stop_revision=None,
-             _hook_master=None, run_hooks=True, possible_transports=None,
-             _override_hook_target=None):
+             _hook_master=None, run_hooks=True, possible_transports=None):
         """See Branch.pull.
 
         :param _hook_master: Private parameter - set the branch to 
-            be supplied as the master to pull hooks.
+            be supplied as the master to push hooks.
         :param run_hooks: Private parameter - if false, this branch
             is being called because it's the master of the primary branch,
             so it should not run its hooks.
-        :param _override_hook_target: Private parameter - set the branch to be
-            supplied as the target_branch to pull hooks.
         """
         result = PullResult()
         result.source_branch = source
-        if _override_hook_target is None:
-            result.target_branch = self
-        else:
-            result.target_branch = _override_hook_target
+        result.target_branch = self
         source.lock_read()
         try:
-            # We assume that during 'pull' the local repository is closer than
-            # the remote one.
-            graph = self.repository.get_graph(source.repository)
             result.old_revno, result.old_revid = self.last_revision_info()
-            self.update_revisions(source, stop_revision, overwrite=overwrite,
-                                  graph=graph)
+            try:
+                self.update_revisions(source, stop_revision)
+            except DivergedBranches:
+                if not overwrite:
+                    raise
+            if overwrite:
+                if stop_revision is None:
+                    stop_revision = source.last_revision()
+                self.generate_revision_history(stop_revision)
             result.tag_conflicts = source.tags.merge_to(self.tags, overwrite)
             result.new_revno, result.new_revid = self.last_revision_info()
             if _hook_master:
                 result.master_branch = _hook_master
-                result.local_branch = result.target_branch
+                result.local_branch = self
             else:
-                result.master_branch = result.target_branch
+                result.master_branch = self
                 result.local_branch = None
             if run_hooks:
                 for hook in Branch.hooks['post_pull']:
@@ -1719,8 +1508,8 @@
         _locs = ['parent', 'pull', 'x-pull']
         for l in _locs:
             try:
-                return self._transport.get_bytes(l).strip('\n')
-            except errors.NoSuchFile:
+                return self.control_files.get(l).read().strip('\n')
+            except NoSuchFile:
                 pass
         return None
 
@@ -1802,18 +1591,21 @@
         result.source_branch = self
         result.target_branch = target
         result.old_revno, result.old_revid = target.last_revision_info()
-
-        # We assume that during 'push' this repository is closer than
-        # the target.
-        graph = self.repository.get_graph(target.repository)
-        target.update_revisions(self, stop_revision, overwrite=overwrite,
-                                graph=graph)
+        try:
+            target.update_revisions(self, stop_revision)
+        except DivergedBranches:
+            if not overwrite:
+                raise
+        if overwrite:
+            target.set_revision_history(self.revision_history())
         result.tag_conflicts = self.tags.merge_to(target.tags, overwrite)
         result.new_revno, result.new_revid = target.last_revision_info()
         return result
 
     def get_parent(self):
         """See Branch.get_parent."""
+
+        assert self.base[-1] == '/'
         parent = self._get_parent_location()
         if parent is None:
             return parent
@@ -1826,9 +1618,6 @@
         except errors.InvalidURLJoin, e:
             raise errors.InaccessibleParent(parent, self.base)
 
-    def get_stacked_on_url(self):
-        raise errors.UnstackableBranchFormat(self._format, self.base)
-
     def set_push_location(self, location):
         """See Branch.set_push_location."""
         self.get_config().set_user_option(
@@ -1841,10 +1630,11 @@
         # TODO: Maybe delete old location files?
         # URLs should never be unicode, even on the local fs,
         # FIXUP this and get_parent in a future branch format bump:
-        # read and rewrite the file. RBC 20060125
+        # read and rewrite the file, and have the new format code read
+        # using .get not .get_utf8. RBC 20060125
         if url is not None:
             if isinstance(url, unicode):
-                try:
+                try: 
                     url = url.encode('ascii')
                 except UnicodeEncodeError:
                     raise errors.InvalidURL(url,
@@ -1855,13 +1645,10 @@
 
     def _set_parent_location(self, url):
         if url is None:
-            self._transport.delete('parent')
+            self.control_files._transport.delete('parent')
         else:
-            self._transport.put_bytes('parent', url + '\n',
-                mode=self.bzrdir._get_file_mode())
-
-    def set_stacked_on_url(self, url):
-        raise errors.UnstackableBranchFormat(self._format, self.base)
+            assert isinstance(url, str)
+            self.control_files.put_bytes('parent', url + '\n')
 
 
 class BzrBranch5(BzrBranch):
@@ -1870,10 +1657,19 @@
     It has support for a master_branch which is the data for bound branches.
     """
 
+    def __init__(self,
+                 _format,
+                 _control_files,
+                 a_bzrdir,
+                 _repository):
+        super(BzrBranch5, self).__init__(_format=_format,
+                                         _control_files=_control_files,
+                                         a_bzrdir=a_bzrdir,
+                                         _repository=_repository)
+        
     @needs_write_lock
     def pull(self, source, overwrite=False, stop_revision=None,
-             run_hooks=True, possible_transports=None,
-             _override_hook_target=None):
+             run_hooks=True, possible_transports=None):
         """Pull from source into self, updating my master if any.
         
         :param run_hooks: Private parameter - if false, this branch
@@ -1893,15 +1689,14 @@
                     run_hooks=False)
             return super(BzrBranch5, self).pull(source, overwrite,
                 stop_revision, _hook_master=master_branch,
-                run_hooks=run_hooks,
-                _override_hook_target=_override_hook_target)
+                run_hooks=run_hooks)
         finally:
             if master_branch:
                 master_branch.unlock()
 
     def get_bound_location(self):
         try:
-            return self._transport.get_bytes('bound')[:-1]
+            return self.control_files.get_utf8('bound').read()[:-1]
         except errors.NoSuchFile:
             return None
 
@@ -1933,12 +1728,11 @@
         :param location: URL to the target branch
         """
         if location:
-            self._transport.put_bytes('bound', location+'\n',
-                mode=self.bzrdir._get_file_mode())
+            self.control_files.put_utf8('bound', location+'\n')
         else:
             try:
-                self._transport.delete('bound')
-            except errors.NoSuchFile:
+                self.control_files._transport.delete('bound')
+            except NoSuchFile:
                 return False
             return True
 
@@ -1966,6 +1760,22 @@
         # last_rev is not in the other_last_rev history, AND
         # other_last_rev is not in our history, and do it without pulling
         # history around
+        last_rev = _mod_revision.ensure_null(self.last_revision())
+        if last_rev != _mod_revision.NULL_REVISION:
+            other.lock_read()
+            try:
+                other_last_rev = other.last_revision()
+                if not _mod_revision.is_null(other_last_rev):
+                    # neither branch is new, we have to do some work to
+                    # ascertain diversion.
+                    remote_graph = other.repository.get_revision_graph(
+                        other_last_rev)
+                    local_graph = self.repository.get_revision_graph(last_rev)
+                    if (last_rev not in remote_graph and
+                        other_last_rev not in local_graph):
+                        raise errors.DivergedBranches(self, other)
+            finally:
+                other.unlock()
         self.set_bound_location(other.base)
 
     @needs_write_lock
@@ -1991,50 +1801,122 @@
         return None
 
 
-class BzrBranch7(BzrBranch5):
-    """A branch with support for a fallback repository."""
-
-    def _get_fallback_repository(self, url):
-        """Get the repository we fallback to at url."""
-        url = urlutils.join(self.base, url)
-        return bzrdir.BzrDir.open(url).open_branch().repository
-
-    def _activate_fallback_location(self, url):
-        """Activate the branch/repository from url as a fallback repository."""
-        self.repository.add_fallback_repository(
-            self._get_fallback_repository(url))
-
-    def _open_hook(self):
+class BzrBranchExperimental(BzrBranch5):
+    """Bzr experimental branch format
+
+    This format has:
+     - a revision-history file.
+     - a format string
+     - a lock dir guarding the branch itself
+     - all of this stored in a branch/ subdirectory
+     - works with shared repositories.
+     - a tag dictionary in the branch
+
+    This format is new in bzr 0.15, but shouldn't be used for real data, 
+    only for testing.
+
+    This class acts as it's own BranchFormat.
+    """
+
+    _matchingbzrdir = bzrdir.BzrDirMetaFormat1()
+
+    @classmethod
+    def get_format_string(cls):
+        """See BranchFormat.get_format_string()."""
+        return "Bazaar-NG branch format experimental\n"
+
+    @classmethod
+    def get_format_description(cls):
+        """See BranchFormat.get_format_description()."""
+        return "Experimental branch format"
+
+    @classmethod
+    def get_reference(cls, a_bzrdir):
+        """Get the target reference of the branch in a_bzrdir.
+
+        format probing must have been completed before calling
+        this method - it is assumed that the format of the branch
+        in a_bzrdir is correct.
+
+        :param a_bzrdir: The bzrdir to get the branch data from.
+        :return: None if the branch is not a reference branch.
+        """
+        return None
+
+    @classmethod
+    def _initialize_control_files(cls, a_bzrdir, utf8_files, lock_filename,
+            lock_class):
+        branch_transport = a_bzrdir.get_branch_transport(cls)
+        control_files = lockable_files.LockableFiles(branch_transport,
+            lock_filename, lock_class)
+        control_files.create_lock()
+        control_files.lock_write()
         try:
-            url = self.get_stacked_on_url()
-        except (errors.UnstackableRepositoryFormat, errors.NotStacked,
-            errors.UnstackableBranchFormat):
-            pass
-        else:
-            self._activate_fallback_location(url)
-
-    def _check_stackable_repo(self):
-        if not self.repository._format.supports_external_lookups:
-            raise errors.UnstackableRepositoryFormat(self.repository._format,
-                self.repository.base)
-
-    def __init__(self, *args, **kwargs):
-        super(BzrBranch7, self).__init__(*args, **kwargs)
-        self._last_revision_info_cache = None
-        self._partial_revision_history_cache = []
-
-    def _clear_cached_state(self):
-        super(BzrBranch7, self)._clear_cached_state()
-        self._last_revision_info_cache = None
-        self._partial_revision_history_cache = []
-
-    def _last_revision_info(self):
-        revision_string = self._transport.get_bytes('last-revision')
+            for filename, content in utf8_files:
+                control_files.put_utf8(filename, content)
+        finally:
+            control_files.unlock()
+        
+    @classmethod
+    def initialize(cls, a_bzrdir):
+        """Create a branch of this format in a_bzrdir."""
+        utf8_files = [('format', cls.get_format_string()),
+                      ('revision-history', ''),
+                      ('branch-name', ''),
+                      ('tags', ''),
+                      ]
+        cls._initialize_control_files(a_bzrdir, utf8_files,
+            'lock', lockdir.LockDir)
+        return cls.open(a_bzrdir, _found=True)
+
+    @classmethod
+    def open(cls, a_bzrdir, _found=False):
+        """Return the branch object for a_bzrdir
+
+        _found is a private parameter, do not use it. It is used to indicate
+               if format probing has already be done.
+        """
+        if not _found:
+            format = BranchFormat.find_format(a_bzrdir)
+            assert format.__class__ == cls
+        transport = a_bzrdir.get_branch_transport(None)
+        control_files = lockable_files.LockableFiles(transport, 'lock',
+                                                     lockdir.LockDir)
+        return cls(_format=cls,
+            _control_files=control_files,
+            a_bzrdir=a_bzrdir,
+            _repository=a_bzrdir.find_repository())
+
+    @classmethod
+    def is_supported(cls):
+        return True
+
+    def _make_tags(self):
+        return BasicTags(self)
+
+    @classmethod
+    def supports_tags(cls):
+        return True
+
+
+BranchFormat.register_format(BzrBranchExperimental)
+
+
+class BzrBranch6(BzrBranch5):
+
+    @needs_read_lock
+    def last_revision_info(self):
+        revision_string = self.control_files.get('last-revision').read()
         revno, revision_id = revision_string.rstrip('\n').split(' ', 1)
         revision_id = cache_utf8.get_cached_utf8(revision_id)
         revno = int(revno)
         return revno, revision_id
 
+    def last_revision(self):
+        """Return last revision id, or None"""
+        revision_id = self.last_revision_info()[1]
+        return revision_id
+
     def _write_last_revision_info(self, revno, revision_id):
         """Simply write out the revision id, with no checks.
 
@@ -2044,22 +1926,17 @@
         Intended to be called by set_last_revision_info and
         _write_revision_history.
         """
-        revision_id = _mod_revision.ensure_null(revision_id)
+        if revision_id is None:
+            revision_id = 'null:'
         out_string = '%d %s\n' % (revno, revision_id)
-        self._transport.put_bytes('last-revision', out_string,
-            mode=self.bzrdir._get_file_mode())
+        self.control_files.put_bytes('last-revision', out_string)
 
     @needs_write_lock
     def set_last_revision_info(self, revno, revision_id):
-        revision_id = _mod_revision.ensure_null(revision_id)
-        old_revno, old_revid = self.last_revision_info()
         if self._get_append_revisions_only():
             self._check_history_violation(revision_id)
-        self._run_pre_change_branch_tip_hooks(revno, revision_id)
         self._write_last_revision_info(revno, revision_id)
         self._clear_cached_state()
-        self._last_revision_info_cache = revno, revision_id
-        self._run_post_change_branch_tip_hooks(old_revno, old_revid)
 
     def _check_history_violation(self, revision_id):
         last_revision = _mod_revision.ensure_null(self.last_revision())
@@ -2071,38 +1948,10 @@
     def _gen_revision_history(self):
         """Generate the revision history from last revision
         """
-        last_revno, last_revision = self.last_revision_info()
-        self._extend_partial_history(stop_index=last_revno-1)
-        return list(reversed(self._partial_revision_history_cache))
-
-    def _extend_partial_history(self, stop_index=None, stop_revision=None):
-        """Extend the partial history to include a given index
-
-        If a stop_index is supplied, stop when that index has been reached.
-        If a stop_revision is supplied, stop when that revision is
-        encountered.  Otherwise, stop when the beginning of history is
-        reached.
-
-        :param stop_index: The index which should be present.  When it is
-            present, history extension will stop.
-        :param revision_id: The revision id which should be present.  When
-            it is encountered, history extension will stop.
-        """
-        repo = self.repository
-        if len(self._partial_revision_history_cache) == 0:
-            iterator = repo.iter_reverse_revision_history(self.last_revision())
-        else:
-            start_revision = self._partial_revision_history_cache[-1]
-            iterator = repo.iter_reverse_revision_history(start_revision)
-            #skip the last revision in the list
-            next_revision = iterator.next()
-        for revision_id in iterator:
-            self._partial_revision_history_cache.append(revision_id)
-            if (stop_index is not None and
-                len(self._partial_revision_history_cache) > stop_index):
-                break
-            if revision_id == stop_revision:
-                break
+        history = list(self.repository.iter_reverse_revision_history(
+            self.last_revision()))
+        history.reverse()
+        return history
 
     def _write_revision_history(self, history):
         """Factored out of set_revision_history.
@@ -2168,13 +2017,6 @@
         """See Branch.get_old_bound_location"""
         return self._get_bound_location(False)
 
-    def get_stacked_on_url(self):
-        self._check_stackable_repo()
-        stacked_url = self._get_config_location('stacked_on_location')
-        if stacked_url is None:
-            raise errors.NotStacked(self)
-        return stacked_url
-
     def set_append_revisions_only(self, enabled):
         if enabled:
             value = 'True'
@@ -2183,32 +2025,6 @@
         self.get_config().set_user_option('append_revisions_only', value,
             warn_masked=True)
 
-    def set_stacked_on_url(self, url):
-        self._check_stackable_repo()
-        if not url:
-            try:
-                old_url = self.get_stacked_on_url()
-            except (errors.NotStacked, errors.UnstackableBranchFormat,
-                errors.UnstackableRepositoryFormat):
-                return
-            url = ''
-            # repositories don't offer an interface to remove fallback
-            # repositories today; take the conceptually simpler option and just
-            # reopen it.
-            self.repository = self.bzrdir.find_repository()
-            # for every revision reference the branch has, ensure it is pulled
-            # in.
-            source_repository = self._get_fallback_repository(old_url)
-            for revision_id in chain([self.last_revision()],
-                self.tags.get_reverse_tag_dict()):
-                self.repository.fetch(source_repository, revision_id,
-                    find_ghosts=True)
-        else:
-            self._activate_fallback_location(url)
-        # write this out after the repository is stacked to avoid setting a
-        # stacked config that doesn't work.
-        self._set_config_location('stacked_on_location', url)
-
     def _get_append_revisions_only(self):
         value = self.get_config().get_user_option('append_revisions_only')
         return value == 'True'
@@ -2245,63 +2061,6 @@
     def _make_tags(self):
         return BasicTags(self)
 
-    @needs_write_lock
-    def generate_revision_history(self, revision_id, last_rev=None,
-                                  other_branch=None):
-        """See BzrBranch5.generate_revision_history"""
-        history = self._lefthand_history(revision_id, last_rev, other_branch)
-        revno = len(history)
-        self.set_last_revision_info(revno, revision_id)
-
-    @needs_read_lock
-    def get_rev_id(self, revno, history=None):
-        """Find the revision id of the specified revno."""
-        if revno == 0:
-            return _mod_revision.NULL_REVISION
-
-        last_revno, last_revision_id = self.last_revision_info()
-        if revno <= 0 or revno > last_revno:
-            raise errors.NoSuchRevision(self, revno)
-
-        if history is not None:
-            return history[revno - 1]
-
-        index = last_revno - revno
-        if len(self._partial_revision_history_cache) <= index:
-            self._extend_partial_history(stop_index=index)
-        if len(self._partial_revision_history_cache) > index:
-            return self._partial_revision_history_cache[index]
-        else:
-            raise errors.NoSuchRevision(self, revno)
-
-    @needs_read_lock
-    def revision_id_to_revno(self, revision_id):
-        """Given a revision id, return its revno"""
-        if _mod_revision.is_null(revision_id):
-            return 0
-        try:
-            index = self._partial_revision_history_cache.index(revision_id)
-        except ValueError:
-            self._extend_partial_history(stop_revision=revision_id)
-            index = len(self._partial_revision_history_cache) - 1
-            if self._partial_revision_history_cache[index] != revision_id:
-                raise errors.NoSuchRevision(self, revision_id)
-        return self.revno() - index
-
-
-class BzrBranch6(BzrBranch7):
-    """See BzrBranchFormat6 for the capabilities of this branch.
-
-    This subclass of BzrBranch7 disables the new features BzrBranch7 added,
-    i.e. stacking.
-    """
-
-    def get_stacked_on_url(self):
-        raise errors.UnstackableBranchFormat(self._format, self.base)
-
-    def set_stacked_on_url(self, url):
-        raise errors.UnstackableBranchFormat(self._format, self.base)
-
 
 ######################################################################
 # results of operations
@@ -2325,11 +2084,8 @@
     :ivar old_revid: Tip revision id before pull.
     :ivar new_revid: Tip revision id after pull.
     :ivar source_branch: Source (local) branch object.
-    :ivar master_branch: Master branch of the target, or the target if no
-        Master
-    :ivar local_branch: target branch if there is a Master, else None
+    :ivar master_branch: Master branch of the target, or None.
     :ivar target_branch: Target/destination branch object.
-    :ivar tag_conflicts: A list of tag conflicts, see BasicTags.merge_to
     """
 
     def __int__(self):
@@ -2337,11 +2093,10 @@
         return self.new_revno - self.old_revno
 
     def report(self, to_file):
-        if not is_quiet():
-            if self.old_revid == self.new_revid:
-                to_file.write('No revisions to pull.\n')
-            else:
-                to_file.write('Now on revision %d.\n' % self.new_revno)
+        if self.old_revid == self.new_revid:
+            to_file.write('No revisions to pull.\n')
+        else:
+            to_file.write('Now on revision %d.\n' % self.new_revno)
         self._show_tag_conficts(to_file)
 
 
@@ -2399,7 +2154,7 @@
         new_branch = format.open(branch.bzrdir, _found=True)
 
         # Copy source data into target
-        new_branch._write_last_revision_info(*branch.last_revision_info())
+        new_branch.set_last_revision_info(*branch.last_revision_info())
         new_branch.set_parent(branch.get_parent())
         new_branch.set_bound_location(branch.get_bound_location())
         new_branch.set_push_location(branch.get_push_location())
@@ -2408,24 +2163,13 @@
         new_branch.tags._set_tag_dict({})
 
         # Copying done; now update target format
-        new_branch._transport.put_bytes('format',
-            format.get_format_string(),
-            mode=new_branch.bzrdir._get_file_mode())
+        new_branch.control_files.put_utf8('format',
+            format.get_format_string())
 
         # Clean up old files
-        new_branch._transport.delete('revision-history')
+        new_branch.control_files._transport.delete('revision-history')
         try:
             branch.set_parent(None)
-        except errors.NoSuchFile:
+        except NoSuchFile:
             pass
         branch.set_bound_location(None)
-
-
-class Converter6to7(object):
-    """Perform an in-place upgrade of format 6 to format 7"""
-
-    def convert(self, branch):
-        format = BzrBranchFormat7()
-        branch._set_config_location('stacked_on_location', '')
-        # update target format
-        branch._transport.put_bytes('format', format.get_format_string())

=== modified file 'bzrlib/branchbuilder.py'
--- bzrlib/branchbuilder.py	2008-07-29 16:16:36 +0000
+++ bzrlib/branchbuilder.py	2007-04-27 06:16:29 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007, 2008 Canonical Ltd
+# Copyright (C) 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -26,24 +26,12 @@
     BranchBuilder on the transport you want your branch on, and then call
     appropriate build_ methods on it to get the shape of history you want.
 
-    This is meant as a helper for the test suite, not as a general class for
-    real data.
-
     For instance:
       builder = BranchBuilder(self.get_transport().clone('relpath'))
-      builder.start_series()
-      builder.build_snapshot('rev-id', [],
-        [('add', ('filename', 'f-id', 'file', 'content\n'))])
-      builder.build_snapshot('rev2-id', ['rev-id'],
-        [('modify', ('f-id', 'new-content\n'))])
-      builder.finish_series()
+      builder.build_commit()
+      builder.build_commit()
+      builder.build_commit()
       branch = builder.get_branch()
-
-    :ivar _tree: This is a private member which is not meant to be modified by
-        users of this class. While a 'series' is in progress, it should hold a
-        MemoryTree with the contents of the last commit (ready to be modified
-        by the next build_snapshot command) with a held write lock. Outside of
-        a series in progress, it should be None.
     """
 
     def __init__(self, transport, format=None):
@@ -52,18 +40,15 @@
         :param transport: The transport the branch should be created on.
             If the path of the transport does not exist but its parent does
             it will be created.
-        :param format: Either a BzrDirFormat, or the name of a format in the
-            bzrdir format registry for the branch to be built.
+        :param format: The name of a format in the bzrdir format registry
+            for the branch to be built.
         """
         if not transport.has('.'):
             transport.mkdir('.')
         if format is None:
             format = 'default'
-        if isinstance(format, str):
-            format = bzrdir.format_registry.make_bzrdir(format)
         self._branch = bzrdir.BzrDir.create_branch_convenience(transport.base,
-            format=format, force_new_tree=False)
-        self._tree = None
+            format=bzrdir.format_registry.make_bzrdir(format))
 
     def build_commit(self):
         """Build a commit on the branch."""
@@ -75,128 +60,6 @@
         finally:
             tree.unlock()
 
-    def _move_branch_pointer(self, new_revision_id):
-        """Point self._branch to a different revision id."""
-        self._branch.lock_write()
-        try:
-            # We don't seem to have a simple set_last_revision(), so we
-            # implement it here.
-            cur_revno, cur_revision_id = self._branch.last_revision_info()
-            g = self._branch.repository.get_graph()
-            new_revno = g.find_distance_to_null(new_revision_id,
-                                                [(cur_revision_id, cur_revno)])
-            self._branch.set_last_revision_info(new_revno, new_revision_id)
-        finally:
-            self._branch.unlock()
-        if self._tree is not None:
-            # We are currently processing a series, but when switching branch
-            # pointers, it is easiest to just create a new memory tree.
-            # That way we are sure to have the right files-on-disk
-            # We are cheating a little bit here, and locking the new tree
-            # before the old tree is unlocked. But that way the branch stays
-            # locked throughout.
-            new_tree = memorytree.MemoryTree.create_on_branch(self._branch)
-            new_tree.lock_write()
-            self._tree.unlock()
-            self._tree = new_tree
-
-    def start_series(self):
-        """We will be creating a series of commits.
-
-        This allows us to hold open the locks while we are processing.
-
-        Make sure to call 'finish_series' when you are done.
-        """
-        if self._tree is not None:
-            raise AssertionError('You cannot start a new series while a'
-                                 ' series is already going.')
-        self._tree = memorytree.MemoryTree.create_on_branch(self._branch)
-        self._tree.lock_write()
-
-    def finish_series(self):
-        """Call this after start_series to unlock the various objects."""
-        self._tree.unlock()
-        self._tree = None
-
-    def build_snapshot(self, revision_id, parent_ids, actions,
-                       message=None):
-        """Build a commit, shaped in a specific way.
-
-        :param revision_id: The handle for the new commit, can be None
-        :param parent_ids: A list of parent_ids to use for the commit.
-            It can be None, which indicates to use the last commit.
-        :param actions: A list of actions to perform. Supported actions are:
-            ('add', ('path', 'file-id', 'kind', 'content' or None))
-            ('modify', ('file-id', 'new-content'))
-            ('unversion', 'file-id')
-            # not supported yet: ('rename', ('orig-path', 'new-path'))
-        :param message: An optional commit message, if not supplied, a default
-            commit message will be written.
-        :return: The revision_id of the new commit
-        """
-        if parent_ids is not None:
-            base_id = parent_ids[0]
-            if base_id != self._branch.last_revision():
-                self._move_branch_pointer(base_id)
-
-        if self._tree is not None:
-            tree = self._tree
-        else:
-            tree = memorytree.MemoryTree.create_on_branch(self._branch)
-        tree.lock_write()
-        try:
-            if parent_ids is not None:
-                tree.set_parent_ids(parent_ids)
-            # Unfortunately, MemoryTree.add(directory) just creates an
-            # inventory entry. And the only public function to create a
-            # directory is MemoryTree.mkdir() which creates the directory, but
-            # also always adds it. So we have to use a multi-pass setup.
-            to_add_directories = []
-            to_add_files = []
-            to_add_file_ids = []
-            to_add_kinds = []
-            new_contents = {}
-            to_unversion_ids = []
-            # TODO: MemoryTree doesn't support rename() or
-            #       apply_inventory_delta, so we'll postpone allowing renames
-            #       for now
-            # to_rename = []
-            for action, info in actions:
-                if action == 'add':
-                    path, file_id, kind, content = info
-                    if kind == 'directory':
-                        to_add_directories.append((path, file_id))
-                    else:
-                        to_add_files.append(path)
-                        to_add_file_ids.append(file_id)
-                        to_add_kinds.append(kind)
-                        if content is not None:
-                            new_contents[file_id] = content
-                elif action == 'modify':
-                    file_id, content = info
-                    new_contents[file_id] = content
-                elif action == 'unversion':
-                    to_unversion_ids.append(info)
-                else:
-                    raise ValueError('Unknown build action: "%s"' % (action,))
-            if to_unversion_ids:
-                tree.unversion(to_unversion_ids)
-            for path, file_id in to_add_directories:
-                if path == '':
-                    # Special case, because the path already exists
-                    tree.add([path], [file_id], ['directory'])
-                else:
-                    tree.mkdir(path, file_id)
-            tree.add(to_add_files, to_add_file_ids, to_add_kinds)
-            for file_id, content in new_contents.iteritems():
-                tree.put_file_bytes_non_atomic(file_id, content)
-
-            if message is None:
-                message = u'commit %d' % (self._branch.revno() + 1,)
-            return tree.commit(message, rev_id=revision_id)
-        finally:
-            tree.unlock()
-
     def get_branch(self):
         """Return the branch created by the builder."""
         return self._branch

=== removed file 'bzrlib/btree_index.py'
--- bzrlib/btree_index.py	2008-08-28 20:19:20 +0000
+++ bzrlib/btree_index.py	1970-01-01 00:00:00 +0000
@@ -1,1138 +0,0 @@
-# Copyright (C) 2008 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-#
-
-"""B+Tree indices"""
-
-import array
-import bisect
-from bisect import bisect_right
-from copy import deepcopy
-import math
-import sha
-import struct
-import tempfile
-import zlib
-
-from bzrlib import (
-    chunk_writer,
-    debug,
-    errors,
-    index,
-    lru_cache,
-    osutils,
-    trace,
-    )
-from bzrlib.index import _OPTION_NODE_REFS, _OPTION_KEY_ELEMENTS, _OPTION_LEN
-from bzrlib.transport import get_transport
-
-
-_BTSIGNATURE = "B+Tree Graph Index 2\n"
-_OPTION_ROW_LENGTHS = "row_lengths="
-_LEAF_FLAG = "type=leaf\n"
-_INTERNAL_FLAG = "type=internal\n"
-_INTERNAL_OFFSET = "offset="
-
-_RESERVED_HEADER_BYTES = 120
-_PAGE_SIZE = 4096
-
-# 4K per page: 4MB - 1000 entries
-_NODE_CACHE_SIZE = 1000
-
-
-class _BuilderRow(object):
-    """The stored state accumulated while writing out a row in the index.
-
-    :ivar spool: A temporary file used to accumulate nodes for this row
-        in the tree.
-    :ivar nodes: The count of nodes emitted so far.
-    """
-
-    def __init__(self):
-        """Create a _BuilderRow."""
-        self.nodes = 0
-        self.spool = tempfile.TemporaryFile()
-        self.writer = None
-
-    def finish_node(self, pad=True):
-        byte_lines, _, padding = self.writer.finish()
-        if self.nodes == 0:
-            # padded note:
-            self.spool.write("\x00" * _RESERVED_HEADER_BYTES)
-        skipped_bytes = 0
-        if not pad and padding:
-            del byte_lines[-1]
-            skipped_bytes = padding
-        self.spool.writelines(byte_lines)
-        remainder = (self.spool.tell() + skipped_bytes) % _PAGE_SIZE
-        if remainder != 0:
-            raise AssertionError("incorrect node length: %d, %d"
-                                 % (self.spool.tell(), remainder))
-        self.nodes += 1
-        self.writer = None
-
-
-class _InternalBuilderRow(_BuilderRow):
-    """The stored state accumulated while writing out internal rows."""
-
-    def finish_node(self, pad=True):
-        if not pad:
-            raise AssertionError("Must pad internal nodes only.")
-        _BuilderRow.finish_node(self)
-
-
-class _LeafBuilderRow(_BuilderRow):
-    """The stored state accumulated while writing out a leaf rows."""
-
-
-class BTreeBuilder(index.GraphIndexBuilder):
-    """A Builder for B+Tree based Graph indices.
-
-    The resulting graph has the structure:
-
-    _SIGNATURE OPTIONS NODES
-    _SIGNATURE     := 'B+Tree Graph Index 1' NEWLINE
-    OPTIONS        := REF_LISTS KEY_ELEMENTS LENGTH
-    REF_LISTS      := 'node_ref_lists=' DIGITS NEWLINE
-    KEY_ELEMENTS   := 'key_elements=' DIGITS NEWLINE
-    LENGTH         := 'len=' DIGITS NEWLINE
-    ROW_LENGTHS    := 'row_lengths' DIGITS (COMMA DIGITS)*
-    NODES          := NODE_COMPRESSED*
-    NODE_COMPRESSED:= COMPRESSED_BYTES{4096}
-    NODE_RAW       := INTERNAL | LEAF
-    INTERNAL       := INTERNAL_FLAG POINTERS
-    LEAF           := LEAF_FLAG ROWS
-    KEY_ELEMENT    := Not-whitespace-utf8
-    KEY            := KEY_ELEMENT (NULL KEY_ELEMENT)*
-    ROWS           := ROW*
-    ROW            := KEY NULL ABSENT? NULL REFERENCES NULL VALUE NEWLINE
-    ABSENT         := 'a'
-    REFERENCES     := REFERENCE_LIST (TAB REFERENCE_LIST){node_ref_lists - 1}
-    REFERENCE_LIST := (REFERENCE (CR REFERENCE)*)?
-    REFERENCE      := KEY
-    VALUE          := no-newline-no-null-bytes
-    """
-
-    def __init__(self, reference_lists=0, key_elements=1, spill_at=100000):
-        """See GraphIndexBuilder.__init__.
-
-        :param spill_at: Optional parameter controlling the maximum number
-            of nodes that BTreeBuilder will hold in memory.
-        """
-        index.GraphIndexBuilder.__init__(self, reference_lists=reference_lists,
-            key_elements=key_elements)
-        self._spill_at = spill_at
-        self._backing_indices = []
-        # A map of {key: (node_refs, value)}
-        self._nodes = {}
-        # Indicate it hasn't been built yet
-        self._nodes_by_key = None
-
-    def add_node(self, key, value, references=()):
-        """Add a node to the index.
-
-        If adding the node causes the builder to reach its spill_at threshold,
-        disk spilling will be triggered.
-
-        :param key: The key. keys are non-empty tuples containing
-            as many whitespace-free utf8 bytestrings as the key length
-            defined for this index.
-        :param references: An iterable of iterables of keys. Each is a
-            reference to another key.
-        :param value: The value to associate with the key. It may be any
-            bytes as long as it does not contain \0 or \n.
-        """
-        # we don't care about absent_references
-        node_refs, _ = self._check_key_ref_value(key, references, value)
-        if key in self._nodes:
-            raise errors.BadIndexDuplicateKey(key, self)
-        self._nodes[key] = (node_refs, value)
-        self._keys.add(key)
-        if self._nodes_by_key is not None and self._key_length > 1:
-            self._update_nodes_by_key(key, value, node_refs)
-        if len(self._keys) < self._spill_at:
-            return
-        self._spill_mem_keys_to_disk()
-
-    def _spill_mem_keys_to_disk(self):
-        """Write the in memory keys down to disk to cap memory consumption.
-
-        If we already have some keys written to disk, we will combine them so
-        as to preserve the sorted order.  The algorithm for combining uses
-        powers of two.  So on the first spill, write all mem nodes into a
-        single index. On the second spill, combine the mem nodes with the nodes
-        on disk to create a 2x sized disk index and get rid of the first index.
-        On the third spill, create a single new disk index, which will contain
-        the mem nodes, and preserve the existing 2x sized index.  On the fourth,
-        combine mem with the first and second indexes, creating a new one of
-        size 4x. On the fifth create a single new one, etc.
-        """
-        iterators_to_combine = [self._iter_mem_nodes()]
-        pos = -1
-        for pos, backing in enumerate(self._backing_indices):
-            if backing is None:
-                pos -= 1
-                break
-            iterators_to_combine.append(backing.iter_all_entries())
-        backing_pos = pos + 1
-        new_backing_file, size = \
-            self._write_nodes(self._iter_smallest(iterators_to_combine))
-        dir_path, base_name = osutils.split(new_backing_file.name)
-        # Note: The transport here isn't strictly needed, because we will use
-        #       direct access to the new_backing._file object
-        new_backing = BTreeGraphIndex(get_transport(dir_path),
-                                      base_name, size)
-        # GC will clean up the file
-        new_backing._file = new_backing_file
-        if len(self._backing_indices) == backing_pos:
-            self._backing_indices.append(None)
-        self._backing_indices[backing_pos] = new_backing
-        for pos in range(backing_pos):
-            self._backing_indices[pos] = None
-        self._keys = set()
-        self._nodes = {}
-        self._nodes_by_key = None
-
-    def add_nodes(self, nodes):
-        """Add nodes to the index.
-
-        :param nodes: An iterable of (key, node_refs, value) entries to add.
-        """
-        if self.reference_lists:
-            for (key, value, node_refs) in nodes:
-                self.add_node(key, value, node_refs)
-        else:
-            for (key, value) in nodes:
-                self.add_node(key, value)
-
-    def _iter_mem_nodes(self):
-        """Iterate over the nodes held in memory."""
-        nodes = self._nodes
-        if self.reference_lists:
-            for key in sorted(nodes):
-                references, value = nodes[key]
-                yield self, key, value, references
-        else:
-            for key in sorted(nodes):
-                references, value = nodes[key]
-                yield self, key, value
-
-    def _iter_smallest(self, iterators_to_combine):
-        if len(iterators_to_combine) == 1:
-            for value in iterators_to_combine[0]:
-                yield value
-            return
-        current_values = []
-        for iterator in iterators_to_combine:
-            try:
-                current_values.append(iterator.next())
-            except StopIteration:
-                current_values.append(None)
-        last = None
-        while True:
-            # Decorate candidates with the value to allow 2.4's min to be used.
-            candidates = [(item[1][1], item) for item
-                in enumerate(current_values) if item[1] is not None]
-            if not len(candidates):
-                return
-            selected = min(candidates)
-            # undecorate back to (pos, node)
-            selected = selected[1]
-            if last == selected[1][1]:
-                raise errors.BadIndexDuplicateKey(last, self)
-            last = selected[1][1]
-            # Yield, with self as the index
-            yield (self,) + selected[1][1:]
-            pos = selected[0]
-            try:
-                current_values[pos] = iterators_to_combine[pos].next()
-            except StopIteration:
-                current_values[pos] = None
-
-    def _add_key(self, string_key, line, rows):
-        """Add a key to the current chunk.
-
-        :param string_key: The key to add.
-        :param line: The fully serialised key and value.
-        """
-        if rows[-1].writer is None:
-            # opening a new leaf chunk;
-            for pos, internal_row in enumerate(rows[:-1]):
-                # flesh out any internal nodes that are needed to
-                # preserve the height of the tree
-                if internal_row.writer is None:
-                    length = _PAGE_SIZE
-                    if internal_row.nodes == 0:
-                        length -= _RESERVED_HEADER_BYTES # padded
-                    internal_row.writer = chunk_writer.ChunkWriter(length, 0)
-                    internal_row.writer.write(_INTERNAL_FLAG)
-                    internal_row.writer.write(_INTERNAL_OFFSET +
-                        str(rows[pos + 1].nodes) + "\n")
-            # add a new leaf
-            length = _PAGE_SIZE
-            if rows[-1].nodes == 0:
-                length -= _RESERVED_HEADER_BYTES # padded
-            rows[-1].writer = chunk_writer.ChunkWriter(length)
-            rows[-1].writer.write(_LEAF_FLAG)
-        if rows[-1].writer.write(line):
-            # this key did not fit in the node:
-            rows[-1].finish_node()
-            key_line = string_key + "\n"
-            new_row = True
-            for row in reversed(rows[:-1]):
-                # Mark the start of the next node in the node above. If it
-                # doesn't fit then propogate upwards until we find one that
-                # it does fit into.
-                if row.writer.write(key_line):
-                    row.finish_node()
-                else:
-                    # We've found a node that can handle the pointer.
-                    new_row = False
-                    break
-            # If we reached the current root without being able to mark the
-            # division point, then we need a new root:
-            if new_row:
-                # We need a new row
-                if 'index' in debug.debug_flags:
-                    trace.mutter('Inserting new global row.')
-                new_row = _InternalBuilderRow()
-                reserved_bytes = 0
-                rows.insert(0, new_row)
-                # This will be padded, hence the -100
-                new_row.writer = chunk_writer.ChunkWriter(
-                    _PAGE_SIZE - _RESERVED_HEADER_BYTES,
-                    reserved_bytes)
-                new_row.writer.write(_INTERNAL_FLAG)
-                new_row.writer.write(_INTERNAL_OFFSET +
-                    str(rows[1].nodes - 1) + "\n")
-                new_row.writer.write(key_line)
-            self._add_key(string_key, line, rows)
-
-    def _write_nodes(self, node_iterator):
-        """Write node_iterator out as a B+Tree.
-
-        :param node_iterator: An iterator of sorted nodes. Each node should
-            match the output given by iter_all_entries.
-        :return: A file handle for a temporary file containing a B+Tree for
-            the nodes.
-        """
-        # The index rows - rows[0] is the root, rows[1] is the layer under it
-        # etc.
-        rows = []
-        # forward sorted by key. In future we may consider topological sorting,
-        # at the cost of table scans for direct lookup, or a second index for
-        # direct lookup
-        key_count = 0
-        # A stack with the number of nodes of each size. 0 is the root node
-        # and must always be 1 (if there are any nodes in the tree).
-        self.row_lengths = []
-        # Loop over all nodes adding them to the bottom row
-        # (rows[-1]). When we finish a chunk in a row,
-        # propogate the key that didn't fit (comes after the chunk) to the
-        # row above, transitively.
-        for node in node_iterator:
-            if key_count == 0:
-                # First key triggers the first row
-                rows.append(_LeafBuilderRow())
-            key_count += 1
-            # TODO: Flattening the node into a string key and a line should
-            #       probably be put into a pyrex function. We can do a quick
-            #       iter over all the entries to determine the final length,
-            #       and then do a single malloc() rather than lots of
-            #       intermediate mallocs as we build everything up.
-            #       ATM 3 / 13s are spent flattening nodes (10s is compressing)
-            string_key, line = _btree_serializer._flatten_node(node,
-                                    self.reference_lists)
-            self._add_key(string_key, line, rows)
-        for row in reversed(rows):
-            pad = (type(row) != _LeafBuilderRow)
-            row.finish_node(pad=pad)
-        result = tempfile.NamedTemporaryFile()
-        lines = [_BTSIGNATURE]
-        lines.append(_OPTION_NODE_REFS + str(self.reference_lists) + '\n')
-        lines.append(_OPTION_KEY_ELEMENTS + str(self._key_length) + '\n')
-        lines.append(_OPTION_LEN + str(key_count) + '\n')
-        row_lengths = [row.nodes for row in rows]
-        lines.append(_OPTION_ROW_LENGTHS + ','.join(map(str, row_lengths)) + '\n')
-        result.writelines(lines)
-        position = sum(map(len, lines))
-        root_row = True
-        if position > _RESERVED_HEADER_BYTES:
-            raise AssertionError("Could not fit the header in the"
-                                 " reserved space: %d > %d"
-                                 % (position, _RESERVED_HEADER_BYTES))
-        # write the rows out:
-        for row in rows:
-            reserved = _RESERVED_HEADER_BYTES # reserved space for first node
-            row.spool.flush()
-            row.spool.seek(0)
-            # copy nodes to the finalised file.
-            # Special case the first node as it may be prefixed
-            node = row.spool.read(_PAGE_SIZE)
-            result.write(node[reserved:])
-            result.write("\x00" * (reserved - position))
-            position = 0 # Only the root row actually has an offset
-            copied_len = osutils.pumpfile(row.spool, result)
-            if copied_len != (row.nodes - 1) * _PAGE_SIZE:
-                if type(row) != _LeafBuilderRow:
-                    raise AssertionError("Incorrect amount of data copied"
-                        " expected: %d, got: %d"
-                        % ((row.nodes - 1) * _PAGE_SIZE,
-                           copied_len))
-        result.flush()
-        size = result.tell()
-        result.seek(0)
-        return result, size
-
-    def finish(self):
-        """Finalise the index.
-
-        :return: A file handle for a temporary file containing the nodes added
-            to the index.
-        """
-        return self._write_nodes(self.iter_all_entries())[0]
-
-    def iter_all_entries(self):
-        """Iterate over all keys within the index
-
-        :return: An iterable of (index, key, reference_lists, value). There is no
-            defined order for the result iteration - it will be in the most
-            efficient order for the index (in this case dictionary hash order).
-        """
-        if 'evil' in debug.debug_flags:
-            trace.mutter_callsite(3,
-                "iter_all_entries scales with size of history.")
-        # Doing serial rather than ordered would be faster; but this shouldn't
-        # be getting called routinely anyway.
-        iterators = [self._iter_mem_nodes()]
-        for backing in self._backing_indices:
-            if backing is not None:
-                iterators.append(backing.iter_all_entries())
-        if len(iterators) == 1:
-            return iterators[0]
-        return self._iter_smallest(iterators)
-
-    def iter_entries(self, keys):
-        """Iterate over keys within the index.
-
-        :param keys: An iterable providing the keys to be retrieved.
-        :return: An iterable of (index, key, value, reference_lists). There is no
-            defined order for the result iteration - it will be in the most
-            efficient order for the index (keys iteration order in this case).
-        """
-        keys = set(keys)
-        if self.reference_lists:
-            for key in keys.intersection(self._keys):
-                node = self._nodes[key]
-                yield self, key, node[1], node[0]
-        else:
-            for key in keys.intersection(self._keys):
-                node = self._nodes[key]
-                yield self, key, node[1]
-        keys.difference_update(self._keys)
-        for backing in self._backing_indices:
-            if backing is None:
-                continue
-            if not keys:
-                return
-            for node in backing.iter_entries(keys):
-                keys.remove(node[1])
-                yield (self,) + node[1:]
-
-    def iter_entries_prefix(self, keys):
-        """Iterate over keys within the index using prefix matching.
-
-        Prefix matching is applied within the tuple of a key, not to within
-        the bytestring of each key element. e.g. if you have the keys ('foo',
-        'bar'), ('foobar', 'gam') and do a prefix search for ('foo', None) then
-        only the former key is returned.
-
-        :param keys: An iterable providing the key prefixes to be retrieved.
-            Each key prefix takes the form of a tuple the length of a key, but
-            with the last N elements 'None' rather than a regular bytestring.
-            The first element cannot be 'None'.
-        :return: An iterable as per iter_all_entries, but restricted to the
-            keys with a matching prefix to those supplied. No additional keys
-            will be returned, and every match that is in the index will be
-            returned.
-        """
-        # XXX: To much duplication with the GraphIndex class; consider finding
-        # a good place to pull out the actual common logic.
-        keys = set(keys)
-        if not keys:
-            return
-        for backing in self._backing_indices:
-            if backing is None:
-                continue
-            for node in backing.iter_entries_prefix(keys):
-                yield (self,) + node[1:]
-        if self._key_length == 1:
-            for key in keys:
-                # sanity check
-                if key[0] is None:
-                    raise errors.BadIndexKey(key)
-                if len(key) != self._key_length:
-                    raise errors.BadIndexKey(key)
-                try:
-                    node = self._nodes[key]
-                except KeyError:
-                    continue
-                if self.reference_lists:
-                    yield self, key, node[1], node[0]
-                else:
-                    yield self, key, node[1]
-            return
-        for key in keys:
-            # sanity check
-            if key[0] is None:
-                raise errors.BadIndexKey(key)
-            if len(key) != self._key_length:
-                raise errors.BadIndexKey(key)
-            # find what it refers to:
-            key_dict = self._get_nodes_by_key()
-            elements = list(key)
-            # find the subdict to return
-            try:
-                while len(elements) and elements[0] is not None:
-                    key_dict = key_dict[elements[0]]
-                    elements.pop(0)
-            except KeyError:
-                # a non-existant lookup.
-                continue
-            if len(elements):
-                dicts = [key_dict]
-                while dicts:
-                    key_dict = dicts.pop(-1)
-                    # can't be empty or would not exist
-                    item, value = key_dict.iteritems().next()
-                    if type(value) == dict:
-                        # push keys
-                        dicts.extend(key_dict.itervalues())
-                    else:
-                        # yield keys
-                        for value in key_dict.itervalues():
-                            yield (self, ) + value
-            else:
-                yield (self, ) + key_dict
-
-    def _get_nodes_by_key(self):
-        if self._nodes_by_key is None:
-            nodes_by_key = {}
-            if self.reference_lists:
-                for key, (references, value) in self._nodes.iteritems():
-                    key_dict = nodes_by_key
-                    for subkey in key[:-1]:
-                        key_dict = key_dict.setdefault(subkey, {})
-                    key_dict[key[-1]] = key, value, references
-            else:
-                for key, (references, value) in self._nodes.iteritems():
-                    key_dict = nodes_by_key
-                    for subkey in key[:-1]:
-                        key_dict = key_dict.setdefault(subkey, {})
-                    key_dict[key[-1]] = key, value
-            self._nodes_by_key = nodes_by_key
-        return self._nodes_by_key
-
-    def key_count(self):
-        """Return an estimate of the number of keys in this index.
-
-        For InMemoryGraphIndex the estimate is exact.
-        """
-        return len(self._keys) + sum(backing.key_count() for backing in
-            self._backing_indices if backing is not None)
-
-    def validate(self):
-        """In memory index's have no known corruption at the moment."""
-
-
-class _LeafNode(object):
-    """A leaf node for a serialised B+Tree index."""
-
-    def __init__(self, bytes, key_length, ref_list_length):
-        """Parse bytes to create a leaf node object."""
-        # splitlines mangles the \r delimiters.. don't use it.
-        self.keys = dict(_btree_serializer._parse_leaf_lines(bytes,
-            key_length, ref_list_length))
-
-
-class _InternalNode(object):
-    """An internal node for a serialised B+Tree index."""
-
-    def __init__(self, bytes):
-        """Parse bytes to create an internal node object."""
-        # splitlines mangles the \r delimiters.. don't use it.
-        self.keys = self._parse_lines(bytes.split('\n'))
-
-    def _parse_lines(self, lines):
-        nodes = []
-        self.offset = int(lines[1][7:])
-        for line in lines[2:]:
-            if line == '':
-                break
-            nodes.append(tuple(line.split('\0')))
-        return nodes
-
-
-class BTreeGraphIndex(object):
-    """Access to nodes via the standard GraphIndex interface for B+Tree's.
-
-    Individual nodes are held in a LRU cache. This holds the root node in
-    memory except when very large walks are done.
-    """
-
-    def __init__(self, transport, name, size):
-        """Create a B+Tree index object on the index name.
-
-        :param transport: The transport to read data for the index from.
-        :param name: The file name of the index on transport.
-        :param size: Optional size of the index in bytes. This allows
-            compatibility with the GraphIndex API, as well as ensuring that
-            the initial read (to read the root node header) can be done
-            without over-reading even on empty indices, and on small indices
-            allows single-IO to read the entire index.
-        """
-        self._transport = transport
-        self._name = name
-        self._size = size
-        self._file = None
-        self._page_size = transport.recommended_page_size()
-        self._root_node = None
-        # Default max size is 100,000 leave values
-        self._leaf_value_cache = None # lru_cache.LRUCache(100*1000)
-        self._leaf_node_cache = lru_cache.LRUCache(_NODE_CACHE_SIZE)
-        self._internal_node_cache = lru_cache.LRUCache()
-        self._key_count = None
-        self._row_lengths = None
-        self._row_offsets = None # Start of each row, [-1] is the end
-
-    def __eq__(self, other):
-        """Equal when self and other were created with the same parameters."""
-        return (
-            type(self) == type(other) and
-            self._transport == other._transport and
-            self._name == other._name and
-            self._size == other._size)
-
-    def __ne__(self, other):
-        return not self.__eq__(other)
-
-    def _get_root_node(self):
-        if self._root_node is None:
-            # We may not have a root node yet
-            nodes = list(self._read_nodes([0]))
-            if len(nodes):
-                self._root_node = nodes[0][1]
-        return self._root_node
-
-    def _cache_nodes(self, nodes, cache):
-        """Read nodes and cache them in the lru.
-
-        The nodes list supplied is sorted and then read from disk, each node
-        being inserted it into the _node_cache.
-
-        Note: Asking for more nodes than the _node_cache can contain will
-        result in some of the results being immediately discarded, to prevent
-        this an assertion is raised if more nodes are asked for than are
-        cachable.
-
-        :return: A dict of {node_pos: node}
-        """
-        if len(nodes) > cache._max_cache:
-            trace.mutter('Requesting %s > %s nodes, not all will be cached',
-                         len(nodes), cache._max_cache)
-        found = {}
-        for node_pos, node in self._read_nodes(sorted(nodes)):
-            if node_pos == 0: # Special case
-                self._root_node = node
-            else:
-                cache.add(node_pos, node)
-            found[node_pos] = node
-        return found
-
-    def _get_nodes(self, cache, node_indexes):
-        found = {}
-        needed = []
-        for idx in node_indexes:
-            if idx == 0 and self._root_node is not None:
-                found[0] = self._root_node
-                continue
-            try:
-                found[idx] = cache[idx]
-            except KeyError:
-                needed.append(idx)
-        found.update(self._cache_nodes(needed, cache))
-        return found
-
-    def _get_internal_nodes(self, node_indexes):
-        """Get a node, from cache or disk.
-
-        After getting it, the node will be cached.
-        """
-        return self._get_nodes(self._internal_node_cache, node_indexes)
-
-    def _get_leaf_nodes(self, node_indexes):
-        """Get a bunch of nodes, from cache or disk."""
-        found = self._get_nodes(self._leaf_node_cache, node_indexes)
-        if self._leaf_value_cache is not None:
-            for node in found.itervalues():
-                for key, value in node.keys.iteritems():
-                    if key in self._leaf_value_cache:
-                        # Don't add the rest of the keys, we've seen this node
-                        # before.
-                        break
-                    self._leaf_value_cache[key] = value
-        return found
-
-    def iter_all_entries(self):
-        """Iterate over all keys within the index.
-
-        :return: An iterable of (index, key, value) or (index, key, value, reference_lists).
-            The former tuple is used when there are no reference lists in the
-            index, making the API compatible with simple key:value index types.
-            There is no defined order for the result iteration - it will be in
-            the most efficient order for the index.
-        """
-        if 'evil' in debug.debug_flags:
-            trace.mutter_callsite(3,
-                "iter_all_entries scales with size of history.")
-        if not self.key_count():
-            return
-        start_of_leaves = self._row_offsets[-2]
-        end_of_leaves = self._row_offsets[-1]
-        needed_nodes = range(start_of_leaves, end_of_leaves)
-        # We iterate strictly in-order so that we can use this function
-        # for spilling index builds to disk.
-        if self.node_ref_lists:
-            for _, node in self._read_nodes(needed_nodes):
-                for key, (value, refs) in sorted(node.keys.items()):
-                    yield (self, key, value, refs)
-        else:
-            for _, node in self._read_nodes(needed_nodes):
-                for key, (value, refs) in sorted(node.keys.items()):
-                    yield (self, key, value)
-
-    @staticmethod
-    def _multi_bisect_right(in_keys, fixed_keys):
-        """Find the positions where each 'in_key' would fit in fixed_keys.
-
-        This is equivalent to doing "bisect_right" on each in_key into
-        fixed_keys
-
-        :param in_keys: A sorted list of keys to match with fixed_keys
-        :param fixed_keys: A sorted list of keys to match against
-        :return: A list of (integer position, [key list]) tuples.
-        """
-        if not in_keys:
-            return []
-        if not fixed_keys:
-            # no pointers in the fixed_keys list, which means everything must
-            # fall to the left.
-            return [(0, in_keys)]
-
-        # TODO: Iterating both lists will generally take M + N steps
-        #       Bisecting each key will generally take M * log2 N steps.
-        #       If we had an efficient way to compare, we could pick the method
-        #       based on which has the fewer number of steps.
-        #       There is also the argument that bisect_right is a compiled
-        #       function, so there is even more to be gained.
-        # iter_steps = len(in_keys) + len(fixed_keys)
-        # bisect_steps = len(in_keys) * math.log(len(fixed_keys), 2)
-        if len(in_keys) == 1: # Bisect will always be faster for M = 1
-            return [(bisect_right(fixed_keys, in_keys[0]), in_keys)]
-        # elif bisect_steps < iter_steps:
-        #     offsets = {}
-        #     for key in in_keys:
-        #         offsets.setdefault(bisect_right(fixed_keys, key),
-        #                            []).append(key)
-        #     return [(o, offsets[o]) for o in sorted(offsets)]
-        in_keys_iter = iter(in_keys)
-        fixed_keys_iter = enumerate(fixed_keys)
-        cur_in_key = in_keys_iter.next()
-        cur_fixed_offset, cur_fixed_key = fixed_keys_iter.next()
-
-        class InputDone(Exception): pass
-        class FixedDone(Exception): pass
-
-        output = []
-        cur_out = []
-
-        # TODO: Another possibility is that rather than iterating on each side,
-        #       we could use a combination of bisecting and iterating. For
-        #       example, while cur_in_key < fixed_key, bisect to find its
-        #       point, then iterate all matching keys, then bisect (restricted
-        #       to only the remainder) for the next one, etc.
-        try:
-            while True:
-                if cur_in_key < cur_fixed_key:
-                    cur_keys = []
-                    cur_out = (cur_fixed_offset, cur_keys)
-                    output.append(cur_out)
-                    while cur_in_key < cur_fixed_key:
-                        cur_keys.append(cur_in_key)
-                        try:
-                            cur_in_key = in_keys_iter.next()
-                        except StopIteration:
-                            raise InputDone
-                    # At this point cur_in_key must be >= cur_fixed_key
-                # step the cur_fixed_key until we pass the cur key, or walk off
-                # the end
-                while cur_in_key >= cur_fixed_key:
-                    try:
-                        cur_fixed_offset, cur_fixed_key = fixed_keys_iter.next()
-                    except StopIteration:
-                        raise FixedDone
-        except InputDone:
-            # We consumed all of the input, nothing more to do
-            pass
-        except FixedDone:
-            # There was some input left, but we consumed all of fixed, so we
-            # have to add one more for the tail
-            cur_keys = [cur_in_key]
-            cur_keys.extend(in_keys_iter)
-            cur_out = (len(fixed_keys), cur_keys)
-            output.append(cur_out)
-        return output
-
-    def iter_entries(self, keys):
-        """Iterate over keys within the index.
-
-        :param keys: An iterable providing the keys to be retrieved.
-        :return: An iterable as per iter_all_entries, but restricted to the
-            keys supplied. No additional keys will be returned, and every
-            key supplied that is in the index will be returned.
-        """
-        # 6 seconds spent in miss_torture using the sorted() line.
-        # Even with out of order disk IO it seems faster not to sort it when
-        # large queries are being made.
-        # However, now that we are doing multi-way bisecting, we need the keys
-        # in sorted order anyway. We could change the multi-way code to not
-        # require sorted order. (For example, it bisects for the first node,
-        # does an in-order search until a key comes before the current point,
-        # which it then bisects for, etc.)
-        keys = frozenset(keys)
-        if not keys:
-            return
-
-        if not self.key_count():
-            return
-
-        needed_keys = []
-        if self._leaf_value_cache is None:
-            needed_keys = keys
-        else:
-            for key in keys:
-                value = self._leaf_value_cache.get(key, None)
-                if value is not None:
-                    # This key is known not to be here, skip it
-                    value, refs = value
-                    if self.node_ref_lists:
-                        yield (self, key, value, refs)
-                    else:
-                        yield (self, key, value)
-                else:
-                    needed_keys.append(key)
-
-        last_key = None
-        needed_keys = keys
-        if not needed_keys:
-            return
-        # 6 seconds spent in miss_torture using the sorted() line.
-        # Even with out of order disk IO it seems faster not to sort it when
-        # large queries are being made.
-        needed_keys = sorted(needed_keys)
-
-        nodes_and_keys = [(0, needed_keys)]
-
-        for row_pos, next_row_start in enumerate(self._row_offsets[1:-1]):
-            node_indexes = [idx for idx, s_keys in nodes_and_keys]
-            nodes = self._get_internal_nodes(node_indexes)
-
-            next_nodes_and_keys = []
-            for node_index, sub_keys in nodes_and_keys:
-                node = nodes[node_index]
-                positions = self._multi_bisect_right(sub_keys, node.keys)
-                node_offset = next_row_start + node.offset
-                next_nodes_and_keys.extend([(node_offset + pos, s_keys)
-                                           for pos, s_keys in positions])
-            nodes_and_keys = next_nodes_and_keys
-        # We should now be at the _LeafNodes
-        node_indexes = [idx for idx, s_keys in nodes_and_keys]
-
-        # TODO: We may *not* want to always read all the nodes in one
-        #       big go. Consider setting a max size on this.
-
-        nodes = self._get_leaf_nodes(node_indexes)
-        for node_index, sub_keys in nodes_and_keys:
-            if not sub_keys:
-                continue
-            node = nodes[node_index]
-            for next_sub_key in sub_keys:
-                if next_sub_key in node.keys:
-                    value, refs = node.keys[next_sub_key]
-                    if self.node_ref_lists:
-                        yield (self, next_sub_key, value, refs)
-                    else:
-                        yield (self, next_sub_key, value)
-
-    def iter_entries_prefix(self, keys):
-        """Iterate over keys within the index using prefix matching.
-
-        Prefix matching is applied within the tuple of a key, not to within
-        the bytestring of each key element. e.g. if you have the keys ('foo',
-        'bar'), ('foobar', 'gam') and do a prefix search for ('foo', None) then
-        only the former key is returned.
-
-        WARNING: Note that this method currently causes a full index parse
-        unconditionally (which is reasonably appropriate as it is a means for
-        thunking many small indices into one larger one and still supplies
-        iter_all_entries at the thunk layer).
-
-        :param keys: An iterable providing the key prefixes to be retrieved.
-            Each key prefix takes the form of a tuple the length of a key, but
-            with the last N elements 'None' rather than a regular bytestring.
-            The first element cannot be 'None'.
-        :return: An iterable as per iter_all_entries, but restricted to the
-            keys with a matching prefix to those supplied. No additional keys
-            will be returned, and every match that is in the index will be
-            returned.
-        """
-        keys = sorted(set(keys))
-        if not keys:
-            return
-        # Load if needed to check key lengths
-        if self._key_count is None:
-            self._get_root_node()
-        # TODO: only access nodes that can satisfy the prefixes we are looking
-        # for. For now, to meet API usage (as this function is not used by
-        # current bzrlib) just suck the entire index and iterate in memory.
-        nodes = {}
-        if self.node_ref_lists:
-            if self._key_length == 1:
-                for _1, key, value, refs in self.iter_all_entries():
-                    nodes[key] = value, refs
-            else:
-                nodes_by_key = {}
-                for _1, key, value, refs in self.iter_all_entries():
-                    key_value = key, value, refs
-                    # For a key of (foo, bar, baz) create
-                    # _nodes_by_key[foo][bar][baz] = key_value
-                    key_dict = nodes_by_key
-                    for subkey in key[:-1]:
-                        key_dict = key_dict.setdefault(subkey, {})
-                    key_dict[key[-1]] = key_value
-        else:
-            if self._key_length == 1:
-                for _1, key, value in self.iter_all_entries():
-                    nodes[key] = value
-            else:
-                nodes_by_key = {}
-                for _1, key, value in self.iter_all_entries():
-                    key_value = key, value
-                    # For a key of (foo, bar, baz) create
-                    # _nodes_by_key[foo][bar][baz] = key_value
-                    key_dict = nodes_by_key
-                    for subkey in key[:-1]:
-                        key_dict = key_dict.setdefault(subkey, {})
-                    key_dict[key[-1]] = key_value
-        if self._key_length == 1:
-            for key in keys:
-                # sanity check
-                if key[0] is None:
-                    raise errors.BadIndexKey(key)
-                if len(key) != self._key_length:
-                    raise errors.BadIndexKey(key)
-                try:
-                    if self.node_ref_lists:
-                        value, node_refs = nodes[key]
-                        yield self, key, value, node_refs
-                    else:
-                        yield self, key, nodes[key]
-                except KeyError:
-                    pass
-            return
-        for key in keys:
-            # sanity check
-            if key[0] is None:
-                raise errors.BadIndexKey(key)
-            if len(key) != self._key_length:
-                raise errors.BadIndexKey(key)
-            # find what it refers to:
-            key_dict = nodes_by_key
-            elements = list(key)
-            # find the subdict whose contents should be returned.
-            try:
-                while len(elements) and elements[0] is not None:
-                    key_dict = key_dict[elements[0]]
-                    elements.pop(0)
-            except KeyError:
-                # a non-existant lookup.
-                continue
-            if len(elements):
-                dicts = [key_dict]
-                while dicts:
-                    key_dict = dicts.pop(-1)
-                    # can't be empty or would not exist
-                    item, value = key_dict.iteritems().next()
-                    if type(value) == dict:
-                        # push keys
-                        dicts.extend(key_dict.itervalues())
-                    else:
-                        # yield keys
-                        for value in key_dict.itervalues():
-                            # each value is the key:value:node refs tuple
-                            # ready to yield.
-                            yield (self, ) + value
-            else:
-                # the last thing looked up was a terminal element
-                yield (self, ) + key_dict
-
-    def key_count(self):
-        """Return an estimate of the number of keys in this index.
-
-        For BTreeGraphIndex the estimate is exact as it is contained in the
-        header.
-        """
-        if self._key_count is None:
-            self._get_root_node()
-        return self._key_count
-
-    def _parse_header_from_bytes(self, bytes):
-        """Parse the header from a region of bytes.
-
-        :param bytes: The data to parse.
-        :return: An offset, data tuple such as readv yields, for the unparsed
-            data. (which may be of length 0).
-        """
-        signature = bytes[0:len(self._signature())]
-        if not signature == self._signature():
-            raise errors.BadIndexFormatSignature(self._name, BTreeGraphIndex)
-        lines = bytes[len(self._signature()):].splitlines()
-        options_line = lines[0]
-        if not options_line.startswith(_OPTION_NODE_REFS):
-            raise errors.BadIndexOptions(self)
-        try:
-            self.node_ref_lists = int(options_line[len(_OPTION_NODE_REFS):])
-        except ValueError:
-            raise errors.BadIndexOptions(self)
-        options_line = lines[1]
-        if not options_line.startswith(_OPTION_KEY_ELEMENTS):
-            raise errors.BadIndexOptions(self)
-        try:
-            self._key_length = int(options_line[len(_OPTION_KEY_ELEMENTS):])
-        except ValueError:
-            raise errors.BadIndexOptions(self)
-        options_line = lines[2]
-        if not options_line.startswith(_OPTION_LEN):
-            raise errors.BadIndexOptions(self)
-        try:
-            self._key_count = int(options_line[len(_OPTION_LEN):])
-        except ValueError:
-            raise errors.BadIndexOptions(self)
-        options_line = lines[3]
-        if not options_line.startswith(_OPTION_ROW_LENGTHS):
-            raise errors.BadIndexOptions(self)
-        try:
-            self._row_lengths = map(int, [length for length in
-                options_line[len(_OPTION_ROW_LENGTHS):].split(',')
-                if len(length)])
-        except ValueError:
-            raise errors.BadIndexOptions(self)
-        offsets = []
-        row_offset = 0
-        for row in self._row_lengths:
-            offsets.append(row_offset)
-            row_offset += row
-        offsets.append(row_offset)
-        self._row_offsets = offsets
-
-        # calculate the bytes we have processed
-        header_end = (len(signature) + sum(map(len, lines[0:4])) + 4)
-        return header_end, bytes[header_end:]
-
-    def _read_nodes(self, nodes):
-        """Read some nodes from disk into the LRU cache.
-
-        This performs a readv to get the node data into memory, and parses each
-        node, the yields it to the caller. The nodes are requested in the
-        supplied order. If possible doing sort() on the list before requesting
-        a read may improve performance.
-
-        :param nodes: The nodes to read. 0 - first node, 1 - second node etc.
-        :return: None
-        """
-        ranges = []
-        for index in nodes:
-            offset = index * _PAGE_SIZE
-            size = _PAGE_SIZE
-            if index == 0:
-                # Root node - special case
-                if self._size:
-                    size = min(_PAGE_SIZE, self._size)
-                else:
-                    stream = self._transport.get(self._name)
-                    start = stream.read(_PAGE_SIZE)
-                    # Avoid doing this again
-                    self._size = len(start)
-                    size = min(_PAGE_SIZE, self._size)
-            else:
-                size = min(size, self._size - offset)
-            ranges.append((offset, size))
-        if not ranges:
-            return
-        if self._file is None:
-            data_ranges = self._transport.readv(self._name, ranges)
-        else:
-            data_ranges = []
-            for offset, size in ranges:
-                self._file.seek(offset)
-                data_ranges.append((offset, self._file.read(size)))
-        for offset, data in data_ranges:
-            if offset == 0:
-                # extract the header
-                offset, data = self._parse_header_from_bytes(data)
-                if len(data) == 0:
-                    continue
-            bytes = zlib.decompress(data)
-            if bytes.startswith(_LEAF_FLAG):
-                node = _LeafNode(bytes, self._key_length, self.node_ref_lists)
-            elif bytes.startswith(_INTERNAL_FLAG):
-                node = _InternalNode(bytes)
-            else:
-                raise AssertionError("Unknown node type for %r" % bytes)
-            yield offset / _PAGE_SIZE, node
-
-    def _signature(self):
-        """The file signature for this index type."""
-        return _BTSIGNATURE
-
-    def validate(self):
-        """Validate that everything in the index can be accessed."""
-        # just read and parse every node.
-        self._get_root_node()
-        if len(self._row_lengths) > 1:
-            start_node = self._row_offsets[1]
-        else:
-            # We shouldn't be reading anything anyway
-            start_node = 1
-        node_end = self._row_offsets[-1]
-        for node in self._read_nodes(range(start_node, node_end)):
-            pass
-
-
-try:
-    from bzrlib import _btree_serializer_c as _btree_serializer
-except ImportError:
-    from bzrlib import _btree_serializer_py as _btree_serializer

=== modified file 'bzrlib/bugtracker.py'
--- bzrlib/bugtracker.py	2008-03-29 13:29:10 +0000
+++ bzrlib/bugtracker.py	2007-04-23 05:59:29 +0000
@@ -39,73 +39,6 @@
 """
 
 
-_bugs_help = \
-"""When making a commit, metadata about bugs fixed by that change can be
-recorded by using the --fixes option. For each bug marked as fixed, an
-entry is included in the 'bugs' revision property stating '<url> <status>'.
-(The only ``status`` value currently supported is ``fixed.``)
-Support for Launchpad's central bug tracker is built in. For other bug
-trackers, configuration is required in advance so that the correct URL
-can be recorded.
-
-In addition to Launchpad, Bazaar directly supports the generation of
-URLs appropriate for Bugzilla and Trac. If your project uses a different
-bug tracker, it is easy to add support for it.
-If you use Bugzilla or Trac, then you only need to set a configuration
-variable which contains the base URL of the bug tracker. These options
-can go into ``bazaar.conf``, ``branch.conf`` or into a branch-specific
-configuration section in ``locations.conf``.  You can set up these values
-for each of the projects you work on.
-
-Note: As you provide a short name for each tracker, you can specify one or
-more bugs in one or more trackers at commit time if you wish.
-
-bugzilla_<tracker_abbreviation>_url
------------------------------------
-
-If present, the location of the Bugzilla bug tracker referred to by
-<tracker_abbreviation>. This option can then be used together with ``bzr commit
---fixes`` to mark bugs in that tracker as being fixed by that commit. For
-example::
-
-    bugzilla_squid_url = http://www.squid-cache.org/bugs
-
-would allow ``bzr commit --fixes squid:1234`` to mark Squid's bug 1234 as
-fixed.
-
-trac_<tracker_abbrevation>_url
-------------------------------
-
-If present, the location of the Trac instance referred to by
-<tracker_abbreviation>. This option can then be used together with ``bzr commit
---fixes`` to mark bugs in that tracker as being fixed by that commit. For
-example::
-
-    trac_twisted_url = http://www.twistedmatrix.com/trac
-
-would allow ``bzr commit --fixes twisted:1234`` to mark Twisted's bug 1234 as
-fixed.
-
-bugtracker_<tracker_abbrevation>_url
-------------------------------------
-
-If present, the location of a generic bug tracker instance referred to by
-<tracker_abbreviation>. The location must contain an ``{id}`` placeholder,
-which will be replaced by a specific bug ID. This option can then be used
-together with ``bzr commit --fixes`` to mark bugs in that tracker as being
-fixed by that commit. For example::
-
-    bugtracker_python_url = http://bugs.python.org/issue{id}
-
-would allow ``bzr commit --fixes python:1234`` to mark bug 1234 in Python's
-Roundup bug tracker as fixed, or::
-
-    bugtracker_cpan_url = http://rt.cpan.org/Public/Bug/Display.html?id={id}
-
-for CPAN's RT bug tracker.
-"""
-
-
 def get_bug_url(abbreviated_bugtracker_name, branch, bug_id):
     """Return a URL pointing to the canonical web page of the bug identified by
     'bug_id'.
@@ -132,7 +65,13 @@
                                                    branch)
 
     def help_topic(self, topic):
-        return _bugs_help
+        return textwrap.dedent("""\
+        Bazaar provides the ability to store information about bugs being fixed
+        as metadata on a revision.
+
+        For each bug marked as fixed, an entry is included in the 'bugs'
+        revision property stating '<url> <status>'.
+        """)
 
 
 tracker_registry = TrackerRegistry()
@@ -171,8 +110,7 @@
     """A style of bug tracker that exists in one place only, such as Launchpad.
 
     If you have one of these trackers then register an instance passing in an
-    abbreviated name for the bug tracker and a base URL. The bug ids are
-    appended directly to the URL.
+    abbreviated name for the bug tracker and a base URL.
     """
 
     def __init__(self, abbreviated_bugtracker_name, base_url):
@@ -188,7 +126,7 @@
 
     def _get_bug_url(self, bug_id):
         """Return the URL for bug_id."""
-        return self.base_url + bug_id
+        return urlutils.join(self.base_url, bug_id)
 
 
 tracker_registry.register(
@@ -199,10 +137,6 @@
     'debian', UniqueIntegerBugTracker('deb', 'http://bugs.debian.org/'))
 
 
-tracker_registry.register('gnome',
-    UniqueIntegerBugTracker('gnome', 'http://bugzilla.gnome.org/show_bug.cgi?id='))
-
-
 class URLParametrizedIntegerBugTracker(IntegerBugTracker):
     """A type of bug tracker that can be found on a variety of different sites,
     and thus needs to have the base URL configured.
@@ -237,24 +171,3 @@
 tracker_registry.register(
     'bugzilla',
     URLParametrizedIntegerBugTracker('bugzilla', 'show_bug.cgi?id='))
-
-
-class GenericBugTracker(URLParametrizedIntegerBugTracker):
-    """Generic bug tracker specified by an URL template."""
-
-    def __init__(self):
-        super(GenericBugTracker, self).__init__('bugtracker', None)
-
-    def get(self, abbreviation, branch):
-        self._abbreviation = abbreviation
-        return super(GenericBugTracker, self).get(abbreviation, branch)
-
-    def _get_bug_url(self, bug_id):
-        """Given a validated bug_id, return the bug's web page's URL."""
-        if '{id}' not in self._base_url:
-            raise errors.InvalidBugTrackerURL(self._abbreviation,
-                                              self._base_url)
-        return self._base_url.replace('{id}', str(bug_id))
-
-
-tracker_registry.register('generic', GenericBugTracker())

=== modified file 'bzrlib/builtins.py'
--- bzrlib/builtins.py	2008-09-01 23:49:18 +0000
+++ bzrlib/builtins.py	2007-10-17 07:52:47 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2004, 2005, 2006, 2007, 2008 Canonical Ltd
+# Copyright (C) 2004, 2005, 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -87,27 +87,27 @@
     if file_list is None or len(file_list) == 0:
         return WorkingTree.open_containing(default_branch)[0], file_list
     tree = WorkingTree.open_containing(osutils.realpath(file_list[0]))[0]
-    return tree, safe_relpath_files(tree, file_list)
-
-
-def safe_relpath_files(tree, file_list):
-    """Convert file_list into a list of relpaths in tree.
-
-    :param tree: A tree to operate on.
-    :param file_list: A list of user provided paths or None.
-    :return: A list of relative paths.
-    :raises errors.PathNotChild: When a provided path is in a different tree
-        than tree.
-    """
-    if file_list is None:
-        return None
     new_list = []
     for filename in file_list:
         try:
             new_list.append(tree.relpath(osutils.dereference_path(filename)))
         except errors.PathNotChild:
             raise errors.FileInWrongBranch(tree.branch, filename)
-    return new_list
+    return tree, new_list
+
+
+@symbol_versioning.deprecated_function(symbol_versioning.zero_fifteen)
+def get_format_type(typestring):
+    """Parse and return a format specifier."""
+    # Have to use BzrDirMetaFormat1 directly, so that
+    # RepositoryFormat.set_default_format works
+    if typestring == "default":
+        return bzrdir.BzrDirMetaFormat1()
+    try:
+        return bzrdir.format_registry.make_bzrdir(typestring)
+    except KeyError:
+        msg = 'Unknown bzr format "%s". See "bzr help formats".' % typestring
+        raise errors.BzrCommandError(msg)
 
 
 # TODO: Make sure no commands unconditionally use the working directory as a
@@ -148,7 +148,7 @@
     
     Note that --short or -S gives status flags for each item, similar
     to Subversion's status command. To get output similar to svn -q,
-    use bzr status -SV.
+    use bzr -SV.
 
     If no arguments are specified, the status of the entire working
     directory is shown.  Otherwise, only the status of the specified
@@ -166,9 +166,7 @@
                      Option('short', help='Use short status indicators.',
                             short_name='S'),
                      Option('versioned', help='Only show versioned files.',
-                            short_name='V'),
-                     Option('no-pending', help='Don\'t show pending merges.',
-                           ),
+                            short_name='V')
                      ]
     aliases = ['st', 'stat']
 
@@ -177,27 +175,18 @@
     
     @display_command
     def run(self, show_ids=False, file_list=None, revision=None, short=False,
-            versioned=False, no_pending=False):
+            versioned=False):
         from bzrlib.status import show_tree_status
 
         if revision and len(revision) > 2:
             raise errors.BzrCommandError('bzr status --revision takes exactly'
                                          ' one or two revision specifiers')
 
-        tree, relfile_list = tree_files(file_list)
-        # Avoid asking for specific files when that is not needed.
-        if relfile_list == ['']:
-            relfile_list = None
-            # Don't disable pending merges for full trees other than '.'.
-            if file_list == ['.']:
-                no_pending = True
-        # A specific path within a tree was given.
-        elif relfile_list is not None:
-            no_pending = True
+        tree, file_list = tree_files(file_list)
+            
         show_tree_status(tree, show_ids=show_ids,
-                         specific_files=relfile_list, revision=revision,
-                         to_file=self.outf, short=short, versioned=versioned,
-                         show_pending=(not no_pending))
+                         specific_files=file_list, revision=revision,
+                         to_file=self.outf, short=short, versioned=versioned)
 
 
 class cmd_cat_revision(Command):
@@ -226,18 +215,13 @@
         # TODO: jam 20060112 should cat-revision always output utf-8?
         if revision_id is not None:
             revision_id = osutils.safe_revision_id(revision_id, warn=False)
-            try:
-                self.outf.write(b.repository.get_revision_xml(revision_id).decode('utf-8'))
-            except errors.NoSuchRevision:
-                msg = "The repository %s contains no revision %s." % (b.repository.base,
-                    revision_id)
-                raise errors.BzrCommandError(msg)
+            self.outf.write(b.repository.get_revision_xml(revision_id).decode('utf-8'))
         elif revision is not None:
             for rev in revision:
                 if rev is None:
                     raise errors.BzrCommandError('You cannot specify a NULL'
                                                  ' revision.')
-                rev_id = rev.as_revision_id(b)
+                revno, rev_id = rev.in_history(b)
                 self.outf.write(b.repository.get_revision_xml(rev_id).decode('utf-8'))
     
 
@@ -311,13 +295,13 @@
             revs.append(RevisionSpec.from_string('-1'))
 
         for rev in revs:
-            revision_id = rev.as_revision_id(b)
-            try:
-                revno = '%4d' % (b.revision_id_to_revno(revision_id))
-            except errors.NoSuchRevision:
+            revinfo = rev.in_history(b)
+            if revinfo.revno is None:
                 dotted_map = b.get_revision_id_to_revno_map()
-                revno = '.'.join(str(i) for i in dotted_map[revision_id])
-            print '%s %s' % (revno, revision_id)
+                revno = '.'.join(str(i) for i in dotted_map[revinfo.rev_id])
+                print '%s %s' % (revno, revinfo.rev_id)
+            else:
+                print '%4d %s' % (revinfo.revno, revinfo.rev_id)
 
     
 class cmd_add(Command):
@@ -482,7 +466,7 @@
                     raise errors.BzrCommandError(
                         'bzr inventory --revision takes exactly one revision'
                         ' identifier')
-                revision_id = revision[0].as_revision_id(work_tree.branch)
+                revision_id = revision[0].in_history(work_tree.branch).rev_id
                 tree = work_tree.branch.repository.revision_tree(revision_id)
 
                 extra_trees = [work_tree]
@@ -550,31 +534,8 @@
         if len(names_list) < 2:
             raise errors.BzrCommandError("missing file argument")
         tree, rel_names = tree_files(names_list)
-        tree.lock_write()
-        try:
-            self._run(tree, names_list, rel_names, after)
-        finally:
-            tree.unlock()
-
-    def _run(self, tree, names_list, rel_names, after):
-        into_existing = osutils.isdir(names_list[-1])
-        if into_existing and len(names_list) == 2:
-            # special cases:
-            # a. case-insensitive filesystem and change case of dir
-            # b. move directory after the fact (if the source used to be
-            #    a directory, but now doesn't exist in the working tree
-            #    and the target is an existing directory, just rename it)
-            if (not tree.case_sensitive
-                and rel_names[0].lower() == rel_names[1].lower()):
-                into_existing = False
-            else:
-                inv = tree.inventory
-                from_id = tree.path2id(rel_names[0])
-                if (not osutils.lexists(names_list[0]) and
-                    from_id and inv.get_file_kind(from_id) == "directory"):
-                    into_existing = False
-        # move/rename
-        if into_existing:
+        
+        if os.path.isdir(names_list[-1]):
             # move into existing directory
             for pair in tree.move(rel_names[:-1], rel_names[-1], after=after):
                 self.outf.write("%s => %s\n" % pair)
@@ -585,8 +546,8 @@
                                              ' directory')
             tree.rename_one(rel_names[0], rel_names[1], after=after)
             self.outf.write("%s => %s\n" % (rel_names[0], rel_names[1]))
-
-
+            
+    
 class cmd_pull(Command):
     """Turn this branch into a mirror of another branch.
 
@@ -605,10 +566,6 @@
     that, you can omit the location to use the default.  To change the
     default, use --remember. The value will only be saved if the remote
     location can be accessed.
-
-    Note: The location can be specified either in the form of a branch,
-    or in the form of a path to a file containing a merge directive generated
-    with bzr send.
     """
 
     _see_also = ['push', 'update', 'status-flags']
@@ -642,11 +599,8 @@
 
         possible_transports = []
         if location is not None:
-            try:
-                mergeable = bundle.read_mergeable_from_url(location,
-                    possible_transports=possible_transports)
-            except errors.NotABundle:
-                mergeable = None
+            mergeable, location_transport = _get_mergeable_helper(location)
+            possible_transports.append(location_transport)
 
         stored_loc = branch_to.get_parent()
         if location is None:
@@ -656,9 +610,10 @@
             else:
                 display_url = urlutils.unescape_for_display(stored_loc,
                         self.outf.encoding)
-                if not is_quiet():
-                    self.outf.write("Using saved parent location: %s\n" % display_url)
+                self.outf.write("Using saved location: %s\n" % display_url)
                 location = stored_loc
+                location_transport = transport.get_transport(
+                    location, possible_transports=possible_transports)
 
         if mergeable is not None:
             if revision is not None:
@@ -669,41 +624,34 @@
                 mergeable.get_merge_request(branch_to.repository)
             branch_from = branch_to
         else:
-            branch_from = Branch.open(location,
-                possible_transports=possible_transports)
+            branch_from = Branch.open_from_transport(location_transport)
 
             if branch_to.get_parent() is None or remember:
                 branch_to.set_parent(branch_from.base)
 
         if revision is not None:
             if len(revision) == 1:
-                revision_id = revision[0].as_revision_id(branch_from)
+                revision_id = revision[0].in_history(branch_from).rev_id
             else:
                 raise errors.BzrCommandError(
                     'bzr pull --revision takes one value.')
 
-        branch_to.lock_write()
-        try:
-            if tree_to is not None:
-                change_reporter = delta._ChangeReporter(
-                    unversioned_filter=tree_to.is_ignored)
-                result = tree_to.pull(branch_from, overwrite, revision_id,
-                                      change_reporter,
-                                      possible_transports=possible_transports)
-            else:
-                result = branch_to.pull(branch_from, overwrite, revision_id)
+        if verbose:
+            old_rh = branch_to.revision_history()
+        if tree_to is not None:
+            change_reporter = delta._ChangeReporter(
+                unversioned_filter=tree_to.is_ignored)
+            result = tree_to.pull(branch_from, overwrite, revision_id,
+                                  change_reporter,
+                                  possible_transports=possible_transports)
+        else:
+            result = branch_to.pull(branch_from, overwrite, revision_id)
 
-            result.report(self.outf)
-            if verbose and result.old_revid != result.new_revid:
-                old_rh = list(
-                    branch_to.repository.iter_reverse_revision_history(
-                    result.old_revid))
-                old_rh.reverse()
-                new_rh = branch_to.revision_history()
-                log.show_changed_revisions(branch_to, old_rh, new_rh,
-                                           to_file=self.outf)
-        finally:
-            branch_to.unlock()
+        result.report(self.outf)
+        if verbose:
+            new_rh = branch_to.revision_history()
+            log.show_changed_revisions(branch_to, old_rh, new_rh,
+                                       to_file=self.outf)
 
 
 class cmd_push(Command):
@@ -733,7 +681,7 @@
     """
 
     _see_also = ['pull', 'update', 'working-trees']
-    takes_options = ['remember', 'overwrite', 'verbose', 'revision',
+    takes_options = ['remember', 'overwrite', 'verbose',
         Option('create-prefix',
                help='Create the path leading up to the branch '
                     'if it does not already exist.'),
@@ -748,71 +696,143 @@
                     ' directory exists, but does not already'
                     ' have a control directory.  This flag will'
                     ' allow push to proceed.'),
-        Option('stacked',
-            help='Create a stacked branch that references the public location '
-                'of the parent branch.'),
-        Option('stacked-on',
-            help='Create a stacked branch that refers to another branch '
-                'for the commit history. Only the work not present in the '
-                'referenced branch is included in the branch created.',
-            type=unicode),
         ]
     takes_args = ['location?']
     encoding_type = 'replace'
 
     def run(self, location=None, remember=False, overwrite=False,
-        create_prefix=False, verbose=False, revision=None,
-        use_existing_dir=False, directory=None, stacked_on=None,
-        stacked=False):
-        from bzrlib.push import _show_push_branch
-
-        # Get the source branch and revision_id
+            create_prefix=False, verbose=False,
+            use_existing_dir=False,
+            directory=None):
+        # FIXME: Way too big!  Put this into a function called from the
+        # command.
         if directory is None:
             directory = '.'
         br_from = Branch.open_containing(directory)[0]
-        if revision is not None:
-            if len(revision) == 1:
-                revision_id = revision[0].in_history(br_from).rev_id
-            else:
-                raise errors.BzrCommandError(
-                    'bzr push --revision takes one value.')
-        else:
-            revision_id = br_from.last_revision()
-
-        # Get the stacked_on branch, if any
-        if stacked_on is not None:
-            stacked_on = urlutils.normalize_url(stacked_on)
-        elif stacked:
-            parent_url = br_from.get_parent()
-            if parent_url:
-                parent = Branch.open(parent_url)
-                stacked_on = parent.get_public_branch()
-                if not stacked_on:
-                    # I considered excluding non-http url's here, thus forcing
-                    # 'public' branches only, but that only works for some
-                    # users, so it's best to just depend on the user spotting an
-                    # error by the feedback given to them. RBC 20080227.
-                    stacked_on = parent_url
-            if not stacked_on:
-                raise errors.BzrCommandError(
-                    "Could not determine branch to refer to.")
-
-        # Get the destination location
+        stored_loc = br_from.get_push_location()
         if location is None:
-            stored_loc = br_from.get_push_location()
             if stored_loc is None:
-                raise errors.BzrCommandError(
-                    "No push location known or specified.")
+                raise errors.BzrCommandError("No push location known or specified.")
             else:
                 display_url = urlutils.unescape_for_display(stored_loc,
                         self.outf.encoding)
-                self.outf.write("Using saved push location: %s\n" % display_url)
+                self.outf.write("Using saved location: %s\n" % display_url)
                 location = stored_loc
 
-        _show_push_branch(br_from, revision_id, location, self.outf,
-            verbose=verbose, overwrite=overwrite, remember=remember,
-            stacked_on=stacked_on, create_prefix=create_prefix,
-            use_existing_dir=use_existing_dir)
+        to_transport = transport.get_transport(location)
+
+        br_to = repository_to = dir_to = None
+        try:
+            dir_to = bzrdir.BzrDir.open_from_transport(to_transport)
+        except errors.NotBranchError:
+            pass # Didn't find anything
+        else:
+            # If we can open a branch, use its direct repository, otherwise see
+            # if there is a repository without a branch.
+            try:
+                br_to = dir_to.open_branch()
+            except errors.NotBranchError:
+                # Didn't find a branch, can we find a repository?
+                try:
+                    repository_to = dir_to.find_repository()
+                except errors.NoRepositoryPresent:
+                    pass
+            else:
+                # Found a branch, so we must have found a repository
+                repository_to = br_to.repository
+        push_result = None
+        if verbose:
+            old_rh = []
+        if dir_to is None:
+            # The destination doesn't exist; create it.
+            # XXX: Refactor the create_prefix/no_create_prefix code into a
+            #      common helper function
+            try:
+                to_transport.mkdir('.')
+            except errors.FileExists:
+                if not use_existing_dir:
+                    raise errors.BzrCommandError("Target directory %s"
+                         " already exists, but does not have a valid .bzr"
+                         " directory. Supply --use-existing-dir to push"
+                         " there anyway." % location)
+            except errors.NoSuchFile:
+                if not create_prefix:
+                    raise errors.BzrCommandError("Parent directory of %s"
+                        " does not exist."
+                        "\nYou may supply --create-prefix to create all"
+                        " leading parent directories."
+                        % location)
+                _create_prefix(to_transport)
+
+            # Now the target directory exists, but doesn't have a .bzr
+            # directory. So we need to create it, along with any work to create
+            # all of the dependent branches, etc.
+            dir_to = br_from.bzrdir.clone_on_transport(to_transport,
+                revision_id=br_from.last_revision())
+            br_to = dir_to.open_branch()
+            # TODO: Some more useful message about what was copied
+            note('Created new branch.')
+            # We successfully created the target, remember it
+            if br_from.get_push_location() is None or remember:
+                br_from.set_push_location(br_to.base)
+        elif repository_to is None:
+            # we have a bzrdir but no branch or repository
+            # XXX: Figure out what to do other than complain.
+            raise errors.BzrCommandError("At %s you have a valid .bzr control"
+                " directory, but not a branch or repository. This is an"
+                " unsupported configuration. Please move the target directory"
+                " out of the way and try again."
+                % location)
+        elif br_to is None:
+            # We have a repository but no branch, copy the revisions, and then
+            # create a branch.
+            last_revision_id = br_from.last_revision()
+            repository_to.fetch(br_from.repository,
+                                revision_id=last_revision_id)
+            br_to = br_from.clone(dir_to, revision_id=last_revision_id)
+            note('Created new branch.')
+            if br_from.get_push_location() is None or remember:
+                br_from.set_push_location(br_to.base)
+        else: # We have a valid to branch
+            # We were able to connect to the remote location, so remember it
+            # we don't need to successfully push because of possible divergence.
+            if br_from.get_push_location() is None or remember:
+                br_from.set_push_location(br_to.base)
+            if verbose:
+                old_rh = br_to.revision_history()
+            try:
+                try:
+                    tree_to = dir_to.open_workingtree()
+                except errors.NotLocalUrl:
+                    warning("This transport does not update the working " 
+                            "tree of: %s. See 'bzr help working-trees' for "
+                            "more information." % br_to.base)
+                    push_result = br_from.push(br_to, overwrite)
+                except errors.NoWorkingTree:
+                    push_result = br_from.push(br_to, overwrite)
+                else:
+                    tree_to.lock_write()
+                    try:
+                        push_result = br_from.push(tree_to.branch, overwrite)
+                        tree_to.update()
+                    finally:
+                        tree_to.unlock()
+            except errors.DivergedBranches:
+                raise errors.BzrCommandError('These branches have diverged.'
+                                        '  Try using "merge" and then "push".')
+        if push_result is not None:
+            push_result.report(self.outf)
+        elif verbose:
+            new_rh = br_to.revision_history()
+            if old_rh != new_rh:
+                # Something changed
+                from bzrlib.log import show_changed_revisions
+                show_changed_revisions(br_to, old_rh, new_rh,
+                                       to_file=self.outf)
+        else:
+            # we probably did a clone rather than a push, so a message was
+            # emitted above
+            pass
 
 
 class cmd_branch(Command):
@@ -831,17 +851,10 @@
 
     _see_also = ['checkout']
     takes_args = ['from_location', 'to_location?']
-    takes_options = ['revision', Option('hardlink',
-        help='Hard-link working tree files where possible.'),
-        Option('stacked',
-            help='Create a stacked branch referring to the source branch. '
-                'The new branch will depend on the availability of the source '
-                'branch for all operations.'),
-        ]
+    takes_options = ['revision']
     aliases = ['get', 'clone']
 
-    def run(self, from_location, to_location=None, revision=None,
-            hardlink=False, stacked=False):
+    def run(self, from_location, to_location=None, revision=None):
         from bzrlib.tag import _merge_tags_if_possible
         if revision is None:
             revision = [None]
@@ -849,12 +862,11 @@
             raise errors.BzrCommandError(
                 'bzr branch --revision takes exactly 1 revision value')
 
-        accelerator_tree, br_from = bzrdir.BzrDir.open_tree_or_branch(
-            from_location)
+        br_from = Branch.open(from_location)
         br_from.lock_read()
         try:
             if len(revision) == 1 and revision[0] is not None:
-                revision_id = revision[0].as_revision_id(br_from)
+                revision_id = revision[0].in_history(br_from)[1]
             else:
                 # FIXME - wt.last_revision, fallback to branch, fall back to
                 # None or perhaps NULL_REVISION to mean copy nothing
@@ -862,6 +874,10 @@
                 revision_id = br_from.last_revision()
             if to_location is None:
                 to_location = urlutils.derive_to_location(from_location)
+                name = None
+            else:
+                name = os.path.basename(to_location) + '\n'
+
             to_transport = transport.get_transport(to_location)
             try:
                 to_transport.mkdir('.')
@@ -874,25 +890,16 @@
             try:
                 # preserve whatever source format we have.
                 dir = br_from.bzrdir.sprout(to_transport.base, revision_id,
-                                            possible_transports=[to_transport],
-                                            accelerator_tree=accelerator_tree,
-                                            hardlink=hardlink, stacked=stacked)
+                                            possible_transports=[to_transport])
                 branch = dir.open_branch()
             except errors.NoSuchRevision:
                 to_transport.delete_tree('.')
-                msg = "The branch %s has no revision %s." % (from_location,
-                    revision[0])
+                msg = "The branch %s has no revision %s." % (from_location, revision[0])
                 raise errors.BzrCommandError(msg)
+            if name:
+                branch.control_files.put_utf8('branch-name', name)
             _merge_tags_if_possible(br_from, branch)
-            # If the source branch is stacked, the new branch may
-            # be stacked whether we asked for that explicitly or not.
-            # We therefore need a try/except here and not just 'if stacked:'
-            try:
-                note('Created new stacked branch referring to %s.' %
-                    branch.get_stacked_on_url())
-            except (errors.NotStacked, errors.UnstackableBranchFormat,
-                errors.UnstackableRepositoryFormat), e:
-                note('Branched %d revision(s).' % branch.revno())
+            note('Branched %d revision(s).' % branch.revno())
         finally:
             br_from.unlock()
 
@@ -928,16 +935,11 @@
                                  "common operations like diff and status without "
                                  "such access, and also support local commits."
                             ),
-                     Option('files-from', type=str,
-                            help="Get file contents from this tree."),
-                     Option('hardlink',
-                            help='Hard-link working tree files where possible.'
-                            ),
                      ]
     aliases = ['co']
 
     def run(self, branch_location=None, to_location=None, revision=None,
-            lightweight=False, files_from=None, hardlink=False):
+            lightweight=False):
         if revision is None:
             revision = [None]
         elif len(revision) > 1:
@@ -946,12 +948,10 @@
         if branch_location is None:
             branch_location = osutils.getcwd()
             to_location = branch_location
-        accelerator_tree, source = bzrdir.BzrDir.open_tree_or_branch(
-            branch_location)
-        if files_from is not None:
-            accelerator_tree = WorkingTree.open(files_from)
+        source = Branch.open(branch_location)
         if len(revision) == 1 and revision[0] is not None:
-            revision_id = revision[0].as_revision_id(source)
+            revision_id = _mod_revision.ensure_null(
+                revision[0].in_history(source)[1])
         else:
             revision_id = None
         if to_location is None:
@@ -966,8 +966,7 @@
             except errors.NoWorkingTree:
                 source.bzrdir.create_workingtree(revision_id)
                 return
-        source.create_checkout(to_location, revision_id, lightweight,
-                               accelerator_tree, hardlink)
+        source.create_checkout(to_location, revision_id, lightweight)
 
 
 class cmd_renames(Command):
@@ -1063,7 +1062,6 @@
     _see_also = ['revno', 'working-trees', 'repositories']
     takes_args = ['location?']
     takes_options = ['verbose']
-    encoding_type = 'replace'
 
     @display_command
     def run(self, location=None, verbose=False):
@@ -1073,20 +1071,23 @@
             noise_level = 0
         from bzrlib.info import show_bzrdir_info
         show_bzrdir_info(bzrdir.BzrDir.open_containing(location)[0],
-                         verbose=noise_level, outfile=self.outf)
+                         verbose=noise_level)
 
 
 class cmd_remove(Command):
     """Remove files or directories.
 
-    This makes bzr stop tracking changes to the specified files. bzr will delete
-    them if they can easily be recovered using revert. If no options or
-    parameters are given bzr will scan for files that are being tracked by bzr
-    but missing in your tree and stop tracking them for you.
+    This makes bzr stop tracking changes to the specified files and
+    delete them if they can easily be recovered using revert.
+
+    You can specify one or more files, and/or --new.  If you specify --new,
+    only 'added' files will be removed.  If you specify both, then new files
+    in the specified directories will be removed.  If the directories are
+    also new, they will also be removed.
     """
     takes_args = ['file*']
     takes_options = ['verbose',
-        Option('new', help='Only remove files that have never been committed.'),
+        Option('new', help='Remove newly-added files.'),
         RegistryOption.from_kwargs('file-deletion-strategy',
             'The file deletion mode to be used.',
             title='Deletion Strategy', value_switches=True, enum_switch=False,
@@ -1095,7 +1096,7 @@
             keep="Don't delete any files.",
             force='Delete all the specified files, even if they can not be '
                 'recovered and even if they are non-empty directories.')]
-    aliases = ['rm', 'del']
+    aliases = ['rm']
     encoding_type = 'replace'
 
     def run(self, file_list, verbose=False, new=False,
@@ -1104,32 +1105,19 @@
 
         if file_list is not None:
             file_list = [f for f in file_list]
+        elif not new:
+            raise errors.BzrCommandError('Specify one or more files to'
+            ' remove, or use --new.')
 
-        tree.lock_write()
-        try:
-            # Heuristics should probably all move into tree.remove_smart or
-            # some such?
-            if new:
-                added = tree.changes_from(tree.basis_tree(),
-                    specific_files=file_list).added
-                file_list = sorted([f[0] for f in added], reverse=True)
-                if len(file_list) == 0:
-                    raise errors.BzrCommandError('No matching files.')
-            elif file_list is None:
-                # missing files show up in iter_changes(basis) as
-                # versioned-with-no-kind.
-                missing = []
-                for change in tree.iter_changes(tree.basis_tree()):
-                    # Find paths in the working tree that have no kind:
-                    if change[1][1] is not None and change[6][1] is None:
-                        missing.append(change[1][1])
-                file_list = sorted(missing, reverse=True)
-                file_deletion_strategy = 'keep'
-            tree.remove(file_list, verbose=verbose, to_file=self.outf,
-                keep_files=file_deletion_strategy=='keep',
-                force=file_deletion_strategy=='force')
-        finally:
-            tree.unlock()
+        if new:
+            added = tree.changes_from(tree.basis_tree(),
+                specific_files=file_list).added
+            file_list = sorted([f[0] for f in added], reverse=True)
+            if len(file_list) == 0:
+                raise errors.BzrCommandError('No matching files.')
+        tree.remove(file_list, verbose=verbose, to_file=self.outf,
+            keep_files=file_deletion_strategy=='keep',
+            force=file_deletion_strategy=='force')
 
 
 class cmd_file_id(Command):
@@ -1240,6 +1228,7 @@
             last_revision = wt.last_revision()
 
         revision_ids = b.repository.get_ancestry(last_revision)
+        assert revision_ids[0] is None
         revision_ids.pop(0)
         for revision_id in revision_ids:
             self.outf.write(revision_id + '\n')
@@ -1265,7 +1254,7 @@
         bzr init
         bzr add .
         bzr status
-        bzr commit -m "imported project"
+        bzr commit -m 'imported project'
     """
 
     _see_also = ['init-repository', 'branch', 'checkout']
@@ -1334,10 +1323,6 @@
             except errors.UpgradeRequired:
                 raise errors.BzrCommandError('This branch format cannot be set'
                     ' to append-revisions-only.  Try --experimental-branch6')
-        if not is_quiet():
-            from bzrlib.info import show_bzrdir_info
-            show_bzrdir_info(bzrdir.BzrDir.open_containing_from_transport(
-                to_transport)[0], verbose=0, outfile=self.outf)
 
 
 class cmd_init_repository(Command):
@@ -1389,31 +1374,17 @@
         newdir = format.initialize_on_transport(to_transport)
         repo = newdir.create_repository(shared=True)
         repo.set_make_working_trees(not no_trees)
-        if not is_quiet():
-            from bzrlib.info import show_bzrdir_info
-            show_bzrdir_info(bzrdir.BzrDir.open_containing_from_transport(
-                to_transport)[0], verbose=0, outfile=self.outf)
 
 
 class cmd_diff(Command):
-    """Show differences in the working tree, between revisions or branches.
+    """Show differences in the working tree or between revisions.
     
-    If no arguments are given, all changes for the current tree are listed.
-    If files are given, only the changes in those files are listed.
-    Remote and multiple branches can be compared by using the --old and
-    --new options. If not provided, the default for both is derived from
-    the first argument, if any, or the current tree if no arguments are
-    given.
+    If files are listed, only the changes in those files are listed.
+    Otherwise, all changes for the tree are listed.
 
     "bzr diff -p1" is equivalent to "bzr diff --prefix old/:new/", and
     produces patches suitable for "patch -p1".
 
-    :Exit values:
-        1 - changed
-        2 - unrepresentable changes
-        3 - error
-        0 - no change
-
     :Examples:
         Shows the difference in the working tree versus the last commit::
 
@@ -1427,30 +1398,29 @@
 
             bzr diff -r1..2
 
-        Difference between revision 2 and revision 1 for branch xxx::
-
-            bzr diff -r1..2 xxx
-
-        Show just the differences for file NEWS::
-
-            bzr diff NEWS
-
-        Show the differences in working tree xxx for file NEWS::
-
-            bzr diff xxx/NEWS
-
-        Show the differences from branch xxx to this working tree:
-
-            bzr diff --old xxx
-
-        Show the differences between two branches for file NEWS::
-
-            bzr diff --old xxx --new yyy NEWS
-
         Same as 'bzr diff' but prefix paths with old/ and new/::
 
             bzr diff --prefix old/:new/
+
+        Show the differences between the two working trees::
+
+            bzr diff bzr.mine bzr.dev
+
+        Show just the differences for 'foo.c'::
+
+            bzr diff foo.c
     """
+    # TODO: Option to use external diff command; could be GNU diff, wdiff,
+    #       or a graphical diff.
+
+    # TODO: Python difflib is not exactly the same as unidiff; should
+    #       either fix it up or prefer to use an external diff.
+
+    # TODO: Selected-file diff is inefficient and doesn't show you
+    #       deleted files.
+
+    # TODO: This probably handles non-Unix newlines poorly.
+
     _see_also = ['status']
     takes_args = ['file*']
     takes_options = [
@@ -1460,28 +1430,16 @@
                short_name='p',
                help='Set prefixes added to old and new filenames, as '
                     'two values separated by a colon. (eg "old/:new/").'),
-        Option('old',
-            help='Branch/tree to compare from.',
-            type=unicode,
-            ),
-        Option('new',
-            help='Branch/tree to compare to.',
-            type=unicode,
-            ),
         'revision',
         'change',
-        Option('using',
-            help='Use this command to compare files.',
-            type=unicode,
-            ),
         ]
     aliases = ['di', 'dif']
     encoding_type = 'exact'
 
     @display_command
     def run(self, revision=None, file_list=None, diff_options=None,
-            prefix=None, old=None, new=None, using=None):
-        from bzrlib.diff import _get_trees_to_diff, show_diff_trees
+            prefix=None):
+        from bzrlib.diff import diff_cmd_helper, show_diff_trees
 
         if (prefix is None) or (prefix == '0'):
             # diff -p0 format
@@ -1501,13 +1459,47 @@
             raise errors.BzrCommandError('bzr diff --revision takes exactly'
                                          ' one or two revision specifiers')
 
-        old_tree, new_tree, specific_files, extra_trees = \
-                _get_trees_to_diff(file_list, revision, old, new)
-        return show_diff_trees(old_tree, new_tree, sys.stdout, 
-                               specific_files=specific_files,
-                               external_diff_options=diff_options,
-                               old_label=old_label, new_label=new_label,
-                               extra_trees=extra_trees, using=using)
+        try:
+            tree1, file_list = internal_tree_files(file_list)
+            tree2 = None
+            b = None
+            b2 = None
+        except errors.FileInWrongBranch:
+            if len(file_list) != 2:
+                raise errors.BzrCommandError("Files are in different branches")
+
+            tree1, file1 = WorkingTree.open_containing(file_list[0])
+            tree2, file2 = WorkingTree.open_containing(file_list[1])
+            if file1 != "" or file2 != "":
+                # FIXME diff those two files. rbc 20051123
+                raise errors.BzrCommandError("Files are in different branches")
+            file_list = None
+        except errors.NotBranchError:
+            if (revision is not None and len(revision) == 2
+                and not revision[0].needs_branch()
+                and not revision[1].needs_branch()):
+                # If both revision specs include a branch, we can
+                # diff them without needing a local working tree
+                tree1, tree2 = None, None
+            else:
+                raise
+
+        if tree2 is not None:
+            if revision is not None:
+                # FIXME: but there should be a clean way to diff between
+                # non-default versions of two trees, it's not hard to do
+                # internally...
+                raise errors.BzrCommandError(
+                        "Sorry, diffing arbitrary revisions across branches "
+                        "is not implemented yet")
+            return show_diff_trees(tree1, tree2, sys.stdout, 
+                                   specific_files=file_list,
+                                   external_diff_options=diff_options,
+                                   old_label=old_label, new_label=new_label)
+
+        return diff_cmd_helper(tree1, file_list, diff_options,
+                               revision_specs=revision,
+                               old_label=old_label, new_label=new_label)
 
 
 class cmd_deleted(Command):
@@ -1549,21 +1541,13 @@
 
     hidden = True
     _see_also = ['status', 'ls']
-    takes_options = [
-            Option('null',
-                   help='Write an ascii NUL (\\0) separator '
-                   'between files rather than a newline.')
-            ]
 
     @display_command
-    def run(self, null=False):
+    def run(self):
         tree = WorkingTree.open_containing(u'.')[0]
         td = tree.changes_from(tree.basis_tree())
         for path, id, kind, text_modified, meta_modified in td.modified:
-            if null:
-                self.outf.write(path + '\0')
-            else:
-                self.outf.write(osutils.quotefn(path) + '\n')
+            self.outf.write(path + '\n')
 
 
 class cmd_added(Command):
@@ -1572,14 +1556,9 @@
 
     hidden = True
     _see_also = ['status', 'ls']
-    takes_options = [
-            Option('null',
-                   help='Write an ascii NUL (\\0) separator '
-                   'between files rather than a newline.')
-            ]
 
     @display_command
-    def run(self, null=False):
+    def run(self):
         wt = WorkingTree.open_containing(u'.')[0]
         wt.lock_read()
         try:
@@ -1596,10 +1575,7 @@
                     path = inv.id2path(file_id)
                     if not os.access(osutils.abspath(path), os.F_OK):
                         continue
-                    if null:
-                        self.outf.write(path + '\0')
-                    else:
-                        self.outf.write(osutils.quotefn(path) + '\n')
+                    self.outf.write(path + '\n')
             finally:
                 basis.unlock()
         finally:
@@ -1671,7 +1647,6 @@
                         'regular expression.',
                    type=str),
             Option('limit',
-                   short_name='l',
                    help='Limit the output to the first N revisions.',
                    argname='N',
                    type=_parse_limit),
@@ -1688,6 +1663,8 @@
             message=None,
             limit=None):
         from bzrlib.log import show_log
+        assert message is None or isinstance(message, basestring), \
+            "invalid message argument %r" % message
         direction = (forward and 'forward') or 'reverse'
         
         # log everything
@@ -1800,8 +1777,7 @@
             Option('from-root',
                    help='Print paths relative to the root of the branch.'),
             Option('unknown', help='Print unknown files.'),
-            Option('versioned', help='Print versioned files.',
-                   short_name='V'),
+            Option('versioned', help='Print versioned files.'),
             Option('ignored', help='Print ignored files.'),
             Option('null',
                    help='Write an ascii NUL (\\0) separator '
@@ -1843,7 +1819,7 @@
             relpath += '/'
         if revision is not None:
             tree = branch.repository.revision_tree(
-                revision[0].as_revision_id(branch))
+                revision[0].in_history(branch).rev_id)
         elif tree is None:
             tree = branch.basis_tree()
 
@@ -1900,12 +1876,27 @@
 class cmd_ignore(Command):
     """Ignore specified files or patterns.
 
-    See ``bzr help patterns`` for details on the syntax of patterns.
-
     To remove patterns from the ignore list, edit the .bzrignore file.
-    After adding, editing or deleting that file either indirectly by
-    using this command or directly by using an editor, be sure to commit
-    it.
+
+    Trailing slashes on patterns are ignored. 
+    If the pattern contains a slash or is a regular expression, it is compared 
+    to the whole path from the branch root.  Otherwise, it is compared to only
+    the last component of the path.  To match a file only in the root 
+    directory, prepend './'.
+
+    Ignore patterns specifying absolute paths are not allowed.
+
+    Ignore patterns may include globbing wildcards such as::
+
+      ? - Matches any single character except '/'
+      * - Matches 0 or more characters except '/'
+      /**/ - Matches 0 or more directories in a path
+      [a-z] - Matches a single character from within a group of characters
+ 
+    Ignore patterns may also be Python regular expressions.  
+    Regular expression ignore patterns are identified by a 'RE:' prefix 
+    followed by the regular expression.  Regular expression ignore patterns
+    may not include named or numbered groups.
 
     Note: ignore patterns containing shell wildcards must be quoted from 
     the shell on Unix.
@@ -1917,22 +1908,18 @@
 
         Ignore class files in all directories::
 
-            bzr ignore "*.class"
-
-        Ignore .o files under the lib directory::
-
-            bzr ignore "lib/**/*.o"
-
-        Ignore .o files under the lib directory::
-
-            bzr ignore "RE:lib/.*\.o"
-
-        Ignore everything but the "debian" toplevel directory::
-
-            bzr ignore "RE:(?!debian/).*"
+            bzr ignore '*.class'
+
+        Ignore .o files under the lib directory::
+
+            bzr ignore 'lib/**/*.o'
+
+        Ignore .o files under the lib directory::
+
+            bzr ignore 'RE:lib/.*\.o'
     """
 
-    _see_also = ['status', 'ignored', 'patterns']
+    _see_also = ['status', 'ignored']
     takes_args = ['name_pattern*']
     takes_options = [
         Option('old-default-rules',
@@ -1940,7 +1927,7 @@
         ]
     
     def run(self, name_pattern_list=None, old_default_rules=None):
-        from bzrlib import ignores
+        from bzrlib.atomicfile import AtomicFile
         if old_default_rules is not None:
             # dump the rules and exit
             for pattern in ignores.OLD_DEFAULTS:
@@ -1957,7 +1944,34 @@
                 raise errors.BzrCommandError(
                     "NAME_PATTERN should not be an absolute path")
         tree, relpath = WorkingTree.open_containing(u'.')
-        ignores.tree_ignores_add_patterns(tree, name_pattern_list)
+        ifn = tree.abspath('.bzrignore')
+        if os.path.exists(ifn):
+            f = open(ifn, 'rt')
+            try:
+                igns = f.read().decode('utf-8')
+            finally:
+                f.close()
+        else:
+            igns = ''
+
+        # TODO: If the file already uses crlf-style termination, maybe
+        # we should use that for the newly added lines?
+
+        if igns and igns[-1] != '\n':
+            igns += '\n'
+        for name_pattern in name_pattern_list:
+            igns += name_pattern + '\n'
+
+        f = AtomicFile(ifn, 'wb')
+        try:
+            f.write(igns.encode('utf-8'))
+            f.commit()
+        finally:
+            f.close()
+
+        if not tree.path2id('.bzrignore'):
+            tree.add(['.bzrignore'])
+
         ignored = globbing.Globster(name_pattern_list)
         matches = []
         tree.lock_read()
@@ -1972,21 +1986,11 @@
             print "Warning: the following files are version controlled and" \
                   " match your ignore pattern:\n%s" % ("\n".join(matches),)
 
-
 class cmd_ignored(Command):
     """List ignored files and the patterns that matched them.
-
-    List all the ignored files and the ignore pattern that caused the file to
-    be ignored.
-
-    Alternatively, to list just the files::
-
-        bzr ls --ignored
     """
 
-    encoding_type = 'replace'
-    _see_also = ['ignore', 'ls']
-
+    _see_also = ['ignore']
     @display_command
     def run(self):
         tree = WorkingTree.open_containing(u'.')[0]
@@ -1997,7 +2001,7 @@
                     continue
                 ## XXX: Slightly inefficient since this was already calculated
                 pat = tree.is_ignored(path)
-                self.outf.write('%-50s %s\n' % (path, pat))
+                print '%-50s %s' % (path, pat)
         finally:
             tree.unlock()
 
@@ -2049,7 +2053,7 @@
          zip                          .zip
       =================       =========================
     """
-    takes_args = ['dest', 'branch_or_subdir?']
+    takes_args = ['dest', 'branch?']
     takes_options = [
         Option('format',
                help="Type of file to export to.",
@@ -2059,16 +2063,14 @@
                type=str,
                help="Name of the root directory inside the exported file."),
         ]
-    def run(self, dest, branch_or_subdir=None, revision=None, format=None,
-        root=None):
+    def run(self, dest, branch=None, revision=None, format=None, root=None):
         from bzrlib.export import export
 
-        if branch_or_subdir is None:
+        if branch is None:
             tree = WorkingTree.open_containing(u'.')[0]
             b = tree.branch
-            subdir = None
         else:
-            b, subdir = Branch.open_containing(branch_or_subdir)
+            b = Branch.open(branch)
             
         if revision is None:
             # should be tree.last_revision  FIXME
@@ -2076,10 +2078,10 @@
         else:
             if len(revision) != 1:
                 raise errors.BzrCommandError('bzr export --revision takes exactly 1 argument')
-            rev_id = revision[0].as_revision_id(b)
+            rev_id = revision[0].in_history(b).rev_id
         t = b.repository.revision_tree(rev_id)
         try:
-            export(t, dest, format, root, subdir)
+            export(t, dest, format, root)
         except errors.NoSuchExportFormat, e:
             raise errors.BzrCommandError('Unsupported export format: %s' % e.format)
 
@@ -2105,23 +2107,23 @@
     def run(self, filename, revision=None, name_from_revision=False):
         if revision is not None and len(revision) != 1:
             raise errors.BzrCommandError("bzr cat --revision takes exactly"
-                                         " one revision specifier")
-        tree, branch, relpath = \
-            bzrdir.BzrDir.open_containing_tree_or_branch(filename)
-        branch.lock_read()
+                                        " one number")
+
+        tree = None
         try:
-            return self._run(tree, branch, relpath, filename, revision,
-                             name_from_revision)
-        finally:
-            branch.unlock()
+            tree, b, relpath = \
+                    bzrdir.BzrDir.open_containing_tree_or_branch(filename)
+        except errors.NotBranchError:
+            pass
 
-    def _run(self, tree, b, relpath, filename, revision, name_from_revision):
+        if revision is not None and revision[0].get_branch() is not None:
+            b = Branch.open(revision[0].get_branch())
         if tree is None:
             tree = b.basis_tree()
         if revision is None:
             revision_id = b.last_revision()
         else:
-            revision_id = revision[0].as_revision_id(b)
+            revision_id = revision[0].in_history(b).rev_id
 
         cur_file_id = tree.path2id(relpath)
         rev_tree = b.repository.revision_tree(revision_id)
@@ -2132,15 +2134,14 @@
                 raise errors.BzrCommandError("%r is not present in revision %s"
                                                 % (filename, revision_id))
             else:
-                content = rev_tree.get_file_text(old_file_id)
+                rev_tree.print_file(old_file_id)
         elif cur_file_id is not None:
-            content = rev_tree.get_file_text(cur_file_id)
+            rev_tree.print_file(cur_file_id)
         elif old_file_id is not None:
-            content = rev_tree.get_file_text(old_file_id)
+            rev_tree.print_file(old_file_id)
         else:
             raise errors.BzrCommandError("%r is not present in revision %s" %
                                          (filename, revision_id))
-        self.outf.write(content)
 
 
 class cmd_local_time_offset(Command):
@@ -2161,12 +2162,6 @@
     committed.  If a directory is specified then the directory and everything 
     within it is committed.
 
-    When excludes are given, they take precedence over selected files.
-    For example, too commit only changes within foo, but not changes within
-    foo/bar::
-
-      bzr commit foo -x foo/bar
-
     If author of the change is not the same person as the committer, you can
     specify the author's name using the --author option. The name should be
     in the same format as a committer-id, e.g. "John Doe <jdoe@example.com>".
@@ -2202,8 +2197,6 @@
     _see_also = ['bugs', 'uncommit']
     takes_args = ['selected*']
     takes_options = [
-            ListOption('exclude', type=str, short_name='x',
-                help="Do not consider changes made to a given path."),
             Option('message', type=unicode,
                    short_name='m',
                    help="Description of the new revision."),
@@ -2219,7 +2212,7 @@
                     "files in the working tree."),
              ListOption('fixes', type=str,
                     help="Mark a bug as being fixed by this revision."),
-             Option('author', type=unicode,
+             Option('author', type=str,
                     help="Set the author's name, if it's different "
                          "from the committer."),
              Option('local',
@@ -2258,7 +2251,7 @@
 
     def run(self, message=None, file=None, verbose=False, selected_list=None,
             unchanged=False, strict=False, local=False, fixes=None,
-            author=None, show_diff=False, exclude=None):
+            author=None, show_diff=False):
         from bzrlib.errors import (
             PointlessCommit,
             ConflictsInTree,
@@ -2308,7 +2301,7 @@
                 raise errors.BzrCommandError(
                     "please specify either --message or --file")
             if file:
-                my_message = codecs.open(file, 'rt',
+                my_message = codecs.open(file, 'rt', 
                                          bzrlib.user_encoding).read()
             if my_message == "":
                 raise errors.BzrCommandError("empty commit message specified")
@@ -2319,8 +2312,7 @@
                         specific_files=selected_list,
                         allow_pointless=unchanged, strict=strict, local=local,
                         reporter=None, verbose=verbose, revprops=properties,
-                        author=author,
-                        exclude=safe_relpath_files(tree, exclude))
+                        author=author)
         except PointlessCommit:
             # FIXME: This should really happen before the file is read in;
             # perhaps prepare the commit; get the message; then actually commit
@@ -2341,13 +2333,12 @@
 
 
 class cmd_check(Command):
-    """Validate working tree structure, branch consistency and repository history.
-
-    This command checks various invariants about branch and repository storage
-    to detect data corruption or bzr bugs.
-
-    The working tree and branch checks will only give output if a problem is
-    detected. The output fields of the repository check are:
+    """Validate consistency of branch history.
+
+    This command checks various invariants about the branch storage to
+    detect data corruption or bzr bugs.
+
+    Output fields:
 
         revisions: This is just the number of revisions checked.  It doesn't
             indicate a problem.
@@ -2362,43 +2353,19 @@
             in the checked revisions.  Texts can be repeated when their file
             entries are modified, but the file contents are not.  It does not
             indicate a problem.
-
-    If no restrictions are specified, all Bazaar data that is found at the given
-    location will be checked.
-
-    :Examples:
-
-        Check the tree and branch at 'foo'::
-
-            bzr check --tree --branch foo
-
-        Check only the repository at 'bar'::
-
-            bzr check --repo bar
-
-        Check everything at 'baz'::
-
-            bzr check baz
     """
 
     _see_also = ['reconcile']
-    takes_args = ['path?']
-    takes_options = ['verbose',
-                     Option('branch', help="Check the branch related to the"
-                                           " current directory."),
-                     Option('repo', help="Check the repository related to the"
-                                         " current directory."),
-                     Option('tree', help="Check the working tree related to"
-                                         " the current directory.")]
+    takes_args = ['branch?']
+    takes_options = ['verbose']
 
-    def run(self, path=None, verbose=False, branch=False, repo=False,
-            tree=False):
-        from bzrlib.check import check_dwim
-        if path is None:
-            path = '.'
-        if not branch and not repo and not tree:
-            branch = repo = tree = True
-        check_dwim(path, verbose, do_branch=branch, do_repo=repo, do_tree=tree)
+    def run(self, branch=None, verbose=False):
+        from bzrlib.check import check
+        if branch is None:
+            branch = Branch.open_containing('.')[0]
+        else:
+            branch = Branch.open(branch)
+        check(branch, verbose)
 
 
 class cmd_upgrade(Command):
@@ -2437,7 +2404,7 @@
 
         Set the current user::
 
-            bzr whoami "Frank Chu <fchu@example.com>"
+            bzr whoami 'Frank Chu <fchu@example.com>'
     """
     takes_options = [ Option('email',
                              help='Display email address only.'),
@@ -2498,76 +2465,6 @@
         print branch.nick
 
 
-class cmd_alias(Command):
-    """Set/unset and display aliases.
-
-    :Examples:
-        Show the current aliases::
-
-            bzr alias
-
-        Show the alias specified for 'll'::
-
-            bzr alias ll
-
-        Set an alias for 'll'::
-
-            bzr alias ll="log --line -r-10..-1"
-
-        To remove an alias for 'll'::
-
-            bzr alias --remove ll
-
-    """
-    takes_args = ['name?']
-    takes_options = [
-        Option('remove', help='Remove the alias.'),
-        ]
-
-    def run(self, name=None, remove=False):
-        if remove:
-            self.remove_alias(name)
-        elif name is None:
-            self.print_aliases()
-        else:
-            equal_pos = name.find('=')
-            if equal_pos == -1:
-                self.print_alias(name)
-            else:
-                self.set_alias(name[:equal_pos], name[equal_pos+1:])
-
-    def remove_alias(self, alias_name):
-        if alias_name is None:
-            raise errors.BzrCommandError(
-                'bzr alias --remove expects an alias to remove.')
-        # If alias is not found, print something like:
-        # unalias: foo: not found
-        c = config.GlobalConfig()
-        c.unset_alias(alias_name)
-
-    @display_command
-    def print_aliases(self):
-        """Print out the defined aliases in a similar format to bash."""
-        aliases = config.GlobalConfig().get_aliases()
-        for key, value in sorted(aliases.iteritems()):
-            self.outf.write('bzr alias %s="%s"\n' % (key, value))
-
-    @display_command
-    def print_alias(self, alias_name):
-        from bzrlib.commands import get_alias
-        alias = get_alias(alias_name)
-        if alias is None:
-            self.outf.write("bzr alias: %s: not found\n" % alias_name)
-        else:
-            self.outf.write(
-                'bzr alias %s="%s"\n' % (alias_name, ' '.join(alias)))
-
-    def set_alias(self, alias_name, alias_command):
-        """Save the alias in the global config."""
-        c = config.GlobalConfig()
-        c.set_alias(alias_name, alias_command)
-
-
 class cmd_selftest(Command):
     """Run internal test suite.
     
@@ -2662,14 +2559,6 @@
                                  ' expression.'),
                      Option('strict', help='Fail on missing dependencies or '
                             'known failures.'),
-                     Option('load-list', type=str, argname='TESTLISTFILE',
-                            help='Load a test id list from a text file.'),
-                     ListOption('debugflag', type=str, short_name='E',
-                                help='Turn on a selftest debug flag.'),
-                     ListOption('starting-with', type=str, argname='TESTID',
-                                param_name='starting_with', short_name='s',
-                                help=
-                                'Load only the tests starting with TESTID.'),
                      ]
     encoding_type = 'replace'
 
@@ -2677,16 +2566,12 @@
             transport=None, benchmark=None,
             lsprof_timed=None, cache_dir=None,
             first=False, list_only=False,
-            randomize=None, exclude=None, strict=False,
-            load_list=None, debugflag=None, starting_with=None):
+            randomize=None, exclude=None, strict=False):
         import bzrlib.ui
         from bzrlib.tests import selftest
         import bzrlib.benchmarks as benchmarks
         from bzrlib.benchmarks import tree_creator
 
-        # Make deprecation warnings visible, unless -Werror is set
-        symbol_versioning.activate_deprecation_warnings(override=False)
-
         if cache_dir is not None:
             tree_creator.TreeCreator.CACHE_ROOT = osutils.abspath(cache_dir)
         if not list_only:
@@ -2694,7 +2579,7 @@
             print '   %s (%s python%s)' % (
                     bzrlib.__path__[0],
                     bzrlib.version_string,
-                    bzrlib._format_version_tuple(sys.version_info),
+                    '.'.join(map(str, sys.version_info)),
                     )
         print
         if testspecs_list is not None:
@@ -2723,17 +2608,14 @@
                               random_seed=randomize,
                               exclude_pattern=exclude,
                               strict=strict,
-                              load_list=load_list,
-                              debug_flags=debugflag,
-                              starting_with=starting_with,
                               )
         finally:
             if benchfile is not None:
                 benchfile.close()
         if result:
-            note('tests passed')
+            info('tests passed')
         else:
-            note('tests failed')
+            info('tests failed')
         return int(not result)
 
 
@@ -2741,17 +2623,11 @@
     """Show version of bzr."""
 
     encoding_type = 'replace'
-    takes_options = [
-        Option("short", help="Print just the version number."),
-        ]
 
     @display_command
-    def run(self, short=False):
+    def run(self):
         from bzrlib.version import show_version
-        if short:
-            self.outf.write(bzrlib.version_string + '\n')
-        else:
-            show_version(to_file=self.outf)
+        show_version(to_file=self.outf)
 
 
 class cmd_rocks(Command):
@@ -2777,37 +2653,24 @@
         
         branch1 = Branch.open_containing(branch)[0]
         branch2 = Branch.open_containing(other)[0]
-        branch1.lock_read()
-        try:
-            branch2.lock_read()
-            try:
-                last1 = ensure_null(branch1.last_revision())
-                last2 = ensure_null(branch2.last_revision())
-
-                graph = branch1.repository.get_graph(branch2.repository)
-                base_rev_id = graph.find_unique_lca(last1, last2)
-
-                print 'merge base is revision %s' % base_rev_id
-            finally:
-                branch2.unlock()
-        finally:
-            branch1.unlock()
+
+        last1 = ensure_null(branch1.last_revision())
+        last2 = ensure_null(branch2.last_revision())
+
+        graph = branch1.repository.get_graph(branch2.repository)
+        base_rev_id = graph.find_unique_lca(last1, last2)
+
+        print 'merge base is revision %s' % base_rev_id
 
 
 class cmd_merge(Command):
     """Perform a three-way merge.
     
-    The source of the merge can be specified either in the form of a branch,
-    or in the form of a path to a file containing a merge directive generated
-    with bzr send. If neither is specified, the default is the upstream branch
-    or the branch most recently merged using --remember.
-
-    When merging a branch, by default the tip will be merged. To pick a different
-    revision, pass --revision. If you specify two values, the first will be used as
-    BASE and the second one as OTHER. Merging individual revisions, or a subset of
-    available revisions, like this is commonly referred to as "cherrypicking".
-
-    Revision numbers are always relative to the branch being merged.
+    The branch is the branch you will merge from.  By default, it will merge
+    the latest revision.  If you specify a revision, that revision will be
+    merged.  If you specify two revisions, the first will be used as a BASE,
+    and the second one as OTHER.  Revision numbers are always relative to the
+    specified branch.
 
     By default, bzr will try to merge in all new work from the other
     branch, automatically determining an appropriate base.  If this
@@ -2844,15 +2707,10 @@
         To merge the changes introduced by 82, without previous changes::
 
             bzr merge -r 81..82 ../bzr.dev
-
-        To apply a merge directive contained in in /tmp/merge:
-
-            bzr merge /tmp/merge
     """
 
-    encoding_type = 'exact'
     _see_also = ['update', 'remerge', 'status-flags']
-    takes_args = ['location?']
+    takes_args = ['branch?']
     takes_options = [
         'change',
         'revision',
@@ -2875,15 +2733,17 @@
                short_name='d',
                type=unicode,
                ),
-        Option('preview', help='Instead of merging, show a diff of the merge.')
     ]
 
-    def run(self, location=None, revision=None, force=False,
-            merge_type=None, show_base=False, reprocess=False, remember=False,
+    def run(self, branch=None, revision=None, force=False, merge_type=None,
+            show_base=False, reprocess=False, remember=False,
             uncommitted=False, pull=False,
             directory=None,
-            preview=False,
             ):
+        # This is actually a branch (or merge-directive) *location*.
+        location = branch
+        del branch
+
         if merge_type is None:
             merge_type = _mod_merge.Merge3Merger
 
@@ -2902,12 +2762,8 @@
             tree.lock_write()
             cleanups.append(tree.unlock)
             if location is not None:
-                try:
-                    mergeable = bundle.read_mergeable_from_url(location,
-                        possible_transports=possible_transports)
-                except errors.NotABundle:
-                    mergeable = None
-                else:
+                mergeable, other_transport = _get_mergeable_helper(location)
+                if mergeable:
                     if uncommitted:
                         raise errors.BzrCommandError('Cannot use --uncommitted'
                             ' with bundles or merge directives.')
@@ -2917,6 +2773,7 @@
                             'Cannot use -r with merge directives or bundles')
                     merger, verified = _mod_merge.Merger.from_mergeable(tree,
                        mergeable, pb)
+                possible_transports.append(other_transport)
 
             if merger is None and uncommitted:
                 if revision is not None and len(revision) > 0:
@@ -2927,8 +2784,6 @@
                 merger = _mod_merge.Merger.from_uncommitted(tree, other_tree,
                     pb)
                 allow_pending = False
-                if other_path != '':
-                    merger.interesting_files = [other_path]
 
             if merger is None:
                 merger, allow_pending = self._get_merger_from_branch(tree,
@@ -2937,9 +2792,10 @@
             merger.merge_type = merge_type
             merger.reprocess = reprocess
             merger.show_base = show_base
+            merger.change_reporter = change_reporter
             self.sanity_check_merger(merger)
             if (merger.base_rev_id == merger.other_rev_id and
-                merger.other_rev_id is not None):
+                merger.other_rev_id != None):
                 note('Nothing to do.')
                 return 0
             if pull:
@@ -2951,38 +2807,19 @@
                     result.report(self.outf)
                     return 0
             merger.check_basis(not force)
-            if preview:
-                return self._do_preview(merger)
+            conflict_count = merger.do_merge()
+            if allow_pending:
+                merger.set_pending()
+            if verified == 'failed':
+                warning('Preview patch does not match changes')
+            if conflict_count != 0:
+                return 1
             else:
-                return self._do_merge(merger, change_reporter, allow_pending,
-                                      verified)
+                return 0
         finally:
             for cleanup in reversed(cleanups):
                 cleanup()
 
-    def _do_preview(self, merger):
-        from bzrlib.diff import show_diff_trees
-        tree_merger = merger.make_merger()
-        tt = tree_merger.make_preview_transform()
-        try:
-            result_tree = tt.get_preview_tree()
-            show_diff_trees(merger.this_tree, result_tree, self.outf,
-                            old_label='', new_label='')
-        finally:
-            tt.finalize()
-
-    def _do_merge(self, merger, change_reporter, allow_pending, verified):
-        merger.change_reporter = change_reporter
-        conflict_count = merger.do_merge()
-        if allow_pending:
-            merger.set_pending()
-        if verified == 'failed':
-            warning('Preview patch does not match changes')
-        if conflict_count != 0:
-            return 1
-        else:
-            return 0
-
     def sanity_check_merger(self, merger):
         if (merger.show_base and
             not merger.merge_type is _mod_merge.Merge3Merger):
@@ -3000,12 +2837,13 @@
                                 possible_transports, pb):
         """Produce a merger from a location, assuming it refers to a branch."""
         from bzrlib.tag import _merge_tags_if_possible
+        assert revision is None or len(revision) < 3
         # find the branch locations
-        other_loc, user_location = self._select_branch_location(tree, location,
+        other_loc, location = self._select_branch_location(tree, location,
             revision, -1)
         if revision is not None and len(revision) == 2:
-            base_loc, _unused = self._select_branch_location(tree,
-                location, revision, 0)
+            base_loc, location = self._select_branch_location(tree, location,
+                                                              revision, 0)
         else:
             base_loc = other_loc
         # Open the branches
@@ -3021,16 +2859,20 @@
             other_revision_id = _mod_revision.ensure_null(
                 other_branch.last_revision())
         else:
-            other_revision_id = revision[-1].as_revision_id(other_branch)
+            other_revision_id = \
+                _mod_revision.ensure_null(
+                    revision[-1].in_history(other_branch).rev_id)
         if (revision is not None and len(revision) == 2
             and revision[0] is not None):
-            base_revision_id = revision[0].as_revision_id(base_branch)
+            base_revision_id = \
+                _mod_revision.ensure_null(
+                    revision[0].in_history(base_branch).rev_id)
         else:
             base_revision_id = None
         # Remember where we merge from
-        if ((remember or tree.branch.get_submit_branch() is None) and
-             user_location is not None):
-            tree.branch.set_submit_branch(other_branch.base)
+        if ((tree.branch.get_parent() is None or remember) and
+            other_branch is not None):
+            tree.branch.set_parent(other_branch.base)
         _merge_tags_if_possible(other_branch, tree.branch)
         merger = _mod_merge.Merger.from_revision_ids(pb, tree,
             other_revision_id, base_revision_id, other_branch, base_branch)
@@ -3041,7 +2883,7 @@
             allow_pending = True
         return merger, allow_pending
 
-    def _select_branch_location(self, tree, user_location, revision=None,
+    def _select_branch_location(self, tree, location, revision=None,
                                 index=None):
         """Select a branch location, according to possible inputs.
 
@@ -3049,43 +2891,41 @@
         ``revision`` and ``index`` must be supplied.)
 
         Otherwise, the ``location`` parameter is used.  If it is None, then the
-        ``submit`` or ``parent`` location is used, and a note is printed.
+        ``parent`` location is used, and a note is printed.
 
         :param tree: The working tree to select a branch for merging into
         :param location: The location entered by the user
         :param revision: The revision parameter to the command
         :param index: The index to use for the revision parameter.  Negative
             indices are permitted.
-        :return: (selected_location, user_location).  The default location
-            will be the user-entered location.
+        :return: (selected_location, default_location).  The default location
+            will be the user-entered location, if any, or else the remembered
+            location.
         """
         if (revision is not None and index is not None
             and revision[index] is not None):
             branch = revision[index].get_branch()
             if branch is not None:
-                return branch, branch
-        if user_location is None:
-            location = self._get_remembered(tree, 'Merging from')
-        else:
-            location = user_location
-        return location, user_location
+                return branch, location
+        location = self._get_remembered_parent(tree, location, 'Merging from')
+        return location, location
 
-    def _get_remembered(self, tree, verb_string):
+    # TODO: move up to common parent; this isn't merge-specific anymore. 
+    def _get_remembered_parent(self, tree, supplied_location, verb_string):
         """Use tree.branch's parent if none was supplied.
 
         Report if the remembered location was used.
         """
-        stored_location = tree.branch.get_submit_branch()
-        stored_location_type = "submit"
-        if stored_location is None:
-            stored_location = tree.branch.get_parent()
-            stored_location_type = "parent"
+        if supplied_location is not None:
+            return supplied_location
+        stored_location = tree.branch.get_parent()
         mutter("%s", stored_location)
         if stored_location is None:
             raise errors.BzrCommandError("No location specified or remembered")
-        display_url = urlutils.unescape_for_display(stored_location, 'utf-8')
-        note(u"%s remembered %s location %s", verb_string,
-                stored_location_type, display_url)
+        display_url = urlutils.unescape_for_display(stored_location,
+            self.outf.encoding)
+        self.outf.write("%s remembered location %s\n" % (verb_string,
+            display_url))
         return stored_location
 
 
@@ -3132,6 +2972,10 @@
                                              " merges.  Not cherrypicking or"
                                              " multi-merges.")
             repository = tree.branch.repository
+            graph = repository.get_graph()
+            base_revision = graph.find_unique_lca(parents[0], parents[1])
+            base_tree = repository.revision_tree(base_revision)
+            other_tree = repository.revision_tree(parents[1])
             interesting_ids = None
             new_conflicts = []
             conflicts = tree.conflicts()
@@ -3167,19 +3011,18 @@
             # list, we imply that the working tree text has seen and rejected
             # all the changes from the other tree, when in fact those changes
             # have not yet been seen.
-            pb = ui.ui_factory.nested_progress_bar()
             tree.set_parent_ids(parents[:1])
             try:
-                merger = _mod_merge.Merger.from_revision_ids(pb,
-                                                             tree, parents[1])
-                merger.interesting_ids = interesting_ids
-                merger.merge_type = merge_type
-                merger.show_base = show_base
-                merger.reprocess = reprocess
-                conflicts = merger.do_merge()
+                conflicts = _mod_merge.merge_inner(
+                                          tree.branch, other_tree, base_tree,
+                                          this_tree=tree,
+                                          interesting_ids=interesting_ids,
+                                          other_rev_id=parents[1],
+                                          merge_type=merge_type,
+                                          show_base=show_base,
+                                          reprocess=reprocess)
             finally:
                 tree.set_parent_ids(parents)
-                pb.finished()
         finally:
             tree.unlock()
         if conflicts > 0:
@@ -3196,9 +3039,9 @@
     last committed revision is used.
 
     To remove only some changes, without reverting to a prior version, use
-    merge instead.  For example, "merge . --revision -2..-3" will remove the
-    changes introduced by -2, without affecting the changes introduced by -1.
-    Or to remove certain changes on a hunk-by-hunk basis, see the Shelf plugin.
+    merge instead.  For example, "merge . --r-2..-3" will remove the changes
+    introduced by -2, without affecting the changes introduced by -1.  Or
+    to remove certain changes on a hunk-by-hunk basis, see the Shelf plugin.
     
     By default, any files that have been manually changed will be backed up
     first.  (Files changed only by merge are not backed up.)  Backup files have
@@ -3215,8 +3058,8 @@
 
     The working tree contains a list of pending merged revisions, which will
     be included as parents in the next commit.  Normally, revert clears that
-    list as well as reverting the files.  If any files are specified, revert
-    leaves the pending merge list alone and reverts only the files.  Use "bzr
+    list as well as reverting the files.  If any files, are specified, revert
+    leaves the pending merge list alnone and reverts only the files.  Use "bzr
     revert ." in the tree root to revert all files but keep the merge record,
     and "bzr revert --forget-merges" to clear the pending merge list without
     reverting any files.
@@ -3246,7 +3089,7 @@
         elif len(revision) != 1:
             raise errors.BzrCommandError('bzr revert --revision takes exactly 1 argument')
         else:
-            rev_id = revision[0].as_revision_id(tree.branch)
+            rev_id = revision[0].in_history(tree.branch).rev_id
         pb = ui.ui_factory.nested_progress_bar()
         try:
             tree.revert(file_list,
@@ -3300,6 +3143,20 @@
         shellcomplete.shellcomplete(context)
 
 
+class cmd_fetch(Command):
+    """Copy in history from another branch but don't merge it.
+
+    This is an internal method used for pull and merge.
+    """
+    hidden = True
+    takes_args = ['from_branch', 'to_branch']
+    def run(self, from_branch, to_branch):
+        from bzrlib.fetch import Fetcher
+        from_b = Branch.open(from_branch)
+        to_b = Branch.open(to_branch)
+        Fetcher(to_b, from_b)
+
+
 class cmd_missing(Command):
     """Show unmerged/unpulled revisions between two branches.
     
@@ -3329,17 +3186,9 @@
         from bzrlib.missing import find_unmerged, iter_log_revisions
 
         if this:
-            mine_only = this
+          mine_only = this
         if other:
-            theirs_only = other
-        # TODO: We should probably check that we don't have mine-only and
-        #       theirs-only set, but it gets complicated because we also have
-        #       this and other which could be used.
-        restrict = 'all'
-        if mine_only:
-            restrict = 'local'
-        elif theirs_only:
-            restrict = 'remote'
+          theirs_only = other
 
         local_branch = Branch.open_containing(u".")[0]
         parent = local_branch.get_parent()
@@ -3350,8 +3199,7 @@
                                              " or specified.")
             display_url = urlutils.unescape_for_display(parent,
                                                         self.outf.encoding)
-            self.outf.write("Using saved parent location: "
-                    + display_url + "\n")
+            self.outf.write("Using last location: " + display_url + "\n")
 
         remote_branch = Branch.open(other_branch)
         if remote_branch.base == local_branch.base:
@@ -3360,9 +3208,8 @@
         try:
             remote_branch.lock_read()
             try:
-                local_extra, remote_extra = find_unmerged(
-                    local_branch, remote_branch, restrict)
-
+                local_extra, remote_extra = find_unmerged(local_branch,
+                                                          remote_branch)
                 if log_format is None:
                     registry = log.log_formatter_registry
                     log_format = registry.get_default(local_branch)
@@ -3370,12 +3217,8 @@
                                 show_ids=show_ids,
                                 show_timezone='original')
                 if reverse is False:
-                    if local_extra is not None:
-                        local_extra.reverse()
-                    if remote_extra is not None:
-                        remote_extra.reverse()
-
-                status_code = 0
+                    local_extra.reverse()
+                    remote_extra.reverse()
                 if local_extra and not theirs_only:
                     self.outf.write("You have %d extra revision(s):\n" %
                                     len(local_extra))
@@ -3384,10 +3227,8 @@
                                         verbose):
                         lf.log_revision(revision)
                     printed_local = True
-                    status_code = 1
                 else:
                     printed_local = False
-
                 if remote_extra and not mine_only:
                     if printed_local is True:
                         self.outf.write("\n\n\n")
@@ -3397,19 +3238,11 @@
                                         remote_branch.repository,
                                         verbose):
                         lf.log_revision(revision)
-                    status_code = 1
-
-                if mine_only and not local_extra:
-                    # We checked local, and found nothing extra
-                    self.outf.write('This branch is up to date.\n')
-                elif theirs_only and not remote_extra:
-                    # We checked remote, and found nothing extra
-                    self.outf.write('Other branch is up to date.\n')
-                elif not (mine_only or theirs_only or local_extra or
-                          remote_extra):
-                    # We checked both branches, and neither one had extra
-                    # revisions
+                if not remote_extra and not local_extra:
+                    status_code = 0
                     self.outf.write("Branches are up to date.\n")
+                else:
+                    status_code = 1
             finally:
                 remote_branch.unlock()
         finally:
@@ -3444,10 +3277,8 @@
 class cmd_plugins(Command):
     """List the installed plugins.
     
-    This command displays the list of installed plugins including
-    version of plugin and a short description of each.
-
-    --verbose shows the path where each plugin is located.
+    This command displays the list of installed plugins including the
+    path where each one is located and a short description of each.
 
     A plugin is an external component for Bazaar that extends the
     revision control system, by adding or replacing code in Bazaar.
@@ -3460,30 +3291,16 @@
     install them. Instructions are also provided there on how to
     write new plugins using the Python programming language.
     """
-    takes_options = ['verbose']
 
     @display_command
-    def run(self, verbose=False):
+    def run(self):
         import bzrlib.plugin
         from inspect import getdoc
-        result = []
         for name, plugin in bzrlib.plugin.plugins().items():
-            version = plugin.__version__
-            if version == 'unknown':
-                version = ''
-            name_ver = '%s %s' % (name, version)
+            print plugin.path(), "[%s]" % plugin.__version__
             d = getdoc(plugin.module)
             if d:
-                doc = d.split('\n')[0]
-            else:
-                doc = '(no description)'
-            result.append((name_ver, doc, plugin.path()))
-        for name_ver, doc, path in sorted(result):
-            print name_ver
-            print '   ', doc
-            if verbose:
-                print '   ', path
-            print
+                print '\t', d.split('\n')[0]
 
 
 class cmd_testament(Command):
@@ -3501,16 +3318,13 @@
             testament_class = StrictTestament
         else:
             testament_class = Testament
-        if branch == '.':
-            b = Branch.open_containing(branch)[0]
-        else:
-            b = Branch.open(branch)
+        b = WorkingTree.open_containing(branch)[0].branch
         b.lock_read()
         try:
             if revision is None:
                 rev_id = b.last_revision()
             else:
-                rev_id = revision[0].as_revision_id(b)
+                rev_id = revision[0].in_history(b).rev_id
             t = testament_class.from_revision(b.repository, rev_id)
             if long:
                 sys.stdout.writelines(t.as_text_lines())
@@ -3545,34 +3359,25 @@
     def run(self, filename, all=False, long=False, revision=None,
             show_ids=False):
         from bzrlib.annotate import annotate_file
-        wt, branch, relpath = \
-            bzrdir.BzrDir.open_containing_tree_or_branch(filename)
-        if wt is not None:
-            wt.lock_read()
-        else:
-            branch.lock_read()
+        tree, relpath = WorkingTree.open_containing(filename)
+        branch = tree.branch
+        branch.lock_read()
         try:
             if revision is None:
                 revision_id = branch.last_revision()
             elif len(revision) != 1:
                 raise errors.BzrCommandError('bzr annotate --revision takes exactly 1 argument')
             else:
-                revision_id = revision[0].as_revision_id(branch)
-            tree = branch.repository.revision_tree(revision_id)
-            if wt is not None:
-                file_id = wt.path2id(relpath)
-            else:
-                file_id = tree.path2id(relpath)
+                revision_id = revision[0].in_history(branch).rev_id
+            file_id = tree.path2id(relpath)
             if file_id is None:
                 raise errors.NotVersionedError(filename)
+            tree = branch.repository.revision_tree(revision_id)
             file_version = tree.inventory[file_id].revision
             annotate_file(branch, file_version, file_id, long, all, self.outf,
                           show_ids=show_ids)
         finally:
-            if wt is not None:
-                wt.unlock()
-            else:
-                branch.unlock()
+            branch.unlock()
 
 
 class cmd_re_sign(Command):
@@ -3584,41 +3389,20 @@
     takes_options = ['revision']
     
     def run(self, revision_id_list=None, revision=None):
+        import bzrlib.gpg as gpg
         if revision_id_list is not None and revision is not None:
             raise errors.BzrCommandError('You can only supply one of revision_id or --revision')
         if revision_id_list is None and revision is None:
             raise errors.BzrCommandError('You must supply either --revision or a revision_id')
         b = WorkingTree.open_containing(u'.')[0].branch
-        b.lock_write()
-        try:
-            return self._run(b, revision_id_list, revision)
-        finally:
-            b.unlock()
-
-    def _run(self, b, revision_id_list, revision):
-        import bzrlib.gpg as gpg
         gpg_strategy = gpg.GPGStrategy(b.get_config())
         if revision_id_list is not None:
-            b.repository.start_write_group()
-            try:
-                for revision_id in revision_id_list:
-                    b.repository.sign_revision(revision_id, gpg_strategy)
-            except:
-                b.repository.abort_write_group()
-                raise
-            else:
-                b.repository.commit_write_group()
+            for revision_id in revision_id_list:
+                b.repository.sign_revision(revision_id, gpg_strategy)
         elif revision is not None:
             if len(revision) == 1:
                 revno, rev_id = revision[0].in_history(b)
-                b.repository.start_write_group()
-                try:
-                    b.repository.sign_revision(rev_id, gpg_strategy)
-                except:
-                    b.repository.abort_write_group()
-                    raise
-                else:
-                    b.repository.commit_write_group()
+                b.repository.sign_revision(rev_id, gpg_strategy)
             elif len(revision) == 2:
                 # are they both on rh- if so we can walk between them
                 # might be nice to have a range helper for arbitrary
@@ -3629,16 +3413,9 @@
                     to_revno = b.revno()
                 if from_revno is None or to_revno is None:
                     raise errors.BzrCommandError('Cannot sign a range of non-revision-history revisions')
-                b.repository.start_write_group()
-                try:
-                    for revno in range(from_revno, to_revno + 1):
-                        b.repository.sign_revision(b.get_rev_id(revno),
-                                                   gpg_strategy)
-                except:
-                    b.repository.abort_write_group()
-                    raise
-                else:
-                    b.repository.commit_write_group()
+                for revno in range(from_revno, to_revno + 1):
+                    b.repository.sign_revision(b.get_rev_id(revno), 
+                                               gpg_strategy)
             else:
                 raise errors.BzrCommandError('Please supply either one revision, or a range.')
 
@@ -3702,9 +3479,8 @@
     specified revision.  For example, "bzr uncommit -r 15" will leave the
     branch at revision 15.
 
-    Uncommit leaves the working tree ready for a new commit.  The only change
-    it may make is to restore any pending merges that were present before
-    the commit.
+    In the future, uncommit will create a revision bundle, which can then
+    be re-applied.
     """
 
     # TODO: jam 20060108 Add an option to allow uncommit to remove
@@ -3714,19 +3490,16 @@
     _see_also = ['commit']
     takes_options = ['verbose', 'revision',
                     Option('dry-run', help='Don\'t actually make changes.'),
-                    Option('force', help='Say yes to all questions.'),
-                    Option('local',
-                           help="Only remove the commits from the local branch"
-                                " when in a checkout."
-                           ),
-                    ]
+                    Option('force', help='Say yes to all questions.')]
     takes_args = ['location?']
     aliases = []
-    encoding_type = 'replace'
 
     def run(self, location=None,
             dry_run=False, verbose=False,
-            revision=None, force=False, local=False):
+            revision=None, force=False):
+        from bzrlib.log import log_formatter, show_log
+        from bzrlib.uncommit import uncommit
+
         if location is None:
             location = u'.'
         control, relpath = bzrdir.BzrDir.open_containing(location)
@@ -3737,40 +3510,20 @@
             tree = None
             b = control.open_branch()
 
-        if tree is not None:
-            tree.lock_write()
-        else:
-            b.lock_write()
-        try:
-            return self._run(b, tree, dry_run, verbose, revision, force,
-                             local=local)
-        finally:
-            if tree is not None:
-                tree.unlock()
-            else:
-                b.unlock()
-
-    def _run(self, b, tree, dry_run, verbose, revision, force, local=False):
-        from bzrlib.log import log_formatter, show_log
-        from bzrlib.uncommit import uncommit
-
-        last_revno, last_rev_id = b.last_revision_info()
-
         rev_id = None
         if revision is None:
-            revno = last_revno
-            rev_id = last_rev_id
+            revno = b.revno()
         else:
             # 'bzr uncommit -r 10' actually means uncommit
             # so that the final tree is at revno 10.
             # but bzrlib.uncommit.uncommit() actually uncommits
             # the revisions that are supplied.
             # So we need to offset it by one
-            revno = revision[0].in_history(b).revno + 1
-            if revno <= last_revno:
-                rev_id = b.get_rev_id(revno)
+            revno = revision[0].in_history(b).revno+1
 
-        if rev_id is None or _mod_revision.is_null(rev_id):
+        if revno <= b.revno():
+            rev_id = b.get_rev_id(revno)
+        if rev_id is None:
             self.outf.write('No revisions to uncommit.\n')
             return 1
 
@@ -3783,7 +3536,7 @@
                  verbose=False,
                  direction='forward',
                  start_revision=revno,
-                 end_revision=last_revno)
+                 end_revision=b.revno())
 
         if dry_run:
             print 'Dry-run, pretending to remove the above revisions.'
@@ -3797,12 +3550,8 @@
                     print 'Canceled'
                     return 0
 
-        mutter('Uncommitting from {%s} to {%s}',
-               last_rev_id, rev_id)
         uncommit(b, tree=tree, dry_run=dry_run, verbose=verbose,
-                 revno=revno, local=local)
-        note('You can restore the old tip by running:\n'
-             '  bzr pull . -r revid:%s', last_rev_id)
+                revno=revno)
 
 
 class cmd_break_lock(Command):
@@ -3867,10 +3616,10 @@
         ]
 
     def run(self, port=None, inet=False, directory=None, allow_writes=False):
-        from bzrlib import lockdir
         from bzrlib.smart import medium, server
         from bzrlib.transport import get_transport
         from bzrlib.transport.chroot import ChrootServer
+        from bzrlib.transport.remote import BZR_DEFAULT_PORT, BZR_DEFAULT_INTERFACE
         if directory is None:
             directory = os.getcwd()
         url = urlutils.local_path_to_url(directory)
@@ -3883,9 +3632,9 @@
             smart_server = medium.SmartServerPipeStreamMedium(
                 sys.stdin, sys.stdout, t)
         else:
-            host = medium.BZR_DEFAULT_INTERFACE
+            host = BZR_DEFAULT_INTERFACE
             if port is None:
-                port = medium.BZR_DEFAULT_PORT
+                port = BZR_DEFAULT_PORT
             else:
                 if ':' in port:
                     host, port = port.split(':')
@@ -3898,14 +3647,11 @@
         # be changed with care though, as we dont want to use bandwidth sending
         # progress over stderr to smart server clients!
         old_factory = ui.ui_factory
-        old_lockdir_timeout = lockdir._DEFAULT_TIMEOUT_SECONDS
         try:
             ui.ui_factory = ui.SilentUIFactory()
-            lockdir._DEFAULT_TIMEOUT_SECONDS = 0
             smart_server.serve()
         finally:
             ui.ui_factory = old_factory
-            lockdir._DEFAULT_TIMEOUT_SECONDS = old_lockdir_timeout
 
 
 class cmd_join(Command):
@@ -3963,21 +3709,23 @@
 
 
 class cmd_split(Command):
-    """Split a subdirectory of a tree into a separate tree.
+    """Split a tree into two trees.
 
-    This command will produce a target tree in a format that supports
-    rich roots, like 'rich-root' or 'rich-root-pack'.  These formats cannot be
-    converted into earlier formats like 'dirstate-tags'.
+    This command is for experimental use only.  It requires the target tree
+    to be in dirstate-with-subtree format, which cannot be converted into
+    earlier formats.
 
     The TREE argument should be a subdirectory of a working tree.  That
     subdirectory will be converted into an independent tree, with its own
     branch.  Commits in the top-level tree will not apply to the new subtree.
+    If you want that behavior, do "bzr join --reference TREE".
     """
 
-    # join is not un-hidden yet
-    #_see_also = ['join']
+    _see_also = ['join']
     takes_args = ['tree']
 
+    hidden = True
+
     def run(self, tree):
         containing_tree, subdir = WorkingTree.open_containing(tree)
         sub_id = containing_tree.path2id(subdir)
@@ -3989,6 +3737,7 @@
             raise errors.UpgradeRequired(containing_tree.branch.base)
 
 
+
 class cmd_merge_directive(Command):
     """Generate a merge directive for auto-merge tools.
 
@@ -4063,9 +3812,10 @@
             if len(revision) > 2:
                 raise errors.BzrCommandError('bzr merge-directive takes '
                     'at most two one revision identifiers')
-            revision_id = revision[-1].as_revision_id(branch)
+            revision_id = revision[-1].in_history(branch).rev_id
             if len(revision) == 2:
-                base_revision_id = revision[0].as_revision_id(branch)
+                base_revision_id = revision[0].in_history(branch).rev_id
+                base_revision_id = ensure_null(base_revision_id)
         else:
             revision_id = branch.last_revision()
         revision_id = ensure_null(revision_id)
@@ -4115,32 +3865,28 @@
     for that mirror.
 
     Mail is sent using your preferred mail program.  This should be transparent
-    on Windows (it uses MAPI).  On Linux, it requires the xdg-email utility.
-    If the preferred client can't be found (or used), your editor will be used.
+    on Windows (it uses MAPI).  On *nix, it requires the xdg-email utility.  If
+    the preferred client can't be found (or used), your editor will be used.
     
     To use a specific mail program, set the mail_client configuration option.
     (For Thunderbird 1.5, this works around some bugs.)  Supported values for
     specific clients are "evolution", "kmail", "mutt", and "thunderbird";
-    generic options are "default", "editor", "emacsclient", "mapi", and
-    "xdg-email".  Plugins may also add supported clients.
+    generic options are "default", "editor", "mapi", and "xdg-email".
 
     If mail is being sent, a to address is required.  This can be supplied
-    either on the commandline, by setting the submit_to configuration
-    option in the branch itself or the child_submit_to configuration option 
-    in the submit branch.
+    either on the commandline, or by setting the submit_to configuration
+    option.
 
     Two formats are currently supported: "4" uses revision bundle format 4 and
     merge directive format 2.  It is significantly faster and smaller than
     older formats.  It is compatible with Bazaar 0.19 and later.  It is the
     default.  "0.9" uses revision bundle format 0.9 and merge directive
     format 1.  It is compatible with Bazaar 0.12 - 0.18.
-    
-    Merge directives are applied using the merge command or the pull command.
     """
 
     encoding_type = 'exact'
 
-    _see_also = ['merge', 'pull']
+    _see_also = ['merge']
 
     takes_args = ['submit_branch?', 'public_branch?']
 
@@ -4156,9 +3902,7 @@
                'rather than the one containing the working directory.',
                short_name='f',
                type=unicode),
-        Option('output', short_name='o',
-               help='Write merge directive to this file; '
-                    'use - for stdout.',
+        Option('output', short_name='o', help='Write directive to this file.',
                type=unicode),
         Option('mail-to', help='Mail the request to this address.',
                type=unicode),
@@ -4180,47 +3924,41 @@
     def _run(self, submit_branch, revision, public_branch, remember, format,
              no_bundle, no_patch, output, from_, mail_to, message):
         from bzrlib.revision import NULL_REVISION
-        branch = Branch.open_containing(from_)[0]
         if output is None:
             outfile = StringIO()
         elif output == '-':
             outfile = self.outf
         else:
             outfile = open(output, 'wb')
-        # we may need to write data into branch's repository to calculate
-        # the data to send.
-        branch.lock_write()
         try:
+            branch = Branch.open_containing(from_)[0]
             if output is None:
                 config = branch.get_config()
                 if mail_to is None:
                     mail_to = config.get_user_option('submit_to')
+                if mail_to is None:
+                    raise errors.BzrCommandError('No mail-to address'
+                                                 ' specified')
                 mail_client = config.get_mail_client()
             if remember and submit_branch is None:
                 raise errors.BzrCommandError(
                     '--remember requires a branch to be specified.')
             stored_submit_branch = branch.get_submit_branch()
-            remembered_submit_branch = None
+            remembered_submit_branch = False
             if submit_branch is None:
                 submit_branch = stored_submit_branch
-                remembered_submit_branch = "submit"
+                remembered_submit_branch = True
             else:
                 if stored_submit_branch is None or remember:
                     branch.set_submit_branch(submit_branch)
             if submit_branch is None:
                 submit_branch = branch.get_parent()
-                remembered_submit_branch = "parent"
+                remembered_submit_branch = True
             if submit_branch is None:
                 raise errors.BzrCommandError('No submit branch known or'
                                              ' specified')
-            if remembered_submit_branch is not None:
-                note('Using saved %s location "%s" to determine what '
-                        'changes to submit.', remembered_submit_branch,
-                        submit_branch)
-
-            if mail_to is None:
-                submit_config = Branch.open(submit_branch).get_config()
-                mail_to = submit_config.get_user_option("child_submit_to")
+            if remembered_submit_branch:
+                note('Using saved location: %s', submit_branch)
 
             stored_public_branch = branch.get_public_branch()
             if public_branch is None:
@@ -4236,9 +3974,9 @@
                 if len(revision) > 2:
                     raise errors.BzrCommandError('bzr send takes '
                         'at most two one revision identifiers')
-                revision_id = revision[-1].as_revision_id(branch)
+                revision_id = revision[-1].in_history(branch).rev_id
                 if len(revision) == 2:
-                    base_revision_id = revision[0].as_revision_id(branch)
+                    base_revision_id = revision[0].in_history(branch).rev_id
             if revision_id is None:
                 revision_id = branch.last_revision()
             if revision_id == NULL_REVISION:
@@ -4276,13 +4014,11 @@
                 else:
                     revision = branch.repository.get_revision(revision_id)
                     subject += revision.get_summary()
-                basename = directive.get_disk_name(branch)
                 mail_client.compose_merge_request(mail_to, subject,
-                                                  outfile.getvalue(), basename)
+                                                  outfile.getvalue())
         finally:
             if output != '-':
                 outfile.close()
-            branch.unlock()
 
 
 class cmd_bundle_revisions(cmd_send):
@@ -4367,9 +4103,6 @@
 
     It is an error to give a tag name that already exists unless you pass 
     --force, in which case the tag is moved to point to the new revision.
-
-    To rename a tag (change the name but keep it on the same revsion), run ``bzr
-    tag new-name -r tag:old-name`` and then ``bzr tag --delete oldname``.
     """
 
     _see_also = ['commit', 'tags']
@@ -4407,7 +4140,7 @@
                         raise errors.BzrCommandError(
                             "Tags can only be placed on a single revision, "
                             "not on a range")
-                    revision_id = revision[0].as_revision_id(branch)
+                    revision_id = revision[0].in_history(branch).rev_id
                 else:
                     revision_id = branch.last_revision()
                 if (not force) and branch.tags.has_tag(tag_name):
@@ -4421,7 +4154,7 @@
 class cmd_tags(Command):
     """List tags.
 
-    This command shows a table of tag names and the revisions they reference.
+    This tag shows a table of tag names and the revisions they reference.
     """
 
     _see_also = ['tag']
@@ -4431,44 +4164,15 @@
             short_name='d',
             type=unicode,
             ),
-        RegistryOption.from_kwargs('sort',
-            'Sort tags by different criteria.', title='Sorting',
-            alpha='Sort tags lexicographically (default).',
-            time='Sort tags chronologically.',
-            ),
-        'show-ids',
     ]
 
     @display_command
     def run(self,
             directory='.',
-            sort='alpha',
-            show_ids=False,
             ):
         branch, relpath = Branch.open_containing(directory)
-        tags = branch.tags.get_tag_dict().items()
-        if not tags:
-            return
-        if sort == 'alpha':
-            tags.sort()
-        elif sort == 'time':
-            timestamps = {}
-            for tag, revid in tags:
-                try:
-                    revobj = branch.repository.get_revision(revid)
-                except errors.NoSuchRevision:
-                    timestamp = sys.maxint # place them at the end
-                else:
-                    timestamp = revobj.timestamp
-                timestamps[revid] = timestamp
-            tags.sort(key=lambda x: timestamps[x[1]])
-        if not show_ids:
-            # [ (tag, revid), ... ] -> [ (tag, dotted_revno), ... ]
-            revno_map = branch.get_revision_id_to_revno_map()
-            tags = [ (tag, '.'.join(map(str, revno_map.get(revid, ('?',)))))
-                        for tag, revid in tags ]
-        for tag, revspec in tags:
-            self.outf.write('%-20s %s\n' % (tag, revspec))
+        for tag_name, target in sorted(branch.tags.get_tag_dict().items()):
+            self.outf.write('%-20s %s\n' % (tag_name, target))
 
 
 class cmd_reconfigure(Command):
@@ -4485,23 +4189,14 @@
     If none of these is available, --bind-to must be specified.
     """
 
-    _see_also = ['branches', 'checkouts', 'standalone-trees', 'working-trees']
     takes_args = ['location?']
     takes_options = [RegistryOption.from_kwargs('target_type',
                      title='Target type',
                      help='The type to reconfigure the directory to.',
                      value_switches=True, enum_switch=False,
-                     branch='Reconfigure to be an unbound branch '
-                        'with no working tree.',
-                     tree='Reconfigure to be an unbound branch '
-                        'with a working tree.',
-                     checkout='Reconfigure to be a bound branch '
-                        'with a working tree.',
-                     lightweight_checkout='Reconfigure to be a lightweight'
-                     ' checkout (with no local history).',
-                     standalone='Reconfigure to be a standalone branch '
-                        '(i.e. stop using shared repository).',
-                     use_shared='Reconfigure to use a shared repository.'),
+                     branch='Reconfigure to a branch.',
+                     tree='Reconfigure to a tree.',
+                     checkout='Reconfigure to a checkout.'),
                      Option('bind-to', help='Branch to bind checkout to.',
                             type=str),
                      Option('force',
@@ -4520,76 +4215,9 @@
         elif target_type == 'checkout':
             reconfiguration = reconfigure.Reconfigure.to_checkout(directory,
                                                                   bind_to)
-        elif target_type == 'lightweight-checkout':
-            reconfiguration = reconfigure.Reconfigure.to_lightweight_checkout(
-                directory, bind_to)
-        elif target_type == 'use-shared':
-            reconfiguration = reconfigure.Reconfigure.to_use_shared(directory)
-        elif target_type == 'standalone':
-            reconfiguration = reconfigure.Reconfigure.to_standalone(directory)
         reconfiguration.apply(force)
 
 
-class cmd_switch(Command):
-    """Set the branch of a checkout and update.
-    
-    For lightweight checkouts, this changes the branch being referenced.
-    For heavyweight checkouts, this checks that there are no local commits
-    versus the current bound branch, then it makes the local branch a mirror
-    of the new location and binds to it.
-    
-    In both cases, the working tree is updated and uncommitted changes
-    are merged. The user can commit or revert these as they desire.
-
-    Pending merges need to be committed or reverted before using switch.
-
-    The path to the branch to switch to can be specified relative to the parent
-    directory of the current branch. For example, if you are currently in a
-    checkout of /path/to/branch, specifying 'newbranch' will find a branch at
-    /path/to/newbranch.
-    """
-
-    takes_args = ['to_location']
-    takes_options = [Option('force',
-                        help='Switch even if local commits will be lost.')
-                     ]
-
-    def run(self, to_location, force=False):
-        from bzrlib import switch
-        tree_location = '.'
-        control_dir = bzrdir.BzrDir.open_containing(tree_location)[0]
-        try:
-            to_branch = Branch.open(to_location)
-        except errors.NotBranchError:
-            to_branch = Branch.open(
-                control_dir.open_branch().base + '../' + to_location)
-        switch.switch(control_dir, to_branch, force)
-        note('Switched to branch: %s',
-            urlutils.unescape_for_display(to_branch.base, 'utf-8'))
-
-
-class cmd_hooks(Command):
-    """Show a branch's currently registered hooks.
-    """
-
-    hidden = True
-    takes_args = ['path?']
-
-    def run(self, path=None):
-        if path is None:
-            path = '.'
-        branch_hooks = Branch.open(path).hooks
-        for hook_type in branch_hooks:
-            hooks = branch_hooks[hook_type]
-            self.outf.write("%s:\n" % (hook_type,))
-            if hooks:
-                for hook in hooks:
-                    self.outf.write("  %s\n" %
-                                    (branch_hooks.get_hook_name(hook),))
-            else:
-                self.outf.write("  <no hooks installed>\n")
-
-
 def _create_prefix(cur_transport):
     needed = [cur_transport]
     # Recurse upwards until we can create a directory successfully
@@ -4612,6 +4240,34 @@
         cur_transport.ensure_base()
 
 
+def _get_mergeable_helper(location):
+    """Get a merge directive or bundle if 'location' points to one.
+
+    Try try to identify a bundle and returns its mergeable form. If it's not,
+    we return the tried transport anyway so that it can reused to access the
+    branch
+
+    :param location: can point to a bundle or a branch.
+
+    :return: mergeable, transport
+    """
+    mergeable = None
+    url = urlutils.normalize_url(location)
+    url, filename = urlutils.split(url, exclude_trailing_slash=False)
+    location_transport = transport.get_transport(url)
+    if filename:
+        try:
+            # There may be redirections but we ignore the intermediate
+            # and final transports used
+            read = bundle.read_mergeable_from_transport
+            mergeable, t = read(location_transport, filename)
+        except errors.NotABundle:
+            # Continue on considering this url a Branch but adjust the
+            # location_transport
+            location_transport = location_transport.clone(filename)
+    return mergeable, location_transport
+
+
 # these get imported and then picked up by the scan for cmd_*
 # TODO: Some more consistent way to split command definitions across files;
 # we do need to load at least some information about them to know of 
@@ -4623,5 +4279,5 @@
     cmd_bundle_info,
     )
 from bzrlib.sign_my_commits import cmd_sign_my_commits
-from bzrlib.weave_commands import cmd_versionedfile_list, \
+from bzrlib.weave_commands import cmd_versionedfile_list, cmd_weave_join, \
         cmd_weave_plan_merge, cmd_weave_merge_text

=== modified file 'bzrlib/bundle/__init__.py'
--- bzrlib/bundle/__init__.py	2008-03-25 01:25:28 +0000
+++ bzrlib/bundle/__init__.py	2007-06-05 15:52:12 +0000
@@ -35,20 +35,20 @@
     return read_mergeable_from_url(url, _do_directive=False)
 
 
-def read_mergeable_from_url(url, _do_directive=True, possible_transports=None):
+def read_mergeable_from_url(url, _do_directive=True):
     """Read mergable object from a given URL.
 
     :return: An object supporting get_target_revision.  Raises NotABundle if
         the target is not a mergeable type.
     """
-    child_transport = get_transport(url,
-        possible_transports=possible_transports)
-    transport = child_transport.clone('..')
-    filename = transport.relpath(child_transport.base)
-    if filename.endswith('/'):
+    url = urlutils.normalize_url(url)
+    url, filename = urlutils.split(url, exclude_trailing_slash=False)
+    if not filename:
         # A path to a directory was passed in
         # definitely not a bundle
         raise errors.NotABundle('A directory cannot be a bundle')
+
+    transport = get_transport(url)
     mergeable, transport = read_mergeable_from_transport(transport, filename,
                                                          _do_directive)
     return mergeable

=== modified file 'bzrlib/bundle/bundle_data.py'
--- bzrlib/bundle/bundle_data.py	2008-05-08 04:33:38 +0000
+++ bzrlib/bundle/bundle_data.py	2007-09-25 08:14:12 +0000
@@ -78,8 +78,7 @@
             for property in self.properties:
                 key_end = property.find(': ')
                 if key_end == -1:
-                    if not property.endswith(':'):
-                        raise ValueError(property)
+                    assert property.endswith(':')
                     key = str(property[:-1])
                     value = ''
                 else:
@@ -197,8 +196,7 @@
     def revision_tree(self, repository, revision_id, base=None):
         revision = self.get_revision(revision_id)
         base = self.get_base(revision)
-        if base == revision_id:
-            raise AssertionError()
+        assert base != revision_id
         if not self._validated_revisions_against_repo:
             self._validate_references_from_repository(repository)
         revision_info = self.get_revision_info(revision_id)
@@ -262,6 +260,21 @@
             elif revision_id not in checked:
                 missing[revision_id] = sha1
 
+        for inv_id, sha1 in inv_to_sha.iteritems():
+            if repository.has_revision(inv_id):
+                # Note: branch.get_inventory_sha1() just returns the value that
+                # is stored in the revision text, and that value may be out
+                # of date. This is bogus, because that means we aren't
+                # validating the actual text, just that we wrote and read the
+                # string. But for now, what the hell.
+                local_sha1 = repository.get_inventory_sha1(inv_id)
+                if sha1 != local_sha1:
+                    raise BzrError('sha1 mismatch. For inventory id {%s}' 
+                                   'local: %s, bundle: %s' % 
+                                   (inv_id, local_sha1, sha1))
+                else:
+                    count += 1
+
         if len(missing) > 0:
             # I don't know if this is an error yet
             warning('Not all revision hashes could be validated.'
@@ -273,13 +286,15 @@
         """At this point we should have generated the BundleTree,
         so build up an inventory, and make sure the hashes match.
         """
+
+        assert inv is not None
+
         # Now we should have a complete inventory entry.
         s = serializer_v5.write_inventory_to_string(inv)
         sha1 = sha_string(s)
         # Target revision is the last entry in the real_revisions list
         rev = self.get_revision(revision_id)
-        if rev.revision_id != revision_id:
-            raise AssertionError()
+        assert rev.revision_id == revision_id
         if sha1 != rev.inventory_sha1:
             open(',,bogus-inv', 'wb').write(s)
             warning('Inventory sha hash mismatch for revision %s. %s'
@@ -293,10 +308,8 @@
         
         rev = self.get_revision(revision_id)
         rev_info = self.get_revision_info(revision_id)
-        if not (rev.revision_id == rev_info.revision_id):
-            raise AssertionError()
-        if not (rev.revision_id == revision_id):
-            raise AssertionError()
+        assert rev.revision_id == rev_info.revision_id
+        assert rev.revision_id == revision_id
         sha1 = self._testament_sha1(rev, inventory)
         if sha1 != rev_info.sha1:
             raise TestamentMismatch(rev.revision_id, rev_info.sha1, sha1)
@@ -334,6 +347,7 @@
                 if name == 'last-changed':
                     last_changed = value
                 elif name == 'executable':
+                    assert value in ('yes', 'no'), value
                     val = (value == 'yes')
                     bundle_tree.note_executable(new_path, val)
                 elif name == 'target':
@@ -343,12 +357,11 @@
             return last_changed, encoding
 
         def do_patch(path, lines, encoding):
-            if encoding == 'base64':
+            if encoding is not None:
+                assert encoding == 'base64'
                 patch = base64.decodestring(''.join(lines))
-            elif encoding is None:
+            else:
                 patch =  ''.join(lines)
-            else:
-                raise ValueError(encoding)
             bundle_tree.note_patch(path, patch)
 
         def renamed(kind, extra, lines):
@@ -482,10 +495,8 @@
 
     def note_rename(self, old_path, new_path):
         """A file/directory has been renamed from old_path => new_path"""
-        if new_path in self._renamed:
-            raise AssertionError(new_path)
-        if old_path in self._renamed_r:
-            raise AssertionError(old_path)
+        assert new_path not in self._renamed
+        assert old_path not in self._renamed_r
         self._renamed[new_path] = old_path
         self._renamed_r[old_path] = new_path
 
@@ -521,8 +532,7 @@
 
     def old_path(self, new_path):
         """Get the old_path (path in the base_tree) for the file at new_path"""
-        if new_path[:1] in ('\\', '/'):
-            raise ValueError(new_path)
+        assert new_path[:1] not in ('\\', '/')
         old_path = self._renamed.get(new_path)
         if old_path is not None:
             return old_path
@@ -548,8 +558,7 @@
         """Get the new_path (path in the target_tree) for the file at old_path
         in the base tree.
         """
-        if old_path[:1] in ('\\', '/'):
-            raise ValueError(old_path)
+        assert old_path[:1] not in ('\\', '/')
         new_path = self._renamed_r.get(old_path)
         if new_path is not None:
             return new_path
@@ -628,13 +637,11 @@
             if (patch_original is None and 
                 self.get_kind(file_id) == 'directory'):
                 return StringIO()
-            if patch_original is None:
-                raise AssertionError("None: %s" % file_id)
+            assert patch_original is not None, "None: %s" % file_id
             return patch_original
 
-        if file_patch.startswith('\\'):
-            raise ValueError(
-                'Malformed patch for %s, %r' % (file_id, file_patch))
+        assert not file_patch.startswith('\\'), \
+            'Malformed patch for %s, %r' % (file_id, file_patch)
         return patched_file(file_patch, patch_original)
 
     def get_symlink_target(self, file_id):
@@ -687,6 +694,8 @@
         This need to be called before ever accessing self.inventory
         """
         from os.path import dirname, basename
+
+        assert self.base_tree is not None
         base_inv = self.base_tree.inventory
         inv = Inventory(None, self.revision_id)
 

=== modified file 'bzrlib/bundle/commands.py'
--- bzrlib/bundle/commands.py	2008-02-13 01:31:33 +0000
+++ bzrlib/bundle/commands.py	2007-10-16 16:02:01 +0000
@@ -59,8 +59,8 @@
             bundle_info = read_bundle(bundle_file)
         else:
             if verbose:
-                raise errors.BzrCommandError('--verbose requires a merge'
-                    ' directive')
+                raise errors.BzrCommandError('Verbose requires a merge'
+                                             ' directive')
         reader_method = getattr(bundle_info, 'get_bundle_reader', None)
         if reader_method is None:
             raise errors.BzrCommandError('Bundle format not supported')

=== modified file 'bzrlib/bundle/serializer/v08.py'
--- bzrlib/bundle/serializer/v08.py	2008-04-24 07:22:53 +0000
+++ bzrlib/bundle/serializer/v08.py	2007-06-20 00:25:11 +0000
@@ -146,8 +146,7 @@
             If this parameter is True, and value is the empty string, we will
             write an extra space.
         """
-        if indent < 1:
-            raise ValueError('indentation must be greater than 0')
+        assert indent > 0, 'indentation must be greater than 0'
         f = self.to_file
         f.write('#' + (' ' * indent))
         f.write(key.encode('utf-8'))
@@ -524,8 +523,7 @@
             action, lines, do_continue = self._read_one_patch()
             if action is not None:
                 revision_actions.append((action, lines))
-        if self.info.revisions[-1].tree_actions is not None:
-            raise AssertionError()
+        assert self.info.revisions[-1].tree_actions is None
         self.info.revisions[-1].tree_actions = revision_actions
 
     def _read_footer(self):

=== modified file 'bzrlib/bundle/serializer/v4.py'
--- bzrlib/bundle/serializer/v4.py	2008-07-01 03:38:35 +0000
+++ bzrlib/bundle/serializer/v4.py	2007-10-03 07:45:17 +0000
@@ -107,20 +107,17 @@
     @staticmethod
     def encode_name(content_kind, revision_id, file_id=None):
         """Encode semantic ids as a container name"""
-        if content_kind not in ('revision', 'file', 'inventory', 'signature',
-                'info'):
-            raise ValueError(content_kind)
+        assert content_kind in ('revision', 'file', 'inventory', 'signature',
+                                'info')
+
         if content_kind == 'file':
-            if file_id is None:
-                raise AssertionError()
+            assert file_id is not None
         else:
-            if file_id is not None:
-                raise AssertionError()
+            assert file_id is None
         if content_kind == 'info':
-            if revision_id is not None:
-                raise AssertionError()
-        elif revision_id is None:
-            raise AssertionError()
+            assert revision_id is None
+        else:
+            assert revision_id is not None
         names = [n.replace('/', '//') for n in
                  (content_kind, revision_id, file_id) if n is not None]
         return '/'.join(names)
@@ -163,17 +160,14 @@
             source_file = iterablefile.IterableFile(self.iter_decode(fileobj))
         else:
             source_file = StringIO(bz2.decompress(fileobj.read()))
-        self._container_file = source_file
+        self._container = pack.ContainerReader(source_file)
 
     @staticmethod
     def iter_decode(fileobj):
         """Iterate through decoded fragments of the file"""
         decompressor = bz2.BZ2Decompressor()
         for line in fileobj:
-            try:
-                yield decompressor.decompress(line)
-            except EOFError:
-                return
+            yield decompressor.decompress(line)
 
     @staticmethod
     def decode_name(name):
@@ -205,16 +199,17 @@
         :return: a generator of (bytes, metadata, content_kind, revision_id,
             file_id)
         """
-        iterator = pack.iter_records_from_file(self._container_file)
-        for names, bytes in iterator:
+        iterator = self._container.iter_records()
+        for names, meta_bytes in iterator:
             if len(names) != 1:
                 raise errors.BadBundle('Record has %d names instead of 1'
                                        % len(names))
-            metadata = bencode.bdecode(bytes)
+            metadata = bencode.bdecode(meta_bytes(None))
             if metadata['storage_kind'] == 'header':
                 bytes = None
             else:
                 _unused, bytes = iterator.next()
+                bytes = bytes(None)
             yield (bytes, metadata) + self.decode_name(names[0][0])
 
 
@@ -278,19 +273,14 @@
             revision_ids = set(repository.get_ancestry(target,
                                                        topo_sorted=False))
             self.revision_ids = revision_ids.difference(self.base_ancestry)
-        self.revision_keys = set([(revid,) for revid in self.revision_ids])
 
     def do_write(self):
         """Write all data to the bundle"""
-        self.repository.lock_read()
-        try:
-            self.bundle.begin()
-            self.write_info()
-            self.write_files()
-            self.write_revisions()
-            self.bundle.end()
-        finally:
-            self.repository.unlock()
+        self.bundle.begin()
+        self.write_info()
+        self.write_files()
+        self.write_revisions()
+        self.bundle.end()
         return self.revision_ids
 
     def write_info(self):
@@ -301,28 +291,58 @@
         self.bundle.add_info_record(serializer=serializer_format,
                                     supports_rich_root=supports_rich_root)
 
+    def iter_file_revisions(self):
+        """Iterate through all relevant revisions of all files.
+
+        This is the correct implementation, but is not compatible with bzr.dev,
+        because certain old revisions were not converted correctly, and have
+        the wrong "revision" marker in inventories.
+        """
+        transaction = self.repository.get_transaction()
+        altered = self.repository.fileids_altered_by_revision_ids(
+            self.revision_ids)
+        for file_id, file_revision_ids in altered.iteritems():
+            vf = self.repository.weave_store.get_weave(file_id, transaction)
+            yield vf, file_id, file_revision_ids
+
+    def iter_file_revisions_aggressive(self):
+        """Iterate through all relevant revisions of all files.
+
+        This uses the standard iter_file_revisions to determine what revisions
+        are referred to by inventories, but then uses the versionedfile to
+        determine what the build-dependencies of each required revision.
+
+        All build dependencies which are not ancestors of the base revision
+        are emitted.
+        """
+        for vf, file_id, file_revision_ids in self.iter_file_revisions():
+            new_revision_ids = set()
+            pending = list(file_revision_ids)
+            while len(pending) > 0:
+                revision_id = pending.pop()
+                if revision_id in new_revision_ids:
+                    continue
+                if revision_id in self.base_ancestry:
+                    continue
+                new_revision_ids.add(revision_id)
+                pending.extend(vf.get_parents(revision_id))
+            yield vf, file_id, new_revision_ids
+
     def write_files(self):
         """Write bundle records for all revisions of all files"""
-        text_keys = []
-        altered_fileids = self.repository.fileids_altered_by_revision_ids(
-                self.revision_ids)
-        for file_id, revision_ids in altered_fileids.iteritems():
-            for revision_id in revision_ids:
-                text_keys.append((file_id, revision_id))
-        self._add_mp_records_keys('file', self.repository.texts, text_keys)
+        for vf, file_id, revision_ids in self.iter_file_revisions():
+            self.add_mp_records('file', file_id, vf, revision_ids)
 
     def write_revisions(self):
         """Write bundle records for all revisions and signatures"""
-        inv_vf = self.repository.inventories
-        revision_order = [key[-1] for key in multiparent.topo_iter_keys(inv_vf,
-            self.revision_keys)]
+        inv_vf = self.repository.get_inventory_weave()
+        revision_order = list(multiparent.topo_iter(inv_vf, self.revision_ids))
         if self.target is not None and self.target in self.revision_ids:
             revision_order.remove(self.target)
             revision_order.append(self.target)
-        self._add_mp_records_keys('inventory', inv_vf, [(revid,) for revid in revision_order])
-        parent_map = self.repository.get_parent_map(revision_order)
-        for revision_id in revision_order:
-            parents = parent_map.get(revision_id, None)
+        self.add_mp_records('inventory', None, inv_vf, revision_order)
+        parents_list = self.repository.get_parents(revision_order)
+        for parents, revision_id in zip(parents_list, revision_order):
             revision_text = self.repository.get_revision_xml(revision_id)
             self.bundle.add_fulltext_record(revision_text, parents,
                                        'revision', revision_id)
@@ -348,23 +368,16 @@
                 base = parents[0]
         return base, target
 
-    def _add_mp_records_keys(self, repo_kind, vf, keys):
+    def add_mp_records(self, repo_kind, file_id, vf, revision_ids):
         """Add multi-parent diff records to a bundle"""
-        ordered_keys = list(multiparent.topo_iter_keys(vf, keys))
-        mpdiffs = vf.make_mpdiffs(ordered_keys)
-        sha1s = vf.get_sha1s(ordered_keys)
-        parent_map = vf.get_parent_map(ordered_keys)
-        for mpdiff, item_key, in zip(mpdiffs, ordered_keys):
-            sha1 = sha1s[item_key]
-            parents = [key[-1] for key in parent_map[item_key]]
+        revision_ids = list(multiparent.topo_iter(vf, revision_ids))
+        mpdiffs = vf.make_mpdiffs(revision_ids)
+        sha1s = vf.get_sha1s(revision_ids)
+        for mpdiff, revision_id, sha1, in zip(mpdiffs, revision_ids, sha1s):
+            parents = vf.get_parents(revision_id)
             text = ''.join(mpdiff.to_patch())
-            # Infer file id records as appropriate.
-            if len(item_key) == 2:
-                file_id = item_key[0]
-            else:
-                file_id = None
             self.bundle.add_multiparent_record(text, sha1, parents, repo_kind,
-                                               item_key[-1], file_id)
+                                               revision_id, file_id)
 
 
 class BundleInfoV4(object):
@@ -477,22 +490,25 @@
         for bytes, metadata, repo_kind, revision_id, file_id in\
             self._container.iter_records():
             if repo_kind == 'info':
-                if self._info is not None:
-                    raise AssertionError()
+                assert self._info is None
                 self._handle_info(metadata)
-            if (pending_file_records and
-                (repo_kind, file_id) != ('file', current_file)):
-                # Flush the data for a single file - prevents memory
-                # spiking due to buffering all files in memory.
-                self._install_mp_records_keys(self._repository.texts,
-                    pending_file_records)
+            if (repo_kind, file_id) != ('file', current_file):
+                if len(pending_file_records) > 0:
+                    self._install_mp_records(current_versionedfile,
+                                             pending_file_records)
                 current_file = None
-                del pending_file_records[:]
+                current_versionedfile = None
+                pending_file_records = []
             if len(pending_inventory_records) > 0 and repo_kind != 'inventory':
-                self._install_inventory_records(pending_inventory_records)
+                self._install_inventory_records(inventory_vf,
+                                                pending_inventory_records)
                 pending_inventory_records = []
             if repo_kind == 'inventory':
-                pending_inventory_records.append(((revision_id,), metadata, bytes))
+                if inventory_vf is None:
+                    inventory_vf = self._repository.get_inventory_weave()
+                if revision_id not in inventory_vf:
+                    pending_inventory_records.append((revision_id, metadata,
+                                                      bytes))
             if repo_kind == 'revision':
                 target_revision = revision_id
                 self._install_revision(revision_id, metadata, bytes)
@@ -500,8 +516,15 @@
                 self._install_signature(revision_id, metadata, bytes)
             if repo_kind == 'file':
                 current_file = file_id
-                pending_file_records.append(((file_id, revision_id), metadata, bytes))
-        self._install_mp_records_keys(self._repository.texts, pending_file_records)
+                if current_versionedfile is None:
+                    current_versionedfile = \
+                        self._repository.weave_store.get_weave_or_empty(
+                        file_id, self._repository.get_transaction())
+                    pending_file_records = []
+                if revision_id in current_versionedfile:
+                    continue
+                pending_file_records.append((revision_id, metadata, bytes))
+        self._install_mp_records(current_versionedfile, pending_file_records)
         return target_revision
 
     def _handle_info(self, info):
@@ -522,29 +545,10 @@
                       records if r not in versionedfile]
         versionedfile.add_mpdiffs(vf_records)
 
-    def _install_mp_records_keys(self, versionedfile, records):
-        d_func = multiparent.MultiParent.from_patch
-        vf_records = []
-        for key, meta, text in records:
-            # Adapt to tuple interface: A length two key is a file_id,
-            # revision_id pair, a length 1 key is a
-            # revision/signature/inventory. We need to do this because
-            # the metadata extraction from the bundle has not yet been updated
-            # to use the consistent tuple interface itself.
-            if len(key) == 2:
-                prefix = key[:1]
-            else:
-                prefix = ()
-            parents = [prefix + (parent,) for parent in meta['parents']]
-            vf_records.append((key, parents, meta['sha1'], d_func(text)))
-        versionedfile.add_mpdiffs(vf_records)
-
-    def _install_inventory_records(self, records):
+    def _install_inventory_records(self, vf, records):
         if self._info['serializer'] == self._repository._serializer.format_num:
-            return self._install_mp_records_keys(self._repository.inventories,
-                records)
-        for key, metadata, bytes in records:
-            revision_id = key[-1]
+            return self._install_mp_records(vf, records)
+        for revision_id, metadata, bytes in records:
             parent_ids = metadata['parents']
             parents = [self._repository.get_inventory(p)
                        for p in parent_ids]
@@ -567,22 +571,25 @@
     def _handle_root(self, target_inv, parent_ids):
         revision_id = target_inv.revision_id
         if self.update_root:
-            text_key = (target_inv.root.file_id, revision_id)
-            parent_keys = [(target_inv.root.file_id, parent) for
-                parent in parent_ids]
-            self._repository.texts.add_lines(text_key, parent_keys, [])
+            target_inv.root.revision = revision_id
+            store = self._repository.weave_store
+            transaction = self._repository.get_transaction()
+            vf = store.get_weave_or_empty(target_inv.root.file_id, transaction)
+            vf.add_lines(revision_id, parent_ids, [])
         elif not self._repository.supports_rich_root():
             if target_inv.root.revision != revision_id:
                 raise errors.IncompatibleRevision(repr(self._repository))
 
+
     def _install_revision(self, revision_id, metadata, text):
         if self._repository.has_revision(revision_id):
             return
-        revision = self._source_serializer.read_revision_from_string(text)
-        self._repository.add_revision(revision.revision_id, revision)
+        self._repository._add_revision_text(revision_id, text)
 
     def _install_signature(self, revision_id, metadata, text):
         transaction = self._repository.get_transaction()
-        if self._repository.has_signature_for_revision_id(revision_id):
+        if self._repository._revision_store.has_signature(revision_id,
+                                                          transaction):
             return
-        self._repository.add_signature_text(revision_id, text)
+        self._repository._revision_store.add_revision_signature_text(
+            revision_id, text, transaction)

=== modified file 'bzrlib/bzrdir.py'
--- bzrlib/bzrdir.py	2008-09-02 22:08:56 +0000
+++ bzrlib/bzrdir.py	2007-09-21 07:29:37 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2008 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -29,7 +29,6 @@
 
 from cStringIO import StringIO
 import os
-import sys
 
 from bzrlib.lazy_import import lazy_import
 lazy_import(globals(), """
@@ -39,32 +38,29 @@
 
 import bzrlib
 from bzrlib import (
-    config,
     errors,
     graph,
     lockable_files,
     lockdir,
-    osutils,
     registry,
     remote,
     revision as _mod_revision,
     symbol_versioning,
     ui,
     urlutils,
-    versionedfile,
-    win32utils,
+    xml4,
+    xml5,
     workingtree,
     workingtree_4,
-    xml4,
-    xml5,
     )
 from bzrlib.osutils import (
     sha_strings,
     sha_string,
     )
-from bzrlib.repository import Repository
 from bzrlib.smart.client import _SmartClient
 from bzrlib.smart import protocol
+from bzrlib.store.revision.text import TextRevisionStore
+from bzrlib.store.text import TextStore
 from bzrlib.store.versioned import WeaveStore
 from bzrlib.transactions import WriteTransaction
 from bzrlib.transport import (
@@ -82,6 +78,7 @@
 from bzrlib.symbol_versioning import (
     deprecated_function,
     deprecated_method,
+    zero_ninetyone,
     )
 
 
@@ -91,13 +88,11 @@
     BzrDir instances let you create or open any of the things that can be
     found within .bzr - checkouts, branches and repositories.
     
-    :ivar transport:
+    transport
         the transport which this bzr dir is rooted at (i.e. file:///.../.bzr/)
-    :ivar root_transport:
+    root_transport
         a transport connected to the directory this bzr was opened from
         (i.e. the parent directory holding the .bzr directory).
-
-    Everything in the bzrdir should have the same file permissions.
     """
 
     def break_lock(self):
@@ -157,88 +152,66 @@
                 format.get_format_description(),
                 basedir)
 
-    def clone(self, url, revision_id=None, force_new_repo=False,
-              preserve_stacking=False):
+    def clone(self, url, revision_id=None, force_new_repo=False):
         """Clone this bzrdir and its contents to url verbatim.
 
-        :param url: The url create the clone at.  If url's last component does
-            not exist, it will be created.
-        :param revision_id: The tip revision-id to use for any branch or
-            working tree.  If not None, then the clone operation may tune
+        If url's last component does not exist, it will be created.
+
+        if revision_id is not None, then the clone operation may tune
             itself to download less data.
-        :param force_new_repo: Do not use a shared repository for the target
+        :param force_new_repo: Do not use a shared repository for the target 
                                even if one is available.
-        :param preserve_stacking: When cloning a stacked branch, stack the
-            new branch on top of the other branch's stacked-on branch.
         """
         return self.clone_on_transport(get_transport(url),
                                        revision_id=revision_id,
-                                       force_new_repo=force_new_repo,
-                                       preserve_stacking=preserve_stacking)
+                                       force_new_repo=force_new_repo)
 
     def clone_on_transport(self, transport, revision_id=None,
-                           force_new_repo=False, preserve_stacking=False,
-                           stacked_on=None):
+                           force_new_repo=False):
         """Clone this bzrdir and its contents to transport verbatim.
 
-        :param transport: The transport for the location to produce the clone
-            at.  If the target directory does not exist, it will be created.
-        :param revision_id: The tip revision-id to use for any branch or
-            working tree.  If not None, then the clone operation may tune
+        If the target directory does not exist, it will be created.
+
+        if revision_id is not None, then the clone operation may tune
             itself to download less data.
-        :param force_new_repo: Do not use a shared repository for the target,
+        :param force_new_repo: Do not use a shared repository for the target 
                                even if one is available.
-        :param preserve_stacking: When cloning a stacked branch, stack the
-            new branch on top of the other branch's stacked-on branch.
         """
         transport.ensure_base()
-        require_stacking = (stacked_on is not None)
-        metadir = self.cloning_metadir(require_stacking)
-        result = metadir.initialize_on_transport(transport)
-        repository_policy = None
+        result = self._format.initialize_on_transport(transport)
         try:
             local_repo = self.find_repository()
         except errors.NoRepositoryPresent:
             local_repo = None
-        try:
-            local_branch = self.open_branch()
-        except errors.NotBranchError:
-            local_branch = None
-        else:
-            # enable fallbacks when branch is not a branch reference
-            if local_branch.repository.has_same_location(local_repo):
-                local_repo = local_branch.repository
-            if preserve_stacking:
-                try:
-                    stacked_on = local_branch.get_stacked_on_url()
-                except (errors.UnstackableBranchFormat,
-                        errors.UnstackableRepositoryFormat,
-                        errors.NotStacked):
-                    pass
-
         if local_repo:
             # may need to copy content in
-            repository_policy = result.determine_repository_policy(
-                force_new_repo, stacked_on, self.root_transport.base,
-                require_stacking=require_stacking)
-            make_working_trees = local_repo.make_working_trees()
-            result_repo = repository_policy.acquire_repository(
-                make_working_trees, local_repo.is_shared())
-            result_repo.fetch(local_repo, revision_id=revision_id)
-        else:
-            result_repo = None
+            if force_new_repo:
+                result_repo = local_repo.clone(
+                    result,
+                    revision_id=revision_id)
+                result_repo.set_make_working_trees(local_repo.make_working_trees())
+            else:
+                try:
+                    result_repo = result.find_repository()
+                    # fetch content this dir needs.
+                    result_repo.fetch(local_repo, revision_id=revision_id)
+                except errors.NoRepositoryPresent:
+                    # needed to make one anyway.
+                    result_repo = local_repo.clone(
+                        result,
+                        revision_id=revision_id)
+                    result_repo.set_make_working_trees(local_repo.make_working_trees())
         # 1 if there is a branch present
         #   make sure its content is available in the target repository
         #   clone it.
-        if local_branch is not None:
-            result_branch = local_branch.clone(result, revision_id=revision_id)
-            if repository_policy is not None:
-                repository_policy.configure_branch(result_branch)
-        if result_repo is None or result_repo.make_working_trees():
-            try:
-                self.open_workingtree().clone(result)
-            except (errors.NoWorkingTree, errors.NotLocalUrl):
-                pass
+        try:
+            self.open_branch().clone(result, revision_id=revision_id)
+        except errors.NotBranchError:
+            pass
+        try:
+            self.open_workingtree().clone(result)
+        except (errors.NoWorkingTree, errors.NotLocalUrl):
+            pass
         return result
 
     # TODO: This should be given a Transport, and should chdir up; otherwise
@@ -265,83 +238,6 @@
             format = BzrDirFormat.get_default_format()
         return format.initialize_on_transport(t)
 
-    @staticmethod
-    def find_bzrdirs(transport, evaluate=None, list_current=None):
-        """Find bzrdirs recursively from current location.
-
-        This is intended primarily as a building block for more sophisticated
-        functionality, like finding trees under a directory, or finding
-        branches that use a given repository.
-        :param evaluate: An optional callable that yields recurse, value,
-            where recurse controls whether this bzrdir is recursed into
-            and value is the value to yield.  By default, all bzrdirs
-            are recursed into, and the return value is the bzrdir.
-        :param list_current: if supplied, use this function to list the current
-            directory, instead of Transport.list_dir
-        :return: a generator of found bzrdirs, or whatever evaluate returns.
-        """
-        if list_current is None:
-            def list_current(transport):
-                return transport.list_dir('')
-        if evaluate is None:
-            def evaluate(bzrdir):
-                return True, bzrdir
-
-        pending = [transport]
-        while len(pending) > 0:
-            current_transport = pending.pop()
-            recurse = True
-            try:
-                bzrdir = BzrDir.open_from_transport(current_transport)
-            except errors.NotBranchError:
-                pass
-            else:
-                recurse, value = evaluate(bzrdir)
-                yield value
-            try:
-                subdirs = list_current(current_transport)
-            except errors.NoSuchFile:
-                continue
-            if recurse:
-                for subdir in sorted(subdirs, reverse=True):
-                    pending.append(current_transport.clone(subdir))
-
-    @staticmethod
-    def find_branches(transport):
-        """Find all branches under a transport.
-
-        This will find all branches below the transport, including branches
-        inside other branches.  Where possible, it will use
-        Repository.find_branches.
-
-        To list all the branches that use a particular Repository, see
-        Repository.find_branches
-        """
-        def evaluate(bzrdir):
-            try:
-                repository = bzrdir.open_repository()
-            except errors.NoRepositoryPresent:
-                pass
-            else:
-                return False, (None, repository)
-            try:
-                branch = bzrdir.open_branch()
-            except errors.NotBranchError:
-                return True, (None, None)
-            else:
-                return True, (branch, None)
-        branches = []
-        for branch, repo in BzrDir.find_bzrdirs(transport, evaluate=evaluate):
-            if repo is not None:
-                branches.extend(repo.find_branches())
-            if branch is not None:
-                branches.append(branch)
-        return branches
-
-    def destroy_repository(self):
-        """Destroy the repository in this BzrDir"""
-        raise NotImplementedError(self.destroy_repository)
-
     def create_branch(self):
         """Create a branch in this BzrDir.
 
@@ -375,73 +271,15 @@
         bzrdir._find_or_create_repository(force_new_repo)
         return bzrdir.create_branch()
 
-    def determine_repository_policy(self, force_new_repo=False, stack_on=None,
-                                    stack_on_pwd=None, require_stacking=False):
-        """Return an object representing a policy to use.
-
-        This controls whether a new repository is created, or a shared
-        repository used instead.
-
-        If stack_on is supplied, will not seek a containing shared repo.
-
-        :param force_new_repo: If True, require a new repository to be created.
-        :param stack_on: If supplied, the location to stack on.  If not
-            supplied, a default_stack_on location may be used.
-        :param stack_on_pwd: If stack_on is relative, the location it is
-            relative to.
-        """
-        def repository_policy(found_bzrdir):
-            stack_on = None
-            stack_on_pwd = None
-            config = found_bzrdir.get_config()
-            stop = False
-            if config is not None:
-                stack_on = config.get_default_stack_on()
-                if stack_on is not None:
-                    stack_on_pwd = found_bzrdir.root_transport.base
-                    stop = True
-                    note('Using default stacking branch %s at %s', stack_on,
-                         stack_on_pwd)
-            # does it have a repository ?
-            try:
-                repository = found_bzrdir.open_repository()
-            except errors.NoRepositoryPresent:
-                repository = None
-            else:
-                if ((found_bzrdir.root_transport.base !=
-                     self.root_transport.base) and not repository.is_shared()):
-                    repository = None
-                else:
-                    stop = True
-            if not stop:
-                return None, False
-            if repository:
-                return UseExistingRepository(repository, stack_on,
-                    stack_on_pwd, require_stacking=require_stacking), True
-            else:
-                return CreateRepository(self, stack_on, stack_on_pwd,
-                    require_stacking=require_stacking), True
-
-        if not force_new_repo:
-            if stack_on is None:
-                policy = self._find_containing(repository_policy)
-                if policy is not None:
-                    return policy
-            else:
-                try:
-                    return UseExistingRepository(self.open_repository(),
-                        stack_on, stack_on_pwd,
-                        require_stacking=require_stacking)
-                except errors.NoRepositoryPresent:
-                    pass
-        return CreateRepository(self, stack_on, stack_on_pwd,
-                                require_stacking=require_stacking)
-
     def _find_or_create_repository(self, force_new_repo):
         """Create a new repository if needed, returning the repository."""
-        policy = self.determine_repository_policy(force_new_repo)
-        return policy.acquire_repository()
-
+        if force_new_repo:
+            return self.create_repository()
+        try:
+            return self.find_repository()
+        except errors.NoRepositoryPresent:
+            return self.create_repository()
+        
     @staticmethod
     def create_branch_convenience(base, force_new_repo=False,
                                   force_new_tree=None, format=None,
@@ -488,6 +326,29 @@
         return result
 
     @staticmethod
+    @deprecated_function(zero_ninetyone)
+    def create_repository(base, shared=False, format=None):
+        """Create a new BzrDir and Repository at the url 'base'.
+
+        If no format is supplied, this will default to the current default
+        BzrDirFormat by default, and use whatever repository format that that
+        uses for bzrdirformat.create_repository.
+
+        :param shared: Create a shared repository rather than a standalone
+                       repository.
+        The Repository object is returned.
+
+        This must be overridden as an instance method in child classes, where
+        it should take no parameters and construct whatever repository format
+        that child class desires.
+
+        This method is deprecated, please call create_repository on a bzrdir
+        instance instead.
+        """
+        bzrdir = BzrDir.create(base, format)
+        return bzrdir.create_repository(shared)
+
+    @staticmethod
     def create_standalone_workingtree(base, format=None):
         """Create a new BzrDir, WorkingTree, Branch and Repository at 'base'.
 
@@ -509,16 +370,10 @@
                                                format=format).bzrdir
         return bzrdir.create_workingtree()
 
-    def create_workingtree(self, revision_id=None, from_branch=None,
-        accelerator_tree=None, hardlink=False):
+    def create_workingtree(self, revision_id=None):
         """Create a working tree at this BzrDir.
         
-        :param revision_id: create it as of this revision id.
-        :param from_branch: override bzrdir branch (for lightweight checkouts)
-        :param accelerator_tree: A tree which can be used for retrieving file
-            contents more quickly than the revision tree, i.e. a workingtree.
-            The revision tree will be used for cases where accelerator_tree's
-            content is different.
+        revision_id: create it as of this revision id.
         """
         raise NotImplementedError(self.create_workingtree)
 
@@ -562,35 +417,6 @@
         """
         raise NotImplementedError(self.destroy_workingtree_metadata)
 
-    def _find_containing(self, evaluate):
-        """Find something in a containing control directory.
-
-        This method will scan containing control dirs, until it finds what
-        it is looking for, decides that it will never find it, or runs out
-        of containing control directories to check.
-
-        It is used to implement find_repository and
-        determine_repository_policy.
-
-        :param evaluate: A function returning (value, stop).  If stop is True,
-            the value will be returned.
-        """
-        found_bzrdir = self
-        while True:
-            result, stop = evaluate(found_bzrdir)
-            if stop:
-                return result
-            next_transport = found_bzrdir.root_transport.clone('..')
-            if (found_bzrdir.root_transport.base == next_transport.base):
-                # top of the file system
-                return None
-            # find the next containing bzrdir
-            try:
-                found_bzrdir = BzrDir.open_containing_from_transport(
-                    next_transport)[0]
-            except errors.NotBranchError:
-                return None
-
     def find_repository(self):
         """Find the repository that should be used.
 
@@ -598,23 +424,35 @@
         new branches as well as to hook existing branches up to their
         repository.
         """
-        def usable_repository(found_bzrdir):
+        try:
+            return self.open_repository()
+        except errors.NoRepositoryPresent:
+            pass
+        next_transport = self.root_transport.clone('..')
+        while True:
+            # find the next containing bzrdir
+            try:
+                found_bzrdir = BzrDir.open_containing_from_transport(
+                    next_transport)[0]
+            except errors.NotBranchError:
+                # none found
+                raise errors.NoRepositoryPresent(self)
             # does it have a repository ?
             try:
                 repository = found_bzrdir.open_repository()
             except errors.NoRepositoryPresent:
-                return None, False
-            if found_bzrdir.root_transport.base == self.root_transport.base:
-                return repository, True
-            elif repository.is_shared():
-                return repository, True
+                next_transport = found_bzrdir.root_transport.clone('..')
+                if (found_bzrdir.root_transport.base == next_transport.base):
+                    # top of the file system
+                    break
+                else:
+                    continue
+            if ((found_bzrdir.root_transport.base ==
+                 self.root_transport.base) or repository.is_shared()):
+                return repository
             else:
-                return None, True
-
-        found_repo = self._find_containing(usable_repository)
-        if found_repo is None:
-            raise errors.NoRepositoryPresent(self)
-        return found_repo
+                raise errors.NoRepositoryPresent(self)
+        raise errors.NoRepositoryPresent(self)
 
     def get_branch_reference(self):
         """Return the referenced URL for the branch in this bzrdir.
@@ -637,50 +475,6 @@
         guaranteed to point to an existing directory ready for use.
         """
         raise NotImplementedError(self.get_branch_transport)
-
-    def _find_creation_modes(self):
-        """Determine the appropriate modes for files and directories.
-
-        They're always set to be consistent with the base directory,
-        assuming that this transport allows setting modes.
-        """
-        # TODO: Do we need or want an option (maybe a config setting) to turn
-        # this off or override it for particular locations? -- mbp 20080512
-        if self._mode_check_done:
-            return
-        self._mode_check_done = True
-        try:
-            st = self.transport.stat('.')
-        except errors.TransportNotPossible:
-            self._dir_mode = None
-            self._file_mode = None
-        else:
-            # Check the directory mode, but also make sure the created
-            # directories and files are read-write for this user. This is
-            # mostly a workaround for filesystems which lie about being able to
-            # write to a directory (cygwin & win32)
-            if (st.st_mode & 07777 == 00000):
-                # FTP allows stat but does not return dir/file modes
-                self._dir_mode = None
-                self._file_mode = None
-            else:
-                self._dir_mode = (st.st_mode & 07777) | 00700
-                # Remove the sticky and execute bits for files
-                self._file_mode = self._dir_mode & ~07111
-
-    def _get_file_mode(self):
-        """Return Unix mode for newly created files, or None.
-        """
-        if not self._mode_check_done:
-            self._find_creation_modes()
-        return self._file_mode
-
-    def _get_dir_mode(self):
-        """Return Unix mode for newly created directories, or None.
-        """
-        if not self._mode_check_done:
-            self._find_creation_modes()
-        return self._dir_mode
         
     def get_repository_transport(self, repository_format):
         """Get the transport for use by repository format in this BzrDir.
@@ -707,12 +501,7 @@
         guaranteed to point to an existing directory ready for use.
         """
         raise NotImplementedError(self.get_workingtree_transport)
-
-    def get_config(self):
-        if getattr(self, '_get_config', None) is None:
-            return None
-        return self._get_config()
-
+        
     def __init__(self, _transport, _format):
         """Initialize a Bzr control dir object.
         
@@ -725,7 +514,6 @@
         self._format = _format
         self.transport = _transport.clone('.bzr')
         self.root_transport = _transport
-        self._mode_check_done = False
 
     def is_control_filename(self, filename):
         """True if filename is the name of a path which is reserved for bzrdir's.
@@ -866,34 +654,6 @@
                 raise errors.NotBranchError(path=url)
             a_transport = new_t
 
-    def _get_tree_branch(self):
-        """Return the branch and tree, if any, for this bzrdir.
-
-        Return None for tree if not present or inaccessible.
-        Raise NotBranchError if no branch is present.
-        :return: (tree, branch)
-        """
-        try:
-            tree = self.open_workingtree()
-        except (errors.NoWorkingTree, errors.NotLocalUrl):
-            tree = None
-            branch = self.open_branch()
-        else:
-            branch = tree.branch
-        return tree, branch
-
-    @classmethod
-    def open_tree_or_branch(klass, location):
-        """Return the branch and working tree at a location.
-
-        If there is no tree at the location, tree will be None.
-        If there is no branch at the location, an exception will be
-        raised
-        :return: (tree, branch)
-        """
-        bzrdir = klass.open(location)
-        return bzrdir._get_tree_branch()
-
     @classmethod
     def open_containing_tree_or_branch(klass, location):
         """Return the branch and working tree contained by a location.
@@ -905,34 +665,15 @@
         relpath is the portion of the path that is contained by the branch.
         """
         bzrdir, relpath = klass.open_containing(location)
-        tree, branch = bzrdir._get_tree_branch()
+        try:
+            tree = bzrdir.open_workingtree()
+        except (errors.NoWorkingTree, errors.NotLocalUrl):
+            tree = None
+            branch = bzrdir.open_branch()
+        else:
+            branch = tree.branch
         return tree, branch, relpath
 
-    @classmethod
-    def open_containing_tree_branch_or_repository(klass, location):
-        """Return the working tree, branch and repo contained by a location.
-
-        Returns (tree, branch, repository, relpath).
-        If there is no tree containing the location, tree will be None.
-        If there is no branch containing the location, branch will be None.
-        If there is no repository containing the location, repository will be
-        None.
-        relpath is the portion of the path that is contained by the innermost
-        BzrDir.
-
-        If no tree, branch or repository is found, a NotBranchError is raised.
-        """
-        bzrdir, relpath = klass.open_containing(location)
-        try:
-            tree, branch = bzrdir._get_tree_branch()
-        except errors.NotBranchError:
-            try:
-                repo = bzrdir.find_repository()
-                return None, None, repo, relpath
-            except (errors.NoRepositoryPresent):
-                raise errors.NotBranchError(location)
-        return tree, branch, branch.repository, relpath
-
     def open_repository(self, _unsupported=False):
         """Open the repository object at this BzrDir if one is present.
 
@@ -946,14 +687,13 @@
         raise NotImplementedError(self.open_repository)
 
     def open_workingtree(self, _unsupported=False,
-                         recommend_upgrade=True, from_branch=None):
+            recommend_upgrade=True):
         """Open the workingtree object at this BzrDir if one is present.
 
         :param recommend_upgrade: Optional keyword parameter, when True (the
             default), emit through the ui module a recommendation that the user
             upgrade the working tree when the workingtree being opened is old
             (but still fully supported).
-        :param from_branch: override bzrdir branch (for lightweight checkouts)
         """
         raise NotImplementedError(self.open_workingtree)
 
@@ -987,16 +727,12 @@
             return False
 
     def _cloning_metadir(self):
-        """Produce a metadir suitable for cloning with.
-        
-        :returns: (destination_bzrdir_format, source_repository)
-        """
+        """Produce a metadir suitable for cloning with."""
         result_format = self._format.__class__()
         try:
             try:
                 branch = self.open_branch()
                 source_repository = branch.repository
-                result_format._branch_format = branch._format
             except errors.NotBranchError:
                 source_branch = None
                 source_repository = self.open_repository()
@@ -1020,18 +756,12 @@
             result_format.workingtree_format = tree._format.__class__()
         return result_format, source_repository
 
-    def cloning_metadir(self, require_stacking=False):
+    def cloning_metadir(self):
         """Produce a metadir suitable for cloning or sprouting with.
 
         These operations may produce workingtrees (yes, even though they're
         "cloning" something that doesn't have a tree), so a viable workingtree
         format must be selected.
-
-        :require_stacking: If True, non-stackable formats will be upgraded
-            to similar stackable formats.
-        :returns: a BzrDirFormat with all component formats either set
-            appropriately or set to None if that component should not be
-            created.
         """
         format, repository = self._cloning_metadir()
         if format._workingtree_format is None:
@@ -1039,33 +769,13 @@
                 return format
             tree_format = repository._format._matchingbzrdir.workingtree_format
             format.workingtree_format = tree_format.__class__()
-        if (require_stacking and not
-            format.get_branch_format().supports_stacking()):
-            # We need to make a stacked branch, but the default format for the
-            # target doesn't support stacking.  So force a branch that *can*
-            # support stacking.
-            from bzrlib.branch import BzrBranchFormat7
-            format._branch_format = BzrBranchFormat7()
-            mutter("using %r for stacking" % (format._branch_format,))
-            from bzrlib.repofmt import pack_repo
-            if format.repository_format.rich_root_data:
-                bzrdir_format_name = '1.6.1-rich-root'
-                repo_format = pack_repo.RepositoryFormatKnitPack5RichRoot()
-            else:
-                bzrdir_format_name = '1.6'
-                repo_format = pack_repo.RepositoryFormatKnitPack5()
-            note('Source format does not support stacking, using format:'
-                 ' \'%s\'\n  %s\n',
-                 bzrdir_format_name, repo_format.get_format_description())
-            format.repository_format = repo_format
         return format
 
     def checkout_metadir(self):
         return self.cloning_metadir()
 
     def sprout(self, url, revision_id=None, force_new_repo=False,
-               recurse='down', possible_transports=None,
-               accelerator_tree=None, hardlink=False, stacked=False):
+               recurse='down', possible_transports=None):
         """Create a copy of this bzrdir prepared for use as a new line of
         development.
 
@@ -1078,67 +788,51 @@
 
         if revision_id is not None, then the clone operation may tune
             itself to download less data.
-        :param accelerator_tree: A tree which can be used for retrieving file
-            contents more quickly than the revision tree, i.e. a workingtree.
-            The revision tree will be used for cases where accelerator_tree's
-            content is different.
-        :param hardlink: If true, hard-link files from accelerator_tree,
-            where possible.
-        :param stacked: If true, create a stacked branch referring to the
-            location of this control directory.
         """
         target_transport = get_transport(url, possible_transports)
         target_transport.ensure_base()
-        cloning_format = self.cloning_metadir(stacked)
-        # Create/update the result branch
+        cloning_format = self.cloning_metadir()
         result = cloning_format.initialize_on_transport(target_transport)
         try:
             source_branch = self.open_branch()
             source_repository = source_branch.repository
-            if stacked:
-                stacked_branch_url = self.root_transport.base
-            else:
-                # if a stacked branch wasn't requested, we don't create one
-                # even if the origin was stacked
-                stacked_branch_url = None
         except errors.NotBranchError:
             source_branch = None
             try:
                 source_repository = self.open_repository()
             except errors.NoRepositoryPresent:
                 source_repository = None
-            stacked_branch_url = None
-        repository_policy = result.determine_repository_policy(
-            force_new_repo, stacked_branch_url, require_stacking=stacked)
-        result_repo = repository_policy.acquire_repository()
-        if source_repository is not None:
-            # Fetch while stacked to prevent unstacked fetch from
-            # Branch.sprout.
-            result_repo.fetch(source_repository, revision_id=revision_id)
-
-        if source_branch is None:
-            # this is for sprouting a bzrdir without a branch; is that
-            # actually useful?
-            # Not especially, but it's part of the contract.
-            result_branch = result.create_branch()
-        else:
-            # Force NULL revision to avoid using repository before stacking
-            # is configured.
-            result_branch = source_branch.sprout(
-                result, revision_id=_mod_revision.NULL_REVISION)
-            parent_location = result_branch.get_parent()
-        mutter("created new branch %r" % (result_branch,))
-        repository_policy.configure_branch(result_branch)
+        if force_new_repo:
+            result_repo = None
+        else:
+            try:
+                result_repo = result.find_repository()
+            except errors.NoRepositoryPresent:
+                result_repo = None
+        if source_repository is None and result_repo is not None:
+            pass
+        elif source_repository is None and result_repo is None:
+            # no repo available, make a new one
+            result.create_repository()
+        elif source_repository is not None and result_repo is None:
+            # have source, and want to make a new target repo
+            result_repo = source_repository.sprout(result,
+                                                   revision_id=revision_id)
+        else:
+            # fetch needed content into target.
+            if source_repository is not None:
+                # would rather do 
+                # source_repository.copy_content_into(result_repo,
+                #                                     revision_id=revision_id)
+                # so we can override the copy method
+                result_repo.fetch(source_repository, revision_id=revision_id)
         if source_branch is not None:
-            source_branch.copy_content_into(result_branch, revision_id)
-            # Override copy_content_into
-            result_branch.set_parent(parent_location)
-
-        # Create/update the result working tree
+            source_branch.sprout(result, revision_id=revision_id)
+        else:
+            result.create_branch()
         if isinstance(target_transport, LocalTransport) and (
             result_repo is None or result_repo.make_working_trees()):
-            wt = result.create_workingtree(accelerator_tree=accelerator_tree,
-                hardlink=hardlink)
+            wt = result.create_workingtree()
             wt.lock_write()
             try:
                 if wt.path2id('') is None:
@@ -1155,10 +849,12 @@
                 basis = wt.basis_tree()
                 basis.lock_read()
                 subtrees = basis.iter_references()
+                recurse_branch = wt.branch
             elif source_branch is not None:
                 basis = source_branch.basis_tree()
                 basis.lock_read()
                 subtrees = basis.iter_references()
+                recurse_branch = source_branch
             else:
                 subtrees = []
                 basis = None
@@ -1168,8 +864,7 @@
                     sublocation = source_branch.reference_parent(file_id, path)
                     sublocation.bzrdir.sprout(target,
                         basis.get_reference_revision(file_id, path),
-                        force_new_repo=force_new_repo, recurse=recurse,
-                        stacked=stacked)
+                        force_new_repo=force_new_repo, recurse=recurse)
             finally:
                 if basis is not None:
                     basis.unlock()
@@ -1182,6 +877,8 @@
     def __init__(self, _transport, _format):
         """See BzrDir.__init__."""
         super(BzrDirPreSplitOut, self).__init__(_transport, _format)
+        assert self._format._lock_class == lockable_files.TransportLock
+        assert self._format._lock_file_name == 'branch-lock'
         self._control_files = lockable_files.LockableFiles(
                                             self.get_branch_transport(None),
                                             self._format._lock_file_name,
@@ -1191,38 +888,29 @@
         """Pre-splitout bzrdirs do not suffer from stale locks."""
         raise NotImplementedError(self.break_lock)
 
-    def cloning_metadir(self, require_stacking=False):
-        """Produce a metadir suitable for cloning with."""
-        if require_stacking:
-            return format_registry.make_bzrdir('1.6')
-        return self._format.__class__()
-
-    def clone(self, url, revision_id=None, force_new_repo=False,
-              preserve_stacking=False):
-        """See BzrDir.clone().
-
-        force_new_repo has no effect, since this family of formats always
-        require a new repository.
-        preserve_stacking has no effect, since no source branch using this
-        family of formats can be stacked, so there is no stacking to preserve.
-        """
+    def clone(self, url, revision_id=None, force_new_repo=False):
+        """See BzrDir.clone()."""
+        from bzrlib.workingtree import WorkingTreeFormat2
         self._make_tail(url)
         result = self._format._initialize_for_clone(url)
         self.open_repository().clone(result, revision_id=revision_id)
         from_branch = self.open_branch()
         from_branch.clone(result, revision_id=revision_id)
         try:
-            tree = self.open_workingtree()
+            self.open_workingtree().clone(result)
         except errors.NotLocalUrl:
             # make a new one, this format always has to have one.
-            result._init_workingtree()
-        else:
-            tree.clone(result)
+            try:
+                WorkingTreeFormat2().initialize(result)
+            except errors.NotLocalUrl:
+                # but we cannot do it for remote trees.
+                to_branch = result.open_branch()
+                WorkingTreeFormat2().stub_initialize_remote(to_branch.control_files)
         return result
 
     def create_branch(self):
         """See BzrDir.create_branch."""
-        return self._format.get_branch_format().initialize(self)
+        return self.open_branch()
 
     def destroy_branch(self):
         """See BzrDir.destroy_branch."""
@@ -1234,16 +922,8 @@
             raise errors.IncompatibleFormat('shared repository', self._format)
         return self.open_repository()
 
-    def destroy_repository(self):
-        """See BzrDir.destroy_repository."""
-        raise errors.UnsupportedOperation(self.destroy_repository, self)
-
-    def create_workingtree(self, revision_id=None, from_branch=None,
-                           accelerator_tree=None, hardlink=False):
+    def create_workingtree(self, revision_id=None):
         """See BzrDir.create_workingtree."""
-        # The workingtree is sometimes created when the bzrdir is created,
-        # but not when cloning.
-
         # this looks buggy but is not -really-
         # because this format creates the workingtree when the bzrdir is
         # created
@@ -1253,10 +933,7 @@
         # that can do wonky stuff here, and that only
         # happens for creating checkouts, which cannot be 
         # done on this format anyway. So - acceptable wart.
-        try:
-            result = self.open_workingtree(recommend_upgrade=False)
-        except errors.NoSuchFile:
-            result = self._init_workingtree()
+        result = self.open_workingtree(recommend_upgrade=False)
         if revision_id is not None:
             if revision_id == _mod_revision.NULL_REVISION:
                 result.set_parent_ids([])
@@ -1264,16 +941,6 @@
                 result.set_parent_ids([revision_id])
         return result
 
-    def _init_workingtree(self):
-        from bzrlib.workingtree import WorkingTreeFormat2
-        try:
-            return WorkingTreeFormat2().initialize(self)
-        except errors.NotLocalUrl:
-            # Even though we can't access the working tree, we need to
-            # create its control files.
-            return WorkingTreeFormat2()._stub_initialize_on_transport(
-                self.transport, self._control_files._file_mode)
-
     def destroy_workingtree(self):
         """See BzrDir.destroy_workingtree."""
         raise errors.UnsupportedOperation(self.destroy_workingtree, self)
@@ -1329,12 +996,8 @@
         return format.open(self, _found=True)
 
     def sprout(self, url, revision_id=None, force_new_repo=False,
-               possible_transports=None, accelerator_tree=None,
-               hardlink=False, stacked=False):
+               possible_transports=None):
         """See BzrDir.sprout()."""
-        if stacked:
-            raise errors.UnstackableBranchFormat(
-                self._format, self.root_transport.base)
         from bzrlib.workingtree import WorkingTreeFormat2
         self._make_tail(url)
         result = self._format._initialize_for_clone(url)
@@ -1347,9 +1010,7 @@
         except errors.NotBranchError:
             pass
         # we always want a working tree
-        WorkingTreeFormat2().initialize(result,
-                                        accelerator_tree=accelerator_tree,
-                                        hardlink=hardlink)
+        WorkingTreeFormat2().initialize(result)
         return result
 
 
@@ -1439,16 +1100,10 @@
         """See BzrDir.create_repository."""
         return self._format.repository_format.initialize(self, shared)
 
-    def destroy_repository(self):
-        """See BzrDir.destroy_repository."""
-        self.transport.delete_tree('repository')
-
-    def create_workingtree(self, revision_id=None, from_branch=None,
-                           accelerator_tree=None, hardlink=False):
+    def create_workingtree(self, revision_id=None):
         """See BzrDir.create_workingtree."""
-        return self._format.workingtree_format.initialize(
-            self, revision_id, from_branch=from_branch,
-            accelerator_tree=accelerator_tree, hardlink=hardlink)
+        from bzrlib.workingtree import WorkingTreeFormat
+        return self._format.workingtree_format.initialize(self, revision_id)
 
     def destroy_workingtree(self):
         """See BzrDir.destroy_workingtree."""
@@ -1578,9 +1233,6 @@
             basedir=self.root_transport.base)
         return format.open(self, _found=True)
 
-    def _get_config(self):
-        return config.BzrDirConfig(self.transport)
-
 
 class BzrDirFormat(object):
     """An encapsulation of the initialization and open routines for a format.
@@ -1648,7 +1300,7 @@
         try:
             return klass._formats[format_string]
         except KeyError:
-            raise errors.UnknownFormatError(format=format_string, kind='bzrdir')
+            raise errors.UnknownFormatError(format=format_string)
 
     @classmethod
     def get_default_format(klass):
@@ -1696,26 +1348,23 @@
                                       # FIXME: RBC 20060121 don't peek under
                                       # the covers
                                       mode=temp_control._dir_mode)
-        if sys.platform == 'win32' and isinstance(transport, LocalTransport):
-            win32utils.set_file_attr_hidden(transport._abspath('.bzr'))
         file_mode = temp_control._file_mode
         del temp_control
-        bzrdir_transport = transport.clone('.bzr')
-        utf8_files = [('README',
-                       "This is a Bazaar control directory.\n"
-                       "Do not change any files in this directory.\n"
-                       "See http://bazaar-vcs.org/ for more information about Bazaar.\n"),
+        mutter('created control directory in ' + transport.base)
+        control = transport.clone('.bzr')
+        utf8_files = [('README', 
+                       "This is a Bazaar-NG control directory.\n"
+                       "Do not change any files in this directory.\n"),
                       ('branch-format', self.get_format_string()),
                       ]
         # NB: no need to escape relative paths that are url safe.
-        control_files = lockable_files.LockableFiles(bzrdir_transport,
-            self._lock_file_name, self._lock_class)
+        control_files = lockable_files.LockableFiles(control,
+                            self._lock_file_name, self._lock_class)
         control_files.create_lock()
         control_files.lock_write()
         try:
-            for (filename, content) in utf8_files:
-                bzrdir_transport.put_bytes(filename, content,
-                    mode=file_mode)
+            for file, content in utf8_files:
+                control_files.put_utf8(file, content)
         finally:
             control_files.unlock()
         return self.open(transport, _found=True)
@@ -1800,6 +1449,11 @@
         klass._control_server_formats.append(format)
 
     @classmethod
+    @symbol_versioning.deprecated_method(symbol_versioning.zero_fourteen)
+    def set_default_format(klass, format):
+        klass._set_default_format(format)
+
+    @classmethod
     def _set_default_format(klass, format):
         """Set default format (for testing behavior of defaults only)"""
         klass._default_format = format
@@ -1810,6 +1464,7 @@
 
     @classmethod
     def unregister_format(klass, format):
+        assert klass._formats[format.get_format_string()] is format
         del klass._formats[format.get_format_string()]
 
     @classmethod
@@ -1886,10 +1541,6 @@
         """See BzrDirFormat.get_format_string()."""
         return "Bazaar-NG branch, format 5\n"
 
-    def get_branch_format(self):
-        from bzrlib import branch
-        return branch.BzrBranchFormat4()
-
     def get_format_description(self):
         """See BzrDirFormat.get_format_description()."""
         return "All-in-one format 5"
@@ -1909,11 +1560,17 @@
         """
         from bzrlib.branch import BzrBranchFormat4
         from bzrlib.repofmt.weaverepo import RepositoryFormat5
+        from bzrlib.workingtree import WorkingTreeFormat2
         result = (super(BzrDirFormat5, self).initialize_on_transport(transport))
         RepositoryFormat5().initialize(result, _internal=True)
         if not _cloning:
             branch = BzrBranchFormat4().initialize(result)
-            result._init_workingtree()
+            try:
+                WorkingTreeFormat2().initialize(result)
+            except errors.NotLocalUrl:
+                # Even though we can't access the working tree, we need to
+                # create its control files.
+                WorkingTreeFormat2().stub_initialize_remote(branch.control_files)
         return result
 
     def _open(self, transport):
@@ -1947,10 +1604,6 @@
         """See BzrDirFormat.get_format_description()."""
         return "All-in-one format 6"
 
-    def get_branch_format(self):
-        from bzrlib import branch
-        return branch.BzrBranchFormat4()
-
     def get_converter(self, format=None):
         """See BzrDirFormat.get_converter()."""
         # there is one and only one upgrade path here.
@@ -1966,11 +1619,17 @@
         """
         from bzrlib.branch import BzrBranchFormat4
         from bzrlib.repofmt.weaverepo import RepositoryFormat6
+        from bzrlib.workingtree import WorkingTreeFormat2
         result = super(BzrDirFormat6, self).initialize_on_transport(transport)
         RepositoryFormat6().initialize(result, _internal=True)
         if not _cloning:
             branch = BzrBranchFormat4().initialize(result)
-            result._init_workingtree()
+            try:
+                WorkingTreeFormat2().initialize(result)
+            except errors.NotLocalUrl:
+                # Even though we can't access the working tree, we need to
+                # create its control files.
+                WorkingTreeFormat2().stub_initialize_remote(branch.control_files)
         return result
 
     def _open(self, transport):
@@ -2051,7 +1710,7 @@
         return RepositoryFormat.get_default_format()
 
     def __set_repository_format(self, value):
-        """Allow changing the repository format for metadir formats."""
+        """Allow changint the repository format for metadir formats."""
         self._repository_format = value
 
     repository_format = property(__return_repository_format, __set_repository_format)
@@ -2157,10 +1816,7 @@
         self.pb.note('  %6d revisions not present', len(self.absent_revisions))
         self.pb.note('  %6d texts', self.text_count)
         self._cleanup_spare_files_after_format4()
-        self.branch._transport.put_bytes(
-            'branch-format',
-            BzrDirFormat5().get_format_string(),
-            mode=self.bzrdir._get_file_mode())
+        self.branch.control_files.put_utf8('branch-format', BzrDirFormat5().get_format_string())
 
     def _cleanup_spare_files_after_format4(self):
         # FIXME working tree upgrade foo.
@@ -2175,10 +1831,10 @@
 
     def _convert_working_inv(self):
         inv = xml4.serializer_v4.read_inventory(
-                self.branch._transport.get('inventory'))
+                    self.branch.control_files.get('inventory'))
         new_inv_xml = xml5.serializer_v5.write_inventory_to_string(inv, working=True)
-        self.branch._transport.put_bytes('inventory', new_inv_xml,
-            mode=self.bzrdir._get_file_mode())
+        # FIXME inventory is a working tree change.
+        self.branch.control_files.put('inventory', StringIO(new_inv_xml))
 
     def _write_all_weaves(self):
         controlweaves = WeaveStore(self.bzrdir.transport, prefixed=False)
@@ -2204,18 +1860,14 @@
         self.bzrdir.transport.mkdir('revision-store')
         revision_transport = self.bzrdir.transport.clone('revision-store')
         # TODO permissions
-        from bzrlib.xml5 import serializer_v5
-        from bzrlib.repofmt.weaverepo import RevisionTextStore
-        revision_store = RevisionTextStore(revision_transport,
-            serializer_v5, False, versionedfile.PrefixMapper(),
-            lambda:True, lambda:True)
+        _revision_store = TextRevisionStore(TextStore(revision_transport,
+                                                      prefixed=False,
+                                                      compressed=True))
         try:
+            transaction = WriteTransaction()
             for i, rev_id in enumerate(self.converted_revs):
                 self.pb.update('write revision', i, len(self.converted_revs))
-                text = serializer_v5.write_revision_to_string(
-                    self.revisions[rev_id])
-                key = (rev_id,)
-                revision_store.add_lines(key, None, osutils.split_lines(text))
+                _revision_store.add_revision(self.revisions[rev_id], transaction)
         finally:
             self.pb.clear()
             
@@ -2234,22 +1886,28 @@
                          rev_id)
             self.absent_revisions.add(rev_id)
         else:
-            rev = self.branch.repository.get_revision(rev_id)
+            rev = self.branch.repository._revision_store.get_revision(rev_id,
+                self.branch.repository.get_transaction())
             for parent_id in rev.parent_ids:
                 self.known_revisions.add(parent_id)
                 self.to_read.append(parent_id)
             self.revisions[rev_id] = rev
 
     def _load_old_inventory(self, rev_id):
+        assert rev_id not in self.converted_revs
         old_inv_xml = self.branch.repository.inventory_store.get(rev_id).read()
         inv = xml4.serializer_v4.read_inventory_from_string(old_inv_xml)
         inv.revision_id = rev_id
         rev = self.revisions[rev_id]
+        if rev.inventory_sha1:
+            assert rev.inventory_sha1 == sha_string(old_inv_xml), \
+                'inventory sha mismatch for {%s}' % rev_id
         return inv
 
     def _load_updated_inventory(self, rev_id):
+        assert rev_id in self.converted_revs
         inv_xml = self.inv_weave.get_text(rev_id)
-        inv = xml5.serializer_v5.read_inventory_from_string(inv_xml, rev_id)
+        inv = xml5.serializer_v5.read_inventory_from_string(inv_xml)
         return inv
 
     def _convert_one_rev(self, rev_id):
@@ -2263,6 +1921,14 @@
         self.converted_revs.add(rev_id)
 
     def _store_new_inv(self, rev, inv, present_parents):
+        # the XML is now updated with text versions
+        if __debug__:
+            entries = inv.iter_entries()
+            entries.next()
+            for path, ie in entries:
+                assert getattr(ie, 'revision', None) is not None, \
+                    'no revision on {%s} in {%s}' % \
+                    (file_id, rev.revision_id)
         new_inv_xml = xml5.serializer_v5.write_inventory_to_string(inv)
         new_inv_sha1 = sha_string(new_inv_xml)
         self.inv_weave.add_lines(rev.revision_id,
@@ -2297,6 +1963,10 @@
             self.text_weaves[file_id] = w
         text_changed = False
         parent_candiate_entries = ie.parent_candidates(parent_invs)
+        for old_revision in parent_candiate_entries.keys():
+            # if this fails, its a ghost ?
+            assert old_revision in self.converted_revs, \
+                "Revision {%s} not in converted_revs" % old_revision
         heads = graph.Graph(self).heads(parent_candiate_entries.keys())
         # XXX: Note that this is unordered - and this is tolerable because 
         # the previous code was also unordered.
@@ -2304,18 +1974,12 @@
             in heads)
         self.snapshot_ie(previous_entries, ie, w, rev_id)
         del ie.text_id
+        assert getattr(ie, 'revision', None) is not None
 
-    @symbol_versioning.deprecated_method(symbol_versioning.one_one)
     def get_parents(self, revision_ids):
         for revision_id in revision_ids:
             yield self.revisions[revision_id].parent_ids
 
-    def get_parent_map(self, revision_ids):
-        """See graph._StackedParentsProvider.get_parent_map"""
-        return dict((revision_id, self.revisions[revision_id])
-                    for revision_id in revision_ids
-                     if revision_id in self.revisions)
-
     def snapshot_ie(self, previous_revisions, ie, w, rev_id):
         # TODO: convert this logic, which is ~= snapshot to
         # a call to:. This needs the path figured out. rather than a work_tree
@@ -2330,8 +1994,10 @@
                 ie.revision = previous_ie.revision
                 return
         if ie.has_text():
-            text = self.branch.repository._text_store.get(ie.text_id)
+            text = self.branch.repository.weave_store.get(ie.text_id)
             file_lines = text.readlines()
+            assert sha_strings(file_lines) == ie.text_sha1
+            assert sum(map(len, file_lines)) == ie.text_size
             w.add_lines(rev_id, previous_revisions, file_lines)
             self.text_count += 1
         else:
@@ -2384,21 +2050,17 @@
                 if (filename.endswith(".weave") or
                     filename.endswith(".gz") or
                     filename.endswith(".sig")):
-                    file_id, suffix = os.path.splitext(filename)
+                    file_id = os.path.splitext(filename)[0]
                 else:
                     file_id = filename
-                    suffix = ''
-                new_name = store._mapper.map((file_id,)) + suffix
+                prefix_dir = store.hash_prefix(file_id)
                 # FIXME keep track of the dirs made RBC 20060121
                 try:
-                    store_transport.move(filename, new_name)
+                    store_transport.move(filename, prefix_dir + '/' + filename)
                 except errors.NoSuchFile: # catches missing dirs strangely enough
-                    store_transport.mkdir(osutils.dirname(new_name))
-                    store_transport.move(filename, new_name)
-        self.bzrdir.transport.put_bytes(
-            'branch-format',
-            BzrDirFormat6().get_format_string(),
-            mode=self.bzrdir._get_file_mode())
+                    store_transport.mkdir(prefix_dir)
+                    store_transport.move(filename, prefix_dir + '/' + filename)
+        self.bzrdir._control_files.put_utf8('branch-format', BzrDirFormat6().get_format_string())
 
 
 class ConvertBzrDir6ToMeta(Converter):
@@ -2413,14 +2075,9 @@
         self.count = 0
         self.total = 20 # the steps we know about
         self.garbage_inventories = []
-        self.dir_mode = self.bzrdir._get_dir_mode()
-        self.file_mode = self.bzrdir._get_file_mode()
 
         self.pb.note('starting upgrade from format 6 to metadir')
-        self.bzrdir.transport.put_bytes(
-                'branch-format',
-                "Converting to format 6",
-                mode=self.file_mode)
+        self.bzrdir._control_files.put_utf8('branch-format', "Converting to format 6")
         # its faster to move specific files around than to open and use the apis...
         # first off, nuke ancestry.weave, it was never used.
         try:
@@ -2436,6 +2093,8 @@
             if name.startswith('basis-inventory.'):
                 self.garbage_inventories.append(name)
         # create new directories for repository, working tree and branch
+        self.dir_mode = self.bzrdir._control_files._dir_mode
+        self.file_mode = self.bzrdir._control_files._file_mode
         repository_names = [('inventory.weave', True),
                             ('revision-store', True),
                             ('weaves', True)]
@@ -2489,12 +2148,10 @@
             for entry in checkout_files:
                 self.move_entry('checkout', entry)
             if last_revision is not None:
-                self.bzrdir.transport.put_bytes(
+                self.bzrdir._control_files.put_utf8(
                     'checkout/last-revision', last_revision)
-        self.bzrdir.transport.put_bytes(
-            'branch-format',
-            BzrDirMetaFormat1().get_format_string(),
-            mode=self.file_mode)
+        self.bzrdir._control_files.put_utf8(
+            'branch-format', BzrDirMetaFormat1().get_format_string())
         return BzrDir.open(self.bzrdir.root_transport.base)
 
     def make_lock(self, name):
@@ -2518,9 +2175,7 @@
                 raise
 
     def put_format(self, dirname, format):
-        self.bzrdir.transport.put_bytes('%s/format' % dirname,
-            format.get_format_string(),
-            self.file_mode)
+        self.bzrdir._control_files.put_utf8('%s/format' % dirname, format.get_format_string())
 
 
 class ConvertMetaToMeta(Converter):
@@ -2556,24 +2211,14 @@
             pass
         else:
             # TODO: conversions of Branch and Tree should be done by
-            # InterXFormat lookups/some sort of registry.
+            # InterXFormat lookups
             # Avoid circular imports
             from bzrlib import branch as _mod_branch
-            old = branch._format.__class__
-            new = self.target_format.get_branch_format().__class__
-            while old != new:
-                if (old == _mod_branch.BzrBranchFormat5 and
-                    new in (_mod_branch.BzrBranchFormat6,
-                        _mod_branch.BzrBranchFormat7)):
-                    branch_converter = _mod_branch.Converter5to6()
-                elif (old == _mod_branch.BzrBranchFormat6 and
-                    new == _mod_branch.BzrBranchFormat7):
-                    branch_converter = _mod_branch.Converter6to7()
-                else:
-                    raise errors.BadConversionTarget("No converter", new)
+            if (branch._format.__class__ is _mod_branch.BzrBranchFormat5 and
+                self.target_format.get_branch_format().__class__ is
+                _mod_branch.BzrBranchFormat6):
+                branch_converter = _mod_branch.Converter5to6()
                 branch_converter.convert(branch)
-                branch = self.bzrdir.open_branch()
-                old = branch._format.__class__
         try:
             tree = self.bzrdir.open_workingtree(recommend_upgrade=False)
         except (errors.NoWorkingTree, errors.NotLocalUrl):
@@ -2603,39 +2248,35 @@
     def probe_transport(klass, transport):
         """Return a RemoteBzrDirFormat object if it looks possible."""
         try:
-            medium = transport.get_smart_medium()
+            client = transport.get_smart_client()
         except (NotImplementedError, AttributeError,
-                errors.TransportNotPossible, errors.NoSmartMedium,
-                errors.SmartProtocolError):
+                errors.TransportNotPossible):
             # no smart server, so not a branch for this format type.
             raise errors.NotBranchError(path=transport.base)
         else:
-            # Decline to open it if the server doesn't support our required
-            # version (3) so that the VFS-based transport will do it.
-            if medium.should_probe():
-                try:
-                    server_version = medium.protocol_version()
-                except errors.SmartProtocolError:
-                    # Apparently there's no usable smart server there, even though
-                    # the medium supports the smart protocol.
-                    raise errors.NotBranchError(path=transport.base)
-                if server_version != '2':
-                    raise errors.NotBranchError(path=transport.base)
+            # Send a 'hello' request in protocol version one, and decline to
+            # open it if the server doesn't support our required version (2) so
+            # that the VFS-based transport will do it.
+            request = client.get_request()
+            smart_protocol = protocol.SmartClientRequestProtocolOne(request)
+            server_version = smart_protocol.query_version()
+            if server_version != 2:
+                raise errors.NotBranchError(path=transport.base)
             return klass()
 
     def initialize_on_transport(self, transport):
         try:
             # hand off the request to the smart server
-            client_medium = transport.get_smart_medium()
+            shared_medium = transport.get_shared_medium()
         except errors.NoSmartMedium:
             # TODO: lookup the local format from a server hint.
             local_dir_format = BzrDirMetaFormat1()
             return local_dir_format.initialize_on_transport(transport)
-        client = _SmartClient(client_medium)
+        client = _SmartClient(shared_medium)
         path = client.remote_path_from_transport(transport)
-        response = client.call('BzrDirFormat.initialize', path)
-        if response[0] != 'ok':
-            raise errors.SmartProtocolError('unexpected response code %s' % (response,))
+        response = _SmartClient(shared_medium).call('BzrDirFormat.initialize',
+                                                    path)
+        assert response[0] in ('ok', ), 'unexpected response code %s' % (response,)
         return remote.RemoteBzrDir(transport)
 
     def _open(self, transport):
@@ -2652,11 +2293,10 @@
 
 class BzrDirFormatInfo(object):
 
-    def __init__(self, native, deprecated, hidden, experimental):
+    def __init__(self, native, deprecated, hidden):
         self.deprecated = deprecated
         self.native = native
         self.hidden = hidden
-        self.experimental = experimental
 
 
 class BzrDirFormatRegistry(registry.Registry):
@@ -2666,22 +2306,11 @@
     e.g. BzrDirMeta1 with weave repository.  Also, it's more user-oriented.
     """
 
-    def __init__(self):
-        """Create a BzrDirFormatRegistry."""
-        self._aliases = set()
-        super(BzrDirFormatRegistry, self).__init__()
-
-    def aliases(self):
-        """Return a set of the format names which are aliases."""
-        return frozenset(self._aliases)
-
     def register_metadir(self, key,
              repository_format, help, native=True, deprecated=False,
              branch_format=None,
              tree_format=None,
-             hidden=False,
-             experimental=False,
-             alias=False):
+             hidden=False):
         """Register a metadir subformat.
 
         These all use a BzrDirMetaFormat1 bzrdir, but can be parameterized
@@ -2719,11 +2348,10 @@
             if repository_format is not None:
                 bd.repository_format = _load(repository_format)
             return bd
-        self.register(key, helper, help, native, deprecated, hidden,
-            experimental, alias)
+        self.register(key, helper, help, native, deprecated, hidden)
 
     def register(self, key, factory, help, native=True, deprecated=False,
-                 hidden=False, experimental=False, alias=False):
+                 hidden=False):
         """Register a BzrDirFormat factory.
         
         The factory must be a callable that takes one parameter: the key.
@@ -2732,26 +2360,21 @@
         This function mainly exists to prevent the info object from being
         supplied directly.
         """
-        registry.Registry.register(self, key, factory, help,
-            BzrDirFormatInfo(native, deprecated, hidden, experimental))
-        if alias:
-            self._aliases.add(key)
+        registry.Registry.register(self, key, factory, help, 
+            BzrDirFormatInfo(native, deprecated, hidden))
 
     def register_lazy(self, key, module_name, member_name, help, native=True,
-        deprecated=False, hidden=False, experimental=False, alias=False):
-        registry.Registry.register_lazy(self, key, module_name, member_name,
-            help, BzrDirFormatInfo(native, deprecated, hidden, experimental))
-        if alias:
-            self._aliases.add(key)
+                      deprecated=False, hidden=False):
+        registry.Registry.register_lazy(self, key, module_name, member_name, 
+            help, BzrDirFormatInfo(native, deprecated, hidden))
 
     def set_default(self, key):
         """Set the 'default' key to be a clone of the supplied key.
         
         This method must be called once and only once.
         """
-        registry.Registry.register(self, 'default', self.get(key),
+        registry.Registry.register(self, 'default', self.get(key), 
             self.get_help(key), info=self.get_info(key))
-        self._aliases.add('default')
 
     def set_default_repository(self, key):
         """Set the FormatRegistry default and Repository default.
@@ -2763,6 +2386,7 @@
             self.remove('default')
         self.set_default(key)
         format = self.get('default')()
+        assert isinstance(format, BzrDirMetaFormat1)
 
     def make_bzrdir(self, key):
         return self.get(key)()
@@ -2795,22 +2419,14 @@
             output += wrapped(default_realkey, '(default) %s' % default_help,
                               self.get_info('default'))
         deprecated_pairs = []
-        experimental_pairs = []
         for key, help in help_pairs:
             info = self.get_info(key)
             if info.hidden:
                 continue
             elif info.deprecated:
                 deprecated_pairs.append((key, help))
-            elif info.experimental:
-                experimental_pairs.append((key, help))
             else:
                 output += wrapped(key, help, info)
-        if len(experimental_pairs) > 0:
-            output += "Experimental formats are shown below.\n\n"
-            for key, help in experimental_pairs:
-                info = self.get_info(key)
-                output += wrapped(key, help, info)
         if len(deprecated_pairs) > 0:
             output += "Deprecated formats are shown below.\n\n"
             for key, help in deprecated_pairs:
@@ -2820,138 +2436,6 @@
         return output
 
 
-class RepositoryAcquisitionPolicy(object):
-    """Abstract base class for repository acquisition policies.
-
-    A repository acquisition policy decides how a BzrDir acquires a repository
-    for a branch that is being created.  The most basic policy decision is
-    whether to create a new repository or use an existing one.
-    """
-    def __init__(self, stack_on, stack_on_pwd, require_stacking):
-        """Constructor.
-
-        :param stack_on: A location to stack on
-        :param stack_on_pwd: If stack_on is relative, the location it is
-            relative to.
-        :param require_stacking: If True, it is a failure to not stack.
-        """
-        self._stack_on = stack_on
-        self._stack_on_pwd = stack_on_pwd
-        self._require_stacking = require_stacking
-
-    def configure_branch(self, branch):
-        """Apply any configuration data from this policy to the branch.
-
-        Default implementation sets repository stacking.
-        """
-        if self._stack_on is None:
-            return
-        if self._stack_on_pwd is None:
-            stack_on = self._stack_on
-        else:
-            try:
-                stack_on = urlutils.rebase_url(self._stack_on,
-                    self._stack_on_pwd,
-                    branch.bzrdir.root_transport.base)
-            except errors.InvalidRebaseURLs:
-                stack_on = self._get_full_stack_on()
-        try:
-            branch.set_stacked_on_url(stack_on)
-        except errors.UnstackableBranchFormat:
-            if self._require_stacking:
-                raise
-
-    def _get_full_stack_on(self):
-        """Get a fully-qualified URL for the stack_on location."""
-        if self._stack_on is None:
-            return None
-        if self._stack_on_pwd is None:
-            return self._stack_on
-        else:
-            return urlutils.join(self._stack_on_pwd, self._stack_on)
-
-    def _add_fallback(self, repository):
-        """Add a fallback to the supplied repository, if stacking is set."""
-        stack_on = self._get_full_stack_on()
-        if stack_on is None:
-            return
-        stacked_dir = BzrDir.open(stack_on)
-        try:
-            stacked_repo = stacked_dir.open_branch().repository
-        except errors.NotBranchError:
-            stacked_repo = stacked_dir.open_repository()
-        try:
-            repository.add_fallback_repository(stacked_repo)
-        except errors.UnstackableRepositoryFormat:
-            if self._require_stacking:
-                raise
-
-    def acquire_repository(self, make_working_trees=None, shared=False):
-        """Acquire a repository for this bzrdir.
-
-        Implementations may create a new repository or use a pre-exising
-        repository.
-        :param make_working_trees: If creating a repository, set
-            make_working_trees to this value (if non-None)
-        :param shared: If creating a repository, make it shared if True
-        :return: A repository
-        """
-        raise NotImplemented(RepositoryAcquisitionPolicy.acquire_repository)
-
-
-class CreateRepository(RepositoryAcquisitionPolicy):
-    """A policy of creating a new repository"""
-
-    def __init__(self, bzrdir, stack_on=None, stack_on_pwd=None,
-                 require_stacking=False):
-        """
-        Constructor.
-        :param bzrdir: The bzrdir to create the repository on.
-        :param stack_on: A location to stack on
-        :param stack_on_pwd: If stack_on is relative, the location it is
-            relative to.
-        """
-        RepositoryAcquisitionPolicy.__init__(self, stack_on, stack_on_pwd,
-                                             require_stacking)
-        self._bzrdir = bzrdir
-
-    def acquire_repository(self, make_working_trees=None, shared=False):
-        """Implementation of RepositoryAcquisitionPolicy.acquire_repository
-
-        Creates the desired repository in the bzrdir we already have.
-        """
-        repository = self._bzrdir.create_repository(shared=shared)
-        self._add_fallback(repository)
-        if make_working_trees is not None:
-            repository.set_make_working_trees(make_working_trees)
-        return repository
-
-
-class UseExistingRepository(RepositoryAcquisitionPolicy):
-    """A policy of reusing an existing repository"""
-
-    def __init__(self, repository, stack_on=None, stack_on_pwd=None,
-                 require_stacking=False):
-        """Constructor.
-
-        :param repository: The repository to use.
-        :param stack_on: A location to stack on
-        :param stack_on_pwd: If stack_on is relative, the location it is
-            relative to.
-        """
-        RepositoryAcquisitionPolicy.__init__(self, stack_on, stack_on_pwd,
-                                             require_stacking)
-        self._repository = repository
-
-    def acquire_repository(self, make_working_trees=None, shared=False):
-        """Implementation of RepositoryAcquisitionPolicy.acquire_repository
-
-        Returns an existing repository to use
-        """
-        self._add_fallback(self._repository)
-        return self._repository
-
-
 format_registry = BzrDirFormatRegistry()
 format_registry.register('weave', BzrDirFormat6,
     'Pre-0.8 format.  Slower than knit and does not'
@@ -2985,13 +2469,6 @@
     branch_format='bzrlib.branch.BzrBranchFormat6',
     tree_format='bzrlib.workingtree.WorkingTreeFormat4',
     )
-format_registry.register_metadir('rich-root',
-    'bzrlib.repofmt.knitrepo.RepositoryFormatKnit4',
-    help='New in 1.0.  Better handling of tree roots.  Incompatible with'
-        ' bzr < 1.0',
-    branch_format='bzrlib.branch.BzrBranchFormat6',
-    tree_format='bzrlib.workingtree.WorkingTreeFormat4',
-    )
 format_registry.register_metadir('dirstate-with-subtree',
     'bzrlib.repofmt.knitrepo.RepositoryFormatKnit3',
     help='New in 0.15: Fast local operations and improved scaling for '
@@ -2999,103 +2476,6 @@
         'bzr branches. Incompatible with bzr < 0.15.',
     branch_format='bzrlib.branch.BzrBranchFormat6',
     tree_format='bzrlib.workingtree.WorkingTreeFormat4',
-    experimental=True,
-    hidden=True,
-    )
-format_registry.register_metadir('pack-0.92',
-    'bzrlib.repofmt.pack_repo.RepositoryFormatKnitPack1',
-    help='New in 0.92: Pack-based format with data compatible with '
-        'dirstate-tags format repositories. Interoperates with '
-        'bzr repositories before 0.92 but cannot be read by bzr < 0.92. '
-        'Previously called knitpack-experimental.  '
-        'For more information, see '
-        'http://doc.bazaar-vcs.org/latest/developers/packrepo.html.',
-    branch_format='bzrlib.branch.BzrBranchFormat6',
-    tree_format='bzrlib.workingtree.WorkingTreeFormat4',
-    )
-format_registry.register_metadir('pack-0.92-subtree',
-    'bzrlib.repofmt.pack_repo.RepositoryFormatKnitPack3',
-    help='New in 0.92: Pack-based format with data compatible with '
-        'dirstate-with-subtree format repositories. Interoperates with '
-        'bzr repositories before 0.92 but cannot be read by bzr < 0.92. '
-        'Previously called knitpack-experimental.  '
-        'For more information, see '
-        'http://doc.bazaar-vcs.org/latest/developers/packrepo.html.',
-    branch_format='bzrlib.branch.BzrBranchFormat6',
-    tree_format='bzrlib.workingtree.WorkingTreeFormat4',
-    hidden=True,
-    experimental=True,
-    )
-format_registry.register_metadir('rich-root-pack',
-    'bzrlib.repofmt.pack_repo.RepositoryFormatKnitPack4',
-    help='New in 1.0: Pack-based format with data compatible with '
-        'rich-root format repositories. Incompatible with'
-        ' bzr < 1.0',
-    branch_format='bzrlib.branch.BzrBranchFormat6',
-    tree_format='bzrlib.workingtree.WorkingTreeFormat4',
-    )
-format_registry.register_metadir('1.6',
-    'bzrlib.repofmt.pack_repo.RepositoryFormatKnitPack5',
-    help='A branch and pack based repository that supports stacking. ',
-    branch_format='bzrlib.branch.BzrBranchFormat7',
-    tree_format='bzrlib.workingtree.WorkingTreeFormat4',
-    )
-format_registry.register_metadir('1.6.1-rich-root',
-    'bzrlib.repofmt.pack_repo.RepositoryFormatKnitPack5RichRoot',
-    help='A branch and pack based repository that supports stacking '
-         'and rich root data (needed for bzr-svn). ',
-    branch_format='bzrlib.branch.BzrBranchFormat7',
-    tree_format='bzrlib.workingtree.WorkingTreeFormat4',
-    )
-# The following two formats should always just be aliases.
-format_registry.register_metadir('development',
-    'bzrlib.repofmt.pack_repo.RepositoryFormatPackDevelopment1',
-    help='Current development format. Can convert data to and from pack-0.92 '
-        '(and anything compatible with pack-0.92) format repositories. '
-        'Repositories and branches in this format can only be read by bzr.dev. '
-        'Please read '
-        'http://doc.bazaar-vcs.org/latest/developers/development-repo.html '
-        'before use.',
-    branch_format='bzrlib.branch.BzrBranchFormat7',
-    tree_format='bzrlib.workingtree.WorkingTreeFormat4',
-    experimental=True,
-    alias=True,
-    )
-format_registry.register_metadir('development-subtree',
-    'bzrlib.repofmt.pack_repo.RepositoryFormatPackDevelopment1Subtree',
-    help='Current development format, subtree variant. Can convert data to and '
-        'from pack-0.92-subtree (and anything compatible with '
-        'pack-0.92-subtree) format repositories. Repositories and branches in '
-        'this format can only be read by bzr.dev. Please read '
-        'http://doc.bazaar-vcs.org/latest/developers/development-repo.html '
-        'before use.',
-    branch_format='bzrlib.branch.BzrBranchFormat7',
-    tree_format='bzrlib.workingtree.WorkingTreeFormat4',
-    experimental=True,
-    alias=True,
-    )
-# And the development formats which the will have aliased one of follow:
-format_registry.register_metadir('development1',
-    'bzrlib.repofmt.pack_repo.RepositoryFormatPackDevelopment1',
-    help='A branch and pack based repository that supports stacking. '
-        'Please read '
-        'http://doc.bazaar-vcs.org/latest/developers/development-repo.html '
-        'before use.',
-    branch_format='bzrlib.branch.BzrBranchFormat7',
-    tree_format='bzrlib.workingtree.WorkingTreeFormat4',
-    hidden=True,
-    experimental=True,
-    )
-format_registry.register_metadir('development1-subtree',
-    'bzrlib.repofmt.pack_repo.RepositoryFormatPackDevelopment1Subtree',
-    help='A branch and pack based repository that supports stacking. '
-        'Please read '
-        'http://doc.bazaar-vcs.org/latest/developers/development-repo.html '
-        'before use.',
-    branch_format='bzrlib.branch.BzrBranchFormat7',
-    tree_format='bzrlib.workingtree.WorkingTreeFormat4',
-    hidden=True,
-    experimental=True,
-    )
-# The current format that is made on 'bzr init'.
-format_registry.set_default('pack-0.92')
+    hidden=True,
+    )
+format_registry.set_default('dirstate-tags')

=== modified file 'bzrlib/check.py'
--- bzrlib/check.py	2008-07-28 06:53:44 +0000
+++ bzrlib/check.py	2007-10-12 03:06:52 +0000
@@ -32,17 +32,12 @@
 # raising them.  If there's more than one exception it'd be good to see them
 # all.
 
-from bzrlib import errors, osutils
+from bzrlib import errors
 from bzrlib import repository as _mod_repository
 from bzrlib import revision
-from bzrlib.branch import Branch
-from bzrlib.bzrdir import BzrDir
 from bzrlib.errors import BzrCheckError
-from bzrlib.repository import Repository
-from bzrlib.symbol_versioning import deprecated_function, deprecated_in
+import bzrlib.ui
 from bzrlib.trace import log_error, note
-import bzrlib.ui
-from bzrlib.workingtree import WorkingTree
 
 class Check(object):
     """Check a repository"""
@@ -60,8 +55,10 @@
         self.missing_revision_cnt = 0
         # maps (file-id, version) -> sha1; used by InventoryFile._check
         self.checked_texts = {}
-        self.checked_weaves = set()
-        self.unreferenced_versions = set()
+        self.checked_weaves = {}
+        self.revision_versions = _mod_repository._RevisionTextVersionCache(
+            self.repository)
+        self.unreferenced_ancestors = set()
         self.inconsistent_parents = []
 
     def check(self):
@@ -71,7 +68,7 @@
             self.progress.update('retrieving inventory', 0, 2)
             # do not put in init, as it should be done with progess,
             # and inside the lock.
-            self.inventory_weave = self.repository.inventories
+            self.inventory_weave = self.repository.get_inventory_weave()
             self.progress.update('checking revision graph', 1)
             self.check_revision_graph()
             self.plan_revisions()
@@ -83,7 +80,7 @@
                 revno += 1
                 self.check_one_rev(rev_id)
             # check_weaves is done after the revision scan so that
-            # revision index is known to be valid.
+            # revision_versions is pre-populated
             self.check_weaves()
         finally:
             self.progress.finished()
@@ -101,7 +98,7 @@
         repository = self.repository
         self.planned_revisions = repository.all_revision_ids()
         self.progress.clear()
-        inventoried = set(key[-1] for key in self.inventory_weave.keys())
+        inventoried = set(self.inventory_weave.versions())
         awol = set(self.planned_revisions) - inventoried
         if len(awol) > 0:
             raise BzrCheckError('Stored revisions missing from inventory'
@@ -115,8 +112,8 @@
         note('%6d file-ids', len(self.checked_weaves))
         note('%6d unique file texts', self.checked_text_cnt)
         note('%6d repeated file texts', self.repeated_text_cnt)
-        note('%6d unreferenced text versions',
-             len(self.unreferenced_versions))
+        note('%6d unreferenced text ancestors',
+             len(self.unreferenced_ancestors))
         if self.missing_inventory_sha_cnt:
             note('%6d revisions are missing inventory_sha1',
                  self.missing_inventory_sha_cnt)
@@ -137,8 +134,8 @@
                     for linker in linkers:
                         note('       * %s', linker)
             if verbose:
-                for file_id, revision_id in self.unreferenced_versions:
-                    log_error('unreferenced version: {%s} in %s', revision_id,
+                for file_id, revision_id in self.unreferenced_ancestors:
+                    log_error('unreferenced ancestor: {%s} in %s', revision_id,
                         file_id)
         if len(self.inconsistent_parents):
             note('%6d inconsistent parents', len(self.inconsistent_parents))
@@ -198,29 +195,38 @@
     def check_weaves(self):
         """Check all the weaves we can get our hands on.
         """
+        n_weaves = 1
         weave_ids = []
-        self.progress.update('checking inventory', 0, 2)
+        if self.repository.weave_store.listable():
+            weave_ids = list(self.repository.weave_store)
+            n_weaves = len(weave_ids) + 1
+        self.progress.update('checking versionedfile', 0, n_weaves)
         self.inventory_weave.check(progress_bar=self.progress)
-        self.progress.update('checking text storage', 1, 2)
-        self.repository.texts.check(progress_bar=self.progress)
-        weave_checker = self.repository._get_versioned_file_checker()
-        result = weave_checker.check_file_version_parents(
-            self.repository.texts, progress_bar=self.progress)
-        self.checked_weaves = weave_checker.file_ids
-        bad_parents, unused_versions = result
-        bad_parents = bad_parents.items()
-        for text_key, (stored_parents, correct_parents) in bad_parents:
-            # XXX not ready for id join/split operations.
-            weave_id = text_key[0]
-            revision_id = text_key[-1]
-            weave_parents = tuple([parent[-1] for parent in stored_parents])
-            correct_parents = tuple([parent[-1] for parent in correct_parents])
-            self.inconsistent_parents.append(
-                (revision_id, weave_id, weave_parents, correct_parents))
-        self.unreferenced_versions.update(unused_versions)
+        files_in_revisions = {}
+        revisions_of_files = {}
+        for i, weave_id in enumerate(weave_ids):
+            self.progress.update('checking versionedfile', i, n_weaves)
+            w = self.repository.weave_store.get_weave(weave_id,
+                    self.repository.get_transaction())
+            # No progress here, because it looks ugly.
+            w.check()
+
+            weave_checker = self.repository.get_versioned_file_checker(
+                self.planned_revisions, self.revision_versions)
+            result = weave_checker.check_file_version_parents(w, weave_id)
+
+            for revision_id, (weave_parents,correct_parents) in result.items():
+                self.inconsistent_parents.append(
+                    (revision_id, weave_id, weave_parents, correct_parents))
+                unreferenced_parents = set(weave_parents)-set(correct_parents)
+                for unreferenced_parent in unreferenced_parents:
+                    self.unreferenced_ancestors.add(
+                        (weave_id, unreferenced_parent))
+            self.checked_weaves[weave_id] = True
 
     def _check_revision_tree(self, rev_id):
         tree = self.repository.revision_tree(rev_id)
+        self.revision_versions.add_revision_text_versions(tree)
         inv = tree.inventory
         seen_ids = {}
         for file_id in inv:
@@ -241,78 +247,21 @@
             seen_names[path] = True
 
 
-@deprecated_function(deprecated_in((1,6,0)))
 def check(branch, verbose):
     """Run consistency checks on a branch.
     
     Results are reported through logging.
     
-    Deprecated in 1.6.  Please use check_branch instead.
-
-    :raise BzrCheckError: if there's a consistency error.
-    """
-    check_branch(branch, verbose)
-
-
-def check_branch(branch, verbose):
-    """Run consistency checks on a branch.
-
-    Results are reported through logging.
-
     :raise BzrCheckError: if there's a consistency error.
     """
     branch.lock_read()
     try:
         branch_result = branch.check()
+        repo_result = branch.repository.check([branch.last_revision()])
     finally:
         branch.unlock()
     branch_result.report_results(verbose)
-
-
-def check_dwim(path, verbose, do_branch=False, do_repo=False, do_tree=False):
-    try:
-        tree, branch, repo, relpath = \
-                        BzrDir.open_containing_tree_branch_or_repository(path)
-    except errors.NotBranchError:
-        tree = branch = repo = None
-
-    if do_tree:
-        if tree is not None:
-            note("Checking working tree at '%s'." 
-                 % (tree.bzrdir.root_transport.base,))
-            tree._check()
-        else:
-            log_error("No working tree found at specified location.")
-
-    if branch is not None:
-        # We have a branch
-        if repo is None:
-            # The branch is in a shared repository
-            repo = branch.repository
-        branches = [branch]
-    elif repo is not None:
-        branches = repo.find_branches(using=True)
-
-    if repo is not None:
-        repo.lock_read()
-        try:
-            if do_repo:
-                note("Checking repository at '%s'."
-                     % (repo.bzrdir.root_transport.base,))
-                result = repo.check()
-                result.report_results(verbose)
-            if do_branch:
-                if branches == []:
-                    log_error("No branch found at specified location.")
-                else:
-                    for branch in branches:
-                        note("Checking branch at '%s'."
-                             % (branch.bzrdir.root_transport.base,))
-                        check_branch(branch, verbose)
-        finally:
-            repo.unlock()
-    else:
-        if do_branch:
-            log_error("No branch found at specified location.")
-        if do_repo:
-            log_error("No repository found at specified location.")
+    repo_result.report_results(verbose)
+
+
+

=== removed file 'bzrlib/chunk_writer.py'
--- bzrlib/chunk_writer.py	2008-08-28 20:13:31 +0000
+++ bzrlib/chunk_writer.py	1970-01-01 00:00:00 +0000
@@ -1,258 +0,0 @@
-# Copyright (C) 2008 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-#
-
-"""ChunkWriter: write compressed data out with a fixed upper bound."""
-
-import zlib
-from zlib import Z_FINISH, Z_SYNC_FLUSH
-
-
-class ChunkWriter(object):
-    """ChunkWriter allows writing of compressed data with a fixed size.
-
-    If less data is supplied than fills a chunk, the chunk is padded with
-    NULL bytes. If more data is supplied, then the writer packs as much
-    in as it can, but never splits any item it was given.
-
-    The algorithm for packing is open to improvement! Current it is:
-     - write the bytes given
-     - if the total seen bytes so far exceeds the chunk size, flush.
-
-    :cvar _max_repack: To fit the maximum number of entries into a node, we
-        will sometimes start over and compress the whole list to get tighter
-        packing. We get diminishing returns after a while, so this limits the
-        number of times we will try.
-        The default is to try to avoid recompressing entirely, but setting this
-        to something like 20 will give maximum compression.
-
-    :cvar _max_zsync: Another tunable nob. If _max_repack is set to 0, then you
-        can limit the number of times we will try to pack more data into a
-        node. This allows us to do a single compression pass, rather than
-        trying until we overflow, and then recompressing again.
-    """
-    #    In testing, some values for bzr.dev::
-    #        repack  time  MB   max   full
-    #         1       7.5  4.6  1140  0
-    #         2       8.4  4.2  1036  1          6.8
-    #         3       9.8  4.1  1012  278
-    #         4      10.8  4.1  728   945
-    #        20      11.1  4.1  0     1012
-    #        repack = 0
-    #        zsync   time  MB    repack  max_z   time w/ add_node
-    #         0       6.7  24.7  0       6270    5.0
-    #         1       6.5  13.2  0       3342    4.3
-    #         2       6.6   9.6  0       2414    4.9
-    #         5       6.5   6.2  0       1549    4.8
-    #         6       6.5   5.8  1       1435    4.8
-    #         7       6.6   5.5  19      1337    4.8
-    #         8       6.7   5.3  81      1220    4.4
-    #        10       6.8   5.0  260     967     5.3
-    #        11       6.8   4.9  366     839     5.3
-    #        12       6.9   4.8  454     731     5.1
-    #        15       7.2   4.7  704     450     5.8
-    #        20       7.7   4.6  1133    7       5.8
-
-    #    In testing, some values for mysql-unpacked::
-    #                next_bytes estim
-    #        repack  time  MB    hit_max full
-    #         1      51.7  15.4  3913  0
-    #         2      54.4  13.7  3467  0         35.4
-    #        20      67.0  13.4  0     3380      46.7
-    #        repack=0
-    #        zsync                               time w/ add_node
-    #         0      47.7 116.5  0       29782   29.5
-    #         1      48.5  60.2  0       15356   27.8
-    #         2      48.1  42.4  0       10822   27.8
-    #         5      48.3  25.5  0       6491    26.8
-    #         6      48.0  23.2  13      5896    27.3
-    #         7      48.1  21.6  29      5451    27.5
-    #         8      48.1  20.3  52      5108    27.1
-    #        10      46.9  18.6  195     4526    29.4
-    #        11      48.8  18.0  421     4143    29.2
-    #        12      47.4  17.5  702     3738    28.0
-    #        15      49.6  16.5  1223    2969    28.9
-    #        20      48.9  15.7  2182    1810    29.6
-    #        30            15.4  3891    23      31.4
-
-    _max_repack = 0
-    _max_zsync = 8
-
-    def __init__(self, chunk_size, reserved=0):
-        """Create a ChunkWriter to write chunk_size chunks.
-
-        :param chunk_size: The total byte count to emit at the end of the
-            chunk.
-        :param reserved: How many bytes to allow for reserved data. reserved
-            data space can only be written to via the write(..., reserved=True).
-        """
-        self.chunk_size = chunk_size
-        self.compressor = zlib.compressobj()
-        self.bytes_in = []
-        self.bytes_list = []
-        self.bytes_out_len = 0
-        # bytes that have been seen, but not included in a flush to out yet
-        self.unflushed_in_bytes = 0
-        self.num_repack = 0
-        self.num_zsync = 0
-        self.unused_bytes = None
-        self.reserved_size = reserved
-
-    def finish(self):
-        """Finish the chunk.
-
-        This returns the final compressed chunk, and either None, or the
-        bytes that did not fit in the chunk.
-
-        :return: (compressed_bytes, unused_bytes, num_nulls_needed)
-            compressed_bytes    a list of bytes that were output from the
-                                compressor. If the compressed length was not
-                                exactly chunk_size, the final string will be a
-                                string of all null bytes to pad this to
-                                chunk_size
-            unused_bytes        None, or the last bytes that were added, which
-                                we could not fit.
-            num_nulls_needed    How many nulls are padded at the end
-        """
-        self.bytes_in = None # Free the data cached so far, we don't need it
-        out = self.compressor.flush(Z_FINISH)
-        self.bytes_list.append(out)
-        self.bytes_out_len += len(out)
-
-        if self.bytes_out_len > self.chunk_size:
-            raise AssertionError('Somehow we ended up with too much'
-                                 ' compressed data, %d > %d'
-                                 % (self.bytes_out_len, self.chunk_size))
-        nulls_needed = self.chunk_size - self.bytes_out_len
-        if nulls_needed:
-            self.bytes_list.append("\x00" * nulls_needed)
-        return self.bytes_list, self.unused_bytes, nulls_needed
-
-    def _recompress_all_bytes_in(self, extra_bytes=None):
-        """Recompress the current bytes_in, and optionally more.
-
-        :param extra_bytes: Optional, if supplied we will add it with
-            Z_SYNC_FLUSH
-        :return: (bytes_out, bytes_out_len, alt_compressed)
-            bytes_out   is the compressed bytes returned from the compressor
-            bytes_out_len the length of the compressed output
-            compressor  An object with everything packed in so far, and
-                        Z_SYNC_FLUSH called.
-        """
-        compressor = zlib.compressobj()
-        bytes_out = []
-        append = bytes_out.append
-        compress = compressor.compress
-        for accepted_bytes in self.bytes_in:
-            out = compress(accepted_bytes)
-            if out:
-                append(out)
-        if extra_bytes:
-            out = compress(extra_bytes)
-            out += compressor.flush(Z_SYNC_FLUSH)
-            append(out)
-        bytes_out_len = sum(map(len, bytes_out))
-        return bytes_out, bytes_out_len, compressor
-
-    def write(self, bytes, reserved=False):
-        """Write some bytes to the chunk.
-
-        If the bytes fit, False is returned. Otherwise True is returned
-        and the bytes have not been added to the chunk.
-
-        :param bytes: The bytes to include
-        :param reserved: If True, we can use the space reserved in the
-            constructor.
-        """
-        if self.num_repack > self._max_repack and not reserved:
-            self.unused_bytes = bytes
-            return True
-        if reserved:
-            capacity = self.chunk_size
-        else:
-            capacity = self.chunk_size - self.reserved_size
-        comp = self.compressor
-
-        # Check to see if the currently unflushed bytes would fit with a bit of
-        # room to spare, assuming no compression.
-        next_unflushed = self.unflushed_in_bytes + len(bytes)
-        remaining_capacity = capacity - self.bytes_out_len - 10
-        if (next_unflushed < remaining_capacity):
-            # looks like it will fit
-            out = comp.compress(bytes)
-            if out:
-                self.bytes_list.append(out)
-                self.bytes_out_len += len(out)
-            self.bytes_in.append(bytes)
-            self.unflushed_in_bytes += len(bytes)
-        else:
-            # This may or may not fit, try to add it with Z_SYNC_FLUSH
-            # Note: It is tempting to do this as a look-ahead pass, and to
-            #       'copy()' the compressor before flushing. However, it seems
-            #       that Which means that it is the same thing as increasing
-            #       repack, similar cost, same benefit. And this way we still
-            #       have the 'repack' knob that can be adjusted, and not depend
-            #       on a platform-specific 'copy()' function.
-            self.num_zsync += 1
-            if self._max_repack == 0 and self.num_zsync > self._max_zsync:
-                self.num_repack += 1
-                self.unused_bytes = bytes
-                return True
-            out = comp.compress(bytes)
-            out += comp.flush(Z_SYNC_FLUSH)
-            self.unflushed_in_bytes = 0
-            if out:
-                self.bytes_list.append(out)
-                self.bytes_out_len += len(out)
-
-            # We are a bit extra conservative, because it seems that you *can*
-            # get better compression with Z_SYNC_FLUSH than a full compress. It
-            # is probably very rare, but we were able to trigger it.
-            if self.num_repack == 0:
-                safety_margin = 100
-            else:
-                safety_margin = 10
-            if self.bytes_out_len + safety_margin <= capacity:
-                # It fit, so mark it added
-                self.bytes_in.append(bytes)
-            else:
-                # We are over budget, try to squeeze this in without any
-                # Z_SYNC_FLUSH calls
-                self.num_repack += 1
-                (bytes_out, this_len,
-                 compressor) = self._recompress_all_bytes_in(bytes)
-                if self.num_repack >= self._max_repack:
-                    # When we get *to* _max_repack, bump over so that the
-                    # earlier > _max_repack will be triggered.
-                    self.num_repack += 1
-                if this_len + 10 > capacity:
-                    (bytes_out, this_len,
-                     compressor) = self._recompress_all_bytes_in()
-                    self.compressor = compressor
-                    # Force us to not allow more data
-                    self.num_repack = self._max_repack + 1
-                    self.bytes_list = bytes_out
-                    self.bytes_out_len = this_len
-                    self.unused_bytes = bytes
-                    return True
-                else:
-                    # This fits when we pack it tighter, so use the new packing
-                    self.compressor = compressor
-                    self.bytes_in.append(bytes)
-                    self.bytes_list = bytes_out
-                    self.bytes_out_len = this_len
-        return False
-

=== modified file 'bzrlib/cmd_version_info.py'
--- bzrlib/cmd_version_info.py	2008-02-25 23:41:06 +0000
+++ bzrlib/cmd_version_info.py	2007-07-10 10:20:27 +0000
@@ -21,14 +21,12 @@
 from bzrlib import (
     branch,
     errors,
+    version_info_formats,
     workingtree,
     )
 """)
-from bzrlib import (
-    version_info_formats,
-    )
 from bzrlib.commands import Command
-from bzrlib.option import Option, RegistryOption
+from bzrlib.option import Option
 
 
 def _parse_version_info_format(format):
@@ -47,40 +45,16 @@
 
 
 class cmd_version_info(Command):
-    """Show version information about this tree.
-
-    You can use this command to add information about version into
-    source code of an application. The output can be in one of the
-    supported formats or in a custom format based on a template.
-
-    For example::
-
-      bzr version-info --custom \\
-        --template="#define VERSION_INFO \\"Project 1.2.3 (r{revno})\\"\\n"
-
-    will produce a C header file with formatted string containing the
-    current revision number. Other supported variables in templates are:
-
-      * {date} - date of the last revision
-      * {build_date} - current date
-      * {revno} - revision number
-      * {revision_id} - revision id
-      * {branch_nick} - branch nickname
-      * {clean} - 0 if the source tree contains uncommitted changes,
-                  otherwise 1
-    """
-
-    takes_options = [RegistryOption('format',
-                            'Select the output format.',
-                            version_info_formats.format_registry,
-                            value_switches=True),
+    """Show version information about this tree."""
+
+    takes_options = [Option('format', type=_parse_version_info_format,
+                            help='Select the output format.'),
                      Option('all', help='Include all possible information.'),
                      Option('check-clean', help='Check if tree is clean.'),
                      Option('include-history',
                             help='Include the revision-history.'),
                      Option('include-file-revisions',
-                            help='Include the last revision for each file.'),
-                     Option('template', type=str, help='Template for the output.'),
+                            help='Include the last revision for each file.')
                      ]
     takes_args = ['location?']
 
@@ -88,13 +62,13 @@
 
     def run(self, location=None, format=None,
             all=False, check_clean=False, include_history=False,
-            include_file_revisions=False, template=None):
+            include_file_revisions=False):
 
         if location is None:
             location = '.'
 
         if format is None:
-            format = version_info_formats.format_registry.get()
+            format = version_info_formats.get_builder(None)
 
         wt = None
         try:
@@ -104,7 +78,7 @@
         else:
             b = wt.branch
 
-        if all or template:
+        if all:
             include_history = True
             check_clean = True
             include_file_revisions=True
@@ -112,6 +86,5 @@
         builder = format(b, working_tree=wt,
                 check_for_clean=check_clean,
                 include_revision_history=include_history,
-                include_file_revisions=include_file_revisions,
-                template=template)
+                include_file_revisions=include_file_revisions)
         builder.generate(self.outf)

=== modified file 'bzrlib/commands.py'
--- bzrlib/commands.py	2008-08-31 19:39:01 +0000
+++ bzrlib/commands.py	2007-09-24 06:42:21 +0000
@@ -43,7 +43,6 @@
     errors,
     option,
     osutils,
-    registry,
     trace,
     win32utils,
     )
@@ -95,6 +94,7 @@
 
 
 def _unsquish_command_name(cmd):
+    assert cmd.startswith("cmd_")
     return cmd[4:].replace('_','-')
 
 
@@ -168,17 +168,6 @@
     cmd_obj = ExternalCommand.find_command(cmd_name)
     if cmd_obj:
         return cmd_obj
-
-    # look for plugins that provide this command but aren't installed
-    for provider in command_providers_registry:
-        try:
-            plugin_metadata = provider.plugin_for_command(cmd_name)
-        except errors.NoPluginAvailable:
-            pass
-        else:
-            raise errors.CommandAvailableInPlugin(cmd_name, 
-                                                  plugin_metadata, provider)
-
     raise KeyError
 
 
@@ -282,7 +271,9 @@
             elif aname[-1] == '*':
                 aname = '[' + aname[:-1] + '...]'
             s += aname + ' '
-        s = s[:-1]      # remove last space
+                
+        assert s[-1] == ' '
+        s = s[:-1]
         return s
 
     def get_help_text(self, additional_see_also=None, plain=True,
@@ -366,7 +357,7 @@
             result += ':See also: '
             result += ', '.join(see_also) + '\n'
 
-        # If this will be rendered as plain text, convert it
+        # If this will be rendered as plan text, convert it
         if plain:
             import bzrlib.help_topics
             result = bzrlib.help_topics.help_as_plain_text(result)
@@ -389,7 +380,7 @@
                     sections[label] += '\n' + section
                 else:
                     sections[label] = section
-
+            
         lines = text.rstrip().splitlines()
         summary = lines.pop(0)
         sections = {}
@@ -398,7 +389,7 @@
             if line.startswith(':') and line.endswith(':') and len(line) > 2:
                 save_section(sections, label, section)
                 label,section = line[1:-1],''
-            elif (label is not None) and len(line) > 1 and not line[0].isspace():
+            elif label != None and len(line) > 1 and not line[0].isspace():
                 save_section(sections, label, section)
                 label,section = None,line
             else:
@@ -442,6 +433,8 @@
 
     def _setup_outf(self):
         """Return a file linked to stdout, which has proper encoding."""
+        assert self.encoding_type in ['strict', 'exact', 'replace']
+
         # Originally I was using self.stdout, but that looks
         # *way* too much like sys.stdout
         if self.encoding_type == 'exact':
@@ -497,7 +490,7 @@
         self._setup_outf()
 
         return self.run(**all_cmd_args)
-
+    
     def run(self):
         """Actually run the command.
 
@@ -597,20 +590,6 @@
 
     return argdict
 
-def apply_coveraged(dirname, the_callable, *args, **kwargs):
-    # Cannot use "import trace", as that would import bzrlib.trace instead of
-    # the standard library's trace.
-    trace = __import__('trace')
-
-    tracer = trace.Trace(count=1, trace=0)
-    sys.settrace(tracer.globaltrace)
-
-    ret = the_callable(*args, **kwargs)
-
-    sys.settrace(None)
-    results = tracer.results()
-    results.write_results(show_missing=1, summary=False,
-                          coverdir=dirname)
 
 
 def apply_profiled(the_callable, *args, **kwargs):
@@ -648,11 +627,6 @@
     return ret
 
 
-def shlex_split_unicode(unsplit):
-    import shlex
-    return [u.decode('utf-8') for u in shlex.split(unsplit.encode('utf-8'))]
-
-
 def get_alias(cmd, config=None):
     """Return an expanded alias, or None if no alias exists.
 
@@ -668,7 +642,8 @@
         config = bzrlib.config.GlobalConfig()
     alias = config.get_alias(cmd)
     if (alias):
-        return shlex_split_unicode(alias)
+        import shlex
+        return [a.decode('utf-8') for a in shlex.split(alias.encode('utf-8'))]
     return None
 
 
@@ -703,16 +678,13 @@
 
     --lsprof
         Run under the Python lsprof profiler.
-
-    --coverage
-        Generate line coverage report in the specified directory.
     """
     argv = list(argv)
     trace.mutter("bzr arguments: %r", argv)
 
     opt_lsprof = opt_profile = opt_no_plugins = opt_builtin =  \
                 opt_no_aliases = False
-    opt_lsprof_file = opt_coverage_dir = None
+    opt_lsprof_file = None
 
     # --no-plugins is handled specially at a very early stage. We need
     # to load plugins before doing other command parsing so that they
@@ -736,9 +708,6 @@
             opt_no_aliases = True
         elif a == '--builtin':
             opt_builtin = True
-        elif a == '--coverage':
-            opt_coverage_dir = argv[i + 1]
-            i += 1
         elif a.startswith('-D'):
             debug.debug_flags.add(a[2:])
         else:
@@ -782,30 +751,11 @@
 
     try:
         if opt_lsprof:
-            if opt_coverage_dir:
-                trace.warning(
-                    '--coverage ignored, because --lsprof is in use.')
             ret = apply_lsprofiled(opt_lsprof_file, run, *run_argv)
         elif opt_profile:
-            if opt_coverage_dir:
-                trace.warning(
-                    '--coverage ignored, because --profile is in use.')
             ret = apply_profiled(run, *run_argv)
-        elif opt_coverage_dir:
-            ret = apply_coveraged(opt_coverage_dir, run, *run_argv)
         else:
             ret = run(*run_argv)
-        if 'memory' in debug.debug_flags:
-            try:
-                status_file = file('/proc/%s/status' % os.getpid(), 'rb')
-            except IOError:
-                pass
-            else:
-                status = status_file.read()
-                status_file.close()
-                trace.note("Process status after command:")
-                for line in status.splitlines():
-                    trace.note(line)
         return ret or 0
     finally:
         # reset, in case we may do other commands later within the same process
@@ -835,11 +785,6 @@
     import bzrlib.ui
     from bzrlib.ui.text import TextUIFactory
     bzrlib.ui.ui_factory = TextUIFactory()
-     
-    # Is this a final release version? If so, we should suppress warnings
-    if bzrlib.version_info[3] == 'final':
-        from bzrlib import symbol_versioning
-        symbol_versioning.suppress_deprecation_warnings(override=False)
     try:
         argv = [a.decode(bzrlib.user_encoding) for a in argv[1:]]
     except UnicodeDecodeError:
@@ -906,27 +851,5 @@
             return [cmd]
 
 
-class Provider(object):
-    '''Generic class to be overriden by plugins'''
-
-    def plugin_for_command(self, cmd_name):
-        '''Takes a command and returns the information for that plugin
-        
-        :return: A dictionary with all the available information 
-        for the requested plugin
-        '''
-        raise NotImplementedError
-
-
-class ProvidersRegistry(registry.Registry):
-    '''This registry exists to allow other providers to exist'''
-
-    def __iter__(self):
-        for key, provider in self.iteritems():
-            yield provider
-
-command_providers_registry = ProvidersRegistry()
-
-
 if __name__ == '__main__':
     sys.exit(main(sys.argv))

=== modified file 'bzrlib/commit.py'
--- bzrlib/commit.py	2008-08-05 04:10:43 +0000
+++ bzrlib/commit.py	2007-10-15 05:02:05 +0000
@@ -16,7 +16,7 @@
 
 
 # The newly committed revision is going to have a shape corresponding
-# to that of the working tree.  Files that are not in the
+# to that of the working inventory.  Files that are not in the
 # working tree and that were in the predecessor are reported as
 # removed --- this can include files that were either removed from the
 # inventory or deleted in the working tree.  If they were only
@@ -25,7 +25,7 @@
 # We then consider the remaining entries, which will be in the new
 # version.  Directory entries are simply copied across.  File entries
 # must be checked to see if a new version of the file should be
-# recorded.  For each parent revision tree, we check to see what
+# recorded.  For each parent revision inventory, we check to see what
 # version of the file was present.  If the file was present in at
 # least one tree, and if it was the same version in all the trees,
 # then we can just refer to that version.  Otherwise, a new version
@@ -59,7 +59,7 @@
 from bzrlib import (
     debug,
     errors,
-    revision,
+    inventory,
     tree,
     )
 from bzrlib.branch import Branch
@@ -71,13 +71,11 @@
 from bzrlib.osutils import (kind_marker, isdir,isfile, is_inside_any,
                             is_inside_or_parent_of_any,
                             minimum_path_selection,
-                            quotefn, sha_file, split_lines,
-                            splitpath,
-                            )
+                            quotefn, sha_file, split_lines)
 from bzrlib.testament import Testament
 from bzrlib.trace import mutter, note, warning, is_quiet
 from bzrlib.xml5 import serializer_v5
-from bzrlib.inventory import InventoryEntry, make_entry
+from bzrlib.inventory import Inventory, InventoryEntry
 from bzrlib import symbol_versioning
 from bzrlib.symbol_versioning import (deprecated_passed,
         deprecated_function,
@@ -91,10 +89,6 @@
     """I report on progress of a commit."""
 
     def started(self, revno, revid, location=None):
-        if location is None:
-            symbol_versioning.warn("As of bzr 1.0 you must pass a location "
-                                   "to started.", DeprecationWarning,
-                                   stacklevel=2)
         pass
 
     def snapshot_change(self, change, path):
@@ -137,15 +131,10 @@
 
     def started(self, revno, rev_id, location=None):
         if location is not None:
-            location = ' to: ' + unescape_for_display(location, 'utf-8')
+            location = ' to "' + unescape_for_display(location, 'utf-8') + '"'
         else:
-            # When started was added, location was only made optional by
-            # accident.  Matt Nordhoff 20071129
-            symbol_versioning.warn("As of bzr 1.0 you must pass a location "
-                                   "to started.", DeprecationWarning,
-                                   stacklevel=2)
             location = ''
-        self._note('Committing%s', location)
+        self._note('Committing revision %d%s.', revno, location)
 
     def completed(self, revno, rev_id):
         self._note('Committed revision %d.', revno)
@@ -204,8 +193,7 @@
                reporter=None,
                config=None,
                message_callback=None,
-               recursive='down',
-               exclude=None):
+               recursive='down'):
         """Commit working copy as a new revision.
 
         :param message: the commit message (it or message_callback is required)
@@ -233,9 +221,6 @@
         :param verbose: if True and the reporter is not None, report everything
         :param recursive: If set to 'down', commit in any subtrees that have
             pending changes of any sort during this commit.
-        :param exclude: None or a list of relative paths to exclude from the
-            commit. Pending changes to excluded files will be ignored by the
-            commit. 
         """
         mutter('preparing to commit')
 
@@ -259,11 +244,6 @@
         self.bound_branch = None
         self.any_entries_changed = False
         self.any_entries_deleted = False
-        if exclude is not None:
-            self.exclude = sorted(
-                minimum_path_selection(exclude))
-        else:
-            self.exclude = []
         self.local = local
         self.master_branch = None
         self.master_locked = False
@@ -289,7 +269,6 @@
 
         self.work_tree.lock_write()
         self.pb = bzrlib.ui.ui_factory.nested_progress_bar()
-        self.basis_revid = self.work_tree.last_revision()
         self.basis_tree = self.work_tree.basis_tree()
         self.basis_tree.lock_read()
         try:
@@ -338,15 +317,12 @@
             self.pb.show_count = True
             self.pb.show_bar = True
 
+            # After a merge, a selected file commit is not supported.
+            # See 'bzr help merge' for an explanation as to why.
             self.basis_inv = self.basis_tree.inventory
             self._gather_parents()
-            # After a merge, a selected file commit is not supported.
-            # See 'bzr help merge' for an explanation as to why.
             if len(self.parents) > 1 and self.specific_files:
                 raise errors.CannotCommitSelectedFileMerge(self.specific_files)
-            # Excludes are a form of selected file commit.
-            if len(self.parents) > 1 and self.exclude:
-                raise errors.CannotCommitSelectedFileMerge(self.exclude)
 
             # Collect the changes
             self._set_progress_stage("Collecting changes",
@@ -377,6 +353,7 @@
 
                 # Prompt the user for a commit message if none provided
                 message = message_callback(self)
+                assert isinstance(message, unicode), type(message)
                 self.message = message
                 self._escape_commit_message()
 
@@ -392,11 +369,9 @@
             # Upload revision data to the master.
             # this will propagate merged revisions too if needed.
             if self.bound_branch:
-                if not self.master_branch.repository.has_same_location(
-                        self.branch.repository):
-                    self._set_progress_stage("Uploading data to master branch")
-                    self.master_branch.repository.fetch(self.branch.repository,
-                        revision_id=self.rev_id)
+                self._set_progress_stage("Uploading data to master branch")
+                self.master_branch.repository.fetch(self.branch.repository,
+                                                    revision_id=self.rev_id)
                 # now the master has the revision data
                 # 'commit' to the master first so a timeout here causes the
                 # local branch to be out of date
@@ -408,8 +383,17 @@
 
             # Make the working tree up to date with the branch
             self._set_progress_stage("Updating the working tree")
-            self.work_tree.update_basis_by_delta(self.rev_id,
-                 self._basis_delta)
+            rev_tree = self.builder.revision_tree()
+            # XXX: This will need to be changed if we support doing a
+            # selective commit while a merge is still pending - then we'd
+            # still have multiple parents after the commit.
+            #
+            # XXX: update_basis_by_delta is slower at present because it works
+            # on inventories, so this is not active until there's a native
+            # dirstate implementation.
+            ## self.work_tree.update_basis_by_delta(self.rev_id,
+            ##      self._basis_delta)
+            self.work_tree.set_parent_trees([(self.rev_id, rev_tree)])
             self.reporter.completed(new_revno, self.rev_id)
             self._process_post_hooks(old_revno, new_revno)
         finally:
@@ -430,17 +414,18 @@
             return
         # TODO: we could simplify this by using self._basis_delta.
 
-        # The initial commit adds a root directory, but this in itself is not
-        # a worthwhile commit.
-        if (self.basis_revid == revision.NULL_REVISION and
-            len(self.builder.new_inventory) == 1):
+        # The inital commit adds a root directory, but this in itself is not
+        # a worthwhile commit.  
+        if len(self.basis_inv) == 0 and len(self.builder.new_inventory) == 1:
             raise PointlessCommit()
+        # Shortcut, if the number of entries changes, then we obviously have
+        # a change
+        if len(self.builder.new_inventory) != len(self.basis_inv):
+            return
         # If length == 1, then we only have the root entry. Which means
         # that there is no real difference (only the root could be different)
-        # unless deletes occured, in which case the length is irrelevant.
-        if (self.any_entries_deleted or 
-            (len(self.builder.new_inventory) != 1 and
-             self.any_entries_changed)):
+        if len(self.builder.new_inventory) != 1 and (self.any_entries_changed
+            or self.any_entries_deleted):
             return
         raise PointlessCommit()
 
@@ -660,30 +645,28 @@
         # in bugs like #46635.  Any reason not to use/enhance Tree.changes_from?
         # ADHB 11-07-2006
 
-        exclude = self.exclude
-        specific_files = self.specific_files or []
+        specific_files = self.specific_files
         mutter("Selecting files for commit with filter %s", specific_files)
 
         # Build the new inventory
-        self._populate_from_inventory()
+        self._populate_from_inventory(specific_files)
 
         # If specific files are selected, then all un-selected files must be
         # recorded in their previous state. For more details, see
         # https://lists.ubuntu.com/archives/bazaar/2007q3/028476.html.
-        if specific_files or exclude:
+        if specific_files:
             for path, old_ie in self.basis_inv.iter_entries():
                 if old_ie.file_id in self.builder.new_inventory:
                     # already added - skip.
                     continue
-                if (is_inside_any(specific_files, path)
-                    and not is_inside_any(exclude, path)):
-                    # was inside the selected path, and not excluded - if not
-                    # present it has been deleted so skip.
+                if is_inside_any(specific_files, path):
+                    # was inside the selected path, if not present it has been
+                    # deleted so skip.
                     continue
-                # From here down it was either not selected, or was excluded:
                 if old_ie.kind == 'directory':
                     self._next_progress_entry()
-                # We preserve the entry unaltered.
+                # not in final inv yet, was not in the selected files, so is an
+                # entry to be preserved unaltered.
                 ie = old_ie.copy()
                 # Note: specific file commits after a merge are currently
                 # prohibited. This test is for sanity/safety in case it's
@@ -703,7 +686,7 @@
             set(self.builder.new_inventory._byid.keys())
         if deleted_ids:
             self.any_entries_deleted = True
-            deleted = [(self.basis_tree.id2path(file_id), file_id)
+            deleted = [(self.basis_inv.id2path(file_id), file_id)
                 for file_id in deleted_ids]
             deleted.sort()
             # XXX: this is not quite directory-order sorting
@@ -711,25 +694,19 @@
                 self._basis_delta.append((path, None, file_id, None))
                 self.reporter.deleted(path)
 
-    def _populate_from_inventory(self):
+    def _populate_from_inventory(self, specific_files):
         """Populate the CommitBuilder by walking the working tree inventory."""
         if self.strict:
             # raise an exception as soon as we find a single unknown.
             for unknown in self.work_tree.unknowns():
                 raise StrictCommitFailed()
-        
-        specific_files = self.specific_files
-        exclude = self.exclude
+               
         report_changes = self.reporter.is_verbose()
         deleted_ids = []
-        # A tree of paths that have been deleted. E.g. if foo/bar has been
-        # deleted, then we have {'foo':{'bar':{}}}
-        deleted_paths = {}
-        # XXX: Note that entries may have the wrong kind because the entry does
-        # not reflect the status on disk.
+        deleted_paths = set()
         work_inv = self.work_tree.inventory
-        # NB: entries will include entries within the excluded ids/paths
-        # because iter_entries_by_dir has no 'exclude' facility today.
+        assert work_inv.root is not None
+        # XXX: Note that entries may have the wrong kind.
         entries = work_inv.iter_entries_by_dir(
             specific_file_ids=self.specific_file_ids, yield_parents=True)
         for path, existing_ie in entries:
@@ -740,38 +717,16 @@
             if kind == 'directory':
                 self._next_progress_entry()
             # Skip files that have been deleted from the working tree.
-            # The deleted path ids are also recorded so they can be explicitly
-            # unversioned later.
-            if deleted_paths:
-                path_segments = splitpath(path)
-                deleted_dict = deleted_paths
-                for segment in path_segments:
-                    deleted_dict = deleted_dict.get(segment, None)
-                    if not deleted_dict:
-                        # We either took a path not present in the dict
-                        # (deleted_dict was None), or we've reached an empty
-                        # child dir in the dict, so are now a sub-path.
-                        break
-                else:
-                    deleted_dict = None
-                if deleted_dict is not None:
-                    # the path has a deleted parent, do not add it.
-                    continue
-            if exclude and is_inside_any(exclude, path):
-                # Skip excluded paths. Excluded paths are processed by
-                # _update_builder_with_changes.
+            # The deleted files/directories are also recorded so they
+            # can be explicitly unversioned later. Note that when a
+            # filter of specific files is given, we must only skip/record
+            # deleted files matching that filter.
+            if is_inside_any(deleted_paths, path):
                 continue
             content_summary = self.work_tree.path_content_summary(path)
-            # Note that when a filter of specific files is given, we must only
-            # skip/record deleted files matching that filter.
             if not specific_files or is_inside_any(specific_files, path):
                 if content_summary[0] == 'missing':
-                    if not deleted_paths:
-                        # path won't have been split yet.
-                        path_segments = splitpath(path)
-                    deleted_dict = deleted_paths
-                    for segment in path_segments:
-                        deleted_dict = deleted_dict.setdefault(segment, {})
+                    deleted_paths.add(path)
                     self.reporter.missing(path)
                     deleted_ids.append(file_id)
                     continue
@@ -839,7 +794,7 @@
         # mutter('check %s {%s}', path, file_id)
         # mutter('%s selected for commit', path)
         if definitely_changed or existing_ie is None:
-            ie = make_entry(kind, name, parent_id, file_id)
+            ie = inventory.make_entry(kind, name, parent_id, file_id)
         else:
             ie = existing_ie.copy()
             ie.revision = None

=== modified file 'bzrlib/config.py'
--- bzrlib/config.py	2008-08-19 19:33:59 +0000
+++ bzrlib/config.py	2007-11-04 15:24:27 +0000
@@ -84,7 +84,7 @@
     urlutils,
     win32utils,
     )
-from bzrlib.util.configobj import configobj
+import bzrlib.util.configobj.configobj as configobj
 """)
 
 
@@ -147,9 +147,20 @@
     def get_mail_client(self):
         """Get a mail client to use"""
         selected_client = self.get_user_option('mail_client')
-        _registry = mail_client.mail_client_registry
         try:
-            mail_client_class = _registry.get(selected_client)
+            mail_client_class = {
+                None: mail_client.DefaultMail,
+                # Specific clients
+                'evolution': mail_client.Evolution,
+                'kmail': mail_client.KMail,
+                'mutt': mail_client.Mutt,
+                'thunderbird': mail_client.Thunderbird,
+                # Generic options
+                'default': mail_client.DefaultMail,
+                'editor': mail_client.Editor,
+                'mapi': mail_client.MAPIClient,
+                'xdg-email': mail_client.XDGEmail,
+            }[selected_client]
         except KeyError:
             raise errors.UnknownMailClient(selected_client)
         return mail_client_class(self)
@@ -428,36 +439,13 @@
 
     def set_user_option(self, option, value):
         """Save option and its value in the configuration."""
-        self._set_option(option, value, 'DEFAULT')
-
-    def get_aliases(self):
-        """Return the aliases section."""
-        if 'ALIASES' in self._get_parser():
-            return self._get_parser()['ALIASES']
-        else:
-            return {}
-
-    def set_alias(self, alias_name, alias_command):
-        """Save the alias in the configuration."""
-        self._set_option(alias_name, alias_command, 'ALIASES')
-
-    def unset_alias(self, alias_name):
-        """Unset an existing alias."""
-        aliases = self._get_parser().get('ALIASES')
-        if not aliases or alias_name not in aliases:
-            raise errors.NoSuchAlias(alias_name)
-        del aliases[alias_name]
-        self._write_config_file()
-
-    def _set_option(self, option, value, section):
         # FIXME: RBC 20051029 This should refresh the parser and also take a
         # file lock on bazaar.conf.
         conf_dir = os.path.dirname(self._get_filename())
         ensure_config_dir_exists(conf_dir)
-        self._get_parser().setdefault(section, {})[option] = value
-        self._write_config_file()
-
-    def _write_config_file(self):
+        if 'DEFAULT' not in self._get_parser():
+            self._get_parser()['DEFAULT'] = {}
+        self._get_parser()['DEFAULT'][option] = value
         f = open(self._get_filename(), 'wb')
         self._get_parser().write(f)
         f.close()
@@ -581,11 +569,9 @@
 
     def set_user_option(self, option, value, store=STORE_LOCATION):
         """Save option and its value in the configuration."""
-        if store not in [STORE_LOCATION,
+        assert store in [STORE_LOCATION,
                          STORE_LOCATION_NORECURSE,
-                         STORE_LOCATION_APPENDPATH]:
-            raise ValueError('bad storage policy %r for %r' %
-                (store, option))
+                         STORE_LOCATION_APPENDPATH], 'bad storage policy'
         # FIXME: RBC 20051029 This should refresh the parser and also take a
         # file lock on locations.conf.
         conf_dir = os.path.dirname(self._get_filename())
@@ -652,11 +638,12 @@
     def _get_user_id(self):
         """Return the full user id for the branch.
     
-        e.g. "John Hacker <jhacker@example.com>"
+        e.g. "John Hacker <jhacker@foo.org>"
         This is looked up in the email controlfile for the branch.
         """
         try:
-            return (self.branch._transport.get_bytes("email")
+            return (self.branch.control_files.get_utf8("email") 
+                    .read()
                     .decode(bzrlib.user_encoding)
                     .rstrip("\r\n"))
         except errors.NoSuchFile, e:
@@ -772,8 +759,7 @@
         if base is None:
             base = os.environ.get('HOME', None)
         if base is None:
-            raise errors.BzrError('You must have one of BZR_HOME, APPDATA,'
-                                  ' or HOME set')
+            raise errors.BzrError('You must have one of BZR_HOME, APPDATA, or HOME set')
         return osutils.pathjoin(base, 'bazaar', '2.0')
     else:
         # cygwin, linux, and darwin all have a $HOME directory
@@ -875,52 +861,51 @@
     return realname, (username + '@' + socket.gethostname())
 
 
-def parse_username(username):
-    """Parse e-mail username and return a (name, address) tuple."""
-    match = re.match(r'(.*?)\s*<?([\w+.-]+@[\w+.-]+)>?', username)
-    if match is None:
-        return (username, '')
-    else:
-        return (match.group(1), match.group(2))
-
-
 def extract_email_address(e):
     """Return just the address part of an email string.
-
+    
     That is just the user@domain part, nothing else. 
     This part is required to contain only ascii characters.
     If it can't be extracted, raises an error.
-
+    
     >>> extract_email_address('Jane Tester <jane@test.com>')
     "jane@test.com"
     """
-    name, email = parse_username(e)
-    if not email:
+    m = re.search(r'[\w+.-]+@[\w+.-]+', e)
+    if not m:
         raise errors.NoEmailInUsername(e)
-    return email
+    return m.group(0)
 
 
 class TreeConfig(IniBasedConfig):
     """Branch configuration data associated with its contents, not location"""
 
-    # XXX: Really needs a better name, as this is not part of the tree! -- mbp 20080507
-
     def __init__(self, branch):
-        # XXX: Really this should be asking the branch for its configuration
-        # data, rather than relying on a Transport, so that it can work 
-        # more cleanly with a RemoteBranch that has no transport.
-        self._config = TransportConfig(branch._transport, 'branch.conf')
         self.branch = branch
 
     def _get_parser(self, file=None):
         if file is not None:
             return IniBasedConfig._get_parser(file)
-        return self._config._get_configobj()
+        return self._get_config()
+
+    def _get_config(self):
+        try:
+            obj = ConfigObj(self.branch.control_files.get('branch.conf'),
+                            encoding='utf-8')
+        except errors.NoSuchFile:
+            obj = ConfigObj(encoding='utf=8')
+        return obj
 
     def get_option(self, name, section=None, default=None):
         self.branch.lock_read()
         try:
-            return self._config.get_option(name, section, default)
+            obj = self._get_config()
+            try:
+                if section is not None:
+                    obj = obj[section]
+                result = obj[name]
+            except KeyError:
+                result = default
         finally:
             self.branch.unlock()
         return result
@@ -929,7 +914,20 @@
         """Set a per-branch configuration option"""
         self.branch.lock_write()
         try:
-            self._config.set_option(value, name, section)
+            cfg_obj = self._get_config()
+            if section is None:
+                obj = cfg_obj
+            else:
+                try:
+                    obj = cfg_obj[section]
+                except KeyError:
+                    cfg_obj[section] = {}
+                    obj = cfg_obj[section]
+            obj[name] = value
+            out_file = StringIO()
+            cfg_obj.write(out_file)
+            out_file.seek(0)
+            self.branch.control_files.put('branch.conf', out_file)
         finally:
             self.branch.unlock()
 
@@ -968,9 +966,10 @@
 
     def _save(self):
         """Save the config file, only tests should use it for now."""
-        conf_dir = os.path.dirname(self._filename)
+        file_name = self._get_filename()
+        conf_dir = os.path.dirname(file_name)
         ensure_config_dir_exists(conf_dir)
-        self._get_config().write(file(self._filename, 'wb'))
+        self._get_config().write(file(file_name, 'wb'))
 
     def _set_option(self, section_name, option_name, value):
         """Set an authentication configuration option"""
@@ -1007,9 +1006,6 @@
         """
         credentials = None
         for auth_def_name, auth_def in self._get_config().items():
-            if type(auth_def) is not configobj.Section:
-                raise ValueError("%s defined outside a section" % auth_def_name)
-
             a_scheme, a_host, a_user, a_path = map(
                 auth_def.get, ['scheme', 'host', 'user', 'path'])
 
@@ -1047,8 +1043,7 @@
                 # Can't find a user
                 continue
             credentials = dict(name=auth_def_name,
-                               user=a_user,
-                               password=auth_def.get('password', None),
+                               user=a_user, password=auth_def['password'],
                                verify_certificates=a_verify_certificates)
             self.decode_password(credentials,
                                  auth_def.get('password_encoding', None))
@@ -1103,17 +1098,12 @@
         credentials = self.get_credentials(scheme, host, port, user, path)
         if credentials is not None:
             password = credentials['password']
-            if password is not None and scheme is 'ssh':
-                trace.warning('password ignored in section [%s],'
-                              ' use an ssh agent instead'
-                              % credentials['name'])
-                password = None
         else:
             password = None
         # Prompt user only if we could't find a password
         if password is None:
             if prompt is None:
-                # Create a default prompt suitable for most cases
+                # Create a default prompt suitable for most of the cases
                 prompt = '%s' % scheme.upper() + ' %(user)s@%(host)s password'
             # Special handling for optional fields in the prompt
             if port is not None:
@@ -1126,93 +1116,3 @@
 
     def decode_password(self, credentials, encoding):
         return credentials
-
-
-class BzrDirConfig(object):
-
-    def __init__(self, transport):
-        self._config = TransportConfig(transport, 'control.conf')
-
-    def set_default_stack_on(self, value):
-        """Set the default stacking location.
-
-        It may be set to a location, or None.
-
-        This policy affects all branches contained by this bzrdir, except for
-        those under repositories.
-        """
-        if value is None:
-            self._config.set_option('', 'default_stack_on')
-        else:
-            self._config.set_option(value, 'default_stack_on')
-
-    def get_default_stack_on(self):
-        """Return the default stacking location.
-
-        This will either be a location, or None.
-
-        This policy affects all branches contained by this bzrdir, except for
-        those under repositories.
-        """
-        value = self._config.get_option('default_stack_on')
-        if value == '':
-            value = None
-        return value
-
-
-class TransportConfig(object):
-    """A Config that reads/writes a config file on a Transport.
-
-    It is a low-level object that considers config data to be name/value pairs
-    that may be associated with a section.  Assigning meaning to the these
-    values is done at higher levels like TreeConfig.
-    """
-
-    def __init__(self, transport, filename):
-        self._transport = transport
-        self._filename = filename
-
-    def get_option(self, name, section=None, default=None):
-        """Return the value associated with a named option.
-
-        :param name: The name of the value
-        :param section: The section the option is in (if any)
-        :param default: The value to return if the value is not set
-        :return: The value or default value
-        """
-        configobj = self._get_configobj()
-        if section is None:
-            section_obj = configobj
-        else:
-            try:
-                section_obj = configobj[section]
-            except KeyError:
-                return default
-        return section_obj.get(name, default)
-
-    def set_option(self, value, name, section=None):
-        """Set the value associated with a named option.
-
-        :param value: The value to set
-        :param name: The name of the value to set
-        :param section: The section the option is in (if any)
-        """
-        configobj = self._get_configobj()
-        if section is None:
-            configobj[name] = value
-        else:
-            configobj.setdefault(section, {})[name] = value
-        self._set_configobj(configobj)
-
-    def _get_configobj(self):
-        try:
-            return ConfigObj(self._transport.get(self._filename),
-                             encoding='utf-8')
-        except errors.NoSuchFile:
-            return ConfigObj(encoding='utf-8')
-
-    def _set_configobj(self, configobj):
-        out_file = StringIO()
-        configobj.write(out_file)
-        out_file.seek(0)
-        self._transport.put_file(self._filename, out_file)

=== modified file 'bzrlib/conflicts.py'
--- bzrlib/conflicts.py	2007-12-25 04:17:50 +0000
+++ bzrlib/conflicts.py	2007-07-23 14:27:42 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2007 Canonical Ltd
+# Copyright (C) 2005 Aaron Bentley, Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -117,19 +117,7 @@
                 resolve(tree, file_list)
 
 
-def resolve(tree, paths=None, ignore_misses=False, recursive=False):
-    """Resolve some or all of the conflicts in a working tree.
-
-    :param paths: If None, resolve all conflicts.  Otherwise, select only
-        specified conflicts.
-    :param recursive: If True, then elements of paths which are directories
-        have all their children resolved, etc.  When invoked as part of
-        recursive commands like revert, this should be True.  For commands
-        or applications wishing finer-grained control, like the resolve
-        command, this should be False.
-    :ignore_misses: If False, warnings will be printed if the supplied paths
-        do not have conflicts.
-    """
+def resolve(tree, paths=None, ignore_misses=False):
     tree.lock_tree_write()
     try:
         tree_conflicts = tree.conflicts()
@@ -138,8 +126,7 @@
             selected_conflicts = tree_conflicts
         else:
             new_conflicts, selected_conflicts = \
-                tree_conflicts.select_conflicts(tree, paths, ignore_misses,
-                    recursive)
+                tree_conflicts.select_conflicts(tree, paths, ignore_misses)
         try:
             tree.set_conflicts(new_conflicts)
         except errors.UnsupportedOperation:
@@ -515,16 +502,6 @@
              "%(action)s."
 
 
-class NonDirectoryParent(HandledConflict):
-    """An attempt to add files to a directory that is not a director or
-    an attempt to change the kind of a directory with files.
-    """
-
-    typestring = 'non-directory parent'
-
-    format = "Conflict: %(path)s is not a directory, but has files in it."\
-             "  %(action)s."
-
 ctype = {}
 
 
@@ -537,4 +514,4 @@
 
 register_types(ContentsConflict, TextConflict, PathConflict, DuplicateID,
                DuplicateEntry, ParentLoop, UnversionedParent, MissingParent,
-               DeletingParent, NonDirectoryParent)
+               DeletingParent,)

=== modified file 'bzrlib/counted_lock.py'
--- bzrlib/counted_lock.py	2008-06-05 09:22:59 +0000
+++ bzrlib/counted_lock.py	2007-05-02 14:00:53 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007, 2008 Canonical Ltd
+# Copyright (C) 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -17,11 +17,17 @@
 """Counted lock class"""
 
 
-from bzrlib import (
-    errors,
+from bzrlib.errors import (
+    LockError,
+    ReadOnlyError,
     )
 
 
+# TODO: Pass through lock tokens on lock_write and read, and return them...
+#
+# TODO: Allow upgrading read locks to write?  Conceptually difficult.
+
+
 class CountedLock(object):
     """Decorator around a lock that makes it reentrant.
 
@@ -34,10 +40,6 @@
         self._lock_mode = None
         self._lock_count = 0
 
-    def __repr__(self):
-        return "%s(%r)" % (self.__class__.__name__,
-            self._real_lock)
-
     def break_lock(self):
         self._real_lock.break_lock()
         self._lock_mode = None
@@ -54,40 +56,32 @@
         it is taken in read mode.
         """
         if self._lock_mode:
+            assert self._lock_mode in ('r', 'w'), \
+                   "invalid lock mode %r" % self._lock_mode
             self._lock_count += 1
         else:
+            assert self._lock_count == 0
             self._real_lock.lock_read()
             self._lock_count = 1
             self._lock_mode = 'r'
 
-    def lock_write(self, token=None):
+    def lock_write(self):
         """Acquire the lock in write mode.
 
         If the lock was originally acquired in read mode this will fail.
-
-        :param token: If non-None, reacquire the lock using this token.
         """
         if self._lock_count == 0:
-            return_token = self._real_lock.lock_write(token)
+            assert self._lock_mode is None
+            self._real_lock.lock_write()
             self._lock_mode = 'w'
-            self._lock_count += 1
-            return return_token
         elif self._lock_mode != 'w':
-            raise errors.ReadOnlyError(self)
-        else:
-            self._real_lock.validate_token(token)
-            self._lock_count += 1
-            return token
+            raise ReadOnlyError(self)
+        self._lock_count += 1
 
     def unlock(self):
         if self._lock_count == 0:
-            raise errors.LockNotHeld(self)
+            raise LockError("%s not locked" % (self,))
         elif self._lock_count == 1:
-            # these are decremented first; if we fail to unlock the most
-            # reasonable assumption is that we still don't have the lock
-            # anymore
+            self._real_lock.unlock()
             self._lock_mode = None
-            self._lock_count -= 1
-            self._real_lock.unlock()
-        else:
-            self._lock_count -= 1
+        self._lock_count -= 1

=== modified file 'bzrlib/debug.py'
--- bzrlib/debug.py	2008-05-07 22:47:56 +0000
+++ bzrlib/debug.py	2007-10-18 10:33:11 +0000
@@ -16,7 +16,7 @@
 
 
 # NOTE: If update these, please also update the help for global-options in
-#       bzrlib/help_topics/__init__.py
+#       bzrlib/help_topics.py.
 
 debug_flags = set()
 """Set of flags that enable different debug behaviour.
@@ -29,15 +29,9 @@
  * error - show stack traces for all top level exceptions
  * evil - capture call sites that do expensive or badly-scaling operations.
  * fetch - trace history copying between repositories
- * graph - trace graph traversal information
- * hashcache - log every time a working file is read to determine its hash
  * hooks - trace hook execution
  * hpss - trace smart protocol requests and responses
- * http - trace http connections, requests and responses
  * index - trace major index operations
- * knit - trace knit operations
  * lock - trace when lockdir locks are taken or released
- * merge - emit information for debugging merges
- * pack - emit information about pack operations
 
 """

=== modified file 'bzrlib/decorators.py'
--- bzrlib/decorators.py	2008-06-08 17:00:25 +0000
+++ bzrlib/decorators.py	2007-01-25 15:54:29 +0000
@@ -22,9 +22,6 @@
            ]
 
 
-import sys
-
-
 def _get_parameters(func):
     """Recreate the parameters for a function using introspection.
 
@@ -92,17 +89,9 @@
 def %(name)s_read_locked(%(params)s):
     self.lock_read()
     try:
-        result = unbound(%(passed_params)s)
-    except:
-        import sys
-        exc_info = sys.exc_info()
-        try:
-            self.unlock()
-        finally:
-            raise exc_info[0], exc_info[1], exc_info[2]
-    else:
+        return unbound(%(passed_params)s)
+    finally:
         self.unlock()
-        return result
 read_locked = %(name)s_read_locked
 """
     params, passed_params = _get_parameters(unbound)
@@ -135,17 +124,9 @@
     def read_locked(self, *args, **kwargs):
         self.lock_read()
         try:
-            result = unbound(self, *args, **kwargs)
-        except:
-            import sys
-            exc_info = sys.exc_info()
-            try:
-                self.unlock()
-            finally:
-                raise exc_info[0], exc_info[1], exc_info[2]
-        else:
+            return unbound(self, *args, **kwargs)
+        finally:
             self.unlock()
-            return result
     read_locked.__doc__ = unbound.__doc__
     read_locked.__name__ = unbound.__name__
     return read_locked
@@ -157,17 +138,9 @@
 def %(name)s_write_locked(%(params)s):
     self.lock_write()
     try:
-        result = unbound(%(passed_params)s)
-    except:
-        import sys
-        exc_info = sys.exc_info()
-        try:
-            self.unlock()
-        finally:
-            raise exc_info[0], exc_info[1], exc_info[2]
-    else:
+        return unbound(%(passed_params)s)
+    finally:
         self.unlock()
-        return result
 write_locked = %(name)s_write_locked
 """
     params, passed_params = _get_parameters(unbound)
@@ -189,16 +162,9 @@
     def write_locked(self, *args, **kwargs):
         self.lock_write()
         try:
-            result = unbound(self, *args, **kwargs)
-        except:
-            exc_info = sys.exc_info()
-            try:
-                self.unlock()
-            finally:
-                raise exc_info[0], exc_info[1], exc_info[2]
-        else:
+            return unbound(self, *args, **kwargs)
+        finally:
             self.unlock()
-            return result
     write_locked.__doc__ = unbound.__doc__
     write_locked.__name__ = unbound.__name__
     return write_locked

=== modified file 'bzrlib/delta.py'
--- bzrlib/delta.py	2008-04-24 07:22:53 +0000
+++ bzrlib/delta.py	2007-10-16 16:02:01 +0000
@@ -19,7 +19,7 @@
     osutils,
     )
 from bzrlib.inventory import InventoryEntry
-from bzrlib.trace import mutter, is_quiet
+from bzrlib.trace import mutter
 from bzrlib.symbol_versioning import deprecated_function
 
 
@@ -211,7 +211,7 @@
     # mutter('start compare_trees')
 
     for (file_id, path, content_change, versioned, parent_id, name, kind,
-         executable) in new_tree.iter_changes(old_tree, want_unchanged,
+         executable) in new_tree._iter_changes(old_tree, want_unchanged,
             specific_files, extra_trees=extra_trees,
             require_versioned=require_versioned,
             want_unversioned=want_unversioned):
@@ -226,6 +226,7 @@
             if fully_present[1] is True:
                 delta.added.append((path[1], file_id, kind[1]))
             else:
+                assert fully_present[0] is True
                 delta.removed.append((path[0], file_id, kind[0]))
         elif fully_present[0] is False:
             continue
@@ -303,18 +304,16 @@
         """Report one change to a file
 
         :param file_id: The file_id of the file
-        :param path: The old and new paths as generated by Tree.iter_changes.
+        :param path: The old and new paths as generated by Tree._iter_changes.
         :param versioned: may be 'added', 'removed', 'unchanged', or
             'unversioned.
         :param renamed: may be True or False
         :param modified: may be 'created', 'deleted', 'kind changed',
             'modified' or 'unchanged'.
         :param exe_change: True if the execute bit has changed
-        :param kind: A pair of file kinds, as generated by Tree.iter_changes.
+        :param kind: A pair of file kinds, as generated by Tree._iter_changes.
             None indicates no file present.
         """
-        if is_quiet():
-            return
         if paths[1] == '' and versioned == 'added' and self.suppress_root_add:
             return
         if versioned == 'unversioned':
@@ -334,7 +333,7 @@
                 # on a rename, we show old and new
                 old_path, path = paths
             else:
-                # if it's not renamed, we're showing both for kind changes
+                # if its not renamed, we're showing both for kind changes
                 # so only show the new path
                 old_path, path = paths[1], paths[1]
             # if the file is not missing in the source, we show its kind
@@ -374,7 +373,7 @@
     Further processing may be required to produce a human-readable output.
     Unfortunately, some tree-changing operations are very complex
     :change_iterator: an iterator or sequence of changes in the format
-        generated by Tree.iter_changes
+        generated by Tree._iter_changes
     :param reporter: The _ChangeReporter that will report the changes.
     """
     versioned_change_map = {

=== modified file 'bzrlib/deprecated_graph.py'
--- bzrlib/deprecated_graph.py	2008-04-24 07:22:53 +0000
+++ bzrlib/deprecated_graph.py	2007-07-19 06:34:09 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2008 Canonical Ltd
+# Copyright (C) 2005 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -15,6 +15,9 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 
+from bzrlib.tsort import topo_sort
+
+
 def max_distance(node, ancestors, distances, root_descendants):
     """Calculate the max distance to an ancestor.  
     Return None if not all possible ancestors have known distances"""
@@ -57,6 +60,7 @@
         new_lines = set()
         for line in lines:
             line_descendants = graph[line]
+            assert line not in line_descendants, "%s refers to itself" % line
             for descendant in line_descendants:
                 distance = max_distance(descendant, ancestors, distances,
                                         root_descendants)
@@ -141,7 +145,6 @@
     def get_ancestry(self, node_id, topo_sorted=True):
         """Return the inclusive ancestors of node_id in topological order."""
         # maybe optimise this ?
-        from bzrlib.tsort import topo_sort
         result = {}
         pending = set([node_id])
         while len(pending):

=== modified file 'bzrlib/diff.py'
--- bzrlib/diff.py	2008-08-26 08:25:27 +0000
+++ bzrlib/diff.py	2007-10-16 16:02:01 +0000
@@ -17,7 +17,6 @@
 import difflib
 import os
 import re
-import shutil
 import sys
 
 from bzrlib.lazy_import import lazy_import
@@ -28,9 +27,6 @@
 import time
 
 from bzrlib import (
-    branch as _mod_branch,
-    bzrdir,
-    commands,
     errors,
     osutils,
     patiencediff,
@@ -41,7 +37,6 @@
 
 from bzrlib.symbol_versioning import (
         deprecated_function,
-        one_three
         )
 from bzrlib.trace import mutter, warning
 
@@ -91,8 +86,6 @@
                       sequencematcher=sequence_matcher)
 
     ud = list(ud)
-    if len(ud) == 0: # Identical contents, nothing to do
-        return
     # work-around for difflib being too smart for its own good
     # if /dev/null is "1,0", patch won't recognize it as /dev/null
     if not oldlines:
@@ -275,135 +268,91 @@
                         new_abspath, e)
 
 
-def _get_trees_to_diff(path_list, revision_specs, old_url, new_url):
-    """Get the trees and specific files to diff given a list of paths.
-
-    This method works out the trees to be diff'ed and the files of
-    interest within those trees.
-
-    :param path_list:
-        the list of arguments passed to the diff command
-    :param revision_specs:
-        Zero, one or two RevisionSpecs from the diff command line,
-        saying what revisions to compare.
-    :param old_url:
-        The url of the old branch or tree. If None, the tree to use is
-        taken from the first path, if any, or the current working tree.
-    :param new_url:
-        The url of the new branch or tree. If None, the tree to use is
-        taken from the first path, if any, or the current working tree.
-    :returns:
-        a tuple of (old_tree, new_tree, specific_files, extra_trees) where
-        extra_trees is a sequence of additional trees to search in for
-        file-ids.
+def diff_cmd_helper(tree, specific_files, external_diff_options, 
+                    old_revision_spec=None, new_revision_spec=None,
+                    revision_specs=None,
+                    old_label='a/', new_label='b/'):
+    """Helper for cmd_diff.
+
+    :param tree:
+        A WorkingTree
+
+    :param specific_files:
+        The specific files to compare, or None
+
+    :param external_diff_options:
+        If non-None, run an external diff, and pass it these options
+
+    :param old_revision_spec:
+        If None, use basis tree as old revision, otherwise use the tree for
+        the specified revision. 
+
+    :param new_revision_spec:
+        If None, use working tree as new revision, otherwise use the tree for
+        the specified revision.
+    
+    :param revision_specs: 
+        Zero, one or two RevisionSpecs from the command line, saying what revisions 
+        to compare.  This can be passed as an alternative to the old_revision_spec 
+        and new_revision_spec parameters.
+
+    The more general form is show_diff_trees(), where the caller
+    supplies any two trees.
     """
-    # Get the old and new revision specs
-    old_revision_spec = None
-    new_revision_spec = None
+
+    # TODO: perhaps remove the old parameters old_revision_spec and
+    # new_revision_spec, since this is only really for use from cmd_diff and
+    # it now always passes through a sequence of revision_specs -- mbp
+    # 20061221
+
+    def spec_tree(spec):
+        if tree:
+            revision = spec.in_store(tree.branch)
+        else:
+            revision = spec.in_store(None)
+        revision_id = revision.rev_id
+        branch = revision.branch
+        return branch.repository.revision_tree(revision_id)
+
     if revision_specs is not None:
+        assert (old_revision_spec is None
+                and new_revision_spec is None)
         if len(revision_specs) > 0:
             old_revision_spec = revision_specs[0]
-            if old_url is None:
-                old_url = old_revision_spec.get_branch()
         if len(revision_specs) > 1:
             new_revision_spec = revision_specs[1]
-            if new_url is None:
-                new_url = new_revision_spec.get_branch()
-
-    other_paths = []
-    make_paths_wt_relative = True
-    consider_relpath = True
-    if path_list is None or len(path_list) == 0:
-        # If no path is given, the current working tree is used
-        default_location = u'.'
-        consider_relpath = False
-    elif old_url is not None and new_url is not None:
-        other_paths = path_list
-        make_paths_wt_relative = False
-    else:
-        default_location = path_list[0]
-        other_paths = path_list[1:]
-
-    # Get the old location
-    specific_files = []
-    if old_url is None:
-        old_url = default_location
-    working_tree, branch, relpath = \
-        bzrdir.BzrDir.open_containing_tree_or_branch(old_url)
-    if consider_relpath and relpath != '':
-        specific_files.append(relpath)
-    old_tree = _get_tree_to_diff(old_revision_spec, working_tree, branch)
-
-    # Get the new location
-    if new_url is None:
-        new_url = default_location
-    if new_url != old_url:
-        working_tree, branch, relpath = \
-            bzrdir.BzrDir.open_containing_tree_or_branch(new_url)
-        if consider_relpath and relpath != '':
-            specific_files.append(relpath)
-    new_tree = _get_tree_to_diff(new_revision_spec, working_tree, branch,
-        basis_is_default=working_tree is None)
-
-    # Get the specific files (all files is None, no files is [])
-    if make_paths_wt_relative and working_tree is not None:
-        other_paths = _relative_paths_in_tree(working_tree, other_paths)
-    specific_files.extend(other_paths)
-    if len(specific_files) == 0:
-        specific_files = None
-
-    # Get extra trees that ought to be searched for file-ids
-    extra_trees = None
-    if working_tree is not None and working_tree not in (old_tree, new_tree):
-        extra_trees = (working_tree,)
-    return old_tree, new_tree, specific_files, extra_trees
-
-
-def _get_tree_to_diff(spec, tree=None, branch=None, basis_is_default=True):
-    if branch is None and tree is not None:
-        branch = tree.branch
-    if spec is None or spec.spec is None:
-        if basis_is_default:
-            if tree is not None:
-                return tree.basis_tree()
-            else:
-                return branch.basis_tree()
-        else:
-            return tree
-    if not spec.needs_branch():
-        branch = _mod_branch.Branch.open(spec.get_branch())
-    revision_id = spec.as_revision_id(branch)
-    return branch.repository.revision_tree(revision_id)
-
-
-def _relative_paths_in_tree(tree, paths):
-    """Get the relative paths within a working tree.
-
-    Each path may be either an absolute path or a path relative to the
-    current working directory.
-    """
-    result = []
-    for filename in paths:
-        try:
-            result.append(tree.relpath(osutils.dereference_path(filename)))
-        except errors.PathNotChild:
-            raise errors.BzrCommandError("Files are in different branches")
-    return result
+
+    if old_revision_spec is None:
+        old_tree = tree.basis_tree()
+    else:
+        old_tree = spec_tree(old_revision_spec)
+
+    if (new_revision_spec is None
+        or new_revision_spec.spec is None):
+        new_tree = tree
+    else:
+        new_tree = spec_tree(new_revision_spec)
+
+    if new_tree is not tree:
+        extra_trees = (tree,)
+    else:
+        extra_trees = None
+
+    return show_diff_trees(old_tree, new_tree, sys.stdout, specific_files,
+                           external_diff_options,
+                           old_label=old_label, new_label=new_label,
+                           extra_trees=extra_trees)
 
 
 def show_diff_trees(old_tree, new_tree, to_file, specific_files=None,
                     external_diff_options=None,
                     old_label='a/', new_label='b/',
                     extra_trees=None,
-                    path_encoding='utf8',
-                    using=None):
+                    path_encoding='utf8'):
     """Show in text form the changes from one tree to another.
 
-    to_file
-        The output stream.
-
-    specific_files
-        Include only changes to these files - None for all changes.
+    to_files
+        If set, include only changes to these files.
 
     external_diff_options
         If set, use an external GNU diff and pass these options.
@@ -422,11 +371,11 @@
                 tree.lock_read()
         new_tree.lock_read()
         try:
-            differ = DiffTree.from_trees_options(old_tree, new_tree, to_file,
-                                                 path_encoding,
-                                                 external_diff_options,
-                                                 old_label, new_label, using)
-            return differ.show_diff(specific_files, extra_trees)
+            return _show_diff_trees(old_tree, new_tree, to_file,
+                                    specific_files, external_diff_options,
+                                    old_label=old_label, new_label=new_label,
+                                    extra_trees=extra_trees,
+                                    path_encoding=path_encoding)
         finally:
             new_tree.unlock()
             if extra_trees is not None:
@@ -436,9 +385,93 @@
         old_tree.unlock()
 
 
+def _show_diff_trees(old_tree, new_tree, to_file,
+                     specific_files, external_diff_options, path_encoding,
+                     old_label='a/', new_label='b/', extra_trees=None):
+
+    # GNU Patch uses the epoch date to detect files that are being added
+    # or removed in a diff.
+    EPOCH_DATE = '1970-01-01 00:00:00 +0000'
+
+    # TODO: Generation of pseudo-diffs for added/deleted files could
+    # be usefully made into a much faster special case.
+
+    if external_diff_options:
+        assert isinstance(external_diff_options, basestring)
+        opts = external_diff_options.split()
+        def diff_file(olab, olines, nlab, nlines, to_file):
+            external_diff(olab, olines, nlab, nlines, to_file, opts)
+    else:
+        diff_file = internal_diff
+    
+    delta = new_tree.changes_from(old_tree,
+        specific_files=specific_files,
+        extra_trees=extra_trees, require_versioned=True)
+
+    has_changes = 0
+    for path, file_id, kind in delta.removed:
+        has_changes = 1
+        path_encoded = path.encode(path_encoding, "replace")
+        to_file.write("=== removed %s '%s'\n" % (kind, path_encoded))
+        old_name = '%s%s\t%s' % (old_label, path,
+                                 _patch_header_date(old_tree, file_id, path))
+        new_name = '%s%s\t%s' % (new_label, path, EPOCH_DATE)
+        old_tree.inventory[file_id].diff(diff_file, old_name, old_tree,
+                                         new_name, None, None, to_file)
+    for path, file_id, kind in delta.added:
+        has_changes = 1
+        path_encoded = path.encode(path_encoding, "replace")
+        to_file.write("=== added %s '%s'\n" % (kind, path_encoded))
+        old_name = '%s%s\t%s' % (old_label, path, EPOCH_DATE)
+        new_name = '%s%s\t%s' % (new_label, path,
+                                 _patch_header_date(new_tree, file_id, path))
+        new_tree.inventory[file_id].diff(diff_file, new_name, new_tree,
+                                         old_name, None, None, to_file, 
+                                         reverse=True)
+    for (old_path, new_path, file_id, kind,
+         text_modified, meta_modified) in delta.renamed:
+        has_changes = 1
+        prop_str = get_prop_change(meta_modified)
+        oldpath_encoded = old_path.encode(path_encoding, "replace")
+        newpath_encoded = new_path.encode(path_encoding, "replace")
+        to_file.write("=== renamed %s '%s' => '%s'%s\n" % (kind,
+                            oldpath_encoded, newpath_encoded, prop_str))
+        old_name = '%s%s\t%s' % (old_label, old_path,
+                                 _patch_header_date(old_tree, file_id,
+                                                    old_path))
+        new_name = '%s%s\t%s' % (new_label, new_path,
+                                 _patch_header_date(new_tree, file_id,
+                                                    new_path))
+        _maybe_diff_file_or_symlink(old_name, old_tree, file_id,
+                                    new_name, new_tree,
+                                    text_modified, kind, to_file, diff_file)
+    for path, file_id, kind, text_modified, meta_modified in delta.modified:
+        has_changes = 1
+        prop_str = get_prop_change(meta_modified)
+        path_encoded = path.encode(path_encoding, "replace")
+        to_file.write("=== modified %s '%s'%s\n" % (kind,
+                            path_encoded, prop_str))
+        # The file may be in a different location in the old tree (because
+        # the containing dir was renamed, but the file itself was not)
+        old_path = old_tree.id2path(file_id)
+        old_name = '%s%s\t%s' % (old_label, old_path,
+                                 _patch_header_date(old_tree, file_id, old_path))
+        new_name = '%s%s\t%s' % (new_label, path,
+                                 _patch_header_date(new_tree, file_id, path))
+        if text_modified:
+            _maybe_diff_file_or_symlink(old_name, old_tree, file_id,
+                                        new_name, new_tree,
+                                        True, kind, to_file, diff_file)
+
+    return has_changes
+
+
 def _patch_header_date(tree, file_id, path):
     """Returns a timestamp suitable for use in a patch header."""
     mtime = tree.get_file_mtime(file_id, path)
+    assert mtime is not None, \
+        "got an mtime of None for file-id %s, path %s in tree %s" % (
+                file_id, path, tree)
     return timestamp.format_patch_date(mtime)
 
 
@@ -461,481 +494,19 @@
         raise errors.PathsDoNotExist(sorted(s))
 
 
-@deprecated_function(one_three)
 def get_prop_change(meta_modified):
     if meta_modified:
         return " (properties changed)"
     else:
         return  ""
 
-def get_executable_change(old_is_x, new_is_x):
-    descr = { True:"+x", False:"-x", None:"??" }
-    if old_is_x != new_is_x:
-        return ["%s to %s" % (descr[old_is_x], descr[new_is_x],)]
-    else:
-        return []
-
-
-class DiffPath(object):
-    """Base type for command object that compare files"""
-
-    # The type or contents of the file were unsuitable for diffing
-    CANNOT_DIFF = 'CANNOT_DIFF'
-    # The file has changed in a semantic way
-    CHANGED = 'CHANGED'
-    # The file content may have changed, but there is no semantic change
-    UNCHANGED = 'UNCHANGED'
-
-    def __init__(self, old_tree, new_tree, to_file, path_encoding='utf-8'):
-        """Constructor.
-
-        :param old_tree: The tree to show as the old tree in the comparison
-        :param new_tree: The tree to show as new in the comparison
-        :param to_file: The file to write comparison data to
-        :param path_encoding: The character encoding to write paths in
-        """
-        self.old_tree = old_tree
-        self.new_tree = new_tree
-        self.to_file = to_file
-        self.path_encoding = path_encoding
-
-    def finish(self):
-        pass
-
-    @classmethod
-    def from_diff_tree(klass, diff_tree):
-        return klass(diff_tree.old_tree, diff_tree.new_tree,
-                     diff_tree.to_file, diff_tree.path_encoding)
-
-    @staticmethod
-    def _diff_many(differs, file_id, old_path, new_path, old_kind, new_kind):
-        for file_differ in differs:
-            result = file_differ.diff(file_id, old_path, new_path, old_kind,
-                                      new_kind)
-            if result is not DiffPath.CANNOT_DIFF:
-                return result
-        else:
-            return DiffPath.CANNOT_DIFF
-
-
-class DiffKindChange(object):
-    """Special differ for file kind changes.
-
-    Represents kind change as deletion + creation.  Uses the other differs
-    to do this.
-    """
-    def __init__(self, differs):
-        self.differs = differs
-
-    def finish(self):
-        pass
-
-    @classmethod
-    def from_diff_tree(klass, diff_tree):
-        return klass(diff_tree.differs)
-
-    def diff(self, file_id, old_path, new_path, old_kind, new_kind):
-        """Perform comparison
-
-        :param file_id: The file_id of the file to compare
-        :param old_path: Path of the file in the old tree
-        :param new_path: Path of the file in the new tree
-        :param old_kind: Old file-kind of the file
-        :param new_kind: New file-kind of the file
-        """
-        if None in (old_kind, new_kind):
-            return DiffPath.CANNOT_DIFF
-        result = DiffPath._diff_many(self.differs, file_id, old_path,
-                                       new_path, old_kind, None)
-        if result is DiffPath.CANNOT_DIFF:
-            return result
-        return DiffPath._diff_many(self.differs, file_id, old_path, new_path,
-                                     None, new_kind)
-
-
-class DiffDirectory(DiffPath):
-
-    def diff(self, file_id, old_path, new_path, old_kind, new_kind):
-        """Perform comparison between two directories.  (dummy)
-
-        """
-        if 'directory' not in (old_kind, new_kind):
-            return self.CANNOT_DIFF
-        if old_kind not in ('directory', None):
-            return self.CANNOT_DIFF
-        if new_kind not in ('directory', None):
-            return self.CANNOT_DIFF
-        return self.CHANGED
-
-
-class DiffSymlink(DiffPath):
-
-    def diff(self, file_id, old_path, new_path, old_kind, new_kind):
-        """Perform comparison between two symlinks
-
-        :param file_id: The file_id of the file to compare
-        :param old_path: Path of the file in the old tree
-        :param new_path: Path of the file in the new tree
-        :param old_kind: Old file-kind of the file
-        :param new_kind: New file-kind of the file
-        """
-        if 'symlink' not in (old_kind, new_kind):
-            return self.CANNOT_DIFF
-        if old_kind == 'symlink':
-            old_target = self.old_tree.get_symlink_target(file_id)
-        elif old_kind is None:
-            old_target = None
-        else:
-            return self.CANNOT_DIFF
-        if new_kind == 'symlink':
-            new_target = self.new_tree.get_symlink_target(file_id)
-        elif new_kind is None:
-            new_target = None
-        else:
-            return self.CANNOT_DIFF
-        return self.diff_symlink(old_target, new_target)
-
-    def diff_symlink(self, old_target, new_target):
-        if old_target is None:
-            self.to_file.write('=== target is %r\n' % new_target)
-        elif new_target is None:
-            self.to_file.write('=== target was %r\n' % old_target)
-        else:
-            self.to_file.write('=== target changed %r => %r\n' %
-                              (old_target, new_target))
-        return self.CHANGED
-
-
-class DiffText(DiffPath):
-
-    # GNU Patch uses the epoch date to detect files that are being added
-    # or removed in a diff.
-    EPOCH_DATE = '1970-01-01 00:00:00 +0000'
-
-    def __init__(self, old_tree, new_tree, to_file, path_encoding='utf-8',
-                 old_label='', new_label='', text_differ=internal_diff):
-        DiffPath.__init__(self, old_tree, new_tree, to_file, path_encoding)
-        self.text_differ = text_differ
-        self.old_label = old_label
-        self.new_label = new_label
-        self.path_encoding = path_encoding
-
-    def diff(self, file_id, old_path, new_path, old_kind, new_kind):
-        """Compare two files in unified diff format
-
-        :param file_id: The file_id of the file to compare
-        :param old_path: Path of the file in the old tree
-        :param new_path: Path of the file in the new tree
-        :param old_kind: Old file-kind of the file
-        :param new_kind: New file-kind of the file
-        """
-        if 'file' not in (old_kind, new_kind):
-            return self.CANNOT_DIFF
-        from_file_id = to_file_id = file_id
-        if old_kind == 'file':
-            old_date = _patch_header_date(self.old_tree, file_id, old_path)
-        elif old_kind is None:
-            old_date = self.EPOCH_DATE
-            from_file_id = None
-        else:
-            return self.CANNOT_DIFF
-        if new_kind == 'file':
-            new_date = _patch_header_date(self.new_tree, file_id, new_path)
-        elif new_kind is None:
-            new_date = self.EPOCH_DATE
-            to_file_id = None
-        else:
-            return self.CANNOT_DIFF
-        from_label = '%s%s\t%s' % (self.old_label, old_path, old_date)
-        to_label = '%s%s\t%s' % (self.new_label, new_path, new_date)
-        return self.diff_text(from_file_id, to_file_id, from_label, to_label)
-
-    def diff_text(self, from_file_id, to_file_id, from_label, to_label):
-        """Diff the content of given files in two trees
-
-        :param from_file_id: The id of the file in the from tree.  If None,
-            the file is not present in the from tree.
-        :param to_file_id: The id of the file in the to tree.  This may refer
-            to a different file from from_file_id.  If None,
-            the file is not present in the to tree.
-        """
-        def _get_text(tree, file_id):
-            if file_id is not None:
-                return tree.get_file(file_id).readlines()
-            else:
-                return []
-        try:
-            from_text = _get_text(self.old_tree, from_file_id)
-            to_text = _get_text(self.new_tree, to_file_id)
-            self.text_differ(from_label, from_text, to_label, to_text,
-                             self.to_file)
-        except errors.BinaryFile:
-            self.to_file.write(
-                  ("Binary files %s and %s differ\n" %
-                  (from_label, to_label)).encode(self.path_encoding))
-        return self.CHANGED
-
-
-class DiffFromTool(DiffPath):
-
-    def __init__(self, command_template, old_tree, new_tree, to_file,
-                 path_encoding='utf-8'):
-        DiffPath.__init__(self, old_tree, new_tree, to_file, path_encoding)
-        self.command_template = command_template
-        self._root = osutils.mkdtemp(prefix='bzr-diff-')
-
-    @classmethod
-    def from_string(klass, command_string, old_tree, new_tree, to_file,
-                    path_encoding='utf-8'):
-        command_template = commands.shlex_split_unicode(command_string)
-        command_template.extend(['%(old_path)s', '%(new_path)s'])
-        return klass(command_template, old_tree, new_tree, to_file,
-                     path_encoding)
-
-    @classmethod
-    def make_from_diff_tree(klass, command_string):
-        def from_diff_tree(diff_tree):
-            return klass.from_string(command_string, diff_tree.old_tree,
-                                     diff_tree.new_tree, diff_tree.to_file)
-        return from_diff_tree
-
-    def _get_command(self, old_path, new_path):
-        my_map = {'old_path': old_path, 'new_path': new_path}
-        return [t % my_map for t in self.command_template]
-
-    def _execute(self, old_path, new_path):
-        command = self._get_command(old_path, new_path)
-        try:
-            proc = subprocess.Popen(command, stdout=subprocess.PIPE,
-                                    cwd=self._root)
-        except OSError, e:
-            if e.errno == errno.ENOENT:
-                raise errors.ExecutableMissing(command[0])
-            else:
-                raise
-        self.to_file.write(proc.stdout.read())
-        return proc.wait()
-
-    def _try_symlink_root(self, tree, prefix):
-        if (getattr(tree, 'abspath', None) is None
-            or not osutils.host_os_dereferences_symlinks()):
-            return False
-        try:
-            os.symlink(tree.abspath(''), osutils.pathjoin(self._root, prefix))
-        except OSError, e:
-            if e.errno != errno.EEXIST:
-                raise
-        return True
-
-    def _write_file(self, file_id, tree, prefix, relpath):
-        full_path = osutils.pathjoin(self._root, prefix, relpath)
-        if self._try_symlink_root(tree, prefix):
-            return full_path
-        parent_dir = osutils.dirname(full_path)
-        try:
-            os.makedirs(parent_dir)
-        except OSError, e:
-            if e.errno != errno.EEXIST:
-                raise
-        source = tree.get_file(file_id, relpath)
-        try:
-            target = open(full_path, 'wb')
-            try:
-                osutils.pumpfile(source, target)
-            finally:
-                target.close()
-        finally:
-            source.close()
-        osutils.make_readonly(full_path)
-        mtime = tree.get_file_mtime(file_id)
-        os.utime(full_path, (mtime, mtime))
-        return full_path
-
-    def _prepare_files(self, file_id, old_path, new_path):
-        old_disk_path = self._write_file(file_id, self.old_tree, 'old',
-                                         old_path)
-        new_disk_path = self._write_file(file_id, self.new_tree, 'new',
-                                         new_path)
-        return old_disk_path, new_disk_path
-
-    def finish(self):
-        osutils.rmtree(self._root)
-
-    def diff(self, file_id, old_path, new_path, old_kind, new_kind):
-        if (old_kind, new_kind) != ('file', 'file'):
-            return DiffPath.CANNOT_DIFF
-        self._prepare_files(file_id, old_path, new_path)
-        self._execute(osutils.pathjoin('old', old_path),
-                      osutils.pathjoin('new', new_path))
-
-
-class DiffTree(object):
-    """Provides textual representations of the difference between two trees.
-
-    A DiffTree examines two trees and where a file-id has altered
-    between them, generates a textual representation of the difference.
-    DiffTree uses a sequence of DiffPath objects which are each
-    given the opportunity to handle a given altered fileid. The list
-    of DiffPath objects can be extended globally by appending to
-    DiffTree.diff_factories, or for a specific diff operation by
-    supplying the extra_factories option to the appropriate method.
-    """
-
-    # list of factories that can provide instances of DiffPath objects
-    # may be extended by plugins.
-    diff_factories = [DiffSymlink.from_diff_tree,
-                      DiffDirectory.from_diff_tree]
-
-    def __init__(self, old_tree, new_tree, to_file, path_encoding='utf-8',
-                 diff_text=None, extra_factories=None):
-        """Constructor
-
-        :param old_tree: Tree to show as old in the comparison
-        :param new_tree: Tree to show as new in the comparison
-        :param to_file: File to write comparision to
-        :param path_encoding: Character encoding to write paths in
-        :param diff_text: DiffPath-type object to use as a last resort for
-            diffing text files.
-        :param extra_factories: Factories of DiffPaths to try before any other
-            DiffPaths"""
-        if diff_text is None:
-            diff_text = DiffText(old_tree, new_tree, to_file, path_encoding,
-                                 '', '',  internal_diff)
-        self.old_tree = old_tree
-        self.new_tree = new_tree
-        self.to_file = to_file
-        self.path_encoding = path_encoding
-        self.differs = []
-        if extra_factories is not None:
-            self.differs.extend(f(self) for f in extra_factories)
-        self.differs.extend(f(self) for f in self.diff_factories)
-        self.differs.extend([diff_text, DiffKindChange.from_diff_tree(self)])
-
-    @classmethod
-    def from_trees_options(klass, old_tree, new_tree, to_file,
-                           path_encoding, external_diff_options, old_label,
-                           new_label, using):
-        """Factory for producing a DiffTree.
-
-        Designed to accept options used by show_diff_trees.
-        :param old_tree: The tree to show as old in the comparison
-        :param new_tree: The tree to show as new in the comparison
-        :param to_file: File to write comparisons to
-        :param path_encoding: Character encoding to use for writing paths
-        :param external_diff_options: If supplied, use the installed diff
-            binary to perform file comparison, using supplied options.
-        :param old_label: Prefix to use for old file labels
-        :param new_label: Prefix to use for new file labels
-        :param using: Commandline to use to invoke an external diff tool
-        """
-        if using is not None:
-            extra_factories = [DiffFromTool.make_from_diff_tree(using)]
-        else:
-            extra_factories = []
-        if external_diff_options:
-            opts = external_diff_options.split()
-            def diff_file(olab, olines, nlab, nlines, to_file):
-                external_diff(olab, olines, nlab, nlines, to_file, opts)
-        else:
-            diff_file = internal_diff
-        diff_text = DiffText(old_tree, new_tree, to_file, path_encoding,
-                             old_label, new_label, diff_file)
-        return klass(old_tree, new_tree, to_file, path_encoding, diff_text,
-                     extra_factories)
-
-    def show_diff(self, specific_files, extra_trees=None):
-        """Write tree diff to self.to_file
-
-        :param sepecific_files: the specific files to compare (recursive)
-        :param extra_trees: extra trees to use for mapping paths to file_ids
-        """
-        try:
-            return self._show_diff(specific_files, extra_trees)
-        finally:
-            for differ in self.differs:
-                differ.finish()
-
-    def _show_diff(self, specific_files, extra_trees):
-        # TODO: Generation of pseudo-diffs for added/deleted files could
-        # be usefully made into a much faster special case.
-        iterator = self.new_tree.iter_changes(self.old_tree,
-                                               specific_files=specific_files,
-                                               extra_trees=extra_trees,
-                                               require_versioned=True)
-        has_changes = 0
-        def changes_key(change):
-            old_path, new_path = change[1]
-            path = new_path
-            if path is None:
-                path = old_path
-            return path
-        def get_encoded_path(path):
-            if path is not None:
-                return path.encode(self.path_encoding, "replace")
-        for (file_id, paths, changed_content, versioned, parent, name, kind,
-             executable) in sorted(iterator, key=changes_key):
-            # The root does not get diffed, and items with no known kind (that
-            # is, missing) in both trees are skipped as well.
-            if parent == (None, None) or kind == (None, None):
-                continue
-            oldpath, newpath = paths
-            oldpath_encoded = get_encoded_path(paths[0])
-            newpath_encoded = get_encoded_path(paths[1])
-            old_present = (kind[0] is not None and versioned[0])
-            new_present = (kind[1] is not None and versioned[1])
-            renamed = (parent[0], name[0]) != (parent[1], name[1])
-
-            properties_changed = []
-            properties_changed.extend(get_executable_change(executable[0], executable[1]))
-
-            if properties_changed:
-                prop_str = " (properties changed: %s)" % (", ".join(properties_changed),)
-            else:
-                prop_str = ""
-
-            if (old_present, new_present) == (True, False):
-                self.to_file.write("=== removed %s '%s'\n" %
-                                   (kind[0], oldpath_encoded))
-                newpath = oldpath
-            elif (old_present, new_present) == (False, True):
-                self.to_file.write("=== added %s '%s'\n" %
-                                   (kind[1], newpath_encoded))
-                oldpath = newpath
-            elif renamed:
-                self.to_file.write("=== renamed %s '%s' => '%s'%s\n" %
-                    (kind[0], oldpath_encoded, newpath_encoded, prop_str))
-            else:
-                # if it was produced by iter_changes, it must be
-                # modified *somehow*, either content or execute bit.
-                self.to_file.write("=== modified %s '%s'%s\n" % (kind[0],
-                                   newpath_encoded, prop_str))
-            if changed_content:
-                self.diff(file_id, oldpath, newpath)
-                has_changes = 1
-            if renamed:
-                has_changes = 1
-        return has_changes
-
-    def diff(self, file_id, old_path, new_path):
-        """Perform a diff of a single file
-
-        :param file_id: file-id of the file
-        :param old_path: The path of the file in the old tree
-        :param new_path: The path of the file in the new tree
-        """
-        try:
-            old_kind = self.old_tree.kind(file_id)
-        except (errors.NoSuchId, errors.NoSuchFile):
-            old_kind = None
-        try:
-            new_kind = self.new_tree.kind(file_id)
-        except (errors.NoSuchId, errors.NoSuchFile):
-            new_kind = None
-
-        result = DiffPath._diff_many(self.differs, file_id, old_path,
-                                       new_path, old_kind, new_kind)
-        if result is DiffPath.CANNOT_DIFF:
-            error_path = new_path
-            if error_path is None:
-                error_path = old_path
-            raise errors.NoDiffFound(error_path)
+
+def _maybe_diff_file_or_symlink(old_path, old_tree, file_id,
+                                new_path, new_tree, text_modified,
+                                kind, to_file, diff_file):
+    if text_modified:
+        new_entry = new_tree.inventory[file_id]
+        old_tree.inventory[file_id].diff(diff_file,
+                                         old_path, old_tree,
+                                         new_path, new_entry, 
+                                         new_tree, to_file)

=== removed file 'bzrlib/directory_service.py'
--- bzrlib/directory_service.py	2008-06-30 05:27:47 +0000
+++ bzrlib/directory_service.py	1970-01-01 00:00:00 +0000
@@ -1,86 +0,0 @@
-# Copyright (C) 2008 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Directory service registration and usage.
-
-Directory services are utilities that provide a mapping from URL-like strings
-to true URLs.  Examples include lp:urls and per-user location aliases.
-"""
-
-from bzrlib import errors, registry
-from bzrlib.branch import Branch
-
-class DirectoryServiceRegistry(registry.Registry):
-    """This object maintains and uses a list of directory services.
-
-    Directory services may be registered via the standard Registry methods.
-    They will be invoked if their key is a prefix of the supplied URL.
-
-    Each item registered should be a factory of objects that provide a look_up
-    method, as invoked by dereference.  Specifically, look_up should accept a
-    name and URL, and return a URL.
-    """
-
-    def dereference(self, url):
-        """Dereference a supplied URL if possible.
-
-        URLs that match a registered directory service prefix are looked up in
-        it.  Non-matching urls are returned verbatim.
-
-        This is applied only once; the resulting URL must not be one that
-        requires further dereferencing.
-
-        :param url: The URL to dereference
-        :return: The dereferenced URL if applicable, the input URL otherwise.
-        """
-        match = self.get_prefix(url)
-        if match is None:
-            return url
-        service, name = match
-        return service().look_up(name, url)
-
-directories = DirectoryServiceRegistry()
-
-
-class AliasDirectory(object):
-    """Directory lookup for locations associated with a branch.
-
-    :parent, :submit, :public, :push, :this, and :bound are currently
-    supported.  On error, a subclass of DirectoryLookupFailure will be raised.
-    """
-
-    def look_up(self, name, url):
-        branch = Branch.open_containing('.')[0]
-        lookups = {
-            'parent': branch.get_parent,
-            'submit': branch.get_submit_branch,
-            'public': branch.get_public_branch,
-            'bound': branch.get_bound_location,
-            'push': branch.get_push_location,
-            'this': lambda: branch.base
-        }
-        try:
-            method = lookups[url[1:]]
-        except KeyError:
-            raise errors.InvalidLocationAlias(url)
-        else:
-            result = method()
-        if result is None:
-            raise errors.UnsetLocationAlias(url)
-        return result
-
-directories.register(':', AliasDirectory,
-                     'Easy access to remembered branch locations')

=== modified file 'bzrlib/dirstate.py'
--- bzrlib/dirstate.py	2008-07-30 08:55:10 +0000
+++ bzrlib/dirstate.py	2007-10-22 20:05:12 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007, 2008 Canonical Ltd
+# Copyright (C) 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -212,7 +212,6 @@
 import zlib
 
 from bzrlib import (
-    cache_utf8,
     debug,
     errors,
     inventory,
@@ -250,7 +249,7 @@
 
     A dirstate is a specialised data structure for managing local working
     tree state information. Its not yet well defined whether it is platform
-    specific, and if it is how we detect/parameterize that.
+    specific, and if it is how we detect/parameterise that.
 
     Dirstates use the usual lock_write, lock_read and unlock mechanisms.
     Unlike most bzr disk formats, DirStates must be locked for reading, using
@@ -306,6 +305,15 @@
     def __init__(self, path):
         """Create a  DirState object.
 
+        Attributes of note:
+
+        :attr _root_entrie: The root row of the directory/file information,
+            - contains the path to / - '', ''
+            - kind of 'directory',
+            - the file id of the root in utf8
+            - size of 0
+            - a packed state
+            - and no sha information.
         :param path: The path at which the dirstate file on disk should live.
         """
         # _header_state and _dirblock_state represent the current state
@@ -321,9 +329,6 @@
         # modified states.
         self._header_state = DirState.NOT_IN_MEMORY
         self._dirblock_state = DirState.NOT_IN_MEMORY
-        # If true, an error has been detected while updating the dirstate, and 
-        # for safety we're not going to commit to disk.
-        self._changes_aborted = False
         self._dirblocks = []
         self._ghosts = []
         self._parents = []
@@ -332,8 +337,6 @@
         self._lock_token = None
         self._lock_state = None
         self._id_index = None
-        # a map from packed_stat to sha's.
-        self._packed_stat_index = None
         self._end_of_header = None
         self._cutoff_time = None
         self._split_path_cache = {}
@@ -393,10 +396,8 @@
         # faster than three separate encodes.
         utf8path = (dirname + '/' + basename).strip('/').encode('utf8')
         dirname, basename = osutils.split(utf8path)
-        # uses __class__ for speed; the check is needed for safety
-        if file_id.__class__ is not str:
-            raise AssertionError(
-                "must be a utf8 file_id not %s" % (type(file_id), ))
+        assert file_id.__class__ == str, \
+            "must be a utf8 file_id not %s" % (type(file_id))
         # Make sure the file_id does not exist in this tree
         file_id_entry = self._get_entry(0, fileid_utf8=file_id)
         if file_id_entry != (None, None):
@@ -458,8 +459,7 @@
         if not present:
             block.insert(entry_index, entry_data)
         else:
-            if block[entry_index][1][0][0] != 'a':
-                raise AssertionError(" %r(%r) already added" % (basename, file_id))
+            assert block[entry_index][1][0][0] == 'a', " %r(%r) already added" % (basename, file_id)
             block[entry_index][1][0] = entry_data[1][0]
 
         if kind == 'directory':
@@ -484,8 +484,7 @@
         # If _dirblock_state was in memory, we should just return info from
         # there, this function is only meant to handle when we want to read
         # part of the disk.
-        if self._dirblock_state != DirState.NOT_IN_MEMORY:
-            raise AssertionError("bad dirblock state %r" % self._dirblock_state)
+        assert self._dirblock_state == DirState.NOT_IN_MEMORY
 
         # The disk representation is generally info + '\0\n\0' at the end. But
         # for bisecting, it is easier to treat this as '\0' + info + '\0\n'
@@ -677,8 +676,8 @@
         # If _dirblock_state was in memory, we should just return info from
         # there, this function is only meant to handle when we want to read
         # part of the disk.
-        if self._dirblock_state != DirState.NOT_IN_MEMORY:
-            raise AssertionError("bad dirblock state %r" % self._dirblock_state)
+        assert self._dirblock_state == DirState.NOT_IN_MEMORY
+
         # The disk representation is generally info + '\0\n\0' at the end. But
         # for bisecting, it is easier to treat this as '\0' + info + '\0\n'
         # Because it means we can sync on the '\n'
@@ -898,48 +897,6 @@
             processed_dirs.update(pending_dirs)
         return found
 
-    def _discard_merge_parents(self):
-        """Discard any parents trees beyond the first.
-        
-        Note that if this fails the dirstate is corrupted.
-
-        After this function returns the dirstate contains 2 trees, neither of
-        which are ghosted.
-        """
-        self._read_header_if_needed()
-        parents = self.get_parent_ids()
-        if len(parents) < 1:
-            return
-        # only require all dirblocks if we are doing a full-pass removal.
-        self._read_dirblocks_if_needed()
-        dead_patterns = set([('a', 'r'), ('a', 'a'), ('r', 'r'), ('r', 'a')])
-        def iter_entries_removable():
-            for block in self._dirblocks:
-                deleted_positions = []
-                for pos, entry in enumerate(block[1]):
-                    yield entry
-                    if (entry[1][0][0], entry[1][1][0]) in dead_patterns:
-                        deleted_positions.append(pos)
-                if deleted_positions:
-                    if len(deleted_positions) == len(block[1]):
-                        del block[1][:]
-                    else:
-                        for pos in reversed(deleted_positions):
-                            del block[1][pos]
-        # if the first parent is a ghost:
-        if parents[0] in self.get_ghosts():
-            empty_parent = [DirState.NULL_PARENT_DETAILS]
-            for entry in iter_entries_removable():
-                entry[1][1:] = empty_parent
-        else:
-            for entry in iter_entries_removable():
-                del entry[1][2:]
-
-        self._ghosts = []
-        self._parents = [parents[0]]
-        self._dirblock_state = DirState.IN_MEMORY_MODIFIED
-        self._header_state = DirState.IN_MEMORY_MODIFIED
-
     def _empty_parent_info(self):
         return [DirState.NULL_PARENT_DETAILS] * (len(self._parents) -
                                                     len(self._ghosts))
@@ -971,9 +928,8 @@
         # the basename of the directory must be the end of its full name.
         if not (parent_block_index == -1 and
             parent_block_index == -1 and dirname == ''):
-            if not dirname.endswith(
-                    self._dirblocks[parent_block_index][1][parent_row_index][0][1]):
-                raise AssertionError("bad dirname %r" % dirname)
+            assert dirname.endswith(
+                self._dirblocks[parent_block_index][1][parent_row_index][0][1])
         block_index, present = self._find_block_index_from_key((dirname, '', ''))
         if not present:
             ## In future, when doing partial parsing, this should load and 
@@ -991,9 +947,8 @@
             to prevent unneeded overhead when callers have a sorted list already.
         :return: Nothing.
         """
-        if new_entries[0][0][0:2] != ('', ''):
-            raise AssertionError(
-                "Missing root row %r" % (new_entries[0][0],))
+        assert new_entries[0][0][0:2] == ('', ''), \
+            "Missing root row %r" % (new_entries[0][0],)
         # The two blocks here are deliberate: the root block and the 
         # contents-of-root block.
         self._dirblocks = [('', []), ('', [])]
@@ -1021,8 +976,7 @@
         # The above loop leaves the "root block" entries mixed with the
         # "contents-of-root block". But we don't want an if check on
         # all entries, so instead we just fix it up here.
-        if self._dirblocks[1] != ('', []):
-            raise ValueError("bad dirblock start %r" % (self._dirblocks[1],))
+        assert self._dirblocks[1] == ('', [])
         root_block = []
         contents_of_root_block = []
         for entry in self._dirblocks[0][1]:
@@ -1173,305 +1127,6 @@
             raise
         return result
 
-    def update_by_delta(self, delta):
-        """Apply an inventory delta to the dirstate for tree 0
-
-        :param delta: An inventory delta.  See Inventory.apply_delta for
-            details.
-        """
-        self._read_dirblocks_if_needed()
-        insertions = {}
-        removals = {}
-        for old_path, new_path, file_id, inv_entry in sorted(delta, reverse=True):
-            if (file_id in insertions) or (file_id in removals):
-                raise AssertionError("repeated file id in delta %r" % (file_id,))
-            if old_path is not None:
-                old_path = old_path.encode('utf-8')
-                removals[file_id] = old_path
-            if new_path is not None:
-                new_path = new_path.encode('utf-8')
-                dirname, basename = osutils.split(new_path)
-                key = (dirname, basename, file_id)
-                minikind = DirState._kind_to_minikind[inv_entry.kind]
-                if minikind == 't':
-                    fingerprint = inv_entry.reference_revision
-                else:
-                    fingerprint = ''
-                insertions[file_id] = (key, minikind, inv_entry.executable,
-                                       fingerprint, new_path)
-            # Transform moves into delete+add pairs
-            if None not in (old_path, new_path):
-                for child in self._iter_child_entries(0, old_path):
-                    if child[0][2] in insertions or child[0][2] in removals:
-                        continue
-                    child_dirname = child[0][0]
-                    child_basename = child[0][1]
-                    minikind = child[1][0][0]
-                    fingerprint = child[1][0][4]
-                    executable = child[1][0][3]
-                    old_child_path = osutils.pathjoin(child[0][0],
-                                                      child[0][1])
-                    removals[child[0][2]] = old_child_path
-                    child_suffix = child_dirname[len(old_path):]
-                    new_child_dirname = (new_path + child_suffix)
-                    key = (new_child_dirname, child_basename, child[0][2])
-                    new_child_path = os.path.join(new_child_dirname,
-                                                  child_basename)
-                    insertions[child[0][2]] = (key, minikind, executable,
-                                               fingerprint, new_child_path)
-        self._apply_removals(removals.values())
-        self._apply_insertions(insertions.values())
-
-    def _apply_removals(self, removals):
-        for path in sorted(removals, reverse=True):
-            dirname, basename = osutils.split(path)
-            block_i, entry_i, d_present, f_present = \
-                self._get_block_entry_index(dirname, basename, 0)
-            entry = self._dirblocks[block_i][1][entry_i]
-            self._make_absent(entry)
-            # See if we have a malformed delta: deleting a directory must not
-            # leave crud behind. This increases the number of bisects needed
-            # substantially, but deletion or renames of large numbers of paths
-            # is rare enough it shouldn't be an issue (famous last words?) RBC
-            # 20080730.
-            block_i, entry_i, d_present, f_present = \
-                self._get_block_entry_index(path, '', 0)
-            if d_present:
-                # The dir block is still present in the dirstate; this could
-                # be due to it being in a parent tree, or a corrupt delta.
-                for child_entry in self._dirblocks[block_i][1]:
-                    if child_entry[1][0][0] not in ('r', 'a'):
-                        raise errors.InconsistentDelta(path, entry[0][2],
-                            "The file id was deleted but its children were "
-                            "not deleted.")
-
-    def _apply_insertions(self, adds):
-        for key, minikind, executable, fingerprint, path_utf8 in sorted(adds):
-            self.update_minimal(key, minikind, executable, fingerprint,
-                                path_utf8=path_utf8)
-
-    def update_basis_by_delta(self, delta, new_revid):
-        """Update the parents of this tree after a commit.
-
-        This gives the tree one parent, with revision id new_revid. The
-        inventory delta is applied to the current basis tree to generate the
-        inventory for the parent new_revid, and all other parent trees are
-        discarded.
-
-        Note that an exception during the operation of this method will leave
-        the dirstate in a corrupt state where it should not be saved.
-
-        Finally, we expect all changes to be synchronising the basis tree with
-        the working tree.
-
-        :param new_revid: The new revision id for the trees parent.
-        :param delta: An inventory delta (see apply_inventory_delta) describing
-            the changes from the current left most parent revision to new_revid.
-        """
-        self._read_dirblocks_if_needed()
-        self._discard_merge_parents()
-        if self._ghosts != []:
-            raise NotImplementedError(self.update_basis_by_delta)
-        if len(self._parents) == 0:
-            # setup a blank tree, the most simple way.
-            empty_parent = DirState.NULL_PARENT_DETAILS
-            for entry in self._iter_entries():
-                entry[1].append(empty_parent)
-            self._parents.append(new_revid)
-
-        self._parents[0] = new_revid
-
-        delta = sorted(delta, reverse=True)
-        adds = []
-        changes = []
-        deletes = []
-        # The paths this function accepts are unicode and must be encoded as we
-        # go.
-        encode = cache_utf8.encode
-        inv_to_entry = self._inv_entry_to_details
-        # delta is now (deletes, changes), (adds) in reverse lexographical
-        # order.
-        # deletes in reverse lexographic order are safe to process in situ.
-        # renames are not, as a rename from any path could go to a path
-        # lexographically lower, so we transform renames into delete, add pairs,
-        # expanding them recursively as needed.
-        # At the same time, to reduce interface friction we convert the input
-        # inventory entries to dirstate.
-        root_only = ('', '')
-        for old_path, new_path, file_id, inv_entry in delta:
-            if old_path is None:
-                adds.append((None, encode(new_path), file_id,
-                    inv_to_entry(inv_entry), True))
-            elif new_path is None:
-                deletes.append((encode(old_path), None, file_id, None, True))
-            elif (old_path, new_path) != root_only:
-                # Renames:
-                # Because renames must preserve their children we must have
-                # processed all relocations and removes before hand. The sort
-                # order ensures we've examined the child paths, but we also
-                # have to execute the removals, or the split to an add/delete
-                # pair will result in the deleted item being reinserted, or
-                # renamed items being reinserted twice - and possibly at the
-                # wrong place. Splitting into a delete/add pair also simplifies
-                # the handling of entries with ('f', ...), ('r' ...) because
-                # the target of the 'r' is old_path here, and we add that to
-                # deletes, meaning that the add handler does not need to check
-                # for 'r' items on every pass.
-                self._update_basis_apply_deletes(deletes)
-                deletes = []
-                new_path_utf8 = encode(new_path)
-                # Split into an add/delete pair recursively.
-                adds.append((None, new_path_utf8, file_id,
-                    inv_to_entry(inv_entry), False))
-                # Expunge deletes that we've seen so that deleted/renamed
-                # children of a rename directory are handled correctly.
-                new_deletes = reversed(list(self._iter_child_entries(1,
-                    encode(old_path))))
-                # Remove the current contents of the tree at orig_path, and
-                # reinsert at the correct new path.
-                for entry in new_deletes:
-                    if entry[0][0]:
-                        source_path = entry[0][0] + '/' + entry[0][1]
-                    else:
-                        source_path = entry[0][1]
-                    if new_path_utf8:
-                        target_path = new_path_utf8 + source_path[len(old_path):]
-                    else:
-                        if old_path == '':
-                            raise AssertionError("cannot rename directory to"
-                                " itself")
-                        target_path = source_path[len(old_path) + 1:]
-                    adds.append((None, target_path, entry[0][2], entry[1][1], False))
-                    deletes.append(
-                        (source_path, target_path, entry[0][2], None, False))
-                deletes.append(
-                    (encode(old_path), new_path, file_id, None, False))
-            else:
-                # changes to just the root should not require remove/insertion
-                # of everything.
-                changes.append((encode(old_path), encode(new_path), file_id,
-                    inv_to_entry(inv_entry)))
-
-        # Finish expunging deletes/first half of renames.
-        self._update_basis_apply_deletes(deletes)
-        # Reinstate second half of renames and new paths.
-        self._update_basis_apply_adds(adds)
-        # Apply in-situ changes.
-        self._update_basis_apply_changes(changes)
-
-        self._dirblock_state = DirState.IN_MEMORY_MODIFIED
-        self._header_state = DirState.IN_MEMORY_MODIFIED
-        self._id_index = None
-        return
-
-    def _update_basis_apply_adds(self, adds):
-        """Apply a sequence of adds to tree 1 during update_basis_by_delta.
-
-        They may be adds, or renames that have been split into add/delete
-        pairs.
-
-        :param adds: A sequence of adds. Each add is a tuple:
-            (None, new_path_utf8, file_id, (entry_details), real_add). real_add
-            is False when the add is the second half of a remove-and-reinsert
-            pair created to handle renames and deletes.
-        """
-        # Adds are accumulated partly from renames, so can be in any input
-        # order - sort it.
-        adds.sort()
-        # adds is now in lexographic order, which places all parents before
-        # their children, so we can process it linearly.
-        absent = 'ar'
-        for old_path, new_path, file_id, new_details, real_add in adds:
-            # the entry for this file_id must be in tree 0.
-            entry = self._get_entry(0, file_id, new_path)
-            if entry[0] is None or entry[0][2] != file_id:
-                self._changes_aborted = True
-                raise errors.InconsistentDelta(new_path, file_id,
-                    'working tree does not contain new entry')
-            if real_add and entry[1][1][0] not in absent:
-                self._changes_aborted = True
-                raise errors.InconsistentDelta(new_path, file_id,
-                    'The entry was considered to be a genuinely new record,'
-                    ' but there was already an old record for it.')
-            # We don't need to update the target of an 'r' because the handling
-            # of renames turns all 'r' situations into a delete at the original
-            # location.
-            entry[1][1] = new_details
-
-    def _update_basis_apply_changes(self, changes):
-        """Apply a sequence of changes to tree 1 during update_basis_by_delta.
-
-        :param adds: A sequence of changes. Each change is a tuple:
-            (path_utf8, path_utf8, file_id, (entry_details))
-        """
-        absent = 'ar'
-        for old_path, new_path, file_id, new_details in changes:
-            # the entry for this file_id must be in tree 0.
-            entry = self._get_entry(0, file_id, new_path)
-            if entry[0] is None or entry[0][2] != file_id:
-                self._changes_aborted = True
-                raise errors.InconsistentDelta(new_path, file_id,
-                    'working tree does not contain new entry')
-            if (entry[1][0][0] in absent or
-                entry[1][1][0] in absent):
-                self._changes_aborted = True
-                raise errors.InconsistentDelta(new_path, file_id,
-                    'changed considered absent')
-            entry[1][1] = new_details
-
-    def _update_basis_apply_deletes(self, deletes):
-        """Apply a sequence of deletes to tree 1 during update_basis_by_delta.
-
-        They may be deletes, or renames that have been split into add/delete
-        pairs.
-
-        :param deletes: A sequence of deletes. Each delete is a tuple:
-            (old_path_utf8, new_path_utf8, file_id, None, real_delete).
-            real_delete is True when the desired outcome is an actual deletion
-            rather than the rename handling logic temporarily deleting a path
-            during the replacement of a parent.
-        """
-        null = DirState.NULL_PARENT_DETAILS
-        for old_path, new_path, file_id, _, real_delete in deletes:
-            if real_delete != (new_path is None):
-                raise AssertionError("bad delete delta")
-            # the entry for this file_id must be in tree 1.
-            dirname, basename = osutils.split(old_path)
-            block_index, entry_index, dir_present, file_present = \
-                self._get_block_entry_index(dirname, basename, 1)
-            if not file_present:
-                self._changes_aborted = True
-                raise errors.InconsistentDelta(old_path, file_id,
-                    'basis tree does not contain removed entry')
-            entry = self._dirblocks[block_index][1][entry_index]
-            if entry[0][2] != file_id:
-                self._changes_aborted = True
-                raise errors.InconsistentDelta(old_path, file_id,
-                    'mismatched file_id in tree 1')
-            if real_delete:
-                if entry[1][0][0] != 'a':
-                    self._changes_aborted = True
-                    raise errors.InconsistentDelta(old_path, file_id,
-                            'This was marked as a real delete, but the WT state'
-                            ' claims that it still exists and is versioned.')
-                del self._dirblocks[block_index][1][entry_index]
-            else:
-                if entry[1][0][0] == 'a':
-                    self._changes_aborted = True
-                    raise errors.InconsistentDelta(old_path, file_id,
-                        'The entry was considered a rename, but the source path'
-                        ' is marked as absent.')
-                    # For whatever reason, we were asked to rename an entry
-                    # that was originally marked as deleted. This could be
-                    # because we are renaming the parent directory, and the WT
-                    # current state has the file marked as deleted.
-                elif entry[1][0][0] == 'r':
-                    # implement the rename
-                    del self._dirblocks[block_index][1][entry_index]
-                else:
-                    # it is being resurrected here, so blank it out temporarily.
-                    self._dirblocks[block_index][1][entry_index][1][1] = null
-
     def update_entry(self, entry, abspath, stat_value,
                      _stat_to_minikind=_stat_to_minikind,
                      _pack_stat=pack_stat):
@@ -1731,8 +1386,8 @@
         # linear search through entries at this path to find the one
         # requested.
         while entry_index < len(block) and block[entry_index][0][1] == basename:
-            if block[entry_index][1][tree_index][0] not in 'ar':
-                # neither absent or relocated
+            if block[entry_index][1][tree_index][0] not in \
+                       ('a', 'r'): # absent, relocated
                 return block_index, entry_index, True, True
             entry_index += 1
         return block_index, entry_index, True, False
@@ -1755,9 +1410,8 @@
         """
         self._read_dirblocks_if_needed()
         if path_utf8 is not None:
-            if type(path_utf8) is not str:
-                raise AssertionError('path_utf8 is not a str: %s %s'
-                    % (type(path_utf8), path_utf8))
+            assert path_utf8.__class__ == str, ('path_utf8 is not a str: %s %s'
+                % (type(path_utf8), path_utf8))
             # path lookups are faster
             dirname, basename = osutils.split(path_utf8)
             block_index, entry_index, dir_present, file_present = \
@@ -1765,15 +1419,14 @@
             if not file_present:
                 return None, None
             entry = self._dirblocks[block_index][1][entry_index]
-            if not (entry[0][2] and entry[1][tree_index][0] not in ('a', 'r')):
-                raise AssertionError('unversioned entry?')
+            assert entry[0][2] and entry[1][tree_index][0] not in ('a', 'r'), 'unversioned entry?!?!'
             if fileid_utf8:
                 if entry[0][2] != fileid_utf8:
-                    self._changes_aborted = True
                     raise errors.BzrError('integrity error ? : mismatching'
                                           ' tree_index, file_id and path')
             return entry
         else:
+            assert fileid_utf8 is not None
             possible_keys = self._get_id_index().get(fileid_utf8, None)
             if not possible_keys:
                 return None, None
@@ -1798,12 +1451,11 @@
                     if entry[1][tree_index][0] == 'a':
                         # there is no home for this entry in this tree
                         return None, None
-                    if entry[1][tree_index][0] != 'r':
-                        raise AssertionError(
-                            "entry %r has invalid minikind %r for tree %r" \
-                            % (entry,
-                               entry[1][tree_index][0],
-                               tree_index))
+                    assert entry[1][tree_index][0] == 'r', \
+                        "entry %r has invalid minikind %r for tree %r" \
+                        % (entry,
+                           entry[1][tree_index][0],
+                           tree_index)
                     real_path = entry[1][tree_index][1]
                     return self._get_entry(tree_index, fileid_utf8=fileid_utf8,
                         path_utf8=real_path)
@@ -1841,8 +1493,7 @@
             raise
         return result
 
-    @staticmethod
-    def _inv_entry_to_details(inv_entry):
+    def _inv_entry_to_details(self, inv_entry):
         """Convert an inventory entry (from a revision tree) to state details.
 
         :param inv_entry: An inventory entry whose sha1 and link targets can be
@@ -1853,13 +1504,14 @@
         kind = inv_entry.kind
         minikind = DirState._kind_to_minikind[kind]
         tree_data = inv_entry.revision
+        assert tree_data, 'empty revision for the inv_entry %s.' % \
+            inv_entry.file_id
         if kind == 'directory':
             fingerprint = ''
             size = 0
             executable = False
         elif kind == 'symlink':
-            # We don't support non-ascii targets for symlinks yet.
-            fingerprint = str(inv_entry.symlink_target or '')
+            fingerprint = inv_entry.symlink_target or ''
             size = 0
             executable = False
         elif kind == 'file':
@@ -1874,47 +1526,6 @@
             raise Exception("can't pack %s" % inv_entry)
         return (minikind, fingerprint, size, executable, tree_data)
 
-    def _iter_child_entries(self, tree_index, path_utf8):
-        """Iterate over all the entries that are children of path_utf.
-
-        This only returns entries that are present (not in 'a', 'r') in 
-        tree_index. tree_index data is not refreshed, so if tree 0 is used,
-        results may differ from that obtained if paths were statted to
-        determine what ones were directories.
-
-        Asking for the children of a non-directory will return an empty
-        iterator.
-        """
-        pending_dirs = []
-        next_pending_dirs = [path_utf8]
-        absent = 'ar'
-        while next_pending_dirs:
-            pending_dirs = next_pending_dirs
-            next_pending_dirs = []
-            for path in pending_dirs:
-                block_index, present = self._find_block_index_from_key(
-                    (path, '', ''))
-                if block_index == 0:
-                    block_index = 1
-                    if len(self._dirblocks) == 1:
-                        # asked for the children of the root with no other
-                        # contents.
-                        return
-                if not present:
-                    # children of a non-directory asked for.
-                    continue
-                block = self._dirblocks[block_index]
-                for entry in block[1]:
-                    kind = entry[1][tree_index][0]
-                    if kind not in absent:
-                        yield entry
-                    if kind == 'd':
-                        if entry[0][0]:
-                            path = entry[0][0] + '/' + entry[0][1]
-                        else:
-                            path = entry[0][1]
-                        next_pending_dirs.append(path)
-    
     def _iter_entries(self):
         """Iterate over all the entries in the dirstate.
 
@@ -1992,10 +1603,13 @@
         parent_line = self._state_file.readline()
         info = parent_line.split('\0')
         num_parents = int(info[0])
+        assert num_parents == len(info)-2, 'incorrect parent info line'
         self._parents = info[1:-1]
+
         ghost_line = self._state_file.readline()
         info = ghost_line.split('\0')
         num_ghosts = int(info[1])
+        assert num_ghosts == len(info)-3, 'incorrect ghost info line'
         self._ghosts = info[2:-1]
         self._header_state = DirState.IN_MEMORY_UNMODIFIED
         self._end_of_header = self._state_file.tell()
@@ -2018,32 +1632,15 @@
         and their ids. Followed by a newline.
         """
         header = self._state_file.readline()
-        if header != DirState.HEADER_FORMAT_3:
-            raise errors.BzrError(
-                'invalid header line: %r' % (header,))
+        assert header == DirState.HEADER_FORMAT_3, \
+            'invalid header line: %r' % (header,)
         crc_line = self._state_file.readline()
-        if not crc_line.startswith('crc32: '):
-            raise errors.BzrError('missing crc32 checksum: %r' % crc_line)
+        assert crc_line.startswith('crc32: '), 'missing crc32 checksum'
         self.crc_expected = int(crc_line[len('crc32: '):-1])
         num_entries_line = self._state_file.readline()
-        if not num_entries_line.startswith('num_entries: '):
-            raise errors.BzrError('missing num_entries line')
+        assert num_entries_line.startswith('num_entries: '), 'missing num_entries line'
         self._num_entries = int(num_entries_line[len('num_entries: '):-1])
 
-    def sha1_from_stat(self, path, stat_result, _pack_stat=pack_stat):
-        """Find a sha1 given a stat lookup."""
-        return self._get_packed_stat_index().get(_pack_stat(stat_result), None)
-
-    def _get_packed_stat_index(self):
-        """Get a packed_stat index of self._dirblocks."""
-        if self._packed_stat_index is None:
-            index = {}
-            for key, tree_details in self._iter_entries():
-                if tree_details[0][0] == 'f':
-                    index[tree_details[0][4]] = tree_details[0][1]
-            self._packed_stat_index = index
-        return self._packed_stat_index
-
     def save(self):
         """Save any pending changes created during this session.
 
@@ -2058,12 +1655,6 @@
         start over, to allow for fine grained read lock duration, so 'status'
         wont block 'commit' - for example.
         """
-        if self._changes_aborted:
-            # Should this be a warning? For now, I'm expecting that places that
-            # mark it inconsistent will warn, making a warning here redundant.
-            trace.mutter('Not saving DirState because '
-                    '_changes_aborted is set.')
-            return
         if (self._header_state == DirState.IN_MEMORY_MODIFIED or
             self._dirblock_state == DirState.IN_MEMORY_MODIFIED):
 
@@ -2111,7 +1702,6 @@
         self._dirblock_state = DirState.IN_MEMORY_MODIFIED
         self._parents = list(parent_ids)
         self._id_index = None
-        self._packed_stat_index = None
 
     def set_path_id(self, path, new_id):
         """Change the id of path to new_id in the current working tree.
@@ -2121,6 +1711,8 @@
         :param new_id: The new id to assign to the path. This must be a utf8
             file id (not unicode, and not None).
         """
+        assert new_id.__class__ == str, \
+            "path_id %r is not a plain string" % (new_id,)
         self._read_dirblocks_if_needed()
         if len(path):
             # TODO: logic not written
@@ -2191,7 +1783,7 @@
         # one: the current tree
         for entry in self._iter_entries():
             # skip entries not in the current tree
-            if entry[1][0][0] in 'ar': # absent, relocated
+            if entry[1][0][0] in ('a', 'r'): # absent, relocated
                 continue
             by_path[entry[0]] = [entry[1][0]] + \
                 [DirState.NULL_PARENT_DETAILS] * parent_count
@@ -2327,7 +1919,7 @@
                 return None
         while current_new or current_old:
             # skip entries in old that are not really there
-            if current_old and current_old[1][0][0] in 'ar':
+            if current_old and current_old[1][0][0] in ('r', 'a'):
                 # relocated or absent
                 current_old = advance(old_iterator)
                 continue
@@ -2395,7 +1987,6 @@
                 current_old = advance(old_iterator)
         self._dirblock_state = DirState.IN_MEMORY_MODIFIED
         self._id_index = None
-        self._packed_stat_index = None
 
     def _make_absent(self, current_old):
         """Mark current_old - an entry - as absent for tree 0.
@@ -2409,7 +2000,7 @@
         all_remaining_keys = set()
         # Dont check the working tree, because it's going.
         for details in current_old[1][1:]:
-            if details[0] not in 'ar': # absent, relocated
+            if details[0] not in ('a', 'r'): # absent, relocated
                 all_remaining_keys.add(current_old[0])
             elif details[0] == 'r': # relocated
                 # record the key for the real path.
@@ -2422,29 +2013,25 @@
             # Remove it, its meaningless.
             block = self._find_block(current_old[0])
             entry_index, present = self._find_entry_index(current_old[0], block[1])
-            if not present:
-                raise AssertionError('could not find entry for %s' % (current_old,))
+            assert present, 'could not find entry for %s' % (current_old,)
             block[1].pop(entry_index)
             # if we have an id_index in use, remove this key from it for this id.
             if self._id_index is not None:
                 self._id_index[current_old[0][2]].remove(current_old[0])
         # update all remaining keys for this id to record it as absent. The
-        # existing details may either be the record we are marking as deleted
+        # existing details may either be the record we are making as deleted
         # (if there were other trees with the id present at this path), or may
         # be relocations.
         for update_key in all_remaining_keys:
             update_block_index, present = \
                 self._find_block_index_from_key(update_key)
-            if not present:
-                raise AssertionError('could not find block for %s' % (update_key,))
+            assert present, 'could not find block for %s' % (update_key,)
             update_entry_index, present = \
                 self._find_entry_index(update_key, self._dirblocks[update_block_index][1])
-            if not present:
-                raise AssertionError('could not find entry for %s' % (update_key,))
+            assert present, 'could not find entry for %s' % (update_key,)
             update_tree_details = self._dirblocks[update_block_index][1][update_entry_index][1]
             # it must not be absent at the moment
-            if update_tree_details[0][0] == 'a': # absent
-                raise AssertionError('bad row %r' % (update_tree_details,))
+            assert update_tree_details[0][0] != 'a' # absent
             update_tree_details[0] = DirState.NULL_PARENT_DETAILS
         self._dirblock_state = DirState.IN_MEMORY_MODIFIED
         return last_reference
@@ -2498,14 +2085,11 @@
                     # the test for existing kinds is different: this can be
                     # factored out to a helper though.
                     other_block_index, present = self._find_block_index_from_key(other_key)
-                    if not present:
-                        raise AssertionError('could not find block for %s' % (other_key,))
+                    assert present, 'could not find block for %s' % (other_key,)
                     other_entry_index, present = self._find_entry_index(other_key,
                                             self._dirblocks[other_block_index][1])
-                    if not present:
-                        raise AssertionError('could not find entry for %s' % (other_key,))
-                    if path_utf8 is None:
-                        raise AssertionError('no path')
+                    assert present, 'could not find entry for %s' % (other_key,)
+                    assert path_utf8 is not None
                     self._dirblocks[other_block_index][1][other_entry_index][1][0] = \
                         ('r', path_utf8, 0, False, '')
 
@@ -2517,14 +2101,12 @@
                     # records.
                     update_block_index, present = \
                         self._find_block_index_from_key(other_key)
-                    if not present:
-                        raise AssertionError('could not find block for %s' % (other_key,))
+                    assert present, 'could not find block for %s' % (other_key,)
                     update_entry_index, present = \
                         self._find_entry_index(other_key, self._dirblocks[update_block_index][1])
-                    if not present:
-                        raise AssertionError('could not find entry for %s' % (other_key,))
+                    assert present, 'could not find entry for %s' % (other_key,)
                     update_details = self._dirblocks[update_block_index][1][update_entry_index][1][lookup_index]
-                    if update_details[0] in 'ar': # relocated, absent
+                    if update_details[0] in ('r', 'a'): # relocated, absent
                         # its a pointer or absent in lookup_index's tree, use
                         # it as is.
                         new_entry[1].append(update_details)
@@ -2546,8 +2128,7 @@
             # we may have passed entries in the state with this file id already
             # that were absent - where parent entries are - and they need to be
             # converted to relocated.
-            if path_utf8 is None:
-                raise AssertionError('no path')
+            assert path_utf8 is not None
             for entry_key in id_index.setdefault(key[2], set()):
                 # TODO:PROFILING: It might be faster to just update
                 # rather than checking if we need to, and then overwrite
@@ -2558,11 +2139,9 @@
                     # This is the vertical axis in the matrix, all pointing
                     # to the real path.
                     block_index, present = self._find_block_index_from_key(entry_key)
-                    if not present:
-                        raise AssertionError('not present: %r', entry_key)
+                    assert present
                     entry_index, present = self._find_entry_index(entry_key, self._dirblocks[block_index][1])
-                    if not present:
-                        raise AssertionError('not present: %r', entry_key)
+                    assert present
                     self._dirblocks[block_index][1][entry_index][1][0] = \
                         ('r', path_utf8, 0, False, '')
         # add a containing dirblock if needed.
@@ -2599,12 +2178,12 @@
             if not self._dirblocks[0][0] == '':
                 raise AssertionError(
                     "dirblocks don't start with root block:\n" + \
-                    pformat(self._dirblocks))
+                    pformat(dirblocks))
         if len(self._dirblocks) > 1:
             if not self._dirblocks[1][0] == '':
                 raise AssertionError(
                     "dirblocks missing root directory:\n" + \
-                    pformat(self._dirblocks))
+                    pformat(dirblocks))
         # the dirblocks are sorted by their path components, name, and dir id
         dir_names = [d[0].split('/')
                 for d in self._dirblocks[1:]]
@@ -2628,6 +2207,7 @@
                     "dirblock for %r is not sorted:\n%s" % \
                     (dirblock[0], pformat(dirblock)))
 
+
         def check_valid_parent():
             """Check that the current entry has a valid parent.
 
@@ -2668,15 +2248,12 @@
                 "wrong number of entry details for row\n%s" \
                 ",\nexpected %d" % \
                 (pformat(entry), tree_count))
-            absent_positions = 0
             for tree_index, tree_state in enumerate(entry[1]):
                 this_tree_map = id_path_maps[tree_index]
                 minikind = tree_state[0]
-                if minikind in 'ar':
-                    absent_positions += 1
                 # have we seen this id before in this column?
                 if file_id in this_tree_map:
-                    previous_path, previous_loc = this_tree_map[file_id]
+                    previous_path = this_tree_map[file_id]
                     # any later mention of this file must be consistent with
                     # what was said before
                     if minikind == 'a':
@@ -2696,34 +2273,28 @@
                         # pointed to by a relocation, which must point here
                         if previous_path != this_path:
                             raise AssertionError(
-                                "entry %r inconsistent with previous path %r "
-                                "seen at %r" %
-                                (entry, previous_path, previous_loc))
+                            "entry %r inconsistent with previous path %r" % \
+                            (entry, previous_path))
                         check_valid_parent()
                 else:
                     if minikind == 'a':
                         # absent; should not occur anywhere else
-                        this_tree_map[file_id] = None, this_path
+                        this_tree_map[file_id] = None
                     elif minikind == 'r':
                         # relocation, must occur at expected location 
-                        this_tree_map[file_id] = tree_state[1], this_path
+                        this_tree_map[file_id] = tree_state[1]
                     else:
-                        this_tree_map[file_id] = this_path, this_path
+                        this_tree_map[file_id] = this_path
                         check_valid_parent()
-            if absent_positions == tree_count:
-                raise AssertionError(
-                    "entry %r has no data for any tree." % (entry,))
 
     def _wipe_state(self):
         """Forget all state information about the dirstate."""
         self._header_state = DirState.NOT_IN_MEMORY
         self._dirblock_state = DirState.NOT_IN_MEMORY
-        self._changes_aborted = False
         self._parents = []
         self._ghosts = []
         self._dirblocks = []
         self._id_index = None
-        self._packed_stat_index = None
         self._end_of_header = None
         self._cutoff_time = None
         self._split_path_cache = {}

=== modified file 'bzrlib/doc/__init__.py'
--- bzrlib/doc/__init__.py	2008-04-28 08:57:45 +0000
+++ bzrlib/doc/__init__.py	2006-10-05 05:37:25 +0000
@@ -20,17 +20,7 @@
 for man page generation.
 """
 
-
-def load_tests(basic_tests, module, loader):
-    suite = loader.suiteClass()
-    # add the tests for this module (obviously none so far)
-    suite.addTests(basic_tests)
-
-    testmod_names = [
-        'bzrlib.doc.api',
-        ]
-
-    # add the tests for the sub modules
-    suite.addTests(loader.loadTestsFromModuleNames(testmod_names))
-
-    return suite
+    
+def test_suite():
+    import bzrlib.doc.api
+    return bzrlib.doc.api.test_suite()

=== modified file 'bzrlib/doc/api/__init__.py'
--- bzrlib/doc/api/__init__.py	2008-04-28 08:57:45 +0000
+++ bzrlib/doc/api/__init__.py	2006-10-05 05:37:25 +0000
@@ -26,12 +26,8 @@
 
 import doctest
 import os
-
-from bzrlib import tests
-
-def load_tests(basic_tests, module, loader):
-    """This module creates its own test suite with DocFileSuite."""
-
+    
+def test_suite():
     dir_ = os.path.dirname(__file__)
     if os.path.isdir(dir_):
         candidates = os.listdir(dir_)
@@ -39,13 +35,4 @@
         candidates = []
     scripts = [candidate for candidate in candidates
                if candidate.endswith('.txt')]
-    # since this module doesn't define tests, we ignore basic_tests
-    suite = doctest.DocFileSuite(*scripts)
-    # DocFileCase reduces the test id to the base name of the tested file, we
-    # want the module to appears there.
-    for t in tests.iter_suite_tests(suite):
-        def make_new_test_id():
-            new_id = '%s.DocFileTest(%s)' % ( __name__, t)
-            return lambda: new_id
-        t.id = make_new_test_id()
-    return suite
+    return doctest.DocFileSuite(*scripts)

=== modified file 'bzrlib/errors.py'
--- bzrlib/errors.py	2008-09-02 18:51:03 +0000
+++ bzrlib/errors.py	2007-10-12 05:26:46 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2008 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -93,11 +93,11 @@
             for key, value in kwds.items():
                 setattr(self, key, value)
 
-    def _format(self):
+    def __str__(self):
         s = getattr(self, '_preformatted_string', None)
         if s is not None:
-            # contains a preformatted message
-            return s
+            # contains a preformatted message; must be cast to plain str
+            return str(s)
         try:
             fmt = self._get_format_string()
             if fmt:
@@ -108,6 +108,8 @@
                 s = fmt % d
                 # __str__() should always return a 'str' object
                 # never a 'unicode' object.
+                if isinstance(s, unicode):
+                    return s.encode('utf8')
                 return s
         except (AttributeError, TypeError, NameError, ValueError, KeyError), e:
             return 'Unprintable exception %s: dict=%r, fmt=%r, error=%r' \
@@ -116,26 +118,6 @@
                    getattr(self, '_fmt', None),
                    e)
 
-    def __unicode__(self):
-        u = self._format()
-        if isinstance(u, str):
-            # Try decoding the str using the default encoding.
-            u = unicode(u)
-        elif not isinstance(u, unicode):
-            # Try to make a unicode object from it, because __unicode__ must
-            # return a unicode object.
-            u = unicode(u)
-        return u
-    
-    def __str__(self):
-        s = self._format()
-        if isinstance(s, unicode):
-            s = s.encode('utf8')
-        else:
-            # __str__ must return a str.
-            s = str(s)
-        return s
-
     def _get_format_string(self):
         """Return format string for this exception or None"""
         fmt = getattr(self, '_fmt', None)
@@ -153,11 +135,6 @@
                getattr(self, '_fmt', None),
                )
 
-    def __eq__(self, other):
-        if self.__class__ != other.__class__:
-            return NotImplemented
-        return self.__dict__ == other.__dict__
-
 
 class InternalBzrError(BzrError):
     """Base class for errors that are internal in nature.
@@ -208,13 +185,6 @@
     _fmt = "The tree builder is already building a tree."
 
 
-class BranchError(BzrError):
-    """Base class for concrete 'errors about a branch'."""
-
-    def __init__(self, branch):
-        BzrError.__init__(self, branch=branch)
-
-
 class BzrCheckError(InternalBzrError):
     
     _fmt = "Internal check failed: %(message)s"
@@ -224,16 +194,6 @@
         self.message = message
 
 
-class DirstateCorrupt(BzrError):
-
-    _fmt = "The dirstate file (%(state)s) appears to be corrupt: %(msg)s"
-
-    def __init__(self, state, msg):
-        BzrError.__init__(self)
-        self.state = state
-        self.msg = msg
-
-
 class DisabledMethod(InternalBzrError):
 
     _fmt = "The smart server method '%(class_name)s' is disabled."
@@ -292,7 +252,6 @@
         self.revision_id = revision_id
         self.branch = branch
 
-
 class ReservedId(BzrError):
 
     _fmt = "Reserved revision-id {%(revision_id)s}"
@@ -307,16 +266,6 @@
         "record_entry_contents.")
 
 
-class NoPublicBranch(BzrError):
-
-    _fmt = 'There is no public branch set for "%(branch_url)s".'
-
-    def __init__(self, branch):
-        import bzrlib.urlutils as urlutils
-        public_location = urlutils.unescape_for_display(branch.base, 'ascii')
-        BzrError.__init__(self, branch_url=public_location)
-
-
 class NoHelpTopic(BzrError):
 
     _fmt = ("No help could be found for '%(topic)s'. "
@@ -345,11 +294,6 @@
         BzrError.__init__(self, repository=repository, file_id=file_id)
 
 
-class NotStacked(BranchError):
-
-    _fmt = "The branch '%(branch)s' is not stacked."
-
-
 class InventoryModified(InternalBzrError):
 
     _fmt = ("The current inventory for the tree %(tree)r has been modified,"
@@ -399,6 +343,16 @@
     # are not intended to be caught anyway.  UI code need not subclass
     # BzrCommandError, and non-UI code should not throw a subclass of
     # BzrCommandError.  ADHB 20051211
+    def __init__(self, msg):
+        # Object.__str__() must return a real string
+        # returning a Unicode string is a python error.
+        if isinstance(msg, unicode):
+            self.msg = msg.encode('utf8')
+        else:
+            self.msg = msg
+
+    def __str__(self):
+        return self.msg
 
 
 class NotWriteLocked(BzrError):
@@ -516,8 +470,7 @@
     """Used when renaming and both source and dest exist."""
 
     _fmt = ("Could not rename %(source)s => %(dest)s because both files exist."
-            " (Use --after to tell bzr about a rename that has already"
-            " happened)%(extra)s")
+            "%(extra)s")
 
     def __init__(self, source, dest, extra=None):
         BzrError.__init__(self)
@@ -544,11 +497,6 @@
     _fmt = 'Directory not empty: "%(path)s"%(extra)s'
 
 
-class HardLinkNotSupported(PathError):
-
-    _fmt = 'Hard-linking "%(path)s" is not supported'
-
-
 class ReadingCompleted(InternalBzrError):
     
     _fmt = ("The MediumRequest '%(request)s' has already had finish_reading "
@@ -576,35 +524,11 @@
 
 class InvalidURLJoin(PathError):
 
-    _fmt = "Invalid URL join request: %(reason)s: %(base)r + %(join_args)r"
-
-    def __init__(self, reason, base, join_args):
-        self.reason = reason
-        self.base = base
-        self.join_args = join_args
-        PathError.__init__(self, base, reason)
-
-
-class InvalidRebaseURLs(PathError):
-
-    _fmt = "URLs differ by more than path: %(from_)r and %(to)r"
-
-    def __init__(self, from_, to):
-        self.from_ = from_
-        self.to = to
-        PathError.__init__(self, from_, 'URLs differ by more than path.')
-
-
-class UnavailableRepresentation(InternalBzrError):
-
-    _fmt = ("The encoding '%(wanted)s' is not available for key %(key)s which "
-        "is encoded as '%(native)s'.")
-
-    def __init__(self, key, wanted, native):
-        InternalBzrError.__init__(self)
-        self.wanted = wanted
-        self.native = native
-        self.key = key
+    _fmt = 'Invalid URL join request: "%(args)s"%(extra)s'
+
+    def __init__(self, msg, base, args):
+        PathError.__init__(self, base, msg)
+        self.args = [base] + list(args)
 
 
 class UnknownHook(BzrError):
@@ -625,28 +549,6 @@
         PathError.__init__(self, url, extra=extra)
 
 
-class UnstackableBranchFormat(BzrError):
-
-    _fmt = ("The branch '%(url)s'(%(format)s) is not a stackable format. "
-        "You will need to upgrade the branch to permit branch stacking.")
-
-    def __init__(self, format, url):
-        BzrError.__init__(self)
-        self.format = format
-        self.url = url
-
-
-class UnstackableRepositoryFormat(BzrError):
-
-    _fmt = ("The repository '%(url)s'(%(format)s) is not a stackable format. "
-        "You will need to upgrade the repository to permit branch stacking.")
-
-    def __init__(self, format, url):
-        BzrError.__init__(self)
-        self.format = format
-        self.url = url
-
-
 class ReadError(PathError):
     
     _fmt = """Error reading from %(path)r."""
@@ -749,7 +651,7 @@
 
 class FileInWrongBranch(BzrError):
 
-    _fmt = 'File "%(path)s" is not in branch %(branch_base)s.'
+    _fmt = 'File "%(path)s" in not in branch %(branch_base)s.'
 
     def __init__(self, branch, path):
         BzrError.__init__(self)
@@ -765,11 +667,7 @@
 
 class UnknownFormatError(BzrError):
     
-    _fmt = "Unknown %(kind)s format: %(format)r"
-
-    def __init__(self, format, kind='branch'):
-        self.kind = kind
-        self.format = format
+    _fmt = "Unknown branch format: %(format)r"
 
 
 class IncompatibleFormat(BzrError):
@@ -784,15 +682,11 @@
 
 class IncompatibleRepositories(BzrError):
 
-    _fmt = "%(target)s\n" \
-            "is not compatible with\n" \
-            "%(source)s\n" \
-            "%(details)s"
+    _fmt = "Repository %(target)s is not compatible with repository"\
+        " %(source)s"
 
-    def __init__(self, source, target, details=None):
-        if details is None:
-            details = "(no details)"
-        BzrError.__init__(self, target=target, source=source, details=details)
+    def __init__(self, source, target):
+        BzrError.__init__(self, target=target, source=source)
 
 
 class IncompatibleRevision(BzrError):
@@ -885,17 +779,6 @@
         BzrError.__init__(self, filename=filename, kind=kind)
 
 
-class BadFilenameEncoding(BzrError):
-
-    _fmt = ('Filename %(filename)r is not valid in your current filesystem'
-            ' encoding %(fs_encoding)s')
-
-    def __init__(self, filename, fs_encoding):
-        BzrError.__init__(self)
-        self.filename = filename
-        self.fs_encoding = fs_encoding
-
-
 class ForbiddenControlFileError(BzrError):
 
     _fmt = 'Cannot operate on "%(filename)s" because it is a control file'
@@ -954,6 +837,17 @@
         self.obj = obj
 
 
+class ReadOnlyLockError(LockError):
+
+    _fmt = "Cannot acquire write lock on %(fname)s. %(msg)s"
+
+    @symbol_versioning.deprecated_method(symbol_versioning.zero_ninetytwo)
+    def __init__(self, fname, msg):
+        LockError.__init__(self, '')
+        self.fname = fname
+        self.msg = msg
+
+
 class LockFailed(LockError):
 
     internal_error = False
@@ -1115,6 +1009,18 @@
         BzrError.__init__(self, branch=branch, revision=revision)
 
 
+# zero_ninetyone: this exception is no longer raised and should be removed
+class NotLeftParentDescendant(InternalBzrError):
+
+    _fmt = ("Revision %(old_revision)s is not the left parent of"
+            " %(new_revision)s, but branch %(branch_location)s expects this")
+
+    def __init__(self, branch, old_revision, new_revision):
+        BzrError.__init__(self, branch_location=branch.base,
+                          old_revision=old_revision,
+                          new_revision=new_revision)
+
+
 class RangeInChangeOption(BzrError):
 
     _fmt = "Option --change does not accept revision ranges"
@@ -1193,12 +1099,6 @@
             " no merge base revision was specified.")
 
 
-class CannotReverseCherrypick(BzrError):
-
-    _fmt = ('Selected merge cannot perform reverse cherrypicks.  Try merge3'
-            ' or diff3.')
-
-
 class NoCommonAncestor(BzrError):
     
     _fmt = "Revisions have no common ancestor: %(revision_a)s %(revision_b)s"
@@ -1246,10 +1146,13 @@
         self.bases = bases
 
 
-class NoCommits(BranchError):
+class NoCommits(BzrError):
 
     _fmt = "Branch %(branch)s has no commits."
 
+    def __init__(self, branch):
+        BzrError.__init__(self, branch=branch)
+
 
 class UnlistableStore(BzrError):
 
@@ -1349,7 +1252,7 @@
 
 class WeaveParentMismatch(WeaveError):
 
-    _fmt = "Parents are mismatched between two revisions. %(message)s"
+    _fmt = "Parents are mismatched between two revisions."
     
 
 class WeaveInvalidChecksum(WeaveError):
@@ -1427,8 +1330,6 @@
 
 
 class KnitDataStreamIncompatible(KnitError):
-    # Not raised anymore, as we can convert data streams.  In future we may
-    # need it again for more exotic cases, so we're keeping it around for now.
 
     _fmt = "Cannot insert knit data stream of format \"%(stream_format)s\" into knit of format \"%(target_format)s\"."
 
@@ -1437,15 +1338,6 @@
         self.target_format = target_format
         
 
-class KnitDataStreamUnknown(KnitError):
-    # Indicates a data stream we don't know how to handle.
-
-    _fmt = "Cannot parse knit data stream of format \"%(stream_format)s\"."
-
-    def __init__(self, stream_format):
-        self.stream_format = stream_format
-        
-
 class KnitHeaderError(KnitError):
 
     _fmt = 'Knit header error: %(badline)r unexpected for file "%(filename)s".'
@@ -1513,30 +1405,6 @@
         self.details = details
 
 
-class UnexpectedProtocolVersionMarker(TransportError):
-
-    _fmt = "Received bad protocol version marker: %(marker)r"
-
-    def __init__(self, marker):
-        self.marker = marker
-
-
-class UnknownSmartMethod(InternalBzrError):
-
-    _fmt = "The server does not recognise the '%(verb)s' request."
-
-    def __init__(self, verb):
-        self.verb = verb
-
-
-class SmartMessageHandlerError(InternalBzrError):
-
-    _fmt = "The message handler raised an exception: %(exc_value)s."
-
-    def __init__(self, exc_info):
-        self.exc_type, self.exc_value, self.tb = exc_info
-        
-
 # A set of semi-meaningful errors which can be thrown
 class TransportNotPossible(TransportError):
 
@@ -1574,10 +1442,11 @@
 
 class InvalidRange(TransportError):
 
-    _fmt = "Invalid range access in %(path)s at %(offset)s: %(msg)s"
-
-    def __init__(self, path, offset, msg=None):
-        TransportError.__init__(self, msg)
+    _fmt = "Invalid range access in %(path)s at %(offset)s."
+    
+    def __init__(self, path, offset):
+        TransportError.__init__(self, ("Invalid range access in %s at %d"
+                                       % (path, offset)))
         self.path = path
         self.offset = offset
 
@@ -1594,7 +1463,7 @@
 class InvalidHttpRange(InvalidHttpResponse):
 
     _fmt = "Invalid http range %(range)r for %(path)s: %(msg)s"
-
+    
     def __init__(self, path, range, msg):
         self.range = range
         InvalidHttpResponse.__init__(self, path, msg)
@@ -1603,7 +1472,7 @@
 class InvalidHttpContentType(InvalidHttpResponse):
 
     _fmt = 'Invalid http Content-type "%(ctype)s" for %(path)s: %(msg)s'
-
+    
     def __init__(self, path, ctype, msg):
         self.ctype = ctype
         InvalidHttpResponse.__init__(self, path, msg)
@@ -1613,13 +1482,14 @@
 
     _fmt = '%(source)s is%(permanently)s redirected to %(target)s'
 
-    def __init__(self, source, target, is_permanent=False, qual_proto=None):
+    def __init__(self, source, target, is_permament=False, qual_proto=None):
         self.source = source
         self.target = target
-        if is_permanent:
+        if is_permament:
             self.permanently = ' permanently'
         else:
             self.permanently = ''
+        self.is_permament = is_permament
         self._qualified_proto = qual_proto
         TransportError.__init__(self)
 
@@ -1661,7 +1531,6 @@
 
     _fmt = "Too many redirections"
 
-
 class ConflictsInTree(BzrError):
 
     _fmt = "Working tree has conflicts."
@@ -1975,22 +1844,6 @@
         self.format = format
 
 
-class NoDiffFound(BzrError):
-
-    _fmt = 'Could not find an appropriate Differ for file "%(path)s"'
-
-    def __init__(self, path):
-        BzrError.__init__(self, path)
-
-
-class ExecutableMissing(BzrError):
-
-    _fmt = "%(exe_name)s could not be found on this machine"
-
-    def __init__(self, exe_name):
-        BzrError.__init__(self, exe_name=exe_name)
-
-
 class NoDiff(BzrError):
 
     _fmt = "Diff is not installed on this machine: %(msg)s"
@@ -2044,9 +1897,9 @@
 
 class ImmortalPendingDeletion(BzrError):
 
-    _fmt = ("Unable to delete transform temporary directory "
-    "%(pending_deletion)s.  Please examine %(pending_deletion)s to see if it "
-    "contains any files you wish to keep, and delete it when you are done.")
+    _fmt = """Unable to delete transform temporary directory
+    %(pending_deletion)s.  Please examine %(pending_deletions)s to see if it
+    contains any files you wish to keep, and delete it when you are done."""
 
     def __init__(self, pending_deletion):
        BzrError.__init__(self, pending_deletion=pending_deletion)
@@ -2084,17 +1937,6 @@
     _fmt = "Format error in conflict listings"
 
 
-class CorruptDirstate(BzrError):
-
-    _fmt = ("Inconsistency in dirstate file %(dirstate_path)s.\n"
-            "Error: %(description)s")
-
-    def __init__(self, dirstate_path, description):
-        BzrError.__init__(self)
-        self.dirstate_path = dirstate_path
-        self.description = description
-
-
 class CorruptRepository(BzrError):
 
     _fmt = ("An error has been detected in the repository %(repo_path)s.\n"
@@ -2105,19 +1947,6 @@
         self.repo_path = repo.bzrdir.root_transport.base
 
 
-class InconsistentDelta(BzrError):
-    """Used when we get a delta that is not valid."""
-
-    _fmt = ("An inconsistent delta was supplied involving %(path)r,"
-            " %(file_id)r\nreason: %(reason)s")
-
-    def __init__(self, path, file_id, reason):
-        BzrError.__init__(self)
-        self.path = path
-        self.file_id = file_id
-        self.reason = reason
-
-
 class UpgradeRequired(BzrError):
 
     _fmt = "To use this feature you must upgrade your branch at %(path)s."
@@ -2127,11 +1956,6 @@
         self.path = path
 
 
-class RepositoryUpgradeRequired(UpgradeRequired):
-
-    _fmt = "To use this feature you must upgrade your repository at %(path)s."
-
-
 class LocalRequiresBoundBranch(BzrError):
 
     _fmt = "Cannot perform local-only commits on unbound branches."
@@ -2281,7 +2105,6 @@
 
     _fmt = "No smart server available at %(url)s"
 
-    @symbol_versioning.deprecated_method(symbol_versioning.one_four)
     def __init__(self, url):
         self.url = url
 
@@ -2301,17 +2124,6 @@
             " Please set BZR_SSH environment variable.")
 
 
-class GhostRevisionsHaveNoRevno(BzrError):
-    """When searching for revnos, if we encounter a ghost, we are stuck"""
-
-    _fmt = ("Could not determine revno for {%(revision_id)s} because"
-            " its ancestry shows a ghost at {%(ghost_revision_id)s}")
-
-    def __init__(self, revision_id, ghost_revision_id):
-        self.revision_id = revision_id
-        self.ghost_revision_id = ghost_revision_id
-
-        
 class GhostRevisionUnusableHere(BzrError):
 
     _fmt = "Ghost revision {%(revision_id)s} cannot be used here."
@@ -2395,19 +2207,6 @@
         self.patch_type = patch_type
 
 
-class TargetNotBranch(BzrError):
-    """A merge directive's target branch is required, but isn't a branch"""
-
-    _fmt = ("Your branch does not have all of the revisions required in "
-            "order to merge this merge directive and the target "
-            "location specified in the merge directive is not a branch: "
-            "%(location)s.")
-
-    def __init__(self, location):
-        BzrError.__init__(self)
-        self.location = location
-
-
 class UnsupportedInventoryKind(BzrError):
     
     _fmt = """Unsupported entry kind %(kind)s"""
@@ -2456,7 +2255,7 @@
 class TagsNotSupported(BzrError):
 
     _fmt = ("Tags not supported by %(branch)s;"
-            " you may be able to use bzr upgrade.")
+            " you may be able to use bzr upgrade --dirstate-tags.")
 
     def __init__(self, branch):
         self.branch = branch
@@ -2479,16 +2278,6 @@
         self.reason = reason
 
 
-class InvalidBugTrackerURL(BzrError):
-
-    _fmt = ("The URL for bug tracker \"%(abbreviation)s\" doesn't "
-            "contain {id}: %(url)s")
-
-    def __init__(self, abbreviation, url):
-        self.abbreviation = abbreviation
-        self.url = url
-
-
 class UnknownBugTrackerAbbreviation(BzrError):
 
     _fmt = ("Cannot find registered bug tracker called %(abbreviation)s "
@@ -2507,21 +2296,6 @@
         self.response_tuple = response_tuple
 
 
-class ErrorFromSmartServer(BzrError):
-
-    _fmt = "Error received from smart server: %(error_tuple)r"
-
-    internal_error = True
-
-    def __init__(self, error_tuple):
-        self.error_tuple = error_tuple
-        try:
-            self.error_verb = error_tuple[0]
-        except IndexError:
-            self.error_verb = None
-        self.error_args = error_tuple[1:]
-
-
 class ContainerError(BzrError):
     """Base class of container errors."""
 
@@ -2597,11 +2371,6 @@
     _fmt = "No message supplied."
 
 
-class NoMailAddressSpecified(BzrError):
-
-    _fmt = "No mail-to address specified."
-
-
 class UnknownMailClient(BzrError):
 
     _fmt = "Unknown mail client: %(mail_client)s"
@@ -2643,18 +2412,6 @@
         BzrError.__init__(self, bzrdir=bzrdir, display_url=display_url)
 
 
-class UnsyncedBranches(BzrDirError):
-
-    _fmt = ("'%(display_url)s' is not in sync with %(target_url)s.  See"
-            " bzr help sync-for-reconfigure.")
-
-    def __init__(self, bzrdir, target_branch):
-        BzrDirError.__init__(self, bzrdir)
-        import bzrlib.urlutils as urlutils
-        self.target_url = urlutils.unescape_for_display(target_branch.base,
-                                                        'ascii')
-
-
 class AlreadyBranch(BzrDirError):
 
     _fmt = "'%(display_url)s' is already a branch."
@@ -2670,21 +2427,6 @@
     _fmt = "'%(display_url)s' is already a checkout."
 
 
-class AlreadyLightweightCheckout(BzrDirError):
-
-    _fmt = "'%(display_url)s' is already a lightweight checkout."
-
-
-class AlreadyUsingShared(BzrDirError):
-
-    _fmt = "'%(display_url)s' is already using a shared repository."
-
-
-class AlreadyStandalone(BzrDirError):
-
-    _fmt = "'%(display_url)s' is already standalone."
-
-
 class ReconfigurationNotSupported(BzrDirError):
 
     _fmt = "Requested reconfiguration of '%(display_url)s' is not supported."
@@ -2704,159 +2446,3 @@
         display_url = urlutils.unescape_for_display(
             tree.bzrdir.root_transport.base, 'ascii')
         BzrError.__init__(self, tree=tree, display_url=display_url)
-
-
-class MissingTemplateVariable(BzrError):
-
-    _fmt = 'Variable {%(name)s} is not available.'
-
-    def __init__(self, name):
-        self.name = name
-
-
-class NoTemplate(BzrError):
-
-    _fmt = 'No template specified.'
-
-
-class UnableCreateSymlink(BzrError):
-
-    _fmt = 'Unable to create symlink %(path_str)son this platform'
-
-    def __init__(self, path=None):
-        path_str = ''
-        if path:
-            try:
-                path_str = repr(str(path))
-            except UnicodeEncodeError:
-                path_str = repr(path)
-            path_str += ' '
-        self.path_str = path_str
-
-
-class UnsupportedTimezoneFormat(BzrError):
-
-    _fmt = ('Unsupported timezone format "%(timezone)s", '
-            'options are "utc", "original", "local".')
-
-    def __init__(self, timezone):
-        self.timezone = timezone
-
-
-class CommandAvailableInPlugin(StandardError):
-    
-    internal_error = False
-
-    def __init__(self, cmd_name, plugin_metadata, provider):
-        
-        self.plugin_metadata = plugin_metadata
-        self.cmd_name = cmd_name
-        self.provider = provider
-
-    def __str__(self):
-
-        _fmt = ('"%s" is not a standard bzr command. \n' 
-                'However, the following official plugin provides this command: %s\n'
-                'You can install it by going to: %s'
-                % (self.cmd_name, self.plugin_metadata['name'], 
-                    self.plugin_metadata['url']))
-
-        return _fmt
-
-
-class NoPluginAvailable(BzrError):
-    pass    
-
-
-class NotATerminal(BzrError):
-
-    _fmt = 'Unable to ask for a password without real terminal.'
-
-
-class UnableEncodePath(BzrError):
-
-    _fmt = ('Unable to encode %(kind)s path %(path)r in '
-            'user encoding %(user_encoding)s')
-
-    def __init__(self, path, kind):
-        self.path = path
-        self.kind = kind
-        self.user_encoding = osutils.get_user_encoding()
-
-
-class NoSuchAlias(BzrError):
-
-    _fmt = ('The alias "%(alias_name)s" does not exist.')
-
-    def __init__(self, alias_name):
-        BzrError.__init__(self, alias_name=alias_name)
-
-
-class DirectoryLookupFailure(BzrError):
-    """Base type for lookup errors."""
-
-    pass
-
-
-class InvalidLocationAlias(DirectoryLookupFailure):
-
-    _fmt = '"%(alias_name)s" is not a valid location alias.'
-
-    def __init__(self, alias_name):
-        DirectoryLookupFailure.__init__(self, alias_name=alias_name)
-
-
-class UnsetLocationAlias(DirectoryLookupFailure):
-
-    _fmt = 'No %(alias_name)s location assigned.'
-
-    def __init__(self, alias_name):
-        DirectoryLookupFailure.__init__(self, alias_name=alias_name[1:])
-
-
-class CannotBindAddress(BzrError):
-
-    _fmt = 'Cannot bind address "%(host)s:%(port)i": %(orig_error)s.'
-
-    def __init__(self, host, port, orig_error):
-        BzrError.__init__(self, host=host, port=port,
-            orig_error=orig_error[1])
-
-
-class UnknownRules(BzrError):
-
-    _fmt = ('Unknown rules detected: %(unknowns_str)s.')
-
-    def __init__(self, unknowns):
-        BzrError.__init__(self, unknowns_str=", ".join(unknowns))
-
-
-class HookFailed(BzrError):
-    """Raised when a pre_change_branch_tip hook function fails anything other
-    than TipChangeRejected.
-    """
-
-    _fmt = ("Hook '%(hook_name)s' during %(hook_stage)s failed:\n"
-            "%(traceback_text)s%(exc_value)s")
-
-    def __init__(self, hook_stage, hook_name, exc_info):
-        import traceback
-        self.hook_stage = hook_stage
-        self.hook_name = hook_name
-        self.exc_info = exc_info
-        self.exc_type = exc_info[0]
-        self.exc_value = exc_info[1]
-        self.exc_tb = exc_info[2]
-        self.traceback_text = ''.join(traceback.format_tb(self.exc_tb))
-
-
-class TipChangeRejected(BzrError):
-    """A pre_change_branch_tip hook function may raise this to cleanly and
-    explicitly abort a change to a branch tip.
-    """
-    
-    _fmt = u"Tip change rejected: %(msg)s"
-
-    def __init__(self, msg):
-        self.msg = msg
-

=== modified file 'bzrlib/export/__init__.py'
--- bzrlib/export/__init__.py	2008-08-08 06:59:48 +0000
+++ bzrlib/export/__init__.py	2006-09-20 23:43:18 +0000
@@ -55,14 +55,14 @@
 
     When requesting a specific type of export, load the respective path.
     """
-    def _loader(tree, dest, root, subdir):
+    def _loader(tree, dest, root):
         mod = __import__(module, globals(), locals(), [funcname])
         func = getattr(mod, funcname)
-        return func(tree, dest, root, subdir)
+        return func(tree, dest, root)
     register_exporter(scheme, extensions, _loader)
 
 
-def export(tree, dest, format=None, root=None, subdir=None):
+def export(tree, dest, format=None, root=None):
     """Export the given Tree to the specific destination.
 
     :param tree: A Tree (such as RevisionTree) to export
@@ -76,9 +76,6 @@
                  If root is None, the default root will be
                  selected as the destination without its
                  extension.
-    :param subdir: A starting directory within the tree. None means to export
-        the entire tree, and anything else should specify the relative path to
-        a directory to start exporting from.
     """
     global _exporters, _exporter_extensions
 
@@ -95,11 +92,7 @@
 
     if format not in _exporters:
         raise errors.NoSuchExportFormat(format)
-    tree.lock_read()
-    try:
-        return _exporters[format](tree, dest, root, subdir)
-    finally:
-        tree.unlock()
+    return _exporters[format](tree, dest, root)
 
 
 def get_root_name(dest):
@@ -132,28 +125,6 @@
     return dest
 
 
-def _export_iter_entries(tree, subdir):
-    """Iter the entries for tree suitable for exporting.
-
-    :param tree: A tree object.
-    :param subdir: None or the path of a directory to start exporting from.
-    """
-    inv = tree.inventory
-    if subdir is None:
-        subdir_id = None
-    else:
-        subdir_id = inv.path2id(subdir)
-    entries = inv.iter_entries(subdir_id)
-    if subdir is None:
-        entries.next() # skip root
-    for entry in entries:
-        # The .bzr* namespace is reserved for "magic" files like
-        # .bzrignore and .bzrrules - do not export these
-        if entry[0].startswith(".bzr"):
-            continue
-        yield entry
-
-
 register_lazy_exporter(None, [], 'bzrlib.export.dir_exporter', 'dir_exporter')
 register_lazy_exporter('dir', [], 'bzrlib.export.dir_exporter', 'dir_exporter')
 register_lazy_exporter('tar', ['.tar'], 'bzrlib.export.tar_exporter', 'tar_exporter')

=== modified file 'bzrlib/export/dir_exporter.py'
--- bzrlib/export/dir_exporter.py	2008-08-08 06:59:48 +0000
+++ bzrlib/export/dir_exporter.py	2006-07-29 16:04:16 +0000
@@ -17,15 +17,10 @@
 """Export a Tree to a non-versioned directory.
 """
 
-
 import os
-
-from bzrlib import errors, osutils
-from bzrlib.export import _export_iter_entries
 from bzrlib.trace import mutter
 
-
-def dir_exporter(tree, dest, root, subdir):
+def dir_exporter(tree, dest, root):
     """Export this tree to a new directory.
 
     `dest` should not exist, and will be created holding the
@@ -37,24 +32,17 @@
     :note: If the export fails, the destination directory will be
            left in a half-assed state.
     """
+    import os
+    os.mkdir(dest)
     mutter('export version %r', tree)
-    os.mkdir(dest)
-    for dp, ie in _export_iter_entries(tree, subdir):
-        fullpath = osutils.pathjoin(dest, dp)
-        if ie.kind == "file":
-            fileobj = tree.get_file(ie.file_id)
-            osutils.pumpfile(fileobj, file(fullpath, 'wb'))
-            if tree.is_executable(ie.file_id):
-                os.chmod(fullpath, 0755)
-        elif ie.kind == "directory":
-            os.mkdir(fullpath)
-        elif ie.kind == "symlink":
-            try:
-                os.symlink(ie.symlink_target, fullpath)
-            except OSError,e:
-                raise errors.BzrError(
-                    "Failed to create symlink %r -> %r, error: %s"
-                    % (fullpath, self.symlink_target, e))
-        else:
-            raise errors.BzrError("don't know how to export {%s} of kind %r" %
-               (ie.file_id, ie.kind))
+    inv = tree.inventory
+    entries = inv.iter_entries()
+    entries.next() # skip root
+    for dp, ie in entries:
+        # .bzrignore has no meaning outside of a working tree
+        # so do not export it
+        if dp == ".bzrignore":
+            continue
+        
+        ie.put_on_disk(dest, dp, tree)
+

=== modified file 'bzrlib/export/tar_exporter.py'
--- bzrlib/export/tar_exporter.py	2008-08-08 06:59:48 +0000
+++ bzrlib/export/tar_exporter.py	2006-07-24 04:40:06 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2008 Canonical Ltd
+# Copyright (C) 2005, 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -18,66 +18,43 @@
 """
 
 import os
-import sys
+from bzrlib.trace import mutter
 import tarfile
-import time
-
-from bzrlib import errors, export, osutils
-from bzrlib.export import _export_iter_entries
-from bzrlib.trace import mutter
-
-
-def tar_exporter(tree, dest, root, subdir, compression=None):
+from bzrlib import errors, export
+
+
+def tar_exporter(tree, dest, root, compression=None):
     """Export this tree to a new tar file.
 
     `dest` will be created holding the contents of this tree; if it
     already exists, it will be clobbered, like with "tar -c".
     """
+    from time import time
+    now = time()
+    compression = str(compression or '')
+    if root is None:
+        root = export.get_root_name(dest)
+    ball = tarfile.open(dest, 'w:' + compression)
     mutter('export version %r', tree)
-    now = time.time()
-    compression = str(compression or '')
-    if dest == '-':
-        # XXX: If no root is given, the output tarball will contain files
-        # named '-/foo'; perhaps this is the most reasonable thing.
-        ball = tarfile.open(None, 'w|' + compression, sys.stdout)
-    else:
-        if root is None:
-            root = export.get_root_name(dest)
-        ball = tarfile.open(dest, 'w:' + compression)
-    for dp, ie in _export_iter_entries(tree, subdir):
-        filename = osutils.pathjoin(root, dp).encode('utf8')
-        item = tarfile.TarInfo(filename)
-        item.mtime = now
-        if ie.kind == "file":
-            item.type = tarfile.REGTYPE
-            if tree.is_executable(ie.file_id):
-                item.mode = 0755
-            else:
-                item.mode = 0644
-            item.size = ie.text_size
-            fileobj = tree.get_file(ie.file_id)
-        elif ie.kind == "directory":
-            item.type = tarfile.DIRTYPE
-            item.name += '/'
-            item.size = 0
-            item.mode = 0755
-            fileobj = None
-        elif ie.kind == "symlink":
-            item.type = tarfile.SYMTYPE
-            item.size = 0
-            item.mode = 0755
-            item.linkname = ie.symlink_target
-            fileobj = None
-        else:
-            raise BzrError("don't know how to export {%s} of kind %r" %
-                           (ie.file_id, ie.kind))
+    inv = tree.inventory
+    entries = inv.iter_entries()
+    entries.next() # skip root
+    for dp, ie in entries:
+        # .bzrignore has no meaning outside of a working tree
+        # so do not export it
+        if dp == ".bzrignore":
+            continue
+        
+        mutter("  export {%s} kind %s to %s", ie.file_id, ie.kind, dest)
+        item, fileobj = ie.get_tar_item(root, dp, now, tree)
         ball.addfile(item, fileobj)
     ball.close()
 
 
-def tgz_exporter(tree, dest, root, subdir):
-    tar_exporter(tree, dest, root, subdir, compression='gz')
-
-
-def tbz_exporter(tree, dest, root, subdir):
-    tar_exporter(tree, dest, root, subdir, compression='bz2')
+def tgz_exporter(tree, dest, root):
+    tar_exporter(tree, dest, root, compression='gz')
+
+
+def tbz_exporter(tree, dest, root):
+    tar_exporter(tree, dest, root, compression='bz2')
+

=== modified file 'bzrlib/export/zip_exporter.py'
--- bzrlib/export/zip_exporter.py	2008-08-08 06:59:48 +0000
+++ bzrlib/export/zip_exporter.py	2006-10-04 01:56:39 +0000
@@ -19,13 +19,11 @@
 
 import os
 import stat
-import time
 import zipfile
 
 from bzrlib import (
     osutils,
     )
-from bzrlib.export import _export_iter_entries
 from bzrlib.trace import mutter
 
 
@@ -37,21 +35,31 @@
 _DIR_ATTR = stat.S_IFDIR | ZIP_DIRECTORY_BIT
 
 
-def zip_exporter(tree, dest, root, subdir):
+def zip_exporter(tree, dest, root):
     """ Export this tree to a new zip file.
 
     `dest` will be created holding the contents of this tree; if it
     already exists, it will be overwritten".
     """
+    import time
+
+    now = time.localtime()[:6]
     mutter('export version %r', tree)
 
-    now = time.localtime()[:6]
-
     compression = zipfile.ZIP_DEFLATED
     zipf = zipfile.ZipFile(dest, "w", compression)
 
+    inv = tree.inventory
+
     try:
-        for dp, ie in _export_iter_entries(tree, subdir):
+        entries = inv.iter_entries()
+        entries.next() # skip root
+        for dp, ie in entries:
+            # .bzrignore has no meaning outside of a working tree
+            # so do not export it
+            if dp == ".bzrignore":
+                continue
+
             file_id = ie.file_id
             mutter("  export {%s} kind %s to %s", file_id, ie.kind, dest)
 

=== modified file 'bzrlib/fetch.py'
--- bzrlib/fetch.py	2008-08-29 02:05:22 +0000
+++ bzrlib/fetch.py	2007-10-05 05:52:45 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2008 Canonical Ltd
+# Copyright (C) 2005, 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -27,23 +27,23 @@
 stored, so that if a revision is present we can totally recreate it.
 However, we can't know what files are included in a revision until we
 read its inventory.  So we query the inventory store of the source for
-the ids we need, and then pull those ids and then return to the inventories.
+the ids we need, and then pull those ids and finally actually join
+the inventories.
 """
 
-import operator
-
 import bzrlib
 import bzrlib.errors as errors
-from bzrlib.errors import InstallFailed
+from bzrlib.errors import (InstallFailed,
+                           )
 from bzrlib.progress import ProgressPhase
 from bzrlib.revision import is_null, NULL_REVISION
 from bzrlib.symbol_versioning import (deprecated_function,
         deprecated_method,
         )
-from bzrlib.tsort import topo_sort
 from bzrlib.trace import mutter
 import bzrlib.ui
-from bzrlib.versionedfile import filter_absent, FulltextContentFactory
+
+from bzrlib.lazy_import import lazy_import
 
 # TODO: Avoid repeatedly opening weaves so many times.
 
@@ -75,13 +75,7 @@
     This should not be used directly, it's essential a object to encapsulate
     the logic in InterRepository.fetch().
     """
-
-    def __init__(self, to_repository, from_repository, last_revision=None, pb=None,
-        find_ghosts=True):
-        """Create a repo fetcher.
-
-        :param find_ghosts: If True search the entire history for ghosts.
-        """
+    def __init__(self, to_repository, from_repository, last_revision=None, pb=None):
         # result variables.
         self.failed_revisions = []
         self.count_copied = 0
@@ -94,7 +88,6 @@
         self.from_repository = from_repository
         # must not mutate self._last_revision as its potentially a shared instance
         self._last_revision = last_revision
-        self.find_ghosts = find_ghosts
         if pb is None:
             self.pb = bzrlib.ui.ui_factory.nested_progress_bar()
             self.nested_pb = self.pb
@@ -114,11 +107,9 @@
                 else:
                     self.to_repository.commit_write_group()
             finally:
-                try:
-                    if self.nested_pb is not None:
-                        self.nested_pb.finished()
-                finally:
-                    self.to_repository.unlock()
+                if self.nested_pb is not None:
+                    self.nested_pb.finished()
+                self.to_repository.unlock()
         finally:
             self.from_repository.unlock()
 
@@ -128,23 +119,21 @@
         This initialises all the needed variables, and then fetches the 
         requested revisions, finally clearing the progress bar.
         """
+        self.to_weaves = self.to_repository.weave_store
+        self.from_weaves = self.from_repository.weave_store
         self.count_total = 0
         self.file_ids_names = {}
-        pp = ProgressPhase('Transferring', 4, self.pb)
+        pp = ProgressPhase('Fetch phase', 4, self.pb)
         try:
             pp.next_phase()
-            search = self._revids_to_fetch()
-            if search is None:
+            revs = self._revids_to_fetch()
+            if revs is None:
                 return
-            if getattr(self, '_fetch_everything_for_search', None) is not None:
-                self._fetch_everything_for_search(search, pp)
-            else:
-                # backward compatibility
-                self._fetch_everything_for_revisions(search.get_keys, pp)
+            self._fetch_everything_for_revisions(revs, pp)
         finally:
             self.pb.clear()
 
-    def _fetch_everything_for_search(self, search, pp):
+    def _fetch_everything_for_revisions(self, revs, pp):
         """Fetch all data for the given set of revisions."""
         # The first phase is "file".  We pass the progress bar for it directly
         # into item_keys_introduced_by, which has more information about how
@@ -157,12 +146,7 @@
         phase = 'file'
         pb = bzrlib.ui.ui_factory.nested_progress_bar()
         try:
-            revs = search.get_keys()
-            graph = self.from_repository.get_graph()
-            revs = list(graph.iter_topo_order(revs))
-            data_to_fetch = self.from_repository.item_keys_introduced_by(revs,
-                                                                         pb)
-            text_keys = []
+            data_to_fetch = self.from_repository.item_keys_introduced_by(revs, pb)
             for knit_kind, file_id, revisions in data_to_fetch:
                 if knit_kind != phase:
                     phase = knit_kind
@@ -171,25 +155,15 @@
                     pp.next_phase()
                     pb = bzrlib.ui.ui_factory.nested_progress_bar()
                 if knit_kind == "file":
-                    # Accumulate file texts
-                    text_keys.extend([(file_id, revision) for revision in
-                        revisions])
+                    self._fetch_weave_text(file_id, revisions)
                 elif knit_kind == "inventory":
-                    # Now copy the file texts.
-                    to_texts = self.to_repository.texts
-                    from_texts = self.from_repository.texts
-                    to_texts.insert_record_stream(from_texts.get_record_stream(
-                        text_keys, self.to_repository._fetch_order,
-                        not self.to_repository._fetch_uses_deltas))
-                    # Cause an error if a text occurs after we have done the
-                    # copy.
-                    text_keys = None
-                    # Before we process the inventory we generate the root
-                    # texts (if necessary) so that the inventories references
-                    # will be valid.
+                    # XXX:
+                    # Once we've processed all the files, then we generate the root
+                    # texts (if necessary), then we process the inventory.  It's a
+                    # bit distasteful to have knit_kind == "inventory" mean this,
+                    # perhaps it should happen on the first non-"file" knit, in case
+                    # it's not always inventory?
                     self._generate_root_texts(revs)
-                    # NB: This currently reopens the inventory weave in source;
-                    # using a single stream interface instead would avoid this.
                     self._fetch_inventory_weave(revs, pb)
                 elif knit_kind == "signatures":
                     # Nothing to do here; this will be taken care of when
@@ -199,8 +173,6 @@
                     self._fetch_revision_texts(revs, pb)
                 else:
                     raise AssertionError("Unknown knit kind %r" % knit_kind)
-            if self.to_repository._fetch_reconcile:
-                self.to_repository.reconcile()
         finally:
             if pb is not None:
                 pb.finished()
@@ -219,59 +191,53 @@
         if (self._last_revision is not None and
             self.to_repository.has_revision(self._last_revision)):
             return None
+            
         try:
-            return self.to_repository.search_missing_revision_ids(
-                self.from_repository, self._last_revision,
-                find_ghosts=self.find_ghosts)
-        except errors.NoSuchRevision, e:
+            # XXX: this gets the full graph on both sides, and will make sure
+            # that ghosts are filled whether or not you care about them.
+            return self.to_repository.missing_revision_ids(self.from_repository,
+                                                           self._last_revision)
+        except errors.NoSuchRevision:
             raise InstallFailed([self._last_revision])
 
+    def _fetch_weave_text(self, file_id, required_versions):
+        to_weave = self.to_weaves.get_weave_or_empty(file_id,
+            self.to_repository.get_transaction())
+        from_weave = self.from_weaves.get_weave(file_id,
+            self.from_repository.get_transaction())
+        # we fetch all the texts, because texts do
+        # not reference anything, and its cheap enough
+        to_weave.join(from_weave, version_ids=required_versions)
+        # we don't need *all* of this data anymore, but we dont know
+        # what we do. This cache clearing will result in a new read 
+        # of the knit data when we do the checkout, but probably we
+        # want to emit the needed data on the fly rather than at the
+        # end anyhow.
+        # the from weave should know not to cache data being joined,
+        # but its ok to ask it to clear.
+        from_weave.clear_cache()
+        to_weave.clear_cache()
+
     def _fetch_inventory_weave(self, revs, pb):
         pb.update("fetch inventory", 0, 2)
-        to_weave = self.to_repository.inventories
+        to_weave = self.to_repository.get_inventory_weave()
         child_pb = bzrlib.ui.ui_factory.nested_progress_bar()
         try:
             # just merge, this is optimisable and its means we don't
             # copy unreferenced data such as not-needed inventories.
             pb.update("fetch inventory", 1, 3)
-            from_weave = self.from_repository.inventories
+            from_weave = self.from_repository.get_inventory_weave()
             pb.update("fetch inventory", 2, 3)
             # we fetch only the referenced inventories because we do not
             # know for unselected inventories whether all their required
             # texts are present in the other repository - it could be
             # corrupt.
-            to_weave.insert_record_stream(from_weave.get_record_stream(
-                [(rev_id,) for rev_id in revs],
-                self.to_repository._fetch_order,
-                not self.to_repository._fetch_uses_deltas))
+            to_weave.join(from_weave, pb=child_pb, msg='merge inventory',
+                          version_ids=revs)
+            from_weave.clear_cache()
         finally:
             child_pb.finished()
 
-    def _fetch_revision_texts(self, revs, pb):
-        # may need to be a InterRevisionStore call here.
-        to_sf = self.to_repository.signatures
-        from_sf = self.from_repository.signatures
-        # A missing signature is just skipped.
-        to_sf.insert_record_stream(filter_absent(from_sf.get_record_stream(
-            [(rev_id,) for rev_id in revs],
-            self.to_repository._fetch_order,
-            True)))
-        # Bug #261339, some knit repositories accidentally had deltas in their
-        # revision stream, when you weren't ever supposed to have deltas.
-        # So we now *force* fulltext copying for signatures and revisions
-        self._fetch_just_revision_texts(revs)
-
-    def _fetch_just_revision_texts(self, version_ids):
-        to_rf = self.to_repository.revisions
-        from_rf = self.from_repository.revisions
-        to_rf.insert_record_stream(from_rf.get_record_stream(
-            [(rev_id,) for rev_id in version_ids],
-            self.to_repository._fetch_order,
-            True))
-        # Bug #261339, some knit repositories accidentally had deltas in their
-        # revision stream, when you weren't ever supposed to have deltas.
-        # So we now *force* fulltext copying for signatures and revisions
-
     def _generate_root_texts(self, revs):
         """This will be called by __fetch between fetching weave texts and
         fetching the inventory weave.
@@ -282,6 +248,62 @@
         pass
 
 
+class GenericRepoFetcher(RepoFetcher):
+    """This is a generic repo to repo fetcher.
+
+    This makes minimal assumptions about repo layout and contents.
+    It triggers a reconciliation after fetching to ensure integrity.
+    """
+
+    def _fetch_revision_texts(self, revs, pb):
+        """Fetch revision object texts"""
+        to_txn = self.to_transaction = self.to_repository.get_transaction()
+        count = 0
+        total = len(revs)
+        to_store = self.to_repository._revision_store
+        for rev in revs:
+            pb.update('copying revisions', count, total)
+            try:
+                sig_text = self.from_repository.get_signature_text(rev)
+                to_store.add_revision_signature_text(rev, sig_text, to_txn)
+            except errors.NoSuchRevision:
+                # not signed.
+                pass
+            to_store.add_revision(self.from_repository.get_revision(rev),
+                                  to_txn)
+            count += 1
+        # fixup inventory if needed: 
+        # this is expensive because we have no inverse index to current ghosts.
+        # but on local disk its a few seconds and sftp push is already insane.
+        # so we just-do-it.
+        # FIXME: repository should inform if this is needed.
+        self.to_repository.reconcile()
+    
+
+class KnitRepoFetcher(RepoFetcher):
+    """This is a knit format repository specific fetcher.
+
+    This differs from the GenericRepoFetcher by not doing a 
+    reconciliation after copying, and using knit joining to
+    copy revision texts.
+    """
+
+    def _fetch_revision_texts(self, revs, pb):
+        # may need to be a InterRevisionStore call here.
+        from_transaction = self.from_repository.get_transaction()
+        to_transaction = self.to_repository.get_transaction()
+        to_sf = self.to_repository._revision_store.get_signature_file(
+            to_transaction)
+        from_sf = self.from_repository._revision_store.get_signature_file(
+            from_transaction)
+        to_sf.join(from_sf, version_ids=revs, ignore_missing=True)
+        to_rf = self.to_repository._revision_store.get_revision_file(
+            to_transaction)
+        from_rf = self.from_repository._revision_store.get_revision_file(
+            from_transaction)
+        to_rf.join(from_rf, version_ids=revs)
+
+
 class Inter1and2Helper(object):
     """Helper for operations that convert data from model 1 and 2
     
@@ -307,8 +329,6 @@
 
         :param revs: A list of revision ids
         """
-        # In case that revs is not a list.
-        revs = list(revs)
         while revs:
             for tree in self.source.revision_trees(revs[:100]):
                 if tree.inventory.revision_id is None:
@@ -316,62 +336,24 @@
                 yield tree
             revs = revs[100:]
 
-    def _find_root_ids(self, revs, parent_map, graph):
-        revision_root = {}
-        planned_versions = {}
-        for tree in self.iter_rev_trees(revs):
-            revision_id = tree.inventory.root.revision
-            root_id = tree.get_root_id()
-            planned_versions.setdefault(root_id, []).append(revision_id)
-            revision_root[revision_id] = root_id
-        # Find out which parents we don't already know root ids for
-        parents = set()
-        for revision_parents in parent_map.itervalues():
-            parents.update(revision_parents)
-        parents.difference_update(revision_root.keys() + [NULL_REVISION])
-        # Limit to revisions present in the versionedfile
-        parents = graph.get_parent_map(parents).keys()
-        for tree in self.iter_rev_trees(parents):
-            root_id = tree.get_root_id()
-            revision_root[tree.get_revision_id()] = root_id
-        return revision_root, planned_versions
-
     def generate_root_texts(self, revs):
         """Generate VersionedFiles for all root ids.
-
+        
         :param revs: the revisions to include
         """
-        to_texts = self.target.texts
-        graph = self.source.get_graph()
-        parent_map = graph.get_parent_map(revs)
-        rev_order = topo_sort(parent_map)
-        rev_id_to_root_id, root_id_to_rev_ids = self._find_root_ids(
-            revs, parent_map, graph)
-        root_id_order = [(rev_id_to_root_id[rev_id], rev_id) for rev_id in
-            rev_order]
-        # Guaranteed stable, this groups all the file id operations together
-        # retaining topological order within the revisions of a file id.
-        # File id splits and joins would invalidate this, but they don't exist
-        # yet, and are unlikely to in non-rich-root environments anyway.
-        root_id_order.sort(key=operator.itemgetter(0))
-        # Create a record stream containing the roots to create.
-        def yield_roots():
-            for key in root_id_order:
-                root_id, rev_id = key
-                rev_parents = parent_map[rev_id]
-                # We drop revision parents with different file-ids, because
-                # that represents a rename of the root to a different location
-                # - its not actually a parent for us. (We could look for that
-                # file id in the revision tree at considerably more expense,
-                # but for now this is sufficient (and reconcile will catch and
-                # correct this anyway).
-                # When a parent revision is a ghost, we guess that its root id
-                # was unchanged (rather than trimming it from the parent list).
-                parent_keys = tuple((root_id, parent) for parent in rev_parents
-                    if parent != NULL_REVISION and
-                        rev_id_to_root_id.get(parent, root_id) == root_id)
-                yield FulltextContentFactory(key, parent_keys, None, '')
-        to_texts.insert_record_stream(yield_roots())
+        inventory_weave = self.source.get_inventory_weave()
+        parent_texts = {}
+        versionedfile = {}
+        to_store = self.target.weave_store
+        for tree in self.iter_rev_trees(revs):
+            revision_id = tree.inventory.root.revision
+            root_id = tree.inventory.root.file_id
+            parents = inventory_weave.get_parents(revision_id)
+            if root_id not in versionedfile:
+                versionedfile[root_id] = to_store.get_weave_or_empty(root_id, 
+                    self.target.get_transaction())
+            _, _, parent_texts[root_id] = versionedfile[root_id].add_lines(
+                revision_id, parents, [], parent_texts)
 
     def regenerate_inventory(self, revs):
         """Generate a new inventory versionedfile in target, convertin data.
@@ -380,60 +362,37 @@
         stored in the target (reserializing it in a different format).
         :param revs: The revisions to include
         """
+        inventory_weave = self.source.get_inventory_weave()
         for tree in self.iter_rev_trees(revs):
-            parents = tree.get_parent_ids()
+            parents = inventory_weave.get_parents(tree.get_revision_id())
             self.target.add_inventory(tree.get_revision_id(), tree.inventory,
                                       parents)
 
-    def fetch_revisions(self, revision_ids):
-        # TODO: should this batch them up rather than requesting 10,000
-        #       revisions at once?
-        for revision in self.source.get_revisions(revision_ids):
-            self.target.add_revision(revision.revision_id, revision)
-
-
-class Model1toKnit2Fetcher(RepoFetcher):
+
+class Model1toKnit2Fetcher(GenericRepoFetcher):
     """Fetch from a Model1 repository into a Knit2 repository
     """
-    def __init__(self, to_repository, from_repository, last_revision=None,
-                 pb=None, find_ghosts=True):
+    def __init__(self, to_repository, from_repository, last_revision=None, 
+                 pb=None):
         self.helper = Inter1and2Helper(from_repository, to_repository)
-        RepoFetcher.__init__(self, to_repository, from_repository,
-            last_revision, pb, find_ghosts)
+        GenericRepoFetcher.__init__(self, to_repository, from_repository,
+                                    last_revision, pb)
 
     def _generate_root_texts(self, revs):
         self.helper.generate_root_texts(revs)
 
     def _fetch_inventory_weave(self, revs, pb):
         self.helper.regenerate_inventory(revs)
-
-    def _fetch_revision_texts(self, revs, pb):
-        """Fetch revision object texts"""
-        count = 0
-        total = len(revs)
-        for rev in revs:
-            pb.update('copying revisions', count, total)
-            try:
-                sig_text = self.from_repository.get_signature_text(rev)
-                self.to_repository.add_signature_text(rev, sig_text)
-            except errors.NoSuchRevision:
-                # not signed.
-                pass
-            self._copy_revision(rev)
-            count += 1
-
-    def _copy_revision(self, rev):
-        self.helper.fetch_revisions([rev])
-
-
-class Knit1to2Fetcher(RepoFetcher):
+ 
+
+class Knit1to2Fetcher(KnitRepoFetcher):
     """Fetch from a Knit1 repository into a Knit2 repository"""
 
-    def __init__(self, to_repository, from_repository, last_revision=None,
-                 pb=None, find_ghosts=True):
+    def __init__(self, to_repository, from_repository, last_revision=None, 
+                 pb=None):
         self.helper = Inter1and2Helper(from_repository, to_repository)
-        RepoFetcher.__init__(self, to_repository, from_repository,
-            last_revision, pb, find_ghosts)
+        KnitRepoFetcher.__init__(self, to_repository, from_repository,
+                                 last_revision, pb)
 
     def _generate_root_texts(self, revs):
         self.helper.generate_root_texts(revs)
@@ -441,5 +400,11 @@
     def _fetch_inventory_weave(self, revs, pb):
         self.helper.regenerate_inventory(revs)
 
-    def _fetch_just_revision_texts(self, version_ids):
-        self.helper.fetch_revisions(version_ids)
+
+class RemoteToOtherFetcher(GenericRepoFetcher):
+
+    def _fetch_everything_for_revisions(self, revs, pp):
+        data_stream = self.from_repository.get_data_stream(revs)
+        self.to_repository.insert_data_stream(data_stream)
+
+

=== modified file 'bzrlib/globbing.py'
--- bzrlib/globbing.py	2008-05-06 02:57:11 +0000
+++ bzrlib/globbing.py	2007-03-07 14:49:00 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2008 Canonical Ltd
+# Copyright (C) 2006 Canonical Ltd
 
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -214,29 +214,7 @@
             if match:
                 return patterns[match.lastindex -1]
         return None
-
-
-class _OrderedGlobster(Globster):
-    """A Globster that keeps pattern order."""
-
-    def __init__(self, patterns):
-        """Constructor.
-
-        :param patterns: sequence of glob patterns
-        """
-        # Note: This could be smarter by running like sequences together
-        self._regex_patterns = []
-        for pat in patterns:
-            pat = normalize_pattern(pat)
-            if pat.startswith(u'RE:') or u'/' in pat:
-                self._add_patterns([pat], _sub_fullpath) 
-            elif pat.startswith(u'*.'):
-                self._add_patterns([pat], _sub_extension,
-                    prefix=r'(?:.*/)?(?!.*/)(?:.*\.)')
-            else:
-                self._add_patterns([pat], _sub_basename, 
-                    prefix=r'(?:.*/)?(?!.*/)')
-
+        
 
 def normalize_pattern(pattern):
     """Converts backslashes in path patterns to forward slashes.

=== modified file 'bzrlib/graph.py'
--- bzrlib/graph.py	2008-07-16 18:14:23 +0000
+++ bzrlib/graph.py	2007-10-19 03:45:02 +0000
@@ -14,19 +14,12 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-import time
-
 from bzrlib import (
-    debug,
     errors,
-    revision,
-    symbol_versioning,
-    trace,
     tsort,
     )
 from bzrlib.deprecated_graph import (node_distances, select_farthest)
-
-STEP_UNIQUE_SEARCHER_EVERY = 5
+from bzrlib.revision import NULL_REVISION
 
 # DIAGRAM of terminology
 #       A
@@ -51,20 +44,6 @@
 # 2. Since len(['D', 'E']) > 1, find_lca('D', 'E') => ['A']
 
 
-class DictParentsProvider(object):
-    """A parents provider for Graph objects."""
-
-    def __init__(self, ancestry):
-        self.ancestry = ancestry
-
-    def __repr__(self):
-        return 'DictParentsProvider(%r)' % self.ancestry
-
-    def get_parent_map(self, keys):
-        """See _StackedParentsProvider.get_parent_map"""
-        ancestry = self.ancestry
-        return dict((k, ancestry[k]) for k in keys if k in ancestry)
-
 
 class _StackedParentsProvider(object):
 
@@ -74,67 +53,28 @@
     def __repr__(self):
         return "_StackedParentsProvider(%r)" % self._parent_providers
 
-    def get_parent_map(self, keys):
-        """Get a mapping of keys => parents
+    def get_parents(self, revision_ids):
+        """Find revision ids of the parents of a list of revisions
 
-        A dictionary is returned with an entry for each key present in this
-        source. If this source doesn't have information about a key, it should
-        not include an entry.
+        A list is returned of the same length as the input.  Each entry
+        is a list of parent ids for the corresponding input revision.
 
         [NULL_REVISION] is used as the parent of the first user-committed
         revision.  Its parent list is empty.
 
-        :param keys: An iterable returning keys to check (eg revision_ids)
-        :return: A dictionary mapping each key to its parents
+        If the revision is not present (i.e. a ghost), None is used in place
+        of the list of parents.
         """
         found = {}
-        remaining = set(keys)
         for parents_provider in self._parent_providers:
-            new_found = parents_provider.get_parent_map(remaining)
+            pending_revisions = [r for r in revision_ids if r not in found]
+            parent_list = parents_provider.get_parents(pending_revisions)
+            new_found = dict((k, v) for k, v in zip(pending_revisions,
+                             parent_list) if v is not None)
             found.update(new_found)
-            remaining.difference_update(new_found)
-            if not remaining:
+            if len(found) == len(revision_ids):
                 break
-        return found
-
-
-class CachingParentsProvider(object):
-    """A parents provider which will cache the revision => parents in a dict.
-
-    This is useful for providers that have an expensive lookup.
-    """
-
-    def __init__(self, parent_provider):
-        self._real_provider = parent_provider
-        # Theoretically we could use an LRUCache here
-        self._cache = {}
-
-    def __repr__(self):
-        return "%s(%r)" % (self.__class__.__name__, self._real_provider)
-
-    def get_parent_map(self, keys):
-        """See _StackedParentsProvider.get_parent_map"""
-        needed = set()
-        # If the _real_provider doesn't have a key, we cache a value of None,
-        # which we then later use to realize we cannot provide a value for that
-        # key.
-        parent_map = {}
-        cache = self._cache
-        for key in keys:
-            if key in cache:
-                value = cache[key]
-                if value is not None:
-                    parent_map[key] = value
-            else:
-                needed.add(key)
-
-        if needed:
-            new_parents = self._real_provider.get_parent_map(needed)
-            cache.update(new_parents)
-            parent_map.update(new_parents)
-            needed.difference_update(new_parents)
-            cache.update(dict.fromkeys(needed, None))
-        return parent_map
+        return [found.get(r, None) for r in revision_ids]
 
 
 class Graph(object):
@@ -149,16 +89,12 @@
 
         This should not normally be invoked directly, because there may be
         specialized implementations for particular repository types.  See
-        Repository.get_graph().
+        Repository.get_graph()
 
-        :param parents_provider: An object providing a get_parent_map call
-            conforming to the behavior of
-            StackedParentsProvider.get_parent_map.
+        :param parents_func: an object providing a get_parents call
+            conforming to the behavior of StackedParentsProvider.get_parents
         """
-        if getattr(parents_provider, 'get_parents', None) is not None:
-            self.get_parents = parents_provider.get_parents
-        if getattr(parents_provider, 'get_parent_map', None) is not None:
-            self.get_parent_map = parents_provider.get_parent_map
+        self.get_parents = parents_provider.get_parents
         self._parents_provider = parents_provider
 
     def __repr__(self):
@@ -205,400 +141,10 @@
 
     def find_difference(self, left_revision, right_revision):
         """Determine the graph difference between two revisions"""
-        border, common, searchers = self._find_border_ancestors(
+        border, common, (left, right) = self._find_border_ancestors(
             [left_revision, right_revision])
-        self._search_for_extra_common(common, searchers)
-        left = searchers[0].seen
-        right = searchers[1].seen
-        return (left.difference(right), right.difference(left))
-
-    def find_distance_to_null(self, target_revision_id, known_revision_ids):
-        """Find the left-hand distance to the NULL_REVISION.
-
-        (This can also be considered the revno of a branch at
-        target_revision_id.)
-
-        :param target_revision_id: A revision_id which we would like to know
-            the revno for.
-        :param known_revision_ids: [(revision_id, revno)] A list of known
-            revno, revision_id tuples. We'll use this to seed the search.
-        """
-        # Map from revision_ids to a known value for their revno
-        known_revnos = dict(known_revision_ids)
-        cur_tip = target_revision_id
-        num_steps = 0
-        NULL_REVISION = revision.NULL_REVISION
-        known_revnos[NULL_REVISION] = 0
-
-        searching_known_tips = list(known_revnos.keys())
-
-        unknown_searched = {}
-
-        while cur_tip not in known_revnos:
-            unknown_searched[cur_tip] = num_steps
-            num_steps += 1
-            to_search = set([cur_tip])
-            to_search.update(searching_known_tips)
-            parent_map = self.get_parent_map(to_search)
-            parents = parent_map.get(cur_tip, None)
-            if not parents: # An empty list or None is a ghost
-                raise errors.GhostRevisionsHaveNoRevno(target_revision_id,
-                                                       cur_tip)
-            cur_tip = parents[0]
-            next_known_tips = []
-            for revision_id in searching_known_tips:
-                parents = parent_map.get(revision_id, None)
-                if not parents:
-                    continue
-                next = parents[0]
-                next_revno = known_revnos[revision_id] - 1
-                if next in unknown_searched:
-                    # We have enough information to return a value right now
-                    return next_revno + unknown_searched[next]
-                if next in known_revnos:
-                    continue
-                known_revnos[next] = next_revno
-                next_known_tips.append(next)
-            searching_known_tips = next_known_tips
-
-        # We reached a known revision, so just add in how many steps it took to
-        # get there.
-        return known_revnos[cur_tip] + num_steps
-
-    def find_unique_ancestors(self, unique_revision, common_revisions):
-        """Find the unique ancestors for a revision versus others.
-
-        This returns the ancestry of unique_revision, excluding all revisions
-        in the ancestry of common_revisions. If unique_revision is in the
-        ancestry, then the empty set will be returned.
-
-        :param unique_revision: The revision_id whose ancestry we are
-            interested in.
-            XXX: Would this API be better if we allowed multiple revisions on
-                 to be searched here?
-        :param common_revisions: Revision_ids of ancestries to exclude.
-        :return: A set of revisions in the ancestry of unique_revision
-        """
-        if unique_revision in common_revisions:
-            return set()
-
-        # Algorithm description
-        # 1) Walk backwards from the unique node and all common nodes.
-        # 2) When a node is seen by both sides, stop searching it in the unique
-        #    walker, include it in the common walker.
-        # 3) Stop searching when there are no nodes left for the unique walker.
-        #    At this point, you have a maximal set of unique nodes. Some of
-        #    them may actually be common, and you haven't reached them yet.
-        # 4) Start new searchers for the unique nodes, seeded with the
-        #    information you have so far.
-        # 5) Continue searching, stopping the common searches when the search
-        #    tip is an ancestor of all unique nodes.
-        # 6) Aggregate together unique searchers when they are searching the
-        #    same tips. When all unique searchers are searching the same node,
-        #    stop move it to a single 'all_unique_searcher'.
-        # 7) The 'all_unique_searcher' represents the very 'tip' of searching.
-        #    Most of the time this produces very little important information.
-        #    So don't step it as quickly as the other searchers.
-        # 8) Search is done when all common searchers have completed.
-
-        unique_searcher, common_searcher = self._find_initial_unique_nodes(
-            [unique_revision], common_revisions)
-
-        unique_nodes = unique_searcher.seen.difference(common_searcher.seen)
-        if not unique_nodes:
-            return unique_nodes
-
-        (all_unique_searcher,
-         unique_tip_searchers) = self._make_unique_searchers(unique_nodes,
-                                    unique_searcher, common_searcher)
-
-        self._refine_unique_nodes(unique_searcher, all_unique_searcher,
-                                  unique_tip_searchers, common_searcher)
-        true_unique_nodes = unique_nodes.difference(common_searcher.seen)
-        if 'graph' in debug.debug_flags:
-            trace.mutter('Found %d truly unique nodes out of %d',
-                         len(true_unique_nodes), len(unique_nodes))
-        return true_unique_nodes
-
-    def _find_initial_unique_nodes(self, unique_revisions, common_revisions):
-        """Steps 1-3 of find_unique_ancestors.
-
-        Find the maximal set of unique nodes. Some of these might actually
-        still be common, but we are sure that there are no other unique nodes.
-
-        :return: (unique_searcher, common_searcher)
-        """
-
-        unique_searcher = self._make_breadth_first_searcher(unique_revisions)
-        # we know that unique_revisions aren't in common_revisions, so skip
-        # past them.
-        unique_searcher.next()
-        common_searcher = self._make_breadth_first_searcher(common_revisions)
-
-        # As long as we are still finding unique nodes, keep searching
-        while unique_searcher._next_query:
-            next_unique_nodes = set(unique_searcher.step())
-            next_common_nodes = set(common_searcher.step())
-
-            # Check if either searcher encounters new nodes seen by the other
-            # side.
-            unique_are_common_nodes = next_unique_nodes.intersection(
-                common_searcher.seen)
-            unique_are_common_nodes.update(
-                next_common_nodes.intersection(unique_searcher.seen))
-            if unique_are_common_nodes:
-                ancestors = unique_searcher.find_seen_ancestors(
-                                unique_are_common_nodes)
-                # TODO: This is a bit overboard, we only really care about
-                #       the ancestors of the tips because the rest we
-                #       already know. This is *correct* but causes us to
-                #       search too much ancestry.
-                ancestors.update(common_searcher.find_seen_ancestors(ancestors))
-                unique_searcher.stop_searching_any(ancestors)
-                common_searcher.start_searching(ancestors)
-
-        return unique_searcher, common_searcher
-
-    def _make_unique_searchers(self, unique_nodes, unique_searcher,
-                               common_searcher):
-        """Create a searcher for all the unique search tips (step 4).
-
-        As a side effect, the common_searcher will stop searching any nodes
-        that are ancestors of the unique searcher tips.
-
-        :return: (all_unique_searcher, unique_tip_searchers)
-        """
-        unique_tips = self._remove_simple_descendants(unique_nodes,
-                        self.get_parent_map(unique_nodes))
-
-        if len(unique_tips) == 1:
-            unique_tip_searchers = []
-            ancestor_all_unique = unique_searcher.find_seen_ancestors(unique_tips)
-        else:
-            unique_tip_searchers = []
-            for tip in unique_tips:
-                revs_to_search = unique_searcher.find_seen_ancestors([tip])
-                revs_to_search.update(
-                    common_searcher.find_seen_ancestors(revs_to_search))
-                searcher = self._make_breadth_first_searcher(revs_to_search)
-                # We don't care about the starting nodes.
-                searcher._label = tip
-                searcher.step()
-                unique_tip_searchers.append(searcher)
-
-            ancestor_all_unique = None
-            for searcher in unique_tip_searchers:
-                if ancestor_all_unique is None:
-                    ancestor_all_unique = set(searcher.seen)
-                else:
-                    ancestor_all_unique = ancestor_all_unique.intersection(
-                                                searcher.seen)
-        # Collapse all the common nodes into a single searcher
-        all_unique_searcher = self._make_breadth_first_searcher(
-                                ancestor_all_unique)
-        if ancestor_all_unique:
-            # We've seen these nodes in all the searchers, so we'll just go to
-            # the next
-            all_unique_searcher.step()
-
-            # Stop any search tips that are already known as ancestors of the
-            # unique nodes
-            stopped_common = common_searcher.stop_searching_any(
-                common_searcher.find_seen_ancestors(ancestor_all_unique))
-
-            total_stopped = 0
-            for searcher in unique_tip_searchers:
-                total_stopped += len(searcher.stop_searching_any(
-                    searcher.find_seen_ancestors(ancestor_all_unique)))
-        if 'graph' in debug.debug_flags:
-            trace.mutter('For %d unique nodes, created %d + 1 unique searchers'
-                         ' (%d stopped search tips, %d common ancestors'
-                         ' (%d stopped common)',
-                         len(unique_nodes), len(unique_tip_searchers),
-                         total_stopped, len(ancestor_all_unique),
-                         len(stopped_common))
-        return all_unique_searcher, unique_tip_searchers
-
-    def _step_unique_and_common_searchers(self, common_searcher,
-                                          unique_tip_searchers,
-                                          unique_searcher):
-        """Step all the searchers"""
-        newly_seen_common = set(common_searcher.step())
-        newly_seen_unique = set()
-        for searcher in unique_tip_searchers:
-            next = set(searcher.step())
-            next.update(unique_searcher.find_seen_ancestors(next))
-            next.update(common_searcher.find_seen_ancestors(next))
-            for alt_searcher in unique_tip_searchers:
-                if alt_searcher is searcher:
-                    continue
-                next.update(alt_searcher.find_seen_ancestors(next))
-            searcher.start_searching(next)
-            newly_seen_unique.update(next)
-        return newly_seen_common, newly_seen_unique
-
-    def _find_nodes_common_to_all_unique(self, unique_tip_searchers,
-                                         all_unique_searcher,
-                                         newly_seen_unique, step_all_unique):
-        """Find nodes that are common to all unique_tip_searchers.
-
-        If it is time, step the all_unique_searcher, and add its nodes to the
-        result.
-        """
-        common_to_all_unique_nodes = newly_seen_unique.copy()
-        for searcher in unique_tip_searchers:
-            common_to_all_unique_nodes.intersection_update(searcher.seen)
-        common_to_all_unique_nodes.intersection_update(
-                                    all_unique_searcher.seen)
-        # Step all-unique less frequently than the other searchers.
-        # In the common case, we don't need to spider out far here, so
-        # avoid doing extra work.
-        if step_all_unique:
-            tstart = time.clock()
-            nodes = all_unique_searcher.step()
-            common_to_all_unique_nodes.update(nodes)
-            if 'graph' in debug.debug_flags:
-                tdelta = time.clock() - tstart
-                trace.mutter('all_unique_searcher step() took %.3fs'
-                             'for %d nodes (%d total), iteration: %s',
-                             tdelta, len(nodes), len(all_unique_searcher.seen),
-                             all_unique_searcher._iterations)
-        return common_to_all_unique_nodes
-
-    def _collapse_unique_searchers(self, unique_tip_searchers,
-                                   common_to_all_unique_nodes):
-        """Combine searchers that are searching the same tips.
-
-        When two searchers are searching the same tips, we can stop one of the
-        searchers. We also know that the maximal set of common ancestors is the
-        intersection of the two original searchers.
-
-        :return: A list of searchers that are searching unique nodes.
-        """
-        # Filter out searchers that don't actually search different
-        # nodes. We already have the ancestry intersection for them
-        unique_search_tips = {}
-        for searcher in unique_tip_searchers:
-            stopped = searcher.stop_searching_any(common_to_all_unique_nodes)
-            will_search_set = frozenset(searcher._next_query)
-            if not will_search_set:
-                if 'graph' in debug.debug_flags:
-                    trace.mutter('Unique searcher %s was stopped.'
-                                 ' (%s iterations) %d nodes stopped',
-                                 searcher._label,
-                                 searcher._iterations,
-                                 len(stopped))
-            elif will_search_set not in unique_search_tips:
-                # This searcher is searching a unique set of nodes, let it
-                unique_search_tips[will_search_set] = [searcher]
-            else:
-                unique_search_tips[will_search_set].append(searcher)
-        # TODO: it might be possible to collapse searchers faster when they
-        #       only have *some* search tips in common.
-        next_unique_searchers = []
-        for searchers in unique_search_tips.itervalues():
-            if len(searchers) == 1:
-                # Searching unique tips, go for it
-                next_unique_searchers.append(searchers[0])
-            else:
-                # These searchers have started searching the same tips, we
-                # don't need them to cover the same ground. The
-                # intersection of their ancestry won't change, so create a
-                # new searcher, combining their histories.
-                next_searcher = searchers[0]
-                for searcher in searchers[1:]:
-                    next_searcher.seen.intersection_update(searcher.seen)
-                if 'graph' in debug.debug_flags:
-                    trace.mutter('Combining %d searchers into a single'
-                                 ' searcher searching %d nodes with'
-                                 ' %d ancestry',
-                                 len(searchers),
-                                 len(next_searcher._next_query),
-                                 len(next_searcher.seen))
-                next_unique_searchers.append(next_searcher)
-        return next_unique_searchers
-
-    def _refine_unique_nodes(self, unique_searcher, all_unique_searcher,
-                             unique_tip_searchers, common_searcher):
-        """Steps 5-8 of find_unique_ancestors.
-        
-        This function returns when common_searcher has stopped searching for
-        more nodes.
-        """
-        # We step the ancestor_all_unique searcher only every
-        # STEP_UNIQUE_SEARCHER_EVERY steps.
-        step_all_unique_counter = 0
-        # While we still have common nodes to search
-        while common_searcher._next_query:
-            (newly_seen_common,
-             newly_seen_unique) = self._step_unique_and_common_searchers(
-                common_searcher, unique_tip_searchers, unique_searcher)
-            # These nodes are common ancestors of all unique nodes
-            common_to_all_unique_nodes = self._find_nodes_common_to_all_unique(
-                unique_tip_searchers, all_unique_searcher, newly_seen_unique,
-                step_all_unique_counter==0)
-            step_all_unique_counter = ((step_all_unique_counter + 1)
-                                       % STEP_UNIQUE_SEARCHER_EVERY)
-
-            if newly_seen_common:
-                # If a 'common' node is an ancestor of all unique searchers, we
-                # can stop searching it.
-                common_searcher.stop_searching_any(
-                    all_unique_searcher.seen.intersection(newly_seen_common))
-            if common_to_all_unique_nodes:
-                common_to_all_unique_nodes.update(
-                    common_searcher.find_seen_ancestors(
-                        common_to_all_unique_nodes))
-                # The all_unique searcher can start searching the common nodes
-                # but everyone else can stop.
-                # This is the sort of thing where we would like to not have it
-                # start_searching all of the nodes, but only mark all of them
-                # as seen, and have it search only the actual tips. Otherwise
-                # it is another get_parent_map() traversal for it to figure out
-                # what we already should know.
-                all_unique_searcher.start_searching(common_to_all_unique_nodes)
-                common_searcher.stop_searching_any(common_to_all_unique_nodes)
-
-            next_unique_searchers = self._collapse_unique_searchers(
-                unique_tip_searchers, common_to_all_unique_nodes)
-            if len(unique_tip_searchers) != len(next_unique_searchers):
-                if 'graph' in debug.debug_flags:
-                    trace.mutter('Collapsed %d unique searchers => %d'
-                                 ' at %s iterations',
-                                 len(unique_tip_searchers),
-                                 len(next_unique_searchers),
-                                 all_unique_searcher._iterations)
-            unique_tip_searchers = next_unique_searchers
-
-    @symbol_versioning.deprecated_method(symbol_versioning.one_one)
-    def get_parents(self, revisions):
-        """Find revision ids of the parents of a list of revisions
-
-        A list is returned of the same length as the input.  Each entry
-        is a list of parent ids for the corresponding input revision.
-
-        [NULL_REVISION] is used as the parent of the first user-committed
-        revision.  Its parent list is empty.
-
-        If the revision is not present (i.e. a ghost), None is used in place
-        of the list of parents.
-
-        Deprecated in bzr 1.2 - please see get_parent_map.
-        """
-        parents = self.get_parent_map(revisions)
-        return [parents.get(r, None) for r in revisions]
-
-    def get_parent_map(self, revisions):
-        """Get a map of key:parent_list for revisions.
-
-        This implementation delegates to get_parents, for old parent_providers
-        that do not supply get_parent_map.
-        """
-        result = {}
-        for rev, parents in self.get_parents(revisions):
-            if parents is not None:
-                result[rev] = parents
-        return result
+        return (left.difference(right).difference(common),
+                right.difference(left).difference(common))
 
     def _make_breadth_first_searcher(self, revisions):
         return _BreadthFirstSearcher(revisions, self)
@@ -619,63 +165,55 @@
         """
         if None in revisions:
             raise errors.InvalidRevisionId(None, self)
+        common_searcher = self._make_breadth_first_searcher([])
         common_ancestors = set()
         searchers = [self._make_breadth_first_searcher([r])
                      for r in revisions]
         active_searchers = searchers[:]
         border_ancestors = set()
+        def update_common(searcher, revisions):
+            w_seen_ancestors = searcher.find_seen_ancestors(
+                revision)
+            stopped = searcher.stop_searching_any(w_seen_ancestors)
+            common_ancestors.update(w_seen_ancestors)
+            common_searcher.start_searching(stopped)
 
         while True:
+            if len(active_searchers) == 0:
+                return border_ancestors, common_ancestors, [s.seen for s in
+                                                            searchers]
+            try:
+                new_common = common_searcher.next()
+                common_ancestors.update(new_common)
+            except StopIteration:
+                pass
+            else:
+                for searcher in active_searchers:
+                    for revision in new_common.intersection(searcher.seen):
+                        update_common(searcher, revision)
+
             newly_seen = set()
-            for searcher in searchers:
-                new_ancestors = searcher.step()
-                if new_ancestors:
-                    newly_seen.update(new_ancestors)
-            new_common = set()
+            new_active_searchers = []
+            for searcher in active_searchers:
+                try:
+                    newly_seen.update(searcher.next())
+                except StopIteration:
+                    pass
+                else:
+                    new_active_searchers.append(searcher)
+            active_searchers = new_active_searchers
             for revision in newly_seen:
                 if revision in common_ancestors:
-                    # Not a border ancestor because it was seen as common
-                    # already
-                    new_common.add(revision)
+                    for searcher in searchers:
+                        update_common(searcher, revision)
                     continue
                 for searcher in searchers:
                     if revision not in searcher.seen:
                         break
                 else:
-                    # This is a border because it is a first common that we see
-                    # after walking for a while.
                     border_ancestors.add(revision)
-                    new_common.add(revision)
-            if new_common:
-                for searcher in searchers:
-                    new_common.update(searcher.find_seen_ancestors(new_common))
-                for searcher in searchers:
-                    searcher.start_searching(new_common)
-                common_ancestors.update(new_common)
-
-            # Figure out what the searchers will be searching next, and if
-            # there is only 1 set being searched, then we are done searching,
-            # since all searchers would have to be searching the same data,
-            # thus it *must* be in common.
-            unique_search_sets = set()
-            for searcher in searchers:
-                will_search_set = frozenset(searcher._next_query)
-                if will_search_set not in unique_search_sets:
-                    # This searcher is searching a unique set of nodes, let it
-                    unique_search_sets.add(will_search_set)
-
-            if len(unique_search_sets) == 1:
-                nodes = unique_search_sets.pop()
-                uncommon_nodes = nodes.difference(common_ancestors)
-                if uncommon_nodes:
-                    raise AssertionError("Somehow we ended up converging"
-                                         " without actually marking them as"
-                                         " in common."
-                                         "\nStart_nodes: %s"
-                                         "\nuncommon_nodes: %s"
-                                         % (revisions, uncommon_nodes))
-                break
-        return border_ancestors, common_ancestors, searchers
+                    for searcher in searchers:
+                        update_common(searcher, revision)
 
     def heads(self, keys):
         """Return the heads from amongst keys.
@@ -693,11 +231,6 @@
             order if they need it.
         """
         candidate_heads = set(keys)
-        if revision.NULL_REVISION in candidate_heads:
-            # NULL_REVISION is only a head if it is the only entry
-            candidate_heads.remove(revision.NULL_REVISION)
-            if not candidate_heads:
-                return set([revision.NULL_REVISION])
         if len(candidate_heads) < 2:
             return candidate_heads
         searchers = dict((c, self._make_breadth_first_searcher([c]))
@@ -706,21 +239,7 @@
         # skip over the actual candidate for each searcher
         for searcher in active_searchers.itervalues():
             searcher.next()
-        # The common walker finds nodes that are common to two or more of the
-        # input keys, so that we don't access all history when a currently
-        # uncommon search point actually meets up with something behind a
-        # common search point. Common search points do not keep searches
-        # active; they just allow us to make searches inactive without
-        # accessing all history.
-        common_walker = self._make_breadth_first_searcher([])
         while len(active_searchers) > 0:
-            ancestors = set()
-            # advance searches
-            try:
-                common_walker.next()
-            except StopIteration:
-                # No common points being searched at this time.
-                pass
             for candidate in active_searchers.keys():
                 try:
                     searcher = active_searchers[candidate]
@@ -730,91 +249,30 @@
                     # a descendant of another candidate.
                     continue
                 try:
-                    ancestors.update(searcher.next())
+                    ancestors = searcher.next()
                 except StopIteration:
                     del active_searchers[candidate]
                     continue
-            # process found nodes
-            new_common = set()
-            for ancestor in ancestors:
-                if ancestor in candidate_heads:
-                    candidate_heads.remove(ancestor)
-                    del searchers[ancestor]
-                    if ancestor in active_searchers:
-                        del active_searchers[ancestor]
-                # it may meet up with a known common node
-                if ancestor in common_walker.seen:
-                    # some searcher has encountered our known common nodes:
-                    # just stop it
-                    ancestor_set = set([ancestor])
-                    for searcher in searchers.itervalues():
-                        searcher.stop_searching_any(ancestor_set)
-                else:
-                    # or it may have been just reached by all the searchers:
+                for ancestor in ancestors:
+                    if ancestor in candidate_heads:
+                        candidate_heads.remove(ancestor)
+                        del searchers[ancestor]
+                        if ancestor in active_searchers:
+                            del active_searchers[ancestor]
                     for searcher in searchers.itervalues():
                         if ancestor not in searcher.seen:
                             break
                     else:
-                        # The final active searcher has just reached this node,
-                        # making it be known as a descendant of all candidates,
-                        # so we can stop searching it, and any seen ancestors
-                        new_common.add(ancestor)
+                        # if this revision was seen by all searchers, then it
+                        # is a descendant of all candidates, so we can stop
+                        # searching it, and any seen ancestors
                         for searcher in searchers.itervalues():
                             seen_ancestors =\
-                                searcher.find_seen_ancestors([ancestor])
+                                searcher.find_seen_ancestors(ancestor)
                             searcher.stop_searching_any(seen_ancestors)
-            common_walker.start_searching(new_common)
         return candidate_heads
 
-    def find_merge_order(self, tip_revision_id, lca_revision_ids):
-        """Find the order that each revision was merged into tip.
-
-        This basically just walks backwards with a stack, and walks left-first
-        until it finds a node to stop.
-        """
-        if len(lca_revision_ids) == 1:
-            return list(lca_revision_ids)
-        looking_for = set(lca_revision_ids)
-        # TODO: Is there a way we could do this "faster" by batching up the
-        # get_parent_map requests?
-        # TODO: Should we also be culling the ancestry search right away? We
-        # could add looking_for to the "stop" list, and walk their
-        # ancestry in batched mode. The flip side is it might mean we walk a
-        # lot of "stop" nodes, rather than only the minimum.
-        # Then again, without it we may trace back into ancestry we could have
-        # stopped early.
-        stack = [tip_revision_id]
-        found = []
-        stop = set()
-        while stack and looking_for:
-            next = stack.pop()
-            stop.add(next)
-            if next in looking_for:
-                found.append(next)
-                looking_for.remove(next)
-                if len(looking_for) == 1:
-                    found.append(looking_for.pop())
-                    break
-                continue
-            parent_ids = self.get_parent_map([next]).get(next, None)
-            if not parent_ids: # Ghost, nothing to search here
-                continue
-            for parent_id in reversed(parent_ids):
-                # TODO: (performance) We see the parent at this point, but we
-                #       wait to mark it until later to make sure we get left
-                #       parents before right parents. However, instead of
-                #       waiting until we have traversed enough parents, we
-                #       could instead note that we've found it, and once all
-                #       parents are in the stack, just reverse iterate the
-                #       stack for them.
-                if parent_id not in stop:
-                    # this will need to be searched
-                    stack.append(parent_id)
-                stop.add(parent_id)
-        return found
-
-    def find_unique_lca(self, left_revision, right_revision,
-                        count_steps=False):
+    def find_unique_lca(self, left_revision, right_revision):
         """Find a unique LCA.
 
         Find lowest common ancestors.  If there is no unique  common
@@ -825,51 +283,16 @@
 
         Note that None is not an acceptable substitute for NULL_REVISION.
         in the input for this method.
-
-        :param count_steps: If True, the return value will be a tuple of
-            (unique_lca, steps) where steps is the number of times that
-            find_lca was run.  If False, only unique_lca is returned.
         """
         revisions = [left_revision, right_revision]
-        steps = 0
         while True:
-            steps += 1
             lca = self.find_lca(*revisions)
             if len(lca) == 1:
-                result = lca.pop()
-                if count_steps:
-                    return result, steps
-                else:
-                    return result
+                return lca.pop()
             if len(lca) == 0:
                 raise errors.NoCommonAncestor(left_revision, right_revision)
             revisions = lca
 
-    def iter_ancestry(self, revision_ids):
-        """Iterate the ancestry of this revision.
-
-        :param revision_ids: Nodes to start the search
-        :return: Yield tuples mapping a revision_id to its parents for the
-            ancestry of revision_id.
-            Ghosts will be returned with None as their parents, and nodes
-            with no parents will have NULL_REVISION as their only parent. (As
-            defined by get_parent_map.)
-            There will also be a node for (NULL_REVISION, ())
-        """
-        pending = set(revision_ids)
-        processed = set()
-        while pending:
-            processed.update(pending)
-            next_map = self.get_parent_map(pending)
-            next_pending = set()
-            for item in next_map.iteritems():
-                yield item
-                next_pending.update(p for p in item[1] if p not in processed)
-            ghosts = pending.difference(next_map)
-            for ghost in ghosts:
-                yield (ghost, None)
-            pending = next_pending
-
     def iter_topo_order(self, revisions):
         """Iterate through the input revisions in topological order.
 
@@ -877,206 +300,75 @@
         An ancestor may sort after a descendant if the relationship is not
         visible in the supplied list of revisions.
         """
-        sorter = tsort.TopoSorter(self.get_parent_map(revisions))
+        sorter = tsort.TopoSorter(zip(revisions, self.get_parents(revisions)))
         return sorter.iter_topo_order()
 
     def is_ancestor(self, candidate_ancestor, candidate_descendant):
         """Determine whether a revision is an ancestor of another.
 
-        We answer this using heads() as heads() has the logic to perform the
-        smallest number of parent lookups to determine the ancestral
-        relationship between N revisions.
-        """
-        return set([candidate_descendant]) == self.heads(
-            [candidate_ancestor, candidate_descendant])
-
-    def _search_for_extra_common(self, common, searchers):
-        """Make sure that unique nodes are genuinely unique.
-
-        After _find_border_ancestors, all nodes marked "common" are indeed
-        common. Some of the nodes considered unique are not, due to history
-        shortcuts stopping the searches early.
-
-        We know that we have searched enough when all common search tips are
-        descended from all unique (uncommon) nodes because we know that a node
-        cannot be an ancestor of its own ancestor.
-
-        :param common: A set of common nodes
-        :param searchers: The searchers returned from _find_border_ancestors
-        :return: None
-        """
-        # Basic algorithm...
-        #   A) The passed in searchers should all be on the same tips, thus
-        #      they should be considered the "common" searchers.
-        #   B) We find the difference between the searchers, these are the
-        #      "unique" nodes for each side.
-        #   C) We do a quick culling so that we only start searching from the
-        #      more interesting unique nodes. (A unique ancestor is more
-        #      interesting than any of its children.)
-        #   D) We start searching for ancestors common to all unique nodes.
-        #   E) We have the common searchers stop searching any ancestors of
-        #      nodes found by (D)
-        #   F) When there are no more common search tips, we stop
-
-        # TODO: We need a way to remove unique_searchers when they overlap with
-        #       other unique searchers.
-        if len(searchers) != 2:
-            raise NotImplementedError(
-                "Algorithm not yet implemented for > 2 searchers")
-        common_searchers = searchers
-        left_searcher = searchers[0]
-        right_searcher = searchers[1]
-        unique = left_searcher.seen.symmetric_difference(right_searcher.seen)
-        if not unique: # No unique nodes, nothing to do
-            return
-        total_unique = len(unique)
-        unique = self._remove_simple_descendants(unique,
-                    self.get_parent_map(unique))
-        simple_unique = len(unique)
-
-        unique_searchers = []
-        for revision_id in unique:
-            if revision_id in left_searcher.seen:
-                parent_searcher = left_searcher
-            else:
-                parent_searcher = right_searcher
-            revs_to_search = parent_searcher.find_seen_ancestors([revision_id])
-            if not revs_to_search: # XXX: This shouldn't be possible
-                revs_to_search = [revision_id]
-            searcher = self._make_breadth_first_searcher(revs_to_search)
-            # We don't care about the starting nodes.
-            searcher.step()
-            unique_searchers.append(searcher)
-
-        # possible todo: aggregate the common searchers into a single common
-        #   searcher, just make sure that we include the nodes into the .seen
-        #   properties of the original searchers
-
-        ancestor_all_unique = None
-        for searcher in unique_searchers:
-            if ancestor_all_unique is None:
-                ancestor_all_unique = set(searcher.seen)
-            else:
-                ancestor_all_unique = ancestor_all_unique.intersection(
-                                            searcher.seen)
-
-        trace.mutter('Started %s unique searchers for %s unique revisions',
-                     simple_unique, total_unique)
-
-        while True: # If we have no more nodes we have nothing to do
-            newly_seen_common = set()
-            for searcher in common_searchers:
-                newly_seen_common.update(searcher.step())
-            newly_seen_unique = set()
-            for searcher in unique_searchers:
-                newly_seen_unique.update(searcher.step())
-            new_common_unique = set()
-            for revision in newly_seen_unique:
-                for searcher in unique_searchers:
-                    if revision not in searcher.seen:
-                        break
-                else:
-                    # This is a border because it is a first common that we see
-                    # after walking for a while.
-                    new_common_unique.add(revision)
-            if newly_seen_common:
-                # These are nodes descended from one of the 'common' searchers.
-                # Make sure all searchers are on the same page
-                for searcher in common_searchers:
-                    newly_seen_common.update(
-                        searcher.find_seen_ancestors(newly_seen_common))
-                # We start searching the whole ancestry. It is a bit wasteful,
-                # though. We really just want to mark all of these nodes as
-                # 'seen' and then start just the tips. However, it requires a
-                # get_parent_map() call to figure out the tips anyway, and all
-                # redundant requests should be fairly fast.
-                for searcher in common_searchers:
-                    searcher.start_searching(newly_seen_common)
-
-                # If a 'common' node is an ancestor of all unique searchers, we
-                # can stop searching it.
-                stop_searching_common = ancestor_all_unique.intersection(
-                                            newly_seen_common)
-                if stop_searching_common:
-                    for searcher in common_searchers:
-                        searcher.stop_searching_any(stop_searching_common)
-            if new_common_unique:
-                # We found some ancestors that are common
-                for searcher in unique_searchers:
-                    new_common_unique.update(
-                        searcher.find_seen_ancestors(new_common_unique))
-                # Since these are common, we can grab another set of ancestors
-                # that we have seen
-                for searcher in common_searchers:
-                    new_common_unique.update(
-                        searcher.find_seen_ancestors(new_common_unique))
-
-                # We can tell all of the unique searchers to start at these
-                # nodes, and tell all of the common searchers to *stop*
-                # searching these nodes
-                for searcher in unique_searchers:
-                    searcher.start_searching(new_common_unique)
-                for searcher in common_searchers:
-                    searcher.stop_searching_any(new_common_unique)
-                ancestor_all_unique.update(new_common_unique)
-
-                # Filter out searchers that don't actually search different
-                # nodes. We already have the ancestry intersection for them
-                next_unique_searchers = []
-                unique_search_sets = set()
-                for searcher in unique_searchers:
-                    will_search_set = frozenset(searcher._next_query)
-                    if will_search_set not in unique_search_sets:
-                        # This searcher is searching a unique set of nodes, let it
-                        unique_search_sets.add(will_search_set)
-                        next_unique_searchers.append(searcher)
-                unique_searchers = next_unique_searchers
-            for searcher in common_searchers:
-                if searcher._next_query:
-                    break
-            else:
-                # All common searcher have stopped searching
-                return
-
-    def _remove_simple_descendants(self, revisions, parent_map):
-        """remove revisions which are children of other ones in the set
-
-        This doesn't do any graph searching, it just checks the immediate
-        parent_map to find if there are any children which can be removed.
-
-        :param revisions: A set of revision_ids
-        :return: A set of revision_ids with the children removed
-        """
-        simple_ancestors = revisions.copy()
-        # TODO: jam 20071214 we *could* restrict it to searching only the
-        #       parent_map of revisions already present in 'revisions', but
-        #       considering the general use case, I think this is actually
-        #       better.
-
-        # This is the same as the following loop. I don't know that it is any
-        # faster.
-        ## simple_ancestors.difference_update(r for r, p_ids in parent_map.iteritems()
-        ##     if p_ids is not None and revisions.intersection(p_ids))
-        ## return simple_ancestors
-
-        # Yet Another Way, invert the parent map (which can be cached)
-        ## descendants = {}
-        ## for revision_id, parent_ids in parent_map.iteritems():
-        ##   for p_id in parent_ids:
-        ##       descendants.setdefault(p_id, []).append(revision_id)
-        ## for revision in revisions.intersection(descendants):
-        ##   simple_ancestors.difference_update(descendants[revision])
-        ## return simple_ancestors
-        for revision, parent_ids in parent_map.iteritems():
-            if parent_ids is None:
-                continue
-            for parent_id in parent_ids:
-                if parent_id in revisions:
-                    # This node has a parent present in the set, so we can
-                    # remove it
-                    simple_ancestors.discard(revision)
-                    break
-        return simple_ancestors
+        There are two possible outcomes: True and False, but there are three
+        possible relationships:
+
+        a) candidate_ancestor is an ancestor of candidate_descendant
+        b) candidate_ancestor is an descendant of candidate_descendant
+        c) candidate_ancestor is an sibling of candidate_descendant
+
+        To check for a, we walk from candidate_descendant, looking for
+        candidate_ancestor.
+
+        To check for b, we walk from candidate_ancestor, looking for
+        candidate_descendant.
+
+        To make a and b more efficient, we can stop any searches that hit
+        common ancestors.
+
+        If we exhaust our searches, but neither a or b is true, then c is true.
+
+        In order to find c efficiently, we must avoid searching from
+        candidate_descendant or candidate_ancestor into common ancestors.  But
+        if we don't search common ancestors at all, we won't know if we hit
+        common ancestors.  So we have a walker for common ancestors.  Note that
+        its searches are not required to terminate in order to determine c to
+        be true.
+        """
+        ancestor_walker = self._make_breadth_first_searcher(
+            [candidate_ancestor])
+        descendant_walker = self._make_breadth_first_searcher(
+            [candidate_descendant])
+        common_walker = self._make_breadth_first_searcher([])
+        active_ancestor = True
+        active_descendant = True
+        while (active_ancestor or active_descendant):
+            new_common = set()
+            if active_descendant:
+                try:
+                    nodes = descendant_walker.next()
+                except StopIteration:
+                    active_descendant = False
+                else:
+                    if candidate_ancestor in nodes:
+                        return True
+                    new_common.update(nodes.intersection(ancestor_walker.seen))
+            if active_ancestor:
+                try:
+                    nodes = ancestor_walker.next()
+                except StopIteration:
+                    active_ancestor = False
+                else:
+                    if candidate_descendant in nodes:
+                        return False
+                    new_common.update(nodes.intersection(
+                        descendant_walker.seen))
+            try:
+                new_common.update(common_walker.next())
+            except StopIteration:
+                pass
+            for walker in (ancestor_walker, descendant_walker):
+                for node in new_common:
+                    c_ancestors = walker.find_seen_ancestors(node)
+                    walker.stop_searching_any(c_ancestors)
+                common_walker.start_searching(new_common)
+        return False
 
 
 class HeadsCache(object):
@@ -1107,38 +399,8 @@
             return set(heads)
 
 
-class FrozenHeadsCache(object):
-    """Cache heads() calls, assuming the caller won't modify them."""
-
-    def __init__(self, graph):
-        self.graph = graph
-        self._heads = {}
-
-    def heads(self, keys):
-        """Return the heads of keys.
-
-        Similar to Graph.heads(). The main difference is that the return value
-        is a frozen set which cannot be mutated.
-
-        :see also: Graph.heads.
-        :param keys: The keys to calculate heads for.
-        :return: A frozenset containing the heads.
-        """
-        keys = frozenset(keys)
-        try:
-            return self._heads[keys]
-        except KeyError:
-            heads = frozenset(self.graph.heads(keys))
-            self._heads[keys] = heads
-            return heads
-
-    def cache(self, keys, heads):
-        """Store a known value."""
-        self._heads[frozenset(keys)] = frozenset(heads)
-
-
 class _BreadthFirstSearcher(object):
-    """Parallel search breadth-first the ancestry of revisions.
+    """Parallel search the breadth-first the ancestry of revisions.
 
     This class implements the iterator protocol, but additionally
     1. provides a set of seen ancestors, and
@@ -1146,184 +408,50 @@
     """
 
     def __init__(self, revisions, parents_provider):
-        self._iterations = 0
-        self._next_query = set(revisions)
-        self.seen = set()
-        self._started_keys = set(self._next_query)
-        self._stopped_keys = set()
-        self._parents_provider = parents_provider
-        self._returning = 'next_with_ghosts'
-        self._current_present = set()
-        self._current_ghosts = set()
-        self._current_parents = {}
+        self._start = set(revisions)
+        self._search_revisions = None
+        self.seen = set(revisions)
+        self._parents_provider = parents_provider 
 
     def __repr__(self):
-        if self._iterations:
-            prefix = "searching"
-        else:
-            prefix = "starting"
-        search = '%s=%r' % (prefix, list(self._next_query))
-        return ('_BreadthFirstSearcher(iterations=%d, %s,'
-                ' seen=%r)' % (self._iterations, search, list(self.seen)))
-
-    def get_result(self):
-        """Get a SearchResult for the current state of this searcher.
-        
-        :return: A SearchResult for this search so far. The SearchResult is
-            static - the search can be advanced and the search result will not
-            be invalidated or altered.
-        """
-        if self._returning == 'next':
-            # We have to know the current nodes children to be able to list the
-            # exclude keys for them. However, while we could have a second
-            # look-ahead result buffer and shuffle things around, this method
-            # is typically only called once per search - when memoising the
-            # results of the search. 
-            found, ghosts, next, parents = self._do_query(self._next_query)
-            # pretend we didn't query: perhaps we should tweak _do_query to be
-            # entirely stateless?
-            self.seen.difference_update(next)
-            next_query = next.union(ghosts)
-        else:
-            next_query = self._next_query
-        excludes = self._stopped_keys.union(next_query)
-        included_keys = self.seen.difference(excludes)
-        return SearchResult(self._started_keys, excludes, len(included_keys),
-            included_keys)
-
-    def step(self):
-        try:
-            return self.next()
-        except StopIteration:
-            return ()
+        return ('_BreadthFirstSearcher(self._search_revisions=%r,'
+                ' self.seen=%r)' % (self._search_revisions, self.seen))
 
     def next(self):
         """Return the next ancestors of this revision.
 
         Ancestors are returned in the order they are seen in a breadth-first
-        traversal.  No ancestor will be returned more than once. Ancestors are
-        returned before their parentage is queried, so ghosts and missing
-        revisions (including the start revisions) are included in the result.
-        This can save a round trip in LCA style calculation by allowing
-        convergence to be detected without reading the data for the revision
-        the convergence occurs on.
-
-        :return: A set of revision_ids.
+        traversal.  No ancestor will be returned more than once.
         """
-        if self._returning != 'next':
-            # switch to returning the query, not the results.
-            self._returning = 'next'
-            self._iterations += 1
+        if self._search_revisions is None:
+            self._search_revisions = self._start
         else:
-            self._advance()
-        if len(self._next_query) == 0:
-            raise StopIteration()
-        # We have seen what we're querying at this point as we are returning
-        # the query, not the results.
-        self.seen.update(self._next_query)
-        return self._next_query
-
-    def next_with_ghosts(self):
-        """Return the next found ancestors, with ghosts split out.
-        
-        Ancestors are returned in the order they are seen in a breadth-first
-        traversal.  No ancestor will be returned more than once. Ancestors are
-        returned only after asking for their parents, which allows us to detect
-        which revisions are ghosts and which are not.
-
-        :return: A tuple with (present ancestors, ghost ancestors) sets.
-        """
-        if self._returning != 'next_with_ghosts':
-            # switch to returning the results, not the current query.
-            self._returning = 'next_with_ghosts'
-            self._advance()
-        if len(self._next_query) == 0:
-            raise StopIteration()
-        self._advance()
-        return self._current_present, self._current_ghosts
-
-    def _advance(self):
-        """Advance the search.
-
-        Updates self.seen, self._next_query, self._current_present,
-        self._current_ghosts, self._current_parents and self._iterations.
-        """
-        self._iterations += 1
-        found, ghosts, next, parents = self._do_query(self._next_query)
-        self._current_present = found
-        self._current_ghosts = ghosts
-        self._next_query = next
-        self._current_parents = parents
-        # ghosts are implicit stop points, otherwise the search cannot be
-        # repeated when ghosts are filled.
-        self._stopped_keys.update(ghosts)
-
-    def _do_query(self, revisions):
-        """Query for revisions.
-
-        Adds revisions to the seen set.
-
-        :param revisions: Revisions to query.
-        :return: A tuple: (set(found_revisions), set(ghost_revisions),
-           set(parents_of_found_revisions), dict(found_revisions:parents)).
-        """
-        found_revisions = set()
-        parents_of_found = set()
-        # revisions may contain nodes that point to other nodes in revisions:
-        # we want to filter them out.
-        self.seen.update(revisions)
-        parent_map = self._parents_provider.get_parent_map(revisions)
-        found_revisions.update(parent_map)
-        for rev_id, parents in parent_map.iteritems():
-            if parents is None:
-                continue
-            new_found_parents = [p for p in parents if p not in self.seen]
-            if new_found_parents:
-                # Calling set.update() with an empty generator is actually
-                # rather expensive.
-                parents_of_found.update(new_found_parents)
-        ghost_revisions = revisions - found_revisions
-        return found_revisions, ghost_revisions, parents_of_found, parent_map
+            new_search_revisions = set()
+            for parents in self._parents_provider.get_parents(
+                self._search_revisions):
+                if parents is None:
+                    continue
+                new_search_revisions.update(p for p in parents if
+                                            p not in self.seen)
+            self._search_revisions = new_search_revisions
+        if len(self._search_revisions) == 0:
+            raise StopIteration()
+        self.seen.update(self._search_revisions)
+        return self._search_revisions
 
     def __iter__(self):
         return self
 
-    def find_seen_ancestors(self, revisions):
-        """Find ancestors of these revisions that have already been seen.
-        
-        This function generally makes the assumption that querying for the
-        parents of a node that has already been queried is reasonably cheap.
-        (eg, not a round trip to a remote host).
-        """
-        # TODO: Often we might ask one searcher for its seen ancestors, and
-        #       then ask another searcher the same question. This can result in
-        #       searching the same revisions repeatedly if the two searchers
-        #       have a lot of overlap.
-        all_seen = self.seen
-        pending = set(revisions).intersection(all_seen)
-        seen_ancestors = set(pending)
-
-        if self._returning == 'next':
-            # self.seen contains what nodes have been returned, not what nodes
-            # have been queried. We don't want to probe for nodes that haven't
-            # been searched yet.
-            not_searched_yet = self._next_query
-        else:
-            not_searched_yet = ()
-        pending.difference_update(not_searched_yet)
-        get_parent_map = self._parents_provider.get_parent_map
-        while pending:
-            parent_map = get_parent_map(pending)
-            all_parents = []
-            # We don't care if it is a ghost, since it can't be seen if it is
-            # a ghost
-            for parent_ids in parent_map.itervalues():
-                all_parents.extend(parent_ids)
-            next_pending = all_seen.intersection(all_parents).difference(seen_ancestors)
-            seen_ancestors.update(next_pending)
-            next_pending.difference_update(not_searched_yet)
-            pending = next_pending
-
+    def find_seen_ancestors(self, revision):
+        """Find ancestors of this revision that have already been seen."""
+        searcher = _BreadthFirstSearcher([revision], self._parents_provider)
+        seen_ancestors = set()
+        for ancestors in searcher:
+            for ancestor in ancestors:
+                if ancestor not in self.seen:
+                    searcher.stop_searching_any([ancestor])
+                else:
+                    seen_ancestors.add(ancestor)
         return seen_ancestors
 
     def stop_searching_any(self, revisions):
@@ -1333,188 +461,13 @@
         None of the specified revisions are required to be present in the
         search list.  In this case, the call is a no-op.
         """
-        # TODO: does this help performance?
-        # if not revisions:
-        #     return set()
-        revisions = frozenset(revisions)
-        if self._returning == 'next':
-            stopped = self._next_query.intersection(revisions)
-            self._next_query = self._next_query.difference(revisions)
-        else:
-            stopped_present = self._current_present.intersection(revisions)
-            stopped = stopped_present.union(
-                self._current_ghosts.intersection(revisions))
-            self._current_present.difference_update(stopped)
-            self._current_ghosts.difference_update(stopped)
-            # stopping 'x' should stop returning parents of 'x', but 
-            # not if 'y' always references those same parents
-            stop_rev_references = {}
-            for rev in stopped_present:
-                for parent_id in self._current_parents[rev]:
-                    if parent_id not in stop_rev_references:
-                        stop_rev_references[parent_id] = 0
-                    stop_rev_references[parent_id] += 1
-            # if only the stopped revisions reference it, the ref count will be
-            # 0 after this loop
-            for parents in self._current_parents.itervalues():
-                for parent_id in parents:
-                    try:
-                        stop_rev_references[parent_id] -= 1
-                    except KeyError:
-                        pass
-            stop_parents = set()
-            for rev_id, refs in stop_rev_references.iteritems():
-                if refs == 0:
-                    stop_parents.add(rev_id)
-            self._next_query.difference_update(stop_parents)
-        self._stopped_keys.update(stopped)
+        stopped = self._search_revisions.intersection(revisions)
+        self._search_revisions = self._search_revisions.difference(revisions)
         return stopped
 
     def start_searching(self, revisions):
-        """Add revisions to the search.
-
-        The parents of revisions will be returned from the next call to next()
-        or next_with_ghosts(). If next_with_ghosts was the most recently used
-        next* call then the return value is the result of looking up the
-        ghost/not ghost status of revisions. (A tuple (present, ghosted)).
-        """
-        revisions = frozenset(revisions)
-        self._started_keys.update(revisions)
-        new_revisions = revisions.difference(self.seen)
-        if self._returning == 'next':
-            self._next_query.update(new_revisions)
-            self.seen.update(new_revisions)
+        if self._search_revisions is None:
+            self._start = set(revisions)
         else:
-            # perform a query on revisions
-            revs, ghosts, query, parents = self._do_query(revisions)
-            self._stopped_keys.update(ghosts)
-            self._current_present.update(revs)
-            self._current_ghosts.update(ghosts)
-            self._next_query.update(query)
-            self._current_parents.update(parents)
-            return revs, ghosts
-
-
-class SearchResult(object):
-    """The result of a breadth first search.
-
-    A SearchResult provides the ability to reconstruct the search or access a
-    set of the keys the search found.
-    """
-
-    def __init__(self, start_keys, exclude_keys, key_count, keys):
-        """Create a SearchResult.
-
-        :param start_keys: The keys the search started at.
-        :param exclude_keys: The keys the search excludes.
-        :param key_count: The total number of keys (from start to but not
-            including exclude).
-        :param keys: The keys the search found. Note that in future we may get
-            a SearchResult from a smart server, in which case the keys list is
-            not necessarily immediately available.
-        """
-        self._recipe = (start_keys, exclude_keys, key_count)
-        self._keys = frozenset(keys)
-
-    def get_recipe(self):
-        """Return a recipe that can be used to replay this search.
-        
-        The recipe allows reconstruction of the same results at a later date
-        without knowing all the found keys. The essential elements are a list
-        of keys to start and and to stop at. In order to give reproducible
-        results when ghosts are encountered by a search they are automatically
-        added to the exclude list (or else ghost filling may alter the
-        results).
-
-        :return: A tuple (start_keys_set, exclude_keys_set, revision_count). To
-            recreate the results of this search, create a breadth first
-            searcher on the same graph starting at start_keys. Then call next()
-            (or next_with_ghosts()) repeatedly, and on every result, call
-            stop_searching_any on any keys from the exclude_keys set. The
-            revision_count value acts as a trivial cross-check - the found
-            revisions of the new search should have as many elements as
-            revision_count. If it does not, then additional revisions have been
-            ghosted since the search was executed the first time and the second
-            time.
-        """
-        return self._recipe
-
-    def get_keys(self):
-        """Return the keys found in this search.
-
-        :return: A set of keys.
-        """
-        return self._keys
-
-
-def collapse_linear_regions(parent_map):
-    """Collapse regions of the graph that are 'linear'.
-
-    For example::
-
-      A:[B], B:[C]
-
-    can be collapsed by removing B and getting::
-
-      A:[C]
-
-    :param parent_map: A dictionary mapping children to their parents
-    :return: Another dictionary with 'linear' chains collapsed
-    """
-    # Note: this isn't a strictly minimal collapse. For example:
-    #   A
-    #  / \
-    # B   C
-    #  \ /
-    #   D
-    #   |
-    #   E
-    # Will not have 'D' removed, even though 'E' could fit. Also:
-    #   A
-    #   |    A
-    #   B => |
-    #   |    C
-    #   C
-    # A and C are both kept because they are edges of the graph. We *could* get
-    # rid of A if we wanted.
-    #   A
-    #  / \
-    # B   C
-    # |   |
-    # D   E
-    #  \ /
-    #   F
-    # Will not have any nodes removed, even though you do have an
-    # 'uninteresting' linear D->B and E->C
-    children = {}
-    for child, parents in parent_map.iteritems():
-        children.setdefault(child, [])
-        for p in parents:
-            children.setdefault(p, []).append(child)
-
-    orig_children = dict(children)
-    removed = set()
-    result = dict(parent_map)
-    for node in parent_map:
-        parents = result[node]
-        if len(parents) == 1:
-            parent_children = children[parents[0]]
-            if len(parent_children) != 1:
-                # This is not the only child
-                continue
-            node_children = children[node]
-            if len(node_children) != 1:
-                continue
-            child_parents = result.get(node_children[0], None)
-            if len(child_parents) != 1:
-                # This is not its only parent
-                continue
-            # The child of this node only points at it, and the parent only has
-            # this as a child. remove this node, and join the others together
-            result[node_children[0]] = parents
-            children[parents[0]] = node_children
-            del result[node]
-            del children[node]
-            removed.add(node)
-
-    return result
+            self._search_revisions.update(revisions.difference(self.seen))
+        self.seen.update(revisions)

=== modified file 'bzrlib/hashcache.py'
--- bzrlib/hashcache.py	2008-04-24 07:22:53 +0000
+++ bzrlib/hashcache.py	2007-02-26 01:06:36 +0000
@@ -210,6 +210,7 @@
             outf.write(CACHE_HEADER)
 
             for path, c  in self._cache.iteritems():
+                assert '//' not in path, path
                 line_info = [path.encode('utf-8'), '// ', c[0], ' ']
                 line_info.append(' '.join([str(fld) for fld in c[1]]))
                 line_info.append('\n')

=== modified file 'bzrlib/help.py'
--- bzrlib/help.py	2008-05-02 07:31:24 +0000
+++ bzrlib/help.py	2007-08-28 23:43:50 +0000
@@ -65,6 +65,11 @@
     outfile.write(_help_commands_to_text('commands'))
 
 
+@symbol_versioning.deprecated_function(symbol_versioning.zero_sixteen)
+def command_usage(cmd):
+    return cmd._usage()
+
+
 def _help_commands_to_text(topic):
     """Generate the help text for the list of commands"""
     out = []

=== removed directory 'bzrlib/help_topics'
=== renamed file 'bzrlib/help_topics/__init__.py' => 'bzrlib/help_topics.py'
--- bzrlib/help_topics/__init__.py	2008-07-13 07:29:40 +0000
+++ bzrlib/help_topics.py	2007-10-18 10:33:11 +0000
@@ -33,13 +33,7 @@
 rendering on the screen naturally.
 """
 
-import sys
-
-import bzrlib
-from bzrlib import (
-    osutils,
-    registry,
-    )
+from bzrlib import registry
 
 
 # Section identifiers (map topics to the right place in the manual)
@@ -134,15 +128,6 @@
     return ''.join(out)
 
 
-def _load_from_file(topic_name):
-    """Load help from a file.
-
-    Topics are expected to be txt files in bzrlib.help_topics.
-    """
-    resource_name = osutils.pathjoin("en", "%s.txt" % (topic_name,))
-    return osutils.resource_string('bzrlib.help_topics', resource_name)
-
-
 def _help_on_revisionspec(name):
     """Generate the help for revision specs."""
     import re
@@ -271,27 +256,21 @@
                "callgrind.out" or end with ".callgrind", the output will be
                formatted for use with KCacheGrind. Otherwise, the output
                will be a pickle.
---coverage     Generate line coverage report in the specified directory.
 
 See doc/developers/profiling.txt for more information on profiling.
 A number of debug flags are also available to assist troubleshooting and
 development.
 
--Dauth            Trace authentication sections used.
--Derror           Instead of normal error handling, always print a traceback
-                  on error.
--Devil            Capture call sites that do expensive or badly-scaling
-                  operations.
--Dfetch           Trace history copying between repositories.
--Dhashcache       Log every time a working file is read to determine its hash.
--Dhooks           Trace hook execution.
--Dhpss            Trace smart protocol requests and responses.
--Dhttp            Trace http connections, requests and responses
--Dindex           Trace major index operations.
--Dknit            Trace knit operations.
--Dlock            Trace when lockdir locks are taken or released.
--Dmerge           Emit information for debugging merges.
--Dpack            Emit information about pack operations.
+-Dauth         Trace authentication sections used.
+-Derror        Instead of normal error handling, always print a traceback on
+               error.
+-Devil         Capture call sites that do expensive or badly-scaling
+               operations.
+-Dhashcache    Log every time a working file is read to determine its hash.
+-Dhooks        Trace hook execution.
+-Dhpss         Trace smart protocol requests and responses.
+-Dindex        Trace major index operations.
+-Dlock         Trace when lockdir locks are taken or released.
 """
 
 _standard_options = \
@@ -349,10 +328,10 @@
 Lightweight checkouts work best when you have fast reliable access to the
 master branch. This means that if the master branch is on the same disk or LAN
 a lightweight checkout will be faster than a heavyweight one for any commands
-that modify the revision history (as only one copy of the branch needs to
-be updated). Heavyweight checkouts will generally be faster for any command
-that uses the history but does not change it, but if the master branch is on
-the same disk then there won't be a noticeable difference.
+that modify the revision history (as only one copy branch needs to be updated).
+Heavyweight checkouts will generally be faster for any command that uses the
+history but does not change it, but if the master branch is on the same disk
+then there wont be a noticeable difference.
 
 Another possible use for a checkout is to use it with a treeless repository
 containing your branches, where you maintain only one working tree by
@@ -480,7 +459,7 @@
 
 Related commands::
 
-  init    Change a directory into a versioned branch.
+  init    Make a directory into a versioned branch.
   branch  Create a new copy of a branch.
   merge   Perform a three-way merge.
 """
@@ -544,10 +523,6 @@
 BZR_PLUGIN_PATH  Paths where bzr should look for plugins.
 BZR_HOME         Directory holding .bazaar config dir. Overrides HOME.
 BZR_HOME (Win32) Directory holding bazaar config dir. Overrides APPDATA and HOME.
-BZR_REMOTE_PATH  Full name of remote 'bzr' command (for bzr+ssh:// URLs).
-BZR_SSH          SSH client: paramiko (default), openssh, ssh, plink.
-BZR_LOG          Location of .bzr.log (use '/dev/null' to suppress log).
-BZR_LOG (Win32)  Location of .bzr.log (use 'NUL' to suppress log).
 ================ =================================================================
 """
 
@@ -573,57 +548,6 @@
   log10 = log --short -r -10..-1
 """
 
-_criss_cross = \
-"""Criss-Cross
-
-A criss-cross in the branch history can cause the default merge technique
-to emit more conflicts than would normally be expected.
-
-In complex merge cases, ``bzr merge --lca`` or ``bzr merge --weave`` may give
-better results.  You may wish to ``bzr revert`` the working tree and merge
-again.  Alternatively, use ``bzr remerge`` on particular conflicted files.
-
-Criss-crosses occur in a branch's history if two branches merge the same thing
-and then merge one another, or if two branches merge one another at the same
-time.  They can be avoided by having each branch only merge from or into a
-designated central branch (a "star topology").
-
-Criss-crosses cause problems because of the way merge works.  Bazaar's default
-merge is a three-way merger; in order to merge OTHER into THIS, it must
-find a basis for comparison, BASE.  Using BASE, it can determine whether
-differences between THIS and OTHER are due to one side adding lines, or
-from another side removing lines.
-
-Criss-crosses mean there is no good choice for a base.  Selecting the recent
-merge points could cause one side's changes to be silently discarded.
-Selecting older merge points (which Bazaar does) mean that extra conflicts
-are emitted.
-
-The ``weave`` merge type is not affected by this problem because it uses
-line-origin detection instead of a basis revision to determine the cause of
-differences.
-"""
-
-_branches_out_of_sync = """Branches out of sync
-
-When reconfiguring a checkout, tree or branch into a lightweight checkout,
-a local branch must be destroyed.  (For checkouts, this is the local branch
-that serves primarily as a cache.)  If the branch-to-be-destroyed does not
-have the same last revision as the new reference branch for the lightweight
-checkout, data could be lost, so Bazaar refuses.
-
-How you deal with this depends on *why* the branches are out of sync.
-
-If you have a checkout and have done local commits, you can get back in sync
-by running "bzr update" (and possibly "bzr commit").
-
-If you have a branch and the remote branch is out-of-date, you can push
-the local changes using "bzr push".  If the local branch is out of date, you
-can do "bzr pull".  If both branches have had changes, you can merge, commit
-and then push your changes.  If you decide that some of the changes aren't
-useful, you can "push --overwrite" or "pull --overwrite" instead.
-"""
-
 
 # Register help topics
 topic_registry.register("revisionspec", _help_on_revisionspec,
@@ -644,24 +568,13 @@
                         "Help on status flags")
 def get_bugs_topic(topic):
     from bzrlib import bugtracker
-    return ("Bug Tracker Settings\n\n" + 
-        bugtracker.tracker_registry.help_topic(topic))
-topic_registry.register('bugs', get_bugs_topic, 'Bug tracker settings')
+    return "Bug Trackers\n\n" + bugtracker.tracker_registry.help_topic(topic)
+topic_registry.register('bugs', get_bugs_topic, 'Bug tracker support')
 topic_registry.register('env-variables', _env_variables,
                         'Environment variable names and values')
 topic_registry.register('files', _files,
                         'Information on configuration and log files')
 
-# Load some of the help topics from files
-topic_registry.register('authentication', _load_from_file,
-                        'Information on configuring authentication')
-topic_registry.register('configuration', _load_from_file,
-                        'Details on the configuration settings available')
-topic_registry.register('conflicts', _load_from_file,
-                        'Types of conflicts and what to do about them')
-topic_registry.register('hooks', _load_from_file,
-                        'Points at which custom processing can be added')
-
 
 # Register concept topics.
 # Note that we might choose to remove these from the online help in the
@@ -671,24 +584,14 @@
                         'Information on what a branch is', SECT_CONCEPT)
 topic_registry.register('checkouts', _checkouts,
                         'Information on what a checkout is', SECT_CONCEPT)
-topic_registry.register('patterns', _load_from_file,
-                        'Information on the pattern syntax',
-                        SECT_CONCEPT)
 topic_registry.register('repositories', _repositories,
                         'Basic information on shared repositories.',
                         SECT_CONCEPT)
-topic_registry.register('rules', _load_from_file,
-                        'Information on defining rule-based preferences',
-                        SECT_CONCEPT)
 topic_registry.register('standalone-trees', _standalone_trees,
                         'Information on what a standalone tree is',
                         SECT_CONCEPT)
 topic_registry.register('working-trees', _working_trees,
                         'Information on working trees', SECT_CONCEPT)
-topic_registry.register('criss-cross', _criss_cross,
-                        'Information on criss-cross merging', SECT_CONCEPT)
-topic_registry.register('sync-for-reconfigure', _branches_out_of_sync,
-                        'Information on criss-cross merging', SECT_CONCEPT)
 
 
 class HelpTopicIndex(object):

=== removed directory 'bzrlib/help_topics/en'
=== removed file 'bzrlib/help_topics/en/patterns.txt'
--- bzrlib/help_topics/en/patterns.txt	2008-06-25 07:17:14 +0000
+++ bzrlib/help_topics/en/patterns.txt	1970-01-01 00:00:00 +0000
@@ -1,25 +0,0 @@
-Patterns
-========
-
-Bazaar uses patterns to match files at various times. For example,
-the ``add`` command skips over files that match ignore patterns
-and preferences can be associated with files using rule patterns.
-The pattern syntax is described below.
-
-Trailing slashes on patterns are ignored. If the pattern contains a
-slash or is a regular expression, it is compared to the whole path
-from the branch root. Otherwise, it is compared to only the last
-component of the path. To match a file only in the root directory,
-prepend './'. Patterns specifying absolute paths are not allowed.
-
-Patterns may include globbing wildcards such as::
-
-  ? - Matches any single character except '/'
-  * - Matches 0 or more characters except '/'
-  /**/ - Matches 0 or more directories in a path
-  [a-z] - Matches a single character from within a group of characters
-
-Patterns may also be Python regular expressions. Regular expression
-patterns are identified by a 'RE:' prefix followed by the regular
-expression.  Regular expression patterns may not include named or
-numbered groups.

=== removed file 'bzrlib/help_topics/en/rules.txt'
--- bzrlib/help_topics/en/rules.txt	2008-08-14 17:25:43 +0000
+++ bzrlib/help_topics/en/rules.txt	1970-01-01 00:00:00 +0000
@@ -1,36 +0,0 @@
-Rules
-=====
-
-Introduction
-------------
-
-Rules are defined in ini file format where the sections are file glob
-patterns and the contents of each section are the preferences for files
-matching that pattern. For example::
-
-    [name *.bat]
-    eol = dos
-
-    [name *.html]
-    keywords = escape
-
-Preferences like these are useful for commands and plugins wishing to
-provide custom behaviour for selected files in selected branches.
-
-
-Files
------
-
-Default rules for all branches are defined in the optional file
-``BZR_HOME/rules``. 
-
-Rule Patterns
--------------
-
-Patterns are ordered and searching stops as soon as one matches.
-As a consequence, more explicit patterns should be placed towards
-the top of the file. Rule patterns use exactly the same conventions
-as ignore patterns. See ``bzr help patterns`` for details.
-
-Note: Patterns containing square brackets should be surrounded in
-quotes to ensure they are corrected parsed.

=== modified file 'bzrlib/hooks.py'
--- bzrlib/hooks.py	2008-04-30 13:21:37 +0000
+++ bzrlib/hooks.py	2007-06-28 06:32:03 +0000
@@ -17,7 +17,6 @@
 
 """Support for plugin hooking logic."""
 from bzrlib.lazy_import import lazy_import
-from bzrlib.symbol_versioning import deprecated_method, one_five
 lazy_import(globals(), """
 from bzrlib import (
         errors,
@@ -46,7 +45,6 @@
         """
         return self._callable_names.get(a_callable, "No hook name")
 
-    @deprecated_method(one_five)
     def install_hook(self, hook_name, a_callable):
         """Install a_callable in to the hook hook_name.
 
@@ -56,25 +54,10 @@
             The exact signature will depend on the hook - see the __init__ 
             method of BranchHooks for details on each hook.
         """
-        self.install_named_hook(hook_name, a_callable, None)
-
-    def install_named_hook(self, hook_name, a_callable, name):
-        """Install a_callable in to the hook hook_name, and label it name.
-
-        :param hook_name: A hook name. See the __init__ method of BranchHooks
-            for the complete list of hooks.
-        :param a_callable: The callable to be invoked when the hook triggers.
-            The exact signature will depend on the hook - see the __init__ 
-            method of BranchHooks for details on each hook.
-        :param name: A name to associate a_callable with, to show users what is
-            running.
-        """
         try:
             self[hook_name].append(a_callable)
         except KeyError:
             raise errors.UnknownHook(self.__class__.__name__, hook_name)
-        if name is not None:
-            self.name_hook(a_callable, name)
 
     def name_hook(self, a_callable, name):
         """Associate name with a_callable to show users what is running."""

=== modified file 'bzrlib/ignores.py'
--- bzrlib/ignores.py	2008-07-08 16:34:56 +0000
+++ bzrlib/ignores.py	2007-03-07 14:49:00 +0000
@@ -18,9 +18,7 @@
 
 import errno
 
-import bzrlib
 from bzrlib import (
-    atomicfile,
     config,
     globbing,
     )
@@ -207,38 +205,3 @@
 def get_runtime_ignores():
     """Get the current set of runtime ignores."""
     return _runtime_ignores
-
-
-def tree_ignores_add_patterns(tree, name_pattern_list):
-    """Retrieve a list of ignores from the ignore file in a tree.
-
-    :param tree: Tree to retrieve the ignore list from.
-    :return: 
-    """
-    ifn = tree.abspath(bzrlib.IGNORE_FILENAME)
-    if tree.has_filename(ifn):
-        f = open(ifn, 'rt')
-        try:
-            igns = f.read().decode('utf-8')
-        finally:
-            f.close()
-    else:
-        igns = ""
-
-    # TODO: If the file already uses crlf-style termination, maybe
-    # we should use that for the newly added lines?
-
-    if igns and igns[-1] != '\n':
-        igns += '\n'
-    for name_pattern in name_pattern_list:
-        igns += name_pattern + '\n'
-
-    f = atomicfile.AtomicFile(ifn, 'wb')
-    try:
-        f.write(igns.encode('utf-8'))
-        f.commit()
-    finally:
-        f.close()
-
-    if not tree.path2id('.bzrignore'):
-        tree.add(['.bzrignore'])

=== modified file 'bzrlib/index.py'
--- bzrlib/index.py	2008-09-03 22:30:56 +0000
+++ bzrlib/index.py	2007-10-18 01:12:22 +0000
@@ -32,16 +32,10 @@
 lazy_import(globals(), """
 from bzrlib import trace
 from bzrlib.bisect_multi import bisect_multi_bytes
-from bzrlib.revision import NULL_REVISION
 from bzrlib.trace import mutter
 """)
-from bzrlib import (
-    debug,
-    errors,
-    symbol_versioning,
-    )
+from bzrlib import debug, errors
 
-_HEADER_READV = (0, 200)
 _OPTION_KEY_ELEMENTS = "key_elements="
 _OPTION_LEN = "len="
 _OPTION_NODE_REFS = "node_ref_lists="
@@ -80,9 +74,8 @@
         """
         self.reference_lists = reference_lists
         self._keys = set()
-        # A dict of {key: (absent, ref_lists, value)}
         self._nodes = {}
-        self._nodes_by_key = None
+        self._nodes_by_key = {}
         self._key_length = key_elements
 
     def _check_key(self, key):
@@ -95,61 +88,16 @@
             if not element or _whitespace_re.search(element) is not None:
                 raise errors.BadIndexKey(element)
 
-    def _get_nodes_by_key(self):
-        if self._nodes_by_key is None:
-            nodes_by_key = {}
-            if self.reference_lists:
-                for key, (absent, references, value) in self._nodes.iteritems():
-                    if absent:
-                        continue
-                    key_dict = nodes_by_key
-                    for subkey in key[:-1]:
-                        key_dict = key_dict.setdefault(subkey, {})
-                    key_dict[key[-1]] = key, value, references
-            else:
-                for key, (absent, references, value) in self._nodes.iteritems():
-                    if absent:
-                        continue
-                    key_dict = nodes_by_key
-                    for subkey in key[:-1]:
-                        key_dict = key_dict.setdefault(subkey, {})
-                    key_dict[key[-1]] = key, value
-            self._nodes_by_key = nodes_by_key
-        return self._nodes_by_key
-
-    def _update_nodes_by_key(self, key, value, node_refs):
-        """Update the _nodes_by_key dict with a new key.
-
-        For a key of (foo, bar, baz) create
-        _nodes_by_key[foo][bar][baz] = key_value
-        """
-        if self._nodes_by_key is None:
-            return
-        key_dict = self._nodes_by_key
-        if self.reference_lists:
-            key_value = key, value, node_refs
-        else:
-            key_value = key, value
-        for subkey in key[:-1]:
-            key_dict = key_dict.setdefault(subkey, {})
-        key_dict[key[-1]] = key_value
-
-    def _check_key_ref_value(self, key, references, value):
-        """Check that 'key' and 'references' are all valid.
-
-        :param key: A key tuple. Must conform to the key interface (be a tuple,
-            be of the right length, not have any whitespace or nulls in any key
-            element.)
-        :param references: An iterable of reference lists. Something like
-            [[(ref, key)], [(ref, key), (other, key)]]
-        :param value: The value associate with this key. Must not contain
-            newlines or null characters.
-        :return: (node_refs, absent_references)
-            node_refs   basically a packed form of 'references' where all
-                        iterables are tuples
-            absent_references   reference keys that are not in self._nodes.
-                                This may contain duplicates if the same key is
-                                referenced in multiple lists.
+    def add_node(self, key, value, references=()):
+        """Add a node to the index.
+
+        :param key: The key. keys are non-empty tuples containing
+            as many whitespace-free utf8 bytestrings as the key length
+            defined for this index.
+        :param references: An iterable of iterables of keys. Each is a
+            reference to another key.
+        :param value: The value to associate with the key. It may be any
+            bytes as long as it does not contain \0 or \n.
         """
         self._check_key(key)
         if _newline_null_re.search(value) is not None:
@@ -157,40 +105,29 @@
         if len(references) != self.reference_lists:
             raise errors.BadIndexValue(references)
         node_refs = []
-        absent_references = []
         for reference_list in references:
             for reference in reference_list:
-                # If reference *is* in self._nodes, then we know it has already
-                # been checked.
+                self._check_key(reference)
                 if reference not in self._nodes:
-                    self._check_key(reference)
-                    absent_references.append(reference)
+                    self._nodes[reference] = ('a', (), '')
             node_refs.append(tuple(reference_list))
-        return tuple(node_refs), absent_references
-
-    def add_node(self, key, value, references=()):
-        """Add a node to the index.
-
-        :param key: The key. keys are non-empty tuples containing
-            as many whitespace-free utf8 bytestrings as the key length
-            defined for this index.
-        :param references: An iterable of iterables of keys. Each is a
-            reference to another key.
-        :param value: The value to associate with the key. It may be any
-            bytes as long as it does not contain \0 or \n.
-        """
-        (node_refs,
-         absent_references) = self._check_key_ref_value(key, references, value)
-        if key in self._nodes and self._nodes[key][0] != 'a':
+        if key in self._nodes and self._nodes[key][0] == '':
             raise errors.BadIndexDuplicateKey(key, self)
-        for reference in absent_references:
-            # There may be duplicates, but I don't think it is worth worrying
-            # about
-            self._nodes[reference] = ('a', (), '')
-        self._nodes[key] = ('', node_refs, value)
+        self._nodes[key] = ('', tuple(node_refs), value)
         self._keys.add(key)
-        if self._nodes_by_key is not None and self._key_length > 1:
-            self._update_nodes_by_key(key, value, node_refs)
+        if self._key_length > 1:
+            key_dict = self._nodes_by_key
+            if self.reference_lists:
+                key_value = key, value, tuple(node_refs)
+            else:
+                key_value = key, value
+            # possibly should do this on-demand, but it seems likely it is 
+            # always wanted
+            # For a key of (foo, bar, baz) create
+            # _nodes_by_key[foo][bar][baz] = key_value
+            for subkey in key[:-1]:
+                key_dict = key_dict.setdefault(subkey, {})
+            key_dict[key[-1]] = key_value
 
     def finish(self):
         lines = [_SIGNATURE]
@@ -199,7 +136,7 @@
         lines.append(_OPTION_LEN + str(len(self._keys)) + '\n')
         prefix_length = sum(len(x) for x in lines)
         # references are byte offsets. To avoid having to do nasty
-        # polynomial work to resolve offsets (references to later in the
+        # polynomial work to resolve offsets (references to later in the 
         # file cannot be determined until all the inbetween references have
         # been calculated too) we pad the offsets with 0's to make them be
         # of consistent length. Using binary offsets would break the trivial
@@ -276,7 +213,7 @@
             raise errors.BzrError('Failed index creation. Internal error:'
                 ' mismatched output length and expected length: %d %d' %
                 (len(result.getvalue()), expected_bytes))
-        return result
+        return StringIO(''.join(lines))
 
 
 class GraphIndex(object):
@@ -329,36 +266,15 @@
         self._keys_by_offset = None
         self._nodes_by_key = None
         self._size = size
-        # The number of bytes we've read so far in trying to process this file
-        self._bytes_read = 0
-
-    def __eq__(self, other):
-        """Equal when self and other were created with the same parameters."""
-        return (
-            type(self) == type(other) and
-            self._transport == other._transport and
-            self._name == other._name and
-            self._size == other._size)
-
-    def __ne__(self, other):
-        return not self.__eq__(other)
-
-    def __repr__(self):
-        return "%s(%r)" % (self.__class__.__name__,
-            self._transport.abspath(self._name))
-
-    def _buffer_all(self, stream=None):
+
+    def _buffer_all(self):
         """Buffer all the index data.
 
         Mutates self._nodes and self.keys_by_offset.
         """
-        if self._nodes is not None:
-            # We already did this
-            return
         if 'index' in debug.debug_flags:
             mutter('Reading entire index %s', self._transport.abspath(self._name))
-        if stream is None:
-            stream = self._transport.get(self._name)
+        stream = self._transport.get(self._name)
         self._read_prefix(stream)
         self._expected_elements = 3 + self._key_length
         line_count = 0
@@ -382,14 +298,14 @@
                 node_value = value
             self._nodes[key] = node_value
             if self._key_length > 1:
-                # TODO: We may want to do this lazily, but if we are calling
-                #       _buffer_all, we are likely to be doing
-                #       iter_entries_prefix
+                subkey = list(reversed(key[:-1]))
                 key_dict = self._nodes_by_key
                 if self.node_ref_lists:
                     key_value = key, node_value[0], node_value[1]
                 else:
                     key_value = key, node_value
+                # possibly should do this on-demand, but it seems likely it is 
+                # always wanted
                 # For a key of (foo, bar, baz) create
                 # _nodes_by_key[foo][bar][baz] = key_value
                 for subkey in key[:-1]:
@@ -531,21 +447,14 @@
             keys supplied. No additional keys will be returned, and every
             key supplied that is in the index will be returned.
         """
+        # PERFORMANCE TODO: parse and bisect all remaining data at some
+        # threshold of total-index processing/get calling layers that expect to
+        # read the entire index to use the iter_all_entries  method instead.
         keys = set(keys)
         if not keys:
             return []
         if self._size is None and self._nodes is None:
             self._buffer_all()
-
-        # We fit about 20 keys per minimum-read (4K), so if we are looking for
-        # more than 1/20th of the index its likely (assuming homogenous key
-        # spread) that we'll read the entire index. If we're going to do that,
-        # buffer the whole thing. A better analysis might take key spread into
-        # account - but B+Tree indices are better anyway.
-        # We could look at all data read, and use a threshold there, which will
-        # trigger on ancestry walks, but that is not yet fully mapped out.
-        if self._nodes is None and len(keys) * 20 > self.key_count():
-            self._buffer_all()
         if self._nodes is not None:
             return self._iter_entries_from_total_buffer(keys)
         else:
@@ -635,7 +544,8 @@
         For GraphIndex the estimate is exact.
         """
         if self._key_count is None:
-            self._read_and_parse([_HEADER_READV])
+            # really this should just read the prefix
+            self._buffer_all()
         return self._key_count
 
     def _lookup_keys_via_location(self, location_keys):
@@ -691,26 +601,12 @@
                 readv_ranges.append((location, length))
         # read the header if needed
         if self._bisect_nodes is None:
-            readv_ranges.append(_HEADER_READV)
+            readv_ranges.append((0, 200))
         self._read_and_parse(readv_ranges)
-        result = []
-        if self._nodes is not None:
-            # _read_and_parse triggered a _buffer_all because we requested the
-            # whole data range
-            for location, key in location_keys:
-                if key not in self._nodes: # not present
-                    result.append(((location, key), False))
-                elif self.node_ref_lists:
-                    value, refs = self._nodes[key]
-                    result.append(((location, key),
-                        (self, key, value, refs)))
-                else:
-                    result.append(((location, key),
-                        (self, key, self._nodes[key])))
-            return result
         # generate results:
         #  - figure out <, >, missing, present
         #  - result present references so we can return them.
+        result = []
         # keys that we cannot answer until we resolve references
         pending_references = []
         pending_locations = set()
@@ -766,15 +662,9 @@
             if length > 0:
                 readv_ranges.append((location, length))
         self._read_and_parse(readv_ranges)
-        if self._nodes is not None:
-            # The _read_and_parse triggered a _buffer_all, grab the data and
-            # return it
-            for location, key in pending_references:
-                value, refs = self._nodes[key]
-                result.append(((location, key), (self, key, value, refs)))
-            return result
         for location, key in pending_references:
             # answer key references we had to look-up-late.
+            index = self._parsed_key_index(key)
             value, refs = self._bisect_nodes[key]
             result.append(((location, key), (self, key,
                 value, self._resolve_references(refs))))
@@ -924,8 +814,7 @@
                 trim_start = data.find('\n') + 1
             else:
                 trim_start = data.find('\n', trim_start) + 1
-            if not (trim_start != 0):
-                raise AssertionError('no \n was present')
+            assert trim_start != 0, 'no \n was present'
             # print 'removing start', offset, trim_start, repr(data[:trim_start])
         if not end_adjacent:
             # work around python bug in rfind
@@ -933,14 +822,12 @@
                 trim_end = data.rfind('\n') + 1
             else:
                 trim_end = data.rfind('\n', None, trim_end) + 1
-            if not (trim_end != 0):
-                raise AssertionError('no \n was present')
+            assert trim_end != 0, 'no \n was present'
             # print 'removing end', offset, trim_end, repr(data[trim_end:])
         # adjust offset and data to the parseable data.
         trimmed_data = data[trim_start:trim_end]
-        if not (trimmed_data):
-            raise AssertionError('read unneeded data [%d:%d] from [%d:%d]' 
-                % (trim_start, trim_end, offset, offset + len(data)))
+        assert trimmed_data, 'read unneeded data [%d:%d] from [%d:%d]' % (
+            trim_start, trim_end, offset, offset + len(data))
         if trim_start:
             offset += trim_start
         # print "parsing", repr(trimmed_data)
@@ -964,16 +851,14 @@
             if line == '':
                 # must be at the end
                 if self._size:
-                    if not (self._size == pos + 1):
-                        raise AssertionError("%s %s" % (self._size, pos))
+                    assert self._size == pos + 1, "%s %s" % (self._size, pos)
                 trailers += 1
                 continue
             elements = line.split('\0')
             if len(elements) != self._expected_elements:
                 raise errors.BadIndexData(self)
-            # keys are tuples. Each element is a string that may occur many
-            # times, so we intern them to save space. AB, RC, 200807
-            key = tuple(intern(element) for element in elements[:self._key_length])
+            # keys are tuples
+            key = tuple(elements[:self._key_length])
             if first_key is None:
                 first_key = key
             absent, references, value = elements[-3:]
@@ -1050,32 +935,17 @@
 
         :param readv_ranges: A prepared readv range list.
         """
-        if not readv_ranges:
-            return
-        if self._nodes is None and self._bytes_read * 2 >= self._size:
-            # We've already read more than 50% of the file and we are about to
-            # request more data, just _buffer_all() and be done
-            self._buffer_all()
-            return
-
-        readv_data = self._transport.readv(self._name, readv_ranges, True,
-            self._size)
-        # parse
-        for offset, data in readv_data:
-            self._bytes_read += len(data)
-            if offset == 0 and len(data) == self._size:
-                # We read the whole range, most likely because the
-                # Transport upcast our readv ranges into one long request
-                # for enough total data to grab the whole index.
-                self._buffer_all(StringIO(data))
-                return
-            if self._bisect_nodes is None:
-                # this must be the start
-                if not (offset == 0):
-                    raise AssertionError()
-                offset, data = self._parse_header_from_bytes(data)
-            # print readv_ranges, "[%d:%d]" % (offset, offset + len(data))
-            self._parse_region(offset, data)
+        if readv_ranges:
+            readv_data = self._transport.readv(self._name, readv_ranges, True,
+                self._size)
+            # parse
+            for offset, data in readv_data:
+                if self._bisect_nodes is None:
+                    # this must be the start
+                    assert offset == 0
+                    offset, data = self._parse_header_from_bytes(data)
+                # print readv_ranges, "[%d:%d]" % (offset, offset + len(data))
+                self._parse_region(offset, data)
 
     def _signature(self):
         """The file signature for this index type."""
@@ -1113,38 +983,6 @@
                 self.__class__.__name__,
                 ', '.join(map(repr, self._indices)))
 
-    @symbol_versioning.deprecated_method(symbol_versioning.one_one)
-    def get_parents(self, revision_ids):
-        """See graph._StackedParentsProvider.get_parents.
-        
-        This implementation thunks the graph.Graph.get_parents api across to
-        GraphIndex.
-
-        :param revision_ids: An iterable of graph keys for this graph.
-        :return: A list of parent details for each key in revision_ids.
-            Each parent details will be one of:
-             * None when the key was missing
-             * (NULL_REVISION,) when the key has no parents.
-             * (parent_key, parent_key...) otherwise.
-        """
-        parent_map = self.get_parent_map(revision_ids)
-        return [parent_map.get(r, None) for r in revision_ids]
-
-    def get_parent_map(self, keys):
-        """See graph._StackedParentsProvider.get_parent_map"""
-        search_keys = set(keys)
-        if NULL_REVISION in search_keys:
-            search_keys.discard(NULL_REVISION)
-            found_parents = {NULL_REVISION:[]}
-        else:
-            found_parents = {}
-        for index, key, value, refs in self.iter_entries(search_keys):
-            parents = refs[0]
-            if not parents:
-                parents = (NULL_REVISION,)
-            found_parents[key] = parents
-        return found_parents
-
     def insert_index(self, pos, index):
         """Insert a new index in the list of indices to query.
 
@@ -1279,7 +1117,7 @@
         """Iterate over keys within the index.
 
         :param keys: An iterable providing the keys to be retrieved.
-        :return: An iterable of (index, key, value, reference_lists). There is no
+        :return: An iterable of (index, key, reference_lists, value). There is no
             defined order for the result iteration - it will be in the most
             efficient order for the index (keys iteration order in this case).
         """
@@ -1332,7 +1170,6 @@
                 else:
                     yield self, key, node[2]
             return
-        nodes_by_key = self._get_nodes_by_key()
         for key in keys:
             # sanity check
             if key[0] is None:
@@ -1340,7 +1177,7 @@
             if len(key) != self._key_length:
                 raise errors.BadIndexKey(key)
             # find what it refers to:
-            key_dict = nodes_by_key
+            key_dict = self._nodes_by_key
             elements = list(key)
             # find the subdict to return
             try:
@@ -1464,7 +1301,7 @@
         """Iterate over keys within the index.
 
         :param keys: An iterable providing the keys to be retrieved.
-        :return: An iterable of (index, key, value, reference_lists). There is no
+        :return: An iterable of (key, reference_lists, value). There is no
             defined order for the result iteration - it will be in the most
             efficient order for the index (keys iteration order in this case).
         """

=== modified file 'bzrlib/info.py'
--- bzrlib/info.py	2008-07-15 04:43:19 +0000
+++ bzrlib/info.py	2007-10-16 16:02:01 +0000
@@ -30,6 +30,8 @@
 from bzrlib.errors import (NoWorkingTree, NotBranchError,
                            NoRepositoryPresent, NotLocalUrl)
 from bzrlib.missing import find_unmerged
+from bzrlib.symbol_versioning import (deprecated_function,
+        zero_eighteen)
 
 
 def plural(n, base='', pl=None):
@@ -126,14 +128,13 @@
     return [(n, locs[n]) for n in order if n in locs]
 
 
-def _show_location_info(locs, outfile):
+def _show_location_info(locs):
     """Show known locations for working, branch and repository."""
-    outfile.write('Location:\n')
+    print 'Location:'
     path_list = LocationList(osutils.getcwd())
     for name, loc in locs:
         path_list.add_url(name, loc)
-    outfile.writelines(path_list.get_lines())
-
+    sys.stdout.writelines(path_list.get_lines())
 
 def _gather_related_branches(branch):
     locs = LocationList(osutils.getcwd())
@@ -141,14 +142,8 @@
     locs.add_url('push branch', branch.get_push_location())
     locs.add_url('parent branch', branch.get_parent())
     locs.add_url('submit branch', branch.get_submit_branch())
-    try:
-        locs.add_url('stacked on', branch.get_stacked_on_url())
-    except (errors.UnstackableBranchFormat, errors.UnstackableRepositoryFormat,
-        errors.NotStacked):
-        pass
     return locs
 
-
 def _show_related_info(branch, outfile):
     """Show parent and push location of branch."""
     locs = _gather_related_branches(branch)
@@ -158,66 +153,60 @@
         outfile.writelines(locs.get_lines())
 
 
-def _show_format_info(control=None, repository=None, branch=None,
-                      working=None, outfile=None):
+def _show_format_info(control=None, repository=None, branch=None, working=None):
     """Show known formats for control, working, branch and repository."""
-    outfile.write('\n')
-    outfile.write('Format:\n')
+    print
+    print 'Format:'
     if control:
-        outfile.write('       control: %s\n' %
-            control._format.get_format_description())
+        print '       control: %s' % control._format.get_format_description()
     if working:
-        outfile.write('  working tree: %s\n' %
-            working._format.get_format_description())
+        print '  working tree: %s' % working._format.get_format_description()
     if branch:
-        outfile.write('        branch: %s\n' %
-            branch._format.get_format_description())
+        print '        branch: %s' % branch._format.get_format_description()
     if repository:
-        outfile.write('    repository: %s\n' %
-            repository._format.get_format_description())
-
-
-def _show_locking_info(repository, branch=None, working=None, outfile=None):
+        print '    repository: %s' % repository._format.get_format_description()
+
+
+def _show_locking_info(repository, branch=None, working=None):
     """Show locking status of working, branch and repository."""
     if (repository.get_physical_lock_status() or
         (branch and branch.get_physical_lock_status()) or
         (working and working.get_physical_lock_status())):
-        outfile.write('\n')
-        outfile.write('Lock status:\n')
+        print
+        print 'Lock status:'
         if working:
             if working.get_physical_lock_status():
                 status = 'locked'
             else:
                 status = 'unlocked'
-            outfile.write('  working tree: %s\n' % status)
+            print '  working tree: %s' % status
         if branch:
             if branch.get_physical_lock_status():
                 status = 'locked'
             else:
                 status = 'unlocked'
-            outfile.write('        branch: %s\n' % status)
+            print '        branch: %s' % status
         if repository:
             if repository.get_physical_lock_status():
                 status = 'locked'
             else:
                 status = 'unlocked'
-            outfile.write('    repository: %s\n' % status)
-
-
-def _show_missing_revisions_branch(branch, outfile):
+            print '    repository: %s' % status
+
+
+def _show_missing_revisions_branch(branch):
     """Show missing master revisions in branch."""
     # Try with inaccessible branch ?
     master = branch.get_master_branch()
     if master:
         local_extra, remote_extra = find_unmerged(branch, master)
         if remote_extra:
-            outfile.write('\n')
-            outfile.write(('Branch is out of date: missing %d '
-                'revision%s.\n') % (len(remote_extra),
-                plural(len(remote_extra))))
-
-
-def _show_missing_revisions_working(working, outfile):
+            print
+            print 'Branch is out of date: missing %d revision%s.' % (
+                len(remote_extra), plural(len(remote_extra)))
+
+
+def _show_missing_revisions_working(working):
     """Show missing revisions in working tree."""
     branch = working.branch
     basis = working.basis_tree()
@@ -231,24 +220,24 @@
     if branch_revno and tree_last_id != branch_last_revision:
         tree_last_revno = branch.revision_id_to_revno(tree_last_id)
         missing_count = branch_revno - tree_last_revno
-        outfile.write('\n')
-        outfile.write(('Working tree is out of date: missing %d '
-            'revision%s.\n') % (missing_count, plural(missing_count)))
-
-
-def _show_working_stats(working, outfile):
+        print
+        print 'Working tree is out of date: missing %d revision%s.' % (
+            missing_count, plural(missing_count))
+
+
+def _show_working_stats(working):
     """Show statistics about a working tree."""
     basis = working.basis_tree()
     work_inv = working.inventory
     delta = working.changes_from(basis, want_unchanged=True)
 
-    outfile.write('\n')
-    outfile.write('In the working tree:\n')
-    outfile.write('  %8s unchanged\n' % len(delta.unchanged))
-    outfile.write('  %8d modified\n' % len(delta.modified))
-    outfile.write('  %8d added\n' % len(delta.added))
-    outfile.write('  %8d removed\n' % len(delta.removed))
-    outfile.write('  %8d renamed\n' % len(delta.renamed))
+    print
+    print 'In the working tree:'
+    print '  %8s unchanged' % len(delta.unchanged)
+    print '  %8d modified' % len(delta.modified)
+    print '  %8d added' % len(delta.added)
+    print '  %8d removed' % len(delta.removed)
+    print '  %8d renamed' % len(delta.renamed)
 
     ignore_cnt = unknown_cnt = 0
     for path in working.extras():
@@ -256,65 +245,61 @@
             ignore_cnt += 1
         else:
             unknown_cnt += 1
-    outfile.write('  %8d unknown\n' % unknown_cnt)
-    outfile.write('  %8d ignored\n' % ignore_cnt)
+    print '  %8d unknown' % unknown_cnt
+    print '  %8d ignored' % ignore_cnt
 
     dir_cnt = 0
     for file_id in work_inv:
         if (work_inv.get_file_kind(file_id) == 'directory' and 
             not work_inv.is_root(file_id)):
             dir_cnt += 1
-    outfile.write('  %8d versioned %s\n' % (dir_cnt,
-        plural(dir_cnt, 'subdirectory', 'subdirectories')))
-
-
-def _show_branch_stats(branch, verbose, outfile):
+    print '  %8d versioned %s' \
+          % (dir_cnt,
+             plural(dir_cnt, 'subdirectory', 'subdirectories'))
+
+
+def _show_branch_stats(branch, verbose):
     """Show statistics about a branch."""
     revno, head = branch.last_revision_info()
-    outfile.write('\n')
-    outfile.write('Branch history:\n')
-    outfile.write('  %8d revision%s\n' % (revno, plural(revno)))
+    print
+    print 'Branch history:'
+    print '  %8d revision%s' % (revno, plural(revno))
     stats = branch.repository.gather_stats(head, committers=verbose)
     if verbose:
         committers = stats['committers']
-        outfile.write('  %8d committer%s\n' % (committers,
-            plural(committers)))
+        print '  %8d committer%s' % (committers, plural(committers))
     if revno:
         timestamp, timezone = stats['firstrev']
         age = int((time.time() - timestamp) / 3600 / 24)
-        outfile.write('  %8d day%s old\n' % (age, plural(age)))
-        outfile.write('   first revision: %s\n' %
-            osutils.format_date(timestamp, timezone))
+        print '  %8d day%s old' % (age, plural(age))
+        print '   first revision: %s' % osutils.format_date(timestamp,
+            timezone)
         timestamp, timezone = stats['latestrev']
-        outfile.write('  latest revision: %s\n' %
-            osutils.format_date(timestamp, timezone))
+        print '  latest revision: %s' % osutils.format_date(timestamp,
+            timezone)
     return stats
 
 
-def _show_repository_info(repository, outfile):
+def _show_repository_info(repository):
     """Show settings of a repository."""
     if repository.make_working_trees():
-        outfile.write('\n')
-        outfile.write('Create working tree for new branches inside '
-            'the repository.\n')
-
-
-def _show_repository_stats(stats, outfile):
+        print
+        print 'Create working tree for new branches inside the repository.'
+
+
+def _show_repository_stats(stats):
     """Show statistics about a repository."""
     if 'revisions' in stats or 'size' in stats:
-        outfile.write('\n')
-        outfile.write('Repository:\n')
+        print
+        print 'Repository:'
     if 'revisions' in stats:
         revisions = stats['revisions']
-        outfile.write('  %8d revision%s\n' % (revisions, plural(revisions)))
+        print '  %8d revision%s' % (revisions, plural(revisions))
     if 'size' in stats:
-        outfile.write('  %8d KiB\n' % (stats['size']/1024))
-
-
-def show_bzrdir_info(a_bzrdir, verbose=False, outfile=None):
+        print '  %8d KiB' % (stats['size']/1024)
+
+def show_bzrdir_info(a_bzrdir, verbose=False):
     """Output to stdout the 'info' for a_bzrdir."""
-    if outfile is None:
-        outfile = sys.stdout
     try:
         tree = a_bzrdir.open_workingtree(
             recommend_upgrade=False)
@@ -342,46 +327,42 @@
 
     lockable.lock_read()
     try:
-        show_component_info(a_bzrdir, repository, branch, tree, verbose,
-                            outfile)
+        show_component_info(a_bzrdir, repository, branch, tree, verbose)
     finally:
         lockable.unlock()
 
 
 def show_component_info(control, repository, branch=None, working=None,
-    verbose=1, outfile=None):
+    verbose=1):
     """Write info about all bzrdir components to stdout"""
-    if outfile is None:
-        outfile = sys.stdout
     if verbose is False:
         verbose = 1
     if verbose is True:
         verbose = 2
     layout = describe_layout(repository, branch, working)
     format = describe_format(control, repository, branch, working)
-    outfile.write("%s (format: %s)\n" % (layout, format))
-    _show_location_info(gather_location_info(repository, branch, working),
-                        outfile)
+    print "%s (format: %s)" % (layout, format)
+    _show_location_info(gather_location_info(repository, branch, working))
     if branch is not None:
-        _show_related_info(branch, outfile)
+        _show_related_info(branch, sys.stdout)
     if verbose == 0:
         return
-    _show_format_info(control, repository, branch, working, outfile)
-    _show_locking_info(repository, branch, working, outfile)
+    _show_format_info(control, repository, branch, working)
+    _show_locking_info(repository, branch, working)
     if branch is not None:
-        _show_missing_revisions_branch(branch, outfile)
+        _show_missing_revisions_branch(branch)
     if working is not None:
-        _show_missing_revisions_working(working, outfile)
-        _show_working_stats(working, outfile)
+        _show_missing_revisions_working(working)
+        _show_working_stats(working)
     elif branch is not None:
-        _show_missing_revisions_branch(branch, outfile)
+        _show_missing_revisions_branch(branch)
     if branch is not None:
-        stats = _show_branch_stats(branch, verbose==2, outfile)
+        stats = _show_branch_stats(branch, verbose==2)
     else:
         stats = repository.gather_stats()
     if branch is None and working is None:
-        _show_repository_info(repository, outfile)
-    _show_repository_stats(stats, outfile)
+        _show_repository_info(repository)
+    _show_repository_stats(stats)
 
 
 def describe_layout(repository=None, branch=None, tree=None):
@@ -443,9 +424,7 @@
         tree.bzrdir.root_transport.base):
         branch = None
         repository = None
-    non_aliases = set(bzrdir.format_registry.keys())
-    non_aliases.difference_update(bzrdir.format_registry.aliases())
-    for key in non_aliases:
+    for key in bzrdir.format_registry.keys():
         format = bzrdir.format_registry.make_bzrdir(key)
         if isinstance(format, bzrdir.BzrDirMetaFormat1):
             if (tree and format.workingtree_format !=
@@ -462,12 +441,35 @@
         candidates.append(key)
     if len(candidates) == 0:
         return 'unnamed'
-    candidates.sort()
+    new_candidates = [c for c in candidates if c != 'default']
+    if len(new_candidates) > 0:
+        candidates = new_candidates
     new_candidates = [c for c in candidates if not
         bzrdir.format_registry.get_info(c).hidden]
     if len(new_candidates) > 0:
-        # If there are any non-hidden formats that match, only return those to
-        # avoid listing hidden formats except when only a hidden format will
-        # do.
         candidates = new_candidates
     return ' or '.join(candidates)
+
+
+@deprecated_function(zero_eighteen)
+def show_tree_info(working, verbose):
+    """Output to stdout the 'info' for working."""
+    branch = working.branch
+    repository = branch.repository
+    control = working.bzrdir
+    show_component_info(control, repository, branch, working, verbose)
+
+
+@deprecated_function(zero_eighteen)
+def show_branch_info(branch, verbose):
+    """Output to stdout the 'info' for branch."""
+    repository = branch.repository
+    control = branch.bzrdir
+    show_component_info(control, repository, branch, verbose=verbose)
+
+
+@deprecated_function(zero_eighteen)
+def show_repository_info(repository, verbose):
+    """Output to stdout the 'info' for repository."""
+    control = repository.bzrdir
+    show_component_info(control, repository, verbose=verbose)

=== modified file 'bzrlib/intset.py'
--- bzrlib/intset.py	2008-04-24 07:22:53 +0000
+++ bzrlib/intset.py	2006-09-08 18:46:29 +0000
@@ -149,6 +149,7 @@
 
 
     def __contains__(self, i):
+        assert i >= 0
         return self._val & (1L << i)
 
 
@@ -176,10 +177,12 @@
             self._val |= to_add._val
         else:
             for i in to_add:
+                assert i >= 0
                 self._val |= (1L << i)
 
 
     def add(self, to_add):
+        assert 0 <= to_add
         self._val |= (1L << to_add)
 
 
@@ -200,6 +203,7 @@
         >>> not a
         True
         """
+        assert 0 <= to_remove
         m = 1L << to_remove
         if not self._val & m:
             raise KeyError(to_remove)

=== modified file 'bzrlib/inventory.py'
--- bzrlib/inventory.py	2008-08-09 00:45:30 +0000
+++ bzrlib/inventory.py	2007-10-16 17:37:43 +0000
@@ -50,7 +50,7 @@
     BzrCheckError,
     BzrError,
     )
-from bzrlib.symbol_versioning import deprecated_in, deprecated_method
+from bzrlib.symbol_versioning import deprecated_method, zero_ninetyone
 from bzrlib.trace import mutter
 
 
@@ -112,6 +112,7 @@
     InventoryFile('2326', 'wibble.c', parent_id='2325', sha1=None, len=None)
     >>> for path, entry in i.iter_entries():
     ...     print path
+    ...     assert i.path2id(path)
     ... 
     <BLANKLINE>
     src
@@ -141,6 +142,23 @@
         """
         return False, False
 
+    def diff(self, text_diff, from_label, tree, to_label, to_entry, to_tree,
+             output_to, reverse=False):
+        """Perform a diff from this to to_entry.
+
+        text_diff will be used for textual difference calculation.
+        This is a template method, override _diff in child classes.
+        """
+        self._read_tree_state(tree.id2path(self.file_id), tree)
+        if to_entry:
+            # cannot diff from one kind to another - you must do a removal
+            # and an addif they do not match.
+            assert self.kind == to_entry.kind
+            to_entry._read_tree_state(to_tree.id2path(to_entry.file_id),
+                                      to_tree)
+        self._diff(text_diff, from_label, tree, to_label, to_entry, to_tree,
+                   output_to, reverse)
+
     def _diff(self, text_diff, from_label, tree, to_label, to_entry, to_tree,
              output_to, reverse=False):
         """Perform a diff between two entries of the same kind."""
@@ -160,6 +178,7 @@
         for inv in previous_inventories:
             if self.file_id in inv:
                 ie = inv[self.file_id]
+                assert ie.file_id == self.file_id
                 if ie.revision in candidates:
                     # same revision value in two different inventories:
                     # correct possible inconsistencies:
@@ -171,12 +190,83 @@
                             ie.executable = False
                     except AttributeError:
                         pass
+                    # must now be the same.
+                    assert candidates[ie.revision] == ie
                 else:
                     # add this revision as a candidate.
                     candidates[ie.revision] = ie
         return candidates
 
-    @deprecated_method(deprecated_in((1, 6, 0)))
+    @deprecated_method(zero_ninetyone)
+    def find_previous_heads(self, previous_inventories,
+                            versioned_file_store,
+                            transaction,
+                            entry_vf=None):
+        """Return the revisions and entries that directly precede this.
+
+        Returned as a map from revision to inventory entry.
+
+        This is a map containing the file revisions in all parents
+        for which the file exists, and its revision is not a parent of
+        any other. If the file is new, the set will be empty.
+
+        :param versioned_file_store: A store where ancestry data on this
+                                     file id can be queried.
+        :param transaction: The transaction that queries to the versioned 
+                            file store should be completed under.
+        :param entry_vf: The entry versioned file, if its already available.
+        """
+        candidates = self.parent_candidates(previous_inventories)
+
+        # revision:ie mapping with one revision for each head.
+        heads = {}
+        # common case optimisation
+        if len(candidates) == 1:
+            # if there is only one candidate revision found
+            # then we can avoid opening the versioned file to access ancestry:
+            # there cannot be any ancestors to eliminate when there is 
+            # only one revision available.
+            return candidates
+        
+        # --- what follows is now encapsulated in repository.get_graph.heads(), 
+        #     but that is not accessible from here as we have no repository
+        #     pointer. Note that the repository.get_graph.heads() call can return
+        #     different results *at the moment* because of the kind-changing check
+        #     we have in parent_candidates().
+
+        # eliminate ancestors amongst the available candidates:
+        # heads are those that are not an ancestor of any other candidate
+        # - this provides convergence at a per-file level.
+        def get_ancestors(weave, entry):
+            return set(weave.get_ancestry(entry.revision, topo_sorted=False))
+        # revision: ancestor list for each head
+        head_ancestors = {}
+        for ie in candidates.values():
+            # may be an ancestor of a known head:
+            already_present = 0 != len(
+                [head for head in heads 
+                 if ie.revision in head_ancestors[head]])
+            if already_present:
+                # an ancestor of an analyzed candidate.
+                continue
+            # not an ancestor of a known head:
+            # load the versioned file for this file id if needed
+            if entry_vf is None:
+                entry_vf = versioned_file_store.get_weave_or_empty(
+                    self.file_id, transaction)
+            ancestors = get_ancestors(entry_vf, ie)
+            # may knock something else out:
+            check_heads = list(heads.keys())
+            for head in check_heads:
+                if head in ancestors:
+                    # this previously discovered 'head' is not
+                    # really a head - its an ancestor of the newly 
+                    # found head,
+                    heads.pop(head)
+            head_ancestors[ie.revision] = ancestors
+            heads[ie.revision] = ie
+        return heads
+
     def get_tar_item(self, root, dp, now, tree):
         """Get a tarfile item and a file stream for its content."""
         item = tarfile.TarInfo(osutils.pathjoin(root, dp).encode('utf8'))
@@ -212,6 +302,7 @@
         Traceback (most recent call last):
         InvalidEntryName: Invalid entry name: src/hello.c
         """
+        assert isinstance(name, basestring), name
         if '/' in name or '\\' in name:
             raise errors.InvalidEntryName(name=name)
         self.executable = False
@@ -219,6 +310,8 @@
         self.text_sha1 = None
         self.text_size = None
         self.file_id = file_id
+        assert isinstance(file_id, (str, None.__class__)), \
+            'bad type %r for %r' % (type(file_id), file_id)
         self.name = name
         self.text_id = text_id
         self.parent_id = parent_id
@@ -239,7 +332,6 @@
         raise BzrError("don't know how to export {%s} of kind %r" %
                        (self.file_id, self.kind))
 
-    @deprecated_method(deprecated_in((1, 6, 0)))
     def put_on_disk(self, dest, dp, tree):
         """Create a representation of self on disk in the prefix dest.
         
@@ -474,9 +566,9 @@
 
     def _check(self, checker, tree_revision_id, tree):
         """See InventoryEntry._check"""
-        key = (self.file_id, self.revision)
-        if key in checker.checked_texts:
-            prev_sha = checker.checked_texts[key]
+        t = (self.file_id, self.revision)
+        if t in checker.checked_texts:
+            prev_sha = checker.checked_texts[t]
             if prev_sha != self.text_sha1:
                 raise BzrCheckError(
                     'mismatched sha1 on {%s} in {%s} (%s != %s) %r' %
@@ -486,14 +578,26 @@
                 checker.repeated_text_cnt += 1
                 return
 
+        if self.file_id not in checker.checked_weaves:
+            mutter('check weave {%s}', self.file_id)
+            w = tree._get_weave(self.file_id)
+            # Not passing a progress bar, because it creates a new
+            # progress, which overwrites the current progress,
+            # and doesn't look nice
+            w.check()
+            checker.checked_weaves[self.file_id] = True
+        else:
+            w = tree._get_weave(self.file_id)
+
         mutter('check version {%s} of {%s}', tree_revision_id, self.file_id)
         checker.checked_text_cnt += 1
         # We can't check the length, because Weave doesn't store that
         # information, and the whole point of looking at the weave's
         # sha1sum is that we don't have to extract the text.
-        if (self.text_sha1 != tree._repository.texts.get_sha1s([key])[key]):
-            raise BzrCheckError('text {%s} version {%s} wrong sha1' % key)
-        checker.checked_texts[key] = self.text_sha1
+        if self.text_sha1 != w.get_sha1(self.revision):
+            raise BzrCheckError('text {%s} version {%s} wrong sha1' 
+                                % (self.file_id, self.revision))
+        checker.checked_texts[t] = self.text_sha1
 
     def copy(self):
         other = InventoryFile(self.file_id, self.name, self.parent_id)
@@ -506,6 +610,8 @@
 
     def detect_changes(self, old_entry):
         """See InventoryEntry.detect_changes."""
+        assert self.text_sha1 is not None
+        assert old_entry.text_sha1 is not None
         text_modified = (self.text_sha1 != old_entry.text_sha1)
         meta_modified = (self.executable != old_entry.executable)
         return text_modified, meta_modified
@@ -513,19 +619,25 @@
     def _diff(self, text_diff, from_label, tree, to_label, to_entry, to_tree,
              output_to, reverse=False):
         """See InventoryEntry._diff."""
-        from bzrlib.diff import DiffText
-        from_file_id = self.file_id
-        if to_entry:
-            to_file_id = to_entry.file_id
-        else:
-            to_file_id = None
-        if reverse:
-            to_file_id, from_file_id = from_file_id, to_file_id
-            tree, to_tree = to_tree, tree
-            from_label, to_label = to_label, from_label
-        differ = DiffText(tree, to_tree, output_to, 'utf-8', '', '',
-                          text_diff)
-        return differ.diff_text(from_file_id, to_file_id, from_label, to_label)
+        try:
+            from_text = tree.get_file(self.file_id).readlines()
+            if to_entry:
+                to_text = to_tree.get_file(to_entry.file_id).readlines()
+            else:
+                to_text = []
+            if not reverse:
+                text_diff(from_label, from_text,
+                          to_label, to_text, output_to)
+            else:
+                text_diff(to_label, to_text,
+                          from_label, from_text, output_to)
+        except errors.BinaryFile:
+            if reverse:
+                label_pair = (to_label, from_label)
+            else:
+                label_pair = (from_label, to_label)
+            output_to.write(
+                  ("Binary files %s and %s differ\n" % label_pair).encode('utf8'))
 
     def has_text(self):
         """See InventoryEntry.has_text."""
@@ -623,21 +735,19 @@
     def _diff(self, text_diff, from_label, tree, to_label, to_entry, to_tree,
              output_to, reverse=False):
         """See InventoryEntry._diff."""
-        from bzrlib.diff import DiffSymlink
-        old_target = self.symlink_target
+        from_text = self.symlink_target
         if to_entry is not None:
-            new_target = to_entry.symlink_target
-        else:
-            new_target = None
-        if not reverse:
-            old_tree = tree
-            new_tree = to_tree
-        else:
-            old_tree = to_tree
-            new_tree = tree
-            new_target, old_target = old_target, new_target
-        differ = DiffSymlink(old_tree, new_tree, output_to)
-        return differ.diff_symlink(old_target, new_target)
+            to_text = to_entry.symlink_target
+            if reverse:
+                temp = from_text
+                from_text = to_text
+                to_text = temp
+            output_to.write('=== target changed %r => %r\n' % (from_text, to_text))
+        else:
+            if not reverse:
+                output_to.write('=== target was %r\n' % self.symlink_target)
+            else:
+                output_to.write('=== target is %r\n' % self.symlink_target)
 
     def __init__(self, file_id, name, parent_id):
         super(InventoryLink, self).__init__(file_id, name, parent_id)
@@ -761,6 +871,7 @@
         an id of None.
         """
         if root_id is not None:
+            assert root_id.__class__ == str
             self._set_root(InventoryDirectory(root_id, u'', None))
         else:
             self.root = None
@@ -815,9 +926,7 @@
                 # adds come later
                 continue
             # Preserve unaltered children of file_id for later reinsertion.
-            file_id_children = getattr(self[file_id], 'children', {})
-            if len(file_id_children):
-                children[file_id] = file_id_children
+            children[file_id] = getattr(self[file_id], 'children', {})
             # Remove file_id and the unaltered children. If file_id is not
             # being deleted it will be reinserted back later.
             self.remove_recursive_id(file_id)
@@ -829,16 +938,8 @@
         for new_path, new_entry in sorted((np, e) for op, np, f, e in
                                           delta if np is not None):
             if new_entry.kind == 'directory':
-                # Pop the child which to allow detection of children whose
-                # parents were deleted and which were not reattached to a new
-                # parent.
-                new_entry.children = children.pop(new_entry.file_id, {})
+                new_entry.children = children.get(new_entry.file_id, {})
             self.add(new_entry)
-        if len(children):
-            # Get the parent id that was deleted
-            parent_id, children = children.popitem()
-            raise errors.InconsistentDelta("<deleted>", parent_id,
-                "The file id was deleted but its children were not deleted.")
 
     def _set_root(self, ie):
         self.root = ie
@@ -847,13 +948,10 @@
     def copy(self):
         # TODO: jam 20051218 Should copy also copy the revision_id?
         entries = self.iter_entries()
-        if self.root is None:
-            return Inventory(root_id=None)
         other = Inventory(entries.next()[1].file_id)
-        other.root.revision = self.root.revision
         # copy recursively so we know directories will be added before
         # their children.  There are more efficient ways than this...
-        for path, entry in entries:
+        for path, entry in entries():
             other.add(entry.copy())
         return other
 
@@ -1076,6 +1174,7 @@
                                          self._byid[entry.file_id])
 
         if entry.parent_id is None:
+            assert self.root is None and len(self._byid) == 0
             self.root = entry
         else:
             try:
@@ -1127,6 +1226,10 @@
         False
         """
         ie = self[file_id]
+
+        assert ie.parent_id is None or \
+            self[ie.parent_id].children[ie.name] == ie
+        
         del self._byid[file_id]
         if ie.parent_id is not None:
             del self[ie.parent_id].children[ie.name]
@@ -1220,6 +1323,8 @@
                 if children is None:
                     return None
                 cie = children[f]
+                assert cie.name == f
+                assert cie.parent_id == parent.file_id
                 parent = cie
             except KeyError:
                 # or raise an error?
@@ -1318,7 +1423,7 @@
 
     :raises InvalidNormalization: When name is not normalized, and cannot be
         accessed on this platform by the normalized path.
-    :return: The NFC normalised version of name.
+    :return: The NFC/NFKC normalised version of name.
     """
     #------- This has been copied to bzrlib.dirstate.DirState.add, please
     # keep them synchronised.

=== modified file 'bzrlib/knit.py'
--- bzrlib/knit.py	2008-08-18 22:34:21 +0000
+++ bzrlib/knit.py	2007-10-17 04:41:40 +0000
@@ -60,31 +60,34 @@
 # record content length ?
                   
 
+from copy import copy
 from cStringIO import StringIO
 from itertools import izip, chain
 import operator
 import os
+import sys
+import warnings
+from zlib import Z_DEFAULT_COMPRESSION
 
+import bzrlib
 from bzrlib.lazy_import import lazy_import
 lazy_import(globals(), """
 from bzrlib import (
     annotate,
-    debug,
-    diff,
-    graph as _mod_graph,
-    index as _mod_index,
-    lru_cache,
     pack,
-    progress,
     trace,
-    tsort,
-    tuned_gzip,
     )
 """)
 from bzrlib import (
+    cache_utf8,
+    debug,
+    diff,
     errors,
     osutils,
     patiencediff,
+    progress,
+    merge,
+    ui,
     )
 from bzrlib.errors import (
     FileExists,
@@ -92,26 +95,23 @@
     KnitError,
     InvalidRevisionId,
     KnitCorrupt,
+    KnitDataStreamIncompatible,
     KnitHeaderError,
     RevisionNotPresent,
     RevisionAlreadyPresent,
     )
+from bzrlib.tuned_gzip import GzipFile, bytes_to_gzip
 from bzrlib.osutils import (
     contains_whitespace,
     contains_linebreaks,
     sha_string,
     sha_strings,
-    split_lines,
-    )
-from bzrlib.versionedfile import (
-    AbsentContentFactory,
-    adapter_registry,
-    ConstantMapper,
-    ContentFactory,
-    FulltextContentFactory,
-    VersionedFile,
-    VersionedFiles,
-    )
+    )
+from bzrlib.symbol_versioning import DEPRECATED_PARAMETER, deprecated_passed
+from bzrlib.tsort import topo_sort
+import bzrlib.ui
+import bzrlib.weave
+from bzrlib.versionedfile import VersionedFile, InterVersionedFile
 
 
 # TODO: Split out code specific to this format into an associated object.
@@ -131,170 +131,12 @@
 INDEX_SUFFIX = '.kndx'
 
 
-class KnitAdapter(object):
-    """Base class for knit record adaption."""
-
-    def __init__(self, basis_vf):
-        """Create an adapter which accesses full texts from basis_vf.
-        
-        :param basis_vf: A versioned file to access basis texts of deltas from.
-            May be None for adapters that do not need to access basis texts.
-        """
-        self._data = KnitVersionedFiles(None, None)
-        self._annotate_factory = KnitAnnotateFactory()
-        self._plain_factory = KnitPlainFactory()
-        self._basis_vf = basis_vf
-
-
-class FTAnnotatedToUnannotated(KnitAdapter):
-    """An adapter from FT annotated knits to unannotated ones."""
-
-    def get_bytes(self, factory, annotated_compressed_bytes):
-        rec, contents = \
-            self._data._parse_record_unchecked(annotated_compressed_bytes)
-        content = self._annotate_factory.parse_fulltext(contents, rec[1])
-        size, bytes = self._data._record_to_data((rec[1],), rec[3], content.text())
-        return bytes
-
-
-class DeltaAnnotatedToUnannotated(KnitAdapter):
-    """An adapter for deltas from annotated to unannotated."""
-
-    def get_bytes(self, factory, annotated_compressed_bytes):
-        rec, contents = \
-            self._data._parse_record_unchecked(annotated_compressed_bytes)
-        delta = self._annotate_factory.parse_line_delta(contents, rec[1],
-            plain=True)
-        contents = self._plain_factory.lower_line_delta(delta)
-        size, bytes = self._data._record_to_data((rec[1],), rec[3], contents)
-        return bytes
-
-
-class FTAnnotatedToFullText(KnitAdapter):
-    """An adapter from FT annotated knits to unannotated ones."""
-
-    def get_bytes(self, factory, annotated_compressed_bytes):
-        rec, contents = \
-            self._data._parse_record_unchecked(annotated_compressed_bytes)
-        content, delta = self._annotate_factory.parse_record(factory.key[-1],
-            contents, factory._build_details, None)
-        return ''.join(content.text())
-
-
-class DeltaAnnotatedToFullText(KnitAdapter):
-    """An adapter for deltas from annotated to unannotated."""
-
-    def get_bytes(self, factory, annotated_compressed_bytes):
-        rec, contents = \
-            self._data._parse_record_unchecked(annotated_compressed_bytes)
-        delta = self._annotate_factory.parse_line_delta(contents, rec[1],
-            plain=True)
-        compression_parent = factory.parents[0]
-        basis_entry = self._basis_vf.get_record_stream(
-            [compression_parent], 'unordered', True).next()
-        if basis_entry.storage_kind == 'absent':
-            raise errors.RevisionNotPresent(compression_parent, self._basis_vf)
-        basis_lines = split_lines(basis_entry.get_bytes_as('fulltext'))
-        # Manually apply the delta because we have one annotated content and
-        # one plain.
-        basis_content = PlainKnitContent(basis_lines, compression_parent)
-        basis_content.apply_delta(delta, rec[1])
-        basis_content._should_strip_eol = factory._build_details[1]
-        return ''.join(basis_content.text())
-
-
-class FTPlainToFullText(KnitAdapter):
-    """An adapter from FT plain knits to unannotated ones."""
-
-    def get_bytes(self, factory, compressed_bytes):
-        rec, contents = \
-            self._data._parse_record_unchecked(compressed_bytes)
-        content, delta = self._plain_factory.parse_record(factory.key[-1],
-            contents, factory._build_details, None)
-        return ''.join(content.text())
-
-
-class DeltaPlainToFullText(KnitAdapter):
-    """An adapter for deltas from annotated to unannotated."""
-
-    def get_bytes(self, factory, compressed_bytes):
-        rec, contents = \
-            self._data._parse_record_unchecked(compressed_bytes)
-        delta = self._plain_factory.parse_line_delta(contents, rec[1])
-        compression_parent = factory.parents[0]
-        # XXX: string splitting overhead.
-        basis_entry = self._basis_vf.get_record_stream(
-            [compression_parent], 'unordered', True).next()
-        if basis_entry.storage_kind == 'absent':
-            raise errors.RevisionNotPresent(compression_parent, self._basis_vf)
-        basis_lines = split_lines(basis_entry.get_bytes_as('fulltext'))
-        basis_content = PlainKnitContent(basis_lines, compression_parent)
-        # Manually apply the delta because we have one annotated content and
-        # one plain.
-        content, _ = self._plain_factory.parse_record(rec[1], contents,
-            factory._build_details, basis_content)
-        return ''.join(content.text())
-
-
-class KnitContentFactory(ContentFactory):
-    """Content factory for streaming from knits.
-    
-    :seealso ContentFactory:
-    """
-
-    def __init__(self, key, parents, build_details, sha1, raw_record,
-        annotated, knit=None):
-        """Create a KnitContentFactory for key.
-        
-        :param key: The key.
-        :param parents: The parents.
-        :param build_details: The build details as returned from
-            get_build_details.
-        :param sha1: The sha1 expected from the full text of this object.
-        :param raw_record: The bytes of the knit data from disk.
-        :param annotated: True if the raw data is annotated.
-        """
-        ContentFactory.__init__(self)
-        self.sha1 = sha1
-        self.key = key
-        self.parents = parents
-        if build_details[0] == 'line-delta':
-            kind = 'delta'
-        else:
-            kind = 'ft'
-        if annotated:
-            annotated_kind = 'annotated-'
-        else:
-            annotated_kind = ''
-        self.storage_kind = 'knit-%s%s-gz' % (annotated_kind, kind)
-        self._raw_record = raw_record
-        self._build_details = build_details
-        self._knit = knit
-
-    def get_bytes_as(self, storage_kind):
-        if storage_kind == self.storage_kind:
-            return self._raw_record
-        if storage_kind == 'fulltext' and self._knit is not None:
-            return self._knit.get_text(self.key[0])
-        else:
-            raise errors.UnavailableRepresentation(self.key, storage_kind,
-                self.storage_kind)
-
-
 class KnitContent(object):
-    """Content of a knit version to which deltas can be applied.
-    
-    This is always stored in memory as a list of lines with \n at the end,
-    plus a flag saying if the final ending is really there or not, because that 
-    corresponds to the on-disk knit representation.
-    """
-
-    def __init__(self):
-        self._should_strip_eol = False
-
-    def apply_delta(self, delta, new_version_id):
-        """Apply delta to this object to become new_version_id."""
-        raise NotImplementedError(self.apply_delta)
+    """Content of a knit version to which deltas can be applied."""
+
+    def annotate(self):
+        """Return a list of (origin, text) tuples."""
+        return list(self.annotate_iter())
 
     def line_delta_iter(self, new_lines):
         """Generate line-based delta from this content to new_lines."""
@@ -341,28 +183,19 @@
     """Annotated content."""
 
     def __init__(self, lines):
-        KnitContent.__init__(self)
         self._lines = lines
 
-    def annotate(self):
-        """Return a list of (origin, text) for each content line."""
-        lines = self._lines[:]
-        if self._should_strip_eol:
-            origin, last_line = lines[-1]
-            lines[-1] = (origin, last_line.rstrip('\n'))
-        return lines
+    def annotate_iter(self):
+        """Yield tuples of (origin, text) for each content line."""
+        return iter(self._lines)
 
-    def apply_delta(self, delta, new_version_id):
-        """Apply delta to this object to become new_version_id."""
-        offset = 0
-        lines = self._lines
-        for start, end, count, delta_lines in delta:
-            lines[offset+start:offset+end] = delta_lines
-            offset = offset + (start - end) + count
+    def strip_last_line_newline(self):
+        line = self._lines[-1][1].rstrip('\n')
+        self._lines[-1] = (self._lines[-1][0], line)
 
     def text(self):
         try:
-            lines = [text for origin, text in self._lines]
+            return [text for origin, text in self._lines]
         except ValueError, e:
             # most commonly (only?) caused by the internal form of the knit
             # missing annotation information because of a bug - see thread
@@ -370,9 +203,6 @@
             raise KnitCorrupt(self,
                 "line in annotated knit missing annotation information: %s"
                 % (e,))
-        if self._should_strip_eol:
-            lines[-1] = lines[-1].rstrip('\n')
-        return lines
 
     def copy(self):
         return AnnotatedKnitContent(self._lines[:])
@@ -387,69 +217,25 @@
     """
 
     def __init__(self, lines, version_id):
-        KnitContent.__init__(self)
         self._lines = lines
         self._version_id = version_id
 
-    def annotate(self):
-        """Return a list of (origin, text) for each content line."""
-        return [(self._version_id, line) for line in self._lines]
-
-    def apply_delta(self, delta, new_version_id):
-        """Apply delta to this object to become new_version_id."""
-        offset = 0
-        lines = self._lines
-        for start, end, count, delta_lines in delta:
-            lines[offset+start:offset+end] = delta_lines
-            offset = offset + (start - end) + count
-        self._version_id = new_version_id
+    def annotate_iter(self):
+        """Yield tuples of (origin, text) for each content line."""
+        for line in self._lines:
+            yield self._version_id, line
 
     def copy(self):
         return PlainKnitContent(self._lines[:], self._version_id)
 
+    def strip_last_line_newline(self):
+        self._lines[-1] = self._lines[-1].rstrip('\n')
+
     def text(self):
-        lines = self._lines
-        if self._should_strip_eol:
-            lines = lines[:]
-            lines[-1] = lines[-1].rstrip('\n')
-        return lines
-
-
-class _KnitFactory(object):
-    """Base class for common Factory functions."""
-
-    def parse_record(self, version_id, record, record_details,
-                     base_content, copy_base_content=True):
-        """Parse a record into a full content object.
-
-        :param version_id: The official version id for this content
-        :param record: The data returned by read_records_iter()
-        :param record_details: Details about the record returned by
-            get_build_details
-        :param base_content: If get_build_details returns a compression_parent,
-            you must return a base_content here, else use None
-        :param copy_base_content: When building from the base_content, decide
-            you can either copy it and return a new object, or modify it in
-            place.
-        :return: (content, delta) A Content object and possibly a line-delta,
-            delta may be None
-        """
-        method, noeol = record_details
-        if method == 'line-delta':
-            if copy_base_content:
-                content = base_content.copy()
-            else:
-                content = base_content
-            delta = self.parse_line_delta(record, version_id)
-            content.apply_delta(delta, version_id)
-        else:
-            content = self.parse_fulltext(record, version_id)
-            delta = None
-        content._should_strip_eol = noeol
-        return (content, delta)
-
-
-class KnitAnnotateFactory(_KnitFactory):
+        return self._lines
+
+
+class KnitAnnotateFactory(object):
     """Factory for creating annotated Content objects."""
 
     annotated = True
@@ -556,24 +342,12 @@
                        for origin, text in lines)
         return out
 
-    def annotate(self, knit, key):
-        content = knit._get_content(key)
-        # adjust for the fact that serialised annotations are only key suffixes
-        # for this factory.
-        if type(key) == tuple:
-            prefix = key[:-1]
-            origins = content.annotate()
-            result = []
-            for origin, line in origins:
-                result.append((prefix + (origin,), line))
-            return result
-        else:
-            # XXX: This smells a bit.  Why would key ever be a non-tuple here?
-            # Aren't keys defined to be tuples?  -- spiv 20080618
-            return content.annotate()
-
-
-class KnitPlainFactory(_KnitFactory):
+    def annotate_iter(self, knit, version_id):
+        content = knit._get_content(version_id)
+        return content.annotate_iter()
+
+
+class KnitPlainFactory(object):
     """Factory for creating plain Content objects."""
 
     annotated = False
@@ -630,127 +404,476 @@
             out.extend(lines)
         return out
 
-    def annotate(self, knit, key):
-        annotator = _KnitAnnotator(knit)
-        return annotator.annotate(key)
-
-
-
-def make_file_factory(annotated, mapper):
-    """Create a factory for creating a file based KnitVersionedFiles.
-
-    This is only functional enough to run interface tests, it doesn't try to
-    provide a full pack environment.
-    
-    :param annotated: knit annotations are wanted.
-    :param mapper: The mapper from keys to paths.
-    """
-    def factory(transport):
-        index = _KndxIndex(transport, mapper, lambda:None, lambda:True, lambda:True)
-        access = _KnitKeyAccess(transport, mapper)
-        return KnitVersionedFiles(index, access, annotated=annotated)
-    return factory
-
-
-def make_pack_factory(graph, delta, keylength):
-    """Create a factory for creating a pack based VersionedFiles.
-
-    This is only functional enough to run interface tests, it doesn't try to
-    provide a full pack environment.
-    
-    :param graph: Store a graph.
-    :param delta: Delta compress contents.
-    :param keylength: How long should keys be.
-    """
-    def factory(transport):
-        parents = graph or delta
-        ref_length = 0
-        if graph:
-            ref_length += 1
+    def annotate_iter(self, knit, version_id):
+        return annotate_knit(knit, version_id)
+
+
+def make_empty_knit(transport, relpath):
+    """Construct a empty knit at the specified location."""
+    k = KnitVersionedFile(transport, relpath, 'w', KnitPlainFactory)
+
+
+class KnitVersionedFile(VersionedFile):
+    """Weave-like structure with faster random access.
+
+    A knit stores a number of texts and a summary of the relationships
+    between them.  Texts are identified by a string version-id.  Texts
+    are normally stored and retrieved as a series of lines, but can
+    also be passed as single strings.
+
+    Lines are stored with the trailing newline (if any) included, to
+    avoid special cases for files with no final newline.  Lines are
+    composed of 8-bit characters, not unicode.  The combination of
+    these approaches should mean any 'binary' file can be safely
+    stored and retrieved.
+    """
+
+    def __init__(self, relpath, transport, file_mode=None, access_mode=None,
+        factory=None, delta=True, create=False, create_parent_dir=False,
+        delay_create=False, dir_mode=None, index=None, access_method=None):
+        """Construct a knit at location specified by relpath.
+        
+        :param create: If not True, only open an existing knit.
+        :param create_parent_dir: If True, create the parent directory if 
+            creating the file fails. (This is used for stores with 
+            hash-prefixes that may not exist yet)
+        :param delay_create: The calling code is aware that the knit won't 
+            actually be created until the first data is stored.
+        :param index: An index to use for the knit.
+        """
+        if access_mode is None:
+            access_mode = 'w'
+        super(KnitVersionedFile, self).__init__(access_mode)
+        assert access_mode in ('r', 'w'), "invalid mode specified %r" % access_mode
+        self.transport = transport
+        self.filename = relpath
+        self.factory = factory or KnitAnnotateFactory()
+        self.writable = (access_mode == 'w')
+        self.delta = delta
+
+        self._max_delta_chain = 200
+
+        if index is None:
+            self._index = _KnitIndex(transport, relpath + INDEX_SUFFIX,
+                access_mode, create=create, file_mode=file_mode,
+                create_parent_dir=create_parent_dir, delay_create=delay_create,
+                dir_mode=dir_mode)
+        else:
+            self._index = index
+        if access_method is None:
+            _access = _KnitAccess(transport, relpath + DATA_SUFFIX, file_mode, dir_mode,
+                ((create and not len(self)) and delay_create), create_parent_dir)
+        else:
+            _access = access_method
+        if create and not len(self) and not delay_create:
+            _access.create()
+        self._data = _KnitData(_access)
+
+    def __repr__(self):
+        return '%s(%s)' % (self.__class__.__name__,
+                           self.transport.abspath(self.filename))
+    
+    def _check_should_delta(self, first_parents):
+        """Iterate back through the parent listing, looking for a fulltext.
+
+        This is used when we want to decide whether to add a delta or a new
+        fulltext. It searches for _max_delta_chain parents. When it finds a
+        fulltext parent, it sees if the total size of the deltas leading up to
+        it is large enough to indicate that we want a new full text anyway.
+
+        Return True if we should create a new delta, False if we should use a
+        full text.
+        """
+        delta_size = 0
+        fulltext_size = None
+        delta_parents = first_parents
+        for count in xrange(self._max_delta_chain):
+            parent = delta_parents[0]
+            method = self._index.get_method(parent)
+            index, pos, size = self._index.get_position(parent)
+            if method == 'fulltext':
+                fulltext_size = size
+                break
+            delta_size += size
+            delta_parents = self._index.get_parents(parent)
+        else:
+            # We couldn't find a fulltext, so we must create a new one
+            return False
+
+        return fulltext_size > delta_size
+
+    def _add_raw_records(self, records, data):
+        """Add all the records 'records' with data pre-joined in 'data'.
+
+        :param records: A list of tuples(version_id, options, parents, size).
+        :param data: The data for the records. When it is written, the records
+                     are adjusted to have pos pointing into data by the sum of
+                     the preceding records sizes.
+        """
+        # write all the data
+        raw_record_sizes = [record[3] for record in records]
+        positions = self._data.add_raw_records(raw_record_sizes, data)
+        offset = 0
+        index_entries = []
+        for (version_id, options, parents, size), access_memo in zip(
+            records, positions):
+            index_entries.append((version_id, options, access_memo, parents))
+            if self._data._do_cache:
+                self._data._cache[version_id] = data[offset:offset+size]
+            offset += size
+        self._index.add_versions(index_entries)
+
+    def enable_cache(self):
+        """Start caching data for this knit"""
+        self._data.enable_cache()
+
+    def clear_cache(self):
+        """Clear the data cache only."""
+        self._data.clear_cache()
+
+    def copy_to(self, name, transport):
+        """See VersionedFile.copy_to()."""
+        # copy the current index to a temp index to avoid racing with local
+        # writes
+        transport.put_file_non_atomic(name + INDEX_SUFFIX + '.tmp',
+                self.transport.get(self._index._filename))
+        # copy the data file
+        f = self._data._open_file()
+        try:
+            transport.put_file(name + DATA_SUFFIX, f)
+        finally:
+            f.close()
+        # move the copied index into place
+        transport.move(name + INDEX_SUFFIX + '.tmp', name + INDEX_SUFFIX)
+
+    def create_empty(self, name, transport, mode=None):
+        return KnitVersionedFile(name, transport, factory=self.factory,
+                                 delta=self.delta, create=True)
+    
+    def get_data_stream(self, required_versions):
+        """Get a data stream for the specified versions.
+
+        Versions may be returned in any order, not necessarily the order
+        specified.
+
+        :param required_versions: The exact set of versions to be extracted.
+            Unlike some other knit methods, this is not used to generate a
+            transitive closure, rather it is used precisely as given.
+        
+        :returns: format_signature, list of (version, options, length, parents),
+            reader_callable.
+        """
+        if not isinstance(required_versions, set):
+            required_versions = set(required_versions)
+        # we don't care about inclusions, the caller cares.
+        # but we need to setup a list of records to visit.
+        for version_id in required_versions:
+            if not self.has_version(version_id):
+                raise RevisionNotPresent(version_id, self.filename)
+        # Pick the desired versions out of the index in oldest-to-newest order
+        version_list = []
+        for version_id in self.versions():
+            if version_id in required_versions:
+                version_list.append(version_id)
+
+        # create the list of version information for the result
+        copy_queue_records = []
+        copy_set = set()
+        result_version_list = []
+        for version_id in version_list:
+            options = self._index.get_options(version_id)
+            parents = self._index.get_parents_with_ghosts(version_id)
+            index_memo = self._index.get_position(version_id)
+            copy_queue_records.append((version_id, index_memo))
+            none, data_pos, data_size = index_memo
+            copy_set.add(version_id)
+            # version, options, length, parents
+            result_version_list.append((version_id, options, data_size,
+                parents))
+
+        # Read the compressed record data.
+        # XXX:
+        # From here down to the return should really be logic in the returned
+        # callable -- in a class that adapts read_records_iter_raw to read
+        # requests.
+        raw_datum = []
+        for (version_id, raw_data), \
+            (version_id2, options, _, parents) in \
+            izip(self._data.read_records_iter_raw(copy_queue_records),
+                 result_version_list):
+            assert version_id == version_id2, 'logic error, inconsistent results'
+            raw_datum.append(raw_data)
+        pseudo_file = StringIO(''.join(raw_datum))
+        def read(length):
+            if length is None:
+                return pseudo_file.read()
+            else:
+                return pseudo_file.read(length)
+        return (self.get_format_signature(), result_version_list, read)
+
+    def _extract_blocks(self, version_id, source, target):
+        if self._index.get_method(version_id) != 'line-delta':
+            return None
+        parent, sha1, noeol, delta = self.get_delta(version_id)
+        return KnitContent.get_line_delta_blocks(delta, source, target)
+
+    def get_delta(self, version_id):
+        """Get a delta for constructing version from some other version."""
+        self.check_not_reserved_id(version_id)
+        parents = self.get_parents(version_id)
+        if len(parents):
+            parent = parents[0]
+        else:
+            parent = None
+        index_memo = self._index.get_position(version_id)
+        data, sha1 = self._data.read_records(((version_id, index_memo),))[version_id]
+        noeol = 'no-eol' in self._index.get_options(version_id)
+        if 'fulltext' == self._index.get_method(version_id):
+            new_content = self.factory.parse_fulltext(data, version_id)
+            if parent is not None:
+                reference_content = self._get_content(parent)
+                old_texts = reference_content.text()
+            else:
+                old_texts = []
+            new_texts = new_content.text()
+            delta_seq = patiencediff.PatienceSequenceMatcher(None, old_texts,
+                                                             new_texts)
+            return parent, sha1, noeol, self._make_line_delta(delta_seq, new_content)
+        else:
+            delta = self.factory.parse_line_delta(data, version_id)
+            return parent, sha1, noeol, delta
+
+    def get_format_signature(self):
+        """See VersionedFile.get_format_signature()."""
+        if self.factory.annotated:
+            annotated_part = "annotated"
+        else:
+            annotated_part = "plain"
+        return "knit-%s" % (annotated_part,)
+        
+    def get_graph_with_ghosts(self):
+        """See VersionedFile.get_graph_with_ghosts()."""
+        graph_items = self._index.get_graph()
+        return dict(graph_items)
+
+    def get_sha1(self, version_id):
+        return self.get_sha1s([version_id])[0]
+
+    def get_sha1s(self, version_ids):
+        """See VersionedFile.get_sha1()."""
+        record_map = self._get_record_map(version_ids)
+        # record entry 2 is the 'digest'.
+        return [record_map[v][2] for v in version_ids]
+
+    @staticmethod
+    def get_suffixes():
+        """See VersionedFile.get_suffixes()."""
+        return [DATA_SUFFIX, INDEX_SUFFIX]
+
+    def has_ghost(self, version_id):
+        """True if there is a ghost reference in the file to version_id."""
+        # maybe we have it
+        if self.has_version(version_id):
+            return False
+        # optimisable if needed by memoising the _ghosts set.
+        items = self._index.get_graph()
+        for node, parents in items:
+            for parent in parents:
+                if parent not in self._index._cache:
+                    if parent == version_id:
+                        return True
+        return False
+
+    def insert_data_stream(self, (format, data_list, reader_callable)):
+        """Insert knit records from a data stream into this knit.
+
+        If a version in the stream is already present in this knit, it will not
+        be inserted a second time.  It will be checked for consistency with the
+        stored version however, and may cause a KnitCorrupt error to be raised
+        if the data in the stream disagrees with the already stored data.
+        
+        :seealso: get_data_stream
+        """
+        if format != self.get_format_signature():
+            trace.mutter('incompatible format signature inserting to %r', self)
+            raise KnitDataStreamIncompatible(
+                format, self.get_format_signature())
+
+        for version_id, options, length, parents in data_list:
+            if self.has_version(version_id):
+                # First check: the list of parents.
+                my_parents = self.get_parents_with_ghosts(version_id)
+                if my_parents != parents:
+                    # XXX: KnitCorrupt is not quite the right exception here.
+                    raise KnitCorrupt(
+                        self.filename,
+                        'parents list %r from data stream does not match '
+                        'already recorded parents %r for %s'
+                        % (parents, my_parents, version_id))
+
+                # Also check the SHA-1 of the fulltext this content will
+                # produce.
+                raw_data = reader_callable(length)
+                my_fulltext_sha1 = self.get_sha1(version_id)
+                df, rec = self._data._parse_record_header(version_id, raw_data)
+                stream_fulltext_sha1 = rec[3]
+                if my_fulltext_sha1 != stream_fulltext_sha1:
+                    # Actually, we don't know if it's this knit that's corrupt,
+                    # or the data stream we're trying to insert.
+                    raise KnitCorrupt(
+                        self.filename, 'sha-1 does not match %s' % version_id)
+            else:
+                if 'line-delta' in options:
+                    # Make sure that this knit record is actually useful: a
+                    # line-delta is no use unless we have its parent.
+                    # Fetching from a broken repository with this problem
+                    # shouldn't break the target repository.
+                    if not self._index.has_version(parents[0]):
+                        raise KnitCorrupt(
+                            self.filename,
+                            'line-delta from stream references '
+                            'missing parent %s' % parents[0])
+                self._add_raw_records(
+                    [(version_id, options, parents, length)],
+                    reader_callable(length))
+
+    def versions(self):
+        """See VersionedFile.versions."""
+        if 'evil' in debug.debug_flags:
+            trace.mutter_callsite(2, "versions scales with size of history")
+        return self._index.get_versions()
+
+    def has_version(self, version_id):
+        """See VersionedFile.has_version."""
+        if 'evil' in debug.debug_flags:
+            trace.mutter_callsite(2, "has_version is a LBYL scenario")
+        return self._index.has_version(version_id)
+
+    __contains__ = has_version
+
+    def _merge_annotations(self, content, parents, parent_texts={},
+                           delta=None, annotated=None,
+                           left_matching_blocks=None):
+        """Merge annotations for content.  This is done by comparing
+        the annotations based on changed to the text.
+        """
+        if left_matching_blocks is not None:
+            delta_seq = diff._PrematchedMatcher(left_matching_blocks)
+        else:
+            delta_seq = None
+        if annotated:
+            for parent_id in parents:
+                merge_content = self._get_content(parent_id, parent_texts)
+                if (parent_id == parents[0] and delta_seq is not None):
+                    seq = delta_seq
+                else:
+                    seq = patiencediff.PatienceSequenceMatcher(
+                        None, merge_content.text(), content.text())
+                for i, j, n in seq.get_matching_blocks():
+                    if n == 0:
+                        continue
+                    # this appears to copy (origin, text) pairs across to the
+                    # new content for any line that matches the last-checked
+                    # parent.
+                    content._lines[j:j+n] = merge_content._lines[i:i+n]
         if delta:
-            ref_length += 1
-            max_delta_chain = 200
-        else:
-            max_delta_chain = 0
-        graph_index = _mod_index.InMemoryGraphIndex(reference_lists=ref_length,
-            key_elements=keylength)
-        stream = transport.open_write_stream('newpack')
-        writer = pack.ContainerWriter(stream.write)
-        writer.begin()
-        index = _KnitGraphIndex(graph_index, lambda:True, parents=parents,
-            deltas=delta, add_callback=graph_index.add_nodes)
-        access = _DirectPackAccess({})
-        access.set_writer(writer, graph_index, (transport, 'newpack'))
-        result = KnitVersionedFiles(index, access,
-            max_delta_chain=max_delta_chain)
-        result.stream = stream
-        result.writer = writer
-        return result
-    return factory
-
-
-def cleanup_pack_knit(versioned_files):
-    versioned_files.stream.close()
-    versioned_files.writer.end()
-
-
-class KnitVersionedFiles(VersionedFiles):
-    """Storage for many versioned files using knit compression.
-
-    Backend storage is managed by indices and data objects.
-
-    :ivar _index: A _KnitGraphIndex or similar that can describe the 
-        parents, graph, compression and data location of entries in this 
-        KnitVersionedFiles.  Note that this is only the index for 
-        *this* vfs; if there are fallbacks they must be queried separately.
-    """
-
-    def __init__(self, index, data_access, max_delta_chain=200,
-        annotated=False):
-        """Create a KnitVersionedFiles with index and data_access.
-
-        :param index: The index for the knit data.
-        :param data_access: The access object to store and retrieve knit
-            records.
-        :param max_delta_chain: The maximum number of deltas to permit during
-            insertion. Set to 0 to prohibit the use of deltas.
-        :param annotated: Set to True to cause annotations to be calculated and
-            stored during insertion.
-        """
-        self._index = index
-        self._access = data_access
-        self._max_delta_chain = max_delta_chain
-        if annotated:
-            self._factory = KnitAnnotateFactory()
-        else:
-            self._factory = KnitPlainFactory()
-        self._fallback_vfs = []
-
-    def add_fallback_versioned_files(self, a_versioned_files):
-        """Add a source of texts for texts not present in this knit.
-
-        :param a_versioned_files: A VersionedFiles object.
-        """
-        self._fallback_vfs.append(a_versioned_files)
-
-    def add_lines(self, key, parents, lines, parent_texts=None,
-        left_matching_blocks=None, nostore_sha=None, random_id=False,
-        check_content=True):
-        """See VersionedFiles.add_lines()."""
-        self._index._check_write_ok()
-        self._check_add(key, lines, random_id, check_content)
-        if parents is None:
-            # The caller might pass None if there is no graph data, but kndx
-            # indexes can't directly store that, so we give them
-            # an empty tuple instead.
-            parents = ()
-        return self._add(key, lines, parents,
+            if delta_seq is None:
+                reference_content = self._get_content(parents[0], parent_texts)
+                new_texts = content.text()
+                old_texts = reference_content.text()
+                delta_seq = patiencediff.PatienceSequenceMatcher(
+                                                 None, old_texts, new_texts)
+            return self._make_line_delta(delta_seq, content)
+
+    def _make_line_delta(self, delta_seq, new_content):
+        """Generate a line delta from delta_seq and new_content."""
+        diff_hunks = []
+        for op in delta_seq.get_opcodes():
+            if op[0] == 'equal':
+                continue
+            diff_hunks.append((op[1], op[2], op[4]-op[3], new_content._lines[op[3]:op[4]]))
+        return diff_hunks
+
+    def _get_components_positions(self, version_ids):
+        """Produce a map of position data for the components of versions.
+
+        This data is intended to be used for retrieving the knit records.
+
+        A dict of version_id to (method, data_pos, data_size, next) is
+        returned.
+        method is the way referenced data should be applied.
+        data_pos is the position of the data in the knit.
+        data_size is the size of the data in the knit.
+        next is the build-parent of the version, or None for fulltexts.
+        """
+        component_data = {}
+        for version_id in version_ids:
+            cursor = version_id
+
+            while cursor is not None and cursor not in component_data:
+                method = self._index.get_method(cursor)
+                if method == 'fulltext':
+                    next = None
+                else:
+                    next = self.get_parents(cursor)[0]
+                index_memo = self._index.get_position(cursor)
+                component_data[cursor] = (method, index_memo, next)
+                cursor = next
+        return component_data
+       
+    def _get_content(self, version_id, parent_texts={}):
+        """Returns a content object that makes up the specified
+        version."""
+        cached_version = parent_texts.get(version_id, None)
+        if cached_version is not None:
+            if not self.has_version(version_id):
+                raise RevisionNotPresent(version_id, self.filename)
+            return cached_version
+
+        text_map, contents_map = self._get_content_maps([version_id])
+        return contents_map[version_id]
+
+    def _check_versions_present(self, version_ids):
+        """Check that all specified versions are present."""
+        self._index.check_versions_present(version_ids)
+
+    def _add_lines_with_ghosts(self, version_id, parents, lines, parent_texts,
+        nostore_sha, random_id, check_content):
+        """See VersionedFile.add_lines_with_ghosts()."""
+        self._check_add(version_id, lines, random_id, check_content)
+        return self._add(version_id, lines, parents, self.delta,
+            parent_texts, None, nostore_sha, random_id)
+
+    def _add_lines(self, version_id, parents, lines, parent_texts,
+        left_matching_blocks, nostore_sha, random_id, check_content):
+        """See VersionedFile.add_lines."""
+        self._check_add(version_id, lines, random_id, check_content)
+        self._check_versions_present(parents)
+        return self._add(version_id, lines[:], parents, self.delta,
             parent_texts, left_matching_blocks, nostore_sha, random_id)
 
-    def _add(self, key, lines, parents, parent_texts,
+    def _check_add(self, version_id, lines, random_id, check_content):
+        """check that version_id and lines are safe to add."""
+        if contains_whitespace(version_id):
+            raise InvalidRevisionId(version_id, self.filename)
+        self.check_not_reserved_id(version_id)
+        # Technically this could be avoided if we are happy to allow duplicate
+        # id insertion when other things than bzr core insert texts, but it
+        # seems useful for folk using the knit api directly to have some safety
+        # blanket that we can disable.
+        if not random_id and self.has_version(version_id):
+            raise RevisionAlreadyPresent(version_id, self.filename)
+        if check_content:
+            self._check_lines_not_unicode(lines)
+            self._check_lines_are_lines(lines)
+
+    def _add(self, version_id, lines, parents, delta, parent_texts,
         left_matching_blocks, nostore_sha, random_id):
         """Add a set of lines on top of version specified by parents.
 
+        If delta is true, compress the text as a line-delta against
+        the first parent.
+
         Any versions not present will be converted into ghosts.
         """
         # first thing, if the content is something we don't need to store, find
@@ -763,21 +886,15 @@
         present_parents = []
         if parent_texts is None:
             parent_texts = {}
-        # Do a single query to ascertain parent presence.
-        present_parent_map = self.get_parent_map(parents)
         for parent in parents:
-            if parent in present_parent_map:
+            if self.has_version(parent):
                 present_parents.append(parent)
 
-        # Currently we can only compress against the left most present parent.
-        if (len(present_parents) == 0 or
-            present_parents[0] != parents[0]):
+        # can only compress against the left most present parent.
+        if (delta and
+            (len(present_parents) == 0 or
+             present_parents[0] != parents[0])):
             delta = False
-        else:
-            # To speed the extract of texts the delta chain is limited
-            # to a fixed number of deltas.  This should minimize both
-            # I/O and the time spend applying deltas.
-            delta = self._check_should_delta(present_parents[0])
 
         text_length = len(line_bytes)
         options = []
@@ -789,858 +906,299 @@
                 lines[-1] = lines[-1] + '\n'
                 line_bytes += '\n'
 
-        for element in key:
-            if type(element) != str:
-                raise TypeError("key contains non-strings: %r" % (key,))
-        # Knit hunks are still last-element only
-        version_id = key[-1]
-        content = self._factory.make(lines, version_id)
-        if 'no-eol' in options:
-            # Hint to the content object that its text() call should strip the
-            # EOL.
-            content._should_strip_eol = True
-        if delta or (self._factory.annotated and len(present_parents) > 0):
+        if delta:
+            # To speed the extract of texts the delta chain is limited
+            # to a fixed number of deltas.  This should minimize both
+            # I/O and the time spend applying deltas.
+            delta = self._check_should_delta(present_parents)
+
+        assert isinstance(version_id, str)
+        content = self.factory.make(lines, version_id)
+        if delta or (self.factory.annotated and len(present_parents) > 0):
             # Merge annotations from parent texts if needed.
             delta_hunks = self._merge_annotations(content, present_parents,
-                parent_texts, delta, self._factory.annotated,
+                parent_texts, delta, self.factory.annotated,
                 left_matching_blocks)
 
         if delta:
             options.append('line-delta')
-            store_lines = self._factory.lower_line_delta(delta_hunks)
-            size, bytes = self._record_to_data(key, digest,
+            store_lines = self.factory.lower_line_delta(delta_hunks)
+            size, bytes = self._data._record_to_data(version_id, digest,
                 store_lines)
         else:
             options.append('fulltext')
             # isinstance is slower and we have no hierarchy.
-            if self._factory.__class__ == KnitPlainFactory:
+            if self.factory.__class__ == KnitPlainFactory:
                 # Use the already joined bytes saving iteration time in
                 # _record_to_data.
-                size, bytes = self._record_to_data(key, digest,
+                size, bytes = self._data._record_to_data(version_id, digest,
                     lines, [line_bytes])
             else:
                 # get mixed annotation + content and feed it into the
                 # serialiser.
-                store_lines = self._factory.lower_fulltext(content)
-                size, bytes = self._record_to_data(key, digest,
+                store_lines = self.factory.lower_fulltext(content)
+                size, bytes = self._data._record_to_data(version_id, digest,
                     store_lines)
 
-        access_memo = self._access.add_raw_records([(key, size)], bytes)[0]
-        self._index.add_records(
-            ((key, options, access_memo, parents),),
+        access_memo = self._data.add_raw_records([size], bytes)[0]
+        self._index.add_versions(
+            ((version_id, options, access_memo, parents),),
             random_id=random_id)
         return digest, text_length, content
 
-    def annotate(self, key):
-        """See VersionedFiles.annotate."""
-        return self._factory.annotate(self, key)
-
     def check(self, progress_bar=None):
-        """See VersionedFiles.check()."""
-        # This doesn't actually test extraction of everything, but that will
-        # impact 'bzr check' substantially, and needs to be integrated with
-        # care. However, it does check for the obvious problem of a delta with
-        # no basis.
-        keys = self._index.keys()
-        parent_map = self.get_parent_map(keys)
-        for key in keys:
-            if self._index.get_method(key) != 'fulltext':
-                compression_parent = parent_map[key][0]
-                if compression_parent not in parent_map:
-                    raise errors.KnitCorrupt(self,
-                        "Missing basis parent %s for %s" % (
-                        compression_parent, key))
-        for fallback_vfs in self._fallback_vfs:
-            fallback_vfs.check()
-
-    def _check_add(self, key, lines, random_id, check_content):
-        """check that version_id and lines are safe to add."""
-        version_id = key[-1]
-        if contains_whitespace(version_id):
-            raise InvalidRevisionId(version_id, self)
-        self.check_not_reserved_id(version_id)
-        # TODO: If random_id==False and the key is already present, we should
-        # probably check that the existing content is identical to what is
-        # being inserted, and otherwise raise an exception.  This would make
-        # the bundle code simpler.
-        if check_content:
-            self._check_lines_not_unicode(lines)
-            self._check_lines_are_lines(lines)
-
-    def _check_header(self, key, line):
-        rec = self._split_header(line)
-        self._check_header_version(rec, key[-1])
-        return rec
-
-    def _check_header_version(self, rec, version_id):
-        """Checks the header version on original format knit records.
+        """See VersionedFile.check()."""
+
+    def _clone_text(self, new_version_id, old_version_id, parents):
+        """See VersionedFile.clone_text()."""
+        # FIXME RBC 20060228 make fast by only inserting an index with null 
+        # delta.
+        self.add_lines(new_version_id, parents, self.get_lines(old_version_id))
+
+    def get_lines(self, version_id):
+        """See VersionedFile.get_lines()."""
+        return self.get_line_list([version_id])[0]
+
+    def _get_record_map(self, version_ids):
+        """Produce a dictionary of knit records.
         
-        These have the last component of the key embedded in the record.
-        """
-        if rec[1] != version_id:
-            raise KnitCorrupt(self,
-                'unexpected version, wanted %r, got %r' % (version_id, rec[1]))
-
-    def _check_should_delta(self, parent):
-        """Iterate back through the parent listing, looking for a fulltext.
-
-        This is used when we want to decide whether to add a delta or a new
-        fulltext. It searches for _max_delta_chain parents. When it finds a
-        fulltext parent, it sees if the total size of the deltas leading up to
-        it is large enough to indicate that we want a new full text anyway.
-
-        Return True if we should create a new delta, False if we should use a
-        full text.
-        """
-        delta_size = 0
-        fulltext_size = None
-        for count in xrange(self._max_delta_chain):
-            # XXX: Collapse these two queries:
-            try:
-                # Note that this only looks in the index of this particular
-                # KnitVersionedFiles, not in the fallbacks.  This ensures that
-                # we won't store a delta spanning physical repository
-                # boundaries.
-                method = self._index.get_method(parent)
-            except RevisionNotPresent:
-                # Some basis is not locally present: always delta
-                return False
-            index, pos, size = self._index.get_position(parent)
-            if method == 'fulltext':
-                fulltext_size = size
-                break
-            delta_size += size
-            # We don't explicitly check for presence because this is in an
-            # inner loop, and if it's missing it'll fail anyhow.
-            # TODO: This should be asking for compression parent, not graph
-            # parent.
-            parent = self._index.get_parent_map([parent])[parent][0]
-        else:
-            # We couldn't find a fulltext, so we must create a new one
-            return False
-        # Simple heuristic - if the total I/O wold be greater as a delta than
-        # the originally installed fulltext, we create a new fulltext.
-        return fulltext_size > delta_size
-
-    def _build_details_to_components(self, build_details):
-        """Convert a build_details tuple to a position tuple."""
-        # record_details, access_memo, compression_parent
-        return build_details[3], build_details[0], build_details[1]
-
-    def _get_components_positions(self, keys, allow_missing=False):
-        """Produce a map of position data for the components of keys.
-
-        This data is intended to be used for retrieving the knit records.
-
-        A dict of key to (record_details, index_memo, next, parents) is
-        returned.
-        method is the way referenced data should be applied.
-        index_memo is the handle to pass to the data access to actually get the
-            data
-        next is the build-parent of the version, or None for fulltexts.
-        parents is the version_ids of the parents of this version
-
-        :param allow_missing: If True do not raise an error on a missing component,
-            just ignore it.
-        """
-        component_data = {}
-        pending_components = keys
-        while pending_components:
-            build_details = self._index.get_build_details(pending_components)
-            current_components = set(pending_components)
-            pending_components = set()
-            for key, details in build_details.iteritems():
-                (index_memo, compression_parent, parents,
-                 record_details) = details
-                method = record_details[0]
-                if compression_parent is not None:
-                    pending_components.add(compression_parent)
-                component_data[key] = self._build_details_to_components(details)
-            missing = current_components.difference(build_details)
-            if missing and not allow_missing:
-                raise errors.RevisionNotPresent(missing.pop(), self)
-        return component_data
-       
-    def _get_content(self, key, parent_texts={}):
-        """Returns a content object that makes up the specified
-        version."""
-        cached_version = parent_texts.get(key, None)
-        if cached_version is not None:
-            # Ensure the cache dict is valid.
-            if not self.get_parent_map([key]):
-                raise RevisionNotPresent(key, self)
-            return cached_version
-        text_map, contents_map = self._get_content_maps([key])
-        return contents_map[key]
-
-    def _get_content_maps(self, keys, nonlocal_keys=None):
+        The keys are version_ids, the values are tuples of (method, content,
+        digest, next).
+        method is the way the content should be applied.  
+        content is a KnitContent object.
+        digest is the SHA1 digest of this version id after all steps are done
+        next is the build-parent of the version, i.e. the leftmost ancestor.
+        If the method is fulltext, next will be None.
+        """
+        position_map = self._get_components_positions(version_ids)
+        # c = component_id, m = method, i_m = index_memo, n = next
+        records = [(c, i_m) for c, (m, i_m, n) in position_map.iteritems()]
+        record_map = {}
+        for component_id, content, digest in \
+                self._data.read_records_iter(records):
+            method, index_memo, next = position_map[component_id]
+            record_map[component_id] = method, content, digest, next
+                          
+        return record_map
+
+    def get_text(self, version_id):
+        """See VersionedFile.get_text"""
+        return self.get_texts([version_id])[0]
+
+    def get_texts(self, version_ids):
+        return [''.join(l) for l in self.get_line_list(version_ids)]
+
+    def get_line_list(self, version_ids):
+        """Return the texts of listed versions as a list of strings."""
+        for version_id in version_ids:
+            self.check_not_reserved_id(version_id)
+        text_map, content_map = self._get_content_maps(version_ids)
+        return [text_map[v] for v in version_ids]
+
+    _get_lf_split_line_list = get_line_list
+
+    def _get_content_maps(self, version_ids):
         """Produce maps of text and KnitContents
         
-        :param keys: The keys to produce content maps for.
-        :param nonlocal_keys: An iterable of keys(possibly intersecting keys)
-            which are known to not be in this knit, but rather in one of the
-            fallback knits.
         :return: (text_map, content_map) where text_map contains the texts for
-            the requested versions and content_map contains the KnitContents.
+        the requested versions and content_map contains the KnitContents.
+        Both dicts take version_ids as their keys.
         """
-        # FUTURE: This function could be improved for the 'extract many' case
-        # by tracking each component and only doing the copy when the number of
-        # children than need to apply delta's to it is > 1 or it is part of the
-        # final output.
-        keys = list(keys)
-        multiple_versions = len(keys) != 1
-        record_map = self._get_record_map(keys, allow_missing=True)
+        record_map = self._get_record_map(version_ids)
 
         text_map = {}
         content_map = {}
         final_content = {}
-        if nonlocal_keys is None:
-            nonlocal_keys = set()
-        else:
-            nonlocal_keys = frozenset(nonlocal_keys)
-        missing_keys = set(nonlocal_keys)
-        for source in self._fallback_vfs:
-            if not missing_keys:
-                break
-            for record in source.get_record_stream(missing_keys,
-                'unordered', True):
-                if record.storage_kind == 'absent':
-                    continue
-                missing_keys.remove(record.key)
-                lines = split_lines(record.get_bytes_as('fulltext'))
-                text_map[record.key] = lines
-                content_map[record.key] = PlainKnitContent(lines, record.key)
-                if record.key in keys:
-                    final_content[record.key] = content_map[record.key]
-        for key in keys:
-            if key in nonlocal_keys:
-                # already handled
-                continue
+        for version_id in version_ids:
             components = []
-            cursor = key
+            cursor = version_id
             while cursor is not None:
-                try:
-                    record, record_details, digest, next = record_map[cursor]
-                except KeyError:
-                    raise RevisionNotPresent(cursor, self)
-                components.append((cursor, record, record_details, digest))
-                cursor = next
+                method, data, digest, next = record_map[cursor]
+                components.append((cursor, method, data, digest))
                 if cursor in content_map:
-                    # no need to plan further back
-                    components.append((cursor, None, None, None))
                     break
+                cursor = next
 
             content = None
-            for (component_id, record, record_details,
-                 digest) in reversed(components):
+            for component_id, method, data, digest in reversed(components):
                 if component_id in content_map:
                     content = content_map[component_id]
                 else:
-                    content, delta = self._factory.parse_record(key[-1],
-                        record, record_details, content,
-                        copy_base_content=multiple_versions)
-                    if multiple_versions:
-                        content_map[component_id] = content
+                    if method == 'fulltext':
+                        assert content is None
+                        content = self.factory.parse_fulltext(data, version_id)
+                    elif method == 'line-delta':
+                        delta = self.factory.parse_line_delta(data, version_id)
+                        content = content.copy()
+                        content._lines = self._apply_delta(content._lines,
+                                                           delta)
+                    content_map[component_id] = content
 
-            final_content[key] = content
+            if 'no-eol' in self._index.get_options(version_id):
+                content = content.copy()
+                content.strip_last_line_newline()
+            final_content[version_id] = content
 
             # digest here is the digest from the last applied component.
             text = content.text()
             actual_sha = sha_strings(text)
             if actual_sha != digest:
-                raise KnitCorrupt(self,
+                raise KnitCorrupt(self.filename,
                     '\n  sha-1 %s'
                     '\n  of reconstructed text does not match'
                     '\n  expected %s'
                     '\n  for version %s' %
-                    (actual_sha, digest, key))
-            text_map[key] = text
+                    (actual_sha, digest, version_id))
+            text_map[version_id] = text
         return text_map, final_content
 
-    def get_parent_map(self, keys):
-        """Get a map of the graph parents of keys.
-
-        :param keys: The keys to look up parents for.
-        :return: A mapping from keys to parents. Absent keys are absent from
-            the mapping.
-        """
-        return self._get_parent_map_with_sources(keys)[0]
-
-    def _get_parent_map_with_sources(self, keys):
-        """Get a map of the parents of keys.
-
-        :param keys: The keys to look up parents for.
-        :return: A tuple. The first element is a mapping from keys to parents.
-            Absent keys are absent from the mapping. The second element is a
-            list with the locations each key was found in. The first element
-            is the in-this-knit parents, the second the first fallback source,
-            and so on.
-        """
-        result = {}
-        sources = [self._index] + self._fallback_vfs
-        source_results = []
-        missing = set(keys)
-        for source in sources:
-            if not missing:
-                break
-            new_result = source.get_parent_map(missing)
-            source_results.append(new_result)
-            result.update(new_result)
-            missing.difference_update(set(new_result))
-        return result, source_results
-
-    def _get_record_map(self, keys, allow_missing=False):
-        """Produce a dictionary of knit records.
-        
-        :return: {key:(record, record_details, digest, next)}
-            record
-                data returned from read_records
-            record_details
-                opaque information to pass to parse_record
-            digest
-                SHA1 digest of the full text after all steps are done
-            next
-                build-parent of the version, i.e. the leftmost ancestor.
-                Will be None if the record is not a delta.
-        :param keys: The keys to build a map for
-        :param allow_missing: If some records are missing, rather than 
-            error, just return the data that could be generated.
-        """
-        position_map = self._get_components_positions(keys,
-            allow_missing=allow_missing)
-        # key = component_id, r = record_details, i_m = index_memo, n = next
-        records = [(key, i_m) for key, (r, i_m, n)
-                             in position_map.iteritems()]
-        record_map = {}
-        for key, record, digest in \
-                self._read_records_iter(records):
-            (record_details, index_memo, next) = position_map[key]
-            record_map[key] = record, record_details, digest, next
-        return record_map
-
-    def get_record_stream(self, keys, ordering, include_delta_closure):
-        """Get a stream of records for keys.
-
-        :param keys: The keys to include.
-        :param ordering: Either 'unordered' or 'topological'. A topologically
-            sorted stream has compression parents strictly before their
-            children.
-        :param include_delta_closure: If True then the closure across any
-            compression parents will be included (in the opaque data).
-        :return: An iterator of ContentFactory objects, each of which is only
-            valid until the iterator is advanced.
-        """
-        # keys might be a generator
-        keys = set(keys)
-        if not keys:
-            return
-        if not self._index.has_graph:
-            # Cannot topological order when no graph has been stored.
-            ordering = 'unordered'
-        if include_delta_closure:
-            positions = self._get_components_positions(keys, allow_missing=True)
-        else:
-            build_details = self._index.get_build_details(keys)
-            # map from key to
-            # (record_details, access_memo, compression_parent_key)
-            positions = dict((key, self._build_details_to_components(details))
-                for key, details in build_details.iteritems())
-        absent_keys = keys.difference(set(positions))
-        # There may be more absent keys : if we're missing the basis component
-        # and are trying to include the delta closure.
-        if include_delta_closure:
-            needed_from_fallback = set()
-            # Build up reconstructable_keys dict.  key:True in this dict means
-            # the key can be reconstructed.
-            reconstructable_keys = {}
-            for key in keys:
-                # the delta chain
-                try:
-                    chain = [key, positions[key][2]]
-                except KeyError:
-                    needed_from_fallback.add(key)
-                    continue
-                result = True
-                while chain[-1] is not None:
-                    if chain[-1] in reconstructable_keys:
-                        result = reconstructable_keys[chain[-1]]
-                        break
-                    else:
-                        try:
-                            chain.append(positions[chain[-1]][2])
-                        except KeyError:
-                            # missing basis component
-                            needed_from_fallback.add(chain[-1])
-                            result = True
-                            break
-                for chain_key in chain[:-1]:
-                    reconstructable_keys[chain_key] = result
-                if not result:
-                    needed_from_fallback.add(key)
-        # Double index lookups here : need a unified api ?
-        global_map, parent_maps = self._get_parent_map_with_sources(keys)
-        if ordering == 'topological':
-            # Global topological sort
-            present_keys = tsort.topo_sort(global_map)
-            # Now group by source:
-            source_keys = []
-            current_source = None
-            for key in present_keys:
-                for parent_map in parent_maps:
-                    if key in parent_map:
-                        key_source = parent_map
-                        break
-                if current_source is not key_source:
-                    source_keys.append((key_source, []))
-                    current_source = key_source
-                source_keys[-1][1].append(key)
-        else:
-            if ordering != 'unordered':
-                raise AssertionError('valid values for ordering are:'
-                    ' "unordered" or "topological" not: %r'
-                    % (ordering,))
-            # Just group by source; remote sources first.
-            present_keys = []
-            source_keys = []
-            for parent_map in reversed(parent_maps):
-                source_keys.append((parent_map, []))
-                for key in parent_map:
-                    present_keys.append(key)
-                    source_keys[-1][1].append(key)
-        absent_keys = keys - set(global_map)
-        for key in absent_keys:
-            yield AbsentContentFactory(key)
-        # restrict our view to the keys we can answer.
-        # XXX: Memory: TODO: batch data here to cap buffered data at (say) 1MB.
-        # XXX: At that point we need to consider the impact of double reads by
-        # utilising components multiple times.
-        if include_delta_closure:
-            # XXX: get_content_maps performs its own index queries; allow state
-            # to be passed in.
-            text_map, _ = self._get_content_maps(present_keys,
-                needed_from_fallback - absent_keys)
-            for key in present_keys:
-                yield FulltextContentFactory(key, global_map[key], None,
-                    ''.join(text_map[key]))
-        else:
-            for source, keys in source_keys:
-                if source is parent_maps[0]:
-                    # this KnitVersionedFiles
-                    records = [(key, positions[key][1]) for key in keys]
-                    for key, raw_data, sha1 in self._read_records_iter_raw(records):
-                        (record_details, index_memo, _) = positions[key]
-                        yield KnitContentFactory(key, global_map[key],
-                            record_details, sha1, raw_data, self._factory.annotated, None)
-                else:
-                    vf = self._fallback_vfs[parent_maps.index(source) - 1]
-                    for record in vf.get_record_stream(keys, ordering,
-                        include_delta_closure):
-                        yield record
-
-    def get_sha1s(self, keys):
-        """See VersionedFiles.get_sha1s()."""
-        missing = set(keys)
-        record_map = self._get_record_map(missing, allow_missing=True)
-        result = {}
-        for key, details in record_map.iteritems():
-            if key not in missing:
-                continue
-            # record entry 2 is the 'digest'.
-            result[key] = details[2]
-        missing.difference_update(set(result))
-        for source in self._fallback_vfs:
-            if not missing:
-                break
-            new_result = source.get_sha1s(missing)
-            result.update(new_result)
-            missing.difference_update(set(new_result))
-        return result
-
-    def insert_record_stream(self, stream):
-        """Insert a record stream into this container.
-
-        :param stream: A stream of records to insert. 
-        :return: None
-        :seealso VersionedFiles.get_record_stream:
-        """
-        def get_adapter(adapter_key):
-            try:
-                return adapters[adapter_key]
-            except KeyError:
-                adapter_factory = adapter_registry.get(adapter_key)
-                adapter = adapter_factory(self)
-                adapters[adapter_key] = adapter
-                return adapter
-        if self._factory.annotated:
-            # self is annotated, we need annotated knits to use directly.
-            annotated = "annotated-"
-            convertibles = []
-        else:
-            # self is not annotated, but we can strip annotations cheaply.
-            annotated = ""
-            convertibles = set(["knit-annotated-ft-gz"])
-            if self._max_delta_chain:
-                convertibles.add("knit-annotated-delta-gz")
-        # The set of types we can cheaply adapt without needing basis texts.
-        native_types = set()
-        if self._max_delta_chain:
-            native_types.add("knit-%sdelta-gz" % annotated)
-        native_types.add("knit-%sft-gz" % annotated)
-        knit_types = native_types.union(convertibles)
-        adapters = {}
-        # Buffer all index entries that we can't add immediately because their
-        # basis parent is missing. We don't buffer all because generating
-        # annotations may require access to some of the new records. However we
-        # can't generate annotations from new deltas until their basis parent
-        # is present anyway, so we get away with not needing an index that
-        # includes the new keys.
-        # key = basis_parent, value = index entry to add
-        buffered_index_entries = {}
-        for record in stream:
-            parents = record.parents
-            # Raise an error when a record is missing.
-            if record.storage_kind == 'absent':
-                raise RevisionNotPresent([record.key], self)
-            if record.storage_kind in knit_types:
-                if record.storage_kind not in native_types:
-                    try:
-                        adapter_key = (record.storage_kind, "knit-delta-gz")
-                        adapter = get_adapter(adapter_key)
-                    except KeyError:
-                        adapter_key = (record.storage_kind, "knit-ft-gz")
-                        adapter = get_adapter(adapter_key)
-                    bytes = adapter.get_bytes(
-                        record, record.get_bytes_as(record.storage_kind))
-                else:
-                    bytes = record.get_bytes_as(record.storage_kind)
-                options = [record._build_details[0]]
-                if record._build_details[1]:
-                    options.append('no-eol')
-                # Just blat it across.
-                # Note: This does end up adding data on duplicate keys. As
-                # modern repositories use atomic insertions this should not
-                # lead to excessive growth in the event of interrupted fetches.
-                # 'knit' repositories may suffer excessive growth, but as a
-                # deprecated format this is tolerable. It can be fixed if
-                # needed by in the kndx index support raising on a duplicate
-                # add with identical parents and options.
-                access_memo = self._access.add_raw_records(
-                    [(record.key, len(bytes))], bytes)[0]
-                index_entry = (record.key, options, access_memo, parents)
-                buffered = False
-                if 'fulltext' not in options:
-                    basis_parent = parents[0]
-                    # Note that pack backed knits don't need to buffer here
-                    # because they buffer all writes to the transaction level,
-                    # but we don't expose that difference at the index level. If
-                    # the query here has sufficient cost to show up in
-                    # profiling we should do that.
-                    if basis_parent not in self.get_parent_map([basis_parent]):
-                        pending = buffered_index_entries.setdefault(
-                            basis_parent, [])
-                        pending.append(index_entry)
-                        buffered = True
-                if not buffered:
-                    self._index.add_records([index_entry])
-            elif record.storage_kind == 'fulltext':
-                self.add_lines(record.key, parents,
-                    split_lines(record.get_bytes_as('fulltext')))
-            else:
-                adapter_key = record.storage_kind, 'fulltext'
-                adapter = get_adapter(adapter_key)
-                lines = split_lines(adapter.get_bytes(
-                    record, record.get_bytes_as(record.storage_kind)))
-                try:
-                    self.add_lines(record.key, parents, lines)
-                except errors.RevisionAlreadyPresent:
-                    pass
-            # Add any records whose basis parent is now available.
-            added_keys = [record.key]
-            while added_keys:
-                key = added_keys.pop(0)
-                if key in buffered_index_entries:
-                    index_entries = buffered_index_entries[key]
-                    self._index.add_records(index_entries)
-                    added_keys.extend(
-                        [index_entry[0] for index_entry in index_entries])
-                    del buffered_index_entries[key]
-        # If there were any deltas which had a missing basis parent, error.
-        if buffered_index_entries:
-            raise errors.RevisionNotPresent(buffered_index_entries.keys()[0],
-                self)
-
-    def iter_lines_added_or_present_in_keys(self, keys, pb=None):
-        """Iterate over the lines in the versioned files from keys.
-
-        This may return lines from other keys. Each item the returned
-        iterator yields is a tuple of a line and a text version that that line
-        is present in (not introduced in).
-
-        Ordering of results is in whatever order is most suitable for the
-        underlying storage format.
-
-        If a progress bar is supplied, it may be used to indicate progress.
-        The caller is responsible for cleaning up progress bars (because this
-        is an iterator).
-
-        NOTES:
-         * Lines are normalised by the underlying store: they will all have \n
-           terminators.
-         * Lines are returned in arbitrary order.
-
-        :return: An iterator over (line, key).
-        """
+    @staticmethod
+    def _apply_delta(lines, delta):
+        """Apply delta to lines."""
+        lines = list(lines)
+        offset = 0
+        for start, end, count, delta_lines in delta:
+            lines[offset+start:offset+end] = delta_lines
+            offset = offset + (start - end) + count
+        return lines
+
+    def iter_lines_added_or_present_in_versions(self, version_ids=None, 
+                                                pb=None):
+        """See VersionedFile.iter_lines_added_or_present_in_versions()."""
+        if version_ids is None:
+            version_ids = self.versions()
         if pb is None:
             pb = progress.DummyProgress()
-        keys = set(keys)
-        total = len(keys)
         # we don't care about inclusions, the caller cares.
         # but we need to setup a list of records to visit.
-        # we need key, position, length
-        key_records = []
-        build_details = self._index.get_build_details(keys)
-        for key, details in build_details.iteritems():
-            if key in keys:
-                key_records.append((key, details[0]))
-                keys.remove(key)
-        records_iter = enumerate(self._read_records_iter(key_records))
-        for (key_idx, (key, data, sha_value)) in records_iter:
-            pb.update('Walking content.', key_idx, total)
-            compression_parent = build_details[key][1]
-            if compression_parent is None:
-                # fulltext
-                line_iterator = self._factory.get_fulltext_content(data)
+        # we need version_id, position, length
+        version_id_records = []
+        requested_versions = set(version_ids)
+        # filter for available versions
+        for version_id in requested_versions:
+            if not self.has_version(version_id):
+                raise RevisionNotPresent(version_id, self.filename)
+        # get a in-component-order queue:
+        for version_id in self.versions():
+            if version_id in requested_versions:
+                index_memo = self._index.get_position(version_id)
+                version_id_records.append((version_id, index_memo))
+
+        total = len(version_id_records)
+        for version_idx, (version_id, data, sha_value) in \
+            enumerate(self._data.read_records_iter(version_id_records)):
+            pb.update('Walking content.', version_idx, total)
+            method = self._index.get_method(version_id)
+
+            assert method in ('fulltext', 'line-delta')
+            if method == 'fulltext':
+                line_iterator = self.factory.get_fulltext_content(data)
             else:
-                # Delta 
-                line_iterator = self._factory.get_linedelta_content(data)
-            # XXX: It might be more efficient to yield (key,
-            # line_iterator) in the future. However for now, this is a simpler
-            # change to integrate into the rest of the codebase. RBC 20071110
+                line_iterator = self.factory.get_linedelta_content(data)
             for line in line_iterator:
-                yield line, key
-        for source in self._fallback_vfs:
-            if not keys:
-                break
-            source_keys = set()
-            for line, key in source.iter_lines_added_or_present_in_keys(keys):
-                source_keys.add(key)
-                yield line, key
-            keys.difference_update(source_keys)
-        if keys:
-            raise RevisionNotPresent(keys, self.filename)
+                yield line
+
         pb.update('Walking content.', total, total)
-
-    def _make_line_delta(self, delta_seq, new_content):
-        """Generate a line delta from delta_seq and new_content."""
-        diff_hunks = []
-        for op in delta_seq.get_opcodes():
-            if op[0] == 'equal':
-                continue
-            diff_hunks.append((op[1], op[2], op[4]-op[3], new_content._lines[op[3]:op[4]]))
-        return diff_hunks
-
-    def _merge_annotations(self, content, parents, parent_texts={},
-                           delta=None, annotated=None,
-                           left_matching_blocks=None):
-        """Merge annotations for content and generate deltas.
-        
-        This is done by comparing the annotations based on changes to the text
-        and generating a delta on the resulting full texts. If annotations are
-        not being created then a simple delta is created.
-        """
-        if left_matching_blocks is not None:
-            delta_seq = diff._PrematchedMatcher(left_matching_blocks)
-        else:
-            delta_seq = None
-        if annotated:
-            for parent_key in parents:
-                merge_content = self._get_content(parent_key, parent_texts)
-                if (parent_key == parents[0] and delta_seq is not None):
-                    seq = delta_seq
-                else:
-                    seq = patiencediff.PatienceSequenceMatcher(
-                        None, merge_content.text(), content.text())
-                for i, j, n in seq.get_matching_blocks():
-                    if n == 0:
-                        continue
-                    # this copies (origin, text) pairs across to the new
-                    # content for any line that matches the last-checked
-                    # parent.
-                    content._lines[j:j+n] = merge_content._lines[i:i+n]
-            # XXX: Robert says the following block is a workaround for a
-            # now-fixed bug and it can probably be deleted. -- mbp 20080618
-            if content._lines and content._lines[-1][1][-1] != '\n':
-                # The copied annotation was from a line without a trailing EOL,
-                # reinstate one for the content object, to ensure correct
-                # serialization.
-                line = content._lines[-1][1] + '\n'
-                content._lines[-1] = (content._lines[-1][0], line)
-        if delta:
-            if delta_seq is None:
-                reference_content = self._get_content(parents[0], parent_texts)
-                new_texts = content.text()
-                old_texts = reference_content.text()
-                delta_seq = patiencediff.PatienceSequenceMatcher(
-                                                 None, old_texts, new_texts)
-            return self._make_line_delta(delta_seq, content)
-
-    def _parse_record(self, version_id, data):
-        """Parse an original format knit record.
-
-        These have the last element of the key only present in the stored data.
-        """
-        rec, record_contents = self._parse_record_unchecked(data)
-        self._check_header_version(rec, version_id)
-        return record_contents, rec[3]
-
-    def _parse_record_header(self, key, raw_data):
-        """Parse a record header for consistency.
-
-        :return: the header and the decompressor stream.
-                 as (stream, header_record)
-        """
-        df = tuned_gzip.GzipFile(mode='rb', fileobj=StringIO(raw_data))
-        try:
-            # Current serialise
-            rec = self._check_header(key, df.readline())
-        except Exception, e:
-            raise KnitCorrupt(self,
-                              "While reading {%s} got %s(%s)"
-                              % (key, e.__class__.__name__, str(e)))
-        return df, rec
-
-    def _parse_record_unchecked(self, data):
-        # profiling notes:
-        # 4168 calls in 2880 217 internal
-        # 4168 calls to _parse_record_header in 2121
-        # 4168 calls to readlines in 330
-        df = tuned_gzip.GzipFile(mode='rb', fileobj=StringIO(data))
-        try:
-            record_contents = df.readlines()
-        except Exception, e:
-            raise KnitCorrupt(self, "Corrupt compressed record %r, got %s(%s)" %
-                (data, e.__class__.__name__, str(e)))
-        header = record_contents.pop(0)
-        rec = self._split_header(header)
-        last_line = record_contents.pop()
-        if len(record_contents) != int(rec[2]):
-            raise KnitCorrupt(self,
-                              'incorrect number of lines %s != %s'
-                              ' for version {%s} %s'
-                              % (len(record_contents), int(rec[2]),
-                                 rec[1], record_contents))
-        if last_line != 'end %s\n' % rec[1]:
-            raise KnitCorrupt(self,
-                              'unexpected version end line %r, wanted %r' 
-                              % (last_line, rec[1]))
-        df.close()
-        return rec, record_contents
-
-    def _read_records_iter(self, records):
-        """Read text records from data file and yield result.
-
-        The result will be returned in whatever is the fastest to read.
-        Not by the order requested. Also, multiple requests for the same
-        record will only yield 1 response.
-        :param records: A list of (key, access_memo) entries
-        :return: Yields (key, contents, digest) in the order
-                 read, not the order requested
-        """
-        if not records:
-            return
-
-        # XXX: This smells wrong, IO may not be getting ordered right.
-        needed_records = sorted(set(records), key=operator.itemgetter(1))
-        if not needed_records:
-            return
-
-        # The transport optimizes the fetching as well 
-        # (ie, reads continuous ranges.)
-        raw_data = self._access.get_raw_records(
-            [index_memo for key, index_memo in needed_records])
-
-        for (key, index_memo), data in \
-                izip(iter(needed_records), raw_data):
-            content, digest = self._parse_record(key[-1], data)
-            yield key, content, digest
-
-    def _read_records_iter_raw(self, records):
-        """Read text records from data file and yield raw data.
-
-        This unpacks enough of the text record to validate the id is
-        as expected but thats all.
-
-        Each item the iterator yields is (key, bytes, sha1_of_full_text).
-        """
-        # setup an iterator of the external records:
-        # uses readv so nice and fast we hope.
-        if len(records):
-            # grab the disk data needed.
-            needed_offsets = [index_memo for key, index_memo
-                                           in records]
-            raw_records = self._access.get_raw_records(needed_offsets)
-
-        for key, index_memo in records:
-            data = raw_records.next()
-            # validate the header (note that we can only use the suffix in
-            # current knit records).
-            df, rec = self._parse_record_header(key, data)
-            df.close()
-            yield key, data, rec[3]
-
-    def _record_to_data(self, key, digest, lines, dense_lines=None):
-        """Convert key, digest, lines into a raw data block.
-        
-        :param key: The key of the record. Currently keys are always serialised
-            using just the trailing component.
-        :param dense_lines: The bytes of lines but in a denser form. For
-            instance, if lines is a list of 1000 bytestrings each ending in \n,
-            dense_lines may be a list with one line in it, containing all the
-            1000's lines and their \n's. Using dense_lines if it is already
-            known is a win because the string join to create bytes in this
-            function spends less time resizing the final string.
-        :return: (len, a StringIO instance with the raw data ready to read.)
-        """
-        # Note: using a string copy here increases memory pressure with e.g.
-        # ISO's, but it is about 3 seconds faster on a 1.2Ghz intel machine
-        # when doing the initial commit of a mozilla tree. RBC 20070921
-        bytes = ''.join(chain(
-            ["version %s %d %s\n" % (key[-1],
-                                     len(lines),
-                                     digest)],
-            dense_lines or lines,
-            ["end %s\n" % key[-1]]))
-        if type(bytes) != str:
-            raise AssertionError(
-                'data must be plain bytes was %s' % type(bytes))
-        if lines and lines[-1][-1] != '\n':
-            raise ValueError('corrupt lines value %r' % lines)
-        compressed_bytes = tuned_gzip.bytes_to_gzip(bytes)
-        return len(compressed_bytes), compressed_bytes
-
-    def _split_header(self, line):
-        rec = line.split()
-        if len(rec) != 4:
-            raise KnitCorrupt(self,
-                              'unexpected number of elements in record header')
-        return rec
-
-    def keys(self):
-        """See VersionedFiles.keys."""
-        if 'evil' in debug.debug_flags:
-            trace.mutter_callsite(2, "keys scales with size of history")
-        sources = [self._index] + self._fallback_vfs
-        result = set()
-        for source in sources:
-            result.update(source.keys())
-        return result
-
-
-
-class _KndxIndex(object):
-    """Manages knit index files
-
-    The index is kept in memory and read on startup, to enable
+        
+    def iter_parents(self, version_ids):
+        """Iterate through the parents for many version ids.
+
+        :param version_ids: An iterable yielding version_ids.
+        :return: An iterator that yields (version_id, parents). Requested 
+            version_ids not present in the versioned file are simply skipped.
+            The order is undefined, allowing for different optimisations in
+            the underlying implementation.
+        """
+        return self._index.iter_parents(version_ids)
+
+    def num_versions(self):
+        """See VersionedFile.num_versions()."""
+        return self._index.num_versions()
+
+    __len__ = num_versions
+
+    def annotate_iter(self, version_id):
+        """See VersionedFile.annotate_iter."""
+        return self.factory.annotate_iter(self, version_id)
+
+    def get_parents(self, version_id):
+        """See VersionedFile.get_parents."""
+        # perf notes:
+        # optimism counts!
+        # 52554 calls in 1264 872 internal down from 3674
+        try:
+            return self._index.get_parents(version_id)
+        except KeyError:
+            raise RevisionNotPresent(version_id, self.filename)
+
+    def get_parents_with_ghosts(self, version_id):
+        """See VersionedFile.get_parents."""
+        try:
+            return self._index.get_parents_with_ghosts(version_id)
+        except KeyError:
+            raise RevisionNotPresent(version_id, self.filename)
+
+    def get_ancestry(self, versions, topo_sorted=True):
+        """See VersionedFile.get_ancestry."""
+        if isinstance(versions, basestring):
+            versions = [versions]
+        if not versions:
+            return []
+        return self._index.get_ancestry(versions, topo_sorted)
+
+    def get_ancestry_with_ghosts(self, versions):
+        """See VersionedFile.get_ancestry_with_ghosts."""
+        if isinstance(versions, basestring):
+            versions = [versions]
+        if not versions:
+            return []
+        return self._index.get_ancestry_with_ghosts(versions)
+
+    def plan_merge(self, ver_a, ver_b):
+        """See VersionedFile.plan_merge."""
+        ancestors_b = set(self.get_ancestry(ver_b, topo_sorted=False))
+        ancestors_a = set(self.get_ancestry(ver_a, topo_sorted=False))
+        annotated_a = self.annotate(ver_a)
+        annotated_b = self.annotate(ver_b)
+        return merge._plan_annotate_merge(annotated_a, annotated_b,
+                                          ancestors_a, ancestors_b)
+
+
+class _KnitComponentFile(object):
+    """One of the files used to implement a knit database"""
+
+    def __init__(self, transport, filename, mode, file_mode=None,
+                 create_parent_dir=False, dir_mode=None):
+        self._transport = transport
+        self._filename = filename
+        self._mode = mode
+        self._file_mode = file_mode
+        self._dir_mode = dir_mode
+        self._create_parent_dir = create_parent_dir
+        self._need_to_create = False
+
+    def _full_path(self):
+        """Return the full path to this file."""
+        return self._transport.base + self._filename
+
+    def check_header(self, fp):
+        line = fp.readline()
+        if line == '':
+            # An empty file can actually be treated as though the file doesn't
+            # exist yet.
+            raise errors.NoSuchFile(self._full_path())
+        if line != self.HEADER:
+            raise KnitHeaderError(badline=line,
+                              filename=self._transport.abspath(self._filename))
+
+    def __repr__(self):
+        return '%s(%s)' % (self.__class__.__name__, self._filename)
+
+
+class _KnitIndex(_KnitComponentFile):
+    """Manages knit index file.
+
+    The index is already kept in memory and read on startup, to enable
     fast lookups of revision information.  The cursor of the index
     file is always pointing to the end, making it easy to append
     entries.
@@ -1688,376 +1246,505 @@
     to ensure that records always start on new lines even if the last write was
     interrupted. As a result its normal for the last line in the index to be
     missing a trailing newline. One can be added with no harmful effects.
-
-    :ivar _kndx_cache: dict from prefix to the old state of KnitIndex objects,
-        where prefix is e.g. the (fileid,) for .texts instances or () for
-        constant-mapped things like .revisions, and the old state is
-        tuple(history_vector, cache_dict).  This is used to prevent having an
-        ABI change with the C extension that reads .kndx files.
     """
 
     HEADER = "# bzr knit index 8\n"
 
-    def __init__(self, transport, mapper, get_scope, allow_writes, is_locked):
-        """Create a _KndxIndex on transport using mapper."""
-        self._transport = transport
-        self._mapper = mapper
-        self._get_scope = get_scope
-        self._allow_writes = allow_writes
-        self._is_locked = is_locked
-        self._reset_cache()
-        self.has_graph = True
-
-    def add_records(self, records, random_id=False):
-        """Add multiple records to the index.
-        
-        :param records: a list of tuples:
-                         (key, options, access_memo, parents).
-        :param random_id: If True the ids being added were randomly generated
-            and no check for existence will be performed.
-        """
-        paths = {}
-        for record in records:
-            key = record[0]
-            prefix = key[:-1]
-            path = self._mapper.map(key) + '.kndx'
-            path_keys = paths.setdefault(path, (prefix, []))
-            path_keys[1].append(record)
-        for path in sorted(paths):
-            prefix, path_keys = paths[path]
-            self._load_prefixes([prefix])
-            lines = []
-            orig_history = self._kndx_cache[prefix][1][:]
-            orig_cache = self._kndx_cache[prefix][0].copy()
-
-            try:
-                for key, options, (_, pos, size), parents in path_keys:
-                    if parents is None:
-                        # kndx indices cannot be parentless.
-                        parents = ()
-                    line = "\n%s %s %s %s %s :" % (
-                        key[-1], ','.join(options), pos, size,
-                        self._dictionary_compress(parents))
-                    if type(line) != str:
-                        raise AssertionError(
-                            'data must be utf8 was %s' % type(line))
-                    lines.append(line)
-                    self._cache_key(key, options, pos, size, parents)
-                if len(orig_history):
-                    self._transport.append_bytes(path, ''.join(lines))
-                else:
-                    self._init_index(path, lines)
-            except:
-                # If any problems happen, restore the original values and re-raise
-                self._kndx_cache[prefix] = (orig_cache, orig_history)
-                raise
-
-    def _cache_key(self, key, options, pos, size, parent_keys):
+    # speed of knit parsing went from 280 ms to 280 ms with slots addition.
+    # __slots__ = ['_cache', '_history', '_transport', '_filename']
+
+    def _cache_version(self, version_id, options, pos, size, parents):
         """Cache a version record in the history array and index cache.
 
         This is inlined into _load_data for performance. KEEP IN SYNC.
         (It saves 60ms, 25% of the __init__ overhead on local 4000 record
          indexes).
         """
-        prefix = key[:-1]
-        version_id = key[-1]
-        # last-element only for compatibilty with the C load_data.
-        parents = tuple(parent[-1] for parent in parent_keys)
-        for parent in parent_keys:
-            if parent[:-1] != prefix:
-                raise ValueError("mismatched prefixes for %r, %r" % (
-                    key, parent_keys))
-        cache, history = self._kndx_cache[prefix]
         # only want the _history index to reference the 1st index entry
         # for version_id
-        if version_id not in cache:
-            index = len(history)
-            history.append(version_id)
+        if version_id not in self._cache:
+            index = len(self._history)
+            self._history.append(version_id)
         else:
-            index = cache[version_id][5]
-        cache[version_id] = (version_id,
+            index = self._cache[version_id][5]
+        self._cache[version_id] = (version_id,
                                    options,
                                    pos,
                                    size,
                                    parents,
                                    index)
 
-    def check_header(self, fp):
-        line = fp.readline()
-        if line == '':
-            # An empty file can actually be treated as though the file doesn't
-            # exist yet.
-            raise errors.NoSuchFile(self)
-        if line != self.HEADER:
-            raise KnitHeaderError(badline=line, filename=self)
-
-    def _check_read(self):
-        if not self._is_locked():
-            raise errors.ObjectNotLocked(self)
-        if self._get_scope() != self._scope:
-            self._reset_cache()
-
-    def _check_write_ok(self):
-        """Assert if not writes are permitted."""
-        if not self._is_locked():
-            raise errors.ObjectNotLocked(self)
-        if self._get_scope() != self._scope:
-            self._reset_cache()
-        if self._mode != 'w':
-            raise errors.ReadOnlyObjectDirtiedError(self)
-
-    def get_build_details(self, keys):
-        """Get the method, index_memo and compression parent for keys.
-
-        Ghosts are omitted from the result.
-
-        :param keys: An iterable of keys.
-        :return: A dict of key:(index_memo, compression_parent, parents,
-            record_details).
-            index_memo
-                opaque structure to pass to read_records to extract the raw
-                data
-            compression_parent
-                Content that this record is built upon, may be None
-            parents
-                Logical parents of this node
-            record_details
-                extra information about the content which needs to be passed to
-                Factory.parse_record
-        """
-        prefixes = self._partition_keys(keys)
-        parent_map = self.get_parent_map(keys)
-        result = {}
-        for key in keys:
-            if key not in parent_map:
-                continue # Ghost
-            method = self.get_method(key)
-            parents = parent_map[key]
-            if method == 'fulltext':
-                compression_parent = None
-            else:
-                compression_parent = parents[0]
-            noeol = 'no-eol' in self.get_options(key)
-            index_memo = self.get_position(key)
-            result[key] = (index_memo, compression_parent,
-                                  parents, (method, noeol))
-        return result
-
-    def get_method(self, key):
-        """Return compression method of specified key."""
-        options = self.get_options(key)
-        if 'fulltext' in options:
-            return 'fulltext'
-        elif 'line-delta' in options:
-            return 'line-delta'
-        else:
-            raise errors.KnitIndexUnknownMethod(self, options)
-
-    def get_options(self, key):
-        """Return a list representing options.
-
-        e.g. ['foo', 'bar']
-        """
-        prefix, suffix = self._split_key(key)
-        self._load_prefixes([prefix])
+    def __init__(self, transport, filename, mode, create=False, file_mode=None,
+                 create_parent_dir=False, delay_create=False, dir_mode=None):
+        _KnitComponentFile.__init__(self, transport, filename, mode,
+                                    file_mode=file_mode,
+                                    create_parent_dir=create_parent_dir,
+                                    dir_mode=dir_mode)
+        self._cache = {}
+        # position in _history is the 'official' index for a revision
+        # but the values may have come from a newer entry.
+        # so - wc -l of a knit index is != the number of unique names
+        # in the knit.
+        self._history = []
         try:
-            return self._kndx_cache[prefix][0][suffix][1]
-        except KeyError:
-            raise RevisionNotPresent(key, self)
-
-    def get_parent_map(self, keys):
-        """Get a map of the parents of keys.
-
-        :param keys: The keys to look up parents for.
-        :return: A mapping from keys to parents. Absent keys are absent from
-            the mapping.
+            fp = self._transport.get(self._filename)
+            try:
+                # _load_data may raise NoSuchFile if the target knit is
+                # completely empty.
+                _load_data(self, fp)
+            finally:
+                fp.close()
+        except NoSuchFile:
+            if mode != 'w' or not create:
+                raise
+            elif delay_create:
+                self._need_to_create = True
+            else:
+                self._transport.put_bytes_non_atomic(
+                    self._filename, self.HEADER, mode=self._file_mode)
+
+    def get_graph(self):
+        """Return a list of the node:parents lists from this knit index."""
+        return [(vid, idx[4]) for vid, idx in self._cache.iteritems()]
+
+    def get_ancestry(self, versions, topo_sorted=True):
+        """See VersionedFile.get_ancestry."""
+        # get a graph of all the mentioned versions:
+        graph = {}
+        pending = set(versions)
+        cache = self._cache
+        while pending:
+            version = pending.pop()
+            # trim ghosts
+            try:
+                parents = [p for p in cache[version][4] if p in cache]
+            except KeyError:
+                raise RevisionNotPresent(version, self._filename)
+            # if not completed and not a ghost
+            pending.update([p for p in parents if p not in graph])
+            graph[version] = parents
+        if not topo_sorted:
+            return graph.keys()
+        return topo_sort(graph.items())
+
+    def get_ancestry_with_ghosts(self, versions):
+        """See VersionedFile.get_ancestry_with_ghosts."""
+        # get a graph of all the mentioned versions:
+        self.check_versions_present(versions)
+        cache = self._cache
+        graph = {}
+        pending = set(versions)
+        while pending:
+            version = pending.pop()
+            try:
+                parents = cache[version][4]
+            except KeyError:
+                # ghost, fake it
+                graph[version] = []
+            else:
+                # if not completed
+                pending.update([p for p in parents if p not in graph])
+                graph[version] = parents
+        return topo_sort(graph.items())
+
+    def iter_parents(self, version_ids):
+        """Iterate through the parents for many version ids.
+
+        :param version_ids: An iterable yielding version_ids.
+        :return: An iterator that yields (version_id, parents). Requested 
+            version_ids not present in the versioned file are simply skipped.
+            The order is undefined, allowing for different optimisations in
+            the underlying implementation.
         """
-        # Parse what we need to up front, this potentially trades off I/O
-        # locality (.kndx and .knit in the same block group for the same file
-        # id) for less checking in inner loops.
-        prefixes = set(key[:-1] for key in keys)
-        self._load_prefixes(prefixes)
-        result = {}
-        for key in keys:
-            prefix = key[:-1]
+        for version_id in version_ids:
             try:
-                suffix_parents = self._kndx_cache[prefix][0][key[-1]][4]
+                yield version_id, tuple(self.get_parents(version_id))
             except KeyError:
                 pass
-            else:
-                result[key] = tuple(prefix + (suffix,) for
-                    suffix in suffix_parents)
-        return result
-
-    def get_position(self, key):
-        """Return details needed to access the version.
-        
-        :return: a tuple (key, data position, size) to hand to the access
-            logic to get the record.
-        """
-        prefix, suffix = self._split_key(key)
-        self._load_prefixes([prefix])
-        entry = self._kndx_cache[prefix][0][suffix]
-        return key, entry[2], entry[3]
-
-    def _init_index(self, path, extra_lines=[]):
-        """Initialize an index."""
-        sio = StringIO()
-        sio.write(self.HEADER)
-        sio.writelines(extra_lines)
-        sio.seek(0)
-        self._transport.put_file_non_atomic(path, sio,
-                            create_parent_dir=True)
-                           # self._create_parent_dir)
-                           # mode=self._file_mode,
-                           # dir_mode=self._dir_mode)
-
-    def keys(self):
-        """Get all the keys in the collection.
-        
-        The keys are not ordered.
-        """
-        result = set()
-        # Identify all key prefixes.
-        # XXX: A bit hacky, needs polish.
-        if type(self._mapper) == ConstantMapper:
-            prefixes = [()]
-        else:
-            relpaths = set()
-            for quoted_relpath in self._transport.iter_files_recursive():
-                path, ext = os.path.splitext(quoted_relpath)
-                relpaths.add(path)
-            prefixes = [self._mapper.unmap(path) for path in relpaths]
-        self._load_prefixes(prefixes)
-        for prefix in prefixes:
-            for suffix in self._kndx_cache[prefix][1]:
-                result.add(prefix + (suffix,))
-        return result
-    
-    def _load_prefixes(self, prefixes):
-        """Load the indices for prefixes."""
-        self._check_read()
-        for prefix in prefixes:
-            if prefix not in self._kndx_cache:
-                # the load_data interface writes to these variables.
-                self._cache = {}
-                self._history = []
-                self._filename = prefix
-                try:
-                    path = self._mapper.map(prefix) + '.kndx'
-                    fp = self._transport.get(path)
-                    try:
-                        # _load_data may raise NoSuchFile if the target knit is
-                        # completely empty.
-                        _load_data(self, fp)
-                    finally:
-                        fp.close()
-                    self._kndx_cache[prefix] = (self._cache, self._history)
-                    del self._cache
-                    del self._filename
-                    del self._history
-                except NoSuchFile:
-                    self._kndx_cache[prefix] = ({}, [])
-                    if type(self._mapper) == ConstantMapper:
-                        # preserve behaviour for revisions.kndx etc.
-                        self._init_index(path)
-                    del self._cache
-                    del self._filename
-                    del self._history
-
-    def _partition_keys(self, keys):
-        """Turn keys into a dict of prefix:suffix_list."""
-        result = {}
-        for key in keys:
-            prefix_keys = result.setdefault(key[:-1], [])
-            prefix_keys.append(key[-1])
-        return result
-
-    def _dictionary_compress(self, keys):
-        """Dictionary compress keys.
-        
-        :param keys: The keys to generate references to.
-        :return: A string representation of keys. keys which are present are
-            dictionary compressed, and others are emitted as fulltext with a
-            '.' prefix.
-        """
-        if not keys:
-            return ''
+
+    def num_versions(self):
+        return len(self._history)
+
+    __len__ = num_versions
+
+    def get_versions(self):
+        """Get all the versions in the file. not topologically sorted."""
+        return self._history
+
+    def _version_list_to_index(self, versions):
         result_list = []
-        prefix = keys[0][:-1]
-        cache = self._kndx_cache[prefix][0]
-        for key in keys:
-            if key[:-1] != prefix:
-                # kndx indices cannot refer across partitioned storage.
-                raise ValueError("mismatched prefixes for %r" % keys)
-            if key[-1] in cache:
+        cache = self._cache
+        for version in versions:
+            if version in cache:
                 # -- inlined lookup() --
-                result_list.append(str(cache[key[-1]][5]))
+                result_list.append(str(cache[version][5]))
                 # -- end lookup () --
             else:
-                result_list.append('.' + key[-1])
+                result_list.append('.' + version)
         return ' '.join(result_list)
 
-    def _reset_cache(self):
-        # Possibly this should be a LRU cache. A dictionary from key_prefix to
-        # (cache_dict, history_vector) for parsed kndx files.
-        self._kndx_cache = {}
-        self._scope = self._get_scope()
-        allow_writes = self._allow_writes()
-        if allow_writes:
-            self._mode = 'w'
+    def add_version(self, version_id, options, index_memo, parents):
+        """Add a version record to the index."""
+        self.add_versions(((version_id, options, index_memo, parents),))
+
+    def add_versions(self, versions, random_id=False):
+        """Add multiple versions to the index.
+        
+        :param versions: a list of tuples:
+                         (version_id, options, pos, size, parents).
+        :param random_id: If True the ids being added were randomly generated
+            and no check for existence will be performed.
+        """
+        lines = []
+        orig_history = self._history[:]
+        orig_cache = self._cache.copy()
+
+        try:
+            for version_id, options, (index, pos, size), parents in versions:
+                line = "\n%s %s %s %s %s :" % (version_id,
+                                               ','.join(options),
+                                               pos,
+                                               size,
+                                               self._version_list_to_index(parents))
+                assert isinstance(line, str), \
+                    'content must be utf-8 encoded: %r' % (line,)
+                lines.append(line)
+                self._cache_version(version_id, options, pos, size, parents)
+            if not self._need_to_create:
+                self._transport.append_bytes(self._filename, ''.join(lines))
+            else:
+                sio = StringIO()
+                sio.write(self.HEADER)
+                sio.writelines(lines)
+                sio.seek(0)
+                self._transport.put_file_non_atomic(self._filename, sio,
+                                    create_parent_dir=self._create_parent_dir,
+                                    mode=self._file_mode,
+                                    dir_mode=self._dir_mode)
+                self._need_to_create = False
+        except:
+            # If any problems happen, restore the original values and re-raise
+            self._history = orig_history
+            self._cache = orig_cache
+            raise
+
+    def has_version(self, version_id):
+        """True if the version is in the index."""
+        return version_id in self._cache
+
+    def get_position(self, version_id):
+        """Return details needed to access the version.
+        
+        .kndx indices do not support split-out data, so return None for the 
+        index field.
+
+        :return: a tuple (None, data position, size) to hand to the access
+            logic to get the record.
+        """
+        entry = self._cache[version_id]
+        return None, entry[2], entry[3]
+
+    def get_method(self, version_id):
+        """Return compression method of specified version."""
+        try:
+            options = self._cache[version_id][1]
+        except KeyError:
+            raise RevisionNotPresent(version_id, self._filename)
+        if 'fulltext' in options:
+            return 'fulltext'
         else:
-            self._mode = 'r'
-
-    def _split_key(self, key):
-        """Split key into a prefix and suffix."""
-        return key[:-1], key[-1]
-
-
-class _KnitGraphIndex(object):
-    """A KnitVersionedFiles index layered on GraphIndex."""
-
-    def __init__(self, graph_index, is_locked, deltas=False, parents=True,
-        add_callback=None):
+            if 'line-delta' not in options:
+                raise errors.KnitIndexUnknownMethod(self._full_path(), options)
+            return 'line-delta'
+
+    def get_options(self, version_id):
+        """Return a string represention options.
+
+        e.g. foo,bar
+        """
+        return self._cache[version_id][1]
+
+    def get_parents(self, version_id):
+        """Return parents of specified version ignoring ghosts."""
+        return [parent for parent in self._cache[version_id][4] 
+                if parent in self._cache]
+
+    def get_parents_with_ghosts(self, version_id):
+        """Return parents of specified version with ghosts."""
+        return self._cache[version_id][4] 
+
+    def check_versions_present(self, version_ids):
+        """Check that all specified versions are present."""
+        cache = self._cache
+        for version_id in version_ids:
+            if version_id not in cache:
+                raise RevisionNotPresent(version_id, self._filename)
+
+
+class KnitGraphIndex(object):
+    """A knit index that builds on GraphIndex."""
+
+    def __init__(self, graph_index, deltas=False, parents=True, add_callback=None):
         """Construct a KnitGraphIndex on a graph_index.
 
         :param graph_index: An implementation of bzrlib.index.GraphIndex.
-        :param is_locked: A callback to check whether the object should answer
-            queries.
         :param deltas: Allow delta-compressed records.
-        :param parents: If True, record knits parents, if not do not record 
-            parents.
         :param add_callback: If not None, allow additions to the index and call
             this callback with a list of added GraphIndex nodes:
             [(node, value, node_refs), ...]
-        :param is_locked: A callback, returns True if the index is locked and
-            thus usable.
+        :param parents: If True, record knits parents, if not do not record 
+            parents.
         """
-        self._add_callback = add_callback
         self._graph_index = graph_index
         self._deltas = deltas
+        self._add_callback = add_callback
         self._parents = parents
         if deltas and not parents:
-            # XXX: TODO: Delta tree and parent graph should be conceptually
-            # separate.
             raise KnitCorrupt(self, "Cannot do delta compression without "
                 "parent tracking.")
-        self.has_graph = parents
-        self._is_locked = is_locked
-
-    def __repr__(self):
-        return "%s(%r)" % (self.__class__.__name__, self._graph_index)
-
-    def add_records(self, records, random_id=False):
-        """Add multiple records to the index.
+
+    def _get_entries(self, keys, check_present=False):
+        """Get the entries for keys.
+        
+        :param keys: An iterable of index keys, - 1-tuples.
+        """
+        keys = set(keys)
+        found_keys = set()
+        if self._parents:
+            for node in self._graph_index.iter_entries(keys):
+                yield node
+                found_keys.add(node[1])
+        else:
+            # adapt parentless index to the rest of the code.
+            for node in self._graph_index.iter_entries(keys):
+                yield node[0], node[1], node[2], ()
+                found_keys.add(node[1])
+        if check_present:
+            missing_keys = keys.difference(found_keys)
+            if missing_keys:
+                raise RevisionNotPresent(missing_keys.pop(), self)
+
+    def _present_keys(self, version_ids):
+        return set([
+            node[1] for node in self._get_entries(version_ids)])
+
+    def _parentless_ancestry(self, versions):
+        """Honour the get_ancestry API for parentless knit indices."""
+        wanted_keys = self._version_ids_to_keys(versions)
+        present_keys = self._present_keys(wanted_keys)
+        missing = set(wanted_keys).difference(present_keys)
+        if missing:
+            raise RevisionNotPresent(missing.pop(), self)
+        return list(self._keys_to_version_ids(present_keys))
+
+    def get_ancestry(self, versions, topo_sorted=True):
+        """See VersionedFile.get_ancestry."""
+        if not self._parents:
+            return self._parentless_ancestry(versions)
+        # XXX: This will do len(history) index calls - perhaps
+        # it should be altered to be a index core feature?
+        # get a graph of all the mentioned versions:
+        graph = {}
+        ghosts = set()
+        versions = self._version_ids_to_keys(versions)
+        pending = set(versions)
+        while pending:
+            # get all pending nodes
+            this_iteration = pending
+            new_nodes = self._get_entries(this_iteration)
+            found = set()
+            pending = set()
+            for (index, key, value, node_refs) in new_nodes:
+                # dont ask for ghosties - otherwise
+                # we we can end up looping with pending
+                # being entirely ghosted.
+                graph[key] = [parent for parent in node_refs[0]
+                    if parent not in ghosts]
+                # queue parents
+                for parent in graph[key]:
+                    # dont examine known nodes again
+                    if parent in graph:
+                        continue
+                    pending.add(parent)
+                found.add(key)
+            ghosts.update(this_iteration.difference(found))
+        if versions.difference(graph):
+            raise RevisionNotPresent(versions.difference(graph).pop(), self)
+        if topo_sorted:
+            result_keys = topo_sort(graph.items())
+        else:
+            result_keys = graph.iterkeys()
+        return [key[0] for key in result_keys]
+
+    def get_ancestry_with_ghosts(self, versions):
+        """See VersionedFile.get_ancestry."""
+        if not self._parents:
+            return self._parentless_ancestry(versions)
+        # XXX: This will do len(history) index calls - perhaps
+        # it should be altered to be a index core feature?
+        # get a graph of all the mentioned versions:
+        graph = {}
+        versions = self._version_ids_to_keys(versions)
+        pending = set(versions)
+        while pending:
+            # get all pending nodes
+            this_iteration = pending
+            new_nodes = self._get_entries(this_iteration)
+            pending = set()
+            for (index, key, value, node_refs) in new_nodes:
+                graph[key] = node_refs[0]
+                # queue parents 
+                for parent in graph[key]:
+                    # dont examine known nodes again
+                    if parent in graph:
+                        continue
+                    pending.add(parent)
+            missing_versions = this_iteration.difference(graph)
+            missing_needed = versions.intersection(missing_versions)
+            if missing_needed:
+                raise RevisionNotPresent(missing_needed.pop(), self)
+            for missing_version in missing_versions:
+                # add a key, no parents
+                graph[missing_version] = []
+                pending.discard(missing_version) # don't look for it
+        result_keys = topo_sort(graph.items())
+        return [key[0] for key in result_keys]
+
+    def get_graph(self):
+        """Return a list of the node:parents lists from this knit index."""
+        if not self._parents:
+            return [(key, ()) for key in self.get_versions()]
+        result = []
+        for index, key, value, refs in self._graph_index.iter_all_entries():
+            result.append((key[0], tuple([ref[0] for ref in refs[0]])))
+        return result
+
+    def iter_parents(self, version_ids):
+        """Iterate through the parents for many version ids.
+
+        :param version_ids: An iterable yielding version_ids.
+        :return: An iterator that yields (version_id, parents). Requested 
+            version_ids not present in the versioned file are simply skipped.
+            The order is undefined, allowing for different optimisations in
+            the underlying implementation.
+        """
+        if self._parents:
+            all_nodes = set(self._get_entries(self._version_ids_to_keys(version_ids)))
+            all_parents = set()
+            present_parents = set()
+            for node in all_nodes:
+                all_parents.update(node[3][0])
+                # any node we are querying must be present
+                present_parents.add(node[1])
+            unknown_parents = all_parents.difference(present_parents)
+            present_parents.update(self._present_keys(unknown_parents))
+            for node in all_nodes:
+                parents = []
+                for parent in node[3][0]:
+                    if parent in present_parents:
+                        parents.append(parent[0])
+                yield node[1][0], tuple(parents)
+        else:
+            for node in self._get_entries(self._version_ids_to_keys(version_ids)):
+                yield node[1][0], ()
+
+    def num_versions(self):
+        return len(list(self._graph_index.iter_all_entries()))
+
+    __len__ = num_versions
+
+    def get_versions(self):
+        """Get all the versions in the file. not topologically sorted."""
+        return [node[1][0] for node in self._graph_index.iter_all_entries()]
+    
+    def has_version(self, version_id):
+        """True if the version is in the index."""
+        return len(self._present_keys(self._version_ids_to_keys([version_id]))) == 1
+
+    def _keys_to_version_ids(self, keys):
+        return tuple(key[0] for key in keys)
+
+    def get_position(self, version_id):
+        """Return details needed to access the version.
+        
+        :return: a tuple (index, data position, size) to hand to the access
+            logic to get the record.
+        """
+        node = self._get_node(version_id)
+        bits = node[2][1:].split(' ')
+        return node[0], int(bits[0]), int(bits[1])
+
+    def get_method(self, version_id):
+        """Return compression method of specified version."""
+        if not self._deltas:
+            return 'fulltext'
+        return self._parent_compression(self._get_node(version_id)[3][1])
+
+    def _parent_compression(self, reference_list):
+        # use the second reference list to decide if this is delta'd or not.
+        if len(reference_list):
+            return 'line-delta'
+        else:
+            return 'fulltext'
+
+    def _get_node(self, version_id):
+        try:
+            return list(self._get_entries(self._version_ids_to_keys([version_id])))[0]
+        except IndexError:
+            raise RevisionNotPresent(version_id, self)
+
+    def get_options(self, version_id):
+        """Return a string represention options.
+
+        e.g. foo,bar
+        """
+        node = self._get_node(version_id)
+        if not self._deltas:
+            options = ['fulltext']
+        else:
+            options = [self._parent_compression(node[3][1])]
+        if node[2][0] == 'N':
+            options.append('no-eol')
+        return options
+
+    def get_parents(self, version_id):
+        """Return parents of specified version ignoring ghosts."""
+        parents = list(self.iter_parents([version_id]))
+        if not parents:
+            # missing key
+            raise errors.RevisionNotPresent(version_id, self)
+        return parents[0][1]
+
+    def get_parents_with_ghosts(self, version_id):
+        """Return parents of specified version with ghosts."""
+        nodes = list(self._get_entries(self._version_ids_to_keys([version_id]),
+            check_present=True))
+        if not self._parents:
+            return ()
+        return self._keys_to_version_ids(nodes[0][3][0])
+
+    def check_versions_present(self, version_ids):
+        """Check that all specified versions are present."""
+        keys = self._version_ids_to_keys(version_ids)
+        present = self._present_keys(keys)
+        missing = keys.difference(present)
+        if missing:
+            raise RevisionNotPresent(missing.pop(), self)
+
+    def add_version(self, version_id, options, access_memo, parents):
+        """Add a version record to the index."""
+        return self.add_versions(((version_id, options, access_memo, parents),))
+
+    def add_versions(self, versions, random_id=False):
+        """Add multiple versions to the index.
         
         This function does not insert data into the Immutable GraphIndex
         backing the KnitGraphIndex, instead it prepares data for insertion by
         the caller and checks that it is safe to insert then calls
         self._add_callback with the prepared GraphIndex nodes.
 
-        :param records: a list of tuples:
-                         (key, options, access_memo, parents).
+        :param versions: a list of tuples:
+                         (version_id, options, pos, size, parents).
         :param random_id: If True the ids being added were randomly generated
             and no check for existence will be performed.
         """
@@ -2065,12 +1752,13 @@
             raise errors.ReadOnlyError(self)
         # we hope there are no repositories with inconsistent parentage
         # anymore.
+        # check for dups
 
         keys = {}
-        for (key, options, access_memo, parents) in records:
-            if self._parents:
-                parents = tuple(parents)
+        for (version_id, options, access_memo, parents) in versions:
             index, pos, size = access_memo
+            key = (version_id, )
+            parents = tuple((parent, ) for parent in parents)
             if 'no-eol' in options:
                 value = 'N'
             else:
@@ -2093,13 +1781,11 @@
                         "in parentless index.")
                 node_refs = ()
             keys[key] = (value, node_refs)
-        # check for dups
         if not random_id:
             present_nodes = self._get_entries(keys)
             for (index, key, value, node_refs) in present_nodes:
-                if (value[0] != keys[key][0][0] or
-                    node_refs != keys[key][1]):
-                    raise KnitCorrupt(self, "inconsistent details in add_records"
+                if (value, node_refs) != keys[key]:
+                    raise KnitCorrupt(self, "inconsistent details in add_versions"
                         ": %s %s" % ((value, node_refs), keys[key]))
                 del keys[key]
         result = []
@@ -2111,274 +1797,136 @@
                 result.append((key, value))
         self._add_callback(result)
         
-    def _check_read(self):
-        """raise if reads are not permitted."""
-        if not self._is_locked():
-            raise errors.ObjectNotLocked(self)
-
-    def _check_write_ok(self):
-        """Assert if writes are not permitted."""
-        if not self._is_locked():
-            raise errors.ObjectNotLocked(self)
-
-    def _compression_parent(self, an_entry):
-        # return the key that an_entry is compressed against, or None
-        # Grab the second parent list (as deltas implies parents currently)
-        compression_parents = an_entry[3][1]
-        if not compression_parents:
-            return None
-        if len(compression_parents) != 1:
-            raise AssertionError(
-                "Too many compression parents: %r" % compression_parents)
-        return compression_parents[0]
-
-    def get_build_details(self, keys):
-        """Get the method, index_memo and compression parent for version_ids.
-
-        Ghosts are omitted from the result.
-
-        :param keys: An iterable of keys.
-        :return: A dict of key:
-            (index_memo, compression_parent, parents, record_details).
-            index_memo
-                opaque structure to pass to read_records to extract the raw
-                data
-            compression_parent
-                Content that this record is built upon, may be None
-            parents
-                Logical parents of this node
-            record_details
-                extra information about the content which needs to be passed to
-                Factory.parse_record
-        """
-        self._check_read()
-        result = {}
-        entries = self._get_entries(keys, False)
-        for entry in entries:
-            key = entry[1]
-            if not self._parents:
-                parents = ()
-            else:
-                parents = entry[3][0]
-            if not self._deltas:
-                compression_parent_key = None
-            else:
-                compression_parent_key = self._compression_parent(entry)
-            noeol = (entry[2][0] == 'N')
-            if compression_parent_key:
-                method = 'line-delta'
-            else:
-                method = 'fulltext'
-            result[key] = (self._node_to_position(entry),
-                                  compression_parent_key, parents,
-                                  (method, noeol))
-        return result
-
-    def _get_entries(self, keys, check_present=False):
-        """Get the entries for keys.
-        
-        :param keys: An iterable of index key tuples.
-        """
-        keys = set(keys)
-        found_keys = set()
-        if self._parents:
-            for node in self._graph_index.iter_entries(keys):
-                yield node
-                found_keys.add(node[1])
-        else:
-            # adapt parentless index to the rest of the code.
-            for node in self._graph_index.iter_entries(keys):
-                yield node[0], node[1], node[2], ()
-                found_keys.add(node[1])
-        if check_present:
-            missing_keys = keys.difference(found_keys)
-            if missing_keys:
-                raise RevisionNotPresent(missing_keys.pop(), self)
-
-    def get_method(self, key):
-        """Return compression method of specified key."""
-        return self._get_method(self._get_node(key))
-
-    def _get_method(self, node):
-        if not self._deltas:
-            return 'fulltext'
-        if self._compression_parent(node):
-            return 'line-delta'
-        else:
-            return 'fulltext'
-
-    def _get_node(self, key):
-        try:
-            return list(self._get_entries([key]))[0]
-        except IndexError:
-            raise RevisionNotPresent(key, self)
-
-    def get_options(self, key):
-        """Return a list representing options.
-
-        e.g. ['foo', 'bar']
-        """
-        node = self._get_node(key)
-        options = [self._get_method(node)]
-        if node[2][0] == 'N':
-            options.append('no-eol')
-        return options
-
-    def get_parent_map(self, keys):
-        """Get a map of the parents of keys.
-
-        :param keys: The keys to look up parents for.
-        :return: A mapping from keys to parents. Absent keys are absent from
-            the mapping.
-        """
-        self._check_read()
-        nodes = self._get_entries(keys)
-        result = {}
-        if self._parents:
-            for node in nodes:
-                result[node[1]] = node[3][0]
-        else:
-            for node in nodes:
-                result[node[1]] = None
-        return result
-
-    def get_position(self, key):
-        """Return details needed to access the version.
-        
-        :return: a tuple (index, data position, size) to hand to the access
-            logic to get the record.
-        """
-        node = self._get_node(key)
-        return self._node_to_position(node)
-
-    def keys(self):
-        """Get all the keys in the collection.
-        
-        The keys are not ordered.
-        """
-        self._check_read()
-        return [node[1] for node in self._graph_index.iter_all_entries()]
-    
-    def _node_to_position(self, node):
-        """Convert an index value to position details."""
-        bits = node[2][1:].split(' ')
-        return node[0], int(bits[0]), int(bits[1])
-
-
-class _KnitKeyAccess(object):
-    """Access to records in .knit files."""
-
-    def __init__(self, transport, mapper):
-        """Create a _KnitKeyAccess with transport and mapper.
-
-        :param transport: The transport the access object is rooted at.
-        :param mapper: The mapper used to map keys to .knit files.
+    def _version_ids_to_keys(self, version_ids):
+        return set((version_id, ) for version_id in version_ids)
+
+
+class _KnitAccess(object):
+    """Access to knit records in a .knit file."""
+
+    def __init__(self, transport, filename, _file_mode, _dir_mode,
+        _need_to_create, _create_parent_dir):
+        """Create a _KnitAccess for accessing and inserting data.
+
+        :param transport: The transport the .knit is located on.
+        :param filename: The filename of the .knit.
         """
         self._transport = transport
-        self._mapper = mapper
+        self._filename = filename
+        self._file_mode = _file_mode
+        self._dir_mode = _dir_mode
+        self._need_to_create = _need_to_create
+        self._create_parent_dir = _create_parent_dir
 
-    def add_raw_records(self, key_sizes, raw_data):
+    def add_raw_records(self, sizes, raw_data):
         """Add raw knit bytes to a storage area.
 
-        The data is spooled to the container writer in one bytes-record per
-        raw data item.
+        The data is spooled to whereever the access method is storing data.
 
-        :param sizes: An iterable of tuples containing the key and size of each
-            raw data segment.
+        :param sizes: An iterable containing the size of each raw data segment.
         :param raw_data: A bytestring containing the data.
-        :return: A list of memos to retrieve the record later. Each memo is an
-            opaque index memo. For _KnitKeyAccess the memo is (key, pos,
-            length), where the key is the record key.
+        :return: A list of memos to retrieve the record later. Each memo is a
+            tuple - (index, pos, length), where the index field is always None
+            for the .knit access method.
         """
-        if type(raw_data) != str:
-            raise AssertionError(
-                'data must be plain bytes was %s' % type(raw_data))
+        assert type(raw_data) == str, \
+            'data must be plain bytes was %s' % type(raw_data)
+        if not self._need_to_create:
+            base = self._transport.append_bytes(self._filename, raw_data)
+        else:
+            self._transport.put_bytes_non_atomic(self._filename, raw_data,
+                                   create_parent_dir=self._create_parent_dir,
+                                   mode=self._file_mode,
+                                   dir_mode=self._dir_mode)
+            self._need_to_create = False
+            base = 0
         result = []
-        offset = 0
-        # TODO: This can be tuned for writing to sftp and other servers where
-        # append() is relatively expensive by grouping the writes to each key
-        # prefix.
-        for key, size in key_sizes:
-            path = self._mapper.map(key)
-            try:
-                base = self._transport.append_bytes(path + '.knit',
-                    raw_data[offset:offset+size])
-            except errors.NoSuchFile:
-                self._transport.mkdir(osutils.dirname(path))
-                base = self._transport.append_bytes(path + '.knit',
-                    raw_data[offset:offset+size])
-            # if base == 0:
-            # chmod.
-            offset += size
-            result.append((key, base, size))
+        for size in sizes:
+            result.append((None, base, size))
+            base += size
         return result
 
+    def create(self):
+        """IFF this data access has its own storage area, initialise it.
+
+        :return: None.
+        """
+        self._transport.put_bytes_non_atomic(self._filename, '',
+                                             mode=self._file_mode)
+
+    def open_file(self):
+        """IFF this data access can be represented as a single file, open it.
+
+        For knits that are not mapped to a single file on disk this will
+        always return None.
+
+        :return: None or a file handle.
+        """
+        try:
+            return self._transport.get(self._filename)
+        except NoSuchFile:
+            pass
+        return None
+
     def get_raw_records(self, memos_for_retrieval):
         """Get the raw bytes for a records.
 
-        :param memos_for_retrieval: An iterable containing the access memo for
-            retrieving the bytes.
+        :param memos_for_retrieval: An iterable containing the (index, pos, 
+            length) memo for retrieving the bytes. The .knit method ignores
+            the index as there is always only a single file.
         :return: An iterator over the bytes of the records.
         """
-        # first pass, group into same-index request to minimise readv's issued.
-        request_lists = []
-        current_prefix = None
-        for (key, offset, length) in memos_for_retrieval:
-            if current_prefix == key[:-1]:
-                current_list.append((offset, length))
-            else:
-                if current_prefix is not None:
-                    request_lists.append((current_prefix, current_list))
-                current_prefix = key[:-1]
-                current_list = [(offset, length)]
-        # handle the last entry
-        if current_prefix is not None:
-            request_lists.append((current_prefix, current_list))
-        for prefix, read_vector in request_lists:
-            path = self._mapper.map(prefix) + '.knit'
-            for pos, data in self._transport.readv(path, read_vector):
-                yield data
-
-
-class _DirectPackAccess(object):
-    """Access to data in one or more packs with less translation."""
-
-    def __init__(self, index_to_packs):
-        """Create a _DirectPackAccess object.
+        read_vector = [(pos, size) for (index, pos, size) in memos_for_retrieval]
+        for pos, data in self._transport.readv(self._filename, read_vector):
+            yield data
+
+
+class _PackAccess(object):
+    """Access to knit records via a collection of packs."""
+
+    def __init__(self, index_to_packs, writer=None):
+        """Create a _PackAccess object.
 
         :param index_to_packs: A dict mapping index objects to the transport
             and file names for obtaining data.
+        :param writer: A tuple (pack.ContainerWriter, write_index) which
+            contains the pack to write, and the index that reads from it will
+            be associated with.
         """
-        self._container_writer = None
-        self._write_index = None
-        self._indices = index_to_packs
+        if writer:
+            self.container_writer = writer[0]
+            self.write_index = writer[1]
+        else:
+            self.container_writer = None
+            self.write_index = None
+        self.indices = index_to_packs
 
-    def add_raw_records(self, key_sizes, raw_data):
+    def add_raw_records(self, sizes, raw_data):
         """Add raw knit bytes to a storage area.
 
         The data is spooled to the container writer in one bytes-record per
         raw data item.
 
-        :param sizes: An iterable of tuples containing the key and size of each
-            raw data segment.
+        :param sizes: An iterable containing the size of each raw data segment.
         :param raw_data: A bytestring containing the data.
-        :return: A list of memos to retrieve the record later. Each memo is an
-            opaque index memo. For _DirectPackAccess the memo is (index, pos,
-            length), where the index field is the write_index object supplied
-            to the PackAccess object.
+        :return: A list of memos to retrieve the record later. Each memo is a
+            tuple - (index, pos, length), where the index field is the 
+            write_index object supplied to the PackAccess object.
         """
-        if type(raw_data) != str:
-            raise AssertionError(
-                'data must be plain bytes was %s' % type(raw_data))
+        assert type(raw_data) == str, \
+            'data must be plain bytes was %s' % type(raw_data)
         result = []
         offset = 0
-        for key, size in key_sizes:
-            p_offset, p_length = self._container_writer.add_bytes_record(
+        for size in sizes:
+            p_offset, p_length = self.container_writer.add_bytes_record(
                 raw_data[offset:offset+size], [])
             offset += size
-            result.append((self._write_index, p_offset, p_length))
+            result.append((self.write_index, p_offset, p_length))
         return result
 
+    def create(self):
+        """Pack based knits do not get individually created."""
+
     def get_raw_records(self, memos_for_retrieval):
         """Get the raw bytes for a records.
 
@@ -2403,17 +1951,417 @@
         if current_index is not None:
             request_lists.append((current_index, current_list))
         for index, offsets in request_lists:
-            transport, path = self._indices[index]
+            transport, path = self.indices[index]
             reader = pack.make_readv_reader(transport, path, offsets)
             for names, read_func in reader.iter_records():
                 yield read_func(None)
 
-    def set_writer(self, writer, index, transport_packname):
+    def open_file(self):
+        """Pack based knits have no single file."""
+        return None
+
+    def set_writer(self, writer, index, (transport, packname)):
         """Set a writer to use for adding data."""
-        if index is not None:
-            self._indices[index] = transport_packname
-        self._container_writer = writer
-        self._write_index = index
+        self.indices[index] = (transport, packname)
+        self.container_writer = writer
+        self.write_index = index
+
+
+class _KnitData(object):
+    """Manage extraction of data from a KnitAccess, caching and decompressing.
+    
+    The KnitData class provides the logic for parsing and using knit records,
+    making use of an access method for the low level read and write operations.
+    """
+
+    def __init__(self, access):
+        """Create a KnitData object.
+
+        :param access: The access method to use. Access methods such as
+            _KnitAccess manage the insertion of raw records and the subsequent
+            retrieval of the same.
+        """
+        self._access = access
+        self._checked = False
+        # TODO: jam 20060713 conceptually, this could spill to disk
+        #       if the cached size gets larger than a certain amount
+        #       but it complicates the model a bit, so for now just use
+        #       a simple dictionary
+        self._cache = {}
+        self._do_cache = False
+
+    def enable_cache(self):
+        """Enable caching of reads."""
+        self._do_cache = True
+
+    def clear_cache(self):
+        """Clear the record cache."""
+        self._do_cache = False
+        self._cache = {}
+
+    def _open_file(self):
+        return self._access.open_file()
+
+    def _record_to_data(self, version_id, digest, lines, dense_lines=None):
+        """Convert version_id, digest, lines into a raw data block.
+        
+        :param dense_lines: The bytes of lines but in a denser form. For
+            instance, if lines is a list of 1000 bytestrings each ending in \n,
+            dense_lines may be a list with one line in it, containing all the
+            1000's lines and their \n's. Using dense_lines if it is already
+            known is a win because the string join to create bytes in this
+            function spends less time resizing the final string.
+        :return: (len, a StringIO instance with the raw data ready to read.)
+        """
+        # Note: using a string copy here increases memory pressure with e.g.
+        # ISO's, but it is about 3 seconds faster on a 1.2Ghz intel machine
+        # when doing the initial commit of a mozilla tree. RBC 20070921
+        bytes = ''.join(chain(
+            ["version %s %d %s\n" % (version_id,
+                                     len(lines),
+                                     digest)],
+            dense_lines or lines,
+            ["end %s\n" % version_id]))
+        assert bytes.__class__ == str
+        compressed_bytes = bytes_to_gzip(bytes)
+        return len(compressed_bytes), compressed_bytes
+
+    def add_raw_records(self, sizes, raw_data):
+        """Append a prepared record to the data file.
+        
+        :param sizes: An iterable containing the size of each raw data segment.
+        :param raw_data: A bytestring containing the data.
+        :return: a list of index data for the way the data was stored.
+            See the access method add_raw_records documentation for more
+            details.
+        """
+        return self._access.add_raw_records(sizes, raw_data)
+        
+    def _parse_record_header(self, version_id, raw_data):
+        """Parse a record header for consistency.
+
+        :return: the header and the decompressor stream.
+                 as (stream, header_record)
+        """
+        df = GzipFile(mode='rb', fileobj=StringIO(raw_data))
+        try:
+            rec = self._check_header(version_id, df.readline())
+        except Exception, e:
+            raise KnitCorrupt(self._access,
+                              "While reading {%s} got %s(%s)"
+                              % (version_id, e.__class__.__name__, str(e)))
+        return df, rec
+
+    def _check_header(self, version_id, line):
+        rec = line.split()
+        if len(rec) != 4:
+            raise KnitCorrupt(self._access,
+                              'unexpected number of elements in record header')
+        if rec[1] != version_id:
+            raise KnitCorrupt(self._access,
+                              'unexpected version, wanted %r, got %r'
+                              % (version_id, rec[1]))
+        return rec
+
+    def _parse_record(self, version_id, data):
+        # profiling notes:
+        # 4168 calls in 2880 217 internal
+        # 4168 calls to _parse_record_header in 2121
+        # 4168 calls to readlines in 330
+        df = GzipFile(mode='rb', fileobj=StringIO(data))
+
+        try:
+            record_contents = df.readlines()
+        except Exception, e:
+            raise KnitCorrupt(self._access,
+                              "While reading {%s} got %s(%s)"
+                              % (version_id, e.__class__.__name__, str(e)))
+        header = record_contents.pop(0)
+        rec = self._check_header(version_id, header)
+
+        last_line = record_contents.pop()
+        if len(record_contents) != int(rec[2]):
+            raise KnitCorrupt(self._access,
+                              'incorrect number of lines %s != %s'
+                              ' for version {%s}'
+                              % (len(record_contents), int(rec[2]),
+                                 version_id))
+        if last_line != 'end %s\n' % rec[1]:
+            raise KnitCorrupt(self._access,
+                              'unexpected version end line %r, wanted %r' 
+                              % (last_line, version_id))
+        df.close()
+        return record_contents, rec[3]
+
+    def read_records_iter_raw(self, records):
+        """Read text records from data file and yield raw data.
+
+        This unpacks enough of the text record to validate the id is
+        as expected but thats all.
+        """
+        # setup an iterator of the external records:
+        # uses readv so nice and fast we hope.
+        if len(records):
+            # grab the disk data needed.
+            if self._cache:
+                # Don't check _cache if it is empty
+                needed_offsets = [index_memo for version_id, index_memo
+                                              in records
+                                              if version_id not in self._cache]
+            else:
+                needed_offsets = [index_memo for version_id, index_memo
+                                               in records]
+
+            raw_records = self._access.get_raw_records(needed_offsets)
+
+        for version_id, index_memo in records:
+            if version_id in self._cache:
+                # This data has already been validated
+                data = self._cache[version_id]
+            else:
+                data = raw_records.next()
+                if self._do_cache:
+                    self._cache[version_id] = data
+
+                # validate the header
+                df, rec = self._parse_record_header(version_id, data)
+                df.close()
+            yield version_id, data
+
+    def read_records_iter(self, records):
+        """Read text records from data file and yield result.
+
+        The result will be returned in whatever is the fastest to read.
+        Not by the order requested. Also, multiple requests for the same
+        record will only yield 1 response.
+        :param records: A list of (version_id, pos, len) entries
+        :return: Yields (version_id, contents, digest) in the order
+                 read, not the order requested
+        """
+        if not records:
+            return
+
+        if self._cache:
+            # Skip records we have alread seen
+            yielded_records = set()
+            needed_records = set()
+            for record in records:
+                if record[0] in self._cache:
+                    if record[0] in yielded_records:
+                        continue
+                    yielded_records.add(record[0])
+                    data = self._cache[record[0]]
+                    content, digest = self._parse_record(record[0], data)
+                    yield (record[0], content, digest)
+                else:
+                    needed_records.add(record)
+            needed_records = sorted(needed_records, key=operator.itemgetter(1))
+        else:
+            needed_records = sorted(set(records), key=operator.itemgetter(1))
+
+        if not needed_records:
+            return
+
+        # The transport optimizes the fetching as well 
+        # (ie, reads continuous ranges.)
+        raw_data = self._access.get_raw_records(
+            [index_memo for version_id, index_memo in needed_records])
+
+        for (version_id, index_memo), data in \
+                izip(iter(needed_records), raw_data):
+            content, digest = self._parse_record(version_id, data)
+            if self._do_cache:
+                self._cache[version_id] = data
+            yield version_id, content, digest
+
+    def read_records(self, records):
+        """Read records into a dictionary."""
+        components = {}
+        for record_id, content, digest in \
+                self.read_records_iter(records):
+            components[record_id] = (content, digest)
+        return components
+
+
+class InterKnit(InterVersionedFile):
+    """Optimised code paths for knit to knit operations."""
+    
+    _matching_file_from_factory = KnitVersionedFile
+    _matching_file_to_factory = KnitVersionedFile
+    
+    @staticmethod
+    def is_compatible(source, target):
+        """Be compatible with knits.  """
+        try:
+            return (isinstance(source, KnitVersionedFile) and
+                    isinstance(target, KnitVersionedFile))
+        except AttributeError:
+            return False
+
+    def join(self, pb=None, msg=None, version_ids=None, ignore_missing=False):
+        """See InterVersionedFile.join."""
+        assert isinstance(self.source, KnitVersionedFile)
+        assert isinstance(self.target, KnitVersionedFile)
+
+        # If the source and target are mismatched w.r.t. annotations vs
+        # plain, the data needs to be converted accordingly
+        if self.source.factory.annotated == self.target.factory.annotated:
+            converter = None
+        elif self.source.factory.annotated:
+            converter = self._anno_to_plain_converter
+        else:
+            # We're converting from a plain to an annotated knit. This requires
+            # building the annotations from scratch. The generic join code
+            # handles this implicitly so we delegate to it.
+            return super(InterKnit, self).join(pb, msg, version_ids,
+                ignore_missing)
+
+        version_ids = self._get_source_version_ids(version_ids, ignore_missing)
+        if not version_ids:
+            return 0
+
+        pb = ui.ui_factory.nested_progress_bar()
+        try:
+            version_ids = list(version_ids)
+            if None in version_ids:
+                version_ids.remove(None)
+    
+            self.source_ancestry = set(self.source.get_ancestry(version_ids))
+            this_versions = set(self.target._index.get_versions())
+            # XXX: For efficiency we should not look at the whole index,
+            #      we only need to consider the referenced revisions - they
+            #      must all be present, or the method must be full-text.
+            #      TODO, RBC 20070919
+            needed_versions = self.source_ancestry - this_versions
+    
+            if not needed_versions:
+                return 0
+            full_list = topo_sort(self.source.get_graph())
+    
+            version_list = [i for i in full_list if (not self.target.has_version(i)
+                            and i in needed_versions)]
+    
+            # plan the join:
+            copy_queue = []
+            copy_queue_records = []
+            copy_set = set()
+            for version_id in version_list:
+                options = self.source._index.get_options(version_id)
+                parents = self.source._index.get_parents_with_ghosts(version_id)
+                # check that its will be a consistent copy:
+                for parent in parents:
+                    # if source has the parent, we must :
+                    # * already have it or
+                    # * have it scheduled already
+                    # otherwise we don't care
+                    assert (self.target.has_version(parent) or
+                            parent in copy_set or
+                            not self.source.has_version(parent))
+                index_memo = self.source._index.get_position(version_id)
+                copy_queue_records.append((version_id, index_memo))
+                copy_queue.append((version_id, options, parents))
+                copy_set.add(version_id)
+
+            # data suck the join:
+            count = 0
+            total = len(version_list)
+            raw_datum = []
+            raw_records = []
+            for (version_id, raw_data), \
+                (version_id2, options, parents) in \
+                izip(self.source._data.read_records_iter_raw(copy_queue_records),
+                     copy_queue):
+                assert version_id == version_id2, 'logic error, inconsistent results'
+                count = count + 1
+                pb.update("Joining knit", count, total)
+                if converter:
+                    size, raw_data = converter(raw_data, version_id, options,
+                        parents)
+                else:
+                    size = len(raw_data)
+                raw_records.append((version_id, options, parents, size))
+                raw_datum.append(raw_data)
+            self.target._add_raw_records(raw_records, ''.join(raw_datum))
+            return count
+        finally:
+            pb.finished()
+
+    def _anno_to_plain_converter(self, raw_data, version_id, options,
+                                 parents):
+        """Convert annotated content to plain content."""
+        data, digest = self.source._data._parse_record(version_id, raw_data)
+        if 'fulltext' in options:
+            content = self.source.factory.parse_fulltext(data, version_id)
+            lines = self.target.factory.lower_fulltext(content)
+        else:
+            delta = self.source.factory.parse_line_delta(data, version_id,
+                plain=True)
+            lines = self.target.factory.lower_line_delta(delta)
+        return self.target._data._record_to_data(version_id, digest, lines)
+
+
+InterVersionedFile.register_optimiser(InterKnit)
+
+
+class WeaveToKnit(InterVersionedFile):
+    """Optimised code paths for weave to knit operations."""
+    
+    _matching_file_from_factory = bzrlib.weave.WeaveFile
+    _matching_file_to_factory = KnitVersionedFile
+    
+    @staticmethod
+    def is_compatible(source, target):
+        """Be compatible with weaves to knits."""
+        try:
+            return (isinstance(source, bzrlib.weave.Weave) and
+                    isinstance(target, KnitVersionedFile))
+        except AttributeError:
+            return False
+
+    def join(self, pb=None, msg=None, version_ids=None, ignore_missing=False):
+        """See InterVersionedFile.join."""
+        assert isinstance(self.source, bzrlib.weave.Weave)
+        assert isinstance(self.target, KnitVersionedFile)
+
+        version_ids = self._get_source_version_ids(version_ids, ignore_missing)
+
+        if not version_ids:
+            return 0
+
+        pb = ui.ui_factory.nested_progress_bar()
+        try:
+            version_ids = list(version_ids)
+    
+            self.source_ancestry = set(self.source.get_ancestry(version_ids))
+            this_versions = set(self.target._index.get_versions())
+            needed_versions = self.source_ancestry - this_versions
+    
+            if not needed_versions:
+                return 0
+            full_list = topo_sort(self.source.get_graph())
+    
+            version_list = [i for i in full_list if (not self.target.has_version(i)
+                            and i in needed_versions)]
+    
+            # do the join:
+            count = 0
+            total = len(version_list)
+            for version_id in version_list:
+                pb.update("Converting to knit", count, total)
+                parents = self.source.get_parents(version_id)
+                # check that its will be a consistent copy:
+                for parent in parents:
+                    # if source has the parent, we must already have it
+                    assert (self.target.has_version(parent))
+                self.target.add_lines(
+                    version_id, parents, self.source.get_lines(version_id))
+                count = count + 1
+            return count
+        finally:
+            pb.finished()
+
+
+InterVersionedFile.register_optimiser(WeaveToKnit)
 
 
 # Deprecated, use PatienceSequenceMatcher instead
@@ -2427,311 +2375,24 @@
     It will work for knits with cached annotations, but this is not
     recommended.
     """
-    annotator = _KnitAnnotator(knit)
-    return iter(annotator.annotate(revision_id))
-
-
-class _KnitAnnotator(object):
-    """Build up the annotations for a text."""
-
-    def __init__(self, knit):
-        self._knit = knit
-
-        # Content objects, differs from fulltexts because of how final newlines
-        # are treated by knits. the content objects here will always have a
-        # final newline
-        self._fulltext_contents = {}
-
-        # Annotated lines of specific revisions
-        self._annotated_lines = {}
-
-        # Track the raw data for nodes that we could not process yet.
-        # This maps the revision_id of the base to a list of children that will
-        # annotated from it.
-        self._pending_children = {}
-
-        # Nodes which cannot be extracted
-        self._ghosts = set()
-
-        # Track how many children this node has, so we know if we need to keep
-        # it
-        self._annotate_children = {}
-        self._compression_children = {}
-
-        self._all_build_details = {}
-        # The children => parent revision_id graph
-        self._revision_id_graph = {}
-
-        self._heads_provider = None
-
-        self._nodes_to_keep_annotations = set()
-        self._generations_until_keep = 100
-
-    def set_generations_until_keep(self, value):
-        """Set the number of generations before caching a node.
-
-        Setting this to -1 will cache every merge node, setting this higher
-        will cache fewer nodes.
-        """
-        self._generations_until_keep = value
-
-    def _add_fulltext_content(self, revision_id, content_obj):
-        self._fulltext_contents[revision_id] = content_obj
-        # TODO: jam 20080305 It might be good to check the sha1digest here
-        return content_obj.text()
-
-    def _check_parents(self, child, nodes_to_annotate):
-        """Check if all parents have been processed.
-
-        :param child: A tuple of (rev_id, parents, raw_content)
-        :param nodes_to_annotate: If child is ready, add it to
-            nodes_to_annotate, otherwise put it back in self._pending_children
-        """
-        for parent_id in child[1]:
-            if (parent_id not in self._annotated_lines):
-                # This parent is present, but another parent is missing
-                self._pending_children.setdefault(parent_id,
-                                                  []).append(child)
-                break
+    ancestry = knit.get_ancestry(revision_id)
+    fulltext = dict(zip(ancestry, knit.get_line_list(ancestry)))
+    annotations = {}
+    for candidate in ancestry:
+        if candidate in annotations:
+            continue
+        parents = knit.get_parents(candidate)
+        if len(parents) == 0:
+            blocks = None
+        elif knit._index.get_method(candidate) != 'line-delta':
+            blocks = None
         else:
-            # This one is ready to be processed
-            nodes_to_annotate.append(child)
-
-    def _add_annotation(self, revision_id, fulltext, parent_ids,
-                        left_matching_blocks=None):
-        """Add an annotation entry.
-
-        All parents should already have been annotated.
-        :return: A list of children that now have their parents satisfied.
-        """
-        a = self._annotated_lines
-        annotated_parent_lines = [a[p] for p in parent_ids]
-        annotated_lines = list(annotate.reannotate(annotated_parent_lines,
-            fulltext, revision_id, left_matching_blocks,
-            heads_provider=self._get_heads_provider()))
-        self._annotated_lines[revision_id] = annotated_lines
-        for p in parent_ids:
-            ann_children = self._annotate_children[p]
-            ann_children.remove(revision_id)
-            if (not ann_children
-                and p not in self._nodes_to_keep_annotations):
-                del self._annotated_lines[p]
-                del self._all_build_details[p]
-                if p in self._fulltext_contents:
-                    del self._fulltext_contents[p]
-        # Now that we've added this one, see if there are any pending
-        # deltas to be done, certainly this parent is finished
-        nodes_to_annotate = []
-        for child in self._pending_children.pop(revision_id, []):
-            self._check_parents(child, nodes_to_annotate)
-        return nodes_to_annotate
-
-    def _get_build_graph(self, key):
-        """Get the graphs for building texts and annotations.
-
-        The data you need for creating a full text may be different than the
-        data you need to annotate that text. (At a minimum, you need both
-        parents to create an annotation, but only need 1 parent to generate the
-        fulltext.)
-
-        :return: A list of (key, index_memo) records, suitable for
-            passing to read_records_iter to start reading in the raw data fro/
-            the pack file.
-        """
-        if key in self._annotated_lines:
-            # Nothing to do
-            return []
-        pending = set([key])
-        records = []
-        generation = 0
-        kept_generation = 0
-        while pending:
-            # get all pending nodes
-            generation += 1
-            this_iteration = pending
-            build_details = self._knit._index.get_build_details(this_iteration)
-            self._all_build_details.update(build_details)
-            # new_nodes = self._knit._index._get_entries(this_iteration)
-            pending = set()
-            for key, details in build_details.iteritems():
-                (index_memo, compression_parent, parents,
-                 record_details) = details
-                self._revision_id_graph[key] = parents
-                records.append((key, index_memo))
-                # Do we actually need to check _annotated_lines?
-                pending.update(p for p in parents
-                                 if p not in self._all_build_details)
-                if compression_parent:
-                    self._compression_children.setdefault(compression_parent,
-                        []).append(key)
-                if parents:
-                    for parent in parents:
-                        self._annotate_children.setdefault(parent,
-                            []).append(key)
-                    num_gens = generation - kept_generation
-                    if ((num_gens >= self._generations_until_keep)
-                        and len(parents) > 1):
-                        kept_generation = generation
-                        self._nodes_to_keep_annotations.add(key)
-
-            missing_versions = this_iteration.difference(build_details.keys())
-            self._ghosts.update(missing_versions)
-            for missing_version in missing_versions:
-                # add a key, no parents
-                self._revision_id_graph[missing_version] = ()
-                pending.discard(missing_version) # don't look for it
-        if self._ghosts.intersection(self._compression_children):
-            raise KnitCorrupt(
-                "We cannot have nodes which have a ghost compression parent:\n"
-                "ghosts: %r\n"
-                "compression children: %r"
-                % (self._ghosts, self._compression_children))
-        # Cleanout anything that depends on a ghost so that we don't wait for
-        # the ghost to show up
-        for node in self._ghosts:
-            if node in self._annotate_children:
-                # We won't be building this node
-                del self._annotate_children[node]
-        # Generally we will want to read the records in reverse order, because
-        # we find the parent nodes after the children
-        records.reverse()
-        return records
-
-    def _annotate_records(self, records):
-        """Build the annotations for the listed records."""
-        # We iterate in the order read, rather than a strict order requested
-        # However, process what we can, and put off to the side things that
-        # still need parents, cleaning them up when those parents are
-        # processed.
-        for (rev_id, record,
-             digest) in self._knit._read_records_iter(records):
-            if rev_id in self._annotated_lines:
-                continue
-            parent_ids = self._revision_id_graph[rev_id]
-            parent_ids = [p for p in parent_ids if p not in self._ghosts]
-            details = self._all_build_details[rev_id]
-            (index_memo, compression_parent, parents,
-             record_details) = details
-            nodes_to_annotate = []
-            # TODO: Remove the punning between compression parents, and
-            #       parent_ids, we should be able to do this without assuming
-            #       the build order
-            if len(parent_ids) == 0:
-                # There are no parents for this node, so just add it
-                # TODO: This probably needs to be decoupled
-                fulltext_content, delta = self._knit._factory.parse_record(
-                    rev_id, record, record_details, None)
-                fulltext = self._add_fulltext_content(rev_id, fulltext_content)
-                nodes_to_annotate.extend(self._add_annotation(rev_id, fulltext,
-                    parent_ids, left_matching_blocks=None))
-            else:
-                child = (rev_id, parent_ids, record)
-                # Check if all the parents are present
-                self._check_parents(child, nodes_to_annotate)
-            while nodes_to_annotate:
-                # Should we use a queue here instead of a stack?
-                (rev_id, parent_ids, record) = nodes_to_annotate.pop()
-                (index_memo, compression_parent, parents,
-                 record_details) = self._all_build_details[rev_id]
-                if compression_parent is not None:
-                    comp_children = self._compression_children[compression_parent]
-                    if rev_id not in comp_children:
-                        raise AssertionError("%r not in compression children %r"
-                            % (rev_id, comp_children))
-                    # If there is only 1 child, it is safe to reuse this
-                    # content
-                    reuse_content = (len(comp_children) == 1
-                        and compression_parent not in
-                            self._nodes_to_keep_annotations)
-                    if reuse_content:
-                        # Remove it from the cache since it will be changing
-                        parent_fulltext_content = self._fulltext_contents.pop(compression_parent)
-                        # Make sure to copy the fulltext since it might be
-                        # modified
-                        parent_fulltext = list(parent_fulltext_content.text())
-                    else:
-                        parent_fulltext_content = self._fulltext_contents[compression_parent]
-                        parent_fulltext = parent_fulltext_content.text()
-                    comp_children.remove(rev_id)
-                    fulltext_content, delta = self._knit._factory.parse_record(
-                        rev_id, record, record_details,
-                        parent_fulltext_content,
-                        copy_base_content=(not reuse_content))
-                    fulltext = self._add_fulltext_content(rev_id,
-                                                          fulltext_content)
-                    blocks = KnitContent.get_line_delta_blocks(delta,
-                            parent_fulltext, fulltext)
-                else:
-                    fulltext_content = self._knit._factory.parse_fulltext(
-                        record, rev_id)
-                    fulltext = self._add_fulltext_content(rev_id,
-                        fulltext_content)
-                    blocks = None
-                nodes_to_annotate.extend(
-                    self._add_annotation(rev_id, fulltext, parent_ids,
-                                     left_matching_blocks=blocks))
-
-    def _get_heads_provider(self):
-        """Create a heads provider for resolving ancestry issues."""
-        if self._heads_provider is not None:
-            return self._heads_provider
-        parent_provider = _mod_graph.DictParentsProvider(
-            self._revision_id_graph)
-        graph_obj = _mod_graph.Graph(parent_provider)
-        head_cache = _mod_graph.FrozenHeadsCache(graph_obj)
-        self._heads_provider = head_cache
-        return head_cache
-
-    def annotate(self, key):
-        """Return the annotated fulltext at the given key.
-
-        :param key: The key to annotate.
-        """
-        if True or len(self._knit._fallback_vfs) > 0:
-            # stacked knits can't use the fast path at present.
-            return self._simple_annotate(key)
-        records = self._get_build_graph(key)
-        if key in self._ghosts:
-            raise errors.RevisionNotPresent(key, self._knit)
-        self._annotate_records(records)
-        return self._annotated_lines[key]
-
-    def _simple_annotate(self, key):
-        """Return annotated fulltext, rediffing from the full texts.
-
-        This is slow but makes no assumptions about the repository
-        being able to produce line deltas.
-        """
-        # TODO: this code generates a parent maps of present ancestors; it
-        # could be split out into a separate method, and probably should use
-        # iter_ancestry instead. -- mbp and robertc 20080704
-        graph = _mod_graph.Graph(self._knit)
-        head_cache = _mod_graph.FrozenHeadsCache(graph)
-        search = graph._make_breadth_first_searcher([key])
-        keys = set()
-        while True:
-            try:
-                present, ghosts = search.next_with_ghosts()
-            except StopIteration:
-                break
-            keys.update(present)
-        parent_map = self._knit.get_parent_map(keys)
-        parent_cache = {}
-        reannotate = annotate.reannotate
-        for record in self._knit.get_record_stream(keys, 'topological', True):
-            key = record.key
-            fulltext = split_lines(record.get_bytes_as('fulltext'))
-            parents = parent_map[key]
-            if parents is not None:
-                parent_lines = [parent_cache[parent] for parent in parent_map[key]]
-            else:
-                parent_lines = []
-            parent_cache[key] = list(
-                reannotate(parent_lines, fulltext, key, None, head_cache))
-        try:
-            return parent_cache[key]
-        except KeyError, e:
-            raise errors.RevisionNotPresent(key, self._knit)
+            parent, sha1, noeol, delta = knit.get_delta(candidate)
+            blocks = KnitContent.get_line_delta_blocks(delta,
+                fulltext[parents[0]], fulltext[candidate])
+        annotations[candidate] = list(annotate.reannotate([annotations[p]
+            for p in parents], fulltext[candidate], candidate, blocks))
+    return iter(annotations[revision_id])
 
 
 try:

=== modified file 'bzrlib/lazy_import.py'
--- bzrlib/lazy_import.py	2008-05-08 04:12:06 +0000
+++ bzrlib/lazy_import.py	2007-04-12 21:33:07 +0000
@@ -64,10 +64,10 @@
             It will be passed (self, scope, name)
         :param name: The variable name in the given scope.
         """
-        object.__setattr__(self, '_scope', scope)
-        object.__setattr__(self, '_factory', factory)
-        object.__setattr__(self, '_name', name)
-        object.__setattr__(self, '_real_obj', None)
+        self._scope = scope
+        self._factory = factory
+        self._name = name
+        self._real_obj = None
         scope[name] = self
 
     def _replace(self):
@@ -88,7 +88,7 @@
                 extra=e)
         obj = factory(self, scope, name)
         if ScopeReplacer._should_proxy:
-            object.__setattr__(self, '_real_obj', obj)
+            self._real_obj = obj
         scope[name] = obj
         return obj
 
@@ -108,15 +108,6 @@
             _cleanup()
         return getattr(obj, attr)
 
-    def __setattr__(self, attr, value):
-        obj = object.__getattribute__(self, '_real_obj')
-        if obj is None:
-            _replace = object.__getattribute__(self, '_replace')
-            obj = _replace()
-            _cleanup = object.__getattribute__(self, '_cleanup')
-            _cleanup()
-        return setattr(obj, attr, value)
-
     def __call__(self, *args, **kwargs):
         _replace = object.__getattribute__(self, '_replace')
         obj = _replace()
@@ -170,12 +161,13 @@
             from foo import bar, baz would get translated into 2 import
             requests. On for 'name=bar' and one for 'name=baz'
         """
-        if (member is not None) and children:
-            raise ValueError('Cannot supply both a member and children')
+        if member is not None:
+            assert not children, \
+                'Cannot supply both a member and children'
 
-        object.__setattr__(self, '_import_replacer_children', children)
-        object.__setattr__(self, '_member', member)
-        object.__setattr__(self, '_module_path', module_path)
+        self._import_replacer_children = children
+        self._member = member
+        self._module_path = module_path
 
         # Indirecting through __class__ so that children can
         # override _import (especially our instrumented version)
@@ -259,8 +251,7 @@
 
         :param import_str: The import string to process
         """
-        if not import_str.startswith('import '):
-            raise ValueError('bad import string %r' % (import_str,))
+        assert import_str.startswith('import ')
         import_str = import_str[len('import '):]
 
         for path in import_str.split(','):
@@ -305,8 +296,7 @@
 
         :param from_str: The import string to process
         """
-        if not from_str.startswith('from '):
-            raise ValueError('bad from/import %r' % from_str)
+        assert from_str.startswith('from ')
         from_str = from_str[len('from '):]
 
         from_module, import_list = from_str.split(' import ')

=== modified file 'bzrlib/lazy_regex.py'
--- bzrlib/lazy_regex.py	2008-04-24 07:22:53 +0000
+++ bzrlib/lazy_regex.py	2006-10-16 01:25:46 +0000
@@ -101,7 +101,6 @@
 
 
 _real_re_compile = re.compile
-if _real_re_compile is lazy_compile:
-    raise AssertionError(
-        "re.compile has already been overridden as lazy_compile, but this would" \
-        " cause infinite recursion")
+assert _real_re_compile is not lazy_compile, \
+    "re.compile has already been overridden as lazy_compile, but this would" \
+    " cause infinite recursion"

=== modified file 'bzrlib/lock.py'
--- bzrlib/lock.py	2008-04-24 07:22:53 +0000
+++ bzrlib/lock.py	2007-10-03 08:06:44 +0000
@@ -187,9 +187,7 @@
 
             :return: A token which can be used to switch back to a read lock.
             """
-            if self.filename in _fcntl_WriteLock._open_locks:
-                raise AssertionError('file already locked: %r'
-                    % (self.filename,))
+            assert self.filename not in _fcntl_WriteLock._open_locks
             try:
                 wlock = _fcntl_TemporaryWriteLock(self)
             except errors.LockError:
@@ -215,9 +213,7 @@
                 # write lock.
                 raise errors.LockContention(self.filename)
 
-            if self.filename in _fcntl_WriteLock._open_locks:
-                raise AssertionError('file already locked: %r'
-                    % (self.filename,))
+            assert self.filename not in _fcntl_WriteLock._open_locks
 
             # See if we can open the file for writing. Another process might
             # have a read lock. We don't use self._open() because we don't want

=== modified file 'bzrlib/lockable_files.py'
--- bzrlib/lockable_files.py	2008-07-09 19:57:36 +0000
+++ bzrlib/lockable_files.py	2007-08-15 04:33:34 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2008 Canonical Ltd
+# Copyright (C) 2005, 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -15,28 +15,20 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 from cStringIO import StringIO
-
-from bzrlib.lazy_import import lazy_import
-lazy_import(globals(), """
 import codecs
-import warnings
-
-from bzrlib import (
-    errors,
-    osutils,
-    transactions,
-    urlutils,
-    )
-""")
-
-from bzrlib.decorators import (
-    needs_read_lock,
-    needs_write_lock,
-    )
-from bzrlib.symbol_versioning import (
-    deprecated_in,
-    deprecated_method,
-    )
+#import traceback
+
+import bzrlib
+from bzrlib.decorators import (needs_read_lock,
+        needs_write_lock)
+import bzrlib.errors as errors
+from bzrlib.errors import BzrError
+from bzrlib.osutils import file_iterator, safe_unicode
+from bzrlib.symbol_versioning import (deprecated_method,
+        )
+from bzrlib.trace import mutter, note
+import bzrlib.transactions as transactions
+import bzrlib.urlutils as urlutils
 
 
 # XXX: The tracking here of lock counts and whether the lock is held is
@@ -64,10 +56,6 @@
     the object is constructed.  In older formats OSLocks are used everywhere.
     in newer formats a LockDir is used for Repositories and Branches, and 
     OSLocks for the local filesystem.
-
-    This class is now deprecated; code should move to using the Transport 
-    directly for file operations and using the lock or CountedLock for 
-    locking.
     """
 
     # _lock_mode: None, or 'r' or 'w'
@@ -75,6 +63,11 @@
     # _lock_count: If _lock_mode is true, a positive count of the number of
     # times the lock has been taken *by this process*.   
     
+    # If set to False (by a plugin, etc) BzrBranch will not set the
+    # mode on created files or directories
+    _set_file_mode = True
+    _set_dir_mode = True
+
     def __init__(self, transport, lock_name, lock_class):
         """Create a LockableFiles group
 
@@ -111,9 +104,11 @@
 
     def __del__(self):
         if self.is_locked():
-            # do not automatically unlock; there should have been a
-            # try/finally to unlock this.
-            warnings.warn("%r was gc'd while locked" % self)
+            # XXX: This should show something every time, and be suitable for
+            # headless operation and embedding
+            from warnings import warn
+            warn("file group %r was not explicitly unlocked" % self)
+            self._lock.unlock()
 
     def break_lock(self):
         """Break the lock of this lockable files group if it is held.
@@ -127,91 +122,67 @@
             file_or_path = '/'.join(file_or_path)
         if file_or_path == '':
             return u''
-        return urlutils.escape(osutils.safe_unicode(file_or_path))
+        return urlutils.escape(safe_unicode(file_or_path))
 
     def _find_modes(self):
-        """Determine the appropriate modes for files and directories.
-        
-        :deprecated: Replaced by BzrDir._find_modes.
-        """
+        """Determine the appropriate modes for files and directories."""
         try:
             st = self._transport.stat('.')
         except errors.TransportNotPossible:
             self._dir_mode = 0755
             self._file_mode = 0644
         else:
-            # Check the directory mode, but also make sure the created
-            # directories and files are read-write for this user. This is
-            # mostly a workaround for filesystems which lie about being able to
-            # write to a directory (cygwin & win32)
-            self._dir_mode = (st.st_mode & 07777) | 00700
+            self._dir_mode = st.st_mode & 07777
             # Remove the sticky and execute bits for files
             self._file_mode = self._dir_mode & ~07111
+        if not self._set_dir_mode:
+            self._dir_mode = None
+        if not self._set_file_mode:
+            self._file_mode = None
 
-    @deprecated_method(deprecated_in((1, 6, 0)))
     def controlfilename(self, file_or_path):
-        """Return location relative to branch.
-        
-        :deprecated: Use Transport methods instead.
-        """
+        """Return location relative to branch."""
         return self._transport.abspath(self._escape(file_or_path))
 
     @needs_read_lock
-    @deprecated_method(deprecated_in((1, 5, 0)))
     def get(self, relpath):
-        """Get a file as a bytestream.
-        
-        :deprecated: Use a Transport instead of LockableFiles.
-        """
+        """Get a file as a bytestream."""
         relpath = self._escape(relpath)
         return self._transport.get(relpath)
 
     @needs_read_lock
-    @deprecated_method(deprecated_in((1, 5, 0)))
     def get_utf8(self, relpath):
-        """Get a file as a unicode stream.
-        
-        :deprecated: Use a Transport instead of LockableFiles.
-        """
+        """Get a file as a unicode stream."""
         relpath = self._escape(relpath)
         # DO NOT introduce an errors=replace here.
         return codecs.getreader('utf-8')(self._transport.get(relpath))
 
     @needs_write_lock
-    @deprecated_method(deprecated_in((1, 6, 0)))
     def put(self, path, file):
         """Write a file.
         
         :param path: The path to put the file, relative to the .bzr control
                      directory
-        :param file: A file-like or string object whose contents should be copied.
-
-        :deprecated: Use Transport methods instead.
+        :param f: A file-like or string object whose contents should be copied.
         """
         self._transport.put_file(self._escape(path), file, mode=self._file_mode)
 
     @needs_write_lock
-    @deprecated_method(deprecated_in((1, 6, 0)))
     def put_bytes(self, path, a_string):
         """Write a string of bytes.
 
         :param path: The path to put the bytes, relative to the transport root.
-        :param a_string: A string object, whose exact bytes are to be copied.
-
-        :deprecated: Use Transport methods instead.
+        :param string: A string object, whose exact bytes are to be copied.
         """
         self._transport.put_bytes(self._escape(path), a_string,
                                   mode=self._file_mode)
 
     @needs_write_lock
-    @deprecated_method(deprecated_in((1, 6, 0)))
     def put_utf8(self, path, a_string):
         """Write a string, encoding as utf-8.
 
         :param path: The path to put the string, relative to the transport root.
         :param string: A string or unicode object whose contents should be copied.
-
-        :deprecated: Use Transport methods instead.
         """
         # IterableFile would not be needed if Transport.put took iterables
         # instead of files.  ADHB 2005-12-25
@@ -246,6 +217,7 @@
         some other way, and need to synchronise this object's state with that
         fact.
         """
+        # mutter("lock write: %s (%s)", self, self._lock_count)
         # TODO: Upgrade locking to support using a Transport,
         # and potentially a remote locking protocol
         if self._lock_mode:
@@ -256,6 +228,7 @@
             return self._token_from_lock
         else:
             token_from_lock = self._lock.lock_write(token=token)
+            #note('write locking %s', self)
             #traceback.print_stack()
             self._lock_mode = 'w'
             self._lock_count = 1
@@ -264,12 +237,14 @@
             return token_from_lock
 
     def lock_read(self):
+        # mutter("lock read: %s (%s)", self, self._lock_count)
         if self._lock_mode:
-            if self._lock_mode not in ('r', 'w'):
-                raise ValueError("invalid lock mode %r" % (self._lock_mode,))
+            assert self._lock_mode in ('r', 'w'), \
+                   "invalid lock mode %r" % self._lock_mode
             self._lock_count += 1
         else:
             self._lock.lock_read()
+            #note('read locking %s', self)
             #traceback.print_stack()
             self._lock_mode = 'r'
             self._lock_count = 1
@@ -278,11 +253,13 @@
             self.get_transaction().set_cache_size(5000)
                         
     def unlock(self):
+        # mutter("unlock: %s (%s)", self, self._lock_count)
         if not self._lock_mode:
             raise errors.LockNotHeld(self)
         if self._lock_count > 1:
             self._lock_count -= 1
         else:
+            #note('unlocking %s', self)
             #traceback.print_stack()
             self._finish_transaction()
             try:

=== modified file 'bzrlib/lockdir.py'
--- bzrlib/lockdir.py	2008-08-16 04:00:54 +0000
+++ bzrlib/lockdir.py	2007-10-03 08:06:44 +0000
@@ -128,7 +128,7 @@
         )
 from bzrlib.trace import mutter, note
 from bzrlib.transport import Transport
-from bzrlib.osutils import rand_chars, format_delta, get_host_name
+from bzrlib.osutils import rand_chars, format_delta
 from bzrlib.rio import read_stanza, Stanza
 import bzrlib.ui
 
@@ -167,6 +167,8 @@
         :param path: Path to the lock within the base directory of the 
             transport.
         """
+        assert isinstance(transport, Transport), \
+            ("not a transport: %r" % transport)
         self.transport = transport
         self.path = path
         self._lock_held = False
@@ -415,6 +417,8 @@
         try:
             info = self._read_info_file(self._held_info_path)
             self._trace("peek -> held")
+            assert isinstance(info, dict), \
+                    "bad parse result %r" % info
             return info
         except NoSuchFile, e:
             self._trace("peek -> not held")
@@ -422,13 +426,14 @@
     def _prepare_info(self):
         """Write information about a pending lock to a temporary file.
         """
+        import socket
         # XXX: is creating this here inefficient?
         config = bzrlib.config.GlobalConfig()
         try:
             user = config.user_email()
         except errors.NoEmailInUsername:
             user = config.username()
-        s = Stanza(hostname=get_host_name(),
+        s = Stanza(hostname=socket.gethostname(),
                    pid=str(os.getpid()),
                    start_time=str(int(time.time())),
                    nonce=self.nonce,
@@ -505,20 +510,15 @@
                 if deadline_str is None:
                     deadline_str = time.strftime('%H:%M:%S',
                                                  time.localtime(deadline))
-                lock_url = self.transport.abspath(self.path)
                 self._report_function('%s %s\n'
                                       '%s\n' # held by
                                       '%s\n' # locked ... ago
-                                      'Will continue to try until %s, unless '
-                                      'you press Ctrl-C\n'
-                                      'If you\'re sure that it\'s not being '
-                                      'modified, use bzr break-lock %s',
+                                      'Will continue to try until %s\n',
                                       start,
                                       formatted_info[0],
                                       formatted_info[1],
                                       formatted_info[2],
-                                      deadline_str,
-                                      lock_url)
+                                      deadline_str)
 
             if (max_attempts is not None) and (attempt_count >= max_attempts):
                 self._trace("exceeded %d attempts")

=== modified file 'bzrlib/log.py'
--- bzrlib/log.py	2008-09-01 00:56:53 +0000
+++ bzrlib/log.py	2007-10-16 17:37:43 +0000
@@ -49,37 +49,25 @@
 all the changes since the previous revision that touched hello.c.
 """
 
-import codecs
-from itertools import (
-    izip,
-    )
+from itertools import izip
 import re
-import sys
-from warnings import (
-    warn,
-    )
-
-from bzrlib.lazy_import import lazy_import
-lazy_import(globals(), """
-
-from bzrlib import (
-    config,
-    errors,
-    repository as _mod_repository,
-    revision as _mod_revision,
-    revisionspec,
-    trace,
-    tsort,
-    )
-""")
 
 from bzrlib import (
     registry,
-    )
-from bzrlib.osutils import (
-    format_date,
-    get_terminal_encoding,
-    terminal_width,
+    symbol_versioning,
+    )
+import bzrlib.errors as errors
+from bzrlib.revisionspec import(
+    RevisionInfo
+    )
+from bzrlib.symbol_versioning import (
+    deprecated_method,
+    zero_seventeen,
+    )
+from bzrlib.trace import mutter
+from bzrlib.tsort import (
+    merge_sort,
+    topo_sort,
     )
 
 
@@ -186,7 +174,6 @@
     finally:
         branch.unlock()
 
-
 def _show_log(branch,
              lf,
              specific_fileid=None,
@@ -197,74 +184,56 @@
              search=None,
              limit=None):
     """Worker function for show_log - see show_log."""
+    from bzrlib.osutils import format_date
+    from bzrlib.errors import BzrCheckError
+    
+    from warnings import warn
+
     if not isinstance(lf, LogFormatter):
         warn("not a LogFormatter instance: %r" % lf)
 
     if specific_fileid:
-        trace.mutter('get log for file_id %r', specific_fileid)
-    generate_merge_revisions = getattr(lf, 'supports_merge_revisions', False)
-    allow_single_merge_revision = getattr(lf,
-        'supports_single_merge_revision', False)
-    view_revisions = calculate_view_revisions(branch, start_revision,
-                                              end_revision, direction,
-                                              specific_fileid,
-                                              generate_merge_revisions,
-                                              allow_single_merge_revision)
-    rev_tag_dict = {}
-    generate_tags = getattr(lf, 'supports_tags', False)
-    if generate_tags:
-        if branch.supports_tags():
-            rev_tag_dict = branch.tags.get_reverse_tag_dict()
-
-    generate_delta = verbose and getattr(lf, 'supports_delta', False)
-
-    # now we just print all the revisions
-    log_count = 0
-    revision_iterator = make_log_rev_iterator(branch, view_revisions,
-        generate_delta, search)
-    for revs in revision_iterator:
-        for (rev_id, revno, merge_depth), rev, delta in revs:
-            lr = LogRevision(rev, revno, merge_depth, delta,
-                             rev_tag_dict.get(rev_id))
-            lf.log_revision(lr)
-            if limit:
-                log_count += 1
-                if log_count >= limit:
-                    return
-
-
-def calculate_view_revisions(branch, start_revision, end_revision, direction,
-                             specific_fileid, generate_merge_revisions,
-                             allow_single_merge_revision):
-    if (not generate_merge_revisions and start_revision is end_revision is
-        None and direction == 'reverse' and specific_fileid is None):
-        return _linear_view_revisions(branch)
+        mutter('get log for file_id %r', specific_fileid)
+
+    if search is not None:
+        import re
+        searchRE = re.compile(search, re.IGNORECASE)
+    else:
+        searchRE = None
 
     mainline_revs, rev_nos, start_rev_id, end_rev_id = \
         _get_mainline_revs(branch, start_revision, end_revision)
     if not mainline_revs:
-        return []
+        return
 
     if direction == 'reverse':
         start_rev_id, end_rev_id = end_rev_id, start_rev_id
-
-    generate_single_revision = False
-    if ((not generate_merge_revisions)
-        and ((start_rev_id and (start_rev_id not in rev_nos))
-            or (end_rev_id and (end_rev_id not in rev_nos)))):
-        generate_single_revision = ((start_rev_id == end_rev_id)
-            and allow_single_merge_revision)
-        if not generate_single_revision:
-            raise errors.BzrCommandError('Selected log formatter only supports'
-                ' mainline revisions.')
-        generate_merge_revisions = generate_single_revision
+        
+    legacy_lf = getattr(lf, 'log_revision', None) is None
+    if legacy_lf:
+        # pre-0.17 formatters use show for mainline revisions.
+        # how should we show merged revisions ?
+        #   pre-0.11 api: show_merge
+        #   0.11-0.16 api: show_merge_revno
+        show_merge_revno = getattr(lf, 'show_merge_revno', None)
+        show_merge = getattr(lf, 'show_merge', None)
+        if show_merge is None and show_merge_revno is None:
+            # no merged-revno support
+            generate_merge_revisions = False
+        else:
+            generate_merge_revisions = True
+        # tell developers to update their code
+        symbol_versioning.warn('LogFormatters should provide log_revision '
+            'instead of show and show_merge_revno since bzr 0.17.',
+            DeprecationWarning, stacklevel=3)
+    else:
+        generate_merge_revisions = getattr(lf, 'supports_merge_revisions', 
+                                           False)
     view_revs_iter = get_view_revisions(mainline_revs, rev_nos, branch,
                           direction, include_merges=generate_merge_revisions)
     view_revisions = _filter_revision_range(list(view_revs_iter),
                                             start_rev_id,
                                             end_rev_id)
-    if view_revisions and generate_single_revision:
-        view_revisions = view_revisions[0:1]
     if specific_fileid:
         view_revisions = _filter_revisions_touching_file_id(branch,
                                                          specific_fileid,
@@ -277,138 +246,65 @@
         min_depth = min([d for r,n,d in view_revisions])
         if min_depth != 0:
             view_revisions = [(r,n,d-min_depth) for r,n,d in view_revisions]
-    return view_revisions
-
-
-def _linear_view_revisions(branch):
-    start_revno, start_revision_id = branch.last_revision_info()
-    repo = branch.repository
-    revision_ids = repo.iter_reverse_revision_history(start_revision_id)
-    for num, revision_id in enumerate(revision_ids):
-        yield revision_id, str(start_revno - num), 0
-
-
-def make_log_rev_iterator(branch, view_revisions, generate_delta, search):
-    """Create a revision iterator for log.
-
-    :param branch: The branch being logged.
-    :param view_revisions: The revisions being viewed.
-    :param generate_delta: Whether to generate a delta for each revision.
-    :param search: A user text search string.
-    :return: An iterator over lists of ((rev_id, revno, merge_depth), rev,
-        delta).
-    """
-    # Convert view_revisions into (view, None, None) groups to fit with
-    # the standard interface here.
-    if type(view_revisions) == list:
-        # A single batch conversion is faster than many incremental ones.
-        # As we have all the data, do a batch conversion.
-        nones = [None] * len(view_revisions)
-        log_rev_iterator = iter([zip(view_revisions, nones, nones)])
-    else:
-        def _convert():
-            for view in view_revisions:
-                yield (view, None, None)
-        log_rev_iterator = iter([_convert()])
-    for adapter in log_adapters:
-        log_rev_iterator = adapter(branch, generate_delta, search,
-            log_rev_iterator)
-    return log_rev_iterator
-
-
-def _make_search_filter(branch, generate_delta, search, log_rev_iterator):
-    """Create a filtered iterator of log_rev_iterator matching on a regex.
-
-    :param branch: The branch being logged.
-    :param generate_delta: Whether to generate a delta for each revision.
-    :param search: A user text search string.
-    :param log_rev_iterator: An input iterator containing all revisions that
-        could be displayed, in lists.
-    :return: An iterator over lists of ((rev_id, revno, merge_depth), rev,
-        delta).
-    """
-    if search is None:
-        return log_rev_iterator
-    # Compile the search now to get early errors.
-    searchRE = re.compile(search, re.IGNORECASE)
-    return _filter_message_re(searchRE, log_rev_iterator)
-
-
-def _filter_message_re(searchRE, log_rev_iterator):
-    for revs in log_rev_iterator:
-        new_revs = []
-        for (rev_id, revno, merge_depth), rev, delta in revs:
-            if searchRE.search(rev.message):
-                new_revs.append(((rev_id, revno, merge_depth), rev, delta))
-        yield new_revs
-
-
-def _make_delta_filter(branch, generate_delta, search, log_rev_iterator):
-    """Add revision deltas to a log iterator if needed.
-
-    :param branch: The branch being logged.
-    :param generate_delta: Whether to generate a delta for each revision.
-    :param search: A user text search string.
-    :param log_rev_iterator: An input iterator containing all revisions that
-        could be displayed, in lists.
-    :return: An iterator over lists of ((rev_id, revno, merge_depth), rev,
-        delta).
-    """
-    if not generate_delta:
-        return log_rev_iterator
-    return _generate_deltas(branch.repository, log_rev_iterator)
-
-
-def _generate_deltas(repository, log_rev_iterator):
-    """Create deltas for each batch of revisions in log_rev_iterator."""
-    for revs in log_rev_iterator:
-        revisions = [rev[1] for rev in revs]
-        deltas = repository.get_deltas_for_revisions(revisions)
-        revs = [(rev[0], rev[1], delta) for rev, delta in izip(revs, deltas)]
-        yield revs
-
-
-def _make_revision_objects(branch, generate_delta, search, log_rev_iterator):
-    """Extract revision objects from the repository
-
-    :param branch: The branch being logged.
-    :param generate_delta: Whether to generate a delta for each revision.
-    :param search: A user text search string.
-    :param log_rev_iterator: An input iterator containing all revisions that
-        could be displayed, in lists.
-    :return: An iterator over lists of ((rev_id, revno, merge_depth), rev,
-        delta).
-    """
-    repository = branch.repository
-    for revs in log_rev_iterator:
-        # r = revision_id, n = revno, d = merge depth
-        revision_ids = [view[0] for view, _, _ in revs]
-        revisions = repository.get_revisions(revision_ids)
-        revs = [(rev[0], revision, rev[2]) for rev, revision in
-            izip(revs, revisions)]
-        yield revs
-
-
-def _make_batch_filter(branch, generate_delta, search, log_rev_iterator):
-    """Group up a single large batch into smaller ones.
-
-    :param branch: The branch being logged.
-    :param generate_delta: Whether to generate a delta for each revision.
-    :param search: A user text search string.
-    :param log_rev_iterator: An input iterator containing all revisions that
-        could be displayed, in lists.
-    :return: An iterator over lists of ((rev_id, revno, merge_depth), rev, delta).
-    """
-    repository = branch.repository
-    num = 9
-    for batch in log_rev_iterator:
-        batch = iter(batch)
-        while True:
-            step = [detail for _, detail in zip(range(num), batch)]
-            if len(step) == 0:
+        
+    rev_tag_dict = {}
+    generate_tags = getattr(lf, 'supports_tags', False)
+    if generate_tags:
+        if branch.supports_tags():
+            rev_tag_dict = branch.tags.get_reverse_tag_dict()
+
+    generate_delta = verbose and getattr(lf, 'supports_delta', False)
+
+    def iter_revisions():
+        # r = revision, n = revno, d = merge depth
+        revision_ids = [r for r, n, d in view_revisions]
+        num = 9
+        repository = branch.repository
+        while revision_ids:
+            cur_deltas = {}
+            revisions = repository.get_revisions(revision_ids[:num])
+            if generate_delta:
+                deltas = repository.get_deltas_for_revisions(revisions)
+                cur_deltas = dict(izip((r.revision_id for r in revisions),
+                                       deltas))
+            for revision in revisions:
+                yield revision, cur_deltas.get(revision.revision_id)
+            revision_ids  = revision_ids[num:]
+            num = min(int(num * 1.5), 200)
+
+    # now we just print all the revisions
+    log_count = 0
+    for ((rev_id, revno, merge_depth), (rev, delta)) in \
+         izip(view_revisions, iter_revisions()):
+
+        if searchRE:
+            if not searchRE.search(rev.message):
+                continue
+
+        if not legacy_lf:
+            lr = LogRevision(rev, revno, merge_depth, delta,
+                             rev_tag_dict.get(rev_id))
+            lf.log_revision(lr)
+        else:
+            # support for legacy (pre-0.17) LogFormatters
+            if merge_depth == 0:
+                if generate_tags:
+                    lf.show(revno, rev, delta, rev_tag_dict.get(rev_id))
+                else:
+                    lf.show(revno, rev, delta)
+            else:
+                if show_merge_revno is None:
+                    lf.show_merge(rev, merge_depth)
+                else:
+                    if generate_tags:
+                        lf.show_merge_revno(rev, merge_depth, revno,
+                                            rev_tag_dict.get(rev_id))
+                    else:
+                        lf.show_merge_revno(rev, merge_depth, revno)
+        if limit:
+            log_count += 1
+            if log_count >= limit:
                 break
-            yield step
-            num = min(int(num * 1.5), 200)
 
 
 def _get_mainline_revs(branch, start_revision, end_revision):
@@ -428,8 +324,8 @@
 
     :return: A (mainline_revs, rev_nos, start_rev_id, end_rev_id) tuple.
     """
-    branch_revno, branch_last_revision = branch.last_revision_info()
-    if branch_revno == 0:
+    which_revs = _enumerate_history(branch)
+    if not which_revs:
         return None, None, None, None
 
     # For mainline generation, map start_revision and end_revision to 
@@ -442,7 +338,7 @@
     if start_revision is None:
         start_revno = 1
     else:
-        if isinstance(start_revision, revisionspec.RevisionInfo):
+        if isinstance(start_revision,RevisionInfo):
             start_rev_id = start_revision.rev_id
             start_revno = start_revision.revno or 1
         else:
@@ -451,45 +347,34 @@
     
     end_rev_id = None
     if end_revision is None:
-        end_revno = branch_revno
+        end_revno = len(which_revs)
     else:
-        if isinstance(end_revision, revisionspec.RevisionInfo):
+        if isinstance(end_revision,RevisionInfo):
             end_rev_id = end_revision.rev_id
-            end_revno = end_revision.revno or branch_revno
+            end_revno = end_revision.revno or len(which_revs)
         else:
             branch.check_real_revno(end_revision)
             end_revno = end_revision
 
-    if ((start_rev_id == _mod_revision.NULL_REVISION)
-        or (end_rev_id == _mod_revision.NULL_REVISION)):
-        raise errors.BzrCommandError('Logging revision 0 is invalid.')
     if start_revno > end_revno:
-        raise errors.BzrCommandError("Start revision must be older than "
-                                     "the end revision.")
+        from bzrlib.errors import BzrCommandError
+        raise BzrCommandError("Start revision must be older than "
+                              "the end revision.")
 
-    if end_revno < start_revno:
+    # list indexes are 0-based; revisions are 1-based
+    cut_revs = which_revs[(start_revno-1):(end_revno)]
+    if not cut_revs:
         return None, None, None, None
-    cur_revno = branch_revno
-    rev_nos = {}
-    mainline_revs = []
-    for revision_id in branch.repository.iter_reverse_revision_history(
-                        branch_last_revision):
-        if cur_revno < start_revno:
-            # We have gone far enough, but we always add 1 more revision
-            rev_nos[revision_id] = cur_revno
-            mainline_revs.append(revision_id)
-            break
-        if cur_revno <= end_revno:
-            rev_nos[revision_id] = cur_revno
-            mainline_revs.append(revision_id)
-        cur_revno -= 1
-    else:
-        # We walked off the edge of all revisions, so we add a 'None' marker
-        mainline_revs.append(None)
 
-    mainline_revs.reverse()
+    # convert the revision history to a dictionary:
+    rev_nos = dict((k, v) for v, k in cut_revs)
 
     # override the mainline to look like the revision history.
+    mainline_revs = [revision_id for index, revision_id in cut_revs]
+    if cut_revs[0][0] == 1:
+        mainline_revs.insert(0, None)
+    else:
+        mainline_revs.insert(0, which_revs[start_revno-2][1])
     return mainline_revs, rev_nos, start_rev_id, end_rev_id
 
 
@@ -557,42 +442,30 @@
     :return: A list of (revision_id, dotted_revno, merge_depth) tuples.
     """
     # find all the revisions that change the specific file
+    file_weave = branch.repository.weave_store.get_weave(file_id,
+                branch.repository.get_transaction())
+    weave_modifed_revisions = set(file_weave.versions())
     # build the ancestry of each revision in the graph
     # - only listing the ancestors that change the specific file.
-    graph = branch.repository.get_graph()
-    # This asks for all mainline revisions, which means we only have to spider
-    # sideways, rather than depth history. That said, its still size-of-history
-    # and should be addressed.
-    # mainline_revisions always includes an extra revision at the beginning, so
-    # don't request it.
-    parent_map = dict(((key, value) for key, value in
-        graph.iter_ancestry(mainline_revisions[1:]) if value is not None))
-    sorted_rev_list = tsort.topo_sort(parent_map.items())
-    text_keys = [(file_id, rev_id) for rev_id in sorted_rev_list]
-    modified_text_versions = branch.repository.texts.get_parent_map(text_keys)
+    rev_graph = branch.repository.get_revision_graph(mainline_revisions[-1])
+    sorted_rev_list = topo_sort(rev_graph)
     ancestry = {}
     for rev in sorted_rev_list:
-        text_key = (file_id, rev)
-        parents = parent_map[rev]
-        if text_key not in modified_text_versions and len(parents) == 1:
+        parents = rev_graph[rev]
+        if rev not in weave_modifed_revisions and len(parents) == 1:
             # We will not be adding anything new, so just use a reference to
             # the parent ancestry.
             rev_ancestry = ancestry[parents[0]]
         else:
             rev_ancestry = set()
-            if text_key in modified_text_versions:
+            if rev in weave_modifed_revisions:
                 rev_ancestry.add(rev)
             for parent in parents:
-                if parent not in ancestry:
-                    # parent is a Ghost, which won't be present in
-                    # sorted_rev_list, but we may access it later, so create an
-                    # empty node for it
-                    ancestry[parent] = set()
                 rev_ancestry = rev_ancestry.union(ancestry[parent])
         ancestry[rev] = rev_ancestry
 
     def is_merging_rev(r):
-        parents = parent_map[r]
+        parents = rev_graph[r]
         if len(parents) > 1:
             leftparent = parents[0]
             for rightparent in parents[1:]:
@@ -604,7 +477,7 @@
     # filter from the view the revisions that did not change or merge 
     # the specific file
     return [(r, n, d) for r, n, d in view_revs_iter
-            if (file_id, r) in modified_text_versions or is_merging_rev(r)]
+            if r in weave_modifed_revisions or is_merging_rev(r)]
 
 
 def get_view_revisions(mainline_revs, rev_nos, branch, direction,
@@ -620,18 +493,8 @@
         for revision_id in revision_ids:
             yield revision_id, str(rev_nos[revision_id]), 0
         return
-    graph = branch.repository.get_graph()
-    # This asks for all mainline revisions, which means we only have to spider
-    # sideways, rather than depth history. That said, its still size-of-history
-    # and should be addressed.
-    # mainline_revisions always includes an extra revision at the beginning, so
-    # don't request it.
-    parent_map = dict(((key, value) for key, value in
-        graph.iter_ancestry(mainline_revs[1:]) if value is not None))
-    # filter out ghosts; merge_sort errors on ghosts.
-    rev_graph = _mod_repository._strip_NULL_ghosts(parent_map)
-    merge_sorted_revisions = tsort.merge_sort(
-        rev_graph,
+    merge_sorted_revisions = merge_sort(
+        branch.repository.get_revision_graph(mainline_revs[-1]),
         mainline_revs[-1],
         mainline_revs,
         generate_revno=True)
@@ -658,6 +521,7 @@
         if val[2] == _depth:
             zd_revisions.append([val])
         else:
+            assert val[2] > _depth
             zd_revisions[-1].append(val)
     for revisions in zd_revisions:
         if len(revisions) > 1:
@@ -700,21 +564,10 @@
     - supports_delta must be True if this log formatter supports delta.
         Otherwise the delta attribute may not be populated.
     - supports_merge_revisions must be True if this log formatter supports 
-        merge revisions.  If not, and if supports_single_merge_revisions is
-        also not True, then only mainline revisions will be passed to the 
-        formatter.
-    - supports_single_merge_revision must be True if this log formatter
-        supports logging only a single merge revision.  This flag is
-        only relevant if supports_merge_revisions is not True.
+        merge revisions.  If not, only mainline revisions (those 
+        with merge_depth == 0) will be passed to the formatter.
     - supports_tags must be True if this log formatter supports tags.
         Otherwise the tags attribute may not be populated.
-
-    Plugins can register functions to show custom revision properties using
-    the properties_handler_registry. The registered function
-    must respect the following interface description:
-        def my_show_properties(properties_dict):
-            # code that returns a dict {'name':'value'} of the properties 
-            # to be shown
     """
 
     def __init__(self, to_file, show_ids=False, show_timezone='original'):
@@ -732,26 +585,15 @@
 #        """
 #        raise NotImplementedError('not implemented in abstract base')
 
+    @deprecated_method(zero_seventeen)
+    def show(self, revno, rev, delta):
+        raise NotImplementedError('not implemented in abstract base')
+
     def short_committer(self, rev):
-        name, address = config.parse_username(rev.committer)
-        if name:
-            return name
-        return address
+        return re.sub('<.*@.*>', '', rev.committer).strip(' ')
 
     def short_author(self, rev):
-        name, address = config.parse_username(rev.get_apparent_author())
-        if name:
-            return name
-        return address
-
-    def show_properties(self, revision, indent):
-        """Displays the custom properties returned by each registered handler.
-        
-        If a registered handler raises an error it is propagated.
-        """
-        for key, handler in properties_handler_registry.iteritems():
-            for key, value in handler(revision).items():
-                self.to_file.write(indent + key + ': ' + value + '\n')
+        return re.sub('<.*@.*>', '', rev.get_apparent_author()).strip(' ')
 
 
 class LongLogFormatter(LogFormatter):
@@ -760,8 +602,20 @@
     supports_delta = True
     supports_tags = True
 
+    @deprecated_method(zero_seventeen)
+    def show(self, revno, rev, delta, tags=None):
+        lr = LogRevision(rev, revno, 0, delta, tags)
+        return self.log_revision(lr)
+
+    @deprecated_method(zero_seventeen)
+    def show_merge_revno(self, rev, merge_depth, revno, tags=None):
+        """Show a merged revision rev, with merge_depth and a revno."""
+        lr = LogRevision(rev, revno, merge_depth, tags=tags)
+        return self.log_revision(lr)
+
     def log_revision(self, revision):
         """Log a revision, either merged or not."""
+        from bzrlib.osutils import format_date
         indent = '    ' * revision.merge_depth
         to_file = self.to_file
         to_file.write(indent + '-' * 60 + '\n')
@@ -770,11 +624,10 @@
         if revision.tags:
             to_file.write(indent + 'tags: %s\n' % (', '.join(revision.tags)))
         if self.show_ids:
-            to_file.write(indent + 'revision-id: ' + revision.rev.revision_id)
+            to_file.write(indent + 'revision-id:' + revision.rev.revision_id)
             to_file.write('\n')
             for parent_id in revision.rev.parent_ids:
                 to_file.write(indent + 'parent: %s\n' % (parent_id,))
-        self.show_properties(revision.rev, indent)
 
         author = revision.rev.properties.get('author', None)
         if author is not None:
@@ -804,10 +657,19 @@
 class ShortLogFormatter(LogFormatter):
 
     supports_delta = True
-    supports_single_merge_revision = True
+
+    @deprecated_method(zero_seventeen)
+    def show(self, revno, rev, delta):
+        lr = LogRevision(rev, revno, 0, delta)
+        return self.log_revision(lr)
 
     def log_revision(self, revision):
+        from bzrlib.osutils import format_date
+
         to_file = self.to_file
+        date_str = format_date(revision.rev.timestamp,
+                               revision.rev.timezone or 0,
+                               self.show_timezone)
         is_merge = ''
         if len(revision.rev.parent_ids) > 1:
             is_merge = ' [merge]'
@@ -836,9 +698,8 @@
 
 class LineLogFormatter(LogFormatter):
 
-    supports_single_merge_revision = True
-
     def __init__(self, *args, **kwargs):
+        from bzrlib.osutils import terminal_width
         super(LineLogFormatter, self).__init__(*args, **kwargs)
         self._max_chars = terminal_width() - 1
 
@@ -848,6 +709,7 @@
         return str[:max_len-3]+'...'
 
     def date_string(self, rev):
+        from bzrlib.osutils import format_date
         return format_date(rev.timestamp, rev.timezone or 0, 
                            self.show_timezone, date_fmt="%Y-%m-%d",
                            show_offset=False)
@@ -858,6 +720,12 @@
         else:
             return rev.message
 
+    @deprecated_method(zero_seventeen)
+    def show(self, revno, rev, delta):
+        from bzrlib.osutils import terminal_width
+        self.to_file.write(self.log_string(revno, rev, terminal_width()-1))
+        self.to_file.write('\n')
+
     def log_revision(self, revision):
         self.to_file.write(self.log_string(revision.revno, revision.rev,
                                               self._max_chars))
@@ -922,10 +790,11 @@
     name -- Name of the formatter to construct; currently 'long', 'short' and
         'line' are supported.
     """
+    from bzrlib.errors import BzrCommandError
     try:
         return log_formatter_registry.make_formatter(name, *args, **kwargs)
     except KeyError:
-        raise errors.BzrCommandError("unknown log formatter: %r" % name)
+        raise BzrCommandError("unknown log formatter: %r" % name)
 
 
 def show_one_log(revno, rev, delta, verbose, to_file, show_timezone):
@@ -944,8 +813,11 @@
     :param to_file: A file to write the results to. If None, stdout will be used
     """
     if to_file is None:
-        to_file = codecs.getwriter(get_terminal_encoding())(sys.stdout,
-            errors='replace')
+        import sys
+        import codecs
+        import bzrlib
+        to_file = codecs.getwriter(bzrlib.user_encoding)(sys.stdout,
+                                                         errors='replace')
     lf = log_formatter(log_format,
                        show_ids=False,
                        to_file=to_file,
@@ -988,22 +860,3 @@
                  end_revision=len(new_rh),
                  search=None)
 
-
-properties_handler_registry = registry.Registry()
-
-# adapters which revision ids to log are filtered. When log is called, the
-# log_rev_iterator is adapted through each of these factory methods.
-# Plugins are welcome to mutate this list in any way they like - as long
-# as the overall behaviour is preserved. At this point there is no extensible
-# mechanism for getting parameters to each factory method, and until there is
-# this won't be considered a stable api.
-log_adapters = [
-    # core log logic
-    _make_batch_filter,
-    # read revision objects
-    _make_revision_objects,
-    # filter on log messages
-    _make_search_filter,
-    # generate deltas for things we will show
-    _make_delta_filter
-    ]

=== removed file 'bzrlib/lru_cache.py'
--- bzrlib/lru_cache.py	2008-04-24 07:22:53 +0000
+++ bzrlib/lru_cache.py	1970-01-01 00:00:00 +0000
@@ -1,220 +0,0 @@
-# Copyright (C) 2006 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""A simple least-recently-used (LRU) cache."""
-
-from collections import deque
-import gc
-
-
-class LRUCache(object):
-    """A class which manages a cache of entries, removing unused ones."""
-
-    def __init__(self, max_cache=100, after_cleanup_size=None):
-        self._max_cache = max_cache
-        if after_cleanup_size is None:
-            self._after_cleanup_size = self._max_cache
-        else:
-            self._after_cleanup_size = min(after_cleanup_size, self._max_cache)
-
-        self._compact_queue_length = 4*self._max_cache
-
-        self._cache = {}
-        self._cleanup = {}
-        self._queue = deque() # Track when things are accessed
-        self._refcount = {} # number of entries in self._queue for each key
-
-    def __contains__(self, key):
-        return key in self._cache
-
-    def __getitem__(self, key):
-        val = self._cache[key]
-        self._record_access(key)
-        return val
-
-    def __len__(self):
-        return len(self._cache)
-
-    def add(self, key, value, cleanup=None):
-        """Add a new value to the cache.
-
-        Also, if the entry is ever removed from the queue, call cleanup.
-        Passing it the key and value being removed.
-
-        :param key: The key to store it under
-        :param value: The object to store
-        :param cleanup: None or a function taking (key, value) to indicate
-                        'value' sohuld be cleaned up.
-        """
-        if key in self._cache:
-            self._remove(key)
-        self._cache[key] = value
-        self._cleanup[key] = cleanup
-        self._record_access(key)
-
-        if len(self._cache) > self._max_cache:
-            # Trigger the cleanup
-            self.cleanup()
-
-    def get(self, key, default=None):
-        if key in self._cache:
-            return self[key]
-        return default
-
-    def cleanup(self):
-        """Clear the cache until it shrinks to the requested size.
-
-        This does not completely wipe the cache, just makes sure it is under
-        the after_cleanup_size.
-        """
-        # Make sure the cache is shrunk to the correct size
-        while len(self._cache) > self._after_cleanup_size:
-            self._remove_lru()
-
-    def __setitem__(self, key, value):
-        """Add a value to the cache, there will be no cleanup function."""
-        self.add(key, value, cleanup=None)
-
-    def _record_access(self, key):
-        """Record that key was accessed."""
-        self._queue.append(key)
-        # Can't use setdefault because you can't += 1 the result
-        self._refcount[key] = self._refcount.get(key, 0) + 1
-
-        # If our access queue is too large, clean it up too
-        if len(self._queue) > self._compact_queue_length:
-            self._compact_queue()
-
-    def _compact_queue(self):
-        """Compact the queue, leaving things in sorted last appended order."""
-        new_queue = deque()
-        for item in self._queue:
-            if self._refcount[item] == 1:
-                new_queue.append(item)
-            else:
-                self._refcount[item] -= 1
-        self._queue = new_queue
-        # All entries should be of the same size. There should be one entry in
-        # queue for each entry in cache, and all refcounts should == 1
-        if not (len(self._queue) == len(self._cache) ==
-                len(self._refcount) == sum(self._refcount.itervalues())):
-            raise AssertionError()
-
-    def _remove(self, key):
-        """Remove an entry, making sure to maintain the invariants."""
-        cleanup = self._cleanup.pop(key)
-        val = self._cache.pop(key)
-        if cleanup is not None:
-            cleanup(key, val)
-        return val
-
-    def _remove_lru(self):
-        """Remove one entry from the lru, and handle consequences.
-
-        If there are no more references to the lru, then this entry should be
-        removed from the cache.
-        """
-        key = self._queue.popleft()
-        self._refcount[key] -= 1
-        if not self._refcount[key]:
-            del self._refcount[key]
-            self._remove(key)
-
-    def clear(self):
-        """Clear out all of the cache."""
-        # Clean up in LRU order
-        while self._cache:
-            self._remove_lru()
-
-
-class LRUSizeCache(LRUCache):
-    """An LRUCache that removes things based on the size of the values.
-
-    This differs in that it doesn't care how many actual items there are,
-    it just restricts the cache to be cleaned up after so much data is stored.
-
-    The values that are added must support len(value).
-    """
-
-    def __init__(self, max_size=1024*1024, after_cleanup_size=None,
-                 compute_size=None):
-        """Create a new LRUSizeCache.
-
-        :param max_size: The max number of bytes to store before we start
-            clearing out entries.
-        :param after_cleanup_size: After cleaning up, shrink everything to this
-            size.
-        :param compute_size: A function to compute the size of the values. We
-            use a function here, so that you can pass 'len' if you are just
-            using simple strings, or a more complex function if you are using
-            something like a list of strings, or even a custom object.
-            The function should take the form "compute_size(value) => integer".
-            If not supplied, it defaults to 'len()'
-        """
-        # This approximates that texts are > 0.5k in size. It only really
-        # effects when we clean up the queue, so we don't want it to be too
-        # large.
-        LRUCache.__init__(self, max_cache=int(max_size/512))
-        self._max_size = max_size
-        if after_cleanup_size is None:
-            self._after_cleanup_size = self._max_size
-        else:
-            self._after_cleanup_size = min(after_cleanup_size, self._max_size)
-
-        self._value_size = 0
-        self._compute_size = compute_size
-        if compute_size is None:
-            self._compute_size = len
-
-    def add(self, key, value, cleanup=None):
-        """Add a new value to the cache.
-
-        Also, if the entry is ever removed from the queue, call cleanup.
-        Passing it the key and value being removed.
-
-        :param key: The key to store it under
-        :param value: The object to store
-        :param cleanup: None or a function taking (key, value) to indicate
-                        'value' sohuld be cleaned up.
-        """
-        if key in self._cache:
-            self._remove(key)
-        value_len = self._compute_size(value)
-        if value_len >= self._after_cleanup_size:
-            return
-        self._value_size += value_len
-        self._cache[key] = value
-        self._cleanup[key] = cleanup
-        self._record_access(key)
-
-        if self._value_size > self._max_size:
-            # Time to cleanup
-            self.cleanup()
-
-    def cleanup(self):
-        """Clear the cache until it shrinks to the requested size.
-
-        This does not completely wipe the cache, just makes sure it is under
-        the after_cleanup_size.
-        """
-        # Make sure the cache is shrunk to the correct size
-        while self._value_size > self._after_cleanup_size:
-            self._remove_lru()
-
-    def _remove(self, key):
-        """Remove an entry, making sure to maintain the invariants."""
-        val = LRUCache._remove(self, key)
-        self._value_size -= self._compute_size(val)

=== modified file 'bzrlib/lsprof.py'
--- bzrlib/lsprof.py	2008-07-09 19:57:36 +0000
+++ bzrlib/lsprof.py	2007-10-16 18:26:12 +0000
@@ -11,6 +11,9 @@
 from _lsprof import Profiler, profiler_entry
 
 
+import bzrlib.osutils
+
+
 __all__ = ['profile', 'Stats']
 
 _g_threadmap = {}
@@ -128,11 +131,11 @@
             otherwise the format is given by the filename extension.
         """
         if format is None:
-            basename = os.path.basename(filename)
+            basename = bzrlib.osutils.basename(filename)
             if basename.startswith('callgrind.out'):
                 format = "callgrind"
             else:
-                ext = os.path.splitext(filename)[1]
+                ext = bzrlib.osutils.splitext(filename)[1]
                 if len(ext) > 1:
                     format = ext[1:]
         outfile = open(filename, 'wb')

=== modified file 'bzrlib/mail_client.py'
--- bzrlib/mail_client.py	2008-08-26 16:44:12 +0000
+++ bzrlib/mail_client.py	2007-09-03 23:54:22 +0000
@@ -20,18 +20,14 @@
 import sys
 import tempfile
 
-import bzrlib
 from bzrlib import (
     email_message,
     errors,
     msgeditor,
     osutils,
     urlutils,
-    registry
     )
 
-mail_client_registry = registry.Registry()
-
 
 class MailClient(object):
     """A mail client that can send messages with attachements."""
@@ -40,7 +36,7 @@
         self.config = config
 
     def compose(self, prompt, to, subject, attachment, mime_subtype,
-                extension, basename=None):
+                extension):
         """Compose (and possibly send) an email message
 
         Must be implemented by subclasses.
@@ -55,25 +51,21 @@
             "plain", "x-patch", etc.
         :param extension: The file extension associated with the attachment
             type, e.g. ".patch"
-        :param basename: The name to use for the attachment, e.g.
-            "send-nick-3252"
         """
         raise NotImplementedError
 
-    def compose_merge_request(self, to, subject, directive, basename=None):
+    def compose_merge_request(self, to, subject, directive):
         """Compose (and possibly send) a merge request
 
         :param to: The address to send the request to
         :param subject: The subject line to use for the request
         :param directive: A merge directive representing the merge request, as
             a bytestring.
-        :param basename: The name to use for the attachment, e.g.
-            "send-nick-3252"
         """
         prompt = self._get_merge_prompt("Please describe these changes:", to,
                                         subject, directive)
         self.compose(prompt, to, subject, directive,
-            'x-patch', '.patch', basename)
+            'x-patch', '.patch')
 
     def _get_merge_prompt(self, prompt, to, subject, attachment):
         """Generate a prompt string.  Overridden by Editor.
@@ -98,10 +90,8 @@
                          attachment.decode('utf-8', 'replace')))
 
     def compose(self, prompt, to, subject, attachment, mime_subtype,
-                extension, basename=None):
+                extension):
         """See MailClient.compose"""
-        if not to:
-            raise errors.NoMailAddressSpecified()
         body = msgeditor.edit_commit_message(prompt)
         if body == '':
             raise errors.NoMessageSupplied()
@@ -112,8 +102,6 @@
                                         body,
                                         attachment,
                                         attachment_mime_subtype=mime_subtype)
-mail_client_registry.register('editor', Editor,
-                              help=Editor.__doc__)
 
 
 class ExternalMailClient(MailClient):
@@ -128,22 +116,17 @@
             return self._client_commands
 
     def compose(self, prompt, to, subject, attachment, mime_subtype,
-                extension, basename=None):
+                extension):
         """See MailClient.compose.
 
         Writes the attachment to a temporary file, invokes _compose.
         """
-        if basename is None:
-            basename = 'attachment'
-        pathname = osutils.mkdtemp(prefix='bzr-mail-')
-        attach_path = osutils.pathjoin(pathname, basename + extension)
-        outfile = open(attach_path, 'wb')
+        fd, pathname = tempfile.mkstemp(extension, 'bzr-mail-')
         try:
-            outfile.write(attachment)
+            os.write(fd, attachment)
         finally:
-            outfile.close()
-        self._compose(prompt, to, subject, attach_path, mime_subtype,
-                      extension)
+            os.close(fd)
+        self._compose(prompt, to, subject, pathname, mime_subtype, extension)
 
     def _compose(self, prompt, to, subject, attach_path, mime_subtype,
                 extension):
@@ -159,7 +142,7 @@
             the attachment type.
         """
         for name in self._get_client_commands():
-            cmdline = [self._encode_path(name, 'executable')]
+            cmdline = [name]
             cmdline.extend(self._get_compose_commandline(to, subject,
                                                          attach_path))
             try:
@@ -182,34 +165,6 @@
         """
         raise NotImplementedError
 
-    def _encode_safe(self, u):
-        """Encode possible unicode string argument to 8-bit string
-        in user_encoding. Unencodable characters will be replaced
-        with '?'.
-
-        :param  u:  possible unicode string.
-        :return:    encoded string if u is unicode, u itself otherwise.
-        """
-        if isinstance(u, unicode):
-            return u.encode(bzrlib.user_encoding, 'replace')
-        return u
-
-    def _encode_path(self, path, kind):
-        """Encode unicode path in user encoding.
-
-        :param  path:   possible unicode path.
-        :param  kind:   path kind ('executable' or 'attachment').
-        :return:        encoded path if path is unicode,
-                        path itself otherwise.
-        :raise:         UnableEncodePath.
-        """
-        if isinstance(path, unicode):
-            try:
-                return path.encode(bzrlib.user_encoding)
-            except UnicodeEncodeError:
-                raise errors.UnableEncodePath(path, kind)
-        return path
-
 
 class Evolution(ExternalMailClient):
     """Evolution mail client."""
@@ -224,11 +179,8 @@
         if attach_path is not None:
             message_options['attach'] = attach_path
         options_list = ['%s=%s' % (k, urlutils.escape(v)) for (k, v) in
-                        sorted(message_options.iteritems())]
-        return ['mailto:%s?%s' % (self._encode_safe(to or ''),
-            '&'.join(options_list))]
-mail_client_registry.register('evolution', Evolution,
-                              help=Evolution.__doc__)
+                        message_options.iteritems()]
+        return ['mailto:%s?%s' % (to or '', '&'.join(options_list))]
 
 
 class Mutt(ExternalMailClient):
@@ -240,15 +192,12 @@
         """See ExternalMailClient._get_compose_commandline"""
         message_options = []
         if subject is not None:
-            message_options.extend(['-s', self._encode_safe(subject)])
+            message_options.extend(['-s', subject ])
         if attach_path is not None:
-            message_options.extend(['-a',
-                self._encode_path(attach_path, 'attachment')])
+            message_options.extend(['-a', attach_path])
         if to is not None:
-            message_options.append(self._encode_safe(to))
+            message_options.append(to)
         return message_options
-mail_client_registry.register('mutt', Mutt,
-                              help=Mutt.__doc__)
 
 
 class Thunderbird(ExternalMailClient):
@@ -262,24 +211,21 @@
     """
 
     _client_commands = ['thunderbird', 'mozilla-thunderbird', 'icedove',
-        '/Applications/Mozilla/Thunderbird.app/Contents/MacOS/thunderbird-bin',
-        '/Applications/Thunderbird.app/Contents/MacOS/thunderbird-bin']
+        '/Applications/Mozilla/Thunderbird.app/Contents/MacOS/thunderbird-bin']
 
     def _get_compose_commandline(self, to, subject, attach_path):
         """See ExternalMailClient._get_compose_commandline"""
         message_options = {}
         if to is not None:
-            message_options['to'] = self._encode_safe(to)
+            message_options['to'] = to
         if subject is not None:
-            message_options['subject'] = self._encode_safe(subject)
+            message_options['subject'] = subject
         if attach_path is not None:
             message_options['attachment'] = urlutils.local_path_to_url(
                 attach_path)
         options_list = ["%s='%s'" % (k, v) for k, v in
                         sorted(message_options.iteritems())]
         return ['-compose', ','.join(options_list)]
-mail_client_registry.register('thunderbird', Thunderbird,
-                              help=Thunderbird.__doc__)
 
 
 class KMail(ExternalMailClient):
@@ -291,15 +237,13 @@
         """See ExternalMailClient._get_compose_commandline"""
         message_options = []
         if subject is not None:
-            message_options.extend(['-s', self._encode_safe(subject)])
+            message_options.extend( ['-s', subject ] )
         if attach_path is not None:
-            message_options.extend(['--attach',
-                self._encode_path(attach_path, 'attachment')])
+            message_options.extend( ['--attach', attach_path] )
         if to is not None:
-            message_options.extend([self._encode_safe(to)])
+            message_options.extend( [ to ] )
+
         return message_options
-mail_client_registry.register('kmail', KMail,
-                              help=KMail.__doc__)
 
 
 class XDGEmail(ExternalMailClient):
@@ -309,120 +253,12 @@
 
     def _get_compose_commandline(self, to, subject, attach_path):
         """See ExternalMailClient._get_compose_commandline"""
-        if not to:
-            raise errors.NoMailAddressSpecified()
-        commandline = [self._encode_safe(to)]
-        if subject is not None:
-            commandline.extend(['--subject', self._encode_safe(subject)])
-        if attach_path is not None:
-            commandline.extend(['--attach',
-                self._encode_path(attach_path, 'attachment')])
-        return commandline
-mail_client_registry.register('xdg-email', XDGEmail,
-                              help=XDGEmail.__doc__)
-
-
-class EmacsMail(ExternalMailClient):
-    """Call emacsclient to have a mail buffer.
-
-    This only work for emacs >= 22.1 due to recent -e/--eval support.
-
-    The good news is that this implementation will work with all mail
-    agents registered against ``mail-user-agent``. So there is no need
-    to instantiate ExternalMailClient for each and every GNU Emacs
-    MUA.
-
-    Users just have to ensure that ``mail-user-agent`` is set according
-    to their tastes.
-    """
-
-    _client_commands = ['emacsclient']
-
-    def _prepare_send_function(self):
-        """Write our wrapper function into a temporary file.
-
-        This temporary file will be loaded at runtime in
-        _get_compose_commandline function.
-
-        This function does not remove the file.  That's a wanted
-        behaviour since _get_compose_commandline won't run the send
-        mail function directly but return the eligible command line.
-        Removing our temporary file here would prevent our sendmail
-        function to work.  (The file is deleted by some elisp code
-        after being read by Emacs.)
-        """
-
-        _defun = r"""(defun bzr-add-mime-att (file)
-  "Attach FILE to a mail buffer as a MIME attachment."
-  (let ((agent mail-user-agent))
-    (if (and file (file-exists-p file))
-        (cond
-         ((eq agent 'sendmail-user-agent)
-          (progn
-            (mail-text)
-            (newline)
-            (if (functionp 'etach-attach)
-              (etach-attach file)
-              (mail-attach-file file))))
-         ((or (eq agent 'message-user-agent)(eq agent 'gnus-user-agent))
-          (progn
-            (mml-attach-file file "text/x-patch" "BZR merge" "inline")))
-         ((eq agent 'mew-user-agent)
-          (progn
-            (mew-draft-prepare-attachments)
-            (mew-attach-link file (file-name-nondirectory file))
-            (let* ((nums (mew-syntax-nums))
-                   (syntax (mew-syntax-get-entry mew-encode-syntax nums)))
-              (mew-syntax-set-cd syntax "BZR merge")
-              (mew-encode-syntax-print mew-encode-syntax))
-            (mew-header-goto-body)))
-         (t
-          (message "Unhandled MUA, report it on bazaar@lists.canonical.com")))
-      (error "File %s does not exist." file))))
-"""
-
-        fd, temp_file = tempfile.mkstemp(prefix="emacs-bzr-send-",
-                                         suffix=".el")
-        try:
-            os.write(fd, _defun)
-        finally:
-            os.close(fd) # Just close the handle but do not remove the file.
-        return temp_file
-
-    def _get_compose_commandline(self, to, subject, attach_path):
-        commandline = ["--eval"]
-
-        _to = "nil"
-        _subject = "nil"
-
-        if to is not None:
-            _to = ("\"%s\"" % self._encode_safe(to).replace('"', '\\"'))
-        if subject is not None:
-            _subject = ("\"%s\"" %
-                        self._encode_safe(subject).replace('"', '\\"'))
-
-        # Funcall the default mail composition function
-        # This will work with any mail mode including default mail-mode
-        # User must tweak mail-user-agent variable to tell what function
-        # will be called inside compose-mail.
-        mail_cmd = "(compose-mail %s %s)" % (_to, _subject)
-        commandline.append(mail_cmd)
-
-        # Try to attach a MIME attachment using our wrapper function
-        if attach_path is not None:
-            # Do not create a file if there is no attachment
-            elisp = self._prepare_send_function()
-            lmmform = '(load "%s")' % elisp
-            mmform  = '(bzr-add-mime-att "%s")' % \
-                self._encode_path(attach_path, 'attachment')
-            rmform = '(delete-file "%s")' % elisp
-            commandline.append(lmmform)
-            commandline.append(mmform)
-            commandline.append(rmform)
-
-        return commandline
-mail_client_registry.register('emacsclient', EmacsMail,
-                              help=EmacsMail.__doc__)
+        commandline = [to]
+        if subject is not None:
+            commandline.extend(['--subject', subject])
+        if attach_path is not None:
+            commandline.extend(['--attach', attach_path])
+        return commandline
 
 
 class MAPIClient(ExternalMailClient):
@@ -441,8 +277,6 @@
             if e.code != simplemapi.MAPI_USER_ABORT:
                 raise errors.MailClientNotFound(['MAPI supported mail client'
                                                  ' (error %d)' % (e.code,)])
-mail_client_registry.register('mapi', MAPIClient,
-                              help=MAPIClient.__doc__)
 
 
 class DefaultMail(MailClient):
@@ -457,24 +291,21 @@
             return XDGEmail(self.config)
 
     def compose(self, prompt, to, subject, attachment, mime_subtype,
-                extension, basename=None):
+                extension):
         """See MailClient.compose"""
         try:
             return self._mail_client().compose(prompt, to, subject,
                                                attachment, mimie_subtype,
-                                               extension, basename)
+                                               extension)
         except errors.MailClientNotFound:
             return Editor(self.config).compose(prompt, to, subject,
                           attachment, mimie_subtype, extension)
 
-    def compose_merge_request(self, to, subject, directive, basename=None):
+    def compose_merge_request(self, to, subject, directive):
         """See MailClient.compose_merge_request"""
         try:
             return self._mail_client().compose_merge_request(to, subject,
-                    directive, basename=basename)
+                                                             directive)
         except errors.MailClientNotFound:
             return Editor(self.config).compose_merge_request(to, subject,
-                          directive, basename=basename)
-mail_client_registry.register('default', DefaultMail,
-                              help=DefaultMail.__doc__)
-mail_client_registry.default_key = 'default'
+                          directive)

=== modified file 'bzrlib/memorytree.py'
--- bzrlib/memorytree.py	2008-07-22 18:12:25 +0000
+++ bzrlib/memorytree.py	2007-09-05 05:51:34 +0000
@@ -92,9 +92,6 @@
         stream = self._file_transport.get(path)
         return sha_file(stream)
 
-    def get_root_id(self):
-        return self.path2id('')
-
     def _comparison_data(self, entry, path):
         """See Tree._comparison_data."""
         if entry is None:
@@ -290,6 +287,7 @@
                 raise errors.GhostRevisionUnusableHere(parents_list[0][0])
             self._parent_ids = [parent_id for parent_id, tree in parents_list]
             if parents_list[0][1] is None or parents_list[0][1] == 'null:':
+                import pdb; pdb.set_trace()
                 self._basis_tree = self.branch.repository.revision_tree(None)
             else:
                 self._basis_tree = parents_list[0][1]

=== modified file 'bzrlib/merge.py'
--- bzrlib/merge.py	2008-08-27 20:32:22 +0000
+++ bzrlib/merge.py	2007-09-08 06:02:59 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2008 Canonical Ltd
+# Copyright (C) 2005, 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -15,20 +15,16 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 
+import os
 import errno
-from itertools import chain
-import os
 import warnings
 
 from bzrlib import (
-    debug,
     errors,
-    graph as _mod_graph,
     osutils,
     patiencediff,
     registry,
     revision as _mod_revision,
-    tsort,
     )
 from bzrlib.branch import Branch
 from bzrlib.conflicts import ConflictList, Conflict
@@ -45,15 +41,13 @@
                            WorkingTreeNotRevision,
                            BinaryFile,
                            )
-from bzrlib.graph import Graph
 from bzrlib.merge3 import Merge3
 from bzrlib.osutils import rename, pathjoin
 from progress import DummyProgress, ProgressPhase
-from bzrlib.revision import (NULL_REVISION, ensure_null)
+from bzrlib.revision import (is_ancestor, NULL_REVISION, ensure_null)
 from bzrlib.textfile import check_text_lines
-from bzrlib.trace import mutter, warning, note, is_quiet
-from bzrlib.transform import (TransformPreview, TreeTransform,
-                              resolve_conflicts, cook_conflicts,
+from bzrlib.trace import mutter, warning, note
+from bzrlib.transform import (TreeTransform, resolve_conflicts, cook_conflicts,
                               conflict_pass, FinalPaths, create_by_entry,
                               unique_add, ROOT_PARENT)
 from bzrlib.versionedfile import PlanWeaveMerge
@@ -70,8 +64,9 @@
 class Merger(object):
     def __init__(self, this_branch, other_tree=None, base_tree=None,
                  this_tree=None, pb=DummyProgress(), change_reporter=None,
-                 recurse='down', revision_graph=None):
+                 recurse='down'):
         object.__init__(self)
+        assert this_tree is not None, "this_tree is required"
         self.this_branch = this_branch
         self.this_basis = _mod_revision.ensure_null(
             this_branch.last_revision())
@@ -93,40 +88,6 @@
         self.recurse = recurse
         self.change_reporter = change_reporter
         self._cached_trees = {}
-        self._revision_graph = revision_graph
-        self._base_is_ancestor = None
-        self._base_is_other_ancestor = None
-
-    @property
-    def revision_graph(self):
-        if self._revision_graph is None:
-            self._revision_graph = self.this_branch.repository.get_graph()
-        return self._revision_graph
-
-    def _set_base_is_ancestor(self, value):
-        self._base_is_ancestor = value
-
-    def _get_base_is_ancestor(self):
-        if self._base_is_ancestor is None:
-            self._base_is_ancestor = self.revision_graph.is_ancestor(
-                self.base_rev_id, self.this_basis)
-        return self._base_is_ancestor
-
-    base_is_ancestor = property(_get_base_is_ancestor, _set_base_is_ancestor)
-
-    def _set_base_is_other_ancestor(self, value):
-        self._base_is_other_ancestor = value
-
-    def _get_base_is_other_ancestor(self):
-        if self._base_is_other_ancestor is None:
-            if self.other_basis is None:
-                return True
-            self._base_is_other_ancestor = self.revision_graph.is_ancestor(
-                self.base_rev_id, self.other_basis)
-        return self._base_is_other_ancestor
-
-    base_is_other_ancestor = property(_get_base_is_other_ancestor,
-                                      _set_base_is_other_ancestor)
 
     @staticmethod
     def from_uncommitted(tree, other_tree, pb):
@@ -140,7 +101,6 @@
                         pb)
         merger.base_rev_id = merger.base_tree.get_revision_id()
         merger.other_rev_id = None
-        merger.other_basis = merger.base_rev_id
         return merger
 
     @classmethod
@@ -154,22 +114,17 @@
         mergeable.install_revisions(tree.branch.repository)
         base_revision_id, other_revision_id, verified =\
             mergeable.get_merge_request(tree.branch.repository)
-        revision_graph = tree.branch.repository.get_graph()
-        if base_revision_id is not None:
-            if (base_revision_id != _mod_revision.NULL_REVISION and
-                revision_graph.is_ancestor(
-                base_revision_id, tree.branch.last_revision())):
-                base_revision_id = None
-            else:
-                warning('Performing cherrypick')
+        if (base_revision_id != _mod_revision.NULL_REVISION and
+            tree.branch.repository.get_graph().is_ancestor(
+            base_revision_id, tree.branch.last_revision())):
+            base_revision_id = None
         merger = klass.from_revision_ids(pb, tree, other_revision_id,
-                                         base_revision_id, revision_graph=
-                                         revision_graph)
+                                         base_revision_id)
         return merger, verified
 
     @staticmethod
-    def from_revision_ids(pb, tree, other, base=None, other_branch=None,
-                          base_branch=None, revision_graph=None):
+    def from_revision_ids(pb, this, other, base=None, other_branch=None,
+                          base_branch=None):
         """Return a Merger for revision-ids.
 
         :param tree: The tree to merge changes into
@@ -177,17 +132,14 @@
         :param base: The revision-id to use as BASE.  If not specified, will
             be auto-selected.
         :param other_branch: A branch containing the other revision-id.  If
-            not supplied, tree.branch is used.
+            not supplied, this.branch is used.
         :param base_branch: A branch containing the base revision-id.  If
-            not supplied, other_branch or tree.branch will be used.
-        :param revision_graph: If you have a revision_graph precomputed, pass
-            it in, otherwise it will be created for you.
+            not supplied, other_branch or this.branch will be used.
         :param pb: A progress indicator
         """
-        merger = Merger(tree.branch, this_tree=tree, pb=pb,
-                        revision_graph=revision_graph)
+        merger = Merger(this.branch, this_tree=this, pb=pb)
         if other_branch is None:
-            other_branch = tree.branch
+            other_branch = this.branch
         merger.set_other_revision(other, other_branch)
         if base is None:
             merger.find_base()
@@ -240,6 +192,7 @@
         self.ensure_revision_trees()
         def get_id(tree, file_id):
             revision_id = tree.inventory[file_id].revision
+            assert revision_id is not None
             return revision_id
         if self.this_rev_id is None:
             if self.this_basis_tree.get_file_sha1(file_id) != \
@@ -261,7 +214,7 @@
     def compare_basis(self):
         try:
             basis_tree = self.revision_tree(self.this_tree.last_revision())
-        except errors.NoSuchRevision:
+        except errors.RevisionNotPresent:
             basis_tree = self.this_tree.basis_tree()
         changes = self.this_tree.changes_from(basis_tree)
         if not changes.has_changed():
@@ -281,7 +234,7 @@
         for revision_id in new_parents:
             try:
                 tree = self.revision_tree(revision_id)
-            except errors.NoSuchRevision:
+            except errors.RevisionNotPresent:
                 tree = None
             else:
                 tree.lock_read()
@@ -343,24 +296,28 @@
         self.base_branch = branch
         self._maybe_fetch(branch, self.this_branch, revision_id)
         self.base_tree = self.revision_tree(revision_id)
+        self.base_is_ancestor = is_ancestor(self.this_basis,
+                                            self.base_rev_id,
+                                            self.this_branch)
+        self.base_is_other_ancestor = is_ancestor(self.other_basis,
+                                                  self.base_rev_id,
+                                                  self.this_branch)
 
     def _maybe_fetch(self, source, target, revision_id):
         if not source.repository.has_same_location(target.repository):
             target.fetch(source, revision_id)
 
     def find_base(self):
+        this_repo = self.this_branch.repository
+        graph = this_repo.get_graph()
         revisions = [ensure_null(self.this_basis),
                      ensure_null(self.other_basis)]
         if NULL_REVISION in revisions:
             self.base_rev_id = NULL_REVISION
         else:
-            self.base_rev_id, steps = self.revision_graph.find_unique_lca(
-                revisions[0], revisions[1], count_steps=True)
+            self.base_rev_id = graph.find_unique_lca(*revisions)
             if self.base_rev_id == NULL_REVISION:
                 raise UnrelatedBranches()
-            if steps > 1:
-                warning('Warning: criss-cross merge encountered.  See bzr'
-                        ' help criss-cross.')
         self.base_tree = self.revision_tree(self.base_rev_id)
         self.base_is_ancestor = True
         self.base_is_other_ancestor = True
@@ -383,14 +340,19 @@
                 self.base_rev_id = _mod_revision.ensure_null(
                     base_branch.get_rev_id(base_revision[1]))
             self._maybe_fetch(base_branch, self.this_branch, self.base_rev_id)
+            self.base_is_ancestor = is_ancestor(self.this_basis, 
+                                                self.base_rev_id,
+                                                self.this_branch)
+            self.base_is_other_ancestor = is_ancestor(self.other_basis,
+                                                      self.base_rev_id,
+                                                      self.this_branch)
 
-    def make_merger(self):
+    def do_merge(self):
         kwargs = {'working_tree':self.this_tree, 'this_tree': self.this_tree,
                   'other_tree': self.other_tree,
                   'interesting_ids': self.interesting_ids,
                   'interesting_files': self.interesting_files,
-                  'pp': self.pp,
-                  'do_merge': False}
+                  'pp': self.pp}
         if self.merge_type.requires_base:
             kwargs['base_tree'] = self.base_tree
         if self.merge_type.supports_reprocess:
@@ -402,41 +364,31 @@
             kwargs['show_base'] = self.show_base
         elif self.show_base:
             raise BzrError("Showing base is not supported for this"
-                           " merge type. %s" % self.merge_type)
-        if (not getattr(self.merge_type, 'supports_reverse_cherrypick', True)
-            and not self.base_is_other_ancestor):
-            raise errors.CannotReverseCherrypick()
-        if self.merge_type.supports_cherrypick:
-            kwargs['cherrypick'] = (not self.base_is_ancestor or
-                                    not self.base_is_other_ancestor)
-        return self.merge_type(pb=self._pb,
-                               change_reporter=self.change_reporter,
-                               **kwargs)
-
-    def do_merge(self):
+                                  " merge type. %s" % self.merge_type)
         self.this_tree.lock_tree_write()
         if self.base_tree is not None:
             self.base_tree.lock_read()
         if self.other_tree is not None:
             self.other_tree.lock_read()
         try:
-            merge = self.make_merger()
-            merge.do_merge()
+            merge = self.merge_type(pb=self._pb,
+                                    change_reporter=self.change_reporter,
+                                    **kwargs)
             if self.recurse == 'down':
-                for relpath, file_id in self.this_tree.iter_references():
-                    sub_tree = self.this_tree.get_nested_tree(file_id, relpath)
+                for path, file_id in self.this_tree.iter_references():
+                    sub_tree = self.this_tree.get_nested_tree(file_id, path)
                     other_revision = self.other_tree.get_reference_revision(
-                        file_id, relpath)
+                        file_id, path)
                     if  other_revision == sub_tree.last_revision():
                         continue
                     sub_merge = Merger(sub_tree.branch, this_tree=sub_tree)
                     sub_merge.merge_type = self.merge_type
+                    relpath = self.this_tree.relpath(path)
                     other_branch = self.other_branch.reference_parent(file_id, relpath)
                     sub_merge.set_other_revision(other_revision, other_branch)
                     base_revision = self.base_tree.get_reference_revision(file_id)
                     sub_merge.base_tree = \
                         sub_tree.branch.repository.revision_tree(base_revision)
-                    sub_merge.base_rev_id = base_revision
                     sub_merge.do_merge()
 
         finally:
@@ -446,7 +398,7 @@
                 self.base_tree.unlock()
             self.this_tree.unlock()
         if len(merge.cooked_conflicts) == 0:
-            if not self.ignore_zero and not is_quiet():
+            if not self.ignore_zero:
                 note("All changes applied successfully.")
         else:
             note("%d conflicts encountered." % len(merge.cooked_conflicts))
@@ -460,15 +412,12 @@
     supports_reprocess = True
     supports_show_base = True
     history_based = False
-    supports_cherrypick = True
-    supports_reverse_cherrypick = True
     winner_idx = {"this": 2, "other": 1, "conflict": 1}
 
     def __init__(self, working_tree, this_tree, base_tree, other_tree, 
                  interesting_ids=None, reprocess=False, show_base=False,
                  pb=DummyProgress(), pp=None, change_reporter=None,
-                 interesting_files=None, do_merge=True,
-                 cherrypick=False):
+                 interesting_files=None):
         """Initialize the merger object and perform the merge.
 
         :param working_tree: The working tree to apply the merge to
@@ -492,14 +441,16 @@
             merge.
         """
         object.__init__(self)
-        if interesting_files is not None and interesting_ids is not None:
-            raise ValueError(
-                'specify either interesting_ids or interesting_files')
+        if interesting_files is not None:
+            assert interesting_ids is None
         self.interesting_ids = interesting_ids
         self.interesting_files = interesting_files
         self.this_tree = working_tree
+        self.this_tree.lock_tree_write()
         self.base_tree = base_tree
+        self.base_tree.lock_read()
         self.other_tree = other_tree
+        self.other_tree.lock_read()
         self._raw_conflicts = []
         self.cooked_conflicts = []
         self.reprocess = reprocess
@@ -507,25 +458,46 @@
         self.pb = pb
         self.pp = pp
         self.change_reporter = change_reporter
-        self.cherrypick = cherrypick
         if self.pp is None:
             self.pp = ProgressPhase("Merge phase", 3, self.pb)
-        if do_merge:
-            self.do_merge()
 
-    def do_merge(self):
-        self.this_tree.lock_tree_write()
-        self.base_tree.lock_read()
-        self.other_tree.lock_read()
-        self.tt = TreeTransform(self.this_tree, self.pb)
+        self.tt = TreeTransform(working_tree, self.pb)
         try:
             self.pp.next_phase()
-            self._compute_transform()
+            entries = self._entries3()
+            child_pb = ui.ui_factory.nested_progress_bar()
+            try:
+                for num, (file_id, changed, parents3, names3,
+                          executable3) in enumerate(entries):
+                    child_pb.update('Preparing file merge', num, len(entries))
+                    self._merge_names(file_id, parents3, names3)
+                    if changed:
+                        file_status = self.merge_contents(file_id)
+                    else:
+                        file_status = 'unmodified'
+                    self._merge_executable(file_id,
+                        executable3, file_status)
+            finally:
+                child_pb.finished()
+            self.fix_root()
+            self.pp.next_phase()
+            child_pb = ui.ui_factory.nested_progress_bar()
+            try:
+                fs_conflicts = resolve_conflicts(self.tt, child_pb,
+                    lambda t, c: conflict_pass(t, c, self.other_tree))
+            finally:
+                child_pb.finished()
+            if change_reporter is not None:
+                from bzrlib import delta
+                delta.report_changes(self.tt._iter_changes(), change_reporter)
+            self.cook_conflicts(fs_conflicts)
+            for conflict in self.cooked_conflicts:
+                warning(conflict)
             self.pp.next_phase()
             results = self.tt.apply(no_conflicts=True)
             self.write_modified(results)
             try:
-                self.this_tree.add_conflicts(self.cooked_conflicts)
+                working_tree.add_conflicts(self.cooked_conflicts)
             except UnsupportedOperation:
                 pass
         finally:
@@ -535,52 +507,6 @@
             self.this_tree.unlock()
             self.pb.clear()
 
-    def make_preview_transform(self):
-        self.base_tree.lock_read()
-        self.other_tree.lock_read()
-        self.tt = TransformPreview(self.this_tree)
-        try:
-            self.pp.next_phase()
-            self._compute_transform()
-            self.pp.next_phase()
-        finally:
-            self.other_tree.unlock()
-            self.base_tree.unlock()
-            self.pb.clear()
-        return self.tt
-
-    def _compute_transform(self):
-        entries = self._entries3()
-        child_pb = ui.ui_factory.nested_progress_bar()
-        try:
-            for num, (file_id, changed, parents3, names3,
-                      executable3) in enumerate(entries):
-                child_pb.update('Preparing file merge', num, len(entries))
-                self._merge_names(file_id, parents3, names3)
-                if changed:
-                    file_status = self.merge_contents(file_id)
-                else:
-                    file_status = 'unmodified'
-                self._merge_executable(file_id,
-                    executable3, file_status)
-        finally:
-            child_pb.finished()
-        self.fix_root()
-        self.pp.next_phase()
-        child_pb = ui.ui_factory.nested_progress_bar()
-        try:
-            fs_conflicts = resolve_conflicts(self.tt, child_pb,
-                lambda t, c: conflict_pass(t, c, self.other_tree))
-        finally:
-            child_pb.finished()
-        if self.change_reporter is not None:
-            from bzrlib import delta
-            delta.report_changes(
-                self.tt.iter_changes(), self.change_reporter)
-        self.cook_conflicts(fs_conflicts)
-        for conflict in self.cooked_conflicts:
-            warning(conflict)
-
     def _entries3(self):
         """Gather data about files modified between three trees.
 
@@ -591,7 +517,7 @@
         executable3 is a tuple of execute-bit values for base, other and this.
         """
         result = []
-        iterator = self.other_tree.iter_changes(self.base_tree,
+        iterator = self.other_tree._iter_changes(self.base_tree,
                 include_unchanged=True, specific_files=self.interesting_files,
                 extra_trees=[self.this_tree])
         for (file_id, paths, changed, versioned, parents, names, kind,
@@ -624,7 +550,7 @@
                                  self.tt.root)
         if self.other_tree.inventory.root is None:
             return
-        other_root_file_id = self.other_tree.get_root_id()
+        other_root_file_id = self.other_tree.inventory.root.file_id
         other_root = self.tt.trans_id_file_id(other_root_file_id)
         if other_root == self.tt.root:
             return
@@ -632,9 +558,6 @@
             self.tt.final_kind(other_root)
         except NoSuchFile:
             return
-        if self.other_tree.inventory.root.file_id in self.this_tree.inventory:
-            # the other tree's root is a non-root in the current tree
-            return
         self.reparent_children(self.other_tree.inventory.root, self.tt.root)
         self.tt.cancel_creation(other_root)
         self.tt.cancel_versioning(other_root)
@@ -718,13 +641,14 @@
         if key_base == key_other:
             return "this"
         key_this = key(this_tree, file_id)
+        if key_this not in (key_base, key_other):
+            return "conflict"
         # "Ambiguous clean merge"
-        if key_this == key_other:
+        elif key_this == key_other:
             return "this"
-        elif key_this == key_base:
+        else:
+            assert key_this == key_base
             return "other"
-        else:
-            return "conflict"
 
     def merge_names(self, file_id):
         def get_entry(tree):
@@ -878,8 +802,7 @@
             base_lines = []
         other_lines = self.get_lines(self.other_tree, file_id)
         this_lines = self.get_lines(self.this_tree, file_id)
-        m3 = Merge3(base_lines, this_lines, other_lines,
-                    is_cherrypick=self.cherrypick)
+        m3 = Merge3(base_lines, this_lines, other_lines)
         start_marker = "!START OF MERGE CONFLICT!" + "I HOPE THIS IS UNIQUE"
         if self.show_base is True:
             base_marker = '|' * 7
@@ -955,6 +878,12 @@
         base_executable, other_executable, this_executable = executable
         if file_status == "deleted":
             return
+        trans_id = self.tt.trans_id_file_id(file_id)
+        try:
+            if self.tt.final_kind(trans_id) != "file":
+                return
+        except NoSuchFile:
+            return
         winner = self._three_way(*executable)
         if winner == "conflict":
         # There must be a None in here, if we have a conflict, but we
@@ -963,26 +892,23 @@
                 winner = "this"
             else:
                 winner = "other"
-        if winner == 'this' and file_status != "modified":
-            return
-        trans_id = self.tt.trans_id_file_id(file_id)
-        try:
-            if self.tt.final_kind(trans_id) != "file":
-                return
-        except NoSuchFile:
-            return
         if winner == "this":
-            executability = this_executable
+            if file_status == "modified":
+                executability = this_executable
+                if executability is not None:
+                    trans_id = self.tt.trans_id_file_id(file_id)
+                    self.tt.set_executability(executability, trans_id)
         else:
+            assert winner == "other"
             if file_id in self.other_tree:
                 executability = other_executable
             elif file_id in self.this_tree:
                 executability = this_executable
             elif file_id in self.base_tree:
                 executability = base_executable
-        if executability is not None:
-            trans_id = self.tt.trans_id_file_id(file_id)
-            self.tt.set_executability(executability, trans_id)
+            if executability is not None:
+                trans_id = self.tt.trans_id_file_id(file_id)
+                self.tt.set_executability(executability, trans_id)
 
     def cook_conflicts(self, fs_conflicts):
         """Convert all conflicts into a form that doesn't depend on trans_id"""
@@ -1021,15 +947,13 @@
         for trans_id, conflicts in name_conflicts.iteritems():
             try:
                 this_parent, other_parent = conflicts['parent conflict']
-                if this_parent == other_parent:
-                    raise AssertionError()
+                assert this_parent != other_parent
             except KeyError:
                 this_parent = other_parent = \
                     self.tt.final_file_id(self.tt.final_parent(trans_id))
             try:
                 this_name, other_name = conflicts['name conflict']
-                if this_name == other_name:
-                    raise AssertionError()
+                assert this_name != other_name
             except KeyError:
                 this_name = other_name = self.tt.final_name(trans_id)
             other_path = fp.get_path(trans_id)
@@ -1050,26 +974,23 @@
     """Three-way tree merger, text weave merger."""
     supports_reprocess = True
     supports_show_base = False
-    supports_reverse_cherrypick = False
-    history_based = True
+
+    def __init__(self, working_tree, this_tree, base_tree, other_tree, 
+                 interesting_ids=None, pb=DummyProgress(), pp=None,
+                 reprocess=False, change_reporter=None,
+                 interesting_files=None):
+        super(WeaveMerger, self).__init__(working_tree, this_tree, 
+                                          base_tree, other_tree, 
+                                          interesting_ids=interesting_ids, 
+                                          pb=pb, pp=pp, reprocess=reprocess,
+                                          change_reporter=change_reporter)
 
     def _merged_lines(self, file_id):
         """Generate the merged lines.
         There is no distinction between lines that are meant to contain <<<<<<<
         and conflicts.
         """
-        if self.cherrypick:
-            base = self.base_tree
-        else:
-            base = None
-        plan = self.this_tree.plan_file_merge(file_id, self.other_tree,
-                                              base=base)
-        if 'merge' in debug.debug_flags:
-            plan = list(plan)
-            trans_id = self.tt.trans_id_file_id(file_id)
-            name = self.tt.final_name(trans_id) + '.plan'
-            contents = ('%10s|%s' % l for l in plan)
-            self.tt.new_file(name, self.tt.final_parent(trans_id), contents)
+        plan = self.this_tree.plan_file_merge(file_id, self.other_tree)
         textmerge = PlanWeaveMerge(plan, '<<<<<<< TREE\n',
             '>>>>>>> MERGE-SOURCE\n')
         return textmerge.merge_lines(self.reprocess)
@@ -1094,30 +1015,6 @@
             file_group.append(trans_id)
 
 
-class LCAMerger(WeaveMerger):
-
-    def _merged_lines(self, file_id):
-        """Generate the merged lines.
-        There is no distinction between lines that are meant to contain <<<<<<<
-        and conflicts.
-        """
-        if self.cherrypick:
-            base = self.base_tree
-        else:
-            base = None
-        plan = self.this_tree.plan_file_lca_merge(file_id, self.other_tree,
-                                                  base=base)
-        if 'merge' in debug.debug_flags:
-            plan = list(plan)
-            trans_id = self.tt.trans_id_file_id(file_id)
-            name = self.tt.final_name(trans_id) + '.plan'
-            contents = ('%10s|%s' % l for l in plan)
-            self.tt.new_file(name, self.tt.final_parent(trans_id), contents)
-        textmerge = PlanWeaveMerge(plan, '<<<<<<< TREE\n',
-            '>>>>>>> MERGE-SOURCE\n')
-        return textmerge.merge_lines(self.reprocess)
-
-
 class Diff3Merger(Merge3Merger):
     """Three-way merger using external diff3 for text merging"""
 
@@ -1188,18 +1085,13 @@
     merger.interesting_ids = interesting_ids
     merger.ignore_zero = ignore_zero
     if interesting_files:
-        if interesting_ids:
-            raise ValueError('Only supply interesting_ids'
-                             ' or interesting_files')
+        assert not interesting_ids, ('Only supply interesting_ids'
+                                     ' or interesting_files')
         merger.interesting_files = interesting_files
     merger.show_base = show_base
     merger.reprocess = reprocess
     merger.other_rev_id = other_rev_id
     merger.other_basis = other_rev_id
-    get_revision_id = getattr(base_tree, 'get_revision_id', None)
-    if get_revision_id is None:
-        get_revision_id = base_tree.last_revision
-    merger.set_base_revision(get_revision_id(), this_branch)
     return merger.do_merge()
 
 def get_merge_type_registry():
@@ -1238,463 +1130,10 @@
             yield status_a(revision, text)
         for revision, text in annotated_b[b_cur:bi]:
             yield status_b(revision, text)
+
         # and now the matched section
         a_cur = ai + l
         b_cur = bi + l
-        for text_a in plain_a[ai:a_cur]:
+        for text_a, text_b in zip(plain_a[ai:a_cur], plain_b[bi:b_cur]):
+            assert text_a == text_b
             yield "unchanged", text_a
-
-
-class _PlanMergeBase(object):
-
-    def __init__(self, a_rev, b_rev, vf, key_prefix):
-        """Contructor.
-
-        :param a_rev: Revision-id of one revision to merge
-        :param b_rev: Revision-id of the other revision to merge
-        :param vf: A VersionedFiles containing both revisions
-        :param key_prefix: A prefix for accessing keys in vf, typically
-            (file_id,).
-        """
-        self.a_rev = a_rev
-        self.b_rev = b_rev
-        self.vf = vf
-        self._last_lines = None
-        self._last_lines_revision_id = None
-        self._cached_matching_blocks = {}
-        self._key_prefix = key_prefix
-        self._precache_tip_lines()
-
-    def _precache_tip_lines(self):
-        lines = self.get_lines([self.a_rev, self.b_rev])
-        self.lines_a = lines[self.a_rev]
-        self.lines_b = lines[self.b_rev]
-
-    def get_lines(self, revisions):
-        """Get lines for revisions from the backing VersionedFiles.
-        
-        :raises RevisionNotPresent: on absent texts.
-        """
-        keys = [(self._key_prefix + (rev,)) for rev in revisions]
-        result = {}
-        for record in self.vf.get_record_stream(keys, 'unordered', True):
-            if record.storage_kind == 'absent':
-                raise errors.RevisionNotPresent(record.key, self.vf)
-            result[record.key[-1]] = osutils.split_lines(
-                record.get_bytes_as('fulltext'))
-        return result
-
-    def plan_merge(self):
-        """Generate a 'plan' for merging the two revisions.
-
-        This involves comparing their texts and determining the cause of
-        differences.  If text A has a line and text B does not, then either the
-        line was added to text A, or it was deleted from B.  Once the causes
-        are combined, they are written out in the format described in
-        VersionedFile.plan_merge
-        """
-        blocks = self._get_matching_blocks(self.a_rev, self.b_rev)
-        unique_a, unique_b = self._unique_lines(blocks)
-        new_a, killed_b = self._determine_status(self.a_rev, unique_a)
-        new_b, killed_a = self._determine_status(self.b_rev, unique_b)
-        return self._iter_plan(blocks, new_a, killed_b, new_b, killed_a)
-
-    def _iter_plan(self, blocks, new_a, killed_b, new_b, killed_a):
-        last_i = 0
-        last_j = 0
-        for i, j, n in blocks:
-            for a_index in range(last_i, i):
-                if a_index in new_a:
-                    if a_index in killed_b:
-                        yield 'conflicted-a', self.lines_a[a_index]
-                    else:
-                        yield 'new-a', self.lines_a[a_index]
-                else:
-                    yield 'killed-b', self.lines_a[a_index]
-            for b_index in range(last_j, j):
-                if b_index in new_b:
-                    if b_index in killed_a:
-                        yield 'conflicted-b', self.lines_b[b_index]
-                    else:
-                        yield 'new-b', self.lines_b[b_index]
-                else:
-                    yield 'killed-a', self.lines_b[b_index]
-            # handle common lines
-            for a_index in range(i, i+n):
-                yield 'unchanged', self.lines_a[a_index]
-            last_i = i+n
-            last_j = j+n
-
-    def _get_matching_blocks(self, left_revision, right_revision):
-        """Return a description of which sections of two revisions match.
-
-        See SequenceMatcher.get_matching_blocks
-        """
-        cached = self._cached_matching_blocks.get((left_revision,
-                                                   right_revision))
-        if cached is not None:
-            return cached
-        if self._last_lines_revision_id == left_revision:
-            left_lines = self._last_lines
-            right_lines = self.get_lines([right_revision])[right_revision]
-        else:
-            lines = self.get_lines([left_revision, right_revision])
-            left_lines = lines[left_revision]
-            right_lines = lines[right_revision]
-        self._last_lines = right_lines
-        self._last_lines_revision_id = right_revision
-        matcher = patiencediff.PatienceSequenceMatcher(None, left_lines,
-                                                       right_lines)
-        return matcher.get_matching_blocks()
-
-    def _unique_lines(self, matching_blocks):
-        """Analyse matching_blocks to determine which lines are unique
-
-        :return: a tuple of (unique_left, unique_right), where the values are
-            sets of line numbers of unique lines.
-        """
-        last_i = 0
-        last_j = 0
-        unique_left = []
-        unique_right = []
-        for i, j, n in matching_blocks:
-            unique_left.extend(range(last_i, i))
-            unique_right.extend(range(last_j, j))
-            last_i = i + n
-            last_j = j + n
-        return unique_left, unique_right
-
-    @staticmethod
-    def _subtract_plans(old_plan, new_plan):
-        """Remove changes from new_plan that came from old_plan.
-
-        It is assumed that the difference between the old_plan and new_plan
-        is their choice of 'b' text.
-
-        All lines from new_plan that differ from old_plan are emitted
-        verbatim.  All lines from new_plan that match old_plan but are
-        not about the 'b' revision are emitted verbatim.
-
-        Lines that match and are about the 'b' revision are the lines we
-        don't want, so we convert 'killed-b' -> 'unchanged', and 'new-b'
-        is skipped entirely.
-        """
-        matcher = patiencediff.PatienceSequenceMatcher(None, old_plan,
-                                                       new_plan)
-        last_j = 0
-        for i, j, n in matcher.get_matching_blocks():
-            for jj in range(last_j, j):
-                yield new_plan[jj]
-            for jj in range(j, j+n):
-                plan_line = new_plan[jj]
-                if plan_line[0] == 'new-b':
-                    pass
-                elif plan_line[0] == 'killed-b':
-                    yield 'unchanged', plan_line[1]
-                else:
-                    yield plan_line
-            last_j = j + n
-
-
-class _PlanMerge(_PlanMergeBase):
-    """Plan an annotate merge using on-the-fly annotation"""
-
-    def __init__(self, a_rev, b_rev, vf, key_prefix):
-        super(_PlanMerge, self).__init__(a_rev, b_rev, vf, key_prefix)
-        self.a_key = self._key_prefix + (self.a_rev,)
-        self.b_key = self._key_prefix + (self.b_rev,)
-        self.graph = Graph(self.vf)
-        heads = self.graph.heads((self.a_key, self.b_key))
-        if len(heads) == 1:
-            # one side dominates, so we can just return its values, yay for
-            # per-file graphs
-            # Ideally we would know that before we get this far
-            self._head_key = heads.pop()
-            if self._head_key == self.a_key:
-                other = b_rev
-            else:
-                other = a_rev
-            mutter('found dominating revision for %s\n%s > %s', self.vf,
-                   self._head_key[-1], other)
-            self._weave = None
-        else:
-            self._head_key = None
-            self._build_weave()
-
-    def _precache_tip_lines(self):
-        # Turn this into a no-op, because we will do this later
-        pass
-
-    def _find_recursive_lcas(self):
-        """Find all the ancestors back to a unique lca"""
-        cur_ancestors = (self.a_key, self.b_key)
-        # graph.find_lca(uncommon, keys) now returns plain NULL_REVISION,
-        # rather than a key tuple. We will just map that directly to no common
-        # ancestors.
-        parent_map = {}
-        while True:
-            next_lcas = self.graph.find_lca(*cur_ancestors)
-            # Map a plain NULL_REVISION to a simple no-ancestors
-            if next_lcas == set([NULL_REVISION]):
-                next_lcas = ()
-            # Order the lca's based on when they were merged into the tip
-            # While the actual merge portion of weave merge uses a set() of
-            # active revisions, the order of insertion *does* effect the
-            # implicit ordering of the texts.
-            for rev_key in cur_ancestors:
-                ordered_parents = tuple(self.graph.find_merge_order(rev_key,
-                                                                    next_lcas))
-                parent_map[rev_key] = ordered_parents
-            if len(next_lcas) == 0:
-                break
-            elif len(next_lcas) == 1:
-                parent_map[list(next_lcas)[0]] = ()
-                break
-            elif len(next_lcas) > 2:
-                # More than 2 lca's, fall back to grabbing all nodes between
-                # this and the unique lca.
-                mutter('More than 2 LCAs, falling back to all nodes for:'
-                       ' %s, %s\n=> %s', self.a_key, self.b_key, cur_ancestors)
-                cur_lcas = next_lcas
-                while len(cur_lcas) > 1:
-                    cur_lcas = self.graph.find_lca(*cur_lcas)
-                if len(cur_lcas) == 0:
-                    # No common base to find, use the full ancestry
-                    unique_lca = None
-                else:
-                    unique_lca = list(cur_lcas)[0]
-                    if unique_lca == NULL_REVISION:
-                        # find_lca will return a plain 'NULL_REVISION' rather
-                        # than a key tuple when there is no common ancestor, we
-                        # prefer to just use None, because it doesn't confuse
-                        # _get_interesting_texts()
-                        unique_lca = None
-                parent_map.update(self._find_unique_parents(next_lcas,
-                                                            unique_lca))
-                break
-            cur_ancestors = next_lcas
-        return parent_map
-
-    def _find_unique_parents(self, tip_keys, base_key):
-        """Find ancestors of tip that aren't ancestors of base.
-        
-        :param tip_keys: Nodes that are interesting
-        :param base_key: Cull all ancestors of this node
-        :return: The parent map for all revisions between tip_keys and
-            base_key. base_key will be included. References to nodes outside of
-            the ancestor set will also be removed.
-        """
-        # TODO: this would be simpler if find_unique_ancestors took a list
-        #       instead of a single tip, internally it supports it, but it
-        #       isn't a "backwards compatible" api change.
-        if base_key is None:
-            parent_map = dict(self.graph.iter_ancestry(tip_keys))
-            # We remove NULL_REVISION because it isn't a proper tuple key, and
-            # thus confuses things like _get_interesting_texts, and our logic
-            # to add the texts into the memory weave.
-            if NULL_REVISION in parent_map:
-                parent_map.pop(NULL_REVISION)
-        else:
-            interesting = set()
-            for tip in tip_keys:
-                interesting.update(
-                    self.graph.find_unique_ancestors(tip, [base_key]))
-            parent_map = self.graph.get_parent_map(interesting)
-            parent_map[base_key] = ()
-        culled_parent_map, child_map, tails = self._remove_external_references(
-            parent_map)
-        # Remove all the tails but base_key
-        if base_key is not None:
-            tails.remove(base_key)
-            self._prune_tails(culled_parent_map, child_map, tails)
-        # Now remove all the uninteresting 'linear' regions
-        simple_map = _mod_graph.collapse_linear_regions(culled_parent_map)
-        return simple_map
-
-    @staticmethod
-    def _remove_external_references(parent_map):
-        """Remove references that go outside of the parent map.
-
-        :param parent_map: Something returned from Graph.get_parent_map(keys)
-        :return: (filtered_parent_map, child_map, tails)
-            filtered_parent_map is parent_map without external references
-            child_map is the {parent_key: [child_keys]} mapping
-            tails is a list of nodes that do not have any parents in the map
-        """
-        # TODO: The basic effect of this function seems more generic than
-        #       _PlanMerge. But the specific details of building a child_map,
-        #       and computing tails seems very specific to _PlanMerge.
-        #       Still, should this be in Graph land?
-        filtered_parent_map = {}
-        child_map = {}
-        tails = []
-        for key, parent_keys in parent_map.iteritems():
-            culled_parent_keys = [p for p in parent_keys if p in parent_map]
-            if not culled_parent_keys:
-                tails.append(key)
-            for parent_key in culled_parent_keys:
-                child_map.setdefault(parent_key, []).append(key)
-            # TODO: Do we want to do this, it adds overhead for every node,
-            #       just to say that the node has no children
-            child_map.setdefault(key, [])
-            filtered_parent_map[key] = culled_parent_keys
-        return filtered_parent_map, child_map, tails
-
-    @staticmethod
-    def _prune_tails(parent_map, child_map, tails_to_remove):
-        """Remove tails from the parent map.
-        
-        This will remove the supplied revisions until no more children have 0
-        parents.
-
-        :param parent_map: A dict of {child: [parents]}, this dictionary will
-            be modified in place.
-        :param tails_to_remove: A list of tips that should be removed,
-            this list will be consumed
-        :param child_map: The reverse dict of parent_map ({parent: [children]})
-            this dict will be modified
-        :return: None, parent_map will be modified in place.
-        """
-        while tails_to_remove:
-            next = tails_to_remove.pop()
-            parent_map.pop(next)
-            children = child_map.pop(next)
-            for child in children:
-                child_parents = parent_map[child]
-                child_parents.remove(next)
-                if len(child_parents) == 0:
-                    tails_to_remove.append(child)
-
-    def _get_interesting_texts(self, parent_map):
-        """Return a dict of texts we are interested in.
-
-        Note that the input is in key tuples, but the output is in plain
-        revision ids.
-
-        :param parent_map: The output from _find_recursive_lcas
-        :return: A dict of {'revision_id':lines} as returned by
-            _PlanMergeBase.get_lines()
-        """
-        all_revision_keys = set(parent_map)
-        all_revision_keys.add(self.a_key)
-        all_revision_keys.add(self.b_key)
-
-        # Everything else is in 'keys' but get_lines is in 'revision_ids'
-        all_texts = self.get_lines([k[-1] for k in all_revision_keys])
-        return all_texts
-
-    def _build_weave(self):
-        from bzrlib import weave
-        self._weave = weave.Weave(weave_name='in_memory_weave',
-                                  allow_reserved=True)
-        parent_map = self._find_recursive_lcas()
-
-        all_texts = self._get_interesting_texts(parent_map)
-
-        # Note: Unfortunately, the order given by topo_sort will effect the
-        # ordering resolution in the output. Specifically, if you add A then B,
-        # then in the output text A lines will show up before B lines. And, of
-        # course, topo_sort doesn't guarantee any real ordering.
-        # So we use merge_sort, and add a fake node on the tip.
-        # This ensures that left-hand parents will always be inserted into the
-        # weave before right-hand parents.
-        tip_key = self._key_prefix + (_mod_revision.CURRENT_REVISION,)
-        parent_map[tip_key] = (self.a_key, self.b_key)
-
-        for seq_num, key, depth, eom in reversed(tsort.merge_sort(parent_map,
-                                                                  tip_key)):
-            if key == tip_key:
-                continue
-        # for key in tsort.topo_sort(parent_map):
-            parent_keys = parent_map[key]
-            revision_id = key[-1]
-            parent_ids = [k[-1] for k in parent_keys]
-            self._weave.add_lines(revision_id, parent_ids,
-                                  all_texts[revision_id])
-
-    def plan_merge(self):
-        """Generate a 'plan' for merging the two revisions.
-
-        This involves comparing their texts and determining the cause of
-        differences.  If text A has a line and text B does not, then either the
-        line was added to text A, or it was deleted from B.  Once the causes
-        are combined, they are written out in the format described in
-        VersionedFile.plan_merge
-        """
-        if self._head_key is not None: # There was a single head
-            if self._head_key == self.a_key:
-                plan = 'new-a'
-            else:
-                if self._head_key != self.b_key:
-                    raise AssertionError('There was an invalid head: %s != %s'
-                                         % (self.b_key, self._head_key))
-                plan = 'new-b'
-            head_rev = self._head_key[-1]
-            lines = self.get_lines([head_rev])[head_rev]
-            return ((plan, line) for line in lines)
-        return self._weave.plan_merge(self.a_rev, self.b_rev)
-
-
-class _PlanLCAMerge(_PlanMergeBase):
-    """
-    This merge algorithm differs from _PlanMerge in that:
-    1. comparisons are done against LCAs only
-    2. cases where a contested line is new versus one LCA but old versus
-       another are marked as conflicts, by emitting the line as conflicted-a
-       or conflicted-b.
-
-    This is faster, and hopefully produces more useful output.
-    """
-
-    def __init__(self, a_rev, b_rev, vf, key_prefix, graph):
-        _PlanMergeBase.__init__(self, a_rev, b_rev, vf, key_prefix)
-        lcas = graph.find_lca(key_prefix + (a_rev,), key_prefix + (b_rev,))
-        self.lcas = set()
-        for lca in lcas:
-            if lca == NULL_REVISION:
-                self.lcas.add(lca)
-            else:
-                self.lcas.add(lca[-1])
-        for lca in self.lcas:
-            if _mod_revision.is_null(lca):
-                lca_lines = []
-            else:
-                lca_lines = self.get_lines([lca])[lca]
-            matcher = patiencediff.PatienceSequenceMatcher(None, self.lines_a,
-                                                           lca_lines)
-            blocks = list(matcher.get_matching_blocks())
-            self._cached_matching_blocks[(a_rev, lca)] = blocks
-            matcher = patiencediff.PatienceSequenceMatcher(None, self.lines_b,
-                                                           lca_lines)
-            blocks = list(matcher.get_matching_blocks())
-            self._cached_matching_blocks[(b_rev, lca)] = blocks
-
-    def _determine_status(self, revision_id, unique_line_numbers):
-        """Determines the status unique lines versus all lcas.
-
-        Basically, determines why the line is unique to this revision.
-
-        A line may be determined new, killed, or both.
-
-        If a line is determined new, that means it was not present in at least
-        one LCA, and is not present in the other merge revision.
-
-        If a line is determined killed, that means the line was present in
-        at least one LCA.
-
-        If a line is killed and new, this indicates that the two merge
-        revisions contain differing conflict resolutions.
-        :param revision_id: The id of the revision in which the lines are
-            unique
-        :param unique_line_numbers: The line numbers of unique lines.
-        :return a tuple of (new_this, killed_other):
-        """
-        new = set()
-        killed = set()
-        unique_line_numbers = set(unique_line_numbers)
-        for lca in self.lcas:
-            blocks = self._get_matching_blocks(revision_id, lca)
-            unique_vs_lca, _ignored = self._unique_lines(blocks)
-            new.update(unique_line_numbers.intersection(unique_vs_lca))
-            killed.update(unique_line_numbers.difference(unique_vs_lca))
-        return new, killed

=== modified file 'bzrlib/merge3.py'
--- bzrlib/merge3.py	2008-05-08 04:16:03 +0000
+++ bzrlib/merge3.py	2007-03-12 19:56:41 +0000
@@ -36,7 +36,8 @@
     >>> intersect((0, 9), (7, 15))
     (7, 9)
     """
-    # preconditions: (ra[0] <= ra[1]) and (rb[0] <= rb[1])
+    assert ra[0] <= ra[1]
+    assert rb[0] <= rb[1]
     
     sa = max(ra[0], rb[0])
     sb = min(ra[1], rb[1])
@@ -66,14 +67,15 @@
     Given BASE, OTHER, THIS, tries to produce a combined text
     incorporating the changes from both BASE->OTHER and BASE->THIS.
     All three will typically be sequences of lines."""
-    def __init__(self, base, a, b, is_cherrypick=False):
+    def __init__(self, base, a, b):
         check_text_lines(base)
         check_text_lines(a)
         check_text_lines(b)
         self.base = base
         self.a = a
         self.b = b
-        self.is_cherrypick = is_cherrypick
+
+
 
     def merge_lines(self,
                     name_a=None,
@@ -128,6 +130,10 @@
                 yield end_marker + newline
             else:
                 raise ValueError(what)
+        
+        
+
+
 
     def merge_annotated(self):
         """Return merge with conflicts, showing origin of lines.
@@ -155,6 +161,10 @@
                 yield '>>>>\n'
             else:
                 raise ValueError(what)
+        
+        
+
+
 
     def merge_groups(self):
         """Yield sequence of line groups.  Each one is a tuple:
@@ -190,6 +200,7 @@
             else:
                 raise ValueError(what)
 
+
     def merge_regions(self):
         """Return sequences of matching and conflicting regions.
 
@@ -221,47 +232,41 @@
         iz = ia = ib = 0
         
         for zmatch, zend, amatch, aend, bmatch, bend in self.find_sync_regions():
+            #print 'match base [%d:%d]' % (zmatch, zend)
+            
             matchlen = zend - zmatch
-            # invariants:
-            #   matchlen >= 0
-            #   matchlen == (aend - amatch)
-            #   matchlen == (bend - bmatch)
+            assert matchlen >= 0
+            assert matchlen == (aend - amatch)
+            assert matchlen == (bend - bmatch)
+            
             len_a = amatch - ia
             len_b = bmatch - ib
             len_base = zmatch - iz
-            # invariants:
-            # assert len_a >= 0
-            # assert len_b >= 0
-            # assert len_base >= 0
+            assert len_a >= 0
+            assert len_b >= 0
+            assert len_base >= 0
 
             #print 'unmatched a=%d, b=%d' % (len_a, len_b)
 
             if len_a or len_b:
                 # try to avoid actually slicing the lists
+                equal_a = compare_range(self.a, ia, amatch,
+                                        self.base, iz, zmatch)
+                equal_b = compare_range(self.b, ib, bmatch,
+                                        self.base, iz, zmatch)
                 same = compare_range(self.a, ia, amatch,
                                      self.b, ib, bmatch)
 
                 if same:
                     yield 'same', ia, amatch
+                elif equal_a and not equal_b:
+                    yield 'b', ib, bmatch
+                elif equal_b and not equal_a:
+                    yield 'a', ia, amatch
+                elif not equal_a and not equal_b:
+                    yield 'conflict', iz, zmatch, ia, amatch, ib, bmatch
                 else:
-                    equal_a = compare_range(self.a, ia, amatch,
-                                            self.base, iz, zmatch)
-                    equal_b = compare_range(self.b, ib, bmatch,
-                                            self.base, iz, zmatch)
-                    if equal_a and not equal_b:
-                        yield 'b', ib, bmatch
-                    elif equal_b and not equal_a:
-                        yield 'a', ia, amatch
-                    elif not equal_a and not equal_b:
-                        if self.is_cherrypick:
-                            for node in self._refine_cherrypick_conflict(
-                                                    iz, zmatch, ia, amatch,
-                                                    ib, bmatch):
-                                yield node
-                        else:
-                            yield 'conflict', iz, zmatch, ia, amatch, ib, bmatch
-                    else:
-                        raise AssertionError("can't handle a=b=base but unmatched")
+                    raise AssertionError("can't handle a=b=base but unmatched")
 
                 ia = amatch
                 ib = bmatch
@@ -270,56 +275,17 @@
             # if the same part of the base was deleted on both sides
             # that's OK, we can just skip it.
 
+                
             if matchlen > 0:
-                # invariants:
-                # assert ia == amatch
-                # assert ib == bmatch
-                # assert iz == zmatch
+                assert ia == amatch
+                assert ib == bmatch
+                assert iz == zmatch
                 
                 yield 'unchanged', zmatch, zend
                 iz = zend
                 ia = aend
                 ib = bend
-
-    def _refine_cherrypick_conflict(self, zstart, zend, astart, aend, bstart, bend):
-        """When cherrypicking b => a, ignore matches with b and base."""
-        # Do not emit regions which match, only regions which do not match
-        matches = bzrlib.patiencediff.PatienceSequenceMatcher(None,
-            self.base[zstart:zend], self.b[bstart:bend]).get_matching_blocks()
-        last_base_idx = 0
-        last_b_idx = 0
-        last_b_idx = 0
-        yielded_a = False
-        for base_idx, b_idx, match_len in matches:
-            conflict_z_len = base_idx - last_base_idx
-            conflict_b_len = b_idx - last_b_idx
-            if conflict_b_len == 0: # There are no lines in b which conflict,
-                                    # so skip it
-                pass
-            else:
-                if yielded_a:
-                    yield ('conflict',
-                           zstart + last_base_idx, zstart + base_idx,
-                           aend, aend, bstart + last_b_idx, bstart + b_idx)
-                else:
-                    # The first conflict gets the a-range
-                    yielded_a = True
-                    yield ('conflict', zstart + last_base_idx, zstart +
-                    base_idx,
-                           astart, aend, bstart + last_b_idx, bstart + b_idx)
-            last_base_idx = base_idx + match_len
-            last_b_idx = b_idx + match_len
-        if last_base_idx != zend - zstart or last_b_idx != bend - bstart:
-            if yielded_a:
-                yield ('conflict', zstart + last_base_idx, zstart + base_idx,
-                       aend, aend, bstart + last_b_idx, bstart + b_idx)
-            else:
-                # The first conflict gets the a-range
-                yielded_a = True
-                yield ('conflict', zstart + last_base_idx, zstart + base_idx,
-                       astart, aend, bstart + last_b_idx, bstart + b_idx)
-        if not yielded_a:
-            yield ('conflict', zstart, zend, astart, aend, bstart, bend)
+    
 
     def reprocess_merge_regions(self, merge_regions):
         """Where there are conflict regions, remove the agreed lines.
@@ -352,10 +318,12 @@
             if reg is not None:
                 yield reg
 
+
     @staticmethod
     def mismatch_region(next_a, region_ia,  next_b, region_ib):
         if next_a < region_ia or next_b < region_ib:
             return 'conflict', None, None, next_a, region_ia, next_b, region_ib
+            
 
     def find_sync_regions(self):
         """Return a list of sync regions, where both descendents match the base.
@@ -388,23 +356,25 @@
 
                 # found a match of base[i[0], i[1]]; this may be less than
                 # the region that matches in either one
-                # assert intlen <= alen
-                # assert intlen <= blen
-                # assert abase <= intbase
-                # assert bbase <= intbase
+                assert intlen <= alen
+                assert intlen <= blen
+                assert abase <= intbase
+                assert bbase <= intbase
 
                 asub = amatch + (intbase - abase)
                 bsub = bmatch + (intbase - bbase)
                 aend = asub + intlen
                 bend = bsub + intlen
 
-                # assert self.base[intbase:intend] == self.a[asub:aend], \
-                #       (self.base[intbase:intend], self.a[asub:aend])
-                # assert self.base[intbase:intend] == self.b[bsub:bend]
+                assert self.base[intbase:intend] == self.a[asub:aend], \
+                       (self.base[intbase:intend], self.a[asub:aend])
+
+                assert self.base[intbase:intend] == self.b[bsub:bend]
 
                 sl.append((intbase, intend,
                            asub, aend,
                            bsub, bend))
+
             # advance whichever one ends first in the base text
             if (abase + alen) < (bbase + blen):
                 ia += 1
@@ -418,6 +388,8 @@
 
         return sl
 
+
+
     def find_unconflicted(self):
         """Return a list of ranges in base that are not conflicted."""
         am = bzrlib.patiencediff.PatienceSequenceMatcher(

=== modified file 'bzrlib/merge_directive.py'
--- bzrlib/merge_directive.py	2008-07-12 00:52:42 +0000
+++ bzrlib/merge_directive.py	2007-08-15 20:49:22 +0000
@@ -136,21 +136,6 @@
         return klass(revision_id, t.as_sha1(), time, timezone, target_branch,
             patch, patch_type, public_branch, message)
 
-    def get_disk_name(self, branch):
-        """Generate a suitable basename for storing this directive on disk
-
-        :param branch: The Branch this merge directive was generated fro
-        :return: A string
-        """
-        revno, revision_id = branch.last_revision_info()
-        if self.revision_id == revision_id:
-            revno = [revno]
-        else:
-            revno = branch.get_revision_id_to_revno_map().get(self.revision_id,
-                ['merge'])
-        nick = re.sub('(\W+)', '-', branch.nick).strip('-')
-        return '%s-%s' % (nick, '.'.join(str(n) for n in revno))
-
     @staticmethod
     def _generate_diff(repository, revision_id, ancestor_id):
         tree_1 = repository.revision_tree(ancestor_id)
@@ -205,36 +190,7 @@
                     StringIO(self.get_raw_bundle()))
                 # We don't use the bundle's target revision, because
                 # MergeDirective.revision_id is authoritative.
-                try:
-                    info.install_revisions(target_repo, stream_input=False)
-                except errors.RevisionNotPresent:
-                    # At least one dependency isn't present.  Try installing
-                    # missing revisions from the submit branch
-                    try:
-                        submit_branch = \
-                            _mod_branch.Branch.open(self.target_branch)
-                    except errors.NotBranchError:
-                        raise errors.TargetNotBranch(self.target_branch)
-                    missing_revisions = []
-                    bundle_revisions = set(r.revision_id for r in
-                                           info.real_revisions)
-                    for revision in info.real_revisions:
-                        for parent_id in revision.parent_ids:
-                            if (parent_id not in bundle_revisions and
-                                not target_repo.has_revision(parent_id)):
-                                missing_revisions.append(parent_id)
-                    # reverse missing revisions to try to get heads first
-                    unique_missing = []
-                    unique_missing_set = set()
-                    for revision in reversed(missing_revisions):
-                        if revision in unique_missing_set:
-                            continue
-                        unique_missing.append(revision)
-                        unique_missing_set.add(revision)
-                    for missing_revision in unique_missing:
-                        target_repo.fetch(submit_branch.repository,
-                                          missing_revision)
-                    info.install_revisions(target_repo, stream_input=False)
+                info.install_revisions(target_repo, stream_input=False)
             else:
                 source_branch = _mod_branch.Branch.open(self.source_branch)
                 target_repo.fetch(source_branch.repository, self.revision_id)
@@ -278,8 +234,7 @@
         """
         _BaseMergeDirective.__init__(self, revision_id, testament_sha1, time,
             timezone, target_branch, patch, source_branch, message)
-        if patch_type not in (None, 'diff', 'bundle'):
-            raise ValueError(patch_type)
+        assert patch_type in (None, 'diff', 'bundle'), patch_type
         if patch_type != 'bundle' and source_branch is None:
             raise errors.NoMergeSource()
         if patch_type is not None and patch is None:

=== modified file 'bzrlib/missing.py'
--- bzrlib/missing.py	2008-05-20 02:34:01 +0000
+++ bzrlib/missing.py	2007-06-21 03:29:39 +0000
@@ -16,9 +16,20 @@
 
 """Display what revisions are missing in 'other' from 'this' and vice versa."""
 
+from bzrlib import ui
 from bzrlib.log import (
     LogRevision,
     )
+from bzrlib.symbol_versioning import (
+    deprecated_function,
+    zero_seventeen,
+    )
+
+
+@deprecated_function(zero_seventeen)
+def iter_log_data(revisions, revision_source, verbose):
+    for revision in iter_log_revisions(revisions, revision_source, verbose):
+        yield revision.revno, revision.rev, revision.delta
 
 
 def iter_log_revisions(revisions, revision_source, verbose):
@@ -42,100 +53,78 @@
         yield LogRevision(rev, revno, delta=delta)
 
 
-def find_unmerged(local_branch, remote_branch, restrict='all'):
-    """Find revisions from each side that have not been merged.
-
-    :param local_branch: Compare the history of local_branch
-    :param remote_branch: versus the history of remote_branch, and determine
-        mainline revisions which have not been merged.
-    :param restrict: ('all', 'local', 'remote') If 'all', we will return the
-        unique revisions from both sides. If 'local', we will return None
-        for the remote revisions, similarly if 'remote' we will return None for
-        the local revisions.
-
-    :return: A list of [(revno, revision_id)] for the mainline revisions on
-        each side.
-    """
+def find_unmerged(local_branch, remote_branch):
+    progress = ui.ui_factory.nested_progress_bar()
     local_branch.lock_read()
     try:
         remote_branch.lock_read()
         try:
-            return _find_unmerged(local_branch,
-                remote_branch, restrict=restrict)
+            local_rev_history, local_rev_history_map = \
+                _get_history(local_branch, progress, "local", 0)
+            remote_rev_history, remote_rev_history_map = \
+                _get_history(remote_branch, progress, "remote", 1)
+            result = _shortcut(local_rev_history, remote_rev_history)
+            if result is not None:
+                local_extra, remote_extra = result
+                local_extra = sorted_revisions(local_extra, 
+                                               local_rev_history_map)
+                remote_extra = sorted_revisions(remote_extra, 
+                                                remote_rev_history_map)
+                return local_extra, remote_extra
+
+            local_ancestry = _get_ancestry(local_branch.repository, progress, 
+                                           "local", 2, local_rev_history)
+            remote_ancestry = _get_ancestry(remote_branch.repository, progress,
+                                            "remote", 3, remote_rev_history)
+            progress.update('pondering', 4, 5)
+            extras = local_ancestry.symmetric_difference(remote_ancestry) 
+            local_extra = extras.intersection(set(local_rev_history))
+            remote_extra = extras.intersection(set(remote_rev_history))
+            local_extra = sorted_revisions(local_extra, local_rev_history_map)
+            remote_extra = sorted_revisions(remote_extra, 
+                                            remote_rev_history_map)
+                    
         finally:
             remote_branch.unlock()
     finally:
         local_branch.unlock()
-
-
-def _enumerate_mainline(ancestry, graph, tip_revno, tip):
-    """Enumerate the mainline revisions for these revisions.
-
-    :param ancestry: A set of revisions that we care about
-    :param graph: A Graph which lets us find the parents for a revision
-    :param tip_revno: The revision number for the tip revision
-    :param tip: The tip of mainline
-    :return: [(revno, revision_id)] for all revisions in ancestry that
-        are left-hand parents from tip, or None if ancestry is None.
-    """
-    if ancestry is None:
+        progress.finished()
+    return (local_extra, remote_extra)
+
+def _shortcut(local_rev_history, remote_rev_history):
+    local_history = set(local_rev_history)
+    remote_history = set(remote_rev_history)
+    if len(local_rev_history) == 0:
+        return set(), remote_history
+    elif len(remote_rev_history) == 0:
+        return local_history, set()
+    elif local_rev_history[-1] in remote_history:
+        return set(), _after(remote_rev_history, local_rev_history)
+    elif remote_rev_history[-1] in local_history:
+        return _after(local_rev_history, remote_rev_history), set()
+    else:
         return None
-    if not ancestry: #Empty ancestry, no need to do any work
-        return []
-
-    # Optionally, we could make 1 call to graph.get_parent_map with all
-    # ancestors. However that will often check many more parents than we
-    # actually need, and the Graph is likely to already have the parents cached
-    # anyway.
-    mainline = []
-    cur = tip
-    cur_revno = tip_revno
-    while cur in ancestry:
-        parent_map = graph.get_parent_map([cur])
-        parents = parent_map.get(cur)
-        if not parents:
-            break # Ghost, we are done
-        mainline.append((cur_revno, cur))
-        cur = parents[0]
-        cur_revno -= 1
-    mainline.reverse()
-    return mainline
-
-
-def _find_unmerged(local_branch, remote_branch, restrict):
-    """See find_unmerged.
-
-    The branches should already be locked before entering.
-    """
-    local_revno, local_revision_id = local_branch.last_revision_info()
-    remote_revno, remote_revision_id = remote_branch.last_revision_info()
-    if local_revno == remote_revno and local_revision_id == remote_revision_id:
-        # A simple shortcut when the tips are at the same point
-        return [], []
-    graph = local_branch.repository.get_graph(
-                remote_branch.repository)
-    if restrict == 'remote':
-        local_extra = None
-        remote_extra = graph.find_unique_ancestors(
-            remote_revision_id, [local_revision_id])
-    elif restrict == 'local':
-        remote_extra = None
-        local_extra = graph.find_unique_ancestors(
-            local_revision_id, [remote_revision_id])
+
+def _after(larger_history, smaller_history):
+    return set(larger_history[larger_history.index(smaller_history[-1])+1:])
+
+def _get_history(branch, progress, label, step):
+    progress.update('%s history' % label, step, 5)
+    rev_history = branch.revision_history()
+    rev_history_map = dict(
+        [(rev, rev_history.index(rev) + 1)
+         for rev in rev_history])
+    return rev_history, rev_history_map
+
+def _get_ancestry(repository, progress, label, step, rev_history):
+    progress.update('%s ancestry' % label, step, 5)
+    if len(rev_history) > 0:
+        ancestry = set(repository.get_ancestry(rev_history[-1],
+                       topo_sorted=False))
     else:
-        if restrict != 'all':
-            raise ValueError('param restrict not one of "all", "local",'
-                             ' "remote": %r' % (restrict,))
-        local_extra, remote_extra = graph.find_difference(
-            local_revision_id, remote_revision_id)
-    # Now that we have unique ancestors, compute just the mainline, and
-    # generate revnos for them.
-    local_mainline = _enumerate_mainline(local_extra, graph, local_revno,
-                                         local_revision_id)
-    remote_mainline = _enumerate_mainline(remote_extra, graph, remote_revno,
-                                          remote_revision_id)
-    return local_mainline, remote_mainline
-
+        ancestry = set()
+    return ancestry
+    
 
 def sorted_revisions(revisions, history_map):
     revisions = [(history_map[r],r) for r in revisions]

=== modified file 'bzrlib/msgeditor.py'
--- bzrlib/msgeditor.py	2008-04-22 09:58:15 +0000
+++ bzrlib/msgeditor.py	2007-10-04 05:35:10 +0000
@@ -25,7 +25,6 @@
 
 import bzrlib
 import bzrlib.config as config
-from bzrlib import osutils
 from bzrlib.errors import BzrError, BadCommitMessageEncoding
 from bzrlib.trace import warning, mutter
 
@@ -61,10 +60,10 @@
             ## mutter("trying editor: %r", (edargs +[filename]))
             x = call(edargs + [filename])
         except OSError, e:
-            # We're searching for an editor, so catch safe errors and continue
-            if e.errno in (errno.ENOENT, ):
-                continue
-            raise
+           # We're searching for an editor, so catch safe errors and continue
+           if e.errno in (errno.ENOENT, ):
+               continue
+           raise
         if x == 0:
             return True
         elif x == 127:
@@ -205,9 +204,8 @@
     """
     import tempfile
     tmp_fileno, msgfilename = tempfile.mkstemp(prefix='bzr_log.',
-                                               dir='.',
+                                               dir=u'.',
                                                text=True)
-    msgfilename = osutils.basename(msgfilename)
     msgfile = os.fdopen(tmp_fileno, 'w')
     try:
         if start_message is not None:

=== modified file 'bzrlib/multiparent.py'
--- bzrlib/multiparent.py	2008-06-11 04:20:16 +0000
+++ bzrlib/multiparent.py	2007-10-04 05:50:44 +0000
@@ -23,7 +23,6 @@
 from StringIO import StringIO
 
 from bzrlib import (
-    errors,
     patiencediff,
     trace,
     ui,
@@ -33,31 +32,16 @@
 from bzrlib.tuned_gzip import GzipFile
 
 
-def topo_iter_keys(vf, keys=None):
-    if keys is None:
-        keys = vf.keys()
-    parents = vf.get_parent_map(keys)
-    return _topo_iter(parents, keys)
-
 def topo_iter(vf, versions=None):
+    seen = set()
+    descendants = {}
     if versions is None:
         versions = vf.versions()
-    parents = vf.get_parent_map(versions)
-    return _topo_iter(parents, versions)
-
-def _topo_iter(parents, versions):
-    seen = set()
-    descendants = {}
     def pending_parents(version):
-        if parents[version] is None:
-            return []
-        return [v for v in parents[version] if v in versions and
+        return [v for v in vf.get_parents(version) if v in versions and
                 v not in seen]
     for version_id in versions:
-        if parents[version_id] is None:
-            # parentless
-            continue
-        for parent_id in parents[version_id]:
+        for parent_id in vf.get_parents(version_id):
             descendants.setdefault(parent_id, []).append(version_id)
     cur = [v for v in versions if len(pending_parents(v)) == 0]
     while len(cur) > 0:
@@ -71,6 +55,7 @@
             yield version_id
             seen.add(version_id)
         cur = next
+    assert len(seen) == len(versions)
 
 
 class MultiParent(object):
@@ -208,8 +193,7 @@
             elif cur_line[0] == '\n':
                 hunks[-1].lines[-1] += '\n'
             else:
-                if not (cur_line[0] == 'c'):
-                    raise AssertionError(cur_line[0])
+                assert cur_line[0] == 'c', cur_line[0]
                 parent, parent_pos, child_pos, num_lines =\
                     [int(v) for v in cur_line.split(' ')[1:]]
                 hunks.append(ParentText(parent, parent_pos, child_pos,
@@ -384,8 +368,7 @@
         :param single_parent: If true, omit all but one parent text, (but
             retain parent metadata).
         """
-        if not (no_cache or not verify):
-            raise ValueError()
+        assert no_cache or not verify
         revisions = set(vf.versions())
         total = len(revisions)
         pb = ui.ui_factory.nested_progress_bar()
@@ -397,7 +380,7 @@
                     if [p for p in parents if p not in self._parents] != []:
                         continue
                     lines = [a + ' ' + l for a, l in
-                             vf.annotate(revision)]
+                             vf.annotate_iter(revision)]
                     if snapshots is None:
                         force_snapshot = None
                     else:
@@ -409,8 +392,7 @@
                         self.clear_cache()
                         vf.clear_cache()
                         if verify:
-                            if not (lines == self.get_line_list([revision])[0]):
-                                raise AssertionError()
+                            assert lines == self.get_line_list([revision])[0]
                             self.clear_cache()
                     pb.update('Importing revisions',
                               (total - len(revisions)) + len(added), total)
@@ -526,10 +508,7 @@
         self._parents[version_id] = parent_ids
 
     def get_diff(self, version_id):
-        try:
-            return self._diffs[version_id]
-        except KeyError:
-            raise errors.RevisionNotPresent(version_id, self)
+        return self._diffs[version_id]
 
     def destroy(self):
         self._diffs = {}

=== modified file 'bzrlib/mutabletree.py'
--- bzrlib/mutabletree.py	2008-05-08 04:33:38 +0000
+++ bzrlib/mutabletree.py	2007-10-12 08:00:07 +0000
@@ -27,7 +27,6 @@
 from bzrlib import (
     add,
     bzrdir,
-    hooks,
     )
 from bzrlib.osutils import dirname
 from bzrlib.revisiontree import RevisionTree
@@ -96,12 +95,8 @@
         TODO: Perhaps callback with the ids and paths as they're added.
         """
         if isinstance(files, basestring):
-            # XXX: Passing a single string is inconsistent and should be
-            # deprecated.
-            if not (ids is None or isinstance(ids, basestring)):
-                raise AssertionError()
-            if not (kinds is None or isinstance(kinds, basestring)):
-                raise AssertionError()
+            assert(ids is None or isinstance(ids, basestring))
+            assert(kinds is None or isinstance(kinds, basestring))
             files = [files]
             if ids is not None:
                 ids = [ids]
@@ -113,12 +108,11 @@
         if ids is None:
             ids = [None] * len(files)
         else:
-            if not (len(ids) == len(files)):
-                raise AssertionError()
+            assert(len(ids) == len(files))
         if kinds is None:
             kinds = [None] * len(files)
-        elif not len(kinds) == len(files):
-            raise AssertionError()
+        else:
+            assert(len(kinds) == len(files))
         for f in files:
             # generic constraint checks:
             if self.is_control_filename(f):
@@ -185,14 +179,10 @@
             revprops['branch-nick'] = self.branch.nick
         author = kwargs.pop('author', None)
         if author is not None:
-            if 'author' in revprops:
-                # XXX: maybe we should just accept one of them?
-                raise AssertionError('author property given twice')
+            assert 'author' not in revprops
             revprops['author'] = author
         # args for wt.commit start at message from the Commit.commit method,
         args = (message, ) + args
-        for hook in MutableTree.hooks['start_commit']:
-            hook(self)
         committed_id = commit.Commit().commit(working_tree=self,
             revprops=revprops, *args, **kwargs)
         return committed_id
@@ -247,19 +237,6 @@
         """
         raise NotImplementedError(self.mkdir)
 
-    @needs_write_lock
-    def put_file_bytes_non_atomic(self, file_id, bytes):
-        """Update the content of a file in the tree.
-        
-        Note that the file is written in-place rather than being
-        written to a temporary location and renamed. As a consequence,
-        readers can potentially see the file half-written.
-
-        :param file_id: file-id of the file
-        :param bytes: the new file contents
-        """
-        raise NotImplementedError(self.put_file_bytes_non_atomic)
-
     def set_parent_ids(self, revision_ids, allow_leftmost_as_ghost=False):
         """Set the parents ids of the working tree.
 
@@ -296,6 +273,7 @@
         # not in an inner loop; and we want to remove direct use of this,
         # so here as a reminder for now. RBC 20070703
         from bzrlib.inventory import InventoryEntry
+        assert isinstance(recurse, bool)
         if action is None:
             action = add.AddAction()
         
@@ -459,13 +437,6 @@
         inventory for the parent new_revid, and all other parent trees are
         discarded.
 
-        All the changes in the delta should be changes synchronising the basis
-        tree with some or all of the working tree, with a change to a directory
-        requiring that its contents have been recursively included. That is,
-        this is not a general purpose tree modification routine, but a helper
-        for commit which is not required to handle situations that do not arise
-        outside of commit.
-
         :param new_revid: The new revision id for the trees parent.
         :param delta: An inventory delta (see apply_inventory_delta) describing
             the changes from the current left most parent revision to new_revid.
@@ -488,24 +459,6 @@
         self.set_parent_trees([(new_revid, rev_tree)])
 
 
-class MutableTreeHooks(hooks.Hooks):
-    """A dictionary mapping a hook name to a list of callables for mutabletree 
-    hooks.
-    """
-
-    def __init__(self):
-        """Create the default hooks.
-
-        """
-        hooks.Hooks.__init__(self)
-        # Invoked before a commit is done in a tree. New in 1.4
-        self['start_commit'] = []
-
-
-# install the default hooks into the MutableTree class.
-MutableTree.hooks = MutableTreeHooks()
-
-
 class _FastPath(object):
     """A path object with fast accessors for things like basename."""
 

=== modified file 'bzrlib/option.py'
--- bzrlib/option.py	2008-08-31 19:39:01 +0000
+++ bzrlib/option.py	2007-09-03 01:50:29 +0000
@@ -17,21 +17,22 @@
 # TODO: For things like --diff-prefix, we want a way to customize the display
 # of the option argument.
 
-import optparse
 import re
 
 from bzrlib.lazy_import import lazy_import
 lazy_import(globals(), """
+import optparse
+
 from bzrlib import (
     errors,
+    log,
+    registry,
     revisionspec,
+    symbol_versioning,
     )
 """)
+from bzrlib.trace import warning
 
-from bzrlib import (
-    log,
-    registry,
-    )
 
 def _parse_revision_str(revstr):
     """This handles a revision string -> revno.
@@ -179,13 +180,12 @@
         self.type = type
         self._short_name = short_name
         if type is None:
-            if argname:
-                raise ValueError('argname not valid for booleans')
+            assert argname is None
         elif argname is None:
             argname = 'ARG'
         self.argname = argname
         if param_name is None:
-            self._param_name = self.name.replace('-', '_')
+            self._param_name = self.name
         else:
             self._param_name = param_name
         self.custom_callback = custom_callback
@@ -210,22 +210,22 @@
             option_strings.append('-%s' % short_name)
         optargfn = self.type
         if optargfn is None:
-            parser.add_option(action='callback',
-                              callback=self._optparse_bool_callback,
+            parser.add_option(action='callback', 
+                              callback=self._optparse_bool_callback, 
                               callback_args=(True,),
                               help=self.help,
                               *option_strings)
             negation_strings = ['--%s' % self.get_negation_name()]
-            parser.add_option(action='callback',
-                              callback=self._optparse_bool_callback,
+            parser.add_option(action='callback', 
+                              callback=self._optparse_bool_callback, 
                               callback_args=(False,),
                               help=optparse.SUPPRESS_HELP, *negation_strings)
         else:
-            parser.add_option(action='callback',
-                              callback=self._optparse_callback,
+            parser.add_option(action='callback', 
+                              callback=self._optparse_callback, 
                               type='string', metavar=self.argname.upper(),
                               help=self.help,
-                              default=OptionParser.DEFAULT_VALUE,
+                              default=OptionParser.DEFAULT_VALUE, 
                               *option_strings)
 
     def _optparse_bool_callback(self, option, opt_str, value, parser, bool_v):
@@ -345,10 +345,6 @@
         for name, switch_help in kwargs.iteritems():
             name = name.replace('_', '-')
             reg.register(name, name, help=switch_help)
-            if not value_switches:
-                help = help + '  "' + name + '": ' + switch_help
-                if not help.endswith("."):
-                    help = help + "."
         return RegistryOption(name_, help, reg, title=title,
             value_switches=value_switches, enum_switch=enum_switch)
 
@@ -478,8 +474,6 @@
                                    "Merge using external diff3")
 _merge_type_registry.register_lazy('weave', 'bzrlib.merge', 'WeaveMerger',
                                    "Weave-based merge")
-_merge_type_registry.register_lazy('lca', 'bzrlib.merge', 'LCAMerger',
-                                   "LCA-newness merge")
 
 # Declare the standard options
 _standard_option('help', short_name='h',

=== modified file 'bzrlib/osutils.py'
--- bzrlib/osutils.py	2008-09-03 20:00:51 +0000
+++ bzrlib/osutils.py	2007-10-22 15:54:47 +0000
@@ -53,7 +53,6 @@
     )
 """)
 
-
 import bzrlib
 from bzrlib import symbol_versioning
 from bzrlib.symbol_versioning import (
@@ -69,17 +68,20 @@
 # OR with 0 on those platforms
 O_BINARY = getattr(os, 'O_BINARY', 0)
 
+# On posix, use lstat instead of stat so that we can
+# operate on broken symlinks. On Windows revert to stat.
+lstat = getattr(os, 'lstat', os.stat)
 
 def make_readonly(filename):
     """Make a filename read-only."""
-    mod = os.lstat(filename).st_mode
+    mod = lstat(filename).st_mode
     if not stat.S_ISLNK(mod):
         mod = mod & 0777555
         os.chmod(filename, mod)
 
 
 def make_writable(filename):
-    mod = os.lstat(filename).st_mode
+    mod = lstat(filename).st_mode
     if not stat.S_ISLNK(mod):
         mod = mod | 0200
         os.chmod(filename, mod)
@@ -149,7 +151,7 @@
     try:
         return _mapper(_lstat(f).st_mode)
     except OSError, e:
-        if getattr(e, 'errno', None) in (errno.ENOENT, errno.ENOTDIR):
+        if getattr(e, 'errno', None) == errno.ENOENT:
             raise errors.NoSuchFile(f)
         raise
 
@@ -234,17 +236,10 @@
 
     success = False
     try:
-        try:
-            # This may throw an exception, in which case success will
-            # not be set.
-            rename_func(old, new)
-            success = True
-        except (IOError, OSError), e:
-            # source and target may be aliases of each other (e.g. on a
-            # case-insensitive filesystem), so we may have accidentally renamed
-            # source by when we tried to rename target
-            if not (file_existed and e.errno in (None, errno.ENOENT)):
-                raise
+        # This may throw an exception, in which case success will
+        # not be set.
+        rename_func(old, new)
+        success = True
     finally:
         if file_existed:
             # If the file used to exist, rename it back into place
@@ -360,7 +355,7 @@
 
 
 def _mac_getcwd():
-    return unicodedata.normalize('NFC', os.getcwdu())
+    return unicodedata.normalize('NFKC', os.getcwdu())
 
 
 # Default is to just use the python builtins, but these can be rebound on
@@ -468,6 +463,34 @@
         return pathjoin(F(p), e)
 
 
+def backup_file(fn):
+    """Copy a file to a backup.
+
+    Backups are named in GNU-style, with a ~ suffix.
+
+    If the file is already a backup, it's not copied.
+    """
+    if fn[-1] == '~':
+        return
+    bfn = fn + '~'
+
+    if has_symlinks() and os.path.islink(fn):
+        target = os.readlink(fn)
+        os.symlink(target, bfn)
+        return
+    inf = file(fn, 'rb')
+    try:
+        content = inf.read()
+    finally:
+        inf.close()
+    
+    outf = file(bfn, 'wb')
+    try:
+        outf.write(content)
+    finally:
+        outf.close()
+
+
 def isdir(f):
     """True if f is an accessible directory."""
     try:
@@ -530,63 +553,22 @@
     return False
 
 
-def pumpfile(from_file, to_file, read_length=-1, buff_size=32768):
+def pumpfile(fromfile, tofile):
     """Copy contents of one file to another.
-
-    The read_length can either be -1 to read to end-of-file (EOF) or
-    it can specify the maximum number of bytes to read.
-
-    The buff_size represents the maximum size for each read operation
-    performed on from_file.
-
+    
     :return: The number of bytes copied.
     """
+    BUFSIZE = 32768
     length = 0
-    if read_length >= 0:
-        # read specified number of bytes
-
-        while read_length > 0:
-            num_bytes_to_read = min(read_length, buff_size)
-
-            block = from_file.read(num_bytes_to_read)
-            if not block:
-                # EOF reached
-                break
-            to_file.write(block)
-
-            actual_bytes_read = len(block)
-            read_length -= actual_bytes_read
-            length += actual_bytes_read
-    else:
-        # read to EOF
-        while True:
-            block = from_file.read(buff_size)
-            if not block:
-                # EOF reached
-                break
-            to_file.write(block)
-            length += len(block)
+    while True:
+        b = fromfile.read(BUFSIZE)
+        if not b:
+            break
+        tofile.write(b)
+        length += len(b)
     return length
 
 
-def pump_string_file(bytes, file_handle, segment_size=None):
-    """Write bytes to file_handle in many smaller writes.
-
-    :param bytes: The string to write.
-    :param file_handle: The file to write to.
-    """
-    # Write data in chunks rather than all at once, because very large
-    # writes fail on some platforms (e.g. Windows with SMB  mounted
-    # drives).
-    if not segment_size:
-        segment_size = 5242880 # 5MB
-    segments = range(len(bytes) / segment_size + 1)
-    write = file_handle.write
-    for segment_index in segments:
-        segment = buffer(bytes, segment_index * segment_size, segment_size)
-        write(segment)
-
-
 def file_iterator(input_file, readsize=32768):
     while True:
         b = input_file.read(readsize)
@@ -596,10 +578,8 @@
 
 
 def sha_file(f):
-    """Calculate the hexdigest of an open file.
-
-    The file cursor should be already at the start.
-    """
+    if getattr(f, 'tell', None) is not None:
+        assert f.tell() == 0
     s = sha.new()
     BUFSIZE = 128<<10
     while True:
@@ -660,7 +640,6 @@
     offset = datetime.fromtimestamp(t) - datetime.utcfromtimestamp(t)
     return offset.days * 86400 + offset.seconds
 
-weekdays = ['Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat', 'Sun']
     
 def format_date(t, offset=0, timezone='original', date_fmt=None,
                 show_offset=True):
@@ -685,15 +664,14 @@
         tt = time.localtime(t)
         offset = local_time_offset(t)
     else:
-        raise errors.UnsupportedTimezoneFormat(timezone)
+        raise errors.BzrError("unsupported timezone format %r" % timezone,
+                              ['options are "utc", "original", "local"'])
     if date_fmt is None:
         date_fmt = "%a %Y-%m-%d %H:%M:%S"
     if show_offset:
         offset_str = ' %+03d%02d' % (offset / 3600, (offset / 60) % 60)
     else:
         offset_str = ''
-    # day of week depends on locale, so we do this ourself
-    date_fmt = date_fmt.replace('%a', weekdays[tt[6]])
     return (time.strftime(date_fmt, tt) +  offset_str)
 
 
@@ -796,6 +774,8 @@
 
 def splitpath(p):
     """Turn string into list of parts."""
+    assert isinstance(p, basestring)
+
     # split on either delimiter because people might use either on
     # Windows
     ps = re.split(r'[\\/]', p)
@@ -811,6 +791,7 @@
     return rps
 
 def joinpath(p):
+    assert isinstance(p, (list, tuple))
     for f in p:
         if (f == '..') or (f is None) or (f == ''):
             raise errors.BzrError("sorry, %r not allowed in path" % f)
@@ -863,18 +844,6 @@
         return False
 
 
-def has_hardlinks():
-    if getattr(os, 'link', None) is not None:
-        return True
-    else:
-        return False
-
-
-def host_os_dereferences_symlinks():
-    return (has_symlinks()
-            and sys.platform not in ('cygwin', 'win32'))
-
-
 def contains_whitespace(s):
     """True if there are any whitespace characters in s."""
     # string.whitespace can include '\xa0' in certain locales, because it is
@@ -915,10 +884,9 @@
     avoids that problem.
     """
 
-    if len(base) < MIN_ABS_PATHLENGTH:
-        # must have space for e.g. a drive letter
-        raise ValueError('%r is too short to calculate a relative path'
-            % (base,))
+    assert len(base) >= MIN_ABS_PATHLENGTH, ('Length of base must be equal or'
+        ' exceed the platform minimum length (which is %d)' % 
+        MIN_ABS_PATHLENGTH)
 
     rp = abspath(path)
 
@@ -1041,20 +1009,20 @@
     On platforms where the system does not normalize filenames 
     (Windows, Linux), you have to access a file by its exact path.
 
-    Internally, bzr only supports NFC normalization, since that is 
+    Internally, bzr only supports NFC/NFKC normalization, since that is 
     the standard for XML documents.
 
     So return the normalized path, and a flag indicating if the file
     can be accessed by that path.
     """
 
-    return unicodedata.normalize('NFC', unicode(path)), True
+    return unicodedata.normalize('NFKC', unicode(path)), True
 
 
 def _inaccessible_normalized_filename(path):
     __doc__ = _accessible_normalized_filename.__doc__
 
-    normalized = unicodedata.normalize('NFC', unicode(path))
+    normalized = unicodedata.normalize('NFKC', unicode(path))
     return normalized, normalized == path
 
 
@@ -1137,34 +1105,6 @@
         raise errors.IllegalPath(path)
 
 
-_WIN32_ERROR_DIRECTORY = 267 # Similar to errno.ENOTDIR
-
-def _is_error_enotdir(e):
-    """Check if this exception represents ENOTDIR.
-
-    Unfortunately, python is very inconsistent about the exception
-    here. The cases are:
-      1) Linux, Mac OSX all versions seem to set errno == ENOTDIR
-      2) Windows, Python2.4, uses errno == ERROR_DIRECTORY (267)
-         which is the windows error code.
-      3) Windows, Python2.5 uses errno == EINVAL and
-         winerror == ERROR_DIRECTORY
-
-    :param e: An Exception object (expected to be OSError with an errno
-        attribute, but we should be able to cope with anything)
-    :return: True if this represents an ENOTDIR error. False otherwise.
-    """
-    en = getattr(e, 'errno', None)
-    if (en == errno.ENOTDIR
-        or (sys.platform == 'win32'
-            and (en == _WIN32_ERROR_DIRECTORY
-                 or (en == errno.EINVAL
-                     and getattr(e, 'winerror', None) == _WIN32_ERROR_DIRECTORY)
-        ))):
-        return True
-    return False
-
-
 def walkdirs(top, prefix=""):
     """Yield data about all the directories in a tree.
     
@@ -1214,25 +1154,17 @@
 
         dirblock = []
         append = dirblock.append
-        try:
-            names = sorted(_listdir(top))
-        except OSError, e:
-            if not _is_error_enotdir(e):
-                raise
-        else:
-            for name in names:
-                abspath = top_slash + name
-                statvalue = _lstat(abspath)
-                kind = _kind_from_mode(statvalue.st_mode & 0170000, 'unknown')
-                append((relprefix + name, name, kind, statvalue, abspath))
+        for name in sorted(_listdir(top)):
+            abspath = top_slash + name
+            statvalue = _lstat(abspath)
+            kind = _kind_from_mode(statvalue.st_mode & 0170000, 'unknown')
+            append((relprefix + name, name, kind, statvalue, abspath))
         yield (relroot, top), dirblock
 
         # push the user specified dirs from dirblock
         pending.extend(d for d in reversed(dirblock) if d[2] == _directory)
 
 
-_real_walkdirs_utf8 = None
-
 def _walkdirs_utf8(top, prefix=""):
     """Yield data about all the directories in a tree.
 
@@ -1247,27 +1179,12 @@
         path-from-top might be unicode or utf8, but it is the correct path to
         pass to os functions to affect the file in question. (such as os.lstat)
     """
-    global _real_walkdirs_utf8
-    if _real_walkdirs_utf8 is None:
-        fs_encoding = _fs_enc.upper()
-        if win32utils.winver == 'Windows NT':
-            # Win98 doesn't have unicode apis like FindFirstFileW
-            # TODO: We possibly could support Win98 by falling back to the
-            #       original FindFirstFile, and using TCHAR instead of WCHAR,
-            #       but that gets a bit tricky, and requires custom compiling
-            #       for win98 anyway.
-            try:
-                from bzrlib._walkdirs_win32 import _walkdirs_utf8_win32_find_file
-            except ImportError:
-                _real_walkdirs_utf8 = _walkdirs_unicode_to_utf8
-            else:
-                _real_walkdirs_utf8 = _walkdirs_utf8_win32_find_file
-        elif fs_encoding not in ('UTF-8', 'US-ASCII', 'ANSI_X3.4-1968'):
-            # ANSI_X3.4-1968 is a form of ASCII
-            _real_walkdirs_utf8 = _walkdirs_unicode_to_utf8
-        else:
-            _real_walkdirs_utf8 = _walkdirs_fs_utf8
-    return _real_walkdirs_utf8(top, prefix=prefix)
+    fs_encoding = _fs_enc.upper()
+    if (sys.platform == 'win32' or
+        fs_encoding not in ('UTF-8', 'US-ASCII', 'ANSI_X3.4-1968')): # ascii
+        return _walkdirs_unicode_to_utf8(top, prefix=prefix)
+    else:
+        return _walkdirs_fs_utf8(top, prefix=prefix)
 
 
 def _walkdirs_fs_utf8(top, prefix=""):
@@ -1278,8 +1195,7 @@
     """
     _lstat = os.lstat
     _directory = _directory_kind
-    # Use C accelerated directory listing.
-    _listdir = _read_dir
+    _listdir = os.listdir
     _kind_from_mode = _formats.get
 
     # 0 - relpath, 1- basename, 2- kind, 3- stat, 4-toppath
@@ -1295,13 +1211,11 @@
 
         dirblock = []
         append = dirblock.append
-        # read_dir supplies in should-stat order.
-        for _, name in sorted(_listdir(top)):
+        for name in sorted(_listdir(top)):
             abspath = top_slash + name
             statvalue = _lstat(abspath)
             kind = _kind_from_mode(statvalue.st_mode & 0170000, 'unknown')
             append((relprefix + name, name, kind, statvalue, abspath))
-        dirblock.sort()
         yield (relroot, top), dirblock
 
         # push the user specified dirs from dirblock
@@ -1448,9 +1362,7 @@
     # Windows returns 'cp0' to indicate there is no code page. So we'll just
     # treat that as ASCII, and not support printing unicode characters to the
     # console.
-    #
-    # For python scripts run under vim, we get '', so also treat that as ASCII
-    if user_encoding in (None, 'cp0', ''):
+    if user_encoding in (None, 'cp0'):
         user_encoding = 'ascii'
     else:
         # check encoding
@@ -1470,20 +1382,6 @@
     return user_encoding
 
 
-def get_host_name():
-    """Return the current unicode host name.
-
-    This is meant to be used in place of socket.gethostname() because that
-    behaves inconsistently on different platforms.
-    """
-    if sys.platform == "win32":
-        import win32utils
-        return win32utils.get_host_name()
-    else:
-        import socket
-        return socket.gethostname().decode(get_user_encoding())
-
-
 def recv_all(socket, bytes):
     """Receive an exact number of bytes.
 
@@ -1502,18 +1400,6 @@
         b += new
     return b
 
-
-def send_all(socket, bytes):
-    """Send all bytes on a socket.
-
-    Regular socket.sendall() can give socket error 10053 on Windows.  This
-    implementation sends no more than 64k at a time, which avoids this problem.
-    """
-    chunk_size = 2**16
-    for pos in xrange(0, len(bytes), chunk_size):
-        socket.sendall(bytes[pos:pos+chunk_size])
-
-
 def dereference_path(path):
     """Determine the real path to a file.
 
@@ -1531,38 +1417,3 @@
 def supports_mapi():
     """Return True if we can use MAPI to launch a mail client."""
     return sys.platform == "win32"
-
-
-def resource_string(package, resource_name):
-    """Load a resource from a package and return it as a string.
-
-    Note: Only packages that start with bzrlib are currently supported.
-
-    This is designed to be a lightweight implementation of resource
-    loading in a way which is API compatible with the same API from
-    pkg_resources. See
-    http://peak.telecommunity.com/DevCenter/PkgResources#basic-resource-access.
-    If and when pkg_resources becomes a standard library, this routine
-    can delegate to it.
-    """
-    # Check package name is within bzrlib
-    if package == "bzrlib":
-        resource_relpath = resource_name
-    elif package.startswith("bzrlib."):
-        package = package[len("bzrlib."):].replace('.', os.sep)
-        resource_relpath = pathjoin(package, resource_name)
-    else:
-        raise errors.BzrError('resource package %s not in bzrlib' % package)
-
-    # Map the resource to a file and read its contents
-    base = dirname(bzrlib.__file__)
-    if getattr(sys, 'frozen', None):    # bzr.exe
-        base = abspath(pathjoin(base, '..', '..'))
-    filename = pathjoin(base, resource_relpath)
-    return open(filename, 'rU').read()
-
-
-try:
-    from bzrlib._readdir_pyx import read_dir as _read_dir
-except ImportError:
-    from bzrlib._readdir_py import read_dir as _read_dir

=== modified file 'bzrlib/pack.py'
--- bzrlib/pack.py	2007-11-10 15:09:09 +0000
+++ bzrlib/pack.py	2007-10-05 05:52:45 +0000
@@ -16,8 +16,7 @@
 
 """Container format for Bazaar data.
 
-"Containers" and "records" are described in
-doc/developers/container-format.txt.
+"Containers" and "records" are described in doc/developers/container-format.txt.
 """
 
 from cStringIO import StringIO
@@ -59,54 +58,8 @@
         raise errors.InvalidRecordError(str(e))
 
 
-class ContainerSerialiser(object):
-    """A helper class for serialising containers.
-    
-    It simply returns bytes from method calls to 'begin', 'end' and
-    'bytes_record'.  You may find ContainerWriter to be a more convenient
-    interface.
-    """
-
-    def begin(self):
-        """Return the bytes to begin a container."""
-        return FORMAT_ONE + "\n"
-
-    def end(self):
-        """Return the bytes to finish a container."""
-        return "E"
-
-    def bytes_record(self, bytes, names):
-        """Return the bytes for a Bytes record with the given name and
-        contents.
-        """
-        # Kind marker
-        byte_sections = ["B"]
-        # Length
-        byte_sections.append(str(len(bytes)) + "\n")
-        # Names
-        for name_tuple in names:
-            # Make sure we're writing valid names.  Note that we will leave a
-            # half-written record if a name is bad!
-            for name in name_tuple:
-                _check_name(name)
-            byte_sections.append('\x00'.join(name_tuple) + "\n")
-        # End of headers
-        byte_sections.append("\n")
-        # Finally, the contents.
-        byte_sections.append(bytes)
-        # XXX: This causes a memory copy of bytes in size, but is usually
-        # faster than two write calls (12 vs 13 seconds to output a gig of
-        # 1k records.) - results may differ on significantly larger records
-        # like .iso's but as they should be rare in any case and thus not
-        # likely to be the common case. The biggest issue is causing extreme
-        # memory pressure in that case. One possibly improvement here is to
-        # check the size of the content before deciding to join here vs call
-        # write twice.
-        return ''.join(byte_sections)
-
-
 class ContainerWriter(object):
-    """A class for writing containers to a file.
+    """A class for writing containers.
 
     :attribute records_written: The number of user records added to the
         container. This does not count the prelude or suffix of the container
@@ -122,11 +75,10 @@
         self._write_func = write_func
         self.current_offset = 0
         self.records_written = 0
-        self._serialiser = ContainerSerialiser()
 
     def begin(self):
         """Begin writing a container."""
-        self.write_func(self._serialiser.begin())
+        self.write_func(FORMAT_ONE + "\n")
 
     def write_func(self, bytes):
         self._write_func(bytes)
@@ -134,7 +86,7 @@
 
     def end(self):
         """Finish writing a container."""
-        self.write_func(self._serialiser.end())
+        self.write_func("E")
 
     def add_bytes_record(self, bytes, names):
         """Add a Bytes record with the given names.
@@ -151,8 +103,30 @@
             and thus are only suitable for use by a ContainerReader.
         """
         current_offset = self.current_offset
-        serialised_record = self._serialiser.bytes_record(bytes, names)
-        self.write_func(serialised_record)
+        # Kind marker
+        byte_sections = ["B"]
+        # Length
+        byte_sections.append(str(len(bytes)) + "\n")
+        # Names
+        for name_tuple in names:
+            # Make sure we're writing valid names.  Note that we will leave a
+            # half-written record if a name is bad!
+            for name in name_tuple:
+                _check_name(name)
+            byte_sections.append('\x00'.join(name_tuple) + "\n")
+        # End of headers
+        byte_sections.append("\n")
+        # Finally, the contents.
+        byte_sections.append(bytes)
+        # XXX: This causes a memory copy of bytes in size, but is usually
+        # faster than two write calls (12 vs 13 seconds to output a gig of
+        # 1k records.) - results may differ on significantly larger records
+        # like .iso's but as they should be rare in any case and thus not
+        # likely to be the common case. The biggest issue is causing extreme
+        # memory pressure in that case. One possibly improvement here is to
+        # check the size of the content before deciding to join here vs call
+        # write twice.
+        self.write_func(''.join(byte_sections))
         self.records_written += 1
         # return a memo of where we wrote data to allow random access.
         return current_offset, self.current_offset - current_offset
@@ -381,123 +355,3 @@
                 _check_name_encoding(name)
         read_bytes(None)
 
-
-class ContainerPushParser(object):
-    """A "push" parser for container format 1.
-
-    It accepts bytes via the ``accept_bytes`` method, and parses them into
-    records which can be retrieved via the ``read_pending_records`` method.
-    """
-
-    def __init__(self):
-        self._buffer = ''
-        self._state_handler = self._state_expecting_format_line
-        self._parsed_records = []
-        self._reset_current_record()
-        self.finished = False
-
-    def _reset_current_record(self):
-        self._current_record_length = None
-        self._current_record_names = []
-
-    def accept_bytes(self, bytes):
-        self._buffer += bytes
-        # Keep iterating the state machine until it stops consuming bytes from
-        # the buffer.
-        last_buffer_length = None
-        cur_buffer_length = len(self._buffer)
-        while cur_buffer_length != last_buffer_length:
-            last_buffer_length = cur_buffer_length
-            self._state_handler()
-            cur_buffer_length = len(self._buffer)
-
-    def read_pending_records(self):
-        records = self._parsed_records
-        self._parsed_records = []
-        return records
-    
-    def _consume_line(self):
-        """Take a line out of the buffer, and return the line.
-
-        If a newline byte is not found in the buffer, the buffer is
-        unchanged and this returns None instead.
-        """
-        newline_pos = self._buffer.find('\n')
-        if newline_pos != -1:
-            line = self._buffer[:newline_pos]
-            self._buffer = self._buffer[newline_pos+1:]
-            return line
-        else:
-            return None
-
-    def _state_expecting_format_line(self):
-        line = self._consume_line()
-        if line is not None:
-            if line != FORMAT_ONE:
-                raise errors.UnknownContainerFormatError(line)
-            self._state_handler = self._state_expecting_record_type
-
-    def _state_expecting_record_type(self):
-        if len(self._buffer) >= 1:
-            record_type = self._buffer[0]
-            self._buffer = self._buffer[1:]
-            if record_type == 'B':
-                self._state_handler = self._state_expecting_length
-            elif record_type == 'E':
-                self.finished = True
-                self._state_handler = self._state_expecting_nothing
-            else:
-                raise errors.UnknownRecordTypeError(record_type)
-
-    def _state_expecting_length(self):
-        line = self._consume_line()
-        if line is not None:
-            try:
-                self._current_record_length = int(line)
-            except ValueError:
-                raise errors.InvalidRecordError(
-                    "%r is not a valid length." % (line,))
-            self._state_handler = self._state_expecting_name
-
-    def _state_expecting_name(self):
-        encoded_name_parts = self._consume_line()
-        if encoded_name_parts == '':
-            self._state_handler = self._state_expecting_body
-        elif encoded_name_parts:
-            name_parts = tuple(encoded_name_parts.split('\x00'))
-            for name_part in name_parts:
-                _check_name(name_part)
-            self._current_record_names.append(name_parts)
-            
-    def _state_expecting_body(self):
-        if len(self._buffer) >= self._current_record_length:
-            body_bytes = self._buffer[:self._current_record_length]
-            self._buffer = self._buffer[self._current_record_length:]
-            record = (self._current_record_names, body_bytes)
-            self._parsed_records.append(record)
-            self._reset_current_record()
-            self._state_handler = self._state_expecting_record_type
-
-    def _state_expecting_nothing(self):
-        pass
-
-    def read_size_hint(self):
-        hint = 16384
-        if self._state_handler == self._state_expecting_body:
-            remaining = self._current_record_length - len(self._buffer)
-            if remaining < 0:
-                remaining = 0
-            return max(hint, remaining)
-        return hint
-
-
-def iter_records_from_file(source_file):
-    parser = ContainerPushParser()
-    while True:
-        bytes = source_file.read(parser.read_size_hint())
-        parser.accept_bytes(bytes)
-        for record in parser.read_pending_records():
-            yield record
-        if parser.finished:
-            break
-

=== modified file 'bzrlib/patches.py'
--- bzrlib/patches.py	2008-04-24 07:22:53 +0000
+++ bzrlib/patches.py	2007-08-17 17:56:35 +0000
@@ -220,6 +220,7 @@
             return self.shift_to_mod_lines(pos)
 
     def shift_to_mod_lines(self, pos):
+        assert (pos >= self.orig_pos-1 and pos <= self.orig_pos+self.orig_range)
         position = self.orig_pos-1
         shift = 0
         for line in self.lines:
@@ -354,8 +355,7 @@
     last_line = None
     for line in iter_lines:
         if line == NO_NL:
-            if not last_line.endswith('\n'):
-                raise AssertionError()
+            assert last_line.endswith('\n')
             last_line = last_line[:-1]
             line = None
         if last_line is not None:
@@ -415,8 +415,7 @@
                 if isinstance(hunk_line, ContextLine):
                     yield orig_line
                 else:
-                    if not isinstance(hunk_line, RemoveLine):
-                        raise AssertionError(hunk_line)
+                    assert isinstance(hunk_line, RemoveLine)
                 line_no += 1
     if orig_lines is not None:
         for line in orig_lines:

=== modified file 'bzrlib/plugin.py'
--- bzrlib/plugin.py	2008-08-14 03:00:08 +0000
+++ bzrlib/plugin.py	2007-08-29 01:50:37 +0000
@@ -20,10 +20,9 @@
 When load_plugins() is invoked, any python module in any directory in
 $BZR_PLUGIN_PATH will be imported.  The module will be imported as
 'bzrlib.plugins.$BASENAME(PLUGIN)'.  In the plugin's main body, it should
-update any bzrlib registries it wants to extend.
-
-See the plugin-api developer documentation for information about writing
-plugins.
+update any bzrlib registries it wants to extend; for example, to add new
+commands, import bzrlib.commands and add your new command to the plugin_cmds
+variable.
 
 BZR_PLUGIN_PATH is also honoured for any plugins imported via
 'import bzrlib.plugins.PLUGINNAME', as long as set_plugins_path has been 
@@ -42,14 +41,12 @@
 
 from bzrlib import (
     config,
-    debug,
     osutils,
-    trace,
     )
 from bzrlib import plugins as _mod_plugins
 """)
 
-from bzrlib.symbol_versioning import deprecated_function, one_three
+from bzrlib.symbol_versioning import deprecated_function, zero_ninetyone
 from bzrlib.trace import mutter, warning, log_exception_quietly
 
 
@@ -64,6 +61,12 @@
     return DEFAULT_PLUGIN_PATH
 
 
+@deprecated_function(zero_ninetyone)
+def all_plugins():
+    """Return a dictionary of the plugins."""
+    return dict((name, plugin.module) for name, plugin in plugins().items())
+
+
 def disable_plugins():
     """Disable loading plugins.
 
@@ -74,48 +77,18 @@
     global _loaded
     _loaded = True
 
-
 def _strip_trailing_sep(path):
     return path.rstrip("\\/")
 
-
 def set_plugins_path():
     """Set the path for plugins to be loaded from."""
     path = os.environ.get('BZR_PLUGIN_PATH',
                           get_default_plugin_path()).split(os.pathsep)
-    bzr_exe = bool(getattr(sys, 'frozen', None))
-    if bzr_exe:    # expand path for bzr.exe
-        # We need to use relative path to system-wide plugin
-        # directory because bzrlib from standalone bzr.exe
-        # could be imported by another standalone program
-        # (e.g. bzr-config; or TortoiseBzr/Olive if/when they
-        # will become standalone exe). [bialix 20071123]
-        # __file__ typically is
-        # C:\Program Files\Bazaar\lib\library.zip\bzrlib\plugin.pyc
-        # then plugins directory is
-        # C:\Program Files\Bazaar\plugins
-        # so relative path is ../../../plugins
-        path.append(osutils.abspath(osutils.pathjoin(
-            osutils.dirname(__file__), '../../../plugins')))
     # Get rid of trailing slashes, since Python can't handle them when
     # it tries to import modules.
     path = map(_strip_trailing_sep, path)
-    if not bzr_exe:     # don't look inside library.zip
-        # search the plugin path before the bzrlib installed dir
-        path.append(os.path.dirname(_mod_plugins.__file__))
-    # search the arch independent path if we can determine that and
-    # the plugin is found nowhere else
-    if sys.platform != 'win32':
-        try:
-            from distutils.sysconfig import get_python_lib
-        except ImportError:
-            # If distutuils is not available, we just won't add that path
-            pass
-        else:
-            archless_path = osutils.pathjoin(get_python_lib(), 'bzrlib',
-                    'plugins')
-            if archless_path not in path:
-                path.append(archless_path)
+    # search the plugin path before the bzrlib installed dir
+    path.append(os.path.dirname(_mod_plugins.__file__))
     _mod_plugins.__path__ = path
     return path
 
@@ -165,6 +138,10 @@
         mutter('looking for plugins in %s', d)
         if os.path.isdir(d):
             load_from_dir(d)
+        else:
+            # it might be a zip: try loading from the zip.
+            load_from_zip(d)
+            continue
 
 
 # backwards compatability: load_from_dirs was the old name
@@ -214,24 +191,18 @@
         except Exception, e:
             ## import pdb; pdb.set_trace()
             if re.search('\.|-| ', name):
-                sanitised_name = re.sub('[-. ]', '_', name)
-                if sanitised_name.startswith('bzr_'):
-                    sanitised_name = sanitised_name[len('bzr_'):]
-                warning("Unable to load %r in %r as a plugin because the "
-                        "file path isn't a valid module name; try renaming "
-                        "it to %r." % (name, d, sanitised_name))
+                warning('Unable to load plugin %r from %r: '
+                    'It is not a valid python module name.' % (name, d))
             else:
                 warning('Unable to load plugin %r from %r' % (name, d))
             log_exception_quietly()
-            if 'error' in debug.debug_flags:
-                trace.print_exception(sys.exc_info(), sys.stderr)
-
-
-@deprecated_function(one_three)
+
+
 def load_from_zip(zip_name):
     """Load all the plugins in a zip."""
     valid_suffixes = ('.py', '.pyc', '.pyo')    # only python modules/packages
                                                 # is allowed
+
     try:
         index = zip_name.rindex('.zip')
     except ValueError:
@@ -304,8 +275,6 @@
             warning('Unable to load plugin %r from %r'
                     % (name, zip_name))
             log_exception_quietly()
-            if 'error' in debug.debug_flags:
-                trace.print_exception(sys.exc_info(), sys.stderr)
 
 
 def plugins():
@@ -404,12 +373,7 @@
         if getattr(self.module, '__path__', None) is not None:
             return os.path.abspath(self.module.__path__[0])
         elif getattr(self.module, '__file__', None) is not None:
-            path = os.path.abspath(self.module.__file__)
-            if path[-4:] in ('.pyc', '.pyo'):
-                pypath = path[:-4] + '.py'
-                if os.path.isfile(pypath):
-                    path = pypath
-            return path
+            return os.path.abspath(self.module.__file__)
         else:
             return repr(self.module)
 
@@ -427,25 +391,13 @@
         else:
             return None
 
-    def load_plugin_tests(self, loader):
-        """Return the adapted plugin's test suite.
-
-        :param loader: The custom loader that should be used to load additional
-            tests.
-
-        """
-        if getattr(self.module, 'load_tests', None) is not None:
-            return loader.loadTestsFromModule(self.module)
-        else:
-            return None
-
     def version_info(self):
         """Return the plugin's version_tuple or None if unknown."""
         version_info = getattr(self.module, 'version_info', None)
         if version_info is not None and len(version_info) == 3:
             version_info = tuple(version_info) + ('final', 0)
         return version_info
-
+    
     def _get__version__(self):
         version_info = self.version_info()
         if version_info is None:

=== modified file 'bzrlib/plugins/launchpad/__init__.py'
--- bzrlib/plugins/launchpad/__init__.py	2008-03-06 21:16:38 +0000
+++ bzrlib/plugins/launchpad/__init__.py	2007-07-11 03:20:03 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006 - 2008 Canonical Ltd
+# Copyright (C) 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -14,17 +14,19 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-"""Launchpad.net integration plugin for Bazaar."""
+"""Launchpad.net integration plugin for Bazaar
+
+To install this file, put the 'bzr_lp' directory, or a symlink to it,
+in your ~/.bazaar/plugins/ directory.
+"""
 
 # The XMLRPC server address can be overridden by setting the environment
 # variable $BZR_LP_XMLRPL_URL
 
 # see http://bazaar-vcs.org/Specs/BranchRegistrationTool
 
-from bzrlib.branch import Branch
 from bzrlib.commands import Command, Option, register_command
-from bzrlib.directory_service import directories
-from bzrlib.errors import BzrCommandError, NoPublicBranch, NotBranchError
+from bzrlib.transport import register_lazy_transport
 from bzrlib.help_topics import topic_registry
 
 
@@ -39,19 +41,15 @@
     branch belongs, and create an account for yourself on launchpad.net.
 
     arguments:
-        public_url: The publicly visible url for the branch to register.
-                    This must be an http or https url (which Launchpad can read
-                    from to access the branch). Local file urls, SFTP urls, and
-                    bzr+ssh urls will not work.
-                    If no public_url is provided, bzr will use the configured
-                    public_url if there is one for the current branch, and
-                    otherwise error.
+        branch_url: The publicly visible url for the branch.
+                    This must be an http or https url, not a local file
+                    path.
 
     example:
         bzr register-branch http://foo.com/bzr/fooproduct.mine \\
                 --product fooproduct
     """
-    takes_args = ['public_url?']
+    takes_args = ['branch_url']
     takes_options = [
          Option('product',
                 'Launchpad product short name to associate with the branch.',
@@ -77,8 +75,8 @@
         ]
 
 
-    def run(self,
-            public_url=None,
+    def run(self, 
+            branch_url, 
             product='',
             branch_name='',
             branch_title='',
@@ -86,27 +84,17 @@
             author='',
             link_bug=None,
             dry_run=False):
-        from bzrlib.plugins.launchpad.lp_registration import (
+        from lp_registration import (
             LaunchpadService, BranchRegistrationRequest, BranchBugLinkRequest,
             DryRunLaunchpadService)
-        if public_url is None:
-            try:
-                b = Branch.open_containing('.')[0]
-            except NotBranchError:
-                raise BzrCommandError('register-branch requires a public '
-                    'branch url - see bzr help register-branch.')
-            public_url = b.get_public_branch()
-            if public_url is None:
-                raise NoPublicBranch(b)
-
-        rego = BranchRegistrationRequest(branch_url=public_url,
+        rego = BranchRegistrationRequest(branch_url=branch_url,
                                          branch_name=branch_name,
                                          branch_title=branch_title,
                                          branch_description=branch_description,
                                          product_name=product,
                                          author_email=author,
                                          )
-        linko = BranchBugLinkRequest(branch_url=public_url,
+        linko = BranchBugLinkRequest(branch_url=branch_url,
                                      bug_id=link_bug)
         if not dry_run:
             service = LaunchpadService()
@@ -126,74 +114,26 @@
 
 register_command(cmd_register_branch)
 
-
-class cmd_launchpad_login(Command):
-    """Show or set the Launchpad user ID.
-
-    When communicating with Launchpad, some commands need to know your
-    Launchpad user ID.  This command can be used to set or show the
-    user ID that Bazaar will use for such communication.
-
-    :Examples:
-      Show the Launchpad ID of the current user::
-
-          bzr launchpad-login
-
-      Set the Launchpad ID of the current user to 'bob'::
-
-          bzr launchpad-login bob
-    """
-    aliases = ['lp-login']
-    takes_args = ['name?']
-    takes_options = [
-        Option('no-check',
-               "Don't check that the user name is valid."),
-        ]
-
-    def run(self, name=None, no_check=False):
-        from bzrlib.plugins.launchpad import account
-        check_account = not no_check
-
-        if name is None:
-            username = account.get_lp_login()
-            if username:
-                if check_account:
-                    account.check_lp_login(username)
-                self.outf.write(username + '\n')
-            else:
-                self.outf.write('No Launchpad user ID configured.\n')
-                return 1
-        else:
-            if check_account:
-                account.check_lp_login(name)
-            account.set_lp_login(name)
-
-register_command(cmd_launchpad_login)
-
-
-def _register_directory():
-    directories.register_lazy('lp:', 'bzrlib.plugins.launchpad.lp_directory',
-                              'LaunchpadDirectory',
-                              'Launchpad-based directory service',)
-_register_directory()
-
+register_lazy_transport(
+    'lp:',
+    'bzrlib.plugins.launchpad.lp_indirect',
+    'launchpad_transport_indirect')
+
+register_lazy_transport(
+    'lp://',
+    'bzrlib.plugins.launchpad.lp_indirect',
+    'launchpad_transport_indirect')
 
 def test_suite():
     """Called by bzrlib to fetch tests for this plugin"""
     from unittest import TestSuite, TestLoader
-    from bzrlib.plugins.launchpad import (
-         test_account, test_lp_directory, test_lp_service, test_register,
-         )
+    import test_register
+    import test_lp_indirect
 
     loader = TestLoader()
     suite = TestSuite()
-    for module in [
-        test_account,
-        test_register,
-        test_lp_directory,
-        test_lp_service,
-        ]:
-        suite.addTests(loader.loadTestsFromModule(module))
+    for m in [test_register, test_lp_indirect]:
+        suite.addTests(loader.loadTestsFromModule(m))
     return suite
 
 _launchpad_help = """Integration with Launchpad.net
@@ -201,22 +141,18 @@
 Launchpad.net provides free Bazaar branch hosting with integrated bug and
 specification tracking.
 
-The bzr client (through the plugin called 'launchpad') has special
+The bzr client (through the plugin called 'launchpad') has two special
 features to communicate with Launchpad:
 
-    * The launchpad-login command tells Bazaar your Launchpad user name. This
-      is then used by the 'lp:' transport to download your branches using
-      bzr+ssh://.
-
-    * The register-branch command tells Launchpad about the url of a
+    * The register-branch command tells launchpad about the url of a 
       public branch.  Launchpad will then mirror the branch, display
-      its contents and allow it to be attached to bugs and other
+      its contents and allow it to be attached to bugs and other 
       objects.
 
-    * The 'lp:' transport uses Launchpad as a directory service: for example
-      'lp:bzr' and 'lp:python' refer to the main branches of the relevant
-      projects and may be branched, logged, etc. You can also use the 'lp:'
-      transport to refer to specific branches, e.g. lp:///~bzr/bzr/trunk.
+    * The 'lp:' transport uses Launchpad as a directory service: 
+      for example 'lp:bzr' and 'lp:python' refer to the main branches of the
+      relevant projects and may be branched, logged, etc.  (Only read access
+      is supported at present.)
 
 For more information see http://help.launchpad.net/
 """

=== removed file 'bzrlib/plugins/launchpad/account.py'
--- bzrlib/plugins/launchpad/account.py	2007-11-12 21:23:07 +0000
+++ bzrlib/plugins/launchpad/account.py	1970-01-01 00:00:00 +0000
@@ -1,70 +0,0 @@
-# Copyright (C) 2007 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Functions to manage the user's Launchpad user ID.
-
-This allows the user to configure their Launchpad user ID once, rather
-than once for each place that needs to take it into account.
-"""
-
-from bzrlib import errors
-from bzrlib.config import GlobalConfig
-from bzrlib.transport import get_transport
-
-
-LAUNCHPAD_BASE = 'https://launchpad.net/'
-
-
-class UnknownLaunchpadUsername(errors.BzrError):
-    _fmt = "The user name %(user)s is not registered on Launchpad."
-
-
-class NoRegisteredSSHKeys(errors.BzrError):
-    _fmt = "The user %(user)s has not registered any SSH keys with Launchpad."
-
-
-def get_lp_login(_config=None):
-    """Return the user's Launchpad username"""
-    if _config is None:
-        _config = GlobalConfig()
-
-    return _config.get_user_option('launchpad_username')
-
-
-def set_lp_login(username, _config=None):
-    """Set the user's Launchpad username"""
-    if _config is None:
-        _config = GlobalConfig()
-
-    _config.set_user_option('launchpad_username', username)
-
-
-def check_lp_login(username, _transport=None):
-    """Check whether the given Launchpad username is okay.
-
-    This will check for both existence and whether the user has
-    uploaded SSH keys.
-    """
-    if _transport is None:
-        _transport = get_transport(LAUNCHPAD_BASE)
-
-    try:
-        data = _transport.get_bytes('~%s/+sshkeys' % username)
-    except errors.NoSuchFile:
-        raise UnknownLaunchpadUsername(user=username)
-
-    if not data:
-        raise NoRegisteredSSHKeys(user=username)

=== renamed file 'bzrlib/plugins/launchpad/lp_directory.py' => 'bzrlib/plugins/launchpad/lp_indirect.py'
--- bzrlib/plugins/launchpad/lp_directory.py	2008-04-18 22:07:16 +0000
+++ bzrlib/plugins/launchpad/lp_indirect.py	2007-01-26 04:44:10 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007, 2008 Canonical Ltd
+# Copyright (C) 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -15,103 +15,31 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 
-"""Directory lookup that uses Launchpad."""
+"""Transport indirection that uses Launchpad as a directory lookup.
 
-from urlparse import urlsplit, urlunsplit
-import xmlrpclib
+When the transport is opened, it immediately redirects to a url
+on Launchpad, which can then either serve the branch itself or redirect
+again.
+"""
 
 from bzrlib import (
-    debug,
     errors,
-    trace,
-    urlutils,
     )
 from bzrlib.transport import (
     get_transport,
-    register_urlparse_netloc_protocol,
+    Transport,
     )
 
-from bzrlib.plugins.launchpad.lp_registration import (
-    LaunchpadService, ResolveLaunchpadPathRequest)
-from bzrlib.plugins.launchpad.account import get_lp_login
-
-
-# As bzrlib.transport.remote may not be loaded yet, make sure bzr+ssh
-# is counted as a netloc protocol.
-register_urlparse_netloc_protocol('bzr+ssh')
-register_urlparse_netloc_protocol('lp')
-
-
-class LaunchpadDirectory(object):
-
-    def _requires_launchpad_login(self, scheme, netloc, path, query,
-                                  fragment):
-        """Does the URL require a Launchpad login in order to be reached?
-
-        The URL is specified by its parsed components, as returned from
-        urlsplit.
-        """
-        return (scheme in ('bzr+ssh', 'sftp')
-                and (netloc.endswith('launchpad.net')
-                     or netloc.endswith('launchpad.dev')))
-
-    def look_up(self, name, url):
-        """See DirectoryService.look_up"""
-        return self._resolve(url)
-
-    def _resolve(self, url,
-                 _request_factory=ResolveLaunchpadPathRequest,
-                 _lp_login=None):
-        """Resolve the base URL for this transport."""
-        result = urlsplit(url)
-        # Perform an XMLRPC request to resolve the path
-        lp_instance = result[1]
-        if lp_instance == '':
-            lp_instance = None
-        elif lp_instance not in LaunchpadService.LAUNCHPAD_INSTANCE:
-            raise errors.InvalidURL(path=url)
-        resolve = _request_factory(result[2].strip('/'))
-        service = LaunchpadService(lp_instance=lp_instance)
-        try:
-            result = resolve.submit(service)
-        except xmlrpclib.Fault, fault:
-            raise errors.InvalidURL(
-                path=url, extra=fault.faultString)
-
-        if 'launchpad' in debug.debug_flags:
-            trace.mutter("resolve_lp_path(%r) == %r", path, result)
-
-        if _lp_login is None:
-            _lp_login = get_lp_login()
-        _warned_login = False
-        for url in result['urls']:
-            scheme, netloc, path, query, fragment = urlsplit(url)
-            if self._requires_launchpad_login(scheme, netloc, path, query,
-                                              fragment):
-                # Only accept launchpad.net bzr+ssh URLs if we know
-                # the user's Launchpad login:
-                if _lp_login is None:
-                    if not _warned_login:
-                        trace.warning('You have not informed bzr of your '
-                                'launchpad login. If you are attempting a\n'
-                                'write operation and it fails, run '
-                                '"bzr launchpad-login YOUR_ID" and try again.')
-                        _warned_login = True
-                    continue
-                url = urlunsplit((scheme, '%s@%s' % (_lp_login, netloc),
-                                  path, query, fragment))
-                break
-            else:
-                # Use the URL if we can create a transport for it.
-                try:
-                    get_transport(url)
-                except (errors.PathError, errors.TransportError):
-                    pass
-                else:
-                    break
-        else:
-            raise errors.InvalidURL(path=url, extra='no supported schemes')
-        return url
+
+def launchpad_transport_indirect(base_url):
+    """Uses Launchpad.net as a directory of open source software"""
+    if base_url.startswith('lp:///'):
+        real_url = 'http://code.launchpad.net/' + base_url[6:]
+    elif base_url.startswith('lp:') and base_url[3] != '/':
+        real_url = 'http://code.launchpad.net/' + base_url[3:]
+    else:
+        raise errors.InvalidURL(path=base_url)
+    return get_transport(real_url)
 
 
 def get_test_permutations():

=== modified file 'bzrlib/plugins/launchpad/lp_registration.py'
--- bzrlib/plugins/launchpad/lp_registration.py	2008-04-24 07:22:53 +0000
+++ bzrlib/plugins/launchpad/lp_registration.py	2007-10-23 14:31:10 +0000
@@ -32,43 +32,23 @@
 export BZR_LP_XMLRPC_URL=http://xmlrpc.staging.launchpad.net/bazaar/
 '''
 
-class InvalidLaunchpadInstance(errors.BzrError):
-
-    _fmt = "%(lp_instance)s is not a valid Launchpad instance."
-
-    def __init__(self, lp_instance):
-        errors.BzrError.__init__(self, lp_instance=lp_instance)
-
-
 class LaunchpadService(object):
     """A service to talk to Launchpad via XMLRPC.
-
+    
     See http://bazaar-vcs.org/Specs/LaunchpadRpc for the methods we can call.
     """
 
-    # NB: these should always end in a slash to avoid xmlrpclib appending
+    # NB: this should always end in a slash to avoid xmlrpclib appending
     # '/RPC2'
-    # We use edge as the default because:
-    # Beta users get redirected to it
-    # All users can use it
-    # There is a bug in the launchpad side where redirection causes an OOPS.
-    LAUNCHPAD_INSTANCE = {
-        'production': 'https://xmlrpc.launchpad.net/bazaar/',
-        'edge': 'https://xmlrpc.edge.launchpad.net/bazaar/',
-        'staging': 'https://xmlrpc.staging.launchpad.net/bazaar/',
-        'demo': 'https://xmlrpc.demo.launchpad.net/bazaar/',
-        'dev': 'http://xmlrpc.launchpad.dev/bazaar/',
-        }
-    DEFAULT_SERVICE_URL = LAUNCHPAD_INSTANCE['edge']
+    DEFAULT_SERVICE_URL = 'https://xmlrpc.launchpad.net/bazaar/'
 
     transport = None
     registrant_email = None
     registrant_password = None
 
 
-    def __init__(self, transport=None, lp_instance=None):
+    def __init__(self, transport=None):
         """Construct a new service talking to the launchpad rpc server"""
-        self._lp_instance = lp_instance
         if transport is None:
             uri_type = urllib.splittype(self.service_url)[0]
             if uri_type == 'https':
@@ -89,46 +69,34 @@
         key = 'BZR_LP_XMLRPC_URL'
         if key in os.environ:
             return os.environ[key]
-        elif self._lp_instance is not None:
-            try:
-                return self.LAUNCHPAD_INSTANCE[self._lp_instance]
-            except KeyError:
-                raise InvalidLaunchpadInstance(self._lp_instance)
         else:
             return self.DEFAULT_SERVICE_URL
 
-    def get_proxy(self, authenticated):
+    def get_proxy(self):
         """Return the proxy for XMLRPC requests."""
-        if authenticated:
-            # auth info must be in url
-            # TODO: if there's no registrant email perhaps we should
-            # just connect anonymously?
-            scheme, hostinfo, path = urlsplit(self.service_url)[:3]
-            if '@' in hostinfo:
-                raise AssertionError(hostinfo)
-            if self.registrant_email is None:
-                raise AssertionError()
-            if self.registrant_password is None:
-                raise AssertionError()
-            # TODO: perhaps fully quote the password to make it very slightly
-            # obscured
-            # TODO: can we perhaps add extra Authorization headers
-            # directly to the request, rather than putting this into
-            # the url?  perhaps a bit more secure against accidentally
-            # revealing it.  std66 s3.2.1 discourages putting the
-            # password in the url.
-            hostinfo = '%s:%s@%s' % (urllib.quote(self.registrant_email),
-                                     urllib.quote(self.registrant_password),
-                                     hostinfo)
-            url = urlunsplit((scheme, hostinfo, path, '', ''))
-        else:
-            url = self.service_url
+        # auth info must be in url
+        # TODO: if there's no registrant email perhaps we should just connect
+        # anonymously?
+        scheme, hostinfo, path = urlsplit(self.service_url)[:3]
+        assert '@' not in hostinfo
+        assert self.registrant_email is not None
+        assert self.registrant_password is not None
+        # TODO: perhaps fully quote the password to make it very slightly
+        # obscured
+        # TODO: can we perhaps add extra Authorization headers directly to the 
+        # request, rather than putting this into the url?  perhaps a bit more 
+        # secure against accidentally revealing it.  std66 s3.2.1 discourages putting
+        # the password in the url.
+        hostinfo = '%s:%s@%s' % (urllib.quote(self.registrant_email),
+                                 urllib.quote(self.registrant_password),
+                                 hostinfo)
+        url = urlunsplit((scheme, hostinfo, path, '', ''))
         return xmlrpclib.ServerProxy(url, transport=self.transport)
 
     def gather_user_credentials(self):
         """Get the password from the user."""
-        the_config = config.GlobalConfig()
-        self.registrant_email = the_config.user_email()
+        config = config.GlobalConfig()
+        self.registrant_email = config.user_email()
         if self.registrant_password is None:
             auth = config.AuthenticationConfig()
             scheme, hostinfo = urlsplit(self.service_url)[:2]
@@ -137,11 +105,11 @@
             # We will reuse http[s] credentials if we can, prompt user
             # otherwise
             self.registrant_password = auth.get_password(scheme, hostinfo,
-                                                         self.registrant_email,
                                                          prompt=prompt)
 
-    def send_request(self, method_name, method_params, authenticated):
-        proxy = self.get_proxy(authenticated)
+    def send_request(self, method_name, method_params):
+        proxy = self.get_proxy()
+        assert method_name
         method = getattr(proxy, method_name)
         try:
             result = method(*method_params)
@@ -166,7 +134,6 @@
 
     # Set this to the XMLRPC method name.
     _methodname = None
-    _authenticated = True
 
     def _request_params(self):
         """Return the arguments to pass to the method"""
@@ -178,8 +145,7 @@
         :param service: LaunchpadService indicating where to send
             the request and the authentication credentials.
         """
-        return service.send_request(self._methodname, self._request_params(),
-                                    self._authenticated)
+        return service.send_request(self._methodname, self._request_params())
 
 
 class DryRunLaunchpadService(LaunchpadService):
@@ -188,7 +154,7 @@
     The dummy service does not need authentication.
     """
 
-    def send_request(self, method_name, method_params, authenticated):
+    def send_request(self, method_name, method_params):
         pass
 
     def gather_user_credentials(self):
@@ -207,8 +173,7 @@
                  author_email='',
                  product_name='',
                  ):
-        if not branch_url:
-            raise errors.InvalidURL(branch_url, "You need to specify a non-empty branch URL.")
+        assert branch_url
         self.branch_url = branch_url
         if branch_name:
             self.branch_name = branch_name
@@ -242,6 +207,7 @@
     _methodname = 'link_branch_to_bug'
 
     def __init__(self, branch_url, bug_id):
+        assert branch_url
         self.bug_id = bug_id
         self.branch_url = branch_url
 
@@ -250,20 +216,3 @@
         # This must match the parameter tuple expected by Launchpad for this
         # method
         return (self.branch_url, self.bug_id, '')
-
-
-class ResolveLaunchpadPathRequest(BaseRequest):
-    """Request to resolve the path component of an lp: URL."""
-
-    _methodname = 'resolve_lp_path'
-    _authenticated = False
-
-    def __init__(self, path):
-        if not path:
-            raise errors.InvalidURL(path=path,
-                                    extra="You must specify a product.")
-        self.path = path
-
-    def _request_params(self):
-        """Return xmlrpc request parameters"""
-        return (self.path,)

=== removed file 'bzrlib/plugins/launchpad/test_account.py'
--- bzrlib/plugins/launchpad/test_account.py	2007-10-18 08:58:19 +0000
+++ bzrlib/plugins/launchpad/test_account.py	1970-01-01 00:00:00 +0000
@@ -1,85 +0,0 @@
-# Copyright (C) 2007 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Tests for Launchpad user ID management functions."""
-
-from cStringIO import StringIO
-
-from bzrlib import config
-from bzrlib.tests import TestCaseInTempDir, TestCaseWithMemoryTransport
-from bzrlib.plugins.launchpad import account
-
-
-class LaunchpadAccountTests(TestCaseInTempDir):
-
-    def setup_config(self, text):
-        my_config = config.GlobalConfig()
-        config_file = StringIO(text)
-        my_config._get_parser(config_file)
-        return my_config
-
-    def test_get_lp_login_unconfigured(self):
-        # Test that get_lp_login() returns None if no username has
-        # been configured.
-        my_config = self.setup_config('')
-        self.assertEqual(None, account.get_lp_login(my_config))
-
-    def test_get_lp_login(self):
-        # Test that get_lp_login() returns the configured username
-        my_config = self.setup_config(
-            '[DEFAULT]\nlaunchpad_username=test-user\n')
-        self.assertEqual('test-user', account.get_lp_login(my_config))
-
-    def test_set_lp_login(self):
-        # Test that set_lp_login() updates the config file.
-        my_config = self.setup_config('')
-        self.assertEqual(None, my_config.get_user_option('launchpad_username'))
-        account.set_lp_login('test-user', my_config)
-        self.assertEqual(
-            'test-user', my_config.get_user_option('launchpad_username'))
-
-    def test_unknown_launchpad_username(self):
-        # Test formatting of UnknownLaunchpadUsername exception
-        error = account.UnknownLaunchpadUsername(user='test-user')
-        self.assertEqualDiff('The user name test-user is not registered '
-                             'on Launchpad.', str(error))
-
-    def test_no_registered_ssh_keys(self):
-        # Test formatting of NoRegisteredSSHKeys exception
-        error = account.NoRegisteredSSHKeys(user='test-user')
-        self.assertEqualDiff('The user test-user has not registered any '
-                             'SSH keys with Launchpad.', str(error))
-
-
-class CheckAccountTests(TestCaseWithMemoryTransport):
-
-    def test_check_lp_login_valid_user(self):
-        transport = self.get_transport()
-        transport.mkdir('~test-user')
-        transport.put_bytes('~test-user/+sshkeys', 'some keys here')
-        account.check_lp_login('test-user', transport)
-
-    def test_check_lp_login_no_user(self):
-        transport = self.get_transport()
-        self.assertRaises(account.UnknownLaunchpadUsername,
-                          account.check_lp_login, 'test-user', transport)
-
-    def test_check_lp_login_no_ssh_keys(self):
-        transport = self.get_transport()
-        transport.mkdir('~test-user')
-        transport.put_bytes('~test-user/+sshkeys', '')
-        self.assertRaises(account.NoRegisteredSSHKeys,
-                          account.check_lp_login, 'test-user', transport)

=== renamed file 'bzrlib/plugins/launchpad/test_lp_directory.py' => 'bzrlib/plugins/launchpad/test_lp_indirect.py'
--- bzrlib/plugins/launchpad/test_lp_directory.py	2008-03-06 21:16:38 +0000
+++ bzrlib/plugins/launchpad/test_lp_indirect.py	2007-02-08 08:33:26 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007, 2008 Canonical Ltd
+# Copyright (C) 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -14,176 +14,37 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-"""Tests for directory lookup through Launchpad.net"""
-
-import xmlrpclib
+"""Tests for indirect branch urls through Launchpad.net"""
 
 from bzrlib import (
     errors,
+    transport,
     )
-from bzrlib.branch import Branch
-from bzrlib.directory_service import directories
-from bzrlib.tests import TestCase, TestCaseWithMemoryTransport
 from bzrlib.transport import get_transport
-from bzrlib.plugins.launchpad import _register_directory
-from bzrlib.plugins.launchpad.lp_directory import (
-    LaunchpadDirectory)
-from bzrlib.plugins.launchpad.account import get_lp_login
-
-
-class FakeResolveFactory(object):
-    def __init__(self, test, expected_path, result):
-        self._test = test
-        self._expected_path = expected_path
-        self._result = result
-
-    def __call__(self, path):
-        self._test.assertEqual(self._expected_path, path)
-        return self
-
-    def submit(self, service):
-        self._service_url = service.service_url
-        return self._result
-
-
-class DirectoryUrlTests(TestCase):
-    """Tests for branch urls through Launchpad.net directory"""
+from bzrlib.tests import TestCase, TestSkipped
+
+
+class IndirectUrlTests(TestCase):
+    """Tests for indirect branch urls through Launchpad.net"""
 
     def test_short_form(self):
         """A launchpad url should map to a http url"""
-        factory = FakeResolveFactory(
-            self, 'apt', dict(urls=[
-                    'http://bazaar.launchpad.net/~apt/apt/devel']))
-        directory = LaunchpadDirectory()
-        self.assertEquals('http://bazaar.launchpad.net/~apt/apt/devel',
-                          directory._resolve('lp:apt', factory))
-        # Make sure that resolve went to the production server.
-        self.assertEquals('https://xmlrpc.edge.launchpad.net/bazaar/',
-                          factory._service_url)
-
-    def test_staging(self):
-        """A launchpad url should map to a http url"""
-        factory = FakeResolveFactory(
-            self, 'apt', dict(urls=[
-                    'http://bazaar.staging.launchpad.net/~apt/apt/devel']))
-        url = 'lp://staging/apt'
-        directory = LaunchpadDirectory()
-        self.assertEquals('http://bazaar.staging.launchpad.net/~apt/apt/devel',
-                          directory._resolve(url, factory))
-        # Make sure that resolve went to the staging server.
-        self.assertEquals('https://xmlrpc.staging.launchpad.net/bazaar/',
-                          factory._service_url)
-
-    def test_url_from_directory(self):
-        """A launchpad url should map to a http url"""
-        factory = FakeResolveFactory(
-            self, 'apt', dict(urls=[
-                    'http://bazaar.launchpad.net/~apt/apt/devel']))
-        directory = LaunchpadDirectory()
-        self.assertEquals('http://bazaar.launchpad.net/~apt/apt/devel',
-                          directory._resolve('lp:///apt', factory))
-
-    def test_directory_skip_bad_schemes(self):
-        factory = FakeResolveFactory(
-            self, 'apt', dict(urls=[
-                    'bad-scheme://bazaar.launchpad.net/~apt/apt/devel',
-                    'http://bazaar.launchpad.net/~apt/apt/devel',
-                    'http://another/location']))
-        directory = LaunchpadDirectory()
-        self.assertEquals('http://bazaar.launchpad.net/~apt/apt/devel',
-                          directory._resolve('lp:///apt', factory))
-
-    def test_directory_no_matching_schemes(self):
-        # If the XMLRPC call does not return any protocols we support,
-        # invalidURL is raised.
-        factory = FakeResolveFactory(
-            self, 'apt', dict(urls=[
-                    'bad-scheme://bazaar.launchpad.net/~apt/apt/devel']))
-        directory = LaunchpadDirectory()
-        self.assertRaises(errors.InvalidURL,
-                          directory._resolve, 'lp:///apt', factory)
-
-    def test_directory_fault(self):
-        # Test that XMLRPC faults get converted to InvalidURL errors.
-        factory = FakeResolveFactory(self, 'apt', None)
-        def submit(service):
-            raise xmlrpclib.Fault(42, 'something went wrong')
-        factory.submit = submit
-        directory = LaunchpadDirectory()
-        self.assertRaises(errors.InvalidURL,
-                          directory._resolve, 'lp:///apt', factory)
-
-    def test_skip_bzr_ssh_launchpad_net_when_anonymous(self):
-        # Test that bzr+ssh://bazaar.launchpad.net gets skipped if
-        # Bazaar does not know the user's Launchpad ID:
-        self.assertEqual(None, get_lp_login())
-        factory = FakeResolveFactory(
-            self, 'apt', dict(urls=[
-                    'bzr+ssh://bazaar.launchpad.net/~apt/apt/devel',
-                    'http://bazaar.launchpad.net/~apt/apt/devel']))
-        directory = LaunchpadDirectory()
-        self.assertEquals('http://bazaar.launchpad.net/~apt/apt/devel',
-                          directory._resolve('lp:///apt', factory))
-
-    def test_skip_sftp_launchpad_net_when_anonymous(self):
-        # Test that sftp://bazaar.launchpad.net gets skipped if
-        # Bazaar does not know the user's Launchpad ID:
-        self.assertEqual(None, get_lp_login())
-        factory = FakeResolveFactory(
-            self, 'apt', dict(urls=[
-                    'sftp://bazaar.launchpad.net/~apt/apt/devel',
-                    'http://bazaar.launchpad.net/~apt/apt/devel']))
-        directory = LaunchpadDirectory()
-        self.assertEquals('http://bazaar.launchpad.net/~apt/apt/devel',
-                          directory._resolve('lp:///apt', factory))
-
-    def test_rewrite_bzr_ssh_launchpad_net(self):
-        # Test that bzr+ssh URLs get rewritten to include the user's
-        # Launchpad ID (assuming we know the Launchpad ID).
-        factory = FakeResolveFactory(
-            self, 'apt', dict(urls=[
-                    'bzr+ssh://bazaar.launchpad.net/~apt/apt/devel',
-                    'http://bazaar.launchpad.net/~apt/apt/devel']))
-        directory = LaunchpadDirectory()
-        self.assertEquals(
-            'bzr+ssh://username@bazaar.launchpad.net/~apt/apt/devel',
-            directory._resolve('lp:///apt', factory, _lp_login='username'))
-
-    def test_no_rewrite_of_other_bzr_ssh(self):
-        # Test that we don't rewrite bzr+ssh URLs for other 
-        self.assertEqual(None, get_lp_login())
-        factory = FakeResolveFactory(
-            self, 'apt', dict(urls=[
-                    'bzr+ssh://example.com/~apt/apt/devel',
-                    'http://bazaar.launchpad.net/~apt/apt/devel']))
-        directory = LaunchpadDirectory()
-        self.assertEquals('bzr+ssh://example.com/~apt/apt/devel',
-                          directory._resolve('lp:///apt', factory))
+        url = 'lp:apt'
+        t = get_transport(url)
+        self.assertEquals(t.base, 'http://code.launchpad.net/apt/')
+
+    def test_indirect_through_url(self):
+        """A launchpad url should map to a http url"""
+        # These can change to use the smartserver protocol or something 
+        # else in the future.
+        url = 'lp:///apt'
+        t = get_transport(url)
+        real_url = t.base
+        self.assertEquals(real_url, 'http://code.launchpad.net/apt/')
 
     # TODO: check we get an error if the url is unreasonable
-    def test_error_for_bad_url(self):
-        directory = LaunchpadDirectory()
+    def test_error_for_bad_indirection(self):
         self.assertRaises(errors.InvalidURL,
-            directory._resolve, 'lp://ratotehunoahu')
-
-
-class DirectoryOpenBranchTests(TestCaseWithMemoryTransport):
-
-    def test_directory_open_branch(self):
-        # Test that opening an lp: branch redirects to the real location.
-        target_branch = self.make_branch('target')
-        class FooService(object):
-            """A directory service that maps the name to a FILE url"""
-
-            def look_up(self, name, url):
-                if 'lp:///apt' == url:
-                    return target_branch.base.rstrip('/')
-                return '!unexpected look_up value!'
-
-        directories.remove('lp:')
-        directories.register('lp:', FooService, 'Map lp URLs to local urls')
-        self.addCleanup(_register_directory)
-        self.addCleanup(lambda: directories.remove('lp:'))
-        transport = get_transport('lp:///apt')
-        branch = Branch.open_from_transport(transport)
-        self.assertEqual(target_branch.base, branch.base)
+            get_transport,
+            'lp://ratotehunoahu')
+

=== removed file 'bzrlib/plugins/launchpad/test_lp_service.py'
--- bzrlib/plugins/launchpad/test_lp_service.py	2008-02-13 03:45:58 +0000
+++ bzrlib/plugins/launchpad/test_lp_service.py	1970-01-01 00:00:00 +0000
@@ -1,86 +0,0 @@
-# Copyright (C) 2008 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Tests for selection of the right Launchpad service by environment"""
-
-import os
-
-from bzrlib.tests import TestCase
-from bzrlib.plugins.launchpad.lp_registration import (
-    InvalidLaunchpadInstance, LaunchpadService)
-
-
-class LaunchpadServiceTests(TestCase):
-    """Test that the correct Launchpad instance is chosen."""
-
-    def setUp(self):
-        super(LaunchpadServiceTests, self).setUp()
-        # make sure we have a reproducible standard environment
-        self._captureVar('BZR_LP_XMLRPC_URL', None)
-
-    def test_default_service(self):
-        service = LaunchpadService()
-        self.assertEqual('https://xmlrpc.launchpad.net/bazaar/',
-                         service.service_url)
-
-    def test_alter_default_service_url(self):
-        LaunchpadService.DEFAULT_SERVICE_URL = 'http://example.com/'
-        try:
-            service = LaunchpadService()
-            self.assertEqual('http://example.com/',
-                             service.service_url)
-        finally:
-            LaunchpadService.DEFAULT_SERVICE_URL = \
-                LaunchpadService.LAUNCHPAD_INSTANCE['production']
-
-    def test_staging_service(self):
-        service = LaunchpadService(lp_instance='staging')
-        self.assertEqual('https://xmlrpc.staging.launchpad.net/bazaar/',
-                         service.service_url)
-
-    def test_edge_service(self):
-        service = LaunchpadService(lp_instance='edge')
-        self.assertEqual('https://xmlrpc.edge.launchpad.net/bazaar/',
-                         service.service_url)
-
-    def test_dev_service(self):
-        service = LaunchpadService(lp_instance='dev')
-        self.assertEqual('http://xmlrpc.launchpad.dev/bazaar/',
-                         service.service_url)
-
-    def test_demo_service(self):
-        service = LaunchpadService(lp_instance='demo')
-        self.assertEqual('https://xmlrpc.demo.launchpad.net/bazaar/',
-                         service.service_url)
-
-    def test_unknown_service(self):
-        error = self.assertRaises(InvalidLaunchpadInstance,
-                                  LaunchpadService,
-                                  lp_instance='fubar')
-        self.assertEqual('fubar is not a valid Launchpad instance.',
-                         str(error))
-
-    def test_environment_overrides_default(self):
-        os.environ['BZR_LP_XMLRPC_URL'] = 'http://example.com/'
-        service = LaunchpadService()
-        self.assertEqual('http://example.com/',
-                         service.service_url)
-
-    def test_environment_overrides_specified_service(self):
-        os.environ['BZR_LP_XMLRPC_URL'] = 'http://example.com/'
-        service = LaunchpadService(lp_instance='staging')
-        self.assertEqual('http://example.com/',
-                         service.service_url)

=== modified file 'bzrlib/plugins/launchpad/test_register.py'
--- bzrlib/plugins/launchpad/test_register.py	2008-05-08 04:54:24 +0000
+++ bzrlib/plugins/launchpad/test_register.py	2007-07-04 09:27:22 +0000
@@ -17,23 +17,15 @@
 import base64
 import os
 from StringIO import StringIO
-import urlparse
 import xmlrpclib
 
-from bzrlib import (
-    config,
-    osutils,
-    tests,
-    ui,
-    )
-from bzrlib.tests import TestCaseWithTransport, TestSkipped
+from bzrlib.tests import TestCase, TestSkipped
 
 # local import
-from bzrlib.plugins.launchpad.lp_registration import (
+from lp_registration import (
         BaseRequest,
         BranchBugLinkRequest,
         BranchRegistrationRequest,
-        ResolveLaunchpadPathRequest,
         LaunchpadService,
         )
 
@@ -82,25 +74,19 @@
     # Python 2.5's xmlrpclib looks for this.
     _use_datetime = False
 
-    def __init__(self, testcase, expect_auth):
+    def __init__(self, testcase):
         self.testcase = testcase
-        self.expect_auth = expect_auth
 
     def make_connection(self, host):
         host, http_headers, x509 = self.get_host_info(host)
         test = self.testcase
         self.connected_host = host
-        if self.expect_auth:
-            auth_hdrs = [v for k,v in http_headers if k == 'Authorization']
-            if len(auth_hdrs) != 1:
-                raise AssertionError("multiple auth headers: %r"
-                    % (auth_hdrs,))
-            authinfo = auth_hdrs[0]
-            expected_auth = 'testuser@launchpad.net:testpassword'
-            test.assertEquals(authinfo,
-                    'Basic ' + base64.encodestring(expected_auth).strip())
-        elif http_headers:
-            raise AssertionError()
+        auth_hdrs = [v for k,v in http_headers if k == 'Authorization']
+        assert len(auth_hdrs) == 1
+        authinfo = auth_hdrs[0]
+        expected_auth = 'testuser@launchpad.net:testpassword'
+        test.assertEquals(authinfo,
+                'Basic ' + base64.encodestring(expected_auth).strip())
         return InstrumentedXMLRPCConnection(test)
 
     def send_request(self, connection, handler_path, request_body):
@@ -117,22 +103,20 @@
 
     def send_content(self, conn, request_body):
         unpacked, method = xmlrpclib.loads(request_body)
-        if None in unpacked:
-            raise AssertionError(
-                "xmlrpc result %r shouldn't contain None" % (unpacked,))
+        assert None not in unpacked, \
+                "xmlrpc result %r shouldn't contain None" % (unpacked,)
         self.sent_params = unpacked
 
 
 class MockLaunchpadService(LaunchpadService):
 
-    def send_request(self, method_name, method_params, authenticated):
+    def send_request(self, method_name, method_params):
         """Stash away the method details rather than sending them to a real server"""
         self.called_method_name = method_name
         self.called_method_params = method_params
-        self.called_authenticated = authenticated
-
-
-class TestBranchRegistration(TestCaseWithTransport):
+
+
+class TestBranchRegistration(TestCase):
     SAMPLE_URL = 'http://bazaar-vcs.org/bzr/bzr.dev/'
     SAMPLE_OWNER = 'jhacker@foo.com'
     SAMPLE_BRANCH_ID = 'bzr.dev'
@@ -140,33 +124,17 @@
     def setUp(self):
         super(TestBranchRegistration, self).setUp()
         # make sure we have a reproducible standard environment
-        self._captureVar('BZR_LP_XMLRPC_URL', None)
+        if 'BZR_LP_XMLRPC_URL' in os.environ:
+            del os.environ['BZR_LP_XMLRPC_URL']
 
     def test_register_help(self):
         """register-branch accepts --help"""
         out, err = self.run_bzr(['register-branch', '--help'])
         self.assertContainsRe(out, r'Register a branch')
 
-    def test_register_no_url_no_branch(self):
+    def test_register_no_url(self):
         """register-branch command requires parameters"""
-        self.make_repository('.')
-        self.run_bzr_error(
-            ['register-branch requires a public branch url - '
-             'see bzr help register-branch'],
-            'register-branch')
-
-    def test_register_no_url_in_published_branch_no_error(self):
-        b = self.make_branch('.')
-        b.set_public_branch('http://test-server.com/bzr/branch')
-        out, err = self.run_bzr(['register-branch', '--dry-run'])
-        self.assertEqual('Branch registered.\n', out)
-        self.assertEqual('', err)
-
-    def test_register_no_url_in_unpublished_branch_errors(self):
-        b = self.make_branch('.')
-        out, err = self.run_bzr_error(['no public branch'],
-            ['register-branch', '--dry-run'])
-        self.assertEqual('', out)
+        self.run_bzr('register-branch', retcode=3)
 
     def test_register_dry_run(self):
         out, err = self.run_bzr(['register-branch',
@@ -177,7 +145,7 @@
     def test_onto_transport(self):
         """Test how the request is sent by transmitting across a mock Transport"""
         # use a real transport, but intercept at the http/xml layer
-        transport = InstrumentedXMLRPCTransport(self, expect_auth=True)
+        transport = InstrumentedXMLRPCTransport(self)
         service = LaunchpadService(transport)
         service.registrant_email = 'testuser@launchpad.net'
         service.registrant_password = 'testpassword'
@@ -188,7 +156,7 @@
                 'author@launchpad.net',
                 'product')
         rego.submit(service)
-        self.assertEquals(transport.connected_host, 'xmlrpc.edge.launchpad.net')
+        self.assertEquals(transport.connected_host, 'xmlrpc.launchpad.net')
         self.assertEquals(len(transport.sent_params), 6)
         self.assertEquals(transport.sent_params,
                 ('http://test-server.com/bzr/branch',  # branch_url
@@ -199,17 +167,6 @@
                  'product'))
         self.assertTrue(transport.got_request)
 
-    def test_onto_transport_unauthenticated(self):
-        """Test how an unauthenticated request is transmitted across a mock Transport"""
-        transport = InstrumentedXMLRPCTransport(self, expect_auth=False)
-        service = LaunchpadService(transport)
-        resolve = ResolveLaunchpadPathRequest('bzr')
-        resolve.submit(service)
-        self.assertEquals(transport.connected_host, 'xmlrpc.edge.launchpad.net')
-        self.assertEquals(len(transport.sent_params), 1)
-        self.assertEquals(transport.sent_params, ('bzr', ))
-        self.assertTrue(transport.got_request)
-
     def test_subclass_request(self):
         """Define a new type of xmlrpc request"""
         class DummyRequest(BaseRequest):
@@ -229,11 +186,10 @@
         """Send registration to mock server"""
         test_case = self
         class MockRegistrationService(MockLaunchpadService):
-            def send_request(self, method_name, method_params, authenticated):
+            def send_request(self, method_name, method_params):
                 test_case.assertEquals(method_name, "register_branch")
                 test_case.assertEquals(list(method_params),
                         ['url', 'name', 'title', 'description', 'email', 'name'])
-                test_case.assertEquals(authenticated, True)
                 return 'result'
         service = MockRegistrationService()
         rego = BranchRegistrationRequest('url', 'name', 'title',
@@ -245,11 +201,10 @@
         """Send registration to mock server"""
         test_case = self
         class MockRegistrationService(MockLaunchpadService):
-            def send_request(self, method_name, method_params, authenticated):
+            def send_request(self, method_name, method_params):
                 test_case.assertEquals(method_name, "register_branch")
                 test_case.assertEquals(list(method_params),
                         ['http://server/branch', 'branch', '', '', '', ''])
-                test_case.assertEquals(authenticated, True)
                 return 'result'
         service = MockRegistrationService()
         rego = BranchRegistrationRequest('http://server/branch')
@@ -260,87 +215,12 @@
         """Send bug-branch link to mock server"""
         test_case = self
         class MockService(MockLaunchpadService):
-            def send_request(self, method_name, method_params, authenticated):
+            def send_request(self, method_name, method_params):
                 test_case.assertEquals(method_name, "link_branch_to_bug")
                 test_case.assertEquals(list(method_params),
                         ['http://server/branch', 1234, ''])
-                test_case.assertEquals(authenticated, True)
                 return 'http://launchpad.net/bug/1234'
         service = MockService()
         rego = BranchBugLinkRequest('http://server/branch', 1234)
         result = rego.submit(service)
         self.assertEquals(result, 'http://launchpad.net/bug/1234')
-
-    def test_mock_resolve_lp_url(self):
-        test_case = self
-        class MockService(MockLaunchpadService):
-            def send_request(self, method_name, method_params, authenticated):
-                test_case.assertEquals(method_name, "resolve_lp_path")
-                test_case.assertEquals(list(method_params), ['bzr'])
-                test_case.assertEquals(authenticated, False)
-                return dict(urls=[
-                        'bzr+ssh://bazaar.launchpad.net~bzr/bzr/trunk',
-                        'sftp://bazaar.launchpad.net~bzr/bzr/trunk',
-                        'bzr+http://bazaar.launchpad.net~bzr/bzr/trunk',
-                        'http://bazaar.launchpad.net~bzr/bzr/trunk'])
-        service = MockService()
-        resolve = ResolveLaunchpadPathRequest('bzr')
-        result = resolve.submit(service)
-        self.assertTrue('urls' in result)
-        self.assertEquals(result['urls'], [
-                'bzr+ssh://bazaar.launchpad.net~bzr/bzr/trunk',
-                'sftp://bazaar.launchpad.net~bzr/bzr/trunk',
-                'bzr+http://bazaar.launchpad.net~bzr/bzr/trunk',
-                'http://bazaar.launchpad.net~bzr/bzr/trunk'])
-
-
-class TestGatherUserCredentials(tests.TestCaseInTempDir):
-
-    def setUp(self):
-        super(TestGatherUserCredentials, self).setUp()
-        # make sure we have a reproducible standard environment
-        self._captureVar('BZR_LP_XMLRPC_URL', None)
-
-    def test_gather_user_credentials_has_password(self):
-        service = LaunchpadService()
-        service.registrant_password = 'mypassword'
-        # This should be a basic no-op, since we already have the password
-        service.gather_user_credentials()
-        self.assertEqual('mypassword', service.registrant_password)
-
-    def test_gather_user_credentials_from_auth_conf(self):
-        auth_path = config.authentication_config_filename()
-        service = LaunchpadService()
-        g_conf = config.GlobalConfig()
-        g_conf.set_user_option('email', 'Test User <test@user.com>')
-        f = open(auth_path, 'wb')
-        try:
-            scheme, hostinfo = urlparse.urlsplit(service.service_url)[:2]
-            f.write('[section]\n'
-                    'scheme=%s\n'
-                    'host=%s\n'
-                    'user=test@user.com\n'
-                    'password=testpass\n'
-                    % (scheme, hostinfo))
-        finally:
-            f.close()
-        self.assertIs(None, service.registrant_password)
-        service.gather_user_credentials()
-        self.assertEqual('test@user.com', service.registrant_email)
-        self.assertEqual('testpass', service.registrant_password)
-
-    def test_gather_user_credentials_prompts(self):
-        service = LaunchpadService()
-        self.assertIs(None, service.registrant_password)
-        g_conf = config.GlobalConfig()
-        g_conf.set_user_option('email', 'Test User <test@user.com>')
-        stdout = tests.StringIOWrapper()
-        ui.ui_factory = tests.TestUIFactory(stdin='userpass\n',
-                                            stdout=stdout)
-        self.assertIs(None, service.registrant_password)
-        service.gather_user_credentials()
-        self.assertEqual('test@user.com', service.registrant_email)
-        self.assertEqual('userpass', service.registrant_password)
-        self.assertContainsRe(stdout.getvalue(),
-                             'launchpad.net password for test@user\\.com')
-

=== added file 'bzrlib/plugins/multiparent.py'
--- bzrlib/plugins/multiparent.py	1970-01-01 00:00:00 +0000
+++ bzrlib/plugins/multiparent.py	2007-10-16 16:02:01 +0000
@@ -0,0 +1,177 @@
+"""Implementation of multiparent diffs for versionedfile-like storage
+
+Provides mp-regen and mp-extract commands.
+Focus is on comparing size/performance to knits.
+"""
+
+from bzrlib.lazy_import import lazy_import
+
+lazy_import(globals(), """
+import (
+        errno,
+        os,
+        sys,
+        time,
+        )
+
+from bzrlib import (
+    commands,
+    urlutils
+    )
+from bzrlib.workingtree import WorkingTree
+from bzrlib.tests import TestUtil
+
+from bzrlib.plugins.multiparent.multiparent import (
+    MultiVersionedFile,
+    MultiMemoryVersionedFile,
+    )
+""")
+
+class cmd_mp_regen(commands.Command):
+    """Generate a multiparent versionedfile"""
+
+    hidden = True
+
+    takes_args = ['file?']
+
+    takes_options = [commands.Option('sync-snapshots',
+                                     help='Snapshots follow source.'),
+                     commands.Option('snapshot-interval', type=int,
+                                     help='Take snapshots every x revisions.'),
+                     commands.Option('outfile', type=unicode,
+                                     help='Write pseudo-knit to this file.'),
+                     commands.Option('memory', help='Use memory, not disk.'),
+                     commands.Option('extract', help='Test extract time.'),
+                     commands.Option('single', help='Use a single parent.'),
+                     commands.Option('verify', help='Verify added texts.'),
+                     commands.Option('cache', help='Aggresively cache.'),
+                     commands.Option('size', help='Aggressive size.'),
+                     commands.Option('build', help='Aggressive build.'),
+                    ]
+    hidden = True
+
+    def run(self, file=None, sync_snapshots=False, snapshot_interval=26,
+            lsprof_timed=False, dump=False, extract=False, single=False,
+            verify=False, outfile=None, memory=False, cache=False,
+            size=False, build=False):
+        file_weave = get_file_weave(file)
+        url = file_weave.transport.abspath(file_weave.filename)
+        sys.stderr.write('Importing: %s\n' % \
+            urlutils.local_path_from_url(url))
+        if sync_snapshots:
+            sys.stderr.write('Snapshots follow input\n')
+        else:
+            sys.stderr.write('Snapshot interval: %d\n' % snapshot_interval)
+        if not memory:
+            if outfile is None:
+                filename = 'pknit'
+            else:
+                filename = outfile
+            vf = MultiVersionedFile(filename, snapshot_interval)
+        else:
+            vf = MultiMemoryVersionedFile(snapshot_interval)
+        vf.destroy()
+        old_snapshots = set(r for r in file_weave.versions() if
+                        file_weave._index.get_method(r) == 'fulltext')
+        if sync_snapshots:
+            to_sync = old_snapshots
+        elif size or build:
+            assert memory
+            to_sync = set()
+        else:
+            to_sync = vf.select_snapshots(file_weave)
+        sys.stderr.write("%d fulltext(s)\n" % len(old_snapshots))
+        sys.stderr.write("%d planned snapshots\n" % len(to_sync))
+
+        try:
+            vf.import_versionedfile(file_weave, to_sync, single_parent=single,
+                                    verify=verify, no_cache=not cache)
+            if size:
+                snapshots = vf.select_by_size(len(old_snapshots))
+                for version_id in snapshots:
+                    vf.make_snapshot(version_id)
+            if build:
+                ranking = vf.get_build_ranking()
+                snapshots = ranking[:len(old_snapshots) -\
+                    len(vf._snapshots)]
+                for version_id in snapshots:
+                    vf.make_snapshot(version_id)
+        except:
+            vf.destroy()
+            raise
+        try:
+            sys.stderr.write("%d actual snapshots\n" % len(vf._snapshots))
+            if not cache:
+                vf.clear_cache()
+            if memory:
+                if outfile is not None:
+                    vf_file = MultiVersionedFile(outfile)
+                vf_file.import_diffs(vf)
+            else:
+                vf_file = vf
+        finally:
+            if outfile is None:
+                vf.destroy()
+            else:
+                vf_file.save()
+
+class cmd_mp_extract(commands.Command):
+    """Test extraction time multiparent knits"""
+
+    hidden = True
+
+    takes_options = [
+        commands.Option('lsprof-timed', help='Use lsprof.'),
+        commands.Option('parallel', help='Extract multiple versions at once.'),
+        commands.Option('count', help='Number of cycles to do.', type=int),
+        ]
+
+    takes_args = ['filename', 'vfile?']
+
+    def run(self, filename, vfile=None, lsprof_timed=False, count=1000,
+            parallel=False):
+        vf = MultiVersionedFile(filename)
+        vf.load()
+        snapshots = [r for r in vf.versions() if vf.get_diff(r).is_snapshot()]
+        print '%d snapshots' % len(snapshots)
+        revisions = list(vf.versions())
+        revisions = revisions[-count:]
+        print 'Testing extract time of %d revisions' % len(revisions)
+        if parallel:
+            revisions_list = [revisions]
+        else:
+            revisions_list = [[r] for r in revisions]
+        start = time.clock()
+        for revisions in revisions_list:
+            vf = MultiVersionedFile(filename)
+            vf.load()
+            vf.get_line_list(revisions)
+        sys.stderr.write(time.clock() - start)
+        sys.stderr.write('\n')
+        if lsprof_timed:
+            from bzrlib.lsprof import profile
+            vf.clear_cache()
+            ret, stats = profile(vf.get_line_list, revisions_list[-1][-1])
+            stats.sort()
+            stats.pprint()
+        start = time.clock()
+        for revisions in revisions_list:
+            file_weave = get_file_weave(vfile)
+            file_weave.get_line_list(revisions)
+        sys.stderr.write(time.clock() - start)
+        sys.stderr.write('\n')
+
+
+def get_file_weave(filename=None, wt=None):
+    if filename is None:
+        wt, path = WorkingTree.open_containing('.')
+        return wt.branch.repository.get_inventory_weave()
+    else:
+        wt, path = WorkingTree.open_containing(filename)
+        file_id = wt.path2id(path)
+        bt = wt.branch.repository.revision_tree(wt.last_revision())
+        return bt.get_weave(file_id)
+
+
+commands.register_command(cmd_mp_regen)
+commands.register_command(cmd_mp_extract)

=== modified file 'bzrlib/progress.py'
--- bzrlib/progress.py	2008-04-24 07:22:53 +0000
+++ bzrlib/progress.py	2007-10-05 02:18:53 +0000
@@ -16,18 +16,22 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 
-"""Progress indicators.
-
-The usual way to use this is via bzrlib.ui.ui_factory.nested_progress_bar which
-will maintain a ProgressBarStack for you.
-
-For direct use, the factory ProgressBar will return an auto-detected progress
-bar that should match your terminal type. You can manually create a
-ProgressBarStack too if you need multiple levels of cooperating progress bars.
-Note that bzrlib's internal functions use the ui module, so if you are using
-bzrlib it really is best to use bzrlib.ui.ui_factory.
+"""Simple text-mode progress indicator.
+
+To display an indicator, create a ProgressBar object.  Call it,
+passing Progress objects indicating the current state.  When done,
+call clear().
+
+Progress is suppressed when output is not sent to a terminal, so as
+not to clutter log files.
 """
 
+# TODO: should be a global option e.g. --silent that disables progress
+# indicators, preferably without needing to adjust all code that
+# potentially calls them.
+
+# TODO: If not on a tty perhaps just print '......' for the benefit of IDEs, etc
+
 # TODO: Optionally show elapsed time instead/as well as ETA; nicer
 # when the rate is unpredictable
 
@@ -189,6 +193,7 @@
     def finished(self):
         """Return this bar to its progress stack."""
         self.clear()
+        assert self._stack is not None
         self._stack.return_pb(self)
 
     def note(self, fmt_string, *args, **kwargs):
@@ -293,6 +298,7 @@
         self.child_fraction = 0
         self._have_output = False
     
+
     def throttle(self, old_msg):
         """Return True if the bar was updated too recently"""
         # time.time consistently takes 40/4000 ms = 0.01 ms.
@@ -314,7 +320,7 @@
         return False
         
     def tick(self):
-        self.update(self.last_msg, self.last_cnt, self.last_total,
+        self.update(self.last_msg, self.last_cnt, self.last_total, 
                     self.child_fraction)
 
     def child_update(self, message, current, total):
@@ -324,11 +330,13 @@
                 pass
             elif self.last_cnt + child_fraction <= self.last_total:
                 self.child_fraction = child_fraction
+            else:
+                mutter('not updating child fraction')
         if self.last_msg is None:
             self.last_msg = ''
         self.tick()
 
-    def update(self, msg, current_cnt=None, total_cnt=None,
+    def update(self, msg, current_cnt=None, total_cnt=None, 
                child_fraction=0):
         """Update and redraw progress bar."""
         if msg is None:
@@ -430,7 +438,7 @@
         self._have_output = True
         #self.to_file.flush()
             
-    def clear(self):
+    def clear(self):        
         if self._have_output:
             self.to_file.write('\r%s\r' % (' ' * (self.width - 1)))
         self._have_output = False
@@ -453,8 +461,7 @@
 
     def update(self, msg, current_cnt=None, total_cnt=None):
         self.current = current_cnt
-        if total_cnt is not None:
-            self.total = total_cnt
+        self.total = total_cnt
         self.message = msg
         self.child_fraction = 0
         self.tick()
@@ -483,24 +490,7 @@
     def note(self, *args, **kwargs):
         self.parent.note(*args, **kwargs)
 
-
-class InstrumentedProgress(TTYProgressBar):
-    """TTYProgress variant that tracks outcomes"""
-
-    def __init__(self, *args, **kwargs):
-        self.always_throttled = True
-        self.never_throttle = False
-        TTYProgressBar.__init__(self, *args, **kwargs)
-
-    def throttle(self, old_message):
-        if self.never_throttle:
-            result =  False
-        else:
-            result = TTYProgressBar.throttle(self, old_message)
-        if result is False:
-            self.always_throttled = False
-
-
+ 
 def str_tdelta(delt):
     if delt is None:
         return "-:--:--"
@@ -530,6 +520,8 @@
     
     total_duration = float(elapsed) * float(total) / float(current)
 
+    assert total_duration >= elapsed
+
     if last_updates and len(last_updates) >= n_recent:
         avg = sum(last_updates) / float(len(last_updates))
         time_left = avg * (total - current)
@@ -556,4 +548,42 @@
             self.cur_phase = 0
         else:
             self.cur_phase += 1
+        assert self.cur_phase < self.total 
         self.pb.update(self.message, self.cur_phase, self.total)
+
+
+def run_tests():
+    import doctest
+    result = doctest.testmod()
+    if result[1] > 0:
+        if result[0] == 0:
+            print "All tests passed"
+    else:
+        print "No tests to run"
+
+
+def demo():
+    sleep = time.sleep
+    
+    print 'dumb-terminal test:'
+    pb = DotsProgressBar()
+    for i in range(100):
+        pb.update('Leoparden', i, 99)
+        sleep(0.1)
+    sleep(1.5)
+    pb.clear()
+    sleep(1.5)
+    
+    print 'smart-terminal test:'
+    pb = ProgressBar(show_pct=True, show_bar=True, show_spinner=False)
+    for i in range(100):
+        pb.update('Elephanten', i, 99)
+        sleep(0.1)
+    sleep(2)
+    pb.clear()
+    sleep(1)
+
+    print 'done!'
+
+if __name__ == "__main__":
+    demo()

=== removed file 'bzrlib/push.py'
--- bzrlib/push.py	2008-08-28 19:35:29 +0000
+++ bzrlib/push.py	1970-01-01 00:00:00 +0000
@@ -1,186 +0,0 @@
-# Copyright (C) 2008 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""UI helper for the push command."""
-
-from bzrlib import builtins, bzrdir, errors, transport
-from bzrlib.trace import note, warning
-
-
-def _show_push_branch(br_from, revision_id, location, to_file, verbose=False,
-    overwrite=False, remember=False, stacked_on=None, create_prefix=False,
-    use_existing_dir=False):
-    """Push a branch to a location.
-
-    :param br_from: the source branch
-    :param revision_id: the revision-id to push up to
-    :param location: the url of the destination
-    :param to_file: the output stream
-    :param verbose: if True, display more output than normal
-    :param overwrite: if False, a current branch at the destination may not
-        have diverged from the source, otherwise the push fails
-    :param remember: if True, store the location as the push location for
-        the source branch
-    :param stacked_on: the url of the branch, if any, to stack on;
-        if set, only the revisions not in that branch are pushed
-    :param create_prefix: if True, create the necessary parent directories
-        at the destination if they don't already exist
-    :param use_existing_dir: if True, proceed even if the destination
-        directory exists without a current .bzr directory in it
-    """
-    to_transport = transport.get_transport(location)
-    br_to = repository_to = dir_to = None
-    try:
-        dir_to = bzrdir.BzrDir.open_from_transport(to_transport)
-    except errors.NotBranchError:
-        pass # Didn't find anything
-    else:
-        # If we can open a branch, use its direct repository, otherwise see
-        # if there is a repository without a branch.
-        try:
-            br_to = dir_to.open_branch()
-        except errors.NotBranchError:
-            # Didn't find a branch, can we find a repository?
-            try:
-                repository_to = dir_to.find_repository()
-            except errors.NoRepositoryPresent:
-                pass
-        else:
-            # Found a branch, so we must have found a repository
-            repository_to = br_to.repository
-
-    push_result = None
-    if verbose:
-        old_rh = []
-    if dir_to is None:
-        # The destination doesn't exist; create it.
-        # XXX: Refactor the create_prefix/no_create_prefix code into a
-        #      common helper function
-
-        def make_directory(transport):
-            transport.mkdir('.')
-            return transport
-
-        def redirected(redirected_transport, e, redirection_notice):
-            return transport.get_transport(e.get_target_url())
-
-        try:
-            to_transport = transport.do_catching_redirections(
-                make_directory, to_transport, redirected)
-        except errors.FileExists:
-            if not use_existing_dir:
-                raise errors.BzrCommandError("Target directory %s"
-                     " already exists, but does not have a valid .bzr"
-                     " directory. Supply --use-existing-dir to push"
-                     " there anyway." % location)
-        except errors.NoSuchFile:
-            if not create_prefix:
-                raise errors.BzrCommandError("Parent directory of %s"
-                    " does not exist."
-                    "\nYou may supply --create-prefix to create all"
-                    " leading parent directories."
-                    % location)
-            builtins._create_prefix(to_transport)
-        except errors.TooManyRedirections:
-            raise errors.BzrCommandError("Too many redirections trying "
-                                         "to make %s." % location)
-
-        # Now the target directory exists, but doesn't have a .bzr
-        # directory. So we need to create it, along with any work to create
-        # all of the dependent branches, etc.
-        dir_to = br_from.bzrdir.clone_on_transport(to_transport,
-            revision_id=revision_id, stacked_on=stacked_on)
-        br_to = dir_to.open_branch()
-        # TODO: Some more useful message about what was copied
-        try:
-            finally_stacked_on = br_to.get_stacked_on_url()
-        except (errors.UnstackableBranchFormat,
-                errors.UnstackableRepositoryFormat,
-                errors.NotStacked):
-            finally_stacked_on = None
-        if finally_stacked_on is not None:
-            note('Created new stacked branch referring to %s.' %
-                 finally_stacked_on)
-        else:
-            note('Created new branch.')
-        # We successfully created the target, remember it
-        if br_from.get_push_location() is None or remember:
-            br_from.set_push_location(br_to.base)
-    elif repository_to is None:
-        # we have a bzrdir but no branch or repository
-        # XXX: Figure out what to do other than complain.
-        raise errors.BzrCommandError("At %s you have a valid .bzr control"
-            " directory, but not a branch or repository. This is an"
-            " unsupported configuration. Please move the target directory"
-            " out of the way and try again."
-            % location)
-    elif br_to is None:
-        # We have a repository but no branch, copy the revisions, and then
-        # create a branch.
-        if stacked_on is not None:
-            warning("Ignoring request for a stacked branch as repository "
-                    "already exists at the destination location.")
-        repository_to.fetch(br_from.repository, revision_id=revision_id)
-        br_to = br_from.clone(dir_to, revision_id=revision_id)
-        note('Created new branch.')
-        if br_from.get_push_location() is None or remember:
-            br_from.set_push_location(br_to.base)
-    else: # We have a valid to branch
-        if stacked_on is not None:
-            warning("Ignoring request for a stacked branch as branch "
-                    "already exists at the destination location.")
-        # We were able to connect to the remote location, so remember it.
-        # (We don't need to successfully push because of possible divergence.)
-        if br_from.get_push_location() is None or remember:
-            br_from.set_push_location(br_to.base)
-        if verbose:
-            old_rh = br_to.revision_history()
-        try:
-            try:
-                tree_to = dir_to.open_workingtree()
-            except errors.NotLocalUrl:
-                warning("This transport does not update the working " 
-                        "tree of: %s. See 'bzr help working-trees' for "
-                        "more information." % br_to.base)
-                push_result = br_from.push(br_to, overwrite,
-                                           stop_revision=revision_id)
-            except errors.NoWorkingTree:
-                push_result = br_from.push(br_to, overwrite,
-                                           stop_revision=revision_id)
-            else:
-                tree_to.lock_write()
-                try:
-                    push_result = br_from.push(tree_to.branch, overwrite,
-                                               stop_revision=revision_id)
-                    tree_to.update()
-                finally:
-                    tree_to.unlock()
-        except errors.DivergedBranches:
-            raise errors.BzrCommandError('These branches have diverged.'
-                                    '  Try using "merge" and then "push".')
-    if push_result is not None:
-        push_result.report(to_file)
-    elif verbose:
-        new_rh = br_to.revision_history()
-        if old_rh != new_rh:
-            # Something changed
-            from bzrlib.log import show_changed_revisions
-            show_changed_revisions(br_to, old_rh, new_rh,
-                                   to_file=to_file)
-    else:
-        # we probably did a clone rather than a push, so a message was
-        # emitted above
-        pass

=== removed file 'bzrlib/readdir.h'
--- bzrlib/readdir.h	2008-09-02 04:45:47 +0000
+++ bzrlib/readdir.h	1970-01-01 00:00:00 +0000
@@ -1,22 +0,0 @@
-/*
- *  Bazaar -- distributed version control
- *
- * Copyright (C) 2006 by Canonical Ltd
- *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
- */
-
-/* Adjust C api to workaround pyrex output bug/limitation */
-typedef struct dirent dirent;

=== modified file 'bzrlib/reconcile.py'
--- bzrlib/reconcile.py	2008-08-18 22:34:21 +0000
+++ bzrlib/reconcile.py	2007-10-15 09:10:30 +0000
@@ -17,24 +17,19 @@
 """Reconcilers are able to fix some potential data errors in a branch."""
 
 
-__all__ = [
-    'KnitReconciler',
-    'PackReconciler',
-    'reconcile',
-    'Reconciler',
-    'RepoReconciler',
-    ]
+__all__ = ['reconcile', 'Reconciler', 'RepoReconciler', 'KnitReconciler']
 
 
 from bzrlib import (
     errors,
+    graph,
     ui,
     repository,
-    repofmt,
     )
+from bzrlib import errors
+from bzrlib import ui
 from bzrlib.trace import mutter, note
-from bzrlib.tsort import TopoSorter
-from bzrlib.versionedfile import AdapterFactory, FulltextContentFactory
+from bzrlib.tsort import TopoSorter, topo_sort
 
 
 def reconcile(dir, other=None):
@@ -68,9 +63,6 @@
                               ancestry was being reported incorrectly.
         garbage_inventories: The number of inventory objects without revisions
                              that were garbage collected.
-        fixed_branch_history: None if there was no branch, False if the branch
-                              history was correct, True if the branch history
-                              needed to be re-normalized.
         """
         self.pb = ui.ui_factory.nested_progress_bar()
         try:
@@ -80,26 +72,9 @@
 
     def _reconcile(self):
         """Helper function for performing reconciliation."""
-        self._reconcile_branch()
-        self._reconcile_repository()
-
-    def _reconcile_branch(self):
-        try:
-            self.branch = self.bzrdir.open_branch()
-        except errors.NotBranchError:
-            # Nothing to check here
-            self.fixed_branch_history = None
-            return
-        self.pb.note('Reconciling branch %s',
-                     self.branch.base)
-        branch_reconciler = self.branch.reconcile(thorough=True)
-        self.fixed_branch_history = branch_reconciler.fixed_history
-
-    def _reconcile_repository(self):
         self.repo = self.bzrdir.find_repository()
         self.pb.note('Reconciling repository %s',
                      self.repo.bzrdir.root_transport.base)
-        self.pb.update("Reconciling repository", 0, 1)
         repo_reconciler = self.repo.reconcile(thorough=True)
         self.inconsistent_parents = repo_reconciler.inconsistent_parents
         self.garbage_inventories = repo_reconciler.garbage_inventories
@@ -112,49 +87,6 @@
             self.pb.note('Reconciliation complete.')
 
 
-class BranchReconciler(object):
-    """Reconciler that works on a branch."""
-
-    def __init__(self, a_branch, thorough=False):
-        self.fixed_history = None
-        self.thorough = thorough
-        self.branch = a_branch
-
-    def reconcile(self):
-        self.branch.lock_write()
-        try:
-            self.pb = ui.ui_factory.nested_progress_bar()
-            try:
-                self._reconcile_steps()
-            finally:
-                self.pb.finished()
-        finally:
-            self.branch.unlock()
-
-    def _reconcile_steps(self):
-        self._reconcile_revision_history()
-
-    def _reconcile_revision_history(self):
-        repo = self.branch.repository
-        last_revno, last_revision_id = self.branch.last_revision_info()
-        real_history = list(repo.iter_reverse_revision_history(
-                                last_revision_id))
-        real_history.reverse()
-        if last_revno != len(real_history):
-            self.fixed_history = True
-            # Technically for Branch5 formats, it is more efficient to use
-            # set_revision_history, as this will regenerate it again.
-            # Not really worth a whole BranchReconciler class just for this,
-            # though.
-            self.pb.note('Fixing last revision info %s => %s',
-                         last_revno, len(real_history))
-            self.branch.set_last_revision_info(len(real_history),
-                                               last_revision_id)
-        else:
-            self.fixed_history = False
-            self.pb.note('revision_history ok.')
-
-
 class RepoReconciler(object):
     """Reconciler that reconciles a repository.
 
@@ -214,10 +146,9 @@
         from bzrlib.weave import WeaveFile, Weave
         transaction = self.repo.get_transaction()
         self.pb.update('Reading inventory data.')
-        self.inventory = self.repo.inventories
-        self.revisions = self.repo.revisions
+        self.inventory = self.repo.get_inventory_weave()
         # the total set of revisions to process
-        self.pending = set([key[-1] for key in self.revisions.keys()])
+        self.pending = set([rev_id for rev_id in self.repo._revision_store.all_revision_ids(transaction)])
 
         # mapping from revision_id to parents
         self._rev_graph = {}
@@ -236,49 +167,44 @@
             self.pb.note('Inventory ok.')
             return
         self.pb.update('Backing up inventory...', 0, 0)
-        self.repo._backup_inventory()
+        self.repo.control_weaves.copy(self.inventory, 'inventory.backup', self.repo.get_transaction())
         self.pb.note('Backup Inventory created.')
-        new_inventories = self.repo._temp_inventories()
+        # asking for '' should never return a non-empty weave
+        new_inventory_vf = self.repo.control_weaves.get_empty('inventory.new',
+            self.repo.get_transaction())
 
         # we have topological order of revisions and non ghost parents ready.
         self._setup_steps(len(self._rev_graph))
-        revision_keys = [(rev_id,) for rev_id in
-            TopoSorter(self._rev_graph.items()).iter_topo_order()]
-        stream = self._change_inv_parents(
-            self.inventory.get_record_stream(revision_keys, 'unordered', True),
-            self._new_inv_parents,
-            set(revision_keys))
-        new_inventories.insert_record_stream(stream)
-        # if this worked, the set of new_inventories.keys should equal
+        for rev_id in TopoSorter(self._rev_graph.items()).iter_topo_order():
+            parents = self._rev_graph[rev_id]
+            # double check this really is in topological order.
+            unavailable = [p for p in parents if p not in new_inventory_vf]
+            assert len(unavailable) == 0
+            # this entry has all the non ghost parents in the inventory
+            # file already.
+            self._reweave_step('adding inventories')
+            if isinstance(new_inventory_vf, WeaveFile):
+                # It's really a WeaveFile, but we call straight into the
+                # Weave's add method to disable the auto-write-out behaviour.
+                # This is done to avoid a revision_count * time-to-write additional overhead on 
+                # reconcile.
+                new_inventory_vf._check_write_ok()
+                Weave._add_lines(new_inventory_vf, rev_id, parents,
+                    self.inventory.get_lines(rev_id), None, None, None, False, True)
+            else:
+                new_inventory_vf.add_lines(rev_id, parents, self.inventory.get_lines(rev_id))
+
+        if isinstance(new_inventory_vf, WeaveFile):
+            new_inventory_vf._save()
+        # if this worked, the set of new_inventory_vf.names should equal
         # self.pending
-        if not (set(new_inventories.keys()) ==
-            set([(revid,) for revid in self.pending])):
-            raise AssertionError()
+        assert set(new_inventory_vf.versions()) == self.pending
         self.pb.update('Writing weave')
-        self.repo._activate_new_inventory()
+        self.repo.control_weaves.copy(new_inventory_vf, 'inventory', self.repo.get_transaction())
+        self.repo.control_weaves.delete('inventory.new', self.repo.get_transaction())
         self.inventory = None
         self.pb.note('Inventory regenerated.')
 
-    def _new_inv_parents(self, revision_key):
-        """Lookup ghost-filtered parents for revision_key."""
-        # Use the filtered ghostless parents list:
-        return tuple([(revid,) for revid in self._rev_graph[revision_key[-1]]])
-
-    def _change_inv_parents(self, stream, get_parents, all_revision_keys):
-        """Adapt a record stream to reconcile the parents."""
-        for record in stream:
-            wanted_parents = get_parents(record.key)
-            if wanted_parents and wanted_parents[0] not in all_revision_keys:
-                # The check for the left most parent only handles knit
-                # compressors, but this code only applies to knit and weave
-                # repositories anyway.
-                bytes = record.get_bytes_as('fulltext')
-                yield FulltextContentFactory(record.key, wanted_parents, record.sha1, bytes)
-            else:
-                adapted_record = AdapterFactory(record.key, wanted_parents, record)
-                yield adapted_record
-            self._reweave_step('adding inventories')
-
     def _setup_steps(self, new_total):
         """Setup the markers we need to control the progress bar."""
         self.total = new_total
@@ -290,13 +216,42 @@
         # analyse revision id rev_id and put it in the stack.
         self._reweave_step('loading revisions')
         rev = self.repo.get_revision_reconcile(rev_id)
+        assert rev.revision_id == rev_id
         parents = []
         for parent in rev.parent_ids:
             if self._parent_is_available(parent):
                 parents.append(parent)
             else:
                 mutter('found ghost %s', parent)
-        self._rev_graph[rev_id] = parents
+        self._rev_graph[rev_id] = parents   
+        if self._parents_are_inconsistent(rev_id, parents):
+            self.inconsistent_parents += 1
+            mutter('Inconsistent inventory parents: id {%s} '
+                   'inventory claims %r, '
+                   'available parents are %r, '
+                   'unavailable parents are %r',
+                   rev_id, 
+                   set(self.inventory.get_parents(rev_id)),
+                   set(parents),
+                   set(rev.parent_ids).difference(set(parents)))
+
+    def _parents_are_inconsistent(self, rev_id, parents):
+        """Return True if the parents list of rev_id does not match the weave.
+
+        This detects inconsistencies based on the self.thorough value:
+        if thorough is on, the first parent value is checked as well as ghost
+        differences.
+        Otherwise only the ghost differences are evaluated.
+        """
+        weave_parents = self.inventory.get_parents(rev_id)
+        weave_missing_old_ghosts = set(weave_parents) != set(parents)
+        first_parent_is_wrong = (
+            len(weave_parents) and len(parents) and
+            parents[0] != weave_parents[0])
+        if self.thorough:
+            return weave_missing_old_ghosts or first_parent_is_wrong
+        else:
+            return weave_missing_old_ghosts
 
     def _check_garbage_inventories(self):
         """Check for garbage inventories which we cannot trust
@@ -306,12 +261,12 @@
         """
         if not self.thorough:
             return
-        inventories = set(self.inventory.keys())
-        revisions = set(self.revisions.keys())
+        inventories = set(self.inventory.versions())
+        revisions = set(self._rev_graph.keys())
         garbage = inventories.difference(revisions)
         self.garbage_inventories = len(garbage)
-        for revision_key in garbage:
-            mutter('Garbage inventory {%s} found.', revision_key[-1])
+        for revision_id in garbage:
+            mutter('Garbage inventory {%s} found.', revision_id)
 
     def _parent_is_available(self, parent):
         """True if parent is a fully available revision
@@ -319,10 +274,8 @@
         A fully available revision has a inventory and a revision object in the
         repository.
         """
-        if parent in self._rev_graph:
-            return True
-        inv_present = (1 == len(self.inventory.get_parent_map([(parent,)])))
-        return (inv_present and self.repo.has_revision(parent))
+        return (parent in self._rev_graph or 
+                (parent in self.inventory and self.repo.has_revision(parent)))
 
     def _reweave_step(self, message):
         """Mark a single step of regeneration complete."""
@@ -352,10 +305,10 @@
         """Load indexes for the reconciliation."""
         self.transaction = self.repo.get_transaction()
         self.pb.update('Reading indexes.', 0, 2)
-        self.inventory = self.repo.inventories
+        self.inventory = self.repo.get_inventory_weave()
         self.pb.update('Reading indexes.', 1, 2)
         self.repo._check_for_inconsistent_revision_parents()
-        self.revisions = self.repo.revisions
+        self.revisions = self.repo._revision_store.get_revision_file(self.transaction)
         self.pb.update('Reading indexes.', 2, 2)
 
     def _gc_inventory(self):
@@ -367,29 +320,47 @@
             self.pb.note('Inventory ok.')
             return
         self.pb.update('Backing up inventory...', 0, 0)
-        self.repo._backup_inventory()
+        self.repo.control_weaves.copy(self.inventory, 'inventory.backup', self.transaction)
         self.pb.note('Backup Inventory created.')
         # asking for '' should never return a non-empty weave
-        new_inventories = self.repo._temp_inventories()
+        new_inventory_vf = self.repo.control_weaves.get_empty('inventory.new',
+            self.transaction)
+
         # we have topological order of revisions and non ghost parents ready.
-        graph = self.revisions.get_parent_map(self.revisions.keys())
-        revision_keys = list(TopoSorter(graph).iter_topo_order())
-        revision_ids = [key[-1] for key in revision_keys]
-        self._setup_steps(len(revision_keys))
-        stream = self._change_inv_parents(
-            self.inventory.get_record_stream(revision_keys, 'unordered', True),
-            graph.__getitem__,
-            set(revision_keys))
-        new_inventories.insert_record_stream(stream)
+        self._setup_steps(len(self.revisions))
+        for rev_id in TopoSorter(self.revisions.get_graph().items()).iter_topo_order():
+            parents = self.revisions.get_parents(rev_id)
+            # double check this really is in topological order.
+            unavailable = [p for p in parents if p not in new_inventory_vf]
+            assert len(unavailable) == 0
+            # this entry has all the non ghost parents in the inventory
+            # file already.
+            self._reweave_step('adding inventories')
+            # ugly but needed, weaves are just way tooooo slow else.
+            new_inventory_vf.add_lines(rev_id, parents, self.inventory.get_lines(rev_id))
+
         # if this worked, the set of new_inventory_vf.names should equal
-        # the revisionds list
-        if not(set(new_inventories.keys()) == set(revision_keys)):
-            raise AssertionError()
+        # self.pending
+        assert set(new_inventory_vf.versions()) == set(self.revisions.versions())
         self.pb.update('Writing weave')
-        self.repo._activate_new_inventory()
+        self.repo.control_weaves.copy(new_inventory_vf, 'inventory', self.transaction)
+        self.repo.control_weaves.delete('inventory.new', self.transaction)
         self.inventory = None
         self.pb.note('Inventory regenerated.')
 
+    def _check_garbage_inventories(self):
+        """Check for garbage inventories which we cannot trust
+
+        We cant trust them because their pre-requisite file data may not
+        be present - all we know is that their revision was not installed.
+        """
+        inventories = set(self.inventory.versions())
+        revisions = set(self.revisions.versions())
+        garbage = inventories.difference(revisions)
+        self.garbage_inventories = len(garbage)
+        for revision_id in garbage:
+            mutter('Garbage inventory {%s} found.', revision_id)
+
     def _fix_text_parents(self):
         """Fix bad versionedfile parent entries.
 
@@ -400,135 +371,35 @@
         parent lists, and replaces the versionedfile with a corrected version.
         """
         transaction = self.repo.get_transaction()
-        versions = [key[-1] for key in self.revisions.keys()]
-        mutter('Prepopulating revision text cache with %d revisions',
-                len(versions))
-        vf_checker = self.repo._get_versioned_file_checker()
-        bad_parents, unused_versions = vf_checker.check_file_version_parents(
-            self.repo.texts, self.pb)
-        text_index = vf_checker.text_index
-        per_id_bad_parents = {}
-        for key in unused_versions:
-            # Ensure that every file with unused versions gets rewritten.
-            # NB: This is really not needed, reconcile != pack.
-            per_id_bad_parents[key[0]] = {}
-        # Generate per-knit/weave data.
-        for key, details in bad_parents.iteritems():
-            file_id = key[0]
-            rev_id = key[1]
-            knit_parents = tuple([parent[-1] for parent in details[0]])
-            correct_parents = tuple([parent[-1] for parent in details[1]])
-            file_details = per_id_bad_parents.setdefault(file_id, {})
-            file_details[rev_id] = (knit_parents, correct_parents)
-        file_id_versions = {}
-        for text_key in text_index:
-            versions_list = file_id_versions.setdefault(text_key[0], [])
-            versions_list.append(text_key[1])
-        # Do the reconcile of individual weaves.
-        for num, file_id in enumerate(per_id_bad_parents):
+        revision_versions = repository._RevisionTextVersionCache(self.repo)
+        versions = self.revisions.versions()
+        revision_versions.prepopulate_revs(versions)
+        for num, file_id in enumerate(self.repo.weave_store):
             self.pb.update('Fixing text parents', num,
-                           len(per_id_bad_parents))
-            versions_with_bad_parents = per_id_bad_parents[file_id]
-            id_unused_versions = set(key[-1] for key in unused_versions
-                if key[0] == file_id)
-            if file_id in file_id_versions:
-                file_versions = file_id_versions[file_id]
-            else:
-                # This id was present in the disk store but is not referenced
-                # by any revision at all.
-                file_versions = []
-            self._fix_text_parent(file_id, versions_with_bad_parents,
-                 id_unused_versions, file_versions)
+                           len(self.repo.weave_store))
+            vf = self.repo.weave_store.get_weave(file_id, transaction)
+            vf_checker = self.repo.get_versioned_file_checker(
+                versions, revision_versions)
+            versions_with_bad_parents = vf_checker.check_file_version_parents(
+                vf, file_id)
+            if len(versions_with_bad_parents) == 0:
+                continue
+            self._fix_text_parent(file_id, vf, versions_with_bad_parents)
 
-    def _fix_text_parent(self, file_id, versions_with_bad_parents,
-            unused_versions, all_versions):
+    def _fix_text_parent(self, file_id, vf, versions_with_bad_parents):
         """Fix bad versionedfile entries in a single versioned file."""
-        mutter('fixing text parent: %r (%d versions)', file_id,
-                len(versions_with_bad_parents))
-        mutter('(%d are unused)', len(unused_versions))
-        new_file_id = 'temp:%s' % file_id
+        new_vf = self.repo.weave_store.get_empty('temp:%s' % file_id,
+            self.transaction)
         new_parents = {}
-        needed_keys = set()
-        for version in all_versions:
-            if version in unused_versions:
-                continue
-            elif version in versions_with_bad_parents:
+        for version in vf.versions():
+            if version in versions_with_bad_parents:
                 parents = versions_with_bad_parents[version][1]
             else:
-                pmap = self.repo.texts.get_parent_map([(file_id, version)])
-                parents = [key[-1] for key in pmap[(file_id, version)]]
-            new_parents[(new_file_id, version)] = [
-                (new_file_id, parent) for parent in parents]
-            needed_keys.add((file_id, version))
-        def fix_parents(stream):
-            for record in stream:
-                bytes = record.get_bytes_as('fulltext')
-                new_key = (new_file_id, record.key[-1])
-                parents = new_parents[new_key]
-                yield FulltextContentFactory(new_key, parents, record.sha1, bytes)
-        stream = self.repo.texts.get_record_stream(needed_keys, 'topological', True)
-        self.repo._remove_file_id(new_file_id)
-        self.repo.texts.insert_record_stream(fix_parents(stream))
-        self.repo._remove_file_id(file_id)
-        if len(new_parents):
-            self.repo._move_file_id(new_file_id, file_id)
-
-
-class PackReconciler(RepoReconciler):
-    """Reconciler that reconciles a pack based repository.
-
-    Garbage inventories do not affect ancestry queries, and removal is
-    considerably more expensive as there is no separate versioned file for
-    them, so they are not cleaned. In short it is currently a no-op.
-
-    In future this may be a good place to hook in annotation cache checking,
-    index recreation etc.
-    """
-
-    # XXX: The index corruption that _fix_text_parents performs is needed for
-    # packs, but not yet implemented. The basic approach is to:
-    #  - lock the names list
-    #  - perform a customised pack() that regenerates data as needed
-    #  - unlock the names list
-    # https://bugs.edge.launchpad.net/bzr/+bug/154173
-
-    def _reconcile_steps(self):
-        """Perform the steps to reconcile this repository."""
-        if not self.thorough:
-            return
-        collection = self.repo._pack_collection
-        collection.ensure_loaded()
-        collection.lock_names()
-        try:
-            packs = collection.all_packs()
-            all_revisions = self.repo.all_revision_ids()
-            total_inventories = len(list(
-                collection.inventory_index.combined_index.iter_all_entries()))
-            if len(all_revisions):
-                self._packer = repofmt.pack_repo.ReconcilePacker(
-                    collection, packs, ".reconcile", all_revisions)
-                new_pack = self._packer.pack(pb=self.pb)
-                if new_pack is not None:
-                    self._discard_and_save(packs)
-            else:
-                # only make a new pack when there is data to copy.
-                self._discard_and_save(packs)
-            self.garbage_inventories = total_inventories - len(list(
-                collection.inventory_index.combined_index.iter_all_entries()))
-        finally:
-            collection._unlock_names()
-
-    def _discard_and_save(self, packs):
-        """Discard some packs from the repository.
-
-        This removes them from the memory index, saves the in-memory index
-        which makes the newly reconciled pack visible and hides the packs to be
-        discarded, and finally renames the packs being discarded into the
-        obsolete packs directory.
-
-        :param packs: The packs to discard.
-        """
-        for pack in packs:
-            self.repo._pack_collection._remove_pack_from_memory(pack)
-        self.repo._pack_collection._save_pack_names()
-        self.repo._pack_collection._obsolete_packs(packs)
+                parents = vf.get_parents(version)
+            new_parents[version] = parents
+        for version in topo_sort(new_parents.items()):
+            new_vf.add_lines(version, new_parents[version],
+                             vf.get_lines(version))
+        self.repo.weave_store.copy(new_vf, file_id, self.transaction)
+        self.repo.weave_store.delete('temp:%s' % file_id, self.transaction)
+

=== modified file 'bzrlib/reconfigure.py'
--- bzrlib/reconfigure.py	2008-04-24 04:58:42 +0000
+++ bzrlib/reconfigure.py	2007-09-14 14:45:55 +0000
@@ -18,7 +18,6 @@
 
 from bzrlib import (
     branch,
-    bzrdir,
     errors,
     )
 
@@ -31,12 +30,6 @@
             self.repository = self.bzrdir.find_repository()
         except errors.NoRepositoryPresent:
             self.repository = None
-        else:
-            if (self.repository.bzrdir.root_transport.base ==
-                self.bzrdir.root_transport.base):
-                self.local_repository = self.repository
-            else:
-                self.local_repository = None
         try:
             branch = self.bzrdir.open_branch()
             if branch.bzrdir.root_transport.base == bzrdir.root_transport.base:
@@ -55,13 +48,10 @@
         self._unbind = False
         self._bind = False
         self._destroy_reference = False
-        self._create_reference = False
-        self._destroy_branch = False
         self._create_branch = False
         self._destroy_tree = False
         self._create_tree = False
         self._create_repository = False
-        self._destroy_repository = False
 
     @staticmethod
     def to_branch(bzrdir):
@@ -69,10 +59,12 @@
 
         :param bzrdir: The bzrdir to reconfigure
         :raise errors.AlreadyBranch: if bzrdir is already a branch
+        :raise errors.ReconfigurationNotSupported: if bzrdir does not contain
+            a branch or branch reference
         """
         reconfiguration = Reconfigure(bzrdir)
         reconfiguration._plan_changes(want_tree=False, want_branch=True,
-                                      want_bound=False, want_reference=False)
+                                      want_bound=False)
         if not reconfiguration.changes_planned():
             raise errors.AlreadyBranch(bzrdir)
         return reconfiguration
@@ -83,10 +75,12 @@
 
         :param bzrdir: The bzrdir to reconfigure
         :raise errors.AlreadyTree: if bzrdir is already a tree
+        :raise errors.ReconfigurationNotSupported: if bzrdir does not contain
+            a branch or branch reference
         """
         reconfiguration = Reconfigure(bzrdir)
         reconfiguration._plan_changes(want_tree=True, want_branch=True,
-                                      want_bound=False, want_reference=False)
+                                      want_bound=False)
         if not reconfiguration.changes_planned():
             raise errors.AlreadyTree(bzrdir)
         return reconfiguration
@@ -98,76 +92,29 @@
         :param bzrdir: The bzrdir to reconfigure
         :param bound_location: The location the checkout should be bound to.
         :raise errors.AlreadyCheckout: if bzrdir is already a checkout
+        :raise errors.ReconfigurationNotSupported: if bzrdir does not contain
+            a branch or branch reference
         """
         reconfiguration = Reconfigure(bzrdir, bound_location)
         reconfiguration._plan_changes(want_tree=True, want_branch=True,
-                                      want_bound=True, want_reference=False)
+                                      want_bound=True)
         if not reconfiguration.changes_planned():
             raise errors.AlreadyCheckout(bzrdir)
         return reconfiguration
 
-    @classmethod
-    def to_lightweight_checkout(klass, bzrdir, reference_location=None):
-        """Make a Reconfiguration to convert bzrdir into a lightweight checkout
-
-        :param bzrdir: The bzrdir to reconfigure
-        :param bound_location: The location the checkout should be bound to.
-        :raise errors.AlreadyLightweightCheckout: if bzrdir is already a
-            lightweight checkout
-        """
-        reconfiguration = klass(bzrdir, reference_location)
-        reconfiguration._plan_changes(want_tree=True, want_branch=False,
-                                      want_bound=False, want_reference=True)
-        if not reconfiguration.changes_planned():
-            raise errors.AlreadyLightweightCheckout(bzrdir)
-        return reconfiguration
-
-    @classmethod
-    def to_use_shared(klass, bzrdir):
-        """Convert a standalone branch into a repository branch"""
-        reconfiguration = klass(bzrdir)
-        reconfiguration._set_use_shared(use_shared=True)
-        if not reconfiguration.changes_planned():
-            raise errors.AlreadyUsingShared(bzrdir)
-        return reconfiguration
-
-    @classmethod
-    def to_standalone(klass, bzrdir):
-        """Convert a repository branch into a standalone branch"""
-        reconfiguration = klass(bzrdir)
-        reconfiguration._set_use_shared(use_shared=False)
-        if not reconfiguration.changes_planned():
-            raise errors.AlreadyStandalone(bzrdir)
-        return reconfiguration
-
-    def _plan_changes(self, want_tree, want_branch, want_bound,
-                      want_reference):
+    def _plan_changes(self, want_tree, want_branch, want_bound):
         """Determine which changes are needed to assume the configuration"""
-        if not want_branch and not want_reference:
-            raise errors.ReconfigurationNotSupported(self.bzrdir)
-        if want_branch and want_reference:
-            raise errors.ReconfigurationNotSupported(self.bzrdir)
         if self.repository is None:
-            if not want_reference:
-                self._create_repository = True
-        else:
-            if want_reference and (self.repository.bzrdir.root_transport.base
-                                   == self.bzrdir.root_transport.base):
-                if not self.repository.is_shared():
-                    self._destroy_repository = True
-        if self.referenced_branch is None:
-            if want_reference:
-                self._create_reference = True
-                if self.local_branch is not None:
-                    self._destroy_branch = True
-        else:
-            if not want_reference:
-                self._destroy_reference = True
+            self._create_repository = True
         if self.local_branch is None:
             if want_branch is True:
-                self._create_branch = True
-                if want_bound:
-                    self._bind = True
+                if self.referenced_branch is not None:
+                    self._destroy_reference = True
+                    self._create_branch = True
+                    if want_bound:
+                        self._bind = True
+                else:
+                    raise errors.ReconfigurationNotSupported(self.bzrdir)
         else:
             if want_bound:
                 if self.local_branch.get_bound_location() is None:
@@ -180,22 +127,11 @@
         if want_tree and self.tree is None:
             self._create_tree = True
 
-    def _set_use_shared(self, use_shared=None):
-        if use_shared is None:
-            return
-        if use_shared:
-            if self.local_repository is not None:
-                self._destroy_repository = True
-        else:
-            if self.local_repository is None:
-                self._create_repository = True
-
     def changes_planned(self):
         """Return True if changes are planned, False otherwise"""
         return (self._unbind or self._bind or self._destroy_tree
                 or self._create_tree or self._destroy_reference
-                or self._create_branch or self._create_repository
-                or self._create_reference or self._destroy_repository)
+                or self._create_branch or self._create_repository)
 
     def _check(self):
         """Raise if reconfiguration would destroy local changes"""
@@ -203,29 +139,20 @@
             changes = self.tree.changes_from(self.tree.basis_tree())
             if changes.has_changed():
                 raise errors.UncommittedChanges(self.tree)
-        if self._create_reference and self.local_branch is not None:
-            reference_branch = branch.Branch.open(self._select_bind_location())
-            if (reference_branch.last_revision() !=
-                self.local_branch.last_revision()):
-                raise errors.UnsyncedBranches(self.bzrdir, reference_branch)
 
     def _select_bind_location(self):
-        """Select a location to bind or create a reference to.
+        """Select a location to bind to.
 
         Preference is:
         1. user specified location
         2. branch reference location (it's a kind of bind location)
-        3. current bind location
-        4. previous bind location (it was a good choice once)
-        5. push location (it's writeable, so committable)
-        6. parent location (it's pullable, so update-from-able)
+        3. previous bind location (it was a good choice once)
+        4. push location (it's writeable, so committable)
+        5. parent location (it's pullable, so update-from-able)
         """
         if self.new_bound_location is not None:
             return self.new_bound_location
         if self.local_branch is not None:
-            bound = self.local_branch.get_bound_location()
-            if bound is not None:
-                return bound
             old_bound = self.local_branch.get_old_bound_location()
             if old_bound is not None:
                 return old_bound
@@ -253,44 +180,19 @@
             self._check()
         if self._create_repository:
             repo = self.bzrdir.create_repository()
-            if self.local_branch and not self._destroy_branch:
-                repo.fetch(self.local_branch.repository,
-                           self.local_branch.last_revision())
         else:
             repo = self.repository
-        if self._create_branch and self.referenced_branch is not None:
+        if self._create_branch:
             repo.fetch(self.referenced_branch.repository,
                        self.referenced_branch.last_revision())
-        if self._create_reference:
-            reference_branch = branch.Branch.open(self._select_bind_location())
-        if self._destroy_repository:
-            if self._create_reference:
-                reference_branch.repository.fetch(self.repository)
-            elif self.local_branch is not None and not self._destroy_branch:
-                up = self.local_branch.bzrdir.root_transport.clone('..')
-                up_bzrdir = bzrdir.BzrDir.open_containing_from_transport(up)[0]
-                new_repo = up_bzrdir.find_repository()
-                new_repo.fetch(self.repository)
-        last_revision_info = None
         if self._destroy_reference:
-            last_revision_info = self.referenced_branch.last_revision_info()
-            self.bzrdir.destroy_branch()
-        if self._destroy_branch:
-            last_revision_info = self.local_branch.last_revision_info()
-            if self._create_reference:
-                self.local_branch.tags.merge_to(reference_branch.tags)
+            reference_info = self.referenced_branch.last_revision_info()
             self.bzrdir.destroy_branch()
         if self._create_branch:
             local_branch = self.bzrdir.create_branch()
-            if last_revision_info is not None:
-                local_branch.set_last_revision_info(*last_revision_info)
-            if self._destroy_reference:
-                self.referenced_branch.tags.merge_to(local_branch.tags)
+            local_branch.set_last_revision_info(*reference_info)
         else:
             local_branch = self.local_branch
-        if self._create_reference:
-            format = branch.BranchReferenceFormat().initialize(self.bzrdir,
-                reference_branch)
         if self._destroy_tree:
             self.bzrdir.destroy_workingtree()
         if self._create_tree:
@@ -300,5 +202,3 @@
         if self._bind:
             bind_location = self._select_bind_location()
             local_branch.bind(branch.Branch.open(bind_location))
-        if self._destroy_repository:
-            self.bzrdir.destroy_repository()

=== modified file 'bzrlib/registry.py'
--- bzrlib/registry.py	2008-03-07 11:46:20 +0000
+++ bzrlib/registry.py	2007-10-02 05:33:39 +0000
@@ -167,17 +167,6 @@
         """
         return self._dict[self._get_key_or_default(key)].get_obj()
 
-    def get_prefix(self, fullname):
-        """Return an object whose key is a prefix of the supplied value.
-
-        :fullname: The name to find a prefix for
-        :return: a tuple of (object, remainder), where the remainder is the
-            portion of the name that did not match the key.
-        """
-        for key, value in self.iteritems():
-            if fullname.startswith(key):
-                return value, fullname[len(key):]
-
     def _get_key_or_default(self, key=None):
         """Return either 'key' or the default key if key is None"""
         if key is not None:

=== modified file 'bzrlib/remote.py'
--- bzrlib/remote.py	2008-09-01 06:19:29 +0000
+++ bzrlib/remote.py	2007-10-15 05:23:29 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007, 2008 Canonical Ltd
+# Copyright (C) 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -17,37 +17,28 @@
 # TODO: At some point, handle upgrades by just passing the whole request
 # across to run on the server.
 
-import bz2
 from cStringIO import StringIO
 
 from bzrlib import (
     branch,
-    debug,
     errors,
-    graph,
     lockdir,
     repository,
-    revision,
-    symbol_versioning,
 )
-from bzrlib.branch import BranchReferenceFormat
+from bzrlib.branch import Branch, BranchReferenceFormat
 from bzrlib.bzrdir import BzrDir, RemoteBzrDirFormat
 from bzrlib.config import BranchConfig, TreeConfig
 from bzrlib.decorators import needs_read_lock, needs_write_lock
-from bzrlib.errors import (
-    NoSuchRevision,
-    SmartProtocolError,
-    )
+from bzrlib.errors import NoSuchRevision
 from bzrlib.lockable_files import LockableFiles
-from bzrlib.pack import ContainerPushParser
+from bzrlib.pack import ContainerReader
+from bzrlib.revision import NULL_REVISION
 from bzrlib.smart import client, vfs
 from bzrlib.symbol_versioning import (
-    deprecated_in,
     deprecated_method,
+    zero_ninetyone,
     )
-from bzrlib.revision import ensure_null, NULL_REVISION
-from bzrlib.trace import mutter, note, warning
-
+from bzrlib.trace import note
 
 # Note: RemoteBzrDirFormat is in bzrdir.py
 
@@ -66,10 +57,11 @@
         self._real_bzrdir = None
 
         if _client is None:
-            medium = transport.get_smart_medium()
-            self._client = client._SmartClient(medium)
+            self._shared_medium = transport.get_shared_medium()
+            self._client = client._SmartClient(self._shared_medium)
         else:
             self._client = _client
+            self._shared_medium = None
             return
 
         path = self._path_for_remote_call(self._client)
@@ -88,23 +80,11 @@
             self._real_bzrdir = BzrDir.open_from_transport(
                 self.root_transport, _server_formats=False)
 
-    def cloning_metadir(self, stacked=False):
-        self._ensure_real()
-        return self._real_bzrdir.cloning_metadir(stacked)
-
-    def _translate_error(self, err, **context):
-        _translate_error(err, bzrdir=self, **context)
-        
     def create_repository(self, shared=False):
         self._ensure_real()
         self._real_bzrdir.create_repository(shared=shared)
         return self.open_repository()
 
-    def destroy_repository(self):
-        """See BzrDir.destroy_repository"""
-        self._ensure_real()
-        self._real_bzrdir.destroy_repository()
-
     def create_branch(self):
         self._ensure_real()
         real_branch = self._real_bzrdir.create_branch()
@@ -115,7 +95,7 @@
         self._ensure_real()
         self._real_bzrdir.destroy_branch()
 
-    def create_workingtree(self, revision_id=None, from_branch=None):
+    def create_workingtree(self, revision_id=None):
         raise errors.NotLocalUrl(self.transport.base)
 
     def find_branch_format(self):
@@ -129,10 +109,7 @@
     def get_branch_reference(self):
         """See BzrDir.get_branch_reference()."""
         path = self._path_for_remote_call(self._client)
-        try:
-            response = self._client.call('BzrDir.open_branch', path)
-        except errors.ErrorFromSmartServer, err:
-            self._translate_error(err)
+        response = self._client.call('BzrDir.open_branch', path)
         if response[0] == 'ok':
             if response[1] == '':
                 # branch at this location.
@@ -140,16 +117,13 @@
             else:
                 # a branch reference, use the existing BranchReference logic.
                 return response[1]
+        elif response == ('nobranch',):
+            raise errors.NotBranchError(path=self.root_transport.base)
         else:
             raise errors.UnexpectedSmartServerResponse(response)
 
-    def _get_tree_branch(self):
-        """See BzrDir._get_tree_branch()."""
-        return None, self.open_branch()
-
     def open_branch(self, _unsupported=False):
-        if _unsupported:
-            raise NotImplementedError('unsupported flag support not implemented yet.')
+        assert _unsupported == False, 'unsupported flag support not implemented yet.'
         reference_url = self.get_branch_reference()
         if reference_url is None:
             # branch at this location.
@@ -161,31 +135,16 @@
                 
     def open_repository(self):
         path = self._path_for_remote_call(self._client)
-        verb = 'BzrDir.find_repositoryV2'
-        try:
-            try:
-                response = self._client.call(verb, path)
-            except errors.UnknownSmartMethod:
-                verb = 'BzrDir.find_repository'
-                response = self._client.call(verb, path)
-        except errors.ErrorFromSmartServer, err:
-            self._translate_error(err)
-        if response[0] != 'ok':
-            raise errors.UnexpectedSmartServerResponse(response)
-        if verb == 'BzrDir.find_repository':
-            # servers that don't support the V2 method don't support external
-            # references either.
-            response = response + ('no', )
-        if not (len(response) == 5):
-            raise SmartProtocolError('incorrect response length %s' % (response,))
+        response = self._client.call('BzrDir.find_repository', path)
+        assert response[0] in ('ok', 'norepository'), \
+            'unexpected response code %s' % (response,)
+        if response[0] == 'norepository':
+            raise errors.NoRepositoryPresent(self)
+        assert len(response) == 4, 'incorrect response length %s' % (response,)
         if response[1] == '':
             format = RemoteRepositoryFormat()
             format.rich_root_data = (response[2] == 'yes')
             format.supports_tree_reference = (response[3] == 'yes')
-            # No wire format to check this yet.
-            format.supports_external_lookups = (response[4] == 'yes')
-            # Used to support creating a real format instance when needed.
-            format._creating_bzrdir = self
             return RemoteRepository(self, format)
         else:
             raise errors.NoRepositoryPresent(self)
@@ -221,15 +180,10 @@
         """Upgrading of remote bzrdirs is not supported yet."""
         return False
 
-    def clone(self, url, revision_id=None, force_new_repo=False,
-              preserve_stacking=False):
+    def clone(self, url, revision_id=None, force_new_repo=False):
         self._ensure_real()
         return self._real_bzrdir.clone(url, revision_id=revision_id,
-            force_new_repo=force_new_repo, preserve_stacking=preserve_stacking)
-
-    def get_config(self):
-        self._ensure_real()
-        return self._real_bzrdir.get_config()
+            force_new_repo=force_new_repo)
 
 
 class RemoteRepositoryFormat(repository.RepositoryFormat):
@@ -238,26 +192,22 @@
     Instances of this repository are represented by RemoteRepository
     instances.
 
-    The RemoteRepositoryFormat is parameterized during construction
+    The RemoteRepositoryFormat is parameterised during construction
     to reflect the capabilities of the real, remote format. Specifically
     the attributes rich_root_data and supports_tree_reference are set
     on a per instance basis, and are not set (and should not be) at
     the class level.
     """
 
-    _matchingbzrdir = RemoteBzrDirFormat()
+    _matchingbzrdir = RemoteBzrDirFormat
 
     def initialize(self, a_bzrdir, shared=False):
-        if not isinstance(a_bzrdir, RemoteBzrDir):
-            prior_repo = self._creating_bzrdir.open_repository()
-            prior_repo._ensure_real()
-            return prior_repo._real_repository._format.initialize(
-                a_bzrdir, shared=shared)
+        assert isinstance(a_bzrdir, RemoteBzrDir), \
+            '%r is not a RemoteBzrDir' % (a_bzrdir,)
         return a_bzrdir.create_repository(shared=shared)
     
     def open(self, a_bzrdir):
-        if not isinstance(a_bzrdir, RemoteBzrDir):
-            raise AssertionError('%r is not a RemoteBzrDir' % (a_bzrdir,))
+        assert isinstance(a_bzrdir, RemoteBzrDir)
         return a_bzrdir.open_repository()
 
     def get_format_description(self):
@@ -300,7 +250,7 @@
             self._real_repository = None
         self.bzrdir = remote_bzrdir
         if _client is None:
-            self._client = remote_bzrdir._client
+            self._client = client._SmartClient(self.bzrdir._shared_medium)
         else:
             self._client = _client
         self._format = format
@@ -308,21 +258,10 @@
         self._lock_token = None
         self._lock_count = 0
         self._leave_lock = False
-        # A cache of looked up revision parent data; reset at unlock time.
-        self._parents_map = None
-        if 'hpss' in debug.debug_flags:
-            self._requested_parents = None
-        # For tests:
-        # These depend on the actual remote format, so force them off for
-        # maximum compatibility. XXX: In future these should depend on the
-        # remote repository instance, but this is irrelevant until we perform
-        # reconcile via an RPC call.
-        self._reconcile_does_inventory_gc = False
-        self._reconcile_fixes_text_parents = False
-        self._reconcile_backsup_inventory = False
+        # for tests
+        self._reconcile_does_inventory_gc = True
+        self._reconcile_fixes_text_parents = True
         self.base = self.bzrdir.transport.base
-        # Additional places to query for data.
-        self._fallback_repositories = []
 
     def __str__(self):
         return "%s(%s)" % (self.__class__.__name__, self.base)
@@ -361,106 +300,59 @@
             #self._real_repository = self.bzrdir._real_bzrdir.open_repository()
             self._set_real_repository(self.bzrdir._real_bzrdir.open_repository())
 
-    def _translate_error(self, err, **context):
-        self.bzrdir._translate_error(err, repository=self, **context)
-
-    def find_text_key_references(self):
-        """Find the text key references within the repository.
-
-        :return: a dictionary mapping (file_id, revision_id) tuples to altered file-ids to an iterable of
-        revision_ids. Each altered file-ids has the exact revision_ids that
-        altered it listed explicitly.
-        :return: A dictionary mapping text keys ((fileid, revision_id) tuples)
-            to whether they were referred to by the inventory of the
-            revision_id that they contain. The inventory texts from all present
-            revision ids are assessed to generate this report.
-        """
-        self._ensure_real()
-        return self._real_repository.find_text_key_references()
-
-    def _generate_text_key_index(self):
-        """Generate a new text key index for the repository.
-
-        This is an expensive function that will take considerable time to run.
-
-        :return: A dict mapping (file_id, revision_id) tuples to a list of
-            parents, also (file_id, revision_id) tuples.
-        """
-        self._ensure_real()
-        return self._real_repository._generate_text_key_index()
-
-    @symbol_versioning.deprecated_method(symbol_versioning.one_four)
     def get_revision_graph(self, revision_id=None):
         """See Repository.get_revision_graph()."""
-        return self._get_revision_graph(revision_id)
-
-    def _get_revision_graph(self, revision_id):
-        """Private method for using with old (< 1.2) servers to fallback."""
         if revision_id is None:
             revision_id = ''
-        elif revision.is_null(revision_id):
+        elif revision_id == NULL_REVISION:
             return {}
 
         path = self.bzrdir._path_for_remote_call(self._client)
-        try:
-            response = self._client.call_expecting_body(
-                'Repository.get_revision_graph', path, revision_id)
-        except errors.ErrorFromSmartServer, err:
-            self._translate_error(err)
-        response_tuple, response_handler = response
-        if response_tuple[0] != 'ok':
-            raise errors.UnexpectedSmartServerResponse(response_tuple)
-        coded = response_handler.read_body_bytes()
-        if coded == '':
-            # no revisions in this repository!
-            return {}
-        lines = coded.split('\n')
-        revision_graph = {}
-        for line in lines:
-            d = tuple(line.split())
-            revision_graph[d[0]] = d[1:]
-            
-        return revision_graph
+        assert type(revision_id) is str
+        response = self._client.call_expecting_body(
+            'Repository.get_revision_graph', path, revision_id)
+        if response[0][0] not in ['ok', 'nosuchrevision']:
+            raise errors.UnexpectedSmartServerResponse(response[0])
+        if response[0][0] == 'ok':
+            coded = response[1].read_body_bytes()
+            if coded == '':
+                # no revisions in this repository!
+                return {}
+            lines = coded.split('\n')
+            revision_graph = {}
+            for line in lines:
+                d = tuple(line.split())
+                revision_graph[d[0]] = d[1:]
+                
+            return revision_graph
+        else:
+            response_body = response[1].read_body_bytes()
+            assert response_body == ''
+            raise NoSuchRevision(self, revision_id)
 
     def has_revision(self, revision_id):
         """See Repository.has_revision()."""
-        if revision_id == NULL_REVISION:
+        if revision_id is None:
             # The null revision is always present.
             return True
         path = self.bzrdir._path_for_remote_call(self._client)
-        response = self._client.call(
-            'Repository.has_revision', path, revision_id)
-        if response[0] not in ('yes', 'no'):
-            raise errors.UnexpectedSmartServerResponse(response)
+        response = self._client.call('Repository.has_revision', path, revision_id)
+        assert response[0] in ('yes', 'no'), 'unexpected response code %s' % (response,)
         return response[0] == 'yes'
 
-    def has_revisions(self, revision_ids):
-        """See Repository.has_revisions()."""
-        result = set()
-        for revision_id in revision_ids:
-            if self.has_revision(revision_id):
-                result.add(revision_id)
-        return result
-
     def has_same_location(self, other):
         return (self.__class__ == other.__class__ and
                 self.bzrdir.transport.base == other.bzrdir.transport.base)
         
     def get_graph(self, other_repository=None):
         """Return the graph for this repository format"""
-        parents_provider = self
-        if (other_repository is not None and
-            other_repository.bzrdir.transport.base !=
-            self.bzrdir.transport.base):
-            parents_provider = graph._StackedParentsProvider(
-                [parents_provider, other_repository._make_parents_provider()])
-        return graph.Graph(parents_provider)
+        self._ensure_real()
+        return self._real_repository.get_graph(other_repository)
 
     def gather_stats(self, revid=None, committers=None):
         """See Repository.gather_stats()."""
         path = self.bzrdir._path_for_remote_call(self._client)
-        # revid can be None to indicate no revisions, not just NULL_REVISION
-        if revid is None or revision.is_null(revid):
+        if revid in (None, NULL_REVISION):
             fmt_revid = ''
         else:
             fmt_revid = revid
@@ -468,12 +360,12 @@
             fmt_committers = 'no'
         else:
             fmt_committers = 'yes'
-        response_tuple, response_handler = self._client.call_expecting_body(
+        response = self._client.call_expecting_body(
             'Repository.gather_stats', path, fmt_revid, fmt_committers)
-        if response_tuple[0] != 'ok':
-            raise errors.UnexpectedSmartServerResponse(response_tuple)
+        assert response[0][0] == 'ok', \
+            'unexpected response code %s' % (response[0],)
 
-        body = response_handler.read_body_bytes()
+        body = response[1].read_body_bytes()
         result = {}
         for line in body.split('\n'):
             if not line:
@@ -487,17 +379,9 @@
 
         return result
 
-    def find_branches(self, using=False):
-        """See Repository.find_branches()."""
-        # should be an API call to the server.
-        self._ensure_real()
-        return self._real_repository.find_branches(using=using)
-
     def get_physical_lock_status(self):
         """See Repository.get_physical_lock_status()."""
-        # should be an API call to the server.
-        self._ensure_real()
-        return self._real_repository.get_physical_lock_status()
+        return False
 
     def is_in_write_group(self):
         """Return True if there is an open write group.
@@ -514,8 +398,7 @@
         """See Repository.is_shared()."""
         path = self.bzrdir._path_for_remote_call(self._client)
         response = self._client.call('Repository.is_shared', path)
-        if response[0] not in ('yes', 'no'):
-            raise SmartProtocolError('unexpected response code %s' % (response,))
+        assert response[0] in ('yes', 'no'), 'unexpected response code %s' % (response,)
         return response[0] == 'yes'
 
     def is_write_locked(self):
@@ -526,9 +409,6 @@
         if not self._lock_mode:
             self._lock_mode = 'r'
             self._lock_count = 1
-            self._parents_map = {}
-            if 'hpss' in debug.debug_flags:
-                self._requested_parents = set()
             if self._real_repository is not None:
                 self._real_repository.lock_read()
         else:
@@ -538,24 +418,23 @@
         path = self.bzrdir._path_for_remote_call(self._client)
         if token is None:
             token = ''
-        try:
-            response = self._client.call('Repository.lock_write', path, token)
-        except errors.ErrorFromSmartServer, err:
-            self._translate_error(err, token=token)
-
+        response = self._client.call('Repository.lock_write', path, token)
         if response[0] == 'ok':
             ok, token = response
             return token
+        elif response[0] == 'LockContention':
+            raise errors.LockContention('(remote lock)')
+        elif response[0] == 'UnlockableTransport':
+            raise errors.UnlockableTransport(self.bzrdir.root_transport)
+        elif response[0] == 'LockFailed':
+            raise errors.LockFailed(response[1], response[2])
         else:
             raise errors.UnexpectedSmartServerResponse(response)
 
     def lock_write(self, token=None):
         if not self._lock_mode:
             self._lock_token = self._remote_lock_write(token)
-            # if self._lock_token is None, then this is something like packs or
-            # svn where we don't get to lock the repo, or a weave style repository
-            # where we cannot lock it over the wire and attempts to do so will
-            # fail.
+            assert self._lock_token, 'Remote server did not return a token!'
             if self._real_repository is not None:
                 self._real_repository.lock_write(token=self._lock_token)
             if token is not None:
@@ -564,23 +443,16 @@
                 self._leave_lock = False
             self._lock_mode = 'w'
             self._lock_count = 1
-            self._parents_map = {}
-            if 'hpss' in debug.debug_flags:
-                self._requested_parents = set()
         elif self._lock_mode == 'r':
             raise errors.ReadOnlyError(self)
         else:
             self._lock_count += 1
-        return self._lock_token or None
+        return self._lock_token
 
     def leave_lock_in_place(self):
-        if not self._lock_token:
-            raise NotImplementedError(self.leave_lock_in_place)
         self._leave_lock = True
 
     def dont_leave_lock_in_place(self):
-        if not self._lock_token:
-            raise NotImplementedError(self.dont_leave_lock_in_place)
         self._leave_lock = False
 
     def _set_real_repository(self, repository):
@@ -589,8 +461,7 @@
         :param repository: The repository to fallback to for non-hpss
             implemented operations.
         """
-        if isinstance(repository, RemoteRepository):
-            raise AssertionError()
+        assert not isinstance(repository, RemoteRepository)
         self._real_repository = repository
         if self._lock_mode == 'w':
             # if we are already locked, the real repository must be able to
@@ -612,45 +483,35 @@
 
     def _unlock(self, token):
         path = self.bzrdir._path_for_remote_call(self._client)
-        if not token:
-            # with no token the remote repository is not persistently locked.
-            return
-        try:
-            response = self._client.call('Repository.unlock', path, token)
-        except errors.ErrorFromSmartServer, err:
-            self._translate_error(err, token=token)
+        response = self._client.call('Repository.unlock', path, token)
         if response == ('ok',):
             return
+        elif response[0] == 'TokenMismatch':
+            raise errors.TokenMismatch(token, '(remote token)')
         else:
             raise errors.UnexpectedSmartServerResponse(response)
 
     def unlock(self):
+        if self._lock_count == 1 and self._lock_mode == 'w':
+            # don't unlock if inside a write group.
+            if self.is_in_write_group():
+                raise errors.BzrError(
+                    'Must end write groups before releasing write locks.')
         self._lock_count -= 1
-        if self._lock_count > 0:
-            return
-        self._parents_map = None
-        if 'hpss' in debug.debug_flags:
-            self._requested_parents = None
-        old_mode = self._lock_mode
-        self._lock_mode = None
-        try:
-            # The real repository is responsible at present for raising an
-            # exception if it's in an unfinished write group.  However, it
-            # normally will *not* actually remove the lock from disk - that's
-            # done by the server on receiving the Repository.unlock call.
-            # This is just to let the _real_repository stay up to date.
+        if not self._lock_count:
+            mode = self._lock_mode
+            self._lock_mode = None
             if self._real_repository is not None:
                 self._real_repository.unlock()
-        finally:
-            # The rpc-level lock should be released even if there was a
-            # problem releasing the vfs-based lock.
-            if old_mode == 'w':
+            if mode != 'w':
                 # Only write-locked repositories need to make a remote method
                 # call to perfom the unlock.
-                old_token = self._lock_token
-                self._lock_token = None
-                if not self._leave_lock:
-                    self._unlock(old_token)
+                return
+            assert self._lock_token, 'Locked, but no token!'
+            token = self._lock_token
+            self._lock_token = None
+            if not self._leave_lock:
+                self._unlock(token)
 
     def break_lock(self):
         # should hand off to the network
@@ -664,12 +525,8 @@
         """
         import tempfile
         path = self.bzrdir._path_for_remote_call(self._client)
-        try:
-            response, protocol = self._client.call_expecting_body(
-                'Repository.tarball', path, compression)
-        except errors.UnknownSmartMethod:
-            protocol.cancel_read_body()
-            return None
+        response, protocol = self._client.call_expecting_body(
+            'Repository.tarball', path, compression)
         if response[0] == 'ok':
             # Extract the tarball and return it
             t = tempfile.NamedTemporaryFile()
@@ -677,13 +534,17 @@
             t.write(protocol.read_body_bytes())
             t.seek(0)
             return t
+        if (response == ('error', "Generic bzr smart protocol error: "
+                "bad request 'Repository.tarball'") or
+              response == ('error', "Generic bzr smart protocol error: "
+                "bad request u'Repository.tarball'")):
+            protocol.cancel_read_body()
+            return None
         raise errors.UnexpectedSmartServerResponse(response)
 
     def sprout(self, to_bzrdir, revision_id=None):
         # TODO: Option to control what format is created?
-        self._ensure_real()
-        dest_repo = self._real_repository._format.initialize(to_bzrdir,
-                                                             shared=False)
+        dest_repo = to_bzrdir.create_repository()
         dest_repo.fetch(self, revision_id=revision_id)
         return dest_repo
 
@@ -706,23 +567,16 @@
         builder = self._real_repository.get_commit_builder(branch, parents,
                 config, timestamp=timestamp, timezone=timezone,
                 committer=committer, revprops=revprops, revision_id=revision_id)
+        # Make the builder use this RemoteRepository rather than the real one.
+        builder.repository = self
         return builder
 
-    def add_fallback_repository(self, repository):
-        """Add a repository to use for looking up data not held locally.
-        
-        :param repository: A repository.
-        """
-        if not self._format.supports_external_lookups:
-            raise errors.UnstackableRepositoryFormat(self._format, self.base)
-        # We need to accumulate additional repositories here, to pass them in
-        # on various RPC's.
-        self._fallback_repositories.append(repository)
-
+    @needs_write_lock
     def add_inventory(self, revid, inv, parents):
         self._ensure_real()
         return self._real_repository.add_inventory(revid, inv, parents)
 
+    @needs_write_lock
     def add_revision(self, rev_id, rev, inv=None, config=None):
         self._ensure_real()
         return self._real_repository.add_revision(
@@ -733,15 +587,16 @@
         self._ensure_real()
         return self._real_repository.get_inventory(revision_id)
 
-    def iter_inventories(self, revision_ids):
-        self._ensure_real()
-        return self._real_repository.iter_inventories(revision_ids)
-
     @needs_read_lock
     def get_revision(self, revision_id):
         self._ensure_real()
         return self._real_repository.get_revision(revision_id)
 
+    @property
+    def weave_store(self):
+        self._ensure_real()
+        return self._real_repository.weave_store
+
     def get_transaction(self):
         self._ensure_real()
         return self._real_repository.get_transaction()
@@ -752,40 +607,15 @@
         return self._real_repository.clone(a_bzrdir, revision_id=revision_id)
 
     def make_working_trees(self):
-        """See Repository.make_working_trees"""
-        self._ensure_real()
-        return self._real_repository.make_working_trees()
-
-    def revision_ids_to_search_result(self, result_set):
-        """Convert a set of revision ids to a graph SearchResult."""
-        result_parents = set()
-        for parents in self.get_graph().get_parent_map(
-            result_set).itervalues():
-            result_parents.update(parents)
-        included_keys = result_set.intersection(result_parents)
-        start_keys = result_set.difference(included_keys)
-        exclude_keys = result_parents.difference(result_set)
-        result = graph.SearchResult(start_keys, exclude_keys,
-            len(result_set), result_set)
-        return result
-
-    @needs_read_lock
-    def search_missing_revision_ids(self, other, revision_id=None, find_ghosts=True):
-        """Return the revision ids that other has that this does not.
-        
-        These are returned in topological order.
-
-        revision_id: only return revision ids included by revision_id.
-        """
-        return repository.InterRepository.get(
-            other, self).search_missing_revision_ids(revision_id, find_ghosts)
+        """RemoteRepositories never create working trees by default."""
+        return False
 
     def fetch(self, source, revision_id=None, pb=None):
         if self.has_same_location(source):
             # check that last_revision is in 'from' and then return a
             # no-operation.
             if (revision_id is not None and
-                not revision.is_null(revision_id)):
+                not _mod_revision.is_null(revision_id)):
                 self.get_revision(revision_id)
             return 0, []
         self._ensure_real()
@@ -796,18 +626,28 @@
         self._ensure_real()
         self._real_repository.create_bundle(target, base, fileobj, format)
 
+    @property
+    def control_weaves(self):
+        self._ensure_real()
+        return self._real_repository.control_weaves
+
     @needs_read_lock
     def get_ancestry(self, revision_id, topo_sorted=True):
         self._ensure_real()
         return self._real_repository.get_ancestry(revision_id, topo_sorted)
 
+    @needs_read_lock
+    def get_inventory_weave(self):
+        self._ensure_real()
+        return self._real_repository.get_inventory_weave()
+
     def fileids_altered_by_revision_ids(self, revision_ids):
         self._ensure_real()
         return self._real_repository.fileids_altered_by_revision_ids(revision_ids)
 
-    def _get_versioned_file_checker(self, revisions, revision_versions_cache):
+    def get_versioned_file_checker(self, revisions, revision_versions_cache):
         self._ensure_real()
-        return self._real_repository._get_versioned_file_checker(
+        return self._real_repository.get_versioned_file_checker(
             revisions, revision_versions_cache)
         
     def iter_files_bytes(self, desired_files):
@@ -816,172 +656,12 @@
         self._ensure_real()
         return self._real_repository.iter_files_bytes(desired_files)
 
-    @property
-    def _fetch_order(self):
-        """Decorate the real repository for now.
-
-        In the long term getting this back from the remote repository as part
-        of open would be more efficient.
-        """
-        self._ensure_real()
-        return self._real_repository._fetch_order
-
-    @property
-    def _fetch_uses_deltas(self):
-        """Decorate the real repository for now.
-
-        In the long term getting this back from the remote repository as part
-        of open would be more efficient.
-        """
-        self._ensure_real()
-        return self._real_repository._fetch_uses_deltas
-
-    @property
-    def _fetch_reconcile(self):
-        """Decorate the real repository for now.
-
-        In the long term getting this back from the remote repository as part
-        of open would be more efficient.
-        """
-        self._ensure_real()
-        return self._real_repository._fetch_reconcile
-
-    def get_parent_map(self, keys):
-        """See bzrlib.Graph.get_parent_map()."""
-        # Hack to build up the caching logic.
-        ancestry = self._parents_map
-        if ancestry is None:
-            # Repository is not locked, so there's no cache.
-            missing_revisions = set(keys)
-            ancestry = {}
-        else:
-            missing_revisions = set(key for key in keys if key not in ancestry)
-        if missing_revisions:
-            parent_map = self._get_parent_map(missing_revisions)
-            if 'hpss' in debug.debug_flags:
-                mutter('retransmitted revisions: %d of %d',
-                        len(set(ancestry).intersection(parent_map)),
-                        len(parent_map))
-            ancestry.update(parent_map)
-        present_keys = [k for k in keys if k in ancestry]
-        if 'hpss' in debug.debug_flags:
-            if self._requested_parents is not None and len(ancestry) != 0:
-                self._requested_parents.update(present_keys)
-                mutter('Current RemoteRepository graph hit rate: %d%%',
-                    100.0 * len(self._requested_parents) / len(ancestry))
-        return dict((k, ancestry[k]) for k in present_keys)
-
-    def _get_parent_map(self, keys):
-        """Helper for get_parent_map that performs the RPC."""
-        medium = self._client._medium
-        if medium._is_remote_before((1, 2)):
-            # We already found out that the server can't understand
-            # Repository.get_parent_map requests, so just fetch the whole
-            # graph.
-            # XXX: Note that this will issue a deprecation warning. This is ok
-            # :- its because we're working with a deprecated server anyway, and
-            # the user will almost certainly have seen a warning about the
-            # server version already.
-            rg = self.get_revision_graph()
-            # There is an api discrepency between get_parent_map and
-            # get_revision_graph. Specifically, a "key:()" pair in
-            # get_revision_graph just means a node has no parents. For
-            # "get_parent_map" it means the node is a ghost. So fix up the
-            # graph to correct this.
-            #   https://bugs.launchpad.net/bzr/+bug/214894
-            # There is one other "bug" which is that ghosts in
-            # get_revision_graph() are not returned at all. But we won't worry
-            # about that for now.
-            for node_id, parent_ids in rg.iteritems():
-                if parent_ids == ():
-                    rg[node_id] = (NULL_REVISION,)
-            rg[NULL_REVISION] = ()
-            return rg
-
-        keys = set(keys)
-        if None in keys:
-            raise ValueError('get_parent_map(None) is not valid')
-        if NULL_REVISION in keys:
-            keys.discard(NULL_REVISION)
-            found_parents = {NULL_REVISION:()}
-            if not keys:
-                return found_parents
-        else:
-            found_parents = {}
-        # TODO(Needs analysis): We could assume that the keys being requested
-        # from get_parent_map are in a breadth first search, so typically they
-        # will all be depth N from some common parent, and we don't have to
-        # have the server iterate from the root parent, but rather from the
-        # keys we're searching; and just tell the server the keyspace we
-        # already have; but this may be more traffic again.
-
-        # Transform self._parents_map into a search request recipe.
-        # TODO: Manage this incrementally to avoid covering the same path
-        # repeatedly. (The server will have to on each request, but the less
-        # work done the better).
-        parents_map = self._parents_map
-        if parents_map is None:
-            # Repository is not locked, so there's no cache.
-            parents_map = {}
-        start_set = set(parents_map)
-        result_parents = set()
-        for parents in parents_map.itervalues():
-            result_parents.update(parents)
-        stop_keys = result_parents.difference(start_set)
-        included_keys = start_set.intersection(result_parents)
-        start_set.difference_update(included_keys)
-        recipe = (start_set, stop_keys, len(parents_map))
-        body = self._serialise_search_recipe(recipe)
-        path = self.bzrdir._path_for_remote_call(self._client)
-        for key in keys:
-            if type(key) is not str:
-                raise ValueError(
-                    "key %r not a plain string" % (key,))
-        verb = 'Repository.get_parent_map'
-        args = (path,) + tuple(keys)
-        try:
-            response = self._client.call_with_body_bytes_expecting_body(
-                verb, args, self._serialise_search_recipe(recipe))
-        except errors.UnknownSmartMethod:
-            # Server does not support this method, so get the whole graph.
-            # Worse, we have to force a disconnection, because the server now
-            # doesn't realise it has a body on the wire to consume, so the
-            # only way to recover is to abandon the connection.
-            warning(
-                'Server is too old for fast get_parent_map, reconnecting.  '
-                '(Upgrade the server to Bazaar 1.2 to avoid this)')
-            medium.disconnect()
-            # To avoid having to disconnect repeatedly, we keep track of the
-            # fact the server doesn't understand remote methods added in 1.2.
-            medium._remember_remote_is_before((1, 2))
-            return self.get_revision_graph(None)
-        response_tuple, response_handler = response
-        if response_tuple[0] not in ['ok']:
-            response_handler.cancel_read_body()
-            raise errors.UnexpectedSmartServerResponse(response_tuple)
-        if response_tuple[0] == 'ok':
-            coded = bz2.decompress(response_handler.read_body_bytes())
-            if coded == '':
-                # no revisions found
-                return {}
-            lines = coded.split('\n')
-            revision_graph = {}
-            for line in lines:
-                d = tuple(line.split())
-                if len(d) > 1:
-                    revision_graph[d[0]] = d[1:]
-                else:
-                    # No parents - so give the Graph result (NULL_REVISION,).
-                    revision_graph[d[0]] = (NULL_REVISION,)
-            return revision_graph
-
     @needs_read_lock
     def get_signature_text(self, revision_id):
         self._ensure_real()
         return self._real_repository.get_signature_text(revision_id)
 
     @needs_read_lock
-    @symbol_versioning.deprecated_method(symbol_versioning.one_three)
     def get_revision_graph_with_ghosts(self, revision_ids=None):
         self._ensure_real()
         return self._real_repository.get_revision_graph_with_ghosts(
@@ -1039,6 +719,8 @@
         # destination
         from bzrlib import osutils
         import tarfile
+        import tempfile
+        from StringIO import StringIO
         # TODO: Maybe a progress bar while streaming the tarball?
         note("Copying repository content as tarball...")
         tar_file = self._get_tarball('bz2')
@@ -1048,7 +730,7 @@
         try:
             tar = tarfile.open('repository', fileobj=tar_file,
                 mode='r|bz2')
-            tmpdir = osutils.mkdtemp()
+            tmpdir = tempfile.mkdtemp()
             try:
                 _extract_tar(tar, tmpdir)
                 tmp_bzrdir = BzrDir.open(tmpdir)
@@ -1062,16 +744,6 @@
         # TODO: Suggestion from john: using external tar is much faster than
         # python's tarfile library, but it may not work on windows.
 
-    @property
-    def inventories(self):
-        """Decorate the real repository for now.
-
-        In the long term a full blown network facility is needed to
-        avoid creating a real repository object locally.
-        """
-        self._ensure_real()
-        return self._real_repository.inventories
-
     @needs_write_lock
     def pack(self):
         """Compress the data within the repository.
@@ -1081,47 +753,14 @@
         self._ensure_real()
         return self._real_repository.pack()
 
-    @property
-    def revisions(self):
-        """Decorate the real repository for now.
-
-        In the short term this should become a real object to intercept graph
-        lookups.
-
-        In the long term a full blown network facility is needed.
-        """
-        self._ensure_real()
-        return self._real_repository.revisions
-
     def set_make_working_trees(self, new_value):
-        self._ensure_real()
-        self._real_repository.set_make_working_trees(new_value)
-
-    @property
-    def signatures(self):
-        """Decorate the real repository for now.
-
-        In the long term a full blown network facility is needed to avoid
-        creating a real repository object locally.
-        """
-        self._ensure_real()
-        return self._real_repository.signatures
+        raise NotImplementedError(self.set_make_working_trees)
 
     @needs_write_lock
     def sign_revision(self, revision_id, gpg_strategy):
         self._ensure_real()
         return self._real_repository.sign_revision(revision_id, gpg_strategy)
 
-    @property
-    def texts(self):
-        """Decorate the real repository for now.
-
-        In the long term a full blown network facility is needed to avoid
-        creating a real repository object locally.
-        """
-        self._ensure_real()
-        return self._real_repository.texts
-
     @needs_read_lock
     def get_revisions(self, revision_ids):
         self._ensure_real()
@@ -1145,14 +784,44 @@
         return self._real_repository.store_revision_signature(
             gpg_strategy, plaintext, revision_id)
 
-    def add_signature_text(self, revision_id, signature):
-        self._ensure_real()
-        return self._real_repository.add_signature_text(revision_id, signature)
-
     def has_signature_for_revision_id(self, revision_id):
         self._ensure_real()
         return self._real_repository.has_signature_for_revision_id(revision_id)
 
+    def get_data_stream(self, revision_ids):
+        path = self.bzrdir._path_for_remote_call(self._client)
+        response, protocol = self._client.call_expecting_body(
+            'Repository.stream_knit_data_for_revisions', path, *revision_ids)
+        if response == ('ok',):
+            return self._deserialise_stream(protocol)
+        elif (response == ('error', "Generic bzr smart protocol error: "
+                "bad request 'Repository.stream_knit_data_for_revisions'") or
+              response == ('error', "Generic bzr smart protocol error: "
+                "bad request u'Repository.stream_knit_data_for_revisions'")):
+            protocol.cancel_read_body()
+            self._ensure_real()
+            return self._real_repository.get_data_stream(revision_ids)
+        else:
+            raise errors.UnexpectedSmartServerResponse(response)
+
+    def _deserialise_stream(self, protocol):
+        buffer = StringIO(protocol.read_body_bytes())
+        reader = ContainerReader(buffer)
+        for record_names, read_bytes in reader.iter_records():
+            try:
+                # These records should have only one name, and that name
+                # should be a one-element tuple.
+                [name_tuple] = record_names
+            except ValueError:
+                raise errors.SmartProtocolError(
+                    'Repository data stream had invalid record name %r'
+                    % (record_names,))
+            yield name_tuple, read_bytes(None)
+
+    def insert_data_stream(self, stream):
+        self._ensure_real()
+        self._real_repository.insert_data_stream(stream)
+
     def item_keys_introduced_by(self, revision_ids, _files_pb=None):
         self._ensure_real()
         return self._real_repository.item_keys_introduced_by(revision_ids,
@@ -1171,20 +840,6 @@
         self._ensure_real()
         return self._real_repository._check_for_inconsistent_revision_parents()
 
-    def _make_parents_provider(self):
-        return self
-
-    def _serialise_search_recipe(self, recipe):
-        """Serialise a graph search recipe.
-
-        :param recipe: A search recipe (start, stop, count).
-        :return: Serialised bytes.
-        """
-        start_keys = ' '.join(recipe[0])
-        stop_keys = ' '.join(recipe[1])
-        count = str(recipe[2])
-        return '\n'.join((start_keys, stop_keys, count))
-
 
 class RemoteBranchLockableFiles(LockableFiles):
     """A 'LockableFiles' implementation that talks to a smart server.
@@ -1205,6 +860,24 @@
         self._dir_mode = None
         self._file_mode = None
 
+    def get(self, path):
+        """'get' a remote path as per the LockableFiles interface.
+
+        :param path: the file to 'get'. If this is 'branch.conf', we do not
+             just retrieve a file, instead we ask the smart server to generate
+             a configuration for us - which is retrieved as an INI file.
+        """
+        if path == 'branch.conf':
+            path = self.bzrdir._path_for_remote_call(self._client)
+            response = self._client.call_expecting_body(
+                'Branch.get_config_file', path)
+            assert response[0][0] == 'ok', \
+                'unexpected response code %s' % (response[0],)
+            return StringIO(response[1].read_body_bytes())
+        else:
+            # VFS fallback.
+            return LockableFiles.get(self, path)
+
 
 class RemoteBranchFormat(branch.BranchFormat):
 
@@ -1219,9 +892,11 @@
         return 'Remote BZR Branch'
 
     def open(self, a_bzrdir):
+        assert isinstance(a_bzrdir, RemoteBzrDir)
         return a_bzrdir.open_branch()
 
     def initialize(self, a_bzrdir):
+        assert isinstance(a_bzrdir, RemoteBzrDir)
         return a_bzrdir.create_branch()
 
     def supports_tags(self):
@@ -1247,14 +922,12 @@
         # We intentionally don't call the parent class's __init__, because it
         # will try to assign to self.tags, which is a property in this subclass.
         # And the parent's __init__ doesn't do much anyway.
-        self._revision_id_to_revno_cache = None
         self._revision_history_cache = None
-        self._last_revision_info_cache = None
         self.bzrdir = remote_bzrdir
         if _client is not None:
             self._client = _client
         else:
-            self._client = remote_bzrdir._client
+            self._client = client._SmartClient(self.bzrdir._shared_medium)
         self.repository = remote_repository
         if real_branch is not None:
             self._real_branch = real_branch
@@ -1274,17 +947,9 @@
         self._control_files = None
         self._lock_mode = None
         self._lock_token = None
-        self._repo_lock_token = None
         self._lock_count = 0
         self._leave_lock = False
 
-    def _get_real_transport(self):
-        # if we try vfs access, return the real branch's vfs transport
-        self._ensure_real()
-        return self._real_branch._transport
-
-    _transport = property(_get_real_transport)
-
     def __str__(self):
         return "%s(%s)" % (self.__class__.__name__, self.base)
 
@@ -1295,10 +960,8 @@
 
         Used before calls to self._real_branch.
         """
-        if self._real_branch is None:
-            if not vfs.vfs_enabled():
-                raise AssertionError('smart server vfs must be enabled '
-                    'to use vfs implementation')
+        if not self._real_branch:
+            assert vfs.vfs_enabled()
             self.bzrdir._ensure_real()
             self._real_branch = self.bzrdir._real_bzrdir.open_branch()
             # Give the remote repository the matching real repo.
@@ -1313,26 +976,6 @@
             if self._lock_mode == 'r':
                 self._real_branch.lock_read()
 
-    def _translate_error(self, err, **context):
-        self.repository._translate_error(err, branch=self, **context)
-
-    def _clear_cached_state(self):
-        super(RemoteBranch, self)._clear_cached_state()
-        if self._real_branch is not None:
-            self._real_branch._clear_cached_state()
-
-    def _clear_cached_state_of_remote_branch_only(self):
-        """Like _clear_cached_state, but doesn't clear the cache of
-        self._real_branch.
-
-        This is useful when falling back to calling a method of
-        self._real_branch that changes state.  In that case the underlying
-        branch changes, so we need to invalidate this RemoteBranch's cache of
-        it.  However, there's no need to invalidate the _real_branch's cache
-        too, in fact doing so might harm performance.
-        """
-        super(RemoteBranch, self)._clear_cached_state()
-        
     @property
     def control_files(self):
         # Defer actually creating RemoteBranchLockableFiles until its needed,
@@ -1352,18 +995,6 @@
         self._ensure_real()
         return self._real_branch.get_physical_lock_status()
 
-    def get_stacked_on_url(self):
-        """Get the URL this branch is stacked against.
-
-        :raises NotStacked: If the branch is not stacked.
-        :raises UnstackableBranchFormat: If the branch does not support
-            stacking.
-        :raises UnstackableRepositoryFormat: If the repository does not support
-            stacking.
-        """
-        self._ensure_real()
-        return self._real_branch.get_stacked_on_url()
-
     def lock_read(self):
         if not self._lock_mode:
             self._lock_mode = 'r'
@@ -1381,22 +1012,29 @@
             repo_token = self.repository.lock_write()
             self.repository.unlock()
         path = self.bzrdir._path_for_remote_call(self._client)
-        try:
-            response = self._client.call(
-                'Branch.lock_write', path, branch_token, repo_token or '')
-        except errors.ErrorFromSmartServer, err:
-            self._translate_error(err, token=token)
-        if response[0] != 'ok':
+        response = self._client.call('Branch.lock_write', path, branch_token,
+                                     repo_token)
+        if response[0] == 'ok':
+            ok, branch_token, repo_token = response
+            return branch_token, repo_token
+        elif response[0] == 'LockContention':
+            raise errors.LockContention('(remote lock)')
+        elif response[0] == 'TokenMismatch':
+            raise errors.TokenMismatch(token, '(remote token)')
+        elif response[0] == 'UnlockableTransport':
+            raise errors.UnlockableTransport(self.bzrdir.root_transport)
+        elif response[0] == 'ReadOnlyError':
+            raise errors.ReadOnlyError(self)
+        elif response[0] == 'LockFailed':
+            raise errors.LockFailed(response[1], response[2])
+        else:
             raise errors.UnexpectedSmartServerResponse(response)
-        ok, branch_token, repo_token = response
-        return branch_token, repo_token
             
     def lock_write(self, token=None):
         if not self._lock_mode:
             remote_tokens = self._remote_lock_write(token)
             self._lock_token, self._repo_lock_token = remote_tokens
-            if not self._lock_token:
-                raise SmartProtocolError('Remote server did not return a token!')
+            assert self._lock_token, 'Remote server did not return a token!'
             # TODO: We really, really, really don't want to call _ensure_real
             # here, but it's the easiest way to ensure coherency between the
             # state of the RemoteBranch and RemoteRepository objects and the
@@ -1428,18 +1066,19 @@
                 if token != self._lock_token:
                     raise errors.TokenMismatch(token, self._lock_token)
             self._lock_count += 1
-        return self._lock_token or None
+        return self._lock_token
 
     def _unlock(self, branch_token, repo_token):
         path = self.bzrdir._path_for_remote_call(self._client)
-        try:
-            response = self._client.call('Branch.unlock', path, branch_token,
-                                         repo_token or '')
-        except errors.ErrorFromSmartServer, err:
-            self._translate_error(err, token=str((branch_token, repo_token)))
+        response = self._client.call('Branch.unlock', path, branch_token,
+                                     repo_token)
         if response == ('ok',):
             return
-        raise errors.UnexpectedSmartServerResponse(response)
+        elif response[0] == 'TokenMismatch':
+            raise errors.TokenMismatch(
+                str((branch_token, repo_token)), '(remote tokens)')
+        else:
+            raise errors.UnexpectedSmartServerResponse(response)
 
     def unlock(self):
         self._lock_count -= 1
@@ -1448,8 +1087,7 @@
             mode = self._lock_mode
             self._lock_mode = None
             if self._real_branch is not None:
-                if (not self._leave_lock and mode == 'w' and
-                    self._repo_lock_token):
+                if not self._leave_lock:
                     # If this RemoteBranch will remove the physical lock for the
                     # repository, make sure the _real_branch doesn't do it
                     # first.  (Because the _real_branch's repository is set to
@@ -1460,8 +1098,7 @@
                 # Only write-locked branched need to make a remote method call
                 # to perfom the unlock.
                 return
-            if not self._lock_token:
-                raise AssertionError('Locked, but no token!')
+            assert self._lock_token, 'Locked, but no token!'
             branch_token = self._lock_token
             repo_token = self._repo_lock_token
             self._lock_token = None
@@ -1474,20 +1111,16 @@
         return self._real_branch.break_lock()
 
     def leave_lock_in_place(self):
-        if not self._lock_token:
-            raise NotImplementedError(self.leave_lock_in_place)
         self._leave_lock = True
 
     def dont_leave_lock_in_place(self):
-        if not self._lock_token:
-            raise NotImplementedError(self.dont_leave_lock_in_place)
         self._leave_lock = False
 
-    def _last_revision_info(self):
+    def last_revision_info(self):
+        """See Branch.last_revision_info()."""
         path = self.bzrdir._path_for_remote_call(self._client)
         response = self._client.call('Branch.last_revision_info', path)
-        if response[0] != 'ok':
-            raise SmartProtocolError('unexpected response code %s' % (response,))
+        assert response[0] == 'ok', 'unexpected response code %s' % (response,)
         revno = int(response[1])
         last_revision = response[2]
         return (revno, last_revision)
@@ -1495,52 +1128,33 @@
     def _gen_revision_history(self):
         """See Branch._gen_revision_history()."""
         path = self.bzrdir._path_for_remote_call(self._client)
-        response_tuple, response_handler = self._client.call_expecting_body(
+        response = self._client.call_expecting_body(
             'Branch.revision_history', path)
-        if response_tuple[0] != 'ok':
-            raise errors.UnexpectedSmartServerResponse(response_tuple)
-        result = response_handler.read_body_bytes().split('\x00')
+        assert response[0][0] == 'ok', ('unexpected response code %s'
+                                        % (response[0],))
+        result = response[1].read_body_bytes().split('\x00')
         if result == ['']:
             return []
         return result
 
-    def _set_last_revision_descendant(self, revision_id, other_branch,
-            allow_diverged=False, allow_overwrite_descendant=False):
-        path = self.bzrdir._path_for_remote_call(self._client)
-        try:
-            response = self._client.call('Branch.set_last_revision_ex',
-                path, self._lock_token, self._repo_lock_token, revision_id,
-                int(allow_diverged), int(allow_overwrite_descendant))
-        except errors.ErrorFromSmartServer, err:
-            self._translate_error(err, other_branch=other_branch)
-        self._clear_cached_state()
-        if len(response) != 3 and response[0] != 'ok':
-            raise errors.UnexpectedSmartServerResponse(response)
-        new_revno, new_revision_id = response[1:]
-        self._last_revision_info_cache = new_revno, new_revision_id
-        self._real_branch._last_revision_info_cache = new_revno, new_revision_id
-
-    def _set_last_revision(self, revision_id):
-        path = self.bzrdir._path_for_remote_call(self._client)
-        self._clear_cached_state()
-        try:
-            response = self._client.call('Branch.set_last_revision',
-                path, self._lock_token, self._repo_lock_token, revision_id)
-        except errors.ErrorFromSmartServer, err:
-            self._translate_error(err)
-        if response != ('ok',):
-            raise errors.UnexpectedSmartServerResponse(response)
-
     @needs_write_lock
     def set_revision_history(self, rev_history):
         # Send just the tip revision of the history; the server will generate
         # the full history from that.  If the revision doesn't exist in this
         # branch, NoSuchRevision will be raised.
+        path = self.bzrdir._path_for_remote_call(self._client)
         if rev_history == []:
             rev_id = 'null:'
         else:
             rev_id = rev_history[-1]
-        self._set_last_revision(rev_id)
+        self._clear_cached_state()
+        response = self._client.call('Branch.set_last_revision',
+            path, self._lock_token, self._repo_lock_token, rev_id)
+        if response[0] == 'NoSuchRevision':
+            raise NoSuchRevision(self, rev_id)
+        else:
+            assert response == ('ok',), (
+                'unexpected response code %r' % (response,))
         self._cache_revision_history(rev_history)
 
     def get_parent(self):
@@ -1551,24 +1165,15 @@
         self._ensure_real()
         return self._real_branch.set_parent(url)
         
-    def set_stacked_on_url(self, stacked_location):
-        """Set the URL this branch is stacked against.
-
-        :raises UnstackableBranchFormat: If the branch does not support
-            stacking.
-        :raises UnstackableRepositoryFormat: If the repository does not support
-            stacking.
-        """
-        self._ensure_real()
-        return self._real_branch.set_stacked_on_url(stacked_location)
+    def get_config(self):
+        return RemoteBranchConfig(self)
 
     def sprout(self, to_bzrdir, revision_id=None):
         # Like Branch.sprout, except that it sprouts a branch in the default
         # format, because RemoteBranches can't be created at arbitrary URLs.
         # XXX: if to_bzrdir is a RemoteBranch, this should perhaps do
         # to_bzrdir.create_branch...
-        self._ensure_real()
-        result = self._real_branch._format.initialize(to_bzrdir)
+        result = branch.BranchFormat.get_default_format().initialize(to_bzrdir)
         self.copy_content_into(result, revision_id=revision_id)
         result.set_parent(self.bzrdir.root_transport.base)
         return result
@@ -1576,11 +1181,15 @@
     @needs_write_lock
     def pull(self, source, overwrite=False, stop_revision=None,
              **kwargs):
-        self._clear_cached_state_of_remote_branch_only()
+        # FIXME: This asks the real branch to run the hooks, which means
+        # they're called with the wrong target branch parameter. 
+        # The test suite specifically allows this at present but it should be
+        # fixed.  It should get a _override_hook_target branch,
+        # as push does.  -- mbp 20070405
         self._ensure_real()
-        return self._real_branch.pull(
+        self._real_branch.pull(
             source, overwrite=overwrite, stop_revision=stop_revision,
-            _override_hook_target=self, **kwargs)
+            **kwargs)
 
     @needs_read_lock
     def push(self, target, overwrite=False, stop_revision=None):
@@ -1592,50 +1201,15 @@
     def is_locked(self):
         return self._lock_count >= 1
 
-    @needs_read_lock
-    def revision_id_to_revno(self, revision_id):
-        self._ensure_real()
-        return self._real_branch.revision_id_to_revno(revision_id)
-
-    @needs_write_lock
     def set_last_revision_info(self, revno, revision_id):
-        revision_id = ensure_null(revision_id)
-        path = self.bzrdir._path_for_remote_call(self._client)
-        try:
-            response = self._client.call('Branch.set_last_revision_info',
-                path, self._lock_token, self._repo_lock_token, str(revno), revision_id)
-        except errors.UnknownSmartMethod:
-            self._ensure_real()
-            self._clear_cached_state_of_remote_branch_only()
-            self._real_branch.set_last_revision_info(revno, revision_id)
-            self._last_revision_info_cache = revno, revision_id
-            return
-        except errors.ErrorFromSmartServer, err:
-            self._translate_error(err)
-        if response == ('ok',):
-            self._clear_cached_state()
-            self._last_revision_info_cache = revno, revision_id
-            # Update the _real_branch's cache too.
-            if self._real_branch is not None:
-                cache = self._last_revision_info_cache
-                self._real_branch._last_revision_info_cache = cache
-        else:
-            raise errors.UnexpectedSmartServerResponse(response)
+        self._ensure_real()
+        self._clear_cached_state()
+        return self._real_branch.set_last_revision_info(revno, revision_id)
 
-    @needs_write_lock
     def generate_revision_history(self, revision_id, last_rev=None,
                                   other_branch=None):
-        medium = self._client._medium
-        if not medium._is_remote_before((1, 6)):
-            try:
-                self._set_last_revision_descendant(revision_id, other_branch,
-                    allow_diverged=True, allow_overwrite_descendant=True)
-                return
-            except errors.UnknownSmartMethod:
-                medium._remember_remote_is_before((1, 6))
-        self._clear_cached_state_of_remote_branch_only()
         self._ensure_real()
-        self._real_branch.generate_revision_history(
+        return self._real_branch.generate_revision_history(
             revision_id, last_rev=last_rev, other_branch=other_branch)
 
     @property
@@ -1647,44 +1221,23 @@
         self._ensure_real()
         return self._real_branch.set_push_location(location)
 
-    @needs_write_lock
-    def update_revisions(self, other, stop_revision=None, overwrite=False,
-                         graph=None):
-        """See Branch.update_revisions."""
-        other.lock_read()
-        try:
-            if stop_revision is None:
-                stop_revision = other.last_revision()
-                if revision.is_null(stop_revision):
-                    # if there are no commits, we're done.
-                    return
-            self.fetch(other, stop_revision)
-
-            if overwrite:
-                # Just unconditionally set the new revision.  We don't care if
-                # the branches have diverged.
-                self._set_last_revision(stop_revision)
-            else:
-                medium = self._client._medium
-                if not medium._is_remote_before((1, 6)):
-                    try:
-                        self._set_last_revision_descendant(stop_revision, other)
-                        return
-                    except errors.UnknownSmartMethod:
-                        medium._remember_remote_is_before((1, 6))
-                # Fallback for pre-1.6 servers: check for divergence
-                # client-side, then do _set_last_revision.
-                last_rev = revision.ensure_null(self.last_revision())
-                if graph is None:
-                    graph = self.repository.get_graph()
-                if self._check_if_descendant_or_diverged(
-                        stop_revision, last_rev, graph, other):
-                    # stop_revision is a descendant of last_rev, but we aren't
-                    # overwriting, so we're done.
-                    return
-                self._set_last_revision(stop_revision)
-        finally:
-            other.unlock()
+    def update_revisions(self, other, stop_revision=None):
+        self._ensure_real()
+        return self._real_branch.update_revisions(
+            other, stop_revision=stop_revision)
+
+
+class RemoteBranchConfig(BranchConfig):
+
+    def username(self):
+        self.branch._ensure_real()
+        return self.branch._real_branch.get_config().username()
+
+    def _get_branch_data_config(self):
+        self.branch._ensure_real()
+        if self._branch_data_config is None:
+            self._branch_data_config = TreeConfig(self.branch._real_branch)
+        return self._branch_data_config
 
 
 def _extract_tar(tar, to_dir):
@@ -1694,43 +1247,3 @@
     """
     for tarinfo in tar:
         tar.extract(tarinfo, to_dir)
-
-
-def _translate_error(err, **context):
-    """Translate an ErrorFromSmartServer into a more useful error.
-
-    Possible context keys:
-      - branch
-      - repository
-      - bzrdir
-      - token
-      - other_branch
-    """
-    def find(name):
-        try:
-            return context[name]
-        except KeyError, keyErr:
-            mutter('Missing key %r in context %r', keyErr.args[0], context)
-            raise err
-    if err.error_verb == 'NoSuchRevision':
-        raise NoSuchRevision(find('branch'), err.error_args[0])
-    elif err.error_verb == 'nosuchrevision':
-        raise NoSuchRevision(find('repository'), err.error_args[0])
-    elif err.error_tuple == ('nobranch',):
-        raise errors.NotBranchError(path=find('bzrdir').root_transport.base)
-    elif err.error_verb == 'norepository':
-        raise errors.NoRepositoryPresent(find('bzrdir'))
-    elif err.error_verb == 'LockContention':
-        raise errors.LockContention('(remote lock)')
-    elif err.error_verb == 'UnlockableTransport':
-        raise errors.UnlockableTransport(find('bzrdir').root_transport)
-    elif err.error_verb == 'LockFailed':
-        raise errors.LockFailed(err.error_args[0], err.error_args[1])
-    elif err.error_verb == 'TokenMismatch':
-        raise errors.TokenMismatch(find('token'), '(remote token)')
-    elif err.error_verb == 'Diverged':
-        raise errors.DivergedBranches(find('branch'), find('other_branch'))
-    elif err.error_verb == 'TipChangeRejected':
-        raise errors.TipChangeRejected(err.error_args[0].decode('utf8'))
-    raise
-

=== modified file 'bzrlib/repofmt/knitrepo.py'
--- bzrlib/repofmt/knitrepo.py	2008-07-28 06:08:42 +0000
+++ bzrlib/repofmt/knitrepo.py	2007-10-12 08:18:54 +0000
@@ -24,19 +24,18 @@
 """)
 from bzrlib import (
     bzrdir,
+    deprecated_graph,
     errors,
     knit,
     lockable_files,
     lockdir,
     osutils,
-    symbol_versioning,
     transactions,
     xml5,
-    xml6,
     xml7,
     )
+
 from bzrlib.decorators import needs_read_lock, needs_write_lock
-from bzrlib.knit import KnitVersionedFiles, _KndxIndex, _KnitKeyAccess
 from bzrlib.repository import (
     CommitBuilder,
     MetaDirRepository,
@@ -48,7 +47,6 @@
 from bzrlib.store.versioned import VersionedFileStore
 from bzrlib.trace import mutter, mutter_callsite
 from bzrlib.util import bencode
-from bzrlib.versionedfile import ConstantMapper, HashEscapedPrefixMapper
 
 
 class _KnitParentsProvider(object):
@@ -59,59 +57,21 @@
     def __repr__(self):
         return 'KnitParentsProvider(%r)' % self._knit
 
-    @symbol_versioning.deprecated_method(symbol_versioning.one_one)
     def get_parents(self, revision_ids):
-        """See graph._StackedParentsProvider.get_parents"""
-        parent_map = self.get_parent_map(revision_ids)
-        return [parent_map.get(r, None) for r in revision_ids]
-
-    def get_parent_map(self, keys):
-        """See graph._StackedParentsProvider.get_parent_map"""
-        parent_map = {}
-        for revision_id in keys:
-            if revision_id is None:
-                raise ValueError('get_parent_map(None) is not valid')
+        parents_list = []
+        for revision_id in revision_ids:
             if revision_id == _mod_revision.NULL_REVISION:
-                parent_map[revision_id] = ()
+                parents = []
             else:
                 try:
-                    parents = tuple(
-                        self._knit.get_parents_with_ghosts(revision_id))
+                    parents = self._knit.get_parents_with_ghosts(revision_id)
                 except errors.RevisionNotPresent:
-                    continue
+                    parents = None
                 else:
                     if len(parents) == 0:
-                        parents = (_mod_revision.NULL_REVISION,)
-                parent_map[revision_id] = parents
-        return parent_map
-
-
-class _KnitsParentsProvider(object):
-
-    def __init__(self, knit, prefix=()):
-        """Create a parent provider for string keys mapped to tuple keys."""
-        self._knit = knit
-        self._prefix = prefix
-
-    def __repr__(self):
-        return 'KnitsParentsProvider(%r)' % self._knit
-
-    def get_parent_map(self, keys):
-        """See graph._StackedParentsProvider.get_parent_map"""
-        parent_map = self._knit.get_parent_map(
-            [self._prefix + (key,) for key in keys])
-        result = {}
-        for key, parents in parent_map.items():
-            revid = key[-1]
-            if len(parents) == 0:
-                parents = (_mod_revision.NULL_REVISION,)
-            else:
-                parents = tuple(parent[-1] for parent in parents)
-            result[revid] = parents
-        for revision_id in keys:
-            if revision_id == _mod_revision.NULL_REVISION:
-                result[revision_id] = ()
-        return result
+                        parents = [_mod_revision.NULL_REVISION]
+            parents_list.append(parents)
+        return parents_list
 
 
 class KnitRepository(MetaDirRepository):
@@ -124,71 +84,28 @@
     _commit_builder_class = None
     _serializer = None
 
-    def __init__(self, _format, a_bzrdir, control_files, _commit_builder_class,
-        _serializer):
-        MetaDirRepository.__init__(self, _format, a_bzrdir, control_files)
+    def __init__(self, _format, a_bzrdir, control_files, _revision_store,
+        control_store, text_store, _commit_builder_class, _serializer):
+        MetaDirRepository.__init__(self, _format, a_bzrdir, control_files,
+            _revision_store, control_store, text_store)
         self._commit_builder_class = _commit_builder_class
         self._serializer = _serializer
         self._reconcile_fixes_text_parents = True
-        self._fetch_uses_deltas = True
-        self._fetch_order = 'topological'
+
+    def _warn_if_deprecated(self):
+        # This class isn't deprecated
+        pass
+
+    def _inventory_add_lines(self, inv_vf, revid, parents, lines, check_content):
+        return inv_vf.add_lines_with_ghosts(revid, parents, lines,
+            check_content=check_content)[0]
 
     @needs_read_lock
     def _all_revision_ids(self):
         """See Repository.all_revision_ids()."""
-        return [key[0] for key in self.revisions.keys()]
-
-    def _activate_new_inventory(self):
-        """Put a replacement inventory.new into use as inventories."""
-        # Copy the content across
-        t = self._transport
-        t.copy('inventory.new.kndx', 'inventory.kndx')
-        try:
-            t.copy('inventory.new.knit', 'inventory.knit')
-        except errors.NoSuchFile:
-            # empty inventories knit
-            t.delete('inventory.knit')
-        # delete the temp inventory
-        t.delete('inventory.new.kndx')
-        try:
-            t.delete('inventory.new.knit')
-        except errors.NoSuchFile:
-            # empty inventories knit
-            pass
-        # Force index reload (sanity check)
-        self.inventories._index._reset_cache()
-        self.inventories.keys()
-
-    def _backup_inventory(self):
-        t = self._transport
-        t.copy('inventory.kndx', 'inventory.backup.kndx')
-        t.copy('inventory.knit', 'inventory.backup.knit')
-
-    def _move_file_id(self, from_id, to_id):
-        t = self._transport.clone('knits')
-        from_rel_url = self.texts._index._mapper.map((from_id, None))
-        to_rel_url = self.texts._index._mapper.map((to_id, None))
-        # We expect both files to always exist in this case.
-        for suffix in ('.knit', '.kndx'):
-            t.rename(from_rel_url + suffix, to_rel_url + suffix)
-
-    def _remove_file_id(self, file_id):
-        t = self._transport.clone('knits')
-        rel_url = self.texts._index._mapper.map((file_id, None))
-        for suffix in ('.kndx', '.knit'):
-            try:
-                t.delete(rel_url + suffix)
-            except errors.NoSuchFile:
-                pass
-
-    def _temp_inventories(self):
-        result = self._format._get_inventories(self._transport, self,
-            'inventory.new')
-        # Reconciling when the output has no revisions would result in no
-        # writes - but we want to ensure there is an inventory for
-        # compatibility with older clients that don't lazy-load.
-        result.get_parent_map([('A',)])
-        return result
+        # Knits get the revision graph from the index of the revision knit, so
+        # it's always possible even if they're on an unlistable transport.
+        return self._revision_store.all_revision_ids(self.get_transaction())
 
     def fileid_involved_between_revs(self, from_revid, to_revid):
         """Find file_id(s) which are involved in the changes between revisions.
@@ -216,11 +133,128 @@
         return self._fileid_involved_by_set(changed)
 
     @needs_read_lock
+    def get_ancestry(self, revision_id, topo_sorted=True):
+        """Return a list of revision-ids integrated by a revision.
+        
+        This is topologically sorted, unless 'topo_sorted' is specified as
+        False.
+        """
+        if _mod_revision.is_null(revision_id):
+            return [None]
+        vf = self._get_revision_vf()
+        try:
+            return [None] + vf.get_ancestry(revision_id, topo_sorted)
+        except errors.RevisionNotPresent:
+            raise errors.NoSuchRevision(self, revision_id)
+
+    @needs_read_lock
+    def get_data_stream(self, revision_ids):
+        """See Repository.get_data_stream."""
+        item_keys = self.item_keys_introduced_by(revision_ids)
+        for knit_kind, file_id, versions in item_keys:
+            name = (knit_kind,)
+            if knit_kind == 'file':
+                name = ('file', file_id)
+                knit = self.weave_store.get_weave_or_empty(
+                    file_id, self.get_transaction())
+            elif knit_kind == 'inventory':
+                knit = self.get_inventory_weave()
+            elif knit_kind == 'revisions':
+                knit = self._revision_store.get_revision_file(
+                    self.get_transaction())
+            elif knit_kind == 'signatures':
+                knit = self._revision_store.get_signature_file(
+                    self.get_transaction())
+            else:
+                raise AssertionError('Unknown knit kind %r' % (knit_kind,))
+            yield name, _get_stream_as_bytes(knit, versions)
+
+    @needs_read_lock
     def get_revision(self, revision_id):
         """Return the Revision object for a named revision"""
         revision_id = osutils.safe_revision_id(revision_id)
         return self.get_revision_reconcile(revision_id)
 
+    @needs_read_lock
+    def get_revision_graph(self, revision_id=None):
+        """Return a dictionary containing the revision graph.
+
+        :param revision_id: The revision_id to get a graph from. If None, then
+        the entire revision graph is returned. This is a deprecated mode of
+        operation and will be removed in the future.
+        :return: a dictionary of revision_id->revision_parents_list.
+        """
+        if 'evil' in debug.debug_flags:
+            mutter_callsite(3,
+                "get_revision_graph scales with size of history.")
+        # special case NULL_REVISION
+        if revision_id == _mod_revision.NULL_REVISION:
+            return {}
+        a_weave = self._get_revision_vf()
+        if revision_id is None:
+            return a_weave.get_graph()
+        if revision_id not in a_weave:
+            raise errors.NoSuchRevision(self, revision_id)
+        else:
+            # add what can be reached from revision_id
+            return a_weave.get_graph([revision_id])
+
+    @needs_read_lock
+    def get_revision_graph_with_ghosts(self, revision_ids=None):
+        """Return a graph of the revisions with ghosts marked as applicable.
+
+        :param revision_ids: an iterable of revisions to graph or None for all.
+        :return: a Graph object with the graph reachable from revision_ids.
+        """
+        if 'evil' in debug.debug_flags:
+            mutter_callsite(3,
+                "get_revision_graph_with_ghosts scales with size of history.")
+        result = deprecated_graph.Graph()
+        vf = self._get_revision_vf()
+        versions = set(vf.versions())
+        if not revision_ids:
+            pending = set(self.all_revision_ids())
+            required = set([])
+        else:
+            pending = set(revision_ids)
+            # special case NULL_REVISION
+            if _mod_revision.NULL_REVISION in pending:
+                pending.remove(_mod_revision.NULL_REVISION)
+            required = set(pending)
+        done = set([])
+        while len(pending):
+            revision_id = pending.pop()
+            if not revision_id in versions:
+                if revision_id in required:
+                    raise errors.NoSuchRevision(self, revision_id)
+                # a ghost
+                result.add_ghost(revision_id)
+                # mark it as done so we don't try for it again.
+                done.add(revision_id)
+                continue
+            parent_ids = vf.get_parents_with_ghosts(revision_id)
+            for parent_id in parent_ids:
+                # is this queued or done ?
+                if (parent_id not in pending and
+                    parent_id not in done):
+                    # no, queue it.
+                    pending.add(parent_id)
+            result.add_node(revision_id, parent_ids)
+            done.add(revision_id)
+        return result
+
+    def _get_revision_vf(self):
+        """:return: a versioned file containing the revisions."""
+        vf = self._revision_store.get_revision_file(self.get_transaction())
+        return vf
+
+    def _get_history_vf(self):
+        """Get a versionedfile whose history graph reflects all revisions.
+
+        For knit repositories, this is the revision knit.
+        """
+        return self._get_revision_vf()
+
     @needs_write_lock
     def reconcile(self, other=None, thorough=False):
         """Reconcile this repository."""
@@ -229,8 +263,11 @@
         reconciler.reconcile()
         return reconciler
     
+    def revision_parents(self, revision_id):
+        return self._get_revision_vf().get_parents(revision_id)
+
     def _make_parents_provider(self):
-        return _KnitsParentsProvider(self.revisions)
+        return _KnitParentsProvider(self._get_revision_vf())
 
     def _find_inconsistent_revision_parents(self):
         """Find revisions with different parent lists in the revision object
@@ -239,17 +276,16 @@
         :returns: an iterator yielding tuples of (revison-id, parents-in-index,
             parents-in-revision).
         """
-        if not self.is_locked():
-            raise AssertionError()
-        vf = self.revisions
-        for index_version in vf.keys():
-            parent_map = vf.get_parent_map([index_version])
-            parents_according_to_index = tuple(parent[-1] for parent in
-                parent_map[index_version])
-            revision = self.get_revision(index_version[-1])
-            parents_according_to_revision = tuple(revision.parent_ids)
+        vf = self._get_revision_vf()
+        index_versions = vf.versions()
+        for index_version in index_versions:
+            parents_according_to_index = vf._index.get_parents_with_ghosts(
+                index_version)
+            revision = self._revision_store.get_revision(index_version,
+                self.get_transaction())
+            parents_according_to_revision = revision.parent_ids
             if parents_according_to_index != parents_according_to_revision:
-                yield (index_version[-1], parents_according_to_index,
+                yield (index_version, parents_according_to_index,
                     parents_according_to_revision)
 
     def _check_for_inconsistent_revision_parents(self):
@@ -288,42 +324,44 @@
     # Set this attribute in derived clases to control the _serializer that the
     # repository objects will have passed to their constructor.
     _serializer = xml5.serializer_v5
-    # Knit based repositories handle ghosts reasonably well.
-    supports_ghosts = True
-    # External lookups are not supported in this format.
-    supports_external_lookups = False
-
-    def _get_inventories(self, repo_transport, repo, name='inventory'):
-        mapper = ConstantMapper(name)
-        index = _KndxIndex(repo_transport, mapper, repo.get_transaction,
-            repo.is_write_locked, repo.is_locked)
-        access = _KnitKeyAccess(repo_transport, mapper)
-        return KnitVersionedFiles(index, access, annotated=False)
-
-    def _get_revisions(self, repo_transport, repo):
-        mapper = ConstantMapper('revisions')
-        index = _KndxIndex(repo_transport, mapper, repo.get_transaction,
-            repo.is_write_locked, repo.is_locked)
-        access = _KnitKeyAccess(repo_transport, mapper)
-        return KnitVersionedFiles(index, access, max_delta_chain=0,
-            annotated=False)
-
-    def _get_signatures(self, repo_transport, repo):
-        mapper = ConstantMapper('signatures')
-        index = _KndxIndex(repo_transport, mapper, repo.get_transaction,
-            repo.is_write_locked, repo.is_locked)
-        access = _KnitKeyAccess(repo_transport, mapper)
-        return KnitVersionedFiles(index, access, max_delta_chain=0,
-            annotated=False)
-
-    def _get_texts(self, repo_transport, repo):
-        mapper = HashEscapedPrefixMapper()
-        base_transport = repo_transport.clone('knits')
-        index = _KndxIndex(base_transport, mapper, repo.get_transaction,
-            repo.is_write_locked, repo.is_locked)
-        access = _KnitKeyAccess(base_transport, mapper)
-        return KnitVersionedFiles(index, access, max_delta_chain=200,
-            annotated=True)
+
+    def _get_control_store(self, repo_transport, control_files):
+        """Return the control store for this repository."""
+        return VersionedFileStore(
+            repo_transport,
+            prefixed=False,
+            file_mode=control_files._file_mode,
+            versionedfile_class=knit.KnitVersionedFile,
+            versionedfile_kwargs={'factory':knit.KnitPlainFactory()},
+            )
+
+    def _get_revision_store(self, repo_transport, control_files):
+        """See RepositoryFormat._get_revision_store()."""
+        versioned_file_store = VersionedFileStore(
+            repo_transport,
+            file_mode=control_files._file_mode,
+            prefixed=False,
+            precious=True,
+            versionedfile_class=knit.KnitVersionedFile,
+            versionedfile_kwargs={'delta':False,
+                                  'factory':knit.KnitPlainFactory(),
+                                 },
+            escaped=True,
+            )
+        return KnitRevisionStore(versioned_file_store)
+
+    def _get_text_store(self, transport, control_files):
+        """See RepositoryFormat._get_text_store()."""
+        return self._get_versioned_file_store('knits',
+                                  transport,
+                                  control_files,
+                                  versionedfile_class=knit.KnitVersionedFile,
+                                  versionedfile_kwargs={
+                                      'create_parent_dir':True,
+                                      'delay_create':True,
+                                      'dir_mode':control_files._dir_mode,
+                                  },
+                                  escaped=True)
 
     def initialize(self, a_bzrdir, shared=False):
         """Create a knit format 1 repository.
@@ -342,16 +380,16 @@
         repo_transport = a_bzrdir.get_repository_transport(None)
         control_files = lockable_files.LockableFiles(repo_transport,
                                 'lock', lockdir.LockDir)
+        control_store = self._get_control_store(repo_transport, control_files)
         transaction = transactions.WriteTransaction()
-        result = self.open(a_bzrdir=a_bzrdir, _found=True)
-        result.lock_write()
+        # trigger a write of the inventory store.
+        control_store.get_weave_or_empty('inventory', transaction)
+        _revision_store = self._get_revision_store(repo_transport, control_files)
         # the revision id here is irrelevant: it will not be stored, and cannot
-        # already exist, we do this to create files on disk for older clients.
-        result.inventories.get_parent_map([('A',)])
-        result.revisions.get_parent_map([('A',)])
-        result.signatures.get_parent_map([('A',)])
-        result.unlock()
-        return result
+        # already exist.
+        _revision_store.has_revision_id('A', transaction)
+        _revision_store.get_signature_file(transaction)
+        return self.open(a_bzrdir=a_bzrdir, _found=True)
 
     def open(self, a_bzrdir, _found=False, _override_transport=None):
         """See RepositoryFormat.open().
@@ -362,23 +400,24 @@
         """
         if not _found:
             format = RepositoryFormat.find_format(a_bzrdir)
+            assert format.__class__ ==  self.__class__
         if _override_transport is not None:
             repo_transport = _override_transport
         else:
             repo_transport = a_bzrdir.get_repository_transport(None)
         control_files = lockable_files.LockableFiles(repo_transport,
                                 'lock', lockdir.LockDir)
-        repo = self.repository_class(_format=self,
+        text_store = self._get_text_store(repo_transport, control_files)
+        control_store = self._get_control_store(repo_transport, control_files)
+        _revision_store = self._get_revision_store(repo_transport, control_files)
+        return self.repository_class(_format=self,
                               a_bzrdir=a_bzrdir,
                               control_files=control_files,
+                              _revision_store=_revision_store,
+                              control_store=control_store,
+                              text_store=text_store,
                               _commit_builder_class=self._commit_builder_class,
                               _serializer=self._serializer)
-        repo.revisions = self._get_revisions(repo_transport, repo)
-        repo.signatures = self._get_signatures(repo_transport, repo)
-        repo.inventories = self._get_inventories(repo_transport, repo)
-        repo.texts = self._get_texts(repo_transport, repo)
-        repo._transport = repo_transport
-        return repo
 
 
 class RepositoryFormatKnit1(RepositoryFormatKnit):
@@ -417,7 +456,7 @@
 
 
 class RepositoryFormatKnit3(RepositoryFormatKnit):
-    """Bzr repository knit format 3.
+    """Bzr repository knit format 2.
 
     This repository format has:
      - knits for file texts and inventory
@@ -463,45 +502,24 @@
         return "Knit repository format 3"
 
 
-class RepositoryFormatKnit4(RepositoryFormatKnit):
-    """Bzr repository knit format 4.
-
-    This repository format has everything in format 3, except for
-    tree-references:
-     - knits for file texts and inventory
-     - hash subdirectory based stores.
-     - knits for revisions and signatures
-     - TextStores for revisions and signatures.
-     - a format marker of its own
-     - an optional 'shared-storage' flag
-     - an optional 'no-working-trees' flag
-     - a LockDir lock
-     - support for recording full info about the tree root
+def _get_stream_as_bytes(knit, required_versions):
+    """Generate a serialised data stream.
+
+    The format is a bencoding of a list.  The first element of the list is a
+    string of the format signature, then each subsequent element is a list
+    corresponding to a record.  Those lists contain:
+
+      * a version id
+      * a list of options
+      * a list of parents
+      * the bytes
+
+    :returns: a bencoded list.
     """
-
-    repository_class = KnitRepository
-    _commit_builder_class = RootCommitBuilder
-    rich_root_data = True
-    supports_tree_reference = False
-    _serializer = xml6.serializer_v6
-
-    def _get_matching_bzrdir(self):
-        return bzrdir.format_registry.make_bzrdir('rich-root')
-
-    def _ignore_setting_bzrdir(self, format):
-        pass
-
-    _matchingbzrdir = property(_get_matching_bzrdir, _ignore_setting_bzrdir)
-
-    def check_conversion_target(self, target_format):
-        if not target_format.rich_root_data:
-            raise errors.BadConversionTarget(
-                'Does not support rich root data.', target_format)
-
-    def get_format_string(self):
-        """See RepositoryFormat.get_format_string()."""
-        return 'Bazaar Knit Repository Format 4 (bzr 1.0)\n'
-
-    def get_format_description(self):
-        """See RepositoryFormat.get_format_description()."""
-        return "Knit repository format 4"
+    knit_stream = knit.get_data_stream(required_versions)
+    format_signature, data_list, callable = knit_stream
+    data = []
+    data.append(format_signature)
+    for version, options, length, parents in data_list:
+        data.append([version, options, parents, callable(length)])
+    return bencode.bencode(data)

=== removed file 'bzrlib/repofmt/pack_repo.py'
--- bzrlib/repofmt/pack_repo.py	2008-09-02 03:17:08 +0000
+++ bzrlib/repofmt/pack_repo.py	1970-01-01 00:00:00 +0000
@@ -1,2253 +0,0 @@
-# Copyright (C) 2005, 2006, 2007, 2008 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-from bzrlib.lazy_import import lazy_import
-lazy_import(globals(), """
-from itertools import izip
-import md5
-import time
-
-from bzrlib import (
-    debug,
-    graph,
-    pack,
-    transactions,
-    ui,
-    )
-from bzrlib.index import (
-    GraphIndex,
-    GraphIndexBuilder,
-    InMemoryGraphIndex,
-    CombinedGraphIndex,
-    GraphIndexPrefixAdapter,
-    )
-from bzrlib.knit import (
-    KnitPlainFactory,
-    KnitVersionedFiles,
-    _KnitGraphIndex,
-    _DirectPackAccess,
-    )
-from bzrlib.osutils import rand_chars, split_lines
-from bzrlib import tsort
-""")
-from bzrlib import (
-    bzrdir,
-    errors,
-    lockable_files,
-    lockdir,
-    symbol_versioning,
-    xml5,
-    xml6,
-    xml7,
-    )
-
-from bzrlib.decorators import needs_write_lock
-from bzrlib.repofmt.knitrepo import KnitRepository
-from bzrlib.repository import (
-    CommitBuilder,
-    MetaDirRepositoryFormat,
-    RepositoryFormat,
-    RootCommitBuilder,
-    )
-import bzrlib.revision as _mod_revision
-from bzrlib.trace import (
-    mutter,
-    warning,
-    )
-
-
-class PackCommitBuilder(CommitBuilder):
-    """A subclass of CommitBuilder to add texts with pack semantics.
-    
-    Specifically this uses one knit object rather than one knit object per
-    added text, reducing memory and object pressure.
-    """
-
-    def __init__(self, repository, parents, config, timestamp=None,
-                 timezone=None, committer=None, revprops=None,
-                 revision_id=None):
-        CommitBuilder.__init__(self, repository, parents, config,
-            timestamp=timestamp, timezone=timezone, committer=committer,
-            revprops=revprops, revision_id=revision_id)
-        self._file_graph = graph.Graph(
-            repository._pack_collection.text_index.combined_index)
-
-    def _heads(self, file_id, revision_ids):
-        keys = [(file_id, revision_id) for revision_id in revision_ids]
-        return set([key[1] for key in self._file_graph.heads(keys)])
-
-
-class PackRootCommitBuilder(RootCommitBuilder):
-    """A subclass of RootCommitBuilder to add texts with pack semantics.
-    
-    Specifically this uses one knit object rather than one knit object per
-    added text, reducing memory and object pressure.
-    """
-
-    def __init__(self, repository, parents, config, timestamp=None,
-                 timezone=None, committer=None, revprops=None,
-                 revision_id=None):
-        CommitBuilder.__init__(self, repository, parents, config,
-            timestamp=timestamp, timezone=timezone, committer=committer,
-            revprops=revprops, revision_id=revision_id)
-        self._file_graph = graph.Graph(
-            repository._pack_collection.text_index.combined_index)
-
-    def _heads(self, file_id, revision_ids):
-        keys = [(file_id, revision_id) for revision_id in revision_ids]
-        return set([key[1] for key in self._file_graph.heads(keys)])
-
-
-class Pack(object):
-    """An in memory proxy for a pack and its indices.
-
-    This is a base class that is not directly used, instead the classes
-    ExistingPack and NewPack are used.
-    """
-
-    def __init__(self, revision_index, inventory_index, text_index,
-        signature_index):
-        """Create a pack instance.
-
-        :param revision_index: A GraphIndex for determining what revisions are
-            present in the Pack and accessing the locations of their texts.
-        :param inventory_index: A GraphIndex for determining what inventories are
-            present in the Pack and accessing the locations of their
-            texts/deltas.
-        :param text_index: A GraphIndex for determining what file texts
-            are present in the pack and accessing the locations of their
-            texts/deltas (via (fileid, revisionid) tuples).
-        :param signature_index: A GraphIndex for determining what signatures are
-            present in the Pack and accessing the locations of their texts.
-        """
-        self.revision_index = revision_index
-        self.inventory_index = inventory_index
-        self.text_index = text_index
-        self.signature_index = signature_index
-
-    def access_tuple(self):
-        """Return a tuple (transport, name) for the pack content."""
-        return self.pack_transport, self.file_name()
-
-    def file_name(self):
-        """Get the file name for the pack on disk."""
-        return self.name + '.pack'
-
-    def get_revision_count(self):
-        return self.revision_index.key_count()
-
-    def inventory_index_name(self, name):
-        """The inv index is the name + .iix."""
-        return self.index_name('inventory', name)
-
-    def revision_index_name(self, name):
-        """The revision index is the name + .rix."""
-        return self.index_name('revision', name)
-
-    def signature_index_name(self, name):
-        """The signature index is the name + .six."""
-        return self.index_name('signature', name)
-
-    def text_index_name(self, name):
-        """The text index is the name + .tix."""
-        return self.index_name('text', name)
-
-    def _external_compression_parents_of_texts(self):
-        keys = set()
-        refs = set()
-        for node in self.text_index.iter_all_entries():
-            keys.add(node[1])
-            refs.update(node[3][1])
-        return refs - keys
-
-
-class ExistingPack(Pack):
-    """An in memory proxy for an existing .pack and its disk indices."""
-
-    def __init__(self, pack_transport, name, revision_index, inventory_index,
-        text_index, signature_index):
-        """Create an ExistingPack object.
-
-        :param pack_transport: The transport where the pack file resides.
-        :param name: The name of the pack on disk in the pack_transport.
-        """
-        Pack.__init__(self, revision_index, inventory_index, text_index,
-            signature_index)
-        self.name = name
-        self.pack_transport = pack_transport
-        if None in (revision_index, inventory_index, text_index,
-                signature_index, name, pack_transport):
-            raise AssertionError()
-
-    def __eq__(self, other):
-        return self.__dict__ == other.__dict__
-
-    def __ne__(self, other):
-        return not self.__eq__(other)
-
-    def __repr__(self):
-        return "<bzrlib.repofmt.pack_repo.Pack object at 0x%x, %s, %s" % (
-            id(self), self.pack_transport, self.name)
-
-
-class NewPack(Pack):
-    """An in memory proxy for a pack which is being created."""
-
-    # A map of index 'type' to the file extension and position in the
-    # index_sizes array.
-    index_definitions = {
-        'revision': ('.rix', 0),
-        'inventory': ('.iix', 1),
-        'text': ('.tix', 2),
-        'signature': ('.six', 3),
-        }
-
-    def __init__(self, upload_transport, index_transport, pack_transport,
-        upload_suffix='', file_mode=None):
-        """Create a NewPack instance.
-
-        :param upload_transport: A writable transport for the pack to be
-            incrementally uploaded to.
-        :param index_transport: A writable transport for the pack's indices to
-            be written to when the pack is finished.
-        :param pack_transport: A writable transport for the pack to be renamed
-            to when the upload is complete. This *must* be the same as
-            upload_transport.clone('../packs').
-        :param upload_suffix: An optional suffix to be given to any temporary
-            files created during the pack creation. e.g '.autopack'
-        :param file_mode: An optional file mode to create the new files with.
-        """
-        # The relative locations of the packs are constrained, but all are
-        # passed in because the caller has them, so as to avoid object churn.
-        Pack.__init__(self,
-            # Revisions: parents list, no text compression.
-            InMemoryGraphIndex(reference_lists=1),
-            # Inventory: We want to map compression only, but currently the
-            # knit code hasn't been updated enough to understand that, so we
-            # have a regular 2-list index giving parents and compression
-            # source.
-            InMemoryGraphIndex(reference_lists=2),
-            # Texts: compression and per file graph, for all fileids - so two
-            # reference lists and two elements in the key tuple.
-            InMemoryGraphIndex(reference_lists=2, key_elements=2),
-            # Signatures: Just blobs to store, no compression, no parents
-            # listing.
-            InMemoryGraphIndex(reference_lists=0),
-            )
-        # where should the new pack be opened
-        self.upload_transport = upload_transport
-        # where are indices written out to
-        self.index_transport = index_transport
-        # where is the pack renamed to when it is finished?
-        self.pack_transport = pack_transport
-        # What file mode to upload the pack and indices with.
-        self._file_mode = file_mode
-        # tracks the content written to the .pack file.
-        self._hash = md5.new()
-        # a four-tuple with the length in bytes of the indices, once the pack
-        # is finalised. (rev, inv, text, sigs)
-        self.index_sizes = None
-        # How much data to cache when writing packs. Note that this is not
-        # synchronised with reads, because it's not in the transport layer, so
-        # is not safe unless the client knows it won't be reading from the pack
-        # under creation.
-        self._cache_limit = 0
-        # the temporary pack file name.
-        self.random_name = rand_chars(20) + upload_suffix
-        # when was this pack started ?
-        self.start_time = time.time()
-        # open an output stream for the data added to the pack.
-        self.write_stream = self.upload_transport.open_write_stream(
-            self.random_name, mode=self._file_mode)
-        if 'pack' in debug.debug_flags:
-            mutter('%s: create_pack: pack stream open: %s%s t+%6.3fs',
-                time.ctime(), self.upload_transport.base, self.random_name,
-                time.time() - self.start_time)
-        # A list of byte sequences to be written to the new pack, and the 
-        # aggregate size of them.  Stored as a list rather than separate 
-        # variables so that the _write_data closure below can update them.
-        self._buffer = [[], 0]
-        # create a callable for adding data 
-        #
-        # robertc says- this is a closure rather than a method on the object
-        # so that the variables are locals, and faster than accessing object
-        # members.
-        def _write_data(bytes, flush=False, _buffer=self._buffer,
-            _write=self.write_stream.write, _update=self._hash.update):
-            _buffer[0].append(bytes)
-            _buffer[1] += len(bytes)
-            # buffer cap
-            if _buffer[1] > self._cache_limit or flush:
-                bytes = ''.join(_buffer[0])
-                _write(bytes)
-                _update(bytes)
-                _buffer[:] = [[], 0]
-        # expose this on self, for the occasion when clients want to add data.
-        self._write_data = _write_data
-        # a pack writer object to serialise pack records.
-        self._writer = pack.ContainerWriter(self._write_data)
-        self._writer.begin()
-        # what state is the pack in? (open, finished, aborted)
-        self._state = 'open'
-
-    def abort(self):
-        """Cancel creating this pack."""
-        self._state = 'aborted'
-        self.write_stream.close()
-        # Remove the temporary pack file.
-        self.upload_transport.delete(self.random_name)
-        # The indices have no state on disk.
-
-    def access_tuple(self):
-        """Return a tuple (transport, name) for the pack content."""
-        if self._state == 'finished':
-            return Pack.access_tuple(self)
-        elif self._state == 'open':
-            return self.upload_transport, self.random_name
-        else:
-            raise AssertionError(self._state)
-
-    def data_inserted(self):
-        """True if data has been added to this pack."""
-        return bool(self.get_revision_count() or
-            self.inventory_index.key_count() or
-            self.text_index.key_count() or
-            self.signature_index.key_count())
-
-    def finish(self):
-        """Finish the new pack.
-
-        This:
-         - finalises the content
-         - assigns a name (the md5 of the content, currently)
-         - writes out the associated indices
-         - renames the pack into place.
-         - stores the index size tuple for the pack in the index_sizes
-           attribute.
-        """
-        self._writer.end()
-        if self._buffer[1]:
-            self._write_data('', flush=True)
-        self.name = self._hash.hexdigest()
-        # write indices
-        # XXX: It'd be better to write them all to temporary names, then
-        # rename them all into place, so that the window when only some are
-        # visible is smaller.  On the other hand none will be seen until
-        # they're in the names list.
-        self.index_sizes = [None, None, None, None]
-        self._write_index('revision', self.revision_index, 'revision')
-        self._write_index('inventory', self.inventory_index, 'inventory')
-        self._write_index('text', self.text_index, 'file texts')
-        self._write_index('signature', self.signature_index,
-            'revision signatures')
-        self.write_stream.close()
-        # Note that this will clobber an existing pack with the same name,
-        # without checking for hash collisions. While this is undesirable this
-        # is something that can be rectified in a subsequent release. One way
-        # to rectify it may be to leave the pack at the original name, writing
-        # its pack-names entry as something like 'HASH: index-sizes
-        # temporary-name'. Allocate that and check for collisions, if it is
-        # collision free then rename it into place. If clients know this scheme
-        # they can handle missing-file errors by:
-        #  - try for HASH.pack
-        #  - try for temporary-name
-        #  - refresh the pack-list to see if the pack is now absent
-        self.upload_transport.rename(self.random_name,
-                '../packs/' + self.name + '.pack')
-        self._state = 'finished'
-        if 'pack' in debug.debug_flags:
-            # XXX: size might be interesting?
-            mutter('%s: create_pack: pack renamed into place: %s%s->%s%s t+%6.3fs',
-                time.ctime(), self.upload_transport.base, self.random_name,
-                self.pack_transport, self.name,
-                time.time() - self.start_time)
-
-    def flush(self):
-        """Flush any current data."""
-        if self._buffer[1]:
-            bytes = ''.join(self._buffer[0])
-            self.write_stream.write(bytes)
-            self._hash.update(bytes)
-            self._buffer[:] = [[], 0]
-
-    def index_name(self, index_type, name):
-        """Get the disk name of an index type for pack name 'name'."""
-        return name + NewPack.index_definitions[index_type][0]
-
-    def index_offset(self, index_type):
-        """Get the position in a index_size array for a given index type."""
-        return NewPack.index_definitions[index_type][1]
-
-    def _replace_index_with_readonly(self, index_type):
-        setattr(self, index_type + '_index',
-            GraphIndex(self.index_transport,
-                self.index_name(index_type, self.name),
-                self.index_sizes[self.index_offset(index_type)]))
-
-    def set_write_cache_size(self, size):
-        self._cache_limit = size
-
-    def _write_index(self, index_type, index, label):
-        """Write out an index.
-
-        :param index_type: The type of index to write - e.g. 'revision'.
-        :param index: The index object to serialise.
-        :param label: What label to give the index e.g. 'revision'.
-        """
-        index_name = self.index_name(index_type, self.name)
-        self.index_sizes[self.index_offset(index_type)] = \
-            self.index_transport.put_file(index_name, index.finish(),
-            mode=self._file_mode)
-        if 'pack' in debug.debug_flags:
-            # XXX: size might be interesting?
-            mutter('%s: create_pack: wrote %s index: %s%s t+%6.3fs',
-                time.ctime(), label, self.upload_transport.base,
-                self.random_name, time.time() - self.start_time)
-        # Replace the writable index on this object with a readonly, 
-        # presently unloaded index. We should alter
-        # the index layer to make its finish() error if add_node is
-        # subsequently used. RBC
-        self._replace_index_with_readonly(index_type)
-
-
-class AggregateIndex(object):
-    """An aggregated index for the RepositoryPackCollection.
-
-    AggregateIndex is reponsible for managing the PackAccess object,
-    Index-To-Pack mapping, and all indices list for a specific type of index
-    such as 'revision index'.
-
-    A CombinedIndex provides an index on a single key space built up
-    from several on-disk indices.  The AggregateIndex builds on this 
-    to provide a knit access layer, and allows having up to one writable
-    index within the collection.
-    """
-    # XXX: Probably 'can be written to' could/should be separated from 'acts
-    # like a knit index' -- mbp 20071024
-
-    def __init__(self):
-        """Create an AggregateIndex."""
-        self.index_to_pack = {}
-        self.combined_index = CombinedGraphIndex([])
-        self.data_access = _DirectPackAccess(self.index_to_pack)
-        self.add_callback = None
-
-    def replace_indices(self, index_to_pack, indices):
-        """Replace the current mappings with fresh ones.
-
-        This should probably not be used eventually, rather incremental add and
-        removal of indices. It has been added during refactoring of existing
-        code.
-
-        :param index_to_pack: A mapping from index objects to
-            (transport, name) tuples for the pack file data.
-        :param indices: A list of indices.
-        """
-        # refresh the revision pack map dict without replacing the instance.
-        self.index_to_pack.clear()
-        self.index_to_pack.update(index_to_pack)
-        # XXX: API break - clearly a 'replace' method would be good?
-        self.combined_index._indices[:] = indices
-        # the current add nodes callback for the current writable index if
-        # there is one.
-        self.add_callback = None
-
-    def add_index(self, index, pack):
-        """Add index to the aggregate, which is an index for Pack pack.
-
-        Future searches on the aggregate index will seach this new index
-        before all previously inserted indices.
-        
-        :param index: An Index for the pack.
-        :param pack: A Pack instance.
-        """
-        # expose it to the index map
-        self.index_to_pack[index] = pack.access_tuple()
-        # put it at the front of the linear index list
-        self.combined_index.insert_index(0, index)
-
-    def add_writable_index(self, index, pack):
-        """Add an index which is able to have data added to it.
-
-        There can be at most one writable index at any time.  Any
-        modifications made to the knit are put into this index.
-        
-        :param index: An index from the pack parameter.
-        :param pack: A Pack instance.
-        """
-        if self.add_callback is not None:
-            raise AssertionError(
-                "%s already has a writable index through %s" % \
-                (self, self.add_callback))
-        # allow writing: queue writes to a new index
-        self.add_index(index, pack)
-        # Updates the index to packs mapping as a side effect,
-        self.data_access.set_writer(pack._writer, index, pack.access_tuple())
-        self.add_callback = index.add_nodes
-
-    def clear(self):
-        """Reset all the aggregate data to nothing."""
-        self.data_access.set_writer(None, None, (None, None))
-        self.index_to_pack.clear()
-        del self.combined_index._indices[:]
-        self.add_callback = None
-
-    def remove_index(self, index, pack):
-        """Remove index from the indices used to answer queries.
-        
-        :param index: An index from the pack parameter.
-        :param pack: A Pack instance.
-        """
-        del self.index_to_pack[index]
-        self.combined_index._indices.remove(index)
-        if (self.add_callback is not None and
-            getattr(index, 'add_nodes', None) == self.add_callback):
-            self.add_callback = None
-            self.data_access.set_writer(None, None, (None, None))
-
-
-class Packer(object):
-    """Create a pack from packs."""
-
-    def __init__(self, pack_collection, packs, suffix, revision_ids=None):
-        """Create a Packer.
-
-        :param pack_collection: A RepositoryPackCollection object where the
-            new pack is being written to.
-        :param packs: The packs to combine.
-        :param suffix: The suffix to use on the temporary files for the pack.
-        :param revision_ids: Revision ids to limit the pack to.
-        """
-        self.packs = packs
-        self.suffix = suffix
-        self.revision_ids = revision_ids
-        # The pack object we are creating.
-        self.new_pack = None
-        self._pack_collection = pack_collection
-        # The index layer keys for the revisions being copied. None for 'all
-        # objects'.
-        self._revision_keys = None
-        # What text keys to copy. None for 'all texts'. This is set by
-        # _copy_inventory_texts
-        self._text_filter = None
-        self._extra_init()
-
-    def _extra_init(self):
-        """A template hook to allow extending the constructor trivially."""
-
-    def pack(self, pb=None):
-        """Create a new pack by reading data from other packs.
-
-        This does little more than a bulk copy of data. One key difference
-        is that data with the same item key across multiple packs is elided
-        from the output. The new pack is written into the current pack store
-        along with its indices, and the name added to the pack names. The 
-        source packs are not altered and are not required to be in the current
-        pack collection.
-
-        :param pb: An optional progress bar to use. A nested bar is created if
-            this is None.
-        :return: A Pack object, or None if nothing was copied.
-        """
-        # open a pack - using the same name as the last temporary file
-        # - which has already been flushed, so its safe.
-        # XXX: - duplicate code warning with start_write_group; fix before
-        #      considering 'done'.
-        if self._pack_collection._new_pack is not None:
-            raise errors.BzrError('call to create_pack_from_packs while '
-                'another pack is being written.')
-        if self.revision_ids is not None:
-            if len(self.revision_ids) == 0:
-                # silly fetch request.
-                return None
-            else:
-                self.revision_ids = frozenset(self.revision_ids)
-                self.revision_keys = frozenset((revid,) for revid in
-                    self.revision_ids)
-        if pb is None:
-            self.pb = ui.ui_factory.nested_progress_bar()
-        else:
-            self.pb = pb
-        try:
-            return self._create_pack_from_packs()
-        finally:
-            if pb is None:
-                self.pb.finished()
-
-    def open_pack(self):
-        """Open a pack for the pack we are creating."""
-        return NewPack(self._pack_collection._upload_transport,
-            self._pack_collection._index_transport,
-            self._pack_collection._pack_transport, upload_suffix=self.suffix,
-            file_mode=self._pack_collection.repo.bzrdir._get_file_mode())
-
-    def _copy_revision_texts(self):
-        """Copy revision data to the new pack."""
-        # select revisions
-        if self.revision_ids:
-            revision_keys = [(revision_id,) for revision_id in self.revision_ids]
-        else:
-            revision_keys = None
-        # select revision keys
-        revision_index_map = self._pack_collection._packs_list_to_pack_map_and_index_list(
-            self.packs, 'revision_index')[0]
-        revision_nodes = self._pack_collection._index_contents(revision_index_map, revision_keys)
-        # copy revision keys and adjust values
-        self.pb.update("Copying revision texts", 1)
-        total_items, readv_group_iter = self._revision_node_readv(revision_nodes)
-        list(self._copy_nodes_graph(revision_index_map, self.new_pack._writer,
-            self.new_pack.revision_index, readv_group_iter, total_items))
-        if 'pack' in debug.debug_flags:
-            mutter('%s: create_pack: revisions copied: %s%s %d items t+%6.3fs',
-                time.ctime(), self._pack_collection._upload_transport.base,
-                self.new_pack.random_name,
-                self.new_pack.revision_index.key_count(),
-                time.time() - self.new_pack.start_time)
-        self._revision_keys = revision_keys
-
-    def _copy_inventory_texts(self):
-        """Copy the inventory texts to the new pack.
-
-        self._revision_keys is used to determine what inventories to copy.
-
-        Sets self._text_filter appropriately.
-        """
-        # select inventory keys
-        inv_keys = self._revision_keys # currently the same keyspace, and note that
-        # querying for keys here could introduce a bug where an inventory item
-        # is missed, so do not change it to query separately without cross
-        # checking like the text key check below.
-        inventory_index_map = self._pack_collection._packs_list_to_pack_map_and_index_list(
-            self.packs, 'inventory_index')[0]
-        inv_nodes = self._pack_collection._index_contents(inventory_index_map, inv_keys)
-        # copy inventory keys and adjust values
-        # XXX: Should be a helper function to allow different inv representation
-        # at this point.
-        self.pb.update("Copying inventory texts", 2)
-        total_items, readv_group_iter = self._least_readv_node_readv(inv_nodes)
-        # Only grab the output lines if we will be processing them
-        output_lines = bool(self.revision_ids)
-        inv_lines = self._copy_nodes_graph(inventory_index_map,
-            self.new_pack._writer, self.new_pack.inventory_index,
-            readv_group_iter, total_items, output_lines=output_lines)
-        if self.revision_ids:
-            self._process_inventory_lines(inv_lines)
-        else:
-            # eat the iterator to cause it to execute.
-            list(inv_lines)
-            self._text_filter = None
-        if 'pack' in debug.debug_flags:
-            mutter('%s: create_pack: inventories copied: %s%s %d items t+%6.3fs',
-                time.ctime(), self._pack_collection._upload_transport.base,
-                self.new_pack.random_name,
-                self.new_pack.inventory_index.key_count(),
-                time.time() - self.new_pack.start_time)
-
-    def _copy_text_texts(self):
-        # select text keys
-        text_index_map, text_nodes = self._get_text_nodes()
-        if self._text_filter is not None:
-            # We could return the keys copied as part of the return value from
-            # _copy_nodes_graph but this doesn't work all that well with the
-            # need to get line output too, so we check separately, and as we're
-            # going to buffer everything anyway, we check beforehand, which
-            # saves reading knit data over the wire when we know there are
-            # mising records.
-            text_nodes = set(text_nodes)
-            present_text_keys = set(_node[1] for _node in text_nodes)
-            missing_text_keys = set(self._text_filter) - present_text_keys
-            if missing_text_keys:
-                # TODO: raise a specific error that can handle many missing
-                # keys.
-                a_missing_key = missing_text_keys.pop()
-                raise errors.RevisionNotPresent(a_missing_key[1],
-                    a_missing_key[0])
-        # copy text keys and adjust values
-        self.pb.update("Copying content texts", 3)
-        total_items, readv_group_iter = self._least_readv_node_readv(text_nodes)
-        list(self._copy_nodes_graph(text_index_map, self.new_pack._writer,
-            self.new_pack.text_index, readv_group_iter, total_items))
-        self._log_copied_texts()
-
-    def _check_references(self):
-        """Make sure our external refereneces are present."""
-        external_refs = self.new_pack._external_compression_parents_of_texts()
-        if external_refs:
-            index = self._pack_collection.text_index.combined_index
-            found_items = list(index.iter_entries(external_refs))
-            if len(found_items) != len(external_refs):
-                found_keys = set(k for idx, k, refs, value in found_items)
-                missing_items = external_refs - found_keys
-                missing_file_id, missing_revision_id = missing_items.pop()
-                raise errors.RevisionNotPresent(missing_revision_id,
-                                                missing_file_id)
-
-    def _create_pack_from_packs(self):
-        self.pb.update("Opening pack", 0, 5)
-        self.new_pack = self.open_pack()
-        new_pack = self.new_pack
-        # buffer data - we won't be reading-back during the pack creation and
-        # this makes a significant difference on sftp pushes.
-        new_pack.set_write_cache_size(1024*1024)
-        if 'pack' in debug.debug_flags:
-            plain_pack_list = ['%s%s' % (a_pack.pack_transport.base, a_pack.name)
-                for a_pack in self.packs]
-            if self.revision_ids is not None:
-                rev_count = len(self.revision_ids)
-            else:
-                rev_count = 'all'
-            mutter('%s: create_pack: creating pack from source packs: '
-                '%s%s %s revisions wanted %s t=0',
-                time.ctime(), self._pack_collection._upload_transport.base, new_pack.random_name,
-                plain_pack_list, rev_count)
-        self._copy_revision_texts()
-        self._copy_inventory_texts()
-        self._copy_text_texts()
-        # select signature keys
-        signature_filter = self._revision_keys # same keyspace
-        signature_index_map = self._pack_collection._packs_list_to_pack_map_and_index_list(
-            self.packs, 'signature_index')[0]
-        signature_nodes = self._pack_collection._index_contents(signature_index_map,
-            signature_filter)
-        # copy signature keys and adjust values
-        self.pb.update("Copying signature texts", 4)
-        self._copy_nodes(signature_nodes, signature_index_map, new_pack._writer,
-            new_pack.signature_index)
-        if 'pack' in debug.debug_flags:
-            mutter('%s: create_pack: revision signatures copied: %s%s %d items t+%6.3fs',
-                time.ctime(), self._pack_collection._upload_transport.base, new_pack.random_name,
-                new_pack.signature_index.key_count(),
-                time.time() - new_pack.start_time)
-        self._check_references()
-        if not self._use_pack(new_pack):
-            new_pack.abort()
-            return None
-        self.pb.update("Finishing pack", 5)
-        new_pack.finish()
-        self._pack_collection.allocate(new_pack)
-        return new_pack
-
-    def _copy_nodes(self, nodes, index_map, writer, write_index):
-        """Copy knit nodes between packs with no graph references."""
-        pb = ui.ui_factory.nested_progress_bar()
-        try:
-            return self._do_copy_nodes(nodes, index_map, writer,
-                write_index, pb)
-        finally:
-            pb.finished()
-
-    def _do_copy_nodes(self, nodes, index_map, writer, write_index, pb):
-        # for record verification
-        knit = KnitVersionedFiles(None, None)
-        # plan a readv on each source pack:
-        # group by pack
-        nodes = sorted(nodes)
-        # how to map this into knit.py - or knit.py into this?
-        # we don't want the typical knit logic, we want grouping by pack
-        # at this point - perhaps a helper library for the following code 
-        # duplication points?
-        request_groups = {}
-        for index, key, value in nodes:
-            if index not in request_groups:
-                request_groups[index] = []
-            request_groups[index].append((key, value))
-        record_index = 0
-        pb.update("Copied record", record_index, len(nodes))
-        for index, items in request_groups.iteritems():
-            pack_readv_requests = []
-            for key, value in items:
-                # ---- KnitGraphIndex.get_position
-                bits = value[1:].split(' ')
-                offset, length = int(bits[0]), int(bits[1])
-                pack_readv_requests.append((offset, length, (key, value[0])))
-            # linear scan up the pack
-            pack_readv_requests.sort()
-            # copy the data
-            transport, path = index_map[index]
-            reader = pack.make_readv_reader(transport, path,
-                [offset[0:2] for offset in pack_readv_requests])
-            for (names, read_func), (_1, _2, (key, eol_flag)) in \
-                izip(reader.iter_records(), pack_readv_requests):
-                raw_data = read_func(None)
-                # check the header only
-                df, _ = knit._parse_record_header(key, raw_data)
-                df.close()
-                pos, size = writer.add_bytes_record(raw_data, names)
-                write_index.add_node(key, eol_flag + "%d %d" % (pos, size))
-                pb.update("Copied record", record_index)
-                record_index += 1
-
-    def _copy_nodes_graph(self, index_map, writer, write_index,
-        readv_group_iter, total_items, output_lines=False):
-        """Copy knit nodes between packs.
-
-        :param output_lines: Return lines present in the copied data as
-            an iterator of line,version_id.
-        """
-        pb = ui.ui_factory.nested_progress_bar()
-        try:
-            for result in self._do_copy_nodes_graph(index_map, writer,
-                write_index, output_lines, pb, readv_group_iter, total_items):
-                yield result
-        except Exception:
-            # Python 2.4 does not permit try:finally: in a generator.
-            pb.finished()
-            raise
-        else:
-            pb.finished()
-
-    def _do_copy_nodes_graph(self, index_map, writer, write_index,
-        output_lines, pb, readv_group_iter, total_items):
-        # for record verification
-        knit = KnitVersionedFiles(None, None)
-        # for line extraction when requested (inventories only)
-        if output_lines:
-            factory = KnitPlainFactory()
-        record_index = 0
-        pb.update("Copied record", record_index, total_items)
-        for index, readv_vector, node_vector in readv_group_iter:
-            # copy the data
-            transport, path = index_map[index]
-            reader = pack.make_readv_reader(transport, path, readv_vector)
-            for (names, read_func), (key, eol_flag, references) in \
-                izip(reader.iter_records(), node_vector):
-                raw_data = read_func(None)
-                if output_lines:
-                    # read the entire thing
-                    content, _ = knit._parse_record(key[-1], raw_data)
-                    if len(references[-1]) == 0:
-                        line_iterator = factory.get_fulltext_content(content)
-                    else:
-                        line_iterator = factory.get_linedelta_content(content)
-                    for line in line_iterator:
-                        yield line, key
-                else:
-                    # check the header only
-                    df, _ = knit._parse_record_header(key, raw_data)
-                    df.close()
-                pos, size = writer.add_bytes_record(raw_data, names)
-                write_index.add_node(key, eol_flag + "%d %d" % (pos, size), references)
-                pb.update("Copied record", record_index)
-                record_index += 1
-
-    def _get_text_nodes(self):
-        text_index_map = self._pack_collection._packs_list_to_pack_map_and_index_list(
-            self.packs, 'text_index')[0]
-        return text_index_map, self._pack_collection._index_contents(text_index_map,
-            self._text_filter)
-
-    def _least_readv_node_readv(self, nodes):
-        """Generate request groups for nodes using the least readv's.
-        
-        :param nodes: An iterable of graph index nodes.
-        :return: Total node count and an iterator of the data needed to perform
-            readvs to obtain the data for nodes. Each item yielded by the
-            iterator is a tuple with:
-            index, readv_vector, node_vector. readv_vector is a list ready to
-            hand to the transport readv method, and node_vector is a list of
-            (key, eol_flag, references) for the the node retrieved by the
-            matching readv_vector.
-        """
-        # group by pack so we do one readv per pack
-        nodes = sorted(nodes)
-        total = len(nodes)
-        request_groups = {}
-        for index, key, value, references in nodes:
-            if index not in request_groups:
-                request_groups[index] = []
-            request_groups[index].append((key, value, references))
-        result = []
-        for index, items in request_groups.iteritems():
-            pack_readv_requests = []
-            for key, value, references in items:
-                # ---- KnitGraphIndex.get_position
-                bits = value[1:].split(' ')
-                offset, length = int(bits[0]), int(bits[1])
-                pack_readv_requests.append(
-                    ((offset, length), (key, value[0], references)))
-            # linear scan up the pack to maximum range combining.
-            pack_readv_requests.sort()
-            # split out the readv and the node data.
-            pack_readv = [readv for readv, node in pack_readv_requests]
-            node_vector = [node for readv, node in pack_readv_requests]
-            result.append((index, pack_readv, node_vector))
-        return total, result
-
-    def _log_copied_texts(self):
-        if 'pack' in debug.debug_flags:
-            mutter('%s: create_pack: file texts copied: %s%s %d items t+%6.3fs',
-                time.ctime(), self._pack_collection._upload_transport.base,
-                self.new_pack.random_name,
-                self.new_pack.text_index.key_count(),
-                time.time() - self.new_pack.start_time)
-
-    def _process_inventory_lines(self, inv_lines):
-        """Use up the inv_lines generator and setup a text key filter."""
-        repo = self._pack_collection.repo
-        fileid_revisions = repo._find_file_ids_from_xml_inventory_lines(
-            inv_lines, self.revision_keys)
-        text_filter = []
-        for fileid, file_revids in fileid_revisions.iteritems():
-            text_filter.extend([(fileid, file_revid) for file_revid in file_revids])
-        self._text_filter = text_filter
-
-    def _revision_node_readv(self, revision_nodes):
-        """Return the total revisions and the readv's to issue.
-
-        :param revision_nodes: The revision index contents for the packs being
-            incorporated into the new pack.
-        :return: As per _least_readv_node_readv.
-        """
-        return self._least_readv_node_readv(revision_nodes)
-
-    def _use_pack(self, new_pack):
-        """Return True if new_pack should be used.
-
-        :param new_pack: The pack that has just been created.
-        :return: True if the pack should be used.
-        """
-        return new_pack.data_inserted()
-
-
-class OptimisingPacker(Packer):
-    """A packer which spends more time to create better disk layouts."""
-
-    def _revision_node_readv(self, revision_nodes):
-        """Return the total revisions and the readv's to issue.
-
-        This sort places revisions in topological order with the ancestors
-        after the children.
-
-        :param revision_nodes: The revision index contents for the packs being
-            incorporated into the new pack.
-        :return: As per _least_readv_node_readv.
-        """
-        # build an ancestors dict
-        ancestors = {}
-        by_key = {}
-        for index, key, value, references in revision_nodes:
-            ancestors[key] = references[0]
-            by_key[key] = (index, value, references)
-        order = tsort.topo_sort(ancestors)
-        total = len(order)
-        # Single IO is pathological, but it will work as a starting point.
-        requests = []
-        for key in reversed(order):
-            index, value, references = by_key[key]
-            # ---- KnitGraphIndex.get_position
-            bits = value[1:].split(' ')
-            offset, length = int(bits[0]), int(bits[1])
-            requests.append(
-                (index, [(offset, length)], [(key, value[0], references)]))
-        # TODO: combine requests in the same index that are in ascending order.
-        return total, requests
-
-
-class ReconcilePacker(Packer):
-    """A packer which regenerates indices etc as it copies.
-    
-    This is used by ``bzr reconcile`` to cause parent text pointers to be
-    regenerated.
-    """
-
-    def _extra_init(self):
-        self._data_changed = False
-
-    def _process_inventory_lines(self, inv_lines):
-        """Generate a text key reference map rather for reconciling with."""
-        repo = self._pack_collection.repo
-        refs = repo._find_text_key_references_from_xml_inventory_lines(
-            inv_lines)
-        self._text_refs = refs
-        # during reconcile we:
-        #  - convert unreferenced texts to full texts
-        #  - correct texts which reference a text not copied to be full texts
-        #  - copy all others as-is but with corrected parents.
-        #  - so at this point we don't know enough to decide what becomes a full
-        #    text.
-        self._text_filter = None
-
-    def _copy_text_texts(self):
-        """generate what texts we should have and then copy."""
-        self.pb.update("Copying content texts", 3)
-        # we have three major tasks here:
-        # 1) generate the ideal index
-        repo = self._pack_collection.repo
-        ancestors = dict([(key[0], tuple(ref[0] for ref in refs[0])) for
-            _1, key, _2, refs in 
-            self.new_pack.revision_index.iter_all_entries()])
-        ideal_index = repo._generate_text_key_index(self._text_refs, ancestors)
-        # 2) generate a text_nodes list that contains all the deltas that can
-        #    be used as-is, with corrected parents.
-        ok_nodes = []
-        bad_texts = []
-        discarded_nodes = []
-        NULL_REVISION = _mod_revision.NULL_REVISION
-        text_index_map, text_nodes = self._get_text_nodes()
-        for node in text_nodes:
-            # 0 - index
-            # 1 - key 
-            # 2 - value
-            # 3 - refs
-            try:
-                ideal_parents = tuple(ideal_index[node[1]])
-            except KeyError:
-                discarded_nodes.append(node)
-                self._data_changed = True
-            else:
-                if ideal_parents == (NULL_REVISION,):
-                    ideal_parents = ()
-                if ideal_parents == node[3][0]:
-                    # no change needed.
-                    ok_nodes.append(node)
-                elif ideal_parents[0:1] == node[3][0][0:1]:
-                    # the left most parent is the same, or there are no parents
-                    # today. Either way, we can preserve the representation as
-                    # long as we change the refs to be inserted.
-                    self._data_changed = True
-                    ok_nodes.append((node[0], node[1], node[2],
-                        (ideal_parents, node[3][1])))
-                    self._data_changed = True
-                else:
-                    # Reinsert this text completely
-                    bad_texts.append((node[1], ideal_parents))
-                    self._data_changed = True
-        # we're finished with some data.
-        del ideal_index
-        del text_nodes
-        # 3) bulk copy the ok data
-        total_items, readv_group_iter = self._least_readv_node_readv(ok_nodes)
-        list(self._copy_nodes_graph(text_index_map, self.new_pack._writer,
-            self.new_pack.text_index, readv_group_iter, total_items))
-        # 4) adhoc copy all the other texts.
-        # We have to topologically insert all texts otherwise we can fail to
-        # reconcile when parts of a single delta chain are preserved intact,
-        # and other parts are not. E.g. Discarded->d1->d2->d3. d1 will be
-        # reinserted, and if d3 has incorrect parents it will also be
-        # reinserted. If we insert d3 first, d2 is present (as it was bulk
-        # copied), so we will try to delta, but d2 is not currently able to be
-        # extracted because it's basis d1 is not present. Topologically sorting
-        # addresses this. The following generates a sort for all the texts that
-        # are being inserted without having to reference the entire text key
-        # space (we only topo sort the revisions, which is smaller).
-        topo_order = tsort.topo_sort(ancestors)
-        rev_order = dict(zip(topo_order, range(len(topo_order))))
-        bad_texts.sort(key=lambda key:rev_order[key[0][1]])
-        transaction = repo.get_transaction()
-        file_id_index = GraphIndexPrefixAdapter(
-            self.new_pack.text_index,
-            ('blank', ), 1,
-            add_nodes_callback=self.new_pack.text_index.add_nodes)
-        data_access = _DirectPackAccess(
-                {self.new_pack.text_index:self.new_pack.access_tuple()})
-        data_access.set_writer(self.new_pack._writer, self.new_pack.text_index,
-            self.new_pack.access_tuple())
-        output_texts = KnitVersionedFiles(
-            _KnitGraphIndex(self.new_pack.text_index,
-                add_callback=self.new_pack.text_index.add_nodes,
-                deltas=True, parents=True, is_locked=repo.is_locked),
-            data_access=data_access, max_delta_chain=200)
-        for key, parent_keys in bad_texts:
-            # We refer to the new pack to delta data being output.
-            # A possible improvement would be to catch errors on short reads
-            # and only flush then.
-            self.new_pack.flush()
-            parents = []
-            for parent_key in parent_keys:
-                if parent_key[0] != key[0]:
-                    # Graph parents must match the fileid
-                    raise errors.BzrError('Mismatched key parent %r:%r' %
-                        (key, parent_keys))
-                parents.append(parent_key[1])
-            text_lines = split_lines(repo.texts.get_record_stream(
-                [key], 'unordered', True).next().get_bytes_as('fulltext'))
-            output_texts.add_lines(key, parent_keys, text_lines,
-                random_id=True, check_content=False)
-        # 5) check that nothing inserted has a reference outside the keyspace.
-        missing_text_keys = self.new_pack._external_compression_parents_of_texts()
-        if missing_text_keys:
-            raise errors.BzrError('Reference to missing compression parents %r'
-                % (missing_text_keys,))
-        self._log_copied_texts()
-
-    def _use_pack(self, new_pack):
-        """Override _use_pack to check for reconcile having changed content."""
-        # XXX: we might be better checking this at the copy time.
-        original_inventory_keys = set()
-        inv_index = self._pack_collection.inventory_index.combined_index
-        for entry in inv_index.iter_all_entries():
-            original_inventory_keys.add(entry[1])
-        new_inventory_keys = set()
-        for entry in new_pack.inventory_index.iter_all_entries():
-            new_inventory_keys.add(entry[1])
-        if new_inventory_keys != original_inventory_keys:
-            self._data_changed = True
-        return new_pack.data_inserted() and self._data_changed
-
-
-class RepositoryPackCollection(object):
-    """Management of packs within a repository.
-    
-    :ivar _names: map of {pack_name: (index_size,)}
-    """
-
-    def __init__(self, repo, transport, index_transport, upload_transport,
-                 pack_transport):
-        """Create a new RepositoryPackCollection.
-
-        :param transport: Addresses the repository base directory 
-            (typically .bzr/repository/).
-        :param index_transport: Addresses the directory containing indices.
-        :param upload_transport: Addresses the directory into which packs are written
-            while they're being created.
-        :param pack_transport: Addresses the directory of existing complete packs.
-        """
-        self.repo = repo
-        self.transport = transport
-        self._index_transport = index_transport
-        self._upload_transport = upload_transport
-        self._pack_transport = pack_transport
-        self._suffix_offsets = {'.rix': 0, '.iix': 1, '.tix': 2, '.six': 3}
-        self.packs = []
-        # name:Pack mapping
-        self._packs_by_name = {}
-        # the previous pack-names content
-        self._packs_at_load = None
-        # when a pack is being created by this object, the state of that pack.
-        self._new_pack = None
-        # aggregated revision index data
-        self.revision_index = AggregateIndex()
-        self.inventory_index = AggregateIndex()
-        self.text_index = AggregateIndex()
-        self.signature_index = AggregateIndex()
-
-    def add_pack_to_memory(self, pack):
-        """Make a Pack object available to the repository to satisfy queries.
-        
-        :param pack: A Pack object.
-        """
-        if pack.name in self._packs_by_name:
-            raise AssertionError()
-        self.packs.append(pack)
-        self._packs_by_name[pack.name] = pack
-        self.revision_index.add_index(pack.revision_index, pack)
-        self.inventory_index.add_index(pack.inventory_index, pack)
-        self.text_index.add_index(pack.text_index, pack)
-        self.signature_index.add_index(pack.signature_index, pack)
-        
-    def all_packs(self):
-        """Return a list of all the Pack objects this repository has.
-
-        Note that an in-progress pack being created is not returned.
-
-        :return: A list of Pack objects for all the packs in the repository.
-        """
-        result = []
-        for name in self.names():
-            result.append(self.get_pack_by_name(name))
-        return result
-
-    def autopack(self):
-        """Pack the pack collection incrementally.
-        
-        This will not attempt global reorganisation or recompression,
-        rather it will just ensure that the total number of packs does
-        not grow without bound. It uses the _max_pack_count method to
-        determine if autopacking is needed, and the pack_distribution
-        method to determine the number of revisions in each pack.
-
-        If autopacking takes place then the packs name collection will have
-        been flushed to disk - packing requires updating the name collection
-        in synchronisation with certain steps. Otherwise the names collection
-        is not flushed.
-
-        :return: True if packing took place.
-        """
-        # XXX: Should not be needed when the management of indices is sane.
-        total_revisions = self.revision_index.combined_index.key_count()
-        total_packs = len(self._names)
-        if self._max_pack_count(total_revisions) >= total_packs:
-            return False
-        # XXX: the following may want to be a class, to pack with a given
-        # policy.
-        mutter('Auto-packing repository %s, which has %d pack files, '
-            'containing %d revisions into %d packs.', self, total_packs,
-            total_revisions, self._max_pack_count(total_revisions))
-        # determine which packs need changing
-        pack_distribution = self.pack_distribution(total_revisions)
-        existing_packs = []
-        for pack in self.all_packs():
-            revision_count = pack.get_revision_count()
-            if revision_count == 0:
-                # revision less packs are not generated by normal operation,
-                # only by operations like sign-my-commits, and thus will not
-                # tend to grow rapdily or without bound like commit containing
-                # packs do - leave them alone as packing them really should
-                # group their data with the relevant commit, and that may
-                # involve rewriting ancient history - which autopack tries to
-                # avoid. Alternatively we could not group the data but treat
-                # each of these as having a single revision, and thus add 
-                # one revision for each to the total revision count, to get
-                # a matching distribution.
-                continue
-            existing_packs.append((revision_count, pack))
-        pack_operations = self.plan_autopack_combinations(
-            existing_packs, pack_distribution)
-        self._execute_pack_operations(pack_operations)
-        return True
-
-    def _execute_pack_operations(self, pack_operations, _packer_class=Packer):
-        """Execute a series of pack operations.
-
-        :param pack_operations: A list of [revision_count, packs_to_combine].
-        :param _packer_class: The class of packer to use (default: Packer).
-        :return: None.
-        """
-        for revision_count, packs in pack_operations:
-            # we may have no-ops from the setup logic
-            if len(packs) == 0:
-                continue
-            _packer_class(self, packs, '.autopack').pack()
-            for pack in packs:
-                self._remove_pack_from_memory(pack)
-        # record the newly available packs and stop advertising the old
-        # packs
-        self._save_pack_names(clear_obsolete_packs=True)
-        # Move the old packs out of the way now they are no longer referenced.
-        for revision_count, packs in pack_operations:
-            self._obsolete_packs(packs)
-
-    def lock_names(self):
-        """Acquire the mutex around the pack-names index.
-        
-        This cannot be used in the middle of a read-only transaction on the
-        repository.
-        """
-        self.repo.control_files.lock_write()
-
-    def pack(self):
-        """Pack the pack collection totally."""
-        self.ensure_loaded()
-        total_packs = len(self._names)
-        if total_packs < 2:
-            # This is arguably wrong because we might not be optimal, but for
-            # now lets leave it in. (e.g. reconcile -> one pack. But not
-            # optimal.
-            return
-        total_revisions = self.revision_index.combined_index.key_count()
-        # XXX: the following may want to be a class, to pack with a given
-        # policy.
-        mutter('Packing repository %s, which has %d pack files, '
-            'containing %d revisions into 1 packs.', self, total_packs,
-            total_revisions)
-        # determine which packs need changing
-        pack_distribution = [1]
-        pack_operations = [[0, []]]
-        for pack in self.all_packs():
-            pack_operations[-1][0] += pack.get_revision_count()
-            pack_operations[-1][1].append(pack)
-        self._execute_pack_operations(pack_operations, OptimisingPacker)
-
-    def plan_autopack_combinations(self, existing_packs, pack_distribution):
-        """Plan a pack operation.
-
-        :param existing_packs: The packs to pack. (A list of (revcount, Pack)
-            tuples).
-        :param pack_distribution: A list with the number of revisions desired
-            in each pack.
-        """
-        if len(existing_packs) <= len(pack_distribution):
-            return []
-        existing_packs.sort(reverse=True)
-        pack_operations = [[0, []]]
-        # plan out what packs to keep, and what to reorganise
-        while len(existing_packs):
-            # take the largest pack, and if its less than the head of the
-            # distribution chart we will include its contents in the new pack for
-            # that position. If its larger, we remove its size from the
-            # distribution chart
-            next_pack_rev_count, next_pack = existing_packs.pop(0)
-            if next_pack_rev_count >= pack_distribution[0]:
-                # this is already packed 'better' than this, so we can
-                # not waste time packing it.
-                while next_pack_rev_count > 0:
-                    next_pack_rev_count -= pack_distribution[0]
-                    if next_pack_rev_count >= 0:
-                        # more to go
-                        del pack_distribution[0]
-                    else:
-                        # didn't use that entire bucket up
-                        pack_distribution[0] = -next_pack_rev_count
-            else:
-                # add the revisions we're going to add to the next output pack
-                pack_operations[-1][0] += next_pack_rev_count
-                # allocate this pack to the next pack sub operation
-                pack_operations[-1][1].append(next_pack)
-                if pack_operations[-1][0] >= pack_distribution[0]:
-                    # this pack is used up, shift left.
-                    del pack_distribution[0]
-                    pack_operations.append([0, []])
-        
-        return pack_operations
-
-    def ensure_loaded(self):
-        # NB: if you see an assertion error here, its probably access against
-        # an unlocked repo. Naughty.
-        if not self.repo.is_locked():
-            raise errors.ObjectNotLocked(self.repo)
-        if self._names is None:
-            self._names = {}
-            self._packs_at_load = set()
-            for index, key, value in self._iter_disk_pack_index():
-                name = key[0]
-                self._names[name] = self._parse_index_sizes(value)
-                self._packs_at_load.add((key, value))
-        # populate all the metadata.
-        self.all_packs()
-
-    def _parse_index_sizes(self, value):
-        """Parse a string of index sizes."""
-        return tuple([int(digits) for digits in value.split(' ')])
-
-    def get_pack_by_name(self, name):
-        """Get a Pack object by name.
-
-        :param name: The name of the pack - e.g. '123456'
-        :return: A Pack object.
-        """
-        try:
-            return self._packs_by_name[name]
-        except KeyError:
-            rev_index = self._make_index(name, '.rix')
-            inv_index = self._make_index(name, '.iix')
-            txt_index = self._make_index(name, '.tix')
-            sig_index = self._make_index(name, '.six')
-            result = ExistingPack(self._pack_transport, name, rev_index,
-                inv_index, txt_index, sig_index)
-            self.add_pack_to_memory(result)
-            return result
-
-    def allocate(self, a_new_pack):
-        """Allocate name in the list of packs.
-
-        :param a_new_pack: A NewPack instance to be added to the collection of
-            packs for this repository.
-        """
-        self.ensure_loaded()
-        if a_new_pack.name in self._names:
-            raise errors.BzrError(
-                'Pack %r already exists in %s' % (a_new_pack.name, self))
-        self._names[a_new_pack.name] = tuple(a_new_pack.index_sizes)
-        self.add_pack_to_memory(a_new_pack)
-
-    def _iter_disk_pack_index(self):
-        """Iterate over the contents of the pack-names index.
-        
-        This is used when loading the list from disk, and before writing to
-        detect updates from others during our write operation.
-        :return: An iterator of the index contents.
-        """
-        return GraphIndex(self.transport, 'pack-names', None
-                ).iter_all_entries()
-
-    def _make_index(self, name, suffix):
-        size_offset = self._suffix_offsets[suffix]
-        index_name = name + suffix
-        index_size = self._names[name][size_offset]
-        return GraphIndex(
-            self._index_transport, index_name, index_size)
-
-    def _max_pack_count(self, total_revisions):
-        """Return the maximum number of packs to use for total revisions.
-        
-        :param total_revisions: The total number of revisions in the
-            repository.
-        """
-        if not total_revisions:
-            return 1
-        digits = str(total_revisions)
-        result = 0
-        for digit in digits:
-            result += int(digit)
-        return result
-
-    def names(self):
-        """Provide an order to the underlying names."""
-        return sorted(self._names.keys())
-
-    def _obsolete_packs(self, packs):
-        """Move a number of packs which have been obsoleted out of the way.
-
-        Each pack and its associated indices are moved out of the way.
-
-        Note: for correctness this function should only be called after a new
-        pack names index has been written without these pack names, and with
-        the names of packs that contain the data previously available via these
-        packs.
-
-        :param packs: The packs to obsolete.
-        :param return: None.
-        """
-        for pack in packs:
-            pack.pack_transport.rename(pack.file_name(),
-                '../obsolete_packs/' + pack.file_name())
-            # TODO: Probably needs to know all possible indices for this pack
-            # - or maybe list the directory and move all indices matching this
-            # name whether we recognize it or not?
-            for suffix in ('.iix', '.six', '.tix', '.rix'):
-                self._index_transport.rename(pack.name + suffix,
-                    '../obsolete_packs/' + pack.name + suffix)
-
-    def pack_distribution(self, total_revisions):
-        """Generate a list of the number of revisions to put in each pack.
-
-        :param total_revisions: The total number of revisions in the
-            repository.
-        """
-        if total_revisions == 0:
-            return [0]
-        digits = reversed(str(total_revisions))
-        result = []
-        for exponent, count in enumerate(digits):
-            size = 10 ** exponent
-            for pos in range(int(count)):
-                result.append(size)
-        return list(reversed(result))
-
-    def _pack_tuple(self, name):
-        """Return a tuple with the transport and file name for a pack name."""
-        return self._pack_transport, name + '.pack'
-
-    def _remove_pack_from_memory(self, pack):
-        """Remove pack from the packs accessed by this repository.
-        
-        Only affects memory state, until self._save_pack_names() is invoked.
-        """
-        self._names.pop(pack.name)
-        self._packs_by_name.pop(pack.name)
-        self._remove_pack_indices(pack)
-
-    def _remove_pack_indices(self, pack):
-        """Remove the indices for pack from the aggregated indices."""
-        self.revision_index.remove_index(pack.revision_index, pack)
-        self.inventory_index.remove_index(pack.inventory_index, pack)
-        self.text_index.remove_index(pack.text_index, pack)
-        self.signature_index.remove_index(pack.signature_index, pack)
-
-    def reset(self):
-        """Clear all cached data."""
-        # cached revision data
-        self.repo._revision_knit = None
-        self.revision_index.clear()
-        # cached signature data
-        self.repo._signature_knit = None
-        self.signature_index.clear()
-        # cached file text data
-        self.text_index.clear()
-        self.repo._text_knit = None
-        # cached inventory data
-        self.inventory_index.clear()
-        # remove the open pack
-        self._new_pack = None
-        # information about packs.
-        self._names = None
-        self.packs = []
-        self._packs_by_name = {}
-        self._packs_at_load = None
-
-    def _make_index_map(self, index_suffix):
-        """Return information on existing indices.
-
-        :param suffix: Index suffix added to pack name.
-
-        :returns: (pack_map, indices) where indices is a list of GraphIndex 
-        objects, and pack_map is a mapping from those objects to the 
-        pack tuple they describe.
-        """
-        # TODO: stop using this; it creates new indices unnecessarily.
-        self.ensure_loaded()
-        suffix_map = {'.rix': 'revision_index',
-            '.six': 'signature_index',
-            '.iix': 'inventory_index',
-            '.tix': 'text_index',
-        }
-        return self._packs_list_to_pack_map_and_index_list(self.all_packs(),
-            suffix_map[index_suffix])
-
-    def _packs_list_to_pack_map_and_index_list(self, packs, index_attribute):
-        """Convert a list of packs to an index pack map and index list.
-
-        :param packs: The packs list to process.
-        :param index_attribute: The attribute that the desired index is found
-            on.
-        :return: A tuple (map, list) where map contains the dict from
-            index:pack_tuple, and lsit contains the indices in the same order
-            as the packs list.
-        """
-        indices = []
-        pack_map = {}
-        for pack in packs:
-            index = getattr(pack, index_attribute)
-            indices.append(index)
-            pack_map[index] = (pack.pack_transport, pack.file_name())
-        return pack_map, indices
-
-    def _index_contents(self, pack_map, key_filter=None):
-        """Get an iterable of the index contents from a pack_map.
-
-        :param pack_map: A map from indices to pack details.
-        :param key_filter: An optional filter to limit the
-            keys returned.
-        """
-        indices = [index for index in pack_map.iterkeys()]
-        all_index = CombinedGraphIndex(indices)
-        if key_filter is None:
-            return all_index.iter_all_entries()
-        else:
-            return all_index.iter_entries(key_filter)
-
-    def _unlock_names(self):
-        """Release the mutex around the pack-names index."""
-        self.repo.control_files.unlock()
-
-    def _save_pack_names(self, clear_obsolete_packs=False):
-        """Save the list of packs.
-
-        This will take out the mutex around the pack names list for the
-        duration of the method call. If concurrent updates have been made, a
-        three-way merge between the current list and the current in memory list
-        is performed.
-
-        :param clear_obsolete_packs: If True, clear out the contents of the
-            obsolete_packs directory.
-        """
-        self.lock_names()
-        try:
-            builder = GraphIndexBuilder()
-            # load the disk nodes across
-            disk_nodes = set()
-            for index, key, value in self._iter_disk_pack_index():
-                disk_nodes.add((key, value))
-            # do a two-way diff against our original content
-            current_nodes = set()
-            for name, sizes in self._names.iteritems():
-                current_nodes.add(
-                    ((name, ), ' '.join(str(size) for size in sizes)))
-            deleted_nodes = self._packs_at_load - current_nodes
-            new_nodes = current_nodes - self._packs_at_load
-            disk_nodes.difference_update(deleted_nodes)
-            disk_nodes.update(new_nodes)
-            # TODO: handle same-name, index-size-changes here - 
-            # e.g. use the value from disk, not ours, *unless* we're the one
-            # changing it.
-            for key, value in disk_nodes:
-                builder.add_node(key, value)
-            self.transport.put_file('pack-names', builder.finish(),
-                mode=self.repo.bzrdir._get_file_mode())
-            # move the baseline forward
-            self._packs_at_load = disk_nodes
-            if clear_obsolete_packs:
-                self._clear_obsolete_packs()
-        finally:
-            self._unlock_names()
-        # synchronise the memory packs list with what we just wrote:
-        new_names = dict(disk_nodes)
-        # drop no longer present nodes
-        for pack in self.all_packs():
-            if (pack.name,) not in new_names:
-                self._remove_pack_from_memory(pack)
-        # add new nodes/refresh existing ones
-        for key, value in disk_nodes:
-            name = key[0]
-            sizes = self._parse_index_sizes(value)
-            if name in self._names:
-                # existing
-                if sizes != self._names[name]:
-                    # the pack for name has had its indices replaced - rare but
-                    # important to handle. XXX: probably can never happen today
-                    # because the three-way merge code above does not handle it
-                    # - you may end up adding the same key twice to the new
-                    # disk index because the set values are the same, unless
-                    # the only index shows up as deleted by the set difference
-                    # - which it may. Until there is a specific test for this,
-                    # assume its broken. RBC 20071017.
-                    self._remove_pack_from_memory(self.get_pack_by_name(name))
-                    self._names[name] = sizes
-                    self.get_pack_by_name(name)
-            else:
-                # new
-                self._names[name] = sizes
-                self.get_pack_by_name(name)
-
-    def _clear_obsolete_packs(self):
-        """Delete everything from the obsolete-packs directory.
-        """
-        obsolete_pack_transport = self.transport.clone('obsolete_packs')
-        for filename in obsolete_pack_transport.list_dir('.'):
-            try:
-                obsolete_pack_transport.delete(filename)
-            except (errors.PathError, errors.TransportError), e:
-                warning("couldn't delete obsolete pack, skipping it:\n%s" % (e,))
-
-    def _start_write_group(self):
-        # Do not permit preparation for writing if we're not in a 'write lock'.
-        if not self.repo.is_write_locked():
-            raise errors.NotWriteLocked(self)
-        self._new_pack = NewPack(self._upload_transport, self._index_transport,
-            self._pack_transport, upload_suffix='.pack',
-            file_mode=self.repo.bzrdir._get_file_mode())
-        # allow writing: queue writes to a new index
-        self.revision_index.add_writable_index(self._new_pack.revision_index,
-            self._new_pack)
-        self.inventory_index.add_writable_index(self._new_pack.inventory_index,
-            self._new_pack)
-        self.text_index.add_writable_index(self._new_pack.text_index,
-            self._new_pack)
-        self.signature_index.add_writable_index(self._new_pack.signature_index,
-            self._new_pack)
-
-        self.repo.inventories._index._add_callback = self.inventory_index.add_callback
-        self.repo.revisions._index._add_callback = self.revision_index.add_callback
-        self.repo.signatures._index._add_callback = self.signature_index.add_callback
-        self.repo.texts._index._add_callback = self.text_index.add_callback
-
-    def _abort_write_group(self):
-        # FIXME: just drop the transient index.
-        # forget what names there are
-        if self._new_pack is not None:
-            self._new_pack.abort()
-            self._remove_pack_indices(self._new_pack)
-            self._new_pack = None
-        self.repo._text_knit = None
-
-    def _commit_write_group(self):
-        self._remove_pack_indices(self._new_pack)
-        if self._new_pack.data_inserted():
-            # get all the data to disk and read to use
-            self._new_pack.finish()
-            self.allocate(self._new_pack)
-            self._new_pack = None
-            if not self.autopack():
-                # when autopack takes no steps, the names list is still
-                # unsaved.
-                self._save_pack_names()
-        else:
-            self._new_pack.abort()
-            self._new_pack = None
-        self.repo._text_knit = None
-
-
-class KnitPackRepository(KnitRepository):
-    """Repository with knit objects stored inside pack containers.
-    
-    The layering for a KnitPackRepository is:
-
-    Graph        |  HPSS    | Repository public layer |
-    ===================================================
-    Tuple based apis below, string based, and key based apis above
-    ---------------------------------------------------
-    KnitVersionedFiles
-      Provides .texts, .revisions etc
-      This adapts the N-tuple keys to physical knit records which only have a
-      single string identifier (for historical reasons), which in older formats
-      was always the revision_id, and in the mapped code for packs is always
-      the last element of key tuples.
-    ---------------------------------------------------
-    GraphIndex
-      A separate GraphIndex is used for each of the
-      texts/inventories/revisions/signatures contained within each individual
-      pack file. The GraphIndex layer works in N-tuples and is unaware of any
-      semantic value.
-    ===================================================
-    
-    """
-
-    def __init__(self, _format, a_bzrdir, control_files, _commit_builder_class,
-        _serializer):
-        KnitRepository.__init__(self, _format, a_bzrdir, control_files,
-            _commit_builder_class, _serializer)
-        index_transport = self._transport.clone('indices')
-        self._pack_collection = RepositoryPackCollection(self, self._transport,
-            index_transport,
-            self._transport.clone('upload'),
-            self._transport.clone('packs'))
-        self.inventories = KnitVersionedFiles(
-            _KnitGraphIndex(self._pack_collection.inventory_index.combined_index,
-                add_callback=self._pack_collection.inventory_index.add_callback,
-                deltas=True, parents=True, is_locked=self.is_locked),
-            data_access=self._pack_collection.inventory_index.data_access,
-            max_delta_chain=200)
-        self.revisions = KnitVersionedFiles(
-            _KnitGraphIndex(self._pack_collection.revision_index.combined_index,
-                add_callback=self._pack_collection.revision_index.add_callback,
-                deltas=False, parents=True, is_locked=self.is_locked),
-            data_access=self._pack_collection.revision_index.data_access,
-            max_delta_chain=0)
-        self.signatures = KnitVersionedFiles(
-            _KnitGraphIndex(self._pack_collection.signature_index.combined_index,
-                add_callback=self._pack_collection.signature_index.add_callback,
-                deltas=False, parents=False, is_locked=self.is_locked),
-            data_access=self._pack_collection.signature_index.data_access,
-            max_delta_chain=0)
-        self.texts = KnitVersionedFiles(
-            _KnitGraphIndex(self._pack_collection.text_index.combined_index,
-                add_callback=self._pack_collection.text_index.add_callback,
-                deltas=True, parents=True, is_locked=self.is_locked),
-            data_access=self._pack_collection.text_index.data_access,
-            max_delta_chain=200)
-        # True when the repository object is 'write locked' (as opposed to the
-        # physical lock only taken out around changes to the pack-names list.) 
-        # Another way to represent this would be a decorator around the control
-        # files object that presents logical locks as physical ones - if this
-        # gets ugly consider that alternative design. RBC 20071011
-        self._write_lock_count = 0
-        self._transaction = None
-        # for tests
-        self._reconcile_does_inventory_gc = True
-        self._reconcile_fixes_text_parents = True
-        self._reconcile_backsup_inventory = False
-        self._fetch_order = 'unordered'
-
-    def _warn_if_deprecated(self):
-        # This class isn't deprecated, but one sub-format is
-        if isinstance(self._format, RepositoryFormatKnitPack5RichRootBroken):
-            from bzrlib import repository
-            if repository._deprecation_warning_done:
-                return
-            repository._deprecation_warning_done = True
-            warning("Format %s for %s is deprecated - please use"
-                    " 'bzr upgrade --1.6.1-rich-root'"
-                    % (self._format, self.bzrdir.transport.base))
-
-    def _abort_write_group(self):
-        self._pack_collection._abort_write_group()
-
-    def _find_inconsistent_revision_parents(self):
-        """Find revisions with incorrectly cached parents.
-
-        :returns: an iterator yielding tuples of (revison-id, parents-in-index,
-            parents-in-revision).
-        """
-        if not self.is_locked():
-            raise errors.ObjectNotLocked(self)
-        pb = ui.ui_factory.nested_progress_bar()
-        result = []
-        try:
-            revision_nodes = self._pack_collection.revision_index \
-                .combined_index.iter_all_entries()
-            index_positions = []
-            # Get the cached index values for all revisions, and also the location
-            # in each index of the revision text so we can perform linear IO.
-            for index, key, value, refs in revision_nodes:
-                pos, length = value[1:].split(' ')
-                index_positions.append((index, int(pos), key[0],
-                    tuple(parent[0] for parent in refs[0])))
-                pb.update("Reading revision index.", 0, 0)
-            index_positions.sort()
-            batch_count = len(index_positions) / 1000 + 1
-            pb.update("Checking cached revision graph.", 0, batch_count)
-            for offset in xrange(batch_count):
-                pb.update("Checking cached revision graph.", offset)
-                to_query = index_positions[offset * 1000:(offset + 1) * 1000]
-                if not to_query:
-                    break
-                rev_ids = [item[2] for item in to_query]
-                revs = self.get_revisions(rev_ids)
-                for revision, item in zip(revs, to_query):
-                    index_parents = item[3]
-                    rev_parents = tuple(revision.parent_ids)
-                    if index_parents != rev_parents:
-                        result.append((revision.revision_id, index_parents, rev_parents))
-        finally:
-            pb.finished()
-        return result
-
-    @symbol_versioning.deprecated_method(symbol_versioning.one_one)
-    def get_parents(self, revision_ids):
-        """See graph._StackedParentsProvider.get_parents."""
-        parent_map = self.get_parent_map(revision_ids)
-        return [parent_map.get(r, None) for r in revision_ids]
-
-    def _make_parents_provider(self):
-        return graph.CachingParentsProvider(self)
-
-    def _refresh_data(self):
-        if self._write_lock_count == 1 or (
-            self.control_files._lock_count == 1 and
-            self.control_files._lock_mode == 'r'):
-            # forget what names there are
-            self._pack_collection.reset()
-            # XXX: Better to do an in-memory merge when acquiring a new lock -
-            # factor out code from _save_pack_names.
-            self._pack_collection.ensure_loaded()
-
-    def _start_write_group(self):
-        self._pack_collection._start_write_group()
-
-    def _commit_write_group(self):
-        return self._pack_collection._commit_write_group()
-
-    def get_transaction(self):
-        if self._write_lock_count:
-            return self._transaction
-        else:
-            return self.control_files.get_transaction()
-
-    def is_locked(self):
-        return self._write_lock_count or self.control_files.is_locked()
-
-    def is_write_locked(self):
-        return self._write_lock_count
-
-    def lock_write(self, token=None):
-        if not self._write_lock_count and self.is_locked():
-            raise errors.ReadOnlyError(self)
-        self._write_lock_count += 1
-        if self._write_lock_count == 1:
-            self._transaction = transactions.WriteTransaction()
-            for repo in self._fallback_repositories:
-                # Writes don't affect fallback repos
-                repo.lock_read()
-        self._refresh_data()
-
-    def lock_read(self):
-        if self._write_lock_count:
-            self._write_lock_count += 1
-        else:
-            self.control_files.lock_read()
-            for repo in self._fallback_repositories:
-                # Writes don't affect fallback repos
-                repo.lock_read()
-        self._refresh_data()
-
-    def leave_lock_in_place(self):
-        # not supported - raise an error
-        raise NotImplementedError(self.leave_lock_in_place)
-
-    def dont_leave_lock_in_place(self):
-        # not supported - raise an error
-        raise NotImplementedError(self.dont_leave_lock_in_place)
-
-    @needs_write_lock
-    def pack(self):
-        """Compress the data within the repository.
-
-        This will pack all the data to a single pack. In future it may
-        recompress deltas or do other such expensive operations.
-        """
-        self._pack_collection.pack()
-
-    @needs_write_lock
-    def reconcile(self, other=None, thorough=False):
-        """Reconcile this repository."""
-        from bzrlib.reconcile import PackReconciler
-        reconciler = PackReconciler(self, thorough=thorough)
-        reconciler.reconcile()
-        return reconciler
-
-    def unlock(self):
-        if self._write_lock_count == 1 and self._write_group is not None:
-            self.abort_write_group()
-            self._transaction = None
-            self._write_lock_count = 0
-            raise errors.BzrError(
-                'Must end write group before releasing write lock on %s'
-                % self)
-        if self._write_lock_count:
-            self._write_lock_count -= 1
-            if not self._write_lock_count:
-                transaction = self._transaction
-                self._transaction = None
-                transaction.finish()
-                for repo in self._fallback_repositories:
-                    repo.unlock()
-        else:
-            self.control_files.unlock()
-            for repo in self._fallback_repositories:
-                repo.unlock()
-
-
-class RepositoryFormatPack(MetaDirRepositoryFormat):
-    """Format logic for pack structured repositories.
-
-    This repository format has:
-     - a list of packs in pack-names
-     - packs in packs/NAME.pack
-     - indices in indices/NAME.{iix,six,tix,rix}
-     - knit deltas in the packs, knit indices mapped to the indices.
-     - thunk objects to support the knits programming API.
-     - a format marker of its own
-     - an optional 'shared-storage' flag
-     - an optional 'no-working-trees' flag
-     - a LockDir lock
-    """
-
-    # Set this attribute in derived classes to control the repository class
-    # created by open and initialize.
-    repository_class = None
-    # Set this attribute in derived classes to control the
-    # _commit_builder_class that the repository objects will have passed to
-    # their constructor.
-    _commit_builder_class = None
-    # Set this attribute in derived clases to control the _serializer that the
-    # repository objects will have passed to their constructor.
-    _serializer = None
-    # External references are not supported in pack repositories yet.
-    supports_external_lookups = False
-
-    def initialize(self, a_bzrdir, shared=False):
-        """Create a pack based repository.
-
-        :param a_bzrdir: bzrdir to contain the new repository; must already
-            be initialized.
-        :param shared: If true the repository will be initialized as a shared
-                       repository.
-        """
-        mutter('creating repository in %s.', a_bzrdir.transport.base)
-        dirs = ['indices', 'obsolete_packs', 'packs', 'upload']
-        builder = GraphIndexBuilder()
-        files = [('pack-names', builder.finish())]
-        utf8_files = [('format', self.get_format_string())]
-        
-        self._upload_blank_content(a_bzrdir, dirs, files, utf8_files, shared)
-        return self.open(a_bzrdir=a_bzrdir, _found=True)
-
-    def open(self, a_bzrdir, _found=False, _override_transport=None):
-        """See RepositoryFormat.open().
-        
-        :param _override_transport: INTERNAL USE ONLY. Allows opening the
-                                    repository at a slightly different url
-                                    than normal. I.e. during 'upgrade'.
-        """
-        if not _found:
-            format = RepositoryFormat.find_format(a_bzrdir)
-        if _override_transport is not None:
-            repo_transport = _override_transport
-        else:
-            repo_transport = a_bzrdir.get_repository_transport(None)
-        control_files = lockable_files.LockableFiles(repo_transport,
-                                'lock', lockdir.LockDir)
-        return self.repository_class(_format=self,
-                              a_bzrdir=a_bzrdir,
-                              control_files=control_files,
-                              _commit_builder_class=self._commit_builder_class,
-                              _serializer=self._serializer)
-
-
-class RepositoryFormatKnitPack1(RepositoryFormatPack):
-    """A no-subtrees parameterized Pack repository.
-
-    This format was introduced in 0.92.
-    """
-
-    repository_class = KnitPackRepository
-    _commit_builder_class = PackCommitBuilder
-    _serializer = xml5.serializer_v5
-
-    def _get_matching_bzrdir(self):
-        return bzrdir.format_registry.make_bzrdir('pack-0.92')
-
-    def _ignore_setting_bzrdir(self, format):
-        pass
-
-    _matchingbzrdir = property(_get_matching_bzrdir, _ignore_setting_bzrdir)
-
-    def get_format_string(self):
-        """See RepositoryFormat.get_format_string()."""
-        return "Bazaar pack repository format 1 (needs bzr 0.92)\n"
-
-    def get_format_description(self):
-        """See RepositoryFormat.get_format_description()."""
-        return "Packs containing knits without subtree support"
-
-    def check_conversion_target(self, target_format):
-        pass
-
-
-class RepositoryFormatKnitPack3(RepositoryFormatPack):
-    """A subtrees parameterized Pack repository.
-
-    This repository format uses the xml7 serializer to get:
-     - support for recording full info about the tree root
-     - support for recording tree-references
-
-    This format was introduced in 0.92.
-    """
-
-    repository_class = KnitPackRepository
-    _commit_builder_class = PackRootCommitBuilder
-    rich_root_data = True
-    supports_tree_reference = True
-    _serializer = xml7.serializer_v7
-
-    def _get_matching_bzrdir(self):
-        return bzrdir.format_registry.make_bzrdir(
-            'pack-0.92-subtree')
-
-    def _ignore_setting_bzrdir(self, format):
-        pass
-
-    _matchingbzrdir = property(_get_matching_bzrdir, _ignore_setting_bzrdir)
-
-    def check_conversion_target(self, target_format):
-        if not target_format.rich_root_data:
-            raise errors.BadConversionTarget(
-                'Does not support rich root data.', target_format)
-        if not getattr(target_format, 'supports_tree_reference', False):
-            raise errors.BadConversionTarget(
-                'Does not support nested trees', target_format)
-            
-    def get_format_string(self):
-        """See RepositoryFormat.get_format_string()."""
-        return "Bazaar pack repository format 1 with subtree support (needs bzr 0.92)\n"
-
-    def get_format_description(self):
-        """See RepositoryFormat.get_format_description()."""
-        return "Packs containing knits with subtree support\n"
-
-
-class RepositoryFormatKnitPack4(RepositoryFormatPack):
-    """A rich-root, no subtrees parameterized Pack repository.
-
-    This repository format uses the xml6 serializer to get:
-     - support for recording full info about the tree root
-
-    This format was introduced in 1.0.
-    """
-
-    repository_class = KnitPackRepository
-    _commit_builder_class = PackRootCommitBuilder
-    rich_root_data = True
-    supports_tree_reference = False
-    _serializer = xml6.serializer_v6
-
-    def _get_matching_bzrdir(self):
-        return bzrdir.format_registry.make_bzrdir(
-            'rich-root-pack')
-
-    def _ignore_setting_bzrdir(self, format):
-        pass
-
-    _matchingbzrdir = property(_get_matching_bzrdir, _ignore_setting_bzrdir)
-
-    def check_conversion_target(self, target_format):
-        if not target_format.rich_root_data:
-            raise errors.BadConversionTarget(
-                'Does not support rich root data.', target_format)
-
-    def get_format_string(self):
-        """See RepositoryFormat.get_format_string()."""
-        return ("Bazaar pack repository format 1 with rich root"
-                " (needs bzr 1.0)\n")
-
-    def get_format_description(self):
-        """See RepositoryFormat.get_format_description()."""
-        return "Packs containing knits with rich root support\n"
-
-
-class RepositoryFormatKnitPack5(RepositoryFormatPack):
-    """Repository that supports external references to allow stacking.
-
-    New in release 1.6.
-
-    Supports external lookups, which results in non-truncated ghosts after
-    reconcile compared to pack-0.92 formats.
-    """
-
-    repository_class = KnitPackRepository
-    _commit_builder_class = PackCommitBuilder
-    _serializer = xml5.serializer_v5
-    supports_external_lookups = True
-
-    def _get_matching_bzrdir(self):
-        return bzrdir.format_registry.make_bzrdir('development1')
-
-    def _ignore_setting_bzrdir(self, format):
-        pass
-
-    _matchingbzrdir = property(_get_matching_bzrdir, _ignore_setting_bzrdir)
-
-    def get_format_string(self):
-        """See RepositoryFormat.get_format_string()."""
-        return "Bazaar RepositoryFormatKnitPack5 (bzr 1.6)\n"
-
-    def get_format_description(self):
-        """See RepositoryFormat.get_format_description()."""
-        return "Packs 5 (adds stacking support, requires bzr 1.6)"
-
-    def check_conversion_target(self, target_format):
-        pass
-
-
-class RepositoryFormatKnitPack5RichRoot(RepositoryFormatPack):
-    """A repository with rich roots and stacking.
-
-    New in release 1.6.1.
-
-    Supports stacking on other repositories, allowing data to be accessed
-    without being stored locally.
-    """
-
-    repository_class = KnitPackRepository
-    _commit_builder_class = PackRootCommitBuilder
-    rich_root_data = True
-    supports_tree_reference = False # no subtrees
-    _serializer = xml6.serializer_v6
-    supports_external_lookups = True
-
-    def _get_matching_bzrdir(self):
-        return bzrdir.format_registry.make_bzrdir(
-            '1.6.1-rich-root')
-
-    def _ignore_setting_bzrdir(self, format):
-        pass
-
-    _matchingbzrdir = property(_get_matching_bzrdir, _ignore_setting_bzrdir)
-
-    def check_conversion_target(self, target_format):
-        if not target_format.rich_root_data:
-            raise errors.BadConversionTarget(
-                'Does not support rich root data.', target_format)
-
-    def get_format_string(self):
-        """See RepositoryFormat.get_format_string()."""
-        return "Bazaar RepositoryFormatKnitPack5RichRoot (bzr 1.6.1)\n"
-
-    def get_format_description(self):
-        return "Packs 5 rich-root (adds stacking support, requires bzr 1.6.1)"
-
-
-class RepositoryFormatKnitPack5RichRootBroken(RepositoryFormatPack):
-    """A repository with rich roots and external references.
-
-    New in release 1.6.
-
-    Supports external lookups, which results in non-truncated ghosts after
-    reconcile compared to pack-0.92 formats.
-
-    This format was deprecated because the serializer it uses accidentally
-    supported subtrees, when the format was not intended to. This meant that
-    someone could accidentally fetch from an incorrect repository.
-    """
-
-    repository_class = KnitPackRepository
-    _commit_builder_class = PackRootCommitBuilder
-    rich_root_data = True
-    supports_tree_reference = False # no subtrees
-    _serializer = xml7.serializer_v7
-
-    supports_external_lookups = True
-
-    def _get_matching_bzrdir(self):
-        return bzrdir.format_registry.make_bzrdir(
-            'development1-subtree')
-
-    def _ignore_setting_bzrdir(self, format):
-        pass
-
-    _matchingbzrdir = property(_get_matching_bzrdir, _ignore_setting_bzrdir)
-
-    def check_conversion_target(self, target_format):
-        if not target_format.rich_root_data:
-            raise errors.BadConversionTarget(
-                'Does not support rich root data.', target_format)
-
-    def get_format_string(self):
-        """See RepositoryFormat.get_format_string()."""
-        return "Bazaar RepositoryFormatKnitPack5RichRoot (bzr 1.6)\n"
-
-    def get_format_description(self):
-        return ("Packs 5 rich-root (adds stacking support, requires bzr 1.6)"
-                " (deprecated)")
-
-
-class RepositoryFormatPackDevelopment1(RepositoryFormatPack):
-    """A no-subtrees development repository.
-
-    This format should be retained until the second release after bzr 1.5.
-
-    Supports external lookups, which results in non-truncated ghosts after
-    reconcile compared to pack-0.92 formats.
-    """
-
-    repository_class = KnitPackRepository
-    _commit_builder_class = PackCommitBuilder
-    _serializer = xml5.serializer_v5
-    supports_external_lookups = True
-
-    def _get_matching_bzrdir(self):
-        return bzrdir.format_registry.make_bzrdir('development1')
-
-    def _ignore_setting_bzrdir(self, format):
-        pass
-
-    _matchingbzrdir = property(_get_matching_bzrdir, _ignore_setting_bzrdir)
-
-    def get_format_string(self):
-        """See RepositoryFormat.get_format_string()."""
-        return "Bazaar development format 1 (needs bzr.dev from before 1.6)\n"
-
-    def get_format_description(self):
-        """See RepositoryFormat.get_format_description()."""
-        return ("Development repository format, currently the same as "
-            "pack-0.92 with external reference support.\n")
-
-    def check_conversion_target(self, target_format):
-        pass
-
-
-class RepositoryFormatPackDevelopment1Subtree(RepositoryFormatPack):
-    """A subtrees development repository.
-
-    This format should be retained until the second release after bzr 1.5.
-
-    Supports external lookups, which results in non-truncated ghosts after
-    reconcile compared to pack-0.92 formats.
-    """
-
-    repository_class = KnitPackRepository
-    _commit_builder_class = PackRootCommitBuilder
-    rich_root_data = True
-    supports_tree_reference = True
-    _serializer = xml7.serializer_v7
-    supports_external_lookups = True
-
-    def _get_matching_bzrdir(self):
-        return bzrdir.format_registry.make_bzrdir(
-            'development1-subtree')
-
-    def _ignore_setting_bzrdir(self, format):
-        pass
-
-    _matchingbzrdir = property(_get_matching_bzrdir, _ignore_setting_bzrdir)
-
-    def check_conversion_target(self, target_format):
-        if not target_format.rich_root_data:
-            raise errors.BadConversionTarget(
-                'Does not support rich root data.', target_format)
-        if not getattr(target_format, 'supports_tree_reference', False):
-            raise errors.BadConversionTarget(
-                'Does not support nested trees', target_format)
-            
-    def get_format_string(self):
-        """See RepositoryFormat.get_format_string()."""
-        return ("Bazaar development format 1 with subtree support "
-            "(needs bzr.dev from before 1.6)\n")
-
-    def get_format_description(self):
-        """See RepositoryFormat.get_format_description()."""
-        return ("Development repository format, currently the same as "
-            "pack-0.92-subtree with external reference support.\n")

=== modified file 'bzrlib/repofmt/weaverepo.py'
--- bzrlib/repofmt/weaverepo.py	2008-07-29 15:51:45 +0000
+++ bzrlib/repofmt/weaverepo.py	2007-10-12 02:07:59 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2008 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -20,9 +20,7 @@
 ghosts.
 """
 
-import os
-from cStringIO import StringIO
-import urllib
+from StringIO import StringIO
 
 from bzrlib import (
     bzrdir,
@@ -32,7 +30,6 @@
     lockdir,
     osutils,
     revision as _mod_revision,
-    versionedfile,
     weave,
     weavefile,
     xml5,
@@ -40,19 +37,13 @@
 from bzrlib.decorators import needs_read_lock, needs_write_lock
 from bzrlib.repository import (
     CommitBuilder,
-    MetaDirVersionedFileRepository,
+    MetaDirRepository,
     MetaDirRepositoryFormat,
     Repository,
     RepositoryFormat,
     )
 from bzrlib.store.text import TextStore
 from bzrlib.trace import mutter
-from bzrlib.tuned_gzip import GzipFile, bytes_to_gzip
-from bzrlib.versionedfile import (
-    AbsentContentFactory,
-    FulltextContentFactory,
-    VersionedFiles,
-    )
 
 
 class AllInOneRepository(Repository):
@@ -60,10 +51,10 @@
 
     _serializer = xml5.serializer_v5
 
-    def __init__(self, _format, a_bzrdir):
+    def __init__(self, _format, a_bzrdir, _revision_store, control_store, text_store):
         # we reuse one control files instance.
-        dir_mode = a_bzrdir._get_dir_mode()
-        file_mode = a_bzrdir._get_file_mode()
+        dir_mode = a_bzrdir._control_files._dir_mode
+        file_mode = a_bzrdir._control_files._file_mode
 
         def get_store(name, compressed=True, prefixed=False):
             # FIXME: This approach of assuming stores are all entirely compressed
@@ -71,29 +62,27 @@
             # some existing branches where there's a mixture; we probably 
             # still want the option to look for both.
             relpath = a_bzrdir._control_files._escape(name)
-            store = TextStore(a_bzrdir.transport.clone(relpath),
+            store = TextStore(a_bzrdir._control_files._transport.clone(relpath),
                               prefixed=prefixed, compressed=compressed,
                               dir_mode=dir_mode,
                               file_mode=file_mode)
             return store
 
         # not broken out yet because the controlweaves|inventory_store
-        # and texts bits are still different.
+        # and text_store | weave_store bits are still different.
         if isinstance(_format, RepositoryFormat4):
             # cannot remove these - there is still no consistent api 
             # which allows access to this old info.
             self.inventory_store = get_store('inventory-store')
-            self._text_store = get_store('text-store')
-        super(AllInOneRepository, self).__init__(_format, a_bzrdir, a_bzrdir._control_files)
-        self._fetch_order = 'topological'
-        self._fetch_reconcile = True
+            text_store = get_store('text-store')
+        super(AllInOneRepository, self).__init__(_format, a_bzrdir, a_bzrdir._control_files, _revision_store, control_store, text_store)
 
     @needs_read_lock
     def _all_possible_ids(self):
         """Return all the possible revisions that we could find."""
         if 'evil' in debug.debug_flags:
             mutter_callsite(3, "_all_possible_ids scales with size of history.")
-        return [key[-1] for key in self.inventories.keys()]
+        return self.get_inventory_weave().versions()
 
     @needs_read_lock
     def _all_revision_ids(self):
@@ -103,31 +92,35 @@
         present: for weaves ghosts may lead to a lack of correctness until
         the reweave updates the parents list.
         """
-        return [key[-1] for key in self.revisions.keys()]
-
-    def _activate_new_inventory(self):
-        """Put a replacement inventory.new into use as inventories."""
-        # Copy the content across
-        t = self.bzrdir._control_files._transport
-        t.copy('inventory.new.weave', 'inventory.weave')
-        # delete the temp inventory
-        t.delete('inventory.new.weave')
-        # Check we can parse the new weave properly as a sanity check
-        self.inventories.keys()
-
-    def _backup_inventory(self):
-        t = self.bzrdir._control_files._transport
-        t.copy('inventory.weave', 'inventory.backup.weave')
-
-    def _temp_inventories(self):
-        t = self.bzrdir._control_files._transport
-        return self._format._get_inventories(t, self, 'inventory.new')
+        if self._revision_store.text_store.listable():
+            return self._revision_store.all_revision_ids(self.get_transaction())
+        result = self._all_possible_ids()
+        # TODO: jam 20070210 Ensure that _all_possible_ids returns non-unicode
+        #       ids. (It should, since _revision_store's API should change to
+        #       return utf8 revision_ids)
+        return self._eliminate_revisions_not_present(result)
+
+    def _check_revision_parents(self, revision, inventory):
+        """Private to Repository and Fetch.
+        
+        This checks the parentage of revision in an inventory weave for 
+        consistency and is only applicable to inventory-weave-for-ancestry
+        using repository formats & fetchers.
+        """
+        weave_parents = inventory.get_parents(revision.revision_id)
+        weave_names = inventory.versions()
+        for parent_id in revision.parent_ids:
+            if parent_id in weave_names:
+                # this parent must not be a ghost.
+                if not parent_id in weave_parents:
+                    # but it is a ghost
+                    raise errors.CorruptRepository(self)
 
     def get_commit_builder(self, branch, parents, config, timestamp=None,
                            timezone=None, committer=None, revprops=None,
                            revision_id=None):
         self._check_ascii_revisionid(revision_id, self.get_commit_builder)
-        result = CommitBuilder(self, parents, config, timestamp, timezone,
+        result = WeaveCommitBuilder(self, parents, config, timestamp, timezone,
                               committer, revprops, revision_id)
         self.start_write_group()
         return result
@@ -135,19 +128,55 @@
     @needs_read_lock
     def get_revisions(self, revision_ids):
         revs = self._get_revisions(revision_ids)
+        # weave corruption can lead to absent revision markers that should be
+        # present.
+        # the following test is reasonably cheap (it needs a single weave read)
+        # and the weave is cached in read transactions. In write transactions
+        # it is not cached but typically we only read a small number of
+        # revisions. For knits when they are introduced we will probably want
+        # to ensure that caching write transactions are in use.
+        inv = self.get_inventory_weave()
+        for rev in revs:
+            self._check_revision_parents(rev, inv)
         return revs
 
-    def _inventory_add_lines(self, revision_id, parents, lines,
-        check_content=True):
-        """Store lines in inv_vf and return the sha1 of the inventory."""
-        present_parents = self.get_graph().get_parent_map(parents)
-        final_parents = []
-        for parent in parents:
-            if parent in present_parents:
-                final_parents.append((parent,))
-        return self.inventories.add_lines((revision_id,), final_parents, lines,
-            check_content=check_content)[0]
+    @needs_read_lock
+    def get_revision_graph(self, revision_id=None):
+        """Return a dictionary containing the revision graph.
+        
+        :param revision_id: The revision_id to get a graph from. If None, then
+        the entire revision graph is returned. This is a deprecated mode of
+        operation and will be removed in the future.
+        :return: a dictionary of revision_id->revision_parents_list.
+        """
+        if 'evil' in debug.debug_flags:
+            mutter_callsite(2,
+                "get_revision_graph scales with size of history.")
+        # special case NULL_REVISION
+        if revision_id == _mod_revision.NULL_REVISION:
+            return {}
+        a_weave = self.get_inventory_weave()
+        all_revisions = self._eliminate_revisions_not_present(
+                                a_weave.versions())
+        entire_graph = dict([(node, tuple(a_weave.get_parents(node))) for 
+                             node in all_revisions])
+        if revision_id is None:
+            return entire_graph
+        elif revision_id not in entire_graph:
+            raise errors.NoSuchRevision(self, revision_id)
+        else:
+            # add what can be reached from revision_id
+            result = {}
+            pending = set([revision_id])
+            while len(pending) > 0:
+                node = pending.pop()
+                result[node] = entire_graph[node]
+                for revision_id in result[node]:
+                    if revision_id not in result:
+                        pending.add(revision_id)
+            return result
 
+    @needs_read_lock
     def is_shared(self):
         """AllInOne repositories cannot be shared."""
         return False
@@ -162,8 +191,8 @@
         :param new_value: True to restore the default, False to disable making
                           working trees.
         """
-        raise errors.RepositoryUpgradeRequired(self.bzrdir.root_transport.base)
-
+        raise NotImplementedError(self.set_make_working_trees)
+    
     def make_working_trees(self):
         """Returns the policy for making working trees on new branches."""
         return True
@@ -174,22 +203,17 @@
         return False
 
 
-class WeaveMetaDirRepository(MetaDirVersionedFileRepository):
+class WeaveMetaDirRepository(MetaDirRepository):
     """A subclass of MetaDirRepository to set weave specific policy."""
 
     _serializer = xml5.serializer_v5
 
-    def __init__(self, _format, a_bzrdir, control_files):
-        super(WeaveMetaDirRepository, self).__init__(_format, a_bzrdir, control_files)
-        self._fetch_order = 'topological'
-        self._fetch_reconcile = True
-
     @needs_read_lock
     def _all_possible_ids(self):
         """Return all the possible revisions that we could find."""
         if 'evil' in debug.debug_flags:
             mutter_callsite(3, "_all_possible_ids scales with size of history.")
-        return [key[-1] for key in self.inventories.keys()]
+        return self.get_inventory_weave().versions()
 
     @needs_read_lock
     def _all_revision_ids(self):
@@ -199,31 +223,35 @@
         present: for weaves ghosts may lead to a lack of correctness until
         the reweave updates the parents list.
         """
-        return [key[-1] for key in self.revisions.keys()]
-
-    def _activate_new_inventory(self):
-        """Put a replacement inventory.new into use as inventories."""
-        # Copy the content across
-        t = self._transport
-        t.copy('inventory.new.weave', 'inventory.weave')
-        # delete the temp inventory
-        t.delete('inventory.new.weave')
-        # Check we can parse the new weave properly as a sanity check
-        self.inventories.keys()
-
-    def _backup_inventory(self):
-        t = self._transport
-        t.copy('inventory.weave', 'inventory.backup.weave')
-
-    def _temp_inventories(self):
-        t = self._transport
-        return self._format._get_inventories(t, self, 'inventory.new')
+        if self._revision_store.text_store.listable():
+            return self._revision_store.all_revision_ids(self.get_transaction())
+        result = self._all_possible_ids()
+        # TODO: jam 20070210 Ensure that _all_possible_ids returns non-unicode
+        #       ids. (It should, since _revision_store's API should change to
+        #       return utf8 revision_ids)
+        return self._eliminate_revisions_not_present(result)
+
+    def _check_revision_parents(self, revision, inventory):
+        """Private to Repository and Fetch.
+        
+        This checks the parentage of revision in an inventory weave for 
+        consistency and is only applicable to inventory-weave-for-ancestry
+        using repository formats & fetchers.
+        """
+        weave_parents = inventory.get_parents(revision.revision_id)
+        weave_names = inventory.versions()
+        for parent_id in revision.parent_ids:
+            if parent_id in weave_names:
+                # this parent must not be a ghost.
+                if not parent_id in weave_parents:
+                    # but it is a ghost
+                    raise errors.CorruptRepository(self)
 
     def get_commit_builder(self, branch, parents, config, timestamp=None,
                            timezone=None, committer=None, revprops=None,
                            revision_id=None):
         self._check_ascii_revisionid(revision_id, self.get_commit_builder)
-        result = CommitBuilder(self, parents, config, timestamp, timezone,
+        result = WeaveCommitBuilder(self, parents, config, timestamp, timezone,
                               committer, revprops, revision_id)
         self.start_write_group()
         return result
@@ -231,21 +259,58 @@
     @needs_read_lock
     def get_revision(self, revision_id):
         """Return the Revision object for a named revision"""
+        # TODO: jam 20070210 get_revision_reconcile should do this for us
         r = self.get_revision_reconcile(revision_id)
+        # weave corruption can lead to absent revision markers that should be
+        # present.
+        # the following test is reasonably cheap (it needs a single weave read)
+        # and the weave is cached in read transactions. In write transactions
+        # it is not cached but typically we only read a small number of
+        # revisions. For knits when they are introduced we will probably want
+        # to ensure that caching write transactions are in use.
+        inv = self.get_inventory_weave()
+        self._check_revision_parents(r, inv)
         return r
 
-    def _inventory_add_lines(self, revision_id, parents, lines,
-        check_content=True):
-        """Store lines in inv_vf and return the sha1 of the inventory."""
-        present_parents = self.get_graph().get_parent_map(parents)
-        final_parents = []
-        for parent in parents:
-            if parent in present_parents:
-                final_parents.append((parent,))
-        return self.inventories.add_lines((revision_id,), final_parents, lines,
-            check_content=check_content)[0]
+    @needs_read_lock
+    def get_revision_graph(self, revision_id=None):
+        """Return a dictionary containing the revision graph.
+        
+        :param revision_id: The revision_id to get a graph from. If None, then
+        the entire revision graph is returned. This is a deprecated mode of
+        operation and will be removed in the future.
+        :return: a dictionary of revision_id->revision_parents_list.
+        """
+        if 'evil' in debug.debug_flags:
+            mutter_callsite(3,
+                "get_revision_graph scales with size of history.")
+        # special case NULL_REVISION
+        if revision_id == _mod_revision.NULL_REVISION:
+            return {}
+        a_weave = self.get_inventory_weave()
+        all_revisions = self._eliminate_revisions_not_present(
+                                a_weave.versions())
+        entire_graph = dict([(node, tuple(a_weave.get_parents(node))) for 
+                             node in all_revisions])
+        if revision_id is None:
+            return entire_graph
+        elif revision_id not in entire_graph:
+            raise errors.NoSuchRevision(self, revision_id)
+        else:
+            # add what can be reached from revision_id
+            result = {}
+            pending = set([revision_id])
+            while len(pending) > 0:
+                node = pending.pop()
+                result[node] = entire_graph[node]
+                for revision_id in result[node]:
+                    if revision_id not in result:
+                        pending.add(revision_id)
+            return result
 
     def revision_graph_can_have_wrong_parents(self):
+        # XXX: This is an old format that we don't support full checking on, so
+        # just claim that checking for this inconsistency is not required.
         return False
 
 
@@ -254,11 +319,13 @@
 
     rich_root_data = False
     supports_tree_reference = False
-    supports_ghosts = False
-    supports_external_lookups = False
 
     def initialize(self, a_bzrdir, shared=False, _internal=False):
-        """Create a weave repository."""
+        """Create a weave repository.
+        
+        TODO: when creating split out bzr branch formats, move this to a common
+        base for Format5, Format6. or something like that.
+        """
         if shared:
             raise errors.IncompatibleFormat(self, a_bzrdir._format)
 
@@ -272,22 +339,36 @@
         empty_weave = sio.getvalue()
 
         mutter('creating repository in %s.', a_bzrdir.transport.base)
+        dirs = ['revision-store', 'weaves']
+        files = [('inventory.weave', StringIO(empty_weave)),
+                 ]
         
         # FIXME: RBC 20060125 don't peek under the covers
         # NB: no need to escape relative paths that are url safe.
         control_files = lockable_files.LockableFiles(a_bzrdir.transport,
-            'branch-lock', lockable_files.TransportLock)
+                                'branch-lock', lockable_files.TransportLock)
         control_files.create_lock()
         control_files.lock_write()
-        transport = a_bzrdir.transport
+        control_files._transport.mkdir_multi(dirs,
+                mode=control_files._dir_mode)
         try:
-            transport.mkdir_multi(['revision-store', 'weaves'],
-                mode=a_bzrdir._get_dir_mode())
-            transport.put_bytes_non_atomic('inventory.weave', empty_weave)
+            for file, content in files:
+                control_files.put(file, content)
         finally:
             control_files.unlock()
         return self.open(a_bzrdir, _found=True)
 
+    def _get_control_store(self, repo_transport, control_files):
+        """Return the control store for this repository."""
+        return self._get_versioned_file_store('',
+                                              repo_transport,
+                                              control_files,
+                                              prefixed=False)
+
+    def _get_text_store(self, transport, control_files):
+        """Get a store for file texts for this format."""
+        raise NotImplementedError(self._get_text_store)
+
     def open(self, a_bzrdir, _found=False):
         """See RepositoryFormat.open()."""
         if not _found:
@@ -296,12 +377,14 @@
 
         repo_transport = a_bzrdir.get_repository_transport(None)
         control_files = a_bzrdir._control_files
-        result = AllInOneRepository(_format=self, a_bzrdir=a_bzrdir)
-        result.revisions = self._get_revisions(repo_transport, result)
-        result.signatures = self._get_signatures(repo_transport, result)
-        result.inventories = self._get_inventories(repo_transport, result)
-        result.texts = self._get_texts(repo_transport, result)
-        return result
+        text_store = self._get_text_store(repo_transport, control_files)
+        control_store = self._get_control_store(repo_transport, control_files)
+        _revision_store = self._get_revision_store(repo_transport, control_files)
+        return AllInOneRepository(_format=self,
+                                  a_bzrdir=a_bzrdir,
+                                  _revision_store=_revision_store,
+                                  control_store=control_store,
+                                  text_store=text_store)
 
     def check_conversion_target(self, target_format):
         pass
@@ -323,8 +406,6 @@
 
     def __init__(self):
         super(RepositoryFormat4, self).__init__()
-        self._fetch_order = 'topological'
-        self._fetch_reconcile = True
 
     def get_format_description(self):
         """See RepositoryFormat.get_format_description()."""
@@ -343,23 +424,23 @@
         """
         return False
 
-    def _get_inventories(self, repo_transport, repo, name='inventory'):
-        # No inventories store written so far.
+    def _get_control_store(self, repo_transport, control_files):
+        """Format 4 repositories have no formal control store at this point.
+        
+        This will cause any control-file-needing apis to fail - this is desired.
+        """
         return None
-
-    def _get_revisions(self, repo_transport, repo):
+    
+    def _get_revision_store(self, repo_transport, control_files):
+        """See RepositoryFormat._get_revision_store()."""
         from bzrlib.xml4 import serializer_v4
-        return RevisionTextStore(repo_transport.clone('revision-store'),
-            serializer_v4, True, versionedfile.PrefixMapper(),
-            repo.is_locked, repo.is_write_locked)
-
-    def _get_signatures(self, repo_transport, repo):
-        return SignatureTextStore(repo_transport.clone('revision-store'),
-            False, versionedfile.PrefixMapper(),
-            repo.is_locked, repo.is_write_locked)
-
-    def _get_texts(self, repo_transport, repo):
-        return None
+        return self._get_text_rev_store(repo_transport,
+                                        control_files,
+                                        'revision-store',
+                                        serializer=serializer_v4)
+
+    def _get_text_store(self, transport, control_files):
+        """See RepositoryFormat._get_text_store()."""
 
 
 class RepositoryFormat5(PreSplitOutRepositoryFormat):
@@ -376,34 +457,22 @@
 
     def __init__(self):
         super(RepositoryFormat5, self).__init__()
-        self._fetch_order = 'topological'
-        self._fetch_reconcile = True
 
     def get_format_description(self):
         """See RepositoryFormat.get_format_description()."""
         return "Weave repository format 5"
 
-    def _get_inventories(self, repo_transport, repo, name='inventory'):
-        mapper = versionedfile.ConstantMapper(name)
-        return versionedfile.ThunkedVersionedFiles(repo_transport,
-            weave.WeaveFile, mapper, repo.is_locked)
-
-    def _get_revisions(self, repo_transport, repo):
-        from bzrlib.xml5 import serializer_v5
-        return RevisionTextStore(repo_transport.clone('revision-store'),
-            serializer_v5, False, versionedfile.PrefixMapper(),
-            repo.is_locked, repo.is_write_locked)
-
-    def _get_signatures(self, repo_transport, repo):
-        return SignatureTextStore(repo_transport.clone('revision-store'),
-            False, versionedfile.PrefixMapper(),
-            repo.is_locked, repo.is_write_locked)
-
-    def _get_texts(self, repo_transport, repo):
-        mapper = versionedfile.PrefixMapper()
-        base_transport = repo_transport.clone('weaves')
-        return versionedfile.ThunkedVersionedFiles(base_transport,
-            weave.WeaveFile, mapper, repo.is_locked)
+    def _get_revision_store(self, repo_transport, control_files):
+        """See RepositoryFormat._get_revision_store()."""
+        """Return the revision store object for this a_bzrdir."""
+        return self._get_text_rev_store(repo_transport,
+                                        control_files,
+                                        'revision-store',
+                                        compressed=False)
+
+    def _get_text_store(self, transport, control_files):
+        """See RepositoryFormat._get_text_store()."""
+        return self._get_versioned_file_store('weaves', transport, control_files, prefixed=False)
 
 
 class RepositoryFormat6(PreSplitOutRepositoryFormat):
@@ -420,35 +489,22 @@
 
     def __init__(self):
         super(RepositoryFormat6, self).__init__()
-        self._fetch_order = 'topological'
-        self._fetch_reconcile = True
 
     def get_format_description(self):
         """See RepositoryFormat.get_format_description()."""
         return "Weave repository format 6"
 
-    def _get_inventories(self, repo_transport, repo, name='inventory'):
-        mapper = versionedfile.ConstantMapper(name)
-        return versionedfile.ThunkedVersionedFiles(repo_transport,
-            weave.WeaveFile, mapper, repo.is_locked)
-
-    def _get_revisions(self, repo_transport, repo):
-        from bzrlib.xml5 import serializer_v5
-        return RevisionTextStore(repo_transport.clone('revision-store'),
-            serializer_v5, False, versionedfile.HashPrefixMapper(),
-            repo.is_locked, repo.is_write_locked)
-
-    def _get_signatures(self, repo_transport, repo):
-        return SignatureTextStore(repo_transport.clone('revision-store'),
-            False, versionedfile.HashPrefixMapper(),
-            repo.is_locked, repo.is_write_locked)
-
-    def _get_texts(self, repo_transport, repo):
-        mapper = versionedfile.HashPrefixMapper()
-        base_transport = repo_transport.clone('weaves')
-        return versionedfile.ThunkedVersionedFiles(base_transport,
-            weave.WeaveFile, mapper, repo.is_locked)
-
+    def _get_revision_store(self, repo_transport, control_files):
+        """See RepositoryFormat._get_revision_store()."""
+        return self._get_text_rev_store(repo_transport,
+                                        control_files,
+                                        'revision-store',
+                                        compressed=False,
+                                        prefixed=True)
+
+    def _get_text_store(self, transport, control_files):
+        """See RepositoryFormat._get_text_store()."""
+        return self._get_versioned_file_store('weaves', transport, control_files)
 
 class RepositoryFormat7(MetaDirRepositoryFormat):
     """Bzr repository 7.
@@ -463,7 +519,13 @@
     """
 
     _versionedfile_class = weave.WeaveFile
-    supports_ghosts = False
+
+    def _get_control_store(self, repo_transport, control_files):
+        """Return the control store for this repository."""
+        return self._get_versioned_file_store('',
+                                              repo_transport,
+                                              control_files,
+                                              prefixed=False)
 
     def get_format_string(self):
         """See RepositoryFormat.get_format_string()."""
@@ -476,27 +538,20 @@
     def check_conversion_target(self, target_format):
         pass
 
-    def _get_inventories(self, repo_transport, repo, name='inventory'):
-        mapper = versionedfile.ConstantMapper(name)
-        return versionedfile.ThunkedVersionedFiles(repo_transport,
-            weave.WeaveFile, mapper, repo.is_locked)
-
-    def _get_revisions(self, repo_transport, repo):
-        from bzrlib.xml5 import serializer_v5
-        return RevisionTextStore(repo_transport.clone('revision-store'),
-            serializer_v5, True, versionedfile.HashPrefixMapper(),
-            repo.is_locked, repo.is_write_locked)
-
-    def _get_signatures(self, repo_transport, repo):
-        return SignatureTextStore(repo_transport.clone('revision-store'),
-            True, versionedfile.HashPrefixMapper(),
-            repo.is_locked, repo.is_write_locked)
-
-    def _get_texts(self, repo_transport, repo):
-        mapper = versionedfile.HashPrefixMapper()
-        base_transport = repo_transport.clone('weaves')
-        return versionedfile.ThunkedVersionedFiles(base_transport,
-            weave.WeaveFile, mapper, repo.is_locked)
+    def _get_revision_store(self, repo_transport, control_files):
+        """See RepositoryFormat._get_revision_store()."""
+        return self._get_text_rev_store(repo_transport,
+                                        control_files,
+                                        'revision-store',
+                                        compressed=False,
+                                        prefixed=True,
+                                        )
+
+    def _get_text_store(self, transport, control_files):
+        """See RepositoryFormat._get_text_store()."""
+        return self._get_versioned_file_store('weaves',
+                                              transport,
+                                              control_files)
 
     def initialize(self, a_bzrdir, shared=False):
         """Create a weave repository.
@@ -527,189 +582,36 @@
         """
         if not _found:
             format = RepositoryFormat.find_format(a_bzrdir)
+            assert format.__class__ ==  self.__class__
         if _override_transport is not None:
             repo_transport = _override_transport
         else:
             repo_transport = a_bzrdir.get_repository_transport(None)
         control_files = lockable_files.LockableFiles(repo_transport,
                                 'lock', lockdir.LockDir)
-        result = WeaveMetaDirRepository(_format=self, a_bzrdir=a_bzrdir,
-            control_files=control_files)
-        result.revisions = self._get_revisions(repo_transport, result)
-        result.signatures = self._get_signatures(repo_transport, result)
-        result.inventories = self._get_inventories(repo_transport, result)
-        result.texts = self._get_texts(repo_transport, result)
-        result._transport = repo_transport
-        return result
-
-
-class TextVersionedFiles(VersionedFiles):
-    """Just-a-bunch-of-files based VersionedFile stores."""
-
-    def __init__(self, transport, compressed, mapper, is_locked, can_write):
-        self._compressed = compressed
-        self._transport = transport
-        self._mapper = mapper
-        if self._compressed:
-            self._ext = '.gz'
-        else:
-            self._ext = ''
-        self._is_locked = is_locked
-        self._can_write = can_write
-
-    def add_lines(self, key, parents, lines):
-        """Add a revision to the store."""
-        if not self._is_locked():
-            raise errors.ObjectNotLocked(self)
-        if not self._can_write():
-            raise errors.ReadOnlyError(self)
-        if '/' in key[-1]:
-            raise ValueError('bad idea to put / in %r' % (key,))
-        text = ''.join(lines)
-        if self._compressed:
-            text = bytes_to_gzip(text)
-        path = self._map(key)
-        self._transport.put_bytes_non_atomic(path, text, create_parent_dir=True)
-
-    def insert_record_stream(self, stream):
-        adapters = {}
-        for record in stream:
-            # Raise an error when a record is missing.
-            if record.storage_kind == 'absent':
-                raise errors.RevisionNotPresent([record.key[0]], self)
-            # adapt to non-tuple interface
-            if record.storage_kind == 'fulltext':
-                self.add_lines(record.key, None,
-                    osutils.split_lines(record.get_bytes_as('fulltext')))
-            else:
-                adapter_key = record.storage_kind, 'fulltext'
-                try:
-                    adapter = adapters[adapter_key]
-                except KeyError:
-                    adapter_factory = adapter_registry.get(adapter_key)
-                    adapter = adapter_factory(self)
-                    adapters[adapter_key] = adapter
-                lines = osutils.split_lines(adapter.get_bytes(
-                    record, record.get_bytes_as(record.storage_kind)))
-                try:
-                    self.add_lines(record.key, None, lines)
-                except RevisionAlreadyPresent:
-                    pass
-
-    def _load_text(self, key):
-        if not self._is_locked():
-            raise errors.ObjectNotLocked(self)
-        path = self._map(key)
-        try:
-            text = self._transport.get_bytes(path)
-            compressed = self._compressed
-        except errors.NoSuchFile:
-            if self._compressed:
-                # try without the .gz
-                path = path[:-3]
-                try:
-                    text = self._transport.get_bytes(path)
-                    compressed = False
-                except errors.NoSuchFile:
-                    return None
-            else:
-                return None
-        if compressed:
-            text = GzipFile(mode='rb', fileobj=StringIO(text)).read()
-        return text
-
-    def _map(self, key):
-        return self._mapper.map(key) + self._ext
-
-
-class RevisionTextStore(TextVersionedFiles):
-    """Legacy thunk for format 4 repositories."""
-
-    def __init__(self, transport, serializer, compressed, mapper, is_locked,
-        can_write):
-        """Create a RevisionTextStore at transport with serializer."""
-        TextVersionedFiles.__init__(self, transport, compressed, mapper,
-            is_locked, can_write)
-        self._serializer = serializer
-
-    def _load_text_parents(self, key):
-        text = self._load_text(key)
-        if text is None:
-            return None, None
-        parents = self._serializer.read_revision_from_string(text).parent_ids
-        return text, tuple((parent,) for parent in parents)
-
-    def get_parent_map(self, keys):
-        result = {}
-        for key in keys:
-            parents = self._load_text_parents(key)[1]
-            if parents is None:
-                continue
-            result[key] = parents
-        return result
-    
-    def get_record_stream(self, keys, sort_order, include_delta_closure):
-        for key in keys:
-            text, parents = self._load_text_parents(key)
-            if text is None:
-                yield AbsentContentFactory(key)
-            else:
-                yield FulltextContentFactory(key, parents, None, text)
-
-    def keys(self):
-        if not self._is_locked():
-            raise errors.ObjectNotLocked(self)
-        relpaths = set()
-        for quoted_relpath in self._transport.iter_files_recursive():
-            relpath = urllib.unquote(quoted_relpath)
-            path, ext = os.path.splitext(relpath)
-            if ext == '.gz':
-                relpath = path
-            if '.sig' not in relpath:
-                relpaths.add(relpath)
-        paths = list(relpaths)
-        return set([self._mapper.unmap(path) for path in paths])
-
-
-class SignatureTextStore(TextVersionedFiles):
-    """Legacy thunk for format 4-7 repositories."""
-
-    def __init__(self, transport, compressed, mapper, is_locked, can_write):
-        TextVersionedFiles.__init__(self, transport, compressed, mapper,
-            is_locked, can_write)
-        self._ext = '.sig' + self._ext
-
-    def get_parent_map(self, keys):
-        result = {}
-        for key in keys:
-            text = self._load_text(key)
-            if text is None:
-                continue
-            result[key] = None
-        return result
-    
-    def get_record_stream(self, keys, sort_order, include_delta_closure):
-        for key in keys:
-            text = self._load_text(key)
-            if text is None:
-                yield AbsentContentFactory(key)
-            else:
-                yield FulltextContentFactory(key, None, None, text)
-
-    def keys(self):
-        if not self._is_locked():
-            raise errors.ObjectNotLocked(self)
-        relpaths = set()
-        for quoted_relpath in self._transport.iter_files_recursive():
-            relpath = urllib.unquote(quoted_relpath)
-            path, ext = os.path.splitext(relpath)
-            if ext == '.gz':
-                relpath = path
-            if not relpath.endswith('.sig'):
-                continue
-            relpaths.add(relpath[:-4])
-        paths = list(relpaths)
-        return set([self._mapper.unmap(path) for path in paths])
+        text_store = self._get_text_store(repo_transport, control_files)
+        control_store = self._get_control_store(repo_transport, control_files)
+        _revision_store = self._get_revision_store(repo_transport, control_files)
+        return WeaveMetaDirRepository(_format=self,
+            a_bzrdir=a_bzrdir,
+            control_files=control_files,
+            _revision_store=_revision_store,
+            control_store=control_store,
+            text_store=text_store)
+
+
+class WeaveCommitBuilder(CommitBuilder):
+    """A builder for weave based repos that don't support ghosts."""
+
+    def _add_text_to_weave(self, file_id, new_lines, parents, nostore_sha):
+        versionedfile = self.repository.weave_store.get_weave_or_empty(
+            file_id, self.repository.get_transaction())
+        result = versionedfile.add_lines(
+            self._new_revision_id, parents, new_lines,
+            nostore_sha=nostore_sha)[0:2]
+        versionedfile.clear_cache()
+        return result
+
 
 _legacy_formats = [RepositoryFormat4(),
                    RepositoryFormat5(),

=== modified file 'bzrlib/repository.py'
--- bzrlib/repository.py	2008-09-03 19:54:34 +0000
+++ bzrlib/repository.py	2007-10-19 17:00:10 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2008 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -25,6 +25,7 @@
     bzrdir,
     check,
     debug,
+    deprecated_graph,
     errors,
     generate_ids,
     gpg,
@@ -32,14 +33,12 @@
     lazy_regex,
     lockable_files,
     lockdir,
-    lru_cache,
     osutils,
     registry,
     remote,
     revision as _mod_revision,
     symbol_versioning,
     transactions,
-    tsort,
     ui,
     )
 from bzrlib.bundle import serializer
@@ -55,10 +54,6 @@
 from bzrlib.inventory import Inventory, InventoryDirectory, ROOT_ID
 from bzrlib.symbol_versioning import (
         deprecated_method,
-        one_one,
-        one_two,
-        one_three,
-        one_six,
         )
 from bzrlib.trace import mutter, mutter_callsite, note, warning
 
@@ -79,8 +74,8 @@
     # the default CommitBuilder does not manage trees whose root is versioned.
     _versioned_root = False
 
-    def __init__(self, repository, parents, config, timestamp=None,
-                 timezone=None, committer=None, revprops=None,
+    def __init__(self, repository, parents, config, timestamp=None, 
+                 timezone=None, committer=None, revprops=None, 
                  revision_id=None):
         """Initiate a CommitBuilder.
 
@@ -98,6 +93,7 @@
         if committer is None:
             self._committer = self._config.username()
         else:
+            assert isinstance(committer, basestring), type(committer)
             self._committer = committer
 
         self.new_inventory = Inventory(None)
@@ -120,7 +116,7 @@
             self._timezone = int(timezone)
 
         self._generate_revision_if_needed()
-        self.__heads = graph.HeadsCache(repository.get_graph()).heads
+        self._heads = graph.HeadsCache(repository.get_graph()).heads
 
     def commit(self, message):
         """Make the actual commit.
@@ -162,7 +158,8 @@
         """Tell the builder that the inventory is finished."""
         if self.new_inventory.root is None:
             raise AssertionError('Root entry should be supplied to'
-                ' record_entry_contents, as of bzr 0.10.')
+                ' record_entry_contents, as of bzr 0.10.',
+                 DeprecationWarning, stacklevel=2)
             self.new_inventory.add(InventoryDirectory(ROOT_ID, '', None))
         self.new_inventory.revision_id = self._new_revision_id
         self.inv_sha1 = self.repository.add_inventory(
@@ -191,14 +188,6 @@
         else:
             self.random_revid = False
 
-    def _heads(self, file_id, revision_ids):
-        """Calculate the graph heads for revision_ids in the graph of file_id.
-
-        This can use either a per-file graph or a global revision graph as we
-        have an identity relationship between the two graphs.
-        """
-        return self.__heads(revision_ids)
-
     def _check_root(self, ie, parent_invs, tree):
         """Helper for record_entry_contents.
 
@@ -291,18 +280,12 @@
             else:
                 # we don't need to commit this, because the caller already
                 # determined that an existing revision of this file is
-                # appropriate. If its not being considered for committing then
-                # it and all its parents to the root must be unaltered so
-                # no-change against the basis.
-                if ie.revision == self._new_revision_id:
-                    raise AssertionError("Impossible situation, a skipped "
-                        "inventory entry (%r) claims to be modified in this "
-                        "commit (%r).", (ie, self._new_revision_id))
-                return None, False
+                # appropriate.
+                return None, (ie.revision == self._new_revision_id)
         # XXX: Friction: parent_candidates should return a list not a dict
         #      so that we don't have to walk the inventories again.
         parent_candiate_entries = ie.parent_candidates(parent_invs)
-        head_set = self._heads(ie.file_id, parent_candiate_entries.keys())
+        head_set = self._heads(parent_candiate_entries.keys())
         heads = []
         for inv in parent_invs:
             if ie.file_id in inv:
@@ -335,8 +318,8 @@
             if kind != parent_entry.kind:
                 store = True
         if kind == 'file':
-            if content_summary[2] is None:
-                raise ValueError("Files must not have executable = None")
+            assert content_summary[2] is not None, \
+                "Files must not have executable = None"
             if not store:
                 if (# if the file length changed we have to store:
                     parent_entry.text_size != content_summary[1] or
@@ -417,16 +400,23 @@
         return self._get_delta(ie, basis_inv, path), True
 
     def _add_text_to_weave(self, file_id, new_lines, parents, nostore_sha):
+        versionedfile = self.repository.weave_store.get_weave_or_empty(
+            file_id, self.repository.get_transaction())
+        # Don't change this to add_lines - add_lines_with_ghosts is cheaper
+        # than add_lines, and allows committing when a parent is ghosted for
+        # some reason.
         # Note: as we read the content directly from the tree, we know its not
         # been turned into unicode or badly split - but a broken tree
         # implementation could give us bad output from readlines() so this is
         # not a guarantee of safety. What would be better is always checking
         # the content during test suite execution. RBC 20070912
-        parent_keys = tuple((file_id, parent) for parent in parents)
-        return self.repository.texts.add_lines(
-            (file_id, self._new_revision_id), parent_keys, new_lines,
-            nostore_sha=nostore_sha, random_id=self.random_revid,
-            check_content=False)[0:2]
+        try:
+            return versionedfile.add_lines_with_ghosts(
+                self._new_revision_id, parents, new_lines,
+                nostore_sha=nostore_sha, random_id=self.random_revid,
+                check_content=False)[0:2]
+        finally:
+            versionedfile.clear_cache()
 
 
 class RootCommitBuilder(CommitBuilder):
@@ -455,43 +445,9 @@
     revisions and file history.  It's normally accessed only by the Branch,
     which views a particular line of development through that history.
 
-    The Repository builds on top of some byte storage facilies (the revisions,
-    signatures, inventories and texts attributes) and a Transport, which
-    respectively provide byte storage and a means to access the (possibly
+    The Repository builds on top of Stores and a Transport, which respectively 
+    describe the disk data format and the way of accessing the (possibly 
     remote) disk.
-
-    The byte storage facilities are addressed via tuples, which we refer to
-    as 'keys' throughout the code base. Revision_keys, inventory_keys and
-    signature_keys are all 1-tuples: (revision_id,). text_keys are two-tuples:
-    (file_id, revision_id). We use this interface because it allows low
-    friction with the underlying code that implements disk indices, network
-    encoding and other parts of bzrlib.
-
-    :ivar revisions: A bzrlib.versionedfile.VersionedFiles instance containing
-        the serialised revisions for the repository. This can be used to obtain
-        revision graph information or to access raw serialised revisions.
-        The result of trying to insert data into the repository via this store
-        is undefined: it should be considered read-only except for implementors
-        of repositories.
-    :ivar signatures: A bzrlib.versionedfile.VersionedFiles instance containing
-        the serialised signatures for the repository. This can be used to
-        obtain access to raw serialised signatures.  The result of trying to
-        insert data into the repository via this store is undefined: it should
-        be considered read-only except for implementors of repositories.
-    :ivar inventories: A bzrlib.versionedfile.VersionedFiles instance containing
-        the serialised inventories for the repository. This can be used to
-        obtain unserialised inventories.  The result of trying to insert data
-        into the repository via this store is undefined: it should be
-        considered read-only except for implementors of repositories.
-    :ivar texts: A bzrlib.versionedfile.VersionedFiles instance containing the
-        texts of files and directories for the repository. This can be used to
-        obtain file texts or file graphs. Note that Repository.iter_file_bytes
-        is usually a better interface for accessing file texts.
-        The result of trying to insert data into the repository via this store
-        is undefined: it should be considered read-only except for implementors
-        of repositories.
-    :ivar _transport: Transport for file access to repository, typically
-        pointing to .bzr/repository.
     """
 
     # What class to use for a CommitBuilder. Often its simpler to change this
@@ -529,59 +485,36 @@
         attempted.
         """
 
-    def add_fallback_repository(self, repository):
-        """Add a repository to use for looking up data not held locally.
-        
-        :param repository: A repository.
-        """
-        if not self._format.supports_external_lookups:
-            raise errors.UnstackableRepositoryFormat(self._format, self.base)
-        self._check_fallback_repository(repository)
-        self._fallback_repositories.append(repository)
-        self.texts.add_fallback_versioned_files(repository.texts)
-        self.inventories.add_fallback_versioned_files(repository.inventories)
-        self.revisions.add_fallback_versioned_files(repository.revisions)
-        self.signatures.add_fallback_versioned_files(repository.signatures)
-
-    def _check_fallback_repository(self, repository):
-        """Check that this repository can fallback to repository safely.
-
-        Raise an error if not.
-        
-        :param repository: A repository to fallback to.
-        """
-        return InterRepository._assert_same_model(self, repository)
-
+    @needs_write_lock
     def add_inventory(self, revision_id, inv, parents):
         """Add the inventory inv to the repository as revision_id.
         
         :param parents: The revision ids of the parents that revision_id
                         is known to have and are in the repository already.
 
-        :returns: The validator(which is a sha1 digest, though what is sha'd is
-            repository format specific) of the serialized inventory.
+        returns the sha1 of the serialized inventory.
         """
-        if not self.is_in_write_group():
-            raise AssertionError("%r not in write group" % (self,))
         _mod_revision.check_not_reserved_id(revision_id)
-        if not (inv.revision_id is None or inv.revision_id == revision_id):
-            raise AssertionError(
-                "Mismatch between inventory revision"
-                " id and insertion revid (%r, %r)"
-                % (inv.revision_id, revision_id))
-        if inv.root is None:
-            raise AssertionError()
+        assert inv.revision_id is None or inv.revision_id == revision_id, \
+            "Mismatch between inventory revision" \
+            " id and insertion revid (%r, %r)" % (inv.revision_id, revision_id)
+        assert inv.root is not None
         inv_lines = self._serialise_inventory_to_lines(inv)
-        return self._inventory_add_lines(revision_id, parents,
+        inv_vf = self.get_inventory_weave()
+        return self._inventory_add_lines(inv_vf, revision_id, parents,
             inv_lines, check_content=False)
 
-    def _inventory_add_lines(self, revision_id, parents, lines,
+    def _inventory_add_lines(self, inv_vf, revision_id, parents, lines,
         check_content=True):
         """Store lines in inv_vf and return the sha1 of the inventory."""
-        parents = [(parent,) for parent in parents]
-        return self.inventories.add_lines((revision_id,), parents, lines,
+        final_parents = []
+        for parent in parents:
+            if parent in inv_vf:
+                final_parents.append(parent)
+        return inv_vf.add_lines(revision_id, final_parents, lines,
             check_content=check_content)[0]
 
+    @needs_write_lock
     def add_revision(self, revision_id, rev, inv=None, config=None):
         """Add rev to the revision store as revision_id.
 
@@ -602,33 +535,27 @@
             plaintext = Testament(rev, inv).as_short_text()
             self.store_revision_signature(
                 gpg.GPGStrategy(config), plaintext, revision_id)
-        # check inventory present
-        if not self.inventories.get_parent_map([(revision_id,)]):
+        if not revision_id in self.get_inventory_weave():
             if inv is None:
                 raise errors.WeaveRevisionNotPresent(revision_id,
-                                                     self.inventories)
+                                                     self.get_inventory_weave())
             else:
                 # yes, this is not suitable for adding with ghosts.
-                rev.inventory_sha1 = self.add_inventory(revision_id, inv,
-                                                        rev.parent_ids)
-        else:
-            key = (revision_id,)
-            rev.inventory_sha1 = self.inventories.get_sha1s([key])[key]
-        self._add_revision(rev)
+                self.add_inventory(revision_id, inv, rev.parent_ids)
+        self._revision_store.add_revision(rev, self.get_transaction())
 
-    def _add_revision(self, revision):
-        text = self._serializer.write_revision_to_string(revision)
-        key = (revision.revision_id,)
-        parents = tuple((parent,) for parent in revision.parent_ids)
-        self.revisions.add_lines(key, parents, osutils.split_lines(text))
+    def _add_revision_text(self, revision_id, text):
+        revision = self._revision_store._serializer.read_revision_from_string(
+            text)
+        self._revision_store._add_revision(revision, StringIO(text),
+                                           self.get_transaction())
 
     def all_revision_ids(self):
         """Returns a list of all the revision ids in the repository. 
 
-        This is conceptually deprecated because code should generally work on
-        the graph reachable from a particular revision, and ignore any other
-        revisions that might be present.  There is no direct replacement
-        method.
+        This is deprecated because code should generally work on the graph
+        reachable from a particular revision, and ignore any other revisions
+        that might be present.  There is no direct replacement method.
         """
         if 'evil' in debug.debug_flags:
             mutter_callsite(2, "all_revision_ids is linear with history.")
@@ -657,17 +584,17 @@
         Returns a set of the present revisions.
         """
         result = []
-        graph = self.get_graph()
-        parent_map = graph.get_parent_map(revision_ids)
-        # The old API returned a list, should this actually be a set?
-        return parent_map.keys()
+        for id in revision_ids:
+            if self.has_revision(id):
+               result.append(id)
+        return result
 
     @staticmethod
     def create(a_bzrdir):
         """Construct the current default format repository in a_bzrdir."""
         return RepositoryFormat.get_default_format().initialize(a_bzrdir)
 
-    def __init__(self, _format, a_bzrdir, control_files):
+    def __init__(self, _format, a_bzrdir, control_files, _revision_store, control_store, text_store):
         """instantiate a Repository.
 
         :param _format: The format of the repository on disk.
@@ -682,32 +609,21 @@
         # the following are part of the public API for Repository:
         self.bzrdir = a_bzrdir
         self.control_files = control_files
-        self._transport = control_files._transport
-        self.base = self._transport.base
+        self._revision_store = _revision_store
+        # backwards compatibility
+        self.weave_store = text_store
         # for tests
         self._reconcile_does_inventory_gc = True
         self._reconcile_fixes_text_parents = False
-        self._reconcile_backsup_inventory = True
         # not right yet - should be more semantically clear ? 
         # 
+        self.control_store = control_store
+        self.control_weaves = control_store
         # TODO: make sure to construct the right store classes, etc, depending
         # on whether escaping is required.
         self._warn_if_deprecated()
         self._write_group = None
-        # Additional places to query for data.
-        self._fallback_repositories = []
-        # What order should fetch operations request streams in?
-        # The default is unordered as that is the cheapest for an origin to
-        # provide.
-        self._fetch_order = 'unordered'
-        # Does this repository use deltas that can be fetched as-deltas ?
-        # (E.g. knits, where the knit deltas can be transplanted intact.
-        # We default to False, which will ensure that enough data to get
-        # a full text out of any fetch stream will be grabbed.
-        self._fetch_uses_deltas = False
-        # Should fetch trigger a reconcile after the fetch? Only needed for
-        # some repository formats that can suffer internal inconsistencies.
-        self._fetch_reconcile = False
+        self.base = control_files._transport.base
 
     def __repr__(self):
         return '%s(%r)' % (self.__class__.__name__,
@@ -722,7 +638,8 @@
         """
         if self.__class__ is not other.__class__:
             return False
-        return (self._transport.base == other._transport.base)
+        return (self.control_files._transport.base ==
+                other.control_files._transport.base)
 
     def is_in_write_group(self):
         """Return True if there is an open write group.
@@ -761,16 +678,11 @@
         XXX: this docstring is duplicated in many places, e.g. lockable_files.py
         """
         result = self.control_files.lock_write(token=token)
-        for repo in self._fallback_repositories:
-            # Writes don't affect fallback repos
-            repo.lock_read()
         self._refresh_data()
         return result
 
     def lock_read(self):
         self.control_files.lock_read()
-        for repo in self._fallback_repositories:
-            repo.lock_read()
         self._refresh_data()
 
     def get_physical_lock_status(self):
@@ -836,86 +748,51 @@
                 last_revision.timezone)
 
         # now gather global repository information
-        # XXX: This is available for many repos regardless of listability.
         if self.bzrdir.root_transport.listable():
-            # XXX: do we want to __define len__() ?
-            # Maybe the versionedfiles object should provide a different
-            # method to get the number of keys.
-            result['revisions'] = len(self.revisions.keys())
-            # result['size'] = t
+            c, t = self._revision_store.total_size(self.get_transaction())
+            result['revisions'] = c
+            result['size'] = t
         return result
 
-    def find_branches(self, using=False):
-        """Find branches underneath this repository.
-
-        This will include branches inside other branches.
-
-        :param using: If True, list only branches using this repository.
-        """
-        if using and not self.is_shared():
-            try:
-                return [self.bzrdir.open_branch()]
-            except errors.NotBranchError:
-                return []
-        class Evaluator(object):
-
-            def __init__(self):
-                self.first_call = True
-
-            def __call__(self, bzrdir):
-                # On the first call, the parameter is always the bzrdir
-                # containing the current repo.
-                if not self.first_call:
-                    try:
-                        repository = bzrdir.open_repository()
-                    except errors.NoRepositoryPresent:
-                        pass
-                    else:
-                        return False, (None, repository)
-                self.first_call = False
-                try:
-                    value = (bzrdir.open_branch(), None)
-                except errors.NotBranchError:
-                    value = (None, None)
-                return True, value
-
-        branches = []
-        for branch, repository in bzrdir.BzrDir.find_bzrdirs(
-                self.bzrdir.root_transport, evaluate=Evaluator()):
-            if branch is not None:
-                branches.append(branch)
-            if not using and repository is not None:
-                branches.extend(repository.find_branches())
-        return branches
-
-    @needs_read_lock
-    def search_missing_revision_ids(self, other, revision_id=None, find_ghosts=True):
-        """Return the revision ids that other has that this does not.
-        
-        These are returned in topological order.
-
-        revision_id: only return revision ids included by revision_id.
-        """
-        return InterRepository.get(other, self).search_missing_revision_ids(
-            revision_id, find_ghosts)
-
-    @deprecated_method(one_two)
-    @needs_read_lock
-    def missing_revision_ids(self, other, revision_id=None, find_ghosts=True):
-        """Return the revision ids that other has that this does not.
-        
-        These are returned in topological order.
-
-        revision_id: only return revision ids included by revision_id.
-        """
-        keys =  self.search_missing_revision_ids(
-            other, revision_id, find_ghosts).get_keys()
-        other.lock_read()
-        try:
-            parents = other.get_graph().get_parent_map(keys)
-        finally:
-            other.unlock()
-        return tsort.topo_sort(parents)
+    def get_data_stream(self, revision_ids):
+        raise NotImplementedError(self.get_data_stream)
+
+    def insert_data_stream(self, stream):
+        for item_key, bytes in stream:
+            if item_key[0] == 'file':
+                (file_id,) = item_key[1:]
+                knit = self.weave_store.get_weave_or_empty(
+                    file_id, self.get_transaction())
+            elif item_key == ('inventory',):
+                knit = self.get_inventory_weave()
+            elif item_key == ('revisions',):
+                knit = self._revision_store.get_revision_file(
+                    self.get_transaction())
+            elif item_key == ('signatures',):
+                knit = self._revision_store.get_signature_file(
+                    self.get_transaction())
+            else:
+                raise RepositoryDataStreamError(
+                    "Unrecognised data stream key '%s'" % (item_key,))
+            decoded_list = bencode.bdecode(bytes)
+            format = decoded_list.pop(0)
+            data_list = []
+            knit_bytes = ''
+            for version, options, parents, some_bytes in decoded_list:
+                data_list.append((version, options, len(some_bytes), parents))
+                knit_bytes += some_bytes
+            knit.insert_data_stream(
+                (format, data_list, StringIO(knit_bytes).read))
+
+    @needs_read_lock
+    def missing_revision_ids(self, other, revision_id=None):
+        """Return the revision ids that other has that this does not.
+        
+        These are returned in topological order.
+
+        revision_id: only return revision ids included by revision_id.
+        """
+        return InterRepository.get(other, self).missing_revision_ids(revision_id)
 
     @staticmethod
     def open(base):
@@ -957,13 +834,10 @@
         extent possible considering file system caching etc).
         """
 
-    def fetch(self, source, revision_id=None, pb=None, find_ghosts=False):
+    def fetch(self, source, revision_id=None, pb=None):
         """Fetch the content required to construct revision_id from source.
 
         If revision_id is None all content is copied.
-        :param find_ghosts: Find and copy revisions in the source that are
-            ghosts in the target (and not reachable directly by walking out to
-            the first-present revision in target from revision_id).
         """
         # fast path same-url fetch operations
         if self.has_same_location(source):
@@ -973,12 +847,11 @@
                 not _mod_revision.is_null(revision_id)):
                 self.get_revision(revision_id)
             return 0, []
-        # if there is no specific appropriate InterRepository, this will get
-        # the InterRepository base class, which raises an
-        # IncompatibleRepositories when asked to fetch.
         inter = InterRepository.get(source, self)
-        return inter.fetch(revision_id=revision_id, pb=pb,
-            find_ghosts=find_ghosts)
+        try:
+            return inter.fetch(revision_id=revision_id, pb=pb)
+        except NotImplementedError:
+            raise errors.IncompatibleRepositories(source, self)
 
     def create_bundle(self, target, base, fileobj, format=None):
         return serializer.write_bundle(self, target, base, fileobj, format)
@@ -1006,13 +879,9 @@
         if (self.control_files._lock_count == 1 and
             self.control_files._lock_mode == 'w'):
             if self._write_group is not None:
-                self.abort_write_group()
-                self.control_files.unlock()
                 raise errors.BzrError(
                     'Must end write groups before releasing write locks.')
         self.control_files.unlock()
-        for repo in self._fallback_repositories:
-            repo.unlock()
 
     @needs_read_lock
     def clone(self, a_bzrdir, revision_id=None):
@@ -1084,22 +953,10 @@
     @needs_read_lock
     def has_revision(self, revision_id):
         """True if this repository has a copy of the revision."""
-        return revision_id in self.has_revisions((revision_id,))
-
-    @needs_read_lock
-    def has_revisions(self, revision_ids):
-        """Probe to find out the presence of multiple revisions.
-
-        :param revision_ids: An iterable of revision_ids.
-        :return: A set of the revision_ids that were present.
-        """
-        parent_map = self.revisions.get_parent_map(
-            [(rev_id,) for rev_id in revision_ids])
-        result = set()
-        if _mod_revision.NULL_REVISION in revision_ids:
-            result.add(_mod_revision.NULL_REVISION)
-        result.update([key[0] for key in parent_map])
-        return result
+        if 'evil' in debug.debug_flags:
+            mutter_callsite(3, "has_revision is a LBYL symptom.")
+        return self._revision_store.has_revision_id(revision_id,
+                                                    self.get_transaction())
 
     @needs_read_lock
     def get_revision(self, revision_id):
@@ -1128,16 +985,13 @@
         for rev_id in revision_ids:
             if not rev_id or not isinstance(rev_id, basestring):
                 raise errors.InvalidRevisionId(revision_id=rev_id, branch=self)
-        keys = [(key,) for key in revision_ids]
-        stream = self.revisions.get_record_stream(keys, 'unordered', True)
-        revs = {}
-        for record in stream:
-            if record.storage_kind == 'absent':
-                raise errors.NoSuchRevision(self, record.key[0])
-            text = record.get_bytes_as('fulltext')
-            rev = self._serializer.read_revision_from_string(text)
-            revs[record.key[0]] = rev
-        return [revs[revid] for revid in revision_ids]
+        revs = self._revision_store.get_revisions(revision_ids,
+                                                  self.get_transaction())
+        for rev in revs:
+            assert not isinstance(rev.revision_id, unicode)
+            for parent_id in rev.parent_ids:
+                assert not isinstance(parent_id, unicode)
+        return revs
 
     @needs_read_lock
     def get_revision_xml(self, revision_id):
@@ -1147,10 +1001,11 @@
         rev = self.get_revision(revision_id)
         rev_tmp = StringIO()
         # the current serializer..
-        self._serializer.write_revision(rev, rev_tmp)
+        self._revision_store._serializer.write_revision(rev, rev_tmp)
         rev_tmp.seek(0)
         return rev_tmp.getvalue()
 
+    @needs_read_lock
     def get_deltas_for_revisions(self, revisions):
         """Produce a generator of revision deltas.
         
@@ -1184,51 +1039,23 @@
     @needs_write_lock
     def store_revision_signature(self, gpg_strategy, plaintext, revision_id):
         signature = gpg_strategy.sign(plaintext)
-        self.add_signature_text(revision_id, signature)
-
-    @needs_write_lock
-    def add_signature_text(self, revision_id, signature):
-        self.signatures.add_lines((revision_id,), (),
-            osutils.split_lines(signature))
-
-    def find_text_key_references(self):
-        """Find the text key references within the repository.
-
-        :return: a dictionary mapping (file_id, revision_id) tuples to altered file-ids to an iterable of
+        self._revision_store.add_revision_signature_text(revision_id,
+                                                         signature,
+                                                         self.get_transaction())
+
+    def fileids_altered_by_revision_ids(self, revision_ids):
+        """Find the file ids and versions affected by revisions.
+
+        :param revisions: an iterable containing revision ids.
+        :return: a dictionary mapping altered file-ids to an iterable of
         revision_ids. Each altered file-ids has the exact revision_ids that
         altered it listed explicitly.
-        :return: A dictionary mapping text keys ((fileid, revision_id) tuples)
-            to whether they were referred to by the inventory of the
-            revision_id that they contain. The inventory texts from all present
-            revision ids are assessed to generate this report.
-        """
-        revision_keys = self.revisions.keys()
-        w = self.inventories
-        pb = ui.ui_factory.nested_progress_bar()
-        try:
-            return self._find_text_key_references_from_xml_inventory_lines(
-                w.iter_lines_added_or_present_in_keys(revision_keys, pb=pb))
-        finally:
-            pb.finished()
-
-    def _find_text_key_references_from_xml_inventory_lines(self,
-        line_iterator):
-        """Core routine for extracting references to texts from inventories.
-
-        This performs the translation of xml lines to revision ids.
-
-        :param line_iterator: An iterator of lines, origin_version_id
-        :return: A dictionary mapping text keys ((fileid, revision_id) tuples)
-            to whether they were referred to by the inventory of the
-            revision_id that they contain. Note that if that revision_id was
-            not part of the line_iterator's output then False will be given -
-            even though it may actually refer to that key.
-        """
-        if not self._serializer.support_altered_by_hack:
-            raise AssertionError(
-                "_find_text_key_references_from_xml_inventory_lines only "
-                "supported for branches which store inventory as unnested xml"
-                ", not on %r" % self)
+        """
+        assert self._serializer.support_altered_by_hack, \
+            ("fileids_altered_by_revision_ids only supported for branches " 
+             "which store inventory as unnested xml, not on %r" % self)
+        selected_revision_ids = set(revision_ids)
+        w = self.get_inventory_weave()
         result = {}
 
         # this code needs to read every new line in every inventory for the
@@ -1250,93 +1077,44 @@
         search = self._file_ids_altered_regex.search
         unescape = _unescape_xml
         setdefault = result.setdefault
-        for line, line_key in line_iterator:
-            match = search(line)
-            if match is None:
-                continue
-            # One call to match.group() returning multiple items is quite a
-            # bit faster than 2 calls to match.group() each returning 1
-            file_id, revision_id = match.group('file_id', 'revision_id')
-
-            # Inlining the cache lookups helps a lot when you make 170,000
-            # lines and 350k ids, versus 8.4 unique ids.
-            # Using a cache helps in 2 ways:
-            #   1) Avoids unnecessary decoding calls
-            #   2) Re-uses cached strings, which helps in future set and
-            #      equality checks.
-            # (2) is enough that removing encoding entirely along with
-            # the cache (so we are using plain strings) results in no
-            # performance improvement.
-            try:
-                revision_id = unescape_revid_cache[revision_id]
-            except KeyError:
-                unescaped = unescape(revision_id)
-                unescape_revid_cache[revision_id] = unescaped
-                revision_id = unescaped
-
-            # Note that unconditionally unescaping means that we deserialise
-            # every fileid, which for general 'pull' is not great, but we don't
-            # really want to have some many fulltexts that this matters anyway.
-            # RBC 20071114.
-            try:
-                file_id = unescape_fileid_cache[file_id]
-            except KeyError:
-                unescaped = unescape(file_id)
-                unescape_fileid_cache[file_id] = unescaped
-                file_id = unescaped
-
-            key = (file_id, revision_id)
-            setdefault(key, False)
-            if revision_id == line_key[-1]:
-                result[key] = True
-        return result
-
-    def _find_file_ids_from_xml_inventory_lines(self, line_iterator,
-        revision_ids):
-        """Helper routine for fileids_altered_by_revision_ids.
-
-        This performs the translation of xml lines to revision ids.
-
-        :param line_iterator: An iterator of lines, origin_version_id
-        :param revision_ids: The revision ids to filter for. This should be a
-            set or other type which supports efficient __contains__ lookups, as
-            the revision id from each parsed line will be looked up in the
-            revision_ids filter.
-        :return: a dictionary mapping altered file-ids to an iterable of
-        revision_ids. Each altered file-ids has the exact revision_ids that
-        altered it listed explicitly.
-        """
-        result = {}
-        setdefault = result.setdefault
-        for key in \
-            self._find_text_key_references_from_xml_inventory_lines(
-                line_iterator).iterkeys():
-            # once data is all ensured-consistent; then this is
-            # if revision_id == version_id
-            if key[-1:] in revision_ids:
-                setdefault(key[0], set()).add(key[-1])
-        return result
-
-    def fileids_altered_by_revision_ids(self, revision_ids, _inv_weave=None):
-        """Find the file ids and versions affected by revisions.
-
-        :param revisions: an iterable containing revision ids.
-        :param _inv_weave: The inventory weave from this repository or None.
-            If None, the inventory weave will be opened automatically.
-        :return: a dictionary mapping altered file-ids to an iterable of
-        revision_ids. Each altered file-ids has the exact revision_ids that
-        altered it listed explicitly.
-        """
-        selected_keys = set((revid,) for revid in revision_ids)
-        w = _inv_weave or self.inventories
         pb = ui.ui_factory.nested_progress_bar()
         try:
-            return self._find_file_ids_from_xml_inventory_lines(
-                w.iter_lines_added_or_present_in_keys(
-                    selected_keys, pb=pb),
-                selected_keys)
+            for line in w.iter_lines_added_or_present_in_versions(
+                                        selected_revision_ids, pb=pb):
+                match = search(line)
+                if match is None:
+                    continue
+                # One call to match.group() returning multiple items is quite a
+                # bit faster than 2 calls to match.group() each returning 1
+                file_id, revision_id = match.group('file_id', 'revision_id')
+
+                # Inlining the cache lookups helps a lot when you make 170,000
+                # lines and 350k ids, versus 8.4 unique ids.
+                # Using a cache helps in 2 ways:
+                #   1) Avoids unnecessary decoding calls
+                #   2) Re-uses cached strings, which helps in future set and
+                #      equality checks.
+                # (2) is enough that removing encoding entirely along with
+                # the cache (so we are using plain strings) results in no
+                # performance improvement.
+                try:
+                    revision_id = unescape_revid_cache[revision_id]
+                except KeyError:
+                    unescaped = unescape(revision_id)
+                    unescape_revid_cache[revision_id] = unescaped
+                    revision_id = unescaped
+
+                if revision_id in selected_revision_ids:
+                    try:
+                        file_id = unescape_fileid_cache[file_id]
+                    except KeyError:
+                        unescaped = unescape(file_id)
+                        unescape_fileid_cache[file_id] = unescaped
+                        file_id = unescaped
+                    setdefault(file_id, set()).add(revision_id)
         finally:
             pb.finished()
+        return result
 
     def iter_files_bytes(self, desired_files):
         """Iterate through file versions.
@@ -1351,125 +1129,19 @@
 
         bytes_iterator is an iterable of bytestrings for the file.  The
         kind of iterable and length of the bytestrings are unspecified, but for
-        this implementation, it is a list of bytes produced by
-        VersionedFile.get_record_stream().
+        this implementation, it is a list of lines produced by
+        VersionedFile.get_lines().
 
         :param desired_files: a list of (file_id, revision_id, identifier)
             triples
         """
         transaction = self.get_transaction()
-        text_keys = {}
         for file_id, revision_id, callable_data in desired_files:
-            text_keys[(file_id, revision_id)] = callable_data
-        for record in self.texts.get_record_stream(text_keys, 'unordered', True):
-            if record.storage_kind == 'absent':
-                raise errors.RevisionNotPresent(record.key, self)
-            yield text_keys[record.key], record.get_bytes_as('fulltext')
-
-    def _generate_text_key_index(self, text_key_references=None,
-        ancestors=None):
-        """Generate a new text key index for the repository.
-
-        This is an expensive function that will take considerable time to run.
-
-        :return: A dict mapping text keys ((file_id, revision_id) tuples) to a
-            list of parents, also text keys. When a given key has no parents,
-            the parents list will be [NULL_REVISION].
-        """
-        # All revisions, to find inventory parents.
-        if ancestors is None:
-            graph = self.get_graph()
-            ancestors = graph.get_parent_map(self.all_revision_ids())
-        if text_key_references is None:
-            text_key_references = self.find_text_key_references()
-        pb = ui.ui_factory.nested_progress_bar()
-        try:
-            return self._do_generate_text_key_index(ancestors,
-                text_key_references, pb)
-        finally:
-            pb.finished()
-
-    def _do_generate_text_key_index(self, ancestors, text_key_references, pb):
-        """Helper for _generate_text_key_index to avoid deep nesting."""
-        revision_order = tsort.topo_sort(ancestors)
-        invalid_keys = set()
-        revision_keys = {}
-        for revision_id in revision_order:
-            revision_keys[revision_id] = set()
-        text_count = len(text_key_references)
-        # a cache of the text keys to allow reuse; costs a dict of all the
-        # keys, but saves a 2-tuple for every child of a given key.
-        text_key_cache = {}
-        for text_key, valid in text_key_references.iteritems():
-            if not valid:
-                invalid_keys.add(text_key)
-            else:
-                revision_keys[text_key[1]].add(text_key)
-            text_key_cache[text_key] = text_key
-        del text_key_references
-        text_index = {}
-        text_graph = graph.Graph(graph.DictParentsProvider(text_index))
-        NULL_REVISION = _mod_revision.NULL_REVISION
-        # Set a cache with a size of 10 - this suffices for bzr.dev but may be
-        # too small for large or very branchy trees. However, for 55K path
-        # trees, it would be easy to use too much memory trivially. Ideally we
-        # could gauge this by looking at available real memory etc, but this is
-        # always a tricky proposition.
-        inventory_cache = lru_cache.LRUCache(10)
-        batch_size = 10 # should be ~150MB on a 55K path tree
-        batch_count = len(revision_order) / batch_size + 1
-        processed_texts = 0
-        pb.update("Calculating text parents.", processed_texts, text_count)
-        for offset in xrange(batch_count):
-            to_query = revision_order[offset * batch_size:(offset + 1) *
-                batch_size]
-            if not to_query:
-                break
-            for rev_tree in self.revision_trees(to_query):
-                revision_id = rev_tree.get_revision_id()
-                parent_ids = ancestors[revision_id]
-                for text_key in revision_keys[revision_id]:
-                    pb.update("Calculating text parents.", processed_texts)
-                    processed_texts += 1
-                    candidate_parents = []
-                    for parent_id in parent_ids:
-                        parent_text_key = (text_key[0], parent_id)
-                        try:
-                            check_parent = parent_text_key not in \
-                                revision_keys[parent_id]
-                        except KeyError:
-                            # the parent parent_id is a ghost:
-                            check_parent = False
-                            # truncate the derived graph against this ghost.
-                            parent_text_key = None
-                        if check_parent:
-                            # look at the parent commit details inventories to
-                            # determine possible candidates in the per file graph.
-                            # TODO: cache here.
-                            try:
-                                inv = inventory_cache[parent_id]
-                            except KeyError:
-                                inv = self.revision_tree(parent_id).inventory
-                                inventory_cache[parent_id] = inv
-                            parent_entry = inv._byid.get(text_key[0], None)
-                            if parent_entry is not None:
-                                parent_text_key = (
-                                    text_key[0], parent_entry.revision)
-                            else:
-                                parent_text_key = None
-                        if parent_text_key is not None:
-                            candidate_parents.append(
-                                text_key_cache[parent_text_key])
-                    parent_heads = text_graph.heads(candidate_parents)
-                    new_parents = list(parent_heads)
-                    new_parents.sort(key=lambda x:candidate_parents.index(x))
-                    if new_parents == []:
-                        new_parents = [NULL_REVISION]
-                    text_index[text_key] = new_parents
-
-        for text_key in invalid_keys:
-            text_index[text_key] = [NULL_REVISION]
-        return text_index
+            try:
+                weave = self.weave_store.get_weave(file_id, transaction)
+            except errors.NoSuchFile:
+                raise errors.NoSuchIdInRepository(self, file_id)
+            yield callable_data, weave.get_lines(revision_id)
 
     def item_keys_introduced_by(self, revision_ids, _files_pb=None):
         """Get an iterable listing the keys of all the data introduced by a set
@@ -1487,10 +1159,12 @@
         # maybe this generator should explicitly have the contract that it
         # should not be iterated until the previously yielded item has been
         # processed?
-        inv_w = self.inventories
+        self.lock_read()
+        inv_w = self.get_inventory_weave()
+        inv_w.enable_cache()
 
         # file ids that changed
-        file_ids = self.fileids_altered_by_revision_ids(revision_ids, inv_w)
+        file_ids = self.fileids_altered_by_revision_ids(revision_ids)
         count = 0
         num_file_ids = len(file_ids)
         for file_id, altered_versions in file_ids.iteritems():
@@ -1504,6 +1178,7 @@
 
         # inventory
         yield ("inventory", None, revision_ids)
+        inv_w.clear_cache()
 
         # signatures
         revisions_with_signatures = set()
@@ -1515,46 +1190,22 @@
                 pass
             else:
                 revisions_with_signatures.add(rev_id)
+        self.unlock()
         yield ("signatures", None, revisions_with_signatures)
 
         # revisions
         yield ("revisions", None, revision_ids)
 
     @needs_read_lock
+    def get_inventory_weave(self):
+        return self.control_weaves.get_weave('inventory',
+            self.get_transaction())
+
+    @needs_read_lock
     def get_inventory(self, revision_id):
-        """Get Inventory object by revision id."""
-        return self.iter_inventories([revision_id]).next()
-
-    def iter_inventories(self, revision_ids):
-        """Get many inventories by revision_ids.
-
-        This will buffer some or all of the texts used in constructing the
-        inventories in memory, but will only parse a single inventory at a
-        time.
-
-        :return: An iterator of inventories.
-        """
-        if ((None in revision_ids)
-            or (_mod_revision.NULL_REVISION in revision_ids)):
-            raise ValueError('cannot get null revision inventory')
-        return self._iter_inventories(revision_ids)
-
-    def _iter_inventories(self, revision_ids):
-        """single-document based inventory iteration."""
-        for text, revision_id in self._iter_inventory_xmls(revision_ids):
-            yield self.deserialise_inventory(revision_id, text)
-
-    def _iter_inventory_xmls(self, revision_ids):
-        keys = [(revision_id,) for revision_id in revision_ids]
-        stream = self.inventories.get_record_stream(keys, 'unordered', True)
-        texts = {}
-        for record in stream:
-            if record.storage_kind != 'absent':
-                texts[record.key] = record.get_bytes_as('fulltext')
-            else:
-                raise errors.NoSuchRevision(self, record.key)
-        for key in keys:
-            yield texts[key], key[-1]
+        """Get Inventory object by hash."""
+        return self.deserialise_inventory(
+            revision_id, self.get_inventory_xml(revision_id))
 
     def deserialise_inventory(self, revision_id, xml):
         """Transform the xml into an inventory object. 
@@ -1562,11 +1213,7 @@
         :param revision_id: The expected revision id of the inventory.
         :param xml: A serialised inventory.
         """
-        result = self._serializer.read_inventory_from_string(xml, revision_id)
-        if result.revision_id != revision_id:
-            raise AssertionError('revision id mismatch %s != %s' % (
-                result.revision_id, revision_id))
-        return result
+        return self._serializer.read_inventory_from_string(xml, revision_id)
 
     def serialise_inventory(self, inv):
         return self._serializer.write_inventory_to_string(inv)
@@ -1580,12 +1227,12 @@
     @needs_read_lock
     def get_inventory_xml(self, revision_id):
         """Get inventory XML as a file object."""
-        texts = self._iter_inventory_xmls([revision_id])
         try:
-            text, revision_id = texts.next()
-        except StopIteration:
+            assert isinstance(revision_id, str), type(revision_id)
+            iw = self.get_inventory_weave()
+            return iw.get_text(revision_id)
+        except IndexError:
             raise errors.HistoryMissing(self, 'inventory', revision_id)
-        return text
 
     @needs_read_lock
     def get_inventory_sha1(self, revision_id):
@@ -1593,24 +1240,81 @@
         """
         return self.get_revision(revision_id).inventory_sha1
 
+    @needs_read_lock
+    def get_revision_graph(self, revision_id=None):
+        """Return a dictionary containing the revision graph.
+
+        NB: This method should not be used as it accesses the entire graph all
+        at once, which is much more data than most operations should require.
+
+        :param revision_id: The revision_id to get a graph from. If None, then
+        the entire revision graph is returned. This is a deprecated mode of
+        operation and will be removed in the future.
+        :return: a dictionary of revision_id->revision_parents_list.
+        """
+        raise NotImplementedError(self.get_revision_graph)
+
+    @needs_read_lock
+    def get_revision_graph_with_ghosts(self, revision_ids=None):
+        """Return a graph of the revisions with ghosts marked as applicable.
+
+        :param revision_ids: an iterable of revisions to graph or None for all.
+        :return: a Graph object with the graph reachable from revision_ids.
+        """
+        if 'evil' in debug.debug_flags:
+            mutter_callsite(3,
+                "get_revision_graph_with_ghosts scales with size of history.")
+        result = deprecated_graph.Graph()
+        if not revision_ids:
+            pending = set(self.all_revision_ids())
+            required = set([])
+        else:
+            pending = set(revision_ids)
+            # special case NULL_REVISION
+            if _mod_revision.NULL_REVISION in pending:
+                pending.remove(_mod_revision.NULL_REVISION)
+            required = set(pending)
+        done = set([])
+        while len(pending):
+            revision_id = pending.pop()
+            try:
+                rev = self.get_revision(revision_id)
+            except errors.NoSuchRevision:
+                if revision_id in required:
+                    raise
+                # a ghost
+                result.add_ghost(revision_id)
+                continue
+            for parent_id in rev.parent_ids:
+                # is this queued or done ?
+                if (parent_id not in pending and
+                    parent_id not in done):
+                    # no, queue it.
+                    pending.add(parent_id)
+            result.add_node(revision_id, rev.parent_ids)
+            done.add(revision_id)
+        return result
+
+    def _get_history_vf(self):
+        """Get a versionedfile whose history graph reflects all revisions.
+
+        For weave repositories, this is the inventory weave.
+        """
+        return self.get_inventory_weave()
+
     def iter_reverse_revision_history(self, revision_id):
         """Iterate backwards through revision ids in the lefthand history
 
         :param revision_id: The revision id to start with.  All its lefthand
             ancestors will be traversed.
         """
-        graph = self.get_graph()
+        if revision_id in (None, _mod_revision.NULL_REVISION):
+            return
         next_id = revision_id
+        versionedfile = self._get_history_vf()
         while True:
-            if next_id in (None, _mod_revision.NULL_REVISION):
-                return
             yield next_id
-            # Note: The following line may raise KeyError in the event of
-            # truncated history. We decided not to have a try:except:raise
-            # RevisionNotPresent here until we see a use for it, because of the
-            # cost in an inner loop that is by its very nature O(history).
-            # Robert Collins 20080326
-            parents = graph.get_parent_map([next_id])[next_id]
+            parents = versionedfile.get_parents(next_id)
             if len(parents) == 0:
                 return
             else:
@@ -1632,6 +1336,7 @@
         else:
             return self.get_inventory(revision_id)
 
+    @needs_read_lock
     def is_shared(self):
         """Return True if this repository is flagged as a shared repository."""
         raise NotImplementedError(self.is_shared)
@@ -1669,13 +1374,17 @@
             inv = self.get_revision_inventory(revision_id)
             return RevisionTree(self, inv, revision_id)
 
+    @needs_read_lock
     def revision_trees(self, revision_ids):
         """Return Tree for a revision on this branch.
 
         `revision_id` may not be None or 'null:'"""
-        inventories = self.iter_inventories(revision_ids)
-        for inv in inventories:
-            yield RevisionTree(self, inv, inv.revision_id)
+        assert None not in revision_ids
+        assert _mod_revision.NULL_REVISION not in revision_ids
+        texts = self.get_inventory_weave().get_texts(revision_ids)
+        for text, revision_id in zip(texts, revision_ids):
+            inv = self.deserialise_inventory(revision_id, text)
+            yield RevisionTree(self, inv, revision_id)
 
     @needs_read_lock
     def get_ancestry(self, revision_id, topo_sorted=True):
@@ -1691,21 +1400,9 @@
             return [None]
         if not self.has_revision(revision_id):
             raise errors.NoSuchRevision(self, revision_id)
-        graph = self.get_graph()
-        keys = set()
-        search = graph._make_breadth_first_searcher([revision_id])
-        while True:
-            try:
-                found, ghosts = search.next_with_ghosts()
-            except StopIteration:
-                break
-            keys.update(found)
-        if _mod_revision.NULL_REVISION in keys:
-            keys.remove(_mod_revision.NULL_REVISION)
-        if topo_sorted:
-            parent_map = graph.get_parent_map(keys)
-            keys = tsort.topo_sort(parent_map)
-        return [None] + list(keys)
+        w = self.get_inventory_weave()
+        candidates = w.get_ancestry(revision_id, topo_sorted)
+        return [None] + candidates # self._eliminate_revisions_not_present(candidates)
 
     def pack(self):
         """Compress the data within the repository.
@@ -1719,7 +1416,6 @@
         """
 
     @needs_read_lock
-    @deprecated_method(one_six)
     def print_file(self, file, revision_id):
         """Print `file` to stdout.
         
@@ -1740,33 +1436,25 @@
     def get_transaction(self):
         return self.control_files.get_transaction()
 
-    @deprecated_method(one_one)
+    def revision_parents(self, revision_id):
+        return self.get_inventory_weave().parent_names(revision_id)
+
     def get_parents(self, revision_ids):
         """See StackedParentsProvider.get_parents"""
-        parent_map = self.get_parent_map(revision_ids)
-        return [parent_map.get(r, None) for r in revision_ids]
-
-    def get_parent_map(self, revision_ids):
-        """See graph._StackedParentsProvider.get_parent_map"""
-        # revisions index works in keys; this just works in revisions
-        # therefore wrap and unwrap
-        query_keys = []
-        result = {}
+        parents_list = []
         for revision_id in revision_ids:
             if revision_id == _mod_revision.NULL_REVISION:
-                result[revision_id] = ()
-            elif revision_id is None:
-                raise ValueError('get_parent_map(None) is not valid')
-            else:
-                query_keys.append((revision_id ,))
-        for ((revision_id,), parent_keys) in \
-                self.revisions.get_parent_map(query_keys).iteritems():
-            if parent_keys:
-                result[revision_id] = tuple(parent_revid
-                    for (parent_revid,) in parent_keys)
-            else:
-                result[revision_id] = (_mod_revision.NULL_REVISION,)
-        return result
+                parents = []
+            else:
+                try:
+                    parents = self.get_revision(revision_id).parent_ids
+                except errors.NoSuchRevision:
+                    parents = None
+                else:
+                    if len(parents) == 0:
+                        parents = [_mod_revision.NULL_REVISION]
+            parents_list.append(parents)
+        return parents_list
 
     def _make_parents_provider(self):
         return self
@@ -1775,27 +1463,14 @@
         """Return the graph walker for this repository format"""
         parents_provider = self._make_parents_provider()
         if (other_repository is not None and
-            not self.has_same_location(other_repository)):
+            other_repository.bzrdir.transport.base !=
+            self.bzrdir.transport.base):
             parents_provider = graph._StackedParentsProvider(
                 [parents_provider, other_repository._make_parents_provider()])
         return graph.Graph(parents_provider)
 
-    def _get_versioned_file_checker(self):
-        """Return an object suitable for checking versioned files."""
-        return _VersionedFileChecker(self)
-
-    def revision_ids_to_search_result(self, result_set):
-        """Convert a set of revision ids to a graph SearchResult."""
-        result_parents = set()
-        for parents in self.get_graph().get_parent_map(
-            result_set).itervalues():
-            result_parents.update(parents)
-        included_keys = result_set.intersection(result_parents)
-        start_keys = result_set.difference(included_keys)
-        exclude_keys = result_parents.difference(result_set)
-        result = graph.SearchResult(start_keys, exclude_keys,
-            len(result_set), result_set)
-        return result
+    def get_versioned_file_checker(self, revisions, revision_versions_cache):
+        return VersionedFileChecker(revisions, revision_versions_cache, self)
 
     @needs_write_lock
     def set_make_working_trees(self, new_value):
@@ -1821,21 +1496,14 @@
     @needs_read_lock
     def has_signature_for_revision_id(self, revision_id):
         """Query for a revision signature for revision_id in the repository."""
-        if not self.has_revision(revision_id):
-            raise errors.NoSuchRevision(self, revision_id)
-        sig_present = (1 == len(
-            self.signatures.get_parent_map([(revision_id,)])))
-        return sig_present
+        return self._revision_store.has_signature(revision_id,
+                                                  self.get_transaction())
 
     @needs_read_lock
     def get_signature_text(self, revision_id):
         """Return the text for a signature."""
-        stream = self.signatures.get_record_stream([(revision_id,)],
-            'unordered', True)
-        record = stream.next()
-        if record.storage_kind == 'absent':
-            raise errors.NoSuchRevision(self, revision_id)
-        return record.get_bytes_as('fulltext')
+        return self._revision_store.get_signature_text(revision_id,
+                                                       self.get_transaction())
 
     @needs_read_lock
     def check(self, revision_ids=None):
@@ -1890,8 +1558,7 @@
         depend on the revision index being consistent.
         """
         raise NotImplementedError(self.revision_graph_can_have_wrong_parents)
-
-
+        
 # remove these delegates a while after bzr 0.15
 def __make_delegated(name, from_module):
     def _deprecated_repository_forwarder():
@@ -1928,30 +1595,6 @@
 
 def install_revision(repository, rev, revision_tree):
     """Install all revision data into a repository."""
-    install_revisions(repository, [(rev, revision_tree, None)])
-
-
-def install_revisions(repository, iterable, num_revisions=None, pb=None):
-    """Install all revision data into a repository.
-
-    Accepts an iterable of revision, tree, signature tuples.  The signature
-    may be None.
-    """
-    repository.start_write_group()
-    try:
-        for n, (revision, revision_tree, signature) in enumerate(iterable):
-            _install_revision(repository, revision, revision_tree, signature)
-            if pb is not None:
-                pb.update('Transferring revisions', n + 1, num_revisions)
-    except:
-        repository.abort_write_group()
-        raise
-    else:
-        repository.commit_write_group()
-
-
-def _install_revision(repository, rev, revision_tree, signature):
-    """Install all revision data into a repository."""
     present_parents = []
     parent_trees = {}
     for p_id in rev.parent_ids:
@@ -1968,52 +1611,53 @@
         path, root = entries.next()
         if root.revision != rev.revision_id:
             raise errors.IncompatibleRevision(repr(repository))
-    text_keys = {}
+    # Add the texts that are not already present
     for path, ie in entries:
-        text_keys[(ie.file_id, ie.revision)] = ie
-    text_parent_map = repository.texts.get_parent_map(text_keys)
-    missing_texts = set(text_keys) - set(text_parent_map)
-    # Add the texts that are not already present
-    for text_key in missing_texts:
-        ie = text_keys[text_key]
-        text_parents = []
-        # FIXME: TODO: The following loop overlaps/duplicates that done by
-        # commit to determine parents. There is a latent/real bug here where
-        # the parents inserted are not those commit would do - in particular
-        # they are not filtered by heads(). RBC, AB
-        for revision, tree in parent_trees.iteritems():
-            if ie.file_id not in tree:
-                continue
-            parent_id = tree.inventory[ie.file_id].revision
-            if parent_id in text_parents:
-                continue
-            text_parents.append((ie.file_id, parent_id))
-        lines = revision_tree.get_file(ie.file_id).readlines()
-        repository.texts.add_lines(text_key, text_parents, lines)
+        w = repository.weave_store.get_weave_or_empty(ie.file_id,
+                repository.get_transaction())
+        if ie.revision not in w:
+            text_parents = []
+            # FIXME: TODO: The following loop *may* be overlapping/duplicate
+            # with InventoryEntry.find_previous_heads(). if it is, then there
+            # is a latent bug here where the parents may have ancestors of each
+            # other. RBC, AB
+            for revision, tree in parent_trees.iteritems():
+                if ie.file_id not in tree:
+                    continue
+                parent_id = tree.inventory[ie.file_id].revision
+                if parent_id in text_parents:
+                    continue
+                text_parents.append(parent_id)
+                    
+            vfile = repository.weave_store.get_weave_or_empty(ie.file_id, 
+                repository.get_transaction())
+            lines = revision_tree.get_file(ie.file_id).readlines()
+            vfile.add_lines(rev.revision_id, text_parents, lines)
     try:
         # install the inventory
         repository.add_inventory(rev.revision_id, inv, present_parents)
     except errors.RevisionAlreadyPresent:
         pass
-    if signature is not None:
-        repository.add_signature_text(rev.revision_id, signature)
     repository.add_revision(rev.revision_id, rev, inv)
 
 
 class MetaDirRepository(Repository):
-    """Repositories in the new meta-dir layout.
-    
-    :ivar _transport: Transport for access to repository control files,
-        typically pointing to .bzr/repository.
-    """
-
-    def __init__(self, _format, a_bzrdir, control_files):
-        super(MetaDirRepository, self).__init__(_format, a_bzrdir, control_files)
-        self._transport = control_files._transport
-
+    """Repositories in the new meta-dir layout."""
+
+    def __init__(self, _format, a_bzrdir, control_files, _revision_store, control_store, text_store):
+        super(MetaDirRepository, self).__init__(_format,
+                                                a_bzrdir,
+                                                control_files,
+                                                _revision_store,
+                                                control_store,
+                                                text_store)
+        dir_mode = self.control_files._dir_mode
+        file_mode = self.control_files._file_mode
+
+    @needs_read_lock
     def is_shared(self):
         """Return True if this repository is flagged as a shared repository."""
-        return self._transport.has('shared-storage')
+        return self.control_files._transport.has('shared-storage')
 
     @needs_write_lock
     def set_make_working_trees(self, new_value):
@@ -2027,24 +1671,15 @@
         """
         if new_value:
             try:
-                self._transport.delete('no-working-trees')
+                self.control_files._transport.delete('no-working-trees')
             except errors.NoSuchFile:
                 pass
         else:
-            self._transport.put_bytes('no-working-trees', '',
-                mode=self.bzrdir._get_file_mode())
+            self.control_files.put_utf8('no-working-trees', '')
     
     def make_working_trees(self):
         """Returns the policy for making working trees on new branches."""
-        return not self._transport.has('no-working-trees')
-
-
-class MetaDirVersionedFileRepository(MetaDirRepository):
-    """Repositories in a meta-dir, that work via versioned file objects."""
-
-    def __init__(self, _format, a_bzrdir, control_files):
-        super(MetaDirVersionedFileRepository, self).__init__(_format, a_bzrdir,
-            control_files)
+        return not self.control_files._transport.has('no-working-trees')
 
 
 class RepositoryFormatRegistry(registry.Registry):
@@ -2094,16 +1729,9 @@
     _matchingbzrdir - the bzrdir format that the repository format was
     originally written to work with. This can be used if manually
     constructing a bzrdir and repository, or more commonly for test suite
-    parameterization.
+    parameterisation.
     """
 
-    # Set to True or False in derived classes. True indicates that the format
-    # supports ghosts gracefully.
-    supports_ghosts = None
-    # Can this repository be given external locations to lookup additional
-    # data. Set to True or False in derived classes.
-    supports_external_lookups = None
-
     def __str__(self):
         return "<%s>" % self.__class__.__name__
 
@@ -2129,8 +1757,7 @@
         except errors.NoSuchFile:
             raise errors.NoRepositoryPresent(a_bzrdir)
         except KeyError:
-            raise errors.UnknownFormatError(format=format_string,
-                                            kind='repository')
+            raise errors.UnknownFormatError(format=format_string)
 
     @classmethod
     def register_format(klass, format):
@@ -2146,6 +1773,10 @@
         from bzrlib import bzrdir
         return bzrdir.format_registry.make_bzrdir('default').repository_format
 
+    def _get_control_store(self, repo_transport, control_files):
+        """Return the control store for this repository."""
+        raise NotImplementedError(self._get_control_store)
+
     def get_format_string(self):
         """Return the ASCII format string that identifies this format.
         
@@ -2158,6 +1789,33 @@
         """Return the short description for this format."""
         raise NotImplementedError(self.get_format_description)
 
+    def _get_revision_store(self, repo_transport, control_files):
+        """Return the revision store object for this a_bzrdir."""
+        raise NotImplementedError(self._get_revision_store)
+
+    def _get_text_rev_store(self,
+                            transport,
+                            control_files,
+                            name,
+                            compressed=True,
+                            prefixed=False,
+                            serializer=None):
+        """Common logic for getting a revision store for a repository.
+        
+        see self._get_revision_store for the subclass-overridable method to 
+        get the store for a repository.
+        """
+        from bzrlib.store.revision.text import TextRevisionStore
+        dir_mode = control_files._dir_mode
+        file_mode = control_files._file_mode
+        text_store = TextStore(transport.clone(name),
+                              prefixed=prefixed,
+                              compressed=compressed,
+                              dir_mode=dir_mode,
+                              file_mode=file_mode)
+        _revision_store = TextRevisionStore(text_store, serializer)
+        return _revision_store
+
     # TODO: this shouldn't be in the base class, it's specific to things that
     # use weaves or knits -- mbp 20070207
     def _get_versioned_file_store(self,
@@ -2217,7 +1875,6 @@
 
     rich_root_data = False
     supports_tree_reference = False
-    supports_external_lookups = False
     _matchingbzrdir = bzrdir.BzrDirMetaFormat1()
 
     def __init__(self):
@@ -2237,17 +1894,15 @@
         """Upload the initial blank content."""
         control_files = self._create_control_files(a_bzrdir)
         control_files.lock_write()
-        transport = control_files._transport
-        if shared == True:
-            utf8_files += [('shared-storage', '')]
         try:
-            transport.mkdir_multi(dirs, mode=a_bzrdir._get_dir_mode())
-            for (filename, content_stream) in files:
-                transport.put_file(filename, content_stream,
-                    mode=a_bzrdir._get_file_mode())
-            for (filename, content_bytes) in utf8_files:
-                transport.put_bytes_non_atomic(filename, content_bytes,
-                    mode=a_bzrdir._get_file_mode())
+            control_files._transport.mkdir_multi(dirs,
+                    mode=control_files._dir_mode)
+            for file, content in files:
+                control_files.put(file, content)
+            for file, content in utf8_files:
+                control_files.put_utf8(file, content)
+            if shared == True:
+                control_files.put_utf8('shared-storage', '')
         finally:
             control_files.unlock()
 
@@ -2264,11 +1919,14 @@
     'RepositoryFormat7'
     )
 
+# KEEP in sync with bzrdir.format_registry default, which controls the overall
+# default control directory format
 format_registry.register_lazy(
     'Bazaar-NG Knit Repository Format 1',
     'bzrlib.repofmt.knitrepo',
     'RepositoryFormatKnit1',
     )
+format_registry.default_key = 'Bazaar-NG Knit Repository Format 1'
 
 format_registry.register_lazy(
     'Bazaar Knit Repository Format 3 (bzr 0.15)\n',
@@ -2276,61 +1934,6 @@
     'RepositoryFormatKnit3',
     )
 
-format_registry.register_lazy(
-    'Bazaar Knit Repository Format 4 (bzr 1.0)\n',
-    'bzrlib.repofmt.knitrepo',
-    'RepositoryFormatKnit4',
-    )
-
-# Pack-based formats. There is one format for pre-subtrees, and one for
-# post-subtrees to allow ease of testing.
-# NOTE: These are experimental in 0.92. Stable in 1.0 and above
-format_registry.register_lazy(
-    'Bazaar pack repository format 1 (needs bzr 0.92)\n',
-    'bzrlib.repofmt.pack_repo',
-    'RepositoryFormatKnitPack1',
-    )
-format_registry.register_lazy(
-    'Bazaar pack repository format 1 with subtree support (needs bzr 0.92)\n',
-    'bzrlib.repofmt.pack_repo',
-    'RepositoryFormatKnitPack3',
-    )
-format_registry.register_lazy(
-    'Bazaar pack repository format 1 with rich root (needs bzr 1.0)\n',
-    'bzrlib.repofmt.pack_repo',
-    'RepositoryFormatKnitPack4',
-    )
-format_registry.register_lazy(
-    'Bazaar RepositoryFormatKnitPack5 (bzr 1.6)\n',
-    'bzrlib.repofmt.pack_repo',
-    'RepositoryFormatKnitPack5',
-    )
-format_registry.register_lazy(
-    'Bazaar RepositoryFormatKnitPack5RichRoot (bzr 1.6.1)\n',
-    'bzrlib.repofmt.pack_repo',
-    'RepositoryFormatKnitPack5RichRoot',
-    )
-format_registry.register_lazy(
-    'Bazaar RepositoryFormatKnitPack5RichRoot (bzr 1.6)\n',
-    'bzrlib.repofmt.pack_repo',
-    'RepositoryFormatKnitPack5RichRootBroken',
-    )
-
-# Development formats. 
-# 1.5->1.6
-format_registry.register_lazy(
-    "Bazaar development format 1 (needs bzr.dev from before 1.6)\n",
-    'bzrlib.repofmt.pack_repo',
-    'RepositoryFormatPackDevelopment1',
-    )
-format_registry.register_lazy(
-    ("Bazaar development format 1 with subtree support "
-        "(needs bzr.dev from before 1.6)\n"),
-    'bzrlib.repofmt.pack_repo',
-    'RepositoryFormatPackDevelopment1Subtree',
-    )
-# 1.6->1.7 go below here
-
 
 class InterRepository(InterObject):
     """This class represents operations taking place between two repositories.
@@ -2350,7 +1953,7 @@
     def copy_content(self, revision_id=None):
         raise NotImplementedError(self.copy_content)
 
-    def fetch(self, revision_id=None, pb=None, find_ghosts=False):
+    def fetch(self, revision_id=None, pb=None):
         """Fetch the content required to construct revision_id.
 
         The content is copied from self.source to self.target.
@@ -2360,116 +1963,42 @@
         :param pb: optional progress bar to use for progress reports. If not
                    provided a default one will be created.
 
-        :returns: (copied_revision_count, failures).
-        """
-        # Normally we should find a specific InterRepository subclass to do
-        # the fetch; if nothing else then at least InterSameDataRepository.
-        # If none of them is suitable it looks like fetching is not possible;
-        # we try to give a good message why.  _assert_same_model will probably
-        # give a helpful message; otherwise a generic one.
-        self._assert_same_model(self.source, self.target)
-        raise errors.IncompatibleRepositories(self.source, self.target,
-            "no suitableInterRepository found")
-
-    def _walk_to_common_revisions(self, revision_ids):
-        """Walk out from revision_ids in source to revisions target has.
-
-        :param revision_ids: The start point for the search.
-        :return: A set of revision ids.
-        """
-        target_graph = self.target.get_graph()
-        revision_ids = frozenset(revision_ids)
-        if set(target_graph.get_parent_map(revision_ids)) == revision_ids:
-            return graph.SearchResult(revision_ids, set(), 0, set())
-        missing_revs = set()
-        source_graph = self.source.get_graph()
-        # ensure we don't pay silly lookup costs.
-        searcher = source_graph._make_breadth_first_searcher(revision_ids)
-        null_set = frozenset([_mod_revision.NULL_REVISION])
-        while True:
-            try:
-                next_revs, ghosts = searcher.next_with_ghosts()
-            except StopIteration:
-                break
-            if revision_ids.intersection(ghosts):
-                absent_ids = set(revision_ids.intersection(ghosts))
-                # If all absent_ids are present in target, no error is needed.
-                absent_ids.difference_update(
-                    set(target_graph.get_parent_map(absent_ids)))
-                if absent_ids:
-                    raise errors.NoSuchRevision(self.source, absent_ids.pop())
-            # we don't care about other ghosts as we can't fetch them and
-            # haven't been asked to.
-            next_revs = set(next_revs)
-            # we always have NULL_REVISION present.
-            have_revs = set(target_graph.get_parent_map(next_revs)).union(null_set)
-            missing_revs.update(next_revs - have_revs)
-            searcher.stop_searching_any(have_revs)
-        return searcher.get_result()
+        Returns the copied revision count and the failed revisions in a tuple:
+        (copied, failures).
+        """
+        raise NotImplementedError(self.fetch)
    
-    @deprecated_method(one_two)
     @needs_read_lock
-    def missing_revision_ids(self, revision_id=None, find_ghosts=True):
+    def missing_revision_ids(self, revision_id=None):
         """Return the revision ids that source has that target does not.
         
         These are returned in topological order.
 
         :param revision_id: only return revision ids included by this
                             revision_id.
-        :param find_ghosts: If True find missing revisions in deep history
-            rather than just finding the surface difference.
-        """
-        return list(self.search_missing_revision_ids(
-            revision_id, find_ghosts).get_keys())
-
-    @needs_read_lock
-    def search_missing_revision_ids(self, revision_id=None, find_ghosts=True):
-        """Return the revision ids that source has that target does not.
-        
-        :param revision_id: only return revision ids included by this
-                            revision_id.
-        :param find_ghosts: If True find missing revisions in deep history
-            rather than just finding the surface difference.
-        :return: A bzrlib.graph.SearchResult.
-        """
-        # stop searching at found target revisions.
-        if not find_ghosts and revision_id is not None:
-            return self._walk_to_common_revisions([revision_id])
+        """
         # generic, possibly worst case, slow code path.
         target_ids = set(self.target.all_revision_ids())
         if revision_id is not None:
             source_ids = self.source.get_ancestry(revision_id)
-            if source_ids[0] is not None:
-                raise AssertionError()
+            assert source_ids[0] is None
             source_ids.pop(0)
         else:
             source_ids = self.source.all_revision_ids()
         result_set = set(source_ids).difference(target_ids)
-        return self.source.revision_ids_to_search_result(result_set)
+        # this may look like a no-op: its not. It preserves the ordering
+        # other_ids had while only returning the members from other_ids
+        # that we've decided we need.
+        return [rev_id for rev_id in source_ids if rev_id in result_set]
 
     @staticmethod
     def _same_model(source, target):
-        """True if source and target have the same data representation.
-        
-        Note: this is always called on the base class; overriding it in a
-        subclass will have no effect.
-        """
-        try:
-            InterRepository._assert_same_model(source, target)
-            return True
-        except errors.IncompatibleRepositories, e:
+        """True if source and target have the same data representation."""
+        if source.supports_rich_root() != target.supports_rich_root():
             return False
-
-    @staticmethod
-    def _assert_same_model(source, target):
-        """Raise an exception if two repositories do not use the same model.
-        """
-        if source.supports_rich_root() != target.supports_rich_root():
-            raise errors.IncompatibleRepositories(source, target,
-                "different rich-root support")
         if source._serializer != target._serializer:
-            raise errors.IncompatibleRepositories(source, target,
-                "different serializers")
+            return False
+        return True
 
 
 class InterSameDataRepository(InterRepository):
@@ -2516,16 +2045,16 @@
         self.target.fetch(self.source, revision_id=revision_id)
 
     @needs_write_lock
-    def fetch(self, revision_id=None, pb=None, find_ghosts=False):
+    def fetch(self, revision_id=None, pb=None):
         """See InterRepository.fetch()."""
-        from bzrlib.fetch import RepoFetcher
+        from bzrlib.fetch import GenericRepoFetcher
         mutter("Using fetch logic to copy between %s(%s) and %s(%s)",
                self.source, self.source._format, self.target,
                self.target._format)
-        f = RepoFetcher(to_repository=self.target,
+        f = GenericRepoFetcher(to_repository=self.target,
                                from_repository=self.source,
                                last_revision=revision_id,
-                               pb=pb, find_ghosts=find_ghosts)
+                               pb=pb)
         return f.count_copied, f.failed_revisions
 
 
@@ -2570,46 +2099,44 @@
         # weave specific optimised path:
         try:
             self.target.set_make_working_trees(self.source.make_working_trees())
-        except (errors.RepositoryUpgradeRequired, NotImplemented):
+        except NotImplementedError:
             pass
         # FIXME do not peek!
-        if self.source._transport.listable():
+        if self.source.control_files._transport.listable():
             pb = ui.ui_factory.nested_progress_bar()
             try:
-                self.target.texts.insert_record_stream(
-                    self.source.texts.get_record_stream(
-                        self.source.texts.keys(), 'topological', False))
+                self.target.weave_store.copy_all_ids(
+                    self.source.weave_store,
+                    pb=pb,
+                    from_transaction=self.source.get_transaction(),
+                    to_transaction=self.target.get_transaction())
                 pb.update('copying inventory', 0, 1)
-                self.target.inventories.insert_record_stream(
-                    self.source.inventories.get_record_stream(
-                        self.source.inventories.keys(), 'topological', False))
-                self.target.signatures.insert_record_stream(
-                    self.source.signatures.get_record_stream(
-                        self.source.signatures.keys(),
-                        'unordered', True))
-                self.target.revisions.insert_record_stream(
-                    self.source.revisions.get_record_stream(
-                        self.source.revisions.keys(),
-                        'topological', True))
+                self.target.control_weaves.copy_multi(
+                    self.source.control_weaves, ['inventory'],
+                    from_transaction=self.source.get_transaction(),
+                    to_transaction=self.target.get_transaction())
+                self.target._revision_store.text_store.copy_all_ids(
+                    self.source._revision_store.text_store,
+                    pb=pb)
             finally:
                 pb.finished()
         else:
             self.target.fetch(self.source, revision_id=revision_id)
 
     @needs_write_lock
-    def fetch(self, revision_id=None, pb=None, find_ghosts=False):
+    def fetch(self, revision_id=None, pb=None):
         """See InterRepository.fetch()."""
-        from bzrlib.fetch import RepoFetcher
+        from bzrlib.fetch import GenericRepoFetcher
         mutter("Using fetch logic to copy between %s(%s) and %s(%s)",
                self.source, self.source._format, self.target, self.target._format)
-        f = RepoFetcher(to_repository=self.target,
+        f = GenericRepoFetcher(to_repository=self.target,
                                from_repository=self.source,
                                last_revision=revision_id,
-                               pb=pb, find_ghosts=find_ghosts)
+                               pb=pb)
         return f.count_copied, f.failed_revisions
 
     @needs_read_lock
-    def search_missing_revision_ids(self, revision_id=None, find_ghosts=True):
+    def missing_revision_ids(self, revision_id=None):
         """See InterRepository.missing_revision_ids()."""
         # we want all revisions to satisfy revision_id in source.
         # but we don't want to stat every file here and there.
@@ -2624,8 +2151,7 @@
         # - RBC 20060209
         if revision_id is not None:
             source_ids = self.source.get_ancestry(revision_id)
-            if source_ids[0] is not None:
-                raise AssertionError()
+            assert source_ids[0] is None
             source_ids.pop(0)
         else:
             source_ids = self.source._all_possible_ids()
@@ -2636,21 +2162,19 @@
         # we do not have a revision as that would be pointless.
         target_ids = set(self.target._all_possible_ids())
         possibly_present_revisions = target_ids.intersection(source_ids_set)
-        actually_present_revisions = set(
-            self.target._eliminate_revisions_not_present(possibly_present_revisions))
+        actually_present_revisions = set(self.target._eliminate_revisions_not_present(possibly_present_revisions))
         required_revisions = source_ids_set.difference(actually_present_revisions)
+        required_topo_revisions = [rev_id for rev_id in source_ids if rev_id in required_revisions]
         if revision_id is not None:
             # we used get_ancestry to determine source_ids then we are assured all
             # revisions referenced are present as they are installed in topological order.
             # and the tip revision was validated by get_ancestry.
-            result_set = required_revisions
+            return required_topo_revisions
         else:
             # if we just grabbed the possibly available ids, then 
             # we only have an estimate of whats available and need to validate
             # that against the revision records.
-            result_set = set(
-                self.source._eliminate_revisions_not_present(required_revisions))
-        return self.source.revision_ids_to_search_result(result_set)
+            return self.source._eliminate_revisions_not_present(required_topo_revisions)
 
 
 class InterKnitRepo(InterSameDataRepository):
@@ -2678,24 +2202,23 @@
         return are_knits and InterRepository._same_model(source, target)
 
     @needs_write_lock
-    def fetch(self, revision_id=None, pb=None, find_ghosts=False):
+    def fetch(self, revision_id=None, pb=None):
         """See InterRepository.fetch()."""
-        from bzrlib.fetch import RepoFetcher
+        from bzrlib.fetch import KnitRepoFetcher
         mutter("Using fetch logic to copy between %s(%s) and %s(%s)",
                self.source, self.source._format, self.target, self.target._format)
-        f = RepoFetcher(to_repository=self.target,
+        f = KnitRepoFetcher(to_repository=self.target,
                             from_repository=self.source,
                             last_revision=revision_id,
-                            pb=pb, find_ghosts=find_ghosts)
+                            pb=pb)
         return f.count_copied, f.failed_revisions
 
     @needs_read_lock
-    def search_missing_revision_ids(self, revision_id=None, find_ghosts=True):
+    def missing_revision_ids(self, revision_id=None):
         """See InterRepository.missing_revision_ids()."""
         if revision_id is not None:
             source_ids = self.source.get_ancestry(revision_id)
-            if source_ids[0] is not None:
-                raise AssertionError()
+            assert source_ids[0] is None
             source_ids.pop(0)
         else:
             source_ids = self.source.all_revision_ids()
@@ -2706,147 +2229,19 @@
         # we do not have a revision as that would be pointless.
         target_ids = set(self.target.all_revision_ids())
         possibly_present_revisions = target_ids.intersection(source_ids_set)
-        actually_present_revisions = set(
-            self.target._eliminate_revisions_not_present(possibly_present_revisions))
+        actually_present_revisions = set(self.target._eliminate_revisions_not_present(possibly_present_revisions))
         required_revisions = source_ids_set.difference(actually_present_revisions)
+        required_topo_revisions = [rev_id for rev_id in source_ids if rev_id in required_revisions]
         if revision_id is not None:
             # we used get_ancestry to determine source_ids then we are assured all
             # revisions referenced are present as they are installed in topological order.
             # and the tip revision was validated by get_ancestry.
-            result_set = required_revisions
+            return required_topo_revisions
         else:
             # if we just grabbed the possibly available ids, then 
             # we only have an estimate of whats available and need to validate
             # that against the revision records.
-            result_set = set(
-                self.source._eliminate_revisions_not_present(required_revisions))
-        return self.source.revision_ids_to_search_result(result_set)
-
-
-class InterPackRepo(InterSameDataRepository):
-    """Optimised code paths between Pack based repositories."""
-
-    @classmethod
-    def _get_repo_format_to_test(self):
-        from bzrlib.repofmt import pack_repo
-        return pack_repo.RepositoryFormatKnitPack1()
-
-    @staticmethod
-    def is_compatible(source, target):
-        """Be compatible with known Pack formats.
-        
-        We don't test for the stores being of specific types because that
-        could lead to confusing results, and there is no need to be 
-        overly general.
-        """
-        from bzrlib.repofmt.pack_repo import RepositoryFormatPack
-        try:
-            are_packs = (isinstance(source._format, RepositoryFormatPack) and
-                isinstance(target._format, RepositoryFormatPack))
-        except AttributeError:
-            return False
-        return are_packs and InterRepository._same_model(source, target)
-
-    @needs_write_lock
-    def fetch(self, revision_id=None, pb=None, find_ghosts=False):
-        """See InterRepository.fetch()."""
-        if (len(self.source._fallback_repositories) > 0 or
-            len(self.target._fallback_repositories) > 0):
-            # The pack layer is not aware of fallback repositories, so when
-            # fetching from a stacked repository or into a stacked repository
-            # we use the generic fetch logic which uses the VersionedFiles
-            # attributes on repository.
-            from bzrlib.fetch import RepoFetcher
-            fetcher = RepoFetcher(self.target, self.source, revision_id,
-                                  pb, find_ghosts)
-            return fetcher.count_copied, fetcher.failed_revisions
-        from bzrlib.repofmt.pack_repo import Packer
-        mutter("Using fetch logic to copy between %s(%s) and %s(%s)",
-               self.source, self.source._format, self.target, self.target._format)
-        self.count_copied = 0
-        if revision_id is None:
-            # TODO:
-            # everything to do - use pack logic
-            # to fetch from all packs to one without
-            # inventory parsing etc, IFF nothing to be copied is in the target.
-            # till then:
-            source_revision_ids = frozenset(self.source.all_revision_ids())
-            revision_ids = source_revision_ids - \
-                frozenset(self.target.get_parent_map(source_revision_ids))
-            revision_keys = [(revid,) for revid in revision_ids]
-            index = self.target._pack_collection.revision_index.combined_index
-            present_revision_ids = set(item[1][0] for item in
-                index.iter_entries(revision_keys))
-            revision_ids = set(revision_ids) - present_revision_ids
-            # implementing the TODO will involve:
-            # - detecting when all of a pack is selected
-            # - avoiding as much as possible pre-selection, so the
-            # more-core routines such as create_pack_from_packs can filter in
-            # a just-in-time fashion. (though having a HEADS list on a
-            # repository might make this a lot easier, because we could
-            # sensibly detect 'new revisions' without doing a full index scan.
-        elif _mod_revision.is_null(revision_id):
-            # nothing to do:
-            return (0, [])
-        else:
-            try:
-                revision_ids = self.search_missing_revision_ids(revision_id,
-                    find_ghosts=find_ghosts).get_keys()
-            except errors.NoSuchRevision:
-                raise errors.InstallFailed([revision_id])
-            if len(revision_ids) == 0:
-                return (0, [])
-        packs = self.source._pack_collection.all_packs()
-        pack = Packer(self.target._pack_collection, packs, '.fetch',
-            revision_ids).pack()
-        if pack is not None:
-            self.target._pack_collection._save_pack_names()
-            # Trigger an autopack. This may duplicate effort as we've just done
-            # a pack creation, but for now it is simpler to think about as
-            # 'upload data, then repack if needed'.
-            self.target._pack_collection.autopack()
-            return (pack.get_revision_count(), [])
-        else:
-            return (0, [])
-
-    @needs_read_lock
-    def search_missing_revision_ids(self, revision_id=None, find_ghosts=True):
-        """See InterRepository.missing_revision_ids().
-        
-        :param find_ghosts: Find ghosts throughout the ancestry of
-            revision_id.
-        """
-        if not find_ghosts and revision_id is not None:
-            return self._walk_to_common_revisions([revision_id])
-        elif revision_id is not None:
-            # Find ghosts: search for revisions pointing from one repository to
-            # the other, and vice versa, anywhere in the history of revision_id.
-            graph = self.target.get_graph(other_repository=self.source)
-            searcher = graph._make_breadth_first_searcher([revision_id])
-            found_ids = set()
-            while True:
-                try:
-                    next_revs, ghosts = searcher.next_with_ghosts()
-                except StopIteration:
-                    break
-                if revision_id in ghosts:
-                    raise errors.NoSuchRevision(self.source, revision_id)
-                found_ids.update(next_revs)
-                found_ids.update(ghosts)
-            found_ids = frozenset(found_ids)
-            # Double query here: should be able to avoid this by changing the
-            # graph api further.
-            result_set = found_ids - frozenset(
-                self.target.get_parent_map(found_ids))
-        else:
-            source_ids = self.source.all_revision_ids()
-            # source_ids is the worst possible case we may need to pull.
-            # now we want to filter source_ids against what we actually
-            # have in target, but don't try to check for existence where we know
-            # we do not have a revision as that would be pointless.
-            target_ids = set(self.target.all_revision_ids())
-            result_set = set(source_ids).difference(target_ids)
-        return self.source.revision_ids_to_search_result(result_set)
+            return self.source._eliminate_revisions_not_present(required_topo_revisions)
 
 
 class InterModel1and2(InterRepository):
@@ -2863,13 +2258,13 @@
             return False
 
     @needs_write_lock
-    def fetch(self, revision_id=None, pb=None, find_ghosts=False):
+    def fetch(self, revision_id=None, pb=None):
         """See InterRepository.fetch()."""
         from bzrlib.fetch import Model1toKnit2Fetcher
         f = Model1toKnit2Fetcher(to_repository=self.target,
                                  from_repository=self.source,
                                  last_revision=revision_id,
-                                 pb=pb, find_ghosts=find_ghosts)
+                                 pb=pb)
         return f.count_copied, f.failed_revisions
 
     @needs_write_lock
@@ -2902,54 +2297,17 @@
     @staticmethod
     def is_compatible(source, target):
         """Be compatible with Knit1 source and Knit3 target"""
+        from bzrlib.repofmt.knitrepo import RepositoryFormatKnit3
         try:
-            from bzrlib.repofmt.knitrepo import (
-                RepositoryFormatKnit1,
-                RepositoryFormatKnit3,
-                )
-            from bzrlib.repofmt.pack_repo import (
-                RepositoryFormatKnitPack1,
-                RepositoryFormatKnitPack3,
-                RepositoryFormatKnitPack4,
-                RepositoryFormatKnitPack5,
-                RepositoryFormatKnitPack5RichRoot,
-                RepositoryFormatPackDevelopment1,
-                RepositoryFormatPackDevelopment1Subtree,
-                )
-            norichroot = (
-                RepositoryFormatKnit1,            # no rr, no subtree
-                RepositoryFormatKnitPack1,        # no rr, no subtree
-                RepositoryFormatPackDevelopment1, # no rr, no subtree
-                RepositoryFormatKnitPack5,        # no rr, no subtree
-                )
-            richroot = (
-                RepositoryFormatKnit3,            # rr, subtree
-                RepositoryFormatKnitPack3,        # rr, subtree
-                RepositoryFormatKnitPack4,        # rr, no subtree
-                RepositoryFormatKnitPack5RichRoot,# rr, no subtree
-                RepositoryFormatPackDevelopment1Subtree, # rr, subtree
-                )
-            for format in norichroot:
-                if format.rich_root_data:
-                    raise AssertionError('Format %s is a rich-root format'
-                        ' but is included in the non-rich-root list'
-                        % (format,))
-            for format in richroot:
-                if not format.rich_root_data:
-                    raise AssertionError('Format %s is not a rich-root format'
-                        ' but is included in the rich-root list'
-                        % (format,))
-            # TODO: One alternative is to just check format.rich_root_data,
-            #       instead of keeping membership lists. However, the formats
-            #       *also* have to use the same 'Knit' style of storage
-            #       (line-deltas, fulltexts, etc.)
-            return (isinstance(source._format, norichroot) and
-                    isinstance(target._format, richroot))
+            from bzrlib.repofmt.knitrepo import RepositoryFormatKnit1, \
+                    RepositoryFormatKnit3
+            return (isinstance(source._format, (RepositoryFormatKnit1)) and
+                    isinstance(target._format, (RepositoryFormatKnit3)))
         except AttributeError:
             return False
 
     @needs_write_lock
-    def fetch(self, revision_id=None, pb=None, find_ghosts=False):
+    def fetch(self, revision_id=None, pb=None):
         """See InterRepository.fetch()."""
         from bzrlib.fetch import Knit1to2Fetcher
         mutter("Using fetch logic to copy between %s(%s) and %s(%s)",
@@ -2958,57 +2316,46 @@
         f = Knit1to2Fetcher(to_repository=self.target,
                             from_repository=self.source,
                             last_revision=revision_id,
-                            pb=pb, find_ghosts=find_ghosts)
+                            pb=pb)
         return f.count_copied, f.failed_revisions
 
 
-class InterDifferingSerializer(InterKnitRepo):
+class InterRemoteToOther(InterRepository):
 
-    @classmethod
-    def _get_repo_format_to_test(self):
-        return None
+    def __init__(self, source, target):
+        InterRepository.__init__(self, source, target)
+        self._real_inter = None
 
     @staticmethod
     def is_compatible(source, target):
-        """Be compatible with Knit2 source and Knit3 target"""
-        if source.supports_rich_root() != target.supports_rich_root():
-            return False
-        # Ideally, we'd support fetching if the source had no tree references
-        # even if it supported them...
-        if (getattr(source, '_format.supports_tree_reference', False) and
-            not getattr(target, '_format.supports_tree_reference', False)):
-            return False
-        return True
+        if not isinstance(source, remote.RemoteRepository):
+            return False
+        source._ensure_real()
+        real_source = source._real_repository
+        # Is source's model compatible with target's model, and are they the
+        # same format?  Currently we can only optimise fetching from an
+        # identical model & format repo.
+        assert not isinstance(real_source, remote.RemoteRepository), (
+            "We don't support remote repos backed by remote repos yet.")
+        return real_source._format == target._format
 
     @needs_write_lock
-    def fetch(self, revision_id=None, pb=None, find_ghosts=False):
+    def fetch(self, revision_id=None, pb=None):
         """See InterRepository.fetch()."""
-        revision_ids = self.target.search_missing_revision_ids(self.source,
-            revision_id, find_ghosts=find_ghosts).get_keys()
-        revision_ids = tsort.topo_sort(
-            self.source.get_graph().get_parent_map(revision_ids))
-        def revisions_iterator():
-            for current_revision_id in revision_ids:
-                revision = self.source.get_revision(current_revision_id)
-                tree = self.source.revision_tree(current_revision_id)
-                try:
-                    signature = self.source.get_signature_text(
-                        current_revision_id)
-                except errors.NoSuchRevision:
-                    signature = None
-                yield revision, tree, signature
-        if pb is None:
-            my_pb = ui.ui_factory.nested_progress_bar()
-            pb = my_pb
-        else:
-            my_pb = None
-        try:
-            install_revisions(self.target, revisions_iterator(),
-                              len(revision_ids), pb)
-        finally:
-            if my_pb is not None:
-                my_pb.finished()
-        return len(revision_ids), 0
+        from bzrlib.fetch import RemoteToOtherFetcher
+        mutter("Using fetch logic to copy between %s(remote) and %s(%s)",
+               self.source, self.target, self.target._format)
+        # TODO: jam 20070210 This should be an assert, not a translate
+        revision_id = osutils.safe_revision_id(revision_id)
+        f = RemoteToOtherFetcher(to_repository=self.target,
+                                 from_repository=self.source,
+                                 last_revision=revision_id,
+                                 pb=pb)
+        return f.count_copied, f.failed_revisions
+
+    @classmethod
+    def _get_repo_format_to_test(self):
+        return None
 
 
 class InterOtherToRemote(InterRepository):
@@ -3033,64 +2380,22 @@
         self._ensure_real_inter()
         self._real_inter.copy_content(revision_id=revision_id)
 
-    def fetch(self, revision_id=None, pb=None, find_ghosts=False):
-        self._ensure_real_inter()
-        return self._real_inter.fetch(revision_id=revision_id, pb=pb,
-            find_ghosts=find_ghosts)
-
-    @classmethod
-    def _get_repo_format_to_test(self):
-        return None
-
-
-class InterRemoteToOther(InterRepository):
-
-    def __init__(self, source, target):
-        InterRepository.__init__(self, source, target)
-        self._real_inter = None
-
-    @staticmethod
-    def is_compatible(source, target):
-        if not isinstance(source, remote.RemoteRepository):
-            return False
-        # Is source's model compatible with target's model?
-        source._ensure_real()
-        real_source = source._real_repository
-        if isinstance(real_source, remote.RemoteRepository):
-            raise NotImplementedError(
-                "We don't support remote repos backed by remote repos yet.")
-        return InterRepository._same_model(real_source, target)
-
-    def _ensure_real_inter(self):
-        if self._real_inter is None:
-            self.source._ensure_real()
-            real_source = self.source._real_repository
-            self._real_inter = InterRepository.get(real_source, self.target)
-    
-    def fetch(self, revision_id=None, pb=None, find_ghosts=False):
-        self._ensure_real_inter()
-        return self._real_inter.fetch(revision_id=revision_id, pb=pb,
-            find_ghosts=find_ghosts)
-
-    def copy_content(self, revision_id=None):
-        self._ensure_real_inter()
-        self._real_inter.copy_content(revision_id=revision_id)
-
-    @classmethod
-    def _get_repo_format_to_test(self):
-        return None
-
-
-
-InterRepository.register_optimiser(InterDifferingSerializer)
+    def fetch(self, revision_id=None, pb=None):
+        self._ensure_real_inter()
+        self._real_inter.fetch(revision_id=revision_id, pb=pb)
+
+    @classmethod
+    def _get_repo_format_to_test(self):
+        return None
+
+
 InterRepository.register_optimiser(InterSameDataRepository)
 InterRepository.register_optimiser(InterWeaveRepo)
 InterRepository.register_optimiser(InterKnitRepo)
 InterRepository.register_optimiser(InterModel1and2)
 InterRepository.register_optimiser(InterKnit1and2)
-InterRepository.register_optimiser(InterPackRepo)
+InterRepository.register_optimiser(InterRemoteToOther)
 InterRepository.register_optimiser(InterOtherToRemote)
-InterRepository.register_optimiser(InterRemoteToOther)
 
 
 class CopyConverter(object):
@@ -3175,75 +2480,101 @@
     return _unescape_re.sub(_unescaper, data)
 
 
-class _VersionedFileChecker(object):
+class _RevisionTextVersionCache(object):
+    """A cache of the versionedfile versions for revision and file-id."""
 
     def __init__(self, repository):
         self.repository = repository
-        self.text_index = self.repository._generate_text_key_index()
-    
-    def calculate_file_version_parents(self, text_key):
-        """Calculate the correct parents for a file version according to
-        the inventories.
-        """
-        parent_keys = self.text_index[text_key]
-        if parent_keys == [_mod_revision.NULL_REVISION]:
-            return ()
-        return tuple(parent_keys)
-
-    def check_file_version_parents(self, texts, progress_bar=None):
-        """Check the parents stored in a versioned file are correct.
-
-        It also detects file versions that are not referenced by their
-        corresponding revision's inventory.
-
-        :returns: A tuple of (wrong_parents, dangling_file_versions).
-            wrong_parents is a dict mapping {revision_id: (stored_parents,
-            correct_parents)} for each revision_id where the stored parents
-            are not correct.  dangling_file_versions is a set of (file_id,
-            revision_id) tuples for versions that are present in this versioned
-            file, but not used by the corresponding inventory.
-        """
-        wrong_parents = {}
-        self.file_ids = set([file_id for file_id, _ in
-            self.text_index.iterkeys()])
-        # text keys is now grouped by file_id
-        n_weaves = len(self.file_ids)
-        files_in_revisions = {}
-        revisions_of_files = {}
-        n_versions = len(self.text_index)
-        progress_bar.update('loading text store', 0, n_versions)
-        parent_map = self.repository.texts.get_parent_map(self.text_index)
-        # On unlistable transports this could well be empty/error...
-        text_keys = self.repository.texts.keys()
-        unused_keys = frozenset(text_keys) - set(self.text_index)
-        for num, key in enumerate(self.text_index.iterkeys()):
-            if progress_bar is not None:
-                progress_bar.update('checking text graph', num, n_versions)
-            correct_parents = self.calculate_file_version_parents(key)
+        self.revision_versions = {}
+        self.revision_parents = {}
+        self.repo_graph = self.repository.get_graph()
+        # XXX: RBC: I haven't tracked down what uses this, but it would be
+        # better to use the headscache directly I think.
+        self.heads = graph.HeadsCache(self.repo_graph).heads
+
+    def add_revision_text_versions(self, tree):
+        """Cache text version data from the supplied revision tree"""
+        inv_revisions = {}
+        for path, entry in tree.iter_entries_by_dir():
+            inv_revisions[entry.file_id] = entry.revision
+        self.revision_versions[tree.get_revision_id()] = inv_revisions
+        return inv_revisions
+
+    def get_text_version(self, file_id, revision_id):
+        """Determine the text version for a given file-id and revision-id"""
+        try:
+            inv_revisions = self.revision_versions[revision_id]
+        except KeyError:
             try:
-                knit_parents = parent_map[key]
+                tree = self.repository.revision_tree(revision_id)
             except errors.RevisionNotPresent:
-                # Missing text!
-                knit_parents = None
+                self.revision_versions[revision_id] = inv_revisions = {}
+            else:
+                inv_revisions = self.add_revision_text_versions(tree)
+        return inv_revisions.get(file_id)
+
+    def prepopulate_revs(self, revision_ids):
+        # Filter out versions that we don't have an inventory for, so that the
+        # revision_trees() call won't fail.
+        inv_weave = self.repository.get_inventory_weave()
+        revs = [r for r in revision_ids if inv_weave.has_version(r)]
+        # XXX: this loop is very similar to
+        # bzrlib.fetch.Inter1and2Helper.iter_rev_trees.
+        while revs:
+            for tree in self.repository.revision_trees(revs[:100]):
+                if tree.inventory.revision_id is None:
+                    tree.inventory.revision_id = tree.get_revision_id()
+                self.add_revision_text_versions(tree)
+            revs = revs[100:]
+
+    def get_parents(self, revision_id):
+        try:
+            return self.revision_parents[revision_id]
+        except KeyError:
+            parents = self.repository.get_parents([revision_id])[0]
+            self.revision_parents[revision_id] = parents
+            return parents
+
+
+class VersionedFileChecker(object):
+
+    def __init__(self, planned_revisions, revision_versions, repository):
+        self.planned_revisions = planned_revisions
+        self.revision_versions = revision_versions
+        self.repository = repository
+    
+    def calculate_file_version_parents(self, revision_id, file_id):
+        text_revision = self.revision_versions.get_text_version(
+            file_id, revision_id)
+        if text_revision is None:
+            return None
+        parents_of_text_revision = self.revision_versions.get_parents(
+            text_revision)
+        parents_from_inventories = []
+        for parent in parents_of_text_revision:
+            if parent == _mod_revision.NULL_REVISION:
+                continue
+            introduced_in = self.revision_versions.get_text_version(file_id,
+                    parent)
+            if introduced_in is not None:
+                parents_from_inventories.append(introduced_in)
+        heads = set(self.revision_versions.heads(parents_from_inventories))
+        new_parents = []
+        for parent in parents_from_inventories:
+            if parent in heads and parent not in new_parents:
+                new_parents.append(parent)
+        return new_parents
+
+    def check_file_version_parents(self, weave, file_id):
+        result = {}
+        for num, revision_id in enumerate(self.planned_revisions):
+            correct_parents = self.calculate_file_version_parents(
+                revision_id, file_id)
+            if correct_parents is None:
+                continue
+            text_revision = self.revision_versions.get_text_version(
+                file_id, revision_id)
+            knit_parents = weave.get_parents(text_revision)
             if correct_parents != knit_parents:
-                wrong_parents[key] = (knit_parents, correct_parents)
-        return wrong_parents, unused_keys
-
-
-def _old_get_graph(repository, revision_id):
-    """DO NOT USE. That is all. I'm serious."""
-    graph = repository.get_graph()
-    revision_graph = dict(((key, value) for key, value in
-        graph.iter_ancestry([revision_id]) if value is not None))
-    return _strip_NULL_ghosts(revision_graph)
-
-
-def _strip_NULL_ghosts(revision_graph):
-    """Also don't use this. more compatibility code for unmigrated clients."""
-    # Filter ghosts, and null:
-    if _mod_revision.NULL_REVISION in revision_graph:
-        del revision_graph[_mod_revision.NULL_REVISION]
-    for key, parents in revision_graph.items():
-        revision_graph[key] = tuple(parent for parent in parents if parent
-            in revision_graph)
-    return revision_graph
+                result[revision_id] = (knit_parents, correct_parents)
+        return result

=== modified file 'bzrlib/revision.py'
--- bzrlib/revision.py	2008-05-12 02:40:40 +0000
+++ bzrlib/revision.py	2007-08-28 06:43:19 +0000
@@ -20,10 +20,18 @@
 
 from bzrlib import (
     errors,
-    symbol_versioning,
+    symbol_versioning
+    )
+from bzrlib.deprecated_graph import (
+    all_descendants,
+    Graph,
+    node_distances,
+    select_farthest,
     )
 from bzrlib.osutils import contains_whitespace
 from bzrlib.progress import DummyProgress
+from bzrlib.symbol_versioning import (deprecated_function,
+        )
 
 NULL_REVISION="null:"
 CURRENT_REVISION="current:"
@@ -117,6 +125,21 @@
         return self.properties.get('author', self.committer)
 
 
+def is_ancestor(revision_id, candidate_id, branch):
+    """Return true if candidate_id is an ancestor of revision_id.
+
+    A false negative will be returned if any intermediate descendent of
+    candidate_id is not present in any of the revision_sources.
+    
+    revisions_source is an object supporting a get_revision operation that
+    behaves like Branch's.
+    """
+    if is_null(candidate_id):
+        return True
+    return (candidate_id in branch.repository.get_ancestry(revision_id,
+            topo_sorted=False))
+
+
 def iter_ancestors(revision_id, revision_source, only_present=False):
     ancestors = (revision_id,)
     distance = 0
@@ -164,6 +187,256 @@
     return matches
 
 
+def revision_graph(revision, revision_source):
+    """Produce a graph of the ancestry of the specified revision.
+    
+    :return: root, ancestors map, descendants map
+    """
+    revision_source.lock_read()
+    try:
+        return _revision_graph(revision, revision_source)
+    finally:
+        revision_source.unlock()
+
+
+def _revision_graph(revision, revision_source):
+    """See revision_graph."""
+    from bzrlib.tsort import topo_sort
+    graph = revision_source.get_revision_graph(revision)
+    # mark all no-parent revisions as being NULL_REVISION parentage.
+    for node, parents in graph.items():
+        if len(parents) == 0:
+            graph[node] = [NULL_REVISION]
+    # add NULL_REVISION to the graph
+    graph[NULL_REVISION] = []
+
+    # pick a root. If there are multiple roots
+    # this could pick a random one.
+    topo_order = topo_sort(graph.items())
+    root = topo_order[0]
+
+    ancestors = {}
+    descendants = {}
+
+    # map the descendants of the graph.
+    # and setup our set based return graph.
+    for node in graph.keys():
+        descendants[node] = {}
+    for node, parents in graph.items():
+        for parent in parents:
+            descendants[parent][node] = 1
+        ancestors[node] = set(parents)
+
+    assert root not in descendants[root]
+    assert root not in ancestors[root]
+    return root, ancestors, descendants
+
+
+def combined_graph(revision_a, revision_b, revision_source):
+    """Produce a combined ancestry graph.
+    Return graph root, ancestors map, descendants map, set of common nodes"""
+    root, ancestors, descendants = revision_graph(
+        revision_a, revision_source)
+    root_b, ancestors_b, descendants_b = revision_graph(
+        revision_b, revision_source)
+    if root != root_b:
+        raise errors.NoCommonRoot(revision_a, revision_b)
+    common = set()
+    for node, node_anc in ancestors_b.iteritems():
+        if node in ancestors:
+            common.add(node)
+        else:
+            ancestors[node] = set()
+        ancestors[node].update(node_anc)
+    for node, node_dec in descendants_b.iteritems():
+        if node not in descendants:
+            descendants[node] = {}
+        descendants[node].update(node_dec)
+    return root, ancestors, descendants, common
+
+
+def common_ancestor(revision_a, revision_b, revision_source, 
+                    pb=DummyProgress()):
+    if None in (revision_a, revision_b):
+        return None
+    if NULL_REVISION in (revision_a, revision_b):
+        return NULL_REVISION
+    # trivial optimisation
+    if revision_a == revision_b:
+        return revision_a
+    try:
+        try:
+            pb.update('Picking ancestor', 1, 3)
+            graph = revision_source.get_revision_graph_with_ghosts(
+                [revision_a, revision_b])
+            # Shortcut the case where one of the tips is already included in
+            # the other graphs ancestry.
+            ancestry_a = graph.get_ancestry(revision_a, topo_sorted=False)
+            if revision_b in ancestry_a:
+                return revision_b
+            ancestry_b = graph.get_ancestry(revision_b, topo_sorted=False)
+            if revision_a in ancestry_b:
+                return revision_a
+            # convert to a NULL_REVISION based graph.
+            ancestors = graph.get_ancestors()
+            descendants = graph.get_descendants()
+            common = set(ancestry_a)
+            common.intersection_update(ancestry_b)
+            descendants[NULL_REVISION] = {}
+            ancestors[NULL_REVISION] = []
+            for root in graph.roots:
+                descendants[NULL_REVISION][root] = 1
+                ancestors[root].append(NULL_REVISION)
+            for ghost in graph.ghosts:
+                # ghosts act as roots for the purpose of finding 
+                # the longest paths from the root: any ghost *might*
+                # be directly attached to the root, so we treat them
+                # as being such.
+                # ghost now descends from NULL
+                descendants[NULL_REVISION][ghost] = 1
+                # that is it has an ancestor of NULL
+                ancestors[ghost] = [NULL_REVISION]
+                # ghost is common if any of ghosts descendants are common:
+                for ghost_descendant in descendants[ghost]:
+                    if ghost_descendant in common:
+                        common.add(ghost)
+                
+            root = NULL_REVISION
+            common.add(NULL_REVISION)
+        except errors.NoCommonRoot:
+            raise errors.NoCommonAncestor(revision_a, revision_b)
+            
+        pb.update('Picking ancestor', 2, 3)
+        distances = node_distances (descendants, ancestors, root)
+        pb.update('Picking ancestor', 3, 2)
+        farthest = select_farthest(distances, common)
+        if farthest is None or farthest == NULL_REVISION:
+            raise errors.NoCommonAncestor(revision_a, revision_b)
+    finally:
+        pb.clear()
+    return farthest
+
+
+class MultipleRevisionSources(object):
+    """Proxy that looks in multiple branches for revisions."""
+    def __init__(self, *args):
+        object.__init__(self)
+        assert len(args) != 0
+        self._revision_sources = args
+
+    def revision_parents(self, revision_id):
+        for source in self._revision_sources:
+            try:
+                return source.revision_parents(revision_id)
+            except (errors.WeaveRevisionNotPresent, errors.NoSuchRevision), e:
+                pass
+        raise e
+
+    def get_revision(self, revision_id):
+        for source in self._revision_sources:
+            try:
+                return source.get_revision(revision_id)
+            except errors.NoSuchRevision, e:
+                pass
+        raise e
+
+    def get_revision_graph(self, revision_id):
+        # we could probe incrementally until the pending
+        # ghosts list stop growing, but its cheaper for now
+        # to just ask for the complete graph for each repository.
+        graphs = []
+        for source in self._revision_sources:
+            ghost_graph = source.get_revision_graph_with_ghosts()
+            graphs.append(ghost_graph)
+        absent = 0
+        for graph in graphs:
+            if not revision_id in graph.get_ancestors():
+                absent += 1
+        if absent == len(graphs):
+            raise errors.NoSuchRevision(self._revision_sources[0], revision_id)
+
+        # combine the graphs
+        result = {}
+        pending = set([revision_id])
+        def find_parents(node_id):
+            """find the parents for node_id."""
+            for graph in graphs:
+                ancestors = graph.get_ancestors()
+                try:
+                    return ancestors[node_id]
+                except KeyError:
+                    pass
+            raise errors.NoSuchRevision(self._revision_sources[0], node_id)
+        while len(pending):
+            # all the graphs should have identical parent lists
+            node_id = pending.pop()
+            try:
+                result[node_id] = find_parents(node_id)
+                for parent_node in result[node_id]:
+                    if not parent_node in result:
+                        pending.add(parent_node)
+            except errors.NoSuchRevision:
+                # ghost, ignore it.
+                pass
+        return result
+
+    def get_revision_graph_with_ghosts(self, revision_ids):
+        # query all the sources for their entire graphs 
+        # and then build a combined graph for just
+        # revision_ids.
+        graphs = []
+        for source in self._revision_sources:
+            ghost_graph = source.get_revision_graph_with_ghosts()
+            graphs.append(ghost_graph.get_ancestors())
+        for revision_id in revision_ids:
+            absent = 0
+            for graph in graphs:
+                    if not revision_id in graph:
+                        absent += 1
+            if absent == len(graphs):
+                raise errors.NoSuchRevision(self._revision_sources[0],
+                                            revision_id)
+
+        # combine the graphs
+        result = Graph()
+        pending = set(revision_ids)
+        done = set()
+        def find_parents(node_id):
+            """find the parents for node_id."""
+            for graph in graphs:
+                try:
+                    return graph[node_id]
+                except KeyError:
+                    pass
+            raise errors.NoSuchRevision(self._revision_sources[0], node_id)
+        while len(pending):
+            # all the graphs should have identical parent lists
+            node_id = pending.pop()
+            try:
+                parents = find_parents(node_id)
+                for parent_node in parents:
+                    # queued or done? 
+                    if (parent_node not in pending and
+                        parent_node not in done):
+                        # no, queue
+                        pending.add(parent_node)
+                result.add_node(node_id, parents)
+                done.add(node_id)
+            except errors.NoSuchRevision:
+                # ghost
+                result.add_ghost(node_id)
+                continue
+        return result
+
+    def lock_read(self):
+        for source in self._revision_sources:
+            source.lock_read()
+
+    def unlock(self):
+        for source in self._revision_sources:
+            source.unlock()
+
+
 def is_reserved_id(revision_id):
     """Determine whether a revision id is reserved
 
@@ -179,7 +452,7 @@
 
 
 def ensure_null(revision_id):
-    """Ensure only NULL_REVISION is used to represent the null revision"""
+    """Ensure only NULL_REVISION is used to represent the null revisionn"""
     if revision_id is None:
         symbol_versioning.warn('NULL_REVISION should be used for the null'
             ' revision instead of None, as of bzr 0.91.',

=== modified file 'bzrlib/revisionspec.py'
--- bzrlib/revisionspec.py	2008-07-19 15:00:27 +0000
+++ bzrlib/revisionspec.py	2007-08-20 13:03:46 +0000
@@ -100,8 +100,6 @@
 
         Use this if you don't know or care what the revno is.
         """
-        if revision_id == revision.NULL_REVISION:
-            return RevisionInfo(branch, 0, revision_id)
         try:
             revno = revs.index(revision_id) + 1
         except ValueError:
@@ -135,7 +133,6 @@
     """
 
     prefix = None
-    wants_revision_history = True
 
     def __new__(cls, spec, _internal=False):
         if _internal:
@@ -161,6 +158,10 @@
 
         if spec is None:
             return RevisionSpec(None, _internal=True)
+
+        assert isinstance(spec, basestring), \
+            "You should only supply strings not %s" % (type(spec),)
+
         for spectype in SPEC_TYPES:
             if spec.startswith(spectype.prefix):
                 trace.mutter('Returning RevisionSpec %s for %s',
@@ -200,14 +201,14 @@
 
     def _match_on(self, branch, revs):
         trace.mutter('Returning RevisionSpec._match_on: None')
-        return RevisionInfo(branch, None, None)
+        return RevisionInfo(branch, 0, None)
 
     def _match_on_and_check(self, branch, revs):
         info = self._match_on(branch, revs)
         if info:
             return info
-        elif info == (None, None):
-            # special case - nothing supplied
+        elif info == (0, None):
+            # special case - the empty tree
             return info
         elif self.prefix:
             raise errors.InvalidRevisionSpec(self.user_spec, branch)
@@ -216,10 +217,7 @@
 
     def in_history(self, branch):
         if branch:
-            if self.wants_revision_history:
-                revs = branch.revision_history()
-            else:
-                revs = None
+            revs = branch.revision_history()
         else:
             # this should never trigger.
             # TODO: make it a deprecated code path. RBC 20060928
@@ -235,23 +233,7 @@
     # will do what you expect.
     in_store = in_history
     in_branch = in_store
-
-    def as_revision_id(self, context_branch):
-        """Return just the revision_id for this revisions spec.
-
-        Some revision specs require a context_branch to be able to determine
-        their value. Not all specs will make use of it.
-        """
-        return self._as_revision_id(context_branch)
-
-    def _as_revision_id(self, context_branch):
-        """Implementation of as_revision_id()
-
-        Classes should override this function to provide appropriate
-        functionality. The default is to just call '.in_history().rev_id'
-        """
-        return self.in_history(context_branch).rev_id
-
+        
     def __repr__(self):
         # this is mostly for helping with testing
         return '<%s %s>' % (self.__class__.__name__,
@@ -296,14 +278,9 @@
                                    your history is very long.
     """
     prefix = 'revno:'
-    wants_revision_history = False
 
     def _match_on(self, branch, revs):
         """Lookup a revision by revision number"""
-        branch, revno, revision_id = self._lookup(branch, revs)
-        return RevisionInfo(branch, revno, revision_id)
-
-    def _lookup(self, branch, revs_or_none):
         loc = self.spec.find(':')
         if loc == -1:
             revno_spec = self.spec
@@ -338,7 +315,9 @@
             # the branch object.
             from bzrlib.branch import Branch
             branch = Branch.open(branch_spec)
-            revs_or_none = None
+            # Need to use a new revision history
+            # because we are using a specific branch
+            revs = branch.revision_history()
 
         if dotted:
             branch.lock_read()
@@ -350,31 +329,25 @@
             finally:
                 branch.unlock()
             if len(revisions) != 1:
-                return branch, None, None
+                return RevisionInfo(branch, None, None)
             else:
                 # there is no traditional 'revno' for dotted-decimal revnos.
                 # so for  API compatability we return None.
-                return branch, None, revisions[0]
+                return RevisionInfo(branch, None, revisions[0])
         else:
-            last_revno, last_revision_id = branch.last_revision_info()
             if revno < 0:
                 # if get_rev_id supported negative revnos, there would not be a
                 # need for this special case.
-                if (-revno) >= last_revno:
+                if (-revno) >= len(revs):
                     revno = 1
                 else:
-                    revno = last_revno + revno + 1
+                    revno = len(revs) + revno + 1
             try:
-                revision_id = branch.get_rev_id(revno, revs_or_none)
+                revision_id = branch.get_rev_id(revno, revs)
             except errors.NoSuchRevision:
                 raise errors.InvalidRevisionSpec(self.user_spec, branch)
-        return branch, revno, revision_id
-
-    def _as_revision_id(self, context_branch):
-        # We would have the revno here, but we don't really care
-        branch, revno, revision_id = self._lookup(context_branch, None)
-        return revision_id
-
+        return RevisionInfo(branch, revno, revision_id)
+        
     def needs_branch(self):
         return self.spec.find(':') == -1
 
@@ -401,8 +374,7 @@
     Examples::
 
       revid:aaaa@bbbb-123456789 -> Select revision 'aaaa@bbbb-123456789'
-    """
-
+    """    
     prefix = 'revid:'
 
     def _match_on(self, branch, revs):
@@ -412,9 +384,6 @@
         revision_id = osutils.safe_revision_id(self.spec, warn=False)
         return RevisionInfo.from_revision_id(branch, revision_id, revs)
 
-    def _as_revision_id(self, context_branch):
-        return osutils.safe_revision_id(self.spec, warn=False)
-
 SPEC_TYPES.append(RevisionSpec_revid)
 
 
@@ -429,43 +398,30 @@
 
       last:1        -> return the last revision
       last:3        -> return the revision 2 before the end.
-    """
+    """    
 
     prefix = 'last:'
 
     def _match_on(self, branch, revs):
-        revno, revision_id = self._revno_and_revision_id(branch, revs)
-        return RevisionInfo(branch, revno, revision_id)
-
-    def _revno_and_revision_id(self, context_branch, revs_or_none):
-        last_revno, last_revision_id = context_branch.last_revision_info()
-
         if self.spec == '':
-            if not last_revno:
-                raise errors.NoCommits(context_branch)
-            return last_revno, last_revision_id
+            if not revs:
+                raise errors.NoCommits(branch)
+            return RevisionInfo(branch, len(revs), revs[-1])
 
         try:
             offset = int(self.spec)
         except ValueError, e:
-            raise errors.InvalidRevisionSpec(self.user_spec, context_branch, e)
+            raise errors.InvalidRevisionSpec(self.user_spec, branch, e)
 
         if offset <= 0:
-            raise errors.InvalidRevisionSpec(self.user_spec, context_branch,
+            raise errors.InvalidRevisionSpec(self.user_spec, branch,
                                              'you must supply a positive value')
-
-        revno = last_revno - offset + 1
+        revno = len(revs) - offset + 1
         try:
-            revision_id = context_branch.get_rev_id(revno, revs_or_none)
+            revision_id = branch.get_rev_id(revno, revs)
         except errors.NoSuchRevision:
-            raise errors.InvalidRevisionSpec(self.user_spec, context_branch)
-        return revno, revision_id
-
-    def _as_revision_id(self, context_branch):
-        # We compute the revno as part of the process, but we don't really care
-        # about it.
-        revno, revision_id = self._revno_and_revision_id(context_branch, None)
-        return revision_id
+            raise errors.InvalidRevisionSpec(self.user_spec, branch)
+        return RevisionInfo(branch, revno, revision_id)
 
 SPEC_TYPES.append(RevisionSpec_last)
 
@@ -518,28 +474,6 @@
                                                  branch)
         return RevisionInfo(branch, revno, revision_id)
 
-    def _as_revision_id(self, context_branch):
-        base_revspec = RevisionSpec.from_string(self.spec)
-        base_revision_id = base_revspec.as_revision_id(context_branch)
-        if base_revision_id == revision.NULL_REVISION:
-            raise errors.InvalidRevisionSpec(self.user_spec, context_branch,
-                                         'cannot go before the null: revision')
-        context_repo = context_branch.repository
-        context_repo.lock_read()
-        try:
-            parent_map = context_repo.get_parent_map([base_revision_id])
-        finally:
-            context_repo.unlock()
-        if base_revision_id not in parent_map:
-            # Ghost, or unknown revision id
-            raise errors.InvalidRevisionSpec(self.user_spec, context_branch,
-                'cannot find the matching revision')
-        parents = parent_map[base_revision_id]
-        if len(parents) < 1:
-            raise errors.InvalidRevisionSpec(self.user_spec, context_branch,
-                'No parents for revision.')
-        return parents[0]
-
 SPEC_TYPES.append(RevisionSpec_before)
 
 
@@ -559,9 +493,6 @@
             branch.tags.lookup_tag(self.spec),
             revs)
 
-    def _as_revision_id(self, context_branch):
-        return context_branch.tags.lookup_tag(self.spec)
-
 SPEC_TYPES.append(RevisionSpec_tag)
 
 
@@ -596,7 +527,7 @@
 
     One way to display all the changes since yesterday would be::
 
-        bzr log -r date:yesterday..
+        bzr log -r date:yesterday..-1
 
     Examples::
 
@@ -665,7 +596,7 @@
         finally:
             branch.unlock()
         if rev == len(revs):
-            raise errors.InvalidRevisionSpec(self.user_spec, branch)
+            return RevisionInfo(branch, None)
         else:
             return RevisionInfo(branch, rev + 1)
 
@@ -698,43 +629,32 @@
         trace.mutter('matching ancestor: on: %s, %s', self.spec, branch)
         return self._find_revision_info(branch, self.spec)
 
-    def _as_revision_id(self, context_branch):
-        return self._find_revision_id(context_branch, self.spec)
-
     @staticmethod
     def _find_revision_info(branch, other_location):
-        revision_id = RevisionSpec_ancestor._find_revision_id(branch,
-                                                              other_location)
-        try:
-            revno = branch.revision_id_to_revno(revision_id)
-        except errors.NoSuchRevision:
-            revno = None
-        return RevisionInfo(branch, revno, revision_id)
-
-    @staticmethod
-    def _find_revision_id(branch, other_location):
         from bzrlib.branch import Branch
 
-        branch.lock_read()
-        try:
-            revision_a = revision.ensure_null(branch.last_revision())
-            if revision_a == revision.NULL_REVISION:
-                raise errors.NoCommits(branch)
-            other_branch = Branch.open(other_location)
-            other_branch.lock_read()
-            try:
-                revision_b = revision.ensure_null(other_branch.last_revision())
-                if revision_b == revision.NULL_REVISION:
-                    raise errors.NoCommits(other_branch)
-                graph = branch.repository.get_graph(other_branch.repository)
-                rev_id = graph.find_unique_lca(revision_a, revision_b)
-            finally:
-                other_branch.unlock()
+        other_branch = Branch.open(other_location)
+        revision_a = branch.last_revision()
+        revision_b = other_branch.last_revision()
+        for r, b in ((revision_a, branch), (revision_b, other_branch)):
+            if r in (None, revision.NULL_REVISION):
+                raise errors.NoCommits(b)
+        revision_source = revision.MultipleRevisionSources(
+                branch.repository, other_branch.repository)
+        graph = branch.repository.get_graph(other_branch.repository)
+        revision_a = revision.ensure_null(revision_a)
+        revision_b = revision.ensure_null(revision_b)
+        if revision.NULL_REVISION in (revision_a, revision_b):
+            rev_id = revision.NULL_REVISION
+        else:
+            rev_id = graph.find_unique_lca(revision_a, revision_b)
             if rev_id == revision.NULL_REVISION:
                 raise errors.NoCommonAncestor(revision_a, revision_b)
-            return rev_id
-        finally:
-            branch.unlock()
+        try:
+            revno = branch.revision_id_to_revno(rev_id)
+        except errors.NoSuchRevision:
+            revno = None
+        return RevisionInfo(branch, revno, rev_id)
 
 
 SPEC_TYPES.append(RevisionSpec_ancestor)
@@ -766,17 +686,7 @@
         except errors.NoSuchRevision:
             revno = None
         return RevisionInfo(branch, revno, revision_b)
-
-    def _as_revision_id(self, context_branch):
-        from bzrlib.branch import Branch
-        other_branch = Branch.open(self.spec)
-        last_revision = other_branch.last_revision()
-        last_revision = revision.ensure_null(last_revision)
-        context_branch.fetch(other_branch, last_revision)
-        if last_revision == revision.NULL_REVISION:
-            raise errors.NoCommits(other_branch)
-        return last_revision
-
+        
 SPEC_TYPES.append(RevisionSpec_branch)
 
 
@@ -787,7 +697,7 @@
 
     Diffing against this shows all the changes that were made in this branch,
     and is a good predictor of what merge will do.  The submit branch is
-    used by the bundle and merge directive commands.  If no submit branch
+    used by the bundle and merge directive comands.  If no submit branch
     is specified, the parent branch is used instead.
 
     The common ancestor is the last revision that existed in both
@@ -801,7 +711,8 @@
 
     prefix = 'submit:'
 
-    def _get_submit_location(self, branch):
+    def _match_on(self, branch, revs):
+        trace.mutter('matching ancestor: on: %s, %s', self.spec, branch)
         submit_location = branch.get_submit_branch()
         location_type = 'submit branch'
         if submit_location is None:
@@ -810,16 +721,7 @@
         if submit_location is None:
             raise errors.NoSubmitBranch(branch)
         trace.note('Using %s %s', location_type, submit_location)
-        return submit_location
-
-    def _match_on(self, branch, revs):
-        trace.mutter('matching ancestor: on: %s, %s', self.spec, branch)
-        return self._find_revision_info(branch,
-            self._get_submit_location(branch))
-
-    def _as_revision_id(self, context_branch):
-        return self._find_revision_id(context_branch,
-            self._get_submit_location(context_branch))
+        return self._find_revision_info(branch, submit_location)
 
 
 SPEC_TYPES.append(RevisionSpec_submit)

=== modified file 'bzrlib/revisiontree.py'
--- bzrlib/revisiontree.py	2008-07-02 01:40:02 +0000
+++ bzrlib/revisiontree.py	2007-10-08 07:29:57 +0000
@@ -19,7 +19,6 @@
 from cStringIO import StringIO
 
 from bzrlib import (
-    errors,
     osutils,
     revision,
     symbol_versioning,
@@ -32,7 +31,7 @@
 
     File text can be retrieved from the text store.
     """
-
+    
     def __init__(self, branch, inv, revision_id):
         # for compatability the 'branch' parameter has not been renamed to 
         # repository at this point. However, we should change RevisionTree's
@@ -40,9 +39,9 @@
         # construction - this will mean that we can change the constructor
         # with much less chance of breaking client code.
         self._repository = branch
+        self._weave_store = branch.weave_store
         self._inventory = inv
         self._revision_id = revision_id
-        self._rules_searcher = None
 
     def supports_tree_reference(self):
         return True
@@ -63,36 +62,40 @@
         """Return the revision id associated with this tree."""
         return self._revision_id
 
+    @symbol_versioning.deprecated_method(symbol_versioning.zero_ninety)
+    def get_weave(self, file_id):
+        return self._get_weave(file_id)
+
+    def _get_weave(self, file_id):
+        return self._weave_store.get_weave(file_id,
+                self._repository.get_transaction())
+
     def get_file_lines(self, file_id):
-        return osutils.split_lines(self.get_file_text(file_id))
+        ie = self._inventory[file_id]
+        weave = self._get_weave(file_id)
+        return weave.get_lines(ie.revision)
 
     def get_file_text(self, file_id):
-        return list(self.iter_files_bytes([(file_id, None)]))[0][1]
+        return ''.join(self.get_file_lines(file_id))
 
     def get_file(self, file_id, path=None):
         return StringIO(self.get_file_text(file_id))
 
     def iter_files_bytes(self, desired_files):
-        """See Tree.iter_files_bytes.
+        """See Tree.extract_files_bytes.
 
         This version is implemented on top of Repository.extract_files_bytes"""
         repo_desired_files = [(f, self.inventory[f].revision, i)
                               for f, i in desired_files]
-        try:
-            for result in self._repository.iter_files_bytes(repo_desired_files):
-                yield result
-        except errors.RevisionNotPresent, e:
-            raise errors.NoSuchFile(e.revision_id)
+        return self._repository.iter_files_bytes(repo_desired_files)
 
     def annotate_iter(self, file_id,
                       default_revision=revision.CURRENT_REVISION):
         """See Tree.annotate_iter"""
-        text_key = (file_id, self.inventory[file_id].revision)
-        annotations = self._repository.texts.annotate(text_key)
-        return [(key[-1], line) for key, line in annotations]
+        w = self._get_weave(file_id)
+        return w.annotate_iter(self.inventory[file_id].revision)
 
     def get_file_size(self, file_id):
-        """See Tree.get_file_size"""
         return self._inventory[file_id].text_size
 
     def get_file_sha1(self, file_id, path=None, stat_value=None):
@@ -159,6 +162,7 @@
         return entry.kind, entry.executable, None
 
     def _file_size(self, entry, stat_value):
+        assert entry.text_size is not None
         return entry.text_size
 
     def _get_ancestors(self, default_revision):
@@ -203,10 +207,3 @@
             for dir in reversed(dirblock):
                 if dir[2] == _directory:
                     pending.append(dir)
-
-    def _get_rules_searcher(self, default_searcher):
-        """See Tree._get_rules_searcher."""
-        if self._rules_searcher is None:
-            self._rules_searcher = super(RevisionTree,
-                self)._get_rules_searcher(default_searcher)
-        return self._rules_searcher

=== modified file 'bzrlib/rio.py'
--- bzrlib/rio.py	2008-04-24 07:22:53 +0000
+++ bzrlib/rio.py	2007-10-16 16:02:01 +0000
@@ -116,8 +116,8 @@
 
     def add(self, tag, value):
         """Append a name and value to the stanza."""
-        if not valid_tag(tag):
-            raise ValueError("invalid tag %r" % (tag,))
+        assert valid_tag(tag), \
+            ("invalid tag %r" % tag)
         if isinstance(value, str):
             value = unicode(value)
         elif isinstance(value, unicode):
@@ -165,6 +165,8 @@
             return []
         result = []
         for tag, value in self.items:
+            assert isinstance(tag, str), type(tag)
+            assert isinstance(value, unicode)
             if value == '':
                 result.append(tag + ': \n')
             elif '\n' in value:
@@ -233,6 +235,7 @@
         """
         d = {}
         for tag, value in self.items:
+            assert tag not in d
             d[tag] = value
         return d
          
@@ -288,6 +291,7 @@
             break       # end of file
         if line == '\n':
             break       # end of stanza
+        assert line.endswith('\n')
         real_l = line
         if line[0] == '\t': # continues previous value
             if tag is None:
@@ -302,8 +306,8 @@
                 raise ValueError('tag/value separator not found in line %r'
                                  % real_l)
             tag = str(line[:colon_index])
-            if not valid_tag(tag):
-                raise ValueError("invalid rio tag %r" % (tag,))
+            assert valid_tag(tag), \
+                    "invalid rio tag %r" % tag
             accum_value = line[colon_index+2:-1]
 
     if tag is not None: # add last tag-value
@@ -323,8 +327,7 @@
     :param max_width: The maximum number of characters per physical line.
     :return: a list of lines
     """
-    if max_width <= 6:
-        raise ValueError(max_width)
+    assert max_width > 6
     max_rio_width = max_width - 4
     lines = []
     for pline in stanza.to_lines():
@@ -370,10 +373,9 @@
     for line in line_iter:
         if line.startswith('# '):
             line = line[2:]
-        elif line.startswith('#'):
+        else:
+            assert line.startswith('#')
             line = line[1:]
-        else:
-            raise ValueError("bad line %r" % (line,))
         if last_line is not None and len(line) > 2:
             line = line[2:]
         line = re.sub('\r', '', line)

=== removed file 'bzrlib/rules.py'
--- bzrlib/rules.py	2008-07-18 08:40:57 +0000
+++ bzrlib/rules.py	1970-01-01 00:00:00 +0000
@@ -1,142 +0,0 @@
-# Copyright (C) 2008 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Rule-based definition of preferences for selected files in selected branches.
-
-See ``bzr help rules`` for details.
-"""
-
-from bzrlib import (
-    config,
-    errors,
-    globbing,
-    osutils,
-    )
-from bzrlib.util.configobj import configobj
-
-
-# Name of the file holding rules in a tree
-RULES_TREE_FILENAME = ".bzrrules"
-
-# Namespace prefix for per file preferences
-FILE_PREFS_PREFIX = 'name '
-FILE_PREFS_PREFIX_LEN = len(FILE_PREFS_PREFIX)
-
-
-class _RulesSearcher(object):
-    """An object that provides rule-based preferences."""
-
-    def get_items(self, path):
-        """Return the preferences for a path as name,value tuples.
-
-        :param path: tree relative path
-        :return: () if no rule matched, otherwise a sequence of name,value
-          tuples.
-        """
-        raise NotImplementedError(self.get_items)
-
-    def get_selected_items(self, path, names):
-        """Return selected preferences for a path as name,value tuples.
-
-        :param path: tree relative path
-        :param names: the list of preferences to lookup
-        :return: () if no rule matched, otherwise a sequence of name,value
-          tuples. The sequence is the same length as names,
-          tuple order matches the order in names, and
-          undefined preferences are given the value None.
-        """
-        raise NotImplementedError(self.get_selected_items)
-
-
-class _IniBasedRulesSearcher(_RulesSearcher):
-
-    def __init__(self, inifile):
-        """Construct a _RulesSearcher based on an ini file.
-
-        The content will be decoded as utf-8.
-
-        :param inifile: the name of the file or a sequence of lines.
-        """
-        options = {'encoding': 'utf-8'}
-        self._cfg = configobj.ConfigObj(inifile, options=options)
-        sections = self._cfg.keys()
-        patterns = [s[FILE_PREFS_PREFIX_LEN:] for s in sections
-            if s.startswith(FILE_PREFS_PREFIX)]
-        if len(patterns) < len(sections):
-            unknowns = [s for s in sections
-                if not s.startswith(FILE_PREFS_PREFIX)]
-            raise errors.UnknownRules(unknowns)
-        elif patterns:
-            self._globster = globbing._OrderedGlobster(patterns)
-        else:
-            self._globster = None
-
-    def get_items(self, path):
-        """See _RulesSearcher.get_items."""
-        if self._globster is None:
-            return ()
-        pat = self._globster.match(path)
-        if pat is None:
-            return ()
-        else:
-            all = self._cfg[FILE_PREFS_PREFIX + pat]
-            return tuple(all.items())
-
-    def get_selected_items(self, path, names):
-        """See _RulesSearcher.get_selected_items."""
-        if self._globster is None:
-            return ()
-        pat = self._globster.match(path)
-        if pat is None:
-            return ()
-        else:
-            all = self._cfg[FILE_PREFS_PREFIX + pat]
-            return tuple((k, all.get(k)) for k in names)
-
-
-class _StackedRulesSearcher(_RulesSearcher):
-
-    def __init__(self, searchers):
-        """Construct a _RulesSearcher based on a stack of other ones.
-
-        :param searchers: a sequence of searchers.
-        """
-        self.searchers = searchers
-
-    def get_items(self, path):
-        """See _RulesSearcher.get_items."""
-        for searcher in self.searchers:
-            result = searcher.get_items(path)
-            if result:
-                return result
-        return ()
-
-    def get_selected_items(self, path, names):
-        """See _RulesSearcher.get_selected_items."""
-        for searcher in self.searchers:
-            result = searcher.get_selected_items(path, names)
-            if result:
-                return result
-        return ()
-
-
-def rules_filename():
-    """Return the default rules filename."""
-    return osutils.pathjoin(config.config_dir(), 'rules')
-
-
-# The object providing default rules
-_per_user_searcher = _IniBasedRulesSearcher(rules_filename())

=== modified file 'bzrlib/sign_my_commits.py'
--- bzrlib/sign_my_commits.py	2007-11-22 02:23:57 +0000
+++ bzrlib/sign_my_commits.py	2007-07-10 10:33:45 +0000
@@ -65,25 +65,18 @@
         count = 0
         repo.lock_write()
         try:
-            repo.start_write_group()
-            try:
-                for rev_id in repo.get_ancestry(branch.last_revision())[1:]:
-                    if repo.has_signature_for_revision_id(rev_id):
-                        continue
-                    rev = repo.get_revision(rev_id)
-                    if rev.committer != committer:
-                        continue
-                    # We have a revision without a signature who has a 
-                    # matching committer, start signing
-                    print rev_id
-                    count += 1
-                    if not dry_run:
-                        repo.sign_revision(rev_id, gpg_strategy)
-            except:
-                repo.abort_write_group()
-                raise
-            else:
-                repo.commit_write_group()
+            for rev_id in repo.get_ancestry(branch.last_revision())[1:]:
+                if repo.has_signature_for_revision_id(rev_id):
+                    continue
+                rev = repo.get_revision(rev_id)
+                if rev.committer != committer:
+                    continue
+                # We have a revision without a signature who has a 
+                # matching committer, start signing
+                print rev_id
+                count += 1
+                if not dry_run:
+                    repo.sign_revision(rev_id, gpg_strategy)
         finally:
             repo.unlock()
         print 'Signed %d revisions' % (count,)

=== modified file 'bzrlib/smart/__init__.py'
--- bzrlib/smart/__init__.py	2007-09-03 04:43:27 +0000
+++ bzrlib/smart/__init__.py	2007-04-26 04:32:44 +0000
@@ -20,17 +20,160 @@
 rather than being a single large module.  Refer to the individual module
 docstrings for details.
 
-Server-side request handlers are registered in the `bzrlib.smart.request`
-module.
-
-The domain logic is in `bzrlib.remote`: `RemoteBzrDir`, `RemoteBranch`,
-and so on.
+Overview
+========
+
+The smart protocol provides a way to send a requests and corresponding
+responses to communicate with a remote bzr process.
+
+Layering
+========
+
+Medium
+------
+
+At the bottom level there is either a socket, pipes, or an HTTP
+request/response.  We call this layer the *medium*.  It is responsible for
+carrying bytes between a client and server.  For sockets, we have the
+idea that you have multiple requests and get a read error because the other side
+did shutdown.  For pipes we have read pipe which will have a zero read which
+marks end-of-file.  For HTTP server environment there is no end-of-stream
+because each request coming into the server is independent.
+
+So we need a wrapper around pipes and sockets to seperate out requests from
+substrate and this will give us a single model which is consistent for HTTP,
+sockets and pipes.
+
+Protocol
+--------
+
+On top of the medium is the *protocol*.  This is the layer that deserialises
+bytes into the structured data that requests and responses consist of.
+
+Version one of the protocol (for requests and responses) is described by::
+
+  REQUEST := MESSAGE_V1
+  RESPONSE := MESSAGE_V1
+  MESSAGE_V1 := ARGS BODY
+
+  ARGS := ARG [MORE_ARGS] NEWLINE
+  MORE_ARGS := SEP ARG [MORE_ARGS]
+  SEP := 0x01
+
+  BODY := LENGTH NEWLINE BODY_BYTES TRAILER
+  LENGTH := decimal integer
+  TRAILER := "done" NEWLINE
+
+That is, a tuple of arguments separated by Ctrl-A and terminated with a newline,
+followed by length prefixed body with a constant trailer.  Note that although
+arguments are not 8-bit safe (they cannot include 0x01 or 0x0a bytes without
+breaking the protocol encoding), the body is.
+
+Version two of the request protocol is::
+
+  REQUEST_V2 := "bzr request 2" NEWLINE MESSAGE_V1
+
+Version two of the response protocol is::
+
+  RESPONSE_V2 := "bzr request 2" NEWLINE MESSAGE_V1
+
+Future versions should follow this structure, like version two does::
+
+  FUTURE_MESSAGE := VERSION_STRING NEWLINE REST_OF_MESSAGE
+
+This is that clients and servers can read bytes up to the first newline byte to
+determine what version a message is.
+
+For compatibility will all versions (past and future) of bzr clients, servers
+that receive a request in an unknown protocol version should respond with a
+single-line error terminated with 0x0a (NEWLINE), rather than structured
+response prefixed with a version string.
+
+Request/Response processing
+---------------------------
+
+On top of the protocol is the logic for processing requests (on the server) or
+responses (on the client).
+
+Server-side
+-----------
+
+Sketch::
+
+ MEDIUM  (factory for protocol, reads bytes & pushes to protocol,
+          uses protocol to detect end-of-request, sends written
+          bytes to client) e.g. socket, pipe, HTTP request handler.
+  ^
+  | bytes.
+  v
+
+ PROTOCOL(serialization, deserialization)  accepts bytes for one
+          request, decodes according to internal state, pushes
+          structured data to handler.  accepts structured data from
+          handler and encodes and writes to the medium.  factory for
+          handler.
+  ^
+  | structured data
+  v
+
+ HANDLER  (domain logic) accepts structured data, operates state
+          machine until the request can be satisfied,
+          sends structured data to the protocol.
+
+Request handlers are registered in `bzrlib.smart.request`.
+
+
+Client-side
+-----------
+
+Sketch::
+
+ CLIENT   domain logic, accepts domain requests, generated structured
+          data, reads structured data from responses and turns into
+          domain data.  Sends structured data to the protocol.
+          Operates state machines until the request can be delivered
+          (e.g. reading from a bundle generated in bzrlib to deliver a
+          complete request).
+
+          Possibly this should just be RemoteBzrDir, RemoteTransport,
+          ...
+  ^
+  | structured data
+  v
+
+PROTOCOL  (serialization, deserialization)  accepts structured data for one
+          request, encodes and writes to the medium.  Reads bytes from the
+          medium, decodes and allows the client to read structured data.
+  ^
+  | bytes.
+  v
+
+ MEDIUM  (accepts bytes from the protocol & delivers to the remote server.
+          Allows the potocol to read bytes e.g. socket, pipe, HTTP request.
+
+The domain logic is in `bzrlib.remote`: `RemoteBzrDir`, `RemoteBranch`, and so
+on.
 
 There is also an plain file-level transport that calls remote methods to
 manipulate files on the server in `bzrlib.transport.remote`.
 
-The protocol is described in doc/developers/network-protocol.txt.
-
+Paths
+=====
+
+Paths are passed across the network.  The client needs to see a namespace that
+includes any repository that might need to be referenced, and the client needs
+to know about a root directory beyond which it cannot ascend.
+
+Servers run over ssh will typically want to be able to access any path the user
+can access.  Public servers on the other hand (which might be over http, ssh
+or tcp) will typically want to restrict access to only a particular directory
+and its children, so will want to do a software virtual root at that level.
+In other words they'll want to rewrite incoming paths to be under that level
+(and prevent escaping using ../ tricks.)
+
+URLs that include ~ should probably be passed across to the server verbatim
+and the server can expand them.  This will proably not be meaningful when
+limited to a directory?
 """
 
 # TODO: _translate_error should be on the client, not the transport because

=== modified file 'bzrlib/smart/branch.py'
--- bzrlib/smart/branch.py	2008-07-25 06:42:08 +0000
+++ bzrlib/smart/branch.py	2007-10-05 04:43:17 +0000
@@ -27,21 +27,14 @@
 
 
 class SmartServerBranchRequest(SmartServerRequest):
-    """Base class for handling common branch request logic.
-    """
+    """Base class for handling common branch request logic."""
 
     def do(self, path, *args):
         """Execute a request for a branch at path.
-    
-        All Branch requests take a path to the branch as their first argument.
 
         If the branch is a branch reference, NotBranchError is raised.
-
-        :param path: The path for the repository as received from the
-            client.
-        :return: A SmartServerResponse from self.do_with_branch().
         """
-        transport = self.transport_from_client_path(path)
+        transport = self._backing_transport.clone(path)
         bzrdir = BzrDir.open_from_transport(transport)
         if bzrdir.get_branch_reference() is not None:
             raise errors.NotBranchError(transport.base)
@@ -76,17 +69,12 @@
 class SmartServerBranchGetConfigFile(SmartServerBranchRequest):
     
     def do_with_branch(self, branch):
-        """Return the content of branch.conf
+        """Return the content of branch.control_files.get('branch.conf').
         
         The body is not utf8 decoded - its the literal bytestream from disk.
         """
-        # This was at one time called by RemoteBranchLockableFiles
-        # intercepting access to this file; as of 1.5 it is not called by the
-        # client but retained for compatibility.  It may be called again to
-        # allow the client to get the configuration without needing vfs
-        # access.
         try:
-            content = branch._transport.get_bytes('branch.conf')
+            content = branch.control_files.get('branch.conf').read()
         except errors.NoSuchFile:
             content = ''
         return SuccessfulSmartServerResponse( ('ok', ), content)
@@ -115,24 +103,9 @@
         return SuccessfulSmartServerResponse(('ok', str(revno), last_revision))
 
 
-class SmartServerSetTipRequest(SmartServerLockedBranchRequest):
-    """Base class for handling common branch request logic for requests that
-    update the branch tip.
-    """
-
-    def do_with_locked_branch(self, branch, *args):
-        try:
-            return self.do_tip_change_with_locked_branch(branch, *args)
-        except errors.TipChangeRejected, e:
-            msg = e.msg
-            if isinstance(msg, unicode):
-                msg = msg.encode('utf-8')
-            return FailedSmartServerResponse(('TipChangeRejected', msg))
-
-
-class SmartServerBranchRequestSetLastRevision(SmartServerSetTipRequest):
+class SmartServerBranchRequestSetLastRevision(SmartServerLockedBranchRequest):
     
-    def do_tip_change_with_locked_branch(self, branch, new_last_revision_id):
+    def do_with_locked_branch(self, branch, new_last_revision_id):
         if new_last_revision_id == 'null:':
             branch.set_revision_history([])
         else:
@@ -143,71 +116,6 @@
         return SuccessfulSmartServerResponse(('ok',))
 
 
-class SmartServerBranchRequestSetLastRevisionEx(SmartServerSetTipRequest):
-    
-    def do_tip_change_with_locked_branch(self, branch, new_last_revision_id,
-            allow_divergence, allow_overwrite_descendant):
-        """Set the last revision of the branch.
-
-        New in 1.6.
-        
-        :param new_last_revision_id: the revision ID to set as the last
-            revision of the branch.
-        :param allow_divergence: A flag.  If non-zero, change the revision ID
-            even if the new_last_revision_id's ancestry has diverged from the
-            current last revision.  If zero, a 'Diverged' error will be
-            returned if new_last_revision_id is not a descendant of the current
-            last revision.
-        :param allow_overwrite_descendant:  A flag.  If zero and
-            new_last_revision_id is not a descendant of the current last
-            revision, then the last revision will not be changed.  If non-zero
-            and there is no divergence, then the last revision is always
-            changed.
-
-        :returns: on success, a tuple of ('ok', revno, revision_id), where
-            revno and revision_id are the new values of the current last
-            revision info.  The revision_id might be different to the
-            new_last_revision_id if allow_overwrite_descendant was not set.
-        """
-        do_not_overwrite_descendant = not allow_overwrite_descendant
-        try:
-            last_revno, last_rev = branch.last_revision_info()
-            graph = branch.repository.get_graph()
-            if not allow_divergence or do_not_overwrite_descendant:
-                relation = branch._revision_relations(
-                    last_rev, new_last_revision_id, graph)
-                if relation == 'diverged' and not allow_divergence:
-                    return FailedSmartServerResponse(('Diverged',))
-                if relation == 'a_descends_from_b' and do_not_overwrite_descendant:
-                    return SuccessfulSmartServerResponse(
-                        ('ok', last_revno, last_rev))
-            new_revno = graph.find_distance_to_null(
-                new_last_revision_id, [(last_rev, last_revno)])
-            branch.set_last_revision_info(new_revno, new_last_revision_id)
-        except errors.GhostRevisionsHaveNoRevno:
-            return FailedSmartServerResponse(
-                ('NoSuchRevision', new_last_revision_id))
-        return SuccessfulSmartServerResponse(
-            ('ok', new_revno, new_last_revision_id))
-
-
-class SmartServerBranchRequestSetLastRevisionInfo(SmartServerSetTipRequest):
-    """Branch.set_last_revision_info.  Sets the revno and the revision ID of
-    the specified branch.
-
-    New in bzrlib 1.4.
-    """
-    
-    def do_tip_change_with_locked_branch(self, branch, new_revno,
-            new_last_revision_id):
-        try:
-            branch.set_last_revision_info(int(new_revno), new_last_revision_id)
-        except errors.NoSuchRevision:
-            return FailedSmartServerResponse(
-                ('NoSuchRevision', new_last_revision_id))
-        return SuccessfulSmartServerResponse(('ok',))
-
-
 class SmartServerBranchRequestLockWrite(SmartServerBranchRequest):
     
     def do_with_branch(self, branch, branch_token='', repo_token=''):
@@ -220,7 +128,6 @@
             try:
                 branch_token = branch.lock_write(token=branch_token)
             finally:
-                # this leaves the repository with 1 lock
                 branch.repository.unlock()
         except errors.LockContention:
             return FailedSmartServerResponse(('LockContention',))
@@ -230,10 +137,7 @@
             return FailedSmartServerResponse(('UnlockableTransport',))
         except errors.LockFailed, e:
             return FailedSmartServerResponse(('LockFailed', str(e.lock), str(e.why)))
-        if repo_token is None:
-            repo_token = ''
-        else:
-            branch.repository.leave_lock_in_place()
+        branch.repository.leave_lock_in_place()
         branch.leave_lock_in_place()
         branch.unlock()
         return SuccessfulSmartServerResponse(('ok', branch_token, repo_token))
@@ -250,8 +154,7 @@
                 branch.repository.unlock()
         except errors.TokenMismatch:
             return FailedSmartServerResponse(('TokenMismatch',))
-        if repo_token:
-            branch.repository.dont_leave_lock_in_place()
+        branch.repository.dont_leave_lock_in_place()
         branch.dont_leave_lock_in_place()
         branch.unlock()
         return SuccessfulSmartServerResponse(('ok',))

=== modified file 'bzrlib/smart/bzrdir.py'
--- bzrlib/smart/bzrdir.py	2008-03-27 06:10:18 +0000
+++ bzrlib/smart/bzrdir.py	2007-04-24 12:20:09 +0000
@@ -30,108 +30,49 @@
 
     def do(self, path):
         from bzrlib.bzrdir import BzrDirFormat
+        t = self._backing_transport.clone(path)
+        default_format = BzrDirFormat.get_default_format()
+        real_bzrdir = default_format.open(t, _found=True)
         try:
-            t = self.transport_from_client_path(path)
-        except errors.PathNotChild:
-            # The client is trying to ask about a path that they have no access
-            # to.
-            # Ideally we'd return a FailedSmartServerResponse here rather than
-            # a "successful" negative, but we want to be compatibile with
-            # clients that don't anticipate errors from this method.
+            real_bzrdir._format.probe_transport(t)
+        except (errors.NotBranchError, errors.UnknownFormatError):
             answer = 'no'
         else:
-            default_format = BzrDirFormat.get_default_format()
-            real_bzrdir = default_format.open(t, _found=True)
-            try:
-                real_bzrdir._format.probe_transport(t)
-            except (errors.NotBranchError, errors.UnknownFormatError):
-                answer = 'no'
-            else:
-                answer = 'yes'
+            answer = 'yes'
         return SuccessfulSmartServerResponse((answer,))
 
 
 class SmartServerRequestFindRepository(SmartServerRequest):
 
-    def _boolean_to_yes_no(self, a_boolean):
-        if a_boolean:
-            return 'yes'
-        else:
-            return 'no'
-
-    def _find(self, path):
-        """try to find a repository from path upwards
-        
-        This operates precisely like 'bzrdir.find_repository'.
-        
-        :return: (relpath, rich_root, tree_ref, external_lookup) flags. All are
-            strings, relpath is a / prefixed path, and the other three are
-            either 'yes' or 'no'.
-        :raises errors.NoRepositoryPresent: When there is no repository
-            present.
-        """
-        bzrdir = BzrDir.open_from_transport(
-            self.transport_from_client_path(path))
-        repository = bzrdir.find_repository()
-        # the relpath of the bzrdir in the found repository gives us the 
-        # path segments to pop-out.
-        relpath = repository.bzrdir.root_transport.relpath(
-            bzrdir.root_transport.base)
-        if len(relpath):
-            segments = ['..'] * len(relpath.split('/'))
-        else:
-            segments = []
-        rich_root = self._boolean_to_yes_no(repository.supports_rich_root())
-        tree_ref = self._boolean_to_yes_no(
-            repository._format.supports_tree_reference)
-        external_lookup = self._boolean_to_yes_no(
-            repository._format.supports_external_lookups)
-        return '/'.join(segments), rich_root, tree_ref, external_lookup
-
-
-class SmartServerRequestFindRepositoryV1(SmartServerRequestFindRepository):
-
-    def do(self, path):
-        """try to find a repository from path upwards
-        
-        This operates precisely like 'bzrdir.find_repository'.
-        
-        If a bzrdir is not present, an exception is propogated
-        rather than 'no branch' because these are different conditions.
-
-        This is the initial version of this method introduced with the smart
-        server. Modern clients will try the V2 method that adds support for the
-        supports_external_lookups attribute.
-
-        :return: norepository or ok, relpath.
-        """
-        try:
-            path, rich_root, tree_ref, external_lookup = self._find(path)
-            return SuccessfulSmartServerResponse(('ok', path, rich_root, tree_ref))
-        except errors.NoRepositoryPresent:
-            return FailedSmartServerResponse(('norepository', ))
-
-
-class SmartServerRequestFindRepositoryV2(SmartServerRequestFindRepository):
-
-    def do(self, path):
-        """try to find a repository from path upwards
-        
-        This operates precisely like 'bzrdir.find_repository'.
-        
-        If a bzrdir is not present, an exception is propogated
-        rather than 'no branch' because these are different conditions.
-
-        This is the second edition of this method introduced in bzr 1.3, which
-        returns information about the supports_external_lookups format
-        attribute too.
-
-        :return: norepository or ok, relpath.
-        """
-        try:
-            path, rich_root, tree_ref, external_lookup = self._find(path)
-            return SuccessfulSmartServerResponse(
-                ('ok', path, rich_root, tree_ref, external_lookup))
+    def do(self, path):
+        """try to find a repository from path upwards
+        
+        This operates precisely like 'bzrdir.find_repository'.
+        
+        If a bzrdir is not present, an exception is propogated
+        rather than 'no branch' because these are different conditions.
+
+        :return: norepository or ok, relpath.
+        """
+        bzrdir = BzrDir.open_from_transport(self._backing_transport.clone(path))
+        try:
+            repository = bzrdir.find_repository()
+            # the relpath of the bzrdir in the found repository gives us the 
+            # path segments to pop-out.
+            relpath = repository.bzrdir.root_transport.relpath(bzrdir.root_transport.base)
+            if len(relpath):
+                segments = ['..'] * len(relpath.split('/'))
+            else:
+                segments = []
+            if repository.supports_rich_root():
+                rich_root = 'yes'
+            else:
+                rich_root = 'no'
+            if repository._format.supports_tree_reference:
+                tree_ref = 'yes'
+            else:
+                tree_ref = 'no'
+            return SuccessfulSmartServerResponse(('ok', '/'.join(segments), rich_root, tree_ref))
         except errors.NoRepositoryPresent:
             return FailedSmartServerResponse(('norepository', ))
 
@@ -144,7 +85,7 @@
         The default format of the server is used.
         :return: SmartServerResponse(('ok', ))
         """
-        target_transport = self.transport_from_client_path(path)
+        target_transport = self._backing_transport.clone(path)
         BzrDirFormat.get_default_format().initialize_on_transport(target_transport)
         return SuccessfulSmartServerResponse(('ok', ))
 
@@ -157,8 +98,7 @@
         If a bzrdir is not present, an exception is propogated
         rather than 'no branch' because these are different conditions.
         """
-        bzrdir = BzrDir.open_from_transport(
-            self.transport_from_client_path(path))
+        bzrdir = BzrDir.open_from_transport(self._backing_transport.clone(path))
         try:
             reference_url = bzrdir.get_branch_reference()
             if reference_url is None:

=== modified file 'bzrlib/smart/client.py'
--- bzrlib/smart/client.py	2008-06-17 04:22:26 +0000
+++ bzrlib/smart/client.py	2007-08-06 05:11:55 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2008 Canonical Ltd
+# Copyright (C) 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -14,97 +14,19 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-import bzrlib
-from bzrlib.smart import message, protocol
-from bzrlib.trace import warning
-from bzrlib import errors
+from urlparse import urlparse
+
+from bzrlib.smart import protocol
+from bzrlib.urlutils import unescape
 
 
 class _SmartClient(object):
 
-    def __init__(self, medium, headers=None):
-        """Constructor.
-
-        :param medium: a SmartClientMedium
-        """
-        self._medium = medium
-        if headers is None:
-            self._headers = {'Software version': bzrlib.__version__}
-        else:
-            self._headers = dict(headers)
-
-    def _send_request(self, protocol_version, method, args, body=None,
-                      readv_body=None):
-        encoder, response_handler = self._construct_protocol(
-            protocol_version)
-        encoder.set_headers(self._headers)
-        if body is not None:
-            if readv_body is not None:
-                raise AssertionError(
-                    "body and readv_body are mutually exclusive.")
-            encoder.call_with_body_bytes((method, ) + args, body)
-        elif readv_body is not None:
-            encoder.call_with_body_readv_array((method, ) + args,
-                    readv_body)
-        else:
-            encoder.call(method, *args)
-        return response_handler
-
-    def _call_and_read_response(self, method, args, body=None, readv_body=None,
-            expect_response_body=True):
-        if self._medium._protocol_version is not None:
-            response_handler = self._send_request(
-                self._medium._protocol_version, method, args, body=body,
-                readv_body=readv_body)
-            return (response_handler.read_response_tuple(
-                        expect_body=expect_response_body),
-                    response_handler)
-        else:
-            for protocol_version in [3, 2]:
-                if protocol_version == 2:
-                    # If v3 doesn't work, the remote side is older than 1.6.
-                    self._medium._remember_remote_is_before((1, 6))
-                response_handler = self._send_request(
-                    protocol_version, method, args, body=body,
-                    readv_body=readv_body)
-                try:
-                    response_tuple = response_handler.read_response_tuple(
-                        expect_body=expect_response_body)
-                except errors.UnexpectedProtocolVersionMarker, err:
-                    # TODO: We could recover from this without disconnecting if
-                    # we recognise the protocol version.
-                    warning(
-                        'Server does not understand Bazaar network protocol %d,'
-                        ' reconnecting.  (Upgrade the server to avoid this.)'
-                        % (protocol_version,))
-                    self._medium.disconnect()
-                    continue
-                except errors.ErrorFromSmartServer:
-                    # If we received an error reply from the server, then it
-                    # must be ok with this protocol version.
-                    self._medium._protocol_version = protocol_version
-                    raise
-                else:
-                    self._medium._protocol_version = protocol_version
-                    return response_tuple, response_handler
-            raise errors.SmartProtocolError(
-                'Server is not a Bazaar server: ' + str(err))
-
-    def _construct_protocol(self, version):
-        request = self._medium.get_request()
-        if version == 3:
-            request_encoder = protocol.ProtocolThreeRequester(request)
-            response_handler = message.ConventionalResponseHandler()
-            response_proto = protocol.ProtocolThreeDecoder(
-                response_handler, expect_version_marker=True)
-            response_handler.setProtoAndMediumRequest(response_proto, request)
-        elif version == 2:
-            request_encoder = protocol.SmartClientRequestProtocolTwo(request)
-            response_handler = request_encoder
-        else:
-            request_encoder = protocol.SmartClientRequestProtocolOne(request)
-            response_handler = request_encoder
-        return request_encoder, response_handler
+    def __init__(self, shared_medium):
+        self._shared_medium = shared_medium
+
+    def get_smart_medium(self):
+        return self._shared_medium.connection
 
     def call(self, method, *args):
         """Call a method on the remote server."""
@@ -120,8 +42,10 @@
             result, smart_protocol = smart_client.call_expecting_body(...)
             body = smart_protocol.read_body_bytes()
         """
-        return self._call_and_read_response(
-            method, args, expect_response_body=True)
+        request = self.get_smart_medium().get_request()
+        smart_protocol = protocol.SmartClientRequestProtocolOne(request)
+        smart_protocol.call(method, *args)
+        return smart_protocol.read_response_tuple(expect_body=True), smart_protocol
 
     def call_with_body_bytes(self, method, args, body):
         """Call a method on the remote server with body bytes."""
@@ -132,27 +56,10 @@
                 raise TypeError('args must be byte strings, not %r' % (args,))
         if type(body) is not str:
             raise TypeError('body must be byte string, not %r' % (body,))
-        response, response_handler = self._call_and_read_response(
-            method, args, body=body, expect_response_body=False)
-        return response
-
-    def call_with_body_bytes_expecting_body(self, method, args, body):
-        """Call a method on the remote server with body bytes."""
-        if type(method) is not str:
-            raise TypeError('method must be a byte string, not %r' % (method,))
-        for arg in args:
-            if type(arg) is not str:
-                raise TypeError('args must be byte strings, not %r' % (args,))
-        if type(body) is not str:
-            raise TypeError('body must be byte string, not %r' % (body,))
-        response, response_handler = self._call_and_read_response(
-            method, args, body=body, expect_response_body=True)
-        return (response, response_handler)
-
-    def call_with_body_readv_array(self, args, body):
-        response, response_handler = self._call_and_read_response(
-                args[0], args[1:], readv_body=body, expect_response_body=True)
-        return (response, response_handler)
+        request = self.get_smart_medium().get_request()
+        smart_protocol = protocol.SmartClientRequestProtocolOne(request)
+        smart_protocol.call_with_body_bytes((method, ) + args, body)
+        return smart_protocol.read_response_tuple()
 
     def remote_path_from_transport(self, transport):
         """Convert transport into a path suitable for using in a request.
@@ -161,5 +68,4 @@
         anything but path, so it is only safe to use it in requests sent over
         the medium from the matching transport.
         """
-        return self._medium.remote_path_from_transport(transport)
-
+        return unescape(urlparse(transport.base)[2]).encode('utf8')

=== modified file 'bzrlib/smart/medium.py'
--- bzrlib/smart/medium.py	2008-08-14 02:15:31 +0000
+++ bzrlib/smart/medium.py	2007-10-05 14:52:02 +0000
@@ -27,138 +27,25 @@
 import os
 import socket
 import sys
-import urllib
 
-from bzrlib.lazy_import import lazy_import
-lazy_import(globals(), """
 from bzrlib import (
     errors,
-    osutils,
     symbol_versioning,
-    urlutils,
-    )
-from bzrlib.smart import protocol
-from bzrlib.transport import ssh
-""")
-
-
-# We must not read any more than 64k at a time so we don't risk "no buffer
-# space available" errors on some platforms.  Windows in particular is likely
-# to give error 10053 or 10055 if we read more than 64k from a socket.
-_MAX_READ_SIZE = 64 * 1024
-
-
-def _get_protocol_factory_for_bytes(bytes):
-    """Determine the right protocol factory for 'bytes'.
-
-    This will return an appropriate protocol factory depending on the version
-    of the protocol being used, as determined by inspecting the given bytes.
-    The bytes should have at least one newline byte (i.e. be a whole line),
-    otherwise it's possible that a request will be incorrectly identified as
-    version 1.
-
-    Typical use would be::
-
-         factory, unused_bytes = _get_protocol_factory_for_bytes(bytes)
-         server_protocol = factory(transport, write_func, root_client_path)
-         server_protocol.accept_bytes(unused_bytes)
-
-    :param bytes: a str of bytes of the start of the request.
-    :returns: 2-tuple of (protocol_factory, unused_bytes).  protocol_factory is
-        a callable that takes three args: transport, write_func,
-        root_client_path.  unused_bytes are any bytes that were not part of a
-        protocol version marker.
-    """
-    if bytes.startswith(protocol.MESSAGE_VERSION_THREE):
-        protocol_factory = protocol.build_server_protocol_three
-        bytes = bytes[len(protocol.MESSAGE_VERSION_THREE):]
-    elif bytes.startswith(protocol.REQUEST_VERSION_TWO):
-        protocol_factory = protocol.SmartServerRequestProtocolTwo
-        bytes = bytes[len(protocol.REQUEST_VERSION_TWO):]
-    else:
-        protocol_factory = protocol.SmartServerRequestProtocolOne
-    return protocol_factory, bytes
-
-
-def _get_line(read_bytes_func):
-    """Read bytes using read_bytes_func until a newline byte.
-    
-    This isn't particularly efficient, so should only be used when the
-    expected size of the line is quite short.
-    
-    :returns: a tuple of two strs: (line, excess)
-    """
-    newline_pos = -1
-    bytes = ''
-    while newline_pos == -1:
-        new_bytes = read_bytes_func(1)
-        bytes += new_bytes
-        if new_bytes == '':
-            # Ran out of bytes before receiving a complete line.
-            return bytes, ''
-        newline_pos = bytes.find('\n')
-    line = bytes[:newline_pos+1]
-    excess = bytes[newline_pos+1:]
-    return line, excess
-
-
-class SmartMedium(object):
-    """Base class for smart protocol media, both client- and server-side."""
-
-    def __init__(self):
-        self._push_back_buffer = None
-        
-    def _push_back(self, bytes):
-        """Return unused bytes to the medium, because they belong to the next
-        request(s).
-
-        This sets the _push_back_buffer to the given bytes.
-        """
-        if self._push_back_buffer is not None:
-            raise AssertionError(
-                "_push_back called when self._push_back_buffer is %r"
-                % (self._push_back_buffer,))
-        if bytes == '':
-            return
-        self._push_back_buffer = bytes
-
-    def _get_push_back_buffer(self):
-        if self._push_back_buffer == '':
-            raise AssertionError(
-                '%s._push_back_buffer should never be the empty string, '
-                'which can be confused with EOF' % (self,))
-        bytes = self._push_back_buffer
-        self._push_back_buffer = None
-        return bytes
-
-    def read_bytes(self, desired_count):
-        """Read some bytes from this medium.
-
-        :returns: some bytes, possibly more or less than the number requested
-            in 'desired_count' depending on the medium.
-        """
-        if self._push_back_buffer is not None:
-            return self._get_push_back_buffer()
-        bytes_to_read = min(desired_count, _MAX_READ_SIZE)
-        return self._read_bytes(bytes_to_read)
-
-    def _read_bytes(self, count):
-        raise NotImplementedError(self._read_bytes)
-
-    def _get_line(self):
-        """Read bytes from this request's response until a newline byte.
-        
-        This isn't particularly efficient, so should only be used when the
-        expected size of the line is quite short.
-
-        :returns: a string of bytes ending in a newline (byte 0x0A).
-        """
-        line, excess = _get_line(self.read_bytes)
-        self._push_back(excess)
-        return line
- 
-
-class SmartServerStreamMedium(SmartMedium):
+    )
+from bzrlib.smart.protocol import (
+    REQUEST_VERSION_TWO,
+    SmartServerRequestProtocolOne,
+    SmartServerRequestProtocolTwo,
+    )
+
+try:
+    from bzrlib.transport import ssh
+except errors.ParamikoNotPresent:
+    # no paramiko.  SmartSSHClientMedium will break.
+    pass
+
+
+class SmartServerStreamMedium(object):
     """Handles smart commands coming over a stream.
 
     The stream may be a pipe connected to sshd, or a tcp socket, or an
@@ -169,23 +56,16 @@
 
     The server passes requests through to an underlying backing transport, 
     which will typically be a LocalTransport looking at the server's filesystem.
-
-    :ivar _push_back_buffer: a str of bytes that have been read from the stream
-        but not used yet, or None if there are no buffered bytes.  Subclasses
-        should make sure to exhaust this buffer before reading more bytes from
-        the stream.  See also the _push_back method.
     """
 
-    def __init__(self, backing_transport, root_client_path='/'):
+    def __init__(self, backing_transport):
         """Construct new server.
 
         :param backing_transport: Transport for the directory served.
         """
         # backing_transport could be passed to serve instead of __init__
         self.backing_transport = backing_transport
-        self.root_client_path = root_client_path
         self.finished = False
-        SmartMedium.__init__(self)
 
     def serve(self):
         """Serve requests until the client disconnects."""
@@ -209,11 +89,15 @@
 
         :returns: a SmartServerRequestProtocol.
         """
+        # Identify the protocol version.
         bytes = self._get_line()
-        protocol_factory, unused_bytes = _get_protocol_factory_for_bytes(bytes)
-        protocol = protocol_factory(
-            self.backing_transport, self._write_out, self.root_client_path)
-        protocol.accept_bytes(unused_bytes)
+        if bytes.startswith(REQUEST_VERSION_TWO):
+            protocol_class = SmartServerRequestProtocolTwo
+            bytes = bytes[len(REQUEST_VERSION_TWO):]
+        else:
+            protocol_class = SmartServerRequestProtocolOne
+        protocol = protocol_class(self.backing_transport, self._write_out)
+        protocol.accept_bytes(bytes)
         return protocol
 
     def _serve_one_request(self, protocol):
@@ -232,53 +116,73 @@
         """Called when an unhandled exception from the protocol occurs."""
         raise NotImplementedError(self.terminate_due_to_error)
 
-    def _read_bytes(self, desired_count):
+    def _get_bytes(self, desired_count):
         """Get some bytes from the medium.
 
         :param desired_count: number of bytes we want to read.
         """
-        raise NotImplementedError(self._read_bytes)
+        raise NotImplementedError(self._get_bytes)
+
+    def _get_line(self):
+        """Read bytes from this request's response until a newline byte.
+        
+        This isn't particularly efficient, so should only be used when the
+        expected size of the line is quite short.
+
+        :returns: a string of bytes ending in a newline (byte 0x0A).
+        """
+        # XXX: this duplicates SmartClientRequestProtocolOne._recv_tuple
+        line = ''
+        while not line or line[-1] != '\n':
+            new_char = self._get_bytes(1)
+            line += new_char
+            if new_char == '':
+                # Ran out of bytes before receiving a complete line.
+                break
+        return line
 
 
 class SmartServerSocketStreamMedium(SmartServerStreamMedium):
 
-    def __init__(self, sock, backing_transport, root_client_path='/'):
+    def __init__(self, sock, backing_transport):
         """Constructor.
 
         :param sock: the socket the server will read from.  It will be put
             into blocking mode.
         """
-        SmartServerStreamMedium.__init__(
-            self, backing_transport, root_client_path=root_client_path)
+        SmartServerStreamMedium.__init__(self, backing_transport)
+        self.push_back = ''
         sock.setblocking(True)
         self.socket = sock
 
     def _serve_one_request_unguarded(self, protocol):
         while protocol.next_read_size():
-            # We can safely try to read large chunks.  If there is less data
-            # than _MAX_READ_SIZE ready, the socket wil just return a short
-            # read immediately rather than block.
-            bytes = self.read_bytes(_MAX_READ_SIZE)
-            if bytes == '':
-                self.finished = True
-                return
-            protocol.accept_bytes(bytes)
+            if self.push_back:
+                protocol.accept_bytes(self.push_back)
+                self.push_back = ''
+            else:
+                bytes = self._get_bytes(4096)
+                if bytes == '':
+                    self.finished = True
+                    return
+                protocol.accept_bytes(bytes)
         
-        self._push_back(protocol.unused_data)
+        self.push_back = protocol.excess_buffer
 
-    def _read_bytes(self, desired_count):
+    def _get_bytes(self, desired_count):
         # We ignore the desired_count because on sockets it's more efficient to
-        # read large chunks (of _MAX_READ_SIZE bytes) at a time.
-        return self.socket.recv(_MAX_READ_SIZE)
-
+        # read 4k at a time.
+        return self.socket.recv(4096)
+    
     def terminate_due_to_error(self):
+        """Called when an unhandled exception from the protocol occurs."""
         # TODO: This should log to a server log file, but no such thing
         # exists yet.  Andrew Bennetts 2006-09-29.
         self.socket.close()
         self.finished = True
 
     def _write_out(self, bytes):
-        osutils.send_all(self.socket, bytes)
+        self.socket.sendall(bytes)
 
 
 class SmartServerPipeStreamMedium(SmartServerStreamMedium):
@@ -303,15 +207,12 @@
 
     def _serve_one_request_unguarded(self, protocol):
         while True:
-            # We need to be careful not to read past the end of the current
-            # request, or else the read from the pipe will block, so we use
-            # protocol.next_read_size().
             bytes_to_read = protocol.next_read_size()
             if bytes_to_read == 0:
                 # Finished serving this request.
                 self._out.flush()
                 return
-            bytes = self.read_bytes(bytes_to_read)
+            bytes = self._get_bytes(bytes_to_read)
             if bytes == '':
                 # Connection has been closed.
                 self.finished = True
@@ -319,7 +220,7 @@
                 return
             protocol.accept_bytes(bytes)
 
-    def _read_bytes(self, desired_count):
+    def _get_bytes(self, desired_count):
         return self._in.read(desired_count)
 
     def terminate_due_to_error(self):
@@ -439,137 +340,42 @@
         return self._read_bytes(count)
 
     def _read_bytes(self, count):
-        """Helper for SmartClientMediumRequest.read_bytes.
+        """Helper for read_bytes.
 
         read_bytes checks the state of the request to determing if bytes
         should be read. After that it hands off to _read_bytes to do the
         actual read.
-        
-        By default this forwards to self._medium.read_bytes because we are
-        operating on the medium's stream.
         """
-        return self._medium.read_bytes(count)
+        raise NotImplementedError(self._read_bytes)
 
     def read_line(self):
-        line = self._read_line()
-        if not line.endswith('\n'):
-            # end of file encountered reading from server
-            raise errors.ConnectionReset(
-                "please check connectivity and permissions",
-                "(and try -Dhpss if further diagnosis is required)")
-        return line
-
-    def _read_line(self):
-        """Helper for SmartClientMediumRequest.read_line.
+        """Read bytes from this request's response until a newline byte.
         
-        By default this forwards to self._medium._get_line because we are
-        operating on the medium's stream.
+        This isn't particularly efficient, so should only be used when the
+        expected size of the line is quite short.
+
+        :returns: a string of bytes ending in a newline (byte 0x0A).
         """
-        return self._medium._get_line()
-
-
-class SmartClientMedium(SmartMedium):
+        # XXX: this duplicates SmartClientRequestProtocolOne._recv_tuple
+        line = ''
+        while not line or line[-1] != '\n':
+            new_char = self.read_bytes(1)
+            line += new_char
+            if new_char == '':
+                raise errors.SmartProtocolError(
+                    'unexpected end of file reading from server')
+        return line
+
+
+class SmartClientMedium(object):
     """Smart client is a medium for sending smart protocol requests over."""
 
-    def __init__(self, base):
-        super(SmartClientMedium, self).__init__()
-        self.base = base
-        self._protocol_version_error = None
-        self._protocol_version = None
-        self._done_hello = False
-        # Be optimistic: we assume the remote end can accept new remote
-        # requests until we get an error saying otherwise.
-        # _remote_version_is_before tracks the bzr version the remote side
-        # can be based on what we've seen so far.
-        self._remote_version_is_before = None
-
-    def _is_remote_before(self, version_tuple):
-        """Is it possible the remote side supports RPCs for a given version?
-
-        Typical use::
-
-            needed_version = (1, 2)
-            if medium._is_remote_before(needed_version):
-                fallback_to_pre_1_2_rpc()
-            else:
-                try:
-                    do_1_2_rpc()
-                except UnknownSmartMethod:
-                    medium._remember_remote_is_before(needed_version)
-                    fallback_to_pre_1_2_rpc()
-
-        :seealso: _remember_remote_is_before
-        """
-        if self._remote_version_is_before is None:
-            # So far, the remote side seems to support everything
-            return False
-        return version_tuple >= self._remote_version_is_before
-
-    def _remember_remote_is_before(self, version_tuple):
-        """Tell this medium that the remote side is older the given version.
-
-        :seealso: _is_remote_before
-        """
-        if (self._remote_version_is_before is not None and
-            version_tuple > self._remote_version_is_before):
-            raise AssertionError(
-                "_remember_remote_is_before(%r) called, but "
-                "_remember_remote_is_before(%r) was called previously."
-                % (version_tuple, self._remote_version_is_before))
-        self._remote_version_is_before = version_tuple
-
-    def protocol_version(self):
-        """Find out if 'hello' smart request works."""
-        if self._protocol_version_error is not None:
-            raise self._protocol_version_error
-        if not self._done_hello:
-            try:
-                medium_request = self.get_request()
-                # Send a 'hello' request in protocol version one, for maximum
-                # backwards compatibility.
-                client_protocol = protocol.SmartClientRequestProtocolOne(medium_request)
-                client_protocol.query_version()
-                self._done_hello = True
-            except errors.SmartProtocolError, e:
-                # Cache the error, just like we would cache a successful
-                # result.
-                self._protocol_version_error = e
-                raise
-        return '2'
-
-    def should_probe(self):
-        """Should RemoteBzrDirFormat.probe_transport send a smart request on
-        this medium?
-
-        Some transports are unambiguously smart-only; there's no need to check
-        if the transport is able to carry smart requests, because that's all
-        it is for.  In those cases, this method should return False.
-
-        But some HTTP transports can sometimes fail to carry smart requests,
-        but still be usuable for accessing remote bzrdirs via plain file
-        accesses.  So for those transports, their media should return True here
-        so that RemoteBzrDirFormat can determine if it is appropriate for that
-        transport.
-        """
-        return False
-
     def disconnect(self):
         """If this medium maintains a persistent connection, close it.
         
         The default implementation does nothing.
         """
         
-    def remote_path_from_transport(self, transport):
-        """Convert transport into a path suitable for using in a request.
-        
-        Note that the resulting remote path doesn't encode the host name or
-        anything but path, so it is only safe to use it in requests sent over
-        the medium from the matching transport.
-        """
-        medium_base = urlutils.join(self.base, '/')
-        rel_url = urlutils.relative_url(medium_base, transport.base)
-        return urllib.unquote(rel_url)
-
 
 class SmartClientStreamMedium(SmartClientMedium):
     """Stream based medium common class.
@@ -580,8 +386,7 @@
     receive bytes.
     """
 
-    def __init__(self, base):
-        SmartClientMedium.__init__(self, base)
+    def __init__(self):
         self._current_request = None
 
     def accept_bytes(self, bytes):
@@ -609,6 +414,9 @@
         """
         return SmartClientStreamMediumRequest(self)
 
+    def read_bytes(self, count):
+        return self._read_bytes(count)
+
 
 class SmartSimplePipesClientMedium(SmartClientStreamMedium):
     """A client medium using simple pipes.
@@ -616,8 +424,8 @@
     This client does not manage the pipes: it assumes they will always be open.
     """
 
-    def __init__(self, readable_pipe, writeable_pipe, base):
-        SmartClientStreamMedium.__init__(self, base)
+    def __init__(self, readable_pipe, writeable_pipe):
+        SmartClientStreamMedium.__init__(self)
         self._readable_pipe = readable_pipe
         self._writeable_pipe = writeable_pipe
 
@@ -638,13 +446,13 @@
     """A client medium using SSH."""
     
     def __init__(self, host, port=None, username=None, password=None,
-            base=None, vendor=None, bzr_remote_path=None):
+            vendor=None, bzr_remote_path=None):
         """Creates a client that will connect on the first use.
         
         :param vendor: An optional override for the ssh vendor to use. See
             bzrlib.transport.ssh for details on ssh vendors.
         """
-        SmartClientStreamMedium.__init__(self, base)
+        SmartClientStreamMedium.__init__(self)
         self._connected = False
         self._host = host
         self._password = password
@@ -699,21 +507,15 @@
         """See SmartClientStreamMedium.read_bytes."""
         if not self._connected:
             raise errors.MediumNotConnected(self)
-        bytes_to_read = min(count, _MAX_READ_SIZE)
-        return self._read_from.read(bytes_to_read)
-
-
-# Port 4155 is the default port for bzr://, registered with IANA.
-BZR_DEFAULT_INTERFACE = '0.0.0.0'
-BZR_DEFAULT_PORT = 4155
+        return self._read_from.read(count)
 
 
 class SmartTCPClientMedium(SmartClientStreamMedium):
     """A client medium using TCP."""
     
-    def __init__(self, host, port, base):
+    def __init__(self, host, port):
         """Creates a client that will connect on the first use."""
-        SmartClientStreamMedium.__init__(self, base)
+        SmartClientStreamMedium.__init__(self)
         self._connected = False
         self._host = host
         self._port = port
@@ -722,7 +524,7 @@
     def _accept_bytes(self, bytes):
         """See SmartClientMedium.accept_bytes."""
         self._ensure_connection()
-        osutils.send_all(self._socket, bytes)
+        self._socket.sendall(bytes)
 
     def disconnect(self):
         """See SmartClientMedium.disconnect()."""
@@ -738,21 +540,10 @@
             return
         self._socket = socket.socket()
         self._socket.setsockopt(socket.IPPROTO_TCP, socket.TCP_NODELAY, 1)
-        if self._port is None:
-            port = BZR_DEFAULT_PORT
-        else:
-            port = int(self._port)
-        try:
-            self._socket.connect((self._host, port))
-        except socket.error, err:
-            # socket errors either have a (string) or (errno, string) as their
-            # args.
-            if type(err.args) is str:
-                err_msg = err.args
-            else:
-                err_msg = err.args[1]
+        result = self._socket.connect_ex((self._host, int(self._port)))
+        if result:
             raise errors.ConnectionError("failed to connect to %s:%d: %s" %
-                    (self._host, port, err_msg))
+                    (self._host, self._port, os.strerror(result)))
         self._connected = True
 
     def _flush(self):
@@ -766,9 +557,7 @@
         """See SmartClientMedium.read_bytes."""
         if not self._connected:
             raise errors.MediumNotConnected(self)
-        # We ignore the desired_count because on sockets it's more efficient to
-        # read large chunks (of _MAX_READ_SIZE bytes) at a time.
-        return self._socket.recv(_MAX_READ_SIZE)
+        return self._socket.recv(count)
 
 
 class SmartClientStreamMediumRequest(SmartClientMediumRequest):
@@ -799,8 +588,7 @@
         This clears the _current_request on self._medium to allow a new 
         request to be created.
         """
-        if self._medium._current_request is not self:
-            raise AssertionError()
+        assert self._medium._current_request is self
         self._medium._current_request = None
         
     def _finished_writing(self):
@@ -810,3 +598,11 @@
         """
         self._medium._flush()
 
+    def _read_bytes(self, count):
+        """See SmartClientMediumRequest._read_bytes.
+        
+        This forwards to self._medium._read_bytes because we are operating
+        on the mediums stream.
+        """
+        return self._medium._read_bytes(count)
+

=== removed file 'bzrlib/smart/message.py'
--- bzrlib/smart/message.py	2008-06-01 23:08:22 +0000
+++ bzrlib/smart/message.py	1970-01-01 00:00:00 +0000
@@ -1,316 +0,0 @@
-# Copyright (C) 2008 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-import collections
-from cStringIO import StringIO
-
-from bzrlib import (
-    debug,
-    errors,
-    )
-from bzrlib.trace import mutter
-
-
-class MessageHandler(object):
-    """Base class for handling messages received via the smart protocol.
-
-    As parts of a message are received, the corresponding PART_received method
-    will be called.
-    """
-
-    def __init__(self):
-        self.headers = None
-
-    def headers_received(self, headers):
-        """Called when message headers are received.
-        
-        This default implementation just stores them in self.headers.
-        """
-        self.headers = headers
-
-    def byte_part_received(self, byte):
-        """Called when a 'byte' part is received.
-
-        Note that a 'byte' part is a message part consisting of exactly one
-        byte.
-        """
-        raise NotImplementedError(self.byte_received)
-
-    def bytes_part_received(self, bytes):
-        """Called when a 'bytes' part is received.
-
-        A 'bytes' message part can contain any number of bytes.  It should not
-        be confused with a 'byte' part, which is always a single byte.
-        """
-        raise NotImplementedError(self.bytes_received)
-
-    def structure_part_received(self, structure):
-        """Called when a 'structure' part is received.
-
-        :param structure: some structured data, which will be some combination
-            of list, dict, int, and str objects.
-        """
-        raise NotImplementedError(self.bytes_received)
-
-    def protocol_error(self, exception):
-        """Called when there is a protocol decoding error.
-        
-        The default implementation just re-raises the exception.
-        """
-        raise
-    
-    def end_received(self):
-        """Called when the end of the message is received."""
-        # No-op by default.
-        pass
-
-
-class ConventionalRequestHandler(MessageHandler):
-    """A message handler for "conventional" requests.
-
-    "Conventional" is used in the sense described in
-    doc/developers/network-protocol.txt: a simple message with arguments and an
-    optional body.
-    """
-
-    def __init__(self, request_handler, responder):
-        MessageHandler.__init__(self)
-        self.request_handler = request_handler
-        self.responder = responder
-        self.args_received = False
-
-    def protocol_error(self, exception):
-        if self.responder.response_sent:
-            # We can only send one response to a request, no matter how many
-            # errors happen while processing it.
-            return
-        self.responder.send_error(exception)
-
-    def byte_part_received(self, byte):
-        raise errors.SmartProtocolError(
-            'Unexpected message part: byte(%r)' % (byte,))
-
-    def structure_part_received(self, structure):
-        if self.args_received:
-            raise errors.SmartProtocolError(
-                'Unexpected message part: structure(%r)' % (structure,))
-        self.args_received = True
-        self.request_handler.dispatch_command(structure[0], structure[1:])
-        if self.request_handler.finished_reading:
-            self.responder.send_response(self.request_handler.response)
-
-    def bytes_part_received(self, bytes):
-        # Note that there's no intrinsic way to distinguish a monolithic body
-        # from a chunk stream.  A request handler knows which it is expecting
-        # (once the args have been received), so it should be able to do the
-        # right thing.
-        self.request_handler.accept_body(bytes)
-        self.request_handler.end_of_body()
-        if not self.request_handler.finished_reading:
-            raise SmartProtocolError(
-                "Conventional request body was received, but request handler "
-                "has not finished reading.")
-        self.responder.send_response(self.request_handler.response)
-
-
-class ResponseHandler(object):
-    """Abstract base class for an object that handles a smart response."""
-
-    def read_response_tuple(self, expect_body=False):
-        """Reads and returns the response tuple for the current request.
-        
-        :keyword expect_body: a boolean indicating if a body is expected in the
-            response.  Some protocol versions needs this information to know
-            when a response is finished.  If False, read_body_bytes should
-            *not* be called afterwards.  Defaults to False.
-        :returns: tuple of response arguments.
-        """
-        raise NotImplementedError(self.read_response_tuple)
-
-    def read_body_bytes(self, count=-1):
-        """Read and return some bytes from the body.
-
-        :param count: if specified, read up to this many bytes.  By default,
-            reads the entire body.
-        :returns: str of bytes from the response body.
-        """
-        raise NotImplementedError(self.read_body_bytes)
-
-    def read_streamed_body(self):
-        """Returns an iterable that reads and returns a series of body chunks.
-        """
-        raise NotImplementedError(self.read_streamed_body)
-
-    def cancel_read_body(self):
-        """Stop expecting a body for this response.
-
-        If expect_body was passed to read_response_tuple, this cancels that
-        expectation (and thus finishes reading the response, allowing a new
-        request to be issued).  This is useful if a response turns out to be an
-        error rather than a normal result with a body.
-        """
-        raise NotImplementedError(self.cancel_read_body)
-
-
-class ConventionalResponseHandler(MessageHandler, ResponseHandler):
-
-    def __init__(self):
-        MessageHandler.__init__(self)
-        self.status = None
-        self.args = None
-        self._bytes_parts = collections.deque()
-        self._body_started = False
-        self._body_stream_status = None
-        self._body = None
-        self._body_error_args = None
-        self.finished_reading = False
-
-    def setProtoAndMediumRequest(self, protocol_decoder, medium_request):
-        self._protocol_decoder = protocol_decoder
-        self._medium_request = medium_request
-
-    def byte_part_received(self, byte):
-        if byte not in ['E', 'S']:
-            raise errors.SmartProtocolError(
-                'Unknown response status: %r' % (byte,))
-        if self._body_started:
-            if self._body_stream_status is not None:
-                raise errors.SmartProtocolError(
-                    'Unexpected byte part received: %r' % (byte,))
-            self._body_stream_status = byte
-        else:
-            if self.status is not None:
-                raise errors.SmartProtocolError(
-                    'Unexpected byte part received: %r' % (byte,))
-            self.status = byte
-
-    def bytes_part_received(self, bytes):
-        self._body_started = True
-        self._bytes_parts.append(bytes)
-
-    def structure_part_received(self, structure):
-        if type(structure) is not list:
-            raise errors.SmartProtocolError(
-                'Args structure is not a sequence: %r' % (structure,))
-        structure = tuple(structure)
-        if not self._body_started:
-            if self.args is not None:
-                raise errors.SmartProtocolError(
-                    'Unexpected structure received: %r (already got %r)'
-                    % (structure, self.args))
-            self.args = structure
-        else:
-            if self._body_stream_status != 'E':
-                raise errors.SmartProtocolError(
-                    'Unexpected structure received after body: %r'
-                    % (structure,))
-            self._body_error_args = structure
-
-    def _wait_for_response_args(self):
-        while self.args is None and not self.finished_reading:
-            self._read_more()
-
-    def _wait_for_response_end(self):
-        while not self.finished_reading:
-            self._read_more()
-
-    def _read_more(self):
-        next_read_size = self._protocol_decoder.next_read_size()
-        if next_read_size == 0:
-            # a complete request has been read.
-            self.finished_reading = True
-            self._medium_request.finished_reading()
-            return
-        bytes = self._medium_request.read_bytes(next_read_size)
-        if bytes == '':
-            # end of file encountered reading from server
-            if 'hpss' in debug.debug_flags:
-                mutter(
-                    'decoder state: buf[:10]=%r, state_accept=%s',
-                    self._protocol_decoder._in_buffer[:10],
-                    self._protocol_decoder.state_accept.__name__)
-            raise errors.ConnectionReset(
-                "please check connectivity and permissions",
-                "(and try -Dhpss if further diagnosis is required)")
-        self._protocol_decoder.accept_bytes(bytes)
-
-    def protocol_error(self, exception):
-        # Whatever the error is, we're done with this request.
-        self.finished_reading = True
-        self._medium_request.finished_reading()
-        raise
-        
-    def read_response_tuple(self, expect_body=False):
-        """Read a response tuple from the wire."""
-        self._wait_for_response_args()
-        if not expect_body:
-            self._wait_for_response_end()
-        if 'hpss' in debug.debug_flags:
-            mutter('   result:   %r', self.args)
-        if self.status == 'E':
-            self._wait_for_response_end()
-            _translate_error(self.args)
-        return tuple(self.args)
-
-    def read_body_bytes(self, count=-1):
-        """Read bytes from the body, decoding into a byte stream.
-        
-        We read all bytes at once to ensure we've checked the trailer for 
-        errors, and then feed the buffer back as read_body_bytes is called.
-
-        Like the builtin file.read in Python, a count of -1 (the default) means
-        read the entire body.
-        """
-        # TODO: we don't necessarily need to buffer the full request if count
-        # != -1.  (2008/04/30, Andrew Bennetts)
-        if self._body is None:
-            self._wait_for_response_end()
-            body_bytes = ''.join(self._bytes_parts)
-            if 'hpss' in debug.debug_flags:
-                mutter('              %d body bytes read', len(body_bytes))
-            self._body = StringIO(body_bytes)
-            self._bytes_parts = None
-        return self._body.read(count)
-
-    def read_streamed_body(self):
-        while not self.finished_reading:
-            while self._bytes_parts:
-                bytes_part = self._bytes_parts.popleft()
-                if 'hpss' in debug.debug_flags:
-                    mutter('              %d byte part read', len(bytes_part))
-                yield bytes_part
-            self._read_more()
-        if self._body_stream_status == 'E':
-            _translate_error(self._body_error_args)
-
-    def cancel_read_body(self):
-        self._wait_for_response_end()
-
-
-def _translate_error(error_tuple):
-    # Many exceptions need some state from the requestor to be properly
-    # translated (e.g. they need a branch object).  So this only translates a
-    # few errors, and the rest are turned into a generic ErrorFromSmartServer.
-    error_name = error_tuple[0]
-    error_args = error_tuple[1:]
-    if error_name == 'UnknownMethod':
-        raise errors.UnknownSmartMethod(error_args[0])
-    if error_name == 'LockContention':
-        raise errors.LockContention('(remote lock)')
-    elif error_name == 'LockFailed':
-        raise errors.LockFailed(*error_args[:2])
-    else:
-        raise errors.ErrorFromSmartServer(error_tuple)

=== modified file 'bzrlib/smart/protocol.py'
--- bzrlib/smart/protocol.py	2008-08-29 19:32:00 +0000
+++ bzrlib/smart/protocol.py	2007-08-13 01:04:05 +0000
@@ -18,18 +18,13 @@
 client and server.
 """
 
-import collections
 from cStringIO import StringIO
-import struct
-import sys
 import time
 
-import bzrlib
 from bzrlib import debug
 from bzrlib import errors
-from bzrlib.smart import message, request
+from bzrlib.smart import request
 from bzrlib.trace import log_exception_quietly, mutter
-from bzrlib.util.bencode import bdecode, bencode
 
 
 # Protocol version strings.  These are sent as prefixes of bzr requests and
@@ -38,9 +33,6 @@
 REQUEST_VERSION_TWO = 'bzr request 2\n'
 RESPONSE_VERSION_TWO = 'bzr response 2\n'
 
-MESSAGE_VERSION_THREE = 'bzr message 3 (bzr 1.6)\n'
-RESPONSE_VERSION_THREE = REQUEST_VERSION_THREE = MESSAGE_VERSION_THREE
-
 
 def _recv_tuple(from_file):
     req_line = from_file.readline()
@@ -48,7 +40,7 @@
 
 
 def _decode_tuple(req_line):
-    if req_line is None or req_line == '':
+    if req_line == None or req_line == '':
         return None
     if req_line[-1] != '\n':
         raise errors.SmartProtocolError("request %r not terminated" % req_line)
@@ -60,40 +52,6 @@
     return '\x01'.join(args) + '\n'
 
 
-class Requester(object):
-    """Abstract base class for an object that can issue requests on a smart
-    medium.
-    """
-
-    def call(self, *args):
-        """Make a remote call.
-
-        :param args: the arguments of this call.
-        """
-        raise NotImplementedError(self.call)
-
-    def call_with_body_bytes(self, args, body):
-        """Make a remote call with a body.
-
-        :param args: the arguments of this call.
-        :type body: str
-        :param body: the body to send with the request.
-        """
-        raise NotImplementedError(self.call_with_body_bytes)
-
-    def call_with_body_readv_array(self, args, body):
-        """Make a remote call with a readv array.
-
-        :param args: the arguments of this call.
-        :type body: iterable of (start, length) tuples.
-        :param body: the readv ranges to send with this request.
-        """
-        raise NotImplementedError(self.call_with_body_readv_array)
-
-    def set_headers(self, headers):
-        raise NotImplementedError(self.set_headers)
-
-
 class SmartProtocolBase(object):
     """Methods common to client and server"""
 
@@ -114,13 +72,12 @@
 class SmartServerRequestProtocolOne(SmartProtocolBase):
     """Server-side encoding and decoding logic for smart version 1."""
     
-    def __init__(self, backing_transport, write_func, root_client_path='/'):
+    def __init__(self, backing_transport, write_func):
         self._backing_transport = backing_transport
-        self._root_client_path = root_client_path
-        self.unused_data = ''
+        self.excess_buffer = ''
         self._finished = False
         self.in_buffer = ''
-        self._has_dispatched = False
+        self.has_dispatched = False
         self.request = None
         self._body_decoder = None
         self._write_func = write_func
@@ -130,36 +87,27 @@
         
         :param bytes: must be a byte string
         """
-        if not isinstance(bytes, str):
-            raise ValueError(bytes)
+        assert isinstance(bytes, str)
         self.in_buffer += bytes
-        if not self._has_dispatched:
+        if not self.has_dispatched:
             if '\n' not in self.in_buffer:
                 # no command line yet
                 return
-            self._has_dispatched = True
+            self.has_dispatched = True
             try:
                 first_line, self.in_buffer = self.in_buffer.split('\n', 1)
                 first_line += '\n'
                 req_args = _decode_tuple(first_line)
                 self.request = request.SmartServerRequestHandler(
-                    self._backing_transport, commands=request.request_handlers,
-                    root_client_path=self._root_client_path)
+                    self._backing_transport, commands=request.request_handlers)
                 self.request.dispatch_command(req_args[0], req_args[1:])
                 if self.request.finished_reading:
                     # trivial request
-                    self.unused_data = self.in_buffer
+                    self.excess_buffer = self.in_buffer
                     self.in_buffer = ''
                     self._send_response(self.request.response)
             except KeyboardInterrupt:
                 raise
-            except errors.UnknownSmartMethod, err:
-                protocol_error = errors.SmartProtocolError(
-                    "bad request %r" % (err.verb,))
-                failure = request.FailedSmartServerResponse(
-                    ('error', str(protocol_error)))
-                self._send_response(failure)
-                return
             except Exception, exception:
                 # everything else: pass to client, flush, and quit
                 log_exception_quietly()
@@ -167,11 +115,11 @@
                     ('error', str(exception))))
                 return
 
-        if self._has_dispatched:
+        if self.has_dispatched:
             if self._finished:
                 # nothing to do.XXX: this routine should be a single state 
                 # machine too.
-                self.unused_data += self.in_buffer
+                self.excess_buffer += self.in_buffer
                 self.in_buffer = ''
                 return
             if self._body_decoder is None:
@@ -182,21 +130,19 @@
             self.request.accept_body(body_data)
             if self._body_decoder.finished_reading:
                 self.request.end_of_body()
-                if not self.request.finished_reading:
-                    raise AssertionError("no more body, request not finished")
+                assert self.request.finished_reading, \
+                    "no more body, request not finished"
             if self.request.response is not None:
                 self._send_response(self.request.response)
-                self.unused_data = self.in_buffer
+                self.excess_buffer = self.in_buffer
                 self.in_buffer = ''
             else:
-                if self.request.finished_reading:
-                    raise AssertionError(
-                        "no response and we have finished reading.")
+                assert not self.request.finished_reading, \
+                    "no response and we have finished reading."
 
     def _send_response(self, response):
         """Send a smart server response down the output stream."""
-        if self._finished:
-            raise AssertionError('response already sent')
+        assert not self._finished, 'response already sent'
         args = response.args
         body = response.body
         self._finished = True
@@ -204,8 +150,7 @@
         self._write_success_or_failure_prefix(response)
         self._write_func(_encode_tuple(args))
         if body is not None:
-            if not isinstance(body, str):
-                raise ValueError(body)
+            assert isinstance(body, str), 'body must be a str'
             bytes = self._encode_bulk_data(body)
             self._write_func(bytes)
 
@@ -238,9 +183,6 @@
     This prefixes responses with the value of RESPONSE_VERSION_TWO.
     """
 
-    response_marker = RESPONSE_VERSION_TWO
-    request_marker = REQUEST_VERSION_TWO
-
     def _write_success_or_failure_prefix(self, response):
         """Write the protocol specific success/failure prefix."""
         if response.is_successful():
@@ -253,120 +195,21 @@
         
         Version two sends the value of RESPONSE_VERSION_TWO.
         """
-        self._write_func(self.response_marker)
-
-    def _send_response(self, response):
-        """Send a smart server response down the output stream."""
-        if (self._finished):
-            raise AssertionError('response already sent')
-        self._finished = True
-        self._write_protocol_version()
-        self._write_success_or_failure_prefix(response)
-        self._write_func(_encode_tuple(response.args))
-        if response.body is not None:
-            if not isinstance(response.body, str):
-                raise AssertionError('body must be a str')
-            if not (response.body_stream is None):
-                raise AssertionError(
-                    'body_stream and body cannot both be set')
-            bytes = self._encode_bulk_data(response.body)
-            self._write_func(bytes)
-        elif response.body_stream is not None:
-            _send_stream(response.body_stream, self._write_func)
-
-
-def _send_stream(stream, write_func):
-    write_func('chunked\n')
-    _send_chunks(stream, write_func)
-    write_func('END\n')
-
-
-def _send_chunks(stream, write_func):
-    for chunk in stream:
-        if isinstance(chunk, str):
-            bytes = "%x\n%s" % (len(chunk), chunk)
-            write_func(bytes)
-        elif isinstance(chunk, request.FailedSmartServerResponse):
-            write_func('ERR\n')
-            _send_chunks(chunk.args, write_func)
-            return
-        else:
-            raise errors.BzrError(
-                'Chunks must be str or FailedSmartServerResponse, got %r'
-                % chunk)
-
-
-class _NeedMoreBytes(Exception):
-    """Raise this inside a _StatefulDecoder to stop decoding until more bytes
-    have been received.
-    """
-
-    def __init__(self, count=None):
-        """Constructor.
-
-        :param count: the total number of bytes needed by the current state.
-            May be None if the number of bytes needed is unknown.
-        """
-        self.count = count
-
-
-class _StatefulDecoder(object):
-    """Base class for writing state machines to decode byte streams.
-
-    Subclasses should provide a self.state_accept attribute that accepts bytes
-    and, if appropriate, updates self.state_accept to a different function.
-    accept_bytes will call state_accept as often as necessary to make sure the
-    state machine has progressed as far as possible before it returns.
-
-    See ProtocolThreeDecoder for an example subclass.
-    """
-
+        self._write_func(RESPONSE_VERSION_TWO)
+
+
+class LengthPrefixedBodyDecoder(object):
+    """Decodes the length-prefixed bulk data."""
+    
     def __init__(self):
+        self.bytes_left = None
         self.finished_reading = False
-        self._in_buffer_list = []
-        self._in_buffer_len = 0
         self.unused_data = ''
-        self.bytes_left = None
-        self._number_needed_bytes = None
-
-    def _get_in_buffer(self):
-        if len(self._in_buffer_list) == 1:
-            return self._in_buffer_list[0]
-        in_buffer = ''.join(self._in_buffer_list)
-        if len(in_buffer) != self._in_buffer_len:
-            raise AssertionError(
-                "Length of buffer did not match expected value: %s != %s"
-                % self._in_buffer_len, len(in_buffer))
-        self._in_buffer_list = [in_buffer]
-        return in_buffer
-
-    def _get_in_bytes(self, count):
-        """Grab X bytes from the input_buffer.
-
-        Callers should have already checked that self._in_buffer_len is >
-        count. Note, this does not consume the bytes from the buffer. The
-        caller will still need to call _get_in_buffer() and then
-        _set_in_buffer() if they actually need to consume the bytes.
-        """
-        # check if we can yield the bytes from just the first entry in our list
-        if len(self._in_buffer_list) == 0:
-            raise AssertionError('Callers must be sure we have buffered bytes'
-                ' before calling _get_in_bytes')
-        if len(self._in_buffer_list[0]) > count:
-            return self._in_buffer_list[0][:count]
-        # We can't yield it from the first buffer, so collapse all buffers, and
-        # yield it from that
-        in_buf = self._get_in_buffer()
-        return in_buf[:count]
-
-    def _set_in_buffer(self, new_buf):
-        if new_buf is not None:
-            self._in_buffer_list = [new_buf]
-            self._in_buffer_len = len(new_buf)
-        else:
-            self._in_buffer_list = []
-            self._in_buffer_len = 0
-
+        self.state_accept = self._state_accept_expecting_length
+        self.state_read = self._state_read_no_data
+        self._in_buffer = ''
+        self._trailer_buffer = ''
+    
     def accept_bytes(self, bytes):
         """Decode as much of bytes as possible.
 
@@ -377,152 +220,12 @@
         data will be appended to self.unused_data.
         """
         # accept_bytes is allowed to change the state
-        self._number_needed_bytes = None
-        # lsprof puts a very large amount of time on this specific call for
-        # large readv arrays
-        self._in_buffer_list.append(bytes)
-        self._in_buffer_len += len(bytes)
-        try:
-            # Run the function for the current state.
+        current_state = self.state_accept
+        self.state_accept(bytes)
+        while current_state != self.state_accept:
             current_state = self.state_accept
-            self.state_accept()
-            while current_state != self.state_accept:
-                # The current state has changed.  Run the function for the new
-                # current state, so that it can:
-                #   - decode any unconsumed bytes left in a buffer, and
-                #   - signal how many more bytes are expected (via raising
-                #     _NeedMoreBytes).
-                current_state = self.state_accept
-                self.state_accept()
-        except _NeedMoreBytes, e:
-            self._number_needed_bytes = e.count
-
-
-class ChunkedBodyDecoder(_StatefulDecoder):
-    """Decoder for chunked body data.
-
-    This is very similar the HTTP's chunked encoding.  See the description of
-    streamed body data in `doc/developers/network-protocol.txt` for details.
-    """
-
-    def __init__(self):
-        _StatefulDecoder.__init__(self)
-        self.state_accept = self._state_accept_expecting_header
-        self.chunk_in_progress = None
-        self.chunks = collections.deque()
-        self.error = False
-        self.error_in_progress = None
-    
-    def next_read_size(self):
-        # Note: the shortest possible chunk is 2 bytes: '0\n', and the
-        # end-of-body marker is 4 bytes: 'END\n'.
-        if self.state_accept == self._state_accept_reading_chunk:
-            # We're expecting more chunk content.  So we're expecting at least
-            # the rest of this chunk plus an END chunk.
-            return self.bytes_left + 4
-        elif self.state_accept == self._state_accept_expecting_length:
-            if self._in_buffer_len == 0:
-                # We're expecting a chunk length.  There's at least two bytes
-                # left: a digit plus '\n'.
-                return 2
-            else:
-                # We're in the middle of reading a chunk length.  So there's at
-                # least one byte left, the '\n' that terminates the length.
-                return 1
-        elif self.state_accept == self._state_accept_reading_unused:
-            return 1
-        elif self.state_accept == self._state_accept_expecting_header:
-            return max(0, len('chunked\n') - self._in_buffer_len)
-        else:
-            raise AssertionError("Impossible state: %r" % (self.state_accept,))
-
-    def read_next_chunk(self):
-        try:
-            return self.chunks.popleft()
-        except IndexError:
-            return None
-
-    def _extract_line(self):
-        in_buf = self._get_in_buffer()
-        pos = in_buf.find('\n')
-        if pos == -1:
-            # We haven't read a complete line yet, so request more bytes before
-            # we continue.
-            raise _NeedMoreBytes(1)
-        line = in_buf[:pos]
-        # Trim the prefix (including '\n' delimiter) from the _in_buffer.
-        self._set_in_buffer(in_buf[pos+1:])
-        return line
-
-    def _finished(self):
-        self.unused_data = self._get_in_buffer()
-        # self._in_buffer = None
-        self._in_buffer_list = []
-        self._in_buffer_len = 0
-        self.state_accept = self._state_accept_reading_unused
-        if self.error:
-            error_args = tuple(self.error_in_progress)
-            self.chunks.append(request.FailedSmartServerResponse(error_args))
-            self.error_in_progress = None
-        self.finished_reading = True
-
-    def _state_accept_expecting_header(self):
-        prefix = self._extract_line()
-        if prefix == 'chunked':
-            self.state_accept = self._state_accept_expecting_length
-        else:
-            raise errors.SmartProtocolError(
-                'Bad chunked body header: "%s"' % (prefix,))
-
-    def _state_accept_expecting_length(self):
-        prefix = self._extract_line()
-        if prefix == 'ERR':
-            self.error = True
-            self.error_in_progress = []
-            self._state_accept_expecting_length()
-            return
-        elif prefix == 'END':
-            # We've read the end-of-body marker.
-            # Any further bytes are unused data, including the bytes left in
-            # the _in_buffer.
-            self._finished()
-            return
-        else:
-            self.bytes_left = int(prefix, 16)
-            self.chunk_in_progress = ''
-            self.state_accept = self._state_accept_reading_chunk
-
-    def _state_accept_reading_chunk(self):
-        in_buf = self._get_in_buffer()
-        in_buffer_len = len(in_buf)
-        self.chunk_in_progress += in_buf[:self.bytes_left]
-        self._set_in_buffer(in_buf[self.bytes_left:])
-        self.bytes_left -= in_buffer_len
-        if self.bytes_left <= 0:
-            # Finished with chunk
-            self.bytes_left = None
-            if self.error:
-                self.error_in_progress.append(self.chunk_in_progress)
-            else:
-                self.chunks.append(self.chunk_in_progress)
-            self.chunk_in_progress = None
-            self.state_accept = self._state_accept_expecting_length
-        
-    def _state_accept_reading_unused(self):
-        self.unused_data += self._get_in_buffer()
-        self._in_buffer_list = []
-
-
-class LengthPrefixedBodyDecoder(_StatefulDecoder):
-    """Decodes the length-prefixed bulk data."""
-    
-    def __init__(self):
-        _StatefulDecoder.__init__(self)
-        self.state_accept = self._state_accept_expecting_length
-        self.state_read = self._state_read_no_data
-        self._body = ''
-        self._trailer_buffer = ''
-    
+            self.state_accept('')
+
     def next_read_size(self):
         if self.bytes_left is not None:
             # Ideally we want to read all the remainder of the body and the
@@ -543,32 +246,30 @@
         """Return any pending data that has been decoded."""
         return self.state_read()
 
-    def _state_accept_expecting_length(self):
-        in_buf = self._get_in_buffer()
-        pos = in_buf.find('\n')
+    def _state_accept_expecting_length(self, bytes):
+        self._in_buffer += bytes
+        pos = self._in_buffer.find('\n')
         if pos == -1:
             return
-        self.bytes_left = int(in_buf[:pos])
-        self._set_in_buffer(in_buf[pos+1:])
+        self.bytes_left = int(self._in_buffer[:pos])
+        self._in_buffer = self._in_buffer[pos+1:]
+        self.bytes_left -= len(self._in_buffer)
         self.state_accept = self._state_accept_reading_body
-        self.state_read = self._state_read_body_buffer
+        self.state_read = self._state_read_in_buffer
 
-    def _state_accept_reading_body(self):
-        in_buf = self._get_in_buffer()
-        self._body += in_buf
-        self.bytes_left -= len(in_buf)
-        self._set_in_buffer(None)
+    def _state_accept_reading_body(self, bytes):
+        self._in_buffer += bytes
+        self.bytes_left -= len(bytes)
         if self.bytes_left <= 0:
             # Finished with body
             if self.bytes_left != 0:
-                self._trailer_buffer = self._body[self.bytes_left:]
-                self._body = self._body[:self.bytes_left]
+                self._trailer_buffer = self._in_buffer[self.bytes_left:]
+                self._in_buffer = self._in_buffer[:self.bytes_left]
             self.bytes_left = None
             self.state_accept = self._state_accept_reading_trailer
         
-    def _state_accept_reading_trailer(self):
-        self._trailer_buffer += self._get_in_buffer()
-        self._set_in_buffer(None)
+    def _state_accept_reading_trailer(self, bytes):
+        self._trailer_buffer += bytes
         # TODO: what if the trailer does not match "done\n"?  Should this raise
         # a ProtocolViolation exception?
         if self._trailer_buffer.startswith('done\n'):
@@ -576,21 +277,19 @@
             self.state_accept = self._state_accept_reading_unused
             self.finished_reading = True
     
-    def _state_accept_reading_unused(self):
-        self.unused_data += self._get_in_buffer()
-        self._set_in_buffer(None)
+    def _state_accept_reading_unused(self, bytes):
+        self.unused_data += bytes
 
     def _state_read_no_data(self):
         return ''
 
-    def _state_read_body_buffer(self):
-        result = self._body
-        self._body = ''
+    def _state_read_in_buffer(self):
+        result = self._in_buffer
+        self._in_buffer = ''
         return result
 
 
-class SmartClientRequestProtocolOne(SmartProtocolBase, Requester,
-                                    message.ResponseHandler):
+class SmartClientRequestProtocolOne(SmartProtocolBase):
     """The client-side protocol for smart version 1."""
 
     def __init__(self, request):
@@ -602,21 +301,13 @@
         self._request = request
         self._body_buffer = None
         self._request_start_time = None
-        self._last_verb = None
-        self._headers = None
-
-    def set_headers(self, headers):
-        self._headers = dict(headers)
 
     def call(self, *args):
         if 'hpss' in debug.debug_flags:
             mutter('hpss call:   %s', repr(args)[1:-1])
-            if getattr(self._request._medium, 'base', None) is not None:
-                mutter('             (to %s)', self._request._medium.base)
             self._request_start_time = time.time()
         self._write_args(args)
         self._request.finished_writing()
-        self._last_verb = args[0]
 
     def call_with_body_bytes(self, args, body):
         """Make a remote call of args with body bytes 'body'.
@@ -625,17 +316,12 @@
         """
         if 'hpss' in debug.debug_flags:
             mutter('hpss call w/body: %s (%r...)', repr(args)[1:-1], body[:20])
-            if getattr(self._request._medium, '_path', None) is not None:
-                mutter('                  (to %s)', self._request._medium._path)
             mutter('              %d bytes', len(body))
             self._request_start_time = time.time()
-            if 'hpssdetail' in debug.debug_flags:
-                mutter('hpss body content: %s', body)
         self._write_args(args)
         bytes = self._encode_bulk_data(body)
         self._request.accept_bytes(bytes)
         self._request.finished_writing()
-        self._last_verb = args[0]
 
     def call_with_body_readv_array(self, args, body):
         """Make a remote call with a readv array.
@@ -645,8 +331,6 @@
         """
         if 'hpss' in debug.debug_flags:
             mutter('hpss call w/readv: %s', repr(args)[1:-1])
-            if getattr(self._request._medium, '_path', None) is not None:
-                mutter('                  (to %s)', self._request._medium._path)
             self._request_start_time = time.time()
         self._write_args(args)
         readv_bytes = self._serialise_offsets(body)
@@ -655,7 +339,6 @@
         self._request.finished_writing()
         if 'hpss' in debug.debug_flags:
             mutter('              %d bytes in readv request', len(readv_bytes))
-        self._last_verb = args[0]
 
     def cancel_read_body(self):
         """After expecting a body, a response code may indicate one otherwise.
@@ -666,7 +349,11 @@
         """
         self._request.finished_reading()
 
-    def _read_response_tuple(self):
+    def read_response_tuple(self, expect_body=False):
+        """Read a response tuple from the wire.
+
+        This should only be called once.
+        """
         result = self._recv_tuple()
         if 'hpss' in debug.debug_flags:
             if self._request_start_time is not None:
@@ -676,66 +363,10 @@
                 self._request_start_time = None
             else:
                 mutter('   result:   %s', repr(result)[1:-1])
-        return result
-
-    def read_response_tuple(self, expect_body=False):
-        """Read a response tuple from the wire.
-
-        This should only be called once.
-        """
-        result = self._read_response_tuple()
-        self._response_is_unknown_method(result)
-        self._raise_args_if_error(result)
         if not expect_body:
             self._request.finished_reading()
         return result
 
-    def _raise_args_if_error(self, result_tuple):
-        # Later protocol versions have an explicit flag in the protocol to say
-        # if an error response is "failed" or not.  In version 1 we don't have
-        # that luxury.  So here is a complete list of errors that can be
-        # returned in response to existing version 1 smart requests.  Responses
-        # starting with these codes are always "failed" responses.
-        v1_error_codes = [
-            'norepository',
-            'NoSuchFile',
-            'FileExists',
-            'DirectoryNotEmpty',
-            'ShortReadvError',
-            'UnicodeEncodeError',
-            'UnicodeDecodeError',
-            'ReadOnlyError',
-            'nobranch',
-            'NoSuchRevision',
-            'nosuchrevision',
-            'LockContention',
-            'UnlockableTransport',
-            'LockFailed',
-            'TokenMismatch',
-            'ReadError',
-            'PermissionDenied',
-            ]
-        if result_tuple[0] in v1_error_codes:
-            self._request.finished_reading()
-            raise errors.ErrorFromSmartServer(result_tuple)
-
-    def _response_is_unknown_method(self, result_tuple):
-        """Raise UnexpectedSmartServerResponse if the response is an 'unknonwn
-        method' response to the request.
-        
-        :param response: The response from a smart client call_expecting_body
-            call.
-        :param verb: The verb used in that call.
-        :raises: UnexpectedSmartServerResponse
-        """
-        if (result_tuple == ('error', "Generic bzr smart protocol error: "
-                "bad request '%s'" % self._last_verb) or
-              result_tuple == ('error', "Generic bzr smart protocol error: "
-                "bad request u'%s'" % self._last_verb)):
-            # The response will have no body, so we've finished reading.
-            self._request.finished_reading()
-            raise errors.UnknownSmartMethod(self._last_verb)
-        
     def read_body_bytes(self, count=-1):
         """Read bytes from the body, decoding into a byte stream.
         
@@ -747,11 +378,8 @@
         _body_decoder = LengthPrefixedBodyDecoder()
 
         while not _body_decoder.finished_reading:
-            bytes = self._request.read_bytes(_body_decoder.next_read_size())
-            if bytes == '':
-                # end of file encountered reading from server
-                raise errors.ConnectionReset(
-                    "Connection lost while reading response body.")
+            bytes_wanted = _body_decoder.next_read_size()
+            bytes = self._request.read_bytes(bytes_wanted)
             _body_decoder.accept_bytes(bytes)
         self._request.finished_reading()
         self._body_buffer = StringIO(_body_decoder.read_pending_data())
@@ -763,7 +391,17 @@
 
     def _recv_tuple(self):
         """Receive a tuple from the medium request."""
-        return _decode_tuple(self._request.read_line())
+        return _decode_tuple(self._recv_line())
+
+    def _recv_line(self):
+        """Read an entire line from the medium request."""
+        line = ''
+        while not line or line[-1] != '\n':
+            # TODO: this is inefficient - but tuples are short.
+            new_char = self._request.read_bytes(1)
+            line += new_char
+            assert new_char != '', "end of file reading from server."
+        return line
 
     def query_version(self):
         """Return protocol version number of the server."""
@@ -794,427 +432,25 @@
     This prefixes the request with the value of REQUEST_VERSION_TWO.
     """
 
-    response_marker = RESPONSE_VERSION_TWO
-    request_marker = REQUEST_VERSION_TWO
-
     def read_response_tuple(self, expect_body=False):
         """Read a response tuple from the wire.
 
         This should only be called once.
         """
         version = self._request.read_line()
-        if version != self.response_marker:
-            self._request.finished_reading()
-            raise errors.UnexpectedProtocolVersionMarker(version)
-        response_status = self._request.read_line()
-        result = SmartClientRequestProtocolOne._read_response_tuple(self)
-        self._response_is_unknown_method(result)
-        if response_status == 'success\n':
-            self.response_status = True
-            if not expect_body:
-                self._request.finished_reading()
-            return result
-        elif response_status == 'failed\n':
-            self.response_status = False
-            self._request.finished_reading()
-            raise errors.ErrorFromSmartServer(result)
-        else:
+        if version != RESPONSE_VERSION_TWO:
+            raise errors.SmartProtocolError('bad protocol marker %r' % version)
+        response_status = self._recv_line()
+        if response_status not in ('success\n', 'failed\n'):
             raise errors.SmartProtocolError(
                 'bad protocol status %r' % response_status)
+        self.response_status = response_status == 'success\n'
+        return SmartClientRequestProtocolOne.read_response_tuple(self, expect_body)
 
     def _write_protocol_version(self):
-        """Write any prefixes this protocol requires.
+        r"""Write any prefixes this protocol requires.
         
         Version two sends the value of REQUEST_VERSION_TWO.
         """
-        self._request.accept_bytes(self.request_marker)
-
-    def read_streamed_body(self):
-        """Read bytes from the body, decoding into a byte stream.
-        """
-        # Read no more than 64k at a time so that we don't risk error 10055 (no
-        # buffer space available) on Windows.
-        _body_decoder = ChunkedBodyDecoder()
-        while not _body_decoder.finished_reading:
-            bytes = self._request.read_bytes(_body_decoder.next_read_size())
-            if bytes == '':
-                # end of file encountered reading from server
-                raise errors.ConnectionReset(
-                    "Connection lost while reading streamed body.")
-            _body_decoder.accept_bytes(bytes)
-            for body_bytes in iter(_body_decoder.read_next_chunk, None):
-                if 'hpss' in debug.debug_flags and type(body_bytes) is str:
-                    mutter('              %d byte chunk read',
-                           len(body_bytes))
-                yield body_bytes
-        self._request.finished_reading()
-
-
-def build_server_protocol_three(backing_transport, write_func,
-                                root_client_path):
-    request_handler = request.SmartServerRequestHandler(
-        backing_transport, commands=request.request_handlers,
-        root_client_path=root_client_path)
-    responder = ProtocolThreeResponder(write_func)
-    message_handler = message.ConventionalRequestHandler(request_handler, responder)
-    return ProtocolThreeDecoder(message_handler)
-
-
-class ProtocolThreeDecoder(_StatefulDecoder):
-
-    response_marker = RESPONSE_VERSION_THREE
-    request_marker = REQUEST_VERSION_THREE
-
-    def __init__(self, message_handler, expect_version_marker=False):
-        _StatefulDecoder.__init__(self)
-        self._has_dispatched = False
-        # Initial state
-        if expect_version_marker:
-            self.state_accept = self._state_accept_expecting_protocol_version
-            # We're expecting at least the protocol version marker + some
-            # headers.
-            self._number_needed_bytes = len(MESSAGE_VERSION_THREE) + 4
-        else:
-            self.state_accept = self._state_accept_expecting_headers
-            self._number_needed_bytes = 4
-        self.decoding_failed = False
-        self.request_handler = self.message_handler = message_handler
-
-    def accept_bytes(self, bytes):
-        self._number_needed_bytes = None
-        try:
-            _StatefulDecoder.accept_bytes(self, bytes)
-        except KeyboardInterrupt:
-            raise
-        except errors.SmartMessageHandlerError, exception:
-            # We do *not* set self.decoding_failed here.  The message handler
-            # has raised an error, but the decoder is still able to parse bytes
-            # and determine when this message ends.
-            log_exception_quietly()
-            self.message_handler.protocol_error(exception.exc_value)
-            # The state machine is ready to continue decoding, but the
-            # exception has interrupted the loop that runs the state machine.
-            # So we call accept_bytes again to restart it.
-            self.accept_bytes('')
-        except Exception, exception:
-            # The decoder itself has raised an exception.  We cannot continue
-            # decoding.
-            self.decoding_failed = True
-            if isinstance(exception, errors.UnexpectedProtocolVersionMarker):
-                # This happens during normal operation when the client tries a
-                # protocol version the server doesn't understand, so no need to
-                # log a traceback every time.
-                # Note that this can only happen when
-                # expect_version_marker=True, which is only the case on the
-                # client side.
-                pass
-            else:
-                log_exception_quietly()
-            self.message_handler.protocol_error(exception)
-
-    def _extract_length_prefixed_bytes(self):
-        if self._in_buffer_len < 4:
-            # A length prefix by itself is 4 bytes, and we don't even have that
-            # many yet.
-            raise _NeedMoreBytes(4)
-        (length,) = struct.unpack('!L', self._get_in_bytes(4))
-        end_of_bytes = 4 + length
-        if self._in_buffer_len < end_of_bytes:
-            # We haven't yet read as many bytes as the length-prefix says there
-            # are.
-            raise _NeedMoreBytes(end_of_bytes)
-        # Extract the bytes from the buffer.
-        in_buf = self._get_in_buffer()
-        bytes = in_buf[4:end_of_bytes]
-        self._set_in_buffer(in_buf[end_of_bytes:])
-        return bytes
-
-    def _extract_prefixed_bencoded_data(self):
-        prefixed_bytes = self._extract_length_prefixed_bytes()
-        try:
-            decoded = bdecode(prefixed_bytes)
-        except ValueError:
-            raise errors.SmartProtocolError(
-                'Bytes %r not bencoded' % (prefixed_bytes,))
-        return decoded
-
-    def _extract_single_byte(self):
-        if self._in_buffer_len == 0:
-            # The buffer is empty
-            raise _NeedMoreBytes(1)
-        in_buf = self._get_in_buffer()
-        one_byte = in_buf[0]
-        self._set_in_buffer(in_buf[1:])
-        return one_byte
-
-    def _state_accept_expecting_protocol_version(self):
-        needed_bytes = len(MESSAGE_VERSION_THREE) - self._in_buffer_len
-        in_buf = self._get_in_buffer()
-        if needed_bytes > 0:
-            # We don't have enough bytes to check if the protocol version
-            # marker is right.  But we can check if it is already wrong by
-            # checking that the start of MESSAGE_VERSION_THREE matches what
-            # we've read so far.
-            # [In fact, if the remote end isn't bzr we might never receive
-            # len(MESSAGE_VERSION_THREE) bytes.  So if the bytes we have so far
-            # are wrong then we should just raise immediately rather than
-            # stall.]
-            if not MESSAGE_VERSION_THREE.startswith(in_buf):
-                # We have enough bytes to know the protocol version is wrong
-                raise errors.UnexpectedProtocolVersionMarker(in_buf)
-            raise _NeedMoreBytes(len(MESSAGE_VERSION_THREE))
-        if not in_buf.startswith(MESSAGE_VERSION_THREE):
-            raise errors.UnexpectedProtocolVersionMarker(in_buf)
-        self._set_in_buffer(in_buf[len(MESSAGE_VERSION_THREE):])
-        self.state_accept = self._state_accept_expecting_headers
-
-    def _state_accept_expecting_headers(self):
-        decoded = self._extract_prefixed_bencoded_data()
-        if type(decoded) is not dict:
-            raise errors.SmartProtocolError(
-                'Header object %r is not a dict' % (decoded,))
-        self.state_accept = self._state_accept_expecting_message_part
-        try:
-            self.message_handler.headers_received(decoded)
-        except:
-            raise errors.SmartMessageHandlerError(sys.exc_info())
-    
-    def _state_accept_expecting_message_part(self):
-        message_part_kind = self._extract_single_byte()
-        if message_part_kind == 'o':
-            self.state_accept = self._state_accept_expecting_one_byte
-        elif message_part_kind == 's':
-            self.state_accept = self._state_accept_expecting_structure
-        elif message_part_kind == 'b':
-            self.state_accept = self._state_accept_expecting_bytes
-        elif message_part_kind == 'e':
-            self.done()
-        else:
-            raise errors.SmartProtocolError(
-                'Bad message kind byte: %r' % (message_part_kind,))
-
-    def _state_accept_expecting_one_byte(self):
-        byte = self._extract_single_byte()
-        self.state_accept = self._state_accept_expecting_message_part
-        try:
-            self.message_handler.byte_part_received(byte)
-        except:
-            raise errors.SmartMessageHandlerError(sys.exc_info())
-
-    def _state_accept_expecting_bytes(self):
-        # XXX: this should not buffer whole message part, but instead deliver
-        # the bytes as they arrive.
-        prefixed_bytes = self._extract_length_prefixed_bytes()
-        self.state_accept = self._state_accept_expecting_message_part
-        try:
-            self.message_handler.bytes_part_received(prefixed_bytes)
-        except:
-            raise errors.SmartMessageHandlerError(sys.exc_info())
-
-    def _state_accept_expecting_structure(self):
-        structure = self._extract_prefixed_bencoded_data()
-        self.state_accept = self._state_accept_expecting_message_part
-        try:
-            self.message_handler.structure_part_received(structure)
-        except:
-            raise errors.SmartMessageHandlerError(sys.exc_info())
-
-    def done(self):
-        self.unused_data = self._get_in_buffer()
-        self._set_in_buffer(None)
-        self.state_accept = self._state_accept_reading_unused
-        try:
-            self.message_handler.end_received()
-        except:
-            raise errors.SmartMessageHandlerError(sys.exc_info())
-
-    def _state_accept_reading_unused(self):
-        self.unused_data = self._get_in_buffer()
-        self._set_in_buffer(None)
-
-    def next_read_size(self):
-        if self.state_accept == self._state_accept_reading_unused:
-            return 0
-        elif self.decoding_failed:
-            # An exception occured while processing this message, probably from
-            # self.message_handler.  We're not sure that this state machine is
-            # in a consistent state, so just signal that we're done (i.e. give
-            # up).
-            return 0
-        else:
-            if self._number_needed_bytes is not None:
-                return self._number_needed_bytes - self._in_buffer_len
-            else:
-                raise AssertionError("don't know how many bytes are expected!")
-
-
-class _ProtocolThreeEncoder(object):
-
-    response_marker = request_marker = MESSAGE_VERSION_THREE
-
-    def __init__(self, write_func):
-        self._buf = ''
-        self._real_write_func = write_func
-
-    def _write_func(self, bytes):
-        self._buf += bytes
-
-    def flush(self):
-        if self._buf:
-            self._real_write_func(self._buf)
-            self._buf = ''
-
-    def _serialise_offsets(self, offsets):
-        """Serialise a readv offset list."""
-        txt = []
-        for start, length in offsets:
-            txt.append('%d,%d' % (start, length))
-        return '\n'.join(txt)
-        
-    def _write_protocol_version(self):
-        self._write_func(MESSAGE_VERSION_THREE)
-
-    def _write_prefixed_bencode(self, structure):
-        bytes = bencode(structure)
-        self._write_func(struct.pack('!L', len(bytes)))
-        self._write_func(bytes)
-
-    def _write_headers(self, headers):
-        self._write_prefixed_bencode(headers)
-
-    def _write_structure(self, args):
-        self._write_func('s')
-        utf8_args = []
-        for arg in args:
-            if type(arg) is unicode:
-                utf8_args.append(arg.encode('utf8'))
-            else:
-                utf8_args.append(arg)
-        self._write_prefixed_bencode(utf8_args)
-
-    def _write_end(self):
-        self._write_func('e')
-        self.flush()
-
-    def _write_prefixed_body(self, bytes):
-        self._write_func('b')
-        self._write_func(struct.pack('!L', len(bytes)))
-        self._write_func(bytes)
-
-    def _write_error_status(self):
-        self._write_func('oE')
-
-    def _write_success_status(self):
-        self._write_func('oS')
-
-
-class ProtocolThreeResponder(_ProtocolThreeEncoder):
-
-    def __init__(self, write_func):
-        _ProtocolThreeEncoder.__init__(self, write_func)
-        self.response_sent = False
-        self._headers = {'Software version': bzrlib.__version__}
-
-    def send_error(self, exception):
-        if self.response_sent:
-            raise AssertionError(
-                "send_error(%s) called, but response already sent."
-                % (exception,))
-        if isinstance(exception, errors.UnknownSmartMethod):
-            failure = request.FailedSmartServerResponse(
-                ('UnknownMethod', exception.verb))
-            self.send_response(failure)
-            return
-        self.response_sent = True
-        self._write_protocol_version()
-        self._write_headers(self._headers)
-        self._write_error_status()
-        self._write_structure(('error', str(exception)))
-        self._write_end()
-
-    def send_response(self, response):
-        if self.response_sent:
-            raise AssertionError(
-                "send_response(%r) called, but response already sent."
-                % (response,))
-        self.response_sent = True
-        self._write_protocol_version()
-        self._write_headers(self._headers)
-        if response.is_successful():
-            self._write_success_status()
-        else:
-            self._write_error_status()
-        self._write_structure(response.args)
-        if response.body is not None:
-            self._write_prefixed_body(response.body)
-        elif response.body_stream is not None:
-            for chunk in response.body_stream:
-                self._write_prefixed_body(chunk)
-                self.flush()
-        self._write_end()
-        
-
-class ProtocolThreeRequester(_ProtocolThreeEncoder, Requester):
-
-    def __init__(self, medium_request):
-        _ProtocolThreeEncoder.__init__(self, medium_request.accept_bytes)
-        self._medium_request = medium_request
-        self._headers = {}
-
-    def set_headers(self, headers):
-        self._headers = headers.copy()
-        
-    def call(self, *args):
-        if 'hpss' in debug.debug_flags:
-            mutter('hpss call:   %s', repr(args)[1:-1])
-            base = getattr(self._medium_request._medium, 'base', None)
-            if base is not None:
-                mutter('             (to %s)', base)
-            self._request_start_time = time.time()
-        self._write_protocol_version()
-        self._write_headers(self._headers)
-        self._write_structure(args)
-        self._write_end()
-        self._medium_request.finished_writing()
-
-    def call_with_body_bytes(self, args, body):
-        """Make a remote call of args with body bytes 'body'.
-
-        After calling this, call read_response_tuple to find the result out.
-        """
-        if 'hpss' in debug.debug_flags:
-            mutter('hpss call w/body: %s (%r...)', repr(args)[1:-1], body[:20])
-            path = getattr(self._medium_request._medium, '_path', None)
-            if path is not None:
-                mutter('                  (to %s)', path)
-            mutter('              %d bytes', len(body))
-            self._request_start_time = time.time()
-        self._write_protocol_version()
-        self._write_headers(self._headers)
-        self._write_structure(args)
-        self._write_prefixed_body(body)
-        self._write_end()
-        self._medium_request.finished_writing()
-
-    def call_with_body_readv_array(self, args, body):
-        """Make a remote call with a readv array.
-
-        The body is encoded with one line per readv offset pair. The numbers in
-        each pair are separated by a comma, and no trailing \n is emitted.
-        """
-        if 'hpss' in debug.debug_flags:
-            mutter('hpss call w/readv: %s', repr(args)[1:-1])
-            path = getattr(self._medium_request._medium, '_path', None)
-            if path is not None:
-                mutter('                  (to %s)', path)
-            self._request_start_time = time.time()
-        self._write_protocol_version()
-        self._write_headers(self._headers)
-        self._write_structure(args)
-        readv_bytes = self._serialise_offsets(body)
-        if 'hpss' in debug.debug_flags:
-            mutter('              %d bytes in readv request', len(readv_bytes))
-        self._write_prefixed_body(readv_bytes)
-        self._write_end()
-        self._medium_request.finished_writing()
+        self._request.accept_bytes(REQUEST_VERSION_TWO)
 

=== modified file 'bzrlib/smart/repository.py'
--- bzrlib/smart/repository.py	2008-08-26 08:25:27 +0000
+++ bzrlib/smart/repository.py	2007-10-12 05:26:46 +0000
@@ -16,26 +16,20 @@
 
 """Server-side repository related request implmentations."""
 
-import bz2
 from cStringIO import StringIO
 import os
 import sys
 import tempfile
 import tarfile
 
-from bzrlib import (
-    errors,
-    osutils,
-    )
+from bzrlib import errors
 from bzrlib.bzrdir import BzrDir
-from bzrlib.pack import ContainerSerialiser
+from bzrlib.pack import ContainerWriter
 from bzrlib.smart.request import (
     FailedSmartServerResponse,
     SmartServerRequest,
     SuccessfulSmartServerResponse,
     )
-from bzrlib.repository import _strip_NULL_ghosts
-from bzrlib import revision as _mod_revision
 
 
 class SmartServerRepositoryRequest(SmartServerRequest):
@@ -44,160 +38,23 @@
     def do(self, path, *args):
         """Execute a repository request.
         
-        All Repository requests take a path to the repository as their first
-        argument.  The repository must be at the exact path given by the
-        client - no searching is done.
+        The repository must be at the exact path - no searching is done.
 
         The actual logic is delegated to self.do_repository_request.
 
-        :param client_path: The path for the repository as received from the
-            client.
-        :return: A SmartServerResponse from self.do_repository_request().
+        :param path: The path for the repository.
+        :return: A smart server from self.do_repository_request().
         """
-        transport = self.transport_from_client_path(path)
+        transport = self._backing_transport.clone(path)
         bzrdir = BzrDir.open_from_transport(transport)
-        # Save the repository for use with do_body.
-        self._repository = bzrdir.open_repository()
-        return self.do_repository_request(self._repository, *args)
-
-    def do_repository_request(self, repository, *args):
-        """Override to provide an implementation for a verb."""
-        # No-op for verbs that take bodies (None as a result indicates a body
-        # is expected)
-        return None
-
-    def recreate_search(self, repository, recipe_bytes):
-        lines = recipe_bytes.split('\n')
-        start_keys = set(lines[0].split(' '))
-        exclude_keys = set(lines[1].split(' '))
-        revision_count = int(lines[2])
-        repository.lock_read()
-        try:
-            search = repository.get_graph()._make_breadth_first_searcher(
-                start_keys)
-            while True:
-                try:
-                    next_revs = search.next()
-                except StopIteration:
-                    break
-                search.stop_searching_any(exclude_keys.intersection(next_revs))
-            search_result = search.get_result()
-            if search_result.get_recipe()[2] != revision_count:
-                # we got back a different amount of data than expected, this
-                # gets reported as NoSuchRevision, because less revisions
-                # indicates missing revisions, and more should never happen as
-                # the excludes list considers ghosts and ensures that ghost
-                # filling races are not a problem.
-                return (None, FailedSmartServerResponse(('NoSuchRevision',)))
-            return (search, None)
-        finally:
-            repository.unlock()
-
-
-class SmartServerRepositoryReadLocked(SmartServerRepositoryRequest):
-    """Calls self.do_readlocked_repository_request."""
-
-    def do_repository_request(self, repository, *args):
-        """Read lock a repository for do_readlocked_repository_request."""
-        repository.lock_read()
-        try:
-            return self.do_readlocked_repository_request(repository, *args)
-        finally:
-            repository.unlock()
-
-
-class SmartServerRepositoryGetParentMap(SmartServerRepositoryRequest):
-    """Bzr 1.2+ - get parent data for revisions during a graph search."""
-    
-    def do_repository_request(self, repository, *revision_ids):
-        """Get parent details for some revisions.
-        
-        All the parents for revision_ids are returned. Additionally up to 64KB
-        of additional parent data found by performing a breadth first search
-        from revision_ids is returned. The verb takes a body containing the
-        current search state, see do_body for details.
-
-        :param repository: The repository to query in.
-        :param revision_ids: The utf8 encoded revision_id to answer for.
-        """
-        self._revision_ids = revision_ids
-        return None # Signal that we want a body.
-
-    def do_body(self, body_bytes):
-        """Process the current search state and perform the parent lookup.
-
-        :return: A smart server response where the body contains an utf8
-            encoded flattened list of the parents of the revisions (the same
-            format as Repository.get_revision_graph) which has been bz2
-            compressed.
-        """
-        repository = self._repository
-        repository.lock_read()
-        try:
-            return self._do_repository_request(body_bytes)
-        finally:
-            repository.unlock()
-
-    def _do_repository_request(self, body_bytes):
-        repository = self._repository
-        revision_ids = set(self._revision_ids)
-        search, error = self.recreate_search(repository, body_bytes)
-        if error is not None:
-            return error
-        # TODO might be nice to start up the search again; but thats not
-        # written or tested yet.
-        client_seen_revs = set(search.get_result().get_keys())
-        # Always include the requested ids.
-        client_seen_revs.difference_update(revision_ids)
-        lines = []
-        repo_graph = repository.get_graph()
-        result = {}
-        queried_revs = set()
-        size_so_far = 0
-        next_revs = revision_ids
-        first_loop_done = False
-        while next_revs:
-            queried_revs.update(next_revs)
-            parent_map = repo_graph.get_parent_map(next_revs)
-            next_revs = set()
-            for revision_id, parents in parent_map.iteritems():
-                # adjust for the wire
-                if parents == (_mod_revision.NULL_REVISION,):
-                    parents = ()
-                # prepare the next query
-                next_revs.update(parents)
-                if revision_id not in client_seen_revs:
-                    # Client does not have this revision, give it to it.
-                    # add parents to the result
-                    result[revision_id] = parents
-                    # Approximate the serialized cost of this revision_id.
-                    size_so_far += 2 + len(revision_id) + sum(map(len, parents))
-            # get all the directly asked for parents, and then flesh out to
-            # 64K (compressed) or so. We do one level of depth at a time to
-            # stay in sync with the client. The 250000 magic number is
-            # estimated compression ratio taken from bzr.dev itself.
-            if first_loop_done and size_so_far > 250000:
-                next_revs = set()
-                break
-            # don't query things we've already queried
-            next_revs.difference_update(queried_revs)
-            first_loop_done = True
-
-        # sorting trivially puts lexographically similar revision ids together.
-        # Compression FTW.
-        for revision, parents in sorted(result.items()):
-            lines.append(' '.join((revision, ) + tuple(parents)))
-
-        return SuccessfulSmartServerResponse(
-            ('ok', ), bz2.compress('\n'.join(lines)))
-
-
-class SmartServerRepositoryGetRevisionGraph(SmartServerRepositoryReadLocked):
-    
-    def do_readlocked_repository_request(self, repository, revision_id):
+        repository = bzrdir.open_repository()
+        return self.do_repository_request(repository, *args)
+
+
+class SmartServerRepositoryGetRevisionGraph(SmartServerRepositoryRequest):
+    
+    def do_repository_request(self, repository, revision_id):
         """Return the result of repository.get_revision_graph(revision_id).
-
-        Deprecated as of bzr 1.4, but supported for older clients.
         
         :param repository: The repository to query in.
         :param revision_id: The utf8 encoded revision_id to get a graph from.
@@ -208,17 +65,9 @@
             revision_id = None
 
         lines = []
-        graph = repository.get_graph()
-        if revision_id:
-            search_ids = [revision_id]
-        else:
-            search_ids = repository.all_revision_ids()
-        search = graph._make_breadth_first_searcher(search_ids)
-        transitive_ids = set()
-        map(transitive_ids.update, list(search))
-        parent_map = graph.get_parent_map(transitive_ids)
-        revision_graph = _strip_NULL_ghosts(parent_map)
-        if revision_id and revision_id not in revision_graph:
+        try:
+            revision_graph = repository.get_revision_graph(revision_id)
+        except errors.NoSuchRevision:
             # Note that we return an empty body, rather than omitting the body.
             # This way the client knows that it can always expect to find a body
             # in the response for this method, even in the error case.
@@ -260,6 +109,7 @@
               firstrev: 1234.230 0
               latestrev: 345.700 3600
               revisions: 2
+              size:45
 
               But containing only fields returned by the gather_stats() call
         """
@@ -318,8 +168,7 @@
         except errors.LockFailed, e:
             return FailedSmartServerResponse(('LockFailed',
                 str(e.lock), str(e.why)))
-        if token is not None:
-            repository.leave_lock_in_place()
+        repository.leave_lock_in_place()
         repository.unlock()
         if token is None:
             token = ''
@@ -352,6 +201,7 @@
 
     def do_repository_request(self, repository, compression):
         from bzrlib import osutils
+        repo_transport = repository.control_files._transport
         tmp_dirname, tmp_repo = self._copy_to_tempdir(repository)
         try:
             controldir_name = tmp_dirname + '/.bzr'
@@ -360,7 +210,7 @@
             osutils.rmtree(tmp_dirname)
 
     def _copy_to_tempdir(self, from_repo):
-        tmp_dirname = osutils.mkdtemp(prefix='tmpbzrclone')
+        tmp_dirname = tempfile.mkdtemp(prefix='tmpbzrclone')
         tmp_bzrdir = from_repo.bzrdir._format.initialize(tmp_dirname)
         tmp_repo = from_repo._format.initialize(tmp_bzrdir)
         from_repo.copy_content_into(tmp_repo)
@@ -373,8 +223,8 @@
             # all finished; write the tempfile out to the network
             temp.seek(0)
             return SuccessfulSmartServerResponse(('ok',), temp.read())
-            # FIXME: Don't read the whole thing into memory here; rather stream
-            # it out from the file onto the network. mbp 20070411
+            # FIXME: Don't read the whole thing into memory here; rather stream it
+            # out from the file onto the network. mbp 20070411
         finally:
             temp.close()
 
@@ -390,8 +240,24 @@
             dirname = dirname.encode(sys.getfilesystemencoding())
             # python's tarball module includes the whole path by default so
             # override it
-            if not dirname.endswith('.bzr'):
-                raise ValueError(dirname)
+            assert dirname.endswith('.bzr')
             tarball.add(dirname, '.bzr') # recursive by default
         finally:
             tarball.close()
+
+
+class SmartServerRepositoryStreamKnitDataForRevisions(SmartServerRepositoryRequest):
+
+    def do_repository_request(self, repository, *revision_ids):
+        stream = repository.get_data_stream(revision_ids)
+        filelike = StringIO()
+        pack = ContainerWriter(filelike.write)
+        pack.begin()
+        try:
+            for name_tuple, bytes in stream:
+                pack.add_bytes_record(bytes, [name_tuple])
+        except errors.RevisionNotPresent, e:
+            return FailedSmartServerResponse(('NoSuchRevision', e.revision_id))
+        pack.end()
+        return SuccessfulSmartServerResponse(('ok',), filelike.getvalue())
+

=== modified file 'bzrlib/smart/request.py'
--- bzrlib/smart/request.py	2008-07-07 05:45:40 +0000
+++ bzrlib/smart/request.py	2007-10-12 05:26:46 +0000
@@ -14,17 +14,8 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-"""Basic server-side logic for dealing with requests.
-
-**XXX**:
-
-The class names are a little confusing: the protocol will instantiate a
-SmartServerRequestHandler, whose dispatch_command method creates an instance of
-a SmartServerRequest subclass.
-
-The request_handlers registry tracks SmartServerRequest classes (rather than
-SmartServerRequestHandler).
-"""
+"""Basic server-side logic for dealing with requests."""
+
 
 import tempfile
 
@@ -33,40 +24,20 @@
     errors,
     registry,
     revision,
-    urlutils,
     )
 from bzrlib.bundle.serializer import write_bundle
 
 
 class SmartServerRequest(object):
-    """Base class for request handlers.
-    
-    To define a new request, subclass this class and override the `do` method
-    (and if appropriate, `do_body` as well).  Request implementors should take
-    care to call `translate_client_path` and `transport_from_client_path` as
-    appropriate when dealing with paths received from the client.
-    """
-    # XXX: rename this class to BaseSmartServerRequestHandler ?  A request
-    # *handler* is a different concept to the request.
+    """Base class for request handlers."""
 
-    def __init__(self, backing_transport, root_client_path='/'):
+    def __init__(self, backing_transport):
         """Constructor.
 
         :param backing_transport: the base transport to be used when performing
             this request.
-        :param root_client_path: the client path that maps to the root of
-            backing_transport.  This is used to interpret relpaths received
-            from the client.  Clients will not be able to refer to paths above
-            this root.  If root_client_path is None, then no translation will
-            be performed on client paths.  Default is '/'.
         """
         self._backing_transport = backing_transport
-        if root_client_path is not None:
-            if not root_client_path.startswith('/'):
-                root_client_path = '/' + root_client_path
-            if not root_client_path.endswith('/'):
-                root_client_path += '/'
-        self._root_client_path = root_client_path
 
     def _check_enabled(self):
         """Raises DisabledMethod if this method is disabled."""
@@ -95,59 +66,15 @@
 
     def do_body(self, body_bytes):
         """Called if the client sends a body with the request.
-
-        The do() method is still called, and must have returned None.
         
         Must return a SmartServerResponse.
         """
+        # TODO: if a client erroneously sends a request that shouldn't have a
+        # body, what to do?  Probably SmartServerRequestHandler should catch
+        # this NotImplementedError and translate it into a 'bad request' error
+        # to send to the client.
         raise NotImplementedError(self.do_body)
 
-    def do_chunk(self, chunk_bytes):
-        """Called with each body chunk if the request has a streamed body.
-
-        The do() method is still called, and must have returned None.
-        """
-        raise NotImplementedError(self.do_chunk)
-
-    def do_end(self):
-        """Called when the end of the request has been received."""
-        pass
-    
-    def translate_client_path(self, client_path):
-        """Translate a path received from a network client into a local
-        relpath.
-
-        All paths received from the client *must* be translated.
-
-        :param client_path: the path from the client.
-        :returns: a relpath that may be used with self._backing_transport
-            (unlike the untranslated client_path, which must not be used with
-            the backing transport).
-        """
-        if self._root_client_path is None:
-            # no translation necessary!
-            return client_path
-        if not client_path.startswith('/'):
-            client_path = '/' + client_path
-        if client_path.startswith(self._root_client_path):
-            path = client_path[len(self._root_client_path):]
-            relpath = urlutils.joinpath('/', path)
-            if not relpath.startswith('/'):
-                raise ValueError(relpath)
-            return '.' + relpath
-        else:
-            raise errors.PathNotChild(client_path, self._root_client_path)
-
-    def transport_from_client_path(self, client_path):
-        """Get a backing transport corresponding to the location referred to by
-        a network client.
-
-        :seealso: translate_client_path
-        :returns: a transport cloned from self._backing_transport
-        """
-        relpath = self.translate_client_path(client_path)
-        return self._backing_transport.clone(relpath)
-
 
 class SmartServerResponse(object):
     """A response to a client request.
@@ -156,31 +83,17 @@
     SuccessfulSmartServerResponse and FailedSmartServerResponse as appropriate.
     """
 
-    def __init__(self, args, body=None, body_stream=None):
-        """Constructor.
-
-        :param args: tuple of response arguments.
-        :param body: string of a response body.
-        :param body_stream: iterable of bytestrings to be streamed to the
-            client.
-        """
+    def __init__(self, args, body=None):
         self.args = args
-        if body is not None and body_stream is not None:
-            raise errors.BzrError(
-                "'body' and 'body_stream' are mutually exclusive.")
         self.body = body
-        self.body_stream = body_stream
 
     def __eq__(self, other):
         if other is None:
             return False
-        return (other.args == self.args and
-                other.body == self.body and
-                other.body_stream is self.body_stream)
+        return other.args == self.args and other.body == self.body
 
     def __repr__(self):
-        status = {True: 'OK', False: 'ERR'}[self.is_successful()]
-        return "<SmartServerResponse status=%s args=%r body=%r>" % (status,
+        return "<SmartServerResponse args=%r body=%r>" % (
             self.args, self.body)
 
 
@@ -217,7 +130,7 @@
     # TODO: Better way of representing the body for commands that take it,
     # and allow it to be streamed into the server.
 
-    def __init__(self, backing_transport, commands, root_client_path):
+    def __init__(self, backing_transport, commands):
         """Constructor.
 
         :param backing_transport: a Transport to handle requests for.
@@ -225,7 +138,6 @@
             subclasses. e.g. bzrlib.transport.smart.vfs.vfs_commands.
         """
         self._backing_transport = backing_transport
-        self._root_client_path = root_client_path
         self._commands = commands
         self._body_bytes = ''
         self.response = None
@@ -254,8 +166,8 @@
         try:
             command = self._commands.get(cmd)
         except LookupError:
-            raise errors.UnknownSmartMethod(cmd)
-        self._command = command(self._backing_transport, self._root_client_path)
+            raise errors.SmartProtocolError("bad request %r" % (cmd,))
+        self._command = command(self._backing_transport)
         self._run_handler_code(self._command.execute, args, {})
 
     def _run_handler_code(self, callable, args, kwargs):
@@ -307,32 +219,6 @@
             else:
                 raise
 
-    def headers_received(self, headers):
-        # Just a no-op at the moment.
-        pass
-
-    def args_received(self, args):
-        cmd = args[0]
-        args = args[1:]
-        try:
-            command = self._commands.get(cmd)
-        except LookupError:
-            raise errors.UnknownSmartMethod(cmd)
-        self._command = command(self._backing_transport)
-        self._run_handler_code(self._command.execute, args, {})
-
-    def prefixed_body_received(self, body_bytes):
-        """No more body data will be received."""
-        self._run_handler_code(self._command.do_body, (body_bytes,), {})
-        # cannot read after this.
-        self.finished_reading = True
-
-    def body_chunk_received(self, chunk_bytes):
-        self._run_handler_code(self._command.do_chunk, (chunk_bytes,), {})
-
-    def end_received(self):
-        self._run_handler_code(self._command.do_end, (), {})
-
 
 class HelloRequest(SmartServerRequest):
     """Answer a version request with the highest protocol version this server
@@ -348,7 +234,7 @@
 
     def do(self, path, revision_id):
         # open transport relative to our base
-        t = self.transport_from_client_path(path)
+        t = self._backing_transport.clone(path)
         control, extra_path = bzrdir.BzrDir.open_containing_from_transport(t)
         repo = control.open_repository()
         tmpf = tempfile.TemporaryFile()
@@ -383,17 +269,9 @@
 request_handlers.register_lazy(
     'Branch.set_last_revision', 'bzrlib.smart.branch', 'SmartServerBranchRequestSetLastRevision')
 request_handlers.register_lazy(
-    'Branch.set_last_revision_info', 'bzrlib.smart.branch',
-    'SmartServerBranchRequestSetLastRevisionInfo')
-request_handlers.register_lazy(
-    'Branch.set_last_revision_ex', 'bzrlib.smart.branch',
-    'SmartServerBranchRequestSetLastRevisionEx')
-request_handlers.register_lazy(
     'Branch.unlock', 'bzrlib.smart.branch', 'SmartServerBranchRequestUnlock')
 request_handlers.register_lazy(
-    'BzrDir.find_repository', 'bzrlib.smart.bzrdir', 'SmartServerRequestFindRepositoryV1')
-request_handlers.register_lazy(
-    'BzrDir.find_repositoryV2', 'bzrlib.smart.bzrdir', 'SmartServerRequestFindRepositoryV2')
+    'BzrDir.find_repository', 'bzrlib.smart.bzrdir', 'SmartServerRequestFindRepository')
 request_handlers.register_lazy(
     'BzrDirFormat.initialize', 'bzrlib.smart.bzrdir', 'SmartServerRequestInitializeBzrDir')
 request_handlers.register_lazy(
@@ -427,9 +305,9 @@
 request_handlers.register_lazy('Repository.gather_stats',
                                'bzrlib.smart.repository',
                                'SmartServerRepositoryGatherStats')
-request_handlers.register_lazy('Repository.get_parent_map',
-                               'bzrlib.smart.repository',
-                               'SmartServerRepositoryGetParentMap')
+request_handlers.register_lazy(
+    'Repository.stream_knit_data_for_revisions', 'bzrlib.smart.repository',
+    'SmartServerRepositoryStreamKnitDataForRevisions')
 request_handlers.register_lazy(
     'Repository.get_revision_graph', 'bzrlib.smart.repository', 'SmartServerRepositoryGetRevisionGraph')
 request_handlers.register_lazy(

=== modified file 'bzrlib/smart/server.py'
--- bzrlib/smart/server.py	2008-06-05 22:56:42 +0000
+++ bzrlib/smart/server.py	2007-07-20 03:20:20 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007, 2008 Canonical Ltd
+# Copyright (C) 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -18,7 +18,6 @@
 
 import errno
 import socket
-import sys
 import threading
 
 from bzrlib.hooks import Hooks
@@ -39,18 +38,14 @@
     hooks: An instance of SmartServerHooks.
     """
 
-    def __init__(self, backing_transport, host='127.0.0.1', port=0,
-                 root_client_path='/'):
+    def __init__(self, backing_transport, host='127.0.0.1', port=0):
         """Construct a new server.
 
         To actually start it running, call either start_background_thread or
         serve.
 
-        :param backing_transport: The transport to serve.
         :param host: Name of the interface to listen on.
         :param port: TCP port to listen on, or 0 to allocate a transient port.
-        :param root_client_path: The client path that will correspond to root
-            of backing_transport.
         """
         # let connections timeout so that we get a chance to terminate
         # Keep a reference to the exceptions we want to catch because the socket
@@ -60,14 +55,7 @@
         self._socket_error = socket_error
         self._socket_timeout = socket_timeout
         self._server_socket = socket.socket()
-        # SO_REUSERADDR has a different meaning on Windows
-        if sys.platform != 'win32':
-            self._server_socket.setsockopt(socket.SOL_SOCKET,
-                socket.SO_REUSEADDR, 1)
-        try:
-            self._server_socket.bind((host, port))
-        except self._socket_error, message:
-            raise errors.CannotBindAddress(host, port, message)
+        self._server_socket.bind((host, port))
         self._sockname = self._server_socket.getsockname()
         self.port = self._sockname[1]
         self._server_socket.listen(1)
@@ -75,9 +63,8 @@
         self.backing_transport = backing_transport
         self._started = threading.Event()
         self._stopped = threading.Event()
-        self.root_client_path = root_client_path
 
-    def serve(self, thread_name_suffix=''):
+    def serve(self):
         self._should_terminate = False
         # for hooks we are letting code know that a server has started (and
         # later stopped).
@@ -119,7 +106,7 @@
                         if e.args[0] != errno.EBADF:
                             trace.warning("listening socket error: %s", e)
                     else:
-                        self.serve_conn(conn, thread_name_suffix)
+                        self.serve_conn(conn)
             except KeyboardInterrupt:
                 # dont log when CTRL-C'd.
                 raise
@@ -142,23 +129,20 @@
         """Return the url of the server"""
         return "bzr://%s:%d/" % self._sockname
 
-    def serve_conn(self, conn, thread_name_suffix):
+    def serve_conn(self, conn):
         # For WIN32, where the timeout value from the listening socket
         # propogates to the newly accepted socket.
         conn.setblocking(True)
         conn.setsockopt(socket.IPPROTO_TCP, socket.TCP_NODELAY, 1)
-        handler = SmartServerSocketStreamMedium(
-            conn, self.backing_transport, self.root_client_path)
-        thread_name = 'smart-server-child' + thread_name_suffix
-        connection_thread = threading.Thread(
-            None, handler.serve, name=thread_name)
+        handler = SmartServerSocketStreamMedium(conn, self.backing_transport)
+        connection_thread = threading.Thread(None, handler.serve, name='smart-server-child')
         connection_thread.setDaemon(True)
         connection_thread.start()
 
-    def start_background_thread(self, thread_name_suffix=''):
+    def start_background_thread(self):
         self._started.clear()
         self._server_thread = threading.Thread(None,
-                self.serve, args=(thread_name_suffix,),
+                self.serve,
                 name='server-' + self.get_url())
         self._server_thread.setDaemon(True)
         self._server_thread.start()
@@ -218,31 +202,15 @@
     This server is backed by the process's cwd.
     """
 
-    def __init__(self, thread_name_suffix=''):
+    def __init__(self):
         SmartTCPServer.__init__(self, None)
-        self.client_path_extra = None
-        self.thread_name_suffix = thread_name_suffix
         
     def get_backing_transport(self, backing_transport_server):
         """Get a backing transport from a server we are decorating."""
         return transport.get_transport(backing_transport_server.get_url())
 
-    def setUp(self, backing_transport_server=None,
-              client_path_extra='/extra/'):
-        """Set up server for testing.
-        
-        :param backing_transport_server: backing server to use.  If not
-            specified, a LocalURLServer at the current working directory will
-            be used.
-        :param client_path_extra: a path segment starting with '/' to append to
-            the root URL for this server.  For instance, a value of '/foo/bar/'
-            will mean the root of the backing transport will be published at a
-            URL like `bzr://127.0.0.1:nnnn/foo/bar/`, rather than
-            `bzr://127.0.0.1:nnnn/`.  Default value is `extra`, so that tests
-            by default will fail unless they do the necessary path translation.
-        """
-        if not client_path_extra.startswith('/'):
-            raise ValueError(client_path_extra)
+    def setUp(self, backing_transport_server=None):
+        """Set up server for testing"""
         from bzrlib.transport.chroot import ChrootServer
         if backing_transport_server is None:
             from bzrlib.transport.local import LocalURLServer
@@ -252,17 +220,12 @@
         self.chroot_server.setUp()
         self.backing_transport = transport.get_transport(
             self.chroot_server.get_url())
-        self.root_client_path = self.client_path_extra = client_path_extra
-        self.start_background_thread(self.thread_name_suffix)
+        self.start_background_thread()
 
     def tearDown(self):
         self.stop_background_thread()
         self.chroot_server.tearDown()
 
-    def get_url(self):
-        url = super(SmartTCPServer_for_testing, self).get_url()
-        return url[:-1] + self.client_path_extra
-
     def get_bogus_url(self):
         """Return a URL which will fail to connect"""
         return 'bzr://127.0.0.1:1/'
@@ -276,24 +239,3 @@
         url = 'readonly+' + backing_transport_server.get_url()
         return transport.get_transport(url)
 
-
-class SmartTCPServer_for_testing_v2_only(SmartTCPServer_for_testing):
-    """A variation of SmartTCPServer_for_testing that limits the client to
-    using RPCs in protocol v2 (i.e. bzr <= 1.5).
-    """
-
-    def get_url(self):
-        url = super(SmartTCPServer_for_testing_v2_only, self).get_url()
-        url = 'bzr-v2://' + url[len('bzr://'):]
-        return url
-
-
-class ReadonlySmartTCPServer_for_testing_v2_only(SmartTCPServer_for_testing_v2_only):
-    """Get a readonly server for testing."""
-
-    def get_backing_transport(self, backing_transport_server):
-        """Get a backing transport from a server we are decorating."""
-        url = 'readonly+' + backing_transport_server.get_url()
-        return transport.get_transport(url)
-
-

=== modified file 'bzrlib/smart/vfs.py'
--- bzrlib/smart/vfs.py	2008-01-04 03:12:11 +0000
+++ bzrlib/smart/vfs.py	2007-07-04 08:08:13 +0000
@@ -63,7 +63,6 @@
 class HasRequest(VfsRequest):
 
     def do(self, relpath):
-        relpath = self.translate_client_path(relpath)
         r = self._backing_transport.has(relpath) and 'yes' or 'no'
         return request.SuccessfulSmartServerResponse((r,))
 
@@ -71,21 +70,17 @@
 class GetRequest(VfsRequest):
 
     def do(self, relpath):
-        relpath = self.translate_client_path(relpath)
         try:
             backing_bytes = self._backing_transport.get_bytes(relpath)
         except errors.ReadError:
             # cannot read the file
             return request.FailedSmartServerResponse(('ReadError', ))
-        except errors.PermissionDenied:
-            return request.FailedSmartServerResponse(('PermissionDenied',))
         return request.SuccessfulSmartServerResponse(('ok',), backing_bytes)
 
 
 class AppendRequest(VfsRequest):
 
     def do(self, relpath, mode):
-        relpath = self.translate_client_path(relpath)
         self._relpath = relpath
         self._mode = _deserialise_optional_mode(mode)
     
@@ -98,7 +93,6 @@
 class DeleteRequest(VfsRequest):
 
     def do(self, relpath):
-        relpath = self.translate_client_path(relpath)
         self._backing_transport.delete(relpath)
         return request.SuccessfulSmartServerResponse(('ok', ))
 
@@ -106,9 +100,6 @@
 class IterFilesRecursiveRequest(VfsRequest):
 
     def do(self, relpath):
-        if not relpath.endswith('/'):
-            relpath += '/'
-        relpath = self.translate_client_path(relpath)
         transport = self._backing_transport.clone(relpath)
         filenames = transport.iter_files_recursive()
         return request.SuccessfulSmartServerResponse(('names',) + tuple(filenames))
@@ -117,9 +108,6 @@
 class ListDirRequest(VfsRequest):
 
     def do(self, relpath):
-        if not relpath.endswith('/'):
-            relpath += '/'
-        relpath = self.translate_client_path(relpath)
         filenames = self._backing_transport.list_dir(relpath)
         return request.SuccessfulSmartServerResponse(('names',) + tuple(filenames))
 
@@ -127,7 +115,6 @@
 class MkdirRequest(VfsRequest):
 
     def do(self, relpath, mode):
-        relpath = self.translate_client_path(relpath)
         self._backing_transport.mkdir(relpath,
                                       _deserialise_optional_mode(mode))
         return request.SuccessfulSmartServerResponse(('ok',))
@@ -136,8 +123,6 @@
 class MoveRequest(VfsRequest):
 
     def do(self, rel_from, rel_to):
-        rel_from = self.translate_client_path(rel_from)
-        rel_to = self.translate_client_path(rel_to)
         self._backing_transport.move(rel_from, rel_to)
         return request.SuccessfulSmartServerResponse(('ok',))
 
@@ -145,7 +130,6 @@
 class PutRequest(VfsRequest):
 
     def do(self, relpath, mode):
-        relpath = self.translate_client_path(relpath)
         self._relpath = relpath
         self._mode = _deserialise_optional_mode(mode)
 
@@ -157,7 +141,6 @@
 class PutNonAtomicRequest(VfsRequest):
 
     def do(self, relpath, mode, create_parent, dir_mode):
-        relpath = self.translate_client_path(relpath)
         self._relpath = relpath
         self._dir_mode = _deserialise_optional_mode(dir_mode)
         self._mode = _deserialise_optional_mode(mode)
@@ -176,7 +159,6 @@
 class ReadvRequest(VfsRequest):
 
     def do(self, relpath):
-        relpath = self.translate_client_path(relpath)
         self._relpath = relpath
 
     def do_body(self, body_bytes):
@@ -200,8 +182,6 @@
 class RenameRequest(VfsRequest):
 
     def do(self, rel_from, rel_to):
-        rel_from = self.translate_client_path(rel_from)
-        rel_to = self.translate_client_path(rel_to)
         self._backing_transport.rename(rel_from, rel_to)
         return request.SuccessfulSmartServerResponse(('ok', ))
 
@@ -209,7 +189,6 @@
 class RmdirRequest(VfsRequest):
 
     def do(self, relpath):
-        relpath = self.translate_client_path(relpath)
         self._backing_transport.rmdir(relpath)
         return request.SuccessfulSmartServerResponse(('ok', ))
 
@@ -217,9 +196,6 @@
 class StatRequest(VfsRequest):
 
     def do(self, relpath):
-        if not relpath.endswith('/'):
-            relpath += '/'
-        relpath = self.translate_client_path(relpath)
         stat = self._backing_transport.stat(relpath)
         return request.SuccessfulSmartServerResponse(
             ('stat', str(stat.st_size), oct(stat.st_mode)))

=== modified file 'bzrlib/status.py'
--- bzrlib/status.py	2008-08-16 22:28:01 +0000
+++ bzrlib/status.py	2007-10-16 16:02:01 +0000
@@ -18,14 +18,11 @@
 
 from bzrlib import (
     delta as _mod_delta,
-    log,
-    osutils,
     tree,
-    tsort,
-    revision as _mod_revision,
     )
 from bzrlib.diff import _raise_if_nonexistent
 import bzrlib.errors as errors
+from bzrlib.log import line_log
 from bzrlib.osutils import is_inside_any
 from bzrlib.symbol_versioning import (deprecated_function,
         )
@@ -63,15 +60,15 @@
     :param show_ids: If set, includes each file's id.
     :param to_file: If set, write to this file (default stdout.)
     :param show_pending: If set, write pending merges.
-    :param revision: If None, compare latest revision with working tree
-        If not None, it must be a RevisionSpec list.
-        If one revision, compare with working tree.
-        If two revisions, show status between first and second.
+    :param revision: If None the compare latest revision with working tree
+        If not None it must be a RevisionSpec list.
+        If one revision show compared it with working tree.
+        If two revisions show status between first and second.
     :param short: If True, gives short SVN-style status lines.
     :param versioned: If True, only shows versioned files.
     """
     if show_unchanged is not None:
-        warn("show_tree_status with show_unchanged has been deprecated "
+        warn("show_status_trees with show_unchanged has been deprecated "
              "since bzrlib 0.9", DeprecationWarning, stacklevel=2)
 
     if to_file is None:
@@ -87,13 +84,13 @@
             old = new.basis_tree()
         elif len(revision) > 0:
             try:
-                rev_id = revision[0].as_revision_id(wt.branch)
+                rev_id = revision[0].in_history(wt.branch).rev_id
                 old = wt.branch.repository.revision_tree(rev_id)
             except errors.NoSuchRevision, e:
                 raise errors.BzrCommandError(str(e))
             if (len(revision) > 1) and (revision[1].spec is not None):
                 try:
-                    rev_id = revision[1].as_revision_id(wt.branch)
+                    rev_id = revision[1].in_history(wt.branch).rev_id
                     new = wt.branch.repository.revision_tree(rev_id)
                     new_is_working_tree = False
                 except errors.NoSuchRevision, e:
@@ -106,7 +103,7 @@
             _raise_if_nonexistent(specific_files, old, new)
             want_unversioned = not versioned
             if short:
-                changes = new.iter_changes(old, show_unchanged, specific_files,
+                changes = new._iter_changes(old, show_unchanged, specific_files,
                     require_versioned=False, want_unversioned=want_unversioned)
                 reporter = _mod_delta._ChangeReporter(output_file=to_file,
                     unversioned_filter=new.is_ignored)
@@ -137,7 +134,7 @@
                 else:
                     prefix = ' '
                 to_file.write("%s %s\n" % (prefix, conflict))
-            if (new_is_working_tree and show_pending):
+            if new_is_working_tree and show_pending:
                 show_pending_merges(new, to_file, short)
         finally:
             old.unlock()
@@ -145,104 +142,59 @@
     finally:
         wt.unlock()
 
-
-def _get_sorted_revisions(tip_revision, revision_ids, parent_map):
-    """Get an iterator which will return the revisions in merge sorted order.
-
-    This will build up a list of all nodes, such that only nodes in the list
-    are referenced. It then uses MergeSorter to return them in 'merge-sorted'
-    order.
-
-    :param revision_ids: A set of revision_ids
-    :param parent_map: The parent information for each node. Revisions which
-        are considered ghosts should not be present in the map.
-    :return: iterator from MergeSorter.iter_topo_order()
-    """
-    # MergeSorter requires that all nodes be present in the graph, so get rid
-    # of any references pointing outside of this graph.
-    parent_graph = {}
-    for revision_id in revision_ids:
-        if revision_id not in parent_map: # ghost
-            parent_graph[revision_id] = []
-        else:
-            # Only include parents which are in this sub-graph
-            parent_graph[revision_id] = [p for p in parent_map[revision_id]
-                                            if p in revision_ids]
-    sorter = tsort.MergeSorter(parent_graph, tip_revision)
-    return sorter.iter_topo_order()
-
-
 def show_pending_merges(new, to_file, short=False):
     """Write out a display of pending merges in a working tree."""
     parents = new.get_parent_ids()
     if len(parents) < 2:
         return
-
-    # we need one extra space for terminals that wrap on last char
-    term_width = osutils.terminal_width() - 1
-    if short:
-        first_prefix = 'P   '
-        sub_prefix = 'P.   '
-    else:
-        first_prefix = '  '
-        sub_prefix = '    '
-
     pending = parents[1:]
     branch = new.branch
     last_revision = parents[0]
     if not short:
         to_file.write('pending merges:\n')
-    graph = branch.repository.get_graph()
-    other_revisions = [last_revision]
-    log_formatter = log.LineLogFormatter(to_file)
+    if last_revision is not None:
+        try:
+            ignore = set(branch.repository.get_ancestry(last_revision,
+                                                        topo_sorted=False))
+        except errors.NoSuchRevision:
+            # the last revision is a ghost : assume everything is new 
+            # except for it
+            ignore = set([None, last_revision])
+    else:
+        ignore = set([None])
+    # TODO: this could be improved using merge_sorted - we'd get the same 
+    # output rather than one level of indent.
     for merge in pending:
-        try:
-            rev = branch.repository.get_revisions([merge])[0]
-        except errors.NoSuchRevision:
-            # If we are missing a revision, just print out the revision id
-            to_file.write(first_prefix + '(ghost) ' + merge + '\n')
-            other_revisions.append(merge)
-            continue
-
-        # Log the merge, as it gets a slightly different formatting
-        log_message = log_formatter.log_string(None, rev,
-                        term_width - len(first_prefix))
-        to_file.write(first_prefix + log_message + '\n')
-        # Find all of the revisions in the merge source, which are not in the
-        # last committed revision.
-        merge_extra = graph.find_unique_ancestors(merge, other_revisions)
-        other_revisions.append(merge)
-        merge_extra.discard(_mod_revision.NULL_REVISION)
-
-        # Get a handle to all of the revisions we will need
-        try:
-            revisions = dict((rev.revision_id, rev) for rev in
-                             branch.repository.get_revisions(merge_extra))
-        except errors.NoSuchRevision:
-            # One of the sub nodes is a ghost, check each one
-            revisions = {}
-            for revision_id in merge_extra:
-                try:
-                    rev = branch.repository.get_revisions([revision_id])[0]
-                except errors.NoSuchRevision:
-                    revisions[revision_id] = None
+        ignore.add(merge)
+        try:
+            from bzrlib.osutils import terminal_width
+            width = terminal_width()
+            m_revision = branch.repository.get_revision(merge)
+            if short:
+                prefix = 'P  '
+            else:
+                prefix = ' '
+            to_file.write(prefix + ' ' + line_log(m_revision, width - 4))
+            to_file.write('\n')
+            inner_merges = branch.repository.get_ancestry(merge)
+            assert inner_merges[0] is None
+            inner_merges.pop(0)
+            inner_merges.reverse()
+            for mmerge in inner_merges:
+                if mmerge in ignore:
+                    continue
+                mm_revision = branch.repository.get_revision(mmerge)
+                if short:
+                    prefix = 'P.  '
                 else:
-                    revisions[revision_id] = rev
-
-        # Display the revisions brought in by this merge.
-        rev_id_iterator = _get_sorted_revisions(merge, merge_extra,
-                            branch.repository.get_parent_map(merge_extra))
-        # Skip the first node
-        num, first, depth, eom = rev_id_iterator.next()
-        if first != merge:
-            raise AssertionError('Somehow we misunderstood how'
-                ' iter_topo_order works %s != %s' % (first, merge))
-        for num, sub_merge, depth, eom in rev_id_iterator:
-            rev = revisions[sub_merge]
-            if rev is None:
-                to_file.write(sub_prefix + '(ghost) ' + sub_merge + '\n')
-                continue
-            log_message = log_formatter.log_string(None,
-                            revisions[sub_merge],
-                            term_width - len(sub_prefix))
-            to_file.write(sub_prefix + log_message + '\n')
+                    prefix = '   '
+                to_file.write(prefix + ' ' + line_log(mm_revision, width - 5))
+                to_file.write('\n')
+                ignore.add(mmerge)
+        except errors.NoSuchRevision:
+            if short:
+                prefix = 'P  '
+            else:
+                prefix = ' '
+            to_file.write(prefix + ' ' + merge)
+            to_file.write('\n')

=== modified file 'bzrlib/store/__init__.py'
--- bzrlib/store/__init__.py	2008-06-18 05:35:02 +0000
+++ bzrlib/store/__init__.py	2007-09-25 08:14:12 +0000
@@ -35,7 +35,6 @@
     osutils,
     symbol_versioning,
     urlutils,
-    versionedfile,
     )
 from bzrlib.errors import BzrError, UnlistableStore, TransportNotPossible
 from bzrlib.symbol_versioning import (
@@ -74,6 +73,10 @@
         """DEPRECATED. Please use .get(fileid) instead."""
         raise NotImplementedError
 
+    #def __contains__(self, fileid):
+    #    """Deprecated, please use has_id"""
+    #    raise NotImplementedError
+
     def __iter__(self):
         raise NotImplementedError
 
@@ -142,6 +145,7 @@
                     failed.add(fileid)
                 else:
                     raise
+        assert count == len(ids)
         if pb:
             pb.clear()
         return count, failed
@@ -185,9 +189,8 @@
         raise NotImplementedError('children need to implement this function.')
 
     def _check_fileid(self, fileid):
-        if type(fileid) != str:
-            raise TypeError('Fileids should be bytestrings: %s %r' % (
-                type(fileid), fileid))
+        if not isinstance(fileid, basestring):
+            raise TypeError('Fileids should be a string type: %s %r' % (type(fileid), fileid))
         if '\\' in fileid or '/' in fileid:
             raise ValueError("invalid store id %r" % fileid)
 
@@ -241,6 +244,7 @@
     def __init__(self, a_transport, prefixed=False, compressed=False,
                  dir_mode=None, file_mode=None,
                  escaped=False):
+        assert isinstance(a_transport, Transport)
         super(TransportStore, self).__init__()
         self._transport = a_transport
         self._prefixed = prefixed
@@ -253,22 +257,20 @@
         # will just use the filesystem defaults
         self._dir_mode = dir_mode
         self._file_mode = file_mode
-        # Create a key mapper to use
-        if escaped and prefixed:
-            self._mapper = versionedfile.HashEscapedPrefixMapper()
-        elif not escaped and prefixed:
-            self._mapper = versionedfile.HashPrefixMapper()
-        elif self._escaped:
-            raise ValueError(
-                "%r: escaped unprefixed stores are not permitted."
-                % (self,))
+
+    def _unescape(self, file_id):
+        """If filename escaping is enabled for this store, unescape and return the filename."""
+        if self._escaped:
+            return urllib.unquote(file_id)
         else:
-            self._mapper = versionedfile.PrefixMapper()
+            return file_id
 
     def _iter_files_recursive(self):
         """Iterate through the files in the transport."""
         for quoted_relpath in self._transport.iter_files_recursive():
-            yield quoted_relpath
+            # transport iterator always returns quoted paths, regardless of
+            # escaping
+            yield urllib.unquote(quoted_relpath)
 
     def __iter__(self):
         for relpath in self._iter_files_recursive():
@@ -282,7 +284,7 @@
                     if name.endswith('.' + suffix):
                         skip = True
             if not skip:
-                yield self._mapper.unmap(name)[0]
+                yield self._unescape(name)
 
     def __len__(self):
         return len(list(self.__iter__()))
@@ -296,9 +298,40 @@
                 self._check_fileid(suffix)
         else:
             suffixes = []
-        path = self._mapper.map((fileid,))
-        full_path = '.'.join([path] + suffixes)
-        return full_path
+        fileid = self._escape_file_id(fileid)
+        if self._prefixed:
+            # hash_prefix adds the '/' separator
+            prefix = self.hash_prefix(fileid, escaped=True)
+        else:
+            prefix = ''
+        path = prefix + fileid
+        full_path = u'.'.join([path] + suffixes)
+        return urlutils.escape(full_path)
+
+    def _escape_file_id(self, file_id):
+        """Turn a file id into a filesystem safe string.
+
+        This is similar to a plain urllib.quote, except
+        it uses specific safe characters, so that it doesn't
+        have to translate a lot of valid file ids.
+        """
+        if not self._escaped:
+            return file_id
+        if isinstance(file_id, unicode):
+            file_id = file_id.encode('utf-8')
+        # @ does not get escaped. This is because it is a valid
+        # filesystem character we use all the time, and it looks
+        # a lot better than seeing %40 all the time.
+        safe = "abcdefghijklmnopqrstuvwxyz0123456789-_@,."
+        r = [((c in safe) and c or ('%%%02x' % ord(c)))
+             for c in file_id]
+        return ''.join(r)
+
+    def hash_prefix(self, fileid, escaped=False):
+        # fileid should be unescaped
+        if not escaped and self._escaped:
+            fileid = self._escape_file_id(fileid)
+        return "%02x/" % (adler32(fileid) & 0xff)
 
     def __repr__(self):
         if self._transport is None:

=== added file 'bzrlib/store/revision/__init__.py'
--- bzrlib/store/revision/__init__.py	1970-01-01 00:00:00 +0000
+++ bzrlib/store/revision/__init__.py	2007-09-25 08:14:12 +0000
@@ -0,0 +1,119 @@
+# Copyright (C) 2006 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+"""Revision stores.
+
+Revision stores are responsible for storing a group of revisions
+and returning some interesting data about them such as ancestors
+and ghosts information.
+"""
+
+from cStringIO import StringIO
+
+from bzrlib.lazy_import import lazy_import
+lazy_import(globals(), """
+from bzrlib import (
+    errors,
+    osutils,
+    xml5,
+    )
+from bzrlib.trace import mutter
+""")
+
+
+class RevisionStore(object):
+    """A revision store stores revisions."""
+
+    def __init__(self, serializer=None):
+        if serializer is None:
+            serializer = xml5.serializer_v5
+        self._serializer = serializer
+
+    def add_revision(self, revision, transaction):
+        """Add revision to the revision store.
+
+        :param rev: The revision object.
+        """
+        # serialisation : common to all at the moment.
+        rev_tmp = StringIO()
+        self._serializer.write_revision(revision, rev_tmp)
+        rev_tmp.seek(0)
+        self._add_revision(revision, rev_tmp, transaction)
+        mutter('added revision_id {%s}', revision.revision_id)
+
+    def _add_revision(self, revision, revision_as_file, transaction):
+        """Template method helper to store revision in this store."""
+        raise NotImplementedError(self._add_revision)
+
+    def add_revision_signature_text(self, revision_id, signature_text, transaction):
+        """Add signature_text as a signature for revision_id."""
+        raise NotImplementedError(self.add_revision_signature_text)
+
+    def all_revision_ids(self, transaction):
+        """Returns a list of all the revision ids in the revision store. 
+
+        :return: list of revision_ids in topological order.
+        """
+        raise NotImplementedError(self.all_revision_ids)
+
+    def get_revision(self, revision_id, transaction):
+        """Return the Revision object for a named revision."""
+        return self.get_revisions([revision_id], transaction)[0]
+
+    def get_revisions(self, revision_ids, transaction):
+        """Return the Revision objects for a list of named revisions."""
+        raise NotImplementedError(self.get_revision)
+
+    def get_signature_text(self, revision_id, transaction):
+        """Get the signature text for the digital signature of revision_id.
+        
+        :return: a signature text.
+        """
+        self._guard_revision(revision_id, transaction)
+        return self._get_signature_text(revision_id, transaction)
+
+    def _get_signature_text(self, revision_id, transaction):
+        """Helper method for get_signature_text to return the text itself."""
+        raise NotImplementedError(self.get_signature_text)
+
+    def _guard_revision(self, revision_id, transaction):
+        """Guard method for testing the presence of a revision."""
+        if not self.has_revision_id(revision_id, transaction):
+            raise errors.NoSuchRevision(self, revision_id)
+
+    def has_revision_id(self, revision_id, transaction):
+        """True if the store contains revision_id."""
+        raise NotImplementedError(self.has_revision_id)
+
+    def has_signature(self, revision_id, transaction):
+        """True if the store has a signature for revision_id."""
+        self._guard_revision(revision_id, transaction)
+        return self._has_signature(revision_id, transaction)
+
+    def _has_signature(self, revision_id, transaction):
+        """Return the presence of a signature for revision_id.
+
+        A worker memrthod for has_signature, this can assume the
+        revision is present.
+        """
+        return NotImplementedError(self._has_signature)
+        
+    def total_size(self, transaction):
+        """How big is the store?
+
+        :return: (count, bytes) tuple.
+        """
+        raise NotImplementedError(self.total_size)

=== added file 'bzrlib/store/revision/knit.py'
--- bzrlib/store/revision/knit.py	1970-01-01 00:00:00 +0000
+++ bzrlib/store/revision/knit.py	2007-09-25 08:14:12 +0000
@@ -0,0 +1,141 @@
+# Copyright (C) 2006 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+"""VersionedFile based revision store.
+
+This stores revisions as individual entries in a knit, and signatures in a 
+parallel knit.
+"""
+
+
+from bzrlib import (
+    errors,
+    osutils,
+    revision as _mod_revision,
+    )
+from bzrlib.knit import KnitVersionedFile, KnitPlainFactory
+from bzrlib.store.revision import RevisionStore
+from bzrlib.store.versioned import VersionedFileStore
+from bzrlib.transport import get_transport
+
+
+class KnitRevisionStoreFactory(object):
+    """Factory to create a KnitRevisionStore for testing."""
+
+    def create(self, url):
+        """Create a revision store at url."""
+        t = get_transport(url)
+        t.mkdir('revision-store')
+        versioned_file_store = VersionedFileStore(
+            t.clone('revision-store'),
+            precious=True,
+            versionedfile_class=KnitVersionedFile,
+            versionedfile_kwargs={'delta':False, 'factory':KnitPlainFactory()})
+        return KnitRevisionStore(versioned_file_store)
+
+    def __str__(self):
+        return "KnitRevisionStore"
+
+
+class KnitRevisionStore(RevisionStore):
+    """A RevisionStore layering on a VersionedFileStore."""
+
+    def __init__(self, versioned_file_store):
+        """Create a KnitRevisionStore object.
+
+        :param versioned_file_store: the text store to use for storing 
+                                     revisions and signatures.
+        """
+        super(KnitRevisionStore, self).__init__()
+        self.versioned_file_store = versioned_file_store
+
+    def __repr__(self):
+        return "%s(%s)" % (self.__class__.__name__,
+                           self.versioned_file_store)
+
+    def _add_revision(self, revision, revision_as_file, transaction):
+        """Template method helper to store revision in this store."""
+        self.get_revision_file(transaction).add_lines_with_ghosts(
+            revision.revision_id,
+            revision.parent_ids,
+            osutils.split_lines(revision_as_file.read()))
+
+    def add_revision_signature_text(self, revision_id, signature_text, transaction):
+        """See RevisionStore.add_revision_signature_text()."""
+        self.get_signature_file(transaction).add_lines(
+            revision_id, [], osutils.split_lines(signature_text))
+
+    def all_revision_ids(self, transaction):
+        """See RevisionStore.all_revision_ids()."""
+        rev_file = self.get_revision_file(transaction)
+        return rev_file.get_ancestry(rev_file.versions())
+
+    def get_revisions(self, revision_ids, transaction):
+        """See RevisionStore.get_revisions()."""
+        texts = self._get_serialized_revisions(revision_ids, transaction)
+        revisions = []
+        try:
+            for text, revision_id in zip(texts, revision_ids):
+                r = self._serializer.read_revision_from_string(text)
+                assert r.revision_id == revision_id
+                revisions.append(r)
+        except SyntaxError, e:
+            raise errors.BzrError('failed to unpack revision_xml for %s: %s' %
+                                   (revision_id, str(e)))
+        return revisions
+
+    def _get_serialized_revisions(self, revision_ids, transaction):
+        texts = []
+        vf = self.get_revision_file(transaction)
+        try:
+            return vf.get_texts(revision_ids)
+        except (errors.RevisionNotPresent), e:
+            raise errors.NoSuchRevision(self, e.revision_id)
+
+    def _get_revision_xml(self, revision_id, transaction):
+        try:
+            return self.get_revision_file(transaction).get_text(revision_id)
+        except (errors.RevisionNotPresent):
+            raise errors.NoSuchRevision(self, revision_id)
+
+    def get_revision_file(self, transaction):
+        """Get the revision versioned file object."""
+        return self.versioned_file_store.get_weave_or_empty('revisions', transaction)
+
+    def get_signature_file(self, transaction):
+        """Get the signature text versioned file object."""
+        return self.versioned_file_store.get_weave_or_empty('signatures', transaction)
+
+    def _get_signature_text(self, revision_id, transaction):
+        """See RevisionStore._get_signature_text()."""
+        try:
+            return self.get_signature_file(transaction).get_text(revision_id)
+        except errors.RevisionNotPresent:
+            raise errors.NoSuchRevision(self, revision_id)
+
+    def has_revision_id(self, revision_id, transaction):
+        """True if the store contains revision_id."""
+        return (_mod_revision.is_null(revision_id)
+                or self.get_revision_file(transaction).has_version(revision_id))
+
+    def _has_signature(self, revision_id, transaction):
+        """See RevisionStore._has_signature()."""
+        return self.get_signature_file(transaction).has_version(revision_id)
+
+    def total_size(self, transaction):
+        """ See RevisionStore.total_size()."""
+        return (len(self.all_revision_ids(transaction)),
+            self.versioned_file_store.total_size()[1])

=== added file 'bzrlib/store/revision/text.py'
--- bzrlib/store/revision/text.py	1970-01-01 00:00:00 +0000
+++ bzrlib/store/revision/text.py	2007-09-25 08:14:12 +0000
@@ -0,0 +1,134 @@
+# Copyright (C) 2006 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+"""TextStore based revision store.
+
+This stores revisions as individual text entries in a TextStore and 
+requires access to a inventory weave to produce object graphs.
+"""
+
+
+from cStringIO import StringIO
+
+
+from bzrlib import (
+    cache_utf8,
+    errors,
+    osutils,
+    revision as _mod_revision,
+    )
+from bzrlib.store.revision import RevisionStore
+from bzrlib.store.text import TextStore
+from bzrlib.store.versioned import VersionedFileStore
+from bzrlib.transport import get_transport
+from bzrlib.tsort import topo_sort
+
+
+class TextRevisionStoreTestFactory(object):
+    """Factory to create a TextRevisionStore for testing.
+
+    This creates a inventory weave and hooks it into the revision store
+    """
+
+    def create(self, url):
+        """Create a revision store at url."""
+        t = get_transport(url)
+        t.mkdir('revstore')
+        text_store = TextStore(t.clone('revstore'))
+        return TextRevisionStore(text_store)
+
+    def __str__(self):
+        return "TextRevisionStore"
+
+
+class TextRevisionStore(RevisionStore):
+    """A RevisionStore layering on a TextStore and Inventory weave store."""
+
+    def __init__(self, text_store, serializer=None):
+        """Create a TextRevisionStore object.
+
+        :param text_store: the text store to put serialised revisions into.
+        """
+        super(TextRevisionStore, self).__init__(serializer)
+        self.text_store = text_store
+        self.text_store.register_suffix('sig')
+
+    def _add_revision(self, revision, revision_as_file, transaction):
+        """Template method helper to store revision in this store."""
+        self.text_store.add(revision_as_file, revision.revision_id)
+
+    def add_revision_signature_text(self, revision_id, signature_text, transaction):
+        """See RevisionStore.add_revision_signature_text()."""
+        self.text_store.add(StringIO(signature_text), revision_id, "sig")
+
+    def all_revision_ids(self, transaction):
+        """See RevisionStore.all_revision_ids()."""
+        # for TextRevisionStores, this is only functional
+        # on listable transports.
+        assert self.text_store.listable()
+        result_graph = {}
+        for rev_id in self.text_store:
+            rev = self.get_revision(rev_id, transaction)
+            result_graph[rev_id] = rev.parent_ids
+        # remove ghosts
+        for rev_id, parents in result_graph.items():
+            for parent in list(parents):
+                if not parent in result_graph:
+                    del parents[parents.index(parent)]
+        return topo_sort(result_graph.items())
+
+    def get_revisions(self, revision_ids, transaction):
+        """See RevisionStore.get_revisions()."""
+        revisions = []
+        for revision_id in revision_ids:
+            xml_file = self._get_revision_xml_file(revision_id)
+            try:
+                r = self._serializer.read_revision(xml_file)
+            except SyntaxError, e:
+                raise errors.BzrError('failed to unpack revision_xml',
+                                   [revision_id,
+                                   str(e)])
+            xml_file.close()
+            assert r.revision_id == revision_id
+            revisions.append(r)
+        return revisions
+
+    def _get_revision_xml_file(self, revision_id):
+        _mod_revision.check_not_reserved_id(revision_id)
+        try:
+            return self.text_store.get(revision_id)
+        except (IndexError, KeyError):
+            raise errors.NoSuchRevision(self, revision_id)
+
+    def _get_signature_text(self, revision_id, transaction):
+        """See RevisionStore._get_signature_text()."""
+        try:
+            return self.text_store.get(revision_id, suffix='sig').read()
+        except (IndexError, KeyError):
+            raise errors.NoSuchRevision(self, revision_id)
+
+    def has_revision_id(self, revision_id, transaction):
+        """True if the store contains revision_id."""
+        return (_mod_revision.is_null(revision_id)
+                or self.text_store.has_id(revision_id))
+
+    def _has_signature(self, revision_id, transaction):
+        """See RevisionStore._has_signature()."""
+        return self.text_store.has_id(revision_id, suffix='sig')
+
+    def total_size(self, transaction):
+        """ See RevisionStore.total_size()."""
+        return self.text_store.total_size()

=== modified file 'bzrlib/store/text.py'
--- bzrlib/store/text.py	2008-05-02 03:30:07 +0000
+++ bzrlib/store/text.py	2006-10-05 05:37:25 +0000
@@ -20,15 +20,13 @@
 do any sort of delta compression.
 """
 
-import gzip
 import os
-from cStringIO import StringIO
-
-from bzrlib import osutils
-from bzrlib.errors import BzrError, NoSuchFile, FileExists
 import bzrlib.store
 from bzrlib.trace import mutter
+from bzrlib.errors import BzrError, NoSuchFile, FileExists
 
+import gzip
+from cStringIO import StringIO
 
 
 class TextStore(bzrlib.store.TransportStore):
@@ -101,7 +99,7 @@
             if not self._prefixed:
                 raise
             try:
-                self._transport.mkdir(osutils.dirname(path), mode=self._dir_mode)
+                self._transport.mkdir(self.hash_prefix(fileid)[:-1], mode=self._dir_mode)
             except FileExists:
                 pass
             result = other._transport.copy_to([path], self._transport,

=== modified file 'bzrlib/store/versioned/__init__.py'
--- bzrlib/store/versioned/__init__.py	2008-06-11 04:20:16 +0000
+++ bzrlib/store/versioned/__init__.py	2007-09-25 08:14:12 +0000
@@ -54,8 +54,21 @@
         self._precious = precious
         self._versionedfile_class = versionedfile_class
         self._versionedfile_kwargs = versionedfile_kwargs
-        # Used for passing get_scope to versioned file constructors;
-        self.get_scope = None
+
+    def _clear_cache_id(self, file_id, transaction):
+        """WARNING may lead to inconsistent object references for file_id.
+
+        Remove file_id from the transaction map. 
+
+        NOT in the transaction api because theres no reliable way to clear
+        callers. So its here for very specialised use rather than having an
+        'api' that isn't.
+        """
+        weave = transaction.map.find_weave(file_id)
+        if weave is not None:
+            mutter("old data in transaction in %s for %s", self, file_id)
+            # FIXME abstraction violation - transaction now has stale data.
+            transaction.map.remove_object(weave)
 
     def filename(self, file_id):
         """Return the path relative to the transport root."""
@@ -69,7 +82,7 @@
                 if relpath.endswith(suffix):
                     # TODO: use standard remove_suffix function
                     escaped_id = os.path.basename(relpath[:-len(suffix)])
-                    file_id = self._mapper.unmap(escaped_id)[0]
+                    file_id = self._unescape(escaped_id)
                     if file_id not in ids:
                         ids.add(file_id)
                         yield file_id
@@ -95,6 +108,7 @@
         filename = self.filename(file_id)
         for suffix in suffixes:
             self._transport.delete(filename + suffix)
+        self._clear_cache_id(file_id, transaction)
 
     def _get(self, file_id):
         return self._transport.get(self.filename(file_id))
@@ -116,19 +130,26 @@
         file_id. This is used to reduce duplicate filename calculations when
         using 'get_weave_or_empty'. FOR INTERNAL USE ONLY.
         """
+        weave = transaction.map.find_weave(file_id)
+        if weave is not None:
+            #mutter("cache hit in %s for %s", self, file_id)
+            return weave
         if _filename is None:
             _filename = self.filename(file_id)
         if transaction.writeable():
             w = self._versionedfile_class(_filename, self._transport, self._file_mode,
-                get_scope=self.get_scope, **self._versionedfile_kwargs)
+                                          **self._versionedfile_kwargs)
+            transaction.map.add_weave(file_id, w)
+            transaction.register_dirty(w)
         else:
             w = self._versionedfile_class(_filename,
                                           self._transport,
                                           self._file_mode,
                                           create=False,
                                           access_mode='r',
-                                          get_scope=self.get_scope,
                                           **self._versionedfile_kwargs)
+            transaction.map.add_weave(file_id, w)
+            transaction.register_clean(w, precious=self._precious)
         return w
 
     def _make_new_versionedfile(self, file_id, transaction,
@@ -147,17 +168,15 @@
             # we try without making the directory first because thats optimising
             # for the common case.
             weave = self._versionedfile_class(_filename, self._transport, self._file_mode, create=True,
-                get_scope=self.get_scope, **self._versionedfile_kwargs)
+                                              **self._versionedfile_kwargs)
         except errors.NoSuchFile:
             if not self._prefixed:
                 # unexpected error - NoSuchFile is expected to be raised on a
                 # missing dir only and that only occurs when we are prefixed.
                 raise
-            dirname = osutils.dirname(_filename)
-            self._transport.mkdir(dirname, mode=self._dir_mode)
-            weave = self._versionedfile_class(_filename, self._transport,
+            self._transport.mkdir(self.hash_prefix(file_id), mode=self._dir_mode)
+            weave = self._versionedfile_class(_filename, self._transport, 
                                               self._file_mode, create=True,
-                                              get_scope=self.get_scope,
                                               **self._versionedfile_kwargs)
         return weave
 
@@ -174,15 +193,21 @@
         except errors.NoSuchFile:
             weave = self._make_new_versionedfile(file_id, transaction,
                 known_missing=True, _filename=_filename)
+            transaction.map.add_weave(file_id, weave)
+            # has to be dirty - its able to mutate on its own.
+            transaction.register_dirty(weave)
             return weave
 
     def _put_weave(self, file_id, weave, transaction):
         """Preserved here for upgrades-to-weaves to use."""
         myweave = self._make_new_versionedfile(file_id, transaction)
-        myweave.insert_record_stream(weave.get_record_stream(
-            [(version,) for version in weave.versions()],
-            'topological', False))
+        myweave.join(weave)
 
+    def copy(self, source, result_id, transaction):
+        """Copy the source versioned file to result_id in this store."""
+        self._clear_cache_id(result_id, transaction)
+        source.copy_to(self.filename(result_id), self._transport)
+ 
     def copy_all_ids(self, store_from, pb=None, from_transaction=None,
                      to_transaction=None):
         """Copy all the file ids from store_from into self."""
@@ -213,6 +238,7 @@
         :param from_transaction: required current transaction in from_store.
         """
         from bzrlib.transactions import PassThroughTransaction
+        assert isinstance(from_store, WeaveStore)
         if from_transaction is None:
             warn("WeaveStore.copy_multi without a from_transaction parameter "
                  "is deprecated. Please provide a from_transaction.",
@@ -237,10 +263,7 @@
                 # joining is fast with knits, and bearable for weaves -
                 # indeed the new case can be optimised if needed.
                 target = self._make_new_versionedfile(f, to_transaction)
-                source = from_store.get_weave(f, from_transaction)
-                target.insert_record_stream(source.get_record_stream(
-                    [(version,) for version in source.versions()],
-                    'topological', False))
+                target.join(from_store.get_weave(f, from_transaction))
         finally:
             pb.finished()
 

=== removed file 'bzrlib/switch.py'
--- bzrlib/switch.py	2007-12-07 05:31:54 +0000
+++ bzrlib/switch.py	1970-01-01 00:00:00 +0000
@@ -1,132 +0,0 @@
-# Copyright (C) 2006, 2007 Canonical Ltd.
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-# Original author: David Allouche
-
-from bzrlib import errors, merge, revision
-from bzrlib.branch import Branch, BranchFormat, BranchReferenceFormat
-from bzrlib.bzrdir import BzrDir
-from bzrlib.trace import note
-
-
-def switch(control_dir, to_branch, force=False):
-    """Switch the branch associated with a checkout.
-
-    :param control_dir: BzrDir of the checkout to change
-    :param to_branch: branch that the checkout is to reference
-    :param force: skip the check for local commits in a heavy checkout
-    """
-    _check_pending_merges(control_dir, force)
-    try:
-        source_repository = control_dir.open_branch().repository
-    except errors.NotBranchError:
-        source_repository = to_branch.repository
-    _set_branch_location(control_dir, to_branch, force)
-    tree = control_dir.open_workingtree()
-    _update(tree, source_repository)
-
-
-def _check_pending_merges(control, force=False):
-    """Check that there are no outstanding pending merges before switching.
-
-    :param control: BzrDir of the branch to check
-    """
-    try:
-        tree = control.open_workingtree()
-    except errors.NotBranchError, ex:
-        # Lightweight checkout and branch is no longer there
-        if force:
-            return
-        else:
-            raise ex
-    # XXX: Should the tree be locked for get_parent_ids?
-    existing_pending_merges = tree.get_parent_ids()[1:]
-    if len(existing_pending_merges) > 0:
-        raise errors.BzrCommandError('Pending merges must be '
-            'committed or reverted before using switch.')
-
-
-def _set_branch_location(control, to_branch, force=False):
-    """Set location value of a branch reference.
-
-    :param control: BzrDir of the checkout to change
-    :param to_branch: branch that the checkout is to reference
-    :param force: skip the check for local commits in a heavy checkout
-    """
-    branch_format = control.find_branch_format()
-    if branch_format.get_reference(control) is not None:
-        # Lightweight checkout: update the branch reference
-        branch_format.set_reference(control, to_branch)
-    else:
-        b = control.open_branch()
-        bound_branch = b.get_bound_location()
-        if bound_branch is not None:
-            # Heavyweight checkout: check all local commits
-            # have been pushed to the current bound branch then
-            # synchronise the local branch with the new remote branch
-            # and bind to it
-            possible_transports = []
-            if not force and _any_local_commits(b, possible_transports):
-                raise errors.BzrCommandError(
-                    'Cannot switch as local commits found in the checkout. '
-                    'Commit these to the bound branch or use --force to '
-                    'throw them away.')
-            b.set_bound_location(None)
-            b.pull(to_branch, overwrite=True,
-                possible_transports=possible_transports)
-            b.set_bound_location(to_branch.base)
-        else:
-            raise errors.BzrCommandError('Cannot switch a branch, '
-                'only a checkout.')
-
-
-def _any_local_commits(this_branch, possible_transports):
-    """Does this branch have any commits not in the master branch?"""
-    last_rev = revision.ensure_null(this_branch.last_revision())
-    if last_rev != revision.NULL_REVISION:
-        other_branch = this_branch.get_master_branch(possible_transports)
-        this_branch.lock_read()
-        other_branch.lock_read()
-        try:
-            other_last_rev = other_branch.last_revision()
-            graph = this_branch.repository.get_graph(
-                other_branch.repository)
-            if not graph.is_ancestor(last_rev, other_last_rev):
-                return True
-        finally:
-            other_branch.unlock()
-            this_branch.unlock()
-    return False
-
-
-def _update(tree, source_repository):
-    """Update a working tree to the latest revision of its branch.
-
-    :param tree: the working tree
-    :param source_repository: repository holding the revisions
-    """
-    tree.lock_tree_write()
-    try:
-        to_branch = tree.branch
-        if tree.last_revision() == to_branch.last_revision():
-            note("Tree is up to date at revision %d.", to_branch.revno())
-            return
-        base_tree = source_repository.revision_tree(tree.last_revision())
-        merge.Merge3Merger(tree, tree, base_tree, to_branch.basis_tree())
-        tree.set_last_revision(to_branch.last_revision())
-        note('Updated to revision %d.' % to_branch.revno())
-    finally:
-        tree.unlock()

=== modified file 'bzrlib/symbol_versioning.py'
--- bzrlib/symbol_versioning.py	2008-07-17 01:50:02 +0000
+++ bzrlib/symbol_versioning.py	2007-10-10 00:21:57 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007, 2008 Canonical Ltd
+# Copyright (C) 2006, 2007 Canonical Ltd
 #   Authors: Robert Collins <robert.collins@canonical.com> and others
 #
 # This program is free software; you can redistribute it and/or modify
@@ -21,14 +21,11 @@
 """
 
 __all__ = ['deprecated_function',
-           'deprecated_in',
            'deprecated_list',
            'deprecated_method',
            'DEPRECATED_PARAMETER',
            'deprecated_passed',
-           'set_warning_method',
-           'warn',
-           'zero_seven',
+           'warn', 'set_warning_method', 'zero_seven',
            'zero_eight',
            'zero_nine',
            'zero_ten',
@@ -43,20 +40,10 @@
            'zero_ninety',
            'zero_ninetyone',
            'zero_ninetytwo',
-           'zero_ninetythree',
-           'one_zero',
-           'one_one',
-           'one_two',
-           'one_three',
-           'one_four',
-           'one_five',
-           'one_six',
            ]
 
 from warnings import warn
 
-import bzrlib
-
 
 DEPRECATED_PARAMETER = "A deprecated parameter marker."
 zero_seven = "%s was deprecated in version 0.7."
@@ -74,24 +61,6 @@
 zero_ninety = "%s was deprecated in version 0.90."
 zero_ninetyone = "%s was deprecated in version 0.91."
 zero_ninetytwo = "%s was deprecated in version 0.92."
-one_zero = "%s was deprecated in version 1.0."
-zero_ninetythree = one_zero # Maintained for backwards compatibility
-one_one = "%s was deprecated in version 1.1."
-one_two = "%s was deprecated in version 1.2."
-one_three = "%s was deprecated in version 1.3."
-one_four = "%s was deprecated in version 1.4."
-one_five = "%s was deprecated in version 1.5."
-one_six = "%s was deprecated in version 1.6."
-
-
-def deprecated_in(version_tuple):
-    """Generate a message that something was deprecated in a release.
-
-    >>> deprecated_in((1, 4, 0))
-    '%s was deprecated in version 1.4.'
-    """
-    return ("%%s was deprecated in version %s."
-            % bzrlib._format_version_tuple(version_tuple))
 
 
 def set_warning_method(method):
@@ -138,8 +107,6 @@
         
         def decorated_function(*args, **kwargs):
             """This is the decorated function."""
-            from bzrlib import trace
-            trace.mutter_callsite(4, "Deprecated function called")
             warn(deprecation_string(callable, deprecation_version),
                 DeprecationWarning, stacklevel=2)
             return callable(*args, **kwargs)
@@ -166,7 +133,6 @@
         
         def decorated_method(self, *args, **kwargs):
             """This is the decorated method."""
-            from bzrlib import trace
             if callable.__name__ == '__init__':
                 symbol = "%s.%s" % (self.__class__.__module__,
                                     self.__class__.__name__,
@@ -176,7 +142,6 @@
                                        self.__class__.__name__,
                                        callable.__name__
                                        )
-            trace.mutter_callsite(4, "Deprecated method called")
             warn(deprecation_version % symbol, DeprecationWarning, stacklevel=2)
             return callable(self, *args, **kwargs)
         _populate_decorated(callable, deprecation_version, "method",
@@ -195,7 +160,7 @@
     # we cannot just forward to a new method name.I.e. in the following
     # examples we would want to have callers that pass any value to 'bad' be
     # given a warning - because we have applied:
-    # @deprecated_parameter('bad', deprecated_in((1, 5, 0))
+    # @deprecated_parameter('bad', zero_seven)
     #
     # def __init__(self, bad=None)
     # def __init__(self, bad, other)
@@ -263,8 +228,7 @@
         ):
         """Create a dict that warns when read or modified.
 
-        :param deprecation_version: string for the warning format to raise,
-            typically from deprecated_in()
+        :param deprecation_version: something like zero_nine
         :param initial_value: The contents of the dict
         :param variable_name: This allows better warnings to be printed
         :param advice: String of advice on what callers should do instead 
@@ -289,8 +253,7 @@
                     initial_value, extra=None):
     """Create a list that warns when modified
 
-    :param deprecation_version: string for the warning format to raise,
-        typically from deprecated_in()
+    :param deprecation_version: something like zero_nine
     :param initial_value: The contents of the list
     :param variable_name: This allows better warnings to be printed
     :param extra: Extra info to print when printing a warning
@@ -335,59 +298,3 @@
                 return self._warn_deprecated(list.pop)
 
     return _DeprecatedList(initial_value)
-
-
-def _check_for_filter(error_only):
-    """Check if there is already a filter for deprecation warnings.
-    
-    :param error_only: Only match an 'error' filter
-    :return: True if a filter is found, False otherwise
-    """
-    import warnings
-    for filter in warnings.filters:
-        if issubclass(DeprecationWarning, filter[2]):
-            # This filter will effect DeprecationWarning
-            if not error_only or filter[0] == 'error':
-                return True
-    return False
-
-
-def suppress_deprecation_warnings(override=True):
-    """Call this function to suppress all deprecation warnings.
-
-    When this is a final release version, we don't want to annoy users with
-    lots of deprecation warnings. We only want the deprecation warnings when
-    running a dev or release candidate.
-
-    :param override: If True, always set the ignore, if False, only set the
-        ignore if there isn't already a filter.
-    """
-    import warnings
-    if not override and _check_for_filter(error_only=False):
-        # If there is already a filter effecting suppress_deprecation_warnings,
-        # then skip it.
-        return
-    warnings.filterwarnings('ignore', category=DeprecationWarning)
-
-
-def activate_deprecation_warnings(override=True):
-    """Call this function to activate deprecation warnings.
-
-    When running in a 'final' release we suppress deprecation warnings.
-    However, the test suite wants to see them. So when running selftest, we
-    re-enable the deprecation warnings.
-
-    Note: warnings that have already been issued under 'ignore' will not be
-    reported after this point. The 'warnings' module has already marked them as
-    handled, so they don't get issued again.
-
-    :param override: If False, only add a filter if there isn't an error filter
-        already. (This slightly differs from suppress_deprecation_warnings, in
-        because it always overrides everything but -Werror).
-    """
-    import warnings
-    if not override and _check_for_filter(error_only=True):
-        # DeprecationWarnings are already turned into errors, don't downgrade
-        # them to 'default'.
-        return
-    warnings.filterwarnings('default', category=DeprecationWarning)

=== modified file 'bzrlib/tag.py'
--- bzrlib/tag.py	2008-06-07 22:15:25 +0000
+++ bzrlib/tag.py	2007-09-18 18:55:00 +0000
@@ -196,8 +196,7 @@
         :param overwrite: Overwrite conflicting tags in the target branch
 
         :returns: A list of tags that conflicted, each of which is 
-            (tagname, source_target, dest_target), or None if no copying was
-            done.
+            (tagname, source_target, dest_target).
         """
         if self.branch == to_tags.branch:
             return

=== modified file 'bzrlib/testament.py'
--- bzrlib/testament.py	2008-04-24 07:22:53 +0000
+++ bzrlib/testament.py	2007-02-18 00:22:24 +0000
@@ -106,10 +106,8 @@
         self.parent_ids = rev.parent_ids[:]
         self.inventory = inventory
         self.revprops = copy(rev.properties)
-        if contains_whitespace(self.revision_id):
-            raise ValueError(self.revision_id)
-        if contains_linebreaks(self.committer):
-            raise ValueError(self.committer)
+        assert not contains_whitespace(self.revision_id)
+        assert not contains_linebreaks(self.committer)
 
     def as_text_lines(self):
         """Yield text form as a sequence of lines.
@@ -127,8 +125,7 @@
         # inventory length contains the root, which is not shown here
         a('parents:\n')
         for parent_id in sorted(self.parent_ids):
-            if contains_whitespace(parent_id):
-                raise ValueError(parent_id)
+            assert not contains_whitespace(parent_id)
             a('  %s\n' % parent_id)
         a('message:\n')
         for l in self.message.splitlines():
@@ -137,6 +134,10 @@
         for path, ie in self._get_entries():
             a(self._entry_to_line(path, ie))
         r.extend(self._revprops_to_lines())
+        if __debug__:
+            for l in r:
+                assert isinstance(l, basestring), \
+                    '%r of type %s is not a plain string' % (l, type(l))
         return [line.encode('utf-8') for line in r]
 
     def _get_entries(self):
@@ -145,25 +146,22 @@
         return entries
 
     def _escape_path(self, path):
-        if contains_linebreaks(path):
-            raise ValueError(path)
+        assert not contains_linebreaks(path)
         return unicode(path.replace('\\', '/').replace(' ', '\ '))
 
     def _entry_to_line(self, path, ie):
         """Turn an inventory entry into a testament line"""
-        if contains_whitespace(ie.file_id):
-            raise ValueError(ie.file_id)
+        assert not contains_whitespace(ie.file_id)
+
         content = ''
         content_spacer=''
         if ie.kind == 'file':
             # TODO: avoid switching on kind
-            if not ie.text_sha1:
-                raise AssertionError()
+            assert ie.text_sha1
             content = ie.text_sha1
             content_spacer = ' '
         elif ie.kind == 'symlink':
-            if not ie.symlink_target:
-                raise AssertionError()
+            assert ie.symlink_target
             content = self._escape_path(ie.symlink_target)
             content_spacer = ' '
 
@@ -188,8 +186,8 @@
             return []
         r = ['properties:\n']
         for name, value in sorted(self.revprops.items()):
-            if contains_whitespace(name):
-                raise ValueError(name)
+            assert isinstance(name, str)
+            assert not contains_whitespace(name)
             r.append('  %s:\n' % name)
             for line in value.splitlines():
                 r.append(u'    %s\n' % line)
@@ -225,8 +223,7 @@
         return self.inventory.iter_entries()
 
     def _escape_path(self, path):
-        if contains_linebreaks(path):
-            raise ValueError(path)
+        assert not contains_linebreaks(path)
         if path == '':
             path = '.'
         return unicode(path.replace('\\', '/').replace(' ', '\ '))

=== renamed file 'bzrlib/tests/http_utils.py' => 'bzrlib/tests/HTTPTestUtil.py'
--- bzrlib/tests/http_utils.py	2008-08-14 02:15:31 +0000
+++ bzrlib/tests/HTTPTestUtil.py	2007-10-17 15:36:20 +0000
@@ -17,64 +17,115 @@
 from cStringIO import StringIO
 import errno
 import md5
+from SimpleHTTPServer import SimpleHTTPRequestHandler
 import re
 import sha
 import socket
-import threading
 import time
 import urllib2
 import urlparse
 
-from bzrlib import (
-    errors,
-    tests,
+from bzrlib.smart import protocol
+from bzrlib.tests import TestCaseWithTransport
+from bzrlib.tests.HttpServer import (
+    HttpServer,
+    TestingHTTPRequestHandler,
     )
-from bzrlib.smart import medium, protocol
-from bzrlib.tests import http_server
 from bzrlib.transport import (
-    chroot,
     get_transport,
     )
 
 
-class HTTPServerWithSmarts(http_server.HttpServer):
+class WallRequestHandler(TestingHTTPRequestHandler):
+    """Whatever request comes in, close the connection"""
+
+    def handle_one_request(self):
+        """Handle a single HTTP request, by abruptly closing the connection"""
+        self.close_connection = 1
+
+
+class BadStatusRequestHandler(TestingHTTPRequestHandler):
+    """Whatever request comes in, returns a bad status"""
+
+    def parse_request(self):
+        """Fakes handling a single HTTP request, returns a bad status"""
+        ignored = TestingHTTPRequestHandler.parse_request(self)
+        try:
+            self.send_response(0, "Bad status")
+            self.end_headers()
+        except socket.error, e:
+            # We don't want to pollute the test results with
+            # spurious server errors while test succeed. In our
+            # case, it may occur that the test has already read
+            # the 'Bad Status' and closed the socket while we are
+            # still trying to send some headers... So the test is
+            # ok, but if we raise the exception, the output is
+            # dirty. So we don't raise, but we close the
+            # connection, just to be safe :)
+            spurious = [errno.EPIPE,
+                        errno.ECONNRESET,
+                        errno.ECONNABORTED,
+                        ]
+            if (len(e.args) > 0) and (e.args[0] in spurious):
+                self.close_connection = 1
+                pass
+            else:
+                raise
+        return False
+
+
+class InvalidStatusRequestHandler(TestingHTTPRequestHandler):
+    """Whatever request comes in, returns am invalid status"""
+
+    def parse_request(self):
+        """Fakes handling a single HTTP request, returns a bad status"""
+        ignored = TestingHTTPRequestHandler.parse_request(self)
+        self.wfile.write("Invalid status line\r\n")
+        return False
+
+
+class BadProtocolRequestHandler(TestingHTTPRequestHandler):
+    """Whatever request comes in, returns a bad protocol version"""
+
+    def parse_request(self):
+        """Fakes handling a single HTTP request, returns a bad status"""
+        ignored = TestingHTTPRequestHandler.parse_request(self)
+        # Returns an invalid protocol version, but curl just
+        # ignores it and those cannot be tested.
+        self.wfile.write("%s %d %s\r\n" % ('HTTP/0.0',
+                                           404,
+                                           'Look at my protocol version'))
+        return False
+
+
+class ForbiddenRequestHandler(TestingHTTPRequestHandler):
+    """Whatever request comes in, returns a 403 code"""
+
+    def parse_request(self):
+        """Handle a single HTTP request, by replying we cannot handle it"""
+        ignored = TestingHTTPRequestHandler.parse_request(self)
+        self.send_error(403)
+        return False
+
+
+class HTTPServerWithSmarts(HttpServer):
     """HTTPServerWithSmarts extends the HttpServer with POST methods that will
     trigger a smart server to execute with a transport rooted at the rootdir of
     the HTTP server.
     """
 
-    def __init__(self, protocol_version=None):
-        http_server.HttpServer.__init__(self, SmartRequestHandler,
-                                        protocol_version=protocol_version)
-
-
-class SmartRequestHandler(http_server.TestingHTTPRequestHandler):
-    """Extend TestingHTTPRequestHandler to support smart client POSTs.
-    
-    XXX: This duplicates a fair bit of the logic in bzrlib.transport.http.wsgi.
-    """
+    def __init__(self):
+        HttpServer.__init__(self, SmartRequestHandler)
+
+
+class SmartRequestHandler(TestingHTTPRequestHandler):
+    """Extend TestingHTTPRequestHandler to support smart client POSTs."""
 
     def do_POST(self):
         """Hand the request off to a smart server instance."""
-        backing = get_transport(self.server.test_case_server._home_dir)
-        chroot_server = chroot.ChrootServer(backing)
-        chroot_server.setUp()
-        try:
-            t = get_transport(chroot_server.get_url())
-            self.do_POST_inner(t)
-        finally:
-            chroot_server.tearDown()
-
-    def do_POST_inner(self, chrooted_transport):
         self.send_response(200)
         self.send_header("Content-type", "application/octet-stream")
-        if not self.path.endswith('.bzr/smart'):
-            raise AssertionError(
-                'POST to path not ending in .bzr/smart: %r' % (self.path,))
-        t = chrooted_transport.clone(self.path[:-len('.bzr/smart')])
-        # if this fails, we should return 400 bad request, but failure is
-        # failure for now - RBC 20060919
-        data_length = int(self.headers['Content-Length'])
+        transport = get_transport(self.server.test_case_server._home_dir)
         # TODO: We might like to support streaming responses.  1.0 allows no
         # Content-length in this case, so for integrity we should perform our
         # own chunking within the stream.
@@ -82,24 +133,86 @@
         # the HTTP chunking as this will allow HTTP persistence safely, even if
         # we have to stop early due to error, but we would also have to use the
         # HTTP trailer facility which may not be widely available.
-        request_bytes = self.rfile.read(data_length)
-        protocol_factory, unused_bytes = medium._get_protocol_factory_for_bytes(
-            request_bytes)
         out_buffer = StringIO()
-        smart_protocol_request = protocol_factory(t, out_buffer.write, '/')
+        smart_protocol_request = protocol.SmartServerRequestProtocolOne(
+                transport, out_buffer.write)
+        # if this fails, we should return 400 bad request, but failure is
+        # failure for now - RBC 20060919
+        data_length = int(self.headers['Content-Length'])
         # Perhaps there should be a SmartServerHTTPMedium that takes care of
         # feeding the bytes in the http request to the smart_protocol_request,
         # but for now it's simpler to just feed the bytes directly.
-        smart_protocol_request.accept_bytes(unused_bytes)
-        if not (smart_protocol_request.next_read_size() == 0):
-            raise errors.SmartProtocolError(
-                "not finished reading, but all data sent to protocol.")
+        smart_protocol_request.accept_bytes(self.rfile.read(data_length))
+        assert smart_protocol_request.next_read_size() == 0, (
+            "not finished reading, but all data sent to protocol.")
         self.send_header("Content-Length", str(len(out_buffer.getvalue())))
         self.end_headers()
         self.wfile.write(out_buffer.getvalue())
 
 
-class TestCaseWithWebserver(tests.TestCaseWithTransport):
+class LimitedRangeRequestHandler(TestingHTTPRequestHandler):
+    """Errors out when range specifiers exceed the limit"""
+
+    def get_multiple_ranges(self, file, file_size, ranges):
+        """Refuses the multiple ranges request"""
+        tcs = self.server.test_case_server
+        if tcs.range_limit is not None and len(ranges) > tcs.range_limit:
+            file.close()
+            # Emulate apache behavior
+            self.send_error(400, "Bad Request")
+            return
+        return TestingHTTPRequestHandler.get_multiple_ranges(self, file,
+                                                             file_size, ranges)
+
+    def do_GET(self):
+        tcs = self.server.test_case_server
+        tcs.GET_request_nb += 1
+        return TestingHTTPRequestHandler.do_GET(self)
+
+
+class LimitedRangeHTTPServer(HttpServer):
+    """An HttpServer erroring out on requests with too much range specifiers"""
+
+    def __init__(self, request_handler=LimitedRangeRequestHandler,
+                 range_limit=None):
+        HttpServer.__init__(self, request_handler)
+        self.range_limit = range_limit
+        self.GET_request_nb = 0
+
+
+class SingleRangeRequestHandler(TestingHTTPRequestHandler):
+    """Always reply to range request as if they were single.
+
+    Don't be explicit about it, just to annoy the clients.
+    """
+
+    def get_multiple_ranges(self, file, file_size, ranges):
+        """Answer as if it was a single range request and ignores the rest"""
+        (start, end) = ranges[0]
+        return self.get_single_range(file, file_size, start, end)
+
+
+class SingleOnlyRangeRequestHandler(TestingHTTPRequestHandler):
+    """Only reply to simple range requests, errors out on multiple"""
+
+    def get_multiple_ranges(self, file, file_size, ranges):
+        """Refuses the multiple ranges request"""
+        if len(ranges) > 1:
+            file.close()
+            self.send_error(416, "Requested range not satisfiable")
+            return
+        (start, end) = ranges[0]
+        return self.get_single_range(file, file_size, start, end)
+
+
+class NoRangeRequestHandler(TestingHTTPRequestHandler):
+    """Ignore range requests without notice"""
+
+    # Just bypass the range handling done by TestingHTTPRequestHandler
+    do_GET = SimpleHTTPRequestHandler.do_GET
+
+
+class TestCaseWithWebserver(TestCaseWithTransport):
     """A support class that provides readonly urls that are http://.
 
     This is done by forcing the readonly server to be an http
@@ -108,7 +221,7 @@
     """
     def setUp(self):
         super(TestCaseWithWebserver, self).setUp()
-        self.transport_readonly_server = http_server.HttpServer
+        self.transport_readonly_server = HttpServer
 
 
 class TestCaseWithTwoWebservers(TestCaseWithWebserver):
@@ -119,7 +232,7 @@
     """
     def setUp(self):
         super(TestCaseWithTwoWebservers, self).setUp()
-        self.transport_secondary_server = http_server.HttpServer
+        self.transport_secondary_server = HttpServer
         self.__secondary_server = None
 
     def create_transport_secondary_server(self):
@@ -138,18 +251,18 @@
         return self.__secondary_server
 
 
-class ProxyServer(http_server.HttpServer):
+class ProxyServer(HttpServer):
     """A proxy test server for http transports."""
 
     proxy_requests = True
 
 
-class RedirectRequestHandler(http_server.TestingHTTPRequestHandler):
+class RedirectRequestHandler(TestingHTTPRequestHandler):
     """Redirect all request to the specified server"""
 
     def parse_request(self):
         """Redirect a single HTTP request to another host"""
-        valid = http_server.TestingHTTPRequestHandler.parse_request(self)
+        valid = TestingHTTPRequestHandler.parse_request(self)
         if valid:
             tcs = self.server.test_case_server
             code, target = tcs.is_redirected(self.path)
@@ -157,8 +270,6 @@
                 # Redirect as instructed
                 self.send_response(code)
                 self.send_header('Location', target)
-                # We do not send a body
-                self.send_header('Content-Length', '0')
                 self.end_headers()
                 return False # The job is done
             else:
@@ -167,13 +278,11 @@
         return valid
 
 
-class HTTPServerRedirecting(http_server.HttpServer):
+class HTTPServerRedirecting(HttpServer):
     """An HttpServer redirecting to another server """
 
-    def __init__(self, request_handler=RedirectRequestHandler,
-                 protocol_version=None):
-        http_server.HttpServer.__init__(self, request_handler,
-                                        protocol_version=protocol_version)
+    def __init__(self, request_handler=RedirectRequestHandler):
+        HttpServer.__init__(self, request_handler)
         # redirections is a list of tuples (source, target, code)
         # - source is a regexp for the paths requested
         # - target is a replacement for re.sub describing where
@@ -231,7 +340,7 @@
        self.old_server = self.get_secondary_server()
 
 
-class AuthRequestHandler(http_server.TestingHTTPRequestHandler):
+class AuthRequestHandler(TestingHTTPRequestHandler):
     """Requires an authentication to process requests.
 
     This is intended to be used with a server that always and
@@ -246,7 +355,7 @@
 
     def do_GET(self):
         if self.authorized():
-            return http_server.TestingHTTPRequestHandler.do_GET(self)
+            return TestingHTTPRequestHandler.do_GET(self)
         else:
             # Note that we must update test_case_server *before*
             # sending the error or the client may try to read it
@@ -255,8 +364,6 @@
             tcs.auth_required_errors += 1
             self.send_response(tcs.auth_error_code)
             self.send_header_auth_reqed()
-            # We do not send a body
-            self.send_header('Content-Length', '0')
             self.end_headers()
             return
 
@@ -319,7 +426,7 @@
         self.send_header(tcs.auth_header_sent,header)
 
 
-class AuthServer(http_server.HttpServer):
+class AuthServer(HttpServer):
     """Extends HttpServer with a dictionary of passwords.
 
     This is used as a base class for various schemes which should
@@ -336,10 +443,8 @@
     auth_error_code = None
     auth_realm = "Thou should not pass"
 
-    def __init__(self, request_handler, auth_scheme,
-                 protocol_version=None):
-        http_server.HttpServer.__init__(self, request_handler,
-                                        protocol_version=protocol_version)
+    def __init__(self, request_handler, auth_scheme):
+        HttpServer.__init__(self, request_handler)
         self.auth_scheme = auth_scheme
         self.password_of = {}
         self.auth_required_errors = 0
@@ -368,10 +473,8 @@
 
     auth_nonce = 'now!'
 
-    def __init__(self, request_handler, auth_scheme,
-                 protocol_version=None):
-        AuthServer.__init__(self, request_handler, auth_scheme,
-                            protocol_version=protocol_version)
+    def __init__(self, request_handler, auth_scheme):
+        AuthServer.__init__(self, request_handler, auth_scheme)
 
     def digest_authorized(self, auth, command):
         nonce = auth['nonce']
@@ -432,36 +535,32 @@
 class HTTPBasicAuthServer(HTTPAuthServer):
     """An HTTP server requiring basic authentication"""
 
-    def __init__(self, protocol_version=None):
-        HTTPAuthServer.__init__(self, BasicAuthRequestHandler, 'basic',
-                                protocol_version=protocol_version)
+    def __init__(self):
+        HTTPAuthServer.__init__(self, BasicAuthRequestHandler, 'basic')
         self.init_http_auth()
 
 
 class HTTPDigestAuthServer(DigestAuthServer, HTTPAuthServer):
     """An HTTP server requiring digest authentication"""
 
-    def __init__(self, protocol_version=None):
-        DigestAuthServer.__init__(self, DigestAuthRequestHandler, 'digest',
-                                  protocol_version=protocol_version)
+    def __init__(self):
+        DigestAuthServer.__init__(self, DigestAuthRequestHandler, 'digest')
         self.init_http_auth()
 
 
 class ProxyBasicAuthServer(ProxyAuthServer):
     """A proxy server requiring basic authentication"""
 
-    def __init__(self, protocol_version=None):
-        ProxyAuthServer.__init__(self, BasicAuthRequestHandler, 'basic',
-                                 protocol_version=protocol_version)
+    def __init__(self):
+        ProxyAuthServer.__init__(self, BasicAuthRequestHandler, 'basic')
         self.init_proxy_auth()
 
 
 class ProxyDigestAuthServer(DigestAuthServer, ProxyAuthServer):
     """A proxy server requiring basic authentication"""
 
-    def __init__(self, protocol_version=None):
-        ProxyAuthServer.__init__(self, DigestAuthRequestHandler, 'digest',
-                                 protocol_version=protocol_version)
+    def __init__(self):
+        ProxyAuthServer.__init__(self, DigestAuthRequestHandler, 'digest')
         self.init_proxy_auth()
 
 

=== renamed file 'bzrlib/tests/http_server.py' => 'bzrlib/tests/HttpServer.py'
--- bzrlib/tests/http_server.py	2008-06-10 05:55:15 +0000
+++ bzrlib/tests/HttpServer.py	2007-09-20 11:05:51 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007 Canonical Ltd
+# Copyright (C) 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -14,23 +14,22 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
+import BaseHTTPServer
 import errno
-import httplib
 import os
+from SimpleHTTPServer import SimpleHTTPRequestHandler
+import socket
 import posixpath
 import random
 import re
-import SimpleHTTPServer
-import socket
-import SocketServer
 import sys
 import threading
 import time
 import urllib
 import urlparse
 
-from bzrlib import transport
-from bzrlib.transport import local
+from bzrlib.transport import Server
+from bzrlib.transport.local import LocalURLServer
 
 
 class WebserverNotAvailable(Exception):
@@ -42,27 +41,12 @@
         return 'path %s is not in %s' % self.args
 
 
-class TestingHTTPRequestHandler(SimpleHTTPServer.SimpleHTTPRequestHandler):
+class TestingHTTPRequestHandler(SimpleHTTPRequestHandler):
     """Handles one request.
 
-    A TestingHTTPRequestHandler is instantiated for every request received by
-    the associated server. Note that 'request' here is inherited from the base
-    TCPServer class, for the HTTP server it is really a connection which itself
-    will handle one or several HTTP requests.
+    A TestingHTTPRequestHandler is instantiated for every request
+    received by the associated server.
     """
-    # Default protocol version
-    protocol_version = 'HTTP/1.1'
-
-    # The Message-like class used to parse the request headers
-    MessageClass = httplib.HTTPMessage
-
-    def setup(self):
-        SimpleHTTPServer.SimpleHTTPRequestHandler.setup(self)
-        self._cwd = self.server._home_dir
-        tcs = self.server.test_case_server
-        if tcs.protocol_version is not None:
-            # If the test server forced a protocol version, use it
-            self.protocol_version = tcs.protocol_version
 
     def log_message(self, format, *args):
         tcs = self.server.test_case_server
@@ -80,16 +64,52 @@
         connection early to avoid polluting the test results.
         """
         try:
-            SimpleHTTPServer.SimpleHTTPRequestHandler.handle_one_request(self)
+            self._handle_one_request()
         except socket.error, e:
-            # Any socket error should close the connection, but some errors are
-            # due to the client closing early and we don't want to pollute test
-            # results, so we raise only the others.
+            if (len(e.args) > 0
+                and e.args[0] in (errno.EPIPE, errno.ECONNRESET,
+                                  errno.ECONNABORTED,)):
+                self.close_connection = 1
+                pass
+            else:
+                raise
+
+    def _handle_one_request(self):
+        """
+        Request handling as defined in the base class.
+
+        You normally don't need to override this method; see the class
+        __doc__ string for information on how to handle specific HTTP
+        commands such as GET and POST.
+
+        On some platforms, notably OS X, a lot of EAGAIN (resource temporary
+        unavailable) occur. We retry silently at most 10 times.
+        """
+        for i in xrange(1,11): # Don't try more than 10 times
+            try:
+                self.raw_requestline = self.rfile.readline()
+            except socket.error, e:
+                if e.args[0] in (errno.EAGAIN, errno.EWOULDBLOCK):
+                    # omitted for now because some tests look at the log of
+                    # the server and expect to see no errors.  see recent
+                    # email thread. -- mbp 20051021. 
+                    ## self.log_message('EAGAIN (%d) while reading from raw_requestline' % i)
+                    time.sleep(0.01)
+                    continue
+                raise
+            else:
+                break
+        if not self.raw_requestline:
             self.close_connection = 1
-            if (len(e.args) == 0
-                or e.args[0] not in (errno.EPIPE, errno.ECONNRESET,
-                                     errno.ECONNABORTED, errno.EBADF)):
-                raise
+            return
+        if not self.parse_request(): # An error code has been sent, just exit
+            return
+        mname = 'do_' + self.command
+        if getattr(self, mname, None) is None:
+            self.send_error(501, "Unsupported method (%r)" % self.command)
+            return
+        method = getattr(self, mname)
+        method()
 
     _range_regexp = re.compile(r'^(?P<start>\d+)-(?P<end>\d+)$')
     _tail_regexp = re.compile(r'^-(?P<tail>\d+)$')
@@ -127,26 +147,6 @@
                     return 0, []
         return tail, ranges
 
-    def _header_line_length(self, keyword, value):
-        header_line = '%s: %s\r\n' % (keyword, value)
-        return len(header_line)
-
-    def send_head(self):
-        """Overrides base implementation to work around a bug in python2.5."""
-        path = self.translate_path(self.path)
-        if os.path.isdir(path) and not self.path.endswith('/'):
-            # redirect browser - doing basically what apache does when
-            # DirectorySlash option is On which is quite common (braindead, but
-            # common)
-            self.send_response(301)
-            self.send_header("Location", self.path + "/")
-            # Indicates that the body is empty for HTTP/1.1 clients 
-            self.send_header('Content-Length', '0')
-            self.end_headers()
-            return None
-
-        return SimpleHTTPServer.SimpleHTTPRequestHandler.send_head(self)
-
     def send_range_content(self, file, start, length):
         file.seek(start)
         self.wfile.write(file.read(length))
@@ -167,48 +167,31 @@
     def get_multiple_ranges(self, file, file_size, ranges):
         self.send_response(206)
         self.send_header('Accept-Ranges', 'bytes')
-        boundary = '%d' % random.randint(0,0x7FFFFFFF)
-        self.send_header('Content-Type',
-                         'multipart/byteranges; boundary=%s' % boundary)
-        boundary_line = '--%s\r\n' % boundary
-        # Calculate the Content-Length
-        content_length = 0
-        for (start, end) in ranges:
-            content_length += len(boundary_line)
-            content_length += self._header_line_length(
-                'Content-type', 'application/octet-stream')
-            content_length += self._header_line_length(
-                'Content-Range', 'bytes %d-%d/%d' % (start, end, file_size))
-            content_length += len('\r\n') # end headers
-            content_length += end - start # + 1
-        content_length += len(boundary_line)
-        self.send_header('Content-length', content_length)
+        boundary = "%d" % random.randint(0,0x7FFFFFFF)
+        self.send_header("Content-Type",
+                         "multipart/byteranges; boundary=%s" % boundary)
         self.end_headers()
-
-        # Send the multipart body
         for (start, end) in ranges:
-            self.wfile.write(boundary_line)
-            self.send_header('Content-type', 'application/octet-stream')
-            self.send_header('Content-Range', 'bytes %d-%d/%d'
-                             % (start, end, file_size))
+            self.wfile.write("--%s\r\n" % boundary)
+            self.send_header("Content-type", 'application/octet-stream')
+            self.send_header("Content-Range", "bytes %d-%d/%d" % (start,
+                                                                  end,
+                                                                  file_size))
             self.end_headers()
             self.send_range_content(file, start, end - start + 1)
-        # Final boundary
-        self.wfile.write(boundary_line)
+            self.wfile.write("--%s\r\n" % boundary)
 
     def do_GET(self):
         """Serve a GET request.
 
         Handles the Range header.
         """
-        # Update statistics
-        self.server.test_case_server.GET_request_nb += 1
 
         path = self.translate_path(self.path)
         ranges_header_value = self.headers.get('Range')
         if ranges_header_value is None or os.path.isdir(path):
             # Let the mother class handle most cases
-            return SimpleHTTPServer.SimpleHTTPRequestHandler.do_GET(self)
+            return SimpleHTTPRequestHandler.do_GET(self)
 
         try:
             # Always read in binary mode. Opening files in text
@@ -285,113 +268,56 @@
         return self._translate_path(path)
 
     def _translate_path(self, path):
-        """Translate a /-separated PATH to the local filename syntax.
-
-        Note that we're translating http URLs here, not file URLs.
-        The URL root location is the server's startup directory.
-        Components that mean special things to the local file system
-        (e.g. drive or directory names) are ignored.  (XXX They should
-        probably be diagnosed.)
-
-        Override from python standard library to stop it calling os.getcwd()
-        """
-        # abandon query parameters
-        path = urlparse.urlparse(path)[2]
-        path = posixpath.normpath(urllib.unquote(path))
-        path = path.decode('utf-8')
-        words = path.split('/')
-        words = filter(None, words)
-        path = self._cwd
-        for num, word in enumerate(words):
-            if num == 0:
+        return SimpleHTTPRequestHandler.translate_path(self, path)
+
+    if sys.platform == 'win32':
+        # On win32 you cannot access non-ascii filenames without
+        # decoding them into unicode first.
+        # However, under Linux, you can access bytestream paths
+        # without any problems. If this function was always active
+        # it would probably break tests when LANG=C was set
+        def _translate_path(self, path):
+            """Translate a /-separated PATH to the local filename syntax.
+
+            For bzr, all url paths are considered to be utf8 paths.
+            On Linux, you can access these paths directly over the bytestream
+            request, but on win32, you must decode them, and access them
+            as Unicode files.
+            """
+            # abandon query parameters
+            path = urlparse.urlparse(path)[2]
+            path = posixpath.normpath(urllib.unquote(path))
+            path = path.decode('utf-8')
+            words = path.split('/')
+            words = filter(None, words)
+            path = os.getcwdu()
+            for word in words:
                 drive, word = os.path.splitdrive(word)
-            head, word = os.path.split(word)
-            if word in (os.curdir, os.pardir): continue
-            path = os.path.join(path, word)
-        return path
-
-
-class TestingHTTPServerMixin:
-
-    def __init__(self, test_case_server):
+                head, word = os.path.split(word)
+                if word in (os.curdir, os.pardir): continue
+                path = os.path.join(path, word)
+            return path
+
+
+class TestingHTTPServer(BaseHTTPServer.HTTPServer):
+
+    def __init__(self, server_address, RequestHandlerClass,
+                 test_case_server):
+        BaseHTTPServer.HTTPServer.__init__(self, server_address,
+                                           RequestHandlerClass)
         # test_case_server can be used to communicate between the
         # tests and the server (or the request handler and the
         # server), allowing dynamic behaviors to be defined from
         # the tests cases.
         self.test_case_server = test_case_server
-        self._home_dir = test_case_server._home_dir
-
-    def tearDown(self):
-         """Called to clean-up the server.
- 
-         Since the server may be (surely is, even) in a blocking listen, we
-         shutdown its socket before closing it.
-         """
-         # Note that is this executed as part of the implicit tear down in the
-         # main thread while the server runs in its own thread. The clean way
-         # to tear down the server is to instruct him to stop accepting
-         # connections and wait for the current connection(s) to end
-         # naturally. To end the connection naturally, the http transports
-         # should close their socket when they do not need to talk to the
-         # server anymore. This happens naturally during the garbage collection
-         # phase of the test transport objetcs (the server clients), so we
-         # don't have to worry about them.  So, for the server, we must tear
-         # down here, from the main thread, when the test have ended.  Note
-         # that since the server is in a blocking operation and since python
-         # use select internally, shutting down the socket is reliable and
-         # relatively clean.
-         try:
-             self.socket.shutdown(socket.SHUT_RDWR)
-         except socket.error, e:
-             # WSAENOTCONN (10057) 'Socket is not connected' is harmless on
-             # windows (occurs before the first connection attempt
-             # vila--20071230)
-             if not len(e.args) or e.args[0] != 10057:
-                 raise
-         # Let the server properly close the socket
-         self.server_close()
-
-
-class TestingHTTPServer(SocketServer.TCPServer, TestingHTTPServerMixin):
-
-    def __init__(self, server_address, request_handler_class,
-                 test_case_server):
-        TestingHTTPServerMixin.__init__(self, test_case_server)
-        SocketServer.TCPServer.__init__(self, server_address,
-                                        request_handler_class)
-
-
-class TestingThreadingHTTPServer(SocketServer.ThreadingTCPServer,
-                                 TestingHTTPServerMixin):
-    """A threading HTTP test server for HTTP 1.1.
-
-    Since tests can initiate several concurrent connections to the same http
-    server, we need an independent connection for each of them. We achieve that
-    by spawning a new thread for each connection.
-    """
-
-    def __init__(self, server_address, request_handler_class,
-                 test_case_server):
-        TestingHTTPServerMixin.__init__(self, test_case_server)
-        SocketServer.ThreadingTCPServer.__init__(self, server_address,
-                                                 request_handler_class)
-        # Decides how threads will act upon termination of the main
-        # process. This is prophylactic as we should not leave the threads
-        # lying around.
-        self.daemon_threads = True
-
-
-class HttpServer(transport.Server):
+
+
+class HttpServer(Server):
     """A test server for http transports.
 
     Subclasses can provide a specific request handler.
     """
 
-    # The real servers depending on the protocol
-    http_server_class = {'HTTP/1.0': TestingHTTPServer,
-                         'HTTP/1.1': TestingThreadingHTTPServer,
-                         }
-
     # Whether or not we proxy the requests (see
     # TestingHTTPRequestHandler.translate_path).
     proxy_requests = False
@@ -399,71 +325,32 @@
     # used to form the url that connects to this server
     _url_protocol = 'http'
 
-    def __init__(self, request_handler=TestingHTTPRequestHandler,
-                 protocol_version=None):
-        """Constructor.
-
-        :param request_handler: a class that will be instantiated to handle an
-            http connection (one or several requests).
-
-        :param protocol_version: if specified, will override the protocol
-            version of the request handler.
-        """
-        transport.Server.__init__(self)
+    # Subclasses can provide a specific request handler
+    def __init__(self, request_handler=TestingHTTPRequestHandler):
+        Server.__init__(self)
         self.request_handler = request_handler
         self.host = 'localhost'
         self.port = 0
         self._httpd = None
-        self.protocol_version = protocol_version
-        # Allows tests to verify number of GET requests issued
-        self.GET_request_nb = 0
 
     def _get_httpd(self):
         if self._httpd is None:
-            rhandler = self.request_handler
-            # Depending on the protocol version, we will create the approriate
-            # server
-            if self.protocol_version is None:
-                # Use the request handler one
-                proto_vers = rhandler.protocol_version
-            else:
-                # Use our own, it will be used to override the request handler
-                # one too.
-                proto_vers = self.protocol_version
-            # Create the appropriate server for the required protocol
-            serv_cls = self.http_server_class.get(proto_vers, None)
-            if serv_cls is None:
-                raise httplib.UnknownProtocol(proto_vers)
-            else:
-                self._httpd = serv_cls((self.host, self.port), rhandler, self)
+            self._httpd = TestingHTTPServer((self.host, self.port),
+                                            self.request_handler,
+                                            self)
             host, self.port = self._httpd.socket.getsockname()
         return self._httpd
 
     def _http_start(self):
-        """Server thread main entry point. """
-        self._http_running = False
-        try:
-            try:
-                httpd = self._get_httpd()
-                self._http_base_url = '%s://%s:%s/' % (self._url_protocol,
-                                                       self.host, self.port)
-                self._http_running = True
-            except:
-                # Whatever goes wrong, we save the exception for the main
-                # thread. Note that since we are running in a thread, no signal
-                # can be received, so we don't care about KeyboardInterrupt.
-                self._http_exception = sys.exc_info()
-        finally:
-            # Release the lock or the main thread will block and the whole
-            # process will hang.
-            self._http_starting.release()
+        httpd = self._get_httpd()
+        self._http_base_url = '%s://%s:%s/' % (self._url_protocol,
+                                               self.host,
+                                               self.port)
+        httpd.socket.settimeout(0.1)
+        self._http_starting.release()
 
-        # From now on, exceptions are taken care of by the
-        # SocketServer.BaseServer or the request handler.
         while self._http_running:
             try:
-                # Really an HTTP connection but the python framework is generic
-                # and call them requests
                 httpd.handle_request()
             except socket.timeout:
                 pass
@@ -493,40 +380,29 @@
         """
         # XXX: TODO: make the server back onto vfs_server rather than local
         # disk.
-        if not (backing_transport_server is None or \
-                isinstance(backing_transport_server, local.LocalURLServer)):
-            raise AssertionError(
-                "HTTPServer currently assumes local transport, got %s" % \
-                backing_transport_server)
+        assert backing_transport_server is None or \
+            isinstance(backing_transport_server, LocalURLServer), \
+            "HTTPServer currently assumes local transport, got %s" % \
+            backing_transport_server
         self._home_dir = os.getcwdu()
         self._local_path_parts = self._home_dir.split(os.path.sep)
+        self._http_starting = threading.Lock()
+        self._http_starting.acquire()
+        self._http_running = True
         self._http_base_url = None
-
-        # Create the server thread
-        self._http_starting = threading.Lock()
-        self._http_starting.acquire()
         self._http_thread = threading.Thread(target=self._http_start)
         self._http_thread.setDaemon(True)
-        self._http_exception = None
         self._http_thread.start()
-
         # Wait for the server thread to start (i.e release the lock)
         self._http_starting.acquire()
-
-        if self._http_exception is not None:
-            # Something went wrong during server start
-            exc_class, exc_value, exc_tb = self._http_exception
-            raise exc_class, exc_value, exc_tb
         self._http_starting.release()
         self.logs = []
 
     def tearDown(self):
         """See bzrlib.transport.Server.tearDown."""
-        self._httpd.tearDown()
+        self._httpd.server_close()
         self._http_running = False
-        # We don't need to 'self._http_thread.join()' here since the thread is
-        # a daemonic one and will be garbage collected anyway. Joining just
-        # slows us down for no added benefit.
+        self._http_thread.join()
 
     def get_url(self):
         """See bzrlib.transport.Server.get_url."""
@@ -536,7 +412,7 @@
         """See bzrlib.transport.Server.get_bogus_url."""
         # this is chosen to try to prevent trouble with proxies, weird dns,
         # etc
-        return self._url_protocol + '://127.0.0.1:1/'
+        return 'http://127.0.0.1:1/'
 
 
 class HttpServer_urllib(HttpServer):

=== modified file 'bzrlib/tests/TestUtil.py'
--- bzrlib/tests/TestUtil.py	2008-03-26 08:41:15 +0000
+++ bzrlib/tests/TestUtil.py	2007-04-23 03:41:48 +0000
@@ -74,11 +74,8 @@
 
 
 class TestLoader(unittest.TestLoader):
-    """Custom TestLoader to extend the stock python one."""
-
+    """Custom  TestLoader to address some quirks in the stock python one."""
     suiteClass = TestSuite
-    # Memoize test names by test class dict
-    test_func_names = {}
 
     def loadTestsFromModuleNames(self, names):
         """use a custom means to load tests from modules.
@@ -89,76 +86,9 @@
         """
         result = self.suiteClass()
         for name in names:
-            result.addTests(self.loadTestsFromModuleName(name))
-        return result
-
-    def loadTestsFromModuleName(self, name):
-        result = self.suiteClass()
-        module = _load_module_by_name(name)
-
-        result.addTests(self.loadTestsFromModule(module))
-        return result
-
-    def loadTestsFromModule(self, module):
-        """Load tests from a module object.
-
-        This extension of the python test loader looks for an attribute
-        load_tests in the module object, and if not found falls back to the
-        regular python loadTestsFromModule.
-
-        If a load_tests attribute is found, it is called and the result is
-        returned. 
-
-        load_tests should be defined like so:
-        >>> def load_tests(standard_tests, module, loader):
-        >>>    pass
-
-        standard_tests is the tests found by the stock TestLoader in the
-        module, module and loader are the module and loader instances.
-
-        For instance, to run every test twice, you might do:
-        >>> def load_tests(standard_tests, module, loader):
-        >>>     result = loader.suiteClass()
-        >>>     for test in iter_suite_tests(standard_tests):
-        >>>         result.addTests([test, test])
-        >>>     return result
-        """
-        basic_tests = super(TestLoader, self).loadTestsFromModule(module)
-        load_tests = getattr(module, "load_tests", None)
-        if load_tests is not None:
-            return load_tests(basic_tests, module, self)
-        else:
-            return basic_tests
-
-    def getTestCaseNames(self, test_case_class):
-        test_fn_names = self.test_func_names.get(test_case_class, None)
-        if test_fn_names is not None:
-            # We already know them
-            return test_fn_names
-
-        test_fn_names = unittest.TestLoader.getTestCaseNames(self,
-                                                             test_case_class)
-        self.test_func_names[test_case_class] = test_fn_names
-        return test_fn_names
-
-
-class FilteredByModuleTestLoader(TestLoader):
-    """A test loader that import only the needed modules."""
-
-    def __init__(self, needs_module):
-        """Constructor.
-
-        :param needs_module: a callable taking a module name as a
-            parameter returing True if the module should be loaded.
-        """
-        TestLoader.__init__(self)
-        self.needs_module = needs_module
-
-    def loadTestsFromModuleName(self, name):
-        if self.needs_module(name):
-            return TestLoader.loadTestsFromModuleName(self, name)
-        else:
-            return self.suiteClass()
+            _load_module_by_name(name)
+            result.addTests(self.loadTestsFromName(name))
+        return result
 
 
 def _load_module_by_name(mod_name):

=== modified file 'bzrlib/tests/__init__.py'
--- bzrlib/tests/__init__.py	2008-09-02 04:34:23 +0000
+++ bzrlib/tests/__init__.py	2007-10-16 17:37:43 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2008 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -42,14 +42,12 @@
 from subprocess import Popen, PIPE
 import sys
 import tempfile
-import threading
+import unittest
 import time
-import unittest
 import warnings
 
 
 from bzrlib import (
-    branchbuilder,
     bzrdir,
     debug,
     errors,
@@ -58,7 +56,6 @@
     progress,
     ui,
     urlutils,
-    registry,
     workingtree,
     )
 import bzrlib.branch
@@ -76,13 +73,13 @@
 from bzrlib.merge import merge_inner
 import bzrlib.merge3
 import bzrlib.plugin
+from bzrlib.revision import common_ancestor
 import bzrlib.store
 from bzrlib import symbol_versioning
 from bzrlib.symbol_versioning import (
-    DEPRECATED_PARAMETER,
-    deprecated_function,
     deprecated_method,
-    deprecated_passed,
+    zero_ninetyone,
+    zero_ninetytwo,
     )
 import bzrlib.trace
 from bzrlib.transport import get_transport
@@ -92,13 +89,12 @@
 from bzrlib.transport.readonly import ReadonlyServer
 from bzrlib.trace import mutter, note
 from bzrlib.tests import TestUtil
-from bzrlib.tests.http_server import HttpServer
+from bzrlib.tests.HttpServer import HttpServer
 from bzrlib.tests.TestUtil import (
                           TestSuite,
                           TestLoader,
                           )
 from bzrlib.tests.treeshape import build_tree_contents
-import bzrlib.version_info_formats.format_custom
 from bzrlib.workingtree import WorkingTree, WorkingTreeFormat2
 
 # Mark this python module as being part of the implementation
@@ -108,6 +104,59 @@
 
 default_transport = LocalURLServer
 
+MODULES_TO_TEST = []
+MODULES_TO_DOCTEST = [
+        bzrlib.timestamp,
+        bzrlib.errors,
+        bzrlib.export,
+        bzrlib.inventory,
+        bzrlib.iterablefile,
+        bzrlib.lockdir,
+        bzrlib.merge3,
+        bzrlib.option,
+        bzrlib.store,
+        # quoted to avoid module-loading circularity
+        'bzrlib.tests',
+        ]
+
+
+def packages_to_test():
+    """Return a list of packages to test.
+
+    The packages are not globally imported so that import failures are
+    triggered when running selftest, not when importing the command.
+    """
+    import bzrlib.doc
+    import bzrlib.tests.blackbox
+    import bzrlib.tests.branch_implementations
+    import bzrlib.tests.bzrdir_implementations
+    import bzrlib.tests.commands
+    import bzrlib.tests.interrepository_implementations
+    import bzrlib.tests.interversionedfile_implementations
+    import bzrlib.tests.intertree_implementations
+    import bzrlib.tests.inventory_implementations
+    import bzrlib.tests.per_lock
+    import bzrlib.tests.repository_implementations
+    import bzrlib.tests.revisionstore_implementations
+    import bzrlib.tests.tree_implementations
+    import bzrlib.tests.workingtree_implementations
+    return [
+            bzrlib.doc,
+            bzrlib.tests.blackbox,
+            bzrlib.tests.branch_implementations,
+            bzrlib.tests.bzrdir_implementations,
+            bzrlib.tests.commands,
+            bzrlib.tests.interrepository_implementations,
+            bzrlib.tests.interversionedfile_implementations,
+            bzrlib.tests.intertree_implementations,
+            bzrlib.tests.inventory_implementations,
+            bzrlib.tests.per_lock,
+            bzrlib.tests.repository_implementations,
+            bzrlib.tests.revisionstore_implementations,
+            bzrlib.tests.tree_implementations,
+            bzrlib.tests.workingtree_implementations,
+            ]
+
 
 class ExtendedTestResult(unittest._TextTestResult):
     """Accepts, reports and accumulates the results of running tests.
@@ -225,7 +274,6 @@
             self.report_error(test, err)
             if self.stop_early:
                 self.stop()
-            self._cleanupLogFile(test)
 
     def addFailure(self, test, err):
         """Tell result that test failed.
@@ -242,7 +290,6 @@
             self.report_failure(test, err)
             if self.stop_early:
                 self.stop()
-            self._cleanupLogFile(test)
 
     def addSuccess(self, test):
         """Tell result that test completed successfully.
@@ -257,16 +304,14 @@
                     self._formatTime(benchmark_time),
                     test.id()))
         self.report_success(test)
-        self._cleanupLogFile(test)
         unittest.TestResult.addSuccess(self, test)
-        test._log_contents = ''
 
     def _testConcluded(self, test):
         """Common code when a test has finished.
 
         Called regardless of whether it succeded, failed, etc.
         """
-        pass
+        self._cleanupLogFile(test)
 
     def _addKnownFailure(self, test, err):
         self.known_failure_count += 1
@@ -302,7 +347,6 @@
             # seems best to treat this as success from point-of-view of unittest
             # -- it actually does nothing so it barely matters :)
             unittest.TestResult.addSuccess(self, test)
-            test._log_contents = ''
 
     def printErrorList(self, flavour, errors):
         for test, err in errors:
@@ -363,29 +407,20 @@
         self.pb.update('[test 0/%d] starting...' % (self.num_tests))
 
     def _progress_prefix_text(self):
-        # the longer this text, the less space we have to show the test
-        # name...
-        a = '[%d' % self.count              # total that have been run
-        # tests skipped as known not to be relevant are not important enough
-        # to show here
-        ## if self.skip_count:
-        ##     a += ', %d skip' % self.skip_count
-        ## if self.known_failure_count:
-        ##     a += '+%dX' % self.known_failure_count
+        a = '[%d' % self.count
         if self.num_tests is not None:
             a +='/%d' % self.num_tests
-        a += ' in '
-        runtime = time.time() - self._overall_start_time
-        if runtime >= 60:
-            a += '%dm%ds' % (runtime / 60, runtime % 60)
-        else:
-            a += '%ds' % runtime
+        a += ' in %ds' % (time.time() - self._overall_start_time)
         if self.error_count:
-            a += ', %d err' % self.error_count
+            a += ', %d errors' % self.error_count
         if self.failure_count:
-            a += ', %d fail' % self.failure_count
+            a += ', %d failed' % self.failure_count
+        if self.known_failure_count:
+            a += ', %d known failures' % self.known_failure_count
+        if self.skip_count:
+            a += ', %d skipped' % self.skip_count
         if self.unsupported:
-            a += ', %d missing' % len(self.unsupported)
+            a += ', %d missing features' % len(self.unsupported)
         a += ']'
         return a
 
@@ -719,12 +754,6 @@
         return password
 
 
-def _report_leaked_threads():
-    bzrlib.trace.warning('%s is leaking threads among %d leaking tests',
-                         TestCase._first_thread_leaker_id,
-                         TestCase._leaking_threads_tests)
-
-
 class TestCase(unittest.TestCase):
     """Base class for bzr unit tests.
     
@@ -746,17 +775,11 @@
     accidentally overlooked.
     """
 
-    _active_threads = None
-    _leaking_threads_tests = 0
-    _first_thread_leaker_id = None
     _log_file_name = None
     _log_contents = ''
     _keep_log_file = False
     # record lsprof data when performing benchmark calls.
     _gather_lsprof_in_benchmarks = False
-    attrs_to_keep = ('id', '_testMethodName', '_testMethodDoc',
-                     '_log_contents', '_log_file_name', '_benchtime',
-                     '_TestCase__testMethodName')
 
     def __init__(self, methodName='testMethod'):
         super(TestCase, self).__init__(methodName)
@@ -765,27 +788,13 @@
     def setUp(self):
         unittest.TestCase.setUp(self)
         self._cleanEnvironment()
+        bzrlib.trace.disable_default_logging()
         self._silenceUI()
         self._startLogFile()
         self._benchcalls = []
         self._benchtime = None
         self._clear_hooks()
         self._clear_debug_flags()
-        TestCase._active_threads = threading.activeCount()
-        self.addCleanup(self._check_leaked_threads)
-
-    def _check_leaked_threads(self):
-        active = threading.activeCount()
-        leaked_threads = active - TestCase._active_threads
-        TestCase._active_threads = active
-        if leaked_threads:
-            TestCase._leaking_threads_tests += 1
-            if TestCase._first_thread_leaker_id is None:
-                TestCase._first_thread_leaker_id = self.id()
-                # we're not specifically told when all tests are finished.
-                # This will do. We use a function to avoid keeping a reference
-                # to a TestCase object.
-                atexit.register(_report_leaked_threads)
 
     def _clear_debug_flags(self):
         """Prevent externally set debug flags affecting tests.
@@ -793,10 +802,9 @@
         Tests that want to use debug flags can just set them in the
         debug_flags set during setup/teardown.
         """
-        if 'allow_debug' not in selftest_debug_flags:
-            self._preserved_debug_flags = set(debug.debug_flags)
-            debug.debug_flags.clear()
-            self.addCleanup(self._restore_debug_flags)
+        self._preserved_debug_flags = set(debug.debug_flags)
+        debug.debug_flags.clear()
+        self.addCleanup(self._restore_debug_flags)
 
     def _clear_hooks(self):
         # prevent hooks affecting tests
@@ -804,7 +812,6 @@
         import bzrlib.smart.server
         self._preserved_hooks = {
             bzrlib.branch.Branch: bzrlib.branch.Branch.hooks,
-            bzrlib.mutabletree.MutableTree: bzrlib.mutabletree.MutableTree.hooks,
             bzrlib.smart.server.SmartTCPServer: bzrlib.smart.server.SmartTCPServer.hooks,
             }
         self.addCleanup(self._restoreHooks)
@@ -863,10 +870,6 @@
             return
         if message is None:
             message = "texts not equal:\n"
-        if a == b + '\n':
-            message = 'first string is missing a final newline.\n'
-        if a + '\n' == b:
-            message = 'second string is missing a final newline.\n'
         raise AssertionError(message +
                              self._ndiff_strings(a, b))
         
@@ -925,8 +928,8 @@
         """
         try:
             list(func(*args, **kwargs))
-        except excClass, e:
-            return e
+        except excClass:
+            return
         else:
             if getattr(excClass,'__name__', None) is not None:
                 excName = excClass.__name__
@@ -1029,33 +1032,7 @@
         else:
             self.fail('Unexpected success.  Should have failed: %s' % reason)
 
-    def assertFileEqual(self, content, path):
-        """Fail if path does not contain 'content'."""
-        self.failUnlessExists(path)
-        f = file(path, 'rb')
-        try:
-            s = f.read()
-        finally:
-            f.close()
-        self.assertEqualDiff(content, s)
-
-    def failUnlessExists(self, path):
-        """Fail unless path or paths, which may be abs or relative, exist."""
-        if not isinstance(path, basestring):
-            for p in path:
-                self.failUnlessExists(p)
-        else:
-            self.failUnless(osutils.lexists(path),path+" does not exist")
-
-    def failIfExists(self, path):
-        """Fail if path or paths, which may be abs or relative, exist."""
-        if not isinstance(path, basestring):
-            for p in path:
-                self.failIfExists(p)
-        else:
-            self.failIf(osutils.lexists(path),path+" exists")
-
-    def _capture_deprecation_warnings(self, a_callable, *args, **kwargs):
+    def _capture_warnings(self, a_callable, *args, **kwargs):
         """A helper for callDeprecated and applyDeprecated.
 
         :param a_callable: A callable to call.
@@ -1087,11 +1064,9 @@
         To test that a deprecated method raises an error, do something like
         this::
 
-            self.assertRaises(errors.ReservedId,
-                self.applyDeprecated,
-                deprecated_in((1, 5, 0)),
-                br.append_revision,
-                'current:')
+        self.assertRaises(errors.ReservedId,
+            self.applyDeprecated, zero_ninetyone,
+                br.append_revision, 'current:')
 
         :param deprecation_format: The deprecation format that the callable
             should have been deprecated with. This is the same type as the
@@ -1105,7 +1080,7 @@
         :param kwargs: The keyword arguments for the callable
         :return: The result of a_callable(``*args``, ``**kwargs``)
         """
-        call_warnings, result = self._capture_deprecation_warnings(a_callable,
+        call_warnings, result = self._capture_warnings(a_callable,
             *args, **kwargs)
         expected_first_warning = symbol_versioning.deprecation_string(
             a_callable, deprecation_format)
@@ -1115,37 +1090,6 @@
         self.assertEqual(expected_first_warning, call_warnings[0])
         return result
 
-    def callCatchWarnings(self, fn, *args, **kw):
-        """Call a callable that raises python warnings.
-
-        The caller's responsible for examining the returned warnings.
-
-        If the callable raises an exception, the exception is not
-        caught and propagates up to the caller.  In that case, the list
-        of warnings is not available.
-
-        :returns: ([warning_object, ...], fn_result)
-        """
-        # XXX: This is not perfect, because it completely overrides the
-        # warnings filters, and some code may depend on suppressing particular
-        # warnings.  It's the easiest way to insulate ourselves from -Werror,
-        # though.  -- Andrew, 20071062
-        wlist = []
-        def _catcher(message, category, filename, lineno, file=None):
-            # despite the name, 'message' is normally(?) a Warning subclass
-            # instance
-            wlist.append(message)
-        saved_showwarning = warnings.showwarning
-        saved_filters = warnings.filters
-        try:
-            warnings.showwarning = _catcher
-            warnings.filters = []
-            result = fn(*args, **kw)
-        finally:
-            warnings.showwarning = saved_showwarning
-            warnings.filters = saved_filters
-        return wlist, result
-
     def callDeprecated(self, expected, callable, *args, **kwargs):
         """Assert that a callable is deprecated in a particular way.
 
@@ -1155,15 +1099,14 @@
         and will ensure that that is issued for the function being called.
 
         Note that this only captures warnings raised by symbol_versioning.warn,
-        not other callers that go direct to the warning module.  To catch
-        general warnings, use callCatchWarnings.
+        not other callers that go direct to the warning module.
 
         :param expected: a list of the deprecation warnings expected, in order
         :param callable: The callable to call
         :param args: The positional arguments for the callable
         :param kwargs: The keyword arguments for the callable
         """
-        call_warnings, result = self._capture_deprecation_warnings(callable,
+        call_warnings, result = self._capture_warnings(callable,
             *args, **kwargs)
         self.assertEqual(expected, call_warnings)
         return result
@@ -1175,7 +1118,7 @@
         """
         fileno, name = tempfile.mkstemp(suffix='.log', prefix='testbzr')
         self._log_file = os.fdopen(fileno, 'w+')
-        self._log_memento = bzrlib.trace.push_log_file(self._log_file)
+        self._log_nonce = bzrlib.trace.enable_test_log(self._log_file)
         self._log_file_name = name
         self.addCleanup(self._finishLogFile)
 
@@ -1186,7 +1129,7 @@
         """
         if self._log_file is None:
             return
-        bzrlib.trace.pop_log_file(self._log_memento)
+        bzrlib.trace.disable_test_log(self._log_nonce)
         self._log_file.close()
         self._log_file = None
         if not self._keep_log_file:
@@ -1197,13 +1140,16 @@
         """Make the logfile not be deleted when _finishLogFile is called."""
         self._keep_log_file = True
 
-    def addCleanup(self, callable, *args, **kwargs):
+    def addCleanup(self, callable):
         """Arrange to run a callable when this case is torn down.
 
         Callables are run in the reverse of the order they are registered, 
         ie last-in first-out.
         """
-        self._cleanups.append((callable, args, kwargs))
+        if callable in self._cleanups:
+            raise ValueError("cleanup function %r already registered on %s" 
+                    % (callable, self))
+        self._cleanups.append(callable)
 
     def _cleanEnvironment(self):
         new_env = {
@@ -1215,7 +1161,6 @@
             'BZREMAIL': None, # may still be present in the environment
             'EMAIL': None,
             'BZR_PROGRESS_BAR': None,
-            'BZR_LOG': None,
             # SSH Agent
             'SSH_AUTH_SOCK': None,
             # Proxies
@@ -1270,16 +1215,7 @@
                     result.addSuccess(self)
                 result.stopTest(self)
                 return
-        try:
-            return unittest.TestCase.run(self, result)
-        finally:
-            saved_attrs = {}
-            absent_attr = object()
-            for attr_name in self.attrs_to_keep:
-                attr = getattr(self, attr_name, absent_attr)
-                if attr is not absent_attr:
-                    saved_attrs[attr_name] = attr
-            self.__dict__ = saved_attrs
+        return unittest.TestCase.run(self, result)
 
     def tearDown(self):
         self._runCleanups()
@@ -1318,8 +1254,7 @@
         # Actually pop the cleanups from the list so tearDown running
         # twice is safe (this happens for skipped tests).
         while self._cleanups:
-            cleanup, args, kwargs = self._cleanups.pop()
-            cleanup(*args, **kwargs)
+            self._cleanups.pop()()
 
     def log(self, *args):
         mutter(*args)
@@ -1337,8 +1272,6 @@
         import bzrlib.trace
         bzrlib.trace._trace_file.flush()
         if self._log_contents:
-            # XXX: this can hardly contain the content flushed above --vila
-            # 20080128
             return self._log_contents
         if self._log_file_name is not None:
             logfile = open(self._log_file_name)
@@ -1528,7 +1461,9 @@
             elif isinstance(args[0], basestring):
                 args = list(shlex.split(args[0]))
         else:
-            raise ValueError("passing varargs to run_bzr_subprocess")
+            symbol_versioning.warn(zero_ninetyone %
+                                   "passing varargs to run_bzr_subprocess",
+                                   DeprecationWarning, stacklevel=3)
         process = self.start_bzr_subprocess(args, env_changes=env_changes,
                                             working_dir=working_dir,
                                             allow_plugins=allow_plugins)
@@ -1590,10 +1525,7 @@
             # so we will avoid using it on all platforms, just to
             # make sure the code path is used, and we don't break on win32
             cleanup_environment()
-            command = [sys.executable]
-            # frozen executables don't need the path to bzr
-            if getattr(sys, "frozen", None) is None:
-                command.append(bzr_path)
+            command = [sys.executable, bzr_path]
             if not allow_plugins:
                 command.append('--no-plugins')
             command.extend(process_args)
@@ -1749,8 +1681,8 @@
     _TEST_NAME = 'test'
 
     def __init__(self, methodName='runTest'):
-        # allow test parameterization after test construction and before test
-        # execution. Variables that the parameterizer sets need to be 
+        # allow test parameterisation after test construction and before test
+        # execution. Variables that the parameteriser sets need to be 
         # ones that are not set by setUp, or setUp will trash them.
         super(TestCaseWithMemoryTransport, self).__init__(methodName)
         self.vfs_transport_factory = default_transport
@@ -1996,11 +1928,6 @@
         b = self.make_branch(relpath, format=format)
         return memorytree.MemoryTree.create_on_branch(b)
 
-    def make_branch_builder(self, relpath, format=None):
-        url = self.get_url(relpath)
-        tran = get_transport(url)
-        return branchbuilder.BranchBuilder(get_transport(url), format=format)
-
     def overrideEnvironmentForTesting(self):
         os.environ['HOME'] = self.test_home_dir
         os.environ['BZR_HOME'] = self.test_home_dir
@@ -2049,32 +1976,16 @@
             self.log("actually: %r" % contents)
             self.fail("contents of %s not as expected" % filename)
 
-    def _getTestDirPrefix(self):
-        # create a directory within the top level test directory
-        if sys.platform == 'win32':
-            name_prefix = re.sub('[<>*=+",:;_/\\-]', '_', self.id())
-            # windows is likely to have path-length limits so use a short name
-            name_prefix = name_prefix[-30:]
-        else:
-            name_prefix = re.sub('[/]', '_', self.id())
-        return name_prefix
-
     def makeAndChdirToTestDir(self):
         """See TestCaseWithMemoryTransport.makeAndChdirToTestDir().
         
         For TestCaseInTempDir we create a temporary directory based on the test
         name and then create two subdirs - test and home under it.
         """
-        name_prefix = osutils.pathjoin(self.TEST_ROOT, self._getTestDirPrefix())
-        name = name_prefix
-        for i in range(100):
-            if os.path.exists(name):
-                name = name_prefix + '_' + str(i)
-            else:
-                os.mkdir(name)
-                break
+        # create a directory within the top level test directory
+        candidate_dir = osutils.mkdtemp(dir=self.TEST_ROOT)
         # now create test and home directories within this dir
-        self.test_base_dir = name
+        self.test_base_dir = candidate_dir
         self.test_home_dir = self.test_base_dir + '/home'
         os.mkdir(self.test_home_dir)
         self.test_dir = self.test_base_dir + '/work'
@@ -2102,7 +2013,6 @@
 
         This doesn't add anything to a branch.
 
-        :type shape:    list or tuple.
         :param line_endings: Either 'binary' or 'native'
             in binary mode, exact contents are written in native mode, the
             line endings match the default platform endings.
@@ -2110,9 +2020,6 @@
             If the transport is readonly or None, "." is opened automatically.
         :return: None
         """
-        if type(shape) not in (list, tuple):
-            raise AssertionError("Parameter 'shape' should be "
-                "a list or a tuple. Got %r instead" % (shape,))
         # It's OK to just create them using forward slashes on windows.
         if transport is None or transport.is_readonly():
             transport = get_transport(".")
@@ -2134,13 +2041,39 @@
     def build_tree_contents(self, shape):
         build_tree_contents(shape)
 
+    def assertFileEqual(self, content, path):
+        """Fail if path does not contain 'content'."""
+        self.failUnlessExists(path)
+        f = file(path, 'rb')
+        try:
+            s = f.read()
+        finally:
+            f.close()
+        self.assertEqualDiff(content, s)
+
+    def failUnlessExists(self, path):
+        """Fail unless path or paths, which may be abs or relative, exist."""
+        if not isinstance(path, basestring):
+            for p in path:
+                self.failUnlessExists(p)
+        else:
+            self.failUnless(osutils.lexists(path),path+" does not exist")
+
+    def failIfExists(self, path):
+        """Fail if path or paths, which may be abs or relative, exist."""
+        if not isinstance(path, basestring):
+            for p in path:
+                self.failIfExists(p)
+        else:
+            self.failIf(osutils.lexists(path),path+" exists")
+
     def assertInWorkingTree(self, path, root_path='.', tree=None):
         """Assert whether path or paths are in the WorkingTree"""
         if tree is None:
             tree = workingtree.WorkingTree.open(root_path)
         if not isinstance(path, basestring):
             for p in path:
-                self.assertInWorkingTree(p, tree=tree)
+                self.assertInWorkingTree(p,tree=tree)
         else:
             self.assertIsNot(tree.path2id(path), None,
                 path+' not in working tree.')
@@ -2210,14 +2143,7 @@
                 # the branch is colocated on disk, we cannot create a checkout.
                 # hopefully callers will expect this.
                 local_controldir= bzrdir.BzrDir.open(self.get_vfs_only_url(relpath))
-                wt = local_controldir.create_workingtree()
-                if wt.branch._format != b._format:
-                    wt._branch = b
-                    # Make sure that assigning to wt._branch fixes wt.branch,
-                    # in case the implementation details of workingtree objects
-                    # change.
-                    self.assertIs(b, wt.branch)
-                return wt
+                return local_controldir.create_workingtree()
             else:
                 return b.create_checkout(relpath, lightweight=True)
 
@@ -2268,193 +2194,51 @@
             self.transport_readonly_server = HttpServer
 
 
-def condition_id_re(pattern):
-    """Create a condition filter which performs a re check on a test's id.
-    
-    :param pattern: A regular expression string.
-    :return: A callable that returns True if the re matches.
-    """
+def filter_suite_by_re(suite, pattern, exclude_pattern=None,
+                       random_order=False):
+    """Create a test suite by filtering another one.
+    
+    :param suite:           the source suite
+    :param pattern:         pattern that names must match
+    :param exclude_pattern: pattern that names must not match, if any
+    :param random_order:    if True, tests in the new suite will be put in
+                            random order
+    :returns: the newly created suite
+    """ 
+    return sort_suite_by_re(suite, pattern, exclude_pattern,
+        random_order, False)
+
+
+def sort_suite_by_re(suite, pattern, exclude_pattern=None,
+                     random_order=False, append_rest=True):
+    """Create a test suite by sorting another one.
+    
+    :param suite:           the source suite
+    :param pattern:         pattern that names must match in order to go
+                            first in the new suite
+    :param exclude_pattern: pattern that names must not match, if any
+    :param random_order:    if True, tests in the new suite will be put in
+                            random order
+    :param append_rest:     if False, pattern is a strict filter and not
+                            just an ordering directive
+    :returns: the newly created suite
+    """ 
+    first = []
+    second = []
     filter_re = re.compile(pattern)
-    def condition(test):
+    if exclude_pattern is not None:
+        exclude_re = re.compile(exclude_pattern)
+    for test in iter_suite_tests(suite):
         test_id = test.id()
-        return filter_re.search(test_id)
-    return condition
-
-
-def condition_isinstance(klass_or_klass_list):
-    """Create a condition filter which returns isinstance(param, klass).
-    
-    :return: A callable which when called with one parameter obj return the
-        result of isinstance(obj, klass_or_klass_list).
-    """
-    def condition(obj):
-        return isinstance(obj, klass_or_klass_list)
-    return condition
-
-
-def condition_id_in_list(id_list):
-    """Create a condition filter which verify that test's id in a list.
-    
-    :param id_list: A TestIdList object.
-    :return: A callable that returns True if the test's id appears in the list.
-    """
-    def condition(test):
-        return id_list.includes(test.id())
-    return condition
-
-
-def condition_id_startswith(starts):
-    """Create a condition filter verifying that test's id starts with a string.
-    
-    :param starts: A list of string.
-    :return: A callable that returns True if the test's id starts with one of 
-        the given strings.
-    """
-    def condition(test):
-        for start in starts:
-            if test.id().startswith(start):
-                return True
-        return False
-    return condition
-
-
-def exclude_tests_by_condition(suite, condition):
-    """Create a test suite which excludes some tests from suite.
-
-    :param suite: The suite to get tests from.
-    :param condition: A callable whose result evaluates True when called with a
-        test case which should be excluded from the result.
-    :return: A suite which contains the tests found in suite that fail
-        condition.
-    """
-    result = []
-    for test in iter_suite_tests(suite):
-        if not condition(test):
-            result.append(test)
-    return TestUtil.TestSuite(result)
-
-
-def filter_suite_by_condition(suite, condition):
-    """Create a test suite by filtering another one.
-    
-    :param suite: The source suite.
-    :param condition: A callable whose result evaluates True when called with a
-        test case which should be included in the result.
-    :return: A suite which contains the tests found in suite that pass
-        condition.
-    """
-    result = []
-    for test in iter_suite_tests(suite):
-        if condition(test):
-            result.append(test)
-    return TestUtil.TestSuite(result)
-
-
-def filter_suite_by_re(suite, pattern):
-    """Create a test suite by filtering another one.
-    
-    :param suite:           the source suite
-    :param pattern:         pattern that names must match
-    :returns: the newly created suite
-    """
-    condition = condition_id_re(pattern)
-    result_suite = filter_suite_by_condition(suite, condition)
-    return result_suite
-
-
-def filter_suite_by_id_list(suite, test_id_list):
-    """Create a test suite by filtering another one.
-
-    :param suite: The source suite.
-    :param test_id_list: A list of the test ids to keep as strings.
-    :returns: the newly created suite
-    """
-    condition = condition_id_in_list(test_id_list)
-    result_suite = filter_suite_by_condition(suite, condition)
-    return result_suite
-
-
-def filter_suite_by_id_startswith(suite, start):
-    """Create a test suite by filtering another one.
-
-    :param suite: The source suite.
-    :param start: A list of string the test id must start with one of.
-    :returns: the newly created suite
-    """
-    condition = condition_id_startswith(start)
-    result_suite = filter_suite_by_condition(suite, condition)
-    return result_suite
-
-
-def exclude_tests_by_re(suite, pattern):
-    """Create a test suite which excludes some tests from suite.
-
-    :param suite: The suite to get tests from.
-    :param pattern: A regular expression string. Test ids that match this
-        pattern will be excluded from the result.
-    :return: A TestSuite that contains all the tests from suite without the
-        tests that matched pattern. The order of tests is the same as it was in
-        suite.
-    """
-    return exclude_tests_by_condition(suite, condition_id_re(pattern))
-
-
-def preserve_input(something):
-    """A helper for performing test suite transformation chains.
-
-    :param something: Anything you want to preserve.
-    :return: Something.
-    """
-    return something
-
-
-def randomize_suite(suite):
-    """Return a new TestSuite with suite's tests in random order.
-    
-    The tests in the input suite are flattened into a single suite in order to
-    accomplish this. Any nested TestSuites are removed to provide global
-    randomness.
-    """
-    tests = list(iter_suite_tests(suite))
-    random.shuffle(tests)
-    return TestUtil.TestSuite(tests)
-
-
-def split_suite_by_condition(suite, condition):
-    """Split a test suite into two by a condition.
-    
-    :param suite: The suite to split.
-    :param condition: The condition to match on. Tests that match this
-        condition are returned in the first test suite, ones that do not match
-        are in the second suite.
-    :return: A tuple of two test suites, where the first contains tests from
-        suite matching the condition, and the second contains the remainder
-        from suite. The order within each output suite is the same as it was in
-        suite.
-    """
-    matched = []
-    did_not_match = []
-    for test in iter_suite_tests(suite):
-        if condition(test):
-            matched.append(test)
-        else:
-            did_not_match.append(test)
-    return TestUtil.TestSuite(matched), TestUtil.TestSuite(did_not_match)
-
-
-def split_suite_by_re(suite, pattern):
-    """Split a test suite into two by a regular expression.
-    
-    :param suite: The suite to split.
-    :param pattern: A regular expression string. Test ids that match this
-        pattern will be in the first test suite returned, and the others in the
-        second test suite returned.
-    :return: A tuple of two test suites, where the first contains tests from
-        suite matching pattern, and the second contains the remainder from
-        suite. The order within each output suite is the same as it was in
-        suite.
-    """
-    return split_suite_by_condition(suite, condition_id_re(pattern))
+        if exclude_pattern is None or not exclude_re.search(test_id):
+            if filter_re.search(test_id):
+                first.append(test)
+            elif append_rest:
+                second.append(test)
+    if random_order:
+        random.shuffle(first)
+        random.shuffle(second)
+    return TestUtil.TestSuite(first + second)
 
 
 def run_suite(suite, name='test', verbose=False, pattern=".*",
@@ -2464,7 +2248,8 @@
               list_only=False,
               random_seed=None,
               exclude_pattern=None,
-              strict=False):
+              strict=False,
+              ):
     TestCase._gather_lsprof_in_benchmarks = lsprof_timed
     if verbose:
         verbosity = 2
@@ -2494,19 +2279,13 @@
             (random_seed))
         random.seed(random_seed)
     # Customise the list of tests if requested
-    if exclude_pattern is not None:
-        suite = exclude_tests_by_re(suite, exclude_pattern)
-    if random_order:
-        order_changer = randomize_suite
-    else:
-        order_changer = preserve_input
-    if pattern != '.*' or random_order:
+    if pattern != '.*' or exclude_pattern is not None or random_order:
         if matching_tests_first:
-            suites = map(order_changer, split_suite_by_re(suite, pattern))
-            suite = TestUtil.TestSuite(suites)
+            suite = sort_suite_by_re(suite, pattern, exclude_pattern,
+                random_order)
         else:
-            suite = order_changer(filter_suite_by_re(suite, pattern))
-
+            suite = filter_suite_by_re(suite, pattern, exclude_pattern,
+                random_order)
     result = runner.run(suite)
 
     if strict:
@@ -2515,10 +2294,6 @@
     return result.wasSuccessful()
 
 
-# Controlled by "bzr selftest -E=..." option
-selftest_debug_flags = set()
-
-
 def selftest(verbose=False, pattern=".*", stop_on_failure=True,
              transport=None,
              test_suite_factory=None,
@@ -2529,9 +2304,6 @@
              random_seed=None,
              exclude_pattern=None,
              strict=False,
-             load_list=None,
-             debug_flags=None,
-             starting_with=None,
              ):
     """Run the whole test suite under the enhanced runner"""
     # XXX: Very ugly way to do this...
@@ -2545,17 +2317,9 @@
         transport = default_transport
     old_transport = default_transport
     default_transport = transport
-    global selftest_debug_flags
-    old_debug_flags = selftest_debug_flags
-    if debug_flags is not None:
-        selftest_debug_flags = set(debug_flags)
     try:
-        if load_list is None:
-            keep_only = None
-        else:
-            keep_only = load_test_id_list(load_list)
         if test_suite_factory is None:
-            suite = test_suite(keep_only, starting_with)
+            suite = test_suite()
         else:
             suite = test_suite_factory()
         return run_suite(suite, 'testbzr', verbose=verbose, pattern=pattern,
@@ -2570,187 +2334,16 @@
                      strict=strict)
     finally:
         default_transport = old_transport
-        selftest_debug_flags = old_debug_flags
-
-
-def load_test_id_list(file_name):
-    """Load a test id list from a text file.
-
-    The format is one test id by line.  No special care is taken to impose
-    strict rules, these test ids are used to filter the test suite so a test id
-    that do not match an existing test will do no harm. This allows user to add
-    comments, leave blank lines, etc.
-    """
-    test_list = []
-    try:
-        ftest = open(file_name, 'rt')
-    except IOError, e:
-        if e.errno != errno.ENOENT:
-            raise
-        else:
-            raise errors.NoSuchFile(file_name)
-
-    for test_name in ftest.readlines():
-        test_list.append(test_name.strip())
-    ftest.close()
-    return test_list
-
-
-def suite_matches_id_list(test_suite, id_list):
-    """Warns about tests not appearing or appearing more than once.
-
-    :param test_suite: A TestSuite object.
-    :param test_id_list: The list of test ids that should be found in 
-         test_suite.
-
-    :return: (absents, duplicates) absents is a list containing the test found
-        in id_list but not in test_suite, duplicates is a list containing the
-        test found multiple times in test_suite.
-
-    When using a prefined test id list, it may occurs that some tests do not
-    exist anymore or that some tests use the same id. This function warns the
-    tester about potential problems in his workflow (test lists are volatile)
-    or in the test suite itself (using the same id for several tests does not
-    help to localize defects).
-    """
-    # Build a dict counting id occurrences
-    tests = dict()
-    for test in iter_suite_tests(test_suite):
-        id = test.id()
-        tests[id] = tests.get(id, 0) + 1
-
-    not_found = []
-    duplicates = []
-    for id in id_list:
-        occurs = tests.get(id, 0)
-        if not occurs:
-            not_found.append(id)
-        elif occurs > 1:
-            duplicates.append(id)
-
-    return not_found, duplicates
-
-
-class TestIdList(object):
-    """Test id list to filter a test suite.
-
-    Relying on the assumption that test ids are built as:
-    <module>[.<class>.<method>][(<param>+)], <module> being in python dotted
-    notation, this class offers methods to :
-    - avoid building a test suite for modules not refered to in the test list,
-    - keep only the tests listed from the module test suite.
-    """
-
-    def __init__(self, test_id_list):
-        # When a test suite needs to be filtered against us we compare test ids
-        # for equality, so a simple dict offers a quick and simple solution.
-        self.tests = dict().fromkeys(test_id_list, True)
-
-        # While unittest.TestCase have ids like:
-        # <module>.<class>.<method>[(<param+)],
-        # doctest.DocTestCase can have ids like:
-        # <module>
-        # <module>.<class>
-        # <module>.<function>
-        # <module>.<class>.<method>
-
-        # Since we can't predict a test class from its name only, we settle on
-        # a simple constraint: a test id always begins with its module name.
-
-        modules = {}
-        for test_id in test_id_list:
-            parts = test_id.split('.')
-            mod_name = parts.pop(0)
-            modules[mod_name] = True
-            for part in parts:
-                mod_name += '.' + part
-                modules[mod_name] = True
-        self.modules = modules
-
-    def refers_to(self, module_name):
-        """Is there tests for the module or one of its sub modules."""
-        return self.modules.has_key(module_name)
-
-    def includes(self, test_id):
-        return self.tests.has_key(test_id)
-
-
-class TestPrefixAliasRegistry(registry.Registry):
-    """A registry for test prefix aliases.
-
-    This helps implement shorcuts for the --starting-with selftest
-    option. Overriding existing prefixes is not allowed but not fatal (a
-    warning will be emitted).
-    """
-
-    def register(self, key, obj, help=None, info=None,
-                 override_existing=False):
-        """See Registry.register.
-
-        Trying to override an existing alias causes a warning to be emitted,
-        not a fatal execption.
-        """
-        try:
-            super(TestPrefixAliasRegistry, self).register(
-                key, obj, help=help, info=info, override_existing=False)
-        except KeyError:
-            actual = self.get(key)
-            note('Test prefix alias %s is already used for %s, ignoring %s'
-                 % (key, actual, obj))
-
-    def resolve_alias(self, id_start):
-        """Replace the alias by the prefix in the given string.
-
-        Using an unknown prefix is an error to help catching typos.
-        """
-        parts = id_start.split('.')
-        try:
-            parts[0] = self.get(parts[0])
-        except KeyError:
-            raise errors.BzrCommandError(
-                '%s is not a known test prefix alias' % parts[0])
-        return '.'.join(parts)
-
-
-test_prefix_alias_registry = TestPrefixAliasRegistry()
-"""Registry of test prefix aliases."""
-
-
-# This alias allows to detect typos ('bzrlin.') by making all valid test ids
-# appear prefixed ('bzrlib.' is "replaced" by 'bzrlib.').
-test_prefix_alias_registry.register('bzrlib', 'bzrlib')
-
-# Obvious higest levels prefixes, feel free to add your own via a plugin
-test_prefix_alias_registry.register('bd', 'bzrlib.doc')
-test_prefix_alias_registry.register('bu', 'bzrlib.utils')
-test_prefix_alias_registry.register('bt', 'bzrlib.tests')
-test_prefix_alias_registry.register('bb', 'bzrlib.tests.blackbox')
-test_prefix_alias_registry.register('bp', 'bzrlib.plugins')
-
-
-def test_suite(keep_only=None, starting_with=None):
+
+
+def test_suite():
     """Build and return TestSuite for the whole of bzrlib.
-
-    :param keep_only: A list of test ids limiting the suite returned.
-
-    :param starting_with: An id limiting the suite returned to the tests
-         starting with it.
-
+    
     This function can be replaced if you need to change the default test
     suite on a global basis, but it is not encouraged.
     """
     testmod_names = [
-                   'bzrlib.doc',
                    'bzrlib.util.tests.test_bencode',
-                   'bzrlib.tests.blackbox',
-                   'bzrlib.tests.branch_implementations',
-                   'bzrlib.tests.bzrdir_implementations',
-                   'bzrlib.tests.commands',
-                   'bzrlib.tests.inventory_implementations',
-                   'bzrlib.tests.interrepository_implementations',
-                   'bzrlib.tests.intertree_implementations',
-                   'bzrlib.tests.per_lock',
-                   'bzrlib.tests.repository_implementations',
                    'bzrlib.tests.test__dirstate_helpers',
                    'bzrlib.tests.test_ancestry',
                    'bzrlib.tests.test_annotate',
@@ -2760,12 +2353,10 @@
                    'bzrlib.tests.test_bisect_multi',
                    'bzrlib.tests.test_branch',
                    'bzrlib.tests.test_branchbuilder',
-                   'bzrlib.tests.test_btree_index',
                    'bzrlib.tests.test_bugtracker',
                    'bzrlib.tests.test_bundle',
                    'bzrlib.tests.test_bzrdir',
                    'bzrlib.tests.test_cache_utf8',
-                   'bzrlib.tests.test_chunk_writer',
                    'bzrlib.tests.test_commands',
                    'bzrlib.tests.test_commit',
                    'bzrlib.tests.test_commit_merge',
@@ -2777,9 +2368,9 @@
                    'bzrlib.tests.test_deprecated_graph',
                    'bzrlib.tests.test_diff',
                    'bzrlib.tests.test_dirstate',
-                   'bzrlib.tests.test_directory_service',
                    'bzrlib.tests.test_email_message',
                    'bzrlib.tests.test_errors',
+                   'bzrlib.tests.test_escaped_store',
                    'bzrlib.tests.test_extract',
                    'bzrlib.tests.test_fetch',
                    'bzrlib.tests.test_ftp_transport',
@@ -2792,7 +2383,6 @@
                    'bzrlib.tests.test_help',
                    'bzrlib.tests.test_hooks',
                    'bzrlib.tests.test_http',
-                   'bzrlib.tests.test_http_implementations',
                    'bzrlib.tests.test_http_response',
                    'bzrlib.tests.test_https_ca_bundle',
                    'bzrlib.tests.test_identitymap',
@@ -2807,7 +2397,6 @@
                    'bzrlib.tests.test_lockable_files',
                    'bzrlib.tests.test_log',
                    'bzrlib.tests.test_lsprof',
-                   'bzrlib.tests.test_lru_cache',
                    'bzrlib.tests.test_mail_client',
                    'bzrlib.tests.test_memorytree',
                    'bzrlib.tests.test_merge',
@@ -2817,31 +2406,26 @@
                    'bzrlib.tests.test_missing',
                    'bzrlib.tests.test_msgeditor',
                    'bzrlib.tests.test_multiparent',
-                   'bzrlib.tests.test_mutabletree',
                    'bzrlib.tests.test_nonascii',
                    'bzrlib.tests.test_options',
                    'bzrlib.tests.test_osutils',
                    'bzrlib.tests.test_osutils_encodings',
                    'bzrlib.tests.test_pack',
-                   'bzrlib.tests.test_pack_repository',
                    'bzrlib.tests.test_patch',
                    'bzrlib.tests.test_patches',
                    'bzrlib.tests.test_permissions',
                    'bzrlib.tests.test_plugins',
                    'bzrlib.tests.test_progress',
-                   'bzrlib.tests.test_read_bundle',
                    'bzrlib.tests.test_reconfigure',
                    'bzrlib.tests.test_reconcile',
                    'bzrlib.tests.test_registry',
                    'bzrlib.tests.test_remote',
                    'bzrlib.tests.test_repository',
-                   'bzrlib.tests.per_repository_reference',
                    'bzrlib.tests.test_revert',
                    'bzrlib.tests.test_revision',
-                   'bzrlib.tests.test_revisionspec',
+                   'bzrlib.tests.test_revisionnamespaces',
                    'bzrlib.tests.test_revisiontree',
                    'bzrlib.tests.test_rio',
-                   'bzrlib.tests.test_rules',
                    'bzrlib.tests.test_sampler',
                    'bzrlib.tests.test_selftest',
                    'bzrlib.tests.test_setup',
@@ -2856,7 +2440,6 @@
                    'bzrlib.tests.test_store',
                    'bzrlib.tests.test_strace',
                    'bzrlib.tests.test_subsume',
-                   'bzrlib.tests.test_switch',
                    'bzrlib.tests.test_symbol_versioning',
                    'bzrlib.tests.test_tag',
                    'bzrlib.tests.test_testament',
@@ -2867,21 +2450,16 @@
                    'bzrlib.tests.test_transactions',
                    'bzrlib.tests.test_transform',
                    'bzrlib.tests.test_transport',
-                   'bzrlib.tests.test_transport_implementations',
-                   'bzrlib.tests.test_transport_log',
                    'bzrlib.tests.test_tree',
                    'bzrlib.tests.test_treebuilder',
                    'bzrlib.tests.test_tsort',
                    'bzrlib.tests.test_tuned_gzip',
                    'bzrlib.tests.test_ui',
-                   'bzrlib.tests.test_uncommit',
                    'bzrlib.tests.test_upgrade',
-                   'bzrlib.tests.test_upgrade_stacked',
                    'bzrlib.tests.test_urlutils',
                    'bzrlib.tests.test_versionedfile',
                    'bzrlib.tests.test_version',
                    'bzrlib.tests.test_version_info',
-                   'bzrlib.tests.test__walkdirs_win32',
                    'bzrlib.tests.test_weave',
                    'bzrlib.tests.test_whitebox',
                    'bzrlib.tests.test_win32utils',
@@ -2889,118 +2467,47 @@
                    'bzrlib.tests.test_workingtree_4',
                    'bzrlib.tests.test_wsgi',
                    'bzrlib.tests.test_xml',
-                   'bzrlib.tests.tree_implementations',
-                   'bzrlib.tests.workingtree_implementations',
                    ]
-
+    test_transport_implementations = [
+        'bzrlib.tests.test_transport_implementations',
+        'bzrlib.tests.test_read_bundle',
+        ]
+    suite = TestUtil.TestSuite()
     loader = TestUtil.TestLoader()
-
-    if starting_with:
-        starting_with = [test_prefix_alias_registry.resolve_alias(start)
-                         for start in starting_with]
-        # We take precedence over keep_only because *at loading time* using
-        # both options means we will load less tests for the same final result.
-        def interesting_module(name):
-            for start in starting_with:
-                if (
-                    # Either the module name starts with the specified string
-                    name.startswith(start)
-                    # or it may contain tests starting with the specified string
-                    or start.startswith(name)
-                    ):
-                    return True
-            return False
-        loader = TestUtil.FilteredByModuleTestLoader(interesting_module)
-
-    elif keep_only is not None:
-        id_filter = TestIdList(keep_only)
-        loader = TestUtil.FilteredByModuleTestLoader(id_filter.refers_to)
-        def interesting_module(name):
-            return id_filter.refers_to(name)
-
-    else:
-        loader = TestUtil.TestLoader()
-        def interesting_module(name):
-            # No filtering, all modules are interesting
-            return True
-
-    suite = loader.suiteClass()
-
-    # modules building their suite with loadTestsFromModuleNames
     suite.addTest(loader.loadTestsFromModuleNames(testmod_names))
-
-    modules_to_doctest = [
-        'bzrlib',
-        'bzrlib.errors',
-        'bzrlib.export',
-        'bzrlib.inventory',
-        'bzrlib.iterablefile',
-        'bzrlib.lockdir',
-        'bzrlib.merge3',
-        'bzrlib.option',
-        'bzrlib.store',
-        'bzrlib.symbol_versioning',
-        'bzrlib.tests',
-        'bzrlib.timestamp',
-        'bzrlib.version_info_formats.format_custom',
-        ]
-
-    for mod in modules_to_doctest:
-        if not interesting_module(mod):
-            # No tests to keep here, move along
-            continue
+    from bzrlib.tests.test_transport_implementations import TransportTestProviderAdapter
+    adapter = TransportTestProviderAdapter()
+    adapt_modules(test_transport_implementations, adapter, loader, suite)
+    for package in packages_to_test():
+        suite.addTest(package.test_suite())
+    for m in MODULES_TO_TEST:
+        suite.addTest(loader.loadTestsFromModule(m))
+    for m in MODULES_TO_DOCTEST:
         try:
-            doc_suite = doctest.DocTestSuite(mod)
+            suite.addTest(doctest.DocTestSuite(m))
         except ValueError, e:
-            print '**failed to get doctest for: %s\n%s' % (mod, e)
+            print '**failed to get doctest for: %s\n%s' %(m,e)
             raise
-        suite.addTest(doc_suite)
-
     default_encoding = sys.getdefaultencoding()
     for name, plugin in bzrlib.plugin.plugins().items():
-        if not interesting_module(plugin.module.__name__):
-            continue
-        plugin_suite = plugin.test_suite()
-        # We used to catch ImportError here and turn it into just a warning,
-        # but really if you don't have --no-plugins this should be a failure.
-        # mbp 20080213 - see http://bugs.launchpad.net/bugs/189771
-        if plugin_suite is None:
-            plugin_suite = plugin.load_plugin_tests(loader)
-        if plugin_suite is not None:
-            suite.addTest(plugin_suite)
+        try:
+            plugin_suite = plugin.test_suite()
+        except ImportError, e:
+            bzrlib.trace.warning(
+                'Unable to test plugin "%s": %s', name, e)
+        else:
+            if plugin_suite is not None:
+                suite.addTest(plugin_suite)
         if default_encoding != sys.getdefaultencoding():
             bzrlib.trace.warning(
                 'Plugin "%s" tried to reset default encoding to: %s', name,
                 sys.getdefaultencoding())
             reload(sys)
             sys.setdefaultencoding(default_encoding)
-
-    if starting_with:
-        suite = filter_suite_by_id_startswith(suite, starting_with)
-
-    if keep_only is not None:
-        # Now that the referred modules have loaded their tests, keep only the
-        # requested ones.
-        suite = filter_suite_by_id_list(suite, id_filter)
-        # Do some sanity checks on the id_list filtering
-        not_found, duplicates = suite_matches_id_list(suite, keep_only)
-        if starting_with:
-            # The tester has used both keep_only and starting_with, so he is
-            # already aware that some tests are excluded from the list, there
-            # is no need to tell him which.
-            pass
-        else:
-            # Some tests mentioned in the list are not in the test suite. The
-            # list may be out of date, report to the tester.
-            for id in not_found:
-                bzrlib.trace.warning('"%s" not found in the test suite', id)
-        for id in duplicates:
-            bzrlib.trace.warning('"%s" is used as an id by several tests', id)
-
     return suite
 
 
-def multiply_tests_from_modules(module_name_list, scenario_iter, loader=None):
+def multiply_tests_from_modules(module_name_list, scenario_iter):
     """Adapt all tests in some given modules to given scenarios.
 
     This is the recommended public interface for test parameterization.
@@ -3012,8 +2519,6 @@
         modules.
     :param scenario_iter: Iterable of pairs of (scenario_name, 
         scenario_param_dict).
-    :param loader: If provided, will be used instead of a new 
-        bzrlib.tests.TestLoader() instance.
 
     This returns a new TestSuite containing the cross product of
     all the tests in all the modules, each repeated for each scenario.
@@ -3035,13 +2540,8 @@
     >>> tests[1].param
     2
     """
-    # XXX: Isn't load_tests() a better way to provide the same functionality
-    # without forcing a predefined TestScenarioApplier ? --vila 080215
-    if loader is None:
-        loader = TestUtil.TestLoader()
-
-    suite = loader.suiteClass()
-
+    loader = TestLoader()
+    suite = TestSuite()
     adapter = TestScenarioApplier()
     adapter.scenarios = list(scenario_iter)
     adapt_modules(module_name_list, adapter, loader, suite)
@@ -3065,13 +2565,7 @@
 
 def adapt_modules(mods_list, adapter, loader, suite):
     """Adapt the modules in mods_list using adapter and add to suite."""
-    tests = loader.loadTestsFromModuleNames(mods_list)
-    adapt_tests(tests, adapter, suite)
-
-
-def adapt_tests(tests_list, adapter, suite):
-    """Adapt the tests in tests_list using adapter and add to suite."""
-    for test in iter_suite_tests(tests_list):
+    for test in iter_suite_tests(loader.loadTestsFromModuleNames(mods_list)):
         suite.addTests(adapter.adapt(test))
 
 
@@ -3093,7 +2587,7 @@
         if sys.platform == 'win32' and e.errno == errno.EACCES:
             sys.stderr.write(('Permission denied: '
                                  'unable to remove testing dir '
-                                 '%s\n' % os.path.basename(dirname)))
+                                 '%\n' % os.path.basename(dirname)))
         else:
             raise
 
@@ -3137,52 +2631,6 @@
 SymlinkFeature = _SymlinkFeature()
 
 
-class _HardlinkFeature(Feature):
-
-    def _probe(self):
-        return osutils.has_hardlinks()
-
-    def feature_name(self):
-        return 'hardlinks'
-
-HardlinkFeature = _HardlinkFeature()
-
-
-class _OsFifoFeature(Feature):
-
-    def _probe(self):
-        return getattr(os, 'mkfifo', None)
-
-    def feature_name(self):
-        return 'filesystem fifos'
-
-OsFifoFeature = _OsFifoFeature()
-
-
-class _UnicodeFilenameFeature(Feature):
-    """Does the filesystem support Unicode filenames?"""
-
-    def _probe(self):
-        try:
-            # Check for character combinations unlikely to be covered by any
-            # single non-unicode encoding. We use the characters
-            # - greek small letter alpha (U+03B1) and
-            # - braille pattern dots-123456 (U+283F).
-            os.stat(u'\u03b1\u283f')
-        except UnicodeEncodeError:
-            return False
-        except (IOError, OSError):
-            # The filesystem allows the Unicode filename but the file doesn't
-            # exist.
-            return True
-        else:
-            # The filesystem allows the Unicode filename and the file exists,
-            # for some reason.
-            return True
-
-UnicodeFilenameFeature = _UnicodeFilenameFeature()
-
-
 class TestScenarioApplier(object):
     """A tool to apply scenarios to tests."""
 
@@ -3243,80 +2691,3 @@
         except UnicodeDecodeError:
             return char
     return None
-
-
-class _FTPServerFeature(Feature):
-    """Some tests want an FTP Server, check if one is available.
-
-    Right now, the only way this is available is if 'medusa' is installed.
-    http://www.amk.ca/python/code/medusa.html
-    """
-
-    def _probe(self):
-        try:
-            import bzrlib.tests.ftp_server
-            return True
-        except ImportError:
-            return False
-
-    def feature_name(self):
-        return 'FTPServer'
-
-FTPServerFeature = _FTPServerFeature()
-
-
-class _UnicodeFilename(Feature):
-    """Does the filesystem support Unicode filenames?"""
-
-    def _probe(self):
-        try:
-            os.stat(u'\u03b1')
-        except UnicodeEncodeError:
-            return False
-        except (IOError, OSError):
-            # The filesystem allows the Unicode filename but the file doesn't
-            # exist.
-            return True
-        else:
-            # The filesystem allows the Unicode filename and the file exists,
-            # for some reason.
-            return True
-
-UnicodeFilename = _UnicodeFilename()
-
-
-class _UTF8Filesystem(Feature):
-    """Is the filesystem UTF-8?"""
-
-    def _probe(self):
-        if osutils._fs_enc.upper() in ('UTF-8', 'UTF8'):
-            return True
-        return False
-
-UTF8Filesystem = _UTF8Filesystem()
-
-
-class _CaseInsensitiveFilesystemFeature(Feature):
-    """Check if underlying filesystem is case-insensitive
-    (e.g. on Windows, Cygwin, MacOS)
-    """
-
-    def _probe(self):
-        if TestCaseWithMemoryTransport.TEST_ROOT is None:
-            root = osutils.mkdtemp(prefix='testbzr-', suffix='.tmp')
-            TestCaseWithMemoryTransport.TEST_ROOT = root
-        else:
-            root = TestCaseWithMemoryTransport.TEST_ROOT
-        tdir = osutils.mkdtemp(prefix='case-sensitive-probe-', suffix='',
-            dir=root)
-        name_a = osutils.pathjoin(tdir, 'a')
-        name_A = osutils.pathjoin(tdir, 'A')
-        os.mkdir(name_a)
-        result = osutils.isdir(name_A)
-        _rmtree_temp_dir(tdir)
-        return result
-
-    def feature_name(self):
-        return 'case-insensitive filesystem'
-
-CaseInsensitiveFilesystemFeature = _CaseInsensitiveFilesystemFeature()

=== modified file 'bzrlib/tests/blackbox/__init__.py'
--- bzrlib/tests/blackbox/__init__.py	2008-06-05 16:27:16 +0000
+++ bzrlib/tests/blackbox/__init__.py	2007-09-17 12:46:56 +0000
@@ -27,24 +27,22 @@
 from bzrlib.tests import (
                           adapt_modules,
                           TestCaseWithTransport,
+                          TestSuite,
+                          TestLoader,
                           iter_suite_tests,
                           )
 from bzrlib.tests.EncodingAdapter import EncodingTestAdapter
 from bzrlib.symbol_versioning import (
     deprecated_method,
+    zero_eighteen,
     )
 import bzrlib.ui as ui
 
 
-def load_tests(basic_tests, module, loader):
-    suite = loader.suiteClass()
-    # add the tests for this module
-    suite.addTests(basic_tests)
-
+def test_suite():
     testmod_names = [
                      'bzrlib.tests.blackbox.test_add',
                      'bzrlib.tests.blackbox.test_added',
-                     'bzrlib.tests.blackbox.test_alias',
                      'bzrlib.tests.blackbox.test_aliases',
                      'bzrlib.tests.blackbox.test_ancestry',
                      'bzrlib.tests.blackbox.test_annotate',
@@ -55,7 +53,6 @@
                      'bzrlib.tests.blackbox.test_bundle_info',
                      'bzrlib.tests.blackbox.test_cat',
                      'bzrlib.tests.blackbox.test_cat_revision',
-                     'bzrlib.tests.blackbox.test_check',
                      'bzrlib.tests.blackbox.test_checkout',
                      'bzrlib.tests.blackbox.test_command_encoding',
                      'bzrlib.tests.blackbox.test_commit',
@@ -66,7 +63,6 @@
                      'bzrlib.tests.blackbox.test_export',
                      'bzrlib.tests.blackbox.test_find_merge_base',
                      'bzrlib.tests.blackbox.test_help',
-                     'bzrlib.tests.blackbox.test_hooks',
                      'bzrlib.tests.blackbox.test_ignore',
                      'bzrlib.tests.blackbox.test_ignored',
                      'bzrlib.tests.blackbox.test_info',
@@ -81,7 +77,6 @@
                      'bzrlib.tests.blackbox.test_merge',
                      'bzrlib.tests.blackbox.test_merge_directive',
                      'bzrlib.tests.blackbox.test_missing',
-                     'bzrlib.tests.blackbox.test_modified',
                      'bzrlib.tests.blackbox.test_mv',
                      'bzrlib.tests.blackbox.test_nick',
                      'bzrlib.tests.blackbox.test_outside_wt',
@@ -105,7 +100,6 @@
                      'bzrlib.tests.blackbox.test_sign_my_commits',
                      'bzrlib.tests.blackbox.test_split',
                      'bzrlib.tests.blackbox.test_status',
-                     'bzrlib.tests.blackbox.test_switch',
                      'bzrlib.tests.blackbox.test_tags',
                      'bzrlib.tests.blackbox.test_testament',
                      'bzrlib.tests.blackbox.test_too_much',
@@ -118,13 +112,13 @@
                      'bzrlib.tests.blackbox.test_versioning',
                      'bzrlib.tests.blackbox.test_whoami',
                      ]
-    # add the tests for the sub modules
-    suite.addTests(loader.loadTestsFromModuleNames(testmod_names))
-
     test_encodings = [
         'bzrlib.tests.blackbox.test_non_ascii',
     ]
 
+    loader = TestLoader()
+    suite = loader.loadTestsFromModuleNames(testmod_names) 
+
     adapter = EncodingTestAdapter()
     adapt_modules(test_encodings, adapter, loader, suite)
 
@@ -133,6 +127,12 @@
 
 class ExternalBase(TestCaseWithTransport):
 
+    @deprecated_method(zero_eighteen)
+    def runbzr(self, args, retcode=0):
+        if isinstance(args, basestring):
+            args = args.split()
+        return self.run_bzr(args, retcode=retcode)
+
     def check_output(self, output, *args):
         """Verify that the expected output matches what bzr says.
 

=== modified file 'bzrlib/tests/blackbox/test_added.py'
--- bzrlib/tests/blackbox/test_added.py	2008-06-05 16:24:53 +0000
+++ bzrlib/tests/blackbox/test_added.py	2007-08-02 17:55:39 +0000
@@ -23,30 +23,13 @@
 from bzrlib.branch import Branch
 from bzrlib.tests.blackbox import ExternalBase
 
-
 class TestAdded(ExternalBase):
 
     def test_added(self):
         """Test that 'added' command reports added files"""
-        self._test_added('a', 'a\n')
-
-    def test_added_with_spaces(self):
-        """Test that 'added' command reports added files with spaces in their names quoted"""
-        self._test_added('a filename with spaces', '"a filename with spaces"\n')
-    
-    def test_added_null_separator(self):
-        """Test that added uses its null operator properly"""
-        self._test_added('a', 'a\0', null=True)
-
-    def _test_added(self, name, output, null=False):
-
-        def check_added(expected, null=False):
-            command = 'added'
-
-            if null:
-                command += ' --null'
-
-            out, err = self.run_bzr(command)
+
+        def check_added(expected):
+            out, err = self.run_bzr('added')
             self.assertEquals(out, expected)
             self.assertEquals(err, '')
 
@@ -55,15 +38,15 @@
         check_added('')
 
         # with unknown file, still nothing added
-        self.build_tree_contents([(name, 'contents of %s\n' % (name))])
+        self.build_tree_contents([('a', 'contents of a\n')])
         check_added('')
-        
+
         # after add, shows up in list
         # bug report 20060119 by Nathan McCallum -- 'bzr added' causes
         # NameError
-        tree.add(name)
-        check_added(output, null) 
+        tree.add('a')
+        check_added('a\n')
 
         # after commit, now no longer listed
-        tree.commit(message='add "%s"' % (name))
+        tree.commit(message='add a')
         check_added('')

=== removed file 'bzrlib/tests/blackbox/test_alias.py'
--- bzrlib/tests/blackbox/test_alias.py	2008-05-30 10:47:49 +0000
+++ bzrlib/tests/blackbox/test_alias.py	1970-01-01 00:00:00 +0000
@@ -1,70 +0,0 @@
-# Copyright (C) 2005, 2006, 2007 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-#
-
-"""Tests of the 'bzr alias' command."""
-
-from bzrlib.tests.blackbox import ExternalBase
-
-
-class TestAlias(ExternalBase):
-
-    def test_list_alias_with_none(self):
-        """Calling alias with no parameters lists existing aliases."""
-        out, err = self.run_bzr('alias')
-        self.assertEquals('', out)
-
-    def test_list_unknown_alias(self):
-        out, err = self.run_bzr('alias commit')
-        self.assertEquals('bzr alias: commit: not found\n', out)
-
-    def test_add_alias_outputs_nothing(self):
-        out, err = self.run_bzr('alias commit="commit --strict"')
-        self.assertEquals('', out)
-
-    def test_add_alias_visible(self):
-        """Adding an alias makes it ..."""
-        self.run_bzr('alias commit="commit --strict"')
-        out, err = self.run_bzr('alias commit')
-        self.assertEquals('bzr alias commit="commit --strict"\n', out)
-
-    def test_alias_listing_alphabetical(self):
-        self.run_bzr('alias commit="commit --strict"')
-        self.run_bzr('alias ll="log --short"')
-        self.run_bzr('alias add="add -q"')
-
-        out, err = self.run_bzr('alias')
-        self.assertEquals(
-            'bzr alias add="add -q"\n'
-            'bzr alias commit="commit --strict"\n'
-            'bzr alias ll="log --short"\n',
-            out)
-
-    def test_remove_unknown_alias(self):
-        out, err = self.run_bzr('alias --remove fooix', retcode=3)
-        self.assertEquals('bzr: ERROR: The alias "fooix" does not exist.\n',
-                          err)
-
-    def test_remove_known_alias(self):
-        self.run_bzr('alias commit="commit --strict"')
-        out, err = self.run_bzr('alias commit')
-        self.assertEquals('bzr alias commit="commit --strict"\n', out)
-        # No output when removing an existing alias.
-        out, err = self.run_bzr('alias --remove commit')
-        self.assertEquals('', out)
-        # Now its not.
-        out, err = self.run_bzr('alias commit')
-        self.assertEquals("bzr alias: commit: not found\n", out)

=== modified file 'bzrlib/tests/blackbox/test_annotate.py'
--- bzrlib/tests/blackbox/test_annotate.py	2007-12-29 18:55:20 +0000
+++ bzrlib/tests/blackbox/test_annotate.py	2007-08-23 14:10:48 +0000
@@ -167,16 +167,3 @@
         out, err = self.run_bzr("annotate doesnotexist", retcode=3)
         self.assertEqual('', out)
         self.assertEqual("bzr: ERROR: doesnotexist is not versioned.\n", err)
-
-    def test_annotate_without_workingtree(self):
-        tree = self.make_branch_and_tree('branch')
-        self.build_tree_contents([('branch/empty', '')])
-        tree.add('empty')
-        tree.commit('add empty file')
-        bzrdir = tree.branch.bzrdir
-        bzrdir.destroy_workingtree()
-        self.assertFalse(bzrdir.has_workingtree())
-
-        os.chdir('branch')
-        out, err = self.run_bzr('annotate empty')
-        self.assertEqual('', out)

=== modified file 'bzrlib/tests/blackbox/test_bound_branches.py'
--- bzrlib/tests/blackbox/test_bound_branches.py	2007-12-10 19:20:41 +0000
+++ bzrlib/tests/blackbox/test_bound_branches.py	2007-08-03 12:50:48 +0000
@@ -198,6 +198,8 @@
         child_tree.commit(message='child')
         self.check_revno(2)
 
+        self.run_bzr('bind', retcode=3)
+
     def test_commit_remote_bound(self):
         # It is not possible to commit to a branch
         # which is bound to a branch which is bound
@@ -245,11 +247,12 @@
         self.check_revno(2, 'base')
 
         os.chdir('child')
-        # These branches have diverged, but bind should succeed anyway
-        self.run_bzr('bind ../base')
+        # These branches have diverged
+        self.run_bzr('bind ../base', retcode=3)
 
-        # This should turn the local commit into a merge
-        child_tree.update()
+        # TODO: In the future, this might require actual changes
+        # to have occurred, rather than just a new revision entry
+        child_tree.merge_from_branch(base_branch)
         child_tree.commit(message='merged')
         self.check_revno(3)
 
@@ -258,6 +261,16 @@
         base_history = base_branch.revision_history()
         child_history = child_branch.revision_history()
 
+        # After a merge, trying to bind again should succeed
+        # keeping the new change as a local commit.
+        self.run_bzr('bind ../base')
+        self.check_revno(3)
+        self.check_revno(2, '../base')
+
+        # and compare the revision history now
+        self.assertEqual(base_history, base_branch.revision_history())
+        self.assertEqual(child_history, child_branch.revision_history())
+
     def test_bind_parent_ahead(self):
         base_tree = self.create_branches()[0]
 
@@ -309,14 +322,6 @@
         self.run_bzr('bind ../base')
         self.check_revno(1, '../base')
 
-    def test_bind_fail_if_missing(self):
-        """We should not be able to bind to a missing branch."""
-        tree = self.make_branch_and_tree('tree_1')
-        tree.commit('dummy commit')
-        self.run_bzr_error(['Not a branch.*no-such-branch/'], ['bind', '../no-such-branch'],
-                            working_dir='tree_1')
-        self.assertIs(None, tree.branch.get_bound_location())
-
     def test_commit_after_merge(self):
         base_tree, child_tree = self.create_branches()
 

=== modified file 'bzrlib/tests/blackbox/test_branch.py'
--- bzrlib/tests/blackbox/test_branch.py	2008-09-02 21:38:04 +0000
+++ bzrlib/tests/blackbox/test_branch.py	2007-08-03 12:59:14 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2008 Canonical Ltd
+# Copyright (C) 2005, 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -19,10 +19,9 @@
 
 import os
 
-from bzrlib import (branch, bzrdir, errors, repository)
+from bzrlib import branch, bzrdir
 from bzrlib.repofmt.knitrepo import RepositoryFormatKnit1
 from bzrlib.tests.blackbox import ExternalBase
-from bzrlib.tests import HardlinkFeature
 from bzrlib.tests.test_sftp_transport import TestCaseWithSFTPServer
 from bzrlib.workingtree import WorkingTree
 
@@ -43,9 +42,8 @@
         self.example_branch('a')
         self.run_bzr('branch a b')
         b = branch.Branch.open('b')
+        self.assertEqual('b\n', b.control_files.get_utf8('branch-name').read())
         self.run_bzr('branch a c -r 1')
-        # previously was erroneously created by branching
-        self.assertFalse(b._transport.has('branch-name'))
         b.bzrdir.open_workingtree().commit(message='foo', allow_pointless=True)
 
     def test_branch_only_copies_history(self):
@@ -86,161 +84,6 @@
         self.assertFalse(pushed_repo.has_revision('a-2'))
         self.assertTrue(pushed_repo.has_revision('b-1'))
 
-    def test_branch_hardlink(self):
-        self.requireFeature(HardlinkFeature)
-        source = self.make_branch_and_tree('source')
-        self.build_tree(['source/file1'])
-        source.add('file1')
-        source.commit('added file')
-        self.run_bzr(['branch', 'source', 'target', '--hardlink'])
-        source_stat = os.stat('source/file1')
-        target_stat = os.stat('target/file1')
-        self.assertEqual(source_stat, target_stat)
-
-
-class TestBranchStacked(ExternalBase):
-    """Tests for branch --stacked"""
-
-    def check_shallow_branch(self, branch_revid, stacked_on):
-        """Assert that the branch 'newbranch' has been published correctly.
-
-        :param stacked_on: url of a branch this one is stacked upon.
-        :param branch_revid: a revision id that should be the only
-            revision present in the stacked branch, and it should not be in
-            the reference branch.
-        """
-        new_branch = branch.Branch.open('newbranch')
-        # The branch refers to the mainline
-        self.assertEqual(stacked_on, new_branch.get_stacked_on_url())
-        # and the branch's work was pushed
-        self.assertTrue(new_branch.repository.has_revision(branch_revid))
-        # The newly committed revision shoud be present in the stacked branch,
-        # but not in the stacked-on branch.  Because stacking is set up by the
-        # branch object, if we open the stacked branch's repository directly,
-        # bypassing the branch, we see only what's in the stacked repository.
-        stacked_repo = bzrdir.BzrDir.open('newbranch').open_repository()
-        stacked_repo_revisions = set(stacked_repo.all_revision_ids())
-        if len(stacked_repo_revisions) != 1:
-            self.fail("wrong revisions in stacked repository: %r"
-                % (stacked_repo_revisions,))
-
-    def assertRevisionInRepository(self, repo_path, revid):
-        """Check that a revision is in a repository, disregarding stacking."""
-        repo = bzrdir.BzrDir.open(repo_path).open_repository()
-        self.assertTrue(repo.has_revision(revid))
-
-    def assertRevisionNotInRepository(self, repo_path, revid):
-        """Check that a revision is not in a repository, disregarding stacking."""
-        repo = bzrdir.BzrDir.open(repo_path).open_repository()
-        self.assertFalse(repo.has_revision(revid))
-
-    def assertRevisionsInBranchRepository(self, revid_list, branch_path):
-        repo = branch.Branch.open(branch_path).repository
-        self.assertEqual(set(revid_list),
-            repo.has_revisions(revid_list))
-
-    def test_branch_stacked_branch_not_stacked(self):
-        """Branching a stacked branch is not stacked by default"""
-        # We have a mainline
-        trunk_tree = self.make_branch_and_tree('target',
-            format='development')
-        trunk_tree.commit('mainline')
-        # and a branch from it which is stacked
-        branch_tree = self.make_branch_and_tree('branch',
-            format='development')
-        branch_tree.branch.set_stacked_on_url(trunk_tree.branch.base)
-        # with some work on it
-        branch_tree.commit('moar work plz')
-        # branching our local branch gives us a new stacked branch pointing at
-        # mainline.
-        out, err = self.run_bzr(['branch', 'branch', 'newbranch'])
-        self.assertEqual('', out)
-        self.assertEqual('Branched 1 revision(s).\n',
-            err)
-        # it should have preserved the branch format, and so it should be
-        # capable of supporting stacking, but not actually have a stacked_on
-        # branch configured
-        self.assertRaises(errors.NotStacked,
-            bzrdir.BzrDir.open('newbranch').open_branch().get_stacked_on_url)
-
-    def test_branch_stacked_branch_stacked(self):
-        """Asking to stack on a stacked branch does work"""
-        # We have a mainline
-        trunk_tree = self.make_branch_and_tree('target',
-            format='development')
-        trunk_revid = trunk_tree.commit('mainline')
-        # and a branch from it which is stacked
-        branch_tree = self.make_branch_and_tree('branch',
-            format='development')
-        branch_tree.branch.set_stacked_on_url(trunk_tree.branch.base)
-        # with some work on it
-        branch_revid = branch_tree.commit('moar work plz')
-        # you can chain branches on from there
-        out, err = self.run_bzr(['branch', 'branch', '--stacked', 'branch2'])
-        self.assertEqual('', out)
-        self.assertEqual('Created new stacked branch referring to %s.\n' %
-            branch_tree.branch.base, err)
-        self.assertEqual(branch_tree.branch.base,
-            branch.Branch.open('branch2').get_stacked_on_url())
-        branch2_tree = WorkingTree.open('branch2')
-        branch2_revid = branch2_tree.commit('work on second stacked branch')
-        self.assertRevisionInRepository('branch2', branch2_revid)
-        self.assertRevisionsInBranchRepository(
-            [trunk_revid, branch_revid, branch2_revid],
-            'branch2')
-
-    def test_branch_stacked(self):
-        # We have a mainline
-        trunk_tree = self.make_branch_and_tree('mainline',
-            format='development')
-        original_revid = trunk_tree.commit('mainline')
-        self.assertRevisionInRepository('mainline', original_revid)
-        # and a branch from it which is stacked
-        out, err = self.run_bzr(['branch', '--stacked', 'mainline',
-            'newbranch'])
-        self.assertEqual('', out)
-        self.assertEqual('Created new stacked branch referring to %s.\n' %
-            trunk_tree.branch.base, err)
-        self.assertRevisionNotInRepository('newbranch', original_revid)
-        new_tree = WorkingTree.open('newbranch')
-        new_revid = new_tree.commit('new work')
-        self.check_shallow_branch(new_revid, trunk_tree.branch.base)
-
-    def test_branch_stacked_from_smart_server(self):
-        # We can branch stacking on a smart server
-        from bzrlib.smart.server import SmartTCPServer_for_testing
-        self.transport_server = SmartTCPServer_for_testing
-        trunk = self.make_branch('mainline', format='development')
-        out, err = self.run_bzr(
-            ['branch', '--stacked', self.get_url('mainline'), 'shallow'])
-
-    def test_branch_stacked_from_non_stacked_format(self):
-        """The origin format doesn't support stacking"""
-        trunk = self.make_branch('trunk', format='pack-0.92')
-        out, err = self.run_bzr(
-            ['branch', '--stacked', 'trunk', 'shallow'])
-        # We should notify the user that we upgraded their format
-        self.assertEqualDiff(
-            'Source format does not support stacking, using format: \'1.6\'\n'
-            '  Packs 5 (adds stacking support, requires bzr 1.6)\n'
-            '\n'
-            'Created new stacked branch referring to %s.\n' % (trunk.base,),
-            err)
-
-    def test_branch_stacked_from_rich_root_non_stackable(self):
-        trunk = self.make_branch('trunk', format='rich-root-pack')
-        out, err = self.run_bzr(
-            ['branch', '--stacked', 'trunk', 'shallow'])
-        # We should notify the user that we upgraded their format
-        self.assertEqualDiff(
-            'Source format does not support stacking, using format:'
-            ' \'1.6.1-rich-root\'\n'
-            '  Packs 5 rich-root (adds stacking support, requires bzr 1.6.1)\n'
-            '\n'
-            'Created new stacked branch referring to %s.\n' % (trunk.base,),
-            err)
-
-
 
 class TestRemoteBranch(TestCaseWithSFTPServer):
 

=== modified file 'bzrlib/tests/blackbox/test_bundle_info.py'
--- bzrlib/tests/blackbox/test_bundle_info.py	2008-02-13 01:31:33 +0000
+++ bzrlib/tests/blackbox/test_bundle_info.py	2007-08-16 18:23:13 +0000
@@ -38,7 +38,7 @@
         self.assertContainsRe(info, 'file: 1 .0 multiparent.')
         self.assertContainsRe(info, 'nicks: source')
         self.assertNotContainsRe(info, 'foo')
-        self.run_bzr_error(['--verbose requires a merge directive'],
+        self.run_bzr_error(['Verbose requires a merge directive'],
                            'bundle-info -v bundle')
         target = self.make_branch('target')
         md = merge_directive.MergeDirective2.from_objects(

=== modified file 'bzrlib/tests/blackbox/test_cat.py'
--- bzrlib/tests/blackbox/test_cat.py	2007-12-05 22:42:37 +0000
+++ bzrlib/tests/blackbox/test_cat.py	2007-09-04 03:23:59 +0000
@@ -20,7 +20,6 @@
 """
 
 import os
-import sys
 
 from bzrlib.tests.blackbox import TestCaseWithTransport
 
@@ -129,9 +128,3 @@
         out, err = self.run_bzr_subprocess(['cat', url])
         self.assertEqual('contents of README\n', out)
 
-    def test_cat_nonexistent_branch(self):
-        if sys.platform == "win32":
-            location = "C:/i/do/not/exist"
-        else:
-            location = "/i/do/not/exist"
-        self.run_bzr_error(['^bzr: ERROR: Not a branch'], ['cat', location])

=== modified file 'bzrlib/tests/blackbox/test_cat_revision.py'
--- bzrlib/tests/blackbox/test_cat_revision.py	2008-08-30 17:08:54 +0000
+++ bzrlib/tests/blackbox/test_cat_revision.py	2007-06-26 20:32:49 +0000
@@ -53,10 +53,3 @@
         self.check_output(revs[1], 'cat-revision -r revid:a@r-0-1')
         self.check_output(revs[2], 'cat-revision -r revid:a@r-0-2')
         self.check_output(revs[3], 'cat-revision -r revid:a@r-0-3')
-
-    def test_cat_no_such_revid(self):
-        tree = self.make_branch_and_tree('.')
-        err = self.run_bzr('cat-revision abcd', retcode=3)[1]
-        self.assertContainsRe(err, 'The repository .* contains no revision abcd.')
-
-

=== removed file 'bzrlib/tests/blackbox/test_check.py'
--- bzrlib/tests/blackbox/test_check.py	2008-07-04 00:37:35 +0000
+++ bzrlib/tests/blackbox/test_check.py	1970-01-01 00:00:00 +0000
@@ -1,115 +0,0 @@
-# Copyright (C) 2007 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Tests for the 'check' CLI command."""
-
-from bzrlib.tests import ChrootedTestCase
-from bzrlib.tests.blackbox import ExternalBase
-
-
-class TestCheck(ExternalBase):
-
-    def test_check_no_tree(self):
-        self.make_branch('.')
-        self.run_bzr('check')
-
-    def test_check_initial_tree(self):
-        self.make_branch_and_tree('.')
-        self.run_bzr('check')
-
-    def test_check_one_commit_tree(self):
-        tree = self.make_branch_and_tree('.')
-        tree.commit('hallelujah')
-        out, err = self.run_bzr('check')
-        self.assertContainsRe(err, r"^Checking working tree at '.*'\.\n"
-                                   r"Checking repository at '.*'\.\n"
-                                   r"checked repository.*\n"
-                                   r"     1 revisions\n"
-                                   r"     0 file-ids\n"
-                                   r"     0 unique file texts\n"
-                                   r"     0 repeated file texts\n"
-                                   r"     0 unreferenced text versions\n"
-                                   r"Checking branch at '.*'\.\n"
-                                   r"checked branch.*\n$")
-
-    def test_check_branch(self):
-        tree = self.make_branch_and_tree('.')
-        tree.commit('foo')
-        out, err = self.run_bzr('check --branch')
-        self.assertContainsRe(err, r"^Checking branch at '.*'\.\n"
-                                   r"checked branch.*\n$")
-
-    def test_check_repository(self):
-        tree = self.make_branch_and_tree('.')
-        tree.commit('foo')
-        out, err = self.run_bzr('check --repo')
-        self.assertContainsRe(err, r"^Checking repository at '.*'\.\n"
-                                   r"checked repository.*\n"
-                                   r"     1 revisions\n"
-                                   r"     0 file-ids\n"
-                                   r"     0 unique file texts\n"
-                                   r"     0 repeated file texts\n"
-                                   r"     0 unreferenced text versions$")
-
-    def test_check_tree(self):
-        tree = self.make_branch_and_tree('.')
-        tree.commit('foo')
-        out, err = self.run_bzr('check --tree')
-        self.assertContainsRe(err, r"^Checking working tree at '.*'\.\n$")
-
-    def test_partial_check(self):
-        tree = self.make_branch_and_tree('.')
-        tree.commit('foo')
-        out, err = self.run_bzr('check --tree --branch')
-        self.assertContainsRe(err, r"^Checking working tree at '.*'\.\n"
-                                   r"Checking branch at '.*'\.\n"
-                                   r"checked branch.*\n$")
-
-    def test_check_missing_tree(self):
-        branch = self.make_branch('.')
-        out, err = self.run_bzr('check --tree')
-        self.assertEqual(err, "No working tree found at specified location.\n")
-
-    def test_check_missing_partial(self):
-        branch = self.make_branch('.')
-        out, err = self.run_bzr('check --tree --branch')
-        self.assertContainsRe(err,
-            r"^No working tree found at specified location\.\n"
-            r"Checking branch at '.*'\.\n"
-            r"checked branch.*\n$")
-
-    def test_check_missing_branch_in_shared_repo(self):
-        self.make_repository('shared', shared=True)
-        out, err = self.run_bzr('check --branch shared')
-        self.assertEqual(err, "No branch found at specified location.\n")
-
-
-class ChrootedCheckTests(ChrootedTestCase):
-
-    def test_check_missing_branch(self):
-        out, err = self.run_bzr(
-            'check --branch %s' % self.get_readonly_url(''))
-        self.assertEqual(err, "No branch found at specified location.\n")
-
-    def test_check_missing_repository(self):
-        out, err = self.run_bzr('check --repo %s' % self.get_readonly_url(''))
-        self.assertEqual(err, "No repository found at specified location.\n")
-
-    def test_check_missing_everything(self):
-        out, err = self.run_bzr('check %s' % self.get_readonly_url(''))
-        self.assertEqual(err, "No working tree found at specified location.\n"
-                              "No branch found at specified location.\n"
-                              "No repository found at specified location.\n")

=== modified file 'bzrlib/tests/blackbox/test_checkout.py'
--- bzrlib/tests/blackbox/test_checkout.py	2007-12-20 20:44:45 +0000
+++ bzrlib/tests/blackbox/test_checkout.py	2007-08-20 13:07:12 +0000
@@ -29,7 +29,6 @@
     workingtree,
     )
 from bzrlib.tests.blackbox import ExternalBase
-from bzrlib.tests import HardlinkFeature
 
 
 class TestCheckout(ExternalBase):
@@ -138,20 +137,3 @@
         branch.bzrdir.destroy_workingtree()
         self.run_bzr('checkout -r 0')
         self.assertEqual('null:', tree.last_revision())
-
-    def test_checkout_files_from(self):
-        branch = _mod_branch.Branch.open('branch')
-        self.run_bzr(['checkout', 'branch', 'branch2', '--files-from',
-                      'branch'])
-
-    def test_checkout_hardlink(self):
-        self.requireFeature(HardlinkFeature)
-        source = self.make_branch_and_tree('source')
-        self.build_tree(['source/file1'])
-        source.add('file1')
-        source.commit('added file')
-        self.run_bzr(['checkout', 'source', 'target', '--files-from', 'source',
-                      '--hardlink'])
-        source_stat = os.stat('source/file1')
-        target_stat = os.stat('target/file1')
-        self.assertEqual(source_stat, target_stat)

=== modified file 'bzrlib/tests/blackbox/test_commit.py'
--- bzrlib/tests/blackbox/test_commit.py	2008-08-05 00:06:19 +0000
+++ bzrlib/tests/blackbox/test_commit.py	2007-10-10 00:21:57 +0000
@@ -83,7 +83,7 @@
         tree.add("hello.txt")
         out,err = self.run_bzr('commit -m added')
         self.assertEqual('', out)
-        self.assertContainsRe(err, '^Committing to: .*\n'
+        self.assertContainsRe(err, '^Committing revision 1 to ".*"\.\n'
                               'added hello.txt\n'
                               'Committed revision 1.\n$',)
 
@@ -102,7 +102,7 @@
         self.build_tree_contents([('hello.txt', 'new contents')])
         out, err = self.run_bzr('commit -m modified')
         self.assertEqual('', out)
-        self.assertContainsRe(err, '^Committing to: .*\n'
+        self.assertContainsRe(err, '^Committing revision 2 to ".*"\.\n'
                               'modified hello\.txt\n'
                               'Committed revision 2\.\n$')
 
@@ -112,7 +112,7 @@
         wt.rename_one('hello.txt', 'gutentag.txt')
         out, err = self.run_bzr('commit -m renamed')
         self.assertEqual('', out)
-        self.assertContainsRe(err, '^Committing to: .*\n'
+        self.assertContainsRe(err, '^Committing revision 2 to ".*"\.\n'
                               'renamed hello\.txt => gutentag\.txt\n'
                               'Committed revision 2\.$\n')
 
@@ -124,7 +124,7 @@
         wt.rename_one('hello.txt', 'subdir/hello.txt')
         out, err = self.run_bzr('commit -m renamed')
         self.assertEqual('', out)
-        self.assertContainsRe(err, '^Committing to: .*\n'
+        self.assertContainsRe(err, '^Committing revision 2 to ".*"\.\n'
                               'added subdir\n'
                               'renamed hello\.txt => subdir/hello\.txt\n'
                               'Committed revision 2\.\n$')
@@ -137,7 +137,7 @@
         wt.add(['hello.txt'])
         out,err = self.run_bzr('commit -m added')
         self.assertEqual('', out)
-        self.assertContainsRe(err, '^Committing to: .*\n'
+        self.assertContainsRe(err, '^Committing revision 1 to ".*"\.\n'
                               'added hello\.txt\n'
                               'Committed revision 1\.\n$')
 
@@ -150,7 +150,7 @@
         tree.add("hello.txt")
         out,err = self.run_bzr('commit -m added')
         self.assertEqual('', out)
-        self.assertContainsRe(err, '^Committing to: .*\n'
+        self.assertContainsRe(err, '^Committing revision 2 to ".*"\.\n'
                               'added hello\.txt\n'
                               'Committed revision 2\.$\n')
 
@@ -164,7 +164,7 @@
         b_tree = a_tree.branch.create_checkout('b')
         expected = "%s/" % (osutils.abspath('a'), )
         out, err = self.run_bzr('commit -m blah --unchanged', working_dir='b')
-        self.assertEqual(err, 'Committing to: %s\n'
+        self.assertEqual(err, 'Committing revision 2 to "%s".\n'
                          'Committed revision 2.\n' % expected)
 
     def test_commit_merge_reports_all_modified_files(self):
@@ -222,7 +222,7 @@
         self.assertEqual('', out)
         expected = '%s/' % (osutils.getcwd(), )
         self.assertEqualDiff(
-            'Committing to: %s\n'
+            'Committing revision 2 to "%s".\n'
             'modified filetomodify\n'
             'added newdir\n'
             'added newfile\n'
@@ -331,35 +331,6 @@
         self.build_tree_contents([('u1/hosts', 'merge resolution\n')])
         self.run_bzr('commit -m checkin-merge-of-the-offline-work-from-u1 u1')
 
-    def test_commit_exclude_excludes_modified_files(self):
-        """Commit -x foo should ignore changes to foo."""
-        tree = self.make_branch_and_tree('.')
-        self.build_tree(['a', 'b', 'c'])
-        tree.smart_add(['.'])
-        out, err = self.run_bzr(['commit', '-m', 'test', '-x', 'b'])
-        self.assertFalse('added b' in out)
-        self.assertFalse('added b' in err)
-        # If b was excluded it will still be 'added' in status.
-        out, err = self.run_bzr(['added'])
-        self.assertEqual('b\n', out)
-        self.assertEqual('', err)
-
-    def test_commit_exclude_twice_uses_both_rules(self):
-        """Commit -x foo -x bar should ignore changes to foo and bar."""
-        tree = self.make_branch_and_tree('.')
-        self.build_tree(['a', 'b', 'c'])
-        tree.smart_add(['.'])
-        out, err = self.run_bzr(['commit', '-m', 'test', '-x', 'b', '-x', 'c'])
-        self.assertFalse('added b' in out)
-        self.assertFalse('added c' in out)
-        self.assertFalse('added b' in err)
-        self.assertFalse('added c' in err)
-        # If b was excluded it will still be 'added' in status.
-        out, err = self.run_bzr(['added'])
-        self.assertTrue('b\n' in out)
-        self.assertTrue('c\n' in out)
-        self.assertEqual('', err)
-
     def test_commit_respects_spec_for_removals(self):
         """Commit with a file spec should only commit removals that match"""
         t = self.make_branch_and_tree('.')
@@ -426,7 +397,7 @@
         output, err = self.run_bzr(
             'commit -m hello --fixes=lp:23452 tree/hello.txt')
         self.assertEqual('', output)
-        self.assertContainsRe(err, 'Committing to: .*\n'
+        self.assertContainsRe(err, 'Committing revision 1 to ".*"\.\n'
                               'added hello\.txt\n'
                               'Committed revision 1\.\n')
 
@@ -549,12 +520,11 @@
         tree = self.make_branch_and_tree('tree')
         self.build_tree(['tree/hello.txt'])
         tree.add('hello.txt')
-        self.run_bzr(["commit", '-m', 'hello',
-                      '--author', u'John D\xf6 <jdoe@example.com>',
-                     "tree/hello.txt"])
+        self.run_bzr("commit -m hello --author='John Doe <jdoe@example.com>' "
+                     "tree/hello.txt")
         last_rev = tree.branch.repository.get_revision(tree.last_revision())
         properties = last_rev.properties
-        self.assertEqual(u'John D\xf6 <jdoe@example.com>', properties['author'])
+        self.assertEqual('John Doe <jdoe@example.com>', properties['author'])
 
     def test_author_no_email(self):
         """Author's name without an email address is allowed, too."""

=== modified file 'bzrlib/tests/blackbox/test_debug.py'
--- bzrlib/tests/blackbox/test_debug.py	2007-11-01 09:52:45 +0000
+++ bzrlib/tests/blackbox/test_debug.py	2007-08-03 02:52:23 +0000
@@ -21,8 +21,7 @@
 import sys
 import time
 
-from bzrlib.tests import TestCaseInTempDir
-
+from bzrlib.tests import TestCaseInTempDir, TestSkipped
 
 class TestDebugOption(TestCaseInTempDir):
 

=== modified file 'bzrlib/tests/blackbox/test_diff.py'
--- bzrlib/tests/blackbox/test_diff.py	2008-01-04 00:26:05 +0000
+++ bzrlib/tests/blackbox/test_diff.py	2007-09-01 16:04:44 +0000
@@ -146,18 +146,18 @@
     def example_branches(self):
         branch1_tree = self.make_branch_and_tree('branch1')
         self.build_tree(['branch1/file'], line_endings='binary')
-        self.build_tree(['branch1/file2'], line_endings='binary')
         branch1_tree.add('file')
-        branch1_tree.add('file2')
-        branch1_tree.commit(message='add file and file2')
+        branch1_tree.commit(message='add file')
         branch2_tree = branch1_tree.bzrdir.sprout('branch2').open_workingtree()
         self.build_tree_contents([('branch2/file', 'new content\n')])
         branch2_tree.commit(message='update file')
         return branch1_tree, branch2_tree
 
-    def check_b2_vs_b1(self, cmd):
-        # Compare branch2 vs branch1 using cmd and check the result
-        out, err = self.run_bzr(cmd, retcode=1)
+    def test_diff_branches(self):
+        self.example_branches()
+        # should open branch1 and diff against branch2, 
+        out, err = self.run_bzr('diff -r branch:branch2 branch1',
+                                retcode=1)
         self.assertEquals('', err)
         self.assertEquals("=== modified file 'file'\n"
                           "--- file\tYYYY-MM-DD HH:MM:SS +ZZZZ\n"
@@ -166,63 +166,17 @@
                           "-new content\n"
                           "+contents of branch1/file\n"
                           "\n", subst_dates(out))
-
-    def check_b1_vs_b2(self, cmd):
-        # Compare branch1 vs branch2 using cmd and check the result
-        out, err = self.run_bzr(cmd, retcode=1)
+        out, err = self.run_bzr('diff branch2 branch1',
+                                         retcode=1)
         self.assertEquals('', err)
         self.assertEqualDiff("=== modified file 'file'\n"
                               "--- file\tYYYY-MM-DD HH:MM:SS +ZZZZ\n"
                               "+++ file\tYYYY-MM-DD HH:MM:SS +ZZZZ\n"
                               "@@ -1,1 +1,1 @@\n"
-                              "-contents of branch1/file\n"
-                              "+new content\n"
+                              "-new content\n"
+                              "+contents of branch1/file\n"
                               "\n", subst_dates(out))
 
-    def check_no_diffs(self, cmd):
-        # Check that running cmd returns an empty diff
-        out, err = self.run_bzr(cmd, retcode=0)
-        self.assertEquals('', err)
-        self.assertEquals('', out)
-
-    def test_diff_branches(self):
-        self.example_branches()
-        # should open branch1 and diff against branch2, 
-        self.check_b2_vs_b1('diff -r branch:branch2 branch1')
-        # Compare two working trees using various syntax forms
-        self.check_b2_vs_b1('diff --old branch2 --new branch1')
-        self.check_b2_vs_b1('diff --old branch2 branch1')
-        self.check_b2_vs_b1('diff branch2 --new branch1')
-        # Test with a selected file that was changed
-        self.check_b2_vs_b1('diff --old branch2 --new branch1 file')
-        self.check_b2_vs_b1('diff --old branch2 branch1/file')
-        self.check_b2_vs_b1('diff branch2/file --new branch1')
-        # Test with a selected file that was not changed
-        self.check_no_diffs('diff --old branch2 --new branch1 file2')
-        self.check_no_diffs('diff --old branch2 branch1/file2')
-        self.check_no_diffs('diff branch2/file2 --new branch1')
-
-    def test_diff_branches_no_working_trees(self):
-        branch1_tree, branch2_tree = self.example_branches()
-        # Compare a working tree to a branch without a WT
-        dir1 = branch1_tree.bzrdir
-        dir1.destroy_workingtree()
-        self.assertFalse(dir1.has_workingtree())
-        self.check_b2_vs_b1('diff --old branch2 --new branch1')
-        self.check_b2_vs_b1('diff --old branch2 branch1')
-        self.check_b2_vs_b1('diff branch2 --new branch1')
-        # Compare a branch without a WT to one with a WT
-        self.check_b1_vs_b2('diff --old branch1 --new branch2')
-        self.check_b1_vs_b2('diff --old branch1 branch2')
-        self.check_b1_vs_b2('diff branch1 --new branch2')
-        # Compare a branch with a WT against another without a WT
-        dir2 = branch2_tree.bzrdir
-        dir2.destroy_workingtree()
-        self.assertFalse(dir2.has_workingtree())
-        self.check_b1_vs_b2('diff --old branch1 --new branch2')
-        self.check_b1_vs_b2('diff --old branch1 branch2')
-        self.check_b1_vs_b2('diff branch1 --new branch2')
-
     def test_diff_revno_branches(self):
         self.example_branches()
         branch2_tree = workingtree.WorkingTree.open_containing('branch2')[0]
@@ -259,14 +213,6 @@
         output = self.run_bzr('diff -r 1.. branch1', retcode=1)
         self.assertContainsRe(output[0], '\n\\-original line\n\\+new line\n')
 
-    def test_diff_to_working_tree_in_subdir(self):
-        self.example_branch2()
-        self.build_tree_contents([('branch1/file1', 'new line')])
-        os.mkdir('branch1/dir1')
-        os.chdir('branch1/dir1')
-        output = self.run_bzr('diff -r 1..', retcode=1)
-        self.assertContainsRe(output[0], '\n\\-original line\n\\+new line\n')
-
     def test_diff_across_rename(self):
         """The working tree path should always be considered for diffing"""
         tree = self.make_example_branch()
@@ -275,14 +221,6 @@
         self.run_bzr('diff hello1', retcode=1)
         self.run_bzr('diff -r 0..1 hello1', retcode=1)
 
-    def test_diff_to_branch_no_working_tree(self):
-        branch1_tree = self.example_branch2()
-        dir1 = branch1_tree.bzrdir
-        dir1.destroy_workingtree()
-        self.assertFalse(dir1.has_workingtree())
-        output = self.run_bzr('diff -r 1.. branch1', retcode=1)
-        self.assertContainsRe(output[0], '\n\\-original line\n\\+repo line\n')
-
 
 class TestCheckoutDiff(TestDiff):
 

=== modified file 'bzrlib/tests/blackbox/test_exceptions.py'
--- bzrlib/tests/blackbox/test_exceptions.py	2007-12-07 06:18:57 +0000
+++ bzrlib/tests/blackbox/test_exceptions.py	2007-10-02 06:56:52 +0000
@@ -44,7 +44,7 @@
         self.assertContainsRe(err,
             r'bzr: ERROR: exceptions\.AssertionError: failed\n')
         self.assertContainsRe(err,
-            r'Please report a bug at https://bugs\.launchpad\.net/bzr/\+filebug')
+            r'Please send this report to')
         self.assertContainsRe(err,
             '(?m)^encoding: .*, fsenc: .*, lang: .*')
         self.assertContainsRe(err,
@@ -54,12 +54,11 @@
         # we must use a subprocess, because the normal in-memory mechanism
         # allows errors to propagate up through the test suite
         out, err = self.run_bzr_subprocess(['assert-fail'],
-            universal_newlines=True,
             retcode=errors.EXIT_INTERNAL_ERROR)
         self.assertEqual(4, errors.EXIT_INTERNAL_ERROR)
         self.assertContainsRe(err,
                 r'bzr: ERROR: exceptions\.AssertionError: always fails\n')
-        self.assertContainsRe(err, r'Please report a bug at')
+        self.assertContainsRe(err, r'Please send this report to')
     
 
 class TestDeprecationWarning(TestCaseInTempDir):

=== modified file 'bzrlib/tests/blackbox/test_export.py'
--- bzrlib/tests/blackbox/test_export.py	2008-08-08 05:25:58 +0000
+++ bzrlib/tests/blackbox/test_export.py	2007-06-26 20:32:49 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2008 Canonical Ltd
+# Copyright (C) 2005, 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -18,7 +18,6 @@
 """Black-box tests for bzr export.
 """
 
-from StringIO import StringIO
 import os
 import stat
 import sys
@@ -38,29 +37,18 @@
         tree = self.make_branch_and_tree('tar')
         self.build_tree(['tar/a'])
         tree.add('a')
-        self.build_tree_contents([('tar/.bzrrules', '')])
-        tree.add('.bzrrules')
-        self.build_tree(['tar/.bzr-adir/', 'tar/.bzr-adir/afile'])
-        tree.add(['.bzr-adir/', '.bzr-adir/afile'])
 
         os.chdir('tar')
         self.run_bzr('ignore something')
         tree.commit('1')
 
         self.failUnless(tree.has_filename('.bzrignore'))
-        self.failUnless(tree.has_filename('.bzrrules'))
-        self.failUnless(tree.has_filename('.bzr-adir'))
-        self.failUnless(tree.has_filename('.bzr-adir/afile'))
         self.run_bzr('export test.tar.gz')
         ball = tarfile.open('test.tar.gz')
         # Make sure the tarball contains 'a', but does not contain
         # '.bzrignore'.
         self.assertEqual(['test/a'], sorted(ball.getnames()))
 
-        out, err = self.run_bzr('export --format=tgz --root=test -')
-        ball = tarfile.open('', fileobj=StringIO(out))
-        self.assertEqual(['test/a'], sorted(ball.getnames()))
-
     def test_tar_export_unicode(self):
         tree = self.make_branch_and_tree('tar')
         fname = u'\xe5.txt'
@@ -82,19 +70,12 @@
         tree = self.make_branch_and_tree('zip')
         self.build_tree(['zip/a'])
         tree.add('a')
-        self.build_tree_contents([('zip/.bzrrules', '')])
-        tree.add('.bzrrules')
-        self.build_tree(['zip/.bzr-adir/', 'zip/.bzr-adir/afile'])
-        tree.add(['.bzr-adir/', '.bzr-adir/afile'])
 
         os.chdir('zip')
         self.run_bzr('ignore something')
         tree.commit('1')
 
         self.failUnless(tree.has_filename('.bzrignore'))
-        self.failUnless(tree.has_filename('.bzrrules'))
-        self.failUnless(tree.has_filename('.bzr-adir'))
-        self.failUnless(tree.has_filename('.bzr-adir/afile'))
         self.run_bzr('export test.zip')
 
         zfile = zipfile.ZipFile('test.zip')
@@ -153,19 +134,12 @@
         tree = self.make_branch_and_tree('dir')
         self.build_tree(['dir/a'])
         tree.add('a')
-        self.build_tree_contents([('dir/.bzrrules', '')])
-        tree.add('.bzrrules')
-        self.build_tree(['dir/.bzr-adir/', 'dir/.bzr-adir/afile'])
-        tree.add(['.bzr-adir/', '.bzr-adir/afile'])
 
         os.chdir('dir')
         self.run_bzr('ignore something')
         tree.commit('1')
 
         self.failUnless(tree.has_filename('.bzrignore'))
-        self.failUnless(tree.has_filename('.bzrrules'))
-        self.failUnless(tree.has_filename('.bzr-adir'))
-        self.failUnless(tree.has_filename('.bzr-adir/afile'))
         self.run_bzr('export direxport')
 
         files = sorted(os.listdir('direxport'))
@@ -174,7 +148,6 @@
         self.assertEqual(['a'], files)
 
     def example_branch(self):
-        """Create a branch a 'branch' containing hello and goodbye."""
         tree = self.make_branch_and_tree('branch')
         self.build_tree_contents([('branch/hello', 'foo')])
         tree.add('hello')
@@ -278,11 +251,3 @@
         self.run_bzr('export first -r 1 branch')
         self.assertEqual(['hello'], sorted(os.listdir('first')))
         self.check_file_contents('first/hello', 'foo')
-
-    def test_export_partial_tree(self):
-        tree = self.example_branch()
-        self.build_tree(['branch/subdir/', 'branch/subdir/foo.txt'])
-        tree.smart_add(['branch'])
-        tree.commit('more setup')
-        out, err = self.run_bzr('export exported branch/subdir')
-        self.assertEqual(['foo.txt'], os.listdir('exported'))

=== removed file 'bzrlib/tests/blackbox/test_hooks.py'
--- bzrlib/tests/blackbox/test_hooks.py	2008-04-23 09:46:52 +0000
+++ bzrlib/tests/blackbox/test_hooks.py	1970-01-01 00:00:00 +0000
@@ -1,53 +0,0 @@
-# Copyright (C) 2008 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Tests for commands related to hooks"""
-
-from bzrlib.branch import Branch
-from bzrlib.tests import TestCaseWithTransport
-
-
-class TestHooks(TestCaseWithTransport):
-
-    def _check_hooks_output(self, command_output, hooks):
-        for hook_type in Branch.hooks:
-            s = "\n  ".join(hooks.get(hook_type, ["<no hooks installed>"]))
-            self.assert_("%s:\n  %s" % (hook_type, s) in command_output)
-
-    def test_hooks_with_no_hooks(self):
-        self.make_branch('.')
-        out, err = self.run_bzr('hooks')
-        self.assertEqual(err, "")
-        for hook_type in Branch.hooks:
-            self._check_hooks_output(out, {})
-
-    def test_hooks_with_unnamed_hook(self):
-        self.make_branch('.')
-        def foo(): return
-        Branch.hooks.install_named_hook('set_rh', foo, None)
-        out, err = self.run_bzr('hooks')
-        self._check_hooks_output(out, {'set_rh': ["No hook name"]})
-
-    def test_hooks_with_named_hook(self):
-        self.make_branch('.')
-        def foo(): return
-        name = "Foo Bar Hook"
-        Branch.hooks.install_named_hook('set_rh', foo, name)
-        out, err = self.run_bzr('hooks')
-        self._check_hooks_output(out, {'set_rh': [name]})
-
-    def test_hooks_no_branch(self):
-        self.run_bzr('hooks', retcode=3)

=== modified file 'bzrlib/tests/blackbox/test_ignore.py'
--- bzrlib/tests/blackbox/test_ignore.py	2007-12-11 14:26:18 +0000
+++ bzrlib/tests/blackbox/test_ignore.py	2007-09-05 01:38:34 +0000
@@ -31,9 +31,11 @@
 import bzrlib.bzrdir as bzrdir
 from bzrlib.errors import BzrCommandError
 from bzrlib.osutils import (
+    has_symlinks,
     pathjoin,
     terminal_width,
     )
+from bzrlib.tests.HTTPTestUtil import TestCaseWithWebserver
 from bzrlib.tests.test_sftp_transport import TestCaseWithSFTPServer
 from bzrlib.tests.blackbox import ExternalBase
 from bzrlib.workingtree import WorkingTree

=== modified file 'bzrlib/tests/blackbox/test_info.py'
--- bzrlib/tests/blackbox/test_info.py	2008-08-29 05:18:56 +0000
+++ bzrlib/tests/blackbox/test_info.py	2007-10-04 05:50:44 +0000
@@ -17,15 +17,15 @@
 
 """Tests for the info command of bzr."""
 
+import os
 import sys
 
+import bzrlib
 from bzrlib import (
-    branch,
     bzrdir,
     errors,
-    info,
     osutils,
-    upgrade,
+    repository,
     urlutils,
     )
 from bzrlib.osutils import format_date
@@ -89,6 +89,7 @@
 
 Repository:
          0 revisions
+         0 KiB
 """, out)
         self.assertEqual('', err)
         tree1.commit('commit one')
@@ -146,7 +147,12 @@
 
 Repository:
          1 revision
+         %d KiB
 """ % (datestring_first, datestring_first,
+       # poking at _revision_store isn't all that clean, but neither is
+       # having the ui test dependent on the exact overhead of a given store.
+       branch2.repository._revision_store.total_size(
+        branch2.repository.get_transaction())[1] / 1024,
        ), out)
         self.assertEqual('', err)
 
@@ -154,8 +160,8 @@
         # (creates backup as unknown)
         branch1.bzrdir.sprout('bound')
         knit1_format = bzrdir.format_registry.make_bzrdir('knit')
-        upgrade.upgrade('bound', knit1_format)
-        branch3 = bzrdir.BzrDir.open('bound').open_branch()
+        bzrlib.upgrade.upgrade('bound', knit1_format)
+        branch3 = bzrlib.bzrdir.BzrDir.open('bound').open_branch()
         branch3.bind(branch1)
         bound_tree = branch3.bzrdir.open_workingtree()
         out, err = self.run_bzr('info -v bound')
@@ -193,15 +199,20 @@
 
 Repository:
          1 revision
+         %d KiB
 """ % (bound_tree._format.get_format_description(),
        branch3._format.get_format_description(),
        branch3.repository._format.get_format_description(),
        datestring_first, datestring_first,
+       # poking at _revision_store isn't all that clean, but neither is
+       # having the ui test dependent on the exact overhead of a given store.
+       branch3.repository._revision_store.total_size(
+        branch3.repository.get_transaction())[1] / 1024,
        ), out)
         self.assertEqual('', err)
 
         # Checkout standalone (same as above, but does not have parent set)
-        branch4 = bzrdir.BzrDir.create_branch_convenience('checkout',
+        branch4 = bzrlib.bzrdir.BzrDir.create_branch_convenience('checkout',
             format=knit1_format)
         branch4.bind(branch1)
         branch4.bzrdir.open_workingtree().update()
@@ -237,8 +248,13 @@
 
 Repository:
          1 revision
+         %d KiB
 """ % (branch4.repository._format.get_format_description(),
        datestring_first, datestring_first,
+       # poking at _revision_store isn't all that clean, but neither is
+       # having the ui test dependent on the exact overhead of a given store.
+       branch4.repository._revision_store.total_size(
+        branch4.repository.get_transaction())[1] / 1024,
        ), out)
         self.assertEqual('', err)
 
@@ -247,9 +263,7 @@
         branch5 = tree5.branch
         out, err = self.run_bzr('info -v lightcheckout')
         self.assertEqualDiff(
-"""Lightweight checkout (format: 1.6 or 1.6.1-rich-root \
-or dirstate or dirstate-tags or \
-pack-0.92 or rich-root or rich-root-pack)
+"""Lightweight checkout (format: dirstate or dirstate-tags)
 Location:
   light checkout root: lightcheckout
    checkout of branch: standalone
@@ -279,6 +293,7 @@
 
 Repository:
          1 revision
+         0 KiB
 """ % (datestring_first, datestring_first,), out)
         self.assertEqual('', err)
 
@@ -325,6 +340,7 @@
 
 Repository:
          1 revision
+         0 KiB
 """ % (datestring_first, datestring_first,
        ), out)
         self.assertEqual('', err)
@@ -367,8 +383,13 @@
 
 Repository:
          1 revision
+         %d KiB
 """ % (branch3.repository._format.get_format_description(),
        datestring_first, datestring_first,
+       # poking at _revision_store isn't all that clean, but neither is
+       # having the ui test dependent on the exact overhead of a given store.
+       branch3.repository._revision_store.total_size(
+        branch3.repository.get_transaction())[1] / 1024,
        ), out)
         self.assertEqual('', err)
 
@@ -407,17 +428,20 @@
 
 Repository:
          1 revision
+         %d KiB
 """ % (branch4.repository._format.get_format_description(),
        datestring_first, datestring_first,
+       # poking at _revision_store isn't all that clean, but neither is
+       # having the ui test dependent on the exact overhead of a given store.
+       branch4.repository._revision_store.total_size(
+        branch4.repository.get_transaction())[1] / 1024,
        ), out)
         self.assertEqual('', err)
 
         # Out of date lightweight checkout
         out, err = self.run_bzr('info lightcheckout --verbose')
         self.assertEqualDiff(
-"""Lightweight checkout (format: 1.6 or 1.6.1-rich-root or \
-dirstate or dirstate-tags or \
-pack-0.92 or rich-root or rich-root-pack)
+"""Lightweight checkout (format: dirstate or dirstate-tags)
 Location:
   light checkout root: lightcheckout
    checkout of branch: standalone
@@ -449,6 +473,7 @@
 
 Repository:
          2 revisions
+         0 KiB
 """ % (datestring_first, datestring_last,), out)
         self.assertEqual('', err)
 
@@ -459,7 +484,7 @@
         repo = branch.repository
         out, err = self.run_bzr('info branch -v')
         self.assertEqualDiff(
-"""Standalone branch (format: %s)
+"""Standalone branch (format: dirstate-tags)
 Location:
   branch root: branch
 
@@ -474,8 +499,8 @@
 
 Repository:
          0 revisions
-""" % (info.describe_format(repo.bzrdir, repo, branch, None),
-       format.get_branch_format().get_format_description(),
+         0 KiB
+""" % (format.get_branch_format().get_format_description(),
        format.repository_format.get_format_description(),
        ), out)
         self.assertEqual('', err)
@@ -499,6 +524,7 @@
 
 Repository:
          0 revisions
+         0 KiB
 """ % ('repo', format.repository_format.get_format_description(),
        ), out)
         self.assertEqual('', err)
@@ -525,6 +551,7 @@
 
 Repository:
          0 revisions
+         0 KiB
 """ % (format.get_branch_format().get_format_description(),
        format.repository_format.get_format_description(),
        ), out)
@@ -552,9 +579,7 @@
         datestring_first = format_date(rev.timestamp, rev.timezone)
         out, err = self.run_bzr('info tree/lightcheckout --verbose')
         self.assertEqualDiff(
-"""Lightweight checkout (format: 1.6 or 1.6.1-rich-root or \
-dirstate or dirstate-tags or \
-pack-0.92 or rich-root or rich-root-pack)
+"""Lightweight checkout (format: dirstate or dirstate-tags)
 Location:
   light checkout root: tree/lightcheckout
    checkout of branch: repo/branch
@@ -585,9 +610,13 @@
 
 Repository:
          1 revision
+         %d KiB
 """ % (format.get_branch_format().get_format_description(),
        format.repository_format.get_format_description(),
        datestring_first, datestring_first,
+       # poking at _revision_store isn't all that clean, but neither is
+       # having the ui test dependent on the exact overhead of a given store.
+       repo._revision_store.total_size(repo.get_transaction())[1] / 1024,
        ), out)
         self.assertEqual('', err)
 
@@ -623,6 +652,7 @@
 
 Repository:
          0 revisions
+         0 KiB
 """ % (format.get_branch_format().get_format_description(),
        format.repository_format.get_format_description(),
        ), out)
@@ -664,9 +694,13 @@
 
 Repository:
          1 revision
+         %d KiB
 """ % (format.get_branch_format().get_format_description(),
        format.repository_format.get_format_description(),
        datestring_first, datestring_first,
+       # poking at _revision_store isn't all that clean, but neither is
+       # having the ui test dependent on the exact overhead of a given store.
+       repo._revision_store.total_size(repo.get_transaction())[1] / 1024,
        ), out)
         self.assertEqual('', err)
         tree3.commit('commit two')
@@ -676,9 +710,7 @@
         datestring_last = format_date(rev.timestamp, rev.timezone)
         out, err = self.run_bzr('info tree/lightcheckout --verbose')
         self.assertEqualDiff(
-"""Lightweight checkout (format: 1.6 or 1.6.1-rich-root or \
-dirstate or dirstate-tags or \
-pack-0.92 or rich-root or rich-root-pack)
+"""Lightweight checkout (format: dirstate or dirstate-tags)
 Location:
   light checkout root: tree/lightcheckout
    checkout of branch: repo/branch
@@ -711,9 +743,13 @@
 
 Repository:
          2 revisions
+         %d KiB
 """ % (format.get_branch_format().get_format_description(),
        format.repository_format.get_format_description(),
        datestring_first, datestring_last,
+       # poking at _revision_store isn't all that clean, but neither is
+       # having the ui test dependent on the exact overhead of a given store.
+       repo._revision_store.total_size(repo.get_transaction())[1] / 1024,
        ), out)
         self.assertEqual('', err)
 
@@ -739,9 +775,13 @@
 
 Repository:
          2 revisions
+         %d KiB
 """ % (format.get_branch_format().get_format_description(),
        format.repository_format.get_format_description(),
        datestring_first, datestring_last,
+       # poking at _revision_store isn't all that clean, but neither is
+       # having the ui test dependent on the exact overhead of a given store.
+       repo._revision_store.total_size(repo.get_transaction())[1] / 1024,
        ), out)
         self.assertEqual('', err)
 
@@ -758,7 +798,11 @@
 
 Repository:
          2 revisions
+         %d KiB
 """ % (format.repository_format.get_format_description(),
+       # poking at _revision_store isn't all that clean, but neither is
+       # having the ui test dependent on the exact overhead of a given store.
+       repo._revision_store.total_size(repo.get_transaction())[1] / 1024,
        ), out)
         self.assertEqual('', err)
 
@@ -783,6 +827,7 @@
 
 Repository:
          0 revisions
+         0 KiB
 """ % (format.repository_format.get_format_description(),
        ), out)
         self.assertEqual('', err)
@@ -823,6 +868,7 @@
 
 Repository:
          0 revisions
+         0 KiB
 """ % (format.get_branch_format().get_format_description(),
        format.repository_format.get_format_description(),
        ), out)
@@ -867,9 +913,13 @@
 
 Repository:
          1 revision
+         %d KiB
 """ % (format.get_branch_format().get_format_description(),
        format.repository_format.get_format_description(),
        datestring_first, datestring_first,
+       # poking at _revision_store isn't all that clean, but neither is
+       # having the ui test dependent on the exact overhead of a given store.
+       repo._revision_store.total_size(repo.get_transaction())[1] / 1024,
        ), out)
         self.assertEqual('', err)
 
@@ -906,8 +956,12 @@
 
 Repository:
          1 revision
+         %d KiB
 """ % (format.get_branch_format().get_format_description(),
        format.repository_format.get_format_description(),
+       # poking at _revision_store isn't all that clean, but neither is
+       # having the ui test dependent on the exact overhead of a given store.
+       repo._revision_store.total_size(repo.get_transaction())[1] / 1024,
        ), out)
         self.assertEqual('', err)
 
@@ -949,9 +1003,13 @@
 
 Repository:
          1 revision
+         %d KiB
 """ % (format.get_branch_format().get_format_description(),
        format.repository_format.get_format_description(),
        datestring_first, datestring_first,
+       # poking at _revision_store isn't all that clean, but neither is
+       # having the ui test dependent on the exact overhead of a given store.
+       repo._revision_store.total_size(repo.get_transaction())[1] / 1024,
        ), out)
         self.assertEqual('', err)
 
@@ -970,7 +1028,11 @@
 
 Repository:
          1 revision
+         %d KiB
 """ % (format.repository_format.get_format_description(),
+       # poking at _revision_store isn't all that clean, but neither is
+       # having the ui test dependent on the exact overhead of a given store.
+       repo._revision_store.total_size(repo.get_transaction())[1] / 1024,
        ),
        out)
         self.assertEqual('', err)
@@ -996,6 +1058,7 @@
 
 Repository:
          0 revisions
+         0 KiB
 """ % (format.repository_format.get_format_description(),
        ), out)
         self.assertEqual('', err)
@@ -1033,12 +1096,13 @@
 
 Repository:
          0 revisions
+         0 KiB
 """ % (format.get_branch_format().get_format_description(),
        format.repository_format.get_format_description(),
        ), out)
         self.assertEqual('', err)
 
-    def assertCheckoutStatusOutput(self,
+    def assertCheckoutStatusOutput(self, 
         command_string, lco_tree, shared_repo=None,
         repo_branch=None,
         tree_locked=False,
@@ -1063,10 +1127,6 @@
         :param tree_locked: If true, expect the tree to be locked.
         :param branch_locked: If true, expect the branch to be locked.
         :param repo_locked: If true, expect the repository to be locked.
-            Note that the lco_tree.branch.repository is inspected, and if is not
-            actually locked then this parameter is overridden. This is because
-            pack repositories do not have any public API for obtaining an
-            exclusive repository wide lock.
         :param verbose: If true, expect verbose output
         """
         def friendly_location(url):
@@ -1076,15 +1136,12 @@
             except errors.PathNotChild:
                 return path
 
-        if tree_locked:
-            # We expect this to fail because of locking errors.
-            # (A write-locked file cannot be read-locked
-            # in the different process -- either on win32 or on linux).
+        if tree_locked and sys.platform == 'win32':
+            # We expect this to fail because of locking errors. (A write-locked
+            # file cannot be read-locked in the same process).
             # This should be removed when the locking errors are fixed.
-            self.expectFailure('OS locks are exclusive '
-                'for different processes (Bug #174055)',
-                self.run_bzr_subprocess,
-                'info ' + command_string)
+            self.run_bzr_error([], 'info ' + command_string)
+            return
         out, err = self.run_bzr('info %s' % command_string)
         description = {
             (True, True): 'Lightweight checkout',
@@ -1092,12 +1149,8 @@
             (False, True): 'Lightweight checkout',
             (False, False): 'Checkout',
             }[(shared_repo is not None, light_checkout)]
-        format = {True: '1.6 or 1.6.1-rich-root'
-                        ' or dirstate or dirstate-tags or pack-0.92'
-                        ' or rich-root or rich-root-pack',
+        format = {True: 'dirstate or dirstate-tags',
                   False: 'dirstate'}[light_checkout]
-        if repo_locked:
-            repo_locked = lco_tree.branch.repository.get_physical_lock_status()
         if repo_locked or branch_locked or tree_locked:
             def locked_message(a_bool):
                 if a_bool:
@@ -1169,6 +1222,7 @@
 %s
 Repository:
          0 revisions
+         0 KiB
 """ %  (description,
         format,
         tree_data,
@@ -1185,21 +1239,21 @@
         transport = self.get_transport()
         # Create shared repository with a branch
         repo = self.make_repository('repo', shared=True,
-                                    format=bzrdir.BzrDirMetaFormat1())
+                                    format=bzrlib.bzrdir.BzrDirMetaFormat1())
         repo.set_make_working_trees(False)
         repo.bzrdir.root_transport.mkdir('branch')
         repo_branch = repo.bzrdir.create_branch_convenience('repo/branch',
-                                    format=bzrdir.BzrDirMetaFormat1())
+                                    format=bzrlib.bzrdir.BzrDirMetaFormat1())
         # Do a heavy checkout
         transport.mkdir('tree')
         transport.mkdir('tree/checkout')
-        co_branch = bzrdir.BzrDir.create_branch_convenience('tree/checkout',
-            format=bzrdir.BzrDirMetaFormat1())
+        co_branch = bzrlib.bzrdir.BzrDir.create_branch_convenience('tree/checkout',
+            format=bzrlib.bzrdir.BzrDirMetaFormat1())
         co_branch.bind(repo_branch)
         # Do a light checkout of the heavy one
         transport.mkdir('tree/lightcheckout')
-        lco_dir = bzrdir.BzrDirMetaFormat1().initialize('tree/lightcheckout')
-        branch.BranchReferenceFormat().initialize(lco_dir, co_branch)
+        lco_dir = bzrlib.bzrdir.BzrDirMetaFormat1().initialize('tree/lightcheckout')
+        bzrlib.branch.BranchReferenceFormat().initialize(lco_dir, co_branch)
         lco_dir.create_workingtree()
         lco_tree = lco_dir.open_workingtree()
 
@@ -1298,7 +1352,7 @@
             raise TestSkipped("don't use oslocks on win32 in unix manner")
 
         tree = self.make_branch_and_tree('branch',
-                                         format=bzrdir.BzrDirFormat6())
+                                         format=bzrlib.bzrdir.BzrDirFormat6())
 
         # Test all permutations of locking the working tree, branch and repository
         # XXX: Well not yet, as we can't query oslocks yet. Currently, it's
@@ -1335,6 +1389,7 @@
 
 Repository:
          0 revisions
+         0 KiB
 """ % ('branch', tree.branch.repository._format.get_format_description(),
        ), out)
         self.assertEqual('', err)
@@ -1368,26 +1423,8 @@
 
 Repository:
          0 revisions
+         0 KiB
 """ % ('branch', tree.branch.repository._format.get_format_description(),
        ), out)
         self.assertEqual('', err)
         tree.unlock()
-
-    def test_info_stacked(self):
-        # We have a mainline
-        trunk_tree = self.make_branch_and_tree('mainline',
-            format='development1')
-        trunk_tree.commit('mainline')
-        # and a branch from it which is stacked
-        new_dir = trunk_tree.bzrdir.sprout('newbranch', stacked=True)
-        out, err = self.run_bzr('info newbranch')
-        self.assertEqual(
-"""Standalone tree (format: development1)
-Location:
-  branch root: newbranch
-
-Related branches:
-  parent branch: mainline
-     stacked on: mainline
-""", out)
-        self.assertEqual("", err)

=== modified file 'bzrlib/tests/blackbox/test_init.py'
--- bzrlib/tests/blackbox/test_init.py	2008-07-18 07:29:06 +0000
+++ bzrlib/tests/blackbox/test_init.py	2007-06-27 19:13:50 +0000
@@ -44,10 +44,7 @@
         # --format=weave should be accepted to allow interoperation with
         # old releases when desired.
         out, err = self.run_bzr('init --format=weave')
-        self.assertEqual("""Standalone tree (format: weave)
-Location:
-  branch root: .
-""", out)
+        self.assertEqual('', out)
         self.assertEqual('', err)
 
     def test_init_at_repository_root(self):
@@ -60,32 +57,19 @@
         repo = newdir.create_repository(shared=True)
         repo.set_make_working_trees(False)
         out, err = self.run_bzr('init repo')
-        self.assertEqual(
-"""Repository tree (format: pack-0.92)
-Location:
-  shared repository: repo
-  repository branch: repo
-""", out)
+        self.assertEqual('', out)
         self.assertEqual('', err)
         newdir.open_branch()
         newdir.open_workingtree()
         
     def test_init_branch(self):
         out, err = self.run_bzr('init')
-        self.assertEqual(
-"""Standalone tree (format: pack-0.92)
-Location:
-  branch root: .
-""", out)
+        self.assertEqual('', out)
         self.assertEqual('', err)
 
         # Can it handle subdirectories of branches too ?
         out, err = self.run_bzr('init subdir1')
-        self.assertEqual(
-"""Standalone tree (format: pack-0.92)
-Location:
-  branch root: subdir1
-""", out)
+        self.assertEqual('', out)
         self.assertEqual('', err)
         WorkingTree.open('subdir1')
         
@@ -96,21 +80,13 @@
         
         os.mkdir('subdir2')
         out, err = self.run_bzr('init subdir2')
-        self.assertEqual("""Standalone tree (format: pack-0.92)
-Location:
-  branch root: subdir2
-""", out)
+        self.assertEqual('', out)
         self.assertEqual('', err)
         # init an existing branch.
         out, err = self.run_bzr('init subdir2', retcode=3)
         self.assertEqual('', out)
         self.failUnless(err.startswith('bzr: ERROR: Already a branch:'))
 
-    def test_init_branch_quiet(self):
-        out, err = self.run_bzr('init -q')
-        self.assertEqual('', out)
-        self.assertEqual('', err)
-
     def test_init_existing_branch(self):
         self.run_bzr('init')
         out, err = self.run_bzr('init', retcode=3)
@@ -166,9 +142,7 @@
     def test_init(self):
         # init on a remote url should succeed.
         out, err = self.run_bzr(['init', self.get_url()])
-        self.assertStartsWith(out, """Standalone branch (format: pack-0.92)
-Location:
-  branch root: """)
+        self.assertEqual('', out)
         self.assertEqual('', err)
     
     def test_init_existing_branch(self):

=== modified file 'bzrlib/tests/blackbox/test_locale.py'
--- bzrlib/tests/blackbox/test_locale.py	2008-06-26 17:18:55 +0000
+++ bzrlib/tests/blackbox/test_locale.py	2007-08-31 00:35:37 +0000
@@ -65,12 +65,6 @@
         # as the first part of the string. It may be a little tempermental
         self.assertEqualDiff("""\
 bzr: warning: unsupported locale setting
-  bzr could not set the application locale.
-  Although this should be no problem for bzr itself,
-  it might cause problems with some plugins.
-  To investigate the issue, look at the output
-  of the locale(1p) tool available on POSIX systems.
-bzr: warning: unsupported locale setting
   Could not determine what text encoding to use.
   This error usually means your Python interpreter
   doesn't support the locale set by $LANG (BOGUS)

=== modified file 'bzrlib/tests/blackbox/test_log.py'
--- bzrlib/tests/blackbox/test_log.py	2008-09-01 00:56:53 +0000
+++ bzrlib/tests/blackbox/test_log.py	2007-09-16 02:29:50 +0000
@@ -23,14 +23,6 @@
 import bzrlib
 from bzrlib.tests.blackbox import ExternalBase
 from bzrlib.tests import TestCaseInTempDir, TestCaseWithTransport
-from bzrlib.tests.test_log import (
-    normalize_log,
-    )
-from bzrlib.tests import test_log
-
-
-class TestCaseWithoutPropsHandler(ExternalBase, test_log.TestCaseWithoutPropsHandler):
-    pass
 
 
 class TestLog(ExternalBase):
@@ -68,29 +60,9 @@
     def test_log_null_both_revspecs(self):
         self._prepare()
         log = self.run_bzr("log -r ..")[0]
+        self.assertEquals(self.full_log, log)
         self.assertEqualDiff(self.full_log, log)
 
-    def test_log_zero_revspec(self):
-        self._prepare()
-        self.run_bzr_error('bzr: ERROR: Logging revision 0 is invalid.',
-                           ['log', '-r0'])
-
-    def test_log_zero_begin_revspec(self):
-        self._prepare()
-        self.run_bzr_error('bzr: ERROR: Logging revision 0 is invalid.',
-                           ['log', '-r0..2'])
-
-    def test_log_zero_end_revspec(self):
-        self._prepare()
-        self.run_bzr_error('bzr: ERROR: Logging revision 0 is invalid.',
-                           ['log', '-r-2..0'])
-
-    def test_log_unsupported_timezone(self):
-        self._prepare()
-        self.run_bzr_error('bzr: ERROR: Unsupported timezone format "foo", '
-                           'options are "utc", "original", "local".',
-                           ['log', '--timezone', 'foo'])
-
     def test_log_negative_begin_revspec_full_log(self):
         self._prepare()
         log = self.run_bzr("log -r -3..")[0]
@@ -115,7 +87,7 @@
         self.assertTrue('revno: 2\n' in log)
         self.assertTrue('revno: 3\n' in log)
 
-    def test_log_positive_revspecs(self):
+    def test_log_postive_revspecs(self):
         self._prepare()
         log = self.run_bzr("log -r 1..3")[0]
         self.assertEqualDiff(self.full_log, log)
@@ -177,31 +149,13 @@
         self.assertContainsRe(log, r'tags: tag1')
 
     def test_log_limit(self):
-        tree = self.make_branch_and_tree('.')
-        # We want more commits than our batch size starts at
-        for pos in range(10):
-            tree.commit("%s" % pos)
+        self._prepare()
         log = self.run_bzr("log --limit 2")[0]
-        self.assertNotContainsRe(log, r'revno: 1\n')
-        self.assertNotContainsRe(log, r'revno: 2\n')
-        self.assertNotContainsRe(log, r'revno: 3\n')
-        self.assertNotContainsRe(log, r'revno: 4\n')
-        self.assertNotContainsRe(log, r'revno: 5\n')
-        self.assertNotContainsRe(log, r'revno: 6\n')
-        self.assertNotContainsRe(log, r'revno: 7\n')
-        self.assertNotContainsRe(log, r'revno: 8\n')
-        self.assertContainsRe(log, r'revno: 9\n')
-        self.assertContainsRe(log, r'revno: 10\n')
-
-    def test_log_limit_short(self):
-        self._prepare()
-        log = self.run_bzr("log -l 2")[0]
-        self.assertNotContainsRe(log, r'revno: 1\n')
-        self.assertContainsRe(log, r'revno: 2\n')
-        self.assertContainsRe(log, r'revno: 3\n')
-
-
-class TestLogMerges(TestCaseWithoutPropsHandler):
+        self.assertTrue('revno: 1\n' not in log)
+        self.assertTrue('revno: 2\n' in log)
+        self.assertTrue('revno: 3\n' in log)
+
+class TestLogMerges(ExternalBase):
 
     def _prepare(self):
         parent_tree = self.make_branch_and_tree('parent')
@@ -220,106 +174,135 @@
     def test_merges_are_indented_by_level(self):
         self._prepare()
         out,err = self.run_bzr('log')
+        # the log will look something like:
+#        self.assertEqual("""\
+#------------------------------------------------------------
+#revno: 2
+#committer: Robert Collins <foo@example.com>
+#branch nick: parent
+#timestamp: Tue 2006-03-28 22:31:40 +1100
+#message:
+#  merge branch 1
+#    ------------------------------------------------------------
+#    revno: 1.1.2  
+#    committer: Robert Collins <foo@example.com>
+#    branch nick: child
+#    timestamp: Tue 2006-03-28 22:31:40 +1100
+#    message:
+#      merge branch 2
+#        ------------------------------------------------------------
+#        revno: 1.1.1.1
+#        committer: Robert Collins <foo@example.com>
+#        branch nick: smallerchild
+#        timestamp: Tue 2006-03-28 22:31:40 +1100
+#        message:
+#          branch 2
+#    ------------------------------------------------------------
+#    revno: 1.1.1
+#    committer: Robert Collins <foo@example.com>
+#    branch nick: child
+#    timestamp: Tue 2006-03-28 22:31:40 +1100
+#    message:
+#      branch 1
+#------------------------------------------------------------
+#revno: 1
+#committer: Robert Collins <foo@example.com>
+#branch nick: parent
+#timestamp: Tue 2006-03-28 22:31:39 +1100
+#message:
+#  first post
+#""", out)
+        # but we dont have a nice pattern matcher hooked up yet, so:
+        # we check for the indenting of the commit message and the 
+        # revision numbers 
+        self.assertTrue('revno: 2' in out)
+        self.assertTrue('  merge branch 1' in out)
+        self.assertTrue('    revno: 1.1.2' in out)
+        self.assertTrue('      merge branch 2' in out)
+        self.assertTrue('        revno: 1.1.1.1' in out)
+        self.assertTrue('          branch 2' in out)
+        self.assertTrue('    revno: 1.1.1' in out)
+        self.assertTrue('      branch 1' in out)
+        self.assertTrue('revno: 1\n' in out)
+        self.assertTrue('  first post' in out)
         self.assertEqual('', err)
-        log = normalize_log(out)
-        self.assertEqualDiff(log, """\
-------------------------------------------------------------
-revno: 2
-committer: Lorem Ipsum <test@example.com>
-branch nick: parent
-timestamp: Just now
-message:
-  merge branch 1
-    ------------------------------------------------------------
-    revno: 1.1.2
-    committer: Lorem Ipsum <test@example.com>
-    branch nick: child
-    timestamp: Just now
-    message:
-      merge branch 2
-        ------------------------------------------------------------
-        revno: 1.2.1
-        committer: Lorem Ipsum <test@example.com>
-        branch nick: smallerchild
-        timestamp: Just now
-        message:
-          branch 2
-    ------------------------------------------------------------
-    revno: 1.1.1
-    committer: Lorem Ipsum <test@example.com>
-    branch nick: child
-    timestamp: Just now
-    message:
-      branch 1
-------------------------------------------------------------
-revno: 1
-committer: Lorem Ipsum <test@example.com>
-branch nick: parent
-timestamp: Just now
-message:
-  first post
-""")
 
     def test_merges_single_merge_rev(self):
         self._prepare()
         out,err = self.run_bzr('log -r1.1.2')
+        # the log will look something like:
+#        self.assertEqual("""\
+#------------------------------------------------------------
+#revno: 1.1.2  
+#committer: Robert Collins <foo@example.com>
+#branch nick: child
+#timestamp: Tue 2006-03-28 22:31:40 +1100
+#message:
+#  merge branch 2
+#    ------------------------------------------------------------
+#    revno: 1.1.1.1
+#    committer: Robert Collins <foo@example.com>
+#    branch nick: smallerchild
+#    timestamp: Tue 2006-03-28 22:31:40 +1100
+#    message:
+#      branch 2
+#""", out)
+        # but we dont have a nice pattern matcher hooked up yet, so:
+        # we check for the indenting of the commit message and the 
+        # revision numbers 
+        self.assertTrue('revno: 2' not in out)
+        self.assertTrue('  merge branch 1' not in out)
+        self.assertTrue('revno: 1.1.2' in out)
+        self.assertTrue('  merge branch 2' in out)
+        self.assertTrue('    revno: 1.1.1.1' in out)
+        self.assertTrue('      branch 2' in out)
+        self.assertTrue('revno: 1.1.1\n' not in out)
+        self.assertTrue('  branch 1' not in out)
+        self.assertTrue('revno: 1\n' not in out)
+        self.assertTrue('  first post' not in out)
         self.assertEqual('', err)
-        log = normalize_log(out)
-        self.assertEqualDiff(log, """\
-------------------------------------------------------------
-revno: 1.1.2
-committer: Lorem Ipsum <test@example.com>
-branch nick: child
-timestamp: Just now
-message:
-  merge branch 2
-    ------------------------------------------------------------
-    revno: 1.2.1
-    committer: Lorem Ipsum <test@example.com>
-    branch nick: smallerchild
-    timestamp: Just now
-    message:
-      branch 2
-""")
 
     def test_merges_partial_range(self):
         self._prepare()
         out,err = self.run_bzr('log -r1.1.1..1.1.2')
+        # the log will look something like:
+#        self.assertEqual("""\
+#------------------------------------------------------------
+#revno: 1.1.2  
+#committer: Robert Collins <foo@example.com>
+#branch nick: child
+#timestamp: Tue 2006-03-28 22:31:40 +1100
+#message:
+#  merge branch 2
+#    ------------------------------------------------------------
+#    revno: 1.1.1.1
+#    committer: Robert Collins <foo@example.com>
+#    branch nick: smallerchild
+#    timestamp: Tue 2006-03-28 22:31:40 +1100
+#    message:
+#      branch 2
+#------------------------------------------------------------
+#revno: 1.1.1
+#committer: Robert Collins <foo@example.com>
+#branch nick: child
+#timestamp: Tue 2006-03-28 22:31:40 +1100
+#message:
+#  branch 1
+#""", out)
+        # but we dont have a nice pattern matcher hooked up yet, so:
+        # we check for the indenting of the commit message and the 
+        # revision numbers 
+        self.assertTrue('revno: 2' not in out)
+        self.assertTrue('  merge branch 1' not in out)
+        self.assertTrue('revno: 1.1.2' in out)
+        self.assertTrue('  merge branch 2' in out)
+        self.assertTrue('    revno: 1.1.1.1' in out)
+        self.assertTrue('      branch 2' in out)
+        self.assertTrue('revno: 1.1.1' in out)
+        self.assertTrue('  branch 1' in out)
+        self.assertTrue('revno: 1\n' not in out)
+        self.assertTrue('  first post' not in out)
         self.assertEqual('', err)
-        log = normalize_log(out)
-        self.assertEqualDiff(log, """\
-------------------------------------------------------------
-revno: 1.1.2
-committer: Lorem Ipsum <test@example.com>
-branch nick: child
-timestamp: Just now
-message:
-  merge branch 2
-    ------------------------------------------------------------
-    revno: 1.2.1
-    committer: Lorem Ipsum <test@example.com>
-    branch nick: smallerchild
-    timestamp: Just now
-    message:
-      branch 2
-------------------------------------------------------------
-revno: 1.1.1
-committer: Lorem Ipsum <test@example.com>
-branch nick: child
-timestamp: Just now
-message:
-  branch 1
-""")
-
-    def test_merges_nonsupporting_formatter(self):
-        self._prepare()
-        err_msg = 'Selected log formatter only supports mainline revisions.'
-        # The single revision case is tested in the core tests
-        # since all standard formatters support single merge revisions.
-        out,err = self.run_bzr('log --short -r1..1.1.2', retcode=3)
-        self.assertContainsRe(err, err_msg)
-        out,err = self.run_bzr('log --short -r1.1.1..1.1.2', retcode=3)
-        self.assertContainsRe(err, err_msg)
 
  
 class TestLogEncodings(TestCaseInTempDir):

=== modified file 'bzrlib/tests/blackbox/test_ls.py'
--- bzrlib/tests/blackbox/test_ls.py	2008-05-02 00:48:17 +0000
+++ bzrlib/tests/blackbox/test_ls.py	2007-06-26 20:32:49 +0000
@@ -60,15 +60,10 @@
                        '--unknown')
         self.ls_equals('', '--ignored')
         self.ls_equals('', '--versioned')
-        self.ls_equals('', '-V')
         self.ls_equals('.bzrignore\n'
                        'a\n',
                        '--unknown --ignored --versioned')
-        self.ls_equals('.bzrignore\n'
-                       'a\n',
-                       '--unknown --ignored -V')
         self.ls_equals('', '--ignored --versioned')
-        self.ls_equals('', '--ignored -V')
         self.ls_equals('.bzrignore\0a\0', '--null')
 
     def test_ls_added(self):
@@ -220,9 +215,6 @@
         self.ls_equals('.bzrignore\n'
                        'a\n'
                        , '--versioned')
-        self.ls_equals('.bzrignore\n'
-                       'a\n'
-                       , '-V')
 
     def test_kinds(self):
         self.build_tree(['subdir/'])

=== modified file 'bzrlib/tests/blackbox/test_merge.py'
--- bzrlib/tests/blackbox/test_merge.py	2008-08-02 17:10:50 +0000
+++ bzrlib/tests/blackbox/test_merge.py	2007-09-25 19:01:48 +0000
@@ -70,8 +70,6 @@
         a_tree.revert(backups=False)
         self.run_bzr('merge ../b -r last:1..last:1 --merge-type weave')
         a_tree.revert(backups=False)
-        self.run_bzr('merge ../b -r last:1..last:1 --merge-type lca')
-        a_tree.revert(backups=False)
         self.run_bzr_error(['Show-base is not supported for this merge type'],
                            'merge ../b -r last:1..last:1 --merge-type weave'
                            ' --show-base')
@@ -138,7 +136,7 @@
         self.failUnlessExists('sub/a.txt.BASE')
 
     def test_merge_remember(self):
-        """Merge changes from one branch to another, test submit location."""
+        """Merge changes from one branch to another and test parent location."""
         tree_a = self.make_branch_and_tree('branch_a')
         branch_a = tree_a.branch
         self.build_tree(['branch_a/a'])
@@ -168,18 +166,15 @@
         tree_b.add('d')
         self.run_bzr_error(['Working tree ".*" has uncommitted changes'],
                            'merge ../branch_a')
-        self.assertEquals(abspath(branch_b.get_submit_branch()),
-                          abspath(parent))
+        self.assertEquals(abspath(branch_b.get_parent()), abspath(parent))
         # test implicit --remember after resolving conflict
         tree_b.commit('commit d')
         out, err = self.run_bzr('merge')
         
         base = urlutils.local_path_from_url(branch_a.base)
-        self.assertStartsWith(err,
-                          'Merging from remembered submit location %s\n' % (base,))
-        self.assertEndsWith(err, '+N  b\nAll changes applied successfully.\n')
-        self.assertEquals(abspath(branch_b.get_submit_branch()),
-                          abspath(parent))
+        self.assertEquals(out, 'Merging from remembered location %s\n' % (base,))
+        self.assertEquals(err, '+N  b\nAll changes applied successfully.\n')
+        self.assertEquals(abspath(branch_b.get_parent()), abspath(parent))
         # re-open tree as external run_bzr modified it
         tree_b = branch_b.bzrdir.open_workingtree()
         tree_b.commit('merge branch_a')
@@ -187,7 +182,7 @@
         out, err = self.run_bzr('merge ../branch_c --remember')
         self.assertEquals(out, '')
         self.assertEquals(err, '+N  c\nAll changes applied successfully.\n')
-        self.assertEquals(abspath(branch_b.get_submit_branch()),
+        self.assertEquals(abspath(branch_b.get_parent()),
                           abspath(branch_c.bzrdir.root_transport.base))
         # re-open tree as external run_bzr modified it
         tree_b = branch_b.bzrdir.open_workingtree()
@@ -243,18 +238,6 @@
         self.run_bzr_error(('Cannot use --uncommitted and --revision',),
                            'merge /a --uncommitted -r1 -d b')
 
-    def test_merge_uncommitted_file(self):
-        """It should be possible to merge changes from a single file."""
-        tree_a = self.make_branch_and_tree('tree_a')
-        tree_a.commit('initial commit')
-        tree_a.bzrdir.sprout('tree_b')
-        self.build_tree(['tree_a/file1', 'tree_a/file2'])
-        tree_a.add(['file1', 'file2'])
-        os.chdir('tree_b')
-        self.run_bzr(['merge', '--uncommitted', '../tree_a/file1'])
-        self.failUnlessExists('file1')
-        self.failIfExists('file2')
-
     def pullable_branch(self):
         tree_a = self.make_branch_and_tree('a')
         self.build_tree(['a/file'])
@@ -306,10 +289,9 @@
         target.commit('empty commit')
         self.write_directive('directive', source.branch, 'target', 'rev2',
                              'rev1')
-        out, err = self.run_bzr('merge -d target directive')
+        self.run_bzr('merge -d target directive')
         self.failIfExists('target/a')
         self.failUnlessExists('target/b')
-        self.assertContainsRe(err, 'Performing cherrypick')
 
     def write_directive(self, filename, source, target, revision_id,
                         base_revision_id=None, mangle_patch=False):
@@ -398,97 +380,3 @@
         # pick 1 revision with option --changes
         self.run_bzr('merge -d target -c revid:rev_d source')
         self.assertDirectoryContent('target', ['.bzr', 'a', 'd'])
-
-    def test_merge_criss_cross(self):
-        tree_a = self.make_branch_and_tree('a')
-        tree_a.commit('', rev_id='rev1')
-        tree_b = tree_a.bzrdir.sprout('b').open_workingtree()
-        tree_a.commit('', rev_id='rev2a')
-        tree_b.commit('', rev_id='rev2b')
-        tree_a.merge_from_branch(tree_b.branch)
-        tree_b.merge_from_branch(tree_a.branch)
-        tree_a.commit('', rev_id='rev3a')
-        tree_b.commit('', rev_id='rev3b')
-        graph = tree_a.branch.repository.get_graph(tree_b.branch.repository)
-        out, err = self.run_bzr(['merge', '-d', 'a', 'b'])
-        self.assertContainsRe(err, 'Warning: criss-cross merge encountered.')
-
-    def test_merge_from_submit(self):
-        tree_a = self.make_branch_and_tree('a')
-        tree_b = tree_a.bzrdir.sprout('b').open_workingtree()
-        tree_c = tree_a.bzrdir.sprout('c').open_workingtree()
-        out, err = self.run_bzr(['merge', '-d', 'c'])
-        self.assertContainsRe(err, 'Merging from remembered parent location .*a\/')
-        tree_c.branch.set_submit_branch(tree_b.bzrdir.root_transport.base)
-        out, err = self.run_bzr(['merge', '-d', 'c'])
-        self.assertContainsRe(err, 'Merging from remembered submit location .*b\/')
-
-    def test_remember_sets_submit(self):
-        tree_a = self.make_branch_and_tree('a')
-        tree_b = tree_a.bzrdir.sprout('b').open_workingtree()
-        self.assertIs(tree_b.branch.get_submit_branch(), None)
-
-        # Remember should not happen if using default from parent
-        out, err = self.run_bzr(['merge', '-d', 'b'])
-        self.assertIs(tree_b.branch.get_submit_branch(), None)
-
-        # Remember should happen if user supplies location
-        out, err = self.run_bzr(['merge', '-d', 'b', 'a'])
-        self.assertEqual(tree_b.branch.get_submit_branch(),
-                         tree_a.bzrdir.root_transport.base)
-
-    def test_weave_cherrypick(self):
-        this_tree = self.make_branch_and_tree('this')
-        self.build_tree_contents([('this/file', "a\n")])
-        this_tree.add('file')
-        this_tree.commit('rev1')
-        other_tree = this_tree.bzrdir.sprout('other').open_workingtree()
-        self.build_tree_contents([('other/file', "a\nb\n")])
-        other_tree.commit('rev2b')
-        self.build_tree_contents([('other/file', "c\na\nb\n")])
-        other_tree.commit('rev3b')
-        self.run_bzr('merge --weave -d this other -r -2..-1')
-        self.assertFileEqual('c\na\n', 'this/file')
-
-    def test_lca_merge_criss_cross(self):
-        tree_a = self.make_branch_and_tree('a')
-        self.build_tree_contents([('a/file', 'base-contents\n')])
-        tree_a.add('file')
-        tree_a.commit('', rev_id='rev1')
-        tree_b = tree_a.bzrdir.sprout('b').open_workingtree()
-        self.build_tree_contents([('a/file',
-                                   'base-contents\nthis-contents\n')])
-        tree_a.commit('', rev_id='rev2a')
-        self.build_tree_contents([('b/file',
-                                   'base-contents\nother-contents\n')])
-        tree_b.commit('', rev_id='rev2b')
-        tree_a.merge_from_branch(tree_b.branch)
-        self.build_tree_contents([('a/file',
-                                   'base-contents\nthis-contents\n')])
-        tree_a.set_conflicts(ConflictList())
-        tree_b.merge_from_branch(tree_a.branch)
-        self.build_tree_contents([('b/file',
-                                   'base-contents\nother-contents\n')])
-        tree_b.set_conflicts(ConflictList())
-        tree_a.commit('', rev_id='rev3a')
-        tree_b.commit('', rev_id='rev3b')
-        out, err = self.run_bzr(['merge', '-d', 'a', 'b', '--lca'], retcode=1)
-        self.assertFileEqual('base-contents\n<<<<<<< TREE\nthis-contents\n'
-                             '=======\nother-contents\n>>>>>>> MERGE-SOURCE\n',
-                             'a/file')
-
-    def test_merge_preview(self):
-        this_tree = self.make_branch_and_tree('this')
-        this_tree.commit('rev1')
-        other_tree = this_tree.bzrdir.sprout('other').open_workingtree()
-        self.build_tree_contents([('other/file', 'new line')])
-        other_tree.add('file')
-        other_tree.commit('rev2a')
-        this_tree.commit('rev2b')
-        out, err = self.run_bzr(['merge', '-d', 'this', 'other', '--preview'])
-        self.assertContainsRe(out, '\+new line')
-        self.assertNotContainsRe(err, '\+N  file\n')
-        this_tree.lock_read()
-        self.addCleanup(this_tree.unlock)
-        self.assertEqual([],
-                         list(this_tree.iter_changes(this_tree.basis_tree())))

=== modified file 'bzrlib/tests/blackbox/test_missing.py'
--- bzrlib/tests/blackbox/test_missing.py	2008-08-02 17:10:50 +0000
+++ bzrlib/tests/blackbox/test_missing.py	2007-08-08 12:48:16 +0000
@@ -77,8 +77,9 @@
         lines2 = self.run_bzr('missing ../b --mine-only', retcode=1)[0]
         lines2 = lines2.splitlines()
         self.assertEqual(lines, lines2)
-        lines3 = self.run_bzr('missing ../b --theirs-only', retcode=0)[0]
-        self.assertEqualDiff('Other branch is up to date.\n', lines3)
+        lines3 = self.run_bzr('missing ../b --theirs-only', retcode=1)[0]
+        lines3 = lines3.splitlines()
+        self.assertEqual(0, len(lines3))
 
         # relative to a, missing the 'merge' commit 
         os.chdir('../b')
@@ -88,8 +89,9 @@
         lines2 = self.run_bzr('missing ../a --theirs-only', retcode=1)[0]
         lines2 = lines2.splitlines()
         self.assertEqual(lines, lines2)
-        lines3 = self.run_bzr('missing ../a --mine-only', retcode=0)[0]
-        self.assertEqualDiff('This branch is up to date.\n', lines3)
+        lines3 = self.run_bzr('missing ../a --mine-only', retcode=1)[0]
+        lines3 = lines3.splitlines()
+        self.assertEqual(0, len(lines3))
         lines4 = self.run_bzr('missing ../a --short', retcode=1)[0]
         lines4 = lines4.splitlines()
         self.assertEqual(4, len(lines4))
@@ -107,22 +109,9 @@
         self.assertEqual("modified:", lines8[-2])
         self.assertEqual("  a", lines8[-1])
 
-        os.chdir('../a')
-        self.assertEqualDiff('Other branch is up to date.\n',
-                             self.run_bzr('missing ../b --theirs-only')[0])
-
         # after a pull we're back on track
         b_tree.pull(a_branch)
-        self.assertEqualDiff("Branches are up to date.\n",
-                             self.run_bzr('missing ../b')[0])
-        os.chdir('../b')
-        self.assertEqualDiff('Branches are up to date.\n',
-                             self.run_bzr('missing ../a')[0])
-        # If you supply mine or theirs you only know one side is up to date
-        self.assertEqualDiff('This branch is up to date.\n',
-                             self.run_bzr('missing ../a --mine-only')[0])
-        self.assertEqualDiff('Other branch is up to date.\n',
-                             self.run_bzr('missing ../a --theirs-only')[0])
+        self.assertEqual("Branches are up to date.\n", self.run_bzr('missing ../a')[0])
 
     def test_missing_check_last_location(self):
         # check that last location shown as filepath not file URL
@@ -142,7 +131,7 @@
 
         # check last location
         lines, err = self.run_bzr('missing', working_dir='../b')
-        self.assertEquals('Using saved parent location: %s\n'
+        self.assertEquals('Using last location: %s\n'
                           'Branches are up to date.\n' % location,
                           lines)
         self.assertEquals('', err)

=== removed file 'bzrlib/tests/blackbox/test_modified.py'
--- bzrlib/tests/blackbox/test_modified.py	2008-06-05 17:38:02 +0000
+++ bzrlib/tests/blackbox/test_modified.py	1970-01-01 00:00:00 +0000
@@ -1,72 +0,0 @@
-# Copyright (C) 2006 Canonical Ltd
-# -*- coding: utf-8 -*-
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-
-"""Black-box tests for 'bzr modified', which shows modified files."""
-
-import os
-
-from bzrlib.branch import Branch
-from bzrlib.tests.blackbox import ExternalBase
-
-class TestModified(ExternalBase):
-
-    def test_modified(self):
-        """Test that 'modified' command reports modified files"""
-        self._test_modified('a', 'a')
-
-    def test_modified_with_spaces(self):
-        """Test that 'modified' command reports modified files with spaces in their names quoted"""
-        self._test_modified('a filename with spaces', '"a filename with spaces"')
-
-    def _test_modified(self, name, output):
-
-        def check_modified(expected, null=False):
-            command = 'modified'
-            if null:
-                command += ' --null'
-            out, err = self.run_bzr(command)
-            self.assertEquals(out, expected)
-            self.assertEquals(err, '')
-
-        # in empty directory, nothing modified
-        tree = self.make_branch_and_tree('.')
-        check_modified('')
-
-        # with unknown file, still nothing modified
-        self.build_tree_contents([(name, 'contents of %s\n' % (name))])
-        check_modified('')
-        
-        # after add, not modified
-        tree.add(name)
-        check_modified('')
-
-        # after commit, not modified
-        tree.commit(message='add %s' % output)
-        check_modified('')
-
-        # modify the file
-        self.build_tree_contents([(name, 'changed\n')]) 
-        check_modified(output + '\n')
-        
-        # check null seps - use the unquoted raw name here
-        check_modified(name + '\0', null=True)
-
-        # now commit the file and it's no longer modified
-        tree.commit(message='modified %s' %(name))
-        check_modified('')
-

=== modified file 'bzrlib/tests/blackbox/test_mv.py'
--- bzrlib/tests/blackbox/test_mv.py	2008-03-05 13:09:32 +0000
+++ bzrlib/tests/blackbox/test_mv.py	2007-08-23 14:10:48 +0000
@@ -24,9 +24,8 @@
     )
 
 from bzrlib.tests import (
-    CaseInsensitiveFilesystemFeature,
-    SymlinkFeature,
     TestCaseWithTransport,
+    TestSkipped,
     )
 
 
@@ -125,54 +124,6 @@
         os.chdir('..')
         self.assertMoved('sub1/sub2/hello.txt','sub1/hello.txt')
 
-    def test_mv_change_case_file(self):
-        # test for bug #77740 (mv unable change filename case on Windows)
-        tree = self.make_branch_and_tree('.')
-        self.build_tree(['test.txt'])
-        tree.add(['test.txt'])
-        self.run_bzr('mv test.txt Test.txt')
-        # we can't use failUnlessExists on case-insensitive filesystem
-        # so try to check shape of the tree
-        shape = sorted(os.listdir(u'.'))
-        self.assertEqual(['.bzr', 'Test.txt'], shape)
-        self.assertInWorkingTree('Test.txt')
-        self.assertNotInWorkingTree('test.txt')
-
-    def test_mv_change_case_dir(self):
-        tree = self.make_branch_and_tree('.')
-        self.build_tree(['foo/'])
-        tree.add(['foo'])
-        self.run_bzr('mv foo Foo')
-        # we can't use failUnlessExists on case-insensitive filesystem
-        # so try to check shape of the tree
-        shape = sorted(os.listdir(u'.'))
-        self.assertEqual(['.bzr', 'Foo'], shape)
-        self.assertInWorkingTree('Foo')
-        self.assertNotInWorkingTree('foo')
-
-    def test_mv_change_case_dir_w_files(self):
-        tree = self.make_branch_and_tree('.')
-        self.build_tree(['foo/', 'foo/bar'])
-        tree.add(['foo'])
-        self.run_bzr('mv foo Foo')
-        # we can't use failUnlessExists on case-insensitive filesystem
-        # so try to check shape of the tree
-        shape = sorted(os.listdir(u'.'))
-        self.assertEqual(['.bzr', 'Foo'], shape)
-        self.assertInWorkingTree('Foo')
-        self.assertNotInWorkingTree('foo')
-
-    def test_mv_file_to_wrong_case_dir(self):
-        self.requireFeature(CaseInsensitiveFilesystemFeature)
-        tree = self.make_branch_and_tree('.')
-        self.build_tree(['foo/', 'bar'])
-        tree.add(['foo', 'bar'])
-        out, err = self.run_bzr('mv bar Foo', retcode=3)
-        self.assertEquals('', out)
-        self.assertEquals(
-            'bzr: ERROR: Could not move to Foo: Foo is not versioned.\n',
-            err)
-
     def test_mv_smoke_aliases(self):
         # just test that aliases for mv exist, if their behaviour is changed in
         # the future, then extend the tests.
@@ -184,7 +135,8 @@
         self.run_bzr('rename b a')
 
     def test_mv_through_symlinks(self):
-        self.requireFeature(SymlinkFeature)
+        if not osutils.has_symlinks():
+            raise TestSkipped('Symlinks are not supported on this platform')
         tree = self.make_branch_and_tree('.')
         self.build_tree(['a/', 'a/b'])
         os.symlink('a', 'c')
@@ -321,8 +273,7 @@
         self.build_tree(['a']) #touch a
         self.run_bzr_error(
             ["^bzr: ERROR: Could not rename a => b because both files exist."
-             " \(Use --after to tell bzr about a rename that has already"
-             " happened\)$"],
+             " \(Use --after to update the Bazaar id\)$"],
             'mv a b')
         self.failUnlessExists('a')
         self.failUnlessExists('b')
@@ -370,9 +321,8 @@
         self.build_tree(['a2']) #touch a2
 
         self.run_bzr_error(
-            ["^bzr: ERROR: Could not rename a1 => sub/a1 because both files"
-             " exist. \(Use --after to tell bzr about a rename that has already"
-             " happened\)$"],
+            ["^bzr: ERROR: Could not rename a1 => sub/a1 because both files exist."
+             " \(Use --after to update the Bazaar id\)$"],
             'mv a1 a2 sub')
         self.failUnlessExists('a1')
         self.failUnlessExists('a2')
@@ -407,26 +357,3 @@
         self.failUnlessExists('sub/a2')
         self.assertInWorkingTree('sub/a1')
         self.assertInWorkingTree('sub/a2')
-
-    def test_mv_already_moved_directory(self):
-        """Use `bzr mv a b` to mark a directory as renamed.
-
-        https://bugs.launchpad.net/bzr/+bug/107967/
-        """
-        self.build_tree(['a/', 'c/'])
-        tree = self.make_branch_and_tree('.')
-        tree.add(['a', 'c'])
-        osutils.rename('a', 'b')
-        osutils.rename('c', 'd')
-        # mv a b should work just like it does for already renamed files
-        self.run_bzr('mv a b')
-        self.failIfExists('a')
-        self.assertNotInWorkingTree('a')
-        self.failUnlessExists('b')
-        self.assertInWorkingTree('b')
-        # and --after should work, too (technically it's ignored)
-        self.run_bzr('mv --after c d')
-        self.failIfExists('c')
-        self.assertNotInWorkingTree('c')
-        self.failUnlessExists('d')
-        self.assertInWorkingTree('d')

=== modified file 'bzrlib/tests/blackbox/test_non_ascii.py'
--- bzrlib/tests/blackbox/test_non_ascii.py	2008-08-02 17:10:50 +0000
+++ bzrlib/tests/blackbox/test_non_ascii.py	2007-10-02 07:14:11 +0000
@@ -47,8 +47,7 @@
         bzrlib.user_encoding = self._orig_encoding
         super(TestNonAscii, self).tearDown()
 
-    def run_bzr_decode(self, args, encoding=None, fail=False, retcode=None,
-                        working_dir=None):
+    def run_bzr_decode(self, args, encoding=None, fail=False, retcode=None):
         """Run bzr and decode the output into a particular encoding.
 
         Returns a string containing the stdout output from bzr.
@@ -60,7 +59,7 @@
             encoding = bzrlib.user_encoding
         try:
             out = self.run_bzr(args, output_encoding=encoding, encoding=encoding,
-                retcode=retcode, working_dir=working_dir)[0]
+                retcode=retcode)[0]
             return out.decode(encoding)
         except UnicodeError, e:
             if not fail:
@@ -95,23 +94,21 @@
                                    % (thing, terminal_enc, fs_enc))
 
         wt = self.make_branch_and_tree('.')
-        self.build_tree_contents([('a', 'foo\n')])
+        open('a', 'wb').write('foo\n')
         wt.add('a')
         wt.commit('adding a')
 
-        self.build_tree_contents(
-            [('b', 'non-ascii \xFF\xFF\xFC\xFB\x00 in b\n')])
+        open('b', 'wb').write('non-ascii \xFF\xFF\xFC\xFB\x00 in b\n')
         wt.add('b')
         wt.commit(self.info['message'])
 
-        self.build_tree_contents([(fname, 'unicode filename\n')])
+        open(fname, 'wb').write('unicode filename\n')
         wt.add(fname)
         wt.commit(u'And a unicode file\n')
         self.wt = wt
 
     def test_status(self):
-        self.build_tree_contents(
-            [(self.info['filename'], 'changed something\n')])
+        open(self.info['filename'], 'ab').write('added something\n')
         txt = self.run_bzr_decode('status')
         self.assertEqual(u'modified:\n  %s\n' % (self.info['filename'],), txt)
 
@@ -130,67 +127,79 @@
         self.assertEqual('unicode filename\n', txt)
 
     def test_cat_revision(self):
+        bzr = self.run_bzr_decode
+
         committer = self.info['committer']
-        txt = self.run_bzr_decode('cat-revision -r 1')
+        txt = bzr('cat-revision -r 1')
         self.failUnless(committer in txt,
                         'failed to find %r in %r' % (committer, txt))
 
         msg = self.info['message']
-        txt = self.run_bzr_decode('cat-revision -r 2')
+        txt = bzr('cat-revision -r 2')
         self.failUnless(msg in txt, 'failed to find %r in %r' % (msg, txt))
 
     def test_mkdir(self):
-        txt = self.run_bzr_decode(['mkdir', self.info['directory']])
+        bzr = self.run_bzr_decode
+
+        txt = bzr(['mkdir', self.info['directory']])
         self.assertEqual(u'added %s\n' % self.info['directory'], txt)
 
         # The text should be garbled, but the command should succeed
-        txt = self.run_bzr_decode(['mkdir', self.info['directory'] + '2'],
-                                  encoding='ascii')
+        txt = bzr(['mkdir', self.info['directory'] + '2'], encoding='ascii')
         expected = u'added %s2\n' % (self.info['directory'],)
         expected = expected.encode('ascii', 'replace')
         self.assertEqual(expected, txt)
 
     def test_relpath(self):
-        txt = self.run_bzr_decode(['relpath', self.info['filename']])
+        bzr = self.run_bzr_decode
+
+        txt = bzr(['relpath', self.info['filename']])
         self.assertEqual(self.info['filename'] + '\n', txt)
 
-        self.run_bzr_decode(['relpath', self.info['filename']],
-                            encoding='ascii', fail=True)
+        bzr(['relpath', self.info['filename']], encoding='ascii', fail=True)
 
     def test_inventory(self):
-        txt = self.run_bzr_decode('inventory')
+        bzr = self.run_bzr_decode
+
+        txt = bzr('inventory')
         self.assertEqual(['a', 'b', self.info['filename']],
                          txt.splitlines())
 
         # inventory should fail if unable to encode
-        self.run_bzr_decode('inventory', encoding='ascii', fail=True)
+        bzr('inventory', encoding='ascii', fail=True)
 
         # We don't really care about the ids themselves,
         # but the command shouldn't fail
-        txt = self.run_bzr_decode('inventory --show-ids')
+        txt = bzr('inventory --show-ids')
 
     def test_revno(self):
         # There isn't a lot to test here, since revno should always
         # be an integer
-        self.assertEqual('3\n', self.run_bzr_decode('revno'))
-        self.assertEqual('3\n', self.run_bzr_decode('revno', encoding='ascii'))
+        bzr = self.run_bzr_decode
+
+        self.assertEqual('3\n', bzr('revno'))
+        self.assertEqual('3\n', bzr('revno', encoding='ascii'))
 
     def test_revision_info(self):
-        self.run_bzr_decode('revision-info -r 1')
+        bzr = self.run_bzr_decode
+
+        bzr('revision-info -r 1')
 
         # TODO: jam 20060105 If we support revisions with non-ascii characters,
         # this should be strict and fail.
-        self.run_bzr_decode('revision-info -r 1', encoding='ascii')
+        bzr('revision-info -r 1', encoding='ascii')
 
     def test_mv(self):
+        bzr = self.run_bzr_decode
+
         fname1 = self.info['filename']
         fname2 = self.info['filename'] + '2'
         dirname = self.info['directory']
 
         # fname1 already exists
-        self.run_bzr_decode(['mv', 'a', fname1], fail=True)
+        bzr(['mv', 'a', fname1], fail=True)
 
-        txt = self.run_bzr_decode(['mv', 'a', fname2])
+        txt = bzr(['mv', 'a', fname2])
         self.assertEqual(u'a => %s\n' % fname2, txt)
         self.failIfExists('a')
         self.failUnlessExists(fname2)
@@ -201,26 +210,28 @@
 
         os.mkdir(dirname)
         self.wt.add(dirname)
-        txt = self.run_bzr_decode(['mv', fname1, fname2, dirname])
+        txt = bzr(['mv', fname1, fname2, dirname])
         self.assertEqual([u'%s => %s/%s' % (fname1, dirname, fname1),
                           u'%s => %s/%s' % (fname2, dirname, fname2)]
                          , txt.splitlines())
 
         # The rename should still succeed
         newpath = u'%s/%s' % (dirname, fname2)
-        txt = self.run_bzr_decode(['mv', newpath, 'a'], encoding='ascii')
+        txt = bzr(['mv', newpath, 'a'], encoding='ascii')
         self.failUnlessExists('a')
         self.assertEqual(newpath.encode('ascii', 'replace') + ' => a\n', txt)
 
     def test_branch(self):
         # We should be able to branch into a directory that
         # has a unicode name, even if we can't display the name
-        self.run_bzr_decode(['branch', u'.', self.info['directory']])
-        self.run_bzr_decode(['branch', u'.', self.info['directory'] + '2'],
-                            encoding='ascii')
+        bzr = self.run_bzr_decode
+        bzr(['branch', u'.', self.info['directory']])
+        bzr(['branch', u'.', self.info['directory'] + '2'], encoding='ascii')
 
     def test_pull(self):
         # Make sure we can pull from paths that can't be encoded
+        bzr = self.run_bzr_decode
+
         dirname1 = self.info['directory']
         dirname2 = self.info['directory'] + '2'
         url1 = urlutils.local_path_to_url(dirname1)
@@ -228,282 +239,310 @@
         out_bzrdir = self.wt.bzrdir.sprout(url1)
         out_bzrdir.sprout(url2)
 
-        self.build_tree_contents(
-            [(osutils.pathjoin(dirname1, "a"), 'different text\n')])
+        os.chdir(dirname1)
+        open('a', 'ab').write('more text\n')
         self.wt.commit('mod a')
 
-        txt = self.run_bzr_decode('pull', working_dir=dirname2)
-
-        expected = osutils.pathjoin(osutils.getcwd(), dirname1)
-        self.assertEqual(u'Using saved parent location: %s/\n'
-                'No revisions to pull.\n' % (expected,), txt)
-
-        self.build_tree_contents(
-            [(osutils.pathjoin(dirname1, 'a'), 'and yet more\n')])
+        pwd = osutils.getcwd()
+
+        os.chdir(u'../' + dirname2)
+        txt = bzr('pull')
+
+        self.assertEqual(u'Using saved location: %s/\n'
+                'No revisions to pull.\n' % (pwd,), txt)
+
+        os.chdir('../' + dirname1)
+        open('a', 'ab').write('and yet more\n')
         self.wt.commit(u'modifying a by ' + self.info['committer'])
 
+        os.chdir('../' + dirname2)
         # We should be able to pull, even if our encoding is bad
-        self.run_bzr_decode('pull --verbose', encoding='ascii',
-                            working_dir=dirname2)
+        bzr('pull --verbose', encoding='ascii')
 
     def test_push(self):
         # TODO: Test push to an SFTP location
         # Make sure we can pull from paths that can't be encoded
+        bzr = self.run_bzr_decode
+
         # TODO: jam 20060427 For drastically improving performance, we probably
         #       could create a local repository, so it wouldn't have to copy
         #       the files around as much.
 
         dirname = self.info['directory']
-        self.run_bzr_decode(['push', dirname])
+        bzr(['push', dirname])
 
-        self.build_tree_contents([('a', 'adding more text\n')])
+        open('a', 'ab').write('adding more text\n')
         self.wt.commit('added some stuff')
 
         # TODO: check the output text is properly encoded
-        self.run_bzr_decode('push')
+        bzr('push')
 
-        self.build_tree_contents(
-            [('a', 'and a bit more: \n%s\n' % (dirname.encode('utf-8'),))])
+        f = open('a', 'ab')
+        try:
+            f.write('and a bit more: ')
+            f.write(dirname.encode('utf-8'))
+            f.write('\n')
+        finally:
+            f.close()
 
         self.wt.commit('Added some ' + dirname)
-        self.run_bzr_decode('push --verbose', encoding='ascii')
-
-        self.run_bzr_decode(['push', '--verbose', dirname + '2'])
-
-        self.run_bzr_decode(['push', '--verbose', dirname + '3'],
-                            encoding='ascii')
-
-        self.run_bzr_decode(['push', '--verbose', '--create-prefix',
-                            dirname + '4/' + dirname + '5'])
-        self.run_bzr_decode(['push', '--verbose', '--create-prefix',
-                            dirname + '6/' + dirname + '7'], encoding='ascii')
+        bzr('push --verbose', encoding='ascii')
+
+        bzr(['push', '--verbose', dirname + '2'])
+
+        bzr(['push', '--verbose', dirname + '3'], encoding='ascii')
+
+        bzr(['push', '--verbose', '--create-prefix',
+             dirname + '4/' + dirname + '5'])
+        bzr(['push', '--verbose', '--create-prefix',
+             dirname + '6/' + dirname + '7'], encoding='ascii')
 
     def test_renames(self):
+        bzr = self.run_bzr_decode
+
         fname = self.info['filename'] + '2'
-        self.wt.rename_one('a', fname)
-        txt = self.run_bzr_decode('renames')
+        bzr(['mv', 'a', fname])
+        txt = bzr('renames')
         self.assertEqual(u'a => %s\n' % fname, txt)
 
-        self.run_bzr_decode('renames', fail=True, encoding='ascii')
+        bzr('renames', fail=True, encoding='ascii')
 
     def test_remove(self):
+        bzr = self.run_bzr_decode
+
         fname = self.info['filename']
-        txt = self.run_bzr_decode(['remove', fname], encoding='ascii')
+        txt = bzr(['remove', fname], encoding='ascii')
 
     def test_remove_verbose(self):
+        bzr = self.run_bzr_decode
+
         fname = self.info['filename']
-        txt = self.run_bzr_decode(['remove', '--verbose', fname],
-                                  encoding='ascii')
+        txt = bzr(['remove', '--verbose', fname], encoding='ascii')
 
     def test_file_id(self):
+        bzr = self.run_bzr_decode
+
         fname = self.info['filename']
-        txt = self.run_bzr_decode(['file-id', fname])
+        txt = bzr(['file-id', fname])
 
         # TODO: jam 20060106 We don't support non-ascii file ids yet, 
         #       so there is nothing which would fail in ascii encoding
         #       This *should* be retcode=3
-        txt = self.run_bzr_decode(['file-id', fname], encoding='ascii')
+        txt = bzr(['file-id', fname], encoding='ascii')
 
     def test_file_path(self):
+        bzr = self.run_bzr_decode
+
         # Create a directory structure
         fname = self.info['filename']
         dirname = self.info['directory']
-        self.build_tree_contents([
-            ('base/', ),
-            (osutils.pathjoin('base', '%s/' % (dirname,)), )])
+        os.mkdir('base')
+        os.mkdir('base/' + dirname)
         self.wt.add('base')
         self.wt.add('base/'+dirname)
-        path = osutils.pathjoin('base', dirname, fname)
+        path = '/'.join(['base', dirname, fname])
         self.wt.rename_one(fname, path)
         self.wt.commit('moving things around')
 
-        txt = self.run_bzr_decode(['file-path', path])
+        txt = bzr(['file-path', path])
 
         # TODO: jam 20060106 We don't support non-ascii file ids yet, 
         #       so there is nothing which would fail in ascii encoding
         #       This *should* be retcode=3
-        txt = self.run_bzr_decode(['file-path', path], encoding='ascii')
+        txt = bzr(['file-path', path], encoding='ascii')
 
     def test_revision_history(self):
+        bzr = self.run_bzr_decode
+
         # TODO: jam 20060106 We don't support non-ascii revision ids yet, 
         #       so there is nothing which would fail in ascii encoding
-        txt = self.run_bzr_decode('revision-history')
+        txt = bzr('revision-history')
 
     def test_ancestry(self):
+        bzr = self.run_bzr_decode
+
         # TODO: jam 20060106 We don't support non-ascii revision ids yet, 
         #       so there is nothing which would fail in ascii encoding
-        txt = self.run_bzr_decode('ancestry')
+        txt = bzr('ancestry')
 
     def test_diff(self):
         # TODO: jam 20060106 diff is a difficult one to test, because it 
         #       shouldn't encode the file contents, but it needs some sort
         #       of encoding for the paths, etc which are displayed.
-        self.build_tree_contents([(self.info['filename'], 'newline\n')])
+        open(self.info['filename'], 'ab').write('newline\n')
         txt = self.run_bzr('diff', retcode=1)[0]
 
     def test_deleted(self):
+        bzr = self.run_bzr_decode
+
         fname = self.info['filename']
         os.remove(fname)
         self.wt.remove(fname)
 
-        txt = self.run_bzr_decode('deleted')
+        txt = bzr('deleted')
         self.assertEqual(fname+'\n', txt)
 
-        txt = self.run_bzr_decode('deleted --show-ids')
+        txt = bzr('deleted --show-ids')
         self.failUnless(txt.startswith(fname))
 
         # Deleted should fail if cannot decode
         # Because it is giving the exact paths
         # which might be used by a front end
-        self.run_bzr_decode('deleted', encoding='ascii', fail=True)
+        bzr('deleted', encoding='ascii', fail=True)
 
     def test_modified(self):
+        bzr = self.run_bzr_decode
+
         fname = self.info['filename']
-        self.build_tree_contents([(fname, 'modified\n')])
-
-        txt = self.run_bzr_decode('modified')
-        self.assertEqual('"'+fname+'"'+'\n', txt)
-
-        self.run_bzr_decode('modified', encoding='ascii', fail=True)
+        open(fname, 'ab').write('modified\n')
+
+        txt = bzr('modified')
+        self.assertEqual(fname+'\n', txt)
+
+        bzr('modified', encoding='ascii', fail=True)
 
     def test_added(self):
+        bzr = self.run_bzr_decode
+
         fname = self.info['filename'] + '2'
-        self.build_tree_contents([(fname, 'added\n')])
+        open(fname, 'wb').write('added\n')
         self.wt.add(fname)
 
-        txt = self.run_bzr_decode('added')
-        self.assertEqual('"'+fname+'"'+'\n', txt)
+        txt = bzr('added')
+        self.assertEqual(fname+'\n', txt)
 
-        self.run_bzr_decode('added', encoding='ascii', fail=True)
+        bzr('added', encoding='ascii', fail=True)
 
     def test_root(self):
+        bzr = self.run_bzr_decode
+
         dirname = self.info['directory']
         url = urlutils.local_path_to_url(dirname)
-        self.run_bzr_decode('root')
+        bzr('root')
 
         self.wt.bzrdir.sprout(url)
 
-        txt = self.run_bzr_decode('root', working_dir=dirname)
+        os.chdir(dirname)
+
+        txt = bzr('root')
         self.failUnless(txt.endswith(dirname+'\n'))
 
-        txt = self.run_bzr_decode('root', encoding='ascii', fail=True,
-                                  working_dir=dirname)
+        txt = bzr('root', encoding='ascii', fail=True)
 
     def test_log(self):
+        bzr = self.run_bzr_decode
+
         fname = self.info['filename']
 
-        txt = self.run_bzr_decode('log')
+        txt = bzr('log')
         self.assertNotEqual(-1, txt.find(self.info['committer']))
         self.assertNotEqual(-1, txt.find(self.info['message']))
 
-        txt = self.run_bzr_decode('log --verbose')
+        txt = bzr('log --verbose')
         self.assertNotEqual(-1, txt.find(fname))
 
         # Make sure log doesn't fail even if we can't write out
-        txt = self.run_bzr_decode('log --verbose', encoding='ascii')
+        txt = bzr('log --verbose', encoding='ascii')
         self.assertEqual(-1, txt.find(fname))
         self.assertNotEqual(-1, txt.find(fname.encode('ascii', 'replace')))
 
     def test_touching_revisions(self):
+        bzr = self.run_bzr_decode
+
         fname = self.info['filename']
-        txt = self.run_bzr_decode(['touching-revisions', fname])
+        txt = bzr(['touching-revisions', fname])
         self.assertEqual(u'     3 added %s\n' % (fname,), txt)
 
         fname2 = self.info['filename'] + '2'
         self.wt.rename_one(fname, fname2)
         self.wt.commit(u'Renamed %s => %s' % (fname, fname2))
 
-        txt = self.run_bzr_decode(['touching-revisions', fname2])
+        txt = bzr(['touching-revisions', fname2])
         expected_txt = (u'     3 added %s\n' 
                         u'     4 renamed %s => %s\n'
                         % (fname, fname, fname2))
         self.assertEqual(expected_txt, txt)
 
-        self.run_bzr_decode(['touching-revisions', fname2], encoding='ascii',
-                            fail=True)
+        bzr(['touching-revisions', fname2], encoding='ascii', fail=True)
 
     def test_ls(self):
-        txt = self.run_bzr_decode('ls')
+        bzr = self.run_bzr_decode
+
+        txt = bzr('ls')
         self.assertEqual(sorted(['a', 'b', self.info['filename']]),
                          sorted(txt.splitlines()))
-        txt = self.run_bzr_decode('ls --null')
+        txt = bzr('ls --null')
         self.assertEqual(sorted(['', 'a', 'b', self.info['filename']]),
                          sorted(txt.split('\0')))
 
-        txt = self.run_bzr_decode('ls', encoding='ascii', fail=True)
-        txt = self.run_bzr_decode('ls --null', encoding='ascii', fail=True)
+        txt = bzr('ls', encoding='ascii', fail=True)
+        txt = bzr('ls --null', encoding='ascii', fail=True)
 
     def test_unknowns(self):
+        bzr = self.run_bzr_decode
+
         fname = self.info['filename'] + '2'
-        self.build_tree_contents([(fname, 'unknown\n')])
+        open(fname, 'wb').write('unknown\n')
 
         # TODO: jam 20060112 bzr unknowns is the only one which 
         #       quotes paths do we really want it to?
-        #       awilkins 20080521 added and modified do it now as well
-        txt = self.run_bzr_decode('unknowns')
+        txt = bzr('unknowns')
         self.assertEqual(u'"%s"\n' % (fname,), txt)
 
-        self.run_bzr_decode('unknowns', encoding='ascii', fail=True)
+        bzr('unknowns', encoding='ascii', fail=True)
 
     def test_ignore(self):
+        bzr = self.run_bzr_decode
+
         fname2 = self.info['filename'] + '2.txt'
-        self.build_tree_contents([(fname2, 'ignored\n')])
+        open(fname2, 'wb').write('ignored\n')
 
         def check_unknowns(expected):
             self.assertEqual(expected, list(self.wt.unknowns()))
 
         check_unknowns([fname2])
 
-        self.run_bzr_decode(['ignore', './' + fname2])
+        bzr(['ignore', './' + fname2])
+        # After 'ignore' you must re-open the working tree
+        self.wt = self.wt.bzrdir.open_workingtree()
         check_unknowns([])
 
         fname3 = self.info['filename'] + '3.txt'
-        self.build_tree_contents([(fname3, 'unknown 3\n')])
+        open(fname3, 'wb').write('unknown 3\n')
         check_unknowns([fname3])
 
         # Ignore should not care what the encoding is
         # (right now it doesn't print anything)
-        self.run_bzr_decode(['ignore', fname3], encoding='ascii')
+        bzr(['ignore', fname3], encoding='ascii')
+        self.wt = self.wt.bzrdir.open_workingtree()
         check_unknowns([])
 
         # Now try a wildcard match
         fname4 = self.info['filename'] + '4.txt'
-        self.build_tree_contents([(fname4, 'unknown 4\n')])
-        self.run_bzr_decode('ignore *.txt')
+        open(fname4, 'wb').write('unknown 4\n')
+        bzr('ignore *.txt')
+        self.wt = self.wt.bzrdir.open_workingtree()
         check_unknowns([])
 
         # and a different wildcard that matches everything
         os.remove('.bzrignore')
-        self.run_bzr_decode(['ignore', self.info['filename'] + '*'])
+        bzr(['ignore', self.info['filename'] + '*'])
+        self.wt = self.wt.bzrdir.open_workingtree()
         check_unknowns([])
 
     def test_missing(self):
+        bzr = self.run_bzr_decode
+
         # create empty tree as reference for missing
-        self.make_branch_and_tree('empty-tree')
+        self.run_bzr('init empty-tree')
 
         msg = self.info['message']
 
-        txt = self.run_bzr_decode('missing empty-tree')
+        txt = bzr('missing empty-tree', retcode=1)
         self.assertNotEqual(-1, txt.find(self.info['committer']))
         self.assertNotEqual(-1, txt.find(msg))
 
         # Make sure missing doesn't fail even if we can't write out
-        txt = self.run_bzr_decode('missing empty-tree', encoding='ascii')
+        txt = bzr('missing empty-tree', encoding='ascii', retcode=1)
         self.assertEqual(-1, txt.find(msg))
         self.assertNotEqual(-1, txt.find(msg.encode('ascii', 'replace')))
-
-    def test_info(self):
-        self.run_bzr_decode(['branch', u'.', self.info['directory']])
-        self.run_bzr_decode(['info', self.info['directory']])
-        self.run_bzr_decode(['info', self.info['directory']],
-                            encoding='ascii')
-
-    def test_ignored(self):
-        fname = self.info['filename'] + '1.txt'
-        self.build_tree_contents([(fname, 'ignored\n')])
-        self.run_bzr(['ignore', fname])
-        txt = self.run_bzr_decode(['ignored'])
-        self.assertEqual(txt, '%-50s %s\n' % (fname, fname))
-        txt = self.run_bzr_decode(['ignored'], encoding='ascii')
-        fname = fname.encode('ascii', 'replace')
-        self.assertEqual(txt, '%-50s %s\n' % (fname, fname))

=== modified file 'bzrlib/tests/blackbox/test_outside_wt.py'
--- bzrlib/tests/blackbox/test_outside_wt.py	2008-08-26 08:25:27 +0000
+++ bzrlib/tests/blackbox/test_outside_wt.py	2007-08-23 14:10:48 +0000
@@ -19,24 +19,20 @@
 """Black-box tests for running bzr outside of a working tree."""
 
 import os
-
-from bzrlib import (
-    osutils,
-    tests,
-    urlutils,
-    )
-
-
-class TestOutsideWT(tests.ChrootedTestCase):
+import tempfile
+
+from bzrlib.tests import ChrootedTestCase
+from bzrlib.osutils import getcwd
+import bzrlib.urlutils as urlutils
+
+
+class TestOutsideWT(ChrootedTestCase):
     """Test that bzr gives proper errors outside of a working tree."""
 
     def test_cwd_log(self):
-        tmp_dir = osutils.mkdtemp()
-        self.addCleanup(lambda: osutils.rmtree(tmp_dir))
-        os.chdir(tmp_dir)
+        os.chdir(tempfile.mkdtemp())
         out, err = self.run_bzr('log', retcode=3)
-        self.assertEqual(u'bzr: ERROR: Not a branch: "%s/".\n'
-                         % (osutils.getcwd(),),
+        self.assertEqual(u'bzr: ERROR: Not a branch: "%s/".\n' % (getcwd(),),
                          err)
 
     def test_url_log(self):
@@ -45,34 +41,32 @@
         self.assertEqual(u'bzr: ERROR: Not a branch:'
                          u' "%s".\n' % url, err)
 
-    def test_diff_outside_tree(self):
-        tmp_dir = osutils.mkdtemp()
-        self.addCleanup(lambda: osutils.rmtree(tmp_dir))
-        os.chdir(tmp_dir)
+    def test_diff_ouside_tree(self):
+        os.chdir(tempfile.mkdtemp())
         self.run_bzr('init branch1')
         self.run_bzr(['commit', '-m', 'nothing',
                                '--unchanged', 'branch1'])
         self.run_bzr(['commit', '-m', 'nothing',
                                '--unchanged', 'branch1'])
-        this_dir = osutils.getcwd()
-        branch2 = "%s/branch2" % (this_dir,)
         # -r X..Y
         out, err = self.run_bzr('diff -r revno:2:branch2..revno:1', retcode=3)
         self.assertEquals('', out)
-        self.assertEqual(u'bzr: ERROR: Not a branch: "%s/".\n' % (branch2,),
+        self.assertEqual(u'bzr: ERROR: Not a branch: "%s/".\n' % (getcwd(),),
                          err)
         # -r X
         out, err = self.run_bzr('diff -r revno:2:branch2', retcode=3)
         self.assertEquals('', out)
-        self.assertEqual(u'bzr: ERROR: Not a branch: "%s/".\n' % (branch2,),
+        self.assertEqual(u'bzr: ERROR: Not a branch: "%s/".\n' % (getcwd(),),
                          err)
         # -r X..
         out, err = self.run_bzr('diff -r revno:2:branch2..', retcode=3)
         self.assertEquals('', out)
-        self.assertEqual(u'bzr: ERROR: Not a branch: "%s/".\n' % (branch2,),
+        self.assertEqual(u'bzr: ERROR: Not a branch: "%s/".\n' % (getcwd(),),
                          err)
         # no -r at all.
         out, err = self.run_bzr('diff', retcode=3)
         self.assertEquals('', out)
-        self.assertEqual(u'bzr: ERROR: Not a branch: "%s/".\n' % (this_dir,),
+        self.assertEqual(u'bzr: ERROR: Not a branch: "%s/".\n' % (getcwd(),),
                          err)
+
+

=== modified file 'bzrlib/tests/blackbox/test_pull.py'
--- bzrlib/tests/blackbox/test_pull.py	2008-03-25 05:40:55 +0000
+++ bzrlib/tests/blackbox/test_pull.py	2007-08-21 13:52:55 +0000
@@ -21,7 +21,6 @@
 import sys
 
 from bzrlib.branch import Branch
-from bzrlib.directory_service import directories
 from bzrlib.osutils import pathjoin
 from bzrlib.tests.blackbox import ExternalBase
 from bzrlib.uncommit import uncommit
@@ -306,37 +305,3 @@
         self.assertContainsRe(out, 'bar')
         self.assertNotContainsRe(out, 'added:')
         self.assertNotContainsRe(out, 'foo')
-
-    def test_pull_quiet(self):
-        """Check that bzr pull --quiet does not print anything"""
-        tree_a = self.make_branch_and_tree('tree_a')
-        self.build_tree(['tree_a/foo'])
-        tree_a.add('foo')
-        revision_id = tree_a.commit('bar')
-        tree_b = tree_a.bzrdir.sprout('tree_b').open_workingtree()
-        out, err = self.run_bzr('pull --quiet -d tree_b')
-        self.assertEqual(out, '')
-        self.assertEqual(err, '')
-        self.assertEqual(tree_b.last_revision(), revision_id)
-        self.build_tree(['tree_a/moo'])
-        tree_a.add('moo')
-        revision_id = tree_a.commit('quack')
-        out, err = self.run_bzr('pull --quiet -d tree_b')
-        self.assertEqual(out, '')
-        self.assertEqual(err, '')
-        self.assertEqual(tree_b.last_revision(), revision_id)
-
-    def test_pull_from_directory_service(self):
-        source = self.make_branch_and_tree('source')
-        source.commit('commit 1')
-        target = source.bzrdir.sprout('target').open_workingtree()
-        source_last = source.commit('commit 2')
-        class FooService(object):
-            """A directory service that always returns source"""
-
-            def look_up(self, name, url):
-                return 'source'
-        directories.register('foo:', FooService, 'Testing directory service')
-        self.addCleanup(lambda: directories.remove('foo:'))
-        self.run_bzr('pull foo:bar -d target')
-        self.assertEqual(source_last, target.last_revision())

=== modified file 'bzrlib/tests/blackbox/test_push.py'
--- bzrlib/tests/blackbox/test_push.py	2008-08-23 17:57:41 +0000
+++ bzrlib/tests/blackbox/test_push.py	2007-06-27 19:13:50 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2007, 2008 Canonical Ltd
+# Copyright (C) 2005, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -18,7 +18,6 @@
 """Black-box tests for bzr push."""
 
 import os
-import re
 
 from bzrlib import (
     errors,
@@ -29,9 +28,6 @@
 from bzrlib.osutils import abspath
 from bzrlib.repofmt.knitrepo import RepositoryFormatKnit1
 from bzrlib.tests.blackbox import ExternalBase
-from bzrlib.tests.http_server import HttpServer
-from bzrlib.transport import register_transport, unregister_transport
-from bzrlib.transport.memory import MemoryServer, MemoryTransport
 from bzrlib.uncommit import uncommit
 from bzrlib.urlutils import local_path_from_url
 from bzrlib.workingtree import WorkingTree
@@ -87,7 +83,7 @@
         out, err = self.run_bzr('push')
         path = branch_a.get_push_location()
         self.assertEquals(out,
-                          'Using saved push location: %s\n' 
+                          'Using saved location: %s\n' 
                           'Pushed up to revision 2.\n'
                           % local_path_from_url(path))
         self.assertEqual(err,
@@ -248,183 +244,3 @@
         self.run_bzr_error(['At ../dir you have a valid .bzr control'],
                 'push ../dir',
                 working_dir='tree')
-
-    def test_push_with_revisionspec(self):
-        """We should be able to push a revision older than the tip."""
-        tree_from = self.make_branch_and_tree('from')
-        tree_from.commit("One.", rev_id="from-1")
-        tree_from.commit("Two.", rev_id="from-2")
-
-        self.run_bzr('push -r1 ../to', working_dir='from')
-
-        tree_to = WorkingTree.open('to')
-        repo_to = tree_to.branch.repository
-        self.assertTrue(repo_to.has_revision('from-1'))
-        self.assertFalse(repo_to.has_revision('from-2'))
-        self.assertEqual(tree_to.branch.last_revision_info()[1], 'from-1')
-
-        self.run_bzr_error(
-            "bzr: ERROR: bzr push --revision takes one value.\n",
-            'push -r0..2 ../to', working_dir='from')
-
-    def create_trunk_and_feature_branch(self):
-        # We have a mainline
-        trunk_tree = self.make_branch_and_tree('target',
-            format='development')
-        trunk_tree.commit('mainline')
-        # and a branch from it
-        branch_tree = self.make_branch_and_tree('branch',
-            format='development')
-        branch_tree.pull(trunk_tree.branch)
-        branch_tree.branch.set_parent(trunk_tree.branch.base)
-        # with some work on it
-        branch_tree.commit('moar work plz')
-        return trunk_tree, branch_tree
-
-    def assertPublished(self, branch_revid, stacked_on):
-        """Assert that the branch 'published' has been published correctly."""
-        published_branch = Branch.open('published')
-        # The published branch refers to the mainline
-        self.assertEqual(stacked_on, published_branch.get_stacked_on_url())
-        # and the branch's work was pushed
-        self.assertTrue(published_branch.repository.has_revision(branch_revid))
-
-    def test_push_new_branch_stacked_on(self):
-        """Pushing a new branch with --stacked-on creates a stacked branch."""
-        trunk_tree, branch_tree = self.create_trunk_and_feature_branch()
-        # we publish branch_tree with a reference to the mainline.
-        out, err = self.run_bzr(['push', '--stacked-on', trunk_tree.branch.base,
-            self.get_url('published')], working_dir='branch')
-        self.assertEqual('', out)
-        self.assertEqual('Created new stacked branch referring to %s.\n' %
-            trunk_tree.branch.base, err)
-        self.assertPublished(branch_tree.last_revision(),
-            trunk_tree.branch.base)
-
-    def test_push_new_branch_stacked_uses_parent_when_no_public_url(self):
-        """When the parent has no public url the parent is used as-is."""
-        trunk_tree, branch_tree = self.create_trunk_and_feature_branch()
-        # now we do a stacked push, which should determine the public location
-        # for us.
-        out, err = self.run_bzr(['push', '--stacked',
-            self.get_url('published')], working_dir='branch')
-        self.assertEqual('', out)
-        self.assertEqual('Created new stacked branch referring to %s.\n' %
-            trunk_tree.branch.base, err)
-        self.assertPublished(branch_tree.last_revision(), trunk_tree.branch.base)
-
-    def test_push_new_branch_stacked_uses_parent_public(self):
-        """Pushing a new branch with --stacked creates a stacked branch."""
-        trunk_tree, branch_tree = self.create_trunk_and_feature_branch()
-        # the trunk is published on a web server
-        self.transport_readonly_server = HttpServer
-        trunk_public = self.make_branch('public_trunk', format='development')
-        trunk_public.pull(trunk_tree.branch)
-        trunk_public_url = self.get_readonly_url('public_trunk')
-        trunk_tree.branch.set_public_branch(trunk_public_url)
-        # now we do a stacked push, which should determine the public location
-        # for us.
-        out, err = self.run_bzr(['push', '--stacked',
-            self.get_url('published')], working_dir='branch')
-        self.assertEqual('', out)
-        self.assertEqual('Created new stacked branch referring to %s.\n' %
-            trunk_public_url, err)
-        self.assertPublished(branch_tree.last_revision(), trunk_public_url)
-
-    def test_push_new_branch_stacked_no_parent(self):
-        """Pushing with --stacked and no parent branch errors."""
-        branch = self.make_branch_and_tree('branch', format='development')
-        # now we do a stacked push, which should fail as the place to refer too
-        # cannot be determined.
-        out, err = self.run_bzr_error(
-            ['Could not determine branch to refer to\\.'], ['push', '--stacked',
-            self.get_url('published')], working_dir='branch')
-        self.assertEqual('', out)
-        self.assertFalse(self.get_transport('published').has('.'))
-
-    def test_push_notifies_default_stacking(self):
-        self.make_branch('stack_on', format='development1')
-        self.make_bzrdir('.').get_config().set_default_stack_on('stack_on')
-        self.make_branch('from', format='development1')
-        out, err = self.run_bzr('push -d from to')
-        self.assertContainsRe(err,
-                              'Using default stacking branch stack_on at .*')
-
-
-class RedirectingMemoryTransport(MemoryTransport):
-
-    def mkdir(self, path, mode=None):
-        path = self.abspath(path)[len(self._scheme):]
-        if path == '/source':
-            raise errors.RedirectRequested(
-                path, self._scheme + '/target', is_permanent=True)
-        elif path == '/infinite-loop':
-            raise errors.RedirectRequested(
-                path, self._scheme + '/infinite-loop', is_permanent=True)
-        else:
-            return super(RedirectingMemoryTransport, self).mkdir(
-                path, mode)
-
-
-class RedirectingMemoryServer(MemoryServer):
-
-    def setUp(self):
-        self._dirs = {'/': None}
-        self._files = {}
-        self._locks = {}
-        self._scheme = 'redirecting-memory+%s:///' % id(self)
-        register_transport(self._scheme, self._memory_factory)
-
-    def _memory_factory(self, url):
-        result = RedirectingMemoryTransport(url)
-        result._dirs = self._dirs
-        result._files = self._files
-        result._locks = self._locks
-        return result
-
-    def tearDown(self):
-        unregister_transport(self._scheme, self._memory_factory)
-
-
-class TestPushRedirect(ExternalBase):
-
-    def setUp(self):
-        ExternalBase.setUp(self)
-        self.memory_server = RedirectingMemoryServer()
-        self.memory_server.setUp()
-        self.addCleanup(self.memory_server.tearDown)
-
-        # Make the branch and tree that we'll be pushing.
-        t = self.make_branch_and_tree('tree')
-        self.build_tree(['tree/file'])
-        t.add('file')
-        t.commit('commit 1')
-
-    def test_push_redirects_on_mkdir(self):
-        """If the push requires a mkdir, push respects redirect requests.
-
-        This is added primarily to handle lp:/ URI support, so that users can
-        push to new branches by specifying lp:/ URIs.
-        """
-        os.chdir('tree')
-        destination_url = self.memory_server.get_url() + 'source'
-        self.run_bzr('push %s' % destination_url)
-        os.chdir('..')
-
-        local_revision = Branch.open('tree').last_revision()
-        remote_revision = Branch.open(
-            self.memory_server.get_url() + 'target').last_revision()
-        self.assertEqual(remote_revision, local_revision)
-
-    def test_push_gracefully_handles_too_many_redirects(self):
-        """Push fails gracefully if the mkdir generates a large number of
-        redirects.
-        """
-        os.chdir('tree')
-        destination_url = self.memory_server.get_url() + 'infinite-loop'
-        out, err = self.run_bzr_error(
-            ['Too many redirections trying to make %s\\.\n'
-             % re.escape(destination_url)],
-            'push %s' % destination_url, retcode=3)
-        os.chdir('..')
-        self.assertEqual('', out)

=== modified file 'bzrlib/tests/blackbox/test_reconcile.py'
--- bzrlib/tests/blackbox/test_reconcile.py	2008-04-30 15:02:49 +0000
+++ bzrlib/tests/blackbox/test_reconcile.py	2007-09-25 03:57:21 +0000
@@ -42,18 +42,10 @@
     def test_trivial_reconcile(self):
         t = bzrdir.BzrDir.create_standalone_workingtree('.')
         (out, err) = self.run_bzr('reconcile')
-        if t.branch.repository._reconcile_backsup_inventory:
-            does_backup_text = "Inventory ok.\n"
-        else:
-            does_backup_text = ""
-        self.assertEqualDiff(out, "Reconciling branch %s\n"
-                                  "revision_history ok.\n"
-                                  "Reconciling repository %s\n"
-                                  "%s"
+        self.assertEqualDiff(out, "Reconciling repository %s\n"
+                                  "Inventory ok.\n"
                                   "Reconciliation complete.\n" %
-                                  (t.branch.base,
-                                   t.bzrdir.root_transport.base,
-                                   does_backup_text))
+                                  t.bzrdir.root_transport.base)
         self.assertEqualDiff(err, "")
 
     def test_does_something_reconcile(self):
@@ -68,19 +60,9 @@
         repo.commit_write_group()
         repo.unlock()
         (out, err) = self.run_bzr('reconcile')
-        if repo._reconcile_backsup_inventory:
-            does_backup_text = (
-                "Backup Inventory created.\n"
-                "Inventory regenerated.\n")
-        else:
-            does_backup_text = ""
-        expected = ("Reconciling branch %s\n"
-                    "revision_history ok.\n"
-                    "Reconciling repository %s\n"
-                    "%s"
-                    "Reconciliation complete.\n" %
-                    (t.branch.base,
-                     t.bzrdir.root_transport.base,
-                     does_backup_text))
-        self.assertEqualDiff(expected, out)
+        self.assertEqualDiff(out, "Reconciling repository %s\n"
+                                  "Backup Inventory created.\n"
+                                  "Inventory regenerated.\n"
+                                  "Reconciliation complete.\n" %
+                                  t.bzrdir.root_transport.base)
         self.assertEqualDiff(err, "")

=== modified file 'bzrlib/tests/blackbox/test_reconfigure.py'
--- bzrlib/tests/blackbox/test_reconfigure.py	2008-04-12 05:48:07 +0000
+++ bzrlib/tests/blackbox/test_reconfigure.py	2007-09-22 06:08:35 +0000
@@ -15,7 +15,6 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 from bzrlib import (
-    bzrdir,
     errors,
     tests,
     workingtree,
@@ -62,27 +61,3 @@
         branch = self.make_branch('branch')
         self.run_bzr_error(['No target configuration specified'],
                            'reconfigure', working_dir='branch')
-
-    def test_checkout_to_lightweight_checkout(self):
-        branch = self.make_branch('branch')
-        checkout = branch.create_checkout('checkout')
-        self.run_bzr('reconfigure --lightweight-checkout checkout')
-
-    def test_standalone_to_use_shared(self):
-        self.build_tree(['repo/'])
-        tree = self.make_branch_and_tree('repo/tree')
-        repo = self.make_repository('repo', shared=True)
-        self.run_bzr('reconfigure --use-shared', working_dir='repo/tree')
-        tree = workingtree.WorkingTree.open('repo/tree')
-        self.assertNotEqual(tree.bzrdir.root_transport.base,
-            tree.branch.repository.bzrdir.root_transport.base)
-
-    def test_use_shared_to_standalone(self):
-        repo = self.make_repository('repo', shared=True)
-        branch = bzrdir.BzrDir.create_branch_convenience('repo/tree')
-        self.assertNotEqual(branch.bzrdir.root_transport.base,
-            branch.repository.bzrdir.root_transport.base)
-        self.run_bzr('reconfigure --standalone', working_dir='repo/tree')
-        tree = workingtree.WorkingTree.open('repo/tree')
-        self.assertEqual(tree.bzrdir.root_transport.base,
-            tree.branch.repository.bzrdir.root_transport.base)

=== modified file 'bzrlib/tests/blackbox/test_remove.py'
--- bzrlib/tests/blackbox/test_remove.py	2008-08-15 02:45:42 +0000
+++ bzrlib/tests/blackbox/test_remove.py	2007-09-06 11:59:59 +0000
@@ -18,7 +18,7 @@
 import os
 import sys
 
-from bzrlib.tests import SymlinkFeature, TestSkipped
+from bzrlib.tests import TestSkipped
 from bzrlib.tests.blackbox import ExternalBase
 from bzrlib.workingtree import WorkingTree
 from bzrlib import osutils
@@ -33,16 +33,15 @@
 
 class TestRemove(ExternalBase):
 
-    def _make_tree_and_add(self, paths):
+    def _make_add_and_assert_tree(self, files):
         tree = self.make_branch_and_tree('.')
-        tree.lock_write()
-        try:
-            self.build_tree(paths)
-            for path in paths:
-                file_id=str(path).replace('/', '_') + _id
-                tree.add(path, file_id)
-        finally:
-            tree.unlock()
+        self.build_tree(files)
+        for f in files:
+            id=str(f).replace('/', '_') + _id
+            tree.add(f, id)
+            self.assertEqual(tree.path2id(f), id)
+            self.failUnlessExists(f)
+            self.assertInWorkingTree(f)
         return tree
 
     def assertFilesDeleted(self, files):
@@ -71,95 +70,35 @@
         #see if we can force it now
         self.run_bzr(['remove', '--force'] + list(files_to_remove))
 
-    def test_remove_new_no_files_specified(self):
-        tree = self.make_branch_and_tree('.')
+    def test_remove_no_files_specified(self):
+        tree = self._make_add_and_assert_tree([])
+        self.run_bzr_error(["bzr: ERROR: Specify one or more files to remove, "
+            "or use --new."], 'remove')
+
         self.run_bzr_error(["bzr: ERROR: No matching files."], 'remove --new')
-        self.run_bzr_error(["bzr: ERROR: No matching files."], 'remove --new .')
-
-    def test_remove_no_files_specified(self):
-        tree = self._make_tree_and_add(['foo'])
-        out, err = self.run_bzr(['rm'])
-        self.assertEqual('', err)
-        self.assertEqual('', out)
-        self.assertInWorkingTree('foo', tree=tree)
-        self.failUnlessExists('foo')
-
-    def test_remove_no_files_specified_missing_dir_and_contents(self):
-        tree = self._make_tree_and_add(
-            ['foo', 'dir/', 'dir/missing/', 'dir/missing/child'])
-        self.get_transport('.').delete_tree('dir/missing')
-        out, err = self.run_bzr(['rm'])
-        self.assertEqual('', out)
-        self.assertEqual(
-            'removed dir/missing/child\n'
-            'removed dir/missing\n',
-            err)
-        # non-missing paths not touched:
-        self.assertInWorkingTree('foo', tree=tree)
-        self.failUnlessExists('foo')
-        self.assertInWorkingTree('dir', tree=tree)
-        self.failUnlessExists('dir')
-        # missing files unversioned
-        self.assertNotInWorkingTree('dir/missing', tree=tree)
-        self.assertNotInWorkingTree('dir/missing/child', tree=tree)
-
-    def test_remove_no_files_specified_already_deleted(self):
-        tree = self._make_tree_and_add(['foo', 'bar'])
-        tree.commit('save foo and bar')
-        os.unlink('bar')
-        self.run_bzr(['rm'])
-        self.assertEqual(None, tree.path2id('bar'))
-        # Running rm with a deleted file does not error.
-        out, err = self.run_bzr(['rm'])
-        self.assertEqual('', out)
-        self.assertEqual('', err)
-
-    def test_remove_no_files_specified_missing_file(self):
-        tree = self._make_tree_and_add(['foo', 'bar'])
-        os.unlink('bar')
-        out, err = self.run_bzr(['rm'])
-        self.assertEqual('', out)
-        self.assertEqual('removed bar\n', err)
-        # non-missing files not touched:
-        self.assertInWorkingTree('foo', tree=tree)
-        self.failUnlessExists('foo')
-        # missing files unversioned
-        self.assertNotInWorkingTree('bar', tree=tree)
-
-    def test_remove_no_files_specified_missing_link(self):
-        self.requireFeature(SymlinkFeature)
-        tree = self._make_tree_and_add(['foo'])
-        os.symlink('foo', 'linkname')
-        tree.add(['linkname'])
-        os.unlink('linkname')
-        out, err = self.run_bzr(['rm'])
-        self.assertEqual('', out)
-        self.assertEqual('removed linkname\n', err)
-        # non-missing files not touched:
-        self.assertInWorkingTree('foo', tree=tree)
-        self.failUnlessExists('foo')
-        # missing files unversioned
-        self.assertNotInWorkingTree('linkname', tree=tree)
+
+        self.run_bzr_error(["bzr: ERROR: No matching files."],
+            'remove --new .')
 
     def test_rm_one_file(self):
-        tree = self._make_tree_and_add([a])
+        tree = self._make_add_and_assert_tree([a])
         self.run_bzr("commit -m 'added a'")
         self.run_bzr('rm a', error_regexes=["deleted a"])
         self.assertFilesDeleted([a])
 
     def test_remove_one_file(self):
-        tree = self._make_tree_and_add([a])
+        tree = self._make_add_and_assert_tree([a])
         self.run_bzr("commit -m 'added a'")
         self.run_bzr('remove a', error_regexes=["deleted a"])
         self.assertFilesDeleted([a])
 
     def test_remove_keep_one_file(self):
-        tree = self._make_tree_and_add([a])
+        tree = self._make_add_and_assert_tree([a])
         self.run_bzr('remove --keep a', error_regexes=["removed a"])
         self.assertFilesUnversioned([a])
 
     def test_remove_one_deleted_file(self):
-        tree = self._make_tree_and_add([a])
+        tree = self._make_add_and_assert_tree([a])
         self.run_bzr("commit -m 'added a'")
         os.unlink(a)
         self.assertInWorkingTree(a)
@@ -178,21 +117,16 @@
             ['unknown:[.\s]*d/[.\s]*b/c[.\s]*b/[.\s]*a'], files)
 
     def test_remove_changed_files(self):
-        tree = self._make_tree_and_add(files)
+        tree = self._make_add_and_assert_tree(files)
         self.run_bzr("commit -m 'added files'")
         self.changeFile(a)
         self.changeFile(c)
         self.run_bzr_remove_changed_files(['modified:[.\s]*a[.\s]*b/c'], files)
 
-    def test_remove_changed_ignored_files(self):
-        tree = self._make_tree_and_add(['a'])
-        self.run_bzr(['ignore', 'a'])
-        self.run_bzr_remove_changed_files(['added:[.\s]*a'], ['a'])
-
     def test_remove_changed_files_from_child_dir(self):
         if sys.platform == 'win32':
             raise TestSkipped("Windows unable to remove '.' directory")
-        tree = self._make_tree_and_add(files)
+        tree = self._make_add_and_assert_tree(files)
         self.run_bzr("commit -m 'added files'")
         self.changeFile(a)
         self.changeFile(c)
@@ -218,7 +152,7 @@
         self.assertFilesDeleted(files)
 
     def test_remove_deleted_files(self):
-        tree = self._make_tree_and_add(files)
+        tree = self._make_add_and_assert_tree(files)
         self.run_bzr("commit -m 'added files'")
         my_files=[f for f in files]
         my_files.sort(reverse=True)
@@ -231,15 +165,15 @@
         self.failIfExists(files)
 
     def test_remove_non_existing_files(self):
-        tree = self._make_tree_and_add([])
+        tree = self._make_add_and_assert_tree([])
         self.run_bzr(['remove', 'b'])
 
     def test_remove_keep_non_existing_files(self):
-        tree = self._make_tree_and_add([])
+        tree = self._make_add_and_assert_tree([])
         self.run_bzr('remove --keep b', error_regexes=["b is not versioned."])
 
     def test_remove_files(self):
-        tree = self._make_tree_and_add(files)
+        tree = self._make_add_and_assert_tree(files)
         self.run_bzr("commit -m 'added files'")
         self.run_bzr('remove a b b/c d',
                      error_regexes=["deleted a", "deleted b", "deleted b/c",
@@ -247,7 +181,7 @@
         self.assertFilesDeleted(files)
 
     def test_remove_keep_files(self):
-        tree = self._make_tree_and_add(files)
+        tree = self._make_add_and_assert_tree(files)
         self.run_bzr("commit -m 'added files'")
         self.run_bzr('remove --keep a b b/c d',
                      error_regexes=["removed a", "removed b", "removed b/c",
@@ -255,13 +189,13 @@
         self.assertFilesUnversioned(files)
 
     def test_remove_with_new(self):
-        tree = self._make_tree_and_add(files)
+        tree = self._make_add_and_assert_tree(files)
         self.run_bzr('remove --new --keep',
                      error_regexes=["removed a", "removed b", "removed b/c"])
         self.assertFilesUnversioned(files)
 
     def test_remove_with_new_in_dir1(self):
-        tree = self._make_tree_and_add(files)
+        tree = self._make_add_and_assert_tree(files)
         self.run_bzr('remove --new --keep b b/c',
                      error_regexes=["removed b", "removed b/c"])
         tree = WorkingTree.open('.')
@@ -270,7 +204,7 @@
         self.assertFilesUnversioned([b,c])
 
     def test_remove_with_new_in_dir2(self):
-        tree = self._make_tree_and_add(files)
+        tree = self._make_add_and_assert_tree(files)
         self.run_bzr('remove --new --keep .',
                      error_regexes=["removed a", "removed b", "removed b/c"])
         tree = WorkingTree.open('.')

=== modified file 'bzrlib/tests/blackbox/test_selftest.py'
--- bzrlib/tests/blackbox/test_selftest.py	2008-08-31 10:46:54 +0000
+++ bzrlib/tests/blackbox/test_selftest.py	2007-09-18 06:31:55 +0000
@@ -34,6 +34,9 @@
                           TestUIFactory,
                           TestSkipped,
                           )
+from bzrlib.symbol_versioning import (
+    zero_eighteen,
+    )
 from bzrlib.tests.blackbox import ExternalBase
 
 
@@ -171,7 +174,7 @@
     def test_benchmark_runs_benchmark_tests(self):
         """bzr selftest --benchmark should not run the default test suite."""
         # We test this by passing a regression test name to --benchmark, which
-        # should result in 0 tests run.
+        # should result in 0 rests run.
         old_root = TestCaseWithMemoryTransport.TEST_ROOT
         try:
             TestCaseWithMemoryTransport.TEST_ROOT = None
@@ -257,7 +260,7 @@
 class TestRunBzrSubprocess(TestCaseWithTransport):
 
     def test_run_bzr_subprocess(self):
-        """The run_bzr_helper_external command behaves nicely."""
+        """The run_bzr_helper_external comand behaves nicely."""
         result = self.run_bzr_subprocess('--version')
         result = self.run_bzr_subprocess(['--version'])
         result = self.run_bzr_subprocess('--version', retcode=None)
@@ -271,6 +274,10 @@
                                       'magic merge'], retcode=3)[1]
         self.assertContainsRe(err, 'Bad value "magic merge" for option'
                               ' "merge-type"')
+        self.callDeprecated(['passing varargs to run_bzr_subprocess was'
+                             ' deprecated in version 0.91.'],
+                            self.run_bzr_subprocess,
+                            'arg1', 'arg2', 'arg3', retcode=3)
 
     def test_run_bzr_subprocess_env(self):
         """run_bzr_subprocess can set environment variables in the child only.
@@ -551,39 +558,3 @@
             out_rand2.splitlines(), 2)
         self.assertEqual(tests_rand, tests_rand2)
 
-
-class TestSelftestWithIdList(TestCaseInTempDir):
-
-    def test_load_list(self):
-        # We don't want to call selftest for the whole suite, so we start with
-        # a reduced list.
-        test_list_fname = 'test.list'
-        fl = open(test_list_fname, 'wt')
-        fl.write('%s\n' % self.id())
-        fl.close()
-        out, err = self.run_bzr(
-            ['selftest', '--load-list', test_list_fname, '--list'])
-        self.assertContainsRe(out, "Listed 1 test in")
-
-    def test_load_unknown(self):
-        out, err = self.run_bzr('selftest --load-list I_do_not_exist ',
-                                retcode=3)
-
-
-class TestSelftestStartingWith(TestCase):
-
-    def test_starting_with_single_argument(self):
-        out, err = self.run_bzr(
-            ['selftest', '--starting-with', self.id(), '--list'])
-        self.assertContainsRe(out, "Listed 1 test in")
-        self.assertContainsRe(out, self.id())
-
-    def test_starting_with_multiple_argument(self):
-        out, err = self.run_bzr(
-            ['selftest',
-             '--starting-with', self.id(),
-             '--starting-with', 'bzrlib.tests.test_sampler',
-             '--list'])
-        self.assertContainsRe(out, "Listed 2 tests in")
-        self.assertContainsRe(out, self.id())
-        self.assertContainsRe(out, 'bzrlib.tests.test_sampler')

=== modified file 'bzrlib/tests/blackbox/test_send.py'
--- bzrlib/tests/blackbox/test_send.py	2008-08-02 17:10:50 +0000
+++ bzrlib/tests/blackbox/test_send.py	2007-08-24 20:32:51 +0000
@@ -17,7 +17,6 @@
 
 
 import os
-import sys
 from StringIO import StringIO
 
 from bzrlib import (
@@ -56,7 +55,7 @@
         self.assertContainsRe(errmsg, 'No submit branch known or specified')
         os.chdir('../branch')
         stdout, stderr = self.run_bzr('send -o-')
-        self.assertEqual(stderr.count('Using saved parent location'), 1)
+        self.assertEqual(stderr.count('Using saved location'), 1)
         br = read_bundle(StringIO(stdout))
         self.assertRevisions(br, ['revision3'])
 
@@ -68,7 +67,7 @@
         self.assertContainsRe(errmsg, 'No submit branch known or specified')
         os.chdir('../branch')
         stdout, stderr = self.run_bzr('bundle')
-        self.assertEqual(stderr.count('Using saved parent location'), 1)
+        self.assertEqual(stderr.count('Using saved location'), 1)
         br = read_bundle(StringIO(stdout))
         self.assertRevisions(br, ['revision3'])
 
@@ -193,9 +192,8 @@
     def test_mailto_option(self):
         self.make_trees()
         branch = _mod_branch.Branch.open('branch')
-        branch.get_config().set_user_option('mail_client', 'editor')
+        branch.get_config().set_user_option('mail_client', 'bogus')
         self.run_bzr_error(('No mail-to address specified',), 'send -f branch')
-        branch.get_config().set_user_option('mail_client', 'bogus')
         self.run_bzr('send -f branch -o-')
         self.run_bzr_error(('Unknown mail client: bogus',),
                            'send -f branch --mail-to jrandom@example.org')
@@ -203,17 +201,6 @@
         self.run_bzr_error(('Unknown mail client: bogus',),
                            'send -f branch')
 
-    def test_mailto_child_option(self):
-        """Make sure that child_submit_to is used."""
-        self.make_trees()
-        branch = _mod_branch.Branch.open('branch')
-        branch.get_config().set_user_option('mail_client', 'bogus')
-        parent = _mod_branch.Branch.open('parent')
-        parent.get_config().set_user_option('child_submit_to', 
-                           'somebody@example.org')
-        self.run_bzr_error(('Unknown mail client: bogus',),
-                           'send -f branch')
-
     def test_format(self):
         self.make_trees()
         s = StringIO(self.run_bzr('send -f branch -o- --format=4')[0])
@@ -248,12 +235,3 @@
                                  'grandparent'])
         self.assertEqual('revision1', md.base_revision_id)
         self.assertEqual('revision3', md.revision_id)
-
-    def test_nonexistant_branch(self):
-        if sys.platform == "win32":
-            location = "C:/i/do/not/exist/"
-        else:
-            location = "/i/do/not/exist/"
-        out, err = self.run_bzr(["send", "--from", location], retcode=3)
-        self.assertEqual(out, '')
-        self.assertEqual(err, 'bzr: ERROR: Not a branch: "%s".\n' % location)

=== modified file 'bzrlib/tests/blackbox/test_serve.py'
--- bzrlib/tests/blackbox/test_serve.py	2008-05-19 11:43:41 +0000
+++ bzrlib/tests/blackbox/test_serve.py	2007-07-11 19:44:51 +0000
@@ -57,16 +57,6 @@
         self.assertEqual('', result[0])
         self.assertEqual('bzr: interrupted\n', result[1])
 
-    def make_read_requests(self, branch):
-        """Do some read only requests."""
-        branch.lock_read()
-        try:
-            branch.repository.all_revision_ids()
-            self.assertEqual(_mod_revision.NULL_REVISION,
-                             _mod_revision.ensure_null(branch.last_revision()))
-        finally:
-            branch.unlock()
-
     def start_server_inet(self, extra_options=()):
         """Start a bzr server subprocess using the --inet option.
 
@@ -80,10 +70,10 @@
         # Connect to the server
         # We use this url because while this is no valid URL to connect to this
         # server instance, the transport needs a URL.
-        url = 'bzr://localhost/'
         client_medium = medium.SmartSimplePipesClientMedium(
-            process.stdout, process.stdin, url)
-        transport = remote.RemoteTransport(url, medium=client_medium)
+            process.stdout, process.stdin)
+        transport = remote.RemoteTransport(
+            'bzr://localhost/', medium=client_medium)
         return process, transport
 
     def start_server_port(self, extra_options=()):
@@ -117,7 +107,9 @@
 
         # We get a working branch
         branch = BzrDir.open_from_transport(transport).open_branch()
-        self.make_read_requests(branch)
+        branch.repository.get_revision_graph()
+        self.assertEqual(_mod_revision.NULL_REVISION,
+                         _mod_revision.ensure_null(branch.last_revision()))
         self.assertInetServerShutsdownCleanly(process)
 
     def test_bzr_serve_port_readonly(self):
@@ -135,7 +127,12 @@
 
         # Connect to the server
         branch = Branch.open(url)
-        self.make_read_requests(branch)
+
+        # We get a working branch
+        branch.repository.get_revision_graph()
+        self.assertEqual(_mod_revision.NULL_REVISION,
+                         _mod_revision.ensure_null(branch.last_revision()))
+
         self.assertServerFinishesCleanly(process)
 
     def test_bzr_connect_to_bzr_ssh(self):
@@ -211,7 +208,10 @@
                 path_to_branch = os.path.splitdrive(path_to_branch)[1]
             branch = Branch.open(
                 'bzr+ssh://fred:secret@localhost:%d%s' % (port, path_to_branch))
-            self.make_read_requests(branch)
+            
+            branch.repository.get_revision_graph()
+            self.assertEqual(_mod_revision.NULL_REVISION,
+                             _mod_revision.ensure_null(branch.last_revision()))
             # Check we can perform write operations
             branch.bzrdir.root_transport.mkdir('foo')
         finally:

=== modified file 'bzrlib/tests/blackbox/test_shared_repository.py'
--- bzrlib/tests/blackbox/test_shared_repository.py	2008-07-18 07:29:06 +0000
+++ bzrlib/tests/blackbox/test_shared_repository.py	2007-06-26 20:32:49 +0000
@@ -26,25 +26,12 @@
 
     def test_make_repository(self):
         out, err = self.run_bzr("init-repository a")
-        self.assertEqual(out,
-"""Shared repository with trees (format: pack-0.92)
-Location:
-  shared repository: a
-""")
-        self.assertEqual(err, "")
-        dir = BzrDir.open('a')
-        self.assertIs(dir.open_repository().is_shared(), True)
-        self.assertRaises(errors.NotBranchError, dir.open_branch)
-        self.assertRaises(errors.NoWorkingTree, dir.open_workingtree)
-
-    def test_make_repository_quiet(self):
-        out, err = self.run_bzr("init-repository a -q")
         self.assertEqual(out, "")
         self.assertEqual(err, "")
         dir = BzrDir.open('a')
         self.assertIs(dir.open_repository().is_shared(), True)
         self.assertRaises(errors.NotBranchError, dir.open_branch)
-        self.assertRaises(errors.NoWorkingTree, dir.open_workingtree)
+        self.assertRaises(errors.NoWorkingTree, dir.open_workingtree)        
 
     def test_init_repo_existing_dir(self):
         """Make repo in existing directory.

=== modified file 'bzrlib/tests/blackbox/test_split.py'
--- bzrlib/tests/blackbox/test_split.py	2007-12-17 19:27:35 +0000
+++ bzrlib/tests/blackbox/test_split.py	2007-06-26 20:32:49 +0000
@@ -17,17 +17,14 @@
 
 import os
 
-from bzrlib import bzrdir, tests, workingtree
-from bzrlib.repofmt.knitrepo import RepositoryFormatKnit4
-from bzrlib.repofmt.pack_repo import RepositoryFormatKnitPack4
-
+from bzrlib import bzrdir, tests
 
 
 class TestSplit(tests.TestCaseWithTransport):
 
     def test_split(self):
         self.build_tree(['a/', 'a/b/', 'a/b/c'])
-        wt = self.make_branch_and_tree('a', format='rich-root-pack')
+        wt = self.make_branch_and_tree('a')
         wt.add(['b', 'b/c'])
         wt.commit('rev1')
         self.run_bzr('split a/b')
@@ -41,26 +38,3 @@
         wt.add(['b', 'b/c', 'b/c/d'], ['b-id', 'c-id', 'd-id'])
         wt.commit('added files')
         self.run_bzr_error(('must upgrade your branch at .*a',), 'split a/b')
-
-    def test_split_tree_failure(self):
-        tree = self.make_branch_and_tree('tree', format='pack-0.92')
-        self.build_tree(['tree/subtree/'])
-        tree.add('subtree')
-        tree.commit('added subtree')
-        self.run_bzr_error(('must upgrade your branch at .*tree',),
-                           'split tree/subtree')
-
-    def split_formats(self, format, repo_format):
-        tree = self.make_branch_and_tree('rich-root', format=format)
-        self.build_tree(['rich-root/a/'])
-        tree.add('a')
-        self.run_bzr(['split', 'rich-root/a'])
-        subtree = workingtree.WorkingTree.open('rich-root/a')
-        self.assertIsInstance(subtree.branch.repository._format,
-                              repo_format)
-
-    def test_split_rich_root(self):
-        self.split_formats('rich-root', RepositoryFormatKnit4)
-
-    def test_split_rich_root_pack(self):
-        self.split_formats('rich-root-pack', RepositoryFormatKnitPack4)

=== modified file 'bzrlib/tests/blackbox/test_status.py'
--- bzrlib/tests/blackbox/test_status.py	2008-08-28 11:01:33 +0000
+++ bzrlib/tests/blackbox/test_status.py	2007-09-04 01:20:26 +0000
@@ -44,22 +44,20 @@
 class BranchStatus(TestCaseWithTransport):
     
     def assertStatus(self, expected_lines, working_tree,
-        revision=None, short=False, pending=True):
+        revision=None, short=False):
         """Run status in working_tree and look for output.
         
         :param expected_lines: The lines to look for.
         :param working_tree: The tree to run status in.
         """
-        output_string = self.status_string(working_tree, revision, short,
-                pending)
+        output_string = self.status_string(working_tree, revision, short)
         self.assertEqual(expected_lines, output_string.splitlines(True))
     
-    def status_string(self, wt, revision=None, short=False, pending=True):
+    def status_string(self, wt, revision=None, short=False):
         # use a real file rather than StringIO because it doesn't handle
         # Unicode very well.
         tof = codecs.getwriter('utf-8')(TemporaryFile())
-        show_tree_status(wt, to_file=tof, revision=revision, short=short,
-                show_pending=pending)
+        show_tree_status(wt, to_file=tof, revision=revision, short=short)
         tof.seek(0)
         return tof.read().decode('utf-8')
 
@@ -95,26 +93,15 @@
                 '  bye.c\n',
                 '  hello.c\n',
                 'pending merges:\n',
-                '  (ghost) pending@pending-0-0\n',
+                '  pending@pending-0-0\n',
             ],
             wt)
         self.assertStatus([
                 '?   bye.c\n',
                 '?   hello.c\n',
-                'P   (ghost) pending@pending-0-0\n',
+                'P   pending@pending-0-0\n',
             ],
             wt, short=True)
-        self.assertStatus([
-                'unknown:\n',
-                '  bye.c\n',
-                '  hello.c\n',
-            ],
-            wt, pending=False)
-        self.assertStatus([
-                '?   bye.c\n',
-                '?   hello.c\n',
-            ],
-            wt, short=True, pending=False)
 
     def test_branch_status_revisions(self):
         """Tests branch status with revisions"""
@@ -428,36 +415,6 @@
         out, err = self.run_bzr('status -r 1..23..123', retcode=3)
         self.assertContainsRe(err, 'one or two revision specifiers')
 
-    def test_status_no_pending(self):
-        a_tree = self.make_branch_and_tree('a')
-        self.build_tree(['a/a'])
-        a_tree.add('a')
-        a_tree.commit('a')
-        b_tree = a_tree.bzrdir.sprout('b').open_workingtree()
-        self.build_tree(['b/b'])
-        b_tree.add('b')
-        b_tree.commit('b')
-
-        self.run_bzr('merge ../b', working_dir='a')
-        out, err = self.run_bzr('status --no-pending', working_dir='a')
-        self.assertEquals(out, "added:\n  b\n")
-
-    def test_pending_specific_files(self):
-        """With a specific file list, pending merges are not shown."""
-        tree = self.make_branch_and_tree('tree')
-        self.build_tree_contents([('tree/a', 'content of a\n')])
-        tree.add('a')
-        r1_id = tree.commit('one')
-        alt = tree.bzrdir.sprout('alt').open_workingtree()
-        self.build_tree_contents([('alt/a', 'content of a\nfrom alt\n')])
-        alt_id = alt.commit('alt')
-        tree.merge_from_branch(alt.branch)
-        output = self.make_utf8_encoded_stringio()
-        show_tree_status(tree, to_file=output)
-        self.assertContainsRe(output.getvalue(), 'pending merges:')
-        out, err = self.run_bzr('status tree/a')
-        self.assertNotContainsRe(out, 'pending merges:')
-
 
 class TestStatusEncodings(TestCaseWithTransport):
     

=== removed file 'bzrlib/tests/blackbox/test_switch.py'
--- bzrlib/tests/blackbox/test_switch.py	2008-03-03 11:35:47 +0000
+++ bzrlib/tests/blackbox/test_switch.py	1970-01-01 00:00:00 +0000
@@ -1,65 +0,0 @@
-# Copyright (C) 2007 Canonical Ltd
-# -*- coding: utf-8 -*-
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-
-"""Tests for the switch command of bzr."""
-
-import os
-
-from bzrlib.tests.blackbox import ExternalBase
-
-
-class TestSwitch(ExternalBase):
-
-    def test_switch_up_to_date_light_checkout(self):
-        self.make_branch_and_tree('branch')
-        self.run_bzr('branch branch branch2')
-        self.run_bzr('checkout --lightweight branch checkout')
-        os.chdir('checkout')
-        out, err = self.run_bzr('switch ../branch2')
-        self.assertContainsRe(err, 'Tree is up to date at revision 0.\n')
-        self.assertContainsRe(err, 'Switched to branch: .*/branch2.\n')
-        self.assertEqual('', out)
-
-    def test_switch_out_of_date_light_checkout(self):
-        self.make_branch_and_tree('branch')
-        self.run_bzr('branch branch branch2')
-        self.build_tree(['branch2/file'])
-        self.run_bzr('add branch2/file')
-        self.run_bzr('commit -m add-file branch2')
-        self.run_bzr('checkout --lightweight branch checkout')
-        os.chdir('checkout')
-        out, err = self.run_bzr('switch ../branch2')
-        #self.assertContainsRe(err, '\+N  file')
-        self.assertContainsRe(err, 'Updated to revision 1.\n')
-        self.assertContainsRe(err, 'Switched to branch: .*/branch2.\n')
-        self.assertEqual('', out)
-
-    def test_switch_finds_relative_branch(self):
-        """Switch will find 'foo' relative to the branch that the checkout is of."""
-        self.build_tree(['repo/'])
-        tree1 = self.make_branch_and_tree('repo/brancha')
-        tree1.commit('foo')
-        tree2 = self.make_branch_and_tree('repo/branchb')
-        tree2.pull(tree1.branch)
-        branchb_id = tree2.commit('bar')
-        checkout =  tree1.branch.create_checkout('checkout', lightweight=True)
-        self.run_bzr(['switch', 'branchb'], working_dir='checkout')
-        self.assertEqual(branchb_id, checkout.last_revision())
-        checkout = checkout.bzrdir.open_workingtree()
-        self.assertEqual(tree2.branch.base, checkout.branch.base)
-        

=== modified file 'bzrlib/tests/blackbox/test_tags.py'
--- bzrlib/tests/blackbox/test_tags.py	2007-10-26 10:49:21 +0000
+++ bzrlib/tests/blackbox/test_tags.py	2007-07-31 22:08:47 +0000
@@ -105,60 +105,14 @@
         self.assertEquals(b3.tags.lookup_tag('tag1'), 'first-revid')
 
     def test_list_tags(self):
-        tree1 = self.make_branch_and_tree('branch1')
-        tree1.commit(allow_pointless=True, message='revision 1',
-                rev_id='revid-1', timestamp=10)
-        tree1.commit(allow_pointless=True, message='revision 2',
-                rev_id='revid-2', timestamp=15)
-
-        b1 = tree1.branch
-        # note how the tag for revid-1 sorts after the one for revid-2
-        b1.tags.set_tag(u'tagA\u30d0', 'revid-2')
-        b1.tags.set_tag(u'tagB\u30d0', 'missing') # not present in repository
-        b1.tags.set_tag(u'tagC\u30d0', 'revid-1')
-
-        # lexicographical order
-        out, err = self.run_bzr('tags -d branch1', encoding='utf-8')
-        self.assertEquals(err, '')
-        self.assertContainsRe(out, (u'^tagA\u30d0  *2\ntagB\u30d0  *\\?\n' +
-            u'tagC\u30d0 *1\n').encode('utf-8'))
-
-        out, err = self.run_bzr('tags --show-ids -d branch1', encoding='utf-8')
-        self.assertEquals(err, '')
-        self.assertContainsRe(out, (u'^tagA\u30d0  *revid-2\n' +
-            u'tagB\u30d0  *missing\ntagC\u30d0 *revid-1\n').encode('utf-8'))
-
-        # chronological order
-        out, err = self.run_bzr('tags --sort=time -d branch1',
-                encoding='utf-8')
-        self.assertEquals(err, '')
-        self.assertContainsRe(out, (u'^tagC\u30d0  *1\ntagA\u30d0  *2\n' +
-            u'tagB\u30d0 *\\?\n').encode('utf-8'))
-
-        out, err = self.run_bzr('tags --sort=time --show-ids -d branch1',
-                encoding='utf-8')
-        self.assertEquals(err, '')
-        self.assertContainsRe(out, (u'^tagC\u30d0  *revid-1\n' +
-            u'tagA\u30d0  *revid-2\ntagB\u30d0 *missing\n').encode('utf-8'))
-
-        # now test dotted revnos
-        tree2 = tree1.bzrdir.sprout('branch2').open_workingtree()
-        tree1.commit(allow_pointless=True, message='revision 3 in branch1',
-                rev_id='revid-3a')
-        tree2.commit(allow_pointless=True, message='revision 3 in branch2',
-                rev_id='revid-3b')
-
-        b2 = tree2.branch
-        b2.tags.set_tag('tagD', 'revid-3b')
-        self.run_bzr('merge -d branch1 branch2')
-        tree1.commit('merge', rev_id='revid-4')
-
-        out, err = self.run_bzr('tags -d branch1', encoding='utf-8')
-        self.assertEquals(err, '')
-        self.assertContainsRe(out, r'tagD  *2\.1\.1\n')
-        out, err = self.run_bzr('tags -d branch2', encoding='utf-8')
-        self.assertEquals(err, '')
-        self.assertContainsRe(out, r'tagD  *3\n')
+        t = self.make_branch_and_tree('branch1')
+        b1 = t.branch
+        tagname = u'\u30d0zaar'
+        b1.tags.set_tag(tagname, 'revid-1')
+        out, err = self.run_bzr('tags -d branch1', encoding='utf-8')
+        self.assertEquals(err, '')
+        self.assertContainsRe(out,
+            u'^\u30d0zaar  *revid-1\n'.encode('utf-8'))
 
     def test_conflicting_tags(self):
         # setup two empty branches with different tags

=== modified file 'bzrlib/tests/blackbox/test_too_much.py'
--- bzrlib/tests/blackbox/test_too_much.py	2007-12-11 14:26:18 +0000
+++ bzrlib/tests/blackbox/test_too_much.py	2007-09-18 08:14:00 +0000
@@ -49,7 +49,7 @@
     pathjoin,
     terminal_width,
     )
-from bzrlib.tests.http_utils import TestCaseWithWebserver
+from bzrlib.tests.HTTPTestUtil import TestCaseWithWebserver
 from bzrlib.tests.test_sftp_transport import TestCaseWithSFTPServer
 from bzrlib.tests.blackbox import ExternalBase
 from bzrlib.workingtree import WorkingTree

=== modified file 'bzrlib/tests/blackbox/test_uncommit.py'
--- bzrlib/tests/blackbox/test_uncommit.py	2008-08-15 17:13:12 +0000
+++ bzrlib/tests/blackbox/test_uncommit.py	2007-06-26 20:32:49 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2008 Canonical Ltd
+# Copyright (C) 2005, 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -32,7 +32,7 @@
         wt.add(['a', 'b', 'c'])
         wt.commit('initial commit', rev_id='a1')
 
-        self.build_tree_contents([('tree/a', 'new contents of a\n')])
+        open('tree/a', 'wb').write('new contents of a\n')
         wt.commit('second commit', rev_id='a2')
 
         return wt
@@ -60,12 +60,6 @@
         out, err = self.run_bzr('status')
         self.assertEquals(out, 'modified:\n  a\n')
 
-    def test_uncommit_no_history(self):
-        wt = self.make_branch_and_tree('tree')
-        out, err = self.run_bzr('uncommit --force', retcode=1)
-        self.assertEqual('', err)
-        self.assertEqual('No revisions to uncommit.\n', out)
-
     def test_uncommit_checkout(self):
         wt = self.create_simple_tree()
         checkout_tree = wt.branch.create_checkout('checkout')
@@ -110,18 +104,6 @@
         b.pull(t_a.branch)
         uncommit.uncommit(b)
 
-    def test_uncommit_bound_local(self):
-        t_a = self.make_branch_and_tree('a')
-        rev_id1 = t_a.commit('commit 1')
-        rev_id2 = t_a.commit('commit 2')
-        rev_id3 = t_a.commit('commit 3')
-        b = t_a.branch.create_checkout('b').branch
-
-        out, err = self.run_bzr(['uncommit', '--local', 'b', '--force'])
-        self.assertEqual(rev_id3, t_a.last_revision())
-        self.assertEqual((3, rev_id3), t_a.branch.last_revision_info())
-        self.assertEqual((2, rev_id2), b.last_revision_info())
-
     def test_uncommit_revision(self):
         wt = self.create_simple_tree()
 
@@ -173,57 +155,47 @@
         wt = self.create_simple_tree()
 
         tree2 = wt.bzrdir.sprout('tree2').open_workingtree()
+
         tree2.commit('unchanged', rev_id='b3')
 
-        tree3 = wt.bzrdir.sprout('tree3').open_workingtree()
-        tree3.commit('unchanged', rev_id='c3')
-
         wt.merge_from_branch(tree2.branch)
         wt.commit('merge b3', rev_id='a3')
 
-        wt.merge_from_branch(tree3.branch)
-        wt.commit('merge c3', rev_id='a4')
+        tree2.commit('unchanged', rev_id='b4')
+
+        wt.merge_from_branch(tree2.branch)
+        wt.commit('merge b4', rev_id='a4')
 
         self.assertEqual(['a4'], wt.get_parent_ids())
 
         os.chdir('tree')
         out, err = self.run_bzr('uncommit --force -r 2')
 
-        self.assertEqual(['a2', 'b3', 'c3'], wt.get_parent_ids())
+        self.assertEqual(['a2', 'b3', 'b4'], wt.get_parent_ids())
 
     def test_uncommit_merge_plus_pending(self):
         wt = self.create_simple_tree()
 
         tree2 = wt.bzrdir.sprout('tree2').open_workingtree()
+
         tree2.commit('unchanged', rev_id='b3')
-        tree3 = wt.bzrdir.sprout('tree3').open_workingtree()
-        tree3.commit('unchanged', rev_id='c3')
-
         wt.branch.fetch(tree2.branch)
         wt.set_pending_merges(['b3'])
         wt.commit('merge b3', rev_id='a3')
 
-
-        wt.merge_from_branch(tree3.branch)
-
-        self.assertEqual(['a3', 'c3'], wt.get_parent_ids())
+        tree2.commit('unchanged', rev_id='b4')
+        wt.branch.fetch(tree2.branch)
+        wt.set_pending_merges(['b4'])
+
+        self.assertEqual(['a3', 'b4'], wt.get_parent_ids())
 
         os.chdir('tree')
         out, err = self.run_bzr('uncommit --force -r 2')
 
-        self.assertEqual(['a2', 'b3', 'c3'], wt.get_parent_ids())
-
-    def test_uncommit_shows_log_with_revision_id(self):
-        wt = self.create_simple_tree()
-
-        out, err = self.run_bzr('uncommit --force', working_dir='tree')
-        self.assertContainsRe(out, r'second commit')
-        self.assertContainsRe(err, r'You can restore the old tip by running')
-        self.assertContainsRe(err, r'bzr pull . -r revid:a2')
+        self.assertEqual(['a2', 'b3', 'b4'], wt.get_parent_ids())
 
     def test_uncommit_octopus_merge(self):
         # Check that uncommit keeps the pending merges in the same order
-        # though it will also filter out ones in the ancestry
         wt = self.create_simple_tree()
 
         tree2 = wt.bzrdir.sprout('tree2').open_workingtree()
@@ -231,7 +203,7 @@
 
         tree2.commit('unchanged', rev_id='b3')
         tree3.commit('unchanged', rev_id='c3')
-
+        
         wt.merge_from_branch(tree2.branch)
         wt.merge_from_branch(tree3.branch)
         wt.commit('merge b3, c3', rev_id='a3')
@@ -248,10 +220,4 @@
         os.chdir('tree')
         out, err = self.run_bzr('uncommit --force -r 2')
 
-        self.assertEqual(['a2', 'c4', 'b4'], wt.get_parent_ids())
-
-    def test_uncommit_nonascii(self):
-        tree = self.make_branch_and_tree('tree')
-        tree.commit(u'\u1234 message')
-        out, err = self.run_bzr('uncommit --force tree', encoding='ascii')
-        self.assertContainsRe(out, r'\? message')
+        self.assertEqual(['a2', 'b3', 'c3', 'c4', 'b4'], wt.get_parent_ids())

=== modified file 'bzrlib/tests/blackbox/test_unknowns.py'
--- bzrlib/tests/blackbox/test_unknowns.py	2008-06-05 16:24:53 +0000
+++ bzrlib/tests/blackbox/test_unknowns.py	2007-09-05 01:54:07 +0000
@@ -20,7 +20,6 @@
 
 from bzrlib.tests.blackbox import ExternalBase
 
-
 class TestUnknowns(ExternalBase):
 
     def test_unknowns(self):
@@ -34,12 +33,12 @@
         self.build_tree_contents([('a', 'contents of a\n')])
         self.assertEquals(self.run_bzr('unknowns')[0], 'a\n')
 
-        # multiple unknown files, including one with a space in its name
-        self.build_tree(['b', 'c', 'd e'])
-        self.assertEquals(self.run_bzr('unknowns')[0], 'a\nb\nc\n"d e"\n')
+        # multiple unknown files
+        self.build_tree(['b', 'c'])
+        self.assertEquals(self.run_bzr('unknowns')[0], 'a\nb\nc\n')
 
         # after add, file no longer shown
-        tree.add(['a', 'd e'])
+        tree.add('a')
         self.assertEquals(self.run_bzr('unknowns')[0], 'b\nc\n')
 
         # after all added, none shown

=== modified file 'bzrlib/tests/blackbox/test_update.py'
--- bzrlib/tests/blackbox/test_update.py	2007-11-01 09:52:45 +0000
+++ bzrlib/tests/blackbox/test_update.py	2007-08-08 02:01:10 +0000
@@ -21,6 +21,7 @@
 import os
 
 from bzrlib import branch, bzrdir
+from bzrlib.tests import TestSkipped
 from bzrlib.tests.blackbox import ExternalBase
 from bzrlib.workingtree import WorkingTree
 

=== modified file 'bzrlib/tests/blackbox/test_upgrade.py'
--- bzrlib/tests/blackbox/test_upgrade.py	2008-03-14 21:31:15 +0000
+++ bzrlib/tests/blackbox/test_upgrade.py	2007-06-27 19:13:50 +0000
@@ -109,7 +109,7 @@
             ['upgrade', '--format=metaweave', url])
         self.assertEqualDiff("""starting upgrade of %s
 making backup of tree history
-%s.bzr has been backed up to %sbackup.bzr
+%s.bzr has been backed up to %s.bzr.backup
 if conversion fails, you can move this directory back to .bzr
 if it succeeds, you can remove this directory if you wish
 starting upgrade from format 5 to 6
@@ -133,7 +133,7 @@
             ['upgrade', '--format=knit', url])
         self.assertEqualDiff("""starting upgrade of %s
 making backup of tree history
-%s.bzr has been backed up to %sbackup.bzr
+%s.bzr has been backed up to %s.bzr.backup
 if conversion fails, you can move this directory back to .bzr
 if it succeeds, you can remove this directory if you wish
 starting repository conversion
@@ -172,7 +172,7 @@
         out, err = self.run_bzr(['upgrade', '--format=knit', url])
         self.assertEqualDiff("""starting upgrade of %s
 making backup of tree history
-%s.bzr has been backed up to %sbackup.bzr
+%s.bzr has been backed up to %s.bzr.backup
 if conversion fails, you can move this directory back to .bzr
 if it succeeds, you can remove this directory if you wish
 starting upgrade from format 6 to metadir
@@ -196,6 +196,6 @@
         # the actual workingtree, not when we only open a bzrdir that contains
         # an old workngtree
         self.run_bzr('init --knit a')
-        out, err = self.run_bzr('revno a')
+        out, err = self.run_bzr('checkout a b')
         if err.find('upgrade') > -1:
             self.fail("message shouldn't suggest upgrade:\n%s" % err)

=== modified file 'bzrlib/tests/blackbox/test_version.py'
--- bzrlib/tests/blackbox/test_version.py	2008-05-02 05:33:36 +0000
+++ bzrlib/tests/blackbox/test_version.py	2007-09-04 11:00:30 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007, 2008 Canonical Ltd
+# Copyright (C) 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -16,9 +16,6 @@
 
 """Black-box tests for bzr version."""
 
-import os
-import sys
-
 import bzrlib
 from bzrlib import osutils, trace
 from bzrlib.tests import (
@@ -34,17 +31,12 @@
     def test_version(self):
         out = self.run_bzr("version")[0]
         self.assertTrue(len(out) > 0)
-        self.assertEqualDiff(out.splitlines()[0],
-            "Bazaar (bzr) %s" % bzrlib.__version__)
+        self.assertEquals(1, out.count(bzrlib.__version__))
         self.assertContainsRe(out, r"(?m)^  Python interpreter:")
         self.assertContainsRe(out, r"(?m)^  Python standard library:")
         self.assertContainsRe(out, r"(?m)^  bzrlib:")
         self.assertContainsRe(out, r"(?m)^  Bazaar configuration:")
-        self.assertContainsRe(out, r'(?m)^  Bazaar log file:.*\.bzr\.log')
-
-    def test_version_short(self):
-        out = self.run_bzr(["version", "--short"])[0]
-        self.assertEqualDiff(out, bzrlib.version_string + '\n')
+        self.assertContainsRe(out, r'(?m)^  Bazaar log file:.*bzr\.log')
 
 
 class TestVersionUnicodeOutput(TestCaseInTempDir):
@@ -82,30 +74,3 @@
         out = self.run_bzr("version")[0]
         self.assertTrue(len(out) > 0)
         self.assertContainsRe(out, r"(?m)^  Bazaar configuration: " + str_val)
-
-
-class TestVersionBzrLogLocation(TestCaseInTempDir):
-
-    def test_simple(self):
-        bzr_log = 'my.bzr.log'
-        osutils.set_or_unset_env('BZR_LOG', bzr_log)
-        default_log = os.path.join(os.environ['BZR_HOME'], '.bzr.log')
-        self.failIfExists([default_log, bzr_log])
-        out = self.run_bzr_subprocess('version')[0]
-        self.assertTrue(len(out) > 0)
-        self.assertContainsRe(out, r"(?m)^  Bazaar log file: " + bzr_log)
-        self.failIfExists(default_log)
-        self.failUnlessExists(bzr_log)
-
-    def test_dev_null(self):
-        if sys.platform == 'win32':
-            bzr_log = 'NUL'
-        else:
-            bzr_log = '/dev/null'
-        osutils.set_or_unset_env('BZR_LOG', bzr_log)
-        default_log = os.path.join(os.environ['BZR_HOME'], '.bzr.log')
-        self.failIfExists(default_log)
-        out = self.run_bzr_subprocess('version')[0]
-        self.assertTrue(len(out) > 0)
-        self.assertContainsRe(out, r"(?m)^  Bazaar log file: " + bzr_log)
-        self.failIfExists(default_log)

=== modified file 'bzrlib/tests/blackbox/test_version_info.py'
--- bzrlib/tests/blackbox/test_version_info.py	2008-02-25 23:41:06 +0000
+++ bzrlib/tests/blackbox/test_version_info.py	2007-06-26 20:32:49 +0000
@@ -134,20 +134,3 @@
         txt = self.run_bzr('version-info --format python branch')[0]
 
         self.assertContainsRe(txt, 'version_info = {')
-
-    def test_custom_without_template(self):
-        wt = self.make_branch_and_tree('branch')
-        out, err = self.run_bzr('version-info --custom', retcode=3)
-        self.assertContainsRe(err, r'ERROR: No template specified\.')
-
-    def test_custom_implies_all(self):
-        self.create_tree()
-        out, err = self.run_bzr('version-info --custom --template='
-            '"{revno} {branch_nick} {clean}\n" branch')
-        self.assertEqual("2 branch 1\n", out)
-        self.assertEqual("", err)
-        self.build_tree_contents([('branch/c', 'now unclean\n')])
-        out, err = self.run_bzr('version-info --custom --template='
-            '"{revno} {branch_nick} {clean}\n" branch')
-        self.assertEqual("2 branch 0\n", out)
-        self.assertEqual("", err)

=== modified file 'bzrlib/tests/blackbox/test_versioning.py'
--- bzrlib/tests/blackbox/test_versioning.py	2007-11-22 02:33:49 +0000
+++ bzrlib/tests/blackbox/test_versioning.py	2007-06-28 12:26:11 +0000
@@ -148,30 +148,24 @@
 
         old = b.repository.revision_tree(b.get_rev_id(1))
         new = b.repository.revision_tree(b.get_rev_id(2))
-        new.lock_read()
 
         eq(new.get_file_by_path('b/two').read(), 'old contents')
         eq(new.get_file_by_path('top').read(), 'old contents')
         eq(new.get_file_by_path('a/one').read(), 'new contents')
-        new.unlock()
 
         os.chdir('a')
         # commit from here should do nothing
         run_bzr(['commit', '.', '-m', 'commit subdir only', '--unchanged'])
         v3 = b.repository.revision_tree(b.get_rev_id(3))
-        v3.lock_read()
         eq(v3.get_file_by_path('b/two').read(), 'old contents')
         eq(v3.get_file_by_path('top').read(), 'old contents')
         eq(v3.get_file_by_path('a/one').read(), 'new contents')
-        v3.unlock()
 
         # commit in subdirectory commits whole tree
         run_bzr(['commit', '-m', 'commit whole tree from subdir'])
         v4 = b.repository.revision_tree(b.get_rev_id(4))
-        v4.lock_read()
         eq(v4.get_file_by_path('b/two').read(), 'new contents')
         eq(v4.get_file_by_path('top').read(), 'new contents')
-        v4.unlock()
 
         # TODO: factor out some kind of assert_tree_state() method
 

=== modified file 'bzrlib/tests/branch_implementations/__init__.py'
--- bzrlib/tests/branch_implementations/__init__.py	2008-07-07 10:31:06 +0000
+++ bzrlib/tests/branch_implementations/__init__.py	2007-06-28 05:19:04 +0000
@@ -33,10 +33,8 @@
                            )
 from bzrlib.remote import RemoteBranchFormat, RemoteBzrDirFormat
 from bzrlib.smart.server import (
+    SmartTCPServer_for_testing,
     ReadonlySmartTCPServer_for_testing,
-    ReadonlySmartTCPServer_for_testing_v2_only,
-    SmartTCPServer_for_testing,
-    SmartTCPServer_for_testing_v2_only,
     )
 from bzrlib.tests.bzrdir_implementations.test_bzrdir import TestCaseWithBzrDir
 from bzrlib.transport.memory import MemoryServer
@@ -52,10 +50,9 @@
     """
 
     def __init__(self, transport_server, transport_readonly_server, formats,
-        vfs_transport_factory=None, name_suffix=''):
+        vfs_transport_factory=None):
         self._transport_server = transport_server
         self._transport_readonly_server = transport_readonly_server
-        self._name_suffix = name_suffix
         self.scenarios = self.formats_to_scenarios(formats)
     
     def formats_to_scenarios(self, formats):
@@ -69,7 +66,6 @@
             # so we have a conditional here to handle them.
             scenario_name = getattr(branch_format, '__name__',
                 branch_format.__class__.__name__)
-            scenario_name += self._name_suffix
             scenario = (scenario_name, {
                 "transport_server":self._transport_server,
                 "transport_readonly_server":self._transport_readonly_server,
@@ -139,16 +135,12 @@
         return tree
 
 
-def load_tests(basic_tests, module, loader):
-    result = loader.suiteClass()
-    # add the tests for this module
-    result.addTests(basic_tests)
-
+def test_suite():
+    result = tests.TestSuite()
     test_branch_implementations = [
         'bzrlib.tests.branch_implementations.test_bound_sftp',
         'bzrlib.tests.branch_implementations.test_branch',
         'bzrlib.tests.branch_implementations.test_break_lock',
-        'bzrlib.tests.branch_implementations.test_check',
         'bzrlib.tests.branch_implementations.test_create_checkout',
         'bzrlib.tests.branch_implementations.test_commit',
         'bzrlib.tests.branch_implementations.test_get_revision_id_to_revno_map',
@@ -160,11 +152,9 @@
         'bzrlib.tests.branch_implementations.test_permissions',
         'bzrlib.tests.branch_implementations.test_pull',
         'bzrlib.tests.branch_implementations.test_push',
-        'bzrlib.tests.branch_implementations.test_reconcile',
         'bzrlib.tests.branch_implementations.test_revision_history',
         'bzrlib.tests.branch_implementations.test_revision_id_to_revno',
         'bzrlib.tests.branch_implementations.test_sprout',
-        'bzrlib.tests.branch_implementations.test_stacking',
         'bzrlib.tests.branch_implementations.test_tags',
         'bzrlib.tests.branch_implementations.test_uncommit',
         'bzrlib.tests.branch_implementations.test_update',
@@ -180,29 +170,15 @@
         # by the TestCaseWithTransport.get_readonly_transport method.
         None,
         combinations)
-    # add the tests for the sub modules
+    loader = tests.TestLoader()
     tests.adapt_modules(test_branch_implementations, adapter, loader, result)
 
-    # Add RemoteBranch tests, which need a special server.
     adapt_to_smart_server = BranchTestProviderAdapter(
         SmartTCPServer_for_testing,
         ReadonlySmartTCPServer_for_testing,
         [(RemoteBranchFormat(), RemoteBzrDirFormat())],
-        MemoryServer,
-        name_suffix='-default')
-    tests.adapt_modules(test_branch_implementations,
-                        adapt_to_smart_server,
-                        loader,
-                        result)
-
-    # Also add tests for RemoteBranch with HPSS protocol v2 (i.e. bzr <1.6)
-    # server.
-    adapt_to_smart_server = BranchTestProviderAdapter(
-        SmartTCPServer_for_testing_v2_only,
-        ReadonlySmartTCPServer_for_testing_v2_only,
-        [(RemoteBranchFormat(), RemoteBzrDirFormat())],
-        MemoryServer,
-        name_suffix='-v2')
+        MemoryServer
+        )
     tests.adapt_modules(test_branch_implementations,
                         adapt_to_smart_server,
                         loader,

=== modified file 'bzrlib/tests/branch_implementations/test_branch.py'
--- bzrlib/tests/branch_implementations/test_branch.py	2008-06-25 10:06:48 +0000
+++ bzrlib/tests/branch_implementations/test_branch.py	2007-10-16 16:02:01 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2008 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -28,7 +28,6 @@
     transactions,
     remote,
     repository,
-    tests,
     )
 from bzrlib.branch import Branch, needs_read_lock, needs_write_lock
 from bzrlib.delta import TreeDelta
@@ -40,27 +39,25 @@
                            )
 from bzrlib.osutils import getcwd
 import bzrlib.revision
-from bzrlib.symbol_versioning import deprecated_in
 from bzrlib.tests import TestCase, TestCaseWithTransport, TestSkipped
 from bzrlib.tests.branch_implementations import TestCaseWithBranch
-from bzrlib.tests.http_server import HttpServer
+from bzrlib.tests.HttpServer import HttpServer
 from bzrlib.trace import mutter
 from bzrlib.transport import get_transport
 from bzrlib.transport.memory import MemoryServer
 from bzrlib.upgrade import upgrade
 from bzrlib.workingtree import WorkingTree
+from bzrlib.symbol_versioning import (
+    zero_ninetyone,
+    )
 
 
 class TestBranch(TestCaseWithBranch):
 
     def test_create_tree_with_merge(self):
         tree = self.create_tree_with_merge()
-        tree.lock_read()
-        self.addCleanup(tree.unlock)
-        graph = tree.branch.repository.get_graph()
-        ancestry_graph = graph.get_parent_map(
-            tree.branch.repository.all_revision_ids())
-        self.assertEqual({'rev-1':('null:',),
+        ancestry_graph = tree.branch.repository.get_revision_graph('rev-3')
+        self.assertEqual({'rev-1':(),
                           'rev-2':('rev-1', ),
                           'rev-1.1.1':('rev-1', ),
                           'rev-3':('rev-2', 'rev-1.1.1', ),
@@ -100,8 +97,6 @@
 
         rev = b2.repository.get_revision('revision-1')
         tree = b2.repository.revision_tree('revision-1')
-        tree.lock_read()
-        self.addCleanup(tree.unlock)
         self.assertEqual(tree.get_file_text('foo-id'), 'hello')
 
     def test_get_revision_delta(self):
@@ -166,13 +161,13 @@
         wt_a.add(['one'])
         wt_a.commit('commit one', rev_id='1')
 
-        branch_b = wt_a.branch.bzrdir.sprout('b', revision_id='1').open_branch()
+        branch_b = wt_a.bzrdir.sprout('b', revision_id='1').open_branch()
         self.assertEqual(wt_a.branch.base, branch_b.get_parent())
         return branch_b
 
     def test_clone_branch_nickname(self):
         # test the nick name is preserved always
-        raise TestSkipped('XXX branch cloning is not yet tested.')
+        raise TestSkipped('XXX branch cloning is not yet tested..')
 
     def test_clone_branch_parent(self):
         # test the parent is preserved always
@@ -216,8 +211,6 @@
         wt = self.make_branch_and_tree('.')
         wt.set_parent_ids(['non:existent@rev--ision--0--2'],
             allow_leftmost_as_ghost=True)
-        self.assertEqual(['non:existent@rev--ision--0--2'],
-            wt.get_parent_ids())
         rev_id = wt.commit('commit against a ghost first parent.')
         rev = wt.branch.repository.get_revision(rev_id)
         self.assertEqual(rev.parent_ids, ['non:existent@rev--ision--0--2'])
@@ -269,20 +262,8 @@
     def test_store_signature(self):
         wt = self.make_branch_and_tree('.')
         branch = wt.branch
-        branch.lock_write()
-        try:
-            branch.repository.start_write_group()
-            try:
-                branch.repository.store_revision_signature(
-                    gpg.LoopbackGPGStrategy(None), 'FOO', 'A')
-            except:
-                branch.repository.abort_write_group()
-                raise
-            else:
-                branch.repository.commit_write_group()
-        finally:
-            branch.unlock()
-        # A signature without a revision should not be accessible.
+        branch.repository.store_revision_signature(
+            gpg.LoopbackGPGStrategy(None), 'FOO', 'A')
         self.assertRaises(errors.NoSuchRevision,
                           branch.repository.has_signature_for_revision_id,
                           'A')
@@ -307,36 +288,6 @@
         self.assertEqual(repo.get_signature_text('A'),
                          d2.open_repository().get_signature_text('A'))
 
-    def test_missing_revisions(self):
-        t1 = self.make_branch_and_tree('b1')
-        rev1 = t1.commit('one')
-        t2 = t1.bzrdir.sprout('b2').open_workingtree()
-        rev2 = t1.commit('two')
-        rev3 = t1.commit('three')
-
-        self.assertEqual([rev2, rev3],
-            self.applyDeprecated(deprecated_in((1, 6, 0)),
-            t2.branch.missing_revisions, t1.branch))
-
-        self.assertEqual([],
-            self.applyDeprecated(deprecated_in((1, 6, 0)),
-            t2.branch.missing_revisions, t1.branch, stop_revision=1))
-        self.assertEqual([rev2],
-            self.applyDeprecated(deprecated_in((1, 6, 0)),
-            t2.branch.missing_revisions, t1.branch, stop_revision=2))
-        self.assertEqual([rev2, rev3],
-            self.applyDeprecated(deprecated_in((1, 6, 0)),
-            t2.branch.missing_revisions, t1.branch, stop_revision=3))
-
-        self.assertRaises(errors.NoSuchRevision,
-            self.applyDeprecated, deprecated_in((1, 6, 0)),
-            t2.branch.missing_revisions, t1.branch, stop_revision=4)
-
-        rev4 = t2.commit('four')
-        self.assertRaises(errors.DivergedBranches,
-            self.applyDeprecated, deprecated_in((1, 6, 0)),
-            t2.branch.missing_revisions, t1.branch)
-
     def test_nicks(self):
         """Test explicit and implicit branch nicknames.
         
@@ -356,8 +307,10 @@
         # Set the branch nick explicitly.  This will ensure there's a branch
         # config file in the branch.
         branch.nick = "Aaron's branch"
+        branch.nick = "Aaron's branch"
         if not isinstance(branch, remote.RemoteBranch):
-            self.failUnless(branch._transport.has("branch.conf"))
+            controlfilename = branch.control_files.controlfilename
+            self.failUnless(t.has(t.relpath(controlfilename("branch.conf"))))
         # Because the nick has been set explicitly, the nick is now always
         # "Aaron's branch", regardless of directory name.
         self.assertEqual(branch.nick, "Aaron's branch")
@@ -401,6 +354,14 @@
         text = tree.branch._format.get_format_description()
         self.failUnless(len(text))
 
+    def test_check_branch_report_results(self):
+        """Checking a branch produces results which can be printed"""
+        branch = self.make_branch('.')
+        result = branch.check()
+        # reports results through logging
+        result.report_results(verbose=True)
+        result.report_results(verbose=False)
+
     def test_get_commit_builder(self):
         branch = self.make_branch(".")
         branch.lock_write()
@@ -603,24 +564,6 @@
         self.assertEqual(None,
             made_branch._format.get_reference(made_branch.bzrdir))
 
-    def test_set_reference(self):
-        """set_reference on all regular branches should be callable."""
-        if not self.branch_format.is_supported():
-            # unsupported formats are not loopback testable
-            # because the default open will not open them and
-            # they may not be initializable.
-            return
-        this_branch = self.make_branch('this')
-        other_branch = self.make_branch('other')
-        try:
-            this_branch._format.set_reference(this_branch.bzrdir, other_branch)
-        except NotImplementedError:
-            # that's ok
-            pass
-        else:
-            ref = this_branch._format.get_reference(this_branch.bzrdir)
-            self.assertEqual(ref, other_branch.base)
-
     def test_format_initialize_find_open(self):
         # loopback test to check the current format initializes to itself.
         if not self.branch_format.is_supported():
@@ -664,7 +607,7 @@
         try:
             branch.bind(branch2)
         except errors.UpgradeRequired:
-            raise tests.TestNotApplicable('Format does not support binding')
+            raise TestSkipped('Format does not support binding')
         self.assertTrue(branch.unbind())
         self.assertFalse(branch.unbind())
         self.assertIs(None, branch.get_bound_location())
@@ -674,25 +617,13 @@
         try:
             self.assertIs(None, branch.get_old_bound_location())
         except errors.UpgradeRequired:
-            raise tests.TestNotApplicable(
-                    'Format does not store old bound locations')
+            raise TestSkipped('Format does not store old bound locations')
         branch2 = self.make_branch('branch2')
         branch.bind(branch2)
         self.assertIs(None, branch.get_old_bound_location())
         branch.unbind()
         self.assertContainsRe(branch.get_old_bound_location(), '\/branch2\/$')
 
-    def test_bind_diverged(self):
-        tree_a = self.make_branch_and_tree('tree_a')
-        tree_a.commit('rev1a')
-        tree_b = tree_a.bzrdir.sprout('tree_b').open_workingtree()
-        tree_a.commit('rev2a')
-        tree_b.commit('rev2b')
-        try:
-            tree_b.branch.bind(tree_a.branch)
-        except errors.UpgradeRequired:
-            raise tests.TestNotApplicable('Format does not support binding')
-
 
 class TestStrict(TestCaseWithBranch):
 

=== modified file 'bzrlib/tests/branch_implementations/test_break_lock.py'
--- bzrlib/tests/branch_implementations/test_break_lock.py	2007-11-26 02:03:03 +0000
+++ bzrlib/tests/branch_implementations/test_break_lock.py	2006-10-05 05:37:25 +0000
@@ -20,7 +20,7 @@
 
 import bzrlib
 import bzrlib.errors as errors
-from bzrlib.tests import TestCase, TestCaseWithTransport, TestNotApplicable
+from bzrlib.tests import TestCase, TestCaseWithTransport, TestSkipped
 from bzrlib.tests.branch_implementations.test_branch import TestCaseWithBranch
 
 
@@ -51,9 +51,6 @@
         # break lock on the branch should try on the repository even
         # if the branch isn't locked
         self.branch.repository.lock_write()
-        other_instance = self.branch.repository.bzrdir.open_repository()
-        if not other_instance.get_physical_lock_status():
-            raise TestNotApplicable("Repository does not lock persistently.")
         bzrlib.ui.ui_factory.stdin = StringIO("y\n")
         try:
             self.unused_branch.break_lock()

=== removed file 'bzrlib/tests/branch_implementations/test_check.py'
--- bzrlib/tests/branch_implementations/test_check.py	2008-06-11 07:52:25 +0000
+++ bzrlib/tests/branch_implementations/test_check.py	1970-01-01 00:00:00 +0000
@@ -1,70 +0,0 @@
-# Copyright (C) 2008 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Tests for branch implementations - test check() functionality"""
-
-from bzrlib import errors
-from bzrlib.tests.branch_implementations import TestCaseWithBranch
-
-
-class TestBranchCheck(TestCaseWithBranch):
-
-    def test_check_detects_invalid_revhistory(self):
-        # Different formats have different ways of handling invalid revision
-        # histories, so the setup portion is customized
-        tree = self.make_branch_and_tree('test')
-        r1 = tree.commit('one')
-        r2 = tree.commit('two')
-        r3 = tree.commit('three')
-        r4 = tree.commit('four')
-        # create an alternate branch
-        tree.set_parent_ids([r1])
-        tree.branch.set_last_revision_info(1, r1)
-        r2b = tree.commit('two-b')
-
-        # now go back and merge the commit
-        tree.set_parent_ids([r4, r2b])
-        tree.branch.set_last_revision_info(4, r4)
-
-        r5 = tree.commit('five')
-        # Now, try to set an invalid history
-        try:
-            tree.branch.set_revision_history([r1, r2b, r5])
-            if tree.branch.last_revision_info() != (3, r5):
-                # RemoteBranch silently corrects an impossible revision
-                # history given to set_revision_history.  It can be tricked
-                # with set_last_revision_info though.
-                tree.branch.set_last_revision_info(3, r5)
-        except errors.NotLefthandHistory:
-            # Branch5 allows set_revision_history to be wrong
-            # Branch6 raises NotLefthandHistory, but we can force bogus stuff
-            # with set_last_revision_info
-            tree.branch.set_last_revision_info(3, r5)
-
-        e = self.assertRaises(errors.BzrCheckError,
-                              tree.branch.check)
-        self.assertEqual('Internal check failed:'
-                         ' revno does not match len(mainline) 3 != 5', str(e))
-
-    def test_check_branch_report_results(self):
-        """Checking a branch produces results which can be printed"""
-        branch = self.make_branch('.')
-        result = branch.check()
-        # reports results through logging
-        result.report_results(verbose=True)
-        result.report_results(verbose=False)
-
-

=== modified file 'bzrlib/tests/branch_implementations/test_commit.py'
--- bzrlib/tests/branch_implementations/test_commit.py	2008-06-03 04:33:18 +0000
+++ bzrlib/tests/branch_implementations/test_commit.py	2007-09-03 12:32:14 +0000
@@ -68,8 +68,8 @@
 
     def test_post_commit_to_origin(self):
         tree = self.make_branch_and_memory_tree('branch')
-        Branch.hooks.install_named_hook('post_commit',
-            self.capture_post_commit_hook, None)
+        Branch.hooks.install_hook('post_commit',
+            self.capture_post_commit_hook)
         tree.lock_write()
         tree.add('')
         revid = tree.commit('a revision')
@@ -90,8 +90,8 @@
         except errors.UpgradeRequired:
             # cant bind this format, the test is irrelevant.
             return
-        Branch.hooks.install_named_hook('post_commit',
-            self.capture_post_commit_hook, None)
+        Branch.hooks.install_hook('post_commit',
+            self.capture_post_commit_hook)
         tree.lock_write()
         tree.add('')
         revid = tree.commit('a revision')
@@ -108,8 +108,8 @@
         tree.lock_write()
         tree.add('')
         revid = tree.commit('first revision')
-        Branch.hooks.install_named_hook('post_commit',
-            self.capture_post_commit_hook, None)
+        Branch.hooks.install_hook('post_commit',
+            self.capture_post_commit_hook)
         revid2 = tree.commit('second revision')
         # having committed from up the branch, we should get the
         # before and after revnos and revids correctly.
@@ -123,12 +123,11 @@
     def test_pre_commit_passes(self):
         empty_delta = TreeDelta()
         root_delta = TreeDelta()
+        root_delta.added = [('', '', 'directory')]
         tree = self.make_branch_and_memory_tree('branch')
         tree.lock_write()
-        tree.add('')
-        root_delta.added = [('', tree.path2id(''), 'directory')]
-        Branch.hooks.install_named_hook("pre_commit",
-            self.capture_pre_commit_hook, None)
+        tree.add('', '')
+        Branch.hooks.install_hook("pre_commit", self.capture_pre_commit_hook)
         revid1 = tree.commit('first revision')
         revid2 = tree.commit('second revision')
         self.assertEqual([
@@ -141,18 +140,17 @@
     def test_pre_commit_fails(self):
         empty_delta = TreeDelta()
         root_delta = TreeDelta()
+        root_delta.added = [('', '', 'directory')]
         tree = self.make_branch_and_memory_tree('branch')
         tree.lock_write()
-        tree.add('')
-        root_delta.added = [('', tree.path2id(''), 'directory')]
+        tree.add('', '')
         class PreCommitException(Exception): pass
         def hook_func(local, master,
                       old_revno, old_revid, new_revno, new_revid,
                       tree_delta, future_tree):
             raise PreCommitException(new_revid)
-        Branch.hooks.install_named_hook("pre_commit",
-            self.capture_pre_commit_hook, None)
-        Branch.hooks.install_named_hook("pre_commit", hook_func, None)
+        Branch.hooks.install_hook("pre_commit", self.capture_pre_commit_hook)
+        Branch.hooks.install_hook("pre_commit", hook_func)
         revids = [None, None, None]
         # this commit will raise an exception
         # so the commit is rolled back and revno unchanged
@@ -162,8 +160,7 @@
         # unregister all pre_commit hooks
         Branch.hooks["pre_commit"] = []
         # and re-register the capture hook
-        Branch.hooks.install_named_hook("pre_commit",
-            self.capture_pre_commit_hook, None)
+        Branch.hooks.install_hook("pre_commit", self.capture_pre_commit_hook)
         # now these commits should go through
         for i in range(1, 3):
             revids[i] = tree.commit('message')
@@ -202,8 +199,7 @@
             tree.unversion(['to_be_unversioned_id'])
             tree.mkdir('added_dir', 'added_dir_id')
             # start to capture pre_commit delta
-            Branch.hooks.install_named_hook("pre_commit",
-                self.capture_pre_commit_hook, None)
+            Branch.hooks.install_hook("pre_commit", self.capture_pre_commit_hook)
             revid2 = tree.commit('second revision')
         finally:
             tree.unlock()

=== modified file 'bzrlib/tests/branch_implementations/test_create_checkout.py'
--- bzrlib/tests/branch_implementations/test_create_checkout.py	2007-11-29 07:12:42 +0000
+++ bzrlib/tests/branch_implementations/test_create_checkout.py	2007-03-29 04:08:16 +0000
@@ -26,12 +26,23 @@
 class TestCreateCheckout(TestCaseWithBranch):
 
     def test_checkout_format(self):
-        """Make sure the new checkout uses the desired branch format."""
+        """Make sure the new checkout uses the same branch format."""
         a_branch = self.make_branch('branch')
+        if isinstance(a_branch, RemoteBranch):
+            # RemoteBranch formats are not the same as local ones, and dont
+            # duplicate the format string (because there is no format string as
+            # such - it might be e.g. totally virtual on the server end).
+            # This test can only assess the checkout format correctness *in
+            # general* when there is a real object locally present for both the
+            # source and target.
+            return
         tree = a_branch.create_checkout('checkout')
-        # All branches can define the format they want checkouts made in.
-        # This checks it is honoured.
-        expected_format = a_branch._get_checkout_format().get_branch_format()
+        if self.branch_format in branch._legacy_formats:
+            # Legacy formats create checkouts with the default format.
+            # Only newer formats create identical checkouts.
+            expected_format = branch.BranchFormat.get_default_format()
+        else:
+            expected_format = a_branch._format
         self.assertEqual(expected_format.__class__,
                          tree.branch._format.__class__)
 
@@ -60,5 +71,5 @@
     def test_create_checkout_exists(self):
         """We shouldn't fail if the directory already exists."""
         tree1 = self.make_branch_and_tree('base')
-        self.build_tree(['checkout/'])
+        self.build_tree('checkout')
         tree2 = tree1.branch.create_checkout('checkout', lightweight=True)

=== modified file 'bzrlib/tests/branch_implementations/test_get_revision_id_to_revno_map.py'
--- bzrlib/tests/branch_implementations/test_get_revision_id_to_revno_map.py	2007-11-13 20:37:09 +0000
+++ bzrlib/tests/branch_implementations/test_get_revision_id_to_revno_map.py	2007-04-24 19:43:09 +0000
@@ -28,13 +28,11 @@
 
     def test_simple_revno(self):
         tree = self.create_tree_with_merge()
-        # Re-open the branch so we make sure we start fresh.
-        # see bug #162486
-        the_branch = tree.bzrdir.open_branch()
+        the_branch = tree.branch
 
         self.assertEqual({'rev-1':(1,), 'rev-2':(2,), 'rev-3':(3,),
                           'rev-1.1.1':(1,1,1)
-                         }, the_branch.get_revision_id_to_revno_map())
+                         }, tree.branch.get_revision_id_to_revno_map())
 
 
 class TestCaching(TestCaseWithBranch):

=== modified file 'bzrlib/tests/branch_implementations/test_hooks.py'
--- bzrlib/tests/branch_implementations/test_hooks.py	2008-07-25 06:42:08 +0000
+++ bzrlib/tests/branch_implementations/test_hooks.py	2007-08-14 11:42:58 +0000
@@ -16,9 +16,7 @@
 
 """Tests that branch classes implement hook callouts correctly."""
 
-from bzrlib.errors import HookFailed, TipChangeRejected
-from bzrlib.branch import Branch, ChangeBranchTipParams
-from bzrlib.revision import NULL_REVISION
+from bzrlib.branch import Branch
 from bzrlib.tests import TestCaseWithMemoryTransport
 
 
@@ -38,8 +36,7 @@
 
     def test_set_rh_empty_history(self):
         branch = self.make_branch('source')
-        Branch.hooks.install_named_hook('set_rh', self.capture_set_rh_hook,
-                                        None)
+        Branch.hooks.install_hook('set_rh', self.capture_set_rh_hook)
         branch.set_revision_history([])
         self.assertEqual(self.hook_calls,
             [('set_rh', branch, [], True)])
@@ -52,8 +49,7 @@
         tree.commit('empty commit', rev_id='foo')
         tree.unlock()
         branch = tree.branch
-        Branch.hooks.install_named_hook('set_rh', self.capture_set_rh_hook,
-                                        None)
+        Branch.hooks.install_hook('set_rh', self.capture_set_rh_hook)
         # some branches require that their history be set to a revision in the
         # repository
         branch.set_revision_history(['f\xc2\xb5'])
@@ -62,256 +58,17 @@
 
     def test_set_rh_branch_is_locked(self):
         branch = self.make_branch('source')
-        Branch.hooks.install_named_hook('set_rh', self.capture_set_rh_hook,
-                                        None)
+        Branch.hooks.install_hook('set_rh', self.capture_set_rh_hook)
         branch.set_revision_history([])
         self.assertEqual(self.hook_calls,
             [('set_rh', branch, [], True)])
 
     def test_set_rh_calls_all_hooks_no_errors(self):
         branch = self.make_branch('source')
-        Branch.hooks.install_named_hook('set_rh', self.capture_set_rh_hook,
-                                        None)
-        Branch.hooks.install_named_hook('set_rh', self.capture_set_rh_hook,
-                                        None)
+        Branch.hooks.install_hook('set_rh', self.capture_set_rh_hook)
+        Branch.hooks.install_hook('set_rh', self.capture_set_rh_hook)
         branch.set_revision_history([])
         self.assertEqual(self.hook_calls,
             [('set_rh', branch, [], True),
              ('set_rh', branch, [], True),
             ])
-
-
-class ChangeBranchTipTestCase(TestCaseWithMemoryTransport):
-    """Base TestCase for testing pre/post_change_branch_tip hooks."""
-
-    def install_logging_hook(self, prefix):
-        """Add a hook that logs calls made to it.
-        
-        :returns: the list that the calls will be appended to.
-        """
-        hook_calls = []
-        Branch.hooks.install_named_hook(
-            prefix + '_change_branch_tip', hook_calls.append, None)
-        return hook_calls
-
-    def make_branch_with_revision_ids(self, *revision_ids):
-        """Makes a branch with the given commits."""
-        tree = self.make_branch_and_memory_tree('source')
-        tree.lock_write()
-        tree.add('')
-        for revision_id in revision_ids:
-            tree.commit(u'Message of ' + revision_id.decode('utf8'),
-                        rev_id=revision_id)
-        tree.unlock()
-        branch = tree.branch
-        return branch
-
-
-class TestPreChangeBranchTip(ChangeBranchTipTestCase):
-    """Tests for pre_change_branch_tip hook.
-    
-    Most of these tests are very similar to the tests in
-    TestPostChangeBranchTip.
-    """
-
-    def test_hook_runs_before_change(self):
-        """The hook runs *before* the branch's last_revision_info has changed.
-        """
-        branch = self.make_branch_with_revision_ids('revid-one')
-        def assertBranchAtRevision1(params):
-            self.assertEquals(
-                (1, 'revid-one'), params.branch.last_revision_info())
-        Branch.hooks.install_named_hook(
-            'pre_change_branch_tip', assertBranchAtRevision1, None)
-        branch.set_last_revision_info(0, NULL_REVISION)
-
-    def test_hook_failure_prevents_change(self):
-        """If a hook raises an exception, the change does not take effect.
-        
-        Also, a HookFailed exception will be raised.
-        """
-        branch = self.make_branch_with_revision_ids(
-            'one-\xc2\xb5', 'two-\xc2\xb5')
-        class PearShapedError(Exception):
-            pass
-        def hook_that_raises(params):
-            raise PearShapedError()
-        Branch.hooks.install_named_hook(
-            'pre_change_branch_tip', hook_that_raises, None)
-        hook_failed_exc = self.assertRaises(
-            HookFailed, branch.set_last_revision_info, 0, NULL_REVISION)
-        self.assertIsInstance(hook_failed_exc.exc_value, PearShapedError)
-        # The revision info is unchanged.
-        self.assertEqual((2, 'two-\xc2\xb5'), branch.last_revision_info())
-        
-    def test_empty_history(self):
-        branch = self.make_branch('source')
-        hook_calls = self.install_logging_hook('pre')
-        branch.set_last_revision_info(0, NULL_REVISION)
-        expected_params = ChangeBranchTipParams(
-            branch, 0, 0, NULL_REVISION, NULL_REVISION)
-        self.assertEqual([expected_params], hook_calls)
-
-    def test_nonempty_history(self):
-        # some branches require that their history be set to a revision in the
-        # repository, so we need to make a branch with non-empty history for
-        # this test.
-        branch = self.make_branch_with_revision_ids(
-            'one-\xc2\xb5', 'two-\xc2\xb5')
-        hook_calls = self.install_logging_hook('pre')
-        branch.set_last_revision_info(1, 'one-\xc2\xb5')
-        expected_params = ChangeBranchTipParams(
-            branch, 2, 1, 'two-\xc2\xb5', 'one-\xc2\xb5')
-        self.assertEqual([expected_params], hook_calls)
-
-    def test_branch_is_locked(self):
-        branch = self.make_branch('source')
-        def assertBranchIsLocked(params):
-            self.assertTrue(params.branch.is_locked())
-        Branch.hooks.install_named_hook(
-            'pre_change_branch_tip', assertBranchIsLocked, None)
-        branch.set_last_revision_info(0, NULL_REVISION)
-
-    def test_calls_all_hooks_no_errors(self):
-        """If multiple hooks are registered, all are called (if none raise
-        errors).
-        """
-        branch = self.make_branch('source')
-        hook_calls_1 = self.install_logging_hook('pre')
-        hook_calls_2 = self.install_logging_hook('pre')
-        self.assertIsNot(hook_calls_1, hook_calls_2)
-        branch.set_last_revision_info(0, NULL_REVISION)
-        # Both hooks are called.
-        self.assertEqual(len(hook_calls_1), 1)
-        self.assertEqual(len(hook_calls_2), 1)
-
-    def test_explicit_reject_by_hook(self):
-        """If a hook raises TipChangeRejected, the change does not take effect.
-        
-        TipChangeRejected exceptions are propagated, not wrapped in HookFailed.
-        """
-        branch = self.make_branch_with_revision_ids(
-            'one-\xc2\xb5', 'two-\xc2\xb5')
-        def hook_that_rejects(params):
-            raise TipChangeRejected('rejection message')
-        Branch.hooks.install_named_hook(
-            'pre_change_branch_tip', hook_that_rejects, None)
-        self.assertRaises(
-            TipChangeRejected, branch.set_last_revision_info, 0, NULL_REVISION)
-        # The revision info is unchanged.
-        self.assertEqual((2, 'two-\xc2\xb5'), branch.last_revision_info())
-        
-
-class TestPostChangeBranchTip(ChangeBranchTipTestCase):
-    """Tests for post_change_branch_tip hook.
-
-    Most of these tests are very similar to the tests in
-    TestPostChangeBranchTip.
-    """
-
-    def test_hook_runs_after_change(self):
-        """The hook runs *after* the branch's last_revision_info has changed.
-        """
-        branch = self.make_branch_with_revision_ids('revid-one')
-        def assertBranchAtRevision1(params):
-            self.assertEquals(
-                (0, NULL_REVISION), params.branch.last_revision_info())
-        Branch.hooks.install_named_hook(
-            'post_change_branch_tip', assertBranchAtRevision1, None)
-        branch.set_last_revision_info(0, NULL_REVISION)
-
-    def test_empty_history(self):
-        branch = self.make_branch('source')
-        hook_calls = self.install_logging_hook('post')
-        branch.set_last_revision_info(0, NULL_REVISION)
-        expected_params = ChangeBranchTipParams(
-            branch, 0, 0, NULL_REVISION, NULL_REVISION)
-        self.assertEqual([expected_params], hook_calls)
-
-    def test_nonempty_history(self):
-        # some branches require that their history be set to a revision in the
-        # repository, so we need to make a branch with non-empty history for
-        # this test.
-        branch = self.make_branch_with_revision_ids(
-            'one-\xc2\xb5', 'two-\xc2\xb5')
-        hook_calls = self.install_logging_hook('post')
-        branch.set_last_revision_info(1, 'one-\xc2\xb5')
-        expected_params = ChangeBranchTipParams(
-            branch, 2, 1, 'two-\xc2\xb5', 'one-\xc2\xb5')
-        self.assertEqual([expected_params], hook_calls)
-
-    def test_branch_is_locked(self):
-        """The branch passed to the hook is locked."""
-        branch = self.make_branch('source')
-        def assertBranchIsLocked(params):
-            self.assertTrue(params.branch.is_locked())
-        Branch.hooks.install_named_hook(
-            'post_change_branch_tip', assertBranchIsLocked, None)
-        branch.set_last_revision_info(0, NULL_REVISION)
-
-    def test_calls_all_hooks_no_errors(self):
-        """If multiple hooks are registered, all are called (if none raise
-        errors).
-        """
-        branch = self.make_branch('source')
-        hook_calls_1 = self.install_logging_hook('post')
-        hook_calls_2 = self.install_logging_hook('post')
-        self.assertIsNot(hook_calls_1, hook_calls_2)
-        branch.set_last_revision_info(0, NULL_REVISION)
-        # Both hooks are called.
-        self.assertEqual(len(hook_calls_1), 1)
-        self.assertEqual(len(hook_calls_2), 1)
-
-
-class TestAllMethodsThatChangeTipWillRunHooks(ChangeBranchTipTestCase):
-    """Every method of Branch that changes a branch tip will invoke the
-    pre/post_change_branch_tip hooks.
-    """
-
-    def setUp(self):
-        ChangeBranchTipTestCase.setUp(self)
-        self.installPreAndPostHooks()
-        
-    def installPreAndPostHooks(self):
-        self.pre_hook_calls = self.install_logging_hook('pre')
-        self.post_hook_calls = self.install_logging_hook('post')
-
-    def resetHookCalls(self):
-        del self.pre_hook_calls[:], self.post_hook_calls[:]
-
-    def assertPreAndPostHooksWereInvoked(self):
-        # Check for len == 1, because the hooks should only be be invoked once
-        # by an operation.
-        self.assertEqual(1, len(self.pre_hook_calls))
-        self.assertEqual(1, len(self.post_hook_calls))
-
-    def test_set_revision_history(self):
-        branch = self.make_branch('')
-        branch.set_revision_history([])
-        self.assertPreAndPostHooksWereInvoked()
-
-    def test_set_last_revision_info(self):
-        branch = self.make_branch('')
-        branch.set_last_revision_info(0, NULL_REVISION)
-        self.assertPreAndPostHooksWereInvoked()
-
-    def test_generate_revision_history(self):
-        branch = self.make_branch('')
-        branch.generate_revision_history(NULL_REVISION)
-        self.assertPreAndPostHooksWereInvoked()
-
-    def test_pull(self):
-        source_branch = self.make_branch_with_revision_ids('rev-1', 'rev-2')
-        self.resetHookCalls()
-        destination_branch = self.make_branch('destination')
-        destination_branch.pull(source_branch)
-        self.assertPreAndPostHooksWereInvoked()
-
-    def test_push(self):
-        source_branch = self.make_branch_with_revision_ids('rev-1', 'rev-2')
-        self.resetHookCalls()
-        destination_branch = self.make_branch('destination')
-        source_branch.push(destination_branch)
-        self.assertPreAndPostHooksWereInvoked()
-
-        

=== modified file 'bzrlib/tests/branch_implementations/test_http.py'
--- bzrlib/tests/branch_implementations/test_http.py	2007-12-11 14:26:18 +0000
+++ bzrlib/tests/branch_implementations/test_http.py	2007-03-28 07:48:37 +0000
@@ -20,7 +20,7 @@
 
 from bzrlib import branch, errors
 from bzrlib.tests.branch_implementations.test_branch import TestCaseWithBranch
-from bzrlib.tests.http_server import HttpServer
+from bzrlib.tests.HttpServer import HttpServer
 from bzrlib.transport.local import LocalURLServer
 from bzrlib.transport.chroot import TestingChrootServer
 

=== modified file 'bzrlib/tests/branch_implementations/test_locking.py'
--- bzrlib/tests/branch_implementations/test_locking.py	2007-11-26 20:30:08 +0000
+++ bzrlib/tests/branch_implementations/test_locking.py	2007-04-18 05:10:19 +0000
@@ -42,21 +42,17 @@
         bcf = b.control_files
         rcf = getattr(b.repository, 'control_files', None)
         if rcf is None:
-            self.combined_branch = False
-        else:
-            # Look out for branch types that reuse their control files
-            self.combined_control = bcf is rcf
-        try:
-            b.control_files = LockWrapper(self.locks, b.control_files, 'bc')
-        except AttributeError:
-            # RemoteBranch seems to trigger this.
-            raise TestSkipped("Could not instrument branch control files.")
-        if self.combined_control:
-            # instrument the repository control files too to ensure its worked
-            # with correctly. When they are not shared, we trust the repository
-            # API and only instrument the repository itself. 
-            b.repository.control_files = \
-                LockWrapper(self.locks, b.repository.control_files, 'rc')
+            raise TestSkipped(
+                "This tests depends on being able to instrument "
+                "repository.control_files, but %r doesn't have control_files."
+                % (b.repository,))
+
+        # Look out for branch types that reuse their control files
+        self.combined_control = bcf is rcf
+
+        b.control_files = LockWrapper(self.locks, b.control_files, 'bc')
+        b.repository.control_files = \
+            LockWrapper(self.locks, b.repository.control_files, 'rc')
         return b
 
     def test_01_lock_read(self):
@@ -74,24 +70,15 @@
         self.assertFalse(b.is_locked())
         self.assertFalse(b.repository.is_locked())
 
-        if self.combined_control:
-            self.assertEqual([('b', 'lr', True),
-                              ('r', 'lr', True),
-                              ('rc', 'lr', True),
-                              ('bc', 'lr', True),
-                              ('b', 'ul', True),
-                              ('bc', 'ul', True),
-                              ('r', 'ul', True),
-                              ('rc', 'ul', True),
-                             ], self.locks)
-        else:
-            self.assertEqual([('b', 'lr', True),
-                              ('r', 'lr', True),
-                              ('bc', 'lr', True),
-                              ('b', 'ul', True),
-                              ('bc', 'ul', True),
-                              ('r', 'ul', True),
-                             ], self.locks)
+        self.assertEqual([('b', 'lr', True),
+                          ('r', 'lr', True),
+                          ('rc', 'lr', True),
+                          ('bc', 'lr', True),
+                          ('b', 'ul', True),
+                          ('bc', 'ul', True),
+                          ('r', 'ul', True),
+                          ('rc', 'ul', True),
+                         ], self.locks)
 
     def test_02_lock_write(self):
         # Test that locking occurs in the correct order
@@ -108,24 +95,15 @@
         self.assertFalse(b.is_locked())
         self.assertFalse(b.repository.is_locked())
 
-        if self.combined_control:
-            self.assertEqual([('b', 'lw', True),
-                              ('r', 'lw', True),
-                              ('rc', 'lw', True),
-                              ('bc', 'lw', True),
-                              ('b', 'ul', True),
-                              ('bc', 'ul', True),
-                              ('r', 'ul', True),
-                              ('rc', 'ul', True),
-                             ], self.locks)
-        else:
-            self.assertEqual([('b', 'lw', True),
-                              ('r', 'lw', True),
-                              ('bc', 'lw', True),
-                              ('b', 'ul', True),
-                              ('bc', 'ul', True),
-                              ('r', 'ul', True),
-                             ], self.locks)
+        self.assertEqual([('b', 'lw', True),
+                          ('r', 'lw', True),
+                          ('rc', 'lw', True),
+                          ('bc', 'lw', True),
+                          ('b', 'ul', True),
+                          ('bc', 'ul', True),
+                          ('r', 'ul', True),
+                          ('rc', 'ul', True),
+                         ], self.locks)
 
     def test_03_lock_fail_unlock_repo(self):
         # Make sure branch.unlock() is called, even if there is a
@@ -148,23 +126,14 @@
 
             # We unlock the branch control files, even if 
             # we fail to unlock the repository
-            if self.combined_control:
-                self.assertEqual([('b', 'lw', True),
-                                  ('r', 'lw', True),
-                                  ('rc', 'lw', True),
-                                  ('bc', 'lw', True),
-                                  ('b', 'ul', True),
-                                  ('bc', 'ul', True),
-                                  ('r', 'ul', False),
-                                 ], self.locks)
-            else:
-                self.assertEqual([('b', 'lw', True),
-                                  ('r', 'lw', True),
-                                  ('bc', 'lw', True),
-                                  ('b', 'ul', True),
-                                  ('bc', 'ul', True),
-                                  ('r', 'ul', False),
-                                 ], self.locks)
+            self.assertEqual([('b', 'lw', True),
+                              ('r', 'lw', True),
+                              ('rc', 'lw', True),
+                              ('bc', 'lw', True),
+                              ('b', 'ul', True),
+                              ('bc', 'ul', True),
+                              ('r', 'ul', False), 
+                             ], self.locks)
 
         finally:
             # For cleanup purposes, make sure we are unlocked
@@ -190,24 +159,15 @@
 
             # We unlock the repository even if 
             # we fail to unlock the control files
-            if self.combined_control:
-                self.assertEqual([('b', 'lw', True),
-                                  ('r', 'lw', True),
-                                  ('rc', 'lw', True),
-                                  ('bc', 'lw', True),
-                                  ('b', 'ul', True),
-                                  ('bc', 'ul', False),
-                                  ('r', 'ul', True),
-                                  ('rc', 'ul', True),
-                                 ], self.locks)
-            else:
-                self.assertEqual([('b', 'lw', True),
-                                  ('r', 'lw', True),
-                                  ('bc', 'lw', True),
-                                  ('b', 'ul', True),
-                                  ('bc', 'ul', False),
-                                  ('r', 'ul', True),
-                                 ], self.locks)
+            self.assertEqual([('b', 'lw', True),
+                              ('r', 'lw', True),
+                              ('rc', 'lw', True),
+                              ('bc', 'lw', True),
+                              ('b', 'ul', True),
+                              ('bc', 'ul', False),
+                              ('r', 'ul', True), 
+                              ('rc', 'ul', True), 
+                             ], self.locks)
 
         finally:
             # For cleanup purposes, make sure we are unlocked
@@ -248,20 +208,13 @@
         self.assertFalse(b.is_locked())
         self.assertFalse(b.repository.is_locked())
 
-        if self.combined_control:
-            self.assertEqual([('b', 'lr', True),
-                              ('r', 'lr', True),
-                              ('rc', 'lr', True),
-                              ('bc', 'lr', False),
-                              ('r', 'ul', True),
-                              ('rc', 'ul', True),
-                             ], self.locks)
-        else:
-            self.assertEqual([('b', 'lr', True),
-                              ('r', 'lr', True),
-                              ('bc', 'lr', False),
-                              ('r', 'ul', True),
-                             ], self.locks)
+        self.assertEqual([('b', 'lr', True),
+                          ('r', 'lr', True),
+                          ('rc', 'lr', True),
+                          ('bc', 'lr', False),
+                          ('r', 'ul', True),
+                          ('rc', 'ul', True),
+                         ], self.locks)
 
     def test_08_lock_write_fail_control(self):
         # Test the repository is unlocked if we can't lock self
@@ -271,20 +224,14 @@
         self.assertRaises(TestPreventLocking, b.lock_write)
         self.assertFalse(b.is_locked())
         self.assertFalse(b.repository.is_locked())
-        if self.combined_control:
-            self.assertEqual([('b', 'lw', True),
-                              ('r', 'lw', True),
-                              ('rc', 'lw', True),
-                              ('bc', 'lw', False),
-                              ('r', 'ul', True),
-                              ('rc', 'ul', True),
-                             ], self.locks)
-        else:
-            self.assertEqual([('b', 'lw', True),
-                              ('r', 'lw', True),
-                              ('bc', 'lw', False),
-                              ('r', 'ul', True),
-                             ], self.locks)
+
+        self.assertEqual([('b', 'lw', True),
+                          ('r', 'lw', True),
+                          ('rc', 'lw', True),
+                          ('bc', 'lw', False),
+                          ('r', 'ul', True),
+                          ('rc', 'ul', True),
+                         ], self.locks)
 
     def test_lock_write_returns_None_refuses_token(self):
         branch = self.make_branch('b')
@@ -451,33 +398,24 @@
             except NotImplementedError:
                 # This branch doesn't support this API.
                 return
-            try:
-                branch.repository.leave_lock_in_place()
-            except NotImplementedError:
-                # This repo doesn't support leaving locks around,
-                # assume it is essentially lock-free.
-                repo_token = None
-            else:
-                repo_token = branch.repository.lock_write()
-                branch.repository.unlock()
+            branch.repository.leave_lock_in_place()
+            repo_token = branch.repository.lock_write()
+            branch.repository.unlock()
         finally:
             branch.unlock()
         # Reacquire the lock (with a different branch object) by using the
         # tokens.
         new_branch = branch.bzrdir.open_branch()
-        if repo_token is not None:
-            # We have to explicitly lock the repository first.
-            new_branch.repository.lock_write(token=repo_token)
+        # We have to explicitly lock the repository first.
+        new_branch.repository.lock_write(token=repo_token)
         new_branch.lock_write(token=token)
-        if repo_token is not None:
-            # Now we don't need our own repository lock anymore (the branch is
-            # holding it for us).
-            new_branch.repository.unlock()
+        # Now we don't need our own repository lock anymore (the branch is
+        # holding it for us).
+        new_branch.repository.unlock()
         # Call dont_leave_lock_in_place, so that the lock will be released by
         # this instance, even though the lock wasn't originally acquired by it.
         new_branch.dont_leave_lock_in_place()
-        if repo_token is not None:
-            new_branch.repository.dont_leave_lock_in_place()
+        new_branch.repository.dont_leave_lock_in_place()
         new_branch.unlock()
         # Now the branch (and repository) is unlocked.  Test this by locking it
         # without tokens.
@@ -499,14 +437,8 @@
         branch = branch.bzrdir.open_branch()
         branch.lock_write()
         try:
-            # The branch should have asked the repository to lock.
-            self.assertTrue(branch.repository.is_write_locked())
-            # Does the repository type actually lock?
-            if not branch.repository.get_physical_lock_status():
-                # The test was successfully applied, so it was applicable.
-                return
-            # Now the branch.repository is physically locked, so we can't lock
-            # it with a new repository instance.
+            # Now the branch.repository is locked, so we can't lock it with a new
+            # repository without a token.
             new_repo = branch.bzrdir.open_repository()
             self.assertRaises(errors.LockContention, new_repo.lock_write)
             # We can call lock_write on the original repository object though,

=== modified file 'bzrlib/tests/branch_implementations/test_parent.py'
--- bzrlib/tests/branch_implementations/test_parent.py	2007-12-21 17:26:37 +0000
+++ bzrlib/tests/branch_implementations/test_parent.py	2007-04-18 05:38:31 +0000
@@ -19,11 +19,7 @@
 
 import bzrlib.errors
 from bzrlib.osutils import getcwd
-from bzrlib.tests import (
-    TestCaseWithTransport,
-    TestNotApplicable,
-    TestSkipped,
-    )
+from bzrlib.tests import TestCaseWithTransport
 from bzrlib import urlutils
 
 
@@ -88,16 +84,3 @@
         # With an invalid branch parent, just return None
         self.assertRaises(bzrlib.errors.InaccessibleParent, b.get_parent)
 
-    def test_win32_set_parent_on_another_drive(self):
-        if sys.platform != 'win32':
-            raise TestSkipped('windows-specific test')
-        b = self.make_branch('.')
-        base_url = b.abspath('.')
-        if not base_url.startswith('file:///'):
-            raise TestNotApplicable('this test should be run with local base')
-        base = urlutils.local_path_from_url(base_url)
-        other = 'file:///B:/path'
-        if base[0] != 'C':
-            other = 'file:///C:/path'
-        b.set_parent(other)
-        self.assertEquals(other, b._get_parent_location())

=== modified file 'bzrlib/tests/branch_implementations/test_permissions.py'
--- bzrlib/tests/branch_implementations/test_permissions.py	2008-08-31 19:19:08 +0000
+++ bzrlib/tests/branch_implementations/test_permissions.py	2007-03-16 03:20:17 +0000
@@ -1,4 +1,5 @@
-# Copyright (C) 2005, 2008 Canonical Ltd
+# Copyright (C) 2005 Canonical Ltd
+# -*- coding: utf-8 -*-
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -22,88 +23,46 @@
 So if the directory is group writable, the files and subdirs should be as well.
 """
 
-# TODO: jam 20051215 Currently the default behavior for 'bzr branch' is just
+# TODO: jam 20051215 Currently the default behavior for 'bzr branch' is just 
 #                    defined by the local umask. This isn't terrible, is it
 #                    the truly desired behavior?
-
+ 
 import os
 import sys
 import stat
 from StringIO import StringIO
 
-from bzrlib import tests
 from bzrlib.branch import Branch
 from bzrlib.bzrdir import BzrDir
 from bzrlib.lockable_files import LockableFiles
 from bzrlib.remote import RemoteBranchFormat
+from bzrlib.tests import TestCaseWithTransport, TestSkipped
 from bzrlib.tests.test_permissions import chmod_r, check_mode_r
 from bzrlib.tests.test_sftp_transport import TestCaseWithSFTPServer
 from bzrlib.transport import get_transport
 from bzrlib.workingtree import WorkingTree
 
 
-class _NullPermsStat(object):
-    """A class that proxy's a stat result and strips permissions."""
-
-    def __init__(self, orig_stat):
-        self._orig_stat = orig_stat
-        # We strip all permission bits from st_mode
-        self.st_mode = orig_stat.st_mode & ~07777
-
-    def __getattr__(self, name):
-        return getattr(self._orig_stat, name)
-
-
-class TestPermissions(tests.TestCaseWithTransport):
+class TestPermissions(TestCaseWithTransport):
 
     def test_new_branch(self):
         if isinstance(self.branch_format, RemoteBranchFormat):
             # Remote branch format have no permission logic in them; there's
             # nothing to test here.
-            raise tests.TestNotApplicable('Remote branches have no'
-                                          ' permission logic')
+            return
         if sys.platform == 'win32':
-            raise tests.TestNotApplicable('chmod has no effect on win32')
+            raise TestSkipped('chmod has no effect on win32')
         # also, these are BzrBranch format specific things..
         os.mkdir('a')
         mode = stat.S_IMODE(os.stat('a').st_mode)
         t = self.make_branch_and_tree('.')
         b = t.branch
-        self.assertEqualMode(mode, b.bzrdir._get_dir_mode())
-        self.assertEqualMode(mode & ~07111, b.bzrdir._get_file_mode())
         self.assertEqualMode(mode, b.control_files._dir_mode)
         self.assertEqualMode(mode & ~07111, b.control_files._file_mode)
 
-        os.mkdir('d')
-        os.chmod('d', 0700)
-        b = self.make_branch('d')
-        self.assertEqualMode(0700, b.bzrdir._get_dir_mode())
-        self.assertEqualMode(0600, b.bzrdir._get_file_mode())
-        self.assertEqualMode(0700, b.control_files._dir_mode)
-        self.assertEqualMode(0600, b.control_files._file_mode)
-        check_mode_r(self, 'd/.bzr', 00600, 00700)
-
-    def test_new_branch_group_sticky_bit(self):
-        if isinstance(self.branch_format, RemoteBranchFormat):
-            # Remote branch format have no permission logic in them; there's
-            # nothing to test here.
-            raise tests.TestNotApplicable('Remote branches have no'
-                                          ' permission logic')
-        if sys.platform == 'win32':
-            raise tests.TestNotApplicable('chmod has no effect on win32')
-        elif sys.platform == 'darwin':
-            # OS X creates temp dirs with the 'wheel' group, which users are
-            # not likely to be in, and this prevents us from setting the sgid
-            # bit
-            os.chown(self.test_dir, os.getuid(), os.getgid())
-        # also, these are BzrBranch format specific things..
-        t = self.make_branch_and_tree('.')
-        b = t.branch
         os.mkdir('b')
         os.chmod('b', 02777)
         b = self.make_branch('b')
-        self.assertEqualMode(02777, b.bzrdir._get_dir_mode())
-        self.assertEqualMode(00666, b.bzrdir._get_file_mode())
         self.assertEqualMode(02777, b.control_files._dir_mode)
         self.assertEqualMode(00666, b.control_files._file_mode)
         check_mode_r(self, 'b/.bzr', 00666, 02777)
@@ -111,26 +70,13 @@
         os.mkdir('c')
         os.chmod('c', 02750)
         b = self.make_branch('c')
-        self.assertEqualMode(02750, b.bzrdir._get_dir_mode())
-        self.assertEqualMode(00640, b.bzrdir._get_file_mode())
         self.assertEqualMode(02750, b.control_files._dir_mode)
         self.assertEqualMode(00640, b.control_files._file_mode)
         check_mode_r(self, 'c/.bzr', 00640, 02750)
 
-    def test_mode_0(self):
-        """Test when a transport returns null permissions for .bzr"""
-        if isinstance(self.branch_format, RemoteBranchFormat):
-            # Remote branch format have no permission logic in them; there's
-            # nothing to test here.
-            raise tests.TestNotApplicable('Remote branches have no'
-                                          ' permission logic')
-        self.make_branch_and_tree('.')
-        bzrdir = BzrDir.open('.')
-        # Monkey patch the transport
-        _orig_stat = bzrdir.transport.stat
-        def null_perms_stat(*args, **kwargs):
-            result = _orig_stat(*args, **kwargs)
-            return _NullPermsStat(result)
-        bzrdir.transport.stat = null_perms_stat
-        self.assertIs(None, bzrdir._get_dir_mode())
-        self.assertIs(None, bzrdir._get_file_mode())
+        os.mkdir('d')
+        os.chmod('d', 0700)
+        b = self.make_branch('d')
+        self.assertEqualMode(0700, b.control_files._dir_mode)
+        self.assertEqualMode(0600, b.control_files._file_mode)
+        check_mode_r(self, 'd/.bzr', 00600, 00700)

=== modified file 'bzrlib/tests/branch_implementations/test_pull.py'
--- bzrlib/tests/branch_implementations/test_pull.py	2008-06-09 15:37:14 +0000
+++ bzrlib/tests/branch_implementations/test_pull.py	2007-05-04 08:46:39 +0000
@@ -23,6 +23,7 @@
 from bzrlib import errors
 from bzrlib.memorytree import MemoryTree
 from bzrlib.revision import NULL_REVISION
+from bzrlib.tests import TestSkipped
 from bzrlib.tests.branch_implementations.test_branch import TestCaseWithBranch
 
 
@@ -81,23 +82,6 @@
         self.assertRaises(errors.BoundBranchConnectionFailure,
                 checkout.branch.pull, other.branch)
 
-    def test_pull_returns_result(self):
-        parent = self.make_branch_and_tree('parent')
-        parent.commit('1st post', rev_id='P1')
-        mine = parent.bzrdir.sprout('mine').open_workingtree()
-        mine.commit('my change', rev_id='M1')
-        result = parent.branch.pull(mine.branch)
-        self.assertIsNot(None, result)
-        self.assertIs(mine.branch, result.source_branch)
-        self.assertIs(parent.branch, result.target_branch)
-        self.assertIs(parent.branch, result.master_branch)
-        self.assertIs(None, result.local_branch)
-        self.assertEqual(1, result.old_revno)
-        self.assertEqual('P1', result.old_revid)
-        self.assertEqual(2, result.new_revno)
-        self.assertEqual('M1', result.new_revid)
-        self.assertEqual(None, result.tag_conflicts)
-
     def test_pull_overwrite(self):
         tree_a = self.make_branch_and_tree('tree_a')
         tree_a.commit('message 1')
@@ -105,14 +89,7 @@
         tree_a.commit('message 2', rev_id='rev2a')
         tree_b.commit('message 2', rev_id='rev2b')
         self.assertRaises(errors.DivergedBranches, tree_a.pull, tree_b.branch)
-        self.assertRaises(errors.DivergedBranches,
-                          tree_a.branch.pull, tree_b.branch,
-                          overwrite=False, stop_revision='rev2b')
-        # It should not have updated the branch tip, but it should have fetched
-        # the revision
-        self.assertEqual('rev2a', tree_a.branch.last_revision())
-        self.assertTrue(tree_a.branch.repository.has_revision('rev2b'))
-        tree_a.branch.pull(tree_b.branch, overwrite=True,
+        tree_a.branch.pull(tree_a.branch, overwrite=True,
                            stop_revision='rev2b')
         self.assertEqual('rev2b', tree_a.branch.last_revision())
         self.assertEqual(tree_b.branch.revision_history(),
@@ -147,8 +124,7 @@
     def test_post_pull_empty_history(self):
         target = self.make_branch('target')
         source = self.make_branch('source')
-        Branch.hooks.install_named_hook('post_pull',
-            self.capture_post_pull_hook, None)
+        Branch.hooks.install_hook('post_pull', self.capture_post_pull_hook)
         target.pull(source)
         # with nothing there we should still get a notification, and
         # have both branches locked at the notification time.
@@ -176,8 +152,7 @@
             local = BzrDir.create_branch_convenience('local2')
             local.bind(target)
         source = self.make_branch('source')
-        Branch.hooks.install_named_hook('post_pull',
-            self.capture_post_pull_hook, None)
+        Branch.hooks.install_hook('post_pull', self.capture_post_pull_hook)
         local.pull(source)
         # with nothing there we should still get a notification, and
         # have both branches locked at the notification time.
@@ -196,8 +171,7 @@
         sourcedir = target.bzrdir.clone(self.get_url('source'))
         source = MemoryTree.create_on_branch(sourcedir.open_branch())
         rev2 = source.commit('rev 2')
-        Branch.hooks.install_named_hook('post_pull',
-            self.capture_post_pull_hook, None)
+        Branch.hooks.install_hook('post_pull', self.capture_post_pull_hook)
         target.branch.pull(source.branch)
         # with nothing there we should still get a notification, and
         # have both branches locked at the notification time.

=== modified file 'bzrlib/tests/branch_implementations/test_push.py'
--- bzrlib/tests/branch_implementations/test_push.py	2008-05-23 07:33:05 +0000
+++ bzrlib/tests/branch_implementations/test_push.py	2007-05-07 12:03:14 +0000
@@ -24,6 +24,7 @@
 from bzrlib.memorytree import MemoryTree
 from bzrlib.remote import RemoteBranch
 from bzrlib.revision import NULL_REVISION
+from bzrlib.tests import TestSkipped
 from bzrlib.tests.branch_implementations.test_branch import TestCaseWithBranch
 from bzrlib.transport.local import LocalURLServer
 
@@ -153,22 +154,6 @@
         self.assertEqual(tree.branch.last_revision(),
                          to_branch.last_revision())
 
-    def test_push_overwrite_of_non_tip_with_stop_revision(self):
-        """Combining the stop_revision and overwrite options works.
-        
-        This was <https://bugs.launchpad.net/bzr/+bug/234229>.
-        """
-        source = self.make_branch_and_tree('source')
-        target = self.make_branch('target')
-
-        source.commit('1st commit')
-        source.branch.push(target)
-        source.commit('2nd commit', rev_id='rev-2')
-        source.commit('3rd commit')
-
-        source.branch.push(target, stop_revision='rev-2', overwrite=True)
-        self.assertEqual('rev-2', target.last_revision())
-
 
 class TestPushHook(TestCaseWithBranch):
 
@@ -198,8 +183,7 @@
     def test_post_push_empty_history(self):
         target = self.make_branch('target')
         source = self.make_branch('source')
-        Branch.hooks.install_named_hook('post_push',
-                                        self.capture_post_push_hook, None)
+        Branch.hooks.install_hook('post_push', self.capture_post_push_hook)
         source.push(target)
         # with nothing there we should still get a notification, and
         # have both branches locked at the notification time.
@@ -227,8 +211,7 @@
             local = BzrDir.create_branch_convenience('local2')
             local.bind(target)
         source = self.make_branch('source')
-        Branch.hooks.install_named_hook('post_push',
-                                        self.capture_post_push_hook, None)
+        Branch.hooks.install_hook('post_push', self.capture_post_push_hook)
         source.push(local)
         # with nothing there we should still get a notification, and
         # have both branches locked at the notification time.
@@ -247,8 +230,7 @@
         sourcedir = target.bzrdir.clone(self.get_url('source'))
         source = MemoryTree.create_on_branch(sourcedir.open_branch())
         rev2 = source.commit('rev 2')
-        Branch.hooks.install_named_hook('post_push',
-                                        self.capture_post_push_hook, None)
+        Branch.hooks.install_hook('post_push', self.capture_post_push_hook)
         source.branch.push(target.branch)
         # with nothing there we should still get a notification, and
         # have both branches locked at the notification time.

=== removed file 'bzrlib/tests/branch_implementations/test_reconcile.py'
--- bzrlib/tests/branch_implementations/test_reconcile.py	2008-06-11 07:52:25 +0000
+++ bzrlib/tests/branch_implementations/test_reconcile.py	1970-01-01 00:00:00 +0000
@@ -1,72 +0,0 @@
-# Copyright (C) 2008 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Tests for branch implementations - test reconcile() functionality"""
-
-from bzrlib import errors, reconcile
-from bzrlib.tests.branch_implementations import TestCaseWithBranch
-
-
-class TestBranchReconcile(TestCaseWithBranch):
-
-    def test_reconcile_fixes_invalid_revhistory(self):
-        # Different formats have different ways of handling invalid revision
-        # histories, so the setup portion is customized
-        tree = self.make_branch_and_tree('test')
-        r1 = tree.commit('one')
-        r2 = tree.commit('two')
-        r3 = tree.commit('three')
-        r4 = tree.commit('four')
-        # create an alternate branch
-        tree.set_parent_ids([r1])
-        tree.branch.set_last_revision_info(1, r1)
-        r2b = tree.commit('two-b')
-
-        # now go back and merge the commit
-        tree.set_parent_ids([r4, r2b])
-        tree.branch.set_last_revision_info(4, r4)
-
-        r5 = tree.commit('five')
-        # Now, try to set an invalid history
-        try:
-            tree.branch.set_revision_history([r1, r2b, r5])
-            if tree.branch.last_revision_info() != (3, r5):
-                # RemoteBranch silently corrects an impossible revision
-                # history given to set_revision_history.  It can be tricked
-                # with set_last_revision_info though.
-                tree.branch.set_last_revision_info(3, r5)
-        except errors.NotLefthandHistory:
-            # Branch5 allows set_revision_history to be wrong
-            # Branch6 raises NotLefthandHistory, but we can force bogus stuff
-            # with set_last_revision_info
-            tree.branch.set_last_revision_info(3, r5)
-
-        self.assertEqual((3, r5), tree.branch.last_revision_info())
-        reconciler = tree.branch.reconcile()
-        self.assertEqual((5, r5), tree.branch.last_revision_info())
-        self.assertIs(True, reconciler.fixed_history)
-
-    def test_reconcile_returns_reconciler(self):
-        a_branch = self.make_branch('a_branch')
-        result = a_branch.reconcile()
-        self.assertIsInstance(result, reconcile.BranchReconciler)
-        # No history to fix
-        self.assertIs(False, result.fixed_history)
-
-    def test_reconcile_supports_thorough(self):
-        a_branch = self.make_branch('a_branch')
-        a_branch.reconcile(thorough=False)
-        a_branch.reconcile(thorough=True)

=== modified file 'bzrlib/tests/branch_implementations/test_revision_history.py'
--- bzrlib/tests/branch_implementations/test_revision_history.py	2008-06-16 16:55:05 +0000
+++ bzrlib/tests/branch_implementations/test_revision_history.py	2007-08-14 08:38:06 +0000
@@ -19,7 +19,6 @@
 from bzrlib import (
     branch,
     errors,
-    revision as _mod_revision,
     )
 from bzrlib.tests.branch_implementations.test_branch import TestCaseWithBranch
 
@@ -140,7 +139,7 @@
         # Lock the branch, set the last revision info, then call
         # last_revision_info.
         a_branch.lock_write()
-        a_branch.set_last_revision_info(0, _mod_revision.NULL_REVISION)
+        a_branch.set_last_revision_info(0, None)
         del calls[:]
         try:
             a_branch.last_revision_info()
@@ -148,19 +147,6 @@
         finally:
             a_branch.unlock()
 
-    def test_set_last_revision_info_none(self):
-        """Passing None to revision_info to None sets it to NULL_REVISION."""
-        a_branch = self.get_branch()
-        # Lock the branch, set the last revision info, then call
-        # last_revision_info.
-        a_branch.lock_write()
-        self.addCleanup(a_branch.unlock)
-        self.callDeprecated(['NULL_REVISION should be used for the null'
-            ' revision instead of None, as of bzr 0.91.'],
-            a_branch.set_last_revision_info, 0, None)
-        self.assertEqual((0, _mod_revision.NULL_REVISION),
-                         a_branch.last_revision_info())
-
     def test_set_last_revision_info_uncaches_revision_history_for_format6(self):
         """On format 6 branches, set_last_revision_info invalidates the revision
         history cache.
@@ -172,7 +158,7 @@
         a_branch.lock_write()
         a_branch.revision_history()
         # Set the last revision info, clearing the cache.
-        a_branch.set_last_revision_info(0, _mod_revision.NULL_REVISION)
+        a_branch.set_last_revision_info(0, None)
         del calls[:]
         try:
             a_branch.revision_history()
@@ -203,12 +189,4 @@
             branch.unlock()
 
 
-class TestRevisionHistory(TestCaseWithBranch):
 
-    def test_parent_ghost(self):
-        tree = self.make_branch_and_tree('tree')
-        tree.add_parent_tree_id('ghost-revision',
-                                allow_leftmost_as_ghost=True)
-        tree.commit('first non-ghost commit', rev_id='non-ghost-revision')
-        self.assertEqual(['non-ghost-revision'],
-                         tree.branch.revision_history())

=== modified file 'bzrlib/tests/branch_implementations/test_sprout.py'
--- bzrlib/tests/branch_implementations/test_sprout.py	2007-11-01 09:52:45 +0000
+++ bzrlib/tests/branch_implementations/test_sprout.py	2007-09-05 04:35:21 +0000
@@ -28,7 +28,7 @@
 
     def test_sprout_branch_nickname(self):
         # test the nick name is reset always
-        raise tests.TestSkipped('XXX branch sprouting is not yet tested.')
+        raise tests.TestSkipped('XXX branch sprouting is not yet tested..')
 
     def test_sprout_branch_parent(self):
         source = self.make_branch('source')

=== removed file 'bzrlib/tests/branch_implementations/test_stacking.py'
--- bzrlib/tests/branch_implementations/test_stacking.py	2008-08-20 16:14:09 +0000
+++ bzrlib/tests/branch_implementations/test_stacking.py	1970-01-01 00:00:00 +0000
@@ -1,338 +0,0 @@
-# Copyright (C) 2008 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Tests for Branch.get_stacked_on_url and set_stacked_on_url."""
-
-from bzrlib import (
-    bzrdir,
-    errors,
-    )
-from bzrlib.revision import NULL_REVISION
-from bzrlib.tests import TestNotApplicable, KnownFailure
-from bzrlib.tests.branch_implementations import TestCaseWithBranch
-
-
-class TestStacking(TestCaseWithBranch):
-
-    def test_get_set_stacked_on_url(self):
-        # branches must either:
-        # raise UnstackableBranchFormat or
-        # raise UnstackableRepositoryFormat or
-        # permit stacking to be done and then return the stacked location.
-        branch = self.make_branch('branch')
-        target = self.make_branch('target')
-        old_format_errors = (
-            errors.UnstackableBranchFormat,
-            errors.UnstackableRepositoryFormat,
-            )
-        try:
-            branch.set_stacked_on_url(target.base)
-        except old_format_errors:
-            # if the set failed, so must the get
-            self.assertRaises(old_format_errors, branch.get_stacked_on_url)
-            return
-        # now we have a stacked branch:
-        self.assertEqual(target.base, branch.get_stacked_on_url())
-        branch.set_stacked_on_url(None)
-        self.assertRaises(errors.NotStacked, branch.get_stacked_on_url)
-
-    def test_get_set_stacked_on_relative(self):
-        # Branches can be stacked on other branches using relative paths.
-        branch = self.make_branch('branch')
-        target = self.make_branch('target')
-        old_format_errors = (
-            errors.UnstackableBranchFormat,
-            errors.UnstackableRepositoryFormat,
-            )
-        try:
-            branch.set_stacked_on_url('../target')
-        except old_format_errors:
-            # if the set failed, so must the get
-            self.assertRaises(old_format_errors, branch.get_stacked_on_url)
-            return
-        self.assertEqual('../target', branch.get_stacked_on_url())
-
-    def assertRevisionInRepository(self, repo_path, revid):
-        """Check that a revision is in a repository, disregarding stacking."""
-        repo = bzrdir.BzrDir.open(repo_path).open_repository()
-        self.assertTrue(repo.has_revision(revid))
-
-    def assertRevisionNotInRepository(self, repo_path, revid):
-        """Check that a revision is not in a repository, disregarding stacking."""
-        repo = bzrdir.BzrDir.open(repo_path).open_repository()
-        self.assertFalse(repo.has_revision(revid))
-
-    def test_get_graph_stacked(self):
-        """A stacked repository shows the graph of its parent."""
-        trunk_tree = self.make_branch_and_tree('mainline')
-        trunk_revid = trunk_tree.commit('mainline')
-        # make a new branch, and stack on the existing one.  we don't use
-        # sprout(stacked=True) here because if that is buggy and copies data
-        # it would cause a false pass of this test.
-        new_branch = self.make_branch('new_branch')
-        try:
-            new_branch.set_stacked_on_url(trunk_tree.branch.base)
-        except (errors.UnstackableBranchFormat,
-            errors.UnstackableRepositoryFormat), e:
-            raise TestNotApplicable(e)
-        # reading the graph from the stacked branch's repository should see
-        # data from the stacked-on branch
-        new_repo = new_branch.repository
-        new_repo.lock_read()
-        try:
-            self.assertEqual(new_repo.get_parent_map([trunk_revid]),
-                {trunk_revid: (NULL_REVISION, )})
-        finally:
-            new_repo.unlock()
-
-    def test_sprout_stacked(self):
-        # We have a mainline
-        trunk_tree = self.make_branch_and_tree('mainline')
-        trunk_revid = trunk_tree.commit('mainline')
-        # and make branch from it which is stacked
-        try:
-            new_dir = trunk_tree.bzrdir.sprout('newbranch', stacked=True)
-        except (errors.UnstackableBranchFormat,
-            errors.UnstackableRepositoryFormat), e:
-            raise TestNotApplicable(e)
-        # stacked repository
-        self.assertRevisionNotInRepository('newbranch', trunk_revid)
-        new_tree = new_dir.open_workingtree()
-        new_branch_revid = new_tree.commit('something local')
-        self.assertRevisionNotInRepository('mainline', new_branch_revid)
-        self.assertRevisionInRepository('newbranch', new_branch_revid)
-
-    def test_unstack_fetches(self):
-        """Removing the stacked-on branch pulls across all data"""
-        # We have a mainline
-        trunk_tree = self.make_branch_and_tree('mainline')
-        trunk_revid = trunk_tree.commit('revision on mainline')
-        # and make branch from it which is stacked
-        try:
-            new_dir = trunk_tree.bzrdir.sprout('newbranch', stacked=True)
-        except (errors.UnstackableBranchFormat,
-            errors.UnstackableRepositoryFormat), e:
-            raise TestNotApplicable(e)
-        # stacked repository
-        self.assertRevisionNotInRepository('newbranch', trunk_revid)
-        # now when we unstack that should implicitly fetch, to make sure that
-        # the branch will still work
-        new_branch = new_dir.open_branch()
-        new_branch.set_stacked_on_url(None)
-        self.assertRevisionInRepository('newbranch', trunk_revid)
-        # of course it's still in the mainline
-        self.assertRevisionInRepository('mainline', trunk_revid)
-        # and now we're no longer stacked
-        self.assertRaises(errors.NotStacked,
-            new_branch.get_stacked_on_url)
-
-    def make_stacked_bzrdir(self, in_directory=None):
-        """Create a stacked branch and return its bzrdir.
-
-        :param in_directory: If not None, create a directory of this
-            name and create the stacking and stacked-on bzrdirs in
-            this directory.
-        """
-        if in_directory is not None:
-            self.get_transport().mkdir(in_directory)
-            prefix = in_directory + '/'
-        else:
-            prefix = ''
-        tree = self.make_branch_and_tree(prefix + 'stacked-on')
-        tree.commit('Added foo')
-        stacked_bzrdir = tree.branch.bzrdir.sprout(
-            prefix + 'stacked', tree.branch.last_revision(), stacked=True)
-        return stacked_bzrdir
-
-    def test_clone_from_stacked_branch_preserve_stacking(self):
-        # We can clone from the bzrdir of a stacked branch. If
-        # preserve_stacking is True, the cloned branch is stacked on the
-        # same branch as the original.
-        try:
-            stacked_bzrdir = self.make_stacked_bzrdir()
-        except (errors.UnstackableBranchFormat,
-                errors.UnstackableRepositoryFormat), e:
-            # not a testable combination.
-            raise TestNotApplicable(e)
-        cloned_bzrdir = stacked_bzrdir.clone('cloned', preserve_stacking=True)
-        try:
-            self.assertEqual(
-                stacked_bzrdir.open_branch().get_stacked_on_url(),
-                cloned_bzrdir.open_branch().get_stacked_on_url())
-        except (errors.UnstackableBranchFormat,
-                errors.UnstackableRepositoryFormat):
-            pass
-
-    def test_clone_from_branch_stacked_on_relative_url_preserve_stacking(self):
-        # If a branch's stacked-on url is relative, we can still clone
-        # from it with preserve_stacking True and get a branch stacked
-        # on an appropriately adjusted relative url.
-        try:
-            stacked_bzrdir = self.make_stacked_bzrdir(in_directory='dir')
-        except (errors.UnstackableBranchFormat,
-                errors.UnstackableRepositoryFormat), e:
-            # not a testable combination.
-            raise TestNotApplicable(e)
-        stacked_bzrdir.open_branch().set_stacked_on_url('../stacked-on')
-        cloned_bzrdir = stacked_bzrdir.clone('cloned', preserve_stacking=True)
-        self.assertEqual(
-            '../dir/stacked-on',
-            cloned_bzrdir.open_branch().get_stacked_on_url())
-
-    def test_clone_from_stacked_branch_no_preserve_stacking(self):
-        try:
-            stacked_bzrdir = self.make_stacked_bzrdir()
-        except (errors.UnstackableBranchFormat,
-                errors.UnstackableRepositoryFormat), e:
-            # not a testable combination.
-            raise TestNotApplicable(e)
-        cloned_unstacked_bzrdir = stacked_bzrdir.clone('cloned-unstacked',
-            preserve_stacking=False)
-        unstacked_branch = cloned_unstacked_bzrdir.open_branch()
-        self.assertRaises((errors.NotStacked, errors.UnstackableBranchFormat),
-                          unstacked_branch.get_stacked_on_url)
-
-    def test_no_op_preserve_stacking(self):
-        """With no stacking, preserve_stacking should be a no-op."""
-        branch = self.make_branch('source')
-        cloned_bzrdir = branch.bzrdir.clone('cloned', preserve_stacking=True)
-        self.assertRaises((errors.NotStacked, errors.UnstackableBranchFormat),
-                          cloned_bzrdir.open_branch().get_stacked_on_url)
-
-    def test_sprout_stacking_policy_handling(self):
-        """Obey policy where possible, ignore otherwise."""
-        stack_on = self.make_branch('stack-on')
-        parent_bzrdir = self.make_bzrdir('.', format='default')
-        parent_bzrdir.get_config().set_default_stack_on('stack-on')
-        source = self.make_branch('source')
-        target = source.bzrdir.sprout('target').open_branch()
-        try:
-            self.assertEqual('../stack-on', target.get_stacked_on_url())
-        except errors.UnstackableBranchFormat:
-            pass
-
-    def test_clone_stacking_policy_handling(self):
-        """Obey policy where possible, ignore otherwise."""
-        stack_on = self.make_branch('stack-on')
-        parent_bzrdir = self.make_bzrdir('.', format='default')
-        parent_bzrdir.get_config().set_default_stack_on('stack-on')
-        source = self.make_branch('source')
-        target = source.bzrdir.clone('target').open_branch()
-        try:
-            self.assertEqual('../stack-on', target.get_stacked_on_url())
-        except errors.UnstackableBranchFormat:
-            pass
-
-    def prepare_stacked_on_fetch(self):
-        stack_on = self.make_branch_and_tree('stack-on')
-        stack_on.commit('first commit', rev_id='rev1')
-        try:
-            stacked_dir = stack_on.bzrdir.sprout('stacked', stacked=True)
-        except (errors.UnstackableRepositoryFormat,
-                errors.UnstackableBranchFormat):
-            raise TestNotApplicable('Format does not support stacking.')
-        unstacked = self.make_repository('unstacked')
-        return stacked_dir.open_workingtree(), unstacked
-
-    def test_fetch_copies_from_stacked_on(self):
-        stacked, unstacked = self.prepare_stacked_on_fetch()
-        unstacked.fetch(stacked.branch.repository, 'rev1')
-        unstacked.get_revision('rev1')
-
-    def test_fetch_copies_from_stacked_on_and_stacked(self):
-        stacked, unstacked = self.prepare_stacked_on_fetch()
-        stacked.commit('second commit', rev_id='rev2')
-        unstacked.fetch(stacked.branch.repository, 'rev2')
-        unstacked.get_revision('rev1')
-        unstacked.get_revision('rev2')
-
-    def test_autopack_when_stacked(self):
-        # in bzr.dev as of 20080730, autopack was reported to fail in stacked
-        # repositories because of problems with text deltas spanning physical
-        # repository boundaries.  however, i didn't actually get this test to
-        # fail on that code. -- mbp
-        # see https://bugs.launchpad.net/bzr/+bug/252821
-        if not self.branch_format.supports_stacking():
-            raise TestNotApplicable("%r does not support stacking"
-                % self.branch_format)
-        stack_on = self.make_branch_and_tree('stack-on')
-        text_lines = ['line %d blah blah blah\n' % i for i in range(20)]
-        self.build_tree_contents([('stack-on/a', ''.join(text_lines))])
-        stack_on.add('a')
-        stack_on.commit('base commit')
-        stacked_dir = stack_on.bzrdir.sprout('stacked', stacked=True)
-        stacked_tree = stacked_dir.open_workingtree()
-        for i in range(20):
-            text_lines[0] = 'changed in %d\n' % i
-            self.build_tree_contents([('stacked/a', ''.join(text_lines))])
-            stacked_tree.commit('commit %d' % i)
-        stacked_tree.branch.repository.pack()
-        stacked_tree.branch.check()
-
-    def test_pull_delta_when_stacked(self):
-        if not self.branch_format.supports_stacking():
-            raise TestNotApplicable("%r does not support stacking"
-                % self.branch_format)
-        stack_on = self.make_branch_and_tree('stack-on')
-        text_lines = ['line %d blah blah blah\n' % i for i in range(20)]
-        self.build_tree_contents([('stack-on/a', ''.join(text_lines))])
-        stack_on.add('a')
-        stack_on.commit('base commit')
-        # make a stacked branch from the mainline
-        stacked_dir = stack_on.bzrdir.sprout('stacked', stacked=True)
-        stacked_tree = stacked_dir.open_workingtree()
-        # make a second non-stacked branch from the mainline
-        other_dir = stack_on.bzrdir.sprout('other')
-        other_tree = other_dir.open_workingtree()
-        text_lines[9] = 'changed in other\n'
-        self.build_tree_contents([('other/a', ''.join(text_lines))])
-        other_tree.commit('commit in other')
-        # this should have generated a delta; try to pull that across
-        # bug 252821 caused a RevisionNotPresent here...
-        stacked_tree.pull(other_tree.branch)
-        stacked_tree.branch.repository.pack()
-        stacked_tree.branch.check()
-
-    def test_fetch_revisions_with_file_changes(self):
-        # Fetching revisions including file changes into a stacked branch
-        # works without error.
-        # Make the source tree.
-        src_tree = self.make_branch_and_tree('src')
-        self.build_tree_contents([('src/a', 'content')])
-        src_tree.add('a')
-        src_tree.commit('first commit')
-
-        # Make the stacked-on branch.
-        src_tree.bzrdir.sprout('stacked-on')
-
-        # Make a branch stacked on it.
-        target = self.make_branch('target')
-        try:
-            target.set_stacked_on_url('../stacked-on')
-        except (errors.UnstackableRepositoryFormat,
-                errors.UnstackableBranchFormat):
-            raise TestNotApplicable('Format does not support stacking.')
-
-        # Change the source branch.
-        self.build_tree_contents([('src/a', 'new content')])
-        src_tree.commit('second commit', rev_id='rev2')
-
-        # Fetch changes to the target.
-        target.fetch(src_tree.branch)
-        rtree = target.repository.revision_tree('rev2')
-        rtree.lock_read()
-        self.addCleanup(rtree.unlock)
-        self.assertEqual('new content', rtree.get_file_by_path('a').read())

=== modified file 'bzrlib/tests/branch_implementations/test_uncommit.py'
--- bzrlib/tests/branch_implementations/test_uncommit.py	2008-03-10 13:35:40 +0000
+++ bzrlib/tests/branch_implementations/test_uncommit.py	2007-07-11 14:58:54 +0000
@@ -53,8 +53,8 @@
         tree.add('')
         revid = tree.commit('a revision')
         tree.unlock()
-        Branch.hooks.install_named_hook('post_uncommit',
-            self.capture_post_uncommit_hook, None)
+        Branch.hooks.install_hook('post_uncommit',
+            self.capture_post_uncommit_hook)
         uncommit(tree.branch)
         # with nothing left we should still get a notification, and
         # have the branch locked at notification time.
@@ -76,8 +76,8 @@
         tree.add('')
         revid = tree.commit('a revision')
         tree.unlock()
-        Branch.hooks.install_named_hook('post_uncommit',
-            self.capture_post_uncommit_hook, None)
+        Branch.hooks.install_hook('post_uncommit',
+            self.capture_post_uncommit_hook)
         uncommit(tree.branch)
         # with nothing left we should still get a notification, and
         # have the branch locked at notification time.
@@ -95,8 +95,8 @@
         revid2 = tree.commit('second revision')
         revid3 = tree.commit('third revision')
         tree.unlock()
-        Branch.hooks.install_named_hook('post_uncommit',
-            self.capture_post_uncommit_hook, None)
+        Branch.hooks.install_hook('post_uncommit',
+            self.capture_post_uncommit_hook)
         uncommit(tree.branch, revno=2)
         # having uncommitted from up the branch, we should get the
         # before and after revnos and revids correctly.

=== modified file 'bzrlib/tests/branch_implementations/test_update.py'
--- bzrlib/tests/branch_implementations/test_update.py	2008-05-29 20:17:37 +0000
+++ bzrlib/tests/branch_implementations/test_update.py	2007-07-11 19:44:51 +0000
@@ -67,51 +67,3 @@
         master_tree.commit('bar', rev_id='bar', allow_pointless=True)
         self.assertEqual('foo', child_tree.branch.update())
         self.assertEqual(['bar'], child_tree.branch.revision_history())
-
-
-class TestUpdateRevisions(TestCaseWithBranch):
-
-    def test_accepts_graph(self):
-        # An implementation may not use it, but it should allow a 'graph' to be
-        # supplied
-        tree1 = self.make_branch_and_tree('tree1')
-        rev1 = tree1.commit('one')
-        tree2 = tree1.bzrdir.sprout('tree2').open_workingtree()
-        rev2 = tree2.commit('two')
-
-        tree1.lock_write()
-        self.addCleanup(tree1.unlock)
-        tree2.lock_read()
-        self.addCleanup(tree2.unlock)
-        graph = tree2.branch.repository.get_graph(tree1.branch.repository)
-
-        tree1.branch.update_revisions(tree2.branch, graph=graph)
-        self.assertEqual((2, rev2), tree1.branch.last_revision_info())
-
-    def test_overwrite_ignores_diverged(self):
-        tree1 = self.make_branch_and_tree('tree1')
-        rev1 = tree1.commit('one')
-        tree2 = tree1.bzrdir.sprout('tree2').open_workingtree()
-        rev2 = tree1.commit('two')
-        rev2b = tree2.commit('alt two')
-
-        self.assertRaises(errors.DivergedBranches,
-                          tree1.branch.update_revisions,
-                          tree2.branch, overwrite=False)
-        # However, the revision should be copied into the repository
-        self.assertTrue(tree1.branch.repository.has_revision(rev2b))
-
-        tree1.branch.update_revisions(tree2.branch, overwrite=True)
-        self.assertEqual((2, rev2b), tree1.branch.last_revision_info())
-
-    def test_ignores_older_unless_overwrite(self):
-        tree1 = self.make_branch_and_tree('tree1')
-        rev1 = tree1.commit('one')
-        tree2 = tree1.bzrdir.sprout('tree2').open_workingtree()
-        rev2 = tree1.commit('two')
-
-        tree1.branch.update_revisions(tree2.branch)
-        self.assertEqual((2, rev2), tree1.branch.last_revision_info())
-
-        tree1.branch.update_revisions(tree2.branch, overwrite=True)
-        self.assertEqual((1, rev1), tree1.branch.last_revision_info())

=== modified file 'bzrlib/tests/bzrdir_implementations/__init__.py'
--- bzrlib/tests/bzrdir_implementations/__init__.py	2008-06-05 22:56:42 +0000
+++ bzrlib/tests/bzrdir_implementations/__init__.py	2007-06-28 06:01:18 +0000
@@ -29,7 +29,9 @@
                           adapt_modules,
                           default_transport,
                           TestCaseWithTransport,
+                          TestLoader,
                           TestScenarioApplier,
+                          TestSuite,
                           )
 from bzrlib.transport.memory import MemoryServer
 
@@ -44,7 +46,7 @@
     """
 
     def __init__(self, vfs_factory, transport_server, transport_readonly_server,
-        formats, name_suffix=''):
+        formats):
         """Create an object to adapt tests.
 
         :param vfs_server: A factory to create a Transport Server which has
@@ -53,7 +55,6 @@
         self._vfs_factory = vfs_factory
         self._transport_server = transport_server
         self._transport_readonly_server = transport_readonly_server
-        self._name_suffix = name_suffix
         self.scenarios = self.formats_to_scenarios(formats)
     
     def formats_to_scenarios(self, formats):
@@ -63,9 +64,7 @@
         """
         result = []
         for format in formats:
-            scenario_name = format.__class__.__name__
-            scenario_name += self._name_suffix
-            scenario = (scenario_name, {
+            scenario = (format.__class__.__name__, {
                 "vfs_transport_factory":self._vfs_factory,
                 "transport_server":self._transport_server,
                 "transport_readonly_server":self._transport_readonly_server,
@@ -87,17 +86,12 @@
         return self.bzrdir
 
     def make_bzrdir(self, relpath, format=None):
-        if format is None:
-            format = self.bzrdir_format
         return super(TestCaseWithBzrDir, self).make_bzrdir(
-            relpath, format=format)
-
-
-def load_tests(basic_tests, module, loader):
-    result = loader.suiteClass()
-    # add the tests for this module
-    result.addTests(basic_tests)
-
+            relpath, format=self.bzrdir_format)
+
+
+def test_suite():
+    result = TestSuite()
     test_bzrdir_implementations = [
         'bzrlib.tests.bzrdir_implementations.test_bzrdir',
         ]
@@ -109,40 +103,24 @@
         # by the TestCaseWithTransport.get_readonly_transport method.
         None,
         formats)
-    # add the tests for the sub modules
+    loader = TestLoader()
     adapt_modules(test_bzrdir_implementations, adapter, loader, result)
 
     # This will always add the tests for smart server transport, regardless of
     # the --transport option the user specified to 'bzr selftest'.
-    from bzrlib.smart.server import (
-        ReadonlySmartTCPServer_for_testing,
-        ReadonlySmartTCPServer_for_testing_v2_only,
-        SmartTCPServer_for_testing,
-        SmartTCPServer_for_testing_v2_only,
-        )
+    from bzrlib.smart.server import SmartTCPServer_for_testing, ReadonlySmartTCPServer_for_testing
     from bzrlib.remote import RemoteBzrDirFormat
 
     # test the remote server behaviour using a MemoryTransport
-    smart_server_suite = loader.suiteClass()
+    smart_server_suite = TestSuite()
     adapt_to_smart_server = BzrDirTestProviderAdapter(
         MemoryServer,
         SmartTCPServer_for_testing,
         ReadonlySmartTCPServer_for_testing,
-        [(RemoteBzrDirFormat())],
-        name_suffix='-default')
-    adapt_modules(test_bzrdir_implementations,
-                  adapt_to_smart_server,
-                  loader,
-                  smart_server_suite)
-    adapt_to_smart_server = BzrDirTestProviderAdapter(
-        MemoryServer,
-        SmartTCPServer_for_testing_v2_only,
-        ReadonlySmartTCPServer_for_testing_v2_only,
-        [(RemoteBzrDirFormat())],
-        name_suffix='-v2')
-    adapt_modules(test_bzrdir_implementations,
-                  adapt_to_smart_server,
-                  loader,
+        [(RemoteBzrDirFormat())])
+    adapt_modules(test_bzrdir_implementations,
+                  adapt_to_smart_server,
+                  TestLoader(),
                   smart_server_suite)
     result.addTests(smart_server_suite)
 

=== modified file 'bzrlib/tests/bzrdir_implementations/test_bzrdir.py'
--- bzrlib/tests/bzrdir_implementations/test_bzrdir.py	2008-08-28 20:51:27 +0000
+++ bzrlib/tests/bzrdir_implementations/test_bzrdir.py	2007-09-26 02:51:16 +0000
@@ -18,7 +18,6 @@
 
 from cStringIO import StringIO
 import errno
-from itertools import izip
 import os
 from stat import S_ISDIR
 import sys
@@ -36,7 +35,7 @@
     workingtree,
     )
 from bzrlib.branch import Branch, needs_read_lock, needs_write_lock
-from bzrlib.check import check_branch
+from bzrlib.check import check
 from bzrlib.errors import (FileExists,
                            NoSuchRevision,
                            NoSuchFile,
@@ -81,10 +80,6 @@
         reading it again, which leads to changed timestamps. This is ok though,
         because the inventory.kndx file is not ignored, and the integrity of
         knit joins is tested by test_knit and test_versionedfile.
-
-        :seealso: Additionally, assertRepositoryHasSameItems provides value
-            rather than representation checking of repositories for
-            equivalence.
         """
         files = []
         directories = ['.']
@@ -106,65 +101,6 @@
                                          target.get(path).read(),
                                          "text for file %r differs:\n" % path)
 
-    def assertRepositoryHasSameItems(self, left_repo, right_repo):
-        """require left_repo and right_repo to contain the same data."""
-        # XXX: TODO: Doesn't work yet, because we need to be able to compare
-        # local repositories to remote ones...  but this is an as-yet unsolved
-        # aspect of format management and the Remote protocols...
-        # self.assertEqual(left_repo._format.__class__,
-        #     right_repo._format.__class__)
-        left_repo.lock_read()
-        try:
-            right_repo.lock_read()
-            try:
-                # revs
-                all_revs = left_repo.all_revision_ids()
-                self.assertEqual(left_repo.all_revision_ids(),
-                    right_repo.all_revision_ids())
-                for rev_id in left_repo.all_revision_ids():
-                    self.assertEqual(left_repo.get_revision(rev_id),
-                        right_repo.get_revision(rev_id))
-                # inventories
-                left_inv_weave = left_repo.inventories
-                right_inv_weave = right_repo.inventories
-                self.assertEqual(set(left_inv_weave.keys()),
-                    set(right_inv_weave.keys()))
-                # XXX: currently this does not handle indirectly referenced
-                # inventories (e.g. where the inventory is a delta basis for
-                # one that is fully present but that the revid for that
-                # inventory is not yet present.)
-                self.assertEqual(set(left_inv_weave.keys()),
-                    set(left_repo.revisions.keys()))
-                left_trees = left_repo.revision_trees(all_revs)
-                right_trees = right_repo.revision_trees(all_revs)
-                for left_tree, right_tree in izip(left_trees, right_trees):
-                    self.assertEqual(left_tree.inventory, right_tree.inventory)
-                # texts
-                text_index = left_repo._generate_text_key_index()
-                self.assertEqual(text_index,
-                    right_repo._generate_text_key_index())
-                desired_files = []
-                for file_id, revision_id in text_index.iterkeys():
-                    desired_files.append(
-                        (file_id, revision_id, (file_id, revision_id)))
-                left_texts = list(left_repo.iter_files_bytes(desired_files))
-                right_texts = list(right_repo.iter_files_bytes(desired_files))
-                left_texts.sort()
-                right_texts.sort()
-                self.assertEqual(left_texts, right_texts)
-                # signatures
-                for rev_id in all_revs:
-                    try:
-                        left_text = left_repo.get_signature_text(rev_id)
-                    except NoSuchRevision:
-                        continue
-                    right_text = right_repo.get_signature_text(rev_id)
-                    self.assertEqual(left_text, right_text)
-            finally:
-                right_repo.unlock()
-        finally:
-            left_repo.unlock()
-
     def skipIfNoWorkingTree(self, a_bzrdir):
         """Raises TestSkipped if a_bzrdir doesn't have a working tree.
         
@@ -189,7 +125,7 @@
                               % a_bzrdir.transport)
 
     def sproutOrSkip(self, from_bzrdir, to_url, revision_id=None,
-                     force_new_repo=False, accelerator_tree=None):
+                     force_new_repo=False):
         """Sprout from_bzrdir into to_url, or raise TestSkipped.
         
         A simple wrapper for from_bzrdir.sprout that translates NotLocalUrl into
@@ -200,8 +136,7 @@
             raise TestSkipped('Cannot sprout to remote bzrdirs.')
         target = from_bzrdir.sprout(to_url, revision_id=revision_id,
                                     force_new_repo=force_new_repo,
-                                    possible_transports=[to_transport],
-                                    accelerator_tree=accelerator_tree)
+                                    possible_transports=[to_transport])
         return target
 
     def test_create_null_workingtree(self):
@@ -244,18 +179,6 @@
         bzrdir.create_branch()
         bzrdir.open_branch()
 
-    def test_destroy_repository(self):
-        repo = self.make_repository('repository')
-        bzrdir = repo.bzrdir
-        try:
-            bzrdir.destroy_repository()
-        except (errors.UnsupportedOperation, errors.TransportNotPossible):
-            raise TestNotApplicable('Format does not support destroying'
-                                    ' repository')
-        self.assertRaises(errors.NoRepositoryPresent, bzrdir.open_repository)
-        bzrdir.create_repository()
-        bzrdir.open_repository()
-
     def test_open_workingtree_raises_no_working_tree(self):
         """BzrDir.open_workingtree() should raise NoWorkingTree (rather than
         e.g. NotLocalUrl) if there is no working tree.
@@ -306,10 +229,9 @@
         self.assertDirectoriesEqual(dir.root_transport, target.root_transport,
                                     [
                                      './.bzr/merge-hashes',
-                                     './.bzr/repository',
+                                     './.bzr/repository/inventory.knit',
                                      ])
-        self.assertRepositoryHasSameItems(tree.branch.repository,
-            target.open_repository())
+
 
     def test_clone_bzrdir_repository_under_shared(self):
         tree = self.make_branch_and_tree('commit_tree')
@@ -402,9 +324,8 @@
         target = dir.clone(self.get_url('target/child'), force_new_repo=True)
         self.assertNotEqual(dir.transport.base, target.transport.base)
         self.assertDirectoriesEqual(dir.root_transport, target.root_transport,
-                                    ['./.bzr/repository',
+                                    ['./.bzr/repository/inventory.knit',
                                      ])
-        self.assertRepositoryHasSameItems(tree.branch.repository, repo)
 
     def test_clone_bzrdir_repository_revision(self):
         # test for revision limiting, [smoke test, not corner case checks].
@@ -440,11 +361,9 @@
                                      './.bzr/basis-inventory-cache',
                                      './.bzr/checkout/stat-cache',
                                      './.bzr/merge-hashes',
-                                     './.bzr/repository',
+                                     './.bzr/repository/inventory.knit',
                                      './.bzr/stat-cache',
                                     ])
-        self.assertRepositoryHasSameItems(
-            tree.branch.repository, target.open_repository())
 
     def test_clone_bzrdir_branch_and_repo_into_shared_repo(self):
         # by default cloning into a shared repo uses the shared repo.
@@ -482,11 +401,10 @@
         dir = source.bzrdir
         target = dir.clone(self.get_url('target/child'), force_new_repo=True)
         self.assertNotEqual(dir.transport.base, target.transport.base)
-        repo = target.open_repository()
+        target.open_repository()
         self.assertDirectoriesEqual(dir.root_transport, target.root_transport,
-                                    ['./.bzr/repository',
+                                    ['./.bzr/repository/inventory.knit',
                                      ])
-        self.assertRepositoryHasSameItems(tree.branch.repository, repo)
 
     def test_clone_bzrdir_branch_reference(self):
         # cloning should preserve the reference status of the branch in a bzrdir
@@ -500,7 +418,9 @@
             return
         target = dir.clone(self.get_url('target'))
         self.assertNotEqual(dir.transport.base, target.transport.base)
-        self.assertDirectoriesEqual(dir.root_transport, target.root_transport)
+        self.assertDirectoriesEqual(dir.root_transport, target.root_transport,
+                                    ['./.bzr/repository/inventory.knit',
+                                     ])
 
     def test_clone_bzrdir_branch_revision(self):
         # test for revision limiting, [smoke test, not corner case checks].
@@ -534,28 +454,11 @@
                                      './.bzr/checkout/stat-cache',
                                      './.bzr/checkout/merge-hashes',
                                      './.bzr/merge-hashes',
-                                     './.bzr/repository',
+                                     './.bzr/repository/inventory.knit',
                                      ])
-        self.assertRepositoryHasSameItems(tree.branch.repository,
-            target.open_repository())
+
         target.open_workingtree().revert()
 
-    def test_clone_on_transport_preserves_repo_format(self):
-        if self.bzrdir_format == bzrdir.format_registry.make_bzrdir('default'):
-            format = 'knit'
-        else:
-            format = None
-        source_branch = self.make_branch('source', format=format)
-        # Ensure no format data is cached
-        a_dir = bzrlib.branch.Branch.open_from_transport(
-            self.get_transport('source')).bzrdir
-        target_transport = a_dir.root_transport.clone('..').clone('target')
-        target_bzrdir = a_dir.clone_on_transport(target_transport)
-        target_repo = target_bzrdir.open_repository()
-        source_branch = bzrlib.branch.Branch.open(
-            self.get_vfs_only_url('source'))
-        self.assertEqual(target_repo._format, source_branch.repository._format)
-
     def test_revert_inventory(self):
         tree = self.make_branch_and_tree('source')
         self.build_tree(['source/foo'])
@@ -570,10 +473,8 @@
                                      './.bzr/checkout/stat-cache',
                                      './.bzr/checkout/merge-hashes',
                                      './.bzr/merge-hashes',
-                                     './.bzr/repository',
+                                     './.bzr/repository/inventory.knit',
                                      ])
-        self.assertRepositoryHasSameItems(tree.branch.repository,
-            target.open_repository())
 
         target.open_workingtree().revert()
         self.assertDirectoriesEqual(dir.root_transport, target.root_transport,
@@ -582,10 +483,8 @@
                                      './.bzr/checkout/stat-cache',
                                      './.bzr/checkout/merge-hashes',
                                      './.bzr/merge-hashes',
-                                     './.bzr/repository',
+                                     './.bzr/repository/inventory.knit',
                                      ])
-        self.assertRepositoryHasSameItems(tree.branch.repository,
-            target.open_repository())
 
     def test_clone_bzrdir_tree_branch_reference(self):
         # a tree with a branch reference (aka a checkout) 
@@ -626,33 +525,6 @@
         self.skipIfNoWorkingTree(target)
         self.assertEqual(['1'], target.open_workingtree().get_parent_ids())
 
-    def test_clone_bzrdir_into_notrees_repo(self):
-        """Cloning into a no-trees repo should not create a working tree"""
-        tree = self.make_branch_and_tree('source')
-        self.build_tree(['source/foo'])
-        tree.add('foo')
-        tree.commit('revision 1')
-
-        try:
-            repo = self.make_repository('repo', shared=True)
-        except errors.IncompatibleFormat:
-            raise TestNotApplicable('must support shared repositories')
-        if repo.make_working_trees():
-            repo.set_make_working_trees(False)
-            self.assertFalse(repo.make_working_trees())
-
-        dir = tree.bzrdir
-        a_dir = dir.clone(self.get_url('repo/a'))
-        a_dir.open_branch()
-        self.assertRaises(errors.NoWorkingTree, a_dir.open_workingtree)
-
-    def test_clone_respects_stacked(self):
-        branch = self.make_branch('parent')
-        child_transport = branch.bzrdir.root_transport.clone('../child')
-        child = branch.bzrdir.clone_on_transport(child_transport,
-                                                 stacked_on=branch.base)
-        self.assertEqual(child.open_branch().get_stacked_on_url(), branch.base)
-
     def test_get_branch_reference_on_reference(self):
         """get_branch_reference should return the right url."""
         referenced_branch = self.make_branch('referenced')
@@ -1031,11 +903,9 @@
                                      './.bzr/checkout/inventory',
                                      './.bzr/inventory',
                                      './.bzr/parent',
-                                     './.bzr/repository',
+                                     './.bzr/repository/inventory.knit',
                                      './.bzr/stat-cache',
                                      ])
-        self.assertRepositoryHasSameItems(
-            tree.branch.repository, target.open_repository())
 
     def test_sprout_bzrdir_tree_branch_reference(self):
         # sprouting should create a repository if needed and a sprouted branch.
@@ -1107,17 +977,6 @@
         target = self.sproutOrSkip(dir, self.get_url('target'), revision_id='1')
         self.assertEqual(['1'], target.open_workingtree().get_parent_ids())
 
-    def test_sprout_takes_accelerator(self):
-        tree = self.make_branch_and_tree('source')
-        self.build_tree(['source/foo'])
-        tree.add('foo')
-        tree.commit('revision 1', rev_id='1')
-        tree.commit('revision 2', rev_id='2', allow_pointless=True)
-        dir = tree.bzrdir
-        target = self.sproutOrSkip(dir, self.get_url('target'),
-                                   accelerator_tree=tree)
-        self.assertEqual(['2'], target.open_workingtree().get_parent_ids())
-
     def test_format_initialize_find_open(self):
         # loopback test to check the current format initializes to itself.
         if not self.bzrdir_format.is_supported():
@@ -1493,8 +1352,7 @@
             finally:
                 pb.finished()
             # and it should pass 'check' now.
-            check_branch(bzrdir.BzrDir.open(self.get_url('.')).open_branch(),
-                         False)
+            check(bzrdir.BzrDir.open(self.get_url('.')).open_branch(), False)
 
     def test_format_description(self):
         dir = self.make_bzrdir('.')
@@ -1549,13 +1407,6 @@
         # break lock with just a repo should unlock the repo.
         repo = self.make_repository('.')
         repo.lock_write()
-        lock_repo = repo.bzrdir.open_repository()
-        if not lock_repo.get_physical_lock_status():
-            # This bzrdir's default repository does not physically lock things
-            # and thus this interaction cannot be tested at the interface
-            # level.
-            repo.unlock()
-            return
         # only one yes needed here: it should only be unlocking
         # the repo
         bzrlib.ui.ui_factory.stdin = StringIO("y\n")
@@ -1565,6 +1416,7 @@
             # this bzrdir does not implement break_lock - so we cant test it.
             repo.unlock()
             return
+        lock_repo = repo.bzrdir.open_repository()
         lock_repo.lock_write()
         lock_repo.unlock()
         self.assertRaises(errors.LockBroken, repo.unlock)
@@ -1590,26 +1442,23 @@
             # dir is inappropriately accessed, 3 will be needed, and
             # we'll see that because the stream will be fully consumed
             bzrlib.ui.ui_factory.stdin = StringIO("y\ny\ny\n")
-            # determine if the repository will have been locked;
-            this_repo_locked = \
-                thisdir.open_repository().get_physical_lock_status()
             master.bzrdir.break_lock()
-            if this_repo_locked:
-                # only two ys should have been read
-                self.assertEqual("y\n", bzrlib.ui.ui_factory.stdin.read())
-            else:
-                # only one y should have been read
-                self.assertEqual("y\ny\n", bzrlib.ui.ui_factory.stdin.read())
+            # only two ys should have been read
+            self.assertEqual("y\n", bzrlib.ui.ui_factory.stdin.read())
             # we should be able to lock a newly opened branch now
             branch = master.bzrdir.open_branch()
             branch.lock_write()
             branch.unlock()
-            if this_repo_locked:
-                # we should not be able to lock the repository in thisdir as
-                # its still held by the explicit lock we took, and the break
-                # lock should not have touched it.
-                repo = thisdir.open_repository()
+            # we should not be able to lock the repository in thisdir as its still
+            # held by the explicit lock we took, and the break lock should not have
+            # touched it.
+            repo = thisdir.open_repository()
+            orig_default = lockdir._DEFAULT_TIMEOUT_SECONDS
+            try:
+                lockdir._DEFAULT_TIMEOUT_SECONDS = 1
                 self.assertRaises(errors.LockContention, repo.lock_write)
+            finally:
+                lockdir._DEFAULT_TIMEOUT_SECONDS = orig_default
         finally:
             unused_repo.unlock()
         self.assertRaises(errors.LockBroken, master.unlock)
@@ -1640,24 +1489,6 @@
         self.assertRaises(errors.LockBroken, tree.unlock)
 
 
-class TestTransportConfig(TestCaseWithBzrDir):
-
-    def test_get_config(self):
-        my_dir = self.make_bzrdir('.')
-        config = my_dir.get_config()
-        if config is None:
-            self.assertFalse(
-                isinstance(my_dir, (bzrdir.BzrDirMeta1, RemoteBzrDir)),
-                "%r should support configs" % my_dir)
-            raise TestNotApplicable(
-                'This BzrDir format does not support configs.')
-        config.set_default_stack_on('http://example.com')
-        self.assertEqual('http://example.com', config.get_default_stack_on())
-        my_dir2 = bzrdir.BzrDir.open(self.get_url('.'))
-        config2 = my_dir2.get_config()
-        self.assertEqual('http://example.com', config2.get_default_stack_on())
-
-
 class ChrootedBzrDirTests(ChrootedTestCase):
 
     def test_find_repository_no_repository(self):

=== modified file 'bzrlib/tests/commands/__init__.py'
--- bzrlib/tests/commands/__init__.py	2008-04-28 08:57:45 +0000
+++ bzrlib/tests/commands/__init__.py	2007-10-04 15:45:21 +0000
@@ -24,11 +24,10 @@
 # FIXME: If the separation described above from the blackbox tests is not worth
 # it, all the tests defined below should be moved to blackbox instead. 
 
-def load_tests(basic_tests, module, loader):
-    suite = loader.suiteClass()
-    # add the tests for this module
-    suite.addTests(basic_tests)
-
+from bzrlib.tests import TestLoader
+
+
+def test_suite():
     testmod_names = [
         'bzrlib.tests.commands.test_branch',
         'bzrlib.tests.commands.test_cat',
@@ -42,7 +41,7 @@
         'bzrlib.tests.commands.test_push',
         'bzrlib.tests.commands.test_update',
         ]
-    # add the tests for the sub modules
-    suite.addTests(loader.loadTestsFromModuleNames(testmod_names))
+    loader = TestLoader()
+    suite = loader.loadTestsFromModuleNames(testmod_names)
 
     return suite

=== modified file 'bzrlib/tests/commands/test_checkout.py'
--- bzrlib/tests/commands/test_checkout.py	2007-10-31 22:46:03 +0000
+++ bzrlib/tests/commands/test_checkout.py	2007-09-11 14:47:02 +0000
@@ -30,12 +30,3 @@
         cmd.run(self.get_url('branch1'), 'local')
         self.assertEquals(1, len(self.connections))
 
-    def test_checkout_lightweight(self):
-        self.make_branch_and_tree('branch1')
-
-        self.start_logging_connections()
-
-        cmd = cmd_checkout()
-        cmd.run(self.get_url('branch1'), 'local', lightweight=True)
-        self.assertEquals(1, len(self.connections))
-

=== modified file 'bzrlib/tests/commands/test_init.py'
--- bzrlib/tests/commands/test_init.py	2008-07-16 20:24:50 +0000
+++ bzrlib/tests/commands/test_init.py	2007-09-11 14:47:02 +0000
@@ -15,7 +15,6 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 
-from bzrlib import tests
 from bzrlib.builtins import cmd_init
 from bzrlib.tests.transport_util import TestCaseWithConnectionHookedTransport
 
@@ -28,8 +27,6 @@
 
     def test_init(self):
         cmd = cmd_init()
-        # We don't care about the ouput but 'outf' should be defined
-        cmd.outf = tests.StringIOWrapper()
         cmd.run(self.get_url())
         self.assertEquals(1, len(self.connections))
 

=== modified file 'bzrlib/tests/commands/test_init_repository.py'
--- bzrlib/tests/commands/test_init_repository.py	2008-07-16 20:24:50 +0000
+++ bzrlib/tests/commands/test_init_repository.py	2007-09-11 14:47:02 +0000
@@ -15,7 +15,6 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 
-from bzrlib import tests
 from bzrlib.builtins import cmd_init_repository
 from bzrlib.tests.transport_util import TestCaseWithConnectionHookedTransport
 
@@ -28,8 +27,6 @@
 
     def test_init_repository(self):
         cmd = cmd_init_repository()
-        # We don't care about the ouput but 'outf' should be defined
-        cmd.outf = tests.StringIOWrapper()
         cmd.run(self.get_url())
         self.assertEquals(1, len(self.connections))
 

=== modified file 'bzrlib/tests/commands/test_push.py'
--- bzrlib/tests/commands/test_push.py	2008-06-06 02:20:29 +0000
+++ bzrlib/tests/commands/test_push.py	2007-09-11 14:47:02 +0000
@@ -15,7 +15,6 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 
-from bzrlib import tests
 from bzrlib.builtins import cmd_push
 from bzrlib.tests.transport_util import TestCaseWithConnectionHookedTransport
 
@@ -28,7 +27,6 @@
         self.start_logging_connections()
 
         cmd = cmd_push()
-        # We don't care about the ouput but 'outf' should be defined
-        cmd.outf = tests.StringIOWrapper()
         cmd.run(self.get_url('remote'), directory='branch')
         self.assertEquals(1, len(self.connections))
+

=== removed file 'bzrlib/tests/file_utils.py'
--- bzrlib/tests/file_utils.py	2008-05-06 15:02:27 +0000
+++ bzrlib/tests/file_utils.py	1970-01-01 00:00:00 +0000
@@ -1,47 +0,0 @@
-# Copyright (C) 2008 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-from cStringIO import StringIO
-
-class FakeReadFile(object):
-    """A file-like object that can be given predefined content and read
-    like a file.  The maximum size and number of the reads is recorded."""
-
-    def __init__(self, data):
-        """Initialize the mock file object with the provided data."""
-        self.data = StringIO(data)
-        self.max_read_size = None
-        self.read_count = 0
-
-    def read(self, size=-1):
-        """Reads size characters from the input (or the rest of the string if
-        size is -1)."""
-        data = self.data.read(size)
-        self.max_read_size = max(self.max_read_size, len(data))
-        self.read_count += 1
-        return data
-
-    def get_max_read_size(self):
-        """Returns the maximum read size or None if no reads have occured."""
-        return self.max_read_size
-
-    def get_read_count(self):
-        """Returns the number of calls to read."""
-        return self.read_count
-
-    def reset_read_count(self):
-        """Clears the read count."""
-        self.read_count = 0

=== removed file 'bzrlib/tests/ftp_server.py'
--- bzrlib/tests/ftp_server.py	2008-06-27 21:57:43 +0000
+++ bzrlib/tests/ftp_server.py	1970-01-01 00:00:00 +0000
@@ -1,284 +0,0 @@
-# Copyright (C) 2007 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-"""
-FTP test server.
-
-Based on medusa: http://www.amk.ca/python/code/medusa.html
-"""
-
-import asyncore
-import errno
-import os
-import select
-import stat
-import threading
-
-import medusa
-import medusa.filesys
-import medusa.ftp_server
-
-from bzrlib import (
-    tests,
-    trace,
-    transport,
-    )
-
-
-class test_filesystem(medusa.filesys.os_filesystem):
-    """A custom filesystem wrapper to add missing functionalities."""
-
-    def chmod(self, path, mode):
-        p = self.normalize(self.path_module.join (self.wd, path))
-        return os.chmod(self.translate(p), mode)
-
-
-class test_authorizer(object):
-    """A custom Authorizer object for running the test suite.
-
-    The reason we cannot use dummy_authorizer, is because it sets the
-    channel to readonly, which we don't always want to do.
-    """
-
-    def __init__(self, root):
-        self.root = root
-        # If secured_user is set secured_password will be checked
-        self.secured_user = None
-        self.secured_password = None
-
-    def authorize(self, channel, username, password):
-        """Return (success, reply_string, filesystem)"""
-        channel.persona = -1, -1
-        if username == 'anonymous':
-            channel.read_only = 1
-        else:
-            channel.read_only = 0
-
-        # Check secured_user if set
-        if (self.secured_user is not None
-            and username == self.secured_user
-            and password != self.secured_password):
-            return 0, 'Password invalid.', None
-        else:
-            return 1, 'OK.', test_filesystem(self.root)
-
-
-class ftp_channel(medusa.ftp_server.ftp_channel):
-    """Customized ftp channel"""
-
-    def log(self, message):
-        """Redirect logging requests."""
-        trace.mutter('ftp_channel: %s', message)
-
-    def log_info(self, message, type='info'):
-        """Redirect logging requests."""
-        trace.mutter('ftp_channel %s: %s', type, message)
-
-    def cmd_rnfr(self, line):
-        """Prepare for renaming a file."""
-        self._renaming = line[1]
-        self.respond('350 Ready for RNTO')
-        # TODO: jam 20060516 in testing, the ftp server seems to
-        #       check that the file already exists, or it sends
-        #       550 RNFR command failed
-
-    def cmd_rnto(self, line):
-        """Rename a file based on the target given.
-
-        rnto must be called after calling rnfr.
-        """
-        if not self._renaming:
-            self.respond('503 RNFR required first.')
-        pfrom = self.filesystem.translate(self._renaming)
-        self._renaming = None
-        pto = self.filesystem.translate(line[1])
-        if os.path.exists(pto):
-            self.respond('550 RNTO failed: file exists')
-            return
-        try:
-            os.rename(pfrom, pto)
-        except (IOError, OSError), e:
-            # TODO: jam 20060516 return custom responses based on
-            #       why the command failed
-            # (bialix 20070418) str(e) on Python 2.5 @ Windows
-            # sometimes don't provide expected error message;
-            # so we obtain such message via os.strerror()
-            self.respond('550 RNTO failed: %s' % os.strerror(e.errno))
-        except:
-            self.respond('550 RNTO failed')
-            # For a test server, we will go ahead and just die
-            raise
-        else:
-            self.respond('250 Rename successful.')
-
-    def cmd_size(self, line):
-        """Return the size of a file
-
-        This is overloaded to help the test suite determine if the 
-        target is a directory.
-        """
-        filename = line[1]
-        if not self.filesystem.isfile(filename):
-            if self.filesystem.isdir(filename):
-                self.respond('550 "%s" is a directory' % (filename,))
-            else:
-                self.respond('550 "%s" is not a file' % (filename,))
-        else:
-            self.respond('213 %d' 
-                % (self.filesystem.stat(filename)[stat.ST_SIZE]),)
-
-    def cmd_mkd(self, line):
-        """Create a directory.
-
-        Overloaded because default implementation does not distinguish
-        *why* it cannot make a directory.
-        """
-        if len (line) != 2:
-            self.command_not_understood(''.join(line))
-        else:
-            path = line[1]
-            try:
-                self.filesystem.mkdir (path)
-                self.respond ('257 MKD command successful.')
-            except (IOError, OSError), e:
-                # (bialix 20070418) str(e) on Python 2.5 @ Windows
-                # sometimes don't provide expected error message;
-                # so we obtain such message via os.strerror()
-                self.respond ('550 error creating directory: %s' %
-                              os.strerror(e.errno))
-            except:
-                self.respond ('550 error creating directory.')
-
-    def cmd_site(self, line):
-        """Site specific commands."""
-        command, args = line[1].split(' ', 1)
-        if command.lower() == 'chmod':
-            try:
-                mode, path = args.split()
-                mode = int(mode, 8)
-            except ValueError:
-                # We catch both malformed line and malformed mode with the same
-                # ValueError.
-                self.command_not_understood(' '.join(line))
-                return
-            try:
-                # Yes path and mode are reversed
-                self.filesystem.chmod(path, mode)
-                self.respond('200 SITE CHMOD command successful')
-            except AttributeError:
-                # The chmod method is not available in read-only and will raise
-                # AttributeError since a different filesystem is used in that
-                # case
-                self.command_not_authorized(' '.join(line))
-        else:
-            # Another site specific command was requested. We don't know that
-            # one
-            self.command_not_understood(' '.join(line))
-
-
-class ftp_server(medusa.ftp_server.ftp_server):
-    """Customize the behavior of the Medusa ftp_server.
-
-    There are a few warts on the ftp_server, based on how it expects
-    to be used.
-    """
-    _renaming = None
-    ftp_channel_class = ftp_channel
-
-    def __init__(self, *args, **kwargs):
-        trace.mutter('Initializing ftp_server: %r, %r', args, kwargs)
-        medusa.ftp_server.ftp_server.__init__(self, *args, **kwargs)
-
-    def log(self, message):
-        """Redirect logging requests."""
-        trace.mutter('ftp_server: %s', message)
-
-    def log_info(self, message, type='info'):
-        """Override the asyncore.log_info so we don't stipple the screen."""
-        trace.mutter('ftp_server %s: %s', type, message)
-
-
-class FTPServer(transport.Server):
-    """Common code for FTP server facilities."""
-
-    def __init__(self):
-        self._root = None
-        self._ftp_server = None
-        self._port = None
-        self._async_thread = None
-        # ftp server logs
-        self.logs = []
-
-    def get_url(self):
-        """Calculate an ftp url to this server."""
-        return 'ftp://foo:bar@localhost:%d/' % (self._port)
-
-    def get_bogus_url(self):
-        """Return a URL which cannot be connected to."""
-        return 'ftp://127.0.0.1:1'
-
-    def log(self, message):
-        """This is used by medusa.ftp_server to log connections, etc."""
-        self.logs.append(message)
-
-    def setUp(self, vfs_server=None):
-        from bzrlib.transport.local import LocalURLServer
-        if not (vfs_server is None or isinstance(vfs_server, LocalURLServer)):
-            raise AssertionError(
-                "FTPServer currently assumes local transport, got %s" % vfs_server)
-        self._root = os.getcwdu()
-        self._ftp_server = ftp_server(
-            authorizer=test_authorizer(root=self._root),
-            ip='localhost',
-            port=0, # bind to a random port
-            resolver=None,
-            logger_object=self # Use FTPServer.log() for messages
-            )
-        self._port = self._ftp_server.getsockname()[1]
-        # Don't let it loop forever, or handle an infinite number of requests.
-        # In this case it will run for 1000s, or 10000 requests
-        self._async_thread = threading.Thread(
-                target=FTPServer._asyncore_loop_ignore_EBADF,
-                kwargs={'timeout':0.1, 'count':10000})
-        self._async_thread.setDaemon(True)
-        self._async_thread.start()
-
-    def tearDown(self):
-        """See bzrlib.transport.Server.tearDown."""
-        self._ftp_server.close()
-        asyncore.close_all()
-        self._async_thread.join()
-
-    @staticmethod
-    def _asyncore_loop_ignore_EBADF(*args, **kwargs):
-        """Ignore EBADF during server shutdown.
-
-        We close the socket to get the server to shutdown, but this causes
-        select.select() to raise EBADF.
-        """
-        try:
-            asyncore.loop(*args, **kwargs)
-            # FIXME: If we reach that point, we should raise an exception
-            # explaining that the 'count' parameter in setUp is too low or
-            # testers may wonder why their test just sits there waiting for a
-            # server that is already dead. Note that if the tester waits too
-            # long under pdb the server will also die.
-        except select.error, e:
-            if e.args[0] != errno.EBADF:
-                raise
-
-
-
-

=== modified file 'bzrlib/tests/interrepository_implementations/__init__.py'
--- bzrlib/tests/interrepository_implementations/__init__.py	2008-04-30 20:09:39 +0000
+++ bzrlib/tests/interrepository_implementations/__init__.py	2007-06-28 04:25:15 +0000
@@ -25,25 +25,18 @@
 rather than in tests/interrepository_implementations/*.py.
 """
 
-
-from bzrlib.errors import (
-    FileExists,
-    UninitializableFormat,
-    )
-
 from bzrlib.repository import (
-                               InterKnitRepo,
+                               InterRepository,
+                               InterModel1and2,
                                InterKnit1and2,
-                               InterModel1and2,
-                               InterRepository,
                                )
 from bzrlib.tests import (
                           adapt_modules,
                           default_transport,
+                          TestLoader,
                           TestScenarioApplier,
+                          TestSuite,
                           )
-from bzrlib.tests.bzrdir_implementations.test_bzrdir import TestCaseWithBzrDir
-from bzrlib.transport import get_transport
 
 
 class InterRepositoryTestProviderAdapter(TestScenarioApplier):
@@ -69,10 +62,7 @@
         """
         result = []
         for interrepo_class, repository_format, repository_format_to in formats:
-            id = '%s,%s,%s' % (interrepo_class.__name__,
-                                repository_format.__class__.__name__,
-                                repository_format_to.__class__.__name__)
-            scenario = (id,
+            scenario = (interrepo_class.__name__,
                 {"transport_server":self._transport_server,
                  "transport_readonly_server":self._transport_readonly_server,
                  "repository_format":repository_format,
@@ -85,7 +75,7 @@
     @staticmethod
     def default_test_list():
         """Generate the default list of interrepo permutations to test."""
-        from bzrlib.repofmt import knitrepo, pack_repo, weaverepo
+        from bzrlib.repofmt import knitrepo, weaverepo
         result = []
         # test the default InterRepository between format 6 and the current 
         # default format.
@@ -104,70 +94,15 @@
         result.append((InterModel1and2,
                        weaverepo.RepositoryFormat5(),
                        knitrepo.RepositoryFormatKnit3()))
-        result.append((InterModel1and2,
-                       knitrepo.RepositoryFormatKnit1(),
-                       knitrepo.RepositoryFormatKnit3()))
         result.append((InterKnit1and2,
                        knitrepo.RepositoryFormatKnit1(),
                        knitrepo.RepositoryFormatKnit3()))
-        result.append((InterKnitRepo,
-                       knitrepo.RepositoryFormatKnit1(),
-                       pack_repo.RepositoryFormatKnitPack1()))
-        result.append((InterKnitRepo,
-                       pack_repo.RepositoryFormatKnitPack1(),
-                       knitrepo.RepositoryFormatKnit1()))
-        result.append((InterKnitRepo,
-                       knitrepo.RepositoryFormatKnit3(),
-                       pack_repo.RepositoryFormatKnitPack3()))
-        result.append((InterKnitRepo,
-                       pack_repo.RepositoryFormatKnitPack3(),
-                       knitrepo.RepositoryFormatKnit3()))
         return result
 
 
-class TestCaseWithInterRepository(TestCaseWithBzrDir):
-
-    def setUp(self):
-        super(TestCaseWithInterRepository, self).setUp()
-
-    def make_branch(self, relpath, format=None):
-        repo = self.make_repository(relpath, format=format)
-        return repo.bzrdir.create_branch()
-
-    def make_bzrdir(self, relpath, format=None):
-        try:
-            url = self.get_url(relpath)
-            segments = url.split('/')
-            if segments and segments[-1] not in ('', '.'):
-                parent = '/'.join(segments[:-1])
-                t = get_transport(parent)
-                try:
-                    t.mkdir(segments[-1])
-                except FileExists:
-                    pass
-            if format is None:
-                format = self.repository_format._matchingbzrdir
-            return format.initialize(url)
-        except UninitializableFormat:
-            raise TestSkipped("Format %s is not initializable." % format)
-
-    def make_repository(self, relpath, format=None):
-        made_control = self.make_bzrdir(relpath, format=format)
-        return self.repository_format.initialize(made_control)
-
-    def make_to_repository(self, relpath):
-        made_control = self.make_bzrdir(relpath,
-            self.repository_format_to._matchingbzrdir)
-        return self.repository_format_to.initialize(made_control)
-
-
-def load_tests(basic_tests, module, loader):
-    result = loader.suiteClass()
-    # add the tests for this module
-    result.addTests(basic_tests)
-
+def test_suite():
+    result = TestSuite()
     test_interrepository_implementations = [
-        'bzrlib.tests.interrepository_implementations.test_fetch',
         'bzrlib.tests.interrepository_implementations.test_interrepository',
         ]
     adapter = InterRepositoryTestProviderAdapter(
@@ -177,6 +112,6 @@
         None,
         InterRepositoryTestProviderAdapter.default_test_list()
         )
-    # add the tests for the sub modules
+    loader = TestLoader()
     adapt_modules(test_interrepository_implementations, adapter, loader, result)
     return result

=== removed file 'bzrlib/tests/interrepository_implementations/test_fetch.py'
--- bzrlib/tests/interrepository_implementations/test_fetch.py	2008-08-10 07:00:59 +0000
+++ bzrlib/tests/interrepository_implementations/test_fetch.py	1970-01-01 00:00:00 +0000
@@ -1,217 +0,0 @@
-# Copyright (C) 2005, 2006, 2008 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-
-import sys
-
-import bzrlib
-from bzrlib import (
-    errors,
-    repository,
-    osutils,
-    )
-from bzrlib.errors import (
-    NoSuchRevision,
-    )
-from bzrlib.revision import (
-    NULL_REVISION,
-    Revision,
-    )
-from bzrlib.tests import (
-    TestNotApplicable,
-    )
-from bzrlib.tests.interrepository_implementations import (
-    TestCaseWithInterRepository,
-    )
-from bzrlib.tests.interrepository_implementations.test_interrepository import (
-    check_repo_format_for_funky_id_on_win32
-    )
-
-
-class TestInterRepository(TestCaseWithInterRepository):
-
-    def test_fetch(self):
-        tree_a = self.make_branch_and_tree('a')
-        self.build_tree(['a/foo'])
-        tree_a.add('foo', 'file1')
-        tree_a.commit('rev1', rev_id='rev1')
-        def check_push_rev1(repo):
-            # ensure the revision is missing.
-            self.assertRaises(NoSuchRevision, repo.get_revision, 'rev1')
-            # fetch with a limit of NULL_REVISION and an explicit progress bar.
-            repo.fetch(tree_a.branch.repository,
-                       revision_id=NULL_REVISION,
-                       pb=bzrlib.progress.DummyProgress())
-            # nothing should have been pushed
-            self.assertFalse(repo.has_revision('rev1'))
-            # fetch with a default limit (grab everything)
-            repo.fetch(tree_a.branch.repository)
-            # check that b now has all the data from a's first commit.
-            rev = repo.get_revision('rev1')
-            tree = repo.revision_tree('rev1')
-            tree.lock_read()
-            self.addCleanup(tree.unlock)
-            tree.get_file_text('file1')
-            for file_id in tree:
-                if tree.inventory[file_id].kind == "file":
-                    tree.get_file(file_id).read()
-
-        # makes a target version repo 
-        repo_b = self.make_to_repository('b')
-        check_push_rev1(repo_b)
-
-    def test_fetch_missing_basis_text(self):
-        """If fetching a delta, we should die if a basis is not present."""
-        tree = self.make_branch_and_tree('tree')
-        self.build_tree(['tree/a'])
-        tree.add(['a'], ['a-id'])
-        tree.commit('one', rev_id='rev-one')
-        self.build_tree_contents([('tree/a', 'new contents\n')])
-        tree.commit('two', rev_id='rev-two')
-
-        to_repo = self.make_to_repository('to_repo')
-        # We build a broken revision so that we can test the fetch code dies
-        # properly. So copy the inventory and revision, but not the text.
-        to_repo.lock_write()
-        try:
-            to_repo.start_write_group()
-            inv = tree.branch.repository.get_inventory('rev-one')
-            to_repo.add_inventory('rev-one', inv, [])
-            rev = tree.branch.repository.get_revision('rev-one')
-            to_repo.add_revision('rev-one', rev, inv=inv)
-            to_repo.commit_write_group()
-        finally:
-            to_repo.unlock()
-
-        # Implementations can either ensure that the target of the delta is
-        # reconstructable, or raise an exception (which stream based copies
-        # generally do).
-        try:
-            to_repo.fetch(tree.branch.repository, 'rev-two')
-        except errors.RevisionNotPresent, e:
-            # If an exception is raised, the revision should not be in the
-            # target.
-            self.assertRaises((errors.NoSuchRevision, errors.RevisionNotPresent),
-                              to_repo.revision_tree, 'rev-two')
-        else:
-            # If not exception is raised, then the text should be
-            # available.
-            to_repo.lock_read()
-            try:
-                rt = to_repo.revision_tree('rev-two')
-                self.assertEqual('new contents\n',
-                                 rt.get_file_text('a-id'))
-            finally:
-                to_repo.unlock()
-
-    def test_fetch_missing_revision_same_location_fails(self):
-        repo_a = self.make_repository('.')
-        repo_b = repository.Repository.open('.')
-        try:
-            self.assertRaises(errors.NoSuchRevision, repo_b.fetch, repo_a, revision_id='XXX')
-        except errors.LockError, e:
-            check_old_format_lock_error(self.repository_format)
-
-    def test_fetch_same_location_trivial_works(self):
-        repo_a = self.make_repository('.')
-        repo_b = repository.Repository.open('.')
-        try:
-            repo_a.fetch(repo_b)
-        except errors.LockError, e:
-            check_old_format_lock_error(self.repository_format)
-
-    def test_fetch_missing_text_other_location_fails(self):
-        source_tree = self.make_branch_and_tree('source')
-        source = source_tree.branch.repository
-        target = self.make_to_repository('target')
-    
-        # start by adding a file so the data knit for the file exists in
-        # repositories that have specific files for each fileid.
-        self.build_tree(['source/id'])
-        source_tree.add(['id'], ['id'])
-        source_tree.commit('a', rev_id='a')
-        # now we manually insert a revision with an inventory referencing
-        # 'id' at revision 'b', but we do not insert revision b.
-        # this should ensure that the new versions of files are being checked
-        # for during pull operations
-        inv = source.get_inventory('a')
-        source.lock_write()
-        self.addCleanup(source.unlock)
-        source.start_write_group()
-        inv['id'].revision = 'b'
-        inv.revision_id = 'b'
-        sha1 = source.add_inventory('b', inv, ['a'])
-        rev = Revision(timestamp=0,
-                       timezone=None,
-                       committer="Foo Bar <foo@example.com>",
-                       message="Message",
-                       inventory_sha1=sha1,
-                       revision_id='b')
-        rev.parent_ids = ['a']
-        source.add_revision('b', rev)
-        source.commit_write_group()
-        self.assertRaises(errors.RevisionNotPresent, target.fetch, source)
-        self.assertFalse(target.has_revision('b'))
-
-    def test_fetch_funky_file_id(self):
-        from_tree = self.make_branch_and_tree('tree')
-        if sys.platform == 'win32':
-            from_repo = from_tree.branch.repository
-            check_repo_format_for_funky_id_on_win32(from_repo)
-        self.build_tree(['tree/filename'])
-        from_tree.add('filename', 'funky-chars<>%&;"\'')
-        from_tree.commit('commit filename')
-        to_repo = self.make_to_repository('to')
-        to_repo.fetch(from_tree.branch.repository, from_tree.get_parent_ids()[0])
-
-    def test_fetch_revision_hash(self):
-        """Ensure that inventory hashes are updated by fetch"""
-        from_tree = self.make_branch_and_tree('tree')
-        from_tree.commit('foo', rev_id='foo-id')
-        to_repo = self.make_to_repository('to')
-        to_repo.fetch(from_tree.branch.repository)
-        recorded_inv_sha1 = to_repo.get_inventory_sha1('foo-id')
-        xml = to_repo.get_inventory_xml('foo-id')
-        computed_inv_sha1 = osutils.sha_string(xml)
-        self.assertEqual(computed_inv_sha1, recorded_inv_sha1)
-
-
-class TestFetchDependentData(TestCaseWithInterRepository):
-
-    def test_reference(self):
-        from_tree = self.make_branch_and_tree('tree')
-        to_repo = self.make_to_repository('to')
-        if (not from_tree.supports_tree_reference() or
-            not from_tree.branch.repository._format.supports_tree_reference or
-            not to_repo._format.supports_tree_reference):
-            raise TestNotApplicable("Need subtree support.")
-        subtree = self.make_branch_and_tree('tree/subtree')
-        subtree.commit('subrev 1')
-        from_tree.add_reference(subtree)
-        tree_rev = from_tree.commit('foo')
-        # now from_tree has a last-modified of subtree of the rev id of the
-        # commit for foo, and a reference revision of the rev id of the commit
-        # for subrev 1
-        to_repo.fetch(from_tree.branch.repository, tree_rev)
-        # to_repo should have a file_graph for from_tree.path2id('subtree') and
-        # revid tree_rev.
-        file_id = from_tree.path2id('subtree')
-        to_repo.lock_read()
-        try:
-            self.assertEqual({(file_id, tree_rev):()},
-                to_repo.texts.get_parent_map([(file_id, tree_rev)]))
-        finally:
-            to_repo.unlock()

=== modified file 'bzrlib/tests/interrepository_implementations/test_interrepository.py'
--- bzrlib/tests/interrepository_implementations/test_interrepository.py	2008-06-11 04:20:16 +0000
+++ bzrlib/tests/interrepository_implementations/test_interrepository.py	2007-10-04 01:24:06 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2008 Canonical Ltd
+# Copyright (C) 2005, 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -22,21 +22,60 @@
 import bzrlib.bzrdir as bzrdir
 from bzrlib.branch import Branch, needs_read_lock, needs_write_lock
 import bzrlib.errors as errors
-import bzrlib.gpg
+from bzrlib.errors import (FileExists,
+                           NoSuchRevision,
+                           NoSuchFile,
+                           UninitializableFormat,
+                           NotBranchError,
+                           )
 from bzrlib.inventory import Inventory
 import bzrlib.repofmt.weaverepo as weaverepo
 import bzrlib.repository as repository
 from bzrlib.revision import NULL_REVISION, Revision
-from bzrlib.symbol_versioning import one_two
 from bzrlib.tests import (
     TestCase,
     TestCaseWithTransport,
     TestNotApplicable,
     TestSkipped,
     )
-from bzrlib.tests.interrepository_implementations import (
-    TestCaseWithInterRepository,
-    )
+from bzrlib.tests.bzrdir_implementations.test_bzrdir import TestCaseWithBzrDir
+from bzrlib.transport import get_transport
+
+
+class TestCaseWithInterRepository(TestCaseWithBzrDir):
+
+    def setUp(self):
+        super(TestCaseWithInterRepository, self).setUp()
+
+    def make_branch(self, relpath, format=None):
+        repo = self.make_repository(relpath, format=format)
+        return repo.bzrdir.create_branch()
+
+    def make_bzrdir(self, relpath, format=None):
+        try:
+            url = self.get_url(relpath)
+            segments = url.split('/')
+            if segments and segments[-1] not in ('', '.'):
+                parent = '/'.join(segments[:-1])
+                t = get_transport(parent)
+                try:
+                    t.mkdir(segments[-1])
+                except FileExists:
+                    pass
+            if format is None:
+                format = self.repository_format._matchingbzrdir
+            return format.initialize(url)
+        except UninitializableFormat:
+            raise TestSkipped("Format %s is not initializable." % format)
+
+    def make_repository(self, relpath, format=None):
+        made_control = self.make_bzrdir(relpath, format=format)
+        return self.repository_format.initialize(made_control)
+
+    def make_to_repository(self, relpath):
+        made_control = self.make_bzrdir(relpath,
+            self.repository_format_to._matchingbzrdir)
+        return self.repository_format_to.initialize(made_control)
 
 
 def check_old_format_lock_error(repository_format):
@@ -90,6 +129,112 @@
         ## self.assertEqual(self.interrepo_class, interrepo.__class__)
         pass
 
+    def test_fetch(self):
+        tree_a = self.make_branch_and_tree('a')
+        self.build_tree(['a/foo'])
+        tree_a.add('foo', 'file1')
+        tree_a.commit('rev1', rev_id='rev1')
+        def check_push_rev1(repo):
+            # ensure the revision is missing.
+            self.assertRaises(NoSuchRevision, repo.get_revision, 'rev1')
+            # fetch with a limit of NULL_REVISION and an explicit progress bar.
+            repo.fetch(tree_a.branch.repository,
+                       revision_id=NULL_REVISION,
+                       pb=bzrlib.progress.DummyProgress())
+            # nothing should have been pushed
+            self.assertFalse(repo.has_revision('rev1'))
+            # fetch with a default limit (grab everything)
+            repo.fetch(tree_a.branch.repository)
+            # check that b now has all the data from a's first commit.
+            rev = repo.get_revision('rev1')
+            tree = repo.revision_tree('rev1')
+            tree.get_file_text('file1')
+            for file_id in tree:
+                if tree.inventory[file_id].kind == "file":
+                    tree.get_file(file_id).read()
+
+        # makes a target version repo 
+        repo_b = self.make_to_repository('b')
+        check_push_rev1(repo_b)
+        
+    def test_fetch_missing_revision_same_location_fails(self):
+        repo_a = self.make_repository('.')
+        repo_b = repository.Repository.open('.')
+        try:
+            self.assertRaises(errors.NoSuchRevision, repo_b.fetch, repo_a, revision_id='XXX')
+        except errors.LockError, e:
+            check_old_format_lock_error(self.repository_format)
+
+    def test_fetch_same_location_trivial_works(self):
+        repo_a = self.make_repository('.')
+        repo_b = repository.Repository.open('.')
+        try:
+            repo_a.fetch(repo_b)
+        except errors.LockError, e:
+            check_old_format_lock_error(self.repository_format)
+
+    def test_fetch_missing_text_other_location_fails(self):
+        source_tree = self.make_branch_and_tree('source')
+        source = source_tree.branch.repository
+        target = self.make_to_repository('target')
+    
+        # start by adding a file so the data knit for the file exists in
+        # repositories that have specific files for each fileid.
+        self.build_tree(['source/id'])
+        source_tree.add(['id'], ['id'])
+        source_tree.commit('a', rev_id='a')
+        # now we manually insert a revision with an inventory referencing
+        # 'id' at revision 'b', but we do not insert revision b.
+        # this should ensure that the new versions of files are being checked
+        # for during pull operations
+        inv = source.get_inventory('a')
+        source.lock_write()
+        source.start_write_group()
+        inv['id'].revision = 'b'
+        inv.revision_id = 'b'
+        sha1 = source.add_inventory('b', inv, ['a'])
+        rev = Revision(timestamp=0,
+                       timezone=None,
+                       committer="Foo Bar <foo@example.com>",
+                       message="Message",
+                       inventory_sha1=sha1,
+                       revision_id='b')
+        rev.parent_ids = ['a']
+        source.add_revision('b', rev)
+        source.commit_write_group()
+        source.unlock()
+        self.assertRaises(errors.RevisionNotPresent, target.fetch, source)
+        self.assertFalse(target.has_revision('b'))
+
+    def test_fetch_funky_file_id(self):
+        from_tree = self.make_branch_and_tree('tree')
+        if sys.platform == 'win32':
+            from_repo = from_tree.branch.repository
+            check_repo_format_for_funky_id_on_win32(from_repo)
+        self.build_tree(['tree/filename'])
+        from_tree.add('filename', 'funky-chars<>%&;"\'')
+        from_tree.commit('commit filename')
+        to_repo = self.make_to_repository('to')
+        to_repo.fetch(from_tree.branch.repository, from_tree.get_parent_ids()[0])
+
+    def test_fetch_no_inventory_revision(self):
+        """Old inventories lack revision_ids, so simulate this"""
+        from_tree = self.make_branch_and_tree('tree')
+        if sys.platform == 'win32':
+            from_repo = from_tree.branch.repository
+            check_repo_format_for_funky_id_on_win32(from_repo)
+        self.build_tree(['tree/filename'])
+        from_tree.add('filename', 'funky-chars<>%&;"\'')
+        from_tree.commit('commit filename')
+        old_deserialise = from_tree.branch.repository.deserialise_inventory
+        def deserialise(revision_id, text):
+            inventory = old_deserialise(revision_id, text)
+            inventory.revision_id = None
+            return inventory
+        from_tree.branch.repository.deserialise_inventory = deserialise
+        to_repo = self.make_to_repository('to')
+        to_repo.fetch(from_tree.branch.repository, from_tree.last_revision())
+
 
 class TestCaseWithComplexRepository(TestCaseWithInterRepository):
 
@@ -100,8 +245,8 @@
         # add a corrupt inventory 'orphan'
         tree_a.branch.repository.lock_write()
         tree_a.branch.repository.start_write_group()
-        inv_file = tree_a.branch.repository.inventories
-        inv_file.add_lines(('orphan',), [], [])
+        inv_file = tree_a.branch.repository.get_inventory_weave()
+        inv_file.add_lines('orphan', [], [])
         tree_a.branch.repository.commit_write_group()
         tree_a.branch.repository.unlock()
         # add a real revision 'rev1'
@@ -115,20 +260,7 @@
         tree_a.branch.repository.commit_write_group()
         tree_a.branch.repository.unlock()
 
-    def test_missing_revision_ids_is_deprecated(self):
-        repo_b = self.make_to_repository('rev1_only')
-        repo_a = self.bzrdir.open_repository()
-        repo_b.fetch(repo_a, 'rev1')
-        # check the test will be valid
-        self.assertFalse(repo_b.has_revision('rev2'))
-        self.assertEqual(['rev2'],
-            self.applyDeprecated(one_two, repo_b.missing_revision_ids, repo_a))
-        inter = repository.InterRepository.get(repo_a, repo_b)
-        self.assertEqual(['rev2'],
-            self.applyDeprecated(one_two, inter.missing_revision_ids, None,
-                True))
-
-    def test_search_missing_revision_ids(self):
+    def test_missing_revision_ids(self):
         # revision ids in repository A but not B are returned, fake ones
         # are stripped. (fake meaning no revision object, but an inventory 
         # as some formats keyed off inventory data in the past.)
@@ -138,36 +270,17 @@
         repo_b.fetch(repo_a, 'rev1')
         # check the test will be valid
         self.assertFalse(repo_b.has_revision('rev2'))
-        result = repo_b.search_missing_revision_ids(repo_a)
-        self.assertEqual(set(['rev2']), result.get_keys())
-        self.assertEqual((set(['rev2']), set(['rev1']), 1), result.get_recipe())
-
-    def test_search_missing_revision_ids_absent_requested_raises(self):
-        # Asking for missing revisions with a tip that is itself absent in the
-        # source raises NoSuchRevision.
-        repo_b = self.make_to_repository('target')
-        repo_a = self.bzrdir.open_repository()
-        # No pizza revisions anywhere
-        self.assertFalse(repo_a.has_revision('pizza'))
-        self.assertFalse(repo_b.has_revision('pizza'))
-        # Asking specifically for an absent revision errors.
-        self.assertRaises(errors.NoSuchRevision,
-            repo_b.search_missing_revision_ids, repo_a, revision_id='pizza',
-            find_ghosts=True)
-        self.assertRaises(errors.NoSuchRevision,
-            repo_b.search_missing_revision_ids, repo_a, revision_id='pizza',
-            find_ghosts=False)
-
-    def test_search_missing_revision_ids_revision_limited(self):
+        self.assertEqual(['rev2'],
+                         repo_b.missing_revision_ids(repo_a))
+
+    def test_missing_revision_ids_revision_limited(self):
         # revision ids in repository A that are not referenced by the
         # requested revision are not returned.
         # make a repository to compare against that is empty
         repo_b = self.make_to_repository('empty')
         repo_a = self.bzrdir.open_repository()
-        result = repo_b.search_missing_revision_ids(repo_a, revision_id='rev1')
-        self.assertEqual(set(['rev1']), result.get_keys())
-        self.assertEqual((set(['rev1']), set([NULL_REVISION]), 1),
-            result.get_recipe())
+        self.assertEqual(['rev1'],
+                         repo_b.missing_revision_ids(repo_a, revision_id='rev1'))
         
     def test_fetch_fetches_signatures_too(self):
         from_repo = self.bzrdir.open_repository()
@@ -180,53 +293,73 @@
 
 class TestCaseWithGhosts(TestCaseWithInterRepository):
 
-    def test_fetch_all_fixes_up_ghost(self):
-        # we want two repositories at this point:
+    def setUp(self):
+        super(TestCaseWithGhosts, self).setUp()
+        # we want two repositories at this point
         # one with a revision that is a ghost in the other
         # repository.
-        # 'ghost' is present in has_ghost, 'ghost' is absent in 'missing_ghost'.
-        # 'references' is present in both repositories, and 'tip' is present
-        # just in has_ghost.
-        # has_ghost       missing_ghost
-        #------------------------------
-        # 'ghost'             -
-        # 'references'    'references'
-        # 'tip'               -
-        # In this test we fetch 'tip' which should not fetch 'ghost'
-        has_ghost = self.make_repository('has_ghost')
-        missing_ghost = self.make_repository('missing_ghost')
-        if [True, True] != [repo._format.supports_ghosts for repo in
-            (has_ghost, missing_ghost)]:
-            raise TestNotApplicable("Need ghost support.")
-
-        def add_commit(repo, revision_id, parent_ids):
-            repo.lock_write()
-            repo.start_write_group()
-            inv = Inventory(revision_id=revision_id)
-            inv.root.revision = revision_id
-            root_id = inv.root.file_id
-            sha1 = repo.add_inventory(revision_id, inv, parent_ids)
-            repo.texts.add_lines((root_id, revision_id), [], [])
-            rev = bzrlib.revision.Revision(timestamp=0,
-                                           timezone=None,
-                                           committer="Foo Bar <foo@example.com>",
-                                           message="Message",
-                                           inventory_sha1=sha1,
-                                           revision_id=revision_id)
-            rev.parent_ids = parent_ids
-            repo.add_revision(revision_id, rev)
-            repo.commit_write_group()
-            repo.unlock()
-        add_commit(has_ghost, 'ghost', [])
-        add_commit(has_ghost, 'references', ['ghost'])
-        add_commit(missing_ghost, 'references', ['ghost'])
-        add_commit(has_ghost, 'tip', ['references'])
-        missing_ghost.fetch(has_ghost, 'tip', find_ghosts=True)
-        # missing ghost now has tip and ghost.
-        rev = missing_ghost.get_revision('tip')
-        inv = missing_ghost.get_inventory('tip')
-        rev = missing_ghost.get_revision('ghost')
-        inv = missing_ghost.get_inventory('ghost')
+
+        # 'ghost' is a ghost in missing_ghost and not in with_ghost_rev
+        repo = self.make_repository('with_ghost_rev')
+        repo.lock_write()
+        builder = repo.get_commit_builder(None, [], None,
+            committer="Foo Bar <foo@example.com>",
+            revision_id='ghost')
+        ie = bzrlib.inventory.InventoryDirectory('TREE_ROOT', '', None)
+        builder.record_entry_contents(ie, [], '', None,
+            ('directory', None, None, None))
+        builder.finish_inventory()
+        builder.commit("Message")
+        repo.unlock()
+         
+        repo = self.make_to_repository('missing_ghost')
+        inv = Inventory(revision_id='with_ghost')
+        inv.root.revision = 'with_ghost'
+        repo.lock_write()
+        repo.start_write_group()
+        sha1 = repo.add_inventory('with_ghost', inv, [])
+        rev = bzrlib.revision.Revision(timestamp=0,
+                                       timezone=None,
+                                       committer="Foo Bar <foo@example.com>",
+                                       message="Message",
+                                       inventory_sha1=sha1,
+                                       revision_id='with_ghost')
+        rev.parent_ids = ['ghost']
+        repo.add_revision('with_ghost', rev)
+        repo.commit_write_group()
+        repo.unlock()
+
+    def test_fetch_all_fixes_up_ghost(self):
+        # fetching from a repo with a current ghost unghosts it in referencing
+        # revisions.
+        repo = repository.Repository.open('missing_ghost')
+        rev = repo.get_revision('with_ghost')
+        from_repo = repository.Repository.open('with_ghost_rev')
+        repo.fetch(from_repo)
         # rev must not be corrupt now
-        self.assertEqual([None, 'ghost', 'references', 'tip'],
-            missing_ghost.get_ancestry('tip'))
+        rev = repo.get_revision('with_ghost')
+        self.assertEqual([None, 'ghost', 'with_ghost'], repo.get_ancestry('with_ghost'))
+
+
+class TestFetchDependentData(TestCaseWithInterRepository):
+
+    def test_reference(self):
+        from_tree = self.make_branch_and_tree('tree')
+        to_repo = self.make_to_repository('to')
+        if (not from_tree.supports_tree_reference() or
+            not from_tree.branch.repository._format.supports_tree_reference or
+            not to_repo._format.supports_tree_reference):
+            raise TestNotApplicable("Need subtree support.")
+        subtree = self.make_branch_and_tree('tree/subtree')
+        subtree.commit('subrev 1')
+        from_tree.add_reference(subtree)
+        tree_rev = from_tree.commit('foo')
+        # now from_tree has a last-modified of subtree of the rev id of the
+        # commit for foo, and a reference revision of the rev id of the commit
+        # for subrev 1
+        to_repo.fetch(from_tree.branch.repository, tree_rev)
+        # to_repo should have a file_graph for from_tree.path2id('subtree') and
+        # revid tree_rev.
+        file_vf = to_repo.weave_store.get_weave(
+            from_tree.path2id('subtree'), to_repo.get_transaction())
+        self.assertEqual([tree_rev], file_vf.get_ancestry([tree_rev]))

=== modified file 'bzrlib/tests/intertree_implementations/__init__.py'
--- bzrlib/tests/intertree_implementations/__init__.py	2008-04-28 08:57:45 +0000
+++ bzrlib/tests/intertree_implementations/__init__.py	2007-06-28 07:15:28 +0000
@@ -27,6 +27,8 @@
 from bzrlib.tests import (
                           adapt_modules,
                           default_transport,
+                          TestLoader,
+                          TestSuite,
                           )
 from bzrlib.tests.tree_implementations import (
     return_parameter,
@@ -87,16 +89,17 @@
                 "mutable_trees_to_test_trees":mutable_trees_to_test_trees,
                 # workingtree_to_test_tree is set to disable changing individual,
                 # trees: instead the mutable_trees_to_test_trees helper is used.,
-                "_workingtree_to_test_tree": return_parameter,
+                "workingtree_to_test_tree":return_parameter,
                 })
             result.append(scenario)
         return result
 
 
-def load_tests(basic_tests, module, loader):
-    result = loader.suiteClass()
+def test_suite():
+    result = TestSuite()
+    loader = TestLoader()
     # load the tests of the infrastructure for these tests
-    result.addTests(basic_tests)
+    result.addTests(loader.loadTestsFromModuleNames(['bzrlib.tests.intertree_implementations']))
 
     default_tree_format = WorkingTreeFormat3()
     test_intertree_implementations = [
@@ -118,6 +121,5 @@
         # by the TestCaseWithTransport.get_readonly_transport method.
         None,
         test_intertree_permutations)
-    # add the tests for the sub modules
     adapt_modules(test_intertree_implementations, adapter, loader, result)
     return result

=== modified file 'bzrlib/tests/intertree_implementations/test_compare.py'
--- bzrlib/tests/intertree_implementations/test_compare.py	2008-08-14 06:54:35 +0000
+++ bzrlib/tests/intertree_implementations/test_compare.py	2007-09-05 03:23:20 +0000
@@ -21,7 +21,6 @@
 
 from bzrlib import errors, tests, workingtree_4
 from bzrlib.osutils import file_kind, has_symlinks
-from bzrlib.tests import TestNotApplicable
 from bzrlib.tests.intertree_implementations import TestCaseWithTwoTrees
 
 # TODO: test the include_root option.
@@ -345,11 +344,11 @@
     """Test the comparison iterator"""
 
     def do_iter_changes(self, tree1, tree2, **extra_args):
-        """Helper to run iter_changes from tree1 to tree2.
+        """Helper to run _iter_changes from tree1 to tree2.
         
         :param tree1, tree2:  The source and target trees. These will be locked
             automatically.
-        :param **extra_args: Extra args to pass to iter_changes. This is not
+        :param **extra_args: Extra args to pass to _iter_changes. This is not
             inspected by this test helper.
         """
         tree1.lock_read()
@@ -357,7 +356,7 @@
         try:
             # sort order of output is not strictly defined
             return sorted(self.intertree_class(tree1, tree2)
-                .iter_changes(**extra_args))
+                ._iter_changes(**extra_args))
         finally:
             tree1.unlock()
             tree2.unlock()
@@ -696,38 +695,6 @@
             ])
         self.assertEqual(expected, self.do_iter_changes(tree1, tree2))
 
-    def test_only_in_source_and_missing(self):
-        tree1 = self.make_branch_and_tree('tree1')
-        tree2 = self.make_to_branch_and_tree('tree2')
-        tree2.set_root_id(tree1.get_root_id())
-        self.build_tree(['tree1/file'])
-        tree1.add(['file'], ['file-id'])
-        os.unlink('tree1/file')
-        tree1, tree2 = self.mutable_trees_to_locked_test_trees(tree1, tree2)
-        root_id = tree1.path2id('')
-        if not tree1.path2id('file'):
-            # The locked test trees conversion could not preserve the missing
-            # file status. This is normal (e.g. InterDirstateTree falls back
-            # to InterTree if the basis is not a DirstateRevisionTree, and
-            # revision trees cannot have missing files. 
-            raise TestNotApplicable()
-        expected = [('file-id', ('file', None), False, (True, False),
-            (root_id, None), ('file', None), (None, None), (False, None))]
-        self.assertEqual(expected, self.do_iter_changes(tree1, tree2))
-
-    def test_only_in_target_and_missing(self):
-        tree1 = self.make_branch_and_tree('tree1')
-        tree2 = self.make_to_branch_and_tree('tree2')
-        tree2.set_root_id(tree1.get_root_id())
-        self.build_tree(['tree2/file'])
-        tree2.add(['file'], ['file-id'])
-        os.unlink('tree2/file')
-        tree1, tree2 = self.mutable_trees_to_locked_test_trees(tree1, tree2)
-        root_id = tree1.path2id('')
-        expected = [('file-id', (None, 'file'), False, (False, True),
-            (None, root_id), (None, 'file'), (None, None), (None, False))]
-        self.assertEqual(expected, self.do_iter_changes(tree1, tree2))
-
     def test_unchanged_with_renames_and_modifications(self):
         """want_unchanged should generate a list of unchanged entries."""
         tree1 = self.make_branch_and_tree('1')
@@ -762,7 +729,7 @@
         tree2.add_reference(subtree2)
         tree1, tree2 = self.mutable_trees_to_locked_test_trees(tree1, tree2)
 
-        self.assertEqual([], list(tree2.iter_changes(tree1)))
+        self.assertEqual([], list(tree2._iter_changes(tree1)))
         subtree1.commit('commit', rev_id='commit-a')
         self.assertEqual([
             ('root-id',
@@ -781,7 +748,7 @@
              ('sub', 'sub'),
              ('tree-reference', 'tree-reference'),
              (False, False))],
-                         list(tree2.iter_changes(tree1,
+                         list(tree2._iter_changes(tree1,
                              include_unchanged=True)))
 
     def test_disk_in_subtrees_skipped(self):
@@ -986,6 +953,7 @@
         tree2.set_root_id(tree1.get_root_id())
         self.build_tree(['tree1/fromfile', 'tree1/fromdir/'])
         self.build_tree(['tree2/tofile', 'tree2/todir/', 'tree2/unknown'])
+        # try:
         os.symlink('original', 'tree1/changed')
         os.symlink('original', 'tree1/removed')
         os.symlink('original', 'tree1/tofile')
@@ -1018,10 +986,14 @@
             ]
         tree1.add(from_paths_and_ids, from_paths_and_ids)
         tree2.add(to_paths_and_ids, to_paths_and_ids)
+        # except ???:
+        #   raise TestSkipped('OS does not support symlinks')
+        #   links_supported = False
         return self.mutable_trees_to_locked_test_trees(tree1, tree2)
 
     def test_versioned_symlinks(self):
-        self.requireFeature(tests.SymlinkFeature)
+        if not has_symlinks():
+            raise tests.TestSkipped("No symlink support")
         tree1, tree2 = self.make_trees_with_symlinks()
         root_id = tree1.path2id('')
         expected = [
@@ -1042,7 +1014,8 @@
                 want_unversioned=True))
 
     def test_versioned_symlinks_specific_files(self):
-        self.requireFeature(tests.SymlinkFeature)
+        if not has_symlinks():
+            raise tests.TestSkipped("No symlink support")
         tree1, tree2 = self.make_trees_with_symlinks()
         root_id = tree1.path2id('')
         expected = [

=== added directory 'bzrlib/tests/interversionedfile_implementations'
=== added file 'bzrlib/tests/interversionedfile_implementations/__init__.py'
--- bzrlib/tests/interversionedfile_implementations/__init__.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/interversionedfile_implementations/__init__.py	2007-06-28 06:16:19 +0000
@@ -0,0 +1,106 @@
+# Copyright (C) 2006 Canonical Ltd
+# Authors: Robert Collins <robert.collins@canonical.com>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+
+"""InterVersioned implementation tests for bzr.
+
+These test the conformance of all the interversionedfile variations to the
+expected API including generally applicable corner cases.
+Specific tests for individual cases are in the tests/test_versionedfile.py file 
+rather than in tests/interversionedfile_implementations/*.py.
+"""
+
+from bzrlib.tests import (
+                          adapt_modules,
+                          default_transport,
+                          TestLoader,
+                          TestScenarioApplier,
+                          TestSuite,
+                          )
+
+
+class InterVersionedFileTestProviderAdapter(TestScenarioApplier):
+    """A tool to generate a suite testing multiple inter versioned-file classes.
+
+    This is done by copying the test once for each InterVersionedFile provider
+    and injecting the transport_server, transport_readonly_server,
+    versionedfile_factory and versionedfile_factory_to classes into each copy.
+    Each copy is also given a new id() to make it easy to identify.
+    """
+
+    def __init__(self, transport_server, transport_readonly_server, formats):
+        self._transport_server = transport_server
+        self._transport_readonly_server = transport_readonly_server
+        self.scenarios = self.formats_to_scenarios(formats)
+    
+    def formats_to_scenarios(self, formats):
+        """Transform the input formats to a list of scenarios.
+
+        :param formats: A list of tuples:
+            (interversionedfile_class, versionedfile_factory,
+             versionedfile_factory_to).
+        """
+        result = []
+        for (interversionedfile_class,
+             versionedfile_factory,
+             versionedfile_factory_to) in formats:
+            scenario = (interversionedfile_class.__name__, {
+                "transport_server":self._transport_server,
+                "transport_readonly_server":self._transport_readonly_server,
+                "interversionedfile_class":interversionedfile_class,
+                "versionedfile_factory":versionedfile_factory,
+                "versionedfile_factory_to":versionedfile_factory_to,
+                })
+            result.append(scenario)
+        return result
+
+    @staticmethod
+    def default_test_list():
+        """Generate the default list of interversionedfile permutations to test."""
+        from bzrlib.versionedfile import InterVersionedFile
+        from bzrlib.weave import WeaveFile
+        from bzrlib.knit import KnitVersionedFile
+        result = []
+        # test the fallback InterVersionedFile from annotated knits to weave
+        result.append((InterVersionedFile,
+                       KnitVersionedFile,
+                       WeaveFile))
+        for optimiser in InterVersionedFile._optimisers:
+            result.append((optimiser,
+                           optimiser._matching_file_from_factory,
+                           optimiser._matching_file_to_factory
+                           ))
+        # if there are specific combinations we want to use, we can add them 
+        # here.
+        return result
+
+
+def test_suite():
+    result = TestSuite()
+    test_interversionedfile_implementations = [
+        'bzrlib.tests.interversionedfile_implementations.test_join',
+        ]
+    adapter = InterVersionedFileTestProviderAdapter(
+        default_transport,
+        # None here will cause a readonly decorator to be created
+        # by the TestCaseWithTransport.get_readonly_transport method.
+        None,
+        InterVersionedFileTestProviderAdapter.default_test_list()
+        )
+    loader = TestLoader()
+    adapt_modules(test_interversionedfile_implementations, adapter, loader, result)
+    return result

=== added file 'bzrlib/tests/interversionedfile_implementations/test_join.py'
--- bzrlib/tests/interversionedfile_implementations/test_join.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/interversionedfile_implementations/test_join.py	2007-09-19 05:14:14 +0000
@@ -0,0 +1,298 @@
+# Copyright (C) 2006 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+"""Tests for join between versioned files."""
+
+
+import bzrlib.errors as errors
+from bzrlib.tests import TestCaseWithTransport
+from bzrlib.transport import get_transport
+import bzrlib.versionedfile as versionedfile
+
+
+class TestJoin(TestCaseWithTransport):
+    #Tests have self.versionedfile_factory and self.versionedfile_factory_to
+    #available to create source and target versioned files respectively.
+
+    def get_source(self, name='source'):
+        """Get a versioned file we will be joining from."""
+        return self.versionedfile_factory(name,
+                                          get_transport(self.get_url()),
+                                          create=True)
+
+    def get_target(self, name='target', create=True):
+        """"Get an empty versioned file to join into."""
+        return self.versionedfile_factory_to(name,
+                                             get_transport(self.get_url()),
+                                             create=create)
+
+    def test_join(self):
+        f1 = self.get_source()
+        f1.add_lines('r0', [], ['a\n', 'b\n'])
+        f1.add_lines('r1', ['r0'], ['c\n', 'b\n'])
+        f2 = self.get_target()
+        f2.join(f1, None)
+        def verify_file(f):
+            self.assertTrue(f.has_version('r0'))
+            self.assertTrue(f.has_version('r1'))
+        verify_file(f2)
+        verify_file(self.get_target())
+
+        self.assertRaises(errors.RevisionNotPresent,
+            f2.join, f1, version_ids=['r3'])
+
+    def test_gets_expected_inter_worker(self):
+        source = self.get_source()
+        target = self.get_target()
+        inter = versionedfile.InterVersionedFile.get(source, target)
+        self.assertTrue(isinstance(inter, self.interversionedfile_class))
+
+    def test_join_versions_joins_ancestors_not_siblings(self):
+        # joining with a version list should bring in ancestors of the
+        # named versions but not siblings thereof.
+        target = self.get_target()
+        target.add_lines('base', [], [])
+        source = self.get_source()
+        source.add_lines('base', [], [])
+        source.add_lines('sibling', ['base'], [])
+        source.add_lines('ancestorleft', ['base'], [])
+        source.add_lines('ancestorright', ['base'], [])
+        source.add_lines('namedleft', ['ancestorleft'], [])
+        source.add_lines('namedright', ['ancestorright'], [])
+        target.join(source, version_ids=['namedleft', 'namedright'])
+        self.assertFalse(target.has_version('sibling'))
+        self.assertTrue(target.has_version('ancestorleft'))
+        self.assertTrue(target.has_version('ancestorright'))
+        self.assertTrue(target.has_version('namedleft'))
+        self.assertTrue(target.has_version('namedright'))
+
+    def test_join_different_parents_existing_version(self):
+        """This may either ignore or error."""
+        w1 = self.get_target('w1')
+        w2 = self.get_source('w2')
+        w1.add_lines('v-1', [], ['line 1\n'])
+        w2.add_lines('v-2', [], ['line 2\n'])
+        w1.add_lines('v-3', ['v-1'], ['line 1\n'])
+        w2.add_lines('v-3', ['v-2'], ['line 1\n'])
+        try:
+            w1.join(w2)
+        except errors.WeaveParentMismatch:
+            # Acceptable behaviour:
+            return
+        self.assertEqual(sorted(w1.versions()),
+                         'v-1 v-2 v-3'.split())
+        self.assertEqualDiff(w1.get_text('v-3'),
+                'line 1\n')
+        self.assertEqual(sorted(w1.get_parents('v-3')),
+                ['v-1'])
+        ann = list(w1.annotate('v-3'))
+        self.assertEqual(len(ann), 1)
+        self.assertEqual(ann[0][0], 'v-1')
+        self.assertEqual(ann[0][1], 'line 1\n')
+        
+    def build_weave1(self):
+        weave1 = self.get_source()
+        self.lines1 = ['hello\n']
+        self.lines3 = ['hello\n', 'cruel\n', 'world\n']
+        weave1.add_lines('v1', [], self.lines1)
+        weave1.add_lines('v2', ['v1'], ['hello\n', 'world\n'])
+        weave1.add_lines('v3', ['v2'], self.lines3)
+        return weave1
+        
+    def test_join_with_empty(self):
+        """Reweave adding empty weave"""
+        wb = self.get_target()
+        w1 = self.build_weave1()
+        w1.join(wb)
+        self.verify_weave1(w1)
+
+    def verify_weave1(self, w1):
+        self.assertEqual(sorted(w1.versions()), ['v1', 'v2', 'v3'])
+        self.assertEqual(w1.get_lines('v1'), ['hello\n'])
+        self.assertEqual([], w1.get_parents('v1'))
+        self.assertEqual(w1.get_lines('v2'), ['hello\n', 'world\n'])
+        self.assertEqual(['v1'], w1.get_parents('v2'))
+        self.assertEqual(w1.get_lines('v3'), ['hello\n', 'cruel\n', 'world\n'])
+        self.assertEqual(['v2'], w1.get_parents('v3'))
+
+    def test_join_source_has_less_parents_preserves_parents(self):
+        # when the target has a text with more parent info, join 
+        # preserves that.
+        s = self.get_source()
+        s.add_lines('base', [], [])
+        s.add_lines('text', [], [])
+        t = self.get_target()
+        t.add_lines('base', [], [])
+        t.add_lines('text', ['base'], [])
+        t.join(s)
+        self.assertEqual(['base'], t.get_parents('text'))
+
+    def test_join_with_ghosts(self):
+        """Join that inserts parents of an existing revision.
+
+        This can happen when merging from another branch who knows about
+        revisions the destination does not, and the destinations index is
+        incorrect because it was or is using a ghost-unaware format to
+        represent the index. In this test the second weave knows of an
+        additional parent of v2.
+        
+        However v2 must not be changed because we consider indexes immutable:
+        instead a check or reconcile operation locally should pickup that v2 is
+        wrong and regenerate the index at a later time. So either this errors,
+        or leaves v2 unaltered.
+        """
+        w1 = self.build_weave1()
+        wb = self.get_target()
+        wb.add_lines('x1', [], ['line from x1\n'])
+        wb.add_lines('v1', [], ['hello\n'])
+        wb.add_lines('v2', ['v1', 'x1'], ['hello\n', 'world\n'])
+        try:
+            w1.join(wb)
+        except errors.WeaveParentMismatch:
+            # Acceptable behaviour:
+            return
+        self.assertEqual(['v1', 'v2', 'v3', 'x1',], sorted(w1.versions()))
+        self.assertEqual('line from x1\n', w1.get_text('x1'))
+        self.assertEqual(['hello\n', 'world\n'], w1.get_lines('v2'))
+        self.assertEqual(['v1'], w1.get_parents('v2'))
+
+    def test_join_with_ignore_missing_versions(self):
+        # test that ignore_missing=True makes a listed but absent version id
+        # be ignored, and that unlisted version_ids are not integrated.
+        w1 = self.build_weave1()
+        wb = self.get_target()
+        wb.add_lines('x1', [], ['line from x1\n'])
+        wb.add_lines('v1', [], ['hello\n'])
+        wb.add_lines('v2', ['v1', 'x1'], ['hello\n', 'world\n'])
+        w1.join(wb, version_ids=['x1', 'z1'], ignore_missing=True)
+        eq = self.assertEquals
+        eq(sorted(w1.versions()), ['v1', 'v2', 'v3', 'x1'])
+        eq(w1.get_text('x1'), 'line from x1\n')
+        eq(w1.get_lines('v2'), ['hello\n', 'world\n'])
+        eq(w1.get_parents('v2'), ['v1'])
+    
+    def build_source_weave(self, name, *pattern):
+        w = self.get_source(name)
+        for version, parents in pattern:
+            w.add_lines(version, parents, [])
+        return w
+
+    def build_target_weave(self, name, *pattern):
+        w = self.get_target(name)
+        for version, parents in pattern:
+            w.add_lines(version, parents, [])
+        return w
+        
+    def test_joining_ghosts(self):
+        # some versioned file formats allow lines to be added with parent
+        # information that is > than that in the format. Formats that do
+        # not support this need to raise NotImplementedError on the
+        # add_lines_with_ghosts api.
+        # files with ghost information when joined into a file which
+        # supports that must preserve it, when joined into a file which
+        # does not must discard it, and when filling a ghost for a listed
+        # ghost must reconcile it
+        source = self.get_source()
+        try:
+            source.has_ghost('a')
+            source_ghosts = True
+        except NotImplementedError:
+            source_ghosts = False
+        target = self.get_target()
+        try:
+            target.has_ghost('a')
+            target_ghosts = True
+        except NotImplementedError:
+            target_ghosts = False
+
+        if not source_ghosts and not target_ghosts:
+            # nothing to do
+            return
+        if source_ghosts and not target_ghosts:
+            # switch source and target so source is ghostless
+            t = source
+            source = target
+            target = t
+            source_ghosts = False
+            target_ghosts = True
+        # now target always supports ghosts.
+
+        # try filling target with ghosts and filling in reverse -  
+        target.add_lines_with_ghosts('notbase', ['base'], [])
+        source.join(target)
+        # legacy apis should behave
+        self.assertEqual(['notbase'], source.get_ancestry(['notbase']))
+        self.assertEqual([], source.get_parents('notbase'))
+        self.assertEqual({'notbase':()}, source.get_graph())
+        self.assertFalse(source.has_version('base'))
+        if source_ghosts:
+            # ghost data should have been preserved
+            self.assertEqual(['base', 'notbase'], source.get_ancestry_with_ghosts(['notbase']))
+            self.assertEqual(['base'], source.get_parents_with_ghosts('notbase'))
+            self.assertEqual({'notbase':['base']}, source.get_graph_with_ghosts())
+            self.assertTrue(source.has_ghost('base'))
+
+        # if we add something that is fills out what is a ghost, then 
+        # when joining into a ghost aware join it should flesh out the ghosts.
+        source.add_lines('base', [], [])
+        target.join(source, version_ids=['base']) 
+        self.assertEqual(['base', 'notbase'], target.get_ancestry(['notbase']))
+        self.assertEqual(['base'], target.get_parents('notbase'))
+        self.assertEqual({'base':(),
+                          'notbase':('base', ),
+                          },
+                         target.get_graph())
+        self.assertTrue(target.has_version('base'))
+        # we have _with_ghost apis to give us ghost information.
+        self.assertEqual(['base', 'notbase'], target.get_ancestry_with_ghosts(['notbase']))
+        self.assertEqual(['base'], target.get_parents_with_ghosts('notbase'))
+        self.assertEqual({'base':[],
+                          'notbase':['base'],
+                          },
+                         target.get_graph_with_ghosts())
+        self.assertFalse(target.has_ghost('base'))
+
+    def test_restricted_join_into_empty(self):
+        # joining into an empty versioned file with a version_ids list
+        # should only grab the selected versions.
+        source = self.get_source()
+        source.add_lines('skip_me', [], ['a\n'])
+        source.add_lines('inherit_me', [], ['b\n'])
+        source.add_lines('select_me', ['inherit_me'], ['b\n'])
+        target = self.get_target()
+        target.join(source, version_ids=['select_me'])
+        self.assertEqual(['inherit_me', 'select_me'], target.versions())
+
+    def test_join_odd_records(self):
+        # this tests that joining the 1st, 3rd and 5th records and not the
+        # 2nd and 4th works, particularly after reopening the file.
+        # this test is designed to test versioned files that perform
+        # optimisations on the join. Grabbing partial data and reopening the
+        # file make it likely to trigger a fault.
+        source = self.get_source()
+        source.add_lines('1', [], ['1st\n'])
+        source.add_lines('2', [], ['2nd\n'])
+        source.add_lines('3', ['1'], ['1st\n', '2nd\n'])
+        source.add_lines('4', ['2'], ['1st\n'])
+        source.add_lines('5', ['3'], ['1st\n', '2nd\n', '3rd\n'])
+        target = self.get_target()
+        target.join(source, version_ids=['1', '3', '5'])
+        target = self.get_target(create=False)
+        self.assertEqual(set(['1', '3', '5']), set(target.versions()))
+        self.assertEqual(3, len(target.versions()))
+        self.assertEqual(['1st\n'], target.get_lines('1'))
+        self.assertEqual(['1st\n', '2nd\n'], target.get_lines('3'))
+        self.assertEqual(['1st\n', '2nd\n', '3rd\n'], target.get_lines('5'))

=== modified file 'bzrlib/tests/inventory_implementations/__init__.py'
--- bzrlib/tests/inventory_implementations/__init__.py	2008-04-28 08:57:45 +0000
+++ bzrlib/tests/inventory_implementations/__init__.py	2007-09-03 04:45:38 +0000
@@ -16,7 +16,24 @@
 
 """Tests for different inventory implementations"""
 
+# NOTE: Don't import Inventory here, to make sure that we don't accidentally
+# hardcode that when we should be using self.make_inventory
+
+from bzrlib import (
+        errors,
+        )
+
+from bzrlib.inventory import (
+        InventoryDirectory,
+        InventoryEntry,
+        InventoryFile,
+        InventoryLink,
+        ROOT_ID,
+        TreeReference,
+        )
+
 from bzrlib.tests import (
+        TestCase,
         multiply_tests_from_modules,
         )
 
@@ -33,17 +50,10 @@
     yield ('Inventory', dict(inventory_class=Inventory))
 
 
-def load_tests(basic_tests, module, loader):
+def test_suite():
     """Generate suite containing all parameterized tests"""
-    suite = loader.suiteClass()
-    # add the tests for this module
-    suite.addTests(basic_tests)
-
     modules_to_test = [
-        'bzrlib.tests.inventory_implementations.basics',
-        ]
-    # add the tests for the sub modules
-    suite.addTests(multiply_tests_from_modules(modules_to_test,
-                                               _inventory_test_scenarios(),
-                                               loader))
-    return suite
+            'bzrlib.tests.inventory_implementations.basics',
+            ]
+    return multiply_tests_from_modules(modules_to_test,
+            _inventory_test_scenarios())

=== modified file 'bzrlib/tests/inventory_implementations/basics.py'
--- bzrlib/tests/inventory_implementations/basics.py	2008-08-09 00:45:30 +0000
+++ bzrlib/tests/inventory_implementations/basics.py	2007-09-20 07:03:33 +0000
@@ -65,30 +65,6 @@
         self.assertEqual('hello-id', ie.file_id)
         self.assertEqual('file', ie.kind)
 
-    def test_copy(self):
-        """Make sure copy() works and creates a deep copy."""
-        inv = self.make_inventory(root_id='some-tree-root')
-        ie = inv.add_path('hello', 'file', 'hello-id')
-        inv2 = inv.copy()
-        inv.root.file_id = 'some-new-root'
-        ie.name = 'file2'
-        self.assertEqual('some-tree-root', inv2.root.file_id)
-        self.assertEqual('hello', inv2['hello-id'].name)
-
-    def test_copy_empty(self):
-        """Make sure an empty inventory can be copied."""
-        inv = self.make_inventory(root_id=None)
-        inv2 = inv.copy()
-        self.assertIs(None, inv2.root)
-
-    def test_copy_copies_root_revision(self):
-        """Make sure the revision of the root gets copied."""
-        inv = self.make_inventory(root_id='someroot')
-        inv.root.revision = 'therev'
-        inv2 = inv.copy()
-        self.assertEquals('someroot', inv2.root.file_id)
-        self.assertEquals('therev', inv2.root.revision)
-
     def test_is_root(self):
         """Ensure our root-checking code is accurate."""
         inv = self.make_inventory('TREE_ROOT')

=== modified file 'bzrlib/tests/per_lock/__init__.py'
--- bzrlib/tests/per_lock/__init__.py	2008-04-28 08:57:45 +0000
+++ bzrlib/tests/per_lock/__init__.py	2007-03-14 23:40:34 +0000
@@ -63,16 +63,13 @@
         return result
 
 
-def load_tests(basic_tests, module, loader):
-    result = loader.suiteClass()
-    # add the tests for this module
-    result.addTests(basic_tests)
-
+def test_suite():
+    result = tests.TestSuite()
     test_lock_implementations = [
         'bzrlib.tests.per_lock.test_lock',
         'bzrlib.tests.per_lock.test_temporary_write_lock',
         ]
     adapter = LockTestProviderAdapter(lock._lock_classes)
-    # add the tests for the sub modules
+    loader = tests.TestLoader()
     tests.adapt_modules(test_lock_implementations, adapter, loader, result)
     return result

=== removed directory 'bzrlib/tests/per_repository_reference'
=== removed file 'bzrlib/tests/per_repository_reference/__init__.py'
--- bzrlib/tests/per_repository_reference/__init__.py	2008-06-06 08:20:03 +0000
+++ bzrlib/tests/per_repository_reference/__init__.py	1970-01-01 00:00:00 +0000
@@ -1,102 +0,0 @@
-# Copyright (C) 2008 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-
-"""Repository implementation tests for external reference repositories.
-
-These tests check the conformance of repositories which refer to other
-repositories for some data, and are run for each repository format supporting
-this.
-"""
-
-from bzrlib import (
-    repository,
-    remote,
-    )
-from bzrlib.bzrdir import BzrDir
-from bzrlib.tests import (
-                          adapt_modules,
-                          adapt_tests,
-                          TestScenarioApplier,
-                          TestSuite,
-                          )
-from bzrlib.tests.repository_implementations import (
-    all_repository_format_scenarios,
-    TestCaseWithRepository,
-    )
-
-
-class TestCaseWithExternalReferenceRepository(TestCaseWithRepository):
-
-    def make_referring(self, relpath, target_path):
-        """Get a new repository that refers to a_repository.
-        
-        :param relpath: The path to create the repository at.
-        :param a_repository: A repository to refer to.
-        """
-        repo = self.make_repository(relpath)
-        repo.add_fallback_repository(self.readonly_repository(target_path))
-        return repo
-
-    def readonly_repository(self, relpath):
-        return BzrDir.open_from_transport(
-            self.get_readonly_transport(relpath)).open_repository()
-
-
-class TestCorrectFormat(TestCaseWithExternalReferenceRepository):
-
-    def test_repository_format(self):
-        # make sure the repository on tree.branch is of the desired format,
-        # because developers use this api to setup the tree, branch and 
-        # repository for their tests: having it not give the right repository
-        # type would invalidate the tests.
-        self.make_branch_and_tree('repo')
-        repo = self.make_referring('referring', 'repo')
-        self.assertIsInstance(repo._format,
-            self.repository_format.__class__)
-
-
-def external_reference_test_scenarios():
-    """Generate test scenarios for repositories supporting external references.
-    """
-    result = []
-    for test_name, scenario_info in all_repository_format_scenarios():
-        # For remote repositories, we need at least one external reference
-        # capable format to test it: defer this until landing such a format.
-        # if isinstance(format, remote.RemoteRepositoryFormat):
-        #     scenario[1]['bzrdir_format'].repository_format = 
-        if scenario_info['repository_format'].supports_external_lookups:
-            result.append((test_name, scenario_info))
-    return result
-
-
-def load_tests(standard_tests, module, loader):
-    adapter = TestScenarioApplier()
-    adapter.scenarios = external_reference_test_scenarios()
-
-    module_list = [
-        'bzrlib.tests.per_repository_reference.test_add_inventory',
-        'bzrlib.tests.per_repository_reference.test_add_revision',
-        'bzrlib.tests.per_repository_reference.test_add_signature_text',
-        'bzrlib.tests.per_repository_reference.test_all_revision_ids',
-        'bzrlib.tests.per_repository_reference.test_break_lock',
-        'bzrlib.tests.per_repository_reference.test_check',
-        ]
-    # Parameterize repository_implementations test modules by format.
-    result = TestSuite()
-    adapt_tests(standard_tests, adapter, result)
-    adapt_modules(module_list, adapter, loader, result)
-    return result

=== removed file 'bzrlib/tests/per_repository_reference/test_add_inventory.py'
--- bzrlib/tests/per_repository_reference/test_add_inventory.py	2008-06-12 04:15:26 +0000
+++ bzrlib/tests/per_repository_reference/test_add_inventory.py	1970-01-01 00:00:00 +0000
@@ -1,49 +0,0 @@
-# Copyright (C) 2008 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Tests for add_inventory on a repository with external references."""
-
-from bzrlib import errors
-from bzrlib.tests.per_repository_reference import (
-    TestCaseWithExternalReferenceRepository,
-    )
-
-
-class TestAddInventory(TestCaseWithExternalReferenceRepository):
-
-    def test_add_inventory_goes_to_repo(self):
-        # adding an inventory only writes to the repository add_inventory is
-        # called on.
-        tree = self.make_branch_and_tree('sample')
-        revid = tree.commit('one')
-        inv = tree.branch.repository.get_inventory(revid)
-        base = self.make_repository('base')
-        repo = self.make_referring('referring', 'base')
-        repo.lock_write()
-        try:
-            repo.start_write_group()
-            try:
-                repo.add_inventory(revid, inv, [])
-            except:
-                repo.abort_write_group()
-                raise
-            else:
-                repo.commit_write_group()
-        finally:
-            repo.unlock()
-        inv2 = repo.get_inventory(revid)
-        self.assertEqual(inv._byid, inv2._byid)
-        self.assertRaises(errors.NoSuchRevision, base.get_inventory, revid)

=== removed file 'bzrlib/tests/per_repository_reference/test_add_revision.py'
--- bzrlib/tests/per_repository_reference/test_add_revision.py	2008-06-06 08:20:03 +0000
+++ bzrlib/tests/per_repository_reference/test_add_revision.py	1970-01-01 00:00:00 +0000
@@ -1,51 +0,0 @@
-# Copyright (C) 2008 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Tests for add_revision on a repository with external references."""
-
-from bzrlib import errors
-from bzrlib.tests.per_repository_reference import (
-    TestCaseWithExternalReferenceRepository,
-    )
-
-
-class TestAddRevision(TestCaseWithExternalReferenceRepository):
-
-    def test_add_revision_goes_to_repo(self):
-        # adding a revision only writes to the repository add_revision is
-        # called on.
-        tree = self.make_branch_and_tree('sample')
-        revid = tree.commit('one')
-        inv = tree.branch.repository.get_inventory(revid)
-        rev = tree.branch.repository.get_revision(revid)
-        base = self.make_repository('base')
-        repo = self.make_referring('referring', 'base')
-        repo.lock_write()
-        try:
-            repo.start_write_group()
-            try:
-                rev = tree.branch.repository.get_revision(revid)
-                repo.add_revision(revid, rev, inv=inv)
-            except:
-                repo.abort_write_group()
-                raise
-            else:
-                repo.commit_write_group()
-        finally:
-            repo.unlock()
-        rev2 = repo.get_revision(revid)
-        self.assertEqual(rev, rev2)
-        self.assertRaises(errors.NoSuchRevision, base.get_revision, revid)

=== removed file 'bzrlib/tests/per_repository_reference/test_add_signature_text.py'
--- bzrlib/tests/per_repository_reference/test_add_signature_text.py	2008-06-06 08:20:03 +0000
+++ bzrlib/tests/per_repository_reference/test_add_signature_text.py	1970-01-01 00:00:00 +0000
@@ -1,51 +0,0 @@
-# Copyright (C) 2008 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Tests for add_signature_text on a repository with external references."""
-
-from bzrlib import errors
-from bzrlib.tests.per_repository_reference import (
-    TestCaseWithExternalReferenceRepository,
-    )
-
-
-class TestAddSignatureText(TestCaseWithExternalReferenceRepository):
-
-    def test_add_signature_text_goes_to_repo(self):
-        # adding a signature only writes to the repository add_signature_text
-        # is called on.
-        tree = self.make_branch_and_tree('sample')
-        revid = tree.commit('one')
-        inv = tree.branch.repository.get_inventory(revid)
-        base = self.make_repository('base')
-        repo = self.make_referring('referring', 'base')
-        repo.lock_write()
-        try:
-            repo.start_write_group()
-            try:
-                rev = tree.branch.repository.get_revision(revid)
-                repo.add_revision(revid, rev, inv=inv)
-                repo.add_signature_text(revid, "text")
-            except:
-                repo.abort_write_group()
-                raise
-            else:
-                repo.commit_write_group()
-        finally:
-            repo.unlock()
-        repo.get_signature_text(revid)
-        self.assertRaises(errors.NoSuchRevision, base.get_signature_text,
-            revid)

=== removed file 'bzrlib/tests/per_repository_reference/test_all_revision_ids.py'
--- bzrlib/tests/per_repository_reference/test_all_revision_ids.py	2008-06-06 08:20:03 +0000
+++ bzrlib/tests/per_repository_reference/test_all_revision_ids.py	1970-01-01 00:00:00 +0000
@@ -1,64 +0,0 @@
-# Copyright (C) 2008 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Tests for all_revision_ids on a repository with external references."""
-
-from bzrlib import errors
-from bzrlib.tests.per_repository_reference import (
-    TestCaseWithExternalReferenceRepository,
-    )
-
-
-class TestAllRevisionIds(TestCaseWithExternalReferenceRepository):
-
-    def test_all_revision_ids_empty(self):
-        base = self.make_repository('base')
-        repo = self.make_referring('referring', 'base')
-        self.assertEqual(set([]), set(repo.all_revision_ids()))
-
-    def test_all_revision_ids_from_base(self):
-        tree = self.make_branch_and_tree('base')
-        revid = tree.commit('one')
-        repo = self.make_referring('referring', 'base')
-        self.assertEqual(set([revid]), set(repo.all_revision_ids()))
-
-    def test_all_revision_ids_from_repo(self):
-        tree = self.make_branch_and_tree('spare')
-        revid = tree.commit('one')
-        base = self.make_repository('base')
-        repo = self.make_referring('referring', 'base')
-        repo.fetch(tree.branch.repository, revid)
-        self.assertEqual(set([revid]), set(repo.all_revision_ids()))
-
-    def test_all_revision_ids_from_both(self):
-        tree = self.make_branch_and_tree('spare')
-        revid = tree.commit('one')
-        base_tree = self.make_branch_and_tree('base')
-        revid2 = base_tree.commit('two')
-        repo = self.make_referring('referring', 'base')
-        repo.fetch(tree.branch.repository, revid)
-        self.assertEqual(set([revid, revid2]), set(repo.all_revision_ids()))
-
-    def test_duplicate_ids_do_not_affect_length(self):
-        tree = self.make_branch_and_tree('spare')
-        revid = tree.commit('one')
-        base = self.make_repository('base')
-        repo = self.make_referring('referring', 'base')
-        repo.fetch(tree.branch.repository, revid)
-        base.fetch(tree.branch.repository, revid)
-        self.assertEqual(set([revid]), set(repo.all_revision_ids()))
-        self.assertEqual(1, len(repo.all_revision_ids()))
-

=== removed file 'bzrlib/tests/per_repository_reference/test_break_lock.py'
--- bzrlib/tests/per_repository_reference/test_break_lock.py	2008-06-06 08:20:03 +0000
+++ bzrlib/tests/per_repository_reference/test_break_lock.py	1970-01-01 00:00:00 +0000
@@ -1,50 +0,0 @@
-# Copyright (C) 2008 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Tests for break_lock on a repository with external references."""
-
-import bzrlib.ui
-from bzrlib import errors
-from bzrlib.tests.per_repository_reference import (
-    TestCaseWithExternalReferenceRepository,
-    )
-
-
-class TestBreakLock(TestCaseWithExternalReferenceRepository):
-
-    def test_break_lock(self):
-        base = self.make_repository('base')
-        repo = self.make_referring('referring', 'base')
-        unused_repo = repo.bzrdir.open_repository()
-        base.lock_write()
-        self.addCleanup(base.unlock)
-        # break_lock when locked should
-        repo.lock_write()
-        self.assertEqual(repo.get_physical_lock_status(),
-            unused_repo.get_physical_lock_status())
-        if not unused_repo.get_physical_lock_status():
-            # 'lock_write' has not taken a physical mutex out.
-            repo.unlock()
-            return
-        # we want a UI factory that accepts canned input for the tests:
-        # while SilentUIFactory still accepts stdin, we need to customise
-        # ours
-        self.old_factory = bzrlib.ui.ui_factory
-        self.addCleanup(self.restoreFactory)
-        bzrlib.ui.ui_factory = bzrlib.ui.SilentUIFactory()
-        bzrlib.ui.ui_factory.stdin = StringIO("y\n")
-        unused_repo.break_lock()
-        self.assertRaises(errors.LockBroken, repo.unlock)

=== removed file 'bzrlib/tests/per_repository_reference/test_check.py'
--- bzrlib/tests/per_repository_reference/test_check.py	2008-06-06 08:20:03 +0000
+++ bzrlib/tests/per_repository_reference/test_check.py	1970-01-01 00:00:00 +0000
@@ -1,42 +0,0 @@
-# Copyright (C) 2008 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Tests for check on a repository with external references."""
-
-import bzrlib.ui
-from bzrlib import errors
-from bzrlib.tests.per_repository_reference import (
-    TestCaseWithExternalReferenceRepository,
-    )
-
-
-class TestCheck(TestCaseWithExternalReferenceRepository):
-
-    def test_check_file_graph_across_external_boundary_ok(self):
-        tree = self.make_branch_and_tree('base')
-        self.build_tree(['base/file'])
-        tree.add(['file'], ['file-id'])
-        rev1_id = tree.commit('one')
-        referring = self.make_branch_and_tree('referring')
-        readonly_base = self.readonly_repository('base')
-        referring.branch.repository.add_fallback_repository(readonly_base)
-        self.build_tree_contents([('referring/file', 'change')])
-        rev2_id = referring.commit('two')
-        check_result = referring.branch.repository.check(
-            referring.branch.repository.all_revision_ids())
-        check_result.report_results(verbose=False)
-        log = self._get_log(keep_log_file=True)
-        self.assertFalse("inconsistent parents" in log)

=== modified file 'bzrlib/tests/repository_implementations/__init__.py'
--- bzrlib/tests/repository_implementations/__init__.py	2008-07-17 02:37:07 +0000
+++ bzrlib/tests/repository_implementations/__init__.py	2007-10-15 05:23:29 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007, 2008 Canonical Ltd
+# Copyright (C) 2006, 2007 Canonical Ltd
 # Authors: Robert Collins <robert.collins@canonical.com>
 #          and others
 #
@@ -27,16 +27,13 @@
 from bzrlib import (
     repository,
     )
-from bzrlib.revision import NULL_REVISION
 from bzrlib.repofmt import (
     weaverepo,
     )
 from bzrlib.remote import RemoteBzrDirFormat, RemoteRepositoryFormat
 from bzrlib.smart.server import (
+    SmartTCPServer_for_testing,
     ReadonlySmartTCPServer_for_testing,
-    ReadonlySmartTCPServer_for_testing_v2_only,
-    SmartTCPServer_for_testing,
-    SmartTCPServer_for_testing_v2_only,
     )
 from bzrlib.tests import (
                           adapt_modules,
@@ -45,64 +42,49 @@
                           multiply_scenarios,
                           multiply_tests_from_modules,
                           TestScenarioApplier,
+                          TestLoader,
+                          TestSuite,
                           )
 from bzrlib.tests.bzrdir_implementations.test_bzrdir import TestCaseWithBzrDir
 from bzrlib.transport.memory import MemoryServer
 
 
-def formats_to_scenarios(formats, transport_server, transport_readonly_server,
-    vfs_transport_factory=None):
-    """Transform the input formats to a list of scenarios.
-
-    :param formats: A list of (scenario_name_suffix, repo_format)
-        where the scenario_name_suffix is to be appended to the format
-        name, and the repo_format is a RepositoryFormat subclass 
-        instance.
-    :returns: Scenarios of [(scenario_name, {parameter_name: value})]
-    """
-    result = []
-    for scenario_name_suffix, repository_format in formats:
-        scenario_name = repository_format.__class__.__name__
-        scenario_name += scenario_name_suffix
-        scenario = (scenario_name,
-            {"transport_server":transport_server,
-             "transport_readonly_server":transport_readonly_server,
-             "bzrdir_format":repository_format._matchingbzrdir,
-             "repository_format":repository_format,
-             })
-        # Only override the test's vfs_transport_factory if one was
-        # specified, otherwise just leave the default in place.
-        if vfs_transport_factory:
-            scenario[1]['vfs_transport_factory'] = vfs_transport_factory
-        result.append(scenario)
-    return result
-
-
-def all_repository_format_scenarios():
-    """Return a list of test scenarios for parameterising repository tests.
-    """
-    registry = repository.format_registry
-    all_formats = [registry.get(k) for k in registry.keys()]
-    all_formats.extend(weaverepo._legacy_formats)
-    # format_scenarios is all the implementations of Repository; i.e. all disk
-    # formats plus RemoteRepository.
-    format_scenarios = formats_to_scenarios(
-        [('', format) for format in all_formats],
-        default_transport,
-        # None here will cause a readonly decorator to be created
-        # by the TestCaseWithTransport.get_readonly_transport method.
-        None)
-    format_scenarios.extend(formats_to_scenarios(
-        [('-default', RemoteRepositoryFormat())],
-        SmartTCPServer_for_testing,
-        ReadonlySmartTCPServer_for_testing,
-        MemoryServer))
-    format_scenarios.extend(formats_to_scenarios(
-        [('-v2', RemoteRepositoryFormat())],
-        SmartTCPServer_for_testing_v2_only,
-        ReadonlySmartTCPServer_for_testing_v2_only,
-        MemoryServer))
-    return format_scenarios
+class RepositoryTestProviderAdapter(TestScenarioApplier):
+    """A tool to generate a suite testing multiple repository formats at once.
+
+    This is done by copying the test once for each transport and injecting
+    the transport_server, transport_readonly_server, and bzrdir_format and
+    repository_format classes into each copy. Each copy is also given a new id()
+    to make it easy to identify.
+    """
+
+    def __init__(self, transport_server, transport_readonly_server, formats,
+                 vfs_transport_factory=None):
+        TestScenarioApplier.__init__(self)
+        self._transport_server = transport_server
+        self._transport_readonly_server = transport_readonly_server
+        self._vfs_transport_factory = vfs_transport_factory
+        self.scenarios = self.formats_to_scenarios(formats)
+    
+    def formats_to_scenarios(self, formats):
+        """Transform the input formats to a list of scenarios.
+
+        :param formats: A list of (repository_format, bzrdir_format).
+        """
+        result = []
+        for repository_format, bzrdir_format in formats:
+            scenario = (repository_format.__class__.__name__,
+                {"transport_server":self._transport_server,
+                 "transport_readonly_server":self._transport_readonly_server,
+                 "bzrdir_format":bzrdir_format,
+                 "repository_format":repository_format,
+                 })
+            # Only override the test's vfs_transport_factory if one was
+            # specified, otherwise just leave the default in place.
+            if self._vfs_transport_factory:
+                scenario[1]['vfs_transport_factory'] = self._vfs_transport_factory
+            result.append(scenario)
+        return result
 
 
 class TestCaseWithRepository(TestCaseWithBzrDir):
@@ -126,9 +108,9 @@
     A subclass needs to define the following methods:
         :populate_repository: a method to use to populate a repository with
             sample revisions, inventories and file versions.
-        :all_versions_after_reconcile: all the versions in repository after
-            reconcile.  run_test verifies that the text of each of these
-            versions of the file is unchanged by the reconcile.
+        :all_versions: all the versions in repository.  run_test verifies
+            that the text of each of these versions of the file is unchanged
+            by the reconcile.
         :populated_parents: a list of (parents list, revision).  Each version
             of the file is verified to have the given parents before running
             the reconcile.  i.e. this is used to assert that the repo from the
@@ -137,37 +119,20 @@
             of the file is verified to have the given parents after the
             reconcile.  i.e. this is used to assert that reconcile made the
             changes we expect it to make.
-    
-    A subclass may define the following optional method as well:
-        :corrected_fulltexts: a list of file versions that should be stored as
-            fulltexts (not deltas) after reconcile.  run_test will verify that
-            this occurs.
     """
 
     def __init__(self, test_case):
         self.test_case = test_case
 
     def make_one_file_inventory(self, repo, revision, parents,
-                                inv_revision=None, root_revision=None,
-                                file_contents=None, make_file_version=True):
+                                inv_revision=None, root_revision=None):
         return self.test_case.make_one_file_inventory(
             repo, revision, parents, inv_revision=inv_revision,
-            root_revision=root_revision, file_contents=file_contents,
-            make_file_version=make_file_version)
+            root_revision=root_revision)
 
     def add_revision(self, repo, revision_id, inv, parent_ids):
         return self.test_case.add_revision(repo, revision_id, inv, parent_ids)
 
-    def corrected_fulltexts(self):
-        return []
-
-    def repository_text_key_index(self):
-        result = {}
-        if self.versioned_root:
-            result.update(self.versioned_repository_text_keys())
-        result.update(self.repository_text_keys())
-        return result
-
 
 class UndamagedRepositoryScenario(BrokenRepoScenario):
     """A scenario where the repository has no damage.
@@ -175,38 +140,24 @@
     It has a single revision, 'rev1a', with a single file.
     """
 
-    def all_versions_after_reconcile(self):
-        return ('rev1a', )
+    def all_versions(self):
+        return ['rev1a']
 
     def populated_parents(self):
-        return (((), 'rev1a'), )
+        return [([], 'rev1a')]
 
     def corrected_parents(self):
         # Same as the populated parents, because there was nothing wrong.
         return self.populated_parents()
 
-    def check_regexes(self, repo):
-        return ["0 unreferenced text versions"]
+    def check_regexes(self):
+        return ["0 unreferenced text ancestors"]
 
     def populate_repository(self, repo):
         # make rev1a: A well-formed revision, containing 'a-file'
         inv = self.make_one_file_inventory(
             repo, 'rev1a', [], root_revision='rev1a')
         self.add_revision(repo, 'rev1a', inv, [])
-        self.versioned_root = repo.supports_rich_root()
-
-    def repository_text_key_references(self):
-        result = {}
-        if self.versioned_root:
-            result.update({('TREE_ROOT', 'rev1a'): True})
-        result.update({('a-file-id', 'rev1a'): True})
-        return result
-
-    def repository_text_keys(self):
-        return {('a-file-id', 'rev1a'):[NULL_REVISION]}
-
-    def versioned_repository_text_keys(self):
-        return {('TREE_ROOT', 'rev1a'):[NULL_REVISION]}
 
 
 class FileParentIsNotInRevisionAncestryScenario(BrokenRepoScenario):
@@ -217,25 +168,25 @@
     'rev2', preserving 'rev1a' as a parent.
     """
 
-    def all_versions_after_reconcile(self):
-        return ('rev1a', 'rev2')
+    def all_versions(self):
+        return ['rev1a', 'rev1b', 'rev2']
 
     def populated_parents(self):
-        return (
-            ((), 'rev1a'),
-            ((), 'rev1b'), # Will be gc'd
-            (('rev1a', 'rev1b'), 'rev2')) # Will have parents trimmed
+        return [
+            ([], 'rev1a'),
+            ([], 'rev1b'),
+            (['rev1a', 'rev1b'], 'rev2')]
 
     def corrected_parents(self):
-        return (
-            ((), 'rev1a'),
-            (None, 'rev1b'),
-            (('rev1a',), 'rev2'))
+        return [
+            ([], 'rev1a'),
+            ([], 'rev1b'),
+            (['rev1a'], 'rev2')]
 
-    def check_regexes(self, repo):
-        return [r"\* a-file-id version rev2 has parents \('rev1a', 'rev1b'\) "
-                r"but should have \('rev1a',\)",
-                "1 unreferenced text versions",
+    def check_regexes(self):
+        return [r"\* a-file-id version rev2 has parents \['rev1a', 'rev1b'\] "
+                r"but should have \['rev1a'\]",
+                "1 unreferenced text ancestors",
                 ]
 
     def populate_repository(self, repo):
@@ -256,24 +207,6 @@
         inv = self.make_one_file_inventory(
             repo, 'rev2', ['rev1a', 'rev1b'])
         self.add_revision(repo, 'rev2', inv, ['rev1a'])
-        self.versioned_root = repo.supports_rich_root()
-
-    def repository_text_key_references(self):
-        result = {}
-        if self.versioned_root:
-            result.update({('TREE_ROOT', 'rev1a'): True,
-                           ('TREE_ROOT', 'rev2'): True})
-        result.update({('a-file-id', 'rev1a'): True,
-                       ('a-file-id', 'rev2'): True})
-        return result
-
-    def repository_text_keys(self):
-        return {('a-file-id', 'rev1a'):[NULL_REVISION],
-                ('a-file-id', 'rev2'):[('a-file-id', 'rev1a')]}
-
-    def versioned_repository_text_keys(self):
-        return {('TREE_ROOT', 'rev1a'):[NULL_REVISION],
-                ('TREE_ROOT', 'rev2'):[('TREE_ROOT', 'rev1a')]}
 
 
 class FileParentHasInaccessibleInventoryScenario(BrokenRepoScenario):
@@ -285,22 +218,24 @@
     inaccessbile (i.e. remove 'rev1c' from the parents of a-file's rev3).
     """
 
-    def all_versions_after_reconcile(self):
-        return ('rev2', 'rev3')
+    def all_versions(self):
+        return ['rev2', 'rev3']
 
     def populated_parents(self):
-        return (
-            ((), 'rev2'),
-            (('rev1c',), 'rev3'))
+        return [
+            ([], 'rev2'),
+            (['rev1c'], 'rev3')]
 
     def corrected_parents(self):
-        return (
-            ((), 'rev2'),
-            ((), 'rev3'))
+        return [
+            ([], 'rev2'),
+            ([], 'rev3')]
 
-    def check_regexes(self, repo):
+    def check_regexes(self):
         return [r"\* a-file-id version rev3 has parents "
-                r"\('rev1c',\) but should have \(\)",
+                r"\['rev1c'\] but should have \[\]",
+                # Also check reporting of unreferenced ancestors
+                r"unreferenced ancestor: {rev1c} in a-file-id",
                 ]
 
     def populate_repository(self, repo):
@@ -322,24 +257,6 @@
         # a-file cannot have rev1c as its ancestor.
         inv = self.make_one_file_inventory(repo, 'rev3', ['rev1c'])
         self.add_revision(repo, 'rev3', inv, ['rev1c', 'rev1a'])
-        self.versioned_root = repo.supports_rich_root()
-
-    def repository_text_key_references(self):
-        result = {}
-        if self.versioned_root:
-            result.update({('TREE_ROOT', 'rev2'): True,
-                           ('TREE_ROOT', 'rev3'): True})
-        result.update({('a-file-id', 'rev2'): True,
-                       ('a-file-id', 'rev3'): True})
-        return result
-
-    def repository_text_keys(self):
-        return {('a-file-id', 'rev2'):[NULL_REVISION],
-                ('a-file-id', 'rev3'):[NULL_REVISION]}
-
-    def versioned_repository_text_keys(self):
-        return {('TREE_ROOT', 'rev2'):[NULL_REVISION],
-                ('TREE_ROOT', 'rev3'):[NULL_REVISION]}
 
 
 class FileParentsNotReferencedByAnyInventoryScenario(BrokenRepoScenario):
@@ -354,51 +271,36 @@
     inventory.
     """
 
-    def all_versions_after_reconcile(self):
-        return ('rev1a', 'rev2c', 'rev4', 'rev5')
+    def all_versions(self):
+        return ['rev1a', 'rev2', 'rev4', 'rev2b', 'rev4', 'rev2c', 'rev5']
 
     def populated_parents(self):
         return [
-            (('rev1a',), 'rev2'),
-            (('rev1a',), 'rev2b'),
-            (('rev2',), 'rev3'),
-            (('rev2',), 'rev4'),
-            (('rev2', 'rev2c'), 'rev5')]
+            (['rev2'], 'rev3'),
+            (['rev2'], 'rev4'),
+            (['rev2', 'rev2c'], 'rev5')]
 
     def corrected_parents(self):
-        return (
-            # rev2 and rev2b have been removed.
-            (None, 'rev2'),
-            (None, 'rev2b'),
+        return [
             # rev3's accessible parent inventories all have rev1a as the last
             # modifier.
-            (('rev1a',), 'rev3'),
+            (['rev1a'], 'rev3'),
             # rev1a features in both rev4's parents but should only appear once
             # in the result
-            (('rev1a',), 'rev4'),
+            (['rev1a'], 'rev4'),
             # rev2c is the head of rev1a and rev2c, the inventory provided
             # per-file last-modified revisions.
-            (('rev2c',), 'rev5'))
+            (['rev2c'], 'rev5')]
 
-    def check_regexes(self, repo):
-        if repo.supports_rich_root():
-            # TREE_ROOT will be wrong; but we're not testing it. so just adjust
-            # the expected count of errors.
-            count = 9
-        else:
-            count = 3
+    def check_regexes(self):
         return [
-            # will be gc'd
-            r"unreferenced version: {rev2} in a-file-id",
-            r"unreferenced version: {rev2b} in a-file-id",
-            # will be corrected
-            r"a-file-id version rev3 has parents \('rev2',\) "
-            r"but should have \('rev1a',\)",
-            r"a-file-id version rev5 has parents \('rev2', 'rev2c'\) "
-            r"but should have \('rev2c',\)",
-            r"a-file-id version rev4 has parents \('rev2',\) "
-            r"but should have \('rev1a',\)",
-            "%d inconsistent parents" % count,
+            "3 inconsistent parents",
+            r"a-file-id version rev3 has parents \['rev2'\] "
+            r"but should have \['rev1a'\]",
+            r"a-file-id version rev5 has parents \['rev2', 'rev2c'\] "
+            r"but should have \['rev2c'\]",
+            r"a-file-id version rev4 has parents \['rev2'\] "
+            r"but should have \['rev1a'\]",
             ]
 
     def populate_repository(self, repo):
@@ -408,8 +310,7 @@
         self.add_revision(repo, 'rev1a', inv, [])
 
         # make rev2, with a-file.
-        # a-file is unmodified from rev1a, and an unreferenced rev2 file
-        # version is present in the repository.
+        # a-file is unmodified from rev1a.
         self.make_one_file_inventory(
             repo, 'rev2', ['rev1a'], inv_revision='rev1a')
         self.add_revision(repo, 'rev2', inv, ['rev1a'])
@@ -458,139 +359,6 @@
         # parents for the per file graph.
         inv = self.make_one_file_inventory(repo, 'rev5', ['rev2', 'rev2c'])
         self.add_revision(repo, 'rev5', inv, ['rev2', 'rev2c'])
-        self.versioned_root = repo.supports_rich_root()
-
-    def repository_text_key_references(self):
-        result = {}
-        if self.versioned_root:
-            result.update({('TREE_ROOT', 'rev1a'): True,
-                           ('TREE_ROOT', 'rev2'): True,
-                           ('TREE_ROOT', 'rev2b'): True,
-                           ('TREE_ROOT', 'rev2c'): True,
-                           ('TREE_ROOT', 'rev3'): True,
-                           ('TREE_ROOT', 'rev4'): True,
-                           ('TREE_ROOT', 'rev5'): True})
-        result.update({('a-file-id', 'rev1a'): True,
-                       ('a-file-id', 'rev2c'): True,
-                       ('a-file-id', 'rev3'): True,
-                       ('a-file-id', 'rev4'): True,
-                       ('a-file-id', 'rev5'): True})
-        return result
-
-    def repository_text_keys(self):
-        return {('a-file-id', 'rev1a'): [NULL_REVISION],
-                 ('a-file-id', 'rev2c'): [('a-file-id', 'rev1a')],
-                 ('a-file-id', 'rev3'): [('a-file-id', 'rev1a')],
-                 ('a-file-id', 'rev4'): [('a-file-id', 'rev1a')],
-                 ('a-file-id', 'rev5'): [('a-file-id', 'rev2c')]}
-
-    def versioned_repository_text_keys(self):
-        return {('TREE_ROOT', 'rev1a'): [NULL_REVISION],
-                ('TREE_ROOT', 'rev2'): [('TREE_ROOT', 'rev1a')],
-                ('TREE_ROOT', 'rev2b'): [('TREE_ROOT', 'rev1a')],
-                ('TREE_ROOT', 'rev2c'): [('TREE_ROOT', 'rev1a')],
-                ('TREE_ROOT', 'rev3'): [('TREE_ROOT', 'rev1a')],
-                ('TREE_ROOT', 'rev4'):
-                    [('TREE_ROOT', 'rev2'), ('TREE_ROOT', 'rev2b')],
-                ('TREE_ROOT', 'rev5'):
-                    [('TREE_ROOT', 'rev2'), ('TREE_ROOT', 'rev2c')]}
-
-
-class UnreferencedFileParentsFromNoOpMergeScenario(BrokenRepoScenario):
-    """
-    rev1a and rev1b with identical contents
-    rev2 revision has parents of [rev1a, rev1b]
-    There is a a-file:rev2 file version, not referenced by the inventory.
-    """
-
-    def all_versions_after_reconcile(self):
-        return ('rev1a', 'rev1b', 'rev2', 'rev4')
-
-    def populated_parents(self):
-        return (
-            ((), 'rev1a'),
-            ((), 'rev1b'),
-            (('rev1a', 'rev1b'), 'rev2'),
-            (None, 'rev3'),
-            (('rev2',), 'rev4'),
-            )
-
-    def corrected_parents(self):
-        return (
-            ((), 'rev1a'),
-            ((), 'rev1b'),
-            ((), 'rev2'),
-            (None, 'rev3'),
-            (('rev2',), 'rev4'),
-            )
-
-    def corrected_fulltexts(self):
-        return ['rev2']
-
-    def check_regexes(self, repo):
-        return []
-
-    def populate_repository(self, repo):
-        # make rev1a: A well-formed revision, containing 'a-file'
-        inv1a = self.make_one_file_inventory(
-            repo, 'rev1a', [], root_revision='rev1a')
-        self.add_revision(repo, 'rev1a', inv1a, [])
-
-        # make rev1b: A well-formed revision, containing 'a-file'
-        # rev1b of a-file has the exact same contents as rev1a.
-        file_contents = repo.revision_tree('rev1a').get_file_text('a-file-id')
-        inv = self.make_one_file_inventory(
-            repo, 'rev1b', [], root_revision='rev1b',
-            file_contents=file_contents)
-        self.add_revision(repo, 'rev1b', inv, [])
-
-        # make rev2, a merge of rev1a and rev1b, with a-file.
-        # a-file is unmodified from rev1a and rev1b, but a new version is
-        # wrongly present anyway.
-        inv = self.make_one_file_inventory(
-            repo, 'rev2', ['rev1a', 'rev1b'], inv_revision='rev1a',
-            file_contents=file_contents)
-        self.add_revision(repo, 'rev2', inv, ['rev1a', 'rev1b'])
-
-        # rev3: a-file unchanged from rev2, but wrongly referencing rev2 of the
-        # file in its inventory.
-        inv = self.make_one_file_inventory(
-            repo, 'rev3', ['rev2'], inv_revision='rev2',
-            file_contents=file_contents, make_file_version=False)
-        self.add_revision(repo, 'rev3', inv, ['rev2'])
-
-        # rev4: a modification of a-file on top of rev3.
-        inv = self.make_one_file_inventory(repo, 'rev4', ['rev2'])
-        self.add_revision(repo, 'rev4', inv, ['rev3'])
-        self.versioned_root = repo.supports_rich_root()
-
-    def repository_text_key_references(self):
-        result = {}
-        if self.versioned_root:
-            result.update({('TREE_ROOT', 'rev1a'): True,
-                           ('TREE_ROOT', 'rev1b'): True,
-                           ('TREE_ROOT', 'rev2'): True,
-                           ('TREE_ROOT', 'rev3'): True,
-                           ('TREE_ROOT', 'rev4'): True})
-        result.update({('a-file-id', 'rev1a'): True,
-                       ('a-file-id', 'rev1b'): True,
-                       ('a-file-id', 'rev2'): False,
-                       ('a-file-id', 'rev4'): True})
-        return result
-
-    def repository_text_keys(self):
-        return {('a-file-id', 'rev1a'): [NULL_REVISION],
-                ('a-file-id', 'rev1b'): [NULL_REVISION],
-                ('a-file-id', 'rev2'): [NULL_REVISION],
-                ('a-file-id', 'rev4'): [('a-file-id', 'rev2')]}
-
-    def versioned_repository_text_keys(self):
-        return {('TREE_ROOT', 'rev1a'): [NULL_REVISION],
-                ('TREE_ROOT', 'rev1b'): [NULL_REVISION],
-                ('TREE_ROOT', 'rev2'):
-                    [('TREE_ROOT', 'rev1a'), ('TREE_ROOT', 'rev1b')],
-                ('TREE_ROOT', 'rev3'): [('TREE_ROOT', 'rev2')],
-                ('TREE_ROOT', 'rev4'): [('TREE_ROOT', 'rev3')]}
 
 
 class TooManyParentsScenario(BrokenRepoScenario):
@@ -600,70 +368,40 @@
     ['good-parent'].
     """
 
-    def all_versions_after_reconcile(self):
-        return ('bad-parent', 'good-parent', 'broken-revision')
+    def all_versions(self):
+        return ['bad-parent', 'good-parent', 'broken-revision']
 
     def populated_parents(self):
-        return (
-            ((), 'bad-parent'),
-            (('bad-parent',), 'good-parent'),
-            (('good-parent', 'bad-parent'), 'broken-revision'))
+        return [
+            ([], 'bad-parent'),
+            (['bad-parent'], 'good-parent'),
+            (['good-parent', 'bad-parent'], 'broken-revision')]
 
     def corrected_parents(self):
-        return (
-            ((), 'bad-parent'),
-            (('bad-parent',), 'good-parent'),
-            (('good-parent',), 'broken-revision'))
+        return [
+            ([], 'bad-parent'),
+            (['bad-parent'], 'good-parent'),
+            (['good-parent'], 'broken-revision')]
 
-    def check_regexes(self, repo):
-        if repo.supports_rich_root():
-            # TREE_ROOT will be wrong; but we're not testing it. so just adjust
-            # the expected count of errors.
-            count = 3
-        else:
-            count = 1
-        return (
-            '     %d inconsistent parents' % count,
+    def check_regexes(self):
+        return [
+            '     1 inconsistent parents',
             (r"      \* a-file-id version broken-revision has parents "
-             r"\('good-parent', 'bad-parent'\) but "
-             r"should have \('good-parent',\)"))
+             r"\['good-parent', 'bad-parent'\] but "
+             r"should have \['good-parent'\]")]
 
     def populate_repository(self, repo):
         inv = self.make_one_file_inventory(
-            repo, 'bad-parent', (), root_revision='bad-parent')
-        self.add_revision(repo, 'bad-parent', inv, ())
-        
-        inv = self.make_one_file_inventory(
-            repo, 'good-parent', ('bad-parent',))
-        self.add_revision(repo, 'good-parent', inv, ('bad-parent',))
-        
-        inv = self.make_one_file_inventory(
-            repo, 'broken-revision', ('good-parent', 'bad-parent'))
-        self.add_revision(repo, 'broken-revision', inv, ('good-parent',))
-        self.versioned_root = repo.supports_rich_root()
-
-    def repository_text_key_references(self):
-        result = {}
-        if self.versioned_root:
-            result.update({('TREE_ROOT', 'bad-parent'): True,
-                           ('TREE_ROOT', 'broken-revision'): True,
-                           ('TREE_ROOT', 'good-parent'): True})
-        result.update({('a-file-id', 'bad-parent'): True,
-                       ('a-file-id', 'broken-revision'): True,
-                       ('a-file-id', 'good-parent'): True})
-        return result
-             
-    def repository_text_keys(self):
-        return {('a-file-id', 'bad-parent'): [NULL_REVISION],
-                ('a-file-id', 'broken-revision'):
-                    [('a-file-id', 'good-parent')],
-                ('a-file-id', 'good-parent'): [('a-file-id', 'bad-parent')]}
-
-    def versioned_repository_text_keys(self):
-        return {('TREE_ROOT', 'bad-parent'): [NULL_REVISION],
-                ('TREE_ROOT', 'broken-revision'):
-                    [('TREE_ROOT', 'good-parent')],
-                ('TREE_ROOT', 'good-parent'): [('TREE_ROOT', 'bad-parent')]}
+            repo, 'bad-parent', [], root_revision='bad-parent')
+        self.add_revision(repo, 'bad-parent', inv, [])
+        
+        inv = self.make_one_file_inventory(
+            repo, 'good-parent', ['bad-parent'])
+        self.add_revision(repo, 'good-parent', inv, ['bad-parent'])
+        
+        inv = self.make_one_file_inventory(
+            repo, 'broken-revision', ['good-parent', 'bad-parent'])
+        self.add_revision(repo, 'broken-revision', inv, ['good-parent'])
 
 
 class ClaimedFileParentDidNotModifyFileScenario(BrokenRepoScenario):
@@ -676,74 +414,45 @@
     'modified-something-else' is the parent file version.
     """
 
-    def all_versions_after_reconcile(self):
-        return ('basis', 'current')
+    def all_versions(self):
+        return ['basis', 'modified-something-else', 'current']
 
     def populated_parents(self):
-        return (
-            ((), 'basis'),
-            (('basis',), 'modified-something-else'),
-            (('modified-something-else',), 'current'))
+        return [
+            ([], 'basis'),
+            (['basis'], 'modified-something-else'),
+            (['modified-something-else'], 'current')]
 
     def corrected_parents(self):
-        return (
-            ((), 'basis'),
-            (None, 'modified-something-else'),
-            (('basis',), 'current'))
+        return [
+            ([], 'basis'),
+            (['basis'], 'modified-something-else'),
+            (['basis'], 'current')]
 
-    def check_regexes(self, repo):
-        if repo.supports_rich_root():
-            # TREE_ROOT will be wrong; but we're not testing it. so just adjust
-            # the expected count of errors.
-            count = 3
-        else:
-            count = 1
-        return (
-            "%d inconsistent parents" % count,
+    def check_regexes(self):
+        return [
+            '1 inconsistent parents',
             r"\* a-file-id version current has parents "
-            r"\('modified-something-else',\) but should have \('basis',\)",
-            )
+            r"\['modified-something-else'\] but should have \['basis'\]"]
 
     def populate_repository(self, repo):
-        inv = self.make_one_file_inventory(repo, 'basis', ())
-        self.add_revision(repo, 'basis', inv, ())
+        inv = self.make_one_file_inventory(repo, 'basis', [])
+        self.add_revision(repo, 'basis', inv, [])
 
         # 'modified-something-else' is a correctly recorded revision, but it
         # does not modify the file we are looking at, so the inventory for that
         # file in this revision points to 'basis'.
         inv = self.make_one_file_inventory(
-            repo, 'modified-something-else', ('basis',), inv_revision='basis')
-        self.add_revision(repo, 'modified-something-else', inv, ('basis',))
+            repo, 'modified-something-else', ['basis'], inv_revision='basis')
+        self.add_revision(repo, 'modified-something-else', inv, ['basis'])
 
         # The 'current' revision has 'modified-something-else' as its parent,
         # but the 'current' version of 'a-file' should have 'basis' as its
         # parent.
         inv = self.make_one_file_inventory(
-            repo, 'current', ('modified-something-else',))
-        self.add_revision(repo, 'current', inv, ('modified-something-else',))
-        self.versioned_root = repo.supports_rich_root()
-
-    def repository_text_key_references(self):
-        result = {}
-        if self.versioned_root:
-            result.update({('TREE_ROOT', 'basis'): True,
-                           ('TREE_ROOT', 'current'): True,
-                           ('TREE_ROOT', 'modified-something-else'): True})
-        result.update({('a-file-id', 'basis'): True,
-                       ('a-file-id', 'current'): True})
-        return result
-
-    def repository_text_keys(self):
-        return {('a-file-id', 'basis'): [NULL_REVISION],
-                ('a-file-id', 'current'): [('a-file-id', 'basis')]}
-
-    def versioned_repository_text_keys(self):
-        return {('TREE_ROOT', 'basis'): ['null:'],
-                ('TREE_ROOT', 'current'):
-                    [('TREE_ROOT', 'modified-something-else')],
-                ('TREE_ROOT', 'modified-something-else'):
-                    [('TREE_ROOT', 'basis')]}
-            
+            repo, 'current', ['modified-something-else'])
+        self.add_revision(repo, 'current', inv, ['modified-something-else'])
+
 
 class IncorrectlyOrderedParentsScenario(BrokenRepoScenario):
     """A scenario where the set parents of a version of a file are correct, but
@@ -757,39 +466,33 @@
     iteration order is arbitrary, it is also consistent within a single test).
     """
 
-    def all_versions_after_reconcile(self):
+    def all_versions(self):
         return ['parent-1', 'parent-2', 'broken-revision-1-2',
                 'broken-revision-2-1']
 
     def populated_parents(self):
-        return (
-            ((), 'parent-1'),
-            ((), 'parent-2'),
-            (('parent-2', 'parent-1'), 'broken-revision-1-2'),
-            (('parent-1', 'parent-2'), 'broken-revision-2-1'))
+        return [
+            ([], 'parent-1'),
+            ([], 'parent-2'),
+            (['parent-2', 'parent-1'], 'broken-revision-1-2'),
+            (['parent-1', 'parent-2'], 'broken-revision-2-1')]
 
     def corrected_parents(self):
-        return (
-            ((), 'parent-1'),
-            ((), 'parent-2'),
-            (('parent-1', 'parent-2'), 'broken-revision-1-2'),
-            (('parent-2', 'parent-1'), 'broken-revision-2-1'))
+        return [
+            ([], 'parent-1'),
+            ([], 'parent-2'),
+            (['parent-1', 'parent-2'], 'broken-revision-1-2'),
+            (['parent-2', 'parent-1'], 'broken-revision-2-1')]
 
-    def check_regexes(self, repo):
-        if repo.supports_rich_root():
-            # TREE_ROOT will be wrong; but we're not testing it. so just adjust
-            # the expected count of errors.
-            count = 4
-        else:
-            count = 2
-        return (
-            "%d inconsistent parents" % count,
+    def check_regexes(self):
+        return [
+            "2 inconsistent parents",
             r"\* a-file-id version broken-revision-1-2 has parents "
-            r"\('parent-2', 'parent-1'\) but should have "
-            r"\('parent-1', 'parent-2'\)",
+            r"\['parent-2', 'parent-1'\] but should have "
+            r"\['parent-1', 'parent-2'\]",
             r"\* a-file-id version broken-revision-2-1 has parents "
-            r"\('parent-1', 'parent-2'\) but should have "
-            r"\('parent-2', 'parent-1'\)")
+            r"\['parent-1', 'parent-2'\] but should have "
+            r"\['parent-2', 'parent-1'\]"]
 
     def populate_repository(self, repo):
         inv = self.make_one_file_inventory(repo, 'parent-1', [])
@@ -807,37 +510,7 @@
             repo, 'broken-revision-2-1', ['parent-1', 'parent-2'])
         self.add_revision(
             repo, 'broken-revision-2-1', inv, ['parent-2', 'parent-1'])
-        self.versioned_root = repo.supports_rich_root()
-
-    def repository_text_key_references(self):
-        result = {}
-        if self.versioned_root:
-            result.update({('TREE_ROOT', 'broken-revision-1-2'): True,
-                           ('TREE_ROOT', 'broken-revision-2-1'): True,
-                           ('TREE_ROOT', 'parent-1'): True,
-                           ('TREE_ROOT', 'parent-2'): True})
-        result.update({('a-file-id', 'broken-revision-1-2'): True,
-                       ('a-file-id', 'broken-revision-2-1'): True,
-                       ('a-file-id', 'parent-1'): True,
-                       ('a-file-id', 'parent-2'): True})
-        return result
-
-    def repository_text_keys(self):
-        return {('a-file-id', 'broken-revision-1-2'):
-                    [('a-file-id', 'parent-1'), ('a-file-id', 'parent-2')],
-                ('a-file-id', 'broken-revision-2-1'):
-                    [('a-file-id', 'parent-2'), ('a-file-id', 'parent-1')],
-                ('a-file-id', 'parent-1'): [NULL_REVISION],
-                ('a-file-id', 'parent-2'): [NULL_REVISION]}
-
-    def versioned_repository_text_keys(self):
-        return {('TREE_ROOT', 'broken-revision-1-2'):
-                    [('TREE_ROOT', 'parent-1'), ('TREE_ROOT', 'parent-2')],
-                ('TREE_ROOT', 'broken-revision-2-1'):
-                    [('TREE_ROOT', 'parent-2'), ('TREE_ROOT', 'parent-1')],
-                ('TREE_ROOT', 'parent-1'): [NULL_REVISION],
-                ('TREE_ROOT', 'parent-2'): [NULL_REVISION]}
-               
+
 
 all_broken_scenario_classes = [
     UndamagedRepositoryScenario,
@@ -847,28 +520,41 @@
     TooManyParentsScenario,
     ClaimedFileParentDidNotModifyFileScenario,
     IncorrectlyOrderedParentsScenario,
-    UnreferencedFileParentsFromNoOpMergeScenario,
     ]
-
-
-def load_tests(basic_tests, module, loader):
-    result = loader.suiteClass()
-    # add the tests for this module
-    result.addTests(basic_tests)
+    
+
+def test_suite():
+    registry = repository.format_registry
+    all_formats = [registry.get(k) for k in registry.keys()]
+    all_formats.extend(weaverepo._legacy_formats)
+    disk_format_adapter = RepositoryTestProviderAdapter(
+        default_transport,
+        # None here will cause a readonly decorator to be created
+        # by the TestCaseWithTransport.get_readonly_transport method.
+        None,
+        [(format, format._matchingbzrdir) for format in all_formats])
+
+    remote_repo_adapter = RepositoryTestProviderAdapter(
+        SmartTCPServer_for_testing,
+        ReadonlySmartTCPServer_for_testing,
+        [(RemoteRepositoryFormat(), RemoteBzrDirFormat())],
+        MemoryServer
+        )
+
+    # format_scenarios is all the implementations of Repository; i.e. all disk
+    # formats plus RemoteRepository.
+    format_scenarios = (disk_format_adapter.scenarios +
+                        remote_repo_adapter.scenarios)
+
     prefix = 'bzrlib.tests.repository_implementations.'
     test_repository_modules = [
-        'test_add_fallback_repository',
         'test_break_lock',
         'test_check',
         # test_check_reconcile is intentionally omitted, see below.
         'test_commit_builder',
         'test_fetch',
         'test_fileid_involved',
-        'test_find_text_key_references',
-        'test__generate_text_key_index',
-        'test_get_parent_map',
         'test_has_same_location',
-        'test_has_revisions',
         'test_is_write_locked',
         'test_iter_reverse_revision_history',
         'test_pack',
@@ -881,15 +567,10 @@
     module_name_list = [prefix + module_name
                         for module_name in test_repository_modules]
 
-    # add the tests for the sub modules
-
-    # Parameterize repository_implementations test modules by format.
-    format_scenarios = all_repository_format_scenarios()
-    result.addTests(multiply_tests_from_modules(module_name_list,
-                                                format_scenarios,
-                                                loader))
-
-    # test_check_reconcile needs to be parameterized by format *and* by broken
+    # Parameterise repository_implementations test modules by format.
+    result = multiply_tests_from_modules(module_name_list, format_scenarios)
+
+    # test_check_reconcile needs to be parameterised by format *and* by broken
     # repository scenario.
     broken_scenarios = [(s.__name__, {'scenario_class': s})
                         for s in all_broken_scenario_classes]
@@ -897,6 +578,7 @@
         format_scenarios, broken_scenarios)
     broken_scenario_applier = TestScenarioApplier()
     broken_scenario_applier.scenarios = broken_scenarios_for_all_formats
+    loader = TestLoader()
     adapt_modules(
         [prefix + 'test_check_reconcile'],
         broken_scenario_applier, loader, result)

=== modified file 'bzrlib/tests/repository_implementations/helpers.py'
--- bzrlib/tests/repository_implementations/helpers.py	2008-06-11 04:20:16 +0000
+++ bzrlib/tests/repository_implementations/helpers.py	2007-09-24 03:45:21 +0000
@@ -16,11 +16,9 @@
 
 """Helper classes for repository implementation tests."""
 
-from cStringIO import StringIO
 
 from bzrlib import (
     inventory,
-    osutils,
     revision as _mod_revision,
     )
 from bzrlib.repofmt.knitrepo import RepositoryFormatKnit
@@ -50,34 +48,23 @@
                 "%s isn't a knit format" % self.repository_format)
 
         repo = self.make_repository('broken')
-        repo.lock_write()
-        repo.start_write_group()
-        try:
-            inv = inventory.Inventory(revision_id='revision-id')
-            inv.root.revision = 'revision-id'
-            inv_sha1 = repo.add_inventory('revision-id', inv, [])
-            if repo.supports_rich_root():
-                root_id = inv.root.file_id
-                repo.texts.add_lines((root_id, 'revision-id'), [], [])
-            revision = _mod_revision.Revision('revision-id',
-                committer='jrandom@example.com', timestamp=0,
-                inventory_sha1=inv_sha1, timezone=0, message='message',
-                parent_ids=[])
-            # Manually add the revision text using the RevisionStore API, with
-            # bad parents.
-            rev_text = repo._serializer.write_revision_to_string(revision)
-            repo.revisions.add_lines((revision.revision_id,),
-                [('incorrect-parent',)],
-                osutils.split_lines(rev_text))
-        except:
-            repo.abort_write_group()
-            repo.unlock()
-            raise
-        else:
-            repo.commit_write_group()
-            repo.unlock()
+        inv = inventory.Inventory(revision_id='revision-id')
+        inv.root.revision = 'revision-id'
+        repo.add_inventory('revision-id', inv, [])
+        revision = _mod_revision.Revision('revision-id',
+            committer='jrandom@example.com', timestamp=0,
+            inventory_sha1='', timezone=0, message='message', parent_ids=[])
+        repo.add_revision('revision-id',revision, inv)
 
+        # Change the knit index's record of the parents for 'revision-id' to
+        # claim it has a parent, 'incorrect-parent', that doesn't exist in this
+        # knit at all.
         repo.lock_write()
         self.addCleanup(repo.unlock)
+        rev_knit = repo._get_revision_vf()
+        index_cache = rev_knit._index._cache
+        cached_index_entry = list(index_cache['revision-id'])
+        cached_index_entry[4] = ['incorrect-parent']
+        index_cache['revision-id'] = tuple(cached_index_entry)
         return repo
 

=== removed file 'bzrlib/tests/repository_implementations/test__generate_text_key_index.py'
--- bzrlib/tests/repository_implementations/test__generate_text_key_index.py	2007-11-15 02:07:37 +0000
+++ bzrlib/tests/repository_implementations/test__generate_text_key_index.py	1970-01-01 00:00:00 +0000
@@ -1,30 +0,0 @@
-# Copyright (C) 2007 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-
-"""Tests for the _generate_text_key_index API."""
-
-
-from bzrlib.tests.repository_implementations import TestCaseWithRepository
-
-
-class TestGenerateTextKeyIndex(TestCaseWithRepository):
-
-    def test_empty(self):
-        repo = self.make_repository('.')
-        repo.lock_read()
-        self.addCleanup(repo.unlock)
-        self.assertEqual({}, repo._generate_text_key_index())

=== removed file 'bzrlib/tests/repository_implementations/test_add_fallback_repository.py'
--- bzrlib/tests/repository_implementations/test_add_fallback_repository.py	2008-07-11 04:46:13 +0000
+++ bzrlib/tests/repository_implementations/test_add_fallback_repository.py	1970-01-01 00:00:00 +0000
@@ -1,47 +0,0 @@
-# Copyright (C) 2008 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Tests for Repository.add_fallback_repository."""
-
-from bzrlib import errors
-from bzrlib.revision import NULL_REVISION
-from bzrlib.tests import TestNotApplicable
-from bzrlib.tests.repository_implementations import TestCaseWithRepository
-
-
-class TestAddFallbackRepository(TestCaseWithRepository):
-
-    def test_add_fallback_repository(self):
-        repo = self.make_repository('repo')
-        tree = self.make_branch_and_tree('branch')
-        if not repo._format.supports_external_lookups:
-            self.assertRaises(errors.UnstackableRepositoryFormat,
-                repo.add_fallback_repository, tree.branch.repository)
-            raise TestNotApplicable
-        repo.add_fallback_repository(tree.branch.repository)
-        # the repository has been added correctly if we can query against it.
-        revision_id = tree.commit('1st post')
-        repo.lock_read()
-        self.addCleanup(repo.unlock)
-        # can see all revisions
-        self.assertEqual(set([revision_id]), set(repo.all_revision_ids()))
-        # and can also query the parent map, either on the revisions
-        # versionedfiles, which works in tuple keys...
-        self.assertEqual({(revision_id,): ()},
-            repo.revisions.get_parent_map([(revision_id,)]))
-        # ... or on the repository directly...
-        self.assertEqual({revision_id: (NULL_REVISION,)},
-            repo.get_parent_map([revision_id]))

=== modified file 'bzrlib/tests/repository_implementations/test_check.py'
--- bzrlib/tests/repository_implementations/test_check.py	2008-06-11 04:20:16 +0000
+++ bzrlib/tests/repository_implementations/test_check.py	2007-10-05 01:56:16 +0000
@@ -20,8 +20,10 @@
 
 from bzrlib import (
     errors,
+    inventory,
     revision as _mod_revision,
     )
+from bzrlib.repository import _RevisionTextVersionCache
 from bzrlib.tests import TestNotApplicable
 from bzrlib.tests.repository_implementations import TestCaseWithRepository
 from bzrlib.tests.repository_implementations.helpers import (
@@ -29,27 +31,6 @@
     )
 
 
-class TestNoSpuriousInconsistentAncestors(TestCaseWithRepository):
-
-    def test_two_files_different_versions_no_inconsistencies_bug_165071(self):
-        """Two files, with different versions can be clean."""
-        tree = self.make_branch_and_tree('.')
-        self.build_tree(['foo'])
-        tree.smart_add(['.'])
-        tree.commit('1')
-        self.build_tree(['bar'])
-        tree.smart_add(['.'])
-        tree.commit('2')
-        # XXX: check requires a non-empty revision IDs list, but it ignores the
-        # contents of it!
-        check_object = tree.branch.repository.check(['ignored'])
-        check_object.report_results(verbose=False)
-        log = self._get_log(keep_log_file=True)
-        self.assertContainsRe(
-            log,
-            "0 unreferenced text versions")
-
-
 class TestFindInconsistentRevisionParents(TestCaseWithBrokenRevisionIndex):
 
     def test__find_inconsistent_revision_parents(self):
@@ -58,7 +39,7 @@
         """
         repo = self.make_repo_with_extra_ghost_index()
         self.assertEqual(
-            [('revision-id', ('incorrect-parent',), ())],
+            [('revision-id', ['incorrect-parent'], [])],
             list(repo._find_inconsistent_revision_parents()))
 
     def test__check_for_inconsistent_revision_parents(self):
@@ -78,11 +59,7 @@
         if not repo.revision_graph_can_have_wrong_parents():
             raise TestNotApplicable(
                 '%r cannot have corrupt revision index.' % repo)
-        repo.lock_read()
-        try:
-            repo._check_for_inconsistent_revision_parents()  # nothing happens
-        finally:
-            repo.unlock()
+        repo._check_for_inconsistent_revision_parents()  # nothing happens
 
     def test_check_reports_bad_ancestor(self):
         repo = self.make_repo_with_extra_ghost_index()
@@ -98,5 +75,5 @@
         self.assertContainsRe(
             log,
             "revision-id has wrong parents in index: "
-            r"\('incorrect-parent',\) should be \(\)")
+            r"\['incorrect-parent'\] should be \[\]")
 

=== modified file 'bzrlib/tests/repository_implementations/test_check_reconcile.py'
--- bzrlib/tests/repository_implementations/test_check_reconcile.py	2008-06-19 13:14:24 +0000
+++ bzrlib/tests/repository_implementations/test_check_reconcile.py	2007-10-03 10:54:07 +0000
@@ -58,9 +58,6 @@
         """
         inv.revision_id = revision_id
         inv.root.revision = revision_id
-        if repo.supports_rich_root():
-            root_id = inv.root.file_id
-            repo.texts.add_lines((root_id, revision_id), [], [])
         repo.add_inventory(revision_id, inv, parent_ids)
         revision = Revision(revision_id, committer='jrandom@example.com',
             timestamp=0, inventory_sha1='', timezone=0, message='foo',
@@ -68,8 +65,7 @@
         repo.add_revision(revision_id,revision, inv)
 
     def make_one_file_inventory(self, repo, revision, parents,
-                                inv_revision=None, root_revision=None,
-                                file_contents=None, make_file_version=True):
+                                inv_revision=None, root_revision=None):
         """Make an inventory containing a version of a file with ID 'a-file'.
 
         The file's ID will be 'a-file', and its filename will be 'a file name',
@@ -82,9 +78,6 @@
             inventory entry.  Otherwise, this defaults to revision.
         :param root_revision: if not None, the inventory's root.revision will
             be set to this.
-        :param file_contents: if not None, the contents of this file version.
-            Otherwise a unique default (based on revision ID) will be
-            generated.
         """
         inv = Inventory(revision_id=revision)
         if root_revision is not None:
@@ -96,13 +89,12 @@
         else:
             entry.revision = revision
         entry.text_size = 0
-        if file_contents is None:
-            file_contents = '%sline\n' % entry.revision
+        file_contents = '%sline\n' % entry.revision
         entry.text_sha1 = sha.sha(file_contents).hexdigest()
         inv.add(entry)
-        if make_file_version:
-            repo.texts.add_lines((file_id, revision),
-                [(file_id, parent) for parent in parents], [file_contents])
+        vf = repo.weave_store.get_weave_or_empty(file_id,
+                                                 repo.get_transaction())
+        vf.add_lines(revision, parents, [file_contents])
         return inv
 
     def require_repo_suffers_text_parent_corruption(self, repo):
@@ -111,35 +103,17 @@
                     "Format does not support text parent reconciliation")
 
     def file_parents(self, repo, revision_id):
-        key = ('a-file-id', revision_id)
-        parent_map = repo.texts.get_parent_map([key])
-        return tuple(parent[-1] for parent in parent_map[key])
-
-    def assertFileVersionAbsent(self, repo, revision_id):
-        self.assertEqual({},
-            repo.texts.get_parent_map([('a-file-id', revision_id)]))
+        return repo.weave_store.get_weave('a-file-id',
+            repo.get_transaction()).get_parents(revision_id)
 
     def assertParentsMatch(self, expected_parents_for_versions, repo,
                            when_description):
         for expected_parents, version in expected_parents_for_versions:
-            if expected_parents is None:
-                self.assertFileVersionAbsent(repo, version)
-            else:
-                found_parents = self.file_parents(repo, version)
-                self.assertEqual(expected_parents, found_parents,
-                    "%s reconcile %s has parents %s, should have %s."
-                    % (when_description, version, found_parents,
-                       expected_parents))
-
-    def prepare_test_repository(self):
-        """Prepare a repository to test with from the test scenario.
-
-        :return: A repository, and the scenario instance.
-        """
-        scenario = self.scenario_class(self)
-        repo = self.make_populated_repository(scenario.populate_repository)
-        self.require_repo_suffers_text_parent_corruption(repo)
-        return repo, scenario
+            found_parents = self.file_parents(repo, version)
+            self.assertEqual(expected_parents, found_parents,
+                "Expected version %s of a-file-id to have parents %s %s "
+                "reconcile, but it has %s instead."
+                % (version, expected_parents, when_description, found_parents))
 
     def shas_for_versions_of_file(self, repo, versions):
         """Get the SHA-1 hashes of the versions of 'a-file' in the repository.
@@ -149,73 +123,35 @@
 
         :returns: A dict of `{version: hash}`.
         """
-        keys = [('a-file-id', version) for version in versions]
-        return repo.texts.get_sha1s(keys)
+        vf = repo.weave_store.get_weave('a-file-id', repo.get_transaction())
+        return dict((v, vf.get_sha1(v)) for v in versions)
 
     def test_reconcile_behaviour(self):
         """Populate a repository and reconcile it, verifying the state before
         and after.
         """
-        repo, scenario = self.prepare_test_repository()
-        repo.lock_read()
-        try:
-            self.assertParentsMatch(scenario.populated_parents(), repo,
-                'before')
-            vf_shas = self.shas_for_versions_of_file(
-                repo, scenario.all_versions_after_reconcile())
-        finally:
-            repo.unlock()
+        scenario = self.scenario_class(self)
+        repo = self.make_populated_repository(scenario.populate_repository)
+        self.require_repo_suffers_text_parent_corruption(repo)
+        self.assertParentsMatch(scenario.populated_parents(), repo, 'before')
+        vf_shas = self.shas_for_versions_of_file(repo, scenario.all_versions())
         result = repo.reconcile(thorough=True)
-        repo.lock_read()
-        try:
-            self.assertParentsMatch(scenario.corrected_parents(), repo,
-                'after')
-            # The contents of the versions in the versionedfile should be the
-            # same after the reconcile.
-            self.assertEqual(
-                vf_shas,
-                self.shas_for_versions_of_file(
-                    repo, scenario.all_versions_after_reconcile()))
-
-            # Scenario.corrected_fulltexts contains texts which the test wants
-            # to assert are now fulltexts. However this is an abstraction
-            # violation; really we care that:
-            # - the text is reconstructable
-            # - it has an empty parents list
-            # (we specify it this way because a store can use arbitrary
-            # compression pointers in principle.
-            for file_version in scenario.corrected_fulltexts():
-                key = ('a-file-id', file_version)
-                self.assertEqual({key:()}, repo.texts.get_parent_map([key]))
-                self.assertIsInstance(
-                    repo.texts.get_record_stream([key], 'unordered',
-                        True).next().get_bytes_as('fulltext'),
-                    str)
-        finally:
-            repo.unlock()
+        self.assertParentsMatch(scenario.corrected_parents(), repo, 'after')
+        # The contents of the versions in the versionedfile should be the same
+        # after the reconcile.
+        self.assertEqual(
+            vf_shas,
+            self.shas_for_versions_of_file(repo, scenario.all_versions()))
 
     def test_check_behaviour(self):
         """Populate a repository and check it, and verify the output."""
-        repo, scenario = self.prepare_test_repository()
+        scenario = self.scenario_class(self)
+        repo = self.make_populated_repository(scenario.populate_repository)
+        self.require_repo_suffers_text_parent_corruption(repo)
         check_result = repo.check()
         check_result.report_results(verbose=True)
-        for pattern in scenario.check_regexes(repo):
+        for pattern in scenario.check_regexes():
             self.assertContainsRe(
                 self._get_log(keep_log_file=True),
                 pattern)
 
-    def test_find_text_key_references(self):
-        """Test that find_text_key_references finds erroneous references."""
-        repo, scenario = self.prepare_test_repository()
-        repo.lock_read()
-        self.addCleanup(repo.unlock)
-        self.assertEqual(scenario.repository_text_key_references(),
-            repo.find_text_key_references())
-
-    def test__generate_text_key_index(self):
-        """Test that the generated text key index has all entries."""
-        repo, scenario = self.prepare_test_repository()
-        repo.lock_read()
-        self.addCleanup(repo.unlock)
-        self.assertEqual(scenario.repository_text_key_index(),
-            repo._generate_text_key_index())

=== modified file 'bzrlib/tests/repository_implementations/test_commit_builder.py'
--- bzrlib/tests/repository_implementations/test_commit_builder.py	2008-06-11 04:20:16 +0000
+++ bzrlib/tests/repository_implementations/test_commit_builder.py	2007-10-19 17:00:10 +0000
@@ -28,7 +28,6 @@
     repository,
     tests,
     )
-from bzrlib.graph import Graph
 from bzrlib.tests.repository_implementations import test_repository
 
 
@@ -148,7 +147,7 @@
         builder = tree.branch.get_commit_builder([parent_tree.inventory])
         try:
             ie = inventory.make_entry('directory', '', None,
-                    tree.get_root_id())
+                    tree.inventory.root.file_id)
             delta, version_recorded = builder.record_entry_contents(
                 ie, [parent_tree.inventory], '', tree,
                 tree.path_content_summary(''))
@@ -214,15 +213,11 @@
         self.assertEqual(rev_id, basis_tree.inventory.root.revision)
 
     def _get_revtrees(self, tree, revision_ids):
-        tree.lock_read()
-        try:
-            trees = list(tree.branch.repository.revision_trees(revision_ids))
-            for _tree in trees:
-                _tree.lock_read()
-                self.addCleanup(_tree.unlock)
-            return trees
-        finally:
-            tree.unlock()
+        trees = list(tree.branch.repository.revision_trees(revision_ids))
+        for tree in trees:
+            tree.lock_read()
+            self.addCleanup(tree.unlock)
+        return trees
 
     def test_last_modified_revision_after_commit_root_unchanged(self):
         # commiting without changing the root does not change the 
@@ -244,10 +239,7 @@
         tree1, tree2 = self._get_revtrees(tree, [rev1, rev2])
         self.assertEqual(rev1, tree1.inventory[name + 'id'].revision)
         self.assertEqual(rev1, tree2.inventory[name + 'id'].revision)
-        file_id = name + 'id'
-        expected_graph = {}
-        expected_graph[(file_id, rev1)] = ()
-        self.assertFileGraph(expected_graph, tree, (file_id, rev1))
+        self.assertFileAncestry([rev1], tree, name)
 
     def test_last_modified_revision_after_commit_dir_unchanged(self):
         # committing without changing a dir does not change the last modified.
@@ -268,10 +260,7 @@
         tree1, tree2 = self._get_revtrees(tree, [rev1, rev2])
         self.assertEqual(rev1, tree1.inventory['dirid'].revision)
         self.assertEqual(rev1, tree2.inventory['dirid'].revision)
-        file_id = 'dirid'
-        expected_graph = {}
-        expected_graph[(file_id, rev1)] = ()
-        self.assertFileGraph(expected_graph, tree, (file_id, rev1))
+        self.assertFileAncestry([rev1], tree, 'dir')
 
     def test_last_modified_revision_after_commit_file_unchanged(self):
         # committing without changing a file does not change the last modified.
@@ -344,11 +333,7 @@
         tree1, tree2 = self._get_revtrees(tree, [rev1, rev2])
         self.assertEqual(rev1, tree1.inventory[name + 'id'].revision)
         self.assertEqual(rev2, tree2.inventory[name + 'id'].revision)
-        file_id = name + 'id'
-        expected_graph = {}
-        expected_graph[(file_id, rev1)] = ()
-        expected_graph[(file_id, rev2)] = ((file_id, rev1),)
-        self.assertFileGraph(expected_graph, tree, (file_id, rev2))
+        self.assertFileAncestry([rev1, rev2], tree, name)
 
     def mini_commit(self, tree, name, new_name, records_version=True,
         delta_against_basis=True):
@@ -378,7 +363,7 @@
             # root
             builder.record_entry_contents(
                 inventory.make_entry('directory', '', None,
-                    tree.get_root_id()), parent_invs, '', tree,
+                    tree.inventory.root.file_id), parent_invs, '', tree,
                     tree.path_content_summary(''))
             def commit_id(file_id):
                 old_ie = tree.inventory[file_id]
@@ -390,7 +375,7 @@
 
             file_id = tree.path2id(new_name)
             parent_id = tree.inventory[file_id].parent_id
-            if parent_id != tree.get_root_id():
+            if parent_id != tree.inventory.root.file_id:
                 commit_id(parent_id)
             # because a change of some sort is meant to have occurred,
             # recording the entry must return True.
@@ -418,13 +403,19 @@
             tree.unlock()
         return rev2
 
-    def assertFileGraph(self, expected_graph, tree, tip):
+    def assertFileAncestry(self, ancestry, tree, name, alt_ancestry=None):
         # all the changes that have occured should be in the ancestry
         # (closest to a public per-file graph API we have today)
         tree.lock_read()
         self.addCleanup(tree.unlock)
-        graph = dict(Graph(tree.branch.repository.texts).iter_ancestry([tip]))
-        self.assertEqual(expected_graph, graph)
+        vw = tree.branch.repository.weave_store.get_weave(name + 'id',
+            tree.branch.repository.get_transaction())
+        result = vw.get_ancestry([ancestry[-1]])
+        if alt_ancestry is None:
+            self.assertEqual(ancestry, result)
+        else:
+            self.assertSubset([tuple(result)],
+                [tuple(ancestry), tuple(alt_ancestry)])
 
     def test_last_modified_revision_after_content_file_changes(self):
         # altering a file changes the last modified.
@@ -462,13 +453,10 @@
         rev4 = self.mini_commit(tree1, 'new_' + name, 'new_' + name)
         tree3, = self._get_revtrees(tree1, [rev4])
         self.assertEqual(rev4, tree3.inventory[name + 'id'].revision)
-        file_id = name + 'id'
-        expected_graph = {}
-        expected_graph[(file_id, rev1)] = ()
-        expected_graph[(file_id, rev2)] = ((file_id, rev1),)
-        expected_graph[(file_id, rev3)] = ((file_id, rev1),)
-        expected_graph[(file_id, rev4)] = ((file_id, rev2), (file_id, rev3),)
-        self.assertFileGraph(expected_graph, tree1, (file_id, rev4))
+        # TODO: change this to an assertFileGraph call to check the
+        # parent order of rev4: it should be rev2, rev3
+        self.assertFileAncestry([rev1, rev2, rev3, rev4], tree1, name,
+            [rev1, rev3, rev2, rev4])
 
     def test_last_modified_revision_after_merge_dir_changes(self):
         # merge a dir changes the last modified.
@@ -497,11 +485,7 @@
         rev3 = self.mini_commit(tree1, name, 'new_' + name, False)
         tree3, = self._get_revtrees(tree1, [rev2])
         self.assertEqual(rev2, tree3.inventory[name + 'id'].revision)
-        file_id = name + 'id'
-        expected_graph = {}
-        expected_graph[(file_id, rev1)] = ()
-        expected_graph[(file_id, rev2)] = ((file_id, rev1),)
-        self.assertFileGraph(expected_graph, tree1, (file_id, rev2))
+        self.assertFileAncestry([rev1, rev2], tree1, name)
 
     def test_last_modified_revision_after_converged_merge_dir_changes(self):
         # merge a dir changes the last modified.

=== modified file 'bzrlib/tests/repository_implementations/test_fetch.py'
--- bzrlib/tests/repository_implementations/test_fetch.py	2008-06-11 04:20:16 +0000
+++ bzrlib/tests/repository_implementations/test_fetch.py	2007-10-05 05:52:45 +0000
@@ -20,7 +20,6 @@
     bzrdir,
     errors,
     gpg,
-    repository,
     )
 from bzrlib.tests import TestSkipped
 from bzrlib.tests.repository_implementations import TestCaseWithRepository
@@ -48,7 +47,7 @@
 
     def test_fetch_knit3(self):
         # create a repository of the sort we are testing.
-        tree_a = self.make_branch_and_tree('a')
+        tree_a = self.make_branch_and_tree('a', '')
         self.build_tree(['a/foo'])
         tree_a.add('foo', 'file1')
         tree_a.commit('rev1', rev_id='rev1')
@@ -69,11 +68,7 @@
         # disk.
         knit3_repo = b_bzrdir.open_repository()
         rev1_tree = knit3_repo.revision_tree('rev1')
-        rev1_tree.lock_read()
-        try:
-            lines = rev1_tree.get_file_lines(rev1_tree.get_root_id())
-        finally:
-            rev1_tree.unlock()
+        lines = rev1_tree.get_file_lines(rev1_tree.inventory.root.file_id)
         self.assertEqual([], lines)
         b_branch = b_bzrdir.create_branch()
         b_branch.pull(tree_a.branch)
@@ -86,31 +81,6 @@
         rev2_tree = knit3_repo.revision_tree('rev2')
         self.assertEqual('rev1', rev2_tree.inventory.root.revision)
 
-    def test_fetch_all_from_self(self):
-        tree = self.make_branch_and_tree('.')
-        rev_id = tree.commit('one')
-        # This needs to be a new copy of the repository, if this changes, the
-        # test needs to be rewritten
-        repo = tree.branch.repository.bzrdir.open_repository()
-        # This fetch should be a no-op see bug #158333
-        tree.branch.repository.fetch(repo, None)
-
-    def test_fetch_from_self(self):
-        tree = self.make_branch_and_tree('.')
-        rev_id = tree.commit('one')
-        repo = tree.branch.repository.bzrdir.open_repository()
-        # This fetch should be a no-op see bug #158333
-        tree.branch.repository.fetch(repo, rev_id)
-
-    def test_fetch_missing_from_self(self):
-        tree = self.make_branch_and_tree('.')
-        rev_id = tree.commit('one')
-        # Even though the fetch() is a NO-OP it should assert the revision id
-        # is present
-        repo = tree.branch.repository.bzrdir.open_repository()
-        self.assertRaises(errors.NoSuchRevision, tree.branch.repository.fetch,
-                          repo, 'no-such-revision')
-
     def makeARepoWithSignatures(self):
         wt = self.make_branch_and_tree('a-repo-with-sigs')
         wt.commit('rev1', allow_pointless=True, rev_id='rev1')
@@ -131,7 +101,7 @@
             target_repo.get_signature_text('rev1'))
 
     def make_repository_with_one_revision(self):
-        wt = self.make_branch_and_tree('source')
+        wt = self.make_branch_and_tree('source', '')
         wt.commit('rev1', allow_pointless=True, rev_id='rev1')
         return wt.branch.repository
 
@@ -145,11 +115,3 @@
         # without causing any errors.
         target_repo.fetch(source_repo, revision_id='rev1')
 
-    def test_fetch_all_same_revisions_twice(self):
-        # Blind-fetching all the same revisions twice should succeed and be a
-        # no-op the second time.
-        repo = self.make_repository('repo')
-        tree = self.make_branch_and_tree('tree')
-        revision_id = tree.commit('test')
-        repo.fetch(tree.branch.repository)
-        repo.fetch(tree.branch.repository)

=== modified file 'bzrlib/tests/repository_implementations/test_fileid_involved.py'
--- bzrlib/tests/repository_implementations/test_fileid_involved.py	2007-10-26 19:18:48 +0000
+++ bzrlib/tests/repository_implementations/test_fileid_involved.py	2007-08-03 01:07:18 +0000
@@ -139,8 +139,7 @@
     def test_fileids_altered_between_two_revs(self):
         def foo(old, new):
             print set(self.branch.repository.get_ancestry(new)).difference(set(self.branch.repository.get_ancestry(old)))
-        self.branch.lock_read()
-        self.addCleanup(self.branch.unlock)
+
         self.assertEqual(
             {'b-file-id-2006-01-01-defg':set(['rev-J']),
              'c-funky<file-id>quiji%bo':set(['rev-K'])
@@ -174,20 +173,18 @@
     def fileids_altered_by_revision_ids(self, revision_ids):
         """This is a wrapper to strip TREE_ROOT if it occurs"""
         repo = self.branch.repository
-        root_id = self.branch.basis_tree().get_root_id()
+        root_id = self.branch.basis_tree().inventory.root.file_id
         result = repo.fileids_altered_by_revision_ids(revision_ids)
         if root_id in result:
             del result[root_id]
         return result
 
     def test_fileids_altered_by_revision_ids(self):
-        self.branch.lock_read()
-        self.addCleanup(self.branch.unlock)
         self.assertEqual(
             {'a-file-id-2006-01-01-abcd':set(['rev-A']),
              'b-file-id-2006-01-01-defg': set(['rev-A']),
              'c-funky<file-id>quiji%bo': set(['rev-A']),
-             },
+             }, 
             self.fileids_altered_by_revision_ids(["rev-A"]))
         self.assertEqual(
             {'a-file-id-2006-01-01-abcd':set(['rev-B'])
@@ -204,8 +201,6 @@
         # comparing the trees - no less, and no more. This is correct 
         # because in our sample data we do not revert any file ids along
         # the revision history.
-        self.branch.lock_read()
-        self.addCleanup(self.branch.unlock)
         pp=[]
         history = self.branch.revision_history( )
 
@@ -242,10 +237,8 @@
                               % self.repository_format)
 
         repo = main_wt.branch.repository
-        repo.lock_read()
-        self.addCleanup(repo.unlock)
         file_ids = repo.fileids_altered_by_revision_ids([revision_id])
-        root_id = main_wt.basis_tree().get_root_id()
+        root_id = main_wt.basis_tree().path2id('')
         if root_id in file_ids:
             self.assertEqual({file_id:set([revision_id]),
                               root_id:set([revision_id])
@@ -297,8 +290,6 @@
         # this tests that fileids_alteted_by_revision_ids returns 
         # more information than compare_tree can, because it 
         # sees each change rather than the aggregate delta.
-        self.branch.lock_read()
-        self.addCleanup(self.branch.unlock)
         history = self.branch.revision_history()
         old_rev = history[0]
         new_rev = history[1]

=== removed file 'bzrlib/tests/repository_implementations/test_find_text_key_references.py'
--- bzrlib/tests/repository_implementations/test_find_text_key_references.py	2007-11-14 04:24:24 +0000
+++ bzrlib/tests/repository_implementations/test_find_text_key_references.py	1970-01-01 00:00:00 +0000
@@ -1,30 +0,0 @@
-# Copyright (C) 2007 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-
-"""Test the find_text_key_references API."""
-
-
-from bzrlib.tests.repository_implementations import TestCaseWithRepository
-
-
-class TestFindTextKeyReferences(TestCaseWithRepository):
-
-    def test_empty(self):
-        repo = self.make_repository('.')
-        repo.lock_read()
-        self.addCleanup(repo.unlock)
-        self.assertEqual({}, repo.find_text_key_references())

=== removed file 'bzrlib/tests/repository_implementations/test_get_parent_map.py'
--- bzrlib/tests/repository_implementations/test_get_parent_map.py	2008-05-19 16:29:30 +0000
+++ bzrlib/tests/repository_implementations/test_get_parent_map.py	1970-01-01 00:00:00 +0000
@@ -1,73 +0,0 @@
-# Copyright (C) 2008 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Tests for the get_parent_map API."""
-
-from bzrlib import revision
-from bzrlib.tests.repository_implementations import TestCaseWithRepository
-
-
-class TestGetParentMap(TestCaseWithRepository):
-
-    def test_missing_revision(self):
-        tree = self.make_branch_and_tree('.')
-        repo = tree.branch.repository
-        repo.lock_read()
-        self.addCleanup(repo.unlock)
-        self.assertEqual({}, repo.get_parent_map(['non-existant']))
-
-    def test_multiple_parents(self):
-        tree = self.make_branch_and_tree('.')
-        rev1 = tree.commit('first')
-        rev2 = tree.commit('second')
-        tree.set_parent_ids([rev1, rev2])
-        tree.branch.set_last_revision_info(1, rev1)
-        rev3 = tree.commit('third')
-        repo = tree.branch.repository
-        repo.lock_read()
-        self.addCleanup(repo.unlock)
-        self.assertEqual({rev3:(rev1, rev2)},
-                         repo.get_parent_map([rev3]))
-        self.assertEqual({rev1:(revision.NULL_REVISION,),
-                          rev2:(rev1,),
-                          rev3:(rev1, rev2),
-                         }, repo.get_parent_map([rev1, rev2, rev3]))
-
-    def test_no_parents(self):
-        tree = self.make_branch_and_tree('.')
-        rev1 = tree.commit('first')
-        repo = tree.branch.repository
-        repo.lock_read()
-        self.addCleanup(repo.unlock)
-        self.assertEqual({rev1:(revision.NULL_REVISION,)},
-                         repo.get_parent_map([rev1]))
-
-    def test_none(self):
-        tree = self.make_branch_and_tree('.')
-        rev1 = tree.commit('first')
-        repo = tree.branch.repository
-        repo.lock_read()
-        self.addCleanup(repo.unlock)
-        self.assertRaises(ValueError,
-                          repo.get_parent_map, [None])
-
-    def test_null_revision(self):
-        tree = self.make_branch_and_tree('.')
-        repo = tree.branch.repository
-        repo.lock_read()
-        self.addCleanup(repo.unlock)
-        self.assertEqual({revision.NULL_REVISION:()},
-                         repo.get_parent_map([revision.NULL_REVISION]))

=== removed file 'bzrlib/tests/repository_implementations/test_has_revisions.py'
--- bzrlib/tests/repository_implementations/test_has_revisions.py	2008-01-11 03:54:51 +0000
+++ bzrlib/tests/repository_implementations/test_has_revisions.py	1970-01-01 00:00:00 +0000
@@ -1,43 +0,0 @@
-# Copyright (C) 2008 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Tests for implementations of Repository.has_revisions."""
-
-from bzrlib.revision import NULL_REVISION
-from bzrlib.tests.repository_implementations import TestCaseWithRepository
-
-
-class TestHasRevisions(TestCaseWithRepository):
-
-    def test_empty_list(self):
-        repo = self.make_repository('.')
-        self.assertEqual(set(), repo.has_revisions([]))
-
-    def test_superset(self):
-        tree = self.make_branch_and_tree('.')
-        repo = tree.branch.repository
-        rev1 = tree.commit('1')
-        rev2 = tree.commit('2')
-        rev3 = tree.commit('3')
-        self.assertEqual(set([rev1, rev3]),
-            repo.has_revisions([rev1, rev3, 'foobar:']))
-
-    def test_NULL(self):
-        # NULL_REVISION is always present. So for
-        # compatibility with 'has_revision' we make this work.
-        repo = self.make_repository('.')
-        self.assertEqual(set([NULL_REVISION]),
-            repo.has_revisions([NULL_REVISION]))

=== modified file 'bzrlib/tests/repository_implementations/test_has_same_location.py'
--- bzrlib/tests/repository_implementations/test_has_same_location.py	2008-05-12 04:07:49 +0000
+++ bzrlib/tests/repository_implementations/test_has_same_location.py	2007-08-07 07:47:27 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007, 2008 Canonical Ltd
+# Copyright (C) 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -17,9 +17,6 @@
 """Tests for implementations of Repository.has_same_location."""
 
 from bzrlib import bzrdir
-from bzrlib.tests import (
-    TestNotApplicable,
-    )
 from bzrlib.tests.repository_implementations import TestCaseWithRepository
 from bzrlib.transport import get_transport
 
@@ -83,21 +80,20 @@
         """
         repo = self.make_repository('repo')
         try:
-            control_transport = repo._transport
+            control_transport = repo.control_files._transport
         except AttributeError:
-            raise TestNotApplicable(
-                "%r has no transport" % (repo,))
+            # This test only applies to repository formats with control_files.
+            return
         if control_transport.base == repo.bzrdir.transport.base:
-            raise TestNotApplicable(
-                "%r has repository files directly in the bzrdir"
-                % (repo,))
             # This test only applies to repository formats where the repo
             # control_files are separate from other bzrdir files, i.e. metadir
             # formats.
+            return
         control_transport.copy_tree('.', '../repository.backup')
         backup_transport = control_transport.clone('../repository.backup')
         backup_repo = repo._format.open(repo.bzrdir, _found=True,
                                         _override_transport=backup_transport)
+
         self.assertDifferentRepo(repo, backup_repo)
 
     def test_different_format_not_equal(self):

=== modified file 'bzrlib/tests/repository_implementations/test_iter_reverse_revision_history.py'
--- bzrlib/tests/repository_implementations/test_iter_reverse_revision_history.py	2008-03-19 04:39:04 +0000
+++ bzrlib/tests/repository_implementations/test_iter_reverse_revision_history.py	2007-09-25 08:14:12 +0000
@@ -90,8 +90,7 @@
     def test_is_generator(self):
         tree = self.create_linear_history()
         repo = tree.branch.repository
-        repo.lock_read()
-        self.addCleanup(repo.unlock)
+
         rev_history = repo.iter_reverse_revision_history('rev4')
         self.assertEqual('rev4', rev_history.next())
         self.assertEqual('rev3', rev_history.next())
@@ -101,11 +100,7 @@
 
     def assertRevHistoryList(self, expected, repo, revision_id):
         """Assert the return values of iter_reverse_revision_history."""
-        repo.lock_read()
-        try:
-            actual = list(repo.iter_reverse_revision_history(revision_id))
-        finally:
-            repo.unlock()
+        actual = list(repo.iter_reverse_revision_history(revision_id))
         self.assertEqual(expected, actual)
 
     def test_linear_history(self):
@@ -124,6 +119,7 @@
     def test_revision_ids_are_utf8(self):
         tree = self.create_linear_history_with_utf8()
         repo = tree.branch.repository
+
         self.assertRevHistoryList(['rev-\xc3\xa5', 'rev-\xc2\xb5'],
                                   repo, 'rev-\xc3\xa5')
 

=== modified file 'bzrlib/tests/repository_implementations/test_reconcile.py'
--- bzrlib/tests/repository_implementations/test_reconcile.py	2008-06-11 04:20:16 +0000
+++ bzrlib/tests/repository_implementations/test_reconcile.py	2007-10-05 03:06:20 +0000
@@ -47,11 +47,10 @@
     def checkNoBackupInventory(self, aBzrDir):
         """Check that there is no backup inventory in aBzrDir."""
         repo = aBzrDir.open_repository()
-        # Remote repository, and possibly others, do not have 
-        # _transport.
-        if getattr(repo, '_transport', None) is not None:
-            for path in repo._transport.list_dir('.'):
-                self.assertFalse('inventory.backup' in path)
+        self.assertRaises(errors.NoSuchFile,
+                          repo.control_weaves.get_weave,
+                          'inventory.backup',
+                          repo.get_transaction())
 
 
 class TestsNeedingReweave(TestReconcile):
@@ -70,24 +69,6 @@
         repo.commit_write_group()
         repo.unlock()
 
-        def add_commit(repo, revision_id, parent_ids):
-            repo.lock_write()
-            repo.start_write_group()
-            inv = Inventory(revision_id=revision_id)
-            inv.root.revision = revision_id
-            root_id = inv.root.file_id
-            sha1 = repo.add_inventory(revision_id, inv, parent_ids)
-            repo.texts.add_lines((root_id, revision_id), [], [])
-            rev = bzrlib.revision.Revision(timestamp=0,
-                                           timezone=None,
-                                           committer="Foo Bar <foo@example.com>",
-                                           message="Message",
-                                           inventory_sha1=sha1,
-                                           revision_id=revision_id)
-            rev.parent_ids = parent_ids
-            repo.add_revision(revision_id, rev)
-            repo.commit_write_group()
-            repo.unlock()
         # an empty inventory with no revision for testing with.
         # this is referenced by 'references_missing' to let us test
         # that all the cached data is correctly converted into ghost links
@@ -96,21 +77,59 @@
         repo.lock_write()
         repo.start_write_group()
         repo.add_inventory('missing', inv, [])
+        inv = Inventory(revision_id='references_missing')
+        inv.root.revision = 'references_missing'
+        sha1 = repo.add_inventory('references_missing', inv, ['missing'])
+        rev = Revision(timestamp=0,
+                       timezone=None,
+                       committer="Foo Bar <foo@example.com>",
+                       message="Message",
+                       inventory_sha1=sha1,
+                       revision_id='references_missing')
+        rev.parent_ids = ['missing']
+        repo.add_revision('references_missing', rev)
         repo.commit_write_group()
         repo.unlock()
-        add_commit(repo, 'references_missing', ['missing'])
 
         # a inventory with no parents and the revision has parents..
         # i.e. a ghost.
         repo = self.make_repository('inventory_one_ghost')
-        add_commit(repo, 'ghost', ['the_ghost'])
+        repo.lock_write()
+        repo.start_write_group()
+        inv = Inventory(revision_id='ghost')
+        inv.root.revision = 'ghost'
+        sha1 = repo.add_inventory('ghost', inv, [])
+        rev = Revision(timestamp=0,
+                       timezone=None,
+                       committer="Foo Bar <foo@example.com>",
+                       message="Message",
+                       inventory_sha1=sha1,
+                       revision_id='ghost')
+        rev.parent_ids = ['the_ghost']
+        repo.add_revision('ghost', rev)
+        repo.commit_write_group()
+        repo.unlock()
          
         # a inventory with a ghost that can be corrected now.
         t.copy_tree('inventory_one_ghost', 'inventory_ghost_present')
         bzrdir_url = self.get_url('inventory_ghost_present')
         bzrdir = bzrlib.bzrdir.BzrDir.open(bzrdir_url)
         repo = bzrdir.open_repository()
-        add_commit(repo, 'the_ghost', [])
+        repo.lock_write()
+        repo.start_write_group()
+        inv = Inventory(revision_id='the_ghost')
+        inv.root.revision = 'the_ghost'
+        sha1 = repo.add_inventory('the_ghost', inv, [])
+        rev = Revision(timestamp=0,
+                       timezone=None,
+                       committer="Foo Bar <foo@example.com>",
+                       message="Message",
+                       inventory_sha1=sha1,
+                       revision_id='the_ghost')
+        rev.parent_ids = []
+        repo.add_revision('the_ghost', rev)
+        repo.commit_write_group()
+        repo.unlock()
 
     def checkEmptyReconcile(self, **kwargs):
         """Check a reconcile on an empty repository."""
@@ -193,15 +212,11 @@
                          repo.get_ancestry('references_missing'))
 
     def check_missing_was_removed(self, repo):
-        if repo._reconcile_backsup_inventory:
-            backed_up = False
-            for path in repo._transport.list_dir('.'):
-                if 'inventory.backup' in path:
-                    backed_up = True
-            self.assertTrue(backed_up)
-            # Not clear how to do this at an interface level:
-            # self.assertTrue('missing' in backup.versions())
-        self.assertRaises(errors.NoSuchRevision, repo.get_inventory, 'missing')
+        backup = repo.control_weaves.get_weave('inventory.backup',
+                                               repo.get_transaction())
+        self.assertTrue('missing' in backup.versions())
+        self.assertRaises(errors.RevisionNotPresent,
+                          repo.get_inventory, 'missing')
 
     def test_reweave_inventory_without_revision_reconciler(self):
         # smoke test for the all in one Reconciler class,
@@ -325,9 +340,6 @@
         repo.start_write_group()
         inv = Inventory(revision_id='wrong-secondary-parent')
         inv.root.revision = 'wrong-secondary-parent'
-        if repo.supports_rich_root():
-            root_id = inv.root.file_id
-            repo.texts.add_lines((root_id, 'wrong-secondary-parent'), [], [])
         sha1 = repo.add_inventory('wrong-secondary-parent', inv, ['1', '3', '2'])
         rev = Revision(timestamp=0,
                        timezone=None,
@@ -345,14 +357,9 @@
         t = get_transport(self.get_url()).clone('wrong-first-parent')
         d = bzrlib.bzrdir.BzrDir.open_from_transport(t)
         repo = d.open_repository()
-        repo.lock_read()
-        try:
-            g = repo.get_graph()
-            if g.get_parent_map(['wrong-first-parent'])['wrong-first-parent'] \
-                == ('1', '2'):
-                raise TestSkipped('wrong-first-parent is not setup for testing')
-        finally:
-            repo.unlock()
+        g = repo.get_revision_graph()
+        if tuple(g['wrong-first-parent']) == ('1', '2'):
+            raise TestSkipped('wrong-first-parent is not setup for testing')
         self.checkUnreconciled(d, repo.reconcile())
         # nothing should have been altered yet : inventories without
         # revisions are not data loss incurring for current format
@@ -362,12 +369,8 @@
         # and no garbage inventories
         self.assertEqual(0, reconciler.garbage_inventories)
         # and should have been fixed:
-        repo.lock_read()
-        self.addCleanup(repo.unlock)
-        g = repo.get_graph()
-        self.assertEqual(
-            {'wrong-first-parent':('1', '2')},
-            g.get_parent_map(['wrong-first-parent']))
+        g = repo.get_revision_graph()
+        self.assertEqual(('1', '2'), g['wrong-first-parent'])
 
     def test_reconcile_wrong_order_secondary_inventory(self):
         # a wrong order in the parents for inventories is ignored.
@@ -399,11 +402,3 @@
         self.assertFalse(reconciler.aborted,
             "reconcile should not have aborted on an unbroken repository.")
 
-
-class TestRepeatedReconcile(TestReconcile):
-
-    def test_trivial_two_reconciles_no_error(self):
-        tree = self.make_branch_and_tree('.')
-        tree.commit('first post')
-        tree.branch.repository.reconcile(thorough=True)
-        tree.branch.repository.reconcile(thorough=True)

=== modified file 'bzrlib/tests/repository_implementations/test_repository.py'
--- bzrlib/tests/repository_implementations/test_repository.py	2008-08-18 23:11:59 +0000
+++ bzrlib/tests/repository_implementations/test_repository.py	2007-10-12 08:18:54 +0000
@@ -23,27 +23,13 @@
 from bzrlib import (
     bzrdir,
     errors,
-    graph,
-    osutils,
     remote,
     repository,
     )
 from bzrlib.delta import TreeDelta
 from bzrlib.inventory import Inventory, InventoryDirectory
-from bzrlib.repofmt.weaverepo import (
-    RepositoryFormat5,
-    RepositoryFormat6,
-    RepositoryFormat7,
-    )
-from bzrlib.revision import NULL_REVISION, Revision
-from bzrlib.smart import server
-from bzrlib.symbol_versioning import one_two, one_three, one_four
-from bzrlib.tests import (
-    KnownFailure,
-    TestCaseWithTransport,
-    TestNotApplicable,
-    TestSkipped,
-    )
+from bzrlib.revision import NULL_REVISION
+from bzrlib.tests import TestCaseWithTransport, TestSkipped
 from bzrlib.tests.repository_implementations import TestCaseWithRepository
 from bzrlib.transport import get_transport
 from bzrlib.upgrade import upgrade
@@ -64,157 +50,6 @@
 
 class TestRepository(TestCaseWithRepository):
 
-    def test_attribute__fetch_order(self):
-        """Test the the _fetch_order attribute."""
-        tree = self.make_branch_and_tree('tree')
-        repo = tree.branch.repository
-        self.assertTrue(repo._fetch_order in ('topological', 'unordered'))
-
-    def test_attribute__fetch_uses_deltas(self):
-        """Test the the _fetch_uses_deltas attribute."""
-        tree = self.make_branch_and_tree('tree')
-        repo = tree.branch.repository
-        self.assertTrue(repo._fetch_uses_deltas in (True, False))
-
-    def test_attribute__fetch_reconcile(self):
-        """Test the the _fetch_reconcile attribute."""
-        tree = self.make_branch_and_tree('tree')
-        repo = tree.branch.repository
-        self.assertTrue(repo._fetch_reconcile in (True, False))
-
-    def test_attribute_inventories_store(self):
-        """Test the existence of the inventories attribute."""
-        tree = self.make_branch_and_tree('tree')
-        repo = tree.branch.repository
-        self.assertIsInstance(repo.inventories,
-            bzrlib.versionedfile.VersionedFiles)
-
-    def test_attribute_inventories_basics(self):
-        """Test basic aspects of the inventories attribute."""
-        tree = self.make_branch_and_tree('tree')
-        repo = tree.branch.repository
-        rev_id = (tree.commit('a'),)
-        tree.lock_read()
-        self.addCleanup(tree.unlock)
-        self.assertEqual(set([rev_id]), set(repo.inventories.keys()))
-
-    def test_attribute_revision_store(self):
-        """Test the existence of the revisions attribute."""
-        tree = self.make_branch_and_tree('tree')
-        repo = tree.branch.repository
-        self.assertIsInstance(repo.revisions,
-            bzrlib.versionedfile.VersionedFiles)
-
-    def test_attribute_revision_store_basics(self):
-        """Test the basic behaviour of the revisions attribute."""
-        tree = self.make_branch_and_tree('tree')
-        repo = tree.branch.repository
-        repo.lock_write()
-        try:
-            self.assertEqual(set(), set(repo.revisions.keys()))
-            revid = (tree.commit("foo"),)
-            self.assertEqual(set([revid]), set(repo.revisions.keys()))
-            self.assertEqual({revid:()},
-                repo.revisions.get_parent_map([revid]))
-        finally:
-            repo.unlock()
-        tree2 = self.make_branch_and_tree('tree2')
-        tree2.pull(tree.branch)
-        left_id = (tree2.commit('left'),)
-        right_id = (tree.commit('right'),)
-        tree.merge_from_branch(tree2.branch)
-        merge_id = (tree.commit('merged'),)
-        repo.lock_read()
-        self.addCleanup(repo.unlock)
-        self.assertEqual(set([revid, left_id, right_id, merge_id]),
-            set(repo.revisions.keys()))
-        self.assertEqual({revid:(), left_id:(revid,), right_id:(revid,),
-             merge_id:(right_id, left_id)},
-            repo.revisions.get_parent_map(repo.revisions.keys()))
-
-    def test_attribute_signature_store(self):
-        """Test the existence of the signatures attribute."""
-        tree = self.make_branch_and_tree('tree')
-        repo = tree.branch.repository
-        self.assertIsInstance(repo.signatures,
-            bzrlib.versionedfile.VersionedFiles)
-
-    def test_attribute_text_store_basics(self):
-        """Test the basic behaviour of the text store."""
-        tree = self.make_branch_and_tree('tree')
-        repo = tree.branch.repository
-        file_id = ("Foo:Bar",)
-        tree.lock_write()
-        try:
-            self.assertEqual(set(), set(repo.texts.keys()))
-            tree.add(['foo'], file_id, ['file'])
-            tree.put_file_bytes_non_atomic(file_id[0], 'content\n')
-            revid = (tree.commit("foo"),)
-            if repo._format.rich_root_data:
-                root_commit = (tree.get_root_id(),) + revid
-                keys = set([root_commit])
-                parents = {root_commit:()}
-            else:
-                keys = set()
-                parents = {}
-            keys.add(file_id + revid)
-            parents[file_id + revid] = ()
-            self.assertEqual(keys, set(repo.texts.keys()))
-            self.assertEqual(parents,
-                repo.texts.get_parent_map(repo.texts.keys()))
-        finally:
-            tree.unlock()
-        tree2 = self.make_branch_and_tree('tree2')
-        tree2.pull(tree.branch)
-        tree2.put_file_bytes_non_atomic('Foo:Bar', 'right\n')
-        right_id = (tree2.commit('right'),)
-        keys.add(file_id + right_id)
-        parents[file_id + right_id] = (file_id + revid,)
-        tree.put_file_bytes_non_atomic('Foo:Bar', 'left\n')
-        left_id = (tree.commit('left'),)
-        keys.add(file_id + left_id)
-        parents[file_id + left_id] = (file_id + revid,)
-        tree.merge_from_branch(tree2.branch)
-        tree.put_file_bytes_non_atomic('Foo:Bar', 'merged\n')
-        try:
-            tree.auto_resolve()
-        except errors.UnsupportedOperation:
-            pass
-        merge_id = (tree.commit('merged'),)
-        keys.add(file_id + merge_id)
-        parents[file_id + merge_id] = (file_id + left_id, file_id + right_id)
-        repo.lock_read()
-        self.addCleanup(repo.unlock)
-        self.assertEqual(keys, set(repo.texts.keys()))
-        self.assertEqual(parents, repo.texts.get_parent_map(repo.texts.keys()))
-
-    def test_attribute_text_store(self):
-        """Test the existence of the texts attribute."""
-        tree = self.make_branch_and_tree('tree')
-        repo = tree.branch.repository
-        self.assertIsInstance(repo.texts,
-            bzrlib.versionedfile.VersionedFiles)
-
-    def test_exposed_versioned_files_are_marked_dirty(self):
-        repo = self.make_repository('.')
-        repo.lock_write()
-        signatures = repo.signatures
-        revisions = repo.revisions
-        inventories = repo.inventories
-        repo.unlock()
-        self.assertRaises(errors.ObjectNotLocked,
-            signatures.keys)
-        self.assertRaises(errors.ObjectNotLocked,
-            revisions.keys)
-        self.assertRaises(errors.ObjectNotLocked,
-            inventories.keys)
-        self.assertRaises(errors.ObjectNotLocked,
-            signatures.add_lines, ('foo',), [], [])
-        self.assertRaises(errors.ObjectNotLocked,
-            revisions.add_lines, ('foo',), [], [])
-        self.assertRaises(errors.ObjectNotLocked,
-            inventories.add_lines, ('foo',), [], [])
-
     def test_clone_to_default_format(self):
         #TODO: Test that cloning a repository preserves all the information
         # such as signatures[not tested yet] etc etc.
@@ -226,24 +61,9 @@
         bzrdirb = self.make_bzrdir('b')
         repo_b = tree_a.branch.repository.clone(bzrdirb)
         tree_b = repo_b.revision_tree('rev1')
-        tree_b.lock_read()
-        self.addCleanup(tree_b.unlock)
         tree_b.get_file_text('file1')
         rev1 = repo_b.get_revision('rev1')
 
-    def test_iter_inventories_is_ordered(self):
-        # just a smoke test
-        tree = self.make_branch_and_tree('a')
-        first_revision = tree.commit('')
-        second_revision = tree.commit('')
-        tree.lock_read()
-        self.addCleanup(tree.unlock)
-        revs = (first_revision, second_revision)
-        invs = tree.branch.repository.iter_inventories(revs)
-        for rev_id, inv in zip(revs, invs):
-            self.assertEqual(rev_id, inv.revision_id)
-            self.assertIsInstance(inv, Inventory)
-
     def test_supports_rich_root(self):
         tree = self.make_branch_and_tree('a')
         tree.commit('')
@@ -419,11 +239,6 @@
         text = repo._format.get_format_description()
         self.failUnless(len(text))
 
-    def test_format_supports_external_lookups(self):
-        repo = self.make_repository('.')
-        self.assertSubset(
-            [repo._format.supports_external_lookups], (True, False))
-
     def assertMessageRoundtrips(self, message):
         """Assert that message roundtrips to a repository and back intact."""
         tree = self.make_branch_and_tree('.')
@@ -474,7 +289,7 @@
         repo = tree.branch.repository
         revision_ids = ['a-rev', 'b-rev', 'c-rev']
         revisions = repo.get_revisions(revision_ids)
-        self.assertEqual(len(revisions), 3)
+        assert len(revisions) == 3, repr(revisions)
         zipped = zip(revisions, revision_ids)
         self.assertEqual(len(zipped), 3)
         for revision, revision_id in zipped:
@@ -487,6 +302,36 @@
         rev_tree = tree.branch.repository.revision_tree(tree.last_revision())
         self.assertEqual('rev_id', rev_tree.inventory.root.revision)
 
+    def DISABLED_DELETE_OR_FIX_BEFORE_MERGE_test_create_basis_inventory(self):
+        # Needs testing here because differences between repo and working tree
+        # basis inventory formats can lead to bugs.
+        t = self.make_branch_and_tree('.')
+        b = t.branch
+        open('a', 'wb').write('a\n')
+        t.add('a')
+        t.commit('a', rev_id='r1')
+
+        t._control_files.get_utf8('basis-inventory-cache')
+
+        basis_inv = t.basis_tree().inventory
+        self.assertEquals('r1', basis_inv.revision_id)
+        
+        store_inv = b.repository.get_inventory('r1')
+        self.assertEquals(store_inv._byid, basis_inv._byid)
+
+        open('b', 'wb').write('b\n')
+        t.add('b')
+        t.commit('b', rev_id='r2')
+
+        t._control_files.get_utf8('basis-inventory-cache')
+
+        basis_inv_txt = t.read_basis_inventory()
+        basis_inv = bzrlib.xml7.serializer_v7.read_inventory_from_string(basis_inv_txt)
+        self.assertEquals('r2', basis_inv.revision_id)
+        store_inv = b.repository.get_inventory('r2')
+
+        self.assertEquals(store_inv._byid, basis_inv._byid)
+
     def test_upgrade_from_format4(self):
         from bzrlib.tests.test_upgrade import _upgrade_dir_template
         if self.repository_format.get_format_description() \
@@ -513,11 +358,72 @@
     def test_format_attributes(self):
         """All repository formats should have some basic attributes."""
         # create a repository to get a real format instance, not the 
-        # template from the test suite parameterization.
+        # template from the test suite parameterisation.
         repo = self.make_repository('.')
         repo._format.rich_root_data
         repo._format.supports_tree_reference
 
+    def test_get_data_stream(self):
+        # Make a repo with a revision
+        tree = self.make_branch_and_tree('t')
+        self.build_tree(['t/foo'])
+        tree.add('foo', 'file1')
+        tree.commit('message', rev_id='rev_id')
+        repo = tree.branch.repository
+
+        # Get a data stream (a file-like object) for that revision
+        try:
+            stream = repo.get_data_stream(['rev_id'])
+        except NotImplementedError:
+            # Not all repositories support streaming.
+            return
+
+        # The data stream is a iterator that yields (name, versioned_file)
+        # pairs for:
+        #   * the file knit (or knits; if this repo has rich roots there will
+        #     be a file knit for that as well as for 'file1').
+        #   * the inventory knit
+        #   * the revisions knit
+        # in that order.
+        expected_record_names = [
+            ('file', 'file1'),
+            ('inventory',),
+            ('signatures',),
+            ('revisions',)]
+        streamed_names = []
+        for name, bytes in stream:
+            streamed_names.append(name)
+
+        if repo.supports_rich_root():
+            # Check for the root versioned file in the stream, then remove it
+            # from streamed_names so we can compare that with
+            # expected_record_names.
+            # Note that the file knits can be in any order, so this test is
+            # written to allow that.
+            inv = repo.get_inventory('rev_id')
+            expected_record_name = ('file', inv.root.file_id)
+            self.assertTrue(expected_record_name in streamed_names)
+            streamed_names.remove(expected_record_name)
+
+        self.assertEqual(expected_record_names, streamed_names)
+
+    def test_insert_data_stream(self):
+        tree = self.make_branch_and_tree('source')
+        self.build_tree(['source/foo'])
+        tree.add('foo', 'file1')
+        tree.commit('message', rev_id='rev_id')
+        source_repo = tree.branch.repository
+        dest_repo = self.make_repository('dest')
+        try:
+            stream = source_repo.get_data_stream(['rev_id'])
+        except NotImplementedError, e:
+            # Not all repositories support streaming.
+            self.assertContainsRe(str(e), 'get_data_stream')
+            raise TestSkipped('This format does not support streaming.')
+
+        dest_repo.insert_data_stream(stream)
+        self.assertTrue(dest_repo.has_revision('rev_id'))
+
     def test_get_serializer_format(self):
         repo = self.make_repository('.')
         format = repo.get_serializer_format()
@@ -532,8 +438,6 @@
         self.build_tree_contents([('tree/file1', 'baz')])
         tree.commit('rev2', rev_id='rev2')
         repository = tree.branch.repository
-        repository.lock_read()
-        self.addCleanup(repository.unlock)
         extracted = dict((i, ''.join(b)) for i, b in
                          repository.iter_files_bytes(
                          [('file1-id', 'rev1', 'file1-old'),
@@ -557,8 +461,6 @@
         tree.add('foo', 'file1')
         tree.commit('message', rev_id='rev_id')
         repo = tree.branch.repository
-        repo.lock_read()
-        self.addCleanup(repo.unlock)
 
         # Item keys will be in this order, for maximum convenience for
         # generating data to insert into knit repository:
@@ -592,33 +494,8 @@
     def test_get_graph(self):
         """Bare-bones smoketest that all repositories implement get_graph."""
         repo = self.make_repository('repo')
-        repo.lock_read()
-        self.addCleanup(repo.unlock)
         repo.get_graph()
 
-    def test_graph_ghost_handling(self):
-        tree = self.make_branch_and_tree('here')
-        tree.lock_write()
-        self.addCleanup(tree.unlock)
-        tree.commit('initial commit', rev_id='rev1')
-        tree.add_parent_tree_id('ghost')
-        tree.commit('commit-with-ghost', rev_id='rev2')
-        graph = tree.branch.repository.get_graph()
-        parents = graph.get_parent_map(['ghost', 'rev2'])
-        self.assertTrue('ghost' not in parents)
-        self.assertEqual(parents['rev2'], ('rev1', 'ghost'))
-
-    def test_parent_map_type(self):
-        tree = self.make_branch_and_tree('here')
-        tree.lock_write()
-        self.addCleanup(tree.unlock)
-        tree.commit('initial commit', rev_id='rev1')
-        tree.commit('next commit', rev_id='rev2')
-        graph = tree.branch.repository.get_graph()
-        parents = graph.get_parent_map([NULL_REVISION, 'rev1', 'rev2'])
-        for value in parents.values():
-            self.assertIsInstance(value, tuple)
-
     def test_implements_revision_graph_can_have_wrong_parents(self):
         """All repositories should implement
         revision_graph_can_have_wrong_parents, so that check and reconcile can
@@ -626,201 +503,14 @@
         """
         repo = self.make_repository('.')
         # This should work, not raise NotImplementedError:
-        if not repo.revision_graph_can_have_wrong_parents():
-            return
-        repo.lock_read()
-        self.addCleanup(repo.unlock)
-        # This repo must also implement
-        # _find_inconsistent_revision_parents and
-        # _check_for_inconsistent_revision_parents.  So calling these
-        # should not raise NotImplementedError.
-        list(repo._find_inconsistent_revision_parents())
-        repo._check_for_inconsistent_revision_parents()
-
-    def test_add_signature_text(self):
-        repo = self.make_repository('repo')
-        repo.lock_write()
-        self.addCleanup(repo.unlock)
-        self.addCleanup(repo.commit_write_group)
-        repo.start_write_group()
-        inv = Inventory(revision_id='A')
-        inv.root.revision = 'A'
-        repo.add_inventory('A', inv, [])
-        repo.add_revision('A', Revision('A', committer='A', timestamp=0,
-                          inventory_sha1='', timezone=0, message='A'))
-        repo.add_signature_text('A', 'This might be a signature')
-        self.assertEqual('This might be a signature',
-                         repo.get_signature_text('A'))
-
-    def test_add_revision_inventory_sha1(self):
-        repo = self.make_repository('repo')
-        inv = Inventory(revision_id='A')
-        inv.root.revision = 'A'
-        inv.root.file_id = 'fixed-root'
-        repo.lock_write()
-        repo.start_write_group()
-        repo.add_revision('A', Revision('A', committer='B', timestamp=0,
-                          timezone=0, message='C'), inv=inv)
-        repo.commit_write_group()
-        repo.unlock()
-        repo.lock_read()
-        self.assertEquals(osutils.sha_string(
-            repo._serializer.write_inventory_to_string(inv)),
-            repo.get_revision('A').inventory_sha1)
-        repo.unlock()
-
-    def test_install_revisions(self):
-        wt = self.make_branch_and_tree('source')
-        wt.commit('A', allow_pointless=True, rev_id='A')
-        repo = wt.branch.repository
-        repo.lock_write()
-        repo.start_write_group()
-        repo.sign_revision('A', bzrlib.gpg.LoopbackGPGStrategy(None))
-        repo.commit_write_group()
-        repo.unlock()
-        repo.lock_read()
-        self.addCleanup(repo.unlock)
-        repo2 = self.make_repository('repo2')
-        revision = repo.get_revision('A')
-        tree = repo.revision_tree('A')
-        signature = repo.get_signature_text('A')
-        repo2.lock_write()
-        self.addCleanup(repo2.unlock)
-        repository.install_revisions(repo2, [(revision, tree, signature)])
-        self.assertEqual(revision, repo2.get_revision('A'))
-        self.assertEqual(signature, repo2.get_signature_text('A'))
-
-    # XXX: this helper duplicated from tests.test_repository
-    def make_remote_repository(self, path):
-        """Make a RemoteRepository object backed by a real repository that will
-        be created at the given path."""
-        repo = self.make_repository(path)
-        smart_server = server.SmartTCPServer_for_testing()
-        smart_server.setUp(self.get_server())
-        remote_transport = get_transport(smart_server.get_url()).clone(path)
-        self.addCleanup(smart_server.tearDown)
-        remote_bzrdir = bzrdir.BzrDir.open_from_transport(remote_transport)
-        remote_repo = remote_bzrdir.open_repository()
-        return remote_repo
-
-    def test_sprout_from_hpss_preserves_format(self):
-        """repo.sprout from a smart server preserves the repository format."""
-        if self.repository_format == RepositoryFormat7():
-            raise TestNotApplicable(
-                "Cannot fetch weaves over smart protocol.")
-        remote_repo = self.make_remote_repository('remote')
-        local_bzrdir = self.make_bzrdir('local')
-        try:
-            local_repo = remote_repo.sprout(local_bzrdir)
-        except errors.TransportNotPossible:
-            raise TestNotApplicable(
-                "Cannot lock_read old formats like AllInOne over HPSS.")
-        remote_backing_repo = bzrdir.BzrDir.open(
-            self.get_vfs_only_url('remote')).open_repository()
-        self.assertEqual(remote_backing_repo._format, local_repo._format)
-
-    def test_sprout_branch_from_hpss_preserves_repo_format(self):
-        """branch.sprout from a smart server preserves the repository format.
-        """
-        weave_formats = [RepositoryFormat5(), RepositoryFormat6(),
-                         RepositoryFormat7()]
-        if self.repository_format in weave_formats:
-            raise TestNotApplicable(
-                "Cannot fetch weaves over smart protocol.")
-        remote_repo = self.make_remote_repository('remote')
-        remote_branch = remote_repo.bzrdir.create_branch()
-        try:
-            local_bzrdir = remote_branch.bzrdir.sprout('local')
-        except errors.TransportNotPossible:
-            raise TestNotApplicable(
-                "Cannot lock_read old formats like AllInOne over HPSS.")
-        local_repo = local_bzrdir.open_repository()
-        remote_backing_repo = bzrdir.BzrDir.open(
-            self.get_vfs_only_url('remote')).open_repository()
-        self.assertEqual(remote_backing_repo._format, local_repo._format)
-
-    def test__make_parents_provider(self):
-        """Repositories must have a _make_parents_provider method that returns
-        an object with a get_parent_map method.
-        """
-        repo = self.make_repository('repo')
-        repo._make_parents_provider().get_parent_map
-
-    def make_repository_and_foo_bar(self, shared):
-        made_control = self.make_bzrdir('repository')
-        repo = made_control.create_repository(shared=shared)
-        bzrdir.BzrDir.create_branch_convenience(self.get_url('repository/foo'),
-                                                force_new_repo=False)
-        bzrdir.BzrDir.create_branch_convenience(self.get_url('repository/bar'),
-                                                force_new_repo=True)
-        baz = self.make_bzrdir('repository/baz')
-        qux = self.make_branch('repository/baz/qux')
-        quxx = self.make_branch('repository/baz/qux/quxx')
-        return repo
-
-    def test_find_branches(self):
-        repo = self.make_repository_and_foo_bar(shared=False)
-        branches = repo.find_branches()
-        self.assertContainsRe(branches[-1].base, 'repository/foo/$')
-        self.assertContainsRe(branches[-3].base, 'repository/baz/qux/$')
-        self.assertContainsRe(branches[-2].base, 'repository/baz/qux/quxx/$')
-        # in some formats, creating a repo creates a branch
-        if len(branches) == 6:
-            self.assertContainsRe(branches[-4].base, 'repository/baz/$')
-            self.assertContainsRe(branches[-5].base, 'repository/bar/$')
-            self.assertContainsRe(branches[-6].base, 'repository/$')
-        else:
-            self.assertEqual(4, len(branches))
-            self.assertContainsRe(branches[-4].base, 'repository/bar/$')
-
-    def test_find_branches_using(self):
-        try:
-            repo = self.make_repository_and_foo_bar(shared=True)
-        except errors.IncompatibleFormat:
-            raise TestNotApplicable
-        branches = repo.find_branches(using=True)
-        self.assertContainsRe(branches[-1].base, 'repository/foo/$')
-        # in some formats, creating a repo creates a branch
-        if len(branches) == 2:
-            self.assertContainsRe(branches[-2].base, 'repository/$')
-        else:
-            self.assertEqual(1, len(branches))
-
-    def test_find_branches_using_standalone(self):
-        branch = self.make_branch('branch')
-        contained = self.make_branch('branch/contained')
-        branches = branch.repository.find_branches(using=True)
-        self.assertEqual([branch.base], [b.base for b in branches])
-        branches = branch.repository.find_branches(using=False)
-        self.assertEqual([branch.base, contained.base],
-                         [b.base for b in branches])
-
-    def test_find_branches_using_empty_standalone_repo(self):
-        repo = self.make_repository('repo')
-        self.assertFalse(repo.is_shared())
-        try:
-            repo.bzrdir.open_branch()
-        except errors.NotBranchError:
-            self.assertEqual([], repo.find_branches(using=True))
-        else:
-            self.assertEqual([repo.bzrdir.root_transport.base],
-                             [b.base for b in repo.find_branches(using=True)])
-
-    def test_set_get_make_working_trees_true(self):
-        repo = self.make_repository('repo')
-        try:
-            repo.set_make_working_trees(True)
-        except errors.RepositoryUpgradeRequired, e:
-            raise TestNotApplicable('Format does not support this flag.')
-        self.assertTrue(repo.make_working_trees())
-
-    def test_set_get_make_working_trees_false(self):
-        repo = self.make_repository('repo')
-        try:
-            repo.set_make_working_trees(False)
-        except errors.RepositoryUpgradeRequired, e:
-            raise TestNotApplicable('Format does not support this flag.')
-        self.assertFalse(repo.make_working_trees())
+        result = repo.revision_graph_can_have_wrong_parents()
+        if result:
+            # If true, then this repo must also implement
+            # _find_inconsistent_revision_parents and
+            # _check_for_inconsistent_revision_parents.  So calling these
+            # should also not raise NotImplementedError.
+            list(repo._find_inconsistent_revision_parents())
+            repo._check_for_inconsistent_revision_parents()
 
 
 class TestRepositoryLocking(TestCaseWithRepository):
@@ -891,9 +581,9 @@
         tree_a.lock_write()
         try:
             tree_a.branch.repository.start_write_group()
+            inv_file = tree_a.branch.repository.get_inventory_weave()
             try:
-                inv_file = tree_a.branch.repository.inventories
-                inv_file.add_lines(('orphan',), [], [])
+                inv_file.add_lines('orphan', [], [])
             except:
                 tree_a.branch.repository.commit_write_group()
                 raise
@@ -907,10 +597,7 @@
         tree_a.commit('rev2', rev_id='rev2', allow_pointless=True)
         # add a reference to a ghost
         tree_a.add_parent_tree_id('ghost1')
-        try:
-            tree_a.commit('rev3', rev_id='rev3', allow_pointless=True)
-        except errors.RevisionNotPresent:
-            raise TestNotApplicable("Cannot test with ghosts for this format.")
+        tree_a.commit('rev3', rev_id='rev3', allow_pointless=True)
         # add another reference to a ghost, and a second ghost.
         tree_a.add_parent_tree_id('ghost1')
         tree_a.add_parent_tree_id('ghost2')
@@ -919,29 +606,25 @@
     def test_revision_trees(self):
         revision_ids = ['rev1', 'rev2', 'rev3', 'rev4']
         repository = self.bzrdir.open_repository()
-        repository.lock_read()
-        self.addCleanup(repository.unlock)
         trees1 = list(repository.revision_trees(revision_ids))
         trees2 = [repository.revision_tree(t) for t in revision_ids]
-        self.assertEqual(len(trees1), len(trees2))
+        assert len(trees1) == len(trees2)
         for tree1, tree2 in zip(trees1, trees2):
-            self.assertFalse(tree2.changes_from(tree1).has_changed())
+            assert not tree2.changes_from(tree1).has_changed()
 
     def test_get_deltas_for_revisions(self):
         repository = self.bzrdir.open_repository()
-        repository.lock_read()
-        self.addCleanup(repository.unlock)
         revisions = [repository.get_revision(r) for r in 
                      ['rev1', 'rev2', 'rev3', 'rev4']]
         deltas1 = list(repository.get_deltas_for_revisions(revisions))
         deltas2 = [repository.get_revision_delta(r.revision_id) for r in
                    revisions]
-        self.assertEqual(deltas1, deltas2)
+        assert deltas1 == deltas2
 
     def test_all_revision_ids(self):
         # all_revision_ids -> all revisions
-        self.assertEqual(set(['rev1', 'rev2', 'rev3', 'rev4']),
-            set(self.bzrdir.open_repository().all_revision_ids()))
+        self.assertEqual(['rev1', 'rev2', 'rev3', 'rev4'],
+                         self.bzrdir.open_repository().all_revision_ids())
 
     def test_get_ancestry_missing_revision(self):
         # get_ancestry(revision that is in some data but not fully installed
@@ -949,11 +632,63 @@
         self.assertRaises(errors.NoSuchRevision,
                           self.bzrdir.open_repository().get_ancestry, 'orphan')
 
-    def test_get_unordered_ancestry(self):
+    def test_get_unsorted_ancestry(self):
         repo = self.bzrdir.open_repository()
         self.assertEqual(set(repo.get_ancestry('rev3')),
                          set(repo.get_ancestry('rev3', topo_sorted=False)))
 
+    def test_get_revision_graph(self):
+        # we can get a mapping of id->parents for the entire revision graph or bits thereof.
+        self.assertEqual({'rev1':(),
+                          'rev2':('rev1', ),
+                          'rev3':('rev2', ),
+                          'rev4':('rev3', ),
+                          },
+                         self.bzrdir.open_repository().get_revision_graph(None))
+        self.assertEqual({'rev1':()},
+                         self.bzrdir.open_repository().get_revision_graph('rev1'))
+        self.assertEqual({'rev1':(),
+                          'rev2':('rev1', )},
+                         self.bzrdir.open_repository().get_revision_graph('rev2'))
+        self.assertRaises(errors.NoSuchRevision,
+                          self.bzrdir.open_repository().get_revision_graph,
+                          'orphan')
+        # and ghosts are not mentioned
+        self.assertEqual({'rev1':(),
+                          'rev2':('rev1', ),
+                          'rev3':('rev2', ),
+                          },
+                         self.bzrdir.open_repository().get_revision_graph('rev3'))
+        # and we can ask for the NULLREVISION graph
+        self.assertEqual({},
+            self.bzrdir.open_repository().get_revision_graph(NULL_REVISION))
+
+    def test_get_revision_graph_with_ghosts(self):
+        # we can get a graph object with roots, ghosts, ancestors and
+        # descendants.
+        repo = self.bzrdir.open_repository()
+        graph = repo.get_revision_graph_with_ghosts([])
+        self.assertEqual(set(['rev1']), graph.roots)
+        self.assertEqual(set(['ghost1', 'ghost2']), graph.ghosts)
+        self.assertEqual({'rev1':[],
+                          'rev2':['rev1'],
+                          'rev3':['rev2', 'ghost1'],
+                          'rev4':['rev3', 'ghost1', 'ghost2'],
+                          },
+                          graph.get_ancestors())
+        self.assertEqual({'ghost1':{'rev3':1, 'rev4':1},
+                          'ghost2':{'rev4':1},
+                          'rev1':{'rev2':1},
+                          'rev2':{'rev3':1},
+                          'rev3':{'rev4':1},
+                          'rev4':{},
+                          },
+                          graph.get_descendants())
+        # and we can ask for the NULLREVISION graph
+        graph = repo.get_revision_graph_with_ghosts([NULL_REVISION])
+        self.assertEqual({}, graph.get_ancestors())
+        self.assertEqual({}, graph.get_descendants())
+
     def test_reserved_id(self):
         repo = self.make_repository('repository')
         repo.lock_write()
@@ -987,10 +722,7 @@
                                        inventory_sha1=sha1,
                                        revision_id='ghost')
         rev.parent_ids = ['the_ghost']
-        try:
-            repo.add_revision('ghost', rev)
-        except (errors.NoSuchRevision, errors.RevisionNotPresent):
-            raise TestNotApplicable("Cannot test with ghosts for this format.")
+        repo.add_revision('ghost', rev)
          
         inv = Inventory(revision_id = 'the_ghost')
         inv.root.revision = 'the_ghost'
@@ -1004,10 +736,8 @@
         rev.parent_ids = []
         repo.add_revision('the_ghost', rev)
         # check its setup usefully
-        inv_weave = repo.inventories
-        possible_parents = (None, (('ghost',),))
-        self.assertSubset(inv_weave.get_parent_map([('ghost',)])[('ghost',)],
-            possible_parents)
+        inv_weave = repo.get_inventory_weave()
+        self.assertEqual(['ghost'], inv_weave.get_ancestry(['ghost']))
         repo.commit_write_group()
         repo.unlock()
 
@@ -1063,8 +793,6 @@
         # now access over vfat; should be safe
         branch = bzrdir.BzrDir.open('vfat+' + self.get_url('repo')).open_branch()
         revtree = branch.repository.revision_tree(REV_ID)
-        revtree.lock_read()
-        self.addCleanup(revtree.unlock)
         contents = revtree.get_file_text(FOO_ID)
         self.assertEqual(contents, 'contents of repo/foo\n')
 

=== modified file 'bzrlib/tests/repository_implementations/test_revision.py'
--- bzrlib/tests/repository_implementations/test_revision.py	2008-04-24 07:22:53 +0000
+++ bzrlib/tests/repository_implementations/test_revision.py	2006-08-15 17:01:22 +0000
@@ -75,7 +75,7 @@
                                'unicode':'\xb5',
                                'multiline':'foo\nbar\n\n'
                               })
-        self.assertTrue(len(tree1.branch.revision_history()) > 0)
+        assert len(tree1.branch.revision_history()) > 0
         rev_a = tree1.branch.repository.get_revision(
                             tree1.branch.last_revision())
 

=== modified file 'bzrlib/tests/repository_implementations/test_statistics.py'
--- bzrlib/tests/repository_implementations/test_statistics.py	2008-06-11 04:20:16 +0000
+++ bzrlib/tests/repository_implementations/test_statistics.py	2007-02-03 10:56:04 +0000
@@ -21,6 +21,16 @@
 
 class TestGatherStats(TestCaseWithRepository):
 
+    def check_stats_has_size(self, stats):
+        """Check that stats has a reasonable size entry."""
+        # actual disk size varies from implementation to implementation,
+        # but they should all provide it on their native transport.
+        self.assertTrue('size' in stats)
+        # and it should be a number
+        self.assertIsInstance(stats['size'], (int, long))
+        # and now remove it to make other assertions work without variation.
+        del stats['size']
+
     def test_gather_stats(self):
         """First smoke test covering the refactoring into the Repository api."""
         tree = self.make_branch_and_memory_tree('.')
@@ -38,6 +48,7 @@
         # now, in the same repository, asking for stats with/without the 
         # committers flag generates the same date information.
         stats = tree.branch.repository.gather_stats(rev2, committers=False)
+        self.check_stats_has_size(stats)
         self.assertEqual({
             'firstrev': (1170491381.0, 0),
             'latestrev': (1171491381.0, 0),
@@ -45,6 +56,7 @@
             },
             stats)
         stats = tree.branch.repository.gather_stats(rev2, committers=True)
+        self.check_stats_has_size(stats)
         self.assertEqual({
             'committers': 2,
             'firstrev': (1170491381.0, 0),
@@ -53,11 +65,28 @@
             },
             stats)
 
+    def test_gather_stats_norevid_gets_size(self):
+        """Without a revid, repository size is still gathered."""
+        tree = self.make_branch_and_memory_tree('.')
+        tree.lock_write()
+        tree.add('')
+        # put something in the repository, because zero-size is borink.
+        rev1 = tree.commit('first post')
+        tree.unlock()
+        # now ask for global repository stats.
+        stats = tree.branch.repository.gather_stats()
+        self.check_stats_has_size(stats)
+        self.assertEqual({
+            'revisions': 1
+            },
+            stats)
+
     def test_gather_stats_empty_repo(self):
-        """An empty repository still has revisions."""
+        """An empty repository still has size and revisions."""
         tree = self.make_branch_and_memory_tree('.')
         # now ask for global repository stats.
         stats = tree.branch.repository.gather_stats()
+        self.check_stats_has_size(stats)
         self.assertEqual({
             'revisions': 0
             },

=== modified file 'bzrlib/tests/repository_implementations/test_write_group.py'
--- bzrlib/tests/repository_implementations/test_write_group.py	2007-10-25 01:24:51 +0000
+++ bzrlib/tests/repository_implementations/test_write_group.py	2007-07-17 16:04:00 +0000
@@ -61,7 +61,7 @@
         self.assertEqual(None, repo.commit_write_group())
         repo.unlock()
 
-    def test_unlock_in_write_group(self):
+    def test_unlock_after_start_errors(self):
         repo = self.make_repository('.')
         repo.lock_write()
         repo.start_write_group()
@@ -69,11 +69,9 @@
         # really to be sure it's used right, not for signalling
         # semantic information.
         self.assertRaises(errors.BzrError, repo.unlock)
-        # after this error occurs, the repository is unlocked, and the write
-        # group is gone.  you've had your chance, and you blew it. ;-)
-        self.assertFalse(repo.is_locked())
-        self.assertRaises(errors.BzrError, repo.commit_write_group)
-        self.assertRaises(errors.BzrError, repo.unlock)
+        self.assertTrue(repo.is_locked())
+        repo.commit_write_group()
+        repo.unlock()
 
     def test_is_in_write_group(self):
         repo = self.make_repository('.')

=== added directory 'bzrlib/tests/revisionstore_implementations'
=== added file 'bzrlib/tests/revisionstore_implementations/__init__.py'
--- bzrlib/tests/revisionstore_implementations/__init__.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/revisionstore_implementations/__init__.py	2007-06-28 06:44:36 +0000
@@ -0,0 +1,91 @@
+# Copyright (C) 2006 Canonical Ltd
+# Authors: Robert Collins <robert.collins@canonical.com>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+
+"""RevisionStore implemnetation tests for bzr.
+
+These test the conformance of all the revision store implementations to the 
+expected API including generally applicable corner cases.
+Specific tests for individual cases are in the tests/test_revisionstore.py file 
+rather than in tests/revisionstore_implementations/*.py.
+"""
+
+from bzrlib.tests import (
+                          adapt_modules,
+                          default_transport,
+                          TestLoader,
+                          TestScenarioApplier,
+                          TestSuite,
+                          )
+
+
+class RevisionStoreTestProviderAdapter(TestScenarioApplier):
+    """A tool to generate a suite testing multiple repository stores.
+
+    This is done by copying the test once for each repository store
+    and injecting the transport_server, transport_readonly_server,
+    and revision-store-factory into each copy.
+    Each copy is also given a new id() to make it easy to identify.
+    """
+
+    def __init__(self, transport_server, transport_readonly_server, factories):
+        self._transport_server = transport_server
+        self._transport_readonly_server = transport_readonly_server
+        self.scenarios = self.factories_to_scenarios(factories)
+    
+    def factories_to_scenarios(self, factories):
+        """Transform the input factories to a list of scenarios.
+
+        :param factories: A list of factories.
+        """
+        result = []
+        for factory in factories:
+            scenario = (factory, {
+                "transport_server":self._transport_server,
+                "transport_readonly_server":self._transport_readonly_server,
+                "store_factory":factory,
+                })
+            result.append(scenario)
+        return result
+
+    @staticmethod
+    def default_test_list():
+        """Generate the default list of revision store permutations to test."""
+        from bzrlib.store.revision.text import TextRevisionStoreTestFactory
+        from bzrlib.store.revision.knit import KnitRevisionStoreFactory
+        result = []
+        # test the fallback InterVersionedFile from weave to annotated knits
+        result.append(TextRevisionStoreTestFactory())
+        result.append(KnitRevisionStoreFactory())
+        return result
+
+
+def test_suite():
+    result = TestSuite()
+    test_revisionstore_implementations = [
+        'bzrlib.tests.revisionstore_implementations.test_all',
+        ]
+    adapter = RevisionStoreTestProviderAdapter(
+        default_transport,
+        # None here will cause a readonly decorator to be created
+        # by the TestCaseWithTransport.get_readonly_transport method.
+        None,
+        RevisionStoreTestProviderAdapter.default_test_list()
+        )
+    loader = TestLoader()
+    adapt_modules(test_revisionstore_implementations, adapter, loader, result)
+    return result

=== added file 'bzrlib/tests/revisionstore_implementations/test_all.py'
--- bzrlib/tests/revisionstore_implementations/test_all.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/revisionstore_implementations/test_all.py	2007-08-22 23:43:36 +0000
@@ -0,0 +1,127 @@
+# Copyright (C) 2006 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+"""Revision store tests."""
+
+
+import bzrlib.errors as errors
+from bzrlib.revision import Revision
+from bzrlib.store.revision import RevisionStore
+from bzrlib.tests import TestCaseWithTransport
+from bzrlib.transactions import PassThroughTransaction
+
+
+class TestFactory(TestCaseWithTransport):
+
+    def test_factory_keeps_smoke_in(self):
+        s = self.store_factory.create(self.get_url('.'))
+        self.assertTrue(isinstance(s, RevisionStore))
+
+
+class TestAll(TestCaseWithTransport):
+
+    def setUp(self):
+        super(TestAll, self).setUp()
+        self.store = self.store_factory.create(self.get_url('.'))
+        self.transaction = PassThroughTransaction()
+
+    def test_add_has_get(self):
+        rev = self.add_sample_rev()
+        self.assertTrue(self.store.has_revision_id('A', self.transaction))
+        rev2 = self.store.get_revision('A', self.transaction)
+        self.assertEqual(rev, rev2)
+
+    def add_sample_rev(self):
+        rev = Revision(timestamp=0,
+                       timezone=0,
+                       committer="Foo Bar <foo@example.com>",
+                       message="Message",
+                       inventory_sha1='aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa',
+                       revision_id='A')
+        self.store.add_revision(rev, self.transaction)
+        return rev
+
+    def test_has_missing(self):
+        # has of a non present id -> False
+        self.assertFalse(self.store.has_revision_id('missing', self.transaction))
+
+    def test_has_null(self):
+        # has of null -> True
+        self.assertTrue(self.store.has_revision_id('null:', self.transaction))
+
+    def test_get_revision_missing(self):
+        # get_revision('B') -> raises NoSuchRevision
+        self.assertRaises(errors.NoSuchRevision,
+                          self.store.get_revision,
+                          'B',
+                          self.transaction)
+
+    def test_get_revision_null(self):
+        # get_revision(null) -> raises ReservedId
+        self.assertRaises(errors.ReservedId,
+                          self.store.get_revision,
+                          'null:',
+                          self.transaction)
+
+    def test_add_signature_text_missing(self):
+        # add of a text signature for a missing revision must work, to allow
+        # revisions to be added after the signature.
+        self.store.add_revision_signature_text('A', 'foo\nbar', self.transaction)
+        # but must not be visible
+        self.assertRaises(errors.NoSuchRevision,
+                          self.store.has_signature,
+                          'A',
+                          self.transaction)
+        # at all
+        self.assertRaises(errors.NoSuchRevision,
+                          self.store.get_signature_text,
+                          'A',
+                          self.transaction)
+        # until the revision is added
+        self.add_sample_rev()
+        self.assertTrue(self.store.has_signature('A', self.transaction))
+        self.assertEqual('foo\nbar',
+                         self.store.get_signature_text('A', self.transaction))
+    
+    def test_add_signature_text(self):
+        # add a signature to a existing revision works.
+        self.add_sample_rev()
+        self.assertFalse(self.store.has_signature('A', self.transaction))
+        self.assertRaises(errors.NoSuchRevision,
+                          self.store.get_signature_text,
+                          'A',
+                          self.transaction)
+        self.store.add_revision_signature_text('A', 'foo\nbar', self.transaction)
+        self.assertTrue(self.store.has_signature('A', self.transaction))
+        self.assertEqual('foo\nbar',
+                         self.store.get_signature_text('A', self.transaction))
+
+    def test_total_size(self):
+        # we get a revision count and a numeric size figure from total_size().
+        count, bytes = self.store.total_size(self.transaction)
+        self.assertEqual(0, count)
+        # some stores use disk immediately that they are created so we just 
+        # check that its an int.
+        self.assertIsInstance(bytes, (int, long))
+        self.add_sample_rev()
+        count, bytes = self.store.total_size(self.transaction)
+        self.assertEqual(1, count)
+        self.assertNotEqual(0, bytes)
+        
+    def test_all_revision_ids(self):
+        self.assertEqual([], self.store.all_revision_ids(self.transaction))
+        self.add_sample_rev()
+        self.assertEqual(['A'], self.store.all_revision_ids(self.transaction))

=== modified file 'bzrlib/tests/stub_sftp.py'
--- bzrlib/tests/stub_sftp.py	2008-04-24 07:22:53 +0000
+++ bzrlib/tests/stub_sftp.py	2006-09-08 18:52:17 +0000
@@ -71,10 +71,9 @@
         if home is None:
             self.home = ''
         else:
-            if not home.startswith(self.root):
-                raise AssertionError(
-                    "home must be a subdirectory of root (%s vs %s)"
-                    % (home, root))
+            assert home.startswith(self.root), \
+                    "home must be a subdirectory of root (%s vs %s)" \
+                    % (home, root)
             self.home = home[len(self.root):]
         if self.home.startswith('/'):
             self.home = self.home[1:]

=== modified file 'bzrlib/tests/test__dirstate_helpers.py'
--- bzrlib/tests/test__dirstate_helpers.py	2008-09-02 18:51:03 +0000
+++ bzrlib/tests/test__dirstate_helpers.py	2007-07-18 20:30:14 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007, 2008 Canonical Ltd
+# Copyright (C) 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -21,7 +21,6 @@
 
 from bzrlib import (
     dirstate,
-    errors,
     tests,
     )
 from bzrlib.tests import test_dirstate
@@ -692,20 +691,6 @@
         self.assertEqual(dirstate.DirState.IN_MEMORY_UNMODIFIED,
                          state._dirblock_state)
 
-    def test_trailing_garbage(self):
-        tree, state, expected = self.create_basic_dirstate()
-        # We can modify the file as long as it hasn't been read yet.
-        f = open('dirstate', 'ab')
-        try:
-            # Add bogus trailing garbage
-            f.write('bogus\n')
-        finally:
-            f.close()
-        e = self.assertRaises(errors.DirstateCorrupt,
-                              state._read_dirblocks_if_needed)
-        # Make sure we mention the bogus characters in the error
-        self.assertContainsRe(str(e), 'bogus')
-
 
 class TestCompiledReadDirblocks(TestReadDirblocks):
     """Test the pyrex implementation of _read_dirblocks"""

=== removed file 'bzrlib/tests/test__walkdirs_win32.py'
--- bzrlib/tests/test__walkdirs_win32.py	2008-07-17 03:46:13 +0000
+++ bzrlib/tests/test__walkdirs_win32.py	1970-01-01 00:00:00 +0000
@@ -1,122 +0,0 @@
-# Copyright (C) 2008 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Tests for the win32 walkdir extension."""
-
-import errno
-
-from bzrlib import tests
-
-
-class _WalkdirsWin32Feature(tests.Feature):
-
-    def _probe(self):
-        try:
-            import bzrlib._walkdirs_win32
-        except ImportError:
-            return False
-        else:
-            return True
-
-    def feature_name(self):
-        return 'bzrlib._walkdirs_win32'
-
-WalkdirsWin32Feature = _WalkdirsWin32Feature()
-
-
-class TestWin32Finder(tests.TestCaseInTempDir):
-
-    _test_needs_features = [WalkdirsWin32Feature]
-
-    def setUp(self):
-        super(TestWin32Finder, self).setUp()
-        from bzrlib._walkdirs_win32 import (
-            _walkdirs_utf8_win32_find_file
-            )
-        self.walkdirs_utf8 = _walkdirs_utf8_win32_find_file
-
-    def _remove_stat_from_dirblock(self, dirblock):
-        return [info[:3] + info[4:] for info in dirblock]
-
-    def assertWalkdirs(self, expected, top, prefix=''):
-        finder = self.walkdirs_utf8(top, prefix=prefix)
-        result = []
-        for dirname, dirblock in finder:
-            result.append((dirname, self._remove_stat_from_dirblock(dirblock)))
-        self.assertEqual(expected, result)
-
-    def test_empty_directory(self):
-        self.assertWalkdirs([(('', u'.'), [])], u'.')
-
-    def test_file_in_dir(self):
-        self.build_tree(['foo'])
-        self.assertWalkdirs([
-            (('', u'.'), [('foo', 'foo', 'file', u'./foo')])
-            ], u'.')
-
-    def test_subdir(self):
-        self.build_tree(['foo', 'bar/', 'bar/baz'])
-        self.assertWalkdirs([
-            (('', u'.'), [('bar', 'bar', 'directory', u'./bar'),
-                          ('foo', 'foo', 'file', u'./foo'),
-                         ]),
-            (('bar', u'./bar'), [('bar/baz', 'baz', 'file', u'./bar/baz')]),
-            ], '.')
-        self.assertWalkdirs([
-            (('xxx', u'.'), [('xxx/bar', 'bar', 'directory', u'./bar'),
-                             ('xxx/foo', 'foo', 'file', u'./foo'),
-                            ]),
-            (('xxx/bar', u'./bar'), [('xxx/bar/baz', 'baz', 'file', u'./bar/baz')]),
-            ], '.', prefix='xxx')
-        self.assertWalkdirs([
-            (('', u'bar'), [('baz', 'baz', 'file', u'bar/baz')]),
-            ], 'bar')
-
-    def test_skip_subdir(self): 
-        self.build_tree(['a/', 'b/', 'c/', 'a/aa', 'b/bb', 'c/cc'])
-        base_dirblock = [('a', 'a', 'directory', u'./a'),
-                          ('b', 'b', 'directory', u'./b'),
-                          ('c', 'c', 'directory', u'./c'),
-                         ]
-        self.assertWalkdirs([
-            (('', u'.'), base_dirblock),
-            (('a', u'./a'), [('a/aa', 'aa', 'file', u'./a/aa')]),
-            (('b', u'./b'), [('b/bb', 'bb', 'file', u'./b/bb')]),
-            (('c', u'./c'), [('c/cc', 'cc', 'file', u'./c/cc')]),
-            ], '.')
-
-        walker = self.walkdirs_utf8('.')
-        dir_info, first_dirblock = walker.next()
-        self.assertEqual(('', u'.'), dir_info)
-        self.assertEqual(base_dirblock,
-                         self._remove_stat_from_dirblock(first_dirblock))
-        # Now, remove 'b' and it should be skipped on the next round
-        del first_dirblock[1]
-        dir_info, second_dirblock = walker.next()
-        second_dirblock = self._remove_stat_from_dirblock(second_dirblock)
-        self.assertEqual(('a', u'./a'), dir_info)
-        self.assertEqual([('a/aa', 'aa', 'file', u'./a/aa')], second_dirblock)
-        dir_info, third_dirblock = walker.next()
-        third_dirblock = self._remove_stat_from_dirblock(third_dirblock)
-        self.assertEqual(('c', u'./c'), dir_info)
-        self.assertEqual([('c/cc', 'cc', 'file', u'./c/cc')], third_dirblock)
-
-    def test_missing_dir(self):
-        e = self.assertRaises(WindowsError, list,
-                                self.walkdirs_utf8(u'no_such_dir'))
-        self.assertEqual(errno.ENOENT, e.errno)
-        self.assertEqual(3, e.winerror)
-        self.assertEqual((3, u'no_such_dir/*'), e.args)

=== modified file 'bzrlib/tests/test_ancestry.py'
--- bzrlib/tests/test_ancestry.py	2008-05-12 02:40:40 +0000
+++ bzrlib/tests/test_ancestry.py	2007-07-11 16:42:37 +0000
@@ -22,6 +22,7 @@
 from bzrlib.tests import TestCaseWithMemoryTransport
 from bzrlib.branch import Branch
 from bzrlib.branchbuilder import BranchBuilder
+from bzrlib.revision import is_ancestor
 
 
 class TestAncestry(TestCaseWithMemoryTransport):
@@ -41,4 +42,17 @@
             rev_id_two, branch)
         self.assertAncestryEqual([None, rev_id_one], rev_id_one, branch)
 
+    def test_none_is_ancestor_empty_branch(self):
+        branch = self.make_branch('.')
+        self.assertTrue(is_ancestor('null:', 'null:', branch))
+
+    def test_none_is_ancestor_non_empty_branch(self):
+        builder = BranchBuilder(self.get_transport())
+        rev_id = builder.build_commit()
+        branch = builder.get_branch()
+        self.assertTrue(is_ancestor('null:', 'null:', branch))
+        self.assertTrue(is_ancestor(rev_id, 'null:',  branch))
+        self.assertFalse(is_ancestor('null:', rev_id, branch))
+
+
 # TODO: check that ancestry is updated to include indirectly merged revisions

=== modified file 'bzrlib/tests/test_annotate.py'
--- bzrlib/tests/test_annotate.py	2008-07-29 16:50:43 +0000
+++ bzrlib/tests/test_annotate.py	2007-08-31 19:38:52 +0000
@@ -107,62 +107,6 @@
 """.splitlines(True)
 
 
-# For the 'duplicate' series, both sides introduce the same change, which then
-# gets merged around. The last-modified should properly reflect this.
-# We always change the fourth line so that the file is properly tracked as
-# being modified in each revision. In reality, this probably would happen over
-# many revisions, and it would be a different line that changes.
-# BASE
-#  |\
-#  A B  # line should be annotated as new for A and B
-#  |\|
-#  C D  # line should 'converge' and say A
-#  |/
-#  E    # D should supersede A and stay as D (not become E because C references
-#         A)
-duplicate_base = annotation("""\
-rev-base first
-rev-base second
-rev-base third
-rev-base fourth-base
-""")
-
-duplicate_A = annotation("""\
-rev-base first
-rev-A alt-second
-rev-base third
-rev-A fourth-A
-""")
-
-duplicate_B = annotation("""\
-rev-base first
-rev-B alt-second
-rev-base third
-rev-B fourth-B
-""")
-
-duplicate_C = annotation("""\
-rev-base first
-rev-A alt-second
-rev-base third
-rev-C fourth-C
-""")
-
-duplicate_D = annotation("""\
-rev-base first
-rev-A alt-second
-rev-base third
-rev-D fourth-D
-""")
-
-duplicate_E = annotation("""\
-rev-base first
-rev-A alt-second
-rev-base third
-rev-E fourth-E
-""")
-
-
 class TestAnnotate(tests.TestCaseWithTransport):
 
     def create_merged_trees(self):
@@ -184,7 +128,7 @@
                      committer="joe@foo.com",
                      timestamp=1166046000.00, timezone=0)
 
-        tree2 = tree1.bzrdir.sprout('tree2').open_workingtree()
+        tree2 = tree1.bzrdir.clone('tree2').open_workingtree()
 
         self.build_tree_contents([('tree1/a', 'first\nsecond\n')])
         tree1.commit('b', rev_id='rev-2',
@@ -205,8 +149,6 @@
         tree1.commit('merge 2', rev_id='rev-3',
                      committer='sal@foo.com',
                      timestamp=1166046003.00, timezone=0)
-        tree1.lock_read()
-        self.addCleanup(tree1.unlock)
         return tree1, tree2
 
     def create_deeply_merged_trees(self):
@@ -218,11 +160,11 @@
          |      |          |
          +------+          |
          |      |          |
-        rev-3  rev-1_1_2  rev-1_2_1 ------+
+        rev-3  rev-1_1_2  rev-1_1_1_1_1 --+
          |      |          |              |
          +------+          |              |
          |                 |              |
-        rev-4             rev-1_2_2  rev-1_3_1
+        rev-4             rev-1_1_1_1_2  rev-1_1_1_1_1_1_1
          |                 |              |
          +-----------------+              |
          |                                |
@@ -233,22 +175,21 @@
         rev-6
         """
         tree1, tree2 = self.create_merged_trees()
-        tree1.unlock()
 
-        tree3 = tree2.bzrdir.sprout('tree3').open_workingtree()
+        tree3 = tree2.bzrdir.clone('tree3').open_workingtree()
 
         tree2.commit('noop', rev_id='rev-1_1_2')
         self.assertEqual(0, tree1.merge_from_branch(tree2.branch))
         tree1.commit('noop merge', rev_id='rev-4')
 
         self.build_tree_contents([('tree3/a', 'first\nthird\nfourth\n')])
-        tree3.commit('four', rev_id='rev-1_2_1',
+        tree3.commit('four', rev_id='rev-1_1_1_1_1',
                      committer='jerry@foo.com',
                      timestamp=1166046003.00, timezone=0)
 
-        tree4 = tree3.bzrdir.sprout('tree4').open_workingtree()
+        tree4 = tree3.bzrdir.clone('tree4').open_workingtree()
 
-        tree3.commit('noop', rev_id='rev-1_2_2',
+        tree3.commit('noop', rev_id='rev-1_1_1_1_2',
                      committer='jerry@foo.com',
                      timestamp=1166046004.00, timezone=0)
         self.assertEqual(0, tree1.merge_from_branch(tree3.branch))
@@ -256,67 +197,12 @@
 
         self.build_tree_contents([('tree4/a',
                                    'first\nthird\nfourth\nfifth\nsixth\n')])
-        tree4.commit('five and six', rev_id='rev-1_3_1',
+        tree4.commit('five and six', rev_id='rev-1_1_1_1_1_1_1',
                      committer='george@foo.com',
                      timestamp=1166046005.00, timezone=0)
         self.assertEqual(0, tree1.merge_from_branch(tree4.branch))
         tree1.commit('merge five and six', rev_id='rev-6')
-        tree1.lock_read()
-        return tree1
-
-    def create_duplicate_lines_tree(self):
-        tree1 = self.make_branch_and_tree('tree1')
-        base_text = ''.join(l for r, l in duplicate_base)
-        a_text = ''.join(l for r, l in duplicate_A)
-        b_text = ''.join(l for r, l in duplicate_B)
-        c_text = ''.join(l for r, l in duplicate_C)
-        d_text = ''.join(l for r, l in duplicate_D)
-        e_text = ''.join(l for r, l in duplicate_E)
-        self.build_tree_contents([('tree1/file', base_text)])
-        tree1.add(['file'], ['file-id'])
-        tree1.commit('base', rev_id='rev-base')
-        tree2 = tree1.bzrdir.sprout('tree2').open_workingtree()
-
-        self.build_tree_contents([('tree1/file', a_text),
-                                  ('tree2/file', b_text)])
-        tree1.commit('A', rev_id='rev-A')
-        tree2.commit('B', rev_id='rev-B')
-
-        tree2.merge_from_branch(tree1.branch)
-        conflicts.resolve(tree2, None) # Resolve the conflicts
-        self.build_tree_contents([('tree2/file', d_text)])
-        tree2.commit('D', rev_id='rev-D')
-
-        self.build_tree_contents([('tree1/file', c_text)])
-        tree1.commit('C', rev_id='rev-C')
-
-        tree1.merge_from_branch(tree2.branch)
-        conflicts.resolve(tree1, None) # Resolve the conflicts
-        self.build_tree_contents([('tree1/file', e_text)])
-        tree1.commit('E', rev_id='rev-E')
-        return tree1
-
-    def assertRepoAnnotate(self, expected, repo, file_id, revision_id):
-        """Assert that the revision is properly annotated."""
-        actual = list(repo.revision_tree(revision_id).annotate_iter(file_id))
-        if actual != expected:
-            # Create an easier to understand diff when the lines don't actually
-            # match
-            self.assertEqualDiff(''.join('\t'.join(l) for l in expected),
-                                 ''.join('\t'.join(l) for l in actual))
-
-    def test_annotate_duplicate_lines(self):
-        # XXX: Should this be a repository_implementations test?
-        tree1 = self.create_duplicate_lines_tree()
-        repo = tree1.branch.repository
-        repo.lock_read()
-        self.addCleanup(repo.unlock)
-        self.assertRepoAnnotate(duplicate_base, repo, 'file-id', 'rev-base')
-        self.assertRepoAnnotate(duplicate_A, repo, 'file-id', 'rev-A')
-        self.assertRepoAnnotate(duplicate_B, repo, 'file-id', 'rev-B')
-        self.assertRepoAnnotate(duplicate_C, repo, 'file-id', 'rev-C')
-        self.assertRepoAnnotate(duplicate_D, repo, 'file-id', 'rev-D')
-        self.assertRepoAnnotate(duplicate_E, repo, 'file-id', 'rev-E')
+        return tree1
 
     def test_annotate_shows_dotted_revnos(self):
         tree1, tree2 = self.create_merged_trees()
@@ -336,46 +222,46 @@
         sio = StringIO()
         annotate.annotate_file(tree1.branch, 'rev-6', 'a-id',
                                to_file=sio, verbose=False, full=False)
-        self.assertEqualDiff('1     joe@foo | first\n'
-                             '2     joe@foo | second\n'
-                             '1.1.1 barry@f | third\n'
-                             '1.2.1 jerry@f | fourth\n'
-                             '1.3.1 george@ | fifth\n'
-                             '              | sixth\n',
+        self.assertEqualDiff('1            joe@foo | first\n'
+                             '2            joe@foo | second\n'
+                             '1.1.1        barry@f | third\n'
+                             '1.1.1.1.1    jerry@f | fourth\n'
+                             '1.1.1.1.1.1> george@ | fifth\n'
+                             '                     | sixth\n',
                              sio.getvalue())
 
         sio = StringIO()
         annotate.annotate_file(tree1.branch, 'rev-6', 'a-id',
                                to_file=sio, verbose=False, full=True)
-        self.assertEqualDiff('1     joe@foo | first\n'
-                             '2     joe@foo | second\n'
-                             '1.1.1 barry@f | third\n'
-                             '1.2.1 jerry@f | fourth\n'
-                             '1.3.1 george@ | fifth\n'
-                             '1.3.1 george@ | sixth\n',
+        self.assertEqualDiff('1            joe@foo | first\n'
+                             '2            joe@foo | second\n'
+                             '1.1.1        barry@f | third\n'
+                             '1.1.1.1.1    jerry@f | fourth\n'
+                             '1.1.1.1.1.1> george@ | fifth\n'
+                             '1.1.1.1.1.1> george@ | sixth\n',
                              sio.getvalue())
 
         # verbose=True shows everything, the full revno, user id, and date
         sio = StringIO()
         annotate.annotate_file(tree1.branch, 'rev-6', 'a-id',
                                to_file=sio, verbose=True, full=False)
-        self.assertEqualDiff('1     joe@foo.com    20061213 | first\n'
-                             '2     joe@foo.com    20061213 | second\n'
-                             '1.1.1 barry@foo.com  20061213 | third\n'
-                             '1.2.1 jerry@foo.com  20061213 | fourth\n'
-                             '1.3.1 george@foo.com 20061213 | fifth\n'
-                             '                              | sixth\n',
+        self.assertEqualDiff('1             joe@foo.com    20061213 | first\n'
+                             '2             joe@foo.com    20061213 | second\n'
+                             '1.1.1         barry@foo.com  20061213 | third\n'
+                             '1.1.1.1.1     jerry@foo.com  20061213 | fourth\n'
+                             '1.1.1.1.1.1.1 george@foo.com 20061213 | fifth\n'
+                             '                                      | sixth\n',
                              sio.getvalue())
 
         sio = StringIO()
         annotate.annotate_file(tree1.branch, 'rev-6', 'a-id',
                                to_file=sio, verbose=True, full=True)
-        self.assertEqualDiff('1     joe@foo.com    20061213 | first\n'
-                             '2     joe@foo.com    20061213 | second\n'
-                             '1.1.1 barry@foo.com  20061213 | third\n'
-                             '1.2.1 jerry@foo.com  20061213 | fourth\n'
-                             '1.3.1 george@foo.com 20061213 | fifth\n'
-                             '1.3.1 george@foo.com 20061213 | sixth\n',
+        self.assertEqualDiff('1             joe@foo.com    20061213 | first\n'
+                             '2             joe@foo.com    20061213 | second\n'
+                             '1.1.1         barry@foo.com  20061213 | third\n'
+                             '1.1.1.1.1     jerry@foo.com  20061213 | fourth\n'
+                             '1.1.1.1.1.1.1 george@foo.com 20061213 | fifth\n'
+                             '1.1.1.1.1.1.1 george@foo.com 20061213 | sixth\n',
                              sio.getvalue())
 
     def test_annotate_uses_branch_context(self):
@@ -387,13 +273,13 @@
         tree1 = self.create_deeply_merged_trees()
 
         sio = StringIO()
-        annotate.annotate_file(tree1.branch, 'rev-1_3_1', 'a-id',
+        annotate.annotate_file(tree1.branch, 'rev-1_1_1_1_1_1_1', 'a-id',
                                to_file=sio, verbose=False, full=False)
-        self.assertEqualDiff('1     joe@foo | first\n'
-                             '1.1.1 barry@f | third\n'
-                             '1.2.1 jerry@f | fourth\n'
-                             '1.3.1 george@ | fifth\n'
-                             '              | sixth\n',
+        self.assertEqualDiff('1            joe@foo | first\n'
+                             '1.1.1        barry@f | third\n'
+                             '1.1.1.1.1    jerry@f | fourth\n'
+                             '1.1.1.1.1.1> george@ | fifth\n'
+                             '                     | sixth\n',
                              sio.getvalue())
 
     def test_annotate_show_ids(self):
@@ -404,24 +290,24 @@
                                to_file=sio, show_ids=True, full=False)
 
         # It looks better with real revision ids :)
-        self.assertEqualDiff('    rev-1 | first\n'
-                             '    rev-2 | second\n'
-                             'rev-1_1_1 | third\n'
-                             'rev-1_2_1 | fourth\n'
-                             'rev-1_3_1 | fifth\n'
-                             '          | sixth\n',
+        self.assertEqualDiff('            rev-1 | first\n'
+                             '            rev-2 | second\n'
+                             '        rev-1_1_1 | third\n'
+                             '    rev-1_1_1_1_1 | fourth\n'
+                             'rev-1_1_1_1_1_1_1 | fifth\n'
+                             '                  | sixth\n',
                              sio.getvalue())
 
         sio = StringIO()
         annotate.annotate_file(tree1.branch, 'rev-6', 'a-id',
                                to_file=sio, show_ids=True, full=True)
 
-        self.assertEqualDiff('    rev-1 | first\n'
-                             '    rev-2 | second\n'
-                             'rev-1_1_1 | third\n'
-                             'rev-1_2_1 | fourth\n'
-                             'rev-1_3_1 | fifth\n'
-                             'rev-1_3_1 | sixth\n',
+        self.assertEqualDiff('            rev-1 | first\n'
+                             '            rev-2 | second\n'
+                             '        rev-1_1_1 | third\n'
+                             '    rev-1_1_1_1_1 | fourth\n'
+                             'rev-1_1_1_1_1_1_1 | fifth\n'
+                             'rev-1_1_1_1_1_1_1 | sixth\n',
                              sio.getvalue())
 
     def test_annotate_unicode_author(self):
@@ -439,8 +325,6 @@
                      committer=u'p\xe9rez',
                      timestamp=1166046000.00, timezone=0)
 
-        tree1.lock_read()
-        self.addCleanup(tree1.unlock)
         # this passes if no exception is raised
         to_file = StringIO()
         annotate.annotate_file(tree1.branch, 'rev-1', 'a-id', to_file=to_file)
@@ -478,8 +362,6 @@
                      author='Author <author@example.com>',
                      timestamp=1166046000.00, timezone=0)
 
-        tree1.lock_read()
-        self.addCleanup(tree1.unlock)
         to_file = StringIO()
         annotate.annotate_file(tree1.branch, 'rev-1', 'a-id', to_file=to_file)
         self.assertEqual('1   committ | hello\n', to_file.getvalue())

=== modified file 'bzrlib/tests/test_bad_files.py'
--- bzrlib/tests/test_bad_files.py	2007-11-02 05:12:17 +0000
+++ bzrlib/tests/test_bad_files.py	2007-07-04 02:43:26 +0000
@@ -25,7 +25,7 @@
     errors,
     )
 from bzrlib.status import show_tree_status
-from bzrlib.tests import OsFifoFeature, TestCaseWithTransport
+from bzrlib.tests import TestCaseWithTransport
 
 
 def verify_status(tester, tree, value):
@@ -40,7 +40,10 @@
 
     def test_bad_files(self):
         """Test that bzr will ignore files it doesn't like"""
-        self.requireFeature(OsFifoFeature)
+        if getattr(os, 'mkfifo', None) is None:
+            # TODO: Ultimately this should be TestSkipped
+            # or PlatformDeficiency
+            return
 
         wt = self.make_branch_and_tree('.')
         b = wt.branch

=== modified file 'bzrlib/tests/test_branch.py'
--- bzrlib/tests/test_branch.py	2008-07-22 19:48:40 +0000
+++ bzrlib/tests/test_branch.py	2007-10-04 05:50:44 +0000
@@ -53,7 +53,6 @@
 from bzrlib.tests import TestCase, TestCaseWithTransport
 from bzrlib.transport import get_transport
 
-
 class TestDefaultFormat(TestCase):
 
     def test_default_format(self):
@@ -123,7 +122,7 @@
         self.assertFileEqual("# comment\n"
                              "[%s]\n"
                              "push_location = foo\n"
-                             "push_location:policy = norecurse\n" % local_path,
+                             "push_location:policy = norecurse" % local_path,
                              fn)
 
     # TODO RBC 20051029 test getting a push location from a branch in a
@@ -201,36 +200,26 @@
         self.make_branch_and_tree('bar')
 
 
-class TestBranch67(object):
-    """Common tests for both branch 6 and 7 which are mostly the same."""
-
-    def get_format_name(self):
-        raise NotImplementedError(self.get_format_name)
-
-    def get_format_name_subtree(self):
-        raise NotImplementedError(self.get_format_name)
-
-    def get_class(self):
-        raise NotImplementedError(self.get_class)
+class TestBranch6(TestCaseWithTransport):
 
     def test_creation(self):
         format = BzrDirMetaFormat1()
         format.set_branch_format(_mod_branch.BzrBranchFormat6())
         branch = self.make_branch('a', format=format)
-        self.assertIsInstance(branch, self.get_class())
-        branch = self.make_branch('b', format=self.get_format_name())
-        self.assertIsInstance(branch, self.get_class())
+        self.assertIsInstance(branch, _mod_branch.BzrBranch6)
+        branch = self.make_branch('b', format='dirstate-tags')
+        self.assertIsInstance(branch, _mod_branch.BzrBranch6)
         branch = _mod_branch.Branch.open('a')
-        self.assertIsInstance(branch, self.get_class())
+        self.assertIsInstance(branch, _mod_branch.BzrBranch6)
 
     def test_layout(self):
-        branch = self.make_branch('a', format=self.get_format_name())
+        branch = self.make_branch('a', format='dirstate-tags')
         self.failUnlessExists('a/.bzr/branch/last-revision')
         self.failIfExists('a/.bzr/branch/revision-history')
 
     def test_config(self):
         """Ensure that all configuration data is stored in the branch"""
-        branch = self.make_branch('a', format=self.get_format_name())
+        branch = self.make_branch('a', format='dirstate-tags')
         branch.set_parent('http://bazaar-vcs.org')
         self.failIfExists('a/.bzr/branch/parent')
         self.assertEqual('http://bazaar-vcs.org', branch.get_parent())
@@ -243,26 +232,26 @@
         self.assertEqual('ftp://bazaar-vcs.org', branch.get_bound_location())
 
     def test_set_revision_history(self):
-        builder = self.make_branch_builder('.', format=self.get_format_name())
-        builder.build_snapshot('foo', None,
-            [('add', ('', None, 'directory', None))],
-            message='foo')
-        builder.build_snapshot('bar', None, [], message='bar')
-        branch = builder.get_branch()
-        branch.lock_write()
-        self.addCleanup(branch.unlock)
-        branch.set_revision_history(['foo', 'bar'])
-        branch.set_revision_history(['foo'])
-        self.assertRaises(errors.NotLefthandHistory,
-                          branch.set_revision_history, ['bar'])
+        tree = self.make_branch_and_memory_tree('.',
+            format='dirstate-tags')
+        tree.lock_write()
+        try:
+            tree.add('.')
+            tree.commit('foo', rev_id='foo')
+            tree.commit('bar', rev_id='bar')
+            tree.branch.set_revision_history(['foo', 'bar'])
+            tree.branch.set_revision_history(['foo'])
+            self.assertRaises(errors.NotLefthandHistory,
+                              tree.branch.set_revision_history, ['bar'])
+        finally:
+            tree.unlock()
 
     def do_checkout_test(self, lightweight=False):
-        tree = self.make_branch_and_tree('source',
-            format=self.get_format_name_subtree())
+        tree = self.make_branch_and_tree('source', format='dirstate-with-subtree')
         subtree = self.make_branch_and_tree('source/subtree',
-            format=self.get_format_name_subtree())
+            format='dirstate-with-subtree')
         subsubtree = self.make_branch_and_tree('source/subtree/subsubtree',
-            format=self.get_format_name_subtree())
+            format='dirstate-with-subtree')
         self.build_tree(['source/subtree/file',
                          'source/subtree/subsubtree/file'])
         subsubtree.add('file')
@@ -290,7 +279,7 @@
         self.do_checkout_test(lightweight=True)
 
     def test_set_push(self):
-        branch = self.make_branch('source', format=self.get_format_name())
+        branch = self.make_branch('source', format='dirstate-tags')
         branch.get_config().set_user_option('push_location', 'old',
             store=config.STORE_LOCATION)
         warnings = []
@@ -305,78 +294,6 @@
         self.assertEqual(warnings[0], 'Value "new" is masked by "old" from '
                          'locations.conf')
 
-
-class TestBranch6(TestBranch67, TestCaseWithTransport):
-
-    def get_class(self):
-        return _mod_branch.BzrBranch6
-
-    def get_format_name(self):
-        return "dirstate-tags"
-
-    def get_format_name_subtree(self):
-        return "dirstate-with-subtree"
-
-    def test_set_stacked_on_url_errors(self):
-        branch = self.make_branch('a', format=self.get_format_name())
-        self.assertRaises(errors.UnstackableBranchFormat,
-            branch.set_stacked_on_url, None)
-
-    def test_default_stacked_location(self):
-        branch = self.make_branch('a', format=self.get_format_name())
-        self.assertRaises(errors.UnstackableBranchFormat, branch.get_stacked_on_url)
-
-
-class TestBranch7(TestBranch67, TestCaseWithTransport):
-
-    def get_class(self):
-        return _mod_branch.BzrBranch7
-
-    def get_format_name(self):
-        return "development"
-
-    def get_format_name_subtree(self):
-        return "development-subtree"
-
-    def test_set_stacked_on_url_unstackable_repo(self):
-        repo = self.make_repository('a', format='dirstate-tags')
-        control = repo.bzrdir
-        branch = _mod_branch.BzrBranchFormat7().initialize(control)
-        target = self.make_branch('b')
-        self.assertRaises(errors.UnstackableRepositoryFormat,
-            branch.set_stacked_on_url, target.base)
-
-    def test_clone_stacked_on_unstackable_repo(self):
-        repo = self.make_repository('a', format='dirstate-tags')
-        control = repo.bzrdir
-        branch = _mod_branch.BzrBranchFormat7().initialize(control)
-        # Calling clone should not raise UnstackableRepositoryFormat.
-        cloned_bzrdir = control.clone('cloned')
-
-    def _test_default_stacked_location(self):
-        branch = self.make_branch('a', format=self.get_format_name())
-        self.assertRaises(errors.NotStacked, branch.get_stacked_on_url)
-
-    def test_stack_and_unstack(self):
-        branch = self.make_branch('a', format=self.get_format_name())
-        target = self.make_branch_and_tree('b', format=self.get_format_name())
-        branch.set_stacked_on_url(target.branch.base)
-        self.assertEqual(target.branch.base, branch.get_stacked_on_url())
-        revid = target.commit('foo')
-        self.assertTrue(branch.repository.has_revision(revid))
-        branch.set_stacked_on_url(None)
-        self.assertRaises(errors.NotStacked, branch.get_stacked_on_url)
-        self.assertFalse(branch.repository.has_revision(revid))
-
-    def test_open_opens_stacked_reference(self):
-        branch = self.make_branch('a', format=self.get_format_name())
-        target = self.make_branch_and_tree('b', format=self.get_format_name())
-        branch.set_stacked_on_url(target.branch.base)
-        branch = branch.bzrdir.open_branch()
-        revid = target.commit('foo')
-        self.assertTrue(branch.repository.has_revision(revid))
-
-
 class TestBranchReference(TestCaseWithTransport):
     """Tests for the branch reference facility."""
 
@@ -417,8 +334,6 @@
         self.assertTrue("pre_commit" in hooks, "pre_commit not in %s" % hooks)
         self.assertTrue("post_pull" in hooks, "post_pull not in %s" % hooks)
         self.assertTrue("post_uncommit" in hooks, "post_uncommit not in %s" % hooks)
-        self.assertTrue("post_change_branch_tip" in hooks,
-                        "post_change_branch_tip not in %s" % hooks)
 
     def test_installed_hooks_are_BranchHooks(self):
         """The installed hooks object should be a BranchHooks."""

=== modified file 'bzrlib/tests/test_branchbuilder.py'
--- bzrlib/tests/test_branchbuilder.py	2008-07-29 16:16:36 +0000
+++ bzrlib/tests/test_branchbuilder.py	2007-04-27 06:16:29 +0000
@@ -18,7 +18,6 @@
 
 from bzrlib import (
     branch as _mod_branch,
-    errors,
     revision as _mod_revision,
     tests,
     )
@@ -72,218 +71,3 @@
         self.assertEqual(
             [rev_id1],
             branch.repository.get_revision(branch.last_revision()).parent_ids)
-
-
-class TestBranchBuilderBuildSnapshot(tests.TestCaseWithMemoryTransport):
-
-    def assertTreeShape(self, expected_shape, tree):
-        """Check that the tree shape matches expectations."""
-        tree.lock_read()
-        try:
-            entries = [(path, ie.file_id, ie.kind)
-                       for path, ie in tree.iter_entries_by_dir()]
-        finally:
-            tree.unlock()
-        self.assertEqual(expected_shape, entries)
-
-    def build_a_rev(self):
-        builder = BranchBuilder(self.get_transport().clone('foo'))
-        rev_id1 = builder.build_snapshot('A-id', None,
-            [('add', ('', 'a-root-id', 'directory', None)),
-             ('add', ('a', 'a-id', 'file', 'contents'))])
-        self.assertEqual('A-id', rev_id1)
-        return builder
-
-    def test_add_one_file(self):
-        builder = self.build_a_rev()
-        branch = builder.get_branch()
-        self.assertEqual((1, 'A-id'), branch.last_revision_info())
-        rev_tree = branch.repository.revision_tree('A-id')
-        rev_tree.lock_read()
-        self.addCleanup(rev_tree.unlock)
-        self.assertTreeShape([(u'', 'a-root-id', 'directory'),
-                              (u'a', 'a-id', 'file')], rev_tree)
-        self.assertEqual('contents', rev_tree.get_file_text('a-id'))
-
-    def test_add_second_file(self):
-        builder = self.build_a_rev()
-        rev_id2 = builder.build_snapshot('B-id', None,
-            [('add', ('b', 'b-id', 'file', 'content_b'))])
-        self.assertEqual('B-id', rev_id2)
-        branch = builder.get_branch()
-        self.assertEqual((2, rev_id2), branch.last_revision_info())
-        rev_tree = branch.repository.revision_tree(rev_id2)
-        rev_tree.lock_read()
-        self.addCleanup(rev_tree.unlock)
-        self.assertTreeShape([(u'', 'a-root-id', 'directory'),
-                              (u'a', 'a-id', 'file'),
-                              (u'b', 'b-id', 'file')], rev_tree)
-        self.assertEqual('content_b', rev_tree.get_file_text('b-id'))
-
-    def test_add_empty_dir(self):
-        builder = self.build_a_rev()
-        rev_id2 = builder.build_snapshot('B-id', None,
-            [('add', ('b', 'b-id', 'directory', None))])
-        rev_tree = builder.get_branch().repository.revision_tree('B-id')
-        self.assertTreeShape([(u'', 'a-root-id', 'directory'),
-                              (u'a', 'a-id', 'file'),
-                              (u'b', 'b-id', 'directory'),
-                             ], rev_tree)
-
-    def test_commit_message_default(self):
-        builder = BranchBuilder(self.get_transport().clone('foo'))
-        rev_id = builder.build_snapshot(None, None,
-            [('add', (u'', None, 'directory', None))])
-        branch = builder.get_branch()
-        rev = branch.repository.get_revision(rev_id)
-        self.assertEqual(u'commit 1', rev.message)
-
-    def test_commit_message_supplied(self):
-        builder = BranchBuilder(self.get_transport().clone('foo'))
-        rev_id = builder.build_snapshot(None, None,
-            [('add', (u'', None, 'directory', None))],
-            message=u'Foo')
-        branch = builder.get_branch()
-        rev = branch.repository.get_revision(rev_id)
-        self.assertEqual(u'Foo', rev.message)
-
-    def test_modify_file(self):
-        builder = self.build_a_rev()
-        rev_id2 = builder.build_snapshot('B-id', None,
-            [('modify', ('a-id', 'new\ncontent\n'))])
-        self.assertEqual('B-id', rev_id2)
-        branch = builder.get_branch()
-        rev_tree = branch.repository.revision_tree(rev_id2)
-        rev_tree.lock_read()
-        self.addCleanup(rev_tree.unlock)
-        self.assertEqual('new\ncontent\n', rev_tree.get_file_text('a-id'))
-
-    def test_delete_file(self):
-        builder = self.build_a_rev()
-        rev_id2 = builder.build_snapshot('B-id', None,
-            [('unversion', 'a-id')])
-        self.assertEqual('B-id', rev_id2)
-        branch = builder.get_branch()
-        rev_tree = branch.repository.revision_tree(rev_id2)
-        rev_tree.lock_read()
-        self.addCleanup(rev_tree.unlock)
-        self.assertTreeShape([(u'', 'a-root-id', 'directory')], rev_tree)
-
-    def test_delete_directory(self):
-        builder = self.build_a_rev()
-        rev_id2 = builder.build_snapshot('B-id', None,
-            [('add', ('b', 'b-id', 'directory', None)),
-             ('add', ('b/c', 'c-id', 'file', 'foo\n')),
-             ('add', ('b/d', 'd-id', 'directory', None)),
-             ('add', ('b/d/e', 'e-id', 'file', 'eff\n')),
-            ])
-        rev_tree = builder.get_branch().repository.revision_tree('B-id')
-        self.assertTreeShape([(u'', 'a-root-id', 'directory'),
-                              (u'a', 'a-id', 'file'),
-                              (u'b', 'b-id', 'directory'),
-                              (u'b/c', 'c-id', 'file'),
-                              (u'b/d', 'd-id', 'directory'),
-                              (u'b/d/e', 'e-id', 'file')], rev_tree)
-        # Removing a directory removes all child dirs
-        builder.build_snapshot('C-id', None, [('unversion', 'b-id')])
-        rev_tree = builder.get_branch().repository.revision_tree('C-id')
-        self.assertTreeShape([(u'', 'a-root-id', 'directory'),
-                              (u'a', 'a-id', 'file'),
-                             ], rev_tree)
-
-    def test_unknown_action(self):
-        builder = self.build_a_rev()
-        e = self.assertRaises(ValueError,
-            builder.build_snapshot, 'B-id', None, [('weirdo', ('foo',))])
-        self.assertEqual('Unknown build action: "weirdo"', str(e))
-
-    # TODO: rename a file/directory, but rename isn't supported by the
-    #       MemoryTree api yet, so for now we wait until it is used
-
-    def test_set_parent(self):
-        builder = self.build_a_rev()
-        builder.start_series()
-        self.addCleanup(builder.finish_series)
-        builder.build_snapshot('B-id', ['A-id'],
-            [('modify', ('a-id', 'new\ncontent\n'))])
-        builder.build_snapshot('C-id', ['A-id'], 
-            [('add', ('c', 'c-id', 'file', 'alt\ncontent\n'))])
-        # We should now have a graph:
-        #   A
-        #   |\
-        #   C B
-        # And not A => B => C
-        repo = builder.get_branch().repository
-        self.assertEqual({'B-id': ('A-id',), 'C-id': ('A-id',)},
-                         repo.get_parent_map(['B-id', 'C-id']))
-        b_tree = repo.revision_tree('B-id')
-        self.assertTreeShape([(u'', 'a-root-id', 'directory'),
-                              (u'a', 'a-id', 'file'),
-                             ], b_tree)
-        self.assertEqual('new\ncontent\n', b_tree.get_file_text('a-id'))
-
-        # We should still be using the content from A in C, not from B
-        c_tree = repo.revision_tree('C-id')
-        self.assertTreeShape([(u'', 'a-root-id', 'directory'),
-                              (u'a', 'a-id', 'file'),
-                              (u'c', 'c-id', 'file'),
-                             ], c_tree)
-        self.assertEqual('contents', c_tree.get_file_text('a-id'))
-        self.assertEqual('alt\ncontent\n', c_tree.get_file_text('c-id'))
-
-    def test_set_merge_parent(self):
-        builder = self.build_a_rev()
-        builder.start_series()
-        self.addCleanup(builder.finish_series)
-        builder.build_snapshot('B-id', ['A-id'],
-            [('add', ('b', 'b-id', 'file', 'b\ncontent\n'))])
-        builder.build_snapshot('C-id', ['A-id'],
-            [('add', ('c', 'c-id', 'file', 'alt\ncontent\n'))])
-        builder.build_snapshot('D-id', ['B-id', 'C-id'], [])
-        repo = builder.get_branch().repository
-        self.assertEqual({'B-id': ('A-id',), 'C-id': ('A-id',),
-                          'D-id': ('B-id', 'C-id')},
-                         repo.get_parent_map(['B-id', 'C-id', 'D-id']))
-        d_tree = repo.revision_tree('D-id')
-        # Note: by default a merge node does *not* pull in the changes from the
-        #       merged tree, you have to supply it yourself.
-        self.assertTreeShape([(u'', 'a-root-id', 'directory'),
-                              (u'a', 'a-id', 'file'),
-                              (u'b', 'b-id', 'file'),
-                             ], d_tree)
-
-    def test_set_merge_parent_and_contents(self):
-        builder = self.build_a_rev()
-        builder.start_series()
-        self.addCleanup(builder.finish_series)
-        builder.build_snapshot('B-id', ['A-id'],
-            [('add', ('b', 'b-id', 'file', 'b\ncontent\n'))])
-        builder.build_snapshot('C-id', ['A-id'],
-            [('add', ('c', 'c-id', 'file', 'alt\ncontent\n'))])
-        builder.build_snapshot('D-id', ['B-id', 'C-id'],
-            [('add', ('c', 'c-id', 'file', 'alt\ncontent\n'))])
-        repo = builder.get_branch().repository
-        self.assertEqual({'B-id': ('A-id',), 'C-id': ('A-id',),
-                          'D-id': ('B-id', 'C-id')},
-                         repo.get_parent_map(['B-id', 'C-id', 'D-id']))
-        d_tree = repo.revision_tree('D-id')
-        self.assertTreeShape([(u'', 'a-root-id', 'directory'),
-                              (u'a', 'a-id', 'file'),
-                              (u'b', 'b-id', 'file'),
-                              (u'c', 'c-id', 'file'),
-                             ], d_tree)
-        # Because we copied the exact text into *this* tree, the 'c' file
-        # should look like it was not modified in the merge
-        self.assertEqual('C-id', d_tree.inventory['c-id'].revision)
-
-    def test_start_finish_series(self):
-        builder = BranchBuilder(self.get_transport().clone('foo'))
-        builder.start_series()
-        try:
-            self.assertIsNot(None, builder._tree)
-            self.assertEqual('w', builder._tree._lock_mode)
-            self.assertTrue(builder._branch.is_locked())
-        finally:
-            builder.finish_series()
-        self.assertIs(None, builder._tree)
-        self.assertFalse(builder._branch.is_locked())

=== removed file 'bzrlib/tests/test_btree_index.py'
--- bzrlib/tests/test_btree_index.py	2008-08-28 20:13:31 +0000
+++ bzrlib/tests/test_btree_index.py	1970-01-01 00:00:00 +0000
@@ -1,998 +0,0 @@
-# Copyright (C) 2008 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-#
-
-"""Tests for btree indices."""
-
-import pprint
-import zlib
-
-from bzrlib import (
-    btree_index,
-    errors,
-    tests,
-    )
-from bzrlib.tests import (
-    TestCaseWithTransport,
-    TestScenarioApplier,
-    adapt_tests,
-    condition_isinstance,
-    split_suite_by_condition,
-    )
-from bzrlib.transport import get_transport
-
-
-def load_tests(standard_tests, module, loader):
-    # parameterise the TestBTreeNodes tests
-    node_tests, others = split_suite_by_condition(standard_tests,
-        condition_isinstance(TestBTreeNodes))
-    applier = TestScenarioApplier()
-    import bzrlib._btree_serializer_py as py_module
-    applier.scenarios = [('python', {'parse_btree': py_module})]
-    if CompiledBtreeParserFeature.available():
-        # Is there a way to do this that gets missing feature failures rather
-        # than no indication to the user?
-        import bzrlib._btree_serializer_c as c_module
-        applier.scenarios.append(('C', {'parse_btree': c_module}))
-    adapt_tests(node_tests, applier, others)
-    return others
-
-
-class _CompiledBtreeParserFeature(tests.Feature):
-    def _probe(self):
-        try:
-            import bzrlib._btree_serializer_c
-        except ImportError:
-            return False
-        return True
-
-    def feature_name(self):
-        return 'bzrlib._btree_serializer_c'
-
-CompiledBtreeParserFeature = _CompiledBtreeParserFeature()
-
-
-class BTreeTestCase(TestCaseWithTransport):
-    # test names here are suffixed by the key length and reference list count
-    # that they test.
-
-    def setUp(self):
-        TestCaseWithTransport.setUp(self)
-        self._original_header = btree_index._RESERVED_HEADER_BYTES
-        def restore():
-            btree_index._RESERVED_HEADER_BYTES = self._original_header
-        self.addCleanup(restore)
-        btree_index._RESERVED_HEADER_BYTES = 100
-
-    def make_nodes(self, count, key_elements, reference_lists):
-        """Generate count*key_elements sample nodes."""
-        keys = []
-        for prefix_pos in range(key_elements):
-            if key_elements - 1:
-                prefix = (str(prefix_pos) * 40,)
-            else:
-                prefix = ()
-            for pos in xrange(count):
-                # TODO: This creates odd keys. When count == 100,000, it
-                #       creates a 240 byte key
-                key = prefix + (str(pos) * 40,)
-                value = "value:%s" % pos
-                if reference_lists:
-                    # generate some references
-                    refs = []
-                    for list_pos in range(reference_lists):
-                        # as many keys in each list as its index + the key depth
-                        # mod 2 - this generates both 0 length lists and
-                        # ones slightly longer than the number of lists.
-                        # It also ensures we have non homogeneous lists.
-                        refs.append([])
-                        for ref_pos in range(list_pos + pos % 2):
-                            if pos % 2:
-                                # refer to a nearby key
-                                refs[-1].append(prefix + ("ref" + str(pos - 1) * 40,))
-                            else:
-                                # serial of this ref in the ref list
-                                refs[-1].append(prefix + ("ref" + str(ref_pos) * 40,))
-                        refs[-1] = tuple(refs[-1])
-                    refs = tuple(refs)
-                else:
-                    refs = ()
-                keys.append((key, value, refs))
-        return keys
-
-    def shrink_page_size(self):
-        """Shrink the default page size so that less fits in a page."""
-        old_page_size = btree_index._PAGE_SIZE
-        def cleanup():
-            btree_index._PAGE_SIZE = old_page_size
-        self.addCleanup(cleanup)
-        btree_index._PAGE_SIZE = 2048
-
-
-class TestBTreeBuilder(BTreeTestCase):
-
-    def test_empty_1_0(self):
-        builder = btree_index.BTreeBuilder(key_elements=1, reference_lists=0)
-        # NamedTemporaryFile dies on builder.finish().read(). weird.
-        temp_file = builder.finish()
-        content = temp_file.read()
-        del temp_file
-        self.assertEqual(
-            "B+Tree Graph Index 2\nnode_ref_lists=0\nkey_elements=1\nlen=0\n"
-            "row_lengths=\n",
-            content)
-
-    def test_empty_2_1(self):
-        builder = btree_index.BTreeBuilder(key_elements=2, reference_lists=1)
-        # NamedTemporaryFile dies on builder.finish().read(). weird.
-        temp_file = builder.finish()
-        content = temp_file.read()
-        del temp_file
-        self.assertEqual(
-            "B+Tree Graph Index 2\nnode_ref_lists=1\nkey_elements=2\nlen=0\n"
-            "row_lengths=\n",
-            content)
-
-    def test_root_leaf_1_0(self):
-        builder = btree_index.BTreeBuilder(key_elements=1, reference_lists=0)
-        nodes = self.make_nodes(5, 1, 0)
-        for node in nodes:
-            builder.add_node(*node)
-        # NamedTemporaryFile dies on builder.finish().read(). weird.
-        temp_file = builder.finish()
-        content = temp_file.read()
-        del temp_file
-        self.assertEqual(158, len(content))
-        self.assertEqual(
-            "B+Tree Graph Index 2\nnode_ref_lists=0\nkey_elements=1\nlen=5\n"
-            "row_lengths=1\n",
-            content[:73])
-        node_content = content[73:]
-        node_bytes = zlib.decompress(node_content)
-        expected_node = ("type=leaf\n"
-            "0000000000000000000000000000000000000000\x00\x00value:0\n"
-            "1111111111111111111111111111111111111111\x00\x00value:1\n"
-            "2222222222222222222222222222222222222222\x00\x00value:2\n"
-            "3333333333333333333333333333333333333333\x00\x00value:3\n"
-            "4444444444444444444444444444444444444444\x00\x00value:4\n")
-        self.assertEqual(expected_node, node_bytes)
-
-    def test_root_leaf_2_2(self):
-        builder = btree_index.BTreeBuilder(key_elements=2, reference_lists=2)
-        nodes = self.make_nodes(5, 2, 2)
-        for node in nodes:
-            builder.add_node(*node)
-        # NamedTemporaryFile dies on builder.finish().read(). weird.
-        temp_file = builder.finish()
-        content = temp_file.read()
-        del temp_file
-        self.assertEqual(264, len(content))
-        self.assertEqual(
-            "B+Tree Graph Index 2\nnode_ref_lists=2\nkey_elements=2\nlen=10\n"
-            "row_lengths=1\n",
-            content[:74])
-        node_content = content[74:]
-        node_bytes = zlib.decompress(node_content)
-        expected_node = (
-            "type=leaf\n"
-            "0000000000000000000000000000000000000000\x000000000000000000000000000000000000000000\x00\t0000000000000000000000000000000000000000\x00ref0000000000000000000000000000000000000000\x00value:0\n"
-            "0000000000000000000000000000000000000000\x001111111111111111111111111111111111111111\x000000000000000000000000000000000000000000\x00ref0000000000000000000000000000000000000000\t0000000000000000000000000000000000000000\x00ref0000000000000000000000000000000000000000\r0000000000000000000000000000000000000000\x00ref0000000000000000000000000000000000000000\x00value:1\n"
-            "0000000000000000000000000000000000000000\x002222222222222222222222222222222222222222\x00\t0000000000000000000000000000000000000000\x00ref0000000000000000000000000000000000000000\x00value:2\n"
-            "0000000000000000000000000000000000000000\x003333333333333333333333333333333333333333\x000000000000000000000000000000000000000000\x00ref2222222222222222222222222222222222222222\t0000000000000000000000000000000000000000\x00ref2222222222222222222222222222222222222222\r0000000000000000000000000000000000000000\x00ref2222222222222222222222222222222222222222\x00value:3\n"
-            "0000000000000000000000000000000000000000\x004444444444444444444444444444444444444444\x00\t0000000000000000000000000000000000000000\x00ref0000000000000000000000000000000000000000\x00value:4\n"
-            "1111111111111111111111111111111111111111\x000000000000000000000000000000000000000000\x00\t1111111111111111111111111111111111111111\x00ref0000000000000000000000000000000000000000\x00value:0\n"
-            "1111111111111111111111111111111111111111\x001111111111111111111111111111111111111111\x001111111111111111111111111111111111111111\x00ref0000000000000000000000000000000000000000\t1111111111111111111111111111111111111111\x00ref0000000000000000000000000000000000000000\r1111111111111111111111111111111111111111\x00ref0000000000000000000000000000000000000000\x00value:1\n"
-            "1111111111111111111111111111111111111111\x002222222222222222222222222222222222222222\x00\t1111111111111111111111111111111111111111\x00ref0000000000000000000000000000000000000000\x00value:2\n"
-            "1111111111111111111111111111111111111111\x003333333333333333333333333333333333333333\x001111111111111111111111111111111111111111\x00ref2222222222222222222222222222222222222222\t1111111111111111111111111111111111111111\x00ref2222222222222222222222222222222222222222\r1111111111111111111111111111111111111111\x00ref2222222222222222222222222222222222222222\x00value:3\n"
-            "1111111111111111111111111111111111111111\x004444444444444444444444444444444444444444\x00\t1111111111111111111111111111111111111111\x00ref0000000000000000000000000000000000000000\x00value:4\n"
-            ""
-            )
-        self.assertEqual(expected_node, node_bytes)
-
-    def test_2_leaves_1_0(self):
-        builder = btree_index.BTreeBuilder(key_elements=1, reference_lists=0)
-        nodes = self.make_nodes(400, 1, 0)
-        for node in nodes:
-            builder.add_node(*node)
-        # NamedTemporaryFile dies on builder.finish().read(). weird.
-        temp_file = builder.finish()
-        content = temp_file.read()
-        del temp_file
-        self.assertEqual(9283, len(content))
-        self.assertEqual(
-            "B+Tree Graph Index 2\nnode_ref_lists=0\nkey_elements=1\nlen=400\n"
-            "row_lengths=1,2\n",
-            content[:77])
-        root = content[77:4096]
-        leaf1 = content[4096:8192]
-        leaf2 = content[8192:]
-        root_bytes = zlib.decompress(root)
-        expected_root = (
-            "type=internal\n"
-            "offset=0\n"
-            ) + ("307" * 40) + "\n"
-        self.assertEqual(expected_root, root_bytes)
-        # We already know serialisation works for leaves, check key selection:
-        leaf1_bytes = zlib.decompress(leaf1)
-        sorted_node_keys = sorted(node[0] for node in nodes)
-        node = btree_index._LeafNode(leaf1_bytes, 1, 0)
-        self.assertEqual(231, len(node.keys))
-        self.assertEqual(sorted_node_keys[:231], sorted(node.keys))
-        leaf2_bytes = zlib.decompress(leaf2)
-        node = btree_index._LeafNode(leaf2_bytes, 1, 0)
-        self.assertEqual(400 - 231, len(node.keys))
-        self.assertEqual(sorted_node_keys[231:], sorted(node.keys))
-
-    def test_last_page_rounded_1_layer(self):
-        builder = btree_index.BTreeBuilder(key_elements=1, reference_lists=0)
-        nodes = self.make_nodes(10, 1, 0)
-        for node in nodes:
-            builder.add_node(*node)
-        # NamedTemporaryFile dies on builder.finish().read(). weird.
-        temp_file = builder.finish()
-        content = temp_file.read()
-        del temp_file
-        self.assertEqual(181, len(content))
-        self.assertEqual(
-            "B+Tree Graph Index 2\nnode_ref_lists=0\nkey_elements=1\nlen=10\n"
-            "row_lengths=1\n",
-            content[:74])
-        # Check thelast page is well formed
-        leaf2 = content[74:]
-        leaf2_bytes = zlib.decompress(leaf2)
-        node = btree_index._LeafNode(leaf2_bytes, 1, 0)
-        self.assertEqual(10, len(node.keys))
-        sorted_node_keys = sorted(node[0] for node in nodes)
-        self.assertEqual(sorted_node_keys, sorted(node.keys))
-
-    def test_last_page_not_rounded_2_layer(self):
-        builder = btree_index.BTreeBuilder(key_elements=1, reference_lists=0)
-        nodes = self.make_nodes(400, 1, 0)
-        for node in nodes:
-            builder.add_node(*node)
-        # NamedTemporaryFile dies on builder.finish().read(). weird.
-        temp_file = builder.finish()
-        content = temp_file.read()
-        del temp_file
-        self.assertEqual(9283, len(content))
-        self.assertEqual(
-            "B+Tree Graph Index 2\nnode_ref_lists=0\nkey_elements=1\nlen=400\n"
-            "row_lengths=1,2\n",
-            content[:77])
-        # Check the last page is well formed
-        leaf2 = content[8192:]
-        leaf2_bytes = zlib.decompress(leaf2)
-        node = btree_index._LeafNode(leaf2_bytes, 1, 0)
-        self.assertEqual(400 - 231, len(node.keys))
-        sorted_node_keys = sorted(node[0] for node in nodes)
-        self.assertEqual(sorted_node_keys[231:], sorted(node.keys))
-
-    def test_three_level_tree_details(self):
-        # The left most pointer in the second internal node in a row should
-        # pointer to the second node that the internal node is for, _not_
-        # the first, otherwise the first node overlaps with the last node of
-        # the prior internal node on that row.
-        self.shrink_page_size()
-        builder = btree_index.BTreeBuilder(key_elements=2, reference_lists=2)
-        # 40K nodes is enough to create a two internal nodes on the second
-        # level, with a 2K page size
-        nodes = self.make_nodes(20000, 2, 2)
-
-        for node in nodes:
-            builder.add_node(*node)
-        transport = get_transport('trace+' + self.get_url(''))
-        size = transport.put_file('index', self.time(builder.finish))
-        del builder
-        index = btree_index.BTreeGraphIndex(transport, 'index', size)
-        # Seed the metadata, we're using internal calls now.
-        index.key_count()
-        self.assertEqual(3, len(index._row_lengths),
-            "Not enough rows: %r" % index._row_lengths)
-        self.assertEqual(4, len(index._row_offsets))
-        self.assertEqual(sum(index._row_lengths), index._row_offsets[-1])
-        internal_nodes = index._get_internal_nodes([0, 1, 2])
-        root_node = internal_nodes[0]
-        internal_node1 = internal_nodes[1]
-        internal_node2 = internal_nodes[2]
-        # The left most node node2 points at should be one after the right most
-        # node pointed at by node1.
-        self.assertEqual(internal_node2.offset, 1 + len(internal_node1.keys))
-        # The left most key of the second node pointed at by internal_node2
-        # should be its first key. We can check this by looking for its first key
-        # in the second node it points at
-        pos = index._row_offsets[2] + internal_node2.offset + 1
-        leaf = index._get_leaf_nodes([pos])[pos]
-        self.assertTrue(internal_node2.keys[0] in leaf.keys)
-
-    def test_2_leaves_2_2(self):
-        builder = btree_index.BTreeBuilder(key_elements=2, reference_lists=2)
-        nodes = self.make_nodes(100, 2, 2)
-        for node in nodes:
-            builder.add_node(*node)
-        # NamedTemporaryFile dies on builder.finish().read(). weird.
-        temp_file = builder.finish()
-        content = temp_file.read()
-        del temp_file
-        self.assertEqual(12643, len(content))
-        self.assertEqual(
-            "B+Tree Graph Index 2\nnode_ref_lists=2\nkey_elements=2\nlen=200\n"
-            "row_lengths=1,3\n",
-            content[:77])
-        root = content[77:4096]
-        leaf1 = content[4096:8192]
-        leaf2 = content[8192:12288]
-        leaf3 = content[12288:]
-        root_bytes = zlib.decompress(root)
-        expected_root = (
-            "type=internal\n"
-            "offset=0\n"
-            + ("0" * 40) + "\x00" + ("91" * 40) + "\n"
-            + ("1" * 40) + "\x00" + ("81" * 40) + "\n"
-            )
-        self.assertEqual(expected_root, root_bytes)
-        # We assume the other leaf nodes have been written correctly - layering
-        # FTW.
-
-    def test_spill_index_stress_1_1(self):
-        builder = btree_index.BTreeBuilder(key_elements=1, spill_at=2)
-        nodes = [node[0:2] for node in self.make_nodes(16, 1, 0)]
-        builder.add_node(*nodes[0])
-        # Test the parts of the index that take up memory are doing so
-        # predictably.
-        self.assertEqual(1, len(builder._nodes))
-        self.assertEqual(1, len(builder._keys))
-        self.assertIs(None, builder._nodes_by_key)
-        builder.add_node(*nodes[1])
-        self.assertEqual(0, len(builder._nodes))
-        self.assertEqual(0, len(builder._keys))
-        self.assertIs(None, builder._nodes_by_key)
-        self.assertEqual(1, len(builder._backing_indices))
-        self.assertEqual(2, builder._backing_indices[0].key_count())
-        # now back to memory
-        builder.add_node(*nodes[2])
-        self.assertEqual(1, len(builder._nodes))
-        self.assertEqual(1, len(builder._keys))
-        self.assertIs(None, builder._nodes_by_key)
-        # And spills to a second backing index combing all
-        builder.add_node(*nodes[3])
-        self.assertEqual(0, len(builder._nodes))
-        self.assertEqual(0, len(builder._keys))
-        self.assertIs(None, builder._nodes_by_key)
-        self.assertEqual(2, len(builder._backing_indices))
-        self.assertEqual(None, builder._backing_indices[0])
-        self.assertEqual(4, builder._backing_indices[1].key_count())
-        # The next spills to the 2-len slot
-        builder.add_node(*nodes[4])
-        builder.add_node(*nodes[5])
-        self.assertEqual(0, len(builder._nodes))
-        self.assertEqual(0, len(builder._keys))
-        self.assertIs(None, builder._nodes_by_key)
-        self.assertEqual(2, len(builder._backing_indices))
-        self.assertEqual(2, builder._backing_indices[0].key_count())
-        self.assertEqual(4, builder._backing_indices[1].key_count())
-        # Next spill combines
-        builder.add_node(*nodes[6])
-        builder.add_node(*nodes[7])
-        self.assertEqual(3, len(builder._backing_indices))
-        self.assertEqual(None, builder._backing_indices[0])
-        self.assertEqual(None, builder._backing_indices[1])
-        self.assertEqual(8, builder._backing_indices[2].key_count())
-        # And so forth - counting up in binary.
-        builder.add_node(*nodes[8])
-        builder.add_node(*nodes[9])
-        self.assertEqual(3, len(builder._backing_indices))
-        self.assertEqual(2, builder._backing_indices[0].key_count())
-        self.assertEqual(None, builder._backing_indices[1])
-        self.assertEqual(8, builder._backing_indices[2].key_count())
-        builder.add_node(*nodes[10])
-        builder.add_node(*nodes[11])
-        self.assertEqual(3, len(builder._backing_indices))
-        self.assertEqual(None, builder._backing_indices[0])
-        self.assertEqual(4, builder._backing_indices[1].key_count())
-        self.assertEqual(8, builder._backing_indices[2].key_count())
-        builder.add_node(*nodes[12])
-        # Test that memory and disk are both used for query methods; and that
-        # None is skipped over happily.
-        self.assertEqual([(builder,) + node for node in sorted(nodes[:13])],
-            list(builder.iter_all_entries()))
-        # Two nodes - one memory one disk
-        self.assertEqual(set([(builder,) + node for node in nodes[11:13]]),
-            set(builder.iter_entries([nodes[12][0], nodes[11][0]])))
-        self.assertEqual(13, builder.key_count())
-        self.assertEqual(set([(builder,) + node for node in nodes[11:13]]),
-            set(builder.iter_entries_prefix([nodes[12][0], nodes[11][0]])))
-        builder.add_node(*nodes[13])
-        self.assertEqual(3, len(builder._backing_indices))
-        self.assertEqual(2, builder._backing_indices[0].key_count())
-        self.assertEqual(4, builder._backing_indices[1].key_count())
-        self.assertEqual(8, builder._backing_indices[2].key_count())
-        builder.add_node(*nodes[14])
-        builder.add_node(*nodes[15])
-        self.assertEqual(4, len(builder._backing_indices))
-        self.assertEqual(None, builder._backing_indices[0])
-        self.assertEqual(None, builder._backing_indices[1])
-        self.assertEqual(None, builder._backing_indices[2])
-        self.assertEqual(16, builder._backing_indices[3].key_count())
-        # Now finish, and check we got a correctly ordered tree
-        transport = self.get_transport('')
-        size = transport.put_file('index', builder.finish())
-        index = btree_index.BTreeGraphIndex(transport, 'index', size)
-        nodes = list(index.iter_all_entries())
-        self.assertEqual(sorted(nodes), nodes)
-        self.assertEqual(16, len(nodes))
-
-    def test_spill_index_stress_2_2(self):
-        # test that references and longer keys don't confuse things.
-        builder = btree_index.BTreeBuilder(key_elements=2, reference_lists=2,
-            spill_at=2)
-        nodes = self.make_nodes(16, 2, 2)
-        builder.add_node(*nodes[0])
-        # Test the parts of the index that take up memory are doing so
-        # predictably.
-        self.assertEqual(1, len(builder._keys))
-        self.assertEqual(1, len(builder._nodes))
-        self.assertIs(None, builder._nodes_by_key)
-        builder.add_node(*nodes[1])
-        self.assertEqual(0, len(builder._keys))
-        self.assertEqual(0, len(builder._nodes))
-        self.assertIs(None, builder._nodes_by_key)
-        self.assertEqual(1, len(builder._backing_indices))
-        self.assertEqual(2, builder._backing_indices[0].key_count())
-        # now back to memory
-        old = dict(builder._get_nodes_by_key()) #Build up the nodes by key dict
-        builder.add_node(*nodes[2])
-        self.assertEqual(1, len(builder._nodes))
-        self.assertEqual(1, len(builder._keys))
-        self.assertIsNot(None, builder._nodes_by_key)
-        self.assertNotEqual({}, builder._nodes_by_key)
-        # We should have a new entry
-        self.assertNotEqual(old, builder._nodes_by_key)
-        # And spills to a second backing index combing all
-        builder.add_node(*nodes[3])
-        self.assertEqual(0, len(builder._nodes))
-        self.assertEqual(0, len(builder._keys))
-        self.assertIs(None, builder._nodes_by_key)
-        self.assertEqual(2, len(builder._backing_indices))
-        self.assertEqual(None, builder._backing_indices[0])
-        self.assertEqual(4, builder._backing_indices[1].key_count())
-        # The next spills to the 2-len slot
-        builder.add_node(*nodes[4])
-        builder.add_node(*nodes[5])
-        self.assertEqual(0, len(builder._nodes))
-        self.assertEqual(0, len(builder._keys))
-        self.assertIs(None, builder._nodes_by_key)
-        self.assertEqual(2, len(builder._backing_indices))
-        self.assertEqual(2, builder._backing_indices[0].key_count())
-        self.assertEqual(4, builder._backing_indices[1].key_count())
-        # Next spill combines
-        builder.add_node(*nodes[6])
-        builder.add_node(*nodes[7])
-        self.assertEqual(3, len(builder._backing_indices))
-        self.assertEqual(None, builder._backing_indices[0])
-        self.assertEqual(None, builder._backing_indices[1])
-        self.assertEqual(8, builder._backing_indices[2].key_count())
-        # And so forth - counting up in binary.
-        builder.add_node(*nodes[8])
-        builder.add_node(*nodes[9])
-        self.assertEqual(3, len(builder._backing_indices))
-        self.assertEqual(2, builder._backing_indices[0].key_count())
-        self.assertEqual(None, builder._backing_indices[1])
-        self.assertEqual(8, builder._backing_indices[2].key_count())
-        builder.add_node(*nodes[10])
-        builder.add_node(*nodes[11])
-        self.assertEqual(3, len(builder._backing_indices))
-        self.assertEqual(None, builder._backing_indices[0])
-        self.assertEqual(4, builder._backing_indices[1].key_count())
-        self.assertEqual(8, builder._backing_indices[2].key_count())
-        builder.add_node(*nodes[12])
-        # Test that memory and disk are both used for query methods; and that
-        # None is skipped over happily.
-        self.assertEqual([(builder,) + node for node in sorted(nodes[:13])],
-            list(builder.iter_all_entries()))
-        # Two nodes - one memory one disk
-        self.assertEqual(set([(builder,) + node for node in nodes[11:13]]),
-            set(builder.iter_entries([nodes[12][0], nodes[11][0]])))
-        self.assertEqual(13, builder.key_count())
-        self.assertEqual(set([(builder,) + node for node in nodes[11:13]]),
-            set(builder.iter_entries_prefix([nodes[12][0], nodes[11][0]])))
-        builder.add_node(*nodes[13])
-        self.assertEqual(3, len(builder._backing_indices))
-        self.assertEqual(2, builder._backing_indices[0].key_count())
-        self.assertEqual(4, builder._backing_indices[1].key_count())
-        self.assertEqual(8, builder._backing_indices[2].key_count())
-        builder.add_node(*nodes[14])
-        builder.add_node(*nodes[15])
-        self.assertEqual(4, len(builder._backing_indices))
-        self.assertEqual(None, builder._backing_indices[0])
-        self.assertEqual(None, builder._backing_indices[1])
-        self.assertEqual(None, builder._backing_indices[2])
-        self.assertEqual(16, builder._backing_indices[3].key_count())
-        # Now finish, and check we got a correctly ordered tree
-        transport = self.get_transport('')
-        size = transport.put_file('index', builder.finish())
-        index = btree_index.BTreeGraphIndex(transport, 'index', size)
-        nodes = list(index.iter_all_entries())
-        self.assertEqual(sorted(nodes), nodes)
-        self.assertEqual(16, len(nodes))
-
-    def test_spill_index_duplicate_key_caught_on_finish(self):
-        builder = btree_index.BTreeBuilder(key_elements=1, spill_at=2)
-        nodes = [node[0:2] for node in self.make_nodes(16, 1, 0)]
-        builder.add_node(*nodes[0])
-        builder.add_node(*nodes[1])
-        builder.add_node(*nodes[0])
-        self.assertRaises(errors.BadIndexDuplicateKey, builder.finish)
-
-
-class TestBTreeIndex(BTreeTestCase):
-
-    def make_index(self, ref_lists=0, key_elements=1, nodes=[]):
-        builder = btree_index.BTreeBuilder(reference_lists=ref_lists,
-            key_elements=key_elements)
-        for key, value, references in nodes:
-            builder.add_node(key, value, references)
-        stream = builder.finish()
-        trans = get_transport('trace+' + self.get_url())
-        size = trans.put_file('index', stream)
-        return btree_index.BTreeGraphIndex(trans, 'index', size)
-
-    def test_trivial_constructor(self):
-        transport = get_transport('trace+' + self.get_url(''))
-        index = btree_index.BTreeGraphIndex(transport, 'index', None)
-        # Checks the page size at load, but that isn't logged yet.
-        self.assertEqual([], transport._activity)
-
-    def test_with_size_constructor(self):
-        transport = get_transport('trace+' + self.get_url(''))
-        index = btree_index.BTreeGraphIndex(transport, 'index', 1)
-        # Checks the page size at load, but that isn't logged yet.
-        self.assertEqual([], transport._activity)
-
-    def test_empty_key_count_no_size(self):
-        builder = btree_index.BTreeBuilder(key_elements=1, reference_lists=0)
-        transport = get_transport('trace+' + self.get_url(''))
-        transport.put_file('index', builder.finish())
-        index = btree_index.BTreeGraphIndex(transport, 'index', None)
-        del transport._activity[:]
-        self.assertEqual([], transport._activity)
-        self.assertEqual(0, index.key_count())
-        # The entire index should have been requested (as we generally have the
-        # size available, and doing many small readvs is inappropriate).
-        # We can't tell how much was actually read here, but - check the code.
-        self.assertEqual([('get', 'index'),
-            ('readv', 'index', [(0, 72)], False, None)],
-            transport._activity)
-
-    def test_empty_key_count(self):
-        builder = btree_index.BTreeBuilder(key_elements=1, reference_lists=0)
-        transport = get_transport('trace+' + self.get_url(''))
-        size = transport.put_file('index', builder.finish())
-        self.assertEqual(72, size)
-        index = btree_index.BTreeGraphIndex(transport, 'index', size)
-        del transport._activity[:]
-        self.assertEqual([], transport._activity)
-        self.assertEqual(0, index.key_count())
-        # The entire index should have been read, as 4K > size
-        self.assertEqual([('readv', 'index', [(0, 72)], False, None)],
-            transport._activity)
-
-    def test_non_empty_key_count_2_2(self):
-        builder = btree_index.BTreeBuilder(key_elements=2, reference_lists=2)
-        nodes = self.make_nodes(35, 2, 2)
-        for node in nodes:
-            builder.add_node(*node)
-        transport = get_transport('trace+' + self.get_url(''))
-        size = transport.put_file('index', builder.finish())
-        index = btree_index.BTreeGraphIndex(transport, 'index', size)
-        del transport._activity[:]
-        self.assertEqual([], transport._activity)
-        self.assertEqual(70, index.key_count())
-        # The entire index should have been read, as it is one page long.
-        self.assertEqual([('readv', 'index', [(0, size)], False, None)],
-            transport._activity)
-        self.assertEqual(1199, size)
-
-    def test_2_levels_key_count_2_2(self):
-        builder = btree_index.BTreeBuilder(key_elements=2, reference_lists=2)
-        nodes = self.make_nodes(160, 2, 2)
-        for node in nodes:
-            builder.add_node(*node)
-        transport = get_transport('trace+' + self.get_url(''))
-        size = transport.put_file('index', builder.finish())
-        self.assertEqual(17692, size)
-        index = btree_index.BTreeGraphIndex(transport, 'index', size)
-        del transport._activity[:]
-        self.assertEqual([], transport._activity)
-        self.assertEqual(320, index.key_count())
-        # The entire index should not have been read.
-        self.assertEqual([('readv', 'index', [(0, 4096)], False, None)],
-            transport._activity)
-
-    def test_validate_one_page(self):
-        builder = btree_index.BTreeBuilder(key_elements=2, reference_lists=2)
-        nodes = self.make_nodes(45, 2, 2)
-        for node in nodes:
-            builder.add_node(*node)
-        transport = get_transport('trace+' + self.get_url(''))
-        size = transport.put_file('index', builder.finish())
-        index = btree_index.BTreeGraphIndex(transport, 'index', size)
-        del transport._activity[:]
-        self.assertEqual([], transport._activity)
-        index.validate()
-        # The entire index should have been read linearly.
-        self.assertEqual([('readv', 'index', [(0, size)], False, None)],
-            transport._activity)
-        self.assertEqual(1514, size)
-
-    def test_validate_two_pages(self):
-        builder = btree_index.BTreeBuilder(key_elements=2, reference_lists=2)
-        nodes = self.make_nodes(80, 2, 2)
-        for node in nodes:
-            builder.add_node(*node)
-        transport = get_transport('trace+' + self.get_url(''))
-        size = transport.put_file('index', builder.finish())
-        # Root page, 2 leaf pages
-        self.assertEqual(9339, size)
-        index = btree_index.BTreeGraphIndex(transport, 'index', size)
-        del transport._activity[:]
-        self.assertEqual([], transport._activity)
-        index.validate()
-        # The entire index should have been read linearly.
-        self.assertEqual([('readv', 'index', [(0, 4096)], False, None),
-            ('readv', 'index', [(4096, 4096), (8192, 1147)], False, None)],
-            transport._activity)
-        # XXX: TODO: write some badly-ordered nodes, and some pointers-to-wrong
-        # node and make validate find them.
-
-    def test_eq_ne(self):
-        # two indices are equal when constructed with the same parameters:
-        transport1 = get_transport('trace+' + self.get_url(''))
-        transport2 = get_transport(self.get_url(''))
-        self.assertTrue(
-            btree_index.BTreeGraphIndex(transport1, 'index', None) ==
-            btree_index.BTreeGraphIndex(transport1, 'index', None))
-        self.assertTrue(
-            btree_index.BTreeGraphIndex(transport1, 'index', 20) ==
-            btree_index.BTreeGraphIndex(transport1, 'index', 20))
-        self.assertFalse(
-            btree_index.BTreeGraphIndex(transport1, 'index', 20) ==
-            btree_index.BTreeGraphIndex(transport2, 'index', 20))
-        self.assertFalse(
-            btree_index.BTreeGraphIndex(transport1, 'inde1', 20) ==
-            btree_index.BTreeGraphIndex(transport1, 'inde2', 20))
-        self.assertFalse(
-            btree_index.BTreeGraphIndex(transport1, 'index', 10) ==
-            btree_index.BTreeGraphIndex(transport1, 'index', 20))
-        self.assertFalse(
-            btree_index.BTreeGraphIndex(transport1, 'index', None) !=
-            btree_index.BTreeGraphIndex(transport1, 'index', None))
-        self.assertFalse(
-            btree_index.BTreeGraphIndex(transport1, 'index', 20) !=
-            btree_index.BTreeGraphIndex(transport1, 'index', 20))
-        self.assertTrue(
-            btree_index.BTreeGraphIndex(transport1, 'index', 20) !=
-            btree_index.BTreeGraphIndex(transport2, 'index', 20))
-        self.assertTrue(
-            btree_index.BTreeGraphIndex(transport1, 'inde1', 20) !=
-            btree_index.BTreeGraphIndex(transport1, 'inde2', 20))
-        self.assertTrue(
-            btree_index.BTreeGraphIndex(transport1, 'index', 10) !=
-            btree_index.BTreeGraphIndex(transport1, 'index', 20))
-
-    def test_iter_all_entries_reads(self):
-        # iterating all entries reads the header, then does a linear
-        # read.
-        self.shrink_page_size()
-        builder = btree_index.BTreeBuilder(key_elements=2, reference_lists=2)
-        # 20k nodes is enough to create a two internal nodes on the second
-        # level, with a 2K page size
-        nodes = self.make_nodes(10000, 2, 2)
-        for node in nodes:
-            builder.add_node(*node)
-        transport = get_transport('trace+' + self.get_url(''))
-        size = transport.put_file('index', builder.finish())
-        self.assertEqual(1303220, size, 'number of expected bytes in the'
-                                        ' output changed')
-        page_size = btree_index._PAGE_SIZE
-        del builder
-        index = btree_index.BTreeGraphIndex(transport, 'index', size)
-        del transport._activity[:]
-        self.assertEqual([], transport._activity)
-        found_nodes = self.time(list, index.iter_all_entries())
-        bare_nodes = []
-        for node in found_nodes:
-            self.assertTrue(node[0] is index)
-            bare_nodes.append(node[1:])
-        self.assertEqual(3, len(index._row_lengths),
-            "Not enough rows: %r" % index._row_lengths)
-        # Should be as long as the nodes we supplied
-        self.assertEqual(20000, len(found_nodes))
-        # Should have the same content
-        self.assertEqual(set(nodes), set(bare_nodes))
-        # Should have done linear scan IO up the index, ignoring
-        # the internal nodes:
-        # The entire index should have been read
-        total_pages = sum(index._row_lengths)
-        self.assertEqual(total_pages, index._row_offsets[-1])
-        self.assertEqual(1303220, size)
-        # The start of the leaves
-        first_byte = index._row_offsets[-2] * page_size
-        readv_request = []
-        for offset in range(first_byte, size, page_size):
-            readv_request.append((offset, page_size))
-        # The last page is truncated
-        readv_request[-1] = (readv_request[-1][0], 1303220 % page_size)
-        expected = [('readv', 'index', [(0, page_size)], False, None),
-             ('readv',  'index', readv_request, False, None)]
-        if expected != transport._activity:
-            self.assertEqualDiff(pprint.pformat(expected),
-                                 pprint.pformat(transport._activity))
-
-    def _test_iter_entries_references_resolved(self):
-        index = self.make_index(1, nodes=[
-            (('name', ), 'data', ([('ref', ), ('ref', )], )),
-            (('ref', ), 'refdata', ([], ))])
-        self.assertEqual(set([(index, ('name', ), 'data', ((('ref',),('ref',)),)),
-            (index, ('ref', ), 'refdata', ((), ))]),
-            set(index.iter_entries([('name',), ('ref',)])))
-
-    def test_iter_entries_references_2_refs_resolved(self):
-        # iterating some entries reads just the pages needed. For now, to
-        # get it working and start measuring, only 4K pages are read.
-        builder = btree_index.BTreeBuilder(key_elements=2, reference_lists=2)
-        # 80 nodes is enough to create a two-level index.
-        nodes = self.make_nodes(160, 2, 2)
-        for node in nodes:
-            builder.add_node(*node)
-        transport = get_transport('trace+' + self.get_url(''))
-        size = transport.put_file('index', builder.finish())
-        del builder
-        index = btree_index.BTreeGraphIndex(transport, 'index', size)
-        del transport._activity[:]
-        self.assertEqual([], transport._activity)
-        # search for one key
-        found_nodes = list(index.iter_entries([nodes[30][0]]))
-        bare_nodes = []
-        for node in found_nodes:
-            self.assertTrue(node[0] is index)
-            bare_nodes.append(node[1:])
-        # Should be as long as the nodes we supplied
-        self.assertEqual(1, len(found_nodes))
-        # Should have the same content
-        self.assertEqual(nodes[30], bare_nodes[0])
-        # Should have read the root node, then one leaf page:
-        self.assertEqual([('readv', 'index', [(0, 4096)], False, None),
-             ('readv',  'index', [(8192, 4096), ], False, None)],
-            transport._activity)
-
-    def test_iter_key_prefix_1_element_key_None(self):
-        index = self.make_index()
-        self.assertRaises(errors.BadIndexKey, list,
-            index.iter_entries_prefix([(None, )]))
-
-    def test_iter_key_prefix_wrong_length(self):
-        index = self.make_index()
-        self.assertRaises(errors.BadIndexKey, list,
-            index.iter_entries_prefix([('foo', None)]))
-        index = self.make_index(key_elements=2)
-        self.assertRaises(errors.BadIndexKey, list,
-            index.iter_entries_prefix([('foo', )]))
-        self.assertRaises(errors.BadIndexKey, list,
-            index.iter_entries_prefix([('foo', None, None)]))
-
-    def test_iter_key_prefix_1_key_element_no_refs(self):
-        index = self.make_index( nodes=[
-            (('name', ), 'data', ()),
-            (('ref', ), 'refdata', ())])
-        self.assertEqual(set([(index, ('name', ), 'data'),
-            (index, ('ref', ), 'refdata')]),
-            set(index.iter_entries_prefix([('name', ), ('ref', )])))
-
-    def test_iter_key_prefix_1_key_element_refs(self):
-        index = self.make_index(1, nodes=[
-            (('name', ), 'data', ([('ref', )], )),
-            (('ref', ), 'refdata', ([], ))])
-        self.assertEqual(set([(index, ('name', ), 'data', ((('ref',),),)),
-            (index, ('ref', ), 'refdata', ((), ))]),
-            set(index.iter_entries_prefix([('name', ), ('ref', )])))
-
-    def test_iter_key_prefix_2_key_element_no_refs(self):
-        index = self.make_index(key_elements=2, nodes=[
-            (('name', 'fin1'), 'data', ()),
-            (('name', 'fin2'), 'beta', ()),
-            (('ref', 'erence'), 'refdata', ())])
-        self.assertEqual(set([(index, ('name', 'fin1'), 'data'),
-            (index, ('ref', 'erence'), 'refdata')]),
-            set(index.iter_entries_prefix([('name', 'fin1'), ('ref', 'erence')])))
-        self.assertEqual(set([(index, ('name', 'fin1'), 'data'),
-            (index, ('name', 'fin2'), 'beta')]),
-            set(index.iter_entries_prefix([('name', None)])))
-
-    def test_iter_key_prefix_2_key_element_refs(self):
-        index = self.make_index(1, key_elements=2, nodes=[
-            (('name', 'fin1'), 'data', ([('ref', 'erence')], )),
-            (('name', 'fin2'), 'beta', ([], )),
-            (('ref', 'erence'), 'refdata', ([], ))])
-        self.assertEqual(set([(index, ('name', 'fin1'), 'data', ((('ref', 'erence'),),)),
-            (index, ('ref', 'erence'), 'refdata', ((), ))]),
-            set(index.iter_entries_prefix([('name', 'fin1'), ('ref', 'erence')])))
-        self.assertEqual(set([(index, ('name', 'fin1'), 'data', ((('ref', 'erence'),),)),
-            (index, ('name', 'fin2'), 'beta', ((), ))]),
-            set(index.iter_entries_prefix([('name', None)])))
-
-
-class TestBTreeNodes(BTreeTestCase):
-
-    def restore_parser(self):
-        btree_index._btree_serializer = self.saved_parser
-
-    def setUp(self):
-        BTreeTestCase.setUp(self)
-        self.saved_parser = btree_index._btree_serializer
-        self.addCleanup(self.restore_parser)
-        btree_index._btree_serializer = self.parse_btree
-
-    def test_LeafNode_1_0(self):
-        node_bytes = ("type=leaf\n"
-            "0000000000000000000000000000000000000000\x00\x00value:0\n"
-            "1111111111111111111111111111111111111111\x00\x00value:1\n"
-            "2222222222222222222222222222222222222222\x00\x00value:2\n"
-            "3333333333333333333333333333333333333333\x00\x00value:3\n"
-            "4444444444444444444444444444444444444444\x00\x00value:4\n")
-        node = btree_index._LeafNode(node_bytes, 1, 0)
-        # We do direct access, or don't care about order, to leaf nodes most of
-        # the time, so a dict is useful:
-        self.assertEqual({
-            ("0000000000000000000000000000000000000000",): ("value:0", ()),
-            ("1111111111111111111111111111111111111111",): ("value:1", ()),
-            ("2222222222222222222222222222222222222222",): ("value:2", ()),
-            ("3333333333333333333333333333333333333333",): ("value:3", ()),
-            ("4444444444444444444444444444444444444444",): ("value:4", ()),
-            }, node.keys)
-
-    def test_LeafNode_2_2(self):
-        node_bytes = ("type=leaf\n"
-            "00\x0000\x00\t00\x00ref00\x00value:0\n"
-            "00\x0011\x0000\x00ref00\t00\x00ref00\r01\x00ref01\x00value:1\n"
-            "11\x0033\x0011\x00ref22\t11\x00ref22\r11\x00ref22\x00value:3\n"
-            "11\x0044\x00\t11\x00ref00\x00value:4\n"
-            ""
-            )
-        node = btree_index._LeafNode(node_bytes, 2, 2)
-        # We do direct access, or don't care about order, to leaf nodes most of
-        # the time, so a dict is useful:
-        self.assertEqual({
-            ('00', '00'): ('value:0', ((), (('00', 'ref00'),))),
-            ('00', '11'): ('value:1',
-                ((('00', 'ref00'),), (('00', 'ref00'), ('01', 'ref01')))),
-            ('11', '33'): ('value:3',
-                ((('11', 'ref22'),), (('11', 'ref22'), ('11', 'ref22')))),
-            ('11', '44'): ('value:4', ((), (('11', 'ref00'),)))
-            }, node.keys)
-
-    def test_InternalNode_1(self):
-        node_bytes = ("type=internal\n"
-            "offset=1\n"
-            "0000000000000000000000000000000000000000\n"
-            "1111111111111111111111111111111111111111\n"
-            "2222222222222222222222222222222222222222\n"
-            "3333333333333333333333333333333333333333\n"
-            "4444444444444444444444444444444444444444\n"
-            )
-        node = btree_index._InternalNode(node_bytes)
-        # We want to bisect to find the right children from this node, so a
-        # vector is most useful.
-        self.assertEqual([
-            ("0000000000000000000000000000000000000000",),
-            ("1111111111111111111111111111111111111111",),
-            ("2222222222222222222222222222222222222222",),
-            ("3333333333333333333333333333333333333333",),
-            ("4444444444444444444444444444444444444444",),
-            ], node.keys)
-        self.assertEqual(1, node.offset)
-
-    def test_LeafNode_2_2(self):
-        node_bytes = ("type=leaf\n"
-            "00\x0000\x00\t00\x00ref00\x00value:0\n"
-            "00\x0011\x0000\x00ref00\t00\x00ref00\r01\x00ref01\x00value:1\n"
-            "11\x0033\x0011\x00ref22\t11\x00ref22\r11\x00ref22\x00value:3\n"
-            "11\x0044\x00\t11\x00ref00\x00value:4\n"
-            ""
-            )
-        node = btree_index._LeafNode(node_bytes, 2, 2)
-        # We do direct access, or don't care about order, to leaf nodes most of
-        # the time, so a dict is useful:
-        self.assertEqual({
-            ('00', '00'): ('value:0', ((), (('00', 'ref00'),))),
-            ('00', '11'): ('value:1',
-                ((('00', 'ref00'),), (('00', 'ref00'), ('01', 'ref01')))),
-            ('11', '33'): ('value:3',
-                ((('11', 'ref22'),), (('11', 'ref22'), ('11', 'ref22')))),
-            ('11', '44'): ('value:4', ((), (('11', 'ref00'),)))
-            }, node.keys)
-
-    def assertFlattened(self, expected, key, value, refs):
-        flat_key, flat_line = self.parse_btree._flatten_node(
-            (None, key, value, refs), bool(refs))
-        self.assertEqual('\x00'.join(key), flat_key)
-        self.assertEqual(expected, flat_line)
-
-    def test__flatten_node(self):
-        self.assertFlattened('key\0\0value\n', ('key',), 'value', [])
-        self.assertFlattened('key\0tuple\0\0value str\n',
-                             ('key', 'tuple'), 'value str', [])
-        self.assertFlattened('key\0tuple\0triple\0\0value str\n',
-                             ('key', 'tuple', 'triple'), 'value str', [])
-        self.assertFlattened('k\0t\0s\0ref\0value str\n',
-                             ('k', 't', 's'), 'value str', [[('ref',)]])
-        self.assertFlattened('key\0tuple\0ref\0key\0value str\n',
-                             ('key', 'tuple'), 'value str', [[('ref', 'key')]])
-        self.assertFlattened("00\x0000\x00\t00\x00ref00\x00value:0\n",
-            ('00', '00'), 'value:0', ((), (('00', 'ref00'),)))
-        self.assertFlattened(
-            "00\x0011\x0000\x00ref00\t00\x00ref00\r01\x00ref01\x00value:1\n",
-            ('00', '11'), 'value:1',
-                ((('00', 'ref00'),), (('00', 'ref00'), ('01', 'ref01'))))
-        self.assertFlattened(
-            "11\x0033\x0011\x00ref22\t11\x00ref22\r11\x00ref22\x00value:3\n",
-            ('11', '33'), 'value:3',
-                ((('11', 'ref22'),), (('11', 'ref22'), ('11', 'ref22'))))
-        self.assertFlattened(
-            "11\x0044\x00\t11\x00ref00\x00value:4\n",
-            ('11', '44'), 'value:4', ((), (('11', 'ref00'),)))
-
-
-class TestCompiledBtree(tests.TestCase):
-
-    def test_exists(self):
-        # This is just to let the user know if they don't have the feature
-        # available
-        self.requireFeature(CompiledBtreeParserFeature)
-
-
-class TestMultiBisectRight(tests.TestCase):
-
-    def assertMultiBisectRight(self, offsets, search_keys, fixed_keys):
-        self.assertEqual(offsets,
-                         btree_index.BTreeGraphIndex._multi_bisect_right(
-                            search_keys, fixed_keys))
-
-    def test_after(self):
-        self.assertMultiBisectRight([(1, ['b'])], ['b'], ['a'])
-        self.assertMultiBisectRight([(3, ['e', 'f', 'g'])],
-                                    ['e', 'f', 'g'], ['a', 'b', 'c'])
-
-    def test_before(self):
-        self.assertMultiBisectRight([(0, ['a'])], ['a'], ['b'])
-        self.assertMultiBisectRight([(0, ['a', 'b', 'c', 'd'])],
-                                    ['a', 'b', 'c', 'd'], ['e', 'f', 'g'])
-
-    def test_exact(self):
-        self.assertMultiBisectRight([(1, ['a'])], ['a'], ['a'])
-        self.assertMultiBisectRight([(1, ['a']), (2, ['b'])], ['a', 'b'], ['a', 'b'])
-        self.assertMultiBisectRight([(1, ['a']), (3, ['c'])],
-                                    ['a', 'c'], ['a', 'b', 'c'])
-
-    def test_inbetween(self):
-        self.assertMultiBisectRight([(1, ['b'])], ['b'], ['a', 'c'])
-        self.assertMultiBisectRight([(1, ['b', 'c', 'd']), (2, ['f', 'g'])],
-                                    ['b', 'c', 'd', 'f', 'g'], ['a', 'e', 'h'])
-
-    def test_mixed(self):
-        self.assertMultiBisectRight([(0, ['a', 'b']), (2, ['d', 'e']),
-                                     (4, ['g', 'h'])],
-                                    ['a', 'b', 'd', 'e', 'g', 'h'],
-                                    ['c', 'd', 'f', 'g'])

=== modified file 'bzrlib/tests/test_bugtracker.py'
--- bzrlib/tests/test_bugtracker.py	2008-04-03 05:02:07 +0000
+++ bzrlib/tests/test_bugtracker.py	2007-04-23 05:59:29 +0000
@@ -81,12 +81,6 @@
         self.assertEqual('http://bugs.debian.org/1234',
                          tracker.get_bug_url('1234'))
 
-    def test_gnome_registered(self):
-        branch = self.make_branch('some_branch')
-        tracker = bugtracker.tracker_registry.get_tracker('gnome', branch)
-        self.assertEqual('http://bugzilla.gnome.org/show_bug.cgi?id=1234',
-                         tracker.get_bug_url('1234'))
-
     def test_trac_registered(self):
         """The Trac bug tracker should be registered by default and generate
         Trac bug page URLs when the appropriate configuration is present.
@@ -110,36 +104,19 @@
         self.assertEqual('http://bugs.com/show_bug.cgi?id=1234',
                          tracker.get_bug_url('1234'))
 
-    def test_generic_registered(self):
-        branch = self.make_branch('some_branch')
-        config = branch.get_config()
-        config.set_user_option('bugtracker_foo_url', 'http://bugs.com/{id}/view.html')
-        tracker = bugtracker.tracker_registry.get_tracker('foo', branch)
-        self.assertEqual('http://bugs.com/1234/view.html',
-                         tracker.get_bug_url('1234'))
-
-    def test_generic_incorrect_url(self):
-        branch = self.make_branch('some_branch')
-        config = branch.get_config()
-        config.set_user_option('bugtracker_foo_url', 'http://bugs.com/view.html')
-        tracker = bugtracker.tracker_registry.get_tracker('foo', branch)
-        self.assertRaises(errors.InvalidBugTrackerURL, tracker.get_bug_url, '1234')
-
 
 class TestUniqueIntegerBugTracker(TestCaseWithMemoryTransport):
 
-    def test_appends_id_to_base_url(self):
+    def test_joins_id_to_base_url(self):
         """The URL of a bug is the base URL joined to the identifier."""
-        tracker = bugtracker.UniqueIntegerBugTracker('xxx',
-                'http://bugs.com/foo')
-        self.assertEqual('http://bugs.com/foo1234', tracker.get_bug_url('1234'))
+        tracker = bugtracker.UniqueIntegerBugTracker('xxx', 'http://bugs.com')
+        self.assertEqual('http://bugs.com/1234', tracker.get_bug_url('1234'))
 
     def test_returns_tracker_if_abbreviation_matches(self):
         """The get() method should return an instance of the tracker if the
         given abbreviation matches the tracker's abbreviated name.
         """
-        tracker = bugtracker.UniqueIntegerBugTracker('xxx',
-                'http://bugs.com/')
+        tracker = bugtracker.UniqueIntegerBugTracker('xxx', 'http://bugs.com')
         branch = self.make_branch('some_branch')
         self.assertIs(tracker, tracker.get('xxx', branch))
 
@@ -147,8 +124,7 @@
         """The get() method should return None if the given abbreviated name
         doesn't match the tracker's abbreviation.
         """
-        tracker = bugtracker.UniqueIntegerBugTracker('xxx',
-                'http://bugs.com/')
+        tracker = bugtracker.UniqueIntegerBugTracker('xxx', 'http://bugs.com')
         branch = self.make_branch('some_branch')
         self.assertIs(None, tracker.get('yyy', branch))
 
@@ -156,21 +132,18 @@
         """A UniqueIntegerBugTracker shouldn't consult the branch for tracker
         information.
         """
-        tracker = bugtracker.UniqueIntegerBugTracker('xxx',
-                'http://bugs.com/')
+        tracker = bugtracker.UniqueIntegerBugTracker('xxx', 'http://bugs.com')
         self.assertIs(tracker, tracker.get('xxx', None))
         self.assertIs(None, tracker.get('yyy', None))
 
     def test_check_bug_id_only_accepts_integers(self):
         """A UniqueIntegerBugTracker accepts integers as bug IDs."""
-        tracker = bugtracker.UniqueIntegerBugTracker('xxx',
-                'http://bugs.com/')
+        tracker = bugtracker.UniqueIntegerBugTracker('xxx', 'http://bugs.com')
         tracker.check_bug_id('1234')
 
     def test_check_bug_id_doesnt_accept_non_integers(self):
         """A UniqueIntegerBugTracker rejects non-integers as bug IDs."""
-        tracker = bugtracker.UniqueIntegerBugTracker('xxx',
-                'http://bugs.com/')
+        tracker = bugtracker.UniqueIntegerBugTracker('xxx', 'http://bugs.com')
         self.assertRaises(
             errors.MalformedBugIdentifier, tracker.check_bug_id, 'red')
 

=== modified file 'bzrlib/tests/test_bundle.py'
--- bzrlib/tests/test_bundle.py	2008-08-26 08:25:27 +0000
+++ bzrlib/tests/test_bundle.py	2007-09-24 08:46:35 +0000
@@ -17,21 +17,19 @@
 from cStringIO import StringIO
 import os
 import sys
+import tempfile
 
 from bzrlib import (
     bzrdir,
     errors,
     inventory,
-    osutils,
     repository,
     revision as _mod_revision,
     treebuilder,
     )
 from bzrlib.bzrdir import BzrDir
-from bzrlib.bundle import read_mergeable_from_url
 from bzrlib.bundle.apply_bundle import install_bundle, merge_bundle
 from bzrlib.bundle.bundle_data import BundleTree
-from bzrlib.directory_service import directories
 from bzrlib.bundle.serializer import write_bundle, read_bundle, v09, v4
 from bzrlib.bundle.serializer.v08 import BundleSerializerV08
 from bzrlib.bundle.serializer.v09 import BundleSerializerV09
@@ -42,16 +40,9 @@
                            NoSuchFile,)
 from bzrlib.merge import Merge3Merger
 from bzrlib.repofmt import knitrepo
-from bzrlib.osutils import sha_file, sha_string
-from bzrlib.tests import (
-    SymlinkFeature,
-    TestCase,
-    TestCaseInTempDir,
-    TestCaseWithTransport,
-    TestSkipped,
-    test_read_bundle,
-    test_commit,
-    )
+from bzrlib.osutils import has_symlinks, sha_file
+from bzrlib.tests import (TestCaseInTempDir, TestCaseWithTransport,
+                          TestCase, TestSkipped, test_commit)
 from bzrlib.transform import TreeTransform
 
 
@@ -169,14 +160,14 @@
         self.assertEqual(btree.path2id("grandparent/parent"), "b")
         self.assertEqual(btree.path2id("grandparent/parent/file"), "c")
 
-        self.assertTrue(btree.path2id("grandparent2") is None)
-        self.assertTrue(btree.path2id("grandparent2/parent") is None)
-        self.assertTrue(btree.path2id("grandparent2/parent/file") is None)
+        assert btree.path2id("grandparent2") is None
+        assert btree.path2id("grandparent2/parent") is None
+        assert btree.path2id("grandparent2/parent/file") is None
 
         btree.note_rename("grandparent", "grandparent2")
-        self.assertTrue(btree.old_path("grandparent") is None)
-        self.assertTrue(btree.old_path("grandparent/parent") is None)
-        self.assertTrue(btree.old_path("grandparent/parent/file") is None)
+        assert btree.old_path("grandparent") is None
+        assert btree.old_path("grandparent/parent") is None
+        assert btree.old_path("grandparent/parent/file") is None
 
         self.assertEqual(btree.id2path("a"), "grandparent2")
         self.assertEqual(btree.id2path("b"), "grandparent2/parent")
@@ -186,9 +177,9 @@
         self.assertEqual(btree.path2id("grandparent2/parent"), "b")
         self.assertEqual(btree.path2id("grandparent2/parent/file"), "c")
 
-        self.assertTrue(btree.path2id("grandparent") is None)
-        self.assertTrue(btree.path2id("grandparent/parent") is None)
-        self.assertTrue(btree.path2id("grandparent/parent/file") is None)
+        assert btree.path2id("grandparent") is None
+        assert btree.path2id("grandparent/parent") is None
+        assert btree.path2id("grandparent/parent/file") is None
 
         btree.note_rename("grandparent/parent", "grandparent2/parent2")
         self.assertEqual(btree.id2path("a"), "grandparent2")
@@ -199,8 +190,8 @@
         self.assertEqual(btree.path2id("grandparent2/parent2"), "b")
         self.assertEqual(btree.path2id("grandparent2/parent2/file"), "c")
 
-        self.assertTrue(btree.path2id("grandparent2/parent") is None)
-        self.assertTrue(btree.path2id("grandparent2/parent/file") is None)
+        assert btree.path2id("grandparent2/parent") is None
+        assert btree.path2id("grandparent2/parent/file") is None
 
         btree.note_rename("grandparent/parent/file", 
                           "grandparent2/parent2/file2")
@@ -212,7 +203,7 @@
         self.assertEqual(btree.path2id("grandparent2/parent2"), "b")
         self.assertEqual(btree.path2id("grandparent2/parent2/file2"), "c")
 
-        self.assertTrue(btree.path2id("grandparent2/parent2/file") is None)
+        assert btree.path2id("grandparent2/parent2/file") is None
 
     def test_moves(self):
         """Ensure that file moves have the proper effect on children"""
@@ -221,7 +212,7 @@
                           "grandparent/alt_parent/file")
         self.assertEqual(btree.id2path("c"), "grandparent/alt_parent/file")
         self.assertEqual(btree.path2id("grandparent/alt_parent/file"), "c")
-        self.assertTrue(btree.path2id("grandparent/parent/file") is None)
+        assert btree.path2id("grandparent/parent/file") is None
 
     def unified_diff(self, old, new):
         out = StringIO()
@@ -233,8 +224,8 @@
         btree = self.make_tree_1()[0]
         btree.note_rename("grandparent/parent/file", 
                           "grandparent/alt_parent/file")
-        self.assertTrue(btree.id2path("e") is None)
-        self.assertTrue(btree.path2id("grandparent/parent/file") is None)
+        assert btree.id2path("e") is None
+        assert btree.path2id("grandparent/parent/file") is None
         btree.note_id("e", "grandparent/parent/file")
         return btree
 
@@ -298,8 +289,8 @@
         btree = self.make_tree_1()[0]
         self.assertEqual(btree.get_file("c").read(), "Hello\n")
         btree.note_deletion("grandparent/parent/file")
-        self.assertTrue(btree.id2path("c") is None)
-        self.assertTrue(btree.path2id("grandparent/parent/file") is None)
+        assert btree.id2path("c") is None
+        assert btree.path2id("grandparent/parent/file") is None
 
     def sorted_ids(self, tree):
         ids = list(tree)
@@ -455,7 +446,7 @@
         """
 
         if checkout_dir is None:
-            checkout_dir = osutils.mkdtemp(prefix='test-branch-', dir='.')
+            checkout_dir = tempfile.mkdtemp(prefix='test-branch-', dir='.')
         else:
             if not os.path.exists(checkout_dir):
                 os.mkdir(checkout_dir)
@@ -464,33 +455,29 @@
         ancestors = write_bundle(self.b1.repository, rev_id, 'null:', s,
                                  format=self.format)
         s.seek(0)
-        self.assertIsInstance(s.getvalue(), str)
+        assert isinstance(s.getvalue(), str), (
+            "Bundle isn't a bytestring:\n %s..." % repr(s.getvalue())[:40])
         install_bundle(tree.branch.repository, read_bundle(s))
         for ancestor in ancestors:
             old = self.b1.repository.revision_tree(ancestor)
             new = tree.branch.repository.revision_tree(ancestor)
-            old.lock_read()
-            new.lock_read()
-            try:
-                # Check that there aren't any inventory level changes
-                delta = new.changes_from(old)
-                self.assertFalse(delta.has_changed(),
-                                 'Revision %s not copied correctly.'
-                                 % (ancestor,))
-
-                # Now check that the file contents are all correct
-                for inventory_id in old:
-                    try:
-                        old_file = old.get_file(inventory_id)
-                    except NoSuchFile:
-                        continue
-                    if old_file is None:
-                        continue
-                    self.assertEqual(old_file.read(),
-                                     new.get_file(inventory_id).read())
-            finally:
-                new.unlock()
-                old.unlock()
+
+            # Check that there aren't any inventory level changes
+            delta = new.changes_from(old)
+            self.assertFalse(delta.has_changed(),
+                             'Revision %s not copied correctly.'
+                             % (ancestor,))
+
+            # Now check that the file contents are all correct
+            for inventory_id in old:
+                try:
+                    old_file = old.get_file(inventory_id)
+                except NoSuchFile:
+                    continue
+                if old_file is None:
+                    continue
+                self.assertEqual(old_file.read(),
+                                 new.get_file(inventory_id).read())
         if not _mod_revision.is_null(rev_id):
             rh = self.b1.revision_history()
             tree.branch.set_revision_history(rh[:rh.index(rev_id)+1])
@@ -505,13 +492,6 @@
         sure everything matches the builtin branch.
         """
         to_tree = self.get_checkout(base_rev_id, checkout_dir=checkout_dir)
-        to_tree.lock_write()
-        try:
-            self._valid_apply_bundle(base_rev_id, info, to_tree)
-        finally:
-            to_tree.unlock()
-
-    def _valid_apply_bundle(self, base_rev_id, info, to_tree):
         original_parents = to_tree.get_parent_ids()
         repository = to_tree.branch.repository
         original_parents = to_tree.get_parent_ids()
@@ -661,7 +641,8 @@
         bundle = self.get_valid_bundle('a@cset-0-6', 'a@cset-0-7')
 
     def test_symlink_bundle(self):
-        self.requireFeature(SymlinkFeature)
+        if not has_symlinks():
+            raise TestSkipped("No symlink support")
         self.tree1 = self.make_branch_and_tree('b1')
         self.b1 = self.tree1.branch
         tt = TreeTransform(self.tree1)
@@ -1019,31 +1000,18 @@
         self.assertNotContainsRe(inv_text, 'format="5"')
         self.assertContainsRe(inv_text, 'format="7"')
 
-    def make_repo_with_installed_revisions(self):
-        tree = self.make_simple_tree('knit')
-        tree.commit('hello', rev_id='rev1')
-        tree.commit('hello', rev_id='rev2')
-        bundle = read_bundle(self.create_bundle_text('null:', 'rev2')[0])
-        repo = self.make_repository('repo', format='dirstate-with-subtree')
-        bundle.install_revisions(repo)
-        return repo
-
     def test_across_models(self):
-        repo = self.make_repo_with_installed_revisions()
+        tree = self.make_simple_tree('knit')
+        tree.commit('hello', rev_id='rev1')
+        tree.commit('hello', rev_id='rev2')
+        bundle = read_bundle(self.create_bundle_text('null:', 'rev2')[0])
+        repo = self.make_repository('repo', format='dirstate-with-subtree')
+        bundle.install_revisions(repo)
         inv = repo.get_inventory('rev2')
         self.assertEqual('rev2', inv.root.revision)
-        root_id = inv.root.file_id
-        repo.lock_read()
-        self.addCleanup(repo.unlock)
-        self.assertEqual({(root_id, 'rev1'):(),
-            (root_id, 'rev2'):((root_id, 'rev1'),)},
-            repo.texts.get_parent_map([(root_id, 'rev1'), (root_id, 'rev2')]))
-
-    def test_inv_hash_across_serializers(self):
-        repo = self.make_repo_with_installed_revisions()
-        recorded_inv_sha1 = repo.get_inventory_sha1('rev2')
-        xml = repo.get_inventory_xml('rev2')
-        self.assertEqual(sha_string(xml), recorded_inv_sha1)
+        root_vf = repo.weave_store.get_weave(inv.root.file_id,
+                                             repo.get_transaction())
+        self.assertEqual(root_vf.versions(), ['rev1', 'rev2'])
 
     def test_across_models_incompatible(self):
         tree = self.make_simple_tree('dirstate-with-subtree')
@@ -1353,18 +1321,13 @@
         tree2 = self.make_branch_and_tree('target')
         target_repo = tree2.branch.repository
         install_bundle(target_repo, serializer.read(s))
-        target_repo.lock_read()
-        self.addCleanup(target_repo.unlock)
-        self.assertEqual({'1':'contents1\nstatic\n',
-            '2':'contents2\nstatic\n'},
-            dict(target_repo.iter_files_bytes(
-                [('fileid-2', 'rev1', '1'), ('fileid-2', 'rev2', '2')])))
+        vf = target_repo.weave_store.get_weave('fileid-2',
+            target_repo.get_transaction())
+        self.assertEqual('contents1\nstatic\n', vf.get_text('rev1'))
+        self.assertEqual('contents2\nstatic\n', vf.get_text('rev2'))
         rtree = target_repo.revision_tree('rev2')
-        inventory_vf = target_repo.inventories
-        # If the inventory store has a graph, it must match the revision graph.
-        self.assertSubset(
-            [inventory_vf.get_parent_map([('rev2',)])[('rev2',)]],
-            [None, (('rev1',),)])
+        inventory_vf = target_repo.get_inventory_weave()
+        self.assertEqual(['rev1'], inventory_vf.get_parents('rev2'))
         self.assertEqual('changed file',
                          target_repo.get_revision('rev2').message)
 
@@ -1584,21 +1547,3 @@
         self.assertEqual((None, {'foo': 'bar', 'storage_kind': 'header'},
             'info', None, None), record)
         self.assertRaises(BadBundle, record_iter.next)
-
-
-class TestReadMergeableFromUrl(TestCaseWithTransport):
-
-    def test_read_mergeable_skips_local(self):
-        """A local bundle named like the URL should not be read.
-        """
-        out, wt = test_read_bundle.create_bundle_file(self)
-        class FooService(object):
-            """A directory service that always returns source"""
-
-            def look_up(self, name, url):
-                return 'source'
-        directories.register('foo:', FooService, 'Testing directory service')
-        self.addCleanup(lambda: directories.remove('foo:'))
-        self.build_tree_contents([('./foo:bar', out.getvalue())])
-        self.assertRaises(errors.NotABundle, read_mergeable_from_url,
-                          'foo:bar')

=== modified file 'bzrlib/tests/test_bzrdir.py'
--- bzrlib/tests/test_bzrdir.py	2008-09-02 15:28:44 +0000
+++ bzrlib/tests/test_bzrdir.py	2007-09-18 07:14:35 +0000
@@ -1,5 +1,5 @@
 # Copyright (C) 2005, 2006, 2007 Canonical Ltd
-#
+# 
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 # the Free Software Foundation; either version 2 of the License, or
@@ -19,21 +19,16 @@
 For interface contract tests, see tests/bzr_dir_implementations.
 """
 
-import os
 import os.path
 from StringIO import StringIO
-import subprocess
-import sys
 
 from bzrlib import (
     bzrdir,
     errors,
     help_topics,
     repository,
-    osutils,
     symbol_versioning,
     urlutils,
-    win32utils,
     workingtree,
     )
 import bzrlib.branch
@@ -41,15 +36,16 @@
                            UnknownFormatError,
                            UnsupportedFormatError,
                            )
+from bzrlib.symbol_versioning import (
+    zero_ninetyone,
+    )
 from bzrlib.tests import (
     TestCase,
-    TestCaseWithMemoryTransport,
     TestCaseWithTransport,
-    TestSkipped,
     test_sftp_transport
     )
-from bzrlib.tests.http_server import HttpServer
-from bzrlib.tests.http_utils import (
+from bzrlib.tests.HttpServer import HttpServer
+from bzrlib.tests.HTTPTestUtil import (
     TestCaseWithTwoWebservers,
     HTTPServerRedirecting,
     )
@@ -66,13 +62,16 @@
         old_format = bzrdir.BzrDirFormat.get_default_format()
         # default is BzrDirFormat6
         self.failUnless(isinstance(old_format, bzrdir.BzrDirMetaFormat1))
-        bzrdir.BzrDirFormat._set_default_format(SampleBzrDirFormat())
+        self.applyDeprecated(symbol_versioning.zero_fourteen, 
+                             bzrdir.BzrDirFormat.set_default_format, 
+                             SampleBzrDirFormat())
         # creating a bzr dir should now create an instrumented dir.
         try:
             result = bzrdir.BzrDir.create('memory:///')
             self.failUnless(isinstance(result, SampleBzrDir))
         finally:
-            bzrdir.BzrDirFormat._set_default_format(old_format)
+            self.applyDeprecated(symbol_versioning.zero_fourteen,
+                bzrdir.BzrDirFormat.set_default_format, old_format)
         self.assertEqual(old_format, bzrdir.BzrDirFormat.get_default_format())
 
 
@@ -94,8 +93,7 @@
             'branch6',
             'bzrlib.repofmt.knitrepo.RepositoryFormatKnit3',
             'Experimental successor to knit.  Use at your own risk.',
-            branch_format='bzrlib.branch.BzrBranchFormat6',
-            experimental=True)
+            branch_format='bzrlib.branch.BzrBranchFormat6')
         my_format_registry.register_metadir(
             'hidden format',
             'bzrlib.repofmt.knitrepo.RepositoryFormatKnit3',
@@ -142,13 +140,10 @@
         topics.register('formats', self.make_format_registry().help_topic, 
                         'Directory formats')
         topic = topics.get_detail('formats')
-        new, rest = topic.split('Experimental formats')
-        experimental, deprecated = rest.split('Deprecated formats')
+        new, deprecated = topic.split('Deprecated formats')
         self.assertContainsRe(new, 'These formats can be used')
         self.assertContainsRe(new, 
                 ':knit:\n    \(native\) \(default\) Format using knits\n')
-        self.assertContainsRe(experimental, 
-                ':branch6:\n    \(native\) Experimental successor to knit')
         self.assertContainsRe(deprecated, 
                 ':lazy:\n    \(native\) Format registered lazily\n')
         self.assertNotContainsRe(new, 'hidden')
@@ -167,16 +162,6 @@
         finally:
             bzrdir.format_registry.set_default_repository(old_default)
 
-    def test_aliases(self):
-        a_registry = bzrdir.BzrDirFormatRegistry()
-        a_registry.register('weave', bzrdir.BzrDirFormat6,
-            'Pre-0.8 format.  Slower and does not support checkouts or shared'
-            ' repositories', deprecated=True)
-        a_registry.register('weavealias', bzrdir.BzrDirFormat6,
-            'Pre-0.8 format.  Slower and does not support checkouts or shared'
-            ' repositories', deprecated=True, alias=True)
-        self.assertEqual(frozenset(['weavealias']), a_registry.aliases())
-    
 
 class SampleBranch(bzrlib.branch.Branch):
     """A dummy branch for guess what, dummy use."""
@@ -278,6 +263,43 @@
         # now open_downlevel should fail too.
         self.assertRaises(UnknownFormatError, bzrdir.BzrDir.open_unsupported, url)
 
+    def test_create_repository_deprecated(self):
+        # new interface is to make the bzrdir, then a repository within that.
+        format = SampleBzrDirFormat()
+        repo = self.applyDeprecated(zero_ninetyone,
+                bzrdir.BzrDir.create_repository,
+                self.get_url(), format=format)
+        self.assertEqual('A repository', repo)
+
+    def test_create_repository_shared(self):
+        # new interface is to make the bzrdir, then a repository within that.
+        old_format = bzrdir.BzrDirFormat.get_default_format()
+        repo = self.applyDeprecated(zero_ninetyone,
+                bzrdir.BzrDir.create_repository,
+                '.', shared=True)
+        self.assertTrue(repo.is_shared())
+
+    def test_create_repository_nonshared(self):
+        # new interface is to make the bzrdir, then a repository within that.
+        old_format = bzrdir.BzrDirFormat.get_default_format()
+        repo = self.applyDeprecated(zero_ninetyone,
+                bzrdir.BzrDir.create_repository,
+                '.')
+        self.assertFalse(repo.is_shared())
+
+    def test_create_repository_under_shared(self):
+        # an explicit create_repository always does so.
+        # we trust the format is right from the 'create_repository test'
+        # new interface is to make the bzrdir, then a repository within that.
+        format = bzrdir.format_registry.make_bzrdir('knit')
+        self.make_repository('.', shared=True, format=format)
+        repo = self.applyDeprecated(zero_ninetyone,
+                bzrdir.BzrDir.create_repository,
+                self.get_url('child'),
+                format=format)
+        self.assertTrue(isinstance(repo, repository.Repository))
+        self.assertTrue(repo.bzrdir.root_transport.base.endswith('child/'))
+
     def test_create_branch_and_repo_uses_default(self):
         format = SampleBzrDirFormat()
         branch = bzrdir.BzrDir.create_branch_and_repo(self.get_url(),
@@ -414,128 +436,6 @@
         branch.bzrdir.open_workingtree()
 
 
-class TestRepositoryAcquisitionPolicy(TestCaseWithTransport):
-
-    def test_acquire_repository_standalone(self):
-        """The default acquisition policy should create a standalone branch."""
-        my_bzrdir = self.make_bzrdir('.')
-        repo_policy = my_bzrdir.determine_repository_policy()
-        repo = repo_policy.acquire_repository()
-        self.assertEqual(repo.bzrdir.root_transport.base,
-                         my_bzrdir.root_transport.base)
-        self.assertFalse(repo.is_shared())
-
-
-    def test_determine_stacking_policy(self):
-        parent_bzrdir = self.make_bzrdir('.')
-        child_bzrdir = self.make_bzrdir('child')
-        parent_bzrdir.get_config().set_default_stack_on('http://example.org')
-        repo_policy = child_bzrdir.determine_repository_policy()
-        self.assertEqual('http://example.org', repo_policy._stack_on)
-
-    def test_determine_stacking_policy_relative(self):
-        parent_bzrdir = self.make_bzrdir('.')
-        child_bzrdir = self.make_bzrdir('child')
-        parent_bzrdir.get_config().set_default_stack_on('child2')
-        repo_policy = child_bzrdir.determine_repository_policy()
-        self.assertEqual('child2', repo_policy._stack_on)
-        self.assertEqual(parent_bzrdir.root_transport.base,
-                         repo_policy._stack_on_pwd)
-
-    def prepare_default_stacking(self, child_format='development1'):
-        parent_bzrdir = self.make_bzrdir('.')
-        child_branch = self.make_branch('child', format=child_format)
-        parent_bzrdir.get_config().set_default_stack_on(child_branch.base)
-        new_child_transport = parent_bzrdir.transport.clone('child2')
-        return child_branch, new_child_transport
-
-    def test_clone_on_transport_obeys_stacking_policy(self):
-        child_branch, new_child_transport = self.prepare_default_stacking()
-        new_child = child_branch.bzrdir.clone_on_transport(new_child_transport)
-        self.assertEqual(child_branch.base,
-                         new_child.open_branch().get_stacked_on_url())
-
-    def test_sprout_obeys_stacking_policy(self):
-        child_branch, new_child_transport = self.prepare_default_stacking()
-        new_child = child_branch.bzrdir.sprout(new_child_transport.base)
-        self.assertEqual(child_branch.base,
-                         new_child.open_branch().get_stacked_on_url())
-
-    def test_clone_ignores_policy_for_unsupported_formats(self):
-        child_branch, new_child_transport = self.prepare_default_stacking(
-            child_format='pack-0.92')
-        new_child = child_branch.bzrdir.clone_on_transport(new_child_transport)
-        self.assertRaises(errors.UnstackableBranchFormat,
-                          new_child.open_branch().get_stacked_on_url)
-
-    def test_sprout_ignores_policy_for_unsupported_formats(self):
-        child_branch, new_child_transport = self.prepare_default_stacking(
-            child_format='pack-0.92')
-        new_child = child_branch.bzrdir.sprout(new_child_transport.base)
-        self.assertRaises(errors.UnstackableBranchFormat,
-                          new_child.open_branch().get_stacked_on_url)
-
-    def test_sprout_upgrades_format_if_stacked_specified(self):
-        child_branch, new_child_transport = self.prepare_default_stacking(
-            child_format='pack-0.92')
-        new_child = child_branch.bzrdir.sprout(new_child_transport.base,
-                                               stacked=True)
-        self.assertEqual(child_branch.bzrdir.root_transport.base,
-                         new_child.open_branch().get_stacked_on_url())
-        repo = new_child.open_repository()
-        self.assertTrue(repo._format.supports_external_lookups)
-        self.assertFalse(repo.supports_rich_root())
-
-    def test_clone_on_transport_upgrades_format_if_stacked_on_specified(self):
-        child_branch, new_child_transport = self.prepare_default_stacking(
-            child_format='pack-0.92')
-        new_child = child_branch.bzrdir.clone_on_transport(new_child_transport,
-            stacked_on=child_branch.bzrdir.root_transport.base)
-        self.assertEqual(child_branch.bzrdir.root_transport.base,
-                         new_child.open_branch().get_stacked_on_url())
-        repo = new_child.open_repository()
-        self.assertTrue(repo._format.supports_external_lookups)
-        self.assertFalse(repo.supports_rich_root())
-
-    def test_sprout_upgrades_to_rich_root_format_if_needed(self):
-        child_branch, new_child_transport = self.prepare_default_stacking(
-            child_format='rich-root-pack')
-        new_child = child_branch.bzrdir.sprout(new_child_transport.base,
-                                               stacked=True)
-        repo = new_child.open_repository()
-        self.assertTrue(repo._format.supports_external_lookups)
-        self.assertTrue(repo.supports_rich_root())
-
-    def test_add_fallback_repo_handles_absolute_urls(self):
-        stack_on = self.make_branch('stack_on', format='development1')
-        repo = self.make_repository('repo', format='development1')
-        policy = bzrdir.UseExistingRepository(repo, stack_on.base)
-        policy._add_fallback(repo)
-
-    def test_add_fallback_repo_handles_relative_urls(self):
-        stack_on = self.make_branch('stack_on', format='development1')
-        repo = self.make_repository('repo', format='development1')
-        policy = bzrdir.UseExistingRepository(repo, '.', stack_on.base)
-        policy._add_fallback(repo)
-
-    def test_configure_relative_branch_stacking_url(self):
-        stack_on = self.make_branch('stack_on', format='development1')
-        stacked = self.make_branch('stack_on/stacked', format='development1')
-        policy = bzrdir.UseExistingRepository(stacked.repository,
-            '.', stack_on.base)
-        policy.configure_branch(stacked)
-        self.assertEqual('..', stacked.get_stacked_on_url())
-
-    def test_relative_branch_stacking_to_absolute(self):
-        stack_on = self.make_branch('stack_on', format='development1')
-        stacked = self.make_branch('stack_on/stacked', format='development1')
-        policy = bzrdir.UseExistingRepository(stacked.repository,
-            '.', self.get_readonly_url('stack_on'))
-        policy.configure_branch(stacked)
-        self.assertEqual(self.get_readonly_url('stack_on'),
-                         stacked.get_stacked_on_url())
-
-
 class ChrootedTests(TestCaseWithTransport):
     """A support class that provides readonly urls outside the local namespace.
 
@@ -549,9 +449,6 @@
         if not self.vfs_transport_factory == MemoryServer:
             self.transport_readonly_server = HttpServer
 
-    def local_branch_path(self, branch):
-         return os.path.realpath(urlutils.local_path_from_url(branch.base))
-
     def test_open_containing(self):
         self.assertRaises(NotBranchError, bzrdir.BzrDir.open_containing,
                           self.get_readonly_url(''))
@@ -563,93 +460,6 @@
         branch, relpath = bzrdir.BzrDir.open_containing(self.get_readonly_url('g/p/q'))
         self.assertEqual('g/p/q', relpath)
 
-    def test_open_containing_tree_branch_or_repository_empty(self):
-        self.assertRaises(errors.NotBranchError,
-            bzrdir.BzrDir.open_containing_tree_branch_or_repository,
-            self.get_readonly_url(''))
-
-    def test_open_containing_tree_branch_or_repository_all(self):
-        self.make_branch_and_tree('topdir')
-        tree, branch, repo, relpath = \
-            bzrdir.BzrDir.open_containing_tree_branch_or_repository(
-                'topdir/foo')
-        self.assertEqual(os.path.realpath('topdir'),
-                         os.path.realpath(tree.basedir))
-        self.assertEqual(os.path.realpath('topdir'),
-                         self.local_branch_path(branch))
-        self.assertEqual(
-            osutils.realpath(os.path.join('topdir', '.bzr', 'repository')),
-            repo.bzrdir.transport.local_abspath('repository'))
-        self.assertEqual(relpath, 'foo')
-
-    def test_open_containing_tree_branch_or_repository_no_tree(self):
-        self.make_branch('branch')
-        tree, branch, repo, relpath = \
-            bzrdir.BzrDir.open_containing_tree_branch_or_repository(
-                'branch/foo')
-        self.assertEqual(tree, None)
-        self.assertEqual(os.path.realpath('branch'),
-                         self.local_branch_path(branch))
-        self.assertEqual(
-            osutils.realpath(os.path.join('branch', '.bzr', 'repository')),
-            repo.bzrdir.transport.local_abspath('repository'))
-        self.assertEqual(relpath, 'foo')
-
-    def test_open_containing_tree_branch_or_repository_repo(self):
-        self.make_repository('repo')
-        tree, branch, repo, relpath = \
-            bzrdir.BzrDir.open_containing_tree_branch_or_repository(
-                'repo')
-        self.assertEqual(tree, None)
-        self.assertEqual(branch, None)
-        self.assertEqual(
-            osutils.realpath(os.path.join('repo', '.bzr', 'repository')),
-            repo.bzrdir.transport.local_abspath('repository'))
-        self.assertEqual(relpath, '')
-
-    def test_open_containing_tree_branch_or_repository_shared_repo(self):
-        self.make_repository('shared', shared=True)
-        bzrdir.BzrDir.create_branch_convenience('shared/branch',
-                                                force_new_tree=False)
-        tree, branch, repo, relpath = \
-            bzrdir.BzrDir.open_containing_tree_branch_or_repository(
-                'shared/branch')
-        self.assertEqual(tree, None)
-        self.assertEqual(os.path.realpath('shared/branch'),
-                         self.local_branch_path(branch))
-        self.assertEqual(
-            osutils.realpath(os.path.join('shared', '.bzr', 'repository')),
-            repo.bzrdir.transport.local_abspath('repository'))
-        self.assertEqual(relpath, '')
-
-    def test_open_containing_tree_branch_or_repository_branch_subdir(self):
-        self.make_branch_and_tree('foo')
-        self.build_tree(['foo/bar/'])
-        tree, branch, repo, relpath = \
-            bzrdir.BzrDir.open_containing_tree_branch_or_repository(
-                'foo/bar')
-        self.assertEqual(os.path.realpath('foo'),
-                         os.path.realpath(tree.basedir))
-        self.assertEqual(os.path.realpath('foo'),
-                         self.local_branch_path(branch))
-        self.assertEqual(
-            osutils.realpath(os.path.join('foo', '.bzr', 'repository')),
-            repo.bzrdir.transport.local_abspath('repository'))
-        self.assertEqual(relpath, 'bar')
-
-    def test_open_containing_tree_branch_or_repository_repo_subdir(self):
-        self.make_repository('bar')
-        self.build_tree(['bar/baz/'])
-        tree, branch, repo, relpath = \
-            bzrdir.BzrDir.open_containing_tree_branch_or_repository(
-                'bar/baz')
-        self.assertEqual(tree, None)
-        self.assertEqual(branch, None)
-        self.assertEqual(
-            osutils.realpath(os.path.join('bar', '.bzr', 'repository')),
-            repo.bzrdir.transport.local_abspath('repository'))
-        self.assertEqual(relpath, 'baz')
-
     def test_open_containing_from_transport(self):
         self.assertRaises(NotBranchError, bzrdir.BzrDir.open_containing_from_transport,
                           get_transport(self.get_readonly_url('')))
@@ -664,13 +474,17 @@
         self.assertEqual('g/p/q', relpath)
 
     def test_open_containing_tree_or_branch(self):
+        def local_branch_path(branch):
+             return os.path.realpath(
+                urlutils.local_path_from_url(branch.base))
+
         self.make_branch_and_tree('topdir')
         tree, branch, relpath = bzrdir.BzrDir.open_containing_tree_or_branch(
             'topdir/foo')
         self.assertEqual(os.path.realpath('topdir'),
                          os.path.realpath(tree.basedir))
         self.assertEqual(os.path.realpath('topdir'),
-                         self.local_branch_path(branch))
+                         local_branch_path(branch))
         self.assertIs(tree.bzrdir, branch.bzrdir)
         self.assertEqual('foo', relpath)
         # opening from non-local should not return the tree
@@ -684,28 +498,9 @@
             'topdir/foo')
         self.assertIs(tree, None)
         self.assertEqual(os.path.realpath('topdir/foo'),
-                         self.local_branch_path(branch))
+                         local_branch_path(branch))
         self.assertEqual('', relpath)
 
-    def test_open_tree_or_branch(self):
-        self.make_branch_and_tree('topdir')
-        tree, branch = bzrdir.BzrDir.open_tree_or_branch('topdir')
-        self.assertEqual(os.path.realpath('topdir'),
-                         os.path.realpath(tree.basedir))
-        self.assertEqual(os.path.realpath('topdir'),
-                         self.local_branch_path(branch))
-        self.assertIs(tree.bzrdir, branch.bzrdir)
-        # opening from non-local should not return the tree
-        tree, branch = bzrdir.BzrDir.open_tree_or_branch(
-            self.get_readonly_url('topdir'))
-        self.assertEqual(None, tree)
-        # without a tree:
-        self.make_branch('topdir/foo')
-        tree, branch = bzrdir.BzrDir.open_tree_or_branch('topdir/foo')
-        self.assertIs(tree, None)
-        self.assertEqual(os.path.realpath('topdir/foo'),
-                         self.local_branch_path(branch))
-
     def test_open_from_transport(self):
         # transport pointing at bzrdir should give a bzrdir with root transport
         # set to the given transport
@@ -765,66 +560,6 @@
         self.failUnlessExists('repo/tree2/subtree')
         self.failIfExists('repo/tree2/subtree/file')
 
-    def make_foo_bar_baz(self):
-        foo = bzrdir.BzrDir.create_branch_convenience('foo').bzrdir
-        bar = self.make_branch('foo/bar').bzrdir
-        baz = self.make_branch('baz').bzrdir
-        return foo, bar, baz
-
-    def test_find_bzrdirs(self):
-        foo, bar, baz = self.make_foo_bar_baz()
-        transport = get_transport(self.get_url())
-        self.assertEqualBzrdirs([baz, foo, bar],
-                                bzrdir.BzrDir.find_bzrdirs(transport))
-
-    def test_find_bzrdirs_list_current(self):
-        def list_current(transport):
-            return [s for s in transport.list_dir('') if s != 'baz']
-
-        foo, bar, baz = self.make_foo_bar_baz()
-        transport = get_transport(self.get_url())
-        self.assertEqualBzrdirs([foo, bar],
-                                bzrdir.BzrDir.find_bzrdirs(transport,
-                                    list_current=list_current))
-
-
-    def test_find_bzrdirs_evaluate(self):
-        def evaluate(bzrdir):
-            try:
-                repo = bzrdir.open_repository()
-            except NoRepositoryPresent:
-                return True, bzrdir.root_transport.base
-            else:
-                return False, bzrdir.root_transport.base
-
-        foo, bar, baz = self.make_foo_bar_baz()
-        transport = get_transport(self.get_url())
-        self.assertEqual([baz.root_transport.base, foo.root_transport.base],
-                         list(bzrdir.BzrDir.find_bzrdirs(transport,
-                                                         evaluate=evaluate)))
-
-    def assertEqualBzrdirs(self, first, second):
-        first = list(first)
-        second = list(second)
-        self.assertEqual(len(first), len(second))
-        for x, y in zip(first, second):
-            self.assertEqual(x.root_transport.base, y.root_transport.base)
-
-    def test_find_branches(self):
-        root = self.make_repository('', shared=True)
-        foo, bar, baz = self.make_foo_bar_baz()
-        qux = self.make_bzrdir('foo/qux')
-        transport = get_transport(self.get_url())
-        branches = bzrdir.BzrDir.find_branches(transport)
-        self.assertEqual(baz.root_transport.base, branches[0].base)
-        self.assertEqual(foo.root_transport.base, branches[1].base)
-        self.assertEqual(bar.root_transport.base, branches[2].base)
-
-        # ensure this works without a top-level repo
-        branches = bzrdir.BzrDir.find_branches(transport.clone('foo'))
-        self.assertEqual(foo.root_transport.base, branches[0].base)
-        self.assertEqual(bar.root_transport.base, branches[1].base)
-
 
 class TestMeta1DirFormat(TestCaseWithTransport):
     """Tests specific to the meta1 dir format."""
@@ -1131,117 +866,3 @@
     """Tests redirections for pycurl implementation"""
 
     _qualifier = 'pycurl'
-
-
-class TestDotBzrHidden(TestCaseWithTransport):
-
-    ls = ['ls']
-    if sys.platform == 'win32':
-        ls = [os.environ['COMSPEC'], '/C', 'dir', '/B']
-
-    def get_ls(self):
-        f = subprocess.Popen(self.ls, stdout=subprocess.PIPE,
-            stderr=subprocess.PIPE)
-        out, err = f.communicate()
-        self.assertEqual(0, f.returncode, 'Calling %s failed: %s'
-                         % (self.ls, err))
-        return out.splitlines()
-
-    def test_dot_bzr_hidden(self):
-        if sys.platform == 'win32' and not win32utils.has_win32file:
-            raise TestSkipped('unable to make file hidden without pywin32 library')
-        b = bzrdir.BzrDir.create('.')
-        self.build_tree(['a'])
-        self.assertEquals(['a'], self.get_ls())
-
-    def test_dot_bzr_hidden_with_url(self):
-        if sys.platform == 'win32' and not win32utils.has_win32file:
-            raise TestSkipped('unable to make file hidden without pywin32 library')
-        b = bzrdir.BzrDir.create(urlutils.local_path_to_url('.'))
-        self.build_tree(['a'])
-        self.assertEquals(['a'], self.get_ls())
-
-
-class _TestBzrDirFormat(bzrdir.BzrDirMetaFormat1):
-    """Test BzrDirFormat implementation for TestBzrDirSprout."""
-
-    def _open(self, transport):
-        return _TestBzrDir(transport, self)
-
-
-class _TestBzrDir(bzrdir.BzrDirMeta1):
-    """Test BzrDir implementation for TestBzrDirSprout.
-    
-    When created a _TestBzrDir already has repository and a branch.  The branch
-    is a test double as well.
-    """
-
-    def __init__(self, *args, **kwargs):
-        super(_TestBzrDir, self).__init__(*args, **kwargs)
-        self.test_branch = _TestBranch()
-        self.test_branch.repository = self.create_repository()
-
-    def open_branch(self, unsupported=False):
-        return self.test_branch
-
-    def cloning_metadir(self, require_stacking=False):
-        return _TestBzrDirFormat()
-
-
-class _TestBranch(bzrlib.branch.Branch):
-    """Test Branch implementation for TestBzrDirSprout."""
-
-    def __init__(self, *args, **kwargs):
-        super(_TestBranch, self).__init__(*args, **kwargs)
-        self.calls = []
-        self._parent = None
-
-    def sprout(self, *args, **kwargs):
-        self.calls.append('sprout')
-        return _TestBranch()
-
-    def copy_content_into(self, destination, revision_id=None):
-        self.calls.append('copy_content_into')
-
-    def get_parent(self):
-        return self._parent
-
-    def set_parent(self, parent):
-        self._parent = parent
-
-
-class TestBzrDirSprout(TestCaseWithMemoryTransport):
-
-    def test_sprout_uses_branch_sprout(self):
-        """BzrDir.sprout calls Branch.sprout.
-
-        Usually, BzrDir.sprout should delegate to the branch's sprout method
-        for part of the work.  This allows the source branch to control the
-        choice of format for the new branch.
-        
-        There are exceptions, but this tests avoids them:
-          - if there's no branch in the source bzrdir,
-          - or if the stacking has been requested and the format needs to be
-            overridden to satisfy that.
-        """
-        # Make an instrumented bzrdir.
-        t = self.get_transport('source')
-        t.ensure_base()
-        source_bzrdir = _TestBzrDirFormat().initialize_on_transport(t)
-        # The instrumented bzrdir has a test_branch attribute that logs calls
-        # made to the branch contained in that bzrdir.  Initially the test
-        # branch exists but no calls have been made to it.
-        self.assertEqual([], source_bzrdir.test_branch.calls)
-
-        # Sprout the bzrdir
-        target_url = self.get_url('target')
-        result = source_bzrdir.sprout(target_url, recurse='no')
-
-        # The bzrdir called the branch's sprout method.
-        self.assertSubset(['sprout'], source_bzrdir.test_branch.calls)
-
-    def test_sprout_parent(self):
-        grandparent_tree = self.make_branch('grandparent')
-        parent = grandparent_tree.bzrdir.sprout('parent').open_branch()
-        branch_tree = parent.bzrdir.sprout('branch').open_branch()
-        self.assertContainsRe(branch_tree.get_parent(), '/parent/$')

=== removed file 'bzrlib/tests/test_chunk_writer.py'
--- bzrlib/tests/test_chunk_writer.py	2008-08-22 05:54:44 +0000
+++ bzrlib/tests/test_chunk_writer.py	1970-01-01 00:00:00 +0000
@@ -1,95 +0,0 @@
-# Copyright (C) 2008 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-#
-
-"""Tests for writing fixed size chunks with compression."""
-
-import zlib
-
-from bzrlib import chunk_writer
-from bzrlib.tests import TestCaseWithTransport
-
-
-class TestWriter(TestCaseWithTransport):
-
-    def check_chunk(self, bytes_list, size):
-        bytes = ''.join(bytes_list)
-        self.assertEqual(size, len(bytes))
-        return zlib.decompress(bytes)
-
-    def test_chunk_writer_empty(self):
-        writer = chunk_writer.ChunkWriter(4096)
-        bytes_list, unused, padding = writer.finish()
-        node_bytes = self.check_chunk(bytes_list, 4096)
-        self.assertEqual("", node_bytes)
-        self.assertEqual(None, unused)
-        # Only a zlib header.
-        self.assertEqual(4088, padding)
-
-    def test_some_data(self):
-        writer = chunk_writer.ChunkWriter(4096)
-        writer.write("foo bar baz quux\n")
-        bytes_list, unused, padding = writer.finish()
-        node_bytes = self.check_chunk(bytes_list, 4096)
-        self.assertEqual("foo bar baz quux\n", node_bytes)
-        self.assertEqual(None, unused)
-        # More than just the header..
-        self.assertEqual(4073, padding)
-
-    def test_too_much_data_does_not_exceed_size(self):
-        # Generate enough data to exceed 4K
-        lines = []
-        for group in range(48):
-            offset = group * 50
-            numbers = range(offset, offset + 50)
-            # Create a line with this group
-            lines.append(''.join(map(str, numbers)) + '\n')
-        writer = chunk_writer.ChunkWriter(4096)
-        for idx, line in enumerate(lines):
-            if writer.write(line):
-                self.assertEqual(46, idx)
-                break
-        bytes_list, unused, _ = writer.finish()
-        node_bytes = self.check_chunk(bytes_list, 4096)
-        # the first 46 lines should have been added
-        expected_bytes = ''.join(lines[:46])
-        self.assertEqualDiff(expected_bytes, node_bytes)
-        # And the line that failed should have been saved for us
-        self.assertEqual(lines[46], unused)
-
-    def test_too_much_data_preserves_reserve_space(self):
-        # Generate enough data to exceed 4K
-        lines = []
-        for group in range(48):
-            offset = group * 50
-            numbers = range(offset, offset + 50)
-            # Create a line with this group
-            lines.append(''.join(map(str, numbers)) + '\n')
-        writer = chunk_writer.ChunkWriter(4096, 256)
-        for idx, line in enumerate(lines):
-            if writer.write(line):
-                self.assertEqual(44, idx)
-                break
-        else:
-            self.fail('We were able to write all lines')
-        self.assertFalse(writer.write("A"*256, reserved=True))
-        bytes_list, unused, _ = writer.finish()
-        node_bytes = self.check_chunk(bytes_list, 4096)
-        # the first 44 lines should have been added
-        expected_bytes = ''.join(lines[:44]) + "A"*256
-        self.assertEqualDiff(expected_bytes, node_bytes)
-        # And the line that failed should have been saved for us
-        self.assertEqual(lines[44], unused)

=== modified file 'bzrlib/tests/test_commit.py'
--- bzrlib/tests/test_commit.py	2008-04-18 18:11:56 +0000
+++ bzrlib/tests/test_commit.py	2007-10-03 05:25:50 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2008 Canonical Ltd
+# Copyright (C) 2005, 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -19,7 +19,6 @@
 
 import bzrlib
 from bzrlib import (
-    bzrdir,
     errors,
     lockdir,
     osutils,
@@ -31,7 +30,7 @@
 from bzrlib.config import BranchConfig
 from bzrlib.errors import (PointlessCommit, BzrError, SigningFailed, 
                            LockContention)
-from bzrlib.tests import SymlinkFeature, TestCaseWithTransport
+from bzrlib.tests import TestCaseWithTransport
 from bzrlib.workingtree import WorkingTree
 
 
@@ -96,16 +95,11 @@
         eq(rev.message, 'add hello')
 
         tree1 = b.repository.revision_tree(rh[0])
-        tree1.lock_read()
         text = tree1.get_file_text(file_id)
-        tree1.unlock()
-        self.assertEqual('hello world', text)
+        eq(text, 'hello world')
 
         tree2 = b.repository.revision_tree(rh[1])
-        tree2.lock_read()
-        text = tree2.get_file_text(file_id)
-        tree2.unlock()
-        self.assertEqual('version 2', text)
+        eq(tree2.get_file_text(file_id), 'version 2')
 
     def test_delete_commit(self):
         """Test a commit with a deleted file"""
@@ -121,26 +115,6 @@
         tree = b.repository.revision_tree('rev2')
         self.assertFalse(tree.has_id('hello-id'))
 
-    def test_partial_commit_move(self):
-        """Test a partial commit where a file was renamed but not committed.
-
-        https://bugs.launchpad.net/bzr/+bug/83039
-        
-        If not handled properly, commit will try to snapshot
-        dialog.py with olive/ as a parent, while 
-        olive/ has not been snapshotted yet.
-        """
-        wt = self.make_branch_and_tree('.')
-        b = wt.branch
-        self.build_tree(['annotate/', 'annotate/foo.py',
-                         'olive/', 'olive/dialog.py'
-                        ])
-        wt.add(['annotate', 'olive', 'annotate/foo.py', 'olive/dialog.py'])
-        wt.commit(message='add files')
-        wt.rename_one("olive/dialog.py", "aaa")
-        self.build_tree_contents([('annotate/foo.py', 'modified\n')])
-        wt.commit('renamed hello', specific_files=["annotate"])
-
     def test_pointless_commit(self):
         """Commit refuses unless there are changes or it's forced."""
         wt = self.make_branch_and_tree('.')
@@ -194,15 +168,11 @@
         eq(b.revno(), 3)
 
         tree2 = b.repository.revision_tree('test@rev-2')
-        tree2.lock_read()
-        self.addCleanup(tree2.unlock)
         self.assertTrue(tree2.has_filename('hello'))
         self.assertEquals(tree2.get_file_text('hello-id'), 'hello')
         self.assertEquals(tree2.get_file_text('buongia-id'), 'new text')
         
         tree3 = b.repository.revision_tree('test@rev-3')
-        tree3.lock_read()
-        self.addCleanup(tree3.unlock)
         self.assertFalse(tree3.has_filename('hello'))
         self.assertEquals(tree3.get_file_text('buongia-id'), 'new text')
 
@@ -219,8 +189,6 @@
 
         eq = self.assertEquals
         tree1 = b.repository.revision_tree('test@rev-1')
-        tree1.lock_read()
-        self.addCleanup(tree1.unlock)
         eq(tree1.id2path('hello-id'), 'hello')
         eq(tree1.get_file_text('hello-id'), 'contents of hello\n')
         self.assertFalse(tree1.has_filename('fruity'))
@@ -229,8 +197,6 @@
         eq(ie.revision, 'test@rev-1')
 
         tree2 = b.repository.revision_tree('test@rev-2')
-        tree2.lock_read()
-        self.addCleanup(tree2.unlock)
         eq(tree2.id2path('hello-id'), 'fruity')
         eq(tree2.get_file_text('hello-id'), 'contents of hello\n')
         self.check_inventory_shape(tree2.inventory, ['fruity'])
@@ -464,10 +430,14 @@
         bound = master.sprout('bound')
         wt = bound.open_workingtree()
         wt.branch.set_bound_location(os.path.realpath('master'))
+
+        orig_default = lockdir._DEFAULT_TIMEOUT_SECONDS
         master_branch.lock_write()
         try:
+            lockdir._DEFAULT_TIMEOUT_SECONDS = 1
             self.assertRaises(LockContention, wt.commit, 'silly')
         finally:
+            lockdir._DEFAULT_TIMEOUT_SECONDS = orig_default
             master_branch.unlock()
 
     def test_commit_bound_merge(self):
@@ -614,7 +584,8 @@
             basis.unlock()
 
     def test_commit_kind_changes(self):
-        self.requireFeature(SymlinkFeature)
+        if not osutils.has_symlinks():
+            raise tests.TestSkipped('Test requires symlink support')
         tree = self.make_branch_and_tree('.')
         os.symlink('target', 'name')
         tree.add('name', 'a-file-id')
@@ -757,11 +728,3 @@
         rev = tree.branch.repository.get_revision(rev_id)
         self.assertEqual('John Doe <jdoe@example.com>',
                          rev.properties['author'])
-
-    def test_commit_with_checkout_and_branch_sharing_repo(self):
-        repo = self.make_repository('repo', shared=True)
-        # make_branch_and_tree ignores shared repos
-        branch = bzrdir.BzrDir.create_branch_convenience('repo/branch')
-        tree2 = branch.create_checkout('repo/tree2')
-        tree2.commit('message', rev_id='rev1')
-        self.assertTrue(tree2.branch.repository.has_revision('rev1'))

=== modified file 'bzrlib/tests/test_commit_merge.py'
--- bzrlib/tests/test_commit_merge.py	2007-11-01 09:52:45 +0000
+++ bzrlib/tests/test_commit_merge.py	2007-03-15 23:27:43 +0000
@@ -19,8 +19,8 @@
 import shutil
 
 from bzrlib.tests import (
-    SymlinkFeature,
     TestCaseWithTransport,
+    TestSkipped,
     )
 from bzrlib.branch import Branch
 from bzrlib.errors import PointlessCommit, BzrError
@@ -102,7 +102,8 @@
         by.repository.check([by.last_revision()])
 
     def test_merge_with_symlink(self):
-        self.requireFeature(SymlinkFeature)
+        if not osutils.has_symlinks():
+            raise TestSkipped('Symlinks are not supported on this platform')
         tree_a = self.make_branch_and_tree('tree_a')
         os.symlink('target', osutils.pathjoin('tree_a', 'link'))
         tree_a.add('link')

=== modified file 'bzrlib/tests/test_config.py'
--- bzrlib/tests/test_config.py	2008-08-10 11:26:50 +0000
+++ bzrlib/tests/test_config.py	2007-10-23 14:31:10 +0000
@@ -17,6 +17,7 @@
 
 """Tests for finding and reading the bzr config file[s]."""
 # import system imports here
+from bzrlib.util.configobj.configobj import ConfigObj, ConfigObjError
 from cStringIO import StringIO
 import os
 import sys
@@ -33,9 +34,7 @@
     urlutils,
     tests,
     trace,
-    transport,
     )
-from bzrlib.util.configobj import configobj
 
 
 sample_long_alias="log -r-15..-1 --line"
@@ -147,8 +146,7 @@
             self.base = "http://example.com/branches/demo"
         else:
             self.base = base
-        self._transport = self.control_files = \
-            FakeControlFilesAndTransport(user_id=user_id)
+        self.control_files = FakeControlFiles(user_id=user_id)
 
     def lock_write(self):
         pass
@@ -157,42 +155,32 @@
         pass
 
 
-class FakeControlFilesAndTransport(object):
+class FakeControlFiles(object):
 
     def __init__(self, user_id=None):
+        self.email = user_id
         self.files = {}
-        if user_id:
-            self.files['email'] = user_id
-        self._transport = self
 
     def get_utf8(self, filename):
-        # from LockableFiles
-        raise AssertionError("get_utf8 should no longer be used")
+        if filename != 'email':
+            raise NotImplementedError
+        if self.email is not None:
+            return StringIO(self.email)
+        raise errors.NoSuchFile(filename)
 
     def get(self, filename):
-        # from Transport
         try:
             return StringIO(self.files[filename])
         except KeyError:
             raise errors.NoSuchFile(filename)
 
-    def get_bytes(self, filename):
-        # from Transport
-        try:
-            return self.files[filename]
-        except KeyError:
-            raise errors.NoSuchFile(filename)
-
     def put(self, filename, fileobj):
         self.files[filename] = fileobj.read()
 
-    def put_file(self, filename, fileobj):
-        return self.put(filename, fileobj)
-
 
 class InstrumentedConfig(config.Config):
     """An instrumented config that supplies stubs for template methods."""
-
+    
     def __init__(self):
         super(InstrumentedConfig, self).__init__()
         self._calls = []
@@ -214,54 +202,36 @@
 active = True
 nonactive = False
 """
-
-
 class TestConfigObj(tests.TestCase):
-
     def test_get_bool(self):
-        co = config.ConfigObj(StringIO(bool_config))
+        from bzrlib.config import ConfigObj
+        co = ConfigObj(StringIO(bool_config))
         self.assertIs(co.get_bool('DEFAULT', 'active'), True)
         self.assertIs(co.get_bool('DEFAULT', 'inactive'), False)
         self.assertIs(co.get_bool('UPPERCASE', 'active'), True)
         self.assertIs(co.get_bool('UPPERCASE', 'nonactive'), False)
 
-    def test_hash_sign_in_value(self):
-        """
-        Before 4.5.0, ConfigObj did not quote # signs in values, so they'd be
-        treated as comments when read in again. (#86838)
-        """
-        co = config.ConfigObj()
-        co['test'] = 'foo#bar'
-        lines = co.write()
-        self.assertEqual(lines, ['test = "foo#bar"'])
-        co2 = config.ConfigObj(lines)
-        self.assertEqual(co2['test'], 'foo#bar')
-
 
 erroneous_config = """[section] # line 1
 good=good # line 2
 [section] # line 3
 whocares=notme # line 4
 """
-
-
 class TestConfigObjErrors(tests.TestCase):
 
     def test_duplicate_section_name_error_line(self):
         try:
-            co = configobj.ConfigObj(StringIO(erroneous_config),
-                                     raise_errors=True)
+            co = ConfigObj(StringIO(erroneous_config), raise_errors=True)
         except config.configobj.DuplicateError, e:
             self.assertEqual(3, e.line_number)
         else:
             self.fail('Error in config file not detected')
 
-
 class TestConfig(tests.TestCase):
 
     def test_constructs(self):
         config.Config()
-
+ 
     def test_no_default_editor(self):
         self.assertRaises(NotImplementedError, config.Config().get_editor)
 
@@ -321,30 +291,45 @@
         if sys.platform == 'win32':
             os.environ['BZR_HOME'] = \
                 r'C:\Documents and Settings\bogus\Application Data'
-            self.bzr_home = \
-                'C:/Documents and Settings/bogus/Application Data/bazaar/2.0'
-        else:
-            self.bzr_home = '/home/bogus/.bazaar'
 
     def test_config_dir(self):
-        self.assertEqual(config.config_dir(), self.bzr_home)
+        if sys.platform == 'win32':
+            self.assertEqual(config.config_dir(), 
+                'C:/Documents and Settings/bogus/Application Data/bazaar/2.0')
+        else:
+            self.assertEqual(config.config_dir(), '/home/bogus/.bazaar')
 
     def test_config_filename(self):
-        self.assertEqual(config.config_filename(),
-                         self.bzr_home + '/bazaar.conf')
+        if sys.platform == 'win32':
+            self.assertEqual(config.config_filename(), 
+                'C:/Documents and Settings/bogus/Application Data/bazaar/2.0/bazaar.conf')
+        else:
+            self.assertEqual(config.config_filename(),
+                             '/home/bogus/.bazaar/bazaar.conf')
 
     def test_branches_config_filename(self):
-        self.assertEqual(config.branches_config_filename(),
-                         self.bzr_home + '/branches.conf')
+        if sys.platform == 'win32':
+            self.assertEqual(config.branches_config_filename(), 
+                'C:/Documents and Settings/bogus/Application Data/bazaar/2.0/branches.conf')
+        else:
+            self.assertEqual(config.branches_config_filename(),
+                             '/home/bogus/.bazaar/branches.conf')
 
     def test_locations_config_filename(self):
-        self.assertEqual(config.locations_config_filename(),
-                         self.bzr_home + '/locations.conf')
+        if sys.platform == 'win32':
+            self.assertEqual(config.locations_config_filename(), 
+                'C:/Documents and Settings/bogus/Application Data/bazaar/2.0/locations.conf')
+        else:
+            self.assertEqual(config.locations_config_filename(),
+                             '/home/bogus/.bazaar/locations.conf')
 
     def test_authentication_config_filename(self):
-        self.assertEqual(config.authentication_config_filename(),
-                         self.bzr_home + '/authentication.conf')
-
+        if sys.platform == 'win32':
+            self.assertEqual(config.authentication_config_filename(), 
+                'C:/Documents and Settings/bogus/Application Data/bazaar/2.0/authentication.conf')
+        else:
+            self.assertEqual(config.authentication_config_filename(),
+                             '/home/bogus/.bazaar/authentication.conf')
 
 class TestIniConfig(tests.TestCase):
 
@@ -356,7 +341,7 @@
         my_config = config.IniBasedConfig(None)
         self.failUnless(
             isinstance(my_config._get_parser(file=config_file),
-                        configobj.ConfigObj))
+                        ConfigObj))
 
     def test_cached(self):
         config_file = StringIO(sample_config_text.encode('utf-8'))
@@ -371,7 +356,7 @@
         my_config = config.GlobalConfig()
 
     def test_calls_read_filenames(self):
-        # replace the class that is constructed, to check its parameters
+        # replace the class that is constructured, to check its parameters
         oldparserclass = config.ConfigObj
         config.ConfigObj = InstrumentedConfigObj
         my_config = config.GlobalConfig()
@@ -448,10 +433,7 @@
         local_path = osutils.getcwd().encode('utf8')
         # Surprisingly ConfigObj doesn't create a trailing newline
         self.check_file_contents(locations,
-                                 '[%s/branch]\n'
-                                 'push_location = http://foobar\n'
-                                 'push_location:policy = norecurse\n'
-                                 % (local_path,))
+            '[%s/branch]\npush_location = http://foobar\npush_location:policy = norecurse' % (local_path,))
 
     def test_autonick_urlencoded(self):
         b = self.make_branch('!repo')
@@ -575,7 +557,7 @@
         my_config = self._get_sample_config()
         self.assertEqual("something",
                          my_config.get_user_option('user_global_option'))
-
+        
     def test_post_commit_default(self):
         my_config = self._get_sample_config()
         self.assertEqual(None, my_config.post_commit())
@@ -588,14 +570,6 @@
         my_config = self._get_sample_config()
         self.assertEqual('help', my_config.get_alias('h'))
 
-    def test_get_aliases(self):
-        my_config = self._get_sample_config()
-        aliases = my_config.get_aliases()
-        self.assertEqual(2, len(aliases))
-        sorted_keys = sorted(aliases)
-        self.assertEqual('help', aliases[sorted_keys[0]])
-        self.assertEqual(sample_long_alias, aliases[sorted_keys[1]])
-
     def test_get_no_alias(self):
         my_config = self._get_sample_config()
         self.assertEqual(None, my_config.get_alias('foo'))
@@ -605,28 +579,6 @@
         self.assertEqual(sample_long_alias, my_config.get_alias('ll'))
 
 
-class TestGlobalConfigSavingOptions(tests.TestCaseInTempDir):
-
-    def test_empty(self):
-        my_config = config.GlobalConfig()
-        self.assertEqual(0, len(my_config.get_aliases()))
-
-    def test_set_alias(self):
-        my_config = config.GlobalConfig()
-        alias_value = 'commit --strict'
-        my_config.set_alias('commit', alias_value)
-        new_config = config.GlobalConfig()
-        self.assertEqual(alias_value, new_config.get_alias('commit'))
-
-    def test_remove_alias(self):
-        my_config = config.GlobalConfig()
-        my_config.set_alias('commit', 'commit --strict')
-        # Now remove the alias again.
-        my_config.unset_alias('commit')
-        new_config = config.GlobalConfig()
-        self.assertIs(None, new_config.get_alias('commit'))
-
-
 class TestLocationConfig(tests.TestCaseInTempDir):
 
     def test_constructs(self):
@@ -637,7 +589,7 @@
         # This is testing the correct file names are provided.
         # TODO: consolidate with the test for GlobalConfigs filename checks.
         #
-        # replace the class that is constructed, to check its parameters
+        # replace the class that is constructured, to check its parameters
         oldparserclass = config.ConfigObj
         config.ConfigObj = InstrumentedConfigObj
         try:
@@ -671,12 +623,12 @@
     def test__get_matching_sections_no_match(self):
         self.get_branch_config('/')
         self.assertEqual([], self.my_location_config._get_matching_sections())
-
+        
     def test__get_matching_sections_exact(self):
         self.get_branch_config('http://www.example.com')
         self.assertEqual([('http://www.example.com', '')],
                          self.my_location_config._get_matching_sections())
-
+   
     def test__get_matching_sections_suffix_does_not(self):
         self.get_branch_config('http://www.example.com-com')
         self.assertEqual([], self.my_location_config._get_matching_sections())
@@ -694,8 +646,7 @@
     def test__get_matching_sections_ignoreparent_subdir(self):
         self.get_branch_config(
             'http://www.example.com/ignoreparent/childbranch')
-        self.assertEqual([('http://www.example.com/ignoreparent',
-                           'childbranch')],
+        self.assertEqual([('http://www.example.com/ignoreparent', 'childbranch')],
                          self.my_location_config._get_matching_sections())
 
     def test__get_matching_sections_subdir_trailing_slash(self):
@@ -781,17 +732,17 @@
         self.get_branch_config('/a/c')
         self.assertEqual(config.CHECK_NEVER,
                          self.my_config.signature_checking())
-
+        
     def test_signatures_when_available(self):
         self.get_branch_config('/a/', global_config=sample_ignore_signatures)
         self.assertEqual(config.CHECK_IF_POSSIBLE,
                          self.my_config.signature_checking())
-
+        
     def test_signatures_always(self):
         self.get_branch_config('/b')
         self.assertEqual(config.CHECK_ALWAYS,
                          self.my_config.signature_checking())
-
+        
     def test_gpg_signing_command(self):
         self.get_branch_config('/b')
         self.assertEqual("gnome-gpg", self.my_config.gpg_signing_command())
@@ -951,7 +902,7 @@
         self.assertIs(self.my_config.get_user_option('foo'), None)
         self.my_config.set_user_option('foo', 'bar')
         self.assertEqual(
-            self.my_config.branch.control_files.files['branch.conf'].strip(),
+            self.my_config.branch.control_files.files['branch.conf'], 
             'foo = bar')
         self.assertEqual(self.my_config.get_user_option('foo'), 'bar')
         self.my_config.set_user_option('foo', 'baz',
@@ -959,7 +910,7 @@
         self.assertEqual(self.my_config.get_user_option('foo'), 'baz')
         self.my_config.set_user_option('foo', 'qux')
         self.assertEqual(self.my_config.get_user_option('foo'), 'baz')
-
+        
     def test_get_bzr_remote_path(self):
         my_config = config.LocationConfig('/a/c')
         self.assertEqual('bzr', my_config.get_bzr_remote_path())
@@ -982,7 +933,7 @@
 
 class TestBranchConfigItems(tests.TestCaseInTempDir):
 
-    def get_branch_config(self, global_config=None, location=None,
+    def get_branch_config(self, global_config=None, location=None, 
                           location_config=None, branch_data_config=None):
         my_config = config.BranchConfig(FakeBranch(location))
         if global_config is not None:
@@ -1002,19 +953,20 @@
         my_config = config.BranchConfig(branch)
         self.assertEqual("Robert Collins <robertc@example.net>",
                          my_config.username())
-        my_config.branch.control_files.files['email'] = "John"
-        my_config.set_user_option('email',
+        branch.control_files.email = "John"
+        my_config.set_user_option('email', 
                                   "Robert Collins <robertc@example.org>")
         self.assertEqual("John", my_config.username())
-        del my_config.branch.control_files.files['email']
+        branch.control_files.email = None
         self.assertEqual("Robert Collins <robertc@example.org>",
                          my_config.username())
 
     def test_not_set_in_branch(self):
         my_config = self.get_branch_config(sample_config_text)
+        my_config.branch.control_files.email = None
         self.assertEqual(u"Erik B\u00e5gfors <erik@bagfors.nu>",
                          my_config._get_user_id())
-        my_config.branch.control_files.files['email'] = "John"
+        my_config.branch.control_files.email = "John"
         self.assertEqual("John", my_config._get_user_id())
 
     def test_BZR_EMAIL_OVERRIDES(self):
@@ -1023,7 +975,7 @@
         my_config = config.BranchConfig(branch)
         self.assertEqual("Robert Collins <robertc@example.org>",
                          my_config.username())
-
+    
     def test_signatures_forced(self):
         my_config = self.get_branch_config(
             global_config=sample_always_signatures)
@@ -1073,14 +1025,14 @@
     def test_config_precedence(self):
         my_config = self.get_branch_config(global_config=precedence_global)
         self.assertEqual(my_config.get_user_option('option'), 'global')
-        my_config = self.get_branch_config(global_config=precedence_global,
+        my_config = self.get_branch_config(global_config=precedence_global, 
                                       branch_data_config=precedence_branch)
         self.assertEqual(my_config.get_user_option('option'), 'branch')
-        my_config = self.get_branch_config(global_config=precedence_global,
+        my_config = self.get_branch_config(global_config=precedence_global, 
                                       branch_data_config=precedence_branch,
                                       location_config=precedence_location)
         self.assertEqual(my_config.get_user_option('option'), 'recurse')
-        my_config = self.get_branch_config(global_config=precedence_global,
+        my_config = self.get_branch_config(global_config=precedence_global, 
                                       branch_data_config=precedence_branch,
                                       location_config=precedence_location,
                                       location='http://example.com/specific')
@@ -1137,17 +1089,6 @@
         self.assertRaises(errors.NoEmailInUsername,
                           config.extract_email_address, 'Jane Tester')
 
-    def test_parse_username(self):
-        self.assertEqual(('', 'jdoe@example.com'),
-                         config.parse_username('jdoe@example.com'))
-        self.assertEqual(('', 'jdoe@example.com'),
-                         config.parse_username('<jdoe@example.com>'))
-        self.assertEqual(('John Doe', 'jdoe@example.com'),
-                         config.parse_username('John Doe <jdoe@example.com>'))
-        self.assertEqual(('John Doe', ''),
-                         config.parse_username('John Doe'))
-        self.assertEqual(('John Doe', 'jdoe@example.com'),
-                         config.parse_username('John Doe jdoe@example.com'))
 
 class TestTreeConfig(tests.TestCaseWithTransport):
 
@@ -1177,46 +1118,6 @@
         self.assertEqual(value, 'value3-section')
 
 
-class TestTransportConfig(tests.TestCaseWithTransport):
-
-    def test_get_value(self):
-        """Test that retreiving a value from a section is possible"""
-        bzrdir_config = config.TransportConfig(transport.get_transport('.'),
-                                               'control.conf')
-        bzrdir_config.set_option('value', 'key', 'SECTION')
-        bzrdir_config.set_option('value2', 'key2')
-        bzrdir_config.set_option('value3-top', 'key3')
-        bzrdir_config.set_option('value3-section', 'key3', 'SECTION')
-        value = bzrdir_config.get_option('key', 'SECTION')
-        self.assertEqual(value, 'value')
-        value = bzrdir_config.get_option('key2')
-        self.assertEqual(value, 'value2')
-        self.assertEqual(bzrdir_config.get_option('non-existant'), None)
-        value = bzrdir_config.get_option('non-existant', 'SECTION')
-        self.assertEqual(value, None)
-        value = bzrdir_config.get_option('non-existant', default='default')
-        self.assertEqual(value, 'default')
-        self.assertEqual(bzrdir_config.get_option('key2', 'NOSECTION'), None)
-        value = bzrdir_config.get_option('key2', 'NOSECTION',
-                                         default='default')
-        self.assertEqual(value, 'default')
-        value = bzrdir_config.get_option('key3')
-        self.assertEqual(value, 'value3-top')
-        value = bzrdir_config.get_option('key3', 'SECTION')
-        self.assertEqual(value, 'value3-section')
-
-    def test_set_unset_default_stack_on(self):
-        my_dir = self.make_bzrdir('.')
-        bzrdir_config = config.BzrDirConfig(my_dir.transport)
-        self.assertIs(None, bzrdir_config.get_default_stack_on())
-        bzrdir_config.set_default_stack_on('Foo')
-        self.assertEqual('Foo', bzrdir_config._config.get_option(
-                         'default_stack_on'))
-        self.assertEqual('Foo', bzrdir_config.get_default_stack_on())
-        bzrdir_config.set_default_stack_on(None)
-        self.assertIs(None, bzrdir_config.get_default_stack_on())
-
-
 class TestAuthenticationConfigFile(tests.TestCase):
     """Test the authentication.conf file matching"""
 
@@ -1232,20 +1133,15 @@
         self.assertEquals(expected_user, user)
         self.assertEquals(expected_password, password)
 
-    def test_empty_config(self):
+    def  test_empty_config(self):
         conf = config.AuthenticationConfig(_file=StringIO())
         self.assertEquals({}, conf._get_config())
         self._got_user_passwd(None, None, conf, 'http', 'foo.net')
 
-    def test_missing_auth_section_header(self):
-        conf = config.AuthenticationConfig(_file=StringIO('foo = bar'))
-        self.assertRaises(ValueError, conf.get_credentials, 'ftp', 'foo.net')
-
-    def test_auth_section_header_not_closed(self):
+    def test_broken_config(self):
         conf = config.AuthenticationConfig(_file=StringIO('[DEF'))
         self.assertRaises(errors.ParseConfigError, conf._get_config)
 
-    def test_auth_value_not_boolean(self):
         conf = config.AuthenticationConfig(_file=StringIO(
                 """[broken]
 scheme=ftp
@@ -1253,8 +1149,6 @@
 verify_certificates=askme # Error: Not a boolean
 """))
         self.assertRaises(ValueError, conf.get_credentials, 'ftp', 'foo.net')
-
-    def test_auth_value_not_int(self):
         conf = config.AuthenticationConfig(_file=StringIO(
                 """[broken]
 scheme=ftp
@@ -1379,18 +1273,6 @@
         self._got_user_passwd(None, None,
                               conf, 'http', 'bar.org', user='georges')
 
-    def test_credentials_for_user_without_password(self):
-        conf = config.AuthenticationConfig(_file=StringIO(
-                """
-[without password]
-scheme=http
-host=bar.org
-user=jim
-"""))
-        # Get user but no password
-        self._got_user_passwd('jim', None,
-                              conf, 'http', 'bar.org')
-
     def test_verify_certificates(self):
         conf = config.AuthenticationConfig(_file=StringIO(
                 """
@@ -1454,51 +1336,6 @@
             'SMTP %(user)s@%(host)s:%(port)d password: ',
             'smtp', port=10025)
 
-    def test_ssh_password_emits_warning(self):
-        conf = config.AuthenticationConfig(_file=StringIO(
-                """
-[ssh with password]
-scheme=ssh
-host=bar.org
-user=jim
-password=jimpass
-"""))
-        entered_password = 'typed-by-hand'
-        stdout = tests.StringIOWrapper()
-        ui.ui_factory = tests.TestUIFactory(stdin=entered_password + '\n',
-                                            stdout=stdout)
-
-        # Since the password defined in the authentication config is ignored,
-        # the user is prompted
-        self.assertEquals(entered_password,
-                          conf.get_password('ssh', 'bar.org', user='jim'))
-        self.assertContainsRe(
-            self._get_log(keep_log_file=True),
-            'password ignored in section \[ssh with password\]')
-
-    def test_ssh_without_password_doesnt_emit_warning(self):
-        conf = config.AuthenticationConfig(_file=StringIO(
-                """
-[ssh with password]
-scheme=ssh
-host=bar.org
-user=jim
-"""))
-        entered_password = 'typed-by-hand'
-        stdout = tests.StringIOWrapper()
-        ui.ui_factory = tests.TestUIFactory(stdin=entered_password + '\n',
-                                            stdout=stdout)
-
-        # Since the password defined in the authentication config is ignored,
-        # the user is prompted
-        self.assertEquals(entered_password,
-                          conf.get_password('ssh', 'bar.org', user='jim'))
-        # No warning shoud be emitted since there is no password. We are only
-        # providing "user".
-        self.assertNotContainsRe(
-            self._get_log(keep_log_file=True),
-            'password ignored in section \[ssh with password\]')
-
 
 # FIXME: Once we have a way to declare authentication to all test servers, we
 # can implement generic tests.

=== modified file 'bzrlib/tests/test_conflicts.py'
--- bzrlib/tests/test_conflicts.py	2008-04-24 07:22:53 +0000
+++ bzrlib/tests/test_conflicts.py	2007-07-23 14:51:48 +0000
@@ -20,20 +20,10 @@
 from bzrlib import bzrdir
 from bzrlib.tests import TestCaseWithTransport, TestCase
 from bzrlib.branch import Branch
-from bzrlib.conflicts import (
-    ConflictList,
-    ContentsConflict,
-    DuplicateID,
-    DuplicateEntry,
-    MissingParent,
-    NonDirectoryParent,
-    ParentLoop,
-    PathConflict,
-    TextConflict,
-    UnversionedParent,
-    resolve,
-    restore,
-    )
+from bzrlib.conflicts import (MissingParent, ContentsConflict, TextConflict,
+        PathConflict, DuplicateID, DuplicateEntry, ParentLoop, UnversionedParent,
+        ConflictList, 
+        restore)
 from bzrlib.errors import NotConflicted
 
 
@@ -57,7 +47,6 @@
     ParentLoop('Cancelled move', u'p\xe5the', u'p\xe5th2e',
                None, '\xc3\xaed2e'),
     UnversionedParent('Versioned directory', u'p\xe5thf', '\xc3\xaedf'),
-    NonDirectoryParent('Created directory', u'p\xe5thg', '\xc3\xaedg'),
 ])
 
 
@@ -85,7 +74,7 @@
         restore('hello.sploo')
         self.assertEqual(len(tree.conflicts()), 0)
         self.assertFileEqual('hello world2', 'hello')
-        self.assertFalse(os.path.lexists('hello.sploo'))
+        assert not os.path.lexists('hello.sploo')
         self.assertRaises(NotConflicted, restore, 'hello')
         self.assertRaises(NotConflicted, restore, 'hello.sploo')
 
@@ -126,18 +115,6 @@
                          tree_conflicts.select_conflicts(tree, ['foo'],
                                                          ignore_misses=True))
 
-    def test_resolve_conflicts_recursive(self):
-        tree = self.make_branch_and_tree('.')
-        self.build_tree(['dir/', 'dir/hello'])
-        tree.add(['dir', 'dir/hello'])
-        tree.set_conflicts(ConflictList([TextConflict('dir/hello')]))
-        resolve(tree, ['dir'], recursive=False, ignore_misses=True)
-        self.assertEqual(ConflictList([TextConflict('dir/hello')]),
-                         tree.conflicts())
-        resolve(tree, ['dir'], recursive=True, ignore_misses=True)
-        self.assertEqual(ConflictList([]),
-                         tree.conflicts())
-
 
 class TestConflictStanzas(TestCase):
 

=== modified file 'bzrlib/tests/test_counted_lock.py'
--- bzrlib/tests/test_counted_lock.py	2008-06-05 09:22:59 +0000
+++ bzrlib/tests/test_counted_lock.py	2007-05-02 14:00:53 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007, 2008 Canonical Ltd
+# Copyright (C) 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -19,9 +19,7 @@
 from bzrlib.counted_lock import CountedLock
 from bzrlib.errors import (
     LockError,
-    LockNotHeld,
     ReadOnlyError,
-    TokenMismatch,
     )
 from bzrlib.tests import TestCase
 
@@ -41,13 +39,10 @@
         self._lock_mode = 'r'
         self._calls.append('lock_read')
 
-    def lock_write(self, token=None):
-        if token not in (None, 'token'):
-            raise TokenMismatch(token, 'token')
+    def lock_write(self):
         self._assert_not_locked()
         self._lock_mode = 'w'
         self._calls.append('lock_write')
-        return 'token'
 
     def unlock(self):
         self._assert_locked()
@@ -67,15 +62,6 @@
             raise LockError("%s is already locked in mode %r" %
                 (self, self._lock_mode))
 
-    def validate_token(self, token):
-        if token == 'token':
-            # already held by this caller
-            return 'token'
-        elif token is None:
-            return
-        else:
-            raise TokenMismatch(token, 'token')
-
 
 class TestDummyLock(TestCase):
 
@@ -145,7 +131,7 @@
     def test_unlock_not_locked(self):
         real_lock = DummyLock()
         l = CountedLock(real_lock)
-        self.assertRaises(LockNotHeld, l.unlock)
+        self.assertRaises(LockError, l.unlock)
 
     def test_read_lock_while_write_locked(self):
         real_lock = DummyLock()

=== modified file 'bzrlib/tests/test_decorators.py'
--- bzrlib/tests/test_decorators.py	2008-06-08 17:00:25 +0000
+++ bzrlib/tests/test_decorators.py	2007-01-24 17:59:50 +0000
@@ -20,139 +20,37 @@
 import inspect
 
 from bzrlib import decorators
+from bzrlib.decorators import needs_read_lock, needs_write_lock
 from bzrlib.tests import TestCase
 
 
-def create_decorator_sample(style, except_in_unlock=False):
-    """Create a DecoratorSample object, using specific lock operators.
+class DecoratorSample(object):
+    """Sample class that uses decorators.
 
-    :param style: The type of lock decorators to use (fast/pretty/None)
-    :param except_in_unlock: If True, raise an exception during unlock
-    :return: An instantiated DecoratorSample object.
+    Log when requests go through lock_read()/unlock() or lock_write()/unlock.
     """
 
-    if style is None:
-        # Default
-        needs_read_lock = decorators.needs_read_lock
-        needs_write_lock = decorators.needs_write_lock
-    elif style == 'pretty':
-        needs_read_lock = decorators._pretty_needs_read_lock
-        needs_write_lock = decorators._pretty_needs_write_lock
-    else:
-        needs_read_lock = decorators._fast_needs_read_lock
-        needs_write_lock = decorators._fast_needs_write_lock
-
-    class DecoratorSample(object):
-        """Sample class that uses decorators.
-
-        Log when requests go through lock_read()/unlock() or
-        lock_write()/unlock.
-        """
-
-        def __init__(self):
-            self.actions = []
-
-        def lock_read(self):
-            self.actions.append('lock_read')
-
-        def lock_write(self):
-            self.actions.append('lock_write')
-
-        def unlock(self):
-            if except_in_unlock:
-                self.actions.append('unlock_fail')
-                raise KeyError('during unlock')
-            else:
-                self.actions.append('unlock')
-
-        @needs_read_lock
-        def frob(self):
-            """Frob the sample object"""
-            self.actions.append('frob')
-            return 'newbie'
-
-        @needs_write_lock
-        def bank(self, bar, biz=None):
-            """Bank the sample, but using bar and biz."""
-            self.actions.append(('bank', bar, biz))
-            return (bar, biz)
-
-        @needs_read_lock
-        def fail_during_read(self):
-            self.actions.append('fail_during_read')
-            raise TypeError('during read')
-
-        @needs_write_lock
-        def fail_during_write(self):
-            self.actions.append('fail_during_write')
-            raise TypeError('during write')
-
-    return DecoratorSample()
-
-
-class TestDecoratorActions(TestCase):
-
-    _decorator_style = None # default
-
-    def test_read_lock_locks_and_unlocks(self):
-        sam = create_decorator_sample(self._decorator_style)
-        self.assertEqual('newbie', sam.frob())
-        self.assertEqual(['lock_read', 'frob', 'unlock'], sam.actions)
-
-    def test_write_lock_locks_and_unlocks(self):
-        sam = create_decorator_sample(self._decorator_style)
-        self.assertEqual(('bar', 'bing'), sam.bank('bar', biz='bing'))
-        self.assertEqual(['lock_write', ('bank', 'bar', 'bing'), 'unlock'],
-                         sam.actions)
-
-    def test_read_lock_unlocks_during_failure(self):
-        sam = create_decorator_sample(self._decorator_style)
-        self.assertRaises(TypeError, sam.fail_during_read)
-        self.assertEqual(['lock_read', 'fail_during_read', 'unlock'],
-                         sam.actions)
-
-    def test_write_lock_unlocks_during_failure(self):
-        sam = create_decorator_sample(self._decorator_style)
-        self.assertRaises(TypeError, sam.fail_during_write)
-        self.assertEqual(['lock_write', 'fail_during_write', 'unlock'],
-                         sam.actions)
-
-    def test_read_lock_raises_original_error(self):
-        sam = create_decorator_sample(self._decorator_style,
-                                      except_in_unlock=True)
-        self.assertRaises(TypeError, sam.fail_during_read)
-        self.assertEqual(['lock_read', 'fail_during_read', 'unlock_fail'],
-                         sam.actions)
-
-    def test_write_lock_raises_original_error(self):
-        sam = create_decorator_sample(self._decorator_style,
-                                      except_in_unlock=True)
-        self.assertRaises(TypeError, sam.fail_during_write)
-        self.assertEqual(['lock_write', 'fail_during_write', 'unlock_fail'],
-                         sam.actions)
-
-    def test_read_lock_raises_unlock_error(self):
-        sam = create_decorator_sample(self._decorator_style,
-                                      except_in_unlock=True)
-        self.assertRaises(KeyError, sam.frob)
-        self.assertEqual(['lock_read', 'frob', 'unlock_fail'], sam.actions)
-
-    def test_write_lock_raises_unlock_error(self):
-        sam = create_decorator_sample(self._decorator_style,
-                                      except_in_unlock=True)
-        self.assertRaises(KeyError, sam.bank, 'bar', biz='bing')
-        self.assertEqual(['lock_write', ('bank', 'bar', 'bing'),
-                          'unlock_fail'], sam.actions)
-
-
-class TestFastDecoratorActions(TestDecoratorActions):
-
-    _decorator_style = 'fast'
-
-
-class TestPrettyDecoratorActions(TestDecoratorActions):
-
-    _decorator_style = 'pretty'
+    def __init__(self):
+        self.actions = []
+
+    def lock_read(self):
+        self.actions.append('lock_read')
+
+    def lock_write(self):
+        self.actions.append('lock_write')
+
+    def unlock(self):
+        self.actions.append('unlock')
+
+    @needs_read_lock
+    def frob(self):
+        """Frob the sample object"""
+        self.actions.append('frob')
+
+    @needs_write_lock
+    def bank(self, bar, biz=None):
+        """Bank the sample, but using bar and biz."""
+        self.actions.append(('bank', bar, biz))
 
 
 class TestDecoratorDocs(TestCase):
@@ -160,20 +58,20 @@
 
     def test_read_lock_passthrough(self):
         """@needs_read_lock exposes underlying name and doc."""
-        sam = create_decorator_sample(None)
+        sam = DecoratorSample()
         self.assertEqual('frob', sam.frob.__name__)
         self.assertEqual('Frob the sample object', sam.frob.__doc__)
 
     def test_write_lock_passthrough(self):
         """@needs_write_lock exposes underlying name and doc."""
-        sam = create_decorator_sample(None)
+        sam = DecoratorSample()
         self.assertEqual('bank', sam.bank.__name__)
         self.assertEqual('Bank the sample, but using bar and biz.',
                          sam.bank.__doc__)
 
     def test_argument_passthrough(self):
         """Test that arguments get passed around properly."""
-        sam = create_decorator_sample(None)
+        sam = DecoratorSample()
         sam.bank('1', biz='2')
         self.assertEqual(['lock_write',
                           ('bank', '1', '2'),

=== modified file 'bzrlib/tests/test_diff.py'
--- bzrlib/tests/test_diff.py	2008-08-23 13:06:24 +0000
+++ bzrlib/tests/test_diff.py	2007-09-04 09:10:35 +0000
@@ -15,50 +15,20 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 import os
-import os.path
 from cStringIO import StringIO
 import errno
 import subprocess
-import sys
 from tempfile import TemporaryFile
 
-from bzrlib import tests
-from bzrlib.diff import (
-    DiffFromTool,
-    DiffPath,
-    DiffSymlink,
-    DiffTree,
-    DiffText,
-    external_diff,
-    internal_diff,
-    show_diff_trees,
-    )
-from bzrlib.errors import BinaryFile, NoDiff, ExecutableMissing
+from bzrlib.diff import internal_diff, external_diff, show_diff_trees
+from bzrlib.errors import BinaryFile, NoDiff
 import bzrlib.osutils as osutils
-import bzrlib.transform as transform
 import bzrlib.patiencediff
 import bzrlib._patiencediff_py
 from bzrlib.tests import (Feature, TestCase, TestCaseWithTransport,
                           TestCaseInTempDir, TestSkipped)
 
 
-class _AttribFeature(Feature):
-
-    def _probe(self):
-        if (sys.platform not in ('cygwin', 'win32')):
-            return False
-        try:
-            proc = subprocess.Popen(['attrib', '.'], stdout=subprocess.PIPE)
-        except OSError, e:
-            return False
-        return (0 == proc.wait())
-
-    def feature_name(self):
-        return 'attrib Windows command-line tool'
-
-AttribFeature = _AttribFeature()
-
-
 class _CompiledPatienceDiffFeature(Feature):
 
     def _probe(self):
@@ -74,6 +44,35 @@
 CompiledPatienceDiffFeature = _CompiledPatienceDiffFeature()
 
 
+class _UnicodeFilename(Feature):
+    """Does the filesystem support Unicode filenames?"""
+
+    def _probe(self):
+        try:
+            os.stat(u'\u03b1')
+        except UnicodeEncodeError:
+            return False
+        except (IOError, OSError):
+            # The filesystem allows the Unicode filename but the file doesn't
+            # exist.
+            return True
+        else:
+            # The filesystem allows the Unicode filename and the file exists,
+            # for some reason.
+            return True
+
+UnicodeFilename = _UnicodeFilename()
+
+
+class TestUnicodeFilename(TestCase):
+
+    def test_probe_passes(self):
+        """UnicodeFilename._probe passes."""
+        # We can't test much more than that because the behaviour depends
+        # on the platform.
+        UnicodeFilename._probe()
+        
+
 def udiff_lines(old, new, allow_binary=False):
     output = StringIO()
     internal_diff('old', old, 'new', new, output, allow_binary)
@@ -232,18 +231,6 @@
                           ]
                           , lines)
 
-    def test_internal_diff_no_content(self):
-        output = StringIO()
-        internal_diff(u'old', [], u'new', [], output)
-        self.assertEqual('', output.getvalue())
-
-    def test_internal_diff_no_changes(self):
-        output = StringIO()
-        internal_diff(u'old', ['text\n', 'contents\n'],
-                      u'new', ['text\n', 'contents\n'],
-                      output)
-        self.assertEqual('', output.getvalue())
-
     def test_internal_diff_returns_bytes(self):
         import StringIO
         output = StringIO.StringIO()
@@ -499,45 +486,12 @@
         self.assertContainsRe(diff, '-contents\n'
                                     '\\+new contents\n')
 
-
-    def test_internal_diff_exec_property(self):
-        tree = self.make_branch_and_tree('tree')
-
-        tt = transform.TreeTransform(tree)
-        tt.new_file('a', tt.root, 'contents\n', 'a-id', True)
-        tt.new_file('b', tt.root, 'contents\n', 'b-id', False)
-        tt.new_file('c', tt.root, 'contents\n', 'c-id', True)
-        tt.new_file('d', tt.root, 'contents\n', 'd-id', False)
-        tt.new_file('e', tt.root, 'contents\n', 'control-e-id', True)
-        tt.new_file('f', tt.root, 'contents\n', 'control-f-id', False)
-        tt.apply()
-        tree.commit('one', rev_id='rev-1')
-
-        tt = transform.TreeTransform(tree)
-        tt.set_executability(False, tt.trans_id_file_id('a-id'))
-        tt.set_executability(True, tt.trans_id_file_id('b-id'))
-        tt.set_executability(False, tt.trans_id_file_id('c-id'))
-        tt.set_executability(True, tt.trans_id_file_id('d-id'))
-        tt.apply()
-        tree.rename_one('c', 'new-c')
-        tree.rename_one('d', 'new-d')
-
-        diff = self.get_diff(tree.basis_tree(), tree)
-
-        self.assertContainsRe(diff, r"file 'a'.*\(properties changed:.*\+x to -x.*\)")
-        self.assertContainsRe(diff, r"file 'b'.*\(properties changed:.*-x to \+x.*\)")
-        self.assertContainsRe(diff, r"file 'c'.*\(properties changed:.*\+x to -x.*\)")
-        self.assertContainsRe(diff, r"file 'd'.*\(properties changed:.*-x to \+x.*\)")
-        self.assertNotContainsRe(diff, r"file 'e'")
-        self.assertNotContainsRe(diff, r"file 'f'")
-
-
     def test_binary_unicode_filenames(self):
         """Test that contents of files are *not* encoded in UTF-8 when there
         is a binary file in the diff.
         """
         # See https://bugs.launchpad.net/bugs/110092.
-        self.requireFeature(tests.UnicodeFilenameFeature)
+        self.requireFeature(UnicodeFilename)
 
         # This bug isn't triggered with cStringIO.
         from StringIO import StringIO
@@ -562,7 +516,7 @@
 
     def test_unicode_filename(self):
         """Test when the filename are unicode."""
-        self.requireFeature(tests.UnicodeFilenameFeature)
+        self.requireFeature(UnicodeFilename)
 
         alpha, omega = u'\u03b1', u'\u03c9'
         autf8, outf8 = alpha.encode('utf8'), omega.encode('utf8')
@@ -590,176 +544,6 @@
         self.assertContainsRe(diff, "=== modified file 'mod_%s'"%autf8)
         self.assertContainsRe(diff, "=== removed file 'del_%s'"%autf8)
 
-
-class DiffWasIs(DiffPath):
-
-    def diff(self, file_id, old_path, new_path, old_kind, new_kind):
-        self.to_file.write('was: ')
-        self.to_file.write(self.old_tree.get_file(file_id).read())
-        self.to_file.write('is: ')
-        self.to_file.write(self.new_tree.get_file(file_id).read())
-        pass
-
-
-class TestDiffTree(TestCaseWithTransport):
-
-    def setUp(self):
-        TestCaseWithTransport.setUp(self)
-        self.old_tree = self.make_branch_and_tree('old-tree')
-        self.old_tree.lock_write()
-        self.addCleanup(self.old_tree.unlock)
-        self.new_tree = self.make_branch_and_tree('new-tree')
-        self.new_tree.lock_write()
-        self.addCleanup(self.new_tree.unlock)
-        self.differ = DiffTree(self.old_tree, self.new_tree, StringIO())
-
-    def test_diff_text(self):
-        self.build_tree_contents([('old-tree/olddir/',),
-                                  ('old-tree/olddir/oldfile', 'old\n')])
-        self.old_tree.add('olddir')
-        self.old_tree.add('olddir/oldfile', 'file-id')
-        self.build_tree_contents([('new-tree/newdir/',),
-                                  ('new-tree/newdir/newfile', 'new\n')])
-        self.new_tree.add('newdir')
-        self.new_tree.add('newdir/newfile', 'file-id')
-        differ = DiffText(self.old_tree, self.new_tree, StringIO())
-        differ.diff_text('file-id', None, 'old label', 'new label')
-        self.assertEqual(
-            '--- old label\n+++ new label\n@@ -1,1 +0,0 @@\n-old\n\n',
-            differ.to_file.getvalue())
-        differ.to_file.seek(0)
-        differ.diff_text(None, 'file-id', 'old label', 'new label')
-        self.assertEqual(
-            '--- old label\n+++ new label\n@@ -0,0 +1,1 @@\n+new\n\n',
-            differ.to_file.getvalue())
-        differ.to_file.seek(0)
-        differ.diff_text('file-id', 'file-id', 'old label', 'new label')
-        self.assertEqual(
-            '--- old label\n+++ new label\n@@ -1,1 +1,1 @@\n-old\n+new\n\n',
-            differ.to_file.getvalue())
-
-    def test_diff_deletion(self):
-        self.build_tree_contents([('old-tree/file', 'contents'),
-                                  ('new-tree/file', 'contents')])
-        self.old_tree.add('file', 'file-id')
-        self.new_tree.add('file', 'file-id')
-        os.unlink('new-tree/file')
-        self.differ.show_diff(None)
-        self.assertContainsRe(self.differ.to_file.getvalue(), '-contents')
-
-    def test_diff_creation(self):
-        self.build_tree_contents([('old-tree/file', 'contents'),
-                                  ('new-tree/file', 'contents')])
-        self.old_tree.add('file', 'file-id')
-        self.new_tree.add('file', 'file-id')
-        os.unlink('old-tree/file')
-        self.differ.show_diff(None)
-        self.assertContainsRe(self.differ.to_file.getvalue(), '\+contents')
-
-    def test_diff_symlink(self):
-        differ = DiffSymlink(self.old_tree, self.new_tree, StringIO())
-        differ.diff_symlink('old target', None)
-        self.assertEqual("=== target was 'old target'\n",
-                         differ.to_file.getvalue())
-
-        differ = DiffSymlink(self.old_tree, self.new_tree, StringIO())
-        differ.diff_symlink(None, 'new target')
-        self.assertEqual("=== target is 'new target'\n",
-                         differ.to_file.getvalue())
-
-        differ = DiffSymlink(self.old_tree, self.new_tree, StringIO())
-        differ.diff_symlink('old target', 'new target')
-        self.assertEqual("=== target changed 'old target' => 'new target'\n",
-                         differ.to_file.getvalue())
-
-    def test_diff(self):
-        self.build_tree_contents([('old-tree/olddir/',),
-                                  ('old-tree/olddir/oldfile', 'old\n')])
-        self.old_tree.add('olddir')
-        self.old_tree.add('olddir/oldfile', 'file-id')
-        self.build_tree_contents([('new-tree/newdir/',),
-                                  ('new-tree/newdir/newfile', 'new\n')])
-        self.new_tree.add('newdir')
-        self.new_tree.add('newdir/newfile', 'file-id')
-        self.differ.diff('file-id', 'olddir/oldfile', 'newdir/newfile')
-        self.assertContainsRe(
-            self.differ.to_file.getvalue(),
-            r'--- olddir/oldfile.*\n\+\+\+ newdir/newfile.*\n\@\@ -1,1 \+1,1'
-             ' \@\@\n-old\n\+new\n\n')
-
-    def test_diff_kind_change(self):
-        self.requireFeature(tests.SymlinkFeature)
-        self.build_tree_contents([('old-tree/olddir/',),
-                                  ('old-tree/olddir/oldfile', 'old\n')])
-        self.old_tree.add('olddir')
-        self.old_tree.add('olddir/oldfile', 'file-id')
-        self.build_tree(['new-tree/newdir/'])
-        os.symlink('new', 'new-tree/newdir/newfile')
-        self.new_tree.add('newdir')
-        self.new_tree.add('newdir/newfile', 'file-id')
-        self.differ.diff('file-id', 'olddir/oldfile', 'newdir/newfile')
-        self.assertContainsRe(
-            self.differ.to_file.getvalue(),
-            r'--- olddir/oldfile.*\n\+\+\+ newdir/newfile.*\n\@\@ -1,1 \+0,0'
-             ' \@\@\n-old\n\n')
-        self.assertContainsRe(self.differ.to_file.getvalue(),
-                              "=== target is 'new'\n")
-
-    def test_diff_directory(self):
-        self.build_tree(['new-tree/new-dir/'])
-        self.new_tree.add('new-dir', 'new-dir-id')
-        self.differ.diff('new-dir-id', None, 'new-dir')
-        self.assertEqual(self.differ.to_file.getvalue(), '')
-
-    def create_old_new(self):
-        self.build_tree_contents([('old-tree/olddir/',),
-                                  ('old-tree/olddir/oldfile', 'old\n')])
-        self.old_tree.add('olddir')
-        self.old_tree.add('olddir/oldfile', 'file-id')
-        self.build_tree_contents([('new-tree/newdir/',),
-                                  ('new-tree/newdir/newfile', 'new\n')])
-        self.new_tree.add('newdir')
-        self.new_tree.add('newdir/newfile', 'file-id')
-
-    def test_register_diff(self):
-        self.create_old_new()
-        old_diff_factories = DiffTree.diff_factories
-        DiffTree.diff_factories=old_diff_factories[:]
-        DiffTree.diff_factories.insert(0, DiffWasIs.from_diff_tree)
-        try:
-            differ = DiffTree(self.old_tree, self.new_tree, StringIO())
-        finally:
-            DiffTree.diff_factories = old_diff_factories
-        differ.diff('file-id', 'olddir/oldfile', 'newdir/newfile')
-        self.assertNotContainsRe(
-            differ.to_file.getvalue(),
-            r'--- olddir/oldfile.*\n\+\+\+ newdir/newfile.*\n\@\@ -1,1 \+1,1'
-             ' \@\@\n-old\n\+new\n\n')
-        self.assertContainsRe(differ.to_file.getvalue(),
-                              'was: old\nis: new\n')
-
-    def test_extra_factories(self):
-        self.create_old_new()
-        differ = DiffTree(self.old_tree, self.new_tree, StringIO(),
-                            extra_factories=[DiffWasIs.from_diff_tree])
-        differ.diff('file-id', 'olddir/oldfile', 'newdir/newfile')
-        self.assertNotContainsRe(
-            differ.to_file.getvalue(),
-            r'--- olddir/oldfile.*\n\+\+\+ newdir/newfile.*\n\@\@ -1,1 \+1,1'
-             ' \@\@\n-old\n\+new\n\n')
-        self.assertContainsRe(differ.to_file.getvalue(),
-                              'was: old\nis: new\n')
-
-    def test_alphabetical_order(self):
-        self.build_tree(['new-tree/a-file'])
-        self.new_tree.add('a-file')
-        self.build_tree(['old-tree/b-file'])
-        self.old_tree.add('b-file')
-        self.differ.show_diff(None)
-        self.assertContainsRe(self.differ.to_file.getvalue(),
-            '.*a-file(.|\n)*b-file')
-
-
 class TestPatienceDiffLib(TestCase):
 
     def setUp(self):
@@ -769,13 +553,6 @@
         self._PatienceSequenceMatcher = \
             bzrlib._patiencediff_py.PatienceSequenceMatcher_py
 
-    def test_diff_unicode_string(self):
-        a = ''.join([unichr(i) for i in range(4000, 4500, 3)])
-        b = ''.join([unichr(i) for i in range(4300, 4800, 2)])
-        sm = self._PatienceSequenceMatcher(None, a, b)
-        mb = sm.get_matching_blocks()
-        self.assertEquals(35, len(mb))
-
     def test_unique_lcs(self):
         unique_lcs = self._unique_lcs
         self.assertEquals(unique_lcs('', ''), [])
@@ -817,43 +594,37 @@
         # This is what it currently gives:
         test_one('aBccDe', 'abccde', [(0,0), (5,5)])
 
-    def assertDiffBlocks(self, a, b, expected_blocks):
-        """Check that the sequence matcher returns the correct blocks.
-
-        :param a: A sequence to match
-        :param b: Another sequence to match
-        :param expected_blocks: The expected output, not including the final
-            matching block (len(a), len(b), 0)
-        """
-        matcher = self._PatienceSequenceMatcher(None, a, b)
-        blocks = matcher.get_matching_blocks()
-        last = blocks.pop()
-        self.assertEqual((len(a), len(b), 0), last)
-        self.assertEqual(expected_blocks, blocks)
-
     def test_matching_blocks(self):
+        def chk_blocks(a, b, expected_blocks):
+            # difflib always adds a signature of the total
+            # length, with no matching entries at the end
+            s = self._PatienceSequenceMatcher(None, a, b)
+            blocks = s.get_matching_blocks()
+            self.assertEquals((len(a), len(b), 0), blocks[-1])
+            self.assertEquals(expected_blocks, blocks[:-1])
+
         # Some basic matching tests
-        self.assertDiffBlocks('', '', [])
-        self.assertDiffBlocks([], [], [])
-        self.assertDiffBlocks('abc', '', [])
-        self.assertDiffBlocks('', 'abc', [])
-        self.assertDiffBlocks('abcd', 'abcd', [(0, 0, 4)])
-        self.assertDiffBlocks('abcd', 'abce', [(0, 0, 3)])
-        self.assertDiffBlocks('eabc', 'abce', [(1, 0, 3)])
-        self.assertDiffBlocks('eabce', 'abce', [(1, 0, 4)])
-        self.assertDiffBlocks('abcde', 'abXde', [(0, 0, 2), (3, 3, 2)])
-        self.assertDiffBlocks('abcde', 'abXYZde', [(0, 0, 2), (3, 5, 2)])
-        self.assertDiffBlocks('abde', 'abXYZde', [(0, 0, 2), (2, 5, 2)])
-        # This may check too much, but it checks to see that
+        chk_blocks('', '', [])
+        chk_blocks([], [], [])
+        chk_blocks('abc', '', [])
+        chk_blocks('', 'abc', [])
+        chk_blocks('abcd', 'abcd', [(0, 0, 4)])
+        chk_blocks('abcd', 'abce', [(0, 0, 3)])
+        chk_blocks('eabc', 'abce', [(1, 0, 3)])
+        chk_blocks('eabce', 'abce', [(1, 0, 4)])
+        chk_blocks('abcde', 'abXde', [(0, 0, 2), (3, 3, 2)])
+        chk_blocks('abcde', 'abXYZde', [(0, 0, 2), (3, 5, 2)])
+        chk_blocks('abde', 'abXYZde', [(0, 0, 2), (2, 5, 2)])
+        # This may check too much, but it checks to see that 
         # a copied block stays attached to the previous section,
         # not the later one.
         # difflib would tend to grab the trailing longest match
         # which would make the diff not look right
-        self.assertDiffBlocks('abcdefghijklmnop', 'abcdefxydefghijklmnop',
-                              [(0, 0, 6), (6, 11, 10)])
+        chk_blocks('abcdefghijklmnop', 'abcdefxydefghijklmnop',
+                   [(0, 0, 6), (6, 11, 10)])
 
         # make sure it supports passing in lists
-        self.assertDiffBlocks(
+        chk_blocks(
                    ['hello there\n',
                     'world\n',
                     'how are you today?\n'],
@@ -863,45 +634,21 @@
 
         # non unique lines surrounded by non-matching lines
         # won't be found
-        self.assertDiffBlocks('aBccDe', 'abccde', [(0,0,1), (5,5,1)])
+        chk_blocks('aBccDe', 'abccde', [(0,0,1), (5,5,1)])
 
         # But they only need to be locally unique
-        self.assertDiffBlocks('aBcDec', 'abcdec', [(0,0,1), (2,2,1), (4,4,2)])
+        chk_blocks('aBcDec', 'abcdec', [(0,0,1), (2,2,1), (4,4,2)])
 
         # non unique blocks won't be matched
-        self.assertDiffBlocks('aBcdEcdFg', 'abcdecdfg', [(0,0,1), (8,8,1)])
+        chk_blocks('aBcdEcdFg', 'abcdecdfg', [(0,0,1), (8,8,1)])
 
         # but locally unique ones will
-        self.assertDiffBlocks('aBcdEeXcdFg', 'abcdecdfg', [(0,0,1), (2,2,2),
+        chk_blocks('aBcdEeXcdFg', 'abcdecdfg', [(0,0,1), (2,2,2),
                                               (5,4,1), (7,5,2), (10,8,1)])
 
-        self.assertDiffBlocks('abbabbXd', 'cabbabxd', [(7,7,1)])
-        self.assertDiffBlocks('abbabbbb', 'cabbabbc', [])
-        self.assertDiffBlocks('bbbbbbbb', 'cbbbbbbc', [])
-
-    def test_matching_blocks_tuples(self):
-        # Some basic matching tests
-        self.assertDiffBlocks([], [], [])
-        self.assertDiffBlocks([('a',), ('b',), ('c,')], [], [])
-        self.assertDiffBlocks([], [('a',), ('b',), ('c,')], [])
-        self.assertDiffBlocks([('a',), ('b',), ('c,')],
-                              [('a',), ('b',), ('c,')],
-                              [(0, 0, 3)])
-        self.assertDiffBlocks([('a',), ('b',), ('c,')],
-                              [('a',), ('b',), ('d,')],
-                              [(0, 0, 2)])
-        self.assertDiffBlocks([('d',), ('b',), ('c,')],
-                              [('a',), ('b',), ('c,')],
-                              [(1, 1, 2)])
-        self.assertDiffBlocks([('d',), ('a',), ('b',), ('c,')],
-                              [('a',), ('b',), ('c,')],
-                              [(1, 0, 3)])
-        self.assertDiffBlocks([('a', 'b'), ('c', 'd'), ('e', 'f')],
-                              [('a', 'b'), ('c', 'X'), ('e', 'f')],
-                              [(0, 0, 1), (2, 2, 1)])
-        self.assertDiffBlocks([('a', 'b'), ('c', 'd'), ('e', 'f')],
-                              [('a', 'b'), ('c', 'dX'), ('e', 'f')],
-                              [(0, 0, 1), (2, 2, 1)])
+        chk_blocks('abbabbXd', 'cabbabxd', [(7,7,1)])
+        chk_blocks('abbabbbb', 'cabbabbc', [])
+        chk_blocks('bbbbbbbb', 'cbbbbbbc', [])
 
     def test_opcodes(self):
         def chk_ops(a, b, expected_codes):
@@ -1019,16 +766,25 @@
     def test_multiple_ranges(self):
         # There was an earlier bug where we used a bad set of ranges,
         # this triggers that specific bug, to make sure it doesn't regress
-        self.assertDiffBlocks('abcdefghijklmnop',
-                              'abcXghiYZQRSTUVWXYZijklmnop',
-                              [(0, 0, 3), (6, 4, 3), (9, 20, 7)])
-
-        self.assertDiffBlocks('ABCd efghIjk  L',
-                              'AxyzBCn mo pqrstuvwI1 2  L',
-                              [(0,0,1), (1, 4, 2), (9, 19, 1), (12, 23, 3)])
+        def chk_blocks(a, b, expected_blocks):
+            # difflib always adds a signature of the total
+            # length, with no matching entries at the end
+            s = self._PatienceSequenceMatcher(None, a, b)
+            blocks = s.get_matching_blocks()
+            x = blocks.pop()
+            self.assertEquals(x, (len(a), len(b), 0))
+            self.assertEquals(expected_blocks, blocks)
+
+        chk_blocks('abcdefghijklmnop'
+                 , 'abcXghiYZQRSTUVWXYZijklmnop'
+                 , [(0, 0, 3), (6, 4, 3), (9, 20, 7)])
+
+        chk_blocks('ABCd efghIjk  L'
+                 , 'AxyzBCn mo pqrstuvwI1 2  L'
+                 , [(0,0,1), (1, 4, 2), (9, 19, 1), (12, 23, 3)])
 
         # These are rot13 code snippets.
-        self.assertDiffBlocks('''\
+        chk_blocks('''\
     trg nqqrq jura lbh nqq n svyr va gur qverpgbel.
     """
     gnxrf_netf = ['svyr*']
@@ -1141,19 +897,6 @@
         self._PatienceSequenceMatcher = \
             bzrlib._patiencediff_c.PatienceSequenceMatcher_c
 
-    def test_unhashable(self):
-        """We should get a proper exception here."""
-        # We need to be able to hash items in the sequence, lists are
-        # unhashable, and thus cannot be diffed
-        e = self.assertRaises(TypeError, self._PatienceSequenceMatcher,
-                                         None, [[]], [])
-        e = self.assertRaises(TypeError, self._PatienceSequenceMatcher,
-                                         None, ['valid', []], [])
-        e = self.assertRaises(TypeError, self._PatienceSequenceMatcher,
-                                         None, ['valid'], [[]])
-        e = self.assertRaises(TypeError, self._PatienceSequenceMatcher,
-                                         None, ['valid'], ['valid', []])
-
 
 class TestPatienceDiffLibFiles(TestCaseInTempDir):
 
@@ -1267,96 +1010,3 @@
             from bzrlib._patiencediff_py import recurse_matches_py
             self.assertIs(recurse_matches_py,
                           bzrlib.patiencediff.recurse_matches)
-
-
-class TestDiffFromTool(TestCaseWithTransport):
-
-    def test_from_string(self):
-        diff_obj = DiffFromTool.from_string('diff', None, None, None)
-        self.addCleanup(diff_obj.finish)
-        self.assertEqual(['diff', '%(old_path)s', '%(new_path)s'],
-            diff_obj.command_template)
-
-    def test_from_string_u5(self):
-        diff_obj = DiffFromTool.from_string('diff -u\\ 5', None, None, None)
-        self.addCleanup(diff_obj.finish)
-        self.assertEqual(['diff', '-u 5', '%(old_path)s', '%(new_path)s'],
-                         diff_obj.command_template)
-        self.assertEqual(['diff', '-u 5', 'old-path', 'new-path'],
-                         diff_obj._get_command('old-path', 'new-path'))
-
-    def test_execute(self):
-        output = StringIO()
-        diff_obj = DiffFromTool(['python', '-c',
-                                 'print "%(old_path)s %(new_path)s"'],
-                                None, None, output)
-        self.addCleanup(diff_obj.finish)
-        diff_obj._execute('old', 'new')
-        self.assertEqual(output.getvalue().rstrip(), 'old new')
-
-    def test_excute_missing(self):
-        diff_obj = DiffFromTool(['a-tool-which-is-unlikely-to-exist'],
-                                None, None, None)
-        self.addCleanup(diff_obj.finish)
-        e = self.assertRaises(ExecutableMissing, diff_obj._execute, 'old',
-                              'new')
-        self.assertEqual('a-tool-which-is-unlikely-to-exist could not be found'
-                         ' on this machine', str(e))
-
-    def test_prepare_files_creates_paths_readable_by_windows_tool(self):
-        self.requireFeature(AttribFeature)
-        output = StringIO()
-        tree = self.make_branch_and_tree('tree')
-        self.build_tree_contents([('tree/file', 'content')])
-        tree.add('file', 'file-id')
-        tree.commit('old tree')
-        tree.lock_read()
-        self.addCleanup(tree.unlock)
-        diff_obj = DiffFromTool(['python', '-c',
-                                 'print "%(old_path)s %(new_path)s"'],
-                                tree, tree, output)
-        diff_obj._prepare_files('file-id', 'file', 'file')
-        self.assertReadableByAttrib(diff_obj._root, 'old\\file', r'old\\file')
-        self.assertReadableByAttrib(diff_obj._root, 'new\\file', r'new\\file')
-
-    def assertReadableByAttrib(self, cwd, relpath, regex):
-        proc = subprocess.Popen(['attrib', relpath],
-                                stdout=subprocess.PIPE,
-                                cwd=cwd)
-        proc.wait()
-        result = proc.stdout.read()
-        self.assertContainsRe(result, regex)
-
-    def test_prepare_files(self):
-        output = StringIO()
-        tree = self.make_branch_and_tree('tree')
-        self.build_tree_contents([('tree/oldname', 'oldcontent')])
-        self.build_tree_contents([('tree/oldname2', 'oldcontent2')])
-        tree.add('oldname', 'file-id')
-        tree.add('oldname2', 'file2-id')
-        tree.commit('old tree', timestamp=0)
-        tree.rename_one('oldname', 'newname')
-        tree.rename_one('oldname2', 'newname2')
-        self.build_tree_contents([('tree/newname', 'newcontent')])
-        self.build_tree_contents([('tree/newname2', 'newcontent2')])
-        old_tree = tree.basis_tree()
-        old_tree.lock_read()
-        self.addCleanup(old_tree.unlock)
-        tree.lock_read()
-        self.addCleanup(tree.unlock)
-        diff_obj = DiffFromTool(['python', '-c',
-                                 'print "%(old_path)s %(new_path)s"'],
-                                old_tree, tree, output)
-        self.addCleanup(diff_obj.finish)
-        self.assertContainsRe(diff_obj._root, 'bzr-diff-[^/]*')
-        old_path, new_path = diff_obj._prepare_files('file-id', 'oldname',
-                                                     'newname')
-        self.assertContainsRe(old_path, 'old/oldname$')
-        self.assertEqual(0, os.stat(old_path).st_mtime)
-        self.assertContainsRe(new_path, 'new/newname$')
-        self.assertFileEqual('oldcontent', old_path)
-        self.assertFileEqual('newcontent', new_path)
-        if osutils.host_os_dereferences_symlinks():
-            self.assertTrue(os.path.samefile('tree/newname', new_path))
-        # make sure we can create files with the same parent directories
-        diff_obj._prepare_files('file2-id', 'oldname2', 'newname2')

=== removed file 'bzrlib/tests/test_directory_service.py'
--- bzrlib/tests/test_directory_service.py	2008-06-26 06:03:36 +0000
+++ bzrlib/tests/test_directory_service.py	1970-01-01 00:00:00 +0000
@@ -1,97 +0,0 @@
-# Copyright (C) 2008 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Test directory service implementation"""
-
-from bzrlib import errors
-from bzrlib.directory_service import DirectoryServiceRegistry, directories
-from bzrlib.tests import TestCase, TestCaseWithTransport
-from bzrlib.transport import get_transport
-
-
-class FooService(object):
-    """A directory service that maps the name to a FILE url"""
-
-    def look_up(self, name, url):
-        return 'file:///foo' + name
-
-
-class TestDirectoryLookup(TestCase):
-
-    def setUp(self):
-        TestCase.setUp(self)
-        self.registry = DirectoryServiceRegistry()
-        self.registry.register('foo:', FooService, 'Map foo URLs to http urls')
-
-    def test_get_directory_service(self):
-        directory, suffix = self.registry.get_prefix('foo:bar')
-        self.assertIs(FooService, directory)
-        self.assertEqual('bar', suffix)
-
-    def test_dereference(self):
-        self.assertEqual('file:///foobar',
-                         self.registry.dereference('foo:bar'))
-        self.assertEqual('baz:qux', self.registry.dereference('baz:qux'))
-
-    def test_get_transport(self):
-        directories.register('foo:', FooService, 'Map foo URLs to http urls')
-        self.addCleanup(lambda: directories.remove('foo:'))
-        self.assertEqual('file:///foobar/', get_transport('foo:bar').base)
-
-
-class TestAliasDirectory(TestCaseWithTransport):
-
-    def test_lookup_parent(self):
-        branch = self.make_branch('.')
-        branch.set_parent('http://a')
-        self.assertEqual('http://a', directories.dereference(':parent'))
-
-    def test_lookup_submit(self):
-        branch = self.make_branch('.')
-        branch.set_submit_branch('http://b')
-        self.assertEqual('http://b', directories.dereference(':submit'))
-
-    def test_lookup_public(self):
-        branch = self.make_branch('.')
-        branch.set_public_branch('http://c')
-        self.assertEqual('http://c', directories.dereference(':public'))
-
-    def test_lookup_bound(self):
-        branch = self.make_branch('.')
-        branch.set_bound_location('http://d')
-        self.assertEqual('http://d', directories.dereference(':bound'))
-
-    def test_lookup_push(self):
-        branch = self.make_branch('.')
-        branch.set_push_location('http://e')
-        self.assertEqual('http://e', directories.dereference(':push'))
-
-    def test_lookup_this(self):
-        branch = self.make_branch('.')
-        self.assertEqual(branch.base, directories.dereference(':this'))
-
-    def test_lookup_badname(self):
-        branch = self.make_branch('.')
-        e = self.assertRaises(errors.InvalidLocationAlias,
-                              directories.dereference, ':booga')
-        self.assertEqual('":booga" is not a valid location alias.',
-                         str(e))
-
-    def test_lookup_badvalue(self):
-        branch = self.make_branch('.')
-        e = self.assertRaises(errors.UnsetLocationAlias,
-                              directories.dereference, ':parent')
-        self.assertEqual('No parent location assigned.', str(e))

=== modified file 'bzrlib/tests/test_dirstate.py'
--- bzrlib/tests/test_dirstate.py	2008-06-05 21:47:39 +0000
+++ bzrlib/tests/test_dirstate.py	2007-10-10 00:07:04 +0000
@@ -23,14 +23,14 @@
 from bzrlib import (
     dirstate,
     errors,
-    inventory,
     osutils,
     )
 from bzrlib.memorytree import MemoryTree
+from bzrlib.osutils import has_symlinks
 from bzrlib.tests import (
-        SymlinkFeature,
         TestCase,
         TestCaseWithTransport,
+        TestSkipped,
         )
 
 
@@ -163,7 +163,7 @@
         """
         # The state should already be write locked, since we just had to do
         # some operation to get here.
-        self.assertTrue(state._lock_token is not None)
+        assert state._lock_token is not None
         try:
             self.assertEqual(expected_result[0],  state.get_parent_ids())
             # there should be no ghosts in this tree.
@@ -360,7 +360,7 @@
         # There are no files on disk and no parents
         tree = self.make_branch_and_tree('tree')
         expected_result = ([], [
-            (('', '', tree.get_root_id()), # common details
+            (('', '', tree.path2id('')), # common details
              [('d', '', 0, False, dirstate.DirState.NULLSTAT), # current tree
              ])])
         state = dirstate.DirState.from_tree(tree, 'dirstate')
@@ -373,7 +373,7 @@
         rev_id = tree.commit('first post').encode('utf8')
         root_stat_pack = dirstate.pack_stat(os.stat(tree.basedir))
         expected_result = ([rev_id], [
-            (('', '', tree.get_root_id()), # common details
+            (('', '', tree.path2id('')), # common details
              [('d', '', 0, False, dirstate.DirState.NULLSTAT), # current tree
               ('d', '', 0, False, rev_id), # first parent details
              ])])
@@ -393,7 +393,7 @@
         rev_id2 = tree2.commit('second post', allow_pointless=True)
         tree.merge_from_branch(tree2.branch)
         expected_result = ([rev_id, rev_id2], [
-            (('', '', tree.get_root_id()), # common details
+            (('', '', tree.path2id('')), # common details
              [('d', '', 0, False, dirstate.DirState.NULLSTAT), # current tree
               ('d', '', 0, False, rev_id), # first parent details
               ('d', '', 0, False, rev_id2), # second parent details
@@ -412,7 +412,7 @@
         tree = self.make_branch_and_tree('tree')
         self.build_tree(['tree/unknown'])
         expected_result = ([], [
-            (('', '', tree.get_root_id()), # common details
+            (('', '', tree.path2id('')), # common details
              [('d', '', 0, False, dirstate.DirState.NULLSTAT), # current tree
              ])])
         state = dirstate.DirState.from_tree(tree, 'dirstate')
@@ -421,7 +421,7 @@
     def get_tree_with_a_file(self):
         tree = self.make_branch_and_tree('tree')
         self.build_tree(['tree/a file'])
-        tree.add('a file', 'a-file-id')
+        tree.add('a file', 'a file id')
         return tree
 
     def test_non_empty_no_parents_to_dirstate(self):
@@ -429,10 +429,10 @@
         # There are files on disk and no parents
         tree = self.get_tree_with_a_file()
         expected_result = ([], [
-            (('', '', tree.get_root_id()), # common details
+            (('', '', tree.path2id('')), # common details
              [('d', '', 0, False, dirstate.DirState.NULLSTAT), # current tree
              ]),
-            (('', 'a file', 'a-file-id'), # common
+            (('', 'a file', 'a file id'), # common
              [('f', '', 0, False, dirstate.DirState.NULLSTAT), # current
              ]),
             ])
@@ -447,11 +447,11 @@
         # and length:
         self.build_tree_contents([('tree/a file', 'new content\n')])
         expected_result = ([rev_id], [
-            (('', '', tree.get_root_id()), # common details
+            (('', '', tree.path2id('')), # common details
              [('d', '', 0, False, dirstate.DirState.NULLSTAT), # current tree
               ('d', '', 0, False, rev_id), # first parent details
              ]),
-            (('', 'a file', 'a-file-id'), # common
+            (('', 'a file', 'a file id'), # common
              [('f', '', 0, False, dirstate.DirState.NULLSTAT), # current
               ('f', 'c3ed76e4bfd45ff1763ca206055bca8e9fc28aa8', 24, False,
                rev_id), # first parent
@@ -474,12 +474,12 @@
         # and length again, giving us three distinct values:
         self.build_tree_contents([('tree/a file', 'new content\n')])
         expected_result = ([rev_id, rev_id2], [
-            (('', '', tree.get_root_id()), # common details
+            (('', '', tree.path2id('')), # common details
              [('d', '', 0, False, dirstate.DirState.NULLSTAT), # current tree
               ('d', '', 0, False, rev_id), # first parent details
               ('d', '', 0, False, rev_id2), # second parent details
              ]),
-            (('', 'a file', 'a-file-id'), # common
+            (('', 'a file', 'a file id'), # common
              [('f', '', 0, False, dirstate.DirState.NULLSTAT), # current
               ('f', 'c3ed76e4bfd45ff1763ca206055bca8e9fc28aa8', 24, False,
                rev_id), # first parent
@@ -526,7 +526,7 @@
         # get a state object
         # no parents, default tree content
         expected_result = ([], [
-            (('', '', tree.get_root_id()), # common details
+            (('', '', tree.path2id('')), # common details
              # current tree details, but new from_tree skips statting, it
              # uses set_state_from_inventory, and thus depends on the
              # inventory state.
@@ -647,45 +647,6 @@
         finally:
             state.unlock()
 
-    def test_save_refuses_if_changes_aborted(self):
-        self.build_tree(['a-file', 'a-dir/'])
-        state = dirstate.DirState.initialize('dirstate')
-        try:
-            # No stat and no sha1 sum.
-            state.add('a-file', 'a-file-id', 'file', None, '')
-            state.save()
-        finally:
-            state.unlock()
-
-        # The dirstate should include TREE_ROOT and 'a-file' and nothing else
-        expected_blocks = [
-            ('', [(('', '', 'TREE_ROOT'),
-                   [('d', '', 0, False, dirstate.DirState.NULLSTAT)])]),
-            ('', [(('', 'a-file', 'a-file-id'),
-                   [('f', '', 0, False, dirstate.DirState.NULLSTAT)])]),
-        ]
-
-        state = dirstate.DirState.on_file('dirstate')
-        state.lock_write()
-        try:
-            state._read_dirblocks_if_needed()
-            self.assertEqual(expected_blocks, state._dirblocks)
-
-            # Now modify the state, but mark it as inconsistent
-            state.add('a-dir', 'a-dir-id', 'directory', None, '')
-            state._changes_aborted = True
-            state.save()
-        finally:
-            state.unlock()
-
-        state = dirstate.DirState.on_file('dirstate')
-        state.lock_read()
-        try:
-            state._read_dirblocks_if_needed()
-            self.assertEqual(expected_blocks, state._dirblocks)
-        finally:
-            state.unlock()
-
 
 class TestDirStateInitialize(TestCaseWithDirState):
 
@@ -718,7 +679,7 @@
         try:
             tree1.add('')
             revid1 = tree1.commit('foo').encode('utf8')
-            root_id = tree1.get_root_id()
+            root_id = tree1.inventory.root.file_id
             inv = tree1.inventory
         finally:
             tree1.unlock()
@@ -932,7 +893,7 @@
         tree2.lock_write()
         try:
             revid2 = tree2.commit('foo')
-            root_id = tree2.get_root_id()
+            root_id = tree2.inventory.root.file_id
         finally:
             tree2.unlock()
         state = dirstate.DirState.initialize('dirstate')
@@ -1002,7 +963,7 @@
         try:
             tree2.put_file_bytes_non_atomic('file-id', 'new file-content')
             revid2 = tree2.commit('foo')
-            root_id = tree2.get_root_id()
+            root_id = tree2.inventory.root.file_id
         finally:
             tree2.unlock()
         # check the layout in memory
@@ -1048,12 +1009,12 @@
             (('', '', 'TREE_ROOT'), [
              ('d', '', 0, False, dirstate.DirState.NULLSTAT), # current tree
              ]),
-            (('', 'a file', 'a-file-id'), [
+            (('', 'a file', 'a file id'), [
              ('f', '1'*20, 19, False, dirstate.pack_stat(stat)), # current tree
              ]),
             ]
         try:
-            state.add('a file', 'a-file-id', 'file', stat, '1'*20)
+            state.add('a file', 'a file id', 'file', stat, '1'*20)
             # having added it, it should be in the output of iter_entries.
             self.assertEqual(expected_entries, list(state._iter_entries()))
             # saving and reloading should not affect this.
@@ -1078,7 +1039,7 @@
         state = dirstate.DirState.initialize('dirstate')
         try:
             self.assertRaises(errors.NotVersionedError, state.add,
-                'unversioned/a file', 'a-file-id', 'file', None, None)
+                'unversioned/a file', 'a file id', 'file', None, None)
         finally:
             state.unlock()
 
@@ -1116,7 +1077,8 @@
         # The most trivial addition of a symlink when there are no parents and
         # its in the root and all data about the file is supplied
         # bzr doesn't support fake symlinks on windows, yet.
-        self.requireFeature(SymlinkFeature)
+        if not has_symlinks():
+            raise TestSkipped("No symlink support")
         os.symlink('target', 'a link')
         stat = os.lstat('a link')
         expected_entries = [
@@ -1155,7 +1117,7 @@
             (('', 'a dir', 'a dir id'), [
              ('d', '', 0, False, dirstate.pack_stat(dirstat)), # current tree
              ]),
-            (('a dir', 'a file', 'a-file-id'), [
+            (('a dir', 'a file', 'a file id'), [
              ('f', '1'*20, 25, False,
               dirstate.pack_stat(filestat)), # current tree details
              ]),
@@ -1163,7 +1125,7 @@
         state = dirstate.DirState.initialize('dirstate')
         try:
             state.add('a dir', 'a dir id', 'directory', dirstat, None)
-            state.add('a dir/a file', 'a-file-id', 'file', filestat, '1'*20)
+            state.add('a dir/a file', 'a file id', 'file', filestat, '1'*20)
             # added it, it should be in the output of iter_entries.
             self.assertEqual(expected_entries, list(state._iter_entries()))
             # saving and reloading should not affect this.
@@ -1432,122 +1394,6 @@
             state.unlock()
 
 
-class TestIterChildEntries(TestCaseWithDirState):
-
-    def create_dirstate_with_two_trees(self):
-        """This dirstate contains multiple files and directories.
-
-         /        a-root-value
-         a/       a-dir
-         b/       b-dir
-         c        c-file
-         d        d-file
-         a/e/     e-dir
-         a/f      f-file
-         b/g      g-file
-         b/h\xc3\xa5  h-\xc3\xa5-file  #This is u'\xe5' encoded into utf-8
-
-        Notice that a/e is an empty directory.
-
-        There is one parent tree, which has the same shape with the following variations:
-        b/g in the parent is gone.
-        b/h in the parent has a different id
-        b/i is new in the parent 
-        c is renamed to b/j in the parent
-
-        :return: The dirstate, still write-locked.
-        """
-        packed_stat = 'AAAAREUHaIpFB2iKAAADAQAtkqUAAIGk'
-        null_sha = 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx'
-        NULL_PARENT_DETAILS = dirstate.DirState.NULL_PARENT_DETAILS
-        root_entry = ('', '', 'a-root-value'), [
-            ('d', '', 0, False, packed_stat),
-            ('d', '', 0, False, 'parent-revid'),
-            ]
-        a_entry = ('', 'a', 'a-dir'), [
-            ('d', '', 0, False, packed_stat),
-            ('d', '', 0, False, 'parent-revid'),
-            ]
-        b_entry = ('', 'b', 'b-dir'), [
-            ('d', '', 0, False, packed_stat),
-            ('d', '', 0, False, 'parent-revid'),
-            ]
-        c_entry = ('', 'c', 'c-file'), [
-            ('f', null_sha, 10, False, packed_stat),
-            ('r', 'b/j', 0, False, ''),
-            ]
-        d_entry = ('', 'd', 'd-file'), [
-            ('f', null_sha, 20, False, packed_stat),
-            ('f', 'd', 20, False, 'parent-revid'),
-            ]
-        e_entry = ('a', 'e', 'e-dir'), [
-            ('d', '', 0, False, packed_stat),
-            ('d', '', 0, False, 'parent-revid'),
-            ]
-        f_entry = ('a', 'f', 'f-file'), [
-            ('f', null_sha, 30, False, packed_stat),
-            ('f', 'f', 20, False, 'parent-revid'),
-            ]
-        g_entry = ('b', 'g', 'g-file'), [
-            ('f', null_sha, 30, False, packed_stat),
-            NULL_PARENT_DETAILS,
-            ]
-        h_entry1 = ('b', 'h\xc3\xa5', 'h-\xc3\xa5-file1'), [
-            ('f', null_sha, 40, False, packed_stat),
-            NULL_PARENT_DETAILS,
-            ]
-        h_entry2 = ('b', 'h\xc3\xa5', 'h-\xc3\xa5-file2'), [
-            NULL_PARENT_DETAILS,
-            ('f', 'h', 20, False, 'parent-revid'),
-            ]
-        i_entry = ('b', 'i', 'i-file'), [
-            NULL_PARENT_DETAILS,
-            ('f', 'h', 20, False, 'parent-revid'),
-            ]
-        j_entry = ('b', 'j', 'c-file'), [
-            ('r', 'c', 0, False, ''),
-            ('f', 'j', 20, False, 'parent-revid'),
-            ]
-        dirblocks = []
-        dirblocks.append(('', [root_entry]))
-        dirblocks.append(('', [a_entry, b_entry, c_entry, d_entry]))
-        dirblocks.append(('a', [e_entry, f_entry]))
-        dirblocks.append(('b', [g_entry, h_entry1, h_entry2, i_entry, j_entry]))
-        state = dirstate.DirState.initialize('dirstate')
-        state._validate()
-        try:
-            state._set_data(['parent'], dirblocks)
-        except:
-            state.unlock()
-            raise
-        return state, dirblocks
-
-    def test_iter_children_b(self):
-        state, dirblocks = self.create_dirstate_with_two_trees()
-        self.addCleanup(state.unlock)
-        expected_result = []
-        expected_result.append(dirblocks[3][1][2]) # h2
-        expected_result.append(dirblocks[3][1][3]) # i
-        expected_result.append(dirblocks[3][1][4]) # j
-        self.assertEqual(expected_result,
-            list(state._iter_child_entries(1, 'b')))
-
-    def test_iter_child_root(self):
-        state, dirblocks = self.create_dirstate_with_two_trees()
-        self.addCleanup(state.unlock)
-        expected_result = []
-        expected_result.append(dirblocks[1][1][0]) # a
-        expected_result.append(dirblocks[1][1][1]) # b
-        expected_result.append(dirblocks[1][1][3]) # d
-        expected_result.append(dirblocks[2][1][0]) # e
-        expected_result.append(dirblocks[2][1][1]) # f
-        expected_result.append(dirblocks[3][1][2]) # h2
-        expected_result.append(dirblocks[3][1][3]) # i
-        expected_result.append(dirblocks[3][1][4]) # j
-        self.assertEqual(expected_result,
-            list(state._iter_child_entries(1, '')))
-
-
 class TestDirstateSortOrder(TestCaseWithTransport):
     """Test that DirState adds entries in the right order."""
 
@@ -1752,7 +1598,9 @@
 
     def test_update_entry_symlink(self):
         """Update entry should read symlinks."""
-        self.requireFeature(SymlinkFeature)
+        if not osutils.has_symlinks():
+            # PlatformDeficiency / TestSkipped
+            raise TestSkipped("No symlink support")
         state, entry = self.get_state_with_a()
         state.save()
         self.assertEqual(dirstate.DirState.IN_MEMORY_UNMODIFIED,
@@ -1909,7 +1757,9 @@
 
     def test_update_file_to_symlink(self):
         """File becomes a symlink"""
-        self.requireFeature(SymlinkFeature)
+        if not osutils.has_symlinks():
+            # PlatformDeficiency / TestSkipped
+            raise TestSkipped("No symlink support")
         state, entry = self.get_state_with_a()
         # The file sha1 won't be cached unless the file is old
         state.adjust_time(+10)
@@ -1928,7 +1778,9 @@
 
     def test_update_dir_to_symlink(self):
         """Directory becomes a symlink"""
-        self.requireFeature(SymlinkFeature)
+        if not osutils.has_symlinks():
+            # PlatformDeficiency / TestSkipped
+            raise TestSkipped("No symlink support")
         state, entry = self.get_state_with_a()
         # The symlink target won't be cached if it isn't old
         state.adjust_time(+10)
@@ -1938,7 +1790,8 @@
 
     def test_update_symlink_to_file(self):
         """Symlink becomes a file"""
-        self.requireFeature(SymlinkFeature)
+        if not has_symlinks():
+            raise TestSkipped("No symlink support")
         state, entry = self.get_state_with_a()
         # The symlink and file info won't be cached unless old
         state.adjust_time(+10)
@@ -1948,7 +1801,8 @@
 
     def test_update_symlink_to_dir(self):
         """Symlink becomes a directory"""
-        self.requireFeature(SymlinkFeature)
+        if not has_symlinks():
+            raise TestSkipped("No symlink support")
         state, entry = self.get_state_with_a()
         # The symlink target won't be cached if it isn't old
         state.adjust_time(+10)
@@ -2055,7 +1909,7 @@
         # the end it would still be fairly arbitrary, and we don't want the
         # extra overhead if we can avoid it. So sort everything to make sure
         # equality is true
-        self.assertEqual(len(map_keys), len(paths))
+        assert len(map_keys) == len(paths)
         expected = {}
         for path, keys in zip(paths, map_keys):
             if keys is None:
@@ -2080,7 +1934,8 @@
         :param paths: A list of directories
         """
         result = state._bisect_dirblocks(paths)
-        self.assertEqual(len(map_keys), len(paths))
+        assert len(map_keys) == len(paths)
+
         expected = {}
         for path, keys in zip(paths, map_keys):
             if keys is None:
@@ -2350,191 +2205,3 @@
             self.assertEqual(expected, state._find_block(key))
         finally:
             state.unlock()
-
-
-class TestDiscardMergeParents(TestCaseWithDirState):
-
-    def test_discard_no_parents(self):
-        # This should be a no-op
-        state = self.create_empty_dirstate()
-        self.addCleanup(state.unlock)
-        state._discard_merge_parents()
-        state._validate()
-
-    def test_discard_one_parent(self):
-        # No-op
-        packed_stat = 'AAAAREUHaIpFB2iKAAADAQAtkqUAAIGk'
-        root_entry_direntry = ('', '', 'a-root-value'), [
-            ('d', '', 0, False, packed_stat),
-            ('d', '', 0, False, packed_stat),
-            ]
-        dirblocks = []
-        dirblocks.append(('', [root_entry_direntry]))
-        dirblocks.append(('', []))
-
-        state = self.create_empty_dirstate()
-        self.addCleanup(state.unlock)
-        state._set_data(['parent-id'], dirblocks[:])
-        state._validate()
-
-        state._discard_merge_parents()
-        state._validate()
-        self.assertEqual(dirblocks, state._dirblocks)
-
-    def test_discard_simple(self):
-        # No-op
-        packed_stat = 'AAAAREUHaIpFB2iKAAADAQAtkqUAAIGk'
-        root_entry_direntry = ('', '', 'a-root-value'), [
-            ('d', '', 0, False, packed_stat),
-            ('d', '', 0, False, packed_stat),
-            ('d', '', 0, False, packed_stat),
-            ]
-        expected_root_entry_direntry = ('', '', 'a-root-value'), [
-            ('d', '', 0, False, packed_stat),
-            ('d', '', 0, False, packed_stat),
-            ]
-        dirblocks = []
-        dirblocks.append(('', [root_entry_direntry]))
-        dirblocks.append(('', []))
-
-        state = self.create_empty_dirstate()
-        self.addCleanup(state.unlock)
-        state._set_data(['parent-id', 'merged-id'], dirblocks[:])
-        state._validate()
-
-        # This should strip of the extra column
-        state._discard_merge_parents()
-        state._validate()
-        expected_dirblocks = [('', [expected_root_entry_direntry]), ('', [])]
-        self.assertEqual(expected_dirblocks, state._dirblocks)
-
-    def test_discard_absent(self):
-        """If entries are only in a merge, discard should remove the entries"""
-        null_stat = dirstate.DirState.NULLSTAT
-        present_dir = ('d', '', 0, False, null_stat)
-        present_file = ('f', '', 0, False, null_stat)
-        absent = dirstate.DirState.NULL_PARENT_DETAILS
-        root_key = ('', '', 'a-root-value')
-        file_in_root_key = ('', 'file-in-root', 'a-file-id')
-        file_in_merged_key = ('', 'file-in-merged', 'b-file-id')
-        dirblocks = [('', [(root_key, [present_dir, present_dir, present_dir])]),
-                     ('', [(file_in_merged_key,
-                            [absent, absent, present_file]),
-                           (file_in_root_key,
-                            [present_file, present_file, present_file]),
-                          ]),
-                    ]
-
-        state = self.create_empty_dirstate()
-        self.addCleanup(state.unlock)
-        state._set_data(['parent-id', 'merged-id'], dirblocks[:])
-        state._validate()
-
-        exp_dirblocks = [('', [(root_key, [present_dir, present_dir])]),
-                         ('', [(file_in_root_key,
-                                [present_file, present_file]),
-                              ]),
-                        ]
-        state._discard_merge_parents()
-        state._validate()
-        self.assertEqual(exp_dirblocks, state._dirblocks)
-
-    def test_discard_renamed(self):
-        null_stat = dirstate.DirState.NULLSTAT
-        present_dir = ('d', '', 0, False, null_stat)
-        present_file = ('f', '', 0, False, null_stat)
-        absent = dirstate.DirState.NULL_PARENT_DETAILS
-        root_key = ('', '', 'a-root-value')
-        file_in_root_key = ('', 'file-in-root', 'a-file-id')
-        # Renamed relative to parent
-        file_rename_s_key = ('', 'file-s', 'b-file-id')
-        file_rename_t_key = ('', 'file-t', 'b-file-id')
-        # And one that is renamed between the parents, but absent in this
-        key_in_1 = ('', 'file-in-1', 'c-file-id')
-        key_in_2 = ('', 'file-in-2', 'c-file-id')
-
-        dirblocks = [
-            ('', [(root_key, [present_dir, present_dir, present_dir])]),
-            ('', [(key_in_1,
-                   [absent, present_file, ('r', 'file-in-2', 'c-file-id')]),
-                  (key_in_2,
-                   [absent, ('r', 'file-in-1', 'c-file-id'), present_file]),
-                  (file_in_root_key,
-                   [present_file, present_file, present_file]),
-                  (file_rename_s_key,
-                   [('r', 'file-t', 'b-file-id'), absent, present_file]),
-                  (file_rename_t_key,
-                   [present_file, absent, ('r', 'file-s', 'b-file-id')]),
-                 ]),
-        ]
-        exp_dirblocks = [
-            ('', [(root_key, [present_dir, present_dir])]),
-            ('', [(key_in_1, [absent, present_file]),
-                  (file_in_root_key, [present_file, present_file]),
-                  (file_rename_t_key, [present_file, absent]),
-                 ]),
-        ]
-        state = self.create_empty_dirstate()
-        self.addCleanup(state.unlock)
-        state._set_data(['parent-id', 'merged-id'], dirblocks[:])
-        state._validate()
-
-        state._discard_merge_parents()
-        state._validate()
-        self.assertEqual(exp_dirblocks, state._dirblocks)
-
-    def test_discard_all_subdir(self):
-        null_stat = dirstate.DirState.NULLSTAT
-        present_dir = ('d', '', 0, False, null_stat)
-        present_file = ('f', '', 0, False, null_stat)
-        absent = dirstate.DirState.NULL_PARENT_DETAILS
-        root_key = ('', '', 'a-root-value')
-        subdir_key = ('', 'sub', 'dir-id')
-        child1_key = ('sub', 'child1', 'child1-id')
-        child2_key = ('sub', 'child2', 'child2-id')
-        child3_key = ('sub', 'child3', 'child3-id')
-
-        dirblocks = [
-            ('', [(root_key, [present_dir, present_dir, present_dir])]),
-            ('', [(subdir_key, [present_dir, present_dir, present_dir])]),
-            ('sub', [(child1_key, [absent, absent, present_file]),
-                     (child2_key, [absent, absent, present_file]),
-                     (child3_key, [absent, absent, present_file]),
-                    ]),
-        ]
-        exp_dirblocks = [
-            ('', [(root_key, [present_dir, present_dir])]),
-            ('', [(subdir_key, [present_dir, present_dir])]),
-            ('sub', []),
-        ]
-        state = self.create_empty_dirstate()
-        self.addCleanup(state.unlock)
-        state._set_data(['parent-id', 'merged-id'], dirblocks[:])
-        state._validate()
-
-        state._discard_merge_parents()
-        state._validate()
-        self.assertEqual(exp_dirblocks, state._dirblocks)
-
-
-class Test_InvEntryToDetails(TestCaseWithDirState):
-
-    def assertDetails(self, expected, inv_entry):
-        details = dirstate.DirState._inv_entry_to_details(inv_entry)
-        self.assertEqual(expected, details)
-        # details should always allow join() and always be a plain str when
-        # finished
-        (minikind, fingerprint, size, executable, tree_data) = details
-        self.assertIsInstance(minikind, str)
-        self.assertIsInstance(fingerprint, str)
-        self.assertIsInstance(tree_data, str)
-
-    def test_unicode_symlink(self):
-        # In general, the code base doesn't support a target that contains
-        # non-ascii characters. So we just assert tha 
-        inv_entry = inventory.InventoryLink('link-file-id', 'name',
-                                            'link-parent-id')
-        inv_entry.revision = 'link-revision-id'
-        inv_entry.symlink_target = u'link-target'
-        details = self.assertDetails(('l', 'link-target', 0, False,
-                                      'link-revision-id'), inv_entry)

=== modified file 'bzrlib/tests/test_errors.py'
--- bzrlib/tests/test_errors.py	2008-09-02 18:51:03 +0000
+++ bzrlib/tests/test_errors.py	2007-10-12 05:26:46 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007, 2008 Canonical Ltd
+# Copyright (C) 2006, 2007 Canonical Ltd
 #   Authors: Robert Collins <robert.collins@canonical.com>
 #            and others
 #
@@ -18,40 +18,17 @@
 
 """Tests for the formatting and construction of errors."""
 
-import sys
 from bzrlib import (
     bzrdir,
     errors,
-    osutils,
     symbol_versioning,
-    urlutils,
     )
 from bzrlib.tests import TestCase, TestCaseWithTransport
 
 
+
 class TestErrors(TestCaseWithTransport):
 
-    def test_bad_filename_encoding(self):
-        error = errors.BadFilenameEncoding('bad/filen\xe5me', 'UTF-8')
-        self.assertEqualDiff(
-            "Filename 'bad/filen\\xe5me' is not valid in your current"
-            " filesystem encoding UTF-8",
-            str(error))
-
-    def test_corrupt_dirstate(self):
-        error = errors.CorruptDirstate('path/to/dirstate', 'the reason why')
-        self.assertEqualDiff(
-            "Inconsistency in dirstate file path/to/dirstate.\n"
-            "Error: the reason why",
-            str(error))
-
-    def test_dirstate_corrupt(self):
-        error = errors.DirstateCorrupt('.bzr/checkout/dirstate',
-                                       'trailing garbage: "x"')
-        self.assertEqualDiff("The dirstate file (.bzr/checkout/dirstate)"
-            " appears to be corrupt: trailing garbage: \"x\"",
-            str(error))
-
     def test_disabled_method(self):
         error = errors.DisabledMethod("class name")
         self.assertEqualDiff(
@@ -67,12 +44,6 @@
         self.assertEqualDiff('The prefix foo is in the help search path twice.',
             str(error))
 
-    def test_ghost_revisions_have_no_revno(self):
-        error = errors.GhostRevisionsHaveNoRevno('target', 'ghost_rev')
-        self.assertEqualDiff("Could not determine revno for {target} because"
-                             " its ancestry shows a ghost at {ghost_rev}",
-                             str(error))
-
     def test_incompatibleAPI(self):
         error = errors.IncompatibleAPI("module", (1, 2, 3), (4, 5, 6), (7, 8, 9))
         self.assertEqualDiff(
@@ -80,33 +51,12 @@
             'It supports versions "(4, 5, 6)" to "(7, 8, 9)".',
             str(error))
 
-    def test_inconsistent_delta(self):
-        error = errors.InconsistentDelta('path', 'file-id', 'reason for foo')
-        self.assertEqualDiff(
-            "An inconsistent delta was supplied involving 'path', 'file-id'\n"
-            "reason: reason for foo",
-            str(error))
-
     def test_in_process_transport(self):
         error = errors.InProcessTransport('fpp')
         self.assertEqualDiff(
             "The transport 'fpp' is only accessible within this process.",
             str(error))
 
-    def test_invalid_http_range(self):
-        error = errors.InvalidHttpRange('path',
-                                        'Content-Range: potatoes 0-00/o0oo0',
-                                        'bad range')
-        self.assertEquals("Invalid http range"
-                          " 'Content-Range: potatoes 0-00/o0oo0'"
-                          " for path: bad range",
-                          str(error))
-
-    def test_invalid_range(self):
-        error = errors.InvalidRange('path', 12, 'bad range')
-        self.assertEquals("Invalid range access in path at 12: bad range",
-                          str(error))
-
     def test_inventory_modified(self):
         error = errors.InventoryModified("a tree to be repred")
         self.assertEqualDiff("The current inventory for the tree 'a tree to "
@@ -136,12 +86,6 @@
                          '"stream format" into knit of format '
                          '"target format".', str(error))
 
-    def test_knit_data_stream_unknown(self):
-        error = errors.KnitDataStreamUnknown(
-            'stream format')
-        self.assertEqual('Cannot parse knit data stream of format '
-                         '"stream format".', str(error))
-
     def test_knit_header_error(self):
         error = errors.KnitHeaderError('line foo\n', 'path/to/file')
         self.assertEqual("Knit header error: 'line foo\\n' unexpected"
@@ -158,14 +102,7 @@
         error = errors.MediumNotConnected("a medium")
         self.assertEqualDiff(
             "The medium 'a medium' is not connected.", str(error))
- 
-    def test_no_public_branch(self):
-        b = self.make_branch('.')
-        error = errors.NoPublicBranch(b)
-        url = urlutils.unescape_for_display(b.base, 'ascii')
-        self.assertEqualDiff(
-            'There is no public branch set for "%s".' % url, str(error))
-
+        
     def test_no_repo(self):
         dir = bzrdir.BzrDir.create(self.get_url())
         error = errors.NoRepositoryPresent(dir)
@@ -196,17 +133,18 @@
                              " tree atree.", str(error))
         self.assertIsInstance(error, errors.NoSuchRevision)
 
-    def test_not_stacked(self):
-        error = errors.NotStacked('a branch')
-        self.assertEqualDiff("The branch 'a branch' is not stacked.",
-            str(error))
-
     def test_not_write_locked(self):
         error = errors.NotWriteLocked('a thing to repr')
         self.assertEqualDiff("'a thing to repr' is not write locked but needs "
             "to be.",
             str(error))
 
+    def test_read_only_lock_error(self):
+        error = self.applyDeprecated(symbol_versioning.zero_ninetytwo,
+            errors.ReadOnlyLockError, 'filename', 'error message')
+        self.assertEqualDiff("Cannot acquire write lock on filename."
+                             " error message", str(error))
+
     def test_lock_failed(self):
         error = errors.LockFailed('http://canonical.com/', 'readonly transport')
         self.assertEqualDiff("Cannot lock http://canonical.com/: readonly transport",
@@ -220,12 +158,6 @@
             "the currently open request.",
             str(error))
 
-    def test_unavailable_representation(self):
-        error = errors.UnavailableRepresentation(('key',), "mpdiff", "fulltext")
-        self.assertEqualDiff("The encoding 'mpdiff' is not available for key "
-            "('key',) which is encoded as 'fulltext'.",
-            str(error))
-
     def test_unknown_hook(self):
         error = errors.UnknownHook("branch", "foo")
         self.assertEqualDiff("The branch hook 'foo' is unknown in this version"
@@ -236,24 +168,6 @@
             " of bzrlib.",
             str(error))
 
-    def test_unstackable_branch_format(self):
-        format = u'foo'
-        url = "/foo"
-        error = errors.UnstackableBranchFormat(format, url)
-        self.assertEqualDiff(
-            "The branch '/foo'(foo) is not a stackable format. "
-            "You will need to upgrade the branch to permit branch stacking.",
-            str(error))
-
-    def test_unstackable_repository_format(self):
-        format = u'foo'
-        url = "/foo"
-        error = errors.UnstackableRepositoryFormat(format, url)
-        self.assertEqualDiff(
-            "The repository '/foo'(foo) is not a stackable format. "
-            "You will need to upgrade the repository to permit branch stacking.",
-            str(error))
-
     def test_up_to_date(self):
         error = errors.UpToDateFormat(bzrdir.BzrDirFormat4())
         self.assertEqualDiff("The branch format Bazaar-NG branch, "
@@ -391,15 +305,6 @@
             host='ahost', port=444, msg='Unable to connect to ssh host',
             orig_error='my_error')
 
-    def test_target_not_branch(self):
-        """Test the formatting of TargetNotBranch."""
-        error = errors.TargetNotBranch('foo')
-        self.assertEqual(
-            "Your branch does not have all of the revisions required in "
-            "order to merge this merge directive and the target "
-            "location specified in the merge directive is not a branch: "
-            "foo.", str(error))
-
     def test_malformed_bug_identifier(self):
         """Test the formatting of MalformedBugIdentifier."""
         error = errors.MalformedBugIdentifier('bogus', 'reason for bogosity')
@@ -477,77 +382,6 @@
         self.assertEqual(
             "Corrupt or incompatible data stream: my reason", str(e))
 
-    def test_immortal_pending_deletion_message(self):
-        err = errors.ImmortalPendingDeletion('foo')
-        self.assertEquals(
-            "Unable to delete transform temporary directory foo.  "
-            "Please examine foo to see if it contains any files "
-            "you wish to keep, and delete it when you are done.",
-            str(err))
-
-    def test_unable_create_symlink(self):
-        err = errors.UnableCreateSymlink()
-        self.assertEquals(
-            "Unable to create symlink on this platform",
-            str(err))
-        err = errors.UnableCreateSymlink(path=u'foo')
-        self.assertEquals(
-            "Unable to create symlink 'foo' on this platform",
-            str(err))
-        err = errors.UnableCreateSymlink(path=u'\xb5')
-        self.assertEquals(
-            "Unable to create symlink u'\\xb5' on this platform",
-            str(err))
-
-    def test_invalid_url_join(self):
-        """Test the formatting of InvalidURLJoin."""
-        e = errors.InvalidURLJoin('Reason', 'base path', ('args',))
-        self.assertEqual(
-            "Invalid URL join request: Reason: 'base path' + ('args',)",
-            str(e))
-
-    def test_incorrect_url(self):
-        err = errors.InvalidBugTrackerURL('foo', 'http://bug.com/')
-        self.assertEquals(
-            ("The URL for bug tracker \"foo\" doesn't contain {id}: "
-             "http://bug.com/"),
-            str(err))
-
-    def test_unable_encode_path(self):
-        err = errors.UnableEncodePath('foo', 'executable')
-        self.assertEquals("Unable to encode executable path 'foo' in "
-            "user encoding " + osutils.get_user_encoding(),
-            str(err))
-
-    def test_unknown_format(self):
-        err = errors.UnknownFormatError('bar', kind='foo')
-        self.assertEquals("Unknown foo format: 'bar'", str(err))
-
-    def test_unknown_rules(self):
-        err = errors.UnknownRules(['foo', 'bar'])
-        self.assertEquals("Unknown rules detected: foo, bar.", str(err))
-
-    def test_hook_failed(self):
-        # Create an exc_info tuple by raising and catching an exception.
-        try:
-            1/0
-        except ZeroDivisionError:
-            exc_info = sys.exc_info()
-        err = errors.HookFailed('hook stage', 'hook name', exc_info)
-        self.assertStartsWith(
-            str(err), 'Hook \'hook name\' during hook stage failed:\n')
-        self.assertEndsWith(
-            str(err), 'integer division or modulo by zero')
-
-    def test_tip_change_rejected(self):
-        err = errors.TipChangeRejected(u'Unicode message\N{INTERROBANG}')
-        self.assertEquals(
-            u'Tip change rejected: Unicode message\N{INTERROBANG}',
-            unicode(err))
-        self.assertEquals(
-            'Tip change rejected: Unicode message\xe2\x80\xbd',
-            str(err))
-
 
 class PassThroughError(errors.BzrError):
     

=== added file 'bzrlib/tests/test_escaped_store.py'
--- bzrlib/tests/test_escaped_store.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/test_escaped_store.py	2007-09-25 08:14:12 +0000
@@ -0,0 +1,112 @@
+# Copyright (C) 2005, 2007 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+"""Test Escaped Stores."""
+
+from cStringIO import StringIO
+import os
+import gzip
+
+from bzrlib import osutils
+from bzrlib.errors import BzrError, UnlistableStore, NoSuchFile
+from bzrlib.store.text import TextStore
+from bzrlib.tests import TestCaseWithTransport
+import bzrlib.transport
+
+
+class TestEscaped(TestCaseWithTransport):
+    """Mixin template class that provides some common tests for stores"""
+
+    def get_store(self, prefixed=False, escaped=True):
+        t = bzrlib.transport.get_transport(self.get_url())
+        return TextStore(t, prefixed=prefixed, escaped=escaped)
+
+    def test_paths(self):
+        text_store = self.get_store()
+
+        self.assertEqual('a', text_store._relpath('a'))
+        self.assertEqual('a', text_store._relpath(u'a'))
+        self.assertEqual('%2520', text_store._relpath(' '))
+        self.assertEqual('%40%253a%253c%253e', text_store._relpath('@:<>'))
+        self.assertEqual('%25c3%25a5', text_store._relpath(u'\xe5'))
+
+    def test_prefixed(self):
+        # Prefix should be determined by unescaped string
+        text_store = self.get_store(prefixed=True)
+
+        # hash_prefix() is not defined for unicode characters
+        # it is only defined for byte streams.
+        # so hash_prefix() needs to operate on *at most* utf-8
+        # encoded. However urlutils.escape() does both encoding to utf-8
+        # and urllib quoting, so we will use the escaped form
+        # as the path passed to hash_prefix
+
+        self.assertEqual('62/a', text_store._relpath('a'))
+        self.assertEqual('88/%2520', text_store._relpath(' '))
+        self.assertEqual('72/%40%253a%253c%253e',
+                text_store._relpath('@:<>'))
+        self.assertEqual('77/%25c3%25a5', text_store._relpath(u'\xe5'))
+
+    def test_files(self):
+        text_store = self.get_store(prefixed=True)
+
+        text_store.add(StringIO('a'), 'a')
+        self.failUnlessExists('62/a')
+
+        text_store.add(StringIO('space'), ' ')
+        self.failUnlessExists('88/%20')
+        self.assertEquals('space', text_store.get(' ').read())
+
+        text_store.add(StringIO('surprise'), '@:<>')
+        self.failUnlessExists('72/@%3a%3c%3e')
+        self.assertEquals('surprise', text_store.get('@:<>').read())
+
+        text_store.add(StringIO('utf8'), '\xc2\xb5')
+        self.failUnlessExists('77/%c2%b5')
+        self.assertEquals('utf8', text_store.get('\xc2\xb5').read())
+
+    def test_weave(self):
+        from bzrlib.store.versioned import WeaveStore
+        from bzrlib.transactions import PassThroughTransaction
+
+        trans = PassThroughTransaction()
+
+        t = bzrlib.transport.get_transport(self.get_url())
+        weave_store = WeaveStore(t, prefixed=True, escaped=True)
+        def add_text(file_id, rev_id, contents, parents, transaction):
+            vfile = weave_store.get_weave_or_empty(file_id, transaction)
+            vfile.add_lines(rev_id, parents, contents)
+
+        def check_text(file_id, revision_id, contents):
+            vfile = weave_store.get_weave(file_id, trans)
+            self.assertEqual(contents, vfile.get_lines(revision_id))
+
+        add_text('a', 'r', ['a'], [], trans)
+        self.failUnlessExists('62/a.weave')
+        check_text('a', 'r', ['a'])
+
+        add_text(' ', 'r', ['space'], [], trans)
+        self.failIfExists('21/ .weave')
+        self.failUnlessExists('88/%20.weave')
+        check_text(' ', 'r', ['space'])
+
+        add_text('@:<>', 'r', ['surprise'], [], trans)
+        self.failUnlessExists('72/@%3a%3c%3e.weave')
+        check_text('@:<>', 'r', ['surprise'])
+
+        add_text('\xc2\xb5', 'r', ['utf8'], [], trans)
+        self.failUnlessExists('77/%c2%b5.weave')
+        check_text('\xc2\xb5', 'r', ['utf8'])

=== modified file 'bzrlib/tests/test_extract.py'
--- bzrlib/tests/test_extract.py	2007-12-17 19:27:35 +0000
+++ bzrlib/tests/test_extract.py	2007-03-06 00:28:36 +0000
@@ -26,7 +26,7 @@
     
     def test_extract(self):
         self.build_tree(['a/', 'a/b/', 'a/b/c', 'a/d'])
-        wt = self.make_branch_and_tree('a', format='rich-root-pack')
+        wt = self.make_branch_and_tree('a')
         wt.add(['b', 'b/c', 'd'], ['b-id', 'c-id', 'd-id'])
         wt.commit('added files')
         b_wt = wt.extract('b-id')
@@ -47,14 +47,14 @@
         return wt.extract('b-id')
 
     def test_extract_in_checkout(self):
-        a_branch = self.make_branch('branch', format='rich-root-pack')
+        a_branch = self.make_branch('branch')
         self.extract_in_checkout(a_branch)
         b_branch = branch.Branch.open('branch/b')
         b_branch_ref = branch.Branch.open('a/b')
         self.assertEqual(b_branch.base, b_branch_ref.base)
 
     def test_extract_in_deep_checkout(self):
-        a_branch = self.make_branch('branch', format='rich-root-pack')
+        a_branch = self.make_branch('branch')
         self.build_tree(['a/', 'a/b/', 'a/b/c/', 'a/b/c/d/', 'a/b/c/d/e'])
         wt = a_branch.create_checkout('a', lightweight=True)
         wt.add(['b', 'b/c', 'b/c/d', 'b/c/d/e/'], ['b-id', 'c-id', 'd-id',

=== modified file 'bzrlib/tests/test_fetch.py'
--- bzrlib/tests/test_fetch.py	2008-08-29 02:05:22 +0000
+++ bzrlib/tests/test_fetch.py	2007-10-16 16:02:01 +0000
@@ -24,13 +24,15 @@
     errors,
     merge,
     repository,
-    versionedfile,
     )
 from bzrlib.branch import Branch
 from bzrlib.bzrdir import BzrDir
 from bzrlib.repofmt import knitrepo
+from bzrlib.symbol_versioning import (
+    zero_ninetyone,
+    )
 from bzrlib.tests import TestCaseWithTransport
-from bzrlib.tests.http_utils import TestCaseWithWebserver
+from bzrlib.tests.HTTPTestUtil import TestCaseWithWebserver
 from bzrlib.tests.test_revision import make_branches
 from bzrlib.trace import mutter
 from bzrlib.upgrade import Convert
@@ -147,35 +149,25 @@
         branch = self.make_branch('branch', format=knit2_format)
         branch.pull(tree.branch, stop_revision='rev1')
         repo = branch.repository
-        repo.lock_read()
-        try:
-            # Make sure fetch retrieved only what we requested
-            self.assertEqual({('tree-root', 'rev1'):()},
-                repo.texts.get_parent_map(
-                    [('tree-root', 'rev1'), ('tree-root', 'rev2')]))
-        finally:
-            repo.unlock()
+        root_knit = repo.weave_store.get_weave('tree-root',
+                                                repo.get_transaction())
+        # Make sure fetch retrieved only what we requested
+        self.assertTrue('rev1' in root_knit)
+        self.assertTrue('rev2' not in root_knit)
         branch.pull(tree.branch)
+        root_knit = repo.weave_store.get_weave('tree-root',
+                                                repo.get_transaction())
         # Make sure that the next revision in the root knit was retrieved,
         # even though the text, name, parent_id, etc., were unchanged.
-        repo.lock_read()
-        try:
-            # Make sure fetch retrieved only what we requested
-            self.assertEqual({('tree-root', 'rev2'):(('tree-root', 'rev1'),)},
-                repo.texts.get_parent_map([('tree-root', 'rev2')]))
-        finally:
-            repo.unlock()
+        self.assertTrue('rev2' in root_knit)
 
     def test_fetch_incompatible(self):
         knit_tree = self.make_branch_and_tree('knit', format='knit')
         knit3_tree = self.make_branch_and_tree('knit3',
             format='dirstate-with-subtree')
         knit3_tree.commit('blah')
-        e = self.assertRaises(errors.IncompatibleRepositories,
-                              knit_tree.branch.fetch, knit3_tree.branch)
-        self.assertContainsRe(str(e),
-            r"(?m).*/knit.*\nis not compatible with\n.*/knit3/.*\n"
-            r"different rich-root support")
+        self.assertRaises(errors.IncompatibleRepositories,
+                          knit_tree.branch.fetch, knit3_tree.branch)
 
 
 class TestMergeFetch(TestCaseWithTransport):
@@ -239,8 +231,6 @@
         br2 = Branch.open('br2')
         br1 = Branch.open('br1')
         wt2 = WorkingTree.open('br2').merge_from_branch(br1)
-        br2.lock_read()
-        self.addCleanup(br2.unlock)
         for rev_id, text in [('1-2', 'original from 1\n'),
                              ('1-3', 'agreement\n'),
                              ('2-1', 'contents in 2\n'),
@@ -274,8 +264,7 @@
 
     def test_weaves_are_retrieved_once(self):
         self.build_tree(("source/", "source/file", "target/"))
-        # This test depends on knit dasta storage.
-        wt = self.make_branch_and_tree('source', format='dirstate-tags')
+        wt = self.make_branch_and_tree('source')
         branch = wt.branch
         wt.add(["file"], ["id"])
         wt.commit("added file")
@@ -293,8 +282,6 @@
         # unfortunately this log entry is branch format specific. We could 
         # factor out the 'what files does this format use' to a method on the 
         # repository, which would let us to this generically. RBC 20060419
-        # RBC 20080408: Or perhaps we can assert that no files are fully read
-        # twice?
         self.assertEqual(1, self._count_log_matches('/ce/id.kndx', http_logs))
         self.assertEqual(1, self._count_log_matches('/ce/id.knit', http_logs))
         self.assertEqual(1, self._count_log_matches('inventory.kndx', http_logs))
@@ -306,14 +293,8 @@
                                                      http_logs))
         # FIXME naughty poking in there.
         self.get_readonly_server().logs = []
-        # check there is nothing more to fetch.  We take care to re-use the
-        # existing transport so that the request logs we're about to examine
-        # aren't cluttered with redundant probes for a smart server.
-        # XXX: Perhaps this further parameterisation: test http with smart
-        # server, and test http without smart server?
-        source = Branch.open(
-            self.get_readonly_url("source/"),
-            possible_transports=[source.bzrdir.root_transport])
+        # check there is nothing more to fetch
+        source = Branch.open(self.get_readonly_url("source/"))
         self.assertEqual(target.fetch(source), (0, []))
         # should make just two requests
         http_logs = self.get_readonly_server().logs
@@ -321,190 +302,9 @@
         self.log('\n'.join(http_logs))
         self.assertEqual(1, self._count_log_matches('branch-format', http_logs))
         self.assertEqual(1, self._count_log_matches('branch/format', http_logs))
-        self.assertEqual(1, self._count_log_matches('repository/format',
-            http_logs))
+        self.assertEqual(1, self._count_log_matches('repository/format', http_logs))
         self.assertTrue(1 >= self._count_log_matches('revision-history',
                                                      http_logs))
         self.assertTrue(1 >= self._count_log_matches('last-revision',
                                                      http_logs))
         self.assertEqual(4, len(http_logs))
-
-
-class TestKnitToPackFetch(TestCaseWithTransport):
-
-    def find_get_record_stream(self, calls):
-        """In a list of calls, find 'get_record_stream' calls.
-
-        This also ensures that there is only one get_record_stream call.
-        """
-        get_record_call = None
-        for call in calls:
-            if call[0] == 'get_record_stream':
-                self.assertIs(None, get_record_call,
-                              "there should only be one call to"
-                              " get_record_stream")
-                get_record_call = call
-        self.assertIsNot(None, get_record_call,
-                         "there should be exactly one call to "
-                         " get_record_stream")
-        return get_record_call
-
-    def test_fetch_with_deltas_no_delta_closure(self):
-        tree = self.make_branch_and_tree('source', format='dirstate')
-        target = self.make_repository('target', format='pack-0.92')
-        self.build_tree(['source/file'])
-        tree.set_root_id('root-id')
-        tree.add('file', 'file-id')
-        tree.commit('one', rev_id='rev-one')
-        source = tree.branch.repository
-        source.texts = versionedfile.RecordingVersionedFilesDecorator(
-                        source.texts)
-        source.signatures = versionedfile.RecordingVersionedFilesDecorator(
-                        source.signatures)
-        source.revisions = versionedfile.RecordingVersionedFilesDecorator(
-                        source.revisions)
-        source.inventories = versionedfile.RecordingVersionedFilesDecorator(
-                        source.inventories)
-        # precondition
-        self.assertTrue(target._fetch_uses_deltas)
-        target.fetch(source, revision_id='rev-one')
-        self.assertEqual(('get_record_stream', [('file-id', 'rev-one')],
-                          target._fetch_order, False),
-                         self.find_get_record_stream(source.texts.calls))
-        self.assertEqual(('get_record_stream', [('rev-one',)],
-                          target._fetch_order, False),
-                         self.find_get_record_stream(source.inventories.calls))
-        # Because of bugs in the old fetch code, revisions could accidentally
-        # have deltas present in knits. However, it was never intended, so we
-        # always for include_delta_closure=True, to make sure we get fulltexts.
-        # bug #261339
-        self.assertEqual(('get_record_stream', [('rev-one',)],
-                          target._fetch_order, True),
-                         self.find_get_record_stream(source.revisions.calls))
-        # XXX: Signatures is special, and slightly broken. The
-        # standard item_keys_introduced_by actually does a lookup for every
-        # signature to see if it exists, rather than waiting to do them all at
-        # once at the end. The fetch code then does an all-at-once and just
-        # allows for some of them to be missing.
-        # So we know there will be extra calls, but the *last* one is the one
-        # we care about.
-        signature_calls = source.signatures.calls[-1:]
-        self.assertEqual(('get_record_stream', [('rev-one',)],
-                          target._fetch_order, True),
-                         self.find_get_record_stream(signature_calls))
-
-    def test_fetch_no_deltas_with_delta_closure(self):
-        tree = self.make_branch_and_tree('source', format='dirstate')
-        target = self.make_repository('target', format='pack-0.92')
-        self.build_tree(['source/file'])
-        tree.set_root_id('root-id')
-        tree.add('file', 'file-id')
-        tree.commit('one', rev_id='rev-one')
-        source = tree.branch.repository
-        source.texts = versionedfile.RecordingVersionedFilesDecorator(
-                        source.texts)
-        source.signatures = versionedfile.RecordingVersionedFilesDecorator(
-                        source.signatures)
-        source.revisions = versionedfile.RecordingVersionedFilesDecorator(
-                        source.revisions)
-        source.inventories = versionedfile.RecordingVersionedFilesDecorator(
-                        source.inventories)
-        target._fetch_uses_deltas = False
-        target.fetch(source, revision_id='rev-one')
-        self.assertEqual(('get_record_stream', [('file-id', 'rev-one')],
-                          target._fetch_order, True),
-                         self.find_get_record_stream(source.texts.calls))
-        self.assertEqual(('get_record_stream', [('rev-one',)],
-                          target._fetch_order, True),
-                         self.find_get_record_stream(source.inventories.calls))
-        self.assertEqual(('get_record_stream', [('rev-one',)],
-                          target._fetch_order, True),
-                         self.find_get_record_stream(source.revisions.calls))
-        # XXX: Signatures is special, and slightly broken. The
-        # standard item_keys_introduced_by actually does a lookup for every
-        # signature to see if it exists, rather than waiting to do them all at
-        # once at the end. The fetch code then does an all-at-once and just
-        # allows for some of them to be missing.
-        # So we know there will be extra calls, but the *last* one is the one
-        # we care about.
-        signature_calls = source.signatures.calls[-1:]
-        self.assertEqual(('get_record_stream', [('rev-one',)],
-                          target._fetch_order, True),
-                         self.find_get_record_stream(signature_calls))
-
-
-class Test1To2Fetch(TestCaseWithTransport):
-    """Tests for Model1To2 failure modes"""
-
-    def make_tree_and_repo(self):
-        self.tree = self.make_branch_and_tree('tree', format='pack-0.92')
-        self.repo = self.make_repository('rich-repo', format='rich-root-pack')
-        self.repo.lock_write()
-        self.addCleanup(self.repo.unlock)
-
-    def do_fetch_order_test(self, first, second):
-        """Test that fetch works no matter what the set order of revision is.
-
-        This test depends on the order of items in a set, which is
-        implementation-dependant, so we test A, B and then B, A.
-        """
-        self.make_tree_and_repo()
-        self.tree.commit('Commit 1', rev_id=first)
-        self.tree.commit('Commit 2', rev_id=second)
-        self.repo.fetch(self.tree.branch.repository, second)
-
-    def test_fetch_order_AB(self):
-        """See do_fetch_order_test"""
-        self.do_fetch_order_test('A', 'B')
-
-    def test_fetch_order_BA(self):
-        """See do_fetch_order_test"""
-        self.do_fetch_order_test('B', 'A')
-
-    def get_parents(self, file_id, revision_id):
-        self.repo.lock_read()
-        try:
-            parent_map = self.repo.texts.get_parent_map([(file_id, revision_id)])
-            return parent_map[(file_id, revision_id)]
-        finally:
-            self.repo.unlock()
-
-    def test_fetch_ghosts(self):
-        self.make_tree_and_repo()
-        self.tree.commit('first commit', rev_id='left-parent')
-        self.tree.add_parent_tree_id('ghost-parent')
-        fork = self.tree.bzrdir.sprout('fork', 'null:').open_workingtree()
-        fork.commit('not a ghost', rev_id='not-ghost-parent')
-        self.tree.branch.repository.fetch(fork.branch.repository,
-                                     'not-ghost-parent')
-        self.tree.add_parent_tree_id('not-ghost-parent')
-        self.tree.commit('second commit', rev_id='second-id')
-        self.repo.fetch(self.tree.branch.repository, 'second-id')
-        root_id = self.tree.get_root_id()
-        self.assertEqual(
-            ((root_id, 'left-parent'), (root_id, 'ghost-parent'),
-             (root_id, 'not-ghost-parent')),
-            self.get_parents(root_id, 'second-id'))
-
-    def make_two_commits(self, change_root, fetch_twice):
-        self.make_tree_and_repo()
-        self.tree.commit('first commit', rev_id='first-id')
-        if change_root:
-            self.tree.set_root_id('unique-id')
-        self.tree.commit('second commit', rev_id='second-id')
-        if fetch_twice:
-            self.repo.fetch(self.tree.branch.repository, 'first-id')
-        self.repo.fetch(self.tree.branch.repository, 'second-id')
-
-    def test_fetch_changed_root(self):
-        self.make_two_commits(change_root=True, fetch_twice=False)
-        self.assertEqual((), self.get_parents('unique-id', 'second-id'))
-
-    def test_two_fetch_changed_root(self):
-        self.make_two_commits(change_root=True, fetch_twice=True)
-        self.assertEqual((), self.get_parents('unique-id', 'second-id'))
-
-    def test_two_fetches(self):
-        self.make_two_commits(change_root=False, fetch_twice=True)
-        self.assertEqual((('TREE_ROOT', 'first-id'),),
-            self.get_parents('TREE_ROOT', 'second-id'))

=== modified file 'bzrlib/tests/test_ftp_transport.py'
--- bzrlib/tests/test_ftp_transport.py	2007-11-04 15:29:17 +0000
+++ bzrlib/tests/test_ftp_transport.py	2007-10-23 07:15:13 +0000
@@ -25,16 +25,38 @@
     )
 
 
+class _MedusaFeature(tests.Feature):
+    """Some tests want an FTP Server, check if one is available.
+
+    Right now, the only way this is available is if 'medusa' is installed.
+    """
+
+    def _probe(self):
+        try:
+            import medusa
+            import medusa.filesys
+            import medusa.ftp_server
+            return True
+        except ImportError:
+            return False
+
+    def feature_name(self):
+        return 'medusa'
+
+MedusaFeature = _MedusaFeature()
+
+
 class TestCaseWithFTPServer(tests.TestCaseWithTransport):
 
-    _test_needs_features = [tests.FTPServerFeature]
+    _test_needs_features = [MedusaFeature]
 
     def setUp(self):
-        from bzrlib.tests import ftp_server
-        self.transport_server = ftp_server.FTPServer
+        from bzrlib.transport.ftp import FtpServer
+        self.transport_server = FtpServer
         super(TestCaseWithFTPServer, self).setUp()
 
 
+
 class TestCaseAFTP(tests.TestCaseWithTransport):
     """Test aftp transport."""
 

=== modified file 'bzrlib/tests/test_globbing.py'
--- bzrlib/tests/test_globbing.py	2008-05-06 03:17:31 +0000
+++ bzrlib/tests/test_globbing.py	2007-03-07 14:49:00 +0000
@@ -17,7 +17,6 @@
 
 from bzrlib.globbing import (
     Globster,
-    _OrderedGlobster,
     )
 from bzrlib.tests import (
     TestCase, 
@@ -306,15 +305,3 @@
             self.assertEqual(patterns[x],globster.match(filename))
         self.assertEqual(None,globster.match('foobar.300'))
 
-
-class TestOrderedGlobster(TestCase):
-
-    def test_ordered_globs(self):
-        """test that the first match in a list is the one found"""
-        patterns = [ u'*.foo', u'bar.*']
-        globster = _OrderedGlobster(patterns)
-        self.assertEqual(u'*.foo', globster.match('bar.foo'))
-        self.assertEqual(None, globster.match('foo.bar'))
-        globster = _OrderedGlobster(reversed(patterns))
-        self.assertEqual(u'bar.*', globster.match('bar.foo'))
-        self.assertEqual(None, globster.match('foo.bar'))

=== modified file 'bzrlib/tests/test_graph.py'
--- bzrlib/tests/test_graph.py	2008-07-16 16:54:06 +0000
+++ bzrlib/tests/test_graph.py	2007-09-03 22:17:20 +0000
@@ -17,8 +17,6 @@
 from bzrlib import (
     errors,
     graph as _mod_graph,
-    symbol_versioning,
-    tests,
     )
 from bzrlib.revision import NULL_REVISION
 from bzrlib.tests import TestCaseWithMemoryTransport
@@ -117,257 +115,11 @@
 #     /  \      \
 #  rev2a rev2b rev2c
 #    |  /   \   /
-#  rev3a    rev3b
+#  rev3a    reveb
 history_shortcut = {'rev1': [NULL_REVISION], 'rev2a': ['rev1'],
                     'rev2b': ['rev1'], 'rev2c': ['rev1'],
                     'rev3a': ['rev2a', 'rev2b'], 'rev3b': ['rev2b', 'rev2c']}
 
-# Extended history shortcut
-#  NULL_REVISION
-#       |
-#       a
-#       |\
-#       b |
-#       | |
-#       c |
-#       | |
-#       d |
-#       |\|
-#       e f
-extended_history_shortcut = {'a': [NULL_REVISION],
-                             'b': ['a'],
-                             'c': ['b'],
-                             'd': ['c'],
-                             'e': ['d'],
-                             'f': ['a', 'd'],
-                            }
-
-# Double shortcut
-# Both sides will see 'A' first, even though it is actually a decendent of a
-# different common revision.
-#
-#  NULL_REVISION
-#       |
-#       a
-#      /|\
-#     / b \
-#    /  |  \
-#   |   c   |
-#   |  / \  |
-#   | d   e |
-#   |/     \|
-#   f       g
-
-double_shortcut = {'a':[NULL_REVISION], 'b':['a'], 'c':['b'],
-                   'd':['c'], 'e':['c'], 'f':['a', 'd'],
-                   'g':['a', 'e']}
-
-# Complex shortcut
-# This has a failure mode in that a shortcut will find some nodes in common,
-# but the common searcher won't have time to find that one branch is actually
-# in common. The extra nodes at the beginning are because we want to avoid
-# walking off the graph. Specifically, node G should be considered common, but
-# is likely to be seen by M long before the common searcher finds it.
-#
-# NULL_REVISION
-#     |
-#     a
-#     |
-#     b
-#     |
-#     c
-#     |
-#     d
-#     |\
-#     e f
-#     | |\
-#     | g h
-#     |/| |
-#     i j |
-#     | | |
-#     | k |
-#     | | |
-#     | l |
-#     |/|/
-#     m n
-complex_shortcut = {'a':[NULL_REVISION], 'b':['a'], 'c':['b'], 'd':['c'],
-                    'e':['d'], 'f':['d'], 'g':['f'], 'h':['f'],
-                    'i':['e', 'g'], 'j':['g'], 'k':['j'],
-                    'l':['k'], 'm':['i', 'l'], 'n':['l', 'h']}
-
-# NULL_REVISION
-#     |
-#     a
-#     |
-#     b
-#     |
-#     c
-#     |
-#     d
-#     |\
-#     e |
-#     | |
-#     f |
-#     | |
-#     g h
-#     | |\
-#     i | j
-#     |\| |
-#     | k |
-#     | | |
-#     | l |
-#     | | |
-#     | m |
-#     | | |
-#     | n |
-#     | | |
-#     | o |
-#     | | |
-#     | p |
-#     | | |
-#     | q |
-#     | | |
-#     | r |
-#     | | |
-#     | s |
-#     | | |
-#     |/|/
-#     t u
-complex_shortcut2 = {'a':[NULL_REVISION], 'b':['a'], 'c':['b'], 'd':['c'],
-                    'e':['d'], 'f':['e'], 'g':['f'], 'h':['d'], 'i':['g'],
-                    'j':['h'], 'k':['h', 'i'], 'l':['k'], 'm':['l'], 'n':['m'],
-                    'o':['n'], 'p':['o'], 'q':['p'], 'r':['q'], 's':['r'],
-                    't':['i', 's'], 'u':['s', 'j'], 
-                    }
-
-# Graph where different walkers will race to find the common and uncommon
-# nodes.
-#
-# NULL_REVISION
-#     |
-#     a
-#     |
-#     b
-#     |
-#     c
-#     |
-#     d
-#     |\
-#     e k
-#     | |
-#     f-+-p
-#     | | |
-#     | l |
-#     | | |
-#     | m |
-#     | |\|
-#     g n q
-#     |\| |
-#     h o |
-#     |/| |
-#     i r |
-#     | | |
-#     | s |
-#     | | |
-#     | t |
-#     | | |
-#     | u |
-#     | | |
-#     | v |
-#     | | |
-#     | w |
-#     | | |
-#     | x |
-#     | |\|
-#     | y z
-#     |/
-#     j
-#
-# x is found to be common right away, but is the start of a long series of
-# common commits.
-# o is actually common, but the i-j shortcut makes it look like it is actually
-# unique to j at first, you have to traverse all of x->o to find it.
-# q,m gives the walker from j a common point to stop searching, as does p,f.
-# k-n exists so that the second pass still has nodes that are worth searching,
-# rather than instantly cancelling the extra walker.
-
-racing_shortcuts = {'a':[NULL_REVISION], 'b':['a'], 'c':['b'], 'd':['c'],
-    'e':['d'], 'f':['e'], 'g':['f'], 'h':['g'], 'i':['h', 'o'], 'j':['i', 'y'],
-    'k':['d'], 'l':['k'], 'm':['l'], 'n':['m'], 'o':['n', 'g'], 'p':['f'],
-    'q':['p', 'm'], 'r':['o'], 's':['r'], 't':['s'], 'u':['t'], 'v':['u'],
-    'w':['v'], 'x':['w'], 'y':['x'], 'z':['x', 'q']}
-
-
-# A graph with multiple nodes unique to one side.
-#
-# NULL_REVISION
-#     |
-#     a
-#     |
-#     b
-#     |
-#     c
-#     |
-#     d
-#     |\
-#     e f
-#     |\ \
-#     g h i
-#     |\ \ \
-#     j k l m
-#     | |/ x|
-#     | n o p
-#     | |/  |
-#     | q   |
-#     | |   |
-#     | r   |
-#     | |   |
-#     | s   |
-#     | |   |
-#     | t   |
-#     | |   |
-#     | u   |
-#     | |   |
-#     | v   |
-#     | |   |
-#     | w   |
-#     | |   |
-#     | x   |
-#     |/ \ /
-#     y   z
-#
-
-multiple_interesting_unique = {'a':[NULL_REVISION], 'b':['a'], 'c':['b'],
-    'd':['c'], 'e':['d'], 'f':['d'], 'g':['e'], 'h':['e'], 'i':['f'],
-    'j':['g'], 'k':['g'], 'l':['h'], 'm':['i'], 'n':['k', 'l'],
-    'o':['m'], 'p':['m', 'l'], 'q':['n', 'o'], 'r':['q'], 's':['r'],
-    't':['s'], 'u':['t'], 'v':['u'], 'w':['v'], 'x':['w'],
-    'y':['j', 'x'], 'z':['x', 'p']}
-
-
-# Shortcut with extra root
-# We have a long history shortcut, and an extra root, which is why we can't
-# stop searchers based on seeing NULL_REVISION
-#  NULL_REVISION
-#       |   |
-#       a   |
-#       |\  |
-#       b | |
-#       | | |
-#       c | |
-#       | | |
-#       d | g
-#       |\|/
-#       e f
-shortcut_extra_root = {'a': [NULL_REVISION],
-                       'b': ['a'],
-                       'c': ['b'],
-                       'd': ['c'],
-                       'e': ['d'],
-                       'f': ['a', 'd', 'g'],
-                       'g': [NULL_REVISION],
-                      }
-
 #  NULL_REVISION
 #       |
 #       f
@@ -382,77 +134,36 @@
             'f':[NULL_REVISION]}
 
 
-# A graph that contains a ghost
-#  NULL_REVISION
-#       |
-#       f
-#       |
-#       e   g
-#      / \ /
-#     b   d
-#     | \ |
-#     a   c
-
-with_ghost = {'a': ['b'], 'c': ['b', 'd'], 'b':['e'], 'd':['e', 'g'],
-              'e': ['f'], 'f':[NULL_REVISION], NULL_REVISION:()}
-
-# A graph that shows we can shortcut finding revnos when reaching them from the
-# side.
-#  NULL_REVISION
-#       |
-#       a
-#       |
-#       b
-#       |
-#       c
-#       |
-#       d
-#       |
-#       e
-#      / \
-#     f   g
-#     |
-#     h
-#     |
-#     i
-
-with_tail = {'a':[NULL_REVISION], 'b':['a'], 'c':['b'], 'd':['c'], 'e':['d'],
-             'f':['e'], 'g':['e'], 'h':['f'], 'i':['h']}
-
-
 class InstrumentedParentsProvider(object):
 
     def __init__(self, parents_provider):
         self.calls = []
         self._real_parents_provider = parents_provider
 
-    def get_parent_map(self, nodes):
+    def get_parents(self, nodes):
         self.calls.extend(nodes)
-        return self._real_parents_provider.get_parent_map(nodes)
-
-
-class TestGraphBase(tests.TestCase):
-
-    def make_graph(self, ancestors):
-        return _mod_graph.Graph(_mod_graph.DictParentsProvider(ancestors))
-
-    def make_breaking_graph(self, ancestors, break_on):
-        """Make a Graph that raises an exception if we hit a node."""
-        g = self.make_graph(ancestors)
-        orig_parent_map = g.get_parent_map
-        def get_parent_map(keys):
-            bad_keys = set(keys).intersection(break_on)
-            if bad_keys:
-                self.fail('key(s) %s was accessed' % (sorted(bad_keys),))
-            return orig_parent_map(keys)
-        g.get_parent_map = get_parent_map
-        return g
+        return self._real_parents_provider.get_parents(nodes)
+
+
+class DictParentsProvider(object):
+
+    def __init__(self, ancestry):
+        self.ancestry = ancestry
+
+    def __repr__(self):
+        return 'DictParentsProvider(%r)' % self.ancestry
+
+    def get_parents(self, revisions):
+        return [self.ancestry.get(r, None) for r in revisions]
 
 
 class TestGraph(TestCaseWithMemoryTransport):
 
     def make_graph(self, ancestors):
-        return _mod_graph.Graph(_mod_graph.DictParentsProvider(ancestors))
+        tree = self.prepare_memory_tree('.')
+        self.build_ancestry(tree, ancestors)
+        tree.unlock()
+        return tree.branch.repository.get_graph()
 
     def prepare_memory_tree(self, location):
         tree = self.make_branch_and_memory_tree(location)
@@ -537,42 +248,11 @@
                          graph.find_unique_lca(NULL_REVISION, 'rev1'))
         self.assertEqual('rev1', graph.find_unique_lca('rev1', 'rev1'))
         self.assertEqual('rev1', graph.find_unique_lca('rev2a', 'rev2b'))
-        self.assertEqual(('rev1', 1,),
-                         graph.find_unique_lca('rev2a', 'rev2b',
-                         count_steps=True))
-
-    def assertRemoveDescendants(self, expected, graph, revisions):
-        parents = graph.get_parent_map(revisions)
-        self.assertEqual(expected,
-                         graph._remove_simple_descendants(revisions, parents))
-
-    def test__remove_simple_descendants(self):
-        graph = self.make_graph(ancestry_1)
-        self.assertRemoveDescendants(set(['rev1']), graph,
-            set(['rev1', 'rev2a', 'rev2b', 'rev3', 'rev4']))
-
-    def test__remove_simple_descendants_disjoint(self):
-        graph = self.make_graph(ancestry_1)
-        self.assertRemoveDescendants(set(['rev1', 'rev3']), graph,
-            set(['rev1', 'rev3']))
-
-    def test__remove_simple_descendants_chain(self):
-        graph = self.make_graph(ancestry_1)
-        self.assertRemoveDescendants(set(['rev1']), graph,
-            set(['rev1', 'rev2a', 'rev3']))
-
-    def test__remove_simple_descendants_siblings(self):
-        graph = self.make_graph(ancestry_1)
-        self.assertRemoveDescendants(set(['rev2a', 'rev2b']), graph,
-            set(['rev2a', 'rev2b', 'rev3']))
 
     def test_unique_lca_criss_cross(self):
         """Ensure we don't pick non-unique lcas in a criss-cross"""
         graph = self.make_graph(criss_cross)
         self.assertEqual('rev1', graph.find_unique_lca('rev3a', 'rev3b'))
-        lca, steps = graph.find_unique_lca('rev3a', 'rev3b', count_steps=True)
-        self.assertEqual('rev1', lca)
-        self.assertEqual(2, steps)
 
     def test_unique_lca_null_revision(self):
         """Ensure we pick NULL_REVISION when necessary"""
@@ -587,22 +267,17 @@
         self.assertEqual(NULL_REVISION,
                          graph.find_unique_lca('rev4a', 'rev1b'))
 
-    def test_lca_double_shortcut(self):
-        graph = self.make_graph(double_shortcut)
-        self.assertEqual('c', graph.find_unique_lca('f', 'g'))
-
     def test_common_ancestor_two_repos(self):
         """Ensure we do unique_lca using data from two repos"""
         mainline_tree = self.prepare_memory_tree('mainline')
         self.build_ancestry(mainline_tree, mainline)
-        self.addCleanup(mainline_tree.unlock)
+        mainline_tree.unlock()
 
         # This is cheating, because the revisions in the graph are actually
         # different revisions, despite having the same revision-id.
         feature_tree = self.prepare_memory_tree('feature')
         self.build_ancestry(feature_tree, feature_branch)
-        self.addCleanup(feature_tree.unlock)
-
+        feature_tree.unlock()
         graph = mainline_tree.branch.repository.get_graph(
             feature_tree.branch.repository)
         self.assertEqual('rev2b', graph.find_unique_lca('rev2a', 'rev3b'))
@@ -619,14 +294,6 @@
         self.assertEqual((set(['rev4', 'rev3', 'rev2a']), set()),
                          graph.find_difference('rev4', 'rev2b'))
 
-    def test_graph_difference_separate_ancestry(self):
-        graph = self.make_graph(ancestry_2)
-        self.assertEqual((set(['rev1a']), set(['rev1b'])),
-                         graph.find_difference('rev1a', 'rev1b'))
-        self.assertEqual((set(['rev1a', 'rev2a', 'rev3a', 'rev4a']),
-                          set(['rev1b'])),
-                         graph.find_difference('rev4a', 'rev1b'))
-
     def test_graph_difference_criss_cross(self):
         graph = self.make_graph(criss_cross)
         self.assertEqual((set(['rev3a']), set(['rev3b'])),
@@ -634,45 +301,19 @@
         self.assertEqual((set([]), set(['rev3b', 'rev2b'])),
                          graph.find_difference('rev2a', 'rev3b'))
 
-    def test_graph_difference_extended_history(self):
-        graph = self.make_graph(extended_history_shortcut)
-        self.assertEqual((set(['e']), set(['f'])),
-                         graph.find_difference('e', 'f'))
-        self.assertEqual((set(['f']), set(['e'])),
-                         graph.find_difference('f', 'e'))
-
-    def test_graph_difference_double_shortcut(self):
-        graph = self.make_graph(double_shortcut)
-        self.assertEqual((set(['d', 'f']), set(['e', 'g'])),
-                         graph.find_difference('f', 'g'))
-
-    def test_graph_difference_complex_shortcut(self):
-        graph = self.make_graph(complex_shortcut)
-        self.assertEqual((set(['m', 'i', 'e']), set(['n', 'h'])),
-                         graph.find_difference('m', 'n'))
-
-    def test_graph_difference_complex_shortcut2(self):
-        graph = self.make_graph(complex_shortcut2)
-        self.assertEqual((set(['t']), set(['j', 'u'])),
-                         graph.find_difference('t', 'u'))
-
-    def test_graph_difference_shortcut_extra_root(self):
-        graph = self.make_graph(shortcut_extra_root)
-        self.assertEqual((set(['e']), set(['f', 'g'])),
-                         graph.find_difference('e', 'f'))
-
     def test_stacked_parents_provider(self):
-        parents1 = _mod_graph.DictParentsProvider({'rev2': ['rev3']})
-        parents2 = _mod_graph.DictParentsProvider({'rev1': ['rev4']})
+
+        parents1 = DictParentsProvider({'rev2': ['rev3']})
+        parents2 = DictParentsProvider({'rev1': ['rev4']})
         stacked = _mod_graph._StackedParentsProvider([parents1, parents2])
-        self.assertEqual({'rev1':['rev4'], 'rev2':['rev3']},
-                         stacked.get_parent_map(['rev1', 'rev2']))
-        self.assertEqual({'rev2':['rev3'], 'rev1':['rev4']},
-                         stacked.get_parent_map(['rev2', 'rev1']))
-        self.assertEqual({'rev2':['rev3']},
-                         stacked.get_parent_map(['rev2', 'rev2']))
-        self.assertEqual({'rev1':['rev4']},
-                         stacked.get_parent_map(['rev1', 'rev1']))
+        self.assertEqual([['rev4',], ['rev3']],
+                         stacked.get_parents(['rev1', 'rev2']))
+        self.assertEqual([['rev3',], ['rev4']],
+                         stacked.get_parents(['rev2', 'rev1']))
+        self.assertEqual([['rev3',], ['rev3']],
+                         stacked.get_parents(['rev2', 'rev2']))
+        self.assertEqual([['rev4',], ['rev4']],
+                         stacked.get_parents(['rev1', 'rev1']))
 
     def test_iter_topo_order(self):
         graph = self.make_graph(ancestry_1)
@@ -710,25 +351,6 @@
         self.assertFalse(graph.is_ancestor('a', 'c'))
         self.assertTrue('null:' not in instrumented_provider.calls)
 
-    def test_iter_ancestry(self):
-        nodes = boundary.copy()
-        nodes[NULL_REVISION] = ()
-        graph = self.make_graph(nodes)
-        expected = nodes.copy()
-        expected.pop('a') # 'a' is not in the ancestry of 'c', all the
-                          # other nodes are
-        self.assertEqual(expected, dict(graph.iter_ancestry(['c'])))
-        self.assertEqual(nodes, dict(graph.iter_ancestry(['a', 'c'])))
-
-    def test_iter_ancestry_with_ghost(self):
-        graph = self.make_graph(with_ghost)
-        expected = with_ghost.copy()
-        # 'a' is not in the ancestry of 'c', and 'g' is a ghost
-        expected['g'] = None
-        self.assertEqual(expected, dict(graph.iter_ancestry(['a', 'c'])))
-        expected.pop('a') 
-        self.assertEqual(expected, dict(graph.iter_ancestry(['c'])))
-
     def test_filter_candidate_lca(self):
         """Test filter_candidate_lca for a corner case
 
@@ -762,7 +384,7 @@
         self.assertEqual(set(['rev1']), graph.heads(('rev1', 'null:')))
 
     def test_heads_one(self):
-        # A single node will always be a head
+        # A single node will alwaya be a head
         graph = self.make_graph(ancestry_1)
         self.assertEqual(set(['null:']), graph.heads(['null:']))
         self.assertEqual(set(['rev1']), graph.heads(['rev1']))
@@ -831,594 +453,3 @@
                          graph.heads(['rev2a', 'rev3b']))
         self.assertEqual(set(['rev2c', 'rev3a']),
                          graph.heads(['rev2c', 'rev3a']))
-
-    def _run_heads_break_deeper(self, graph_dict, search):
-        """Run heads on a graph-as-a-dict.
-        
-        If the search asks for the parents of 'deeper' the test will fail.
-        """
-        class stub(object):
-            pass
-        def get_parent_map(keys):
-            result = {}
-            for key in keys:
-                if key == 'deeper':
-                    self.fail('key deeper was accessed')
-                result[key] = graph_dict[key]
-            return result
-        an_obj = stub()
-        an_obj.get_parent_map = get_parent_map
-        graph = _mod_graph.Graph(an_obj)
-        return graph.heads(search)
-
-    def test_heads_limits_search(self):
-        # test that a heads query does not search all of history
-        graph_dict = {
-            'left':['common'],
-            'right':['common'],
-            'common':['deeper'],
-        }
-        self.assertEqual(set(['left', 'right']),
-            self._run_heads_break_deeper(graph_dict, ['left', 'right']))
-
-    def test_heads_limits_search_assymetric(self):
-        # test that a heads query does not search all of history
-        graph_dict = {
-            'left':['midleft'],
-            'midleft':['common'],
-            'right':['common'],
-            'common':['aftercommon'],
-            'aftercommon':['deeper'],
-        }
-        self.assertEqual(set(['left', 'right']),
-            self._run_heads_break_deeper(graph_dict, ['left', 'right']))
-
-    def test_heads_limits_search_common_search_must_continue(self):
-        # test that common nodes are still queried, preventing
-        # all-the-way-to-origin behaviour in the following graph:
-        graph_dict = {
-            'h1':['shortcut', 'common1'],
-            'h2':['common1'],
-            'shortcut':['common2'],
-            'common1':['common2'],
-            'common2':['deeper'],
-        }
-        self.assertEqual(set(['h1', 'h2']),
-            self._run_heads_break_deeper(graph_dict, ['h1', 'h2']))
-
-    def test_breadth_first_search_start_ghosts(self):
-        graph = self.make_graph({})
-        # with_ghosts reports the ghosts
-        search = graph._make_breadth_first_searcher(['a-ghost'])
-        self.assertEqual((set(), set(['a-ghost'])), search.next_with_ghosts())
-        self.assertRaises(StopIteration, search.next_with_ghosts)
-        # next includes them
-        search = graph._make_breadth_first_searcher(['a-ghost'])
-        self.assertEqual(set(['a-ghost']), search.next())
-        self.assertRaises(StopIteration, search.next)
-
-    def test_breadth_first_search_deep_ghosts(self):
-        graph = self.make_graph({
-            'head':['present'],
-            'present':['child', 'ghost'],
-            'child':[],
-            })
-        # with_ghosts reports the ghosts
-        search = graph._make_breadth_first_searcher(['head'])
-        self.assertEqual((set(['head']), set()), search.next_with_ghosts())
-        self.assertEqual((set(['present']), set()), search.next_with_ghosts())
-        self.assertEqual((set(['child']), set(['ghost'])),
-            search.next_with_ghosts())
-        self.assertRaises(StopIteration, search.next_with_ghosts)
-        # next includes them
-        search = graph._make_breadth_first_searcher(['head'])
-        self.assertEqual(set(['head']), search.next())
-        self.assertEqual(set(['present']), search.next())
-        self.assertEqual(set(['child', 'ghost']),
-            search.next())
-        self.assertRaises(StopIteration, search.next)
-
-    def test_breadth_first_search_change_next_to_next_with_ghosts(self):
-        # To make the API robust, we allow calling both next() and
-        # next_with_ghosts() on the same searcher.
-        graph = self.make_graph({
-            'head':['present'],
-            'present':['child', 'ghost'],
-            'child':[],
-            })
-        # start with next_with_ghosts
-        search = graph._make_breadth_first_searcher(['head'])
-        self.assertEqual((set(['head']), set()), search.next_with_ghosts())
-        self.assertEqual(set(['present']), search.next())
-        self.assertEqual((set(['child']), set(['ghost'])),
-            search.next_with_ghosts())
-        self.assertRaises(StopIteration, search.next)
-        # start with next
-        search = graph._make_breadth_first_searcher(['head'])
-        self.assertEqual(set(['head']), search.next())
-        self.assertEqual((set(['present']), set()), search.next_with_ghosts())
-        self.assertEqual(set(['child', 'ghost']),
-            search.next())
-        self.assertRaises(StopIteration, search.next_with_ghosts)
-
-    def test_breadth_first_change_search(self):
-        # Changing the search should work with both next and next_with_ghosts.
-        graph = self.make_graph({
-            'head':['present'],
-            'present':['stopped'],
-            'other':['other_2'],
-            'other_2':[],
-            })
-        search = graph._make_breadth_first_searcher(['head'])
-        self.assertEqual((set(['head']), set()), search.next_with_ghosts())
-        self.assertEqual((set(['present']), set()), search.next_with_ghosts())
-        self.assertEqual(set(['present']),
-            search.stop_searching_any(['present']))
-        self.assertEqual((set(['other']), set(['other_ghost'])),
-            search.start_searching(['other', 'other_ghost']))
-        self.assertEqual((set(['other_2']), set()), search.next_with_ghosts())
-        self.assertRaises(StopIteration, search.next_with_ghosts)
-        # next includes them
-        search = graph._make_breadth_first_searcher(['head'])
-        self.assertEqual(set(['head']), search.next())
-        self.assertEqual(set(['present']), search.next())
-        self.assertEqual(set(['present']),
-            search.stop_searching_any(['present']))
-        search.start_searching(['other', 'other_ghost'])
-        self.assertEqual(set(['other_2']), search.next())
-        self.assertRaises(StopIteration, search.next)
-
-    def assertSeenAndResult(self, instructions, search, next):
-        """Check the results of .seen and get_result() for a seach.
-
-        :param instructions: A list of tuples:
-            (seen, recipe, included_keys, starts, stops).
-            seen, recipe and included_keys are results to check on the search
-            and the searches get_result(). starts and stops are parameters to
-            pass to start_searching and stop_searching_any during each
-            iteration, if they are not None.
-        :param search: The search to use.
-        :param next: A callable to advance the search.
-        """
-        for seen, recipe, included_keys, starts, stops in instructions:
-            next()
-            if starts is not None:
-                search.start_searching(starts)
-            if stops is not None:
-                search.stop_searching_any(stops)
-            result = search.get_result()
-            self.assertEqual(recipe, result.get_recipe())
-            self.assertEqual(set(included_keys), result.get_keys())
-            self.assertEqual(seen, search.seen)
-
-    def test_breadth_first_get_result_excludes_current_pending(self):
-        graph = self.make_graph({
-            'head':['child'],
-            'child':[NULL_REVISION],
-            NULL_REVISION:[],
-            })
-        search = graph._make_breadth_first_searcher(['head'])
-        # At the start, nothing has been seen, to its all excluded:
-        result = search.get_result()
-        self.assertEqual((set(['head']), set(['head']), 0),
-            result.get_recipe())
-        self.assertEqual(set(), result.get_keys())
-        self.assertEqual(set(), search.seen)
-        # using next:
-        expected = [
-            (set(['head']), (set(['head']), set(['child']), 1),
-             ['head'], None, None),
-            (set(['head', 'child']), (set(['head']), set([NULL_REVISION]), 2),
-             ['head', 'child'], None, None),
-            (set(['head', 'child', NULL_REVISION]), (set(['head']), set(), 3),
-             ['head', 'child', NULL_REVISION], None, None),
-            ]
-        self.assertSeenAndResult(expected, search, search.next)
-        # using next_with_ghosts:
-        search = graph._make_breadth_first_searcher(['head'])
-        self.assertSeenAndResult(expected, search, search.next_with_ghosts)
-
-    def test_breadth_first_get_result_starts_stops(self):
-        graph = self.make_graph({
-            'head':['child'],
-            'child':[NULL_REVISION],
-            'otherhead':['otherchild'],
-            'otherchild':['excluded'],
-            'excluded':[NULL_REVISION],
-            NULL_REVISION:[]
-            })
-        search = graph._make_breadth_first_searcher([])
-        # Starting with nothing and adding a search works:
-        search.start_searching(['head'])
-        # head has been seen:
-        result = search.get_result()
-        self.assertEqual((set(['head']), set(['child']), 1),
-            result.get_recipe())
-        self.assertEqual(set(['head']), result.get_keys())
-        self.assertEqual(set(['head']), search.seen)
-        # using next:
-        expected = [
-            # stop at child, and start a new search at otherhead:
-            # - otherhead counts as seen immediately when start_searching is
-            # called.
-            (set(['head', 'child', 'otherhead']),
-             (set(['head', 'otherhead']), set(['child', 'otherchild']), 2),
-             ['head', 'otherhead'], ['otherhead'], ['child']),
-            (set(['head', 'child', 'otherhead', 'otherchild']),
-             (set(['head', 'otherhead']), set(['child', 'excluded']), 3),
-             ['head', 'otherhead', 'otherchild'], None, None),
-            # stop searching excluded now
-            (set(['head', 'child', 'otherhead', 'otherchild', 'excluded']),
-             (set(['head', 'otherhead']), set(['child', 'excluded']), 3),
-             ['head', 'otherhead', 'otherchild'], None, ['excluded']),
-            ]
-        self.assertSeenAndResult(expected, search, search.next)
-        # using next_with_ghosts:
-        search = graph._make_breadth_first_searcher([])
-        search.start_searching(['head'])
-        self.assertSeenAndResult(expected, search, search.next_with_ghosts)
-
-    def test_breadth_first_stop_searching_not_queried(self):
-        # A client should be able to say 'stop node X' even if X has not been
-        # returned to the client.
-        graph = self.make_graph({
-            'head':['child', 'ghost1'],
-            'child':[NULL_REVISION],
-            NULL_REVISION:[],
-            })
-        search = graph._make_breadth_first_searcher(['head'])
-        expected = [
-            # NULL_REVISION and ghost1 have not been returned
-            (set(['head']), (set(['head']), set(['child', 'ghost1']), 1),
-             ['head'], None, [NULL_REVISION, 'ghost1']),
-            # ghost1 has been returned, NULL_REVISION is to be returned in the
-            # next iteration.
-            (set(['head', 'child', 'ghost1']),
-             (set(['head']), set(['ghost1', NULL_REVISION]), 2),
-             ['head', 'child'], None, [NULL_REVISION, 'ghost1']),
-            ]
-        self.assertSeenAndResult(expected, search, search.next)
-        # using next_with_ghosts:
-        search = graph._make_breadth_first_searcher(['head'])
-        self.assertSeenAndResult(expected, search, search.next_with_ghosts)
-
-    def test_breadth_first_get_result_ghosts_are_excluded(self):
-        graph = self.make_graph({
-            'head':['child', 'ghost'],
-            'child':[NULL_REVISION],
-            NULL_REVISION:[],
-            })
-        search = graph._make_breadth_first_searcher(['head'])
-        # using next:
-        expected = [
-            (set(['head']),
-             (set(['head']), set(['ghost', 'child']), 1),
-             ['head'], None, None),
-            (set(['head', 'child', 'ghost']),
-             (set(['head']), set([NULL_REVISION, 'ghost']), 2),
-             ['head', 'child'], None, None),
-            ]
-        self.assertSeenAndResult(expected, search, search.next)
-        # using next_with_ghosts:
-        search = graph._make_breadth_first_searcher(['head'])
-        self.assertSeenAndResult(expected, search, search.next_with_ghosts)
-
-    def test_breadth_first_get_result_starting_a_ghost_ghost_is_excluded(self):
-        graph = self.make_graph({
-            'head':['child'],
-            'child':[NULL_REVISION],
-            NULL_REVISION:[],
-            })
-        search = graph._make_breadth_first_searcher(['head'])
-        # using next:
-        expected = [
-            (set(['head', 'ghost']),
-             (set(['head', 'ghost']), set(['child', 'ghost']), 1),
-             ['head'], ['ghost'], None),
-            (set(['head', 'child', 'ghost']),
-             (set(['head', 'ghost']), set([NULL_REVISION, 'ghost']), 2),
-             ['head', 'child'], None, None),
-            ]
-        self.assertSeenAndResult(expected, search, search.next)
-        # using next_with_ghosts:
-        search = graph._make_breadth_first_searcher(['head'])
-        self.assertSeenAndResult(expected, search, search.next_with_ghosts)
-
-    def test_breadth_first_revision_count_includes_NULL_REVISION(self):
-        graph = self.make_graph({
-            'head':[NULL_REVISION],
-            NULL_REVISION:[],
-            })
-        search = graph._make_breadth_first_searcher(['head'])
-        # using next:
-        expected = [
-            (set(['head']),
-             (set(['head']), set([NULL_REVISION]), 1),
-             ['head'], None, None),
-            (set(['head', NULL_REVISION]),
-             (set(['head']), set([]), 2),
-             ['head', NULL_REVISION], None, None),
-            ]
-        self.assertSeenAndResult(expected, search, search.next)
-        # using next_with_ghosts:
-        search = graph._make_breadth_first_searcher(['head'])
-        self.assertSeenAndResult(expected, search, search.next_with_ghosts)
-
-    def test_breadth_first_search_get_result_after_StopIteration(self):
-        # StopIteration should not invalid anything..
-        graph = self.make_graph({
-            'head':[NULL_REVISION],
-            NULL_REVISION:[],
-            })
-        search = graph._make_breadth_first_searcher(['head'])
-        # using next:
-        expected = [
-            (set(['head']),
-             (set(['head']), set([NULL_REVISION]), 1),
-             ['head'], None, None),
-            (set(['head', 'ghost', NULL_REVISION]),
-             (set(['head', 'ghost']), set(['ghost']), 2),
-             ['head', NULL_REVISION], ['ghost'], None),
-            ]
-        self.assertSeenAndResult(expected, search, search.next)
-        self.assertRaises(StopIteration, search.next)
-        self.assertEqual(set(['head', 'ghost', NULL_REVISION]), search.seen)
-        result = search.get_result()
-        self.assertEqual((set(['ghost', 'head']), set(['ghost']), 2),
-            result.get_recipe())
-        self.assertEqual(set(['head', NULL_REVISION]), result.get_keys())
-        # using next_with_ghosts:
-        search = graph._make_breadth_first_searcher(['head'])
-        self.assertSeenAndResult(expected, search, search.next_with_ghosts)
-        self.assertRaises(StopIteration, search.next)
-        self.assertEqual(set(['head', 'ghost', NULL_REVISION]), search.seen)
-        result = search.get_result()
-        self.assertEqual((set(['ghost', 'head']), set(['ghost']), 2),
-            result.get_recipe())
-        self.assertEqual(set(['head', NULL_REVISION]), result.get_keys())
-
-
-class TestFindUniqueAncestors(TestGraphBase):
-
-    def assertFindUniqueAncestors(self, graph, expected, node, common):
-        actual = graph.find_unique_ancestors(node, common)
-        self.assertEqual(expected, sorted(actual))
-
-    def test_empty_set(self):
-        graph = self.make_graph(ancestry_1)
-        self.assertFindUniqueAncestors(graph, [], 'rev1', ['rev1'])
-        self.assertFindUniqueAncestors(graph, [], 'rev2b', ['rev2b'])
-        self.assertFindUniqueAncestors(graph, [], 'rev3', ['rev1', 'rev3'])
-
-    def test_single_node(self):
-        graph = self.make_graph(ancestry_1)
-        self.assertFindUniqueAncestors(graph, ['rev2a'], 'rev2a', ['rev1'])
-        self.assertFindUniqueAncestors(graph, ['rev2b'], 'rev2b', ['rev1'])
-        self.assertFindUniqueAncestors(graph, ['rev3'], 'rev3', ['rev2a'])
-
-    def test_minimal_ancestry(self):
-        graph = self.make_breaking_graph(extended_history_shortcut,
-                                         [NULL_REVISION, 'a', 'b'])
-        self.assertFindUniqueAncestors(graph, ['e'], 'e', ['d'])
-
-        graph = self.make_breaking_graph(extended_history_shortcut,
-                                         ['b'])
-        self.assertFindUniqueAncestors(graph, ['f'], 'f', ['a', 'd'])
-
-        graph = self.make_breaking_graph(complex_shortcut,
-                                         ['a', 'b'])
-        self.assertFindUniqueAncestors(graph, ['h'], 'h', ['i'])
-        self.assertFindUniqueAncestors(graph, ['e', 'g', 'i'], 'i', ['h'])
-        self.assertFindUniqueAncestors(graph, ['h'], 'h', ['g'])
-        self.assertFindUniqueAncestors(graph, ['h'], 'h', ['j'])
-
-    def test_in_ancestry(self):
-        graph = self.make_graph(ancestry_1)
-        self.assertFindUniqueAncestors(graph, [], 'rev1', ['rev3'])
-        self.assertFindUniqueAncestors(graph, [], 'rev2b', ['rev4'])
-
-    def test_multiple_revisions(self):
-        graph = self.make_graph(ancestry_1)
-        self.assertFindUniqueAncestors(graph,
-            ['rev4'], 'rev4', ['rev3', 'rev2b'])
-        self.assertFindUniqueAncestors(graph,
-            ['rev2a', 'rev3', 'rev4'], 'rev4', ['rev2b'])
-
-    def test_complex_shortcut(self):
-        graph = self.make_graph(complex_shortcut)
-        self.assertFindUniqueAncestors(graph,
-            ['h', 'n'], 'n', ['m'])
-        self.assertFindUniqueAncestors(graph,
-            ['e', 'i', 'm'], 'm', ['n'])
-
-    def test_complex_shortcut2(self):
-        graph = self.make_graph(complex_shortcut2)
-        self.assertFindUniqueAncestors(graph,
-            ['j', 'u'], 'u', ['t'])
-        self.assertFindUniqueAncestors(graph,
-            ['t'], 't', ['u'])
-
-    def test_multiple_interesting_unique(self):
-        graph = self.make_graph(multiple_interesting_unique)
-        self.assertFindUniqueAncestors(graph,
-            ['j', 'y'], 'y', ['z'])
-        self.assertFindUniqueAncestors(graph,
-            ['p', 'z'], 'z', ['y'])
-
-    def test_racing_shortcuts(self):
-        graph = self.make_graph(racing_shortcuts)
-        self.assertFindUniqueAncestors(graph,
-            ['p', 'q', 'z'], 'z', ['y'])
-        self.assertFindUniqueAncestors(graph,
-            ['h', 'i', 'j', 'y'], 'j', ['z'])
-
-
-class TestGraphFindDistanceToNull(TestGraphBase):
-    """Test an api that should be able to compute a revno"""
-
-    def assertFindDistance(self, revno, graph, target_id, known_ids):
-        """Assert the output of Graph.find_distance_to_null()"""
-        actual = graph.find_distance_to_null(target_id, known_ids)
-        self.assertEqual(revno, actual)
-
-    def test_nothing_known(self):
-        graph = self.make_graph(ancestry_1)
-        self.assertFindDistance(0, graph, NULL_REVISION, [])
-        self.assertFindDistance(1, graph, 'rev1', [])
-        self.assertFindDistance(2, graph, 'rev2a', [])
-        self.assertFindDistance(2, graph, 'rev2b', [])
-        self.assertFindDistance(3, graph, 'rev3', [])
-        self.assertFindDistance(4, graph, 'rev4', [])
-
-    def test_rev_is_ghost(self):
-        graph = self.make_graph(ancestry_1)
-        e = self.assertRaises(errors.GhostRevisionsHaveNoRevno,
-                              graph.find_distance_to_null, 'rev_missing', [])
-        self.assertEqual('rev_missing', e.revision_id)
-        self.assertEqual('rev_missing', e.ghost_revision_id)
-
-    def test_ancestor_is_ghost(self):
-        graph = self.make_graph({'rev':['parent']})
-        e = self.assertRaises(errors.GhostRevisionsHaveNoRevno,
-                              graph.find_distance_to_null, 'rev', [])
-        self.assertEqual('rev', e.revision_id)
-        self.assertEqual('parent', e.ghost_revision_id)
-
-    def test_known_in_ancestry(self):
-        graph = self.make_graph(ancestry_1)
-        self.assertFindDistance(2, graph, 'rev2a', [('rev1', 1)])
-        self.assertFindDistance(3, graph, 'rev3', [('rev2a', 2)])
-
-    def test_known_in_ancestry_limits(self):
-        graph = self.make_breaking_graph(ancestry_1, ['rev1'])
-        self.assertFindDistance(4, graph, 'rev4', [('rev3', 3)])
-
-    def test_target_is_ancestor(self):
-        graph = self.make_graph(ancestry_1)
-        self.assertFindDistance(2, graph, 'rev2a', [('rev3', 3)])
-
-    def test_target_is_ancestor_limits(self):
-        """We shouldn't search all history if we run into ourselves"""
-        graph = self.make_breaking_graph(ancestry_1, ['rev1'])
-        self.assertFindDistance(3, graph, 'rev3', [('rev4', 4)])
-
-    def test_target_parallel_to_known_limits(self):
-        # Even though the known revision isn't part of the other ancestry, they
-        # eventually converge
-        graph = self.make_breaking_graph(with_tail, ['a'])
-        self.assertFindDistance(6, graph, 'f', [('g', 6)])
-        self.assertFindDistance(7, graph, 'h', [('g', 6)])
-        self.assertFindDistance(8, graph, 'i', [('g', 6)])
-        self.assertFindDistance(6, graph, 'g', [('i', 8)])
-
-
-class TestFindMergeOrder(TestGraphBase):
-
-    def assertMergeOrder(self, expected, graph, tip, base_revisions):
-        self.assertEqual(expected, graph.find_merge_order(tip, base_revisions))
-
-    def test_parents(self):
-        graph = self.make_graph(ancestry_1)
-        self.assertMergeOrder(['rev3', 'rev2b'], graph, 'rev4',
-                                                        ['rev3', 'rev2b'])
-        self.assertMergeOrder(['rev3', 'rev2b'], graph, 'rev4',
-                                                        ['rev2b', 'rev3'])
-
-    def test_ancestors(self):
-        graph = self.make_graph(ancestry_1)
-        self.assertMergeOrder(['rev1', 'rev2b'], graph, 'rev4',
-                                                        ['rev1', 'rev2b'])
-        self.assertMergeOrder(['rev1', 'rev2b'], graph, 'rev4',
-                                                        ['rev2b', 'rev1'])
-
-    def test_shortcut_one_ancestor(self):
-        # When we have enough info, we can stop searching
-        graph = self.make_breaking_graph(ancestry_1, ['rev3', 'rev2b', 'rev4'])
-        # Single ancestors shortcut right away
-        self.assertMergeOrder(['rev3'], graph, 'rev4', ['rev3'])
-
-    def test_shortcut_after_one_ancestor(self):
-        graph = self.make_breaking_graph(ancestry_1, ['rev2a', 'rev2b'])
-        self.assertMergeOrder(['rev3', 'rev1'], graph, 'rev4', ['rev1', 'rev3'])
-
-
-class TestCachingParentsProvider(tests.TestCase):
-
-    def setUp(self):
-        super(TestCachingParentsProvider, self).setUp()
-        dict_pp = _mod_graph.DictParentsProvider({'a':('b',)})
-        self.inst_pp = InstrumentedParentsProvider(dict_pp)
-        self.caching_pp = _mod_graph.CachingParentsProvider(self.inst_pp)
-
-    def test_get_parent_map(self):
-        """Requesting the same revision should be returned from cache"""
-        self.assertEqual({}, self.caching_pp._cache)
-        self.assertEqual({'a':('b',)}, self.caching_pp.get_parent_map(['a']))
-        self.assertEqual(['a'], self.inst_pp.calls)
-        self.assertEqual({'a':('b',)}, self.caching_pp.get_parent_map(['a']))
-        # No new call, as it should have been returned from the cache
-        self.assertEqual(['a'], self.inst_pp.calls)
-        self.assertEqual({'a':('b',)}, self.caching_pp._cache)
-
-    def test_get_parent_map_not_present(self):
-        """The cache should also track when a revision doesn't exist"""
-        self.assertEqual({}, self.caching_pp.get_parent_map(['b']))
-        self.assertEqual(['b'], self.inst_pp.calls)
-        self.assertEqual({}, self.caching_pp.get_parent_map(['b']))
-        # No new calls
-        self.assertEqual(['b'], self.inst_pp.calls)
-        self.assertEqual({'b':None}, self.caching_pp._cache)
-
-    def test_get_parent_map_mixed(self):
-        """Anything that can be returned from cache, should be"""
-        self.assertEqual({}, self.caching_pp.get_parent_map(['b']))
-        self.assertEqual(['b'], self.inst_pp.calls)
-        self.assertEqual({'a':('b',)},
-                         self.caching_pp.get_parent_map(['a', 'b']))
-        self.assertEqual(['b', 'a'], self.inst_pp.calls)
-
-    def test_get_parent_map_repeated(self):
-        """Asking for the same parent 2x will only forward 1 request."""
-        self.assertEqual({'a':('b',)},
-                         self.caching_pp.get_parent_map(['b', 'a', 'b']))
-        # Use sorted because we don't care about the order, just that each is
-        # only present 1 time.
-        self.assertEqual(['a', 'b'], sorted(self.inst_pp.calls))
-
-
-class TestCollapseLinearRegions(tests.TestCase):
-
-    def assertCollapsed(self, collapsed, original):
-        self.assertEqual(collapsed,
-                         _mod_graph.collapse_linear_regions(original))
-
-    def test_collapse_nothing(self):
-        d = {1:[2, 3], 2:[], 3:[]}
-        self.assertCollapsed(d, d)
-        d = {1:[2], 2:[3, 4], 3:[5], 4:[5], 5:[]}
-        self.assertCollapsed(d, d)
-
-    def test_collapse_chain(self):
-        # Any time we have a linear chain, we should be able to collapse
-        d = {1:[2], 2:[3], 3:[4], 4:[5], 5:[]}
-        self.assertCollapsed({1:[5], 5:[]}, d)
-        d = {5:[4], 4:[3], 3:[2], 2:[1], 1:[]}
-        self.assertCollapsed({5:[1], 1:[]}, d)
-        d = {5:[3], 3:[4], 4:[1], 1:[2], 2:[]}
-        self.assertCollapsed({5:[2], 2:[]}, d)
-
-    def test_collapse_with_multiple_children(self):
-        #    7
-        #    |
-        #    6
-        #   / \
-        #  4   5
-        #  |   |
-        #  2   3
-        #   \ /
-        #    1
-        #
-        # 4 and 5 cannot be removed because 6 has 2 children
-        # 2 and 3 cannot be removed because 1 has 2 parents
-        d = {1:[2, 3], 2:[4], 4:[6], 3:[5], 5:[6], 6:[7], 7:[]}
-        self.assertCollapsed(d, d)

=== modified file 'bzrlib/tests/test_hashcache.py'
--- bzrlib/tests/test_hashcache.py	2007-11-02 05:12:17 +0000
+++ bzrlib/tests/test_hashcache.py	2006-09-20 14:03:05 +0000
@@ -22,7 +22,7 @@
 
 from bzrlib.errors import BzrError
 from bzrlib.hashcache import HashCache
-from bzrlib.tests import OsFifoFeature, TestCaseInTempDir, TestCase
+from bzrlib.tests import TestCaseInTempDir, TestSkipped, TestCase
 
 
 def sha1(t):
@@ -111,8 +111,9 @@
 
     def test_hashcache_raise(self):
         """check that hashcache can raise BzrError"""
-        self.requireFeature(OsFifoFeature)
         hc = self.make_hashcache()
+        if getattr(os, 'mkfifo', None) is None:
+            raise TestSkipped('filesystem fifos not supported on this system')
         os.mkfifo('a')
         # It's possible that the system supports fifos but the filesystem
         # can't.  In that case we should skip at this point.  But in fact

=== modified file 'bzrlib/tests/test_help.py'
--- bzrlib/tests/test_help.py	2007-12-10 03:31:11 +0000
+++ bzrlib/tests/test_help.py	2007-08-30 13:53:57 +0000
@@ -201,14 +201,6 @@
             '\n'
             'See also: bar, foo\n')
 
-    def test_get_help_text_loaded_from_file(self):
-        # Pick a known topic stored in an external file
-        topic = help_topics.RegisteredTopic('hooks')
-        self.assertStartsWith(topic.get_help_text(),
-            'Hooks\n'
-            '=====\n'
-            '\n')
-
     def test_get_help_topic(self):
         """The help topic for a RegisteredTopic is its topic from construction."""
         topic = help_topics.RegisteredTopic('foobar')

=== modified file 'bzrlib/tests/test_hooks.py'
--- bzrlib/tests/test_hooks.py	2008-04-30 22:56:47 +0000
+++ bzrlib/tests/test_hooks.py	2007-06-28 03:08:53 +0000
@@ -23,7 +23,6 @@
     UnknownHook,
     )
 
-from bzrlib.symbol_versioning import one_five
 from bzrlib.tests import TestCase
 
 
@@ -32,43 +31,25 @@
     def test_install_hook_raises_unknown_hook(self):
         """install_hook should raise UnknownHook if a hook is unknown."""
         hooks = Hooks()
-        self.assertRaises(UnknownHook, self.applyDeprecated, one_five,
-                          hooks.install_hook, 'silly', None)
+        self.assertRaises(UnknownHook, hooks.install_hook, 'silly', None)
 
     def test_install_hook_appends_known_hook(self):
         """install_hook should append the callable for known hooks."""
         hooks = Hooks()
         hooks['set_rh'] = []
-        self.applyDeprecated(one_five, hooks.install_hook, 'set_rh', None)
-        self.assertEqual(hooks['set_rh'], [None])
-
-    def test_install_named_hook_raises_unknown_hook(self):
-        hooks = Hooks()
-        self.assertRaises(UnknownHook, hooks.install_named_hook, 'silly',
-                          None, "")
-
-    def test_install_named_hook_appends_known_hook(self):
-        hooks = Hooks()
-        hooks['set_rh'] = []
-        hooks.install_named_hook('set_rh', None, "demo")
-        self.assertEqual(hooks['set_rh'], [None])
-
-    def test_install_named_hook_and_retrieve_name(self):
-        hooks = Hooks()
-        hooks['set_rh'] = []
-        hooks.install_named_hook('set_rh', None, "demo")
-        self.assertEqual("demo", hooks.get_hook_name(None))
+        hooks.install_hook('set_rh', None)
+        self.assertEqual(hooks['set_rh'], [None])
 
     def test_name_hook_and_retrieve_name(self):
         """name_hook puts the name in the names mapping."""
         hooks = Hooks()
         hooks['set_rh'] = []
-        self.applyDeprecated(one_five, hooks.install_hook, 'set_rh', None)
+        hooks.install_hook('set_rh', None)
         hooks.name_hook(None, 'demo')
         self.assertEqual("demo", hooks.get_hook_name(None))
 
     def test_get_unnamed_hook_name_is_unnamed(self):
         hooks = Hooks()
         hooks['set_rh'] = []
-        self.applyDeprecated(one_five, hooks.install_hook, 'set_rh', None)
+        hooks.install_hook('set_rh', None)
         self.assertEqual("No hook name", hooks.get_hook_name(None))

=== modified file 'bzrlib/tests/test_http.py'
--- bzrlib/tests/test_http.py	2008-08-14 02:15:31 +0000
+++ bzrlib/tests/test_http.py	2007-10-23 08:51:09 +0000
@@ -14,151 +14,74 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-"""Tests for HTTP implementations.
-
-This module defines a load_tests() method that parametrize tests classes for
-transport implementation, http protocol versions and authentication schemes.
-"""
+# FIXME: This test should be repeated for each available http client
+# implementation; at the moment we have urllib and pycurl.
 
 # TODO: Should be renamed to bzrlib.transport.http.tests?
 # TODO: What about renaming to bzrlib.tests.transport.http ?
 
 from cStringIO import StringIO
-import httplib
 import os
 import select
-import SimpleHTTPServer
 import socket
 import sys
 import threading
 
 import bzrlib
 from bzrlib import (
-    bzrdir,
     config,
     errors,
     osutils,
-    remote as _mod_remote,
-    tests,
-    transport,
     ui,
     urlutils,
     )
 from bzrlib.tests import (
-    http_server,
-    http_utils,
+    TestCase,
+    TestUIFactory,
+    TestSkipped,
+    StringIOWrapper,
+    )
+from bzrlib.tests.HttpServer import (
+    HttpServer,
+    HttpServer_PyCurl,
+    HttpServer_urllib,
+    )
+from bzrlib.tests.HTTPTestUtil import (
+    BadProtocolRequestHandler,
+    BadStatusRequestHandler,
+    ForbiddenRequestHandler,
+    HTTPBasicAuthServer,
+    HTTPDigestAuthServer,
+    HTTPServerRedirecting,
+    InvalidStatusRequestHandler,
+    LimitedRangeHTTPServer,
+    NoRangeRequestHandler,
+    ProxyBasicAuthServer,
+    ProxyDigestAuthServer,
+    ProxyServer,
+    SingleRangeRequestHandler,
+    SingleOnlyRangeRequestHandler,
+    TestCaseWithRedirectedWebserver,
+    TestCaseWithTwoWebservers,
+    TestCaseWithWebserver,
+    WallRequestHandler,
     )
 from bzrlib.transport import (
-    http,
-    remote,
+    _CoalescedOffset,
+    do_catching_redirections,
+    get_transport,
+    Transport,
     )
 from bzrlib.transport.http import (
-    _urllib,
+    extract_auth,
+    HttpTransportBase,
     _urllib2_wrappers,
     )
-
-
-try:
-    from bzrlib.transport.http._pycurl import PyCurlTransport
-    pycurl_present = True
-except errors.DependencyNotPresent:
-    pycurl_present = False
-
-
-class TransportAdapter(tests.TestScenarioApplier):
-    """Generate the same test for each transport implementation."""
-
-    def __init__(self):
-        transport_scenarios = [
-            ('urllib', dict(_transport=_urllib.HttpTransport_urllib,
-                            _server=http_server.HttpServer_urllib,
-                            _qualified_prefix='http+urllib',)),
-            ]
-        if pycurl_present:
-            transport_scenarios.append(
-                ('pycurl', dict(_transport=PyCurlTransport,
-                                _server=http_server.HttpServer_PyCurl,
-                                _qualified_prefix='http+pycurl',)))
-        self.scenarios = transport_scenarios
-
-
-class TransportProtocolAdapter(TransportAdapter):
-    """Generate the same test for each protocol implementation.
-
-    In addition to the transport adaptatation that we inherit from.
-    """
-
-    def __init__(self):
-        super(TransportProtocolAdapter, self).__init__()
-        protocol_scenarios = [
-            ('HTTP/1.0',  dict(_protocol_version='HTTP/1.0')),
-            ('HTTP/1.1',  dict(_protocol_version='HTTP/1.1')),
-            ]
-        self.scenarios = tests.multiply_scenarios(self.scenarios,
-                                                  protocol_scenarios)
-
-
-class TransportProtocolAuthenticationAdapter(TransportProtocolAdapter):
-    """Generate the same test for each authentication scheme implementation.
-
-    In addition to the protocol adaptatation that we inherit from.
-    """
-
-    def __init__(self):
-        super(TransportProtocolAuthenticationAdapter, self).__init__()
-        auth_scheme_scenarios = [
-            ('basic', dict(_auth_scheme='basic')),
-            ('digest', dict(_auth_scheme='digest')),
-            ]
-
-        self.scenarios = tests.multiply_scenarios(self.scenarios,
-                                                  auth_scheme_scenarios)
-
-def load_tests(standard_tests, module, loader):
-    """Multiply tests for http clients and protocol versions."""
-    # one for each transport
-    t_adapter = TransportAdapter()
-    t_classes= (TestHttpTransportRegistration,
-                TestHttpTransportUrls,
-                )
-    is_testing_for_transports = tests.condition_isinstance(t_classes)
-
-    # multiplied by one for each protocol version
-    tp_adapter = TransportProtocolAdapter()
-    tp_classes= (SmartHTTPTunnellingTest,
-                 TestDoCatchRedirections,
-                 TestHTTPConnections,
-                 TestHTTPRedirections,
-                 TestHTTPSilentRedirections,
-                 TestLimitedRangeRequestServer,
-                 TestPost,
-                 TestProxyHttpServer,
-                 TestRanges,
-                 TestSpecificRequestHandler,
-                 )
-    is_also_testing_for_protocols = tests.condition_isinstance(tp_classes)
-
-    # multiplied by one for each authentication scheme
-    tpa_adapter = TransportProtocolAuthenticationAdapter()
-    tpa_classes = (TestAuth,
-                   )
-    is_also_testing_for_authentication = tests.condition_isinstance(
-        tpa_classes)
-
-    result = loader.suiteClass()
-    for test_class in tests.iter_suite_tests(standard_tests):
-        # Each test class is either standalone or testing for some combination
-        # of transport, protocol version, authentication scheme. Use the right
-        # adpater (or none) depending on the class.
-        if is_testing_for_transports(test_class):
-            result.addTests(t_adapter.adapt(test_class))
-        elif is_also_testing_for_protocols(test_class):
-            result.addTests(tp_adapter.adapt(test_class))
-        elif is_also_testing_for_authentication(test_class):
-            result.addTests(tpa_adapter.adapt(test_class))
-        else:
-            result.addTest(test_class)
-    return result
+from bzrlib.transport.http._urllib import HttpTransport_urllib
+from bzrlib.transport.http._urllib2_wrappers import (
+    ProxyHandler,
+    Request,
+    )
 
 
 class FakeManager(object):
@@ -227,82 +150,6 @@
         self.port = None
 
 
-class TestHTTPServer(tests.TestCase):
-    """Test the HTTP servers implementations."""
-
-    def test_invalid_protocol(self):
-        class BogusRequestHandler(http_server.TestingHTTPRequestHandler):
-
-            protocol_version = 'HTTP/0.1'
-
-        server = http_server.HttpServer(BogusRequestHandler)
-        try:
-            self.assertRaises(httplib.UnknownProtocol,server.setUp)
-        except:
-            server.tearDown()
-            self.fail('HTTP Server creation did not raise UnknownProtocol')
-
-    def test_force_invalid_protocol(self):
-        server = http_server.HttpServer(protocol_version='HTTP/0.1')
-        try:
-            self.assertRaises(httplib.UnknownProtocol,server.setUp)
-        except:
-            server.tearDown()
-            self.fail('HTTP Server creation did not raise UnknownProtocol')
-
-    def test_server_start_and_stop(self):
-        server = http_server.HttpServer()
-        server.setUp()
-        self.assertTrue(server._http_running)
-        server.tearDown()
-        self.assertFalse(server._http_running)
-
-    def test_create_http_server_one_zero(self):
-        class RequestHandlerOneZero(http_server.TestingHTTPRequestHandler):
-
-            protocol_version = 'HTTP/1.0'
-
-        server = http_server.HttpServer(RequestHandlerOneZero)
-        server.setUp()
-        self.addCleanup(server.tearDown)
-        self.assertIsInstance(server._httpd, http_server.TestingHTTPServer)
-
-    def test_create_http_server_one_one(self):
-        class RequestHandlerOneOne(http_server.TestingHTTPRequestHandler):
-
-            protocol_version = 'HTTP/1.1'
-
-        server = http_server.HttpServer(RequestHandlerOneOne)
-        server.setUp()
-        self.addCleanup(server.tearDown)
-        self.assertIsInstance(server._httpd,
-                              http_server.TestingThreadingHTTPServer)
-
-    def test_create_http_server_force_one_one(self):
-        class RequestHandlerOneZero(http_server.TestingHTTPRequestHandler):
-
-            protocol_version = 'HTTP/1.0'
-
-        server = http_server.HttpServer(RequestHandlerOneZero,
-                                        protocol_version='HTTP/1.1')
-        server.setUp()
-        self.addCleanup(server.tearDown)
-        self.assertIsInstance(server._httpd,
-                              http_server.TestingThreadingHTTPServer)
-
-    def test_create_http_server_force_one_zero(self):
-        class RequestHandlerOneOne(http_server.TestingHTTPRequestHandler):
-
-            protocol_version = 'HTTP/1.1'
-
-        server = http_server.HttpServer(RequestHandlerOneOne,
-                                        protocol_version='HTTP/1.0')
-        server.setUp()
-        self.addCleanup(server.tearDown)
-        self.assertIsInstance(server._httpd,
-                              http_server.TestingHTTPServer)
-
-
 class TestWithTransport_pycurl(object):
     """Test case to inherit from if pycurl is present"""
 
@@ -311,31 +158,38 @@
             from bzrlib.transport.http._pycurl import PyCurlTransport
             return PyCurlTransport
         except errors.DependencyNotPresent:
-            raise tests.TestSkipped('pycurl not present')
+            raise TestSkipped('pycurl not present')
 
     _transport = property(_get_pycurl_maybe)
 
 
-class TestHttpUrls(tests.TestCase):
+class TestHttpUrls(TestCase):
 
     # TODO: This should be moved to authorization tests once they
     # are written.
 
     def test_url_parsing(self):
         f = FakeManager()
-        url = http.extract_auth('http://example.com', f)
+        url = extract_auth('http://example.com', f)
         self.assertEquals('http://example.com', url)
         self.assertEquals(0, len(f.credentials))
-        url = http.extract_auth(
-            'http://user:pass@www.bazaar-vcs.org/bzr/bzr.dev', f)
+        url = extract_auth('http://user:pass@www.bazaar-vcs.org/bzr/bzr.dev', f)
         self.assertEquals('http://www.bazaar-vcs.org/bzr/bzr.dev', url)
         self.assertEquals(1, len(f.credentials))
         self.assertEquals([None, 'www.bazaar-vcs.org', 'user', 'pass'],
                           f.credentials[0])
 
 
-class TestHttpTransportUrls(tests.TestCase):
-    """Test the http urls."""
+class TestHttpTransportUrls(object):
+    """Test the http urls.
+
+    This MUST be used by daughter classes that also inherit from
+    TestCase.
+
+    We can't inherit directly from TestCase or the
+    test framework will try to create an instance which cannot
+    run, its implementation being incomplete.
+    """
 
     def test_abs_url(self):
         """Construction of absolute http URLs"""
@@ -372,7 +226,20 @@
             server.tearDown()
 
 
-class TestHttps_pycurl(TestWithTransport_pycurl, tests.TestCase):
+class TestHttpUrls_urllib(TestHttpTransportUrls, TestCase):
+    """Test http urls with urllib"""
+
+    _transport = HttpTransport_urllib
+    _server = HttpServer_urllib
+    _qualified_prefix = 'http+urllib'
+
+
+class TestHttpUrls_pycurl(TestWithTransport_pycurl, TestHttpTransportUrls,
+                          TestCase):
+    """Test http urls with pycurl"""
+
+    _server = HttpServer_PyCurl
+    _qualified_prefix = 'http+pycurl'
 
     # TODO: This should really be moved into another pycurl
     # specific test. When https tests will be implemented, take
@@ -387,39 +254,40 @@
         try:
             import pycurl
         except ImportError:
-            raise tests.TestSkipped('pycurl not present')
-
-        version_info_orig = pycurl.version_info
-        try:
-            # Now that we have pycurl imported, we can fake its version_info
-            # This was taken from a windows pycurl without SSL
-            # (thanks to bialix)
-            pycurl.version_info = lambda : (2,
-                                            '7.13.2',
-                                            462082,
-                                            'i386-pc-win32',
-                                            2576,
-                                            None,
-                                            0,
-                                            None,
-                                            ('ftp', 'gopher', 'telnet',
-                                             'dict', 'ldap', 'http', 'file'),
-                                            None,
-                                            0,
-                                            None)
-            self.assertRaises(errors.DependencyNotPresent, self._transport,
-                              'https://launchpad.net')
-        finally:
-            # Restore the right function
-            pycurl.version_info = version_info_orig
-
-
-class TestHTTPConnections(http_utils.TestCaseWithWebserver):
-    """Test the http connections."""
+            raise TestSkipped('pycurl not present')
+        # Now that we have pycurl imported, we can fake its version_info
+        # This was taken from a windows pycurl without SSL
+        # (thanks to bialix)
+        pycurl.version_info = lambda : (2,
+                                        '7.13.2',
+                                        462082,
+                                        'i386-pc-win32',
+                                        2576,
+                                        None,
+                                        0,
+                                        None,
+                                        ('ftp', 'gopher', 'telnet',
+                                         'dict', 'ldap', 'http', 'file'),
+                                        None,
+                                        0,
+                                        None)
+        self.assertRaises(errors.DependencyNotPresent, self._transport,
+                          'https://launchpad.net')
+
+class TestHttpConnections(object):
+    """Test the http connections.
+
+    This MUST be used by daughter classes that also inherit from
+    TestCaseWithWebserver.
+
+    We can't inherit directly from TestCaseWithWebserver or the
+    test framework will try to create an instance which cannot
+    run, its implementation being incomplete.
+    """
 
     def setUp(self):
-        http_utils.TestCaseWithWebserver.setUp(self)
-        self.build_tree(['foo/', 'foo/bar'], line_endings='binary',
+        TestCaseWithWebserver.setUp(self)
+        self.build_tree(['xxx', 'foo/', 'foo/bar'], line_endings='binary',
                         transport=self.get_transport())
 
     def test_http_has(self):
@@ -471,24 +339,40 @@
             socket.setdefaulttimeout(default_timeout)
 
 
-class TestHttpTransportRegistration(tests.TestCase):
+class TestHttpConnections_urllib(TestHttpConnections, TestCaseWithWebserver):
+    """Test http connections with urllib"""
+
+    _transport = HttpTransport_urllib
+
+
+
+class TestHttpConnections_pycurl(TestWithTransport_pycurl,
+                                 TestHttpConnections,
+                                 TestCaseWithWebserver):
+    """Test http connections with pycurl"""
+
+
+class TestHttpTransportRegistration(TestCase):
     """Test registrations of various http implementations"""
 
     def test_http_registered(self):
-        t = transport.get_transport('%s://foo.com/' % self._qualified_prefix)
-        self.assertIsInstance(t, transport.Transport)
-        self.assertIsInstance(t, self._transport)
-
-
-class TestPost(tests.TestCase):
-
-    def test_post_body_is_received(self):
+        # urlllib should always be present
+        t = get_transport('http+urllib://bzr.google.com/')
+        self.assertIsInstance(t, Transport)
+        self.assertIsInstance(t, HttpTransport_urllib)
+
+
+class TestPost(object):
+
+    def _test_post_body_is_received(self, scheme):
         server = RecordingServer(expect_body_tail='end-of-body')
         server.setUp()
         self.addCleanup(server.tearDown)
-        scheme = self._qualified_prefix
         url = '%s://%s:%s/' % (scheme, server.host, server.port)
-        http_transport = self._transport(url)
+        try:
+            http_transport = get_transport(url)
+        except errors.UnsupportedProtocol:
+            raise TestSkipped('%s not available' % scheme)
         code, response = http_transport._post('abc def end-of-body')
         self.assertTrue(
             server.received_bytes.startswith('POST /.bzr/smart HTTP/1.'))
@@ -500,14 +384,30 @@
             server.received_bytes.endswith('\r\n\r\nabc def end-of-body'))
 
 
-class TestRangeHeader(tests.TestCase):
+class TestPost_urllib(TestCase, TestPost):
+    """TestPost for urllib implementation"""
+
+    _transport = HttpTransport_urllib
+
+    def test_post_body_is_received_urllib(self):
+        self._test_post_body_is_received('http+urllib')
+
+
+class TestPost_pycurl(TestWithTransport_pycurl, TestCase, TestPost):
+    """TestPost for pycurl implementation"""
+
+    def test_post_body_is_received_pycurl(self):
+        self._test_post_body_is_received('http+pycurl')
+
+
+class TestRangeHeader(TestCase):
     """Test range_header method"""
 
     def check_header(self, value, ranges=[], tail=0):
         offsets = [ (start, end - start + 1) for start, end in ranges]
-        coalesce = transport.Transport._coalesce_offsets
+        coalesce = Transport._coalesce_offsets
         coalesced = list(coalesce(offsets, limit=0, fudge_factor=0))
-        range_header = http.HttpTransportBase._range_header
+        range_header = HttpTransportBase._range_header
         self.assertEqual(value, range_header(coalesced, tail))
 
     def test_range_header_single(self):
@@ -528,35 +428,11 @@
                           tail=50)
 
 
-class TestSpecificRequestHandler(http_utils.TestCaseWithWebserver):
-    """Tests a specific request handler.
-
-    Daughter classes are expected to override _req_handler_class
-    """
-
-    # Provide a useful default
-    _req_handler_class = http_server.TestingHTTPRequestHandler
-
-    def create_transport_readonly_server(self):
-        return http_server.HttpServer(self._req_handler_class,
-                                      protocol_version=self._protocol_version)
-
-    def _testing_pycurl(self):
-        return pycurl_present and self._transport == PyCurlTransport
-
-
-class WallRequestHandler(http_server.TestingHTTPRequestHandler):
-    """Whatever request comes in, close the connection"""
-
-    def handle_one_request(self):
-        """Handle a single HTTP request, by abruptly closing the connection"""
-        self.close_connection = 1
-
-
-class TestWallServer(TestSpecificRequestHandler):
+class TestWallServer(object):
     """Tests exceptions during the connection phase"""
 
-    _req_handler_class = WallRequestHandler
+    def create_transport_readonly_server(self):
+        return HttpServer(WallRequestHandler)
 
     def test_http_has(self):
         server = self.get_readonly_server()
@@ -576,21 +452,23 @@
                           t.get, 'foo/bar')
 
 
-class BadStatusRequestHandler(http_server.TestingHTTPRequestHandler):
-    """Whatever request comes in, returns a bad status"""
-
-    def parse_request(self):
-        """Fakes handling a single HTTP request, returns a bad status"""
-        ignored = http_server.TestingHTTPRequestHandler.parse_request(self)
-        self.send_response(0, "Bad status")
-        self.close_connection = 1
-        return False
-
-
-class TestBadStatusServer(TestSpecificRequestHandler):
+class TestWallServer_urllib(TestWallServer, TestCaseWithWebserver):
+    """Tests "wall" server for urllib implementation"""
+
+    _transport = HttpTransport_urllib
+
+
+class TestWallServer_pycurl(TestWithTransport_pycurl,
+                            TestWallServer,
+                            TestCaseWithWebserver):
+    """Tests "wall" server for pycurl implementation"""
+
+
+class TestBadStatusServer(object):
     """Tests bad status from server."""
 
-    _req_handler_class = BadStatusRequestHandler
+    def create_transport_readonly_server(self):
+        return HttpServer(BadStatusRequestHandler)
 
     def test_http_has(self):
         server = self.get_readonly_server()
@@ -603,14 +481,16 @@
         self.assertRaises(errors.InvalidHttpResponse, t.get, 'foo/bar')
 
 
-class InvalidStatusRequestHandler(http_server.TestingHTTPRequestHandler):
-    """Whatever request comes in, returns an invalid status"""
-
-    def parse_request(self):
-        """Fakes handling a single HTTP request, returns a bad status"""
-        ignored = http_server.TestingHTTPRequestHandler.parse_request(self)
-        self.wfile.write("Invalid status line\r\n")
-        return False
+class TestBadStatusServer_urllib(TestBadStatusServer, TestCaseWithWebserver):
+    """Tests bad status server for urllib implementation"""
+
+    _transport = HttpTransport_urllib
+
+
+class TestBadStatusServer_pycurl(TestWithTransport_pycurl,
+                                 TestBadStatusServer,
+                                 TestCaseWithWebserver):
+    """Tests bad status server for pycurl implementation"""
 
 
 class TestInvalidStatusServer(TestBadStatusServer):
@@ -619,45 +499,28 @@
     Both implementations raises the same error as for a bad status.
     """
 
-    _req_handler_class = InvalidStatusRequestHandler
-
-    def test_http_has(self):
-        if self._testing_pycurl() and self._protocol_version == 'HTTP/1.1':
-            raise tests.KnownFailure(
-                'pycurl hangs if the server send back garbage')
-        super(TestInvalidStatusServer, self).test_http_has()
-
-    def test_http_get(self):
-        if self._testing_pycurl() and self._protocol_version == 'HTTP/1.1':
-            raise tests.KnownFailure(
-                'pycurl hangs if the server send back garbage')
-        super(TestInvalidStatusServer, self).test_http_get()
-
-
-class BadProtocolRequestHandler(http_server.TestingHTTPRequestHandler):
-    """Whatever request comes in, returns a bad protocol version"""
-
-    def parse_request(self):
-        """Fakes handling a single HTTP request, returns a bad status"""
-        ignored = http_server.TestingHTTPRequestHandler.parse_request(self)
-        # Returns an invalid protocol version, but curl just
-        # ignores it and those cannot be tested.
-        self.wfile.write("%s %d %s\r\n" % ('HTTP/0.0',
-                                           404,
-                                           'Look at my protocol version'))
-        return False
-
-
-class TestBadProtocolServer(TestSpecificRequestHandler):
+    def create_transport_readonly_server(self):
+        return HttpServer(InvalidStatusRequestHandler)
+
+
+class TestInvalidStatusServer_urllib(TestInvalidStatusServer,
+                                     TestCaseWithWebserver):
+    """Tests invalid status server for urllib implementation"""
+
+    _transport = HttpTransport_urllib
+
+
+class TestInvalidStatusServer_pycurl(TestWithTransport_pycurl,
+                                     TestInvalidStatusServer,
+                                     TestCaseWithWebserver):
+    """Tests invalid status server for pycurl implementation"""
+
+
+class TestBadProtocolServer(object):
     """Tests bad protocol from server."""
 
-    _req_handler_class = BadProtocolRequestHandler
-
-    def setUp(self):
-        if pycurl_present and self._transport == PyCurlTransport:
-            raise tests.TestNotApplicable(
-                "pycurl doesn't check the protocol version")
-        super(TestBadProtocolServer, self).setUp()
+    def create_transport_readonly_server(self):
+        return HttpServer(BadProtocolRequestHandler)
 
     def test_http_has(self):
         server = self.get_readonly_server()
@@ -670,20 +533,24 @@
         self.assertRaises(errors.InvalidHttpResponse, t.get, 'foo/bar')
 
 
-class ForbiddenRequestHandler(http_server.TestingHTTPRequestHandler):
-    """Whatever request comes in, returns a 403 code"""
-
-    def parse_request(self):
-        """Handle a single HTTP request, by replying we cannot handle it"""
-        ignored = http_server.TestingHTTPRequestHandler.parse_request(self)
-        self.send_error(403)
-        return False
-
-
-class TestForbiddenServer(TestSpecificRequestHandler):
+class TestBadProtocolServer_urllib(TestBadProtocolServer,
+                                   TestCaseWithWebserver):
+    """Tests bad protocol server for urllib implementation"""
+
+    _transport = HttpTransport_urllib
+
+# curl don't check the protocol version
+#class TestBadProtocolServer_pycurl(TestWithTransport_pycurl,
+#                                   TestBadProtocolServer,
+#                                   TestCaseWithWebserver):
+#    """Tests bad protocol server for pycurl implementation"""
+
+
+class TestForbiddenServer(object):
     """Tests forbidden server"""
 
-    _req_handler_class = ForbiddenRequestHandler
+    def create_transport_readonly_server(self):
+        return HttpServer(ForbiddenRequestHandler)
 
     def test_http_has(self):
         server = self.get_readonly_server()
@@ -696,7 +563,19 @@
         self.assertRaises(errors.TransportError, t.get, 'foo/bar')
 
 
-class TestRecordingServer(tests.TestCase):
+class TestForbiddenServer_urllib(TestForbiddenServer, TestCaseWithWebserver):
+    """Tests forbidden server for urllib implementation"""
+
+    _transport = HttpTransport_urllib
+
+
+class TestForbiddenServer_pycurl(TestWithTransport_pycurl,
+                                 TestForbiddenServer,
+                                 TestCaseWithWebserver):
+    """Tests forbidden server for pycurl implementation"""
+
+
+class TestRecordingServer(TestCase):
 
     def test_create(self):
         server = RecordingServer(expect_body_tail=None)
@@ -727,14 +606,19 @@
         self.assertEqual('abc', server.received_bytes)
 
 
-class TestRangeRequestServer(TestSpecificRequestHandler):
+class TestRangeRequestServer(object):
     """Tests readv requests against server.
 
-    We test against default "normal" server.
+    This MUST be used by daughter classes that also inherit from
+    TestCaseWithWebserver.
+
+    We can't inherit directly from TestCaseWithWebserver or the
+    test framework will try to create an instance which cannot
+    run, its implementation being incomplete.
     """
 
     def setUp(self):
-        super(TestRangeRequestServer, self).setUp()
+        TestCaseWithWebserver.setUp(self)
         self.build_tree_contents([('a', '0123456789')],)
 
     def test_readv(self):
@@ -769,269 +653,92 @@
         self.assertListRaises((errors.InvalidRange, errors.ShortReadvError,),
                               t.readv, 'a', [(12,2)])
 
-    def test_readv_multiple_get_requests(self):
-        server = self.get_readonly_server()
-        t = self._transport(server.get_url())
-        # force transport to issue multiple requests
-        t._max_readv_combine = 1
-        t._max_get_ranges = 1
-        l = list(t.readv('a', ((0, 1), (1, 1), (3, 2), (9, 1))))
-        self.assertEqual(l[0], (0, '0'))
-        self.assertEqual(l[1], (1, '1'))
-        self.assertEqual(l[2], (3, '34'))
-        self.assertEqual(l[3], (9, '9'))
-        # The server should have issued 4 requests
-        self.assertEqual(4, server.GET_request_nb)
-
-    def test_readv_get_max_size(self):
-        server = self.get_readonly_server()
-        t = self._transport(server.get_url())
-        # force transport to issue multiple requests by limiting the number of
-        # bytes by request. Note that this apply to coalesced offsets only, a
-        # single range will keep its size even if bigger than the limit.
-        t._get_max_size = 2
-        l = list(t.readv('a', ((0, 1), (1, 1), (2, 4), (6, 4))))
-        self.assertEqual(l[0], (0, '0'))
-        self.assertEqual(l[1], (1, '1'))
-        self.assertEqual(l[2], (2, '2345'))
-        self.assertEqual(l[3], (6, '6789'))
-        # The server should have issued 3 requests
-        self.assertEqual(3, server.GET_request_nb)
-
-    def test_complete_readv_leave_pipe_clean(self):
-        server = self.get_readonly_server()
-        t = self._transport(server.get_url())
-        # force transport to issue multiple requests
-        t._get_max_size = 2
-        l = list(t.readv('a', ((0, 1), (1, 1), (2, 4), (6, 4))))
-        # The server should have issued 3 requests
-        self.assertEqual(3, server.GET_request_nb)
-        self.assertEqual('0123456789', t.get_bytes('a'))
-        self.assertEqual(4, server.GET_request_nb)
-
-    def test_incomplete_readv_leave_pipe_clean(self):
-        server = self.get_readonly_server()
-        t = self._transport(server.get_url())
-        # force transport to issue multiple requests
-        t._get_max_size = 2
-        # Don't collapse readv results into a list so that we leave unread
-        # bytes on the socket
-        ireadv = iter(t.readv('a', ((0, 1), (1, 1), (2, 4), (6, 4))))
-        self.assertEqual((0, '0'), ireadv.next())
-        # The server should have issued one request so far 
-        self.assertEqual(1, server.GET_request_nb)
-        self.assertEqual('0123456789', t.get_bytes('a'))
-        # get_bytes issued an additional request, the readv pending ones are
-        # lost
-        self.assertEqual(2, server.GET_request_nb)
-
-
-class SingleRangeRequestHandler(http_server.TestingHTTPRequestHandler):
-    """Always reply to range request as if they were single.
-
-    Don't be explicit about it, just to annoy the clients.
-    """
-
-    def get_multiple_ranges(self, file, file_size, ranges):
-        """Answer as if it was a single range request and ignores the rest"""
-        (start, end) = ranges[0]
-        return self.get_single_range(file, file_size, start, end)
-
 
 class TestSingleRangeRequestServer(TestRangeRequestServer):
     """Test readv against a server which accept only single range requests"""
 
-    _req_handler_class = SingleRangeRequestHandler
-
-
-class SingleOnlyRangeRequestHandler(http_server.TestingHTTPRequestHandler):
-    """Only reply to simple range requests, errors out on multiple"""
-
-    def get_multiple_ranges(self, file, file_size, ranges):
-        """Refuses the multiple ranges request"""
-        if len(ranges) > 1:
-            file.close()
-            self.send_error(416, "Requested range not satisfiable")
-            return
-        (start, end) = ranges[0]
-        return self.get_single_range(file, file_size, start, end)
+    def create_transport_readonly_server(self):
+        return HttpServer(SingleRangeRequestHandler)
+
+
+class TestSingleRangeRequestServer_urllib(TestSingleRangeRequestServer,
+                                          TestCaseWithWebserver):
+    """Tests single range requests accepting server for urllib implementation"""
+
+    _transport = HttpTransport_urllib
+
+
+class TestSingleRangeRequestServer_pycurl(TestWithTransport_pycurl,
+                                          TestSingleRangeRequestServer,
+                                          TestCaseWithWebserver):
+    """Tests single range requests accepting server for pycurl implementation"""
 
 
 class TestSingleOnlyRangeRequestServer(TestRangeRequestServer):
     """Test readv against a server which only accept single range requests"""
 
-    _req_handler_class = SingleOnlyRangeRequestHandler
-
-
-class NoRangeRequestHandler(http_server.TestingHTTPRequestHandler):
-    """Ignore range requests without notice"""
-
-    def do_GET(self):
-        # Update the statistics
-        self.server.test_case_server.GET_request_nb += 1
-        # Just bypass the range handling done by TestingHTTPRequestHandler
-        return SimpleHTTPServer.SimpleHTTPRequestHandler.do_GET(self)
+    def create_transport_readonly_server(self):
+        return HttpServer(SingleOnlyRangeRequestHandler)
+
+
+class TestSingleOnlyRangeRequestServer_urllib(TestSingleOnlyRangeRequestServer,
+                                              TestCaseWithWebserver):
+    """Tests single range requests accepting server for urllib implementation"""
+
+    _transport = HttpTransport_urllib
+
+
+class TestSingleOnlyRangeRequestServer_pycurl(TestWithTransport_pycurl,
+                                              TestSingleOnlyRangeRequestServer,
+                                              TestCaseWithWebserver):
+    """Tests single range requests accepting server for pycurl implementation"""
 
 
 class TestNoRangeRequestServer(TestRangeRequestServer):
     """Test readv against a server which do not accept range requests"""
 
-    _req_handler_class = NoRangeRequestHandler
-
-
-class MultipleRangeWithoutContentLengthRequestHandler(
-    http_server.TestingHTTPRequestHandler):
-    """Reply to multiple range requests without content length header."""
-
-    def get_multiple_ranges(self, file, file_size, ranges):
-        self.send_response(206)
-        self.send_header('Accept-Ranges', 'bytes')
-        boundary = "%d" % random.randint(0,0x7FFFFFFF)
-        self.send_header("Content-Type",
-                         "multipart/byteranges; boundary=%s" % boundary)
-        self.end_headers()
-        for (start, end) in ranges:
-            self.wfile.write("--%s\r\n" % boundary)
-            self.send_header("Content-type", 'application/octet-stream')
-            self.send_header("Content-Range", "bytes %d-%d/%d" % (start,
-                                                                  end,
-                                                                  file_size))
-            self.end_headers()
-            self.send_range_content(file, start, end - start + 1)
-        # Final boundary
-        self.wfile.write("--%s\r\n" % boundary)
-
-
-class TestMultipleRangeWithoutContentLengthServer(TestRangeRequestServer):
-
-    _req_handler_class = MultipleRangeWithoutContentLengthRequestHandler
-
-
-class TruncatedMultipleRangeRequestHandler(
-    http_server.TestingHTTPRequestHandler):
-    """Reply to multiple range requests truncating the last ones.
-
-    This server generates responses whose Content-Length describes all the
-    ranges, but fail to include the last ones leading to client short reads.
-    This has been observed randomly with lighttpd (bug #179368).
+    def create_transport_readonly_server(self):
+        return HttpServer(NoRangeRequestHandler)
+
+
+class TestNoRangeRequestServer_urllib(TestNoRangeRequestServer,
+                                      TestCaseWithWebserver):
+    """Tests range requests refusing server for urllib implementation"""
+
+    _transport = HttpTransport_urllib
+
+
+class TestNoRangeRequestServer_pycurl(TestWithTransport_pycurl,
+                               TestNoRangeRequestServer,
+                               TestCaseWithWebserver):
+    """Tests range requests refusing server for pycurl implementation"""
+
+
+class TestLimitedRangeRequestServer(object):
+    """Tests readv requests against server that errors out on too much ranges.
+
+    This MUST be used by daughter classes that also inherit from
+    TestCaseWithWebserver.
+
+    We can't inherit directly from TestCaseWithWebserver or the
+    test framework will try to create an instance which cannot
+    run, its implementation being incomplete.
     """
 
-    _truncated_ranges = 2
-
-    def get_multiple_ranges(self, file, file_size, ranges):
-        self.send_response(206)
-        self.send_header('Accept-Ranges', 'bytes')
-        boundary = 'tagada'
-        self.send_header('Content-Type',
-                         'multipart/byteranges; boundary=%s' % boundary)
-        boundary_line = '--%s\r\n' % boundary
-        # Calculate the Content-Length
-        content_length = 0
-        for (start, end) in ranges:
-            content_length += len(boundary_line)
-            content_length += self._header_line_length(
-                'Content-type', 'application/octet-stream')
-            content_length += self._header_line_length(
-                'Content-Range', 'bytes %d-%d/%d' % (start, end, file_size))
-            content_length += len('\r\n') # end headers
-            content_length += end - start # + 1
-        content_length += len(boundary_line)
-        self.send_header('Content-length', content_length)
-        self.end_headers()
-
-        # Send the multipart body
-        cur = 0
-        for (start, end) in ranges:
-            self.wfile.write(boundary_line)
-            self.send_header('Content-type', 'application/octet-stream')
-            self.send_header('Content-Range', 'bytes %d-%d/%d'
-                             % (start, end, file_size))
-            self.end_headers()
-            if cur + self._truncated_ranges >= len(ranges):
-                # Abruptly ends the response and close the connection
-                self.close_connection = 1
-                return
-            self.send_range_content(file, start, end - start + 1)
-            cur += 1
-        # No final boundary
-        self.wfile.write(boundary_line)
-
-
-class TestTruncatedMultipleRangeServer(TestSpecificRequestHandler):
-
-    _req_handler_class = TruncatedMultipleRangeRequestHandler
-
-    def setUp(self):
-        super(TestTruncatedMultipleRangeServer, self).setUp()
-        self.build_tree_contents([('a', '0123456789')],)
-
-    def test_readv_with_short_reads(self):
-        server = self.get_readonly_server()
-        t = self._transport(server.get_url())
-        # Force separate ranges for each offset
-        t._bytes_to_read_before_seek = 0
-        ireadv = iter(t.readv('a', ((0, 1), (2, 1), (4, 2), (9, 1))))
-        self.assertEqual((0, '0'), ireadv.next())
-        self.assertEqual((2, '2'), ireadv.next())
-        if not self._testing_pycurl():
-            # Only one request have been issued so far (except for pycurl that
-            # try to read the whole response at once)
-            self.assertEqual(1, server.GET_request_nb)
-        self.assertEqual((4, '45'), ireadv.next())
-        self.assertEqual((9, '9'), ireadv.next())
-        # Both implementations issue 3 requests but:
-        # - urllib does two multiple (4 ranges, then 2 ranges) then a single
-        #   range,
-        # - pycurl does two multiple (4 ranges, 4 ranges) then a single range
-        self.assertEqual(3, server.GET_request_nb)
-        # Finally the client have tried a single range request and stays in
-        # that mode
-        self.assertEqual('single', t._range_hint)
-
-class LimitedRangeRequestHandler(http_server.TestingHTTPRequestHandler):
-    """Errors out when range specifiers exceed the limit"""
-
-    def get_multiple_ranges(self, file, file_size, ranges):
-        """Refuses the multiple ranges request"""
-        tcs = self.server.test_case_server
-        if tcs.range_limit is not None and len(ranges) > tcs.range_limit:
-            file.close()
-            # Emulate apache behavior
-            self.send_error(400, "Bad Request")
-            return
-        return http_server.TestingHTTPRequestHandler.get_multiple_ranges(
-            self, file, file_size, ranges)
-
-
-class LimitedRangeHTTPServer(http_server.HttpServer):
-    """An HttpServer erroring out on requests with too much range specifiers"""
-
-    def __init__(self, request_handler=LimitedRangeRequestHandler,
-                 protocol_version=None,
-                 range_limit=None):
-        http_server.HttpServer.__init__(self, request_handler,
-                                        protocol_version=protocol_version)
-        self.range_limit = range_limit
-
-
-class TestLimitedRangeRequestServer(http_utils.TestCaseWithWebserver):
-    """Tests readv requests against a server erroring out on too much ranges."""
-
-    # Requests with more range specifiers will error out
     range_limit = 3
 
     def create_transport_readonly_server(self):
-        return LimitedRangeHTTPServer(range_limit=self.range_limit,
-                                      protocol_version=self._protocol_version)
+        # Requests with more range specifiers will error out
+        return LimitedRangeHTTPServer(range_limit=self.range_limit)
 
     def get_transport(self):
         return self._transport(self.get_readonly_server().get_url())
 
     def setUp(self):
-        http_utils.TestCaseWithWebserver.setUp(self)
+        TestCaseWithWebserver.setUp(self)
         # We need to manipulate ranges that correspond to real chunks in the
         # response, so we build a content appropriately.
-        filler = ''.join(['abcdefghij' for x in range(102)])
+        filler = ''.join(['abcdefghij' for _ in range(102)])
         content = ''.join(['%04d' % v + filler for v in range(16)])
         self.build_tree_contents([('a', content)],)
 
@@ -1042,7 +749,7 @@
         self.assertEqual(l[1], (1024, '0001'))
         self.assertEqual(1, self.get_readonly_server().GET_request_nb)
 
-    def test_more_ranges(self):
+    def test_a_lot_of_ranges(self):
         t = self.get_transport()
         l = list(t.readv('a', ((0, 4), (1024, 4), (4096, 4), (8192, 4))))
         self.assertEqual(l[0], (0, '0000'))
@@ -1050,23 +757,36 @@
         self.assertEqual(l[2], (4096, '0004'))
         self.assertEqual(l[3], (8192, '0008'))
         # The server will refuse to serve the first request (too much ranges),
-        # a second request will succeed.
+        # a second request will succeeds.
         self.assertEqual(2, self.get_readonly_server().GET_request_nb)
 
 
-class TestHttpProxyWhiteBox(tests.TestCase):
+class TestLimitedRangeRequestServer_urllib(TestLimitedRangeRequestServer,
+                                          TestCaseWithWebserver):
+    """Tests limited range requests server for urllib implementation"""
+
+    _transport = HttpTransport_urllib
+
+
+class TestLimitedRangeRequestServer_pycurl(TestWithTransport_pycurl,
+                                          TestLimitedRangeRequestServer,
+                                          TestCaseWithWebserver):
+    """Tests limited range requests server for pycurl implementation"""
+
+
+
+class TestHttpProxyWhiteBox(TestCase):
     """Whitebox test proxy http authorization.
 
     Only the urllib implementation is tested here.
     """
 
     def setUp(self):
-        tests.TestCase.setUp(self)
+        TestCase.setUp(self)
         self._old_env = {}
 
     def tearDown(self):
         self._restore_env()
-        tests.TestCase.tearDown(self)
 
     def _install_env(self, env):
         for name, value in env.iteritems():
@@ -1077,8 +797,8 @@
             osutils.set_or_unset_env(name, value)
 
     def _proxied_request(self):
-        handler = _urllib2_wrappers.ProxyHandler()
-        request = _urllib2_wrappers.Request('GET','http://baz/buzzle')
+        handler = ProxyHandler()
+        request = Request('GET','http://baz/buzzle')
         handler.set_proxy(request, 'http')
         return request
 
@@ -1093,9 +813,16 @@
         self.assertRaises(errors.InvalidURL, self._proxied_request)
 
 
-class TestProxyHttpServer(http_utils.TestCaseWithTwoWebservers):
+class TestProxyHttpServer(object):
     """Tests proxy server.
 
+    This MUST be used by daughter classes that also inherit from
+    TestCaseWithTwoWebservers.
+
+    We can't inherit directly from TestCaseWithTwoWebservers or
+    the test framework will try to create an instance which
+    cannot run, its implementation being incomplete.
+
     Be aware that we do not setup a real proxy here. Instead, we
     check that the *connection* goes through the proxy by serving
     different content (the faked proxy server append '-proxied'
@@ -1106,31 +833,23 @@
     # test https connections.
 
     def setUp(self):
-        super(TestProxyHttpServer, self).setUp()
+        TestCaseWithTwoWebservers.setUp(self)
         self.build_tree_contents([('foo', 'contents of foo\n'),
                                   ('foo-proxied', 'proxied contents of foo\n')])
         # Let's setup some attributes for tests
         self.server = self.get_readonly_server()
         self.proxy_address = '%s:%d' % (self.server.host, self.server.port)
-        if self._testing_pycurl():
-            # Oh my ! pycurl does not check for the port as part of
-            # no_proxy :-( So we just test the host part
-            self.no_proxy_host = 'localhost'
-        else:
-            self.no_proxy_host = self.proxy_address
+        self.no_proxy_host = self.proxy_address
         # The secondary server is the proxy
         self.proxy = self.get_secondary_server()
         self.proxy_url = self.proxy.get_url()
         self._old_env = {}
 
-    def _testing_pycurl(self):
-        return pycurl_present and self._transport == PyCurlTransport
-
     def create_transport_secondary_server(self):
         """Creates an http server that will serve files with
         '-proxied' appended to their names.
         """
-        return http_utils.ProxyServer(protocol_version=self._protocol_version)
+        return ProxyServer()
 
     def _install_env(self, env):
         for name, value in env.iteritems():
@@ -1162,12 +881,6 @@
         self.proxied_in_env({'http_proxy': self.proxy_url})
 
     def test_HTTP_PROXY(self):
-        if self._testing_pycurl():
-            # pycurl does not check HTTP_PROXY for security reasons
-            # (for use in a CGI context that we do not care
-            # about. Should we ?)
-            raise tests.TestNotApplicable(
-                'pycurl does not check HTTP_PROXY for security reasons')
         self.proxied_in_env({'HTTP_PROXY': self.proxy_url})
 
     def test_all_proxy(self):
@@ -1181,9 +894,6 @@
                                  'no_proxy': self.no_proxy_host})
 
     def test_HTTP_PROXY_with_NO_PROXY(self):
-        if self._testing_pycurl():
-            raise tests.TestNotApplicable(
-                'pycurl does not check HTTP_PROXY for security reasons')
         self.not_proxied_in_env({'HTTP_PROXY': self.proxy_url,
                                  'NO_PROXY': self.no_proxy_host})
 
@@ -1196,29 +906,63 @@
                                  'NO_PROXY': self.no_proxy_host})
 
     def test_http_proxy_without_scheme(self):
-        if self._testing_pycurl():
-            # pycurl *ignores* invalid proxy env variables. If that ever change
-            # in the future, this test will fail indicating that pycurl do not
-            # ignore anymore such variables.
-            self.not_proxied_in_env({'http_proxy': self.proxy_address})
-        else:
-            self.assertRaises(errors.InvalidURL,
-                              self.proxied_in_env,
-                              {'http_proxy': self.proxy_address})
-
-
-class TestRanges(http_utils.TestCaseWithWebserver):
-    """Test the Range header in GET methods."""
-
-    def setUp(self):
-        http_utils.TestCaseWithWebserver.setUp(self)
+        self.assertRaises(errors.InvalidURL,
+                          self.proxied_in_env,
+                          {'http_proxy': self.proxy_address})
+
+
+class TestProxyHttpServer_urllib(TestProxyHttpServer,
+                                 TestCaseWithTwoWebservers):
+    """Tests proxy server for urllib implementation"""
+
+    _transport = HttpTransport_urllib
+
+
+class TestProxyHttpServer_pycurl(TestWithTransport_pycurl,
+                                 TestProxyHttpServer,
+                                 TestCaseWithTwoWebservers):
+    """Tests proxy server for pycurl implementation"""
+
+    def setUp(self):
+        TestProxyHttpServer.setUp(self)
+        # Oh my ! pycurl does not check for the port as part of
+        # no_proxy :-( So we just test the host part
+        self.no_proxy_host = 'localhost'
+
+    def test_HTTP_PROXY(self):
+        # pycurl do not check HTTP_PROXY for security reasons
+        # (for use in a CGI context that we do not care
+        # about. Should we ?)
+        raise TestSkipped()
+
+    def test_HTTP_PROXY_with_NO_PROXY(self):
+        raise TestSkipped()
+
+    def test_http_proxy_without_scheme(self):
+        # pycurl *ignores* invalid proxy env variables. If that
+        # ever change in the future, this test will fail
+        # indicating that pycurl do not ignore anymore such
+        # variables.
+        self.not_proxied_in_env({'http_proxy': self.proxy_address})
+
+
+class TestRanges(object):
+    """Test the Range header in GET methods..
+
+    This MUST be used by daughter classes that also inherit from
+    TestCaseWithWebserver.
+
+    We can't inherit directly from TestCaseWithWebserver or the
+    test framework will try to create an instance which cannot
+    run, its implementation being incomplete.
+    """
+
+    def setUp(self):
+        TestCaseWithWebserver.setUp(self)
         self.build_tree_contents([('a', '0123456789')],)
         server = self.get_readonly_server()
         self.transport = self._transport(server.get_url())
 
-    def create_transport_readonly_server(self):
-        return http_server.HttpServer(protocol_version=self._protocol_version)
-
     def _file_contents(self, relpath, ranges):
         offsets = [ (start, end - start + 1) for start, end in ranges]
         coalesce = self.transport._coalesce_offsets
@@ -1232,35 +976,51 @@
     def _file_tail(self, relpath, tail_amount):
         code, data = self.transport._get(relpath, [], tail_amount)
         self.assertTrue(code in (200, 206),'_get returns: %d' % code)
-        data.seek(-tail_amount, 2)
+        data.seek(-tail_amount + 1, 2)
         return data.read(tail_amount)
 
     def test_range_header(self):
         # Valid ranges
         map(self.assertEqual,['0', '234'],
             list(self._file_contents('a', [(0,0), (2,4)])),)
-
-    def test_range_header_tail(self):
+        # Tail
         self.assertEqual('789', self._file_tail('a', 3))
-
-    def test_syntactically_invalid_range_header(self):
-        self.assertListRaises(errors.InvalidHttpRange,
+        # Syntactically invalid range
+        self.assertListRaises(errors.InvalidRange,
                           self._file_contents, 'a', [(4, 3)])
-
-    def test_semantically_invalid_range_header(self):
-        self.assertListRaises(errors.InvalidHttpRange,
+        # Semantically invalid range
+        self.assertListRaises(errors.InvalidRange,
                           self._file_contents, 'a', [(42, 128)])
 
 
-class TestHTTPRedirections(http_utils.TestCaseWithRedirectedWebserver):
-    """Test redirection between http servers."""
+class TestRanges_urllib(TestRanges, TestCaseWithWebserver):
+    """Test the Range header in GET methods for urllib implementation"""
+
+    _transport = HttpTransport_urllib
+
+
+class TestRanges_pycurl(TestWithTransport_pycurl,
+                        TestRanges,
+                        TestCaseWithWebserver):
+    """Test the Range header in GET methods for pycurl implementation"""
+
+
+class TestHTTPRedirections(object):
+    """Test redirection between http servers.
+
+    This MUST be used by daughter classes that also inherit from
+    TestCaseWithRedirectedWebserver.
+
+    We can't inherit directly from TestCaseWithTwoWebservers or the
+    test framework will try to create an instance which cannot
+    run, its implementation being incomplete. 
+    """
 
     def create_transport_secondary_server(self):
         """Create the secondary server redirecting to the primary server"""
         new = self.get_readonly_server()
 
-        redirecting = http_utils.HTTPServerRedirecting(
-            protocol_version=self._protocol_version)
+        redirecting = HTTPServerRedirecting()
         redirecting.redirect_to(new.host, new.port)
         return redirecting
 
@@ -1286,24 +1046,32 @@
         self.assertEqual([], bundle.revisions)
 
 
-class RedirectedRequest(_urllib2_wrappers.Request):
-    """Request following redirections. """
-
-    init_orig = _urllib2_wrappers.Request.__init__
+class TestHTTPRedirections_urllib(TestHTTPRedirections,
+                                  TestCaseWithRedirectedWebserver):
+    """Tests redirections for urllib implementation"""
+
+    _transport = HttpTransport_urllib
+
+
+
+class TestHTTPRedirections_pycurl(TestWithTransport_pycurl,
+                                  TestHTTPRedirections,
+                                  TestCaseWithRedirectedWebserver):
+    """Tests redirections for pycurl implementation"""
+
+
+class RedirectedRequest(Request):
+    """Request following redirections"""
+
+    init_orig = Request.__init__
 
     def __init__(self, method, url, *args, **kwargs):
-        """Constructor.
-
-        """
-        # Since the tests using this class will replace
-        # _urllib2_wrappers.Request, we can't just call the base class __init__
-        # or we'll loop.
         RedirectedRequest.init_orig(self, method, url, args, kwargs)
         self.follow_redirections = True
 
 
-class TestHTTPSilentRedirections(http_utils.TestCaseWithRedirectedWebserver):
-    """Test redirections.
+class TestHTTPSilentRedirections_urllib(TestCaseWithRedirectedWebserver):
+    """Test redirections provided by urllib.
 
     http implementations do not redirect silently anymore (they
     do not redirect at all in fact). The mechanism is still in
@@ -1316,11 +1084,10 @@
     -- vila 20070212
     """
 
+    _transport = HttpTransport_urllib
+
     def setUp(self):
-        if pycurl_present and self._transport == PyCurlTransport:
-            raise tests.TestNotApplicable(
-                "pycurl doesn't redirect silently annymore")
-        super(TestHTTPSilentRedirections, self).setUp()
+        super(TestHTTPSilentRedirections_urllib, self).setUp()
         self.setup_redirected_request()
         self.addCleanup(self.cleanup_redirected_request)
         self.build_tree_contents([('a','a'),
@@ -1347,8 +1114,7 @@
 
     def create_transport_secondary_server(self):
         """Create the secondary server, redirections are defined in the tests"""
-        return http_utils.HTTPServerRedirecting(
-            protocol_version=self._protocol_version)
+        return HTTPServerRedirecting()
 
     def test_one_redirection(self):
         t = self.old_transport
@@ -1370,18 +1136,23 @@
                                        self.old_server.port)
         new_prefix = 'http://%s:%s' % (self.new_server.host,
                                        self.new_server.port)
-        self.old_server.redirections = [
-            ('/1(.*)', r'%s/2\1' % (old_prefix), 302),
-            ('/2(.*)', r'%s/3\1' % (old_prefix), 303),
-            ('/3(.*)', r'%s/4\1' % (old_prefix), 307),
-            ('/4(.*)', r'%s/5\1' % (new_prefix), 301),
-            ('(/[^/]+)', r'%s/1\1' % (old_prefix), 301),
-            ]
+        self.old_server.redirections = \
+            [('/1(.*)', r'%s/2\1' % (old_prefix), 302),
+             ('/2(.*)', r'%s/3\1' % (old_prefix), 303),
+             ('/3(.*)', r'%s/4\1' % (old_prefix), 307),
+             ('/4(.*)', r'%s/5\1' % (new_prefix), 301),
+             ('(/[^/]+)', r'%s/1\1' % (old_prefix), 301),
+             ]
         self.assertEquals('redirected 5 times',t._perform(req).read())
 
 
-class TestDoCatchRedirections(http_utils.TestCaseWithRedirectedWebserver):
-    """Test transport.do_catching_redirections."""
+class TestDoCatchRedirections(TestCaseWithRedirectedWebserver):
+    """Test transport.do_catching_redirections.
+
+    We arbitrarily choose to use urllib transports
+    """
+
+    _transport = HttpTransport_urllib
 
     def setUp(self):
         super(TestDoCatchRedirections, self).setUp()
@@ -1397,8 +1168,7 @@
 
         # We use None for redirected so that we fail if redirected
         self.assertEquals('0123456789',
-                          transport.do_catching_redirections(
-                self.get_a, t, None).read())
+                          do_catching_redirections(self.get_a, t, None).read())
 
     def test_one_redirection(self):
         self.redirections = 0
@@ -1409,8 +1179,10 @@
             return self._transport(dir)
 
         self.assertEquals('0123456789',
-                          transport.do_catching_redirections(
-                self.get_a, self.old_transport, redirected).read())
+                          do_catching_redirections(self.get_a,
+                                                   self.old_transport,
+                                                   redirected
+                                                   ).read())
         self.assertEquals(1, self.redirections)
 
     def test_redirection_loop(self):
@@ -1421,38 +1193,31 @@
             # a/a/a
             return self.old_transport.clone(exception.target)
 
-        self.assertRaises(errors.TooManyRedirections,
-                          transport.do_catching_redirections,
+        self.assertRaises(errors.TooManyRedirections, do_catching_redirections,
                           self.get_a, self.old_transport, redirected)
 
 
-class TestAuth(http_utils.TestCaseWithWebserver):
-    """Test authentication scheme"""
-
-    _auth_header = 'Authorization'
+class TestAuth(object):
+    """Test some authentication scheme specified by daughter class.
+
+    This MUST be used by daughter classes that also inherit from
+    either TestCaseWithWebserver or TestCaseWithTwoWebservers.
+    """
+
     _password_prompt_prefix = ''
 
     def setUp(self):
-        super(TestAuth, self).setUp()
-        self.server = self.get_readonly_server()
+        """Set up the test environment
+
+        Daughter classes should set up their own environment
+        (including self.server) and explicitely call this
+        method. This is needed because we want to reuse the same
+        tests for proxy and no-proxy accesses which have
+        different ways of setting self.server.
+        """
         self.build_tree_contents([('a', 'contents of a\n'),
                                   ('b', 'contents of b\n'),])
 
-    def create_transport_readonly_server(self):
-        if self._auth_scheme == 'basic':
-            server = http_utils.HTTPBasicAuthServer(
-                protocol_version=self._protocol_version)
-        else:
-            if self._auth_scheme != 'digest':
-                raise AssertionError('Unknown auth scheme: %r'
-                                     % self._auth_scheme)
-            server = http_utils.HTTPDigestAuthServer(
-                protocol_version=self._protocol_version)
-        return server
-
-    def _testing_pycurl(self):
-        return pycurl_present and self._transport == PyCurlTransport
-
     def get_user_url(self, user=None, password=None):
         """Build an url embedding user and password"""
         url = '%s://' % self.server._url_protocol
@@ -1464,9 +1229,6 @@
         url += '%s:%s/' % (self.server.host, self.server.port)
         return url
 
-    def get_user_transport(self, user=None, password=None):
-        return self._transport(self.get_user_url(user, password))
-
     def test_no_user(self):
         self.server.add_user('joe', 'foo')
         t = self.get_user_transport()
@@ -1506,15 +1268,10 @@
         self.assertEqual(2, self.server.auth_required_errors)
 
     def test_prompt_for_password(self):
-        if self._testing_pycurl():
-            raise tests.TestNotApplicable(
-                'pycurl cannot prompt, it handles auth by embedding'
-                ' user:pass in urls only')
-
         self.server.add_user('joe', 'foo')
         t = self.get_user_transport('joe', None)
-        stdout = tests.StringIOWrapper()
-        ui.ui_factory = tests.TestUIFactory(stdin='foo\n', stdout=stdout)
+        stdout = StringIOWrapper()
+        ui.ui_factory = TestUIFactory(stdin='foo\n', stdout=stdout)
         self.assertEqual('contents of a\n',t.get('a').read())
         # stdin should be empty
         self.assertEqual('', ui.ui_factory.stdin.readline())
@@ -1538,18 +1295,13 @@
         self.assertEquals(expected_prompt, actual_prompt)
 
     def test_no_prompt_for_password_when_using_auth_config(self):
-        if self._testing_pycurl():
-            raise tests.TestNotApplicable(
-                'pycurl does not support authentication.conf'
-                ' since it cannot prompt')
-
         user =' joe'
         password = 'foo'
         stdin_content = 'bar\n'  # Not the right password
         self.server.add_user(user, password)
         t = self.get_user_transport(user, None)
-        ui.ui_factory = tests.TestUIFactory(stdin=stdin_content,
-                                            stdout=tests.StringIOWrapper())
+        ui.ui_factory = TestUIFactory(stdin=stdin_content,
+                                      stdout=StringIOWrapper())
         # Create a minimal config file with the right password
         conf = config.AuthenticationConfig()
         conf._get_config().update(
@@ -1563,38 +1315,40 @@
         # Only one 'Authentication Required' error should occur
         self.assertEqual(1, self.server.auth_required_errors)
 
-    def test_changing_nonce(self):
-        if self._auth_scheme != 'digest':
-            raise tests.TestNotApplicable('HTTP auth digest only test')
-        if self._testing_pycurl():
-            raise tests.KnownFailure(
-                'pycurl does not handle a nonce change')
-        self.server.add_user('joe', 'foo')
-        t = self.get_user_transport('joe', 'foo')
-        self.assertEqual('contents of a\n', t.get('a').read())
-        self.assertEqual('contents of b\n', t.get('b').read())
-        # Only one 'Authentication Required' error should have
-        # occured so far
-        self.assertEqual(1, self.server.auth_required_errors)
-        # The server invalidates the current nonce
-        self.server.auth_nonce = self.server.auth_nonce + '. No, now!'
-        self.assertEqual('contents of a\n', t.get('a').read())
-        # Two 'Authentication Required' errors should occur (the
-        # initial 'who are you' and a second 'who are you' with the new nonce)
-        self.assertEqual(2, self.server.auth_required_errors)
-
+
+
+class TestHTTPAuth(TestAuth):
+    """Test HTTP authentication schemes.
+
+    Daughter classes MUST inherit from TestCaseWithWebserver too.
+    """
+
+    _auth_header = 'Authorization'
+
+    def setUp(self):
+        TestCaseWithWebserver.setUp(self)
+        self.server = self.get_readonly_server()
+        TestAuth.setUp(self)
+
+    def get_user_transport(self, user=None, password=None):
+        return self._transport(self.get_user_url(user, password))
 
 
 class TestProxyAuth(TestAuth):
-    """Test proxy authentication schemes."""
+    """Test proxy authentication schemes.
 
+    Daughter classes MUST also inherit from TestCaseWithWebserver.
+    """
     _auth_header = 'Proxy-authorization'
-    _password_prompt_prefix='Proxy '
+    _password_prompt_prefix = 'Proxy '
+
 
     def setUp(self):
-        super(TestProxyAuth, self).setUp()
+        TestCaseWithWebserver.setUp(self)
+        self.server = self.get_readonly_server()
         self._old_env = {}
         self.addCleanup(self._restore_env)
+        TestAuth.setUp(self)
         # Override the contents to avoid false positives
         self.build_tree_contents([('a', 'not proxied contents of a\n'),
                                   ('b', 'not proxied contents of b\n'),
@@ -1602,18 +1356,6 @@
                                   ('b-proxied', 'contents of b\n'),
                                   ])
 
-    def create_transport_readonly_server(self):
-        if self._auth_scheme == 'basic':
-            server = http_utils.ProxyBasicAuthServer(
-                protocol_version=self._protocol_version)
-        else:
-            if self._auth_scheme != 'digest':
-                raise AssertionError('Unknown auth scheme: %r'
-                                     % self._auth_scheme)
-            server = http_utils.ProxyDigestAuthServer(
-                protocol_version=self._protocol_version)
-        return server
-
     def get_user_transport(self, user=None, password=None):
         self._install_env({'all_proxy': self.get_user_url(user, password)})
         return self._transport(self.server.get_url())
@@ -1626,126 +1368,59 @@
         for name, value in self._old_env.iteritems():
             osutils.set_or_unset_env(name, value)
 
-    def test_empty_pass(self):
-        if self._testing_pycurl():
-            import pycurl
-            if pycurl.version_info()[1] < '7.16.0':
-                raise tests.KnownFailure(
-                    'pycurl < 7.16.0 does not handle empty proxy passwords')
-        super(TestProxyAuth, self).test_empty_pass()
-
-
-class SampleSocket(object):
-    """A socket-like object for use in testing the HTTP request handler."""
-
-    def __init__(self, socket_read_content):
-        """Constructs a sample socket.
-
-        :param socket_read_content: a byte sequence
-        """
-        # Use plain python StringIO so we can monkey-patch the close method to
-        # not discard the contents.
-        from StringIO import StringIO
-        self.readfile = StringIO(socket_read_content)
-        self.writefile = StringIO()
-        self.writefile.close = lambda: None
-
-    def makefile(self, mode='r', bufsize=None):
-        if 'r' in mode:
-            return self.readfile
-        else:
-            return self.writefile
-
-
-class SmartHTTPTunnellingTest(tests.TestCaseWithTransport):
-
-    def setUp(self):
-        super(SmartHTTPTunnellingTest, self).setUp()
-        # We use the VFS layer as part of HTTP tunnelling tests.
-        self._captureVar('BZR_NO_SMART_VFS', None)
-        self.transport_readonly_server = http_utils.HTTPServerWithSmarts
-
-    def create_transport_readonly_server(self):
-        return http_utils.HTTPServerWithSmarts(
-            protocol_version=self._protocol_version)
-
-    def test_open_bzrdir(self):
-        branch = self.make_branch('relpath')
-        http_server = self.get_readonly_server()
-        url = http_server.get_url() + 'relpath'
-        bd = bzrdir.BzrDir.open(url)
-        self.assertIsInstance(bd, _mod_remote.RemoteBzrDir)
-
-    def test_bulk_data(self):
-        # We should be able to send and receive bulk data in a single message.
-        # The 'readv' command in the smart protocol both sends and receives
-        # bulk data, so we use that.
-        self.build_tree(['data-file'])
-        http_server = self.get_readonly_server()
-        http_transport = self._transport(http_server.get_url())
-        medium = http_transport.get_smart_medium()
-        # Since we provide the medium, the url below will be mostly ignored
-        # during the test, as long as the path is '/'.
-        remote_transport = remote.RemoteTransport('bzr://fake_host/',
-                                                  medium=medium)
-        self.assertEqual(
-            [(0, "c")], list(remote_transport.readv("data-file", [(0,1)])))
-
-    def test_http_send_smart_request(self):
-
-        post_body = 'hello\n'
-        expected_reply_body = 'ok\x012\n'
-
-        http_server = self.get_readonly_server()
-        http_transport = self._transport(http_server.get_url())
-        medium = http_transport.get_smart_medium()
-        response = medium.send_http_smart_request(post_body)
-        reply_body = response.read()
-        self.assertEqual(expected_reply_body, reply_body)
-
-    def test_smart_http_server_post_request_handler(self):
-        httpd = self.get_readonly_server()._get_httpd()
-
-        socket = SampleSocket(
-            'POST /.bzr/smart %s \r\n' % self._protocol_version
-            # HTTP/1.1 posts must have a Content-Length (but it doesn't hurt
-            # for 1.0)
-            + 'Content-Length: 6\r\n'
-            '\r\n'
-            'hello\n')
-        # Beware: the ('localhost', 80) below is the
-        # client_address parameter, but we don't have one because
-        # we have defined a socket which is not bound to an
-        # address. The test framework never uses this client
-        # address, so far...
-        request_handler = http_utils.SmartRequestHandler(socket,
-                                                         ('localhost', 80),
-                                                         httpd)
-        response = socket.writefile.getvalue()
-        self.assertStartsWith(response, '%s 200 ' % self._protocol_version)
-        # This includes the end of the HTTP headers, and all the body.
-        expected_end_of_response = '\r\n\r\nok\x012\n'
-        self.assertEndsWith(response, expected_end_of_response)
-
-
-class ForbiddenRequestHandler(http_server.TestingHTTPRequestHandler):
-    """No smart server here request handler."""
-
-    def do_POST(self):
-        self.send_error(403, "Forbidden")
-
-
-class SmartClientAgainstNotSmartServer(TestSpecificRequestHandler):
-    """Test smart client behaviour against an http server without smarts."""
-
-    _req_handler_class = ForbiddenRequestHandler
-
-    def test_probe_smart_server(self):
-        """Test error handling against server refusing smart requests."""
-        server = self.get_readonly_server()
-        t = self._transport(server.get_url())
-        # No need to build a valid smart request here, the server will not even
-        # try to interpret it.
-        self.assertRaises(errors.SmartProtocolError,
-                          t.send_http_smart_request, 'whatever')
+
+class TestHTTPBasicAuth(TestHTTPAuth, TestCaseWithWebserver):
+    """Test http basic authentication scheme"""
+
+    _transport = HttpTransport_urllib
+
+    def create_transport_readonly_server(self):
+        return HTTPBasicAuthServer()
+
+
+class TestHTTPProxyBasicAuth(TestProxyAuth, TestCaseWithWebserver):
+    """Test proxy basic authentication scheme"""
+
+    _transport = HttpTransport_urllib
+
+    def create_transport_readonly_server(self):
+        return ProxyBasicAuthServer()
+
+
+class TestDigestAuth(object):
+    """Digest Authentication specific tests"""
+
+    def test_changing_nonce(self):
+        self.server.add_user('joe', 'foo')
+        t = self.get_user_transport('joe', 'foo')
+        self.assertEqual('contents of a\n', t.get('a').read())
+        self.assertEqual('contents of b\n', t.get('b').read())
+        # Only one 'Authentication Required' error should have
+        # occured so far
+        self.assertEqual(1, self.server.auth_required_errors)
+        # The server invalidates the current nonce
+        self.server.auth_nonce = self.server.auth_nonce + '. No, now!'
+        self.assertEqual('contents of a\n', t.get('a').read())
+        # Two 'Authentication Required' errors should occur (the
+        # initial 'who are you' and a second 'who are you' with the new nonce)
+        self.assertEqual(2, self.server.auth_required_errors)
+
+
+class TestHTTPDigestAuth(TestHTTPAuth, TestDigestAuth, TestCaseWithWebserver):
+    """Test http digest authentication scheme"""
+
+    _transport = HttpTransport_urllib
+
+    def create_transport_readonly_server(self):
+        return HTTPDigestAuthServer()
+
+
+class TestHTTPProxyDigestAuth(TestProxyAuth, TestDigestAuth,
+                              TestCaseWithWebserver):
+    """Test proxy digest authentication scheme"""
+
+    _transport = HttpTransport_urllib
+
+    def create_transport_readonly_server(self):
+        return ProxyDigestAuthServer()
 

=== removed file 'bzrlib/tests/test_http_implementations.py'
--- bzrlib/tests/test_http_implementations.py	2007-12-21 12:20:33 +0000
+++ bzrlib/tests/test_http_implementations.py	1970-01-01 00:00:00 +0000
@@ -1,51 +0,0 @@
-# Copyright (C) 2007 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Tests for HTTP transports and servers implementations.
-
-(transport, server) implementations tested here are supplied by
-HTTPTestProviderAdapter. Note that a server is characterized by a request
-handler class.
-
-Transport implementations are normally tested via
-test_transport_implementations. The tests here are about the variations in HTTP
-protocol implementation to guarantee the robustness of our transports.
-"""
-
-import errno
-import SimpleHTTPServer
-import socket
-
-import bzrlib
-from bzrlib import (
-    config,
-    errors,
-    osutils,
-    tests,
-    transport,
-    ui,
-    urlutils,
-    )
-from bzrlib.tests import (
-    http_server,
-    http_utils,
-    )
-from bzrlib.transport.http import (
-    _urllib,
-    _urllib2_wrappers,
-    )
-
-

=== modified file 'bzrlib/tests/test_http_response.py'
--- bzrlib/tests/test_http_response.py	2008-07-15 13:11:53 +0000
+++ bzrlib/tests/test_http_response.py	2006-10-16 01:50:48 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007 Canonical Ltd
+# Copyright (C) 2005, 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -14,462 +14,292 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-"""Tests from HTTP response parsing.
-
-The handle_response method read the response body of a GET request an returns
-the corresponding RangeFile.
-
-There are four different kinds of RangeFile:
-- a whole file whose size is unknown, seen as a simple byte stream,
-- a whole file whose size is known, we can't read past its end,
-- a single range file, a part of a file with a start and a size,
-- a multiple range file, several consecutive parts with known start offset
-  and size.
-
-Some properties are common to all kinds:
-- seek can only be forward (its really a socket underneath),
-- read can't cross ranges,
-- successive ranges are taken into account transparently,
-
-- the expected pattern of use is either seek(offset)+read(size) or a single
-  read with no size specified. For multiple range files, multiple read() will
-  return the corresponding ranges, trying to read further will raise
-  InvalidHttpResponse.
+"""Tests from HTTP response parsing."""
+
+from cStringIO import StringIO
+import mimetools
+
+from bzrlib import errors
+from bzrlib.transport import http
+from bzrlib.transport.http import response
+from bzrlib.tests import TestCase
+
+
+class TestResponseRange(TestCase):
+    """Test the ResponseRange class."""
+
+    def test_cmp(self):
+        RR = response.ResponseRange
+        r1 = RR(0, 10, 0)
+        r2 = RR(15, 20, 10)
+        self.assertTrue(r1 < r2)
+        self.assertFalse(r1 > r2)
+        self.assertTrue(r1 < 5)
+        self.assertFalse(r2 < 5)
+
+        self.assertEqual(RR(0, 10, 5), RR(0, 10, 5))
+        self.assertNotEqual(RR(0, 10, 5), RR(0, 8, 5))
+        self.assertNotEqual(RR(0, 10, 5), RR(0, 10, 6))
+
+    def test_sort_list(self):
+        """Ensure longer ranges are sorted after shorter ones"""
+        RR = response.ResponseRange
+        lst = [RR(3, 8, 0), 5, RR(3, 7, 0), 6]
+        lst.sort()
+        self.assertEqual([RR(3,7,0), RR(3,8,0), 5, 6], lst)
+
+
+class TestRangeFile(TestCase):
+    """Test RangeFile."""
+
+    def setUp(self):
+        content = "abcdefghijklmnopqrstuvwxyz"
+        self.fp = response.RangeFile('foo', StringIO(content))
+        self.fp._add_range(0,  9,   0)
+        self.fp._add_range(20, 29, 10)
+        self.fp._add_range(30, 39, 15)
+
+    def test_valid_accesses(self):
+        """Test so that valid accesses work to the file."""
+        self.fp.seek(0, 0)
+        self.assertEquals(self.fp.read(3), 'abc')
+        self.assertEquals(self.fp.read(3), 'def')
+        self.assertEquals(self.fp.tell(), 6)
+        self.fp.seek(20, 0)
+        self.assertEquals(self.fp.read(3), 'klm')
+        self.assertEquals(self.fp.read(2), 'no')
+        self.assertEquals(self.fp.tell(), 25)
+        # should wrap over to 30-39 entity
+        self.assertEquals(self.fp.read(3), 'pqr')
+        self.fp.seek(3)
+        self.assertEquals(self.fp.read(3), 'def')
+        self.assertEquals(self.fp.tell(), 6)
+
+    def test_invalid_accesses(self):
+        """Test so that invalid accesses trigger errors."""
+        self.fp.seek(9)
+        self.assertRaises(errors.InvalidRange, self.fp.read, 2)
+        self.fp.seek(39)
+        self.assertRaises(errors.InvalidRange, self.fp.read, 2)
+        self.fp.seek(19)
+        self.assertRaises(errors.InvalidRange, self.fp.read, 2)
+
+    def test__finish_ranges(self):
+        """Test that after RangeFile._finish_ranges the list is sorted."""
+        self.fp._add_range(1, 2, 3)
+        self.fp._add_range(8, 9, 10)
+        self.fp._add_range(3, 4, 5)
+
+        # TODO: jam 20060706 If we switch to inserting
+        #       in sorted order, remove this test
+        self.assertNotEqual(self.fp._ranges, sorted(self.fp._ranges))
+
+        self.fp._finish_ranges()
+        self.assertEqual(self.fp._ranges, sorted(self.fp._ranges))
+
+    def test_seek_and_tell(self):
+        # Check for seeking before start
+        self.fp.seek(-2, 0)
+        self.assertEqual(0, self.fp.tell())
+
+        self.fp.seek(5, 0)
+        self.assertEqual(5, self.fp.tell())
+
+        self.fp.seek(-2, 1)
+        self.assertEqual(3, self.fp.tell())
+
+        # TODO: jam 20060706 following tests will fail if this 
+        #       is not true, and would be difficult to debug
+        #       but it is a layering violation
+        self.assertEqual(39, self.fp._len)
+
+        self.fp.seek(0, 2)
+        self.assertEqual(39, self.fp.tell())
+
+        self.fp.seek(-10, 2)
+        self.assertEqual(29, self.fp.tell())
+
+        self.assertRaises(ValueError, self.fp.seek, 0, 4)
+        self.assertRaises(ValueError, self.fp.seek, 0, -1)
+
+
+class TestRegexes(TestCase):
+
+    def assertRegexMatches(self, groups, text):
+        """Check that the regex matches and returns the right values"""
+        m = self.regex.match(text)
+        self.assertNotEqual(None, m, "text %s did not match regex" % (text,))
+
+        self.assertEqual(groups, m.groups())
+
+    def test_range_re(self):
+        """Test that we match valid ranges."""
+        self.regex = response.HttpRangeResponse._CONTENT_RANGE_RE
+        self.assertRegexMatches(('bytes', '1', '10', '11'),
+                           'bytes 1-10/11')
+        self.assertRegexMatches(('bytes', '1', '10', '11'),
+                           '\tbytes  1-10/11   ')
+        self.assertRegexMatches(('bytes', '2123', '4242', '1231'),
+                           '\tbytes  2123-4242/1231   ')
+        self.assertRegexMatches(('chars', '1', '2', '3'),
+                           ' chars 1-2/3')
+
+    def test_content_type_re(self):
+        self.regex = response.HttpMultipartRangeResponse._CONTENT_TYPE_RE
+        self.assertRegexMatches(('', 'xxyyzz'),
+                                'multipart/byteranges; boundary = xxyyzz')
+        self.assertRegexMatches(('', 'xxyyzz'),
+                                'multipart/byteranges;boundary=xxyyzz')
+        self.assertRegexMatches(('', 'xx yy zz'),
+                                ' multipart/byteranges ; boundary= xx yy zz ')
+        self.assertRegexMatches(('"', 'xx yy zz'),
+                                ' multipart/byteranges ; boundary= "xx yy zz" ')
+        self.assertEqual(None,
+                         self.regex.match(
+                             ' multipart/byteranges ; boundary= "xx yy zz '))
+        self.assertEqual(None,
+                         self.regex.match(
+                             ' multipart/byteranges ; boundary= xx yy zz" '))
+        self.assertEqual(None,
+                self.regex.match('multipart byteranges;boundary=xx'))
+
+
+simple_data = """
+--xxyyzz\r
+foo\r
+Content-range: bytes 1-10/20\r
+\r
+1234567890
+--xxyyzz\r
+Content-Range: bytes 21-30/20\r
+bar\r
+\r
+abcdefghij
+--xxyyzz\r
+content-range: bytes 41-50/20\r
+\r
+zyxwvutsrq
+--xxyyzz\r
+content-range: bytes 51-60/20\r
+\r
+xxyyzz fbd
 """
 
-from cStringIO import StringIO
-import httplib
-
-from bzrlib import (
-    errors,
-    tests,
-    )
-from bzrlib.transport.http import (
-    response,
-    _urllib2_wrappers,
-    )
-from bzrlib.tests.file_utils import (
-    FakeReadFile,
-    )
-
-
-class ReadSocket(object):
-    """A socket-like object that can be given a predefined content."""
-
-    def __init__(self, data):
-        self.readfile = StringIO(data)
-
-    def makefile(self, mode='r', bufsize=None):
-        return self.readfile
-
-
-class FakeHTTPConnection(_urllib2_wrappers.HTTPConnection):
-
-    def __init__(self, sock):
-        _urllib2_wrappers.HTTPConnection.__init__(self, 'localhost')
-        # Set the socket to bypass the connection
-        self.sock = sock
-
-    def send(self, str):
-        """Ignores the writes on the socket."""
-        pass
-
-
-class TestHTTPConnection(tests.TestCase):
-
-    def test_cleanup_pipe(self):
-        sock = ReadSocket("""HTTP/1.1 200 OK\r
-Content-Type: text/plain; charset=UTF-8\r
-Content-Length: 18
-\r
-0123456789
-garbage""")
-        conn = FakeHTTPConnection(sock)
-        # Simulate the request sending so that the connection will be able to
-        # read the response.
-        conn.putrequest('GET', 'http://localhost/fictious')
-        conn.endheaders()
-        # Now, get the response
-        resp = conn.getresponse()
-        # Read part of the response
-        self.assertEquals('0123456789\n', resp.read(11))
-        # Override the thresold to force the warning emission
-        conn._range_warning_thresold = 6 # There are 7 bytes pending
-        conn.cleanup_pipe()
-        self.assertContainsRe(self._get_log(keep_log_file=True),
-                              'Got a 200 response when asking')
-
-
-class TestRangeFileMixin(object):
-    """Tests for accessing the first range in a RangeFile."""
-
-    # A simple string used to represent a file part (also called a range), in
-    # which offsets are easy to calculate for test writers. It's used as a
-    # building block with slight variations but basically 'a' is the first char
-    # of the range and 'z' is the last.
-    alpha = 'abcdefghijklmnopqrstuvwxyz'
-
-    def test_can_read_at_first_access(self):
-        """Test that the just created file can be read."""
-        self.assertEquals(self.alpha, self._file.read())
-
-    def test_seek_read(self):
-        """Test seek/read inside the range."""
-        f = self._file
-        start = self.first_range_start
-        # Before any use, tell() should be at the range start
-        self.assertEquals(start, f.tell())
-        cur = start # For an overall offset assertion
-        f.seek(start + 3)
-        cur += 3
-        self.assertEquals('def', f.read(3))
-        cur += len('def')
-        f.seek(4, 1)
-        cur += 4
-        self.assertEquals('klmn', f.read(4))
-        cur += len('klmn')
-        # read(0) in the middle of a range
-        self.assertEquals('', f.read(0))
-        # seek in place
-        here = f.tell()
-        f.seek(0, 1)
-        self.assertEquals(here, f.tell())
-        self.assertEquals(cur, f.tell())
-
-    def test_read_zero(self):
-        f = self._file
-        start = self.first_range_start
-        self.assertEquals('', f.read(0))
-        f.seek(10, 1)
-        self.assertEquals('', f.read(0))
-
-    def test_seek_at_range_end(self):
-        f = self._file
-        f.seek(26, 1)
-
-    def test_read_at_range_end(self):
-        """Test read behaviour at range end."""
-        f = self._file
-        self.assertEquals(self.alpha, f.read())
-        self.assertEquals('', f.read(0))
-        self.assertRaises(errors.InvalidRange, f.read, 1)
-
-    def test_unbounded_read_after_seek(self):
-        f = self._file
-        f.seek(24, 1)
-        # Should not cross ranges
-        self.assertEquals('yz', f.read())
-
-    def test_seek_backwards(self):
-        f = self._file
-        start = self.first_range_start
-        f.seek(start)
-        f.read(12)
-        self.assertRaises(errors.InvalidRange, f.seek, start + 5)
-
-    def test_seek_outside_single_range(self):
-        f = self._file
-        if f._size == -1 or f._boundary is not None:
-            raise tests.TestNotApplicable('Needs a fully defined range')
-        # Will seek past the range and then errors out
-        self.assertRaises(errors.InvalidRange,
-                          f.seek, self.first_range_start + 27)
-
-    def test_read_past_end_of_range(self):
-        f = self._file
-        if f._size == -1:
-            raise tests.TestNotApplicable("Can't check an unknown size")
-        start = self.first_range_start
-        f.seek(start + 20)
-        self.assertRaises(errors.InvalidRange, f.read, 10)
-
-    def test_seek_from_end(self):
-       """Test seeking from the end of the file.
-
-       The semantic is unclear in case of multiple ranges. Seeking from end
-       exists only for the http transports, cannot be used if the file size is
-       unknown and is not used in bzrlib itself. This test must be (and is)
-       overridden by daughter classes.
-
-       Reading from end makes sense only when a range has been requested from
-       the end of the file (see HttpTransportBase._get() when using the
-       'tail_amount' parameter). The HTTP response can only be a whole file or
-       a single range.
-       """
-       f = self._file
-       f.seek(-2, 2)
-       self.assertEquals('yz', f.read())
-
-
-class TestRangeFileSizeUnknown(tests.TestCase, TestRangeFileMixin):
-    """Test a RangeFile for a whole file whose size is not known."""
-
-    def setUp(self):
-        super(TestRangeFileSizeUnknown, self).setUp()
-        self._file = response.RangeFile('Whole_file_size_known',
-                                        StringIO(self.alpha))
-        # We define no range, relying on RangeFile to provide default values
-        self.first_range_start = 0 # It's the whole file
-
-    def test_seek_from_end(self):
-        """See TestRangeFileMixin.test_seek_from_end.
-
-        The end of the file can't be determined since the size is unknown.
-        """
-        self.assertRaises(errors.InvalidRange, self._file.seek, -1, 2)
-
-    def test_read_at_range_end(self):
-        """Test read behaviour at range end."""
-        f = self._file
-        self.assertEquals(self.alpha, f.read())
-        self.assertEquals('', f.read(0))
-        self.assertEquals('', f.read(1))
-
-
-class TestRangeFileSizeKnown(tests.TestCase, TestRangeFileMixin):
-    """Test a RangeFile for a whole file whose size is known."""
-
-    def setUp(self):
-        super(TestRangeFileSizeKnown, self).setUp()
-        self._file = response.RangeFile('Whole_file_size_known',
-                                        StringIO(self.alpha))
-        self._file.set_range(0, len(self.alpha))
-        self.first_range_start = 0 # It's the whole file
-
-
-class TestRangeFileSingleRange(tests.TestCase, TestRangeFileMixin):
-    """Test a RangeFile for a single range."""
-
-    def setUp(self):
-        super(TestRangeFileSingleRange, self).setUp()
-        self._file = response.RangeFile('Single_range_file',
-                                        StringIO(self.alpha))
-        self.first_range_start = 15
-        self._file.set_range(self.first_range_start, len(self.alpha))
-
-
-    def test_read_before_range(self):
-        # This can't occur under normal circumstances, we have to force it
-        f = self._file
-        f._pos = 0 # Force an invalid pos
+
+class TestHelpers(TestCase):
+    """Test the helper functions"""
+
+    def test__parse_range(self):
+        """Test that _parse_range acts reasonably."""
+        content = StringIO('')
+        parse_range = response.HttpRangeResponse._parse_range
+        self.assertEqual((1,2), parse_range('bytes 1-2/3'))
+        self.assertEqual((10,20), parse_range('bytes 10-20/2'))
+
+        self.assertRaises(errors.InvalidHttpRange, parse_range, 'char 1-3/2')
+        self.assertRaises(errors.InvalidHttpRange, parse_range, 'bytes a-3/2')
+
+        try:
+            parse_range('bytes x-10/3', path='http://foo/bar')
+        except errors.InvalidHttpRange, e:
+            self.assertContainsRe(str(e), 'http://foo/bar')
+            self.assertContainsRe(str(e), 'bytes x-10/3')
+        else:
+            self.fail('Did not raise InvalidHttpRange')
+
+    def test__parse_boundary_simple(self):
+        """Test that _parse_boundary handles Content-type properly"""
+        parse_boundary = response.HttpMultipartRangeResponse._parse_boundary
+        m = parse_boundary(' multipart/byteranges; boundary=xxyyzz')
+        self.assertNotEqual(None, m)
+        # Check that the returned regex is capable of splitting simple_data
+        matches = list(m.finditer(simple_data))
+        self.assertEqual(4, len(matches))
+
+        # match.group() should be the content-range entry
+        # and match.end() should be the start of the content
+        self.assertEqual(' bytes 1-10/20', matches[0].group(1))
+        self.assertEqual(simple_data.find('1234567890'), matches[0].end())
+        self.assertEqual(' bytes 21-30/20', matches[1].group(1))
+        self.assertEqual(simple_data.find('abcdefghij'), matches[1].end())
+        self.assertEqual(' bytes 41-50/20', matches[2].group(1))
+        self.assertEqual(simple_data.find('zyxwvutsrq'), matches[2].end())
+        self.assertEqual(' bytes 51-60/20', matches[3].group(1))
+        self.assertEqual(simple_data.find('xxyyzz fbd'), matches[3].end())
+
+    def test__parse_boundary_invalid(self):
+        parse_boundary = response.HttpMultipartRangeResponse._parse_boundary
+        try:
+            parse_boundary(' multipart/bytes;boundary=xxyyzz',
+                           path='http://foo/bar')
+        except errors.InvalidHttpContentType, e:
+            self.assertContainsRe(str(e), 'http://foo/bar')
+            self.assertContainsRe(str(e), 'multipart/bytes;boundary=xxyyzz')
+        else:
+            self.fail('Did not raise InvalidHttpContentType')
+
+
+class TestHttpRangeResponse(TestCase):
+
+    def test_smoketest(self):
+        """A basic test that HttpRangeResponse is reasonable."""
+        content = StringIO('0123456789')
+        f = response.HttpRangeResponse('http://foo', 'bytes 1-10/9', content)
+        self.assertEqual([response.ResponseRange(1,10,0)], f._ranges)
+
+        f.seek(0)
         self.assertRaises(errors.InvalidRange, f.read, 2)
-
-
-class TestRangeFileMultipleRanges(tests.TestCase, TestRangeFileMixin):
-    """Test a RangeFile for multiple ranges.
-
-    The RangeFile used for the tests contains three ranges:
-
-    - at offset 25: alpha
-    - at offset 100: alpha
-    - at offset 126: alpha.upper()
-
-    The two last ranges are contiguous. This only rarely occurs (should not in
-    fact) in real uses but may lead to hard to track bugs.
-    """
-
-    # The following is used to represent the boundary paramter defined
-    # in HTTP response headers and the boundary lines that separate
-    # multipart content.
-
-    boundary = "separation"
-
-    def setUp(self):
-        super(TestRangeFileMultipleRanges, self).setUp()
-
-        boundary = self.boundary
-
-        content = ''
-        self.first_range_start = 25
-        file_size = 200 # big enough to encompass all ranges
-        for (start, part) in [(self.first_range_start, self.alpha),
-                              # Two contiguous ranges
-                              (100, self.alpha),
-                              (126, self.alpha.upper())]:
-            content += self._multipart_byterange(part, start, boundary,
-                                                 file_size)
-        # Final boundary
-        content += self._boundary_line()
-
-        self._file = response.RangeFile('Multiple_ranges_file',
-                                        StringIO(content))
-        self.set_file_boundary()
-
-    def _boundary_line(self):
-        """Helper to build the formatted boundary line."""
-        return '--' + self.boundary + '\r\n'
-
-    def set_file_boundary(self):
-        # Ranges are set by decoding the range headers, the RangeFile user is
-        # supposed to call the following before using seek or read since it
-        # requires knowing the *response* headers (in that case the boundary
-        # which is part of the Content-Type header).
-        self._file.set_boundary(self.boundary)
-
-    def _multipart_byterange(self, data, offset, boundary, file_size='*'):
-        """Encode a part of a file as a multipart/byterange MIME type.
-
-        When a range request is issued, the HTTP response body can be
-        decomposed in parts, each one representing a range (start, size) in a
-        file.
-
-        :param data: The payload.
-        :param offset: where data starts in the file
-        :param boundary: used to separate the parts
-        :param file_size: the size of the file containing the range (default to
-            '*' meaning unknown)
-
-        :return: a string containing the data encoded as it will appear in the
-            HTTP response body.
-        """
-        bline = self._boundary_line()
-        # Each range begins with a boundary line
-        range = bline
-        # A range is described by a set of headers, but only 'Content-Range' is
-        # required for our implementation (TestHandleResponse below will
-        # exercise ranges with multiple or missing headers')
-        range += 'Content-Range: bytes %d-%d/%d\r\n' % (offset,
-                                                        offset+len(data)-1,
-                                                        file_size)
-        range += '\r\n'
-        # Finally the raw bytes
-        range += data
-        return range
-
-    def test_read_all_ranges(self):
-        f = self._file
-        self.assertEquals(self.alpha, f.read()) # Read first range
-        f.seek(100) # Trigger the second range recognition
-        self.assertEquals(self.alpha, f.read()) # Read second range
-        self.assertEquals(126, f.tell())
-        f.seek(126) # Start of third range which is also the current pos !
-        self.assertEquals('A', f.read(1))
-        f.seek(10, 1)
-        self.assertEquals('LMN', f.read(3))
-
-    def test_seek_from_end(self):
-        """See TestRangeFileMixin.test_seek_from_end."""
-        # The actual implementation will seek from end for the first range only
-        # and then fail. Since seeking from end is intended to be used for a
-        # single range only anyway, this test just document the actual
-        # behaviour.
-        f = self._file
-        f.seek(-2, 2)
-        self.assertEquals('yz', f.read())
-        self.assertRaises(errors.InvalidRange, f.seek, -2, 2)
-
-    def test_seek_into_void(self):
-        f = self._file
-        start = self.first_range_start
-        f.seek(start)
-        # Seeking to a point between two ranges is possible (only once) but
-        # reading there is forbidden
-        f.seek(start + 40)
-        # We crossed a range boundary, so now the file is positioned at the
-        # start of the new range (i.e. trying to seek below 100 will error out)
-        f.seek(100)
-        f.seek(125)
-
-    def test_seek_across_ranges(self):
-        f = self._file
-        start = self.first_range_start
-        f.seek(126) # skip the two first ranges
-        self.assertEquals('AB', f.read(2))
-
-    def test_checked_read_dont_overflow_buffers(self):
-        f = self._file
-        start = self.first_range_start
-        # We force a very low value to exercise all code paths in _checked_read
-        f._discarded_buf_size = 8
-        f.seek(126) # skip the two first ranges
-        self.assertEquals('AB', f.read(2))
-
-    def test_seek_twice_between_ranges(self):
-        f = self._file
-        start = self.first_range_start
-        f.seek(start + 40) # Past the first range but before the second
-        # Now the file is positioned at the second range start (100)
-        self.assertRaises(errors.InvalidRange, f.seek, start + 41)
-
-    def test_seek_at_range_end(self):
-        """Test seek behavior at range end."""
-        f = self._file
-        f.seek(25 + 25)
-        f.seek(100 + 25)
-        f.seek(126 + 25)
-
-    def test_read_at_range_end(self):
-        f = self._file
-        self.assertEquals(self.alpha, f.read())
-        self.assertEquals(self.alpha, f.read())
-        self.assertEquals(self.alpha.upper(), f.read())
-        self.assertRaises(errors.InvalidHttpResponse, f.read, 1)
-
-
-class TestRangeFileMultipleRangesQuotedBoundaries(TestRangeFileMultipleRanges):
-    """Perform the same tests as TestRangeFileMultipleRanges, but uses 
-    an angle-bracket quoted boundary string like IIS 6.0 and 7.0
-    (but not IIS 5, which breaks the RFC in a different way
-    by using square brackets, not angle brackets)
-    
-    This reveals a bug caused by 
-    
-    - The bad implementation of RFC 822 unquoting in Python (angles are not 
-      quotes), coupled with 
-
-    - The bad implementation of RFC 2046 in IIS (angles are not permitted chars
-      in boundary lines).
- 
-    """
-    # The boundary as it appears in boundary lines
-    # IIS 6 and 7 use this value
-    _boundary_trimmed = "q1w2e3r4t5y6u7i8o9p0zaxscdvfbgnhmjklkl"
-    boundary = '<' + _boundary_trimmed + '>'
-
-    def set_file_boundary(self):
-        # Emulate broken rfc822.unquote() here by removing angles
-        self._file.set_boundary(self._boundary_trimmed)
-
-
-class TestRangeFileVarious(tests.TestCase):
-    """Tests RangeFile aspects not covered elsewhere."""
-
-    def test_seek_whence(self):
-        """Test the seek whence parameter values."""
-        f = response.RangeFile('foo', StringIO('abc'))
-        f.set_range(0, 3)
-        f.seek(0)
-        f.seek(1, 1)
-        f.seek(-1, 2)
-        self.assertRaises(ValueError, f.seek, 0, 14)
-
-    def test_range_syntax(self):
-        """Test the Content-Range scanning."""
-
-        f = response.RangeFile('foo', StringIO())
-
-        def ok(expected, header_value):
-            f.set_range_from_header(header_value)
-            # Slightly peek under the covers to get the size
-            self.assertEquals(expected, (f.tell(), f._size))
-
-        ok((1, 10), 'bytes 1-10/11')
-        ok((1, 10), 'bytes 1-10/*')
-        ok((12, 2), '\tbytes 12-13/*')
-        ok((28, 1), '  bytes 28-28/*')
-        ok((2123, 2120), 'bytes  2123-4242/12310')
-        ok((1, 10), 'bytes 1-10/ttt') # We don't check total (ttt)
-
-        def nok(header_value):
-            self.assertRaises(errors.InvalidHttpRange,
-                              f.set_range_from_header, header_value)
-
-        nok('bytes 10-2/3')
-        nok('chars 1-2/3')
-        nok('bytes xx-yyy/zzz')
-        nok('bytes xx-12/zzz')
-        nok('bytes 11-yy/zzz')
-        nok('bytes10-2/3')
+        f.seek(1)
+        self.assertEqual('012345', f.read(6))
+
+    def test_invalid(self):
+        try:
+            f = response.HttpRangeResponse('http://foo', 'bytes x-10/9',
+                                           StringIO('0123456789'))
+        except errors.InvalidHttpRange, e:
+            self.assertContainsRe(str(e), 'http://foo')
+            self.assertContainsRe(str(e), 'bytes x-10/9')
+        else:
+            self.fail('Failed to raise InvalidHttpRange')
+
+
+class TestHttpMultipartRangeResponse(TestCase):
+    """Test the handling of multipart range responses"""
+
+    def test_simple(self):
+        content = StringIO(simple_data)
+        multi = response.HttpMultipartRangeResponse('http://foo',
+                    'multipart/byteranges; boundary = xxyyzz', content)
+
+        self.assertEqual(4, len(multi._ranges))
+
+        multi.seek(1)
+        self.assertEqual('1234567890', multi.read(10))
+        multi.seek(21)
+        self.assertEqual('abcdefghij', multi.read(10))
+        multi.seek(41)
+        self.assertEqual('zyxwvutsrq', multi.read(10))
+        multi.seek(51)
+        self.assertEqual('xxyyzz fbd', multi.read(10))
+        # TODO: jam 20060706 Currently RangeFile does not support
+        #       reading across ranges. Consider adding it.
+        multi.seek(41)
+        # self.assertEqual('zyxwvutsrqxxyyzz fbd', multi.read(20))
+        self.assertRaises(errors.InvalidRange, multi.read, 20)
+
+        multi.seek(21)
+        self.assertRaises(errors.InvalidRange, multi.read, 11)
+        multi.seek(31)
+        self.assertRaises(errors.InvalidRange, multi.read, 10)
+
+    def test_invalid(self):
+        content = StringIO('')
+        try:
+            response.HttpMultipartRangeResponse('http://foo',
+                        'multipart/byte;boundary=invalid', content)
+        except errors.InvalidHttpContentType, e:
+            self.assertContainsRe(str(e), 'http://foo')
+            self.assertContainsRe(str(e), 'multipart/byte;')
 
 
 # Taken from real request responses
@@ -487,6 +317,25 @@
 """)
 
 
+_missing_response = (404, """HTTP/1.1 404 Not Found\r
+Date: Tue, 11 Jul 2006 04:32:56 GMT\r
+Server: Apache/2.0.54 (Fedora)\r
+Content-Length: 336\r
+Connection: close\r
+Content-Type: text/html; charset=iso-8859-1\r
+\r
+""", """<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML 2.0//EN">
+<html><head>
+<title>404 Not Found</title>
+</head><body>
+<h1>Not Found</h1>
+<p>The requested URL /branches/bzr/jam-integration/.bzr/repository/format was not found on this server.</p>
+<hr>
+<address>Apache/2.0.54 (Fedora) Server at bzr.arbash-meinel.com Port 80</address>
+</body></html>
+""")
+
+
 _single_range_response = (206, """HTTP/1.1 206 Partial Content\r
 Date: Tue, 11 Jul 2006 04:45:22 GMT\r
 Server: Apache/2.0.54 (Fedora)\r
@@ -565,7 +414,6 @@
 --418470f848b63279b--\r
 """)
 
-
 _multipart_squid_range_response = (206, """HTTP/1.0 206 Partial Content\r
 Date: Thu, 31 Aug 2006 21:16:22 GMT\r
 Server: Apache/2.2.2 (Unix) DAV/2\r
@@ -598,60 +446,34 @@
 """)
 
 
+_redirect_response = (206, """HTTP/1.1 301 Moved Permanently\r
+Date: Tue, 18 Jul 2006 20:29:22 GMT\r
+Server: Apache/2.0.54 (Ubuntu) PHP/4.4.0-3ubuntu1 mod_ssl/2.0.54 OpenSSL/0.9.7g\r
+Location: http://bazaar-vcs.org/bzr/bzr.dev/.bzr/repository/inventory.knit\r
+Content-Length: 272\r
+Keep-Alive: timeout=15, max=100\r
+Connection: Keep-Alive\r
+Content-Type: text/html; charset=iso-8859-1\r
+\r
+HTTP/1.1 206 Partial Content\r
+Date: Tue, 18 Jul 2006 20:29:23 GMT\r
+Server: Apache/2.0.54 (Ubuntu) PHP/4.4.0-3ubuntu1 mod_ssl/2.0.54 OpenSSL/0.9.7g\r
+Last-Modified: Tue, 18 Jul 2006 20:24:59 GMT\r
+ETag: "be8213-83958c-f0d3dcc0"\r
+Accept-Ranges: bytes\r
+Content-Length: 425\r
+Content-Range: bytes 8623075-8623499/8623500\r
+Keep-Alive: timeout=15, max=100\r
+Connection: Keep-Alive\r
+Content-Type: text/plain; charset=UTF-8\r
+\r
+""", """this data intentionally removed, 
+this is not meant to be tested by
+handle_response, just _extract_headers
+""")
+
+
 # This is made up
-_full_text_response_no_content_type = (200, """HTTP/1.1 200 OK\r
-Date: Tue, 11 Jul 2006 04:32:56 GMT\r
-Server: Apache/2.0.54 (Fedora)\r
-Last-Modified: Sun, 23 Apr 2006 19:35:20 GMT\r
-ETag: "56691-23-38e9ae00"\r
-Accept-Ranges: bytes\r
-Content-Length: 35\r
-Connection: close\r
-\r
-""", """Bazaar-NG meta directory, format 1
-""")
-
-
-_full_text_response_no_content_length = (200, """HTTP/1.1 200 OK\r
-Date: Tue, 11 Jul 2006 04:32:56 GMT\r
-Server: Apache/2.0.54 (Fedora)\r
-Last-Modified: Sun, 23 Apr 2006 19:35:20 GMT\r
-ETag: "56691-23-38e9ae00"\r
-Accept-Ranges: bytes\r
-Connection: close\r
-Content-Type: text/plain; charset=UTF-8\r
-\r
-""", """Bazaar-NG meta directory, format 1
-""")
-
-
-_single_range_no_content_range = (206, """HTTP/1.1 206 Partial Content\r
-Date: Tue, 11 Jul 2006 04:45:22 GMT\r
-Server: Apache/2.0.54 (Fedora)\r
-Last-Modified: Thu, 06 Jul 2006 20:22:05 GMT\r
-ETag: "238a3c-16ec2-805c5540"\r
-Accept-Ranges: bytes\r
-Content-Length: 100\r
-Connection: close\r
-\r
-""", """mbp@sourcefrog.net-20050309040815-13242001617e4a06
-mbp@sourcefrog.net-20050309040929-eee0eb3e6d1e762""")
-
-
-_single_range_response_truncated = (206, """HTTP/1.1 206 Partial Content\r
-Date: Tue, 11 Jul 2006 04:45:22 GMT\r
-Server: Apache/2.0.54 (Fedora)\r
-Last-Modified: Thu, 06 Jul 2006 20:22:05 GMT\r
-ETag: "238a3c-16ec2-805c5540"\r
-Accept-Ranges: bytes\r
-Content-Length: 100\r
-Content-Range: bytes 100-199/93890\r
-Connection: close\r
-Content-Type: text/plain; charset=UTF-8\r
-\r
-""", """mbp@sourcefrog.net-20050309040815-13242001617e4a06""")
-
-
 _invalid_response = (444, """HTTP/1.1 444 Bad Response\r
 Date: Tue, 11 Jul 2006 04:32:56 GMT\r
 Connection: close\r
@@ -668,51 +490,113 @@
 """)
 
 
-_multipart_no_content_range = (206, """HTTP/1.0 206 Partial Content\r
-Content-Type: multipart/byteranges; boundary=THIS_SEPARATES\r
-Content-Length: 598\r
-\r
-""",
-"""\r
---THIS_SEPARATES\r
-Content-Type: text/plain\r
-\r
-# bzr knit index 8
---THIS_SEPARATES\r
-""")
-
-
-_multipart_no_boundary = (206, """HTTP/1.0 206 Partial Content\r
-Content-Type: multipart/byteranges; boundary=THIS_SEPARATES\r
-Content-Length: 598\r
-\r
-""",
-"""\r
---THIS_SEPARATES\r
-Content-Type: text/plain\r
-Content-Range: bytes 0-18/18672\r
-\r
-# bzr knit index 8
-
-The range ended at the line above, this text is garbage instead of a boundary
-line
-""")
-
-
-class TestHandleResponse(tests.TestCase):
-
-    def _build_HTTPMessage(self, raw_headers):
-        status_and_headers = StringIO(raw_headers)
-        # Get rid of the status line
-        status_and_headers.readline()
-        msg = httplib.HTTPMessage(status_and_headers)
-        return msg
-
+# This should be in test_http.py, but the headers we
+# want to parse are here
+class TestExtractHeader(TestCase):
+    
+    def use_response(self, response):
+        self.headers = http._extract_headers(response[1], 'http://foo')
+
+    def check_header(self, header, value):
+        self.assertEqual(value, self.headers[header])
+        
+    def test_full_text(self):
+        self.use_response(_full_text_response)
+
+        self.check_header('Date', 'Tue, 11 Jul 2006 04:32:56 GMT')
+        self.check_header('date', 'Tue, 11 Jul 2006 04:32:56 GMT')
+        self.check_header('Content-Length', '35')
+        self.check_header('Content-Type', 'text/plain; charset=UTF-8')
+        self.check_header('content-type', 'text/plain; charset=UTF-8')
+
+    def test_missing_response(self):
+        self.use_response(_missing_response)
+
+        self.check_header('Content-Length', '336')
+        self.check_header('Content-Type', 'text/html; charset=iso-8859-1')
+
+    def test_single_range(self):
+        self.use_response(_single_range_response)
+
+        self.check_header('Content-Length', '100')
+        self.check_header('Content-Range', 'bytes 100-199/93890')
+        self.check_header('Content-Type', 'text/plain; charset=UTF-8')
+
+    def test_single_range_no_content(self):
+        self.use_response(_single_range_no_content_type)
+
+        self.check_header('Content-Length', '100')
+        self.check_header('Content-Range', 'bytes 100-199/93890')
+
+    def test_multi_range(self):
+        self.use_response(_multipart_range_response)
+
+        self.check_header('Content-Length', '1534')
+        self.check_header('Content-Type',
+                          'multipart/byteranges; boundary=418470f848b63279b')
+
+    def test_multi_squid_range(self):
+        self.use_response(_multipart_squid_range_response)
+
+        self.check_header('Content-Length', '598')
+        self.check_header('Content-Type',
+                          'multipart/byteranges; '\
+                          'boundary="squid/2.5.STABLE12:C99323425AD4FE26F726261FA6C24196"')
+
+    def test_redirect(self):
+        """We default to returning the last group of headers in the file."""
+        self.use_response(_redirect_response)
+        self.check_header('Content-Range', 'bytes 8623075-8623499/8623500')
+        self.check_header('Content-Type', 'text/plain; charset=UTF-8')
+
+    def test_empty(self):
+        self.assertRaises(errors.InvalidHttpResponse,
+            http._extract_headers, '', 'bad url')
+
+    def test_no_opening_http(self):
+        # Remove the HTTP line from the header
+        first, txt = _full_text_response[1].split('\r\n', 1)
+        self.assertRaises(errors.InvalidHttpResponse,
+            http._extract_headers, txt, 'missing HTTTP')
+
+    def test_trailing_whitespace(self):
+        # Test that we ignore bogus whitespace on the end
+        code, txt, body = _full_text_response
+        txt += '\r\n\n\n\n\n'
+        self.use_response((code, txt, body))
+
+        self.check_header('Date', 'Tue, 11 Jul 2006 04:32:56 GMT')
+        self.check_header('Content-Length', '35')
+        self.check_header('Content-Type', 'text/plain; charset=UTF-8')
+
+    def test_trailing_non_http(self):
+        # Test that we ignore bogus stuff on the end
+        code, txt, body = _full_text_response
+        txt = txt + 'Foo: Bar\r\nBaz: Bling\r\n\r\n'
+        self.use_response((code, txt, body))
+
+        self.check_header('Date', 'Tue, 11 Jul 2006 04:32:56 GMT')
+        self.check_header('Content-Length', '35')
+        self.check_header('Content-Type', 'text/plain; charset=UTF-8')
+        self.assertRaises(KeyError, self.headers.__getitem__, 'Foo')
+
+    def test_extra_whitespace(self):
+        # Test that we read an HTTP response, even with extra whitespace
+        code, txt, body = _redirect_response
+        # Find the second HTTP location
+        loc = txt.find('HTTP', 5)
+        txt = txt[:loc] + '\r\n\n' + txt[loc:]
+        self.use_response((code, txt, body))
+        self.check_header('Content-Range', 'bytes 8623075-8623499/8623500')
+        self.check_header('Content-Type', 'text/plain; charset=UTF-8')
+
+
+class TestHandleResponse(TestCase):
+    
     def get_response(self, a_response):
         """Process a supplied response, and return the result."""
-        code, raw_headers, body = a_response
-        msg = self._build_HTTPMessage(raw_headers)
-        return response.handle_response('http://foo', code, msg,
+        headers = http._extract_headers(a_response[1], 'http://foo')
+        return response.handle_response('http://foo', a_response[0], headers,
                                         StringIO(a_response[2]))
 
     def test_full_text(self):
@@ -720,25 +604,31 @@
         # It is a StringIO from the original data
         self.assertEqual(_full_text_response[2], out.read())
 
+    def test_missing_response(self):
+        self.assertRaises(errors.NoSuchFile,
+            self.get_response, _missing_response)
+
     def test_single_range(self):
         out = self.get_response(_single_range_response)
+        self.assertIsInstance(out, response.HttpRangeResponse)
+
+        self.assertRaises(errors.InvalidRange, out.read, 20)
 
         out.seek(100)
         self.assertEqual(_single_range_response[2], out.read(100))
 
     def test_single_range_no_content(self):
         out = self.get_response(_single_range_no_content_type)
+        self.assertIsInstance(out, response.HttpRangeResponse)
+
+        self.assertRaises(errors.InvalidRange, out.read, 20)
 
         out.seek(100)
         self.assertEqual(_single_range_no_content_type[2], out.read(100))
 
-    def test_single_range_truncated(self):
-        out = self.get_response(_single_range_response_truncated)
-        # Content-Range declares 100 but only 51 present
-        self.assertRaises(errors.ShortReadvError, out.seek, out.tell() + 51)
-
     def test_multi_range(self):
         out = self.get_response(_multipart_range_response)
+        self.assertIsInstance(out, response.HttpMultipartRangeResponse)
 
         # Just make sure we can read the right contents
         out.seek(0)
@@ -749,6 +639,7 @@
 
     def test_multi_squid_range(self):
         out = self.get_response(_multipart_squid_range_response)
+        self.assertIsInstance(out, response.HttpMultipartRangeResponse)
 
         # Just make sure we can read the right contents
         out.seek(0)
@@ -759,72 +650,30 @@
 
     def test_invalid_response(self):
         self.assertRaises(errors.InvalidHttpResponse,
-                          self.get_response, _invalid_response)
+            self.get_response, _invalid_response)
 
     def test_full_text_no_content_type(self):
         # We should not require Content-Type for a full response
-        code, raw_headers, body = _full_text_response_no_content_type
-        msg = self._build_HTTPMessage(raw_headers)
-        out = response.handle_response('http://foo', code, msg, StringIO(body))
-        self.assertEqual(body, out.read())
+        a_response = _full_text_response
+        headers = http._extract_headers(a_response[1], 'http://foo')
+        del headers['Content-Type']
+        out = response.handle_response('http://foo', a_response[0], headers,
+                                        StringIO(a_response[2]))
+        self.assertEqual(_full_text_response[2], out.read())
 
-    def test_full_text_no_content_length(self):
-        code, raw_headers, body = _full_text_response_no_content_length
-        msg = self._build_HTTPMessage(raw_headers)
-        out = response.handle_response('http://foo', code, msg, StringIO(body))
-        self.assertEqual(body, out.read())
+    def test_missing_no_content_type(self):
+        # Without Content-Type we should still raise NoSuchFile on a 404
+        a_response = _missing_response
+        headers = http._extract_headers(a_response[1], 'http://missing')
+        del headers['Content-Type']
+        self.assertRaises(errors.NoSuchFile,
+            response.handle_response, 'http://missing', a_response[0], headers,
+                                      StringIO(a_response[2]))
 
     def test_missing_content_range(self):
-        code, raw_headers, body = _single_range_no_content_range
-        msg = self._build_HTTPMessage(raw_headers)
-        self.assertRaises(errors.InvalidHttpResponse,
-                          response.handle_response,
-                          'http://bogus', code, msg, StringIO(body))
-
-    def test_multipart_no_content_range(self):
-        code, raw_headers, body = _multipart_no_content_range
-        msg = self._build_HTTPMessage(raw_headers)
-        self.assertRaises(errors.InvalidHttpResponse,
-                          response.handle_response,
-                          'http://bogus', code, msg, StringIO(body))
-
-    def test_multipart_no_boundary(self):
-        out = self.get_response(_multipart_no_boundary)
-        out.read()  # Read the whole range
-        # Fail to find the boundary line
-        self.assertRaises(errors.InvalidHttpResponse, out.seek, 1, 1)
-
-
-class TestRangeFileSizeReadLimited(tests.TestCase):
-    """Test RangeFile _max_read_size functionality which limits the size of
-    read blocks to prevent MemoryError messages in socket.recv.
-    """
-
-    def setUp(self):
-        # create a test datablock larger than _max_read_size.
-        chunk_size = response.RangeFile._max_read_size
-        test_pattern = '0123456789ABCDEF'
-        self.test_data =  test_pattern * (3 * chunk_size / len(test_pattern))
-        self.test_data_len = len(self.test_data)
-
-    def test_max_read_size(self):
-        """Read data in blocks and verify that the reads are not larger than
-           the maximum read size.
-        """
-        # retrieve data in large blocks from response.RangeFile object
-        mock_read_file = FakeReadFile(self.test_data)
-        range_file = response.RangeFile('test_max_read_size', mock_read_file)
-        response_data = range_file.read(self.test_data_len)
-
-        # verify read size was equal to the maximum read size
-        self.assertTrue(mock_read_file.get_max_read_size() > 0)
-        self.assertEqual(mock_read_file.get_max_read_size(),
-                         response.RangeFile._max_read_size)
-        self.assertEqual(mock_read_file.get_read_count(), 3)
-
-        # report error if the data wasn't equal (we only report the size due
-        # to the length of the data)
-        if response_data != self.test_data:
-            message = "Data not equal.  Expected %d bytes, received %d."
-            self.fail(message % (len(response_data), self.test_data_len))
-
+        a_response = _single_range_response
+        headers = http._extract_headers(a_response[1], 'http://nocontent')
+        del headers['Content-Range']
+        self.assertRaises(errors.InvalidHttpResponse,
+            response.handle_response, 'http://nocontent', a_response[0],
+                                      headers, StringIO(a_response[2]))

=== modified file 'bzrlib/tests/test_ignores.py'
--- bzrlib/tests/test_ignores.py	2008-07-07 21:54:04 +0000
+++ bzrlib/tests/test_ignores.py	2007-03-07 14:49:00 +0000
@@ -19,7 +19,7 @@
 from cStringIO import StringIO
 
 from bzrlib import config, errors, ignores
-from bzrlib.tests import TestCase, TestCaseInTempDir, TestCaseWithTransport
+from bzrlib.tests import TestCase, TestCaseInTempDir
 
 
 class TestParseIgnoreFile(TestCase):
@@ -150,30 +150,3 @@
 
         ignores.add_runtime_ignores(['bar'])
         self.assertEqual(set(['foo', 'bar']), ignores.get_runtime_ignores())
-
-
-class TestTreeIgnores(TestCaseWithTransport):
-
-    def test_new_file(self):
-        tree = self.make_branch_and_tree(".")
-        ignores.tree_ignores_add_patterns(tree, ["myentry"])
-        self.assertTrue(tree.has_filename(".bzrignore"))
-        self.assertEquals("myentry\n", 
-                          open(".bzrignore", 'r').read())
-
-    def test_add_to_existing(self):
-        tree = self.make_branch_and_tree(".")
-        self.build_tree_contents([('.bzrignore', "myentry1\n")]) 
-        tree.add([".bzrignore"])
-        ignores.tree_ignores_add_patterns(tree, ["myentry2", "foo"])
-        self.assertEquals("myentry1\nmyentry2\nfoo\n", 
-                          open(".bzrignore", 'r').read())
-
-    def test_adds_ending_newline(self):
-        tree = self.make_branch_and_tree(".")
-        self.build_tree_contents([('.bzrignore', "myentry1")]) 
-        tree.add([".bzrignore"])
-        ignores.tree_ignores_add_patterns(tree, ["myentry2"])
-        self.assertEquals("myentry1\nmyentry2\n", 
-                          open(".bzrignore", 'r').read())
-

=== modified file 'bzrlib/tests/test_index.py'
--- bzrlib/tests/test_index.py	2008-09-02 17:52:00 +0000
+++ bzrlib/tests/test_index.py	2007-10-15 07:56:04 +0000
@@ -353,20 +353,6 @@
 
 class TestGraphIndex(TestCaseWithMemoryTransport):
 
-    def make_key(self, number):
-        return (str(number) + 'X'*100,)
-
-    def make_value(self, number):
-            return str(number) + 'Y'*100
-
-    def make_nodes(self, count=64):
-        # generate a big enough index that we only read some of it on a typical
-        # bisection lookup.
-        nodes = []
-        for counter in range(count):
-            nodes.append((self.make_key(counter), self.make_value(counter), ()))
-        return nodes
-
     def make_index(self, ref_lists=0, key_elements=1, nodes=[]):
         builder = GraphIndexBuilder(ref_lists, key_elements=key_elements)
         for key, value, references in nodes:
@@ -386,21 +372,7 @@
         self.assertEqual([], index._parsed_byte_map)
         self.assertEqual([], index._parsed_key_map)
 
-    def test_key_count_buffers(self):
-        index = self.make_index(nodes=self.make_nodes(2))
-        # reset the transport log
-        del index._transport._activity[:]
-        self.assertEqual(2, index.key_count())
-        # We should have requested reading the header bytes
-        self.assertEqual([
-            ('readv', 'index', [(0, 200)], True, index._size),
-            ],
-            index._transport._activity)
-        # And that should have been enough to trigger reading the whole index
-        # with buffering
-        self.assertIsNot(None, index._nodes)
-
-    def test_lookup_key_via_location_buffers(self):
+    def test_first_lookup_key_via_location(self):
         index = self.make_index()
         # reset the transport log
         del index._transport._activity[:]
@@ -418,48 +390,44 @@
         # is a trivial index.
         self.assertEqual([((index._size // 2, ('missing', )), False)],
             result)
-        # And this should have caused the file to be fully buffered
-        self.assertIsNot(None, index._nodes)
-        self.assertEqual([], index._parsed_byte_map)
+        # And the regions of the file that have been parsed - in this case the
+        # entire file - should be in the parsed region map.
+        self.assertEqual([(0, 60)], index._parsed_byte_map)
+        self.assertEqual([(None, None)], index._parsed_key_map)
 
-    def test_first_lookup_key_via_location(self):
-        # We need enough data so that the _HEADER_READV doesn't consume the
-        # whole file. We always read 800 bytes for every key, and the local
-        # transport natural expansion is 4096 bytes. So we have to have >8192
-        # bytes or we will trigger "buffer_all".
-        # We also want the 'missing' key to fall within the range that *did*
-        # read
-        nodes = []
-        index = self.make_index(nodes=self.make_nodes(64))
+    def test_parsing_parses_data_adjacent_to_parsed_regions(self):
+        # we trim data we recieve to remove the first and trailing
+        # partial lines, except when they start at the end/finish at the start
+        # of a region we've alread parsed/ the end of the file. The trivial
+        # test for this is an index with 1 key.
+        index = self.make_index(nodes=[(('name', ), 'data', ())])
         # reset the transport log
         del index._transport._activity[:]
-        # do a _lookup_keys_via_location call for the middle of the file, which
-        # is what bisection uses.
-        start_lookup = index._size // 2
         result = index._lookup_keys_via_location(
-            [(start_lookup, ('40missing', ))])
+            [(index._size // 2, ('missing', ))])
         # this should have asked for a readv request, with adjust_for_latency,
         # and two regions: the header, and half-way into the file.
         self.assertEqual([
-            ('readv', 'index',
-             [(start_lookup, 800), (0, 200)], True, index._size),
+            ('readv', 'index', [(36, 36), (0, 200)], True, 72),
             ],
             index._transport._activity)
         # and the result should be that the key cannot be present, because this
-        # is a trivial index.
-        self.assertEqual([((start_lookup, ('40missing', )), False)],
+        # is a trivial index and we should not have to do more round trips.
+        self.assertEqual([((index._size // 2, ('missing', )), False)],
             result)
-        # And this should not have caused the file to be fully buffered
-        self.assertIs(None, index._nodes)
-        # And the regions of the file that have been parsed should be in the
-        # parsed_byte_map and the parsed_key_map
-        self.assertEqual([(0, 4008), (5046, 8996)], index._parsed_byte_map)
-        self.assertEqual([(None, self.make_key(26)),
-                          (self.make_key(31), self.make_key(48))],
-                         index._parsed_key_map)
+        # The whole file should be parsed at this point.
+        self.assertEqual([(0, 72)], index._parsed_byte_map)
+        self.assertEqual([(None, ('name',))], index._parsed_key_map)
 
     def test_parsing_non_adjacent_data_trims(self):
-        index = self.make_index(nodes=self.make_nodes(64))
+        # generate a big enough index that we only read some of it on a typical
+        # bisection lookup.
+        nodes = []
+        def make_key(number):
+            return (str(number) + 'X'*100,)
+        for counter in range(64):
+            nodes.append((make_key(counter), 'Y'*100, ()))
+        index = self.make_index(nodes=nodes)
         result = index._lookup_keys_via_location(
             [(index._size // 2, ('40', ))])
         # and the result should be that the key cannot be present, because key is
@@ -469,9 +437,8 @@
             result)
         # and we should have a parse map that includes the header and the
         # region that was parsed after trimming.
-        self.assertEqual([(0, 4008), (5046, 8996)], index._parsed_byte_map)
-        self.assertEqual([(None, self.make_key(26)),
-                          (self.make_key(31), self.make_key(48))],
+        self.assertEqual([(0, 3972), (5001, 8914)], index._parsed_byte_map)
+        self.assertEqual([(None, make_key(26)), (make_key(31), make_key(48))],
             index._parsed_key_map)
 
     def test_parsing_data_handles_parsed_contained_regions(self):
@@ -481,45 +448,53 @@
         # which then trims the start and end so the parsed size is < readv
         # miniumum.
         # then a dual lookup (or a reference lookup for that matter) which
-        # abuts or overlaps the parsed region on both sides will need to
+        # abuts or overlaps the parsed region on both sides will need to 
         # discard the data in the middle, but parse the end as well.
         #
-        # we test this by doing a single lookup to seed the data, then
-        # a lookup for two keys that are present, and adjacent -
+        # we test this by doing a single lookup to seed the data, then 
+        # a lookup for two keys that are present, and adjacent - 
         # we except both to be found, and the parsed byte map to include the
         # locations of both keys.
-        index = self.make_index(nodes=self.make_nodes(128))
+        nodes = []
+        def make_key(number):
+            return (str(number) + 'X'*100,)
+        def make_value(number):
+            return 'Y'*100
+        for counter in range(128):
+            nodes.append((make_key(counter), make_value(counter), ()))
+        index = self.make_index(nodes=nodes)
         result = index._lookup_keys_via_location(
             [(index._size // 2, ('40', ))])
         # and we should have a parse map that includes the header and the
         # region that was parsed after trimming.
-        self.assertEqual([(0, 4045), (11759, 15707)], index._parsed_byte_map)
-        self.assertEqual([(None, self.make_key(116)),
-                          (self.make_key(35), self.make_key(51))],
+        self.assertEqual([(0, 3991), (11622, 15534)], index._parsed_byte_map)
+        self.assertEqual([(None, make_key(116)), (make_key(35), make_key(51))],
             index._parsed_key_map)
         # now ask for two keys, right before and after the parsed region
         result = index._lookup_keys_via_location(
-            [(11450, self.make_key(34)), (15707, self.make_key(52))])
+            [(11450, make_key(34)), (15534, make_key(52))])
         self.assertEqual([
-            ((11450, self.make_key(34)),
-             (index, self.make_key(34), self.make_value(34))),
-            ((15707, self.make_key(52)),
-             (index, self.make_key(52), self.make_value(52))),
+            ((11450, make_key(34)), (index, make_key(34), make_value(34))),
+            ((15534, make_key(52)), (index, make_key(52), make_value(52))),
             ],
             result)
-        self.assertEqual([(0, 4045), (9889, 17993)], index._parsed_byte_map)
+        self.assertEqual([(0, 3991), (9975, 17799)], index._parsed_byte_map)
 
     def test_lookup_missing_key_answers_without_io_when_map_permits(self):
         # generate a big enough index that we only read some of it on a typical
         # bisection lookup.
-        index = self.make_index(nodes=self.make_nodes(64))
+        nodes = []
+        def make_key(number):
+            return (str(number) + 'X'*100,)
+        for counter in range(64):
+            nodes.append((make_key(counter), 'Y'*100, ()))
+        index = self.make_index(nodes=nodes)
         # lookup the keys in the middle of the file
         result =index._lookup_keys_via_location(
             [(index._size // 2, ('40', ))])
         # check the parse map, this determines the test validity
-        self.assertEqual([(0, 4008), (5046, 8996)], index._parsed_byte_map)
-        self.assertEqual([(None, self.make_key(26)),
-                          (self.make_key(31), self.make_key(48))],
+        self.assertEqual([(0, 3972), (5001, 8914)], index._parsed_byte_map)
+        self.assertEqual([(None, make_key(26)), (make_key(31), make_key(48))],
             index._parsed_key_map)
         # reset the transport log
         del index._transport._activity[:]
@@ -527,6 +502,7 @@
         # not create a new transport request, and should return False (cannot
         # be in the index) - even when the byte location we ask for is outside
         # the parsed region
+        # 
         result = index._lookup_keys_via_location(
             [(4000, ('40', ))])
         self.assertEqual([((4000, ('40', )), False)],
@@ -536,14 +512,20 @@
     def test_lookup_present_key_answers_without_io_when_map_permits(self):
         # generate a big enough index that we only read some of it on a typical
         # bisection lookup.
-        index = self.make_index(nodes=self.make_nodes(64))
+        nodes = []
+        def make_key(number):
+            return (str(number) + 'X'*100,)
+        def make_value(number):
+            return str(number) + 'Y'*100
+        for counter in range(64):
+            nodes.append((make_key(counter), make_value(counter), ()))
+        index = self.make_index(nodes=nodes)
         # lookup the keys in the middle of the file
         result =index._lookup_keys_via_location(
             [(index._size // 2, ('40', ))])
         # check the parse map, this determines the test validity
         self.assertEqual([(0, 4008), (5046, 8996)], index._parsed_byte_map)
-        self.assertEqual([(None, self.make_key(26)),
-                          (self.make_key(31), self.make_key(48))],
+        self.assertEqual([(None, make_key(26)), (make_key(31), make_key(48))],
             index._parsed_key_map)
         # reset the transport log
         del index._transport._activity[:]
@@ -552,25 +534,28 @@
         # be in the index) - even when the byte location we ask for is outside
         # the parsed region
         # 
-        result = index._lookup_keys_via_location([(4000, self.make_key(40))])
+        result = index._lookup_keys_via_location([(4000, make_key(40))])
         self.assertEqual(
-            [((4000, self.make_key(40)),
-              (index, self.make_key(40), self.make_value(40)))],
+            [((4000, make_key(40)), (index, make_key(40), make_value(40)))],
             result)
         self.assertEqual([], index._transport._activity)
 
     def test_lookup_key_below_probed_area(self):
         # generate a big enough index that we only read some of it on a typical
         # bisection lookup.
-        index = self.make_index(nodes=self.make_nodes(64))
+        nodes = []
+        def make_key(number):
+            return (str(number) + 'X'*100,)
+        for counter in range(64):
+            nodes.append((make_key(counter), 'Y'*100, ()))
+        index = self.make_index(nodes=nodes)
         # ask for the key in the middle, but a key that is located in the
         # unparsed region before the middle.
         result =index._lookup_keys_via_location(
             [(index._size // 2, ('30', ))])
         # check the parse map, this determines the test validity
-        self.assertEqual([(0, 4008), (5046, 8996)], index._parsed_byte_map)
-        self.assertEqual([(None, self.make_key(26)),
-                          (self.make_key(31), self.make_key(48))],
+        self.assertEqual([(0, 3972), (5001, 8914)], index._parsed_byte_map)
+        self.assertEqual([(None, make_key(26)), (make_key(31), make_key(48))],
             index._parsed_key_map)
         self.assertEqual([((index._size // 2, ('30', )), -1)],
             result)
@@ -578,15 +563,19 @@
     def test_lookup_key_above_probed_area(self):
         # generate a big enough index that we only read some of it on a typical
         # bisection lookup.
-        index = self.make_index(nodes=self.make_nodes(64))
+        nodes = []
+        def make_key(number):
+            return (str(number) + 'X'*100,)
+        for counter in range(64):
+            nodes.append((make_key(counter), 'Y'*100, ()))
+        index = self.make_index(nodes=nodes)
         # ask for the key in the middle, but a key that is located in the
         # unparsed region after the middle.
         result =index._lookup_keys_via_location(
             [(index._size // 2, ('50', ))])
         # check the parse map, this determines the test validity
-        self.assertEqual([(0, 4008), (5046, 8996)], index._parsed_byte_map)
-        self.assertEqual([(None, self.make_key(26)),
-                          (self.make_key(31), self.make_key(48))],
+        self.assertEqual([(0, 3972), (5001, 8914)], index._parsed_byte_map)
+        self.assertEqual([(None, make_key(26)), (make_key(31), make_key(48))],
             index._parsed_key_map)
         self.assertEqual([((index._size // 2, ('50', )), +1)],
             result)
@@ -595,75 +584,38 @@
         # generate a big enough index that we only read some of it on a typical
         # bisection lookup.
         nodes = []
-        for counter in range(99):
-            nodes.append((self.make_key(counter), self.make_value(counter),
-                ((self.make_key(counter + 20),),)  ))
-        index = self.make_index(ref_lists=1, nodes=nodes)
-        # lookup a key in the middle that does not exist, so that when we can
-        # check that the referred-to-keys are not accessed automatically.
-        index_size = index._size
-        index_center = index_size // 2
-        result = index._lookup_keys_via_location(
-            [(index_center, ('40', ))])
-        # check the parse map - only the start and middle should have been
-        # parsed.
-        self.assertEqual([(0, 4027), (10198, 14028)], index._parsed_byte_map)
-        self.assertEqual([(None, self.make_key(17)),
-                          (self.make_key(44), self.make_key(5))],
-            index._parsed_key_map)
-        # and check the transport activity likewise.
-        self.assertEqual(
-            [('readv', 'index', [(index_center, 800), (0, 200)], True,
-                                  index_size)],
-            index._transport._activity)
-        # reset the transport log for testing the reference lookup
-        del index._transport._activity[:]
-        # now looking up a key in the portion of the file already parsed should
-        # only perform IO to resolve its key references.
-        result = index._lookup_keys_via_location([(11000, self.make_key(45))])
-        self.assertEqual(
-            [((11000, self.make_key(45)),
-              (index, self.make_key(45), self.make_value(45),
-               ((self.make_key(65),),)))],
-            result)
-        self.assertEqual([('readv', 'index', [(15093, 800)], True, index_size)],
-            index._transport._activity)
-
-    def test_lookup_key_can_buffer_all(self):
-        nodes = []
+        def make_key(number):
+            return (str(number) + 'X'*100,)
+        def make_value(number):
+            return str(number) + 'Y'*100
         for counter in range(64):
-            nodes.append((self.make_key(counter), self.make_value(counter),
-                ((self.make_key(counter + 20),),)  ))
+            nodes.append((make_key(counter), make_value(counter),
+                ((make_key(counter + 20),),)  ))
         index = self.make_index(ref_lists=1, nodes=nodes)
         # lookup a key in the middle that does not exist, so that when we can
         # check that the referred-to-keys are not accessed automatically.
-        index_size = index._size
-        index_center = index_size // 2
-        result = index._lookup_keys_via_location([(index_center, ('40', ))])
+        result =index._lookup_keys_via_location(
+            [(index._size // 2, ('40', ))])
         # check the parse map - only the start and middle should have been
         # parsed.
         self.assertEqual([(0, 3890), (6444, 10274)], index._parsed_byte_map)
-        self.assertEqual([(None, self.make_key(25)),
-                          (self.make_key(37), self.make_key(52))],
+        self.assertEqual([(None, make_key(25)), (make_key(37), make_key(52))],
             index._parsed_key_map)
         # and check the transport activity likewise.
         self.assertEqual(
-            [('readv', 'index', [(index_center, 800), (0, 200)], True,
-                                  index_size)],
+            [('readv', 'index', [(7906, 800), (0, 200)], True, 15813)],
             index._transport._activity)
         # reset the transport log for testing the reference lookup
         del index._transport._activity[:]
         # now looking up a key in the portion of the file already parsed should
         # only perform IO to resolve its key references.
-        result = index._lookup_keys_via_location([(7000, self.make_key(40))])
+        result = index._lookup_keys_via_location([(4000, make_key(40))])
         self.assertEqual(
-            [((7000, self.make_key(40)),
-              (index, self.make_key(40), self.make_value(40),
-               ((self.make_key(60),),)))],
+            [((4000, make_key(40)),
+              (index, make_key(40), make_value(40), ((make_key(60),),)))],
             result)
-        # Resolving the references would have required more data read, and we
-        # are already above the 50% threshold, so it triggered a _buffer_all
-        self.assertEqual([('get', 'index')], index._transport._activity)
+        self.assertEqual([('readv', 'index', [(11976, 800)], True, 15813)],
+            index._transport._activity)
 
     def test_iter_all_entries_empty(self):
         index = self.make_index()
@@ -688,48 +640,6 @@
             (index, ('ref', ), 'refdata', ((), ))]),
             set(index.iter_all_entries()))
 
-    def test_iter_entries_buffers_once(self):
-        index = self.make_index(nodes=self.make_nodes(2))
-        # reset the transport log
-        del index._transport._activity[:]
-        self.assertEqual(set([(index, self.make_key(1), self.make_value(1))]),
-                         set(index.iter_entries([self.make_key(1)])))
-        # We should have requested reading the header bytes
-        # But not needed any more than that because it would have triggered a
-        # buffer all
-        self.assertEqual([
-            ('readv', 'index', [(0, 200)], True, index._size),
-            ],
-            index._transport._activity)
-        # And that should have been enough to trigger reading the whole index
-        # with buffering
-        self.assertIsNot(None, index._nodes)
-
-    def test_iter_entries_buffers_by_bytes_read(self):
-        index = self.make_index(nodes=self.make_nodes(64))
-        list(index.iter_entries([self.make_key(10)]))
-        # The first time through isn't enough to trigger a buffer all
-        self.assertIs(None, index._nodes)
-        self.assertEqual(4096, index._bytes_read)
-        # Grabbing a key in that same page won't trigger a buffer all, as we
-        # still haven't read 50% of the file
-        list(index.iter_entries([self.make_key(11)]))
-        self.assertIs(None, index._nodes)
-        self.assertEqual(4096, index._bytes_read)
-        # We haven't read more data, so reading outside the range won't trigger
-        # a buffer all right away
-        list(index.iter_entries([self.make_key(40)]))
-        self.assertIs(None, index._nodes)
-        self.assertEqual(8192, index._bytes_read)
-        # On the next pass, we will not trigger buffer all if the key is
-        # available without reading more
-        list(index.iter_entries([self.make_key(32)]))
-        self.assertIs(None, index._nodes)
-        # But if we *would* need to read more to resolve it, then we will
-        # buffer all.
-        list(index.iter_entries([self.make_key(60)]))
-        self.assertIsNot(None, index._nodes)
-
     def test_iter_entries_references_resolved(self):
         index = self.make_index(1, nodes=[
             (('name', ), 'data', ([('ref', ), ('ref', )], )),
@@ -853,29 +763,6 @@
             (('name', ), '', ()), (('foo', ), '', ())])
         self.assertEqual(2, index.key_count())
 
-    def test_read_and_parse_tracks_real_read_value(self):
-        index = self.make_index(nodes=self.make_nodes(10))
-        del index._transport._activity[:]
-        index._read_and_parse([(0, 200)])
-        self.assertEqual([
-            ('readv', 'index', [(0, 200)], True, index._size),
-            ],
-            index._transport._activity)
-        # The readv expansion code will expand the initial request to 4096
-        # bytes, which is more than enough to read the entire index, and we
-        # will track the fact that we read that many bytes.
-        self.assertEqual(index._size, index._bytes_read)
-
-    def test_read_and_parse_triggers_buffer_all(self):
-        index = self.make_index(key_elements=2, nodes=[
-            (('name', 'fin1'), 'data', ()),
-            (('name', 'fin2'), 'beta', ()),
-            (('ref', 'erence'), 'refdata', ())])
-        self.assertTrue(index._size > 0)
-        self.assertIs(None, index._nodes)
-        index._read_and_parse([(0, index._size)])
-        self.assertIsNot(None, index._nodes)
-
     def test_validate_bad_index_errors(self):
         trans = self.get_transport()
         trans.put_bytes('name', "not an index\n")

=== modified file 'bzrlib/tests/test_info.py'
--- bzrlib/tests/test_info.py	2008-08-29 05:18:56 +0000
+++ bzrlib/tests/test_info.py	2007-10-04 05:50:44 +0000
@@ -126,37 +126,27 @@
 
     def test_describe_tree_format(self):
         for key in bzrdir.format_registry.keys():
-            if key in bzrdir.format_registry.aliases():
+            if key == 'default':
                 continue
             self.assertTreeDescription(key)
 
     def test_describe_checkout_format(self):
         for key in bzrdir.format_registry.keys():
-            if key in bzrdir.format_registry.aliases():
-                # Aliases will not describe correctly in the UI because the
-                # real format is found.
-                continue
-            # legacy: weave does not support checkouts
-            if key == 'weave':
-                continue
-            if bzrdir.format_registry.get_info(key).experimental:
-                # We don't require that experimental formats support checkouts
-                # or describe correctly in the UI.
+            if key in ('default', 'weave', 'experimental'):
+                continue
+            if key.startswith('experimental-'):
+                # these are typically hidden or aliases for other formats
                 continue
             expected = None
-            if key in ('dirstate', 'dirstate-tags', 'dirstate-with-subtree',
-                'pack-0.92', 'pack-0.92-subtree', 'rich-root',
-                'rich-root-pack', '1.6', '1.6.1-rich-root'):
-                expected = '1.6 or 1.6.1-rich-root or ' \
-                    'dirstate or dirstate-tags or pack-0.92 or'\
-                    ' rich-root or rich-root-pack'
+            if key in ('dirstate', 'dirstate-tags', 'dirstate-with-subtree'):
+                expected = 'dirstate or dirstate-tags'
             if key in ('knit', 'metaweave'):
                 expected = 'knit or metaweave'
             self.assertCheckoutDescription(key, expected)
 
     def test_describe_branch_format(self):
         for key in bzrdir.format_registry.keys():
-            if key in bzrdir.format_registry.aliases():
+            if key == 'default':
                 continue
             expected = None
             if key in ('dirstate', 'knit'):
@@ -165,7 +155,7 @@
 
     def test_describe_repo_format(self):
         for key in bzrdir.format_registry.keys():
-            if key in bzrdir.format_registry.aliases():
+            if key == 'default':
                 continue
             expected = None
             if key in ('dirstate', 'knit', 'dirstate-tags'):

=== modified file 'bzrlib/tests/test_knit.py'
--- bzrlib/tests/test_knit.py	2008-07-14 07:39:30 +0000
+++ bzrlib/tests/test_knit.py	2007-10-15 09:04:41 +0000
@@ -26,7 +26,6 @@
     errors,
     generate_ids,
     knit,
-    multiparent,
     pack,
     )
 from bzrlib.errors import (
@@ -39,32 +38,29 @@
 from bzrlib.knit import (
     AnnotatedKnitContent,
     KnitContent,
+    KnitGraphIndex,
+    KnitVersionedFile,
+    KnitPlainFactory,
+    KnitAnnotateFactory,
+    _KnitAccess,
+    _KnitData,
+    _KnitIndex,
+    _PackAccess,
+    PlainKnitContent,
+    WeaveToKnit,
     KnitSequenceMatcher,
-    KnitVersionedFiles,
-    PlainKnitContent,
-    _DirectPackAccess,
-    _KndxIndex,
-    _KnitGraphIndex,
-    _KnitKeyAccess,
-    make_file_factory,
     )
 from bzrlib.osutils import split_lines
-from bzrlib.symbol_versioning import one_four
 from bzrlib.tests import (
     Feature,
-    KnownFailure,
     TestCase,
     TestCaseWithMemoryTransport,
     TestCaseWithTransport,
     )
 from bzrlib.transport import get_transport
 from bzrlib.transport.memory import MemoryTransport
-from bzrlib.tuned_gzip import GzipFile
-from bzrlib.versionedfile import (
-    AbsentContentFactory,
-    ConstantMapper,
-    RecordingVersionedFilesDecorator,
-    )
+from bzrlib.util import bencode
+from bzrlib.weave import Weave
 
 
 class _CompiledKnitFeature(Feature):
@@ -145,51 +141,6 @@
         self.assertDerivedBlocksEqual('a\nb\nc', 'a\nb\nc\n', noeol=True)
 
 
-TEXT_1 = """\
-Banana cup cakes:
-
-- bananas
-- eggs
-- broken tea cups
-"""
-
-TEXT_1A = """\
-Banana cup cake recipe
-(serves 6)
-
-- bananas
-- eggs
-- broken tea cups
-- self-raising flour
-"""
-
-TEXT_1B = """\
-Banana cup cake recipe
-
-- bananas (do not use plantains!!!)
-- broken tea cups
-- flour
-"""
-
-delta_1_1a = """\
-0,1,2
-Banana cup cake recipe
-(serves 6)
-5,5,1
-- self-raising flour
-"""
-
-TEXT_2 = """\
-Boeuf bourguignon
-
-- beef
-- red wine
-- small onions
-- carrot
-- mushrooms
-"""
-
-
 class TestPlainKnitContent(TestCase, KnitContentTestsMixin):
 
     def _make_content(self, lines):
@@ -204,6 +155,17 @@
         self.assertEqual(content.annotate(),
             [("bogus", "text1"), ("bogus", "text2")])
 
+    def test_annotate_iter(self):
+        content = self._make_content([])
+        it = content.annotate_iter()
+        self.assertRaises(StopIteration, it.next)
+
+        content = self._make_content([("bogus", "text1"), ("bogus", "text2")])
+        it = content.annotate_iter()
+        self.assertEqual(it.next(), ("bogus", "text1"))
+        self.assertEqual(it.next(), ("bogus", "text2"))
+        self.assertRaises(StopIteration, it.next)
+
     def test_line_delta(self):
         content1 = self._make_content([("", "a"), ("", "b")])
         content2 = self._make_content([("", "a"), ("", "a"), ("", "c")])
@@ -231,6 +193,17 @@
         self.assertEqual(content.annotate(),
             [("origin1", "text1"), ("origin2", "text2")])
 
+    def test_annotate_iter(self):
+        content = self._make_content([])
+        it = content.annotate_iter()
+        self.assertRaises(StopIteration, it.next)
+
+        content = self._make_content([("origin1", "text1"), ("origin2", "text2")])
+        it = content.annotate_iter()
+        self.assertEqual(it.next(), ("origin1", "text1"))
+        self.assertEqual(it.next(), ("origin2", "text2"))
+        self.assertRaises(StopIteration, it.next)
+
     def test_line_delta(self):
         content1 = self._make_content([("", "a"), ("", "b")])
         content2 = self._make_content([("", "a"), ("", "a"), ("", "c")])
@@ -274,17 +247,20 @@
 class KnitRecordAccessTestsMixin(object):
     """Tests for getting and putting knit records."""
 
+    def assertAccessExists(self, access):
+        """Ensure the data area for access has been initialised/exists."""
+        raise NotImplementedError(self.assertAccessExists)
+
     def test_add_raw_records(self):
         """Add_raw_records adds records retrievable later."""
         access = self.get_access()
-        memos = access.add_raw_records([('key', 10)], '1234567890')
+        memos = access.add_raw_records([10], '1234567890')
         self.assertEqual(['1234567890'], list(access.get_raw_records(memos)))
  
     def test_add_several_raw_records(self):
         """add_raw_records with many records and read some back."""
         access = self.get_access()
-        memos = access.add_raw_records([('key', 10), ('key2', 2), ('key3', 5)],
-            '12345678901234567')
+        memos = access.add_raw_records([10, 2, 5], '12345678901234567')
         self.assertEqual(['1234567890', '12', '34567'],
             list(access.get_raw_records(memos)))
         self.assertEqual(['1234567890'],
@@ -296,20 +272,39 @@
         self.assertEqual(['1234567890', '34567'],
             list(access.get_raw_records(memos[0:1] + memos[2:3])))
 
+    def test_create(self):
+        """create() should make a file on disk."""
+        access = self.get_access()
+        access.create()
+        self.assertAccessExists(access)
+
+    def test_open_file(self):
+        """open_file never errors."""
+        access = self.get_access()
+        access.open_file()
+
 
 class TestKnitKnitAccess(TestCaseWithMemoryTransport, KnitRecordAccessTestsMixin):
     """Tests for the .kndx implementation."""
 
+    def assertAccessExists(self, access):
+        self.assertNotEqual(None, access.open_file())
+
     def get_access(self):
         """Get a .knit style access instance."""
-        mapper = ConstantMapper("foo")
-        access = _KnitKeyAccess(self.get_transport(), mapper)
+        access = _KnitAccess(self.get_transport(), "foo.knit", None, None,
+            False, False)
         return access
     
 
 class TestPackKnitAccess(TestCaseWithMemoryTransport, KnitRecordAccessTestsMixin):
     """Tests for the pack based access."""
 
+    def assertAccessExists(self, access):
+        # as pack based access has no backing unless an index maps data, this
+        # is a no-op.
+        pass
+
     def get_access(self):
         return self._get_access()[0]
 
@@ -319,23 +314,23 @@
             transport.append_bytes(packname, bytes)
         writer = pack.ContainerWriter(write_data)
         writer.begin()
-        access = _DirectPackAccess({})
-        access.set_writer(writer, index, (transport, packname))
+        indices = {index:(transport, packname)}
+        access = _PackAccess(indices, writer=(writer, index))
         return access, writer
 
     def test_read_from_several_packs(self):
         access, writer = self._get_access()
         memos = []
-        memos.extend(access.add_raw_records([('key', 10)], '1234567890'))
+        memos.extend(access.add_raw_records([10], '1234567890'))
         writer.end()
         access, writer = self._get_access('pack2', 'FOOBAR')
-        memos.extend(access.add_raw_records([('key', 5)], '12345'))
+        memos.extend(access.add_raw_records([5], '12345'))
         writer.end()
         access, writer = self._get_access('pack3', 'BAZ')
-        memos.extend(access.add_raw_records([('key', 5)], 'alpha'))
+        memos.extend(access.add_raw_records([5], 'alpha'))
         writer.end()
         transport = self.get_transport()
-        access = _DirectPackAccess({"FOO":(transport, 'packfile'),
+        access = _PackAccess({"FOO":(transport, 'packfile'),
             "FOOBAR":(transport, 'pack2'),
             "BAZ":(transport, 'pack3')})
         self.assertEqual(['1234567890', '12345', 'alpha'],
@@ -351,7 +346,7 @@
 
     def test_set_writer(self):
         """The writer should be settable post construction."""
-        access = _DirectPackAccess({})
+        access = _PackAccess({})
         transport = self.get_transport()
         packname = 'packfile'
         index = 'foo'
@@ -360,7 +355,7 @@
         writer = pack.ContainerWriter(write_data)
         writer.begin()
         access.set_writer(writer, index, (transport, packname))
-        memos = access.add_raw_records([('key', 10)], '1234567890')
+        memos = access.add_raw_records([10], '1234567890')
         writer.end()
         self.assertEqual(['1234567890'], list(access.get_raw_records(memos)))
 
@@ -382,16 +377,15 @@
                                         'end rev-id-1\n'
                                         % (sha1sum,))
         transport = MockTransport([gz_txt])
-        access = _KnitKeyAccess(transport, ConstantMapper('filename'))
-        knit = KnitVersionedFiles(None, access)
-        records = [(('rev-id-1',), (('rev-id-1',), 0, len(gz_txt)))]
-
-        contents = list(knit._read_records_iter(records))
-        self.assertEqual([(('rev-id-1',), ['foo\n', 'bar\n'],
-            '4e48e2c9a3d2ca8a708cb0cc545700544efb5021')], contents)
-
-        raw_contents = list(knit._read_records_iter_raw(records))
-        self.assertEqual([(('rev-id-1',), gz_txt, sha1sum)], raw_contents)
+        access = _KnitAccess(transport, 'filename', None, None, False, False)
+        data = _KnitData(access=access)
+        records = [('rev-id-1', (None, 0, len(gz_txt)))]
+
+        contents = data.read_records(records)
+        self.assertEqual({'rev-id-1':(['foo\n', 'bar\n'], sha1sum)}, contents)
+
+        raw_contents = list(data.read_records_iter_raw(records))
+        self.assertEqual([('rev-id-1', gz_txt)], raw_contents)
 
     def test_not_enough_lines(self):
         sha1sum = sha.new('foo\n').hexdigest()
@@ -401,15 +395,14 @@
                                         'end rev-id-1\n'
                                         % (sha1sum,))
         transport = MockTransport([gz_txt])
-        access = _KnitKeyAccess(transport, ConstantMapper('filename'))
-        knit = KnitVersionedFiles(None, access)
-        records = [(('rev-id-1',), (('rev-id-1',), 0, len(gz_txt)))]
-        self.assertRaises(errors.KnitCorrupt, list,
-            knit._read_records_iter(records))
+        access = _KnitAccess(transport, 'filename', None, None, False, False)
+        data = _KnitData(access=access)
+        records = [('rev-id-1', (None, 0, len(gz_txt)))]
+        self.assertRaises(errors.KnitCorrupt, data.read_records, records)
 
         # read_records_iter_raw won't detect that sort of mismatch/corruption
-        raw_contents = list(knit._read_records_iter_raw(records))
-        self.assertEqual([(('rev-id-1',),  gz_txt, sha1sum)], raw_contents)
+        raw_contents = list(data.read_records_iter_raw(records))
+        self.assertEqual([('rev-id-1', gz_txt)], raw_contents)
 
     def test_too_many_lines(self):
         sha1sum = sha.new('foo\nbar\n').hexdigest()
@@ -420,15 +413,14 @@
                                         'end rev-id-1\n'
                                         % (sha1sum,))
         transport = MockTransport([gz_txt])
-        access = _KnitKeyAccess(transport, ConstantMapper('filename'))
-        knit = KnitVersionedFiles(None, access)
-        records = [(('rev-id-1',), (('rev-id-1',), 0, len(gz_txt)))]
-        self.assertRaises(errors.KnitCorrupt, list,
-            knit._read_records_iter(records))
+        access = _KnitAccess(transport, 'filename', None, None, False, False)
+        data = _KnitData(access=access)
+        records = [('rev-id-1', (None, 0, len(gz_txt)))]
+        self.assertRaises(errors.KnitCorrupt, data.read_records, records)
 
         # read_records_iter_raw won't detect that sort of mismatch/corruption
-        raw_contents = list(knit._read_records_iter_raw(records))
-        self.assertEqual([(('rev-id-1',), gz_txt, sha1sum)], raw_contents)
+        raw_contents = list(data.read_records_iter_raw(records))
+        self.assertEqual([('rev-id-1', gz_txt)], raw_contents)
 
     def test_mismatched_version_id(self):
         sha1sum = sha.new('foo\nbar\n').hexdigest()
@@ -438,16 +430,15 @@
                                         'end rev-id-1\n'
                                         % (sha1sum,))
         transport = MockTransport([gz_txt])
-        access = _KnitKeyAccess(transport, ConstantMapper('filename'))
-        knit = KnitVersionedFiles(None, access)
+        access = _KnitAccess(transport, 'filename', None, None, False, False)
+        data = _KnitData(access=access)
         # We are asking for rev-id-2, but the data is rev-id-1
-        records = [(('rev-id-2',), (('rev-id-2',), 0, len(gz_txt)))]
-        self.assertRaises(errors.KnitCorrupt, list,
-            knit._read_records_iter(records))
+        records = [('rev-id-2', (None, 0, len(gz_txt)))]
+        self.assertRaises(errors.KnitCorrupt, data.read_records, records)
 
-        # read_records_iter_raw detects mismatches in the header
+        # read_records_iter_raw will notice if we request the wrong version.
         self.assertRaises(errors.KnitCorrupt, list,
-            knit._read_records_iter_raw(records))
+                          data.read_records_iter_raw(records))
 
     def test_uncompressed_data(self):
         sha1sum = sha.new('foo\nbar\n').hexdigest()
@@ -457,17 +448,16 @@
                'end rev-id-1\n'
                % (sha1sum,))
         transport = MockTransport([txt])
-        access = _KnitKeyAccess(transport, ConstantMapper('filename'))
-        knit = KnitVersionedFiles(None, access)
-        records = [(('rev-id-1',), (('rev-id-1',), 0, len(txt)))]
+        access = _KnitAccess(transport, 'filename', None, None, False, False)
+        data = _KnitData(access=access)
+        records = [('rev-id-1', (None, 0, len(txt)))]
 
         # We don't have valid gzip data ==> corrupt
-        self.assertRaises(errors.KnitCorrupt, list,
-            knit._read_records_iter(records))
+        self.assertRaises(errors.KnitCorrupt, data.read_records, records)
 
         # read_records_iter_raw will notice the bad data
         self.assertRaises(errors.KnitCorrupt, list,
-            knit._read_records_iter_raw(records))
+                          data.read_records_iter_raw(records))
 
     def test_corrupted_data(self):
         sha1sum = sha.new('foo\nbar\n').hexdigest()
@@ -479,261 +469,415 @@
         # Change 2 bytes in the middle to \xff
         gz_txt = gz_txt[:10] + '\xff\xff' + gz_txt[12:]
         transport = MockTransport([gz_txt])
-        access = _KnitKeyAccess(transport, ConstantMapper('filename'))
-        knit = KnitVersionedFiles(None, access)
-        records = [(('rev-id-1',), (('rev-id-1',), 0, len(gz_txt)))]
-        self.assertRaises(errors.KnitCorrupt, list,
-            knit._read_records_iter(records))
-        # read_records_iter_raw will barf on bad gz data
-        self.assertRaises(errors.KnitCorrupt, list,
-            knit._read_records_iter_raw(records))
+        access = _KnitAccess(transport, 'filename', None, None, False, False)
+        data = _KnitData(access=access)
+        records = [('rev-id-1', (None, 0, len(gz_txt)))]
+
+        self.assertRaises(errors.KnitCorrupt, data.read_records, records)
+
+        # read_records_iter_raw will notice if we request the wrong version.
+        self.assertRaises(errors.KnitCorrupt, list,
+                          data.read_records_iter_raw(records))
 
 
 class LowLevelKnitIndexTests(TestCase):
 
-    def get_knit_index(self, transport, name, mode):
-        mapper = ConstantMapper(name)
+    def get_knit_index(self, *args, **kwargs):
         orig = knit._load_data
         def reset():
             knit._load_data = orig
         self.addCleanup(reset)
         from bzrlib._knit_load_data_py import _load_data_py
         knit._load_data = _load_data_py
-        allow_writes = lambda: 'w' in mode
-        return _KndxIndex(transport, mapper, lambda:None, allow_writes, lambda:True)
+        return _KnitIndex(*args, **kwargs)
+
+    def test_no_such_file(self):
+        transport = MockTransport()
+
+        self.assertRaises(NoSuchFile, self.get_knit_index,
+                          transport, "filename", "r")
+        self.assertRaises(NoSuchFile, self.get_knit_index,
+                          transport, "filename", "w", create=False)
 
     def test_create_file(self):
         transport = MockTransport()
-        index = self.get_knit_index(transport, "filename", "w")
-        index.keys()
-        call = transport.calls.pop(0)
-        # call[1][1] is a StringIO - we can't test it by simple equality.
-        self.assertEqual('put_file_non_atomic', call[0])
-        self.assertEqual('filename.kndx', call[1][0])
-        # With no history, _KndxIndex writes a new index:
-        self.assertEqual(_KndxIndex.HEADER,
-            call[1][1].getvalue())
-        self.assertEqual({'create_parent_dir': True}, call[2])
+
+        index = self.get_knit_index(transport, "filename", "w",
+            file_mode="wb", create=True)
+        self.assertEqual(
+                ("put_bytes_non_atomic",
+                    ("filename", index.HEADER), {"mode": "wb"}),
+                transport.calls.pop(0))
+
+    def test_delay_create_file(self):
+        transport = MockTransport()
+
+        index = self.get_knit_index(transport, "filename", "w",
+            create=True, file_mode="wb", create_parent_dir=True,
+            delay_create=True, dir_mode=0777)
+        self.assertEqual([], transport.calls)
+
+        index.add_versions([])
+        name, (filename, f), kwargs = transport.calls.pop(0)
+        self.assertEqual("put_file_non_atomic", name)
+        self.assertEqual(
+            {"dir_mode": 0777, "create_parent_dir": True, "mode": "wb"},
+            kwargs)
+        self.assertEqual("filename", filename)
+        self.assertEqual(index.HEADER, f.read())
+
+        index.add_versions([])
+        self.assertEqual(("append_bytes", ("filename", ""), {}),
+            transport.calls.pop(0))
 
     def test_read_utf8_version_id(self):
         unicode_revision_id = u"version-\N{CYRILLIC CAPITAL LETTER A}"
         utf8_revision_id = unicode_revision_id.encode('utf-8')
         transport = MockTransport([
-            _KndxIndex.HEADER,
+            _KnitIndex.HEADER,
             '%s option 0 1 :' % (utf8_revision_id,)
             ])
         index = self.get_knit_index(transport, "filename", "r")
-        # _KndxIndex is a private class, and deals in utf8 revision_ids, not
+        # _KnitIndex is a private class, and deals in utf8 revision_ids, not
         # Unicode revision_ids.
-        self.assertEqual({(utf8_revision_id,):()},
-            index.get_parent_map(index.keys()))
-        self.assertFalse((unicode_revision_id,) in index.keys())
+        self.assertTrue(index.has_version(utf8_revision_id))
+        self.assertFalse(index.has_version(unicode_revision_id))
 
     def test_read_utf8_parents(self):
         unicode_revision_id = u"version-\N{CYRILLIC CAPITAL LETTER A}"
         utf8_revision_id = unicode_revision_id.encode('utf-8')
         transport = MockTransport([
-            _KndxIndex.HEADER,
+            _KnitIndex.HEADER,
             "version option 0 1 .%s :" % (utf8_revision_id,)
             ])
         index = self.get_knit_index(transport, "filename", "r")
-        self.assertEqual({("version",):((utf8_revision_id,),)},
-            index.get_parent_map(index.keys()))
+        self.assertEqual([utf8_revision_id],
+            index.get_parents_with_ghosts("version"))
 
     def test_read_ignore_corrupted_lines(self):
         transport = MockTransport([
-            _KndxIndex.HEADER,
+            _KnitIndex.HEADER,
             "corrupted",
             "corrupted options 0 1 .b .c ",
             "version options 0 1 :"
             ])
         index = self.get_knit_index(transport, "filename", "r")
-        self.assertEqual(1, len(index.keys()))
-        self.assertEqual(set([("version",)]), index.keys())
+        self.assertEqual(1, index.num_versions())
+        self.assertTrue(index.has_version("version"))
 
     def test_read_corrupted_header(self):
         transport = MockTransport(['not a bzr knit index header\n'])
-        index = self.get_knit_index(transport, "filename", "r")
-        self.assertRaises(KnitHeaderError, index.keys)
+        self.assertRaises(KnitHeaderError,
+            self.get_knit_index, transport, "filename", "r")
 
     def test_read_duplicate_entries(self):
         transport = MockTransport([
-            _KndxIndex.HEADER,
+            _KnitIndex.HEADER,
             "parent options 0 1 :",
             "version options1 0 1 0 :",
             "version options2 1 2 .other :",
             "version options3 3 4 0 .other :"
             ])
         index = self.get_knit_index(transport, "filename", "r")
-        self.assertEqual(2, len(index.keys()))
+        self.assertEqual(2, index.num_versions())
         # check that the index used is the first one written. (Specific
         # to KnitIndex style indices.
-        self.assertEqual("1", index._dictionary_compress([("version",)]))
-        self.assertEqual((("version",), 3, 4), index.get_position(("version",)))
-        self.assertEqual(["options3"], index.get_options(("version",)))
-        self.assertEqual({("version",):(("parent",), ("other",))},
-            index.get_parent_map([("version",)]))
+        self.assertEqual("1", index._version_list_to_index(["version"]))
+        self.assertEqual((None, 3, 4), index.get_position("version"))
+        self.assertEqual(["options3"], index.get_options("version"))
+        self.assertEqual(["parent", "other"],
+            index.get_parents_with_ghosts("version"))
 
     def test_read_compressed_parents(self):
         transport = MockTransport([
-            _KndxIndex.HEADER,
+            _KnitIndex.HEADER,
             "a option 0 1 :",
             "b option 0 1 0 :",
             "c option 0 1 1 0 :",
             ])
         index = self.get_knit_index(transport, "filename", "r")
-        self.assertEqual({("b",):(("a",),), ("c",):(("b",), ("a",))},
-            index.get_parent_map([("b",), ("c",)]))
+        self.assertEqual(["a"], index.get_parents("b"))
+        self.assertEqual(["b", "a"], index.get_parents("c"))
 
     def test_write_utf8_version_id(self):
         unicode_revision_id = u"version-\N{CYRILLIC CAPITAL LETTER A}"
         utf8_revision_id = unicode_revision_id.encode('utf-8')
         transport = MockTransport([
-            _KndxIndex.HEADER
+            _KnitIndex.HEADER
             ])
         index = self.get_knit_index(transport, "filename", "r")
-        index.add_records([
-            ((utf8_revision_id,), ["option"], ((utf8_revision_id,), 0, 1), [])])
-        call = transport.calls.pop(0)
-        # call[1][1] is a StringIO - we can't test it by simple equality.
-        self.assertEqual('put_file_non_atomic', call[0])
-        self.assertEqual('filename.kndx', call[1][0])
-        # With no history, _KndxIndex writes a new index:
-        self.assertEqual(_KndxIndex.HEADER +
-            "\n%s option 0 1  :" % (utf8_revision_id,),
-            call[1][1].getvalue())
-        self.assertEqual({'create_parent_dir': True}, call[2])
+        index.add_version(utf8_revision_id, ["option"], (None, 0, 1), [])
+        self.assertEqual(("append_bytes", ("filename",
+            "\n%s option 0 1  :" % (utf8_revision_id,)),
+            {}),
+            transport.calls.pop(0))
 
     def test_write_utf8_parents(self):
         unicode_revision_id = u"version-\N{CYRILLIC CAPITAL LETTER A}"
         utf8_revision_id = unicode_revision_id.encode('utf-8')
         transport = MockTransport([
-            _KndxIndex.HEADER
-            ])
-        index = self.get_knit_index(transport, "filename", "r")
-        index.add_records([
-            (("version",), ["option"], (("version",), 0, 1), [(utf8_revision_id,)])])
-        call = transport.calls.pop(0)
-        # call[1][1] is a StringIO - we can't test it by simple equality.
-        self.assertEqual('put_file_non_atomic', call[0])
-        self.assertEqual('filename.kndx', call[1][0])
-        # With no history, _KndxIndex writes a new index:
-        self.assertEqual(_KndxIndex.HEADER +
-            "\nversion option 0 1 .%s :" % (utf8_revision_id,),
-            call[1][1].getvalue())
-        self.assertEqual({'create_parent_dir': True}, call[2])
-
-    def test_keys(self):
-        transport = MockTransport([
-            _KndxIndex.HEADER
-            ])
-        index = self.get_knit_index(transport, "filename", "r")
-
-        self.assertEqual(set(), index.keys())
-
-        index.add_records([(("a",), ["option"], (("a",), 0, 1), [])])
-        self.assertEqual(set([("a",)]), index.keys())
-
-        index.add_records([(("a",), ["option"], (("a",), 0, 1), [])])
-        self.assertEqual(set([("a",)]), index.keys())
-
-        index.add_records([(("b",), ["option"], (("b",), 0, 1), [])])
-        self.assertEqual(set([("a",), ("b",)]), index.keys())
-
-    def add_a_b(self, index, random_id=None):
-        kwargs = {}
-        if random_id is not None:
-            kwargs["random_id"] = random_id
-        index.add_records([
-            (("a",), ["option"], (("a",), 0, 1), [("b",)]),
-            (("a",), ["opt"], (("a",), 1, 2), [("c",)]),
-            (("b",), ["option"], (("b",), 2, 3), [("a",)])
-            ], **kwargs)
-
-    def assertIndexIsAB(self, index):
-        self.assertEqual({
-            ('a',): (('c',),),
-            ('b',): (('a',),),
-            },
-            index.get_parent_map(index.keys()))
-        self.assertEqual((("a",), 1, 2), index.get_position(("a",)))
-        self.assertEqual((("b",), 2, 3), index.get_position(("b",)))
-        self.assertEqual(["opt"], index.get_options(("a",)))
+            _KnitIndex.HEADER
+            ])
+        index = self.get_knit_index(transport, "filename", "r")
+        index.add_version("version", ["option"], (None, 0, 1), [utf8_revision_id])
+        self.assertEqual(("append_bytes", ("filename",
+            "\nversion option 0 1 .%s :" % (utf8_revision_id,)),
+            {}),
+            transport.calls.pop(0))
+
+    def test_get_graph(self):
+        transport = MockTransport()
+        index = self.get_knit_index(transport, "filename", "w", create=True)
+        self.assertEqual([], index.get_graph())
+
+        index.add_version("a", ["option"], (None, 0, 1), ["b"])
+        self.assertEqual([("a", ["b"])], index.get_graph())
+
+        index.add_version("c", ["option"], (None, 0, 1), ["d"])
+        self.assertEqual([("a", ["b"]), ("c", ["d"])],
+            sorted(index.get_graph()))
+
+    def test_get_ancestry(self):
+        transport = MockTransport([
+            _KnitIndex.HEADER,
+            "a option 0 1 :",
+            "b option 0 1 0 .e :",
+            "c option 0 1 1 0 :",
+            "d option 0 1 2 .f :"
+            ])
+        index = self.get_knit_index(transport, "filename", "r")
+
+        self.assertEqual([], index.get_ancestry([]))
+        self.assertEqual(["a"], index.get_ancestry(["a"]))
+        self.assertEqual(["a", "b"], index.get_ancestry(["b"]))
+        self.assertEqual(["a", "b", "c"], index.get_ancestry(["c"]))
+        self.assertEqual(["a", "b", "c", "d"], index.get_ancestry(["d"]))
+        self.assertEqual(["a", "b"], index.get_ancestry(["a", "b"]))
+        self.assertEqual(["a", "b", "c"], index.get_ancestry(["a", "c"]))
+
+        self.assertRaises(RevisionNotPresent, index.get_ancestry, ["e"])
+
+    def test_get_ancestry_with_ghosts(self):
+        transport = MockTransport([
+            _KnitIndex.HEADER,
+            "a option 0 1 :",
+            "b option 0 1 0 .e :",
+            "c option 0 1 0 .f .g :",
+            "d option 0 1 2 .h .j .k :"
+            ])
+        index = self.get_knit_index(transport, "filename", "r")
+
+        self.assertEqual([], index.get_ancestry_with_ghosts([]))
+        self.assertEqual(["a"], index.get_ancestry_with_ghosts(["a"]))
+        self.assertEqual(["a", "e", "b"],
+            index.get_ancestry_with_ghosts(["b"]))
+        self.assertEqual(["a", "g", "f", "c"],
+            index.get_ancestry_with_ghosts(["c"]))
+        self.assertEqual(["a", "g", "f", "c", "k", "j", "h", "d"],
+            index.get_ancestry_with_ghosts(["d"]))
+        self.assertEqual(["a", "e", "b"],
+            index.get_ancestry_with_ghosts(["a", "b"]))
+        self.assertEqual(["a", "g", "f", "c"],
+            index.get_ancestry_with_ghosts(["a", "c"]))
+        self.assertEqual(
+            ["a", "g", "f", "c", "e", "b", "k", "j", "h", "d"],
+            index.get_ancestry_with_ghosts(["b", "d"]))
+
+        self.assertRaises(RevisionNotPresent,
+            index.get_ancestry_with_ghosts, ["e"])
+
+    def test_iter_parents(self):
+        transport = MockTransport()
+        index = self.get_knit_index(transport, "filename", "w", create=True)
+        # no parents
+        index.add_version('r0', ['option'], (None, 0, 1), [])
+        # 1 parent
+        index.add_version('r1', ['option'], (None, 0, 1), ['r0'])
+        # 2 parents
+        index.add_version('r2', ['option'], (None, 0, 1), ['r1', 'r0'])
+        # XXX TODO a ghost
+        # cases: each sample data individually:
+        self.assertEqual(set([('r0', ())]),
+            set(index.iter_parents(['r0'])))
+        self.assertEqual(set([('r1', ('r0', ))]),
+            set(index.iter_parents(['r1'])))
+        self.assertEqual(set([('r2', ('r1', 'r0'))]),
+            set(index.iter_parents(['r2'])))
+        # no nodes returned for a missing node
+        self.assertEqual(set(),
+            set(index.iter_parents(['missing'])))
+        # 1 node returned with missing nodes skipped
+        self.assertEqual(set([('r1', ('r0', ))]),
+            set(index.iter_parents(['ghost1', 'r1', 'ghost'])))
+        # 2 nodes returned
+        self.assertEqual(set([('r0', ()), ('r1', ('r0', ))]),
+            set(index.iter_parents(['r0', 'r1'])))
+        # 2 nodes returned, missing skipped
+        self.assertEqual(set([('r0', ()), ('r1', ('r0', ))]),
+            set(index.iter_parents(['a', 'r0', 'b', 'r1', 'c'])))
+
+    def test_num_versions(self):
+        transport = MockTransport([
+            _KnitIndex.HEADER
+            ])
+        index = self.get_knit_index(transport, "filename", "r")
+
+        self.assertEqual(0, index.num_versions())
+        self.assertEqual(0, len(index))
+
+        index.add_version("a", ["option"], (None, 0, 1), [])
+        self.assertEqual(1, index.num_versions())
+        self.assertEqual(1, len(index))
+
+        index.add_version("a", ["option2"], (None, 1, 2), [])
+        self.assertEqual(1, index.num_versions())
+        self.assertEqual(1, len(index))
+
+        index.add_version("b", ["option"], (None, 0, 1), [])
+        self.assertEqual(2, index.num_versions())
+        self.assertEqual(2, len(index))
+
+    def test_get_versions(self):
+        transport = MockTransport([
+            _KnitIndex.HEADER
+            ])
+        index = self.get_knit_index(transport, "filename", "r")
+
+        self.assertEqual([], index.get_versions())
+
+        index.add_version("a", ["option"], (None, 0, 1), [])
+        self.assertEqual(["a"], index.get_versions())
+
+        index.add_version("a", ["option"], (None, 0, 1), [])
+        self.assertEqual(["a"], index.get_versions())
+
+        index.add_version("b", ["option"], (None, 0, 1), [])
+        self.assertEqual(["a", "b"], index.get_versions())
+
+    def test_add_version(self):
+        transport = MockTransport([
+            _KnitIndex.HEADER
+            ])
+        index = self.get_knit_index(transport, "filename", "r")
+
+        index.add_version("a", ["option"], (None, 0, 1), ["b"])
+        self.assertEqual(("append_bytes",
+            ("filename", "\na option 0 1 .b :"),
+            {}), transport.calls.pop(0))
+        self.assertTrue(index.has_version("a"))
+        self.assertEqual(1, index.num_versions())
+        self.assertEqual((None, 0, 1), index.get_position("a"))
+        self.assertEqual(["option"], index.get_options("a"))
+        self.assertEqual(["b"], index.get_parents_with_ghosts("a"))
+
+        index.add_version("a", ["opt"], (None, 1, 2), ["c"])
+        self.assertEqual(("append_bytes",
+            ("filename", "\na opt 1 2 .c :"),
+            {}), transport.calls.pop(0))
+        self.assertTrue(index.has_version("a"))
+        self.assertEqual(1, index.num_versions())
+        self.assertEqual((None, 1, 2), index.get_position("a"))
+        self.assertEqual(["opt"], index.get_options("a"))
+        self.assertEqual(["c"], index.get_parents_with_ghosts("a"))
+
+        index.add_version("b", ["option"], (None, 2, 3), ["a"])
+        self.assertEqual(("append_bytes",
+            ("filename", "\nb option 2 3 0 :"),
+            {}), transport.calls.pop(0))
+        self.assertTrue(index.has_version("b"))
+        self.assertEqual(2, index.num_versions())
+        self.assertEqual((None, 2, 3), index.get_position("b"))
+        self.assertEqual(["option"], index.get_options("b"))
+        self.assertEqual(["a"], index.get_parents_with_ghosts("b"))
 
     def test_add_versions(self):
         transport = MockTransport([
-            _KndxIndex.HEADER
+            _KnitIndex.HEADER
             ])
         index = self.get_knit_index(transport, "filename", "r")
 
-        self.add_a_b(index)
-        call = transport.calls.pop(0)
-        # call[1][1] is a StringIO - we can't test it by simple equality.
-        self.assertEqual('put_file_non_atomic', call[0])
-        self.assertEqual('filename.kndx', call[1][0])
-        # With no history, _KndxIndex writes a new index:
-        self.assertEqual(
-            _KndxIndex.HEADER +
+        index.add_versions([
+            ("a", ["option"], (None, 0, 1), ["b"]),
+            ("a", ["opt"], (None, 1, 2), ["c"]),
+            ("b", ["option"], (None, 2, 3), ["a"])
+            ])
+        self.assertEqual(("append_bytes", ("filename",
             "\na option 0 1 .b :"
             "\na opt 1 2 .c :"
-            "\nb option 2 3 0 :",
-            call[1][1].getvalue())
-        self.assertEqual({'create_parent_dir': True}, call[2])
-        self.assertIndexIsAB(index)
+            "\nb option 2 3 0 :"
+            ), {}), transport.calls.pop(0))
+        self.assertTrue(index.has_version("a"))
+        self.assertTrue(index.has_version("b"))
+        self.assertEqual(2, index.num_versions())
+        self.assertEqual((None, 1, 2), index.get_position("a"))
+        self.assertEqual((None, 2, 3), index.get_position("b"))
+        self.assertEqual(["opt"], index.get_options("a"))
+        self.assertEqual(["option"], index.get_options("b"))
+        self.assertEqual(["c"], index.get_parents_with_ghosts("a"))
+        self.assertEqual(["a"], index.get_parents_with_ghosts("b"))
 
     def test_add_versions_random_id_is_accepted(self):
         transport = MockTransport([
-            _KndxIndex.HEADER
+            _KnitIndex.HEADER
             ])
         index = self.get_knit_index(transport, "filename", "r")
-        self.add_a_b(index, random_id=True)
+
+        index.add_versions([
+            ("a", ["option"], (None, 0, 1), ["b"]),
+            ("a", ["opt"], (None, 1, 2), ["c"]),
+            ("b", ["option"], (None, 2, 3), ["a"])
+            ], random_id=True)
 
     def test_delay_create_and_add_versions(self):
         transport = MockTransport()
 
-        index = self.get_knit_index(transport, "filename", "w")
-        # dir_mode=0777)
+        index = self.get_knit_index(transport, "filename", "w",
+            create=True, file_mode="wb", create_parent_dir=True,
+            delay_create=True, dir_mode=0777)
         self.assertEqual([], transport.calls)
-        self.add_a_b(index)
-        #self.assertEqual(
-        #[    {"dir_mode": 0777, "create_parent_dir": True, "mode": "wb"},
-        #    kwargs)
-        # Two calls: one during which we load the existing index (and when its
-        # missing create it), then a second where we write the contents out.
-        self.assertEqual(2, len(transport.calls))
-        call = transport.calls.pop(0)
-        self.assertEqual('put_file_non_atomic', call[0])
-        self.assertEqual('filename.kndx', call[1][0])
-        # With no history, _KndxIndex writes a new index:
-        self.assertEqual(_KndxIndex.HEADER, call[1][1].getvalue())
-        self.assertEqual({'create_parent_dir': True}, call[2])
-        call = transport.calls.pop(0)
-        # call[1][1] is a StringIO - we can't test it by simple equality.
-        self.assertEqual('put_file_non_atomic', call[0])
-        self.assertEqual('filename.kndx', call[1][0])
-        # With no history, _KndxIndex writes a new index:
-        self.assertEqual(
-            _KndxIndex.HEADER +
+
+        index.add_versions([
+            ("a", ["option"], (None, 0, 1), ["b"]),
+            ("a", ["opt"], (None, 1, 2), ["c"]),
+            ("b", ["option"], (None, 2, 3), ["a"])
+            ])
+        name, (filename, f), kwargs = transport.calls.pop(0)
+        self.assertEqual("put_file_non_atomic", name)
+        self.assertEqual(
+            {"dir_mode": 0777, "create_parent_dir": True, "mode": "wb"},
+            kwargs)
+        self.assertEqual("filename", filename)
+        self.assertEqual(
+            index.HEADER +
             "\na option 0 1 .b :"
             "\na opt 1 2 .c :"
             "\nb option 2 3 0 :",
-            call[1][1].getvalue())
-        self.assertEqual({'create_parent_dir': True}, call[2])
+            f.read())
+
+    def test_has_version(self):
+        transport = MockTransport([
+            _KnitIndex.HEADER,
+            "a option 0 1 :"
+            ])
+        index = self.get_knit_index(transport, "filename", "r")
+
+        self.assertTrue(index.has_version("a"))
+        self.assertFalse(index.has_version("b"))
 
     def test_get_position(self):
         transport = MockTransport([
-            _KndxIndex.HEADER,
+            _KnitIndex.HEADER,
             "a option 0 1 :",
             "b option 1 2 :"
             ])
         index = self.get_knit_index(transport, "filename", "r")
 
-        self.assertEqual((("a",), 0, 1), index.get_position(("a",)))
-        self.assertEqual((("b",), 1, 2), index.get_position(("b",)))
+        self.assertEqual((None, 0, 1), index.get_position("a"))
+        self.assertEqual((None, 1, 2), index.get_position("b"))
 
     def test_get_method(self):
         transport = MockTransport([
-            _KndxIndex.HEADER,
+            _KnitIndex.HEADER,
             "a fulltext,unknown 0 1 :",
             "b unknown,line-delta 1 2 :",
             "c bad 3 4 :"
@@ -746,7 +890,7 @@
 
     def test_get_options(self):
         transport = MockTransport([
-            _KndxIndex.HEADER,
+            _KnitIndex.HEADER,
             "a opt1 0 1 :",
             "b opt2,opt3 1 2 :"
             ])
@@ -755,31 +899,60 @@
         self.assertEqual(["opt1"], index.get_options("a"))
         self.assertEqual(["opt2", "opt3"], index.get_options("b"))
 
-    def test_get_parent_map(self):
-        transport = MockTransport([
-            _KndxIndex.HEADER,
-            "a option 0 1 :",
-            "b option 1 2 0 .c :",
-            "c option 1 2 1 0 .e :"
-            ])
-        index = self.get_knit_index(transport, "filename", "r")
-
-        self.assertEqual({
-            ("a",):(),
-            ("b",):(("a",), ("c",)),
-            ("c",):(("b",), ("a",), ("e",)),
-            }, index.get_parent_map(index.keys()))
+    def test_get_parents(self):
+        transport = MockTransport([
+            _KnitIndex.HEADER,
+            "a option 0 1 :",
+            "b option 1 2 0 .c :",
+            "c option 1 2 1 0 .e :"
+            ])
+        index = self.get_knit_index(transport, "filename", "r")
+
+        self.assertEqual([], index.get_parents("a"))
+        self.assertEqual(["a", "c"], index.get_parents("b"))
+        self.assertEqual(["b", "a"], index.get_parents("c"))
+
+    def test_get_parents_with_ghosts(self):
+        transport = MockTransport([
+            _KnitIndex.HEADER,
+            "a option 0 1 :",
+            "b option 1 2 0 .c :",
+            "c option 1 2 1 0 .e :"
+            ])
+        index = self.get_knit_index(transport, "filename", "r")
+
+        self.assertEqual([], index.get_parents_with_ghosts("a"))
+        self.assertEqual(["a", "c"], index.get_parents_with_ghosts("b"))
+        self.assertEqual(["b", "a", "e"],
+            index.get_parents_with_ghosts("c"))
+
+    def test_check_versions_present(self):
+        transport = MockTransport([
+            _KnitIndex.HEADER,
+            "a option 0 1 :",
+            "b option 0 1 :"
+            ])
+        index = self.get_knit_index(transport, "filename", "r")
+
+        check = index.check_versions_present
+
+        check([])
+        check(["a"])
+        check(["b"])
+        check(["a", "b"])
+        self.assertRaises(RevisionNotPresent, check, ["c"])
+        self.assertRaises(RevisionNotPresent, check, ["a", "b", "c"])
 
     def test_impossible_parent(self):
         """Test we get KnitCorrupt if the parent couldn't possibly exist."""
         transport = MockTransport([
-            _KndxIndex.HEADER,
+            _KnitIndex.HEADER,
             "a option 0 1 :",
             "b option 0 1 4 :"  # We don't have a 4th record
             ])
-        index = self.get_knit_index(transport, 'filename', 'r')
         try:
-            self.assertRaises(errors.KnitCorrupt, index.keys)
+            self.assertRaises(errors.KnitCorrupt,
+                              self.get_knit_index, transport, 'filename', 'r')
         except TypeError, e:
             if (str(e) == ('exceptions must be strings, classes, or instances,'
                            ' not exceptions.IndexError')
@@ -792,14 +965,14 @@
 
     def test_corrupted_parent(self):
         transport = MockTransport([
-            _KndxIndex.HEADER,
+            _KnitIndex.HEADER,
             "a option 0 1 :",
             "b option 0 1 :",
             "c option 0 1 1v :", # Can't have a parent of '1v'
             ])
-        index = self.get_knit_index(transport, 'filename', 'r')
         try:
-            self.assertRaises(errors.KnitCorrupt, index.keys)
+            self.assertRaises(errors.KnitCorrupt,
+                              self.get_knit_index, transport, 'filename', 'r')
         except TypeError, e:
             if (str(e) == ('exceptions must be strings, classes, or instances,'
                            ' not exceptions.ValueError')
@@ -812,14 +985,14 @@
 
     def test_corrupted_parent_in_list(self):
         transport = MockTransport([
-            _KndxIndex.HEADER,
+            _KnitIndex.HEADER,
             "a option 0 1 :",
             "b option 0 1 :",
             "c option 0 1 1 v :", # Can't have a parent of 'v'
             ])
-        index = self.get_knit_index(transport, 'filename', 'r')
         try:
-            self.assertRaises(errors.KnitCorrupt, index.keys)
+            self.assertRaises(errors.KnitCorrupt,
+                              self.get_knit_index, transport, 'filename', 'r')
         except TypeError, e:
             if (str(e) == ('exceptions must be strings, classes, or instances,'
                            ' not exceptions.ValueError')
@@ -832,12 +1005,12 @@
 
     def test_invalid_position(self):
         transport = MockTransport([
-            _KndxIndex.HEADER,
+            _KnitIndex.HEADER,
             "a option 1v 1 :",
             ])
-        index = self.get_knit_index(transport, 'filename', 'r')
         try:
-            self.assertRaises(errors.KnitCorrupt, index.keys)
+            self.assertRaises(errors.KnitCorrupt,
+                              self.get_knit_index, transport, 'filename', 'r')
         except TypeError, e:
             if (str(e) == ('exceptions must be strings, classes, or instances,'
                            ' not exceptions.ValueError')
@@ -850,12 +1023,12 @@
 
     def test_invalid_size(self):
         transport = MockTransport([
-            _KndxIndex.HEADER,
+            _KnitIndex.HEADER,
             "a option 1 1v :",
             ])
-        index = self.get_knit_index(transport, 'filename', 'r')
         try:
-            self.assertRaises(errors.KnitCorrupt, index.keys)
+            self.assertRaises(errors.KnitCorrupt,
+                              self.get_knit_index, transport, 'filename', 'r')
         except TypeError, e:
             if (str(e) == ('exceptions must be strings, classes, or instances,'
                            ' not exceptions.ValueError')
@@ -868,58 +1041,969 @@
 
     def test_short_line(self):
         transport = MockTransport([
-            _KndxIndex.HEADER,
+            _KnitIndex.HEADER,
             "a option 0 10  :",
             "b option 10 10 0", # This line isn't terminated, ignored
             ])
         index = self.get_knit_index(transport, "filename", "r")
-        self.assertEqual(set([('a',)]), index.keys())
+        self.assertEqual(['a'], index.get_versions())
 
     def test_skip_incomplete_record(self):
         # A line with bogus data should just be skipped
         transport = MockTransport([
-            _KndxIndex.HEADER,
+            _KnitIndex.HEADER,
             "a option 0 10  :",
             "b option 10 10 0", # This line isn't terminated, ignored
             "c option 20 10 0 :", # Properly terminated, and starts with '\n'
             ])
         index = self.get_knit_index(transport, "filename", "r")
-        self.assertEqual(set([('a',), ('c',)]), index.keys())
+        self.assertEqual(['a', 'c'], index.get_versions())
 
     def test_trailing_characters(self):
         # A line with bogus data should just be skipped
         transport = MockTransport([
-            _KndxIndex.HEADER,
+            _KnitIndex.HEADER,
             "a option 0 10  :",
             "b option 10 10 0 :a", # This line has extra trailing characters
             "c option 20 10 0 :", # Properly terminated, and starts with '\n'
             ])
         index = self.get_knit_index(transport, "filename", "r")
-        self.assertEqual(set([('a',), ('c',)]), index.keys())
+        self.assertEqual(['a', 'c'], index.get_versions())
 
 
 class LowLevelKnitIndexTests_c(LowLevelKnitIndexTests):
 
     _test_needs_features = [CompiledKnitFeature]
 
-    def get_knit_index(self, transport, name, mode):
-        mapper = ConstantMapper(name)
+    def get_knit_index(self, *args, **kwargs):
         orig = knit._load_data
         def reset():
             knit._load_data = orig
         self.addCleanup(reset)
         from bzrlib._knit_load_data_c import _load_data_c
         knit._load_data = _load_data_c
-        allow_writes = lambda: mode == 'w'
-        return _KndxIndex(transport, mapper, lambda:None, allow_writes, lambda:True)
+        return _KnitIndex(*args, **kwargs)
+
 
 
 class KnitTests(TestCaseWithTransport):
     """Class containing knit test helper routines."""
 
-    def make_test_knit(self, annotate=False, name='test'):
-        mapper = ConstantMapper(name)
-        return make_file_factory(annotate, mapper)(self.get_transport())
+    def make_test_knit(self, annotate=False, delay_create=False, index=None,
+                       name='test'):
+        if not annotate:
+            factory = KnitPlainFactory()
+        else:
+            factory = None
+        return KnitVersionedFile(name, get_transport('.'), access_mode='w',
+                                 factory=factory, create=True,
+                                 delay_create=delay_create, index=index)
+
+    def assertRecordContentEqual(self, knit, version_id, candidate_content):
+        """Assert that some raw record content matches the raw record content
+        for a particular version_id in the given knit.
+        """
+        index_memo = knit._index.get_position(version_id)
+        record = (version_id, index_memo)
+        [(_, expected_content)] = list(knit._data.read_records_iter_raw([record]))
+        self.assertEqual(expected_content, candidate_content)
+
+
+class BasicKnitTests(KnitTests):
+
+    def add_stock_one_and_one_a(self, k):
+        k.add_lines('text-1', [], split_lines(TEXT_1))
+        k.add_lines('text-1a', ['text-1'], split_lines(TEXT_1A))
+
+    def test_knit_constructor(self):
+        """Construct empty k"""
+        self.make_test_knit()
+
+    def test_make_explicit_index(self):
+        """We can supply an index to use."""
+        knit = KnitVersionedFile('test', get_transport('.'),
+            index='strangelove')
+        self.assertEqual(knit._index, 'strangelove')
+
+    def test_knit_add(self):
+        """Store one text in knit and retrieve"""
+        k = self.make_test_knit()
+        k.add_lines('text-1', [], split_lines(TEXT_1))
+        self.assertTrue(k.has_version('text-1'))
+        self.assertEqualDiff(''.join(k.get_lines('text-1')), TEXT_1)
+
+    def test_knit_reload(self):
+        # test that the content in a reloaded knit is correct
+        k = self.make_test_knit()
+        k.add_lines('text-1', [], split_lines(TEXT_1))
+        del k
+        k2 = KnitVersionedFile('test', get_transport('.'), access_mode='r', factory=KnitPlainFactory(), create=True)
+        self.assertTrue(k2.has_version('text-1'))
+        self.assertEqualDiff(''.join(k2.get_lines('text-1')), TEXT_1)
+
+    def test_knit_several(self):
+        """Store several texts in a knit"""
+        k = self.make_test_knit()
+        k.add_lines('text-1', [], split_lines(TEXT_1))
+        k.add_lines('text-2', [], split_lines(TEXT_2))
+        self.assertEqualDiff(''.join(k.get_lines('text-1')), TEXT_1)
+        self.assertEqualDiff(''.join(k.get_lines('text-2')), TEXT_2)
+        
+    def test_repeated_add(self):
+        """Knit traps attempt to replace existing version"""
+        k = self.make_test_knit()
+        k.add_lines('text-1', [], split_lines(TEXT_1))
+        self.assertRaises(RevisionAlreadyPresent, 
+                k.add_lines,
+                'text-1', [], split_lines(TEXT_1))
+
+    def test_empty(self):
+        k = self.make_test_knit(True)
+        k.add_lines('text-1', [], [])
+        self.assertEquals(k.get_lines('text-1'), [])
+
+    def test_incomplete(self):
+        """Test if texts without a ending line-end can be inserted and
+        extracted."""
+        k = KnitVersionedFile('test', get_transport('.'), delta=False, create=True)
+        k.add_lines('text-1', [], ['a\n',    'b'  ])
+        k.add_lines('text-2', ['text-1'], ['a\rb\n', 'b\n'])
+        # reopening ensures maximum room for confusion
+        k = KnitVersionedFile('test', get_transport('.'), delta=False, create=True)
+        self.assertEquals(k.get_lines('text-1'), ['a\n',    'b'  ])
+        self.assertEquals(k.get_lines('text-2'), ['a\rb\n', 'b\n'])
+
+    def test_delta(self):
+        """Expression of knit delta as lines"""
+        k = self.make_test_knit()
+        td = list(line_delta(TEXT_1.splitlines(True),
+                             TEXT_1A.splitlines(True)))
+        self.assertEqualDiff(''.join(td), delta_1_1a)
+        out = apply_line_delta(TEXT_1.splitlines(True), td)
+        self.assertEqualDiff(''.join(out), TEXT_1A)
+
+    def test_add_with_parents(self):
+        """Store in knit with parents"""
+        k = self.make_test_knit()
+        self.add_stock_one_and_one_a(k)
+        self.assertEquals(k.get_parents('text-1'), [])
+        self.assertEquals(k.get_parents('text-1a'), ['text-1'])
+
+    def test_ancestry(self):
+        """Store in knit with parents"""
+        k = self.make_test_knit()
+        self.add_stock_one_and_one_a(k)
+        self.assertEquals(set(k.get_ancestry(['text-1a'])), set(['text-1a', 'text-1']))
+
+    def test_add_delta(self):
+        """Store in knit with parents"""
+        k = KnitVersionedFile('test', get_transport('.'), factory=KnitPlainFactory(),
+            delta=True, create=True)
+        self.add_stock_one_and_one_a(k)
+        k.clear_cache()
+        self.assertEqualDiff(''.join(k.get_lines('text-1a')), TEXT_1A)
+
+    def test_add_delta_knit_graph_index(self):
+        """Does adding work with a KnitGraphIndex."""
+        index = InMemoryGraphIndex(2)
+        knit_index = KnitGraphIndex(index, add_callback=index.add_nodes,
+            deltas=True)
+        k = KnitVersionedFile('test', get_transport('.'),
+            delta=True, create=True, index=knit_index)
+        self.add_stock_one_and_one_a(k)
+        k.clear_cache()
+        self.assertEqualDiff(''.join(k.get_lines('text-1a')), TEXT_1A)
+        # check the index had the right data added.
+        self.assertEqual(set([
+            (index, ('text-1', ), ' 0 127', ((), ())),
+            (index, ('text-1a', ), ' 127 140', ((('text-1', ),), (('text-1', ),))),
+            ]), set(index.iter_all_entries()))
+        # we should not have a .kndx file
+        self.assertFalse(get_transport('.').has('test.kndx'))
+
+    def test_annotate(self):
+        """Annotations"""
+        k = KnitVersionedFile('knit', get_transport('.'), factory=KnitAnnotateFactory(),
+            delta=True, create=True)
+        self.insert_and_test_small_annotate(k)
+
+    def insert_and_test_small_annotate(self, k):
+        """test annotation with k works correctly."""
+        k.add_lines('text-1', [], ['a\n', 'b\n'])
+        k.add_lines('text-2', ['text-1'], ['a\n', 'c\n'])
+
+        origins = k.annotate('text-2')
+        self.assertEquals(origins[0], ('text-1', 'a\n'))
+        self.assertEquals(origins[1], ('text-2', 'c\n'))
+
+    def test_annotate_fulltext(self):
+        """Annotations"""
+        k = KnitVersionedFile('knit', get_transport('.'), factory=KnitAnnotateFactory(),
+            delta=False, create=True)
+        self.insert_and_test_small_annotate(k)
+
+    def test_annotate_merge_1(self):
+        k = self.make_test_knit(True)
+        k.add_lines('text-a1', [], ['a\n', 'b\n'])
+        k.add_lines('text-a2', [], ['d\n', 'c\n'])
+        k.add_lines('text-am', ['text-a1', 'text-a2'], ['d\n', 'b\n'])
+        origins = k.annotate('text-am')
+        self.assertEquals(origins[0], ('text-a2', 'd\n'))
+        self.assertEquals(origins[1], ('text-a1', 'b\n'))
+
+    def test_annotate_merge_2(self):
+        k = self.make_test_knit(True)
+        k.add_lines('text-a1', [], ['a\n', 'b\n', 'c\n'])
+        k.add_lines('text-a2', [], ['x\n', 'y\n', 'z\n'])
+        k.add_lines('text-am', ['text-a1', 'text-a2'], ['a\n', 'y\n', 'c\n'])
+        origins = k.annotate('text-am')
+        self.assertEquals(origins[0], ('text-a1', 'a\n'))
+        self.assertEquals(origins[1], ('text-a2', 'y\n'))
+        self.assertEquals(origins[2], ('text-a1', 'c\n'))
+
+    def test_annotate_merge_9(self):
+        k = self.make_test_knit(True)
+        k.add_lines('text-a1', [], ['a\n', 'b\n', 'c\n'])
+        k.add_lines('text-a2', [], ['x\n', 'y\n', 'z\n'])
+        k.add_lines('text-am', ['text-a1', 'text-a2'], ['k\n', 'y\n', 'c\n'])
+        origins = k.annotate('text-am')
+        self.assertEquals(origins[0], ('text-am', 'k\n'))
+        self.assertEquals(origins[1], ('text-a2', 'y\n'))
+        self.assertEquals(origins[2], ('text-a1', 'c\n'))
+
+    def test_annotate_merge_3(self):
+        k = self.make_test_knit(True)
+        k.add_lines('text-a1', [], ['a\n', 'b\n', 'c\n'])
+        k.add_lines('text-a2', [] ,['x\n', 'y\n', 'z\n'])
+        k.add_lines('text-am', ['text-a1', 'text-a2'], ['k\n', 'y\n', 'z\n'])
+        origins = k.annotate('text-am')
+        self.assertEquals(origins[0], ('text-am', 'k\n'))
+        self.assertEquals(origins[1], ('text-a2', 'y\n'))
+        self.assertEquals(origins[2], ('text-a2', 'z\n'))
+
+    def test_annotate_merge_4(self):
+        k = self.make_test_knit(True)
+        k.add_lines('text-a1', [], ['a\n', 'b\n', 'c\n'])
+        k.add_lines('text-a2', [], ['x\n', 'y\n', 'z\n'])
+        k.add_lines('text-a3', ['text-a1'], ['a\n', 'b\n', 'p\n'])
+        k.add_lines('text-am', ['text-a2', 'text-a3'], ['a\n', 'b\n', 'z\n'])
+        origins = k.annotate('text-am')
+        self.assertEquals(origins[0], ('text-a1', 'a\n'))
+        self.assertEquals(origins[1], ('text-a1', 'b\n'))
+        self.assertEquals(origins[2], ('text-a2', 'z\n'))
+
+    def test_annotate_merge_5(self):
+        k = self.make_test_knit(True)
+        k.add_lines('text-a1', [], ['a\n', 'b\n', 'c\n'])
+        k.add_lines('text-a2', [], ['d\n', 'e\n', 'f\n'])
+        k.add_lines('text-a3', [], ['x\n', 'y\n', 'z\n'])
+        k.add_lines('text-am',
+                    ['text-a1', 'text-a2', 'text-a3'],
+                    ['a\n', 'e\n', 'z\n'])
+        origins = k.annotate('text-am')
+        self.assertEquals(origins[0], ('text-a1', 'a\n'))
+        self.assertEquals(origins[1], ('text-a2', 'e\n'))
+        self.assertEquals(origins[2], ('text-a3', 'z\n'))
+
+    def test_annotate_file_cherry_pick(self):
+        k = self.make_test_knit(True)
+        k.add_lines('text-1', [], ['a\n', 'b\n', 'c\n'])
+        k.add_lines('text-2', ['text-1'], ['d\n', 'e\n', 'f\n'])
+        k.add_lines('text-3', ['text-2', 'text-1'], ['a\n', 'b\n', 'c\n'])
+        origins = k.annotate('text-3')
+        self.assertEquals(origins[0], ('text-1', 'a\n'))
+        self.assertEquals(origins[1], ('text-1', 'b\n'))
+        self.assertEquals(origins[2], ('text-1', 'c\n'))
+
+    def _test_join_with_factories(self, k1_factory, k2_factory):
+        k1 = KnitVersionedFile('test1', get_transport('.'), factory=k1_factory, create=True)
+        k1.add_lines('text-a', [], ['a1\n', 'a2\n', 'a3\n'])
+        k1.add_lines('text-b', ['text-a'], ['a1\n', 'b2\n', 'a3\n'])
+        k1.add_lines('text-c', [], ['c1\n', 'c2\n', 'c3\n'])
+        k1.add_lines('text-d', ['text-c'], ['c1\n', 'd2\n', 'd3\n'])
+        k1.add_lines('text-m', ['text-b', 'text-d'], ['a1\n', 'b2\n', 'd3\n'])
+        k2 = KnitVersionedFile('test2', get_transport('.'), factory=k2_factory, create=True)
+        count = k2.join(k1, version_ids=['text-m'])
+        self.assertEquals(count, 5)
+        self.assertTrue(k2.has_version('text-a'))
+        self.assertTrue(k2.has_version('text-c'))
+        origins = k2.annotate('text-m')
+        self.assertEquals(origins[0], ('text-a', 'a1\n'))
+        self.assertEquals(origins[1], ('text-b', 'b2\n'))
+        self.assertEquals(origins[2], ('text-d', 'd3\n'))
+
+    def test_knit_join_plain_to_plain(self):
+        """Test joining a plain knit with a plain knit."""
+        self._test_join_with_factories(KnitPlainFactory(), KnitPlainFactory())
+
+    def test_knit_join_anno_to_anno(self):
+        """Test joining an annotated knit with an annotated knit."""
+        self._test_join_with_factories(None, None)
+
+    def test_knit_join_anno_to_plain(self):
+        """Test joining an annotated knit with a plain knit."""
+        self._test_join_with_factories(None, KnitPlainFactory())
+
+    def test_knit_join_plain_to_anno(self):
+        """Test joining a plain knit with an annotated knit."""
+        self._test_join_with_factories(KnitPlainFactory(), None)
+
+    def test_reannotate(self):
+        k1 = KnitVersionedFile('knit1', get_transport('.'),
+                               factory=KnitAnnotateFactory(), create=True)
+        # 0
+        k1.add_lines('text-a', [], ['a\n', 'b\n'])
+        # 1
+        k1.add_lines('text-b', ['text-a'], ['a\n', 'c\n'])
+
+        k2 = KnitVersionedFile('test2', get_transport('.'),
+                               factory=KnitAnnotateFactory(), create=True)
+        k2.join(k1, version_ids=['text-b'])
+
+        # 2
+        k1.add_lines('text-X', ['text-b'], ['a\n', 'b\n'])
+        # 2
+        k2.add_lines('text-c', ['text-b'], ['z\n', 'c\n'])
+        # 3
+        k2.add_lines('text-Y', ['text-b'], ['b\n', 'c\n'])
+
+        # test-c will have index 3
+        k1.join(k2, version_ids=['text-c'])
+
+        lines = k1.get_lines('text-c')
+        self.assertEquals(lines, ['z\n', 'c\n'])
+
+        origins = k1.annotate('text-c')
+        self.assertEquals(origins[0], ('text-c', 'z\n'))
+        self.assertEquals(origins[1], ('text-b', 'c\n'))
+
+    def test_get_line_delta_texts(self):
+        """Make sure we can call get_texts on text with reused line deltas"""
+        k1 = KnitVersionedFile('test1', get_transport('.'), 
+                               factory=KnitPlainFactory(), create=True)
+        for t in range(3):
+            if t == 0:
+                parents = []
+            else:
+                parents = ['%d' % (t-1)]
+            k1.add_lines('%d' % t, parents, ['hello\n'] * t)
+        k1.get_texts(('%d' % t) for t in range(3))
+        
+    def test_iter_lines_reads_in_order(self):
+        instrumented_t = get_transport('trace+memory:///')
+        k1 = KnitVersionedFile('id', instrumented_t, create=True, delta=True)
+        self.assertEqual([('get', 'id.kndx',)], instrumented_t._activity)
+        # add texts with no required ordering
+        k1.add_lines('base', [], ['text\n'])
+        k1.add_lines('base2', [], ['text2\n'])
+        k1.clear_cache()
+        # clear the logged activity, but preserve the list instance in case of
+        # clones pointing at it.
+        del instrumented_t._activity[:]
+        # request a last-first iteration
+        results = list(k1.iter_lines_added_or_present_in_versions(
+            ['base2', 'base']))
+        self.assertEqual(
+            [('readv', 'id.knit', [(0, 87), (87, 89)], False, None)],
+            instrumented_t._activity)
+        self.assertEqual(['text\n', 'text2\n'], results)
+
+    def test_create_empty_annotated(self):
+        k1 = self.make_test_knit(True)
+        # 0
+        k1.add_lines('text-a', [], ['a\n', 'b\n'])
+        k2 = k1.create_empty('t', MemoryTransport())
+        self.assertTrue(isinstance(k2.factory, KnitAnnotateFactory))
+        self.assertEqual(k1.delta, k2.delta)
+        # the generic test checks for empty content and file class
+
+    def test_knit_format(self):
+        # this tests that a new knit index file has the expected content
+        # and that is writes the data we expect as records are added.
+        knit = self.make_test_knit(True)
+        # Now knit files are not created until we first add data to them
+        self.assertFileEqual("# bzr knit index 8\n", 'test.kndx')
+        knit.add_lines_with_ghosts('revid', ['a_ghost'], ['a\n'])
+        self.assertFileEqual(
+            "# bzr knit index 8\n"
+            "\n"
+            "revid fulltext 0 84 .a_ghost :",
+            'test.kndx')
+        knit.add_lines_with_ghosts('revid2', ['revid'], ['a\n'])
+        self.assertFileEqual(
+            "# bzr knit index 8\n"
+            "\nrevid fulltext 0 84 .a_ghost :"
+            "\nrevid2 line-delta 84 82 0 :",
+            'test.kndx')
+        # we should be able to load this file again
+        knit = KnitVersionedFile('test', get_transport('.'), access_mode='r')
+        self.assertEqual(['revid', 'revid2'], knit.versions())
+        # write a short write to the file and ensure that its ignored
+        indexfile = file('test.kndx', 'ab')
+        indexfile.write('\nrevid3 line-delta 166 82 1 2 3 4 5 .phwoar:demo ')
+        indexfile.close()
+        # we should be able to load this file again
+        knit = KnitVersionedFile('test', get_transport('.'), access_mode='w')
+        self.assertEqual(['revid', 'revid2'], knit.versions())
+        # and add a revision with the same id the failed write had
+        knit.add_lines('revid3', ['revid2'], ['a\n'])
+        # and when reading it revid3 should now appear.
+        knit = KnitVersionedFile('test', get_transport('.'), access_mode='r')
+        self.assertEqual(['revid', 'revid2', 'revid3'], knit.versions())
+        self.assertEqual(['revid2'], knit.get_parents('revid3'))
+
+    def test_delay_create(self):
+        """Test that passing delay_create=True creates files late"""
+        knit = self.make_test_knit(annotate=True, delay_create=True)
+        self.failIfExists('test.knit')
+        self.failIfExists('test.kndx')
+        knit.add_lines_with_ghosts('revid', ['a_ghost'], ['a\n'])
+        self.failUnlessExists('test.knit')
+        self.assertFileEqual(
+            "# bzr knit index 8\n"
+            "\n"
+            "revid fulltext 0 84 .a_ghost :",
+            'test.kndx')
+
+    def test_create_parent_dir(self):
+        """create_parent_dir can create knits in nonexistant dirs"""
+        # Has no effect if we don't set 'delay_create'
+        trans = get_transport('.')
+        self.assertRaises(NoSuchFile, KnitVersionedFile, 'dir/test',
+                          trans, access_mode='w', factory=None,
+                          create=True, create_parent_dir=True)
+        # Nothing should have changed yet
+        knit = KnitVersionedFile('dir/test', trans, access_mode='w',
+                                 factory=None, create=True,
+                                 create_parent_dir=True,
+                                 delay_create=True)
+        self.failIfExists('dir/test.knit')
+        self.failIfExists('dir/test.kndx')
+        self.failIfExists('dir')
+        knit.add_lines('revid', [], ['a\n'])
+        self.failUnlessExists('dir')
+        self.failUnlessExists('dir/test.knit')
+        self.assertFileEqual(
+            "# bzr knit index 8\n"
+            "\n"
+            "revid fulltext 0 84  :",
+            'dir/test.kndx')
+
+    def test_create_mode_700(self):
+        trans = get_transport('.')
+        if not trans._can_roundtrip_unix_modebits():
+            # Can't roundtrip, so no need to run this test
+            return
+        knit = KnitVersionedFile('dir/test', trans, access_mode='w',
+                                 factory=None, create=True,
+                                 create_parent_dir=True,
+                                 delay_create=True,
+                                 file_mode=0600,
+                                 dir_mode=0700)
+        knit.add_lines('revid', [], ['a\n'])
+        self.assertTransportMode(trans, 'dir', 0700)
+        self.assertTransportMode(trans, 'dir/test.knit', 0600)
+        self.assertTransportMode(trans, 'dir/test.kndx', 0600)
+
+    def test_create_mode_770(self):
+        trans = get_transport('.')
+        if not trans._can_roundtrip_unix_modebits():
+            # Can't roundtrip, so no need to run this test
+            return
+        knit = KnitVersionedFile('dir/test', trans, access_mode='w',
+                                 factory=None, create=True,
+                                 create_parent_dir=True,
+                                 delay_create=True,
+                                 file_mode=0660,
+                                 dir_mode=0770)
+        knit.add_lines('revid', [], ['a\n'])
+        self.assertTransportMode(trans, 'dir', 0770)
+        self.assertTransportMode(trans, 'dir/test.knit', 0660)
+        self.assertTransportMode(trans, 'dir/test.kndx', 0660)
+
+    def test_create_mode_777(self):
+        trans = get_transport('.')
+        if not trans._can_roundtrip_unix_modebits():
+            # Can't roundtrip, so no need to run this test
+            return
+        knit = KnitVersionedFile('dir/test', trans, access_mode='w',
+                                 factory=None, create=True,
+                                 create_parent_dir=True,
+                                 delay_create=True,
+                                 file_mode=0666,
+                                 dir_mode=0777)
+        knit.add_lines('revid', [], ['a\n'])
+        self.assertTransportMode(trans, 'dir', 0777)
+        self.assertTransportMode(trans, 'dir/test.knit', 0666)
+        self.assertTransportMode(trans, 'dir/test.kndx', 0666)
+
+    def test_plan_merge(self):
+        my_knit = self.make_test_knit(annotate=True)
+        my_knit.add_lines('text1', [], split_lines(TEXT_1))
+        my_knit.add_lines('text1a', ['text1'], split_lines(TEXT_1A))
+        my_knit.add_lines('text1b', ['text1'], split_lines(TEXT_1B))
+        plan = list(my_knit.plan_merge('text1a', 'text1b'))
+        for plan_line, expected_line in zip(plan, AB_MERGE):
+            self.assertEqual(plan_line, expected_line)
+
+    def test_get_stream_empty(self):
+        """Get a data stream for an empty knit file."""
+        k1 = self.make_test_knit()
+        format, data_list, reader_callable = k1.get_data_stream([])
+        self.assertEqual('knit-plain', format)
+        self.assertEqual([], data_list)
+        content = reader_callable(None)
+        self.assertEqual('', content)
+        self.assertIsInstance(content, str)
+
+    def test_get_stream_one_version(self):
+        """Get a data stream for a single record out of a knit containing just
+        one record.
+        """
+        k1 = self.make_test_knit()
+        test_data = [
+            ('text-a', [], TEXT_1),
+            ]
+        expected_data_list = [
+            # version, options, length, parents
+            ('text-a', ['fulltext'], 122, []),
+           ]
+        for version_id, parents, lines in test_data:
+            k1.add_lines(version_id, parents, split_lines(lines))
+
+        format, data_list, reader_callable = k1.get_data_stream(['text-a'])
+        self.assertEqual('knit-plain', format)
+        self.assertEqual(expected_data_list, data_list)
+        # There's only one record in the knit, so the content should be the
+        # entire knit data file's contents.
+        self.assertEqual(k1.transport.get_bytes(k1._data._access._filename),
+                         reader_callable(None))
+        
+    def test_get_stream_get_one_version_of_many(self):
+        """Get a data stream for just one version out of a knit containing many
+        versions.
+        """
+        k1 = self.make_test_knit()
+        # Insert the same data as test_knit_join, as they seem to cover a range
+        # of cases (no parents, one parent, multiple parents).
+        test_data = [
+            ('text-a', [], TEXT_1),
+            ('text-b', ['text-a'], TEXT_1),
+            ('text-c', [], TEXT_1),
+            ('text-d', ['text-c'], TEXT_1),
+            ('text-m', ['text-b', 'text-d'], TEXT_1),
+            ]
+        expected_data_list = [
+            # version, options, length, parents
+            ('text-m', ['line-delta'], 84, ['text-b', 'text-d']),
+            ]
+        for version_id, parents, lines in test_data:
+            k1.add_lines(version_id, parents, split_lines(lines))
+
+        format, data_list, reader_callable = k1.get_data_stream(['text-m'])
+        self.assertEqual('knit-plain', format)
+        self.assertEqual(expected_data_list, data_list)
+        self.assertRecordContentEqual(k1, 'text-m', reader_callable(None))
+        
+    def test_get_stream_ghost_parent(self):
+        """Get a data stream for a version with a ghost parent."""
+        k1 = self.make_test_knit()
+        # Test data
+        k1.add_lines('text-a', [], split_lines(TEXT_1))
+        k1.add_lines_with_ghosts('text-b', ['text-a', 'text-ghost'],
+                                 split_lines(TEXT_1))
+        # Expected data
+        expected_data_list = [
+            # version, options, length, parents
+            ('text-b', ['line-delta'], 84, ['text-a', 'text-ghost']),
+            ]
+        
+        format, data_list, reader_callable = k1.get_data_stream(['text-b'])
+        self.assertEqual('knit-plain', format)
+        self.assertEqual(expected_data_list, data_list)
+        self.assertRecordContentEqual(k1, 'text-b', reader_callable(None))
+    
+    def test_get_stream_get_multiple_records(self):
+        """Get a stream for multiple records of a knit."""
+        k1 = self.make_test_knit()
+        # Insert the same data as test_knit_join, as they seem to cover a range
+        # of cases (no parents, one parent, multiple parents).
+        test_data = [
+            ('text-a', [], TEXT_1),
+            ('text-b', ['text-a'], TEXT_1),
+            ('text-c', [], TEXT_1),
+            ('text-d', ['text-c'], TEXT_1),
+            ('text-m', ['text-b', 'text-d'], TEXT_1),
+            ]
+        expected_data_list = [
+            # version, options, length, parents
+            ('text-b', ['line-delta'], 84, ['text-a']),
+            ('text-d', ['line-delta'], 84, ['text-c']),
+            ]
+        for version_id, parents, lines in test_data:
+            k1.add_lines(version_id, parents, split_lines(lines))
+
+        # Note that even though we request the revision IDs in a particular
+        # order, the data stream may return them in any order it likes.  In this
+        # case, they'll be in the order they were inserted into the knit.
+        format, data_list, reader_callable = k1.get_data_stream(
+            ['text-d', 'text-b'])
+        self.assertEqual('knit-plain', format)
+        self.assertEqual(expected_data_list, data_list)
+        self.assertRecordContentEqual(k1, 'text-b', reader_callable(84))
+        self.assertRecordContentEqual(k1, 'text-d', reader_callable(84))
+        self.assertEqual('', reader_callable(None),
+                         "There should be no more bytes left to read.")
+
+    def test_get_stream_all(self):
+        """Get a data stream for all the records in a knit.
+
+        This exercises fulltext records, line-delta records, records with
+        various numbers of parents, and reading multiple records out of the
+        callable.  These cases ought to all be exercised individually by the
+        other test_get_stream_* tests; this test is basically just paranoia.
+        """
+        k1 = self.make_test_knit()
+        # Insert the same data as test_knit_join, as they seem to cover a range
+        # of cases (no parents, one parent, multiple parents).
+        test_data = [
+            ('text-a', [], TEXT_1),
+            ('text-b', ['text-a'], TEXT_1),
+            ('text-c', [], TEXT_1),
+            ('text-d', ['text-c'], TEXT_1),
+            ('text-m', ['text-b', 'text-d'], TEXT_1),
+           ]
+        expected_data_list = [
+            # version, options, length, parents
+            ('text-a', ['fulltext'], 122, []),
+            ('text-b', ['line-delta'], 84, ['text-a']),
+            ('text-c', ['fulltext'], 121, []),
+            ('text-d', ['line-delta'], 84, ['text-c']),
+            ('text-m', ['line-delta'], 84, ['text-b', 'text-d']),
+            ]
+        for version_id, parents, lines in test_data:
+            k1.add_lines(version_id, parents, split_lines(lines))
+
+        format, data_list, reader_callable = k1.get_data_stream(
+            ['text-a', 'text-b', 'text-c', 'text-d', 'text-m'])
+        self.assertEqual('knit-plain', format)
+        self.assertEqual(expected_data_list, data_list)
+        for version_id, options, length, parents in expected_data_list:
+            bytes = reader_callable(length)
+            self.assertRecordContentEqual(k1, version_id, bytes)
+
+    def assertKnitFilesEqual(self, knit1, knit2):
+        """Assert that the contents of the index and data files of two knits are
+        equal.
+        """
+        self.assertEqual(
+            knit1.transport.get_bytes(knit1._data._access._filename),
+            knit2.transport.get_bytes(knit2._data._access._filename))
+        self.assertEqual(
+            knit1.transport.get_bytes(knit1._index._filename),
+            knit2.transport.get_bytes(knit2._index._filename))
+
+    def test_insert_data_stream_empty(self):
+        """Inserting a data stream with no records should not put any data into
+        the knit.
+        """
+        k1 = self.make_test_knit()
+        k1.insert_data_stream(
+            (k1.get_format_signature(), [], lambda ignored: ''))
+        self.assertEqual('', k1.transport.get_bytes(k1._data._access._filename),
+                         "The .knit should be completely empty.")
+        self.assertEqual(k1._index.HEADER,
+                         k1.transport.get_bytes(k1._index._filename),
+                         "The .kndx should have nothing apart from the header.")
+
+    def test_insert_data_stream_one_record(self):
+        """Inserting a data stream with one record from a knit with one record
+        results in byte-identical files.
+        """
+        source = self.make_test_knit(name='source')
+        source.add_lines('text-a', [], split_lines(TEXT_1))
+        data_stream = source.get_data_stream(['text-a'])
+        
+        target = self.make_test_knit(name='target')
+        target.insert_data_stream(data_stream)
+        
+        self.assertKnitFilesEqual(source, target)
+
+    def test_insert_data_stream_records_already_present(self):
+        """Insert a data stream where some records are alreday present in the
+        target, and some not.  Only the new records are inserted.
+        """
+        source = self.make_test_knit(name='source')
+        target = self.make_test_knit(name='target')
+        # Insert 'text-a' into both source and target
+        source.add_lines('text-a', [], split_lines(TEXT_1))
+        target.insert_data_stream(source.get_data_stream(['text-a']))
+        # Insert 'text-b' into just the source.
+        source.add_lines('text-b', ['text-a'], split_lines(TEXT_1))
+        # Get a data stream of both text-a and text-b, and insert it.
+        data_stream = source.get_data_stream(['text-a', 'text-b'])
+        target.insert_data_stream(data_stream)
+        # The source and target will now be identical.  This means the text-a
+        # record was not added a second time.
+        self.assertKnitFilesEqual(source, target)
+
+    def test_insert_data_stream_multiple_records(self):
+        """Inserting a data stream of all records from a knit with multiple
+        records results in byte-identical files.
+        """
+        source = self.make_test_knit(name='source')
+        source.add_lines('text-a', [], split_lines(TEXT_1))
+        source.add_lines('text-b', ['text-a'], split_lines(TEXT_1))
+        source.add_lines('text-c', [], split_lines(TEXT_1))
+        data_stream = source.get_data_stream(['text-a', 'text-b', 'text-c'])
+        
+        target = self.make_test_knit(name='target')
+        target.insert_data_stream(data_stream)
+        
+        self.assertKnitFilesEqual(source, target)
+
+    def test_insert_data_stream_ghost_parent(self):
+        """Insert a data stream with a record that has a ghost parent."""
+        # Make a knit with a record, text-a, that has a ghost parent.
+        source = self.make_test_knit(name='source')
+        source.add_lines_with_ghosts('text-a', ['text-ghost'],
+                                     split_lines(TEXT_1))
+        data_stream = source.get_data_stream(['text-a'])
+
+        target = self.make_test_knit(name='target')
+        target.insert_data_stream(data_stream)
+
+        self.assertKnitFilesEqual(source, target)
+
+        # The target knit object is in a consistent state, i.e. the record we
+        # just added is immediately visible.
+        self.assertTrue(target.has_version('text-a'))
+        self.assertTrue(target.has_ghost('text-ghost'))
+        self.assertEqual(split_lines(TEXT_1), target.get_lines('text-a'))
+
+    def test_insert_data_stream_inconsistent_version_lines(self):
+        """Inserting a data stream which has different content for a version_id
+        than already exists in the knit will raise KnitCorrupt.
+        """
+        source = self.make_test_knit(name='source')
+        target = self.make_test_knit(name='target')
+        # Insert a different 'text-a' into both source and target
+        source.add_lines('text-a', [], split_lines(TEXT_1))
+        target.add_lines('text-a', [], split_lines(TEXT_2))
+        # Insert a data stream with conflicting content into the target
+        data_stream = source.get_data_stream(['text-a'])
+        self.assertRaises(
+            errors.KnitCorrupt, target.insert_data_stream, data_stream)
+
+    def test_insert_data_stream_inconsistent_version_parents(self):
+        """Inserting a data stream which has different parents for a version_id
+        than already exists in the knit will raise KnitCorrupt.
+        """
+        source = self.make_test_knit(name='source')
+        target = self.make_test_knit(name='target')
+        # Insert a different 'text-a' into both source and target.  They differ
+        # only by the parents list, the content is the same.
+        source.add_lines_with_ghosts('text-a', [], split_lines(TEXT_1))
+        target.add_lines_with_ghosts('text-a', ['a-ghost'], split_lines(TEXT_1))
+        # Insert a data stream with conflicting content into the target
+        data_stream = source.get_data_stream(['text-a'])
+        self.assertRaises(
+            errors.KnitCorrupt, target.insert_data_stream, data_stream)
+
+    def test_insert_data_stream_incompatible_format(self):
+        """A data stream in a different format to the target knit cannot be
+        inserted.
+
+        It will raise KnitDataStreamIncompatible.
+        """
+        data_stream = ('fake-format-signature', [], lambda _: '')
+        target = self.make_test_knit(name='target')
+        self.assertRaises(
+            errors.KnitDataStreamIncompatible,
+            target.insert_data_stream, data_stream)
+
+    #  * test that a stream of "already present version, then new version"
+    #    inserts correctly.
+
+TEXT_1 = """\
+Banana cup cakes:
+
+- bananas
+- eggs
+- broken tea cups
+"""
+
+TEXT_1A = """\
+Banana cup cake recipe
+(serves 6)
+
+- bananas
+- eggs
+- broken tea cups
+- self-raising flour
+"""
+
+TEXT_1B = """\
+Banana cup cake recipe
+
+- bananas (do not use plantains!!!)
+- broken tea cups
+- flour
+"""
+
+delta_1_1a = """\
+0,1,2
+Banana cup cake recipe
+(serves 6)
+5,5,1
+- self-raising flour
+"""
+
+TEXT_2 = """\
+Boeuf bourguignon
+
+- beef
+- red wine
+- small onions
+- carrot
+- mushrooms
+"""
+
+AB_MERGE_TEXT="""unchanged|Banana cup cake recipe
+new-a|(serves 6)
+unchanged|
+killed-b|- bananas
+killed-b|- eggs
+new-b|- bananas (do not use plantains!!!)
+unchanged|- broken tea cups
+new-a|- self-raising flour
+new-b|- flour
+"""
+AB_MERGE=[tuple(l.split('|')) for l in AB_MERGE_TEXT.splitlines(True)]
+
+
+def line_delta(from_lines, to_lines):
+    """Generate line-based delta from one text to another"""
+    s = difflib.SequenceMatcher(None, from_lines, to_lines)
+    for op in s.get_opcodes():
+        if op[0] == 'equal':
+            continue
+        yield '%d,%d,%d\n' % (op[1], op[2], op[4]-op[3])
+        for i in range(op[3], op[4]):
+            yield to_lines[i]
+
+
+def apply_line_delta(basis_lines, delta_lines):
+    """Apply a line-based perfect diff
+    
+    basis_lines -- text to apply the patch to
+    delta_lines -- diff instructions and content
+    """
+    out = basis_lines[:]
+    i = 0
+    offset = 0
+    while i < len(delta_lines):
+        l = delta_lines[i]
+        a, b, c = map(long, l.split(','))
+        i = i + 1
+        out[offset+a:offset+b] = delta_lines[i:i+c]
+        i = i + c
+        offset = offset + (b - a) + c
+    return out
+
+
+class TestWeaveToKnit(KnitTests):
+
+    def test_weave_to_knit_matches(self):
+        # check that the WeaveToKnit is_compatible function
+        # registers True for a Weave to a Knit.
+        w = Weave()
+        k = self.make_test_knit()
+        self.failUnless(WeaveToKnit.is_compatible(w, k))
+        self.failIf(WeaveToKnit.is_compatible(k, w))
+        self.failIf(WeaveToKnit.is_compatible(w, w))
+        self.failIf(WeaveToKnit.is_compatible(k, k))
+
+
+class TestKnitCaching(KnitTests):
+    
+    def create_knit(self):
+        k = self.make_test_knit(True)
+        k.add_lines('text-1', [], split_lines(TEXT_1))
+        k.add_lines('text-2', [], split_lines(TEXT_2))
+        return k
+
+    def test_no_caching(self):
+        k = self.create_knit()
+        # Nothing should be cached without setting 'enable_cache'
+        self.assertEqual({}, k._data._cache)
+
+    def test_cache_data_read_raw(self):
+        k = self.create_knit()
+
+        # Now cache and read
+        k.enable_cache()
+
+        def read_one_raw(version):
+            pos_map = k._get_components_positions([version])
+            method, index_memo, next = pos_map[version]
+            lst = list(k._data.read_records_iter_raw([(version, index_memo)]))
+            self.assertEqual(1, len(lst))
+            return lst[0]
+
+        val = read_one_raw('text-1')
+        self.assertEqual({'text-1':val[1]}, k._data._cache)
+
+        k.clear_cache()
+        # After clear, new reads are not cached
+        self.assertEqual({}, k._data._cache)
+
+        val2 = read_one_raw('text-1')
+        self.assertEqual(val, val2)
+        self.assertEqual({}, k._data._cache)
+
+    def test_cache_data_read(self):
+        k = self.create_knit()
+
+        def read_one(version):
+            pos_map = k._get_components_positions([version])
+            method, index_memo, next = pos_map[version]
+            lst = list(k._data.read_records_iter([(version, index_memo)]))
+            self.assertEqual(1, len(lst))
+            return lst[0]
+
+        # Now cache and read
+        k.enable_cache()
+
+        val = read_one('text-2')
+        self.assertEqual(['text-2'], k._data._cache.keys())
+        self.assertEqual('text-2', val[0])
+        content, digest = k._data._parse_record('text-2',
+                                                k._data._cache['text-2'])
+        self.assertEqual(content, val[1])
+        self.assertEqual(digest, val[2])
+
+        k.clear_cache()
+        self.assertEqual({}, k._data._cache)
+
+        val2 = read_one('text-2')
+        self.assertEqual(val, val2)
+        self.assertEqual({}, k._data._cache)
+
+    def test_cache_read(self):
+        k = self.create_knit()
+        k.enable_cache()
+
+        text = k.get_text('text-1')
+        self.assertEqual(TEXT_1, text)
+        self.assertEqual(['text-1'], k._data._cache.keys())
+
+        k.clear_cache()
+        self.assertEqual({}, k._data._cache)
+
+        text = k.get_text('text-1')
+        self.assertEqual(TEXT_1, text)
+        self.assertEqual({}, k._data._cache)
 
 
 class TestKnitIndex(KnitTests):
@@ -928,16 +2012,15 @@
         """Adding versions to the index should update the lookup dict"""
         knit = self.make_test_knit()
         idx = knit._index
-        idx.add_records([(('a-1',), ['fulltext'], (('a-1',), 0, 0), [])])
+        idx.add_version('a-1', ['fulltext'], (None, 0, 0), [])
         self.check_file_contents('test.kndx',
             '# bzr knit index 8\n'
             '\n'
             'a-1 fulltext 0 0  :'
             )
-        idx.add_records([
-            (('a-2',), ['fulltext'], (('a-2',), 0, 0), [('a-1',)]),
-            (('a-3',), ['fulltext'], (('a-3',), 0, 0), [('a-2',)]),
-            ])
+        idx.add_versions([('a-2', ['fulltext'], (None, 0, 0), ['a-1']),
+                          ('a-3', ['fulltext'], (None, 0, 0), ['a-2']),
+                         ])
         self.check_file_contents('test.kndx',
             '# bzr knit index 8\n'
             '\n'
@@ -945,16 +2028,11 @@
             'a-2 fulltext 0 0 0 :\n'
             'a-3 fulltext 0 0 1 :'
             )
-        self.assertEqual(set([('a-3',), ('a-1',), ('a-2',)]), idx.keys())
-        self.assertEqual({
-            ('a-1',): ((('a-1',), 0, 0), None, (), ('fulltext', False)),
-            ('a-2',): ((('a-2',), 0, 0), None, (('a-1',),), ('fulltext', False)),
-            ('a-3',): ((('a-3',), 0, 0), None, (('a-2',),), ('fulltext', False)),
-            }, idx.get_build_details(idx.keys()))
-        self.assertEqual({('a-1',):(),
-            ('a-2',):(('a-1',),),
-            ('a-3',):(('a-2',),),},
-            idx.get_parent_map(idx.keys()))
+        self.assertEqual(['a-1', 'a-2', 'a-3'], idx._history)
+        self.assertEqual({'a-1':('a-1', ['fulltext'], 0, 0, [], 0),
+                          'a-2':('a-2', ['fulltext'], 0, 0, ['a-1'], 1),
+                          'a-3':('a-3', ['fulltext'], 0, 0, ['a-2'], 2),
+                         }, idx._cache)
 
     def test_add_versions_fails_clean(self):
         """If add_versions fails in the middle, it restores a pristine state.
@@ -970,29 +2048,26 @@
 
         knit = self.make_test_knit()
         idx = knit._index
-        idx.add_records([(('a-1',), ['fulltext'], (('a-1',), 0, 0), [])])
+        idx.add_version('a-1', ['fulltext'], (None, 0, 0), [])
 
         class StopEarly(Exception):
             pass
 
         def generate_failure():
             """Add some entries and then raise an exception"""
-            yield (('a-2',), ['fulltext'], (None, 0, 0), ('a-1',))
-            yield (('a-3',), ['fulltext'], (None, 0, 0), ('a-2',))
+            yield ('a-2', ['fulltext'], (None, 0, 0), ['a-1'])
+            yield ('a-3', ['fulltext'], (None, 0, 0), ['a-2'])
             raise StopEarly()
 
         # Assert the pre-condition
-        def assertA1Only():
-            self.assertEqual(set([('a-1',)]), set(idx.keys()))
-            self.assertEqual(
-                {('a-1',): ((('a-1',), 0, 0), None, (), ('fulltext', False))},
-                idx.get_build_details([('a-1',)]))
-            self.assertEqual({('a-1',):()}, idx.get_parent_map(idx.keys()))
-
-        assertA1Only()
-        self.assertRaises(StopEarly, idx.add_records, generate_failure())
+        self.assertEqual(['a-1'], idx._history)
+        self.assertEqual({'a-1':('a-1', ['fulltext'], 0, 0, [], 0)}, idx._cache)
+
+        self.assertRaises(StopEarly, idx.add_versions, generate_failure())
+
         # And it shouldn't be modified
-        assertA1Only()
+        self.assertEqual(['a-1'], idx._history)
+        self.assertEqual({'a-1':('a-1', ['fulltext'], 0, 0, [], 0)}, idx._cache)
 
     def test_knit_index_ignores_empty_files(self):
         # There was a race condition in older bzr, where a ^C at the right time
@@ -1007,8 +2082,8 @@
     def test_knit_index_checks_header(self):
         t = get_transport('.')
         t.put_bytes('test.kndx', '# not really a knit header\n\n')
-        k = self.make_test_knit()
-        self.assertRaises(KnitHeaderError, k.keys)
+
+        self.assertRaises(KnitHeaderError, self.make_test_knit)
 
 
 class TestGraphIndexKnit(KnitTests):
@@ -1053,100 +2128,183 @@
             add_callback = self.catch_add
         else:
             add_callback = None
-        return _KnitGraphIndex(combined_index, lambda:True, deltas=deltas,
+        return KnitGraphIndex(combined_index, deltas=deltas,
             add_callback=add_callback)
 
-    def test_keys(self):
-        index = self.two_graph_index()
-        self.assertEqual(set([('tail',), ('tip',), ('parent',), ('separate',)]),
-            set(index.keys()))
+    def test_get_graph(self):
+        index = self.two_graph_index()
+        self.assertEqual(set([
+            ('tip', ('parent', )),
+            ('tail', ()),
+            ('parent', ('tail', 'ghost')),
+            ('separate', ()),
+            ]), set(index.get_graph()))
+
+    def test_get_ancestry(self):
+        # get_ancestry is defined as eliding ghosts, not erroring.
+        index = self.two_graph_index()
+        self.assertEqual([], index.get_ancestry([]))
+        self.assertEqual(['separate'], index.get_ancestry(['separate']))
+        self.assertEqual(['tail'], index.get_ancestry(['tail']))
+        self.assertEqual(['tail', 'parent'], index.get_ancestry(['parent']))
+        self.assertEqual(['tail', 'parent', 'tip'], index.get_ancestry(['tip']))
+        self.assertTrue(index.get_ancestry(['tip', 'separate']) in
+            (['tail', 'parent', 'tip', 'separate'],
+             ['separate', 'tail', 'parent', 'tip'],
+            ))
+        # and without topo_sort
+        self.assertEqual(set(['separate']),
+            set(index.get_ancestry(['separate'], topo_sorted=False)))
+        self.assertEqual(set(['tail']),
+            set(index.get_ancestry(['tail'], topo_sorted=False)))
+        self.assertEqual(set(['tail', 'parent']),
+            set(index.get_ancestry(['parent'], topo_sorted=False)))
+        self.assertEqual(set(['tail', 'parent', 'tip']),
+            set(index.get_ancestry(['tip'], topo_sorted=False)))
+        self.assertEqual(set(['separate', 'tail', 'parent', 'tip']),
+            set(index.get_ancestry(['tip', 'separate'])))
+        # asking for a ghost makes it go boom.
+        self.assertRaises(errors.RevisionNotPresent, index.get_ancestry, ['ghost'])
+
+    def test_get_ancestry_with_ghosts(self):
+        index = self.two_graph_index()
+        self.assertEqual([], index.get_ancestry_with_ghosts([]))
+        self.assertEqual(['separate'], index.get_ancestry_with_ghosts(['separate']))
+        self.assertEqual(['tail'], index.get_ancestry_with_ghosts(['tail']))
+        self.assertTrue(index.get_ancestry_with_ghosts(['parent']) in
+            (['tail', 'ghost', 'parent'],
+             ['ghost', 'tail', 'parent'],
+            ))
+        self.assertTrue(index.get_ancestry_with_ghosts(['tip']) in
+            (['tail', 'ghost', 'parent', 'tip'],
+             ['ghost', 'tail', 'parent', 'tip'],
+            ))
+        self.assertTrue(index.get_ancestry_with_ghosts(['tip', 'separate']) in
+            (['tail', 'ghost', 'parent', 'tip', 'separate'],
+             ['ghost', 'tail', 'parent', 'tip', 'separate'],
+             ['separate', 'tail', 'ghost', 'parent', 'tip'],
+             ['separate', 'ghost', 'tail', 'parent', 'tip'],
+            ))
+        # asking for a ghost makes it go boom.
+        self.assertRaises(errors.RevisionNotPresent, index.get_ancestry_with_ghosts, ['ghost'])
+
+    def test_num_versions(self):
+        index = self.two_graph_index()
+        self.assertEqual(4, index.num_versions())
+
+    def test_get_versions(self):
+        index = self.two_graph_index()
+        self.assertEqual(set(['tail', 'tip', 'parent', 'separate']),
+            set(index.get_versions()))
+
+    def test_has_version(self):
+        index = self.two_graph_index()
+        self.assertTrue(index.has_version('tail'))
+        self.assertFalse(index.has_version('ghost'))
 
     def test_get_position(self):
         index = self.two_graph_index()
-        self.assertEqual((index._graph_index._indices[0], 0, 100), index.get_position(('tip',)))
-        self.assertEqual((index._graph_index._indices[1], 100, 78), index.get_position(('parent',)))
+        self.assertEqual((index._graph_index._indices[0], 0, 100), index.get_position('tip'))
+        self.assertEqual((index._graph_index._indices[1], 100, 78), index.get_position('parent'))
 
     def test_get_method_deltas(self):
         index = self.two_graph_index(deltas=True)
-        self.assertEqual('fulltext', index.get_method(('tip',)))
-        self.assertEqual('line-delta', index.get_method(('parent',)))
+        self.assertEqual('fulltext', index.get_method('tip'))
+        self.assertEqual('line-delta', index.get_method('parent'))
 
     def test_get_method_no_deltas(self):
         # check that the parent-history lookup is ignored with deltas=False.
         index = self.two_graph_index(deltas=False)
-        self.assertEqual('fulltext', index.get_method(('tip',)))
-        self.assertEqual('fulltext', index.get_method(('parent',)))
+        self.assertEqual('fulltext', index.get_method('tip'))
+        self.assertEqual('fulltext', index.get_method('parent'))
 
     def test_get_options_deltas(self):
         index = self.two_graph_index(deltas=True)
-        self.assertEqual(['fulltext', 'no-eol'], index.get_options(('tip',)))
-        self.assertEqual(['line-delta'], index.get_options(('parent',)))
+        self.assertEqual(['fulltext', 'no-eol'], index.get_options('tip'))
+        self.assertEqual(['line-delta'], index.get_options('parent'))
 
     def test_get_options_no_deltas(self):
         # check that the parent-history lookup is ignored with deltas=False.
         index = self.two_graph_index(deltas=False)
-        self.assertEqual(['fulltext', 'no-eol'], index.get_options(('tip',)))
-        self.assertEqual(['fulltext'], index.get_options(('parent',)))
-
-    def test_get_parent_map(self):
-        index = self.two_graph_index()
-        self.assertEqual({('parent',):(('tail',), ('ghost',))},
-            index.get_parent_map([('parent',), ('ghost',)]))
+        self.assertEqual(['fulltext', 'no-eol'], index.get_options('tip'))
+        self.assertEqual(['fulltext'], index.get_options('parent'))
+
+    def test_get_parents(self):
+        # get_parents ignores ghosts
+        index = self.two_graph_index()
+        self.assertEqual(('tail', ), index.get_parents('parent'))
+        # and errors on ghosts.
+        self.assertRaises(errors.RevisionNotPresent,
+            index.get_parents, 'ghost')
+
+    def test_get_parents_with_ghosts(self):
+        index = self.two_graph_index()
+        self.assertEqual(('tail', 'ghost'), index.get_parents_with_ghosts('parent'))
+        # and errors on ghosts.
+        self.assertRaises(errors.RevisionNotPresent,
+            index.get_parents_with_ghosts, 'ghost')
+
+    def test_check_versions_present(self):
+        # ghosts should not be considered present
+        index = self.two_graph_index()
+        self.assertRaises(RevisionNotPresent, index.check_versions_present,
+            ['ghost'])
+        self.assertRaises(RevisionNotPresent, index.check_versions_present,
+            ['tail', 'ghost'])
+        index.check_versions_present(['tail', 'separate'])
 
     def catch_add(self, entries):
         self.caught_entries.append(entries)
 
     def test_add_no_callback_errors(self):
         index = self.two_graph_index()
-        self.assertRaises(errors.ReadOnlyError, index.add_records,
-            [(('new',), 'fulltext,no-eol', (None, 50, 60), ['separate'])])
+        self.assertRaises(errors.ReadOnlyError, index.add_version,
+            'new', 'fulltext,no-eol', (None, 50, 60), ['separate'])
 
     def test_add_version_smoke(self):
         index = self.two_graph_index(catch_adds=True)
-        index.add_records([(('new',), 'fulltext,no-eol', (None, 50, 60),
-            [('separate',)])])
+        index.add_version('new', 'fulltext,no-eol', (None, 50, 60), ['separate'])
         self.assertEqual([[(('new', ), 'N50 60', ((('separate',),),))]],
             self.caught_entries)
 
     def test_add_version_delta_not_delta_index(self):
         index = self.two_graph_index(catch_adds=True)
-        self.assertRaises(errors.KnitCorrupt, index.add_records,
-            [(('new',), 'no-eol,line-delta', (None, 0, 100), [('parent',)])])
+        self.assertRaises(errors.KnitCorrupt, index.add_version,
+            'new', 'no-eol,line-delta', (None, 0, 100), ['parent'])
         self.assertEqual([], self.caught_entries)
 
     def test_add_version_same_dup(self):
         index = self.two_graph_index(catch_adds=True)
         # options can be spelt two different ways
-        index.add_records([(('tip',), 'fulltext,no-eol', (None, 0, 100), [('parent',)])])
-        index.add_records([(('tip',), 'no-eol,fulltext', (None, 0, 100), [('parent',)])])
-        # position/length are ignored (because each pack could have fulltext or
-        # delta, and be at a different position.
-        index.add_records([(('tip',), 'fulltext,no-eol', (None, 50, 100),
-            [('parent',)])])
-        index.add_records([(('tip',), 'fulltext,no-eol', (None, 0, 1000),
-            [('parent',)])])
-        # but neither should have added data:
-        self.assertEqual([[], [], [], []], self.caught_entries)
+        index.add_version('tip', 'fulltext,no-eol', (None, 0, 100), ['parent'])
+        index.add_version('tip', 'no-eol,fulltext', (None, 0, 100), ['parent'])
+        # but neither should have added data.
+        self.assertEqual([[], []], self.caught_entries)
         
     def test_add_version_different_dup(self):
         index = self.two_graph_index(deltas=True, catch_adds=True)
         # change options
-        self.assertRaises(errors.KnitCorrupt, index.add_records,
-            [(('tip',), 'no-eol,line-delta', (None, 0, 100), [('parent',)])])
-        self.assertRaises(errors.KnitCorrupt, index.add_records,
-            [(('tip',), 'line-delta,no-eol', (None, 0, 100), [('parent',)])])
-        self.assertRaises(errors.KnitCorrupt, index.add_records,
-            [(('tip',), 'fulltext', (None, 0, 100), [('parent',)])])
+        self.assertRaises(errors.KnitCorrupt, index.add_version,
+            'tip', 'no-eol,line-delta', (None, 0, 100), ['parent'])
+        self.assertRaises(errors.KnitCorrupt, index.add_version,
+            'tip', 'line-delta,no-eol', (None, 0, 100), ['parent'])
+        self.assertRaises(errors.KnitCorrupt, index.add_version,
+            'tip', 'fulltext', (None, 0, 100), ['parent'])
+        # position/length
+        self.assertRaises(errors.KnitCorrupt, index.add_version,
+            'tip', 'fulltext,no-eol', (None, 50, 100), ['parent'])
+        self.assertRaises(errors.KnitCorrupt, index.add_version,
+            'tip', 'fulltext,no-eol', (None, 0, 1000), ['parent'])
         # parents
-        self.assertRaises(errors.KnitCorrupt, index.add_records,
-            [(('tip',), 'fulltext,no-eol', (None, 0, 100), [])])
+        self.assertRaises(errors.KnitCorrupt, index.add_version,
+            'tip', 'fulltext,no-eol', (None, 0, 100), [])
         self.assertEqual([], self.caught_entries)
         
     def test_add_versions_nodeltas(self):
         index = self.two_graph_index(catch_adds=True)
-        index.add_records([
-                (('new',), 'fulltext,no-eol', (None, 50, 60), [('separate',)]),
-                (('new2',), 'fulltext', (None, 0, 6), [('new',)]),
+        index.add_versions([
+                ('new', 'fulltext,no-eol', (None, 50, 60), ['separate']),
+                ('new2', 'fulltext', (None, 0, 6), ['new']),
                 ])
         self.assertEqual([(('new', ), 'N50 60', ((('separate',),),)),
             (('new2', ), ' 0 6', ((('new',),),))],
@@ -1155,9 +2313,9 @@
 
     def test_add_versions_deltas(self):
         index = self.two_graph_index(deltas=True, catch_adds=True)
-        index.add_records([
-                (('new',), 'fulltext,no-eol', (None, 50, 60), [('separate',)]),
-                (('new2',), 'line-delta', (None, 0, 6), [('new',)]),
+        index.add_versions([
+                ('new', 'fulltext,no-eol', (None, 50, 60), ['separate']),
+                ('new2', 'line-delta', (None, 0, 6), ['new']),
                 ])
         self.assertEqual([(('new', ), 'N50 60', ((('separate',),), ())),
             (('new2', ), ' 0 6', ((('new',),), (('new',),), ))],
@@ -1166,51 +2324,81 @@
 
     def test_add_versions_delta_not_delta_index(self):
         index = self.two_graph_index(catch_adds=True)
-        self.assertRaises(errors.KnitCorrupt, index.add_records,
-            [(('new',), 'no-eol,line-delta', (None, 0, 100), [('parent',)])])
+        self.assertRaises(errors.KnitCorrupt, index.add_versions,
+            [('new', 'no-eol,line-delta', (None, 0, 100), ['parent'])])
         self.assertEqual([], self.caught_entries)
 
     def test_add_versions_random_id_accepted(self):
         index = self.two_graph_index(catch_adds=True)
-        index.add_records([], random_id=True)
+        index.add_versions([], random_id=True)
 
     def test_add_versions_same_dup(self):
         index = self.two_graph_index(catch_adds=True)
         # options can be spelt two different ways
-        index.add_records([(('tip',), 'fulltext,no-eol', (None, 0, 100),
-            [('parent',)])])
-        index.add_records([(('tip',), 'no-eol,fulltext', (None, 0, 100),
-            [('parent',)])])
-        # position/length are ignored (because each pack could have fulltext or
-        # delta, and be at a different position.
-        index.add_records([(('tip',), 'fulltext,no-eol', (None, 50, 100),
-            [('parent',)])])
-        index.add_records([(('tip',), 'fulltext,no-eol', (None, 0, 1000),
-            [('parent',)])])
+        index.add_versions([('tip', 'fulltext,no-eol', (None, 0, 100), ['parent'])])
+        index.add_versions([('tip', 'no-eol,fulltext', (None, 0, 100), ['parent'])])
         # but neither should have added data.
-        self.assertEqual([[], [], [], []], self.caught_entries)
+        self.assertEqual([[], []], self.caught_entries)
         
     def test_add_versions_different_dup(self):
         index = self.two_graph_index(deltas=True, catch_adds=True)
         # change options
-        self.assertRaises(errors.KnitCorrupt, index.add_records,
-            [(('tip',), 'no-eol,line-delta', (None, 0, 100), [('parent',)])])
-        self.assertRaises(errors.KnitCorrupt, index.add_records,
-            [(('tip',), 'line-delta,no-eol', (None, 0, 100), [('parent',)])])
-        self.assertRaises(errors.KnitCorrupt, index.add_records,
-            [(('tip',), 'fulltext', (None, 0, 100), [('parent',)])])
+        self.assertRaises(errors.KnitCorrupt, index.add_versions,
+            [('tip', 'no-eol,line-delta', (None, 0, 100), ['parent'])])
+        self.assertRaises(errors.KnitCorrupt, index.add_versions,
+            [('tip', 'line-delta,no-eol', (None, 0, 100), ['parent'])])
+        self.assertRaises(errors.KnitCorrupt, index.add_versions,
+            [('tip', 'fulltext', (None, 0, 100), ['parent'])])
+        # position/length
+        self.assertRaises(errors.KnitCorrupt, index.add_versions,
+            [('tip', 'fulltext,no-eol', (None, 50, 100), ['parent'])])
+        self.assertRaises(errors.KnitCorrupt, index.add_versions,
+            [('tip', 'fulltext,no-eol', (None, 0, 1000), ['parent'])])
         # parents
-        self.assertRaises(errors.KnitCorrupt, index.add_records,
-            [(('tip',), 'fulltext,no-eol', (None, 0, 100), [])])
+        self.assertRaises(errors.KnitCorrupt, index.add_versions,
+            [('tip', 'fulltext,no-eol', (None, 0, 100), [])])
         # change options in the second record
-        self.assertRaises(errors.KnitCorrupt, index.add_records,
-            [(('tip',), 'fulltext,no-eol', (None, 0, 100), [('parent',)]),
-             (('tip',), 'no-eol,line-delta', (None, 0, 100), [('parent',)])])
+        self.assertRaises(errors.KnitCorrupt, index.add_versions,
+            [('tip', 'fulltext,no-eol', (None, 0, 100), ['parent']),
+             ('tip', 'no-eol,line-delta', (None, 0, 100), ['parent'])])
         self.assertEqual([], self.caught_entries)
 
+    def test_iter_parents(self):
+        index1 = self.make_g_index('1', 1, [
+        # no parents
+            (('r0', ), 'N0 100', ([], )),
+        # 1 parent
+            (('r1', ), '', ([('r0', )], ))])
+        index2 = self.make_g_index('2', 1, [
+        # 2 parents
+            (('r2', ), 'N0 100', ([('r1', ), ('r0', )], )),
+            ])
+        combined_index = CombinedGraphIndex([index1, index2])
+        index = KnitGraphIndex(combined_index)
+        # XXX TODO a ghost
+        # cases: each sample data individually:
+        self.assertEqual(set([('r0', ())]),
+            set(index.iter_parents(['r0'])))
+        self.assertEqual(set([('r1', ('r0', ))]),
+            set(index.iter_parents(['r1'])))
+        self.assertEqual(set([('r2', ('r1', 'r0'))]),
+            set(index.iter_parents(['r2'])))
+        # no nodes returned for a missing node
+        self.assertEqual(set(),
+            set(index.iter_parents(['missing'])))
+        # 1 node returned with missing nodes skipped
+        self.assertEqual(set([('r1', ('r0', ))]),
+            set(index.iter_parents(['ghost1', 'r1', 'ghost'])))
+        # 2 nodes returned
+        self.assertEqual(set([('r0', ()), ('r1', ('r0', ))]),
+            set(index.iter_parents(['r0', 'r1'])))
+        # 2 nodes returned, missing skipped
+        self.assertEqual(set([('r0', ()), ('r1', ('r0', ))]),
+            set(index.iter_parents(['a', 'r0', 'b', 'r1', 'c'])))
+
 
 class TestNoParentsGraphIndexKnit(KnitTests):
-    """Tests for knits using _KnitGraphIndex with no parents."""
+    """Tests for knits using KnitGraphIndex with no parents."""
 
     def make_g_index(self, name, ref_lists=0, nodes=[]):
         builder = GraphIndexBuilder(ref_lists)
@@ -1223,8 +2411,8 @@
 
     def test_parents_deltas_incompatible(self):
         index = CombinedGraphIndex([])
-        self.assertRaises(errors.KnitError, _KnitGraphIndex, lambda:True,
-            index, deltas=True, parents=False)
+        self.assertRaises(errors.KnitError, KnitGraphIndex, index,
+            deltas=True, parents=False)
 
     def two_graph_index(self, catch_adds=False):
         """Build a two-graph index.
@@ -1246,87 +2434,150 @@
             add_callback = self.catch_add
         else:
             add_callback = None
-        return _KnitGraphIndex(combined_index, lambda:True, parents=False,
+        return KnitGraphIndex(combined_index, parents=False,
             add_callback=add_callback)
 
-    def test_keys(self):
-        index = self.two_graph_index()
-        self.assertEqual(set([('tail',), ('tip',), ('parent',), ('separate',)]),
-            set(index.keys()))
+    def test_get_graph(self):
+        index = self.two_graph_index()
+        self.assertEqual(set([
+            ('tip', ()),
+            ('tail', ()),
+            ('parent', ()),
+            ('separate', ()),
+            ]), set(index.get_graph()))
+
+    def test_get_ancestry(self):
+        # with no parents, ancestry is always just the key.
+        index = self.two_graph_index()
+        self.assertEqual([], index.get_ancestry([]))
+        self.assertEqual(['separate'], index.get_ancestry(['separate']))
+        self.assertEqual(['tail'], index.get_ancestry(['tail']))
+        self.assertEqual(['parent'], index.get_ancestry(['parent']))
+        self.assertEqual(['tip'], index.get_ancestry(['tip']))
+        self.assertTrue(index.get_ancestry(['tip', 'separate']) in
+            (['tip', 'separate'],
+             ['separate', 'tip'],
+            ))
+        # asking for a ghost makes it go boom.
+        self.assertRaises(errors.RevisionNotPresent, index.get_ancestry, ['ghost'])
+
+    def test_get_ancestry_with_ghosts(self):
+        index = self.two_graph_index()
+        self.assertEqual([], index.get_ancestry_with_ghosts([]))
+        self.assertEqual(['separate'], index.get_ancestry_with_ghosts(['separate']))
+        self.assertEqual(['tail'], index.get_ancestry_with_ghosts(['tail']))
+        self.assertEqual(['parent'], index.get_ancestry_with_ghosts(['parent']))
+        self.assertEqual(['tip'], index.get_ancestry_with_ghosts(['tip']))
+        self.assertTrue(index.get_ancestry_with_ghosts(['tip', 'separate']) in
+            (['tip', 'separate'],
+             ['separate', 'tip'],
+            ))
+        # asking for a ghost makes it go boom.
+        self.assertRaises(errors.RevisionNotPresent, index.get_ancestry_with_ghosts, ['ghost'])
+
+    def test_num_versions(self):
+        index = self.two_graph_index()
+        self.assertEqual(4, index.num_versions())
+
+    def test_get_versions(self):
+        index = self.two_graph_index()
+        self.assertEqual(set(['tail', 'tip', 'parent', 'separate']),
+            set(index.get_versions()))
+
+    def test_has_version(self):
+        index = self.two_graph_index()
+        self.assertTrue(index.has_version('tail'))
+        self.assertFalse(index.has_version('ghost'))
 
     def test_get_position(self):
         index = self.two_graph_index()
-        self.assertEqual((index._graph_index._indices[0], 0, 100),
-            index.get_position(('tip',)))
-        self.assertEqual((index._graph_index._indices[1], 100, 78),
-            index.get_position(('parent',)))
+        self.assertEqual((index._graph_index._indices[0], 0, 100), index.get_position('tip'))
+        self.assertEqual((index._graph_index._indices[1], 100, 78), index.get_position('parent'))
 
     def test_get_method(self):
         index = self.two_graph_index()
-        self.assertEqual('fulltext', index.get_method(('tip',)))
-        self.assertEqual(['fulltext'], index.get_options(('parent',)))
+        self.assertEqual('fulltext', index.get_method('tip'))
+        self.assertEqual(['fulltext'], index.get_options('parent'))
 
     def test_get_options(self):
         index = self.two_graph_index()
-        self.assertEqual(['fulltext', 'no-eol'], index.get_options(('tip',)))
-        self.assertEqual(['fulltext'], index.get_options(('parent',)))
-
-    def test_get_parent_map(self):
-        index = self.two_graph_index()
-        self.assertEqual({('parent',):None},
-            index.get_parent_map([('parent',), ('ghost',)]))
+        self.assertEqual(['fulltext', 'no-eol'], index.get_options('tip'))
+        self.assertEqual(['fulltext'], index.get_options('parent'))
+
+    def test_get_parents(self):
+        index = self.two_graph_index()
+        self.assertEqual((), index.get_parents('parent'))
+        # and errors on ghosts.
+        self.assertRaises(errors.RevisionNotPresent,
+            index.get_parents, 'ghost')
+
+    def test_get_parents_with_ghosts(self):
+        index = self.two_graph_index()
+        self.assertEqual((), index.get_parents_with_ghosts('parent'))
+        # and errors on ghosts.
+        self.assertRaises(errors.RevisionNotPresent,
+            index.get_parents_with_ghosts, 'ghost')
+
+    def test_check_versions_present(self):
+        index = self.two_graph_index()
+        self.assertRaises(RevisionNotPresent, index.check_versions_present,
+            ['missing'])
+        self.assertRaises(RevisionNotPresent, index.check_versions_present,
+            ['tail', 'missing'])
+        index.check_versions_present(['tail', 'separate'])
 
     def catch_add(self, entries):
         self.caught_entries.append(entries)
 
     def test_add_no_callback_errors(self):
         index = self.two_graph_index()
-        self.assertRaises(errors.ReadOnlyError, index.add_records,
-            [(('new',), 'fulltext,no-eol', (None, 50, 60), [('separate',)])])
+        self.assertRaises(errors.ReadOnlyError, index.add_version,
+            'new', 'fulltext,no-eol', (None, 50, 60), ['separate'])
 
     def test_add_version_smoke(self):
         index = self.two_graph_index(catch_adds=True)
-        index.add_records([(('new',), 'fulltext,no-eol', (None, 50, 60), [])])
+        index.add_version('new', 'fulltext,no-eol', (None, 50, 60), [])
         self.assertEqual([[(('new', ), 'N50 60')]],
             self.caught_entries)
 
     def test_add_version_delta_not_delta_index(self):
         index = self.two_graph_index(catch_adds=True)
-        self.assertRaises(errors.KnitCorrupt, index.add_records,
-            [(('new',), 'no-eol,line-delta', (None, 0, 100), [])])
+        self.assertRaises(errors.KnitCorrupt, index.add_version,
+            'new', 'no-eol,line-delta', (None, 0, 100), [])
         self.assertEqual([], self.caught_entries)
 
     def test_add_version_same_dup(self):
         index = self.two_graph_index(catch_adds=True)
         # options can be spelt two different ways
-        index.add_records([(('tip',), 'fulltext,no-eol', (None, 0, 100), [])])
-        index.add_records([(('tip',), 'no-eol,fulltext', (None, 0, 100), [])])
-        # position/length are ignored (because each pack could have fulltext or
-        # delta, and be at a different position.
-        index.add_records([(('tip',), 'fulltext,no-eol', (None, 50, 100), [])])
-        index.add_records([(('tip',), 'fulltext,no-eol', (None, 0, 1000), [])])
+        index.add_version('tip', 'fulltext,no-eol', (None, 0, 100), [])
+        index.add_version('tip', 'no-eol,fulltext', (None, 0, 100), [])
         # but neither should have added data.
-        self.assertEqual([[], [], [], []], self.caught_entries)
+        self.assertEqual([[], []], self.caught_entries)
         
     def test_add_version_different_dup(self):
         index = self.two_graph_index(catch_adds=True)
         # change options
-        self.assertRaises(errors.KnitCorrupt, index.add_records,
-            [(('tip',), 'no-eol,line-delta', (None, 0, 100), [])])
-        self.assertRaises(errors.KnitCorrupt, index.add_records,
-            [(('tip',), 'line-delta,no-eol', (None, 0, 100), [])])
-        self.assertRaises(errors.KnitCorrupt, index.add_records,
-            [(('tip',), 'fulltext', (None, 0, 100), [])])
+        self.assertRaises(errors.KnitCorrupt, index.add_version,
+            'tip', 'no-eol,line-delta', (None, 0, 100), [])
+        self.assertRaises(errors.KnitCorrupt, index.add_version,
+            'tip', 'line-delta,no-eol', (None, 0, 100), [])
+        self.assertRaises(errors.KnitCorrupt, index.add_version,
+            'tip', 'fulltext', (None, 0, 100), [])
+        # position/length
+        self.assertRaises(errors.KnitCorrupt, index.add_version,
+            'tip', 'fulltext,no-eol', (None, 50, 100), [])
+        self.assertRaises(errors.KnitCorrupt, index.add_version,
+            'tip', 'fulltext,no-eol', (None, 0, 1000), [])
         # parents
-        self.assertRaises(errors.KnitCorrupt, index.add_records,
-            [(('tip',), 'fulltext,no-eol', (None, 0, 100), [('parent',)])])
+        self.assertRaises(errors.KnitCorrupt, index.add_version,
+            'tip', 'fulltext,no-eol', (None, 0, 100), ['parent'])
         self.assertEqual([], self.caught_entries)
         
     def test_add_versions(self):
         index = self.two_graph_index(catch_adds=True)
-        index.add_records([
-                (('new',), 'fulltext,no-eol', (None, 50, 60), []),
-                (('new2',), 'fulltext', (None, 0, 6), []),
+        index.add_versions([
+                ('new', 'fulltext,no-eol', (None, 50, 60), []),
+                ('new2', 'fulltext', (None, 0, 6), []),
                 ])
         self.assertEqual([(('new', ), 'N50 60'), (('new2', ), ' 0 6')],
             sorted(self.caught_entries[0]))
@@ -1334,445 +2585,58 @@
 
     def test_add_versions_delta_not_delta_index(self):
         index = self.two_graph_index(catch_adds=True)
-        self.assertRaises(errors.KnitCorrupt, index.add_records,
-            [(('new',), 'no-eol,line-delta', (None, 0, 100), [('parent',)])])
+        self.assertRaises(errors.KnitCorrupt, index.add_versions,
+            [('new', 'no-eol,line-delta', (None, 0, 100), ['parent'])])
         self.assertEqual([], self.caught_entries)
 
     def test_add_versions_parents_not_parents_index(self):
         index = self.two_graph_index(catch_adds=True)
-        self.assertRaises(errors.KnitCorrupt, index.add_records,
-            [(('new',), 'no-eol,fulltext', (None, 0, 100), [('parent',)])])
+        self.assertRaises(errors.KnitCorrupt, index.add_versions,
+            [('new', 'no-eol,fulltext', (None, 0, 100), ['parent'])])
         self.assertEqual([], self.caught_entries)
 
     def test_add_versions_random_id_accepted(self):
         index = self.two_graph_index(catch_adds=True)
-        index.add_records([], random_id=True)
+        index.add_versions([], random_id=True)
 
     def test_add_versions_same_dup(self):
         index = self.two_graph_index(catch_adds=True)
         # options can be spelt two different ways
-        index.add_records([(('tip',), 'fulltext,no-eol', (None, 0, 100), [])])
-        index.add_records([(('tip',), 'no-eol,fulltext', (None, 0, 100), [])])
-        # position/length are ignored (because each pack could have fulltext or
-        # delta, and be at a different position.
-        index.add_records([(('tip',), 'fulltext,no-eol', (None, 50, 100), [])])
-        index.add_records([(('tip',), 'fulltext,no-eol', (None, 0, 1000), [])])
+        index.add_versions([('tip', 'fulltext,no-eol', (None, 0, 100), [])])
+        index.add_versions([('tip', 'no-eol,fulltext', (None, 0, 100), [])])
         # but neither should have added data.
-        self.assertEqual([[], [], [], []], self.caught_entries)
+        self.assertEqual([[], []], self.caught_entries)
         
     def test_add_versions_different_dup(self):
         index = self.two_graph_index(catch_adds=True)
         # change options
-        self.assertRaises(errors.KnitCorrupt, index.add_records,
-            [(('tip',), 'no-eol,line-delta', (None, 0, 100), [])])
-        self.assertRaises(errors.KnitCorrupt, index.add_records,
-            [(('tip',), 'line-delta,no-eol', (None, 0, 100), [])])
-        self.assertRaises(errors.KnitCorrupt, index.add_records,
-            [(('tip',), 'fulltext', (None, 0, 100), [])])
+        self.assertRaises(errors.KnitCorrupt, index.add_versions,
+            [('tip', 'no-eol,line-delta', (None, 0, 100), [])])
+        self.assertRaises(errors.KnitCorrupt, index.add_versions,
+            [('tip', 'line-delta,no-eol', (None, 0, 100), [])])
+        self.assertRaises(errors.KnitCorrupt, index.add_versions,
+            [('tip', 'fulltext', (None, 0, 100), [])])
+        # position/length
+        self.assertRaises(errors.KnitCorrupt, index.add_versions,
+            [('tip', 'fulltext,no-eol', (None, 50, 100), [])])
+        self.assertRaises(errors.KnitCorrupt, index.add_versions,
+            [('tip', 'fulltext,no-eol', (None, 0, 1000), [])])
         # parents
-        self.assertRaises(errors.KnitCorrupt, index.add_records,
-            [(('tip',), 'fulltext,no-eol', (None, 0, 100), [('parent',)])])
+        self.assertRaises(errors.KnitCorrupt, index.add_versions,
+            [('tip', 'fulltext,no-eol', (None, 0, 100), ['parent'])])
         # change options in the second record
-        self.assertRaises(errors.KnitCorrupt, index.add_records,
-            [(('tip',), 'fulltext,no-eol', (None, 0, 100), []),
-             (('tip',), 'no-eol,line-delta', (None, 0, 100), [])])
+        self.assertRaises(errors.KnitCorrupt, index.add_versions,
+            [('tip', 'fulltext,no-eol', (None, 0, 100), []),
+             ('tip', 'no-eol,line-delta', (None, 0, 100), [])])
         self.assertEqual([], self.caught_entries)
 
-
-class TestStacking(KnitTests):
-
-    def get_basis_and_test_knit(self):
-        basis = self.make_test_knit(name='basis')
-        basis = RecordingVersionedFilesDecorator(basis)
-        test = self.make_test_knit(name='test')
-        test.add_fallback_versioned_files(basis)
-        return basis, test
-
-    def test_add_fallback_versioned_files(self):
-        basis = self.make_test_knit(name='basis')
-        test = self.make_test_knit(name='test')
-        # It must not error; other tests test that the fallback is referred to
-        # when accessing data.
-        test.add_fallback_versioned_files(basis)
-
-    def test_add_lines(self):
-        # lines added to the test are not added to the basis
-        basis, test = self.get_basis_and_test_knit()
-        key = ('foo',)
-        key_basis = ('bar',)
-        key_cross_border = ('quux',)
-        key_delta = ('zaphod',)
-        test.add_lines(key, (), ['foo\n'])
-        self.assertEqual({}, basis.get_parent_map([key]))
-        # lines added to the test that reference across the stack do a
-        # fulltext.
-        basis.add_lines(key_basis, (), ['foo\n'])
-        basis.calls = []
-        test.add_lines(key_cross_border, (key_basis,), ['foo\n'])
-        self.assertEqual('fulltext', test._index.get_method(key_cross_border))
-        self.assertEqual([("get_parent_map", set([key_basis]))], basis.calls)
-        # Subsequent adds do delta.
-        basis.calls = []
-        test.add_lines(key_delta, (key_cross_border,), ['foo\n'])
-        self.assertEqual('line-delta', test._index.get_method(key_delta))
-        self.assertEqual([], basis.calls)
-
-    def test_annotate(self):
-        # annotations from the test knit are answered without asking the basis
-        basis, test = self.get_basis_and_test_knit()
-        key = ('foo',)
-        key_basis = ('bar',)
-        key_missing = ('missing',)
-        test.add_lines(key, (), ['foo\n'])
-        details = test.annotate(key)
-        self.assertEqual([(key, 'foo\n')], details)
-        self.assertEqual([], basis.calls)
-        # But texts that are not in the test knit are looked for in the basis
-        # directly.
-        basis.add_lines(key_basis, (), ['foo\n', 'bar\n'])
-        basis.calls = []
-        details = test.annotate(key_basis)
-        self.assertEqual([(key_basis, 'foo\n'), (key_basis, 'bar\n')], details)
-        # Not optimised to date:
-        # self.assertEqual([("annotate", key_basis)], basis.calls)
-        self.assertEqual([('get_parent_map', set([key_basis])),
-            ('get_parent_map', set([key_basis])),
-            ('get_parent_map', set([key_basis])),
-            ('get_record_stream', [key_basis], 'unordered', True)],
-            basis.calls)
-
-    def test_check(self):
-        # At the moment checking a stacked knit does implicitly check the
-        # fallback files.  
-        basis, test = self.get_basis_and_test_knit()
-        test.check()
-
-    def test_get_parent_map(self):
-        # parents in the test knit are answered without asking the basis
-        basis, test = self.get_basis_and_test_knit()
-        key = ('foo',)
-        key_basis = ('bar',)
-        key_missing = ('missing',)
-        test.add_lines(key, (), [])
-        parent_map = test.get_parent_map([key])
-        self.assertEqual({key: ()}, parent_map)
-        self.assertEqual([], basis.calls)
-        # But parents that are not in the test knit are looked for in the basis
-        basis.add_lines(key_basis, (), [])
-        basis.calls = []
-        parent_map = test.get_parent_map([key, key_basis, key_missing])
-        self.assertEqual({key: (),
-            key_basis: ()}, parent_map)
-        self.assertEqual([("get_parent_map", set([key_basis, key_missing]))],
-            basis.calls)
-
-    def test_get_record_stream_unordered_fulltexts(self):
-        # records from the test knit are answered without asking the basis:
-        basis, test = self.get_basis_and_test_knit()
-        key = ('foo',)
-        key_basis = ('bar',)
-        key_missing = ('missing',)
-        test.add_lines(key, (), ['foo\n'])
-        records = list(test.get_record_stream([key], 'unordered', True))
-        self.assertEqual(1, len(records))
-        self.assertEqual([], basis.calls)
-        # Missing (from test knit) objects are retrieved from the basis:
-        basis.add_lines(key_basis, (), ['foo\n', 'bar\n'])
-        basis.calls = []
-        records = list(test.get_record_stream([key_basis, key_missing],
-            'unordered', True))
-        self.assertEqual(2, len(records))
-        calls = list(basis.calls)
-        for record in records:
-            self.assertSubset([record.key], (key_basis, key_missing))
-            if record.key == key_missing:
-                self.assertIsInstance(record, AbsentContentFactory)
-            else:
-                reference = list(basis.get_record_stream([key_basis],
-                    'unordered', True))[0]
-                self.assertEqual(reference.key, record.key)
-                self.assertEqual(reference.sha1, record.sha1)
-                self.assertEqual(reference.storage_kind, record.storage_kind)
-                self.assertEqual(reference.get_bytes_as(reference.storage_kind),
-                    record.get_bytes_as(record.storage_kind))
-                self.assertEqual(reference.get_bytes_as('fulltext'),
-                    record.get_bytes_as('fulltext'))
-        # It's not strictly minimal, but it seems reasonable for now for it to
-        # ask which fallbacks have which parents.
-        self.assertEqual([
-            ("get_parent_map", set([key_basis, key_missing])),
-            ("get_record_stream", [key_basis], 'unordered', True)],
-            calls)
-
-    def test_get_record_stream_ordered_fulltexts(self):
-        # ordering is preserved down into the fallback store.
-        basis, test = self.get_basis_and_test_knit()
-        key = ('foo',)
-        key_basis = ('bar',)
-        key_basis_2 = ('quux',)
-        key_missing = ('missing',)
-        test.add_lines(key, (key_basis,), ['foo\n'])
-        # Missing (from test knit) objects are retrieved from the basis:
-        basis.add_lines(key_basis, (key_basis_2,), ['foo\n', 'bar\n'])
-        basis.add_lines(key_basis_2, (), ['quux\n'])
-        basis.calls = []
-        # ask for in non-topological order
-        records = list(test.get_record_stream(
-            [key, key_basis, key_missing, key_basis_2], 'topological', True))
-        self.assertEqual(4, len(records))
-        results = []
-        for record in records:
-            self.assertSubset([record.key],
-                (key_basis, key_missing, key_basis_2, key))
-            if record.key == key_missing:
-                self.assertIsInstance(record, AbsentContentFactory)
-            else:
-                results.append((record.key, record.sha1, record.storage_kind,
-                    record.get_bytes_as('fulltext')))
-        calls = list(basis.calls)
-        order = [record[0] for record in results]
-        self.assertEqual([key_basis_2, key_basis, key], order)
-        for result in results:
-            if result[0] == key:
-                source = test
-            else:
-                source = basis
-            record = source.get_record_stream([result[0]], 'unordered',
-                True).next()
-            self.assertEqual(record.key, result[0])
-            self.assertEqual(record.sha1, result[1])
-            self.assertEqual(record.storage_kind, result[2])
-            self.assertEqual(record.get_bytes_as('fulltext'), result[3])
-        # It's not strictly minimal, but it seems reasonable for now for it to
-        # ask which fallbacks have which parents.
-        self.assertEqual([
-            ("get_parent_map", set([key_basis, key_basis_2, key_missing])),
-            # unordered is asked for by the underlying worker as it still
-            # buffers everything while answering - which is a problem!
-            ("get_record_stream", [key_basis_2, key_basis], 'unordered', True)],
-            calls)
-
-    def test_get_record_stream_unordered_deltas(self):
-        # records from the test knit are answered without asking the basis:
-        basis, test = self.get_basis_and_test_knit()
-        key = ('foo',)
-        key_basis = ('bar',)
-        key_missing = ('missing',)
-        test.add_lines(key, (), ['foo\n'])
-        records = list(test.get_record_stream([key], 'unordered', False))
-        self.assertEqual(1, len(records))
-        self.assertEqual([], basis.calls)
-        # Missing (from test knit) objects are retrieved from the basis:
-        basis.add_lines(key_basis, (), ['foo\n', 'bar\n'])
-        basis.calls = []
-        records = list(test.get_record_stream([key_basis, key_missing],
-            'unordered', False))
-        self.assertEqual(2, len(records))
-        calls = list(basis.calls)
-        for record in records:
-            self.assertSubset([record.key], (key_basis, key_missing))
-            if record.key == key_missing:
-                self.assertIsInstance(record, AbsentContentFactory)
-            else:
-                reference = list(basis.get_record_stream([key_basis],
-                    'unordered', False))[0]
-                self.assertEqual(reference.key, record.key)
-                self.assertEqual(reference.sha1, record.sha1)
-                self.assertEqual(reference.storage_kind, record.storage_kind)
-                self.assertEqual(reference.get_bytes_as(reference.storage_kind),
-                    record.get_bytes_as(record.storage_kind))
-        # It's not strictly minimal, but it seems reasonable for now for it to
-        # ask which fallbacks have which parents.
-        self.assertEqual([
-            ("get_parent_map", set([key_basis, key_missing])),
-            ("get_record_stream", [key_basis], 'unordered', False)],
-            calls)
-
-    def test_get_record_stream_ordered_deltas(self):
-        # ordering is preserved down into the fallback store.
-        basis, test = self.get_basis_and_test_knit()
-        key = ('foo',)
-        key_basis = ('bar',)
-        key_basis_2 = ('quux',)
-        key_missing = ('missing',)
-        test.add_lines(key, (key_basis,), ['foo\n'])
-        # Missing (from test knit) objects are retrieved from the basis:
-        basis.add_lines(key_basis, (key_basis_2,), ['foo\n', 'bar\n'])
-        basis.add_lines(key_basis_2, (), ['quux\n'])
-        basis.calls = []
-        # ask for in non-topological order
-        records = list(test.get_record_stream(
-            [key, key_basis, key_missing, key_basis_2], 'topological', False))
-        self.assertEqual(4, len(records))
-        results = []
-        for record in records:
-            self.assertSubset([record.key],
-                (key_basis, key_missing, key_basis_2, key))
-            if record.key == key_missing:
-                self.assertIsInstance(record, AbsentContentFactory)
-            else:
-                results.append((record.key, record.sha1, record.storage_kind,
-                    record.get_bytes_as(record.storage_kind)))
-        calls = list(basis.calls)
-        order = [record[0] for record in results]
-        self.assertEqual([key_basis_2, key_basis, key], order)
-        for result in results:
-            if result[0] == key:
-                source = test
-            else:
-                source = basis
-            record = source.get_record_stream([result[0]], 'unordered',
-                False).next()
-            self.assertEqual(record.key, result[0])
-            self.assertEqual(record.sha1, result[1])
-            self.assertEqual(record.storage_kind, result[2])
-            self.assertEqual(record.get_bytes_as(record.storage_kind), result[3])
-        # It's not strictly minimal, but it seems reasonable for now for it to
-        # ask which fallbacks have which parents.
-        self.assertEqual([
-            ("get_parent_map", set([key_basis, key_basis_2, key_missing])),
-            ("get_record_stream", [key_basis_2, key_basis], 'topological', False)],
-            calls)
-
-    def test_get_sha1s(self):
-        # sha1's in the test knit are answered without asking the basis
-        basis, test = self.get_basis_and_test_knit()
-        key = ('foo',)
-        key_basis = ('bar',)
-        key_missing = ('missing',)
-        test.add_lines(key, (), ['foo\n'])
-        key_sha1sum = sha.new('foo\n').hexdigest()
-        sha1s = test.get_sha1s([key])
-        self.assertEqual({key: key_sha1sum}, sha1s)
-        self.assertEqual([], basis.calls)
-        # But texts that are not in the test knit are looked for in the basis
-        # directly (rather than via text reconstruction) so that remote servers
-        # etc don't have to answer with full content.
-        basis.add_lines(key_basis, (), ['foo\n', 'bar\n'])
-        basis_sha1sum = sha.new('foo\nbar\n').hexdigest()
-        basis.calls = []
-        sha1s = test.get_sha1s([key, key_missing, key_basis])
-        self.assertEqual({key: key_sha1sum,
-            key_basis: basis_sha1sum}, sha1s)
-        self.assertEqual([("get_sha1s", set([key_basis, key_missing]))],
-            basis.calls)
-
-    def test_insert_record_stream(self):
-        # records are inserted as normal; insert_record_stream builds on
-        # add_lines, so a smoke test should be all that's needed:
-        key = ('foo',)
-        key_basis = ('bar',)
-        key_delta = ('zaphod',)
-        basis, test = self.get_basis_and_test_knit()
-        source = self.make_test_knit(name='source')
-        basis.add_lines(key_basis, (), ['foo\n'])
-        basis.calls = []
-        source.add_lines(key_basis, (), ['foo\n'])
-        source.add_lines(key_delta, (key_basis,), ['bar\n'])
-        stream = source.get_record_stream([key_delta], 'unordered', False)
-        test.insert_record_stream(stream)
-        self.assertEqual([("get_parent_map", set([key_basis]))],
-            basis.calls)
-        self.assertEqual({key_delta:(key_basis,)},
-            test.get_parent_map([key_delta]))
-        self.assertEqual('bar\n', test.get_record_stream([key_delta],
-            'unordered', True).next().get_bytes_as('fulltext'))
-
-    def test_iter_lines_added_or_present_in_keys(self):
-        # Lines from the basis are returned, and lines for a given key are only
-        # returned once. 
-        key1 = ('foo1',)
-        key2 = ('foo2',)
-        # all sources are asked for keys:
-        basis, test = self.get_basis_and_test_knit()
-        basis.add_lines(key1, (), ["foo"])
-        basis.calls = []
-        lines = list(test.iter_lines_added_or_present_in_keys([key1]))
-        self.assertEqual([("foo\n", key1)], lines)
-        self.assertEqual([("iter_lines_added_or_present_in_keys", set([key1]))],
-            basis.calls)
-        # keys in both are not duplicated:
-        test.add_lines(key2, (), ["bar\n"])
-        basis.add_lines(key2, (), ["bar\n"])
-        basis.calls = []
-        lines = list(test.iter_lines_added_or_present_in_keys([key2]))
-        self.assertEqual([("bar\n", key2)], lines)
-        self.assertEqual([], basis.calls)
-
-    def test_keys(self):
-        key1 = ('foo1',)
-        key2 = ('foo2',)
-        # all sources are asked for keys:
-        basis, test = self.get_basis_and_test_knit()
-        keys = test.keys()
-        self.assertEqual(set(), set(keys))
-        self.assertEqual([("keys",)], basis.calls)
-        # keys from a basis are returned:
-        basis.add_lines(key1, (), [])
-        basis.calls = []
-        keys = test.keys()
-        self.assertEqual(set([key1]), set(keys))
-        self.assertEqual([("keys",)], basis.calls)
-        # keys in both are not duplicated:
-        test.add_lines(key2, (), [])
-        basis.add_lines(key2, (), [])
-        basis.calls = []
-        keys = test.keys()
-        self.assertEqual(2, len(keys))
-        self.assertEqual(set([key1, key2]), set(keys))
-        self.assertEqual([("keys",)], basis.calls)
-
-    def test_add_mpdiffs(self):
-        # records are inserted as normal; add_mpdiff builds on
-        # add_lines, so a smoke test should be all that's needed:
-        key = ('foo',)
-        key_basis = ('bar',)
-        key_delta = ('zaphod',)
-        basis, test = self.get_basis_and_test_knit()
-        source = self.make_test_knit(name='source')
-        basis.add_lines(key_basis, (), ['foo\n'])
-        basis.calls = []
-        source.add_lines(key_basis, (), ['foo\n'])
-        source.add_lines(key_delta, (key_basis,), ['bar\n'])
-        diffs = source.make_mpdiffs([key_delta])
-        test.add_mpdiffs([(key_delta, (key_basis,),
-            source.get_sha1s([key_delta])[key_delta], diffs[0])])
-        self.assertEqual([("get_parent_map", set([key_basis])),
-            ('get_record_stream', [key_basis], 'unordered', True),
-            ('get_parent_map', set([key_basis]))],
-            basis.calls)
-        self.assertEqual({key_delta:(key_basis,)},
-            test.get_parent_map([key_delta]))
-        self.assertEqual('bar\n', test.get_record_stream([key_delta],
-            'unordered', True).next().get_bytes_as('fulltext'))
-
-    def test_make_mpdiffs(self):
-        # Generating an mpdiff across a stacking boundary should detect parent
-        # texts regions.
-        key = ('foo',)
-        key_left = ('bar',)
-        key_right = ('zaphod',)
-        basis, test = self.get_basis_and_test_knit()
-        basis.add_lines(key_left, (), ['bar\n'])
-        basis.add_lines(key_right, (), ['zaphod\n'])
-        basis.calls = []
-        test.add_lines(key, (key_left, key_right),
-            ['bar\n', 'foo\n', 'zaphod\n'])
-        diffs = test.make_mpdiffs([key])
-        self.assertEqual([
-            multiparent.MultiParent([multiparent.ParentText(0, 0, 0, 1),
-                multiparent.NewText(['foo\n']),
-                multiparent.ParentText(1, 0, 2, 1)])],
-            diffs)
-        self.assertEqual(4, len(basis.calls))
-        self.assertEqual([
-            ("get_parent_map", set([key_left, key_right])),
-            ("get_parent_map", set([key_left, key_right])),
-            ("get_parent_map", set([key_left, key_right])),
-            ],
-            basis.calls[:3])
-        last_call = basis.calls[3]
-        self.assertEqual('get_record_stream', last_call[0])
-        self.assertEqual(set([key_left, key_right]), set(last_call[1]))
-        self.assertEqual('unordered', last_call[2])
-        self.assertEqual(True, last_call[3])
+    def test_iter_parents(self):
+        index = self.two_graph_index()
+        self.assertEqual(set([
+            ('tip', ()), ('tail', ()), ('parent', ()), ('separate', ())
+            ]),
+            set(index.iter_parents(['tip', 'tail', 'ghost', 'parent', 'separate'])))
+        self.assertEqual(set([('tip', ())]),
+            set(index.iter_parents(['tip'])))
+        self.assertEqual(set(),
+            set(index.iter_parents([])))

=== modified file 'bzrlib/tests/test_lazy_import.py'
--- bzrlib/tests/test_lazy_import.py	2008-03-24 14:39:02 +0000
+++ bzrlib/tests/test_lazy_import.py	2007-04-12 21:33:07 +0000
@@ -150,41 +150,6 @@
                           ('foo', 2),
                          ], actions)
 
-    def test_setattr_replaces(self):
-        """ScopeReplacer can create an instance in local scope.
-
-        An object should appear in globals() by constructing a ScopeReplacer,
-        and it will be replaced with the real object upon the first request.
-        """
-        actions = []
-        TestClass.use_actions(actions)
-        def factory(replacer, scope, name):
-            return TestClass()
-        try:
-            test_obj6
-        except NameError:
-            # test_obj6 shouldn't exist yet
-            pass
-        else:
-            self.fail('test_obj6 was not supposed to exist yet')
-
-        orig_globals = set(globals().keys())
-
-        lazy_import.ScopeReplacer(scope=globals(), name='test_obj6',
-                                  factory=factory)
-
-        new_globals = set(globals().keys())
-
-        # We can't use isinstance() because that uses test_obj6.__class__
-        # and that goes through __getattribute__ which would activate
-        # the replacement
-        self.assertEqual(lazy_import.ScopeReplacer,
-                         object.__getattribute__(test_obj6, '__class__'))
-        test_obj6.bar = 'test'
-        self.assertNotEqual(lazy_import.ScopeReplacer,
-                            object.__getattribute__(test_obj6, '__class__'))
-        self.assertEqual('test', test_obj6.bar)
-
     def test_replace_side_effects(self):
         """Creating a new object should only create one entry in globals.
 

=== modified file 'bzrlib/tests/test_lockable_files.py'
--- bzrlib/tests/test_lockable_files.py	2008-06-05 06:49:44 +0000
+++ bzrlib/tests/test_lockable_files.py	2007-04-19 14:55:20 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2008 Canonical Ltd
+# Copyright (C) 2005, 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -17,20 +17,12 @@
 from StringIO import StringIO
 
 import bzrlib
-from bzrlib import (
-    errors,
-    lockdir,
-    osutils,
-    )
+import bzrlib.errors as errors
 from bzrlib.errors import BzrBadParameterNotString, NoSuchFile, ReadOnlyError
 from bzrlib.lockable_files import LockableFiles, TransportLock
-from bzrlib.symbol_versioning import (
-    deprecated_in,
-    )
-from bzrlib.tests import (
-    TestCaseInTempDir,
-    TestNotApplicable,
-    )
+from bzrlib import lockdir
+from bzrlib.lockdir import LockDir
+from bzrlib.tests import TestCaseInTempDir
 from bzrlib.tests.test_smart import TestCaseWithSmartMedium
 from bzrlib.tests.test_transactions import DummyWeave
 from bzrlib.transactions import (PassThroughTransaction,
@@ -41,84 +33,44 @@
 
 
 # these tests are applied in each parameterized suite for LockableFiles
-#
-# they use an old style of parameterization, but we want to remove this class
-# so won't modernize them now. - mbp 20080430
 class _TestLockableFiles_mixin(object):
 
     def test_read_write(self):
-        self.assertRaises(NoSuchFile,
-            self.applyDeprecated,
-            deprecated_in((1, 5, 0)),
-            self.lockable.get, 'foo')
-        self.assertRaises(NoSuchFile,
-            self.applyDeprecated,
-            deprecated_in((1, 5, 0)),
-            self.lockable.get_utf8, 'foo')
+        self.assertRaises(NoSuchFile, self.lockable.get, 'foo')
+        self.assertRaises(NoSuchFile, self.lockable.get_utf8, 'foo')
         self.lockable.lock_write()
         try:
             unicode_string = u'bar\u1234'
             self.assertEqual(4, len(unicode_string))
             byte_string = unicode_string.encode('utf-8')
             self.assertEqual(6, len(byte_string))
-            self.assertRaises(UnicodeEncodeError,
-                self.applyDeprecated,
-                deprecated_in((1, 6, 0)),
-                self.lockable.put, 'foo',
-                StringIO(unicode_string))
-            self.applyDeprecated(
-                deprecated_in((1, 6, 0)),
-                self.lockable.put,
-                'foo', StringIO(byte_string))
-            byte_stream = self.applyDeprecated(
-                deprecated_in((1, 5, 0)),
-                self.lockable.get,
-                'foo')
-            self.assertEqual(byte_string, byte_stream.read())
-            unicode_stream = self.applyDeprecated(
-                deprecated_in((1, 5, 0)),
-                self.lockable.get_utf8,
-                'foo')
+            self.assertRaises(UnicodeEncodeError, self.lockable.put, 'foo',
+                              StringIO(unicode_string))
+            self.lockable.put('foo', StringIO(byte_string))
+            self.assertEqual(byte_string,
+                             self.lockable.get('foo').read())
             self.assertEqual(unicode_string,
-                unicode_stream.read())
+                             self.lockable.get_utf8('foo').read())
             self.assertRaises(BzrBadParameterNotString,
-                self.applyDeprecated,
-                deprecated_in((1, 6, 0)),
-                self.lockable.put_utf8,
-                'bar',
-                StringIO(unicode_string))
-            self.applyDeprecated(
-                deprecated_in((1, 6, 0)),
-                self.lockable.put_utf8,
-                'bar',
-                unicode_string)
-            unicode_stream = self.applyDeprecated(
-                deprecated_in((1, 5, 0)),
-                self.lockable.get_utf8,
-                'bar')
+                              self.lockable.put_utf8,
+                              'bar',
+                              StringIO(unicode_string)
+                              )
+            self.lockable.put_utf8('bar', unicode_string)
             self.assertEqual(unicode_string,
-                unicode_stream.read())
-            byte_stream = self.applyDeprecated(
-                deprecated_in((1, 5, 0)),
-                self.lockable.get,
-                'bar')
-            self.assertEqual(byte_string, byte_stream.read())
-            self.applyDeprecated(
-                deprecated_in((1, 6, 0)),
-                self.lockable.put_bytes,
-                'raw', 'raw\xffbytes')
-            byte_stream = self.applyDeprecated(
-                deprecated_in((1, 5, 0)),
-                self.lockable.get,
-                'raw')
-            self.assertEqual('raw\xffbytes', byte_stream.read())
+                             self.lockable.get_utf8('bar').read())
+            self.assertEqual(byte_string,
+                             self.lockable.get('bar').read())
+            self.lockable.put_bytes('raw', 'raw\xffbytes')
+            self.assertEqual('raw\xffbytes',
+                             self.lockable.get('raw').read())
         finally:
             self.lockable.unlock()
 
     def test_locks(self):
         self.lockable.lock_read()
         try:
-            self.assertRaises(ReadOnlyError, self.lockable.put, 'foo',
+            self.assertRaises(ReadOnlyError, self.lockable.put, 'foo', 
                               StringIO('bar\u1234'))
         finally:
             self.lockable.unlock()
@@ -157,7 +109,7 @@
         except NotImplementedError:
             # this lock cannot be broken
             self.lockable.unlock()
-            raise TestNotApplicable("%r is not breakable" % (self.lockable,))
+            return
         l2 = self.get_lockable()
         orig_factory = bzrlib.ui.ui_factory
         # silent ui - no need for stdout
@@ -180,7 +132,7 @@
             if token is not None:
                 # This test does not apply, because this lockable supports
                 # tokens.
-                raise TestNotApplicable("%r uses tokens" % (self.lockable,))
+                return
             self.assertRaises(errors.TokenLockingNotSupported,
                               self.lockable.lock_write, token='token')
         finally:
@@ -374,10 +326,7 @@
         super(TestLockableFiles_TransportLock, self).tearDown()
         # free the subtransport so that we do not get a 5 second
         # timeout due to the SFTP connection cache.
-        try:
-            del self.sub_transport
-        except AttributeError:
-            pass
+        del self.sub_transport
 
     def get_lockable(self):
         return LockableFiles(self.sub_transport, 'my-lock', TransportLock)
@@ -398,7 +347,7 @@
         self.lockable.create_lock()
 
     def get_lockable(self):
-        return LockableFiles(self.transport, 'my-lock', lockdir.LockDir)
+        return LockableFiles(self.transport, 'my-lock', LockDir)
 
     def test_lock_created(self):
         self.assertTrue(self.transport.has('my-lock'))
@@ -408,16 +357,10 @@
         self.assertFalse(self.transport.has('my-lock/held/info'))
         self.assertTrue(self.transport.has('my-lock'))
 
-    def test__file_modes(self):
-        self.transport.mkdir('readonly')
-        osutils.make_readonly('readonly')
-        lockable = LockableFiles(self.transport.clone('readonly'), 'test-lock',
-                                 lockdir.LockDir)
-        # The directory mode should be read-write-execute for the current user
-        self.assertEqual(00700, lockable._dir_mode & 00700)
-        # Files should be read-write for the current user
-        self.assertEqual(00600, lockable._file_mode & 00700)
 
+    # TODO: Test the lockdir inherits the right file and directory permissions
+    # from the LockableFiles.
+        
 
 class TestLockableFiles_RemoteLockDir(TestCaseWithSmartMedium,
                               _TestLockableFiles_mixin):

=== modified file 'bzrlib/tests/test_lockdir.py'
--- bzrlib/tests/test_lockdir.py	2008-06-17 04:07:49 +0000
+++ bzrlib/tests/test_lockdir.py	2007-10-05 04:47:09 +0000
@@ -190,13 +190,9 @@
             lf1.unlock()
         lock_base = lf2.transport.abspath(lf2.path)
         self.assertEqual(1, len(self._logged_reports))
-        lock_url = lf2.transport.abspath(lf2.path)
         self.assertEqual('%s %s\n'
                          '%s\n%s\n'
-                         'Will continue to try until %s, unless '
-                         'you press Ctrl-C\n'
-                         'If you\'re sure that it\'s not being '
-                         'modified, use bzr break-lock %s',
+                         'Will continue to try until %s\n',
                          self._logged_reports[0][0])
         args = self._logged_reports[0][1]
         self.assertEqual('Unable to obtain', args[0])
@@ -337,9 +333,6 @@
            unlocks the lockdir, allowing Lock2 to acquire the lock.
         """
 
-        raise tests.KnownFailure(
-            "timing dependency in lock tests (#213182)")
-
         wait_to_check_lock = Lock()
         wait_until_checked_lock = Lock()
 
@@ -413,13 +406,10 @@
         # There should be 2 reports, because the lock changed
         lock_base = lf2.transport.abspath(lf2.path)
         self.assertEqual(2, len(self._logged_reports))
-        lock_url = lf2.transport.abspath(lf2.path)
+
         self.assertEqual('%s %s\n'
                          '%s\n%s\n'
-                         'Will continue to try until %s, unless '
-                         'you press Ctrl-C\n'
-                         'If you\'re sure that it\'s not being '
-                         'modified, use bzr break-lock %s',
+                         'Will continue to try until %s\n',
                          self._logged_reports[0][0])
         args = self._logged_reports[0][1]
         self.assertEqual('Unable to obtain', args[0])
@@ -431,10 +421,7 @@
 
         self.assertEqual('%s %s\n'
                          '%s\n%s\n'
-                         'Will continue to try until %s, unless '
-                         'you press Ctrl-C\n'
-                         'If you\'re sure that it\'s not being '
-                         'modified, use bzr break-lock %s',
+                         'Will continue to try until %s\n',
                          self._logged_reports[1][0])
         args = self._logged_reports[1][1]
         self.assertEqual('Lock owner changed for', args[0])

=== modified file 'bzrlib/tests/test_log.py'
--- bzrlib/tests/test_log.py	2008-08-21 04:12:02 +0000
+++ bzrlib/tests/test_log.py	2007-10-16 16:02:01 +0000
@@ -17,7 +17,7 @@
 import os
 from cStringIO import StringIO
 
-from bzrlib import log, registry
+from bzrlib import log
 from bzrlib.tests import TestCase, TestCaseWithTransport
 from bzrlib.log import (show_log,
                         get_view_revisions,
@@ -27,32 +27,8 @@
                         ShortLogFormatter,
                         LineLogFormatter)
 from bzrlib.branch import Branch
-from bzrlib.errors import (
-    BzrCommandError,
-    InvalidRevisionNumber,
-    )
+from bzrlib.errors import InvalidRevisionNumber
 from bzrlib.revision import Revision
-from bzrlib.revisionspec import (
-    RevisionInfo,
-    RevisionSpec,
-    )
-
-
-class TestCaseWithoutPropsHandler(TestCaseWithTransport):
-
-    def setUp(self):
-        super(TestCaseWithoutPropsHandler, self).setUp()
-        # keep a reference to the "current" custom prop. handler registry
-        self.properties_handler_registry = \
-            log.properties_handler_registry
-        # clean up the registry in log
-        log.properties_handler_registry = registry.Registry()
-        
-    def _cleanup(self):
-        super(TestCaseWithoutPropsHandler, self)._cleanup()
-        # restore the custom properties handler registry
-        log.properties_handler_registry = \
-            self.properties_handler_registry
 
 
 class LogCatcher(LogFormatter):
@@ -218,35 +194,6 @@
         d = logentry.delta
         self.checkDelta(d, added=['file1', 'file2'])
 
-    def test_merges_nonsupporting_formatter(self):
-        """Tests that show_log will raise if the formatter doesn't
-        support merge revisions."""
-        wt = self.make_branch_and_memory_tree('.')
-        wt.lock_write()
-        try:
-            wt.add('')
-            wt.commit('rev-1', rev_id='rev-1',
-                      timestamp=1132586655, timezone=36000,
-                      committer='Joe Foo <joe@foo.com>')
-            wt.commit('rev-merged', rev_id='rev-2a',
-                      timestamp=1132586700, timezone=36000,
-                      committer='Joe Foo <joe@foo.com>')
-            wt.set_parent_ids(['rev-1', 'rev-2a'])
-            wt.branch.set_last_revision_info(1, 'rev-1')
-            wt.commit('rev-2', rev_id='rev-2b',
-                      timestamp=1132586800, timezone=36000,
-                      committer='Joe Foo <joe@foo.com>')
-            logfile = self.make_utf8_encoded_stringio()
-            formatter = ShortLogFormatter(to_file=logfile)
-            wtb = wt.branch
-            lf = LogCatcher()
-            revspec = RevisionSpec.from_string('1.1.1')
-            rev = revspec.in_history(wtb)
-            self.assertRaises(BzrCommandError, show_log, wtb, lf,
-                              start_revision=rev, end_revision=rev)
-        finally:
-            wt.unlock()
-
 
 def make_commits_with_trailing_newlines(wt):
     """Helper method for LogFormatter tests"""    
@@ -272,23 +219,6 @@
     return b
 
 
-def normalize_log(log):
-    """Replaces the variable lines of logs with fixed lines"""
-    author = 'author: Dolor Sit <test@example.com>'
-    committer = 'committer: Lorem Ipsum <test@example.com>'
-    lines = log.splitlines(True)
-    for idx,line in enumerate(lines):
-        stripped_line = line.lstrip()
-        indent = ' ' * (len(line) - len(stripped_line))
-        if stripped_line.startswith('author:'):
-            lines[idx] = indent + author + '\n'
-        elif stripped_line.startswith('committer:'):
-            lines[idx] = indent + committer + '\n'
-        elif stripped_line.startswith('timestamp:'):
-            lines[idx] = indent + 'timestamp: Just now\n'
-    return ''.join(lines)
-
-
 class TestShortLogFormatter(TestCaseWithTransport):
 
     def test_trailing_newlines(self):
@@ -297,7 +227,7 @@
         sio = self.make_utf8_encoded_stringio()
         lf = ShortLogFormatter(to_file=sio)
         show_log(b, lf)
-        self.assertEqualDiff(sio.getvalue(), """\
+        self.assertEquals(sio.getvalue(), """\
     3 Joe Foo\t2005-11-21
       single line with trailing newline
 
@@ -311,68 +241,24 @@
 
 """)
 
-    def test_short_log_with_merges(self):
-        wt = self.make_branch_and_memory_tree('.')
-        wt.lock_write()
-        try:
-            wt.add('')
-            wt.commit('rev-1', rev_id='rev-1',
-                      timestamp=1132586655, timezone=36000,
-                      committer='Joe Foo <joe@foo.com>')
-            wt.commit('rev-merged', rev_id='rev-2a',
-                      timestamp=1132586700, timezone=36000,
-                      committer='Joe Foo <joe@foo.com>')
-            wt.set_parent_ids(['rev-1', 'rev-2a'])
-            wt.branch.set_last_revision_info(1, 'rev-1')
-            wt.commit('rev-2', rev_id='rev-2b',
-                      timestamp=1132586800, timezone=36000,
-                      committer='Joe Foo <joe@foo.com>')
-            logfile = self.make_utf8_encoded_stringio()
-            formatter = ShortLogFormatter(to_file=logfile)
-            show_log(wt.branch, formatter)
-            self.assertEqualDiff(logfile.getvalue(), """\
-    2 Joe Foo\t2005-11-22 [merge]
-      rev-2
-
-    1 Joe Foo\t2005-11-22
-      rev-1
-
-""")
-        finally:
-            wt.unlock()
-
-    def test_short_log_single_merge_revision(self):
-        wt = self.make_branch_and_memory_tree('.')
-        wt.lock_write()
-        try:
-            wt.add('')
-            wt.commit('rev-1', rev_id='rev-1',
-                      timestamp=1132586655, timezone=36000,
-                      committer='Joe Foo <joe@foo.com>')
-            wt.commit('rev-merged', rev_id='rev-2a',
-                      timestamp=1132586700, timezone=36000,
-                      committer='Joe Foo <joe@foo.com>')
-            wt.set_parent_ids(['rev-1', 'rev-2a'])
-            wt.branch.set_last_revision_info(1, 'rev-1')
-            wt.commit('rev-2', rev_id='rev-2b',
-                      timestamp=1132586800, timezone=36000,
-                      committer='Joe Foo <joe@foo.com>')
-            logfile = self.make_utf8_encoded_stringio()
-            formatter = ShortLogFormatter(to_file=logfile)
-            revspec = RevisionSpec.from_string('1.1.1')
-            wtb = wt.branch
-            rev = revspec.in_history(wtb)
-            show_log(wtb, formatter, start_revision=rev, end_revision=rev)
-            self.assertEqualDiff(logfile.getvalue(), """\
-1.1.1 Joe Foo\t2005-11-22
-      rev-merged
-
-""")
-        finally:
-            wt.unlock()
-
-
-class TestLongLogFormatter(TestCaseWithoutPropsHandler):
+
+class TestLongLogFormatter(TestCaseWithTransport):
+
+    def normalize_log(self,log):
+        """Replaces the variable lines of logs with fixed lines"""
+        author = 'author: Dolor Sit <test@example.com>'
+        committer = 'committer: Lorem Ipsum <test@example.com>'
+        lines = log.splitlines(True)
+        for idx,line in enumerate(lines):
+            stripped_line = line.lstrip()
+            indent = ' ' * (len(line) - len(stripped_line))
+            if stripped_line.startswith('author:'):
+                lines[idx] = indent + author + '\n'
+            elif stripped_line.startswith('committer:'):
+                lines[idx] = indent + committer + '\n'
+            elif stripped_line.startswith('timestamp:'):
+                lines[idx] = indent + 'timestamp: Just now\n'
+        return ''.join(lines)
 
     def test_verbose_log(self):
         """Verbose log includes changed files
@@ -425,8 +311,8 @@
         sio = self.make_utf8_encoded_stringio()
         lf = LongLogFormatter(to_file=sio)
         show_log(b, lf, verbose=True)
-        log = normalize_log(sio.getvalue())
-        self.assertEqualDiff(log, """\
+        log = self.normalize_log(sio.getvalue())
+        self.assertEqualDiff("""\
 ------------------------------------------------------------
 revno: 2
 committer: Lorem Ipsum <test@example.com>
@@ -442,7 +328,7 @@
     message:
       merge branch 2
         ------------------------------------------------------------
-        revno: 1.2.1
+        revno: 1.1.1.1.1
         committer: Lorem Ipsum <test@example.com>
         branch nick: smallerchild
         timestamp: Just now
@@ -462,7 +348,7 @@
 timestamp: Just now
 message:
   first post
-""")
+""", log)
 
     def test_verbose_merge_revisions_contain_deltas(self):
         wt = self.make_branch_and_tree('parent')
@@ -481,8 +367,8 @@
         sio = self.make_utf8_encoded_stringio()
         lf = LongLogFormatter(to_file=sio)
         show_log(b, lf, verbose=True)
-        log = normalize_log(sio.getvalue())
-        self.assertEqualDiff(log, """\
+        log = self.normalize_log(sio.getvalue())
+        self.assertEqualDiff("""\
 ------------------------------------------------------------
 revno: 2
 committer: Lorem Ipsum <test@example.com>
@@ -515,7 +401,7 @@
 added:
   f1
   f2
-""")
+""", log)
 
     def test_trailing_newlines(self):
         wt = self.make_branch_and_tree('.')
@@ -578,106 +464,6 @@
   add a
 ''')
 
-    def test_properties_in_log(self):
-        """Log includes the custom properties returned by the registered 
-        handlers.
-        """
-        wt = self.make_branch_and_tree('.')
-        b = wt.branch
-        self.build_tree(['a'])
-        wt.add('a')
-        b.nick = 'test_properties_in_log'
-        wt.commit(message='add a',
-                  timestamp=1132711707,
-                  timezone=36000,
-                  committer='Lorem Ipsum <test@example.com>',
-                  author='John Doe <jdoe@example.com>')
-        sio = StringIO()
-        formatter = LongLogFormatter(to_file=sio)
-        try:
-            def trivial_custom_prop_handler(revision):
-                return {'test_prop':'test_value'}
-            
-            log.properties_handler_registry.register(
-                'trivial_custom_prop_handler', 
-                trivial_custom_prop_handler)
-            show_log(b, formatter)
-        finally:
-            log.properties_handler_registry.remove(
-                'trivial_custom_prop_handler')
-            self.assertEqualDiff(sio.getvalue(), '''\
-------------------------------------------------------------
-revno: 1
-test_prop: test_value
-author: John Doe <jdoe@example.com>
-committer: Lorem Ipsum <test@example.com>
-branch nick: test_properties_in_log
-timestamp: Wed 2005-11-23 12:08:27 +1000
-message:
-  add a
-''')
-
-    def test_error_in_properties_handler(self):
-        """Log includes the custom properties returned by the registered 
-        handlers.
-        """
-        wt = self.make_branch_and_tree('.')
-        b = wt.branch
-        self.build_tree(['a'])
-        wt.add('a')
-        b.nick = 'test_author_log'
-        wt.commit(message='add a',
-                  timestamp=1132711707,
-                  timezone=36000,
-                  committer='Lorem Ipsum <test@example.com>',
-                  author='John Doe <jdoe@example.com>',
-                  revprops={'first_prop':'first_value'})
-        sio = StringIO()
-        formatter = LongLogFormatter(to_file=sio)
-        try:
-            def trivial_custom_prop_handler(revision):
-                raise StandardError("a test error")
-            
-            log.properties_handler_registry.register(
-                'trivial_custom_prop_handler', 
-                trivial_custom_prop_handler)
-            self.assertRaises(StandardError, show_log, b, formatter,)
-        finally:
-            log.properties_handler_registry.remove(
-                'trivial_custom_prop_handler')
-                
-    def test_properties_handler_bad_argument(self):
-        wt = self.make_branch_and_tree('.')
-        b = wt.branch
-        self.build_tree(['a'])
-        wt.add('a')
-        b.nick = 'test_author_log'
-        wt.commit(message='add a',
-                  timestamp=1132711707,
-                  timezone=36000,
-                  committer='Lorem Ipsum <test@example.com>',
-                  author='John Doe <jdoe@example.com>',
-                  revprops={'a_prop':'test_value'})
-        sio = StringIO()
-        formatter = LongLogFormatter(to_file=sio)
-        try:
-            def bad_argument_prop_handler(revision):
-                return {'custom_prop_name':revision.properties['a_prop']}
-                
-            log.properties_handler_registry.register(
-                'bad_argument_prop_handler', 
-                bad_argument_prop_handler)
-            
-            self.assertRaises(AttributeError, formatter.show_properties, 
-                'a revision', '')
-            
-            revision = b.repository.get_revision(b.last_revision())
-            formatter.show_properties(revision, '')
-            self.assertEqualDiff(sio.getvalue(),
-                '''custom_prop_name: test_value\n''')
-        finally:
-            log.properties_handler_registry.remove(
-                'bad_argument_prop_handler')
 
 
 class TestLineLogFormatter(TestCaseWithTransport):
@@ -692,8 +478,8 @@
         self.build_tree(['a'])
         wt.add('a')
         b.nick = 'test-line-log'
-        wt.commit(message='add a',
-                  timestamp=1132711707,
+        wt.commit(message='add a', 
+                  timestamp=1132711707, 
                   timezone=36000,
                   committer='Line-Log-Formatter Tester <test@line.log>')
         logfile = file('out.tmp', 'w+')
@@ -702,8 +488,38 @@
         logfile.flush()
         logfile.seek(0)
         log_contents = logfile.read()
-        self.assertEqualDiff(log_contents,
-            '1: Line-Log-Formatte... 2005-11-23 add a\n')
+        self.assertEqualDiff(log_contents, '1: Line-Log-Formatte... 2005-11-23 add a\n')
+
+    def test_short_log_with_merges(self):
+        wt = self.make_branch_and_memory_tree('.')
+        wt.lock_write()
+        try:
+            wt.add('')
+            wt.commit('rev-1', rev_id='rev-1',
+                      timestamp=1132586655, timezone=36000,
+                      committer='Joe Foo <joe@foo.com>')
+            wt.commit('rev-merged', rev_id='rev-2a',
+                      timestamp=1132586700, timezone=36000,
+                      committer='Joe Foo <joe@foo.com>')
+            wt.set_parent_ids(['rev-1', 'rev-2a'])
+            wt.branch.set_last_revision_info(1, 'rev-1')
+            wt.commit('rev-2', rev_id='rev-2b',
+                      timestamp=1132586800, timezone=36000,
+                      committer='Joe Foo <joe@foo.com>')
+            logfile = self.make_utf8_encoded_stringio()
+            formatter = ShortLogFormatter(to_file=logfile)
+            show_log(wt.branch, formatter)
+            logfile.flush()
+            self.assertEqualDiff("""\
+    2 Joe Foo\t2005-11-22 [merge]
+      rev-2
+
+    1 Joe Foo\t2005-11-22
+      rev-1
+
+""", logfile.getvalue())
+        finally:
+            wt.unlock()
 
     def test_trailing_newlines(self):
         wt = self.make_branch_and_tree('.')
@@ -717,35 +533,6 @@
 1: Joe Foo 2005-11-21 simple log message
 """)
 
-    def test_line_log_single_merge_revision(self):
-        wt = self.make_branch_and_memory_tree('.')
-        wt.lock_write()
-        try:
-            wt.add('')
-            wt.commit('rev-1', rev_id='rev-1',
-                      timestamp=1132586655, timezone=36000,
-                      committer='Joe Foo <joe@foo.com>')
-            wt.commit('rev-merged', rev_id='rev-2a',
-                      timestamp=1132586700, timezone=36000,
-                      committer='Joe Foo <joe@foo.com>')
-            wt.set_parent_ids(['rev-1', 'rev-2a'])
-            wt.branch.set_last_revision_info(1, 'rev-1')
-            wt.commit('rev-2', rev_id='rev-2b',
-                      timestamp=1132586800, timezone=36000,
-                      committer='Joe Foo <joe@foo.com>')
-            logfile = self.make_utf8_encoded_stringio()
-            formatter = LineLogFormatter(to_file=logfile)
-            revspec = RevisionSpec.from_string('1.1.1')
-            wtb = wt.branch
-            rev = revspec.in_history(wtb)
-            show_log(wtb, formatter, start_revision=rev, end_revision=rev)
-            self.assertEqualDiff(logfile.getvalue(), """\
-1.1.1: Joe Foo 2005-11-22 rev-merged
-""")
-        finally:
-            wt.unlock()
-
-
 
 class TestGetViewRevisions(TestCaseWithTransport):
 
@@ -791,10 +578,10 @@
         full_rev_nos_for_reference = {
             '1': '1',
             '2': '2',
-            '3a': '2.1.1', #first commit tree 3
-            '3b': '2.2.1', # first commit tree 2
+            '3a': '2.2.1', #first commit tree 3
+            '3b': '2.1.1', # first commit tree 2
             '3c': '3', #merges 3b to main
-            '4a': '2.2.2', # second commit tree 2
+            '4a': '2.1.2', # second commit tree 2
             '4b': '4', # merges 4a to main
             }
         return mainline_revs, rev_nos, wt
@@ -802,8 +589,6 @@
     def test_get_view_revisions_forward(self):
         """Test the get_view_revisions method"""
         mainline_revs, rev_nos, wt = self.make_tree_with_commits()
-        wt.lock_read()
-        self.addCleanup(wt.unlock)
         revisions = list(get_view_revisions(mainline_revs, rev_nos, wt.branch,
                                             'forward'))
         self.assertEqual([('1', '1', 0), ('2', '2', 0), ('3', '3', 0)],
@@ -815,8 +600,6 @@
     def test_get_view_revisions_reverse(self):
         """Test the get_view_revisions with reverse"""
         mainline_revs, rev_nos, wt = self.make_tree_with_commits()
-        wt.lock_read()
-        self.addCleanup(wt.unlock)
         revisions = list(get_view_revisions(mainline_revs, rev_nos, wt.branch,
                                             'reverse'))
         self.assertEqual([('3', '3', 0), ('2', '2', 0), ('1', '1', 0), ],
@@ -828,8 +611,6 @@
     def test_get_view_revisions_merge(self):
         """Test get_view_revisions when there are merges"""
         mainline_revs, rev_nos, wt = self.make_tree_with_merges()
-        wt.lock_read()
-        self.addCleanup(wt.unlock)
         revisions = list(get_view_revisions(mainline_revs, rev_nos, wt.branch,
                                             'forward'))
         self.assertEqual([('1', '1', 0), ('2', '2', 0), ('3', '3', 0),
@@ -844,8 +625,6 @@
     def test_get_view_revisions_merge_reverse(self):
         """Test get_view_revisions in reverse when there are merges"""
         mainline_revs, rev_nos, wt = self.make_tree_with_merges()
-        wt.lock_read()
-        self.addCleanup(wt.unlock)
         revisions = list(get_view_revisions(mainline_revs, rev_nos, wt.branch,
                                             'reverse'))
         self.assertEqual([('4b', '4', 0), ('4a', '3.1.1', 1),
@@ -860,13 +639,11 @@
     def test_get_view_revisions_merge2(self):
         """Test get_view_revisions when there are merges"""
         mainline_revs, rev_nos, wt = self.make_tree_with_many_merges()
-        wt.lock_read()
-        self.addCleanup(wt.unlock)
         revisions = list(get_view_revisions(mainline_revs, rev_nos, wt.branch,
                                             'forward'))
         expected = [('1', '1', 0), ('2', '2', 0), ('3c', '3', 0),
-            ('3a', '2.1.1', 1), ('3b', '2.2.1', 1), ('4b', '4', 0),
-            ('4a', '2.2.2', 1)]
+            ('3a', '2.2.1', 1), ('3b', '2.1.1', 1), ('4b', '4', 0),
+            ('4a', '2.1.2', 1)]
         self.assertEqual(expected, revisions)
         revisions = list(get_view_revisions(mainline_revs, rev_nos, wt.branch,
                                              'forward', include_merges=False))
@@ -1008,20 +785,6 @@
         # f3 should be marked as modified by revisions A, B, C, and D
         self.assertAllRevisionsForFileID(tree, 'f2-id', ['D', 'C', 'A'])
 
-    def test_file_id_with_ghosts(self):
-        # This is testing bug #209948, where having a ghost would cause
-        # _filter_revisions_touching_file_id() to fail.
-        tree = self.create_tree_with_single_merge()
-        # We need to add a revision, so switch back to a write-locked tree
-        tree.unlock()
-        tree.lock_write()
-        first_parent = tree.last_revision()
-        tree.set_parent_ids([first_parent, 'ghost-revision-id'])
-        self.build_tree_contents([('tree/f1', 'A\nB\nXX\n')])
-        tree.commit('commit with a ghost', rev_id='XX')
-        self.assertAllRevisionsForFileID(tree, 'f1-id', ['XX', 'B', 'A'])
-        self.assertAllRevisionsForFileID(tree, 'f2-id', ['D', 'C', 'A'])
-
 
 class TestShowChangedRevisions(TestCaseWithTransport):
 
@@ -1043,16 +806,6 @@
         rev.committer = 'John Doe <jdoe@example.com>'
         lf = LogFormatter(None)
         self.assertEqual('John Doe', lf.short_committer(rev))
-        rev.committer = 'John Smith <jsmith@example.com>'
-        self.assertEqual('John Smith', lf.short_committer(rev))
-        rev.committer = 'John Smith'
-        self.assertEqual('John Smith', lf.short_committer(rev))
-        rev.committer = 'jsmith@example.com'
-        self.assertEqual('jsmith@example.com', lf.short_committer(rev))
-        rev.committer = '<jsmith@example.com>'
-        self.assertEqual('jsmith@example.com', lf.short_committer(rev))
-        rev.committer = 'John Smith jsmith@example.com'
-        self.assertEqual('John Smith', lf.short_committer(rev))
 
     def test_short_author(self):
         rev = Revision('a-id')
@@ -1061,11 +814,3 @@
         self.assertEqual('John Doe', lf.short_author(rev))
         rev.properties['author'] = 'John Smith <jsmith@example.com>'
         self.assertEqual('John Smith', lf.short_author(rev))
-        rev.properties['author'] = 'John Smith'
-        self.assertEqual('John Smith', lf.short_author(rev))
-        rev.properties['author'] = 'jsmith@example.com'
-        self.assertEqual('jsmith@example.com', lf.short_author(rev))
-        rev.properties['author'] = '<jsmith@example.com>'
-        self.assertEqual('jsmith@example.com', lf.short_author(rev))
-        rev.properties['author'] = 'John Smith jsmith@example.com'
-        self.assertEqual('John Smith', lf.short_author(rev))

=== removed file 'bzrlib/tests/test_lru_cache.py'
--- bzrlib/tests/test_lru_cache.py	2007-11-16 23:53:17 +0000
+++ bzrlib/tests/test_lru_cache.py	1970-01-01 00:00:00 +0000
@@ -1,314 +0,0 @@
-# Copyright (C) 2006 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Tests for the lru_cache module."""
-
-from bzrlib import (
-    lru_cache,
-    tests,
-    )
-
-
-class TestLRUCache(tests.TestCase):
-    """Test that LRU cache properly keeps track of entries."""
-
-    def test_missing(self):
-        cache = lru_cache.LRUCache(max_cache=10)
-
-        self.failIf('foo' in cache)
-        self.assertRaises(KeyError, cache.__getitem__, 'foo')
-
-        cache['foo'] = 'bar'
-        self.assertEqual('bar', cache['foo'])
-        self.failUnless('foo' in cache)
-        self.failIf('bar' in cache)
-
-    def test_overflow(self):
-        """Adding extra entries will pop out old ones."""
-        cache = lru_cache.LRUCache(max_cache=1)
-
-        cache['foo'] = 'bar'
-        # With a max cache of 1, adding 'baz' should pop out 'foo'
-        cache['baz'] = 'biz'
-
-        self.failIf('foo' in cache)
-        self.failUnless('baz' in cache)
-
-        self.assertEqual('biz', cache['baz'])
-
-    def test_by_usage(self):
-        """Accessing entries bumps them up in priority."""
-        cache = lru_cache.LRUCache(max_cache=2)
-
-        cache['baz'] = 'biz'
-        cache['foo'] = 'bar'
-
-        self.assertEqual('biz', cache['baz'])
-
-        # This must kick out 'foo' because it was the last accessed
-        cache['nub'] = 'in'
-
-        self.failIf('foo' in cache)
-
-    def test_queue_stays_bounded(self):
-        """Lots of accesses does not cause the queue to grow without bound."""
-        cache = lru_cache.LRUCache(max_cache=10)
-
-        cache['baz'] = 'biz'
-        cache['foo'] = 'bar'
-
-        for i in xrange(1000):
-            cache['baz']
-
-        self.failUnless(len(cache._queue) < 40)
-
-    def test_cleanup(self):
-        """Test that we can use a cleanup function."""
-        cleanup_called = []
-        def cleanup_func(key, val):
-            cleanup_called.append((key, val))
-
-        cache = lru_cache.LRUCache(max_cache=2)
-
-        cache.add('baz', '1', cleanup=cleanup_func)
-        cache.add('foo', '2', cleanup=cleanup_func)
-        cache.add('biz', '3', cleanup=cleanup_func)
-
-        self.assertEqual([('baz', '1')], cleanup_called)
-
-        # 'foo' is now most recent, so final cleanup will call it last
-        cache['foo']
-        cache.clear()
-        self.assertEqual([('baz', '1'), ('biz', '3'), ('foo', '2')], cleanup_called)
-
-    def test_cleanup_on_replace(self):
-        """Replacing an object should cleanup the old value."""
-        cleanup_called = []
-        def cleanup_func(key, val):
-            cleanup_called.append((key, val))
-
-        cache = lru_cache.LRUCache(max_cache=2)
-        cache.add(1, 10, cleanup=cleanup_func)
-        cache.add(2, 20, cleanup=cleanup_func)
-        cache.add(2, 25, cleanup=cleanup_func)
-
-        self.assertEqual([(2, 20)], cleanup_called)
-        self.assertEqual(25, cache[2])
-        
-        # Even __setitem__ should make sure cleanup() is called
-        cache[2] = 26
-        self.assertEqual([(2, 20), (2, 25)], cleanup_called)
-
-    def test_len(self):
-        cache = lru_cache.LRUCache(max_cache=10)
-
-        cache[1] = 10
-        cache[2] = 20
-        cache[3] = 30
-        cache[4] = 40
-
-        self.assertEqual(4, len(cache))
-
-        cache[5] = 50
-        cache[6] = 60
-        cache[7] = 70
-        cache[8] = 80
-
-        self.assertEqual(8, len(cache))
-
-        cache[1] = 15 # replacement
-
-        self.assertEqual(8, len(cache))
-
-        cache[9] = 90
-        cache[10] = 100
-        cache[11] = 110
-
-        # We hit the max
-        self.assertEqual(10, len(cache))
-
-    def test_cleanup_shrinks_to_after_clean_size(self):
-        cache = lru_cache.LRUCache(max_cache=5, after_cleanup_size=3)
-
-        cache.add(1, 10)
-        cache.add(2, 20)
-        cache.add(3, 25)
-        cache.add(4, 30)
-        cache.add(5, 35)
-
-        self.assertEqual(5, len(cache))
-        # This will bump us over the max, which causes us to shrink down to
-        # after_cleanup_cache size
-        cache.add(6, 40)
-        self.assertEqual(3, len(cache))
-
-    def test_after_cleanup_larger_than_max(self):
-        cache = lru_cache.LRUCache(max_cache=5, after_cleanup_size=10)
-        self.assertEqual(5, cache._after_cleanup_size)
-
-    def test_after_cleanup_none(self):
-        cache = lru_cache.LRUCache(max_cache=5, after_cleanup_size=None)
-        self.assertEqual(5, cache._after_cleanup_size)
-
-    def test_cleanup(self):
-        cache = lru_cache.LRUCache(max_cache=5, after_cleanup_size=2)
-
-        # Add these in order
-        cache.add(1, 10)
-        cache.add(2, 20)
-        cache.add(3, 25)
-        cache.add(4, 30)
-        cache.add(5, 35)
-
-        self.assertEqual(5, len(cache))
-        # Force a compaction
-        cache.cleanup()
-        self.assertEqual(2, len(cache))
-
-    def test_compact_preserves_last_access_order(self):
-        cache = lru_cache.LRUCache(max_cache=5)
-
-        # Add these in order
-        cache.add(1, 10)
-        cache.add(2, 20)
-        cache.add(3, 25)
-        cache.add(4, 30)
-        cache.add(5, 35)
-
-        self.assertEqual([1, 2, 3, 4, 5], list(cache._queue))
-
-        # Now access some randomly
-        cache[2]
-        cache[5]
-        cache[3]
-        cache[2]
-        self.assertEqual([1, 2, 3, 4, 5, 2, 5, 3, 2], list(cache._queue))
-        self.assertEqual({1:1, 2:3, 3:2, 4:1, 5:2}, cache._refcount)
-
-        # Compacting should save the last position
-        cache._compact_queue()
-        self.assertEqual([1, 4, 5, 3, 2], list(cache._queue))
-        self.assertEqual({1:1, 2:1, 3:1, 4:1, 5:1}, cache._refcount)
-
-    def test_get(self):
-        cache = lru_cache.LRUCache(max_cache=5)
-
-        cache.add(1, 10)
-        cache.add(2, 20)
-        self.assertEqual(20, cache.get(2))
-        self.assertIs(None, cache.get(3))
-        obj = object()
-        self.assertIs(obj, cache.get(3, obj))
-
-
-class TestLRUSizeCache(tests.TestCase):
-
-    def test_basic_init(self):
-        cache = lru_cache.LRUSizeCache()
-        self.assertEqual(2048, cache._max_cache)
-        self.assertEqual(4*2048, cache._compact_queue_length)
-        self.assertEqual(cache._max_size, cache._after_cleanup_size)
-        self.assertEqual(0, cache._value_size)
-
-    def test_add_tracks_size(self):
-        cache = lru_cache.LRUSizeCache()
-        self.assertEqual(0, cache._value_size)
-        cache.add('my key', 'my value text')
-        self.assertEqual(13, cache._value_size)
-
-    def test_remove_tracks_size(self):
-        cache = lru_cache.LRUSizeCache()
-        self.assertEqual(0, cache._value_size)
-        cache.add('my key', 'my value text')
-        self.assertEqual(13, cache._value_size)
-        cache._remove('my key')
-        self.assertEqual(0, cache._value_size)
-
-    def test_no_add_over_size(self):
-        """Adding a large value may not be cached at all."""
-        cache = lru_cache.LRUSizeCache(max_size=10, after_cleanup_size=5)
-        self.assertEqual(0, cache._value_size)
-        self.assertEqual({}, cache._cache)
-        cache.add('test', 'key')
-        self.assertEqual(3, cache._value_size)
-        self.assertEqual({'test':'key'}, cache._cache)
-        cache.add('test2', 'key that is too big')
-        self.assertEqual(3, cache._value_size)
-        self.assertEqual({'test':'key'}, cache._cache)
-        # If we would add a key, only to cleanup and remove all cached entries,
-        # then obviously that value should not be stored
-        cache.add('test3', 'bigkey')
-        self.assertEqual(3, cache._value_size)
-        self.assertEqual({'test':'key'}, cache._cache)
-
-        cache.add('test4', 'bikey')
-        self.assertEqual(3, cache._value_size)
-        self.assertEqual({'test':'key'}, cache._cache)
-
-    def test_adding_clears_cache_based_on_size(self):
-        """The cache is cleared in LRU order until small enough"""
-        cache = lru_cache.LRUSizeCache(max_size=20)
-        cache.add('key1', 'value') # 5 chars
-        cache.add('key2', 'value2') # 6 chars
-        cache.add('key3', 'value23') # 7 chars
-        self.assertEqual(5+6+7, cache._value_size)
-        cache['key2'] # reference key2 so it gets a newer reference time
-        cache.add('key4', 'value234') # 8 chars, over limit
-        # We have to remove 2 keys to get back under limit
-        self.assertEqual(6+8, cache._value_size)
-        self.assertEqual({'key2':'value2', 'key4':'value234'},
-                         cache._cache)
-
-    def test_adding_clears_to_after_cleanup_size(self):
-        cache = lru_cache.LRUSizeCache(max_size=20, after_cleanup_size=10)
-        cache.add('key1', 'value') # 5 chars
-        cache.add('key2', 'value2') # 6 chars
-        cache.add('key3', 'value23') # 7 chars
-        self.assertEqual(5+6+7, cache._value_size)
-        cache['key2'] # reference key2 so it gets a newer reference time
-        cache.add('key4', 'value234') # 8 chars, over limit
-        # We have to remove 3 keys to get back under limit
-        self.assertEqual(8, cache._value_size)
-        self.assertEqual({'key4':'value234'}, cache._cache)
-
-    def test_custom_sizes(self):
-        def size_of_list(lst):
-            return sum(len(x) for x in lst)
-        cache = lru_cache.LRUSizeCache(max_size=20, after_cleanup_size=10,
-                                       compute_size=size_of_list)
-
-        cache.add('key1', ['val', 'ue']) # 5 chars
-        cache.add('key2', ['val', 'ue2']) # 6 chars
-        cache.add('key3', ['val', 'ue23']) # 7 chars
-        self.assertEqual(5+6+7, cache._value_size)
-        cache['key2'] # reference key2 so it gets a newer reference time
-        cache.add('key4', ['value', '234']) # 8 chars, over limit
-        # We have to remove 3 keys to get back under limit
-        self.assertEqual(8, cache._value_size)
-        self.assertEqual({'key4':['value', '234']}, cache._cache)
-
-    def test_cleanup(self):
-        cache = lru_cache.LRUSizeCache(max_size=20, after_cleanup_size=10)
-
-        # Add these in order
-        cache.add('key1', 'value') # 5 chars
-        cache.add('key2', 'value2') # 6 chars
-        cache.add('key3', 'value23') # 7 chars
-        self.assertEqual(5+6+7, cache._value_size)
-
-        cache.cleanup()
-        # Only the most recent fits after cleaning up
-        self.assertEqual(7, cache._value_size)

=== modified file 'bzrlib/tests/test_mail_client.py'
--- bzrlib/tests/test_mail_client.py	2008-04-13 11:48:00 +0000
+++ bzrlib/tests/test_mail_client.py	2007-09-03 23:54:22 +0000
@@ -15,7 +15,6 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 from bzrlib import (
-    errors,
     mail_client,
     tests,
     urlutils,
@@ -32,17 +31,6 @@
         self.assertEqual(['-s', 'Hi there!', 'jrandom@example.org'],
                          commandline)
 
-    def test_commandline_is_8bit(self):
-        mutt = mail_client.Mutt(None)
-        cmdline = mutt._get_compose_commandline(u'jrandom@example.org',
-            u'Hi there!', u'file%')
-        self.assertEqual(
-            ['-s', 'Hi there!', '-a', 'file%', 'jrandom@example.org'],
-            cmdline)
-        for item in cmdline:
-            self.assertFalse(isinstance(item, unicode),
-                'Command-line item %r is unicode!' % item)
-
 
 class TestThunderbird(tests.TestCase):
 
@@ -57,81 +45,19 @@
         self.assertEqual(['-compose', "subject='Hi there!',"
                                       "to='jrandom@example.org'"], commandline)
 
-    def test_commandline_is_8bit(self):
-        # test for bug #139318
-        tbird = mail_client.Thunderbird(None)
-        cmdline = tbird._get_compose_commandline(u'jrandom@example.org',
-            u'Hi there!', u'file%')
-        self.assertEqual(['-compose',
-            ("attachment='%s'," % urlutils.local_path_to_url('file%')) +
-            "subject='Hi there!',to='jrandom@example.org'",
-            ], cmdline)
-        for item in cmdline:
-            self.assertFalse(isinstance(item, unicode),
-                'Command-line item %r is unicode!' % item)
-
-
-class TestEmacsMail(tests.TestCase):
-
-    def test_commandline(self):
-        eclient = mail_client.EmacsMail(None)
-
-        commandline = eclient._get_compose_commandline(None, 'Hi there!', None)
-        self.assertEqual(['--eval', '(compose-mail nil "Hi there!")'],
-                         commandline)
-
-        commandline = eclient._get_compose_commandline('jrandom@example.org',
-                                                       'Hi there!', None)
-        self.assertEqual(['--eval',
-                          '(compose-mail "jrandom@example.org" "Hi there!")'],
-                         commandline)
-
-        # We won't be able to know the temporary file name at this stage
-        # so we can't raise an assertion with assertEqual
-        cmdline = eclient._get_compose_commandline(None, None, 'file%')
-        commandline = ' '.join(cmdline)
-        self.assertContainsRe(commandline, '--eval')
-        self.assertContainsRe(commandline, '(compose-mail nil nil)')
-        self.assertContainsRe(commandline, '(load .*)')
-        self.assertContainsRe(commandline, '(bzr-add-mime-att \"file%\")')
-
-    def test_commandline_is_8bit(self):
-        eclient = mail_client.EmacsMail(None)
-        commandline = eclient._get_compose_commandline(u'jrandom@example.org',
-            u'Hi there!', u'file%')
-        for item in commandline:
-            self.assertFalse(isinstance(item, unicode),
-                'Command-line item %r is unicode!' % item)
-
 
 class TestXDGEmail(tests.TestCase):
 
     def test_commandline(self):
         xdg_email = mail_client.XDGEmail(None)
-        self.assertRaises(errors.NoMailAddressSpecified,
-                          xdg_email._get_compose_commandline,
-                          None, None, 'file%')
-        commandline = xdg_email._get_compose_commandline(
-            'jrandom@example.org', None, 'file%')
-        self.assertEqual(['jrandom@example.org', '--attach', 'file%'],
-                         commandline)
+        commandline = xdg_email._get_compose_commandline(None, None,
+                                                         'file%')
+        self.assertEqual([None, '--attach', 'file%'], commandline)
         commandline = xdg_email._get_compose_commandline(
             'jrandom@example.org', 'Hi there!', None)
         self.assertEqual(['jrandom@example.org', '--subject', 'Hi there!'],
                          commandline)
 
-    def test_commandline_is_8bit(self):
-        xdg_email = mail_client.XDGEmail(None)
-        cmdline = xdg_email._get_compose_commandline(u'jrandom@example.org',
-            u'Hi there!', u'file%')
-        self.assertEqual(
-            ['jrandom@example.org', '--subject', 'Hi there!',
-             '--attach', 'file%'],
-            cmdline)
-        for item in cmdline:
-            self.assertFalse(isinstance(item, unicode),
-                'Command-line item %r is unicode!' % item)
-
 
 class TestEvolution(tests.TestCase):
 
@@ -144,18 +70,6 @@
         self.assertEqual(['mailto:jrandom@example.org?subject=Hi%20there%21'],
                          commandline)
 
-    def test_commandline_is_8bit(self):
-        evo = mail_client.Evolution(None)
-        cmdline = evo._get_compose_commandline(u'jrandom@example.org',
-            u'Hi there!', u'file%')
-        self.assertEqual(
-            ['mailto:jrandom@example.org?attach=file%25&subject=Hi%20there%21'
-            ],
-            cmdline)
-        for item in cmdline:
-            self.assertFalse(isinstance(item, unicode),
-                'Command-line item %r is unicode!' % item)
-
 
 class TestKMail(tests.TestCase):
 
@@ -168,17 +82,6 @@
         self.assertEqual(['-s', 'Hi there!', 'jrandom@example.org'],
                          commandline)
 
-    def test_commandline_is_8bit(self):
-        kmail = mail_client.KMail(None)
-        cmdline = kmail._get_compose_commandline(u'jrandom@example.org',
-            u'Hi there!', u'file%')
-        self.assertEqual(
-            ['-s', 'Hi there!', '--attach', 'file%', 'jrandom@example.org'],
-            cmdline)
-        for item in cmdline:
-            self.assertFalse(isinstance(item, unicode),
-                'Command-line item %r is unicode!' % item)
-
 
 class TestEditor(tests.TestCase):
 
@@ -192,34 +95,3 @@
         self.assertContainsRe(prompt, u'foo\u1234(.|\n)*bar\u1234'
                               u'(.|\n)*baz\u1234(.|\n)*qux\u1234')
         editor._get_merge_prompt(u'foo', u'bar', u'baz', 'qux\xff')
-
-
-class DummyMailClient(object):
-
-    def compose_merge_request(self, *args, **kwargs):
-        self.args = args
-        self.kwargs = kwargs
-
-
-class DefaultMailDummyClient(mail_client.DefaultMail):
-
-    def __init__(self):
-        self.client = DummyMailClient()
-
-    def _mail_client(self):
-        return self.client
-
-
-class TestDefaultMail(tests.TestCase):
-
-    def test_compose_merge_request(self):
-        client = DefaultMailDummyClient()
-        to = "a@b.com"
-        subject = "[MERGE]"
-        directive = "directive",
-        basename = "merge"
-        client.compose_merge_request(to, subject, directive,
-                                     basename=basename)
-        dummy_client = client.client
-        self.assertEqual(dummy_client.args, (to, subject, directive))
-        self.assertEqual(dummy_client.kwargs, {"basename":basename})

=== modified file 'bzrlib/tests/test_memorytree.py'
--- bzrlib/tests/test_memorytree.py	2008-07-22 18:12:25 +0000
+++ bzrlib/tests/test_memorytree.py	2006-10-15 15:55:32 +0000
@@ -52,16 +52,6 @@
             tree.get_file(tree.path2id('foo')).read())
         tree.unlock()
 
-    def test_get_root_id(self):
-        branch = self.make_branch('branch')
-        tree = MemoryTree.create_on_branch(branch)
-        tree.lock_write()
-        try:
-            tree.add([''])
-            self.assertIsNot(None, tree.get_root_id())
-        finally:
-            tree.unlock()
-
     def test_lock_tree_write(self):
         """Check we can lock_tree_write and unlock MemoryTrees."""
         branch = self.make_branch('branch')
@@ -125,22 +115,6 @@
         self.assertEqual('barshoom', tree.get_file('foo-id').read())
         tree.unlock()
 
-    def test_add_in_subdir(self):
-        branch = self.make_branch('branch')
-        tree = MemoryTree.create_on_branch(branch)
-        tree.lock_write()
-        self.addCleanup(tree.unlock)
-        tree.add([''], ['root-id'], ['directory'])
-        # Unfortunately, the only way to 'mkdir' is to call 'tree.mkdir', but
-        # that *always* adds the directory as well. So if you want to create a
-        # file in a subdirectory, you have to split out the 'mkdir()' calls
-        # from the add and put_file_bytes_non_atomic calls. :(
-        tree.mkdir('adir', 'dir-id')
-        tree.add(['adir/afile'], ['file-id'], ['file'])
-        self.assertEqual('adir/afile', tree.id2path('file-id'))
-        self.assertEqual('adir', tree.id2path('dir-id'))
-        tree.put_file_bytes_non_atomic('file-id', 'barshoom')
-
     def test_commit_trivial(self):
         """Smoke test for commit on a MemoryTree.
 
@@ -159,8 +133,6 @@
         tree.unlock()
         # and we should have a revision that is accessible outside the tree lock
         revtree = tree.branch.repository.revision_tree(revision_id)
-        revtree.lock_read()
-        self.addCleanup(revtree.unlock)
         self.assertEqual('barshoom', revtree.get_file('foo-id').read())
 
     def test_unversion(self):

=== modified file 'bzrlib/tests/test_merge.py'
--- bzrlib/tests/test_merge.py	2008-08-27 20:32:22 +0000
+++ bzrlib/tests/test_merge.py	2007-09-14 09:51:38 +0000
@@ -20,19 +20,17 @@
 from bzrlib import (
     conflicts,
     errors,
-    knit,
     merge as _mod_merge,
     option,
     progress,
-    transform,
-    versionedfile,
     )
 from bzrlib.branch import Branch
 from bzrlib.conflicts import ConflictList, TextConflict
 from bzrlib.errors import UnrelatedBranches, NoCommits, BzrCommandError
-from bzrlib.merge import transform_tree, merge_inner, _PlanMerge
+from bzrlib.merge import transform_tree, merge_inner
 from bzrlib.osutils import pathjoin, file_kind
-from bzrlib.tests import TestCaseWithTransport, TestCaseWithMemoryTransport
+from bzrlib.revision import common_ancestor
+from bzrlib.tests import TestCaseWithTransport
 from bzrlib.trace import (enable_test_log, disable_test_log)
 from bzrlib.workingtree import WorkingTree
 
@@ -105,14 +103,8 @@
         """Merge base is sane when two unrelated branches are merged"""
         wt1, br2 = self.test_pending_with_null()
         wt1.commit("blah")
-        wt1.lock_read()
-        try:
-            last = wt1.branch.last_revision()
-            last2 = br2.last_revision()
-            graph = wt1.branch.repository.get_graph()
-            self.assertEqual(last2, graph.find_unique_lca(last, last2))
-        finally:
-            wt1.unlock()
+        last = wt1.branch.last_revision()
+        self.assertEqual(common_ancestor(last, last, wt1.branch.repository), last)
 
     def test_create_rename(self):
         """Rename an inventory entry while creating the file"""
@@ -144,8 +136,6 @@
         tree_a.commit(message="hello")
         dir_b = tree_a.bzrdir.sprout('b')
         tree_b = dir_b.open_workingtree()
-        tree_b.lock_write()
-        self.addCleanup(tree_b.unlock)
         tree_a.commit(message="hello again")
         log = StringIO()
         merge_inner(tree_b.branch, tree_a, tree_b.basis_tree(), 
@@ -295,815 +285,3 @@
         merger.merge_type = _mod_merge.Merge3Merger
         merger.do_merge()
         self.assertEqual(tree_a.get_parent_ids(), [tree_b.last_revision()])
-
-    def test_merge_uncommitted_otherbasis_ancestor_of_thisbasis_weave(self):
-        tree_a = self.make_branch_and_tree('a')
-        self.build_tree(['a/file_1', 'a/file_2'])
-        tree_a.add(['file_1'])
-        tree_a.commit('commit 1')
-        tree_a.add(['file_2'])
-        tree_a.commit('commit 2')
-        tree_b = tree_a.bzrdir.sprout('b').open_workingtree()
-        tree_b.rename_one('file_1', 'renamed')
-        merger = _mod_merge.Merger.from_uncommitted(tree_a, tree_b,
-                                                    progress.DummyProgress())
-        merger.merge_type = _mod_merge.WeaveMerger
-        merger.do_merge()
-        self.assertEqual(tree_a.get_parent_ids(), [tree_b.last_revision()])
-
-    def prepare_cherrypick(self):
-        """Prepare a pair of trees for cherrypicking tests.
-
-        Both trees have a file, 'file'.
-        rev1 sets content to 'a'.
-        rev2b adds 'b'.
-        rev3b adds 'c'.
-        A full merge of rev2b and rev3b into this_tree would add both 'b' and
-        'c'.  A successful cherrypick of rev2b-rev3b into this_tree will add
-        'c', but not 'b'.
-        """
-        this_tree = self.make_branch_and_tree('this')
-        self.build_tree_contents([('this/file', "a\n")])
-        this_tree.add('file')
-        this_tree.commit('rev1')
-        other_tree = this_tree.bzrdir.sprout('other').open_workingtree()
-        self.build_tree_contents([('other/file', "a\nb\n")])
-        other_tree.commit('rev2b', rev_id='rev2b')
-        self.build_tree_contents([('other/file', "c\na\nb\n")])
-        other_tree.commit('rev3b', rev_id='rev3b')
-        this_tree.lock_write()
-        self.addCleanup(this_tree.unlock)
-        return this_tree, other_tree
-
-    def test_weave_cherrypick(self):
-        this_tree, other_tree = self.prepare_cherrypick()
-        merger = _mod_merge.Merger.from_revision_ids(progress.DummyProgress(),
-            this_tree, 'rev3b', 'rev2b', other_tree.branch)
-        merger.merge_type = _mod_merge.WeaveMerger
-        merger.do_merge()
-        self.assertFileEqual('c\na\n', 'this/file')
-
-    def test_weave_cannot_reverse_cherrypick(self):
-        this_tree, other_tree = self.prepare_cherrypick()
-        merger = _mod_merge.Merger.from_revision_ids(progress.DummyProgress(),
-            this_tree, 'rev2b', 'rev3b', other_tree.branch)
-        merger.merge_type = _mod_merge.WeaveMerger
-        self.assertRaises(errors.CannotReverseCherrypick, merger.do_merge)
-
-    def test_merge3_can_reverse_cherrypick(self):
-        this_tree, other_tree = self.prepare_cherrypick()
-        merger = _mod_merge.Merger.from_revision_ids(progress.DummyProgress(),
-            this_tree, 'rev2b', 'rev3b', other_tree.branch)
-        merger.merge_type = _mod_merge.Merge3Merger
-        merger.do_merge()
-
-    def test_merge3_will_detect_cherrypick(self):
-        this_tree = self.make_branch_and_tree('this')
-        self.build_tree_contents([('this/file', "a\n")])
-        this_tree.add('file')
-        this_tree.commit('rev1')
-        other_tree = this_tree.bzrdir.sprout('other').open_workingtree()
-        self.build_tree_contents([('other/file', "a\nb\n")])
-        other_tree.commit('rev2b', rev_id='rev2b')
-        self.build_tree_contents([('other/file', "a\nb\nc\n")])
-        other_tree.commit('rev3b', rev_id='rev3b')
-        this_tree.lock_write()
-        self.addCleanup(this_tree.unlock)
-
-        merger = _mod_merge.Merger.from_revision_ids(progress.DummyProgress(),
-            this_tree, 'rev3b', 'rev2b', other_tree.branch)
-        merger.merge_type = _mod_merge.Merge3Merger
-        merger.do_merge()
-        self.assertFileEqual('a\n'
-                             '<<<<<<< TREE\n'
-                             '=======\n'
-                             'c\n'
-                             '>>>>>>> MERGE-SOURCE\n',
-                             'this/file')
-
-    def test_make_merger(self):
-        this_tree = self.make_branch_and_tree('this')
-        this_tree.commit('rev1', rev_id='rev1')
-        other_tree = this_tree.bzrdir.sprout('other').open_workingtree()
-        this_tree.commit('rev2', rev_id='rev2a')
-        other_tree.commit('rev2', rev_id='rev2b')
-        this_tree.lock_write()
-        self.addCleanup(this_tree.unlock)
-        merger = _mod_merge.Merger.from_revision_ids(progress.DummyProgress,
-            this_tree, 'rev2b', other_branch=other_tree.branch)
-        merger.merge_type = _mod_merge.Merge3Merger
-        tree_merger = merger.make_merger()
-        self.assertIs(_mod_merge.Merge3Merger, tree_merger.__class__)
-        self.assertEqual('rev2b', tree_merger.other_tree.get_revision_id())
-        self.assertEqual('rev1', tree_merger.base_tree.get_revision_id())
-
-    def test_make_preview_transform(self):
-        this_tree = self.make_branch_and_tree('this')
-        self.build_tree_contents([('this/file', '1\n')])
-        this_tree.add('file', 'file-id')
-        this_tree.commit('rev1', rev_id='rev1')
-        other_tree = this_tree.bzrdir.sprout('other').open_workingtree()
-        self.build_tree_contents([('this/file', '1\n2a\n')])
-        this_tree.commit('rev2', rev_id='rev2a')
-        self.build_tree_contents([('other/file', '2b\n1\n')])
-        other_tree.commit('rev2', rev_id='rev2b')
-        this_tree.lock_write()
-        self.addCleanup(this_tree.unlock)
-        merger = _mod_merge.Merger.from_revision_ids(progress.DummyProgress(),
-            this_tree, 'rev2b', other_branch=other_tree.branch)
-        merger.merge_type = _mod_merge.Merge3Merger
-        tree_merger = merger.make_merger()
-        tt = tree_merger.make_preview_transform()
-        self.addCleanup(tt.finalize)
-        preview_tree = tt.get_preview_tree()
-        tree_file = this_tree.get_file('file-id')
-        try:
-            self.assertEqual('1\n2a\n', tree_file.read())
-        finally:
-            tree_file.close()
-        preview_file = preview_tree.get_file('file-id')
-        try:
-            self.assertEqual('2b\n1\n2a\n', preview_file.read())
-        finally:
-            preview_file.close()
-
-    def test_do_merge(self):
-        this_tree = self.make_branch_and_tree('this')
-        self.build_tree_contents([('this/file', '1\n')])
-        this_tree.add('file', 'file-id')
-        this_tree.commit('rev1', rev_id='rev1')
-        other_tree = this_tree.bzrdir.sprout('other').open_workingtree()
-        self.build_tree_contents([('this/file', '1\n2a\n')])
-        this_tree.commit('rev2', rev_id='rev2a')
-        self.build_tree_contents([('other/file', '2b\n1\n')])
-        other_tree.commit('rev2', rev_id='rev2b')
-        this_tree.lock_write()
-        self.addCleanup(this_tree.unlock)
-        merger = _mod_merge.Merger.from_revision_ids(progress.DummyProgress(),
-            this_tree, 'rev2b', other_branch=other_tree.branch)
-        merger.merge_type = _mod_merge.Merge3Merger
-        tree_merger = merger.make_merger()
-        tt = tree_merger.do_merge()
-        tree_file = this_tree.get_file('file-id')
-        try:
-            self.assertEqual('2b\n1\n2a\n', tree_file.read())
-        finally:
-            tree_file.close()
-
-    def test_merge_add_into_deleted_root(self):
-        # Yes, people actually do this.  And report bugs if it breaks.
-        source = self.make_branch_and_tree('source', format='rich-root-pack')
-        self.build_tree(['source/foo/'])
-        source.add('foo', 'foo-id')
-        source.commit('Add foo')
-        target = source.bzrdir.sprout('target').open_workingtree()
-        subtree = target.extract('foo-id')
-        subtree.commit('Delete root')
-        self.build_tree(['source/bar'])
-        source.add('bar', 'bar-id')
-        source.commit('Add bar')
-        subtree.merge_from_branch(source.branch)
-
-    def test_merge_joined_branch(self):
-        source = self.make_branch_and_tree('source', format='rich-root-pack')
-        self.build_tree(['source/foo'])
-        source.add('foo')
-        source.commit('Add foo')
-        target = self.make_branch_and_tree('target', format='rich-root-pack')
-        self.build_tree(['target/bla'])
-        target.add('bla')
-        target.commit('Add bla')
-        nested = source.bzrdir.sprout('target/subtree').open_workingtree()
-        target.subsume(nested)
-        target.commit('Join nested')
-        self.build_tree(['source/bar'])
-        source.add('bar')
-        source.commit('Add bar')
-        target.merge_from_branch(source.branch)
-        target.commit('Merge source')
-
-
-class TestPlanMerge(TestCaseWithMemoryTransport):
-
-    def setUp(self):
-        TestCaseWithMemoryTransport.setUp(self)
-        mapper = versionedfile.PrefixMapper()
-        factory = knit.make_file_factory(True, mapper)
-        self.vf = factory(self.get_transport())
-        self.plan_merge_vf = versionedfile._PlanMergeVersionedFile('root')
-        self.plan_merge_vf.fallback_versionedfiles.append(self.vf)
-
-    def add_version(self, key, parents, text):
-        self.vf.add_lines(key, parents, [c+'\n' for c in text])
-
-    def add_rev(self, prefix, revision_id, parents, text):
-        self.add_version((prefix, revision_id), [(prefix, p) for p in parents],
-                         text)
-
-    def add_uncommitted_version(self, key, parents, text):
-        self.plan_merge_vf.add_lines(key, parents,
-                                     [c+'\n' for c in text])
-
-    def setup_plan_merge(self):
-        self.add_rev('root', 'A', [], 'abc')
-        self.add_rev('root', 'B', ['A'], 'acehg')
-        self.add_rev('root', 'C', ['A'], 'fabg')
-        return _PlanMerge('B', 'C', self.plan_merge_vf, ('root',))
-
-    def setup_plan_merge_uncommitted(self):
-        self.add_version(('root', 'A'), [], 'abc')
-        self.add_uncommitted_version(('root', 'B:'), [('root', 'A')], 'acehg')
-        self.add_uncommitted_version(('root', 'C:'), [('root', 'A')], 'fabg')
-        return _PlanMerge('B:', 'C:', self.plan_merge_vf, ('root',))
-
-    def test_unique_lines(self):
-        plan = self.setup_plan_merge()
-        self.assertEqual(plan._unique_lines(
-            plan._get_matching_blocks('B', 'C')),
-            ([1, 2, 3], [0, 2]))
-
-    def test_plan_merge(self):
-        self.setup_plan_merge()
-        plan = self.plan_merge_vf.plan_merge('B', 'C')
-        self.assertEqual([
-                          ('new-b', 'f\n'),
-                          ('unchanged', 'a\n'),
-                          ('killed-a', 'b\n'),
-                          ('killed-b', 'c\n'),
-                          ('new-a', 'e\n'),
-                          ('new-a', 'h\n'),
-                          ('new-a', 'g\n'),
-                          ('new-b', 'g\n')],
-                         list(plan))
-
-    def test_plan_merge_cherrypick(self):
-        self.add_rev('root', 'A', [], 'abc')
-        self.add_rev('root', 'B', ['A'], 'abcde')
-        self.add_rev('root', 'C', ['A'], 'abcefg')
-        self.add_rev('root', 'D', ['A', 'B', 'C'], 'abcdegh')
-        my_plan = _PlanMerge('B', 'D', self.plan_merge_vf, ('root',))
-        # We shortcut when one text supersedes the other in the per-file graph.
-        # We don't actually need to compare the texts at this point.
-        self.assertEqual([
-                          ('new-b', 'a\n'),
-                          ('new-b', 'b\n'),
-                          ('new-b', 'c\n'),
-                          ('new-b', 'd\n'),
-                          ('new-b', 'e\n'),
-                          ('new-b', 'g\n'),
-                          ('new-b', 'h\n')],
-                          list(my_plan.plan_merge()))
-
-    def test_plan_merge_no_common_ancestor(self):
-        self.add_rev('root', 'A', [], 'abc')
-        self.add_rev('root', 'B', [], 'xyz')
-        my_plan = _PlanMerge('A', 'B', self.plan_merge_vf, ('root',))
-        self.assertEqual([
-                          ('new-a', 'a\n'),
-                          ('new-a', 'b\n'),
-                          ('new-a', 'c\n'),
-                          ('new-b', 'x\n'),
-                          ('new-b', 'y\n'),
-                          ('new-b', 'z\n')],
-                          list(my_plan.plan_merge()))
-
-    def test_plan_merge_tail_ancestors(self):
-        # The graph looks like this:
-        #       A       # Common to all ancestors
-        #      / \
-        #     B   C     # Ancestors of E, only common to one side
-        #     |\ /|
-        #     D E F     # D, F are unique to G, H respectively
-        #     |/ \|     # E is the LCA for G & H, and the unique LCA for
-        #     G   H     # I, J
-        #     |\ /|
-        #     | X |
-        #     |/ \|
-        #     I   J     # criss-cross merge of G, H
-        #
-        # In this situation, a simple pruning of ancestors of E will leave D &
-        # F "dangling", which looks like they introduce lines different from
-        # the ones in E, but in actuality C&B introduced the lines, and they
-        # are already present in E
-
-        # Introduce the base text
-        self.add_rev('root', 'A', [], 'abc')
-        # Introduces a new line B
-        self.add_rev('root', 'B', ['A'], 'aBbc')
-        # Introduces a new line C
-        self.add_rev('root', 'C', ['A'], 'abCc')
-        # Introduce new line D
-        self.add_rev('root', 'D', ['B'], 'DaBbc')
-        # Merges B and C by just incorporating both
-        self.add_rev('root', 'E', ['B', 'C'], 'aBbCc')
-        # Introduce new line F
-        self.add_rev('root', 'F', ['C'], 'abCcF')
-        # Merge D & E by just combining the texts
-        self.add_rev('root', 'G', ['D', 'E'], 'DaBbCc')
-        # Merge F & E by just combining the texts
-        self.add_rev('root', 'H', ['F', 'E'], 'aBbCcF')
-        # Merge G & H by just combining texts
-        self.add_rev('root', 'I', ['G', 'H'], 'DaBbCcF')
-        # Merge G & H but supersede an old line in B
-        self.add_rev('root', 'J', ['H', 'G'], 'DaJbCcF')
-        plan = self.plan_merge_vf.plan_merge('I', 'J')
-        self.assertEqual([
-                          ('unchanged', 'D\n'),
-                          ('unchanged', 'a\n'),
-                          ('killed-b', 'B\n'),
-                          ('new-b', 'J\n'),
-                          ('unchanged', 'b\n'),
-                          ('unchanged', 'C\n'),
-                          ('unchanged', 'c\n'),
-                          ('unchanged', 'F\n')],
-                         list(plan))
-
-    def test_plan_merge_tail_triple_ancestors(self):
-        # The graph looks like this:
-        #       A       # Common to all ancestors
-        #      / \
-        #     B   C     # Ancestors of E, only common to one side
-        #     |\ /|
-        #     D E F     # D, F are unique to G, H respectively
-        #     |/|\|     # E is the LCA for G & H, and the unique LCA for
-        #     G Q H     # I, J
-        #     |\ /|     # Q is just an extra node which is merged into both
-        #     | X |     # I and J
-        #     |/ \|
-        #     I   J     # criss-cross merge of G, H
-        #
-        # This is the same as the test_plan_merge_tail_ancestors, except we add
-        # a third LCA that doesn't add new lines, but will trigger our more
-        # involved ancestry logic
-
-        self.add_rev('root', 'A', [], 'abc')
-        self.add_rev('root', 'B', ['A'], 'aBbc')
-        self.add_rev('root', 'C', ['A'], 'abCc')
-        self.add_rev('root', 'D', ['B'], 'DaBbc')
-        self.add_rev('root', 'E', ['B', 'C'], 'aBbCc')
-        self.add_rev('root', 'F', ['C'], 'abCcF')
-        self.add_rev('root', 'G', ['D', 'E'], 'DaBbCc')
-        self.add_rev('root', 'H', ['F', 'E'], 'aBbCcF')
-        self.add_rev('root', 'Q', ['E'], 'aBbCc')
-        self.add_rev('root', 'I', ['G', 'Q', 'H'], 'DaBbCcF')
-        # Merge G & H but supersede an old line in B
-        self.add_rev('root', 'J', ['H', 'Q', 'G'], 'DaJbCcF')
-        plan = self.plan_merge_vf.plan_merge('I', 'J')
-        self.assertEqual([
-                          ('unchanged', 'D\n'),
-                          ('unchanged', 'a\n'),
-                          ('killed-b', 'B\n'),
-                          ('new-b', 'J\n'),
-                          ('unchanged', 'b\n'),
-                          ('unchanged', 'C\n'),
-                          ('unchanged', 'c\n'),
-                          ('unchanged', 'F\n')],
-                         list(plan))
-
-    def test_plan_merge_2_tail_triple_ancestors(self):
-        # The graph looks like this:
-        #     A   B     # 2 tails going back to NULL
-        #     |\ /|
-        #     D E F     # D, is unique to G, F to H
-        #     |/|\|     # E is the LCA for G & H, and the unique LCA for
-        #     G Q H     # I, J
-        #     |\ /|     # Q is just an extra node which is merged into both
-        #     | X |     # I and J
-        #     |/ \|
-        #     I   J     # criss-cross merge of G, H (and Q)
-        #
-
-        # This is meant to test after hitting a 3-way LCA, and multiple tail
-        # ancestors (only have NULL_REVISION in common)
-
-        self.add_rev('root', 'A', [], 'abc')
-        self.add_rev('root', 'B', [], 'def')
-        self.add_rev('root', 'D', ['A'], 'Dabc')
-        self.add_rev('root', 'E', ['A', 'B'], 'abcdef')
-        self.add_rev('root', 'F', ['B'], 'defF')
-        self.add_rev('root', 'G', ['D', 'E'], 'Dabcdef')
-        self.add_rev('root', 'H', ['F', 'E'], 'abcdefF')
-        self.add_rev('root', 'Q', ['E'], 'abcdef')
-        self.add_rev('root', 'I', ['G', 'Q', 'H'], 'DabcdefF')
-        # Merge G & H but supersede an old line in B
-        self.add_rev('root', 'J', ['H', 'Q', 'G'], 'DabcdJfF')
-        plan = self.plan_merge_vf.plan_merge('I', 'J')
-        self.assertEqual([
-                          ('unchanged', 'D\n'),
-                          ('unchanged', 'a\n'),
-                          ('unchanged', 'b\n'),
-                          ('unchanged', 'c\n'),
-                          ('unchanged', 'd\n'),
-                          ('killed-b', 'e\n'),
-                          ('new-b', 'J\n'),
-                          ('unchanged', 'f\n'),
-                          ('unchanged', 'F\n')],
-                         list(plan))
-
-    def test_plan_merge_uncommitted_files(self):
-        self.setup_plan_merge_uncommitted()
-        plan = self.plan_merge_vf.plan_merge('B:', 'C:')
-        self.assertEqual([
-                          ('new-b', 'f\n'),
-                          ('unchanged', 'a\n'),
-                          ('killed-a', 'b\n'),
-                          ('killed-b', 'c\n'),
-                          ('new-a', 'e\n'),
-                          ('new-a', 'h\n'),
-                          ('new-a', 'g\n'),
-                          ('new-b', 'g\n')],
-                         list(plan))
-
-    def test_plan_merge_insert_order(self):
-        """Weave merges are sensitive to the order of insertion.
-        
-        Specifically for overlapping regions, it effects which region gets put
-        'first'. And when a user resolves an overlapping merge, if they use the
-        same ordering, then the lines match the parents, if they don't only
-        *some* of the lines match.
-        """
-        self.add_rev('root', 'A', [], 'abcdef')
-        self.add_rev('root', 'B', ['A'], 'abwxcdef')
-        self.add_rev('root', 'C', ['A'], 'abyzcdef')
-        # Merge, and resolve the conflict by adding *both* sets of lines
-        # If we get the ordering wrong, these will look like new lines in D,
-        # rather than carried over from B, C
-        self.add_rev('root', 'D', ['B', 'C'],
-                         'abwxyzcdef')
-        # Supersede the lines in B and delete the lines in C, which will
-        # conflict if they are treated as being in D
-        self.add_rev('root', 'E', ['C', 'B'],
-                         'abnocdef')
-        # Same thing for the lines in C
-        self.add_rev('root', 'F', ['C'], 'abpqcdef')
-        plan = self.plan_merge_vf.plan_merge('D', 'E')
-        self.assertEqual([
-                          ('unchanged', 'a\n'),
-                          ('unchanged', 'b\n'),
-                          ('killed-b', 'w\n'),
-                          ('killed-b', 'x\n'),
-                          ('killed-b', 'y\n'),
-                          ('killed-b', 'z\n'),
-                          ('new-b', 'n\n'),
-                          ('new-b', 'o\n'),
-                          ('unchanged', 'c\n'),
-                          ('unchanged', 'd\n'),
-                          ('unchanged', 'e\n'),
-                          ('unchanged', 'f\n')],
-                         list(plan))
-        plan = self.plan_merge_vf.plan_merge('E', 'D')
-        # Going in the opposite direction shows the effect of the opposite plan
-        self.assertEqual([
-                          ('unchanged', 'a\n'),
-                          ('unchanged', 'b\n'),
-                          ('new-b', 'w\n'),
-                          ('new-b', 'x\n'),
-                          ('killed-a', 'y\n'),
-                          ('killed-a', 'z\n'),
-                          ('killed-both', 'w\n'),
-                          ('killed-both', 'x\n'),
-                          ('new-a', 'n\n'),
-                          ('new-a', 'o\n'),
-                          ('unchanged', 'c\n'),
-                          ('unchanged', 'd\n'),
-                          ('unchanged', 'e\n'),
-                          ('unchanged', 'f\n')],
-                         list(plan))
-
-    def test_plan_merge_criss_cross(self):
-        # This is specificly trying to trigger problems when using limited
-        # ancestry and weaves. The ancestry graph looks like:
-        #       XX      unused ancestor, should not show up in the weave
-        #       |
-        #       A       Unique LCA
-        #       |\
-        #       B \     Introduces a line 'foo'
-        #      / \ \
-        #     C   D E   C & D both have 'foo', E has different changes
-        #     |\ /| |
-        #     | X | |
-        #     |/ \|/
-        #     F   G      All of C, D, E are merged into F and G, so they are
-        #                all common ancestors.
-        #
-        # The specific issue with weaves:
-        #   B introduced a text ('foo') that is present in both C and D.
-        #   If we do not include B (because it isn't an ancestor of E), then
-        #   the A=>C and A=>D look like both sides independently introduce the
-        #   text ('foo'). If F does not modify the text, it would still appear
-        #   to have deleted on of the versions from C or D. If G then modifies
-        #   'foo', it should appear as superseding the value in F (since it
-        #   came from B), rather than conflict because of the resolution during
-        #   C & D.
-        self.add_rev('root', 'XX', [], 'qrs')
-        self.add_rev('root', 'A', ['XX'], 'abcdef')
-        self.add_rev('root', 'B', ['A'], 'axcdef')
-        self.add_rev('root', 'C', ['B'], 'axcdefg')
-        self.add_rev('root', 'D', ['B'], 'haxcdef')
-        self.add_rev('root', 'E', ['A'], 'abcdyf')
-        # Simple combining of all texts
-        self.add_rev('root', 'F', ['C', 'D', 'E'], 'haxcdyfg')
-        # combine and supersede 'x'
-        self.add_rev('root', 'G', ['C', 'D', 'E'], 'hazcdyfg')
-        plan = self.plan_merge_vf.plan_merge('F', 'G')
-        self.assertEqual([
-                          ('unchanged', 'h\n'),
-                          ('unchanged', 'a\n'),
-                          ('killed-base', 'b\n'),
-                          ('killed-b', 'x\n'),
-                          ('new-b', 'z\n'),
-                          ('unchanged', 'c\n'),
-                          ('unchanged', 'd\n'),
-                          ('killed-base', 'e\n'),
-                          ('unchanged', 'y\n'),
-                          ('unchanged', 'f\n'),
-                          ('unchanged', 'g\n')],
-                         list(plan))
-
-    def assertRemoveExternalReferences(self, filtered_parent_map,
-                                       child_map, tails, parent_map):
-        """Assert results for _PlanMerge._remove_external_references."""
-        (act_filtered_parent_map, act_child_map,
-         act_tails) = _PlanMerge._remove_external_references(parent_map)
-
-        # The parent map *should* preserve ordering, but the ordering of
-        # children is not strictly defined
-        # child_map = dict((k, sorted(children))
-        #                  for k, children in child_map.iteritems())
-        # act_child_map = dict(k, sorted(children)
-        #                      for k, children in act_child_map.iteritems())
-        self.assertEqual(filtered_parent_map, act_filtered_parent_map)
-        self.assertEqual(child_map, act_child_map)
-        self.assertEqual(sorted(tails), sorted(act_tails))
-
-    def test__remove_external_references(self):
-        # First, nothing to remove
-        self.assertRemoveExternalReferences({3: [2], 2: [1], 1: []},
-            {1: [2], 2: [3], 3: []}, [1], {3: [2], 2: [1], 1: []})
-        # The reverse direction
-        self.assertRemoveExternalReferences({1: [2], 2: [3], 3: []},
-            {3: [2], 2: [1], 1: []}, [3], {1: [2], 2: [3], 3: []})
-        # Extra references
-        self.assertRemoveExternalReferences({3: [2], 2: [1], 1: []},
-            {1: [2], 2: [3], 3: []}, [1], {3: [2, 4], 2: [1, 5], 1: [6]})
-        # Multiple tails
-        self.assertRemoveExternalReferences(
-            {4: [2, 3], 3: [], 2: [1], 1: []},
-            {1: [2], 2: [4], 3: [4], 4: []},
-            [1, 3],
-            {4: [2, 3], 3: [5], 2: [1], 1: [6]})
-        # Multiple children
-        self.assertRemoveExternalReferences(
-            {1: [3], 2: [3, 4], 3: [], 4: []},
-            {1: [], 2: [], 3: [1, 2], 4: [2]},
-            [3, 4],
-            {1: [3], 2: [3, 4], 3: [5], 4: []})
-
-    def assertPruneTails(self, pruned_map, tails, parent_map):
-        child_map = {}
-        for key, parent_keys in parent_map.iteritems():
-            child_map.setdefault(key, [])
-            for pkey in parent_keys:
-                child_map.setdefault(pkey, []).append(key)
-        _PlanMerge._prune_tails(parent_map, child_map, tails)
-        self.assertEqual(pruned_map, parent_map)
-
-    def test__prune_tails(self):
-        # Nothing requested to prune
-        self.assertPruneTails({1: [], 2: [], 3: []}, [],
-                              {1: [], 2: [], 3: []})
-        # Prune a single entry
-        self.assertPruneTails({1: [], 3: []}, [2],
-                              {1: [], 2: [], 3: []})
-        # Prune a chain
-        self.assertPruneTails({1: []}, [3],
-                              {1: [], 2: [3], 3: []})
-        # Prune a chain with a diamond
-        self.assertPruneTails({1: []}, [5],
-                              {1: [], 2: [3, 4], 3: [5], 4: [5], 5: []})
-        # Prune a partial chain
-        self.assertPruneTails({1: [6], 6:[]}, [5],
-                              {1: [2, 6], 2: [3, 4], 3: [5], 4: [5], 5: [],
-                               6: []})
-        # Prune a chain with multiple tips, that pulls out intermediates
-        self.assertPruneTails({1:[3], 3:[]}, [4, 5],
-                              {1: [2, 3], 2: [4, 5], 3: [], 4:[], 5:[]})
-        self.assertPruneTails({1:[3], 3:[]}, [5, 4],
-                              {1: [2, 3], 2: [4, 5], 3: [], 4:[], 5:[]})
-
-    def test_subtract_plans(self):
-        old_plan = [
-        ('unchanged', 'a\n'),
-        ('new-a', 'b\n'),
-        ('killed-a', 'c\n'),
-        ('new-b', 'd\n'),
-        ('new-b', 'e\n'),
-        ('killed-b', 'f\n'),
-        ('killed-b', 'g\n'),
-        ]
-        new_plan = [
-        ('unchanged', 'a\n'),
-        ('new-a', 'b\n'),
-        ('killed-a', 'c\n'),
-        ('new-b', 'd\n'),
-        ('new-b', 'h\n'),
-        ('killed-b', 'f\n'),
-        ('killed-b', 'i\n'),
-        ]
-        subtracted_plan = [
-        ('unchanged', 'a\n'),
-        ('new-a', 'b\n'),
-        ('killed-a', 'c\n'),
-        ('new-b', 'h\n'),
-        ('unchanged', 'f\n'),
-        ('killed-b', 'i\n'),
-        ]
-        self.assertEqual(subtracted_plan,
-            list(_PlanMerge._subtract_plans(old_plan, new_plan)))
-
-    def setup_merge_with_base(self):
-        self.add_rev('root', 'COMMON', [], 'abc')
-        self.add_rev('root', 'THIS', ['COMMON'], 'abcd')
-        self.add_rev('root', 'BASE', ['COMMON'], 'eabc')
-        self.add_rev('root', 'OTHER', ['BASE'], 'eafb')
-
-    def test_plan_merge_with_base(self):
-        self.setup_merge_with_base()
-        plan = self.plan_merge_vf.plan_merge('THIS', 'OTHER', 'BASE')
-        self.assertEqual([('unchanged', 'a\n'),
-                          ('new-b', 'f\n'),
-                          ('unchanged', 'b\n'),
-                          ('killed-b', 'c\n'),
-                          ('new-a', 'd\n')
-                         ], list(plan))
-
-    def test_plan_lca_merge(self):
-        self.setup_plan_merge()
-        plan = self.plan_merge_vf.plan_lca_merge('B', 'C')
-        self.assertEqual([
-                          ('new-b', 'f\n'),
-                          ('unchanged', 'a\n'),
-                          ('killed-b', 'c\n'),
-                          ('new-a', 'e\n'),
-                          ('new-a', 'h\n'),
-                          ('killed-a', 'b\n'),
-                          ('unchanged', 'g\n')],
-                         list(plan))
-
-    def test_plan_lca_merge_uncommitted_files(self):
-        self.setup_plan_merge_uncommitted()
-        plan = self.plan_merge_vf.plan_lca_merge('B:', 'C:')
-        self.assertEqual([
-                          ('new-b', 'f\n'),
-                          ('unchanged', 'a\n'),
-                          ('killed-b', 'c\n'),
-                          ('new-a', 'e\n'),
-                          ('new-a', 'h\n'),
-                          ('killed-a', 'b\n'),
-                          ('unchanged', 'g\n')],
-                         list(plan))
-
-    def test_plan_lca_merge_with_base(self):
-        self.setup_merge_with_base()
-        plan = self.plan_merge_vf.plan_lca_merge('THIS', 'OTHER', 'BASE')
-        self.assertEqual([('unchanged', 'a\n'),
-                          ('new-b', 'f\n'),
-                          ('unchanged', 'b\n'),
-                          ('killed-b', 'c\n'),
-                          ('new-a', 'd\n')
-                         ], list(plan))
-
-    def test_plan_lca_merge_with_criss_cross(self):
-        self.add_version(('root', 'ROOT'), [], 'abc')
-        # each side makes a change
-        self.add_version(('root', 'REV1'), [('root', 'ROOT')], 'abcd')
-        self.add_version(('root', 'REV2'), [('root', 'ROOT')], 'abce')
-        # both sides merge, discarding others' changes
-        self.add_version(('root', 'LCA1'),
-            [('root', 'REV1'), ('root', 'REV2')], 'abcd')
-        self.add_version(('root', 'LCA2'),
-            [('root', 'REV1'), ('root', 'REV2')], 'fabce')
-        plan = self.plan_merge_vf.plan_lca_merge('LCA1', 'LCA2')
-        self.assertEqual([('new-b', 'f\n'),
-                          ('unchanged', 'a\n'),
-                          ('unchanged', 'b\n'),
-                          ('unchanged', 'c\n'),
-                          ('conflicted-a', 'd\n'),
-                          ('conflicted-b', 'e\n'),
-                         ], list(plan))
-
-    def test_plan_lca_merge_with_null(self):
-        self.add_version(('root', 'A'), [], 'ab')
-        self.add_version(('root', 'B'), [], 'bc')
-        plan = self.plan_merge_vf.plan_lca_merge('A', 'B')
-        self.assertEqual([('new-a', 'a\n'),
-                          ('unchanged', 'b\n'),
-                          ('new-b', 'c\n'),
-                         ], list(plan))
-
-    def test_plan_merge_with_delete_and_change(self):
-        self.add_rev('root', 'C', [], 'a')
-        self.add_rev('root', 'A', ['C'], 'b')
-        self.add_rev('root', 'B', ['C'], '')
-        plan = self.plan_merge_vf.plan_merge('A', 'B')
-        self.assertEqual([('killed-both', 'a\n'),
-                          ('new-a', 'b\n'),
-                         ], list(plan))
-
-    def test_plan_merge_with_move_and_change(self):
-        self.add_rev('root', 'C', [], 'abcd')
-        self.add_rev('root', 'A', ['C'], 'acbd')
-        self.add_rev('root', 'B', ['C'], 'aBcd')
-        plan = self.plan_merge_vf.plan_merge('A', 'B')
-        self.assertEqual([('unchanged', 'a\n'),
-                          ('new-a', 'c\n'),
-                          ('killed-b', 'b\n'),
-                          ('new-b', 'B\n'),
-                          ('killed-a', 'c\n'),
-                          ('unchanged', 'd\n'),
-                         ], list(plan))
-
-
-class TestMergeImplementation(object):
-
-    def do_merge(self, target_tree, source_tree, **kwargs):
-        merger = _mod_merge.Merger.from_revision_ids(progress.DummyProgress(),
-            target_tree, source_tree.last_revision(),
-            other_branch=source_tree.branch)
-        merger.merge_type=self.merge_type
-        for name, value in kwargs.items():
-            setattr(merger, name, value)
-        merger.do_merge()
-
-    def test_merge_specific_file(self):
-        this_tree = self.make_branch_and_tree('this')
-        this_tree.lock_write()
-        self.addCleanup(this_tree.unlock)
-        self.build_tree_contents([
-            ('this/file1', 'a\nb\n'),
-            ('this/file2', 'a\nb\n')
-        ])
-        this_tree.add(['file1', 'file2'])
-        this_tree.commit('Added files')
-        other_tree = this_tree.bzrdir.sprout('other').open_workingtree()
-        self.build_tree_contents([
-            ('other/file1', 'a\nb\nc\n'),
-            ('other/file2', 'a\nb\nc\n')
-        ])
-        other_tree.commit('modified both')
-        self.build_tree_contents([
-            ('this/file1', 'd\na\nb\n'),
-            ('this/file2', 'd\na\nb\n')
-        ])
-        this_tree.commit('modified both')
-        self.do_merge(this_tree, other_tree, interesting_files=['file1'])
-        self.assertFileEqual('d\na\nb\nc\n', 'this/file1')
-        self.assertFileEqual('d\na\nb\n', 'this/file2')
-
-    def test_merge_move_and_change(self):
-        this_tree = self.make_branch_and_tree('this')
-        this_tree.lock_write()
-        self.addCleanup(this_tree.unlock)
-        self.build_tree_contents([
-            ('this/file1', 'line 1\nline 2\nline 3\nline 4\n'),
-        ])
-        this_tree.add('file1',)
-        this_tree.commit('Added file')
-        other_tree = this_tree.bzrdir.sprout('other').open_workingtree()
-        self.build_tree_contents([
-            ('other/file1', 'line 1\nline 2 to 2.1\nline 3\nline 4\n'),
-        ])
-        other_tree.commit('Changed 2 to 2.1')
-        self.build_tree_contents([
-            ('this/file1', 'line 1\nline 3\nline 2\nline 4\n'),
-        ])
-        this_tree.commit('Swapped 2 & 3')
-        self.do_merge(this_tree, other_tree)
-        self.assertFileEqual('line 1\n'
-            '<<<<<<< TREE\n'
-            'line 3\n'
-            'line 2\n'
-            '=======\n'
-            'line 2 to 2.1\n'
-            'line 3\n'
-            '>>>>>>> MERGE-SOURCE\n'
-            'line 4\n', 'this/file1')
-
-
-class TestMerge3Merge(TestCaseWithTransport, TestMergeImplementation):
-
-    merge_type = _mod_merge.Merge3Merger
-
-
-class TestWeaveMerge(TestCaseWithTransport, TestMergeImplementation):
-
-    merge_type = _mod_merge.WeaveMerger
-
-
-class TestLCAMerge(TestCaseWithTransport, TestMergeImplementation):
-
-    merge_type = _mod_merge.LCAMerger
-
-    def test_merge_move_and_change(self):
-        self.expectFailure("lca merge doesn't conflict for move and change",
-            super(TestLCAMerge, self).test_merge_move_and_change)

=== modified file 'bzrlib/tests/test_merge3.py'
--- bzrlib/tests/test_merge3.py	2008-03-04 14:25:46 +0000
+++ bzrlib/tests/test_merge3.py	2007-03-12 19:56:41 +0000
@@ -383,42 +383,3 @@
         m_lines = m3.merge_lines('OTHER', 'THIS')
         self.assertEqual('<<<<<<< OTHER\rc\r=======\rb\r'
             '>>>>>>> THIS\r'.splitlines(True), list(m_lines))
-
-    def test_merge3_cherrypick(self):
-        base_text = "a\nb\n"
-        this_text = "a\n"
-        other_text = "a\nb\nc\n"
-        # When cherrypicking, lines in base are not part of the conflict
-        m3 = Merge3(base_text.splitlines(True), this_text.splitlines(True),
-                    other_text.splitlines(True), is_cherrypick=True)
-        m_lines = m3.merge_lines()
-        self.assertEqualDiff('a\n<<<<<<<\n=======\nc\n>>>>>>>\n',
-                             ''.join(m_lines))
-
-        # This is not symmetric
-        m3 = Merge3(base_text.splitlines(True), other_text.splitlines(True),
-                    this_text.splitlines(True), is_cherrypick=True)
-        m_lines = m3.merge_lines()
-        self.assertEqualDiff('a\n<<<<<<<\nb\nc\n=======\n>>>>>>>\n',
-                             ''.join(m_lines))
-
-    def test_merge3_cherrypick_w_mixed(self):
-        base_text = 'a\nb\nc\nd\ne\n'
-        this_text = 'a\nb\nq\n'
-        other_text = 'a\nb\nc\nd\nf\ne\ng\n'
-        # When cherrypicking, lines in base are not part of the conflict
-        m3 = Merge3(base_text.splitlines(True), this_text.splitlines(True),
-                    other_text.splitlines(True), is_cherrypick=True)
-        m_lines = m3.merge_lines()
-        self.assertEqualDiff('a\n'
-                             'b\n'
-                             '<<<<<<<\n'
-                             'q\n'
-                             '=======\n'
-                             'f\n'
-                             '>>>>>>>\n'
-                             '<<<<<<<\n'
-                             '=======\n'
-                             'g\n'
-                             '>>>>>>>\n',
-                             ''.join(m_lines))

=== modified file 'bzrlib/tests/test_merge_core.py'
--- bzrlib/tests/test_merge_core.py	2008-06-11 07:22:00 +0000
+++ bzrlib/tests/test_merge_core.py	2007-08-29 16:09:51 +0000
@@ -64,8 +64,7 @@
 
     def get_cset_path(self, parent, name):
         if name is None:
-            if parent is not None:
-                raise AssertionError()
+            assert (parent is None)
             return None
         return pathjoin(self.cset.entries[parent].path, name)
 
@@ -91,8 +90,7 @@
             tt.apply()
             wt.commit('branch commit')
             wt.flush()
-            if len(wt.branch.revision_history()) != 2:
-                raise AssertionError()
+            assert len(wt.branch.revision_history()) == 2
         self.this.branch.fetch(self.other.branch)
         other_basis = self.other.branch.basis_tree()
         merger = merge_type(self.this, self.this, self.base, other_basis, 
@@ -460,6 +458,7 @@
         file.close()
         mary_tree.commit("change file2")
         # john should be able to merge with no conflicts.
+        merge_type = Merge3Merger
         base = [None, None]
         other = ("mary", -1)
         tree.merge_from_branch(mary_tree.branch)
@@ -724,10 +723,8 @@
 
     def test_from_revision_ids(self):
         this, other = self.set_up_trees()
-        self.assertRaises(errors.NoSuchRevision, Merger.from_revision_ids,
+        self.assertRaises(errors.RevisionNotPresent, Merger.from_revision_ids,
                           progress.DummyProgress(), this, 'rev2b')
-        this.lock_write()
-        self.addCleanup(this.unlock)
         merger = Merger.from_revision_ids(progress.DummyProgress(), this,
             'rev2b', other_branch=other.branch)
         self.assertEqual('rev2b', merger.other_rev_id)
@@ -743,19 +740,11 @@
         self.assertIs(None, merger.other_rev_id)
         self.assertEqual('rev2b', merger.base_rev_id)
 
-    def prepare_for_merging(self):
+    def test_from_mergeable(self):
         this, other = self.set_up_trees()
         other.commit('rev3', rev_id='rev3')
-        this.lock_write()
-        self.addCleanup(this.unlock)
-        return this, other
-
-    def test_from_mergeable(self):
-        this, other = self.prepare_for_merging()
         md = merge_directive.MergeDirective2.from_objects(
             other.branch.repository, 'rev3', 0, 0, 'this')
-        other.lock_read()
-        self.addCleanup(other.unlock)
         merger, verified = Merger.from_mergeable(this, md,
             progress.DummyProgress())
         md.patch = None
@@ -768,14 +757,3 @@
         merger, verified = Merger.from_mergeable(this, md,
             progress.DummyProgress())
         self.assertEqual('rev2b', merger.base_rev_id)
-
-    def test_from_mergeable_old_merge_directive(self):
-        this, other = self.prepare_for_merging()
-        other.lock_write()
-        self.addCleanup(other.unlock)
-        md = merge_directive.MergeDirective.from_objects(
-            other.branch.repository, 'rev3', 0, 0, 'this')
-        merger, verified = Merger.from_mergeable(this, md,
-            progress.DummyProgress())
-        self.assertEqual('rev3', merger.other_rev_id)
-        self.assertEqual('rev1', merger.base_rev_id)

=== modified file 'bzrlib/tests/test_merge_directive.py'
--- bzrlib/tests/test_merge_directive.py	2008-07-28 12:40:59 +0000
+++ bzrlib/tests/test_merge_directive.py	2007-08-15 20:49:22 +0000
@@ -372,20 +372,6 @@
             tree_d.branch.base, patch_type='diff',
             public_branch=tree_a.branch.base)
 
-    def test_disk_name(self):
-        tree_a, tree_b, branch_c = self.make_trees()
-        tree_a.branch.nick = 'fancy <name>'
-        md = self.from_objects(tree_a.branch.repository, 'rev2a', 500, 120,
-            tree_b.branch.base)
-        self.assertEqual('fancy-name-2', md.get_disk_name(tree_a.branch))
-
-    def test_disk_name_old_revno(self):
-        tree_a, tree_b, branch_c = self.make_trees()
-        tree_a.branch.nick = 'fancy-name'
-        md = self.from_objects(tree_a.branch.repository, 'rev1', 500, 120,
-            tree_b.branch.base)
-        self.assertEqual('fancy-name-1', md.get_disk_name(tree_a.branch))
-
     def test_generate_patch(self):
         tree_a, tree_b, branch_c = self.make_trees()
         md2 = self.from_objects(tree_a.branch.repository, 'rev2a', 500, 120,
@@ -567,26 +553,6 @@
         revision = md.install_revisions(tree_b.branch.repository)
         self.assertEqual('rev2a', revision)
 
-    def test_use_submit_for_missing_dependency(self):
-        tree_a, tree_b, branch_c = self.make_trees()
-        branch_c.pull(tree_a.branch)
-        self.build_tree_contents([('tree_a/file', 'content_q\ncontent_r\n')])
-        tree_a.commit('rev3a', rev_id='rev3a')
-        md = self.from_objects(tree_a.branch.repository, 'rev3a', 500, 36,
-            branch_c.base, base_revision_id='rev2a')
-        revision = md.install_revisions(tree_b.branch.repository)
-
-    def test_handle_target_not_a_branch(self):
-        tree_a, tree_b, branch_c = self.make_trees()
-        branch_c.pull(tree_a.branch)
-        self.build_tree_contents([('tree_a/file', 'content_q\ncontent_r\n')])
-        tree_a.commit('rev3a', rev_id='rev3a')
-        md = self.from_objects(tree_a.branch.repository, 'rev3a', 500, 36,
-            branch_c.base, base_revision_id='rev2a')
-        md.target_branch = self.get_url('not-a-branch')
-        self.assertRaises(errors.TargetNotBranch, md.install_revisions,
-                tree_b.branch.repository)
-
 
 class TestMergeDirective1Branch(tests.TestCaseWithTransport,
     TestMergeDirectiveBranch):
@@ -598,17 +564,10 @@
 
     def from_objects(self, repository, revision_id, time, timezone,
         target_branch, patch_type='bundle', local_target_branch=None,
-        public_branch=None, message=None, base_revision_id=None):
-        if base_revision_id is not None:
-            raise tests.TestNotApplicable('This format does not support'
-                                          ' explicit bases.')
-        repository.lock_write()
-        try:
-            return merge_directive.MergeDirective.from_objects( repository,
-                revision_id, time, timezone, target_branch, patch_type,
-                local_target_branch, public_branch, message)
-        finally:
-            repository.unlock()
+        public_branch=None, message=None):
+        return merge_directive.MergeDirective.from_objects(
+            repository, revision_id, time, timezone, target_branch,
+            patch_type, local_target_branch, public_branch, message)
 
     def make_merge_directive(self, revision_id, testament_sha1, time, timezone,
                  target_branch, patch=None, patch_type=None,
@@ -631,7 +590,7 @@
         public_branch=None, message=None, base_revision_id=None):
         include_patch = (patch_type in ('bundle', 'diff'))
         include_bundle = (patch_type == 'bundle')
-        self.assertTrue(patch_type in ('bundle', 'diff', None))
+        assert patch_type in ('bundle', 'diff', None)
         return merge_directive.MergeDirective2.from_objects(
             repository, revision_id, time, timezone, target_branch,
             include_patch, include_bundle, local_target_branch, public_branch,

=== modified file 'bzrlib/tests/test_missing.py'
--- bzrlib/tests/test_missing.py	2008-05-19 21:35:52 +0000
+++ bzrlib/tests/test_missing.py	2007-07-25 22:03:13 +0000
@@ -17,23 +17,18 @@
 import os
 
 
-from bzrlib import (
-    missing,
-    tests,
-    )
 from bzrlib.missing import (
+    find_unmerged,
+    iter_log_data,
     iter_log_revisions,
     )
+from bzrlib.symbol_versioning import zero_seventeen
 from bzrlib.tests import TestCaseWithTransport
 from bzrlib.workingtree import WorkingTree
 
 
 class TestMissing(TestCaseWithTransport):
 
-    def assertUnmerged(self, expected, source, target, restrict='all'):
-        unmerged = missing.find_unmerged(source, target, restrict=restrict)
-        self.assertEqual(expected, unmerged)
-            
     def test_find_unmerged(self):
         original_tree = self.make_branch_and_tree('original')
         original = original_tree.branch
@@ -41,26 +36,97 @@
         puller = puller_tree.branch
         merger_tree = self.make_branch_and_tree('merger')
         merger = merger_tree.branch
-        self.assertUnmerged(([], []), original, puller)
+        self.assertEqual(find_unmerged(original, puller), ([], []))
         original_tree.commit('a', rev_id='a')
-        self.assertUnmerged(([(1, 'a')], []), original, puller)
+        self.assertEqual(find_unmerged(original, puller), ([(1, u'a')], []))
         puller_tree.pull(original)
-        self.assertUnmerged(([], []), original, puller)
+        self.assertEqual(find_unmerged(original, puller), ([], []))
         merger_tree.pull(original)
         original_tree.commit('b', rev_id='b')
         original_tree.commit('c', rev_id='c')
-        self.assertUnmerged(([(2, 'b'), (3, 'c')], []),
-                            original, puller)
+        self.assertEqual(find_unmerged(original, puller), ([(2, u'b'), 
+                                                            (3, u'c')], []))
 
         puller_tree.pull(original)
-        self.assertUnmerged(([], []), original, puller)
-        self.assertUnmerged(([(2, 'b'), (3, 'c')], []),
-                            original, merger)
+        self.assertEqual(find_unmerged(original, puller), ([], []))
+        self.assertEqual(find_unmerged(original, merger), ([(2, u'b'), 
+                                                            (3, u'c')], []))
         merger_tree.merge_from_branch(original)
-        self.assertUnmerged(([(2, 'b'), (3, 'c')], []),
-                            original, merger)
+        self.assertEqual(find_unmerged(original, merger), ([(2, u'b'), 
+                                                            (3, u'c')], []))
         merger_tree.commit('d', rev_id='d')
-        self.assertUnmerged(([], [(2, 'd')]), original, merger)
+        self.assertEqual(find_unmerged(original, merger), ([], [(2, 'd')]))
+
+    def test_iter_log_data(self):
+        base_tree = self.make_branch_and_tree('base')
+        self.build_tree(['base/a'])
+        base_tree.add(['a'], ['a-id'])
+        base_tree.commit('add a', rev_id='b-1')
+
+        child_tree = base_tree.bzrdir.sprout('child').open_workingtree()
+
+        self.build_tree(['child/b'])
+        child_tree.add(['b'], ['b-id'])
+        child_tree.commit('adding b', rev_id='c-2')
+
+        child_tree.remove(['a'])
+        child_tree.commit('removing a', rev_id='c-3')
+
+        self.build_tree_contents([('child/b', 'new contents for b\n')])
+        child_tree.commit('modifying b', rev_id='c-4')
+
+        child_tree.rename_one('b', 'c')
+        child_tree.commit('rename b=>c', rev_id='c-5')
+
+        base_extra, child_extra = find_unmerged(base_tree.branch,
+                                                child_tree.branch)
+        results = list(self.applyDeprecated(zero_seventeen, iter_log_data,
+                            base_extra,
+                            base_tree.branch.repository,
+                            verbose=True))
+        self.assertEqual([], results)
+
+        results = list(self.applyDeprecated(zero_seventeen, iter_log_data,
+                            child_extra,
+                            child_tree.branch.repository,
+                            verbose=True))
+        self.assertEqual(4, len(results))
+
+        r0,r1,r2,r3 = results
+
+        self.assertEqual((2, 'c-2'), (r0[0], r0[1].revision_id))
+        self.assertEqual((3, 'c-3'), (r1[0], r1[1].revision_id))
+        self.assertEqual((4, 'c-4'), (r2[0], r2[1].revision_id))
+        self.assertEqual((5, 'c-5'), (r3[0], r3[1].revision_id))
+
+        delta0 = r0[2]
+        self.assertNotEqual(None, delta0)
+        self.assertEqual([('b', 'b-id', 'file')], delta0.added)
+        self.assertEqual([], delta0.removed)
+        self.assertEqual([], delta0.renamed)
+        self.assertEqual([], delta0.modified)
+
+        delta1 = r1[2]
+        self.assertNotEqual(None, delta1)
+        self.assertEqual([], delta1.added)
+        self.assertEqual([('a', 'a-id', 'file')], delta1.removed)
+        self.assertEqual([], delta1.renamed)
+        self.assertEqual([], delta1.modified)
+
+        delta2 = r2[2]
+        self.assertNotEqual(None, delta2)
+        self.assertEqual([], delta2.added)
+        self.assertEqual([], delta2.removed)
+        self.assertEqual([], delta2.renamed)
+        self.assertEqual([('b', 'b-id', 'file', True, False)], delta2.modified)
+
+        delta3 = r3[2]
+        self.assertNotEqual(None, delta3)
+        self.assertEqual([], delta3.added)
+        self.assertEqual([], delta3.removed)
+        self.assertEqual([('b', 'c', 'b-id', 'file', False, False)],
+                         delta3.renamed)
+        self.assertEqual([], delta3.modified)
 
     def test_iter_log_revisions(self):
         base_tree = self.make_branch_and_tree('base')
@@ -83,8 +149,8 @@
         child_tree.rename_one('b', 'c')
         child_tree.commit('rename b=>c', rev_id='c-5')
 
-        base_extra, child_extra = missing.find_unmerged(base_tree.branch,
-                                                        child_tree.branch)
+        base_extra, child_extra = find_unmerged(base_tree.branch,
+                                                child_tree.branch)
         results = list(iter_log_revisions(base_extra, 
                             base_tree.branch.repository,
                             verbose=True))
@@ -130,63 +196,3 @@
         self.assertEqual([('b', 'c', 'b-id', 'file', False, False)],
                          delta3.renamed)
         self.assertEqual([], delta3.modified)
-
-
-class TestFindUnmerged(tests.TestCaseWithTransport):
-
-    def assertUnmerged(self, local, remote, local_branch, remote_branch,
-                       restrict):
-        """Check the output of find_unmerged_mainline_revisions"""
-        local_extra, remote_extra = missing.find_unmerged(
-                                        local_branch, remote_branch, restrict)
-        self.assertEqual(local, local_extra)
-        self.assertEqual(remote, remote_extra)
-
-    def test_same_branch(self):
-        tree = self.make_branch_and_tree('tree')
-        rev1 = tree.commit('one')
-        tree.lock_read()
-        self.addCleanup(tree.unlock)
-        self.assertUnmerged([], [], tree.branch, tree.branch, 'all')
-
-    def test_one_ahead(self):
-        tree = self.make_branch_and_tree('tree')
-        rev1 = tree.commit('one')
-        tree2 = tree.bzrdir.sprout('tree2').open_workingtree()
-        rev2 = tree2.commit('two')
-        tree.lock_read()
-        self.addCleanup(tree.unlock)
-        tree2.lock_read()
-        self.addCleanup(tree2.unlock)
-        self.assertUnmerged([], [(2, rev2)], tree.branch, tree2.branch, 'all')
-        self.assertUnmerged([(2, rev2)], [], tree2.branch, tree.branch, 'all')
-
-    def test_restrict(self):
-        tree = self.make_branch_and_tree('tree')
-        rev1 = tree.commit('one')
-        tree2 = tree.bzrdir.sprout('tree2').open_workingtree()
-        rev2 = tree2.commit('two')
-        tree.lock_read()
-        self.addCleanup(tree.unlock)
-        tree2.lock_read()
-        self.addCleanup(tree2.unlock)
-        self.assertUnmerged([], [(2, rev2)], tree.branch, tree2.branch, 'all')
-        self.assertUnmerged([], None, tree.branch, tree2.branch, 'local')
-        self.assertUnmerged(None, [(2, rev2)], tree.branch, tree2.branch,
-                                               'remote')
-
-    def test_merged(self):
-        tree = self.make_branch_and_tree('tree')
-        rev1 = tree.commit('one')
-        tree2 = tree.bzrdir.sprout('tree2').open_workingtree()
-        rev2 = tree2.commit('two')
-        rev3 = tree2.commit('three')
-        tree.merge_from_branch(tree2.branch)
-        rev4 = tree.commit('four')
-
-        tree.lock_read()
-        self.addCleanup(tree.unlock)
-        tree2.lock_read()
-        self.addCleanup(tree2.unlock)
-
-        self.assertUnmerged([(2, rev4)], [], tree.branch, tree2.branch, 'all')

=== modified file 'bzrlib/tests/test_msgeditor.py'
--- bzrlib/tests/test_msgeditor.py	2008-06-06 13:30:30 +0000
+++ bzrlib/tests/test_msgeditor.py	2007-10-04 05:35:10 +0000
@@ -25,7 +25,6 @@
     errors,
     msgeditor,
     osutils,
-    tests,
     )
 from bzrlib.branch import Branch
 from bzrlib.config import ensure_config_dir_exists, config_filename
@@ -34,26 +33,13 @@
     edit_commit_message_encoded
 )
 from bzrlib.tests import (
-    iter_suite_tests,
     probe_bad_non_ascii,
-    split_suite_by_re,
     TestCaseWithTransport,
-    TestNotApplicable,
     TestSkipped,
     )
-from bzrlib.tests.EncodingAdapter import EncodingTestAdapter
 from bzrlib.trace import mutter
 
 
-def load_tests(standard_tests, module, loader):
-    """Parameterize the test for tempfile creation with different encodings."""
-    to_adapt, result = split_suite_by_re(standard_tests,
-        "test__create_temp_file_with_commit_template_in_unicode_dir")
-    for test in iter_suite_tests(to_adapt):
-        result.addTests(EncodingTestAdapter().adapt(test))
-    return result
-
-
 class MsgEditorTest(TestCaseWithTransport):
 
     def make_uncommitted_tree(self):
@@ -257,15 +243,6 @@
                                     'infotext'])
         self.assertFileEqual(expected, msgfilename)
 
-    def test__create_temp_file_with_commit_template_in_unicode_dir(self):
-        self.requireFeature(tests.UnicodeFilenameFeature)
-        if hasattr(self, 'info'):
-            os.mkdir(self.info['directory'])
-            os.chdir(self.info['directory'])
-            msgeditor._create_temp_file_with_commit_template('infotext')
-        else:
-            raise TestNotApplicable('Test run elsewhere with non-ascii data.')
-
     def test__create_temp_file_with_empty_commit_template(self):
         # empty file
         create_file = msgeditor._create_temp_file_with_commit_template

=== removed file 'bzrlib/tests/test_mutabletree.py'
--- bzrlib/tests/test_mutabletree.py	2008-04-05 01:46:46 +0000
+++ bzrlib/tests/test_mutabletree.py	1970-01-01 00:00:00 +0000
@@ -1,40 +0,0 @@
-# Copyright (C) 2008 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Tests for MutableTree.
-
-Most functionality of MutableTree is tested as part of WorkingTree.
-"""
-
-from bzrlib.tests import TestCase
-from bzrlib.mutabletree import MutableTree, MutableTreeHooks
-
-class TestHooks(TestCase):
-
-    def test_constructor(self):
-        """Check that creating a MutableTreeHooks instance has the right 
-        defaults."""
-        hooks = MutableTreeHooks()
-        self.assertTrue("start_commit" in hooks, 
-                        "start_commit not in %s" % hooks)
-
-    def test_installed_hooks_are_MutableTreeHooks(self):
-        """The installed hooks object should be a MutableTreeHooks."""
-        # the installed hooks are saved in self._preserved_hooks.
-        self.assertIsInstance(self._preserved_hooks[MutableTree], 
-                              MutableTreeHooks)
-
-

=== modified file 'bzrlib/tests/test_nonascii.py'
--- bzrlib/tests/test_nonascii.py	2008-01-28 16:59:52 +0000
+++ bzrlib/tests/test_nonascii.py	2006-12-22 08:52:28 +0000
@@ -46,26 +46,18 @@
 a_dots_d = u'a\u0308'
 z_umlat_c = u'\u017d'
 z_umlat_d = u'Z\u030c'
-squared_c = u'\xbc' # This gets mapped to '2' if we use NFK[CD]
-squared_d = u'\xbc'
-quarter_c = u'\xb2' # Gets mapped to u'1\u20444' (1/4) if we use NFK[CD]
-quarter_d = u'\xb2'
 
 
 class TestNormalization(TestCase):
     """Verify that we have our normalizations correct."""
 
     def test_normalize(self):
-        self.assertEqual(a_circle_d, normalize('NFD', a_circle_c))
-        self.assertEqual(a_circle_c, normalize('NFC', a_circle_d))
-        self.assertEqual(a_dots_d, normalize('NFD', a_dots_c))
-        self.assertEqual(a_dots_c, normalize('NFC', a_dots_d))
-        self.assertEqual(z_umlat_d, normalize('NFD', z_umlat_c))
-        self.assertEqual(z_umlat_c, normalize('NFC', z_umlat_d))
-        self.assertEqual(squared_d, normalize('NFC', squared_c))
-        self.assertEqual(squared_c, normalize('NFD', squared_d))
-        self.assertEqual(quarter_d, normalize('NFC', quarter_c))
-        self.assertEqual(quarter_c, normalize('NFD', quarter_d))
+        self.assertEqual(a_circle_d, normalize('NFKD', a_circle_c))
+        self.assertEqual(a_circle_c, normalize('NFKC', a_circle_d))
+        self.assertEqual(a_dots_d, normalize('NFKD', a_dots_c))
+        self.assertEqual(a_dots_c, normalize('NFKC', a_dots_d))
+        self.assertEqual(z_umlat_d, normalize('NFKD', z_umlat_c))
+        self.assertEqual(z_umlat_c, normalize('NFKC', z_umlat_d))
 
 
 class NormalizedFilename(TestCaseWithTransport):
@@ -82,10 +74,6 @@
         self.assertEqual((a_dots_c, True), anf(a_dots_d))
         self.assertEqual((z_umlat_c, True), anf(z_umlat_c))
         self.assertEqual((z_umlat_c, True), anf(z_umlat_d))
-        self.assertEqual((squared_c, True), anf(squared_c))
-        self.assertEqual((squared_c, True), anf(squared_d))
-        self.assertEqual((quarter_c, True), anf(quarter_c))
-        self.assertEqual((quarter_c, True), anf(quarter_d))
 
     def test__inaccessible_normalized_filename(self):
         inf = osutils._inaccessible_normalized_filename
@@ -98,10 +86,6 @@
         self.assertEqual((a_dots_c, False), inf(a_dots_d))
         self.assertEqual((z_umlat_c, True), inf(z_umlat_c))
         self.assertEqual((z_umlat_c, False), inf(z_umlat_d))
-        self.assertEqual((squared_c, True), inf(squared_c))
-        self.assertEqual((squared_c, True), inf(squared_d))
-        self.assertEqual((quarter_c, True), inf(quarter_c))
-        self.assertEqual((quarter_c, True), inf(quarter_d))
 
     def test_functions(self):
         if osutils.normalizes_filenames():
@@ -137,8 +121,7 @@
         # a_circle_c and a_dots_c actually map to the same file
         # adding a suffix kicks in the 'preserving but insensitive'
         # route, and maintains the right files
-        files = [a_circle_c+'.1', a_dots_c+'.2', z_umlat_c+'.3',
-                 squared_c+'.4', quarter_c+'.5']
+        files = [a_circle_c+'.1', a_dots_c+'.2', z_umlat_c+'.3']
         try:
             self.build_tree(files, line_endings='native')
         except UnicodeError:

=== modified file 'bzrlib/tests/test_options.py'
--- bzrlib/tests/test_options.py	2008-08-31 19:39:01 +0000
+++ bzrlib/tests/test_options.py	2007-09-03 01:50:29 +0000
@@ -17,12 +17,15 @@
 import re
 
 from bzrlib import (
+    builtins,
     bzrdir,
     commands,
     errors,
     option,
+    repository,
+    symbol_versioning,
     )
-from bzrlib.builtins import cmd_commit
+from bzrlib.builtins import cmd_commit, cmd_log, cmd_status
 from bzrlib.commands import Command, parse_args
 from bzrlib.tests import TestCase
 from bzrlib.repofmt import knitrepo
@@ -38,18 +41,16 @@
 
     def test_parse_args(self):
         """Option parser"""
-        # XXX: Using cmd_commit makes these tests overly sensitive to changes
-        # to cmd_commit, when they are meant to be about option parsing in
-        # general.
-        self.assertEqual(parse_args(cmd_commit(), ['--help']),
-           ([], {'exclude': [], 'fixes': [], 'help': True}))
-        self.assertEqual(parse_args(cmd_commit(), ['--message=biter']),
-           ([], {'exclude': [], 'fixes': [], 'message': 'biter'}))
+        eq = self.assertEquals
+        eq(parse_args(cmd_commit(), ['--help']),
+           ([], {'fixes': [], 'help': True}))
+        eq(parse_args(cmd_commit(), ['--message=biter']),
+           ([], {'fixes': [], 'message': 'biter'}))
 
     def test_no_more_opts(self):
         """Terminated options"""
-        self.assertEqual(parse_args(cmd_commit(), ['--', '-file-with-dashes']),
-                          (['-file-with-dashes'], {'exclude': [], 'fixes': []}))
+        self.assertEquals(parse_args(cmd_commit(), ['--', '-file-with-dashes']),
+                          (['-file-with-dashes'], {'fixes': []}))
 
     def test_option_help(self):
         """Options have help strings."""
@@ -66,7 +67,7 @@
     def test_option_arg_help(self):
         """Help message shows option arguments."""
         out, err = self.run_bzr('help commit')
-        self.assertEqual(err, '')
+        self.assertEquals(err, '')
         self.assertContainsRe(out, r'--file[ =]MSGFILE')
 
     def test_unknown_short_opt(self):
@@ -80,7 +81,8 @@
 
     def test_allow_dash(self):
         """Test that we can pass a plain '-' as an argument."""
-        self.assertEqual((['-']), parse_args(cmd_commit(), ['-'])[0])
+        self.assertEqual(
+            (['-'], {'fixes': []}), parse_args(cmd_commit(), ['-']))
 
     def parse(self, options, args):
         parser = option.get_optparser(dict((o.name, o) for o in options))
@@ -256,12 +258,6 @@
         opts, args = self.parse(options, ['--hello=world', '--hello=sailor'])
         self.assertEqual(['world', 'sailor'], opts.hello)
 
-    def test_list_option_with_dash(self):
-        options = [option.ListOption('with-dash', type=str)]
-        opts, args = self.parse(options, ['--with-dash=world',
-                                          '--with-dash=sailor'])
-        self.assertEqual(['world', 'sailor'], opts.with_dash)
-
     def test_list_option_no_arguments(self):
         options = [option.ListOption('hello', type=str)]
         opts, args = self.parse(options, [])

=== modified file 'bzrlib/tests/test_osutils.py'
--- bzrlib/tests/test_osutils.py	2008-09-03 08:32:49 +0000
+++ bzrlib/tests/test_osutils.py	2007-10-22 16:03:11 +0000
@@ -16,19 +16,16 @@
 
 """Tests for the osutils wrapper."""
 
-from cStringIO import StringIO
 import errno
 import os
 import socket
 import stat
 import sys
-import time
 
 import bzrlib
 from bzrlib import (
     errors,
     osutils,
-    tests,
     win32utils,
     )
 from bzrlib.errors import BzrBadParameterNotUnicode, InvalidURL
@@ -36,54 +33,14 @@
         is_inside_any,
         is_inside_or_parent_of_any,
         pathjoin,
-        pumpfile,
-        pump_string_file,
         )
 from bzrlib.tests import (
-        adapt_tests,
-        Feature,
         probe_unicode_in_user_encoding,
-        split_suite_by_re,
         StringIOWrapper,
-        SymlinkFeature,
         TestCase,
         TestCaseInTempDir,
-        TestScenarioApplier,
         TestSkipped,
         )
-from bzrlib.tests.file_utils import (
-    FakeReadFile,
-    )
-from bzrlib.tests.test__walkdirs_win32 import WalkdirsWin32Feature
-
-
-def load_tests(standard_tests, module, loader):
-    """Parameterize readdir tests."""
-    to_adapt, result = split_suite_by_re(standard_tests, "readdir")
-    adapter = TestScenarioApplier()
-    from bzrlib import _readdir_py
-    adapter.scenarios = [('python', {'read_dir': _readdir_py.read_dir})]
-    if ReadDirFeature.available():
-        adapter.scenarios.append(('pyrex',
-            {'read_dir': ReadDirFeature.read_dir}))
-    adapt_tests(to_adapt, adapter, result)
-    return result
-
-
-class _ReadDirFeature(Feature):
-
-    def _probe(self):
-        try:
-            from bzrlib import _readdir_pyx
-            self.read_dir = _readdir_pyx.read_dir
-            return True
-        except ImportError:
-            return False
-
-    def feature_name(self):
-        return 'bzrlib._readdir_pyx'
-
-ReadDirFeature = _ReadDirFeature()
 
 
 class TestOSUtils(TestCaseInTempDir):
@@ -135,16 +92,6 @@
 
     # TODO: test fancy_rename using a MemoryTransport
 
-    def test_rename_change_case(self):
-        # on Windows we should be able to change filename case by rename
-        self.build_tree(['a', 'b/'])
-        osutils.rename('a', 'A')
-        osutils.rename('b', 'B')
-        # we can't use failUnlessExists on case-insensitive filesystem
-        # so try to check shape of the tree
-        shape = sorted(os.listdir('.'))
-        self.assertEquals(['A', 'B'], shape)
-
     def test_01_rand_chars_empty(self):
         result = osutils.rand_chars(0)
         self.assertEqual(result, '')
@@ -302,12 +249,9 @@
         self.assertFormatedDelta('1 second in the future', -1)
         self.assertFormatedDelta('2 seconds in the future', -2)
 
-    def test_format_date(self):
-        self.assertRaises(errors.UnsupportedTimezoneFormat,
-            osutils.format_date, 0, timezone='foo')
-
     def test_dereference_path(self):
-        self.requireFeature(SymlinkFeature)
+        if not osutils.has_symlinks():
+            raise TestSkipped('Symlinks are not supported on this platform')
         cwd = osutils.realpath('.')
         os.mkdir('bar')
         bar_path = osutils.pathjoin(cwd, 'bar')
@@ -340,12 +284,12 @@
 
         # Make a file readonly
         osutils.make_readonly('file')
-        mode = os.lstat('file').st_mode
+        mode = osutils.lstat('file').st_mode
         self.assertEqual(mode, mode & 0777555)
 
         # Make a file writable
         osutils.make_writable('file')
-        mode = os.lstat('file').st_mode
+        mode = osutils.lstat('file').st_mode
         self.assertEqual(mode, mode | 0200)
 
         if osutils.has_symlinks():
@@ -360,143 +304,6 @@
         self.assertEqual("@", osutils.kind_marker("symlink"))
         self.assertRaises(errors.BzrError, osutils.kind_marker, "unknown")
 
-    def test_host_os_dereferences_symlinks(self):
-        osutils.host_os_dereferences_symlinks()
-
-
-class TestPumpFile(TestCase):
-    """Test pumpfile method."""
-    def setUp(self):
-        # create a test datablock
-        self.block_size = 512
-        pattern = '0123456789ABCDEF'
-        self.test_data = pattern * (3 * self.block_size / len(pattern))
-        self.test_data_len = len(self.test_data)
-
-    def test_bracket_block_size(self):
-        """Read data in blocks with the requested read size bracketing the
-        block size."""
-        # make sure test data is larger than max read size
-        self.assertTrue(self.test_data_len > self.block_size)
-
-        from_file = FakeReadFile(self.test_data)
-        to_file = StringIO()
-
-        # read (max / 2) bytes and verify read size wasn't affected
-        num_bytes_to_read = self.block_size / 2
-        pumpfile(from_file, to_file, num_bytes_to_read, self.block_size)
-        self.assertEqual(from_file.get_max_read_size(), num_bytes_to_read)
-        self.assertEqual(from_file.get_read_count(), 1)
-
-        # read (max) bytes and verify read size wasn't affected
-        num_bytes_to_read = self.block_size
-        from_file.reset_read_count()
-        pumpfile(from_file, to_file, num_bytes_to_read, self.block_size)
-        self.assertEqual(from_file.get_max_read_size(), num_bytes_to_read)
-        self.assertEqual(from_file.get_read_count(), 1)
-
-        # read (max + 1) bytes and verify read size was limited
-        num_bytes_to_read = self.block_size + 1
-        from_file.reset_read_count()
-        pumpfile(from_file, to_file, num_bytes_to_read, self.block_size)
-        self.assertEqual(from_file.get_max_read_size(), self.block_size)
-        self.assertEqual(from_file.get_read_count(), 2)
-
-        # finish reading the rest of the data
-        num_bytes_to_read = self.test_data_len - to_file.tell()
-        pumpfile(from_file, to_file, num_bytes_to_read, self.block_size)
-
-        # report error if the data wasn't equal (we only report the size due
-        # to the length of the data)
-        response_data = to_file.getvalue()
-        if response_data != self.test_data:
-            message = "Data not equal.  Expected %d bytes, received %d."
-            self.fail(message % (len(response_data), self.test_data_len))
-
-    def test_specified_size(self):
-        """Request a transfer larger than the maximum block size and verify
-        that the maximum read doesn't exceed the block_size."""
-        # make sure test data is larger than max read size
-        self.assertTrue(self.test_data_len > self.block_size)
-
-        # retrieve data in blocks
-        from_file = FakeReadFile(self.test_data)
-        to_file = StringIO()
-        pumpfile(from_file, to_file, self.test_data_len, self.block_size)
-
-        # verify read size was equal to the maximum read size
-        self.assertTrue(from_file.get_max_read_size() > 0)
-        self.assertEqual(from_file.get_max_read_size(), self.block_size)
-        self.assertEqual(from_file.get_read_count(), 3)
-
-        # report error if the data wasn't equal (we only report the size due
-        # to the length of the data)
-        response_data = to_file.getvalue()
-        if response_data != self.test_data:
-            message = "Data not equal.  Expected %d bytes, received %d."
-            self.fail(message % (len(response_data), self.test_data_len))
-
-    def test_to_eof(self):
-        """Read to end-of-file and verify that the reads are not larger than
-        the maximum read size."""
-        # make sure test data is larger than max read size
-        self.assertTrue(self.test_data_len > self.block_size)
-
-        # retrieve data to EOF
-        from_file = FakeReadFile(self.test_data)
-        to_file = StringIO()
-        pumpfile(from_file, to_file, -1, self.block_size)
-
-        # verify read size was equal to the maximum read size
-        self.assertEqual(from_file.get_max_read_size(), self.block_size)
-        self.assertEqual(from_file.get_read_count(), 4)
-
-        # report error if the data wasn't equal (we only report the size due
-        # to the length of the data)
-        response_data = to_file.getvalue()
-        if response_data != self.test_data:
-            message = "Data not equal.  Expected %d bytes, received %d."
-            self.fail(message % (len(response_data), self.test_data_len))
-
-    def test_defaults(self):
-        """Verifies that the default arguments will read to EOF -- this
-        test verifies that any existing usages of pumpfile will not be broken
-        with this new version."""
-        # retrieve data using default (old) pumpfile method
-        from_file = FakeReadFile(self.test_data)
-        to_file = StringIO()
-        pumpfile(from_file, to_file)
-
-        # report error if the data wasn't equal (we only report the size due
-        # to the length of the data)
-        response_data = to_file.getvalue()
-        if response_data != self.test_data:
-            message = "Data not equal.  Expected %d bytes, received %d."
-            self.fail(message % (len(response_data), self.test_data_len))
-
-
-class TestPumpStringFile(TestCase):
-
-    def test_empty(self):
-        output = StringIO()
-        pump_string_file("", output)
-        self.assertEqual("", output.getvalue())
-
-    def test_more_than_segment_size(self):
-        output = StringIO()
-        pump_string_file("123456789", output, 2)
-        self.assertEqual("123456789", output.getvalue())
-
-    def test_segment_size(self):
-        output = StringIO()
-        pump_string_file("12", output, 2)
-        self.assertEqual("12", output.getvalue())
-
-    def test_segment_size_multiple(self):
-        output = StringIO()
-        pump_string_file("1234", output, 2)
-        self.assertEqual("1234", output.getvalue())
-
 
 class TestSafeUnicode(TestCase):
 
@@ -779,38 +586,6 @@
 
 class TestWalkDirs(TestCaseInTempDir):
 
-    def test_readdir(self):
-        tree = [
-            '.bzr/',
-            '0file',
-            '1dir/',
-            '1dir/0file',
-            '1dir/1dir/',
-            '2file'
-            ]
-        self.build_tree(tree)
-        expected_names = ['.bzr', '0file', '1dir', '2file']
-        # read_dir returns pairs, which form a table with either None in all
-        # the first columns, or a sort key to get best on-disk-read order, 
-        # and the disk path name in utf-8 encoding in the second column.
-        read_result = self.read_dir('.')
-        # The second column is always the names, and every name except "." and
-        # ".." should be present.
-        names = sorted([row[1] for row in read_result])
-        self.assertEqual(expected_names, names)
-        expected_sort_key = None
-        if read_result[0][0] is None:
-            # No sort key returned - all keys must None
-            operator = self.assertEqual
-        else:
-            # A sort key in the first row implies sort keys in the other rows.
-            operator = self.assertNotEqual
-        for row in read_result:
-            operator(None, row[0])
-
-    def test_compiled_extension_exists(self):
-        self.requireFeature(ReadDirFeature)
-        
     def test_walkdirs(self):
         tree = [
             '.bzr',
@@ -912,80 +687,6 @@
                 new_dirblock.append((info[0], info[1], info[2], info[4]))
             dirblock[:] = new_dirblock
 
-    def test__walkdirs_utf8_selection(self):
-        # Just trigger the function once, to make sure it has selected a real
-        # implementation.
-        list(osutils._walkdirs_utf8('.'))
-        if WalkdirsWin32Feature.available():
-            # If the compiled form is available, make sure it is used
-            from bzrlib._walkdirs_win32 import _walkdirs_utf8_win32_find_file
-            self.assertIs(_walkdirs_utf8_win32_find_file,
-                          osutils._real_walkdirs_utf8)
-        elif sys.platform == 'win32':
-            self.assertIs(osutils._walkdirs_unicode_to_utf8,
-                          osutils._real_walkdirs_utf8)
-        elif osutils._fs_enc.upper() in ('UTF-8', 'ASCII', 'ANSI_X3.4-1968'): # ascii
-            self.assertIs(osutils._walkdirs_fs_utf8,
-                          osutils._real_walkdirs_utf8)
-        else:
-            self.assertIs(osutils._walkdirs_unicode_to_utf8,
-                          osutils._real_walkdirs_utf8)
-
-    def _save_platform_info(self):
-        cur_winver = win32utils.winver
-        cur_fs_enc = osutils._fs_enc
-        cur_real_walkdirs_utf8 = osutils._real_walkdirs_utf8
-        def restore():
-            win32utils.winver = cur_winver
-            osutils._fs_enc = cur_fs_enc
-            osutils._real_walkdirs_utf8 = cur_real_walkdirs_utf8
-        self.addCleanup(restore)
-
-    def assertWalkdirsUtf8Is(self, expected):
-        """Assert the right implementation for _walkdirs_utf8 is chosen."""
-        # Force it to redetect
-        osutils._real_walkdirs_utf8 = None
-        # Nothing to list, but should still trigger the selection logic
-        self.assertEqual([(('', '.'), [])], list(osutils._walkdirs_utf8('.')))
-        self.assertIs(expected, osutils._real_walkdirs_utf8)
-
-    def test_force_walkdirs_utf8_fs_utf8(self):
-        self._save_platform_info()
-        win32utils.winver = None # Avoid the win32 detection code
-        osutils._fs_enc = 'UTF-8'
-        self.assertWalkdirsUtf8Is(osutils._walkdirs_fs_utf8)
-
-    def test_force_walkdirs_utf8_fs_ascii(self):
-        self._save_platform_info()
-        win32utils.winver = None # Avoid the win32 detection code
-        osutils._fs_enc = 'US-ASCII'
-        self.assertWalkdirsUtf8Is(osutils._walkdirs_fs_utf8)
-
-    def test_force_walkdirs_utf8_fs_ANSI(self):
-        self._save_platform_info()
-        win32utils.winver = None # Avoid the win32 detection code
-        osutils._fs_enc = 'ANSI_X3.4-1968'
-        self.assertWalkdirsUtf8Is(osutils._walkdirs_fs_utf8)
-
-    def test_force_walkdirs_utf8_fs_latin1(self):
-        self._save_platform_info()
-        win32utils.winver = None # Avoid the win32 detection code
-        osutils._fs_enc = 'latin1'
-        self.assertWalkdirsUtf8Is(osutils._walkdirs_unicode_to_utf8)
-
-    def test_force_walkdirs_utf8_nt(self):
-        self.requireFeature(WalkdirsWin32Feature)
-        self._save_platform_info()
-        win32utils.winver = 'Windows NT'
-        from bzrlib._walkdirs_win32 import _walkdirs_utf8_win32_find_file
-        self.assertWalkdirsUtf8Is(_walkdirs_utf8_win32_find_file)
-
-    def test_force_walkdirs_utf8_nt(self):
-        self.requireFeature(WalkdirsWin32Feature)
-        self._save_platform_info()
-        win32utils.winver = 'Windows 98'
-        self.assertWalkdirsUtf8Is(osutils._walkdirs_unicode_to_utf8)
-
     def test_unicode_walkdirs(self):
         """Walkdirs should always return unicode paths."""
         name0 = u'0file-\xb6'
@@ -1142,99 +843,6 @@
         self._filter_out_stat(result)
         self.assertEqual(expected_dirblocks, result)
 
-    def test__walkdirs_utf_win32_find_file(self):
-        self.requireFeature(WalkdirsWin32Feature)
-        self.requireFeature(tests.UnicodeFilenameFeature)
-        from bzrlib._walkdirs_win32 import _walkdirs_utf8_win32_find_file
-        name0u = u'0file-\xb6'
-        name1u = u'1dir-\u062c\u0648'
-        name2u = u'2file-\u0633'
-        tree = [
-            name0u,
-            name1u + '/',
-            name1u + '/' + name0u,
-            name1u + '/' + name1u + '/',
-            name2u,
-            ]
-        self.build_tree(tree)
-        name0 = name0u.encode('utf8')
-        name1 = name1u.encode('utf8')
-        name2 = name2u.encode('utf8')
-
-        # All of the abspaths should be in unicode, all of the relative paths
-        # should be in utf8
-        expected_dirblocks = [
-                (('', '.'),
-                 [(name0, name0, 'file', './' + name0u),
-                  (name1, name1, 'directory', './' + name1u),
-                  (name2, name2, 'file', './' + name2u),
-                 ]
-                ),
-                ((name1, './' + name1u),
-                 [(name1 + '/' + name0, name0, 'file', './' + name1u
-                                                        + '/' + name0u),
-                  (name1 + '/' + name1, name1, 'directory', './' + name1u
-                                                            + '/' + name1u),
-                 ]
-                ),
-                ((name1 + '/' + name1, './' + name1u + '/' + name1u),
-                 [
-                 ]
-                ),
-            ]
-        result = list(_walkdirs_utf8_win32_find_file(u'.'))
-        self._filter_out_stat(result)
-        self.assertEqual(expected_dirblocks, result)
-
-    def assertStatIsCorrect(self, path, win32stat):
-        os_stat = os.stat(path)
-        self.assertEqual(os_stat.st_size, win32stat.st_size)
-        self.assertAlmostEqual(os_stat.st_mtime, win32stat.st_mtime, places=4)
-        self.assertAlmostEqual(os_stat.st_ctime, win32stat.st_ctime, places=4)
-        self.assertAlmostEqual(os_stat.st_atime, win32stat.st_atime, places=4)
-        self.assertEqual(os_stat.st_dev, win32stat.st_dev)
-        self.assertEqual(os_stat.st_ino, win32stat.st_ino)
-        self.assertEqual(os_stat.st_mode, win32stat.st_mode)
-
-    def test__walkdirs_utf_win32_find_file_stat_file(self):
-        """make sure our Stat values are valid"""
-        self.requireFeature(WalkdirsWin32Feature)
-        self.requireFeature(tests.UnicodeFilenameFeature)
-        from bzrlib._walkdirs_win32 import _walkdirs_utf8_win32_find_file
-        name0u = u'0file-\xb6'
-        name0 = name0u.encode('utf8')
-        self.build_tree([name0u])
-        # I hate to sleep() here, but I'm trying to make the ctime different
-        # from the mtime
-        time.sleep(2)
-        f = open(name0u, 'ab')
-        try:
-            f.write('just a small update')
-        finally:
-            f.close()
-
-        result = list(_walkdirs_utf8_win32_find_file(u'.'))
-        entry = result[0][1][0]
-        self.assertEqual((name0, name0, 'file'), entry[:3])
-        self.assertEqual(u'./' + name0u, entry[4])
-        self.assertStatIsCorrect(entry[4], entry[3])
-        self.assertNotEqual(entry[3].st_mtime, entry[3].st_ctime)
-
-    def test__walkdirs_utf_win32_find_file_stat_directory(self):
-        """make sure our Stat values are valid"""
-        self.requireFeature(WalkdirsWin32Feature)
-        self.requireFeature(tests.UnicodeFilenameFeature)
-        from bzrlib._walkdirs_win32 import _walkdirs_utf8_win32_find_file
-        name0u = u'0dir-\u062c\u0648'
-        name0 = name0u.encode('utf8')
-        self.build_tree([name0u + '/'])
-
-        result = list(_walkdirs_utf8_win32_find_file(u'.'))
-        entry = result[0][1][0]
-        self.assertEqual((name0, name0, 'directory'), entry[:3])
-        self.assertEqual(u'./' + name0u, entry[4])
-        self.assertStatIsCorrect(entry[4], entry[3])
-
     def assertPathCompare(self, path_less, path_greater):
         """check that path_less and path_greater compare correctly."""
         self.assertEqual(0, osutils.compare_paths_prefix_order(
@@ -1329,7 +937,8 @@
         self.assertEqual(['c'], os.listdir('target/b'))
 
     def test_copy_tree_symlinks(self):
-        self.requireFeature(SymlinkFeature)
+        if not osutils.has_symlinks():
+            return
         self.build_tree(['source/'])
         os.symlink('a/generic/path', 'source/lnk')
         osutils.copy_tree('source', 'target')
@@ -1453,66 +1062,3 @@
         self.build_tree_contents([('foo', text)])
         expected_sha = osutils.sha_string(text)
         self.assertEqual(expected_sha, osutils.sha_file_by_name('foo'))
-
-
-_debug_text = \
-r'''# Copyright (C) 2005, 2006 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-
-# NOTE: If update these, please also update the help for global-options in
-#       bzrlib/help_topics/__init__.py
-
-debug_flags = set()
-"""Set of flags that enable different debug behaviour.
-
-These are set with eg ``-Dlock`` on the bzr command line.
-
-Options include:
- 
- * auth - show authentication sections used
- * error - show stack traces for all top level exceptions
- * evil - capture call sites that do expensive or badly-scaling operations.
- * fetch - trace history copying between repositories
- * graph - trace graph traversal information
- * hashcache - log every time a working file is read to determine its hash
- * hooks - trace hook execution
- * hpss - trace smart protocol requests and responses
- * http - trace http connections, requests and responses
- * index - trace major index operations
- * knit - trace knit operations
- * lock - trace when lockdir locks are taken or released
- * merge - emit information for debugging merges
- * pack - emit information about pack operations
-
-"""
-'''
-
-
-class TestResourceLoading(TestCaseInTempDir):
-
-    def test_resource_string(self):
-        # test resource in bzrlib
-        text = osutils.resource_string('bzrlib', 'debug.py')
-        self.assertEquals(_debug_text, text)
-        # test resource under bzrlib
-        text = osutils.resource_string('bzrlib.ui', 'text.py')
-        self.assertContainsRe(text, "class TextUIFactory")
-        # test unsupported package
-        self.assertRaises(errors.BzrError, osutils.resource_string, 'zzzz',
-            'yyy.xx')
-        # test unknown resource
-        self.assertRaises(IOError, osutils.resource_string, 'bzrlib', 'yyy.xx')

=== modified file 'bzrlib/tests/test_osutils_encodings.py'
--- bzrlib/tests/test_osutils_encodings.py	2008-05-05 17:02:02 +0000
+++ bzrlib/tests/test_osutils_encodings.py	2007-01-04 23:36:44 +0000
@@ -29,6 +29,7 @@
 from bzrlib.tests import (
         StringIOWrapper,
         TestCase, 
+        TestSkipped,
         )
 
 
@@ -197,15 +198,6 @@
                           ' Continuing with ascii encoding.\n',
                           sys.stderr.getvalue())
 
-    def test_user_empty(self):
-        """Running bzr from a vim script gives '' for a preferred locale"""
-        def f():
-            return ''
-
-        locale.getpreferredencoding = f
-        self.assertEquals('ascii', osutils.get_user_encoding(use_cache=False))
-        self.assertEquals('', sys.stderr.getvalue())
-
     def test_user_locale_error(self):
         def f():
             raise locale.Error, 'unsupported locale'

=== modified file 'bzrlib/tests/test_pack.py'
--- bzrlib/tests/test_pack.py	2007-10-29 08:34:38 +0000
+++ bzrlib/tests/test_pack.py	2007-08-28 05:17:06 +0000
@@ -22,181 +22,151 @@
 from bzrlib import pack, errors, tests
 
 
-class TestContainerSerialiser(tests.TestCase):
-    """Tests for the ContainerSerialiser class."""
-
-    def test_construct(self):
-        """Test constructing a ContainerSerialiser."""
-        pack.ContainerSerialiser()
-
-    def test_begin(self):
-        serialiser = pack.ContainerSerialiser()
-        self.assertEqual('Bazaar pack format 1 (introduced in 0.18)\n',
-                         serialiser.begin())
-
-    def test_end(self):
-        serialiser = pack.ContainerSerialiser()
-        self.assertEqual('E', serialiser.end())
-
-    def test_bytes_record_no_name(self):
-        serialiser = pack.ContainerSerialiser()
-        record = serialiser.bytes_record('bytes', [])
-        self.assertEqual('B5\n\nbytes', record)
-        
-    def test_bytes_record_one_name_with_one_part(self):
-        serialiser = pack.ContainerSerialiser()
-        record = serialiser.bytes_record('bytes', [('name',)])
-        self.assertEqual('B5\nname\n\nbytes', record)
-        
-    def test_bytes_record_one_name_with_two_parts(self):
-        serialiser = pack.ContainerSerialiser()
-        record = serialiser.bytes_record('bytes', [('part1', 'part2')])
-        self.assertEqual('B5\npart1\x00part2\n\nbytes', record)
-        
-    def test_bytes_record_two_names(self):
-        serialiser = pack.ContainerSerialiser()
-        record = serialiser.bytes_record('bytes', [('name1',), ('name2',)])
-        self.assertEqual('B5\nname1\nname2\n\nbytes', record)
-
-    def test_bytes_record_whitespace_in_name_part(self):
-        serialiser = pack.ContainerSerialiser()
-        self.assertRaises(
-            errors.InvalidRecordError,
-            serialiser.bytes_record, 'bytes', [('bad name',)])
-
-
 class TestContainerWriter(tests.TestCase):
 
-    def setUp(self):
-        self.output = StringIO()
-        self.writer = pack.ContainerWriter(self.output.write)
-
-    def assertOutput(self, expected_output):
-        """Assert that the output of self.writer ContainerWriter is equal to
-        expected_output.
-        """
-        self.assertEqual(expected_output, self.output.getvalue())
-
     def test_construct(self):
         """Test constructing a ContainerWriter.
         
-        This uses None as the output stream to show that the constructor
-        doesn't try to use the output stream.
+        This uses None as the output stream to show that the constructor doesn't
+        try to use the output stream.
         """
         writer = pack.ContainerWriter(None)
 
     def test_begin(self):
         """The begin() method writes the container format marker line."""
-        self.writer.begin()
-        self.assertOutput('Bazaar pack format 1 (introduced in 0.18)\n')
+        output = StringIO()
+        writer = pack.ContainerWriter(output.write)
+        writer.begin()
+        self.assertEqual('Bazaar pack format 1 (introduced in 0.18)\n',
+                         output.getvalue())
 
     def test_zero_records_written_after_begin(self):
         """After begin is written, 0 records have been written."""
-        self.writer.begin()
-        self.assertEqual(0, self.writer.records_written)
+        output = StringIO()
+        writer = pack.ContainerWriter(output.write)
+        writer.begin()
+        self.assertEqual(0, writer.records_written)
 
     def test_end(self):
         """The end() method writes an End Marker record."""
-        self.writer.begin()
-        self.writer.end()
-        self.assertOutput('Bazaar pack format 1 (introduced in 0.18)\nE')
+        output = StringIO()
+        writer = pack.ContainerWriter(output.write)
+        writer.begin()
+        writer.end()
+        self.assertEqual('Bazaar pack format 1 (introduced in 0.18)\nE',
+                         output.getvalue())
 
     def test_empty_end_does_not_add_a_record_to_records_written(self):
         """The end() method does not count towards the records written."""
-        self.writer.begin()
-        self.writer.end()
-        self.assertEqual(0, self.writer.records_written)
+        output = StringIO()
+        writer = pack.ContainerWriter(output.write)
+        writer.begin()
+        writer.end()
+        self.assertEqual(0, writer.records_written)
 
     def test_non_empty_end_does_not_add_a_record_to_records_written(self):
         """The end() method does not count towards the records written."""
-        self.writer.begin()
-        self.writer.add_bytes_record('foo', names=[])
-        self.writer.end()
-        self.assertEqual(1, self.writer.records_written)
+        output = StringIO()
+        writer = pack.ContainerWriter(output.write)
+        writer.begin()
+        writer.add_bytes_record('foo', names=[])
+        writer.end()
+        self.assertEqual(1, writer.records_written)
 
     def test_add_bytes_record_no_name(self):
         """Add a bytes record with no name."""
-        self.writer.begin()
-        offset, length = self.writer.add_bytes_record('abc', names=[])
+        output = StringIO()
+        writer = pack.ContainerWriter(output.write)
+        writer.begin()
+        offset, length = writer.add_bytes_record('abc', names=[])
         self.assertEqual((42, 7), (offset, length))
-        self.assertOutput(
-            'Bazaar pack format 1 (introduced in 0.18)\nB3\n\nabc')
+        self.assertEqual('Bazaar pack format 1 (introduced in 0.18)\nB3\n\nabc',
+                         output.getvalue())
 
     def test_add_bytes_record_one_name(self):
         """Add a bytes record with one name."""
-        self.writer.begin()
-        offset, length = self.writer.add_bytes_record(
-            'abc', names=[('name1', )])
+        output = StringIO()
+        writer = pack.ContainerWriter(output.write)
+        writer.begin()
+        offset, length = writer.add_bytes_record('abc', names=[('name1', )])
         self.assertEqual((42, 13), (offset, length))
-        self.assertOutput(
-            'Bazaar pack format 1 (introduced in 0.18)\n'
-            'B3\nname1\n\nabc')
-
-    def test_add_bytes_record_two_names(self):
-        """Add a bytes record with two names."""
-        self.writer.begin()
-        offset, length = self.writer.add_bytes_record(
-            'abc', names=[('name1', ), ('name2', )])
-        self.assertEqual((42, 19), (offset, length))
-        self.assertOutput(
-            'Bazaar pack format 1 (introduced in 0.18)\n'
-            'B3\nname1\nname2\n\nabc')
-
-    def test_add_bytes_record_two_names(self):
-        """Add a bytes record with two names."""
-        self.writer.begin()
-        offset, length = self.writer.add_bytes_record(
-            'abc', names=[('name1', ), ('name2', )])
-        self.assertEqual((42, 19), (offset, length))
-        self.assertOutput(
-            'Bazaar pack format 1 (introduced in 0.18)\n'
-            'B3\nname1\nname2\n\nabc')
+        self.assertEqual(
+            'Bazaar pack format 1 (introduced in 0.18)\n'
+            'B3\nname1\n\nabc',
+            output.getvalue())
+
+    def test_add_bytes_record_two_names(self):
+        """Add a bytes record with two names."""
+        output = StringIO()
+        writer = pack.ContainerWriter(output.write)
+        writer.begin()
+        offset, length = writer.add_bytes_record('abc', names=[('name1', ), ('name2', )])
+        self.assertEqual((42, 19), (offset, length))
+        self.assertEqual(
+            'Bazaar pack format 1 (introduced in 0.18)\n'
+            'B3\nname1\nname2\n\nabc',
+            output.getvalue())
+
+    def test_add_bytes_record_two_names(self):
+        """Add a bytes record with two names."""
+        output = StringIO()
+        writer = pack.ContainerWriter(output.write)
+        writer.begin()
+        offset, length = writer.add_bytes_record('abc', names=[('name1', ), ('name2', )])
+        self.assertEqual((42, 19), (offset, length))
+        self.assertEqual(
+            'Bazaar pack format 1 (introduced in 0.18)\n'
+            'B3\nname1\nname2\n\nabc',
+            output.getvalue())
 
     def test_add_bytes_record_two_element_name(self):
         """Add a bytes record with a two-element name."""
-        self.writer.begin()
-        offset, length = self.writer.add_bytes_record(
-            'abc', names=[('name1', 'name2')])
+        output = StringIO()
+        writer = pack.ContainerWriter(output.write)
+        writer.begin()
+        offset, length = writer.add_bytes_record('abc', names=[('name1', 'name2')])
         self.assertEqual((42, 19), (offset, length))
-        self.assertOutput(
+        self.assertEqual(
             'Bazaar pack format 1 (introduced in 0.18)\n'
-            'B3\nname1\x00name2\n\nabc')
+            'B3\nname1\x00name2\n\nabc',
+            output.getvalue())
 
     def test_add_second_bytes_record_gets_higher_offset(self):
-        self.writer.begin()
-        self.writer.add_bytes_record('abc', names=[])
-        offset, length = self.writer.add_bytes_record('abc', names=[])
+        output = StringIO()
+        writer = pack.ContainerWriter(output.write)
+        writer.begin()
+        writer.add_bytes_record('abc', names=[])
+        offset, length = writer.add_bytes_record('abc', names=[])
         self.assertEqual((49, 7), (offset, length))
-        self.assertOutput(
+        self.assertEqual(
             'Bazaar pack format 1 (introduced in 0.18)\n'
             'B3\n\nabc'
-            'B3\n\nabc')
+            'B3\n\nabc',
+            output.getvalue())
 
     def test_add_bytes_record_invalid_name(self):
         """Adding a Bytes record with a name with whitespace in it raises
         InvalidRecordError.
         """
-        self.writer.begin()
+        output = StringIO()
+        writer = pack.ContainerWriter(output.write)
+        writer.begin()
         self.assertRaises(
             errors.InvalidRecordError,
-            self.writer.add_bytes_record, 'abc', names=[('bad name', )])
+            writer.add_bytes_record, 'abc', names=[('bad name', )])
 
     def test_add_bytes_records_add_to_records_written(self):
         """Adding a Bytes record increments the records_written counter."""
-        self.writer.begin()
-        self.writer.add_bytes_record('foo', names=[])
-        self.assertEqual(1, self.writer.records_written)
-        self.writer.add_bytes_record('foo', names=[])
-        self.assertEqual(2, self.writer.records_written)
+        output = StringIO()
+        writer = pack.ContainerWriter(output.write)
+        writer.begin()
+        writer.add_bytes_record('foo', names=[])
+        self.assertEqual(1, writer.records_written)
+        writer.add_bytes_record('foo', names=[])
+        self.assertEqual(2, writer.records_written)
 
 
 class TestContainerReader(tests.TestCase):
-    """Tests for the ContainerReader.
-
-    The ContainerReader reads format 1 containers, so these tests explicitly
-    test how it reacts to format 1 data.  If a new version of the format is
-    added, then separate tests for that format should be added.
-    """
 
     def get_reader_for(self, bytes):
         stream = StringIO(bytes)
@@ -329,13 +299,7 @@
         
 
 class TestBytesRecordReader(tests.TestCase):
-    """Tests for reading and validating Bytes records with
-    BytesRecordReader.
-    
-    Like TestContainerReader, this explicitly tests the reading of format 1
-    data.  If a new version of the format is added, then a separate set of
-    tests for reading that format should be added.
-    """
+    """Tests for reading and validating Bytes records with BytesRecordReader."""
 
     def get_reader_for(self, bytes):
         stream = StringIO(bytes)
@@ -559,137 +523,3 @@
         results.append(f.readline())
         results.append(f.read(4))
         self.assertEqual(['0', '\n', '2\n4\n'], results)
-
-
-class PushParserTestCase(tests.TestCase):
-    """Base class for TestCases involving ContainerPushParser."""
-
-    def make_parser_expecting_record_type(self):
-        parser = pack.ContainerPushParser()
-        parser.accept_bytes("Bazaar pack format 1 (introduced in 0.18)\n")
-        return parser
-
-    def make_parser_expecting_bytes_record(self):
-        parser = pack.ContainerPushParser()
-        parser.accept_bytes("Bazaar pack format 1 (introduced in 0.18)\nB")
-        return parser
-
-    def assertRecordParsing(self, expected_record, bytes):
-        """Assert that 'bytes' is parsed as a given bytes record.
-
-        :param expected_record: A tuple of (names, bytes).
-        """
-        parser = self.make_parser_expecting_bytes_record()
-        parser.accept_bytes(bytes)
-        parsed_records = parser.read_pending_records()
-        self.assertEqual([expected_record], parsed_records)
-
-        
-class TestContainerPushParser(PushParserTestCase):
-    """Tests for ContainerPushParser.
-    
-    The ContainerPushParser reads format 1 containers, so these tests
-    explicitly test how it reacts to format 1 data.  If a new version of the
-    format is added, then separate tests for that format should be added.
-    """
-
-    def test_construct(self):
-        """ContainerPushParser can be constructed."""
-        pack.ContainerPushParser()
-
-    def test_multiple_records_at_once(self):
-        """If multiple records worth of data are fed to the parser in one
-        string, the parser will correctly parse all the records.
-
-        (A naive implementation might stop after parsing the first record.)
-        """
-        parser = self.make_parser_expecting_record_type()
-        parser.accept_bytes("B5\nname1\n\nbody1B5\nname2\n\nbody2")
-        self.assertEqual(
-            [([('name1',)], 'body1'), ([('name2',)], 'body2')],
-            parser.read_pending_records())
-
-
-class TestContainerPushParserBytesParsing(PushParserTestCase):
-    """Tests for reading Bytes records with ContainerPushParser.
-    
-    The ContainerPushParser reads format 1 containers, so these tests
-    explicitly test how it reacts to format 1 data.  If a new version of the
-    format is added, then separate tests for that format should be added.
-    """
-
-    def test_record_with_no_name(self):
-        """Reading a Bytes record with no name returns an empty list of
-        names.
-        """
-        self.assertRecordParsing(([], 'aaaaa'), "5\n\naaaaa")
-
-    def test_record_with_one_name(self):
-        """Reading a Bytes record with one name returns a list of just that
-        name.
-        """
-        self.assertRecordParsing(
-            ([('name1', )], 'aaaaa'),
-            "5\nname1\n\naaaaa")
-
-    def test_record_with_two_names(self):
-        """Reading a Bytes record with two names returns a list of both names.
-        """
-        self.assertRecordParsing(
-            ([('name1', ), ('name2', )], 'aaaaa'),
-            "5\nname1\nname2\n\naaaaa")
-
-    def test_record_with_two_part_names(self):
-        """Reading a Bytes record with a two_part name reads both."""
-        self.assertRecordParsing(
-            ([('name1', 'name2')], 'aaaaa'),
-            "5\nname1\x00name2\n\naaaaa")
-
-    def test_invalid_length(self):
-        """If the length-prefix is not a number, parsing raises
-        InvalidRecordError.
-        """
-        parser = self.make_parser_expecting_bytes_record()
-        self.assertRaises(
-            errors.InvalidRecordError, parser.accept_bytes, "not a number\n")
-
-    def test_incomplete_record(self):
-        """If the bytes seen so far don't form a complete record, then there
-        will be nothing returned by read_pending_records.
-        """
-        parser = self.make_parser_expecting_bytes_record()
-        parser.accept_bytes("5\n\nabcd")
-        self.assertEqual([], parser.read_pending_records())
-
-    def test_accept_nothing(self):
-        """The edge case of parsing an empty string causes no error."""
-        parser = self.make_parser_expecting_bytes_record()
-        parser.accept_bytes("")
-
-    def assertInvalidRecord(self, bytes):
-        """Assert that parsing the given bytes will raise an
-        InvalidRecordError.
-        """
-        parser = self.make_parser_expecting_bytes_record()
-        self.assertRaises(
-            errors.InvalidRecordError, parser.accept_bytes, bytes)
-
-    def test_read_invalid_name_whitespace(self):
-        """Names must have no whitespace."""
-        # A name with a space.
-        self.assertInvalidRecord("0\nbad name\n\n")
-
-        # A name with a tab.
-        self.assertInvalidRecord("0\nbad\tname\n\n")
-
-        # A name with a vertical tab.
-        self.assertInvalidRecord("0\nbad\vname\n\n")
-
-    def test_repeated_read_pending_records(self):
-        """read_pending_records will not return the same record twice."""
-        parser = self.make_parser_expecting_bytes_record()
-        parser.accept_bytes("6\n\nabcdef")
-        self.assertEqual([([], 'abcdef')], parser.read_pending_records())
-        self.assertEqual([], parser.read_pending_records())
-
-

=== removed file 'bzrlib/tests/test_pack_repository.py'
--- bzrlib/tests/test_pack_repository.py	2008-09-02 03:17:08 +0000
+++ bzrlib/tests/test_pack_repository.py	1970-01-01 00:00:00 +0000
@@ -1,642 +0,0 @@
-# Copyright (C) 2008 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Tests for pack repositories.
-
-These tests are repeated for all pack-based repository formats.
-"""
-
-from cStringIO import StringIO
-from stat import S_ISDIR
-
-from bzrlib.index import GraphIndex, InMemoryGraphIndex
-from bzrlib import (
-    bzrdir,
-    errors,
-    inventory,
-    progress,
-    repository,
-    revision as _mod_revision,
-    symbol_versioning,
-    tests,
-    ui,
-    upgrade,
-    workingtree,
-    )
-from bzrlib.tests import (
-    TestCase,
-    TestCaseWithTransport,
-    TestNotApplicable,
-    TestSkipped,
-    )
-from bzrlib.transport import (
-    fakenfs,
-    get_transport,
-    )
-
-
-class TestPackRepository(TestCaseWithTransport):
-    """Tests to be repeated across all pack-based formats.
-
-    The following are populated from the test scenario:
-
-    :ivar format_name: Registered name fo the format to test.
-    :ivar format_string: On-disk format marker.
-    :ivar format_supports_external_lookups: Boolean.
-    """
-
-    def get_format(self):
-        return bzrdir.format_registry.make_bzrdir(self.format_name)
-
-    def test_attribute__fetch_order(self):
-        """Packs do not need ordered data retrieval."""
-        format = self.get_format()
-        repo = self.make_repository('.', format=format)
-        self.assertEqual('unordered', repo._fetch_order)
-
-    def test_attribute__fetch_uses_deltas(self):
-        """Packs reuse deltas."""
-        format = self.get_format()
-        repo = self.make_repository('.', format=format)
-        self.assertEqual(True, repo._fetch_uses_deltas)
-
-    def test_disk_layout(self):
-        format = self.get_format()
-        repo = self.make_repository('.', format=format)
-        # in case of side effects of locking.
-        repo.lock_write()
-        repo.unlock()
-        t = repo.bzrdir.get_repository_transport(None)
-        self.check_format(t)
-        # XXX: no locks left when unlocked at the moment
-        # self.assertEqualDiff('', t.get('lock').read())
-        self.check_databases(t)
-
-    def check_format(self, t):
-        self.assertEqualDiff(
-            self.format_string, # from scenario
-            t.get('format').read())
-
-    def assertHasNoKndx(self, t, knit_name):
-        """Assert that knit_name has no index on t."""
-        self.assertFalse(t.has(knit_name + '.kndx'))
-
-    def assertHasNoKnit(self, t, knit_name):
-        """Assert that knit_name exists on t."""
-        # no default content
-        self.assertFalse(t.has(knit_name + '.knit'))
-
-    def check_databases(self, t):
-        """check knit content for a repository."""
-        # check conversion worked
-        self.assertHasNoKndx(t, 'inventory')
-        self.assertHasNoKnit(t, 'inventory')
-        self.assertHasNoKndx(t, 'revisions')
-        self.assertHasNoKnit(t, 'revisions')
-        self.assertHasNoKndx(t, 'signatures')
-        self.assertHasNoKnit(t, 'signatures')
-        self.assertFalse(t.has('knits'))
-        # revision-indexes file-container directory
-        self.assertEqual([],
-            list(GraphIndex(t, 'pack-names', None).iter_all_entries()))
-        self.assertTrue(S_ISDIR(t.stat('packs').st_mode))
-        self.assertTrue(S_ISDIR(t.stat('upload').st_mode))
-        self.assertTrue(S_ISDIR(t.stat('indices').st_mode))
-        self.assertTrue(S_ISDIR(t.stat('obsolete_packs').st_mode))
-
-    def test_shared_disk_layout(self):
-        format = self.get_format()
-        repo = self.make_repository('.', shared=True, format=format)
-        # we want:
-        t = repo.bzrdir.get_repository_transport(None)
-        self.check_format(t)
-        # XXX: no locks left when unlocked at the moment
-        # self.assertEqualDiff('', t.get('lock').read())
-        # We should have a 'shared-storage' marker file.
-        self.assertEqualDiff('', t.get('shared-storage').read())
-        self.check_databases(t)
-
-    def test_shared_no_tree_disk_layout(self):
-        format = self.get_format()
-        repo = self.make_repository('.', shared=True, format=format)
-        repo.set_make_working_trees(False)
-        # we want:
-        t = repo.bzrdir.get_repository_transport(None)
-        self.check_format(t)
-        # XXX: no locks left when unlocked at the moment
-        # self.assertEqualDiff('', t.get('lock').read())
-        # We should have a 'shared-storage' marker file.
-        self.assertEqualDiff('', t.get('shared-storage').read())
-        # We should have a marker for the no-working-trees flag.
-        self.assertEqualDiff('', t.get('no-working-trees').read())
-        # The marker should go when we toggle the setting.
-        repo.set_make_working_trees(True)
-        self.assertFalse(t.has('no-working-trees'))
-        self.check_databases(t)
-
-    def test_adding_revision_creates_pack_indices(self):
-        format = self.get_format()
-        tree = self.make_branch_and_tree('.', format=format)
-        trans = tree.branch.repository.bzrdir.get_repository_transport(None)
-        self.assertEqual([],
-            list(GraphIndex(trans, 'pack-names', None).iter_all_entries()))
-        tree.commit('foobarbaz')
-        index = GraphIndex(trans, 'pack-names', None)
-        index_nodes = list(index.iter_all_entries())
-        self.assertEqual(1, len(index_nodes))
-        node = index_nodes[0]
-        name = node[1][0]
-        # the pack sizes should be listed in the index
-        pack_value = node[2]
-        sizes = [int(digits) for digits in pack_value.split(' ')]
-        for size, suffix in zip(sizes, ['.rix', '.iix', '.tix', '.six']):
-            stat = trans.stat('indices/%s%s' % (name, suffix))
-            self.assertEqual(size, stat.st_size)
-
-    def test_pulling_nothing_leads_to_no_new_names(self):
-        format = self.get_format()
-        tree1 = self.make_branch_and_tree('1', format=format)
-        tree2 = self.make_branch_and_tree('2', format=format)
-        tree1.branch.repository.fetch(tree2.branch.repository)
-        trans = tree1.branch.repository.bzrdir.get_repository_transport(None)
-        self.assertEqual([],
-            list(GraphIndex(trans, 'pack-names', None).iter_all_entries()))
-
-    def test_commit_across_pack_shape_boundary_autopacks(self):
-        format = self.get_format()
-        tree = self.make_branch_and_tree('.', format=format)
-        trans = tree.branch.repository.bzrdir.get_repository_transport(None)
-        # This test could be a little cheaper by replacing the packs
-        # attribute on the repository to allow a different pack distribution
-        # and max packs policy - so we are checking the policy is honoured
-        # in the test. But for now 11 commits is not a big deal in a single
-        # test.
-        for x in range(9):
-            tree.commit('commit %s' % x)
-        # there should be 9 packs:
-        index = GraphIndex(trans, 'pack-names', None)
-        self.assertEqual(9, len(list(index.iter_all_entries())))
-        # insert some files in obsolete_packs which should be removed by pack.
-        trans.put_bytes('obsolete_packs/foo', '123')
-        trans.put_bytes('obsolete_packs/bar', '321')
-        # committing one more should coalesce to 1 of 10.
-        tree.commit('commit triggering pack')
-        index = GraphIndex(trans, 'pack-names', None)
-        self.assertEqual(1, len(list(index.iter_all_entries())))
-        # packing should not damage data
-        tree = tree.bzrdir.open_workingtree()
-        check_result = tree.branch.repository.check(
-            [tree.branch.last_revision()])
-        # We should have 50 (10x5) files in the obsolete_packs directory.
-        obsolete_files = list(trans.list_dir('obsolete_packs'))
-        self.assertFalse('foo' in obsolete_files)
-        self.assertFalse('bar' in obsolete_files)
-        self.assertEqual(50, len(obsolete_files))
-        # XXX: Todo check packs obsoleted correctly - old packs and indices
-        # in the obsolete_packs directory.
-        large_pack_name = list(index.iter_all_entries())[0][1][0]
-        # finally, committing again should not touch the large pack.
-        tree.commit('commit not triggering pack')
-        index = GraphIndex(trans, 'pack-names', None)
-        self.assertEqual(2, len(list(index.iter_all_entries())))
-        pack_names = [node[1][0] for node in index.iter_all_entries()]
-        self.assertTrue(large_pack_name in pack_names)
-
-    def test_fail_obsolete_deletion(self):
-        # failing to delete obsolete packs is not fatal
-        format = self.get_format()
-        server = fakenfs.FakeNFSServer()
-        server.setUp()
-        self.addCleanup(server.tearDown)
-        transport = get_transport(server.get_url())
-        bzrdir = self.get_format().initialize_on_transport(transport)
-        repo = bzrdir.create_repository()
-        repo_transport = bzrdir.get_repository_transport(None)
-        self.assertTrue(repo_transport.has('obsolete_packs'))
-        # these files are in use by another client and typically can't be deleted
-        repo_transport.put_bytes('obsolete_packs/.nfsblahblah', 'contents')
-        repo._pack_collection._clear_obsolete_packs()
-        self.assertTrue(repo_transport.has('obsolete_packs/.nfsblahblah'))
-
-    def test_pack_after_two_commits_packs_everything(self):
-        format = self.get_format()
-        tree = self.make_branch_and_tree('.', format=format)
-        trans = tree.branch.repository.bzrdir.get_repository_transport(None)
-        tree.commit('start')
-        tree.commit('more work')
-        tree.branch.repository.pack()
-        # there should be 1 pack:
-        index = GraphIndex(trans, 'pack-names', None)
-        self.assertEqual(1, len(list(index.iter_all_entries())))
-        self.assertEqual(2, len(tree.branch.repository.all_revision_ids()))
-
-    def test_pack_layout(self):
-        format = self.get_format()
-        tree = self.make_branch_and_tree('.', format=format)
-        trans = tree.branch.repository.bzrdir.get_repository_transport(None)
-        tree.commit('start', rev_id='1')
-        tree.commit('more work', rev_id='2')
-        tree.branch.repository.pack()
-        tree.lock_read()
-        self.addCleanup(tree.unlock)
-        pack = tree.branch.repository._pack_collection.get_pack_by_name(
-            tree.branch.repository._pack_collection.names()[0])
-        # revision access tends to be tip->ancestor, so ordering that way on 
-        # disk is a good idea.
-        for _1, key, val, refs in pack.revision_index.iter_all_entries():
-            if key == ('1',):
-                pos_1 = int(val[1:].split()[0])
-            else:
-                pos_2 = int(val[1:].split()[0])
-        self.assertTrue(pos_2 < pos_1)
-
-    def test_pack_repositories_support_multiple_write_locks(self):
-        format = self.get_format()
-        self.make_repository('.', shared=True, format=format)
-        r1 = repository.Repository.open('.')
-        r2 = repository.Repository.open('.')
-        r1.lock_write()
-        self.addCleanup(r1.unlock)
-        r2.lock_write()
-        r2.unlock()
-
-    def _add_text(self, repo, fileid):
-        """Add a text to the repository within a write group."""
-        repo.texts.add_lines((fileid, 'samplerev+'+fileid), [], [])
-
-    def test_concurrent_writers_merge_new_packs(self):
-        format = self.get_format()
-        self.make_repository('.', shared=True, format=format)
-        r1 = repository.Repository.open('.')
-        r2 = repository.Repository.open('.')
-        r1.lock_write()
-        try:
-            # access enough data to load the names list
-            list(r1.all_revision_ids())
-            r2.lock_write()
-            try:
-                # access enough data to load the names list
-                list(r2.all_revision_ids())
-                r1.start_write_group()
-                try:
-                    r2.start_write_group()
-                    try:
-                        self._add_text(r1, 'fileidr1')
-                        self._add_text(r2, 'fileidr2')
-                    except:
-                        r2.abort_write_group()
-                        raise
-                except:
-                    r1.abort_write_group()
-                    raise
-                # both r1 and r2 have open write groups with data in them
-                # created while the other's write group was open.
-                # Commit both which requires a merge to the pack-names.
-                try:
-                    r1.commit_write_group()
-                except:
-                    r1.abort_write_group()
-                    r2.abort_write_group()
-                    raise
-                r2.commit_write_group()
-                # tell r1 to reload from disk
-                r1._pack_collection.reset()
-                # Now both repositories should know about both names
-                r1._pack_collection.ensure_loaded()
-                r2._pack_collection.ensure_loaded()
-                self.assertEqual(r1._pack_collection.names(), r2._pack_collection.names())
-                self.assertEqual(2, len(r1._pack_collection.names()))
-            finally:
-                r2.unlock()
-        finally:
-            r1.unlock()
-
-    def test_concurrent_writer_second_preserves_dropping_a_pack(self):
-        format = self.get_format()
-        self.make_repository('.', shared=True, format=format)
-        r1 = repository.Repository.open('.')
-        r2 = repository.Repository.open('.')
-        # add a pack to drop
-        r1.lock_write()
-        try:
-            r1.start_write_group()
-            try:
-                self._add_text(r1, 'fileidr1')
-            except:
-                r1.abort_write_group()
-                raise
-            else:
-                r1.commit_write_group()
-            r1._pack_collection.ensure_loaded()
-            name_to_drop = r1._pack_collection.all_packs()[0].name
-        finally:
-            r1.unlock()
-        r1.lock_write()
-        try:
-            # access enough data to load the names list
-            list(r1.all_revision_ids())
-            r2.lock_write()
-            try:
-                # access enough data to load the names list
-                list(r2.all_revision_ids())
-                r1._pack_collection.ensure_loaded()
-                try:
-                    r2.start_write_group()
-                    try:
-                        # in r1, drop the pack
-                        r1._pack_collection._remove_pack_from_memory(
-                            r1._pack_collection.get_pack_by_name(name_to_drop))
-                        # in r2, add a pack
-                        self._add_text(r2, 'fileidr2')
-                    except:
-                        r2.abort_write_group()
-                        raise
-                except:
-                    r1._pack_collection.reset()
-                    raise
-                # r1 has a changed names list, and r2 an open write groups with
-                # changes.
-                # save r1, and then commit the r2 write group, which requires a
-                # merge to the pack-names, which should not reinstate
-                # name_to_drop
-                try:
-                    r1._pack_collection._save_pack_names()
-                    r1._pack_collection.reset()
-                except:
-                    r2.abort_write_group()
-                    raise
-                try:
-                    r2.commit_write_group()
-                except:
-                    r2.abort_write_group()
-                    raise
-                # Now both repositories should now about just one name.
-                r1._pack_collection.ensure_loaded()
-                r2._pack_collection.ensure_loaded()
-                self.assertEqual(r1._pack_collection.names(), r2._pack_collection.names())
-                self.assertEqual(1, len(r1._pack_collection.names()))
-                self.assertFalse(name_to_drop in r1._pack_collection.names())
-            finally:
-                r2.unlock()
-        finally:
-            r1.unlock()
-
-    def test_lock_write_does_not_physically_lock(self):
-        repo = self.make_repository('.', format=self.get_format())
-        repo.lock_write()
-        self.addCleanup(repo.unlock)
-        self.assertFalse(repo.get_physical_lock_status())
-
-    def prepare_for_break_lock(self):
-        # Setup the global ui factory state so that a break-lock method call
-        # will find usable input in the input stream.
-        old_factory = ui.ui_factory
-        def restoreFactory():
-            ui.ui_factory = old_factory
-        self.addCleanup(restoreFactory)
-        ui.ui_factory = ui.SilentUIFactory()
-        ui.ui_factory.stdin = StringIO("y\n")
-
-    def test_break_lock_breaks_physical_lock(self):
-        repo = self.make_repository('.', format=self.get_format())
-        repo._pack_collection.lock_names()
-        repo.control_files.leave_in_place()
-        repo.unlock()
-        repo2 = repository.Repository.open('.')
-        self.assertTrue(repo.get_physical_lock_status())
-        self.prepare_for_break_lock()
-        repo2.break_lock()
-        self.assertFalse(repo.get_physical_lock_status())
-
-    def test_broken_physical_locks_error_on__unlock_names_lock(self):
-        repo = self.make_repository('.', format=self.get_format())
-        repo._pack_collection.lock_names()
-        self.assertTrue(repo.get_physical_lock_status())
-        repo2 = repository.Repository.open('.')
-        self.prepare_for_break_lock()
-        repo2.break_lock()
-        self.assertRaises(errors.LockBroken, repo._pack_collection._unlock_names)
-
-    def test_fetch_without_find_ghosts_ignores_ghosts(self):
-        # we want two repositories at this point:
-        # one with a revision that is a ghost in the other
-        # repository.
-        # 'ghost' is present in has_ghost, 'ghost' is absent in 'missing_ghost'.
-        # 'references' is present in both repositories, and 'tip' is present
-        # just in has_ghost.
-        # has_ghost       missing_ghost
-        #------------------------------
-        # 'ghost'             -
-        # 'references'    'references'
-        # 'tip'               -
-        # In this test we fetch 'tip' which should not fetch 'ghost'
-        has_ghost = self.make_repository('has_ghost', format=self.get_format())
-        missing_ghost = self.make_repository('missing_ghost',
-            format=self.get_format())
-
-        def add_commit(repo, revision_id, parent_ids):
-            repo.lock_write()
-            repo.start_write_group()
-            inv = inventory.Inventory(revision_id=revision_id)
-            inv.root.revision = revision_id
-            root_id = inv.root.file_id
-            sha1 = repo.add_inventory(revision_id, inv, [])
-            repo.texts.add_lines((root_id, revision_id), [], [])
-            rev = _mod_revision.Revision(timestamp=0,
-                                         timezone=None,
-                                         committer="Foo Bar <foo@example.com>",
-                                         message="Message",
-                                         inventory_sha1=sha1,
-                                         revision_id=revision_id)
-            rev.parent_ids = parent_ids
-            repo.add_revision(revision_id, rev)
-            repo.commit_write_group()
-            repo.unlock()
-        add_commit(has_ghost, 'ghost', [])
-        add_commit(has_ghost, 'references', ['ghost'])
-        add_commit(missing_ghost, 'references', ['ghost'])
-        add_commit(has_ghost, 'tip', ['references'])
-        missing_ghost.fetch(has_ghost, 'tip')
-        # missing ghost now has tip and not ghost.
-        rev = missing_ghost.get_revision('tip')
-        inv = missing_ghost.get_inventory('tip')
-        self.assertRaises(errors.NoSuchRevision,
-            missing_ghost.get_revision, 'ghost')
-        self.assertRaises(errors.NoSuchRevision,
-            missing_ghost.get_inventory, 'ghost')
-
-    def test_supports_external_lookups(self):
-        repo = self.make_repository('.', format=self.get_format())
-        self.assertEqual(self.format_supports_external_lookups,
-            repo._format.supports_external_lookups)
-
-
-class TestPackRepositoryStacking(TestCaseWithTransport):
-
-    """Tests for stacking pack repositories"""
-
-    def setUp(self):
-        if not self.format_supports_external_lookups:
-            raise TestNotApplicable("%r doesn't support stacking" 
-                % (self.format_name,))
-        super(TestPackRepositoryStacking, self).setUp()
-
-    def get_format(self):
-        return bzrdir.format_registry.make_bzrdir(self.format_name)
-
-    def test_stack_checks_rich_root_compatibility(self):
-        # early versions of the packing code relied on pack internals to
-        # stack, but the current version should be able to stack on any
-        # format.
-        #
-        # TODO: Possibly this should be run per-repository-format and raise
-        # TestNotApplicable on formats that don't support stacking. -- mbp
-        # 20080729
-        repo = self.make_repository('repo', format=self.get_format())
-        if repo.supports_rich_root():
-            # can only stack on repositories that have compatible internal
-            # metadata
-            if getattr(repo._format, 'supports_tree_reference', False):
-                matching_format_name = 'pack-0.92-subtree'
-            else:
-                matching_format_name = 'rich-root-pack'
-            mismatching_format_name = 'pack-0.92'
-        else:
-            matching_format_name = 'pack-0.92'
-            mismatching_format_name = 'pack-0.92-subtree'
-        base = self.make_repository('base', format=matching_format_name)
-        repo.add_fallback_repository(base)
-        # you can't stack on something with incompatible data
-        bad_repo = self.make_repository('mismatch',
-            format=mismatching_format_name)
-        e = self.assertRaises(errors.IncompatibleRepositories,
-            repo.add_fallback_repository, bad_repo)
-        self.assertContainsRe(str(e),
-            r'(?m)KnitPackRepository.*/mismatch/.*\nis not compatible with\n'
-            r'KnitPackRepository.*/repo/.*\n'
-            r'different rich-root support')
-
-    def test_stack_checks_serializers_compatibility(self):
-        repo = self.make_repository('repo', format=self.get_format())
-        if getattr(repo._format, 'supports_tree_reference', False):
-            # can only stack on repositories that have compatible internal
-            # metadata
-            matching_format_name = 'pack-0.92-subtree'
-            mismatching_format_name = 'rich-root-pack'
-        else:
-            if repo.supports_rich_root():
-                matching_format_name = 'rich-root-pack'
-                mismatching_format_name = 'pack-0.92-subtree'
-            else:
-                raise TestNotApplicable('No formats use non-v5 serializer'
-                    ' without having rich-root also set')
-        base = self.make_repository('base', format=matching_format_name)
-        repo.add_fallback_repository(base)
-        # you can't stack on something with incompatible data
-        bad_repo = self.make_repository('mismatch',
-            format=mismatching_format_name)
-        e = self.assertRaises(errors.IncompatibleRepositories,
-            repo.add_fallback_repository, bad_repo)
-        self.assertContainsRe(str(e),
-            r'(?m)KnitPackRepository.*/mismatch/.*\nis not compatible with\n'
-            r'KnitPackRepository.*/repo/.*\n'
-            r'different serializers')
-
-    def test_adding_pack_does_not_record_pack_names_from_other_repositories(self):
-        base = self.make_branch_and_tree('base', format=self.get_format())
-        base.commit('foo')
-        referencing = self.make_branch_and_tree('repo', format=self.get_format())
-        referencing.branch.repository.add_fallback_repository(base.branch.repository)
-        referencing.commit('bar')
-        new_instance = referencing.bzrdir.open_repository()
-        new_instance.lock_read()
-        self.addCleanup(new_instance.unlock)
-        new_instance._pack_collection.ensure_loaded()
-        self.assertEqual(1, len(new_instance._pack_collection.all_packs()))
-
-    def test_autopack_only_considers_main_repo_packs(self):
-        base = self.make_branch_and_tree('base', format=self.get_format())
-        base.commit('foo')
-        tree = self.make_branch_and_tree('repo', format=self.get_format())
-        tree.branch.repository.add_fallback_repository(base.branch.repository)
-        trans = tree.branch.repository.bzrdir.get_repository_transport(None)
-        # This test could be a little cheaper by replacing the packs
-        # attribute on the repository to allow a different pack distribution
-        # and max packs policy - so we are checking the policy is honoured
-        # in the test. But for now 11 commits is not a big deal in a single
-        # test.
-        for x in range(9):
-            tree.commit('commit %s' % x)
-        # there should be 9 packs:
-        index = GraphIndex(trans, 'pack-names', None)
-        self.assertEqual(9, len(list(index.iter_all_entries())))
-        # committing one more should coalesce to 1 of 10.
-        tree.commit('commit triggering pack')
-        index = GraphIndex(trans, 'pack-names', None)
-        self.assertEqual(1, len(list(index.iter_all_entries())))
-        # packing should not damage data
-        tree = tree.bzrdir.open_workingtree()
-        check_result = tree.branch.repository.check(
-            [tree.branch.last_revision()])
-        # We should have 50 (10x5) files in the obsolete_packs directory.
-        obsolete_files = list(trans.list_dir('obsolete_packs'))
-        self.assertFalse('foo' in obsolete_files)
-        self.assertFalse('bar' in obsolete_files)
-        self.assertEqual(50, len(obsolete_files))
-        # XXX: Todo check packs obsoleted correctly - old packs and indices
-        # in the obsolete_packs directory.
-        large_pack_name = list(index.iter_all_entries())[0][1][0]
-        # finally, committing again should not touch the large pack.
-        tree.commit('commit not triggering pack')
-        index = GraphIndex(trans, 'pack-names', None)
-        self.assertEqual(2, len(list(index.iter_all_entries())))
-        pack_names = [node[1][0] for node in index.iter_all_entries()]
-        self.assertTrue(large_pack_name in pack_names)
-
-
-def load_tests(basic_tests, module, test_loader):
-    # these give the bzrdir canned format name, and the repository on-disk
-    # format string
-    scenarios_params = [
-         dict(format_name='pack-0.92',
-              format_string="Bazaar pack repository format 1 (needs bzr 0.92)\n",
-              format_supports_external_lookups=False),
-         dict(format_name='pack-0.92-subtree',
-              format_string="Bazaar pack repository format 1 "
-              "with subtree support (needs bzr 0.92)\n",
-              format_supports_external_lookups=False),
-         dict(format_name='1.6',
-              format_string="Bazaar RepositoryFormatKnitPack5 (bzr 1.6)\n",
-              format_supports_external_lookups=True),
-         dict(format_name='1.6.1-rich-root',
-              format_string="Bazaar RepositoryFormatKnitPack5RichRoot "
-                  "(bzr 1.6.1)\n",
-              format_supports_external_lookups=True),
-         dict(format_name='development',
-              format_string="Bazaar development format 1 "
-                  "(needs bzr.dev from before 1.6)\n",
-              format_supports_external_lookups=True),
-         dict(format_name='development-subtree',
-              format_string="Bazaar development format 1 "
-                  "with subtree support (needs bzr.dev from before 1.6)\n",
-              format_supports_external_lookups=True),
-         ]
-    adapter = tests.TestScenarioApplier()
-    # name of the scenario is the format name
-    adapter.scenarios = [(s['format_name'], s) for s in scenarios_params]
-    suite = tests.TestSuite()
-    tests.adapt_tests(basic_tests, adapter, suite)
-    return suite

=== modified file 'bzrlib/tests/test_patches.py'
--- bzrlib/tests/test_patches.py	2008-05-08 04:18:41 +0000
+++ bzrlib/tests/test_patches.py	2007-08-17 13:47:21 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2004 - 2008 Aaron Bentley, Canonical Ltd
+# Copyright (C) 2004 - 2006 Aaron Bentley, Canonical Ltd
 # <aaron.bentley@utoronto.ca>
 #
 # This program is free software; you can redistribute it and/or modify
@@ -16,10 +16,9 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 
+import unittest
 import os.path
 
-from bzrlib.tests import TestCase
-
 from bzrlib.iterablefile import IterableFile
 from bzrlib.patches import (MalformedLine, 
                             MalformedHunkHeader, 
@@ -36,8 +35,7 @@
                             parse_patches)
 
 
-class PatchesTester(TestCase):
-
+class PatchesTester(unittest.TestCase):
     def datafile(self, filename):
         data_path = os.path.join(os.path.dirname(__file__), 
                                  "test_patches_data", filename)
@@ -47,8 +45,8 @@
         """Parse a valid patch header"""
         lines = "--- orig/commands.py\n+++ mod/dommands.py\n".split('\n')
         (orig, mod) = get_patch_names(lines.__iter__())
-        self.assertEqual(orig, "orig/commands.py")
-        self.assertEqual(mod, "mod/dommands.py")
+        assert(orig == "orig/commands.py")
+        assert(mod == "mod/dommands.py")
 
     def testInvalidPatchHeader(self):
         """Parse an invalid patch header"""
@@ -60,21 +58,21 @@
         """Parse a valid hunk header"""
         header = "@@ -34,11 +50,6 @@\n"
         hunk = hunk_from_header(header);
-        self.assertEqual(hunk.orig_pos, 34)
-        self.assertEqual(hunk.orig_range, 11)
-        self.assertEqual(hunk.mod_pos, 50)
-        self.assertEqual(hunk.mod_range, 6)
-        self.assertEqual(str(hunk), header)
+        assert (hunk.orig_pos == 34)
+        assert (hunk.orig_range == 11)
+        assert (hunk.mod_pos == 50)
+        assert (hunk.mod_range == 6)
+        assert (str(hunk) == header)
 
     def testValidHunkHeader2(self):
         """Parse a tricky, valid hunk header"""
         header = "@@ -1 +0,0 @@\n"
         hunk = hunk_from_header(header);
-        self.assertEqual(hunk.orig_pos, 1)
-        self.assertEqual(hunk.orig_range, 1)
-        self.assertEqual(hunk.mod_pos, 0)
-        self.assertEqual(hunk.mod_range, 0)
-        self.assertEqual(str(hunk), header)
+        assert (hunk.orig_pos == 1)
+        assert (hunk.orig_range == 1)
+        assert (hunk.mod_pos == 0)
+        assert (hunk.mod_range == 0)
+        assert (str(hunk) == header)
 
     def testPDiff(self):
         """Parse a hunk header produced by diff -p"""
@@ -100,8 +98,8 @@
 
     def lineThing(self,text, type):
         line = parse_line(text)
-        self.assertIsInstance(line, type)
-        self.assertEqual(str(line), text)
+        assert(isinstance(line, type))
+        assert(str(line)==text)
 
     def makeMalformedLine(self, text):
         self.assertRaises(MalformedLine, parse_line, text)
@@ -153,7 +151,7 @@
             if mod_pos is None:
                 removals.append(orig[i])
                 continue
-            self.assertEqual(mod[mod_pos], orig[i])
+            assert(mod[mod_pos]==orig[i])
         rem_iter = removals.__iter__()
         for hunk in patch.hunks:
             for line in hunk.lines:
@@ -162,7 +160,7 @@
                     if line.contents != next:
                         sys.stdout.write(" orig:%spatch:%s" % (next,
                                          line.contents))
-                    self.assertEqual(line.contents, next)
+                    assert(line.contents == next)
         self.assertRaises(StopIteration, rem_iter.next)
 
     def testPatching(self):
@@ -190,7 +188,7 @@
     def testFirstLineRenumber(self):
         """Make sure we handle lines at the beginning of the hunk"""
         patch = parse_patch(self.datafile("insert_top.patch"))
-        self.assertEqual(patch.pos_in_mod(0), 1)
+        assert (patch.pos_in_mod(0)==1)
 
     def testParsePatches(self):
         """Make sure file names can be extracted from tricky unified diffs"""
@@ -226,4 +224,13 @@
         patch_files = []
         for patch in patches:
             patch_files.append((patch.oldname, patch.newname))
-        self.assertEqual(patch_files, filenames)
+        assert (patch_files == filenames)
+            
+def test():
+    patchesTestSuite = unittest.makeSuite(PatchesTester,'test')
+    runner = unittest.TextTestRunner(verbosity=0)
+    return runner.run(patchesTestSuite)
+
+
+if __name__ == "__main__":
+    test()

=== modified file 'bzrlib/tests/test_permissions.py'
--- bzrlib/tests/test_permissions.py	2008-09-01 06:16:07 +0000
+++ bzrlib/tests/test_permissions.py	2007-06-06 14:26:08 +0000
@@ -29,7 +29,7 @@
 # TODO: jam 20051215 Currently the default behavior for 'bzr branch' is just 
 #                    defined by the local umask. This isn't terrible, is it
 #                    the truly desired behavior?
-
+ 
 import os
 import sys
 import stat
@@ -47,6 +47,7 @@
 
 def chmod_r(base, file_mode, dir_mode):
     """Recursively chmod from a base directory"""
+    assert os.path.isdir(base)
     os.chmod(base, dir_mode)
     for root, dirs, files in os.walk(base):
         for d in dirs:
@@ -66,6 +67,7 @@
     :param dir_mode: The mode for all directories
     :param include_base: If false, only check the subdirectories
     """
+    assert os.path.isdir(base)
     t = get_transport(".")
     if include_base:
         test.assertTransportMode(t, base, dir_mode)
@@ -104,8 +106,6 @@
         b = t.branch
         self.assertEqualMode(0755, b.control_files._dir_mode)
         self.assertEqualMode(0644, b.control_files._file_mode)
-        self.assertEqualMode(0755, b.bzrdir._get_dir_mode())
-        self.assertEqualMode(0644, b.bzrdir._get_file_mode())
 
         # Modifying a file shouldn't break the permissions
         open('a', 'wb').write('foo2\n')
@@ -126,8 +126,6 @@
         b = t.branch
         self.assertEqualMode(0775, b.control_files._dir_mode)
         self.assertEqualMode(0664, b.control_files._file_mode)
-        self.assertEqualMode(0775, b.bzrdir._get_dir_mode())
-        self.assertEqualMode(0664, b.bzrdir._get_file_mode())
 
         open('a', 'wb').write('foo3\n')
         t.commit('foo3')
@@ -138,18 +136,6 @@
         t.commit('new c')
         check_mode_r(self, '.bzr', 0664, 0775)
 
-    def test_new_files_group_sticky_bit(self):
-        if sys.platform == 'win32':
-            raise TestSkipped('chmod has no effect on win32')
-        elif sys.platform == 'darwin':
-            # OS X creates temp dirs with the 'wheel' group, which users are
-            # not likely to be in, and this prevents us from setting the sgid
-            # bit
-            os.chown(self.test_dir, os.getuid(), os.getgid())
-
-        t = self.make_branch_and_tree('.')
-        b = t.branch
-
         # Test the group sticky bit
         # Recursively update the modes of all files
         chmod_r('.bzr', 0664, 02775)
@@ -158,8 +144,6 @@
         b = t.branch
         self.assertEqualMode(02775, b.control_files._dir_mode)
         self.assertEqualMode(0664, b.control_files._file_mode)
-        self.assertEqualMode(02775, b.bzrdir._get_dir_mode())
-        self.assertEqualMode(0664, b.bzrdir._get_file_mode())
 
         open('a', 'wb').write('foo4\n')
         t.commit('foo4')
@@ -170,6 +154,43 @@
         t.commit('new d')
         check_mode_r(self, '.bzr', 0664, 02775)
 
+    def test_disable_set_mode(self):
+        # TODO: jam 20051215 Ultimately, this test should probably test that
+        #                    extra chmod calls aren't being made
+        try:
+            transport = get_transport(self.get_url())
+            transport.put_bytes('my-lock', '')
+            lockable = LockableFiles(transport, 'my-lock', TransportLock)
+            self.assertNotEqual(None, lockable._dir_mode)
+            self.assertNotEqual(None, lockable._file_mode)
+
+            LockableFiles._set_dir_mode = False
+            transport = get_transport('.')
+            lockable = LockableFiles(transport, 'my-lock', TransportLock)
+            self.assertEqual(None, lockable._dir_mode)
+            self.assertNotEqual(None, lockable._file_mode)
+
+            LockableFiles._set_file_mode = False
+            transport = get_transport('.')
+            lockable = LockableFiles(transport, 'my-lock', TransportLock)
+            self.assertEqual(None, lockable._dir_mode)
+            self.assertEqual(None, lockable._file_mode)
+
+            LockableFiles._set_dir_mode = True
+            transport = get_transport('.')
+            lockable = LockableFiles(transport, 'my-lock', TransportLock)
+            self.assertNotEqual(None, lockable._dir_mode)
+            self.assertEqual(None, lockable._file_mode)
+
+            LockableFiles._set_file_mode = True
+            transport = get_transport('.')
+            lockable = LockableFiles(transport, 'my-lock', TransportLock)
+            self.assertNotEqual(None, lockable._dir_mode)
+            self.assertNotEqual(None, lockable._file_mode)
+        finally:
+            LockableFiles._set_dir_mode = True
+            LockableFiles._set_file_mode = True
+
 
 class TestSftpPermissions(TestCaseWithSFTPServer):
 
@@ -198,8 +219,6 @@
         b_local = t.branch
         self.assertEqualMode(0755, b_local.control_files._dir_mode)
         self.assertEqualMode(0644, b_local.control_files._file_mode)
-        self.assertEqualMode(0755, b_local.bzrdir._get_dir_mode())
-        self.assertEqualMode(0644, b_local.bzrdir._get_file_mode())
 
         os.mkdir('sftp')
         sftp_url = self.get_url('sftp')
@@ -213,8 +232,6 @@
         b_sftp = Branch.open(sftp_url)
         self.assertEqualMode(0755, b_sftp.control_files._dir_mode)
         self.assertEqualMode(0644, b_sftp.control_files._file_mode)
-        self.assertEqualMode(0755, b_sftp.bzrdir._get_dir_mode())
-        self.assertEqualMode(0644, b_sftp.bzrdir._get_file_mode())
 
         open('local/a', 'wb').write('foo2\n')
         t_local.commit('foo2')
@@ -236,8 +253,6 @@
         b_sftp = Branch.open(sftp_url)
         self.assertEqualMode(0775, b_sftp.control_files._dir_mode)
         self.assertEqualMode(0664, b_sftp.control_files._file_mode)
-        self.assertEqualMode(0775, b_sftp.bzrdir._get_dir_mode())
-        self.assertEqualMode(0664, b_sftp.bzrdir._get_file_mode())
 
         open('local/a', 'wb').write('foo3\n')
         t_local.commit('foo3')

=== modified file 'bzrlib/tests/test_plugins.py'
--- bzrlib/tests/test_plugins.py	2008-08-11 12:50:16 +0000
+++ bzrlib/tests/test_plugins.py	2007-10-16 18:26:12 +0000
@@ -20,7 +20,6 @@
 # affects the global state of the process.  See bzrlib/plugins.py for more
 # comments.
 
-import logging
 import os
 from StringIO import StringIO
 import sys
@@ -31,12 +30,8 @@
 import bzrlib.plugins
 import bzrlib.commands
 import bzrlib.help
-from bzrlib.symbol_versioning import one_three
-from bzrlib.tests import (
-    TestCase,
-    TestCaseInTempDir,
-    TestUtil,
-    )
+from bzrlib.symbol_versioning import zero_ninetyone
+from bzrlib.tests import TestCase, TestCaseInTempDir
 from bzrlib.osutils import pathjoin, abspath, normpath
 
 
@@ -193,29 +188,29 @@
                 del bzrlib.plugins.ts_plugin
         self.failIf(getattr(bzrlib.plugins, 'ts_plugin', None))
 
-    def test_plugin_with_bad_name_does_not_load(self):
-        # Create badly-named plugin
-        file('bzr-bad plugin-name..py', 'w').close()
-
-        # Capture output
-        stream = StringIO()
-        handler = logging.StreamHandler(stream)
-        log = logging.getLogger('bzr')
-        log.addHandler(handler)
-
-        bzrlib.plugin.load_from_dir('.')
-
-        # Stop capturing output
-        handler.flush()
-        handler.close()
-        log.removeHandler(handler)
-
-        self.assertContainsRe(stream.getvalue(),
-            r"Unable to load 'bzr-bad plugin-name\.' in '\.' as a plugin "
-            "because the file path isn't a valid module name; try renaming "
-            "it to 'bad_plugin_name_'\.")
-
-        stream.close()
+
+class TestAllPlugins(TestCaseInTempDir):
+
+    def test_plugin_appears_in_all_plugins(self):
+        # This test tests a new plugin appears in bzrlib.plugin.all_plugins().
+        # check the plugin is not loaded already
+        self.failIf(getattr(bzrlib.plugins, 'plugin', None))
+        # write a plugin that _cannot_ fail to load.
+        file('plugin.py', 'w').write("\n")
+        try:
+            bzrlib.plugin.load_from_path(['.'])
+            all_plugins = self.applyDeprecated(zero_ninetyone,
+                bzrlib.plugin.all_plugins)
+            self.failUnless('plugin' in all_plugins)
+            self.failUnless(getattr(bzrlib.plugins, 'plugin', None))
+            self.assertEqual(all_plugins['plugin'], bzrlib.plugins.plugin)
+        finally:
+            # remove the plugin 'plugin'
+            if 'bzrlib.plugins.plugin' in sys.modules:
+                del sys.modules['bzrlib.plugins.plugin']
+            if getattr(bzrlib.plugins, 'plugin', None):
+                del bzrlib.plugins.plugin
+        self.failIf(getattr(bzrlib.plugins, 'plugin', None))
 
 
 class TestPlugins(TestCaseInTempDir):
@@ -253,28 +248,6 @@
         plugin_path = self.test_dir + '/plugin.py'
         self.assertIsSameRealPath(plugin_path, normpath(plugin.path()))
 
-    def test_plugin_get_path_py_not_pyc(self):
-        self.setup_plugin()         # after first import there will be plugin.pyc
-        self.teardown_plugin()
-        bzrlib.plugin.load_from_path(['.']) # import plugin.pyc
-        plugins = bzrlib.plugin.plugins()
-        plugin = plugins['plugin']
-        plugin_path = self.test_dir + '/plugin.py'
-        self.assertIsSameRealPath(plugin_path, normpath(plugin.path()))
-
-    def test_plugin_get_path_pyc_only(self):
-        self.setup_plugin()         # after first import there will be plugin.pyc
-        self.teardown_plugin()
-        os.unlink(self.test_dir + '/plugin.py')
-        bzrlib.plugin.load_from_path(['.']) # import plugin.pyc
-        plugins = bzrlib.plugin.plugins()
-        plugin = plugins['plugin']
-        if __debug__:
-            plugin_path = self.test_dir + '/plugin.pyc'
-        else:
-            plugin_path = self.test_dir + '/plugin.pyo'
-        self.assertIsSameRealPath(plugin_path, normpath(plugin.path()))
-
     def test_no_test_suite_gives_None_for_test_suite(self):
         self.setup_plugin()
         plugin = bzrlib.plugin.plugins()['plugin']
@@ -286,21 +259,6 @@
         plugin = bzrlib.plugin.plugins()['plugin']
         self.assertEqual('foo', plugin.test_suite())
 
-    def test_no_load_plugin_tests_gives_None_for_load_plugin_tests(self):
-        self.setup_plugin()
-        loader = TestUtil.TestLoader()
-        plugin = bzrlib.plugin.plugins()['plugin']
-        self.assertEqual(None, plugin.load_plugin_tests(loader))
-
-    def test_load_plugin_tests_gives_load_plugin_tests_result(self):
-        source = """
-def load_tests(standard_tests, module, loader):
-    return 'foo'"""
-        self.setup_plugin(source)
-        loader = TestUtil.TestLoader()
-        plugin = bzrlib.plugin.plugins()['plugin']
-        self.assertEqual('foo', plugin.load_plugin_tests(loader))
-
     def test_no_version_info(self):
         self.setup_plugin()
         plugin = bzrlib.plugin.plugins()['plugin']
@@ -403,8 +361,7 @@
         try:
             # this is normally done by load_plugins -> set_plugins_path
             bzrlib.plugins.__path__ = [zip_name]
-            self.applyDeprecated(one_three,
-                bzrlib.plugin.load_from_zip, zip_name)
+            bzrlib.plugin.load_from_zip(zip_name)
             self.assertTrue(plugin_name in dir(bzrlib.plugins),
                             'Plugin is not loaded')
         finally:
@@ -437,7 +394,7 @@
 
     def test_set_plugins_path_with_trailing_slashes(self):
         """set_plugins_path should set the module __path__ based on
-        BZR_PLUGIN_PATH after removing all trailing slashes."""
+        BZR_PLUGIN_PATH."""
         old_path = bzrlib.plugins.__path__
         old_env = os.environ.get('BZR_PLUGIN_PATH')
         try:
@@ -445,19 +402,16 @@
             os.environ['BZR_PLUGIN_PATH'] = "first\\//\\" + os.pathsep + \
                 "second/\\/\\/"
             bzrlib.plugin.set_plugins_path()
-            # We expect our nominated paths to have all path-seps removed,
-            # and this is testing only that.
-            expected_path = ['first', 'second']
-            self.assertEqual(expected_path,
-                bzrlib.plugins.__path__[:len(expected_path)])
+            expected_path = ['first', 'second',
+                os.path.dirname(bzrlib.plugins.__file__)]
+            self.assertEqual(expected_path, bzrlib.plugins.__path__)
         finally:
             bzrlib.plugins.__path__ = old_path
-            if old_env is not None:
+            if old_env != None:
                 os.environ['BZR_PLUGIN_PATH'] = old_env
             else:
                 del os.environ['BZR_PLUGIN_PATH']
 
-
 class TestHelpIndex(tests.TestCase):
     """Tests for the PluginsHelpIndex class."""
 

=== modified file 'bzrlib/tests/test_progress.py'
--- bzrlib/tests/test_progress.py	2008-02-13 03:30:01 +0000
+++ bzrlib/tests/test_progress.py	2007-07-11 06:47:30 +0000
@@ -24,19 +24,29 @@
         TTYProgressBar,
         DotsProgressBar,
         ProgressBarStack,
-        InstrumentedProgress,
         )
 from bzrlib.tests import TestCase
 
 
 class FakeStack:
-
     def __init__(self, top):
         self.__top = top
 
     def top(self):
         return self.__top
 
+class InstrumentedProgress(TTYProgressBar):
+    """TTYProgress variant that tracks outcomes"""
+
+    def __init__(self, *args, **kwargs):
+        self.always_throttled = True
+        TTYProgressBar.__init__(self, *args, **kwargs)
+
+    def throttle(self, old_message):
+        result = TTYProgressBar.throttle(self, old_message)
+        if result is False:
+            self.always_throttled = False
+        
 
 class _TTYStringIO(StringIO):
     """A helper class which makes a StringIO look like a terminal"""
@@ -53,7 +63,6 @@
 
 
 class TestProgress(TestCase):
-
     def setUp(self):
         q = DummyProgress()
         self.top = ChildProgress(_stack=FakeStack(q))

=== modified file 'bzrlib/tests/test_read_bundle.py'
--- bzrlib/tests/test_read_bundle.py	2008-04-01 19:30:25 +0000
+++ bzrlib/tests/test_read_bundle.py	2007-07-17 13:27:14 +0000
@@ -23,43 +23,13 @@
 from bzrlib.bundle.serializer import write_bundle
 import bzrlib.bzrdir
 import bzrlib.errors as errors
-from bzrlib import tests
+from bzrlib.tests import TestCaseInTempDir
 from bzrlib.tests.test_transport import TestTransportImplementation
-from bzrlib.tests.test_transport_implementations import TransportTestProviderAdapter
 import bzrlib.transport
 from bzrlib.transport.memory import MemoryTransport
 import bzrlib.urlutils
 
 
-def load_tests(standard_tests, module, loader):
-    """Multiply tests for tranport implementations."""
-    result = loader.suiteClass()
-    adapter = TransportTestProviderAdapter()
-    for test in tests.iter_suite_tests(standard_tests):
-        result.addTests(adapter.adapt(test))
-    return result
-
-
-def create_bundle_file(test_case):
-    test_case.build_tree(['tree/', 'tree/a', 'tree/subdir/'])
-
-    format = bzrlib.bzrdir.BzrDirFormat.get_default_format()
-
-    bzrdir = format.initialize('tree')
-    repo = bzrdir.create_repository()
-    branch = repo.bzrdir.create_branch()
-    wt = branch.bzrdir.create_workingtree()
-
-    wt.add(['a', 'subdir/'])
-    wt.commit('new project', rev_id='commit-1')
-
-    out = cStringIO.StringIO()
-    rev_ids = write_bundle(wt.branch.repository,
-                           wt.get_parent_ids()[0], 'null:', out)
-    out.seek(0)
-    return out, wt
-
-
 class TestReadBundleFromURL(TestTransportImplementation):
     """Test that read_bundle works properly across multiple transports"""
 
@@ -67,7 +37,22 @@
         return bzrlib.urlutils.join(self._server.get_url(), relpath)
 
     def create_test_bundle(self):
-        out, wt = create_bundle_file(self)
+        self.build_tree(['tree/', 'tree/a', 'tree/subdir/'])
+
+        format = bzrlib.bzrdir.BzrDirFormat.get_default_format()
+
+        bzrdir = format.initialize('tree')
+        repo = bzrdir.create_repository()
+        branch = repo.bzrdir.create_branch()
+        wt = branch.bzrdir.create_workingtree()
+
+        wt.add(['a', 'subdir/'])
+        wt.commit('new project', rev_id='commit-1')
+
+        out = cStringIO.StringIO()
+        rev_ids = write_bundle(wt.branch.repository,
+                               wt.get_parent_ids()[0], 'null:', out)
+        out.seek(0)
         if self.get_transport().is_readonly():
             f = open('test_bundle', 'wb')
             f.write(out.getvalue())
@@ -101,14 +86,3 @@
         self.assertRaises(errors.NotABundle, 
             bzrlib.bundle.read_bundle_from_url, 
             self.get_url('tree/a'))
-
-    def test_read_mergeable_populates_possible_transports(self):
-        self._captureVar('BZR_NO_SMART_VFS', None)
-        wt = self.create_test_bundle()
-        if wt is None:
-            return
-        possible_transports = []
-        url = unicode(self.get_url('test_bundle'))
-        info = bzrlib.bundle.read_mergeable_from_url(url,
-            possible_transports=possible_transports)
-        self.assertEqual(1, len(possible_transports))

=== modified file 'bzrlib/tests/test_reconcile.py'
--- bzrlib/tests/test_reconcile.py	2008-04-30 15:02:49 +0000
+++ bzrlib/tests/test_reconcile.py	2006-10-11 23:08:27 +0000
@@ -17,7 +17,8 @@
 """Tests for reconiliation behaviour that is repository independent."""
 
 
-from bzrlib import bzrdir, errors, tests
+import bzrlib
+import bzrlib.errors as errors
 from bzrlib.reconcile import reconcile, Reconciler
 from bzrlib.revision import Revision
 from bzrlib.tests.repository_implementations.test_repository import TestCaseWithRepository
@@ -29,10 +30,10 @@
 
     def test_reweave_empty(self):
         # we want a repo capable format
-        parent = bzrdir.BzrDirMetaFormat1().initialize('.')
+        parent = bzrlib.bzrdir.BzrDirMetaFormat1().initialize('.')
         parent.create_repository(shared=True)
         parent.root_transport.mkdir('child')
-        child = bzrdir.BzrDirMetaFormat1().initialize('child')
+        child = bzrlib.bzrdir.BzrDirMetaFormat1().initialize('child')
         self.assertRaises(errors.NoRepositoryPresent, child.open_repository)
         reconciler = Reconciler(child)
         reconciler.reconcile()
@@ -43,27 +44,3 @@
         self.assertEqual(0, reconciler.inconsistent_parents)
         # and no garbage inventories
         self.assertEqual(0, reconciler.garbage_inventories)
-
-
-class TestReconciler(tests.TestCaseWithTransport):
-    
-    def test_reconciler_with_no_branch(self):
-        repo = self.make_repository('repo')
-        reconciler = Reconciler(repo.bzrdir)
-        reconciler.reconcile()
-        # no inconsistent parents should have been found
-        # but the values should have been set.
-        self.assertEqual(0, reconciler.inconsistent_parents)
-        # and no garbage inventories
-        self.assertEqual(0, reconciler.garbage_inventories)
-        self.assertIs(None, reconciler.fixed_branch_history)
-
-    def test_reconciler_finds_branch(self):
-        a_branch = self.make_branch('a_branch')
-        reconciler = Reconciler(a_branch.bzrdir)
-        reconciler.reconcile()
-
-        # It should have checked the repository, and the branch
-        self.assertEqual(0, reconciler.inconsistent_parents)
-        self.assertEqual(0, reconciler.garbage_inventories)
-        self.assertIs(False, reconciler.fixed_branch_history)

=== modified file 'bzrlib/tests/test_reconfigure.py'
--- bzrlib/tests/test_reconfigure.py	2008-04-25 22:16:00 +0000
+++ bzrlib/tests/test_reconfigure.py	2007-09-13 01:54:20 +0000
@@ -18,7 +18,6 @@
     branch as _mod_branch,
     errors,
     reconfigure,
-    repository,
     tests,
     workingtree,
     )
@@ -50,8 +49,8 @@
 
     def test_repo_to_branch(self):
         repo = self.make_repository('repo')
-        reconfiguration = reconfigure.Reconfigure.to_branch(repo.bzrdir)
-        reconfiguration.apply()
+        self.assertRaises(errors.ReconfigurationNotSupported,
+                          reconfigure.Reconfigure.to_branch, repo.bzrdir)
 
     def test_checkout_to_branch(self):
         branch = self.make_branch('branch')
@@ -60,16 +59,11 @@
         reconfiguration.apply()
         self.assertIs(None, checkout.branch.get_bound_location())
 
-    def prepare_lightweight_checkout_to_branch(self):
+    def test_lightweight_checkout_to_branch(self):
         branch = self.make_branch('branch')
         checkout = branch.create_checkout('checkout', lightweight=True)
         checkout.commit('first commit', rev_id='rev1')
         reconfiguration = reconfigure.Reconfigure.to_branch(checkout.bzrdir)
-        return reconfiguration, checkout
-
-    def test_lightweight_checkout_to_branch(self):
-        reconfiguration, checkout = \
-            self.prepare_lightweight_checkout_to_branch()
         reconfiguration.apply()
         checkout_branch = checkout.bzrdir.open_branch()
         self.assertEqual(checkout_branch.bzrdir.root_transport.base,
@@ -78,35 +72,14 @@
         repo = checkout.bzrdir.open_repository()
         repo.get_revision('rev1')
 
-    def test_lightweight_checkout_to_branch_tags(self):
-        reconfiguration, checkout = \
-            self.prepare_lightweight_checkout_to_branch()
-        checkout.branch.tags.set_tag('foo', 'bar')
-        reconfiguration.apply()
-        checkout_branch = checkout.bzrdir.open_branch()
-        self.assertEqual('bar', checkout_branch.tags.lookup_tag('foo'))
-
-    def prepare_lightweight_checkout_to_checkout(self):
+    def test_lightweight_checkout_to_checkout(self):
         branch = self.make_branch('branch')
         checkout = branch.create_checkout('checkout', lightweight=True)
         reconfiguration = reconfigure.Reconfigure.to_checkout(checkout.bzrdir)
-        return reconfiguration, checkout
-
-    def test_lightweight_checkout_to_checkout(self):
-        reconfiguration, checkout = \
-            self.prepare_lightweight_checkout_to_checkout()
         reconfiguration.apply()
         checkout_branch = checkout.bzrdir.open_branch()
         self.assertIsNot(checkout_branch.get_bound_location(), None)
 
-    def test_lightweight_checkout_to_checkout_tags(self):
-        reconfiguration, checkout = \
-            self.prepare_lightweight_checkout_to_checkout()
-        checkout.branch.tags.set_tag('foo', 'bar')
-        reconfiguration.apply()
-        checkout_branch = checkout.bzrdir.open_branch()
-        self.assertEqual('bar', checkout_branch.tags.lookup_tag('foo'))
-
     def test_lightweight_conversion_uses_shared_repo(self):
         parent = self.make_branch('parent')
         shared_repo = self.make_repository('repo', shared=True)
@@ -138,12 +111,9 @@
         branch.set_push_location('sftp://push')
         self.assertEqual('sftp://push',
                          reconfiguration._select_bind_location())
-        branch.set_bound_location('bzr://foo/old-bound')
+        branch.set_bound_location('bzr:old-bound')
         branch.set_bound_location(None)
-        self.assertEqual('bzr://foo/old-bound',
-                         reconfiguration._select_bind_location())
-        branch.set_bound_location('bzr://foo/cur-bound')
-        self.assertEqual('bzr://foo/cur-bound',
+        self.assertEqual('bzr:old-bound',
                          reconfiguration._select_bind_location())
         reconfiguration.new_bound_location = 'ftp://user-specified'
         self.assertEqual('ftp://user-specified',
@@ -173,207 +143,8 @@
                                                               parent.base)
         reconfiguration.apply()
 
-    def test_tree_to_lightweight_checkout(self):
-        # A tree with no related branches and no supplied bind location cannot
-        # become a checkout
-        parent = self.make_branch('parent')
-
-        tree = self.make_branch_and_tree('tree')
-        reconfiguration = reconfigure.Reconfigure.to_lightweight_checkout(
-            tree.bzrdir)
-        self.assertRaises(errors.NoBindLocation, reconfiguration.apply)
-        # setting a parent allows it to become a checkout
-        tree.branch.set_parent(parent.base)
-        reconfiguration.apply()
-        # supplying a location allows it to become a checkout
-        tree2 = self.make_branch_and_tree('tree2')
-        reconfiguration = reconfigure.Reconfigure.to_lightweight_checkout(
-            tree2.bzrdir, parent.base)
-        reconfiguration.apply()
-
     def test_checkout_to_checkout(self):
         parent = self.make_branch('parent')
         checkout = parent.create_checkout('checkout')
         self.assertRaises(errors.AlreadyCheckout,
                           reconfigure.Reconfigure.to_checkout, checkout.bzrdir)
-
-    def make_unsynced_checkout(self):
-        parent = self.make_branch('parent')
-        checkout = parent.create_checkout('checkout')
-        checkout.commit('test', rev_id='new-commit', local=True)
-        reconfiguration = reconfigure.Reconfigure.to_lightweight_checkout(
-            checkout.bzrdir)
-        return checkout, parent, reconfiguration
-
-    def test_unsynced_checkout_to_lightweight(self):
-        checkout, parent, reconfiguration = self.make_unsynced_checkout()
-        self.assertRaises(errors.UnsyncedBranches, reconfiguration.apply)
-
-    def test_synced_checkout_to_lightweight(self):
-        checkout, parent, reconfiguration = self.make_unsynced_checkout()
-        parent.pull(checkout.branch)
-        reconfiguration.apply()
-        wt = checkout.bzrdir.open_workingtree()
-        self.assertTrue(parent.repository.has_same_location(
-            wt.branch.repository))
-        parent.repository.get_revision('new-commit')
-        self.assertRaises(errors.NoRepositoryPresent,
-                          checkout.bzrdir.open_repository)
-
-    def prepare_branch_to_lightweight_checkout(self):
-        parent = self.make_branch('parent')
-        child = parent.bzrdir.sprout('child').open_workingtree()
-        child.commit('test', rev_id='new-commit')
-        parent.pull(child.branch)
-        child.bzrdir.destroy_workingtree()
-        reconfiguration = reconfigure.Reconfigure.to_lightweight_checkout(
-            child.bzrdir)
-        return parent, child, reconfiguration
-
-    def test_branch_to_lightweight_checkout(self):
-        parent, child, reconfiguration = \
-            self.prepare_branch_to_lightweight_checkout()
-        reconfiguration.apply()
-        self.assertTrue(reconfiguration._destroy_branch)
-        wt = child.bzrdir.open_workingtree()
-        self.assertTrue(parent.repository.has_same_location(
-            wt.branch.repository))
-        parent.repository.get_revision('new-commit')
-        self.assertRaises(errors.NoRepositoryPresent,
-                          child.bzrdir.open_repository)
-
-    def test_branch_to_lightweight_checkout_failure(self):
-        parent, child, reconfiguration = \
-            self.prepare_branch_to_lightweight_checkout()
-        old_Repository_fetch = repository.Repository.fetch
-        repository.Repository.fetch = None
-        try:
-            self.assertRaises(TypeError, reconfiguration.apply)
-        finally:
-            repository.Repository.fetch = old_Repository_fetch
-        child = _mod_branch.Branch.open('child')
-        self.assertContainsRe(child.base, 'child/$')
-
-    def test_branch_to_lightweight_checkout_fetch_tags(self):
-        parent, child, reconfiguration = \
-            self.prepare_branch_to_lightweight_checkout()
-        child.branch.tags.set_tag('foo', 'bar')
-        reconfiguration.apply()
-        child = _mod_branch.Branch.open('child')
-        self.assertEqual('bar', parent.tags.lookup_tag('foo'))
-
-    def test_lightweight_checkout_to_lightweight_checkout(self):
-        parent = self.make_branch('parent')
-        checkout = parent.create_checkout('checkout', lightweight=True)
-        self.assertRaises(errors.AlreadyLightweightCheckout,
-                          reconfigure.Reconfigure.to_lightweight_checkout,
-                          checkout.bzrdir)
-
-    def test_repo_to_tree(self):
-        repo = self.make_repository('repo')
-        reconfiguration = reconfigure.Reconfigure.to_tree(repo.bzrdir)
-        reconfiguration.apply()
-        workingtree.WorkingTree.open('repo')
-
-    def test_shared_repo_to_lightweight_checkout(self):
-        repo = self.make_repository('repo', shared=True)
-        reconfiguration = reconfigure.Reconfigure.to_lightweight_checkout(
-            repo.bzrdir)
-        self.assertRaises(errors.NoBindLocation, reconfiguration.apply)
-        branch = self.make_branch('branch')
-        reconfiguration = reconfigure.Reconfigure.to_lightweight_checkout(
-            repo.bzrdir, 'branch')
-        reconfiguration.apply()
-        workingtree.WorkingTree.open('repo')
-        repository.Repository.open('repo')
-
-    def test_unshared_repo_to_lightweight_checkout(self):
-        repo = self.make_repository('repo', shared=False)
-        branch = self.make_branch('branch')
-        reconfiguration = reconfigure.Reconfigure.to_lightweight_checkout(
-            repo.bzrdir, 'branch')
-        reconfiguration.apply()
-        workingtree.WorkingTree.open('repo')
-        self.assertRaises(errors.NoRepositoryPresent,
-                          repository.Repository.open, 'repo')
-
-    def test_standalone_to_use_shared(self):
-        self.build_tree(['root/'])
-        tree = self.make_branch_and_tree('root/tree')
-        tree.commit('Hello', rev_id='hello-id')
-        repo = self.make_repository('root', shared=True)
-        reconfiguration = reconfigure.Reconfigure.to_use_shared(tree.bzrdir)
-        reconfiguration.apply()
-        tree = workingtree.WorkingTree.open('root/tree')
-        self.assertTrue(repo.has_same_location(tree.branch.repository))
-        self.assertEqual('Hello', repo.get_revision('hello-id').message)
-
-    def add_dead_head(self, tree):
-        revno, revision_id = tree.branch.last_revision_info()
-        tree.commit('Dead head', rev_id='dead-head-id')
-        tree.branch.set_last_revision_info(revno, revision_id)
-        tree.set_last_revision(revision_id)
-
-    def test_standalone_to_use_shared_preserves_dead_heads(self):
-        self.build_tree(['root/'])
-        tree = self.make_branch_and_tree('root/tree')
-        self.add_dead_head(tree)
-        tree.commit('Hello', rev_id='hello-id')
-        repo = self.make_repository('root', shared=True)
-        reconfiguration = reconfigure.Reconfigure.to_use_shared(tree.bzrdir)
-        reconfiguration.apply()
-        tree = workingtree.WorkingTree.open('root/tree')
-        message = repo.get_revision('dead-head-id').message
-        self.assertEqual('Dead head', message)
-
-    def make_repository_tree(self):
-        self.build_tree(['root/'])
-        repo = self.make_repository('root', shared=True)
-        tree = self.make_branch_and_tree('root/tree')
-        reconfigure.Reconfigure.to_use_shared(tree.bzrdir).apply()
-        return workingtree.WorkingTree.open('root/tree')
-
-    def test_use_shared_to_use_shared(self):
-        tree = self.make_repository_tree()
-        self.assertRaises(errors.AlreadyUsingShared,
-                          reconfigure.Reconfigure.to_use_shared, tree.bzrdir)
-
-    def test_use_shared_to_standalone(self):
-        tree = self.make_repository_tree()
-        tree.commit('Hello', rev_id='hello-id')
-        reconfigure.Reconfigure.to_standalone(tree.bzrdir).apply()
-        tree = workingtree.WorkingTree.open('root/tree')
-        repo = tree.branch.repository
-        self.assertEqual(repo.bzrdir.root_transport.base,
-                         tree.bzrdir.root_transport.base)
-        self.assertEqual('Hello', repo.get_revision('hello-id').message)
-
-    def test_use_shared_to_standalone_preserves_dead_heads(self):
-        tree = self.make_repository_tree()
-        self.add_dead_head(tree)
-        tree.commit('Hello', rev_id='hello-id')
-        reconfigure.Reconfigure.to_standalone(tree.bzrdir).apply()
-        tree = workingtree.WorkingTree.open('root/tree')
-        repo = tree.branch.repository
-        self.assertRaises(errors.NoSuchRevision, repo.get_revision,
-                          'dead-head-id')
-
-    def test_standalone_to_standalone(self):
-        tree = self.make_branch_and_tree('tree')
-        self.assertRaises(errors.AlreadyStandalone,
-                          reconfigure.Reconfigure.to_standalone, tree.bzrdir)
-
-    def make_unsynced_branch_reconfiguration(self):
-        parent = self.make_branch_and_tree('parent')
-        parent.commit('commit 1')
-        child = parent.bzrdir.sprout('child').open_workingtree()
-        child.commit('commit 2')
-        return reconfigure.Reconfigure.to_lightweight_checkout(child.bzrdir)
-
-    def test_unsynced_branch_to_lightweight_checkout_unforced(self):
-        reconfiguration = self.make_unsynced_branch_reconfiguration()
-        self.assertRaises(errors.UnsyncedBranches, reconfiguration.apply)
-
-    def test_unsynced_branch_to_lightweight_checkout_forced(self):
-        reconfiguration = self.make_unsynced_branch_reconfiguration()
-        reconfiguration.apply(force=True)

=== modified file 'bzrlib/tests/test_registry.py'
--- bzrlib/tests/test_registry.py	2008-05-08 04:21:01 +0000
+++ bzrlib/tests/test_registry.py	2006-10-16 01:50:48 +0000
@@ -41,7 +41,7 @@
 
         self.failUnless(a_registry.default_key is None)
 
-        # test get() (self.default_key is None)
+        # test get() (self.default_key == None)
         self.assertRaises(KeyError, a_registry.get)
         self.assertRaises(KeyError, a_registry.get, None)
         self.assertEqual(2, a_registry.get('two'))
@@ -187,20 +187,6 @@
                          ], sorted((key, a_registry.get_info(key))
                                     for key in a_registry.keys()))
 
-    def test_get_prefix(self):
-        my_registry = registry.Registry()
-        http_object = object()
-        sftp_object = object()
-        my_registry.register('http:', http_object)
-        my_registry.register('sftp:', sftp_object)
-        found_object, suffix = my_registry.get_prefix('http://foo/bar')
-        self.assertEqual('//foo/bar', suffix)
-        self.assertIs(http_object, found_object)
-        self.assertIsNot(sftp_object, found_object)
-        found_object, suffix = my_registry.get_prefix('sftp://baz/qux')
-        self.assertEqual('//baz/qux', suffix)
-        self.assertIs(sftp_object, found_object)
-
 
 class TestRegistryWithDirs(TestCaseInTempDir):
     """Registry tests that require temporary dirs"""

=== modified file 'bzrlib/tests/test_remote.py'
--- bzrlib/tests/test_remote.py	2008-07-25 06:42:08 +0000
+++ bzrlib/tests/test_remote.py	2007-10-12 06:24:42 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007, 2008 Canonical Ltd
+# Copyright (C) 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -23,12 +23,11 @@
 These tests correspond to tests.test_smart, which exercises the server side.
 """
 
-import bz2
 from cStringIO import StringIO
 
 from bzrlib import (
+    bzrdir,
     errors,
-    graph,
     pack,
     remote,
     repository,
@@ -45,10 +44,8 @@
 from bzrlib.revision import NULL_REVISION
 from bzrlib.smart import server, medium
 from bzrlib.smart.client import _SmartClient
-from bzrlib.symbol_versioning import one_four
-from bzrlib.transport import get_transport, http
 from bzrlib.transport.memory import MemoryTransport
-from bzrlib.transport.remote import RemoteTransport, RemoteTCPTransport
+from bzrlib.transport.remote import RemoteTransport
 
 
 class BasicRemoteObjectTests(tests.TestCaseWithTransport):
@@ -57,6 +54,7 @@
         self.transport_server = server.SmartTCPServer_for_testing
         super(BasicRemoteObjectTests, self).setUp()
         self.transport = self.get_transport()
+        self.client = self.transport.get_smart_client()
         # make a branch that can be opened over the smart transport
         self.local_wt = BzrDir.create_standalone_workingtree('.')
 
@@ -110,13 +108,10 @@
     """Lookalike SmartClientRequestProtocolOne allowing body reading tests."""
 
     def __init__(self, body, fake_client):
-        self.body = body
-        self._body_buffer = None
+        self._body_buffer = StringIO(body)
         self._fake_client = fake_client
 
     def read_body_bytes(self, count=-1):
-        if self._body_buffer is None:
-            self._body_buffer = StringIO(self.body)
         bytes = self._body_buffer.read(count)
         if self._body_buffer.tell() == len(self._body_buffer.getvalue()):
             self._fake_client.expecting_body = False
@@ -125,227 +120,60 @@
     def cancel_read_body(self):
         self._fake_client.expecting_body = False
 
-    def read_streamed_body(self):
-        return self.body
-
 
 class FakeClient(_SmartClient):
     """Lookalike for _SmartClient allowing testing."""
     
-    def __init__(self, fake_medium_base='fake base'):
+    def __init__(self, responses):
+        # We don't call the super init because there is no medium.
         """Create a FakeClient.
 
-        :param responses: A list of response-tuple, body-data pairs to be sent
-            back to callers.  A special case is if the response-tuple is
-            'unknown verb', then a UnknownSmartMethod will be raised for that
-            call, using the second element of the tuple as the verb in the
-            exception.
+        :param respones: A list of response-tuple, body-data pairs to be sent
+            back to callers.
         """
-        self.responses = []
+        self.responses = responses
         self._calls = []
         self.expecting_body = False
-        _SmartClient.__init__(self, FakeMedium(self._calls, fake_medium_base))
-
-    def add_success_response(self, *args):
-        self.responses.append(('success', args, None))
-
-    def add_success_response_with_body(self, body, *args):
-        self.responses.append(('success', args, body))
-
-    def add_error_response(self, *args):
-        self.responses.append(('error', args))
-
-    def add_unknown_method_response(self, verb):
-        self.responses.append(('unknown', verb))
-
-    def _get_next_response(self):
-        response_tuple = self.responses.pop(0)
-        if response_tuple[0] == 'unknown':
-            raise errors.UnknownSmartMethod(response_tuple[1])
-        elif response_tuple[0] == 'error':
-            raise errors.ErrorFromSmartServer(response_tuple[1])
-        return response_tuple
 
     def call(self, method, *args):
         self._calls.append(('call', method, args))
-        return self._get_next_response()[1]
+        return self.responses.pop(0)[0]
 
     def call_expecting_body(self, method, *args):
         self._calls.append(('call_expecting_body', method, args))
-        result = self._get_next_response()
-        self.expecting_body = True
-        return result[1], FakeProtocol(result[2], self)
-
-    def call_with_body_bytes_expecting_body(self, method, args, body):
-        self._calls.append(('call_with_body_bytes_expecting_body', method,
-            args, body))
-        result = self._get_next_response()
-        self.expecting_body = True
-        return result[1], FakeProtocol(result[2], self)
-
-
-class FakeMedium(medium.SmartClientMedium):
-
-    def __init__(self, client_calls, base):
-        medium.SmartClientMedium.__init__(self, base)
-        self._client_calls = client_calls
-
-    def disconnect(self):
-        self._client_calls.append(('disconnect medium',))
-
-
-class TestVfsHas(tests.TestCase):
-
-    def test_unicode_path(self):
-        client = FakeClient('/')
-        client.add_success_response('yes',)
-        transport = RemoteTransport('bzr://localhost/', _client=client)
-        filename = u'/hell\u00d8'.encode('utf8')
-        result = transport.has(filename)
-        self.assertEqual(
-            [('call', 'has', (filename,))],
-            client._calls)
-        self.assertTrue(result)
-
-
-class Test_ClientMedium_remote_path_from_transport(tests.TestCase):
-    """Tests for the behaviour of client_medium.remote_path_from_transport."""
-
-    def assertRemotePath(self, expected, client_base, transport_base):
-        """Assert that the result of
-        SmartClientMedium.remote_path_from_transport is the expected value for
-        a given client_base and transport_base.
-        """
-        client_medium = medium.SmartClientMedium(client_base)
-        transport = get_transport(transport_base)
-        result = client_medium.remote_path_from_transport(transport)
-        self.assertEqual(expected, result)
-
-    def test_remote_path_from_transport(self):
-        """SmartClientMedium.remote_path_from_transport calculates a URL for
-        the given transport relative to the root of the client base URL.
-        """
-        self.assertRemotePath('xyz/', 'bzr://host/path', 'bzr://host/xyz')
-        self.assertRemotePath(
-            'path/xyz/', 'bzr://host/path', 'bzr://host/path/xyz')
-
-    def assertRemotePathHTTP(self, expected, transport_base, relpath):
-        """Assert that the result of
-        HttpTransportBase.remote_path_from_transport is the expected value for
-        a given transport_base and relpath of that transport.  (Note that
-        HttpTransportBase is a subclass of SmartClientMedium)
-        """
-        base_transport = get_transport(transport_base)
-        client_medium = base_transport.get_smart_medium()
-        cloned_transport = base_transport.clone(relpath)
-        result = client_medium.remote_path_from_transport(cloned_transport)
-        self.assertEqual(expected, result)
-        
-    def test_remote_path_from_transport_http(self):
-        """Remote paths for HTTP transports are calculated differently to other
-        transports.  They are just relative to the client base, not the root
-        directory of the host.
-        """
-        for scheme in ['http:', 'https:', 'bzr+http:', 'bzr+https:']:
-            self.assertRemotePathHTTP(
-                '../xyz/', scheme + '//host/path', '../xyz/')
-            self.assertRemotePathHTTP(
-                'xyz/', scheme + '//host/path', 'xyz/')
-
-
-class Test_ClientMedium_remote_is_at_least(tests.TestCase):
-    """Tests for the behaviour of client_medium.remote_is_at_least."""
-
-    def test_initially_unlimited(self):
-        """A fresh medium assumes that the remote side supports all
-        versions.
-        """
-        client_medium = medium.SmartClientMedium('dummy base')
-        self.assertFalse(client_medium._is_remote_before((99, 99)))
-    
-    def test__remember_remote_is_before(self):
-        """Calling _remember_remote_is_before ratchets down the known remote
-        version.
-        """
-        client_medium = medium.SmartClientMedium('dummy base')
-        # Mark the remote side as being less than 1.6.  The remote side may
-        # still be 1.5.
-        client_medium._remember_remote_is_before((1, 6))
-        self.assertTrue(client_medium._is_remote_before((1, 6)))
-        self.assertFalse(client_medium._is_remote_before((1, 5)))
-        # Calling _remember_remote_is_before again with a lower value works.
-        client_medium._remember_remote_is_before((1, 5))
-        self.assertTrue(client_medium._is_remote_before((1, 5)))
-        # You cannot call _remember_remote_is_before with a larger value.
-        self.assertRaises(
-            AssertionError, client_medium._remember_remote_is_before, (1, 9))
+        result = self.responses.pop(0)
+        self.expecting_body = True
+        return result[0], FakeProtocol(result[1], self)
 
 
 class TestBzrDirOpenBranch(tests.TestCase):
 
     def test_branch_present(self):
+        client = FakeClient([(('ok', ''), ), (('ok', '', 'no', 'no'), )])
         transport = MemoryTransport()
         transport.mkdir('quack')
         transport = transport.clone('quack')
-        client = FakeClient(transport.base)
-        client.add_success_response('ok', '')
-        client.add_success_response('ok', '', 'no', 'no', 'no')
         bzrdir = RemoteBzrDir(transport, _client=client)
         result = bzrdir.open_branch()
         self.assertEqual(
-            [('call', 'BzrDir.open_branch', ('quack/',)),
-             ('call', 'BzrDir.find_repositoryV2', ('quack/',))],
+            [('call', 'BzrDir.open_branch', ('///quack/',)),
+             ('call', 'BzrDir.find_repository', ('///quack/',))],
             client._calls)
         self.assertIsInstance(result, RemoteBranch)
         self.assertEqual(bzrdir, result.bzrdir)
 
     def test_branch_missing(self):
+        client = FakeClient([(('nobranch',), )])
         transport = MemoryTransport()
         transport.mkdir('quack')
         transport = transport.clone('quack')
-        client = FakeClient(transport.base)
-        client.add_error_response('nobranch')
         bzrdir = RemoteBzrDir(transport, _client=client)
         self.assertRaises(errors.NotBranchError, bzrdir.open_branch)
         self.assertEqual(
-            [('call', 'BzrDir.open_branch', ('quack/',))],
-            client._calls)
-
-    def test__get_tree_branch(self):
-        # _get_tree_branch is a form of open_branch, but it should only ask for
-        # branch opening, not any other network requests.
-        calls = []
-        def open_branch():
-            calls.append("Called")
-            return "a-branch"
-        transport = MemoryTransport()
-        # no requests on the network - catches other api calls being made.
-        client = FakeClient(transport.base)
-        bzrdir = RemoteBzrDir(transport, _client=client)
-        # patch the open_branch call to record that it was called.
-        bzrdir.open_branch = open_branch
-        self.assertEqual((None, "a-branch"), bzrdir._get_tree_branch())
-        self.assertEqual(["Called"], calls)
-        self.assertEqual([], client._calls)
-
-    def test_url_quoting_of_path(self):
-        # Relpaths on the wire should not be URL-escaped.  So "~" should be
-        # transmitted as "~", not "%7E".
-        transport = RemoteTCPTransport('bzr://localhost/~hello/')
-        client = FakeClient(transport.base)
-        client.add_success_response('ok', '')
-        client.add_success_response('ok', '', 'no', 'no', 'no')
-        bzrdir = RemoteBzrDir(transport, _client=client)
-        result = bzrdir.open_branch()
-        self.assertEqual(
-            [('call', 'BzrDir.open_branch', ('~hello/',)),
-             ('call', 'BzrDir.find_repositoryV2', ('~hello/',))],
-            client._calls)
-
-    def check_open_repository(self, rich_root, subtrees, external_lookup='no'):
-        transport = MemoryTransport()
-        transport.mkdir('quack')
-        transport = transport.clone('quack')
+            [('call', 'BzrDir.open_branch', ('///quack/',))],
+            client._calls)
+
+    def check_open_repository(self, rich_root, subtrees):
         if rich_root:
             rich_response = 'yes'
         else:
@@ -354,13 +182,14 @@
             subtree_response = 'yes'
         else:
             subtree_response = 'no'
-        client = FakeClient(transport.base)
-        client.add_success_response(
-            'ok', '', rich_response, subtree_response, external_lookup)
+        client = FakeClient([(('ok', '', rich_response, subtree_response), ),])
+        transport = MemoryTransport()
+        transport.mkdir('quack')
+        transport = transport.clone('quack')
         bzrdir = RemoteBzrDir(transport, _client=client)
         result = bzrdir.open_repository()
         self.assertEqual(
-            [('call', 'BzrDir.find_repositoryV2', ('quack/',))],
+            [('call', 'BzrDir.find_repository', ('///quack/',))],
             client._calls)
         self.assertIsInstance(result, RemoteRepository)
         self.assertEqual(bzrdir, result.bzrdir)
@@ -372,7 +201,6 @@
         self.check_open_repository(False, True)
         self.check_open_repository(True, False)
         self.check_open_repository(False, False)
-        self.check_open_repository(False, False, 'yes')
 
     def test_old_server(self):
         """RemoteBzrDirFormat should fail to probe if the server version is too
@@ -382,23 +210,6 @@
             RemoteBzrDirFormat.probe_transport, OldServerTransport())
 
 
-class TestBzrDirOpenRepository(tests.TestCase):
-
-    def test_backwards_compat_1_2(self):
-        transport = MemoryTransport()
-        transport.mkdir('quack')
-        transport = transport.clone('quack')
-        client = FakeClient(transport.base)
-        client.add_unknown_method_response('RemoteRepository.find_repositoryV2')
-        client.add_success_response('ok', '', 'no', 'no')
-        bzrdir = RemoteBzrDir(transport, _client=client)
-        repo = bzrdir.open_repository()
-        self.assertEqual(
-            [('call', 'BzrDir.find_repositoryV2', ('quack/',)),
-             ('call', 'BzrDir.find_repository', ('quack/',))],
-            client._calls)
-
-
 class OldSmartClient(object):
     """A fake smart client for test_old_version that just returns a version one
     response to the 'hello' (query version) command.
@@ -411,9 +222,6 @@
             input_file, output_file)
         return medium.SmartClientStreamMediumRequest(client_medium)
 
-    def protocol_version(self):
-        return 1
-
 
 class OldServerTransport(object):
     """A fake transport for test_old_server that reports it's smart server
@@ -431,9 +239,8 @@
 
     def test_empty_branch(self):
         # in an empty branch we decode the response properly
+        client = FakeClient([(('ok', '0', 'null:'), )])
         transport = MemoryTransport()
-        client = FakeClient(transport.base)
-        client.add_success_response('ok', '0', 'null:')
         transport.mkdir('quack')
         transport = transport.clone('quack')
         # we do not want bzrdir to make any remote calls
@@ -442,16 +249,15 @@
         result = branch.last_revision_info()
 
         self.assertEqual(
-            [('call', 'Branch.last_revision_info', ('quack/',))],
+            [('call', 'Branch.last_revision_info', ('///quack/',))],
             client._calls)
         self.assertEqual((0, NULL_REVISION), result)
 
     def test_non_empty_branch(self):
         # in a non-empty branch we also decode the response properly
         revid = u'\xc8'.encode('utf8')
+        client = FakeClient([(('ok', '2', revid), )])
         transport = MemoryTransport()
-        client = FakeClient(transport.base)
-        client.add_success_response('ok', '2', revid)
         transport.mkdir('kwaak')
         transport = transport.clone('kwaak')
         # we do not want bzrdir to make any remote calls
@@ -460,7 +266,7 @@
         result = branch.last_revision_info()
 
         self.assertEqual(
-            [('call', 'Branch.last_revision_info', ('kwaak/',))],
+            [('call', 'Branch.last_revision_info', ('///kwaak/',))],
             client._calls)
         self.assertEqual((2, revid), result)
 
@@ -470,17 +276,17 @@
     def test_set_empty(self):
         # set_revision_history([]) is translated to calling
         # Branch.set_last_revision(path, '') on the wire.
+        client = FakeClient([
+            # lock_write
+            (('ok', 'branch token', 'repo token'), ),
+            # set_last_revision
+            (('ok',), ),
+            # unlock
+            (('ok',), )])
         transport = MemoryTransport()
         transport.mkdir('branch')
         transport = transport.clone('branch')
 
-        client = FakeClient(transport.base)
-        # lock_write
-        client.add_success_response('ok', 'branch token', 'repo token')
-        # set_last_revision
-        client.add_success_response('ok')
-        # unlock
-        client.add_success_response('ok')
         bzrdir = RemoteBzrDir(transport, _client=False)
         branch = RemoteBranch(bzrdir, None, _client=client)
         # This is a hack to work around the problem that RemoteBranch currently
@@ -491,7 +297,7 @@
         result = branch.set_revision_history([])
         self.assertEqual(
             [('call', 'Branch.set_last_revision',
-                ('branch/', 'branch token', 'repo token', 'null:'))],
+                ('///branch/', 'branch token', 'repo token', 'null:'))],
             client._calls)
         branch.unlock()
         self.assertEqual(None, result)
@@ -499,17 +305,17 @@
     def test_set_nonempty(self):
         # set_revision_history([rev-id1, ..., rev-idN]) is translated to calling
         # Branch.set_last_revision(path, rev-idN) on the wire.
+        client = FakeClient([
+            # lock_write
+            (('ok', 'branch token', 'repo token'), ),
+            # set_last_revision
+            (('ok',), ),
+            # unlock
+            (('ok',), )])
         transport = MemoryTransport()
         transport.mkdir('branch')
         transport = transport.clone('branch')
 
-        client = FakeClient(transport.base)
-        # lock_write
-        client.add_success_response('ok', 'branch token', 'repo token')
-        # set_last_revision
-        client.add_success_response('ok')
-        # unlock
-        client.add_success_response('ok')
         bzrdir = RemoteBzrDir(transport, _client=False)
         branch = RemoteBranch(bzrdir, None, _client=client)
         # This is a hack to work around the problem that RemoteBranch currently
@@ -522,27 +328,26 @@
         result = branch.set_revision_history(['rev-id1', 'rev-id2'])
         self.assertEqual(
             [('call', 'Branch.set_last_revision',
-                ('branch/', 'branch token', 'repo token', 'rev-id2'))],
+                ('///branch/', 'branch token', 'repo token', 'rev-id2'))],
             client._calls)
         branch.unlock()
         self.assertEqual(None, result)
 
     def test_no_such_revision(self):
+        # A response of 'NoSuchRevision' is translated into an exception.
+        client = FakeClient([
+            # lock_write
+            (('ok', 'branch token', 'repo token'), ),
+            # set_last_revision
+            (('NoSuchRevision', 'rev-id'), ),
+            # unlock
+            (('ok',), )])
         transport = MemoryTransport()
         transport.mkdir('branch')
         transport = transport.clone('branch')
-        # A response of 'NoSuchRevision' is translated into an exception.
-        client = FakeClient(transport.base)
-        # lock_write
-        client.add_success_response('ok', 'branch token', 'repo token')
-        # set_last_revision
-        client.add_error_response('NoSuchRevision', 'rev-id')
-        # unlock
-        client.add_success_response('ok')
 
         bzrdir = RemoteBzrDir(transport, _client=False)
-        repo = RemoteRepository(bzrdir, None, _client=client)
-        branch = RemoteBranch(bzrdir, repo, _client=client)
+        branch = RemoteBranch(bzrdir, None, _client=client)
         branch._ensure_real = lambda: None
         branch.lock_write()
         client._calls = []
@@ -551,261 +356,53 @@
             errors.NoSuchRevision, branch.set_revision_history, ['rev-id'])
         branch.unlock()
 
-    def test_tip_change_rejected(self):
-        """TipChangeRejected responses cause a TipChangeRejected exception to
-        be raised.
-        """
-        transport = MemoryTransport()
-        transport.mkdir('branch')
-        transport = transport.clone('branch')
-        client = FakeClient(transport.base)
-        # lock_write
-        client.add_success_response('ok', 'branch token', 'repo token')
-        # set_last_revision
-        rejection_msg_unicode = u'rejection message\N{INTERROBANG}'
-        rejection_msg_utf8 = rejection_msg_unicode.encode('utf8')
-        client.add_error_response('TipChangeRejected', rejection_msg_utf8)
-        # unlock
-        client.add_success_response('ok')
-
-        bzrdir = RemoteBzrDir(transport, _client=False)
-        repo = RemoteRepository(bzrdir, None, _client=client)
-        branch = RemoteBranch(bzrdir, repo, _client=client)
-        branch._ensure_real = lambda: None
-        branch.lock_write()
-        self.addCleanup(branch.unlock)
-        client._calls = []
-
-        # The 'TipChangeRejected' error response triggered by calling
-        # set_revision_history causes a TipChangeRejected exception.
-        err = self.assertRaises(
-            errors.TipChangeRejected, branch.set_revision_history, ['rev-id'])
-        # The UTF-8 message from the response has been decoded into a unicode
-        # object.
-        self.assertIsInstance(err.msg, unicode)
-        self.assertEqual(rejection_msg_unicode, err.msg)
-
-
-class TestBranchSetLastRevisionInfo(tests.TestCase):
-
-    def test_set_last_revision_info(self):
-        # set_last_revision_info(num, 'rev-id') is translated to calling
-        # Branch.set_last_revision_info(num, 'rev-id') on the wire.
-        transport = MemoryTransport()
-        transport.mkdir('branch')
-        transport = transport.clone('branch')
-        client = FakeClient(transport.base)
-        # lock_write
-        client.add_success_response('ok', 'branch token', 'repo token')
-        # set_last_revision
-        client.add_success_response('ok')
-        # unlock
-        client.add_success_response('ok')
-
-        bzrdir = RemoteBzrDir(transport, _client=False)
-        branch = RemoteBranch(bzrdir, None, _client=client)
-        # This is a hack to work around the problem that RemoteBranch currently
-        # unnecessarily invokes _ensure_real upon a call to lock_write.
-        branch._ensure_real = lambda: None
-        # Lock the branch, reset the record of remote calls.
-        branch.lock_write()
-        client._calls = []
-        result = branch.set_last_revision_info(1234, 'a-revision-id')
-        self.assertEqual(
-            [('call', 'Branch.set_last_revision_info',
-                ('branch/', 'branch token', 'repo token',
-                 '1234', 'a-revision-id'))],
-            client._calls)
-        self.assertEqual(None, result)
-
-    def test_no_such_revision(self):
-        # A response of 'NoSuchRevision' is translated into an exception.
-        transport = MemoryTransport()
-        transport.mkdir('branch')
-        transport = transport.clone('branch')
-        client = FakeClient(transport.base)
-        # lock_write
-        client.add_success_response('ok', 'branch token', 'repo token')
-        # set_last_revision
-        client.add_error_response('NoSuchRevision', 'revid')
-        # unlock
-        client.add_success_response('ok')
-
-        bzrdir = RemoteBzrDir(transport, _client=False)
-        repo = RemoteRepository(bzrdir, None, _client=client)
-        branch = RemoteBranch(bzrdir, repo, _client=client)
-        # This is a hack to work around the problem that RemoteBranch currently
-        # unnecessarily invokes _ensure_real upon a call to lock_write.
-        branch._ensure_real = lambda: None
-        # Lock the branch, reset the record of remote calls.
-        branch.lock_write()
-        client._calls = []
-
-        self.assertRaises(
-            errors.NoSuchRevision, branch.set_last_revision_info, 123, 'revid')
-        branch.unlock()
-
-    def lock_remote_branch(self, branch):
-        """Trick a RemoteBranch into thinking it is locked."""
-        branch._lock_mode = 'w'
-        branch._lock_count = 2
-        branch._lock_token = 'branch token'
-        branch._repo_lock_token = 'repo token'
-
-    def test_backwards_compatibility(self):
-        """If the server does not support the Branch.set_last_revision_info
-        verb (which is new in 1.4), then the client falls back to VFS methods.
-        """
-        # This test is a little messy.  Unlike most tests in this file, it
-        # doesn't purely test what a Remote* object sends over the wire, and
-        # how it reacts to responses from the wire.  It instead relies partly
-        # on asserting that the RemoteBranch will call
-        # self._real_branch.set_last_revision_info(...).
-
-        # First, set up our RemoteBranch with a FakeClient that raises
-        # UnknownSmartMethod, and a StubRealBranch that logs how it is called.
-        transport = MemoryTransport()
-        transport.mkdir('branch')
-        transport = transport.clone('branch')
-        client = FakeClient(transport.base)
-        client.add_unknown_method_response('Branch.set_last_revision_info')
-        bzrdir = RemoteBzrDir(transport, _client=False)
-        branch = RemoteBranch(bzrdir, None, _client=client)
-        class StubRealBranch(object):
-            def __init__(self):
-                self.calls = []
-            def set_last_revision_info(self, revno, revision_id):
-                self.calls.append(
-                    ('set_last_revision_info', revno, revision_id))
-            def _clear_cached_state(self):
-                pass
-        real_branch = StubRealBranch()
-        branch._real_branch = real_branch
-        self.lock_remote_branch(branch)
-
-        # Call set_last_revision_info, and verify it behaved as expected.
-        result = branch.set_last_revision_info(1234, 'a-revision-id')
-        self.assertEqual(
-            [('call', 'Branch.set_last_revision_info',
-                ('branch/', 'branch token', 'repo token',
-                 '1234', 'a-revision-id')),],
-            client._calls)
-        self.assertEqual(
-            [('set_last_revision_info', 1234, 'a-revision-id')],
-            real_branch.calls)
-
-    def test_unexpected_error(self):
-        # A response of 'NoSuchRevision' is translated into an exception.
-        transport = MemoryTransport()
-        transport.mkdir('branch')
-        transport = transport.clone('branch')
-        client = FakeClient(transport.base)
-        # lock_write
-        client.add_success_response('ok', 'branch token', 'repo token')
-        # set_last_revision
-        client.add_error_response('UnexpectedError')
-        # unlock
-        client.add_success_response('ok')
-
-        bzrdir = RemoteBzrDir(transport, _client=False)
-        repo = RemoteRepository(bzrdir, None, _client=client)
-        branch = RemoteBranch(bzrdir, repo, _client=client)
-        # This is a hack to work around the problem that RemoteBranch currently
-        # unnecessarily invokes _ensure_real upon a call to lock_write.
-        branch._ensure_real = lambda: None
-        # Lock the branch, reset the record of remote calls.
-        branch.lock_write()
-        client._calls = []
-
-        err = self.assertRaises(
-            errors.ErrorFromSmartServer,
-            branch.set_last_revision_info, 123, 'revid')
-        self.assertEqual(('UnexpectedError',), err.error_tuple)
-        branch.unlock()
-
-    def test_tip_change_rejected(self):
-        """TipChangeRejected responses cause a TipChangeRejected exception to
-        be raised.
-        """
-        transport = MemoryTransport()
-        transport.mkdir('branch')
-        transport = transport.clone('branch')
-        client = FakeClient(transport.base)
-        # lock_write
-        client.add_success_response('ok', 'branch token', 'repo token')
-        # set_last_revision
-        client.add_error_response('TipChangeRejected', 'rejection message')
-        # unlock
-        client.add_success_response('ok')
-
-        bzrdir = RemoteBzrDir(transport, _client=False)
-        repo = RemoteRepository(bzrdir, None, _client=client)
-        branch = RemoteBranch(bzrdir, repo, _client=client)
-        # This is a hack to work around the problem that RemoteBranch currently
-        # unnecessarily invokes _ensure_real upon a call to lock_write.
-        branch._ensure_real = lambda: None
-        # Lock the branch, reset the record of remote calls.
-        branch.lock_write()
-        self.addCleanup(branch.unlock)
-        client._calls = []
-
-        # The 'TipChangeRejected' error response triggered by calling
-        # set_last_revision_info causes a TipChangeRejected exception.
-        err = self.assertRaises(
-            errors.TipChangeRejected,
-            branch.set_last_revision_info, 123, 'revid')
-        self.assertEqual('rejection message', err.msg)
-
 
 class TestBranchControlGetBranchConf(tests.TestCaseWithMemoryTransport):
-    """Getting the branch configuration should use an abstract method not vfs.
+    """Test branch.control_files api munging...
+
+    We special case RemoteBranch.control_files.get('branch.conf') to
+    call a specific API so that RemoteBranch's can intercept configuration
+    file reading, allowing them to signal to the client about things like
+    'email is configured for commits'.
     """
 
     def test_get_branch_conf(self):
-        raise tests.KnownFailure('branch.conf is not retrieved by get_config_file')
-        ## # We should see that branch.get_config() does a single rpc to get the
-        ## # remote configuration file, abstracting away where that is stored on
-        ## # the server.  However at the moment it always falls back to using the
-        ## # vfs, and this would need some changes in config.py.
-
-        ## # in an empty branch we decode the response properly
-        ## client = FakeClient([(('ok', ), '# config file body')], self.get_url())
-        ## # we need to make a real branch because the remote_branch.control_files
-        ## # will trigger _ensure_real.
-        ## branch = self.make_branch('quack')
-        ## transport = branch.bzrdir.root_transport
-        ## # we do not want bzrdir to make any remote calls
-        ## bzrdir = RemoteBzrDir(transport, _client=False)
-        ## branch = RemoteBranch(bzrdir, None, _client=client)
-        ## config = branch.get_config()
-        ## self.assertEqual(
-        ##     [('call_expecting_body', 'Branch.get_config_file', ('quack/',))],
-        ##     client._calls)
+        # in an empty branch we decode the response properly
+        client = FakeClient([(('ok', ), 'config file body')])
+        # we need to make a real branch because the remote_branch.control_files
+        # will trigger _ensure_real.
+        branch = self.make_branch('quack')
+        transport = branch.bzrdir.root_transport
+        # we do not want bzrdir to make any remote calls
+        bzrdir = RemoteBzrDir(transport, _client=False)
+        branch = RemoteBranch(bzrdir, None, _client=client)
+        result = branch.control_files.get('branch.conf')
+        self.assertEqual(
+            [('call_expecting_body', 'Branch.get_config_file', ('///quack/',))],
+            client._calls)
+        self.assertEqual('config file body', result.read())
 
 
 class TestBranchLockWrite(tests.TestCase):
 
     def test_lock_write_unlockable(self):
+        client = FakeClient([(('UnlockableTransport', ), '')])
         transport = MemoryTransport()
-        client = FakeClient(transport.base)
-        client.add_error_response('UnlockableTransport')
         transport.mkdir('quack')
         transport = transport.clone('quack')
         # we do not want bzrdir to make any remote calls
         bzrdir = RemoteBzrDir(transport, _client=False)
-        repo = RemoteRepository(bzrdir, None, _client=client)
-        branch = RemoteBranch(bzrdir, repo, _client=client)
+        branch = RemoteBranch(bzrdir, None, _client=client)
         self.assertRaises(errors.UnlockableTransport, branch.lock_write)
         self.assertEqual(
-            [('call', 'Branch.lock_write', ('quack/', '', ''))],
+            [('call', 'Branch.lock_write', ('///quack/', '', ''))],
             client._calls)
 
 
 class TestTransportIsReadonly(tests.TestCase):
 
     def test_true(self):
-        client = FakeClient()
-        client.add_success_response('yes')
+        client = FakeClient([(('yes',), '')])
         transport = RemoteTransport('bzr://example.com/', medium=False,
                                     _client=client)
         self.assertEqual(True, transport.is_readonly())
@@ -814,8 +411,7 @@
             client._calls)
 
     def test_false(self):
-        client = FakeClient()
-        client.add_success_response('no')
+        client = FakeClient([(('no',), '')])
         transport = RemoteTransport('bzr://example.com/', medium=False,
                                     _client=client)
         self.assertEqual(False, transport.is_readonly())
@@ -830,8 +426,23 @@
         advisory anyway (a transport could be read-write, but then the
         underlying filesystem could be readonly anyway).
         """
-        client = FakeClient()
-        client.add_unknown_method_response('Transport.is_readonly')
+        client = FakeClient([(
+            ('error', "Generic bzr smart protocol error: "
+                      "bad request 'Transport.is_readonly'"), '')])
+        transport = RemoteTransport('bzr://example.com/', medium=False,
+                                    _client=client)
+        self.assertEqual(False, transport.is_readonly())
+        self.assertEqual(
+            [('call', 'Transport.is_readonly', ())],
+            client._calls)
+
+    def test_error_from_old_0_11_server(self):
+        """Same as test_error_from_old_server, but with the slightly different
+        error message from bzr 0.11 servers.
+        """
+        client = FakeClient([(
+            ('error', "Generic bzr smart protocol error: "
+                      "bad request u'Transport.is_readonly'"), '')])
         transport = RemoteTransport('bzr://example.com/', medium=False,
                                     _client=client)
         self.assertEqual(False, transport.is_readonly())
@@ -848,7 +459,7 @@
     because they might break compatibility with different-versioned servers.
     """
 
-    def setup_fake_client_and_repository(self, transport_path):
+    def setup_fake_client_and_repository(self, responses, transport_path):
         """Create the fake client and repository for testing with.
         
         There's no real server here; we just have canned responses sent
@@ -857,9 +468,9 @@
         :param transport_path: Path below the root of the MemoryTransport
             where the repository will be created.
         """
+        client = FakeClient(responses)
         transport = MemoryTransport()
         transport.mkdir(transport_path)
-        client = FakeClient(transport.base)
         transport = transport.clone(transport_path)
         # we do not want bzrdir to make any remote calls
         bzrdir = RemoteBzrDir(transport, _client=False)
@@ -871,31 +482,32 @@
 
     def test_revid_none(self):
         # ('ok',), body with revisions and size
+        responses = [(('ok', ), 'revisions: 2\nsize: 18\n')]
         transport_path = 'quack'
-        repo, client = self.setup_fake_client_and_repository(transport_path)
-        client.add_success_response_with_body(
-            'revisions: 2\nsize: 18\n', 'ok')
+        repo, client = self.setup_fake_client_and_repository(
+            responses, transport_path)
         result = repo.gather_stats(None)
         self.assertEqual(
             [('call_expecting_body', 'Repository.gather_stats',
-             ('quack/','','no'))],
+             ('///quack/','','no'))],
             client._calls)
         self.assertEqual({'revisions': 2, 'size': 18}, result)
 
     def test_revid_no_committers(self):
         # ('ok',), body without committers
-        body = ('firstrev: 123456.300 3600\n'
-                'latestrev: 654231.400 0\n'
-                'revisions: 2\n'
-                'size: 18\n')
+        responses = [(('ok', ),
+                      'firstrev: 123456.300 3600\n'
+                      'latestrev: 654231.400 0\n'
+                      'revisions: 2\n'
+                      'size: 18\n')]
         transport_path = 'quick'
         revid = u'\xc8'.encode('utf8')
-        repo, client = self.setup_fake_client_and_repository(transport_path)
-        client.add_success_response_with_body(body, 'ok')
+        repo, client = self.setup_fake_client_and_repository(
+            responses, transport_path)
         result = repo.gather_stats(revid)
         self.assertEqual(
             [('call_expecting_body', 'Repository.gather_stats',
-              ('quick/', revid, 'no'))],
+              ('///quick/', revid, 'no'))],
             client._calls)
         self.assertEqual({'revisions': 2, 'size': 18,
                           'firstrev': (123456.300, 3600),
@@ -904,19 +516,20 @@
 
     def test_revid_with_committers(self):
         # ('ok',), body with committers
-        body = ('committers: 128\n'
-                'firstrev: 123456.300 3600\n'
-                'latestrev: 654231.400 0\n'
-                'revisions: 2\n'
-                'size: 18\n')
+        responses = [(('ok', ),
+                      'committers: 128\n'
+                      'firstrev: 123456.300 3600\n'
+                      'latestrev: 654231.400 0\n'
+                      'revisions: 2\n'
+                      'size: 18\n')]
         transport_path = 'buick'
         revid = u'\xc8'.encode('utf8')
-        repo, client = self.setup_fake_client_and_repository(transport_path)
-        client.add_success_response_with_body(body, 'ok')
+        repo, client = self.setup_fake_client_and_repository(
+            responses, transport_path)
         result = repo.gather_stats(revid, True)
         self.assertEqual(
             [('call_expecting_body', 'Repository.gather_stats',
-              ('buick/', revid, 'yes'))],
+              ('///buick/', revid, 'yes'))],
             client._calls)
         self.assertEqual({'revisions': 2, 'size': 18,
                           'committers': 128,
@@ -925,126 +538,16 @@
                          result)
 
 
-class TestRepositoryGetGraph(TestRemoteRepository):
-
-    def test_get_graph(self):
-        # get_graph returns a graph with the repository as the
-        # parents_provider.
-        transport_path = 'quack'
-        repo, client = self.setup_fake_client_and_repository(transport_path)
-        graph = repo.get_graph()
-        self.assertEqual(graph._parents_provider, repo)
-
-
-class TestRepositoryGetParentMap(TestRemoteRepository):
-
-    def test_get_parent_map_caching(self):
-        # get_parent_map returns from cache until unlock()
-        # setup a reponse with two revisions
-        r1 = u'\u0e33'.encode('utf8')
-        r2 = u'\u0dab'.encode('utf8')
-        lines = [' '.join([r2, r1]), r1]
-        encoded_body = bz2.compress('\n'.join(lines))
-
-        transport_path = 'quack'
-        repo, client = self.setup_fake_client_and_repository(transport_path)
-        client.add_success_response_with_body(encoded_body, 'ok')
-        client.add_success_response_with_body(encoded_body, 'ok')
-        repo.lock_read()
-        graph = repo.get_graph()
-        parents = graph.get_parent_map([r2])
-        self.assertEqual({r2: (r1,)}, parents)
-        # locking and unlocking deeper should not reset
-        repo.lock_read()
-        repo.unlock()
-        parents = graph.get_parent_map([r1])
-        self.assertEqual({r1: (NULL_REVISION,)}, parents)
-        self.assertEqual(
-            [('call_with_body_bytes_expecting_body',
-              'Repository.get_parent_map', ('quack/', r2), '\n\n0')],
-            client._calls)
-        repo.unlock()
-        # now we call again, and it should use the second response.
-        repo.lock_read()
-        graph = repo.get_graph()
-        parents = graph.get_parent_map([r1])
-        self.assertEqual({r1: (NULL_REVISION,)}, parents)
-        self.assertEqual(
-            [('call_with_body_bytes_expecting_body',
-              'Repository.get_parent_map', ('quack/', r2), '\n\n0'),
-             ('call_with_body_bytes_expecting_body',
-              'Repository.get_parent_map', ('quack/', r1), '\n\n0'),
-            ],
-            client._calls)
-        repo.unlock()
-
-    def test_get_parent_map_reconnects_if_unknown_method(self):
-        transport_path = 'quack'
-        repo, client = self.setup_fake_client_and_repository(transport_path)
-        client.add_unknown_method_response('Repository,get_parent_map')
-        client.add_success_response_with_body('', 'ok')
-        self.assertFalse(client._medium._is_remote_before((1, 2)))
-        rev_id = 'revision-id'
-        expected_deprecations = [
-            'bzrlib.remote.RemoteRepository.get_revision_graph was deprecated '
-            'in version 1.4.']
-        parents = self.callDeprecated(
-            expected_deprecations, repo.get_parent_map, [rev_id])
-        self.assertEqual(
-            [('call_with_body_bytes_expecting_body',
-              'Repository.get_parent_map', ('quack/', rev_id), '\n\n0'),
-             ('disconnect medium',),
-             ('call_expecting_body', 'Repository.get_revision_graph',
-              ('quack/', ''))],
-            client._calls)
-        # The medium is now marked as being connected to an older server
-        self.assertTrue(client._medium._is_remote_before((1, 2)))
-
-    def test_get_parent_map_fallback_parentless_node(self):
-        """get_parent_map falls back to get_revision_graph on old servers.  The
-        results from get_revision_graph are tweaked to match the get_parent_map
-        API.
-
-        Specifically, a {key: ()} result from get_revision_graph means "no
-        parents" for that key, which in get_parent_map results should be
-        represented as {key: ('null:',)}.
-
-        This is the test for https://bugs.launchpad.net/bzr/+bug/214894
-        """
-        rev_id = 'revision-id'
-        transport_path = 'quack'
-        repo, client = self.setup_fake_client_and_repository(transport_path)
-        client.add_success_response_with_body(rev_id, 'ok')
-        client._medium._remember_remote_is_before((1, 2))
-        expected_deprecations = [
-            'bzrlib.remote.RemoteRepository.get_revision_graph was deprecated '
-            'in version 1.4.']
-        parents = self.callDeprecated(
-            expected_deprecations, repo.get_parent_map, [rev_id])
-        self.assertEqual(
-            [('call_expecting_body', 'Repository.get_revision_graph',
-             ('quack/', ''))],
-            client._calls)
-        self.assertEqual({rev_id: ('null:',)}, parents)
-
-    def test_get_parent_map_unexpected_response(self):
-        repo, client = self.setup_fake_client_and_repository('path')
-        client.add_success_response('something unexpected!')
-        self.assertRaises(
-            errors.UnexpectedSmartServerResponse,
-            repo.get_parent_map, ['a-revision-id'])
-
-
 class TestRepositoryGetRevisionGraph(TestRemoteRepository):
     
     def test_null_revision(self):
         # a null revision has the predictable result {}, we should have no wire
         # traffic when calling it with this argument
+        responses = [(('notused', ), '')]
         transport_path = 'empty'
-        repo, client = self.setup_fake_client_and_repository(transport_path)
-        client.add_success_response('notused')
-        result = self.applyDeprecated(one_four, repo.get_revision_graph,
-            NULL_REVISION)
+        repo, client = self.setup_fake_client_and_repository(
+            responses, transport_path)
+        result = repo.get_revision_graph(NULL_REVISION)
         self.assertEqual([], client._calls)
         self.assertEqual({}, result)
 
@@ -1055,13 +558,14 @@
         lines = [' '.join([r2, r1]), r1]
         encoded_body = '\n'.join(lines)
 
+        responses = [(('ok', ), encoded_body)]
         transport_path = 'sinhala'
-        repo, client = self.setup_fake_client_and_repository(transport_path)
-        client.add_success_response_with_body(encoded_body, 'ok')
-        result = self.applyDeprecated(one_four, repo.get_revision_graph)
+        repo, client = self.setup_fake_client_and_repository(
+            responses, transport_path)
+        result = repo.get_revision_graph()
         self.assertEqual(
             [('call_expecting_body', 'Repository.get_revision_graph',
-             ('sinhala/', ''))],
+             ('///sinhala/', ''))],
             client._calls)
         self.assertEqual({r1: (), r2: (r1, )}, result)
 
@@ -1074,60 +578,55 @@
         lines = [' '.join([r2, r11, r12]), r11, r12]
         encoded_body = '\n'.join(lines)
 
+        responses = [(('ok', ), encoded_body)]
         transport_path = 'sinhala'
-        repo, client = self.setup_fake_client_and_repository(transport_path)
-        client.add_success_response_with_body(encoded_body, 'ok')
-        result = self.applyDeprecated(one_four, repo.get_revision_graph, r2)
+        repo, client = self.setup_fake_client_and_repository(
+            responses, transport_path)
+        result = repo.get_revision_graph(r2)
         self.assertEqual(
             [('call_expecting_body', 'Repository.get_revision_graph',
-             ('sinhala/', r2))],
+             ('///sinhala/', r2))],
             client._calls)
         self.assertEqual({r11: (), r12: (), r2: (r11, r12), }, result)
 
     def test_no_such_revision(self):
         revid = '123'
+        responses = [(('nosuchrevision', revid), '')]
         transport_path = 'sinhala'
-        repo, client = self.setup_fake_client_and_repository(transport_path)
-        client.add_error_response('nosuchrevision', revid)
+        repo, client = self.setup_fake_client_and_repository(
+            responses, transport_path)
         # also check that the right revision is reported in the error
         self.assertRaises(errors.NoSuchRevision,
-            self.applyDeprecated, one_four, repo.get_revision_graph, revid)
+            repo.get_revision_graph, revid)
         self.assertEqual(
             [('call_expecting_body', 'Repository.get_revision_graph',
-             ('sinhala/', revid))],
+             ('///sinhala/', revid))],
             client._calls)
 
-    def test_unexpected_error(self):
-        revid = '123'
-        transport_path = 'sinhala'
-        repo, client = self.setup_fake_client_and_repository(transport_path)
-        client.add_error_response('AnUnexpectedError')
-        e = self.assertRaises(errors.ErrorFromSmartServer,
-            self.applyDeprecated, one_four, repo.get_revision_graph, revid)
-        self.assertEqual(('AnUnexpectedError',), e.error_tuple)
-
         
 class TestRepositoryIsShared(TestRemoteRepository):
 
     def test_is_shared(self):
         # ('yes', ) for Repository.is_shared -> 'True'.
+        responses = [(('yes', ), )]
         transport_path = 'quack'
-        repo, client = self.setup_fake_client_and_repository(transport_path)
-        client.add_success_response('yes')
+        repo, client = self.setup_fake_client_and_repository(
+            responses, transport_path)
         result = repo.is_shared()
         self.assertEqual(
-            [('call', 'Repository.is_shared', ('quack/',))],
+            [('call', 'Repository.is_shared', ('///quack/',))],
             client._calls)
         self.assertEqual(True, result)
 
     def test_is_not_shared(self):
         # ('no', ) for Repository.is_shared -> 'False'.
+        responses = [(('no', ), )]
         transport_path = 'qwack'
-        repo, client = self.setup_fake_client_and_repository(transport_path)
-        client.add_success_response('no')
+        repo, client = self.setup_fake_client_and_repository(
+            responses, transport_path)
         result = repo.is_shared()
         self.assertEqual(
-            [('call', 'Repository.is_shared', ('qwack/',))],
+            [('call', 'Repository.is_shared', ('///qwack/',))],
             client._calls)
         self.assertEqual(False, result)
 
@@ -1135,54 +634,59 @@
 class TestRepositoryLockWrite(TestRemoteRepository):
 
     def test_lock_write(self):
+        responses = [(('ok', 'a token'), '')]
         transport_path = 'quack'
-        repo, client = self.setup_fake_client_and_repository(transport_path)
-        client.add_success_response('ok', 'a token')
+        repo, client = self.setup_fake_client_and_repository(
+            responses, transport_path)
         result = repo.lock_write()
         self.assertEqual(
-            [('call', 'Repository.lock_write', ('quack/', ''))],
+            [('call', 'Repository.lock_write', ('///quack/', ''))],
             client._calls)
         self.assertEqual('a token', result)
 
     def test_lock_write_already_locked(self):
+        responses = [(('LockContention', ), '')]
         transport_path = 'quack'
-        repo, client = self.setup_fake_client_and_repository(transport_path)
-        client.add_error_response('LockContention')
+        repo, client = self.setup_fake_client_and_repository(
+            responses, transport_path)
         self.assertRaises(errors.LockContention, repo.lock_write)
         self.assertEqual(
-            [('call', 'Repository.lock_write', ('quack/', ''))],
+            [('call', 'Repository.lock_write', ('///quack/', ''))],
             client._calls)
 
     def test_lock_write_unlockable(self):
+        responses = [(('UnlockableTransport', ), '')]
         transport_path = 'quack'
-        repo, client = self.setup_fake_client_and_repository(transport_path)
-        client.add_error_response('UnlockableTransport')
+        repo, client = self.setup_fake_client_and_repository(
+            responses, transport_path)
         self.assertRaises(errors.UnlockableTransport, repo.lock_write)
         self.assertEqual(
-            [('call', 'Repository.lock_write', ('quack/', ''))],
+            [('call', 'Repository.lock_write', ('///quack/', ''))],
             client._calls)
 
 
 class TestRepositoryUnlock(TestRemoteRepository):
 
     def test_unlock(self):
+        responses = [(('ok', 'a token'), ''),
+                     (('ok',), '')]
         transport_path = 'quack'
-        repo, client = self.setup_fake_client_and_repository(transport_path)
-        client.add_success_response('ok', 'a token')
-        client.add_success_response('ok')
+        repo, client = self.setup_fake_client_and_repository(
+            responses, transport_path)
         repo.lock_write()
         repo.unlock()
         self.assertEqual(
-            [('call', 'Repository.lock_write', ('quack/', '')),
-             ('call', 'Repository.unlock', ('quack/', 'a token'))],
+            [('call', 'Repository.lock_write', ('///quack/', '')),
+             ('call', 'Repository.unlock', ('///quack/', 'a token'))],
             client._calls)
 
     def test_unlock_wrong_token(self):
         # If somehow the token is wrong, unlock will raise TokenMismatch.
+        responses = [(('ok', 'a token'), ''),
+                     (('TokenMismatch',), '')]
         transport_path = 'quack'
-        repo, client = self.setup_fake_client_and_repository(transport_path)
-        client.add_success_response('ok', 'a token')
-        client.add_error_response('TokenMismatch')
+        repo, client = self.setup_fake_client_and_repository(
+            responses, transport_path)
         repo.lock_write()
         self.assertRaises(errors.TokenMismatch, repo.unlock)
 
@@ -1192,10 +696,12 @@
     def test_none(self):
         # repo.has_revision(None) should not cause any traffic.
         transport_path = 'quack'
-        repo, client = self.setup_fake_client_and_repository(transport_path)
+        responses = None
+        repo, client = self.setup_fake_client_and_repository(
+            responses, transport_path)
 
         # The null revision is always there, so has_revision(None) == True.
-        self.assertEqual(True, repo.has_revision(NULL_REVISION))
+        self.assertEqual(True, repo.has_revision(None))
 
         # The remote repo shouldn't be accessed.
         self.assertEqual([], client._calls)
@@ -1222,13 +728,15 @@
     def test_repository_tarball(self):
         # Test that Repository.tarball generates the right operations
         transport_path = 'repo'
+        expected_responses = [(('ok',), self.tarball_content),
+            ]
         expected_calls = [('call_expecting_body', 'Repository.tarball',
-                           ('repo/', 'bz2',),),
+                           ('///repo/', 'bz2',),),
             ]
-        repo, client = self.setup_fake_client_and_repository(transport_path)
-        client.add_success_response_with_body(self.tarball_content, 'ok')
+        remote_repo, client = self.setup_fake_client_and_repository(
+            expected_responses, transport_path)
         # Now actually ask for the tarball
-        tarball_file = repo._get_tarball('bz2')
+        tarball_file = remote_repo._get_tarball('bz2')
         try:
             self.assertEqual(expected_calls, client._calls)
             self.assertEqual(self.tarball_content, tarball_file.read())
@@ -1255,141 +763,60 @@
         src_repo.copy_content_into(dest_repo)
 
 
-class TestErrorTranslationBase(tests.TestCaseWithMemoryTransport):
-    """Base class for unit tests for bzrlib.remote._translate_error."""
-
-    def translateTuple(self, error_tuple, **context):
-        """Call _translate_error with an ErrorFromSmartServer built from the
-        given error_tuple.
-
-        :param error_tuple: A tuple of a smart server response, as would be
-            passed to an ErrorFromSmartServer.
-        :kwargs context: context items to call _translate_error with.
-
-        :returns: The error raised by _translate_error.
-        """
-        # Raise the ErrorFromSmartServer before passing it as an argument,
-        # because _translate_error may need to re-raise it with a bare 'raise'
-        # statement.
-        server_error = errors.ErrorFromSmartServer(error_tuple)
-        translated_error = self.translateErrorFromSmartServer(
-            server_error, **context)
-        return translated_error
-
-    def translateErrorFromSmartServer(self, error_object, **context):
-        """Like translateTuple, but takes an already constructed
-        ErrorFromSmartServer rather than a tuple.
-        """
-        try:
-            raise error_object
-        except errors.ErrorFromSmartServer, server_error:
-            translated_error = self.assertRaises(
-                errors.BzrError, remote._translate_error, server_error,
-                **context)
-        return translated_error
-
-    
-class TestErrorTranslationSuccess(TestErrorTranslationBase):
-    """Unit tests for bzrlib.remote._translate_error.
-    
-    Given an ErrorFromSmartServer (which has an error tuple from a smart
-    server) and some context, _translate_error raises more specific errors from
-    bzrlib.errors.
-
-    This test case covers the cases where _translate_error succeeds in
-    translating an ErrorFromSmartServer to something better.  See
-    TestErrorTranslationRobustness for other cases.
-    """
-
-    def test_NoSuchRevision(self):
-        branch = self.make_branch('')
-        revid = 'revid'
-        translated_error = self.translateTuple(
-            ('NoSuchRevision', revid), branch=branch)
-        expected_error = errors.NoSuchRevision(branch, revid)
-        self.assertEqual(expected_error, translated_error)
-
-    def test_nosuchrevision(self):
-        repository = self.make_repository('')
-        revid = 'revid'
-        translated_error = self.translateTuple(
-            ('nosuchrevision', revid), repository=repository)
-        expected_error = errors.NoSuchRevision(repository, revid)
-        self.assertEqual(expected_error, translated_error)
-
-    def test_nobranch(self):
-        bzrdir = self.make_bzrdir('')
-        translated_error = self.translateTuple(('nobranch',), bzrdir=bzrdir)
-        expected_error = errors.NotBranchError(path=bzrdir.root_transport.base)
-        self.assertEqual(expected_error, translated_error)
-
-    def test_LockContention(self):
-        translated_error = self.translateTuple(('LockContention',))
-        expected_error = errors.LockContention('(remote lock)')
-        self.assertEqual(expected_error, translated_error)
-
-    def test_UnlockableTransport(self):
-        bzrdir = self.make_bzrdir('')
-        translated_error = self.translateTuple(
-            ('UnlockableTransport',), bzrdir=bzrdir)
-        expected_error = errors.UnlockableTransport(bzrdir.root_transport)
-        self.assertEqual(expected_error, translated_error)
-
-    def test_LockFailed(self):
-        lock = 'str() of a server lock'
-        why = 'str() of why'
-        translated_error = self.translateTuple(('LockFailed', lock, why))
-        expected_error = errors.LockFailed(lock, why)
-        self.assertEqual(expected_error, translated_error)
-
-    def test_TokenMismatch(self):
-        token = 'a lock token'
-        translated_error = self.translateTuple(('TokenMismatch',), token=token)
-        expected_error = errors.TokenMismatch(token, '(remote token)')
-        self.assertEqual(expected_error, translated_error)
-
-    def test_Diverged(self):
-        branch = self.make_branch('a')
-        other_branch = self.make_branch('b')
-        translated_error = self.translateTuple(
-            ('Diverged',), branch=branch, other_branch=other_branch)
-        expected_error = errors.DivergedBranches(branch, other_branch)
-        self.assertEqual(expected_error, translated_error)
-
-
-class TestErrorTranslationRobustness(TestErrorTranslationBase):
-    """Unit tests for bzrlib.remote._translate_error's robustness.
-    
-    TestErrorTranslationSuccess is for cases where _translate_error can
-    translate successfully.  This class about how _translate_err behaves when
-    it fails to translate: it re-raises the original error.
-    """
-
-    def test_unrecognised_server_error(self):
-        """If the error code from the server is not recognised, the original
-        ErrorFromSmartServer is propagated unmodified.
-        """
-        error_tuple = ('An unknown error tuple',)
-        server_error = errors.ErrorFromSmartServer(error_tuple)
-        translated_error = self.translateErrorFromSmartServer(server_error)
-        self.assertEqual(server_error, translated_error)
-
-    def test_context_missing_a_key(self):
-        """In case of a bug in the client, or perhaps an unexpected response
-        from a server, _translate_error returns the original error tuple from
-        the server and mutters a warning.
-        """
-        # To translate a NoSuchRevision error _translate_error needs a 'branch'
-        # in the context dict.  So let's give it an empty context dict instead
-        # to exercise its error recovery.
-        empty_context = {}
-        error_tuple = ('NoSuchRevision', 'revid')
-        server_error = errors.ErrorFromSmartServer(error_tuple)
-        translated_error = self.translateErrorFromSmartServer(server_error)
-        self.assertEqual(server_error, translated_error)
-        # In addition to re-raising ErrorFromSmartServer, some debug info has
-        # been muttered to the log file for developer to look at.
-        self.assertContainsRe(
-            self._get_log(keep_log_file=True),
-            "Missing key 'branch' in context")
+class TestRepositoryStreamKnitData(TestRemoteRepository):
+
+    def make_pack_file(self, records):
+        pack_file = StringIO()
+        pack_writer = pack.ContainerWriter(pack_file.write)
+        pack_writer.begin()
+        for bytes, names in records:
+            pack_writer.add_bytes_record(bytes, names)
+        pack_writer.end()
+        pack_file.seek(0)
+        return pack_file
+
+    def test_bad_pack_from_server(self):
+        """A response with invalid data (e.g. it has a record with multiple
+        names) triggers an exception.
         
+        Not all possible errors will be caught at this stage, but obviously
+        malformed data should be.
+        """
+        record = ('bytes', [('name1',), ('name2',)])
+        pack_file = self.make_pack_file([record])
+        responses = [(('ok',), pack_file.getvalue()), ]
+        transport_path = 'quack'
+        repo, client = self.setup_fake_client_and_repository(
+            responses, transport_path)
+        stream = repo.get_data_stream(['revid'])
+        self.assertRaises(errors.SmartProtocolError, list, stream)
+    
+    def test_backwards_compatibility(self):
+        """If the server doesn't recognise this request, fallback to VFS."""
+        error_msg = (
+            "Generic bzr smart protocol error: "
+            "bad request 'Repository.stream_knit_data_for_revisions'")
+        responses = [
+            (('error', error_msg), '')]
+        repo, client = self.setup_fake_client_and_repository(
+            responses, 'path')
+        self.mock_called = False
+        repo._real_repository = MockRealRepository(self)
+        repo.get_data_stream(['revid'])
+        self.assertTrue(self.mock_called)
+        self.failIf(client.expecting_body,
+            "The protocol has been left in an unclean state that will cause "
+            "TooManyConcurrentRequests errors.")
+
+
+class MockRealRepository(object):
+    """Helper class for TestRepositoryStreamKnitData.test_unknown_method."""
+
+    def __init__(self, test):
+        self.test = test
+
+    def get_data_stream(self, revision_ids):
+        self.test.assertEqual(['revid'], revision_ids)
+        self.test.mock_called = True
+
+

=== modified file 'bzrlib/tests/test_repository.py'
--- bzrlib/tests/test_repository.py	2008-08-04 07:55:41 +0000
+++ bzrlib/tests/test_repository.py	2007-10-19 17:14:33 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007, 2008 Canonical Ltd
+# Copyright (C) 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -22,7 +22,6 @@
 also see this file.
 """
 
-import md5
 from stat import S_ISDIR
 from StringIO import StringIO
 
@@ -32,34 +31,27 @@
                            UnknownFormatError,
                            UnsupportedFormatError,
                            )
-from bzrlib import graph
-from bzrlib.index import GraphIndex, InMemoryGraphIndex
 from bzrlib.repository import RepositoryFormat
 from bzrlib.smart import server
 from bzrlib.tests import (
     TestCase,
     TestCaseWithTransport,
-    TestSkipped,
     test_knit,
     )
-from bzrlib.transport import (
-    fakenfs,
-    get_transport,
-    )
+from bzrlib.transport import get_transport
 from bzrlib.transport.memory import MemoryServer
 from bzrlib.util import bencode
 from bzrlib import (
     bzrdir,
     errors,
     inventory,
-    progress,
     repository,
     revision as _mod_revision,
     symbol_versioning,
     upgrade,
     workingtree,
     )
-from bzrlib.repofmt import knitrepo, weaverepo, pack_repo
+from bzrlib.repofmt import knitrepo, weaverepo
 
 
 class TestDefaultFormat(TestCase):
@@ -162,24 +154,6 @@
 
 class TestFormat6(TestCaseWithTransport):
 
-    def test_attribute__fetch_order(self):
-        """Weaves need topological data insertion."""
-        control = bzrdir.BzrDirFormat6().initialize(self.get_url())
-        repo = weaverepo.RepositoryFormat6().initialize(control)
-        self.assertEqual('topological', repo._fetch_order)
-
-    def test_attribute__fetch_uses_deltas(self):
-        """Weaves do not reuse deltas."""
-        control = bzrdir.BzrDirFormat6().initialize(self.get_url())
-        repo = weaverepo.RepositoryFormat6().initialize(control)
-        self.assertEqual(False, repo._fetch_uses_deltas)
-
-    def test_attribute__fetch_reconcile(self):
-        """Weave repositories need a reconcile after fetch."""
-        control = bzrdir.BzrDirFormat6().initialize(self.get_url())
-        repo = weaverepo.RepositoryFormat6().initialize(control)
-        self.assertEqual(True, repo._fetch_reconcile)
-
     def test_no_ancestry_weave(self):
         control = bzrdir.BzrDirFormat6().initialize(self.get_url())
         repo = weaverepo.RepositoryFormat6().initialize(control)
@@ -189,32 +163,18 @@
                           control.transport.get,
                           'ancestry.weave')
 
-    def test_supports_external_lookups(self):
+    def test_exposed_versioned_files_are_marked_dirty(self):
         control = bzrdir.BzrDirFormat6().initialize(self.get_url())
         repo = weaverepo.RepositoryFormat6().initialize(control)
-        self.assertFalse(repo._format.supports_external_lookups)
+        repo.lock_write()
+        inv = repo.get_inventory_weave()
+        repo.unlock()
+        self.assertRaises(errors.OutSideTransaction,
+            inv.add_lines, 'foo', [], [])
 
 
 class TestFormat7(TestCaseWithTransport):
-
-    def test_attribute__fetch_order(self):
-        """Weaves need topological data insertion."""
-        control = bzrdir.BzrDirMetaFormat1().initialize(self.get_url())
-        repo = weaverepo.RepositoryFormat7().initialize(control)
-        self.assertEqual('topological', repo._fetch_order)
-
-    def test_attribute__fetch_uses_deltas(self):
-        """Weaves do not reuse deltas."""
-        control = bzrdir.BzrDirMetaFormat1().initialize(self.get_url())
-        repo = weaverepo.RepositoryFormat7().initialize(control)
-        self.assertEqual(False, repo._fetch_uses_deltas)
-
-    def test_attribute__fetch_reconcile(self):
-        """Weave repositories need a reconcile after fetch."""
-        control = bzrdir.BzrDirMetaFormat1().initialize(self.get_url())
-        repo = weaverepo.RepositoryFormat7().initialize(control)
-        self.assertEqual(True, repo._fetch_reconcile)
-
+    
     def test_disk_layout(self):
         control = bzrdir.BzrDirMetaFormat1().initialize(self.get_url())
         repo = weaverepo.RepositoryFormat7().initialize(control)
@@ -236,25 +196,6 @@
                              'w\n'
                              'W\n',
                              t.get('inventory.weave').read())
-        # Creating a file with id Foo:Bar results in a non-escaped file name on
-        # disk.
-        control.create_branch()
-        tree = control.create_workingtree()
-        tree.add(['foo'], ['Foo:Bar'], ['file'])
-        tree.put_file_bytes_non_atomic('Foo:Bar', 'content\n')
-        tree.commit('first post', rev_id='first')
-        self.assertEqualDiff(
-            '# bzr weave file v5\n'
-            'i\n'
-            '1 7fe70820e08a1aac0ef224d9c66ab66831cc4ab1\n'
-            'n first\n'
-            '\n'
-            'w\n'
-            '{ 0\n'
-            '. content\n'
-            '}\n'
-            'W\n',
-            t.get('weaves/74/Foo%3ABar.weave').read())
 
     def test_shared_disk_layout(self):
         control = bzrdir.BzrDirMetaFormat1().initialize(self.get_url())
@@ -335,26 +276,18 @@
                              'W\n',
                              t.get('inventory.weave').read())
 
-    def test_supports_external_lookups(self):
+    def test_exposed_versioned_files_are_marked_dirty(self):
         control = bzrdir.BzrDirMetaFormat1().initialize(self.get_url())
         repo = weaverepo.RepositoryFormat7().initialize(control)
-        self.assertFalse(repo._format.supports_external_lookups)
+        repo.lock_write()
+        inv = repo.get_inventory_weave()
+        repo.unlock()
+        self.assertRaises(errors.OutSideTransaction,
+            inv.add_lines, 'foo', [], [])
 
 
 class TestFormatKnit1(TestCaseWithTransport):
     
-    def test_attribute__fetch_order(self):
-        """Knits need topological data insertion."""
-        repo = self.make_repository('.',
-                format=bzrdir.format_registry.get('knit')())
-        self.assertEqual('topological', repo._fetch_order)
-
-    def test_attribute__fetch_uses_deltas(self):
-        """Knits reuse deltas."""
-        repo = self.make_repository('.',
-                format=bzrdir.format_registry.get('knit')())
-        self.assertEqual(True, repo._fetch_uses_deltas)
-
     def test_disk_layout(self):
         control = bzrdir.BzrDirMetaFormat1().initialize(self.get_url())
         repo = knitrepo.RepositoryFormatKnit1().initialize(control)
@@ -374,19 +307,13 @@
         # self.assertEqualDiff('', t.get('lock').read())
         self.assertTrue(S_ISDIR(t.stat('knits').st_mode))
         self.check_knits(t)
-        # Check per-file knits.
-        branch = control.create_branch()
-        tree = control.create_workingtree()
-        tree.add(['foo'], ['Nasty-IdC:'], ['file'])
-        tree.put_file_bytes_non_atomic('Nasty-IdC:', '')
-        tree.commit('1st post', rev_id='foo')
-        self.assertHasKnit(t, 'knits/e8/%254easty-%2549d%2543%253a',
-            '\nfoo fulltext 0 81  :')
 
-    def assertHasKnit(self, t, knit_name, extra_content=''):
+    def assertHasKnit(self, t, knit_name):
         """Assert that knit_name exists on t."""
-        self.assertEqualDiff('# bzr knit index 8\n' + extra_content,
+        self.assertEqualDiff('# bzr knit index 8\n',
                              t.get(knit_name + '.kndx').read())
+        # no default content
+        self.assertTrue(t.has(knit_name + '.knit'))
 
     def check_knits(self, t):
         """check knit content for a repository."""
@@ -436,6 +363,16 @@
         self.assertTrue(S_ISDIR(t.stat('knits').st_mode))
         self.check_knits(t)
 
+    def test_exposed_versioned_files_are_marked_dirty(self):
+        format = bzrdir.BzrDirMetaFormat1()
+        format.repository_format = knitrepo.RepositoryFormatKnit1()
+        repo = self.make_repository('.', format=format)
+        repo.lock_write()
+        inv = repo.get_inventory_weave()
+        repo.unlock()
+        self.assertRaises(errors.OutSideTransaction,
+            inv.add_lines, 'foo', [], [])
+
     def test_deserialise_sets_root_revision(self):
         """We must have a inventory.root.revision
 
@@ -458,15 +395,68 @@
         # Arguably, the deserialise_inventory should detect a mismatch, and
         # raise an error, rather than silently using one revision_id over the
         # other.
-        self.assertRaises(AssertionError, repo.deserialise_inventory,
-            'test-rev-id', inv_xml)
-        inv = repo.deserialise_inventory('other-rev-id', inv_xml)
+        inv = repo.deserialise_inventory('test-rev-id', inv_xml)
         self.assertEqual('other-rev-id', inv.root.revision)
 
-    def test_supports_external_lookups(self):
-        repo = self.make_repository('.',
-                format=bzrdir.format_registry.get('knit')())
-        self.assertFalse(repo._format.supports_external_lookups)
+
+class KnitRepositoryStreamTests(test_knit.KnitTests):
+    """Tests for knitrepo._get_stream_as_bytes."""
+
+    def test_get_stream_as_bytes(self):
+        # Make a simple knit
+        k1 = self.make_test_knit()
+        k1.add_lines('text-a', [], test_knit.split_lines(test_knit.TEXT_1))
+        
+        # Serialise it, check the output.
+        bytes = knitrepo._get_stream_as_bytes(k1, ['text-a'])
+        data = bencode.bdecode(bytes)
+        format, record = data
+        self.assertEqual('knit-plain', format)
+        self.assertEqual(['text-a', ['fulltext'], []], record[:3])
+        self.assertRecordContentEqual(k1, 'text-a', record[3])
+
+    def test_get_stream_as_bytes_all(self):
+        """Get a serialised data stream for all the records in a knit.
+
+        Much like test_get_stream_all, except for get_stream_as_bytes.
+        """
+        k1 = self.make_test_knit()
+        # Insert the same data as BasicKnitTests.test_knit_join, as they seem
+        # to cover a range of cases (no parents, one parent, multiple parents).
+        test_data = [
+            ('text-a', [], test_knit.TEXT_1),
+            ('text-b', ['text-a'], test_knit.TEXT_1),
+            ('text-c', [], test_knit.TEXT_1),
+            ('text-d', ['text-c'], test_knit.TEXT_1),
+            ('text-m', ['text-b', 'text-d'], test_knit.TEXT_1),
+           ]
+        expected_data_list = [
+            # version, options, parents
+            ('text-a', ['fulltext'], []),
+            ('text-b', ['line-delta'], ['text-a']),
+            ('text-c', ['fulltext'], []),
+            ('text-d', ['line-delta'], ['text-c']),
+            ('text-m', ['line-delta'], ['text-b', 'text-d']),
+            ]
+        for version_id, parents, lines in test_data:
+            k1.add_lines(version_id, parents, test_knit.split_lines(lines))
+
+        bytes = knitrepo._get_stream_as_bytes(
+            k1, ['text-a', 'text-b', 'text-c', 'text-d', 'text-m'])
+
+        data = bencode.bdecode(bytes)
+        format = data.pop(0)
+        self.assertEqual('knit-plain', format)
+
+        for expected, actual in zip(expected_data_list, data):
+            expected_version = expected[0]
+            expected_options = expected[1]
+            expected_parents = expected[2]
+            version, options, parents, bytes = actual
+            self.assertEqual(expected_version, version)
+            self.assertEqual(expected_options, options)
+            self.assertEqual(expected_parents, parents)
+            self.assertRecordContentEqual(k1, version, bytes)
 
 
 class DummyRepository(object):
@@ -579,6 +569,49 @@
                                                         repo_b).__class__)
 
 
+class TestInterRemoteToOther(TestCaseWithTransport):
+
+    def make_remote_repository(self, path, backing_format=None):
+        """Make a RemoteRepository object backed by a real repository that will
+        be created at the given path."""
+        self.make_repository(path, format=backing_format)
+        smart_server = server.SmartTCPServer_for_testing()
+        smart_server.setUp()
+        remote_transport = get_transport(smart_server.get_url()).clone(path)
+        self.addCleanup(smart_server.tearDown)
+        remote_bzrdir = bzrdir.BzrDir.open_from_transport(remote_transport)
+        remote_repo = remote_bzrdir.open_repository()
+        return remote_repo
+
+    def test_is_compatible_same_format(self):
+        """InterRemoteToOther is compatible with a remote repository and a
+        second repository that have the same format."""
+        local_repo = self.make_repository('local')
+        remote_repo = self.make_remote_repository('remote')
+        is_compatible = repository.InterRemoteToOther.is_compatible
+        self.assertTrue(
+            is_compatible(remote_repo, local_repo),
+            "InterRemoteToOther(%r, %r) is false" % (remote_repo, local_repo))
+          
+    def test_is_incompatible_different_format(self):
+        local_repo = self.make_repository('local', 'dirstate')
+        remote_repo = self.make_remote_repository('a', 'dirstate-with-subtree')
+        is_compatible = repository.InterRemoteToOther.is_compatible
+        self.assertFalse(
+            is_compatible(remote_repo, local_repo),
+            "InterRemoteToOther(%r, %r) is true" % (local_repo, remote_repo))
+
+    def test_is_incompatible_different_format_both_remote(self):
+        remote_repo_a = self.make_remote_repository(
+            'a', 'dirstate-with-subtree')
+        remote_repo_b = self.make_remote_repository('b', 'dirstate')
+        is_compatible = repository.InterRemoteToOther.is_compatible
+        self.assertFalse(
+            is_compatible(remote_repo_a, remote_repo_b),
+            "InterRemoteToOther(%r, %r) is true"
+            % (remote_repo_a, remote_repo_b))
+
+
 class TestRepositoryConverter(TestCaseWithTransport):
 
     def test_convert_empty(self):
@@ -606,20 +639,6 @@
 
 class TestRepositoryFormatKnit3(TestCaseWithTransport):
 
-    def test_attribute__fetch_order(self):
-        """Knits need topological data insertion."""
-        format = bzrdir.BzrDirMetaFormat1()
-        format.repository_format = knitrepo.RepositoryFormatKnit3()
-        repo = self.make_repository('.', format=format)
-        self.assertEqual('topological', repo._fetch_order)
-
-    def test_attribute__fetch_uses_deltas(self):
-        """Knits reuse deltas."""
-        format = bzrdir.BzrDirMetaFormat1()
-        format.repository_format = knitrepo.RepositoryFormatKnit3()
-        repo = self.make_repository('.', format=format)
-        self.assertEqual(True, repo._fetch_uses_deltas)
-
     def test_convert(self):
         """Ensure the upgrade adds weaves for roots"""
         format = bzrdir.BzrDirMetaFormat1()
@@ -627,37 +646,30 @@
         tree = self.make_branch_and_tree('.', format)
         tree.commit("Dull commit", rev_id="dull")
         revision_tree = tree.branch.repository.revision_tree('dull')
-        revision_tree.lock_read()
-        try:
-            self.assertRaises(errors.NoSuchFile, revision_tree.get_file_lines,
-                revision_tree.inventory.root.file_id)
-        finally:
-            revision_tree.unlock()
+        self.assertRaises(errors.NoSuchFile, revision_tree.get_file_lines,
+            revision_tree.inventory.root.file_id)
         format = bzrdir.BzrDirMetaFormat1()
         format.repository_format = knitrepo.RepositoryFormatKnit3()
         upgrade.Convert('.', format)
         tree = workingtree.WorkingTree.open('.')
         revision_tree = tree.branch.repository.revision_tree('dull')
-        revision_tree.lock_read()
-        try:
-            revision_tree.get_file_lines(revision_tree.inventory.root.file_id)
-        finally:
-            revision_tree.unlock()
+        revision_tree.get_file_lines(revision_tree.inventory.root.file_id)
         tree.commit("Another dull commit", rev_id='dull2')
         revision_tree = tree.branch.repository.revision_tree('dull2')
-        revision_tree.lock_read()
-        self.addCleanup(revision_tree.unlock)
         self.assertEqual('dull', revision_tree.inventory.root.revision)
 
-    def test_supports_external_lookups(self):
+    def test_exposed_versioned_files_are_marked_dirty(self):
         format = bzrdir.BzrDirMetaFormat1()
         format.repository_format = knitrepo.RepositoryFormatKnit3()
         repo = self.make_repository('.', format=format)
-        self.assertFalse(repo._format.supports_external_lookups)
+        repo.lock_write()
+        inv = repo.get_inventory_weave()
+        repo.unlock()
+        self.assertRaises(errors.OutSideTransaction,
+            inv.add_lines, 'foo', [], [])
 
 
 class TestWithBrokenRepo(TestCaseWithTransport):
-    """These tests seem to be more appropriate as interface tests?"""
 
     def make_broken_repository(self):
         # XXX: This function is borrowed from Aaron's "Reconcile can fix bad
@@ -726,9 +738,9 @@
         entry.revision = revision
         entry.text_size = 0
         inv.add(entry)
-        text_key = (file_id, revision)
-        parent_keys = [(file_id, parent) for parent in parents]
-        repo.texts.add_lines(text_key, parent_keys, ['line\n'])
+        vf = repo.weave_store.get_weave_or_empty(file_id,
+                                                 repo.get_transaction())
+        vf.add_lines(revision, parents, ['line\n'])
 
     def test_insert_from_broken_repo(self):
         """Inserting a data stream from a broken repository won't silently
@@ -736,277 +748,7 @@
         """
         broken_repo = self.make_broken_repository()
         empty_repo = self.make_repository('empty-repo')
-        self.assertRaises(errors.RevisionNotPresent, empty_repo.fetch, broken_repo)
-
-
-class TestRepositoryPackCollection(TestCaseWithTransport):
-
-    def get_format(self):
-        return bzrdir.format_registry.make_bzrdir('pack-0.92')
-
-    def test__max_pack_count(self):
-        """The maximum pack count is a function of the number of revisions."""
-        format = self.get_format()
-        repo = self.make_repository('.', format=format)
-        packs = repo._pack_collection
-        # no revisions - one pack, so that we can have a revision free repo
-        # without it blowing up
-        self.assertEqual(1, packs._max_pack_count(0))
-        # after that the sum of the digits, - check the first 1-9
-        self.assertEqual(1, packs._max_pack_count(1))
-        self.assertEqual(2, packs._max_pack_count(2))
-        self.assertEqual(3, packs._max_pack_count(3))
-        self.assertEqual(4, packs._max_pack_count(4))
-        self.assertEqual(5, packs._max_pack_count(5))
-        self.assertEqual(6, packs._max_pack_count(6))
-        self.assertEqual(7, packs._max_pack_count(7))
-        self.assertEqual(8, packs._max_pack_count(8))
-        self.assertEqual(9, packs._max_pack_count(9))
-        # check the boundary cases with two digits for the next decade
-        self.assertEqual(1, packs._max_pack_count(10))
-        self.assertEqual(2, packs._max_pack_count(11))
-        self.assertEqual(10, packs._max_pack_count(19))
-        self.assertEqual(2, packs._max_pack_count(20))
-        self.assertEqual(3, packs._max_pack_count(21))
-        # check some arbitrary big numbers
-        self.assertEqual(25, packs._max_pack_count(112894))
-
-    def test_pack_distribution_zero(self):
-        format = self.get_format()
-        repo = self.make_repository('.', format=format)
-        packs = repo._pack_collection
-        self.assertEqual([0], packs.pack_distribution(0))
-
-    def test_ensure_loaded_unlocked(self):
-        format = self.get_format()
-        repo = self.make_repository('.', format=format)
-        self.assertRaises(errors.ObjectNotLocked,
-                          repo._pack_collection.ensure_loaded)
-
-    def test_pack_distribution_one_to_nine(self):
-        format = self.get_format()
-        repo = self.make_repository('.', format=format)
-        packs = repo._pack_collection
-        self.assertEqual([1],
-            packs.pack_distribution(1))
-        self.assertEqual([1, 1],
-            packs.pack_distribution(2))
-        self.assertEqual([1, 1, 1],
-            packs.pack_distribution(3))
-        self.assertEqual([1, 1, 1, 1],
-            packs.pack_distribution(4))
-        self.assertEqual([1, 1, 1, 1, 1],
-            packs.pack_distribution(5))
-        self.assertEqual([1, 1, 1, 1, 1, 1],
-            packs.pack_distribution(6))
-        self.assertEqual([1, 1, 1, 1, 1, 1, 1],
-            packs.pack_distribution(7))
-        self.assertEqual([1, 1, 1, 1, 1, 1, 1, 1],
-            packs.pack_distribution(8))
-        self.assertEqual([1, 1, 1, 1, 1, 1, 1, 1, 1],
-            packs.pack_distribution(9))
-
-    def test_pack_distribution_stable_at_boundaries(self):
-        """When there are multi-rev packs the counts are stable."""
-        format = self.get_format()
-        repo = self.make_repository('.', format=format)
-        packs = repo._pack_collection
-        # in 10s:
-        self.assertEqual([10], packs.pack_distribution(10))
-        self.assertEqual([10, 1], packs.pack_distribution(11))
-        self.assertEqual([10, 10], packs.pack_distribution(20))
-        self.assertEqual([10, 10, 1], packs.pack_distribution(21))
-        # 100s
-        self.assertEqual([100], packs.pack_distribution(100))
-        self.assertEqual([100, 1], packs.pack_distribution(101))
-        self.assertEqual([100, 10, 1], packs.pack_distribution(111))
-        self.assertEqual([100, 100], packs.pack_distribution(200))
-        self.assertEqual([100, 100, 1], packs.pack_distribution(201))
-        self.assertEqual([100, 100, 10, 1], packs.pack_distribution(211))
-
-    def test_plan_pack_operations_2009_revisions_skip_all_packs(self):
-        format = self.get_format()
-        repo = self.make_repository('.', format=format)
-        packs = repo._pack_collection
-        existing_packs = [(2000, "big"), (9, "medium")]
-        # rev count - 2009 -> 2x1000 + 9x1
-        pack_operations = packs.plan_autopack_combinations(
-            existing_packs, [1000, 1000, 1, 1, 1, 1, 1, 1, 1, 1, 1])
-        self.assertEqual([], pack_operations)
-
-    def test_plan_pack_operations_2010_revisions_skip_all_packs(self):
-        format = self.get_format()
-        repo = self.make_repository('.', format=format)
-        packs = repo._pack_collection
-        existing_packs = [(2000, "big"), (9, "medium"), (1, "single")]
-        # rev count - 2010 -> 2x1000 + 1x10
-        pack_operations = packs.plan_autopack_combinations(
-            existing_packs, [1000, 1000, 10])
-        self.assertEqual([], pack_operations)
-
-    def test_plan_pack_operations_2010_combines_smallest_two(self):
-        format = self.get_format()
-        repo = self.make_repository('.', format=format)
-        packs = repo._pack_collection
-        existing_packs = [(1999, "big"), (9, "medium"), (1, "single2"),
-            (1, "single1")]
-        # rev count - 2010 -> 2x1000 + 1x10 (3)
-        pack_operations = packs.plan_autopack_combinations(
-            existing_packs, [1000, 1000, 10])
-        self.assertEqual([[2, ["single2", "single1"]], [0, []]], pack_operations)
-
-    def test_all_packs_none(self):
-        format = self.get_format()
-        tree = self.make_branch_and_tree('.', format=format)
-        tree.lock_read()
-        self.addCleanup(tree.unlock)
-        packs = tree.branch.repository._pack_collection
-        packs.ensure_loaded()
-        self.assertEqual([], packs.all_packs())
-
-    def test_all_packs_one(self):
-        format = self.get_format()
-        tree = self.make_branch_and_tree('.', format=format)
-        tree.commit('start')
-        tree.lock_read()
-        self.addCleanup(tree.unlock)
-        packs = tree.branch.repository._pack_collection
-        packs.ensure_loaded()
-        self.assertEqual([
-            packs.get_pack_by_name(packs.names()[0])],
-            packs.all_packs())
-
-    def test_all_packs_two(self):
-        format = self.get_format()
-        tree = self.make_branch_and_tree('.', format=format)
-        tree.commit('start')
-        tree.commit('continue')
-        tree.lock_read()
-        self.addCleanup(tree.unlock)
-        packs = tree.branch.repository._pack_collection
-        packs.ensure_loaded()
-        self.assertEqual([
-            packs.get_pack_by_name(packs.names()[0]),
-            packs.get_pack_by_name(packs.names()[1]),
-            ], packs.all_packs())
-
-    def test_get_pack_by_name(self):
-        format = self.get_format()
-        tree = self.make_branch_and_tree('.', format=format)
-        tree.commit('start')
-        tree.lock_read()
-        self.addCleanup(tree.unlock)
-        packs = tree.branch.repository._pack_collection
-        packs.ensure_loaded()
-        name = packs.names()[0]
-        pack_1 = packs.get_pack_by_name(name)
-        # the pack should be correctly initialised
-        sizes = packs._names[name]
-        rev_index = GraphIndex(packs._index_transport, name + '.rix', sizes[0])
-        inv_index = GraphIndex(packs._index_transport, name + '.iix', sizes[1])
-        txt_index = GraphIndex(packs._index_transport, name + '.tix', sizes[2])
-        sig_index = GraphIndex(packs._index_transport, name + '.six', sizes[3])
-        self.assertEqual(pack_repo.ExistingPack(packs._pack_transport,
-            name, rev_index, inv_index, txt_index, sig_index), pack_1)
-        # and the same instance should be returned on successive calls.
-        self.assertTrue(pack_1 is packs.get_pack_by_name(name))
-
-
-class TestPack(TestCaseWithTransport):
-    """Tests for the Pack object."""
-
-    def assertCurrentlyEqual(self, left, right):
-        self.assertTrue(left == right)
-        self.assertTrue(right == left)
-        self.assertFalse(left != right)
-        self.assertFalse(right != left)
-
-    def assertCurrentlyNotEqual(self, left, right):
-        self.assertFalse(left == right)
-        self.assertFalse(right == left)
-        self.assertTrue(left != right)
-        self.assertTrue(right != left)
-
-    def test___eq____ne__(self):
-        left = pack_repo.ExistingPack('', '', '', '', '', '')
-        right = pack_repo.ExistingPack('', '', '', '', '', '')
-        self.assertCurrentlyEqual(left, right)
-        # change all attributes and ensure equality changes as we do.
-        left.revision_index = 'a'
-        self.assertCurrentlyNotEqual(left, right)
-        right.revision_index = 'a'
-        self.assertCurrentlyEqual(left, right)
-        left.inventory_index = 'a'
-        self.assertCurrentlyNotEqual(left, right)
-        right.inventory_index = 'a'
-        self.assertCurrentlyEqual(left, right)
-        left.text_index = 'a'
-        self.assertCurrentlyNotEqual(left, right)
-        right.text_index = 'a'
-        self.assertCurrentlyEqual(left, right)
-        left.signature_index = 'a'
-        self.assertCurrentlyNotEqual(left, right)
-        right.signature_index = 'a'
-        self.assertCurrentlyEqual(left, right)
-        left.name = 'a'
-        self.assertCurrentlyNotEqual(left, right)
-        right.name = 'a'
-        self.assertCurrentlyEqual(left, right)
-        left.transport = 'a'
-        self.assertCurrentlyNotEqual(left, right)
-        right.transport = 'a'
-        self.assertCurrentlyEqual(left, right)
-
-    def test_file_name(self):
-        pack = pack_repo.ExistingPack('', 'a_name', '', '', '', '')
-        self.assertEqual('a_name.pack', pack.file_name())
-
-
-class TestNewPack(TestCaseWithTransport):
-    """Tests for pack_repo.NewPack."""
-
-    def test_new_instance_attributes(self):
-        upload_transport = self.get_transport('upload')
-        pack_transport = self.get_transport('pack')
-        index_transport = self.get_transport('index')
-        upload_transport.mkdir('.')
-        pack = pack_repo.NewPack(upload_transport, index_transport,
-            pack_transport)
-        self.assertIsInstance(pack.revision_index, InMemoryGraphIndex)
-        self.assertIsInstance(pack.inventory_index, InMemoryGraphIndex)
-        self.assertIsInstance(pack._hash, type(md5.new()))
-        self.assertTrue(pack.upload_transport is upload_transport)
-        self.assertTrue(pack.index_transport is index_transport)
-        self.assertTrue(pack.pack_transport is pack_transport)
-        self.assertEqual(None, pack.index_sizes)
-        self.assertEqual(20, len(pack.random_name))
-        self.assertIsInstance(pack.random_name, str)
-        self.assertIsInstance(pack.start_time, float)
-
-
-class TestPacker(TestCaseWithTransport):
-    """Tests for the packs repository Packer class."""
-
-    # To date, this class has been factored out and nothing new added to it;
-    # thus there are not yet any tests.
-
-
-class TestInterDifferingSerializer(TestCaseWithTransport):
-
-    def test_progress_bar(self):
-        tree = self.make_branch_and_tree('tree')
-        tree.commit('rev1', rev_id='rev-1')
-        tree.commit('rev2', rev_id='rev-2')
-        tree.commit('rev3', rev_id='rev-3')
-        repo = self.make_repository('repo')
-        inter_repo = repository.InterDifferingSerializer(
-            tree.branch.repository, repo)
-        pb = progress.InstrumentedProgress(to_file=StringIO())
-        pb.never_throttle = True
-        inter_repo.fetch('rev-1', pb)
-        self.assertEqual('Transferring revisions', pb.last_msg)
-        self.assertEqual(1, pb.last_cnt)
-        self.assertEqual(1, pb.last_total)
-        inter_repo.fetch('rev-3', pb)
-        self.assertEqual(2, pb.last_cnt)
-        self.assertEqual(2, pb.last_total)
+        stream = broken_repo.get_data_stream(['rev1a', 'rev2', 'rev3'])
+        self.assertRaises(
+            errors.KnitCorrupt, empty_repo.insert_data_stream, stream)
+

=== modified file 'bzrlib/tests/test_revert.py'
--- bzrlib/tests/test_revert.py	2007-12-29 21:43:44 +0000
+++ bzrlib/tests/test_revert.py	2007-08-29 20:41:28 +0000
@@ -30,8 +30,6 @@
         self.build_tree(['source/dir/', 'source/dir/contents'])
         source_tree.add(['dir', 'dir/contents'], ['dir-id', 'contents-id'])
         source_tree.commit('added dir')
-        target_tree.lock_write()
-        self.addCleanup(target_tree.unlock)
         merge.merge_inner(target_tree.branch, source_tree.basis_tree(), 
                           target_tree.basis_tree(), this_tree=target_tree)
         self.failUnlessExists('target/dir')
@@ -86,12 +84,8 @@
         tt = transform.TreeTransform(tree)
         tt.new_file('newfile', tt.root, 'helooo!', 'newfile-id', True)
         tt.apply()
-        tree.lock_write()
-        try:
-            self.assertTrue(tree.is_executable('newfile-id'))
-            tree.commit('added newfile')
-        finally:
-            tree.unlock()
+        self.assertTrue(tree.is_executable('newfile-id'))
+        tree.commit('added newfile')
         return tree
 
     def test_preserve_execute(self):
@@ -102,8 +96,6 @@
         tt.create_file('Woooorld!', newfile)
         tt.apply()
         tree = workingtree.WorkingTree.open('tree')
-        tree.lock_write()
-        self.addCleanup(tree.unlock)
         self.assertTrue(tree.is_executable('newfile-id'))
         transform.revert(tree, tree.basis_tree(), None, backups=True)
         self.assertEqual('helooo!', tree.get_file('newfile-id').read())
@@ -115,8 +107,6 @@
         newfile = tt.trans_id_tree_file_id('newfile-id')
         tt.set_executability(False, newfile)
         tt.apply()
-        tree.lock_write()
-        self.addCleanup(tree.unlock)
         transform.revert(tree, tree.basis_tree(), None)
         self.assertTrue(tree.is_executable('newfile-id'))
 
@@ -142,18 +132,3 @@
             ' as of bzr 0.91.  Please use None (the default) instead.'],
             tree.revert, [])
         self.assertIs(None, tree.path2id('file'))
-
-    def test_revert_file_in_deleted_dir(self):
-        tree = self.make_branch_and_tree('.')
-        self.build_tree(['dir/', 'dir/file1', 'dir/file2'])
-        tree.add(['dir', 'dir/file1', 'dir/file2'],
-                 ['dir-id', 'file1-id', 'file2-id'])
-        tree.commit("Added files")
-        os.unlink('dir/file1')
-        os.unlink('dir/file2')
-        os.rmdir('dir')
-        tree.remove(['dir/', 'dir/file1', 'dir/file2'])
-        tree.revert(['dir/file1'])
-        self.failUnlessExists('dir/file1')
-        self.failIfExists('dir/file2')
-        self.assertEqual('dir-id', tree.path2id('dir'))

=== modified file 'bzrlib/tests/test_revision.py'
--- bzrlib/tests/test_revision.py	2008-07-21 08:07:23 +0000
+++ bzrlib/tests/test_revision.py	2007-08-28 06:43:19 +0000
@@ -20,14 +20,14 @@
 
 from bzrlib import (
     revision,
-    symbol_versioning,
     )
 from bzrlib.branch import Branch
 from bzrlib.errors import NoSuchRevision
 from bzrlib.deprecated_graph import Graph
-from bzrlib.revision import (find_present_ancestors,
+from bzrlib.revision import (find_present_ancestors, combined_graph,
+                             common_ancestor,
+                             is_ancestor, MultipleRevisionSources,
                              NULL_REVISION)
-from bzrlib.symbol_versioning import one_three
 from bzrlib.tests import TestCase, TestCaseWithTransport
 from bzrlib.trace import mutter
 from bzrlib.workingtree import WorkingTree
@@ -124,6 +124,26 @@
                 result = sorted(branch.repository.get_ancestry(rev_id))
                 self.assertEquals(result, [None] + sorted(anc))
     
+    
+    def test_is_ancestor(self):
+        """Test checking whether a revision is an ancestor of another revision"""
+        br1, br2 = make_branches(self)
+        revisions = br1.revision_history()
+        revisions_2 = br2.revision_history()
+        sources = br1
+
+        self.assert_(is_ancestor(revisions[0], revisions[0], br1))
+        self.assert_(is_ancestor(revisions[1], revisions[0], sources))
+        self.assert_(not is_ancestor(revisions[0], revisions[1], sources))
+        self.assert_(is_ancestor(revisions_2[3], revisions[0], sources))
+        # disabled mbp 20050914, doesn't seem to happen anymore
+        ## self.assertRaises(NoSuchRevision, is_ancestor, revisions_2[3],
+        ##                  revisions[0], br1)        
+        self.assert_(is_ancestor(revisions[3], revisions_2[4], sources))
+        self.assert_(is_ancestor(revisions[3], revisions_2[4], br1))
+        self.assert_(is_ancestor(revisions[3], revisions_2[3], sources))
+        ## self.assert_(not is_ancestor(revisions[3], revisions_2[3], br1))
+
 
 class TestIntermediateRevisions(TestCaseWithTransport):
 
@@ -142,6 +162,11 @@
         wt2.merge_from_branch(self.br1)
         wt2.commit("Commit fifteen", rev_id="b@u-0-10")
 
+        from bzrlib.revision import MultipleRevisionSources
+        self.sources = MultipleRevisionSources(self.br1.repository,
+                                               self.br2.repository)
+
+
 
 class MockRevisionSource(object):
     """A RevisionSource that takes a pregenerated graph.
@@ -161,6 +186,63 @@
 class TestCommonAncestor(TestCaseWithTransport):
     """Test checking whether a revision is an ancestor of another revision"""
 
+    def test_common_ancestor(self):
+        """Pick a reasonable merge base"""
+        br1, br2 = make_branches(self)
+        revisions = br1.revision_history()
+        revisions_2 = br2.revision_history()
+        sources = MultipleRevisionSources(br1.repository, br2.repository)
+        expected_ancestors_list = {revisions[3]:(0, 0), 
+                                   revisions[2]:(1, 1),
+                                   revisions_2[4]:(2, 1), 
+                                   revisions[1]:(3, 2),
+                                   revisions_2[3]:(4, 2),
+                                   revisions[0]:(5, 3) }
+        ancestors_list = find_present_ancestors(revisions[3], sources)
+        self.assertEquals(len(expected_ancestors_list), len(ancestors_list))
+        for key, value in expected_ancestors_list.iteritems():
+            self.assertEqual(ancestors_list[key], value, 
+                              "key %r, %r != %r" % (key, ancestors_list[key],
+                                                    value))
+        self.assertEqual(common_ancestor(revisions[0], revisions[0], sources),
+                          revisions[0])
+        self.assertEqual(common_ancestor(revisions[1], revisions[2], sources),
+                          revisions[1])
+        self.assertEqual(common_ancestor(revisions[1], revisions[1], sources),
+                          revisions[1])
+        self.assertEqual(common_ancestor(revisions[2], revisions_2[4], sources),
+                          revisions[2])
+        self.assertEqual(common_ancestor(revisions[3], revisions_2[4], sources),
+                          revisions_2[4])
+        self.assertEqual(common_ancestor(revisions[4], revisions_2[5], sources),
+                          revisions_2[4])
+        self.assertTrue(common_ancestor(revisions[5], revisions_2[6], sources) in
+                        (revisions[4], revisions_2[5]))
+        self.assertTrue(common_ancestor(revisions_2[6], revisions[5], sources),
+                        (revisions[4], revisions_2[5]))
+        self.assertEqual(None, common_ancestor(None, revisions[5], sources))
+        self.assertEqual(NULL_REVISION,
+            common_ancestor(NULL_REVISION, NULL_REVISION, sources))
+        self.assertEqual(NULL_REVISION,
+            common_ancestor(revisions[0], NULL_REVISION, sources))
+        self.assertEqual(NULL_REVISION,
+            common_ancestor(NULL_REVISION, revisions[0], sources))
+
+    def test_combined(self):
+        """combined_graph
+        Ensure it's not order-sensitive
+        """
+        br1, br2 = make_branches(self)
+        source = MultipleRevisionSources(br1.repository, br2.repository)
+        combined_1 = combined_graph(br1.last_revision(),
+                                    br2.last_revision(), source)
+        combined_2 = combined_graph(br2.last_revision(),
+                                    br1.last_revision(), source)
+        self.assertEquals(combined_1[1], combined_2[1])
+        self.assertEquals(combined_1[2], combined_2[2])
+        self.assertEquals(combined_1[3], combined_2[3])
+        self.assertEquals(combined_1, combined_2)
+
     def test_get_history(self):
         # TODO: test ghosts on the left hand branch's impact
         # TODO: test ghosts on all parents, we should get some
@@ -180,6 +262,41 @@
         history = rev.get_history(tree.branch.repository)
         self.assertEqual([None, '1', '2' ,'3'], history)
 
+    def test_common_ancestor_rootless_graph(self):
+        # common_ancestor on a graph with no reachable roots - only
+        # ghosts - should still return a useful value.
+        graph = Graph()
+        # add a ghost node which would be a root if it wasn't a ghost.
+        graph.add_ghost('a_ghost')
+        # add a normal commit on top of that
+        graph.add_node('rev1', ['a_ghost'])
+        # add a left-branch revision
+        graph.add_node('left', ['rev1'])
+        # add a right-branch revision
+        graph.add_node('right', ['rev1'])
+        source = MockRevisionSource(graph)
+        self.assertEqual('rev1', common_ancestor('left', 'right', source))
+
+
+class TestMultipleRevisionSources(TestCaseWithTransport):
+    """Tests for the MultipleRevisionSources adapter."""
+
+    def test_get_revision_graph_merges_ghosts(self):
+        # when we ask for the revision graph for B, which
+        # is in repo 1 with a ghost of A, and which is not
+        # in repo 2, which has A, the revision_graph()
+        # should return A and B both.
+        tree_1 = self.make_branch_and_tree('1')
+        tree_1.set_parent_ids(['A'], allow_leftmost_as_ghost=True)
+        tree_1.commit('foo', rev_id='B', allow_pointless=True)
+        tree_2 = self.make_branch_and_tree('2')
+        tree_2.commit('bar', rev_id='A', allow_pointless=True)
+        source = MultipleRevisionSources(tree_1.branch.repository,
+                                         tree_2.branch.repository)
+        self.assertEqual({'B':['A'],
+                          'A':[]},
+                         source.get_revision_graph('B'))
+
 
 class TestReservedId(TestCase):
 

=== renamed file 'bzrlib/tests/test_revisionspec.py' => 'bzrlib/tests/test_revisionnamespaces.py'
--- bzrlib/tests/test_revisionspec.py	2008-06-16 16:13:26 +0000
+++ bzrlib/tests/test_revisionnamespaces.py	2007-08-06 22:26:54 +0000
@@ -49,15 +49,15 @@
 
         self.tree = self.make_branch_and_tree('tree')
         self.build_tree(['tree/a'])
-        self.tree.lock_write()
-        self.addCleanup(self.tree.unlock)
         self.tree.add(['a'])
         self.tree.commit('a', rev_id='r1')
 
         self.tree2 = self.tree.bzrdir.sprout('tree2').open_workingtree()
         self.tree2.commit('alt', rev_id='alt_r2')
 
-        self.tree.merge_from_branch(self.tree2.branch)
+        self.tree.branch.repository.fetch(self.tree2.branch.repository,
+                                          revision_id='alt_r2')
+        self.tree.set_pending_merges(['alt_r2'])
         self.tree.commit('second', rev_id='r2')
 
     def get_in_history(self, revision_spec):
@@ -73,68 +73,22 @@
                          ' %r != %r'
                          % (revision_spec, exp_revision_id, rev_info.rev_id))
 
-    def assertInvalid(self, revision_spec, extra='',
-                      invalid_as_revision_id=True):
+    def assertInvalid(self, revision_spec, extra=''):
         try:
             self.get_in_history(revision_spec)
         except errors.InvalidRevisionSpec, e:
             self.assertEqual(revision_spec, e.spec)
             self.assertEqual(extra, e.extra)
         else:
-            self.fail('Expected InvalidRevisionSpec to be raised for'
-                      ' %r.in_history' % (revision_spec,))
-        if invalid_as_revision_id:
-            try:
-                spec = RevisionSpec.from_string(revision_spec)
-                spec.as_revision_id(self.tree.branch)
-            except errors.InvalidRevisionSpec, e:
-                self.assertEqual(revision_spec, e.spec)
-                self.assertEqual(extra, e.extra)
-            else:
-                self.fail('Expected InvalidRevisionSpec to be raised for'
-                          ' %r.as_revision_id' % (revision_spec,))
-
-    def assertAsRevisionId(self, revision_id, revision_spec):
-        """Calling as_revision_id() should return the specified id."""
-        spec = RevisionSpec.from_string(revision_spec)
-        self.assertEqual(revision_id,
-                         spec.as_revision_id(self.tree.branch))
-
-
-class RevisionSpecMatchOnTrap(RevisionSpec):
-
-    def _match_on(self, branch, revs):
-        self.last_call = (branch, revs)
-        return super(RevisionSpecMatchOnTrap, self)._match_on(branch, revs)
-
-
-class TestRevisionSpecBase(TestRevisionSpec):
-
-    def test_wants_revision_history(self):
-        # If wants_revision_history = True, then _match_on should get the
-        # branch revision history
-        spec = RevisionSpecMatchOnTrap('foo', _internal=True)
-        spec.in_history(self.tree.branch)
-
-        self.assertEqual((self.tree.branch, ['r1' ,'r2']),
-                         spec.last_call)
-
-    def test_wants_no_revision_history(self):
-        # If wants_revision_history = False, then _match_on should get None for
-        # the branch revision history
-        spec = RevisionSpecMatchOnTrap('foo', _internal=True)
-        spec.wants_revision_history = False
-        spec.in_history(self.tree.branch)
-
-        self.assertEqual((self.tree.branch, None), spec.last_call)
-
+            self.fail('Expected InvalidRevisionSpec to be raised for %s'
+                      % (revision_spec,))
 
 
 class TestOddRevisionSpec(TestRevisionSpec):
     """Test things that aren't normally thought of as revision specs"""
 
     def test_none(self):
-        self.assertInHistoryIs(None, None, None)
+        self.assertInHistoryIs(0, None, None)
 
     def test_object(self):
         self.assertRaises(TypeError, RevisionSpec.from_string, object())
@@ -292,13 +246,6 @@
         self.assertEqual((2, 'b@r-0-2'),
                          spec_in_history('revno:2:b/', None))
 
-    def test_as_revision_id(self):
-        self.assertAsRevisionId('null:', '0')
-        self.assertAsRevisionId('r1', '1')
-        self.assertAsRevisionId('r2', '2')
-        self.assertAsRevisionId('r1', '-2')
-        self.assertAsRevisionId('r2', '-1')
-        self.assertAsRevisionId('alt_r2', '1.1.1')
 
 
 class TestRevisionSpec_revid(TestRevisionSpec):
@@ -310,7 +257,7 @@
         self.assertInHistoryIs(2, 'r2', 'revid:r2')
         
     def test_missing(self):
-        self.assertInvalid('revid:r3', invalid_as_revision_id=False)
+        self.assertInvalid('revid:r3')
 
     def test_merged(self):
         """We can reach revisions in the ancestry"""
@@ -319,7 +266,7 @@
     def test_not_here(self):
         self.tree2.commit('alt third', rev_id='alt_r3')
         # It exists in tree2, but not in tree
-        self.assertInvalid('revid:alt_r3', invalid_as_revision_id=False)
+        self.assertInvalid('revid:alt_r3')
 
     def test_in_repository(self):
         """We can get any revision id in the repository"""
@@ -336,11 +283,6 @@
         self.assertInHistoryIs(3, revision_id, u'revid:\N{SNOWMAN}')
         self.assertInHistoryIs(3, revision_id, 'revid:' + revision_id)
 
-    def test_as_revision_id(self):
-        self.assertAsRevisionId('r1', 'revid:r1')
-        self.assertAsRevisionId('r2', 'revid:r2')
-        self.assertAsRevisionId('alt_r2', 'revid:alt_r2')
-
 
 class TestRevisionSpec_last(TestRevisionSpec):
 
@@ -372,10 +314,6 @@
             pass
         self.assertInvalid('last:Y', extra='\n' + str(e))
 
-    def test_as_revision_id(self):
-        self.assertAsRevisionId('r2', 'last:1')
-        self.assertAsRevisionId('r1', 'last:2')
-
 
 class TestRevisionSpec_before(TestRevisionSpec):
 
@@ -407,19 +345,15 @@
                                           revision_id='new_r1')
         self.assertInHistoryIs(0, 'null:', 'before:revid:new_r1')
 
-    def test_as_revision_id(self):
-        self.assertAsRevisionId('r1', 'before:revid:r2')
-        self.assertAsRevisionId('r1', 'before:2')
-        self.assertAsRevisionId('r1', 'before:1.1.1')
-        self.assertAsRevisionId('r1', 'before:revid:alt_r2')
-
 
 class TestRevisionSpec_tag(TestRevisionSpec):
     
     def make_branch_and_tree(self, relpath):
         # override format as the default one may not support tags
-        return TestRevisionSpec.make_branch_and_tree(
-            self, relpath, format='dirstate-tags')
+        control = bzrdir.BzrDir.create(relpath)
+        control.create_repository()
+        branch.BzrBranchExperimental.initialize(control)
+        return control.create_workingtree()
 
     def test_from_string_tag(self):
         spec = RevisionSpec.from_string('tag:bzr-0.14')
@@ -429,8 +363,6 @@
     def test_lookup_tag(self):
         self.tree.branch.tags.set_tag('bzr-0.14', 'r1')
         self.assertInHistoryIs(1, 'r1', 'tag:bzr-0.14')
-        self.tree.branch.tags.set_tag('null_rev', 'null:')
-        self.assertInHistoryIs(0, 'null:', 'tag:null_rev')
 
     def test_failed_lookup(self):
         # tags that don't exist give a specific message: arguably we should
@@ -439,13 +371,6 @@
             self.get_in_history,
             'tag:some-random-tag')
 
-    def test_as_revision_id(self):
-        self.tree.branch.tags.set_tag('my-tag', 'r2')
-        self.tree.branch.tags.set_tag('null_rev', 'null:')
-        self.assertAsRevisionId('r2', 'tag:my-tag')
-        self.assertAsRevisionId('null:', 'tag:null_rev')
-        self.assertAsRevisionId('r1', 'before:tag:my-tag')
-
 
 class TestRevisionSpec_date(TestRevisionSpec):
 
@@ -482,9 +407,6 @@
         self.assertInHistoryIs(2, 'new_r2',
             'date:%04d-%02d-%02d' % (now.year, now.month, now.day))
 
-    def test_as_revision_id(self):
-        self.assertAsRevisionId('new_r2', 'date:today')
-
 
 class TestRevisionSpec_ancestor(TestRevisionSpec):
     
@@ -528,9 +450,6 @@
                           spec_in_history, 'ancestor:tree',
                                            new_tree.branch)
 
-    def test_as_revision_id(self):
-        self.assertAsRevisionId('alt_r2', 'ancestor:tree2')
-
 
 class TestRevisionSpec_branch(TestRevisionSpec):
     
@@ -565,9 +484,6 @@
         self.assertRaises(errors.NoCommits,
                           self.get_in_history, 'branch:new_tree')
 
-    def test_as_revision_id(self):
-        self.assertAsRevisionId('alt_r2', 'branch:tree2')
-
 
 class TestRevisionSpec_submit(TestRevisionSpec):
 
@@ -583,7 +499,3 @@
         # submit branch overrides parent branch
         self.tree.branch.set_submit_branch('tree2')
         self.assertInHistoryIs(None, 'alt_r2', 'submit:')
-
-    def test_as_revision_id(self):
-        self.tree.branch.set_submit_branch('tree2')
-        self.assertAsRevisionId('alt_r2', 'branch:tree2')

=== modified file 'bzrlib/tests/test_revisiontree.py'
--- bzrlib/tests/test_revisiontree.py	2008-05-02 07:31:24 +0000
+++ bzrlib/tests/test_revisiontree.py	2006-09-30 00:25:31 +0000
@@ -22,6 +22,7 @@
     )
 import bzrlib
 from bzrlib.tests import TestCaseWithTransport
+from bzrlib.tree import RevisionTree
 
 
 class TestTreeWithCommits(TestCaseWithTransport):

=== removed file 'bzrlib/tests/test_rules.py'
--- bzrlib/tests/test_rules.py	2008-07-18 08:40:57 +0000
+++ bzrlib/tests/test_rules.py	1970-01-01 00:00:00 +0000
@@ -1,119 +0,0 @@
-# Copyright (C) 2008 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Tests for finding, parsing and searching rule-based preferences."""
-
-import os
-import sys
-
-from bzrlib import (
-    config,
-    errors,
-    rules,
-    tests,
-    )
-from bzrlib.util.configobj import configobj
-
-
-class TestIniBasedRulesSearcher(tests.TestCase):
-
-    def make_searcher(self, text):
-        """Make a _RulesSearcher from a string"""
-        if text is None:
-            lines = None
-        else:
-            lines = text.splitlines()
-        return rules._IniBasedRulesSearcher(lines)
-
-    def test_unknown_namespace(self):
-        self.assertRaises(errors.UnknownRules, rules._IniBasedRulesSearcher,
-            ["[junk]", "foo=bar"])
-
-    def test_get_items_file_missing(self):
-        rs = self.make_searcher(None)
-        self.assertEquals((), rs.get_items('a.txt'))
-        self.assertEquals((), rs.get_selected_items('a.txt', ['foo']))
-
-    def test_get_items_file_empty(self):
-        rs = self.make_searcher("")
-        self.assertEquals((), rs.get_items('a.txt'))
-        self.assertEquals((), rs.get_selected_items('a.txt', ['foo']))
-
-    def test_get_items_from_extension_match(self):
-        rs = self.make_searcher("[name *.txt]\nfoo=bar\na=True\n")
-        self.assertEquals((), rs.get_items('a.py'))
-        self.assertEquals((('foo', 'bar'), ('a', 'True')),
-            rs.get_items('a.txt'))
-        self.assertEquals((('foo', 'bar'), ('a', 'True')),
-            rs.get_items('dir/a.txt'))
-        self.assertEquals((('foo', 'bar'),),
-            rs.get_selected_items('a.txt', ['foo']))
-
-    def test_get_items_pathname_match(self):
-        rs = self.make_searcher("[name ./a.txt]\nfoo=baz\n")
-        self.assertEquals((('foo', 'baz'),),
-            rs.get_items('a.txt'))
-        self.assertEquals((), rs.get_items('dir/a.txt'))
-
-    def test_get_items_match_first(self):
-        rs = self.make_searcher(
-            "[name ./a.txt]\nfoo=baz\n"
-            "[name *.txt]\nfoo=bar\na=True\n")
-        self.assertEquals((('foo', 'baz'),),
-            rs.get_items('a.txt'))
-        self.assertEquals((('foo', 'bar'), ('a', 'True')),
-            rs.get_items('dir/a.txt'))
-
-
-class TestStackedRulesSearcher(tests.TestCase):
-
-    def make_searcher(self, text1=None, text2=None):
-        """Make a _StackedRulesSearcher with 0, 1 or 2 items"""
-        searchers = []
-        if text1 is not None:
-            searchers.append(rules._IniBasedRulesSearcher(
-                text1.splitlines()))
-        if text2 is not None:
-            searchers.append(rules._IniBasedRulesSearcher(
-                text2.splitlines()))
-        return rules._StackedRulesSearcher(searchers)
-
-    def test_stack_searching(self):
-        rs = self.make_searcher(
-            "[name ./a.txt]\nfoo=baz\n",
-            "[name *.txt]\nfoo=bar\na=True\n")
-        self.assertEquals((('foo', 'baz'),),
-            rs.get_items('a.txt'))
-        self.assertEquals((('foo', 'bar'), ('a', 'True')),
-            rs.get_items('dir/a.txt'))
-
-
-class TestRulesPath(tests.TestCase):
-
-    def setUp(self):
-        super(TestRulesPath, self).setUp()
-        os.environ['HOME'] = '/home/bogus'
-        if sys.platform == 'win32':
-            os.environ['BZR_HOME'] = \
-                r'C:\Documents and Settings\bogus\Application Data'
-            self.bzr_home = \
-                'C:/Documents and Settings/bogus/Application Data/bazaar/2.0'
-        else:
-            self.bzr_home = '/home/bogus/.bazaar'
-
-    def test_rules_filename(self):
-        self.assertEqual(rules.rules_filename(),
-                         self.bzr_home + '/rules')

=== modified file 'bzrlib/tests/test_selftest.py'
--- bzrlib/tests/test_selftest.py	2008-08-31 10:51:07 +0000
+++ bzrlib/tests/test_selftest.py	2007-10-02 11:24:53 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2008 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -26,27 +26,19 @@
 
 import bzrlib
 from bzrlib import (
-    branchbuilder,
     bzrdir,
     errors,
     memorytree,
     osutils,
-    remote,
     repository,
     symbol_versioning,
-    tests,
-    workingtree,
     )
 from bzrlib.progress import _BaseProgressBar
-from bzrlib.repofmt import (
-    pack_repo,
-    weaverepo,
-    )
+from bzrlib.repofmt import weaverepo
 from bzrlib.symbol_versioning import (
-    one_zero,
-    zero_eleven,
-    zero_ten,
-    )
+        zero_ten,
+        zero_eleven,
+        )
 from bzrlib.tests import (
                           ChrootedTestCase,
                           ExtendedTestResult,
@@ -62,17 +54,9 @@
                           TestUtil,
                           TextTestRunner,
                           UnavailableFeature,
-                          condition_id_re,
-                          condition_isinstance,
-                          exclude_tests_by_condition,
-                          exclude_tests_by_re,
-                          filter_suite_by_condition,
+                          iter_suite_tests,
                           filter_suite_by_re,
-                          iter_suite_tests,
-                          preserve_input,
-                          randomize_suite,
-                          split_suite_by_condition,
-                          split_suite_by_re,
+                          sort_suite_by_re,
                           test_lsprof,
                           test_suite,
                           )
@@ -83,11 +67,6 @@
 from bzrlib.version import _get_bzr_source_tree
 
 
-def _test_ids(test_suite):
-    """Get the ids for the tests in a test suite."""
-    return [t.id() for t in iter_suite_tests(test_suite)]
-
-
 class SelftestTests(TestCase):
 
     def test_import_tests(self):
@@ -109,22 +88,15 @@
                               'a test message\n')
 
 
-class TestUnicodeFilename(TestCase):
-
-    def test_probe_passes(self):
-        """UnicodeFilename._probe passes."""
-        # We can't test much more than that because the behaviour depends
-        # on the platform.
-        tests.UnicodeFilename._probe()
-
-
 class TestTreeShape(TestCaseInTempDir):
 
     def test_unicode_paths(self):
-        self.requireFeature(tests.UnicodeFilename)
-
         filename = u'hell\u00d8'
-        self.build_tree_contents([(filename, 'contents of hello')])
+        try:
+            self.build_tree_contents([(filename, 'contents of hello')])
+        except UnicodeEncodeError:
+            raise TestSkipped("can't build unicode working tree in "
+                "filesystem encoding %s" % sys.getfilesystemencoding())
         self.failUnlessExists(filename)
 
 
@@ -139,8 +111,8 @@
     """
 
     def test_get_transport_permutations(self):
-        # this checks that get_test_permutations defined by the module is
-        # called by the adapter get_transport_test_permutations method.
+        # this checks that we the module get_test_permutations call
+        # is made by the adapter get_transport_test_permitations method.
         class MockModule(object):
             def get_test_permutations(self):
                 return sample_permutation
@@ -152,10 +124,11 @@
                          adapter.get_transport_test_permutations(MockModule()))
 
     def test_adapter_checks_all_modules(self):
-        # this checks that the adapter returns as many permutations as there
-        # are in all the registered transport modules - we assume if this
-        # matches its probably doing the right thing especially in combination
-        # with the tests for setting the right classes below.
+        # this checks that the adapter returns as many permurtations as
+        # there are in all the registered# transport modules for there
+        # - we assume if this matches its probably doing the right thing
+        # especially in combination with the tests for setting the right
+        # classes below.
         from bzrlib.tests.test_transport_implementations \
             import TransportTestProviderAdapter
         from bzrlib.transport import _get_transport_modules
@@ -247,46 +220,86 @@
             adapter.scenarios)
 
 
-class TestRepositoryParameterisation(TestCase):
+class TestRepositoryProviderAdapter(TestCase):
     """A group of tests that test the repository implementation test adapter."""
 
+    def test_constructor(self):
+        # check that constructor parameters are passed through to the
+        # scenarios.
+        from bzrlib.tests.repository_implementations import RepositoryTestProviderAdapter
+        server1 = "a"
+        server2 = "b"
+        formats = [("c", "C"), ("d", "D")]
+        adapter = RepositoryTestProviderAdapter(server1, server2, formats)
+        self.assertEqual([
+            ('str',
+             {'bzrdir_format': 'C',
+              'repository_format': 'c',
+              'transport_readonly_server': 'b',
+              'transport_server': 'a'}),
+            ('str',
+             {'bzrdir_format': 'D',
+              'repository_format': 'd',
+              'transport_readonly_server': 'b',
+              'transport_server': 'a'})],
+            adapter.scenarios)
+
+    def test_setting_vfs_transport(self):
+        """The vfs_transport_factory can be set optionally."""
+        from bzrlib.tests.repository_implementations import RepositoryTestProviderAdapter
+        formats = [("a", "b"), ("c", "d")]
+        adapter = RepositoryTestProviderAdapter(None, None, formats,
+            vfs_transport_factory="vfs")
+        self.assertEqual([
+            ('str',
+             {'bzrdir_format': 'b',
+              'repository_format': 'a',
+              'transport_readonly_server': None,
+              'transport_server': None,
+              'vfs_transport_factory': 'vfs'}),
+            ('str',
+             {'bzrdir_format': 'd',
+              'repository_format': 'c',
+              'transport_readonly_server': None,
+              'transport_server': None,
+              'vfs_transport_factory': 'vfs'})],
+            adapter.scenarios)
+
     def test_formats_to_scenarios(self):
         """The adapter can generate all the scenarios needed."""
-        from bzrlib.tests.repository_implementations import formats_to_scenarios
-        formats = [("(c)", remote.RemoteRepositoryFormat()),
-                   ("(d)", repository.format_registry.get(
-                        'Bazaar pack repository format 1 (needs bzr 0.92)\n'))]
-        no_vfs_scenarios = formats_to_scenarios(formats, "server", "readonly",
-            None)
-        vfs_scenarios = formats_to_scenarios(formats, "server", "readonly",
-            vfs_transport_factory="vfs")
-        # no_vfs generate scenarios without vfs_transport_factory
+        from bzrlib.tests.repository_implementations import RepositoryTestProviderAdapter
+        no_vfs_adapter = RepositoryTestProviderAdapter("server", "readonly",
+            [], None)
+        vfs_adapter = RepositoryTestProviderAdapter("server", "readonly",
+            [], vfs_transport_factory="vfs")
+        # no_vfs generate scenarios without vfs_transport_factor
+        formats = [("c", "C"), (1, "D")]
         self.assertEqual([
-            ('RemoteRepositoryFormat(c)',
-             {'bzrdir_format': remote.RemoteBzrDirFormat(),
-              'repository_format': remote.RemoteRepositoryFormat(),
+            ('str',
+             {'bzrdir_format': 'C',
+              'repository_format': 'c',
               'transport_readonly_server': 'readonly',
               'transport_server': 'server'}),
-            ('RepositoryFormatKnitPack1(d)',
-             {'bzrdir_format': bzrdir.BzrDirMetaFormat1(),
-              'repository_format': pack_repo.RepositoryFormatKnitPack1(),
+            ('int',
+             {'bzrdir_format': 'D',
+              'repository_format': 1,
               'transport_readonly_server': 'readonly',
               'transport_server': 'server'})],
-            no_vfs_scenarios)
+            no_vfs_adapter.formats_to_scenarios(formats))
         self.assertEqual([
-            ('RemoteRepositoryFormat(c)',
-             {'bzrdir_format': remote.RemoteBzrDirFormat(),
-              'repository_format': remote.RemoteRepositoryFormat(),
+            ('str',
+             {'bzrdir_format': 'C',
+              'repository_format': 'c',
               'transport_readonly_server': 'readonly',
               'transport_server': 'server',
               'vfs_transport_factory': 'vfs'}),
-            ('RepositoryFormatKnitPack1(d)',
-             {'bzrdir_format': bzrdir.BzrDirMetaFormat1(),
-              'repository_format': pack_repo.RepositoryFormatKnitPack1(),
+            ('int',
+             {'bzrdir_format': 'D',
+              'repository_format': 1,
               'transport_readonly_server': 'readonly',
               'transport_server': 'server',
               'vfs_transport_factory': 'vfs'})],
-            vfs_scenarios)
+            vfs_adapter.formats_to_scenarios(formats))
 
 
 class TestTestScenarioApplier(TestCase):
@@ -353,13 +366,13 @@
         formats = [(str, "C1", "C2"), (int, "D1", "D2")]
         adapter = InterRepositoryTestProviderAdapter(server1, server2, formats)
         self.assertEqual([
-            ('str,str,str',
+            ('str',
              {'interrepo_class': str,
               'repository_format': 'C1',
               'repository_format_to': 'C2',
               'transport_readonly_server': 'b',
               'transport_server': 'a'}),
-            ('int,str,str',
+            ('int',
              {'interrepo_class': int,
               'repository_format': 'D1',
               'repository_format_to': 'D2',
@@ -368,6 +381,61 @@
             adapter.formats_to_scenarios(formats))
 
 
+class TestInterVersionedFileProviderAdapter(TestCase):
+    """A group of tests that test the InterVersionedFile test adapter."""
+
+    def test_scenarios(self):
+        # check that constructor parameters are passed through to the adapted
+        # test.
+        from bzrlib.tests.interversionedfile_implementations \
+            import InterVersionedFileTestProviderAdapter
+        server1 = "a"
+        server2 = "b"
+        formats = [(str, "C1", "C2"), (int, "D1", "D2")]
+        adapter = InterVersionedFileTestProviderAdapter(server1, server2, formats)
+        self.assertEqual([
+            ('str',
+             {'interversionedfile_class':str,
+              'transport_readonly_server': 'b',
+              'transport_server': 'a',
+              'versionedfile_factory': 'C1',
+              'versionedfile_factory_to': 'C2'}),
+            ('int',
+             {'interversionedfile_class': int,
+              'transport_readonly_server': 'b',
+              'transport_server': 'a',
+              'versionedfile_factory': 'D1',
+              'versionedfile_factory_to': 'D2'})],
+            adapter.scenarios)
+
+
+class TestRevisionStoreProviderAdapter(TestCase):
+    """A group of tests that test the RevisionStore test adapter."""
+
+    def test_scenarios(self):
+        # check that constructor parameters are passed through to the adapted
+        # test.
+        from bzrlib.tests.revisionstore_implementations \
+            import RevisionStoreTestProviderAdapter
+        # revision stores need a store factory - i.e. RevisionKnit
+        #, a readonly and rw transport 
+        # transport servers:
+        server1 = "a"
+        server2 = "b"
+        store_factories = ["c", "d"]
+        adapter = RevisionStoreTestProviderAdapter(server1, server2, store_factories)
+        self.assertEqual([
+            ('c',
+             {'store_factory': 'c',
+              'transport_readonly_server': 'b',
+              'transport_server': 'a'}),
+            ('d',
+             {'store_factory': 'd',
+              'transport_readonly_server': 'b',
+              'transport_server': 'a'})],
+            adapter.scenarios)
+
+
 class TestWorkingTreeProviderAdapter(TestCase):
     """A group of tests that test the workingtree implementation test adapter."""
 
@@ -378,20 +446,19 @@
             import WorkingTreeTestProviderAdapter
         server1 = "a"
         server2 = "b"
-        formats = [workingtree.WorkingTreeFormat2(),
-                   workingtree.WorkingTreeFormat3(),]
+        formats = [("c", "C"), ("d", "D")]
         adapter = WorkingTreeTestProviderAdapter(server1, server2, formats)
         self.assertEqual([
-            ('WorkingTreeFormat2',
-             {'bzrdir_format': formats[0]._matchingbzrdir,
-              'transport_readonly_server': 'b',
-              'transport_server': 'a',
-              'workingtree_format': formats[0]}),
-            ('WorkingTreeFormat3',
-             {'bzrdir_format': formats[1]._matchingbzrdir,
-              'transport_readonly_server': 'b',
-              'transport_server': 'a',
-              'workingtree_format': formats[1]})],
+            ('str',
+             {'bzrdir_format': 'C',
+              'transport_readonly_server': 'b',
+              'transport_server': 'a',
+              'workingtree_format': 'c'}),
+            ('str',
+             {'bzrdir_format': 'D',
+              'transport_readonly_server': 'b',
+              'transport_server': 'a',
+              'workingtree_format': 'd'})],
             adapter.scenarios)
 
 
@@ -411,37 +478,35 @@
             return_parameter,
             revision_tree_from_workingtree
             )
+        from bzrlib.workingtree import WorkingTreeFormat, WorkingTreeFormat3
         input_test = TestTreeProviderAdapter(
             "test_adapted_tests")
         server1 = "a"
         server2 = "b"
-        formats = [workingtree.WorkingTreeFormat2(),
-                   workingtree.WorkingTreeFormat3(),]
+        formats = [("c", "C"), ("d", "D")]
         adapter = TreeTestProviderAdapter(server1, server2, formats)
         suite = adapter.adapt(input_test)
         tests = list(iter(suite))
-        # XXX We should not have tests fail as we add more scenarios
-        # abentley 20080412
-        self.assertEqual(6, len(tests))
+        self.assertEqual(4, len(tests))
         # this must match the default format setp up in
         # TreeTestProviderAdapter.adapt
-        default_format = workingtree.WorkingTreeFormat3
-        self.assertEqual(tests[0].workingtree_format, formats[0])
-        self.assertEqual(tests[0].bzrdir_format, formats[0]._matchingbzrdir)
+        default_format = WorkingTreeFormat3
+        self.assertEqual(tests[0].workingtree_format, formats[0][0])
+        self.assertEqual(tests[0].bzrdir_format, formats[0][1])
         self.assertEqual(tests[0].transport_server, server1)
         self.assertEqual(tests[0].transport_readonly_server, server2)
-        self.assertEqual(tests[0]._workingtree_to_test_tree, return_parameter)
-        self.assertEqual(tests[1].workingtree_format, formats[1])
-        self.assertEqual(tests[1].bzrdir_format, formats[1]._matchingbzrdir)
+        self.assertEqual(tests[0].workingtree_to_test_tree, return_parameter)
+        self.assertEqual(tests[1].workingtree_format, formats[1][0])
+        self.assertEqual(tests[1].bzrdir_format, formats[1][1])
         self.assertEqual(tests[1].transport_server, server1)
         self.assertEqual(tests[1].transport_readonly_server, server2)
-        self.assertEqual(tests[1]._workingtree_to_test_tree, return_parameter)
+        self.assertEqual(tests[1].workingtree_to_test_tree, return_parameter)
         self.assertIsInstance(tests[2].workingtree_format, default_format)
         #self.assertEqual(tests[2].bzrdir_format,
         #                 default_format._matchingbzrdir)
         self.assertEqual(tests[2].transport_server, server1)
         self.assertEqual(tests[2].transport_readonly_server, server2)
-        self.assertEqual(tests[2]._workingtree_to_test_tree,
+        self.assertEqual(tests[2].workingtree_to_test_tree,
             revision_tree_from_workingtree)
 
 
@@ -456,7 +521,7 @@
         # because each optimiser can be direction specific, we need to test
         # each optimiser in its chosen direction.
         # unlike the TestProviderAdapter we dont want to automatically add a
-        # parameterized one for WorkingTree - the optimisers will tell us what
+        # parameterised one for WorkingTree - the optimisers will tell us what
         # ones to add.
         from bzrlib.tests.tree_implementations import (
             return_parameter,
@@ -482,14 +547,14 @@
         self.assertEqual(tests[0].workingtree_format, formats[0][1])
         self.assertEqual(tests[0].workingtree_format_to, formats[0][2])
         self.assertEqual(tests[0].mutable_trees_to_test_trees, formats[0][3])
-        self.assertEqual(tests[0]._workingtree_to_test_tree, return_parameter)
+        self.assertEqual(tests[0].workingtree_to_test_tree, return_parameter)
         self.assertEqual(tests[0].transport_server, server1)
         self.assertEqual(tests[0].transport_readonly_server, server2)
         self.assertEqual(tests[1].intertree_class, formats[1][0])
         self.assertEqual(tests[1].workingtree_format, formats[1][1])
         self.assertEqual(tests[1].workingtree_format_to, formats[1][2])
         self.assertEqual(tests[1].mutable_trees_to_test_trees, formats[1][3])
-        self.assertEqual(tests[1]._workingtree_to_test_tree, return_parameter)
+        self.assertEqual(tests[1].workingtree_to_test_tree, return_parameter)
         self.assertEqual(tests[1].transport_server, server1)
         self.assertEqual(tests[1].transport_readonly_server, server2)
 
@@ -548,43 +613,6 @@
         self.assertEqual(format.repository_format.__class__,
             tree.branch.repository._format.__class__)
 
-    def test_make_branch_builder(self):
-        builder = self.make_branch_builder('dir')
-        self.assertIsInstance(builder, branchbuilder.BranchBuilder)
-        # Guard against regression into MemoryTransport leaking
-        # files to disk instead of keeping them in memory.
-        self.failIf(osutils.lexists('dir'))
-
-    def test_make_branch_builder_with_format(self):
-        # Use a repo layout that doesn't conform to a 'named' layout, to ensure
-        # that the format objects are used.
-        format = bzrdir.BzrDirMetaFormat1()
-        repo_format = weaverepo.RepositoryFormat7()
-        format.repository_format = repo_format
-        builder = self.make_branch_builder('dir', format=format)
-        the_branch = builder.get_branch()
-        # Guard against regression into MemoryTransport leaking
-        # files to disk instead of keeping them in memory.
-        self.failIf(osutils.lexists('dir'))
-        self.assertEqual(format.repository_format.__class__,
-                         the_branch.repository._format.__class__)
-        self.assertEqual(repo_format.get_format_string(),
-                         self.get_transport().get_bytes(
-                            'dir/.bzr/repository/format'))
-
-    def test_make_branch_builder_with_format_name(self):
-        builder = self.make_branch_builder('dir', format='knit')
-        the_branch = builder.get_branch()
-        # Guard against regression into MemoryTransport leaking
-        # files to disk instead of keeping them in memory.
-        self.failIf(osutils.lexists('dir'))
-        dir_format = bzrdir.format_registry.make_bzrdir('knit')
-        self.assertEqual(dir_format.repository_format.__class__,
-                         the_branch.repository._format.__class__)
-        self.assertEqual('Bazaar-NG Knit Repository Format 1',
-                         self.get_transport().get_bytes(
-                            'dir/.bzr/repository/format'))
-
     def test_safety_net(self):
         """No test should modify the safety .bzr directory.
 
@@ -619,7 +647,7 @@
         self.assertEqual(t2.base[:-1], t.abspath('foo/bar'))
 
     def test_get_readonly_url_http(self):
-        from bzrlib.tests.http_server import HttpServer
+        from bzrlib.tests.HttpServer import HttpServer
         from bzrlib.transport import get_transport
         from bzrlib.transport.local import LocalURLServer
         from bzrlib.transport.http import HttpTransportBase
@@ -643,18 +671,6 @@
         self.assertRaises(AssertionError, self.assertIsDirectory, 'a_file', t)
         self.assertRaises(AssertionError, self.assertIsDirectory, 'not_here', t)
 
-    def test_make_branch_builder(self):
-        builder = self.make_branch_builder('dir')
-        rev_id = builder.build_commit()
-        self.failUnlessExists('dir')
-        a_dir = bzrdir.BzrDir.open('dir')
-        self.assertRaises(errors.NoWorkingTree, a_dir.open_workingtree)
-        a_branch = a_dir.open_branch()
-        builder_branch = builder.get_branch()
-        self.assertEqual(a_branch.base, builder_branch.base)
-        self.assertEqual((1, rev_id), builder_branch.last_revision_info())
-        self.assertEqual((1, rev_id), a_branch.last_revision_info())
-
 
 class TestTestCaseTransports(TestCaseWithTransport):
 
@@ -890,7 +906,7 @@
         test.run(result)
         self.assertEqual(
             [
-            ('update', '[2 in 0s] passing_test', None, None),
+            ('update', '[2 in 0s, 3 known failures] passing_test', None, None),
             ],
             pb.calls[2:])
 
@@ -966,7 +982,7 @@
         test.run(result)
         self.assertEqual(
             [
-            ('update', '[2 in 0s, 2 missing] passing_test', None, None),
+            ('update', '[2 in 0s, 2 missing features] passing_test', None, None),
             ],
             pb.calls[1:])
     
@@ -1017,15 +1033,6 @@
         self.assertEqual(None, result._extractBenchmarkTime(test))
 
 
-class TestUnicodeFilenameFeature(TestCase):
-
-    def test_probe_passes(self):
-        """UnicodeFilenameFeature._probe passes."""
-        # We can't test much more than that because the behaviour depends
-        # on the platform.
-        tests.UnicodeFilenameFeature._probe()
-
-
 class TestRunner(TestCase):
 
     def dummy_test(self):
@@ -1103,11 +1110,10 @@
         self.assertTrue(result.wasSuccessful())
 
     def test_skipped_from_setup(self):
-        calls = []
         class SkippedSetupTest(TestCase):
 
             def setUp(self):
-                calls.append('setUp')
+                self.counter = 1
                 self.addCleanup(self.cleanup)
                 raise TestSkipped('skipped setup')
 
@@ -1115,35 +1121,34 @@
                 self.fail('test reached')
 
             def cleanup(self):
-                calls.append('cleanup')
+                self.counter -= 1
 
         runner = TextTestRunner(stream=self._log_file)
         test = SkippedSetupTest('test_skip')
         result = self.run_test_runner(runner, test)
         self.assertTrue(result.wasSuccessful())
         # Check if cleanup was called the right number of times.
-        self.assertEqual(['setUp', 'cleanup'], calls)
+        self.assertEqual(0, test.counter)
 
     def test_skipped_from_test(self):
-        calls = []
         class SkippedTest(TestCase):
 
             def setUp(self):
-                calls.append('setUp')
+                self.counter = 1
                 self.addCleanup(self.cleanup)
 
             def test_skip(self):
                 raise TestSkipped('skipped test')
 
             def cleanup(self):
-                calls.append('cleanup')
+                self.counter -= 1
 
         runner = TextTestRunner(stream=self._log_file)
         test = SkippedTest('test_skip')
         result = self.run_test_runner(runner, test)
         self.assertTrue(result.wasSuccessful())
         # Check if cleanup was called the right number of times.
-        self.assertEqual(['setUp', 'cleanup'], calls)
+        self.assertEqual(0, test.counter)
 
     def test_not_applicable(self):
         # run a test that is skipped because it's not applicable
@@ -1206,12 +1211,6 @@
             revision_id = workingtree.get_parent_ids()[0]
             self.assertEndsWith(output_string.rstrip(), revision_id)
 
-    def assertLogDeleted(self, test):
-        log = test._get_log()
-        self.assertEqual("DELETED log file to reduce memory footprint", log)
-        self.assertEqual('', test._log_contents)
-        self.assertIs(None, test._log_file_name)
-
     def test_success_log_deleted(self):
         """Successful tests have their log deleted"""
 
@@ -1225,55 +1224,10 @@
         test = LogTester('test_success')
         result = self.run_test_runner(runner, test)
 
-        self.assertLogDeleted(test)
-
-    def test_skipped_log_deleted(self):
-        """Skipped tests have their log deleted"""
-
-        class LogTester(TestCase):
-
-            def test_skipped(self):
-                self.log('this will be removed\n')
-                raise tests.TestSkipped()
-
-        sio = cStringIO.StringIO()
-        runner = TextTestRunner(stream=sio)
-        test = LogTester('test_skipped')
-        result = self.run_test_runner(runner, test)
-
-        self.assertLogDeleted(test)
-
-    def test_not_aplicable_log_deleted(self):
-        """Not applicable tests have their log deleted"""
-
-        class LogTester(TestCase):
-
-            def test_not_applicable(self):
-                self.log('this will be removed\n')
-                raise tests.TestNotApplicable()
-
-        sio = cStringIO.StringIO()
-        runner = TextTestRunner(stream=sio)
-        test = LogTester('test_not_applicable')
-        result = self.run_test_runner(runner, test)
-
-        self.assertLogDeleted(test)
-
-    def test_known_failure_log_deleted(self):
-        """Know failure tests have their log deleted"""
-
-        class LogTester(TestCase):
-
-            def test_known_failure(self):
-                self.log('this will be removed\n')
-                raise tests.KnownFailure()
-
-        sio = cStringIO.StringIO()
-        runner = TextTestRunner(stream=sio)
-        test = LogTester('test_known_failure')
-        result = self.run_test_runner(runner, test)
-
-        self.assertLogDeleted(test)
+        log = test._get_log()
+        self.assertEqual("DELETED log file to reduce memory footprint", log)
+        self.assertEqual('', test._log_contents)
+        self.assertIs(None, test._log_file_name)
 
     def test_fail_log_kept(self):
         """Failed tests have their log kept"""
@@ -1325,8 +1279,6 @@
     def _test_pass(self):
         pass
 
-class _TestException(Exception):
-    pass
 
 class TestTestCase(TestCase):
     """Tests that test the core bzrlib TestCase."""
@@ -1490,61 +1442,6 @@
             ],
             result.calls)
 
-    def test_assert_list_raises_on_generator(self):
-        def generator_which_will_raise():
-            # This will not raise until after the first yield
-            yield 1
-            raise _TestException()
-
-        e = self.assertListRaises(_TestException, generator_which_will_raise)
-        self.assertIsInstance(e, _TestException)
-
-        e = self.assertListRaises(Exception, generator_which_will_raise)
-        self.assertIsInstance(e, _TestException)
-
-    def test_assert_list_raises_on_plain(self):
-        def plain_exception():
-            raise _TestException()
-            return []
-
-        e = self.assertListRaises(_TestException, plain_exception)
-        self.assertIsInstance(e, _TestException)
-
-        e = self.assertListRaises(Exception, plain_exception)
-        self.assertIsInstance(e, _TestException)
-
-    def test_assert_list_raises_assert_wrong_exception(self):
-        class _NotTestException(Exception):
-            pass
-
-        def wrong_exception():
-            raise _NotTestException()
-
-        def wrong_exception_generator():
-            yield 1
-            yield 2
-            raise _NotTestException()
-
-        # Wrong exceptions are not intercepted
-        self.assertRaises(_NotTestException,
-            self.assertListRaises, _TestException, wrong_exception)
-        self.assertRaises(_NotTestException,
-            self.assertListRaises, _TestException, wrong_exception_generator)
-
-    def test_assert_list_raises_no_exception(self):
-        def success():
-            return []
-
-        def success_generator():
-            yield 1
-            yield 2
-
-        self.assertRaises(AssertionError,
-            self.assertListRaises, _TestException, success)
-
-        self.assertRaises(AssertionError,
-            self.assertListRaises, _TestException, success_generator)
-
 
 @symbol_versioning.deprecated_function(zero_eleven)
 def sample_deprecated_function():
@@ -1628,22 +1525,6 @@
         self.callDeprecated([], testfunc, be_deprecated=False)
 
 
-class TestWarningTests(TestCase):
-    """Tests for calling methods that raise warnings."""
-
-    def test_callCatchWarnings(self):
-        def meth(a, b):
-            warnings.warn("this is your last warning")
-            return a + b
-        wlist, result = self.callCatchWarnings(meth, 1, 2)
-        self.assertEquals(3, result)
-        # would like just to compare them, but UserWarning doesn't implement
-        # eq well
-        w0, = wlist
-        self.assertIsInstance(w0, UserWarning)
-        self.assertEquals("this is your last warning", str(w0))
-
-
 class TestConvenienceMakers(TestCaseWithTransport):
     """Test for the make_* convenience functions."""
 
@@ -1763,149 +1644,20 @@
         self.loader = TestUtil.TestLoader()
         self.suite.addTest(self.loader.loadTestsFromModuleNames([
             'bzrlib.tests.test_selftest']))
-        self.all_names = _test_ids(self.suite)
-
-    def test_condition_id_re(self):
-        test_name = ('bzrlib.tests.test_selftest.TestSelftestFiltering.'
-            'test_condition_id_re')
-        filtered_suite = filter_suite_by_condition(self.suite,
-            condition_id_re('test_condition_id_re'))
-        self.assertEqual([test_name], _test_ids(filtered_suite))
-
-    def test_condition_id_in_list(self):
-        test_names = ['bzrlib.tests.test_selftest.TestSelftestFiltering.'
-                      'test_condition_id_in_list']
-        id_list = tests.TestIdList(test_names)
-        filtered_suite = filter_suite_by_condition(
-            self.suite, tests.condition_id_in_list(id_list))
-        my_pattern = 'TestSelftestFiltering.*test_condition_id_in_list'
-        re_filtered = filter_suite_by_re(self.suite, my_pattern)
-        self.assertEqual(_test_ids(re_filtered), _test_ids(filtered_suite))
-
-    def test_condition_id_startswith(self):
-        klass = 'bzrlib.tests.test_selftest.TestSelftestFiltering.'
-        start1 = klass + 'test_condition_id_starts'
-        start2 = klass + 'test_condition_id_in'
-        test_names = [ klass + 'test_condition_id_in_list',
-                      klass + 'test_condition_id_startswith',
-                     ]
-        filtered_suite = filter_suite_by_condition(
-            self.suite, tests.condition_id_startswith([start1, start2]))
-        self.assertEqual(test_names, _test_ids(filtered_suite))
-
-    def test_condition_isinstance(self):
-        filtered_suite = filter_suite_by_condition(self.suite,
-            condition_isinstance(self.__class__))
-        class_pattern = 'bzrlib.tests.test_selftest.TestSelftestFiltering.'
-        re_filtered = filter_suite_by_re(self.suite, class_pattern)
-        self.assertEqual(_test_ids(re_filtered), _test_ids(filtered_suite))
-
-    def test_exclude_tests_by_condition(self):
-        excluded_name = ('bzrlib.tests.test_selftest.TestSelftestFiltering.'
-            'test_exclude_tests_by_condition')
-        filtered_suite = exclude_tests_by_condition(self.suite,
-            lambda x:x.id() == excluded_name)
-        self.assertEqual(len(self.all_names) - 1,
-            filtered_suite.countTestCases())
-        self.assertFalse(excluded_name in _test_ids(filtered_suite))
-        remaining_names = list(self.all_names)
-        remaining_names.remove(excluded_name)
-        self.assertEqual(remaining_names, _test_ids(filtered_suite))
-
-    def test_exclude_tests_by_re(self):
-        self.all_names = _test_ids(self.suite)
-        filtered_suite = exclude_tests_by_re(self.suite, 'exclude_tests_by_re')
-        excluded_name = ('bzrlib.tests.test_selftest.TestSelftestFiltering.'
-            'test_exclude_tests_by_re')
-        self.assertEqual(len(self.all_names) - 1,
-            filtered_suite.countTestCases())
-        self.assertFalse(excluded_name in _test_ids(filtered_suite))
-        remaining_names = list(self.all_names)
-        remaining_names.remove(excluded_name)
-        self.assertEqual(remaining_names, _test_ids(filtered_suite))
-
-    def test_filter_suite_by_condition(self):
-        test_name = ('bzrlib.tests.test_selftest.TestSelftestFiltering.'
-            'test_filter_suite_by_condition')
-        filtered_suite = filter_suite_by_condition(self.suite,
-            lambda x:x.id() == test_name)
-        self.assertEqual([test_name], _test_ids(filtered_suite))
+        self.all_names = [t.id() for t in iter_suite_tests(self.suite)]
 
     def test_filter_suite_by_re(self):
-        filtered_suite = filter_suite_by_re(self.suite, 'test_filter_suite_by_r')
-        filtered_names = _test_ids(filtered_suite)
+        filtered_suite = filter_suite_by_re(self.suite, 'test_filter')
+        filtered_names = [t.id() for t in iter_suite_tests(filtered_suite)]
         self.assertEqual(filtered_names, ['bzrlib.tests.test_selftest.'
             'TestSelftestFiltering.test_filter_suite_by_re'])
-
-    def test_filter_suite_by_id_list(self):
-        test_list = ['bzrlib.tests.test_selftest.'
-                     'TestSelftestFiltering.test_filter_suite_by_id_list']
-        filtered_suite = tests.filter_suite_by_id_list(
-            self.suite, tests.TestIdList(test_list))
-        filtered_names = _test_ids(filtered_suite)
-        self.assertEqual(
-            filtered_names,
-            ['bzrlib.tests.test_selftest.'
-             'TestSelftestFiltering.test_filter_suite_by_id_list'])
-
-    def test_filter_suite_by_id_startswith(self):
-        # By design this test may fail if another test is added whose name also
-        # begins with one of the start value used.
-        klass = 'bzrlib.tests.test_selftest.TestSelftestFiltering.'
-        start1 = klass + 'test_filter_suite_by_id_starts'
-        start2 = klass + 'test_filter_suite_by_id_li'
-        test_list = [klass + 'test_filter_suite_by_id_list',
-                     klass + 'test_filter_suite_by_id_startswith',
-                     ]
-        filtered_suite = tests.filter_suite_by_id_startswith(
-            self.suite, [start1, start2])
-        self.assertEqual(
-            test_list,
-            _test_ids(filtered_suite),
-            )
-
-    def test_preserve_input(self):
-        # NB: Surely this is something in the stdlib to do this?
-        self.assertTrue(self.suite is preserve_input(self.suite))
-        self.assertTrue("@#$" is preserve_input("@#$"))
-
-    def test_randomize_suite(self):
-        randomized_suite = randomize_suite(self.suite)
-        # randomizing should not add or remove test names.
-        self.assertEqual(set(_test_ids(self.suite)),
-                         set(_test_ids(randomized_suite)))
-        # Technically, this *can* fail, because random.shuffle(list) can be
-        # equal to list. Trying multiple times just pushes the frequency back.
-        # As its len(self.all_names)!:1, the failure frequency should be low
-        # enough to ignore. RBC 20071021.
-        # It should change the order.
-        self.assertNotEqual(self.all_names, _test_ids(randomized_suite))
-        # But not the length. (Possibly redundant with the set test, but not
-        # necessarily.)
-        self.assertEqual(len(self.all_names), len(_test_ids(randomized_suite)))
-
-    def test_split_suit_by_condition(self):
-        self.all_names = _test_ids(self.suite)
-        condition = condition_id_re('test_filter_suite_by_r')
-        split_suite = split_suite_by_condition(self.suite, condition)
-        filtered_name = ('bzrlib.tests.test_selftest.TestSelftestFiltering.'
-            'test_filter_suite_by_re')
-        self.assertEqual([filtered_name], _test_ids(split_suite[0]))
-        self.assertFalse(filtered_name in _test_ids(split_suite[1]))
-        remaining_names = list(self.all_names)
-        remaining_names.remove(filtered_name)
-        self.assertEqual(remaining_names, _test_ids(split_suite[1]))
-
-    def test_split_suit_by_re(self):
-        self.all_names = _test_ids(self.suite)
-        split_suite = split_suite_by_re(self.suite, 'test_filter_suite_by_r')
-        filtered_name = ('bzrlib.tests.test_selftest.TestSelftestFiltering.'
-            'test_filter_suite_by_re')
-        self.assertEqual([filtered_name], _test_ids(split_suite[0]))
-        self.assertFalse(filtered_name in _test_ids(split_suite[1]))
-        remaining_names = list(self.all_names)
-        remaining_names.remove(filtered_name)
-        self.assertEqual(remaining_names, _test_ids(split_suite[1]))
+            
+    def test_sort_suite_by_re(self):
+        sorted_suite = sort_suite_by_re(self.suite, 'test_filter')
+        sorted_names = [t.id() for t in iter_suite_tests(sorted_suite)]
+        self.assertEqual(sorted_names[0], 'bzrlib.tests.test_selftest.'
+            'TestSelftestFiltering.test_filter_suite_by_re')
+        self.assertEquals(sorted(self.all_names), sorted(sorted_names))
 
 
 class TestCheckInventoryShape(TestCaseWithTransport):
@@ -1945,275 +1697,4 @@
         # code.
         out, err = self.run_bzr(["log", "/nonexistantpath"], retcode=3)
         self.assertEqual(out, '')
-        self.assertContainsRe(err,
-            'bzr: ERROR: Not a branch: ".*nonexistantpath/".\n')
-
-
-class TestTestLoader(TestCase):
-    """Tests for the test loader."""
-
-    def _get_loader_and_module(self):
-        """Gets a TestLoader and a module with one test in it."""
-        loader = TestUtil.TestLoader()
-        module = {}
-        class Stub(TestCase):
-            def test_foo(self):
-                pass
-        class MyModule(object):
-            pass
-        MyModule.a_class = Stub
-        module = MyModule()
-        return loader, module
-
-    def test_module_no_load_tests_attribute_loads_classes(self):
-        loader, module = self._get_loader_and_module()
-        self.assertEqual(1, loader.loadTestsFromModule(module).countTestCases())
-
-    def test_module_load_tests_attribute_gets_called(self):
-        loader, module = self._get_loader_and_module()
-        # 'self' is here because we're faking the module with a class. Regular
-        # load_tests do not need that :)
-        def load_tests(self, standard_tests, module, loader):
-            result = loader.suiteClass()
-            for test in iter_suite_tests(standard_tests):
-                result.addTests([test, test])
-            return result
-        # add a load_tests() method which multiplies the tests from the module.
-        module.__class__.load_tests = load_tests
-        self.assertEqual(2, loader.loadTestsFromModule(module).countTestCases())
-
-    def test_load_tests_from_module_name_smoke_test(self):
-        loader = TestUtil.TestLoader()
-        suite = loader.loadTestsFromModuleName('bzrlib.tests.test_sampler')
-        self.assertEquals(['bzrlib.tests.test_sampler.DemoTest.test_nothing'],
-                          _test_ids(suite))
-
-    def test_load_tests_from_module_name_with_bogus_module_name(self):
-        loader = TestUtil.TestLoader()
-        self.assertRaises(ImportError, loader.loadTestsFromModuleName, 'bogus')
-
-
-class TestTestIdList(tests.TestCase):
-
-    def _create_id_list(self, test_list):
-        return tests.TestIdList(test_list)
-
-    def _create_suite(self, test_id_list):
-
-        class Stub(TestCase):
-            def test_foo(self):
-                pass
-
-        def _create_test_id(id):
-            return lambda: id
-
-        suite = TestUtil.TestSuite()
-        for id in test_id_list:
-            t  = Stub('test_foo')
-            t.id = _create_test_id(id)
-            suite.addTest(t)
-        return suite
-
-    def _test_ids(self, test_suite):
-        """Get the ids for the tests in a test suite."""
-        return [t.id() for t in iter_suite_tests(test_suite)]
-
-    def test_empty_list(self):
-        id_list = self._create_id_list([])
-        self.assertEquals({}, id_list.tests)
-        self.assertEquals({}, id_list.modules)
-
-    def test_valid_list(self):
-        id_list = self._create_id_list(
-            ['mod1.cl1.meth1', 'mod1.cl1.meth2',
-             'mod1.func1', 'mod1.cl2.meth2',
-             'mod1.submod1',
-             'mod1.submod2.cl1.meth1', 'mod1.submod2.cl2.meth2',
-             ])
-        self.assertTrue(id_list.refers_to('mod1'))
-        self.assertTrue(id_list.refers_to('mod1.submod1'))
-        self.assertTrue(id_list.refers_to('mod1.submod2'))
-        self.assertTrue(id_list.includes('mod1.cl1.meth1'))
-        self.assertTrue(id_list.includes('mod1.submod1'))
-        self.assertTrue(id_list.includes('mod1.func1'))
-
-    def test_bad_chars_in_params(self):
-        id_list = self._create_id_list(['mod1.cl1.meth1(xx.yy)'])
-        self.assertTrue(id_list.refers_to('mod1'))
-        self.assertTrue(id_list.includes('mod1.cl1.meth1(xx.yy)'))
-
-    def test_module_used(self):
-        id_list = self._create_id_list(['mod.class.meth'])
-        self.assertTrue(id_list.refers_to('mod'))
-        self.assertTrue(id_list.refers_to('mod.class'))
-        self.assertTrue(id_list.refers_to('mod.class.meth'))
-
-    def test_test_suite(self):
-        # This test is slow, so we do a single test with one test in each
-        # category
-        test_list = [
-            # testmod_names
-            'bzrlib.tests.blackbox.test_branch.TestBranch.test_branch',
-            'bzrlib.tests.test_selftest.TestTestIdList.test_test_suite',
-            # transport implementations
-            'bzrlib.tests.test_transport_implementations.TransportTests'
-            '.test_abspath(LocalURLServer)',
-            # modules_to_doctest
-            'bzrlib.timestamp.format_highres_date',
-            # plugins can't be tested that way since selftest may be run with
-            # --no-plugins
-            ]
-        suite = tests.test_suite(test_list)
-        self.assertEquals(test_list, _test_ids(suite))
-
-    def test_test_suite_matches_id_list_with_unknown(self):
-        loader = TestUtil.TestLoader()
-        suite = loader.loadTestsFromModuleName('bzrlib.tests.test_sampler')
-        test_list = ['bzrlib.tests.test_sampler.DemoTest.test_nothing',
-                     'bogus']
-        not_found, duplicates = tests.suite_matches_id_list(suite, test_list)
-        self.assertEquals(['bogus'], not_found)
-        self.assertEquals([], duplicates)
-
-    def test_suite_matches_id_list_with_duplicates(self):
-        loader = TestUtil.TestLoader()
-        suite = loader.loadTestsFromModuleName('bzrlib.tests.test_sampler')
-        dupes = loader.suiteClass()
-        for test in iter_suite_tests(suite):
-            dupes.addTest(test)
-            dupes.addTest(test) # Add it again
-
-        test_list = ['bzrlib.tests.test_sampler.DemoTest.test_nothing',]
-        not_found, duplicates = tests.suite_matches_id_list(
-            dupes, test_list)
-        self.assertEquals([], not_found)
-        self.assertEquals(['bzrlib.tests.test_sampler.DemoTest.test_nothing'],
-                          duplicates)
-
-
-class TestLoadTestIdList(tests.TestCaseInTempDir):
-
-    def _create_test_list_file(self, file_name, content):
-        fl = open(file_name, 'wt')
-        fl.write(content)
-        fl.close()
-
-    def test_load_unknown(self):
-        self.assertRaises(errors.NoSuchFile,
-                          tests.load_test_id_list, 'i_do_not_exist')
-
-    def test_load_test_list(self):
-        test_list_fname = 'test.list'
-        self._create_test_list_file(test_list_fname,
-                                    'mod1.cl1.meth1\nmod2.cl2.meth2\n')
-        tlist = tests.load_test_id_list(test_list_fname)
-        self.assertEquals(2, len(tlist))
-        self.assertEquals('mod1.cl1.meth1', tlist[0])
-        self.assertEquals('mod2.cl2.meth2', tlist[1])
-
-    def test_load_dirty_file(self):
-        test_list_fname = 'test.list'
-        self._create_test_list_file(test_list_fname,
-                                    '  mod1.cl1.meth1\n\nmod2.cl2.meth2  \n'
-                                    'bar baz\n')
-        tlist = tests.load_test_id_list(test_list_fname)
-        self.assertEquals(4, len(tlist))
-        self.assertEquals('mod1.cl1.meth1', tlist[0])
-        self.assertEquals('', tlist[1])
-        self.assertEquals('mod2.cl2.meth2', tlist[2])
-        self.assertEquals('bar baz', tlist[3])
-
-
-class TestFilteredByModuleTestLoader(tests.TestCase):
-
-    def _create_loader(self, test_list):
-        id_filter = tests.TestIdList(test_list)
-        loader = TestUtil.FilteredByModuleTestLoader(id_filter.refers_to)
-        return loader
-
-    def test_load_tests(self):
-        test_list = ['bzrlib.tests.test_sampler.DemoTest.test_nothing']
-        loader = self._create_loader(test_list)
-
-        suite = loader.loadTestsFromModuleName('bzrlib.tests.test_sampler')
-        self.assertEquals(test_list, _test_ids(suite))
-
-    def test_exclude_tests(self):
-        test_list = ['bogus']
-        loader = self._create_loader(test_list)
-
-        suite = loader.loadTestsFromModuleName('bzrlib.tests.test_sampler')
-        self.assertEquals([], _test_ids(suite))
-
-
-class TestFilteredByNameStartTestLoader(tests.TestCase):
-
-    def _create_loader(self, name_start):
-        def needs_module(name):
-            return name.startswith(name_start) or name_start.startswith(name)
-        loader = TestUtil.FilteredByModuleTestLoader(needs_module)
-        return loader
-
-    def test_load_tests(self):
-        test_list = ['bzrlib.tests.test_sampler.DemoTest.test_nothing']
-        loader = self._create_loader('bzrlib.tests.test_samp')
-
-        suite = loader.loadTestsFromModuleName('bzrlib.tests.test_sampler')
-        self.assertEquals(test_list, _test_ids(suite))
-
-    def test_load_tests_inside_module(self):
-        test_list = ['bzrlib.tests.test_sampler.DemoTest.test_nothing']
-        loader = self._create_loader('bzrlib.tests.test_sampler.Demo')
-
-        suite = loader.loadTestsFromModuleName('bzrlib.tests.test_sampler')
-        self.assertEquals(test_list, _test_ids(suite))
-
-    def test_exclude_tests(self):
-        test_list = ['bogus']
-        loader = self._create_loader('bogus')
-
-        suite = loader.loadTestsFromModuleName('bzrlib.tests.test_sampler')
-        self.assertEquals([], _test_ids(suite))
-
-
-class TestTestPrefixRegistry(tests.TestCase):
-
-    def _get_registry(self):
-        tp_registry = tests.TestPrefixAliasRegistry()
-        return tp_registry
-
-    def test_register_new_prefix(self):
-        tpr = self._get_registry()
-        tpr.register('foo', 'fff.ooo.ooo')
-        self.assertEquals('fff.ooo.ooo', tpr.get('foo'))
-
-    def test_register_existing_prefix(self):
-        tpr = self._get_registry()
-        tpr.register('bar', 'bbb.aaa.rrr')
-        tpr.register('bar', 'bBB.aAA.rRR')
-        self.assertEquals('bbb.aaa.rrr', tpr.get('bar'))
-        self.assertContainsRe(self._get_log(keep_log_file=True),
-                              r'.*bar.*bbb.aaa.rrr.*bBB.aAA.rRR')
-
-    def test_get_unknown_prefix(self):
-        tpr = self._get_registry()
-        self.assertRaises(KeyError, tpr.get, 'I am not a prefix')
-
-    def test_resolve_prefix(self):
-        tpr = self._get_registry()
-        tpr.register('bar', 'bb.aa.rr')
-        self.assertEquals('bb.aa.rr', tpr.resolve_alias('bar'))
-
-    def test_resolve_unknown_alias(self):
-        tpr = self._get_registry()
-        self.assertRaises(errors.BzrCommandError,
-                          tpr.resolve_alias, 'I am not a prefix')
-
-    def test_predefined_prefixes(self):
-        tpr = tests.test_prefix_alias_registry
-        self.assertEquals('bzrlib', tpr.resolve_alias('bzrlib'))
-        self.assertEquals('bzrlib.doc', tpr.resolve_alias('bd'))
-        self.assertEquals('bzrlib.utils', tpr.resolve_alias('bu'))
-        self.assertEquals('bzrlib.tests', tpr.resolve_alias('bt'))
-        self.assertEquals('bzrlib.tests.blackbox', tpr.resolve_alias('bb'))
-        self.assertEquals('bzrlib.plugins', tpr.resolve_alias('bp'))
+        self.assertEqual(err, 'bzr: ERROR: Not a branch: "/nonexistantpath/".\n')

=== modified file 'bzrlib/tests/test_setup.py'
--- bzrlib/tests/test_setup.py	2008-08-26 08:25:27 +0000
+++ bzrlib/tests/test_setup.py	2006-10-11 23:08:27 +0000
@@ -20,6 +20,7 @@
 import sys
 import subprocess
 import shutil
+import tempfile
 from tempfile import TemporaryFile
 
 import bzrlib
@@ -55,7 +56,7 @@
             raise TestSkipped('You must have distutils installed to run this test.'
                               ' Usually this can be found by installing "python-dev"')
         self.log('test_build running in %s' % os.getcwd())
-        install_dir = osutils.mkdtemp()
+        install_dir = tempfile.mkdtemp()
         # setup.py must be run from the root source directory, but the tests
         # are not necessarily invoked from there
         self.source_dir = os.path.dirname(os.path.dirname(bzrlib.__file__))

=== modified file 'bzrlib/tests/test_sftp_transport.py'
--- bzrlib/tests/test_sftp_transport.py	2007-12-11 14:26:18 +0000
+++ bzrlib/tests/test_sftp_transport.py	2007-09-24 09:40:01 +0000
@@ -41,7 +41,7 @@
     TestCase,
     TestSkipped,
     )
-from bzrlib.tests.http_server import HttpServer
+from bzrlib.tests.HttpServer import HttpServer
 from bzrlib.transport import get_transport
 import bzrlib.transport.http
 

=== modified file 'bzrlib/tests/test_smart.py'
--- bzrlib/tests/test_smart.py	2008-07-25 06:42:08 +0000
+++ bzrlib/tests/test_smart.py	2007-10-12 05:26:46 +0000
@@ -14,88 +14,20 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-"""Tests for the smart wire/domain protocol.
-
-This module contains tests for the domain-level smart requests and responses,
-such as the 'Branch.lock_write' request. Many of these use specific disk
-formats to exercise calls that only make sense for formats with specific
-properties.
-
-Tests for low-level protocol encoding are found in test_smart_transport.
-"""
-
-import bz2
-from cStringIO import StringIO
+"""Tests for the smart wire/domain protocol."""
+
+from StringIO import StringIO
+import tempfile
 import tarfile
 
-from bzrlib import (
-    bzrdir,
-    errors,
-    pack,
-    smart,
-    tests,
-    urlutils,
-    )
-from bzrlib.branch import Branch, BranchReferenceFormat
+from bzrlib import bzrdir, errors, pack, smart, tests
+from bzrlib.smart.request import SmartServerResponse
+import bzrlib.smart.bzrdir
 import bzrlib.smart.branch
-import bzrlib.smart.bzrdir
 import bzrlib.smart.repository
-from bzrlib.smart.request import (
-    FailedSmartServerResponse,
-    SmartServerRequest,
-    SmartServerResponse,
-    SuccessfulSmartServerResponse,
-    )
-from bzrlib.tests import (
-    iter_suite_tests,
-    split_suite_by_re,
-    TestScenarioApplier,
-    )
-from bzrlib.transport import chroot, get_transport
 from bzrlib.util import bencode
 
 
-def load_tests(standard_tests, module, loader):
-    """Multiply tests version and protocol consistency."""
-    # FindRepository tests.
-    bzrdir_mod = bzrlib.smart.bzrdir
-    applier = TestScenarioApplier()
-    applier.scenarios = [
-        ("find_repository", {
-            "_request_class":bzrdir_mod.SmartServerRequestFindRepositoryV1}),
-        ("find_repositoryV2", {
-            "_request_class":bzrdir_mod.SmartServerRequestFindRepositoryV2}),
-        ]
-    to_adapt, result = split_suite_by_re(standard_tests,
-        "TestSmartServerRequestFindRepository")
-    v2_only, v1_and_2 = split_suite_by_re(to_adapt,
-        "_v2")
-    for test in iter_suite_tests(v1_and_2):
-        result.addTests(applier.adapt(test))
-    del applier.scenarios[0]
-    for test in iter_suite_tests(v2_only):
-        result.addTests(applier.adapt(test))
-    return result
-
-
-class TestCaseWithChrootedTransport(tests.TestCaseWithTransport):
-
-    def setUp(self):
-        tests.TestCaseWithTransport.setUp(self)
-        self._chroot_server = None
-
-    def get_transport(self, relpath=None):
-        if self._chroot_server is None:
-            backing_transport = tests.TestCaseWithTransport.get_transport(self)
-            self._chroot_server = chroot.ChrootServer(backing_transport)
-            self._chroot_server.setUp()
-            self.addCleanup(self._chroot_server.tearDown)
-        t = get_transport(self._chroot_server.get_url())
-        if relpath is not None:
-            t = t.clone(relpath)
-        return t
-
-
 class TestCaseWithSmartMedium(tests.TestCaseWithTransport):
 
     def setUp(self):
@@ -104,10 +36,7 @@
         # the default or a parameterized class, but rather use the
         # TestCaseWithTransport infrastructure to set up a smart server and
         # transport.
-        self.transport_server = self.make_transport_server
-
-    def make_transport_server(self):
-        return smart.server.SmartTCPServer_for_testing('-' + self.id())
+        self.transport_server = smart.server.SmartTCPServer_for_testing
 
     def get_smart_medium(self):
         """Get a smart medium to use in tests."""
@@ -128,60 +57,29 @@
         self.assertNotEqual(None,
             SmartServerResponse(('ok', )))
 
-    def test__str__(self):
-        """SmartServerResponses can be stringified."""
-        self.assertEqual(
-            "<SmartServerResponse status=OK args=('args',) body='body'>",
-            str(SuccessfulSmartServerResponse(('args',), 'body')))
-        self.assertEqual(
-            "<SmartServerResponse status=ERR args=('args',) body='body'>",
-            str(FailedSmartServerResponse(('args',), 'body')))
-
-
-class TestSmartServerRequest(tests.TestCaseWithMemoryTransport):
-
-    def test_translate_client_path(self):
-        transport = self.get_transport()
-        request = SmartServerRequest(transport, 'foo/')
-        self.assertEqual('./', request.translate_client_path('foo/'))
-        self.assertRaises(
-            errors.InvalidURLJoin, request.translate_client_path, 'foo/..')
-        self.assertRaises(
-            errors.PathNotChild, request.translate_client_path, '/')
-        self.assertRaises(
-            errors.PathNotChild, request.translate_client_path, 'bar/')
-        self.assertEqual('./baz', request.translate_client_path('foo/baz'))
-
-    def test_transport_from_client_path(self):
-        transport = self.get_transport()
-        request = SmartServerRequest(transport, 'foo/')
-        self.assertEqual(
-            transport.base,
-            request.transport_from_client_path('foo/').base)
-
-
-class TestSmartServerRequestFindRepository(tests.TestCaseWithMemoryTransport):
+
+class TestSmartServerRequestFindRepository(tests.TestCaseWithTransport):
     """Tests for BzrDir.find_repository."""
 
     def test_no_repository(self):
         """When there is no repository to be found, ('norepository', ) is returned."""
         backing = self.get_transport()
-        request = self._request_class(backing)
+        request = smart.bzrdir.SmartServerRequestFindRepository(backing)
         self.make_bzrdir('.')
         self.assertEqual(SmartServerResponse(('norepository', )),
-            request.execute(''))
+            request.execute(backing.local_abspath('')))
 
     def test_nonshared_repository(self):
         # nonshared repositorys only allow 'find' to return a handle when the 
         # path the repository is being searched on is the same as that that 
         # the repository is at.
         backing = self.get_transport()
-        request = self._request_class(backing)
+        request = smart.bzrdir.SmartServerRequestFindRepository(backing)
         result = self._make_repository_and_result()
-        self.assertEqual(result, request.execute(''))
+        self.assertEqual(result, request.execute(backing.local_abspath('')))
         self.make_bzrdir('subdir')
         self.assertEqual(SmartServerResponse(('norepository', )),
-            request.execute('subdir'))
+            request.execute(backing.local_abspath('subdir')))
 
     def _make_repository_and_result(self, shared=False, format=None):
         """Convenience function to setup a repository.
@@ -197,58 +95,42 @@
             subtrees = 'yes'
         else:
             subtrees = 'no'
-        if (smart.bzrdir.SmartServerRequestFindRepositoryV2 ==
-            self._request_class):
-            # All tests so far are on formats, and for non-external
-            # repositories.
-            return SuccessfulSmartServerResponse(
-                ('ok', '', rich_root, subtrees, 'no'))
-        else:
-            return SuccessfulSmartServerResponse(('ok', '', rich_root, subtrees))
+        return SmartServerResponse(('ok', '', rich_root, subtrees))
 
     def test_shared_repository(self):
         """When there is a shared repository, we get 'ok', 'relpath-to-repo'."""
         backing = self.get_transport()
-        request = self._request_class(backing)
+        request = smart.bzrdir.SmartServerRequestFindRepository(backing)
         result = self._make_repository_and_result(shared=True)
-        self.assertEqual(result, request.execute(''))
+        self.assertEqual(result, request.execute(backing.local_abspath('')))
         self.make_bzrdir('subdir')
         result2 = SmartServerResponse(result.args[0:1] + ('..', ) + result.args[2:])
         self.assertEqual(result2,
-            request.execute('subdir'))
+            request.execute(backing.local_abspath('subdir')))
         self.make_bzrdir('subdir/deeper')
         result3 = SmartServerResponse(result.args[0:1] + ('../..', ) + result.args[2:])
         self.assertEqual(result3,
-            request.execute('subdir/deeper'))
+            request.execute(backing.local_abspath('subdir/deeper')))
 
     def test_rich_root_and_subtree_encoding(self):
         """Test for the format attributes for rich root and subtree support."""
         backing = self.get_transport()
-        request = self._request_class(backing)
+        request = smart.bzrdir.SmartServerRequestFindRepository(backing)
         result = self._make_repository_and_result(format='dirstate-with-subtree')
         # check the test will be valid
         self.assertEqual('yes', result.args[2])
         self.assertEqual('yes', result.args[3])
-        self.assertEqual(result, request.execute(''))
-
-    def test_supports_external_lookups_no_v2(self):
-        """Test for the supports_external_lookups attribute."""
-        backing = self.get_transport()
-        request = self._request_class(backing)
-        result = self._make_repository_and_result(format='dirstate-with-subtree')
-        # check the test will be valid
-        self.assertEqual('no', result.args[4])
-        self.assertEqual(result, request.execute(''))
-
-
-class TestSmartServerRequestInitializeBzrDir(tests.TestCaseWithMemoryTransport):
+        self.assertEqual(result, request.execute(backing.local_abspath('')))
+
+
+class TestSmartServerRequestInitializeBzrDir(tests.TestCaseWithTransport):
 
     def test_empty_dir(self):
         """Initializing an empty dir should succeed and do it."""
         backing = self.get_transport()
         request = smart.bzrdir.SmartServerRequestInitializeBzrDir(backing)
         self.assertEqual(SmartServerResponse(('ok', )),
-            request.execute(''))
+            request.execute(backing.local_abspath('.')))
         made_dir = bzrdir.BzrDir.open_from_transport(backing)
         # no branch, tree or repository is expected with the current 
         # default formart.
@@ -261,7 +143,7 @@
         backing = self.get_transport()
         request = smart.bzrdir.SmartServerRequestInitializeBzrDir(backing)
         self.assertRaises(errors.NoSuchFile,
-            request.execute, 'subdir')
+            request.execute, backing.local_abspath('subdir'))
 
     def test_initialized_dir(self):
         """Initializing an extant bzrdir should fail like the bzrdir api."""
@@ -269,10 +151,10 @@
         request = smart.bzrdir.SmartServerRequestInitializeBzrDir(backing)
         self.make_bzrdir('subdir')
         self.assertRaises(errors.FileExists,
-            request.execute, 'subdir')
-
-
-class TestSmartServerRequestOpenBranch(TestCaseWithChrootedTransport):
+            request.execute, backing.local_abspath('subdir'))
+
+
+class TestSmartServerRequestOpenBranch(tests.TestCaseWithTransport):
 
     def test_no_branch(self):
         """When there is no branch, ('nobranch', ) is returned."""
@@ -280,7 +162,7 @@
         request = smart.bzrdir.SmartServerRequestOpenBranch(backing)
         self.make_bzrdir('.')
         self.assertEqual(SmartServerResponse(('nobranch', )),
-            request.execute(''))
+            request.execute(backing.local_abspath('')))
 
     def test_branch(self):
         """When there is a branch, 'ok' is returned."""
@@ -288,7 +170,7 @@
         request = smart.bzrdir.SmartServerRequestOpenBranch(backing)
         self.make_branch('.')
         self.assertEqual(SmartServerResponse(('ok', '')),
-            request.execute(''))
+            request.execute(backing.local_abspath('')))
 
     def test_branch_reference(self):
         """When there is a branch reference, the reference URL is returned."""
@@ -296,13 +178,15 @@
         request = smart.bzrdir.SmartServerRequestOpenBranch(backing)
         branch = self.make_branch('branch')
         checkout = branch.create_checkout('reference',lightweight=True)
-        reference_url = BranchReferenceFormat().get_reference(checkout.bzrdir)
+        # TODO: once we have an API to probe for references of any sort, we
+        # can use it here.
+        reference_url = backing.abspath('branch') + '/'
         self.assertFileEqual(reference_url, 'reference/.bzr/branch/location')
         self.assertEqual(SmartServerResponse(('ok', reference_url)),
-            request.execute('reference'))
-
-
-class TestSmartServerRequestRevisionHistory(tests.TestCaseWithMemoryTransport):
+            request.execute(backing.local_abspath('reference')))
+
+
+class TestSmartServerRequestRevisionHistory(tests.TestCaseWithTransport):
 
     def test_empty(self):
         """For an empty branch, the body is empty."""
@@ -310,7 +194,7 @@
         request = smart.branch.SmartServerRequestRevisionHistory(backing)
         self.make_branch('.')
         self.assertEqual(SmartServerResponse(('ok', ), ''),
-            request.execute(''))
+            request.execute(backing.local_abspath('')))
 
     def test_not_empty(self):
         """For a non-empty branch, the body is empty."""
@@ -324,10 +208,10 @@
         tree.unlock()
         self.assertEqual(
             SmartServerResponse(('ok', ), ('\x00'.join([r1, r2]))),
-            request.execute(''))
-
-
-class TestSmartServerBranchRequest(tests.TestCaseWithMemoryTransport):
+            request.execute(backing.local_abspath('')))
+
+
+class TestSmartServerBranchRequest(tests.TestCaseWithTransport):
 
     def test_no_branch(self):
         """When there is a bzrdir and no branch, NotBranchError is raised."""
@@ -335,7 +219,7 @@
         request = smart.branch.SmartServerBranchRequest(backing)
         self.make_bzrdir('.')
         self.assertRaises(errors.NotBranchError,
-            request.execute, '')
+            request.execute, backing.local_abspath(''))
 
     def test_branch_reference(self):
         """When there is a branch reference, NotBranchError is raised."""
@@ -344,10 +228,10 @@
         branch = self.make_branch('branch')
         checkout = branch.create_checkout('reference',lightweight=True)
         self.assertRaises(errors.NotBranchError,
-            request.execute, 'checkout')
-
-
-class TestSmartServerBranchRequestLastRevisionInfo(tests.TestCaseWithMemoryTransport):
+            request.execute, backing.local_abspath('checkout'))
+
+
+class TestSmartServerBranchRequestLastRevisionInfo(tests.TestCaseWithTransport):
 
     def test_empty(self):
         """For an empty branch, the result is ('ok', '0', 'null:')."""
@@ -355,7 +239,7 @@
         request = smart.branch.SmartServerBranchRequestLastRevisionInfo(backing)
         self.make_branch('.')
         self.assertEqual(SmartServerResponse(('ok', '0', 'null:')),
-            request.execute(''))
+            request.execute(backing.local_abspath('')))
 
     def test_not_empty(self):
         """For a non-empty branch, the result is ('ok', 'revno', 'revid')."""
@@ -370,10 +254,10 @@
         tree.unlock()
         self.assertEqual(
             SmartServerResponse(('ok', '2', rev_id_utf8)),
-            request.execute(''))
-
-
-class TestSmartServerBranchRequestGetConfigFile(tests.TestCaseWithMemoryTransport):
+            request.execute(backing.local_abspath('')))
+
+
+class TestSmartServerBranchRequestGetConfigFile(tests.TestCaseWithTransport):
 
     def test_default(self):
         """With no file, we get empty content."""
@@ -383,7 +267,7 @@
         # there should be no file by default
         content = ''
         self.assertEqual(SmartServerResponse(('ok', ), content),
-            request.execute(''))
+            request.execute(backing.local_abspath('')))
 
     def test_with_content(self):
         # SmartServerBranchGetConfigFile should return the content from
@@ -392,240 +276,105 @@
         backing = self.get_transport()
         request = smart.branch.SmartServerBranchGetConfigFile(backing)
         branch = self.make_branch('.')
-        branch._transport.put_bytes('branch.conf', 'foo bar baz')
+        branch.control_files.put_utf8('branch.conf', 'foo bar baz')
         self.assertEqual(SmartServerResponse(('ok', ), 'foo bar baz'),
-            request.execute(''))
-
-
-class SetLastRevisionTestBase(tests.TestCaseWithMemoryTransport):
-    """Base test case for verbs that implement set_last_revision."""
-
-    def setUp(self):
-        tests.TestCaseWithMemoryTransport.setUp(self)
-        backing_transport = self.get_transport()
-        self.request = self.request_class(backing_transport)
-        self.tree = self.make_branch_and_memory_tree('.')
-
-    def lock_branch(self):
-        b = self.tree.branch
-        branch_token = b.lock_write()
-        repo_token = b.repository.lock_write()
-        b.repository.unlock()
-        return branch_token, repo_token
-
-    def unlock_branch(self):
-        self.tree.branch.unlock()
-        
-    def set_last_revision(self, revision_id, revno):
-        branch_token, repo_token = self.lock_branch()
-        response = self._set_last_revision(
-            revision_id, revno, branch_token, repo_token)
-        self.unlock_branch()
-        return response
-
-    def assertRequestSucceeds(self, revision_id, revno):
-        response = self.set_last_revision(revision_id, revno)
-        self.assertEqual(SuccessfulSmartServerResponse(('ok',)), response)
-
-        
-class TestSetLastRevisionVerbMixin(object):
-    """Mixin test case for verbs that implement set_last_revision."""
-
-    def test_set_null_to_null(self):
-        """An empty branch can have its last revision set to 'null:'."""
-        self.assertRequestSucceeds('null:', 0)
-
-    def test_NoSuchRevision(self):
-        """If the revision_id is not present, the verb returns NoSuchRevision.
-        """
-        revision_id = 'non-existent revision'
-        self.assertEqual(
-            FailedSmartServerResponse(('NoSuchRevision', revision_id)),
-            self.set_last_revision(revision_id, 1))
-
-    def make_tree_with_two_commits(self):
-        self.tree.lock_write()
-        self.tree.add('')
-        rev_id_utf8 = u'\xc8'.encode('utf-8')
-        r1 = self.tree.commit('1st commit', rev_id=rev_id_utf8)
-        r2 = self.tree.commit('2nd commit', rev_id='rev-2')
-        self.tree.unlock()
-
-    def test_branch_last_revision_info_is_updated(self):
-        """A branch's tip can be set to a revision that is present in its
-        repository.
-        """
-        # Make a branch with an empty revision history, but two revisions in
-        # its repository.
-        self.make_tree_with_two_commits()
-        rev_id_utf8 = u'\xc8'.encode('utf-8')
-        self.tree.branch.set_revision_history([])
-        self.assertEqual(
-            (0, 'null:'), self.tree.branch.last_revision_info())
-        # We can update the branch to a revision that is present in the
-        # repository.
-        self.assertRequestSucceeds(rev_id_utf8, 1)
-        self.assertEqual(
-            (1, rev_id_utf8), self.tree.branch.last_revision_info())
-
-    def test_branch_last_revision_info_rewind(self):
-        """A branch's tip can be set to a revision that is an ancestor of the
-        current tip.
-        """
-        self.make_tree_with_two_commits()
-        rev_id_utf8 = u'\xc8'.encode('utf-8')
-        self.assertEqual(
-            (2, 'rev-2'), self.tree.branch.last_revision_info())
-        self.assertRequestSucceeds(rev_id_utf8, 1)
-        self.assertEqual(
-            (1, rev_id_utf8), self.tree.branch.last_revision_info())
-
-    def test_TipChangeRejected(self):
-        """If a pre_change_branch_tip hook raises TipChangeRejected, the verb
-        returns TipChangeRejected.
-        """
-        rejection_message = u'rejection message\N{INTERROBANG}'
-        def hook_that_rejects(params):
-            raise errors.TipChangeRejected(rejection_message)
-        Branch.hooks.install_named_hook(
-            'pre_change_branch_tip', hook_that_rejects, None)
-        self.assertEqual(
-            FailedSmartServerResponse(
-                ('TipChangeRejected', rejection_message.encode('utf-8'))),
-            self.set_last_revision('null:', 0))
-
-
-class TestSmartServerBranchRequestSetLastRevision(
-        SetLastRevisionTestBase, TestSetLastRevisionVerbMixin):
-    """Tests for Branch.set_last_revision verb."""
-
-    request_class = smart.branch.SmartServerBranchRequestSetLastRevision
-
-    def _set_last_revision(self, revision_id, revno, branch_token, repo_token):
-        return self.request.execute(
-            '', branch_token, repo_token, revision_id)
-
-
-class TestSmartServerBranchRequestSetLastRevisionInfo(
-        SetLastRevisionTestBase, TestSetLastRevisionVerbMixin):
-    """Tests for Branch.set_last_revision_info verb."""
-
-    request_class = smart.branch.SmartServerBranchRequestSetLastRevisionInfo
-
-    def _set_last_revision(self, revision_id, revno, branch_token, repo_token):
-        return self.request.execute(
-            '', branch_token, repo_token, revno, revision_id)
-
-    def test_NoSuchRevision(self):
-        """Branch.set_last_revision_info does not have to return
-        NoSuchRevision if the revision_id is absent.
-        """
-        raise tests.TestNotApplicable()
-
-
-class TestSmartServerBranchRequestSetLastRevisionEx(
-        SetLastRevisionTestBase, TestSetLastRevisionVerbMixin):
-    """Tests for Branch.set_last_revision_ex verb."""
-
-    request_class = smart.branch.SmartServerBranchRequestSetLastRevisionEx
-
-    def _set_last_revision(self, revision_id, revno, branch_token, repo_token):
-        return self.request.execute(
-            '', branch_token, repo_token, revision_id, 0, 0)
-
-    def assertRequestSucceeds(self, revision_id, revno):
-        response = self.set_last_revision(revision_id, revno)
-        self.assertEqual(
-            SuccessfulSmartServerResponse(('ok', revno, revision_id)),
-            response)
-        
-    def test_branch_last_revision_info_rewind(self):
-        """A branch's tip can be set to a revision that is an ancestor of the
-        current tip, but only if allow_overwrite_descendant is passed.
-        """
-        self.make_tree_with_two_commits()
-        rev_id_utf8 = u'\xc8'.encode('utf-8')
-        self.assertEqual(
-            (2, 'rev-2'), self.tree.branch.last_revision_info())
-        # If allow_overwrite_descendant flag is 0, then trying to set the tip
-        # to an older revision ID has no effect.
-        branch_token, repo_token = self.lock_branch()
-        response = self.request.execute(
-            '', branch_token, repo_token, rev_id_utf8, 0, 0)
-        self.assertEqual(
-            SuccessfulSmartServerResponse(('ok', 2, 'rev-2')),
-            response)
-        self.assertEqual(
-            (2, 'rev-2'), self.tree.branch.last_revision_info())
-
-        # If allow_overwrite_descendant flag is 1, then setting the tip to an
-        # ancestor works.
-        response = self.request.execute(
-            '', branch_token, repo_token, rev_id_utf8, 0, 1)
-        self.assertEqual(
-            SuccessfulSmartServerResponse(('ok', 1, rev_id_utf8)),
-            response)
-        self.unlock_branch()
-        self.assertEqual(
-            (1, rev_id_utf8), self.tree.branch.last_revision_info())
-
-    def make_branch_with_divergent_history(self):
-        """Make a branch with divergent history in its repo.
-
-        The branch's tip will be 'child-2', and the repo will also contain
-        'child-1', which diverges from a common base revision.
-        """
-        self.tree.lock_write()
-        self.tree.add('')
-        r1 = self.tree.commit('1st commit')
-        revno_1, revid_1 = self.tree.branch.last_revision_info()
-        r2 = self.tree.commit('2nd commit', rev_id='child-1')
-        # Undo the second commit
-        self.tree.branch.set_last_revision_info(revno_1, revid_1)
-        self.tree.set_parent_ids([revid_1])
-        # Make a new second commit, child-2.  child-2 has diverged from
-        # child-1.
-        new_r2 = self.tree.commit('2nd commit', rev_id='child-2')
-        self.tree.unlock()
-        
-    def test_not_allow_diverged(self):
-        """If allow_diverged is not passed, then setting a divergent history
-        returns a Diverged error.
-        """
-        self.make_branch_with_divergent_history()
-        self.assertEqual(
-            FailedSmartServerResponse(('Diverged',)),
-            self.set_last_revision('child-1', 2))
-        # The branch tip was not changed.
-        self.assertEqual('child-2', self.tree.branch.last_revision())
-
-    def test_allow_diverged(self):
-        """If allow_diverged is passed, then setting a divergent history
-        succeeds.
-        """
-        self.make_branch_with_divergent_history()
-        branch_token, repo_token = self.lock_branch()
-        response = self.request.execute(
-            '', branch_token, repo_token, 'child-1', 1, 0)
-        self.assertEqual(
-            SuccessfulSmartServerResponse(('ok', 2, 'child-1')),
-            response)
-        self.unlock_branch()
-        # The branch tip was changed.
-        self.assertEqual('child-1', self.tree.branch.last_revision())
-
-
-class TestSmartServerBranchRequestLockWrite(tests.TestCaseWithMemoryTransport):
-
-    def setUp(self):
-        tests.TestCaseWithMemoryTransport.setUp(self)
+            request.execute(backing.local_abspath('')))
+
+
+class TestSmartServerBranchRequestSetLastRevision(tests.TestCaseWithTransport):
+
+    def test_empty(self):
+        backing = self.get_transport()
+        request = smart.branch.SmartServerBranchRequestSetLastRevision(backing)
+        b = self.make_branch('.')
+        branch_token = b.lock_write()
+        repo_token = b.repository.lock_write()
+        b.repository.unlock()
+        try:
+            self.assertEqual(SmartServerResponse(('ok',)),
+                request.execute(
+                    backing.local_abspath(''), branch_token, repo_token,
+                    'null:'))
+        finally:
+            b.unlock()
+
+    def test_not_present_revision_id(self):
+        backing = self.get_transport()
+        request = smart.branch.SmartServerBranchRequestSetLastRevision(backing)
+        b = self.make_branch('.')
+        branch_token = b.lock_write()
+        repo_token = b.repository.lock_write()
+        b.repository.unlock()
+        try:
+            revision_id = 'non-existent revision'
+            self.assertEqual(
+                SmartServerResponse(('NoSuchRevision', revision_id)),
+                request.execute(
+                    backing.local_abspath(''), branch_token, repo_token,
+                    revision_id))
+        finally:
+            b.unlock()
+
+    def test_revision_id_present(self):
+        backing = self.get_transport()
+        request = smart.branch.SmartServerBranchRequestSetLastRevision(backing)
+        tree = self.make_branch_and_memory_tree('.')
+        tree.lock_write()
+        tree.add('')
+        rev_id_utf8 = u'\xc8'.encode('utf-8')
+        r1 = tree.commit('1st commit', rev_id=rev_id_utf8)
+        r2 = tree.commit('2nd commit')
+        tree.unlock()
+        branch_token = tree.branch.lock_write()
+        repo_token = tree.branch.repository.lock_write()
+        tree.branch.repository.unlock()
+        try:
+            self.assertEqual(
+                SmartServerResponse(('ok',)),
+                request.execute(
+                    backing.local_abspath(''), branch_token, repo_token,
+                    rev_id_utf8))
+            self.assertEqual([rev_id_utf8], tree.branch.revision_history())
+        finally:
+            tree.branch.unlock()
+
+    def test_revision_id_present2(self):
+        backing = self.get_transport()
+        request = smart.branch.SmartServerBranchRequestSetLastRevision(backing)
+        tree = self.make_branch_and_memory_tree('.')
+        tree.lock_write()
+        tree.add('')
+        rev_id_utf8 = u'\xc8'.encode('utf-8')
+        r1 = tree.commit('1st commit', rev_id=rev_id_utf8)
+        r2 = tree.commit('2nd commit')
+        tree.unlock()
+        tree.branch.set_revision_history([])
+        branch_token = tree.branch.lock_write()
+        repo_token = tree.branch.repository.lock_write()
+        tree.branch.repository.unlock()
+        try:
+            self.assertEqual(
+                SmartServerResponse(('ok',)),
+                request.execute(
+                    backing.local_abspath(''), branch_token, repo_token,
+                    rev_id_utf8))
+            self.assertEqual([rev_id_utf8], tree.branch.revision_history())
+        finally:
+            tree.branch.unlock()
+
+
+class TestSmartServerBranchRequestLockWrite(tests.TestCaseWithTransport):
+
+    def setUp(self):
+        tests.TestCaseWithTransport.setUp(self)
+        self.reduceLockdirTimeout()
 
     def test_lock_write_on_unlocked_branch(self):
         backing = self.get_transport()
         request = smart.branch.SmartServerBranchRequestLockWrite(backing)
-        branch = self.make_branch('.', format='knit')
+        branch = self.make_branch('.')
         repository = branch.repository
-        response = request.execute('')
+        response = request.execute(backing.local_abspath(''))
         branch_nonce = branch.control_files._lock.peek().get('nonce')
         repository_nonce = repository.control_files._lock.peek().get('nonce')
         self.assertEqual(
@@ -643,21 +392,21 @@
         branch.lock_write()
         branch.leave_lock_in_place()
         branch.unlock()
-        response = request.execute('')
+        response = request.execute(backing.local_abspath(''))
         self.assertEqual(
             SmartServerResponse(('LockContention',)), response)
 
     def test_lock_write_with_tokens_on_locked_branch(self):
         backing = self.get_transport()
         request = smart.branch.SmartServerBranchRequestLockWrite(backing)
-        branch = self.make_branch('.', format='knit')
+        branch = self.make_branch('.')
         branch_token = branch.lock_write()
         repo_token = branch.repository.lock_write()
         branch.repository.unlock()
         branch.leave_lock_in_place()
         branch.repository.leave_lock_in_place()
         branch.unlock()
-        response = request.execute('',
+        response = request.execute(backing.local_abspath(''),
                                    branch_token, repo_token)
         self.assertEqual(
             SmartServerResponse(('ok', branch_token, repo_token)), response)
@@ -665,14 +414,14 @@
     def test_lock_write_with_mismatched_tokens_on_locked_branch(self):
         backing = self.get_transport()
         request = smart.branch.SmartServerBranchRequestLockWrite(backing)
-        branch = self.make_branch('.', format='knit')
+        branch = self.make_branch('.')
         branch_token = branch.lock_write()
         repo_token = branch.repository.lock_write()
         branch.repository.unlock()
         branch.leave_lock_in_place()
         branch.repository.leave_lock_in_place()
         branch.unlock()
-        response = request.execute('',
+        response = request.execute(backing.local_abspath(''),
                                    branch_token+'xxx', repo_token)
         self.assertEqual(
             SmartServerResponse(('TokenMismatch',)), response)
@@ -680,11 +429,11 @@
     def test_lock_write_on_locked_repo(self):
         backing = self.get_transport()
         request = smart.branch.SmartServerBranchRequestLockWrite(backing)
-        branch = self.make_branch('.', format='knit')
+        branch = self.make_branch('.')
         branch.repository.lock_write()
         branch.repository.leave_lock_in_place()
         branch.repository.unlock()
-        response = request.execute('')
+        response = request.execute(backing.local_abspath(''))
         self.assertEqual(
             SmartServerResponse(('LockContention',)), response)
 
@@ -692,23 +441,22 @@
         backing = self.get_readonly_transport()
         request = smart.branch.SmartServerBranchRequestLockWrite(backing)
         branch = self.make_branch('.')
-        root = self.get_transport().clone('/')
-        path = urlutils.relative_url(root.base, self.get_transport().base)
-        response = request.execute(path)
+        response = request.execute('')
         error_name, lock_str, why_str = response.args
         self.assertFalse(response.is_successful())
         self.assertEqual('LockFailed', error_name)
 
 
-class TestSmartServerBranchRequestUnlock(tests.TestCaseWithMemoryTransport):
+class TestSmartServerBranchRequestUnlock(tests.TestCaseWithTransport):
 
     def setUp(self):
-        tests.TestCaseWithMemoryTransport.setUp(self)
+        tests.TestCaseWithTransport.setUp(self)
+        self.reduceLockdirTimeout()
 
     def test_unlock_on_locked_branch_and_repo(self):
         backing = self.get_transport()
         request = smart.branch.SmartServerBranchRequestUnlock(backing)
-        branch = self.make_branch('.', format='knit')
+        branch = self.make_branch('.')
         # Lock the branch
         branch_token = branch.lock_write()
         repo_token = branch.repository.lock_write()
@@ -718,7 +466,7 @@
         branch.leave_lock_in_place()
         branch.repository.leave_lock_in_place()
         branch.unlock()
-        response = request.execute('',
+        response = request.execute(backing.local_abspath(''),
                                    branch_token, repo_token)
         self.assertEqual(
             SmartServerResponse(('ok',)), response)
@@ -731,16 +479,16 @@
     def test_unlock_on_unlocked_branch_unlocked_repo(self):
         backing = self.get_transport()
         request = smart.branch.SmartServerBranchRequestUnlock(backing)
-        branch = self.make_branch('.', format='knit')
+        branch = self.make_branch('.')
         response = request.execute(
-            '', 'branch token', 'repo token')
+            backing.local_abspath(''), 'branch token', 'repo token')
         self.assertEqual(
             SmartServerResponse(('TokenMismatch',)), response)
 
     def test_unlock_on_unlocked_branch_locked_repo(self):
         backing = self.get_transport()
         request = smart.branch.SmartServerBranchRequestUnlock(backing)
-        branch = self.make_branch('.', format='knit')
+        branch = self.make_branch('.')
         # Lock the repository.
         repo_token = branch.repository.lock_write()
         branch.repository.leave_lock_in_place()
@@ -748,12 +496,12 @@
         # Issue branch lock_write request on the unlocked branch (with locked
         # repo).
         response = request.execute(
-            '', 'branch token', repo_token)
+            backing.local_abspath(''), 'branch token', repo_token)
         self.assertEqual(
             SmartServerResponse(('TokenMismatch',)), response)
 
 
-class TestSmartServerRepositoryRequest(tests.TestCaseWithMemoryTransport):
+class TestSmartServerRepositoryRequest(tests.TestCaseWithTransport):
 
     def test_no_repository(self):
         """Raise NoRepositoryPresent when there is a bzrdir and no repo."""
@@ -766,26 +514,10 @@
         self.make_repository('.', shared=True)
         self.make_bzrdir('subdir')
         self.assertRaises(errors.NoRepositoryPresent,
-            request.execute, 'subdir')
-
-
-class TestSmartServerRepositoryGetParentMap(tests.TestCaseWithMemoryTransport):
-
-    def test_trivial_bzipped(self):
-        # This tests that the wire encoding is actually bzipped
-        backing = self.get_transport()
-        request = smart.repository.SmartServerRepositoryGetParentMap(backing)
-        tree = self.make_branch_and_memory_tree('.')
-
-        self.assertEqual(None,
-            request.execute('', 'missing-id'))
-        # Note that it returns a body (of '' bzipped).
-        self.assertEqual(
-            SuccessfulSmartServerResponse(('ok', ), bz2.compress('')),
-            request.do_body('\n\n0\n'))
-
-
-class TestSmartServerRepositoryGetRevisionGraph(tests.TestCaseWithMemoryTransport):
+            request.execute, backing.local_abspath('subdir'))
+
+
+class TestSmartServerRepositoryGetRevisionGraph(tests.TestCaseWithTransport):
 
     def test_none_argument(self):
         backing = self.get_transport()
@@ -800,7 +532,7 @@
         # the lines of revision_id->revision_parent_list has no guaranteed
         # order coming out of a dict, so sort both our test and response
         lines = sorted([' '.join([r2, r1]), r1])
-        response = request.execute('', '')
+        response = request.execute(backing.local_abspath(''), '')
         response.body = '\n'.join(sorted(response.body.split('\n')))
 
         self.assertEqual(
@@ -818,7 +550,7 @@
         tree.unlock()
 
         self.assertEqual(SmartServerResponse(('ok', ), rev_id_utf8),
-            request.execute('', rev_id_utf8))
+            request.execute(backing.local_abspath(''), rev_id_utf8))
     
     def test_no_such_revision(self):
         backing = self.get_transport()
@@ -832,10 +564,10 @@
         # Note that it still returns body (of zero bytes).
         self.assertEqual(
             SmartServerResponse(('nosuchrevision', 'missingrevision', ), ''),
-            request.execute('', 'missingrevision'))
-
-
-class TestSmartServerRequestHasRevision(tests.TestCaseWithMemoryTransport):
+            request.execute(backing.local_abspath(''), 'missingrevision'))
+
+
+class TestSmartServerRequestHasRevision(tests.TestCaseWithTransport):
 
     def test_missing_revision(self):
         """For a missing revision, ('no', ) is returned."""
@@ -843,7 +575,7 @@
         request = smart.repository.SmartServerRequestHasRevision(backing)
         self.make_repository('.')
         self.assertEqual(SmartServerResponse(('no', )),
-            request.execute('', 'revid'))
+            request.execute(backing.local_abspath(''), 'revid'))
 
     def test_present_revision(self):
         """For a present revision, ('yes', ) is returned."""
@@ -857,10 +589,10 @@
         tree.unlock()
         self.assertTrue(tree.branch.repository.has_revision(rev_id_utf8))
         self.assertEqual(SmartServerResponse(('yes', )),
-            request.execute('', rev_id_utf8))
-
-
-class TestSmartServerRepositoryGatherStats(tests.TestCaseWithMemoryTransport):
+            request.execute(backing.local_abspath(''), rev_id_utf8))
+
+
+class TestSmartServerRepositoryGatherStats(tests.TestCaseWithTransport):
 
     def test_empty_revid(self):
         """With an empty revid, we get only size an number and revisions"""
@@ -868,9 +600,10 @@
         request = smart.repository.SmartServerRepositoryGatherStats(backing)
         repository = self.make_repository('.')
         stats = repository.gather_stats()
-        expected_body = 'revisions: 0\n'
+        size = stats['size']
+        expected_body = 'revisions: 0\nsize: %d\n' % size
         self.assertEqual(SmartServerResponse(('ok', ), expected_body),
-                         request.execute('', '', 'no'))
+                         request.execute(backing.local_abspath(''), '', 'no'))
 
     def test_revid_with_committers(self):
         """For a revid we get more infos."""
@@ -887,11 +620,13 @@
         tree.unlock()
 
         stats = tree.branch.repository.gather_stats()
+        size = stats['size']
         expected_body = ('firstrev: 123456.200 3600\n'
                          'latestrev: 654321.400 0\n'
-                         'revisions: 2\n')
+                         'revisions: 2\n'
+                         'size: %d\n' % size)
         self.assertEqual(SmartServerResponse(('ok', ), expected_body),
-                         request.execute('',
+                         request.execute(backing.local_abspath(''),
                                          rev_id_utf8, 'no'))
 
     def test_not_empty_repository_with_committers(self):
@@ -910,16 +645,18 @@
         tree.unlock()
         stats = tree.branch.repository.gather_stats()
 
+        size = stats['size']
         expected_body = ('committers: 2\n'
                          'firstrev: 123456.200 3600\n'
                          'latestrev: 654321.400 0\n'
-                         'revisions: 2\n')
+                         'revisions: 2\n'
+                         'size: %d\n' % size)
         self.assertEqual(SmartServerResponse(('ok', ), expected_body),
-                         request.execute('',
+                         request.execute(backing.local_abspath(''),
                                          rev_id_utf8, 'yes'))
 
 
-class TestSmartServerRepositoryIsShared(tests.TestCaseWithMemoryTransport):
+class TestSmartServerRepositoryIsShared(tests.TestCaseWithTransport):
 
     def test_is_shared(self):
         """For a shared repository, ('yes', ) is returned."""
@@ -927,7 +664,7 @@
         request = smart.repository.SmartServerRepositoryIsShared(backing)
         self.make_repository('.', shared=True)
         self.assertEqual(SmartServerResponse(('yes', )),
-            request.execute('', ))
+            request.execute(backing.local_abspath(''), ))
 
     def test_is_not_shared(self):
         """For a shared repository, ('no', ) is returned."""
@@ -935,19 +672,20 @@
         request = smart.repository.SmartServerRepositoryIsShared(backing)
         self.make_repository('.', shared=False)
         self.assertEqual(SmartServerResponse(('no', )),
-            request.execute('', ))
-
-
-class TestSmartServerRepositoryLockWrite(tests.TestCaseWithMemoryTransport):
+            request.execute(backing.local_abspath(''), ))
+
+
+class TestSmartServerRepositoryLockWrite(tests.TestCaseWithTransport):
 
     def setUp(self):
-        tests.TestCaseWithMemoryTransport.setUp(self)
+        tests.TestCaseWithTransport.setUp(self)
+        self.reduceLockdirTimeout()
 
     def test_lock_write_on_unlocked_repo(self):
         backing = self.get_transport()
         request = smart.repository.SmartServerRepositoryLockWrite(backing)
-        repository = self.make_repository('.', format='knit')
-        response = request.execute('')
+        repository = self.make_repository('.')
+        response = request.execute(backing.local_abspath(''))
         nonce = repository.control_files._lock.peek().get('nonce')
         self.assertEqual(SmartServerResponse(('ok', nonce)), response)
         # The repository is now locked.  Verify that with a new repository
@@ -958,36 +696,37 @@
     def test_lock_write_on_locked_repo(self):
         backing = self.get_transport()
         request = smart.repository.SmartServerRepositoryLockWrite(backing)
-        repository = self.make_repository('.', format='knit')
+        repository = self.make_repository('.')
         repository.lock_write()
         repository.leave_lock_in_place()
         repository.unlock()
-        response = request.execute('')
+        response = request.execute(backing.local_abspath(''))
         self.assertEqual(
             SmartServerResponse(('LockContention',)), response)
 
     def test_lock_write_on_readonly_transport(self):
         backing = self.get_readonly_transport()
         request = smart.repository.SmartServerRepositoryLockWrite(backing)
-        repository = self.make_repository('.', format='knit')
+        repository = self.make_repository('.')
         response = request.execute('')
         self.assertFalse(response.is_successful())
         self.assertEqual('LockFailed', response.args[0])
 
 
-class TestSmartServerRepositoryUnlock(tests.TestCaseWithMemoryTransport):
+class TestSmartServerRepositoryUnlock(tests.TestCaseWithTransport):
 
     def setUp(self):
-        tests.TestCaseWithMemoryTransport.setUp(self)
+        tests.TestCaseWithTransport.setUp(self)
+        self.reduceLockdirTimeout()
 
     def test_unlock_on_locked_repo(self):
         backing = self.get_transport()
         request = smart.repository.SmartServerRepositoryUnlock(backing)
-        repository = self.make_repository('.', format='knit')
+        repository = self.make_repository('.')
         token = repository.lock_write()
         repository.leave_lock_in_place()
         repository.unlock()
-        response = request.execute('', token)
+        response = request.execute(backing.local_abspath(''), token)
         self.assertEqual(
             SmartServerResponse(('ok',)), response)
         # The repository is now unlocked.  Verify that with a new repository
@@ -999,13 +738,75 @@
     def test_unlock_on_unlocked_repo(self):
         backing = self.get_transport()
         request = smart.repository.SmartServerRepositoryUnlock(backing)
-        repository = self.make_repository('.', format='knit')
-        response = request.execute('', 'some token')
+        repository = self.make_repository('.')
+        response = request.execute(backing.local_abspath(''), 'some token')
         self.assertEqual(
             SmartServerResponse(('TokenMismatch',)), response)
 
 
-class TestSmartServerIsReadonly(tests.TestCaseWithMemoryTransport):
+class TestSmartServerRepositoryTarball(tests.TestCaseWithTransport):
+
+    def test_repository_tarball(self):
+        backing = self.get_transport()
+        request = smart.repository.SmartServerRepositoryTarball(backing)
+        repository = self.make_repository('.')
+        # make some extraneous junk in the repository directory which should
+        # not be copied
+        self.build_tree(['.bzr/repository/extra-junk'])
+        response = request.execute(backing.local_abspath(''), 'bz2')
+        self.assertEqual(('ok',), response.args)
+        # body should be a tbz2
+        body_file = StringIO(response.body)
+        body_tar = tarfile.open('body_tar.tbz2', fileobj=body_file,
+            mode='r|bz2')
+        # let's make sure there are some key repository components inside it.
+        # the tarfile returns directories with trailing slashes...
+        names = set([n.rstrip('/') for n in body_tar.getnames()])
+        self.assertTrue('.bzr/repository/lock' in names)
+        self.assertTrue('.bzr/repository/format' in names)
+        self.assertTrue('.bzr/repository/extra-junk' not in names,
+            "extraneous file present in tar file")
+
+
+class TestSmartServerRepositoryStreamKnitData(tests.TestCaseWithTransport):
+
+    def test_fetch_revisions(self):
+        backing = self.get_transport()
+        request = smart.repository.SmartServerRepositoryStreamKnitDataForRevisions(backing)
+        tree = self.make_branch_and_memory_tree('.')
+        tree.lock_write()
+        tree.add('')
+        rev_id1_utf8 = u'\xc8'.encode('utf-8')
+        rev_id2_utf8 = u'\xc9'.encode('utf-8')
+        r1 = tree.commit('1st commit', rev_id=rev_id1_utf8)
+        r1 = tree.commit('2nd commit', rev_id=rev_id2_utf8)
+        tree.unlock()
+
+        response = request.execute(backing.local_abspath(''), rev_id2_utf8)
+        self.assertEqual(('ok',), response.args)
+        from cStringIO import StringIO
+        unpacker = pack.ContainerReader(StringIO(response.body))
+        names = []
+        for [name], read_bytes in unpacker.iter_records():
+            names.append(name)
+            bytes = read_bytes(None)
+            # The bytes should be a valid bencoded string.
+            bencode.bdecode(bytes)
+            # XXX: assert that the bencoded knit records have the right
+            # contents?
+        
+    def test_no_such_revision_error(self):
+        backing = self.get_transport()
+        request = smart.repository.SmartServerRepositoryStreamKnitDataForRevisions(backing)
+        repo = self.make_repository('.')
+        rev_id1_utf8 = u'\xc8'.encode('utf-8')
+        response = request.execute(backing.local_abspath(''), rev_id1_utf8)
+        self.assertEqual(
+            SmartServerResponse(('NoSuchRevision', rev_id1_utf8)),
+            response)
+
+
+class TestSmartServerIsReadonly(tests.TestCaseWithTransport):
 
     def test_is_readonly_no(self):
         backing = self.get_transport()
@@ -1025,13 +826,6 @@
 class TestHandlers(tests.TestCase):
     """Tests for the request.request_handlers object."""
 
-    def test_all_registrations_exist(self):
-        """All registered request_handlers can be found."""
-        # If there's a typo in a register_lazy call, this loop will fail with
-        # an AttributeError.
-        for key, item in smart.request.request_handlers.iteritems():
-            pass
-
     def test_registered_methods(self):
         """Test that known methods are registered to the correct object."""
         self.assertEqual(
@@ -1050,17 +844,11 @@
             smart.request.request_handlers.get('Branch.set_last_revision'),
             smart.branch.SmartServerBranchRequestSetLastRevision)
         self.assertEqual(
-            smart.request.request_handlers.get('Branch.set_last_revision_info'),
-            smart.branch.SmartServerBranchRequestSetLastRevisionInfo)
-        self.assertEqual(
             smart.request.request_handlers.get('Branch.unlock'),
             smart.branch.SmartServerBranchRequestUnlock)
         self.assertEqual(
             smart.request.request_handlers.get('BzrDir.find_repository'),
-            smart.bzrdir.SmartServerRequestFindRepositoryV1)
-        self.assertEqual(
-            smart.request.request_handlers.get('BzrDir.find_repositoryV2'),
-            smart.bzrdir.SmartServerRequestFindRepositoryV2)
+            smart.bzrdir.SmartServerRequestFindRepository)
         self.assertEqual(
             smart.request.request_handlers.get('BzrDirFormat.initialize'),
             smart.bzrdir.SmartServerRequestInitializeBzrDir)
@@ -1071,9 +859,6 @@
             smart.request.request_handlers.get('Repository.gather_stats'),
             smart.repository.SmartServerRepositoryGatherStats)
         self.assertEqual(
-            smart.request.request_handlers.get('Repository.get_parent_map'),
-            smart.repository.SmartServerRepositoryGetParentMap)
-        self.assertEqual(
             smart.request.request_handlers.get(
                 'Repository.get_revision_graph'),
             smart.repository.SmartServerRepositoryGetRevisionGraph)
@@ -1087,6 +872,10 @@
             smart.request.request_handlers.get('Repository.lock_write'),
             smart.repository.SmartServerRepositoryLockWrite)
         self.assertEqual(
+            smart.request.request_handlers.get(
+                'Repository.stream_knit_data_for_revisions'),
+            smart.repository.SmartServerRepositoryStreamKnitDataForRevisions)
+        self.assertEqual(
             smart.request.request_handlers.get('Repository.tarball'),
             smart.repository.SmartServerRepositoryTarball)
         self.assertEqual(

=== modified file 'bzrlib/tests/test_smart_transport.py'
--- bzrlib/tests/test_smart_transport.py	2008-08-29 19:32:00 +0000
+++ bzrlib/tests/test_smart_transport.py	2007-10-22 21:19:13 +0000
@@ -21,8 +21,8 @@
 import os
 import socket
 import threading
+import urllib2
 
-import bzrlib
 from bzrlib import (
         bzrdir,
         errors,
@@ -33,12 +33,16 @@
 from bzrlib.smart import (
         client,
         medium,
-        message,
         protocol,
+        request,
         request as _mod_request,
         server,
         vfs,
 )
+from bzrlib.tests.HTTPTestUtil import (
+        HTTPServerWithSmarts,
+        SmartRequestHandler,
+        )
 from bzrlib.tests.test_smart import TestCaseWithSmartMedium
 from bzrlib.transport import (
         get_transport,
@@ -76,30 +80,6 @@
         return self.vendor.read_from, self.vendor.write_to
 
 
-class _InvalidHostnameFeature(tests.Feature):
-    """Does 'non_existent.invalid' fail to resolve?
-    
-    RFC 2606 states that .invalid is reserved for invalid domain names, and
-    also underscores are not a valid character in domain names.  Despite this,
-    it's possible a badly misconfigured name server might decide to always
-    return an address for any name, so this feature allows us to distinguish a
-    broken system from a broken test.
-    """
-
-    def _probe(self):
-        try:
-            socket.gethostbyname('non_existent.invalid')
-        except socket.gaierror:
-            # The host name failed to resolve.  Good.
-            return True
-        else:
-            return False
-
-    def feature_name(self):
-        return 'invalid hostname'
-
-InvalidHostnameFeature = _InvalidHostnameFeature()
-
 
 class SmartClientMediumTests(tests.TestCase):
     """Tests for SmartClientMedium.
@@ -115,7 +95,7 @@
         sock.bind(('127.0.0.1', 0))
         sock.listen(1)
         port = sock.getsockname()[1]
-        client_medium = medium.SmartTCPClientMedium('127.0.0.1', port, 'base')
+        client_medium = medium.SmartTCPClientMedium('127.0.0.1', port)
         return sock, client_medium
 
     def receive_bytes_on_server(self, sock, bytes):
@@ -133,16 +113,27 @@
         t.start()
         return t
     
+    def test_construct_smart_stream_medium_client(self):
+        # make a new instance of the common base for Stream-like Mediums.
+        # this just ensures that the constructor stays parameter-free which
+        # is important for reuse : some subclasses will dynamically connect,
+        # others are always on, etc.
+        client_medium = medium.SmartClientStreamMedium()
+
+    def test_construct_smart_client_medium(self):
+        # the base client medium takes no parameters
+        client_medium = medium.SmartClientMedium()
+    
     def test_construct_smart_simple_pipes_client_medium(self):
         # the SimplePipes client medium takes two pipes:
         # readable pipe, writeable pipe.
         # Constructing one should just save these and do nothing.
         # We test this by passing in None.
-        client_medium = medium.SmartSimplePipesClientMedium(None, None, None)
+        client_medium = medium.SmartSimplePipesClientMedium(None, None)
         
     def test_simple_pipes_client_request_type(self):
         # SimplePipesClient should use SmartClientStreamMediumRequest's.
-        client_medium = medium.SmartSimplePipesClientMedium(None, None, None)
+        client_medium = medium.SmartSimplePipesClientMedium(None, None)
         request = client_medium.get_request()
         self.assertIsInstance(request, medium.SmartClientStreamMediumRequest)
 
@@ -154,8 +145,7 @@
         # classes - as the sibling classes share this logic, they do not have
         # explicit tests for this.
         output = StringIO()
-        client_medium = medium.SmartSimplePipesClientMedium(
-            None, output, 'base')
+        client_medium = medium.SmartSimplePipesClientMedium(None, output)
         request = client_medium.get_request()
         request.finished_writing()
         request.finished_reading()
@@ -166,8 +156,7 @@
     def test_simple_pipes_client__accept_bytes_writes_to_writable(self):
         # accept_bytes writes to the writeable pipe.
         output = StringIO()
-        client_medium = medium.SmartSimplePipesClientMedium(
-            None, output, 'base')
+        client_medium = medium.SmartSimplePipesClientMedium(None, output)
         client_medium._accept_bytes('abc')
         self.assertEqual('abc', output.getvalue())
     
@@ -175,8 +164,7 @@
         # calling disconnect does nothing.
         input = StringIO()
         output = StringIO()
-        client_medium = medium.SmartSimplePipesClientMedium(
-            input, output, 'base')
+        client_medium = medium.SmartSimplePipesClientMedium(input, output)
         # send some bytes to ensure disconnecting after activity still does not
         # close.
         client_medium._accept_bytes('abc')
@@ -189,8 +177,7 @@
         # accept_bytes writes to.
         input = StringIO()
         output = StringIO()
-        client_medium = medium.SmartSimplePipesClientMedium(
-            input, output, 'base')
+        client_medium = medium.SmartSimplePipesClientMedium(input, output)
         client_medium._accept_bytes('abc')
         client_medium.disconnect()
         client_medium._accept_bytes('abc')
@@ -201,14 +188,14 @@
     def test_simple_pipes_client_ignores_disconnect_when_not_connected(self):
         # Doing a disconnect on a new (and thus unconnected) SimplePipes medium
         # does nothing.
-        client_medium = medium.SmartSimplePipesClientMedium(None, None, 'base')
+        client_medium = medium.SmartSimplePipesClientMedium(None, None)
         client_medium.disconnect()
 
     def test_simple_pipes_client_can_always_read(self):
         # SmartSimplePipesClientMedium is never disconnected, so read_bytes
         # always tries to read from the underlying pipe.
         input = StringIO('abcdef')
-        client_medium = medium.SmartSimplePipesClientMedium(input, None, 'base')
+        client_medium = medium.SmartSimplePipesClientMedium(input, None)
         self.assertEqual('abc', client_medium.read_bytes(3))
         client_medium.disconnect()
         self.assertEqual('def', client_medium.read_bytes(3))
@@ -223,8 +210,7 @@
         flush_calls = []
         def logging_flush(): flush_calls.append('flush')
         output.flush = logging_flush
-        client_medium = medium.SmartSimplePipesClientMedium(
-            input, output, 'base')
+        client_medium = medium.SmartSimplePipesClientMedium(input, output)
         # this call is here to ensure we only flush once, not on every
         # _accept_bytes call.
         client_medium._accept_bytes('abc')
@@ -244,7 +230,7 @@
         # having vendor be invalid means that if it tries to connect via the
         # vendor it will blow up.
         client_medium = medium.SmartSSHClientMedium('127.0.0.1', unopened_port,
-            username=None, password=None, base='base', vendor="not a vendor",
+            username=None, password=None, vendor="not a vendor",
             bzr_remote_path='bzr')
         sock.close()
 
@@ -254,8 +240,7 @@
         output = StringIO()
         vendor = StringIOSSHVendor(StringIO(), output)
         client_medium = medium.SmartSSHClientMedium(
-            'a hostname', 'a port', 'a username', 'a password', 'base', vendor,
-            'bzr')
+            'a hostname', 'a port', 'a username', 'a password', vendor, 'bzr')
         client_medium._accept_bytes('abc')
         self.assertEqual('abc', output.getvalue())
         self.assertEqual([('connect_ssh', 'a username', 'a password',
@@ -276,7 +261,7 @@
         client_medium = self.callDeprecated(
             ['bzr_remote_path is required as of bzr 0.92'],
             medium.SmartSSHClientMedium, 'a hostname', 'a port', 'a username',
-            'a password', 'base', vendor)
+            'a password', vendor)
         client_medium._accept_bytes('abc')
         self.assertEqual('abc', output.getvalue())
         self.assertEqual([('connect_ssh', 'a username', 'a password',
@@ -290,7 +275,7 @@
         output = StringIO()
         vendor = StringIOSSHVendor(StringIO(), output)
         client_medium = medium.SmartSSHClientMedium('a hostname', 'a port',
-            'a username', 'a password', 'base', vendor, bzr_remote_path='fugly')
+            'a username', 'a password', vendor, bzr_remote_path='fugly')
         client_medium._accept_bytes('abc')
         self.assertEqual('abc', output.getvalue())
         self.assertEqual([('connect_ssh', 'a username', 'a password',
@@ -304,8 +289,9 @@
         input = StringIO()
         output = StringIO()
         vendor = StringIOSSHVendor(input, output)
-        client_medium = medium.SmartSSHClientMedium(
-            'a hostname', base='base', vendor=vendor, bzr_remote_path='bzr')
+        client_medium = medium.SmartSSHClientMedium('a hostname',
+                                                    vendor=vendor,
+                                                    bzr_remote_path='bzr')
         client_medium._accept_bytes('abc')
         client_medium.disconnect()
         self.assertTrue(input.closed)
@@ -325,8 +311,8 @@
         input = StringIO()
         output = StringIO()
         vendor = StringIOSSHVendor(input, output)
-        client_medium = medium.SmartSSHClientMedium(
-            'a hostname', base='base', vendor=vendor, bzr_remote_path='bzr')
+        client_medium = medium.SmartSSHClientMedium('a hostname',
+            vendor=vendor, bzr_remote_path='bzr')
         client_medium._accept_bytes('abc')
         client_medium.disconnect()
         # the disconnect has closed output, so we need a new output for the
@@ -354,15 +340,15 @@
     def test_ssh_client_ignores_disconnect_when_not_connected(self):
         # Doing a disconnect on a new (and thus unconnected) SSH medium
         # does not fail.  It's ok to disconnect an unconnected medium.
-        client_medium = medium.SmartSSHClientMedium(
-            None, base='base', bzr_remote_path='bzr')
+        client_medium = medium.SmartSSHClientMedium(None,
+                                                    bzr_remote_path='bzr')
         client_medium.disconnect()
 
     def test_ssh_client_raises_on_read_when_not_connected(self):
         # Doing a read on a new (and thus unconnected) SSH medium raises
         # MediumNotConnected.
-        client_medium = medium.SmartSSHClientMedium(
-            None, base='base', bzr_remote_path='bzr')
+        client_medium = medium.SmartSSHClientMedium(None,
+                                                    bzr_remote_path='bzr')
         self.assertRaises(errors.MediumNotConnected, client_medium.read_bytes,
                           0)
         self.assertRaises(errors.MediumNotConnected, client_medium.read_bytes,
@@ -379,8 +365,9 @@
         def logging_flush(): flush_calls.append('flush')
         output.flush = logging_flush
         vendor = StringIOSSHVendor(input, output)
-        client_medium = medium.SmartSSHClientMedium(
-            'a hostname', base='base', vendor=vendor, bzr_remote_path='bzr')
+        client_medium = medium.SmartSSHClientMedium('a hostname',
+                                                    vendor=vendor,
+                                                    bzr_remote_path='bzr')
         # this call is here to ensure we only flush once, not on every
         # _accept_bytes call.
         client_medium._accept_bytes('abc')
@@ -394,8 +381,7 @@
         sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
         sock.bind(('127.0.0.1', 0))
         unopened_port = sock.getsockname()[1]
-        client_medium = medium.SmartTCPClientMedium(
-            '127.0.0.1', unopened_port, 'base')
+        client_medium = medium.SmartTCPClientMedium('127.0.0.1', unopened_port)
         sock.close()
 
     def test_tcp_client_connects_on_first_use(self):
@@ -424,18 +410,17 @@
         # now disconnect again: this should not do anything, if disconnection
         # really did disconnect.
         medium.disconnect()
-
     
     def test_tcp_client_ignores_disconnect_when_not_connected(self):
         # Doing a disconnect on a new (and thus unconnected) TCP medium
         # does not fail.  It's ok to disconnect an unconnected medium.
-        client_medium = medium.SmartTCPClientMedium(None, None, None)
+        client_medium = medium.SmartTCPClientMedium(None, None)
         client_medium.disconnect()
 
     def test_tcp_client_raises_on_read_when_not_connected(self):
         # Doing a read on a new (and thus unconnected) TCP medium raises
         # MediumNotConnected.
-        client_medium = medium.SmartTCPClientMedium(None, None, None)
+        client_medium = medium.SmartTCPClientMedium(None, None)
         self.assertRaises(errors.MediumNotConnected, client_medium.read_bytes, 0)
         self.assertRaises(errors.MediumNotConnected, client_medium.read_bytes, 1)
 
@@ -458,13 +443,6 @@
         # really did disconnect.
         medium.disconnect()
 
-    def test_tcp_client_host_unknown_connection_error(self):
-        self.requireFeature(InvalidHostnameFeature)
-        client_medium = medium.SmartTCPClientMedium(
-            'non_existent.invalid', 4155, 'base')
-        self.assertRaises(
-            errors.ConnectionError, client_medium._ensure_connection)
-
 
 class TestSmartClientStreamMediumRequest(tests.TestCase):
     """Tests the for SmartClientStreamMediumRequest.
@@ -479,8 +457,7 @@
         # WritingCompleted to prevent bad assumptions on stream environments
         # breaking the needs of message-based environments.
         output = StringIO()
-        client_medium = medium.SmartSimplePipesClientMedium(
-            None, output, 'base')
+        client_medium = medium.SmartSimplePipesClientMedium(None, output)
         request = medium.SmartClientStreamMediumRequest(client_medium)
         request.finished_writing()
         self.assertRaises(errors.WritingCompleted, request.accept_bytes, None)
@@ -491,8 +468,7 @@
         # and checking that the pipes get the data.
         input = StringIO()
         output = StringIO()
-        client_medium = medium.SmartSimplePipesClientMedium(
-            input, output, 'base')
+        client_medium = medium.SmartSimplePipesClientMedium(input, output)
         request = medium.SmartClientStreamMediumRequest(client_medium)
         request.accept_bytes('123')
         request.finished_writing()
@@ -504,8 +480,7 @@
         # constructing a SmartClientStreamMediumRequest on a StreamMedium sets
         # the current request to the new SmartClientStreamMediumRequest
         output = StringIO()
-        client_medium = medium.SmartSimplePipesClientMedium(
-            None, output, 'base')
+        client_medium = medium.SmartSimplePipesClientMedium(None, output)
         request = medium.SmartClientStreamMediumRequest(client_medium)
         self.assertIs(client_medium._current_request, request)
 
@@ -513,8 +488,7 @@
         # constructing a SmartClientStreamMediumRequest on a StreamMedium with
         # a non-None _current_request raises TooManyConcurrentRequests.
         output = StringIO()
-        client_medium = medium.SmartSimplePipesClientMedium(
-            None, output, 'base')
+        client_medium = medium.SmartSimplePipesClientMedium(None, output)
         client_medium._current_request = "a"
         self.assertRaises(errors.TooManyConcurrentRequests,
             medium.SmartClientStreamMediumRequest, client_medium)
@@ -523,8 +497,7 @@
         # calling finished_reading clears the current request from the requests
         # medium
         output = StringIO()
-        client_medium = medium.SmartSimplePipesClientMedium(
-            None, output, 'base')
+        client_medium = medium.SmartSimplePipesClientMedium(None, output)
         request = medium.SmartClientStreamMediumRequest(client_medium)
         request.finished_writing()
         request.finished_reading()
@@ -533,8 +506,7 @@
     def test_finished_read_before_finished_write_errors(self):
         # calling finished_reading before calling finished_writing triggers a
         # WritingNotComplete error.
-        client_medium = medium.SmartSimplePipesClientMedium(
-            None, None, 'base')
+        client_medium = medium.SmartSimplePipesClientMedium(None, None)
         request = medium.SmartClientStreamMediumRequest(client_medium)
         self.assertRaises(errors.WritingNotComplete, request.finished_reading)
         
@@ -547,8 +519,7 @@
         # smoke tests.
         input = StringIO('321')
         output = StringIO()
-        client_medium = medium.SmartSimplePipesClientMedium(
-            input, output, 'base')
+        client_medium = medium.SmartSimplePipesClientMedium(input, output)
         request = medium.SmartClientStreamMediumRequest(client_medium)
         request.finished_writing()
         self.assertEqual('321', request.read_bytes(3))
@@ -561,7 +532,7 @@
         # WritingNotComplete error because the Smart protocol is designed to be
         # compatible with strict message based protocols like HTTP where the
         # request cannot be submitted until the writing has completed.
-        client_medium = medium.SmartSimplePipesClientMedium(None, None, 'base')
+        client_medium = medium.SmartSimplePipesClientMedium(None, None)
         request = medium.SmartClientStreamMediumRequest(client_medium)
         self.assertRaises(errors.WritingNotComplete, request.read_bytes, None)
 
@@ -570,8 +541,7 @@
         # ReadingCompleted to prevent bad assumptions on stream environments
         # breaking the needs of message-based environments.
         output = StringIO()
-        client_medium = medium.SmartSimplePipesClientMedium(
-            None, output, 'base')
+        client_medium = medium.SmartSimplePipesClientMedium(None, output)
         request = medium.SmartClientStreamMediumRequest(client_medium)
         request.finished_writing()
         request.finished_reading()
@@ -609,13 +579,13 @@
         self.accepted_bytes = ''
         self._finished_reading = False
         self.expected_bytes = expected_bytes
-        self.unused_data = ''
+        self.excess_buffer = ''
 
     def accept_bytes(self, bytes):
         self.accepted_bytes += bytes
         if self.accepted_bytes.startswith(self.expected_bytes):
             self._finished_reading = True
-            self.unused_data = self.accepted_bytes[len(self.expected_bytes):]
+            self.excess_buffer = self.accepted_bytes[len(self.expected_bytes):]
 
     def next_read_size(self):
         if self._finished_reading:
@@ -732,68 +702,6 @@
         server._serve_one_request(SampleRequest('x'))
         self.assertTrue(server.finished)
         
-    def test_socket_stream_incomplete_request(self):
-        """The medium should still construct the right protocol version even if
-        the initial read only reads part of the request.
-
-        Specifically, it should correctly read the protocol version line even
-        if the partial read doesn't end in a newline.  An older, naive
-        implementation of _get_line in the server used to have a bug in that
-        case.
-        """
-        incomplete_request_bytes = protocol.REQUEST_VERSION_TWO + 'hel'
-        rest_of_request_bytes = 'lo\n'
-        expected_response = (
-            protocol.RESPONSE_VERSION_TWO + 'success\nok\x012\n')
-        server_sock, client_sock = self.portable_socket_pair()
-        server = medium.SmartServerSocketStreamMedium(
-            server_sock, None)
-        client_sock.sendall(incomplete_request_bytes)
-        server_protocol = server._build_protocol()
-        client_sock.sendall(rest_of_request_bytes)
-        server._serve_one_request(server_protocol)
-        server_sock.close()
-        self.assertEqual(expected_response, client_sock.recv(50),
-                         "Not a version 2 response to 'hello' request.")
-        self.assertEqual('', client_sock.recv(1))
-
-    def test_pipe_stream_incomplete_request(self):
-        """The medium should still construct the right protocol version even if
-        the initial read only reads part of the request.
-
-        Specifically, it should correctly read the protocol version line even
-        if the partial read doesn't end in a newline.  An older, naive
-        implementation of _get_line in the server used to have a bug in that
-        case.
-        """
-        incomplete_request_bytes = protocol.REQUEST_VERSION_TWO + 'hel'
-        rest_of_request_bytes = 'lo\n'
-        expected_response = (
-            protocol.RESPONSE_VERSION_TWO + 'success\nok\x012\n')
-        # Make a pair of pipes, to and from the server
-        to_server, to_server_w = os.pipe()
-        from_server_r, from_server = os.pipe()
-        to_server = os.fdopen(to_server, 'r', 0)
-        to_server_w = os.fdopen(to_server_w, 'w', 0)
-        from_server_r = os.fdopen(from_server_r, 'r', 0)
-        from_server = os.fdopen(from_server, 'w', 0)
-        server = medium.SmartServerPipeStreamMedium(
-            to_server, from_server, None)
-        # Like test_socket_stream_incomplete_request, write an incomplete
-        # request (that does not end in '\n') and build a protocol from it.
-        to_server_w.write(incomplete_request_bytes)
-        server_protocol = server._build_protocol()
-        # Send the rest of the request, and finish serving it.
-        to_server_w.write(rest_of_request_bytes)
-        server._serve_one_request(server_protocol)
-        to_server_w.close()
-        from_server.close()
-        self.assertEqual(expected_response, from_server_r.read(),
-                         "Not a version 2 response to 'hello' request.")
-        self.assertEqual('', from_server_r.read(1))
-        from_server_r.close()
-        to_server.close()
-
     def test_pipe_like_stream_with_two_requests(self):
         # If two requests are read in one go, then two calls to
         # _serve_one_request should still process both of them as if they had
@@ -943,38 +851,6 @@
         # A request that starts with "bzr request 2\n" is version two.
         server_protocol = self.build_protocol_socket('bzr request 2\n')
         self.assertProtocolTwo(server_protocol)
-
-
-class TestGetProtocolFactoryForBytes(tests.TestCase):
-    """_get_protocol_factory_for_bytes identifies the protocol factory a server
-    should use to decode a given request.  Any bytes not part of the version
-    marker string (and thus part of the actual request) are returned alongside
-    the protocol factory.
-    """
-
-    def test_version_three(self):
-        result = medium._get_protocol_factory_for_bytes(
-            'bzr message 3 (bzr 1.6)\nextra bytes')
-        protocol_factory, remainder = result
-        self.assertEqual(
-            protocol.build_server_protocol_three, protocol_factory)
-        self.assertEqual('extra bytes', remainder)
-        
-    def test_version_two(self):
-        result = medium._get_protocol_factory_for_bytes(
-            'bzr request 2\nextra bytes')
-        protocol_factory, remainder = result
-        self.assertEqual(
-            protocol.SmartServerRequestProtocolTwo, protocol_factory)
-        self.assertEqual('extra bytes', remainder)
-        
-    def test_version_one(self):
-        """Version one requests have no version markers."""
-        result = medium._get_protocol_factory_for_bytes('anything\n')
-        protocol_factory, remainder = result
-        self.assertEqual(
-            protocol.SmartServerRequestProtocolOne, protocol_factory)
-        self.assertEqual('anything\n', remainder)
         
 
 class TestSmartTCPServer(tests.TestCase):
@@ -989,7 +865,7 @@
             def get_bytes(self, path):
                 raise Exception("some random exception from inside server")
         smart_server = server.SmartTCPServer(backing_transport=FlakyTransport())
-        smart_server.start_background_thread('-' + self.id())
+        smart_server.start_background_thread()
         try:
             transport = remote.RemoteTCPTransport(smart_server.get_url())
             try:
@@ -1025,7 +901,7 @@
             self.real_backing_transport = self.backing_transport
             self.backing_transport = get_transport("readonly+" + self.backing_transport.abspath('.'))
         self.server = server.SmartTCPServer(self.backing_transport)
-        self.server.start_background_thread('-' + self.id())
+        self.server.start_background_thread()
         self.transport = remote.RemoteTCPTransport(self.server.get_url())
         self.addCleanup(self.tearDownServer)
 
@@ -1161,8 +1037,8 @@
     def test_server_started_hook_memory(self):
         """The server_started hook fires when the server is started."""
         self.hook_calls = []
-        server.SmartTCPServer.hooks.install_named_hook('server_started',
-            self.capture_server_call, None)
+        server.SmartTCPServer.hooks.install_hook('server_started',
+            self.capture_server_call)
         self.setUpServer()
         # at this point, the server will be starting a thread up.
         # there is no indicator at the moment, so bodge it by doing a request.
@@ -1175,8 +1051,8 @@
     def test_server_started_hook_file(self):
         """The server_started hook fires when the server is started."""
         self.hook_calls = []
-        server.SmartTCPServer.hooks.install_named_hook('server_started',
-            self.capture_server_call, None)
+        server.SmartTCPServer.hooks.install_hook('server_started',
+            self.capture_server_call)
         self.setUpServer(backing_transport=get_transport("."))
         # at this point, the server will be starting a thread up.
         # there is no indicator at the moment, so bodge it by doing a request.
@@ -1191,8 +1067,8 @@
     def test_server_stopped_hook_simple_memory(self):
         """The server_stopped hook fires when the server is stopped."""
         self.hook_calls = []
-        server.SmartTCPServer.hooks.install_named_hook('server_stopped',
-            self.capture_server_call, None)
+        server.SmartTCPServer.hooks.install_hook('server_stopped',
+            self.capture_server_call)
         self.setUpServer()
         result = [([self.backing_transport.base], self.transport.base)]
         # check the stopping message isn't emitted up front.
@@ -1208,8 +1084,8 @@
     def test_server_stopped_hook_simple_file(self):
         """The server_stopped hook fires when the server is stopped."""
         self.hook_calls = []
-        server.SmartTCPServer.hooks.install_named_hook('server_stopped',
-            self.capture_server_call, None)
+        server.SmartTCPServer.hooks.install_hook('server_stopped',
+            self.capture_server_call)
         self.setUpServer(backing_transport=get_transport("."))
         result = [(
             [self.backing_transport.base, self.backing_transport.external_url()]
@@ -1233,11 +1109,11 @@
     and the request dispatching.
 
     Note: these tests are rudimentary versions of the command object tests in
-    test_smart.py.
+    test_remote.py.
     """
         
     def test_hello(self):
-        cmd = _mod_request.HelloRequest(None, '/')
+        cmd = request.HelloRequest(None)
         response = cmd.execute()
         self.assertEqual(('ok', '2'), response.args)
         self.assertEqual(None, response.body)
@@ -1249,7 +1125,7 @@
         wt.add('hello')
         rev_id = wt.commit('add hello')
         
-        cmd = _mod_request.GetBundleRequest(self.get_transport(), '/')
+        cmd = request.GetBundleRequest(self.get_transport())
         response = cmd.execute('.', rev_id)
         bundle = serializer.read_bundle(StringIO(response.body))
         self.assertEqual((), response.args)
@@ -1264,13 +1140,12 @@
 
     def build_handler(self, transport):
         """Returns a handler for the commands in protocol version one."""
-        return _mod_request.SmartServerRequestHandler(
-            transport, _mod_request.request_handlers, '/')
+        return request.SmartServerRequestHandler(transport,
+                                                 request.request_handlers)
 
     def test_construct_request_handler(self):
         """Constructing a request handler should be easy and set defaults."""
-        handler = _mod_request.SmartServerRequestHandler(None, commands=None,
-                root_client_path='/')
+        handler = request.SmartServerRequestHandler(None, None)
         self.assertFalse(handler.finished_reading)
 
     def test_hello(self):
@@ -1282,7 +1157,7 @@
     def test_disable_vfs_handler_classes_via_environment(self):
         # VFS handler classes will raise an error from "execute" if
         # BZR_NO_SMART_VFS is set.
-        handler = vfs.HasRequest(None, '/')
+        handler = vfs.HasRequest(None)
         # set environment variable after construction to make sure it's
         # examined.
         # Note that we can safely clobber BZR_NO_SMART_VFS here, because setUp
@@ -1347,7 +1222,7 @@
         handler.accept_body('100,1')
         handler.end_of_body()
         self.assertTrue(handler.finished_reading)
-        self.assertEqual(('ShortReadvError', './a-file', '100', '1', '0'),
+        self.assertEqual(('ShortReadvError', 'a-file', '100', '1', '0'),
             handler.response.args)
         self.assertEqual(None, handler.response.body)
 
@@ -1372,21 +1247,18 @@
         
     def test_use_connection_factory(self):
         # We want to be able to pass a client as a parameter to RemoteTransport.
-        input = StringIO('ok\n3\nbardone\n')
+        input = StringIO("ok\n3\nbardone\n")
         output = StringIO()
-        client_medium = medium.SmartSimplePipesClientMedium(
-            input, output, 'base')
+        client_medium = medium.SmartSimplePipesClientMedium(input, output)
         transport = remote.RemoteTransport(
             'bzr://localhost/', medium=client_medium)
-        # Disable version detection.
-        client_medium._protocol_version = 1
 
         # We want to make sure the client is used when the first remote
         # method is called.  No data should have been sent, or read.
         self.assertEqual(0, input.tell())
         self.assertEqual('', output.getvalue())
 
-        # Now call a method that should result in one request: as the
+        # Now call a method that should result in a single request : as the
         # transport makes its own protocol instances, we check on the wire.
         # XXX: TODO: give the transport a protocol factory, which can make
         # an instrumented protocol for us.
@@ -1397,13 +1269,21 @@
 
     def test__translate_error_readonly(self):
         """Sending a ReadOnlyError to _translate_error raises TransportNotPossible."""
-        client_medium = medium.SmartSimplePipesClientMedium(None, None, 'base')
+        client_medium = medium.SmartClientMedium()
         transport = remote.RemoteTransport(
             'bzr://localhost/', medium=client_medium)
         self.assertRaises(errors.TransportNotPossible,
             transport._translate_error, ("ReadOnlyError", ))
 
 
+class InstrumentedServerProtocol(medium.SmartServerStreamMedium):
+    """A smart server which is backed by memory and saves its write requests."""
+
+    def __init__(self, write_output_list):
+        medium.SmartServerStreamMedium.__init__(self, memory.MemoryTransport())
+        self._write_output_list = write_output_list
+
+
 class TestSmartProtocol(tests.TestCase):
     """Base class for smart protocol tests.
 
@@ -1419,59 +1299,25 @@
     Subclasses can override client_protocol_class and server_protocol_class.
     """
 
-    request_encoder = None
-    response_decoder = None
+    client_protocol_class = None
     server_protocol_class = None
-    client_protocol_class = None
-
-    def make_client_protocol_and_output(self, input_bytes=None):
-        """
-        :returns: a Request
-        """
-        # This is very similar to
-        # bzrlib.smart.client._SmartClient._build_client_protocol
-        # XXX: make this use _SmartClient!
-        if input_bytes is None:
-            input = StringIO()
-        else:
-            input = StringIO(input_bytes)
-        output = StringIO()
-        client_medium = medium.SmartSimplePipesClientMedium(
-            input, output, 'base')
-        request = client_medium.get_request()
-        if self.client_protocol_class is not None:
-            client_protocol = self.client_protocol_class(request)
-            return client_protocol, client_protocol, output
-        else:
-            self.assertNotEqual(None, self.request_encoder)
-            self.assertNotEqual(None, self.response_decoder)
-            requester = self.request_encoder(request)
-            response_handler = message.ConventionalResponseHandler()
-            response_protocol = self.response_decoder(
-                response_handler, expect_version_marker=True)
-            response_handler.setProtoAndMediumRequest(
-                response_protocol, request)
-            return requester, response_handler, output
-
-    def make_client_protocol(self, input_bytes=None):
-        result = self.make_client_protocol_and_output(input_bytes=input_bytes)
-        requester, response_handler, output = result
-        return requester, response_handler
-
-    def make_server_protocol(self):
-        out_stream = StringIO()
-        smart_protocol = self.server_protocol_class(None, out_stream.write)
-        return smart_protocol, out_stream
 
     def setUp(self):
         super(TestSmartProtocol, self).setUp()
-        self.response_marker = getattr(
-            self.client_protocol_class, 'response_marker', None)
-        self.request_marker = getattr(
-            self.client_protocol_class, 'request_marker', None)
+        # XXX: self.server_to_client doesn't seem to be used.  If so,
+        # InstrumentedServerProtocol is redundant too.
+        self.server_to_client = []
+        self.to_server = StringIO()
+        self.to_client = StringIO()
+        self.client_medium = medium.SmartSimplePipesClientMedium(self.to_client,
+            self.to_server)
+        self.client_protocol = self.client_protocol_class(self.client_medium)
+        self.smart_server = InstrumentedServerProtocol(self.server_to_client)
+        self.smart_server_request = request.SmartServerRequestHandler(
+            None, request.request_handlers)
 
     def assertOffsetSerialisation(self, expected_offsets, expected_serialised,
-        requester):
+        client):
         """Check that smart (de)serialises offsets as expected.
         
         We check both serialisation and deserialisation at the same time
@@ -1483,22 +1329,22 @@
         """
         # XXX: '_deserialise_offsets' should be a method of the
         # SmartServerRequestProtocol in future.
-        readv_cmd = vfs.ReadvRequest(None, '/')
+        readv_cmd = vfs.ReadvRequest(None)
         offsets = readv_cmd._deserialise_offsets(expected_serialised)
         self.assertEqual(expected_offsets, offsets)
-        serialised = requester._serialise_offsets(offsets)
+        serialised = client._serialise_offsets(offsets)
         self.assertEqual(expected_serialised, serialised)
 
     def build_protocol_waiting_for_body(self):
-        smart_protocol, out_stream = self.make_server_protocol()
-        smart_protocol._has_dispatched = True
-        smart_protocol.request = _mod_request.SmartServerRequestHandler(
-            None, _mod_request.request_handlers, '/')
+        out_stream = StringIO()
+        smart_protocol = self.server_protocol_class(None, out_stream.write)
+        smart_protocol.has_dispatched = True
+        smart_protocol.request = self.smart_server_request
         class FakeCommand(object):
             def do_body(cmd, body_bytes):
                 self.end_received = True
                 self.assertEqual('abcdefg', body_bytes)
-                return _mod_request.SuccessfulSmartServerResponse(('ok', ))
+                return request.SuccessfulSmartServerResponse(('ok', ))
         smart_protocol.request._command = FakeCommand()
         # Call accept_bytes to make sure that internal state like _body_decoder
         # is initialised.  This test should probably be given a clearer
@@ -1515,66 +1361,69 @@
         # check the encoding of the server for all input_tuples matches
         # expected bytes
         for input_tuple in input_tuples:
-            server_protocol, server_output = self.make_server_protocol()
+            server_output = StringIO()
+            server_protocol = self.server_protocol_class(
+                None, server_output.write)
             server_protocol._send_response(
                 _mod_request.SuccessfulSmartServerResponse(input_tuple))
             self.assertEqual(expected_bytes, server_output.getvalue())
         # check the decoding of the client smart_protocol from expected_bytes:
-        requester, response_handler = self.make_client_protocol(expected_bytes)
-        requester.call('foo')
-        self.assertEqual(expected_tuple, response_handler.read_response_tuple())
+        input = StringIO(expected_bytes)
+        output = StringIO()
+        client_medium = medium.SmartSimplePipesClientMedium(input, output)
+        request = client_medium.get_request()
+        smart_protocol = self.client_protocol_class(request)
+        smart_protocol.call('foo')
+        self.assertEqual(expected_tuple, smart_protocol.read_response_tuple())
 
 
 class CommonSmartProtocolTestMixin(object):
 
-    def test_connection_closed_reporting(self):
-        requester, response_handler = self.make_client_protocol()
-        requester.call('hello')
-        ex = self.assertRaises(errors.ConnectionReset,
-            response_handler.read_response_tuple)
-        self.assertEqual("Connection closed: "
-            "please check connectivity and permissions "
-            "(and try -Dhpss if further diagnosis is required)", str(ex))
-
-    def test_server_offset_serialisation(self):
-        """The Smart protocol serialises offsets as a comma and \n string.
-
-        We check a number of boundary cases are as expected: empty, one offset,
-        one with the order of reads not increasing (an out of order read), and
-        one that should coalesce.
-        """
-        requester, response_handler = self.make_client_protocol()
-        self.assertOffsetSerialisation([], '', requester)
-        self.assertOffsetSerialisation([(1,2)], '1,2', requester)
-        self.assertOffsetSerialisation([(10,40), (0,5)], '10,40\n0,5',
-            requester)
-        self.assertOffsetSerialisation([(1,2), (3,4), (100, 200)],
-            '1,2\n3,4\n100,200', requester)
-
-
-class TestVersionOneFeaturesInProtocolOne(
-    TestSmartProtocol, CommonSmartProtocolTestMixin):
-    """Tests for version one smart protocol features as implemeted by version
-    one."""
+    def test_errors_are_logged(self):
+        """If an error occurs during testing, it is logged to the test log."""
+        out_stream = StringIO()
+        smart_protocol = self.server_protocol_class(None, out_stream.write)
+        # This triggers a "bad request" error.
+        smart_protocol.accept_bytes('abc\n')
+        test_log = self._get_log(keep_log_file=True)
+        self.assertContainsRe(test_log, 'Traceback')
+        self.assertContainsRe(test_log, 'SmartProtocolError')
+
+
+class TestSmartProtocolOne(TestSmartProtocol, CommonSmartProtocolTestMixin):
+    """Tests for the smart protocol version one."""
 
     client_protocol_class = protocol.SmartClientRequestProtocolOne
     server_protocol_class = protocol.SmartServerRequestProtocolOne
 
     def test_construct_version_one_server_protocol(self):
         smart_protocol = protocol.SmartServerRequestProtocolOne(None, None)
-        self.assertEqual('', smart_protocol.unused_data)
+        self.assertEqual('', smart_protocol.excess_buffer)
         self.assertEqual('', smart_protocol.in_buffer)
-        self.assertFalse(smart_protocol._has_dispatched)
+        self.assertFalse(smart_protocol.has_dispatched)
         self.assertEqual(1, smart_protocol.next_read_size())
 
     def test_construct_version_one_client_protocol(self):
         # we can construct a client protocol from a client medium request
         output = StringIO()
-        client_medium = medium.SmartSimplePipesClientMedium(
-            None, output, 'base')
+        client_medium = medium.SmartSimplePipesClientMedium(None, output)
         request = client_medium.get_request()
         client_protocol = protocol.SmartClientRequestProtocolOne(request)
 
+    def test_server_offset_serialisation(self):
+        """The Smart protocol serialises offsets as a comma and \n string.
+
+        We check a number of boundary cases are as expected: empty, one offset,
+        one with the order of reads not increasing (an out of order read), and
+        one that should coalesce.
+        """
+        self.assertOffsetSerialisation([], '', self.client_protocol)
+        self.assertOffsetSerialisation([(1,2)], '1,2', self.client_protocol)
+        self.assertOffsetSerialisation([(10,40), (0,5)], '10,40\n0,5',
+            self.client_protocol)
+        self.assertOffsetSerialisation([(1,2), (3,4), (100, 200)],
+            '1,2\n3,4\n100,200', self.client_protocol)
+
     def test_accept_bytes_of_bad_request_to_protocol(self):
         out_stream = StringIO()
         smart_protocol = protocol.SmartServerRequestProtocolOne(
@@ -1585,7 +1434,7 @@
         self.assertEqual(
             "error\x01Generic bzr smart protocol error: bad request 'abc'\n",
             out_stream.getvalue())
-        self.assertTrue(smart_protocol._has_dispatched)
+        self.assertTrue(smart_protocol.has_dispatched)
         self.assertEqual(0, smart_protocol.next_read_size())
 
     def test_accept_body_bytes_to_protocol(self):
@@ -1608,7 +1457,7 @@
         smart_protocol.accept_bytes('readv\x01foo\n3\n3,3done\n')
         self.assertEqual(0, smart_protocol.next_read_size())
         self.assertEqual('readv\n3\ndefdone\n', out_stream.getvalue())
-        self.assertEqual('', smart_protocol.unused_data)
+        self.assertEqual('', smart_protocol.excess_buffer)
         self.assertEqual('', smart_protocol.in_buffer)
 
     def test_accept_excess_bytes_are_preserved(self):
@@ -1617,17 +1466,17 @@
             None, out_stream.write)
         smart_protocol.accept_bytes('hello\nhello\n')
         self.assertEqual("ok\x012\n", out_stream.getvalue())
-        self.assertEqual("hello\n", smart_protocol.unused_data)
+        self.assertEqual("hello\n", smart_protocol.excess_buffer)
         self.assertEqual("", smart_protocol.in_buffer)
 
     def test_accept_excess_bytes_after_body(self):
         protocol = self.build_protocol_waiting_for_body()
         protocol.accept_bytes('7\nabcdefgdone\nX')
         self.assertTrue(self.end_received)
-        self.assertEqual("X", protocol.unused_data)
+        self.assertEqual("X", protocol.excess_buffer)
         self.assertEqual("", protocol.in_buffer)
         protocol.accept_bytes('Y')
-        self.assertEqual("XY", protocol.unused_data)
+        self.assertEqual("XY", protocol.excess_buffer)
         self.assertEqual("", protocol.in_buffer)
 
     def test_accept_excess_bytes_after_dispatch(self):
@@ -1637,9 +1486,9 @@
         smart_protocol.accept_bytes('hello\n')
         self.assertEqual("ok\x012\n", out_stream.getvalue())
         smart_protocol.accept_bytes('hel')
-        self.assertEqual("hel", smart_protocol.unused_data)
+        self.assertEqual("hel", smart_protocol.excess_buffer)
         smart_protocol.accept_bytes('lo\n')
-        self.assertEqual("hello\n", smart_protocol.unused_data)
+        self.assertEqual("hello\n", smart_protocol.excess_buffer)
         self.assertEqual("", smart_protocol.in_buffer)
 
     def test__send_response_sets_finished_reading(self):
@@ -1647,7 +1496,7 @@
             None, lambda x: None)
         self.assertEqual(1, smart_protocol.next_read_size())
         smart_protocol._send_response(
-            _mod_request.SuccessfulSmartServerResponse(('x',)))
+            request.SuccessfulSmartServerResponse(('x',)))
         self.assertEqual(0, smart_protocol.next_read_size())
 
     def test__send_response_errors_with_base_response(self):
@@ -1655,7 +1504,7 @@
         smart_protocol = protocol.SmartServerRequestProtocolOne(
             None, lambda x: None)
         self.assertRaises(AttributeError, smart_protocol._send_response,
-            _mod_request.SmartServerResponse(('x',)))
+            request.SmartServerResponse(('x',)))
 
     def test_query_version(self):
         """query_version on a SmartClientProtocolOne should return a number.
@@ -1669,8 +1518,7 @@
         # the error if the response is a non-understood version.
         input = StringIO('ok\x012\n')
         output = StringIO()
-        client_medium = medium.SmartSimplePipesClientMedium(
-            input, output, 'base')
+        client_medium = medium.SmartSimplePipesClientMedium(input, output)
         request = client_medium.get_request()
         smart_protocol = protocol.SmartClientRequestProtocolOne(request)
         self.assertEqual(2, smart_protocol.query_version())
@@ -1693,8 +1541,7 @@
         expected_bytes = "foo\n7\nabcdefgdone\n"
         input = StringIO("\n")
         output = StringIO()
-        client_medium = medium.SmartSimplePipesClientMedium(
-            input, output, 'base')
+        client_medium = medium.SmartSimplePipesClientMedium(input, output)
         request = client_medium.get_request()
         smart_protocol = protocol.SmartClientRequestProtocolOne(request)
         smart_protocol.call_with_body_bytes(('foo', ), "abcdefg")
@@ -1706,49 +1553,12 @@
         expected_bytes = "foo\n7\n1,2\n5,6done\n"
         input = StringIO("\n")
         output = StringIO()
-        client_medium = medium.SmartSimplePipesClientMedium(
-            input, output, 'base')
+        client_medium = medium.SmartSimplePipesClientMedium(input, output)
         request = client_medium.get_request()
         smart_protocol = protocol.SmartClientRequestProtocolOne(request)
         smart_protocol.call_with_body_readv_array(('foo', ), [(1,2),(5,6)])
         self.assertEqual(expected_bytes, output.getvalue())
 
-    def _test_client_read_response_tuple_raises_UnknownSmartMethod(self,
-            server_bytes):
-        input = StringIO(server_bytes)
-        output = StringIO()
-        client_medium = medium.SmartSimplePipesClientMedium(
-            input, output, 'base')
-        request = client_medium.get_request()
-        smart_protocol = protocol.SmartClientRequestProtocolOne(request)
-        smart_protocol.call('foo')
-        self.assertRaises(
-            errors.UnknownSmartMethod, smart_protocol.read_response_tuple)
-        # The request has been finished.  There is no body to read, and
-        # attempts to read one will fail.
-        self.assertRaises(
-            errors.ReadingCompleted, smart_protocol.read_body_bytes)
-
-    def test_client_read_response_tuple_raises_UnknownSmartMethod(self):
-        """read_response_tuple raises UnknownSmartMethod if the response says
-        the server did not recognise the request.
-        """
-        server_bytes = (
-            "error\x01Generic bzr smart protocol error: bad request 'foo'\n")
-        self._test_client_read_response_tuple_raises_UnknownSmartMethod(
-            server_bytes)
-
-    def test_client_read_response_tuple_raises_UnknownSmartMethod_0_11(self):
-        """read_response_tuple also raises UnknownSmartMethod if the response
-        from a bzr 0.11 says the server did not recognise the request.
-
-        (bzr 0.11 sends a slightly different error message to later versions.)
-        """
-        server_bytes = (
-            "error\x01Generic bzr smart protocol error: bad request u'foo'\n")
-        self._test_client_read_response_tuple_raises_UnknownSmartMethod(
-            server_bytes)
-
     def test_client_read_body_bytes_all(self):
         # read_body_bytes should decode the body bytes from the wire into
         # a response.
@@ -1756,8 +1566,7 @@
         server_bytes = "ok\n7\n1234567done\n"
         input = StringIO(server_bytes)
         output = StringIO()
-        client_medium = medium.SmartSimplePipesClientMedium(
-            input, output, 'base')
+        client_medium = medium.SmartSimplePipesClientMedium(input, output)
         request = client_medium.get_request()
         smart_protocol = protocol.SmartClientRequestProtocolOne(request)
         smart_protocol.call('foo')
@@ -1774,8 +1583,7 @@
         server_bytes = "ok\n7\n1234567done\n"
         input = StringIO(server_bytes)
         output = StringIO()
-        client_medium = medium.SmartSimplePipesClientMedium(
-            input, output, 'base')
+        client_medium = medium.SmartSimplePipesClientMedium(input, output)
         request = client_medium.get_request()
         smart_protocol = protocol.SmartClientRequestProtocolOne(request)
         smart_protocol.call('foo')
@@ -1792,8 +1600,7 @@
         server_bytes = "ok\n7\n1234567done\n"
         input = StringIO(server_bytes)
         output = StringIO()
-        client_medium = medium.SmartSimplePipesClientMedium(
-            input, output, 'base')
+        client_medium = medium.SmartSimplePipesClientMedium(input, output)
         request = client_medium.get_request()
         smart_protocol = protocol.SmartClientRequestProtocolOne(request)
         smart_protocol.call('foo')
@@ -1803,24 +1610,11 @@
         self.assertRaises(
             errors.ReadingCompleted, smart_protocol.read_body_bytes)
 
-    def test_client_read_body_bytes_interrupted_connection(self):
-        server_bytes = "ok\n999\nincomplete body"
-        input = StringIO(server_bytes)
-        output = StringIO()
-        client_medium = medium.SmartSimplePipesClientMedium(
-            input, output, 'base')
-        request = client_medium.get_request()
-        smart_protocol = self.client_protocol_class(request)
-        smart_protocol.call('foo')
-        smart_protocol.read_response_tuple(True)
-        self.assertRaises(
-            errors.ConnectionReset, smart_protocol.read_body_bytes)
-
-
-class TestVersionOneFeaturesInProtocolTwo(
-    TestSmartProtocol, CommonSmartProtocolTestMixin):
-    """Tests for version one smart protocol features as implemeted by version
-    two.
+
+class TestSmartProtocolTwo(TestSmartProtocol, CommonSmartProtocolTestMixin):
+    """Tests for the smart protocol version two.
+
+    This test case is mostly the same as TestSmartProtocolOne.
     """
 
     client_protocol_class = protocol.SmartClientRequestProtocolTwo
@@ -1828,30 +1622,44 @@
 
     def test_construct_version_two_server_protocol(self):
         smart_protocol = protocol.SmartServerRequestProtocolTwo(None, None)
-        self.assertEqual('', smart_protocol.unused_data)
+        self.assertEqual('', smart_protocol.excess_buffer)
         self.assertEqual('', smart_protocol.in_buffer)
-        self.assertFalse(smart_protocol._has_dispatched)
+        self.assertFalse(smart_protocol.has_dispatched)
         self.assertEqual(1, smart_protocol.next_read_size())
 
     def test_construct_version_two_client_protocol(self):
         # we can construct a client protocol from a client medium request
         output = StringIO()
-        client_medium = medium.SmartSimplePipesClientMedium(
-            None, output, 'base')
+        client_medium = medium.SmartSimplePipesClientMedium(None, output)
         request = client_medium.get_request()
         client_protocol = protocol.SmartClientRequestProtocolTwo(request)
 
+    def test_server_offset_serialisation(self):
+        """The Smart protocol serialises offsets as a comma and \n string.
+
+        We check a number of boundary cases are as expected: empty, one offset,
+        one with the order of reads not increasing (an out of order read), and
+        one that should coalesce.
+        """
+        self.assertOffsetSerialisation([], '', self.client_protocol)
+        self.assertOffsetSerialisation([(1,2)], '1,2', self.client_protocol)
+        self.assertOffsetSerialisation([(10,40), (0,5)], '10,40\n0,5',
+            self.client_protocol)
+        self.assertOffsetSerialisation([(1,2), (3,4), (100, 200)],
+            '1,2\n3,4\n100,200', self.client_protocol)
+
     def test_accept_bytes_of_bad_request_to_protocol(self):
         out_stream = StringIO()
-        smart_protocol = self.server_protocol_class(None, out_stream.write)
+        smart_protocol = protocol.SmartServerRequestProtocolTwo(
+            None, out_stream.write)
         smart_protocol.accept_bytes('abc')
         self.assertEqual('abc', smart_protocol.in_buffer)
         smart_protocol.accept_bytes('\n')
         self.assertEqual(
-            self.response_marker +
+            protocol.RESPONSE_VERSION_TWO +
             "failed\nerror\x01Generic bzr smart protocol error: bad request 'abc'\n",
             out_stream.getvalue())
-        self.assertTrue(smart_protocol._has_dispatched)
+        self.assertTrue(smart_protocol.has_dispatched)
         self.assertEqual(0, smart_protocol.next_read_size())
 
     def test_accept_body_bytes_to_protocol(self):
@@ -1869,247 +1677,69 @@
         mem_transport = memory.MemoryTransport()
         mem_transport.put_bytes('foo', 'abcdefghij')
         out_stream = StringIO()
-        smart_protocol = self.server_protocol_class(
-            mem_transport, out_stream.write)
+        smart_protocol = protocol.SmartServerRequestProtocolTwo(mem_transport,
+                out_stream.write)
         smart_protocol.accept_bytes('readv\x01foo\n3\n3,3done\n')
         self.assertEqual(0, smart_protocol.next_read_size())
-        self.assertEqual(self.response_marker +
+        self.assertEqual(protocol.RESPONSE_VERSION_TWO +
                          'success\nreadv\n3\ndefdone\n',
                          out_stream.getvalue())
-        self.assertEqual('', smart_protocol.unused_data)
+        self.assertEqual('', smart_protocol.excess_buffer)
         self.assertEqual('', smart_protocol.in_buffer)
 
     def test_accept_excess_bytes_are_preserved(self):
         out_stream = StringIO()
-        smart_protocol = self.server_protocol_class(None, out_stream.write)
+        smart_protocol = protocol.SmartServerRequestProtocolTwo(
+            None, out_stream.write)
         smart_protocol.accept_bytes('hello\nhello\n')
-        self.assertEqual(self.response_marker + "success\nok\x012\n",
+        self.assertEqual(protocol.RESPONSE_VERSION_TWO + "success\nok\x012\n",
                          out_stream.getvalue())
-        self.assertEqual("hello\n", smart_protocol.unused_data)
+        self.assertEqual("hello\n", smart_protocol.excess_buffer)
         self.assertEqual("", smart_protocol.in_buffer)
 
     def test_accept_excess_bytes_after_body(self):
         # The excess bytes look like the start of another request.
         server_protocol = self.build_protocol_waiting_for_body()
-        server_protocol.accept_bytes('7\nabcdefgdone\n' + self.response_marker)
+        server_protocol.accept_bytes(
+            '7\nabcdefgdone\n' + protocol.RESPONSE_VERSION_TWO)
         self.assertTrue(self.end_received)
-        self.assertEqual(self.response_marker,
-                         server_protocol.unused_data)
+        self.assertEqual(protocol.RESPONSE_VERSION_TWO,
+                         server_protocol.excess_buffer)
         self.assertEqual("", server_protocol.in_buffer)
         server_protocol.accept_bytes('Y')
-        self.assertEqual(self.response_marker + "Y",
-                         server_protocol.unused_data)
+        self.assertEqual(protocol.RESPONSE_VERSION_TWO + "Y",
+                         server_protocol.excess_buffer)
         self.assertEqual("", server_protocol.in_buffer)
 
     def test_accept_excess_bytes_after_dispatch(self):
         out_stream = StringIO()
-        smart_protocol = self.server_protocol_class(None, out_stream.write)
+        smart_protocol = protocol.SmartServerRequestProtocolTwo(
+            None, out_stream.write)
         smart_protocol.accept_bytes('hello\n')
-        self.assertEqual(self.response_marker + "success\nok\x012\n",
+        self.assertEqual(protocol.RESPONSE_VERSION_TWO + "success\nok\x012\n",
                          out_stream.getvalue())
-        smart_protocol.accept_bytes(self.request_marker + 'hel')
-        self.assertEqual(self.request_marker + "hel",
-                         smart_protocol.unused_data)
+        smart_protocol.accept_bytes(protocol.REQUEST_VERSION_TWO + 'hel')
+        self.assertEqual(protocol.REQUEST_VERSION_TWO + "hel",
+                         smart_protocol.excess_buffer)
         smart_protocol.accept_bytes('lo\n')
-        self.assertEqual(self.request_marker + "hello\n",
-                         smart_protocol.unused_data)
+        self.assertEqual(protocol.REQUEST_VERSION_TWO + "hello\n",
+                         smart_protocol.excess_buffer)
         self.assertEqual("", smart_protocol.in_buffer)
 
     def test__send_response_sets_finished_reading(self):
-        smart_protocol = self.server_protocol_class(None, lambda x: None)
+        smart_protocol = protocol.SmartServerRequestProtocolTwo(
+            None, lambda x: None)
         self.assertEqual(1, smart_protocol.next_read_size())
         smart_protocol._send_response(
-            _mod_request.SuccessfulSmartServerResponse(('x',)))
+            request.SuccessfulSmartServerResponse(('x',)))
         self.assertEqual(0, smart_protocol.next_read_size())
 
     def test__send_response_errors_with_base_response(self):
         """Ensure that only the Successful/Failed subclasses are used."""
-        smart_protocol = self.server_protocol_class(None, lambda x: None)
+        smart_protocol = protocol.SmartServerRequestProtocolTwo(
+            None, lambda x: None)
         self.assertRaises(AttributeError, smart_protocol._send_response,
-            _mod_request.SmartServerResponse(('x',)))
-
-    def test_query_version(self):
-        """query_version on a SmartClientProtocolTwo should return a number.
-        
-        The protocol provides the query_version because the domain level clients
-        may all need to be able to probe for capabilities.
-        """
-        # What we really want to test here is that SmartClientProtocolTwo calls
-        # accept_bytes(tuple_based_encoding_of_hello) and reads and parses the
-        # response of tuple-encoded (ok, 1).  Also, seperately we should test
-        # the error if the response is a non-understood version.
-        input = StringIO(self.response_marker + 'success\nok\x012\n')
-        output = StringIO()
-        client_medium = medium.SmartSimplePipesClientMedium(
-            input, output, 'base')
-        request = client_medium.get_request()
-        smart_protocol = self.client_protocol_class(request)
-        self.assertEqual(2, smart_protocol.query_version())
-
-    def test_client_call_empty_response(self):
-        # protocol.call() can get back an empty tuple as a response. This occurs
-        # when the parsed line is an empty line, and results in a tuple with
-        # one element - an empty string.
-        self.assertServerToClientEncoding(
-            self.response_marker + 'success\n\n', ('', ), [(), ('', )])
-
-    def test_client_call_three_element_response(self):
-        # protocol.call() can get back tuples of other lengths. A three element
-        # tuple should be unpacked as three strings.
-        self.assertServerToClientEncoding(
-            self.response_marker + 'success\na\x01b\x0134\n',
-            ('a', 'b', '34'),
-            [('a', 'b', '34')])
-
-    def test_client_call_with_body_bytes_uploads(self):
-        # protocol.call_with_body_bytes should length-prefix the bytes onto the
-        # wire.
-        expected_bytes = self.request_marker + "foo\n7\nabcdefgdone\n"
-        input = StringIO("\n")
-        output = StringIO()
-        client_medium = medium.SmartSimplePipesClientMedium(
-            input, output, 'base')
-        request = client_medium.get_request()
-        smart_protocol = self.client_protocol_class(request)
-        smart_protocol.call_with_body_bytes(('foo', ), "abcdefg")
-        self.assertEqual(expected_bytes, output.getvalue())
-
-    def test_client_call_with_body_readv_array(self):
-        # protocol.call_with_upload should encode the readv array and then
-        # length-prefix the bytes onto the wire.
-        expected_bytes = self.request_marker + "foo\n7\n1,2\n5,6done\n"
-        input = StringIO("\n")
-        output = StringIO()
-        client_medium = medium.SmartSimplePipesClientMedium(
-            input, output, 'base')
-        request = client_medium.get_request()
-        smart_protocol = self.client_protocol_class(request)
-        smart_protocol.call_with_body_readv_array(('foo', ), [(1,2),(5,6)])
-        self.assertEqual(expected_bytes, output.getvalue())
-
-    def test_client_read_body_bytes_all(self):
-        # read_body_bytes should decode the body bytes from the wire into
-        # a response.
-        expected_bytes = "1234567"
-        server_bytes = (self.response_marker +
-                        "success\nok\n7\n1234567done\n")
-        input = StringIO(server_bytes)
-        output = StringIO()
-        client_medium = medium.SmartSimplePipesClientMedium(
-            input, output, 'base')
-        request = client_medium.get_request()
-        smart_protocol = self.client_protocol_class(request)
-        smart_protocol.call('foo')
-        smart_protocol.read_response_tuple(True)
-        self.assertEqual(expected_bytes, smart_protocol.read_body_bytes())
-
-    def test_client_read_body_bytes_incremental(self):
-        # test reading a few bytes at a time from the body
-        # XXX: possibly we should test dribbling the bytes into the stringio
-        # to make the state machine work harder: however, as we use the
-        # LengthPrefixedBodyDecoder that is already well tested - we can skip
-        # that.
-        expected_bytes = "1234567"
-        server_bytes = self.response_marker + "success\nok\n7\n1234567done\n"
-        input = StringIO(server_bytes)
-        output = StringIO()
-        client_medium = medium.SmartSimplePipesClientMedium(
-            input, output, 'base')
-        request = client_medium.get_request()
-        smart_protocol = self.client_protocol_class(request)
-        smart_protocol.call('foo')
-        smart_protocol.read_response_tuple(True)
-        self.assertEqual(expected_bytes[0:2], smart_protocol.read_body_bytes(2))
-        self.assertEqual(expected_bytes[2:4], smart_protocol.read_body_bytes(2))
-        self.assertEqual(expected_bytes[4:6], smart_protocol.read_body_bytes(2))
-        self.assertEqual(expected_bytes[6], smart_protocol.read_body_bytes())
-
-    def test_client_cancel_read_body_does_not_eat_body_bytes(self):
-        # cancelling the expected body needs to finish the request, but not
-        # read any more bytes.
-        server_bytes = self.response_marker + "success\nok\n7\n1234567done\n"
-        input = StringIO(server_bytes)
-        output = StringIO()
-        client_medium = medium.SmartSimplePipesClientMedium(
-            input, output, 'base')
-        request = client_medium.get_request()
-        smart_protocol = self.client_protocol_class(request)
-        smart_protocol.call('foo')
-        smart_protocol.read_response_tuple(True)
-        smart_protocol.cancel_read_body()
-        self.assertEqual(len(self.response_marker + 'success\nok\n'),
-                         input.tell())
-        self.assertRaises(
-            errors.ReadingCompleted, smart_protocol.read_body_bytes)
-
-    def test_client_read_body_bytes_interrupted_connection(self):
-        server_bytes = (self.response_marker +
-                        "success\nok\n999\nincomplete body")
-        input = StringIO(server_bytes)
-        output = StringIO()
-        client_medium = medium.SmartSimplePipesClientMedium(
-            input, output, 'base')
-        request = client_medium.get_request()
-        smart_protocol = self.client_protocol_class(request)
-        smart_protocol.call('foo')
-        smart_protocol.read_response_tuple(True)
-        self.assertRaises(
-            errors.ConnectionReset, smart_protocol.read_body_bytes)
-
-
-class TestSmartProtocolTwoSpecificsMixin(object):
-
-    def assertBodyStreamSerialisation(self, expected_serialisation,
-                                      body_stream):
-        """Assert that body_stream is serialised as expected_serialisation."""
-        out_stream = StringIO()
-        protocol._send_stream(body_stream, out_stream.write)
-        self.assertEqual(expected_serialisation, out_stream.getvalue())
-
-    def assertBodyStreamRoundTrips(self, body_stream):
-        """Assert that body_stream is the same after being serialised and
-        deserialised.
-        """
-        out_stream = StringIO()
-        protocol._send_stream(body_stream, out_stream.write)
-        decoder = protocol.ChunkedBodyDecoder()
-        decoder.accept_bytes(out_stream.getvalue())
-        decoded_stream = list(iter(decoder.read_next_chunk, None))
-        self.assertEqual(body_stream, decoded_stream)
-
-    def test_body_stream_serialisation_empty(self):
-        """A body_stream with no bytes can be serialised."""
-        self.assertBodyStreamSerialisation('chunked\nEND\n', [])
-        self.assertBodyStreamRoundTrips([])
-
-    def test_body_stream_serialisation(self):
-        stream = ['chunk one', 'chunk two', 'chunk three']
-        self.assertBodyStreamSerialisation(
-            'chunked\n' + '9\nchunk one' + '9\nchunk two' + 'b\nchunk three' +
-            'END\n',
-            stream)
-        self.assertBodyStreamRoundTrips(stream)
-
-    def test_body_stream_with_empty_element_serialisation(self):
-        """A body stream can include ''.
-
-        The empty string can be transmitted like any other string.
-        """
-        stream = ['', 'chunk']
-        self.assertBodyStreamSerialisation(
-            'chunked\n' + '0\n' + '5\nchunk' + 'END\n', stream)
-        self.assertBodyStreamRoundTrips(stream)
-
-    def test_body_stream_error_serialistion(self):
-        stream = ['first chunk',
-                  _mod_request.FailedSmartServerResponse(
-                      ('FailureName', 'failure arg'))]
-        expected_bytes = (
-            'chunked\n' + 'b\nfirst chunk' +
-            'ERR\n' + 'b\nFailureName' + 'b\nfailure arg' +
-            'END\n')
-        self.assertBodyStreamSerialisation(expected_bytes, stream)
-        self.assertBodyStreamRoundTrips(stream)
+            request.SmartServerResponse(('x',)))
 
     def test__send_response_includes_failure_marker(self):
         """FailedSmartServerResponse have 'failed\n' after the version."""
@@ -2117,7 +1747,7 @@
         smart_protocol = protocol.SmartServerRequestProtocolTwo(
             None, out_stream.write)
         smart_protocol._send_response(
-            _mod_request.FailedSmartServerResponse(('x',)))
+            request.FailedSmartServerResponse(('x',)))
         self.assertEqual(protocol.RESPONSE_VERSION_TWO + 'failed\nx\n',
                          out_stream.getvalue())
 
@@ -2127,616 +1757,133 @@
         smart_protocol = protocol.SmartServerRequestProtocolTwo(
             None, out_stream.write)
         smart_protocol._send_response(
-            _mod_request.SuccessfulSmartServerResponse(('x',)))
+            request.SuccessfulSmartServerResponse(('x',)))
         self.assertEqual(protocol.RESPONSE_VERSION_TWO + 'success\nx\n',
                          out_stream.getvalue())
 
-    def test__send_response_with_body_stream_sets_finished_reading(self):
-        smart_protocol = protocol.SmartServerRequestProtocolTwo(
-            None, lambda x: None)
-        self.assertEqual(1, smart_protocol.next_read_size())
-        smart_protocol._send_response(
-            _mod_request.SuccessfulSmartServerResponse(('x',), body_stream=[]))
-        self.assertEqual(0, smart_protocol.next_read_size())
-
-    def test_streamed_body_bytes(self):
-        body_header = 'chunked\n'
-        two_body_chunks = "4\n1234" + "3\n567"
-        body_terminator = "END\n"
-        server_bytes = (protocol.RESPONSE_VERSION_TWO +
-                        "success\nok\n" + body_header + two_body_chunks +
-                        body_terminator)
-        input = StringIO(server_bytes)
-        output = StringIO()
-        client_medium = medium.SmartSimplePipesClientMedium(
-            input, output, 'base')
-        request = client_medium.get_request()
-        smart_protocol = protocol.SmartClientRequestProtocolTwo(request)
-        smart_protocol.call('foo')
-        smart_protocol.read_response_tuple(True)
-        stream = smart_protocol.read_streamed_body()
-        self.assertEqual(['1234', '567'], list(stream))
-
-    def test_read_streamed_body_error(self):
-        """When a stream is interrupted by an error..."""
-        body_header = 'chunked\n'
-        a_body_chunk = '4\naaaa'
-        err_signal = 'ERR\n'
-        err_chunks = 'a\nerror arg1' + '4\narg2'
-        finish = 'END\n'
-        body = body_header + a_body_chunk + err_signal + err_chunks + finish
-        server_bytes = (protocol.RESPONSE_VERSION_TWO +
-                        "success\nok\n" + body)
-        input = StringIO(server_bytes)
-        output = StringIO()
-        client_medium = medium.SmartSimplePipesClientMedium(
-            input, output, 'base')
-        smart_request = client_medium.get_request()
-        smart_protocol = protocol.SmartClientRequestProtocolTwo(smart_request)
-        smart_protocol.call('foo')
-        smart_protocol.read_response_tuple(True)
-        expected_chunks = [
-            'aaaa',
-            _mod_request.FailedSmartServerResponse(('error arg1', 'arg2'))]
-        stream = smart_protocol.read_streamed_body()
-        self.assertEqual(expected_chunks, list(stream))
-
-    def test_streamed_body_bytes_interrupted_connection(self):
-        body_header = 'chunked\n'
-        incomplete_body_chunk = "9999\nincomplete chunk"
-        server_bytes = (protocol.RESPONSE_VERSION_TWO +
-                        "success\nok\n" + body_header + incomplete_body_chunk)
-        input = StringIO(server_bytes)
-        output = StringIO()
-        client_medium = medium.SmartSimplePipesClientMedium(
-            input, output, 'base')
-        request = client_medium.get_request()
-        smart_protocol = protocol.SmartClientRequestProtocolTwo(request)
-        smart_protocol.call('foo')
-        smart_protocol.read_response_tuple(True)
-        stream = smart_protocol.read_streamed_body()
-        self.assertRaises(errors.ConnectionReset, stream.next)
+    def test_query_version(self):
+        """query_version on a SmartClientProtocolTwo should return a number.
+        
+        The protocol provides the query_version because the domain level clients
+        may all need to be able to probe for capabilities.
+        """
+        # What we really want to test here is that SmartClientProtocolTwo calls
+        # accept_bytes(tuple_based_encoding_of_hello) and reads and parses the
+        # response of tuple-encoded (ok, 1).  Also, seperately we should test
+        # the error if the response is a non-understood version.
+        input = StringIO(protocol.RESPONSE_VERSION_TWO + 'success\nok\x012\n')
+        output = StringIO()
+        client_medium = medium.SmartSimplePipesClientMedium(input, output)
+        request = client_medium.get_request()
+        smart_protocol = protocol.SmartClientRequestProtocolTwo(request)
+        self.assertEqual(2, smart_protocol.query_version())
+
+    def test_client_call_empty_response(self):
+        # protocol.call() can get back an empty tuple as a response. This occurs
+        # when the parsed line is an empty line, and results in a tuple with
+        # one element - an empty string.
+        self.assertServerToClientEncoding(
+            protocol.RESPONSE_VERSION_TWO + 'success\n\n', ('', ), [(), ('', )])
+
+    def test_client_call_three_element_response(self):
+        # protocol.call() can get back tuples of other lengths. A three element
+        # tuple should be unpacked as three strings.
+        self.assertServerToClientEncoding(
+            protocol.RESPONSE_VERSION_TWO + 'success\na\x01b\x0134\n',
+            ('a', 'b', '34'),
+            [('a', 'b', '34')])
+
+    def test_client_call_with_body_bytes_uploads(self):
+        # protocol.call_with_body_bytes should length-prefix the bytes onto the
+        # wire.
+        expected_bytes = protocol.REQUEST_VERSION_TWO + "foo\n7\nabcdefgdone\n"
+        input = StringIO("\n")
+        output = StringIO()
+        client_medium = medium.SmartSimplePipesClientMedium(input, output)
+        request = client_medium.get_request()
+        smart_protocol = protocol.SmartClientRequestProtocolTwo(request)
+        smart_protocol.call_with_body_bytes(('foo', ), "abcdefg")
+        self.assertEqual(expected_bytes, output.getvalue())
+
+    def test_client_call_with_body_readv_array(self):
+        # protocol.call_with_upload should encode the readv array and then
+        # length-prefix the bytes onto the wire.
+        expected_bytes = protocol.REQUEST_VERSION_TWO+"foo\n7\n1,2\n5,6done\n"
+        input = StringIO("\n")
+        output = StringIO()
+        client_medium = medium.SmartSimplePipesClientMedium(input, output)
+        request = client_medium.get_request()
+        smart_protocol = protocol.SmartClientRequestProtocolTwo(request)
+        smart_protocol.call_with_body_readv_array(('foo', ), [(1,2),(5,6)])
+        self.assertEqual(expected_bytes, output.getvalue())
 
     def test_client_read_response_tuple_sets_response_status(self):
         server_bytes = protocol.RESPONSE_VERSION_TWO + "success\nok\n"
         input = StringIO(server_bytes)
         output = StringIO()
-        client_medium = medium.SmartSimplePipesClientMedium(
-            input, output, 'base')
+        client_medium = medium.SmartSimplePipesClientMedium(input, output)
         request = client_medium.get_request()
         smart_protocol = protocol.SmartClientRequestProtocolTwo(request)
         smart_protocol.call('foo')
         smart_protocol.read_response_tuple(False)
         self.assertEqual(True, smart_protocol.response_status)
 
-    def test_client_read_response_tuple_raises_UnknownSmartMethod(self):
-        """read_response_tuple raises UnknownSmartMethod if the response says
-        the server did not recognise the request.
-        """
-        server_bytes = (
-            protocol.RESPONSE_VERSION_TWO +
-            "failed\n" +
-            "error\x01Generic bzr smart protocol error: bad request 'foo'\n")
-        input = StringIO(server_bytes)
-        output = StringIO()
-        client_medium = medium.SmartSimplePipesClientMedium(
-            input, output, 'base')
-        request = client_medium.get_request()
-        smart_protocol = protocol.SmartClientRequestProtocolTwo(request)
-        smart_protocol.call('foo')
-        self.assertRaises(
-            errors.UnknownSmartMethod, smart_protocol.read_response_tuple)
-        # The request has been finished.  There is no body to read, and
-        # attempts to read one will fail.
+    def test_client_read_body_bytes_all(self):
+        # read_body_bytes should decode the body bytes from the wire into
+        # a response.
+        expected_bytes = "1234567"
+        server_bytes = (protocol.RESPONSE_VERSION_TWO +
+                        "success\nok\n7\n1234567done\n")
+        input = StringIO(server_bytes)
+        output = StringIO()
+        client_medium = medium.SmartSimplePipesClientMedium(input, output)
+        request = client_medium.get_request()
+        smart_protocol = protocol.SmartClientRequestProtocolTwo(request)
+        smart_protocol.call('foo')
+        smart_protocol.read_response_tuple(True)
+        self.assertEqual(expected_bytes, smart_protocol.read_body_bytes())
+
+    def test_client_read_body_bytes_incremental(self):
+        # test reading a few bytes at a time from the body
+        # XXX: possibly we should test dribbling the bytes into the stringio
+        # to make the state machine work harder: however, as we use the
+        # LengthPrefixedBodyDecoder that is already well tested - we can skip
+        # that.
+        expected_bytes = "1234567"
+        server_bytes = (protocol.RESPONSE_VERSION_TWO +
+                        "success\nok\n7\n1234567done\n")
+        input = StringIO(server_bytes)
+        output = StringIO()
+        client_medium = medium.SmartSimplePipesClientMedium(input, output)
+        request = client_medium.get_request()
+        smart_protocol = protocol.SmartClientRequestProtocolTwo(request)
+        smart_protocol.call('foo')
+        smart_protocol.read_response_tuple(True)
+        self.assertEqual(expected_bytes[0:2], smart_protocol.read_body_bytes(2))
+        self.assertEqual(expected_bytes[2:4], smart_protocol.read_body_bytes(2))
+        self.assertEqual(expected_bytes[4:6], smart_protocol.read_body_bytes(2))
+        self.assertEqual(expected_bytes[6], smart_protocol.read_body_bytes())
+
+    def test_client_cancel_read_body_does_not_eat_body_bytes(self):
+        # cancelling the expected body needs to finish the request, but not
+        # read any more bytes.
+        expected_bytes = "1234567"
+        server_bytes = (protocol.RESPONSE_VERSION_TWO +
+                        "success\nok\n7\n1234567done\n")
+        input = StringIO(server_bytes)
+        output = StringIO()
+        client_medium = medium.SmartSimplePipesClientMedium(input, output)
+        request = client_medium.get_request()
+        smart_protocol = protocol.SmartClientRequestProtocolTwo(request)
+        smart_protocol.call('foo')
+        smart_protocol.read_response_tuple(True)
+        smart_protocol.cancel_read_body()
+        self.assertEqual(len(protocol.RESPONSE_VERSION_TWO + 'success\nok\n'),
+                         input.tell())
         self.assertRaises(
             errors.ReadingCompleted, smart_protocol.read_body_bytes)
 
 
-class TestSmartProtocolTwoSpecifics(
-        TestSmartProtocol, TestSmartProtocolTwoSpecificsMixin):
-    """Tests for aspects of smart protocol version two that are unique to
-    version two.
-
-    Thus tests involving body streams and success/failure markers belong here.
-    """
-
-    client_protocol_class = protocol.SmartClientRequestProtocolTwo
-    server_protocol_class = protocol.SmartServerRequestProtocolTwo
-
-
-class TestVersionOneFeaturesInProtocolThree(
-    TestSmartProtocol, CommonSmartProtocolTestMixin):
-    """Tests for version one smart protocol features as implemented by version
-    three.
-    """
-
-    request_encoder = protocol.ProtocolThreeRequester
-    response_decoder = protocol.ProtocolThreeDecoder
-    # build_server_protocol_three is a function, so we can't set it as a class
-    # attribute directly, because then Python will assume it is actually a
-    # method.  So we make server_protocol_class be a static method, rather than
-    # simply doing:
-    # "server_protocol_class = protocol.build_server_protocol_three".
-    server_protocol_class = staticmethod(protocol.build_server_protocol_three)
-
-    def setUp(self):
-        super(TestVersionOneFeaturesInProtocolThree, self).setUp()
-        self.response_marker = protocol.MESSAGE_VERSION_THREE
-        self.request_marker = protocol.MESSAGE_VERSION_THREE
-
-    def test_construct_version_three_server_protocol(self):
-        smart_protocol = protocol.ProtocolThreeDecoder(None)
-        self.assertEqual('', smart_protocol.unused_data)
-        self.assertEqual([], smart_protocol._in_buffer_list)
-        self.assertEqual(0, smart_protocol._in_buffer_len)
-        self.assertFalse(smart_protocol._has_dispatched)
-        # The protocol starts by expecting four bytes, a length prefix for the
-        # headers.
-        self.assertEqual(4, smart_protocol.next_read_size())
-
-
-class NoOpRequest(_mod_request.SmartServerRequest):
-
-    def do(self):
-        return _mod_request.SuccessfulSmartServerResponse(())
-
-dummy_registry = {'ARG': NoOpRequest}
-
-
-class LoggingMessageHandler(object):
-
-    def __init__(self):
-        self.event_log = []
-
-    def _log(self, *args):
-        self.event_log.append(args)
-
-    def headers_received(self, headers):
-        self._log('headers', headers)
-
-    def protocol_error(self, exception):
-        self._log('protocol_error', exception)
-
-    def byte_part_received(self, byte):
-        self._log('byte', byte)
-
-    def bytes_part_received(self, bytes):
-        self._log('bytes', bytes)
-
-    def structure_part_received(self, structure):
-        self._log('structure', structure)
-
-    def end_received(self):
-        self._log('end')
-
-
-class TestProtocolThree(TestSmartProtocol):
-    """Tests for v3 of the server-side protocol."""
-
-    request_encoder = protocol.ProtocolThreeRequester
-    response_decoder = protocol.ProtocolThreeDecoder
-    server_protocol_class = protocol.ProtocolThreeDecoder
-
-    def test_trivial_request(self):
-        """Smoke test for the simplest possible v3 request: empty headers, no
-        message parts.
-        """
-        output = StringIO()
-        headers = '\0\0\0\x02de'  # length-prefixed, bencoded empty dict
-        end = 'e'
-        request_bytes = headers + end
-        smart_protocol = self.server_protocol_class(LoggingMessageHandler())
-        smart_protocol.accept_bytes(request_bytes)
-        self.assertEqual(0, smart_protocol.next_read_size())
-        self.assertEqual('', smart_protocol.unused_data)
-
-    def make_protocol_expecting_message_part(self):
-        headers = '\0\0\0\x02de'  # length-prefixed, bencoded empty dict
-        message_handler = LoggingMessageHandler()
-        smart_protocol = self.server_protocol_class(message_handler)
-        smart_protocol.accept_bytes(headers)
-        # Clear the event log
-        del message_handler.event_log[:]
-        return smart_protocol, message_handler.event_log
-
-    def test_decode_one_byte(self):
-        """The protocol can decode a 'one byte' message part."""
-        smart_protocol, event_log = self.make_protocol_expecting_message_part()
-        smart_protocol.accept_bytes('ox')
-        self.assertEqual([('byte', 'x')], event_log)
-
-    def test_decode_bytes(self):
-        """The protocol can decode a 'bytes' message part."""
-        smart_protocol, event_log = self.make_protocol_expecting_message_part()
-        smart_protocol.accept_bytes(
-            'b' # message part kind
-            '\0\0\0\x07' # length prefix
-            'payload' # payload
-            )
-        self.assertEqual([('bytes', 'payload')], event_log)
-
-    def test_decode_structure(self):
-        """The protocol can decode a 'structure' message part."""
-        smart_protocol, event_log = self.make_protocol_expecting_message_part()
-        smart_protocol.accept_bytes(
-            's' # message part kind
-            '\0\0\0\x07' # length prefix
-            'l3:ARGe' # ['ARG']
-            )
-        self.assertEqual([('structure', ['ARG'])], event_log)
-
-    def test_decode_multiple_bytes(self):
-        """The protocol can decode a multiple 'bytes' message parts."""
-        smart_protocol, event_log = self.make_protocol_expecting_message_part()
-        smart_protocol.accept_bytes(
-            'b' # message part kind
-            '\0\0\0\x05' # length prefix
-            'first' # payload
-            'b' # message part kind
-            '\0\0\0\x06'
-            'second'
-            )
-        self.assertEqual(
-            [('bytes', 'first'), ('bytes', 'second')], event_log)
-
-
-class TestConventionalResponseHandler(tests.TestCase):
-
-    def make_response_handler(self, response_bytes):
-        from bzrlib.smart.message import ConventionalResponseHandler
-        response_handler = ConventionalResponseHandler()
-        protocol_decoder = protocol.ProtocolThreeDecoder(response_handler)
-        # put decoder in desired state (waiting for message parts)
-        protocol_decoder.state_accept = protocol_decoder._state_accept_expecting_message_part
-        output = StringIO()
-        client_medium = medium.SmartSimplePipesClientMedium(
-            StringIO(response_bytes), output, 'base')
-        medium_request = client_medium.get_request()
-        medium_request.finished_writing()
-        response_handler.setProtoAndMediumRequest(
-            protocol_decoder, medium_request)
-        return response_handler
-
-    def test_body_stream_interrupted_by_error(self):
-        interrupted_body_stream = (
-            'oS' # successful response
-            's\0\0\0\x02le' # empty args
-            'b\0\0\0\x09chunk one' # first chunk
-            'b\0\0\0\x09chunk two' # second chunk
-            'oE' # error flag
-            's\0\0\0\x0el5:error3:abce' # bencoded error
-            'e' # message end
-            )
-        response_handler = self.make_response_handler(interrupted_body_stream)
-        stream = response_handler.read_streamed_body()
-        self.assertEqual('chunk one', stream.next())
-        self.assertEqual('chunk two', stream.next())
-        exc = self.assertRaises(errors.ErrorFromSmartServer, stream.next)
-        self.assertEqual(('error', 'abc'), exc.error_tuple)
-
-    def test_body_stream_interrupted_by_connection_lost(self):
-        interrupted_body_stream = (
-            'oS' # successful response
-            's\0\0\0\x02le' # empty args
-            'b\0\0\xff\xffincomplete chunk')
-        response_handler = self.make_response_handler(interrupted_body_stream)
-        stream = response_handler.read_streamed_body()
-        self.assertRaises(errors.ConnectionReset, stream.next)
-
-    def test_read_body_bytes_interrupted_by_connection_lost(self):
-        interrupted_body_stream = (
-            'oS' # successful response
-            's\0\0\0\x02le' # empty args
-            'b\0\0\xff\xffincomplete chunk')
-        response_handler = self.make_response_handler(interrupted_body_stream)
-        self.assertRaises(
-            errors.ConnectionReset, response_handler.read_body_bytes)
-
-
-class TestMessageHandlerErrors(tests.TestCase):
-    """Tests for v3 that unrecognised (but well-formed) requests/responses are
-    still fully read off the wire, so that subsequent requests/responses on the
-    same medium can be decoded.
-    """
-
-    def test_non_conventional_request(self):
-        """ConventionalRequestHandler (the default message handler on the
-        server side) will reject an unconventional message, but still consume
-        all the bytes of that message and signal when it has done so.
-
-        This is what allows a server to continue to accept requests after the
-        client sends a completely unrecognised request.
-        """
-        # Define an invalid request (but one that is a well-formed message).
-        # This particular invalid request not only lacks the mandatory
-        # verb+args tuple, it has a single-byte part, which is forbidden.  In
-        # fact it has that part twice, to trigger multiple errors.
-        invalid_request = (
-            protocol.MESSAGE_VERSION_THREE +  # protocol version marker
-            '\0\0\0\x02de' + # empty headers
-            'oX' + # a single byte part: 'X'.  ConventionalRequestHandler will
-                   # error at this part.
-            'oX' + # and again.
-            'e' # end of message
-            )
-
-        to_server = StringIO(invalid_request)
-        from_server = StringIO()
-        transport = memory.MemoryTransport('memory:///')
-        server = medium.SmartServerPipeStreamMedium(
-            to_server, from_server, transport)
-        proto = server._build_protocol()
-        message_handler = proto.message_handler
-        server._serve_one_request(proto)
-        # All the bytes have been read from the medium...
-        self.assertEqual('', to_server.read())
-        # ...and the protocol decoder has consumed all the bytes, and has
-        # finished reading.
-        self.assertEqual('', proto.unused_data)
-        self.assertEqual(0, proto.next_read_size())
-
-
-class InstrumentedRequestHandler(object):
-    """Test Double of SmartServerRequestHandler."""
-
-    def __init__(self):
-        self.calls = []
-
-    def body_chunk_received(self, chunk_bytes):
-        self.calls.append(('body_chunk_received', chunk_bytes))
-
-    def no_body_received(self):
-        self.calls.append(('no_body_received',))
-
-    def prefixed_body_received(self, body_bytes):
-        self.calls.append(('prefixed_body_received', body_bytes))
-
-    def end_received(self):
-        self.calls.append(('end_received',))
-
-
-class StubRequest(object):
-
-    def finished_reading(self):
-        pass
-
-
-class TestClientDecodingProtocolThree(TestSmartProtocol):
-    """Tests for v3 of the client-side protocol decoding."""
-
-    def make_logging_response_decoder(self):
-        """Make v3 response decoder using a test response handler."""
-        response_handler = LoggingMessageHandler()
-        decoder = protocol.ProtocolThreeDecoder(response_handler)
-        return decoder, response_handler
-
-    def make_conventional_response_decoder(self):
-        """Make v3 response decoder using a conventional response handler."""
-        response_handler = message.ConventionalResponseHandler()
-        decoder = protocol.ProtocolThreeDecoder(response_handler)
-        response_handler.setProtoAndMediumRequest(decoder, StubRequest())
-        return decoder, response_handler
-
-    def test_trivial_response_decoding(self):
-        """Smoke test for the simplest possible v3 response: empty headers,
-        status byte, empty args, no body.
-        """
-        headers = '\0\0\0\x02de'  # length-prefixed, bencoded empty dict
-        response_status = 'oS' # success
-        args = 's\0\0\0\x02le' # length-prefixed, bencoded empty list
-        end = 'e' # end marker
-        message_bytes = headers + response_status + args + end
-        decoder, response_handler = self.make_logging_response_decoder()
-        decoder.accept_bytes(message_bytes)
-        # The protocol decoder has finished, and consumed all bytes
-        self.assertEqual(0, decoder.next_read_size())
-        self.assertEqual('', decoder.unused_data)
-        # The message handler has been invoked with all the parts of the
-        # trivial response: empty headers, status byte, no args, end.
-        self.assertEqual(
-            [('headers', {}), ('byte', 'S'), ('structure', []), ('end',)],
-            response_handler.event_log)
-
-    def test_incomplete_message(self):
-        """A decoder will keep signalling that it needs more bytes via
-        next_read_size() != 0 until it has seen a complete message, regardless
-        which state it is in.
-        """
-        # Define a simple response that uses all possible message parts.
-        headers = '\0\0\0\x02de'  # length-prefixed, bencoded empty dict
-        response_status = 'oS' # success
-        args = 's\0\0\0\x02le' # length-prefixed, bencoded empty list
-        body = 'b\0\0\0\x04BODY' # a body: 'BODY'
-        end = 'e' # end marker
-        simple_response = headers + response_status + args + body + end
-        # Feed the request to the decoder one byte at a time.
-        decoder, response_handler = self.make_logging_response_decoder()
-        for byte in simple_response:
-            self.assertNotEqual(0, decoder.next_read_size())
-            decoder.accept_bytes(byte)
-        # Now the response is complete
-        self.assertEqual(0, decoder.next_read_size())
-
-    def test_read_response_tuple_raises_UnknownSmartMethod(self):
-        """read_response_tuple raises UnknownSmartMethod if the server replied
-        with 'UnknownMethod'.
-        """
-        headers = '\0\0\0\x02de'  # length-prefixed, bencoded empty dict
-        response_status = 'oE' # error flag
-        # args: ('UnknownMethod', 'method-name')
-        args = 's\0\0\0\x20l13:UnknownMethod11:method-namee'
-        end = 'e' # end marker
-        message_bytes = headers + response_status + args + end
-        decoder, response_handler = self.make_conventional_response_decoder()
-        decoder.accept_bytes(message_bytes)
-        error = self.assertRaises(
-            errors.UnknownSmartMethod, response_handler.read_response_tuple)
-        self.assertEqual('method-name', error.verb)
-
-    def test_read_response_tuple_error(self):
-        """If the response has an error, it is raised as an exception."""
-        headers = '\0\0\0\x02de'  # length-prefixed, bencoded empty dict
-        response_status = 'oE' # error
-        args = 's\0\0\0\x1al9:first arg10:second arge' # two args
-        end = 'e' # end marker
-        message_bytes = headers + response_status + args + end
-        decoder, response_handler = self.make_conventional_response_decoder()
-        decoder.accept_bytes(message_bytes)
-        error = self.assertRaises(
-            errors.ErrorFromSmartServer, response_handler.read_response_tuple)
-        self.assertEqual(('first arg', 'second arg'), error.error_tuple)
-
-
-class TestClientEncodingProtocolThree(TestSmartProtocol):
-
-    request_encoder = protocol.ProtocolThreeRequester
-    response_decoder = protocol.ProtocolThreeDecoder
-    server_protocol_class = protocol.ProtocolThreeDecoder
-
-    def make_client_encoder_and_output(self):
-        result = self.make_client_protocol_and_output()
-        requester, response_handler, output = result
-        return requester, output
-
-    def test_call_smoke_test(self):
-        """A smoke test for ProtocolThreeRequester.call.
-
-        This test checks that a particular simple invocation of call emits the
-        correct bytes for that invocation.
-        """
-        requester, output = self.make_client_encoder_and_output()
-        requester.set_headers({'header name': 'header value'})
-        requester.call('one arg')
-        self.assertEquals(
-            'bzr message 3 (bzr 1.6)\n' # protocol version
-            '\x00\x00\x00\x1fd11:header name12:header valuee' # headers
-            's\x00\x00\x00\x0bl7:one arge' # args
-            'e', # end
-            output.getvalue())
-
-    def test_call_with_body_bytes_smoke_test(self):
-        """A smoke test for ProtocolThreeRequester.call_with_body_bytes.
-
-        This test checks that a particular simple invocation of
-        call_with_body_bytes emits the correct bytes for that invocation.
-        """
-        requester, output = self.make_client_encoder_and_output()
-        requester.set_headers({'header name': 'header value'})
-        requester.call_with_body_bytes(('one arg',), 'body bytes')
-        self.assertEquals(
-            'bzr message 3 (bzr 1.6)\n' # protocol version
-            '\x00\x00\x00\x1fd11:header name12:header valuee' # headers
-            's\x00\x00\x00\x0bl7:one arge' # args
-            'b' # there is a prefixed body
-            '\x00\x00\x00\nbody bytes' # the prefixed body
-            'e', # end
-            output.getvalue())
-
-    def test_call_writes_just_once(self):
-        """A bodyless request is written to the medium all at once."""
-        medium_request = StubMediumRequest()
-        encoder = protocol.ProtocolThreeRequester(medium_request)
-        encoder.call('arg1', 'arg2', 'arg3')
-        self.assertEqual(
-            ['accept_bytes', 'finished_writing'], medium_request.calls)
-
-    def test_call_with_body_bytes_writes_just_once(self):
-        """A request with body bytes is written to the medium all at once."""
-        medium_request = StubMediumRequest()
-        encoder = protocol.ProtocolThreeRequester(medium_request)
-        encoder.call_with_body_bytes(('arg', 'arg'), 'body bytes')
-        self.assertEqual(
-            ['accept_bytes', 'finished_writing'], medium_request.calls)
-
-
-class StubMediumRequest(object):
-    """A stub medium request that tracks the number of times accept_bytes is
-    called.
-    """
-
-    def __init__(self):
-        self.calls = []
-        self._medium = 'dummy medium'
-
-    def accept_bytes(self, bytes):
-        self.calls.append('accept_bytes')
-
-    def finished_writing(self):
-        self.calls.append('finished_writing')
-
-
-class TestResponseEncodingProtocolThree(tests.TestCase):
-
-    def make_response_encoder(self):
-        out_stream = StringIO()
-        response_encoder = protocol.ProtocolThreeResponder(out_stream.write)
-        return response_encoder, out_stream
-
-    def test_send_error_unknown_method(self):
-        encoder, out_stream = self.make_response_encoder()
-        encoder.send_error(errors.UnknownSmartMethod('method name'))
-        # Use assertEndsWith so that we don't compare the header, which varies
-        # by bzrlib.__version__.
-        self.assertEndsWith(
-            out_stream.getvalue(),
-            # error status
-            'oE' +
-            # tuple: 'UnknownMethod', 'method name'
-            's\x00\x00\x00\x20l13:UnknownMethod11:method namee'
-            # end of message
-            'e')
-
-
-class TestResponseEncoderBufferingProtocolThree(tests.TestCase):
-    """Tests for buffering of responses.
-
-    We want to avoid doing many small writes when one would do, to avoid
-    unnecessary network overhead.
-    """
-
-    def setUp(self):
-        self.writes = []
-        self.responder = protocol.ProtocolThreeResponder(self.writes.append)
-
-    def assertWriteCount(self, expected_count):
-        self.assertEqual(
-            expected_count, len(self.writes),
-            "Too many writes: %r" % (self.writes,))
-        
-    def test_send_error_writes_just_once(self):
-        """An error response is written to the medium all at once."""
-        self.responder.send_error(Exception('An exception string.'))
-        self.assertWriteCount(1)
-
-    def test_send_response_writes_just_once(self):
-        """A normal response with no body is written to the medium all at once.
-        """
-        response = _mod_request.SuccessfulSmartServerResponse(('arg', 'arg'))
-        self.responder.send_response(response)
-        self.assertWriteCount(1)
-
-    def test_send_response_with_body_writes_just_once(self):
-        """A normal response with a monolithic body is written to the medium
-        all at once.
-        """
-        response = _mod_request.SuccessfulSmartServerResponse(
-            ('arg', 'arg'), body='body bytes')
-        self.responder.send_response(response)
-        self.assertWriteCount(1)
-
-    def test_send_response_with_body_stream_writes_once_per_chunk(self):
-        """A normal response with a stream body is written to the medium
-        writes to the medium once per chunk.
-        """
-        # Construct a response with stream with 2 chunks in it.
-        response = _mod_request.SuccessfulSmartServerResponse(
-            ('arg', 'arg'), body_stream=['chunk1', 'chunk2'])
-        self.responder.send_response(response)
-        # We will write 3 times: exactly once for each chunk, plus a final
-        # write to end the response.
-        self.assertWriteCount(3)
-
-
 class TestSmartClientUnicode(tests.TestCase):
     """_SmartClient tests for unicode arguments.
 
@@ -2756,8 +1903,7 @@
         """
         input = StringIO("\n")
         output = StringIO()
-        client_medium = medium.SmartSimplePipesClientMedium(
-            input, output, 'ignored base')
+        client_medium = medium.SmartSimplePipesClientMedium(input, output)
         smart_client = client._SmartClient(client_medium)
         self.assertRaises(TypeError,
             smart_client.call_with_body_bytes, method, args, body)
@@ -2775,276 +1921,6 @@
         self.assertCallDoesNotBreakMedium('method', ('args',), u'body')
 
 
-class MockMedium(medium.SmartClientMedium):
-    """A mock medium that can be used to test _SmartClient.
-    
-    It can be given a series of requests to expect (and responses it should
-    return for them).  It can also be told when the client is expected to
-    disconnect a medium.  Expectations must be satisfied in the order they are
-    given, or else an AssertionError will be raised.
-
-    Typical use looks like::
-
-        medium = MockMedium()
-        medium.expect_request(...)
-        medium.expect_request(...)
-        medium.expect_request(...)
-    """
-
-    def __init__(self):
-        super(MockMedium, self).__init__('dummy base')
-        self._mock_request = _MockMediumRequest(self)
-        self._expected_events = []
-        
-    def expect_request(self, request_bytes, response_bytes,
-                       allow_partial_read=False):
-        """Expect 'request_bytes' to be sent, and reply with 'response_bytes'.
-
-        No assumption is made about how many times accept_bytes should be
-        called to send the request.  Similarly, no assumption is made about how
-        many times read_bytes/read_line are called by protocol code to read a
-        response.  e.g.::
-        
-            request.accept_bytes('ab')
-            request.accept_bytes('cd')
-            request.finished_writing()
-
-        and::
-        
-            request.accept_bytes('abcd')
-            request.finished_writing()
-
-        Will both satisfy ``medium.expect_request('abcd', ...)``.  Thus tests
-        using this should not break due to irrelevant changes in protocol
-        implementations.
-
-        :param allow_partial_read: if True, no assertion is raised if a
-            response is not fully read.  Setting this is useful when the client
-            is expected to disconnect without needing to read the complete
-            response.  Default is False.
-        """
-        self._expected_events.append(('send request', request_bytes))
-        if allow_partial_read:
-            self._expected_events.append(
-                ('read response (partial)', response_bytes))
-        else:
-            self._expected_events.append(('read response', response_bytes))
-
-    def expect_disconnect(self):
-        """Expect the client to call ``medium.disconnect()``."""
-        self._expected_events.append('disconnect')
-
-    def _assertEvent(self, observed_event):
-        """Raise AssertionError unless observed_event matches the next expected
-        event.
-
-        :seealso: expect_request
-        :seealso: expect_disconnect
-        """
-        try:
-            expected_event = self._expected_events.pop(0)
-        except IndexError:
-            raise AssertionError(
-                'Mock medium observed event %r, but no more events expected'
-                % (observed_event,))
-        if expected_event[0] == 'read response (partial)':
-            if observed_event[0] != 'read response':
-                raise AssertionError(
-                    'Mock medium observed event %r, but expected event %r'
-                    % (observed_event, expected_event))
-        elif observed_event != expected_event:
-            raise AssertionError(
-                'Mock medium observed event %r, but expected event %r'
-                % (observed_event, expected_event))
-        if self._expected_events:
-            next_event = self._expected_events[0]
-            if next_event[0].startswith('read response'):
-                self._mock_request._response = next_event[1]
-
-    def get_request(self):
-        return self._mock_request
-
-    def disconnect(self):
-        if self._mock_request._read_bytes:
-            self._assertEvent(('read response', self._mock_request._read_bytes))
-            self._mock_request._read_bytes = ''
-        self._assertEvent('disconnect')
-
-
-class _MockMediumRequest(object):
-    """A mock ClientMediumRequest used by MockMedium."""
-
-    def __init__(self, mock_medium):
-        self._medium = mock_medium
-        self._written_bytes = ''
-        self._read_bytes = ''
-        self._response = None
-
-    def accept_bytes(self, bytes):
-        self._written_bytes += bytes
-
-    def finished_writing(self):
-        self._medium._assertEvent(('send request', self._written_bytes))
-        self._written_bytes = ''
-
-    def finished_reading(self):
-        self._medium._assertEvent(('read response', self._read_bytes))
-        self._read_bytes = ''
-
-    def read_bytes(self, size):
-        resp = self._response
-        bytes, resp = resp[:size], resp[size:]
-        self._response = resp
-        self._read_bytes += bytes
-        return bytes
-
-    def read_line(self):
-        resp = self._response
-        try:
-            line, resp = resp.split('\n', 1)
-            line += '\n'
-        except ValueError:
-            line, resp = resp, ''
-        self._response = resp
-        self._read_bytes += line
-        return line
-
-
-class Test_SmartClientVersionDetection(tests.TestCase):
-    """Tests for _SmartClient's automatic protocol version detection.
-
-    On the first remote call, _SmartClient will keep retrying the request with
-    different protocol versions until it finds one that works.
-    """
-
-    def test_version_three_server(self):
-        """With a protocol 3 server, only one request is needed."""
-        medium = MockMedium()
-        smart_client = client._SmartClient(medium, headers={})
-        message_start = protocol.MESSAGE_VERSION_THREE + '\x00\x00\x00\x02de'
-        medium.expect_request(
-            message_start +
-            's\x00\x00\x00\x1el11:method-name5:arg 15:arg 2ee',
-            message_start + 's\0\0\0\x13l14:response valueee')
-        result = smart_client.call('method-name', 'arg 1', 'arg 2')
-        # The call succeeded without raising any exceptions from the mock
-        # medium, and the smart_client returns the response from the server.
-        self.assertEqual(('response value',), result)
-        self.assertEqual([], medium._expected_events)
-        # Also, the v3 works then the server should be assumed to support RPCs
-        # introduced in 1.6.
-        self.assertFalse(medium._is_remote_before((1, 6)))
-
-    def test_version_two_server(self):
-        """If the server only speaks protocol 2, the client will first try
-        version 3, then fallback to protocol 2.
-
-        Further, _SmartClient caches the detection, so future requests will all
-        use protocol 2 immediately.
-        """
-        medium = MockMedium()
-        smart_client = client._SmartClient(medium, headers={})
-        # First the client should send a v3 request, but the server will reply
-        # with a v2 error.
-        medium.expect_request(
-            'bzr message 3 (bzr 1.6)\n\x00\x00\x00\x02de' +
-            's\x00\x00\x00\x1el11:method-name5:arg 15:arg 2ee',
-            'bzr response 2\nfailed\n\n')
-        # So then the client should disconnect to reset the connection, because
-        # the client needs to assume the server cannot read any further
-        # requests off the original connection.
-        medium.expect_disconnect()
-        # The client should then retry the original request in v2
-        medium.expect_request(
-            'bzr request 2\nmethod-name\x01arg 1\x01arg 2\n',
-            'bzr response 2\nsuccess\nresponse value\n')
-        result = smart_client.call('method-name', 'arg 1', 'arg 2')
-        # The smart_client object will return the result of the successful
-        # query.
-        self.assertEqual(('response value',), result)
-
-        # Now try another request, and this time the client will just use
-        # protocol 2.  (i.e. the autodetection won't be repeated)
-        medium.expect_request(
-            'bzr request 2\nanother-method\n',
-            'bzr response 2\nsuccess\nanother response\n')
-        result = smart_client.call('another-method')
-        self.assertEqual(('another response',), result)
-        self.assertEqual([], medium._expected_events)
-
-        # Also, because v3 is not supported, the client medium should assume
-        # that RPCs introduced in 1.6 aren't supported either.
-        self.assertTrue(medium._is_remote_before((1, 6)))
-
-    def test_unknown_version(self):
-        """If the server does not use any known (or at least supported)
-        protocol version, a SmartProtocolError is raised.
-        """
-        medium = MockMedium()
-        smart_client = client._SmartClient(medium, headers={})
-        unknown_protocol_bytes = 'Unknown protocol!'
-        # The client will try v3 and v2 before eventually giving up.
-        medium.expect_request(
-            'bzr message 3 (bzr 1.6)\n\x00\x00\x00\x02de' +
-            's\x00\x00\x00\x1el11:method-name5:arg 15:arg 2ee',
-            unknown_protocol_bytes)
-        medium.expect_disconnect()
-        medium.expect_request(
-            'bzr request 2\nmethod-name\x01arg 1\x01arg 2\n',
-            unknown_protocol_bytes)
-        medium.expect_disconnect()
-        self.assertRaises(
-            errors.SmartProtocolError,
-            smart_client.call, 'method-name', 'arg 1', 'arg 2')
-        self.assertEqual([], medium._expected_events)
-
-    def test_first_response_is_error(self):
-        """If the server replies with an error, then the version detection
-        should be complete.
-        
-        This test is very similar to test_version_two_server, but catches a bug
-        we had in the case where the first reply was an error response.
-        """
-        medium = MockMedium()
-        smart_client = client._SmartClient(medium, headers={})
-        message_start = protocol.MESSAGE_VERSION_THREE + '\x00\x00\x00\x02de'
-        # Issue a request that gets an error reply in a non-default protocol
-        # version.
-        medium.expect_request(
-            message_start +
-            's\x00\x00\x00\x10l11:method-nameee',
-            'bzr response 2\nfailed\n\n')
-        medium.expect_disconnect()
-        medium.expect_request(
-            'bzr request 2\nmethod-name\n',
-            'bzr response 2\nfailed\nFooBarError\n')
-        err = self.assertRaises(
-            errors.ErrorFromSmartServer,
-            smart_client.call, 'method-name')
-        self.assertEqual(('FooBarError',), err.error_tuple)
-        # Now the medium should have remembered the protocol version, so
-        # subsequent requests will use the remembered version immediately.
-        medium.expect_request(
-            'bzr request 2\nmethod-name\n',
-            'bzr response 2\nsuccess\nresponse value\n')
-        result = smart_client.call('method-name')
-        self.assertEqual(('response value',), result)
-        self.assertEqual([], medium._expected_events)
-
-
-class Test_SmartClient(tests.TestCase):
-
-    def test_call_default_headers(self):
-        """ProtocolThreeRequester.call by default sends a 'Software
-        version' header.
-        """
-        smart_client = client._SmartClient('dummy medium')
-        self.assertEqual(
-            bzrlib.__version__, smart_client._headers['Software version'])
-        # XXX: need a test that smart_client._headers is passed to the request
-        # encoder.
-
-
 class LengthPrefixedBodyDecoder(tests.TestCase):
 
     # XXX: TODO: make accept_reading_trailer invoke translate_response or 
@@ -3112,220 +1988,35 @@
         self.assertEqual('', decoder.unused_data)
 
 
-class TestChunkedBodyDecoder(tests.TestCase):
-    """Tests for ChunkedBodyDecoder.
-    
-    This is the body decoder used for protocol version two.
-    """
-
-    def test_construct(self):
-        decoder = protocol.ChunkedBodyDecoder()
-        self.assertFalse(decoder.finished_reading)
-        self.assertEqual(8, decoder.next_read_size())
-        self.assertEqual(None, decoder.read_next_chunk())
-        self.assertEqual('', decoder.unused_data)
-
-    def test_empty_content(self):
-        """'chunked\nEND\n' is the complete encoding of a zero-length body.
-        """
-        decoder = protocol.ChunkedBodyDecoder()
-        decoder.accept_bytes('chunked\n')
-        decoder.accept_bytes('END\n')
-        self.assertTrue(decoder.finished_reading)
-        self.assertEqual(None, decoder.read_next_chunk())
-        self.assertEqual('', decoder.unused_data)
-
-    def test_one_chunk(self):
-        """A body in a single chunk is decoded correctly."""
-        decoder = protocol.ChunkedBodyDecoder()
-        decoder.accept_bytes('chunked\n')
-        chunk_length = 'f\n'
-        chunk_content = '123456789abcdef'
-        finish = 'END\n'
-        decoder.accept_bytes(chunk_length + chunk_content + finish)
-        self.assertTrue(decoder.finished_reading)
-        self.assertEqual(chunk_content, decoder.read_next_chunk())
-        self.assertEqual('', decoder.unused_data)
-        
-    def test_incomplete_chunk(self):
-        """When there are less bytes in the chunk than declared by the length,
-        then we haven't finished reading yet.
-        """
-        decoder = protocol.ChunkedBodyDecoder()
-        decoder.accept_bytes('chunked\n')
-        chunk_length = '8\n'
-        three_bytes = '123'
-        decoder.accept_bytes(chunk_length + three_bytes)
-        self.assertFalse(decoder.finished_reading)
-        self.assertEqual(
-            5 + 4, decoder.next_read_size(),
-            "The next_read_size hint should be the number of missing bytes in "
-            "this chunk plus 4 (the length of the end-of-body marker: "
-            "'END\\n')")
-        self.assertEqual(None, decoder.read_next_chunk())
-
-    def test_incomplete_length(self):
-        """A chunk length hasn't been read until a newline byte has been read.
-        """
-        decoder = protocol.ChunkedBodyDecoder()
-        decoder.accept_bytes('chunked\n')
-        decoder.accept_bytes('9')
-        self.assertEqual(
-            1, decoder.next_read_size(),
-            "The next_read_size hint should be 1, because we don't know the "
-            "length yet.")
-        decoder.accept_bytes('\n')
-        self.assertEqual(
-            9 + 4, decoder.next_read_size(),
-            "The next_read_size hint should be the length of the chunk plus 4 "
-            "(the length of the end-of-body marker: 'END\\n')")
-        self.assertFalse(decoder.finished_reading)
-        self.assertEqual(None, decoder.read_next_chunk())
-
-    def test_two_chunks(self):
-        """Content from multiple chunks is concatenated."""
-        decoder = protocol.ChunkedBodyDecoder()
-        decoder.accept_bytes('chunked\n')
-        chunk_one = '3\naaa'
-        chunk_two = '5\nbbbbb'
-        finish = 'END\n'
-        decoder.accept_bytes(chunk_one + chunk_two + finish)
-        self.assertTrue(decoder.finished_reading)
-        self.assertEqual('aaa', decoder.read_next_chunk())
-        self.assertEqual('bbbbb', decoder.read_next_chunk())
-        self.assertEqual(None, decoder.read_next_chunk())
-        self.assertEqual('', decoder.unused_data)
-
-    def test_excess_bytes(self):
-        """Bytes after the chunked body are reported as unused bytes."""
-        decoder = protocol.ChunkedBodyDecoder()
-        decoder.accept_bytes('chunked\n')
-        chunked_body = "5\naaaaaEND\n"
-        excess_bytes = "excess bytes"
-        decoder.accept_bytes(chunked_body + excess_bytes)
-        self.assertTrue(decoder.finished_reading)
-        self.assertEqual('aaaaa', decoder.read_next_chunk())
-        self.assertEqual(excess_bytes, decoder.unused_data)
-        self.assertEqual(
-            1, decoder.next_read_size(),
-            "next_read_size hint should be 1 when finished_reading.")
-
-    def test_multidigit_length(self):
-        """Lengths in the chunk prefixes can have multiple digits."""
-        decoder = protocol.ChunkedBodyDecoder()
-        decoder.accept_bytes('chunked\n')
-        length = 0x123
-        chunk_prefix = hex(length) + '\n'
-        chunk_bytes = 'z' * length
-        finish = 'END\n'
-        decoder.accept_bytes(chunk_prefix + chunk_bytes + finish)
-        self.assertTrue(decoder.finished_reading)
-        self.assertEqual(chunk_bytes, decoder.read_next_chunk())
-
-    def test_byte_at_a_time(self):
-        """A complete body fed to the decoder one byte at a time should not
-        confuse the decoder.  That is, it should give the same result as if the
-        bytes had been received in one batch.
-
-        This test is the same as test_one_chunk apart from the way accept_bytes
-        is called.
-        """
-        decoder = protocol.ChunkedBodyDecoder()
-        decoder.accept_bytes('chunked\n')
-        chunk_length = 'f\n'
-        chunk_content = '123456789abcdef'
-        finish = 'END\n'
-        for byte in (chunk_length + chunk_content + finish):
-            decoder.accept_bytes(byte)
-        self.assertTrue(decoder.finished_reading)
-        self.assertEqual(chunk_content, decoder.read_next_chunk())
-        self.assertEqual('', decoder.unused_data)
-
-    def test_read_pending_data_resets(self):
-        """read_pending_data does not return the same bytes twice."""
-        decoder = protocol.ChunkedBodyDecoder()
-        decoder.accept_bytes('chunked\n')
-        chunk_one = '3\naaa'
-        chunk_two = '3\nbbb'
-        finish = 'END\n'
-        decoder.accept_bytes(chunk_one)
-        self.assertEqual('aaa', decoder.read_next_chunk())
-        decoder.accept_bytes(chunk_two)
-        self.assertEqual('bbb', decoder.read_next_chunk())
-        self.assertEqual(None, decoder.read_next_chunk())
-
-    def test_decode_error(self):
-        decoder = protocol.ChunkedBodyDecoder()
-        decoder.accept_bytes('chunked\n')
-        chunk_one = 'b\nfirst chunk'
-        error_signal = 'ERR\n'
-        error_chunks = '5\npart1' + '5\npart2'
-        finish = 'END\n'
-        decoder.accept_bytes(chunk_one + error_signal + error_chunks + finish)
-        self.assertTrue(decoder.finished_reading)
-        self.assertEqual('first chunk', decoder.read_next_chunk())
-        expected_failure = _mod_request.FailedSmartServerResponse(
-            ('part1', 'part2'))
-        self.assertEqual(expected_failure, decoder.read_next_chunk())
-
-    def test_bad_header(self):
-        """accept_bytes raises a SmartProtocolError if a chunked body does not
-        start with the right header.
-        """
-        decoder = protocol.ChunkedBodyDecoder()
-        self.assertRaises(
-            errors.SmartProtocolError, decoder.accept_bytes, 'bad header\n')
-
-
 class TestSuccessfulSmartServerResponse(tests.TestCase):
 
-    def test_construct_no_body(self):
-        response = _mod_request.SuccessfulSmartServerResponse(('foo', 'bar'))
+    def test_construct(self):
+        response = request.SuccessfulSmartServerResponse(('foo', 'bar'))
         self.assertEqual(('foo', 'bar'), response.args)
         self.assertEqual(None, response.body)
-
-    def test_construct_with_body(self):
-        response = _mod_request.SuccessfulSmartServerResponse(('foo', 'bar'),
-                                                              'bytes')
+        response = request.SuccessfulSmartServerResponse(('foo', 'bar'), 'bytes')
         self.assertEqual(('foo', 'bar'), response.args)
         self.assertEqual('bytes', response.body)
-        # repr(response) doesn't trigger exceptions.
-        repr(response)
-
-    def test_construct_with_body_stream(self):
-        bytes_iterable = ['abc']
-        response = _mod_request.SuccessfulSmartServerResponse(
-            ('foo', 'bar'), body_stream=bytes_iterable)
-        self.assertEqual(('foo', 'bar'), response.args)
-        self.assertEqual(bytes_iterable, response.body_stream)
-
-    def test_construct_rejects_body_and_body_stream(self):
-        """'body' and 'body_stream' are mutually exclusive."""
-        self.assertRaises(
-            errors.BzrError,
-            _mod_request.SuccessfulSmartServerResponse, (), 'body', ['stream'])
 
     def test_is_successful(self):
         """is_successful should return True for SuccessfulSmartServerResponse."""
-        response = _mod_request.SuccessfulSmartServerResponse(('error',))
+        response = request.SuccessfulSmartServerResponse(('error',))
         self.assertEqual(True, response.is_successful())
 
 
 class TestFailedSmartServerResponse(tests.TestCase):
 
     def test_construct(self):
-        response = _mod_request.FailedSmartServerResponse(('foo', 'bar'))
+        response = request.FailedSmartServerResponse(('foo', 'bar'))
         self.assertEqual(('foo', 'bar'), response.args)
         self.assertEqual(None, response.body)
-        response = _mod_request.FailedSmartServerResponse(('foo', 'bar'), 'bytes')
+        response = request.FailedSmartServerResponse(('foo', 'bar'), 'bytes')
         self.assertEqual(('foo', 'bar'), response.args)
         self.assertEqual('bytes', response.body)
-        # repr(response) doesn't trigger exceptions.
-        repr(response)
 
     def test_is_successful(self):
         """is_successful should return False for FailedSmartServerResponse."""
-        response = _mod_request.FailedSmartServerResponse(('error',))
+        response = request.FailedSmartServerResponse(('error',))
         self.assertEqual(False, response.is_successful())
 
 
@@ -3338,13 +2029,38 @@
         return None
 
 
-class HTTPTunnellingSmokeTest(tests.TestCase):
-
+class HTTPTunnellingSmokeTest(tests.TestCaseWithTransport):
+    
     def setUp(self):
         super(HTTPTunnellingSmokeTest, self).setUp()
         # We use the VFS layer as part of HTTP tunnelling tests.
         self._captureVar('BZR_NO_SMART_VFS', None)
 
+    def _test_bulk_data(self, url_protocol):
+        # We should be able to send and receive bulk data in a single message.
+        # The 'readv' command in the smart protocol both sends and receives bulk
+        # data, so we use that.
+        self.build_tree(['data-file'])
+        self.transport_readonly_server = HTTPServerWithSmarts
+
+        http_transport = self.get_readonly_transport()
+        medium = http_transport.get_smart_medium()
+        # Since we provide the medium, the url below will be mostly ignored
+        # during the test, as long as the path is '/'.
+        remote_transport = remote.RemoteTransport('bzr://fake_host/',
+                                                  medium=medium)
+        self.assertEqual(
+            [(0, "c")], list(remote_transport.readv("data-file", [(0,1)])))
+
+    def test_bulk_data_pycurl(self):
+        try:
+            self._test_bulk_data('http+pycurl')
+        except errors.UnsupportedProtocol, e:
+            raise tests.TestSkipped(str(e))
+    
+    def test_bulk_data_urllib(self):
+        self._test_bulk_data('http+urllib')
+
     def test_smart_http_medium_request_accept_bytes(self):
         medium = FakeHTTPMedium()
         request = SmartClientHTTPMediumRequest(medium)
@@ -3354,6 +2070,85 @@
         request.finished_writing()
         self.assertEqual('abcdef', medium.written_request)
 
+    def _test_http_send_smart_request(self, url_protocol):
+        http_server = HTTPServerWithSmarts()
+        http_server._url_protocol = url_protocol
+        http_server.setUp(self.get_vfs_only_server())
+        self.addCleanup(http_server.tearDown)
+
+        post_body = 'hello\n'
+        expected_reply_body = 'ok\x012\n'
+
+        http_transport = get_transport(http_server.get_url())
+        medium = http_transport.get_smart_medium()
+        response = medium.send_http_smart_request(post_body)
+        reply_body = response.read()
+        self.assertEqual(expected_reply_body, reply_body)
+
+    def test_http_send_smart_request_pycurl(self):
+        try:
+            self._test_http_send_smart_request('http+pycurl')
+        except errors.UnsupportedProtocol, e:
+            raise tests.TestSkipped(str(e))
+
+    def test_http_send_smart_request_urllib(self):
+        self._test_http_send_smart_request('http+urllib')
+
+    def test_http_server_with_smarts(self):
+        self.transport_readonly_server = HTTPServerWithSmarts
+
+        post_body = 'hello\n'
+        expected_reply_body = 'ok\x012\n'
+
+        smart_server_url = self.get_readonly_url('.bzr/smart')
+        reply = urllib2.urlopen(smart_server_url, post_body).read()
+
+        self.assertEqual(expected_reply_body, reply)
+
+    def test_smart_http_server_post_request_handler(self):
+        self.transport_readonly_server = HTTPServerWithSmarts
+        httpd = self.get_readonly_server()._get_httpd()
+
+        socket = SampleSocket(
+            'POST /.bzr/smart HTTP/1.0\r\n'
+            # HTTP/1.0 posts must have a Content-Length.
+            'Content-Length: 6\r\n'
+            '\r\n'
+            'hello\n')
+        # Beware: the ('localhost', 80) below is the
+        # client_address parameter, but we don't have one because
+        # we have defined a socket which is not bound to an
+        # address. The test framework never uses this client
+        # address, so far...
+        request_handler = SmartRequestHandler(socket, ('localhost', 80), httpd)
+        response = socket.writefile.getvalue()
+        self.assertStartsWith(response, 'HTTP/1.0 200 ')
+        # This includes the end of the HTTP headers, and all the body.
+        expected_end_of_response = '\r\n\r\nok\x012\n'
+        self.assertEndsWith(response, expected_end_of_response)
+
+
+class SampleSocket(object):
+    """A socket-like object for use in testing the HTTP request handler."""
+    
+    def __init__(self, socket_read_content):
+        """Constructs a sample socket.
+
+        :param socket_read_content: a byte sequence
+        """
+        # Use plain python StringIO so we can monkey-patch the close method to
+        # not discard the contents.
+        from StringIO import StringIO
+        self.readfile = StringIO(socket_read_content)
+        self.writefile = StringIO()
+        self.writefile.close = lambda: None
+        
+    def makefile(self, mode='r', bufsize=None):
+        if 'r' in mode:
+            return self.readfile
+        else:
+            return self.writefile
+
 
 class RemoteHTTPTransportTestCase(tests.TestCase):
 
@@ -3369,9 +2164,20 @@
         self.assertEqual(base_transport._http_transport,
                          new_transport._http_transport)
         self.assertEqual('child_dir/foo', new_transport._remote_path('foo'))
-        self.assertEqual(
-            'child_dir/',
-            new_transport._client.remote_path_from_transport(new_transport))
+
+    def test_remote_path_after_clone_parent(self):
+        # However, accessing a parent directory should go direct to the parent's
+        # URL.  We don't send relpaths like "../foo" in smart requests.
+        base_transport = remote.RemoteHTTPTransport('bzr+http://host/path1/path2')
+        new_transport = base_transport.clone('..')
+        self.assertEqual('foo', new_transport._remote_path('foo'))
+        new_transport = base_transport.clone('../')
+        self.assertEqual('foo', new_transport._remote_path('foo'))
+        new_transport = base_transport.clone('../abc')
+        self.assertEqual('foo', new_transport._remote_path('foo'))
+        # "abc/../.." should be equivalent to ".."
+        new_transport = base_transport.clone('abc/../..')
+        self.assertEqual('foo', new_transport._remote_path('foo'))
 
     def test_remote_path_unnormal_base(self):
         # If the transport's base isn't normalised, the _remote_path should
@@ -3385,9 +2191,6 @@
         base_transport = remote.RemoteHTTPTransport('bzr+http://host/%7Ea/b')
         new_transport = base_transport.clone('c')
         self.assertEqual('bzr+http://host/%7Ea/b/c/', new_transport.base)
-        self.assertEqual(
-            'c/',
-            new_transport._client.remote_path_from_transport(new_transport))
 
         
 # TODO: Client feature that does get_bundle and then installs that into a

=== modified file 'bzrlib/tests/test_source.py'
--- bzrlib/tests/test_source.py	2008-08-11 02:04:00 +0000
+++ bzrlib/tests/test_source.py	2007-08-15 04:33:34 +0000
@@ -1,6 +1,5 @@
-# Copyright (C) 2005, 2006, 2008 Canonical Ltd
+# Copyright (C) 2005, 2006 Canonical Ltd
 #   Authors: Robert Collins <robert.collins@canonical.com>
-#            and others
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -23,22 +22,15 @@
 
 # import system imports here
 import os
-import parser
 import re
-import symbol
 import sys
-import token
 
 #import bzrlib specific imports here
 from bzrlib import (
     osutils,
     )
 import bzrlib.branch
-from bzrlib.tests import (
-    KnownFailure,
-    TestCase,
-    TestSkipped,
-    )
+from bzrlib.tests import TestCase, TestSkipped
 
 
 # Files which are listed here will be skipped when testing for Copyright (or
@@ -55,8 +47,6 @@
 
     def source_file_name(self, package):
         """Return the path of the .py file for package."""
-        if getattr(sys, "frozen", None) is not None:
-            raise TestSkipped("can't test sources in frozen distributions.")
         path = package.__file__
         if path[-1] in 'co':
             return path[:-1]
@@ -111,11 +101,7 @@
         return source_dir
 
     def get_source_files(self):
-        """Yield all source files for bzr and bzrlib
-        
-        :param our_files_only: If true, exclude files from included libraries
-            or plugins.
-        """
+        """yield all source files for bzr and bzrlib"""
         bzrlib_dir = self.get_bzrlib_dir()
 
         # This is the front-end 'bzr' script
@@ -140,31 +126,30 @@
                 f.close()
             yield fname, text
 
-    def is_our_code(self, fname):
-        """Return true if it's a "real" part of bzrlib rather than external code"""
-        if '/util/' in fname or '/plugins/' in fname:
-            return False
-        else:
-            return True
-
     def is_copyright_exception(self, fname):
         """Certain files are allowed to be different"""
-        if not self.is_our_code(fname):
+        if '/util/' in fname or '/plugins/' in fname:
             # We don't ask that external utilities or plugins be
             # (C) Canonical Ltd
             return True
+
         for exc in COPYRIGHT_EXCEPTIONS:
             if fname.endswith(exc):
                 return True
+
         return False
 
     def is_license_exception(self, fname):
         """Certain files are allowed to be different"""
-        if not self.is_our_code(fname):
+        if '/util/' in fname or '/plugins/' in fname:
+            # We don't ask that external utilities or plugins be
+            # (C) Canonical Ltd
             return True
+
         for exc in LICENSE_EXCEPTIONS:
             if fname.endswith(exc):
                 return True
+
         return False
 
     def test_tmpdir_not_in_source_files(self):
@@ -268,7 +253,7 @@
         incorrect = []
 
         for fname, text in self.get_source_file_contents():
-            if not self.is_our_code(fname):
+            if '/util/' in fname or '/plugins/' in fname:
                 continue
             if '\t' in text:
                 incorrect.append(fname)
@@ -278,31 +263,3 @@
               '\nThey should either be replaced by "\\t" or by spaces:'
               '\n\n    %s'
               % ('\n    '.join(incorrect)))
-
-    def test_no_asserts(self):
-        """bzr shouldn't use the 'assert' statement."""
-        # assert causes too much variation between -O and not, and tends to
-        # give bad errors to the user
-        def search(x):
-            # scan down through x for assert statements, report any problems
-            # this is a bit cheesy; it may get some false positives?
-            if x[0] == symbol.assert_stmt:
-                return True
-            elif x[0] == token.NAME:
-                # can't search further down
-                return False
-            for sub in x[1:]:
-                if sub and search(sub):
-                    return True
-            return False
-        badfiles = []
-        for fname, text in self.get_source_file_contents():
-            if not self.is_our_code(fname):
-                continue
-            ast = parser.ast2tuple(parser.suite(''.join(text)))
-            if search(ast):
-                badfiles.append(fname)
-        if badfiles:
-            self.fail(
-                "these files contain an assert statement and should not:\n%s"
-                % '\n'.join(badfiles))

=== modified file 'bzrlib/tests/test_ssh_transport.py'
--- bzrlib/tests/test_ssh_transport.py	2008-02-08 18:36:35 +0000
+++ bzrlib/tests/test_ssh_transport.py	2007-03-02 14:10:15 +0000
@@ -184,7 +184,7 @@
         self.assertEqual(
             vendor._get_vendor_specific_argv(
                 "user", "host", 100, command=["bzr"]),
-            ["plink", "-x", "-a", "-ssh", "-2", "-batch",
+            ["plink", "-x", "-a", "-ssh", "-2",
                 "-P", "100",
                 "-l", "user",
                 "host", "bzr"]
@@ -195,7 +195,7 @@
         self.assertEqual(
             vendor._get_vendor_specific_argv(
                 "user", "host", 100, subsystem="sftp"),
-            ["plink", "-x", "-a", "-ssh", "-2", "-batch",
+            ["plink", "-x", "-a", "-ssh", "-2",
                 "-P", "100",
                 "-l", "user",
                 "-s", "host", "sftp"]

=== modified file 'bzrlib/tests/test_status.py'
--- bzrlib/tests/test_status.py	2008-08-16 22:28:01 +0000
+++ bzrlib/tests/test_status.py	2006-10-05 05:37:25 +0000
@@ -17,7 +17,6 @@
 
 from StringIO import StringIO
 
-from bzrlib import config
 from bzrlib.revisionspec import RevisionSpec
 from bzrlib.status import show_pending_merges, show_tree_status
 from bzrlib.tests import TestCaseWithTransport
@@ -35,72 +34,9 @@
         # do a merge
         tree2.merge_from_branch(tree.branch)
         output = StringIO()
-        tree2.lock_read()
-        try:
-            show_pending_merges(tree2, output)
-        finally:
-            tree2.unlock()
+        show_pending_merges(tree2, output)
         self.assertContainsRe(output.getvalue(), 'empty commit')
 
-    def test_multiple_pending(self):
-        config.GlobalConfig().set_user_option('email', 'Joe Foo <joe@foo.com>')
-        tree = self.make_branch_and_tree('a')
-        tree.commit('commit 1', timestamp=1196796819, timezone=0)
-        tree2 = tree.bzrdir.clone('b').open_workingtree()
-        tree.commit('commit 2', timestamp=1196796819, timezone=0)
-        tree2.commit('commit 2b', timestamp=1196796819, timezone=0)
-        tree3 = tree2.bzrdir.clone('c').open_workingtree()
-        tree2.commit('commit 3b', timestamp=1196796819, timezone=0)
-        tree3.commit('commit 3c', timestamp=1196796819, timezone=0)
-        tree.merge_from_branch(tree2.branch)
-        tree.merge_from_branch(tree3.branch)
-        output = StringIO()
-        tree.lock_read()
-        self.addCleanup(tree.unlock)
-        show_pending_merges(tree, output)
-        # Even though 2b is in the ancestry of 3c, it should only be displayed
-        # under the first merge parent.
-        self.assertEqualDiff('pending merges:\n'
-                             '  Joe Foo 2007-12-04 commit 3b\n'
-                             '    Joe Foo 2007-12-04 commit 2b\n'
-                             '  Joe Foo 2007-12-04 commit 3c\n',
-                             output.getvalue())
-
-    def test_with_pending_ghost(self):
-        """Test when a pending merge is itself a ghost"""
-        tree = self.make_branch_and_tree('a')
-        tree.commit('first')
-        tree.add_parent_tree_id('a-ghost-revision')
-        tree.lock_read()
-        self.addCleanup(tree.unlock)
-        output = StringIO()
-        show_pending_merges(tree, output)
-        self.assertEqualDiff('pending merges:\n'
-                             '  (ghost) a-ghost-revision\n',
-                             output.getvalue())
-
-    def test_pending_with_ghosts(self):
-        """Test when a pending merge's ancestry includes ghosts."""
-        config.GlobalConfig().set_user_option('email', 'Joe Foo <joe@foo.com>')
-        tree = self.make_branch_and_tree('a')
-        tree.commit('empty commit')
-        tree2 = tree.bzrdir.clone('b').open_workingtree()
-        tree2.commit('a non-ghost', timestamp=1196796819, timezone=0)
-        tree2.add_parent_tree_id('a-ghost-revision')
-        tree2.commit('commit with ghost', timestamp=1196796819, timezone=0)
-        tree2.commit('another non-ghost', timestamp=1196796819, timezone=0)
-        tree.merge_from_branch(tree2.branch)
-        tree.lock_read()
-        self.addCleanup(tree.unlock)
-        output = StringIO()
-        show_pending_merges(tree, output)
-        self.assertEqualDiff('pending merges:\n'
-                             '  Joe Foo 2007-12-04 another non-ghost\n'
-                             '    Joe Foo 2007-12-04 commit with ghost\n'
-                             '    (ghost) a-ghost-revision\n'
-                             '    Joe Foo 2007-12-04 a non-ghost\n',
-                             output.getvalue())
-
     def tests_revision_to_revision(self):
         """doing a status between two revision trees should work."""
         tree = self.make_branch_and_tree('.')

=== modified file 'bzrlib/tests/test_store.py'
--- bzrlib/tests/test_store.py	2008-05-12 04:20:02 +0000
+++ bzrlib/tests/test_store.py	2007-08-15 04:33:34 +0000
@@ -398,50 +398,39 @@
 
     def test_escaped_uppercase(self):
         """Uppercase letters are escaped for safety on Windows"""
-        my_store = store.TransportStore(MemoryTransport(), prefixed=True,
-            escaped=True)
+        my_store = store.TransportStore(MemoryTransport(), escaped=True)
         # a particularly perverse file-id! :-)
-        self.assertEquals(my_store._relpath('C:<>'), 'be/%2543%253a%253c%253e')
+        self.assertEquals(my_store._escape_file_id('C:<>'), '%43%3a%3c%3e')
 
 
 class TestVersionFileStore(TestCaseWithTransport):
 
-    def get_scope(self):
-        return self._transaction
-
     def setUp(self):
         super(TestVersionFileStore, self).setUp()
         self.vfstore = store.versioned.VersionedFileStore(MemoryTransport())
-        self.vfstore.get_scope = self.get_scope
-        self._transaction = None
 
     def test_get_weave_registers_dirty_in_write(self):
-        self._transaction = transactions.WriteTransaction()
-        vf = self.vfstore.get_weave_or_empty('id', self._transaction)
-        self._transaction.finish()
-        self._transaction = None
-        self.assertRaises(errors.OutSideTransaction, vf.add_lines, 'b', [], [])
-        self._transaction = transactions.WriteTransaction()
-        vf = self.vfstore.get_weave('id', self._transaction)
-        self._transaction.finish()
-        self._transaction = None
-        self.assertRaises(errors.OutSideTransaction, vf.add_lines, 'b', [], [])
+        transaction = transactions.WriteTransaction()
+        vf = self.vfstore.get_weave_or_empty('id', transaction)
+        transaction.finish()
+        self.assertRaises(errors.OutSideTransaction, vf.add_lines, 'b', [], [])
+        transaction = transactions.WriteTransaction()
+        vf = self.vfstore.get_weave('id', transaction)
+        transaction.finish()
+        self.assertRaises(errors.OutSideTransaction, vf.add_lines, 'b', [], [])
+
+    def test_get_weave_or_empty_readonly_fails(self):
+        transaction = transactions.ReadOnlyTransaction()
+        vf = self.assertRaises(errors.ReadOnlyError,
+                               self.vfstore.get_weave_or_empty,
+                               'id',
+                               transaction)
 
     def test_get_weave_readonly_cant_write(self):
-        self._transaction = transactions.WriteTransaction()
-        vf = self.vfstore.get_weave_or_empty('id', self._transaction)
-        self._transaction.finish()
-        self._transaction = transactions.ReadOnlyTransaction()
-        vf = self.vfstore.get_weave_or_empty('id', self._transaction)
+        transaction = transactions.WriteTransaction()
+        vf = self.vfstore.get_weave_or_empty('id', transaction)
+        transaction.finish()
+        transaction = transactions.ReadOnlyTransaction()
+        vf = self.vfstore.get_weave_or_empty('id', transaction)
         self.assertRaises(errors.ReadOnlyError, vf.add_lines, 'b', [], [])
 
-    def test___iter__escaped(self):
-        self.vfstore = store.versioned.VersionedFileStore(MemoryTransport(),
-            prefixed=True, escaped=True)
-        self.vfstore.get_scope = self.get_scope
-        self._transaction = transactions.WriteTransaction()
-        vf = self.vfstore.get_weave_or_empty(' ', self._transaction)
-        vf.add_lines('a', [], [])
-        del vf
-        self._transaction.finish()
-        self.assertEqual([' '], list(self.vfstore))

=== modified file 'bzrlib/tests/test_strace.py'
--- bzrlib/tests/test_strace.py	2008-05-07 17:54:04 +0000
+++ bzrlib/tests/test_strace.py	2007-07-03 09:28:59 +0000
@@ -19,15 +19,12 @@
 
 import errno
 import subprocess
-import threading
 
-from bzrlib import (
-    tests,
-    )
 from bzrlib.strace import StraceFeature, strace_detailed, StraceResult
-
-
-class TestStraceFeature(tests.TestCaseWithTransport):
+from bzrlib.tests import TestCaseWithTransport
+
+
+class TestStraceFeature(TestCaseWithTransport):
 
     def test_strace_detection(self):
         """Strace is available if its runnable."""
@@ -46,24 +43,11 @@
         self.assertEqual(found_strace, StraceFeature.available())
 
 
-class TestStrace(tests.TestCaseWithTransport):
+class TestStrace(TestCaseWithTransport):
 
     _test_needs_features = [StraceFeature]
 
-    def _check_threads(self):
-        # For bug #226769, it was decided that the strace tests should not be
-        # run when more than one thread is active. A lot of tests are currently
-        # leaking threads for good or bad reasons, once they are fixed or
-        # strace itself is fixed (bug #103133), we can get rid of the
-        # restriction.
-        active = threading.activeCount()
-        if active > 1: # There is always the main thread at least
-            raise tests.KnownFailure(
-                '%d active threads, bug #103133 needs to be fixed.' % active)
-
     def test_strace_callable_is_called(self):
-        self._check_threads()
-
         output = []
         def function(positional, *args, **kwargs):
             output.append((positional, args, kwargs))
@@ -72,8 +56,6 @@
         self.assertEqual([("a", ("b",), {"c":"c"})], output)
 
     def test_strace_callable_result(self):
-        self._check_threads()
-
         def function():
             return "foo"
         result, strace_result = strace_detailed(function,[], {},
@@ -83,8 +65,6 @@
 
     def test_strace_result_has_raw_log(self):
         """Checks that a reasonable raw strace log was found by strace."""
-        self._check_threads()
-
         def function():
             self.build_tree(['myfile'])
         unused, result = strace_detailed(function, [], {},

=== modified file 'bzrlib/tests/test_subsume.py'
--- bzrlib/tests/test_subsume.py	2008-04-24 07:22:53 +0000
+++ bzrlib/tests/test_subsume.py	2007-03-06 08:41:40 +0000
@@ -22,7 +22,7 @@
     def make_branch_and_tree(self, relpath, format=None):
         if format is None:
             format = 'dirstate-with-subtree'
-        return tests.TestCaseWithTransport.make_branch_and_tree(self, relpath,
+        return tests.TestCaseWithTransport.make_branch_and_tree(self, relpath, 
                                                                 format)
 
     def make_trees(self, format=None, same_root=False):
@@ -59,7 +59,7 @@
 
     def test_subsume_tree(self):
         base_tree, sub_tree = self.make_trees()
-        self.assertNotEqual(base_tree.get_root_id(), sub_tree.get_root_id())
+        assert base_tree.get_root_id() != sub_tree.get_root_id()
         sub_root_id = sub_tree.get_root_id()
         # this test checks the subdir is removed, so it needs to know the
         # control directory; that changes rarely so just hardcode (and check)

=== removed file 'bzrlib/tests/test_switch.py'
--- bzrlib/tests/test_switch.py	2008-05-21 15:42:47 +0000
+++ bzrlib/tests/test_switch.py	1970-01-01 00:00:00 +0000
@@ -1,134 +0,0 @@
-# Copyright (C) 2007 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Tests for bzrlib.switch."""
-
-
-import os
-
-from bzrlib import branch, errors, switch, tests
-
-
-class TestSwitch(tests.TestCaseWithTransport):
-
-    def setUp(self):
-        super(TestSwitch, self).setUp()
-        self.lightweight = True
-
-    def _setup_tree(self):
-        tree = self.make_branch_and_tree('branch-1')
-        self.build_tree(['branch-1/file-1'])
-        tree.add('file-1')
-        tree.commit('rev1')
-        return tree
-
-    def test_switch_updates(self):
-        """Test switch updates tree and keeps uncommitted changes."""
-        tree = self._setup_tree()
-        to_branch = tree.bzrdir.sprout('branch-2').open_branch()
-        self.build_tree(['branch-1/file-2'])
-        tree.add('file-2')
-        tree.remove('file-1')
-        tree.commit('rev2')
-        checkout = tree.branch.create_checkout('checkout',
-            lightweight=self.lightweight)
-        self.build_tree(['checkout/file-3'])
-        checkout.add('file-3')
-        self.failIfExists('checkout/file-1')
-        self.failUnlessExists('checkout/file-2')
-        switch.switch(checkout.bzrdir, to_branch)
-        self.failUnlessExists('checkout/file-1')
-        self.failIfExists('checkout/file-2')
-        self.failUnlessExists('checkout/file-3')
-
-    def test_switch_after_branch_moved(self):
-        """Test switch after the branch is moved."""
-        tree = self._setup_tree()
-        checkout = tree.branch.create_checkout('checkout',
-            lightweight=self.lightweight)
-        self.build_tree(['branch-1/file-2'])
-        tree.add('file-2')
-        tree.remove('file-1')
-        tree.commit('rev2')
-        self.build_tree(['checkout/file-3'])
-        checkout.add('file-3')
-        checkout_dir = checkout.bzrdir
-        # rename the branch on disk, the checkout object is now invalid.
-        os.rename('branch-1', 'branch-2')
-        to_branch = branch.Branch.open('branch-2')
-        # Check fails without --force
-        err = self.assertRaises((errors.NotBranchError,
-            errors.BoundBranchConnectionFailure),
-            switch.switch, checkout.bzrdir, to_branch)
-        switch.switch(checkout.bzrdir, to_branch, force=True)
-        self.failIfExists('checkout/file-1')
-        self.failUnlessExists('checkout/file-2')
-        self.failUnlessExists('checkout/file-3')
-
-    def test_switch_when_pending_merges(self):
-        """Test graceful failure if pending merges are outstanding."""
-        # Create 2 branches and a checkout
-        tree = self._setup_tree()
-        tree2 = tree.bzrdir.sprout('branch-2').open_workingtree()
-        checkout = tree.branch.create_checkout('checkout',
-            lightweight=self.lightweight)
-        # Change tree2 and merge it into the checkout without committing
-        self.build_tree(['branch-2/file-2'])
-        tree2.add('file-2')
-        tree2.commit('rev2')
-        checkout.merge_from_branch(tree2.branch)
-        # Check the error reporting is as expected
-        err = self.assertRaises(errors.BzrCommandError,
-            switch.switch, checkout.bzrdir, tree2.branch)
-        self.assertContainsRe(str(err),
-            "Pending merges must be committed or reverted before using switch")
-
-
-class TestSwitchHeavyweight(TestSwitch):
-
-    def setUp(self):
-        super(TestSwitchHeavyweight, self).setUp()
-        self.lightweight = False
-
-    def test_switch_with_local_commits(self):
-        """Test switch complains about local commits unless --force given."""
-        tree = self._setup_tree()
-        to_branch = tree.bzrdir.sprout('branch-2').open_branch()
-        self.build_tree(['branch-1/file-2'])
-        tree.add('file-2')
-        tree.remove('file-1')
-        tree.commit('rev2')
-        checkout = tree.branch.create_checkout('checkout')
-        self.build_tree(['checkout/file-3'])
-        checkout.add('file-3')
-        checkout.commit(message='local only commit', local=True)
-        self.build_tree(['checkout/file-4'])
-        # Check the error reporting is as expected
-        err = self.assertRaises(errors.BzrCommandError,
-            switch.switch, checkout.bzrdir, to_branch)
-        self.assertContainsRe(str(err),
-            'Cannot switch as local commits found in the checkout.')
-        # Check all is ok when force is given
-        self.failIfExists('checkout/file-1')
-        self.failUnlessExists('checkout/file-2')
-        switch.switch(checkout.bzrdir, to_branch, force=True)
-        self.failUnlessExists('checkout/file-1')
-        self.failIfExists('checkout/file-2')
-        self.failIfExists('checkout/file-3')
-        self.failUnlessExists('checkout/file-4')
-        # Check that the checkout is a true mirror of the bound branch
-        self.assertEqual(to_branch.last_revision_info(),
-                         checkout.branch.last_revision_info())

=== modified file 'bzrlib/tests/test_symbol_versioning.py'
--- bzrlib/tests/test_symbol_versioning.py	2008-05-28 23:20:33 +0000
+++ bzrlib/tests/test_symbol_versioning.py	2007-09-18 04:21:20 +0000
@@ -18,9 +18,7 @@
 
 """Symbol versioning tests."""
 
-import warnings
-
-from bzrlib import symbol_versioning
+import bzrlib.symbol_versioning as symbol_versioning
 from bzrlib.tests import TestCase
 
 
@@ -209,75 +207,3 @@
             symbol_versioning.deprecation_string(
                 symbol_versioning.deprecated_function,
                 symbol_versioning.zero_eleven))
-
-
-class TestSuppressAndActivate(TestCase):
-
-    def setUp(self):
-        existing_filters = list(warnings.filters)
-        def restore():
-            warnings.filters[:] = existing_filters
-        self.addCleanup(restore)
-        # Clean out the filters so we have a clean slate.
-        warnings.resetwarnings()
-
-    def assertFirstWarning(self, action, category):
-        """Test the first warning in the filters is correct"""
-        first = warnings.filters[0]
-        self.assertEqual((action, category), (first[0], first[2]))
-
-    def test_suppress_deprecation_warnings(self):
-        """suppress_deprecation_warnings sets DeprecationWarning to ignored."""
-        symbol_versioning.suppress_deprecation_warnings()
-        self.assertFirstWarning('ignore', DeprecationWarning)
-
-    def test_suppress_deprecation_with_warning_filter(self):
-        """don't suppress if we already have a filter"""
-        warnings.filterwarnings('error', category=Warning)
-        self.assertFirstWarning('error', Warning)
-        self.assertEqual(1, len(warnings.filters))
-        symbol_versioning.suppress_deprecation_warnings(override=False)
-        self.assertFirstWarning('error', Warning)
-        self.assertEqual(1, len(warnings.filters))
-
-    def test_suppress_deprecation_with_filter(self):
-        """don't suppress if we already have a filter"""
-        warnings.filterwarnings('error', category=DeprecationWarning)
-        self.assertFirstWarning('error', DeprecationWarning)
-        self.assertEqual(1, len(warnings.filters))
-        symbol_versioning.suppress_deprecation_warnings(override=False)
-        self.assertFirstWarning('error', DeprecationWarning)
-        self.assertEqual(1, len(warnings.filters))
-        symbol_versioning.suppress_deprecation_warnings(override=True)
-        self.assertFirstWarning('ignore', DeprecationWarning)
-        self.assertEqual(2, len(warnings.filters))
-
-    def test_activate_deprecation_no_error(self):
-        # First nuke the filters, so we know it is clean
-        symbol_versioning.activate_deprecation_warnings()
-        self.assertFirstWarning('default', DeprecationWarning)
-
-    def test_activate_deprecation_with_error(self):
-        # First nuke the filters, so we know it is clean
-        # Add a warning == error rule
-        warnings.filterwarnings('error', category=Warning)
-        self.assertFirstWarning('error', Warning)
-        self.assertEqual(1, len(warnings.filters))
-        symbol_versioning.activate_deprecation_warnings(override=False)
-        # There should not be a new warning
-        self.assertFirstWarning('error', Warning)
-        self.assertEqual(1, len(warnings.filters))
-
-    def test_activate_deprecation_with_DW_error(self):
-        # First nuke the filters, so we know it is clean
-        # Add a warning == error rule
-        warnings.filterwarnings('error', category=DeprecationWarning)
-        self.assertFirstWarning('error', DeprecationWarning)
-        self.assertEqual(1, len(warnings.filters))
-        symbol_versioning.activate_deprecation_warnings(override=False)
-        # There should not be a new warning
-        self.assertFirstWarning('error', DeprecationWarning)
-        self.assertEqual(1, len(warnings.filters))
-        symbol_versioning.activate_deprecation_warnings(override=True)
-        self.assertFirstWarning('default', DeprecationWarning)
-        self.assertEqual(2, len(warnings.filters))

=== modified file 'bzrlib/tests/test_testament.py'
--- bzrlib/tests/test_testament.py	2007-11-01 09:52:45 +0000
+++ bzrlib/tests/test_testament.py	2007-03-06 00:28:36 +0000
@@ -21,9 +21,10 @@
 import os
 from sha import sha
 
-from bzrlib.tests import SymlinkFeature, TestCaseWithTransport
+from bzrlib.tests import TestCaseWithTransport
 from bzrlib.testament import Testament, StrictTestament, StrictTestament3
 from bzrlib.transform import TreeTransform
+from bzrlib.osutils import has_symlinks
 
 
 class TestamentSetup(TestCaseWithTransport):
@@ -97,7 +98,8 @@
 
     def test_testament_symlinks(self):
         """Testament containing symlink (where possible)"""
-        self.requireFeature(SymlinkFeature)
+        if not has_symlinks():
+            return
         os.symlink('wibble/linktarget', 'link')
         self.wt.add(['link'], ['link-id'])
         self.wt.commit(message='add symlink',

=== modified file 'bzrlib/tests/test_trace.py'
--- bzrlib/tests/test_trace.py	2008-06-17 01:13:49 +0000
+++ bzrlib/tests/test_trace.py	2007-09-24 06:00:49 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2008 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -21,9 +21,7 @@
 from cStringIO import StringIO
 import errno
 import os
-import re
 import sys
-import tempfile
 
 from bzrlib import (
     errors,
@@ -32,8 +30,6 @@
 from bzrlib.trace import (
     mutter, mutter_callsite, report_exception,
     set_verbosity_level, get_verbosity_level, is_quiet, is_verbose, be_quiet,
-    pop_log_file,
-    push_log_file,
     _rollover_trace_maybe,
     )
 
@@ -93,28 +89,6 @@
         self.assertTrue(len(msg) > 0)
         self.assertEqualDiff(msg, 'bzr: ERROR: Not a branch: \"wibble\".\n')
 
-    def test_report_external_import_error(self):
-        """Short friendly message for missing system modules."""
-        try:
-            import ImaginaryModule
-        except ImportError, e:
-            pass
-        else:
-            self.fail("somehow succeeded in importing %r" % ImaginaryModule)
-        msg = _format_exception()
-        self.assertEqual(msg,
-            'bzr: ERROR: No module named ImaginaryModule\n'
-            'You may need to install this Python library separately.\n')
-
-    def test_report_import_syntax_error(self):
-        try:
-            raise ImportError("syntax error")
-        except ImportError, e:
-            pass
-        msg = _format_exception()
-        self.assertContainsRe(msg,
-            r"Traceback \(most recent call last\)")
-
     def test_trace_unicode(self):
         """Write Unicode to trace log"""
         self.log(u'the unicode character for benzene is \N{BENZENE RING}')
@@ -143,20 +117,15 @@
         else:
             self.fail("expected error not raised")
 
-    def assertLogStartsWith(self, log, string):
-        """Like assertStartsWith, but skips the log timestamp."""
-        self.assertContainsRe(log,
-            '^\\d+\\.\\d+  ' + re.escape(string))
-
     def test_mutter_callsite_1(self):
         """mutter_callsite can capture 1 level of stack frame."""
         mutter_callsite(1, "foo %s", "a string")
         log = self._get_log(keep_log_file=True)
         # begin with the message
-        self.assertLogStartsWith(log, 'foo a string\nCalled from:\n')
+        self.assertStartsWith(log, 'foo a string\nCalled from:\n')
         # should show two frame: this frame and the one above
         self.assertContainsRe(log,
-            'test_trace\\.py", line \\d+, in test_mutter_callsite_1\n')
+            'test_trace\.py", line \d+, in test_mutter_callsite_1\n')
         # this frame should be the final one
         self.assertEndsWith(log, ' "a string")\n')
 
@@ -165,7 +134,7 @@
         mutter_callsite(2, "foo %s", "a string")
         log = self._get_log(keep_log_file=True)
         # begin with the message
-        self.assertLogStartsWith(log, 'foo a string\nCalled from:\n')
+        self.assertStartsWith(log, 'foo a string\nCalled from:\n')
         # should show two frame: this frame and the one above
         self.assertContainsRe(log,
             'test_trace.py", line \d+, in test_mutter_callsite_2\n')
@@ -183,39 +152,6 @@
         self.assertContainsRe(log, "But fails in an ascii string")
         self.assertContainsRe(log, u"ascii argument: \xb5")
 
-    def test_push_log_file(self):
-        """Can push and pop log file, and this catches mutter messages.
-
-        This is primarily for use in the test framework. 
-        """
-        tmp1 = tempfile.NamedTemporaryFile()
-        tmp2 = tempfile.NamedTemporaryFile()
-        try:
-            memento1 = push_log_file(tmp1)
-            mutter("comment to file1")
-            try:
-                memento2 = push_log_file(tmp2)
-                try:
-                    mutter("comment to file2")
-                finally:
-                    pop_log_file(memento2)
-                mutter("again to file1")
-            finally:
-                pop_log_file(memento1)
-            # the files were opened in binary mode, so should have exactly
-            # these bytes.  and removing the file as the log target should
-            # have caused them to be flushed out.  need to match using regexps
-            # as there's a timestamp at the front.
-            tmp1.seek(0)
-            self.assertContainsRe(tmp1.read(),
-                r"\d+\.\d+  comment to file1\n\d+\.\d+  again to file1\n")
-            tmp2.seek(0)
-            self.assertContainsRe(tmp2.read(),
-                r"\d+\.\d+  comment to file2\n")
-        finally:
-            tmp1.close()
-            tmp2.close()
-
 
 class TestVerbosityLevel(TestCase):
 

=== modified file 'bzrlib/tests/test_transform.py'
--- bzrlib/tests/test_transform.py	2008-08-29 00:35:38 +0000
+++ bzrlib/tests/test_transform.py	2007-09-05 04:35:21 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007, 2008 Canonical Ltd
+# Copyright (C) 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -16,44 +16,31 @@
 
 import os
 import stat
-from StringIO import StringIO
 import sys
 
 from bzrlib import (
     errors,
     generate_ids,
-    osutils,
-    progress,
-    revision as _mod_revision,
     symbol_versioning,
     tests,
     urlutils,
     )
 from bzrlib.bzrdir import BzrDir
 from bzrlib.conflicts import (DuplicateEntry, DuplicateID, MissingParent,
-                              UnversionedParent, ParentLoop, DeletingParent,
-                              NonDirectoryParent)
-from bzrlib.diff import show_diff_trees
+                              UnversionedParent, ParentLoop, DeletingParent,)
 from bzrlib.errors import (DuplicateKey, MalformedTransform, NoSuchFile,
                            ReusingTransform, CantMoveRoot, 
                            PathsNotVersionedError, ExistingLimbo,
                            ExistingPendingDeletion, ImmortalLimbo,
                            ImmortalPendingDeletion, LockError)
-from bzrlib.osutils import file_kind, pathjoin
+from bzrlib.osutils import file_kind, has_symlinks, pathjoin
 from bzrlib.merge import Merge3Merger
-from bzrlib.tests import (
-    CaseInsensitiveFilesystemFeature,
-    HardlinkFeature,
-    SymlinkFeature,
-    TestCase,
-    TestCaseInTempDir,
-    TestSkipped,
-    )
+from bzrlib.tests import TestCaseInTempDir, TestSkipped, TestCase
 from bzrlib.transform import (TreeTransform, ROOT_PARENT, FinalPaths, 
                               resolve_conflicts, cook_conflicts, 
-                              build_tree, get_backup_name,
-                              _FileMover, resolve_checkout,
-                              TransformPreview)
+                              find_interesting, build_tree, get_backup_name,
+                              change_entry, _FileMover)
+
 
 class TestTreeTransform(tests.TestCaseWithTransport):
 
@@ -64,7 +51,7 @@
 
     def get_transform(self):
         transform = TreeTransform(self.wt)
-        self.addCleanup(transform.finalize)
+        #self.addCleanup(transform.finalize)
         return transform, transform.root
 
     def test_existing_limbo(self):
@@ -85,16 +72,14 @@
     def test_existing_pending_deletion(self):
         transform, root = self.get_transform()
         deletion_path = self._limbodir = urlutils.local_path_from_url(
-            transform._tree._transport.abspath('pending-deletion'))
+            transform._tree._control_files.controlfilename('pending-deletion'))
         os.mkdir(pathjoin(deletion_path, 'blocking-directory'))
         self.assertRaises(ImmortalPendingDeletion, transform.apply)
         self.assertRaises(LockError, self.wt.unlock)
         self.assertRaises(ExistingPendingDeletion, self.get_transform)
 
     def test_build(self):
-        transform, root = self.get_transform()
-        self.wt.lock_tree_write()
-        self.addCleanup(self.wt.unlock)
+        transform, root = self.get_transform() 
         self.assertIs(transform.get_tree_parent(root), ROOT_PARENT)
         imaginary_id = transform.trans_id_tree_path('imaginary')
         imaginary_id2 = transform.trans_id_tree_path('imaginary/')
@@ -135,25 +120,8 @@
         transform.finalize()
         transform.finalize()
 
-    def test_hardlink(self):
-        self.requireFeature(HardlinkFeature)
-        transform, root = self.get_transform()
-        transform.new_file('file1', root, 'contents')
-        transform.apply()
-        target = self.make_branch_and_tree('target')
-        target_transform = TreeTransform(target)
-        trans_id = target_transform.create_path('file1', target_transform.root)
-        target_transform.create_hardlink(self.wt.abspath('file1'), trans_id)
-        target_transform.apply()
-        self.failUnlessExists('target/file1')
-        source_stat = os.stat(self.wt.abspath('file1'))
-        target_stat = os.stat('target/file1')
-        self.assertEqual(source_stat, target_stat)
-
     def test_convenience(self):
         transform, root = self.get_transform()
-        self.wt.lock_tree_write()
-        self.addCleanup(self.wt.unlock)
         trans_id = transform.new_file('name', root, 'contents', 
                                       'my_pretties', True)
         oz = transform.new_directory('oz', root, 'oz-id')
@@ -260,114 +228,6 @@
         transform3.adjust_path('tip', root_id, tip_id)
         transform3.apply()
 
-    def test_conflict_on_case_insensitive(self):
-        tree = self.make_branch_and_tree('tree')
-        # Don't try this at home, kids!
-        # Force the tree to report that it is case sensitive, for conflict
-        # resolution tests
-        tree.case_sensitive = True
-        transform = TreeTransform(tree)
-        self.addCleanup(transform.finalize)
-        transform.new_file('file', transform.root, 'content')
-        transform.new_file('FiLe', transform.root, 'content')
-        result = transform.find_conflicts()
-        self.assertEqual([], result)
-        transform.finalize()
-        # Force the tree to report that it is case insensitive, for conflict
-        # generation tests
-        tree.case_sensitive = False
-        transform = TreeTransform(tree)
-        self.addCleanup(transform.finalize)
-        transform.new_file('file', transform.root, 'content')
-        transform.new_file('FiLe', transform.root, 'content')
-        result = transform.find_conflicts()
-        self.assertEqual([('duplicate', 'new-1', 'new-2', 'file')], result)
-
-    def test_conflict_on_case_insensitive_existing(self):
-        tree = self.make_branch_and_tree('tree')
-        self.build_tree(['tree/FiLe'])
-        # Don't try this at home, kids!
-        # Force the tree to report that it is case sensitive, for conflict
-        # resolution tests
-        tree.case_sensitive = True
-        transform = TreeTransform(tree)
-        self.addCleanup(transform.finalize)
-        transform.new_file('file', transform.root, 'content')
-        result = transform.find_conflicts()
-        self.assertEqual([], result)
-        transform.finalize()
-        # Force the tree to report that it is case insensitive, for conflict
-        # generation tests
-        tree.case_sensitive = False
-        transform = TreeTransform(tree)
-        self.addCleanup(transform.finalize)
-        transform.new_file('file', transform.root, 'content')
-        result = transform.find_conflicts()
-        self.assertEqual([('duplicate', 'new-1', 'new-2', 'file')], result)
-
-    def test_resolve_case_insensitive_conflict(self):
-        tree = self.make_branch_and_tree('tree')
-        # Don't try this at home, kids!
-        # Force the tree to report that it is case insensitive, for conflict
-        # resolution tests
-        tree.case_sensitive = False
-        transform = TreeTransform(tree)
-        self.addCleanup(transform.finalize)
-        transform.new_file('file', transform.root, 'content')
-        transform.new_file('FiLe', transform.root, 'content')
-        resolve_conflicts(transform)
-        transform.apply()
-        self.failUnlessExists('tree/file')
-        self.failUnlessExists('tree/FiLe.moved')
-
-    def test_resolve_checkout_case_conflict(self):
-        tree = self.make_branch_and_tree('tree')
-        # Don't try this at home, kids!
-        # Force the tree to report that it is case insensitive, for conflict
-        # resolution tests
-        tree.case_sensitive = False
-        transform = TreeTransform(tree)
-        self.addCleanup(transform.finalize)
-        transform.new_file('file', transform.root, 'content')
-        transform.new_file('FiLe', transform.root, 'content')
-        resolve_conflicts(transform,
-                          pass_func=lambda t, c: resolve_checkout(t, c, []))
-        transform.apply()
-        self.failUnlessExists('tree/file')
-        self.failUnlessExists('tree/FiLe.moved')
-
-    def test_apply_case_conflict(self):
-        """Ensure that a transform with case conflicts can always be applied"""
-        tree = self.make_branch_and_tree('tree')
-        transform = TreeTransform(tree)
-        self.addCleanup(transform.finalize)
-        transform.new_file('file', transform.root, 'content')
-        transform.new_file('FiLe', transform.root, 'content')
-        dir = transform.new_directory('dir', transform.root)
-        transform.new_file('dirfile', dir, 'content')
-        transform.new_file('dirFiLe', dir, 'content')
-        resolve_conflicts(transform)
-        transform.apply()
-        self.failUnlessExists('tree/file')
-        if not os.path.exists('tree/FiLe.moved'):
-            self.failUnlessExists('tree/FiLe')
-        self.failUnlessExists('tree/dir/dirfile')
-        if not os.path.exists('tree/dir/dirFiLe.moved'):
-            self.failUnlessExists('tree/dir/dirFiLe')
-
-    def test_case_insensitive_limbo(self):
-        tree = self.make_branch_and_tree('tree')
-        # Don't try this at home, kids!
-        # Force the tree to report that it is case insensitive
-        tree.case_sensitive = False
-        transform = TreeTransform(tree)
-        self.addCleanup(transform.finalize)
-        dir = transform.new_directory('dir', transform.root)
-        first = transform.new_file('file', dir, 'content')
-        second = transform.new_file('FiLe', dir, 'content')
-        self.assertContainsRe(transform._limbo_name(first), 'new-1/file')
-        self.assertNotContainsRe(transform._limbo_name(second), 'new-1/FiLe')
-
     def test_add_del(self):
         start, root = self.get_transform()
         start.new_directory('a', root, 'a')
@@ -525,7 +385,8 @@
         replace.apply()
 
     def test_symlinks(self):
-        self.requireFeature(SymlinkFeature)
+        if not has_symlinks():
+            raise TestSkipped('Symlinks are not supported on this platform')
         transform,root = self.get_transform()
         oz_id = transform.new_directory('oz', root, 'oz-id')
         wizard = transform.new_symlink('wizard', oz_id, 'wizard-target', 
@@ -545,26 +406,6 @@
         self.assertEqual(os.readlink(self.wt.abspath('oz/wizard')),
                          'wizard-target')
 
-    def test_unable_create_symlink(self):
-        def tt_helper():
-            wt = self.make_branch_and_tree('.')
-            tt = TreeTransform(wt)  # TreeTransform obtains write lock
-            try:
-                tt.new_symlink('foo', tt.root, 'bar')
-                tt.apply()
-            finally:
-                wt.unlock()
-        os_symlink = getattr(os, 'symlink', None)
-        os.symlink = None
-        try:
-            err = self.assertRaises(errors.UnableCreateSymlink, tt_helper)
-            self.assertEquals(
-                "Unable to create symlink 'foo' on this platform",
-                str(err))
-        finally:
-            if os_symlink:
-                os.symlink = os_symlink
-
     def get_conflicted(self):
         create,root = self.get_transform()
         create.new_file('dorothy', root, 'dorothy', 'dorothy-id')
@@ -654,61 +495,6 @@
         self.assertEqual(conflicts_s[6], 'Conflict moving oz/emeraldcity into'
                                          ' oz/emeraldcity.  Cancelled move.')
 
-    def prepare_wrong_parent_kind(self):
-        tt, root = self.get_transform()
-        tt.new_file('parent', root, 'contents', 'parent-id')
-        tt.apply()
-        tt, root = self.get_transform()
-        parent_id = tt.trans_id_file_id('parent-id')
-        tt.new_file('child,', parent_id, 'contents2', 'file-id')
-        return tt
-
-    def test_find_conflicts_wrong_parent_kind(self):
-        tt = self.prepare_wrong_parent_kind()
-        tt.find_conflicts()
-
-    def test_resolve_conflicts_wrong_existing_parent_kind(self):
-        tt = self.prepare_wrong_parent_kind()
-        raw_conflicts = resolve_conflicts(tt)
-        self.assertEqual(set([('non-directory parent', 'Created directory',
-                         'new-3')]), raw_conflicts)
-        cooked_conflicts = cook_conflicts(raw_conflicts, tt)
-        self.assertEqual([NonDirectoryParent('Created directory', 'parent.new',
-        'parent-id')], cooked_conflicts)
-        tt.apply()
-        self.assertEqual(None, self.wt.path2id('parent'))
-        self.assertEqual('parent-id', self.wt.path2id('parent.new'))
-
-    def test_resolve_conflicts_wrong_new_parent_kind(self):
-        tt, root = self.get_transform()
-        parent_id = tt.new_directory('parent', root, 'parent-id')
-        tt.new_file('child,', parent_id, 'contents2', 'file-id')
-        tt.apply()
-        tt, root = self.get_transform()
-        parent_id = tt.trans_id_file_id('parent-id')
-        tt.delete_contents(parent_id)
-        tt.create_file('contents', parent_id)
-        raw_conflicts = resolve_conflicts(tt)
-        self.assertEqual(set([('non-directory parent', 'Created directory',
-                         'new-3')]), raw_conflicts)
-        tt.apply()
-        self.assertEqual(None, self.wt.path2id('parent'))
-        self.assertEqual('parent-id', self.wt.path2id('parent.new'))
-
-    def test_resolve_conflicts_wrong_parent_kind_unversioned(self):
-        tt, root = self.get_transform()
-        parent_id = tt.new_directory('parent', root)
-        tt.new_file('child,', parent_id, 'contents2')
-        tt.apply()
-        tt, root = self.get_transform()
-        parent_id = tt.trans_id_tree_path('parent')
-        tt.delete_contents(parent_id)
-        tt.create_file('contents', parent_id)
-        resolve_conflicts(tt)
-        tt.apply()
-        self.assertIs(None, self.wt.path2id('parent'))
-        self.assertIs(None, self.wt.path2id('parent.new'))
-
     def test_moving_versioned_directories(self):
         create, root = self.get_transform()
         kansas = create.new_directory('kansas', root, 'kansas-id')
@@ -747,6 +533,16 @@
         rename.set_executability(True, myfile)
         rename.apply()
 
+    def test_find_interesting(self):
+        create, root = self.get_transform()
+        wt = create._tree
+        create.new_file('vfile', root, 'myfile-text', 'myfile-id')
+        create.new_file('uvfile', root, 'othertext')
+        create.apply()
+        result = self.applyDeprecated(symbol_versioning.zero_fifteen,
+            find_interesting, wt, wt, ['vfile'])
+        self.assertEqual(result, set(['myfile-id']))
+
     def test_set_executability_order(self):
         """Ensure that executability behaves the same, no matter what order.
         
@@ -758,8 +554,6 @@
         """
         transform, root = self.get_transform()
         wt = transform._tree
-        wt.lock_read()
-        self.addCleanup(wt.unlock)
         transform.new_file('set_on_creation', root, 'Set on creation', 'soc',
                            True)
         sac = transform.new_file('set_after_creation', root,
@@ -779,8 +573,6 @@
         transform, root = self.get_transform()
         transform.new_file('file1', root, 'contents', 'file1-id', True)
         transform.apply()
-        self.wt.lock_write()
-        self.addCleanup(self.wt.unlock)
         self.assertTrue(self.wt.is_executable('file1-id'))
         transform, root = self.get_transform()
         file1_id = transform.trans_id_tree_file_id('file1-id')
@@ -826,17 +618,17 @@
         transform.apply()
         transform, root = self.get_transform()
         try:
-            self.assertEqual([], list(transform.iter_changes()))
+            self.assertEqual([], list(transform._iter_changes()))
             old = transform.trans_id_tree_file_id('id-1')
             transform.unversion_file(old)
             self.assertEqual([('id-1', ('old', None), False, (True, False),
                 ('eert_toor', 'eert_toor'), ('old', 'old'), ('file', 'file'),
-                (True, True))], list(transform.iter_changes()))
+                (True, True))], list(transform._iter_changes()))
             transform.new_directory('new', root, 'id-1')
             self.assertEqual([('id-1', ('old', 'new'), True, (True, True),
                 ('eert_toor', 'eert_toor'), ('old', 'new'),
                 ('file', 'directory'),
-                (True, False))], list(transform.iter_changes()))
+                (True, False))], list(transform._iter_changes()))
         finally:
             transform.finalize()
 
@@ -851,7 +643,7 @@
             transform.version_file('id-1', old)
             self.assertEqual([('id-1', (None, 'old'), False, (False, True),
                 ('eert_toor', 'eert_toor'), ('old', 'old'), ('file', 'file'),
-                (False, False))], list(transform.iter_changes()))
+                (False, False))], list(transform._iter_changes()))
         finally:
             transform.finalize()
 
@@ -867,61 +659,61 @@
             old = transform.trans_id_tree_path('old')
             subdir = transform.trans_id_tree_file_id('subdir-id')
             new = transform.trans_id_tree_path('new')
-            self.assertEqual([], list(transform.iter_changes()))
+            self.assertEqual([], list(transform._iter_changes()))
 
             #content deletion
             transform.delete_contents(old)
             self.assertEqual([('id-1', ('old', 'old'), True, (True, True),
                 ('eert_toor', 'eert_toor'), ('old', 'old'), ('file', None),
-                (False, False))], list(transform.iter_changes()))
+                (False, False))], list(transform._iter_changes()))
 
             #content change
             transform.create_file('blah', old)
             self.assertEqual([('id-1', ('old', 'old'), True, (True, True),
                 ('eert_toor', 'eert_toor'), ('old', 'old'), ('file', 'file'),
-                (False, False))], list(transform.iter_changes()))
+                (False, False))], list(transform._iter_changes()))
             transform.cancel_deletion(old)
             self.assertEqual([('id-1', ('old', 'old'), True, (True, True),
                 ('eert_toor', 'eert_toor'), ('old', 'old'), ('file', 'file'),
-                (False, False))], list(transform.iter_changes()))
+                (False, False))], list(transform._iter_changes()))
             transform.cancel_creation(old)
 
             # move file_id to a different file
-            self.assertEqual([], list(transform.iter_changes()))
+            self.assertEqual([], list(transform._iter_changes()))
             transform.unversion_file(old)
             transform.version_file('id-1', new)
             transform.adjust_path('old', root, new)
             self.assertEqual([('id-1', ('old', 'old'), True, (True, True),
                 ('eert_toor', 'eert_toor'), ('old', 'old'), ('file', 'file'),
-                (False, False))], list(transform.iter_changes()))
+                (False, False))], list(transform._iter_changes()))
             transform.cancel_versioning(new)
             transform._removed_id = set()
 
             #execute bit
-            self.assertEqual([], list(transform.iter_changes()))
+            self.assertEqual([], list(transform._iter_changes()))
             transform.set_executability(True, old)
             self.assertEqual([('id-1', ('old', 'old'), False, (True, True),
                 ('eert_toor', 'eert_toor'), ('old', 'old'), ('file', 'file'),
-                (False, True))], list(transform.iter_changes()))
+                (False, True))], list(transform._iter_changes()))
             transform.set_executability(None, old)
 
             # filename
-            self.assertEqual([], list(transform.iter_changes()))
+            self.assertEqual([], list(transform._iter_changes()))
             transform.adjust_path('new', root, old)
             transform._new_parent = {}
             self.assertEqual([('id-1', ('old', 'new'), False, (True, True),
                 ('eert_toor', 'eert_toor'), ('old', 'new'), ('file', 'file'),
-                (False, False))], list(transform.iter_changes()))
+                (False, False))], list(transform._iter_changes()))
             transform._new_name = {}
 
             # parent directory
-            self.assertEqual([], list(transform.iter_changes()))
+            self.assertEqual([], list(transform._iter_changes()))
             transform.adjust_path('new', subdir, old)
             transform._new_name = {}
             self.assertEqual([('id-1', ('old', 'subdir/old'), False,
                 (True, True), ('eert_toor', 'subdir-id'), ('old', 'old'),
                 ('file', 'file'), (False, False))],
-                list(transform.iter_changes()))
+                list(transform._iter_changes()))
             transform._new_path = {}
 
         finally:
@@ -949,7 +741,7 @@
                 ('id-2', (u'file2', u'file2'), False, (True, True),
                 ('eert_toor', 'eert_toor'), ('file2', u'file2'),
                 ('file', 'file'), (False, True))],
-                list(transform.iter_changes()))
+                list(transform._iter_changes()))
         finally:
             transform.finalize()
 
@@ -969,7 +761,7 @@
             transform.adjust_path('flitter', root, floater)
             self.assertEqual([('floater-id', ('floater', 'flitter'), False,
             (True, True), ('toor_eert', 'toor_eert'), ('floater', 'flitter'),
-            (None, None), (False, False))], list(transform.iter_changes()))
+            (None, None), (False, False))], list(transform._iter_changes()))
         finally:
             transform.finalize()
 
@@ -984,14 +776,14 @@
         try:
             old = transform.trans_id_tree_path('old')
             subdir = transform.trans_id_tree_file_id('subdir-id')
-            self.assertEqual([], list(transform.iter_changes()))
+            self.assertEqual([], list(transform._iter_changes()))
             transform.delete_contents(subdir)
             transform.create_directory(subdir)
             transform.set_executability(False, old)
             transform.unversion_file(old)
             transform.version_file('id-1', old)
             transform.adjust_path('old', root, old)
-            self.assertEqual([], list(transform.iter_changes()))
+            self.assertEqual([], list(transform._iter_changes()))
         finally:
             transform.finalize()
 
@@ -1162,153 +954,13 @@
         transform.cancel_creation(parent)
         transform.finalize()
 
-    def test_case_insensitive_clash(self):
-        self.requireFeature(CaseInsensitiveFilesystemFeature)
-        def tt_helper():
-            wt = self.make_branch_and_tree('.')
-            tt = TreeTransform(wt)  # TreeTransform obtains write lock
-            try:
-                tt.new_file('foo', tt.root, 'bar')
-                tt.new_file('Foo', tt.root, 'spam')
-                # Lie to tt that we've already resolved all conflicts.
-                tt.apply(no_conflicts=True)
-            except:
-                wt.unlock()
-                raise
-        err = self.assertRaises(errors.FileExists, tt_helper)
-        self.assertContainsRe(str(err),
-            "^File exists: .+/foo")
-
-    def test_two_directories_clash(self):
-        def tt_helper():
-            wt = self.make_branch_and_tree('.')
-            tt = TreeTransform(wt)  # TreeTransform obtains write lock
-            try:
-                foo_1 = tt.new_directory('foo', tt.root)
-                tt.new_directory('bar', foo_1)
-                foo_2 = tt.new_directory('foo', tt.root)
-                tt.new_directory('baz', foo_2)
-                # Lie to tt that we've already resolved all conflicts.
-                tt.apply(no_conflicts=True)
-            except:
-                wt.unlock()
-                raise
-        err = self.assertRaises(errors.FileExists, tt_helper)
-        self.assertContainsRe(str(err),
-            "^File exists: .+/foo")
-
-    def test_two_directories_clash_finalize(self):
-        def tt_helper():
-            wt = self.make_branch_and_tree('.')
-            tt = TreeTransform(wt)  # TreeTransform obtains write lock
-            try:
-                foo_1 = tt.new_directory('foo', tt.root)
-                tt.new_directory('bar', foo_1)
-                foo_2 = tt.new_directory('foo', tt.root)
-                tt.new_directory('baz', foo_2)
-                # Lie to tt that we've already resolved all conflicts.
-                tt.apply(no_conflicts=True)
-            except:
-                tt.finalize()
-                raise
-        err = self.assertRaises(errors.FileExists, tt_helper)
-        self.assertContainsRe(str(err),
-            "^File exists: .+/foo")
-
-    def test_file_to_directory(self):
-        wt = self.make_branch_and_tree('.')
-        self.build_tree(['foo'])
-        wt.add(['foo'])
-        wt.commit("one")
-        tt = TreeTransform(wt)
-        self.addCleanup(tt.finalize)
-        foo_trans_id = tt.trans_id_tree_path("foo")
-        tt.delete_contents(foo_trans_id)
-        tt.create_directory(foo_trans_id)
-        bar_trans_id = tt.trans_id_tree_path("foo/bar")
-        tt.create_file(["aa\n"], bar_trans_id)
-        tt.version_file("bar-1", bar_trans_id)
-        tt.apply()
-        self.failUnlessExists("foo/bar")
-        wt.lock_read()
-        try:
-            self.assertEqual(wt.inventory.get_file_kind(wt.path2id("foo")),
-                    "directory")
-        finally:
-            wt.unlock()
-        wt.commit("two")
-        changes = wt.changes_from(wt.basis_tree())
-        self.assertFalse(changes.has_changed(), changes)
-
-    def test_file_to_symlink(self):
-        self.requireFeature(SymlinkFeature)
-        wt = self.make_branch_and_tree('.')
-        self.build_tree(['foo'])
-        wt.add(['foo'])
-        wt.commit("one")
-        tt = TreeTransform(wt)
-        self.addCleanup(tt.finalize)
-        foo_trans_id = tt.trans_id_tree_path("foo")
-        tt.delete_contents(foo_trans_id)
-        tt.create_symlink("bar", foo_trans_id)
-        tt.apply()
-        self.failUnlessExists("foo")
-        wt.lock_read()
-        self.addCleanup(wt.unlock)
-        self.assertEqual(wt.inventory.get_file_kind(wt.path2id("foo")),
-                "symlink")
-
-    def test_dir_to_file(self):
-        wt = self.make_branch_and_tree('.')
-        self.build_tree(['foo/', 'foo/bar'])
-        wt.add(['foo', 'foo/bar'])
-        wt.commit("one")
-        tt = TreeTransform(wt)
-        self.addCleanup(tt.finalize)
-        foo_trans_id = tt.trans_id_tree_path("foo")
-        bar_trans_id = tt.trans_id_tree_path("foo/bar")
-        tt.delete_contents(foo_trans_id)
-        tt.delete_versioned(bar_trans_id)
-        tt.create_file(["aa\n"], foo_trans_id)
-        tt.apply()
-        self.failUnlessExists("foo")
-        wt.lock_read()
-        self.addCleanup(wt.unlock)
-        self.assertEqual(wt.inventory.get_file_kind(wt.path2id("foo")),
-                "file")
-
-    def test_dir_to_hardlink(self):
-        self.requireFeature(HardlinkFeature)
-        wt = self.make_branch_and_tree('.')
-        self.build_tree(['foo/', 'foo/bar'])
-        wt.add(['foo', 'foo/bar'])
-        wt.commit("one")
-        tt = TreeTransform(wt)
-        self.addCleanup(tt.finalize)
-        foo_trans_id = tt.trans_id_tree_path("foo")
-        bar_trans_id = tt.trans_id_tree_path("foo/bar")
-        tt.delete_contents(foo_trans_id)
-        tt.delete_versioned(bar_trans_id)
-        self.build_tree(['baz'])
-        tt.create_hardlink("baz", foo_trans_id)
-        tt.apply()
-        self.failUnlessExists("foo")
-        self.failUnlessExists("baz")
-        wt.lock_read()
-        self.addCleanup(wt.unlock)
-        self.assertEqual(wt.inventory.get_file_kind(wt.path2id("foo")),
-                "file")
-
-    def test_no_final_path(self):
-        transform, root = self.get_transform()
-        trans_id = transform.trans_id_file_id('foo')
-        transform.create_file('bar', trans_id)
-        transform.cancel_creation(trans_id)
-        transform.apply()
+    def test_change_entry(self):
+        txt = 'bzrlib.transform.change_entry was deprecated in version 0.90.'
+        self.callDeprecated([txt], change_entry, None, None, None, None, None,
+            None, None, None)
 
 
 class TransformGroup(object):
-
     def __init__(self, dirname, root_id):
         self.name = dirname
         os.mkdir(dirname)
@@ -1325,7 +977,6 @@
 
 
 class TestTransformMerge(TestCaseInTempDir):
-
     def test_text_merge(self):
         root_id = generate_ids.gen_root_id()
         base = TransformGroup("base", root_id)
@@ -1361,7 +1012,6 @@
         this.tt.new_file('i', this.root, '1\n2\n3\n4\n', 'i')
         this.tt.apply()
         Merge3Merger(this.wt, this.wt, base.wt, other.wt)
-
         # textual merge
         self.assertEqual(this.wt.get_file('a').read(), 'y\nb\nc\nd\bz\n')
         # three-way text conflict
@@ -1405,7 +1055,8 @@
         this.wt.revert()
 
     def test_file_merge(self):
-        self.requireFeature(SymlinkFeature)
+        if not has_symlinks():
+            raise TestSkipped('Symlinks are not supported on this platform')
         root_id = generate_ids.gen_root_id()
         base = TransformGroup("BASE", root_id)
         this = TransformGroup("THIS", root_id)
@@ -1513,8 +1164,9 @@
 
 class TestBuildTree(tests.TestCaseWithTransport):
 
-    def test_build_tree_with_symlinks(self):
-        self.requireFeature(SymlinkFeature)
+    def test_build_tree(self):
+        if not has_symlinks():
+            raise TestSkipped('Test requires symlink support')
         os.mkdir('a')
         a = BzrDir.create_standalone_workingtree('a')
         os.mkdir('a/foo')
@@ -1568,7 +1220,8 @@
 
     def test_symlink_conflict_handling(self):
         """Ensure that when building trees, conflict handling is done"""
-        self.requireFeature(SymlinkFeature)
+        if not has_symlinks():
+            raise TestSkipped('Test requires symlink support')
         source = self.make_branch_and_tree('source')
         os.symlink('foo', 'source/symlink')
         source.add('symlink', 'new-symlink')
@@ -1665,149 +1318,6 @@
         # children of non-root directories should not be renamed
         self.assertEqual(2, transform_result.rename_count)
 
-    def create_ab_tree(self):
-        """Create a committed test tree with two files"""
-        source = self.make_branch_and_tree('source')
-        self.build_tree_contents([('source/file1', 'A')])
-        self.build_tree_contents([('source/file2', 'B')])
-        source.add(['file1', 'file2'], ['file1-id', 'file2-id'])
-        source.commit('commit files')
-        source.lock_write()
-        self.addCleanup(source.unlock)
-        return source
-
-    def test_build_tree_accelerator_tree(self):
-        source = self.create_ab_tree()
-        self.build_tree_contents([('source/file2', 'C')])
-        calls = []
-        real_source_get_file = source.get_file
-        def get_file(file_id, path=None):
-            calls.append(file_id)
-            return real_source_get_file(file_id, path)
-        source.get_file = get_file
-        target = self.make_branch_and_tree('target')
-        revision_tree = source.basis_tree()
-        revision_tree.lock_read()
-        self.addCleanup(revision_tree.unlock)
-        build_tree(revision_tree, target, source)
-        self.assertEqual(['file1-id'], calls)
-        target.lock_read()
-        self.addCleanup(target.unlock)
-        self.assertEqual([], list(target.iter_changes(revision_tree)))
-
-    def test_build_tree_accelerator_tree_missing_file(self):
-        source = self.create_ab_tree()
-        os.unlink('source/file1')
-        source.remove(['file2'])
-        target = self.make_branch_and_tree('target')
-        revision_tree = source.basis_tree()
-        revision_tree.lock_read()
-        self.addCleanup(revision_tree.unlock)
-        build_tree(revision_tree, target, source)
-        target.lock_read()
-        self.addCleanup(target.unlock)
-        self.assertEqual([], list(target.iter_changes(revision_tree)))
-
-    def test_build_tree_accelerator_wrong_kind(self):
-        self.requireFeature(SymlinkFeature)
-        source = self.make_branch_and_tree('source')
-        self.build_tree_contents([('source/file1', '')])
-        self.build_tree_contents([('source/file2', '')])
-        source.add(['file1', 'file2'], ['file1-id', 'file2-id'])
-        source.commit('commit files')
-        os.unlink('source/file2')
-        self.build_tree_contents([('source/file2/', 'C')])
-        os.unlink('source/file1')
-        os.symlink('file2', 'source/file1')
-        calls = []
-        real_source_get_file = source.get_file
-        def get_file(file_id, path=None):
-            calls.append(file_id)
-            return real_source_get_file(file_id, path)
-        source.get_file = get_file
-        target = self.make_branch_and_tree('target')
-        revision_tree = source.basis_tree()
-        revision_tree.lock_read()
-        self.addCleanup(revision_tree.unlock)
-        build_tree(revision_tree, target, source)
-        self.assertEqual([], calls)
-        target.lock_read()
-        self.addCleanup(target.unlock)
-        self.assertEqual([], list(target.iter_changes(revision_tree)))
-
-    def test_build_tree_hardlink(self):
-        self.requireFeature(HardlinkFeature)
-        source = self.create_ab_tree()
-        target = self.make_branch_and_tree('target')
-        revision_tree = source.basis_tree()
-        revision_tree.lock_read()
-        self.addCleanup(revision_tree.unlock)
-        build_tree(revision_tree, target, source, hardlink=True)
-        target.lock_read()
-        self.addCleanup(target.unlock)
-        self.assertEqual([], list(target.iter_changes(revision_tree)))
-        source_stat = os.stat('source/file1')
-        target_stat = os.stat('target/file1')
-        self.assertEqual(source_stat, target_stat)
-
-        # Explicitly disallowing hardlinks should prevent them.
-        target2 = self.make_branch_and_tree('target2')
-        build_tree(revision_tree, target2, source, hardlink=False)
-        target2.lock_read()
-        self.addCleanup(target2.unlock)
-        self.assertEqual([], list(target2.iter_changes(revision_tree)))
-        source_stat = os.stat('source/file1')
-        target2_stat = os.stat('target2/file1')
-        self.assertNotEqual(source_stat, target2_stat)
-
-    def test_build_tree_accelerator_tree_moved(self):
-        source = self.make_branch_and_tree('source')
-        self.build_tree_contents([('source/file1', 'A')])
-        source.add(['file1'], ['file1-id'])
-        source.commit('commit files')
-        source.rename_one('file1', 'file2')
-        source.lock_read()
-        self.addCleanup(source.unlock)
-        target = self.make_branch_and_tree('target')
-        revision_tree = source.basis_tree()
-        revision_tree.lock_read()
-        self.addCleanup(revision_tree.unlock)
-        build_tree(revision_tree, target, source)
-        target.lock_read()
-        self.addCleanup(target.unlock)
-        self.assertEqual([], list(target.iter_changes(revision_tree)))
-
-    def test_build_tree_hardlinks_preserve_execute(self):
-        self.requireFeature(HardlinkFeature)
-        source = self.create_ab_tree()
-        tt = TreeTransform(source)
-        trans_id = tt.trans_id_tree_file_id('file1-id')
-        tt.set_executability(True, trans_id)
-        tt.apply()
-        self.assertTrue(source.is_executable('file1-id'))
-        target = self.make_branch_and_tree('target')
-        revision_tree = source.basis_tree()
-        revision_tree.lock_read()
-        self.addCleanup(revision_tree.unlock)
-        build_tree(revision_tree, target, source, hardlink=True)
-        target.lock_read()
-        self.addCleanup(target.unlock)
-        self.assertEqual([], list(target.iter_changes(revision_tree)))
-        self.assertTrue(source.is_executable('file1-id'))
-
-    def test_case_insensitive_build_tree_inventory(self):
-        source = self.make_branch_and_tree('source')
-        self.build_tree(['source/file', 'source/FILE'])
-        source.add(['file', 'FILE'], ['lower-id', 'upper-id'])
-        source.commit('added files')
-        # Don't try this at home, kids!
-        # Force the tree to report that it is case insensitive
-        target = self.make_branch_and_tree('target')
-        target.case_sensitive = False
-        build_tree(source.basis_tree(), target, source, delta_from_tree=True)
-        self.assertEqual('file.moved', target.id2path('lower-id'))
-        self.assertEqual('FILE', target.id2path('upper-id'))
-
 
 class MockTransform(object):
 
@@ -1826,7 +1336,6 @@
         object.__init__(self)
         self.name = "name"
 
-
 class TestGetBackupName(TestCase):
     def test_get_backup_name(self):
         tt = MockTransform()
@@ -1886,7 +1395,7 @@
         mover.rename('c/e', 'c/d')
         try:
             mover.rename('a', 'c')
-        except errors.FileExists, e:
+        except OSError, e:
             mover.rollback()
         self.failUnlessExists('a')
         self.failUnlessExists('c/d')
@@ -1959,496 +1468,3 @@
                           _mover=self.ExceptionFileMover(bad_target='d'))
         self.failUnlessExists('a')
         self.failUnlessExists('a/b')
-
-    def test_resolve_no_parent(self):
-        wt = self.make_branch_and_tree('.')
-        tt = TreeTransform(wt)
-        self.addCleanup(tt.finalize)
-        parent = tt.trans_id_file_id('parent-id')
-        tt.new_file('file', parent, 'Contents')
-        resolve_conflicts(tt)
-
-
-class TestTransformPreview(tests.TestCaseWithTransport):
-
-    def create_tree(self):
-        tree = self.make_branch_and_tree('.')
-        self.build_tree_contents([('a', 'content 1')])
-        tree.add('a', 'a-id')
-        tree.commit('rev1', rev_id='rev1')
-        return tree.branch.repository.revision_tree('rev1')
-
-    def get_empty_preview(self):
-        repository = self.make_repository('repo')
-        tree = repository.revision_tree(_mod_revision.NULL_REVISION)
-        preview = TransformPreview(tree)
-        self.addCleanup(preview.finalize)
-        return preview
-
-    def test_transform_preview(self):
-        revision_tree = self.create_tree()
-        preview = TransformPreview(revision_tree)
-        self.addCleanup(preview.finalize)
-
-    def test_transform_preview_tree(self):
-        revision_tree = self.create_tree()
-        preview = TransformPreview(revision_tree)
-        self.addCleanup(preview.finalize)
-        preview.get_preview_tree()
-
-    def test_transform_new_file(self):
-        revision_tree = self.create_tree()
-        preview = TransformPreview(revision_tree)
-        self.addCleanup(preview.finalize)
-        preview.new_file('file2', preview.root, 'content B\n', 'file2-id')
-        preview_tree = preview.get_preview_tree()
-        self.assertEqual(preview_tree.kind('file2-id'), 'file')
-        self.assertEqual(
-            preview_tree.get_file('file2-id').read(), 'content B\n')
-
-    def test_diff_preview_tree(self):
-        revision_tree = self.create_tree()
-        preview = TransformPreview(revision_tree)
-        self.addCleanup(preview.finalize)
-        preview.new_file('file2', preview.root, 'content B\n', 'file2-id')
-        preview_tree = preview.get_preview_tree()
-        out = StringIO()
-        show_diff_trees(revision_tree, preview_tree, out)
-        lines = out.getvalue().splitlines()
-        self.assertEqual(lines[0], "=== added file 'file2'")
-        # 3 lines of diff administrivia
-        self.assertEqual(lines[4], "+content B")
-
-    def test_transform_conflicts(self):
-        revision_tree = self.create_tree()
-        preview = TransformPreview(revision_tree)
-        self.addCleanup(preview.finalize)
-        preview.new_file('a', preview.root, 'content 2')
-        resolve_conflicts(preview)
-        trans_id = preview.trans_id_file_id('a-id')
-        self.assertEqual('a.moved', preview.final_name(trans_id))
-
-    def get_tree_and_preview_tree(self):
-        revision_tree = self.create_tree()
-        preview = TransformPreview(revision_tree)
-        self.addCleanup(preview.finalize)
-        a_trans_id = preview.trans_id_file_id('a-id')
-        preview.delete_contents(a_trans_id)
-        preview.create_file('b content', a_trans_id)
-        preview_tree = preview.get_preview_tree()
-        return revision_tree, preview_tree
-
-    def test_iter_changes(self):
-        revision_tree, preview_tree = self.get_tree_and_preview_tree()
-        root = revision_tree.inventory.root.file_id
-        self.assertEqual([('a-id', ('a', 'a'), True, (True, True),
-                          (root, root), ('a', 'a'), ('file', 'file'),
-                          (False, False))],
-                          list(preview_tree.iter_changes(revision_tree)))
-
-    def test_wrong_tree_value_error(self):
-        revision_tree, preview_tree = self.get_tree_and_preview_tree()
-        e = self.assertRaises(ValueError, preview_tree.iter_changes,
-                              preview_tree)
-        self.assertEqual('from_tree must be transform source tree.', str(e))
-
-    def test_include_unchanged_value_error(self):
-        revision_tree, preview_tree = self.get_tree_and_preview_tree()
-        e = self.assertRaises(ValueError, preview_tree.iter_changes,
-                              revision_tree, include_unchanged=True)
-        self.assertEqual('include_unchanged is not supported', str(e))
-
-    def test_specific_files(self):
-        revision_tree, preview_tree = self.get_tree_and_preview_tree()
-        e = self.assertRaises(ValueError, preview_tree.iter_changes,
-                              revision_tree, specific_files=['pete'])
-        self.assertEqual('specific_files is not supported', str(e))
-
-    def test_want_unversioned_value_error(self):
-        revision_tree, preview_tree = self.get_tree_and_preview_tree()
-        e = self.assertRaises(ValueError, preview_tree.iter_changes,
-                              revision_tree, want_unversioned=True)
-        self.assertEqual('want_unversioned is not supported', str(e))
-
-    def test_ignore_extra_trees_no_specific_files(self):
-        # extra_trees is harmless without specific_files, so we'll silently
-        # accept it, even though we won't use it.
-        revision_tree, preview_tree = self.get_tree_and_preview_tree()
-        preview_tree.iter_changes(revision_tree, extra_trees=[preview_tree])
-
-    def test_ignore_require_versioned_no_specific_files(self):
-        # require_versioned is meaningless without specific_files.
-        revision_tree, preview_tree = self.get_tree_and_preview_tree()
-        preview_tree.iter_changes(revision_tree, require_versioned=False)
-
-    def test_ignore_pb(self):
-        # pb could be supported, but TT.iter_changes doesn't support it.
-        revision_tree, preview_tree = self.get_tree_and_preview_tree()
-        preview_tree.iter_changes(revision_tree, pb=progress.DummyProgress())
-
-    def test_kind(self):
-        revision_tree = self.create_tree()
-        preview = TransformPreview(revision_tree)
-        self.addCleanup(preview.finalize)
-        preview.new_file('file', preview.root, 'contents', 'file-id')
-        preview.new_directory('directory', preview.root, 'dir-id')
-        preview_tree = preview.get_preview_tree()
-        self.assertEqual('file', preview_tree.kind('file-id'))
-        self.assertEqual('directory', preview_tree.kind('dir-id'))
-
-    def test_get_file_mtime(self):
-        preview = self.get_empty_preview()
-        file_trans_id = preview.new_file('file', preview.root, 'contents',
-                                         'file-id')
-        limbo_path = preview._limbo_name(file_trans_id)
-        preview_tree = preview.get_preview_tree()
-        self.assertEqual(os.stat(limbo_path).st_mtime,
-                         preview_tree.get_file_mtime('file-id'))
-
-    def test_get_file(self):
-        preview = self.get_empty_preview()
-        preview.new_file('file', preview.root, 'contents', 'file-id')
-        preview_tree = preview.get_preview_tree()
-        tree_file = preview_tree.get_file('file-id')
-        try:
-            self.assertEqual('contents', tree_file.read())
-        finally:
-            tree_file.close()
-
-    def test_get_symlink_target(self):
-        self.requireFeature(SymlinkFeature)
-        preview = self.get_empty_preview()
-        preview.new_symlink('symlink', preview.root, 'target', 'symlink-id')
-        preview_tree = preview.get_preview_tree()
-        self.assertEqual('target',
-                         preview_tree.get_symlink_target('symlink-id'))
-
-    def test_all_file_ids(self):
-        tree = self.make_branch_and_tree('tree')
-        self.build_tree(['tree/a', 'tree/b', 'tree/c'])
-        tree.add(['a', 'b', 'c'], ['a-id', 'b-id', 'c-id'])
-        preview = TransformPreview(tree)
-        self.addCleanup(preview.finalize)
-        preview.unversion_file(preview.trans_id_file_id('b-id'))
-        c_trans_id = preview.trans_id_file_id('c-id')
-        preview.unversion_file(c_trans_id)
-        preview.version_file('c-id', c_trans_id)
-        preview_tree = preview.get_preview_tree()
-        self.assertEqual(set(['a-id', 'c-id', tree.get_root_id()]),
-                         preview_tree.all_file_ids())
-
-    def test_path2id_deleted_unchanged(self):
-        tree = self.make_branch_and_tree('tree')
-        self.build_tree(['tree/unchanged', 'tree/deleted'])
-        tree.add(['unchanged', 'deleted'], ['unchanged-id', 'deleted-id'])
-        preview = TransformPreview(tree)
-        self.addCleanup(preview.finalize)
-        preview.unversion_file(preview.trans_id_file_id('deleted-id'))
-        preview_tree = preview.get_preview_tree()
-        self.assertEqual('unchanged-id', preview_tree.path2id('unchanged'))
-        self.assertIs(None, preview_tree.path2id('deleted'))
-
-    def test_path2id_created(self):
-        tree = self.make_branch_and_tree('tree')
-        self.build_tree(['tree/unchanged'])
-        tree.add(['unchanged'], ['unchanged-id'])
-        preview = TransformPreview(tree)
-        self.addCleanup(preview.finalize)
-        preview.new_file('new', preview.trans_id_file_id('unchanged-id'),
-            'contents', 'new-id')
-        preview_tree = preview.get_preview_tree()
-        self.assertEqual('new-id', preview_tree.path2id('unchanged/new'))
-
-    def test_path2id_moved(self):
-        tree = self.make_branch_and_tree('tree')
-        self.build_tree(['tree/old_parent/', 'tree/old_parent/child'])
-        tree.add(['old_parent', 'old_parent/child'],
-                 ['old_parent-id', 'child-id'])
-        preview = TransformPreview(tree)
-        self.addCleanup(preview.finalize)
-        new_parent = preview.new_directory('new_parent', preview.root,
-                                           'new_parent-id')
-        preview.adjust_path('child', new_parent,
-                            preview.trans_id_file_id('child-id'))
-        preview_tree = preview.get_preview_tree()
-        self.assertIs(None, preview_tree.path2id('old_parent/child'))
-        self.assertEqual('child-id', preview_tree.path2id('new_parent/child'))
-
-    def test_path2id_renamed_parent(self):
-        tree = self.make_branch_and_tree('tree')
-        self.build_tree(['tree/old_name/', 'tree/old_name/child'])
-        tree.add(['old_name', 'old_name/child'],
-                 ['parent-id', 'child-id'])
-        preview = TransformPreview(tree)
-        self.addCleanup(preview.finalize)
-        preview.adjust_path('new_name', preview.root,
-                            preview.trans_id_file_id('parent-id'))
-        preview_tree = preview.get_preview_tree()
-        self.assertIs(None, preview_tree.path2id('old_name/child'))
-        self.assertEqual('child-id', preview_tree.path2id('new_name/child'))
-
-    def assertMatchingIterEntries(self, tt, specific_file_ids=None):
-        preview_tree = tt.get_preview_tree()
-        preview_result = list(preview_tree.iter_entries_by_dir(
-                              specific_file_ids))
-        tree = tt._tree
-        tt.apply()
-        actual_result = list(tree.iter_entries_by_dir(specific_file_ids))
-        self.assertEqual(actual_result, preview_result)
-
-    def test_iter_entries_by_dir_new(self):
-        tree = self.make_branch_and_tree('tree')
-        tt = TreeTransform(tree)
-        tt.new_file('new', tt.root, 'contents', 'new-id')
-        self.assertMatchingIterEntries(tt)
-
-    def test_iter_entries_by_dir_deleted(self):
-        tree = self.make_branch_and_tree('tree')
-        self.build_tree(['tree/deleted'])
-        tree.add('deleted', 'deleted-id')
-        tt = TreeTransform(tree)
-        tt.delete_contents(tt.trans_id_file_id('deleted-id'))
-        self.assertMatchingIterEntries(tt)
-
-    def test_iter_entries_by_dir_unversioned(self):
-        tree = self.make_branch_and_tree('tree')
-        self.build_tree(['tree/removed'])
-        tree.add('removed', 'removed-id')
-        tt = TreeTransform(tree)
-        tt.unversion_file(tt.trans_id_file_id('removed-id'))
-        self.assertMatchingIterEntries(tt)
-
-    def test_iter_entries_by_dir_moved(self):
-        tree = self.make_branch_and_tree('tree')
-        self.build_tree(['tree/moved', 'tree/new_parent/'])
-        tree.add(['moved', 'new_parent'], ['moved-id', 'new_parent-id'])
-        tt = TreeTransform(tree)
-        tt.adjust_path('moved', tt.trans_id_file_id('new_parent-id'),
-                       tt.trans_id_file_id('moved-id'))
-        self.assertMatchingIterEntries(tt)
-
-    def test_iter_entries_by_dir_specific_file_ids(self):
-        tree = self.make_branch_and_tree('tree')
-        tree.set_root_id('tree-root-id')
-        self.build_tree(['tree/parent/', 'tree/parent/child'])
-        tree.add(['parent', 'parent/child'], ['parent-id', 'child-id'])
-        tt = TreeTransform(tree)
-        self.assertMatchingIterEntries(tt, ['tree-root-id', 'child-id'])
-
-    def test_symlink_content_summary(self):
-        self.requireFeature(SymlinkFeature)
-        preview = self.get_empty_preview()
-        preview.new_symlink('path', preview.root, 'target', 'path-id')
-        summary = preview.get_preview_tree().path_content_summary('path')
-        self.assertEqual(('symlink', None, None, 'target'), summary)
-
-    def test_missing_content_summary(self):
-        preview = self.get_empty_preview()
-        summary = preview.get_preview_tree().path_content_summary('path')
-        self.assertEqual(('missing', None, None, None), summary)
-
-    def test_deleted_content_summary(self):
-        tree = self.make_branch_and_tree('tree')
-        self.build_tree(['tree/path/'])
-        tree.add('path')
-        preview = TransformPreview(tree)
-        self.addCleanup(preview.finalize)
-        preview.delete_contents(preview.trans_id_tree_path('path'))
-        summary = preview.get_preview_tree().path_content_summary('path')
-        self.assertEqual(('missing', None, None, None), summary)
-
-    def test_file_content_summary_executable(self):
-        if not osutils.supports_executable():
-            raise TestNotApplicable()
-        preview = self.get_empty_preview()
-        path_id = preview.new_file('path', preview.root, 'contents', 'path-id')
-        preview.set_executability(True, path_id)
-        summary = preview.get_preview_tree().path_content_summary('path')
-        self.assertEqual(4, len(summary))
-        self.assertEqual('file', summary[0])
-        # size must be known
-        self.assertEqual(len('contents'), summary[1])
-        # executable
-        self.assertEqual(True, summary[2])
-        # will not have hash (not cheap to determine)
-        self.assertIs(None, summary[3])
-
-    def test_change_executability(self):
-        if not osutils.supports_executable():
-            raise TestNotApplicable()
-        tree = self.make_branch_and_tree('tree')
-        self.build_tree(['tree/path'])
-        tree.add('path')
-        preview = TransformPreview(tree)
-        self.addCleanup(preview.finalize)
-        path_id = preview.trans_id_tree_path('path')
-        preview.set_executability(True, path_id)
-        summary = preview.get_preview_tree().path_content_summary('path')
-        self.assertEqual(True, summary[2])
-
-    def test_file_content_summary_non_exec(self):
-        preview = self.get_empty_preview()
-        preview.new_file('path', preview.root, 'contents', 'path-id')
-        summary = preview.get_preview_tree().path_content_summary('path')
-        self.assertEqual(4, len(summary))
-        self.assertEqual('file', summary[0])
-        # size must be known
-        self.assertEqual(len('contents'), summary[1])
-        # not executable
-        if osutils.supports_executable():
-            self.assertEqual(False, summary[2])
-        else:
-            self.assertEqual(None, summary[2])
-        # will not have hash (not cheap to determine)
-        self.assertIs(None, summary[3])
-
-    def test_dir_content_summary(self):
-        preview = self.get_empty_preview()
-        preview.new_directory('path', preview.root, 'path-id')
-        summary = preview.get_preview_tree().path_content_summary('path')
-        self.assertEqual(('directory', None, None, None), summary)
-
-    def test_tree_content_summary(self):
-        preview = self.get_empty_preview()
-        path = preview.new_directory('path', preview.root, 'path-id')
-        preview.set_tree_reference('rev-1', path)
-        summary = preview.get_preview_tree().path_content_summary('path')
-        self.assertEqual(4, len(summary))
-        self.assertEqual('tree-reference', summary[0])
-
-    def test_annotate(self):
-        tree = self.make_branch_and_tree('tree')
-        self.build_tree_contents([('tree/file', 'a\n')])
-        tree.add('file', 'file-id')
-        tree.commit('a', rev_id='one')
-        self.build_tree_contents([('tree/file', 'a\nb\n')])
-        preview = TransformPreview(tree)
-        self.addCleanup(preview.finalize)
-        file_trans_id = preview.trans_id_file_id('file-id')
-        preview.delete_contents(file_trans_id)
-        preview.create_file('a\nb\nc\n', file_trans_id)
-        preview_tree = preview.get_preview_tree()
-        expected = [
-            ('one', 'a\n'),
-            ('me:', 'b\n'),
-            ('me:', 'c\n'),
-        ]
-        annotation = preview_tree.annotate_iter('file-id', 'me:')
-        self.assertEqual(expected, annotation)
-
-    def test_annotate_missing(self):
-        preview = self.get_empty_preview()
-        preview.new_file('file', preview.root, 'a\nb\nc\n', 'file-id')
-        preview_tree = preview.get_preview_tree()
-        expected = [
-            ('me:', 'a\n'),
-            ('me:', 'b\n'),
-            ('me:', 'c\n'),
-         ]
-        annotation = preview_tree.annotate_iter('file-id', 'me:')
-        self.assertEqual(expected, annotation)
-
-    def test_annotate_rename(self):
-        tree = self.make_branch_and_tree('tree')
-        self.build_tree_contents([('tree/file', 'a\n')])
-        tree.add('file', 'file-id')
-        tree.commit('a', rev_id='one')
-        preview = TransformPreview(tree)
-        self.addCleanup(preview.finalize)
-        file_trans_id = preview.trans_id_file_id('file-id')
-        preview.adjust_path('newname', preview.root, file_trans_id)
-        preview_tree = preview.get_preview_tree()
-        expected = [
-            ('one', 'a\n'),
-        ]
-        annotation = preview_tree.annotate_iter('file-id', 'me:')
-        self.assertEqual(expected, annotation)
-
-    def test_annotate_deleted(self):
-        tree = self.make_branch_and_tree('tree')
-        self.build_tree_contents([('tree/file', 'a\n')])
-        tree.add('file', 'file-id')
-        tree.commit('a', rev_id='one')
-        self.build_tree_contents([('tree/file', 'a\nb\n')])
-        preview = TransformPreview(tree)
-        self.addCleanup(preview.finalize)
-        file_trans_id = preview.trans_id_file_id('file-id')
-        preview.delete_contents(file_trans_id)
-        preview_tree = preview.get_preview_tree()
-        annotation = preview_tree.annotate_iter('file-id', 'me:')
-        self.assertIs(None, annotation)
-
-    def test_stored_kind(self):
-        preview = self.get_empty_preview()
-        preview.new_file('file', preview.root, 'a\nb\nc\n', 'file-id')
-        preview_tree = preview.get_preview_tree()
-        self.assertEqual('file', preview_tree.stored_kind('file-id'))
-
-    def test_is_executable(self):
-        preview = self.get_empty_preview()
-        preview.new_file('file', preview.root, 'a\nb\nc\n', 'file-id')
-        preview.set_executability(True, preview.trans_id_file_id('file-id'))
-        preview_tree = preview.get_preview_tree()
-        self.assertEqual(True, preview_tree.is_executable('file-id'))
-
-    def test_get_set_parent_ids(self):
-        revision_tree, preview_tree = self.get_tree_and_preview_tree()
-        self.assertEqual([], preview_tree.get_parent_ids())
-        preview_tree.set_parent_ids(['rev-1'])
-        self.assertEqual(['rev-1'], preview_tree.get_parent_ids())
-
-    def test_plan_file_merge(self):
-        work_a = self.make_branch_and_tree('wta')
-        self.build_tree_contents([('wta/file', 'a\nb\nc\nd\n')])
-        work_a.add('file', 'file-id')
-        base_id = work_a.commit('base version')
-        tree_b = work_a.bzrdir.sprout('wtb').open_workingtree()
-        preview = TransformPreview(work_a)
-        self.addCleanup(preview.finalize)
-        trans_id = preview.trans_id_file_id('file-id')
-        preview.delete_contents(trans_id)
-        preview.create_file('b\nc\nd\ne\n', trans_id)
-        self.build_tree_contents([('wtb/file', 'a\nc\nd\nf\n')])
-        tree_a = preview.get_preview_tree()
-        tree_a.set_parent_ids([base_id])
-        self.assertEqual([
-            ('killed-a', 'a\n'),
-            ('killed-b', 'b\n'),
-            ('unchanged', 'c\n'),
-            ('unchanged', 'd\n'),
-            ('new-a', 'e\n'),
-            ('new-b', 'f\n'),
-        ], list(tree_a.plan_file_merge('file-id', tree_b)))
-
-    def test_plan_file_merge_revision_tree(self):
-        work_a = self.make_branch_and_tree('wta')
-        self.build_tree_contents([('wta/file', 'a\nb\nc\nd\n')])
-        work_a.add('file', 'file-id')
-        base_id = work_a.commit('base version')
-        tree_b = work_a.bzrdir.sprout('wtb').open_workingtree()
-        preview = TransformPreview(work_a.basis_tree())
-        self.addCleanup(preview.finalize)
-        trans_id = preview.trans_id_file_id('file-id')
-        preview.delete_contents(trans_id)
-        preview.create_file('b\nc\nd\ne\n', trans_id)
-        self.build_tree_contents([('wtb/file', 'a\nc\nd\nf\n')])
-        tree_a = preview.get_preview_tree()
-        tree_a.set_parent_ids([base_id])
-        self.assertEqual([
-            ('killed-a', 'a\n'),
-            ('killed-b', 'b\n'),
-            ('unchanged', 'c\n'),
-            ('unchanged', 'd\n'),
-            ('new-a', 'e\n'),
-            ('new-b', 'f\n'),
-        ], list(tree_a.plan_file_merge('file-id', tree_b)))
-
-    def test_walkdirs(self):
-        preview = self.get_empty_preview()
-        preview.version_file('tree-root', preview.root)
-        preview_tree = preview.get_preview_tree()
-        file_trans_id = preview.new_file('a', preview.root, 'contents',
-                                         'a-id')
-        expected = [(('', 'tree-root'),
-                    [('a', 'a', 'file', None, 'a-id', 'file')])]
-        self.assertEqual(expected, list(preview_tree.walkdirs()))

=== modified file 'bzrlib/tests/test_transport.py'
--- bzrlib/tests/test_transport.py	2008-06-19 06:57:22 +0000
+++ bzrlib/tests/test_transport.py	2007-10-22 21:19:13 +0000
@@ -48,6 +48,10 @@
 from bzrlib.transport.memory import MemoryTransport
 from bzrlib.transport.local import (LocalTransport,
                                     EmulatedWin32LocalTransport)
+from bzrlib.transport.remote import (
+    BZR_DEFAULT_PORT,
+    RemoteTCPTransport
+    )
 
 
 # TODO: Should possibly split transport-specific tests into their own files.
@@ -74,13 +78,10 @@
         try:
             _clear_protocol_handlers()
             register_transport_proto('foo')
-            register_lazy_transport('foo', 'bzrlib.tests.test_transport',
-                                    'TestTransport.SampleHandler')
+            register_lazy_transport('foo', 'bzrlib.tests.test_transport', 'TestTransport.SampleHandler')
             register_transport_proto('bar')
-            register_lazy_transport('bar', 'bzrlib.tests.test_transport',
-                                    'TestTransport.SampleHandler')
-            self.assertEqual([SampleHandler.__module__,
-                              'bzrlib.transport.chroot'],
+            register_lazy_transport('bar', 'bzrlib.tests.test_transport', 'TestTransport.SampleHandler')
+            self.assertEqual([SampleHandler.__module__, 'bzrlib.transport.chroot'],
                              _get_transport_modules())
         finally:
             _set_protocol_handlers(handlers)
@@ -152,12 +153,11 @@
 
 
 class TestCoalesceOffsets(TestCase):
-
-    def check(self, expected, offsets, limit=0, max_size=0, fudge=0):
+    
+    def check(self, expected, offsets, limit=0, fudge=0):
         coalesce = Transport._coalesce_offsets
         exp = [_CoalescedOffset(*x) for x in expected]
-        out = list(coalesce(offsets, limit=limit, fudge_factor=fudge,
-                            max_size=max_size))
+        out = list(coalesce(offsets, limit=limit, fudge_factor=fudge))
         self.assertEqual(exp, out)
 
     def test_coalesce_empty(self):
@@ -170,7 +170,7 @@
         self.check([(0, 10, [(0, 10)]),
                     (20, 10, [(0, 10)]),
                    ], [(0, 10), (20, 10)])
-
+            
     def test_coalesce_unsorted(self):
         self.check([(20, 10, [(0, 10)]),
                     (0, 10, [(0, 10)]),
@@ -180,7 +180,6 @@
         self.check([(0, 20, [(0, 10), (10, 10)])],
                    [(0, 10), (10, 10)])
 
-    # XXX: scary, http.readv() can't handle that --vila20071209
     def test_coalesce_overlapped(self):
         self.check([(0, 15, [(0, 10), (5, 10)])],
                    [(0, 10), (5, 10)])
@@ -210,20 +209,6 @@
                    ], [(10, 10), (30, 10), (100, 10)],
                    fudge=10
                   )
-    def test_coalesce_max_size(self):
-        self.check([(10, 20, [(0, 10), (10, 10)]),
-                    (30, 50, [(0, 50)]),
-                    # If one range is above max_size, it gets its own coalesced
-                    # offset
-                    (100, 80, [(0, 80),]),],
-                   [(10, 10), (20, 10), (30, 50), (100, 80)],
-                   max_size=50
-                  )
-
-    def test_coalesce_no_max_size(self):
-        self.check([(10, 170, [(0, 10), (10, 10), (20, 50), (70, 100)]),],
-                   [(10, 10), (20, 10), (30, 50), (80, 100)],
-                  )
 
 
 class TestMemoryTransport(TestCase):
@@ -433,9 +418,9 @@
         self.assertEqual(True, transport.is_readonly())
 
     def test_http_parameters(self):
-        from bzrlib.tests.http_server import HttpServer
+        from bzrlib.tests.HttpServer import HttpServer
         import bzrlib.transport.readonly as readonly
-        # connect to '.' via http which is not listable
+        # connect to . via http which is not listable
         server = HttpServer()
         server.setUp()
         try:
@@ -466,8 +451,8 @@
     def test_http_parameters(self):
         # the listable and is_readonly parameters
         # are not changed by the fakenfs decorator
-        from bzrlib.tests.http_server import HttpServer
-        # connect to '.' via http which is not listable
+        from bzrlib.tests.HttpServer import HttpServer
+        # connect to . via http which is not listable
         server = HttpServer()
         server.setUp()
         try:
@@ -634,18 +619,13 @@
     def test_parse_url(self):
         t = ConnectedTransport('http://simple.example.com/home/source')
         self.assertEquals(t._host, 'simple.example.com')
-        self.assertEquals(t._port, None)
+        self.assertEquals(t._port, 80)
         self.assertEquals(t._path, '/home/source/')
         self.failUnless(t._user is None)
         self.failUnless(t._password is None)
 
         self.assertEquals(t.base, 'http://simple.example.com/home/source/')
 
-    def test_parse_url_with_at_in_user(self):
-        # Bug 228058
-        t = ConnectedTransport('ftp://user@host.com@www.host.com/')
-        self.assertEquals(t._user, 'user@host.com')
-
     def test_parse_quoted_url(self):
         t = ConnectedTransport('http://ro%62ey:h%40t@ex%41mple.com:2222/path')
         self.assertEquals(t._host, 'exAmple.com')
@@ -736,6 +716,123 @@
         self.assertIsNot(t1, t2)
 
 
+class TestRemoteTCPTransport(TestCase):
+    """Tests for bzr:// transport (RemoteTCPTransport)."""
+
+    def test_relpath_with_implicit_port(self):
+        """Connected transports with the same URL are the same, even if the
+        port is implicit.
+
+        So t.relpath(url) should always be '' if t.base is the same as url, or
+        if the only difference is that one explicitly specifies the default
+        port and the other doesn't specify a port.
+        """
+        t_implicit_port = RemoteTCPTransport('bzr://host.com/')
+        self.assertEquals('', t_implicit_port.relpath('bzr://host.com/'))
+        self.assertEquals('', t_implicit_port.relpath('bzr://host.com:4155/'))
+        t_explicit_port = RemoteTCPTransport('bzr://host.com:4155/')
+        self.assertEquals('', t_explicit_port.relpath('bzr://host.com/'))
+        self.assertEquals('', t_explicit_port.relpath('bzr://host.com:4155/'))
+
+    def test_construct_uses_default_port(self):
+        """If no port is specified, then RemoteTCPTransport uses
+        BZR_DEFAULT_PORT.
+        """
+        t = get_transport('bzr://host.com/')
+        self.assertEquals(BZR_DEFAULT_PORT, t._port)
+
+    def test_url_omits_default_port(self):
+        """If a RemoteTCPTransport uses the default port, then its base URL
+        will omit the port.
+
+        This is like how ":80" is omitted from "http://example.com/".
+        """
+        t = get_transport('bzr://host.com:4155/')
+        self.assertEquals('bzr://host.com/', t.base)
+
+    def test_url_includes_non_default_port(self):
+        """Non-default ports are included in the transport's URL.
+
+        Contrast this to `test_url_omits_default_port`.
+        """
+        t = get_transport('bzr://host.com:666/')
+        self.assertEquals('bzr://host.com:666/', t.base)
+
+
+class SSHPortTestMixin(object):
+    """Mixin class for testing SSH-based transports' use of ports in URLs.
+    
+    Unlike other connected transports, SSH-based transports (sftp, bzr+ssh)
+    don't have a default port, because the user may have OpenSSH configured to
+    use a non-standard port.
+    """
+
+    def make_url(self, netloc):
+        """Make a url for the given netloc, using the scheme defined on the
+        TestCase.
+        """
+        return '%s://%s/' % (self.scheme, netloc)
+
+    def test_relpath_with_implicit_port(self):
+        """SSH-based transports with the same URL are the same.
+        
+        Note than an unspecified port number is different to port 22 (because
+        OpenSSH may be configured to use a non-standard port).
+
+        So t.relpath(url) should always be '' if t.base is the same as url, but
+        raise PathNotChild if the ports in t and url are not both specified (or
+        both unspecified).
+        """
+        url_implicit_port = self.make_url('host.com')
+        url_explicit_port = self.make_url('host.com:22')
+
+        t_implicit_port = get_transport(url_implicit_port)
+        self.assertEquals('', t_implicit_port.relpath(url_implicit_port))
+        self.assertRaises(
+            PathNotChild, t_implicit_port.relpath, url_explicit_port)
+        
+        t_explicit_port = get_transport(url_explicit_port)
+        self.assertRaises(
+            PathNotChild, t_explicit_port.relpath, url_implicit_port)
+        self.assertEquals('', t_explicit_port.relpath(url_explicit_port))
+
+    def test_construct_with_no_port(self):
+        """If no port is specified, then the SSH-based transport's _port will
+        be None.
+        """
+        t = get_transport(self.make_url('host.com'))
+        self.assertEquals(None, t._port)
+
+    def test_url_with_no_port(self):
+        """If no port was specified, none is shown in the base URL."""
+        t = get_transport(self.make_url('host.com'))
+        self.assertEquals(self.make_url('host.com'), t.base)
+
+    def test_url_includes_port(self):
+        """An SSH-based transport's base will show the port if one was
+        specified, even if that port is 22, because we do not assume 22 is the
+        default port.
+        """
+        # 22 is the "standard" port for SFTP.
+        t = get_transport(self.make_url('host.com:22'))
+        self.assertEquals(self.make_url('host.com:22'), t.base)
+        # 666 is not a standard port.
+        t = get_transport(self.make_url('host.com:666'))
+        self.assertEquals(self.make_url('host.com:666'), t.base)
+
+
+class SFTPTransportPortTest(TestCase, SSHPortTestMixin):
+    """Tests for sftp:// transport (SFTPTransport)."""
+
+    scheme = 'sftp'
+
+
+class BzrSSHTransportPortTest(TestCase, SSHPortTestMixin):
+    """Tests for bzr+ssh:// transport (RemoteSSHTransport)."""
+
+    scheme = 'bzr+ssh'
+
+
 class TestTransportTrace(TestCase):
 
     def test_get(self):

=== modified file 'bzrlib/tests/test_transport_implementations.py'
--- bzrlib/tests/test_transport_implementations.py	2008-06-09 07:20:06 +0000
+++ bzrlib/tests/test_transport_implementations.py	2007-10-22 21:19:13 +0000
@@ -20,7 +20,6 @@
 TransportTestProviderAdapter.
 """
 
-import itertools
 import os
 from cStringIO import StringIO
 from StringIO import StringIO as pyStringIO
@@ -31,7 +30,6 @@
 from bzrlib import (
     errors,
     osutils,
-    tests,
     urlutils,
     )
 from bzrlib.errors import (ConnectionError,
@@ -39,6 +37,7 @@
                            FileExists,
                            InvalidURL,
                            LockError,
+                           NoSmartServer,
                            NoSuchFile,
                            NotLocalUrl,
                            PathError,
@@ -46,12 +45,7 @@
                            )
 from bzrlib.osutils import getcwd
 from bzrlib.smart import medium
-from bzrlib.tests import (
-    TestCaseInTempDir,
-    TestScenarioApplier,
-    TestSkipped,
-    TestNotApplicable,
-    )
+from bzrlib.tests import TestCaseInTempDir, TestScenarioApplier, TestSkipped
 from bzrlib.tests.test_transport import TestTransportImplementation
 from bzrlib.transport import (
     ConnectedTransport,
@@ -75,9 +69,10 @@
     def get_transport_test_permutations(self, module):
         """Get the permutations module wants to have tested."""
         if getattr(module, 'get_test_permutations', None) is None:
-            raise AssertionError(
-                "transport module %s doesn't provide get_test_permutations()"
-                % module.__name__)
+            raise AssertionError("transport module %s doesn't provide get_test_permutations()"
+                    % module.__name__)
+            ##warning("transport module %s doesn't provide get_test_permutations()"
+            ##       % module.__name__)
             return []
         return module.get_test_permutations()
 
@@ -95,19 +90,11 @@
                     result.append(scenario)
             except errors.DependencyNotPresent, e:
                 # Continue even if a dependency prevents us 
-                # from adding this test
+                # from running this test
                 pass
         return result
 
 
-def load_tests(standard_tests, module, loader):
-    """Multiply tests for tranport implementations."""
-    result = loader.suiteClass()
-    adapter = TransportTestProviderAdapter()
-    for test in tests.iter_suite_tests(standard_tests):
-        result.addTests(adapter.adapt(test))
-    return result
-
 
 class TransportTests(TestTransportImplementation):
 
@@ -177,11 +164,6 @@
         self.assertEqual(True, t.has_any(['b', 'b', 'b']))
 
     def test_has_root_works(self):
-        from bzrlib.smart import server
-        if self.transport_server is server.SmartTCPServer_for_testing:
-            raise TestNotApplicable(
-                "SmartTCPServer_for_testing intentionally does not allow "
-                "access to /.")
         current_transport = self.get_transport()
         self.assertTrue(current_transport.has('/'))
         root = current_transport.clone('/')
@@ -199,15 +181,11 @@
         self.build_tree(files, transport=t, line_endings='binary')
         self.check_transport_contents('contents of a\n', t, 'a')
         content_f = t.get_multi(files)
-        # Use itertools.izip() instead of use zip() or map(), since they fully
-        # evaluate their inputs, the transport requests should be issued and
-        # handled sequentially (we don't want to force transport to buffer).
-        for content, f in itertools.izip(contents, content_f):
+        for content, f in zip(contents, content_f):
             self.assertEqual(content, f.read())
 
         content_f = t.get_multi(iter(files))
-        # Use itertools.izip() for the same reason
-        for content, f in itertools.izip(contents, content_f):
+        for content, f in zip(contents, content_f):
             self.assertEqual(content, f.read())
 
         self.assertRaises(NoSuchFile, t.get, 'c')
@@ -227,8 +205,8 @@
         except (errors.PathError, errors.RedirectRequested):
             # early failure return immediately.
             return
-        # having got a file, read() must either work (i.e. http reading a dir
-        # listing) or fail with ReadError
+        # having got a file, read() must either work (i.e. http reading a dir listing) or
+        # fail with ReadError
         try:
             a_file.read()
         except errors.ReadError:
@@ -922,20 +900,6 @@
         self.assertFalse(t.has('adir/bdir'))
         self.assertFalse(t.has('adir/bsubdir'))
 
-    def test_rename_across_subdirs(self):
-        t = self.get_transport()
-        if t.is_readonly():
-            raise TestNotApplicable("transport is readonly")
-        t.mkdir('a')
-        t.mkdir('b')
-        ta = t.clone('a')
-        tb = t.clone('b')
-        ta.put_bytes('f', 'aoeu')
-        ta.rename('f', '../b/f')
-        self.assertTrue(tb.has('f'))
-        self.assertFalse(ta.has('f'))
-        self.assertTrue(t.has('b/f'))
-
     def test_delete_tree(self):
         t = self.get_transport()
 
@@ -951,14 +915,14 @@
         except TransportNotPossible:
             # ok, this transport does not support delete_tree
             return
-
+        
         # did it delete that trivial case?
         self.assertRaises(NoSuchFile, t.stat, 'adir')
 
         self.build_tree(['adir/',
-                         'adir/file',
-                         'adir/subdir/',
-                         'adir/subdir/file',
+                         'adir/file', 
+                         'adir/subdir/', 
+                         'adir/subdir/file', 
                          'adir/subdir2/',
                          'adir/subdir2/file',
                          ], transport=t)
@@ -995,7 +959,7 @@
         self.check_transport_contents('c this file\n', t, 'b')
 
         # TODO: Try to write a test for atomicity
-        # TODO: Test moving into a non-existent subdirectory
+        # TODO: Test moving into a non-existant subdirectory
         # TODO: Test Transport.move_multi
 
     def test_copy(self):
@@ -1022,7 +986,8 @@
     def test_connection_error(self):
         """ConnectionError is raised when connection is impossible.
         
-        The error should be raised from the first operation on the transport.
+        The error may be raised from either the constructor or the first
+        operation on the transport.
         """
         try:
             url = self._server.get_bogus_url()
@@ -1045,7 +1010,7 @@
             return
 
         paths = ['a', 'b/', 'b/c', 'b/d/', 'b/d/e']
-        sizes = [14, 0, 16, 0, 18]
+        sizes = [14, 0, 16, 0, 18] 
         self.build_tree(paths, transport=t, line_endings='binary')
 
         for path, size in zip(paths, sizes):
@@ -1073,17 +1038,17 @@
     def test_list_dir(self):
         # TODO: Test list_dir, just try once, and if it throws, stop testing
         t = self.get_transport()
-
+        
         if not t.listable():
             self.assertRaises(TransportNotPossible, t.list_dir, '.')
             return
 
-        def sorted_list(d, transport):
-            l = list(transport.list_dir(d))
+        def sorted_list(d):
+            l = list(t.list_dir(d))
             l.sort()
             return l
 
-        self.assertEqual([], sorted_list('.', t))
+        self.assertEqual([], sorted_list('.'))
         # c2 is precisely one letter longer than c here to test that
         # suffixing is not confused.
         # a%25b checks that quoting is done consistently across transports
@@ -1095,13 +1060,8 @@
             self.build_tree(tree_names)
 
         self.assertEqual(
-            ['a', 'a%2525b', 'b', 'c', 'c2'], sorted_list('', t))
-        self.assertEqual(
-            ['a', 'a%2525b', 'b', 'c', 'c2'], sorted_list('.', t))
-        self.assertEqual(['d', 'e'], sorted_list('c', t))
-
-        # Cloning the transport produces an equivalent listing
-        self.assertEqual(['d', 'e'], sorted_list('', t.clone('c')))
+            ['a', 'a%2525b', 'b', 'c', 'c2'], sorted_list('.'))
+        self.assertEqual(['d', 'e'], sorted_list('c'))
 
         if not t.is_readonly():
             t.delete('c/d')
@@ -1109,9 +1069,9 @@
         else:
             os.unlink('c/d')
             os.unlink('b')
-
-        self.assertEqual(['a', 'a%2525b', 'c', 'c2'], sorted_list('.', t))
-        self.assertEqual(['e'], sorted_list('c', t))
+            
+        self.assertEqual(['a', 'a%2525b', 'c', 'c2'], sorted_list('.'))
+        self.assertEqual(['e'], sorted_list('c'))
 
         self.assertListRaises(PathError, t.list_dir, 'q')
         self.assertListRaises(PathError, t.list_dir, 'c/f')
@@ -1126,7 +1086,7 @@
             self.build_tree(['a/', 'a/%'], transport=t)
         else:
             self.build_tree(['a/', 'a/%'])
-
+        
         names = list(t.list_dir('a'))
         self.assertEqual(['%25'], names)
         self.assertIsInstance(names[0], str)
@@ -1191,8 +1151,6 @@
         else:
             port = 1234
         self.assertIsNot(t, t._reuse_for(new_url(port=port)))
-        # No point in trying to reuse a transport for a local URL
-        self.assertIs(None, t._reuse_for('/valid_but_not_existing'))
 
     def test_connection_sharing(self):
         t = self.get_transport()
@@ -1303,7 +1261,7 @@
         self.assertEqual('', t.relpath(t.base))
         # base ends with /
         self.assertEqual('', t.relpath(t.base[:-1]))
-        # subdirs which don't exist should still give relpaths.
+        # subdirs which dont exist should still give relpaths.
         self.assertEqual('foo', t.relpath(t.base + 'foo'))
         # trailing slash should be the same.
         self.assertEqual('foo', t.relpath(t.base + 'foo/'))
@@ -1591,15 +1549,12 @@
                 adjust_for_latency=True, upper_limit=content_size))
             self.assertEqual(1, len(result))
             data_len = len(result[0][1])
-            # minimum length is from 400 to 1034 - 634
+            # minimmum length is from 400 to 1034 - 634
             self.assertTrue(data_len >= 634)
             # must contain the region 400 to 1034
             self.assertTrue(result[0][0] <= 400)
             self.assertTrue(result[0][0] + data_len >= 1034)
             check_result_data(result)
-
-    def test_readv_with_adjust_for_latency_with_big_file(self):
-        transport = self.get_transport()
         # test from observed failure case.
         if transport.is_readonly():
             file('a', 'w').write('a'*1024*1024)

=== removed file 'bzrlib/tests/test_transport_log.py'
--- bzrlib/tests/test_transport_log.py	2008-09-02 04:34:23 +0000
+++ bzrlib/tests/test_transport_log.py	1970-01-01 00:00:00 +0000
@@ -1,44 +0,0 @@
-# Copyright (C) 2004, 2005, 2006, 2007 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-
-"""Tests for log+ transport decorator."""
-
-
-from bzrlib.tests import TestCaseWithMemoryTransport
-from bzrlib.trace import mutter
-from bzrlib.transport import get_transport
-
-
-class TestTransportLog(TestCaseWithMemoryTransport):
-
-    def test_log_transport(self):
-        base_transport = self.get_transport('')
-        logging_transport = get_transport('log+' + base_transport.base)
-
-        # operations such as mkdir are logged
-        mutter('where are you?')
-        logging_transport.mkdir('subdir')
-        self.assertContainsRe(self._get_log(True),
-            r'mkdir memory\+\d+://.*subdir')
-        self.assertContainsRe(self._get_log(True),
-            '  --> None')
-        # they have the expected effect
-        self.assertTrue(logging_transport.has('subdir'))
-        # and they operate on the underlying transport 
-        self.assertTrue(base_transport.has('subdir'))
-
-

=== modified file 'bzrlib/tests/test_tree.py'
--- bzrlib/tests/test_tree.py	2008-08-01 17:48:30 +0000
+++ bzrlib/tests/test_tree.py	2007-07-31 19:42:15 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2008 Canonical Ltd
+# Copyright (C) 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -16,12 +16,7 @@
 
 """Tests for Tree and InterTree."""
 
-from bzrlib import (
-    errors,
-    revision,
-    tests,
-    tree as _mod_tree,
-    )
+from bzrlib import errors
 from bzrlib.tests import TestCaseWithTransport
 from bzrlib.tree import InterTree
 
@@ -143,277 +138,3 @@
             specific_files=['known_file', 'unknown_file'] ,
             require_versioned=False)
         self.assertEqual(len(delta.added), 1)
-
-
-class TestMultiWalker(TestCaseWithTransport):
-
-    def assertStepOne(self, has_more, path, file_id, iterator):
-        retval = _mod_tree.MultiWalker._step_one(iterator)
-        if not has_more:
-            self.assertIs(None, path)
-            self.assertIs(None, file_id)
-            self.assertEqual((False, None, None), retval)
-        else:
-            self.assertEqual((has_more, path, file_id),
-                             (retval[0], retval[1], retval[2].file_id))
-
-    def test__step_one_empty(self):
-        tree = self.make_branch_and_tree('empty')
-        repo = tree.branch.repository
-        empty_tree = repo.revision_tree(revision.NULL_REVISION)
-
-        iterator = empty_tree.iter_entries_by_dir()
-        self.assertStepOne(False, None, None, iterator)
-        self.assertStepOne(False, None, None, iterator)
-
-    def test__step_one(self):
-        tree = self.make_branch_and_tree('tree')
-        self.build_tree(['tree/a', 'tree/b/', 'tree/b/c'])
-        tree.add(['a', 'b', 'b/c'], ['a-id', 'b-id', 'c-id'])
-
-        iterator = tree.iter_entries_by_dir()
-        tree.lock_read()
-        self.addCleanup(tree.unlock)
-
-        root_id = tree.path2id('')
-        self.assertStepOne(True, '', root_id, iterator)
-        self.assertStepOne(True, 'a', 'a-id', iterator)
-        self.assertStepOne(True, 'b', 'b-id', iterator)
-        self.assertStepOne(True, 'b/c', 'c-id', iterator)
-        self.assertStepOne(False, None, None, iterator)
-        self.assertStepOne(False, None, None, iterator)
-
-    def assertWalkerNext(self, exp_path, exp_file_id, master_has_node,
-                         exp_other_paths, iterator):
-        """Check what happens when we step the iterator.
-
-        :param path: The path for this entry
-        :param file_id: The file_id for this entry
-        :param master_has_node: Does the master tree have this entry?
-        :param exp_other_paths: A list of other_path values.
-        :param iterator: The iterator to step
-        """
-        path, file_id, master_ie, other_values = iterator.next()
-        self.assertEqual((exp_path, exp_file_id), (path, file_id),
-                         'Master entry did not match')
-        if master_has_node:
-            self.assertIsNot(None, master_ie, 'master should have an entry')
-        else:
-            self.assertIs(None, master_ie, 'master should not have an entry')
-        self.assertEqual(len(exp_other_paths), len(other_values),
-                            'Wrong number of other entries')
-        other_paths = []
-        other_file_ids = []
-        for path, ie in other_values:
-            other_paths.append(path)
-            if ie is None:
-                other_file_ids.append(None)
-            else:
-                other_file_ids.append(ie.file_id)
-        
-        exp_file_ids = []
-        for path in exp_other_paths:
-            if path is None:
-                exp_file_ids.append(None)
-            else:
-                exp_file_ids.append(file_id)
-        self.assertEqual(exp_other_paths, other_paths, "Other paths incorrect")
-        self.assertEqual(exp_file_ids, other_file_ids,
-                         "Other file_ids incorrect")
-
-    def lock_and_get_basis_and_root_id(self, tree):
-        tree.lock_read()
-        self.addCleanup(tree.unlock)
-        basis_tree = tree.basis_tree()
-        basis_tree.lock_read()
-        self.addCleanup(basis_tree.unlock)
-        root_id = tree.path2id('')
-        return basis_tree, root_id
-
-    def test_simple_stepping(self):
-        tree = self.make_branch_and_tree('tree')
-        self.build_tree(['tree/a', 'tree/b/', 'tree/b/c'])
-        tree.add(['a', 'b', 'b/c'], ['a-id', 'b-id', 'c-id'])
-
-        tree.commit('first', rev_id='first-rev-id')
-
-        basis_tree, root_id = self.lock_and_get_basis_and_root_id(tree)
-
-        walker = _mod_tree.MultiWalker(tree, [basis_tree])
-        iterator = walker.iter_all()
-        self.assertWalkerNext(u'', root_id, True, [u''], iterator)
-        self.assertWalkerNext(u'a', 'a-id', True, [u'a'], iterator)
-        self.assertWalkerNext(u'b', 'b-id', True, [u'b'], iterator)
-        self.assertWalkerNext(u'b/c', 'c-id', True, [u'b/c'], iterator)
-        self.assertRaises(StopIteration, iterator.next)
-
-    def test_master_has_extra(self):
-        tree = self.make_branch_and_tree('tree')
-        self.build_tree(['tree/a', 'tree/b/', 'tree/c', 'tree/d'])
-        tree.add(['a', 'b', 'd'], ['a-id', 'b-id', 'd-id'])
-
-        tree.commit('first', rev_id='first-rev-id')
-
-        tree.add(['c'], ['c-id'])
-        basis_tree, root_id = self.lock_and_get_basis_and_root_id(tree)
-
-        walker = _mod_tree.MultiWalker(tree, [basis_tree])
-        iterator = walker.iter_all()
-        self.assertWalkerNext(u'', root_id, True, [u''], iterator)
-        self.assertWalkerNext(u'a', 'a-id', True, [u'a'], iterator)
-        self.assertWalkerNext(u'b', 'b-id', True, [u'b'], iterator)
-        self.assertWalkerNext(u'c', 'c-id', True, [None], iterator)
-        self.assertWalkerNext(u'd', 'd-id', True, [u'd'], iterator)
-        self.assertRaises(StopIteration, iterator.next)
-
-    def test_master_renamed_to_earlier(self):
-        """The record is still present, it just shows up early."""
-        tree = self.make_branch_and_tree('tree')
-        self.build_tree(['tree/a', 'tree/c', 'tree/d'])
-        tree.add(['a', 'c', 'd'], ['a-id', 'c-id', 'd-id'])
-        tree.commit('first', rev_id='first-rev-id')
-        tree.rename_one('d', 'b')
-
-        basis_tree, root_id = self.lock_and_get_basis_and_root_id(tree)
-
-        walker = _mod_tree.MultiWalker(tree, [basis_tree])
-        iterator = walker.iter_all()
-        self.assertWalkerNext(u'', root_id, True, [u''], iterator)
-        self.assertWalkerNext(u'a', 'a-id', True, [u'a'], iterator)
-        self.assertWalkerNext(u'b', 'd-id', True, [u'd'], iterator)
-        self.assertWalkerNext(u'c', 'c-id', True, [u'c'], iterator)
-        self.assertRaises(StopIteration, iterator.next)
-
-    def test_master_renamed_to_later(self):
-        tree = self.make_branch_and_tree('tree')
-        self.build_tree(['tree/a', 'tree/b', 'tree/d'])
-        tree.add(['a', 'b', 'd'], ['a-id', 'b-id', 'd-id'])
-        tree.commit('first', rev_id='first-rev-id')
-        tree.rename_one('b', 'e')
-
-        basis_tree, root_id = self.lock_and_get_basis_and_root_id(tree)
-
-        walker = _mod_tree.MultiWalker(tree, [basis_tree])
-        iterator = walker.iter_all()
-        self.assertWalkerNext(u'', root_id, True, [u''], iterator)
-        self.assertWalkerNext(u'a', 'a-id', True, [u'a'], iterator)
-        self.assertWalkerNext(u'd', 'd-id', True, [u'd'], iterator)
-        self.assertWalkerNext(u'e', 'b-id', True, [u'b'], iterator)
-        self.assertRaises(StopIteration, iterator.next)
-
-    def test_other_extra_in_middle(self):
-        tree = self.make_branch_and_tree('tree')
-        self.build_tree(['tree/a', 'tree/b', 'tree/d'])
-        tree.add(['a', 'b', 'd'], ['a-id', 'b-id', 'd-id'])
-        tree.commit('first', rev_id='first-rev-id')
-        tree.remove(['b'])
-
-        basis_tree, root_id = self.lock_and_get_basis_and_root_id(tree)
-        walker = _mod_tree.MultiWalker(tree, [basis_tree])
-        iterator = walker.iter_all()
-        self.assertWalkerNext(u'', root_id, True, [u''], iterator)
-        self.assertWalkerNext(u'a', 'a-id', True, [u'a'], iterator)
-        self.assertWalkerNext(u'd', 'd-id', True, [u'd'], iterator)
-        self.assertWalkerNext(u'b', 'b-id', False, [u'b'], iterator)
-        self.assertRaises(StopIteration, iterator.next)
-
-    def test_other_extra_at_end(self):
-        tree = self.make_branch_and_tree('tree')
-        self.build_tree(['tree/a', 'tree/b', 'tree/d'])
-        tree.add(['a', 'b', 'd'], ['a-id', 'b-id', 'd-id'])
-        tree.commit('first', rev_id='first-rev-id')
-        tree.remove(['d'])
-
-        basis_tree, root_id = self.lock_and_get_basis_and_root_id(tree)
-        walker = _mod_tree.MultiWalker(tree, [basis_tree])
-        iterator = walker.iter_all()
-        self.assertWalkerNext(u'', root_id, True, [u''], iterator)
-        self.assertWalkerNext(u'a', 'a-id', True, [u'a'], iterator)
-        self.assertWalkerNext(u'b', 'b-id', True, [u'b'], iterator)
-        self.assertWalkerNext(u'd', 'd-id', False, [u'd'], iterator)
-        self.assertRaises(StopIteration, iterator.next)
-
-    def test_others_extra_at_end(self):
-        tree = self.make_branch_and_tree('tree')
-        self.build_tree(['tree/a', 'tree/b', 'tree/c', 'tree/d', 'tree/e'])
-        tree.add(['a', 'b', 'c', 'd', 'e'],
-                 ['a-id', 'b-id', 'c-id', 'd-id', 'e-id'])
-        tree.commit('first', rev_id='first-rev-id')
-        tree.remove(['e'])
-        tree.commit('second', rev_id='second-rev-id')
-        tree.remove(['d'])
-        tree.commit('third', rev_id='third-rev-id')
-        tree.remove(['c'])
-
-        basis_tree, root_id = self.lock_and_get_basis_and_root_id(tree)
-        first_tree = tree.branch.repository.revision_tree('first-rev-id')
-        second_tree = tree.branch.repository.revision_tree('second-rev-id')
-        walker = _mod_tree.MultiWalker(tree, [basis_tree, first_tree,
-                                              second_tree])
-        iterator = walker.iter_all()
-        self.assertWalkerNext(u'', root_id, True, [u'', u'', u''], iterator)
-        self.assertWalkerNext(u'a', 'a-id', True, [u'a', u'a', u'a'], iterator)
-        self.assertWalkerNext(u'b', 'b-id', True, [u'b', u'b', u'b'], iterator)
-        self.assertWalkerNext(u'c', 'c-id', False, [u'c', u'c', u'c'], iterator)
-        self.assertWalkerNext(u'd', 'd-id', False, [None, u'd', u'd'], iterator)
-        self.assertWalkerNext(u'e', 'e-id', False, [None, u'e', None], iterator)
-        self.assertRaises(StopIteration, iterator.next)
-
-    def test_different_file_id_in_others(self):
-        tree = self.make_branch_and_tree('tree')
-        self.build_tree(['tree/a', 'tree/b', 'tree/c/'])
-        tree.add(['a', 'b', 'c'], ['a-id', 'b-id', 'c-id'])
-        tree.commit('first', rev_id='first-rev-id')
-
-        tree.rename_one('b', 'c/d')
-        self.build_tree(['tree/b'])
-        tree.add(['b'], ['b2-id'])
-        tree.commit('second', rev_id='second-rev-id')
-
-        tree.rename_one('a', 'c/e')
-        self.build_tree(['tree/a'])
-        tree.add(['a'], ['a2-id'])
-
-        basis_tree, root_id = self.lock_and_get_basis_and_root_id(tree)
-        first_tree = tree.branch.repository.revision_tree('first-rev-id')
-        walker = _mod_tree.MultiWalker(tree, [basis_tree, first_tree])
-
-        iterator = walker.iter_all()
-        self.assertWalkerNext(u'', root_id, True, [u'', u''], iterator)
-        self.assertWalkerNext(u'a', 'a2-id', True, [None, None], iterator)
-        self.assertWalkerNext(u'b', 'b2-id', True, [u'b', None], iterator)
-        self.assertWalkerNext(u'c', 'c-id', True, [u'c', u'c'], iterator)
-        self.assertWalkerNext(u'c/d', 'b-id', True, [u'c/d', u'b'], iterator)
-        self.assertWalkerNext(u'c/e', 'a-id', True, [u'a', u'a'], iterator)
-        self.assertRaises(StopIteration, iterator.next)
-
-    def assertCmpByDirblock(self, cmp_val, path1, path2):
-        self.assertEqual(cmp_val,
-            _mod_tree.MultiWalker._cmp_path_by_dirblock(path1, path2))
-
-    def test__cmp_path_by_dirblock(self):
-        # We only support Unicode strings at this point
-        self.assertRaises(TypeError,
-            _mod_tree.MultiWalker._cmp_path_by_dirblock, '', 'b')
-        self.assertCmpByDirblock(0, u'', u'')
-        self.assertCmpByDirblock(0, u'a', u'a')
-        self.assertCmpByDirblock(0, u'a/b', u'a/b')
-        self.assertCmpByDirblock(0, u'a/b/c', u'a/b/c')
-        self.assertCmpByDirblock(1, u'a-a', u'a')
-        self.assertCmpByDirblock(-1, u'a-a', u'a/a')
-        self.assertCmpByDirblock(-1, u'a=a', u'a/a')
-        self.assertCmpByDirblock(1, u'a-a/a', u'a/a')
-        self.assertCmpByDirblock(1, u'a=a/a', u'a/a')
-        self.assertCmpByDirblock(1, u'a-a/a', u'a/a/a')
-        self.assertCmpByDirblock(1, u'a=a/a', u'a/a/a')
-        self.assertCmpByDirblock(1, u'a-a/a/a', u'a/a/a')
-        self.assertCmpByDirblock(1, u'a=a/a/a', u'a/a/a')
-
-    def assertPathToKey(self, expected, path):
-        self.assertEqual(expected, _mod_tree.MultiWalker._path_to_key(path))
-
-    def test__path_to_key(self):
-        self.assertPathToKey(([u''], u''), u'')
-        self.assertPathToKey(([u''], u'a'), u'a')
-        self.assertPathToKey(([u'a'], u'b'), u'a/b')
-        self.assertPathToKey(([u'a', u'b'], u'c'), u'a/b/c')

=== modified file 'bzrlib/tests/test_tsort.py'
--- bzrlib/tests/test_tsort.py	2008-08-07 22:26:48 +0000
+++ bzrlib/tests/test_tsort.py	2007-06-21 01:58:29 +0000
@@ -21,7 +21,6 @@
 from bzrlib.tests import TestCase
 from bzrlib.tsort import topo_sort, TopoSorter, MergeSorter, merge_sort
 from bzrlib.errors import GraphCycleError
-from bzrlib.revision import NULL_REVISION
 
 
 class TopoSortTests(TestCase):
@@ -98,13 +97,6 @@
     def assertSortAndIterate(self, graph, branch_tip, result_list,
             generate_revno, mainline_revisions=None):
         """Check that merge based sorting and iter_topo_order on graph works."""
-        value = merge_sort(graph, branch_tip,
-                           mainline_revisions=mainline_revisions,
-                           generate_revno=generate_revno)
-        if result_list != value:
-            import pprint
-            self.assertEqualDiff(pprint.pformat(result_list),
-                                 pprint.pformat(value))
         self.assertEquals(result_list,
             merge_sort(graph, branch_tip, mainline_revisions=mainline_revisions,
                 generate_revno=generate_revno))
@@ -120,8 +112,6 @@
         # sorting of an emptygraph does not error
         self.assertSortAndIterate({}, None, [], False)
         self.assertSortAndIterate({}, None, [], True)
-        self.assertSortAndIterate({}, NULL_REVISION, [], False)
-        self.assertSortAndIterate({}, NULL_REVISION, [], True)
 
     def test_merge_sort_not_empty_no_tip(self):
         # merge sorting of a branch starting with None should result
@@ -191,55 +181,7 @@
              ],
             True
             )
-
-    def test_merge_sort_race(self):
-        # A
-        # |
-        # B-.
-        # |\ \
-        # | | C
-        # | |/
-        # | D
-        # |/
-        # F
-        graph = {'A': [],
-                 'B': ['A'],
-                 'C': ['B'],
-                 'D': ['B', 'C'],
-                 'F': ['B', 'D'],
-                 }
-        self.assertSortAndIterate(graph, 'F',
-            [(0, 'F', 0, (3,), False),
-             (1, 'D', 1, (2,2,1), False),
-             (2, 'C', 1, (2,1,1), True), # XXX: Shouldn't it be merge_depth=2?
-             (3, 'B', 0, (2,), False),
-             (4, 'A', 0, (1,), True),
-             ], True)
-        # A
-        # |
-        # B-.
-        # |\ \
-        # | X C
-        # | |/
-        # | D
-        # |/
-        # F
-        graph = {'A': [],
-                 'B': ['A'],
-                 'C': ['B'],
-                 'X': ['B'],
-                 'D': ['X', 'C'],
-                 'F': ['B', 'D'],
-                 }
-        self.assertSortAndIterate(graph, 'F',
-            [(0, 'F', 0, (3,), False),
-             (1, 'D', 1, (2,1,2), False),
-             (2, 'C', 2, (2,2,1), True),
-             (3, 'X', 1, (2,1,1), True),
-             (4, 'B', 0, (2,), False),
-             (5, 'A', 0, (1,), True),
-             ], True)
-
+        
     def test_merge_depth_with_nested_merges(self):
         # the merge depth marker should reflect the depth of the revision
         # in terms of merges out from the mainline
@@ -286,96 +228,17 @@
              }.items(),
             'A',
             [(0, 'A', 0, (3,),  False),
-             (1, 'B', 1, (1,3,2), False),
-             (2, 'C', 1, (1,3,1), True),
+             (1, 'B', 1, (1,2,2), False),
+             (2, 'C', 1, (1,2,1), True),
              (3, 'D', 0, (2,), False),
              (4, 'E', 1, (1,1,2), False),
-             (5, 'F', 2, (1,2,1), True),
+             (5, 'F', 2, (1,1,1,1,1), True),
              (6, 'G', 1, (1,1,1), True),
              (7, 'H', 0, (1,), True),
              ],
             True
             )
-
-    def test_dotted_revnos_with_simple_merges(self):
-        # A         1
-        # |\
-        # B C       2, 1.1.1
-        # | |\
-        # D E F     3, 1.1.2, 1.2.1
-        # |/ /|
-        # G H I     4, 1.2.2, 1.3.1
-        # |/ /
-        # J K       5, 1.3.2
-        # |/
-        # L         6
-        self.assertSortAndIterate(
-            {'A': [],
-             'B': ['A'],
-             'C': ['A'],
-             'D': ['B'],
-             'E': ['C'],
-             'F': ['C'],
-             'G': ['D', 'E'],
-             'H': ['F'],
-             'I': ['F'],
-             'J': ['G', 'H'],
-             'K': ['I'],
-             'L': ['J', 'K'],
-            }.items(),
-            'L',
-            [(0, 'L', 0, (6,), False),
-             (1, 'K', 1, (1,3,2), False),
-             (2, 'I', 1, (1,3,1), True),
-             (3, 'J', 0, (5,), False),
-             (4, 'H', 1, (1,2,2), False),
-             (5, 'F', 1, (1,2,1), True),
-             (6, 'G', 0, (4,), False),
-             (7, 'E', 1, (1,1,2), False),
-             (8, 'C', 1, (1,1,1), True),
-             (9, 'D', 0, (3,), False),
-             (10, 'B', 0, (2,), False),
-             (11, 'A', 0, (1,),  True),
-             ],
-            True
-            )
-        # Adding a shortcut from the first revision should not change any of
-        # the existing numbers
-        self.assertSortAndIterate(
-            {'A': [],
-             'B': ['A'],
-             'C': ['A'],
-             'D': ['B'],
-             'E': ['C'],
-             'F': ['C'],
-             'G': ['D', 'E'],
-             'H': ['F'],
-             'I': ['F'],
-             'J': ['G', 'H'],
-             'K': ['I'],
-             'L': ['J', 'K'],
-             'M': ['A'],
-             'N': ['L', 'M'],
-            }.items(),
-            'N',
-            [(0, 'N', 0, (7,), False),
-             (1, 'M', 1, (1,4,1), True),
-             (2, 'L', 0, (6,), False),
-             (3, 'K', 1, (1,3,2), False),
-             (4, 'I', 1, (1,3,1), True),
-             (5, 'J', 0, (5,), False),
-             (6, 'H', 1, (1,2,2), False),
-             (7, 'F', 1, (1,2,1), True),
-             (8, 'G', 0, (4,), False),
-             (9, 'E', 1, (1,1,2), False),
-             (10, 'C', 1, (1,1,1), True),
-             (11, 'D', 0, (3,), False),
-             (12, 'B', 0, (2,), False),
-             (13, 'A', 0, (1,),  True),
-             ],
-            True
-            )
-
+ 
     def test_end_of_merge_not_last_revision_in_branch(self):
         # within a branch only the last revision gets an
         # end of merge marker.
@@ -448,11 +311,11 @@
              },
             'A',
             [(0, 'A', 0, (2,), False),
-             (1, 'B', 1, (1,3,2), False),
-             (2, 'C', 2, (1,4,1), True),
-             (3, 'D', 1, (1,3,1), True),
+             (1, 'B', 1, (1,2,2), False),
+             (2, 'C', 2, (1,2,1,1,1), True),
+             (3, 'D', 1, (1,2,1), True),
              (4, 'E', 1, (1,1,2), False),
-             (5, 'F', 2, (1,2,1), True),
+             (5, 'F', 2, (1,1,1,1,1), True),
              (6, 'G', 1, (1,1,1), True),
              (7, 'H', 0, (1,), True),
              ],
@@ -540,19 +403,6 @@
             mainline_revisions=[None, 'A']
             )
 
-    def test_mainline_revs_with_ghost(self):
-        # We have a mainline, but the end of it is actually a ghost
-        # The graph that is passed to tsort has had ghosts filtered out, but
-        # the mainline history has not.
-        self.assertSortAndIterate(
-            {'B':[],
-             'C':['B']}.items(),
-            'C',
-            [(0, 'C', 0, (2,), False),
-             (1, 'B', 0, (1,), True),
-             ],
-             True, mainline_revisions=['A', 'B', 'C'])
-
     def test_parallel_root_sequence_numbers_increase_with_merges(self):
         """When there are parallel roots, check their revnos."""
         self.assertSortAndIterate(
@@ -612,62 +462,3 @@
              ],
             True
             )
-
-    def test_roots_and_sub_branches_versus_ghosts(self):
-        """Extra roots and their mini branches use the same numbering.
-
-        All of them use the 0-node numbering.
-        """
-        #       A D   K
-        #       | |\  |\
-        #       B E F L M
-        #       | |/  |/
-        #       C G   N
-        #       |/    |\
-        #       H I   O P
-        #       |/    |/
-        #       J     Q
-        #       |.---'
-        #       R
-        self.assertSortAndIterate(
-            {'A': [],
-             'B': ['A'],
-             'C': ['B'],
-             'D': [],
-             'E': ['D'],
-             'F': ['D'],
-             'G': ['E', 'F'],
-             'H': ['C', 'G'],
-             'I': [],
-             'J': ['H', 'I'],
-             'K': [],
-             'L': ['K'],
-             'M': ['K'],
-             'N': ['L', 'M'],
-             'O': ['N'],
-             'P': ['N'],
-             'Q': ['O', 'P'],
-             'R': ['J', 'Q'],
-            }.items(),
-            'R',
-            [( 0, 'R', 0, (6,), False),
-             ( 1, 'Q', 1, (0,4,5), False),
-             ( 2, 'P', 2, (0,6,1), True),
-             ( 3, 'O', 1, (0,4,4), False),
-             ( 4, 'N', 1, (0,4,3), False),
-             ( 5, 'M', 2, (0,5,1), True),
-             ( 6, 'L', 1, (0,4,2), False),
-             ( 7, 'K', 1, (0,4,1), True),
-             ( 8, 'J', 0, (5,), False),
-             ( 9, 'I', 1, (0,3,1), True),
-             (10, 'H', 0, (4,), False),
-             (11, 'G', 1, (0,1,3), False),
-             (12, 'F', 2, (0,2,1), True),
-             (13, 'E', 1, (0,1,2), False),
-             (14, 'D', 1, (0,1,1), True),
-             (15, 'C', 0, (3,), False),
-             (16, 'B', 0, (2,), False),
-             (17, 'A', 0, (1,), True),
-             ],
-            True
-            )

=== removed file 'bzrlib/tests/test_uncommit.py'
--- bzrlib/tests/test_uncommit.py	2008-03-20 15:10:05 +0000
+++ bzrlib/tests/test_uncommit.py	1970-01-01 00:00:00 +0000
@@ -1,98 +0,0 @@
-# Copyright (C) 2008 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Test uncommit."""
-
-
-from bzrlib import (
-    errors,
-    tests,
-    uncommit,
-    )
-
-
-class TestUncommit(tests.TestCaseWithTransport):
-
-    def make_linear_tree(self):
-        tree = self.make_branch_and_tree('tree')
-        tree.lock_write()
-        try:
-            self.build_tree(['tree/one'])
-            tree.add('one')
-            rev_id1 = tree.commit('one')
-            self.build_tree(['tree/two'])
-            tree.add('two')
-            rev_id2 = tree.commit('two')
-        finally:
-            tree.unlock()
-        return tree, [rev_id1, rev_id2]
-
-    def test_uncommit(self):
-        tree, history = self.make_linear_tree()
-        self.assertEqual(history[1], tree.last_revision())
-        self.assertEqual((2, history[1]), tree.branch.last_revision_info())
-        uncommit.uncommit(tree.branch, tree=tree)
-        self.assertEqual(history[0], tree.last_revision())
-        self.assertEqual((1, history[0]), tree.branch.last_revision_info())
-
-        # The file should not be removed
-        self.failUnlessExists('tree/two')
-        # And it should still be listed as added
-        self.assertIsNot(None, tree.path2id('two'))
-
-    def test_uncommit_bound(self):
-        tree, history = self.make_linear_tree()
-        child = tree.bzrdir.sprout('child').open_workingtree()
-        child.branch.bind(tree.branch)
-
-        self.assertEqual(history[1], tree.last_revision())
-        self.assertEqual((2, history[1]), tree.branch.last_revision_info())
-        self.assertEqual(history[1], child.last_revision())
-        self.assertEqual((2, history[1]), child.branch.last_revision_info())
-
-        # Uncommit in a bound branch should uncommit the master branch, but not
-        # touch the other working tree.
-        uncommit.uncommit(child.branch, tree=child)
-
-        self.assertEqual(history[1], tree.last_revision())
-        self.assertEqual((1, history[0]), tree.branch.last_revision_info())
-        self.assertEqual(history[0], child.last_revision())
-        self.assertEqual((1, history[0]), child.branch.last_revision_info())
-
-    def test_uncommit_bound_local(self):
-        tree, history = self.make_linear_tree()
-        child = tree.bzrdir.sprout('child').open_workingtree()
-        child.branch.bind(tree.branch)
-
-        self.assertEqual(history[1], tree.last_revision())
-        self.assertEqual((2, history[1]), tree.branch.last_revision_info())
-        self.assertEqual(history[1], child.last_revision())
-        self.assertEqual((2, history[1]), child.branch.last_revision_info())
-
-        # Uncommit local=True should only affect the local branch
-        uncommit.uncommit(child.branch, tree=child, local=True)
-
-        self.assertEqual(history[1], tree.last_revision())
-        self.assertEqual((2, history[1]), tree.branch.last_revision_info())
-        self.assertEqual(history[0], child.last_revision())
-        self.assertEqual((1, history[0]), child.branch.last_revision_info())
-
-    def test_uncommit_unbound_local(self):
-        tree, history = self.make_linear_tree()
-
-        # If this tree isn't bound, local=True raises an exception
-        self.assertRaises(errors.LocalRequiresBoundBranch,
-            uncommit.uncommit, tree.branch, tree=tree, local=True)

=== modified file 'bzrlib/tests/test_upgrade.py'
--- bzrlib/tests/test_upgrade.py	2008-06-11 04:20:16 +0000
+++ bzrlib/tests/test_upgrade.py	2007-08-06 22:26:54 +0000
@@ -67,39 +67,31 @@
             'mbp@sourcefrog.net-20051004035756-235f2b7dcdddd8dd'])
         rt = b.repository.revision_tree(rh[0])
         foo_id = 'foo-20051004035605-91e788d1875603ae'
-        rt.lock_read()
-        try:
-            eq(rt.get_file_text(foo_id), 'initial contents\n')
-        finally:
-            rt.unlock()
+        eq(rt.get_file_text(foo_id), 'initial contents\n')
         rt = b.repository.revision_tree(rh[1])
-        rt.lock_read()
-        try:
-            eq(rt.get_file_text(foo_id), 'new contents\n')
-        finally:
-            rt.unlock()
+        eq(rt.get_file_text(foo_id), 'new contents\n')
         # check a backup was made:
         transport = get_transport(b.base)
-        transport.stat('backup.bzr')
-        transport.stat('backup.bzr/README')
-        transport.stat('backup.bzr/branch-format')
-        transport.stat('backup.bzr/revision-history')
-        transport.stat('backup.bzr/merged-patches')
-        transport.stat('backup.bzr/pending-merged-patches')
-        transport.stat('backup.bzr/pending-merges')
-        transport.stat('backup.bzr/branch-name')
-        transport.stat('backup.bzr/branch-lock')
-        transport.stat('backup.bzr/inventory')
-        transport.stat('backup.bzr/stat-cache')
-        transport.stat('backup.bzr/text-store')
-        transport.stat('backup.bzr/text-store/foo-20051004035611-1591048e9dc7c2d4.gz')
-        transport.stat('backup.bzr/text-store/foo-20051004035756-4081373d897c3453.gz')
-        transport.stat('backup.bzr/inventory-store/')
-        transport.stat('backup.bzr/inventory-store/mbp@sourcefrog.net-20051004035611-176b16534b086b3c.gz')
-        transport.stat('backup.bzr/inventory-store/mbp@sourcefrog.net-20051004035756-235f2b7dcdddd8dd.gz')
-        transport.stat('backup.bzr/revision-store/')
-        transport.stat('backup.bzr/revision-store/mbp@sourcefrog.net-20051004035611-176b16534b086b3c.gz')
-        transport.stat('backup.bzr/revision-store/mbp@sourcefrog.net-20051004035756-235f2b7dcdddd8dd.gz')
+        transport.stat('.bzr.backup')
+        transport.stat('.bzr.backup/README')
+        transport.stat('.bzr.backup/branch-format')
+        transport.stat('.bzr.backup/revision-history')
+        transport.stat('.bzr.backup/merged-patches')
+        transport.stat('.bzr.backup/pending-merged-patches')
+        transport.stat('.bzr.backup/pending-merges')
+        transport.stat('.bzr.backup/branch-name')
+        transport.stat('.bzr.backup/branch-lock')
+        transport.stat('.bzr.backup/inventory')
+        transport.stat('.bzr.backup/stat-cache')
+        transport.stat('.bzr.backup/text-store')
+        transport.stat('.bzr.backup/text-store/foo-20051004035611-1591048e9dc7c2d4.gz')
+        transport.stat('.bzr.backup/text-store/foo-20051004035756-4081373d897c3453.gz')
+        transport.stat('.bzr.backup/inventory-store/')
+        transport.stat('.bzr.backup/inventory-store/mbp@sourcefrog.net-20051004035611-176b16534b086b3c.gz')
+        transport.stat('.bzr.backup/inventory-store/mbp@sourcefrog.net-20051004035756-235f2b7dcdddd8dd.gz')
+        transport.stat('.bzr.backup/revision-store/')
+        transport.stat('.bzr.backup/revision-store/mbp@sourcefrog.net-20051004035611-176b16534b086b3c.gz')
+        transport.stat('.bzr.backup/revision-store/mbp@sourcefrog.net-20051004035756-235f2b7dcdddd8dd.gz')
 
     def test_upgrade_with_ghosts(self):
         """Upgrade v0.0.4 tree containing ghost references.
@@ -133,12 +125,11 @@
         self.assertNotEqual(old_repo_format.__class__, repo._format.__class__)
         # and we should be able to read the names for the file id 
         # 'dir-20051005095101-da1441ea3fa6917a'
-        repo.lock_read()
-        self.addCleanup(repo.unlock)
-        text_keys = repo.texts.keys()
-        dir_keys = [key for key in text_keys if key[0] ==
-                'dir-20051005095101-da1441ea3fa6917a']
-        self.assertNotEqual([], dir_keys)
+        self.assertNotEqual(
+            [],
+            repo.weave_store.get_weave(
+                'dir-20051005095101-da1441ea3fa6917a',
+                repo.get_transaction()))
 
     def test_upgrade_to_meta_sets_workingtree_last_revision(self):
         self.build_tree_contents(_upgrade_dir_template)
@@ -154,10 +145,10 @@
         upgrade('.', bzrdir.BzrDirFormat6())
         transport = get_transport('.')
         transport.delete_multi(['.bzr/pending-merges', '.bzr/inventory'])
-        self.assertFalse(transport.has('.bzr/stat-cache'))
-        # XXX: upgrade fails if a backup.bzr is already present
+        assert not transport.has('.bzr/stat-cache')
+        # XXX: upgrade fails if a .bzr.backup is already present
         # -- David Allouche 2006-08-11
-        transport.delete_tree('backup.bzr')
+        transport.delete_tree('.bzr.backup')
         # At this point, we have a format6 branch without checkout files.
         upgrade('.', bzrdir.BzrDirMetaFormat1())
         # The upgrade should not have set up a working tree.
@@ -257,9 +248,7 @@
      ('foo', 'new contents\n'),
      ('.bzr/',),
      ('.bzr/README',
-      'This is a Bazaar control directory.\n'
-      'Do not change any files in this directory.\n'
-      'See http://bazaar-vcs.org/ for more information about Bazaar.\n'),
+      'This is a Bazaar-NG control directory.\nDo not change any files in this directory.\n'),
      ('.bzr/branch-format', 'Bazaar-NG branch, format 0.0.4\n'),
      ('.bzr/revision-history',
       'mbp@sourcefrog.net-20051004035611-176b16534b086b3c\n'
@@ -299,9 +288,8 @@
     ),
     ( './.bzr/', ),
     ( './.bzr/README',
-      'This is a Bazaar control directory.\n'
-      'Do not change any files in this directory.\n'
-      'See http://bazaar-vcs.org/ for more information about Bazaar.\n'
+        'This is a Bazaar-NG control directory.\n'
+        'Do not change any files in this directory.\n'
     ),
     ( './.bzr/branch-format',
         'Bazaar-NG branch, format 0.0.4\n'
@@ -365,9 +353,8 @@
 _upgrade_dir_template = [
     ( './.bzr/', ),
     ( './.bzr/README',
-      'This is a Bazaar control directory.\n'
-      'Do not change any files in this directory.\n'
-      'See http://bazaar-vcs.org/ for more information about Bazaar.\n'
+        'This is a Bazaar-NG control directory.\n'
+        'Do not change any files in this directory.\n'
     ),
     ( './.bzr/branch-format',
         'Bazaar-NG branch, format 0.0.4\n'

=== removed file 'bzrlib/tests/test_upgrade_stacked.py'
--- bzrlib/tests/test_upgrade_stacked.py	2008-08-29 05:18:56 +0000
+++ bzrlib/tests/test_upgrade_stacked.py	1970-01-01 00:00:00 +0000
@@ -1,90 +0,0 @@
-# Copyright (C) 2008 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-
-"""Tests for upgrades of various stacking situations."""
-
-from bzrlib import (
-    bzrdir,
-    errors,
-    tests,
-    )
-from bzrlib.upgrade import upgrade
-
-
-class TestStackUpgrade(tests.TestCaseWithTransport):
-    # TODO: This should possibly be repeated for all stacking repositories,
-    # pairwise by rich/non-rich format; should possibly also try other kinds
-    # of upgrades like knit->pack. -- mbp 20080804
-
-    def test_stack_upgrade(self):
-        """Correct checks when stacked-on repository is upgraded.
-        
-        We initially stack on a repo with the same rich root support, 
-        we then upgrade it and should fail, we then upgrade the overlaid 
-        repository.
-        """
-        base = self.make_branch_and_tree('base',
-            format=self.scenario_old_format)
-        self.build_tree(['base/foo'])
-        base.commit('base commit')
-        # make another one stacked
-        stacked = base.bzrdir.sprout('stacked', stacked=True)
-        # this must really be stacked (or get_stacked_on_url raises an error)
-        self.assertTrue(stacked.open_branch().get_stacked_on_url())
-        # now we'll upgrade the underlying branch, then upgrade the stacked
-        # branch, and this should still work.
-        new_format = bzrdir.format_registry.make_bzrdir(
-            self.scenario_new_format)
-        upgrade('base', new_format)
-        # in some cases you'll get an error if the underlying model has
-        # changed; if just the data format has changed this should still work
-        if self.scenario_model_change:
-            self.assertRaises(errors.IncompatibleRepositories,
-                stacked.open_branch)
-        else:
-            stacked.open_branch().check()
-        stacked = bzrdir.BzrDir.open('stacked')
-        # but we can upgrade the stacked repository
-        upgrade('stacked', new_format)
-        # and now it's ok
-        stacked = bzrdir.BzrDir.open('stacked')
-        stacked.open_branch().check()
-
-
-def load_tests(basic_tests, module, test_loader):
-    """Generate dynamic scenario tests.
-
-    Called by the bzrlib test framework.
-    """
-    scenario_pairs = [ # old format, new format, model_change
-#        ('knit', 'rich-root', True),
-        ('knit', '1.6', False),
-#        ('pack-0.92', '1.6', False),
-        ('1.6', '1.6.1-rich-root', True),
-        ]
-    scenarios = []
-    for (old_name, new_name, model_change) in scenario_pairs:
-        name = old_name + ', ' + new_name
-        scenarios.append((name,
-            dict(scenario_old_format=old_name,
-                scenario_new_format=new_name,
-                scenario_model_change=model_change)))
-    adapter = tests.TestScenarioApplier()
-    adapter.scenarios = scenarios
-    suite = tests.TestSuite()
-    tests.adapt_tests(basic_tests, adapter, suite)
-    return suite

=== modified file 'bzrlib/tests/test_urlutils.py'
--- bzrlib/tests/test_urlutils.py	2008-07-22 02:55:10 +0000
+++ bzrlib/tests/test_urlutils.py	2007-06-06 14:06:14 +0000
@@ -22,7 +22,7 @@
 
 from bzrlib import osutils, urlutils, win32utils
 import bzrlib
-from bzrlib.errors import InvalidURL, InvalidURLJoin, InvalidRebaseURLs
+from bzrlib.errors import InvalidURL, InvalidURLJoin
 from bzrlib.tests import TestCaseInTempDir, TestCase, TestSkipped
 
 
@@ -291,7 +291,6 @@
             raise TestSkipped("local encoding cannot handle unicode")
 
         self.assertEqual('file:///path/to/r%C3%A4ksm%C3%B6rg%C3%A5s', result)
-        self.assertFalse(isinstance(result, unicode))
 
     def test_posix_local_path_from_url(self):
         from_url = urlutils._posix_local_path_from_url
@@ -316,8 +315,6 @@
         #     to_url('C:/path/to/foo '))
         self.assertEqual('file:///C:/path/to/f%20oo',
             to_url('C:/path/to/f oo'))
-        
-        self.assertEqual('file:///', to_url('/'))
 
         try:
             result = to_url(u'd:/path/to/r\xe4ksm\xf6rg\xe5s')
@@ -325,7 +322,6 @@
             raise TestSkipped("local encoding cannot handle unicode")
 
         self.assertEqual('file:///D:/path/to/r%C3%A4ksm%C3%B6rg%C3%A5s', result)
-        self.assertFalse(isinstance(result, unicode))
 
     def test_win32_unc_path_to_url(self):
         to_url = urlutils._win32_local_path_to_url
@@ -340,7 +336,7 @@
             raise TestSkipped("local encoding cannot handle unicode")
 
         self.assertEqual('file://HOST/path/to/r%C3%A4ksm%C3%B6rg%C3%A5s', result)
-        self.assertFalse(isinstance(result, unicode))
+
 
     def test_win32_local_path_from_url(self):
         from_url = urlutils._win32_local_path_from_url
@@ -350,7 +346,6 @@
             from_url('file:///d|/path/to/r%C3%A4ksm%C3%B6rg%C3%A5s'))
         self.assertEqual(u'D:/path/to/r\xe4ksm\xf6rg\xe5s',
             from_url('file:///d:/path/to/r%c3%a4ksm%c3%b6rg%c3%a5s'))
-        self.assertEqual('/', from_url('file:///'))
 
         self.assertRaises(InvalidURL, from_url, '/path/to/foo')
         # Not a valid _win32 url, no drive letter
@@ -496,7 +491,6 @@
     def test_escape(self):
         self.assertEqual('%25', urlutils.escape('%'))
         self.assertEqual('%C3%A5', urlutils.escape(u'\xe5'))
-        self.assertFalse(isinstance(urlutils.escape(u'\xe5'), unicode))
 
     def test_unescape(self):
         self.assertEqual('%', urlutils.unescape('%25'))
@@ -547,29 +541,6 @@
         #test('.', 'http://host/', 'http://host')
         test('http://host', 'http://host/', 'http://host')
 
-        # On Windows file:///C:/path/to and file:///D:/other/path
-        # should not use relative url over the non-existent '/' directory.
-        if sys.platform == 'win32':
-            # on the same drive
-            test('../../other/path',
-                'file:///C:/path/to', 'file:///C:/other/path')
-            #~next two tests is failed, i.e. urlutils.relative_url expects
-            #~to see normalized file URLs?
-            #~test('../../other/path',
-            #~    'file:///C:/path/to', 'file:///c:/other/path')
-            #~test('../../other/path',
-            #~    'file:///C:/path/to', 'file:///C|/other/path')
-
-            # check UNC paths too
-            test('../../other/path',
-                'file://HOST/base/path/to', 'file://HOST/base/other/path')
-            # on different drives
-            test('file:///D:/other/path',
-                'file:///C:/path/to', 'file:///D:/other/path')
-            # TODO: strictly saying in UNC path //HOST/base is full analog
-            # of drive letter for hard disk, and this situation is also
-            # should be exception from rules. [bialix 20071221]
-
 
 class TestCwdToURL(TestCaseInTempDir):
     """Test that local_path_to_url works base on the cwd"""
@@ -617,56 +588,3 @@
         self.assertEqual("bar", derive("http://foo/bar"))
         self.assertEqual("bar", derive("bzr+ssh://foo/bar"))
         self.assertEqual("foo-bar", derive("lp:foo-bar"))
-
-
-class TestRebaseURL(TestCase):
-    """Test the behavior of rebase_url."""
-
-    def test_non_relative(self):
-        result = urlutils.rebase_url('file://foo', 'file://foo',
-                                     'file://foo/bar')
-        self.assertEqual('file://foo', result)
-        result = urlutils.rebase_url('/foo', 'file://foo',
-                                     'file://foo/bar')
-        self.assertEqual('/foo', result)
-
-    def test_different_ports(self):
-        e = self.assertRaises(InvalidRebaseURLs, urlutils.rebase_url,
-                              'foo', 'http://bar:80', 'http://bar:81')
-        self.assertEqual(str(e), "URLs differ by more than path:"
-                         " 'http://bar:80' and 'http://bar:81'")
-
-    def test_different_hosts(self):
-        e = self.assertRaises(InvalidRebaseURLs, urlutils.rebase_url,
-                              'foo', 'http://bar', 'http://baz')
-        self.assertEqual(str(e), "URLs differ by more than path: 'http://bar'"
-                         " and 'http://baz'")
-
-    def test_different_protocol(self):
-        e = self.assertRaises(InvalidRebaseURLs, urlutils.rebase_url,
-                              'foo', 'http://bar', 'ftp://bar')
-        self.assertEqual(str(e), "URLs differ by more than path: 'http://bar'"
-                         " and 'ftp://bar'")
-
-    def test_rebase_success(self):
-        self.assertEqual('../bar', urlutils.rebase_url('bar', 'http://baz/',
-                         'http://baz/qux'))
-        self.assertEqual('qux/bar', urlutils.rebase_url('bar',
-                         'http://baz/qux', 'http://baz/'))
-        self.assertEqual('.', urlutils.rebase_url('foo',
-                         'http://bar/', 'http://bar/foo/'))
-        self.assertEqual('qux/bar', urlutils.rebase_url('../bar',
-                         'http://baz/qux/foo', 'http://baz/'))
-
-    def test_determine_relative_path(self):
-        self.assertEqual('../../baz/bar',
-                         urlutils.determine_relative_path(
-                         '/qux/quxx', '/baz/bar'))
-        self.assertEqual('..',
-                         urlutils.determine_relative_path(
-                         '/bar/baz', '/bar'))
-        self.assertEqual('baz',
-                         urlutils.determine_relative_path(
-                         '/bar', '/bar/baz'))
-        self.assertEqual('.', urlutils.determine_relative_path(
-                         '/bar', '/bar'))

=== modified file 'bzrlib/tests/test_version_info.py'
--- bzrlib/tests/test_version_info.py	2008-05-02 07:31:24 +0000
+++ bzrlib/tests/test_version_info.py	2007-10-15 04:50:34 +0000
@@ -21,16 +21,9 @@
 import os
 import sys
 
-from bzrlib import (
-    errors,
-    symbol_versioning,
-    tests,
-    version_info_formats,
-    )
 from bzrlib.tests import TestCaseWithTransport
 from bzrlib.rio import read_stanzas
 
-from bzrlib.version_info_formats.format_custom import CustomVersionInfoBuilder
 from bzrlib.version_info_formats.format_rio import RioVersionInfoBuilder
 from bzrlib.version_info_formats.format_python import PythonVersionInfoBuilder
 
@@ -229,70 +222,4 @@
         self.assertEqual('unversioned', tvi.file_revisions['c'])
         self.assertEqual('removed', tvi.file_revisions['d'])
 
-    def test_custom_version_text(self):
-        wt = self.create_branch()
-
-        def regen(tpl, **kwargs):
-            sio = StringIO()
-            builder = CustomVersionInfoBuilder(wt.branch, working_tree=wt,
-                                               template=tpl, **kwargs)
-            builder.generate(sio)
-            val = sio.getvalue()
-            return val
-
-        val = regen('build-date: "{build_date}"\ndate: "{date}"')
-        self.assertContainsRe(val, 'build-date: "[0-9-+: ]+"')
-        self.assertContainsRe(val, 'date: "[0-9-+: ]+"')
-
-        val = regen('revno: {revno}')
-        self.assertEqual(val, 'revno: 3')
-
-        val = regen('revision-id: {revision_id}')
-        self.assertEqual(val, 'revision-id: r3')
-
-        val = regen('clean: {clean}', check_for_clean=True)
-        self.assertEqual(val, 'clean: 1')
-
-        self.build_tree(['branch/c'])
-        val = regen('clean: {clean}', check_for_clean=True)
-        self.assertEqual(val, 'clean: 0')
-        os.remove('branch/c')
-
-    def test_custom_without_template(self):
-        builder = CustomVersionInfoBuilder(None)
-        sio = StringIO()
-        self.assertRaises(errors.NoTemplate, builder.generate, sio)
-
-
-class TestBuilder(version_info_formats.VersionInfoBuilder):
-    pass
-
-
-class TestVersionInfoFormatRegistry(tests.TestCase):
-
-    def setUp(self):
-        super(TestVersionInfoFormatRegistry, self).setUp()
-        registry = version_info_formats.format_registry
-        self._default_key = registry._default_key
-        self._dict = registry._dict.copy()
-        self._help_dict = registry._help_dict.copy()
-        self._info_dict = registry._info_dict.copy()
-        self.addCleanup(self._cleanup)
-
-    def _cleanup(self):
-        # Restore the registry to pristine state after the test runs
-        registry = version_info_formats.format_registry
-        registry._default_key = self._default_key
-        registry._dict = self._dict
-        registry._help_dict = self._help_dict
-        registry._info_dict = self._info_dict
-
-    def test_register_remove(self):
-        registry = version_info_formats.format_registry
-        registry.register('testbuilder',
-            TestBuilder, 'a simple test builder')
-        self.assertIs(TestBuilder, registry.get('testbuilder'))
-        self.assertEqual('a simple test builder',
-                         registry.get_help('testbuilder'))
-        registry.remove('testbuilder')
-        self.assertRaises(KeyError, registry.get, 'testbuilder')
+

=== modified file 'bzrlib/tests/test_versionedfile.py'
--- bzrlib/tests/test_versionedfile.py	2008-07-17 09:13:16 +0000
+++ bzrlib/tests/test_versionedfile.py	2007-10-12 05:26:46 +0000
@@ -21,7 +21,6 @@
 # TODO: might be nice to create a versionedfile with some type of corruption
 # considered typical and check that it can be detected/corrected.
 
-from itertools import chain
 from StringIO import StringIO
 
 import bzrlib
@@ -31,206 +30,26 @@
     progress,
     )
 from bzrlib.errors import (
-                           RevisionNotPresent,
+                           RevisionNotPresent, 
                            RevisionAlreadyPresent,
                            WeaveParentMismatch
                            )
-from bzrlib import knit as _mod_knit
 from bzrlib.knit import (
-    cleanup_pack_knit,
-    make_file_factory,
-    make_pack_factory,
+    KnitVersionedFile,
     KnitAnnotateFactory,
     KnitPlainFactory,
     )
-from bzrlib.symbol_versioning import one_four, one_five
-from bzrlib.tests import (
-    TestCase,
-    TestCaseWithMemoryTransport,
-    TestScenarioApplier,
-    TestSkipped,
-    condition_isinstance,
-    split_suite_by_condition,
-    iter_suite_tests,
-    )
-from bzrlib.tests.http_utils import TestCaseWithWebserver
+from bzrlib.tests import TestCaseWithMemoryTransport, TestSkipped
+from bzrlib.tests.HTTPTestUtil import TestCaseWithWebserver
 from bzrlib.trace import mutter
 from bzrlib.transport import get_transport
 from bzrlib.transport.memory import MemoryTransport
 from bzrlib.tsort import topo_sort
-from bzrlib.tuned_gzip import GzipFile
 import bzrlib.versionedfile as versionedfile
-from bzrlib.versionedfile import (
-    ConstantMapper,
-    HashEscapedPrefixMapper,
-    PrefixMapper,
-    VirtualVersionedFiles,
-    make_versioned_files_factory,
-    )
 from bzrlib.weave import WeaveFile
 from bzrlib.weavefile import read_weave, write_weave
 
 
-def load_tests(standard_tests, module, loader):
-    """Parameterize VersionedFiles tests for different implementations."""
-    to_adapt, result = split_suite_by_condition(
-        standard_tests, condition_isinstance(TestVersionedFiles))
-    len_one_adapter = TestScenarioApplier()
-    len_two_adapter = TestScenarioApplier()
-    # We want to be sure of behaviour for:
-    # weaves prefix layout (weave texts)
-    # individually named weaves (weave inventories)
-    # annotated knits - prefix|hash|hash-escape layout, we test the third only
-    #                   as it is the most complex mapper.
-    # individually named knits
-    # individual no-graph knits in packs (signatures)
-    # individual graph knits in packs (inventories)
-    # individual graph nocompression knits in packs (revisions)
-    # plain text knits in packs (texts)
-    len_one_adapter.scenarios = [
-        ('weave-named', {
-            'cleanup':None,
-            'factory':make_versioned_files_factory(WeaveFile,
-                ConstantMapper('inventory')),
-            'graph':True,
-            'key_length':1,
-            }),
-        ('named-knit', {
-            'cleanup':None,
-            'factory':make_file_factory(False, ConstantMapper('revisions')),
-            'graph':True,
-            'key_length':1,
-            }),
-        ('named-nograph-knit-pack', {
-            'cleanup':cleanup_pack_knit,
-            'factory':make_pack_factory(False, False, 1),
-            'graph':False,
-            'key_length':1,
-            }),
-        ('named-graph-knit-pack', {
-            'cleanup':cleanup_pack_knit,
-            'factory':make_pack_factory(True, True, 1),
-            'graph':True,
-            'key_length':1,
-            }),
-        ('named-graph-nodelta-knit-pack', {
-            'cleanup':cleanup_pack_knit,
-            'factory':make_pack_factory(True, False, 1),
-            'graph':True,
-            'key_length':1,
-            }),
-        ]
-    len_two_adapter.scenarios = [
-        ('weave-prefix', {
-            'cleanup':None,
-            'factory':make_versioned_files_factory(WeaveFile,
-                PrefixMapper()),
-            'graph':True,
-            'key_length':2,
-            }),
-        ('annotated-knit-escape', {
-            'cleanup':None,
-            'factory':make_file_factory(True, HashEscapedPrefixMapper()),
-            'graph':True,
-            'key_length':2,
-            }),
-        ('plain-knit-pack', {
-            'cleanup':cleanup_pack_knit,
-            'factory':make_pack_factory(True, True, 2),
-            'graph':True,
-            'key_length':2,
-            }),
-        ]
-    for test in iter_suite_tests(to_adapt):
-        result.addTests(len_one_adapter.adapt(test))
-        result.addTests(len_two_adapter.adapt(test))
-    return result
-
-
-def get_diamond_vf(f, trailing_eol=True, left_only=False):
-    """Get a diamond graph to exercise deltas and merges.
-    
-    :param trailing_eol: If True end the last line with \n.
-    """
-    parents = {
-        'origin': (),
-        'base': (('origin',),),
-        'left': (('base',),),
-        'right': (('base',),),
-        'merged': (('left',), ('right',)),
-        }
-    # insert a diamond graph to exercise deltas and merges.
-    if trailing_eol:
-        last_char = '\n'
-    else:
-        last_char = ''
-    f.add_lines('origin', [], ['origin' + last_char])
-    f.add_lines('base', ['origin'], ['base' + last_char])
-    f.add_lines('left', ['base'], ['base\n', 'left' + last_char])
-    if not left_only:
-        f.add_lines('right', ['base'],
-            ['base\n', 'right' + last_char])
-        f.add_lines('merged', ['left', 'right'],
-            ['base\n', 'left\n', 'right\n', 'merged' + last_char])
-    return f, parents
-
-
-def get_diamond_files(files, key_length, trailing_eol=True, left_only=False,
-    nograph=False):
-    """Get a diamond graph to exercise deltas and merges.
-
-    This creates a 5-node graph in files. If files supports 2-length keys two
-    graphs are made to exercise the support for multiple ids.
-    
-    :param trailing_eol: If True end the last line with \n.
-    :param key_length: The length of keys in files. Currently supports length 1
-        and 2 keys.
-    :param left_only: If True do not add the right and merged nodes.
-    :param nograph: If True, do not provide parents to the add_lines calls;
-        this is useful for tests that need inserted data but have graphless
-        stores.
-    :return: The results of the add_lines calls.
-    """
-    if key_length == 1:
-        prefixes = [()]
-    else:
-        prefixes = [('FileA',), ('FileB',)]
-    # insert a diamond graph to exercise deltas and merges.
-    if trailing_eol:
-        last_char = '\n'
-    else:
-        last_char = ''
-    result = []
-    def get_parents(suffix_list):
-        if nograph:
-            return ()
-        else:
-            result = [prefix + suffix for suffix in suffix_list]
-            return result
-    # we loop over each key because that spreads the inserts across prefixes,
-    # which is how commit operates.
-    for prefix in prefixes:
-        result.append(files.add_lines(prefix + ('origin',), (),
-            ['origin' + last_char]))
-    for prefix in prefixes:
-        result.append(files.add_lines(prefix + ('base',),
-            get_parents([('origin',)]), ['base' + last_char]))
-    for prefix in prefixes:
-        result.append(files.add_lines(prefix + ('left',),
-            get_parents([('base',)]),
-            ['base\n', 'left' + last_char]))
-    if not left_only:
-        for prefix in prefixes:
-            result.append(files.add_lines(prefix + ('right',),
-                get_parents([('base',)]),
-                ['base\n', 'right' + last_char]))
-        for prefix in prefixes:
-            result.append(files.add_lines(prefix + ('merged',),
-                get_parents([('left',), ('right',)]),
-                ['base\n', 'left\n', 'right\n', 'merged' + last_char]))
-    return result
-
-
 class VersionedFileTestMixIn(object):
     """A mixin test class for testing VersionedFiles.
 
@@ -239,11 +58,6 @@
     they are strictly controlled by their owning repositories.
     """
 
-    def get_transaction(self):
-        if not hasattr(self, '_transaction'):
-            self._transaction = None
-        return self._transaction
-
     def test_add(self):
         f = self.get_file()
         f.add_lines('r0', [], ['a\n', 'b\n'])
@@ -419,82 +233,6 @@
         self.assertRaises(errors.ReservedId, vf.get_lines, 'b:')
         self.assertRaises(errors.ReservedId, vf.get_text, 'b:')
 
-    def test_add_unchanged_last_line_noeol_snapshot(self):
-        """Add a text with an unchanged last line with no eol should work."""
-        # Test adding this in a number of chain lengths; because the interface
-        # for VersionedFile does not allow forcing a specific chain length, we
-        # just use a small base to get the first snapshot, then a much longer
-        # first line for the next add (which will make the third add snapshot)
-        # and so on. 20 has been chosen as an aribtrary figure - knits use 200
-        # as a capped delta length, but ideally we would have some way of
-        # tuning the test to the store (e.g. keep going until a snapshot
-        # happens).
-        for length in range(20):
-            version_lines = {}
-            vf = self.get_file('case-%d' % length)
-            prefix = 'step-%d'
-            parents = []
-            for step in range(length):
-                version = prefix % step
-                lines = (['prelude \n'] * step) + ['line']
-                vf.add_lines(version, parents, lines)
-                version_lines[version] = lines
-                parents = [version]
-            vf.add_lines('no-eol', parents, ['line'])
-            vf.get_texts(version_lines.keys())
-            self.assertEqualDiff('line', vf.get_text('no-eol'))
-
-    def test_get_texts_eol_variation(self):
-        # similar to the failure in <http://bugs.launchpad.net/234748>
-        vf = self.get_file()
-        sample_text_nl = ["line\n"]
-        sample_text_no_nl = ["line"]
-        versions = []
-        version_lines = {}
-        parents = []
-        for i in range(4):
-            version = 'v%d' % i
-            if i % 2:
-                lines = sample_text_nl
-            else:
-                lines = sample_text_no_nl
-            # left_matching blocks is an internal api; it operates on the
-            # *internal* representation for a knit, which is with *all* lines
-            # being normalised to end with \n - even the final line in a no_nl
-            # file. Using it here ensures that a broken internal implementation
-            # (which is what this test tests) will generate a correct line
-            # delta (which is to say, an empty delta).
-            vf.add_lines(version, parents, lines,
-                left_matching_blocks=[(0, 0, 1)])
-            parents = [version]
-            versions.append(version)
-            version_lines[version] = lines
-        vf.check()
-        vf.get_texts(versions)
-        vf.get_texts(reversed(versions))
-
-    def test_add_lines_with_matching_blocks_noeol_last_line(self):
-        """Add a text with an unchanged last line with no eol should work."""
-        from bzrlib import multiparent
-        # Hand verified sha1 of the text we're adding.
-        sha1 = '6a1d115ec7b60afb664dc14890b5af5ce3c827a4'
-        # Create a mpdiff which adds a new line before the trailing line, and
-        # reuse the last line unaltered (which can cause annotation reuse).
-        # Test adding this in two situations:
-        # On top of a new insertion
-        vf = self.get_file('fulltext')
-        vf.add_lines('noeol', [], ['line'])
-        vf.add_lines('noeol2', ['noeol'], ['newline\n', 'line'],
-            left_matching_blocks=[(0, 1, 1)])
-        self.assertEqualDiff('newline\nline', vf.get_text('noeol2'))
-        # On top of a delta
-        vf = self.get_file('delta')
-        vf.add_lines('base', [], ['line'])
-        vf.add_lines('noeol', ['base'], ['prelude\n', 'line'])
-        vf.add_lines('noeol2', ['noeol'], ['newline\n', 'line'],
-            left_matching_blocks=[(1, 1, 1)])
-        self.assertEqualDiff('newline\nline', vf.get_text('noeol2'))
-
     def test_make_mpdiffs(self):
         from bzrlib import multiparent
         vf = self.get_file('foo')
@@ -502,20 +240,11 @@
         new_vf = self.get_file('bar')
         for version in multiparent.topo_iter(vf):
             mpdiff = vf.make_mpdiffs([version])[0]
-            new_vf.add_mpdiffs([(version, vf.get_parent_map([version])[version],
-                                 vf.get_sha1s([version])[version], mpdiff)])
+            new_vf.add_mpdiffs([(version, vf.get_parents(version),
+                                 vf.get_sha1(version), mpdiff)])
             self.assertEqualDiff(vf.get_text(version),
                                  new_vf.get_text(version))
 
-    def test_make_mpdiffs_with_ghosts(self):
-        vf = self.get_file('foo')
-        try:
-            vf.add_lines_with_ghosts('text', ['ghost'], ['line\n'])
-        except NotImplementedError:
-            # old Weave formats do not allow ghosts
-            return
-        self.assertRaises(errors.RevisionNotPresent, vf.make_mpdiffs, ['ghost'])
-
     def _setup_for_deltas(self, f):
         self.assertFalse(f.has_version('base'))
         # add texts that should trip the knit maximum delta chain threshold
@@ -618,47 +347,116 @@
             set(f.get_ancestry('rM', topo_sorted=False)))
 
     def test_mutate_after_finish(self):
-        self._transaction = 'before'
         f = self.get_file()
-        self._transaction = 'after'
+        f.transaction_finished()
         self.assertRaises(errors.OutSideTransaction, f.add_lines, '', [], [])
         self.assertRaises(errors.OutSideTransaction, f.add_lines_with_ghosts, '', [], [])
+        self.assertRaises(errors.OutSideTransaction, f.join, '')
+        self.assertRaises(errors.OutSideTransaction, f.clone_text, 'base', 'bar', ['foo'])
         
+    def test_clear_cache(self):
+        f = self.get_file()
+        # on a new file it should not error
+        f.clear_cache()
+        # and after adding content, doing a clear_cache and a get should work.
+        f.add_lines('0', [], ['a'])
+        f.clear_cache()
+        self.assertEqual(['a'], f.get_lines('0'))
+
+    def test_clone_text(self):
+        f = self.get_file()
+        f.add_lines('r0', [], ['a\n', 'b\n'])
+        f.clone_text('r1', 'r0', ['r0'])
+        def verify_file(f):
+            self.assertEquals(f.get_lines('r1'), f.get_lines('r0'))
+            self.assertEquals(f.get_lines('r1'), ['a\n', 'b\n'])
+            self.assertEquals(f.get_parents('r1'), ['r0'])
+    
+            self.assertRaises(RevisionNotPresent,
+                f.clone_text, 'r2', 'rX', [])
+            self.assertRaises(RevisionAlreadyPresent,
+                f.clone_text, 'r1', 'r0', [])
+        verify_file(f)
+        verify_file(self.reopen_file())
+
+    def test_create_empty(self):
+        f = self.get_file()
+        f.add_lines('0', [], ['a\n'])
+        new_f = f.create_empty('t', MemoryTransport())
+        # smoke test, specific types should check it is honoured correctly for
+        # non type attributes
+        self.assertEqual([], new_f.versions())
+        self.assertTrue(isinstance(new_f, f.__class__))
+
     def test_copy_to(self):
         f = self.get_file()
         f.add_lines('0', [], ['a\n'])
         t = MemoryTransport()
         f.copy_to('foo', t)
-        for suffix in self.get_factory().get_suffixes():
+        for suffix in f.__class__.get_suffixes():
             self.assertTrue(t.has('foo' + suffix))
 
     def test_get_suffixes(self):
         f = self.get_file()
+        # should be the same
+        self.assertEqual(f.__class__.get_suffixes(), f.__class__.get_suffixes())
         # and should be a list
-        self.assertTrue(isinstance(self.get_factory().get_suffixes(), list))
-
-    def test_get_parent_map(self):
+        self.assertTrue(isinstance(f.__class__.get_suffixes(), list))
+
+    def build_graph(self, file, graph):
+        for node in topo_sort(graph.items()):
+            file.add_lines(node, graph[node], [])
+
+    def test_get_graph(self):
+        f = self.get_file()
+        graph = {
+            'v1': (),
+            'v2': ('v1', ),
+            'v3': ('v2', )}
+        self.build_graph(f, graph)
+        self.assertEqual(graph, f.get_graph())
+    
+    def test_get_graph_partial(self):
+        f = self.get_file()
+        complex_graph = {}
+        simple_a = {
+            'c': (),
+            'b': ('c', ),
+            'a': ('b', ),
+            }
+        complex_graph.update(simple_a)
+        simple_b = {
+            'c': (),
+            'b': ('c', ),
+            }
+        complex_graph.update(simple_b)
+        simple_gam = {
+            'c': (),
+            'oo': (),
+            'bar': ('oo', 'c'),
+            'gam': ('bar', ),
+            }
+        complex_graph.update(simple_gam)
+        simple_b_gam = {}
+        simple_b_gam.update(simple_gam)
+        simple_b_gam.update(simple_b)
+        self.build_graph(f, complex_graph)
+        self.assertEqual(simple_a, f.get_graph(['a']))
+        self.assertEqual(simple_b, f.get_graph(['b']))
+        self.assertEqual(simple_gam, f.get_graph(['gam']))
+        self.assertEqual(simple_b_gam, f.get_graph(['b', 'gam']))
+
+    def test_get_parents(self):
         f = self.get_file()
         f.add_lines('r0', [], ['a\n', 'b\n'])
-        self.assertEqual(
-            {'r0':()}, f.get_parent_map(['r0']))
-        f.add_lines('r1', ['r0'], ['a\n', 'b\n'])
-        self.assertEqual(
-            {'r1':('r0',)}, f.get_parent_map(['r1']))
-        self.assertEqual(
-            {'r0':(),
-             'r1':('r0',)},
-            f.get_parent_map(['r0', 'r1']))
+        f.add_lines('r1', [], ['a\n', 'b\n'])
         f.add_lines('r2', [], ['a\n', 'b\n'])
         f.add_lines('r3', [], ['a\n', 'b\n'])
         f.add_lines('m', ['r0', 'r1', 'r2', 'r3'], ['a\n', 'b\n'])
-        self.assertEqual(
-            {'m':('r0', 'r1', 'r2', 'r3')}, f.get_parent_map(['m']))
-        self.assertEqual({}, f.get_parent_map('y'))
-        self.assertEqual(
-            {'r0':(),
-             'r1':('r0',)},
-            f.get_parent_map(['r0', 'y', 'r1']))
+        self.assertEquals(f.get_parents('m'), ['r0', 'r1', 'r2', 'r3'])
+
+        self.assertRaises(RevisionNotPresent,
+            f.get_parents, 'y')
 
     def test_annotate(self):
         f = self.get_file()
@@ -700,6 +498,37 @@
         """Open the versioned file from disk again."""
         raise NotImplementedError(self.reopen_file)
 
+    def test_iter_parents(self):
+        """iter_parents returns the parents for many nodes."""
+        f = self.get_file()
+        # sample data:
+        # no parents
+        f.add_lines('r0', [], ['a\n', 'b\n'])
+        # 1 parents
+        f.add_lines('r1', ['r0'], ['a\n', 'b\n'])
+        # 2 parents
+        f.add_lines('r2', ['r1', 'r0'], ['a\n', 'b\n'])
+        # XXX TODO a ghost
+        # cases: each sample data individually:
+        self.assertEqual(set([('r0', ())]),
+            set(f.iter_parents(['r0'])))
+        self.assertEqual(set([('r1', ('r0', ))]),
+            set(f.iter_parents(['r1'])))
+        self.assertEqual(set([('r2', ('r1', 'r0'))]),
+            set(f.iter_parents(['r2'])))
+        # no nodes returned for a missing node
+        self.assertEqual(set(),
+            set(f.iter_parents(['missing'])))
+        # 1 node returned with missing nodes skipped
+        self.assertEqual(set([('r1', ('r0', ))]),
+            set(f.iter_parents(['ghost1', 'r1', 'ghost'])))
+        # 2 nodes returned
+        self.assertEqual(set([('r0', ()), ('r1', ('r0', ))]),
+            set(f.iter_parents(['r0', 'r1'])))
+        # 2 nodes returned, missing skipped
+        self.assertEqual(set([('r0', ()), ('r1', ('r0', ))]),
+            set(f.iter_parents(['a', 'r0', 'b', 'r1', 'c'])))
+
     def test_iter_lines_added_or_present_in_versions(self):
         # test that we get at least an equalset of the lines added by
         # versions in the weave 
@@ -731,14 +560,18 @@
                      ['base\n', 'lancestor\n', 'otherchild\n'])
         def iter_with_versions(versions, expected):
             # now we need to see what lines are returned, and how often.
-            lines = {}
+            lines = {'base\n':0,
+                     'lancestor\n':0,
+                     'rancestor\n':0,
+                     'child\n':0,
+                     'otherchild\n':0,
+                     }
             progress = InstrumentedProgress()
             # iterate over the lines
-            for line in vf.iter_lines_added_or_present_in_versions(versions,
+            for line in vf.iter_lines_added_or_present_in_versions(versions, 
                 pb=progress):
-                lines.setdefault(line, 0)
                 lines[line] += 1
-            if []!= progress.updates:
+            if []!= progress.updates: 
                 self.assertEqual(expected, progress.updates)
             return lines
         lines = iter_with_versions(['child', 'otherchild'],
@@ -746,8 +579,8 @@
                                     ('Walking content.', 1, 2),
                                     ('Walking content.', 2, 2)])
         # we must see child and otherchild
-        self.assertTrue(lines[('child\n', 'child')] > 0)
-        self.assertTrue(lines[('otherchild\n', 'otherchild')] > 0)
+        self.assertTrue(lines['child\n'] > 0)
+        self.assertTrue(lines['otherchild\n'] > 0)
         # we dont care if we got more than that.
         
         # test all lines
@@ -758,11 +591,11 @@
                                           ('Walking content.', 4, 5),
                                           ('Walking content.', 5, 5)])
         # all lines must be seen at least once
-        self.assertTrue(lines[('base\n', 'base')] > 0)
-        self.assertTrue(lines[('lancestor\n', 'lancestor')] > 0)
-        self.assertTrue(lines[('rancestor\n', 'rancestor')] > 0)
-        self.assertTrue(lines[('child\n', 'child')] > 0)
-        self.assertTrue(lines[('otherchild\n', 'otherchild')] > 0)
+        self.assertTrue(lines['base\n'] > 0)
+        self.assertTrue(lines['lancestor\n'] > 0)
+        self.assertTrue(lines['rancestor\n'] > 0)
+        self.assertTrue(lines['child\n'] > 0)
+        self.assertTrue(lines['otherchild\n'] > 0)
 
     def test_add_lines_with_ghosts(self):
         # some versioned file formats allow lines to be added with parent
@@ -778,29 +611,43 @@
             vf.add_lines_with_ghosts('notbxbfse', [parent_id_utf8], [])
         except NotImplementedError:
             # check the other ghost apis are also not implemented
+            self.assertRaises(NotImplementedError, vf.has_ghost, 'foo')
             self.assertRaises(NotImplementedError, vf.get_ancestry_with_ghosts, ['foo'])
             self.assertRaises(NotImplementedError, vf.get_parents_with_ghosts, 'foo')
+            self.assertRaises(NotImplementedError, vf.get_graph_with_ghosts)
             return
         vf = self.reopen_file()
         # test key graph related apis: getncestry, _graph, get_parents
         # has_version
         # - these are ghost unaware and must not be reflect ghosts
         self.assertEqual(['notbxbfse'], vf.get_ancestry('notbxbfse'))
+        self.assertEqual([], vf.get_parents('notbxbfse'))
+        self.assertEqual({'notbxbfse':()}, vf.get_graph())
         self.assertFalse(vf.has_version(parent_id_utf8))
         # we have _with_ghost apis to give us ghost information.
         self.assertEqual([parent_id_utf8, 'notbxbfse'], vf.get_ancestry_with_ghosts(['notbxbfse']))
         self.assertEqual([parent_id_utf8], vf.get_parents_with_ghosts('notbxbfse'))
+        self.assertEqual({'notbxbfse':[parent_id_utf8]}, vf.get_graph_with_ghosts())
+        self.assertTrue(vf.has_ghost(parent_id_utf8))
         # if we add something that is a ghost of another, it should correct the
         # results of the prior apis
         vf.add_lines(parent_id_utf8, [], [])
         self.assertEqual([parent_id_utf8, 'notbxbfse'], vf.get_ancestry(['notbxbfse']))
-        self.assertEqual({'notbxbfse':(parent_id_utf8,)},
-            vf.get_parent_map(['notbxbfse']))
+        self.assertEqual([parent_id_utf8], vf.get_parents('notbxbfse'))
+        self.assertEqual({parent_id_utf8:(),
+                          'notbxbfse':(parent_id_utf8, ),
+                          },
+                         vf.get_graph())
         self.assertTrue(vf.has_version(parent_id_utf8))
         # we have _with_ghost apis to give us ghost information.
         self.assertEqual([parent_id_utf8, 'notbxbfse'],
             vf.get_ancestry_with_ghosts(['notbxbfse']))
         self.assertEqual([parent_id_utf8], vf.get_parents_with_ghosts('notbxbfse'))
+        self.assertEqual({parent_id_utf8:[],
+                          'notbxbfse':[parent_id_utf8],
+                          },
+                         vf.get_graph_with_ghosts())
+        self.assertFalse(vf.has_ghost(parent_id_utf8))
 
     def test_add_lines_with_ghosts_after_normal_revs(self):
         # some versioned file formats allow lines to be added with parent
@@ -810,9 +657,10 @@
         vf = self.get_file()
         # probe for ghost support
         try:
-            vf.add_lines_with_ghosts('base', [], ['line\n', 'line_b\n'])
+            vf.has_ghost('hoo')
         except NotImplementedError:
             return
+        vf.add_lines_with_ghosts('base', [], ['line\n', 'line_b\n'])
         vf.add_lines_with_ghosts('references_ghost',
                                  ['base', 'a_ghost'],
                                  ['line\n', 'line_b\n', 'line_c\n'])
@@ -832,8 +680,10 @@
                           'base',
                           [],
                           [])
+        self.assertRaises(errors.ReadOnlyError, vf.join, 'base')
+        self.assertRaises(errors.ReadOnlyError, vf.clone_text, 'base', 'bar', ['foo'])
     
-    def test_get_sha1s(self):
+    def test_get_sha1(self):
         # check the sha1 data is available
         vf = self.get_file()
         # a simple file
@@ -842,23 +692,26 @@
         vf.add_lines('b', ['a'], ['a\n'])
         # a file differing only in last newline.
         vf.add_lines('c', [], ['a'])
-        self.assertEqual({
-            'a': '3f786850e387550fdab836ed7e6dc881de23001b',
-            'c': '86f7e437faa5a7fce15d1ddcb9eaeaea377667b8',
-            'b': '3f786850e387550fdab836ed7e6dc881de23001b',
-            },
-            vf.get_sha1s(['a', 'c', 'b']))
+        self.assertEqual(
+            '3f786850e387550fdab836ed7e6dc881de23001b', vf.get_sha1('a'))
+        self.assertEqual(
+            '3f786850e387550fdab836ed7e6dc881de23001b', vf.get_sha1('b'))
+        self.assertEqual(
+            '86f7e437faa5a7fce15d1ddcb9eaeaea377667b8', vf.get_sha1('c'))
+
+        self.assertEqual(['3f786850e387550fdab836ed7e6dc881de23001b',
+                          '86f7e437faa5a7fce15d1ddcb9eaeaea377667b8',
+                          '3f786850e387550fdab836ed7e6dc881de23001b'],
+                          vf.get_sha1s(['a', 'c', 'b']))
         
 
 class TestWeave(TestCaseWithMemoryTransport, VersionedFileTestMixIn):
 
     def get_file(self, name='foo'):
-        return WeaveFile(name, get_transport(self.get_url('.')), create=True,
-            get_scope=self.get_transaction)
+        return WeaveFile(name, get_transport(self.get_url('.')), create=True)
 
     def get_file_corrupted_text(self):
-        w = WeaveFile('foo', get_transport(self.get_url('.')), create=True,
-            get_scope=self.get_transaction)
+        w = WeaveFile('foo', get_transport(self.get_url('.')), create=True)
         w.add_lines('v1', [], ['hello\n'])
         w.add_lines('v2', ['v1'], ['hello\n', 'there\n'])
         
@@ -892,82 +745,129 @@
         return w
 
     def reopen_file(self, name='foo', create=False):
-        return WeaveFile(name, get_transport(self.get_url('.')), create=create,
-            get_scope=self.get_transaction)
+        return WeaveFile(name, get_transport(self.get_url('.')), create=create)
 
     def test_no_implicit_create(self):
         self.assertRaises(errors.NoSuchFile,
                           WeaveFile,
                           'foo',
-                          get_transport(self.get_url('.')),
-                          get_scope=self.get_transaction)
+                          get_transport(self.get_url('.')))
 
     def get_factory(self):
         return WeaveFile
 
 
-class TestPlanMergeVersionedFile(TestCaseWithMemoryTransport):
-
-    def setUp(self):
-        TestCaseWithMemoryTransport.setUp(self)
-        mapper = PrefixMapper()
-        factory = make_file_factory(True, mapper)
-        self.vf1 = factory(self.get_transport('root-1'))
-        self.vf2 = factory(self.get_transport('root-2'))
-        self.plan_merge_vf = versionedfile._PlanMergeVersionedFile('root')
-        self.plan_merge_vf.fallback_versionedfiles.extend([self.vf1, self.vf2])
-
-    def test_add_lines(self):
-        self.plan_merge_vf.add_lines(('root', 'a:'), [], [])
-        self.assertRaises(ValueError, self.plan_merge_vf.add_lines,
-            ('root', 'a'), [], [])
-        self.assertRaises(ValueError, self.plan_merge_vf.add_lines,
-            ('root', 'a:'), None, [])
-        self.assertRaises(ValueError, self.plan_merge_vf.add_lines,
-            ('root', 'a:'), [], None)
-
-    def setup_abcde(self):
-        self.vf1.add_lines(('root', 'A'), [], ['a'])
-        self.vf1.add_lines(('root', 'B'), [('root', 'A')], ['b'])
-        self.vf2.add_lines(('root', 'C'), [], ['c'])
-        self.vf2.add_lines(('root', 'D'), [('root', 'C')], ['d'])
-        self.plan_merge_vf.add_lines(('root', 'E:'),
-            [('root', 'B'), ('root', 'D')], ['e'])
-
-    def test_get_parents(self):
-        self.setup_abcde()
-        self.assertEqual({('root', 'B'):(('root', 'A'),)},
-            self.plan_merge_vf.get_parent_map([('root', 'B')]))
-        self.assertEqual({('root', 'D'):(('root', 'C'),)},
-            self.plan_merge_vf.get_parent_map([('root', 'D')]))
-        self.assertEqual({('root', 'E:'):(('root', 'B'),('root', 'D'))},
-            self.plan_merge_vf.get_parent_map([('root', 'E:')]))
-        self.assertEqual({},
-            self.plan_merge_vf.get_parent_map([('root', 'F')]))
-        self.assertEqual({
-                ('root', 'B'):(('root', 'A'),),
-                ('root', 'D'):(('root', 'C'),),
-                ('root', 'E:'):(('root', 'B'),('root', 'D')),
-                },
-            self.plan_merge_vf.get_parent_map(
-                [('root', 'B'), ('root', 'D'), ('root', 'E:'), ('root', 'F')]))
-
-    def test_get_record_stream(self):
-        self.setup_abcde()
-        def get_record(suffix):
-            return self.plan_merge_vf.get_record_stream(
-                [('root', suffix)], 'unordered', True).next()
-        self.assertEqual('a', get_record('A').get_bytes_as('fulltext'))
-        self.assertEqual('c', get_record('C').get_bytes_as('fulltext'))
-        self.assertEqual('e', get_record('E:').get_bytes_as('fulltext'))
-        self.assertEqual('absent', get_record('F').storage_kind)
+class TestKnit(TestCaseWithMemoryTransport, VersionedFileTestMixIn):
+
+    def get_file(self, name='foo'):
+        return self.get_factory()(name, get_transport(self.get_url('.')),
+                                  delta=True, create=True)
+
+    def get_factory(self):
+        return KnitVersionedFile
+
+    def get_file_corrupted_text(self):
+        knit = self.get_file()
+        knit.add_lines('v1', [], ['hello\n'])
+        knit.add_lines('v2', ['v1'], ['hello\n', 'there\n'])
+        return knit
+
+    def reopen_file(self, name='foo', create=False):
+        return self.get_factory()(name, get_transport(self.get_url('.')),
+            delta=True,
+            create=create)
+
+    def test_detection(self):
+        knit = self.get_file()
+        knit.check()
+
+    def test_no_implicit_create(self):
+        self.assertRaises(errors.NoSuchFile,
+                          KnitVersionedFile,
+                          'foo',
+                          get_transport(self.get_url('.')))
+
+
+class TestPlaintextKnit(TestKnit):
+    """Test a knit with no cached annotations"""
+
+    def _factory(self, name, transport, file_mode=None, access_mode=None,
+                 delta=True, create=False):
+        return KnitVersionedFile(name, transport, file_mode, access_mode,
+                                 KnitPlainFactory(), delta=delta,
+                                 create=create)
+
+    def get_factory(self):
+        return self._factory
+
+
+class InterString(versionedfile.InterVersionedFile):
+    """An inter-versionedfile optimised code path for strings.
+
+    This is for use during testing where we use strings as versionedfiles
+    so that none of the default regsitered interversionedfile classes will
+    match - which lets us test the match logic.
+    """
+
+    @staticmethod
+    def is_compatible(source, target):
+        """InterString is compatible with strings-as-versionedfiles."""
+        return isinstance(source, str) and isinstance(target, str)
+
+
+# TODO this and the InterRepository core logic should be consolidatable
+# if we make the registry a separate class though we still need to 
+# test the behaviour in the active registry to catch failure-to-handle-
+# stange-objects
+class TestInterVersionedFile(TestCaseWithMemoryTransport):
+
+    def test_get_default_inter_versionedfile(self):
+        # test that the InterVersionedFile.get(a, b) probes
+        # for a class where is_compatible(a, b) returns
+        # true and returns a default interversionedfile otherwise.
+        # This also tests that the default registered optimised interversionedfile
+        # classes do not barf inappropriately when a surprising versionedfile type
+        # is handed to them.
+        dummy_a = "VersionedFile 1."
+        dummy_b = "VersionedFile 2."
+        self.assertGetsDefaultInterVersionedFile(dummy_a, dummy_b)
+
+    def assertGetsDefaultInterVersionedFile(self, a, b):
+        """Asserts that InterVersionedFile.get(a, b) -> the default."""
+        inter = versionedfile.InterVersionedFile.get(a, b)
+        self.assertEqual(versionedfile.InterVersionedFile,
+                         inter.__class__)
+        self.assertEqual(a, inter.source)
+        self.assertEqual(b, inter.target)
+
+    def test_register_inter_versionedfile_class(self):
+        # test that a optimised code path provider - a
+        # InterVersionedFile subclass can be registered and unregistered
+        # and that it is correctly selected when given a versionedfile
+        # pair that it returns true on for the is_compatible static method
+        # check
+        dummy_a = "VersionedFile 1."
+        dummy_b = "VersionedFile 2."
+        versionedfile.InterVersionedFile.register_optimiser(InterString)
+        try:
+            # we should get the default for something InterString returns False
+            # to
+            self.assertFalse(InterString.is_compatible(dummy_a, None))
+            self.assertGetsDefaultInterVersionedFile(dummy_a, None)
+            # and we should get an InterString for a pair it 'likes'
+            self.assertTrue(InterString.is_compatible(dummy_a, dummy_b))
+            inter = versionedfile.InterVersionedFile.get(dummy_a, dummy_b)
+            self.assertEqual(InterString, inter.__class__)
+            self.assertEqual(dummy_a, inter.source)
+            self.assertEqual(dummy_b, inter.target)
+        finally:
+            versionedfile.InterVersionedFile.unregister_optimiser(InterString)
+        # now we should get the default InterVersionedFile object again.
+        self.assertGetsDefaultInterVersionedFile(dummy_a, dummy_b)
 
 
 class TestReadonlyHttpMixin(object):
 
-    def get_transaction(self):
-        return 1
-
     def test_readonly_http_works(self):
         # we should be able to read from http with a versioned file.
         vf = self.get_file()
@@ -986,13 +886,22 @@
 class TestWeaveHTTP(TestCaseWithWebserver, TestReadonlyHttpMixin):
 
     def get_file(self):
-        return WeaveFile('foo', get_transport(self.get_url('.')), create=True,
-            get_scope=self.get_transaction)
+        return WeaveFile('foo', get_transport(self.get_url('.')), create=True)
 
     def get_factory(self):
         return WeaveFile
 
 
+class TestKnitHTTP(TestCaseWithWebserver, TestReadonlyHttpMixin):
+
+    def get_file(self):
+        return KnitVersionedFile('foo', get_transport(self.get_url('.')),
+                                 delta=True, create=True)
+
+    def get_factory(self):
+        return KnitVersionedFile
+
+
 class MergeCasesMixin(object):
 
     def doMerge(self, base, a, b, mp):
@@ -1230,6 +1139,16 @@
         self._test_merge_from_strings(base, a, b, result)
 
 
+class TestKnitMerge(TestCaseWithMemoryTransport, MergeCasesMixin):
+
+    def get_file(self, name='foo'):
+        return KnitVersionedFile(name, get_transport(self.get_url('.')),
+                                 delta=True, create=True)
+
+    def log_contents(self, w):
+        pass
+
+
 class TestWeaveMerge(TestCaseWithMemoryTransport, MergeCasesMixin):
 
     def get_file(self, name='foo'):
@@ -1245,976 +1164,21 @@
                                 'xxx', '>>>>>>> ', 'bbb']
 
 
-class TestContentFactoryAdaption(TestCaseWithMemoryTransport):
-
-    def test_select_adaptor(self):
-        """Test expected adapters exist."""
-        # One scenario for each lookup combination we expect to use.
-        # Each is source_kind, requested_kind, adapter class
-        scenarios = [
-            ('knit-delta-gz', 'fulltext', _mod_knit.DeltaPlainToFullText),
-            ('knit-ft-gz', 'fulltext', _mod_knit.FTPlainToFullText),
-            ('knit-annotated-delta-gz', 'knit-delta-gz',
-                _mod_knit.DeltaAnnotatedToUnannotated),
-            ('knit-annotated-delta-gz', 'fulltext',
-                _mod_knit.DeltaAnnotatedToFullText),
-            ('knit-annotated-ft-gz', 'knit-ft-gz',
-                _mod_knit.FTAnnotatedToUnannotated),
-            ('knit-annotated-ft-gz', 'fulltext',
-                _mod_knit.FTAnnotatedToFullText),
-            ]
-        for source, requested, klass in scenarios:
-            adapter_factory = versionedfile.adapter_registry.get(
-                (source, requested))
-            adapter = adapter_factory(None)
-            self.assertIsInstance(adapter, klass)
-
-    def get_knit(self, annotated=True):
-        mapper = ConstantMapper('knit')
-        transport = self.get_transport()
-        return make_file_factory(annotated, mapper)(transport)
-
-    def helpGetBytes(self, f, ft_adapter, delta_adapter):
-        """Grab the interested adapted texts for tests."""
-        # origin is a fulltext
-        entries = f.get_record_stream([('origin',)], 'unordered', False)
-        base = entries.next()
-        ft_data = ft_adapter.get_bytes(base, base.get_bytes_as(base.storage_kind))
-        # merged is both a delta and multiple parents.
-        entries = f.get_record_stream([('merged',)], 'unordered', False)
-        merged = entries.next()
-        delta_data = delta_adapter.get_bytes(merged,
-            merged.get_bytes_as(merged.storage_kind))
-        return ft_data, delta_data
-
-    def test_deannotation_noeol(self):
-        """Test converting annotated knits to unannotated knits."""
-        # we need a full text, and a delta
-        f = self.get_knit()
-        get_diamond_files(f, 1, trailing_eol=False)
-        ft_data, delta_data = self.helpGetBytes(f,
-            _mod_knit.FTAnnotatedToUnannotated(None),
-            _mod_knit.DeltaAnnotatedToUnannotated(None))
-        self.assertEqual(
-            'version origin 1 b284f94827db1fa2970d9e2014f080413b547a7e\n'
-            'origin\n'
-            'end origin\n',
-            GzipFile(mode='rb', fileobj=StringIO(ft_data)).read())
-        self.assertEqual(
-            'version merged 4 32c2e79763b3f90e8ccde37f9710b6629c25a796\n'
-            '1,2,3\nleft\nright\nmerged\nend merged\n',
-            GzipFile(mode='rb', fileobj=StringIO(delta_data)).read())
-
-    def test_deannotation(self):
-        """Test converting annotated knits to unannotated knits."""
-        # we need a full text, and a delta
-        f = self.get_knit()
-        get_diamond_files(f, 1)
-        ft_data, delta_data = self.helpGetBytes(f,
-            _mod_knit.FTAnnotatedToUnannotated(None),
-            _mod_knit.DeltaAnnotatedToUnannotated(None))
-        self.assertEqual(
-            'version origin 1 00e364d235126be43292ab09cb4686cf703ddc17\n'
-            'origin\n'
-            'end origin\n',
-            GzipFile(mode='rb', fileobj=StringIO(ft_data)).read())
-        self.assertEqual(
-            'version merged 3 ed8bce375198ea62444dc71952b22cfc2b09226d\n'
-            '2,2,2\nright\nmerged\nend merged\n',
-            GzipFile(mode='rb', fileobj=StringIO(delta_data)).read())
-
-    def test_annotated_to_fulltext_no_eol(self):
-        """Test adapting annotated knits to full texts (for -> weaves)."""
-        # we need a full text, and a delta
-        f = self.get_knit()
-        get_diamond_files(f, 1, trailing_eol=False)
-        # Reconstructing a full text requires a backing versioned file, and it
-        # must have the base lines requested from it.
-        logged_vf = versionedfile.RecordingVersionedFilesDecorator(f)
-        ft_data, delta_data = self.helpGetBytes(f,
-            _mod_knit.FTAnnotatedToFullText(None),
-            _mod_knit.DeltaAnnotatedToFullText(logged_vf))
-        self.assertEqual('origin', ft_data)
-        self.assertEqual('base\nleft\nright\nmerged', delta_data)
-        self.assertEqual([('get_record_stream', [('left',)], 'unordered',
-            True)], logged_vf.calls)
-
-    def test_annotated_to_fulltext(self):
-        """Test adapting annotated knits to full texts (for -> weaves)."""
-        # we need a full text, and a delta
-        f = self.get_knit()
-        get_diamond_files(f, 1)
-        # Reconstructing a full text requires a backing versioned file, and it
-        # must have the base lines requested from it.
-        logged_vf = versionedfile.RecordingVersionedFilesDecorator(f)
-        ft_data, delta_data = self.helpGetBytes(f,
-            _mod_knit.FTAnnotatedToFullText(None),
-            _mod_knit.DeltaAnnotatedToFullText(logged_vf))
-        self.assertEqual('origin\n', ft_data)
-        self.assertEqual('base\nleft\nright\nmerged\n', delta_data)
-        self.assertEqual([('get_record_stream', [('left',)], 'unordered',
-            True)], logged_vf.calls)
-
-    def test_unannotated_to_fulltext(self):
-        """Test adapting unannotated knits to full texts.
-        
-        This is used for -> weaves, and for -> annotated knits.
-        """
-        # we need a full text, and a delta
-        f = self.get_knit(annotated=False)
-        get_diamond_files(f, 1)
-        # Reconstructing a full text requires a backing versioned file, and it
-        # must have the base lines requested from it.
-        logged_vf = versionedfile.RecordingVersionedFilesDecorator(f)
-        ft_data, delta_data = self.helpGetBytes(f,
-            _mod_knit.FTPlainToFullText(None),
-            _mod_knit.DeltaPlainToFullText(logged_vf))
-        self.assertEqual('origin\n', ft_data)
-        self.assertEqual('base\nleft\nright\nmerged\n', delta_data)
-        self.assertEqual([('get_record_stream', [('left',)], 'unordered',
-            True)], logged_vf.calls)
-
-    def test_unannotated_to_fulltext_no_eol(self):
-        """Test adapting unannotated knits to full texts.
-        
-        This is used for -> weaves, and for -> annotated knits.
-        """
-        # we need a full text, and a delta
-        f = self.get_knit(annotated=False)
-        get_diamond_files(f, 1, trailing_eol=False)
-        # Reconstructing a full text requires a backing versioned file, and it
-        # must have the base lines requested from it.
-        logged_vf = versionedfile.RecordingVersionedFilesDecorator(f)
-        ft_data, delta_data = self.helpGetBytes(f,
-            _mod_knit.FTPlainToFullText(None),
-            _mod_knit.DeltaPlainToFullText(logged_vf))
-        self.assertEqual('origin', ft_data)
-        self.assertEqual('base\nleft\nright\nmerged', delta_data)
-        self.assertEqual([('get_record_stream', [('left',)], 'unordered',
-            True)], logged_vf.calls)
-
-
-class TestKeyMapper(TestCaseWithMemoryTransport):
-    """Tests for various key mapping logic."""
-
-    def test_identity_mapper(self):
-        mapper = versionedfile.ConstantMapper("inventory")
-        self.assertEqual("inventory", mapper.map(('foo@ar',)))
-        self.assertEqual("inventory", mapper.map(('quux',)))
-
-    def test_prefix_mapper(self):
-        #format5: plain
-        mapper = versionedfile.PrefixMapper()
-        self.assertEqual("file-id", mapper.map(("file-id", "revision-id")))
-        self.assertEqual("new-id", mapper.map(("new-id", "revision-id")))
-        self.assertEqual(('file-id',), mapper.unmap("file-id"))
-        self.assertEqual(('new-id',), mapper.unmap("new-id"))
-
-    def test_hash_prefix_mapper(self):
-        #format6: hash + plain
-        mapper = versionedfile.HashPrefixMapper()
-        self.assertEqual("9b/file-id", mapper.map(("file-id", "revision-id")))
-        self.assertEqual("45/new-id", mapper.map(("new-id", "revision-id")))
-        self.assertEqual(('file-id',), mapper.unmap("9b/file-id"))
-        self.assertEqual(('new-id',), mapper.unmap("45/new-id"))
-
-    def test_hash_escaped_mapper(self):
-        #knit1: hash + escaped
-        mapper = versionedfile.HashEscapedPrefixMapper()
-        self.assertEqual("88/%2520", mapper.map((" ", "revision-id")))
-        self.assertEqual("ed/fil%2545-%2549d", mapper.map(("filE-Id",
-            "revision-id")))
-        self.assertEqual("88/ne%2557-%2549d", mapper.map(("neW-Id",
-            "revision-id")))
-        self.assertEqual(('filE-Id',), mapper.unmap("ed/fil%2545-%2549d"))
-        self.assertEqual(('neW-Id',), mapper.unmap("88/ne%2557-%2549d"))
-
-
-class TestVersionedFiles(TestCaseWithMemoryTransport):
-    """Tests for the multiple-file variant of VersionedFile."""
-
-    def get_versionedfiles(self, relpath='files'):
-        transport = self.get_transport(relpath)
-        if relpath != '.':
-            transport.mkdir('.')
-        files = self.factory(transport)
-        if self.cleanup is not None:
-            self.addCleanup(lambda:self.cleanup(files))
-        return files
-
-    def test_annotate(self):
-        files = self.get_versionedfiles()
-        self.get_diamond_files(files)
-        if self.key_length == 1:
-            prefix = ()
-        else:
-            prefix = ('FileA',)
-        # introduced full text
-        origins = files.annotate(prefix + ('origin',))
-        self.assertEqual([
-            (prefix + ('origin',), 'origin\n')],
-            origins)
-        # a delta
-        origins = files.annotate(prefix + ('base',))
-        self.assertEqual([
-            (prefix + ('base',), 'base\n')],
-            origins)
-        # a merge
-        origins = files.annotate(prefix + ('merged',))
-        if self.graph:
-            self.assertEqual([
-                (prefix + ('base',), 'base\n'),
-                (prefix + ('left',), 'left\n'),
-                (prefix + ('right',), 'right\n'),
-                (prefix + ('merged',), 'merged\n')
-                ],
-                origins)
-        else:
-            # Without a graph everything is new.
-            self.assertEqual([
-                (prefix + ('merged',), 'base\n'),
-                (prefix + ('merged',), 'left\n'),
-                (prefix + ('merged',), 'right\n'),
-                (prefix + ('merged',), 'merged\n')
-                ],
-                origins)
-        self.assertRaises(RevisionNotPresent,
-            files.annotate, prefix + ('missing-key',))
-
-    def test_construct(self):
-        """Each parameterised test can be constructed on a transport."""
-        files = self.get_versionedfiles()
-
-    def get_diamond_files(self, files, trailing_eol=True, left_only=False):
-        return get_diamond_files(files, self.key_length,
-            trailing_eol=trailing_eol, nograph=not self.graph,
-            left_only=left_only)
-
-    def test_add_lines_return(self):
-        files = self.get_versionedfiles()
-        # save code by using the stock data insertion helper.
-        adds = self.get_diamond_files(files)
-        results = []
-        # We can only validate the first 2 elements returned from add_lines.
-        for add in adds:
-            self.assertEqual(3, len(add))
-            results.append(add[:2])
-        if self.key_length == 1:
-            self.assertEqual([
-                ('00e364d235126be43292ab09cb4686cf703ddc17', 7),
-                ('51c64a6f4fc375daf0d24aafbabe4d91b6f4bb44', 5),
-                ('a8478686da38e370e32e42e8a0c220e33ee9132f', 10),
-                ('9ef09dfa9d86780bdec9219a22560c6ece8e0ef1', 11),
-                ('ed8bce375198ea62444dc71952b22cfc2b09226d', 23)],
-                results)
-        elif self.key_length == 2:
-            self.assertEqual([
-                ('00e364d235126be43292ab09cb4686cf703ddc17', 7),
-                ('00e364d235126be43292ab09cb4686cf703ddc17', 7),
-                ('51c64a6f4fc375daf0d24aafbabe4d91b6f4bb44', 5),
-                ('51c64a6f4fc375daf0d24aafbabe4d91b6f4bb44', 5),
-                ('a8478686da38e370e32e42e8a0c220e33ee9132f', 10),
-                ('a8478686da38e370e32e42e8a0c220e33ee9132f', 10),
-                ('9ef09dfa9d86780bdec9219a22560c6ece8e0ef1', 11),
-                ('9ef09dfa9d86780bdec9219a22560c6ece8e0ef1', 11),
-                ('ed8bce375198ea62444dc71952b22cfc2b09226d', 23),
-                ('ed8bce375198ea62444dc71952b22cfc2b09226d', 23)],
-                results)
-
-    def test_empty_lines(self):
-        """Empty files can be stored."""
-        f = self.get_versionedfiles()
-        key_a = self.get_simple_key('a')
-        f.add_lines(key_a, [], [])
-        self.assertEqual('',
-            f.get_record_stream([key_a], 'unordered', True
-                ).next().get_bytes_as('fulltext'))
-        key_b = self.get_simple_key('b')
-        f.add_lines(key_b, self.get_parents([key_a]), [])
-        self.assertEqual('',
-            f.get_record_stream([key_b], 'unordered', True
-                ).next().get_bytes_as('fulltext'))
-
-    def test_newline_only(self):
-        f = self.get_versionedfiles()
-        key_a = self.get_simple_key('a')
-        f.add_lines(key_a, [], ['\n'])
-        self.assertEqual('\n',
-            f.get_record_stream([key_a], 'unordered', True
-                ).next().get_bytes_as('fulltext'))
-        key_b = self.get_simple_key('b')
-        f.add_lines(key_b, self.get_parents([key_a]), ['\n'])
-        self.assertEqual('\n',
-            f.get_record_stream([key_b], 'unordered', True
-                ).next().get_bytes_as('fulltext'))
-
-    def test_get_record_stream_empty(self):
-        """An empty stream can be requested without error."""
-        f = self.get_versionedfiles()
-        entries = f.get_record_stream([], 'unordered', False)
-        self.assertEqual([], list(entries))
-
-    def assertValidStorageKind(self, storage_kind):
-        """Assert that storage_kind is a valid storage_kind."""
-        self.assertSubset([storage_kind],
-            ['mpdiff', 'knit-annotated-ft', 'knit-annotated-delta',
-             'knit-ft', 'knit-delta', 'fulltext', 'knit-annotated-ft-gz',
-             'knit-annotated-delta-gz', 'knit-ft-gz', 'knit-delta-gz'])
-
-    def capture_stream(self, f, entries, on_seen, parents):
-        """Capture a stream for testing."""
-        for factory in entries:
-            on_seen(factory.key)
-            self.assertValidStorageKind(factory.storage_kind)
-            self.assertEqual(f.get_sha1s([factory.key])[factory.key],
-                factory.sha1)
-            self.assertEqual(parents[factory.key], factory.parents)
-            self.assertIsInstance(factory.get_bytes_as(factory.storage_kind),
-                str)
-
-    def test_get_record_stream_interface(self):
-        """each item in a stream has to provide a regular interface."""
-        files = self.get_versionedfiles()
-        self.get_diamond_files(files)
-        keys, _ = self.get_keys_and_sort_order()
-        parent_map = files.get_parent_map(keys)
-        entries = files.get_record_stream(keys, 'unordered', False)
-        seen = set()
-        self.capture_stream(files, entries, seen.add, parent_map)
-        self.assertEqual(set(keys), seen)
-
-    def get_simple_key(self, suffix):
-        """Return a key for the object under test."""
-        if self.key_length == 1:
-            return (suffix,)
-        else:
-            return ('FileA',) + (suffix,)
-
-    def get_keys_and_sort_order(self):
-        """Get diamond test keys list, and their sort ordering."""
-        if self.key_length == 1:
-            keys = [('merged',), ('left',), ('right',), ('base',)]
-            sort_order = {('merged',):2, ('left',):1, ('right',):1, ('base',):0}
-        else:
-            keys = [
-                ('FileA', 'merged'), ('FileA', 'left'), ('FileA', 'right'),
-                ('FileA', 'base'),
-                ('FileB', 'merged'), ('FileB', 'left'), ('FileB', 'right'),
-                ('FileB', 'base'),
-                ]
-            sort_order = {
-                ('FileA', 'merged'):2, ('FileA', 'left'):1, ('FileA', 'right'):1,
-                ('FileA', 'base'):0,
-                ('FileB', 'merged'):2, ('FileB', 'left'):1, ('FileB', 'right'):1,
-                ('FileB', 'base'):0,
-                }
-        return keys, sort_order
-
-    def test_get_record_stream_interface_ordered(self):
-        """each item in a stream has to provide a regular interface."""
-        files = self.get_versionedfiles()
-        self.get_diamond_files(files)
-        keys, sort_order = self.get_keys_and_sort_order()
-        parent_map = files.get_parent_map(keys)
-        entries = files.get_record_stream(keys, 'topological', False)
-        seen = []
-        self.capture_stream(files, entries, seen.append, parent_map)
-        self.assertStreamOrder(sort_order, seen, keys)
-
-    def test_get_record_stream_interface_ordered_with_delta_closure(self):
-        """each item must be accessible as a fulltext."""
-        files = self.get_versionedfiles()
-        self.get_diamond_files(files)
-        keys, sort_order = self.get_keys_and_sort_order()
-        parent_map = files.get_parent_map(keys)
-        entries = files.get_record_stream(keys, 'topological', True)
-        seen = []
-        for factory in entries:
-            seen.append(factory.key)
-            self.assertValidStorageKind(factory.storage_kind)
-            self.assertSubset([factory.sha1],
-                [None, files.get_sha1s([factory.key])[factory.key]])
-            self.assertEqual(parent_map[factory.key], factory.parents)
-            # self.assertEqual(files.get_text(factory.key),
-            self.assertIsInstance(factory.get_bytes_as('fulltext'), str)
-            self.assertIsInstance(factory.get_bytes_as(factory.storage_kind),
-                str)
-        self.assertStreamOrder(sort_order, seen, keys)
-
-    def assertStreamOrder(self, sort_order, seen, keys):
-        self.assertEqual(len(set(seen)), len(keys))
-        if self.key_length == 1:
-            lows = {():0}
-        else:
-            lows = {('FileA',):0, ('FileB',):0}
-        if not self.graph:
-            self.assertEqual(set(keys), set(seen))
-        else:
-            for key in seen:
-                sort_pos = sort_order[key]
-                self.assertTrue(sort_pos >= lows[key[:-1]],
-                    "Out of order in sorted stream: %r, %r" % (key, seen))
-                lows[key[:-1]] = sort_pos
-
-    def test_get_record_stream_unknown_storage_kind_raises(self):
-        """Asking for a storage kind that the stream cannot supply raises."""
-        files = self.get_versionedfiles()
-        self.get_diamond_files(files)
-        if self.key_length == 1:
-            keys = [('merged',), ('left',), ('right',), ('base',)]
-        else:
-            keys = [
-                ('FileA', 'merged'), ('FileA', 'left'), ('FileA', 'right'),
-                ('FileA', 'base'),
-                ('FileB', 'merged'), ('FileB', 'left'), ('FileB', 'right'),
-                ('FileB', 'base'),
-                ]
-        parent_map = files.get_parent_map(keys)
-        entries = files.get_record_stream(keys, 'unordered', False)
-        # We track the contents because we should be able to try, fail a
-        # particular kind and then ask for one that works and continue.
-        seen = set()
-        for factory in entries:
-            seen.add(factory.key)
-            self.assertValidStorageKind(factory.storage_kind)
-            self.assertEqual(files.get_sha1s([factory.key])[factory.key],
-                factory.sha1)
-            self.assertEqual(parent_map[factory.key], factory.parents)
-            # currently no stream emits mpdiff
-            self.assertRaises(errors.UnavailableRepresentation,
-                factory.get_bytes_as, 'mpdiff')
-            self.assertIsInstance(factory.get_bytes_as(factory.storage_kind),
-                str)
-        self.assertEqual(set(keys), seen)
-
-    def test_get_record_stream_missing_records_are_absent(self):
-        files = self.get_versionedfiles()
-        self.get_diamond_files(files)
-        if self.key_length == 1:
-            keys = [('merged',), ('left',), ('right',), ('absent',), ('base',)]
-        else:
-            keys = [
-                ('FileA', 'merged'), ('FileA', 'left'), ('FileA', 'right'),
-                ('FileA', 'absent'), ('FileA', 'base'),
-                ('FileB', 'merged'), ('FileB', 'left'), ('FileB', 'right'),
-                ('FileB', 'absent'), ('FileB', 'base'),
-                ('absent', 'absent'),
-                ]
-        parent_map = files.get_parent_map(keys)
-        entries = files.get_record_stream(keys, 'unordered', False)
-        self.assertAbsentRecord(files, keys, parent_map, entries)
-        entries = files.get_record_stream(keys, 'topological', False)
-        self.assertAbsentRecord(files, keys, parent_map, entries)
-
-    def assertAbsentRecord(self, files, keys, parents, entries):
-        """Helper for test_get_record_stream_missing_records_are_absent."""
-        seen = set()
-        for factory in entries:
-            seen.add(factory.key)
-            if factory.key[-1] == 'absent':
-                self.assertEqual('absent', factory.storage_kind)
-                self.assertEqual(None, factory.sha1)
-                self.assertEqual(None, factory.parents)
-            else:
-                self.assertValidStorageKind(factory.storage_kind)
-                self.assertEqual(files.get_sha1s([factory.key])[factory.key],
-                    factory.sha1)
-                self.assertEqual(parents[factory.key], factory.parents)
-                self.assertIsInstance(factory.get_bytes_as(factory.storage_kind),
-                    str)
-        self.assertEqual(set(keys), seen)
-
-    def test_filter_absent_records(self):
-        """Requested missing records can be filter trivially."""
-        files = self.get_versionedfiles()
-        self.get_diamond_files(files)
-        keys, _ = self.get_keys_and_sort_order()
-        parent_map = files.get_parent_map(keys)
-        # Add an absent record in the middle of the present keys. (We don't ask
-        # for just absent keys to ensure that content before and after the
-        # absent keys is still delivered).
-        present_keys = list(keys)
-        if self.key_length == 1:
-            keys.insert(2, ('extra',))
-        else:
-            keys.insert(2, ('extra', 'extra'))
-        entries = files.get_record_stream(keys, 'unordered', False)
-        seen = set()
-        self.capture_stream(files, versionedfile.filter_absent(entries), seen.add,
-            parent_map)
-        self.assertEqual(set(present_keys), seen)
-
-    def get_mapper(self):
-        """Get a mapper suitable for the key length of the test interface."""
-        if self.key_length == 1:
-            return ConstantMapper('source')
-        else:
-            return HashEscapedPrefixMapper()
-
-    def get_parents(self, parents):
-        """Get parents, taking self.graph into consideration."""
-        if self.graph:
-            return parents
-        else:
-            return None
-
-    def test_get_parent_map(self):
-        files = self.get_versionedfiles()
-        if self.key_length == 1:
-            parent_details = [
-                (('r0',), self.get_parents(())),
-                (('r1',), self.get_parents((('r0',),))),
-                (('r2',), self.get_parents(())),
-                (('r3',), self.get_parents(())),
-                (('m',), self.get_parents((('r0',),('r1',),('r2',),('r3',)))),
-                ]
-        else:
-            parent_details = [
-                (('FileA', 'r0'), self.get_parents(())),
-                (('FileA', 'r1'), self.get_parents((('FileA', 'r0'),))),
-                (('FileA', 'r2'), self.get_parents(())),
-                (('FileA', 'r3'), self.get_parents(())),
-                (('FileA', 'm'), self.get_parents((('FileA', 'r0'),
-                    ('FileA', 'r1'), ('FileA', 'r2'), ('FileA', 'r3')))),
-                ]
-        for key, parents in parent_details:
-            files.add_lines(key, parents, [])
-            # immediately after adding it should be queryable.
-            self.assertEqual({key:parents}, files.get_parent_map([key]))
-        # We can ask for an empty set
-        self.assertEqual({}, files.get_parent_map([]))
-        # We can ask for many keys
-        all_parents = dict(parent_details)
-        self.assertEqual(all_parents, files.get_parent_map(all_parents.keys()))
-        # Absent keys are just not included in the result.
-        keys = all_parents.keys()
-        if self.key_length == 1:
-            keys.insert(1, ('missing',))
-        else:
-            keys.insert(1, ('missing', 'missing'))
-        # Absent keys are just ignored
-        self.assertEqual(all_parents, files.get_parent_map(keys))
-
-    def test_get_sha1s(self):
-        files = self.get_versionedfiles()
-        self.get_diamond_files(files)
-        if self.key_length == 1:
-            keys = [('base',), ('origin',), ('left',), ('merged',), ('right',)]
-        else:
-            # ask for shas from different prefixes.
-            keys = [
-                ('FileA', 'base'), ('FileB', 'origin'), ('FileA', 'left'),
-                ('FileA', 'merged'), ('FileB', 'right'),
-                ]
-        self.assertEqual({
-            keys[0]: '51c64a6f4fc375daf0d24aafbabe4d91b6f4bb44',
-            keys[1]: '00e364d235126be43292ab09cb4686cf703ddc17',
-            keys[2]: 'a8478686da38e370e32e42e8a0c220e33ee9132f',
-            keys[3]: 'ed8bce375198ea62444dc71952b22cfc2b09226d',
-            keys[4]: '9ef09dfa9d86780bdec9219a22560c6ece8e0ef1',
-            },
-            files.get_sha1s(keys))
-        
-    def test_insert_record_stream_empty(self):
-        """Inserting an empty record stream should work."""
-        files = self.get_versionedfiles()
-        files.insert_record_stream([])
-
-    def assertIdenticalVersionedFile(self, expected, actual):
-        """Assert that left and right have the same contents."""
-        self.assertEqual(set(actual.keys()), set(expected.keys()))
-        actual_parents = actual.get_parent_map(actual.keys())
-        if self.graph:
-            self.assertEqual(actual_parents, expected.get_parent_map(expected.keys()))
-        else:
-            for key, parents in actual_parents.items():
-                self.assertEqual(None, parents)
-        for key in actual.keys():
-            actual_text = actual.get_record_stream(
-                [key], 'unordered', True).next().get_bytes_as('fulltext')
-            expected_text = expected.get_record_stream(
-                [key], 'unordered', True).next().get_bytes_as('fulltext')
-            self.assertEqual(actual_text, expected_text)
-
-    def test_insert_record_stream_fulltexts(self):
-        """Any file should accept a stream of fulltexts."""
-        files = self.get_versionedfiles()
-        mapper = self.get_mapper()
-        source_transport = self.get_transport('source')
-        source_transport.mkdir('.')
-        # weaves always output fulltexts.
-        source = make_versioned_files_factory(WeaveFile, mapper)(
-            source_transport)
-        self.get_diamond_files(source, trailing_eol=False)
-        stream = source.get_record_stream(source.keys(), 'topological',
-            False)
-        files.insert_record_stream(stream)
-        self.assertIdenticalVersionedFile(source, files)
-
-    def test_insert_record_stream_fulltexts_noeol(self):
-        """Any file should accept a stream of fulltexts."""
-        files = self.get_versionedfiles()
-        mapper = self.get_mapper()
-        source_transport = self.get_transport('source')
-        source_transport.mkdir('.')
-        # weaves always output fulltexts.
-        source = make_versioned_files_factory(WeaveFile, mapper)(
-            source_transport)
-        self.get_diamond_files(source, trailing_eol=False)
-        stream = source.get_record_stream(source.keys(), 'topological',
-            False)
-        files.insert_record_stream(stream)
-        self.assertIdenticalVersionedFile(source, files)
-
-    def test_insert_record_stream_annotated_knits(self):
-        """Any file should accept a stream from plain knits."""
-        files = self.get_versionedfiles()
-        mapper = self.get_mapper()
-        source_transport = self.get_transport('source')
-        source_transport.mkdir('.')
-        source = make_file_factory(True, mapper)(source_transport)
-        self.get_diamond_files(source)
-        stream = source.get_record_stream(source.keys(), 'topological',
-            False)
-        files.insert_record_stream(stream)
-        self.assertIdenticalVersionedFile(source, files)
-
-    def test_insert_record_stream_annotated_knits_noeol(self):
-        """Any file should accept a stream from plain knits."""
-        files = self.get_versionedfiles()
-        mapper = self.get_mapper()
-        source_transport = self.get_transport('source')
-        source_transport.mkdir('.')
-        source = make_file_factory(True, mapper)(source_transport)
-        self.get_diamond_files(source, trailing_eol=False)
-        stream = source.get_record_stream(source.keys(), 'topological',
-            False)
-        files.insert_record_stream(stream)
-        self.assertIdenticalVersionedFile(source, files)
-
-    def test_insert_record_stream_plain_knits(self):
-        """Any file should accept a stream from plain knits."""
-        files = self.get_versionedfiles()
-        mapper = self.get_mapper()
-        source_transport = self.get_transport('source')
-        source_transport.mkdir('.')
-        source = make_file_factory(False, mapper)(source_transport)
-        self.get_diamond_files(source)
-        stream = source.get_record_stream(source.keys(), 'topological',
-            False)
-        files.insert_record_stream(stream)
-        self.assertIdenticalVersionedFile(source, files)
-
-    def test_insert_record_stream_plain_knits_noeol(self):
-        """Any file should accept a stream from plain knits."""
-        files = self.get_versionedfiles()
-        mapper = self.get_mapper()
-        source_transport = self.get_transport('source')
-        source_transport.mkdir('.')
-        source = make_file_factory(False, mapper)(source_transport)
-        self.get_diamond_files(source, trailing_eol=False)
-        stream = source.get_record_stream(source.keys(), 'topological',
-            False)
-        files.insert_record_stream(stream)
-        self.assertIdenticalVersionedFile(source, files)
-
-    def test_insert_record_stream_existing_keys(self):
-        """Inserting keys already in a file should not error."""
-        files = self.get_versionedfiles()
-        source = self.get_versionedfiles('source')
-        self.get_diamond_files(source)
-        # insert some keys into f.
-        self.get_diamond_files(files, left_only=True)
-        stream = source.get_record_stream(source.keys(), 'topological',
-            False)
-        files.insert_record_stream(stream)
-        self.assertIdenticalVersionedFile(source, files)
-
-    def test_insert_record_stream_missing_keys(self):
-        """Inserting a stream with absent keys should raise an error."""
-        files = self.get_versionedfiles()
-        source = self.get_versionedfiles('source')
-        stream = source.get_record_stream([('missing',) * self.key_length],
-            'topological', False)
-        self.assertRaises(errors.RevisionNotPresent, files.insert_record_stream,
-            stream)
-
-    def test_insert_record_stream_out_of_order(self):
-        """An out of order stream can either error or work."""
-        files = self.get_versionedfiles()
-        source = self.get_versionedfiles('source')
-        self.get_diamond_files(source)
-        if self.key_length == 1:
-            origin_keys = [('origin',)]
-            end_keys = [('merged',), ('left',)]
-            start_keys = [('right',), ('base',)]
-        else:
-            origin_keys = [('FileA', 'origin'), ('FileB', 'origin')]
-            end_keys = [('FileA', 'merged',), ('FileA', 'left',),
-                ('FileB', 'merged',), ('FileB', 'left',)]
-            start_keys = [('FileA', 'right',), ('FileA', 'base',),
-                ('FileB', 'right',), ('FileB', 'base',)]
-        origin_entries = source.get_record_stream(origin_keys, 'unordered', False)
-        end_entries = source.get_record_stream(end_keys, 'topological', False)
-        start_entries = source.get_record_stream(start_keys, 'topological', False)
-        entries = chain(origin_entries, end_entries, start_entries)
-        try:
-            files.insert_record_stream(entries)
-        except RevisionNotPresent:
-            # Must not have corrupted the file.
-            files.check()
-        else:
-            self.assertIdenticalVersionedFile(source, files)
-
-    def test_insert_record_stream_delta_missing_basis_no_corruption(self):
-        """Insertion where a needed basis is not included aborts safely."""
-        # We use a knit always here to be sure we are getting a binary delta.
-        mapper = self.get_mapper()
-        source_transport = self.get_transport('source')
-        source_transport.mkdir('.')
-        source = make_file_factory(False, mapper)(source_transport)
-        self.get_diamond_files(source)
-        entries = source.get_record_stream(['origin', 'merged'], 'unordered', False)
-        files = self.get_versionedfiles()
-        self.assertRaises(RevisionNotPresent, files.insert_record_stream,
-            entries)
-        files.check()
-        self.assertEqual({}, files.get_parent_map([]))
-
-    def test_iter_lines_added_or_present_in_keys(self):
-        # test that we get at least an equalset of the lines added by
-        # versions in the store.
-        # the ordering here is to make a tree so that dumb searches have
-        # more changes to muck up.
-
-        class InstrumentedProgress(progress.DummyProgress):
-
-            def __init__(self):
-
-                progress.DummyProgress.__init__(self)
-                self.updates = []
-
-            def update(self, msg=None, current=None, total=None):
-                self.updates.append((msg, current, total))
-
-        files = self.get_versionedfiles()
-        # add a base to get included
-        files.add_lines(self.get_simple_key('base'), (), ['base\n'])
-        # add a ancestor to be included on one side
-        files.add_lines(self.get_simple_key('lancestor'), (), ['lancestor\n'])
-        # add a ancestor to be included on the other side
-        files.add_lines(self.get_simple_key('rancestor'),
-            self.get_parents([self.get_simple_key('base')]), ['rancestor\n'])
-        # add a child of rancestor with no eofile-nl
-        files.add_lines(self.get_simple_key('child'),
-            self.get_parents([self.get_simple_key('rancestor')]),
-            ['base\n', 'child\n'])
-        # add a child of lancestor and base to join the two roots
-        files.add_lines(self.get_simple_key('otherchild'),
-            self.get_parents([self.get_simple_key('lancestor'),
-                self.get_simple_key('base')]),
-            ['base\n', 'lancestor\n', 'otherchild\n'])
-        def iter_with_keys(keys, expected):
-            # now we need to see what lines are returned, and how often.
-            lines = {}
-            progress = InstrumentedProgress()
-            # iterate over the lines
-            for line in files.iter_lines_added_or_present_in_keys(keys,
-                pb=progress):
-                lines.setdefault(line, 0)
-                lines[line] += 1
-            if []!= progress.updates:
-                self.assertEqual(expected, progress.updates)
-            return lines
-        lines = iter_with_keys(
-            [self.get_simple_key('child'), self.get_simple_key('otherchild')],
-            [('Walking content.', 0, 2),
-             ('Walking content.', 1, 2),
-             ('Walking content.', 2, 2)])
-        # we must see child and otherchild
-        self.assertTrue(lines[('child\n', self.get_simple_key('child'))] > 0)
-        self.assertTrue(
-            lines[('otherchild\n', self.get_simple_key('otherchild'))] > 0)
-        # we dont care if we got more than that.
-        
-        # test all lines
-        lines = iter_with_keys(files.keys(),
-            [('Walking content.', 0, 5),
-             ('Walking content.', 1, 5),
-             ('Walking content.', 2, 5),
-             ('Walking content.', 3, 5),
-             ('Walking content.', 4, 5),
-             ('Walking content.', 5, 5)])
-        # all lines must be seen at least once
-        self.assertTrue(lines[('base\n', self.get_simple_key('base'))] > 0)
-        self.assertTrue(
-            lines[('lancestor\n', self.get_simple_key('lancestor'))] > 0)
-        self.assertTrue(
-            lines[('rancestor\n', self.get_simple_key('rancestor'))] > 0)
-        self.assertTrue(lines[('child\n', self.get_simple_key('child'))] > 0)
-        self.assertTrue(
-            lines[('otherchild\n', self.get_simple_key('otherchild'))] > 0)
-
-    def test_make_mpdiffs(self):
-        from bzrlib import multiparent
-        files = self.get_versionedfiles('source')
-        # add texts that should trip the knit maximum delta chain threshold
-        # as well as doing parallel chains of data in knits.
-        # this is done by two chains of 25 insertions
-        files.add_lines(self.get_simple_key('base'), [], ['line\n'])
-        files.add_lines(self.get_simple_key('noeol'),
-            self.get_parents([self.get_simple_key('base')]), ['line'])
-        # detailed eol tests:
-        # shared last line with parent no-eol
-        files.add_lines(self.get_simple_key('noeolsecond'),
-            self.get_parents([self.get_simple_key('noeol')]),
-                ['line\n', 'line'])
-        # differing last line with parent, both no-eol
-        files.add_lines(self.get_simple_key('noeolnotshared'),
-            self.get_parents([self.get_simple_key('noeolsecond')]),
-                ['line\n', 'phone'])
-        # add eol following a noneol parent, change content
-        files.add_lines(self.get_simple_key('eol'),
-            self.get_parents([self.get_simple_key('noeol')]), ['phone\n'])
-        # add eol following a noneol parent, no change content
-        files.add_lines(self.get_simple_key('eolline'),
-            self.get_parents([self.get_simple_key('noeol')]), ['line\n'])
-        # noeol with no parents:
-        files.add_lines(self.get_simple_key('noeolbase'), [], ['line'])
-        # noeol preceeding its leftmost parent in the output:
-        # this is done by making it a merge of two parents with no common
-        # anestry: noeolbase and noeol with the 
-        # later-inserted parent the leftmost.
-        files.add_lines(self.get_simple_key('eolbeforefirstparent'),
-            self.get_parents([self.get_simple_key('noeolbase'),
-                self.get_simple_key('noeol')]),
-            ['line'])
-        # two identical eol texts
-        files.add_lines(self.get_simple_key('noeoldup'),
-            self.get_parents([self.get_simple_key('noeol')]), ['line'])
-        next_parent = self.get_simple_key('base')
-        text_name = 'chain1-'
-        text = ['line\n']
-        sha1s = {0 :'da6d3141cb4a5e6f464bf6e0518042ddc7bfd079',
-                 1 :'45e21ea146a81ea44a821737acdb4f9791c8abe7',
-                 2 :'e1f11570edf3e2a070052366c582837a4fe4e9fa',
-                 3 :'26b4b8626da827088c514b8f9bbe4ebf181edda1',
-                 4 :'e28a5510be25ba84d31121cff00956f9970ae6f6',
-                 5 :'d63ec0ce22e11dcf65a931b69255d3ac747a318d',
-                 6 :'2c2888d288cb5e1d98009d822fedfe6019c6a4ea',
-                 7 :'95c14da9cafbf828e3e74a6f016d87926ba234ab',
-                 8 :'779e9a0b28f9f832528d4b21e17e168c67697272',
-                 9 :'1f8ff4e5c6ff78ac106fcfe6b1e8cb8740ff9a8f',
-                 10:'131a2ae712cf51ed62f143e3fbac3d4206c25a05',
-                 11:'c5a9d6f520d2515e1ec401a8f8a67e6c3c89f199',
-                 12:'31a2286267f24d8bedaa43355f8ad7129509ea85',
-                 13:'dc2a7fe80e8ec5cae920973973a8ee28b2da5e0a',
-                 14:'2c4b1736566b8ca6051e668de68650686a3922f2',
-                 15:'5912e4ecd9b0c07be4d013e7e2bdcf9323276cde',
-                 16:'b0d2e18d3559a00580f6b49804c23fea500feab3',
-                 17:'8e1d43ad72f7562d7cb8f57ee584e20eb1a69fc7',
-                 18:'5cf64a3459ae28efa60239e44b20312d25b253f3',
-                 19:'1ebed371807ba5935958ad0884595126e8c4e823',
-                 20:'2aa62a8b06fb3b3b892a3292a068ade69d5ee0d3',
-                 21:'01edc447978004f6e4e962b417a4ae1955b6fe5d',
-                 22:'d8d8dc49c4bf0bab401e0298bb5ad827768618bb',
-                 23:'c21f62b1c482862983a8ffb2b0c64b3451876e3f',
-                 24:'c0593fe795e00dff6b3c0fe857a074364d5f04fc',
-                 25:'dd1a1cf2ba9cc225c3aff729953e6364bf1d1855',
-                 }
-        for depth in range(26):
-            new_version = self.get_simple_key(text_name + '%s' % depth)
-            text = text + ['line\n']
-            files.add_lines(new_version, self.get_parents([next_parent]), text)
-            next_parent = new_version
-        next_parent = self.get_simple_key('base')
-        text_name = 'chain2-'
-        text = ['line\n']
-        for depth in range(26):
-            new_version = self.get_simple_key(text_name + '%s' % depth)
-            text = text + ['line\n']
-            files.add_lines(new_version, self.get_parents([next_parent]), text)
-            next_parent = new_version
-        target = self.get_versionedfiles('target')
-        for key in multiparent.topo_iter_keys(files, files.keys()):
-            mpdiff = files.make_mpdiffs([key])[0]
-            parents = files.get_parent_map([key])[key] or []
-            target.add_mpdiffs(
-                [(key, parents, files.get_sha1s([key])[key], mpdiff)])
-            self.assertEqualDiff(
-                files.get_record_stream([key], 'unordered',
-                    True).next().get_bytes_as('fulltext'),
-                target.get_record_stream([key], 'unordered',
-                    True).next().get_bytes_as('fulltext')
-                )
-
-    def test_keys(self):
-        # While use is discouraged, versions() is still needed by aspects of
-        # bzr.
-        files = self.get_versionedfiles()
-        self.assertEqual(set(), set(files.keys()))
-        if self.key_length == 1:
-            key = ('foo',)
-        else:
-            key = ('foo', 'bar',)
-        files.add_lines(key, (), [])
-        self.assertEqual(set([key]), set(files.keys()))
-
-
-class VirtualVersionedFilesTests(TestCase):
-    """Basic tests for the VirtualVersionedFiles implementations."""
-
-    def _get_parent_map(self, keys):
-        ret = {}
-        for k in keys:
-            if k in self._parent_map:
-                ret[k] = self._parent_map[k]
-        return ret
-
-    def setUp(self):
-        TestCase.setUp(self)
-        self._lines = {}
-        self._parent_map = {}
-        self.texts = VirtualVersionedFiles(self._get_parent_map, 
-                                           self._lines.get)
-
-    def test_add_lines(self):
-        self.assertRaises(NotImplementedError, 
-                self.texts.add_lines, "foo", [], [])
-
-    def test_add_mpdiffs(self):
-        self.assertRaises(NotImplementedError, 
-                self.texts.add_mpdiffs, [])
-
-    def test_check(self):
-        self.assertTrue(self.texts.check())
-
-    def test_insert_record_stream(self):
-        self.assertRaises(NotImplementedError, self.texts.insert_record_stream,
-                          [])
-
-    def test_get_sha1s_nonexistent(self):
-        self.assertEquals({}, self.texts.get_sha1s([("NONEXISTENT",)]))
-
-    def test_get_sha1s(self):
-        self._lines["key"] = ["dataline1", "dataline2"]
-        self.assertEquals({("key",): osutils.sha_strings(self._lines["key"])},
-                           self.texts.get_sha1s([("key",)]))
-
-    def test_get_parent_map(self):
-        self._parent_map = {"G": ("A", "B")}
-        self.assertEquals({("G",): (("A",),("B",))}, 
-                          self.texts.get_parent_map([("G",), ("L",)]))
-
-    def test_get_record_stream(self):
-        self._lines["A"] = ["FOO", "BAR"]
-        it = self.texts.get_record_stream([("A",)], "unordered", True)
-        record = it.next()
-        self.assertEquals("fulltext", record.storage_kind)
-        self.assertEquals("FOOBAR", record.get_bytes_as("fulltext"))
-
-    def test_get_record_stream_absent(self):
-        it = self.texts.get_record_stream([("A",)], "unordered", True)
-        record = it.next()
-        self.assertEquals("absent", record.storage_kind)
+class TestFormatSignatures(TestCaseWithMemoryTransport):
+
+    def get_knit_file(self, name, annotated):
+        if annotated:
+            factory = KnitAnnotateFactory()
+        else:
+            factory = KnitPlainFactory()
+        return KnitVersionedFile(
+            name, get_transport(self.get_url('.')), create=True,
+            factory=factory)
+
+    def test_knit_format_signatures(self):
+        """Different formats of knit have different signature strings."""
+        knit = self.get_knit_file('a', True)
+        self.assertEqual('knit-annotated', knit.get_format_signature())
+        knit = self.get_knit_file('p', False)
+        self.assertEqual('knit-plain', knit.get_format_signature())
 

=== modified file 'bzrlib/tests/test_weave.py'
--- bzrlib/tests/test_weave.py	2008-07-09 21:42:24 +0000
+++ bzrlib/tests/test_weave.py	2007-09-19 05:14:14 +0000
@@ -65,7 +65,7 @@
 class WeaveContains(TestBase):
     """Weave __contains__ operator"""
     def runTest(self):
-        k = Weave(get_scope=lambda:None)
+        k = Weave()
         self.assertFalse('foo' in k)
         k.add_lines('foo', [], TEXT_1)
         self.assertTrue('foo' in k)
@@ -84,6 +84,18 @@
                          [('text0', TEXT_0[0])])
 
 
+class GetSha1(TestBase):
+    def test_get_sha1(self):
+        k = Weave()
+        k.add_lines('text0', [], 'text0')
+        self.assertEqual('34dc0e430c642a26c3dd1c2beb7a8b4f4445eb79',
+                         k.get_sha1('text0'))
+        self.assertRaises(errors.RevisionNotPresent,
+                          k.get_sha1, 0)
+        self.assertRaises(errors.RevisionNotPresent,
+                          k.get_sha1, 'text1')
+                        
+
 class InvalidAdd(TestBase):
     """Try to use invalid version number during add."""
     def runTest(self):
@@ -657,6 +669,66 @@
         self.weave1.add_lines('v1', [], self.lines1)
         self.weave1.add_lines('v2', ['v1'], ['hello\n', 'world\n'])
         self.weave1.add_lines('v3', ['v2'], self.lines3)
+        
+    def test_join_empty(self):
+        """Join two empty weaves."""
+        eq = self.assertEqual
+        w1 = Weave()
+        w2 = Weave()
+        w1.join(w2)
+        eq(len(w1), 0)
+        
+    def test_join_empty_to_nonempty(self):
+        """Join empty weave onto nonempty."""
+        self.weave1.join(Weave())
+        self.assertEqual(len(self.weave1), 3)
+
+    def test_join_unrelated(self):
+        """Join two weaves with no history in common."""
+        wb = Weave()
+        wb.add_lines('b1', [], ['line from b\n'])
+        w1 = self.weave1
+        w1.join(wb)
+        eq = self.assertEqual
+        eq(len(w1), 4)
+        eq(sorted(w1.versions()),
+           ['b1', 'v1', 'v2', 'v3'])
+
+    def test_join_related(self):
+        wa = self.weave1.copy()
+        wb = self.weave1.copy()
+        wa.add_lines('a1', ['v3'], ['hello\n', 'sweet\n', 'world\n'])
+        wb.add_lines('b1', ['v3'], ['hello\n', 'pale blue\n', 'world\n'])
+        eq = self.assertEquals
+        eq(len(wa), 4)
+        eq(len(wb), 4)
+        wa.join(wb)
+        eq(len(wa), 5)
+        eq(wa.get_lines('b1'),
+           ['hello\n', 'pale blue\n', 'world\n'])
+
+    def test_join_text_disagreement(self):
+        """Cannot join weaves with different texts for a version."""
+        wa = Weave()
+        wb = Weave()
+        wa.add_lines('v1', [], ['hello\n'])
+        wb.add_lines('v1', [], ['not\n', 'hello\n'])
+        self.assertRaises(WeaveError,
+                          wa.join, wb)
+
+    def test_join_unordered(self):
+        """Join weaves where indexes differ.
+        
+        The source weave contains a different version at index 0."""
+        wa = self.weave1.copy()
+        wb = Weave()
+        wb.add_lines('x1', [], ['line from x1\n'])
+        wb.add_lines('v1', [], ['hello\n'])
+        wb.add_lines('v2', ['v1'], ['hello\n', 'world\n'])
+        wa.join(wb)
+        eq = self.assertEquals
+        eq(sorted(wa.versions()), ['v1', 'v2', 'v3', 'x1',])
+        eq(wa.get_text('x1'), 'line from x1\n')
 
     def test_written_detection(self):
         # Test detection of weave file corruption.
@@ -707,21 +779,6 @@
         self.assertRaises(errors.WeaveInvalidChecksum, w.check)
 
 
-class TestWeave(TestCase):
-
-    def test_allow_reserved_false(self):
-        w = Weave('name', allow_reserved=False)
-        # Add lines is checked at the WeaveFile level, not at the Weave level
-        w.add_lines('name:', [], TEXT_1)
-        # But get_lines is checked at this level
-        self.assertRaises(errors.ReservedId, w.get_lines, 'name:')
-
-    def test_allow_reserved_true(self):
-        w = Weave('name', allow_reserved=True)
-        w.add_lines('name:', [], TEXT_1)
-        self.assertEqual(TEXT_1, w.get_lines('name:'))
-
-
 class InstrumentedWeave(Weave):
     """Keep track of how many times functions are called."""
     
@@ -734,6 +791,57 @@
         return Weave._extract(self, versions)
 
 
+class JoinOptimization(TestCase):
+    """Test that Weave.join() doesn't extract all texts, only what must be done."""
+
+    def test_join(self):
+        w1 = InstrumentedWeave()
+        w2 = InstrumentedWeave()
+
+        txt0 = ['a\n']
+        txt1 = ['a\n', 'b\n']
+        txt2 = ['a\n', 'c\n']
+        txt3 = ['a\n', 'b\n', 'c\n']
+
+        w1.add_lines('txt0', [], txt0) # extract 1a
+        w2.add_lines('txt0', [], txt0) # extract 1b
+        w1.add_lines('txt1', ['txt0'], txt1)# extract 2a
+        w2.add_lines('txt2', ['txt0'], txt2)# extract 2b
+        w1.join(w2) # extract 3a to add txt2 
+        w2.join(w1) # extract 3b to add txt1 
+
+        w1.add_lines('txt3', ['txt1', 'txt2'], txt3) # extract 4a 
+        w2.add_lines('txt3', ['txt2', 'txt1'], txt3) # extract 4b
+        # These secretly have inverted parents
+
+        # This should not have to do any extractions
+        w1.join(w2) # NO extract, texts already present with same parents
+        w2.join(w1) # NO extract, texts already present with same parents
+
+        self.assertEqual(4, w1._extract_count)
+        self.assertEqual(4, w2._extract_count)
+
+    def test_double_parent(self):
+        # It should not be considered illegal to add
+        # a revision with the same parent twice
+        w1 = InstrumentedWeave()
+        w2 = InstrumentedWeave()
+
+        txt0 = ['a\n']
+        txt1 = ['a\n', 'b\n']
+        txt2 = ['a\n', 'c\n']
+        txt3 = ['a\n', 'b\n', 'c\n']
+
+        w1.add_lines('txt0', [], txt0)
+        w2.add_lines('txt0', [], txt0)
+        w1.add_lines('txt1', ['txt0'], txt1)
+        w2.add_lines('txt1', ['txt0', 'txt0'], txt1)
+        # Same text, effectively the same, because the
+        # parent is only repeated
+        w1.join(w2) # extract 3a to add txt2 
+        w2.join(w1) # extract 3b to add txt1 
+
+
 class TestNeedsReweave(TestCase):
     """Internal corner cases for when reweave is needed."""
 

=== modified file 'bzrlib/tests/test_whitebox.py'
--- bzrlib/tests/test_whitebox.py	2008-08-26 08:25:27 +0000
+++ bzrlib/tests/test_whitebox.py	2006-10-16 01:25:46 +0000
@@ -36,15 +36,15 @@
         if it is inside a branch and return the path relative to the base.
         """
         import tempfile
-
+        
         savedir = os.getcwdu()
-        dtmp = osutils.mkdtemp()
+        dtmp = tempfile.mkdtemp()
         # On Mac OSX, /tmp actually expands to /private/tmp
         dtmp = realpath(dtmp)
 
         def rp(p):
             return relpath(dtmp, p)
-
+        
         try:
             # check paths inside dtmp while standing outside it
             self.assertEqual(rp(pathjoin(dtmp, 'foo')), 'foo')

=== modified file 'bzrlib/tests/test_win32utils.py'
--- bzrlib/tests/test_win32utils.py	2007-12-29 22:05:47 +0000
+++ bzrlib/tests/test_win32utils.py	2007-08-11 05:59:59 +0000
@@ -154,7 +154,7 @@
         for a in ('iexplore', 'iexplore.exe'):
             p = get_app_path(a)
             d, b = os.path.split(p)
-            self.assertEquals('iexplore.exe', b.lower())
+            self.assertEquals('iexplore.exe', b)
             self.assertNotEquals('', d)
 
     def test_not_existing(self):

=== modified file 'bzrlib/tests/test_workingtree.py'
--- bzrlib/tests/test_workingtree.py	2008-05-12 04:07:49 +0000
+++ bzrlib/tests/test_workingtree.py	2007-10-17 17:03:06 +0000
@@ -28,6 +28,7 @@
 from bzrlib.bzrdir import BzrDir
 from bzrlib.lockdir import LockDir
 from bzrlib.mutabletree import needs_tree_write_lock
+from bzrlib.symbol_versioning import zero_thirteen
 from bzrlib.tests import TestCase, TestCaseWithTransport, TestSkipped
 from bzrlib.transport import get_transport
 from bzrlib.workingtree import (
@@ -93,8 +94,7 @@
         """See WorkingTreeFormat.get_format_string()."""
         return "Sample tree format."
 
-    def initialize(self, a_bzrdir, revision_id=None, from_branch=None,
-                   accelerator_tree=None, hardlink=False):
+    def initialize(self, a_bzrdir, revision_id=None):
         """Sample branches cannot be created."""
         t = a_bzrdir.get_workingtree_transport(self)
         t.put_bytes('format', self.get_format_string())
@@ -216,7 +216,7 @@
         control.create_repository()
         control.create_branch()
         tree = workingtree.WorkingTreeFormat3().initialize(control)
-        tree._transport.delete("pending-merges")
+        tree._control_files._transport.delete("pending-merges")
         self.assertEqual([], tree.get_parent_ids())
 
 
@@ -250,6 +250,19 @@
         self.assertEqual(list(tree.conflicts()), [expected])
 
 
+class TestNonFormatSpecificCode(TestCaseWithTransport):
+    """This class contains tests of workingtree that are not format specific."""
+
+    def test_gen_file_id(self):
+        file_id = self.applyDeprecated(zero_thirteen, workingtree.gen_file_id,
+                                      'filename')
+        self.assertStartsWith(file_id, 'filename-')
+
+    def test_gen_root_id(self):
+        file_id = self.applyDeprecated(zero_thirteen, workingtree.gen_root_id)
+        self.assertStartsWith(file_id, 'tree_root-')
+        
+
 class InstrumentedTree(object):
     """A instrumented tree to check the needs_tree_write_lock decorator."""
 
@@ -296,25 +309,6 @@
         self.assertEqual(['t', 'u', 't', 'u'], tree._locks)
 
 
-class TestRevert(TestCaseWithTransport):
-
-    def test_revert_conflicts_recursive(self):
-        this_tree = self.make_branch_and_tree('this-tree')
-        self.build_tree_contents([('this-tree/foo/',),
-                                  ('this-tree/foo/bar', 'bar')])
-        this_tree.add(['foo', 'foo/bar'])
-        this_tree.commit('created foo/bar')
-        other_tree = this_tree.bzrdir.sprout('other-tree').open_workingtree()
-        self.build_tree_contents([('other-tree/foo/bar', 'baz')])
-        other_tree.commit('changed bar')
-        self.build_tree_contents([('this-tree/foo/bar', 'qux')])
-        this_tree.commit('changed qux')
-        this_tree.merge_from_branch(other_tree.branch)
-        self.assertEqual(1, len(this_tree.conflicts()))
-        this_tree.revert(['foo'])
-        self.assertEqual(0, len(this_tree.conflicts()))
-
-
 class TestAutoResolve(TestCaseWithTransport):
 
     def test_auto_resolve(self):
@@ -362,15 +356,3 @@
         file_conflict = conflicts.TextConflict('file', None, 'hello-id')
         tree.set_conflicts(conflicts.ConflictList([file_conflict]))
         tree.auto_resolve()
-
-
-class TestFindTrees(TestCaseWithTransport):
-
-    def test_find_trees(self):
-        self.make_branch_and_tree('foo')
-        self.make_branch_and_tree('foo/bar')
-        # Sticking a tree inside a control dir is heinous, so let's skip it
-        self.make_branch_and_tree('foo/.bzr/baz')
-        self.make_branch('qux')
-        trees = workingtree.WorkingTree.find_trees('.')
-        self.assertEqual(2, len(list(trees)))

=== modified file 'bzrlib/tests/test_workingtree_4.py'
--- bzrlib/tests/test_workingtree_4.py	2008-07-08 14:55:19 +0000
+++ bzrlib/tests/test_workingtree_4.py	2007-09-17 05:33:56 +0000
@@ -115,19 +115,17 @@
         rev2 = subtree2.commit('commit in subdir2')
 
         subtree.flush()
-        subtree3 = subtree.bzrdir.sprout('subdir3').open_workingtree()
-        rev3 = subtree3.commit('merge from subdir2')
+        subtree.merge_from_branch(subtree2.branch)
+        rev3 = subtree.commit('merge from subdir2')
 
         repo = tree.branch.repository
-        repo.fetch(subtree.branch.repository, rev1)
-        repo.fetch(subtree2.branch.repository, rev2)
-        repo.fetch(subtree3.branch.repository, rev3)
+        repo.fetch(subtree.branch.repository, rev3)
         # will also pull the others...
 
         # create repository based revision trees
-        rev1_revtree = repo.revision_tree(rev1)
-        rev2_revtree = repo.revision_tree(rev2)
-        rev3_revtree = repo.revision_tree(rev3)
+        rev1_revtree = subtree.branch.repository.revision_tree(rev1)
+        rev2_revtree = subtree2.branch.repository.revision_tree(rev2)
+        rev3_revtree = subtree.branch.repository.revision_tree(rev3)
         # tree doesn't contain a text merge yet but we'll just
         # set the parents as if a merge had taken place. 
         # this should cause the tree data to be folded into the 
@@ -498,7 +496,7 @@
             (None, u'dir'),
             (None, 'directory'),
             (None, False))]
-        self.assertEqual(expected, list(tree.iter_changes(tree.basis_tree(),
+        self.assertEqual(expected, list(tree._iter_changes(tree.basis_tree(),
             specific_files=['dir'])))
         tree.unlock()
         # do a commit, we want to trigger the dirstate fast-path too
@@ -516,7 +514,7 @@
             ('dir', 'dir'),
             ('directory', None),
             (False, False))]
-        self.assertEqual(expected, list(tree.iter_changes(tree.basis_tree())))
+        self.assertEqual(expected, list(tree._iter_changes(tree.basis_tree())))
         tree.unlock()
 
     def test_with_subtree_supports_tree_references(self):
@@ -528,7 +526,7 @@
         # workingtree_4.
 
     def test_iter_changes_ignores_unversioned_dirs(self):
-        """iter_changes should not descend into unversioned directories."""
+        """_iter_changes should not descend into unversioned directories."""
         tree = self.make_branch_and_tree('.', format='dirstate')
         # We have an unversioned directory at the root, a versioned one with
         # other versioned files and an unversioned directory, and another
@@ -566,109 +564,13 @@
         basis.lock_read()
         self.addCleanup(basis.unlock)
         changes = [c[1] for c in
-                   tree.iter_changes(basis, want_unversioned=True)]
+                   tree._iter_changes(basis, want_unversioned=True)]
         self.assertEqual([(None, 'unversioned'),
                           (None, 'versioned/unversioned'),
                           (None, 'versioned2/unversioned'),
                          ], changes)
         self.assertEqual(['', 'versioned', 'versioned2'], returned)
         del returned[:] # reset
-        changes = [c[1] for c in tree.iter_changes(basis)]
+        changes = [c[1] for c in tree._iter_changes(basis)]
         self.assertEqual([], changes)
         self.assertEqual(['', 'versioned', 'versioned2'], returned)
-
-
-class TestCorruptDirstate(TestCaseWithTransport):
-    """Tests for how we handle when the dirstate has been corrupted."""
-
-    def create_wt4(self):
-        control = bzrdir.BzrDirMetaFormat1().initialize(self.get_url())
-        control.create_repository()
-        control.create_branch()
-        tree = workingtree_4.WorkingTreeFormat4().initialize(control)
-        return tree
-
-    def test_invalid_rename(self):
-        tree = self.create_wt4()
-        # Create a corrupted dirstate
-        tree.lock_write()
-        try:
-            tree.commit('init') # We need a parent, or we always compare with NULL
-            state = tree.current_dirstate()
-            state._read_dirblocks_if_needed()
-            # Now add in an invalid entry, a rename with a dangling pointer
-            state._dirblocks[1][1].append((('', 'foo', 'foo-id'),
-                                            [('f', '', 0, False, ''),
-                                             ('r', 'bar', 0 , False, '')]))
-            self.assertListRaises(errors.CorruptDirstate,
-                                  tree.iter_changes, tree.basis_tree())
-        finally:
-            tree.unlock()
-
-    def get_simple_dirblocks(self, state):
-        """Extract the simple information from the DirState.
-
-        This returns the dirblocks, only with the sha1sum and stat details
-        filtered out.
-        """
-        simple_blocks = []
-        for block in state._dirblocks:
-            simple_block = (block[0], [])
-            for entry in block[1]:
-                # Include the key for each entry, and for each parent include
-                # just the minikind, so we know if it was
-                # present/absent/renamed/etc
-                simple_block[1].append((entry[0], [i[0] for i in entry[1]]))
-            simple_blocks.append(simple_block)
-        return simple_blocks
-
-    def test_update_basis_with_invalid_delta(self):
-        """When given an invalid delta, it should abort, and not be saved."""
-        self.build_tree(['dir/', 'dir/file'])
-        tree = self.create_wt4()
-        tree.lock_write()
-        self.addCleanup(tree.unlock)
-        tree.add(['dir', 'dir/file'], ['dir-id', 'file-id'])
-        first_revision_id = tree.commit('init')
-
-        root_id = tree.path2id('')
-        state = tree.current_dirstate()
-        state._read_dirblocks_if_needed()
-        self.assertEqual([
-            ('', [(('', '', root_id), ['d', 'd'])]),
-            ('', [(('', 'dir', 'dir-id'), ['d', 'd'])]),
-            ('dir', [(('dir', 'file', 'file-id'), ['f', 'f'])]),
-        ],  self.get_simple_dirblocks(state))
-
-        tree.remove(['dir/file'])
-        self.assertEqual([
-            ('', [(('', '', root_id), ['d', 'd'])]),
-            ('', [(('', 'dir', 'dir-id'), ['d', 'd'])]),
-            ('dir', [(('dir', 'file', 'file-id'), ['a', 'f'])]),
-        ],  self.get_simple_dirblocks(state))
-        # Make sure the removal is written to disk
-        tree.flush()
-
-        # self.assertRaises(Exception, tree.update_basis_by_delta,
-        new_dir = inventory.InventoryDirectory('dir-id', 'new-dir', root_id)
-        new_dir.revision = 'new-revision-id'
-        new_file = inventory.InventoryFile('file-id', 'new-file', root_id)
-        new_file.revision = 'new-revision-id'
-        self.assertRaises(errors.InconsistentDelta,
-            tree.update_basis_by_delta, 'new-revision-id',
-            [('dir', 'new-dir', 'dir-id', new_dir),
-             ('dir/file', 'new-dir/new-file', 'file-id', new_file),
-            ])
-        del state
-
-        # Now when we re-read the file it should not have been modified
-        tree.unlock()
-        tree.lock_read()
-        self.assertEqual(first_revision_id, tree.last_revision())
-        state = tree.current_dirstate()
-        state._read_dirblocks_if_needed()
-        self.assertEqual([
-            ('', [(('', '', root_id), ['d', 'd'])]),
-            ('', [(('', 'dir', 'dir-id'), ['d', 'd'])]),
-            ('dir', [(('dir', 'file', 'file-id'), ['a', 'f'])]),
-        ],  self.get_simple_dirblocks(state))

=== modified file 'bzrlib/tests/test_wsgi.py'
--- bzrlib/tests/test_wsgi.py	2008-05-16 08:22:25 +0000
+++ bzrlib/tests/test_wsgi.py	2007-04-26 06:01:31 +0000
@@ -83,7 +83,7 @@
         self.assertEqual('405 Method not allowed', self.status)
         self.assertTrue(('Allow', 'POST') in self.headers)
         
-    def _fake_make_request(self, transport, write_func, bytes, rcp):
+    def _fake_make_request(self, transport, write_func, bytes):
         request = FakeRequest(transport, write_func)
         request.accept_bytes(bytes)
         self.request = request
@@ -106,7 +106,7 @@
         })
         iterable = wsgi_app(environ, self.start_response)
         response = self.read_response(iterable)
-        self.assertEqual([('clone', 'foo/bar/')] , transport.calls)
+        self.assertEqual([('clone', 'foo/bar')] , transport.calls)
 
     def test_smart_wsgi_app_request_and_response(self):
         # SmartWSGIApp reads the smart request from the 'wsgi.input' file-like
@@ -179,13 +179,13 @@
         backing_transport = app.app.backing_transport
         chroot_backing_transport = backing_transport.server.backing_transport
         self.assertEndsWith(chroot_backing_transport.base, 'a%20root/')
-        self.assertEqual(app.app.root_client_path, 'a prefix')
+        self.assertEqual(app.prefix, 'a prefix')
         self.assertEqual(app.path_var, 'a path_var')
 
     def test_incomplete_request(self):
         transport = FakeTransport()
         wsgi_app = wsgi.SmartWSGIApp(transport)
-        def make_request(transport, write_func, bytes, root_client_path):
+        def make_request(transport, write_func, bytes):
             request = IncompleteRequest(transport, write_func)
             request.accept_bytes(bytes)
             self.request = request

=== modified file 'bzrlib/tests/test_xml.py'
--- bzrlib/tests/test_xml.py	2008-04-15 04:29:44 +0000
+++ bzrlib/tests/test_xml.py	2007-10-19 17:14:33 +0000
@@ -20,7 +20,6 @@
     errors, 
     inventory, 
     xml7,
-    xml8,
     xml_serializer,
     )
 from bzrlib.tests import TestCase
@@ -148,24 +147,6 @@
 </inventory>
 """
 
-_expected_rev_v8 = """<revision committer="Martin Pool &lt;mbp@sourcefrog.net&gt;" format="8" inventory_sha1="e79c31c1deb64c163cf660fdedd476dd579ffd41" revision_id="mbp@sourcefrog.net-20050905080035-e0439293f8b6b9f9" timestamp="1125907235.212" timezone="36000">
-<message>- start splitting code for xml (de)serialization away from objects
-  preparatory to supporting multiple formats by a single library
-</message>
-<parents>
-<revision_ref revision_id="mbp@sourcefrog.net-20050905063503-43948f59fa127d92" />
-</parents>
-</revision>
-"""
-
-_expected_inv_v8 = """<inventory format="8" revision_id="rev_outer">
-<directory file_id="tree-root-321" name="" revision="rev_outer" />
-<directory file_id="dir-id" name="dir" parent_id="tree-root-321" revision="rev_outer" />
-<file file_id="file-id" name="file" parent_id="tree-root-321" revision="rev_outer" text_sha1="A" text_size="1" />
-<symlink file_id="link-id" name="link" parent_id="tree-root-321" revision="rev_outer" symlink_target="a" />
-</inventory>
-"""
-
 _revision_utf8_v5 = """<revision committer="Erik B&#229;gfors &lt;erik@foo.net&gt;"
     inventory_sha1="e79c31c1deb64c163cf660fdedd476dd579ffd41"
     revision_id="erik@b&#229;gfors-02"
@@ -349,8 +330,10 @@
         new_rev = s_v5.read_revision_from_string(txt)
         self.assertEqual(props, new_rev.properties)
 
-    def get_sample_inventory(self):
+    def test_roundtrip_inventory_v7(self):
         inv = Inventory('tree-root-321', revision_id='rev_outer')
+        inv.add(inventory.TreeReference('nested-id', 'nested', 'tree-root-321',
+                                        'rev_outer', 'rev_inner'))
         inv.add(inventory.InventoryFile('file-id', 'file', 'tree-root-321'))
         inv.add(inventory.InventoryDirectory('dir-id', 'dir', 
                                              'tree-root-321'))
@@ -362,12 +345,6 @@
         inv['file-id'].text_size = 1
         inv['link-id'].revision = 'rev_outer'
         inv['link-id'].symlink_target = 'a'
-        return inv
-
-    def test_roundtrip_inventory_v7(self):
-        inv = self.get_sample_inventory()
-        inv.add(inventory.TreeReference('nested-id', 'nested', 'tree-root-321',
-                                        'rev_outer', 'rev_inner'))
         txt = xml7.serializer_v7.write_inventory_to_string(inv)
         lines = xml7.serializer_v7.write_inventory_to_lines(inv)
         self.assertEqual(bzrlib.osutils.split_lines(txt), lines)
@@ -412,42 +389,6 @@
                           s_v5.read_inventory_from_string,
                           txt.replace('format="7"', 'format="5"'))
 
-    def test_roundtrip_inventory_v8(self):
-        inv = self.get_sample_inventory()
-        txt = xml8.serializer_v8.write_inventory_to_string(inv)
-        inv2 = xml8.serializer_v8.read_inventory_from_string(txt)
-        self.assertEqual(4, len(inv2))
-        for path, ie in inv.iter_entries():
-            self.assertEqual(ie, inv2[ie.file_id])
-
-    def test_inventory_text_v8(self):
-        inv = self.get_sample_inventory()
-        txt = xml8.serializer_v8.write_inventory_to_string(inv)
-        lines = xml8.serializer_v8.write_inventory_to_lines(inv)
-        self.assertEqual(bzrlib.osutils.split_lines(txt), lines)
-        self.assertEqualDiff(_expected_inv_v8, txt)
-
-    def test_revision_text_v6(self):
-        """Pack revision to XML v6"""
-        rev = bzrlib.xml6.serializer_v6.read_revision_from_string(
-            _expected_rev_v5)
-        serialized = bzrlib.xml6.serializer_v6.write_revision_to_string(rev)
-        self.assertEqualDiff(serialized, _expected_rev_v5)
-
-    def test_revision_text_v7(self):
-        """Pack revision to XML v7"""
-        rev = bzrlib.xml7.serializer_v7.read_revision_from_string(
-            _expected_rev_v5)
-        serialized = bzrlib.xml7.serializer_v7.write_revision_to_string(rev)
-        self.assertEqualDiff(serialized, _expected_rev_v5)
-
-    def test_revision_text_v8(self):
-        """Pack revision to XML v8"""
-        rev = bzrlib.xml8.serializer_v8.read_revision_from_string(
-            _expected_rev_v8)
-        serialized = bzrlib.xml8.serializer_v8.write_revision_to_string(rev)
-        self.assertEqualDiff(serialized, _expected_rev_v8)
-
     def test_revision_ids_are_utf8(self):
         """Parsed revision_ids should all be utf-8 strings, not unicode."""
         s_v5 = bzrlib.xml5.serializer_v5
@@ -501,8 +442,6 @@
                       xml_serializer.format_registry.get('6'))
         self.assertIs(bzrlib.xml7.serializer_v7,
                       xml_serializer.format_registry.get('7'))
-        self.assertIs(bzrlib.xml8.serializer_v8,
-                      xml_serializer.format_registry.get('8'))
 
 
 class TestEncodeAndEscape(TestCase):
@@ -510,31 +449,31 @@
 
     def setUp(self):
         # Keep the cache clear before and after the test
-        bzrlib.xml8._ensure_utf8_re()
-        bzrlib.xml8._clear_cache()
-        self.addCleanup(bzrlib.xml8._clear_cache)
+        bzrlib.xml5._ensure_utf8_re()
+        bzrlib.xml5._clear_cache()
+        self.addCleanup(bzrlib.xml5._clear_cache)
 
     def test_simple_ascii(self):
         # _encode_and_escape always appends a final ", because these parameters
         # are being used in xml attributes, and by returning it now, we have to
         # do fewer string operations later.
-        val = bzrlib.xml8._encode_and_escape('foo bar')
+        val = bzrlib.xml5._encode_and_escape('foo bar')
         self.assertEqual('foo bar"', val)
         # The second time should be cached
-        val2 = bzrlib.xml8._encode_and_escape('foo bar')
+        val2 = bzrlib.xml5._encode_and_escape('foo bar')
         self.assertIs(val2, val)
 
     def test_ascii_with_xml(self):
         self.assertEqual('&amp;&apos;&quot;&lt;&gt;"',
-                         bzrlib.xml8._encode_and_escape('&\'"<>'))
+                         bzrlib.xml5._encode_and_escape('&\'"<>'))
 
     def test_utf8_with_xml(self):
         # u'\xb5\xe5&\u062c'
         utf8_str = '\xc2\xb5\xc3\xa5&\xd8\xac'
         self.assertEqual('&#181;&#229;&amp;&#1580;"',
-                         bzrlib.xml8._encode_and_escape(utf8_str))
+                         bzrlib.xml5._encode_and_escape(utf8_str))
 
     def test_unicode(self):
         uni_str = u'\xb5\xe5&\u062c'
         self.assertEqual('&#181;&#229;&amp;&#1580;"',
-                         bzrlib.xml8._encode_and_escape(uni_str))
+                         bzrlib.xml5._encode_and_escape(uni_str))

=== modified file 'bzrlib/tests/transport_util.py'
--- bzrlib/tests/transport_util.py	2008-05-08 04:33:38 +0000
+++ bzrlib/tests/transport_util.py	2007-09-24 15:01:26 +0000
@@ -65,8 +65,7 @@
     hooks = TransportHooks()
 
     def __init__(self, base, _from_transport=None):
-        if not base.startswith(_hooked_scheme + '://'):
-            raise ValueError(base)
+        assert base.startswith(_hooked_scheme + '://')
         # We need to trick the backing transport class about the scheme used
         # We'll do the reverse when we need to talk to the backing server
         fake_base = _change_scheme_in(base, _hooked_scheme, _backing_scheme)
@@ -116,8 +115,8 @@
         return url
 
     def start_logging_connections(self):
-        ConnectionHookedTransport.hooks.install_named_hook(
-            '_set_connection', self._collect_connection, None)
+        ConnectionHookedTransport.hooks.install_hook('_set_connection',
+                                                     self._collect_connection)
         # uninstall our hooks when we are finished
         self.addCleanup(self.reset_hooks)
 

=== modified file 'bzrlib/tests/tree_implementations/__init__.py'
--- bzrlib/tests/tree_implementations/__init__.py	2008-08-28 23:43:12 +0000
+++ bzrlib/tests/tree_implementations/__init__.py	2007-10-08 07:29:57 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007, 2008 Canonical Ltd
+# Copyright (C) 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -28,7 +28,6 @@
 from bzrlib import (
     errors,
     osutils,
-    progress,
     tests,
     transform,
     )
@@ -37,15 +36,15 @@
                           adapt_modules,
                           default_transport,
                           TestCaseWithTransport,
+                          TestLoader,
                           TestSkipped,
+                          TestSuite,
                           )
 from bzrlib.tests.bzrdir_implementations.test_bzrdir import TestCaseWithBzrDir
 from bzrlib.tests.workingtree_implementations import (
     WorkingTreeTestProviderAdapter,
     )
-from bzrlib.revision import NULL_REVISION
 from bzrlib.revisiontree import RevisionTree
-from bzrlib.transform import TransformPreview
 from bzrlib.workingtree import (
     WorkingTreeFormat,
     WorkingTreeFormat3,
@@ -57,49 +56,27 @@
     )
 
 
-def return_parameter(testcase, something):
+def return_parameter(something):
     """A trivial thunk to return its input."""
     return something
 
 
-def revision_tree_from_workingtree(testcase, tree):
+def revision_tree_from_workingtree(tree):
     """Create a revision tree from a working tree."""
     revid = tree.commit('save tree', allow_pointless=True, recursive=None)
     return tree.branch.repository.revision_tree(revid)
 
 
-def _dirstate_tree_from_workingtree(testcase, tree):
-    revid = tree.commit('save tree', allow_pointless=True, recursive=None)
+def _dirstate_tree_from_workingtree(tree):
+    revid = tree.commit('save tree', allow_pointless=True)
     return tree.basis_tree()
 
 
-def preview_tree_pre(testcase, tree):
-    tt = TransformPreview(tree)
-    testcase.addCleanup(tt.finalize)
-    preview_tree = tt.get_preview_tree()
-    preview_tree.set_parent_ids(tree.get_parent_ids())
-    return preview_tree
-
-
-def preview_tree_post(testcase, tree):
-    basis = tree.basis_tree()
-    tt = TransformPreview(basis)
-    testcase.addCleanup(tt.finalize)
-    pp = progress.ProgressPhase('', 1, progress.DummyProgress())
-    tree.lock_read()
-    testcase.addCleanup(tree.unlock)
-    transform._prepare_revert_transform(basis, tree, tt, None, False, pp,
-                                        basis, {})
-    preview_tree = tt.get_preview_tree()
-    preview_tree.set_parent_ids(tree.get_parent_ids())
-    return preview_tree
-
-
 class TestTreeImplementationSupport(TestCaseWithTransport):
 
     def test_revision_tree_from_workingtree(self):
         tree = self.make_branch_and_tree('.')
-        tree = revision_tree_from_workingtree(self, tree)
+        tree = revision_tree_from_workingtree(tree)
         self.assertIsInstance(tree, RevisionTree)
 
 
@@ -112,9 +89,6 @@
         made_control.create_branch()
         return self.workingtree_format.initialize(made_control)
 
-    def workingtree_to_test_tree(self, tree):
-        return self._workingtree_to_test_tree(self, tree)
-
     def _convert_tree(self, tree, converter=None):
         """helper to convert using the converter or a supplied one."""
         # convert that to the final shape
@@ -288,7 +262,7 @@
             self.build_tree(paths[1:])
         except UnicodeError:
             raise tests.TestSkipped('filesystem does not support unicode.')
-        if tree.get_root_id() is None:
+        if tree.path2id('') is None:
             # Some trees do not have a root yet.
             tree.add(paths, file_ids)
         else:
@@ -322,61 +296,35 @@
     """
 
     def __init__(self, transport_server, transport_readonly_server, formats):
-        """Create a TreeTestProviderAdapter.
-
-        :param formats: [workingtree_format]
-        """
         super(TreeTestProviderAdapter, self).__init__(transport_server,
             transport_readonly_server, formats)
         # now adjust the scenarios and add the non-working-tree tree scenarios.
         for scenario in self.scenarios:
             # for working tree adapted tests, preserve the tree
-            scenario[1]["_workingtree_to_test_tree"] = return_parameter
+            scenario[1]["workingtree_to_test_tree"] = return_parameter
         # add RevisionTree scenario
-        self.scenarios.append(self.create_tree_scenario(RevisionTree.__name__,
-                              revision_tree_from_workingtree,))
-
-        # also test WorkingTree4's RevisionTree implementation which is
-        # specialised.
-        self.scenarios.append(self.create_tree_scenario(
-            DirStateRevisionTree.__name__, _dirstate_tree_from_workingtree,
-            WorkingTreeFormat4()))
-        self.scenarios.append(self.create_tree_scenario('PreviewTree',
-            preview_tree_pre))
-        self.scenarios.append(self.create_tree_scenario('PreviewTreePost',
-            preview_tree_post))
-
-    def create_tree_scenario(self, name, converter, workingtree_format=None):
-        """Create a scenario for the specified converter
-
-        :param name: The name to append to tests using this converter
-        :param converter: A function that converts a workingtree into the
-            desired format.
-        :param workingtree_format: The particular workingtree format to
-            convert from.
-        :return: a (name, options) tuple, where options is a dict of values
-            to be used as members of the TestCase.
-        """
-        if workingtree_format is None:
-            workingtree_format = WorkingTreeFormat._default_format
-        scenario_options = WorkingTreeTestProviderAdapter.create_scenario(self,
-            workingtree_format)[1]
-        scenario_options["_workingtree_to_test_tree"] = converter
-        return name, scenario_options
-
-
-def load_tests(basic_tests, module, loader):
-    result = loader.suiteClass()
-    # add the tests for this module
-    result.addTests(basic_tests)
-
+        # this is the 'default format' in that it's used to test the generic InterTree
+        # code.
+        default_format = WorkingTreeFormat3()
+        self.scenarios.append(self.formats_to_scenarios([
+            (default_format, default_format._matchingbzrdir)])[0])
+        self.scenarios[-1] = (RevisionTree.__name__, self.scenarios[-1][1])
+        self.scenarios[-1][1]["workingtree_to_test_tree"] = revision_tree_from_workingtree
+
+        # also test WorkingTree4's RevisionTree implementation which is specialised.
+        dirstate_format = WorkingTreeFormat4()
+        self.scenarios.append(self.formats_to_scenarios([
+            (dirstate_format, dirstate_format._matchingbzrdir)])[0])
+        self.scenarios[-1] = (DirStateRevisionTree.__name__, self.scenarios[-1][1])
+        self.scenarios[-1][1]["workingtree_to_test_tree"] = _dirstate_tree_from_workingtree
+
+
+def test_suite():
+    result = TestSuite()
     test_tree_implementations = [
-        'bzrlib.tests.tree_implementations.test_annotate_iter',
         'bzrlib.tests.tree_implementations.test_get_file_mtime',
-        'bzrlib.tests.tree_implementations.test_get_root_id',
         'bzrlib.tests.tree_implementations.test_get_symlink_target',
         'bzrlib.tests.tree_implementations.test_inv',
-        'bzrlib.tests.tree_implementations.test_iter_search_rules',
         'bzrlib.tests.tree_implementations.test_list_files',
         'bzrlib.tests.tree_implementations.test_path_content_summary',
         'bzrlib.tests.tree_implementations.test_revision_tree',
@@ -384,14 +332,14 @@
         'bzrlib.tests.tree_implementations.test_tree',
         'bzrlib.tests.tree_implementations.test_walkdirs',
         ]
-
     adapter = TreeTestProviderAdapter(
         default_transport,
         # None here will cause a readonly decorator to be created
         # by the TestCaseWithTransport.get_readonly_transport method.
         None,
-        WorkingTreeFormat._formats.values() + _legacy_formats)
-
-    # add the tests for the sub modules
+        [(format, format._matchingbzrdir) for format in 
+         WorkingTreeFormat._formats.values() + _legacy_formats])
+    loader = TestLoader()
     adapt_modules(test_tree_implementations, adapter, loader, result)
+    result.addTests(loader.loadTestsFromModuleNames(['bzrlib.tests.tree_implementations']))
     return result

=== removed file 'bzrlib/tests/tree_implementations/test_annotate_iter.py'
--- bzrlib/tests/tree_implementations/test_annotate_iter.py	2008-03-15 09:25:32 +0000
+++ bzrlib/tests/tree_implementations/test_annotate_iter.py	1970-01-01 00:00:00 +0000
@@ -1,55 +0,0 @@
-# Copyright (C) 2008 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Test that all Tree's implement .annotate_iter()"""
-
-from bzrlib.tests.tree_implementations import TestCaseWithTree
-
-
-class TestAnnotate(TestCaseWithTree):
-
-    def get_simple_tree(self):
-        tree = self.make_branch_and_tree('tree')
-        self.build_tree_contents([('tree/one', 'first\ncontent\n')])
-        tree.add(['one'], ['one-id'])
-        tree.commit('one', rev_id='one')
-        self.build_tree_contents([('tree/one', 'second\ncontent\n')])
-        tree.commit('two', rev_id='two')
-        return self._convert_tree(tree)
-
-    def get_tree_with_ghost(self):
-        tree = self.make_branch_and_tree('tree')
-        self.build_tree_contents([('tree/one', 'first\ncontent\n')])
-        tree.add(['one'], ['one-id'])
-        tree.commit('one', rev_id='one')
-        tree.set_parent_ids(['one', 'ghost-one'])
-        self.build_tree_contents([('tree/one', 'second\ncontent\n')])
-        tree.commit('two', rev_id='two')
-        return self._convert_tree(tree)
-
-    def test_annotate_simple(self):
-        tree = self.get_simple_tree()
-        tree.lock_read()
-        self.addCleanup(tree.unlock)
-        self.assertEqual([('two', 'second\n'), ('one', 'content\n')],
-                         list(tree.annotate_iter('one-id')))
-
-    def test_annotate_with_ghost(self):
-        tree = self.get_tree_with_ghost()
-        tree.lock_read()
-        self.addCleanup(tree.unlock)
-        self.assertEqual([('two', 'second\n'), ('one', 'content\n')],
-                         list(tree.annotate_iter('one-id')))

=== removed file 'bzrlib/tests/tree_implementations/test_get_root_id.py'
--- bzrlib/tests/tree_implementations/test_get_root_id.py	2007-11-13 16:05:20 +0000
+++ bzrlib/tests/tree_implementations/test_get_root_id.py	1970-01-01 00:00:00 +0000
@@ -1,44 +0,0 @@
-# Copyright (C) 2007 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Tests for Tree.get_root_id()"""
-
-from bzrlib.tests.tree_implementations import TestCaseWithTree
-
-
-class TestGetRootID(TestCaseWithTree):
-
-    def make_tree_with_default_root_id(self):
-        tree = self.make_branch_and_tree('tree')
-        return self._convert_tree(tree)
-
-    def make_tree_with_fixed_root_id(self):
-        tree = self.make_branch_and_tree('tree')
-        tree.set_root_id('custom-tree-root-id')
-        return self._convert_tree(tree)
-
-    def test_get_root_id_default(self):
-        tree = self.make_tree_with_default_root_id()
-        tree.lock_read()
-        self.addCleanup(tree.unlock)
-        self.assertIsNot(None, tree.get_root_id())
-
-    def test_get_root_id_fixed(self):
-        tree = self.make_tree_with_fixed_root_id()
-        tree.lock_read()
-        self.addCleanup(tree.unlock)
-        self.assertEqual('custom-tree-root-id', tree.get_root_id())
-

=== modified file 'bzrlib/tests/tree_implementations/test_get_symlink_target.py'
--- bzrlib/tests/tree_implementations/test_get_symlink_target.py	2007-11-01 09:52:45 +0000
+++ bzrlib/tests/tree_implementations/test_get_symlink_target.py	2007-02-25 16:56:33 +0000
@@ -29,7 +29,9 @@
 class TestGetSymlinkTarget(TestCaseWithTree):
 
     def get_tree_with_symlinks(self):
-        self.requireFeature(tests.SymlinkFeature)
+        if not osutils.has_symlinks():
+            raise tests.TestSkipped('platform does not support symlinks.')
+
         tree = self.make_branch_and_tree('tree')
         os.symlink('foo', 'tree/link')
         os.symlink('../bar', 'tree/rel_link')

=== modified file 'bzrlib/tests/tree_implementations/test_inv.py'
--- bzrlib/tests/tree_implementations/test_inv.py	2008-06-11 04:20:16 +0000
+++ bzrlib/tests/tree_implementations/test_inv.py	2007-10-16 16:02:01 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007, 2008 Canonical Ltd
+# Copyright (C) 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -22,15 +22,125 @@
 
 from bzrlib.diff import internal_diff
 from bzrlib.mutabletree import MutableTree
-from bzrlib.osutils import has_symlinks
-from bzrlib.tests import SymlinkFeature, TestSkipped
+from bzrlib.osutils import (
+    has_symlinks,
+    )
+from bzrlib.symbol_versioning import zero_ninetyone
+from bzrlib.tests import TestSkipped
 from bzrlib.tests.tree_implementations import TestCaseWithTree
-from bzrlib.transform import _PreviewTree
 from bzrlib.uncommit import uncommit
 
 
-def get_entry(tree, file_id):
-    return tree.iter_entries_by_dir([file_id]).next()[1]
+class TestEntryDiffing(TestCaseWithTree):
+
+    def setUp(self):
+        super(TestEntryDiffing, self).setUp()
+        self.wt = self.make_branch_and_tree('.')
+        self.branch = self.wt.branch
+        open('file', 'wb').write('foo\n')
+        open('binfile', 'wb').write('foo\n')
+        self.wt.add(['file'], ['fileid'])
+        self.wt.add(['binfile'], ['binfileid'])
+        if has_symlinks():
+            os.symlink('target1', 'symlink')
+            self.wt.add(['symlink'], ['linkid'])
+        self.wt.commit('message_1', rev_id = '1')
+        open('file', 'wb').write('bar\n')
+        open('binfile', 'wb').write('x' * 1023 + '\x00\n')
+        if has_symlinks():
+            os.unlink('symlink')
+            os.symlink('target2', 'symlink')
+        self.tree_1 = self.branch.repository.revision_tree('1')
+        self.inv_1 = self.branch.repository.get_inventory('1')
+        self.file_1 = self.inv_1['fileid']
+        self.file_1b = self.inv_1['binfileid']
+        self.tree_2 = self.workingtree_to_test_tree(self.wt)
+        self.tree_2.lock_read()
+        self.addCleanup(self.tree_2.unlock)
+        self.inv_2 = self.tree_2.inventory
+        self.file_2 = self.inv_2['fileid']
+        self.file_2b = self.inv_2['binfileid']
+        if has_symlinks():
+            self.link_1 = self.inv_1['linkid']
+            self.link_2 = self.inv_2['linkid']
+
+    def test_file_diff_deleted(self):
+        output = StringIO()
+        self.file_1.diff(internal_diff, 
+                          "old_label", self.tree_1,
+                          "/dev/null", None, None,
+                          output)
+        self.assertEqual(output.getvalue(), "--- old_label\n"
+                                            "+++ /dev/null\n"
+                                            "@@ -1,1 +0,0 @@\n"
+                                            "-foo\n"
+                                            "\n")
+
+    def test_file_diff_added(self):
+        output = StringIO()
+        self.file_1.diff(internal_diff, 
+                          "new_label", self.tree_1,
+                          "/dev/null", None, None,
+                          output, reverse=True)
+        self.assertEqual(output.getvalue(), "--- /dev/null\n"
+                                            "+++ new_label\n"
+                                            "@@ -0,0 +1,1 @@\n"
+                                            "+foo\n"
+                                            "\n")
+
+    def test_file_diff_changed(self):
+        output = StringIO()
+        self.file_1.diff(internal_diff, 
+                          "/dev/null", self.tree_1, 
+                          "new_label", self.file_2, self.tree_2,
+                          output)
+        self.assertEqual(output.getvalue(), "--- /dev/null\n"
+                                            "+++ new_label\n"
+                                            "@@ -1,1 +1,1 @@\n"
+                                            "-foo\n"
+                                            "+bar\n"
+                                            "\n")
+        
+    def test_file_diff_binary(self):
+        output = StringIO()
+        self.file_1.diff(internal_diff, 
+                          "/dev/null", self.tree_1, 
+                          "new_label", self.file_2b, self.tree_2,
+                          output)
+        self.assertEqual(output.getvalue(), 
+                         "Binary files /dev/null and new_label differ\n")
+    def test_link_diff_deleted(self):
+        if not has_symlinks():
+            return
+        output = StringIO()
+        self.link_1.diff(internal_diff, 
+                          "old_label", self.tree_1,
+                          "/dev/null", None, None,
+                          output)
+        self.assertEqual(output.getvalue(),
+                         "=== target was 'target1'\n")
+
+    def test_link_diff_added(self):
+        if not has_symlinks():
+            return
+        output = StringIO()
+        self.link_1.diff(internal_diff, 
+                          "new_label", self.tree_1,
+                          "/dev/null", None, None,
+                          output, reverse=True)
+        self.assertEqual(output.getvalue(),
+                         "=== target is 'target1'\n")
+
+    def test_link_diff_changed(self):
+        if not has_symlinks():
+            return
+        output = StringIO()
+        self.link_1.diff(internal_diff, 
+                          "/dev/null", self.tree_1, 
+                          "new_label", self.link_2, self.tree_2,
+                          output)
+        self.assertEqual(output.getvalue(),
+                         "=== target changed 'target1' => 'target2'\n")
 
 
 class TestPreviousHeads(TestCaseWithTree):
@@ -63,9 +173,43 @@
         self.tree = self.workingtree_to_test_tree(self.wt)
         self.tree.lock_read()
         self.addCleanup(self.tree.unlock)
-        self.file_active = get_entry(self.tree, 'fileid')
-
-    # TODO: test two inventories with the same file revision
+        self.file_active = self.tree.inventory['fileid']
+        self.weave = self.branch.repository.weave_store.get_weave('fileid',
+            self.branch.repository.get_transaction())
+        
+    def get_previous_heads(self, inventories):
+        return self.applyDeprecated(zero_ninetyone,
+            self.file_active.find_previous_heads,
+            inventories,
+            self.branch.repository.weave_store,
+            self.branch.repository.get_transaction())
+        
+    def test_fileid_in_no_inventory(self):
+        self.assertEqual({}, self.get_previous_heads([self.inv_A]))
+
+    def test_fileid_in_one_inventory(self):
+        self.assertEqual({'B':self.inv_B['fileid']},
+                         self.get_previous_heads([self.inv_B]))
+        self.assertEqual({'B':self.inv_B['fileid']},
+                         self.get_previous_heads([self.inv_A, self.inv_B]))
+        self.assertEqual({'B':self.inv_B['fileid']},
+                         self.get_previous_heads([self.inv_B, self.inv_A]))
+
+    def test_fileid_in_two_inventories_gives_both_entries(self):
+        self.assertEqual({'B':self.inv_B['fileid'],
+                          'C':self.inv_C['fileid']},
+                          self.get_previous_heads([self.inv_B, self.inv_C]))
+        self.assertEqual({'B':self.inv_B['fileid'],
+                          'C':self.inv_C['fileid']},
+                          self.get_previous_heads([self.inv_C, self.inv_B]))
+
+    def test_fileid_in_two_inventories_already_merged_gives_head(self):
+        self.assertEqual({'D':self.inv_D['fileid']},
+                         self.get_previous_heads([self.inv_B, self.inv_D]))
+        self.assertEqual({'D':self.inv_D['fileid']},
+                         self.get_previous_heads([self.inv_D, self.inv_B]))
+
+    # TODO: test two inventories with the same file revision 
 
 
 class TestInventory(TestCaseWithTree):
@@ -74,32 +218,23 @@
         self.tree = self.get_tree_with_subdirs_and_all_content_types()
         self.tree.lock_read()
         self.addCleanup(self.tree.unlock)
+        # Commenting out the following line still fails.
+        self.inv = self.tree.inventory
 
     def test_symlink_target(self):
-        self.requireFeature(SymlinkFeature)
+        if not has_symlinks():
+            raise TestSkipped('No symlink support')
         self._set_up()
-        if isinstance(self.tree, (MutableTree, _PreviewTree)):
+        if isinstance(self.tree, MutableTree):
             raise TestSkipped(
-                'symlinks not accurately represented in working trees and'
-                ' preview trees')
-        entry = get_entry(self.tree, self.tree.path2id('symlink'))
+                'symlinks not accurately represented in working trees')
+        entry = self.inv[self.inv.path2id('symlink')]
         self.assertEqual(entry.symlink_target, 'link-target')
 
-    def test_symlink_target_tree(self):
-        self.requireFeature(SymlinkFeature)
-        self._set_up()
-        self.assertEqual('link-target',
-                         self.tree.get_symlink_target('symlink'))
-
-    def test_kind_symlink(self):
-        self.requireFeature(SymlinkFeature)
-        self._set_up()
-        self.assertEqual('symlink', self.tree.kind('symlink'))
-        self.assertIs(None, self.tree.get_file_size('symlink'))
-
     def test_symlink(self):
-        self.requireFeature(SymlinkFeature)
+        if not has_symlinks():
+            raise TestSkipped('No symlink support')
         self._set_up()
-        entry = get_entry(self.tree, self.tree.path2id('symlink'))
+        entry = self.inv[self.inv.path2id('symlink')]
         self.assertEqual(entry.kind, 'symlink')
         self.assertEqual(None, entry.text_size)

=== removed file 'bzrlib/tests/tree_implementations/test_iter_search_rules.py'
--- bzrlib/tests/tree_implementations/test_iter_search_rules.py	2008-08-14 17:25:43 +0000
+++ bzrlib/tests/tree_implementations/test_iter_search_rules.py	1970-01-01 00:00:00 +0000
@@ -1,78 +0,0 @@
-# Copyright (C) 2008 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Test that all Tree's implement iter_search_rules."""
-
-from bzrlib import (
-    rules,
-    tests,
-    )
-from bzrlib.tests.tree_implementations import TestCaseWithTree
-
-
-class TestIterSearchRules(TestCaseWithTree):
-
-    def make_per_user_searcher(self, text):
-        """Make a _RulesSearcher from a string"""
-        return rules._IniBasedRulesSearcher(text.splitlines(True))
-
-    def make_tree_with_rules(self, text):
-        tree = self.make_branch_and_tree('.')
-        if text is not None:
-            self.fail("No method for in-tree rules agreed on yet.")
-            text_utf8 = text.encode('utf-8')
-            self.build_tree_contents([(rules.RULES_TREE_FILENAME, text_utf8)])
-            tree.add(rules.RULES_TREE_FILENAME)
-            tree.commit("add rules file")
-        result = self._convert_tree(tree)
-        result.lock_read()
-        self.addCleanup(result.unlock)
-        return result
-
-    def test_iter_search_rules_no_tree(self):
-        per_user = self.make_per_user_searcher(
-            "[name ./a.txt]\nfoo=baz\n"
-            "[name *.txt]\nfoo=bar\na=True\n")
-        tree = self.make_tree_with_rules(None)
-        result = list(tree.iter_search_rules(['a.txt', 'dir/a.txt'],
-            _default_searcher=per_user))
-        self.assertEquals((('foo', 'baz'),), result[0])
-        self.assertEquals((('foo', 'bar'), ('a', 'True')), result[1])
-
-    def _disabled_test_iter_search_rules_just_tree(self):
-        per_user = self.make_per_user_searcher('')
-        tree = self.make_tree_with_rules(
-            "[name ./a.txt]\n"
-            "foo=baz\n"
-            "[name *.txt]\n"
-            "foo=bar\n"
-            "a=True\n")
-        result = list(tree.iter_search_rules(['a.txt', 'dir/a.txt'],
-            _default_searcher=per_user))
-        self.assertEquals((('foo', 'baz'),), result[0])
-        self.assertEquals((('foo', 'bar'), ('a', 'True')), result[1])
-
-    def _disabled_test_iter_search_rules_tree_and_per_user(self):
-        per_user = self.make_per_user_searcher(
-            "[name ./a.txt]\nfoo=baz\n"
-            "[name *.txt]\nfoo=bar\na=True\n")
-        tree = self.make_tree_with_rules(
-            "[name ./a.txt]\n"
-            "foo=qwerty\n")
-        result = list(tree.iter_search_rules(['a.txt', 'dir/a.txt'],
-            _default_searcher=per_user))
-        self.assertEquals((('foo', 'qwerty'),), result[0])
-        self.assertEquals((('foo', 'bar'), ('a', 'True')), result[1])

=== modified file 'bzrlib/tests/tree_implementations/test_test_trees.py'
--- bzrlib/tests/tree_implementations/test_test_trees.py	2008-04-12 19:43:13 +0000
+++ bzrlib/tests/tree_implementations/test_test_trees.py	2007-04-14 11:55:51 +0000
@@ -16,7 +16,8 @@
 
 """Tests for the test trees used by the tree_implementations tests."""
 
-from bzrlib.tests import SymlinkFeature
+from bzrlib.osutils import has_symlinks
+from bzrlib.tests import TestSkipped
 from bzrlib.tests.tree_implementations import TestCaseWithTree
 
 
@@ -51,7 +52,7 @@
             [('', 'root-id'), ('a', 'a-id'), ('b', 'b-id'), ('b/c', 'c-id')],
             [(path, node.file_id) for path, node in tree.iter_entries_by_dir()])
         self.assertEqualDiff('contents of a\n', tree.get_file_text('a-id'))
-        self.assertFalse(tree.is_executable('c-id', path='b/c'))
+        self.assertFalse(tree.is_executable('c-id'))
 
     def test_abc_tree_content_2_no_parents(self):
         tree = self.make_branch_and_tree('.')
@@ -147,7 +148,8 @@
         # currently this test tree requires unicode. It might be good
         # to have it simply stop having the single unicode file in it
         # when dealing with a non-unicode filesystem.
-        self.requireFeature(SymlinkFeature)
+        if not has_symlinks():
+            raise TestSkipped('No symlink support')
         tree = self.get_tree_with_subdirs_and_all_content_types()
         tree.lock_read()
         self.addCleanup(tree.unlock)

=== modified file 'bzrlib/tests/tree_implementations/test_tree.py'
--- bzrlib/tests/tree_implementations/test_tree.py	2008-07-16 18:14:23 +0000
+++ bzrlib/tests/tree_implementations/test_tree.py	2007-08-30 02:02:21 +0000
@@ -56,8 +56,8 @@
         tree_b.lock_read()
         self.addCleanup(tree_b.unlock)
         self.assertEqual([
+            ('killed-b', 'b\n'),
             ('killed-a', 'a\n'),
-            ('killed-b', 'b\n'),
             ('unchanged', 'c\n'),
             ('unchanged', 'd\n'),
             ('new-a', 'e\n'),
@@ -69,7 +69,7 @@
 
     def skip_if_no_reference(self, tree):
         if not getattr(tree, 'supports_tree_reference', lambda: False)():
-            raise tests.TestNotApplicable('Tree references not supported')
+            raise tests.TestSkipped('Tree references not supported')
 
     def create_nested(self):
         work_tree = self.make_branch_and_tree('wt')
@@ -88,8 +88,6 @@
 
     def test_get_reference_revision(self):
         tree = self.create_nested()
-        tree.lock_read()
-        self.addCleanup(tree.unlock)
         path = tree.id2path('sub-root')
         self.assertEqual('sub-1', tree.get_reference_revision('sub-root', path))
 
@@ -98,7 +96,7 @@
         tree.lock_read()
         self.addCleanup(tree.unlock)
         entry = tree.inventory['sub-root']
-        self.assertEqual([(u'subtree', 'sub-root')],
+        self.assertEqual([(tree.abspath('subtree'), 'sub-root')],
             list(tree.iter_references()))
 
     def test_get_root_id(self):
@@ -123,26 +121,6 @@
         finally:
             tree.unlock()
 
-    def test_all_file_ids(self):
-        work_tree = self.make_branch_and_tree('wt')
-        tree = self.get_tree_no_parents_abc_content(work_tree)
-        tree.lock_read()
-        self.addCleanup(tree.unlock)
-        self.assertEqual(tree.all_file_ids(),
-                         set(['b-id', 'root-id', 'c-id', 'a-id']))
-
-
-class TestStoredKind(TestCaseWithTree):
-
-    def test_stored_kind(self):
-        tree = self.make_branch_and_tree('tree')
-        work_tree = self.make_branch_and_tree('wt')
-        tree = self.get_tree_no_parents_abc_content(work_tree)
-        tree.lock_read()
-        self.addCleanup(tree.unlock)
-        self.assertEqual('file', tree.stored_kind('a-id'))
-        self.assertEqual('directory', tree.stored_kind('b-id'))
-
 
 class TestFileContent(TestCaseWithTree):
 
@@ -191,15 +169,3 @@
         work_tree = self.make_branch_and_tree('wt')
         tree = self._convert_tree(work_tree)
         self.assertIsInstance(tree.conflicts(), conflicts.ConflictList)
-
-
-class TestIterEntriesByDir(TestCaseWithTree):
-
-    def test_iteration_order(self):
-        work_tree = self.make_branch_and_tree('.')
-        self.build_tree(['a/', 'a/b/', 'a/b/c', 'a/d/', 'a/d/e', 'f/', 'f/g'])
-        work_tree.add(['a', 'a/b', 'a/b/c', 'a/d', 'a/d/e', 'f', 'f/g'])
-        tree = self._convert_tree(work_tree)
-        output_order = [p for p, e in tree.iter_entries_by_dir()]
-        self.assertEqual(['', 'a', 'f', 'a/b', 'a/d', 'a/b/c', 'a/d/e', 'f/g'],
-                         output_order)

=== modified file 'bzrlib/tests/tree_implementations/test_walkdirs.py'
--- bzrlib/tests/tree_implementations/test_walkdirs.py	2008-07-23 19:09:46 +0000
+++ bzrlib/tests/tree_implementations/test_walkdirs.py	2007-04-14 11:55:51 +0000
@@ -16,9 +16,6 @@
 
 """Tests for the generic Tree.walkdirs interface."""
 
-import os
-
-from bzrlib import tests
 from bzrlib.osutils import has_symlinks
 from bzrlib.tests.tree_implementations import TestCaseWithTree
 
@@ -101,22 +98,3 @@
         for pos, item in enumerate(expected_dirblocks):
             self.assertEqual(item, result[pos])
         self.assertEqual(len(expected_dirblocks), len(result))
-
-    def test_walkdir_versioned_kind(self):
-        work_tree = self.make_branch_and_tree('tree')
-        work_tree.set_root_id('tree-root')
-        self.build_tree(['tree/file', 'tree/dir/'])
-        work_tree.add(['file', 'dir'], ['file-id', 'dir-id'])
-        os.unlink('tree/file')
-        os.rmdir('tree/dir')
-        tree = self._convert_tree(work_tree)
-        tree.lock_read()
-        self.addCleanup(tree.unlock)
-        if tree.path2id('file') is None:
-            raise tests.TestNotApplicable(
-                'Tree type cannot represent dangling ids.')
-        expected = [(('', 'tree-root'), [
-            ('dir', 'dir', 'unknown', None, 'dir-id', 'directory'),
-            ('file', 'file', 'unknown', None, 'file-id', 'file')]),
-            (('dir', 'dir-id'), [])]
-        self.assertEqual(expected, list(tree.walkdirs()))

=== modified file 'bzrlib/tests/treeshape.py'
--- bzrlib/tests/treeshape.py	2008-04-24 07:22:53 +0000
+++ bzrlib/tests/treeshape.py	2006-10-11 23:08:27 +0000
@@ -65,8 +65,7 @@
         filenames.sort()
         for fn in filenames:
             fullpath = pathjoin(dirpath, fn)
-            if (fullpath[-1] in '@/'):
-                raise AssertionError(fullpath)
+            assert not (fullpath[-1] in '@/')
             info = os.lstat(fullpath)
             if stat.S_ISLNK(info.st_mode):
                 yield (fullpath + '@', os.readlink(fullpath))

=== modified file 'bzrlib/tests/workingtree_implementations/__init__.py'
--- bzrlib/tests/workingtree_implementations/__init__.py	2008-07-17 00:42:40 +0000
+++ bzrlib/tests/workingtree_implementations/__init__.py	2007-07-12 07:22:52 +0000
@@ -27,7 +27,9 @@
 from bzrlib.tests import (
                           adapt_modules,
                           default_transport,
+                          TestLoader,
                           TestScenarioApplier,
+                          TestSuite,
                           )
 from bzrlib.tests.bzrdir_implementations.test_bzrdir import TestCaseWithBzrDir
 from bzrlib.workingtree import (WorkingTreeFormat,
@@ -48,34 +50,24 @@
         self._transport_server = transport_server
         self._transport_readonly_server = transport_readonly_server
         self.scenarios = self.formats_to_scenarios(formats)
-
+    
     def formats_to_scenarios(self, formats):
         """Transform the input formats to a list of scenarios.
 
-        :param formats: A list [workingtree_format].
+        :param formats: A list of (workingtree_format, bzrdir_format).
         """
-
+    
         result = []
-        for workingtree_format in formats:
-            result.append(self.create_scenario(workingtree_format))
+        for workingtree_format, bzrdir_format in formats:
+            scenario = (workingtree_format.__class__.__name__, {
+                "transport_server":self._transport_server,
+                "transport_readonly_server":self._transport_readonly_server,
+                "bzrdir_format":bzrdir_format,
+                "workingtree_format":workingtree_format,
+                })
+            result.append(scenario)
         return result
 
-    def create_scenario(self, workingtree_format):
-        """Create a scenario for the specified converter
-
-        :param workingtree_format: The particular workingtree format to test.
-        :param bzrdir_format: The bzrdir format to test.
-        :return: a (name, options) tuple, where options is a dict of values
-            to be used as members of the TestCase.
-        """
-        scenario_options = {
-            "transport_server": self._transport_server,
-            "transport_readonly_server": self._transport_readonly_server,
-            "bzrdir_format": workingtree_format._matchingbzrdir,
-            "workingtree_format": workingtree_format,
-            }
-        return workingtree_format.__class__.__name__, scenario_options
-
 
 class TestCaseWithWorkingTree(TestCaseWithBzrDir):
 
@@ -86,11 +78,8 @@
         return self.workingtree_format.initialize(made_control)
 
 
-def load_tests(basic_tests, module, loader):
-    result = loader.suiteClass()
-    # add the tests for this module
-    result.addTests(basic_tests)
-
+def test_suite():
+    result = TestSuite()
     test_workingtree_implementations = [
         'bzrlib.tests.workingtree_implementations.test_add_reference',
         'bzrlib.tests.workingtree_implementations.test_add',
@@ -127,14 +116,13 @@
         'bzrlib.tests.workingtree_implementations.test_walkdirs',
         'bzrlib.tests.workingtree_implementations.test_workingtree',
         ]
-
     adapter = WorkingTreeTestProviderAdapter(
         default_transport,
         # None here will cause a readonly decorator to be created
         # by the TestCaseWithTransport.get_readonly_transport method.
         None,
-        WorkingTreeFormat._formats.values() + _legacy_formats)
-
-    # add the tests for the sub modules
+        [(format, format._matchingbzrdir) for format in 
+         WorkingTreeFormat._formats.values() + _legacy_formats])
+    loader = TestLoader()
     adapt_modules(test_workingtree_implementations, adapter, loader, result)
     return result

=== modified file 'bzrlib/tests/workingtree_implementations/test_add_reference.py'
--- bzrlib/tests/workingtree_implementations/test_add_reference.py	2008-04-24 07:22:53 +0000
+++ bzrlib/tests/workingtree_implementations/test_add_reference.py	2007-03-06 13:08:53 +0000
@@ -36,19 +36,13 @@
         sub_tree.commit('commit', rev_id='sub_1')
         return tree, sub_tree
 
-    def _references_unsupported(self, tree):
-        if tree.__class__ in TREES_NOT_SUPPORTING_REFERENCES:
-            raise tests.TestSkipped('Tree format does not support references')
-        else:
-            self.fail('%r does not support references but should'
-                % (tree, ))
-
     def make_nested_trees(self):
         tree, sub_tree = self.make_trees()
         try:
             tree.add_reference(sub_tree)
         except errors.UnsupportedOperation:
-            self._references_unsupported(tree)
+            assert tree.__class__ in TREES_NOT_SUPPORTING_REFERENCES
+            raise tests.TestSkipped('Tree format does not support references')
         return tree, sub_tree
 
     def test_add_reference(self):
@@ -82,7 +76,8 @@
             self.assertRaises(errors.BadReferenceTarget, tree.add_reference, 
                               sub_tree)
         except errors.UnsupportedOperation:
-            self._references_unsupported(tree)
+            assert tree.__class__ in TREES_NOT_SUPPORTING_REFERENCES
+            raise tests.TestSkipped('Tree format does not support references')
 
     def test_root_present(self):
         """Subtree root is present, though not the working tree root"""
@@ -92,7 +87,8 @@
             self.assertRaises(errors.BadReferenceTarget, tree.add_reference, 
                               sub_tree)
         except errors.UnsupportedOperation:
-            self._references_unsupported(tree)
+            assert tree.__class__ in TREES_NOT_SUPPORTING_REFERENCES
+            raise tests.TestSkipped('Tree format does not support references')
 
     def test_add_non_subtree(self):
         tree, sub_tree = self.make_trees()
@@ -102,7 +98,8 @@
             self.assertRaises(errors.BadReferenceTarget, tree.add_reference, 
                               sibling)
         except errors.UnsupportedOperation:
-            self._references_unsupported(tree)
+            assert tree.__class__ in TREES_NOT_SUPPORTING_REFERENCES
+            raise tests.TestSkipped('Tree format does not support references')
 
     def test_get_nested_tree(self):
         tree, sub_tree = self.make_nested_trees()

=== modified file 'bzrlib/tests/workingtree_implementations/test_basis_inventory.py'
--- bzrlib/tests/workingtree_implementations/test_basis_inventory.py	2008-05-12 04:07:49 +0000
+++ bzrlib/tests/workingtree_implementations/test_basis_inventory.py	2007-02-22 05:51:57 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2004, 2005, 2008 Canonical Ltd
+# Copyright (C) 2004, 2005 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -16,7 +16,6 @@
 
 import os
 
-from bzrlib.tests import TestNotApplicable
 from bzrlib.tests.workingtree_implementations import TestCaseWithWorkingTree
 from bzrlib.branch import Branch
 from bzrlib import inventory
@@ -31,8 +30,7 @@
         # not separate is mandatory.
         if isinstance(self.workingtree_format,
             bzrlib.workingtree_4.WorkingTreeFormat4):
-            raise TestNotApplicable("not applicable to %r"
-                % (self.workingtree_format,))
+            return
         # TODO: jam 20051218 this probably should add more than just
         #                    a couple files to the inventory
 
@@ -43,7 +41,7 @@
         t.add('a')
         t.commit('a', rev_id='r1')
 
-        self.assertTrue(t._transport.has('basis-inventory-cache'))
+        t._control_files.get_utf8('basis-inventory-cache')
 
         basis_inv = t.basis_tree().inventory
         self.assertEquals('r1', basis_inv.revision_id)
@@ -55,7 +53,7 @@
         t.add('b')
         t.commit('b', rev_id='r2')
 
-        self.assertTrue(t._transport.has('basis-inventory-cache'))
+        t._control_files.get_utf8('basis-inventory-cache')
 
         basis_inv_txt = t.read_basis_inventory()
         basis_inv = bzrlib.xml7.serializer_v7.read_inventory_from_string(basis_inv_txt)
@@ -70,19 +68,18 @@
         # not separate and ignorable.
         if isinstance(self.workingtree_format,
             bzrlib.workingtree_4.WorkingTreeFormat4):
-            raise TestNotApplicable("not applicable to %r"
-                % (self.workingtree_format,))
+            return
         t = self.make_branch_and_tree('.')
         b = t.branch
         open('a', 'wb').write('a\n')
         t.add('a')
         t.commit('a', rev_id='r1')
-        t._transport.put_bytes('basis-inventory-cache', 'booga')
-        t.basis_tree()
-        t._transport.put_bytes('basis-inventory-cache', '<xml/>')
-        t.basis_tree()
-        t._transport.put_bytes('basis-inventory-cache', '<inventory />')
-        t.basis_tree()
-        t._transport.put_bytes('basis-inventory-cache',
-            '<inventory format="pi"/>')
+        t._control_files.put_utf8('basis-inventory-cache', 'booga')
+        t.basis_tree()
+        t._control_files.put_utf8('basis-inventory-cache', '<xml/>')
+        t.basis_tree()
+        t._control_files.put_utf8('basis-inventory-cache', '<inventory />')
+        t.basis_tree()
+        t._control_files.put_utf8('basis-inventory-cache', 
+                                  '<inventory format="pi"/>')
         t.basis_tree()

=== modified file 'bzrlib/tests/workingtree_implementations/test_break_lock.py'
--- bzrlib/tests/workingtree_implementations/test_break_lock.py	2007-11-26 03:11:58 +0000
+++ bzrlib/tests/workingtree_implementations/test_break_lock.py	2007-02-26 01:06:36 +0000
@@ -20,7 +20,6 @@
 
 import bzrlib
 import bzrlib.errors as errors
-from bzrlib.tests import TestNotApplicable
 from bzrlib.tests.workingtree_implementations import TestCaseWithWorkingTree
 
 
@@ -52,19 +51,14 @@
         # if the workingtree isn't locked - and the easiest way
         # to see if that happened is to lock the repo.
         self.workingtree.branch.repository.lock_write()
-        stdin = StringIO("y\n")
-        bzrlib.ui.ui_factory.stdin = stdin
+        bzrlib.ui.ui_factory.stdin = StringIO("y\n")
         try:
             self.unused_workingtree.break_lock()
         except NotImplementedError:
             # workingtree does not support break_lock
             self.workingtree.branch.repository.unlock()
             return
-        remaining = stdin.read()
-        if remaining == 'y\n':
-            raise TestNotApplicable("repository does not physically lock.")
-        self.assertRaises(errors.LockBroken,
-            self.workingtree.branch.repository.unlock)
+        self.assertRaises(errors.LockBroken, self.workingtree.branch.repository.unlock)
 
     def test_locked(self):
         # break_lock when locked should

=== modified file 'bzrlib/tests/workingtree_implementations/test_commit.py'
--- bzrlib/tests/workingtree_implementations/test_commit.py	2008-08-05 04:10:43 +0000
+++ bzrlib/tests/workingtree_implementations/test_commit.py	2007-09-20 07:59:48 +0000
@@ -21,10 +21,7 @@
 from bzrlib import (
     branch,
     bzrdir,
-    conflicts,
     errors,
-    mutabletree,
-    osutils,
     revision as _mod_revision,
     ui,
     uncommit,
@@ -32,8 +29,8 @@
     )
 from bzrlib.errors import (NotBranchError, NotVersionedError, 
                            UnsupportedOperation)
-from bzrlib.osutils import pathjoin, getcwd
-from bzrlib.tests import TestCase
+from bzrlib.osutils import pathjoin, getcwd, has_symlinks
+from bzrlib.tests import TestSkipped, TestCase
 from bzrlib.tests.workingtree_implementations import TestCaseWithWorkingTree
 from bzrlib.trace import mutter
 from bzrlib.workingtree import (TreeEntry, TreeDirectory, TreeFile, TreeLink,
@@ -91,156 +88,6 @@
 
 class TestCommit(TestCaseWithWorkingTree):
 
-    def test_autodelete_renamed(self):
-        tree_a = self.make_branch_and_tree('a')
-        self.build_tree(['a/dir/', 'a/dir/f1', 'a/dir/f2'])
-        tree_a.add(['dir', 'dir/f1', 'dir/f2'], ['dir-id', 'f1-id', 'f2-id'])
-        rev_id1 = tree_a.commit('init')
-        # Start off by renaming entries,
-        # but then actually auto delete the whole tree
-        # https://bugs.launchpad.net/bzr/+bug/114615
-        tree_a.rename_one('dir/f1', 'dir/a')
-        tree_a.rename_one('dir/f2', 'dir/z')
-        osutils.rmtree('a/dir')
-        tree_a.commit('autoremoved')
-
-        tree_a.lock_read()
-        try:
-            root_id = tree_a.get_root_id()
-            paths = [(path, ie.file_id)
-                     for path, ie in tree_a.iter_entries_by_dir()]
-        finally:
-            tree_a.unlock()
-        # The only paths left should be the root
-        self.assertEqual([('', root_id)], paths)
-
-    def test_no_autodelete_renamed_away(self):
-        tree_a = self.make_branch_and_tree('a')
-        self.build_tree(['a/dir/', 'a/dir/f1', 'a/dir/f2', 'a/dir2/'])
-        tree_a.add(['dir', 'dir/f1', 'dir/f2', 'dir2'],
-                   ['dir-id', 'f1-id', 'f2-id', 'dir2-id'])
-        rev_id1 = tree_a.commit('init')
-        # Rename one entry out of this directory
-        tree_a.rename_one('dir/f1', 'dir2/a')
-        osutils.rmtree('a/dir')
-        tree_a.commit('autoremoved')
-
-        tree_a.lock_read()
-        try:
-            root_id = tree_a.get_root_id()
-            paths = [(path, ie.file_id)
-                     for path, ie in tree_a.iter_entries_by_dir()]
-        finally:
-            tree_a.unlock()
-        # The only paths left should be the root
-        self.assertEqual([('', root_id), ('dir2', 'dir2-id'),
-                          ('dir2/a', 'f1-id'),
-                         ], paths)
-
-    def test_no_autodelete_alternate_renamed(self):
-        # Test for bug #114615
-        tree_a = self.make_branch_and_tree('A')
-        self.build_tree(['A/a/', 'A/a/m', 'A/a/n'])
-        tree_a.add(['a', 'a/m', 'a/n'], ['a-id', 'm-id', 'n-id'])
-        tree_a.commit('init')
-
-        tree_a.lock_read()
-        try:
-            root_id = tree_a.get_root_id()
-        finally:
-            tree_a.unlock()
-
-        tree_b = tree_a.bzrdir.sprout('B').open_workingtree()
-        self.build_tree(['B/xyz/'])
-        tree_b.add(['xyz'], ['xyz-id'])
-        tree_b.rename_one('a/m', 'xyz/m')
-        osutils.rmtree('B/a')
-        tree_b.commit('delete in B')
-
-        paths = [(path, ie.file_id)
-                 for path, ie in tree_b.iter_entries_by_dir()]
-        self.assertEqual([('', root_id),
-                          ('xyz', 'xyz-id'),
-                          ('xyz/m', 'm-id'),
-                         ], paths)
-
-        self.build_tree_contents([('A/a/n', 'new contents for n\n')])
-        tree_a.commit('change n in A')
-
-        # Merging from A should introduce conflicts because 'n' was modified
-        # and removed, so 'a' needs to be restored.
-        num_conflicts = tree_b.merge_from_branch(tree_a.branch)
-        self.assertEqual(3, num_conflicts)
-        paths = [(path, ie.file_id)
-                 for path, ie in tree_b.iter_entries_by_dir()]
-        self.assertEqual([('', root_id),
-                          ('a', 'a-id'),
-                          ('xyz', 'xyz-id'),
-                          ('a/n.OTHER', 'n-id'),
-                          ('xyz/m', 'm-id'),
-                         ], paths)
-        osutils.rmtree('B/a')
-        try:
-            # bzr resolve --all
-            tree_b.set_conflicts(conflicts.ConflictList())
-        except errors.UnsupportedOperation:
-            # On WT2, set_conflicts is unsupported, but the rmtree has the same
-            # effect.
-            pass
-        tree_b.commit('autoremove a, without touching xyz/m')
-        paths = [(path, ie.file_id)
-                 for path, ie in tree_b.iter_entries_by_dir()]
-        self.assertEqual([('', root_id),
-                          ('xyz', 'xyz-id'),
-                          ('xyz/m', 'm-id'),
-                         ], paths)
-
-    def test_commit_exclude_pending_merge_fails(self):
-        """Excludes are a form of partial commit."""
-        wt = self.make_branch_and_tree('.')
-        self.build_tree(['foo'])
-        wt.add('foo')
-        wt.commit('commit one')
-        wt2 = wt.bzrdir.sprout('to').open_workingtree()
-        wt2.commit('change_right')
-        wt.merge_from_branch(wt2.branch)
-        self.assertRaises(errors.CannotCommitSelectedFileMerge,
-            wt.commit, 'test', exclude=['foo'])
-
-    def test_commit_exclude_exclude_changed_is_pointless(self):
-        tree = self.make_branch_and_tree('.')
-        self.build_tree(['a'])
-        tree.smart_add(['.'])
-        tree.commit('setup test')
-        self.build_tree_contents([('a', 'new contents for "a"\n')])
-        self.assertRaises(errors.PointlessCommit, tree.commit, 'test',
-            exclude=['a'], allow_pointless=False)
-
-    def test_commit_exclude_excludes_modified_files(self):
-        tree = self.make_branch_and_tree('.')
-        self.build_tree(['a', 'b', 'c'])
-        tree.smart_add(['.'])
-        tree.commit('test', exclude=['b', 'c'])
-        # If b was excluded it will still be 'added' in status.
-        tree.lock_read()
-        self.addCleanup(tree.unlock)
-        changes = list(tree.iter_changes(tree.basis_tree()))
-        self.assertEqual(2, len(changes))
-        self.assertEqual((None, 'b'), changes[0][1])
-        self.assertEqual((None, 'c'), changes[1][1])
-
-    def test_commit_exclude_subtree_of_selected(self):
-        tree = self.make_branch_and_tree('.')
-        self.build_tree(['a/', 'a/b'])
-        tree.smart_add(['.'])
-        tree.commit('test', specific_files=['a'], exclude=['a/b'])
-        # If a/b was excluded it will still be 'added' in status.
-        tree.lock_read()
-        self.addCleanup(tree.unlock)
-        changes = list(tree.iter_changes(tree.basis_tree()))
-        self.assertEqual(1, len(changes))
-        self.assertEqual((None, 'a/b'), changes[0][1])
-
     def test_commit_sets_last_revision(self):
         tree = self.make_branch_and_tree('tree')
         committed_id = tree.commit('foo', rev_id='foo')
@@ -544,8 +391,8 @@
         ui.ui_factory = factory
         def a_hook(_, _2, _3, _4, _5, _6):
             pass
-        branch.Branch.hooks.install_named_hook('post_commit', a_hook,
-                                               'hook name')
+        branch.Branch.hooks.install_hook('post_commit', a_hook)
+        branch.Branch.hooks.name_hook(a_hook, 'hook name')
         tree.commit('first post')
         self.assertEqual(
             [('update', 1, 5, 'Collecting changes [Directory 0] - Stage'),
@@ -569,8 +416,8 @@
         ui.ui_factory = factory
         def a_hook(_, _2, _3, _4, _5, _6, _7, _8):
             pass
-        branch.Branch.hooks.install_named_hook('pre_commit', a_hook,
-                                               'hook name')
+        branch.Branch.hooks.install_hook('pre_commit', a_hook)
+        branch.Branch.hooks.name_hook(a_hook, 'hook name')
         tree.commit('first post')
         self.assertEqual(
             [('update', 1, 5, 'Collecting changes [Directory 0] - Stage'),
@@ -583,21 +430,3 @@
              ],
             factory._calls
            )
-
-    def test_start_commit_hook(self):
-        """Make sure a start commit hook can modify the tree that is 
-        committed."""
-        def start_commit_hook_adds_file(tree):
-            open(tree.abspath("newfile"), 'w').write("data")
-            tree.add(["newfile"])
-        def restoreDefaults():
-            mutabletree.MutableTree.hooks['start_commit'] = []
-        self.addCleanup(restoreDefaults)
-        tree = self.make_branch_and_tree('.')
-        mutabletree.MutableTree.hooks.install_named_hook(
-            'start_commit',
-            start_commit_hook_adds_file,
-            None)
-        revid = tree.commit('first post')
-        committed_tree = tree.basis_tree()
-        self.assertTrue(committed_tree.has_filename("newfile"))

=== modified file 'bzrlib/tests/workingtree_implementations/test_inv.py'
--- bzrlib/tests/workingtree_implementations/test_inv.py	2007-12-31 16:10:05 +0000
+++ bzrlib/tests/workingtree_implementations/test_inv.py	2007-10-03 05:04:42 +0000
@@ -78,7 +78,6 @@
         wt.apply_inventory_delta([('foo', 'baz', 'foo-id',
             inventory.InventoryDirectory('foo-id', 'baz', root_id))])
         # foo/bar should have been followed the rename of its parent to baz/bar
-        self.assertEqual('baz', wt.id2path('foo-id'))
         self.assertEqual('baz/bar', wt.id2path('bar-id'))
 
     def test_rename_dir_with_children_with_children(self):

=== modified file 'bzrlib/tests/workingtree_implementations/test_locking.py'
--- bzrlib/tests/workingtree_implementations/test_locking.py	2008-03-17 04:38:59 +0000
+++ bzrlib/tests/workingtree_implementations/test_locking.py	2006-10-13 07:39:25 +0000
@@ -228,7 +228,13 @@
         branch_copy.lock_write()
         try:
             try:
-                self.assertRaises(errors.LockError, wt.lock_write)
+                orig_default = lockdir._DEFAULT_TIMEOUT_SECONDS
+                try:
+                    lockdir._DEFAULT_TIMEOUT_SECONDS = 1
+                    self.assertRaises(errors.LockError, wt.lock_write)
+                finally:
+                    lockdir._DEFAULT_TIMEOUT_SECONDS = orig_default
+
                 self.assertFalse(wt.is_locked())
                 self.assertFalse(wt.branch.is_locked())
             finally:

=== modified file 'bzrlib/tests/workingtree_implementations/test_merge_from_branch.py'
--- bzrlib/tests/workingtree_implementations/test_merge_from_branch.py	2008-03-07 14:15:10 +0000
+++ bzrlib/tests/workingtree_implementations/test_merge_from_branch.py	2007-07-25 21:25:00 +0000
@@ -69,7 +69,7 @@
         tree_a.merge_from_branch(tree_b.branch)
         tree_a.lock_read()
         self.addCleanup(tree_a.unlock)
-        list(tree_a.iter_changes(tree_a.basis_tree()))
+        list(tree_a._iter_changes(tree_a.basis_tree()))
 
     def test_merge_empty(self):
         tree_a = self.make_branch_and_tree('tree_a')
@@ -96,7 +96,7 @@
         tree_a.merge_from_branch(tree_b.branch, from_revision='rev_1')
         tree_a.lock_read()
         self.addCleanup(tree_a.unlock)
-        changes = list(tree_a.iter_changes(tree_a.basis_tree()))
+        changes = list(tree_a._iter_changes(tree_a.basis_tree()))
         self.assertEqual(1, len(changes))
 
     def test_merge_type(self):

=== modified file 'bzrlib/tests/workingtree_implementations/test_parents.py'
--- bzrlib/tests/workingtree_implementations/test_parents.py	2008-06-02 16:09:09 +0000
+++ bzrlib/tests/workingtree_implementations/test_parents.py	2007-10-12 08:00:07 +0000
@@ -51,6 +51,9 @@
                              _mod_revision.ensure_null(tree.last_revision()))
         else:
             self.assertEqual(expected[0], tree.last_revision())
+        self.assertEqual(expected[1:],
+            self.applyDeprecated(symbol_versioning.zero_eleven,
+                tree.pending_merges))
 
 
 class TestGetParents(TestParents):
@@ -160,73 +163,6 @@
         self.assertConsistentParents(
             [first_revision, second_revision, third_revision], t)
 
-    def test_set_duplicate_parent_ids(self):
-        t = self.make_branch_and_tree('.')
-        rev1 = t.commit('first post')
-        uncommit(t.branch, tree=t)
-        rev2 = t.commit('second post')
-        uncommit(t.branch, tree=t)
-        rev3 = t.commit('third post')
-        uncommit(t.branch, tree=t)
-        t.set_parent_ids([rev1, rev2, rev2, rev3])
-        # We strip the duplicate, but preserve the ordering
-        self.assertConsistentParents([rev1, rev2, rev3], t)
-
-    def test_set_duplicate_parent_trees(self):
-        t = self.make_branch_and_tree('.')
-        rev1 = t.commit('first post')
-        uncommit(t.branch, tree=t)
-        rev2 = t.commit('second post')
-        uncommit(t.branch, tree=t)
-        rev3 = t.commit('third post')
-        uncommit(t.branch, tree=t)
-        rev_tree1 = t.branch.repository.revision_tree(rev1)
-        rev_tree2 = t.branch.repository.revision_tree(rev2)
-        rev_tree3 = t.branch.repository.revision_tree(rev3)
-        t.set_parent_trees([(rev1, rev_tree1), (rev2, rev_tree2),
-                            (rev2, rev_tree2), (rev3, rev_tree3)])
-        # We strip the duplicate, but preserve the ordering
-        self.assertConsistentParents([rev1, rev2, rev3], t)
-
-    def test_set_parent_ids_in_ancestry(self):
-        t = self.make_branch_and_tree('.')
-        rev1 = t.commit('first post')
-        rev2 = t.commit('second post')
-        rev3 = t.commit('third post')
-        # Reset the tree, back to rev1
-        t.set_parent_ids([rev1])
-        t.branch.set_last_revision_info(1, rev1)
-        self.assertConsistentParents([rev1], t)
-        t.set_parent_ids([rev1, rev2, rev3])
-        # rev2 is in the ancestry of rev3, so it will be filtered out
-        self.assertConsistentParents([rev1, rev3], t)
-        # Order should be preserved, and the first revision should always be
-        # kept
-        t.set_parent_ids([rev2, rev3, rev1])
-        self.assertConsistentParents([rev2, rev3], t)
-
-    def test_set_parent_trees_in_ancestry(self):
-        t = self.make_branch_and_tree('.')
-        rev1 = t.commit('first post')
-        rev2 = t.commit('second post')
-        rev3 = t.commit('third post')
-        # Reset the tree, back to rev1
-        t.set_parent_ids([rev1])
-        t.branch.set_last_revision_info(1, rev1)
-        self.assertConsistentParents([rev1], t)
-        rev_tree1 = t.branch.repository.revision_tree(rev1)
-        rev_tree2 = t.branch.repository.revision_tree(rev2)
-        rev_tree3 = t.branch.repository.revision_tree(rev3)
-        t.set_parent_trees([(rev1, rev_tree1), (rev2, rev_tree2),
-                            (rev3, rev_tree3)])
-        # rev2 is in the ancestry of rev3, so it will be filtered out
-        self.assertConsistentParents([rev1, rev3], t)
-        # Order should be preserved, and the first revision should always be
-        # kept
-        t.set_parent_trees([(rev2, rev_tree2), (rev1, rev_tree1),
-                            (rev3, rev_tree3)])
-        self.assertConsistentParents([rev2, rev3], t)
-
 
 class TestAddParent(TestParents):
 
@@ -313,7 +249,7 @@
         self.assertConsistentParents([first_revision, 'second'], tree)
 
 
-class UpdateToOneParentViaDeltaTests(TestCaseWithWorkingTree):
+class UpdateToOneParentViaDeltaTests(TestParents):
     """Tests for the update_basis_by_delta call.
     
     This is intuitively defined as 'apply an inventory delta to the basis and
@@ -324,11 +260,7 @@
 
     def assertDeltaApplicationResultsInExpectedBasis(self, tree, revid, delta,
         expected_inventory):
-        tree.lock_write()
-        try:
-            tree.update_basis_by_delta(revid, delta)
-        finally:
-            tree.unlock()
+        tree.update_basis_by_delta(revid, delta)
         # check the last revision was adjusted to rev_id
         self.assertEqual(revid, tree.last_revision())
         # check the parents are what we expect
@@ -422,14 +354,8 @@
                 parents.append(extra_parent)
             tree.set_parent_ids(parents)
         self.fake_up_revision(tree, new_revid, new_shape)
-        # give tree an inventory of new_shape
-        tree._write_inventory(new_shape)
         self.assertDeltaApplicationResultsInExpectedBasis(tree, new_revid,
             delta, new_shape)
-        # The tree should be internally consistent; while this is a moderately
-        # large hammer, this is a particularly sensitive area of code, so the
-        # extra assurance is well worth it.
-        tree._validate()
         osutils.rmtree('tree')
 
     def test_no_parents_just_root(self):
@@ -561,53 +487,6 @@
         self.assertTransitionFromBasisToShape(basis_shape, old_revid,
             new_shape, new_revid)
 
-    def test_parent_child_swap(self):
-        # test a A->A/B and A/B->A path swap.
-        old_revid = 'old-parent'
-        basis_shape = Inventory(root_id=None)
-        self.add_dir(basis_shape, old_revid, 'root-id', None, '')
-        self.add_dir(basis_shape, old_revid, 'dir-id-A', 'root-id', 'A')
-        self.add_dir(basis_shape, old_revid, 'dir-id-B', 'dir-id-A', 'B')
-        self.add_link(basis_shape, old_revid, 'link-id-C', 'dir-id-B', 'C', 'C')
-        new_revid = 'new-parent'
-        new_shape = Inventory(root_id=None)
-        self.add_new_root(new_shape, old_revid, new_revid)
-        self.add_dir(new_shape, new_revid, 'dir-id-B', 'root-id', 'A')
-        self.add_dir(new_shape, new_revid, 'dir-id-A', 'dir-id-B', 'B')
-        self.add_link(new_shape, new_revid, 'link-id-C', 'dir-id-A', 'C', 'C')
-        self.assertTransitionFromBasisToShape(basis_shape, old_revid,
-            new_shape, new_revid)
-
-    def test_parent_deleted_child_renamed(self):
-        # test a A->None and A/B->A.
-        old_revid = 'old-parent'
-        basis_shape = Inventory(root_id=None)
-        self.add_dir(basis_shape, old_revid, 'root-id', None, '')
-        self.add_dir(basis_shape, old_revid, 'dir-id-A', 'root-id', 'A')
-        self.add_dir(basis_shape, old_revid, 'dir-id-B', 'dir-id-A', 'B')
-        self.add_link(basis_shape, old_revid, 'link-id-C', 'dir-id-B', 'C', 'C')
-        new_revid = 'new-parent'
-        new_shape = Inventory(root_id=None)
-        self.add_new_root(new_shape, old_revid, new_revid)
-        self.add_dir(new_shape, new_revid, 'dir-id-B', 'root-id', 'A')
-        self.add_link(new_shape, old_revid, 'link-id-C', 'dir-id-B', 'C', 'C')
-        self.assertTransitionFromBasisToShape(basis_shape, old_revid,
-            new_shape, new_revid)
-
-    def test_dir_to_root(self):
-        # test a A->''.
-        old_revid = 'old-parent'
-        basis_shape = Inventory(root_id=None)
-        self.add_dir(basis_shape, old_revid, 'root-id', None, '')
-        self.add_dir(basis_shape, old_revid, 'dir-id-A', 'root-id', 'A')
-        self.add_link(basis_shape, old_revid, 'link-id-B', 'dir-id-A', 'B', 'B')
-        new_revid = 'new-parent'
-        new_shape = Inventory(root_id=None)
-        self.add_dir(new_shape, new_revid, 'dir-id-A', None, '')
-        self.add_link(new_shape, old_revid, 'link-id-B', 'dir-id-A', 'B', 'B')
-        self.assertTransitionFromBasisToShape(basis_shape, old_revid,
-            new_shape, new_revid)
-
     def test_path_swap(self):
         # test a A->B and B->A path swap.
         old_revid = 'old-parent'
@@ -696,21 +575,3 @@
         self.add_link(new_shape, new_revid, 'link-id-B', 'root-id', 'B', 'C')
         self.assertTransitionFromBasisToShape(basis_shape, old_revid,
             new_shape, new_revid)
-
-    def test_move_moves_children_recursively(self):
-        old_revid = 'old-parent'
-        basis_shape = Inventory(root_id=None)
-        self.add_dir(basis_shape, old_revid, 'root-id', None, '')
-        self.add_dir(basis_shape, old_revid, 'dir-id-A', 'root-id', 'A')
-        self.add_dir(basis_shape, old_revid, 'dir-id-B', 'dir-id-A', 'B')
-        self.add_link(basis_shape, old_revid, 'link-id-C', 'dir-id-B', 'C', 'D')
-        new_revid = 'new-parent'
-        new_shape = Inventory(root_id=None)
-        self.add_new_root(new_shape, old_revid, new_revid)
-        # the moved path:
-        self.add_dir(new_shape, new_revid, 'dir-id-A', 'root-id', 'B')
-        # unmoved children.
-        self.add_dir(new_shape, old_revid, 'dir-id-B', 'dir-id-A', 'B')
-        self.add_link(new_shape, old_revid, 'link-id-C', 'dir-id-B', 'C', 'D')
-        self.assertTransitionFromBasisToShape(basis_shape, old_revid,
-            new_shape, new_revid)

=== modified file 'bzrlib/tests/workingtree_implementations/test_pull.py'
--- bzrlib/tests/workingtree_implementations/test_pull.py	2007-11-01 09:52:45 +0000
+++ bzrlib/tests/workingtree_implementations/test_pull.py	2006-09-05 08:14:23 +0000
@@ -21,6 +21,7 @@
 from bzrlib import errors
 from bzrlib.errors import NotBranchError, NotVersionedError
 from bzrlib.osutils import basename
+from bzrlib.tests import TestSkipped
 from bzrlib.tests.workingtree_implementations import TestCaseWithWorkingTree
 from bzrlib.trace import mutter
 from bzrlib.transport import get_transport

=== modified file 'bzrlib/tests/workingtree_implementations/test_remove.py'
--- bzrlib/tests/workingtree_implementations/test_remove.py	2008-07-30 07:52:22 +0000
+++ bzrlib/tests/workingtree_implementations/test_remove.py	2007-08-13 20:00:03 +0000
@@ -67,9 +67,9 @@
     def test_remove_unchanged_files(self):
         """Check that unchanged files are removed and deleted."""
         tree = self.get_committed_tree(TestRemove.files)
+
         tree.remove(TestRemove.files, keep_files=False)
         self.assertRemovedAndDeleted(TestRemove.files)
-        tree._validate()
 
     def test_remove_added_files(self):
         """Removal of newly added files must fail."""
@@ -82,11 +82,10 @@
             '(?s)added:.*a.*b/.*b/c.*d/')
         self.assertInWorkingTree(TestRemove.files)
         self.failUnlessExists(TestRemove.files)
-        tree._validate()
 
     def test_remove_changed_file(self):
         """Removal of a changed files must fail."""
-        tree = self.get_committed_tree(['a'])
+        tree = self.get_committed_tree('a')
         self.build_tree_contents([('a', "some other new content!")])
         self.assertInWorkingTree('a')
         err = self.assertRaises(errors.BzrRemoveChangedFilesError, tree.remove,
@@ -94,7 +93,6 @@
         self.assertContainsRe(err.changes_as_text, '(?s)modified:.*a')
         self.assertInWorkingTree('a')
         self.failUnlessExists('a')
-        tree._validate()
 
     def test_remove_deleted_files(self):
         """Check that files are removed if they don't exist any more."""
@@ -103,9 +101,9 @@
             osutils.delete_any(f)
         self.assertInWorkingTree(TestRemove.files)
         self.failIfExists(TestRemove.files)
+
         tree.remove(TestRemove.files, keep_files=False)
         self.assertRemovedAndDeleted(TestRemove.files)
-        tree._validate()
 
     def test_remove_renamed_files(self):
         """Check that files are removed even if they are renamed."""
@@ -119,7 +117,6 @@
 
         tree.remove(rfilesx, keep_files=False)
         self.assertRemovedAndDeleted(rfilesx)
-        tree._validate()
 
     def test_remove_renamed_changed_files(self):
         """Check that files are not removed if they are renamed and changed."""
@@ -139,7 +136,6 @@
             '(?s)modified:.*ax.*bx/cx')
         self.assertInWorkingTree(rfilesx)
         self.failUnlessExists(rfilesx)
-        tree._validate()
 
     def test_force_remove_changed_files(self):
         """Check that changed files are removed and deleted when forced."""
@@ -149,7 +145,6 @@
 
         tree.remove(TestRemove.files, keep_files=False, force=True)
         self.assertRemovedAndDeleted(TestRemove.files)
-        tree._validate()
 
     def test_remove_unknown_files(self):
         """Try to delete unknown files."""
@@ -158,14 +153,12 @@
             TestRemove.files, keep_files=False)
         self.assertContainsRe(err.changes_as_text,
             '(?s)unknown:.*d/.*b/c.*b/.*a.*')
-        tree._validate()
 
     def test_remove_nonexisting_files(self):
         """Try to delete non-existing files."""
         tree = self.get_tree(TestRemove.files)
         tree.remove([''], keep_files=False)
         tree.remove(['xyz', 'abc/def'], keep_files=False)
-        tree._validate()
 
     def test_remove_unchanged_directory(self):
         """Unchanged directories should be deleted."""
@@ -173,16 +166,6 @@
         tree = self.get_committed_tree(files)
         tree.remove('b', keep_files=False)
         self.assertRemovedAndDeleted('b')
-        tree._validate()
-
-    def test_remove_absent_directory(self):
-        """Removing a absent directory succeeds without corruption (#150438)."""
-        paths = ['a/', 'a/b']
-        tree = self.get_committed_tree(paths)
-        self.get_transport('.').delete_tree('a')
-        tree.remove(['a'])
-        self.assertRemovedAndDeleted('b')
-        tree._validate()
 
     def test_remove_unknown_ignored_files(self):
         """Unknown ignored files should be deleted."""
@@ -199,22 +182,6 @@
         self.assertNotEquals(None, tree.is_ignored('b/unknown_ignored_dir'))
         tree.remove('b', keep_files=False)
         self.assertRemovedAndDeleted('b')
-        tree._validate()
-
-    def test_remove_changed_ignored_files(self):
-        """Changed ignored files should not be deleted."""
-        files = ['an_ignored_file']
-        tree = self.get_tree(files)
-        tree.add(files)
-        ignores.add_runtime_ignores(["*ignored*"])
-        self.assertInWorkingTree(files)
-        self.assertNotEquals(None, tree.is_ignored(files[0]))
-        err = self.assertRaises(errors.BzrRemoveChangedFilesError, tree.remove,
-            files, keep_files=False)
-        self.assertContainsRe(err.changes_as_text,
-            '(?s)added:.*' + files[0])
-        self.assertInWorkingTree(files)
-        tree._validate()
 
     def test_dont_remove_directory_with_unknowns(self):
         """Directories with unknowns should not be deleted."""
@@ -241,7 +208,6 @@
 
         self.assertInWorkingTree(directories)
         self.failUnlessExists(directories)
-        tree._validate()
 
     def test_force_remove_directory_with_unknowns(self):
         """Unchanged non-empty directories should be deleted when forced."""
@@ -259,7 +225,6 @@
 
         self.assertRemovedAndDeleted(files)
         self.assertRemovedAndDeleted(other_files)
-        tree._validate()
 
     def test_remove_directory_with_changed_file(self):
         """Refuse to delete directories with changed files."""
@@ -276,7 +241,6 @@
         # see if we can force it now..
         tree.remove('b', keep_files=False, force=True)
         self.assertRemovedAndDeleted(files)
-        tree._validate()
 
     def test_remove_directory_with_renames(self):
         """Delete directory with renames in or out."""
@@ -300,7 +264,6 @@
         # check if it works with renames in
         tree.remove('b', keep_files=False)
         self.assertRemovedAndDeleted(['b/'])
-        tree._validate()
 
     def test_non_cwd(self):
         tree = self.make_branch_and_tree('tree')
@@ -310,20 +273,3 @@
         tree.remove('dir/', keep_files=False)
         self.failIfExists('tree/dir/file')
         self.assertNotInWorkingTree('tree/dir/file', 'tree')
-        tree._validate()
-
-    def test_remove_uncommitted_removed_file(self):
-        # As per bug #152811
-        tree = self.get_committed_tree(['a'])
-        tree.remove('a', keep_files=False)
-        tree.remove('a', keep_files=False)
-        self.failIfExists('a')
-        tree._validate()
-
-    def test_remove_file_and_containing_dir(self):
-        tree = self.get_committed_tree(['config/', 'config/file'])
-        tree.remove('config/file', keep_files=False)
-        tree.remove('config', keep_files=False)
-        self.failIfExists('config/file')
-        self.failIfExists('config')
-        tree._validate()

=== modified file 'bzrlib/tests/workingtree_implementations/test_rename_one.py'
--- bzrlib/tests/workingtree_implementations/test_rename_one.py	2008-01-28 22:41:25 +0000
+++ bzrlib/tests/workingtree_implementations/test_rename_one.py	2007-09-17 05:33:56 +0000
@@ -314,4 +314,4 @@
         self.build_tree(['a'])
         tree.add(['a'])
         self.assertRaises((errors.InvalidNormalization, UnicodeEncodeError),
-            tree.rename_one, 'a', u'ba\u030arry')
+            tree.rename_one, 'a', u'b\xb5rry')

=== modified file 'bzrlib/tests/workingtree_implementations/test_set_root_id.py'
--- bzrlib/tests/workingtree_implementations/test_set_root_id.py	2008-05-02 07:31:24 +0000
+++ bzrlib/tests/workingtree_implementations/test_set_root_id.py	2007-02-18 00:22:24 +0000
@@ -17,11 +17,22 @@
 """Tests for WorkingTree.set_root_id"""
 
 from bzrlib import inventory
+from bzrlib.symbol_versioning import zero_twelve
 from bzrlib.tests.workingtree_implementations import TestCaseWithWorkingTree
 
 
 class TestSetRootId(TestCaseWithWorkingTree):
 
+    def test_set_None(self):
+        # setting the root_id to None is equivalent to setting it
+        # to inventory.ROOT_ID
+        tree = self.make_branch_and_tree('a-tree')
+        self.callDeprecated([
+            'WorkingTree.set_root_id with fileid=None was deprecated in version'
+            ' 0.12.'],
+            tree.set_root_id, None)
+        self.assertEqual(inventory.ROOT_ID, tree.get_root_id())
+
     def test_set_and_read_unicode(self):
         tree = self.make_branch_and_tree('a-tree')
         # setting the root id allows it to be read via get_root_id.

=== modified file 'bzrlib/tests/workingtree_implementations/test_unversion.py'
--- bzrlib/tests/workingtree_implementations/test_unversion.py	2007-10-26 19:18:48 +0000
+++ bzrlib/tests/workingtree_implementations/test_unversion.py	2007-03-01 01:56:28 +0000
@@ -16,10 +16,7 @@
 
 """Tests of the WorkingTree.unversion API."""
 
-from bzrlib import (
-    errors,
-    osutils,
-    )
+from bzrlib import errors
 from bzrlib.tests.workingtree_implementations import TestCaseWithWorkingTree
 
 
@@ -102,91 +99,3 @@
             self.assertTrue(tree.has_filename('d'))
         finally:
             tree.unlock()
-
-    def test_unversion_renamed(self):
-        tree = self.make_branch_and_tree('a')
-        self.build_tree(['a/dir/', 'a/dir/f1', 'a/dir/f2', 'a/dir/f3',
-                         'a/dir2/'])
-        tree.add(['dir', 'dir/f1', 'dir/f2', 'dir/f3', 'dir2'],
-                 ['dir-id', 'f1-id', 'f2-id', 'f3-id', 'dir2-id'])
-        rev_id1 = tree.commit('init')
-        # Start off by renaming entries, and then unversion a bunch of entries
-        # https://bugs.launchpad.net/bzr/+bug/114615
-        tree.rename_one('dir/f1', 'dir/a')
-        tree.rename_one('dir/f2', 'dir/z')
-        tree.move(['dir/f3'], 'dir2')
-
-        tree.lock_read()
-        try:
-            root_id = tree.get_root_id()
-            paths = [(path, ie.file_id)
-                     for path, ie in tree.iter_entries_by_dir()]
-        finally:
-            tree.unlock()
-        self.assertEqual([('', root_id),
-                          ('dir', 'dir-id'),
-                          ('dir2', 'dir2-id'),
-                          ('dir/a', 'f1-id'),
-                          ('dir/z', 'f2-id'),
-                          ('dir2/f3', 'f3-id'),
-                         ], paths)
-
-        tree.unversion(set(['dir-id']))
-        paths = [(path, ie.file_id)
-                 for path, ie in tree.iter_entries_by_dir()]
-
-        self.assertEqual([('', root_id),
-                          ('dir2', 'dir2-id'),
-                          ('dir2/f3', 'f3-id'),
-                         ], paths)
-
-    def test_unversion_after_conflicted_merge(self):
-        # Test for bug #114615
-        tree_a = self.make_branch_and_tree('A')
-        self.build_tree(['A/a/', 'A/a/m', 'A/a/n'])
-        tree_a.add(['a', 'a/m', 'a/n'], ['a-id', 'm-id', 'n-id'])
-        tree_a.commit('init')
-
-        tree_a.lock_read()
-        try:
-            root_id = tree_a.get_root_id()
-        finally:
-            tree_a.unlock()
-
-        tree_b = tree_a.bzrdir.sprout('B').open_workingtree()
-        self.build_tree(['B/xyz/'])
-        tree_b.add(['xyz'], ['xyz-id'])
-        tree_b.rename_one('a/m', 'xyz/m')
-        tree_b.unversion(['a-id'])
-        tree_b.commit('delete in B')
-
-        paths = [(path, ie.file_id)
-                 for path, ie in tree_b.iter_entries_by_dir()]
-        self.assertEqual([('', root_id),
-                          ('xyz', 'xyz-id'),
-                          ('xyz/m', 'm-id'),
-                         ], paths)
-
-        self.build_tree_contents([('A/a/n', 'new contents for n\n')])
-        tree_a.commit('change n in A')
-
-        # Merging from A should introduce conflicts because 'n' was modified
-        # and removed, so 'a' needs to be restored. We also have a conflict
-        # because 'a' is still an existing directory
-        num_conflicts = tree_b.merge_from_branch(tree_a.branch)
-        self.assertEqual(4, num_conflicts)
-        paths = [(path, ie.file_id)
-                 for path, ie in tree_b.iter_entries_by_dir()]
-        self.assertEqual([('', root_id),
-                          ('a', 'a-id'),
-                          ('xyz', 'xyz-id'),
-                          ('a/n.OTHER', 'n-id'),
-                          ('xyz/m', 'm-id'),
-                         ], paths)
-        tree_b.unversion(['a-id'])
-        paths = [(path, ie.file_id)
-                 for path, ie in tree_b.iter_entries_by_dir()]
-        self.assertEqual([('', root_id),
-                          ('xyz', 'xyz-id'),
-                          ('xyz/m', 'm-id'),
-                         ], paths)

=== modified file 'bzrlib/tests/workingtree_implementations/test_walkdirs.py'
--- bzrlib/tests/workingtree_implementations/test_walkdirs.py	2008-05-08 04:21:01 +0000
+++ bzrlib/tests/workingtree_implementations/test_walkdirs.py	2007-04-14 12:17:31 +0000
@@ -19,152 +19,128 @@
 import os
 
 from bzrlib import transform
-from bzrlib.tests import SymlinkFeature
+from bzrlib.osutils import has_symlinks
+from bzrlib.tests import TestSkipped
 from bzrlib.tests.workingtree_implementations import TestCaseWithWorkingTree
 
 # tests to write:
 # type mismatches - file to link, dir, dir to file, link, link to file, dir
 
-class DirBlock:
-    """Object representation of the tuples returned by dirstate."""
-
-    def __init__(self, tree, file_path, file_name=None, id=None,
-                 inventory_kind=None, stat=None, disk_kind='unknown'):
-        self.file_path = file_path
-        self.abspath = tree.abspath(file_path)
-        self.relpath = tree.relpath(file_path)
-        if file_name is None:
-           file_name = os.path.split(file_path)[-1]
-           if len(file_name) == 0:
-               file_name = os.path.split(file_path)[-2]
-        self.file_name = file_name
-        self.id = id
-        self.inventory_kind = inventory_kind
-        self.stat = stat
-        self.disk_kind = disk_kind
-
-    def as_tuple(self):
-         return (self.relpath, self.file_name, self.disk_kind,
-                 self.stat, self.id, self.inventory_kind)
-
-    def as_dir_tuple(self):
-         return (self.relpath, self.id)
-
-    def __str__(self):
-        return """
-file_path      = %r
-abspath        = %r
-relpath        = %r
-file_name      = %r
-id             = %r
-inventory_kind = %r
-stat           = %r
-disk_kind      = %r""" % (self.file_path, self.abspath, self.relpath,
-        self.file_name, self.id, self.inventory_kind, self.stat,
-        self.disk_kind)
-
-
 class TestWalkdirs(TestCaseWithWorkingTree):
 
-    added='added'
-    missing='missing'
-    unknown='unknown'
-
-    def get_tree(self, file_status, prefix=None):
+    def get_tree_with_unknowns(self):
         tree = self.make_branch_and_tree('.')
-        dirblocks = []
-        paths = [
-            file_status + ' file',
-            file_status + ' dir/',
-            file_status + ' dir/a file',
-            file_status + ' empty dir/',
-            ]
-        self.build_tree(paths)
-
-        def add_dirblock(path, kind):
-            dirblock = DirBlock(tree, path)
-            if file_status != self.unknown:
-                dirblock.id = 'a ' + str(path).replace('/','-') + '-id'
-                dirblock.inventory_kind = kind
-            if file_status != self.missing:
-                dirblock.disk_kind = kind
-                dirblock.stat = os.lstat(dirblock.relpath)
-            dirblocks.append(dirblock)
-
-        add_dirblock(paths[0], 'file')
-        add_dirblock(paths[1], 'directory')
-        add_dirblock(paths[2], 'file')
-        add_dirblock(paths[3], 'directory')
-
-        if file_status != self.unknown:
-            tree.add(paths, [db.id for db in dirblocks])
-
-        if file_status == self.missing:
-            # now make the files be missing
-            tree.bzrdir.root_transport.delete(dirblocks[0].relpath)
-            tree.bzrdir.root_transport.delete_tree(dirblocks[1].relpath)
-            tree.bzrdir.root_transport.delete_tree(dirblocks[3].relpath)
-
+        self.build_tree([
+            'unknown file',
+            'unknown dir/',
+            'unknown dir/a file',
+            ])
+        u_f_stat = os.lstat('unknown file')
+        u_d_stat = os.lstat('unknown dir')
+        u_d_f_stat = os.lstat('unknown dir/a file')
         expected_dirblocks = [
             (('', tree.path2id('')),
-             [dirblocks[1].as_tuple(), dirblocks[3].as_tuple(),
-              dirblocks[0].as_tuple()]
-            ),
-            (dirblocks[1].as_dir_tuple(),
-             [dirblocks[2].as_tuple()]
-            ),
-            (dirblocks[3].as_dir_tuple(),
-             []
+             [
+              ('unknown dir', 'unknown dir', 'directory', u_d_stat, None, None),
+              ('unknown file', 'unknown file', 'file', u_f_stat, None, None),
+             ]
+            ),
+            (('unknown dir', None),
+             [('unknown dir/a file', 'a file', 'file', u_d_f_stat, None, None),
+             ]
             ),
             ]
-        if prefix:
-            expected_dirblocks = [e for e in expected_dirblocks
-                if len(e) > 0 and len(e[0]) > 0 and e[0][0] == prefix]
         return tree, expected_dirblocks
-
-    def _test_walkdir(self, file_status, prefix=""):
-        result = []
-        tree, expected_dirblocks = self.get_tree(file_status, prefix)
-        tree.lock_read()
-        for dirinfo, dirblock in tree.walkdirs(prefix):
-            result.append((dirinfo, list(dirblock)))
-        tree.unlock()
-
-        # check each return value for debugging ease.
-        for pos, item in enumerate(expected_dirblocks):
-            result_pos = []
-            if len(result) > pos:
-                result_pos = result[pos]
-            self.assertEqual(item, result_pos)
-        self.assertEqual(expected_dirblocks, result)
-
+    
     def test_walkdir_unknowns(self):
         """unknown files and directories should be reported by walkdirs."""
-        self._test_walkdir(self.unknown)
+        # test that its iterable by iterating:
+        result = []
+        tree, expected_dirblocks = self.get_tree_with_unknowns()
+        tree.lock_read()
+        for dirinfo, dirblock in tree.walkdirs():
+            result.append((dirinfo, list(dirblock)))
+        tree.unlock()
+        # check each return value for debugging ease.
+        for pos, item in enumerate(expected_dirblocks):
+            self.assertEqual(item, result[pos])
+        self.assertEqual(len(expected_dirblocks), len(result))
 
     def test_walkdir_from_unknown_dir(self):
         """Doing a walkdir when the requested prefix is unknown but on disk."""
-        self._test_walkdir(self.unknown, 'unknown dir')
+        result = []
+        tree, expected_dirblocks = self.get_tree_with_unknowns()
+        tree.lock_read()
+        for dirinfo, dirblock in tree.walkdirs('unknown dir'):
+            result.append((dirinfo, list(dirblock)))
+        tree.unlock()
+        # check each return value for debugging ease.
+        for pos, item in enumerate(expected_dirblocks[1:]):
+            self.assertEqual(item, result[pos])
+        self.assertEqual(len(expected_dirblocks) - 1, len(result))
 
+    def get_tree_with_missings(self):
+        tree = self.make_branch_and_tree('.')
+        paths = [
+            'missing file',
+            'missing dir/',
+            'missing dir/a file',
+            ]
+        ids = [
+            'a file',
+            'a dir',
+            'a dir-a file',
+            ]
+        self.build_tree(paths)
+        tree.add(paths, ids)
+        # now make the files be missing
+        tree.bzrdir.root_transport.delete_tree('missing dir')
+        tree.bzrdir.root_transport.delete('missing file')
+        expected_dirblocks = [
+            (('', tree.path2id('')),
+             [
+              ('missing dir', 'missing dir', 'unknown', None, 'a dir', 'directory'),
+              ('missing file', 'missing file', 'unknown', None, 'a file', 'file'),
+             ]
+            ),
+            (('missing dir', 'a dir'),
+             [('missing dir/a file', 'a file', 'unknown', None, 'a dir-a file', 'file'),
+             ]
+            ),
+            ]
+        return tree, expected_dirblocks
+    
     def test_walkdir_missings(self):
         """missing files and directories should be reported by walkdirs."""
-        self._test_walkdir(self.missing)
-
-    def test_walkdir_from_dir(self):
-        """Doing a walkdir when the requested prefix is known and on disk."""
-        self._test_walkdir(self.added, 'added dir')
-
-    def test_walkdir_from_empty_dir(self):
-        """Doing a walkdir when the requested prefix is empty dir."""
-        self._test_walkdir(self.added, 'added empty dir')
+        # test that its iterable by iterating:
+        result = []
+        tree, expected_dirblocks = self.get_tree_with_missings()
+        tree.lock_read()
+        for dirinfo, dirblock in tree.walkdirs():
+            result.append((dirinfo, list(dirblock)))
+        tree.unlock()
+        # check each return value for debugging ease.
+        for pos, item in enumerate(expected_dirblocks):
+            self.assertEqual(item, result[pos])
+        self.assertEqual(len(expected_dirblocks), len(result))
 
     def test_walkdir_from_missing_dir(self):
         """Doing a walkdir when the requested prefix is missing but on disk."""
-        self._test_walkdir(self.missing, 'missing dir')
+        result = []
+        tree, expected_dirblocks = self.get_tree_with_missings()
+        tree.lock_read()
+        for dirinfo, dirblock in tree.walkdirs('missing dir'):
+            result.append((dirinfo, list(dirblock)))
+        tree.unlock()
+        # check each return value for debugging ease.
+        for pos, item in enumerate(expected_dirblocks[1:]):
+            self.assertEqual(item, result[pos])
+        self.assertEqual(len(expected_dirblocks[1:]), len(result))
 
     def test_walkdirs_type_changes(self):
         """Walkdir shows the actual kinds on disk and the recorded kinds."""
-        self.requireFeature(SymlinkFeature)
+        if not has_symlinks():
+            raise TestSkipped('No symlink support')
         tree = self.make_branch_and_tree('.')
         paths = ['file1', 'file2', 'dir1/', 'dir2/']
         ids = ['file1', 'file2', 'dir1', 'dir2']

=== modified file 'bzrlib/tests/workingtree_implementations/test_workingtree.py'
--- bzrlib/tests/workingtree_implementations/test_workingtree.py	2008-07-08 14:55:19 +0000
+++ bzrlib/tests/workingtree_implementations/test_workingtree.py	2007-08-29 16:09:51 +0000
@@ -17,19 +17,11 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 from cStringIO import StringIO
-import errno
 import os
 import sys
 
-from bzrlib import (
-    branch,
-    bzrdir,
-    errors,
-    osutils,
-    tests,
-    urlutils,
-    workingtree,
-    )
+import bzrlib
+from bzrlib import branch, bzrdir, errors, osutils, urlutils, workingtree
 from bzrlib.errors import (NotBranchError, NotVersionedError,
                            UnsupportedOperation, PathsNotVersionedError)
 from bzrlib.inventory import Inventory
@@ -38,10 +30,11 @@
 from bzrlib.tests.workingtree_implementations import TestCaseWithWorkingTree
 from bzrlib.trace import mutter
 from bzrlib.workingtree import (TreeEntry, TreeDirectory, TreeFile, TreeLink,
-                                WorkingTree, WorkingTree2)
+                                WorkingTree)
 from bzrlib.conflicts import ConflictList, TextConflict, ContentsConflict
 
 
+
 class TestWorkingTree(TestCaseWithWorkingTree):
 
     def test_list_files(self):
@@ -586,7 +579,7 @@
         # FIXME: This doesn't really test that it works; also this is not
         # implementation-independent. mbp 20070226
         tree = self.make_branch_and_tree('master')
-        tree._transport.put_bytes('merge-hashes', 'asdfasdf')
+        tree._control_files.put('merge-hashes', StringIO('asdfasdf'))
         self.assertRaises(errors.MergeModifiedFormatError, tree.merge_modified)
 
     def test_merge_modified(self):
@@ -615,11 +608,11 @@
             
         tree2 = WorkingTree.open('master')
         self.assertEqual(tree2.conflicts(), example_conflicts)
-        tree2._transport.put_bytes('conflicts', '')
-        self.assertRaises(errors.ConflictFormatError,
+        tree2._control_files.put('conflicts', StringIO(''))
+        self.assertRaises(errors.ConflictFormatError, 
                           tree2.conflicts)
-        tree2._transport.put_bytes('conflicts', 'a')
-        self.assertRaises(errors.ConflictFormatError,
+        tree2._control_files.put('conflicts', StringIO('a'))
+        self.assertRaises(errors.ConflictFormatError, 
                           tree2.conflicts)
 
     def make_merge_conflicts(self):
@@ -649,7 +642,7 @@
         try:
             tree.set_conflicts(ConflictList())
         except UnsupportedOperation:
-            raise TestSkipped('unsupported operation')
+            raise TestSkipped
         self.assertEqual(tree.conflicts(), ConflictList())
 
     def test_add_conflicts(self):
@@ -657,7 +650,7 @@
         try:
             tree.add_conflicts([TextConflict('path_a')])
         except UnsupportedOperation:
-            raise TestSkipped('unsupported operation')
+            raise TestSkipped()
         self.assertEqual(ConflictList([TextConflict('path_a')]),
                          tree.conflicts())
         tree.add_conflicts([TextConflict('path_a')])
@@ -752,7 +745,7 @@
         # if we write write an inventory then do a walkdirs we should get back
         # missing entries, and actual, and unknowns as appropriate.
         self.build_tree(['present', 'unknown'])
-        inventory = Inventory(tree.get_root_id())
+        inventory = Inventory(tree.path2id(''))
         inventory.add_path('missing', 'file', 'missing-id')
         inventory.add_path('present', 'file', 'present-id')
         # there is no point in being able to write an inventory to an unlocked
@@ -765,7 +758,7 @@
             present_stat = os.lstat('present')
             unknown_stat = os.lstat('unknown')
             expected_results = [
-                (('', tree.get_root_id()),
+                (('', tree.inventory.root.file_id),
                  [('missing', 'missing', 'unknown', None, 'missing-id', 'file'),
                   ('present', 'present', 'file', present_stat, 'present-id', 'file'),
                   ('unknown', 'unknown', 'file', unknown_stat, None, None),
@@ -833,17 +826,6 @@
             expected_kind = names[i]
             self.assertEqual(expected_kind, actual_kind)
 
-    def test_stored_kind_with_missing(self):
-        tree = self.make_branch_and_tree('tree')
-        tree.lock_write()
-        self.addCleanup(tree.unlock)
-        self.build_tree(['tree/a', 'tree/b/'])
-        tree.add(['a', 'b'], ['a-id', 'b-id'])
-        os.unlink('tree/a')
-        os.rmdir('tree/b')
-        self.assertEqual('file', tree.stored_kind('a-id'))
-        self.assertEqual('directory', tree.stored_kind('b-id'))
-
     def test_missing_file_sha1(self):
         """If a file is missing, its sha1 should be reported as None."""
         tree = self.make_branch_and_tree('.')
@@ -866,81 +848,3 @@
         tree.commit('foo')
         tree.remove('file')
         self.assertRaises(errors.NoSuchId, tree.get_file_sha1, 'file-id')
-
-    def test_case_sensitive(self):
-        """If filesystem is case-sensitive, tree should report this.
-
-        We check case-sensitivity by creating a file with a lowercase name,
-        then testing whether it exists with an uppercase name.
-        """
-        self.build_tree(['filename'])
-        if os.path.exists('FILENAME'):
-            case_sensitive = False
-        else:
-            case_sensitive = True
-        tree = self.make_branch_and_tree('test')
-        if tree.__class__ == WorkingTree2:
-            raise TestSkipped('WorkingTree2 is not supported')
-        self.assertEqual(case_sensitive, tree.case_sensitive)
-
-    def test_all_file_ids_with_missing(self):
-        tree = self.make_branch_and_tree('tree')
-        tree.lock_write()
-        self.addCleanup(tree.unlock)
-        self.build_tree(['tree/a', 'tree/b'])
-        tree.add(['a', 'b'], ['a-id', 'b-id'])
-        os.unlink('tree/a')
-        self.assertEqual(set(['a-id', 'b-id', tree.get_root_id()]),
-                         tree.all_file_ids())
-
-    def test_sprout_hardlink(self):
-        source = self.make_branch_and_tree('source')
-        self.build_tree(['source/file'])
-        source.add('file')
-        source.commit('added file')
-        def fake_link(source, target):
-            raise OSError(errno.EPERM, 'Operation not permitted')
-        real_os_link = os.link
-        os.link = fake_link
-        try:
-            # Hard-link support is optional, so supplying hardlink=True may
-            # or may not raise an exception.  But if it does, it must be
-            # HardLinkNotSupported
-            try:
-                source.bzrdir.sprout('target', accelerator_tree=source,
-                                     hardlink=True)
-            except errors.HardLinkNotSupported:
-                pass
-        finally:
-            os.link = real_os_link
-
-
-class TestIllegalPaths(TestCaseWithWorkingTree):
-
-    def test_bad_fs_path(self):
-        self.requireFeature(tests.UTF8Filesystem)
-        # We require a UTF8 filesystem, because otherwise we would need to get
-        # tricky to figure out how to create an illegal filename.
-        # \xb5 is an illegal path because it should be \xc2\xb5 for UTF-8
-        tree = self.make_branch_and_tree('tree')
-        self.build_tree(['tree/subdir/'])
-        tree.add('subdir')
-
-        f = open('tree/subdir/m\xb5', 'wb')
-        try:
-            f.write('trivial\n')
-        finally:
-            f.close()
-
-        tree.lock_read()
-        self.addCleanup(tree.unlock)
-        basis = tree.basis_tree()
-        basis.lock_read()
-        self.addCleanup(basis.unlock)
-
-        e = self.assertListRaises(errors.BadFilenameEncoding,
-                                  tree.iter_changes, tree.basis_tree(),
-                                                     want_unversioned=True)
-        # We should display the relative path
-        self.assertEqual('subdir/m\xb5', e.filename)
-        self.assertEqual(osutils._fs_enc, e.fs_encoding)

=== modified file 'bzrlib/textinv.py'
--- bzrlib/textinv.py	2008-04-24 07:22:53 +0000
+++ bzrlib/textinv.py	2006-10-16 01:50:48 +0000
@@ -36,8 +36,7 @@
 
 
 def unescape(s):
-    if s.find(' ') != -1:
-        raise AssertionError()
+    assert s.find(' ') == -1
     s = (s.replace(r'\x20', ' ')
          .replace(r'\x09', '\t')
          .replace(r'\x0a', '\n')

=== modified file 'bzrlib/textui.py'
--- bzrlib/textui.py	2008-04-24 07:22:53 +0000
+++ bzrlib/textui.py	2006-10-11 23:08:27 +0000
@@ -25,13 +25,11 @@
         kind_ch = '/'
     elif kind == 'symlink':
         kind_ch = '->'
-    elif kind == 'file':
+    else:
+        assert kind == 'file', ("can't handle file of type %r" % kind)
         kind_ch = ''
-    else:
-        raise ValueError(kind)
 
-    if len(state) != 1:
-        raise ValueError(state)
+    assert len(state) == 1
         
     if to_file is None:
         to_file = sys.stdout

=== modified file 'bzrlib/timestamp.py'
--- bzrlib/timestamp.py	2008-06-26 17:18:55 +0000
+++ bzrlib/timestamp.py	2007-04-19 08:03:19 +0000
@@ -47,8 +47,7 @@
     >>> format_highres_date(1152428738.867522, 19800)
     'Sun 2006-07-09 12:35:38.867522001 +0530'
     """
-    if not isinstance(t, float):
-        raise ValueError(t)
+    assert isinstance(t, float)
 
     # This has to be formatted for "original" date, so that the
     # revision XML entry will be reproduced faithfully.
@@ -56,8 +55,7 @@
         offset = 0
     tt = time.gmtime(t + offset)
 
-    return (osutils.weekdays[tt[6]] +
-            time.strftime(" %Y-%m-%d %H:%M:%S", tt)
+    return (time.strftime("%a %Y-%m-%d %H:%M:%S", tt)
             # Get the high-res seconds, but ignore the 0
             + ('%.9f' % (t - int(t)))[1:]
             + ' %+03d%02d' % (offset / 3600, (offset / 60) % 60))
@@ -101,11 +99,6 @@
     ...      break
 
     """
-    # Weekday parsing is locale sensitive, so drop the weekday
-    space_loc = date.find(' ')
-    if space_loc == -1 or date[:space_loc] not in osutils.weekdays:
-        raise ValueError(
-            'Date string does not contain a day of week: %r' % date)
     # Up until the first period is a datestamp that is generated
     # as normal from time.strftime, so use time.strptime to
     # parse it
@@ -113,7 +106,7 @@
     if dot_loc == -1:
         raise ValueError(
             'Date string does not contain high-precision seconds: %r' % date)
-    base_time = time.strptime(date[space_loc:dot_loc], " %Y-%m-%d %H:%M:%S")
+    base_time = time.strptime(date[:dot_loc], "%a %Y-%m-%d %H:%M:%S")
     fract_seconds, offset = date[dot_loc:].split()
     fract_seconds = float(fract_seconds)
 
@@ -136,9 +129,8 @@
 
     Inverse of parse_patch_date.
     """
-    if offset % 60 != 0:
-        raise ValueError(
-        "can't represent timezone %s offset by fractional minutes" % offset)
+    assert offset % 60 == 0, \
+        "can't represent timezone %s offset by fractional minutes" % offset
     # so that we don't need to do calculations on pre-epoch times, 
     # which doesn't work with win32 python gmtime, we always
     # give the epoch in utc
@@ -159,9 +151,8 @@
     """
     secs_str = date_str[:-6]
     offset_str = date_str[-5:]
-    if len(offset_str) != 5:
-        raise ValueError(
-            "invalid timezone %r" % offset_str)
+    assert len(offset_str) == 5, \
+            "invalid timezone %r" % offset_str
     offset_hours, offset_mins = offset_str[:3], offset_str[3:]
     offset = int(offset_hours) * 3600 + int(offset_mins) * 60
     tm_time = time.strptime(secs_str, '%Y-%m-%d %H:%M:%S')

=== modified file 'bzrlib/trace.py'
--- bzrlib/trace.py	2008-06-18 07:21:15 +0000
+++ bzrlib/trace.py	2007-10-16 17:37:43 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2008 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -49,24 +49,17 @@
 # FIXME: Unfortunately it turns out that python's logging module
 # is quite expensive, even when the message is not printed by any handlers.
 # We should perhaps change back to just simply doing it here.
-#
-# On the other hand, as of 1.2 we generally only call the mutter() statement
-# if (according to debug_flags) we actually intend to write it.  So the
-# increased cost of logging.py is not so bad, and we could standardize on
-# that.
 
-import codecs
-import logging
 import os
 import sys
 import re
-import time
 
 from bzrlib.lazy_import import lazy_import
 lazy_import(globals(), """
 from cStringIO import StringIO
 import errno
 import locale
+import logging
 import traceback
 """)
 
@@ -78,54 +71,33 @@
     errors,
     osutils,
     plugin,
-    symbol_versioning,
     )
 """)
 
-
-# global verbosity for bzrlib; controls the log level for stderr; 0=normal; <0
-# is quiet; >0 is verbose.
+_file_handler = None
+_stderr_handler = None
 _verbosity_level = 0
-
-# File-like object where mutter/debug output is currently sent.  Can be
-# changed by _push_log_file etc.  This is directly manipulated by some
-# external code; maybe there should be functions to do that more precisely
-# than push/pop_log_file.
 _trace_file = None
-
-# Absolute path for ~/.bzr.log.  Not changed even if the log/trace output is
-# redirected elsewhere.  Used to show the location in --version.
+_trace_depth = 0
+_bzr_log_file = None
 _bzr_log_filename = None
 
-# The time the first message was written to the trace file, so that we can
-# show relative times since startup.
-_bzr_log_start_time = bzrlib._start_time
-
-
-# held in a global for quick reference
+
+# configure convenient aliases for output routines
+
 _bzr_logger = logging.getLogger('bzr')
 
-
 def note(*args, **kwargs):
     # FIXME note always emits utf-8, regardless of the terminal encoding
-    #
-    # FIXME: clearing the ui and then going through the abstract logging
-    # framework is whack; we should probably have a logging Handler that
-    # deals with terminal output if needed.
     import bzrlib.ui
     bzrlib.ui.ui_factory.clear_term()
     _bzr_logger.info(*args, **kwargs)
 
-
 def warning(*args, **kwargs):
     import bzrlib.ui
     bzrlib.ui.ui_factory.clear_term()
     _bzr_logger.warning(*args, **kwargs)
 
-
-# configure convenient aliases for output routines
-#
-# TODO: deprecate them, have one name for each.
 info = note
 log_error = _bzr_logger.error
 error =     _bzr_logger.error
@@ -152,11 +124,10 @@
         out = fmt % tuple(real_args)
     else:
         out = fmt
-    timestamp = '%0.3f  ' % (time.time() - _bzr_log_start_time,)
-    out = timestamp + out + '\n'
+    out += '\n'
     _trace_file.write(out)
-    # no need to flush here, the trace file is now linebuffered when it's
-    # opened.
+    # TODO: jam 20051227 Consider flushing the trace file to help debugging
+    #_trace_file.flush()
 
 
 def mutter_callsite(stacklevel, fmt, *args):
@@ -168,11 +139,7 @@
     :param args: A list of substitution variables.
     """
     outf = StringIO()
-    if stacklevel is None:
-        limit = None
-    else:
-        limit = stacklevel + 1
-    traceback.print_stack(limit=limit, file=outf)
+    traceback.print_stack(limit=stacklevel + 1, file=outf)
     formatted_lines = outf.getvalue().splitlines()
     formatted_stack = '\n'.join(formatted_lines[:-2])
     mutter(fmt + "\nCalled from:\n%s", *(args + (formatted_stack,)))
@@ -190,139 +157,44 @@
         return
 
 
-def _get_bzr_log_filename():
-    bzr_log = os.environ.get('BZR_LOG')
-    if bzr_log:
-        return bzr_log
-    home = os.environ.get('BZR_HOME')
-    if home is None:
+def open_tracefile(tracefilename=None):
+    # Messages are always written to here, so that we have some
+    # information if something goes wrong.  In a future version this
+    # file will be removed on successful completion.
+    global _file_handler, _bzr_log_file, _bzr_log_filename
+    import codecs
+
+    if tracefilename is None:
         if sys.platform == 'win32':
             from bzrlib import win32utils
             home = win32utils.get_home_location()
         else:
             home = os.path.expanduser('~')
-    return os.path.join(home, '.bzr.log')
-
-
-def _open_bzr_log():
-    """Open the .bzr.log trace file.  
-
-    If the log is more than a particular length, the old file is renamed to
-    .bzr.log.old and a new file is started.  Otherwise, we append to the
-    existing file.
-
-    This sets the global _bzr_log_filename.
-    """
-    global _bzr_log_filename
-    _bzr_log_filename = _get_bzr_log_filename()
+        _bzr_log_filename = os.path.join(home, '.bzr.log')
+    else:
+        _bzr_log_filename = tracefilename
+
+    _bzr_log_filename = os.path.expanduser(_bzr_log_filename)
     _rollover_trace_maybe(_bzr_log_filename)
     try:
-        bzr_log_file = open(_bzr_log_filename, 'at', 1) # line buffered
-        # bzr_log_file.tell() on windows always return 0 until some writing done
-        bzr_log_file.write('\n')
-        if bzr_log_file.tell() <= 2:
-            bzr_log_file.write("this is a debug log for diagnosing/reporting problems in bzr\n")
-            bzr_log_file.write("you can delete or truncate this file, or include sections in\n")
-            bzr_log_file.write("bug reports to https://bugs.launchpad.net/bzr/+filebug\n\n")
-        return bzr_log_file
+        LINE_BUFFERED = 1
+        #tf = codecs.open(trace_fname, 'at', 'utf8', buffering=LINE_BUFFERED)
+        tf = open(_bzr_log_filename, 'at', LINE_BUFFERED)
+        _bzr_log_file = tf
+        # tf.tell() on windows always return 0 until some writing done
+        tf.write('\n')
+        if tf.tell() <= 2:
+            tf.write("this is a debug log for diagnosing/reporting problems in bzr\n")
+            tf.write("you can delete or truncate this file, or include sections in\n")
+            tf.write("bug reports to bazaar@lists.canonical.com\n\n")
+        _file_handler = logging.StreamHandler(tf)
+        fmt = r'[%(process)5d] %(asctime)s.%(msecs)03d %(levelname)s: %(message)s'
+        datefmt = r'%a %H:%M:%S'
+        _file_handler.setFormatter(logging.Formatter(fmt, datefmt))
+        _file_handler.setLevel(logging.DEBUG)
+        logging.getLogger('').addHandler(_file_handler)
     except IOError, e:
         warning("failed to open trace file: %s" % (e))
-    # TODO: What should happen if we fail to open the trace file?  Maybe the
-    # objects should be pointed at /dev/null or the equivalent?  Currently
-    # returns None which will cause failures later.
-
-
-def enable_default_logging():
-    """Configure default logging: messages to stderr and debug to .bzr.log
-    
-    This should only be called once per process.
-
-    Non-command-line programs embedding bzrlib do not need to call this.  They
-    can instead either pass a file to _push_log_file, or act directly on
-    logging.getLogger("bzr").
-    
-    Output can be redirected away by calling _push_log_file.
-    """
-    # create encoded wrapper around stderr
-    bzr_log_file = _open_bzr_log()
-    push_log_file(bzr_log_file,
-        r'[%(process)5d] %(asctime)s.%(msecs)03d %(levelname)s: %(message)s',
-        r'%Y-%m-%d %H:%M:%S')
-    # after hooking output into bzr_log, we also need to attach a stderr
-    # handler, writing only at level info and with encoding
-    writer_factory = codecs.getwriter(osutils.get_terminal_encoding())
-    encoded_stderr = writer_factory(sys.stderr, errors='replace')
-    stderr_handler = logging.StreamHandler(encoded_stderr)
-    stderr_handler.setLevel(logging.INFO)
-    logging.getLogger('bzr').addHandler(stderr_handler)
-
-
-def push_log_file(to_file, log_format=None, date_format=None):
-    """Intercept log and trace messages and send them to a file.
-
-    :param to_file: A file-like object to which messages will be sent.
-
-    :returns: A memento that should be passed to _pop_log_file to restore the 
-    previously active logging.
-    """
-    global _trace_file
-    # make a new handler
-    new_handler = logging.StreamHandler(to_file)
-    new_handler.setLevel(logging.DEBUG)
-    if log_format is None:
-        log_format = '%(levelname)8s  %(message)s'
-    new_handler.setFormatter(logging.Formatter(log_format, date_format))
-    # save and remove any existing log handlers
-    bzr_logger = logging.getLogger('bzr')
-    old_handlers = bzr_logger.handlers[:]
-    del bzr_logger.handlers[:]
-    # set that as the default logger
-    bzr_logger.addHandler(new_handler)
-    bzr_logger.setLevel(logging.DEBUG)
-    # TODO: check if any changes are needed to the root logger
-    #
-    # TODO: also probably need to save and restore the level on bzr_logger.
-    # but maybe we can avoid setting the logger level altogether, and just set
-    # the level on the handler?
-    #
-    # save the old trace file
-    old_trace_file = _trace_file
-    # send traces to the new one
-    _trace_file = to_file
-    result = new_handler, _trace_file
-    return ('log_memento', old_handlers, new_handler, old_trace_file, to_file)
-
-
-def pop_log_file((magic, old_handlers, new_handler, old_trace_file, new_trace_file)):
-    """Undo changes to logging/tracing done by _push_log_file.
-
-    This flushes, but does not close the trace file.
-    
-    Takes the memento returned from _push_log_file."""
-    global _trace_file
-    _trace_file = old_trace_file
-    bzr_logger = logging.getLogger('bzr')
-    bzr_logger.removeHandler(new_handler)
-    # must be closed, otherwise logging will try to close it atexit, and the
-    # file will likely already be closed underneath.
-    new_handler.close()
-    bzr_logger.handlers = old_handlers
-    new_trace_file.flush()
-
-
-@symbol_versioning.deprecated_function(symbol_versioning.one_two)
-def enable_test_log(to_file):
-    """Redirect logging to a temporary file for a test
-    
-    :returns: an opaque reference that should be passed to disable_test_log
-    after the test completes.
-    """
-    return push_log_file(to_file)
-
-
-@symbol_versioning.deprecated_function(symbol_versioning.one_two)
-def disable_test_log(memento):
-    return pop_log_file(memento)
 
 
 def log_exception_quietly():
@@ -332,9 +204,25 @@
     interesting to developers but not to users.  For example, 
     errors loading plugins.
     """
+    import traceback
     mutter(traceback.format_exc())
 
 
+def enable_default_logging():
+    """Configure default logging to stderr and .bzr.log"""
+    # FIXME: if this is run twice, things get confused
+    global _stderr_handler, _file_handler, _trace_file, _bzr_log_file
+    _stderr_handler = logging.StreamHandler()
+    logging.getLogger('').addHandler(_stderr_handler)
+    _stderr_handler.setLevel(logging.INFO)
+    if not _file_handler:
+        open_tracefile()
+    _trace_file = _bzr_log_file
+    if _file_handler:
+        _file_handler.setLevel(logging.DEBUG)
+    _bzr_logger.setLevel(logging.DEBUG)
+
+
 def set_verbosity_level(level):
     """Set the verbosity level.
 
@@ -364,9 +252,9 @@
 def _update_logging_level(quiet=True):
     """Hide INFO messages if quiet."""
     if quiet:
-        _bzr_logger.setLevel(logging.WARNING)
+        _stderr_handler.setLevel(logging.WARNING)
     else:
-        _bzr_logger.setLevel(logging.INFO)
+        _stderr_handler.setLevel(logging.INFO)
 
 
 def is_quiet():
@@ -379,13 +267,49 @@
     return _verbosity_level > 0
 
 
-@symbol_versioning.deprecated_function(symbol_versioning.one_two)
 def disable_default_logging():
     """Turn off default log handlers.
 
-    Don't call this method, use _push_log_file and _pop_log_file instead.
-    """
-    pass
+    This is intended to be used by the test framework, which doesn't
+    want leakage from the code-under-test into the main logs.
+    """
+
+    l = logging.getLogger('')
+    l.removeHandler(_stderr_handler)
+    if _file_handler:
+        l.removeHandler(_file_handler)
+    _trace_file = None
+
+
+def enable_test_log(to_file):
+    """Redirect logging to a temporary file for a test
+    
+    returns an opaque reference that should be passed to disable_test_log
+    after the test completes.
+    """
+    disable_default_logging()
+    global _trace_file
+    global _trace_depth
+    hdlr = logging.StreamHandler(to_file)
+    hdlr.setLevel(logging.DEBUG)
+    hdlr.setFormatter(logging.Formatter('%(levelname)8s  %(message)s'))
+    _bzr_logger.addHandler(hdlr)
+    _bzr_logger.setLevel(logging.DEBUG)
+    result = hdlr, _trace_file, _trace_depth
+    _trace_file = to_file
+    _trace_depth += 1
+    return result
+
+
+def disable_test_log((test_log_hdlr, old_trace_file, old_trace_depth)):
+    _bzr_logger.removeHandler(test_log_hdlr)
+    test_log_hdlr.close()
+    global _trace_file
+    global _trace_depth
+    _trace_file = old_trace_file
+    _trace_depth = old_trace_depth
+    if not _trace_depth:
+        enable_default_logging()
 
 
 def report_exception(exc_info, err_file):
@@ -405,11 +329,6 @@
     elif isinstance(exc_object, KeyboardInterrupt):
         err_file.write("bzr: interrupted\n")
         return errors.EXIT_ERROR
-    elif isinstance(exc_object, ImportError) \
-        and str(exc_object).startswith("No module named "):
-        report_user_error(exc_info, err_file,
-            'You may need to install this Python library separately.')
-        return errors.EXIT_ERROR
     elif not getattr(exc_object, 'internal_error', True):
         report_user_error(exc_info, err_file)
         return errors.EXIT_ERROR
@@ -423,39 +342,30 @@
         return errors.EXIT_INTERNAL_ERROR
 
 
-def print_exception(exc_info, err_file):
-    exc_type, exc_object, exc_tb = exc_info
-    err_file.write("bzr: ERROR: %s.%s: %s\n" % (
-        exc_type.__module__, exc_type.__name__, exc_object))
-    err_file.write('\n')
-    traceback.print_exception(exc_type, exc_object, exc_tb, file=err_file)
-
-
 # TODO: Should these be specially encoding the output?
-def report_user_error(exc_info, err_file, advice=None):
+def report_user_error(exc_info, err_file):
     """Report to err_file an error that's not an internal error.
 
     These don't get a traceback unless -Derror was given.
-
-    :param exc_info: 3-tuple from sys.exc_info()
-    :param advice: Extra advice to the user to be printed following the
-        exception.
     """
     if 'error' in debug.debug_flags:
-        print_exception(exc_info, err_file)
+        report_bug(exc_info, err_file)
         return
     err_file.write("bzr: ERROR: %s\n" % (exc_info[1],))
-    if advice:
-        err_file.write("%s\n" % (advice,))
 
 
 def report_bug(exc_info, err_file):
     """Report an exception that probably indicates a bug in bzr"""
-    print_exception(exc_info, err_file)
+    import traceback
+    exc_type, exc_object, exc_tb = exc_info
+    err_file.write("bzr: ERROR: %s.%s: %s\n" % (
+        exc_type.__module__, exc_type.__name__, exc_object))
+    err_file.write('\n')
+    traceback.print_exception(exc_type, exc_object, exc_tb, file=err_file)
     err_file.write('\n')
     err_file.write('bzr %s on python %s (%s)\n' % \
                        (bzrlib.__version__,
-                        bzrlib._format_version_tuple(sys.version_info),
+                        '.'.join(map(str, sys.version_info)),
                         sys.platform))
     err_file.write('arguments: %r\n' % sys.argv)
     err_file.write(
@@ -467,9 +377,8 @@
         err_file.write("  %-20s %s [%s]\n" %
             (name, a_plugin.path(), a_plugin.__version__))
     err_file.write(
-"""\
-*** Bazaar has encountered an internal error.
-    Please report a bug at https://bugs.launchpad.net/bzr/+filebug
-    including this traceback, and a description of what you
-    were doing when the error occurred.
-""")
+        "\n"
+        "** Please send this report to bazaar@lists.ubuntu.com\n"
+        "   with a description of what you were doing when the\n"
+        "   error occurred.\n"
+        )

=== modified file 'bzrlib/transactions.py'
--- bzrlib/transactions.py	2008-04-24 07:22:53 +0000
+++ bzrlib/transactions.py	2006-10-11 23:08:27 +0000
@@ -79,8 +79,7 @@
 
     def set_cache_size(self, size):
         """Set a new cache size."""
-        if size < -1:
-            raise ValueError(size)
+        assert -1 <= size
         self._limit = size
         self._trim()
 

=== modified file 'bzrlib/transform.py'
--- bzrlib/transform.py	2008-09-01 06:19:29 +0000
+++ bzrlib/transform.py	2007-08-29 05:30:05 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007, 2008 Canonical Ltd
+# Copyright (C) 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -16,37 +16,28 @@
 
 import os
 import errno
-from stat import S_ISREG, S_IEXEC
+from stat import S_ISREG
 
 from bzrlib.lazy_import import lazy_import
 lazy_import(globals(), """
 from bzrlib import (
-    annotate,
     bzrdir,
     delta,
     errors,
-    inventory,
-    osutils,
-    revision as _mod_revision,
+    inventory
     )
 """)
 from bzrlib.errors import (DuplicateKey, MalformedTransform, NoSuchFile,
                            ReusingTransform, NotVersionedError, CantMoveRoot,
-                           ExistingLimbo, ImmortalLimbo, NoFinalPath,
-                           UnableCreateSymlink)
+                           ExistingLimbo, ImmortalLimbo, NoFinalPath)
 from bzrlib.inventory import InventoryEntry
-from bzrlib.osutils import (
-    delete_any,
-    file_kind,
-    has_symlinks,
-    lexists,
-    pathjoin,
-    splitpath,
-    supports_executable,
-)
+from bzrlib.osutils import (file_kind, supports_executable, pathjoin, lexists,
+                            delete_any)
 from bzrlib.progress import DummyProgress, ProgressPhase
 from bzrlib.symbol_versioning import (
         deprecated_function,
+        zero_fifteen,
+        zero_ninety,
         )
 from bzrlib.trace import mutter, warning
 from bzrlib import tree
@@ -70,31 +61,68 @@
         self.rename_count = rename_count
 
 
-class TreeTransformBase(object):
-    """The base class for TreeTransform and TreeTransformBase"""
-
-    def __init__(self, tree, limbodir, pb=DummyProgress(),
-                 case_sensitive=True):
-        """Constructor.
-
-        :param tree: The tree that will be transformed, but not necessarily
-            the output tree.
-        :param limbodir: A directory where new files can be stored until
-            they are installed in their proper places
-        :param pb: A ProgressBar indicating how much progress is being made
-        :param case_sensitive: If True, the target of the transform is
-            case sensitive, not just case preserving.
+class TreeTransform(object):
+    """Represent a tree transformation.
+    
+    This object is designed to support incremental generation of the transform,
+    in any order.
+
+    However, it gives optimum performance when parent directories are created
+    before their contents.  The transform is then able to put child files
+    directly in their parent directory, avoiding later renames.
+    
+    It is easy to produce malformed transforms, but they are generally
+    harmless.  Attempting to apply a malformed transform will cause an
+    exception to be raised before any modifications are made to the tree.  
+
+    Many kinds of malformed transforms can be corrected with the 
+    resolve_conflicts function.  The remaining ones indicate programming error,
+    such as trying to create a file with no path.
+
+    Two sets of file creation methods are supplied.  Convenience methods are:
+     * new_file
+     * new_directory
+     * new_symlink
+
+    These are composed of the low-level methods:
+     * create_path
+     * create_file or create_directory or create_symlink
+     * version_file
+     * set_executability
+    """
+    def __init__(self, tree, pb=DummyProgress()):
+        """Note: a tree_write lock is taken on the tree.
+        
+        Use TreeTransform.finalize() to release the lock (can be omitted if
+        TreeTransform.apply() called).
         """
         object.__init__(self)
         self._tree = tree
-        self._limbodir = limbodir
-        self._deletiondir = None
+        self._tree.lock_tree_write()
+        try:
+            control_files = self._tree._control_files
+            self._limbodir = urlutils.local_path_from_url(
+                control_files.controlfilename('limbo'))
+            try:
+                os.mkdir(self._limbodir)
+            except OSError, e:
+                if e.errno == errno.EEXIST:
+                    raise ExistingLimbo(self._limbodir)
+            self._deletiondir = urlutils.local_path_from_url(
+                control_files.controlfilename('pending-deletion'))
+            try:
+                os.mkdir(self._deletiondir)
+            except OSError, e:
+                if e.errno == errno.EEXIST:
+                    raise errors.ExistingPendingDeletion(self._deletiondir)
+
+        except: 
+            self._tree.unlock()
+            raise
+
         self._id_number = 0
-        # mapping of trans_id -> new basename
         self._new_name = {}
-        # mapping of trans_id -> new parent trans_id
         self._new_parent = {}
-        # mapping of trans_id with new contents -> new file_kind
         self._new_contents = {}
         # A mapping of transform ids to their limbo filename
         self._limbo_files = {}
@@ -105,41 +133,22 @@
         self._limbo_children_names = {}
         # List of transform ids that need to be renamed from limbo into place
         self._needs_rename = set()
-        # Set of trans_ids whose contents will be removed
         self._removed_contents = set()
-        # Mapping of trans_id -> new execute-bit value
         self._new_executability = {}
-        # Mapping of trans_id -> new tree-reference value
         self._new_reference_revision = {}
-        # Mapping of trans_id -> new file_id
         self._new_id = {}
-        # Mapping of old file-id -> trans_id
         self._non_present_ids = {}
-        # Mapping of new file_id -> trans_id
         self._r_new_id = {}
-        # Set of file_ids that will be removed
         self._removed_id = set()
-        # Mapping of path in old tree -> trans_id
         self._tree_path_ids = {}
-        # Mapping trans_id -> path in old tree
         self._tree_id_paths = {}
         # Cache of realpath results, to speed up canonical_path
         self._realpaths = {}
         # Cache of relpath results, to speed up canonical_path
         self._relpaths = {}
-        # The trans_id that will be used as the tree root
-        root_id = tree.get_root_id()
-        if root_id is not None:
-            self._new_root = self.trans_id_tree_file_id(root_id)
-        else:
-            self._new_root = None
-        # Indictor of whether the transform has been applied
-        self._done = False
-        # A progress bar
+        self._new_root = self.trans_id_tree_file_id(tree.get_root_id())
+        self.__done = False
         self._pb = pb
-        # Whether the target is case sensitive
-        self._case_sensitive_target = case_sensitive
-        # A counter of how many files have been renamed
         self.rename_count = 0
 
     def __get_root(self):
@@ -170,8 +179,7 @@
                 # We don't especially care *why* the dir is immortal.
                 raise ImmortalLimbo(self._limbodir)
             try:
-                if self._deletiondir is not None:
-                    os.rmdir(self._deletiondir)
+                os.rmdir(self._deletiondir)
             except OSError:
                 raise errors.ImmortalPendingDeletion(self._deletiondir)
         finally:
@@ -199,10 +207,6 @@
         previous_name = self._new_name.get(trans_id)
         self._new_name[trans_id] = name
         self._new_parent[trans_id] = parent
-        if parent == ROOT_PARENT:
-            if self._new_root is not None:
-                raise ValueError("Cannot have multiple roots.")
-            self._new_root = trans_id
         if (trans_id in self._limbo_files and
             trans_id not in self._needs_rename):
             self._rename_in_limbo([trans_id])
@@ -265,9 +269,7 @@
         This reflects only files that already exist, not ones that will be
         added by transactions.
         """
-        if inventory_id is None:
-            raise ValueError('None is not a valid file id')
-        path = self._tree.id2path(inventory_id)
+        path = self._tree.inventory.id2path(inventory_id)
         return self.trans_id_tree_path(path)
 
     def trans_id_file_id(self, file_id):
@@ -276,8 +278,6 @@
         a transaction has been unversioned, it is deliberately still returned.
         (this will likely lead to an unversioned parent conflict.)
         """
-        if file_id is None:
-            raise ValueError('None is not a valid file id')
         if file_id in self._r_new_id and self._r_new_id[file_id] is not None:
             return self._r_new_id[file_id]
         elif file_id in self._tree.inventory:
@@ -366,34 +366,13 @@
         try:
             mode = os.stat(self._tree.abspath(old_path)).st_mode
         except OSError, e:
-            if e.errno in (errno.ENOENT, errno.ENOTDIR):
-                # Either old_path doesn't exist, or the parent of the
-                # target is not a directory (but will be one eventually)
-                # Either way, we know it doesn't exist *right now*
-                # See also bug #248448
+            if e.errno == errno.ENOENT:
                 return
             else:
                 raise
         if typefunc(mode):
             os.chmod(self._limbo_name(trans_id), mode)
 
-    def create_hardlink(self, path, trans_id):
-        """Schedule creation of a hard link"""
-        name = self._limbo_name(trans_id)
-        try:
-            os.link(path, name)
-        except OSError, e:
-            if e.errno != errno.EPERM:
-                raise
-            raise errors.HardLinkNotSupported(path)
-        try:
-            unique_add(self._new_contents, trans_id, 'file')
-        except:
-            # Clean up the file, it never got registered so
-            # TreeTransform.finalize() won't clean it up.
-            os.unlink(name)
-            raise
-
     def create_directory(self, trans_id):
         """Schedule creation of a new directory.
         
@@ -408,15 +387,8 @@
         target is a bytestring.
         See also new_symlink.
         """
-        if has_symlinks():
-            os.symlink(target, self._limbo_name(trans_id))
-            unique_add(self._new_contents, trans_id, 'symlink')
-        else:
-            try:
-                path = FinalPaths(self).get_path(trans_id)
-            except KeyError:
-                path = None
-            raise UnableCreateSymlink(path=path)
+        os.symlink(target, self._limbo_name(trans_id))
+        unique_add(self._new_contents, trans_id, 'symlink')
 
     def cancel_creation(self, trans_id):
         """Cancel the creation of new file contents."""
@@ -463,8 +435,7 @@
 
     def version_file(self, file_id, trans_id):
         """Schedule a file to become versioned."""
-        if file_id is None:
-            raise ValueError()
+        assert file_id is not None
         unique_add(self._new_id, trans_id, file_id)
         unique_add(self._r_new_id, file_id, trans_id)
 
@@ -474,40 +445,16 @@
         del self._new_id[trans_id]
         del self._r_new_id[file_id]
 
-    def new_paths(self, filesystem_only=False):
-        """Determine the paths of all new and changed files.
-
-        :param filesystem_only: if True, only calculate values for files
-            that require renames or execute bit changes.
-        """
-        new_ids = set()
-        if filesystem_only:
-            stale_ids = self._needs_rename.difference(self._new_name)
-            stale_ids.difference_update(self._new_parent)
-            stale_ids.difference_update(self._new_contents)
-            stale_ids.difference_update(self._new_id)
-            needs_rename = self._needs_rename.difference(stale_ids)
-            id_sets = (needs_rename, self._new_executability)
-        else:
-            id_sets = (self._new_name, self._new_parent, self._new_contents,
-                       self._new_id, self._new_executability)
-        for id_set in id_sets:
-            new_ids.update(id_set)
-        return sorted(FinalPaths(self).get_paths(new_ids))
-
-    def _inventory_altered(self):
-        """Get the trans_ids and paths of files needing new inv entries."""
-        new_ids = set()
-        for id_set in [self._new_name, self._new_parent, self._new_id,
-                       self._new_executability]:
-            new_ids.update(id_set)
-        changed_kind = set(self._removed_contents)
-        changed_kind.intersection_update(self._new_contents)
-        changed_kind.difference_update(new_ids)
-        changed_kind = (t for t in changed_kind if self.tree_kind(t) !=
-                        self.final_kind(t))
-        new_ids.update(changed_kind)
-        return sorted(FinalPaths(self).get_paths(new_ids))
+    def new_paths(self):
+        """Determine the paths of all new and changed files"""
+        new_ids = set()
+        fp = FinalPaths(self)
+        for id_set in (self._new_name, self._new_parent, self._new_contents,
+                       self._new_id, self._new_executability):
+            new_ids.update(id_set)
+        new_paths = [(fp.get_path(t), t) for t in new_ids]
+        new_paths.sort()
+        return new_paths
 
     def tree_kind(self, trans_id):
         """Determine the file kind in the working tree.
@@ -548,7 +495,7 @@
             return None
         # the file is old; the old id is still valid
         if self._new_root == trans_id:
-            return self._tree.get_root_id()
+            return self._tree.inventory.root.file_id
         return self._tree.inventory.path2id(path)
 
     def final_file_id(self, trans_id):
@@ -558,6 +505,8 @@
         applied.
         """
         try:
+            # there is a new id for this file
+            assert self._new_id[trans_id] is not None
             return self._new_id[trans_id]
         except KeyError:
             if trans_id in self._removed_id:
@@ -620,7 +569,7 @@
 
     def find_conflicts(self):
         """Find any violations of inventory or filesystem invariants"""
-        if self._done is True:
+        if self.__done is True:
             raise ReusingTransform()
         conflicts = []
         # ensure all children of all existent parents are known
@@ -648,10 +597,7 @@
                         self.tree_kind(t) == 'directory'])
         for trans_id in self._removed_id:
             file_id = self.tree_file_id(trans_id)
-            if file_id is not None:
-                if self._tree.inventory[file_id].kind == 'directory':
-                    parents.append(trans_id)
-            elif self.tree_kind(trans_id) == 'directory':
+            if self._tree.inventory[file_id].kind == 'directory':
                 parents.append(trans_id)
 
         for parent_id in parents:
@@ -667,11 +613,10 @@
         try:
             children = os.listdir(self._tree.abspath(path))
         except OSError, e:
-            if not (osutils._is_error_enotdir(e)
-                    or e.errno in (errno.ENOENT, errno.ESRCH)):
+            if e.errno != errno.ENOENT and e.errno != errno.ESRCH:
                 raise
             return
-
+            
         for child in children:
             childpath = joinpath(path, child)
             if self._tree.is_control_filename(childpath):
@@ -792,8 +737,6 @@
             return conflicts
         for children in by_parent.itervalues():
             name_ids = [(self.final_name(t), t) for t in children]
-            if not self._case_sensitive_target:
-                name_ids = [(n.lower(), t) for n, t in name_ids]
             name_ids.sort()
             last_name = None
             last_trans_id = None
@@ -817,8 +760,8 @@
         conflicts = []
         removed_tree_ids = set((self.tree_file_id(trans_id) for trans_id in
                                 self._removed_id))
-        all_ids = self._tree.all_file_ids()
-        active_tree_ids = all_ids.difference(removed_tree_ids)
+        active_tree_ids = set((f for f in self._tree.inventory if
+                               f not in removed_tree_ids))
         for trans_id, file_id in self._new_id.iteritems():
             if file_id in active_tree_ids:
                 old_trans_id = self.trans_id_tree_file_id(file_id)
@@ -857,6 +800,48 @@
                 continue
             return True
         return False
+            
+    def apply(self, no_conflicts=False, _mover=None):
+        """Apply all changes to the inventory and filesystem.
+        
+        If filesystem or inventory conflicts are present, MalformedTransform
+        will be thrown.
+
+        If apply succeeds, finalize is not necessary.
+
+        :param no_conflicts: if True, the caller guarantees there are no
+            conflicts, so no check is made.
+        :param _mover: Supply an alternate FileMover, for testing
+        """
+        if not no_conflicts:
+            conflicts = self.find_conflicts()
+            if len(conflicts) != 0:
+                raise MalformedTransform(conflicts=conflicts)
+        inv = self._tree.inventory
+        inventory_delta = []
+        child_pb = bzrlib.ui.ui_factory.nested_progress_bar()
+        try:
+            if _mover is None:
+                mover = _FileMover()
+            else:
+                mover = _mover
+            try:
+                child_pb.update('Apply phase', 0, 2)
+                self._apply_removals(inv, inventory_delta, mover)
+                child_pb.update('Apply phase', 1, 2)
+                modified_paths = self._apply_insertions(inv, inventory_delta,
+                                                        mover)
+            except:
+                mover.rollback()
+                raise
+            else:
+                mover.apply_deletions()
+        finally:
+            child_pb.finished()
+        self._tree.apply_inventory_delta(inventory_delta)
+        self.__done = True
+        self.finalize()
+        return _TransformResults(modified_paths, self.rename_count)
 
     def _limbo_name(self, trans_id):
         """Generate the limbo name of a file"""
@@ -878,20 +863,9 @@
                 # the direct path can only be used if no other file has
                 # already taken this pathname, i.e. if the name is unused, or
                 # if it is already associated with this trans_id.
-                elif self._case_sensitive_target:
-                    if (self._limbo_children_names[parent].get(filename)
-                        in (trans_id, None)):
-                        use_direct_path = True
-                else:
-                    for l_filename, l_trans_id in\
-                        self._limbo_children_names[parent].iteritems():
-                        if l_trans_id == trans_id:
-                            continue
-                        if l_filename.lower() == filename.lower():
-                            break
-                    else:
-                        use_direct_path = True
-
+                elif (self._limbo_children_names[parent].get(filename)
+                      in (trans_id, None)):
+                    use_direct_path = True
         if use_direct_path:
             limbo_name = pathjoin(self._limbo_files[parent], filename)
             self._limbo_children[parent].add(trans_id)
@@ -902,10 +876,127 @@
         self._limbo_files[trans_id] = limbo_name
         return limbo_name
 
-    def _set_executability(self, path, trans_id):
+    def _apply_removals(self, inv, inventory_delta, mover):
+        """Perform tree operations that remove directory/inventory names.
+        
+        That is, delete files that are to be deleted, and put any files that
+        need renaming into limbo.  This must be done in strict child-to-parent
+        order.
+        """
+        tree_paths = list(self._tree_path_ids.iteritems())
+        tree_paths.sort(reverse=True)
+        child_pb = bzrlib.ui.ui_factory.nested_progress_bar()
+        try:
+            for num, data in enumerate(tree_paths):
+                path, trans_id = data
+                child_pb.update('removing file', num, len(tree_paths))
+                full_path = self._tree.abspath(path)
+                if trans_id in self._removed_contents:
+                    mover.pre_delete(full_path, os.path.join(self._deletiondir,
+                                     trans_id))
+                elif trans_id in self._new_name or trans_id in \
+                    self._new_parent:
+                    try:
+                        mover.rename(full_path, self._limbo_name(trans_id))
+                    except OSError, e:
+                        if e.errno != errno.ENOENT:
+                            raise
+                    else:
+                        self.rename_count += 1
+                if trans_id in self._removed_id:
+                    if trans_id == self._new_root:
+                        file_id = self._tree.inventory.root.file_id
+                    else:
+                        file_id = self.tree_file_id(trans_id)
+                    assert file_id is not None
+                    inventory_delta.append((path, None, file_id, None))
+        finally:
+            child_pb.finished()
+
+    def _apply_insertions(self, inv, inventory_delta, mover):
+        """Perform tree operations that insert directory/inventory names.
+        
+        That is, create any files that need to be created, and restore from
+        limbo any files that needed renaming.  This must be done in strict
+        parent-to-child order.
+        """
+        new_paths = self.new_paths()
+        modified_paths = []
+        child_pb = bzrlib.ui.ui_factory.nested_progress_bar()
+        try:
+            for num, (path, trans_id) in enumerate(new_paths):
+                new_entry = None
+                child_pb.update('adding file', num, len(new_paths))
+                try:
+                    kind = self._new_contents[trans_id]
+                except KeyError:
+                    kind = contents = None
+                if trans_id in self._new_contents or \
+                    self.path_changed(trans_id):
+                    full_path = self._tree.abspath(path)
+                    if trans_id in self._needs_rename:
+                        try:
+                            mover.rename(self._limbo_name(trans_id), full_path)
+                        except OSError, e:
+                            # We may be renaming a dangling inventory id
+                            if e.errno != errno.ENOENT:
+                                raise
+                        else:
+                            self.rename_count += 1
+                    if trans_id in self._new_contents:
+                        modified_paths.append(full_path)
+                        del self._new_contents[trans_id]
+
+                if trans_id in self._new_id:
+                    if kind is None:
+                        kind = file_kind(self._tree.abspath(path))
+                    if trans_id in self._new_reference_revision:
+                        new_entry = inventory.TreeReference(
+                            self._new_id[trans_id],
+                            self._new_name[trans_id], 
+                            self.final_file_id(self._new_parent[trans_id]),
+                            None, self._new_reference_revision[trans_id])
+                    else:
+                        new_entry = inventory.make_entry(kind,
+                            self.final_name(trans_id),
+                            self.final_file_id(self.final_parent(trans_id)),
+                            self._new_id[trans_id])
+                else:
+                    if trans_id in self._new_name or trans_id in\
+                        self._new_parent or\
+                        trans_id in self._new_executability:
+                        file_id = self.final_file_id(trans_id)
+                        if file_id is not None:
+                            entry = inv[file_id]
+                            new_entry = entry.copy()
+
+                    if trans_id in self._new_name or trans_id in\
+                        self._new_parent:
+                            if new_entry is not None:
+                                new_entry.name = self.final_name(trans_id)
+                                parent = self.final_parent(trans_id)
+                                parent_id = self.final_file_id(parent)
+                                new_entry.parent_id = parent_id
+
+                if trans_id in self._new_executability:
+                    self._set_executability(path, new_entry, trans_id)
+                if new_entry is not None:
+                    if new_entry.file_id in inv:
+                        old_path = inv.id2path(new_entry.file_id)
+                    else:
+                        old_path = None
+                    inventory_delta.append((old_path, path,
+                                            new_entry.file_id,
+                                            new_entry))
+        finally:
+            child_pb.finished()
+        return modified_paths
+
+    def _set_executability(self, path, entry, trans_id):
         """Set the executability of versioned files """
+        new_executability = self._new_executability[trans_id]
+        entry.executable = new_executability
         if supports_executable():
-            new_executability = self._new_executability[trans_id]
             abspath = self._tree.abspath(path)
             current_mode = os.stat(abspath).st_mode
             if new_executability:
@@ -1048,8 +1139,8 @@
             to_executable = False
         return to_name, to_parent, to_kind, to_executable
 
-    def iter_changes(self):
-        """Produce output in the same format as Tree.iter_changes.
+    def _iter_changes(self):
+        """Produce output in the same format as Tree._iter_changes.
 
         Will produce nonsensical results if invoked while inventory/filesystem
         conflicts (as reported by TreeTransform.find_conflicts()) are present.
@@ -1110,684 +1201,6 @@
                    (from_executable, to_executable)))
         return iter(sorted(results, key=lambda x:x[1]))
 
-    def get_preview_tree(self):
-        """Return a tree representing the result of the transform.
-
-        This tree only supports the subset of Tree functionality required
-        by show_diff_trees.  It must only be compared to tt._tree.
-        """
-        return _PreviewTree(self)
-
-
-class TreeTransform(TreeTransformBase):
-    """Represent a tree transformation.
-
-    This object is designed to support incremental generation of the transform,
-    in any order.
-
-    However, it gives optimum performance when parent directories are created
-    before their contents.  The transform is then able to put child files
-    directly in their parent directory, avoiding later renames.
-
-    It is easy to produce malformed transforms, but they are generally
-    harmless.  Attempting to apply a malformed transform will cause an
-    exception to be raised before any modifications are made to the tree.
-
-    Many kinds of malformed transforms can be corrected with the
-    resolve_conflicts function.  The remaining ones indicate programming error,
-    such as trying to create a file with no path.
-
-    Two sets of file creation methods are supplied.  Convenience methods are:
-     * new_file
-     * new_directory
-     * new_symlink
-
-    These are composed of the low-level methods:
-     * create_path
-     * create_file or create_directory or create_symlink
-     * version_file
-     * set_executability
-
-    Transform/Transaction ids
-    -------------------------
-    trans_ids are temporary ids assigned to all files involved in a transform.
-    It's possible, even common, that not all files in the Tree have trans_ids.
-
-    trans_ids are used because filenames and file_ids are not good enough
-    identifiers; filenames change, and not all files have file_ids.  File-ids
-    are also associated with trans-ids, so that moving a file moves its
-    file-id.
-
-    trans_ids are only valid for the TreeTransform that generated them.
-
-    Limbo
-    -----
-    Limbo is a temporary directory use to hold new versions of files.
-    Files are added to limbo by create_file, create_directory, create_symlink,
-    and their convenience variants (new_*).  Files may be removed from limbo
-    using cancel_creation.  Files are renamed from limbo into their final
-    location as part of TreeTransform.apply
-
-    Limbo must be cleaned up, by either calling TreeTransform.apply or
-    calling TreeTransform.finalize.
-
-    Files are placed into limbo inside their parent directories, where
-    possible.  This reduces subsequent renames, and makes operations involving
-    lots of files faster.  This optimization is only possible if the parent
-    directory is created *before* creating any of its children, so avoid
-    creating children before parents, where possible.
-
-    Pending-deletion
-    ----------------
-    This temporary directory is used by _FileMover for storing files that are
-    about to be deleted.  In case of rollback, the files will be restored.
-    FileMover does not delete files until it is sure that a rollback will not
-    happen.
-    """
-    def __init__(self, tree, pb=DummyProgress()):
-        """Note: a tree_write lock is taken on the tree.
-
-        Use TreeTransform.finalize() to release the lock (can be omitted if
-        TreeTransform.apply() called).
-        """
-        tree.lock_tree_write()
-
-        try:
-            limbodir = urlutils.local_path_from_url(
-                tree._transport.abspath('limbo'))
-            try:
-                os.mkdir(limbodir)
-            except OSError, e:
-                if e.errno == errno.EEXIST:
-                    raise ExistingLimbo(limbodir)
-            deletiondir = urlutils.local_path_from_url(
-                tree._transport.abspath('pending-deletion'))
-            try:
-                os.mkdir(deletiondir)
-            except OSError, e:
-                if e.errno == errno.EEXIST:
-                    raise errors.ExistingPendingDeletion(deletiondir)
-        except:
-            tree.unlock()
-            raise
-
-        TreeTransformBase.__init__(self, tree, limbodir, pb,
-                                   tree.case_sensitive)
-        self._deletiondir = deletiondir
-
-    def apply(self, no_conflicts=False, precomputed_delta=None, _mover=None):
-        """Apply all changes to the inventory and filesystem.
-
-        If filesystem or inventory conflicts are present, MalformedTransform
-        will be thrown.
-
-        If apply succeeds, finalize is not necessary.
-
-        :param no_conflicts: if True, the caller guarantees there are no
-            conflicts, so no check is made.
-        :param precomputed_delta: An inventory delta to use instead of
-            calculating one.
-        :param _mover: Supply an alternate FileMover, for testing
-        """
-        if not no_conflicts:
-            conflicts = self.find_conflicts()
-            if len(conflicts) != 0:
-                raise MalformedTransform(conflicts=conflicts)
-        child_pb = bzrlib.ui.ui_factory.nested_progress_bar()
-        try:
-            if precomputed_delta is None:
-                child_pb.update('Apply phase', 0, 2)
-                inventory_delta = self._generate_inventory_delta()
-                offset = 1
-            else:
-                inventory_delta = precomputed_delta
-                offset = 0
-            if _mover is None:
-                mover = _FileMover()
-            else:
-                mover = _mover
-            try:
-                child_pb.update('Apply phase', 0 + offset, 2 + offset)
-                self._apply_removals(mover)
-                child_pb.update('Apply phase', 1 + offset, 2 + offset)
-                modified_paths = self._apply_insertions(mover)
-            except:
-                mover.rollback()
-                raise
-            else:
-                mover.apply_deletions()
-        finally:
-            child_pb.finished()
-        self._tree.apply_inventory_delta(inventory_delta)
-        self._done = True
-        self.finalize()
-        return _TransformResults(modified_paths, self.rename_count)
-
-    def _generate_inventory_delta(self):
-        """Generate an inventory delta for the current transform."""
-        inventory_delta = []
-        child_pb = bzrlib.ui.ui_factory.nested_progress_bar()
-        new_paths = self._inventory_altered()
-        total_entries = len(new_paths) + len(self._removed_id)
-        try:
-            for num, trans_id in enumerate(self._removed_id):
-                if (num % 10) == 0:
-                    child_pb.update('removing file', num, total_entries)
-                if trans_id == self._new_root:
-                    file_id = self._tree.get_root_id()
-                else:
-                    file_id = self.tree_file_id(trans_id)
-                # File-id isn't really being deleted, just moved
-                if file_id in self._r_new_id:
-                    continue
-                path = self._tree_id_paths[trans_id]
-                inventory_delta.append((path, None, file_id, None))
-            new_path_file_ids = dict((t, self.final_file_id(t)) for p, t in
-                                     new_paths)
-            entries = self._tree.iter_entries_by_dir(
-                new_path_file_ids.values())
-            old_paths = dict((e.file_id, p) for p, e in entries)
-            final_kinds = {}
-            for num, (path, trans_id) in enumerate(new_paths):
-                if (num % 10) == 0:
-                    child_pb.update('adding file',
-                                    num + len(self._removed_id), total_entries)
-                file_id = new_path_file_ids[trans_id]
-                if file_id is None:
-                    continue
-                needs_entry = False
-                try:
-                    kind = self.final_kind(trans_id)
-                except NoSuchFile:
-                    kind = self._tree.stored_kind(file_id)
-                parent_trans_id = self.final_parent(trans_id)
-                parent_file_id = new_path_file_ids.get(parent_trans_id)
-                if parent_file_id is None:
-                    parent_file_id = self.final_file_id(parent_trans_id)
-                if trans_id in self._new_reference_revision:
-                    new_entry = inventory.TreeReference(
-                        file_id,
-                        self._new_name[trans_id],
-                        self.final_file_id(self._new_parent[trans_id]),
-                        None, self._new_reference_revision[trans_id])
-                else:
-                    new_entry = inventory.make_entry(kind,
-                        self.final_name(trans_id),
-                        parent_file_id, file_id)
-                old_path = old_paths.get(new_entry.file_id)
-                new_executability = self._new_executability.get(trans_id)
-                if new_executability is not None:
-                    new_entry.executable = new_executability
-                inventory_delta.append(
-                    (old_path, path, new_entry.file_id, new_entry))
-        finally:
-            child_pb.finished()
-        return inventory_delta
-
-    def _apply_removals(self, mover):
-        """Perform tree operations that remove directory/inventory names.
-
-        That is, delete files that are to be deleted, and put any files that
-        need renaming into limbo.  This must be done in strict child-to-parent
-        order.
-
-        If inventory_delta is None, no inventory delta generation is performed.
-        """
-        tree_paths = list(self._tree_path_ids.iteritems())
-        tree_paths.sort(reverse=True)
-        child_pb = bzrlib.ui.ui_factory.nested_progress_bar()
-        try:
-            for num, data in enumerate(tree_paths):
-                path, trans_id = data
-                child_pb.update('removing file', num, len(tree_paths))
-                full_path = self._tree.abspath(path)
-                if trans_id in self._removed_contents:
-                    mover.pre_delete(full_path, os.path.join(self._deletiondir,
-                                     trans_id))
-                elif trans_id in self._new_name or trans_id in \
-                    self._new_parent:
-                    try:
-                        mover.rename(full_path, self._limbo_name(trans_id))
-                    except OSError, e:
-                        if e.errno != errno.ENOENT:
-                            raise
-                    else:
-                        self.rename_count += 1
-        finally:
-            child_pb.finished()
-
-    def _apply_insertions(self, mover):
-        """Perform tree operations that insert directory/inventory names.
-
-        That is, create any files that need to be created, and restore from
-        limbo any files that needed renaming.  This must be done in strict
-        parent-to-child order.
-
-        If inventory_delta is None, no inventory delta is calculated, and
-        no list of modified paths is returned.
-        """
-        new_paths = self.new_paths(filesystem_only=True)
-        modified_paths = []
-        new_path_file_ids = dict((t, self.final_file_id(t)) for p, t in
-                                 new_paths)
-        child_pb = bzrlib.ui.ui_factory.nested_progress_bar()
-        try:
-            for num, (path, trans_id) in enumerate(new_paths):
-                if (num % 10) == 0:
-                    child_pb.update('adding file', num, len(new_paths))
-                full_path = self._tree.abspath(path)
-                if trans_id in self._needs_rename:
-                    try:
-                        mover.rename(self._limbo_name(trans_id), full_path)
-                    except OSError, e:
-                        # We may be renaming a dangling inventory id
-                        if e.errno != errno.ENOENT:
-                            raise
-                    else:
-                        self.rename_count += 1
-                if (trans_id in self._new_contents or
-                    self.path_changed(trans_id)):
-                    if trans_id in self._new_contents:
-                        modified_paths.append(full_path)
-                if trans_id in self._new_executability:
-                    self._set_executability(path, trans_id)
-        finally:
-            child_pb.finished()
-        self._new_contents.clear()
-        return modified_paths
-
-
-class TransformPreview(TreeTransformBase):
-    """A TreeTransform for generating preview trees.
-
-    Unlike TreeTransform, this version works when the input tree is a
-    RevisionTree, rather than a WorkingTree.  As a result, it tends to ignore
-    unversioned files in the input tree.
-    """
-
-    def __init__(self, tree, pb=DummyProgress(), case_sensitive=True):
-        tree.lock_read()
-        limbodir = osutils.mkdtemp(prefix='bzr-limbo-')
-        TreeTransformBase.__init__(self, tree, limbodir, pb, case_sensitive)
-
-    def canonical_path(self, path):
-        return path
-
-    def tree_kind(self, trans_id):
-        path = self._tree_id_paths.get(trans_id)
-        if path is None:
-            raise NoSuchFile(None)
-        file_id = self._tree.path2id(path)
-        return self._tree.kind(file_id)
-
-    def _set_mode(self, trans_id, mode_id, typefunc):
-        """Set the mode of new file contents.
-        The mode_id is the existing file to get the mode from (often the same
-        as trans_id).  The operation is only performed if there's a mode match
-        according to typefunc.
-        """
-        # is it ok to ignore this?  probably
-        pass
-
-    def iter_tree_children(self, parent_id):
-        """Iterate through the entry's tree children, if any"""
-        try:
-            path = self._tree_id_paths[parent_id]
-        except KeyError:
-            return
-        file_id = self.tree_file_id(parent_id)
-        if file_id is None:
-            return
-        children = getattr(self._tree.inventory[file_id], 'children', {})
-        for child in children:
-            childpath = joinpath(path, child)
-            yield self.trans_id_tree_path(childpath)
-
-
-class _PreviewTree(tree.Tree):
-    """Partial implementation of Tree to support show_diff_trees"""
-
-    def __init__(self, transform):
-        self._transform = transform
-        self._final_paths = FinalPaths(transform)
-        self.__by_parent = None
-        self._parent_ids = []
-
-    def _changes(self, file_id):
-        for changes in self._transform.iter_changes():
-            if changes[0] == file_id:
-                return changes
-
-    def _content_change(self, file_id):
-        """Return True if the content of this file changed"""
-        changes = self._changes(file_id)
-        # changes[2] is true if the file content changed.  See
-        # InterTree.iter_changes.
-        return (changes is not None and changes[2])
-
-    def _get_repository(self):
-        repo = getattr(self._transform._tree, '_repository', None)
-        if repo is None:
-            repo = self._transform._tree.branch.repository
-        return repo
-
-    def _iter_parent_trees(self):
-        for revision_id in self.get_parent_ids():
-            try:
-                yield self.revision_tree(revision_id)
-            except errors.NoSuchRevisionInTree:
-                yield self._get_repository().revision_tree(revision_id)
-
-    def _get_file_revision(self, file_id, vf, tree_revision):
-        parent_keys = [(file_id, self._file_revision(t, file_id)) for t in
-                       self._iter_parent_trees()]
-        vf.add_lines((file_id, tree_revision), parent_keys,
-                     self.get_file(file_id).readlines())
-        repo = self._get_repository()
-        base_vf = repo.texts
-        if base_vf not in vf.fallback_versionedfiles:
-            vf.fallback_versionedfiles.append(base_vf)
-        return tree_revision
-
-    def _stat_limbo_file(self, file_id):
-        trans_id = self._transform.trans_id_file_id(file_id)
-        name = self._transform._limbo_name(trans_id)
-        return os.lstat(name)
-
-    @property
-    def _by_parent(self):
-        if self.__by_parent is None:
-            self.__by_parent = self._transform.by_parent()
-        return self.__by_parent
-
-    def lock_read(self):
-        # Perhaps in theory, this should lock the TreeTransform?
-        pass
-
-    def unlock(self):
-        pass
-
-    @property
-    def inventory(self):
-        """This Tree does not use inventory as its backing data."""
-        raise NotImplementedError(_PreviewTree.inventory)
-
-    def get_root_id(self):
-        return self._transform.final_file_id(self._transform.root)
-
-    def all_file_ids(self):
-        tree_ids = set(self._transform._tree.all_file_ids())
-        tree_ids.difference_update(self._transform.tree_file_id(t)
-                                   for t in self._transform._removed_id)
-        tree_ids.update(self._transform._new_id.values())
-        return tree_ids
-
-    def __iter__(self):
-        return iter(self.all_file_ids())
-
-    def paths2ids(self, specific_files, trees=None, require_versioned=False):
-        """See Tree.paths2ids"""
-        to_find = set(specific_files)
-        result = set()
-        for (file_id, paths, changed, versioned, parent, name, kind,
-             executable) in self._transform.iter_changes():
-            if paths[1] in to_find:
-                result.add(file_id)
-                to_find.remove(paths[1])
-        result.update(self._transform._tree.paths2ids(to_find,
-                      trees=[], require_versioned=require_versioned))
-        return result
-
-    def _path2trans_id(self, path):
-        segments = splitpath(path)
-        cur_parent = self._transform.root
-        for cur_segment in segments:
-            for child in self._all_children(cur_parent):
-                if self._transform.final_name(child) == cur_segment:
-                    cur_parent = child
-                    break
-            else:
-                return None
-        return cur_parent
-
-    def path2id(self, path):
-        return self._transform.final_file_id(self._path2trans_id(path))
-
-    def id2path(self, file_id):
-        trans_id = self._transform.trans_id_file_id(file_id)
-        try:
-            return self._final_paths._determine_path(trans_id)
-        except NoFinalPath:
-            raise errors.NoSuchId(self, file_id)
-
-    def _all_children(self, trans_id):
-        children = set(self._transform.iter_tree_children(trans_id))
-        # children in the _new_parent set are provided by _by_parent.
-        children.difference_update(self._transform._new_parent.keys())
-        children.update(self._by_parent.get(trans_id, []))
-        return children
-
-    def _make_inv_entries(self, ordered_entries, specific_file_ids):
-        for trans_id, parent_file_id in ordered_entries:
-            file_id = self._transform.final_file_id(trans_id)
-            if file_id is None:
-                continue
-            if (specific_file_ids is not None
-                and file_id not in specific_file_ids):
-                continue
-            try:
-                kind = self._transform.final_kind(trans_id)
-            except NoSuchFile:
-                kind = self._transform._tree.stored_kind(file_id)
-            new_entry = inventory.make_entry(
-                kind,
-                self._transform.final_name(trans_id),
-                parent_file_id, file_id)
-            yield new_entry, trans_id
-
-    def _list_files_by_dir(self):
-        todo = [ROOT_PARENT]
-        ordered_ids = []
-        while len(todo) > 0:
-            parent = todo.pop()
-            parent_file_id = self._transform.final_file_id(parent)
-            children = list(self._all_children(parent))
-            paths = dict(zip(children, self._final_paths.get_paths(children)))
-            children.sort(key=paths.get)
-            todo.extend(reversed(children))
-            for trans_id in children:
-                ordered_ids.append((trans_id, parent_file_id))
-        return ordered_ids
-
-    def iter_entries_by_dir(self, specific_file_ids=None):
-        # This may not be a maximally efficient implementation, but it is
-        # reasonably straightforward.  An implementation that grafts the
-        # TreeTransform changes onto the tree's iter_entries_by_dir results
-        # might be more efficient, but requires tricky inferences about stack
-        # position.
-        ordered_ids = self._list_files_by_dir()
-        for entry, trans_id in self._make_inv_entries(ordered_ids,
-                                                      specific_file_ids):
-            yield unicode(self._final_paths.get_path(trans_id)), entry
-
-    def list_files(self, include_root=False):
-        """See Tree.list_files."""
-        # XXX This should behave like WorkingTree.list_files, but is really
-        # more like RevisionTree.list_files.
-        for path, entry in self.iter_entries_by_dir():
-            if entry.name == '' and not include_root:
-                continue
-            yield path, 'V', entry.kind, entry.file_id, entry
-
-    def kind(self, file_id):
-        trans_id = self._transform.trans_id_file_id(file_id)
-        return self._transform.final_kind(trans_id)
-
-    def stored_kind(self, file_id):
-        trans_id = self._transform.trans_id_file_id(file_id)
-        try:
-            return self._transform._new_contents[trans_id]
-        except KeyError:
-            return self._transform._tree.stored_kind(file_id)
-
-    def get_file_mtime(self, file_id, path=None):
-        """See Tree.get_file_mtime"""
-        if not self._content_change(file_id):
-            return self._transform._tree.get_file_mtime(file_id, path)
-        return self._stat_limbo_file(file_id).st_mtime
-
-    def get_file_size(self, file_id):
-        """See Tree.get_file_size"""
-        if self.kind(file_id) == 'file':
-            return self._transform._tree.get_file_size(file_id)
-        else:
-            return None
-
-    def get_file_sha1(self, file_id, path=None, stat_value=None):
-        return self._transform._tree.get_file_sha1(file_id)
-
-    def is_executable(self, file_id, path=None):
-        trans_id = self._transform.trans_id_file_id(file_id)
-        try:
-            return self._transform._new_executability[trans_id]
-        except KeyError:
-            return self._transform._tree.is_executable(file_id, path)
-
-    def path_content_summary(self, path):
-        trans_id = self._path2trans_id(path)
-        tt = self._transform
-        tree_path = tt._tree_id_paths.get(trans_id)
-        kind = tt._new_contents.get(trans_id)
-        if kind is None:
-            if tree_path is None or trans_id in tt._removed_contents:
-                return 'missing', None, None, None
-            summary = tt._tree.path_content_summary(tree_path)
-            kind, size, executable, link_or_sha1 = summary
-        else:
-            link_or_sha1 = None
-            limbo_name = tt._limbo_name(trans_id)
-            if trans_id in tt._new_reference_revision:
-                kind = 'tree-reference'
-            if kind == 'file':
-                statval = os.lstat(limbo_name)
-                size = statval.st_size
-                if not supports_executable():
-                    executable = None
-                else:
-                    executable = statval.st_mode & S_IEXEC
-            else:
-                size = None
-                executable = None
-            if kind == 'symlink':
-                link_or_sha1 = os.readlink(limbo_name)
-        if supports_executable():
-            executable = tt._new_executability.get(trans_id, executable)
-        return kind, size, executable, link_or_sha1
-
-    def iter_changes(self, from_tree, include_unchanged=False,
-                      specific_files=None, pb=None, extra_trees=None,
-                      require_versioned=True, want_unversioned=False):
-        """See InterTree.iter_changes.
-
-        This implementation does not support include_unchanged, specific_files,
-        or want_unversioned.  extra_trees, require_versioned, and pb are
-        ignored.
-        """
-        if from_tree is not self._transform._tree:
-            raise ValueError('from_tree must be transform source tree.')
-        if include_unchanged:
-            raise ValueError('include_unchanged is not supported')
-        if specific_files is not None:
-            raise ValueError('specific_files is not supported')
-        if want_unversioned:
-            raise ValueError('want_unversioned is not supported')
-        return self._transform.iter_changes()
-
-    def get_file(self, file_id, path=None):
-        """See Tree.get_file"""
-        if not self._content_change(file_id):
-            return self._transform._tree.get_file(file_id, path)
-        trans_id = self._transform.trans_id_file_id(file_id)
-        name = self._transform._limbo_name(trans_id)
-        return open(name, 'rb')
-
-    def get_file_text(self, file_id):
-        text_file = self.get_file(file_id)
-        try:
-            return text_file.read()
-        finally:
-            text_file.close()
-
-    def annotate_iter(self, file_id,
-                      default_revision=_mod_revision.CURRENT_REVISION):
-        changes = self._changes(file_id)
-        if changes is None:
-            get_old = True
-        else:
-            changed_content, versioned, kind = (changes[2], changes[3],
-                                                changes[6])
-            if kind[1] is None:
-                return None
-            get_old = (kind[0] == 'file' and versioned[0])
-        if get_old:
-            old_annotation = self._transform._tree.annotate_iter(file_id,
-                default_revision=default_revision)
-        else:
-            old_annotation = []
-        if changes is None:
-            return old_annotation
-        if not changed_content:
-            return old_annotation
-        return annotate.reannotate([old_annotation],
-                                   self.get_file(file_id).readlines(),
-                                   default_revision)
-
-    def get_symlink_target(self, file_id):
-        """See Tree.get_symlink_target"""
-        if not self._content_change(file_id):
-            return self._transform._tree.get_symlink_target(file_id)
-        trans_id = self._transform.trans_id_file_id(file_id)
-        name = self._transform._limbo_name(trans_id)
-        return os.readlink(name)
-
-    def walkdirs(self, prefix=''):
-        pending = [self._transform.root]
-        while len(pending) > 0:
-            parent_id = pending.pop()
-            children = []
-            subdirs = []
-            prefix = prefix.rstrip('/')
-            parent_path = self._final_paths.get_path(parent_id)
-            parent_file_id = self._transform.final_file_id(parent_id)
-            for child_id in self._all_children(parent_id):
-                path_from_root = self._final_paths.get_path(child_id)
-                basename = self._transform.final_name(child_id)
-                file_id = self._transform.final_file_id(child_id)
-                try:
-                    kind = self._transform.final_kind(child_id)
-                    versioned_kind = kind
-                except NoSuchFile:
-                    kind = 'unknown'
-                    versioned_kind = self._transform._tree.stored_kind(file_id)
-                if versioned_kind == 'directory':
-                    subdirs.append(child_id)
-                children.append((path_from_root, basename, kind, None,
-                                 file_id, versioned_kind))
-            children.sort()
-            if parent_path.startswith(prefix):
-                yield (parent_path, parent_file_id), children
-            pending.extend(sorted(subdirs, key=self._final_paths.get_path,
-                                  reverse=True))
-
-    def get_parent_ids(self):
-        return self._parent_ids
-
-    def set_parent_ids(self, parent_ids):
-        self._parent_ids = parent_ids
-
-    def get_revision_tree(self, revision_id):
-        return self._transform._tree.get_revision_tree(revision_id)
-
 
 def joinpath(parent, child):
     """Join tree-relative paths, handling the tree root specially"""
@@ -1824,11 +1237,6 @@
             self._known_paths[trans_id] = self._determine_path(trans_id)
         return self._known_paths[trans_id]
 
-    def get_paths(self, trans_ids):
-        return [(self.get_path(t), t) for t in trans_ids]
-
-
-
 def topology_sorted_ids(tree):
     """Determine the topological order of the ids in a tree"""
     file_ids = list(tree)
@@ -1836,8 +1244,7 @@
     return file_ids
 
 
-def build_tree(tree, wt, accelerator_tree=None, hardlink=False,
-               delta_from_tree=False):
+def build_tree(tree, wt):
     """Create working tree for a branch, using a TreeTransform.
     
     This function should be used on empty trees, having a tree root at most.
@@ -1850,44 +1257,21 @@
     - Otherwise, if the content on disk matches the content we are building,
       it is silently replaced.
     - Otherwise, conflict resolution will move the old file to 'oldname.moved'.
-
-    :param tree: The tree to convert wt into a copy of
-    :param wt: The working tree that files will be placed into
-    :param accelerator_tree: A tree which can be used for retrieving file
-        contents more quickly than tree itself, i.e. a workingtree.  tree
-        will be used for cases where accelerator_tree's content is different.
-    :param hardlink: If true, hard-link files to accelerator_tree, where
-        possible.  accelerator_tree must implement abspath, i.e. be a
-        working tree.
-    :param delta_from_tree: If true, build_tree may use the input Tree to
-        generate the inventory delta.
     """
     wt.lock_tree_write()
     try:
         tree.lock_read()
         try:
-            if accelerator_tree is not None:
-                accelerator_tree.lock_read()
-            try:
-                return _build_tree(tree, wt, accelerator_tree, hardlink,
-                                   delta_from_tree)
-            finally:
-                if accelerator_tree is not None:
-                    accelerator_tree.unlock()
+            return _build_tree(tree, wt)
         finally:
             tree.unlock()
     finally:
         wt.unlock()
 
-
-def _build_tree(tree, wt, accelerator_tree, hardlink, delta_from_tree):
+def _build_tree(tree, wt):
     """See build_tree."""
-    for num, _unused in enumerate(wt.all_file_ids()):
-        if num > 0:  # more than just a root
-            raise errors.WorkingTreeAlreadyPopulated(base=wt.basedir)
-    existing_files = set()
-    for dir, files in wt.walkdirs():
-        existing_files.update(f[0] for f in files)
+    if len(wt.inventory) > 1:  # more than just a root
+        raise errors.WorkingTreeAlreadyPopulated(base=wt.basedir)
     file_trans_id = {}
     top_pb = bzrlib.ui.ui_factory.nested_progress_bar()
     pp = ProgressPhase("Build phase", 2, top_pb)
@@ -1899,8 +1283,8 @@
         # is set within the tree, nor setting the root and thus
         # marking the tree as dirty, because we use two different
         # idioms here: tree interfaces and inventory interfaces.
-        if wt.get_root_id() != tree.get_root_id():
-            wt.set_root_id(tree.get_root_id())
+        if wt.path2id('') != tree.inventory.root.file_id:
+            wt.set_root_id(tree.inventory.root.file_id)
             wt.flush()
     tt = TreeTransform(wt)
     divert = set()
@@ -1911,24 +1295,20 @@
         pb = bzrlib.ui.ui_factory.nested_progress_bar()
         try:
             deferred_contents = []
-            num = 0
-            total = len(tree.inventory)
-            if delta_from_tree:
-                precomputed_delta = []
-            else:
-                precomputed_delta = None
             for num, (tree_path, entry) in \
                 enumerate(tree.inventory.iter_entries_by_dir()):
-                pb.update("Building tree", num - len(deferred_contents), total)
+                pb.update("Building tree", num - len(deferred_contents),
+                          len(tree.inventory))
                 if entry.parent_id is None:
                     continue
                 reparent = False
                 file_id = entry.file_id
-                if delta_from_tree:
-                    precomputed_delta.append((None, tree_path, file_id, entry))
-                if tree_path in existing_files:
-                    target_path = wt.abspath(tree_path)
+                target_path = wt.abspath(tree_path)
+                try:
                     kind = file_kind(target_path)
+                except NoSuchFile:
+                    pass
+                else:
                     if kind == "directory":
                         try:
                             bzrdir.BzrDir.open(target_path)
@@ -1942,17 +1322,21 @@
                         tt.delete_contents(tt.trans_id_tree_path(tree_path))
                         if kind == 'directory':
                             reparent = True
+                if entry.parent_id not in file_trans_id:
+                    raise AssertionError(
+                        'entry %s parent id %r is not in file_trans_id %r'
+                        % (entry, entry.parent_id, file_trans_id))
                 parent_id = file_trans_id[entry.parent_id]
                 if entry.kind == 'file':
                     # We *almost* replicate new_by_entry, so that we can defer
                     # getting the file text, and get them all at once.
                     trans_id = tt.create_path(entry.name, parent_id)
                     file_trans_id[file_id] = trans_id
-                    tt.version_file(file_id, trans_id)
-                    executable = tree.is_executable(file_id, tree_path)
-                    if executable:
+                    tt.version_file(entry.file_id, trans_id)
+                    executable = tree.is_executable(entry.file_id, tree_path)
+                    if executable is not None:
                         tt.set_executability(executable, trans_id)
-                    deferred_contents.append((file_id, trans_id))
+                    deferred_contents.append((entry.file_id, trans_id))
                 else:
                     file_trans_id[file_id] = new_by_entry(tt, entry, parent_id,
                                                           tree)
@@ -1960,17 +1344,18 @@
                     new_trans_id = file_trans_id[file_id]
                     old_parent = tt.trans_id_tree_path(tree_path)
                     _reparent_children(tt, old_parent, new_trans_id)
-            offset = num + 1 - len(deferred_contents)
-            _create_files(tt, tree, deferred_contents, pb, offset,
-                          accelerator_tree, hardlink)
+            for num, (trans_id, bytes) in enumerate(
+                tree.iter_files_bytes(deferred_contents)):
+                tt.create_file(bytes, trans_id)
+                pb.update('Adding file contents',
+                          (num + len(tree.inventory) - len(deferred_contents)),
+                          len(tree.inventory))
         finally:
             pb.finished()
         pp.next_phase()
         divert_trans = set(file_trans_id[f] for f in divert)
         resolver = lambda t, c: resolve_checkout(t, c, divert_trans)
         raw_conflicts = resolve_conflicts(tt, pass_func=resolver)
-        if len(raw_conflicts) > 0:
-            precomputed_delta = None
         conflicts = cook_conflicts(raw_conflicts, tt)
         for conflict in conflicts:
             warning(conflict)
@@ -1978,57 +1363,17 @@
             wt.add_conflicts(conflicts)
         except errors.UnsupportedOperation:
             pass
-        result = tt.apply(no_conflicts=True,
-                          precomputed_delta=precomputed_delta)
+        result = tt.apply()
     finally:
         tt.finalize()
         top_pb.finished()
     return result
 
 
-def _create_files(tt, tree, desired_files, pb, offset, accelerator_tree,
-                  hardlink):
-    total = len(desired_files) + offset
-    if accelerator_tree is None:
-        new_desired_files = desired_files
-    else:
-        iter = accelerator_tree.iter_changes(tree, include_unchanged=True)
-        unchanged = dict((f, p[1]) for (f, p, c, v, d, n, k, e)
-                         in iter if not (c or e[0] != e[1]))
-        new_desired_files = []
-        count = 0
-        for file_id, trans_id in desired_files:
-            accelerator_path = unchanged.get(file_id)
-            if accelerator_path is None:
-                new_desired_files.append((file_id, trans_id))
-                continue
-            pb.update('Adding file contents', count + offset, total)
-            if hardlink:
-                tt.create_hardlink(accelerator_tree.abspath(accelerator_path),
-                                   trans_id)
-            else:
-                contents = accelerator_tree.get_file(file_id, accelerator_path)
-                try:
-                    tt.create_file(contents, trans_id)
-                finally:
-                    contents.close()
-            count += 1
-        offset += count
-    for count, (trans_id, contents) in enumerate(tree.iter_files_bytes(
-                                                 new_desired_files)):
-        tt.create_file(contents, trans_id)
-        pb.update('Adding file contents', count + offset, total)
-
-
 def _reparent_children(tt, old_parent, new_parent):
     for child in tt.iter_tree_children(old_parent):
         tt.adjust_path(tt.final_name(child), new_parent, child)
 
-def _reparent_transform_children(tt, old_parent, new_parent):
-    by_parent = tt.by_parent()
-    for child in by_parent[old_parent]:
-        tt.adjust_path(tt.final_name(child), new_parent, child)
-    return by_parent[old_parent]
 
 def _content_match(tree, entry, file_id, kind, target_path):
     if entry.kind != kind:
@@ -2048,8 +1393,7 @@
     new_conflicts = set()
     for c_type, conflict in ((c[0], c) for c in conflicts):
         # Anything but a 'duplicate' would indicate programmer error
-        if c_type != 'duplicate':
-            raise AssertionError(c_type)
+        assert c_type == 'duplicate', c_type
         # Now figure out which is new and which is old
         if tt.new_contents(conflict[1]):
             new_file = conflict[1]
@@ -2094,7 +1438,6 @@
     else:
         raise errors.BadFileKindError(name, kind)
 
-
 def create_by_entry(tt, entry, tree, trans_id, lines=None, mode_id=None):
     """Create new file contents according to an inventory entry."""
     if entry.kind == "file":
@@ -2106,13 +1449,73 @@
     elif entry.kind == "directory":
         tt.create_directory(trans_id)
 
-
 def create_entry_executability(tt, entry, trans_id):
     """Set the executability of a trans_id according to an inventory entry"""
     if entry.kind == "file":
         tt.set_executability(entry.executable, trans_id)
 
 
+@deprecated_function(zero_fifteen)
+def find_interesting(working_tree, target_tree, filenames):
+    """Find the ids corresponding to specified filenames.
+    
+    Deprecated: Please use tree1.paths2ids(filenames, [tree2]).
+    """
+    working_tree.lock_read()
+    try:
+        target_tree.lock_read()
+        try:
+            return working_tree.paths2ids(filenames, [target_tree])
+        finally:
+            target_tree.unlock()
+    finally:
+        working_tree.unlock()
+
+
+@deprecated_function(zero_ninety)
+def change_entry(tt, file_id, working_tree, target_tree, 
+                 trans_id_file_id, backups, trans_id, by_parent):
+    """Replace a file_id's contents with those from a target tree."""
+    if file_id is None and target_tree is None:
+        # skip the logic altogether in the deprecation test
+        return
+    e_trans_id = trans_id_file_id(file_id)
+    entry = target_tree.inventory[file_id]
+    has_contents, contents_mod, meta_mod, = _entry_changes(file_id, entry, 
+                                                           working_tree)
+    if contents_mod:
+        mode_id = e_trans_id
+        if has_contents:
+            if not backups:
+                tt.delete_contents(e_trans_id)
+            else:
+                parent_trans_id = trans_id_file_id(entry.parent_id)
+                backup_name = get_backup_name(entry, by_parent,
+                                              parent_trans_id, tt)
+                tt.adjust_path(backup_name, parent_trans_id, e_trans_id)
+                tt.unversion_file(e_trans_id)
+                e_trans_id = tt.create_path(entry.name, parent_trans_id)
+                tt.version_file(file_id, e_trans_id)
+                trans_id[file_id] = e_trans_id
+        create_by_entry(tt, entry, target_tree, e_trans_id, mode_id=mode_id)
+        create_entry_executability(tt, entry, e_trans_id)
+
+    elif meta_mod:
+        tt.set_executability(entry.executable, e_trans_id)
+    if tt.final_name(e_trans_id) != entry.name:
+        adjust_path  = True
+    else:
+        parent_id = tt.final_parent(e_trans_id)
+        parent_file_id = tt.final_file_id(parent_id)
+        if parent_file_id != entry.parent_id:
+            adjust_path = True
+        else:
+            adjust_path = False
+    if adjust_path:
+        parent_trans_id = trans_id_file_id(entry.parent_id)
+        tt.adjust_path(entry.name, parent_trans_id, e_trans_id)
+
+
 def get_backup_name(entry, by_parent, parent_trans_id, tt):
     return _get_backup_name(entry.name, by_parent, parent_trans_id, tt)
 
@@ -2163,12 +1566,24 @@
     tt = TreeTransform(working_tree, pb)
     try:
         pp = ProgressPhase("Revert phase", 3, pb)
-        conflicts, merge_modified = _prepare_revert_transform(
-            working_tree, target_tree, tt, filenames, backups, pp)
+        pp.next_phase()
+        child_pb = bzrlib.ui.ui_factory.nested_progress_bar()
+        try:
+            merge_modified = _alter_files(working_tree, target_tree, tt,
+                                          child_pb, filenames, backups)
+        finally:
+            child_pb.finished()
+        pp.next_phase()
+        child_pb = bzrlib.ui.ui_factory.nested_progress_bar()
+        try:
+            raw_conflicts = resolve_conflicts(tt, child_pb)
+        finally:
+            child_pb.finished()
+        conflicts = cook_conflicts(raw_conflicts, tt)
         if change_reporter:
             change_reporter = delta._ChangeReporter(
                 unversioned_filter=working_tree.is_ignored)
-            delta.report_changes(tt.iter_changes(), change_reporter)
+            delta.report_changes(tt._iter_changes(), change_reporter)
         for conflict in conflicts:
             warning(conflict)
         pp.next_phase()
@@ -2181,40 +1596,16 @@
     return conflicts
 
 
-def _prepare_revert_transform(working_tree, target_tree, tt, filenames,
-                              backups, pp, basis_tree=None,
-                              merge_modified=None):
-    pp.next_phase()
-    child_pb = bzrlib.ui.ui_factory.nested_progress_bar()
-    try:
-        if merge_modified is None:
-            merge_modified = working_tree.merge_modified()
-        merge_modified = _alter_files(working_tree, target_tree, tt,
-                                      child_pb, filenames, backups,
-                                      merge_modified, basis_tree)
-    finally:
-        child_pb.finished()
-    pp.next_phase()
-    child_pb = bzrlib.ui.ui_factory.nested_progress_bar()
-    try:
-        raw_conflicts = resolve_conflicts(tt, child_pb,
-            lambda t, c: conflict_pass(t, c, target_tree))
-    finally:
-        child_pb.finished()
-    conflicts = cook_conflicts(raw_conflicts, tt)
-    return conflicts, merge_modified
-
-
 def _alter_files(working_tree, target_tree, tt, pb, specific_files,
-                 backups, merge_modified, basis_tree=None):
-    if basis_tree is not None:
-        basis_tree.lock_read()
-    change_list = target_tree.iter_changes(working_tree,
+                 backups):
+    merge_modified = working_tree.merge_modified()
+    change_list = target_tree._iter_changes(working_tree,
         specific_files=specific_files, pb=pb)
-    if target_tree.get_root_id() is None:
+    if target_tree.inventory.root is None:
         skip_root = True
     else:
         skip_root = False
+    basis_tree = None
     try:
         deferred_files = []
         for id_num, (file_id, path, changed_content, versioned, parent, name,
@@ -2256,12 +1647,8 @@
                         # contents
                         mode_id = trans_id
                         trans_id = new_trans_id
-                if kind[1] in ('directory', 'tree-reference'):
+                if kind[1] == 'directory':
                     tt.create_directory(trans_id)
-                    if kind[1] == 'tree-reference':
-                        revision = target_tree.get_reference_revision(file_id,
-                                                                      path[1])
-                        tt.set_tree_reference(revision, trans_id)
                 elif kind[1] == 'symlink':
                     tt.create_symlink(target_tree.get_symlink_target(file_id),
                                       trans_id)
@@ -2281,19 +1668,16 @@
                     # preserve the execute bit when backing up
                     if keep_content and executable[0] == executable[1]:
                         tt.set_executability(executable[1], trans_id)
-                elif kind[1] is not None:
-                    raise AssertionError(kind[1])
+                else:
+                    assert kind[1] is None
             if versioned == (False, True):
                 tt.version_file(file_id, trans_id)
             if versioned == (True, False):
                 tt.unversion_file(trans_id)
-            if (name[1] is not None and
+            if (name[1] is not None and 
                 (name[0] != name[1] or parent[0] != parent[1])):
-                if name[1] == '' and parent[1] is None:
-                    parent_trans = ROOT_PARENT
-                else:
-                    parent_trans = tt.trans_id_file_id(parent[1])
-                tt.adjust_path(name[1], parent_trans, trans_id)
+                tt.adjust_path(
+                    name[1], tt.trans_id_file_id(parent[1]), trans_id)
             if executable[0] != executable[1] and kind[1] == "file":
                 tt.set_executability(executable[1], trans_id)
         for (trans_id, mode_id), bytes in target_tree.iter_files_bytes(
@@ -2337,15 +1721,16 @@
                                conflict[1], conflict[2], ))
         elif c_type == 'duplicate':
             # files that were renamed take precedence
+            new_name = tt.final_name(conflict[1])+'.moved'
             final_parent = tt.final_parent(conflict[1])
             if tt.path_changed(conflict[1]):
-                existing_file, new_file = conflict[2], conflict[1]
+                tt.adjust_path(new_name, final_parent, conflict[2])
+                new_conflicts.add((c_type, 'Moved existing file to', 
+                                   conflict[2], conflict[1]))
             else:
-                existing_file, new_file = conflict[1], conflict[2]
-            new_name = tt.final_name(existing_file)+'.moved'
-            tt.adjust_path(new_name, final_parent, existing_file)
-            new_conflicts.add((c_type, 'Moved existing file to', 
-                               existing_file, new_file))
+                tt.adjust_path(new_name, final_parent, conflict[1])
+                new_conflicts.add((c_type, 'Moved existing file to', 
+                                  conflict[1], conflict[2]))
         elif c_type == 'parent loop':
             # break the loop by undoing one of the ops that caused the loop
             cur = conflict[1]
@@ -2362,53 +1747,18 @@
                 new_conflicts.add(('deleting parent', 'Not deleting', 
                                    trans_id))
             except KeyError:
-                create = True
+                tt.create_directory(trans_id)
+                new_conflicts.add((c_type, 'Created directory', trans_id))
                 try:
                     tt.final_name(trans_id)
                 except NoFinalPath:
-                    if path_tree is not None:
-                        file_id = tt.final_file_id(trans_id)
-                        if file_id is None:
-                            file_id = tt.inactive_file_id(trans_id)
-                        entry = path_tree.inventory[file_id]
-                        # special-case the other tree root (move its
-                        # children to current root)
-                        if entry.parent_id is None:
-                            create=False
-                            moved = _reparent_transform_children(
-                                tt, trans_id, tt.root)
-                            for child in moved:
-                                new_conflicts.add((c_type, 'Moved to root',
-                                                   child))
-                        else:
-                            parent_trans_id = tt.trans_id_file_id(
-                                entry.parent_id)
-                            tt.adjust_path(entry.name, parent_trans_id,
-                                           trans_id)
-                if create:
-                    tt.create_directory(trans_id)
-                    new_conflicts.add((c_type, 'Created directory', trans_id))
+                    file_id = tt.final_file_id(trans_id)
+                    entry = path_tree.inventory[file_id]
+                    parent_trans_id = tt.trans_id_file_id(entry.parent_id)
+                    tt.adjust_path(entry.name, parent_trans_id, trans_id)
         elif c_type == 'unversioned parent':
-            file_id = tt.inactive_file_id(conflict[1])
-            # special-case the other tree root (move its children instead)
-            if path_tree and file_id in path_tree:
-                if path_tree.inventory[file_id].parent_id is None:
-                    continue
-            tt.version_file(file_id, conflict[1])
+            tt.version_file(tt.inactive_file_id(conflict[1]), conflict[1])
             new_conflicts.add((c_type, 'Versioned directory', conflict[1]))
-        elif c_type == 'non-directory parent':
-            parent_id = conflict[1]
-            parent_parent = tt.final_parent(parent_id)
-            parent_name = tt.final_name(parent_id)
-            parent_file_id = tt.final_file_id(parent_id)
-            new_parent_id = tt.new_directory(parent_name + '.new',
-                parent_parent, parent_file_id)
-            _reparent_transform_children(tt, parent_id, new_parent_id)
-            if parent_file_id is not None:
-                tt.unversion_file(parent_id)
-            new_conflicts.add((c_type, 'Created directory', new_parent_id))
-        elif c_type == 'versioning no contents':
-            tt.cancel_versioning(conflict[1])
     return new_conflicts
 
 
@@ -2449,12 +1799,7 @@
 
     def rename(self, from_, to):
         """Rename a file from one path to another.  Functions like os.rename"""
-        try:
-            os.rename(from_, to)
-        except OSError, e:
-            if e.errno in (errno.EEXIST, errno.ENOTEMPTY):
-                raise errors.FileExists(to, str(e))
-            raise
+        os.rename(from_, to)
         self.past_renames.append((from_, to))
 
     def pre_delete(self, from_, to):

=== modified file 'bzrlib/transport/__init__.py'
--- bzrlib/transport/__init__.py	2008-09-03 09:11:20 +0000
+++ bzrlib/transport/__init__.py	2007-10-22 21:19:13 +0000
@@ -33,10 +33,14 @@
 from bzrlib.lazy_import import lazy_import
 lazy_import(globals(), """
 import errno
+from collections import deque
 from stat import S_ISDIR
+import unittest
 import urllib
 import urlparse
+import warnings
 
+import bzrlib
 from bzrlib import (
     errors,
     osutils,
@@ -46,13 +50,18 @@
 """)
 
 from bzrlib.symbol_versioning import (
+        deprecated_passed,
         deprecated_method,
         deprecated_function,
         DEPRECATED_PARAMETER,
-        one_four,
+        zero_eight,
+        zero_eleven,
+        zero_ninety,
         )
 from bzrlib.trace import (
+    note,
     mutter,
+    warning,
     )
 from bzrlib import registry
 
@@ -119,24 +128,26 @@
         self.get(key).insert(0,
                 registry._LazyObjectGetter(module_name, member_name))
 
-    def register_transport(self, key, help=None):
-        self.register(key, [], help)
+    def register_transport(self, key, help=None, default_port=None):
+        self.register(key, [], help, default_port)
 
     def set_default_transport(self, key=None):
         """Return either 'key' or the default key if key is None"""
         self._default_key = key
 
+    def get_default_port(self, scheme):
+        """Return the registered default port for this protocol scheme."""
+        try:
+            return self.get_info(scheme + '://')
+        except LookupError:
+            return None
+
 
 transport_list_registry = TransportListRegistry()
 
 
-def register_transport_proto(prefix, help=None, info=None,
-                             register_netloc=False):
-    transport_list_registry.register_transport(prefix, help)
-    if register_netloc:
-        if not prefix.endswith('://'):
-            raise ValueError(prefix)
-        register_urlparse_netloc_protocol(prefix[:-3])
+def register_transport_proto(prefix, help=None, info=None, default_port=None):
+    transport_list_registry.register_transport(prefix, help, default_port)
 
 
 def register_lazy_transport(prefix, module, classname):
@@ -179,6 +190,39 @@
         transport_list_registry.remove(scheme)
 
 
+
+@deprecated_function(zero_ninety)
+def split_url(url):
+    # TODO: jam 20060606 urls should only be ascii, or they should raise InvalidURL
+    if isinstance(url, unicode):
+        url = url.encode('utf-8')
+    (scheme, netloc, path, params,
+     query, fragment) = urlparse.urlparse(url, allow_fragments=False)
+    username = password = host = port = None
+    if '@' in netloc:
+        username, host = netloc.split('@', 1)
+        if ':' in username:
+            username, password = username.split(':', 1)
+            password = urllib.unquote(password)
+        username = urllib.unquote(username)
+    else:
+        host = netloc
+
+    if ':' in host:
+        host, port = host.rsplit(':', 1)
+        try:
+            port = int(port)
+        except ValueError:
+            # TODO: Should this be ConnectionError?
+            raise errors.TransportError(
+                'invalid port number %s in url:\n%s' % (port, url))
+    host = urllib.unquote(host)
+
+    path = urllib.unquote(path)
+
+    return (scheme, username, password, host, port, path)
+
+
 class _CoalescedOffset(object):
     """A data container for keeping track of coalesced offsets."""
 
@@ -193,10 +237,6 @@
         return cmp((self.start, self.length, self.ranges),
                    (other.start, other.length, other.ranges))
 
-    def __repr__(self):
-        return '%s(%r, %r, %r)' % (self.__class__.__name__,
-            self.start, self.length, self.ranges)
-
 
 class LateReadError(object):
     """A helper for transports which pretends to be a readable file.
@@ -254,7 +294,7 @@
         self.file_handle.close()
 
     def write(self, bytes):
-        osutils.pump_string_file(bytes, self.file_handle)
+        self.file_handle.write(bytes)
 
 
 class AppendBasedFileStream(FileStream):
@@ -293,7 +333,7 @@
     _bytes_to_read_before_seek = 0
 
     def __init__(self, base):
-        super(Transport, self).__init__(base=base)
+        super(Transport, self).__init__()
         self.base = base
 
     def _translate_error(self, e, path, raise_generic=True):
@@ -302,7 +342,7 @@
         This handles things like ENOENT, ENOTDIR, EEXIST, and EACCESS
         """
         if getattr(e, 'errno', None) is not None:
-            if e.errno in (errno.ENOENT, errno.ENOTDIR, errno.EINVAL):
+            if e.errno in (errno.ENOENT, errno.ENOTDIR):
                 raise errors.NoSuchFile(path, extra=e)
             # I would rather use errno.EFOO, but there doesn't seem to be
             # any matching for 267
@@ -371,6 +411,8 @@
         object or string to another one.
         This just gives them something easy to call.
         """
+        assert not isinstance(from_file, basestring), \
+            '_pump should only be called on files not %s' % (type(from_file,))
         return osutils.pumpfile(from_file, to_file)
 
     def _get_total(self, multi):
@@ -537,7 +579,7 @@
         *NOTE*: This only lists *files*, not subdirectories!
         
         As with other listing functions, only some transports implement this,.
-        you may check via listable() to determine if it will.
+        you may check via is_listable to determine if it will.
         """
         raise errors.TransportNotPossible("This transport has not "
                                           "implemented iter_files_recursive "
@@ -570,7 +612,6 @@
         """
         return self.get(relpath).read()
 
-    @deprecated_method(one_four)
     def get_smart_client(self):
         """Return a smart client for this transport if possible.
 
@@ -591,7 +632,6 @@
         """
         raise errors.NoSmartMedium(self)
 
-    @deprecated_method(one_four)
     def get_shared_medium(self):
         """Return a smart client shared medium for this transport if possible.
 
@@ -608,7 +648,7 @@
 
         :param relpath: The path to read data from.
         :param offsets: A list of (offset, size) tuples.
-        :param adjust_for_latency: Adjust the requested offsets to accomodate
+        :param adjust_for_latency: Adjust the requested offsets to accomdate
             transport latency. This may re-order the offsets, expand them to
             grab adjacent data when there is likely a high cost to requesting
             data relative to delivering it.
@@ -624,12 +664,9 @@
         if adjust_for_latency:
             # Design note: We may wish to have different algorithms for the
             # expansion of the offsets per-transport. E.g. for local disk to
-            # use page-aligned expansion. If that is the case consider the
-            # following structure:
-            #  - a test that transport.readv uses self._offset_expander or some
-            #    similar attribute, to do the expansion
-            #  - a test for each transport that it has some known-good offset
-            #    expander
+            # use page-aligned expansion. If that is the case consider the following structure:
+            #  - a test that transport.readv uses self._offset_expander or some similar attribute, to do the expansion
+            #  - a test for each transport that it has some known-good offset expander
             #  - unit tests for each offset expander
             #  - a set of tests for the offset expander interface, giving
             #    baseline behaviour (which the current transport
@@ -751,7 +788,7 @@
         return offsets
 
     @staticmethod
-    def _coalesce_offsets(offsets, limit=0, fudge_factor=0, max_size=0):
+    def _coalesce_offsets(offsets, limit, fudge_factor):
         """Yield coalesced offsets.
 
         With a long list of neighboring requests, combine them
@@ -760,21 +797,13 @@
         Turns  [(15, 10), (25, 10)] => [(15, 20, [(0, 10), (10, 10)])]
 
         :param offsets: A list of (start, length) pairs
-
-        :param limit: Only combine a maximum of this many pairs Some transports
-                penalize multiple reads more than others, and sometimes it is
-                better to return early.
-                0 means no limit
-
+        :param limit: Only combine a maximum of this many pairs
+                      Some transports penalize multiple reads more than
+                      others, and sometimes it is better to return early.
+                      0 means no limit
         :param fudge_factor: All transports have some level of 'it is
                 better to read some more data and throw it away rather 
                 than seek', so collapse if we are 'close enough'
-
-        :param max_size: Create coalesced offsets no bigger than this size.
-                When a single offset is bigger than 'max_size', it will keep
-                its size and be alone in the coalesced offset.
-                0 means no maximum size.
-
         :return: yield _CoalescedOffset objects, which have members for where
                 to start, how much to read, and how to split those 
                 chunks back up
@@ -784,11 +813,10 @@
 
         for start, size in offsets:
             end = start + size
-            if (last_end is not None
+            if (last_end is not None 
                 and start <= last_end + fudge_factor
                 and start >= cur.start
-                and (limit <= 0 or len(cur.ranges) < limit)
-                and (max_size <= 0 or end - cur.start <= max_size)):
+                and (limit <= 0 or len(cur.ranges) < limit)):
                 cur.length = end - cur.start
                 cur.ranges.append((start-cur.start, size))
             else:
@@ -965,9 +993,8 @@
 
         :returns: the length of relpath before the content was written to it.
         """
-        if not isinstance(bytes, str):
-            raise TypeError(
-                'bytes must be a plain string, not %s' % type(bytes))
+        assert isinstance(bytes, str), \
+            'bytes must be a plain string, not %s' % type(bytes)
         return self.append_file(relpath, StringIO(bytes), mode=mode)
 
     def append_multi(self, files, pb=None):
@@ -1222,7 +1249,7 @@
 class _SharedConnection(object):
     """A connection shared between several transports."""
 
-    def __init__(self, connection=None, credentials=None, base=None):
+    def __init__(self, connection=None, credentials=None):
         """Constructor.
 
         :param connection: An opaque object specific to each transport.
@@ -1232,7 +1259,6 @@
         """
         self.connection = connection
         self.credentials = credentials
-        self.base = base
 
 
 class ConnectedTransport(Transport):
@@ -1311,7 +1337,7 @@
          query, fragment) = urlparse.urlparse(url, allow_fragments=False)
         user = password = host = port = None
         if '@' in netloc:
-            user, host = netloc.rsplit('@', 1)
+            user, host = netloc.split('@', 1)
             if ':' in user:
                 user, password = user.split(':', 1)
                 password = urllib.unquote(password)
@@ -1332,6 +1358,10 @@
         host = urllib.unquote(host)
         path = urllib.unquote(path)
 
+        if port is None:
+            # The port isn't explicitly specified, so return the default (if
+            # there is one).
+            port = transport_list_registry.get_default_port(scheme)
         return (scheme, user, password, host, port, path)
 
     @staticmethod
@@ -1362,7 +1392,10 @@
             # have one so that it doesn't get accidentally
             # exposed.
             netloc = '%s@%s' % (urllib.quote(user), netloc)
-        if port is not None:
+        if (port is not None and 
+            port != transport_list_registry.get_default_port(scheme)):
+            # Include the port in the netloc (unless it's the same as the
+            # default, in which case we omit it as it is redundant).
             netloc = '%s:%d' % (netloc, port)
         path = urllib.quote(path)
         return urlparse.urlunparse((scheme, netloc, path, None, None, None))
@@ -1419,7 +1452,7 @@
         """Get the object shared amongst cloned transports.
 
         This should be used only by classes that needs to extend the sharing
-        with objects other than transports.
+        with other objects than tramsports.
 
         Use _get_connection to get the connection itself.
         """
@@ -1477,14 +1510,7 @@
 
         :return: A new transport or None if the connection cannot be shared.
         """
-        try:
-            (scheme, user, password,
-             host, port, path) = self._split_url(other_base)
-        except errors.InvalidURL:
-            # No hope in trying to reuse an existing transport for an invalid
-            # URL
-            return None
-
+        (scheme, user, password, host, port, path) = self._split_url(other_base)
         transport = None
         # Don't compare passwords, they may be absent from other_base or from
         # self and they don't carry more information than user anyway.
@@ -1506,6 +1532,15 @@
         return transport
 
 
+@deprecated_function(zero_ninety)
+def urlescape(relpath):
+    urlutils.escape(relpath)
+
+
+@deprecated_function(zero_ninety)
+def urlunescape(url):
+    urlutils.unescape(url)
+
 # We try to recognize an url lazily (ignoring user, password, etc)
 _urlRE = re.compile(r'^(?P<proto>[^:/\\]+)://(?P<rest>.*)$')
 
@@ -1523,8 +1558,6 @@
     if base is None:
         base = '.'
     last_err = None
-    from bzrlib.directory_service import directories
-    base = directories.dereference(base)
 
     def convert_path_to_url(base, error_str):
         m = _urlRE.match(base)
@@ -1561,8 +1594,7 @@
             transport, last_err = _try_transport_factories(base, factory_list)
             if transport:
                 if possible_transports is not None:
-                    if transport in possible_transports:
-                        raise AssertionError()
+                    assert transport not in possible_transports
                     possible_transports.append(transport)
                 return transport
 
@@ -1678,72 +1710,57 @@
 register_lazy_transport('file://', 'bzrlib.transport.local', 'LocalTransport')
 transport_list_registry.set_default_transport("file://")
 
+# Note that sftp:// has no default_port, because the user's ~/.ssh/config
+# can set it to arbitrary values based on hostname.
 register_transport_proto('sftp://',
-            help="Access using SFTP (most SSH servers provide SFTP).",
-            register_netloc=True)
+            help="Access using SFTP (most SSH servers provide SFTP).")
 register_lazy_transport('sftp://', 'bzrlib.transport.sftp', 'SFTPTransport')
 # Decorated http transport
 register_transport_proto('http+urllib://',
 #                help="Read-only access of branches exported on the web."
-                         register_netloc=True)
+            default_port=80)
 register_lazy_transport('http+urllib://', 'bzrlib.transport.http._urllib',
                         'HttpTransport_urllib')
 register_transport_proto('https+urllib://',
 #                help="Read-only access of branches exported on the web using SSL."
-                         register_netloc=True)
+            default_port=443)
 register_lazy_transport('https+urllib://', 'bzrlib.transport.http._urllib',
                         'HttpTransport_urllib')
 register_transport_proto('http+pycurl://',
 #                help="Read-only access of branches exported on the web."
-                         register_netloc=True)
+            default_port=80)
 register_lazy_transport('http+pycurl://', 'bzrlib.transport.http._pycurl',
                         'PyCurlTransport')
 register_transport_proto('https+pycurl://',
 #                help="Read-only access of branches exported on the web using SSL."
-                         register_netloc=True)
+            default_port=443)
 register_lazy_transport('https+pycurl://', 'bzrlib.transport.http._pycurl',
                         'PyCurlTransport')
 # Default http transports (last declared wins (if it can be imported))
 register_transport_proto('http://',
-                 help="Read-only access of branches exported on the web.")
+            help="Read-only access of branches exported on the web.",
+            default_port=80)
 register_transport_proto('https://',
-            help="Read-only access of branches exported on the web using SSL.")
+            help="Read-only access of branches exported on the web using SSL.",
+            default_port=443)
 register_lazy_transport('http://', 'bzrlib.transport.http._urllib',
                         'HttpTransport_urllib')
 register_lazy_transport('https://', 'bzrlib.transport.http._urllib',
                         'HttpTransport_urllib')
-register_lazy_transport('http://', 'bzrlib.transport.http._pycurl',
-                        'PyCurlTransport')
-register_lazy_transport('https://', 'bzrlib.transport.http._pycurl',
-                        'PyCurlTransport')
+register_lazy_transport('http://', 'bzrlib.transport.http._pycurl', 'PyCurlTransport')
+register_lazy_transport('https://', 'bzrlib.transport.http._pycurl', 'PyCurlTransport')
 
-register_transport_proto('ftp://', help="Access using passive FTP.")
+register_transport_proto('ftp://',
+            help="Access using passive FTP.",
+            default_port=21)
 register_lazy_transport('ftp://', 'bzrlib.transport.ftp', 'FtpTransport')
-register_transport_proto('aftp://', help="Access using active FTP.")
+register_transport_proto('aftp://',
+            help="Access using active FTP.",
+            default_port=21)
 register_lazy_transport('aftp://', 'bzrlib.transport.ftp', 'FtpTransport')
 
-# Default to trying GSSAPI authentication (if the kerberos module is available)
-register_transport_proto('ftp+gssapi://', register_netloc=True)
-register_lazy_transport('ftp+gssapi://', 'bzrlib.transport.ftp._gssapi', 
-                        'GSSAPIFtpTransport')
-register_transport_proto('aftp+gssapi://', register_netloc=True)
-register_lazy_transport('aftp+gssapi://', 'bzrlib.transport.ftp._gssapi', 
-                        'GSSAPIFtpTransport')
-register_transport_proto('ftp+nogssapi://', register_netloc=True)
-register_transport_proto('aftp+nogssapi://', register_netloc=True)
-
-register_lazy_transport('ftp://', 'bzrlib.transport.ftp._gssapi', 
-                        'GSSAPIFtpTransport')
-register_lazy_transport('aftp://', 'bzrlib.transport.ftp._gssapi', 
-                        'GSSAPIFtpTransport')
-register_lazy_transport('ftp+nogssapi://', 'bzrlib.transport.ftp', 
-                        'FtpTransport')
-register_lazy_transport('aftp+nogssapi://', 'bzrlib.transport.ftp', 
-                        'FtpTransport')
-
 register_transport_proto('memory://')
-register_lazy_transport('memory://', 'bzrlib.transport.memory',
-                        'MemoryTransport')
+register_lazy_transport('memory://', 'bzrlib.transport.memory', 'MemoryTransport')
 
 # chroots cannot be implicitly accessed, they must be explicitly created:
 register_transport_proto('chroot+')
@@ -1751,66 +1768,48 @@
 register_transport_proto('readonly+',
 #              help="This modifier converts any transport to be readonly."
             )
-register_lazy_transport('readonly+', 'bzrlib.transport.readonly',
-                        'ReadonlyTransportDecorator')
+register_lazy_transport('readonly+', 'bzrlib.transport.readonly', 'ReadonlyTransportDecorator')
 
 register_transport_proto('fakenfs+')
-register_lazy_transport('fakenfs+', 'bzrlib.transport.fakenfs',
-                        'FakeNFSTransportDecorator')
-
-register_transport_proto('log+')
-register_lazy_transport('log+', 'bzrlib.transport.log', 'TransportLogDecorator')
+register_lazy_transport('fakenfs+', 'bzrlib.transport.fakenfs', 'FakeNFSTransportDecorator')
 
 register_transport_proto('trace+')
-register_lazy_transport('trace+', 'bzrlib.transport.trace',
-                        'TransportTraceDecorator')
+register_lazy_transport('trace+', 'bzrlib.transport.trace', 'TransportTraceDecorator')
 
 register_transport_proto('unlistable+')
-register_lazy_transport('unlistable+', 'bzrlib.transport.unlistable',
-                        'UnlistableTransportDecorator')
+register_lazy_transport('unlistable+', 'bzrlib.transport.unlistable', 'UnlistableTransportDecorator')
 
 register_transport_proto('brokenrename+')
 register_lazy_transport('brokenrename+', 'bzrlib.transport.brokenrename',
-                        'BrokenRenameTransportDecorator')
+        'BrokenRenameTransportDecorator')
 
 register_transport_proto('vfat+')
 register_lazy_transport('vfat+',
                         'bzrlib.transport.fakevfat',
                         'FakeVFATTransportDecorator')
-
-register_transport_proto('nosmart+')
-register_lazy_transport('nosmart+', 'bzrlib.transport.nosmart',
-                        'NoSmartTransportDecorator')
-
-# These two schemes were registered, but don't seem to have an actual transport
-# protocol registered
-for scheme in ['ssh', 'bzr+loopback']:
-    register_urlparse_netloc_protocol(scheme)
-del scheme
-
 register_transport_proto('bzr://',
             help="Fast access using the Bazaar smart server.",
-                         register_netloc=True)
+            default_port=4155)
 
-register_lazy_transport('bzr://', 'bzrlib.transport.remote',
+register_lazy_transport('bzr://',
+                        'bzrlib.transport.remote',
                         'RemoteTCPTransport')
-register_transport_proto('bzr-v2://', register_netloc=True)
-
-register_lazy_transport('bzr-v2://', 'bzrlib.transport.remote',
-                        'RemoteTCPTransportV2Only')
 register_transport_proto('bzr+http://',
 #                help="Fast access using the Bazaar smart server over HTTP."
-                         register_netloc=True)
-register_lazy_transport('bzr+http://', 'bzrlib.transport.remote',
+            default_port=80)
+register_lazy_transport('bzr+http://',
+                        'bzrlib.transport.remote',
                         'RemoteHTTPTransport')
 register_transport_proto('bzr+https://',
 #                help="Fast access using the Bazaar smart server over HTTPS."
-                         register_netloc=True)
+             )
 register_lazy_transport('bzr+https://',
                         'bzrlib.transport.remote',
                         'RemoteHTTPTransport')
+# Note that bzr+ssh:// has no default_port, because the user's ~/.ssh/config
+# can set it to arbitrary values based on hostname.
 register_transport_proto('bzr+ssh://',
-            help="Fast access using the Bazaar smart server over SSH.",
-            register_netloc=True)
-register_lazy_transport('bzr+ssh://', 'bzrlib.transport.remote',
+            help="Fast access using the Bazaar smart server over SSH.")
+register_lazy_transport('bzr+ssh://',
+                        'bzrlib.transport.remote',
                         'RemoteSSHTransport')

=== modified file 'bzrlib/transport/chroot.py'
--- bzrlib/transport/chroot.py	2008-04-24 07:22:53 +0000
+++ bzrlib/transport/chroot.py	2007-08-15 06:53:07 +0000
@@ -45,6 +45,7 @@
         self.backing_transport = backing_transport
 
     def _factory(self, url):
+        assert url.startswith(self.scheme)
         return ChrootTransport(self, url)
 
     def get_url(self):
@@ -78,8 +79,7 @@
 
     def _safe_relpath(self, relpath):
         safe_relpath = self._combine_paths(self.base_path, relpath)
-        if not safe_relpath.startswith('/'):
-            raise ValueError(safe_relpath)
+        assert safe_relpath.startswith('/')
         return safe_relpath[1:]
 
     # Transport methods
@@ -116,9 +116,6 @@
     def has(self, relpath):
         return self._call('has', relpath)
 
-    def is_readonly(self):
-        return self.server.backing_transport.is_readonly()
-
     def iter_files_recursive(self):
         backing_transport = self.server.backing_transport.clone(
             self._safe_relpath('.'))

=== modified file 'bzrlib/transport/decorator.py'
--- bzrlib/transport/decorator.py	2008-04-24 07:22:53 +0000
+++ bzrlib/transport/decorator.py	2007-10-02 05:33:39 +0000
@@ -45,10 +45,9 @@
             need to share state across clones.
         """
         prefix = self._get_url_prefix()
-        if not url.startswith(prefix):
-            raise ValueError(
+        assert url.startswith(prefix), \
                 "url %r doesn't start with decorator prefix %r" % \
-                (url, prefix))
+                (url, prefix)
         decorated_url = url[len(prefix):]
         if _decorated is None:
             self._decorated = get_transport(decorated_url)

=== modified file 'bzrlib/transport/fakenfs.py'
--- bzrlib/transport/fakenfs.py	2008-05-26 03:34:59 +0000
+++ bzrlib/transport/fakenfs.py	2006-07-28 16:05:23 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2008 Canonical Ltd
+# Copyright (C) 2005, 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -24,10 +24,7 @@
 
 from stat import S_ISDIR
 
-from bzrlib import (
-    errors,
-    urlutils,
-    )
+import bzrlib.errors as errors
 from bzrlib.transport.decorator import TransportDecorator, DecoratorServer
 
 
@@ -56,11 +53,6 @@
             else:
                 raise
 
-    def delete(self, relpath):
-        if urlutils.basename(relpath).startswith('.nfs'):
-            raise errors.ResourceBusy(self.abspath(relpath))
-        return self._decorated.delete(relpath)
-
 
 class FakeNFSServer(DecoratorServer):
     """Server for the FakeNFSTransportDecorator for testing with."""

=== removed directory 'bzrlib/transport/ftp'
=== renamed file 'bzrlib/transport/ftp/__init__.py' => 'bzrlib/transport/ftp.py'
--- bzrlib/transport/ftp/__init__.py	2008-08-28 15:01:41 +0000
+++ bzrlib/transport/ftp.py	2007-10-23 07:15:13 +0000
@@ -25,14 +25,16 @@
 """
 
 from cStringIO import StringIO
+import asyncore
 import errno
 import ftplib
-import getpass
 import os
 import os.path
+import urllib
 import urlparse
-import socket
+import select
 import stat
+import threading
 import time
 import random
 from warnings import warn
@@ -89,8 +91,7 @@
 
     def __init__(self, base, _from_transport=None):
         """Set the base path where files will be stored."""
-        if not (base.startswith('ftp://') or base.startswith('aftp://')):
-            raise ValueError(base)
+        assert base.startswith('ftp://') or base.startswith('aftp://')
         super(FtpTransport, self).__init__(base,
                                            _from_transport=_from_transport)
         self._unqualified_scheme = 'ftp'
@@ -144,10 +145,6 @@
                                              port=self._port)
             connection.login(user=user, passwd=password)
             connection.set_pasv(not self.is_active)
-        except socket.error, e:
-            raise errors.SocketConnectionError(self._host, self._port,
-                                               msg='Unable to connect to',
-                                               orig_error= e)
         except ftplib.error_perm, e:
             raise errors.TransportError(msg="Error setting up connection:"
                                         " %s" % str(e), orig_error=e)
@@ -179,10 +176,7 @@
             or 'no such dir' in s
             or 'could not create file' in s # vsftpd
             or 'file doesn\'t exist' in s
-            or 'rnfr command failed.' in s # vsftpd RNFR reply if file not found
             or 'file/directory not found' in s # filezilla server
-            # Microsoft FTP-Service RNFR reply if file not found
-            or (s.startswith('550 ') and 'unable to rename to' in extra)
             ):
             raise errors.NoSuchFile(path, extra=extra)
         if ('file exists' in s):
@@ -310,7 +304,6 @@
             try:
                 f.storbinary('STOR '+tmp_abspath, fp)
                 self._rename_and_overwrite(tmp_abspath, abspath, f)
-                self._setmode(relpath, mode)
                 if bytes is not None:
                     return len(bytes)
                 else:
@@ -352,7 +345,6 @@
             mutter("FTP mkd: %s", abspath)
             f = self._get_FTP()
             f.mkd(abspath)
-            self._setmode(relpath, mode)
         except ftplib.error_perm, e:
             self._translate_perm_error(e, abspath,
                 unknown_exc=errors.FileExists)
@@ -413,7 +405,8 @@
             conn = ftp.transfercmd(cmd)
             conn.sendall(text)
             conn.close()
-            self._setmode(relpath, mode)
+            if mode:
+                self._setmode(relpath, mode)
             ftp.getresp()
         except ftplib.error_perm, e:
             self._translate_perm_error(e, abspath, extra='error appending',
@@ -433,18 +426,16 @@
         Only set permissions if the FTP server supports the 'SITE CHMOD'
         extension.
         """
-        if mode:
-            try:
-                mutter("FTP site chmod: setting permissions to %s on %s",
-                    str(mode), self._remote_path(relpath))
-                ftp = self._get_FTP()
-                cmd = "SITE CHMOD %s %s" % (oct(mode),
-                                            self._remote_path(relpath))
-                ftp.sendcmd(cmd)
-            except ftplib.error_perm, e:
-                # Command probably not available on this server
-                warning("FTP Could not set permissions to %s on %s. %s",
-                        str(mode), self._remote_path(relpath), str(e))
+        try:
+            mutter("FTP site chmod: setting permissions to %s on %s",
+                str(mode), self._remote_path(relpath))
+            ftp = self._get_FTP()
+            cmd = "SITE CHMOD %s %s" % (self._remote_path(relpath), str(mode))
+            ftp.sendcmd(cmd)
+        except ftplib.error_perm, e:
+            # Command probably not available on this server
+            warning("FTP Could not set permissions to %s on %s. %s",
+                    str(mode), self._remote_path(relpath), str(e))
 
     # TODO: jam 20060516 I believe ftp allows you to tell an ftp server
     #       to copy something to another machine. And you may be able
@@ -519,16 +510,6 @@
             paths = f.nlst(basepath)
         except ftplib.error_perm, e:
             self._translate_perm_error(e, relpath, extra='error with list_dir')
-        except ftplib.error_temp, e:
-            # xs4all's ftp server raises a 450 temp error when listing an empty
-            # directory. Check for that and just return an empty list in that
-            # case. See bug #215522
-            if str(e).lower().startswith('450 no files found'):
-                mutter('FTP Server returned "%s" for nlst.'
-                       ' Assuming it means empty directory',
-                       str(e))
-                return []
-            raise
         # If FTP.nlst returns paths prefixed by relpath, strip 'em
         if paths and paths[0].startswith(basepath):
             entries = [path[len(basepath)+1:] for path in paths]
@@ -585,29 +566,246 @@
         return self.lock_read(relpath)
 
 
+class FtpServer(Server):
+    """Common code for FTP server facilities."""
+
+    def __init__(self):
+        self._root = None
+        self._ftp_server = None
+        self._port = None
+        self._async_thread = None
+        # ftp server logs
+        self.logs = []
+
+    def get_url(self):
+        """Calculate an ftp url to this server."""
+        return 'ftp://foo:bar@localhost:%d/' % (self._port)
+
+#    def get_bogus_url(self):
+#        """Return a URL which cannot be connected to."""
+#        return 'ftp://127.0.0.1:1'
+
+    def log(self, message):
+        """This is used by medusa.ftp_server to log connections, etc."""
+        self.logs.append(message)
+
+    def setUp(self, vfs_server=None):
+        if not _have_medusa:
+            raise RuntimeError('Must have medusa to run the FtpServer')
+
+        assert vfs_server is None or isinstance(vfs_server, LocalURLServer), \
+            "FtpServer currently assumes local transport, got %s" % vfs_server
+
+        self._root = os.getcwdu()
+        self._ftp_server = _ftp_server(
+            authorizer=_test_authorizer(root=self._root),
+            ip='localhost',
+            port=0, # bind to a random port
+            resolver=None,
+            logger_object=self # Use FtpServer.log() for messages
+            )
+        self._port = self._ftp_server.getsockname()[1]
+        # Don't let it loop forever, or handle an infinite number of requests.
+        # In this case it will run for 1000s, or 10000 requests
+        self._async_thread = threading.Thread(
+                target=FtpServer._asyncore_loop_ignore_EBADF,
+                kwargs={'timeout':0.1, 'count':10000})
+        self._async_thread.setDaemon(True)
+        self._async_thread.start()
+
+    def tearDown(self):
+        """See bzrlib.transport.Server.tearDown."""
+        self._ftp_server.close()
+        asyncore.close_all()
+        self._async_thread.join()
+
+    @staticmethod
+    def _asyncore_loop_ignore_EBADF(*args, **kwargs):
+        """Ignore EBADF during server shutdown.
+
+        We close the socket to get the server to shutdown, but this causes
+        select.select() to raise EBADF.
+        """
+        try:
+            asyncore.loop(*args, **kwargs)
+            # FIXME: If we reach that point, we should raise an exception
+            # explaining that the 'count' parameter in setUp is too low or
+            # testers may wonder why their test just sits there waiting for a
+            # server that is already dead. Note that if the tester waits too
+            # long under pdb the server will also die.
+        except select.error, e:
+            if e.args[0] != errno.EBADF:
+                raise
+
+
+_ftp_channel = None
+_ftp_server = None
+_test_authorizer = None
+
+
+def _setup_medusa():
+    global _have_medusa, _ftp_channel, _ftp_server, _test_authorizer
+    try:
+        import medusa
+        import medusa.filesys
+        import medusa.ftp_server
+    except ImportError:
+        return False
+
+    _have_medusa = True
+
+    class test_authorizer(object):
+        """A custom Authorizer object for running the test suite.
+
+        The reason we cannot use dummy_authorizer, is because it sets the
+        channel to readonly, which we don't always want to do.
+        """
+
+        def __init__(self, root):
+            self.root = root
+            # If secured_user is set secured_password will be checked
+            self.secured_user = None
+            self.secured_password = None
+
+        def authorize(self, channel, username, password):
+            """Return (success, reply_string, filesystem)"""
+            if not _have_medusa:
+                return 0, 'No Medusa.', None
+
+            channel.persona = -1, -1
+            if username == 'anonymous':
+                channel.read_only = 1
+            else:
+                channel.read_only = 0
+
+            # Check secured_user if set
+            if (self.secured_user is not None
+                and username == self.secured_user
+                and password != self.secured_password):
+                return 0, 'Password invalid.', None
+            else:
+                return 1, 'OK.', medusa.filesys.os_filesystem(self.root)
+
+
+    class ftp_channel(medusa.ftp_server.ftp_channel):
+        """Customized ftp channel"""
+
+        def log(self, message):
+            """Redirect logging requests."""
+            mutter('_ftp_channel: %s', message)
+
+        def log_info(self, message, type='info'):
+            """Redirect logging requests."""
+            mutter('_ftp_channel %s: %s', type, message)
+
+        def cmd_rnfr(self, line):
+            """Prepare for renaming a file."""
+            self._renaming = line[1]
+            self.respond('350 Ready for RNTO')
+            # TODO: jam 20060516 in testing, the ftp server seems to
+            #       check that the file already exists, or it sends
+            #       550 RNFR command failed
+
+        def cmd_rnto(self, line):
+            """Rename a file based on the target given.
+
+            rnto must be called after calling rnfr.
+            """
+            if not self._renaming:
+                self.respond('503 RNFR required first.')
+            pfrom = self.filesystem.translate(self._renaming)
+            self._renaming = None
+            pto = self.filesystem.translate(line[1])
+            if os.path.exists(pto):
+                self.respond('550 RNTO failed: file exists')
+                return
+            try:
+                os.rename(pfrom, pto)
+            except (IOError, OSError), e:
+                # TODO: jam 20060516 return custom responses based on
+                #       why the command failed
+                # (bialix 20070418) str(e) on Python 2.5 @ Windows
+                # sometimes don't provide expected error message;
+                # so we obtain such message via os.strerror()
+                self.respond('550 RNTO failed: %s' % os.strerror(e.errno))
+            except:
+                self.respond('550 RNTO failed')
+                # For a test server, we will go ahead and just die
+                raise
+            else:
+                self.respond('250 Rename successful.')
+
+        def cmd_size(self, line):
+            """Return the size of a file
+
+            This is overloaded to help the test suite determine if the 
+            target is a directory.
+            """
+            filename = line[1]
+            if not self.filesystem.isfile(filename):
+                if self.filesystem.isdir(filename):
+                    self.respond('550 "%s" is a directory' % (filename,))
+                else:
+                    self.respond('550 "%s" is not a file' % (filename,))
+            else:
+                self.respond('213 %d' 
+                    % (self.filesystem.stat(filename)[stat.ST_SIZE]),)
+
+        def cmd_mkd(self, line):
+            """Create a directory.
+
+            Overloaded because default implementation does not distinguish
+            *why* it cannot make a directory.
+            """
+            if len (line) != 2:
+                self.command_not_understood(''.join(line))
+            else:
+                path = line[1]
+                try:
+                    self.filesystem.mkdir (path)
+                    self.respond ('257 MKD command successful.')
+                except (IOError, OSError), e:
+                    # (bialix 20070418) str(e) on Python 2.5 @ Windows
+                    # sometimes don't provide expected error message;
+                    # so we obtain such message via os.strerror()
+                    self.respond ('550 error creating directory: %s' %
+                                  os.strerror(e.errno))
+                except:
+                    self.respond ('550 error creating directory.')
+
+
+    class ftp_server(medusa.ftp_server.ftp_server):
+        """Customize the behavior of the Medusa ftp_server.
+
+        There are a few warts on the ftp_server, based on how it expects
+        to be used.
+        """
+        _renaming = None
+        ftp_channel_class = ftp_channel
+
+        def __init__(self, *args, **kwargs):
+            mutter('Initializing _ftp_server: %r, %r', args, kwargs)
+            medusa.ftp_server.ftp_server.__init__(self, *args, **kwargs)
+
+        def log(self, message):
+            """Redirect logging requests."""
+            mutter('_ftp_server: %s', message)
+
+        def log_info(self, message, type='info'):
+            """Override the asyncore.log_info so we don't stipple the screen."""
+            mutter('_ftp_server %s: %s', type, message)
+
+    _test_authorizer = test_authorizer
+    _ftp_channel = ftp_channel
+    _ftp_server = ftp_server
+
+    return True
+
+
 def get_test_permutations():
     """Return the permutations to be used in testing."""
-    from bzrlib import tests
-    if tests.FTPServerFeature.available():
-        from bzrlib.tests import ftp_server
-        return [(FtpTransport, ftp_server.FTPServer)]
+    if not _setup_medusa():
+        warn("You must install medusa (http://www.amk.ca/python/code/medusa.html) for FTP tests")
+        return []
     else:
-        # Dummy server to have the test suite report the number of tests
-        # needing that feature. We raise UnavailableFeature from methods before
-        # the test server is being used. Doing so in the setUp method has bad
-        # side-effects (tearDown is never called).
-        class UnavailableFTPServer(object):
-
-            def setUp(self):
-                pass
-
-            def tearDown(self):
-                pass
-
-            def get_url(self):
-                raise tests.UnavailableFeature(tests.FTPServerFeature)
-
-            def get_bogus_url(self):
-                raise tests.UnavailableFeature(tests.FTPServerFeature)
-
-        return [(FtpTransport, UnavailableFTPServer)]
+        return [(FtpTransport, FtpServer)]

=== removed file 'bzrlib/transport/ftp/_gssapi.py'
--- bzrlib/transport/ftp/_gssapi.py	2008-08-28 16:44:20 +0000
+++ bzrlib/transport/ftp/_gssapi.py	1970-01-01 00:00:00 +0000
@@ -1,159 +0,0 @@
-# Copyright (C) 2005, 2006, 2007, 2008 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Support for secure authentication using GSSAPI over FTP.
-
-See RFC2228 for details.
-"""
-
-import base64, ftplib, getpass, socket
-
-from bzrlib import (
-    config, 
-    errors,
-    )
-from bzrlib.trace import info, mutter
-from bzrlib.transport.ftp import FtpTransport
-from bzrlib.transport import register_transport_proto, register_transport
-
-try:
-    import kerberos
-except ImportError, e:
-    mutter('failed to import kerberos lib: %s', e)
-    raise errors.DependencyNotPresent('kerberos', e)
-
-if getattr(kerberos, "authGSSClientWrap", None) is None:
-    raise errors.DependencyNotPresent('kerberos', 
-        "missing encryption function authGSSClientWrap")
-
-
-class GSSAPIFtp(ftplib.FTP):
-    """Extended version of ftplib.FTP that can authenticate using GSSAPI."""
-
-    def mic_putcmd(self, line):
-        rc = kerberos.authGSSClientWrap(self.vc, 
-            base64.b64encode(line), kerberos.authGSSClientUserName(self.vc))
-        wrapped = kerberos.authGSSClientResponse(self.vc)
-        ftplib.FTP.putcmd(self, "MIC " + wrapped)
-
-    def mic_getline(self):
-        resp = ftplib.FTP.getline(self)
-        if resp[:4] != '631 ':
-            raise AssertionError
-        rc = kerberos.authGSSClientUnwrap(self.vc, resp[4:].strip("\r\n"))
-        response = base64.b64decode(kerberos.authGSSClientResponse(self.vc))
-        return response
-
-    def gssapi_login(self, user):
-        # Try GSSAPI login first
-
-        # Used FTP response codes:
-        # 235 [ADAT=base64data] - indicates that the security data exchange 
-        #     completed successfully.
-        # 334 [ADAT=base64data] - indicates that the requested security 
-        #     mechanism is ok, and includes security data to be used by the 
-        #     client to construct the next command.
-        # 335 [ADAT=base64data] - indicates that the security data is
-        #     acceptable, and more is required to complete the security 
-        #     data exchange.
-
-        resp = self.sendcmd('AUTH GSSAPI')
-        if resp.startswith('334 '):
-            rc, self.vc = kerberos.authGSSClientInit("ftp@%s" % self.host)
-            if kerberos.authGSSClientStep(self.vc, "") != 1:
-                while resp[:4] in ('334 ', '335 '):
-                    authdata = kerberos.authGSSClientResponse(self.vc)
-                    resp = self.sendcmd('ADAT ' + authdata)
-                    if resp[:9] in ('235 ADAT=', '335 ADAT='):
-                        rc = kerberos.authGSSClientStep(self.vc, resp[9:])
-                        if not ((resp.startswith('235 ') and rc == 1) or 
-                                (resp.startswith('335 ') and rc == 0)):
-                            raise ftplib.error_reply, resp
-            info("Authenticated as %s" % kerberos.authGSSClientUserName(
-                    self.vc))
-
-            # Monkey patch ftplib
-            self.putcmd = self.mic_putcmd
-            self.getline = self.mic_getline
-            self.sendcmd('USER ' + user)
-            return resp
-        mutter("Unable to use GSSAPI authentication: %s", resp)
-
-
-class GSSAPIFtpTransport(FtpTransport):
-    """FTP transport implementation that will try to use GSSAPI authentication.
-
-    """
-
-    def _create_connection(self, credentials=None):
-        """Create a new connection with the provided credentials.
-
-        :param credentials: The credentials needed to establish the connection.
-
-        :return: The created connection and its associated credentials.
-
-        The credentials are a tuple with the username and password. The 
-        password is used if GSSAPI Authentication is not available.
-
-        The username and password can both be None, in which case the 
-        credentials specified in the URL or provided by the 
-        AuthenticationConfig() are used.
-        """
-        if credentials is None:
-            user, password = self._user, self._password
-        else:
-            user, password = credentials
-
-        auth = config.AuthenticationConfig()
-        if user is None:
-            user = auth.get_user('ftp', self._host, port=self._port)
-            if user is None:
-                # Default to local user
-                user = getpass.getuser()
-
-        mutter("Constructing FTP instance against %r" %
-               ((self._host, self._port, user, '********',
-                self.is_active),))
-        try:
-            connection = GSSAPIFtp()
-            connection.connect(host=self._host, port=self._port)
-            try:
-                connection.gssapi_login(user=user)
-            except ftplib.error_perm, e:
-                if user and user != 'anonymous' and \
-                        password is None: # '' is a valid password
-                    password = auth.get_password('ftp', self._host, user,
-                                                 port=self._port)
-                connection.login(user=user, passwd=password)
-            connection.set_pasv(not self.is_active)
-        except socket.error, e:
-            raise errors.SocketConnectionError(self._host, self._port,
-                                               msg='Unable to connect to',
-                                               orig_error= e)
-        except ftplib.error_perm, e:
-            raise errors.TransportError(msg="Error setting up connection:"
-                                        " %s" % str(e), orig_error=e)
-        return connection, (user, password)
-
-
-def get_test_permutations():
-    """Return the permutations to be used in testing."""
-    from bzrlib import tests
-    if tests.FTPServerFeature.available():
-        from bzrlib.tests import ftp_server
-        return [(GSSAPIFtpTransport, ftp_server.FTPServer)]
-    else:
-        return []

=== modified file 'bzrlib/transport/http/__init__.py'
--- bzrlib/transport/http/__init__.py	2008-09-02 04:34:23 +0000
+++ bzrlib/transport/http/__init__.py	2007-08-26 22:10:51 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007 Canonical Ltd
+# Copyright (C) 2005, 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -27,7 +27,6 @@
 import sys
 
 from bzrlib import (
-    debug,
     errors,
     ui,
     urlutils,
@@ -35,6 +34,7 @@
 from bzrlib.smart import medium
 from bzrlib.symbol_versioning import (
         deprecated_method,
+        zero_seventeen,
         )
 from bzrlib.trace import mutter
 from bzrlib.transport import (
@@ -52,9 +52,8 @@
     password manager.  Return the url, minus those auth parameters (which
     confuse urllib2).
     """
-    if not re.match(r'^(https?)(\+\w+)?://', url):
-        raise ValueError(
-            'invalid absolute url %r' % (url,))
+    assert re.match(r'^(https?)(\+\w+)?://', url), \
+            'invalid absolute url %r' % url
     scheme, netloc, path, query, fragment = urlparse.urlsplit(url)
 
     if '@' in netloc:
@@ -79,6 +78,49 @@
     return url
 
 
+def _extract_headers(header_text, url):
+    """Extract the mapping for an rfc2822 header
+
+    This is a helper function for the test suite and for _pycurl.
+    (urllib already parses the headers for us)
+
+    In the case that there are multiple headers inside the file,
+    the last one is returned.
+
+    :param header_text: A string of header information.
+        This expects that the first line of a header will always be HTTP ...
+    :param url: The url we are parsing, so we can raise nice errors
+    :return: mimetools.Message object, which basically acts like a case 
+        insensitive dictionary.
+    """
+    first_header = True
+    remaining = header_text
+
+    if not remaining:
+        raise errors.InvalidHttpResponse(url, 'Empty headers')
+
+    while remaining:
+        header_file = StringIO(remaining)
+        first_line = header_file.readline()
+        if not first_line.startswith('HTTP'):
+            if first_header: # The first header *must* start with HTTP
+                raise errors.InvalidHttpResponse(url,
+                    'Opening header line did not start with HTTP: %s'
+                    % (first_line,))
+            else:
+                break # We are done parsing
+        first_header = False
+        m = mimetools.Message(header_file)
+
+        # mimetools.Message parses the first header up to a blank line
+        # So while there is remaining data, it probably means there is
+        # another header to be parsed.
+        # Get rid of any preceeding whitespace, which if it is all whitespace
+        # will get rid of everything.
+        remaining = header_file.read().lstrip()
+    return m
+
+
 class HttpTransportBase(ConnectedTransport, medium.SmartClientMedium):
     """Base class for http implementations.
 
@@ -115,6 +157,15 @@
         else:
             self._range_hint = 'multi'
 
+    def _remote_path(self, relpath):
+        """Produce absolute path, adjusting protocol."""
+        relative = urlutils.unescape(relpath).encode('utf-8')
+        path = self._combine_paths(self._path, relative)
+        return self._unsplit_url(self._unqualified_scheme,
+                                 self._user, self._password,
+                                 self._host, self._port,
+                                 path)
+
     def has(self, relpath):
         raise NotImplementedError("has() is abstract on %r" % self)
 
@@ -124,12 +175,7 @@
         :param relpath: The relative path to the file
         """
         code, response_file = self._get(relpath, None)
-        # FIXME: some callers want an iterable... One step forward, three steps
-        # backwards :-/ And not only an iterable, but an iterable that can be
-        # seeked backwards, so we will never be able to do that.  One such
-        # known client is bzrlib.bundle.serializer.v4.get_bundle_reader. At the
-        # time of this writing it's even the only known client -- vila20071203
-        return StringIO(response_file.read())
+        return response_file
 
     def _get(self, relpath, ranges, tail_amount=0):
         """Get a file, or part of a file.
@@ -143,24 +189,6 @@
         """
         raise NotImplementedError(self._get)
 
-    def _remote_path(self, relpath):
-        """See ConnectedTransport._remote_path.
-
-        user and passwords are not embedded in the path provided to the server.
-        """
-        relative = urlutils.unescape(relpath).encode('utf-8')
-        path = self._combine_paths(self._path, relative)
-        return self._unsplit_url(self._unqualified_scheme,
-                                 None, None, self._host, self._port, path)
-
-    def _create_auth(self):
-        """Returns a dict returning the credentials provided at build time."""
-        auth = dict(host=self._host, port=self._port,
-                    user=self._user, password=self._password,
-                    protocol=self._unqualified_scheme,
-                    path=self._path)
-        return auth
-
     def get_request(self):
         return SmartClientHTTPMediumRequest(self)
 
@@ -180,11 +208,35 @@
             self._range_hint = None
             mutter('Retry "%s" without ranges' % relpath)
         else:
-            # We tried all the tricks, but nothing worked. We re-raise the
-            # original exception; the 'mutter' calls above will indicate that
-            # further tries were unsuccessful
+            # We tried all the tricks, but nothing worked. We re-raise original
+            # exception; the 'mutter' calls above will indicate that further
+            # tries were unsuccessful
             raise exc_info[0], exc_info[1], exc_info[2]
 
+    def _get_ranges_hinted(self, relpath, ranges):
+        """Issue a ranged GET request taking server capabilities into account.
+
+        Depending of the errors returned by the server, we try several GET
+        requests, trying to minimize the data transferred.
+
+        :param relpath: Path relative to transport base URL
+        :param ranges: None to get the whole file;
+            or  a list of _CoalescedOffset to fetch parts of a file.
+        :returns: A file handle containing at least the requested ranges.
+        """
+        exc_info = None
+        try_again = True
+        while try_again:
+            try_again = False
+            try:
+                code, f = self._get(relpath, ranges)
+            except errors.InvalidRange, e:
+                if exc_info is None:
+                    exc_info = sys.exc_info()
+                self._degrade_range_hint(relpath, ranges, exc_info)
+                try_again = True
+        return f
+
     # _coalesce_offsets is a helper for readv, it try to combine ranges without
     # degrading readv performances. _bytes_to_read_before_seek is the value
     # used for the limit parameter and has been tuned for other transports. For
@@ -198,13 +250,7 @@
     _bytes_to_read_before_seek = 128
     # No limit on the offset number that get combined into one, we are trying
     # to avoid downloading the whole file.
-    _max_readv_combine = 0
-    # By default Apache has a limit of ~400 ranges before replying with a 400
-    # Bad Request. So we go underneath that amount to be safe.
-    _max_get_ranges = 200
-    # We impose no limit on the range size. But see _pycurl.py for a different
-    # use.
-    _get_max_size = 0
+    _max_readv_combined = 0
 
     def _readv(self, relpath, offsets):
         """Get parts of the file at the given relative path.
@@ -212,132 +258,41 @@
         :param offsets: A list of (offset, size) tuples.
         :param return: A list or generator of (offset, data) tuples
         """
-
-        # offsets may be a generator, we will iterate it several times, so
-        # build a list
-        offsets = list(offsets)
-
-        try_again = True
-        retried_offset = None
-        while try_again:
-            try_again = False
-
-            # Coalesce the offsets to minimize the GET requests issued
-            sorted_offsets = sorted(offsets)
-            coalesced = self._coalesce_offsets(
-                sorted_offsets, limit=self._max_readv_combine,
-                fudge_factor=self._bytes_to_read_before_seek,
-                max_size=self._get_max_size)
-
-            # Turn it into a list, we will iterate it several times
-            coalesced = list(coalesced)
-            if 'http' in debug.debug_flags:
-                mutter('http readv of %s  offsets => %s collapsed %s',
-                    relpath, len(offsets), len(coalesced))
-
-            # Cache the data read, but only until it's been used
-            data_map = {}
-            # We will iterate on the data received from the GET requests and
-            # serve the corresponding offsets respecting the initial order. We
-            # need an offset iterator for that.
-            iter_offsets = iter(offsets)
-            cur_offset_and_size = iter_offsets.next()
-
-            try:
-                for cur_coal, rfile in self._coalesce_readv(relpath, coalesced):
-                    # Split the received chunk
-                    for offset, size in cur_coal.ranges:
-                        start = cur_coal.start + offset
-                        rfile.seek(start, 0)
-                        data = rfile.read(size)
-                        data_len = len(data)
-                        if data_len != size:
-                            raise errors.ShortReadvError(relpath, start, size,
-                                                         actual=data_len)
-                        if (start, size) == cur_offset_and_size:
-                            # The offset requested are sorted as the coalesced
-                            # ones, no need to cache. Win !
-                            yield cur_offset_and_size[0], data
-                            cur_offset_and_size = iter_offsets.next()
-                        else:
-                            # Different sorting. We need to cache.
-                            data_map[(start, size)] = data
-
-                    # Yield everything we can
-                    while cur_offset_and_size in data_map:
-                        # Clean the cached data since we use it
-                        # XXX: will break if offsets contains duplicates --
-                        # vila20071129
-                        this_data = data_map.pop(cur_offset_and_size)
-                        yield cur_offset_and_size[0], this_data
-                        cur_offset_and_size = iter_offsets.next()
-
-            except (errors.ShortReadvError, errors.InvalidRange,
-                    errors.InvalidHttpRange), e:
-                mutter('Exception %r: %s during http._readv',e, e)
-                if (not isinstance(e, errors.ShortReadvError)
-                    or retried_offset == cur_offset_and_size):
-                    # We don't degrade the range hint for ShortReadvError since
-                    # they do not indicate a problem with the server ability to
-                    # handle ranges. Except when we fail to get back a required
-                    # offset twice in a row. In that case, falling back to
-                    # single range or whole file should help or end up in a
-                    # fatal exception.
+        sorted_offsets = sorted(list(offsets))
+        fudge = self._bytes_to_read_before_seek
+        coalesced = self._coalesce_offsets(sorted_offsets,
+                                           limit=self._max_readv_combine,
+                                           fudge_factor=fudge)
+        coalesced = list(coalesced)
+        mutter('http readv of %s  offsets => %s collapsed %s',
+                relpath, len(offsets), len(coalesced))
+
+        f = self._get_ranges_hinted(relpath, coalesced)
+        for start, size in offsets:
+            try_again = True
+            while try_again:
+                try_again = False
+                f.seek(start, ((start < 0) and 2) or 0)
+                start = f.tell()
+                try:
+                    data = f.read(size)
+                    if len(data) != size:
+                        raise errors.ShortReadvError(relpath, start, size,
+                                                     actual=len(data))
+                except errors.ShortReadvError, e:
                     self._degrade_range_hint(relpath, coalesced, sys.exc_info())
-                # Some offsets may have been already processed, so we retry
-                # only the unsuccessful ones.
-                offsets = [cur_offset_and_size] + [o for o in iter_offsets]
-                retried_offset = cur_offset_and_size
-                try_again = True
-
-    def _coalesce_readv(self, relpath, coalesced):
-        """Issue several GET requests to satisfy the coalesced offsets"""
-
-        def get_and_yield(relpath, coalesced):
-            if coalesced:
-                # Note that the _get below may raise
-                # errors.InvalidHttpRange. It's the caller's responsibility to
-                # decide how to retry since it may provide different coalesced
-                # offsets.
-                code, rfile = self._get(relpath, coalesced)
-                for coal in coalesced:
-                    yield coal, rfile
-
-        if self._range_hint is None:
-            # Download whole file
-            for c, rfile in get_and_yield(relpath, coalesced):
-                yield c, rfile
-        else:
-            total = len(coalesced)
-            if self._range_hint == 'multi':
-                max_ranges = self._max_get_ranges
-            elif self._range_hint == 'single':
-                max_ranges = total
-            else:
-                raise AssertionError("Unknown _range_hint %r"
-                                     % (self._range_hint,))
-            # TODO: Some web servers may ignore the range requests and return
-            # the whole file, we may want to detect that and avoid further
-            # requests.
-            # Hint: test_readv_multiple_get_requests will fail once we do that
-            cumul = 0
-            ranges = []
-            for coal in coalesced:
-                if ((self._get_max_size > 0
-                     and cumul + coal.length > self._get_max_size)
-                    or len(ranges) >= max_ranges):
-                    # Get that much and yield
-                    for c, rfile in get_and_yield(relpath, ranges):
-                        yield c, rfile
-                    # Restart with the current offset
-                    ranges = [coal]
-                    cumul = coal.length
-                else:
-                    ranges.append(coal)
-                    cumul += coal.length
-            # Get the rest and yield
-            for c, rfile in get_and_yield(relpath, ranges):
-                yield c, rfile
+
+                    # Since the offsets and the ranges may not be in the same
+                    # order, we don't try to calculate a restricted single
+                    # range encompassing unprocessed offsets.
+
+                    # Note: we replace 'f' here, it may need cleaning one day
+                    # before being thrown that way.
+                    f = self._get_ranges_hinted(relpath, coalesced)
+                    try_again = True
+
+            # After one or more tries, we get the data.
+            yield start, data
 
     def recommended_page_size(self):
         """See Transport.recommended_page_size().
@@ -347,6 +302,34 @@
         """
         return 64 * 1024
 
+    @staticmethod
+    @deprecated_method(zero_seventeen)
+    def offsets_to_ranges(offsets):
+        """Turn a list of offsets and sizes into a list of byte ranges.
+
+        :param offsets: A list of tuples of (start, size).  An empty list
+            is not accepted.
+        :return: a list of inclusive byte ranges (start, end) 
+            Adjacent ranges will be combined.
+        """
+        # Make sure we process sorted offsets
+        offsets = sorted(offsets)
+
+        prev_end = None
+        combined = []
+
+        for start, size in offsets:
+            end = start + size - 1
+            if prev_end is None:
+                combined.append([start, end])
+            elif start <= prev_end + 1:
+                combined[-1][1] = end
+            else:
+                combined.append([start, end])
+            prev_end = end
+
+        return combined
+
     def _post(self, body_bytes):
         """POST body_bytes to .bzr/smart on this transport.
         
@@ -461,14 +444,10 @@
             return self.__class__(self.abspath(offset), self)
 
     def _attempted_range_header(self, offsets, tail_amount):
-        """Prepare a HTTP Range header at a level the server should accept.
-
-        :return: the range header representing offsets/tail_amount or None if
-            no header can be built.
-        """
+        """Prepare a HTTP Range header at a level the server should accept"""
 
         if self._range_hint == 'multi':
-            # Generate the header describing all offsets
+            # Nothing to do here
             return self._range_header(offsets, tail_amount)
         elif self._range_hint == 'single':
             # Combine all the requested ranges into a single
@@ -516,28 +495,10 @@
         return ','.join(strings)
 
     def send_http_smart_request(self, bytes):
-        try:
-            code, body_filelike = self._post(bytes)
-            if code != 200:
-                raise InvalidHttpResponse(
-                    self._remote_path('.bzr/smart'),
-                    'Expected 200 response code, got %r' % (code,))
-        except errors.InvalidHttpResponse, e:
-            raise errors.SmartProtocolError(str(e))
+        code, body_filelike = self._post(bytes)
+        assert code == 200, 'unexpected HTTP response code %r' % (code,)
         return body_filelike
 
-    def should_probe(self):
-        return True
-
-    def remote_path_from_transport(self, transport):
-        # Strip the optional 'bzr+' prefix from transport so it will have the
-        # same scheme as self.
-        transport_base = transport.base
-        if transport_base.startswith('bzr+'):
-            transport_base = transport_base[4:]
-        rel_url = urlutils.relative_url(self.base, transport_base)
-        return urllib.unquote(rel_url)
-
 
 class SmartClientHTTPMediumRequest(medium.SmartClientMediumRequest):
     """A SmartClientMediumRequest that works with an HTTP medium."""
@@ -554,17 +515,8 @@
         self._response_body = data
 
     def _read_bytes(self, count):
-        """See SmartClientMediumRequest._read_bytes."""
         return self._response_body.read(count)
 
-    def _read_line(self):
-        line, excess = medium._get_line(self._response_body.read)
-        if excess != '':
-            raise AssertionError(
-                '_get_line returned excess bytes, but this mediumrequest '
-                'cannot handle excess. (%r)' % (excess,))
-        return line
-
     def _finished_reading(self):
         """See SmartClientMediumRequest._finished_reading."""
         pass

=== modified file 'bzrlib/transport/http/_pycurl.py'
--- bzrlib/transport/http/_pycurl.py	2008-08-29 07:40:35 +0000
+++ bzrlib/transport/http/_pycurl.py	2007-10-01 08:42:16 +0000
@@ -33,19 +33,21 @@
 
 import os
 from cStringIO import StringIO
-import httplib
 import sys
 
 from bzrlib import (
-    debug,
     errors,
-    trace,
     __version__ as bzrlib_version,
     )
 import bzrlib
+from bzrlib.errors import (NoSuchFile,
+                           ConnectionError,
+                           DependencyNotPresent)
 from bzrlib.trace import mutter
+from bzrlib.transport import register_urlparse_netloc_protocol
 from bzrlib.transport.http import (
     ca_bundle,
+    _extract_headers,
     HttpTransportBase,
     response,
     )
@@ -54,7 +56,7 @@
     import pycurl
 except ImportError, e:
     mutter("failed to import pycurl: %s", e)
-    raise errors.DependencyNotPresent('pycurl', e)
+    raise DependencyNotPresent('pycurl', e)
 
 try:
     # see if we can actually initialize PyCurl - sometimes it will load but
@@ -69,7 +71,7 @@
     pycurl.Curl()
 except pycurl.error, e:
     mutter("failed to initialize pycurl: %s", e)
-    raise errors.DependencyNotPresent('pycurl', e)
+    raise DependencyNotPresent('pycurl', e)
 
 
 
@@ -92,7 +94,9 @@
 CURLE_COULDNT_RESOLVE_PROXY = _get_pycurl_errcode('E_COULDNT_RESOLVE_PROXY', 5)
 CURLE_GOT_NOTHING = _get_pycurl_errcode('E_GOT_NOTHING', 52)
 CURLE_PARTIAL_FILE = _get_pycurl_errcode('E_PARTIAL_FILE', 18)
-CURLE_SEND_ERROR = _get_pycurl_errcode('E_SEND_ERROR', 55)
+
+
+register_urlparse_netloc_protocol('http+pycurl')
 
 
 class PyCurlTransport(HttpTransportBase):
@@ -112,7 +116,7 @@
             # protocols
             supported = pycurl.version_info()[8]
             if 'https' not in supported:
-                raise errors.DependencyNotPresent('pycurl', 'no https support')
+                raise DependencyNotPresent('pycurl', 'no https support')
         self.cabundle = ca_bundle.get_ca_path()
 
     def _get_curl(self):
@@ -124,10 +128,7 @@
             # connect to the http server until the first request (which had
             # just called us).
             connection = pycurl.Curl()
-            # First request, initialize credentials.
-            auth = self._create_auth()
-            # Proxy handling is out of reach, so we punt
-            self._set_connection(connection, auth)
+            self._set_connection(connection, None)
         return connection
 
     def has(self, relpath):
@@ -205,21 +206,13 @@
         data.seek(0)
 
         if code == 404:
-            raise errors.NoSuchFile(abspath)
+            raise NoSuchFile(abspath)
         if code != 200:
             self._raise_curl_http_error(
                 curl, 'expected 200 or 404 for full response.')
 
         return code, data
 
-    # The parent class use 0 to minimize the requests, but since we can't
-    # exploit the results as soon as they are received (pycurl limitation) we'd
-    # better issue more requests and provide a more responsive UI do the cost
-    # of more latency costs.
-    # If you modify this, think about modifying the comment in http/__init__.py
-    # too.
-    _get_max_size = 4 * 1024 * 1024
-
     def _get_ranged(self, relpath, offsets, tail_amount):
         """Make a request for just part of the file."""
         curl = self._get_curl()
@@ -234,57 +227,28 @@
         data.seek(0)
 
         code = curl.getinfo(pycurl.HTTP_CODE)
-
-        if code == 404: # not found
-            raise errors.NoSuchFile(abspath)
-        elif code in (400, 416):
-            # We don't know which, but one of the ranges we specified was
-            # wrong.
-            raise errors.InvalidHttpRange(abspath, range_header,
-                                          'Server return code %d'
-                                          % curl.getinfo(pycurl.HTTP_CODE))
-        msg = self._parse_headers(header)
-        return code, response.handle_response(abspath, code, msg, data)
-
-    def _parse_headers(self, status_and_headers):
-        """Transform the headers provided by curl into an HTTPMessage"""
-        status_and_headers.seek(0)
-        # Ignore status line
-        status_and_headers.readline()
-        msg = httplib.HTTPMessage(status_and_headers)
-        return msg
+        # mutter('header:\n%r', header.getvalue())
+        headers = _extract_headers(header.getvalue(), abspath)
+        # handle_response will raise NoSuchFile, etc based on the response code
+        return code, response.handle_response(abspath, code, headers, data)
 
     def _post(self, body_bytes):
+        fake_file = StringIO(body_bytes)
         curl = self._get_curl()
-        abspath, data, header = self._setup_request(curl, '.bzr/smart')
+        # Other places that use the Curl object (returned by _get_curl)
+        # for GET requests explicitly set HTTPGET, so it should be safe to
+        # re-use the same object for both GETs and POSTs.
         curl.setopt(pycurl.POST, 1)
-        fake_file = StringIO(body_bytes)
         curl.setopt(pycurl.POSTFIELDSIZE, len(body_bytes))
         curl.setopt(pycurl.READFUNCTION, fake_file.read)
+        abspath, data, header = self._setup_request(curl, '.bzr/smart')
         # We override the Expect: header so that pycurl will send the POST
         # body immediately.
-        try:
-            self._curl_perform(curl, header, ['Expect: '])
-        except pycurl.error, e:
-            if e[0] == CURLE_SEND_ERROR:
-                # When talking to an HTTP/1.0 server, getting a 400+ error code
-                # triggers a bug in some combinations of curl/kernel in rare
-                # occurrences. Basically, the server closes the connection
-                # after sending the error but the client (having received and
-                # parsed the response) still try to send the request body (see
-                # bug #225020 and its upstream associated bug).  Since the
-                # error code and the headers are known to be available, we just
-                # swallow the exception, leaving the upper levels handle the
-                # 400+ error.
-                mutter('got pycurl error in POST: %s, %s, %s, url: %s ',
-                       e[0], e[1], e, abspath)
-            else:
-                # Re-raise otherwise
-                raise
+        self._curl_perform(curl, header, ['Expect: '])
         data.seek(0)
         code = curl.getinfo(pycurl.HTTP_CODE)
-        msg = self._parse_headers(header)
-        return code, response.handle_response(abspath, code, msg, data)
+        headers = _extract_headers(header.getvalue(), abspath)
+        return code, response.handle_response(abspath, code, headers, data)
 
     def _raise_curl_http_error(self, curl, info=None):
         code = curl.getinfo(pycurl.HTTP_CODE)
@@ -293,8 +257,7 @@
         # requests
         if code == 403:
             raise errors.TransportError(
-                'Server refuses to fulfill the request (403 Forbidden)'
-                ' for %s' % url)
+                'Server refuses to fullfil the request for: %s' % url)
         else:
             if info is None:
                 msg = ''
@@ -305,27 +268,12 @@
 
     def _set_curl_options(self, curl):
         """Set options for all requests"""
-        if 'http' in debug.debug_flags:
-            curl.setopt(pycurl.VERBOSE, 1)
-            # pycurl doesn't implement the CURLOPT_STDERR option, so we can't
-            # do : curl.setopt(pycurl.STDERR, trace._trace_file)
-
-        ua_str = 'bzr/%s (pycurl: %s)' % (bzrlib.__version__, pycurl.version)
+        ## curl.setopt(pycurl.VERBOSE, 1)
+        # TODO: maybe include a summary of the pycurl version
+        ua_str = 'bzr/%s (pycurl)' % (bzrlib.__version__,)
         curl.setopt(pycurl.USERAGENT, ua_str)
         if self.cabundle:
             curl.setopt(pycurl.CAINFO, self.cabundle)
-        # Set accepted auth methods
-        curl.setopt(pycurl.HTTPAUTH, pycurl.HTTPAUTH_ANY)
-        curl.setopt(pycurl.PROXYAUTH, pycurl.HTTPAUTH_ANY)
-        auth = self._get_credentials()
-        user = auth.get('user', None)
-        password = auth.get('password', None)
-        userpass = None
-        if user is not None:
-            userpass = user + ':'
-            if password is not None: # '' is a valid password
-                userpass += password
-            curl.setopt(pycurl.USERPWD, userpass)
 
     def _curl_perform(self, curl, header, more_headers=[]):
         """Perform curl operation and translate exceptions."""
@@ -348,30 +296,32 @@
                         CURLE_COULDNT_CONNECT,
                         CURLE_GOT_NOTHING,
                         CURLE_COULDNT_RESOLVE_PROXY,):
-                raise errors.ConnectionError(
-                    'curl connection error (%s)\non %s' % (e[1], url))
+                raise ConnectionError('curl connection error (%s)\non %s'
+                              % (e[1], url))
             elif e[0] == CURLE_PARTIAL_FILE:
-                # Pycurl itself has detected a short read.  We do not have all
-                # the information for the ShortReadvError, but that should be
-                # enough
+                # Pycurl itself has detected a short read.  We do
+                # not have all the information for the
+                # ShortReadvError, but that should be enough
                 raise errors.ShortReadvError(url,
                                              offset='unknown', length='unknown',
                                              actual='unknown',
                                              extra='Server aborted the request')
+            # jam 20060713 The code didn't use to re-raise the exception here,
+            # but that seemed bogus
             raise
         code = curl.getinfo(pycurl.HTTP_CODE)
         if code in (301, 302, 303, 307):
             url = curl.getinfo(pycurl.EFFECTIVE_URL)
-            msg = self._parse_headers(header)
-            redirected_to = msg.getheader('location')
+            headers = _extract_headers(header.getvalue(), url)
+            redirected_to = headers['Location']
             raise errors.RedirectRequested(url,
                                            redirected_to,
-                                           is_permanent=(code == 301),
+                                           is_permament=(code == 301),
                                            qual_proto=self._scheme)
 
 
 def get_test_permutations():
     """Return the permutations to be used in testing."""
-    from bzrlib.tests.http_server import HttpServer_PyCurl
+    from bzrlib.tests.HttpServer import HttpServer_PyCurl
     return [(PyCurlTransport, HttpServer_PyCurl),
             ]

=== modified file 'bzrlib/transport/http/_urllib.py'
--- bzrlib/transport/http/_urllib.py	2008-05-29 06:43:43 +0000
+++ bzrlib/transport/http/_urllib.py	2007-11-04 15:24:27 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007 Canonical Ltd
+# Copyright (C) 2005, 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -20,11 +20,12 @@
 
 from bzrlib import (
     errors,
-    trace,
     urlutils,
     )
-from bzrlib.transport import http
-# TODO: handle_response should be integrated into the http/__init__.py
+from bzrlib.trace import mutter
+from bzrlib.transport import register_urlparse_netloc_protocol
+from bzrlib.transport.http import HttpTransportBase
+# TODO: handle_response should be integrated into the _urllib2_wrappers
 from bzrlib.transport.http.response import handle_response
 from bzrlib.transport.http._urllib2_wrappers import (
     Opener,
@@ -32,7 +33,10 @@
     )
 
 
-class HttpTransport_urllib(http.HttpTransportBase):
+register_urlparse_netloc_protocol('http+urllib')
+
+
+class HttpTransport_urllib(HttpTransportBase):
     """Python urllib transport for http and https."""
 
     # In order to debug we have to issue our traces in sync with
@@ -49,6 +53,17 @@
         else:
             self._opener = self._opener_class()
 
+    def _remote_path(self, relpath):
+        """Produce absolute path, adjusting protocol."""
+        relative = urlutils.unescape(relpath).encode('utf-8')
+        path = self._combine_paths(self._path, relative)
+        # urllib2 will be confused if it find authentication
+        # info (user, password) in the urls. So we handle them separatly.
+
+        # rhaaaa ! confused where ? confused when ? --vila 20070922
+        return self._unsplit_url(self._unqualified_scheme,
+                                 None, None, self._host, self._port, path)
+
     def _perform(self, request):
         """Send the request to the server and handles common errors.
 
@@ -59,19 +74,27 @@
             # Give back shared info
             request.connection = connection
             (auth, proxy_auth) = self._get_credentials()
-            # Clean the httplib.HTTPConnection pipeline in case the previous
-            # request couldn't do it
-            connection.cleanup_pipe()
         else:
-            # First request, initialize credentials.
+            # First request, intialize credentials.
             # scheme and realm will be set by the _urllib2_wrappers.AuthHandler
-            auth = self._create_auth()
-            # Proxy initialization will be done by the first proxied request
+            user = self._user
+            password = self._password
+            auth = dict(host=self._host, port=self._port,
+                        user=user, password=password,
+                        protocol=self._unqualified_scheme,
+                        path=self._path)
+            auth = {'host': self._host, 'port': self._port,
+                    'user': user, 'password': password,
+                    'protocol': self._unqualified_scheme,
+                    'path': self._path}
+            # Proxy initialization will be done by first proxied request
             proxy_auth = dict()
+            proxy_auth = {}
         # Ensure authentication info is provided
         request.auth = auth
         request.proxy_auth = proxy_auth
 
+        mutter('%s: [%s]' % (request.method, request.get_full_url()))
         if self._debuglevel > 0:
             print 'perform: %s base: %s, url: %s' % (request.method, self.base,
                                                      request.get_full_url())
@@ -90,12 +113,12 @@
                 and code in (301, 302, 303, 307):
             raise errors.RedirectRequested(request.get_full_url(),
                                            request.redirected_to,
-                                           is_permanent=(code == 301),
+                                           is_permament=(code == 301),
                                            qual_proto=self._scheme)
 
         if request.redirected_to is not None:
-            trace.mutter('redirected from: %s to: %s' % (request.get_full_url(),
-                                                         request.redirected_to))
+            mutter('redirected from: %s to: %s' % (request.get_full_url(),
+                                                   request.redirected_to))
 
         return response
 
@@ -110,7 +133,6 @@
             if range_header is not None:
                 accepted_errors.append(206)
                 accepted_errors.append(400)
-                accepted_errors.append(416)
                 bytes = 'bytes=' + range_header
                 headers = {'Range': bytes}
 
@@ -120,24 +142,21 @@
 
         code = response.code
         if code == 404: # not found
+            self._get_connection().fake_close()
             raise errors.NoSuchFile(abspath)
-        elif code in (400, 416):
-            # We don't know which, but one of the ranges we specified was
-            # wrong.
-            raise errors.InvalidHttpRange(abspath, range_header,
-                                          'Server return code %d' % code)
 
-        data = handle_response(abspath, code, response.info(), response)
+        data = handle_response(abspath, code, response.headers, response)
+        # Close response to free the httplib.HTTPConnection pipeline
+        self._get_connection().fake_close()
         return code, data
 
     def _post(self, body_bytes):
         abspath = self._remote_path('.bzr/smart')
-        # We include 403 in accepted_errors so that send_http_smart_request can
-        # handle a 403.  Otherwise a 403 causes an unhandled TransportError.
-        response = self._perform(Request('POST', abspath, body_bytes,
-                                         accepted_errors=[200, 403]))
+        response = self._perform(Request('POST', abspath, body_bytes))
         code = response.code
-        data = handle_response(abspath, code, response.info(), response)
+        data = handle_response(abspath, code, response.headers, response)
+        # Close response to free the httplib.HTTPConnection pipeline
+        self._get_connection().fake_close()
         return code, data
 
     def _head(self, relpath):
@@ -150,6 +169,7 @@
                           accepted_errors=[200, 404])
         response = self._perform(request)
 
+        self._get_connection().fake_close()
         return response
 
     def has(self, relpath):
@@ -166,6 +186,6 @@
 
 def get_test_permutations():
     """Return the permutations to be used in testing."""
-    from bzrlib.tests.http_server import HttpServer_urllib
+    from bzrlib.tests.HttpServer import HttpServer_urllib
     return [(HttpTransport_urllib, HttpServer_urllib),
             ]

=== modified file 'bzrlib/transport/http/_urllib2_wrappers.py'
--- bzrlib/transport/http/_urllib2_wrappers.py	2008-05-19 10:30:37 +0000
+++ bzrlib/transport/http/_urllib2_wrappers.py	2007-10-23 10:58:09 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007 Canonical Ltd
+# Copyright (C) 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -20,7 +20,7 @@
 
 For instance, we create a new HTTPConnection and HTTPSConnection that inherit
 from the original urllib2.HTTP(s)Connection objects, but also have a new base
-which implements a custom getresponse and cleanup_pipe handlers.
+which implements a custom getresponse and fake_close handlers.
 
 And then we implement custom HTTPHandler and HTTPSHandler classes, that use
 the custom HTTPConnection classes.
@@ -30,10 +30,6 @@
 
 And a custom Request class that lets us track redirections, and
 handle authentication schemes.
-
-For coherency with python libraries, we use capitalized header names throughout
-the code, even if the header names will be titled just before sending the
-request (see AbstractHTTPHandler.do_open).
 """
 
 DEBUG = 0
@@ -60,26 +56,12 @@
 from bzrlib import __version__ as bzrlib_version
 from bzrlib import (
     config,
-    debug,
     errors,
-    trace,
     transport,
     ui,
     )
 
 
-class _BufferedMakefileSocket(object):
-
-    def __init__(self, sock):
-        self.sock = sock
-
-    def makefile(self, mode='r', bufsize=-1):
-        return self.sock.makefile(mode, 65536)
-
-    def __getattr__(self, name):
-        return getattr(self.sock, name)
-
-
 # We define our own Response class to keep our httplib pipe clean
 class Response(httplib.HTTPResponse):
     """Custom HTTPResponse, to avoid the need to decorate.
@@ -91,19 +73,8 @@
     # Some responses have bodies in which we have no interest
     _body_ignored_responses = [301,302, 303, 307, 401, 403, 404]
 
-    # in finish() below, we may have to discard several MB in the worst
-    # case. To avoid buffering that much, we read and discard by chunks
-    # instead. The underlying file is either a socket or a StringIO, so reading
-    # 8k chunks should be fine.
-    _discarded_buf_size = 8192
-
-    def __init__(self, sock, *args, **kwargs):
-        # httplib creates a fileobject that doesn't do buffering, which
-        # makes fp.readline() very expensive because it only reads one byte
-        # at a time.  So we wrap the socket in an object that forces
-        # sock.makefile to make a buffered file.
-        sock = _BufferedMakefileSocket(sock)
-        httplib.HTTPResponse.__init__(self, sock, *args, **kwargs)
+    def __init__(self, *args, **kwargs):
+        httplib.HTTPResponse.__init__(self, *args, **kwargs)
 
     def begin(self):
         """Begin to read the response from the server.
@@ -115,9 +86,13 @@
         """
         httplib.HTTPResponse.begin(self)
         if self.status in self._body_ignored_responses:
-            if self.debuglevel >= 2:
+            if self.debuglevel > 0:
                 print "For status: [%s]," % self.status,
-                print "will ready body, length: %s" % self.length
+                print "will ready body, length: ",
+                if  self.length is not None:
+                    print "[%d]" % self.length
+                else:
+                    print "None"
             if not (self.length is None or self.will_close):
                 # In some cases, we just can't read the body not
                 # even try or we may encounter a 104, 'Connection
@@ -125,9 +100,8 @@
                 # and the server closed the connection just after
                 # having issued the response headers (even if the
                 # headers indicate a Content-Type...)
-                body = self.read(self.length)
-                if self.debuglevel >= 9:
-                    # This one can be huge and is generally not interesting
+                body = self.fp.read(self.length)
+                if self.debuglevel > 0:
                     print "Consumed body: [%s]" % body
             self.close()
         elif self.status == 200:
@@ -135,80 +109,22 @@
             # close the connection. Some cases are not correctly detected by
             # httplib.HTTPConnection.getresponse (called by
             # httplib.HTTPResponse.begin). The CONNECT response for the https
-            # through proxy case is one.  Note: the 'will_close' below refers
-            # to the "true" socket between us and the server, whereas the
-            # 'close()' above refers to the copy of that socket created by
-            # httplib for the response itself. So, in the if above we close the
-            # socket to indicate that we are done with the response whereas
-            # below we keep the socket with the server opened.
+            # through proxy case is one.
             self.will_close = False
 
-    def finish(self):
-        """Finish reading the body.
-
-        In some cases, the client may have left some bytes to read in the
-        body. That will block the next request to succeed if we use a
-        persistent connection. If we don't use a persistent connection, well,
-        nothing will block the next request since a new connection will be
-        issued anyway.
-
-        :return: the number of bytes left on the socket (may be None)
-        """
-        pending = None
-        if not self.isclosed():
-            # Make sure nothing was left to be read on the socket
-            pending = 0
-            data = True
-            while data and self.length:
-                # read() will update self.length
-                data = self.read(min(self.length, self._discarded_buf_size))
-                pending += len(data)
-            if pending:
-                trace.mutter("%s bytes left on the HTTP socket", pending)
-            self.close()
-        return pending
-
 
 # Not inheriting from 'object' because httplib.HTTPConnection doesn't.
 class AbstractHTTPConnection:
     """A custom HTTP(S) Connection, which can reset itself on a bad response"""
 
     response_class = Response
-
-    # When we detect a server responding with the whole file to range requests,
-    # we want to warn. But not below a given thresold.
-    _range_warning_thresold = 1024 * 1024
-
-    def __init__(self):
-        self._response = None
-        self._ranges_received_whole_file = None
-
-    def _mutter_connect(self):
-        netloc = '%s:%s' % (self.host, self.port)
-        if self.proxied_host is not None:
-            netloc += '(proxy for %s)' % self.proxied_host
-        trace.mutter('* About to connect() to %s' % netloc)
-
-    def getresponse(self):
-        """Capture the response to be able to cleanup"""
-        self._response = httplib.HTTPConnection.getresponse(self)
-        return self._response
-
-    def cleanup_pipe(self):
-        """Read the remaining bytes of the last response if any."""
-        if self._response is not None:
-            pending = self._response.finish()
-            # Warn the user (once)
-            if (self._ranges_received_whole_file is None
-                and self._response.status == 200
-                and pending and pending > self._range_warning_thresold
-                ):
-                self._ranges_received_whole_file = True
-                trace.warning(
-                    'Got a 200 response when asking for multiple ranges,'
-                    ' does your server at %s:%s support range requests?',
-                    self.host, self.port)
-            self._response = None
+    strict = 1 # We don't support HTTP/0.9
+
+    def fake_close(self):
+        """Make the connection believes the response have been fully handled.
+
+        That makes the httplib.HTTPConnection happy
+        """
         # Preserve our preciousss
         sock = self.sock
         self.sock = None
@@ -221,32 +137,20 @@
 class HTTPConnection(AbstractHTTPConnection, httplib.HTTPConnection):
 
     # XXX: Needs refactoring at the caller level.
-    def __init__(self, host, port=None, proxied_host=None):
-        AbstractHTTPConnection.__init__(self)
-        # Use strict=True since we don't support HTTP/0.9
-        httplib.HTTPConnection.__init__(self, host, port, strict=True)
+    def __init__(self, host, port=None, strict=None, proxied_host=None):
+        httplib.HTTPConnection.__init__(self, host, port, strict)
         self.proxied_host = proxied_host
 
-    def connect(self):
-        if 'http' in debug.debug_flags:
-            self._mutter_connect()
-        httplib.HTTPConnection.connect(self)
-
-
-# FIXME: Should test for ssl availability
+
 class HTTPSConnection(AbstractHTTPConnection, httplib.HTTPSConnection):
 
     def __init__(self, host, port=None, key_file=None, cert_file=None,
-                 proxied_host=None):
-        AbstractHTTPConnection.__init__(self)
-        # Use strict=True since we don't support HTTP/0.9
+                 strict=None, proxied_host=None):
         httplib.HTTPSConnection.__init__(self, host, port,
-                                         key_file, cert_file, strict=True)
+                                         key_file, cert_file, strict)
         self.proxied_host = proxied_host
 
     def connect(self):
-        if 'http' in debug.debug_flags:
-            self._mutter_connect()
         httplib.HTTPConnection.connect(self)
         if self.proxied_host is None:
             self.connect_to_origin()
@@ -313,8 +217,7 @@
         # confused
         Request.__init__(self, 'CONNECT', request.get_full_url(),
                          connection=request.connection)
-        if request.proxied_host is None:
-            raise AssertionError()
+        assert request.proxied_host is not None
         self.proxied_host = request.proxied_host
 
     def get_selector(self):
@@ -411,6 +314,10 @@
     _default_headers = {'Pragma': 'no-cache',
                         'Cache-control': 'max-age=0',
                         'Connection': 'Keep-Alive',
+                        # FIXME: Spell it User-*A*gent once we
+                        # know how to properly avoid bogus
+                        # urllib2 using capitalize() for headers
+                        # instead of title(sp?).
                         'User-agent': 'bzr/%s (urllib)' % bzrlib_version,
                         'Accept': '*/*',
                         }
@@ -446,13 +353,9 @@
             raise errors.ConnectionError("Couldn't resolve host '%s'"
                                          % request.get_origin_req_host(),
                                          orig_error=exc_val)
-        elif isinstance(exc_val, httplib.ImproperConnectionState):
-            # The httplib pipeline is in incorrect state, it's a bug in our
-            # implementation.
-            raise exc_type, exc_val, exc_tb
         else:
             if first_try:
-                if self._debuglevel >= 2:
+                if self._debuglevel > 0:
                     print 'Received exception: [%r]' % exc_val
                     print '  On connection: [%r]' % request.connection
                     method = request.get_method()
@@ -460,8 +363,9 @@
                     print '  Will retry, %s %r' % (method, url)
                 request.connection.close()
                 response = self.do_open(http_class, request, False)
+                convert_to_addinfourl = False
             else:
-                if self._debuglevel >= 2:
+                if self._debuglevel > 0:
                     print 'Received second exception: [%r]' % exc_val
                     print '  On connection: [%r]' % request.connection
                 if exc_type in (httplib.BadStatusLine, httplib.UnknownProtocol):
@@ -478,24 +382,35 @@
                 else:
                     # All other exception are considered connection related.
 
+                    # httplib.HTTPException should indicate a bug in our
+                    # urllib-based implementation, somewhow the httplib
+                    # pipeline is in an incorrect state, we retry in hope that
+                    # this will correct the problem but that may need
+                    # investigation (note that no such bug is known as of
+                    # 20061005 --vila).
+
                     # socket errors generally occurs for reasons
                     # far outside our scope, so closing the
                     # connection and retrying is the best we can
                     # do.
 
+                    # FIXME: and then there is HTTPError raised by:
+                    # - HTTPDefaultErrorHandler (we define our own)
+                    # - HTTPRedirectHandler.redirect_request 
+
                     my_exception = errors.ConnectionError(
                         msg= 'while sending %s %s:' % (request.get_method(),
                                                        request.get_selector()),
                         orig_error=exc_val)
 
-                if self._debuglevel >= 2:
+                if self._debuglevel > 0:
                     print 'On connection: [%r]' % request.connection
                     method = request.get_method()
                     url = request.get_full_url()
                     print '  Failed again, %s %r' % (method, url)
                     print '  Will raise: [%r]' % my_exception
                 raise my_exception, None, exc_tb
-        return response
+        return response, convert_to_addinfourl
 
     def do_open(self, http_class, request, first_try=True):
         """See urllib2.AbstractHTTPHandler.do_open for the general idea.
@@ -503,43 +418,30 @@
         The request will be retried once if it fails.
         """
         connection = request.connection
-        if connection is None:
-            raise AssertionError(
-                'Cannot process a request without a connection')
+        assert connection is not None, \
+            'Cannot process a request without a connection'
 
         # Get all the headers
         headers = {}
         headers.update(request.header_items())
         headers.update(request.unredirected_hdrs)
-        # Some servers or proxies will choke on headers not properly
-        # cased. httplib/urllib/urllib2 all use capitalize to get canonical
-        # header names, but only python2.5 urllib2 use title() to fix them just
-        # before sending the request. And not all versions of python 2.5 do
-        # that. Since we replace urllib2.AbstractHTTPHandler.do_open we do it
-        # ourself below.
-        headers = dict((name.title(), val) for name, val in headers.iteritems())
 
         try:
-            method = request.get_method()
-            url = request.get_selector()
-            connection._send_request(method, url,
+            connection._send_request(request.get_method(),
+                                     request.get_selector(),
                                      # FIXME: implements 100-continue
                                      #None, # We don't send the body yet
                                      request.get_data(),
                                      headers)
-            if 'http' in debug.debug_flags:
-                trace.mutter('> %s %s' % (method, url))
-                hdrs = ['%s: %s' % (k, v) for k,v in headers.items()]
-                trace.mutter('> ' + '\n> '.join(hdrs) + '\n')
-            if self._debuglevel >= 1:
-                print 'Request sent: [%r] from (%s)' \
-                    % (request, request.connection.sock.getsockname())
+            if self._debuglevel > 0:
+                print 'Request sent: [%r]' % request
             response = connection.getresponse()
             convert_to_addinfourl = True
         except (socket.gaierror, httplib.BadStatusLine, httplib.UnknownProtocol,
                 socket.error, httplib.HTTPException):
-            response = self.retry_or_raise(http_class, request, first_try)
-            convert_to_addinfourl = False
+            response, convert_to_addinfourl = self.retry_or_raise(http_class,
+                                                                  request,
+                                                                  first_try)
 
 # FIXME: HTTPConnection does not fully support 100-continue (the
 # server responses are just ignored)
@@ -553,7 +455,7 @@
 #            connection.send(body)
 #            response = connection.getresponse()
 
-        if self._debuglevel >= 2:
+        if self._debuglevel > 0:
             print 'Receives response: %r' % response
             print '  For: %r(%r)' % (request.get_method(),
                                      request.get_full_url())
@@ -563,32 +465,41 @@
             req = request
             r = response
             r.recv = r.read
-            fp = socket._fileobject(r, bufsize=65536)
+            fp = socket._fileobject(r)
             resp = urllib2.addinfourl(fp, r.msg, req.get_full_url())
             resp.code = r.status
             resp.msg = r.reason
-            resp.version = r.version
-            if self._debuglevel >= 2:
+            if self._debuglevel > 0:
                 print 'Create addinfourl: %r' % resp
                 print '  For: %r(%r)' % (request.get_method(),
                                          request.get_full_url())
-            if 'http' in debug.debug_flags:
-                version = 'HTTP/%d.%d'
-                try:
-                    version = version % (resp.version / 10,
-                                         resp.version % 10)
-                except:
-                    version = 'HTTP/%r' % resp.version
-                trace.mutter('< %s %s %s' % (version, resp.code,
-                                             resp.msg))
-                # Use the raw header lines instead of treating resp.info() as a
-                # dict since we may miss duplicated headers otherwise.
-                hdrs = [h.rstrip('\r\n') for h in resp.info().headers]
-                trace.mutter('< ' + '\n< '.join(hdrs) + '\n')
         else:
             resp = response
         return resp
 
+#       # we need titled headers in a dict but
+#       # response.getheaders returns a list of (lower(header).
+#       # Let's title that because most of bzr handle titled
+#       # headers, but maybe we should switch to lowercased
+#       # headers...
+#        # jam 20060908: I think we actually expect the headers to
+#        #       be similar to mimetools.Message object, which uses
+#        #       case insensitive keys. It lowers() all requests.
+#        #       My concern is that the code may not do perfect title case.
+#        #       For example, it may use Content-type rather than Content-Type
+#
+#        # When we get rid of addinfourl, we must ensure that bzr
+#        # always use titled headers and that any header received
+#        # from server is also titled.
+#
+#        headers = {}
+#        for header, value in (response.getheaders()):
+#            headers[header.title()] = value
+#        # FIXME: Implements a secured .read method
+#        response.code = response.status
+#        response.headers = headers
+#        return response
+
 
 class HTTPHandler(AbstractHTTPHandler):
     """A custom handler that just thunks into HTTPConnection"""
@@ -604,6 +515,7 @@
 
     def https_open(self, request):
         connection = request.connection
+        assert isinstance(connection, HTTPSConnection)
         if connection.sock is None and \
                 connection.proxied_host is not None and \
                 request.get_method() != 'CONNECT' : # Don't loop
@@ -613,7 +525,7 @@
             # - with and without certificate
             # - with self-signed certificate
             # - with and without authentication
-            # - with good and bad credentials (especially the proxy auth around
+            # - with good and bad credentials (especially the proxy auth aound
             #   CONNECT)
             # - with basic and digest schemes
             # - reconnection on errors
@@ -627,7 +539,7 @@
                 raise ConnectionError("Can't connect to %s via proxy %s" % (
                         connect.proxied_host, self.host))
             # Housekeeping
-            connection.cleanup_pipe()
+            connection.fake_close()
             # Establish the connection encryption 
             connection.connect_to_origin()
             # Propagate the connection to the original request
@@ -698,9 +610,9 @@
     def http_error_302(self, req, fp, code, msg, headers):
         """Requests the redirected to URI.
 
-        Copied from urllib2 to be able to clean the pipe of the associated
-        connection, *before* issuing the redirected request but *after* having
-        eventually raised an error.
+        Copied from urllib2 to be able to fake_close the
+        associated connection, *before* issuing the redirected
+        request but *after* having eventually raised an error.
         """
         # Some servers (incorrectly) return multiple Location headers
         # (so probably same goes for URI).  Use first header.
@@ -714,7 +626,7 @@
             newurl = headers.getheaders('uri')[0]
         else:
             return
-        if self._debuglevel >= 1:
+        if self._debuglevel > 0:
             print 'Redirected to: %s (followed: %r)' % (newurl,
                                                         req.follow_redirections)
         if req.follow_redirections is False:
@@ -745,7 +657,7 @@
         # use it with HTTPError.
         fp.close()
         # We have all we need already in the response
-        req.connection.cleanup_pipe()
+        req.connection.fake_close()
 
         return self.parent.open(redirected_req)
 
@@ -777,7 +689,7 @@
         urllib2.ProxyHandler.__init__(self, proxies)
         # First, let's get rid of urllib2 implementation
         for type, proxy in self.proxies.items():
-            if self._debuglevel >= 3:
+            if self._debuglevel > 0:
                 print 'Will unbind %s_open for %r' % (type, proxy)
             delattr(self, '%s_open' % type)
 
@@ -786,13 +698,13 @@
         https_proxy = self.get_proxy_env_var('https')
 
         if http_proxy is not None:
-            if self._debuglevel >= 3:
+            if self._debuglevel > 0:
                 print 'Will bind http_request for %r' % http_proxy
             setattr(self, 'http_request',
                     lambda request: self.set_proxy(request, 'http'))
 
         if https_proxy is not None:
-            if self._debuglevel >= 3:
+            if self._debuglevel > 0:
                 print 'Will bind http_request for %r' % https_proxy
             setattr(self, 'https_request',
                     lambda request: self.set_proxy(request, 'https'))
@@ -843,7 +755,7 @@
             return request
 
         proxy = self.get_proxy_env_var(type)
-        if self._debuglevel >= 3:
+        if self._debuglevel > 0:
             print 'set_proxy %s_request for %r' % (type, proxy)
         # FIXME: python 2.5 urlparse provides a better _parse_proxy which can
         # grok user:password@host:port as well as
@@ -867,7 +779,7 @@
         else:
             phost = host + ':%d' % port
         request.set_proxy(phost, type)
-        if self._debuglevel >= 3:
+        if self._debuglevel > 0:
             print 'set_proxy: proxy set to %s://%s' % (type, phost)
         return request
 
@@ -968,8 +880,6 @@
                 # We already tried that, give up
                 return None
 
-            # Housekeeping
-            request.connection.cleanup_pipe()
             response = self.parent.open(request)
             if response:
                 self.auth_successful(request, response)
@@ -1058,8 +968,8 @@
         the prompt, so we build the prompt from the authentication dict which
         contains all the needed parts.
 
-        Also, http and proxy AuthHandlers present different prompts to the
-        user. The daughter classes should implements a public
+        Also, hhtp and proxy AuthHandlers present different prompts to the
+        user. The daughter classes hosuld implements a public
         build_password_prompt using this method.
         """
         prompt = '%s' % auth['protocol'].upper() + ' %(user)s@%(host)s'
@@ -1341,9 +1251,12 @@
 
     def http_error_default(self, req, fp, code, msg, hdrs):
         if code == 403:
-            raise errors.TransportError(
-                'Server refuses to fulfill the request (403 Forbidden)'
-                ' for %s' % req.get_full_url())
+            raise errors.TransportError('Server refuses to fullfil the request')
+        elif code == 416:
+            # We don't know which, but one of the ranges we
+            # specified was wrong. So we raise with 0 for a lack
+            # of a better magic value.
+            raise errors.InvalidRange(req.get_full_url(),0)
         else:
             raise errors.InvalidHttpResponse(req.get_full_url(),
                                              'Unable to handle http code %d: %s'
@@ -1374,7 +1287,7 @@
             )
 
         self.open = self._opener.open
-        if DEBUG >= 9:
+        if DEBUG >= 2:
             # When dealing with handler order, it's easy to mess
             # things up, the following will help understand which
             # handler is used, when and for what.

=== modified file 'bzrlib/transport/http/response.py'
--- bzrlib/transport/http/response.py	2008-07-15 13:11:53 +0000
+++ bzrlib/transport/http/response.py	2007-06-20 13:56:21 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007 Canonical Ltd
+# Copyright (C) 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -22,310 +22,275 @@
 """
 
 
-import httplib
+from bisect import bisect
 from cStringIO import StringIO
-import rfc822
-
-from bzrlib import (
-    errors,
-    trace,
-    osutils,
-    )
-
-
-# A RangeFile expects the following grammar (simplified to outline the
-# assumptions we rely upon).
-
-# file: whole_file
-#     | single_range
-#     | multiple_range
-
-# whole_file: [content_length_header] data
-
-# single_range: content_range_header data
-
-# multiple_range: boundary_header boundary (content_range_header data boundary)+
+import re
+
+from bzrlib import errors
+from bzrlib.trace import mutter
+
+
+class ResponseRange(object):
+    """A range in a RangeFile-object."""
+
+    __slots__ = ['_ent_start', '_ent_end', '_data_start']
+
+    def __init__(self, ent_start, ent_end, data_start):
+        self._ent_start = ent_start
+        self._ent_end = ent_end
+        self._data_start = data_start
+
+    def __cmp__(self, other):
+        """Compare this to other.
+
+        We need this both for sorting, and so that we can
+        bisect the list of ranges.
+        """
+        if isinstance(other, int):
+            # Later on we bisect for a starting point
+            # so we allow comparing against a single integer
+            return cmp(self._ent_start, other)
+        else:
+            return cmp((self._ent_start, self._ent_end, self._data_start),
+                       (other._ent_start, other._ent_end, other._data_start))
+
+    def __str__(self):
+        return "%s(%s-%s,%s)" % (self.__class__.__name__,
+                                 self._ent_start, self._ent_end,
+                                 self._data_start)
+
+    __repr__ = __str__
+
 
 class RangeFile(object):
     """File-like object that allow access to partial available data.
 
-    All accesses should happen sequentially since the acquisition occurs during
-    an http response reception (as sockets can't be seeked, we simulate the
-    seek by just reading and discarding the data).
-
-    The access pattern is defined by a set of ranges discovered as reading
-    progress. Only one range is available at a given time, so all accesses
-    should happen with monotonically increasing offsets.
+    Specified by a set of ranges.
     """
 
-    # in _checked_read() below, we may have to discard several MB in the worst
-    # case. To avoid buffering that much, we read and discard by chunks
-    # instead. The underlying file is either a socket or a StringIO, so reading
-    # 8k chunks should be fine.
-    _discarded_buf_size = 8192
-
-    # maximum size of read requests -- used to avoid MemoryError issues in recv
-    _max_read_size = 512 * 1024
-
-    def __init__(self, path, infile):
-        """Constructor.
-
-        :param path: File url, for error reports.
-        :param infile: File-like socket set at body start.
-        """
+    def __init__(self, path, input_file):
         self._path = path
-        self._file = infile
-        self._boundary = None
-        # When using multi parts response, this will be set with the headers
-        # associated with the range currently read.
-        self._headers = None
-        # Default to the whole file of unspecified size
-        self.set_range(0, -1)
-
-    def set_range(self, start, size):
-        """Change the range mapping"""
-        self._start = start
-        self._size = size
-        # Set the new _pos since that's what we want to expose
-        self._pos = self._start
-
-    def set_boundary(self, boundary):
-        """Define the boundary used in a multi parts message.
-        
-        The file should be at the beginning of the body, the first range
-        definition is read and taken into account.
-        """
-        self._boundary = boundary
-        # Decode the headers and setup the first range
-        self.read_boundary()
-        self.read_range_definition()
-
-    def read_boundary(self):
-        """Read the boundary headers defining a new range"""
-        boundary_line = '\r\n'
-        while boundary_line == '\r\n':
-            # RFC2616 19.2 Additional CRLFs may precede the first boundary
-            # string entity.
-            # To be on the safe side we allow it before any boundary line
-            boundary_line = self._file.readline()
-
-        if boundary_line != '--' + self._boundary + '\r\n':
-            # rfc822.unquote() incorrectly unquotes strings enclosed in <>
-            # IIS 6 and 7 incorrectly wrap boundary strings in <>
-            # together they make a beautiful bug, which we will be gracious
-            # about here
-            if (self._unquote_boundary(boundary_line) != 
-                '--' + self._boundary + '\r\n'):
-                raise errors.InvalidHttpResponse(
-                    self._path,
-                    "Expected a boundary (%s) line, got '%s'"
-                    % (self._boundary, boundary_line))
-
-    def _unquote_boundary(self, b):
-        return b[:2] + rfc822.unquote(b[2:-2]) + b[-2:]
-
-    def read_range_definition(self):
-        """Read a new range definition in a multi parts message.
-
-        Parse the headers including the empty line following them so that we
-        are ready to read the data itself.
-        """
-        self._headers = httplib.HTTPMessage(self._file, seekable=0)
-        # Extract the range definition
-        content_range = self._headers.getheader('content-range', None)
-        if content_range is None:
-            raise errors.InvalidHttpResponse(
-                self._path,
-                'Content-Range header missing in a multi-part response')
-        self.set_range_from_header(content_range)
-
-    def set_range_from_header(self, content_range):
-        """Helper to set the new range from its description in the headers"""
-        try:
-            rtype, values = content_range.split()
-        except ValueError:
-            raise errors.InvalidHttpRange(self._path, content_range,
-                                          'Malformed header')
-        if rtype != 'bytes':
-            raise errors.InvalidHttpRange(self._path, content_range,
-                                          "Unsupported range type '%s'" % rtype)
-        try:
-            # We don't need total, but note that it may be either the file size
-            # or '*' if the server can't or doesn't want to return the file
-            # size.
-            start_end, total = values.split('/')
-            start, end = start_end.split('-')
-            start = int(start)
-            end = int(end)
-        except ValueError:
-            raise errors.InvalidHttpRange(self._path, content_range,
-                                          'Invalid range values')
-        size = end - start + 1
-        if size <= 0:
-            raise errors.InvalidHttpRange(self._path, content_range,
-                                          'Invalid range, size <= 0')
-        self.set_range(start, size)
-
-    def _checked_read(self, size):
-        """Read the file checking for short reads.
-
-        The data read is discarded along the way.
-        """
-        pos = self._pos
-        remaining = size
-        while remaining > 0:
-            data = self._file.read(min(remaining, self._discarded_buf_size))
-            remaining -= len(data)
-            if not data:
-                raise errors.ShortReadvError(self._path, pos, size,
-                                             size - remaining)
-        self._pos += size
-
-    def _seek_to_next_range(self):
-        # We will cross range boundaries
-        if self._boundary is None:
-            # If we don't have a boundary, we can't find another range
-            raise errors.InvalidRange(self._path, self._pos,
-                                      "Range (%s, %s) exhausted"
-                                      % (self._start, self._size))
-        self.read_boundary()
-        self.read_range_definition()
-
-    def read(self, size=-1):
+        self._pos = 0
+        self._len = 0
+        self._ranges = []
+        self._data = input_file.read()
+
+    def _add_range(self, ent_start, ent_end, data_start):
+        """Add an entity range.
+
+        :param ent_start: Start offset of entity
+        :param ent_end: End offset of entity (inclusive)
+        :param data_start: Start offset of data in data stream.
+        """
+        self._ranges.append(ResponseRange(ent_start, ent_end, data_start))
+        self._len = max(self._len, ent_end)
+
+    def _finish_ranges(self):
+        self._ranges.sort()
+
+    def read(self, size):
         """Read size bytes from the current position in the file.
 
-        Reading across ranges is not supported. We rely on the underlying http
-        client to clean the socket if we leave bytes unread. This may occur for
-        the final boundary line of a multipart response or for any range
-        request not entirely consumed by the client (due to offset coalescing)
-
-        :param size:  The number of bytes to read.  Leave unspecified or pass
-            -1 to read to EOF.
+        Reading across ranges is not supported.
         """
-        if (self._size > 0
-            and self._pos == self._start + self._size):
-            if size == 0:
-                return ''
-            else:
-                self._seek_to_next_range()
-        elif self._pos < self._start:
-            raise errors.InvalidRange(
-                self._path, self._pos,
-                "Can't read %s bytes before range (%s, %s)"
-                % (size, self._start, self._size))
-        if self._size > 0:
-            if size > 0 and self._pos + size > self._start + self._size:
-                raise errors.InvalidRange(
-                    self._path, self._pos,
-                    "Can't read %s bytes across range (%s, %s)"
-                    % (size, self._start, self._size))
-
-        # read data from file
-        buffer = StringIO()
-        limited = size
-        if self._size > 0:
-            # Don't read past the range definition
-            limited = self._start + self._size - self._pos
-            if size >= 0:
-                limited = min(limited, size)
-        osutils.pumpfile(self._file, buffer, limited, self._max_read_size)
-        data = buffer.getvalue()
-
-        # Update _pos respecting the data effectively read
-        self._pos += len(data)
-        return data
+        # find the last range which has a start <= pos
+        i = bisect(self._ranges, self._pos) - 1
+
+        if i < 0 or self._pos > self._ranges[i]._ent_end:
+            mutter('Bisect for pos: %s failed. Found offset: %d, ranges:%s',
+                   self._pos, i, self._ranges)
+            raise errors.InvalidRange(self._path, self._pos)
+
+        r = self._ranges[i]
+
+        # mutter('found range %s %s for pos %s', i, self._ranges[i], self._pos)
+
+        if (self._pos + size - 1) > r._ent_end:
+            raise errors.InvalidRange(self._path, self._pos)
+
+        start = r._data_start + (self._pos - r._ent_start)
+        end   = start + size
+        # mutter("range read %d bytes at %d == %d-%d", size, self._pos,
+        #         start, end)
+        self._pos += (end-start)
+        return self._data[start:end]
 
     def seek(self, offset, whence=0):
-        start_pos = self._pos
         if whence == 0:
-            final_pos = offset
+            self._pos = offset
         elif whence == 1:
-            final_pos = start_pos + offset
+            self._pos += offset
         elif whence == 2:
-            if self._size > 0:
-                final_pos = self._start + self._size + offset # offset < 0
-            else:
-                raise errors.InvalidRange(
-                    self._path, self._pos,
-                    "RangeFile: can't seek from end while size is unknown")
+            self._pos = self._len + offset
         else:
             raise ValueError("Invalid value %s for whence." % whence)
 
-        if final_pos < self._pos:
-            # Can't seek backwards
-            raise errors.InvalidRange(
-                self._path, self._pos,
-                'RangeFile: trying to seek backwards to %s' % final_pos)
-
-        if self._size > 0:
-            cur_limit = self._start + self._size
-            while final_pos > cur_limit:
-                # We will cross range boundaries
-                remain = cur_limit - self._pos
-                if remain > 0:
-                    # Finish reading the current range
-                    self._checked_read(remain)
-                self._seek_to_next_range()
-                cur_limit = self._start + self._size
-
-        size = final_pos - self._pos
-        if size > 0: # size can be < 0 if we crossed a range boundary
-            # We don't need the data, just read it and throw it away
-            self._checked_read(size)
+        if self._pos < 0:
+            self._pos = 0
 
     def tell(self):
         return self._pos
 
 
-def handle_response(url, code, msg, data):
-    """Interpret the code & headers and wrap the provided data in a RangeFile.
-
-    This is a factory method which returns an appropriate RangeFile based on
-    the code & headers it's given.
+class HttpRangeResponse(RangeFile):
+    """A single-range HTTP response."""
+
+    # TODO: jam 20060706 Consider compiling these regexes on demand
+    _CONTENT_RANGE_RE = re.compile(
+        r'\s*([^\s]+)\s+([0-9]+)-([0-9]+)/([0-9]+)\s*$')
+
+    def __init__(self, path, content_range, input_file):
+        # mutter("parsing 206 non-multipart response for %s", path)
+        RangeFile.__init__(self, path, input_file)
+        start, end = self._parse_range(content_range, path)
+        self._add_range(start, end, 0)
+        self._finish_ranges()
+
+    @staticmethod
+    def _parse_range(range, path='<unknown>'):
+        """Parse an http Content-range header and return start + end
+
+        :param range: The value for Content-range
+        :param path: Provide to give better error messages.
+        :return: (start, end) A tuple of integers
+        """
+        match = HttpRangeResponse._CONTENT_RANGE_RE.match(range)
+        if not match:
+            raise errors.InvalidHttpRange(path, range,
+                                          "Invalid Content-range")
+
+        rtype, start, end, total = match.groups()
+
+        if rtype != 'bytes':
+            raise errors.InvalidHttpRange(path, range,
+                    "Unsupported range type '%s'" % (rtype,))
+
+        try:
+            start = int(start)
+            end = int(end)
+        except ValueError, e:
+            raise errors.InvalidHttpRange(path, range, str(e))
+
+        return start, end
+
+
+class HttpMultipartRangeResponse(RangeFile):
+    """A multi-range HTTP response."""
+    
+    _CONTENT_TYPE_RE = re.compile(
+        r'^\s*multipart/byteranges\s*;\s*boundary\s*=\s*("?)([^"]*?)\1\s*$')
+    
+    # Start with --<boundary>\r\n
+    # and ignore all headers ending in \r\n
+    # except for content-range:
+    # and find the two trailing \r\n separators
+    # indicating the start of the text
+    # TODO: jam 20060706 This requires exact conformance
+    #       to the spec, we probably could relax the requirement
+    #       of \r\n, and use something more like (\r?\n)
+    _BOUNDARY_PATT = (
+        "^--%s(?:\r\n(?:(?:content-range:([^\r]+))|[^\r]+))+\r\n\r\n")
+
+    def __init__(self, path, content_type, input_file):
+        # mutter("parsing 206 multipart response for %s", path)
+        # TODO: jam 20060706 Is it valid to initialize a
+        #       grandparent without initializing parent?
+        RangeFile.__init__(self, path, input_file)
+
+        self.boundary_regex = self._parse_boundary(content_type, path)
+        # mutter('response:\n%r', self._data)
+
+        for match in self.boundary_regex.finditer(self._data):
+            ent_start, ent_end = HttpRangeResponse._parse_range(match.group(1),
+                                                                path)
+            self._add_range(ent_start, ent_end, match.end())
+
+        self._finish_ranges()
+
+    @staticmethod
+    def _parse_boundary(ctype, path='<unknown>'):
+        """Parse the Content-type field.
+        
+        This expects a multipart Content-type, and returns a
+        regex which is capable of finding the boundaries
+        in the multipart data.
+        """
+        match = HttpMultipartRangeResponse._CONTENT_TYPE_RE.match(ctype)
+        if not match:
+            raise errors.InvalidHttpContentType(path, ctype,
+                    "Expected multipart/byteranges with boundary")
+
+        boundary = match.group(2)
+        # mutter('multipart boundary is %s', boundary)
+        pattern = HttpMultipartRangeResponse._BOUNDARY_PATT
+        return re.compile(pattern % re.escape(boundary),
+                          re.IGNORECASE | re.MULTILINE)
+
+
+def _is_multipart(content_type):
+    return content_type.startswith('multipart/byteranges;')
+
+
+def handle_response(url, code, headers, data):
+    """Interpret the code & headers and return a HTTP response.
+
+    This is a factory method which returns an appropriate HTTP response
+    based on the code & headers it's given.
 
     :param url: The url being processed. Mostly for error reporting
     :param code: The integer HTTP response code
-    :param msg: An HTTPMessage containing the headers for the response
+    :param headers: A dict-like object that contains the HTTP response headers
     :param data: A file-like object that can be read() to get the
                  requested data
     :return: A file-like object that can seek()+read() the 
              ranges indicated by the headers.
     """
-    rfile = RangeFile(url, data)
-    if code == 200:
-        # A whole file
-        size = msg.getheader('content-length', None)
-        if size is None:
-            size = -1
-        else:
-            size = int(size)
-        rfile.set_range(0, size)
-    elif code == 206:
-        content_type = msg.getheader('content-type', None)
-        if content_type is None:
-            # When there is no content-type header we treat the response as
-            # being of type 'application/octet-stream' as per RFC2616 section
-            # 7.2.1.
+
+    if code == 206:
+        try:
+            content_type = headers['Content-Type']
+        except KeyError:
+            # When there is no content-type header we treat
+            # the response as being of type 'application/octet-stream' as per
+            # RFC2616 section 7.2.1.
             # Therefore it is obviously not multipart
             content_type = 'application/octet-stream'
             is_multipart = False
         else:
-            is_multipart = (msg.getmaintype() == 'multipart'
-                            and msg.getsubtype() == 'byteranges')
+            is_multipart = _is_multipart(content_type)
 
         if is_multipart:
             # Full fledged multipart response
-            rfile.set_boundary(msg.getparam('boundary'))
+            return HttpMultipartRangeResponse(url, content_type, data)
         else:
             # A response to a range request, but not multipart
-            content_range = msg.getheader('content-range', None)
-            if content_range is None:
+            try:
+                content_range = headers['Content-Range']
+            except KeyError:
                 raise errors.InvalidHttpResponse(url,
                     'Missing the Content-Range header in a 206 range response')
-            rfile.set_range_from_header(content_range)
+            return HttpRangeResponse(url, content_range, data)
+    elif code == 200:
+        # A regular non-range response, unfortunately the result from
+        # urllib doesn't support seek, so we wrap it in a StringIO
+        tell = getattr(data, 'tell', None)
+        if tell is None:
+            return StringIO(data.read())
+        return data
+    elif code == 404:
+        raise errors.NoSuchFile(url)
+    # Some servers will retun "400: Bad Request" when too much ranges are
+    # specified
+    elif code in (400, 416):
+        # We don't know which, but one of the ranges we specified
+        # was wrong. So we raise with 0 for a lack of a better
+        # magic value.
+        raise errors.InvalidRange(url,0)
+
+    # TODO: jam 20060713 Properly handle redirects (302 Found, etc)
+    #       The '_get' code says to follow redirects, we probably 
+    #       should actually handle the return values
     else:
-        raise errors.InvalidHttpResponse(url,
-                                         'Unknown response code %s' % code)
-
-    return rfile
+        raise errors.InvalidHttpResponse(url, "Unknown response code %s" 
+                                              % (code,))
 

=== modified file 'bzrlib/transport/http/wsgi.py'
--- bzrlib/transport/http/wsgi.py	2008-05-16 05:55:23 +0000
+++ bzrlib/transport/http/wsgi.py	2007-08-15 19:16:00 +0000
@@ -22,12 +22,12 @@
 
 from cStringIO import StringIO
 
-from bzrlib.smart import protocol, medium
+from bzrlib.smart import protocol
 from bzrlib.transport import chroot, get_transport
 from bzrlib.urlutils import local_path_to_url
     
 
-def make_app(root, prefix, path_var='REQUEST_URI', readonly=True):
+def make_app(root, prefix, path_var, readonly=True):
     """Convenience function to construct a WSGI bzr smart server.
     
     :param root: a local path that requests will be relative to.
@@ -39,8 +39,8 @@
         base_transport = get_transport('readonly+' + local_url)
     else:
         base_transport = get_transport(local_url)
-    app = SmartWSGIApp(base_transport, prefix)
-    app = RelpathSetter(app, '', path_var)
+    app = SmartWSGIApp(base_transport)
+    app = RelpathSetter(app, prefix, path_var)
     return app
 
 
@@ -85,14 +85,11 @@
 class SmartWSGIApp(object):
     """A WSGI application for the bzr smart server."""
 
-    def __init__(self, backing_transport, root_client_path='/'):
+    def __init__(self, backing_transport):
         """Constructor.
 
         :param backing_transport: a transport.  Requests will be processed
             relative to this transport.
-        :param root_client_path: the client path that maps to the root of
-            backing_transport.  This is used to interpret relpaths received from
-            the client.
         """
         # Use a ChrootTransportDecorator so that this web application won't
         # accidentally let people access locations they shouldn't.
@@ -101,7 +98,6 @@
         self.chroot_server = chroot.ChrootServer(backing_transport)
         self.chroot_server.setUp()
         self.backing_transport = get_transport(self.chroot_server.get_url())
-        self.root_client_path = root_client_path
         # While the chroot server can technically be torn down at this point,
         # as all it does is remove the scheme registration from transport's 
         # protocol dictionary, we don't *just in case* there are parts of 
@@ -116,43 +112,12 @@
             return []
 
         relpath = environ['bzrlib.relpath']
-
-        if not relpath.startswith('/'):
-            relpath = '/' + relpath
-        if not relpath.endswith('/'):
-            relpath += '/'
-
-        # Compare the HTTP path (relpath) and root_client_path, and calculate
-        # new relpath and root_client_path accordingly, to be used to build the
-        # request.
-        if relpath.startswith(self.root_client_path):
-            # The relpath traverses all of the mandatory root client path.
-            # Remove the root_client_path from the relpath, and set
-            # adjusted_tcp to None to tell the request handler that no further
-            # path translation is required.
-            adjusted_rcp = None
-            adjusted_relpath = relpath[len(self.root_client_path):]
-        elif self.root_client_path.startswith(relpath):
-            # The relpath traverses some of the mandatory root client path.
-            # Subtract the relpath from the root_client_path, and set the
-            # relpath to '.'.
-            adjusted_rcp = '/' + self.root_client_path[len(relpath):]
-            adjusted_relpath = '.'
-        else:
-            adjusted_rcp = self.root_client_path
-            adjusted_relpath = relpath
-
-        if adjusted_relpath.startswith('/'):
-            adjusted_relpath = adjusted_relpath[1:]
-        if adjusted_relpath.startswith('/'):
-            raise AssertionError(adjusted_relpath)
-
-        transport = self.backing_transport.clone(adjusted_relpath)
+        transport = self.backing_transport.clone(relpath)
         out_buffer = StringIO()
         request_data_length = int(environ['CONTENT_LENGTH'])
         request_data_bytes = environ['wsgi.input'].read(request_data_length)
         smart_protocol_request = self.make_request(
-            transport, out_buffer.write, request_data_bytes, adjusted_rcp)
+            transport, out_buffer.write, request_data_bytes)
         if smart_protocol_request.next_read_size() != 0:
             # The request appears to be incomplete, or perhaps it's just a
             # newer version we don't understand.  Regardless, all we can do
@@ -166,9 +131,14 @@
         start_response('200 OK', headers)
         return [response_data]
 
-    def make_request(self, transport, write_func, request_bytes, rcp):
-        protocol_factory, unused_bytes = medium._get_protocol_factory_for_bytes(
-            request_bytes)
-        server_protocol = protocol_factory(transport, write_func, rcp)
-        server_protocol.accept_bytes(unused_bytes)
+    def make_request(self, transport, write_func, request_bytes):
+        # XXX: This duplicates the logic in
+        # SmartServerStreamMedium._build_protocol.
+        if request_bytes.startswith(protocol.REQUEST_VERSION_TWO):
+            protocol_class = protocol.SmartServerRequestProtocolTwo
+            request_bytes = request_bytes[len(protocol.REQUEST_VERSION_TWO):]
+        else:
+            protocol_class = protocol.SmartServerRequestProtocolOne
+        server_protocol = protocol_class(transport, write_func)
+        server_protocol.accept_bytes(request_bytes)
         return server_protocol

=== modified file 'bzrlib/transport/local.py'
--- bzrlib/transport/local.py	2008-08-11 02:32:44 +0000
+++ bzrlib/transport/local.py	2007-10-04 05:09:58 +0000
@@ -63,15 +63,6 @@
             base = urlutils.local_path_to_url(base)
         if base[-1] != '/':
             base = base + '/'
-
-        # Special case : windows has no "root", but does have
-        # multiple lettered drives inside it. #240910
-        if sys.platform == 'win32' and base == 'file:///':
-            base = ''
-            self._local_base = ''
-            super(LocalTransport, self).__init__(base)
-            return
-            
         super(LocalTransport, self).__init__(base)
         self._local_base = urlutils.local_path_from_url(base)
 
@@ -105,6 +96,7 @@
     def abspath(self, relpath):
         """Return the full url to the given relative URL."""
         # TODO: url escape the result. RBC 20060523.
+        assert isinstance(relpath, basestring), (type(relpath), relpath)
         # jam 20060426 Using normpath on the real path, because that ensures
         #       proper handling of stuff like
         path = osutils.normpath(osutils.pathjoin(
@@ -117,9 +109,8 @@
         This function only exists for the LocalTransport, since it is
         the only one that has direct local access.
         This is mostly for stuff like WorkingTree which needs to know
-        the local working directory.  The returned path will always contain
-        forward slashes as the path separator, regardless of the platform.
-
+        the local working directory.
+        
         This function is quite expensive: it calls realpath which resolves
         symlinks.
         """
@@ -316,10 +307,7 @@
         """See Transport.open_write_stream."""
         # initialise the file
         self.put_bytes_non_atomic(relpath, "", mode=mode)
-        abspath = self._abspath(relpath)
-        handle = open(abspath, 'wb')
-        if mode is not None:
-            self._check_mode_and_size(abspath, handle.fileno(), mode)
+        handle = open(self._abspath(relpath), 'wb')
         transport._file_streams[self.abspath(relpath)] = handle
         return transport.FileFileStream(self, relpath, handle)
 
@@ -520,6 +508,7 @@
         self._local_base = urlutils._win32_local_path_from_url(base)
 
     def abspath(self, relpath):
+        assert isinstance(relpath, basestring), (type(relpath), relpath)
         path = osutils.normpath(osutils.pathjoin(
                     self._local_base, urlutils.unescape(relpath)))
         return urlutils._win32_local_path_to_url(path)

=== removed file 'bzrlib/transport/log.py'
--- bzrlib/transport/log.py	2008-09-02 07:44:13 +0000
+++ bzrlib/transport/log.py	1970-01-01 00:00:00 +0000
@@ -1,157 +0,0 @@
-# Copyright (C) 2007 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Transport decorator that logs transport operations to .bzr.log."""
-
-
-# see also the transportstats plugin, which gives you some summary information
-# in a machine-readable dump
-
-import StringIO
-import cStringIO
-import time
-import types
-
-from bzrlib.trace import mutter
-from bzrlib.transport.decorator import (
-    TransportDecorator,
-    )
-from bzrlib.transport.trace import (
-    DecoratorServer,
-    TransportTraceDecorator,
-    )
-
-
-
-
-class TransportLogDecorator(TransportDecorator):
-    """Decorator for Transports that logs interesting operations to .bzr.log.
-
-    In general we want to log things that usually take a network round trip
-    and may be slow.
-
-    Not all operations are logged yet.
-    """
-
-    def __init__(self, *args, **kw):
-        super(TransportLogDecorator, self).__init__(*args, **kw)
-        def _make_hook(hookname):
-            def _hook(relpath, *args, **kw):
-                return self._log_and_call(hookname, relpath, *args, **kw)
-            return _hook
-        for methodname in (
-            'append_bytes',
-            'append_file',
-            'copy_to',
-            'delete',
-            'get',
-            'has',
-            'open_write_stream',
-            'mkdir',
-            'move',
-            'put_bytes', 'put_bytes_non_atomic', 'put_file put_file_non_atomic',
-            'list_dir', 'lock_read', 'lock_write',
-            'readv', 'rename', 'rmdir',
-            'stat',
-            'ulock',
-            ):
-            setattr(self, methodname, _make_hook(methodname))
-
-    @classmethod
-    def _get_url_prefix(self):
-        return 'log+'
-
-    def iter_files_recursive(self):
-        # needs special handling because it does not have a relpath parameter
-        mutter("%s %s"
-            % ('iter_files_recursive', self._decorated.base))
-        return self._call_and_log_result('iter_files_recursive', (), {})
-
-    def _log_and_call(self, methodname, relpath, *args, **kwargs):
-        if kwargs:
-            kwargs_str = dict(kwargs)
-        else:
-            kwargs_str = ''
-        mutter("%s %s %s %s"
-               % (methodname, self._decorated.abspath(relpath),
-                  self._shorten(self._strip_tuple_parens(args)),
-                  kwargs_str))
-        return self._call_and_log_result(methodname, (relpath,) + args, kwargs)
-
-    def _call_and_log_result(self, methodname, args, kwargs):
-        before = time.time()
-        try:
-            result = getattr(self._decorated, methodname)(*args, **kwargs)
-        except Exception, e:
-            mutter("  --> %s" % e)
-            mutter("      %.03fs" % (time.time() - before))
-            raise
-        return self._show_result(before, methodname, result)
-
-    def _show_result(self, before, methodname, result):
-        result_len = None
-        if isinstance(result, types.GeneratorType):
-            # eagerly pull in all the contents, so that we can measure how
-            # long it takes to get them.  this does make the behaviour a bit
-            # different, but we hope not noticably so
-            result = list(result)
-        if isinstance(result, (cStringIO.OutputType, StringIO.StringIO)):
-            val = repr(result.getvalue())
-            result_len = len(val)
-            shown_result = "%s(%s) (%d bytes)" % (result.__class__.__name__,
-                self._shorten(val), result_len)
-        elif methodname == 'readv':
-            num_hunks = len(result)
-            total_bytes = sum((len(d) for o,d in result))
-            shown_result = "readv response, %d hunks, %d total bytes" % (
-                num_hunks, total_bytes)
-            result_len = total_bytes
-        else:
-            shown_result = self._shorten(self._strip_tuple_parens(result))
-        mutter("  --> %s" % shown_result)
-        # XXX: the time may be wrong when e.g. a generator object is returned from
-        # an http readv, if the object is returned before the bulk data
-        # is read.
-        elapsed = time.time() - before
-        if result_len and elapsed > 0:
-            # this is the rate of higher-level data, not the raw network speed
-            mutter("      %9.03fs %8dkB/s" % (elapsed, result_len/elapsed/1024))
-        else:
-            mutter("      %9.03fs" % (elapsed))
-        return result
-
-    def _shorten(self, x):
-        if len(x) > 70:
-            x = x[:67] + '...'
-        return x
-
-    def _strip_tuple_parens(self, t):
-        t = repr(t)
-        if t[0] == '(' and t[-1] == ')':
-            t = t[1:-1]
-        return t
-
-
-class LogDecoratorServer(DecoratorServer):
-    """Server for testing."""
-
-    def get_decorator_class(self):
-        return TransportLogDecorator
-
-
-def get_test_permutations():
-    """Return the permutations to be used in testing."""
-    return [(TransportLogDecorator, LogDecoratorServer)]

=== modified file 'bzrlib/transport/memory.py'
--- bzrlib/transport/memory.py	2008-04-24 07:22:53 +0000
+++ bzrlib/transport/memory.py	2007-10-04 05:09:58 +0000
@@ -261,28 +261,28 @@
     def _abspath(self, relpath):
         """Generate an internal absolute path."""
         relpath = urlutils.unescape(relpath)
-        if relpath[:1] == '/':
+        if relpath.find('..') != -1:
+            raise AssertionError('relpath contains ..')
+        if relpath == '':
+            return '/'
+        if relpath[0] == '/':
             return relpath
-        cwd_parts = self._cwd.split('/')
-        rel_parts = relpath.split('/')
-        r = []
-        for i in cwd_parts + rel_parts:
-            if i == '..':
-                if not r:
-                    raise ValueError("illegal relpath %r under %r"
-                        % (relpath, self._cwd))
-                r = r[:-1]
-            elif i == '.' or i == '':
-                pass
-            else:
-                r.append(i)
-        return '/' + '/'.join(r)
+        if relpath == '.':
+            if (self._cwd == '/'):
+                return self._cwd
+            return self._cwd[:-1]
+        if relpath.endswith('/'):
+            relpath = relpath[:-1]
+        if relpath.startswith('./'):
+            relpath = relpath[2:]
+        return self._cwd + relpath
 
 
 class _MemoryLock(object):
     """This makes a lock."""
 
     def __init__(self, path, transport):
+        assert isinstance(transport, MemoryTransport)
         self.path = path
         self.transport = transport
         if self.path in self.transport._locks:

=== removed file 'bzrlib/transport/nosmart.py'
--- bzrlib/transport/nosmart.py	2008-04-02 10:05:36 +0000
+++ bzrlib/transport/nosmart.py	1970-01-01 00:00:00 +0000
@@ -1,49 +0,0 @@
-# Copyright (C) 2008 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Implementation of Transport that never has a smart medium.
-
-This is mainly useful with HTTP transports, which sometimes have a smart medium
-and sometimes don't.  By using this decorator, you can force those transports
-to never have a smart medium.
-"""
-
-from bzrlib import errors
-from bzrlib.transport.decorator import TransportDecorator, DecoratorServer
-
-
-class NoSmartTransportDecorator(TransportDecorator):
-    """A decorator for transports that disables get_smart_medium."""
-
-    @classmethod
-    def _get_url_prefix(self):
-        return 'nosmart+'
-
-    def get_smart_medium(self):
-        raise errors.NoSmartMedium(self)
-
-
-class NoSmartTransportServer(DecoratorServer):
-    """Server for the NoSmartTransportDecorator for testing with."""
-
-    def get_decorator_class(self):
-        return NoSmartTransportDecorator
-
-
-def get_test_permutations():
-    """Return the permutations to be used in testing."""
-    return [(NoSmartTransportDecorator, NoSmartTransportServer)]
-

=== modified file 'bzrlib/transport/remote.py'
--- bzrlib/transport/remote.py	2008-08-29 19:33:35 +0000
+++ bzrlib/transport/remote.py	2007-10-05 14:52:02 +0000
@@ -23,6 +23,8 @@
 __all__ = ['RemoteTransport', 'RemoteTCPTransport', 'RemoteSSHTransport']
 
 from cStringIO import StringIO
+import urllib
+import urlparse
 
 from bzrlib import (
     config,
@@ -32,8 +34,17 @@
     transport,
     urlutils,
     )
-from bzrlib.smart import client, medium
-from bzrlib.symbol_versioning import (deprecated_method, one_four)
+from bzrlib.smart import client, medium, protocol
+
+# must do this otherwise urllib can't parse the urls properly :(
+for scheme in ['ssh', 'bzr', 'bzr+loopback', 'bzr+ssh', 'bzr+http', 'bzr+https']:
+    transport.register_urlparse_netloc_protocol(scheme)
+del scheme
+
+
+# Port 4155 is the default port for bzr://, registered with IANA.
+BZR_DEFAULT_INTERFACE = '0.0.0.0'
+BZR_DEFAULT_PORT = 4155
 
 
 class _SmartStat(object):
@@ -43,7 +54,7 @@
         self.st_mode = mode
 
 
-class RemoteTransport(transport.ConnectedTransport, medium.SmartClientMedium):
+class RemoteTransport(transport.ConnectedTransport):
     """Connection to a smart server.
 
     The connection holds references to the medium that can be used to send
@@ -77,10 +88,8 @@
             one is being cloned from.  Attributes such as the medium will
             be reused.
 
-        :param medium: The medium to use for this RemoteTransport.  If None,
-            the medium from the _from_transport is shared.  If both this
-            and _from_transport are None, a new medium will be built.
-            _from_transport and medium cannot both be specified.
+        :param medium: The medium to use for this RemoteTransport. This must be
+            supplied if _from_transport is None.
 
         :param _client: Override the _SmartClient used by this transport.  This
             should only be used for testing purposes; normally this is
@@ -103,20 +112,10 @@
                     trace.mutter('hpss: Built a new medium: %s',
                                  medium.__class__.__name__)
             self._shared_connection = transport._SharedConnection(medium,
-                                                                  credentials,
-                                                                  self.base)
-        elif medium is None:
-            # No medium was specified, so share the medium from the
-            # _from_transport.
-            medium = self._shared_connection.connection
-        else:
-            raise AssertionError(
-                "Both _from_transport (%r) and medium (%r) passed to "
-                "RemoteTransport.__init__, but these parameters are mutally "
-                "exclusive." % (_from_transport, medium))
+                                                                  credentials)
 
         if _client is None:
-            self._client = client._SmartClient(medium)
+            self._client = client._SmartClient(self.get_shared_medium())
         else:
             self._client = _client
 
@@ -131,17 +130,19 @@
 
     def is_readonly(self):
         """Smart server transport can do read/write file operations."""
-        try:
-            resp = self._call2('Transport.is_readonly')
-        except errors.UnknownSmartMethod:
+        resp = self._call2('Transport.is_readonly')
+        if resp == ('yes', ):
+            return True
+        elif resp == ('no', ):
+            return False
+        elif (resp == ('error', "Generic bzr smart protocol error: "
+                                "bad request 'Transport.is_readonly'") or
+              resp == ('error', "Generic bzr smart protocol error: "
+                                "bad request u'Transport.is_readonly'")):
             # XXX: nasty hack: servers before 0.16 don't have a
             # 'Transport.is_readonly' verb, so we do what clients before 0.16
             # did: assume False.
             return False
-        if resp == ('yes', ):
-            return True
-        elif resp == ('no', ):
-            return False
         else:
             self._translate_error(resp)
         raise errors.UnexpectedSmartServerResponse(resp)
@@ -152,7 +153,6 @@
     def get_smart_medium(self):
         return self._get_connection()
 
-    @deprecated_method(one_four)
     def get_shared_medium(self):
         return self._get_shared_connection()
 
@@ -161,25 +161,16 @@
         return self._combine_paths(self._path, relpath)
 
     def _call(self, method, *args):
-        try:
-            resp = self._call2(method, *args)
-        except errors.ErrorFromSmartServer, err:
-            self._translate_error(err.error_tuple)
+        resp = self._call2(method, *args)
         self._translate_error(resp)
 
     def _call2(self, method, *args):
         """Call a method on the remote server."""
-        try:
-            return self._client.call(method, *args)
-        except errors.ErrorFromSmartServer, err:
-            self._translate_error(err.error_tuple)
+        return self._client.call(method, *args)
 
     def _call_with_body_bytes(self, method, args, body):
         """Call a method on the remote server with body bytes."""
-        try:
-            return self._client.call_with_body_bytes(method, args, body)
-        except errors.ErrorFromSmartServer, err:
-            self._translate_error(err.error_tuple)
+        return self._client.call_with_body_bytes(method, args, body)
 
     def has(self, relpath):
         """Indicate whether a remote file of the given name exists or not.
@@ -203,14 +194,14 @@
 
     def get_bytes(self, relpath):
         remote = self._remote_path(relpath)
-        try:
-            resp, response_handler = self._client.call_expecting_body('get', remote)
-        except errors.ErrorFromSmartServer, err:
-            self._translate_error(err.error_tuple, relpath)
+        request = self.get_smart_medium().get_request()
+        smart_protocol = protocol.SmartClientRequestProtocolOne(request)
+        smart_protocol.call('get', remote)
+        resp = smart_protocol.read_response_tuple(True)
         if resp != ('ok', ):
-            response_handler.cancel_read_body()
-            raise errors.UnexpectedSmartServerResponse(resp)
-        return response_handler.read_body_bytes()
+            smart_protocol.cancel_read_body()
+            self._translate_error(resp, relpath)
+        return smart_protocol.read_body_bytes()
 
     def _serialise_optional_mode(self, mode):
         if mode is None:
@@ -301,10 +292,6 @@
         # the external path for RemoteTransports is the base
         return self.base
 
-    def recommended_page_size(self):
-        """Return the recommended page size for this transport."""
-        return 64 * 1024
-        
     def _readv(self, relpath, offsets):
         if not offsets:
             return
@@ -312,55 +299,38 @@
         offsets = list(offsets)
 
         sorted_offsets = sorted(offsets)
+        # turn the list of offsets into a stack
+        offset_stack = iter(offsets)
+        cur_offset_and_size = offset_stack.next()
         coalesced = list(self._coalesce_offsets(sorted_offsets,
                                limit=self._max_readv_combine,
                                fudge_factor=self._bytes_to_read_before_seek))
 
-        try:
-            result = self._client.call_with_body_readv_array(
-                ('readv', self._remote_path(relpath),),
-                [(c.start, c.length) for c in coalesced])
-            resp, response_handler = result
-        except errors.ErrorFromSmartServer, err:
-            self._translate_error(err.error_tuple)
+        request = self.get_smart_medium().get_request()
+        smart_protocol = protocol.SmartClientRequestProtocolOne(request)
+        smart_protocol.call_with_body_readv_array(
+            ('readv', self._remote_path(relpath)),
+            [(c.start, c.length) for c in coalesced])
+        resp = smart_protocol.read_response_tuple(True)
 
         if resp[0] != 'readv':
             # This should raise an exception
-            response_handler.cancel_read_body()
-            raise errors.UnexpectedSmartServerResponse(resp)
-
-        return self._handle_response(offsets, coalesced, response_handler)
-
-    def _handle_response(self, offsets, coalesced, response_handler):
-        # turn the list of offsets into a stack
-        offset_stack = iter(offsets)
-        cur_offset_and_size = offset_stack.next()
+            smart_protocol.cancel_read_body()
+            self._translate_error(resp)
+            return
+
         # FIXME: this should know how many bytes are needed, for clarity.
-        data = response_handler.read_body_bytes()
+        data = smart_protocol.read_body_bytes()
         # Cache the results, but only until they have been fulfilled
         data_map = {}
-        data_offset = 0
         for c_offset in coalesced:
             if len(data) < c_offset.length:
                 raise errors.ShortReadvError(relpath, c_offset.start,
                             c_offset.length, actual=len(data))
             for suboffset, subsize in c_offset.ranges:
                 key = (c_offset.start+suboffset, subsize)
-                this_data = data[data_offset+suboffset:
-                                 data_offset+suboffset+subsize]
-                # Special case when the data is in-order, rather than packing
-                # into a map and then back out again. Benchmarking shows that
-                # this has 100% hit rate, but leave in the data_map work just
-                # in case.
-                # TODO: Could we get away with using buffer() to avoid the
-                #       memory copy?  Callers would need to realize they may
-                #       not have a real string.
-                if key == cur_offset_and_size:
-                    yield cur_offset_and_size[0], this_data
-                    cur_offset_and_size = offset_stack.next()
-                else:
-                    data_map[key] = this_data
-            data_offset += c_offset.length
+                data_map[key] = data[suboffset:suboffset+subsize]
+            data = data[c_offset.length:]
 
             # Now that we've read some data, see if we can yield anything back
             while cur_offset_and_size in data_map:
@@ -426,18 +396,15 @@
             else:
                 error_path = resp[1]
             raise errors.ReadError(error_path)
-        elif what == "PermissionDenied":
-            if orig_path is not None:
-                error_path = orig_path
-            else:
-                error_path = resp[1]
-            raise errors.PermissionDenied(error_path)
         else:
             raise errors.SmartProtocolError('unexpected smart server error: %r' % (resp,))
 
     def disconnect(self):
         self.get_smart_medium().disconnect()
 
+    def delete_tree(self, relpath):
+        raise errors.TransportNotPossible('readonly transport')
+
     def stat(self, relpath):
         resp = self._call2('stat', self._remote_path(relpath))
         if resp[0] == 'stat':
@@ -484,24 +451,8 @@
     """
 
     def _build_medium(self):
-        client_medium = medium.SmartTCPClientMedium(
-            self._host, self._port, self.base)
-        return client_medium, None
-
-
-class RemoteTCPTransportV2Only(RemoteTransport):
-    """Connection to smart server over plain tcp with the client hard-coded to
-    assume protocol v2 and remote server version <= 1.6.
-
-    This should only be used for testing.
-    """
-
-    def _build_medium(self):
-        client_medium = medium.SmartTCPClientMedium(
-            self._host, self._port, self.base)
-        client_medium._protocol_version = 2
-        client_medium._remember_remote_is_before((1, 6))
-        return client_medium, None
+        assert self.base.startswith('bzr://')
+        return medium.SmartTCPClientMedium(self._host, self._port), None
 
 
 class RemoteSSHTransport(RemoteTransport):
@@ -512,15 +463,14 @@
     """
 
     def _build_medium(self):
+        assert self.base.startswith('bzr+ssh://')
         # ssh will prompt the user for a password if needed and if none is
         # provided but it will not give it back, so no credentials can be
         # stored.
         location_config = config.LocationConfig(self.base)
         bzr_remote_path = location_config.get_bzr_remote_path()
-        client_medium = medium.SmartSSHClientMedium(self._host, self._port,
-            self._user, self._password, self.base,
-            bzr_remote_path=bzr_remote_path)
-        return client_medium, None
+        return medium.SmartSSHClientMedium(self._host, self._port,
+            self._user, self._password, bzr_remote_path=bzr_remote_path), None
 
 
 class RemoteHTTPTransport(RemoteTransport):
@@ -535,6 +485,8 @@
     """
 
     def __init__(self, base, _from_transport=None, http_transport=None):
+        assert ( base.startswith('bzr+http://') or base.startswith('bzr+https://') )
+
         if http_transport is None:
             # FIXME: the password may be lost here because it appears in the
             # url only for an intial construction (when the url came from the
@@ -554,7 +506,7 @@
         """After connecting, HTTP Transport only deals in relative URLs."""
         # Adjust the relpath based on which URL this smart transport is
         # connected to.
-        http_base = urlutils.normalize_url(self.get_smart_medium().base)
+        http_base = urlutils.normalize_url(self._http_transport.base)
         url = urlutils.join(self.base[len('bzr+'):], relpath)
         url = urlutils.normalize_url(url)
         return urlutils.relative_url(http_base, url)
@@ -571,14 +523,26 @@
         smart requests may be different).  This is so that the server doesn't
         have to handle .bzr/smart requests at arbitrary places inside .bzr
         directories, just at the initial URL the user uses.
+
+        The exception is parent paths (i.e. relative_url of "..").
         """
         if relative_url:
             abs_url = self.abspath(relative_url)
         else:
             abs_url = self.base
+        # We either use the exact same http_transport (for child locations), or
+        # a clone of the underlying http_transport (for parent locations).  This
+        # means we share the connection.
+        norm_base = urlutils.normalize_url(self.base)
+        norm_abs_url = urlutils.normalize_url(abs_url)
+        normalized_rel_url = urlutils.relative_url(norm_base, norm_abs_url)
+        if normalized_rel_url == ".." or normalized_rel_url.startswith("../"):
+            http_transport = self._http_transport.clone(normalized_rel_url)
+        else:
+            http_transport = self._http_transport
         return RemoteHTTPTransport(abs_url,
                                    _from_transport=self,
-                                   http_transport=self._http_transport)
+                                   http_transport=http_transport)
 
 
 def get_test_permutations():

=== modified file 'bzrlib/transport/sftp.py'
--- bzrlib/transport/sftp.py	2008-07-18 19:51:08 +0000
+++ bzrlib/transport/sftp.py	2007-10-04 05:09:58 +0000
@@ -50,12 +50,14 @@
 from bzrlib.osutils import pathjoin, fancy_rename, getcwd
 from bzrlib.symbol_versioning import (
         deprecated_function,
+        zero_ninety,
         )
 from bzrlib.trace import mutter, warning
 from bzrlib.transport import (
     FileFileStream,
     _file_streams,
     local,
+    register_urlparse_netloc_protocol,
     Server,
     ssh,
     ConnectedTransport,
@@ -86,11 +88,22 @@
     from paramiko.sftp_file import SFTPFile
 
 
+register_urlparse_netloc_protocol('sftp')
+
+
 _paramiko_version = getattr(paramiko, '__version_info__', (0, 0, 0))
 # don't use prefetch unless paramiko version >= 1.5.5 (there were bugs earlier)
 _default_do_prefetch = (_paramiko_version >= (1, 5, 5))
 
 
+@deprecated_function(zero_ninety)
+def clear_connection_cache():
+    """Remove all hosts from the SFTP connection cache.
+
+    Primarily useful for test cases wanting to force garbage collection.
+    We don't have a global connection cache anymore.
+    """
+
 class SFTPLock(object):
     """This fakes a lock in a remote location.
     
@@ -102,6 +115,8 @@
     __slots__ = ['path', 'lock_path', 'lock_file', 'transport']
 
     def __init__(self, path, transport):
+        assert isinstance(transport, SFTPTransport)
+
         self.lock_file = None
         self.path = path
         self.lock_path = path + '.write-lock'
@@ -153,6 +168,7 @@
     _max_request_size = 32768
 
     def __init__(self, base, _from_transport=None):
+        assert base.startswith('sftp://')
         super(SFTPTransport, self).__init__(base,
                                             _from_transport=_from_transport)
 
@@ -334,10 +350,9 @@
 
             if cur_data_len < cur_coalesced.length:
                 continue
-            if cur_data_len != cur_coalesced.length:
-                raise AssertionError(
-                    "Somehow we read too much: %s != %s" 
-                    % (cur_data_len, cur_coalesced.length))
+            assert cur_data_len == cur_coalesced.length, \
+                "Somehow we read too much: %s != %s" % (cur_data_len,
+                                                        cur_coalesced.length)
             all_data = ''.join(cur_data)
             cur_data = []
             cur_data_len = 0
@@ -519,21 +534,7 @@
         try:
             self._get_sftp().mkdir(abspath, local_mode)
             if mode is not None:
-                # chmod a dir through sftp will erase any sgid bit set
-                # on the server side.  So, if the bit mode are already
-                # set, avoid the chmod.  If the mode is not fine but
-                # the sgid bit is set, report a warning to the user
-                # with the umask fix.
-                stat = self._get_sftp().lstat(abspath)
-                mode = mode & 0777 # can't set special bits anyway
-                if mode != stat.st_mode & 0777:
-                    if stat.st_mode & 06000:
-                        warning('About to chmod %s over sftp, which will result'
-                                ' in its suid or sgid bits being cleared.  If'
-                                ' you want to preserve those bits, change your '
-                                ' environment on the server to use umask 0%03o.'
-                                % (abspath, 0777 - mode))
-                    self._get_sftp().chmod(abspath, mode=mode)
+                self._get_sftp().chmod(abspath, mode=mode)
         except (paramiko.SSHException, IOError), e:
             self._translate_io_exception(e, abspath, ': unable to mkdir',
                 failure_exc=FileExists)
@@ -584,8 +585,7 @@
             if (e.args == ('No such file or directory',) or
                 e.args == ('No such file',)):
                 raise NoSuchFile(path, str(e) + more_info)
-            if (e.args == ('mkdir failed',) or
-                e.args[0].startswith('syserr: File exists')):
+            if (e.args == ('mkdir failed',)):
                 raise FileExists(path, str(e) + more_info)
             # strange but true, for the paramiko server.
             if (e.args == ('Failure',)):
@@ -952,11 +952,10 @@
     def setUp(self, backing_server=None):
         # XXX: TODO: make sftpserver back onto backing_server rather than local
         # disk.
-        if not (backing_server is None or
-                isinstance(backing_server, local.LocalURLServer)):
-            raise AssertionError(
-                "backing_server should not be %r, because this can only serve the "
-                "local current working directory." % (backing_server,))
+        assert (backing_server is None or
+                isinstance(backing_server, local.LocalURLServer)), (
+            "backing_server should not be %r, because this can only serve the "
+            "local current working directory." % (backing_server,))
         self._original_vendor = ssh._ssh_vendor_manager._cached_ssh_vendor
         ssh._ssh_vendor_manager._cached_ssh_vendor = self._vendor
         if sys.platform == 'win32':
@@ -1024,12 +1023,10 @@
             def close(self):
                 pass
 
-        server = paramiko.SFTPServer(
-            FakeChannel(), 'sftp', StubServer(self), StubSFTPServer,
-            root=self._root, home=self._server_homedir)
+        server = paramiko.SFTPServer(FakeChannel(), 'sftp', StubServer(self), StubSFTPServer,
+                                     root=self._root, home=self._server_homedir)
         try:
-            server.start_subsystem(
-                'sftp', None, ssh.SocketAsChannelAdapter(sock))
+            server.start_subsystem('sftp', None, sock)
         except socket.error, e:
             if (len(e.args) > 0) and (e.args[0] == errno.EPIPE):
                 # it's okay for the client to disconnect abruptly

=== modified file 'bzrlib/transport/ssh.py'
--- bzrlib/transport/ssh.py	2008-04-24 07:22:53 +0000
+++ bzrlib/transport/ssh.py	2007-10-23 07:25:41 +0000
@@ -132,7 +132,7 @@
 
     def _get_vendor_by_inspection(self):
         """Return the vendor or None by checking for known SSH implementations."""
-        for args in (['ssh', '-V'], ['plink', '-V']):
+        for args in [['ssh', '-V'], ['plink', '-V']]:
             version = self._get_ssh_version_string(args)
             vendor = self._get_vendor_by_version_string(version, args)
             if vendor is not None:
@@ -172,34 +172,19 @@
     signal.signal(signal.SIGINT, signal.SIG_IGN)
 
 
-class SocketAsChannelAdapter(object):
+class LoopbackSFTP(object):
     """Simple wrapper for a socket that pretends to be a paramiko Channel."""
 
     def __init__(self, sock):
         self.__socket = sock
 
-    def get_name(self):
-        return "bzr SocketAsChannelAdapter"
-    
     def send(self, data):
         return self.__socket.send(data)
 
     def recv(self, n):
-        try:
-            return self.__socket.recv(n)
-        except socket.error, e:
-            if e.args[0] in (errno.EPIPE, errno.ECONNRESET, errno.ECONNABORTED,
-                             errno.EBADF):
-                # Connection has closed.  Paramiko expects an empty string in
-                # this case, not an exception.
-                return ''
-            raise
+        return self.__socket.recv(n)
 
     def recv_ready(self):
-        # TODO: jam 20051215 this function is necessary to support the
-        # pipelined() function. In reality, it probably should use
-        # poll() or select() to actually return if there is data
-        # available, otherwise we probably don't get any benefit
         return True
 
     def close(self):
@@ -252,7 +237,7 @@
             sock.connect((host, port))
         except socket.error, e:
             self._raise_connection_error(host, port=port, orig_error=e)
-        return SFTPClient(SocketAsChannelAdapter(sock))
+        return SFTPClient(LoopbackSFTP(sock))
 
 register_ssh_vendor('loopback', LoopbackVendor())
 
@@ -341,10 +326,7 @@
     register_ssh_vendor('paramiko', vendor)
     register_ssh_vendor('none', vendor)
     register_default_ssh_vendor(vendor)
-    _sftp_connection_errors = (EOFError, paramiko.SSHException)
     del vendor
-else:
-    _sftp_connection_errors = (EOFError,)
 
 
 class SubprocessVendor(SSHVendor):
@@ -362,8 +344,8 @@
             argv = self._get_vendor_specific_argv(username, host, port,
                                                   subsystem='sftp')
             sock = self._connect(argv)
-            return SFTPClient(SocketAsChannelAdapter(sock))
-        except _sftp_connection_errors, e:
+            return SFTPClient(sock)
+        except (EOFError, paramiko.SSHException), e:
             self._raise_connection_error(host, port=port, orig_error=e)
         except (OSError, IOError), e:
             # If the machine is fast enough, ssh can actually exit
@@ -402,6 +384,11 @@
 
     def _get_vendor_specific_argv(self, username, host, port, subsystem=None,
                                   command=None):
+        assert subsystem is not None or command is not None, (
+            'Must specify a command or subsystem')
+        if subsystem is not None:
+            assert command is None, (
+                'subsystem and command are mutually exclusive')
         args = ['ssh',
                 '-oForwardX11=no', '-oForwardAgent=no',
                 '-oClearAllForwardings=yes', '-oProtocol=2',
@@ -424,6 +411,11 @@
 
     def _get_vendor_specific_argv(self, username, host, port, subsystem=None,
                                   command=None):
+        assert subsystem is not None or command is not None, (
+            'Must specify a command or subsystem')
+        if subsystem is not None:
+            assert command is None, (
+                'subsystem and command are mutually exclusive')
         args = ['ssh', '-x']
         if port is not None:
             args.extend(['-p', str(port)])
@@ -443,7 +435,12 @@
 
     def _get_vendor_specific_argv(self, username, host, port, subsystem=None,
                                   command=None):
-        args = ['plink', '-x', '-a', '-ssh', '-2', '-batch']
+        assert subsystem is not None or command is not None, (
+            'Must specify a command or subsystem')
+        if subsystem is not None:
+            assert command is None, (
+                'subsystem and command are mutually exclusive')
+        args = ['plink', '-x', '-a', '-ssh', '-2']
         if port is not None:
             args.extend(['-P', str(port)])
         if username is not None:
@@ -601,6 +598,13 @@
     def send(self, data):
         return os.write(self.proc.stdin.fileno(), data)
 
+    def recv_ready(self):
+        # TODO: jam 20051215 this function is necessary to support the
+        # pipelined() function. In reality, it probably should use
+        # poll() or select() to actually return if there is data
+        # available, otherwise we probably don't get any benefit
+        return True
+
     def recv(self, count):
         return os.read(self.proc.stdout.fileno(), count)
 

=== modified file 'bzrlib/transport/trace.py'
--- bzrlib/transport/trace.py	2008-09-02 04:34:23 +0000
+++ bzrlib/transport/trace.py	2007-10-04 04:59:43 +0000
@@ -33,6 +33,10 @@
     Not all operations are logged at this point, if you need an unlogged
     operation please add a test to the tests of this transport, for the logging
     of the operation you want logged.
+
+    Another future enhancement would be to log to bzrlib.trace.mutter when
+    trace+ is used from the command line (or perhaps as well/instead use
+    -Dtransport), to make tracing operations of the entire program easily.
     """
 
     def __init__(self, url, _decorated=None, _from_transport=None):
@@ -58,7 +62,6 @@
 
     def delete(self, relpath):
         """See Transport.delete()."""
-        self._activity.append(('delete', relpath))
         return self._decorated.delete(relpath)
 
     def delete_tree(self, relpath):
@@ -72,7 +75,7 @@
 
     def get(self, relpath):
         """See Transport.get()."""
-        self._trace(('get', relpath))
+        self._activity.append(('get', relpath))
         return self._decorated.get(relpath)
 
     def get_smart_client(self):
@@ -88,7 +91,6 @@
 
     def mkdir(self, relpath, mode=None):
         """See Transport.mkdir()."""
-        self._trace(('mkdir', relpath, mode))
         return self._decorated.mkdir(relpath, mode)
 
     def open_write_stream(self, relpath, mode=None):
@@ -101,7 +103,7 @@
     
     def put_bytes(self, relpath, bytes, mode=None):
         """See Transport.put_bytes()."""
-        self._trace(('put_bytes', relpath, len(bytes), mode))
+        self._activity.append(('put_bytes', relpath, len(bytes), mode))
         return self._decorated.put_bytes(relpath, bytes, mode)
 
     def listable(self):
@@ -119,7 +121,7 @@
     def readv(self, relpath, offsets, adjust_for_latency=False,
         upper_limit=None):
         """See Transport.readv."""
-        self._trace(('readv', relpath, offsets, adjust_for_latency,
+        self._activity.append(('readv', relpath, offsets, adjust_for_latency,
             upper_limit))
         return self._decorated.readv(relpath, offsets, adjust_for_latency,
             upper_limit)
@@ -129,7 +131,6 @@
         return self._decorated.recommended_page_size()
 
     def rename(self, rel_from, rel_to):
-        self._activity.append(('rename', rel_from, rel_to))
         return self._decorated.rename(rel_from, rel_to)
     
     def rmdir(self, relpath):
@@ -148,13 +149,6 @@
         """See Transport.lock_write."""
         return self._decorated.lock_write(relpath)
 
-    def _trace(self, operation_tuple):
-        """Record that a transport operation occured.
-
-        :param operation: Tuple of transport call name and arguments.
-        """
-        self._activity.append(operation_tuple)
-
 
 class TraceServer(DecoratorServer):
     """Server for the TransportTraceDecorator for testing with."""

=== modified file 'bzrlib/tree.py'
--- bzrlib/tree.py	2008-08-14 17:25:43 +0000
+++ bzrlib/tree.py	2007-10-08 07:29:57 +0000
@@ -23,11 +23,10 @@
 
 import bzrlib
 from bzrlib import (
-    conflicts as _mod_conflicts,
     delta,
     osutils,
     revision as _mod_revision,
-    rules,
+    conflicts as _mod_conflicts,
     symbol_versioning,
     )
 from bzrlib.decorators import needs_read_lock
@@ -94,15 +93,11 @@
             want_unversioned=want_unversioned,
             )
 
-    @symbol_versioning.deprecated_method(symbol_versioning.one_three)
-    def _iter_changes(self, *args, **kwargs):
-        return self.iter_changes(*args, **kwargs)
-
-    def iter_changes(self, from_tree, include_unchanged=False,
+    def _iter_changes(self, from_tree, include_unchanged=False,
                      specific_files=None, pb=None, extra_trees=None,
                      require_versioned=True, want_unversioned=False):
         intertree = InterTree.get(from_tree, self)
-        return intertree.iter_changes(include_unchanged, specific_files, pb,
+        return intertree._iter_changes(include_unchanged, specific_files, pb,
             extra_trees, require_versioned, want_unversioned=want_unversioned)
     
     def conflicts(self):
@@ -150,10 +145,6 @@
     def __iter__(self):
         return iter(self.inventory)
 
-    def all_file_ids(self):
-        """Iterate through all file ids, including ids for missing files."""
-        return set(self.inventory)
-
     def id2path(self, file_id):
         """Return the path for a file id.
 
@@ -177,26 +168,10 @@
     def iter_entries_by_dir(self, specific_file_ids=None):
         """Walk the tree in 'by_dir' order.
 
-        This will yield each entry in the tree as a (path, entry) tuple.
-        The order that they are yielded is:
-
-        Directories are walked in a depth-first lexicographical order,
-        however, whenever a directory is reached, all of its direct child
-        nodes are yielded in  lexicographical order before yielding the
-        grandchildren.
-
-        For example, in the tree::
-
-           a/
-             b/
-               c
-             d/
-               e
-           f/
-             g
-
-        The yield order (ignoring root) would be::
-          a, f, a/b, a/d, a/b/c, a/d/e, f/g
+        This will yield each entry in the tree as a (path, entry) tuple. The
+        order that they are yielded is: the contents of a directory are 
+        preceeded by the parent of a directory, and all the contents of a 
+        directory are grouped together.
         """
         return self.inventory.iter_entries_by_dir(
             specific_file_ids=specific_file_ids)
@@ -210,14 +185,6 @@
         raise NotImplementedError("Tree subclass %s must implement kind"
             % self.__class__.__name__)
 
-    def stored_kind(self, file_id):
-        """File kind stored for this file_id.
-
-        May not match kind on disk for working trees.  Always available
-        for versioned files, even when the file itself is missing.
-        """
-        return self.kind(file_id)
-
     def path_content_summary(self, path):
         """Get a summary of the information about path.
         
@@ -271,15 +238,6 @@
         """
         raise NotImplementedError(self.get_file_mtime)
 
-    def get_file_size(self, file_id):
-        """Return the size of a file in bytes.
-
-        This applies only to regular files.  If invoked on directories or
-        symlinks, it will return None.
-        :param file_id: The file-id of the file
-        """
-        raise NotImplementedError(self.get_file_size)
-
     def get_file_by_path(self, path):
         return self.get_file(self._inventory.path2id(path), path)
 
@@ -319,36 +277,17 @@
         """
         raise NotImplementedError(self.get_symlink_target)
 
-    def get_root_id(self):
-        """Return the file_id for the root of this tree."""
-        raise NotImplementedError(self.get_root_id)
-
-    def annotate_iter(self, file_id,
-                      default_revision=_mod_revision.CURRENT_REVISION):
+    def annotate_iter(self, file_id):
         """Return an iterator of revision_id, line tuples.
 
         For working trees (and mutable trees in general), the special
         revision_id 'current:' will be used for lines that are new in this
         tree, e.g. uncommitted changes.
         :param file_id: The file to produce an annotated version from
-        :param default_revision: For lines that don't match a basis, mark them
-            with this revision id. Not all implementations will make use of
-            this value.
         """
         raise NotImplementedError(self.annotate_iter)
 
-    def _get_plan_merge_data(self, file_id, other, base):
-        from bzrlib import merge, versionedfile
-        vf = versionedfile._PlanMergeVersionedFile(file_id)
-        last_revision_a = self._get_file_revision(file_id, vf, 'this:')
-        last_revision_b = other._get_file_revision(file_id, vf, 'other:')
-        if base is None:
-            last_revision_base = None
-        else:
-            last_revision_base = base._get_file_revision(file_id, vf, 'base:')
-        return vf, last_revision_a, last_revision_b, last_revision_base
-
-    def plan_file_merge(self, file_id, other, base=None):
+    def plan_file_merge(self, file_id, other):
         """Generate a merge plan based on annotations.
 
         If the file contains uncommitted changes in this tree, they will be
@@ -356,58 +295,14 @@
         uncommitted changes in the other tree, they will be assigned to the
         'other:' pseudo-revision.
         """
-        data = self._get_plan_merge_data(file_id, other, base)
-        vf, last_revision_a, last_revision_b, last_revision_base = data
-        return vf.plan_merge(last_revision_a, last_revision_b,
-                             last_revision_base)
-
-    def plan_file_lca_merge(self, file_id, other, base=None):
-        """Generate a merge plan based lca-newness.
-
-        If the file contains uncommitted changes in this tree, they will be
-        attributed to the 'current:' pseudo-revision.  If the file contains
-        uncommitted changes in the other tree, they will be assigned to the
-        'other:' pseudo-revision.
-        """
-        data = self._get_plan_merge_data(file_id, other, base)
-        vf, last_revision_a, last_revision_b, last_revision_base = data
-        return vf.plan_lca_merge(last_revision_a, last_revision_b,
-                                 last_revision_base)
-
-    def _iter_parent_trees(self):
-        """Iterate through parent trees, defaulting to Tree.revision_tree."""
-        for revision_id in self.get_parent_ids():
-            try:
-                yield self.revision_tree(revision_id)
-            except errors.NoSuchRevisionInTree:
-                yield self.repository.revision_tree(revision_id)
-
-    @staticmethod
-    def _file_revision(revision_tree, file_id):
-        """Determine the revision associated with a file in a given tree."""
-        revision_tree.lock_read()
-        try:
-            return revision_tree.inventory[file_id].revision
-        finally:
-            revision_tree.unlock()
-
-    def _get_file_revision(self, file_id, vf, tree_revision):
-        """Ensure that file_id, tree_revision is in vf to plan the merge."""
-
-        if getattr(self, '_repository', None) is None:
-            last_revision = tree_revision
-            parent_keys = [(file_id, self._file_revision(t, file_id)) for t in
-                self._iter_parent_trees()]
-            vf.add_lines((file_id, last_revision), parent_keys,
-                         self.get_file(file_id).readlines())
-            repo = self.branch.repository
-            base_vf = repo.texts
-        else:
-            last_revision = self._file_revision(self, file_id)
-            base_vf = self._repository.texts
-        if base_vf not in vf.fallback_versionedfiles:
-            vf.fallback_versionedfiles.append(base_vf)
-        return last_revision
+        from bzrlib import merge
+        annotated_a = list(self.annotate_iter(file_id,
+                                              _mod_revision.CURRENT_REVISION))
+        annotated_b = list(other.annotate_iter(file_id, 'other:'))
+        ancestors_a = self._get_ancestors(_mod_revision.CURRENT_REVISION)
+        ancestors_b = other._get_ancestors('other:')
+        return merge._plan_annotate_merge(annotated_a, annotated_b,
+                                          ancestors_a, ancestors_b)
 
     inventory = property(_get_inventory,
                          doc="Inventory of this Tree")
@@ -455,7 +350,6 @@
         """
         return find_ids_across_trees(paths, [self] + list(trees), require_versioned)
 
-    @symbol_versioning.deprecated_method(symbol_versioning.one_six)
     def print_file(self, file_id):
         """Print file with id `file_id` to stdout."""
         import sys
@@ -533,32 +427,6 @@
         """
         raise NotImplementedError(self.walkdirs)
 
-    def iter_search_rules(self, path_names, pref_names=None,
-        _default_searcher=rules._per_user_searcher):
-        """Find the preferences for filenames in a tree.
-
-        :param path_names: an iterable of paths to find attributes for.
-          Paths are given relative to the root of the tree.
-        :param pref_names: the list of preferences to lookup - None for all
-        :param _default_searcher: private parameter to assist testing - don't use
-        :return: an iterator of tuple sequences, one per path-name.
-          See _RulesSearcher.get_items for details on the tuple sequence.
-        """
-        searcher = self._get_rules_searcher(_default_searcher)
-        if searcher is not None:
-            if pref_names is not None:
-                for path in path_names:
-                    yield searcher.get_selected_items(path, pref_names)
-            else:
-                for path in path_names:
-                    yield searcher.get_items(path)
-
-    @needs_read_lock
-    def _get_rules_searcher(self, default_searcher):
-        """Get the RulesSearcher for this tree given the default one."""
-        searcher = default_searcher
-        return searcher
-
 
 class EmptyTree(Tree):
 
@@ -578,6 +446,7 @@
         return False
 
     def kind(self, file_id):
+        assert self._inventory[file_id].kind == "directory"
         return "directory"
 
     def list_files(self, include_root=False):
@@ -626,6 +495,7 @@
         # what happened to the file that used to have
         # this name.  There are two possibilities: either it was
         # deleted entirely, or renamed.
+        assert old_id
         if new_inv.has_id(old_id):
             return 'X', old_inv.id2path(old_id), new_inv.id2path(old_id)
         else:
@@ -783,7 +653,7 @@
             require_versioned=require_versioned,
             want_unversioned=want_unversioned)
 
-    def iter_changes(self, include_unchanged=False,
+    def _iter_changes(self, include_unchanged=False,
                       specific_files=None, pb=None, extra_trees=[],
                       require_versioned=True, want_unversioned=False):
         """Generate an iterator of changes between trees.
@@ -948,240 +818,21 @@
                 self.source._comparison_data(from_entry, path)
             kind = (from_kind, None)
             executable = (from_executable, None)
-            changed_content = from_kind is not None
+            changed_content = True
             # the parent's path is necessarily known at this point.
             yield(file_id, (path, to_path), changed_content, versioned, parent,
                   name, kind, executable)
 
 
-class MultiWalker(object):
-    """Walk multiple trees simultaneously, getting combined results."""
-
-    # Note: This could be written to not assume you can do out-of-order
-    #       lookups. Instead any nodes that don't match in all trees could be
-    #       marked as 'deferred', and then returned in the final cleanup loop.
-    #       For now, I think it is "nicer" to return things as close to the
-    #       "master_tree" order as we can.
-
-    def __init__(self, master_tree, other_trees):
-        """Create a new MultiWalker.
-
-        All trees being walked must implement "iter_entries_by_dir()", such
-        that they yield (path, object) tuples, where that object will have a
-        '.file_id' member, that can be used to check equality.
-
-        :param master_tree: All trees will be 'slaved' to the master_tree such
-            that nodes in master_tree will be used as 'first-pass' sync points.
-            Any nodes that aren't in master_tree will be merged in a second
-            pass.
-        :param other_trees: A list of other trees to walk simultaneously.
-        """
-        self._master_tree = master_tree
-        self._other_trees = other_trees
-
-        # Keep track of any nodes that were properly processed just out of
-        # order, that way we don't return them at the end, we don't have to
-        # track *all* processed file_ids, just the out-of-order ones
-        self._out_of_order_processed = set()
-
-    @staticmethod
-    def _step_one(iterator):
-        """Step an iter_entries_by_dir iterator.
-
-        :return: (has_more, path, ie)
-            If has_more is False, path and ie will be None.
-        """
-        try:
-            path, ie = iterator.next()
-        except StopIteration:
-            return False, None, None
-        else:
-            return True, path, ie
-
-    @staticmethod
-    def _cmp_path_by_dirblock(path1, path2):
-        """Compare two paths based on what directory they are in.
-
-        This generates a sort order, such that all children of a directory are
-        sorted together, and grandchildren are in the same order as the
-        children appear. But all grandchildren come after all children.
-
-        :param path1: first path
-        :param path2: the second path
-        :return: negative number if ``path1`` comes first,
-            0 if paths are equal
-            and a positive number if ``path2`` sorts first
-        """
-        # Shortcut this special case
-        if path1 == path2:
-            return 0
-        # This is stolen from _dirstate_helpers_py.py, only switching it to
-        # Unicode objects. Consider using encode_utf8() and then using the
-        # optimized versions, or maybe writing optimized unicode versions.
-        if not isinstance(path1, unicode):
-            raise TypeError("'path1' must be a unicode string, not %s: %r"
-                            % (type(path1), path1))
-        if not isinstance(path2, unicode):
-            raise TypeError("'path2' must be a unicode string, not %s: %r"
-                            % (type(path2), path2))
-        return cmp(MultiWalker._path_to_key(path1),
-                   MultiWalker._path_to_key(path2))
-
-    @staticmethod
-    def _path_to_key(path):
-        dirname, basename = osutils.split(path)
-        return (dirname.split(u'/'), basename)
-
-    def _lookup_by_file_id(self, extra_entries, other_tree, file_id):
-        """Lookup an inventory entry by file_id.
-
-        This is called when an entry is missing in the normal order.
-        Generally this is because a file was either renamed, or it was
-        deleted/added. If the entry was found in the inventory and not in
-        extra_entries, it will be added to self._out_of_order_processed
-
-        :param extra_entries: A dictionary of {file_id: (path, ie)}.  This
-            should be filled with entries that were found before they were
-            used. If file_id is present, it will be removed from the
-            dictionary.
-        :param other_tree: The Tree to search, in case we didn't find the entry
-            yet.
-        :param file_id: The file_id to look for
-        :return: (path, ie) if found or (None, None) if not present.
-        """
-        if file_id in extra_entries:
-            return extra_entries.pop(file_id)
-        # TODO: Is id2path better as the first call, or is
-        #       inventory[file_id] better as a first check?
-        try:
-            cur_path = other_tree.id2path(file_id)
-        except errors.NoSuchId:
-            cur_path = None
-        if cur_path is None:
-            return (None, None)
-        else:
-            self._out_of_order_processed.add(file_id)
-            cur_ie = other_tree.inventory[file_id]
-            return (cur_path, cur_ie)
-
-    def iter_all(self):
-        """Match up the values in the different trees."""
-        for result in self._walk_master_tree():
-            yield result
-        self._finish_others()
-        for result in self._walk_others():
-            yield result
-
-    def _walk_master_tree(self):
-        """First pass, walk all trees in lock-step.
-        
-        When we are done, all nodes in the master_tree will have been
-        processed. _other_walkers, _other_entries, and _others_extra will be
-        set on 'self' for future processing.
-        """
-        # This iterator has the most "inlining" done, because it tends to touch
-        # every file in the tree, while the others only hit nodes that don't
-        # match.
-        master_iterator = self._master_tree.iter_entries_by_dir()
-
-        other_walkers = [other.iter_entries_by_dir()
-                         for other in self._other_trees]
-        other_entries = [self._step_one(walker) for walker in other_walkers]
-        # Track extra nodes in the other trees
-        others_extra = [{} for i in xrange(len(self._other_trees))]
-
-        master_has_more = True
-        step_one = self._step_one
-        lookup_by_file_id = self._lookup_by_file_id
-        out_of_order_processed = self._out_of_order_processed
-
-        while master_has_more:
-            (master_has_more, path, master_ie) = step_one(master_iterator)
-            if not master_has_more:
-                break
-
-            file_id = master_ie.file_id
-            other_values = []
-            other_values_append = other_values.append
-            next_other_entries = []
-            next_other_entries_append = next_other_entries.append
-            for idx, (other_has_more, other_path, other_ie) in enumerate(other_entries):
-                if not other_has_more:
-                    other_values_append(lookup_by_file_id(
-                        others_extra[idx], self._other_trees[idx], file_id))
-                    next_other_entries_append((False, None, None))
-                elif file_id == other_ie.file_id:
-                    # This is the critical code path, as most of the entries
-                    # should match between most trees.
-                    other_values_append((other_path, other_ie))
-                    next_other_entries_append(step_one(other_walkers[idx]))
-                else:
-                    # This walker did not match, step it until it either
-                    # matches, or we know we are past the current walker.
-                    other_walker = other_walkers[idx]
-                    other_extra = others_extra[idx]
-                    while (other_has_more and
-                           self._cmp_path_by_dirblock(other_path, path) < 0):
-                        other_file_id = other_ie.file_id
-                        if other_file_id not in out_of_order_processed:
-                            other_extra[other_file_id] = (other_path, other_ie)
-                        other_has_more, other_path, other_ie = \
-                            step_one(other_walker)
-                    if other_has_more and other_ie.file_id == file_id:
-                        # We ended up walking to this point, match and step
-                        # again
-                        other_values_append((other_path, other_ie))
-                        other_has_more, other_path, other_ie = \
-                            step_one(other_walker)
-                    else:
-                        # This record isn't in the normal order, see if it
-                        # exists at all.
-                        other_values_append(lookup_by_file_id(
-                            other_extra, self._other_trees[idx], file_id))
-                    next_other_entries_append((other_has_more, other_path,
-                                               other_ie))
-            other_entries = next_other_entries
-
-            # We've matched all the walkers, yield this datapoint
-            yield path, file_id, master_ie, other_values
-        self._other_walkers = other_walkers
-        self._other_entries = other_entries
-        self._others_extra = others_extra
-
-    def _finish_others(self):
-        """Finish walking the other iterators, so we get all entries."""
-        for idx, info in enumerate(self._other_entries):
-            other_extra = self._others_extra[idx]
-            (other_has_more, other_path, other_ie) = info
-            while other_has_more:
-                other_file_id = other_ie.file_id
-                if other_file_id not in self._out_of_order_processed:
-                    other_extra[other_file_id] = (other_path, other_ie)
-                other_has_more, other_path, other_ie = \
-                    self._step_one(self._other_walkers[idx])
-        del self._other_entries
-
-    def _walk_others(self):
-        """Finish up by walking all the 'deferred' nodes."""
-        # TODO: One alternative would be to grab all possible unprocessed
-        #       file_ids, and then sort by path, and then yield them. That
-        #       might ensure better ordering, in case a caller strictly
-        #       requires parents before children.
-        for idx, other_extra in enumerate(self._others_extra):
-            others = sorted(other_extra.itervalues(),
-                            key=lambda x: self._path_to_key(x[0]))
-            for other_path, other_ie in others:
-                file_id = other_ie.file_id
-                # We don't need to check out_of_order_processed here, because
-                # the lookup_by_file_id will be removing anything processed
-                # from the extras cache
-                other_extra.pop(file_id)
-                other_values = [(None, None) for i in xrange(idx)]
-                other_values.append((other_path, other_ie))
-                for alt_idx, alt_extra in enumerate(self._others_extra[idx+1:]):
-                    alt_idx = alt_idx + idx + 1
-                    alt_extra = self._others_extra[alt_idx]
-                    alt_tree = self._other_trees[alt_idx]
-                    other_values.append(self._lookup_by_file_id(
-                                            alt_extra, alt_tree, file_id))
-                yield other_path, file_id, None, other_values
+# This was deprecated before 0.12, but did not have an official warning
+@symbol_versioning.deprecated_function(symbol_versioning.zero_twelve)
+def RevisionTree(*args, **kwargs):
+    """RevisionTree has moved to bzrlib.revisiontree.RevisionTree()
+
+    Accessing it as bzrlib.tree.RevisionTree has been deprecated as of
+    bzr 0.12.
+    """
+    from bzrlib.revisiontree import RevisionTree as _RevisionTree
+    return _RevisionTree(*args, **kwargs)
+ 
+

=== modified file 'bzrlib/treebuilder.py'
--- bzrlib/treebuilder.py	2008-04-24 07:22:53 +0000
+++ bzrlib/treebuilder.py	2006-09-22 04:52:17 +0000
@@ -45,6 +45,7 @@
             self._tree.add('', 'root-id', 'directory')
             self._root_done = True
         for name in recipe:
+            assert isinstance(name, basestring)
             if name[-1] == '/':
                 self._tree.mkdir(name[:-1])
             else:

=== modified file 'bzrlib/tsort.py'
--- bzrlib/tsort.py	2008-08-07 22:26:48 +0000
+++ bzrlib/tsort.py	2007-06-21 01:58:29 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2008 Canonical Ltd
+# Copyright (C) 2005, 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -19,7 +19,6 @@
 
 
 from bzrlib import errors
-import bzrlib.revision as _mod_revision
 
 
 __all__ = ["topo_sort", "TopoSorter", "merge_sort", "MergeSorter"]
@@ -193,7 +192,7 @@
     __slots__ = ['_node_name_stack',
                  '_node_merge_depth_stack',
                  '_pending_parents_stack',
-                 '_first_child_stack',
+                 '_assigned_sequence_stack',
                  '_left_subtree_pushed_stack',
                  '_generate_revno',
                  '_graph',
@@ -201,7 +200,7 @@
                  '_stop_revision',
                  '_original_graph',
                  '_revnos',
-                 '_revno_to_branch_count',
+                 '_root_sequence',
                  '_completed_node_names',
                  '_scheduled_nodes',
                 ]
@@ -240,7 +239,7 @@
            found.
          * revno_sequence: When requested this field provides a sequence of
              revision numbers for all revisions. The format is:
-             (REVNO, BRANCHNUM, BRANCHREVNO). BRANCHNUM is the number of the
+             REVNO[[.BRANCHREVNO.REVNO] ...]. BRANCHREVNO is the number of the
              branch that the revno is on. From left to right the REVNO numbers
              are the sequence numbers within that branch of the revision.
              For instance, the graph {A:[], B:['A'], C:['A', 'B']} will get
@@ -351,13 +350,7 @@
             if parent is None:
                 # end of mainline_revisions history
                 continue
-            graph_parent_ids = self._graph[revision]
-            if not graph_parent_ids:
-                # We ran into a ghost, skip over it, this is a workaround for
-                # bug #243536, the _graph has had ghosts stripped, but the
-                # mainline_revisions have not
-                continue
-            if graph_parent_ids[0] == parent:
+            if self._graph[revision][0] == parent:
                 continue
             # remove it from its prior spot
             self._graph[revision].remove(parent)
@@ -369,15 +362,15 @@
         self._original_graph = dict(self._graph.items())
         # we need to know the revision numbers of revisions to determine
         # the revision numbers of their descendants
-        # this is a graph from node to [revno_tuple, first_child]
-        # where first_child is True if no other children have seen this node
+        # this is a graph from node to [revno_tuple, sequence_number]
+        # where sequence is the number of branches made from the node,
         # and revno_tuple is the tuple that was assigned to the node.
         # we dont know revnos to start with, so we start it seeded with
-        # [None, True]
-        self._revnos = dict((revision, [None, True])
-                            for revision in self._graph)
-        # Each mainline revision counts how many child branches have spawned from it.
-        self._revno_to_branch_count = {}
+        # [None, 0]
+        self._revnos = dict((revision, [None, 0]) for revision in self._graph)
+        # the global implicit root node has revno 0, but we need to know
+        # the sequence number for it too:
+        self._root_sequence = 0
         
         # this is a stack storing the depth first search into the graph.
         self._node_name_stack = []
@@ -389,7 +382,7 @@
         self._pending_parents_stack = []
         # When we first look at a node we assign it a seqence number from its
         # leftmost parent.
-        self._first_child_stack = []
+        self._assigned_sequence_stack = []
         # this is a set of the nodes who have been completely analysed for fast
         # membership checking
         self._completed_node_names = set()
@@ -413,8 +406,7 @@
         self._left_subtree_pushed_stack = []
 
         # seed the search with the tip of the branch
-        if (branch_tip is not None and
-            branch_tip != _mod_revision.NULL_REVISION):
+        if branch_tip is not None:
             parents = self._graph.pop(branch_tip)
             self._push_node(branch_tip, 0, parents)
 
@@ -447,7 +439,8 @@
                       node_merge_depth_stack_append=node_merge_depth_stack.append,
                       left_subtree_pushed_stack_append=left_subtree_pushed_stack.append,
                       pending_parents_stack_append=pending_parents_stack.append,
-                      first_child_stack_append=self._first_child_stack.append,
+                      assigned_sequence_stack_append=self._assigned_sequence_stack.append,
+                      original_graph=self._original_graph,
                       revnos=self._revnos,
                       ):
             """Add node_name to the pending node stack.
@@ -462,28 +455,28 @@
             node_merge_depth_stack_append(merge_depth)
             left_subtree_pushed_stack_append(False)
             pending_parents_stack_append(list(parents))
-            # as we push it, check if it is the first child
+            # as we push it, assign it a sequence number against its parent:
+            parents = original_graph[node_name]
             if parents:
                 # node has parents, assign from the left most parent.
-                parent_info = revnos[parents[0]]
-                first_child = parent_info[1]
-                parent_info[1] = False
+                parent_revno = revnos[parents[0]]
+                sequence = parent_revno[1]
+                parent_revno[1] += 1
             else:
-                # We don't use the same algorithm here, but we need to keep the
-                # stack in line
-                first_child = None
-            first_child_stack_append(first_child)
+                # no parents, use the root sequence
+                sequence = self._root_sequence
+                self._root_sequence +=1
+            assigned_sequence_stack_append(sequence)
 
         def pop_node(node_name_stack_pop=node_name_stack.pop,
                      node_merge_depth_stack_pop=node_merge_depth_stack.pop,
-                     first_child_stack_pop=self._first_child_stack.pop,
+                     assigned_sequence_stack_pop=self._assigned_sequence_stack.pop,
                      left_subtree_pushed_stack_pop=left_subtree_pushed_stack.pop,
                      pending_parents_stack_pop=pending_parents_stack.pop,
                      original_graph=self._original_graph,
                      revnos=self._revnos,
                      completed_node_names_add=self._completed_node_names.add,
                      scheduled_nodes_append=scheduled_nodes.append,
-                     revno_to_branch_count=self._revno_to_branch_count,
                     ):
             """Pop the top node off the stack
 
@@ -493,7 +486,7 @@
             # pop off the local variables
             node_name = node_name_stack_pop()
             merge_depth = node_merge_depth_stack_pop()
-            first_child = first_child_stack_pop()
+            sequence = assigned_sequence_stack_pop()
             # remove this node from the pending lists:
             left_subtree_pushed_stack_pop()
             pending_parents_stack_pop()
@@ -501,28 +494,20 @@
             parents = original_graph[node_name]
             if parents:
                 # node has parents, assign from the left most parent.
-                parent_revno = revnos[parents[0]][0]
-                if not first_child:
+                parent_revno = revnos[parents[0]]
+                if sequence:
                     # not the first child, make a new branch
-                    base_revno = parent_revno[0]
-                    branch_count = revno_to_branch_count.get(base_revno, 0)
-                    branch_count += 1
-                    revno_to_branch_count[base_revno] = branch_count
-                    revno = (parent_revno[0], branch_count, 1)
-                    # revno = (parent_revno[0], branch_count, parent_revno[-1]+1)
+                    revno = parent_revno[0] + (sequence, 1)
                 else:
-                    # as the first child, we just increase the final revision
-                    # number
-                    revno = parent_revno[:-1] + (parent_revno[-1] + 1,)
+                    # increment the sequence number within the branch
+                    revno = parent_revno[0][:-1] + (parent_revno[0][-1] + 1,)
             else:
                 # no parents, use the root sequence
-                root_count = revno_to_branch_count.get(0, -1)
-                root_count += 1
-                if root_count:
-                    revno = (0, root_count, 1)
+                if sequence:
+                    # make a parallel import revision number
+                    revno = (0, sequence, 1)
                 else:
                     revno = (1,)
-                revno_to_branch_count[0] = root_count
 
             # store the revno for this node for future reference
             revnos[node_name][0] = revno
@@ -625,18 +610,18 @@
         self._node_merge_depth_stack.append(merge_depth)
         self._left_subtree_pushed_stack.append(False)
         self._pending_parents_stack.append(list(parents))
-        # as we push it, figure out if this is the first child
+        # as we push it, assign it a sequence number against its parent:
         parents = self._original_graph[node_name]
         if parents:
             # node has parents, assign from the left most parent.
-            parent_info = self._revnos[parents[0]]
-            first_child = parent_info[1]
-            parent_info[1] = False
+            parent_revno = self._revnos[parents[0]]
+            sequence = parent_revno[1]
+            parent_revno[1] += 1
         else:
-            # We don't use the same algorithm here, but we need to keep the
-            # stack in line
-            first_child = None
-        self._first_child_stack.append(first_child)
+            # no parents, use the root sequence
+            sequence = self._root_sequence
+            self._root_sequence +=1
+        self._assigned_sequence_stack.append(sequence)
 
     def _pop_node(self):
         """Pop the top node off the stack 
@@ -647,7 +632,7 @@
         # pop off the local variables
         node_name = self._node_name_stack.pop()
         merge_depth = self._node_merge_depth_stack.pop()
-        first_child = self._first_child_stack.pop()
+        sequence = self._assigned_sequence_stack.pop()
         # remove this node from the pending lists:
         self._left_subtree_pushed_stack.pop()
         self._pending_parents_stack.pop()
@@ -655,28 +640,20 @@
         parents = self._original_graph[node_name]
         if parents:
             # node has parents, assign from the left most parent.
-            parent_revno = self._revnos[parents[0]][0]
-            if not first_child:
+            parent_revno = self._revnos[parents[0]]
+            if sequence:
                 # not the first child, make a new branch
-                base_revno = parent_revno[0]
-                branch_count = self._revno_to_branch_count.get(base_revno, 0)
-                branch_count += 1
-                self._revno_to_branch_count[base_revno] = branch_count
-                revno = (parent_revno[0], branch_count, 1)
-                # revno = (parent_revno[0], branch_count, parent_revno[-1]+1)
+                revno = parent_revno[0] + (sequence, 1)
             else:
-                # as the first child, we just increase the final revision
-                # number
-                revno = parent_revno[:-1] + (parent_revno[-1] + 1,)
+                # increment the sequence number within the branch
+                revno = parent_revno[0][:-1] + (parent_revno[0][-1] + 1,)
         else:
             # no parents, use the root sequence
-            root_count = self._revno_to_branch_count.get(0, 0)
-            if root_count:
-                revno = (0, root_count, 1)
+            if sequence:
+                # make a parallel import revision number
+                revno = (0, sequence, 1)
             else:
                 revno = (1,)
-            root_count += 1
-            self._revno_to_branch_count[0] = root_count
 
         # store the revno for this node for future reference
         self._revnos[node_name][0] = revno

=== modified file 'bzrlib/tuned_gzip.py'
--- bzrlib/tuned_gzip.py	2008-04-24 07:22:53 +0000
+++ bzrlib/tuned_gzip.py	2007-09-13 03:16:07 +0000
@@ -149,8 +149,7 @@
 
         if buf == "":
             self._add_read_data(self.decompress.flush())
-            if len(self.decompress.unused_data) < 8:
-                raise AssertionError("what does flush do?")
+            assert len(self.decompress.unused_data) >= 8, "what does flush do?"
             self._gzip_tail = self.decompress.unused_data[0:8]
             self._read_eof()
             # tell the driving read() call we have stuffed all the data
@@ -176,8 +175,7 @@
                 self._gzip_tail = self.decompress.unused_data[0:8]
             elif seek_length < 0:
                 # we haven't read enough to check the checksum.
-                if not (-8 < seek_length):
-                    raise AssertionError("too great a seek")
+                assert -8 < seek_length, "too great a seek."
                 buf = self.fileobj.read(-seek_length)
                 self._gzip_tail = self.decompress.unused_data + buf
             else:
@@ -202,8 +200,7 @@
         # We then check the that the computed CRC and size of the
         # uncompressed data matches the stored values.  Note that the size
         # stored is the true file size mod 2**32.
-        if not (len(self._gzip_tail) == 8):
-            raise AssertionError("gzip trailer is incorrect length.")
+        assert len(self._gzip_tail) == 8, "gzip trailer is incorrect length."
         crc32, isize = struct.unpack("<LL", self._gzip_tail)
         # note that isize is unsigned - it can exceed 2GB
         if crc32 != U32(self.crc):

=== modified file 'bzrlib/ui/__init__.py'
--- bzrlib/ui/__init__.py	2008-03-11 22:15:16 +0000
+++ bzrlib/ui/__init__.py	2007-08-15 04:33:34 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2008 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -14,6 +14,8 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
+
+
 """UI abstraction.
 
 This tells the library how to display things to the user.  Through this
@@ -33,7 +35,6 @@
 import getpass
 
 from bzrlib import (
-    errors,
     osutils,
     progress,
     trace,
@@ -124,8 +125,6 @@
                 return False
 
     def get_non_echoed_password(self, prompt):
-        if not sys.stdin.isatty():
-            raise errors.NotATerminal()
         encoding = osutils.get_terminal_encoding()
         return getpass.getpass(prompt.encode(encoding, 'replace'))
 

=== modified file 'bzrlib/uncommit.py'
--- bzrlib/uncommit.py	2008-05-29 22:15:28 +0000
+++ bzrlib/uncommit.py	2007-07-11 19:44:51 +0000
@@ -20,24 +20,17 @@
 
 import os
 
-from bzrlib import (
-    errors,
-    revision as _mod_revision,
-    )
+from bzrlib import revision as _mod_revision
 from bzrlib.branch import Branch
 from bzrlib.errors import BoundBranchOutOfDate
 
 
-def uncommit(branch, dry_run=False, verbose=False, revno=None, tree=None,
-             local=False):
+def uncommit(branch, dry_run=False, verbose=False, revno=None, tree=None):
     """Remove the last revision from the supplied branch.
 
     :param dry_run: Don't actually change anything
     :param verbose: Print each step as you do it
     :param revno: Remove back to this revision
-    :param local: If this branch is bound, only remove the revisions from the
-        local branch. If this branch is not bound, it is an error to pass
-        local=True.
     """
     unlockable = []
     try:
@@ -52,51 +45,39 @@
         if tree is not None:
             pending_merges = tree.get_parent_ids()[1:]
 
-        if local:
-            master = None
-            if branch.get_bound_location() is None:
-                raise errors.LocalRequiresBoundBranch()
-        else:
-            master = branch.get_master_branch()
-            if master is not None:
-                master.lock_write()
-                unlockable.append(master)
-        old_revno, old_tip = branch.last_revision_info()
-        if master is not None and old_tip != master.last_revision():
+        master = branch.get_master_branch()
+        if master is not None:
+            master.lock_write()
+            unlockable.append(master)
+        rh = branch.revision_history()
+        if master is not None and rh[-1] != master.last_revision():
             raise BoundBranchOutOfDate(branch, master)
         if revno is None:
-            revno = old_revno
-        new_revno = revno - 1
+            revno = len(rh)
+        old_revno, old_tip = branch.last_revision_info()
+        new_revno = revno -1
 
-        revid_iterator = branch.repository.iter_reverse_revision_history(
-                            old_tip)
-        cur_revno = old_revno
-        new_revision_id = old_tip
-        graph = branch.repository.get_graph()
-        for rev_id in revid_iterator:
-            if cur_revno == new_revno:
-                new_revision_id = rev_id
-                break
-            if verbose:
-                print 'Removing revno %d: %s' % (cur_revno, rev_id)
-            cur_revno -= 1
-            parents = graph.get_parent_map([rev_id]).get(rev_id, None)
-            if not parents:
-                continue
+        files_to_remove = []
+        for r in range(revno-1, len(rh)):
+            rev_id = rh.pop()
+            # NB: performance would be better using the revision graph rather
+            # than the whole revision.
+            rev = branch.repository.get_revision(rev_id)
             # When we finish popping off the pending merges, we want
             # them to stay in the order that they used to be.
             # but we pop from the end, so reverse the order, and
             # then get the order right at the end
-            pending_merges.extend(reversed(parents[1:]))
-        else:
-            # We ran off the end of revisions, which means we should be trying
-            # to get to NULL_REVISION
-            new_revision_id = _mod_revision.NULL_REVISION
+            pending_merges.extend(reversed(rev.parent_ids[1:]))
+            if verbose:
+                print 'Removing revno %d: %s' % (len(rh)+1, rev_id)
 
+        # Committing before we start removing files, because
+        # once we have removed at least one, all the rest are invalid.
         if not dry_run:
             if master is not None:
-                master.set_last_revision_info(new_revno, new_revision_id)
-            branch.set_last_revision_info(new_revno, new_revision_id)
+                master.set_revision_history(rh)
+            branch.set_revision_history(rh)
+            new_tip = _mod_revision.ensure_null(branch.last_revision())
             if master is None:
                 hook_local = None
                 hook_master = branch
@@ -104,14 +85,14 @@
                 hook_local = branch
                 hook_master = master
             for hook in Branch.hooks['post_uncommit']:
-                hook_new_tip = new_revision_id
+                hook_new_tip = new_tip
                 if hook_new_tip == _mod_revision.NULL_REVISION:
                     hook_new_tip = None
                 hook(hook_local, hook_master, old_revno, old_tip, new_revno,
                      hook_new_tip)
             if tree is not None:
-                if not _mod_revision.is_null(new_revision_id):
-                    parents = [new_revision_id]
+                if not _mod_revision.is_null(new_tip):
+                    parents = [new_tip]
                 else:
                     parents = []
                 parents.extend(reversed(pending_merges))

=== modified file 'bzrlib/upgrade.py'
--- bzrlib/upgrade.py	2008-08-07 00:25:38 +0000
+++ bzrlib/upgrade.py	2006-08-17 19:51:54 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2008 Canonical Ltd
+# Copyright (C) 2005 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -21,7 +21,6 @@
 
 from bzrlib.bzrdir import ConvertBzrDir4To5, ConvertBzrDir5To6, BzrDir, BzrDirFormat4, BzrDirFormat5, BzrDirFormat
 import bzrlib.errors as errors
-from bzrlib.remote import RemoteBzrDir
 from bzrlib.transport import get_transport
 import bzrlib.ui as ui
 
@@ -31,9 +30,6 @@
     def __init__(self, url, format):
         self.format = format
         self.bzrdir = BzrDir.open_unsupported(url)
-        if isinstance(self.bzrdir, RemoteBzrDir):
-            self.bzrdir._ensure_real()
-            self.bzrdir = self.bzrdir._real_bzrdir
         if self.bzrdir.root_transport.is_readonly():
             raise errors.UpgradeReadonly
         self.transport = self.bzrdir.root_transport
@@ -51,15 +47,12 @@
                 self.pb.note("This is a checkout. The branch (%s) needs to be "
                              "upgraded separately.",
                              branch.bzrdir.root_transport.base)
-            del branch
-        except (errors.NotBranchError, errors.IncompatibleRepositories):
-            # might not be a format we can open without upgrading; see e.g. 
-            # https://bugs.launchpad.net/bzr/+bug/253891
+        except errors.NotBranchError:
             pass
         if not self.bzrdir.needs_format_conversion(self.format):
             raise errors.UpToDateFormat(self.bzrdir._format)
         if not self.bzrdir.can_convert_format():
-            raise errors.BzrError("cannot upgrade from bzrdir format %s" %
+            raise errors.BzrError("cannot upgrade from branch format %s" %
                            self.bzrdir._format)
         if self.format is None:
             target_format = BzrDirFormat.get_default_format()
@@ -75,8 +68,8 @@
 
     def _backup_control_dir(self):
         self.pb.note('making backup of tree history')
-        self.transport.copy_tree('.bzr', 'backup.bzr')
-        self.pb.note('%s.bzr has been backed up to %sbackup.bzr',
+        self.transport.copy_tree('.bzr', '.bzr.backup')
+        self.pb.note('%s.bzr has been backed up to %s.bzr.backup',
              self.transport.base,
              self.transport.base)
         self.pb.note('if conversion fails, you can move this directory back to .bzr')

=== modified file 'bzrlib/urlutils.py'
--- bzrlib/urlutils.py	2008-07-22 02:55:10 +0000
+++ bzrlib/urlutils.py	2007-06-06 14:06:14 +0000
@@ -26,7 +26,6 @@
 lazy_import(globals(), """
 from posixpath import split as _posix_split, normpath as _posix_normpath
 import urllib
-import urlparse
 
 from bzrlib import (
     errors,
@@ -76,10 +75,10 @@
     
     This assumes that both paths are already fully specified file:// URLs.
     """
-    if len(base) < MIN_ABS_FILEURL_LENGTH:
-        raise ValueError('Length of base must be equal or'
-            ' exceed the platform minimum url length (which is %d)' %
-            MIN_ABS_FILEURL_LENGTH)
+    assert len(base) >= MIN_ABS_FILEURL_LENGTH, ('Length of base must be equal or'
+        ' exceed the platform minimum url length (which is %d)' % 
+        MIN_ABS_FILEURL_LENGTH)
+
     base = local_path_from_url(base)
     path = local_path_from_url(path)
     return escape(osutils.relpath(base, path))
@@ -250,11 +249,6 @@
             raise errors.InvalidURL(url, 'Win32 UNC path urls'
                 ' have form file://HOST/path')
         return unescape(win32_url)
-
-    # allow empty paths so we can serve all roots
-    if win32_url == '///':
-        return '/'
-    
     # usual local path with drive letter
     if (win32_url[3] not in ('abcdefghijklmnopqrstuvwxyz'
                              'ABCDEFGHIJKLMNOPQRSTUVWXYZ')
@@ -276,15 +270,11 @@
     #       which actually strips trailing space characters.
     #       The worst part is that under linux ntpath.abspath has different
     #       semantics, since 'nt' is not an available module.
-    if path == '/':
-        return 'file:///'
-
     win32_path = osutils._win32_abspath(path)
     # check for UNC path \\HOST\path
     if win32_path.startswith('//'):
         return 'file:' + escape(win32_path)
-    return ('file:///' + str(win32_path[0].upper()) + ':' +
-        escape(win32_path[2:]))
+    return 'file:///' + win32_path[0].upper() + ':' + escape(win32_path[2:])
 
 
 local_path_to_url = _posix_local_path_to_url
@@ -380,11 +370,6 @@
     other_scheme = other[:other_first_slash]
     if base_scheme != other_scheme:
         return other
-    elif sys.platform == 'win32' and base_scheme == 'file://':
-        base_drive = base[base_first_slash+1:base_first_slash+3]
-        other_drive = other[other_first_slash+1:other_first_slash+3]
-        if base_drive != other_drive:
-            return other
 
     base_path = base[base_first_slash+1:]
     other_path = other[other_first_slash+1:]
@@ -583,8 +568,7 @@
     :return: A unicode string which can be safely encoded into the 
          specified encoding.
     """
-    if encoding is None:
-        raise ValueError('you cannot specify None for the display encoding')
+    assert encoding is not None, 'you cannot specify None for the display encoding.'
     if url.startswith('file://'):
         try:
             path = local_path_from_url(url)
@@ -645,45 +629,3 @@
             return from_location[sep+1:]
         else:
             return from_location
-
-
-def _is_absolute(url):
-    return (osutils.pathjoin('/foo', url) == url)
-
-
-def rebase_url(url, old_base, new_base):
-    """Convert a relative path from an old base URL to a new base URL.
-
-    The result will be a relative path.
-    Absolute paths and full URLs are returned unaltered.
-    """
-    scheme, separator = _find_scheme_and_separator(url)
-    if scheme is not None:
-        return url
-    if _is_absolute(url):
-        return url
-    old_parsed = urlparse.urlparse(old_base)
-    new_parsed = urlparse.urlparse(new_base)
-    if (old_parsed[:2]) != (new_parsed[:2]):
-        raise errors.InvalidRebaseURLs(old_base, new_base)
-    return determine_relative_path(new_parsed[2],
-                                   join(old_parsed[2], url))
-
-
-def determine_relative_path(from_path, to_path):
-    """Determine a relative path from from_path to to_path."""
-    from_segments = osutils.splitpath(from_path)
-    to_segments = osutils.splitpath(to_path)
-    count = -1
-    for count, (from_element, to_element) in enumerate(zip(from_segments,
-                                                       to_segments)):
-        if from_element != to_element:
-            break
-    else:
-        count += 1
-    unique_from = from_segments[count:]
-    unique_to = to_segments[count:]
-    segments = (['..'] * len(unique_from) + unique_to)
-    if len(segments) == 0:
-        return '.'
-    return osutils.pathjoin(*segments)

=== modified file 'bzrlib/util/configobj/configobj.py'
--- bzrlib/util/configobj/configobj.py	2008-02-27 21:36:16 +0000
+++ bzrlib/util/configobj/configobj.py	2007-10-16 17:37:43 +0000
@@ -1,6 +1,6 @@
 # configobj.py
 # A config file reader/writer that supports nested sections in config files.
-# Copyright (C) 2005-2008 Michael Foord, Nicola Larosa
+# Copyright (C) 2005 Michael Foord, Nicola Larosa
 # E-mail: fuzzyman AT voidspace DOT org DOT uk
 #         nico AT tekNico DOT net
 
@@ -18,36 +18,30 @@
 
 from __future__ import generators
 
+"""
+    >>> z = ConfigObj()
+    >>> z['a'] = 'a'
+    >>> z['sect'] = {
+    ...    'subsect': {
+    ...         'a': 'fish',
+    ...         'b': 'wobble',
+    ...     },
+    ...     'member': 'value',
+    ... }
+    >>> x = ConfigObj(z.write())
+    >>> z == x
+    1
+"""
+
 import sys
 INTP_VER = sys.version_info[:2]
 if INTP_VER < (2, 2):
     raise RuntimeError("Python v.2.2 or later needed")
 
 import os, re
-compiler = None
-try:
-    import compiler
-except ImportError:
-    # for IronPython
-    pass
 from types import StringTypes
 from warnings import warn
-try:
-    from codecs import BOM_UTF8, BOM_UTF16, BOM_UTF16_BE, BOM_UTF16_LE
-except ImportError:
-    # Python 2.2 does not have these
-    # UTF-8
-    BOM_UTF8 = '\xef\xbb\xbf'
-    # UTF-16, little endian
-    BOM_UTF16_LE = '\xff\xfe'
-    # UTF-16, big endian
-    BOM_UTF16_BE = '\xfe\xff'
-    if sys.byteorder == 'little':
-        # UTF-16, native endianness
-        BOM_UTF16 = BOM_UTF16_LE
-    else:
-        # UTF-16, native endianness
-        BOM_UTF16 = BOM_UTF16_BE
+from codecs import BOM_UTF8, BOM_UTF16, BOM_UTF16_BE, BOM_UTF16_LE
 
 # A dictionary mapping BOM to
 # the encoding to decode with, and what to set the
@@ -88,18 +82,10 @@
     None: BOM_UTF8
     }
 
-
-def match_utf8(encoding):
-    return BOM_LIST.get(encoding.lower()) == 'utf_8'
-
-
-# Quote strings used for writing values
-squot = "'%s'"
-dquot = '"%s"'
-noquot = "%s"
-wspace_plus = ' \r\t\n\v\t\'"'
-tsquot = '"""%s"""'
-tdquot = "'''%s'''"
+try:
+    from validate import VdtMissingValue
+except ImportError:
+    VdtMissingValue = None
 
 try:
     enumerate
@@ -117,16 +103,21 @@
     True, False = 1, 0
 
 
-__version__ = '4.5.2'
+__version__ = '4.2.0beta2'
 
 __revision__ = '$Id: configobj.py 156 2006-01-31 14:57:08Z fuzzyman $'
 
 __docformat__ = "restructuredtext en"
 
+# NOTE: Does it make sense to have the following in __all__ ?
+# NOTE: DEFAULT_INDENT_TYPE, NUM_INDENT_SPACES, MAX_INTERPOL_DEPTH
+# NOTE: If used as from configobj import...
+# NOTE: They are effectively read only
 __all__ = (
     '__version__',
     'DEFAULT_INDENT_TYPE',
-    'DEFAULT_INTERPOLATION',
+    'NUM_INDENT_SPACES',
+    'MAX_INTERPOL_DEPTH',
     'ConfigObjError',
     'NestingError',
     'ParseError',
@@ -135,18 +126,15 @@
     'ConfigObj',
     'SimpleVal',
     'InterpolationError',
-    'InterpolationLoopError',
+    'InterpolationDepthError',
     'MissingInterpolationOption',
     'RepeatSectionError',
-    'ReloadError',
-    'UnreprError',
-    'UnknownType',
     '__docformat__',
     'flatten_errors',
 )
 
-DEFAULT_INTERPOLATION = 'configparser'
-DEFAULT_INDENT_TYPE = '    '
+DEFAULT_INDENT_TYPE = ' '
+NUM_INDENT_SPACES = 4
 MAX_INTERPOL_DEPTH = 10
 
 OPTION_DEFAULTS = {
@@ -161,94 +149,16 @@
     'indent_type': None,
     'encoding': None,
     'default_encoding': None,
-    'unrepr': False,
-    'write_empty_values': False,
 }
 
-
-
-def getObj(s):
-    s = "a=" + s
-    if compiler is None:
-        raise ImportError('compiler module not available')
-    p = compiler.parse(s)
-    return p.getChildren()[1].getChildren()[0].getChildren()[1]
-
-
-class UnknownType(Exception):
-    pass
-
-
-class Builder(object):
-    
-    def build(self, o):
-        m = getattr(self, 'build_' + o.__class__.__name__, None)
-        if m is None:
-            raise UnknownType(o.__class__.__name__)
-        return m(o)
-    
-    def build_List(self, o):
-        return map(self.build, o.getChildren())
-    
-    def build_Const(self, o):
-        return o.value
-    
-    def build_Dict(self, o):
-        d = {}
-        i = iter(map(self.build, o.getChildren()))
-        for el in i:
-            d[el] = i.next()
-        return d
-    
-    def build_Tuple(self, o):
-        return tuple(self.build_List(o))
-    
-    def build_Name(self, o):
-        if o.name == 'None':
-            return None
-        if o.name == 'True':
-            return True
-        if o.name == 'False':
-            return False
-        
-        # An undefined Name
-        raise UnknownType('Undefined Name')
-    
-    def build_Add(self, o):
-        real, imag = map(self.build_Const, o.getChildren())
-        try:
-            real = float(real)
-        except TypeError:
-            raise UnknownType('Add')
-        if not isinstance(imag, complex) or imag.real != 0.0:
-            raise UnknownType('Add')
-        return real+imag
-    
-    def build_Getattr(self, o):
-        parent = self.build(o.expr)
-        return getattr(parent, o.attrname)
-    
-    def build_UnarySub(self, o):
-        return -self.build_Const(o.getChildren()[0])
-    
-    def build_UnaryAdd(self, o):
-        return self.build_Const(o.getChildren()[0])
-
-
-_builder = Builder()
-
-
-def unrepr(s):
-    if not s:
-        return s
-    return _builder.build(getObj(s))
-
-
-
 class ConfigObjError(SyntaxError):
     """
     This is the base class for all errors that ConfigObj raises.
     It is a subclass of SyntaxError.
+    
+    >>> raise ConfigObjError
+    Traceback (most recent call last):
+    ConfigObjError
     """
     def __init__(self, message='', line_number=None, line=''):
         self.line = line
@@ -256,248 +166,92 @@
         self.message = message
         SyntaxError.__init__(self, message)
 
-
 class NestingError(ConfigObjError):
     """
     This error indicates a level of nesting that doesn't match.
+    
+    >>> raise NestingError
+    Traceback (most recent call last):
+    NestingError
     """
 
-
 class ParseError(ConfigObjError):
     """
     This error indicates that a line is badly written.
     It is neither a valid ``key = value`` line,
     nor a valid section marker line.
-    """
-
-
-class ReloadError(IOError):
-    """
-    A 'reload' operation failed.
-    This exception is a subclass of ``IOError``.
-    """
-    def __init__(self):
-        IOError.__init__(self, 'reload failed, filename is not set.')
-
+    
+    >>> raise ParseError
+    Traceback (most recent call last):
+    ParseError
+    """
 
 class DuplicateError(ConfigObjError):
     """
     The keyword or section specified already exists.
+    
+    >>> raise DuplicateError
+    Traceback (most recent call last):
+    DuplicateError
     """
 
-
 class ConfigspecError(ConfigObjError):
     """
     An error occured whilst parsing a configspec.
+    
+    >>> raise ConfigspecError
+    Traceback (most recent call last):
+    ConfigspecError
     """
 
-
 class InterpolationError(ConfigObjError):
     """Base class for the two interpolation errors."""
 
-
-class InterpolationLoopError(InterpolationError):
+class InterpolationDepthError(InterpolationError):
     """Maximum interpolation depth exceeded in string interpolation."""
 
     def __init__(self, option):
+        """
+        >>> raise InterpolationDepthError('yoda')
+        Traceback (most recent call last):
+        InterpolationDepthError: max interpolation depth exceeded in value "yoda".
+        """
         InterpolationError.__init__(
             self,
-            'interpolation loop detected in value "%s".' % option)
-
+            'max interpolation depth exceeded in value "%s".' % option)
 
 class RepeatSectionError(ConfigObjError):
     """
     This error indicates additional sections in a section with a
     ``__many__`` (repeated) section.
+    
+    >>> raise RepeatSectionError
+    Traceback (most recent call last):
+    RepeatSectionError
     """
 
-
 class MissingInterpolationOption(InterpolationError):
     """A value specified for interpolation was missing."""
 
     def __init__(self, option):
+        """
+        >>> raise MissingInterpolationOption('yoda')
+        Traceback (most recent call last):
+        MissingInterpolationOption: missing option "yoda" in interpolation.
+        """
         InterpolationError.__init__(
             self,
             'missing option "%s" in interpolation.' % option)
 
-
-class UnreprError(ConfigObjError):
-    """An error parsing in unrepr mode."""
-
-
-
-class InterpolationEngine(object):
-    """
-    A helper class to help perform string interpolation.
-
-    This class is an abstract base class; its descendants perform
-    the actual work.
-    """
-
-    # compiled regexp to use in self.interpolate()
-    _KEYCRE = re.compile(r"%\(([^)]*)\)s")
-
-    def __init__(self, section):
-        # the Section instance that "owns" this engine
-        self.section = section
-
-
-    def interpolate(self, key, value):
-        def recursive_interpolate(key, value, section, backtrail):
-            """The function that does the actual work.
-
-            ``value``: the string we're trying to interpolate.
-            ``section``: the section in which that string was found
-            ``backtrail``: a dict to keep track of where we've been,
-            to detect and prevent infinite recursion loops
-
-            This is similar to a depth-first-search algorithm.
-            """
-            # Have we been here already?
-            if backtrail.has_key((key, section.name)):
-                # Yes - infinite loop detected
-                raise InterpolationLoopError(key)
-            # Place a marker on our backtrail so we won't come back here again
-            backtrail[(key, section.name)] = 1
-
-            # Now start the actual work
-            match = self._KEYCRE.search(value)
-            while match:
-                # The actual parsing of the match is implementation-dependent,
-                # so delegate to our helper function
-                k, v, s = self._parse_match(match)
-                if k is None:
-                    # That's the signal that no further interpolation is needed
-                    replacement = v
-                else:
-                    # Further interpolation may be needed to obtain final value
-                    replacement = recursive_interpolate(k, v, s, backtrail)
-                # Replace the matched string with its final value
-                start, end = match.span()
-                value = ''.join((value[:start], replacement, value[end:]))
-                new_search_start = start + len(replacement)
-                # Pick up the next interpolation key, if any, for next time
-                # through the while loop
-                match = self._KEYCRE.search(value, new_search_start)
-
-            # Now safe to come back here again; remove marker from backtrail
-            del backtrail[(key, section.name)]
-
-            return value
-
-        # Back in interpolate(), all we have to do is kick off the recursive
-        # function with appropriate starting values
-        value = recursive_interpolate(key, value, self.section, {})
-        return value
-
-
-    def _fetch(self, key):
-        """Helper function to fetch values from owning section.
-
-        Returns a 2-tuple: the value, and the section where it was found.
-        """
-        # switch off interpolation before we try and fetch anything !
-        save_interp = self.section.main.interpolation
-        self.section.main.interpolation = False
-
-        # Start at section that "owns" this InterpolationEngine
-        current_section = self.section
-        while True:
-            # try the current section first
-            val = current_section.get(key)
-            if val is not None:
-                break
-            # try "DEFAULT" next
-            val = current_section.get('DEFAULT', {}).get(key)
-            if val is not None:
-                break
-            # move up to parent and try again
-            # top-level's parent is itself
-            if current_section.parent is current_section:
-                # reached top level, time to give up
-                break
-            current_section = current_section.parent
-
-        # restore interpolation to previous value before returning
-        self.section.main.interpolation = save_interp
-        if val is None:
-            raise MissingInterpolationOption(key)
-        return val, current_section
-
-
-    def _parse_match(self, match):
-        """Implementation-dependent helper function.
-
-        Will be passed a match object corresponding to the interpolation
-        key we just found (e.g., "%(foo)s" or "$foo"). Should look up that
-        key in the appropriate config file section (using the ``_fetch()``
-        helper function) and return a 3-tuple: (key, value, section)
-
-        ``key`` is the name of the key we're looking for
-        ``value`` is the value found for that key
-        ``section`` is a reference to the section where it was found
-
-        ``key`` and ``section`` should be None if no further
-        interpolation should be performed on the resulting value
-        (e.g., if we interpolated "$$" and returned "$").
-        """
-        raise NotImplementedError()
-    
-
-
-class ConfigParserInterpolation(InterpolationEngine):
-    """Behaves like ConfigParser."""
-    _KEYCRE = re.compile(r"%\(([^)]*)\)s")
-
-    def _parse_match(self, match):
-        key = match.group(1)
-        value, section = self._fetch(key)
-        return key, value, section
-
-
-
-class TemplateInterpolation(InterpolationEngine):
-    """Behaves like string.Template."""
-    _delimiter = '$'
-    _KEYCRE = re.compile(r"""
-        \$(?:
-          (?P<escaped>\$)              |   # Two $ signs
-          (?P<named>[_a-z][_a-z0-9]*)  |   # $name format
-          {(?P<braced>[^}]*)}              # ${name} format
-        )
-        """, re.IGNORECASE | re.VERBOSE)
-
-    def _parse_match(self, match):
-        # Valid name (in or out of braces): fetch value from section
-        key = match.group('named') or match.group('braced')
-        if key is not None:
-            value, section = self._fetch(key)
-            return key, value, section
-        # Escaped delimiter (e.g., $$): return single delimiter
-        if match.group('escaped') is not None:
-            # Return None for key and section to indicate it's time to stop
-            return None, self._delimiter, None
-        # Anything else: ignore completely, just return it unchanged
-        return None, match.group(), None
-
-
-interpolation_engines = {
-    'configparser': ConfigParserInterpolation,
-    'template': TemplateInterpolation,
-}
-
-
-
 class Section(dict):
     """
     A dictionary-like object that represents a section in a config file.
     
-    It does string interpolation if the 'interpolation' attribute
+    It does string interpolation if the 'interpolate' attribute
     of the 'main' object is set to True.
     
-    Interpolation is tried first from this object, then from the 'DEFAULT'
-    section of this object, next from the parent and its 'DEFAULT' section,
-    and so on until the main object is reached.
+    Interpolation is tried first from the 'DEFAULT' section of this object,
+    next from the 'DEFAULT' section of the parent, lastly the main object.
     
     A Section will behave like an ordered dictionary - following the
     order of the ``scalars`` and ``sections`` attributes.
@@ -506,6 +260,8 @@
     Iteration follows the order: scalars, then sections.
     """
 
+    _KEYCRE = re.compile(r"%\(([^)]*)\)s|.")
+
     def __init__(self, parent, depth, main, indict=None, name=None):
         """
         * parent is the section above
@@ -522,68 +278,68 @@
         self.main = main
         # level of nesting depth of this Section
         self.depth = depth
+        # the sequence of scalar values in this Section
+        self.scalars = []
+        # the sequence of sections in this Section
+        self.sections = []
         # purely for information
         self.name = name
-        #
-        self._initialise()
-        # we do this explicitly so that __setitem__ is used properly
-        # (rather than just passing to ``dict.__init__``)
-        for entry, value in indict.iteritems():
-            self[entry] = value
-            
-            
-    def _initialise(self):
-        # the sequence of scalar values in this Section
-        self.scalars = []
-        # the sequence of sections in this Section
-        self.sections = []
         # for comments :-)
         self.comments = {}
         self.inline_comments = {}
         # for the configspec
         self.configspec = {}
-        self._order = []
-        self._configspec_comments = {}
-        self._configspec_inline_comments = {}
-        self._cs_section_comments = {}
-        self._cs_section_inline_comments = {}
         # for defaults
         self.defaults = []
-        self.default_values = {}
-
-
-    def _interpolate(self, key, value):
-        try:
-            # do we already have an interpolation engine?
-            engine = self._interpolation_engine
-        except AttributeError:
-            # not yet: first time running _interpolate(), so pick the engine
-            name = self.main.interpolation
-            if name == True:  # note that "if name:" would be incorrect here
-                # backwards-compatibility: interpolation=True means use default
-                name = DEFAULT_INTERPOLATION
-            name = name.lower()  # so that "Template", "template", etc. all work
-            class_ = interpolation_engines.get(name, None)
-            if class_ is None:
-                # invalid value for self.main.interpolation
-                self.main.interpolation = False
-                return value
+        #
+        # we do this explicitly so that __setitem__ is used properly
+        # (rather than just passing to ``dict.__init__``)
+        for entry in indict:
+            self[entry] = indict[entry]
+
+    def _interpolate(self, value):
+        """Nicked from ConfigParser."""
+        depth = MAX_INTERPOL_DEPTH
+        # loop through this until it's done
+        while depth:
+            depth -= 1
+            if value.find("%(") != -1:
+                value = self._KEYCRE.sub(self._interpolation_replace, value)
             else:
-                # save reference to engine so we don't have to do this again
-                engine = self._interpolation_engine = class_(self)
-        # let the engine do the actual work
-        return engine.interpolate(key, value)
+                break
+        else:
+            raise InterpolationDepthError(value)
+        return value
 
+    def _interpolation_replace(self, match):
+        """ """
+        s = match.group(1)
+        if s is None:
+            return match.group()
+        else:
+            # switch off interpolation before we try and fetch anything !
+            self.main.interpolation = False
+            # try the 'DEFAULT' member of *this section* first
+            val = self.get('DEFAULT', {}).get(s)
+            # try the 'DEFAULT' member of the *parent section* next
+            if val is None:
+                val = self.parent.get('DEFAULT', {}).get(s)
+            # last, try the 'DEFAULT' member of the *main section*
+            if val is None:
+                val = self.main.get('DEFAULT', {}).get(s)
+            self.main.interpolation = True
+            if val is None:
+                raise MissingInterpolationOption(s)
+            return val
 
     def __getitem__(self, key):
         """Fetch the item and do string interpolation."""
         val = dict.__getitem__(self, key)
         if self.main.interpolation and isinstance(val, StringTypes):
-            return self._interpolate(key, val)
+            return self._interpolate(val)
         return val
 
-
-    def __setitem__(self, key, value, unrepr=False):
+    def __setitem__(self, key, value):
         """
         Correctly set a value.
         
@@ -593,15 +349,11 @@
         Keys must be strings.
         Values need only be strings (or lists of strings) if
         ``main.stringify`` is set.
-        
-        `unrepr`` must be set when setting a value to a dictionary, without
-        creating a new sub-section.
         """
         if not isinstance(key, StringTypes):
-            raise ValueError('The key "%s" is not a string.' % key)
-        
+            raise ValueError, 'The key "%s" is not a string.' % key
         # add the comment
-        if not self.comments.has_key(key):
+        if key not in self.comments:
             self.comments[key] = []
             self.inline_comments[key] = ''
         # remove the entry from defaults
@@ -609,13 +361,13 @@
             self.defaults.remove(key)
         #
         if isinstance(value, Section):
-            if not self.has_key(key):
+            if key not in self:
                 self.sections.append(key)
             dict.__setitem__(self, key, value)
-        elif isinstance(value, dict) and not unrepr:
+        elif isinstance(value, dict):
             # First create the new depth level,
             # then create the section
-            if not self.has_key(key):
+            if key not in self:
                 self.sections.append(key)
             new_depth = self.depth + 1
             dict.__setitem__(
@@ -628,7 +380,7 @@
                     indict=value,
                     name=key))
         else:
-            if not self.has_key(key):
+            if key not in self:
                 self.scalars.append(key)
             if not self.main.stringify:
                 if isinstance(value, StringTypes):
@@ -636,12 +388,12 @@
                 elif isinstance(value, (list, tuple)):
                     for entry in value:
                         if not isinstance(entry, StringTypes):
-                            raise TypeError('Value is not a string "%s".' % entry)
+                            raise TypeError, (
+                                'Value is not a string "%s".' % entry)
                 else:
-                    raise TypeError('Value is not a string "%s".' % value)
+                    raise TypeError, 'Value is not a string "%s".' % value
             dict.__setitem__(self, key, value)
 
-
     def __delitem__(self, key):
         """Remove items from the sequence when deleting."""
         dict. __delitem__(self, key)
@@ -652,7 +404,6 @@
         del self.comments[key]
         del self.inline_comments[key]
 
-
     def get(self, key, default=None):
         """A version of ``get`` that doesn't bypass string interpolation."""
         try:
@@ -660,7 +411,6 @@
         except KeyError:
             return default
 
-
     def update(self, indict):
         """
         A version of update that uses our ``__setitem__``.
@@ -670,10 +420,7 @@
 
 
     def pop(self, key, *args):
-        """
-        'D.pop(k[,d]) -> v, remove specified key and return the corresponding value.
-        If key is not found, d is returned if given, otherwise KeyError is raised'
-        """
+        """ """
         val = dict.pop(self, key, *args)
         if key in self.scalars:
             del self.comments[key]
@@ -684,21 +431,19 @@
             del self.inline_comments[key]
             self.sections.remove(key)
         if self.main.interpolation and isinstance(val, StringTypes):
-            return self._interpolate(key, val)
+            return self._interpolate(val)
         return val
 
-
     def popitem(self):
         """Pops the first (key,val)"""
         sequence = (self.scalars + self.sections)
         if not sequence:
-            raise KeyError(": 'popitem(): dictionary is empty'")
+            raise KeyError, ": 'popitem(): dictionary is empty'"
         key = sequence[0]
         val =  self[key]
         del self[key]
         return key, val
 
-
     def clear(self):
         """
         A version of clear that also affects scalars/sections
@@ -714,7 +459,6 @@
         self.inline_comments = {}
         self.configspec = {}
 
-
     def setdefault(self, key, default=None):
         """A version of setdefault that sets sequence if appropriate."""
         try:
@@ -723,47 +467,37 @@
             self[key] = default
             return self[key]
 
-
     def items(self):
-        """D.items() -> list of D's (key, value) pairs, as 2-tuples"""
+        """ """
         return zip((self.scalars + self.sections), self.values())
 
-
     def keys(self):
-        """D.keys() -> list of D's keys"""
+        """ """
         return (self.scalars + self.sections)
 
-
     def values(self):
-        """D.values() -> list of D's values"""
+        """ """
         return [self[key] for key in (self.scalars + self.sections)]
 
-
     def iteritems(self):
-        """D.iteritems() -> an iterator over the (key, value) items of D"""
+        """ """
         return iter(self.items())
 
-
     def iterkeys(self):
-        """D.iterkeys() -> an iterator over the keys of D"""
+        """ """
         return iter((self.scalars + self.sections))
 
     __iter__ = iterkeys
 
-
     def itervalues(self):
-        """D.itervalues() -> an iterator over the values of D"""
+        """ """
         return iter(self.values())
 
-
     def __repr__(self):
-        """x.__repr__() <==> repr(x)"""
         return '{%s}' % ', '.join([('%s: %s' % (repr(key), repr(self[key])))
             for key in (self.scalars + self.sections)])
 
     __str__ = __repr__
-    __str__.__doc__ = "x.__str__() <==> str(x)"
-
 
     # Extra methods - not in a normal dictionary
 
@@ -785,16 +519,12 @@
             this_entry = self[entry]
             if isinstance(this_entry, Section):
                 this_entry = this_entry.dict()
-            elif isinstance(this_entry, list):
+            elif isinstance(this_entry, (list, tuple)):
                 # create a copy rather than a reference
                 this_entry = list(this_entry)
-            elif isinstance(this_entry, tuple):
-                # create a copy rather than a reference
-                this_entry = tuple(this_entry)
             newdict[entry] = this_entry
         return newdict
 
-
     def merge(self, indict):
         """
         A recursive update - useful for merging config files.
@@ -821,7 +551,6 @@
             else:   
                 self[key] = val
 
-
     def rename(self, oldkey, newkey):
         """
         Change a keyname to another, without changing position in sequence.
@@ -836,7 +565,7 @@
         elif oldkey in self.sections:
             the_list = self.sections
         else:
-            raise KeyError('Key "%s" not found.' % oldkey)
+            raise KeyError, 'Key "%s" not found.' % oldkey
         pos = the_list.index(oldkey)
         #
         val = self[oldkey]
@@ -851,7 +580,6 @@
         self.comments[newkey] = comm
         self.inline_comments[newkey] = inline_comment
 
-
     def walk(self, function, raise_errors=True,
             call_on_sections=False, **keywargs):
         """
@@ -936,7 +664,6 @@
                 **keywargs)
         return out
 
-
     def decode(self, encoding):
         """
         Decode all strings and values to unicode, using the specified encoding.
@@ -951,7 +678,8 @@
         >>> def testuni(val):
         ...     for entry in val:
         ...         if not isinstance(entry, unicode):
-        ...             print >> sys.stderr, type(entry)
+        ...             sys.stderr.write(type(entry))
+        ...             sys.stderr.write('\n')
         ...             raise AssertionError, 'decode failed.'
         ...         if isinstance(val[entry], dict):
         ...             testuni(val[entry])
@@ -962,8 +690,7 @@
         >>> a == m
         1
         """
-        warn('use of ``decode`` is deprecated.', DeprecationWarning)
-        def decode(section, key, encoding=encoding, warn=True):
+        def decode(section, key, encoding=encoding):
             """ """
             val = section[key]
             if isinstance(val, (list, tuple)):
@@ -980,7 +707,6 @@
         # using ``call_on_sections`` allows us to modify section names
         self.walk(decode, call_on_sections=True)
 
-
     def encode(self, encoding):
         """
         Encode all strings and values from unicode,
@@ -989,7 +715,6 @@
         Works with subsections and list values.
         Uses the ``walk`` method.
         """
-        warn('use of ``encode`` is deprecated.', DeprecationWarning)
         def encode(section, key, encoding=encoding):
             """ """
             val = section[key]
@@ -1006,14 +731,12 @@
             section[newkey] = newval
         self.walk(encode, call_on_sections=True)
 
-
     def istrue(self, key):
         """A deprecated version of ``as_bool``."""
         warn('use of ``istrue`` is deprecated. Use ``as_bool`` method '
                 'instead.', DeprecationWarning)
         return self.as_bool(key)
 
-
     def as_bool(self, key):
         """
         Accepts a key as input. The corresponding value must be a string or
@@ -1050,14 +773,12 @@
         else:
             try:
                 if not isinstance(val, StringTypes):
-                    # TODO: Why do we raise a KeyError here?
-                    raise KeyError()
+                    raise KeyError
                 else:
                     return self.main._bools[val.lower()]
             except KeyError:
                 raise ValueError('Value "%s" is neither True nor False' % val)
 
-
     def as_int(self, key):
         """
         A convenience method which coerces the specified value to an integer.
@@ -1080,7 +801,6 @@
         """
         return int(self[key])
 
-
     def as_float(self, key):
         """
         A convenience method which coerces the specified value to a float.
@@ -1101,43 +821,40 @@
         3.2000000000000002
         """
         return float(self[key])
-
-
-    def restore_default(self, key):
-        """
-        Restore (and return) default value for the specified key.
-        
-        This method will only work for a ConfigObj that was created
-        with a configspec and has been validated.
-        
-        If there is no default value for this key, ``KeyError`` is raised.
-        """
-        default = self.default_values[key]
-        dict.__setitem__(self, key, default)
-        if key not in self.defaults:
-            self.defaults.append(key)
-        return default
-
     
-    def restore_defaults(self):
-        """
-        Recursively restore default values to all members
-        that have them.
-        
-        This method will only work for a ConfigObj that was created
-        with a configspec and has been validated.
-        
-        It doesn't delete or modify entries without default values.
-        """
-        for key in self.default_values:
-            self.restore_default(key)
-            
-        for section in self.sections:
-            self[section].restore_defaults()
-
 
 class ConfigObj(Section):
-    """An object to read, create, and write config files."""
+    """
+    An object to read, create, and write config files.
+    
+    Testing with duplicate keys and sections.
+    
+    >>> c = '''
+    ... [hello]
+    ... member = value
+    ... [hello again]
+    ... member = value
+    ... [ "hello" ]
+    ... member = value
+    ... '''
+    >>> ConfigObj(c.split('\\n'), raise_errors = True)
+    Traceback (most recent call last):
+    DuplicateError: Duplicate section name at line 5.
+    
+    >>> d = '''
+    ... [hello]
+    ... member = value
+    ... [hello again]
+    ... member1 = value
+    ... member2 = value
+    ... 'member1' = value
+    ... [ "and again" ]
+    ... member = value
+    ... '''
+    >>> ConfigObj(d.split('\\n'), raise_errors = True)
+    Traceback (most recent call last):
+    DuplicateError: Duplicate keyword name at line 6.
+    """
 
     _keyword = re.compile(r'''^ # line start
         (\s*)                   # indentation
@@ -1167,8 +884,6 @@
 
     # this regexp pulls list values out as a single string
     # or single values and comments
-    # FIXME: this regex adds a '' to the end of comma terminated lists
-    #   workaround in ``_handle_value``
     _valueexp = re.compile(r'''^
         (?:
             (?:
@@ -1177,7 +892,7 @@
                         (?:
                             (?:".*?")|              # double quotes
                             (?:'.*?')|              # single quotes
-                            (?:[^'",\#][^,\#]*?)    # unquoted
+                            (?:[^'",\#][^,\#]*?)       # unquoted
                         )
                         \s*,\s*                     # comma
                     )*      # match all list items ending in a comma (if any)
@@ -1185,8 +900,7 @@
                 (
                     (?:".*?")|                      # double quotes
                     (?:'.*?')|                      # single quotes
-                    (?:[^'",\#\s][^,]*?)|           # unquoted
-                    (?:(?<!,))                      # Empty value
+                    (?:[^'",\#\s][^,]*?)             # unquoted
                 )?          # last item in a list - or string value
             )|
             (,)             # alternatively a single comma - empty list
@@ -1212,8 +926,7 @@
         (
             (?:".*?")|          # double quotes
             (?:'.*?')|          # single quotes
-            (?:[^'"\#].*?)|     # unquoted
-            (?:)                # Empty value
+            (?:[^'"\#].*?)      # unquoted
         )
         \s*(\#.*)?              # optional comment
         $''',
@@ -1238,88 +951,89 @@
         'true': True, 'false': False,
         }
 
-
     def __init__(self, infile=None, options=None, **kwargs):
         """
-        Parse a config file or create a config file object.
+        Parse or create a config file object.
         
         ``ConfigObj(infile=None, options=None, **kwargs)``
         """
-        # init the superclass
-        Section.__init__(self, self, 0, self)
-        
         if infile is None:
             infile = []
         if options is None:
             options = {}
-        else:
-            options = dict(options)
-            
         # keyword arguments take precedence over an options dictionary
         options.update(kwargs)
-        
+        # init the superclass
+        Section.__init__(self, self, 0, self)
+        #
         defaults = OPTION_DEFAULTS.copy()
+        for entry in options.keys():
+            if entry not in defaults.keys():
+                raise TypeError, 'Unrecognised option "%s".' % entry
         # TODO: check the values too.
-        for entry in options:
-            if entry not in defaults:
-                raise TypeError('Unrecognised option "%s".' % entry)
-        
+        #
         # Add any explicit options to the defaults
         defaults.update(options)
-        self._initialise(defaults)
-        configspec = defaults['configspec']
-        self._original_configspec = configspec
-        self._load(infile, configspec)
-        
-        
-    def _load(self, infile, configspec):
+        #
+        # initialise a few variables
+        self.filename = None
+        self._errors = []
+        self.raise_errors = defaults['raise_errors']
+        self.interpolation = defaults['interpolation']
+        self.list_values = defaults['list_values']
+        self.create_empty = defaults['create_empty']
+        self.file_error = defaults['file_error']
+        self.stringify = defaults['stringify']
+        self.indent_type = defaults['indent_type']
+        self.encoding = defaults['encoding']
+        self.default_encoding = defaults['default_encoding']
+        self.BOM = False
+        self.newlines = None
+        #
+        self.initial_comment = []
+        self.final_comment = []
+        #
         if isinstance(infile, StringTypes):
             self.filename = infile
             if os.path.isfile(infile):
-                h = open(infile, 'rb')
-                infile = h.read() or []
-                h.close()
+                infile = open(infile).read() or []
             elif self.file_error:
                 # raise an error if the file doesn't exist
-                raise IOError('Config file not found: "%s".' % self.filename)
+                raise IOError, 'Config file not found: "%s".' % self.filename
             else:
                 # file doesn't already exist
                 if self.create_empty:
                     # this is a good test that the filename specified
-                    # isn't impossible - like on a non-existent device
+                    # isn't impossible - like on a non existent device
                     h = open(infile, 'w')
                     h.write('')
                     h.close()
                 infile = []
-                
         elif isinstance(infile, (list, tuple)):
             infile = list(infile)
-            
         elif isinstance(infile, dict):
             # initialise self
             # the Section class handles creating subsections
             if isinstance(infile, ConfigObj):
                 # get a copy of our ConfigObj
                 infile = infile.dict()
-                
             for entry in infile:
                 self[entry] = infile[entry]
             del self._errors
-            
-            if configspec is not None:
-                self._handle_configspec(configspec)
+            if defaults['configspec'] is not None:
+                self._handle_configspec(defaults['configspec'])
             else:
                 self.configspec = None
             return
-        
         elif getattr(infile, 'read', None) is not None:
             # This supports file like objects
             infile = infile.read() or []
             # needs splitting into lines - but needs doing *after* decoding
             # in case it's not an 8 bit encoding
         else:
-            raise TypeError('infile must be a filename, file like object, or list of lines.')
-        
+            raise TypeError, ('infile must be a filename,'
+                ' file like object, or list of lines.')
+        #
         if infile:
             # don't do it for the empty ConfigObj
             infile = self._handle_bom(infile)
@@ -1328,25 +1042,19 @@
             # Set the newlines attribute (first line ending it finds)
             # and strip trailing '\n' or '\r' from lines
             for line in infile:
-                if (not line) or (line[-1] not in ('\r', '\n', '\r\n')):
+                if (not line) or (line[-1] not in '\r\n'):
                     continue
                 for end in ('\r\n', '\n', '\r'):
                     if line.endswith(end):
                         self.newlines = end
                         break
                 break
-
             infile = [line.rstrip('\r\n') for line in infile]
-            
+        #
         self._parse(infile)
         # if we had any errors, now is the time to raise them
         if self._errors:
-            info = "at line %s." % self._errors[0].line_number
-            if len(self._errors) > 1:
-                msg = "Parsing failed with several errors.\nFirst error %s" % info
-                error = ConfigObjError(msg)
-            else:
-                error = self._errors[0]
+            error = ConfigObjError("Parsing failed.")
             # set the errors attribute; it's a list of tuples:
             # (error_type, message, line_number)
             error.errors = self._errors
@@ -1355,48 +1063,12 @@
             raise error
         # delete private attributes
         del self._errors
-        
-        if configspec is None:
+        #
+        if defaults['configspec'] is None:
             self.configspec = None
         else:
-            self._handle_configspec(configspec)
-    
-    
-    def _initialise(self, options=None):
-        if options is None:
-            options = OPTION_DEFAULTS
-            
-        # initialise a few variables
-        self.filename = None
-        self._errors = []
-        self.raise_errors = options['raise_errors']
-        self.interpolation = options['interpolation']
-        self.list_values = options['list_values']
-        self.create_empty = options['create_empty']
-        self.file_error = options['file_error']
-        self.stringify = options['stringify']
-        self.indent_type = options['indent_type']
-        self.encoding = options['encoding']
-        self.default_encoding = options['default_encoding']
-        self.BOM = False
-        self.newlines = None
-        self.write_empty_values = options['write_empty_values']
-        self.unrepr = options['unrepr']
-        
-        self.initial_comment = []
-        self.final_comment = []
-        self.configspec = {}
-        
-        # Clear section attributes as well
-        Section._initialise(self)
-        
-        
-    def __repr__(self):
-        return ('ConfigObj({%s})' % 
-                ', '.join([('%s: %s' % (repr(key), repr(self[key]))) 
-                for key in (self.scalars + self.sections)]))
-    
-    
+            self._handle_configspec(defaults['configspec'])
+
     def _handle_bom(self, infile):
         """
         Handle any BOM, and decode if necessary.
@@ -1422,10 +1094,10 @@
         if ((self.encoding is not None) and
             (self.encoding.lower() not in BOM_LIST)):
             # No need to check for a BOM
-            # the encoding specified doesn't have one
+            # encoding specified doesn't have one
             # just decode
             return self._decode(infile, self.encoding)
-        
+        #
         if isinstance(infile, (list, tuple)):
             line = infile[0]
         else:
@@ -1447,18 +1119,18 @@
                         ##self.BOM = True
                         # Don't need to remove BOM
                         return self._decode(infile, encoding)
-                    
+                #
                 # If we get this far, will *probably* raise a DecodeError
                 # As it doesn't appear to start with a BOM
                 return self._decode(infile, self.encoding)
-            
+            #
             # Must be UTF8
             BOM = BOM_SET[enc]
             if not line.startswith(BOM):
                 return self._decode(infile, self.encoding)
-            
+            #
             newline = line[len(BOM):]
-            
+            #
             # BOM removed
             if isinstance(infile, (list, tuple)):
                 infile[0] = newline
@@ -1466,7 +1138,7 @@
                 infile = newline
             self.BOM = True
             return self._decode(infile, self.encoding)
-        
+        #
         # No encoding specified - so we need to check for UTF8/UTF16
         for BOM, (encoding, final_encoding) in BOMS.items():
             if not line.startswith(BOM):
@@ -1490,21 +1162,20 @@
                         return infile
                 # UTF16 - have to decode
                 return self._decode(infile, encoding)
-            
+        #
         # No BOM discovered and no encoding specified, just return
         if isinstance(infile, StringTypes):
             # infile read from a file will be a single string
             return infile.splitlines(True)
-        return infile
-
-
-    def _a_to_u(self, aString):
-        """Decode ASCII strings to unicode if a self.encoding is specified."""
-        if self.encoding:
-            return aString.decode('ascii')
-        else:
-            return aString
-
+        else:
+            return infile
+
+    def _a_to_u(self, string):
+        """Decode ascii strings to unicode if a self.encoding is specified."""
+        if not self.encoding:
+            return string
+        else:
+            return string.decode('ascii')
 
     def _decode(self, infile, encoding):
         """
@@ -1524,7 +1195,6 @@
                 infile[i] = line.decode(encoding)
         return infile
 
-
     def _decode_element(self, line):
         """Decode element to unicode if necessary."""
         if not self.encoding:
@@ -1533,7 +1203,6 @@
             return line.decode(self.default_encoding)
         return line
 
-
     def _str(self, value):
         """
         Used by ``stringify`` within validate, to turn non-string values
@@ -1544,20 +1213,83 @@
         else:
             return value
 
-
     def _parse(self, infile):
-        """Actually parse the config file."""
-        temp_list_values = self.list_values
-        if self.unrepr:
-            self.list_values = False
-            
+        """
+        Actually parse the config file
+        
+        Testing Interpolation
+        
+        >>> c = ConfigObj()
+        >>> c['DEFAULT'] = {
+        ...     'b': 'goodbye',
+        ...     'userdir': 'c:\\\\home',
+        ...     'c': '%(d)s',
+        ...     'd': '%(c)s'
+        ... }
+        >>> c['section'] = {
+        ...     'a': '%(datadir)s\\\\some path\\\\file.py',
+        ...     'b': '%(userdir)s\\\\some path\\\\file.py',
+        ...     'c': 'Yo %(a)s',
+        ...     'd': '%(not_here)s',
+        ...     'e': '%(c)s',
+        ... }
+        >>> c['section']['DEFAULT'] = {
+        ...     'datadir': 'c:\\\\silly_test',
+        ...     'a': 'hello - %(b)s',
+        ... }
+        >>> c['section']['a'] == 'c:\\\\silly_test\\\\some path\\\\file.py'
+        1
+        >>> c['section']['b'] == 'c:\\\\home\\\\some path\\\\file.py'
+        1
+        >>> c['section']['c'] == 'Yo hello - goodbye'
+        1
+        
+        Switching Interpolation Off
+        
+        >>> c.interpolation = False
+        >>> c['section']['a'] == '%(datadir)s\\\\some path\\\\file.py'
+        1
+        >>> c['section']['b'] == '%(userdir)s\\\\some path\\\\file.py'
+        1
+        >>> c['section']['c'] == 'Yo %(a)s'
+        1
+        
+        Testing the interpolation errors.
+        
+        >>> c.interpolation = True
+        >>> c['section']['d']
+        Traceback (most recent call last):
+        MissingInterpolationOption: missing option "not_here" in interpolation.
+        >>> c['section']['e']
+        Traceback (most recent call last):
+        InterpolationDepthError: max interpolation depth exceeded in value "%(c)s".
+        
+        Testing our quoting.
+        
+        >>> i._quote('\"""\'\'\'')
+        Traceback (most recent call last):
+        SyntaxError: EOF while scanning triple-quoted string
+        >>> try:
+        ...     i._quote('\\n', multiline=False)
+        ... except ConfigObjError, e:
+        ...    e.msg
+        'Value "\\n" cannot be safely quoted.'
+        >>> k._quote(' "\' ', multiline=False)
+        Traceback (most recent call last):
+        SyntaxError: EOL while scanning single-quoted string
+        
+        Testing with "stringify" off.
+        >>> c.stringify = False
+        >>> c['test'] = 1
+        Traceback (most recent call last):
+        TypeError: Value is not a string "1".
+        """
         comment_list = []
         done_start = False
         this_section = self
         maxline = len(infile) - 1
         cur_index = -1
         reset_comment = False
-        
         while cur_index < maxline:
             if reset_comment:
                 comment_list = []
@@ -1569,35 +1301,37 @@
                 reset_comment = False
                 comment_list.append(line)
                 continue
-            
             if not done_start:
                 # preserve initial comment
                 self.initial_comment = comment_list
                 comment_list = []
                 done_start = True
-                
             reset_comment = True
             # first we check if it's a section marker
             mat = self._sectionmarker.match(line)
+##            sys.stderr.write('%s %s\n' % (sline, mat))
             if mat is not None:
                 # is a section line
-                (indent, sect_open, sect_name, sect_close, comment) = mat.groups()
+                (indent, sect_open, sect_name, sect_close, comment) = (
+                    mat.groups())
                 if indent and (self.indent_type is None):
-                    self.indent_type = indent
+                    self.indent_type = indent[0]
                 cur_depth = sect_open.count('[')
                 if cur_depth != sect_close.count(']'):
-                    self._handle_error("Cannot compute the section depth at line %s.",
-                                       NestingError, infile, cur_index)
+                    self._handle_error(
+                        "Cannot compute the section depth at line %s.",
+                        NestingError, infile, cur_index)
                     continue
-                
                 if cur_depth < this_section.depth:
                     # the new section is dropping back to a previous level
                     try:
-                        parent = self._match_depth(this_section,
-                                                   cur_depth).parent
+                        parent = self._match_depth(
+                            this_section,
+                            cur_depth).parent
                     except SyntaxError:
-                        self._handle_error("Cannot compute nesting level at line %s.",
-                                           NestingError, infile, cur_index)
+                        self._handle_error(
+                            "Cannot compute nesting level at line %s.",
+                            NestingError, infile, cur_index)
                         continue
                 elif cur_depth == this_section.depth:
                     # the new section is a sibling of the current section
@@ -1606,15 +1340,18 @@
                     # the new section is a child the current section
                     parent = this_section
                 else:
-                    self._handle_error("Section too nested at line %s.",
-                                       NestingError, infile, cur_index)
-                    
+                    self._handle_error(
+                        "Section too nested at line %s.",
+                        NestingError, infile, cur_index)
+                #
                 sect_name = self._unquote(sect_name)
-                if parent.has_key(sect_name):
-                    self._handle_error('Duplicate section name at line %s.',
-                                       DuplicateError, infile, cur_index)
+                if sect_name in parent:
+##                    sys.stderr.write(sect_name)
+##                    sys.stderr.write('\n')
+                    self._handle_error(
+                        'Duplicate section name at line %s.',
+                        DuplicateError, infile, cur_index)
                     continue
-                
                 # create the new section
                 this_section = Section(
                     parent,
@@ -1624,23 +1361,20 @@
                 parent[sect_name] = this_section
                 parent.inline_comments[sect_name] = comment
                 parent.comments[sect_name] = comment_list
+##                sys.stderr.write(parent[sect_name] is this_section)
+##                sys.stderr.write('\n')
                 continue
             #
             # it's not a section marker,
             # so it should be a valid ``key = value`` line
             mat = self._keyword.match(line)
-            if mat is None:
-                # it neither matched as a keyword
-                # or a section marker
-                self._handle_error(
-                    'Invalid line at line "%s".',
-                    ParseError, infile, cur_index)
-            else:
+##            sys.stderr.write('%s %s\n' % (sline, mat))
+            if mat is not None:
                 # is a keyword value
                 # value will include any inline comment
                 (indent, key, value) = mat.groups()
                 if indent and (self.indent_type is None):
-                    self.indent_type = indent
+                    self.indent_type = indent[0]
                 # check for a multiline value
                 if value[:3] in ['"""', "'''"]:
                     try:
@@ -1651,67 +1385,50 @@
                             'Parse error in value at line %s.',
                             ParseError, infile, cur_index)
                         continue
-                    else:
-                        if self.unrepr:
-                            comment = ''
-                            try:
-                                value = unrepr(value)
-                            except Exception, e:
-                                if type(e) == UnknownType:
-                                    msg = 'Unknown name or type in value at line %s.'
-                                else:
-                                    msg = 'Parse error in value at line %s.'
-                                self._handle_error(msg, UnreprError, infile,
-                                    cur_index)
-                                continue
                 else:
-                    if self.unrepr:
-                        comment = ''
-                        try:
-                            value = unrepr(value)
-                        except Exception, e:
-                            if isinstance(e, UnknownType):
-                                msg = 'Unknown name or type in value at line %s.'
-                            else:
-                                msg = 'Parse error in value at line %s.'
-                            self._handle_error(msg, UnreprError, infile,
-                                cur_index)
-                            continue
-                    else:
-                        # extract comment and lists
-                        try:
-                            (value, comment) = self._handle_value(value)
-                        except SyntaxError:
-                            self._handle_error(
-                                'Parse error in value at line %s.',
-                                ParseError, infile, cur_index)
-                            continue
+                    # extract comment and lists
+                    try:
+                        (value, comment) = self._handle_value(value)
+                    except SyntaxError:
+                        self._handle_error(
+                            'Parse error in value at line %s.',
+                            ParseError, infile, cur_index)
+                        continue
                 #
+##                sys.stderr.write(sline)
+##                sys.stderr.write('\n')
                 key = self._unquote(key)
-                if this_section.has_key(key):
+                if key in this_section:
                     self._handle_error(
                         'Duplicate keyword name at line %s.',
                         DuplicateError, infile, cur_index)
                     continue
-                # add the key.
-                # we set unrepr because if we have got this far we will never
-                # be creating a new section
-                this_section.__setitem__(key, value, unrepr=True)
+                # add the key
+##                sys.stderr.write(this_section.name + '\n')
+                this_section[key] = value
                 this_section.inline_comments[key] = comment
                 this_section.comments[key] = comment_list
+##                sys.stderr.write('%s %s\n' % (key, this_section[key]))
+##                if this_section.name is not None:
+##                    sys.stderr.write(this_section + '\n')
+##                    sys.stderr.write(this_section.parent + '\n')
+##                    sys.stderr.write(this_section.parent[this_section.name])
+##                    sys.stderr.write('\n')
                 continue
-        #
+            #
+            # it neither matched as a keyword
+            # or a section marker
+            self._handle_error(
+                'Invalid line at line "%s".',
+                ParseError, infile, cur_index)
         if self.indent_type is None:
             # no indentation used, set the type accordingly
             self.indent_type = ''
-
         # preserve the final comment
         if not self and not self.initial_comment:
             self.initial_comment = comment_list
-        elif not reset_comment:
+        else:
             self.final_comment = comment_list
-        self.list_values = temp_list_values
-
 
     def _match_depth(self, sect, depth):
         """
@@ -1724,13 +1441,12 @@
         while depth < sect.depth:
             if sect is sect.parent:
                 # we've reached the top level already
-                raise SyntaxError()
+                raise SyntaxError
             sect = sect.parent
         if sect.depth == depth:
             return sect
         # shouldn't get here
-        raise SyntaxError()
-
+        raise SyntaxError
 
     def _handle_error(self, text, ErrorClass, infile, cur_index):
         """
@@ -1750,14 +1466,12 @@
         # reraise when parsing has finished
         self._errors.append(error)
 
-
     def _unquote(self, value):
         """Return an unquoted version of a value"""
         if (value[0] == value[-1]) and (value[0] in ('"', "'")):
             value = value[1:-1]
         return value
 
-
     def _quote(self, value, multiline=True):
         """
         Return a safely quoted version of a value.
@@ -1772,17 +1486,9 @@
         Obey list syntax for empty and single member lists.
         
         If ``list_values=False`` then the value is only quoted if it contains
-        a ``\n`` (is multiline) or '#'.
-        
-        If ``write_empty_values`` is set, and the value is an empty string, it
-        won't be quoted.
+        a ``\n`` (is multiline).
         """
-        if multiline and self.write_empty_values and value == '':
-            # Only if multiline is set, so that it is used for values not
-            # keys, and not values that are part of a list
-            return ''
-        
-        if multiline and isinstance(value, (list, tuple)):
+        if isinstance(value, (list, tuple)):
             if not value:
                 return ','
             elif len(value) == 1:
@@ -1793,96 +1499,165 @@
             if self.stringify:
                 value = str(value)
             else:
-                raise TypeError('Value "%s" is not a string.' % value)
-
+                raise TypeError, 'Value "%s" is not a string.' % value
+        squot = "'%s'"
+        dquot = '"%s"'
+        noquot = "%s"
+        wspace_plus = ' \r\t\n\v\t\'"'
+        tsquot = '"""%s"""'
+        tdquot = "'''%s'''"
         if not value:
             return '""'
-        
-        no_lists_no_quotes = not self.list_values and '\n' not in value and '#' not in value
-        need_triple = multiline and ((("'" in value) and ('"' in value)) or ('\n' in value ))
-        hash_triple_quote = multiline and not need_triple and ("'" in value) and ('"' in value) and ('#' in value)
-        check_for_single = (no_lists_no_quotes or not need_triple) and not hash_triple_quote
-        
-        if check_for_single:
+        if (not self.list_values and '\n' not in value) or not (multiline and
+                ((("'" in value) and ('"' in value)) or ('\n' in value))):
             if not self.list_values:
                 # we don't quote if ``list_values=False``
                 quot = noquot
             # for normal values either single or double quotes will do
             elif '\n' in value:
                 # will only happen if multiline is off - e.g. '\n' in key
-                raise ConfigObjError('Value "%s" cannot be safely quoted.' % value)
+                raise ConfigObjError, ('Value "%s" cannot be safely quoted.' %
+                    value)
             elif ((value[0] not in wspace_plus) and
                     (value[-1] not in wspace_plus) and
                     (',' not in value)):
                 quot = noquot
             else:
-                quot = self._get_single_quote(value)
+                if ("'" in value) and ('"' in value):
+                    raise ConfigObjError, (
+                        'Value "%s" cannot be safely quoted.' % value)
+                elif '"' in value:
+                    quot = squot
+                else:
+                    quot = dquot
         else:
             # if value has '\n' or "'" *and* '"', it will need triple quotes
-            quot = self._get_triple_quote(value)
-        
-        if quot == noquot and '#' in value and self.list_values:
-            quot = self._get_single_quote(value)
-                
+            if (value.find('"""') != -1) and (value.find("'''") != -1):
+                raise ConfigObjError, (
+                    'Value "%s" cannot be safely quoted.' % value)
+            if value.find('"""') == -1:
+                quot = tdquot
+            else:
+                quot = tsquot
         return quot % value
-    
-    
-    def _get_single_quote(self, value):
-        if ("'" in value) and ('"' in value):
-            raise ConfigObjError('Value "%s" cannot be safely quoted.' % value)
-        elif '"' in value:
-            quot = squot
-        else:
-            quot = dquot
-        return quot
-    
-    
-    def _get_triple_quote(self, value):
-        if (value.find('"""') != -1) and (value.find("'''") != -1):
-            raise ConfigObjError('Value "%s" cannot be safely quoted.' % value)
-        if value.find('"""') == -1:
-            quot = tdquot
-        else:
-            quot = tsquot 
-        return quot
-
 
     def _handle_value(self, value):
         """
         Given a value string, unquote, remove comment,
         handle lists. (including empty and single member lists)
+        
+        Testing list values.
+        
+        >>> testconfig3 = '''
+        ... a = ,
+        ... b = test,
+        ... c = test1, test2   , test3
+        ... d = test1, test2, test3,
+        ... '''
+        >>> d = ConfigObj(testconfig3.split('\\n'), raise_errors=True)
+        >>> d['a'] == []
+        1
+        >>> d['b'] == ['test']
+        1
+        >>> d['c'] == ['test1', 'test2', 'test3']
+        1
+        >>> d['d'] == ['test1', 'test2', 'test3']
+        1
+        
+        Testing with list values off.
+        
+        >>> e = ConfigObj(
+        ...     testconfig3.split('\\n'),
+        ...     raise_errors=True,
+        ...     list_values=False)
+        >>> e['a'] == ','
+        1
+        >>> e['b'] == 'test,'
+        1
+        >>> e['c'] == 'test1, test2   , test3'
+        1
+        >>> e['d'] == 'test1, test2, test3,'
+        1
+        
+        Testing creating from a dictionary.
+        
+        >>> f = {
+        ...     'key1': 'val1',
+        ...     'key2': 'val2',
+        ...     'section 1': {
+        ...         'key1': 'val1',
+        ...         'key2': 'val2',
+        ...         'section 1b': {
+        ...             'key1': 'val1',
+        ...             'key2': 'val2',
+        ...         },
+        ...     },
+        ...     'section 2': {
+        ...         'key1': 'val1',
+        ...         'key2': 'val2',
+        ...         'section 2b': {
+        ...             'key1': 'val1',
+        ...             'key2': 'val2',
+        ...         },
+        ...     },
+        ...      'key3': 'val3',
+        ... }
+        >>> g = ConfigObj(f)
+        >>> f == g
+        1
+        
+        Testing we correctly detect badly built list values (4 of them).
+        
+        >>> testconfig4 = '''
+        ... config = 3,4,,
+        ... test = 3,,4
+        ... fish = ,,
+        ... dummy = ,,hello, goodbye
+        ... '''
+        >>> try:
+        ...     ConfigObj(testconfig4.split('\\n'))
+        ... except ConfigObjError, e:
+        ...     len(e.errors)
+        4
+        
+        Testing we correctly detect badly quoted values (4 of them).
+        
+        >>> testconfig5 = '''
+        ... config = "hello   # comment
+        ... test = 'goodbye
+        ... fish = 'goodbye   # comment
+        ... dummy = "hello again
+        ... '''
+        >>> try:
+        ...     ConfigObj(testconfig5.split('\\n'))
+        ... except ConfigObjError, e:
+        ...     len(e.errors)
+        4
         """
         # do we look for lists in values ?
         if not self.list_values:
             mat = self._nolistvalue.match(value)
             if mat is None:
-                raise SyntaxError()
+                raise SyntaxError
+            (value, comment) = mat.groups()
             # NOTE: we don't unquote here
-            return mat.groups()
-        #
+            return (value, comment)
         mat = self._valueexp.match(value)
         if mat is None:
             # the value is badly constructed, probably badly quoted,
             # or an invalid list
-            raise SyntaxError()
+            raise SyntaxError
         (list_values, single, empty_list, comment) = mat.groups()
         if (list_values == '') and (single is None):
             # change this if you want to accept empty values
-            raise SyntaxError()
+            raise SyntaxError
         # NOTE: note there is no error handling from here if the regex
         # is wrong: then incorrect values will slip through
         if empty_list is not None:
             # the single comma - meaning an empty list
             return ([], comment)
         if single is not None:
-            # handle empty values
-            if list_values and not single:
-                # FIXME: the '' is a workaround because our regex now matches
-                #   '' at the end of a list if it has a trailing comma
-                single = None
-            else:
-                single = single or '""'
-                single = self._unquote(single)
+            single = self._unquote(single)
         if list_values == '':
             # not a list value
             return (single, comment)
@@ -1892,9 +1667,30 @@
             the_list += [single]
         return (the_list, comment)
 
-
     def _multiline(self, value, infile, cur_index, maxline):
-        """Extract the value, where we are in a multiline situation."""
+        """
+        Extract the value, where we are in a multiline situation
+        
+        Testing multiline values.
+        
+        >>> i == {
+        ...     'name4': ' another single line value ',
+        ...     'multi section': {
+        ...         'name4': '\\n        Well, this is a\\n        multiline '
+        ...             'value\\n        ',
+        ...         'name2': '\\n        Well, this is a\\n        multiline '
+        ...             'value\\n        ',
+        ...         'name3': '\\n        Well, this is a\\n        multiline '
+        ...             'value\\n        ',
+        ...         'name1': '\\n        Well, this is a\\n        multiline '
+        ...             'value\\n        ',
+        ...     },
+        ...     'name2': ' another single line value ',
+        ...     'name3': ' a single line value ',
+        ...     'name1': ' a single line value ',
+        ... }
+        1
+        """
         quot = value[:3]
         newvalue = value[3:]
         single_line = self._triple_quote[quot][0]
@@ -1906,7 +1702,7 @@
             return retval
         elif newvalue.find(quot) != -1:
             # somehow the triple quote is missing
-            raise SyntaxError()
+            raise SyntaxError
         #
         while cur_index < maxline:
             cur_index += 1
@@ -1919,68 +1715,46 @@
                 break
         else:
             # we've got to the end of the config, oops...
-            raise SyntaxError()
+            raise SyntaxError
         mat = multi_line.match(line)
         if mat is None:
             # a badly formed line
-            raise SyntaxError()
+            raise SyntaxError
         (value, comment) = mat.groups()
         return (newvalue + value, comment, cur_index)
 
-
     def _handle_configspec(self, configspec):
         """Parse the configspec."""
-        # FIXME: Should we check that the configspec was created with the 
-        #        correct settings ? (i.e. ``list_values=False``)
-        if not isinstance(configspec, ConfigObj):
-            try:
-                configspec = ConfigObj(configspec,
-                                       raise_errors=True,
-                                       file_error=True,
-                                       list_values=False)
-            except ConfigObjError, e:
-                # FIXME: Should these errors have a reference
-                #        to the already parsed ConfigObj ?
-                raise ConfigspecError('Parsing configspec failed: %s' % e)
-            except IOError, e:
-                raise IOError('Reading configspec failed: %s' % e)
-        
+        try:
+            configspec = ConfigObj(
+                configspec,
+                raise_errors=True,
+                file_error=True,
+                list_values=False)
+        except ConfigObjError, e:
+            # FIXME: Should these errors have a reference
+            # to the already parsed ConfigObj ?
+            raise ConfigspecError('Parsing configspec failed: %s' % e)
+        except IOError, e:
+            raise IOError('Reading configspec failed: %s' % e)
         self._set_configspec_value(configspec, self)
 
-
     def _set_configspec_value(self, configspec, section):
         """Used to recursively set configspec values."""
         if '__many__' in configspec.sections:
             section.configspec['__many__'] = configspec['__many__']
             if len(configspec.sections) > 1:
                 # FIXME: can we supply any useful information here ?
-                raise RepeatSectionError()
-            
-        if getattr(configspec, 'initial_comment', None) is not None:
-            section._configspec_initial_comment = configspec.initial_comment
-            section._configspec_final_comment = configspec.final_comment
-            section._configspec_encoding = configspec.encoding
-            section._configspec_BOM = configspec.BOM
-            section._configspec_newlines = configspec.newlines
-            section._configspec_indent_type = configspec.indent_type
-            
+                raise RepeatSectionError
         for entry in configspec.scalars:
-            section._configspec_comments[entry] = configspec.comments[entry]
-            section._configspec_inline_comments[entry] = configspec.inline_comments[entry]
             section.configspec[entry] = configspec[entry]
-            section._order.append(entry)
-            
         for entry in configspec.sections:
             if entry == '__many__':
                 continue
-            
-            section._cs_section_comments[entry] = configspec.comments[entry]
-            section._cs_section_inline_comments[entry] = configspec.inline_comments[entry]
-            if not section.has_key(entry):
+            if entry not in section:
                 section[entry] = {}
             self._set_configspec_value(configspec[entry], section[entry])
 
-
     def _handle_repeat(self, section, configspec):
         """Dynamically assign configspec for repeated section."""
         try:
@@ -1991,11 +1765,9 @@
                                 if isinstance(configspec[entry], dict)]
             scalar_keys = [entry for entry in configspec 
                                 if not isinstance(configspec[entry], dict)]
-            
         if '__many__' in section_keys and len(section_keys) > 1:
             # FIXME: can we supply any useful information here ?
-            raise RepeatSectionError()
-        
+            raise RepeatSectionError
         scalars = {}
         sections = {}
         for entry in scalar_keys:
@@ -2007,46 +1779,81 @@
                 scalars[entry] = val
                 continue
             sections[entry] = val
-            
+        #
         section.configspec = scalars
         for entry in sections:
-            if not section.has_key(entry):
+            if entry not in section:
                 section[entry] = {}
             self._handle_repeat(section[entry], sections[entry])
 
-
     def _write_line(self, indent_string, entry, this_entry, comment):
         """Write an individual line, for the write method"""
         # NOTE: the calls to self._quote here handles non-StringType values.
-        if not self.unrepr:
-            val = self._decode_element(self._quote(this_entry))
-        else:
-            val = repr(this_entry)
-        return '%s%s%s%s%s' % (indent_string,
-                               self._decode_element(self._quote(entry, multiline=False)),
-                               self._a_to_u(' = '),
-                               val,
-                               self._decode_element(comment))
-
+        return '%s%s%s%s%s' % (
+            indent_string,
+            self._decode_element(self._quote(entry, multiline=False)),
+            self._a_to_u(' = '),
+            self._decode_element(self._quote(this_entry)),
+            self._decode_element(comment))
 
     def _write_marker(self, indent_string, depth, entry, comment):
         """Write a section marker line"""
-        return '%s%s%s%s%s' % (indent_string,
-                               self._a_to_u('[' * depth),
-                               self._quote(self._decode_element(entry), multiline=False),
-                               self._a_to_u(']' * depth),
-                               self._decode_element(comment))
-
+        return '%s%s%s%s%s' % (
+            indent_string,
+            self._a_to_u('[' * depth),
+            self._quote(self._decode_element(entry), multiline=False),
+            self._a_to_u(']' * depth),
+            self._decode_element(comment))
 
     def _handle_comment(self, comment):
-        """Deal with a comment."""
+        """
+        Deal with a comment.
+        
+        >>> filename = a.filename
+        >>> a.filename = None
+        >>> values = a.write()
+        >>> index = 0
+        >>> while index < 23:
+        ...     index += 1
+        ...     line = values[index-1]
+        ...     assert line.endswith('# comment ' + str(index))
+        >>> a.filename = filename
+        
+        >>> start_comment = ['# Initial Comment', '', '#']
+        >>> end_comment = ['', '#', '# Final Comment']
+        >>> newconfig = start_comment + testconfig1.split('\\n') + end_comment
+        >>> nc = ConfigObj(newconfig)
+        >>> nc.initial_comment
+        ['# Initial Comment', '', '#']
+        >>> nc.final_comment
+        ['', '#', '# Final Comment']
+        >>> nc.initial_comment == start_comment
+        1
+        >>> nc.final_comment == end_comment
+        1
+        """
         if not comment:
             return ''
-        start = self.indent_type
+        if self.indent_type == '\t':
+            start = self._a_to_u('\t')
+        else:
+            start = self._a_to_u(' ' * NUM_INDENT_SPACES)
         if not comment.startswith('#'):
-            start += self._a_to_u(' # ')
+            start += _a_to_u('# ')
         return (start + comment)
 
+    def _compute_indent_string(self, depth):
+        """
+        Compute the indent string, according to current indent_type and depth
+        """
+        if self.indent_type == '':
+            # no indentation at all
+            return ''
+        if self.indent_type == '\t':
+            return '\t' * depth
+        if self.indent_type == ' ':
+            return ' ' * NUM_INDENT_SPACES * depth
+        raise SyntaxError
 
     # Public methods
 
@@ -2062,11 +1869,27 @@
         >>> a.filename = filename
         >>> a == ConfigObj('test.ini', raise_errors=True)
         1
+        >>> os.remove('test.ini')
+        >>> b.filename = 'test.ini'
+        >>> b.write()
+        >>> b == ConfigObj('test.ini', raise_errors=True)
+        1
+        >>> os.remove('test.ini')
+        >>> i.filename = 'test.ini'
+        >>> i.write()
+        >>> i == ConfigObj('test.ini', raise_errors=True)
+        1
+        >>> os.remove('test.ini')
+        >>> a = ConfigObj()
+        >>> a['DEFAULT'] = {'a' : 'fish'}
+        >>> a['a'] = '%(a)s'
+        >>> a.write()
+        ['a = %(a)s', '[DEFAULT]', 'a = fish']
         """
         if self.indent_type is None:
             # this can be true if initialised from a dictionary
             self.indent_type = DEFAULT_INDENT_TYPE
-            
+        #
         out = []
         cs = self._a_to_u('#')
         csp = self._a_to_u('# ')
@@ -2080,8 +1903,9 @@
                 if stripped_line and not stripped_line.startswith(cs):
                     line = csp + line
                 out.append(line)
-                
-        indent_string = self.indent_type * section.depth
+        #
+        indent_string = self._a_to_u(
+            self._compute_indent_string(section.depth))
         for entry in (section.scalars + section.sections):
             if entry in section.defaults:
                 # don't write out default values
@@ -2093,7 +1917,7 @@
                 out.append(indent_string + comment_line)
             this_entry = section[entry]
             comment = self._handle_comment(section.inline_comments[entry])
-            
+            #
             if isinstance(this_entry, dict):
                 # a section
                 out.append(self._write_marker(
@@ -2108,7 +1932,7 @@
                     entry,
                     this_entry,
                     comment))
-                
+        #
         if section is self:
             for line in self.final_comment:
                 line = self._decode_element(line)
@@ -2117,10 +1941,10 @@
                     line = csp + line
                 out.append(line)
             self.interpolation = int_val
-            
+        #
         if section is not self:
             return out
-        
+        #
         if (self.filename is None) and (outfile is None):
             # output a list of lines
             # might need to encode
@@ -2134,28 +1958,24 @@
                     out.append('')
                 out[0] = BOM_UTF8 + out[0]
             return out
-        
+        #
         # Turn the list to a string, joined with correct newlines
-        newline = self.newlines or os.linesep
-        output = self._a_to_u(newline).join(out)
+        output = (self._a_to_u(self.newlines or os.linesep)
+            ).join(out)
         if self.encoding:
             output = output.encode(self.encoding)
-        if self.BOM and ((self.encoding is None) or match_utf8(self.encoding)):
+        if (self.BOM and ((self.encoding is None) or
+            (BOM_LIST.get(self.encoding.lower()) == 'utf_8'))):
             # Add the UTF8 BOM
             output = BOM_UTF8 + output
-            
-        if not output.endswith(newline):
-            output += newline
         if outfile is not None:
             outfile.write(output)
         else:
-            h = open(self.filename, 'wb')
+            h = open(self.filename, 'w')
             h.write(output)
             h.close()
 
-
-    def validate(self, validator, preserve_errors=False, copy=False,
-                 section=None):
+    def validate(self, validator, preserve_errors=False, section=None):
         """
         Test the ConfigObj against a configspec.
         
@@ -2180,7 +2000,7 @@
         If ``preserve_errors`` is ``True`` (``False`` is default) then instead
         of a marking a fail with a ``False``, it will preserve the actual
         exception object. This can contain info about the reason for failure.
-        For example the ``VdtValueTooSmallError`` indicates that the value
+        For example the ``VdtValueTooSmallError`` indeicates that the value
         supplied was too small. If a value (or section) is missing it will
         still be marked as ``False``.
         
@@ -2189,26 +2009,390 @@
         You can then use the ``flatten_errors`` function to turn your nested
         results dictionary into a flattened list of failures - useful for
         displaying meaningful error messages.
+        
+        >>> try:
+        ...     from validate import Validator
+        ... except ImportError:
+        ...     sys.stderr.write('Cannot import the Validator object, skipping the related tests\n')
+        ... else:
+        ...     config = '''
+        ...     test1=40
+        ...     test2=hello
+        ...     test3=3
+        ...     test4=5.0
+        ...     [section]
+        ...         test1=40
+        ...         test2=hello
+        ...         test3=3
+        ...         test4=5.0
+        ...         [[sub section]]
+        ...             test1=40
+        ...             test2=hello
+        ...             test3=3
+        ...             test4=5.0
+        ... '''.split('\\n')
+        ...     configspec = '''
+        ...     test1= integer(30,50)
+        ...     test2= string
+        ...     test3=integer
+        ...     test4=float(6.0)
+        ...     [section ]
+        ...         test1=integer(30,50)
+        ...         test2=string
+        ...         test3=integer
+        ...         test4=float(6.0)
+        ...         [[sub section]]
+        ...             test1=integer(30,50)
+        ...             test2=string
+        ...             test3=integer
+        ...             test4=float(6.0)
+        ...     '''.split('\\n')
+        ...     val = Validator()
+        ...     c1 = ConfigObj(config, configspec=configspec)
+        ...     test = c1.validate(val)
+        ...     test == {
+        ...         'test1': True,
+        ...         'test2': True,
+        ...         'test3': True,
+        ...         'test4': False,
+        ...         'section': {
+        ...             'test1': True,
+        ...             'test2': True,
+        ...             'test3': True,
+        ...             'test4': False,
+        ...             'sub section': {
+        ...                 'test1': True,
+        ...                 'test2': True,
+        ...                 'test3': True,
+        ...                 'test4': False,
+        ...             },
+        ...         },
+        ...     }
+        1
+        >>> val.check(c1.configspec['test4'], c1['test4'])
+        Traceback (most recent call last):
+        VdtValueTooSmallError: the value "5.0" is too small.
+        
+        >>> val_test_config = '''
+        ...     key = 0
+        ...     key2 = 1.1
+        ...     [section]
+        ...     key = some text
+        ...     key2 = 1.1, 3.0, 17, 6.8
+        ...         [[sub-section]]
+        ...         key = option1
+        ...         key2 = True'''.split('\\n')
+        >>> val_test_configspec = '''
+        ...     key = integer
+        ...     key2 = float
+        ...     [section]
+        ...     key = string
+        ...     key2 = float_list(4)
+        ...        [[sub-section]]
+        ...        key = option(option1, option2)
+        ...        key2 = boolean'''.split('\\n')
+        >>> val_test = ConfigObj(val_test_config, configspec=val_test_configspec)
+        >>> val_test.validate(val)
+        1
+        >>> val_test['key'] = 'text not a digit'
+        >>> val_res = val_test.validate(val)
+        >>> val_res == {'key2': True, 'section': True, 'key': False}
+        1
+        >>> configspec = '''
+        ...     test1=integer(30,50, default=40)
+        ...     test2=string(default="hello")
+        ...     test3=integer(default=3)
+        ...     test4=float(6.0, default=6.0)
+        ...     [section ]
+        ...         test1=integer(30,50, default=40)
+        ...         test2=string(default="hello")
+        ...         test3=integer(default=3)
+        ...         test4=float(6.0, default=6.0)
+        ...         [[sub section]]
+        ...             test1=integer(30,50, default=40)
+        ...             test2=string(default="hello")
+        ...             test3=integer(default=3)
+        ...             test4=float(6.0, default=6.0)
+        ...     '''.split('\\n')
+        >>> default_test = ConfigObj(['test1=30'], configspec=configspec)
+        >>> default_test
+        {'test1': '30', 'section': {'sub section': {}}}
+        >>> default_test.validate(val)
+        1
+        >>> default_test == {
+        ...     'test1': 30,
+        ...     'test2': 'hello',
+        ...     'test3': 3,
+        ...     'test4': 6.0,
+        ...     'section': {
+        ...         'test1': 40,
+        ...         'test2': 'hello',
+        ...         'test3': 3,
+        ...         'test4': 6.0,
+        ...         'sub section': {
+        ...             'test1': 40,
+        ...             'test3': 3,
+        ...             'test2': 'hello',
+        ...             'test4': 6.0,
+        ...         },
+        ...     },
+        ... }
+        1
+        
+        Now testing with repeated sections : BIG TEST
+        
+        >>> repeated_1 = '''
+        ... [dogs]
+        ...     [[__many__]] # spec for a dog
+        ...         fleas = boolean(default=True)
+        ...         tail = option(long, short, default=long)
+        ...         name = string(default=rover)
+        ...         [[[__many__]]]  # spec for a puppy
+        ...             name = string(default="son of rover")
+        ...             age = float(default=0.0)
+        ... [cats]
+        ...     [[__many__]] # spec for a cat
+        ...         fleas = boolean(default=True)
+        ...         tail = option(long, short, default=short)
+        ...         name = string(default=pussy)
+        ...         [[[__many__]]] # spec for a kitten
+        ...             name = string(default="son of pussy")
+        ...             age = float(default=0.0)
+        ...         '''.split('\\n')
+        >>> repeated_2 = '''
+        ... [dogs]
+        ... 
+        ...     # blank dogs with puppies
+        ...     # should be filled in by the configspec
+        ...     [[dog1]]
+        ...         [[[puppy1]]]
+        ...         [[[puppy2]]]
+        ...         [[[puppy3]]]
+        ...     [[dog2]]
+        ...         [[[puppy1]]]
+        ...         [[[puppy2]]]
+        ...         [[[puppy3]]]
+        ...     [[dog3]]
+        ...         [[[puppy1]]]
+        ...         [[[puppy2]]]
+        ...         [[[puppy3]]]
+        ... [cats]
+        ... 
+        ...     # blank cats with kittens
+        ...     # should be filled in by the configspec
+        ...     [[cat1]]
+        ...         [[[kitten1]]]
+        ...         [[[kitten2]]]
+        ...         [[[kitten3]]]
+        ...     [[cat2]]
+        ...         [[[kitten1]]]
+        ...         [[[kitten2]]]
+        ...         [[[kitten3]]]
+        ...     [[cat3]]
+        ...         [[[kitten1]]]
+        ...         [[[kitten2]]]
+        ...         [[[kitten3]]]
+        ... '''.split('\\n')
+        >>> repeated_3 = '''
+        ... [dogs]
+        ... 
+        ...     [[dog1]]
+        ...     [[dog2]]
+        ...     [[dog3]]
+        ... [cats]
+        ... 
+        ...     [[cat1]]
+        ...     [[cat2]]
+        ...     [[cat3]]
+        ... '''.split('\\n')
+        >>> repeated_4 = '''
+        ... [__many__]
+        ... 
+        ...     name = string(default=Michael)
+        ...     age = float(default=0.0)
+        ...     sex = option(m, f, default=m)
+        ... '''.split('\\n')
+        >>> repeated_5 = '''
+        ... [cats]
+        ... [[__many__]]
+        ...     fleas = boolean(default=True)
+        ...     tail = option(long, short, default=short)
+        ...     name = string(default=pussy)
+        ...     [[[description]]]
+        ...         height = float(default=3.3)
+        ...         weight = float(default=6)
+        ...         [[[[coat]]]]
+        ...             fur = option(black, grey, brown, "tortoise shell", default=black)
+        ...             condition = integer(0,10, default=5)
+        ... '''.split('\\n')
+        >>> from validate import Validator
+        >>> val= Validator()
+        >>> repeater = ConfigObj(repeated_2, configspec=repeated_1)
+        >>> repeater.validate(val)
+        1
+        >>> repeater == {
+        ...     'dogs': {
+        ...         'dog1': {
+        ...             'fleas': True,
+        ...             'tail': 'long',
+        ...             'name': 'rover',
+        ...             'puppy1': {'name': 'son of rover', 'age': 0.0},
+        ...             'puppy2': {'name': 'son of rover', 'age': 0.0},
+        ...             'puppy3': {'name': 'son of rover', 'age': 0.0},
+        ...         },
+        ...         'dog2': {
+        ...             'fleas': True,
+        ...             'tail': 'long',
+        ...             'name': 'rover',
+        ...             'puppy1': {'name': 'son of rover', 'age': 0.0},
+        ...             'puppy2': {'name': 'son of rover', 'age': 0.0},
+        ...             'puppy3': {'name': 'son of rover', 'age': 0.0},
+        ...         },
+        ...         'dog3': {
+        ...             'fleas': True,
+        ...             'tail': 'long',
+        ...             'name': 'rover',
+        ...             'puppy1': {'name': 'son of rover', 'age': 0.0},
+        ...             'puppy2': {'name': 'son of rover', 'age': 0.0},
+        ...             'puppy3': {'name': 'son of rover', 'age': 0.0},
+        ...         },
+        ...     },
+        ...     'cats': {
+        ...         'cat1': {
+        ...             'fleas': True,
+        ...             'tail': 'short',
+        ...             'name': 'pussy',
+        ...             'kitten1': {'name': 'son of pussy', 'age': 0.0},
+        ...             'kitten2': {'name': 'son of pussy', 'age': 0.0},
+        ...             'kitten3': {'name': 'son of pussy', 'age': 0.0},
+        ...         },
+        ...         'cat2': {
+        ...             'fleas': True,
+        ...             'tail': 'short',
+        ...             'name': 'pussy',
+        ...             'kitten1': {'name': 'son of pussy', 'age': 0.0},
+        ...             'kitten2': {'name': 'son of pussy', 'age': 0.0},
+        ...             'kitten3': {'name': 'son of pussy', 'age': 0.0},
+        ...         },
+        ...         'cat3': {
+        ...             'fleas': True,
+        ...             'tail': 'short',
+        ...             'name': 'pussy',
+        ...             'kitten1': {'name': 'son of pussy', 'age': 0.0},
+        ...             'kitten2': {'name': 'son of pussy', 'age': 0.0},
+        ...             'kitten3': {'name': 'son of pussy', 'age': 0.0},
+        ...         },
+        ...     },
+        ... }
+        1
+        >>> repeater = ConfigObj(repeated_3, configspec=repeated_1)
+        >>> repeater.validate(val)
+        1
+        >>> repeater == {
+        ...     'cats': {
+        ...         'cat1': {'fleas': True, 'tail': 'short', 'name': 'pussy'},
+        ...         'cat2': {'fleas': True, 'tail': 'short', 'name': 'pussy'},
+        ...         'cat3': {'fleas': True, 'tail': 'short', 'name': 'pussy'},
+        ...     },
+        ...     'dogs': {
+        ...         'dog1': {'fleas': True, 'tail': 'long', 'name': 'rover'},
+        ...         'dog2': {'fleas': True, 'tail': 'long', 'name': 'rover'},
+        ...         'dog3': {'fleas': True, 'tail': 'long', 'name': 'rover'},
+        ...     },
+        ... }
+        1
+        >>> repeater = ConfigObj(configspec=repeated_4)
+        >>> repeater['Michael'] = {}
+        >>> repeater.validate(val)
+        1
+        >>> repeater == {
+        ...     'Michael': {'age': 0.0, 'name': 'Michael', 'sex': 'm'},
+        ... }
+        1
+        >>> repeater = ConfigObj(repeated_3, configspec=repeated_5)
+        >>> repeater == {
+        ...     'dogs': {'dog1': {}, 'dog2': {}, 'dog3': {}},
+        ...     'cats': {'cat1': {}, 'cat2': {}, 'cat3': {}},
+        ... }
+        1
+        >>> repeater.validate(val)
+        1
+        >>> repeater == {
+        ...     'dogs': {'dog1': {}, 'dog2': {}, 'dog3': {}},
+        ...     'cats': {
+        ...         'cat1': {
+        ...             'fleas': True,
+        ...             'tail': 'short',
+        ...             'name': 'pussy',
+        ...             'description': {
+        ...                 'weight': 6.0,
+        ...                 'height': 3.2999999999999998,
+        ...                 'coat': {'fur': 'black', 'condition': 5},
+        ...             },
+        ...         },
+        ...         'cat2': {
+        ...             'fleas': True,
+        ...             'tail': 'short',
+        ...             'name': 'pussy',
+        ...             'description': {
+        ...                 'weight': 6.0,
+        ...                 'height': 3.2999999999999998,
+        ...                 'coat': {'fur': 'black', 'condition': 5},
+        ...             },
+        ...         },
+        ...         'cat3': {
+        ...             'fleas': True,
+        ...             'tail': 'short',
+        ...             'name': 'pussy',
+        ...             'description': {
+        ...                 'weight': 6.0,
+        ...                 'height': 3.2999999999999998,
+        ...                 'coat': {'fur': 'black', 'condition': 5},
+        ...             },
+        ...         },
+        ...     },
+        ... }
+        1
+        
+        Test that interpolation is preserved for validated string values.
+        Also check that interpolation works in configspecs.
+        >>> t = ConfigObj()
+        >>> t['DEFAULT'] = {}
+        >>> t['DEFAULT']['test'] = 'a'
+        >>> t['test'] = '%(test)s'
+        >>> t['test']
+        'a'
+        >>> v = Validator()
+        >>> t.configspec = {'test': 'string'}
+        >>> t.validate(v)
+        1
+        >>> t.interpolation = False
+        >>> t
+        {'test': '%(test)s', 'DEFAULT': {'test': 'a'}}
+        >>> specs = [
+        ...    'interpolated string  = string(default="fuzzy-%(man)s")',
+        ...    '[DEFAULT]',
+        ...    'man = wuzzy',
+        ...    ]
+        >>> c = ConfigObj(configspec=specs)
+        >>> c.validate(v)
+        1
+        >>> c['interpolated string']
+        'fuzzy-wuzzy'
+        
+        FIXME: Above tests will fail if we couldn't import Validator (the ones
+        that don't raise errors will produce different output and still fail as
+        tests)
         """
         if section is None:
             if self.configspec is None:
-                raise ValueError('No configspec supplied.')
+                raise ValueError, 'No configspec supplied.'
             if preserve_errors:
-                # We do this once to remove a top level dependency on the validate module
-                # Which makes importing configobj faster
-                from validate import VdtMissingValue
-                self._vdtMissingValue = VdtMissingValue
+                if VdtMissingValue is None:
+                    raise ImportError('Missing validate module.')
             section = self
         #
         spec_section = section.configspec
-        if copy and getattr(section, '_configspec_initial_comment', None) is not None:
-            section.initial_comment = section._configspec_initial_comment
-            section.final_comment = section._configspec_final_comment
-            section.encoding = section._configspec_encoding
-            section.BOM = section._configspec_BOM
-            section.newlines = section._configspec_newlines
-            section.indent_type = section._configspec_indent_type
-            
         if '__many__' in section.configspec:
             many = spec_section['__many__']
             # dynamically assign the configspecs
@@ -2219,9 +2403,7 @@
         out = {}
         ret_true = True
         ret_false = True
-        order = [k for k in section._order if k in spec_section]
-        order += [k for k in spec_section if k not in order]
-        for entry in order:
+        for entry in spec_section:
             if entry == '__many__':
                 continue
             if (not entry in section.scalars) or (entry in section.defaults):
@@ -2229,13 +2411,6 @@
                 # or entries from defaults
                 missing = True
                 val = None
-                if copy and not entry in section.scalars:
-                    # copy comments
-                    section.comments[entry] = (
-                        section._configspec_comments.get(entry, []))
-                    section.inline_comments[entry] = (
-                        section._configspec_inline_comments.get(entry, ''))
-                #
             else:
                 missing = False
                 val = section[entry]
@@ -2245,7 +2420,7 @@
                                         missing=missing
                                         )
             except validator.baseErrorClass, e:
-                if not preserve_errors or isinstance(e, self._vdtMissingValue):
+                if not preserve_errors or isinstance(e, VdtMissingValue):
                     out[entry] = False
                 else:
                     # preserve the error
@@ -2253,22 +2428,6 @@
                     ret_false = False
                 ret_true = False
             else:
-                try: 
-                    section.default_values.pop(entry, None)
-                except AttributeError: 
-                    # For Python 2.2 compatibility
-                    try:
-                        del section.default_values[entry]
-                    except KeyError:
-                        pass
-                    
-                if getattr(validator, 'get_default_value', None) is not None:
-                    try: 
-                        section.default_values[entry] = validator.get_default_value(spec_section[entry])
-                    except KeyError:
-                        # No default
-                        pass
-                    
                 ret_false = False
                 out[entry] = True
                 if self.stringify or missing:
@@ -2285,20 +2444,15 @@
                             check = self._str(check)
                     if (check != val) or missing:
                         section[entry] = check
-                if not copy and missing and entry not in section.defaults:
+                if missing and entry not in section.defaults:
                     section.defaults.append(entry)
-        # Missing sections will have been created as empty ones when the
-        # configspec was read.
+        #
+        # FIXME: Will this miss missing sections ?
         for entry in section.sections:
-            # FIXME: this means DEFAULT is not copied in copy mode
             if section is self and entry == 'DEFAULT':
                 continue
-            if copy:
-                section.comments[entry] = section._cs_section_comments[entry]
-                section.inline_comments[entry] = (
-                    section._cs_section_inline_comments[entry])
             check = self.validate(validator, preserve_errors=preserve_errors,
-                copy=copy, section=section[entry])
+                section=section[entry])
             out[entry] = check
             if check == False:
                 ret_true = False
@@ -2312,45 +2466,8 @@
             return True
         elif ret_false:
             return False
-        return out
-
-
-    def reset(self):
-        """Clear ConfigObj instance and restore to 'freshly created' state."""
-        self.clear()
-        self._initialise()
-        # FIXME: Should be done by '_initialise', but ConfigObj constructor (and reload)
-        #        requires an empty dictionary
-        self.configspec = None
-        # Just to be sure ;-)
-        self._original_configspec = None
-        
-        
-    def reload(self):
-        """
-        Reload a ConfigObj from file.
-        
-        This method raises a ``ReloadError`` if the ConfigObj doesn't have
-        a filename attribute pointing to a file.
-        """
-        if not isinstance(self.filename, StringTypes):
-            raise ReloadError()
-
-        filename = self.filename
-        current_options = {}
-        for entry in OPTION_DEFAULTS:
-            if entry == 'configspec':
-                continue
-            current_options[entry] = getattr(self, entry)
-            
-        configspec = self._original_configspec
-        current_options['configspec'] = configspec
-            
-        self.clear()
-        self._initialise(current_options)
-        self._load(filename, configspec)
-        
-
+        else:
+            return out
 
 class SimpleVal(object):
     """
@@ -2362,6 +2479,46 @@
     method of your ``ConfigObj``. ``validate`` will return ``True`` if all
     members are present, or a dictionary with True/False meaning
     present/missing. (Whole missing sections will be replaced with ``False``)
+    
+    >>> val = SimpleVal()
+    >>> config = '''
+    ... test1=40
+    ... test2=hello
+    ... test3=3
+    ... test4=5.0
+    ... [section]
+    ... test1=40
+    ... test2=hello
+    ... test3=3
+    ... test4=5.0
+    ...     [[sub section]]
+    ...     test1=40
+    ...     test2=hello
+    ...     test3=3
+    ...     test4=5.0
+    ... '''.split('\\n')
+    >>> configspec = '''
+    ... test1=''
+    ... test2=''
+    ... test3=''
+    ... test4=''
+    ... [section]
+    ... test1=''
+    ... test2=''
+    ... test3=''
+    ... test4=''
+    ...     [[sub section]]
+    ...     test1=''
+    ...     test2=''
+    ...     test3=''
+    ...     test4=''
+    ... '''.split('\\n')
+    >>> o = ConfigObj(config, configspec=configspec)
+    >>> o.validate(val)
+    1
+    >>> o = ConfigObj(configspec=configspec)
+    >>> o.validate(val)
+    0
     """
     
     def __init__(self):
@@ -2370,10 +2527,9 @@
     def check(self, check, member, missing=False):
         """A dummy check method, always returns the value unchanged."""
         if missing:
-            raise self.baseErrorClass()
+            raise self.baseErrorClass
         return member
 
-
 # Check / processing functions for options
 def flatten_errors(cfg, res, levels=None, results=None):
     """
@@ -2407,6 +2563,7 @@
     
     For example *The value "3" is of the wrong type*.
     
+    # FIXME: is the ordering of the output arbitrary ?
     >>> import validate
     >>> vtor = validate.Validator()
     >>> my_ini = '''
@@ -2498,4 +2655,850 @@
     return results
 
 
-"""*A programming language is a medium of expression.* - Paul Graham"""
+# FIXME: test error code for badly built multiline values
+# FIXME: test handling of StringIO
+# FIXME: test interpolation with writing
+
+def _doctest():
+    """
+    Dummy function to hold some of the doctests.
+    
+    >>> a.depth
+    0
+    >>> a == {
+    ...     'key2': 'val',
+    ...     'key1': 'val',
+    ...     'lev1c': {
+    ...         'lev2c': {
+    ...             'lev3c': {
+    ...                 'key1': 'val',
+    ...             },
+    ...         },
+    ...     },
+    ...     'lev1b': {
+    ...         'key2': 'val',
+    ...         'key1': 'val',
+    ...         'lev2ba': {
+    ...             'key1': 'val',
+    ...         },
+    ...         'lev2bb': {
+    ...             'key1': 'val',
+    ...         },
+    ...     },
+    ...     'lev1a': {
+    ...         'key2': 'val',
+    ...         'key1': 'val',
+    ...     },
+    ... }
+    1
+    >>> b.depth
+    0
+    >>> b == {
+    ...     'key3': 'val3',
+    ...     'key2': 'val2',
+    ...     'key1': 'val1',
+    ...     'section 1': {
+    ...         'keys11': 'val1',
+    ...         'keys13': 'val3',
+    ...         'keys12': 'val2',
+    ...     },
+    ...     'section 2': {
+    ...         'section 2 sub 1': {
+    ...             'fish': '3',
+    ...     },
+    ...     'keys21': 'val1',
+    ...     'keys22': 'val2',
+    ...     'keys23': 'val3',
+    ...     },
+    ... }
+    1
+    >>> t = '''
+    ... 'a' = b # !"$%^&*(),::;'@~#= 33
+    ... "b" = b #= 6, 33
+    ... ''' .split('\\n')
+    >>> t2 = ConfigObj(t)
+    >>> assert t2 == {'a': 'b', 'b': 'b'}
+    >>> t2.inline_comments['b'] = ''
+    >>> del t2['a']
+    >>> assert t2.write() == ['','b = b', '']
+    
+    # Test ``list_values=False`` stuff
+    >>> c = '''
+    ...     key1 = no quotes
+    ...     key2 = 'single quotes'
+    ...     key3 = "double quotes"
+    ...     key4 = "list", 'with', several, "quotes"
+    ...     '''
+    >>> cfg = ConfigObj(c.splitlines(), list_values=False)
+    >>> cfg == {'key1': 'no quotes', 'key2': "'single quotes'", 
+    ... 'key3': '"double quotes"', 
+    ... 'key4': '"list", \\'with\\', several, "quotes"'
+    ... }
+    1
+    >>> cfg = ConfigObj(list_values=False)
+    >>> cfg['key1'] = 'Multiline\\nValue'
+    >>> cfg['key2'] = '''"Value" with 'quotes' !'''
+    >>> cfg.write()
+    ["key1 = '''Multiline\\nValue'''", 'key2 = "Value" with \\'quotes\\' !']
+    >>> cfg.list_values = True
+    >>> cfg.write() == ["key1 = '''Multiline\\nValue'''",
+    ... 'key2 = \\'\\'\\'"Value" with \\'quotes\\' !\\'\\'\\'']
+    1
+    
+    Test flatten_errors:
+    
+    >>> from validate import Validator, VdtValueTooSmallError
+    >>> config = '''
+    ...     test1=40
+    ...     test2=hello
+    ...     test3=3
+    ...     test4=5.0
+    ...     [section]
+    ...         test1=40
+    ...         test2=hello
+    ...         test3=3
+    ...         test4=5.0
+    ...         [[sub section]]
+    ...             test1=40
+    ...             test2=hello
+    ...             test3=3
+    ...             test4=5.0
+    ... '''.split('\\n')
+    >>> configspec = '''
+    ...     test1= integer(30,50)
+    ...     test2= string
+    ...     test3=integer
+    ...     test4=float(6.0)
+    ...     [section ]
+    ...         test1=integer(30,50)
+    ...         test2=string
+    ...         test3=integer
+    ...         test4=float(6.0)
+    ...         [[sub section]]
+    ...             test1=integer(30,50)
+    ...             test2=string
+    ...             test3=integer
+    ...             test4=float(6.0)
+    ...     '''.split('\\n')
+    >>> val = Validator()
+    >>> c1 = ConfigObj(config, configspec=configspec)
+    >>> res = c1.validate(val)
+    >>> flatten_errors(c1, res) == [([], 'test4', False), (['section', 
+    ...     'sub section'], 'test4', False), (['section'], 'test4', False)]
+    True
+    >>> res = c1.validate(val, preserve_errors=True)
+    >>> check = flatten_errors(c1, res)
+    >>> check[0][:2]
+    ([], 'test4')
+    >>> check[1][:2]
+    (['section', 'sub section'], 'test4')
+    >>> check[2][:2]
+    (['section'], 'test4')
+    >>> for entry in check:
+    ...     isinstance(entry[2], VdtValueTooSmallError)
+    ...     print str(entry[2])
+    True
+    the value "5.0" is too small.
+    True
+    the value "5.0" is too small.
+    True
+    the value "5.0" is too small.
+    
+    Test unicode handling, BOM, write witha file like object and line endings :
+    >>> u_base = '''
+    ... # initial comment
+    ...     # inital comment 2
+    ... 
+    ... test1 = some value
+    ... # comment
+    ... test2 = another value    # inline comment
+    ... # section comment
+    ... [section]    # inline comment
+    ...     test = test    # another inline comment
+    ...     test2 = test2
+    ... 
+    ... # final comment
+    ... # final comment2
+    ... '''
+    >>> u = u_base.encode('utf_8').splitlines(True)
+    >>> u[0] = BOM_UTF8 + u[0]
+    >>> uc = ConfigObj(u)
+    >>> uc.encoding = None
+    >>> uc.BOM == True
+    1
+    >>> uc == {'test1': 'some value', 'test2': 'another value',
+    ... 'section': {'test': 'test', 'test2': 'test2'}}
+    1
+    >>> uc = ConfigObj(u, encoding='utf_8', default_encoding='latin-1')
+    >>> uc.BOM
+    1
+    >>> isinstance(uc['test1'], unicode)
+    1
+    >>> uc.encoding
+    'utf_8'
+    >>> uc.newlines
+    '\\n'
+    >>> uc['latin1'] = "This costs lot's of "
+    >>> a_list = uc.write()
+    >>> len(a_list)
+    15
+    >>> isinstance(a_list[0], str)
+    1
+    >>> a_list[0].startswith(BOM_UTF8)
+    1
+    >>> u = u_base.replace('\\n', '\\r\\n').encode('utf_8').splitlines(True)
+    >>> uc = ConfigObj(u)
+    >>> uc.newlines
+    '\\r\\n'
+    >>> uc.newlines = '\\r'
+    >>> from cStringIO import StringIO
+    >>> file_like = StringIO()
+    >>> uc.write(file_like)
+    >>> file_like.seek(0)
+    >>> uc2 = ConfigObj(file_like)
+    >>> uc2 == uc
+    1
+    >>> uc2.filename is None
+    1
+    >>> uc2.newlines == '\\r'
+    1
+    """
+
+if __name__ == '__main__':
+    # run the code tests in doctest format
+    #
+    testconfig1 = """\
+    key1= val    # comment 1
+    key2= val    # comment 2
+    # comment 3
+    [lev1a]     # comment 4
+    key1= val    # comment 5
+    key2= val    # comment 6
+    # comment 7
+    [lev1b]    # comment 8
+    key1= val    # comment 9
+    key2= val    # comment 10
+    # comment 11
+        [[lev2ba]]    # comment 12
+        key1= val    # comment 13
+        # comment 14
+        [[lev2bb]]    # comment 15
+        key1= val    # comment 16
+    # comment 17
+    [lev1c]    # comment 18
+    # comment 19
+        [[lev2c]]    # comment 20
+        # comment 21
+            [[[lev3c]]]    # comment 22
+            key1 = val    # comment 23"""
+    #
+    testconfig2 = """\
+                        key1 = 'val1'
+                        key2 =   "val2"
+                        key3 = val3
+                        ["section 1"] # comment
+                        keys11 = val1
+                        keys12 = val2
+                        keys13 = val3
+                        [section 2]
+                        keys21 = val1
+                        keys22 = val2
+                        keys23 = val3
+                        
+                            [['section 2 sub 1']]
+                            fish = 3
+    """
+    #
+    testconfig6 = '''
+    name1 = """ a single line value """ # comment
+    name2 = \''' another single line value \''' # comment
+    name3 = """ a single line value """
+    name4 = \''' another single line value \'''
+        [ "multi section" ]
+        name1 = """
+        Well, this is a
+        multiline value
+        """
+        name2 = \'''
+        Well, this is a
+        multiline value
+        \'''
+        name3 = """
+        Well, this is a
+        multiline value
+        """     # a comment
+        name4 = \'''
+        Well, this is a
+        multiline value
+        \'''  # I guess this is a comment too
+    '''
+    #
+    import doctest
+    m = sys.modules.get('__main__')
+    globs = m.__dict__.copy()
+    a = ConfigObj(testconfig1.split('\n'), raise_errors=True)
+    b = ConfigObj(testconfig2.split('\n'), raise_errors=True)
+    i = ConfigObj(testconfig6.split('\n'), raise_errors=True)
+    globs.update({
+        'INTP_VER': INTP_VER,
+        'a': a,
+        'b': b,
+        'i': i,
+    })
+    doctest.testmod(m, globs=globs)
+
+"""
+    BUGS
+    ====
+    
+    None known.
+    
+    TODO
+    ====
+    
+    Better support for configuration from multiple files, including tracking
+    *where* the original file came from and writing changes to the correct
+    file.
+    
+    
+    Make ``newline`` an option (as well as an attribute) ?
+    
+    ``UTF16`` encoded files, when returned as a list of lines, will have the
+    BOM at the start of every line. Should this be removed from all but the
+    first line ?
+    
+    Option to set warning type for unicode decode ? (Defaults to strict).
+    
+    A method to optionally remove uniform indentation from multiline values.
+    (do as an example of using ``walk`` - along with string-escape)
+    
+    Should the results dictionary from validate be an ordered dictionary if
+    `odict <http://www.voidspace.org.uk/python/odict.html>`_ is available ?
+    
+    Implement a better ``__repr__`` ? (``ConfigObj({})``)
+    
+    Implement some of the sequence methods (which include slicing) from the
+    newer ``odict`` ?
+    
+    INCOMPATIBLE CHANGES
+    ====================
+    
+    (I have removed a lot of needless complications - this list is probably not
+    conclusive, many option/attribute/method names have changed)
+    
+    Case sensitive
+    
+    The only valid divider is '='
+    
+    We've removed line continuations with '\'
+    
+    No recursive lists in values
+    
+    No empty section
+    
+    No distinction between flatfiles and non flatfiles
+    
+    Change in list syntax - use commas to indicate list, not parentheses
+    (square brackets and parentheses are no longer recognised as lists)
+    
+    ';' is no longer valid for comments and no multiline comments
+    
+    No attribute access
+    
+    We don't allow empty values - have to use '' or ""
+    
+    In ConfigObj 3 - setting a non-flatfile member to ``None`` would
+    initialise it as an empty section.
+    
+    The escape entities '&mjf-lf;' and '&mjf-quot;' have gone
+    replaced by triple quote, multiple line values.
+    
+    The ``newline``, ``force_return``, and ``default`` options have gone
+    
+    The ``encoding`` and ``backup_encoding`` methods have gone - replaced
+    with the ``encode`` and ``decode`` methods.
+    
+    ``fileerror`` and ``createempty`` options have become ``file_error`` and
+    ``create_empty``
+    
+    Partial configspecs (for specifying the order members should be written
+    out and which should be present) have gone. The configspec is no longer
+    used to specify order for the ``write`` method.
+    
+    Exceeding the maximum depth of recursion in string interpolation now
+    raises an error ``InterpolationDepthError``.
+    
+    Specifying a value for interpolation which doesn't exist now raises an
+    error ``MissingInterpolationOption`` (instead of merely being ignored).
+    
+    The ``writein`` method has been removed.
+    
+    The comments attribute is now a list (``inline_comments`` equates to the
+    old comments attribute)
+    
+    ISSUES
+    ======
+    
+    ``validate`` doesn't report *extra* values or sections.
+    
+    You can't have a keyword with the same name as a section (in the same
+    section). They are both dictionary keys - so they would overlap.
+    
+    ConfigObj doesn't quote and unquote values if ``list_values=False``.
+    This means that leading or trailing whitespace in values will be lost when
+    writing. (Unless you manually quote).
+    
+    Interpolation checks first the 'DEFAULT' subsection of the current
+    section, next it checks the 'DEFAULT' section of the parent section,
+    last it checks the 'DEFAULT' section of the main section.
+    
+    Logically a 'DEFAULT' section should apply to all subsections of the *same
+    parent* - this means that checking the 'DEFAULT' subsection in the
+    *current section* is not necessarily logical ?
+    
+    In order to simplify unicode support (which is possibly of limited value
+    in a config file) I have removed automatic support and added the
+    ``encode`` and ``decode methods, which can be used to transform keys and
+    entries. Because the regex looks for specific values on inital parsing
+    (i.e. the quotes and the equals signs) it can only read ascii compatible
+    encodings. For unicode use ``UTF8``, which is ASCII compatible.
+    
+    Does it matter that we don't support the ':' divider, which is supported
+    by ``ConfigParser`` ?
+    
+    The regular expression correctly removes the value -
+    ``"'hello', 'goodbye'"`` and then unquote just removes the front and
+    back quotes (called from ``_handle_value``). What should we do ??
+    (*ought* to raise exception because it's an invalid value if lists are
+    off *sigh*. This is not what you want if you want to do your own list
+    processing - would be *better* in this case not to unquote.)
+    
+    String interpolation and validation don't play well together. When
+    validation changes type it sets the value. This will correctly fetch the
+    value using interpolation - but then overwrite the interpolation reference.
+    If the value is unchanged by validation (it's a string) - but other types
+    will be.
+    
+    
+    List Value Syntax
+    =================
+    
+    List values allow you to specify multiple values for a keyword. This
+    maps to a list as the resulting Python object when parsed.
+    
+    The syntax for lists is easy. A list is a comma separated set of values.
+    If these values contain quotes, the hash mark, or commas, then the values
+    can be surrounded by quotes. e.g. : ::
+    
+        keyword = value1, 'value 2', "value 3"
+    
+    If a value needs to be a list, but only has one member, then you indicate
+    this with a trailing comma. e.g. : ::
+    
+        keyword = "single value",
+    
+    If a value needs to be a list, but it has no members, then you indicate
+    this with a single comma. e.g. : ::
+    
+        keyword = ,     # an empty list
+    
+    Using triple quotes it will be possible for single values to contain
+    newlines and *both* single quotes and double quotes. Triple quotes aren't
+    allowed in list values. This means that the members of list values can't
+    contain carriage returns (or line feeds :-) or both quote values.
+      
+    CHANGELOG
+    =========
+    
+    2006/02/04
+    ----------
+    
+    Removed ``BOM_UTF8`` from ``__all__``.
+    
+    The ``BOM`` attribute has become a boolean. (Defaults to ``False``.) It is
+    *only* ``True`` for the ``UTF16`` encoding.
+    
+    File like objects no longer need a ``seek`` attribute.
+    
+    ConfigObj no longer keeps a reference to file like objects. Instead the
+    ``write`` method takes a file like object as an optional argument. (Which
+    will be used in preference of the ``filename`` attribute if htat exists as
+    well.)
+    
+    Full unicode support added. New options/attributes ``encoding``,
+    ``default_encoding``.
+    
+    utf16 files decoded to unicode.
+    
+    If ``BOM`` is ``True``, but no encoding specified, then the utf8 BOM is
+    written out at the start of the file. (It will normally only be ``True`` if
+    the utf8 BOM was found when the file was read.)
+    
+    File paths are *not* converted to absolute paths, relative paths will
+    remain relative as the ``filename`` attribute.
+    
+    Fixed bug where ``final_comment`` wasn't returned if ``write`` is returning
+    a list of lines.
+    
+    2006/01/31
+    ----------
+    
+    Added ``True``, ``False``, and ``enumerate`` if they are not defined.
+    (``True`` and ``False`` are needed for *early* versions of Python 2.2,
+    ``enumerate`` is needed for all versions ofPython 2.2)
+    
+    Deprecated ``istrue``, replaced it with ``as_bool``.
+    
+    Added ``as_int`` and ``as_float``.
+    
+    utf8 and utf16 BOM handled in an endian agnostic way.
+    
+    2005/12/14
+    ----------
+    
+    Validation no longer done on the 'DEFAULT' section (only in the root
+    level). This allows interpolation in configspecs.
+    
+    Change in validation syntax implemented in validate 0.2.1
+    
+    4.1.0
+    
+    2005/12/10
+    ----------
+    
+    Added ``merge``, a recursive update.
+    
+    Added ``preserve_errors`` to ``validate`` and the ``flatten_errors``
+    example function.
+    
+    Thanks to Matthew Brett for suggestions and helping me iron out bugs.
+    
+    Fixed bug where a config file is *all* comment, the comment will now be
+    ``initial_comment`` rather than ``final_comment``.
+    
+    2005/12/02
+    ----------
+    
+    Fixed bug in ``create_empty``. Thanks to Paul Jimenez for the report.
+    
+    2005/11/04
+    ----------
+    
+    Fixed bug in ``Section.walk`` when transforming names as well as values.
+    
+    Added the ``istrue`` method. (Fetches the boolean equivalent of a string
+    value).
+    
+    Fixed ``list_values=False`` - they are now only quoted/unquoted if they
+    are multiline values.
+    
+    List values are written as ``item, item`` rather than ``item,item``.
+    
+    4.0.1
+    
+    2005/10/09
+    ----------
+    
+    Fixed typo in ``write`` method. (Testing for the wrong value when resetting
+    ``interpolation``).
+
+    4.0.0 Final
+    
+    2005/09/16
+    ----------
+    
+    Fixed bug in ``setdefault`` - creating a new section *wouldn't* return
+    a reference to the new section.
+    
+    2005/09/09
+    ----------
+    
+    Removed ``PositionError``.
+    
+    Allowed quotes around keys as documented.
+    
+    Fixed bug with commas in comments. (matched as a list value)
+    
+    Beta 5
+    
+    2005/09/07
+    ----------
+    
+    Fixed bug in initialising ConfigObj from a ConfigObj.
+    
+    Changed the mailing list address.
+    
+    Beta 4
+    
+    2005/09/03
+    ----------
+    
+    Fixed bug in ``Section.__delitem__`` oops.
+    
+    2005/08/28
+    ----------
+    
+    Interpolation is switched off before writing out files.
+    
+    Fixed bug in handling ``StringIO`` instances. (Thanks to report from
+    "Gustavo Niemeyer" <gustavo@niemeyer.net>)
+    
+    Moved the doctests from the ``__init__`` method to a separate function.
+    (For the sake of IDE calltips).
+    
+    Beta 3
+    
+    2005/08/26
+    ----------
+    
+    String values unchanged by validation *aren't* reset. This preserves
+    interpolation in string values.
+    
+    2005/08/18
+    ----------
+    
+    None from a default is turned to '' if stringify is off - because setting 
+    a value to None raises an error.
+    
+    Version 4.0.0-beta2
+    
+    2005/08/16
+    ----------
+    
+    By Nicola Larosa
+    
+    Actually added the RepeatSectionError class ;-)
+    
+    2005/08/15
+    ----------
+    
+    If ``stringify`` is off - list values are preserved by the ``validate``
+    method. (Bugfix)
+    
+    2005/08/14
+    ----------
+    
+    By Michael Foord
+    
+    Fixed ``simpleVal``.
+    
+    Added ``RepeatSectionError`` error if you have additional sections in a
+    section with a ``__many__`` (repeated) section.
+    
+    By Nicola Larosa
+    
+    Reworked the ConfigObj._parse, _handle_error and _multiline methods:
+    mutated the self._infile, self._index and self._maxline attributes into
+    local variables and method parameters
+    
+    Reshaped the ConfigObj._multiline method to better reflect its semantics
+    
+    Changed the "default_test" test in ConfigObj.validate to check the fix for
+    the bug in validate.Validator.check
+    
+    2005/08/13
+    ----------
+    
+    By Nicola Larosa
+    
+    Updated comments at top
+    
+    2005/08/11
+    ----------
+    
+    By Michael Foord
+    
+    Implemented repeated sections.
+    
+    By Nicola Larosa
+    
+    Added test for interpreter version: raises RuntimeError if earlier than
+    2.2
+    
+    2005/08/10
+    ----------
+   
+    By Michael Foord
+     
+    Implemented default values in configspecs.
+    
+    By Nicola Larosa
+    
+    Fixed naked except: clause in validate that was silencing the fact
+    that Python2.2 does not have dict.pop
+    
+    2005/08/08
+    ----------
+    
+    By Michael Foord
+    
+    Bug fix causing error if file didn't exist.
+    
+    2005/08/07
+    ----------
+    
+    By Nicola Larosa
+    
+    Adjusted doctests for Python 2.2.3 compatibility
+    
+    2005/08/04
+    ----------
+    
+    By Michael Foord
+    
+    Added the inline_comments attribute
+    
+    We now preserve and rewrite all comments in the config file
+    
+    configspec is now a section attribute
+    
+    The validate method changes values in place
+    
+    Added InterpolationError
+    
+    The errors now have line number, line, and message attributes. This
+    simplifies error handling
+    
+    Added __docformat__
+    
+    2005/08/03
+    ----------
+    
+    By Michael Foord
+    
+    Fixed bug in Section.pop (now doesn't raise KeyError if a default value
+    is specified)
+    
+    Replaced ``basestring`` with ``types.StringTypes``
+    
+    Removed the ``writein`` method
+    
+    Added __version__
+    
+    2005/07/29
+    ----------
+    
+    By Nicola Larosa
+    
+    Indentation in config file is not significant anymore, subsections are
+    designated by repeating square brackets
+    
+    Adapted all tests and docs to the new format
+    
+    2005/07/28
+    ----------
+    
+    By Nicola Larosa
+    
+    Added more tests
+    
+    2005/07/23
+    ----------
+    
+    By Nicola Larosa
+    
+    Reformatted final docstring in ReST format, indented it for easier folding
+    
+    Code tests converted to doctest format, and scattered them around
+    in various docstrings
+    
+    Walk method rewritten using scalars and sections attributes
+    
+    2005/07/22
+    ----------
+    
+    By Nicola Larosa
+    
+    Changed Validator and SimpleVal "test" methods to "check"
+    
+    More code cleanup
+    
+    2005/07/21
+    ----------
+    
+    Changed Section.sequence to Section.scalars and Section.sections
+    
+    Added Section.configspec
+    
+    Sections in the root section now have no extra indentation
+    
+    Comments now better supported in Section and preserved by ConfigObj
+    
+    Comments also written out
+    
+    Implemented initial_comment and final_comment
+    
+    A scalar value after a section will now raise an error
+    
+    2005/07/20
+    ----------
+    
+    Fixed a couple of bugs
+    
+    Can now pass a tuple instead of a list
+    
+    Simplified dict and walk methods
+    
+    Added __str__ to Section
+    
+    2005/07/10
+    ----------
+    
+    By Nicola Larosa
+    
+    More code cleanup
+    
+    2005/07/08
+    ----------
+    
+    The stringify option implemented. On by default.
+    
+    2005/07/07
+    ----------
+    
+    Renamed private attributes with a single underscore prefix.
+    
+    Changes to interpolation - exceeding recursion depth, or specifying a
+    missing value, now raise errors.
+    
+    Changes for Python 2.2 compatibility. (changed boolean tests - removed
+    ``is True`` and ``is False``)
+    
+    Added test for duplicate section and member (and fixed bug)
+    
+    2005/07/06
+    ----------
+    
+    By Nicola Larosa
+    
+    Code cleanup
+    
+    2005/07/02
+    ----------
+    
+    Version 0.1.0
+    
+    Now properly handles values including comments and lists.
+    
+    Better error handling.
+    
+    String interpolation.
+    
+    Some options implemented.
+    
+    You can pass a Section a dictionary to initialise it.
+    
+    Setting a Section member to a dictionary will create a Section instance.
+    
+    2005/06/26
+    ----------
+    
+    Version 0.0.1
+    
+    Experimental reader.
+    
+    A reasonably elegant implementation - a basic reader in 160 lines of code.
+    
+    *A programming language is a medium of expression.* - Paul Graham
+"""
+

=== modified file 'bzrlib/util/configobj/docs/BSD-LICENSE.txt'
--- bzrlib/util/configobj/docs/BSD-LICENSE.txt	2008-02-08 19:09:45 +0000
+++ bzrlib/util/configobj/docs/BSD-LICENSE.txt	2005-10-18 18:48:27 +0000
@@ -18,7 +18,7 @@
 
 ::
 
-    Copyright (c) 2003-2008, Michael Foord & Nicola Larosa
+    Copyright (c) 2003-2005, Michael Foord
     All rights reserved.
     E-mail : fuzzyman AT voidspace DOT org DOT uk
     

=== modified file 'bzrlib/util/configobj/docs/configobj.txt'
--- bzrlib/util/configobj/docs/configobj.txt	2008-02-27 21:34:30 +0000
+++ bzrlib/util/configobj/docs/configobj.txt	2006-05-06 17:54:19 +0000
@@ -7,16 +7,14 @@
 ----------------------------------------
 
 :Authors: Michael Foord, Nicola Larosa
-:Version: ConfigObj 4.5.2
-:Date: 2008/02/24
+:Version: ConfigObj 4.2.0
+:Date: 2006/02/16
 :Homepage: `ConfigObj Homepage`_
 :Sourceforge: Sourceforge_
-:Development: `SVN Repository`_
 :License: `BSD License`_
 :Support: `Mailing List`_
 
 .. _Mailing List: http://lists.sourceforge.net/lists/listinfo/configobj-develop
-.. _SVN Repository: http://svn.pythonutils.python-hosting.com
 
 .. meta::
    :description: ConfigObj - a Python module for easy reading and writing of 
@@ -24,11 +22,9 @@
    :keywords: python, script, module, config, configuration, data, persistence,
               developer, configparser
 
-
 .. contents:: ConfigObj Manual
 .. sectnum::
 
-
 Introduction
 ============
 
@@ -36,7 +32,31 @@
 file round tripper*. Its main feature is that it is very easy to use, with a
 straightforward programmer's interface and a simple syntax for config files.
 It has lots of other features though :
-    
+
+.. sidebar:: ConfigObj in Bazaar
+
+    **ConfigObj** is now used as the config file parser for `Bazaar <http://bazaar-vcs.org>`_.
+    
+    Bazaar is *the* Python  distributed {acro;VCS;Version Control System}. 
+    ConfigObj is used to read ``bazaar.conf`` and ``branches.conf``.
+    
+    Other projects that use **ConfigObj** include :
+    
+    * `Planet Plus <http://planetplus.python-hosting.com/>`_
+    
+        A new web application version of `Planet <http://www.planetplanet.org/>`_, 
+        the web aggregator.
+        
+    * `NeuroImaging in Python <http://projects.scipy.org/neuroimaging/ni/wiki>`_
+    
+        BrainSTAT is a project with the ultimate goal to produce a
+        platform-independent python environment for the analysis of brain
+        imaging data.
+        
+    * `Gruik <http://www.tracos.org/gruik/wiki>`_
+    
+        Gruik is a free software network packet sniffer.
+
 * Nested sections (subsections), to any level
 * List values
 * Multiple line values
@@ -47,18 +67,33 @@
     - repeated sections
     - and allowing default values
 
-* When writing out config files, ConfigObj preserves all comments and the order of members and sections
-* Many useful methods and options for working with configuration files (like the 'reload' method)
-* Full Unicode support
+* All comments in the file are preserved
+* The order of keys/sections is preserved
+* No external dependencies
+* Full unicode support.
 
+ConfigObj 4 is a complete rewrite of ConfigObj. ConfigObj now has a barrage [#]_
+of doctests built into it, testing almost every feature. Run ``python configobj.py -v``
+to see them in action. Despite the tests, ConfigObj 4 is smaller than version 3
+and has no external dependencies.
 
 For support and bug reports please use the ConfigObj `Mailing List`_.
 
+.. hint::
+
+    ConfigObj provides a convenient API for storing all sorts of data, not just
+    config files. There is an article on using `ConfigObj for Data Persistence`_.
+    
+    The code from that article is available as ConfigPersist.py_.
+
+.. _ConfigObj for Data Persistence: http://www.voidspace.org.uk/python/articles/configobj_for_data_persistence.shtml
+.. _ConfigPersist.py: http://www.voidspace.org.uk/python/configpersist.html
+
 
 Downloading
 ===========
 
-The current version is **4.5.2**, dated 24th February 2008. ConfigObj 4 is
+The current version is **4.2.0**, dated 16th February 2006. ConfigObj 4 is
 now stable. We still expect to pick up a few bugs along the way though [#]_.
 {sm;:-)}
 
@@ -74,7 +109,7 @@
 
 * configobj.zip_ from Voidspace
 
-    This also contains validate.py_  and `this document`_.
+    This also contains validate.py_ , the `API Docs`_ and `this document`_.
 
 * The latest development version can be obtained from the `Subversion
   Repository`_.
@@ -86,10 +121,12 @@
 Documentation
 -------------
 
-*configobj.zip* also contains `this document`_.
-
-* You can view `this document`_ online at the `ConfigObj Homepage`_.
-
+*configobj.zip* contains `this document`_ and full `API Docs`_, generated by
+the EpyDoc_ program.
+
+* You can view `this document`_ online as the `ConfigObj Homepage`_.
+
+* You can also browse the `API Docs`_ online.
 
 Pythonutils
 -----------
@@ -98,55 +135,17 @@
 various other useful modules, and is required by many of the `Voidspace Python
 Projects`_.
 
-
-Development Version
--------------------
-
-It is sometimes possible to get the latest *development version* of ConfigObj
-from the `Subversion Repository <http://svn.pythonutils.python-hosting.com/trunk/pythonutils/>`_.
-
 .. _configobj.py: http://www.voidspace.org.uk/cgi-bin/voidspace/downman.py?file=configobj.py
-.. _configobj.zip: http://www.voidspace.org.uk/cgi-bin/voidspace/downman.py?file=configobj-4.5.2.zip
+.. _configobj.zip: http://www.voidspace.org.uk/cgi-bin/voidspace/downman.py?file=configobj-4.2.0.zip
 .. _validate.py: http://www.voidspace.org.uk/cgi-bin/voidspace/downman.py?file=validate.py
+.. _API Docs: http://www.voidspace.org.uk/python/configobj-api/
 .. _this document:
 .. _configobj homepage: http://www.voidspace.org.uk/python/configobj.html
+.. _Subversion Repository: http://svn.rest2web.python-hosting.com/branches/configobj4
 .. _Sourceforge: http://sourceforge.net/projects/configobj
+.. _EpyDoc: http://epydoc.sourceforge.net
 .. _pythonutils: http://www.voidspace.org.uk/python/pythonutils.html
-.. _Voidspace Python Projects: http://www.voidspace.org.uk/python/index.shtml
-
-
-
-ConfigObj in the Real World
-===========================
-    
-**ConfigObj** is widely used. Projects using it include:
-
-* `Bazaar <http://bazaar-ng.org>`_.
-
-    Bazaar is a Python distributed {acro;VCS;Version Control System}.
-    ConfigObj is used to read ``bazaar.conf`` and ``branches.conf``.
-
-* `Turbogears <http://www.turbogears.org/>`_
-
-    Turbogears is a web application framework.
-
-* `Chandler <http://chandler.osafoundation.org/>`_
-
-   A Python and `wxPython <http://www.wxpython.org>`_ 
-   {acro;PIM;Personal Information Manager}, being developed by the 
-   `OSAFoundation <http://www.osafoundation.org/>`_.
- 
-* `matplotlib <http://matplotlib.sourceforge.net/>`_
-
-	A 2D plotting library.
-
-* `IPython <http://ipython.scipy.org/moin/>`_
-
-    IPython is an enhanced interactive Python shell. IPython uses ConfigObj in a module called 'TConfig' that combines it with enthought `Traits <http://code.enthought.com/traits/>`_: `tconfig <http://ipython.scipy.org/ipython/ipython/browser/ipython/branches/saw/sandbox/tconfig>`_.
-    
-* `Elisa - the Fluendo Mediacenter <http://elisa.fluendo.com/>`_    
-    
-    Elisa is an open source cross-platform media center solution designed to be simple for people not particularly familiar with computers.
+.. _Voidspace Python Projects: http://www.voidspace.org.uk/python
 
 
 Getting Started
@@ -155,7 +154,6 @@
 The outstanding feature of using ConfigObj is simplicity. Most functions can be
 performed with single line commands.
 
-
 Reading a Config File
 ---------------------
 
@@ -196,7 +194,6 @@
 
     {-coloring}
 
-
 Writing a Config File
 ---------------------
 
@@ -246,7 +243,6 @@
     Keywords and section names can only be strings [#]_. Attempting to set
     anything else will raise a ``ValueError``.
 
-
 Config Files
 ------------
 
@@ -308,7 +304,6 @@
 
     {-coloring}
 
-
 infile
 ------
 
@@ -332,7 +327,6 @@
   ``filename`` attribute of your ConfigObj will be ``None``. All keys must be
   strings. In this case, the order of values and sections is arbitrary.
 
-
 options
 -------
 
@@ -360,7 +354,7 @@
     values are not parsed for lists.
 	
 	If ``list_values = False`` then single line values are not quoted or
-	unquoted when reading and writing.
+	unqouted when reading and writing.
 
     Changing this value affects whether single line values will be quoted or 
     not when writing.
@@ -386,7 +380,7 @@
     default.
 
     You can set this attribute to change whether string interpolation is done
-    when values are fetched. See the `String Interpolation`_ section for more details.
+    when values are fetched. See the interpolation_ section for more details.
 
 * 'configspec': ``None``
 
@@ -416,17 +410,16 @@
     non-string value [#]_ will raise a ``TypeError`` (no type conversion is
     done by validation).
 
-* 'indent_type': ``'    '``
+* 'indent_type': ``' '``
 
-    Indentation is not significant; it can however be present in the input and
-    output config. Any combination of tabs and spaces may be used: the string
-    will be repeated for each level of indentation. Typical values are: ``''``
-    (no indentation), ``'    '`` (indentation with four spaces, the default),
-    ``'\t'`` (indentation with one tab).
+    Indentation is not significant; it can however be present in the output
+    config. Allowable values are: ``''`` (no indentation), ``' '`` (indentation
+    with spaces, fixed at four per level), or ``'\t'`` (indentation with tabs,
+    one tab per level).
 
     If this option is not specified, and the ConfigObj is initialised with a
     dictionary, the indentation used in the output is the default one, that is,
-    four spaces.
+    spaces.
 
     If this option is not specified, and the ConfigObj is initialised with a
     list of lines or a file, the indentation used in the first indented line is
@@ -465,7 +458,7 @@
 
     ``default_encoding``, if specified, is the encoding used to decode byte
     strings in the **ConfigObj** before writing. If this is ``None``, then
-    the Python default encoding (``sys.defaultencoding`` - usually ASCII) is
+    the Python default encoding (``sys.defaultencoding`` - usually ascii) is
     used.
     
     For most Western European users, a value of ``latin-1`` is sensible.
@@ -475,20 +468,6 @@
     Any characters in byte-strings that can't be decoded using the
     ``default_encoding`` will raise a ``UnicodeDecodeError``.
 
-* 'unrepr': ``False``
-
-    The ``unrepr`` option reads and writes files in a different mode. This
-    allows you to store and retrieve the basic Python data-types using config
-    files.
-    
-    This uses Python syntax for lists and quoting. See `unrepr mode`_ for the
-    full details.
-
-* 'write_empty_values': ``False`` 
-
-    If ``write_empty_values`` is ``True``, empty strings are written as
-    empty values. See `Empty Values`_ for more details.
-
 
 Methods
 -------
@@ -499,14 +478,14 @@
 
 In addition, the following `Section Methods`_ may be useful :
 
-* 'restore_default'
-* 'restore_defaults'
-* 'walk'
-* 'merge'
-* 'dict'
-* 'as_bool'
-* 'as_float'
-* 'as_int'
+* *encode*
+* *decode*
+* *walk*
+* *merge*
+* *dict* 
+* *as_bool*
+* *as_float*
+* *as_int*
 
 Read about Sections_ for details of all the methods.
 
@@ -519,17 +498,13 @@
     
     You would typically use this to create a default ConfigObj and then merge
     in user settings. This way users only need to specify values that are
-    different from the default. You can use configspecs and validation to
-    achieve the same thing of course.
+    different from the default.
     
 
 The public methods available on ConfigObj are :
 
 * 'write'
 * 'validate'
-* 'reset'
-* 'reload'
-
 
 write
 ~~~~~
@@ -559,13 +534,12 @@
 'final_comment'. Comment lines and inline comments are written with each
 key/value.
 
-
 validate
 ~~~~~~~~
 
 ::
 
-    validate(validator, preserve_errors=False, copy=False)
+    validate(validator, preserve_errors=False)
 
 .. raw:: html
 
@@ -581,6 +555,7 @@
     test = config.validate(val)
     if test == True:
         print 'Succeeded.'
+
     {-coloring}
 
 The validate method uses the `validate 
@@ -588,7 +563,7 @@
 validation.
     
 This method validates the ConfigObj against the configspec. By doing type
-conversion as well it can abstract away the config file altogether and present
+conversion as well, it can abstract away the config file altogether and present
 the config *data* to your application (in the types it expects it to be).
 
 If the ``configspec`` attribute of the ConfigObj is ``None``, it raises a
@@ -606,32 +581,12 @@
 
 .. hint::
 
-    The system of configspecs can seem confusing at first, but is actually
-    quite simple and powerful. For a concrete example of how to use it, you may
-    find this blog entry helpful :
-    `Transforming Values with ConfigObj <http://www.voidspace.org.uk/python/weblog/arch_d7_2006_03_04.shtml#e257>`_.
-
-
-The ``copy`` parameter fills in missing values from the configspec (default
-values), *without* marking the values as defaults. It also causes comments to
-be copied from the configspec into the config file. This allows you to use a
-configspec to create default config files. (Normally default values aren't
-written out by the ``write`` method.)
-
-As of ConfigObj 4.3.0 you can also pass in a ConfigObj instance as your
-configspec. This is especially useful if you need to specify the encoding of
-your configspec file. When you read your configspec file, you *must* specify
-``list_values=False``.
-
-.. raw:: html
-
-    {+coloring}
-    from configobj import ConfigObj
-    configspec = ConfigObj(configspecfilename, encoding='UTF8',
-                           list_values=False)
-    config = ConfigObj(filename, configspec=configspec)
-    {-coloring}
+    If your ConfigObj is only comprised of basic data types, then you can use
+    a function from the ConfigPersist.py_ module to auto-generate your
+    configspec.
     
+    See `ConfigObj for Data Persistence`_.
+
 
 Return Value
 ############
@@ -703,7 +658,6 @@
 Writing invalid default values is a *guaranteed* way of confusing your users.
 Default values **must** pass the check.
 
-
 Mentioning Repeated Sections
 ############################
 
@@ -744,46 +698,7 @@
 
     {-coloring}
 
-
-Mentioning copy Mode
-####################
-
-As discussed in `Mentioning Default Values`_, you can use a configspec to
-supply default values. These are marked in the ConfigObj instance as defaults,
-and *not* written out by the ``write`` mode. This means that your users only
-need to supply values that are different from the defaults.
-
-This can be inconvenient if you *do* want to write out the default values,
-for example to write out a default config file.
-
-If you set ``copy=True`` when you call validate, then no values are marked as
-defaults. In addition, all comments from the configspec are copied into
-your ConfigObj instance. You can then call ``write`` to create your config
-file.
     
-There is a limitation with this. In order to allow `String Interpolation`_ to work
-within configspecs, ``DEFAULT`` sections are not processed by
-validation; even in copy mode.
-
-
-reload
-~~~~~~
-
-If a ConfigObj instance was loaded from the filesystem, then this method will reload it. It
-will also reuse any configspec you supplied at instantiation (including reloading it from
-the filesystem if you passed it in as a filename).
-
-If the ConfigObj does not have a filename attribute pointing to a file, then a ``ReloadError`` 
-will be raised.
-
-
-reset
-~~~~~
-
-This method takes no arguments and doesn't return anything. It restores a ConfigObj
-instance to a freshly created state.
-
-
 Attributes
 ----------
 
@@ -798,9 +713,6 @@
 * list_values
 * encoding
 * default_encoding
-* unrepr
-* write_empty_values
-* newlines
 
 .. note::
 
@@ -814,17 +726,15 @@
 * create_empty
 * file_error
 
-
-interpolation
-~~~~~~~~~~~~~
+interpolate
+~~~~~~~~~~~
 
 ConfigObj can perform string interpolation in a *similar* way to
-``ConfigParser``. See the `String Interpolation`_ section for full details.
+``ConfigParser``. See the interpolation_ section for full details.
 
-If ``interpolation`` is set to ``False``, then interpolation is *not* done when
+If ``interpolate`` is set to ``False``, then interpolation is *not* done when
 you fetch values.
 
-
 stringify
 ~~~~~~~~~
 
@@ -835,7 +745,6 @@
 If stringify is unset (``False``) then attempting to set a value to a non
 string (or a list of strings) will raise a ``TypeError``.
 
-
 BOM
 ~~~
 
@@ -848,7 +757,6 @@
 
 For UTF16 encodings, a BOM is *always* written.
 
-
 initial_comment
 ~~~~~~~~~~~~~~~
 
@@ -859,7 +767,6 @@
 
 The write method puts these lines before it starts writing out the members.
 
-
 final_comment
 ~~~~~~~~~~~~~
 
@@ -871,7 +778,6 @@
 The ``write`` method puts these lines after it finishes writing out the
 members.
 
-
 list_values
 ~~~~~~~~~~~
 
@@ -899,7 +805,6 @@
 	``list_values=False``. This means that files written by **ConfigObj**
 	*could* now be incompatible - and need the quotes removing by hand.
 
-
 encoding
 ~~~~~~~~
 
@@ -913,40 +818,12 @@
 ~~~~~~~~~~~~~~~~
 
 If encoding is set, any byte-strings in your ConfigObj instance (keys or
-members) will first be decoded to Unicode using the encoding specified by the
+members) will first be decoded to unicode using the encoding specified by the
 ``default_encoding`` attribute. This ensures that the output is in the encoding
 specified.
 
 If this value is ``None`` then ``sys.defaultencoding`` is used instead.
 
-
-unrepr
-~~~~~~
-
-Another boolean value. If this is set, then ``repr(value)`` is used to write
-values. This writes values in a slightly different way to the normal ConfigObj
-file syntax.
-
-This preserves basic Python data-types when read back in. See `unrepr mode`_
-for more details.
-
-
-write_empty_values
-~~~~~~~~~~~~~~~~~~
-
-Also boolean. If set, values that are an empty string (``''``) are written as
-empty values. See `Empty Values`_ for more details.
-
-
-newlines
-~~~~~~~~
-
-When a config file is read, ConfigObj records the type of newline separators in the
-file and uses this separator when writing. It defaults to ``None``, and ConfigObj
-uses the system default (``os.sep``) if write is called without newlines having
-been set.
-
-
 The Config File Format
 ======================
 
@@ -1063,7 +940,7 @@
 
     {+coloring}
 
-    ConfigObj({
+    {
         'keyword1': 'value1',
         'keyword2': 'value2',
         'section 1': {
@@ -1086,26 +963,13 @@
                 'keyword2': 'value2',
             },
         },
-    })
+    }
 
     {-coloring}
 
 Sections are ordered: note how the structure of the resulting ConfigObj is in
 the same order as the original file.
 
-.. note::
-
-    In ConfigObj 4.3.0 *empty values* became valid syntax. They are read as the
-    empty string. There is also an option/attribute (``write_empty_values``) to
-    allow the writing of these.
-    
-    This is mainly to support 'legacy' config files, written from other
-    applications. This is documented under `Empty Values`_.
-    
-    `unrepr mode`_ introduces *another* syntax variation, used for storing
-    basic Python datatypes in config files. {sm;:-)}
-
-
 Sections
 ========
 
@@ -1171,7 +1035,6 @@
 
 * 'values'
 
-
 Section Attributes
 ------------------
 
@@ -1201,12 +1064,6 @@
     Setting any of these values in the section removes them from the defaults
     list.
 
-* default_values
-
-    This attribute is a dictionary mapping keys to the default values for the
-    keys. By default it is an empty dictionary and is populated when you
-    validate the ConfigObj.
-
 * scalars, sections
 
     These attributes are normal lists, representing the order that members,
@@ -1258,7 +1115,6 @@
 
     See the validation_ section for full details of how to write configspecs.
 
-
 Section Methods
 ---------------
 
@@ -1357,7 +1213,7 @@
     
         In ConfigObj 4.1.0, this method was called ``istrue``. That method is
         now deprecated and will issue a warning when used. It will go away
-        in a future release.
+        in the next release.
         
 * **as_int**
 
@@ -1375,30 +1231,6 @@
     
     It raises a ``ValueError`` if the conversion can't be done.
     
-* **restore_default**
-
-    ``restore_default(key)``
-    
-    Restore (and return) the default value for the specified key.
-    
-    This method will only work for a ConfigObj that was created
-    with a configspec and has been validated.
-    
-    If there is no default value for this key, ``KeyError`` is raised.
-
-* **restore_defaults**
-    
-    ``restore_defaults()``
-
-    Recursively restore default values to all members
-    that have them.
-    
-    This method will only work for a ConfigObj that was created
-    with a configspec and has been validated.
-    
-    It doesn't delete or modify entries without default values.
-
-
 Walking a Section
 -----------------
 
@@ -1577,14 +1409,14 @@
     #
     cfg.walk(transform, call_on_sections=True)
     print cfg
-    ConfigObj({'CLIENT1key1': 'CLIENT1value1', 'CLIENT1key2': 'CLIENT1value2', 
+    {'CLIENT1key1': 'CLIENT1value1', 'CLIENT1key2': 'CLIENT1value2', 
     'CLIENT1key3': 'CLIENT1value3', 
     'CLIENT1section1': {'CLIENT1key1': 'CLIENT1value1', 
         'CLIENT1key2': 'CLIENT1value2', 'CLIENT1key3': 'CLIENT1value3'}, 
     'CLIENT1section2': {'CLIENT1key1': 'CLIENT1value1', 
         'CLIENT1key2': 'CLIENT1value2', 'CLIENT1key3': 'CLIENT1value3', 
         'CLIENT1section1': {'CLIENT1key1': 'CLIENT1value1', 
-            'CLIENT1key2': 'CLIENT1value2', 'CLIENT1key3': 'CLIENT1value3'}}})
+            'CLIENT1key2': 'CLIENT1value2', 'CLIENT1key3': 'CLIENT1value3'}}}
             
     {-coloring}
 
@@ -1613,7 +1445,7 @@
     (in a configspec), a ``RepeatSectionError`` will be raised.
 
 Number 5 (which is actually two different types of exceptions) is documented
-    in `String Interpolation`_.
+    in interpolation_.
 
 Number 6 is explained in the validation_ section.
 
@@ -1642,22 +1474,13 @@
 
 * ``ConfigspecError``
 
-    An error occurred whilst parsing a configspec.
-
-* ``UnreprError``
-
-    An error occurred when parsing a value in `unrepr mode`_.
-    
-* ``ReloadError``
-
-    ``reload`` was called on a ConfigObj instance that doesn't have a valid 
-    filename attribute.
+    An error occured whilst parsing a configspec.
 
 When parsing a configspec, ConfigObj will stop on the first error it
 encounters.  It will raise a ``ConfigspecError``. This will have an ``error``
 attribute, which is the actual error that was raised.
 
-Behaviour when parsing a config file depends on the option ``raise_errors``.
+Behavior when parsing a config file depends on the option ``raise_errors``.
 If ConfigObj encounters an error while parsing a config file:
 
     If ``raise_errors=True`` then ConfigObj will raise the appropriate error
@@ -1666,12 +1489,12 @@
     If ``raise_errors=False`` (the default) then parsing will continue to the
     end and *all* errors will be collected.
 
-If ``raise_errors`` is False and multiple errors are found a ``ConfigObjError``
-is raised. The error raised has a ``config`` attribute, which is the parts of
-the ConfigObj that parsed successfully. It also has an attribute ``errors``,
-which is a list of *all* the errors raised. Each entry in the list is an
-instance of the appropriate error type. Each one has the following attributes
-(useful for delivering a sensible error message to your user) :
+In the second case a ``ConfigObjError`` is raised after parsing has stopped.
+The error raised has a ``config`` attribute, which is the parts of the
+ConfigObj that parsed successfully. It also has an attribute ``errors``, which
+is a list of *all* the errors raised. Each entry in the list is an instance of
+the appropriate error type. Each one has the following attributes (useful for
+delivering a sensible error message to your user) :
 
 * ``line``: the original line that caused the error.
 
@@ -1679,13 +1502,6 @@
 
 * ``message``: the error message that accompanied the error.
 
-If only one error is found, then that error is re-raised. The error still has
-the ``config`` and ``errors`` attributes. This means that your error handling
-code can be the same whether one error is raised in parsing , or several.
-
-It also means that in the most common case (a single error) a useful error
-message will be raised.
-
 .. note::
 
     One wrongly written line could break the basic structure of your config
@@ -1697,13 +1513,6 @@
 Validation
 ==========
 
-.. hint::
-
-    The system of configspecs can seem confusing at first, but is actually
-    quite simple and powerful. For a concrete example of how to use it, you may
-    find this blog entry helpful :
-    `Transforming Values with ConfigObj <http://www.voidspace.org.uk/python/weblog/arch_d7_2006_03_04.shtml#e257>`_.
-
 Validation is done through a combination of the configspec_ and a ``Validator``
 object. For this you need *validate.py* [#]_. See downloading_ if you don't
 have a copy.
@@ -1722,7 +1531,6 @@
 application configuration (boolean, integers, floats, etc) and the text format
 of your config file.
 
-
 configspec
 ----------
 
@@ -1769,22 +1577,8 @@
     In order to allow this, checks in the 'DEFAULT' section (of the root level
     of your configspec) are *not* used.
 
-If you need to specify the encoding of your configspec, then you can pass in a
-ConfigObj instance as your configspec. When you read your configspec file, you
-*must* specify ``list_values=False``.
-
-.. raw:: html
-
-    {+coloring}
-    from configobj import ConfigObj
-    configspec = ConfigObj(configspecfilename, encoding='UTF8',
-        list_values=False)
-    config = ConfigObj(filename, configspec=configspec)
-    {-coloring}
-
 .. _validate.py documentation: http://www.voidspace.org.uk/python/validate.html
 
-
 Type Conversion
 ---------------
 
@@ -1799,7 +1593,6 @@
 set the stringify_ attribute to ``False``. If this is the case, attempting to
 set a value to a non-string will raise an error.
 
-
 Default Values
 --------------
 
@@ -1877,32 +1670,6 @@
 sub-sections. Defaults work in the normal way in repeated sections.
 
 
-Copy Mode
----------
-
-Because you can specify default values in your configspec, you can use
-ConfigObj to write out default config files for your application.
-
-However, normally values supplied from a default in a configspec are *not*
-written out by the ``write`` method.
-
-To do this, you need to specify ``copy=True`` when you call validate. As well
-as not marking values as default, all the comments in the configspec file
-will be copied into your ConfigObj instance.
-
-.. raw:: html
-
-    {+coloring}
-    from configobj import ConfigObj
-    from validate import Validator
-    vdt = Validator()
-    config = ConfigObj(configspec='default.ini')
-    config.filename = 'new_default.ini'
-    config.validate(vdt, copy=True)
-    config.write()
-    {-coloring}
-
-
 Validation and Interpolation
 ----------------------------
 
@@ -1916,7 +1683,6 @@
 overwritten. If validation changes type - the value has to be overwritten, and
 any interpolation references are lost {sm;:-(}.
 
-
 SimpleVal
 ---------
 
@@ -1968,124 +1734,27 @@
     {-coloring}
 
 
-Empty values
-============
-
-Many config files from other applications allow empty values. As of version
-4.3.0, ConfigObj will read these as an empty string.
-
-A new option/attribute has been added (``write_empty_values``) to allow
-ConfigObj to write empty strings as empty values.
-
-.. raw:: html
-
-    {+coloring}
-    from configobj import ConfigObj
-    cfg = '''
-        key =
-        key2 = # a comment
-    '''.splitlines()
-    config = ConfigObj(cfg)
-    print config
-    ConfigObj({'key': '', 'key2': ''})
-    
-    config.write_empty_values = True
-    for line in config.write():
-        print line
-    
-    key = 
-    key2 =     # a comment
-    {-coloring}
-
-
-unrepr mode
-===========
-
-The ``unrepr`` option allows you to store and retrieve the basic Python
-data-types using config files. It has to use a slightly different syntax to
-normal ConfigObj files. Unsurprisingly it uses Python syntax.
-
-This means that lists are different (they are surrounded by square brackets),
-and strings *must* be quoted.
-
-The types that ``unrepr`` can work with are :
-
-    | strings, lists tuples
-    | None, True, False
-    | dictionaries, integers, floats
-    | longs and complex numbers
-    
-You can't store classes, types or instances.
-
-``unrepr`` uses ``repr(object)`` to write out values, so it currently *doesn't*
-check that you are writing valid objects. If you attempt to read an unsupported
-value, ConfigObj will raise a ``configobj.UnknownType`` exception.
-
-Values that are triple quoted cased. The triple quotes are removed *before*
-converting. This means that you can use triple quotes to write dictionaries
-over several lines in your config files. They won't be written like this
-though.
-
-If you are writing config files by hand, for use with ``unrepr``, you should
-be aware of the following differences from normal ConfigObj syntax :
-
-    | List : ``['A List', 'With', 'Strings']``
-    | Strings : ``"Must be quoted."``
-    | Backslash : ``"The backslash must be escaped \\"``
-
-These all follow normal Python syntax.
-
-In unrepr mode *inline comments* are not saved. This is because lines are
-parsed using the `compiler package <http://docs.python.org/lib/compiler.html>`_
-which discards comments.
-
-
-String Interpolation
-====================
+Interpolation
+=============
 
 ConfigObj allows string interpolation *similar* to the way ``ConfigParser``
-or ``string.Template`` work. The value of the ``interpolation`` attribute
-determines which style of interpolation you want to use. Valid values are
-"ConfigParser" or "Template" (case-insensitive, so "configparser" and
-"template" will also work). For backwards compatibility reasons, the value
-``True`` is also a valid value for the ``interpolation`` attribute, and
-will select ``ConfigParser``-style interpolation. At some undetermined point
-in the future, that default *may* change to ``Template``-style interpolation.
-
-For ``ConfigParser``-style interpolation, you specify a value to be
-substituted by including ``%(name)s`` in the value.
-
-For ``Template``-style interpolation, you specify a value to be substituted
-by including ``${cl}name{cr}`` in the value. Alternately, if 'name' is a valid
-Python identifier (i.e., is composed of nothing but alphanumeric characters,
-plus the underscore character), then the braces are optional and the value
-can be written as ``$name``.
-
-Note that ``ConfigParser``-style interpolation and ``Template``-style
-interpolation are mutually exclusive; you cannot have a configuration file
-that's a mix of one or the other. Pick one and stick to it. ``Template``-style
-interpolation is simpler to read and write by hand, and is recommended if
-you don't have a particular reason to use ``ConfigParser``-style.
-
-Interpolation checks first the current section to see if ``name`` is the key
-to a value. ('name' is case sensitive).
-
-If it doesn't find it, next it checks the 'DEFAULT' sub-section of the current
-section.
-
-If it still doesn't find it, it moves on to check the parent section and the
-parent section's 'DEFAULT' subsection, and so on all the way up to the main
-section.
-
-If the value specified isn't found in any of these locations, then a
-``MissingInterpolationOption`` error is raised (a subclass of
-``ConfigObjError``).
+
+You specify a value to be substituted by including ``%(name)s`` in the value.
+
+Interpolation checks first the 'DEFAULT' sub-section of the current section to
+see if ``name`` is the key to a value. ('name' is case sensitive).
+
+If it doesn't find it, next it checks the 'DEFAULT' section of the parent
+section, last it checks the 'DEFAULT' section of the main section.
+
+If the value specified isn't found then a ``MissingInterpolationOption`` error
+is raised (a subclass of ``ConfigObjError``).
 
 If it is found then the returned value is also checked for substitutions. This
 allows you to make up compound values (for example directory paths) that use
 more than one default value. It also means it's possible to create circular
-references. If there are any circular references which would cause an infinite
-interpolation loop, an ``InterpolationLoopError`` is raised.
+references. If after ten replacements there are still values to substitute, an
+``InterpolationDepthError`` is raised.
 
 Both of these errors are subclasses of ``InterpolationError``, which is a
 subclass of ``ConfigObjError``.
@@ -2137,7 +1806,7 @@
 failed.
 
 ``flatten_errors`` is an example function that turns a results dictionary into
-a flat list, that only contains values that *failed*.
+a flat list, that only contains vaues that *failed*.
 
 ``cfg`` is the ConfigObj instance being checked, ``res`` is the results
 dictionary returned by ``validate``.
@@ -2194,9 +1863,82 @@
 
     {-coloring}
 
+Backwards Compatibility
+=======================
+
+There have been a lot of changes since ConfigObj 3. The core parser is now
+based on regular expressions, and is a lot faster and smaller. There is now no
+difference in the way we treat flat files and non-flatfiles, that is, no empty
+sections. This means some of the code can be a lot simpler, less code does
+more of the work [#]_.
+
+There have been other simplifications: for example we only have eight options
+instead of seventeen.
+
+Most config files created for ConfigObj 3 will be read with no changes and many
+programs will work without having to alter code. Some of the changes do break
+backwards compatibility: for example, code that uses the previous options will
+now raise an error. It should be very easy to fix these, though.
+
+Below is a list of all the changes that affect backwards compatibility. This
+doesn't include details of method signatures that have changed, because almost
+all of them have.
+
+Incompatible Changes
+--------------------
+
+(I have removed a lot of needless complications: this list is probably not
+conclusive, many option/attribute/method names have changed.)
+
+Case sensitive.
+
+The only valid divider is '='.
+
+Line continuations with ``\`` removed.
+
+No recursive lists in values.
+
+No empty sections.
+
+No distinction between flatfiles and non flatfiles.
+
+Change in list syntax: use commas to indicate list, not parentheses (square
+brackets and parentheses are no longer recognised as lists).
+
+';' is no longer valid for comments, and no multiline comments.
+
+No attribute-style access to values.
+
+Empty values not allowed: use '' or "".
+
+In ConfigObj 3, setting a non-flatfile member to ``None`` would initialise it
+as an empty section.
+
+The escape entities '&mjf-lf;' and '&mjf-quot;' have gone, replaced by triple
+quote, multiple line values.
+
+The ``newline``, ``force_return``, and ``default`` options have gone.
+
+``fileerror`` and ``createempty`` options have become ``file_error`` and
+``create_empty``.
+
+Partial configspecs (for specifying the order members should be written out,
+and which should be present) have gone. The configspec is no longer used to
+specify order for the ``write`` method.
+
+Exceeding the maximum depth of recursion in string interpolation now raises an
+error ``InterpolationDepthError``.
+
+Specifying a value for interpolation which doesn't exist now raises a
+``MissingInterpolationOption`` error (instead of merely being ignored).
+
+The ``writein`` method has been removed.
+
+The comments attribute is now a list (``inline_comments`` equates to the old
+comments attribute).
 
 ConfigObj 3
-===========
+-----------
 
 ConfigObj 3 is now deprecated in favour of ConfigObj 4. I can fix bugs in
 ConfigObj 3 if needed, though.
@@ -2218,7 +1960,7 @@
 Particularly thanks to Nicola Larosa for help on the config file spec, the
 validation system and the doctests.
 
-*validate.py* was originally written by Michael Foord and Mark Andrews.
+*validate.py* was originally written by Michael Foord and `Mark Andrews`_.
 
 Thanks to others for input and bugfixes.
 
@@ -2232,7 +1974,7 @@
 Of course if it does, let us know and we'll fix the problem so it doesn't
 happen to anyone else {sm;:-)}. ::
 
-    Copyright (c) 2004 - 2008, Michael Foord & Nicola Larosa
+    Copyright (c) 2004 - 2006, Michael Foord & Nicola Larosa
     All rights reserved.
 
     Redistribution and use in source and binary forms, with or without
@@ -2272,28 +2014,15 @@
 TODO
 ====
 
-Better support for configuration from multiple files, including tracking
-*where* the original file came from and writing changes to the correct
-file.
-
-Make ``newline`` an option (as well as an attribute) ?
-
-``UTF16`` encoded files, when returned as a list of lines, will have the
-BOM at the start of every line. Should this be removed from all but the
-first line ?
-
-Option to set warning type for unicode decode ? (Defaults to strict).
-
-A method to optionally remove uniform indentation from multiline values.
-(do as an example of using ``walk`` - along with string-escape)
-
-Should the results dictionary from validate be an ordered dictionary if
-`odict <http://www.voidspace.org.uk/python/odict.html>`_ is available ?
-
-Implement some of the sequence methods (which include slicing) from the
-newer ``odict`` ?
-
-Preserve line numbers of values (and possibly the original text of each value).
+Fix any bugs (and resolvable issues).
+
+Do an example for the 'walk' which removes uniform indentation in multiline
+values.
+
+When initialising a section from a ConfigObj *or* an ``OrderedDictionary``
+we could preserve ordering.
+
+Add an *odict* method which returns an ``OrderedDictionary``.
 
 
 ISSUES
@@ -2304,218 +2033,34 @@
     Please file any bug reports to `Michael Foord`_ or the **ConfigObj**
     `Mailing List`_.
 
-There is currently no way to specify the encoding of a configspec file.
-
-When using ``copy`` mode for validation, it won't copy ``DEFAULT``
-sections. This is so that you *can* use interpolation in configspec
-files.
-
-``validate`` doesn't report *extra* values or sections.
-
-You can't have a keyword with the same name as a section (in the same
-section). They are both dictionary keys - so they would overlap.
-
-ConfigObj doesn't quote and unquote values if ``list_values=False``.
-This means that leading or trailing whitespace in values will be lost when
-writing. (Unless you manually quote).
-
-Interpolation checks first the current section, then the 'DEFAULT' subsection
-of the current section, before moving on to the current section's parent and
-so on up the tree.
-
-Does it matter that we don't support the ':' divider, which is supported
-by ``ConfigParser`` ?
-
-String interpolation and validation don't play well together. When
-validation changes type it sets the value. This will correctly fetch the
-value using interpolation - but then overwrite the interpolation reference.
-If the value is unchanged by validation (it's a string) - but other types
-will be.
+You can't have a keyword with the same name as a section (in the same section).
+They are both dictionary keys, so they would overlap.
+
+Interpolation checks first the 'DEFAULT' sub-section of the current section,
+next it checks the 'DEFAULT' section of the parent section, last it checks the
+'DEFAULT' section of the main section.
+
+Logically a 'DEFAULT' section should apply to all subsections of the *same
+parent*: this means that checking the 'DEFAULT' sub-section in the *current
+section* is not necessarily logical ?
+
+Does it matter that we don't support the ':' divider, which is supported by
+``ConfigParser`` ?
+
+String interpolation and validation don't play well together. See 
+`Validation and Interpolation`_.
+
+Validation is no longer done on the 'DEFAULT' section (on the root level). This
+allows interpolation from within your configspec - but also prevents you
+validating the 'DEFAULT' section.
 
 
 CHANGELOG
 =========
 
 This is an abbreviated changelog showing the major releases up to version 4.
-From version 4 it lists all releases and changes.
-
-
-2008/02/05 - Version 4.5.2
---------------------------
-
-Distribution updated to include version 0.3.2 of validate_. This means that
-``None`` as a default value win configspecs works.
-
-
-2008/02/05 - Version 4.5.1
---------------------------
-
-Distribution updated to include version 0.3.1 of validate_. This means that
-Unicode configspecs now work.
-
-
-2008/02/05 - Version 4.5.0
---------------------------
-
-ConfigObj will now guarantee that files will be written terminated with a
-newline.
-
-ConfigObj will no longer attempt to import the ``validate`` module, until/unless 
-you call ``ConfigObj.validate`` with ``preserve_errors=True``. This makes it 
-faster to import.
-
-New methods ``restore_default`` and ``restore_defaults``. ``restore_default``
-resets an entry to its default value (and returns that value). ``restore_defaults``
-resets all entries to their default value. It doesn't modify entries without a 
-default value. You must have validated a ConfigObj (which populates the
-``default_values`` dictionary) before calling these methods.
-
-BUGFIX: Proper quoting of keys, values and list values that contain hashes 
-(when writing).  When ``list_values=False``, values containing hashes are 
-triple quoted.
-
-Added the ``reload`` method. This reloads a ConfigObj from file. If the filename
-attribute is not set then a ``ReloadError`` (a new exception inheriting from
-``IOError``) is raised.
-
-BUGFIX: Files are read in with 'rb' mode, so that native/non-native line endings work!
-
-Minor efficiency improvement in ``unrepr`` mode.
-
-Added missing docstrings for some overidden dictionary methods.
-
-Added the ``reset`` method. This restores a ConfigObj to a freshly created state.
-
-Removed old CHANGELOG file.
-
-
-2007/02/04 - Version 4.4.0
---------------------------
-
-Official release of 4.4.0
-
-
-2006/12/17 - Version 4.3.3-alpha4
----------------------------------
-
-By Nicola Larosa
-
-Allowed arbitrary indentation in the ``indent_type`` parameter, removed the
-``NUM_INDENT_SPACES`` and ``MAX_INTERPOL_DEPTH`` (a leftover) constants,
-added indentation tests (including another docutils workaround, sigh), updated
-the documentation.
-
-By Michael Foord
-
-Made the import of ``compiler`` conditional so that ``ConfigObj`` can be used
-with `IronPython <http://www.codeplex.com/IronPython>`_.
-
-
-2006/12/17 - Version 4.3.3-alpha3
----------------------------------
-
-By Nicola Larosa
-
-Added a missing ``self.`` in the _handle_comment method and a related test,
-per Sourceforge bug #1523975.
-
-
-2006/12/09 - Version 4.3.3-alpha2
----------------------------------
-
-By Nicola Larosa
-
-Changed interpolation search strategy, based on this patch by Robin Munn:
-http://sourceforge.net/mailarchive/message.php?msg_id=17125993
-
-
-2006/12/09 - Version 4.3.3-alpha1
----------------------------------
-
-By Nicola Larosa
-
-Added Template-style interpolation, with tests, based on this patch by
-Robin Munn: http://sourceforge.net/mailarchive/message.php?msg_id=17125991
-(awful archives, bad Sourceforge, bad).
-
-
-2006/06/04 - Version 4.3.2
---------------------------
-
-Changed error handling, if parsing finds a single error then that error will
-be re-raised. That error will still have an ``errors`` and a ``config``
-attribute.
-
-Fixed bug where '\\n' terminated files could be truncated.
-
-Bugfix in ``unrepr`` mode, it couldn't handle '#' in values. (Thanks to
-Philippe Normand for the report.)
-
-As a consequence of this fix, ConfigObj doesn't now keep inline comments in
-``unrepr`` mode. This is because the parser in the `compiler package`_
-doesn't keep comments. {sm;:-)}
-
-Error messages are now more useful. They tell you the number of parsing errors
-and the line number of the first error. (In the case of multiple errors.)
-
-Line numbers in exceptions now start at 1, not 0.
-
-Errors in ``unrepr`` mode are now handled the same way as in the normal mode.
-The errors stored will be an ``UnreprError``.
-
-
-2006/04/29 - Version 4.3.1
---------------------------
-
-Added ``validate.py`` back into ``configobj.zip``. (Thanks to Stewart
-Midwinter)
-
-Updated to `validate.py`_ 0.2.2.
-
-Preserve tuples when calling the ``dict`` method. (Thanks to Gustavo Niemeyer.)
-
-Changed ``__repr__`` to return a string that contains ``ConfigObj({ ... })``.
-
-Change so that an options dictionary isn't modified by passing it to ConfigObj.
-(Thanks to Artarious.)
-
-Added ability to handle negative integers in ``unrepr``. (Thanks to Kevin
-Dangoor.)
-
-
-2006/03/24 - Version 4.3.0
---------------------------
-
-Moved the tests and the CHANGELOG (etc) into a separate file. This has reduced
-the size of ``configobj.py`` by about 40%.
-
-Added the ``unrepr`` mode to reading and writing config files. Thanks to Kevin
-Dangoor for this suggestion.
-
-Empty values are now valid syntax. They are read as an empty string ``''``.
-(``key =``, or ``key = # comment``.)
-
-``validate`` now honours the order of the configspec.
-
-Added the ``copy`` mode to validate. Thanks to Louis Cordier for this
-suggestion.
-
-Fixed bug where files written on windows could be given ``'\r\r\n'`` line
-terminators.
-
-Fixed bug where last occurring comment line could be interpreted as the
-final comment if the last line isn't terminated.
-
-Fixed bug where nested list values would be flattened when ``write`` is
-called. Now sub-lists have a string representation written instead.
-
-Deprecated ``encode`` and ``decode`` methods instead.
-
-You can now pass in a ConfigObj instance as a configspec (remember to read
-the configspec file using ``list_values=False``).
-
-Sorted footnotes in the docs.
-
+From version 4 it lists all releases and changes. *More* data on individual
+changes may be found in the source code.
 
 2006/02/16 - Version 4.2.0
 --------------------------
@@ -2523,7 +2068,7 @@
 Removed ``BOM_UTF8`` from ``__all__``.
 
 The ``BOM`` attribute has become a boolean. (Defaults to ``False``.) It is
-*only* ``True`` for the ``UTF16/UTF8`` encodings.
+*only* ``True`` for the ``UTF16`` encoding.
 
 File like objects no longer need a ``seek`` attribute.
 
@@ -2541,8 +2086,6 @@
 written out at the start of the file. (It will normally only be ``True`` if
 the utf8 BOM was found when the file was read.)
 
-Thanks to Aaron Bentley for help and testing on the unicode issues.
-
 File paths are *not* converted to absolute paths, relative paths will
 remain relative as the ``filename`` attribute.
 
@@ -2553,7 +2096,6 @@
 
 Added ``as_int`` and ``as_float``.
 
-
 2005/12/14 - Version 4.1.0
 --------------------------
 
@@ -2572,7 +2114,6 @@
 
 Also use the new list syntax in validate_ 0.2.1. (For configspecs).
 
-
 2005/12/02 - Version 4.0.2
 --------------------------
 
@@ -2604,7 +2145,6 @@
 
 Obscure typo/bug fixed in ``write``. Wouldn't have affected anyone though.
 
-
 2005/09/09 - Version 4.0.0 beta 5
 ---------------------------------
 
@@ -2614,7 +2154,6 @@
 
 Fixed bug with commas in comments. (matched as a list value)
 
-
 2005/09/07 - Version 4.0.0 beta 4
 ---------------------------------
 
@@ -2625,26 +2164,23 @@
 
 Changed the mailing list address.
 
-
 2005/08/28 - Version 4.0.0 beta 3
 ---------------------------------
 
 Interpolation is switched off before writing out files.
 
 Fixed bug in handling ``StringIO`` instances. (Thanks to report from
-Gustavo Niemeyer.)
+"Gustavo Niemeyer" <gustavo@niemeyer.net>)
 
 Moved the doctests from the ``__init__`` method to a separate function.
 (For the sake of IDE calltips).
 
-
 2005/08/25 - Version 4.0.0 beta 2
 ---------------------------------
 
 Amendments to *validate.py*.
 
-First public release.
-
+Official release.
 
 2005/08/21 - Version 4.0.0 beta 1
 ---------------------------------
@@ -2667,8 +2203,7 @@
 
 Improved error handling.
 
-Plus lots of other improvements. {sm;:grin:}
-
+Plus lots of other improvements {sm;:grin:}.
 
 2004/05/24 - Version 3.0.0
 --------------------------
@@ -2721,7 +2256,6 @@
 
 Charmap is now incorporated into ConfigObj.
 
-
 2004/03/14 - Version 2.0.0 beta
 -------------------------------
 
@@ -2731,9 +2265,9 @@
 The config object now behaves like a dictionary.
 
 I've completely broken the interface, but I don't think anyone was really
-using it anyway.
+ using it anyway.
 
-This new version is much more 'classy'. {sm;:wink:}
+This new version is much more 'classy' {sm;:wink:}
 
 It will also read straight from/to a filename and completely parse a config
 file without you *having* to supply a config spec.
@@ -2743,7 +2277,6 @@
 No longer has getval and setval methods: use normal dictionary methods, or add
 and delete.
 
-
 2004/01/29 - Version 1.0.5
 --------------------------
 
@@ -2755,35 +2288,39 @@
 
 A couple of bugs have been fixed.
 
-
 Origins
 -------
 
 ConfigObj originated in a set of functions for reading config files in the
-`atlantibots <http://www.voidspace.org.uk/atlantibots/>`_ project. The original
-functions were written by Rob McNeur.
+atlantibots_ project. The original functions were written by Rob McNeur...
 
+.. _atlantibots: http://www.voidspace.org.uk/atlantibots
 
 ----------
 
-
 Footnotes
 =========
 
+.. [#] 253 of them, at the time of writing.
+
 .. [#] And if you discover any bugs, let us know. We'll fix them quickly.
 
 .. [#] If you specify a filename that doesn't exist, ConfigObj will assume you
     are creating a new one. See the *create_empty* and *file_error* options_.
 
-.. [#] They can be byte strings (*ordinary* strings) or Unicode.
-
-.. [#] Except we don't support the RFC822 style line continuations, nor ':' as
-    a divider.
+.. [#] They can be byte strings ('ordinary' strings) or Unicode.
 
 .. [#] This is a change in ConfigObj 4.2.0. Note that ConfigObj doesn't call
     the seek method of any file like object you pass in. You may want to call
     ``file_object.seek(0)`` yourself, first.
 
+.. [#] Except we don't support the RFC822 style line continuations, nor ':' as
+    a divider.
+
+.. [#] For a file object that will depend what mode it was opened with. You
+    can read *and* write to a ``StringIO`` instance, but not always to a
+    ``cStringIO`` instance.
+
 .. [#] A side effect of this is that it enables you to copy a ConfigObj :
 
     .. raw:: html
@@ -2798,12 +2335,12 @@
 
     The order of values and sections will not be preserved, though.
 
-.. [#] Other than lists of strings.
-
 .. [#] The exception is if it detects a ``UTF16`` encoded file which it
     must decode before parsing.
      
-.. [#] The method signature shows that this method takes
+.. [#] Other than lists of strings.
+
+.. [#] The method signature in the API docs will show that this method takes
     two arguments. The second is the section to be written. This is because the
     ``write`` method is called recursively.
 
@@ -2818,6 +2355,10 @@
 
 .. [#] Minimum required version of *validate.py* 0.2.0 .
 
+.. [#] There's nothing to stop you decoding the whole config file to Unicode
+    *first*.
+
+.. [#] It also makes ConfigObj a lot simpler to *use*.
 
 .. note::
 
@@ -2825,32 +2366,34 @@
     textmacros module and the PySrc CSS stuff. See
     http://www.voidspace.org.uk/python/firedrop2/textmacros.shtml
 
-
 .. raw:: html
 
     <div align="center">
-        <p>
-            <a href="http://www.python.org">
-                <img src="images/new_python.gif" width="100" height="103" border="0" 
-                    alt="Powered by Python" />
-            </a>
-            <a href="http://sourceforge.net">
-                <img src="http://sourceforge.net/sflogo.php?group_id=123265&amp;type=1" width="88" height="31" border="0" alt="SourceForge.net Logo" />
-            </a>
-            <a href="http://www.opensource.org">
-                <img src="images/osi-certified-120x100.gif" width="120" height="100" border="0"
-                    alt="Certified Open Source"/>
-            </a>
-        </p>
-        <p>
-            <a href="http://www.voidspace.org.uk/python/index.shtml">
-                <img src="images/pythonbanner.gif" width="468" height="60" 
-                alt="Python on Voidspace" border="0" />
-            </a>
-        </p>
-
+        <a href="http://sourceforge.net/donate/index.php?group_id=123265">
+            <img src="http://images.sourceforge.net/images/project-support.jpg" width="88" height="32" border="0" alt="Support This Project" /> 
+        </a>
+        <a href="http://sourceforge.net">
+            <img src="http://sourceforge.net/sflogo.php?group_id=123265&amp;type=1" width="88" height="31" border="0" alt="SourceForge.net Logo" />
+        </a>
+        <br />
+        <a href="http://www.python.org">
+            <img src="images/powered_by_python.jpg" width="602" height="186" border="0" />
+        </a><br /><br />
+        <a href="http://www.opensource.org">
+            <img src="images/osi-certified-120x100.gif" width="120" height="100" border="0" />
+            <br /><strong>Certified Open Source</strong>
+        </a>
+        <br /><br />
+        <script type="text/javascript" language="JavaScript">var site="s16atlantibots"</script>
+        <script type="text/javascript" language="JavaScript1.2" src="http://s16.sitemeter.com/js/counter.js?site=s16atlantibots"></script>
+        <noscript>
+            <a href="http://s16.sitemeter.com/stats.asp?site=s16atlantibots">
+                <img src="http://s16.sitemeter.com/meter.asp?site=s16atlantibots" alt="Site Meter" border=0 />
+            </a>
+        </noscript>
     </div>
 
 .. _listquote: http://www.voidspace.org.uk/python/modules.shtml#listquote
-.. _Michael Foord: http://www.voidspace.org.uk/python/weblog/index.shtml
+.. _Michael Foord: http://www.voidspace.org.uk/index2.shtml
 .. _Nicola Larosa: http://www.teknico.net
+.. _Mark Andrews: http://www.la-la.com

=== modified file 'bzrlib/util/configobj/docs/validate.txt'
--- bzrlib/util/configobj/docs/validate.txt	2008-02-27 21:34:30 +0000
+++ bzrlib/util/configobj/docs/validate.txt	2006-02-21 02:26:30 +0000
@@ -8,8 +8,8 @@
 
 
 :Authors: `Michael Foord`_, `Nicola Larosa`_, `Mark Andrews`_
-:Version: Validate 0.3.2
-:Date: 2008/02/24
+:Version: Validate 0.2.1
+:Date: 2005/12/16
 :Homepage: `Validate Homepage`_
 :License: `BSD License`_
 :Support: `Mailing List`_
@@ -17,14 +17,13 @@
 .. _Mailing List: http://lists.sourceforge.net/lists/listinfo/configobj-develop
 .. _Michael Foord: fuzzyman@voidspace.org.uk
 .. _Nicola Larosa: nico@teknico.net
+.. _Mark Andrews: mark@la-la.com
 .. _This Document:
 .. _Validate Homepage: http://www.voidspace.org.uk/python/validate.html
 .. _BSD License: http://www.voidspace.org.uk/python/license.shtml
 
 
 .. contents:: Validate Manual
-.. sectnum::
-
 
 Introduction
 ============
@@ -38,7 +37,7 @@
 type.
 
 Checks are also strings, and are easy to write. One generic system can be used
-to validate information from different sources via a single consistent
+to validate information from different sources, via a single consistent
 mechanism.
 
 Checks look like function calls, and map to function calls. They can include
@@ -64,15 +63,13 @@
 
 .. _ConfigObj: http://www.voidspace.org.uk/python/configobj.html
 
-
 Downloading
 ===========
 
-The current version is **0.3.2**, dated 24th February 2008. 
+The current version is **0.2.1**, dated 16th December 2005. 
 
 You can get obtain validate in the following ways :
 
-
 Files
 -----
 
@@ -86,14 +83,15 @@
     
 * The latest development version can be obtained from the `Subversion Repository`_.
 
-
 Documentation
 -------------
 
-*configobj.zip* contains `this document`_.
+*configobj.zip* contains `this document`_ and full `API Docs`_, generated 
+automatically by EpyDoc_.
 
 * You can view `this document`_ online as the `Validate Homepage`_.
 
+* You can also browse the `API Docs`_ online.
 
 Pythonutils
 -----------
@@ -103,10 +101,12 @@
 Python Projects`_.
 
 .. _configobj.py: http://www.voidspace.org.uk/cgi-bin/voidspace/downman.py?file=configobj.py
-.. _configobj.zip: http://www.voidspace.org.uk/cgi-bin/voidspace/downman.py?file=configobj-4.5.2.zip
+.. _configobj.zip: http://www.voidspace.org.uk/cgi-bin/voidspace/downman.py?file=configobj-4.1.0.zip
 .. _validate.py: http://www.voidspace.org.uk/cgi-bin/voidspace/downman.py?file=validate.py
-.. _Subversion Repository: http://svn.pythonutils.python-hosting.com/trunk/pythonutils/
+.. _API Docs: http://www.voidspace.org.uk/python/configobj-api/
+.. _Subversion Repository: http://svn.rest2web.python-hosting.com/branches/configobj4/
 .. _Sourceforge: http://sourceforge.net/projects/configobj
+.. _EpyDoc: http://epydoc.sourceforge.net
 .. _pythonutils: http://www.voidspace.org.uk/python/pythonutils.html
 .. _Voidspace Python Projects: http://www.voidspace.org.uk/python
 .. _validate: http://www.voidspace.org.uk/python/validate.html
@@ -141,8 +141,8 @@
 :'float': matches float values
           Has the same parameters as the integer check.
 
-:'boolean': matches boolean values: ``True`` or ``False``.
-            Acceptable string values for True are : ::
+:'bool': matches boolean values: ``True`` or ``False``.
+         Acceptable string values for True are : ::
 
              true, on, yes, 1
 
@@ -159,10 +159,7 @@
             dotted-quad string, i.e. '1.2.3.4'.
 
 :'list': matches any list. Takes optional keyword args 'min', and 'max' to
-         specify min and max sizes of the list. The list checks always 
-         return a list.
-         
-:'tuple': matches any list. This check returns a tuple rather than a list.
+         specify min and max sizes of the list.
 
 :'int_list': Matches a list of integers. Takes the same arguments as list.
 
@@ -181,7 +178,7 @@
 
                Each position can be one of : ::
 
-                   int, str, boolean, float, ip_addr
+                   int, str, bool, float, ip_addr
 
                So to specify a list with two strings followed by two integers,
                you write the check as : ::
@@ -207,7 +204,7 @@
     #
     vtor = Validator()
     newval1 = vtor.check('integer', value1)
-    newval2 = vtor.check('boolean', value2)
+    newval2 = vtor.check('bool', value2)
     # etc ...
 
     {-coloring}
@@ -268,7 +265,6 @@
 Dictionary keys/functions you pass in can override the built-in ones if you
 want.
 
-
 Adding functions
 ----------------
 
@@ -288,10 +284,9 @@
 
     {-coloring}
 
-``vtor.functions`` is just a dictionary that maps names to functions, so we
+``vtor.functions``is just a dictionary that maps names to functions, so we
 could also have called ``vtor.functions.update(fdict)``.
 
-
 Writing the check
 -----------------
 
@@ -306,7 +301,6 @@
 
 but the check part will be identical .
 
-
 The check method
 ----------------
 
@@ -358,8 +352,8 @@
     check1 = 'integer(default=50)'
     check2 = 'option("val 1", "val 2", "val 3", default="val 1")'
 
-    assert vtor.check(check1, '', missing=True) == 50
-    assert vtor.check(check2, '', missing=True) == "val 1"
+    assert vtor.check('', check1, missing=True) == 50
+    assert vtor.check('', check2, missing=True) == "val 1"
 
     {-coloring}
 
@@ -374,12 +368,6 @@
 optional, and may be omitted without harm.
 
 
-.. note:: 
-
-    As of version 0.3.0, if you specify ``default='None'`` (note the quote marks
-    around ``None``) then it will be interpreted as the string ``'None'``.
-
-
 List Values
 ~~~~~~~~~~~
 
@@ -393,20 +381,6 @@
 
     checkname(default=list('val1', 'val2', 'val3'))
 
-
-get_default_value
------------------
-
-``Validator`` instances have a ``get_default_value`` method. It takes a ``check`` string 
-(the same string you would pass to the ``check`` method) and returns the default value,
-converted to the right type. If the check doesn't define a default value then this method
-raises a ``KeyError``.
-
-If the ``check`` has been seen before then it will have been parsed and cached already, 
-so this method is not expensive to call (however the conversion is done each time).
-
-
-
 Validator Exceptions
 ====================
 
@@ -465,7 +439,6 @@
 * ``VdtValueTooShortError``
 * ``VdtValueTooLongError``
 
-
 Writing check functions
 =======================
 
@@ -489,7 +462,6 @@
 
 And that's it !
 
-
 Example
 -------
 
@@ -578,26 +550,12 @@
 If you are using validate in another circumstance you may want to create your 
 own subclasses of ``ValidateError``, that convey more specific information.
 
-
-Known Issues
-============
-
-The following parses and then blows up. The resulting error message
-is confusing:
-
-    ``checkname(default=list(1, 2, 3, 4)``
-    
-This is because it parses as: ``checkname(default="list(1", 2, 3, 4)``.
-That isn't actually unreasonable, but the error message won't help you
-work out what has happened.
-    
-
 TODO
 ====
 
 * A regex check function ?
-* A timestamp check function ? (Using the ``parse`` function from ``DateUtil`` perhaps).
-
+* A timestamp check function ? (Using the ``parse`` function from ``DateUtil``).
+* Allow triple quotes ? (getting a bit heavy for a regex)
 
 ISSUES
 ======
@@ -610,69 +568,9 @@
 If we could pull tuples out of arguments, it would be easier
 to specify arguments for 'mixed_lists'.
 
-
 CHANGELOG
 =========
 
-2008/02/24 - Version 0.3.2
---------------------------
-
-BUGFIX: Handling of None as default value fixed.
-
-
-2008/02/05 - Version 0.3.1
---------------------------
-
-BUGFIX: Unicode checks no longer broken.
-
-
-2008/02/05 - Version 0.3.0
---------------------------
-
-Improved performance with a parse cache.
-
-New ``get_default_value`` method. Given a check it returns the default
-value (converted to the correct type) or raises a ``KeyError`` if the
-check doesn't specify a default.
-
-Added 'tuple' check and corresponding 'is_tuple' function (which always returns a tuple).
-
-BUGFIX: A quoted 'None' as a default value is no longer treated as None,
-but as the string 'None'.
-
-BUGFIX: We weren't unquoting keyword arguments of length two, so an
-empty string didn't work as a default.
-
-BUGFIX: Strings no longer pass the 'is_list' check. Additionally, the
-list checks always return lists.
-
-A couple of documentation bug fixes.
-
-Removed CHANGELOG from module.
-
-
-2007/02/04      Version 0.2.3
------------------------------
-
-Release of 0.2.3
-
-
-2006/12/17      Version 0.2.3-alpha1
-------------------------------------
-
-By Nicola Larosa
-
-Fixed validate doc to talk of ``boolean`` instead of ``bool``; changed the
-``is_bool`` function to ``is_boolean`` (Sourceforge bug #1531525).
-
-
-2006/04/29      Version 0.2.2
------------------------------
-
-Addressed bug where a string would pass the ``is_list`` test. (Thanks to
-Konrad Wojas.)
-
-
 2005/12/16      Version 0.2.1
 -----------------------------
 
@@ -687,7 +585,6 @@
 
 Moved a function call outside a try...except block.
 
-
 2005/08/18      Version 0.2.0
 -----------------------------
 
@@ -695,12 +592,11 @@
 
 Does type conversion as well.
 
-
 2005/02/01      Version 0.1.0
 -----------------------------
 
 Initial version developed by `Michael Foord`_
-and Mark Andrews.
+and `Mark Andrews`_
 
 .. note::
 
@@ -708,28 +604,22 @@
     textmacros module and the PySrc CSS stuff. See
     http://www.voidspace.org.uk/python/firedrop2/textmacros.shtml
 
-
 .. raw:: html
 
     <div align="center">
-        <p>
-            <a href="http://www.python.org">
-                <img src="images/new_python.gif" width="100" height="103" border="0" 
-                    alt="Powered by Python" />
-            </a>
-            <a href="http://sourceforge.net">
-                <img src="http://sourceforge.net/sflogo.php?group_id=123265&amp;type=1" width="88" height="31" border="0" alt="SourceForge.net Logo" />
-            </a>
-            <a href="http://www.opensource.org">
-                <img src="images/osi-certified-120x100.gif" width="120" height="100" border="0"
-                    alt="Certified Open Source"/>
-            </a>
-        </p>
-        <p>
-            <a href="http://www.voidspace.org.uk/python/index.shtml">
-                <img src="images/pythonbanner.gif" width="468" height="60" 
-                alt="Python on Voidspace" border="0" />
-            </a>
-        </p>
+        <a href="http://www.python.org">
+            <img src="images/powered_by_python.jpg" width="602" height="186" border="0" />
+        </a>
+        <a href="http://www.opensource.org">
+            <img src="images/osi-certified-120x100.gif" width="120" height="100" border="0" />
+            <br /><strong>Certified Open Source</strong>
+        </a>
+        <br /><br />
+        <script type="text/javascript" language="JavaScript">var site="s16atlantibots"</script>
+        <script type="text/javascript" language="JavaScript1.2" src="http://s16.sitemeter.com/js/counter.js?site=s16atlantibots"></script>
+        <noscript>
+            <a href="http://s16.sitemeter.com/stats.asp?site=s16atlantibots">
+                <img src="http://s16.sitemeter.com/meter.asp?site=s16atlantibots" alt="Site Meter" border=0 />
+            </a>
+        </noscript>
     </div>
-

=== modified file 'bzrlib/version.py'
--- bzrlib/version.py	2008-03-19 01:40:18 +0000
+++ bzrlib/version.py	2007-10-16 17:37:43 +0000
@@ -57,7 +57,7 @@
         python_dll = "python%d%d.dll" % sys.version_info[:2]
         to_file.write(os.path.join(basedir, python_dll) + ' ')
     # and now version of python interpreter
-    to_file.write(bzrlib._format_version_tuple(sys.version_info))
+    to_file.write('.'.join(map(str, sys.version_info)))
     to_file.write('\n')
 
     to_file.write("  Python standard library:" + ' ')

=== modified file 'bzrlib/version_info_formats/__init__.py'
--- bzrlib/version_info_formats/__init__.py	2008-05-08 04:33:38 +0000
+++ bzrlib/version_info_formats/__init__.py	2007-02-15 18:32:24 +0000
@@ -19,12 +19,11 @@
 import time
 
 from bzrlib.osutils import local_time_offset, format_date
-from bzrlib import registry
-from bzrlib.symbol_versioning import (
-    deprecated_function,
-    one_zero,
-    )
-
+
+
+# This contains a map of format id => formatter
+# None is considered the default formatter
+_version_formats = {}
 
 def create_date_str(timestamp=None, offset=None):
     """Just a wrapper around format_date to provide the right format.
@@ -49,7 +48,7 @@
                 check_for_clean=False,
                 include_revision_history=False,
                 include_file_revisions=False,
-                template=None):
+                ):
         """Build up information about the given branch.
         If working_tree is given, it can be checked for changes.
 
@@ -63,15 +62,12 @@
             date and message
         :param include_file_revisions: The output should
             include the explicit last-changed revision for each file.
-        :param template: Template for the output formatting, not used by
-            all builders.
         """
         self._branch = branch
         self._working_tree = working_tree
         self._check = check_for_clean
         self._include_history = include_revision_history
         self._include_file_revs = include_file_revisions
-        self._template = template
 
         self._clean = None
         self._file_revisions = {}
@@ -141,9 +137,8 @@
         rev_hist = self._branch.revision_history()
         if self._working_tree is not None:
             last_rev = self._working_tree.last_revision()
-            if last_rev not in rev_hist:
-                raise AssertionError(
-                    "Working Tree's last revision not in branch.revision_history")
+            assert last_rev in rev_hist, \
+                "Working Tree's last revision not in branch.revision_history"
             rev_hist = rev_hist[:rev_hist.index(last_rev)+1]
 
         repository =  self._branch.repository
@@ -174,22 +169,44 @@
         raise NotImplementedError(VersionInfoBuilder.generate)
 
 
-format_registry = registry.Registry()
-
-
-format_registry.register_lazy(
-    'rio',
-    'bzrlib.version_info_formats.format_rio',
-    'RioVersionInfoBuilder',
-    'Version info in RIO (simple text) format (default).')
-format_registry.default_key = 'rio'
-format_registry.register_lazy(
-    'python',
-    'bzrlib.version_info_formats.format_python',
-    'PythonVersionInfoBuilder',
-    'Version info in Python format.')
-format_registry.register_lazy(
-    'custom',
-    'bzrlib.version_info_formats.format_custom',
-    'CustomVersionInfoBuilder',
-    'Version info in Custom template-based format.')
+
+def register_builder(format, module, class_name):
+    """Register a version info format.
+
+    :param format: The short name of the format, this will be used as the
+        lookup key.
+    :param module: The string name to the module where the format class
+        can be found
+    :param class_name: The string name of the class to instantiate
+    """
+    if len(_version_formats) == 0:
+        _version_formats[None] = (module, class_name)
+    _version_formats[format] = (module, class_name)
+
+
+def get_builder(format):
+    """Get a handle to the version info builder class
+
+    :param format: The lookup key supplied to register_builder
+    :return: A class, which follows the VersionInfoBuilder api.
+    """
+    builder_module, builder_class_name = _version_formats[format]
+    module = __import__(builder_module, globals(), locals(),
+                        [builder_class_name])
+    klass = getattr(module, builder_class_name)
+    return klass
+
+
+def get_builder_formats():
+    """Get the possible list of formats"""
+    formats = _version_formats.keys()
+    formats.remove(None)
+    return formats
+
+
+register_builder('rio',
+                 'bzrlib.version_info_formats.format_rio',
+                 'RioVersionInfoBuilder')
+register_builder('python',
+                 'bzrlib.version_info_formats.format_python',
+                 'PythonVersionInfoBuilder')

=== removed file 'bzrlib/version_info_formats/format_custom.py'
--- bzrlib/version_info_formats/format_custom.py	2008-01-30 15:54:33 +0000
+++ bzrlib/version_info_formats/format_custom.py	1970-01-01 00:00:00 +0000
@@ -1,107 +0,0 @@
-# Copyright (C) 2007 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""A generator which creates a template-based output from the current
-   tree info."""
-
-from bzrlib import errors
-from bzrlib.lazy_regex import lazy_compile
-from bzrlib.version_info_formats import (
-   create_date_str,
-   VersionInfoBuilder,
-   )
-
-
-class Template(object):
-    """A simple template engine.
-
-    >>> t = Template()
-    >>> t.add('test', 'xxx')
-    >>> print list(t.process('{test}'))
-    ['xxx']
-    >>> print list(t.process('{test} test'))
-    ['xxx', ' test']
-    >>> print list(t.process('test {test}'))
-    ['test ', 'xxx']
-    >>> print list(t.process('test {test} test'))
-    ['test ', 'xxx', ' test']
-    >>> print list(t.process('{test}\\\\n'))
-    ['xxx', '\\n']
-    >>> print list(t.process('{test}\\n'))
-    ['xxx', '\\n']
-    """
-
-    _tag_re = lazy_compile('{(\w+)}')
-
-    def __init__(self):
-        self._data = {}
-
-    def add(self, name, value):
-        self._data[name] = value
-
-    def process(self, tpl):
-        tpl = tpl.decode('string_escape')
-        pos = 0
-        while True:
-            match = self._tag_re.search(tpl, pos)
-            if not match:
-                if pos < len(tpl):
-                    yield tpl[pos:]
-                break
-            start, end = match.span()
-            if start > 0:
-                yield tpl[pos:start]
-            pos = end
-            name = match.group(1)
-            try:
-                data = self._data[name]
-            except KeyError:
-                raise errors.MissingTemplateVariable(name)
-            if not isinstance(data, basestring):
-                data = str(data)
-            yield data
-
-
-class CustomVersionInfoBuilder(VersionInfoBuilder):
-    """Create a version file based on a custom template."""
-
-    def generate(self, to_file):
-        if self._template is None:
-            raise errors.NoTemplate()
-
-        info = Template()
-        info.add('build_date', create_date_str())
-        info.add('branch_nick', self._branch.nick)
-
-        revision_id = self._get_revision_id()
-        if revision_id is None:
-            info.add('revno', 0)
-        else:
-            info.add('revno', self._branch.revision_id_to_revno(revision_id))
-            info.add('revision_id', revision_id)
-            rev = self._branch.repository.get_revision(revision_id)
-            info.add('date', create_date_str(rev.timestamp, rev.timezone))
-
-        if self._check:
-            self._extract_file_revisions()
-
-        if self._check:
-            if self._clean:
-                info.add('clean', 1)
-            else:
-                info.add('clean', 0)
-
-        to_file.writelines(info.process(self._template))

=== modified file 'bzrlib/versionedfile.py'
--- bzrlib/versionedfile.py	2008-07-17 09:40:51 +0000
+++ bzrlib/versionedfile.py	2007-10-12 08:18:54 +0000
@@ -19,12 +19,6 @@
 
 """Versioned text file storage api."""
 
-from copy import copy
-from cStringIO import StringIO
-import os
-import urllib
-from zlib import adler32
-
 from bzrlib.lazy_import import lazy_import
 lazy_import(globals(), """
 
@@ -36,126 +30,15 @@
     revision,
     ui,
     )
-from bzrlib.graph import DictParentsProvider, Graph, _StackedParentsProvider
 from bzrlib.transport.memory import MemoryTransport
 """)
+
+from cStringIO import StringIO
+
 from bzrlib.inter import InterObject
-from bzrlib.registry import Registry
-from bzrlib.symbol_versioning import *
 from bzrlib.textmerge import TextMerge
 
 
-adapter_registry = Registry()
-adapter_registry.register_lazy(('knit-delta-gz', 'fulltext'), 'bzrlib.knit',
-    'DeltaPlainToFullText')
-adapter_registry.register_lazy(('knit-ft-gz', 'fulltext'), 'bzrlib.knit',
-    'FTPlainToFullText')
-adapter_registry.register_lazy(('knit-annotated-delta-gz', 'knit-delta-gz'),
-    'bzrlib.knit', 'DeltaAnnotatedToUnannotated')
-adapter_registry.register_lazy(('knit-annotated-delta-gz', 'fulltext'),
-    'bzrlib.knit', 'DeltaAnnotatedToFullText')
-adapter_registry.register_lazy(('knit-annotated-ft-gz', 'knit-ft-gz'),
-    'bzrlib.knit', 'FTAnnotatedToUnannotated')
-adapter_registry.register_lazy(('knit-annotated-ft-gz', 'fulltext'),
-    'bzrlib.knit', 'FTAnnotatedToFullText')
-
-
-class ContentFactory(object):
-    """Abstract interface for insertion and retrieval from a VersionedFile.
-    
-    :ivar sha1: None, or the sha1 of the content fulltext.
-    :ivar storage_kind: The native storage kind of this factory. One of
-        'mpdiff', 'knit-annotated-ft', 'knit-annotated-delta', 'knit-ft',
-        'knit-delta', 'fulltext', 'knit-annotated-ft-gz',
-        'knit-annotated-delta-gz', 'knit-ft-gz', 'knit-delta-gz'.
-    :ivar key: The key of this content. Each key is a tuple with a single
-        string in it.
-    :ivar parents: A tuple of parent keys for self.key. If the object has
-        no parent information, None (as opposed to () for an empty list of
-        parents).
-    """
-
-    def __init__(self):
-        """Create a ContentFactory."""
-        self.sha1 = None
-        self.storage_kind = None
-        self.key = None
-        self.parents = None
-
-
-class FulltextContentFactory(ContentFactory):
-    """Static data content factory.
-
-    This takes a fulltext when created and just returns that during
-    get_bytes_as('fulltext').
-    
-    :ivar sha1: None, or the sha1 of the content fulltext.
-    :ivar storage_kind: The native storage kind of this factory. Always
-        'fulltext'.
-    :ivar key: The key of this content. Each key is a tuple with a single
-        string in it.
-    :ivar parents: A tuple of parent keys for self.key. If the object has
-        no parent information, None (as opposed to () for an empty list of
-        parents).
-     """
-
-    def __init__(self, key, parents, sha1, text):
-        """Create a ContentFactory."""
-        self.sha1 = sha1
-        self.storage_kind = 'fulltext'
-        self.key = key
-        self.parents = parents
-        self._text = text
-
-    def get_bytes_as(self, storage_kind):
-        if storage_kind == self.storage_kind:
-            return self._text
-        raise errors.UnavailableRepresentation(self.key, storage_kind,
-            self.storage_kind)
-
-
-class AbsentContentFactory(ContentFactory):
-    """A placeholder content factory for unavailable texts.
-    
-    :ivar sha1: None.
-    :ivar storage_kind: 'absent'.
-    :ivar key: The key of this content. Each key is a tuple with a single
-        string in it.
-    :ivar parents: None.
-    """
-
-    def __init__(self, key):
-        """Create a ContentFactory."""
-        self.sha1 = None
-        self.storage_kind = 'absent'
-        self.key = key
-        self.parents = None
-
-
-class AdapterFactory(ContentFactory):
-    """A content factory to adapt between key prefix's."""
-
-    def __init__(self, key, parents, adapted):
-        """Create an adapter factory instance."""
-        self.key = key
-        self.parents = parents
-        self._adapted = adapted
-
-    def __getattr__(self, attr):
-        """Return a member from the adapted object."""
-        if attr in ('key', 'parents'):
-            return self.__dict__[attr]
-        else:
-            return getattr(self._adapted, attr)
-
-
-def filter_absent(record_stream):
-    """Adapt a record stream to remove absent records."""
-    for record in record_stream:
-        if record.storage_kind != 'absent':
-            yield record
-
-
 class VersionedFile(object):
     """Versioned text file storage.
     
@@ -170,6 +53,10 @@
     Texts are identified by a version-id string.
     """
 
+    def __init__(self, access_mode):
+        self.finished = False
+        self._access_mode = access_mode
+
     @staticmethod
     def check_not_reserved_id(version_id):
         revision.check_not_reserved_id(version_id)
@@ -178,36 +65,18 @@
         """Copy this versioned file to name on transport."""
         raise NotImplementedError(self.copy_to)
 
-    def get_record_stream(self, versions, ordering, include_delta_closure):
-        """Get a stream of records for versions.
+    def versions(self):
+        """Return a unsorted list of versions."""
+        raise NotImplementedError(self.versions)
 
-        :param versions: The versions to include. Each version is a tuple
-            (version,).
-        :param ordering: Either 'unordered' or 'topological'. A topologically
-            sorted stream has compression parents strictly before their
-            children.
-        :param include_delta_closure: If True then the closure across any
-            compression parents will be included (in the data content of the
-            stream, not in the emitted records). This guarantees that
-            'fulltext' can be used successfully on every record.
-        :return: An iterator of ContentFactory objects, each of which is only
-            valid until the iterator is advanced.
-        """
-        raise NotImplementedError(self.get_record_stream)
+    def has_ghost(self, version_id):
+        """Returns whether version is present as a ghost."""
+        raise NotImplementedError(self.has_ghost)
 
     def has_version(self, version_id):
         """Returns whether version is present."""
         raise NotImplementedError(self.has_version)
 
-    def insert_record_stream(self, stream):
-        """Insert a record stream into this versioned file.
-
-        :param stream: A stream of records to insert. 
-        :return: None
-        :seealso VersionedFile.get_record_stream:
-        """
-        raise NotImplementedError
-
     def add_lines(self, version_id, parents, lines, parent_texts=None,
         left_matching_blocks=None, nostore_sha=None, random_id=False,
         check_content=True):
@@ -259,17 +128,17 @@
 
     def add_lines_with_ghosts(self, version_id, parents, lines,
         parent_texts=None, nostore_sha=None, random_id=False,
-        check_content=True, left_matching_blocks=None):
+        check_content=True):
         """Add lines to the versioned file, allowing ghosts to be present.
         
         This takes the same parameters as add_lines and returns the same.
         """
         self._check_write_ok()
         return self._add_lines_with_ghosts(version_id, parents, lines,
-            parent_texts, nostore_sha, random_id, check_content, left_matching_blocks)
+            parent_texts, nostore_sha, random_id, check_content)
 
     def _add_lines_with_ghosts(self, version_id, parents, lines, parent_texts,
-        nostore_sha, random_id, check_content, left_matching_blocks):
+        nostore_sha, random_id, check_content):
         """Helper to do class specific add_lines_with_ghosts."""
         raise NotImplementedError(self.add_lines_with_ghosts)
 
@@ -289,6 +158,51 @@
             if '\n' in line[:-1]:
                 raise errors.BzrBadParameterContainsNewline("lines")
 
+    def _check_write_ok(self):
+        """Is the versioned file marked as 'finished' ? Raise if it is."""
+        if self.finished:
+            raise errors.OutSideTransaction()
+        if self._access_mode != 'w':
+            raise errors.ReadOnlyObjectDirtiedError(self)
+
+    def enable_cache(self):
+        """Tell this versioned file that it should cache any data it reads.
+        
+        This is advisory, implementations do not have to support caching.
+        """
+        pass
+    
+    def clear_cache(self):
+        """Remove any data cached in the versioned file object.
+
+        This only needs to be supported if caches are supported
+        """
+        pass
+
+    def clone_text(self, new_version_id, old_version_id, parents):
+        """Add an identical text to old_version_id as new_version_id.
+
+        Must raise RevisionNotPresent if the old version or any of the
+        parents are not present in file history.
+
+        Must raise RevisionAlreadyPresent if the new version is
+        already present in file history."""
+        self._check_write_ok()
+        return self._clone_text(new_version_id, old_version_id, parents)
+
+    def _clone_text(self, new_version_id, old_version_id, parents):
+        """Helper function to do the _clone_text work."""
+        raise NotImplementedError(self.clone_text)
+
+    def create_empty(self, name, transport, mode=None):
+        """Create a new versioned file of this exact type.
+
+        :param name: the file name
+        :param transport: the transport
+        :param mode: optional file mode.
+        """
+        raise NotImplementedError(self.create_empty)
+
     def get_format_signature(self):
         """Get a text description of the data encoding in this file.
         
@@ -299,29 +213,15 @@
     def make_mpdiffs(self, version_ids):
         """Create multiparent diffs for specified versions."""
         knit_versions = set()
-        knit_versions.update(version_ids)
-        parent_map = self.get_parent_map(version_ids)
         for version_id in version_ids:
-            try:
-                knit_versions.update(parent_map[version_id])
-            except KeyError:
-                raise errors.RevisionNotPresent(version_id, self)
-        # We need to filter out ghosts, because we can't diff against them.
-        knit_versions = set(self.get_parent_map(knit_versions).keys())
+            knit_versions.add(version_id)
+            knit_versions.update(self.get_parents(version_id))
         lines = dict(zip(knit_versions,
             self._get_lf_split_line_list(knit_versions)))
         diffs = []
         for version_id in version_ids:
             target = lines[version_id]
-            try:
-                parents = [lines[p] for p in parent_map[version_id] if p in
-                    knit_versions]
-            except KeyError:
-                # I don't know how this could ever trigger.
-                # parent_map[version_id] was already triggered in the previous
-                # for loop, and lines[p] has the 'if p in knit_versions' check,
-                # so we again won't have a KeyError.
-                raise errors.RevisionNotPresent(version_id, self)
+            parents = [lines[p] for p in self.get_parents(version_id)]
             if len(parents) > 0:
                 left_parent_blocks = self._extract_blocks(version_id,
                                                           parents[0], target)
@@ -351,9 +251,8 @@
         for version, parent_ids, expected_sha1, mpdiff in records:
             needed_parents.update(p for p in parent_ids
                                   if not mpvf.has_version(p))
-        present_parents = set(self.get_parent_map(needed_parents).keys())
-        for parent_id, lines in zip(present_parents,
-                                 self._get_lf_split_line_list(present_parents)):
+        for parent_id, lines in zip(needed_parents,
+                                 self._get_lf_split_line_list(needed_parents)):
             mpvf.add_version(lines, parent_id, [])
         for (version, parent_ids, expected_sha1, mpdiff), lines in\
             zip(records, mpvf.get_line_list(versions)):
@@ -362,22 +261,33 @@
                     mpvf.get_diff(parent_ids[0]).num_lines()))
             else:
                 left_matching_blocks = None
-            try:
-                _, _, version_text = self.add_lines_with_ghosts(version,
-                    parent_ids, lines, vf_parents,
-                    left_matching_blocks=left_matching_blocks)
-            except NotImplementedError:
-                # The vf can't handle ghosts, so add lines normally, which will
-                # (reasonably) fail if there are ghosts in the data.
-                _, _, version_text = self.add_lines(version,
-                    parent_ids, lines, vf_parents,
-                    left_matching_blocks=left_matching_blocks)
+            _, _, version_text = self.add_lines(version, parent_ids, lines,
+                vf_parents, left_matching_blocks=left_matching_blocks)
             vf_parents[version] = version_text
-        sha1s = self.get_sha1s(versions)
-        for version, parent_ids, expected_sha1, mpdiff in records:
-            if expected_sha1 != sha1s[version]:
+        for (version, parent_ids, expected_sha1, mpdiff), sha1 in\
+             zip(records, self.get_sha1s(versions)):
+            if expected_sha1 != sha1:
                 raise errors.VersionedFileInvalidChecksum(version)
 
+    def get_sha1(self, version_id):
+        """Get the stored sha1 sum for the given revision.
+        
+        :param version_id: The name of the version to lookup
+        """
+        raise NotImplementedError(self.get_sha1)
+
+    def get_sha1s(self, version_ids):
+        """Get the stored sha1 sums for the given revisions.
+
+        :param version_ids: The names of the versions to lookup
+        :return: a list of sha1s in order according to the version_ids
+        """
+        raise NotImplementedError(self.get_sha1s)
+
+    def get_suffixes(self):
+        """Return the file suffixes associated with this versioned file."""
+        raise NotImplementedError(self.get_suffixes)
+    
     def get_text(self, version_id):
         """Return version contents as a text string.
 
@@ -430,14 +340,44 @@
         but are not explicitly marked.
         """
         raise NotImplementedError(self.get_ancestry_with_ghosts)
-    
-    def get_parent_map(self, version_ids):
-        """Get a map of the parents of version_ids.
-
-        :param version_ids: The version ids to look up parents for.
-        :return: A mapping from version id to parents.
-        """
-        raise NotImplementedError(self.get_parent_map)
+        
+    def get_graph(self, version_ids=None):
+        """Return a graph from the versioned file. 
+        
+        Ghosts are not listed or referenced in the graph.
+        :param version_ids: Versions to select.
+                            None means retrieve all versions.
+        """
+        if version_ids is None:
+            return dict(self.iter_parents(self.versions()))
+        result = {}
+        pending = set(version_ids)
+        while pending:
+            this_iteration = pending
+            pending = set()
+            for version, parents in self.iter_parents(this_iteration):
+                result[version] = parents
+                for parent in parents:
+                    if parent in result:
+                        continue
+                    pending.add(parent)
+        return result
+
+    def get_graph_with_ghosts(self):
+        """Return a graph for the entire versioned file.
+        
+        Ghosts are referenced in parents list but are not
+        explicitly listed.
+        """
+        raise NotImplementedError(self.get_graph_with_ghosts)
+
+    def get_parents(self, version_id):
+        """Return version names for parents of a version.
+
+        Must raise RevisionNotPresent if version is not present in
+        file history.
+        """
+        raise NotImplementedError(self.get_parents)
 
     def get_parents_with_ghosts(self, version_id):
         """Return version names for parents of version_id.
@@ -448,29 +388,47 @@
         Ghosts that are known about will be included in the parent list,
         but are not explicitly marked.
         """
-        try:
-            return list(self.get_parent_map([version_id])[version_id])
-        except KeyError:
-            raise errors.RevisionNotPresent(version_id, self)
+        raise NotImplementedError(self.get_parents_with_ghosts)
+
+    def annotate_iter(self, version_id):
+        """Yield list of (version-id, line) pairs for the specified
+        version.
+
+        Must raise RevisionNotPresent if the given version is
+        not present in file history.
+        """
+        raise NotImplementedError(self.annotate_iter)
 
     def annotate(self, version_id):
-        """Return a list of (version-id, line) tuples for version_id.
-
-        :raise RevisionNotPresent: If the given version is
-        not present in file history.
+        return list(self.annotate_iter(version_id))
+
+    def join(self, other, pb=None, msg=None, version_ids=None,
+             ignore_missing=False):
+        """Integrate versions from other into this versioned file.
+
+        If version_ids is None all versions from other should be
+        incorporated into this versioned file.
+
+        Must raise RevisionNotPresent if any of the specified versions
+        are not present in the other file's history unless ignore_missing
+        is supplied in which case they are silently skipped.
         """
-        raise NotImplementedError(self.annotate)
+        self._check_write_ok()
+        return InterVersionedFile.get(other, self).join(
+            pb,
+            msg,
+            version_ids,
+            ignore_missing)
 
-    def iter_lines_added_or_present_in_versions(self, version_ids=None,
+    def iter_lines_added_or_present_in_versions(self, version_ids=None, 
                                                 pb=None):
         """Iterate over the lines in the versioned file from version_ids.
 
-        This may return lines from other versions. Each item the returned
-        iterator yields is a tuple of a line and a text version that that line
-        is present in (not introduced in).
-
-        Ordering of results is in whatever order is most suitable for the
-        underlying storage format.
+        This may return lines from other versions, and does not return the
+        specific version marker at this point. The api may be changed
+        during development to include the version that the versioned file
+        thinks is relevant, but given that such hints are just guesses,
+        its better not to have it if we don't need it.
 
         If a progress bar is supplied, it may be used to indicate progress.
         The caller is responsible for cleaning up progress bars (because this
@@ -478,11 +436,32 @@
 
         NOTES: Lines are normalised: they will all have \n terminators.
                Lines are returned in arbitrary order.
-
-        :return: An iterator over (line, version_id).
         """
         raise NotImplementedError(self.iter_lines_added_or_present_in_versions)
 
+    def iter_parents(self, version_ids):
+        """Iterate through the parents for many version ids.
+
+        :param version_ids: An iterable yielding version_ids.
+        :return: An iterator that yields (version_id, parents). Requested 
+            version_ids not present in the versioned file are simply skipped.
+            The order is undefined, allowing for different optimisations in
+            the underlying implementation.
+        """
+        for version_id in version_ids:
+            try:
+                yield version_id, tuple(self.get_parents(version_id))
+            except errors.RevisionNotPresent:
+                pass
+
+    def transaction_finished(self):
+        """The transaction that this file was opened in has finished.
+
+        This records self.finished = True and should cause all mutating
+        operations to error.
+        """
+        self.finished = True
+
     def plan_merge(self, ver_a, ver_b):
         """Return pseudo-annotation indicating how the two versions merge.
 
@@ -510,739 +489,6 @@
         return PlanWeaveMerge(plan, a_marker, b_marker).merge_lines()[0]
 
 
-class RecordingVersionedFilesDecorator(object):
-    """A minimal versioned files that records calls made on it.
-    
-    Only enough methods have been added to support tests using it to date.
-
-    :ivar calls: A list of the calls made; can be reset at any time by
-        assigning [] to it.
-    """
-
-    def __init__(self, backing_vf):
-        """Create a RecordingVersionedFileDsecorator decorating backing_vf.
-        
-        :param backing_vf: The versioned file to answer all methods.
-        """
-        self._backing_vf = backing_vf
-        self.calls = []
-
-    def add_lines(self, key, parents, lines, parent_texts=None,
-        left_matching_blocks=None, nostore_sha=None, random_id=False,
-        check_content=True):
-        self.calls.append(("add_lines", key, parents, lines, parent_texts,
-            left_matching_blocks, nostore_sha, random_id, check_content))
-        return self._backing_vf.add_lines(key, parents, lines, parent_texts,
-            left_matching_blocks, nostore_sha, random_id, check_content)
-
-    def check(self):
-        self._backing_vf.check()
-
-    def get_parent_map(self, keys):
-        self.calls.append(("get_parent_map", copy(keys)))
-        return self._backing_vf.get_parent_map(keys)
-
-    def get_record_stream(self, keys, sort_order, include_delta_closure):
-        self.calls.append(("get_record_stream", list(keys), sort_order,
-            include_delta_closure))
-        return self._backing_vf.get_record_stream(keys, sort_order,
-            include_delta_closure)
-
-    def get_sha1s(self, keys):
-        self.calls.append(("get_sha1s", copy(keys)))
-        return self._backing_vf.get_sha1s(keys)
-
-    def iter_lines_added_or_present_in_keys(self, keys, pb=None):
-        self.calls.append(("iter_lines_added_or_present_in_keys", copy(keys)))
-        return self._backing_vf.iter_lines_added_or_present_in_keys(keys, pb=pb)
-
-    def keys(self):
-        self.calls.append(("keys",))
-        return self._backing_vf.keys()
-
-
-class KeyMapper(object):
-    """KeyMappers map between keys and underlying partitioned storage."""
-
-    def map(self, key):
-        """Map key to an underlying storage identifier.
-
-        :param key: A key tuple e.g. ('file-id', 'revision-id').
-        :return: An underlying storage identifier, specific to the partitioning
-            mechanism.
-        """
-        raise NotImplementedError(self.map)
-
-    def unmap(self, partition_id):
-        """Map a partitioned storage id back to a key prefix.
-        
-        :param partition_id: The underlying partition id.
-        :return: As much of a key (or prefix) as is derivable from the partition
-            id.
-        """
-        raise NotImplementedError(self.unmap)
-
-
-class ConstantMapper(KeyMapper):
-    """A key mapper that maps to a constant result."""
-
-    def __init__(self, result):
-        """Create a ConstantMapper which will return result for all maps."""
-        self._result = result
-
-    def map(self, key):
-        """See KeyMapper.map()."""
-        return self._result
-
-
-class URLEscapeMapper(KeyMapper):
-    """Base class for use with transport backed storage.
-
-    This provides a map and unmap wrapper that respectively url escape and
-    unescape their outputs and inputs.
-    """
-
-    def map(self, key):
-        """See KeyMapper.map()."""
-        return urllib.quote(self._map(key))
-
-    def unmap(self, partition_id):
-        """See KeyMapper.unmap()."""
-        return self._unmap(urllib.unquote(partition_id))
-
-
-class PrefixMapper(URLEscapeMapper):
-    """A key mapper that extracts the first component of a key.
-    
-    This mapper is for use with a transport based backend.
-    """
-
-    def _map(self, key):
-        """See KeyMapper.map()."""
-        return key[0]
-
-    def _unmap(self, partition_id):
-        """See KeyMapper.unmap()."""
-        return (partition_id,)
-
-
-class HashPrefixMapper(URLEscapeMapper):
-    """A key mapper that combines the first component of a key with a hash.
-
-    This mapper is for use with a transport based backend.
-    """
-
-    def _map(self, key):
-        """See KeyMapper.map()."""
-        prefix = self._escape(key[0])
-        return "%02x/%s" % (adler32(prefix) & 0xff, prefix)
-
-    def _escape(self, prefix):
-        """No escaping needed here."""
-        return prefix
-
-    def _unmap(self, partition_id):
-        """See KeyMapper.unmap()."""
-        return (self._unescape(osutils.basename(partition_id)),)
-
-    def _unescape(self, basename):
-        """No unescaping needed for HashPrefixMapper."""
-        return basename
-
-
-class HashEscapedPrefixMapper(HashPrefixMapper):
-    """Combines the escaped first component of a key with a hash.
-    
-    This mapper is for use with a transport based backend.
-    """
-
-    _safe = "abcdefghijklmnopqrstuvwxyz0123456789-_@,."
-
-    def _escape(self, prefix):
-        """Turn a key element into a filesystem safe string.
-
-        This is similar to a plain urllib.quote, except
-        it uses specific safe characters, so that it doesn't
-        have to translate a lot of valid file ids.
-        """
-        # @ does not get escaped. This is because it is a valid
-        # filesystem character we use all the time, and it looks
-        # a lot better than seeing %40 all the time.
-        r = [((c in self._safe) and c or ('%%%02x' % ord(c)))
-             for c in prefix]
-        return ''.join(r)
-
-    def _unescape(self, basename):
-        """Escaped names are easily unescaped by urlutils."""
-        return urllib.unquote(basename)
-
-
-def make_versioned_files_factory(versioned_file_factory, mapper):
-    """Create a ThunkedVersionedFiles factory.
-
-    This will create a callable which when called creates a
-    ThunkedVersionedFiles on a transport, using mapper to access individual
-    versioned files, and versioned_file_factory to create each individual file.
-    """
-    def factory(transport):
-        return ThunkedVersionedFiles(transport, versioned_file_factory, mapper,
-            lambda:True)
-    return factory
-
-
-class VersionedFiles(object):
-    """Storage for many versioned files.
-
-    This object allows a single keyspace for accessing the history graph and
-    contents of named bytestrings.
-
-    Currently no implementation allows the graph of different key prefixes to
-    intersect, but the API does allow such implementations in the future.
-
-    The keyspace is expressed via simple tuples. Any instance of VersionedFiles
-    may have a different length key-size, but that size will be constant for
-    all texts added to or retrieved from it. For instance, bzrlib uses
-    instances with a key-size of 2 for storing user files in a repository, with
-    the first element the fileid, and the second the version of that file.
-
-    The use of tuples allows a single code base to support several different
-    uses with only the mapping logic changing from instance to instance.
-    """
-
-    def add_lines(self, key, parents, lines, parent_texts=None,
-        left_matching_blocks=None, nostore_sha=None, random_id=False,
-        check_content=True):
-        """Add a text to the store.
-
-        :param key: The key tuple of the text to add.
-        :param parents: The parents key tuples of the text to add.
-        :param lines: A list of lines. Each line must be a bytestring. And all
-            of them except the last must be terminated with \n and contain no
-            other \n's. The last line may either contain no \n's or a single
-            terminating \n. If the lines list does meet this constraint the add
-            routine may error or may succeed - but you will be unable to read
-            the data back accurately. (Checking the lines have been split
-            correctly is expensive and extremely unlikely to catch bugs so it
-            is not done at runtime unless check_content is True.)
-        :param parent_texts: An optional dictionary containing the opaque 
-            representations of some or all of the parents of version_id to
-            allow delta optimisations.  VERY IMPORTANT: the texts must be those
-            returned by add_lines or data corruption can be caused.
-        :param left_matching_blocks: a hint about which areas are common
-            between the text and its left-hand-parent.  The format is
-            the SequenceMatcher.get_matching_blocks format.
-        :param nostore_sha: Raise ExistingContent and do not add the lines to
-            the versioned file if the digest of the lines matches this.
-        :param random_id: If True a random id has been selected rather than
-            an id determined by some deterministic process such as a converter
-            from a foreign VCS. When True the backend may choose not to check
-            for uniqueness of the resulting key within the versioned file, so
-            this should only be done when the result is expected to be unique
-            anyway.
-        :param check_content: If True, the lines supplied are verified to be
-            bytestrings that are correctly formed lines.
-        :return: The text sha1, the number of bytes in the text, and an opaque
-                 representation of the inserted version which can be provided
-                 back to future add_lines calls in the parent_texts dictionary.
-        """
-        raise NotImplementedError(self.add_lines)
-
-    def add_mpdiffs(self, records):
-        """Add mpdiffs to this VersionedFile.
-
-        Records should be iterables of version, parents, expected_sha1,
-        mpdiff. mpdiff should be a MultiParent instance.
-        """
-        vf_parents = {}
-        mpvf = multiparent.MultiMemoryVersionedFile()
-        versions = []
-        for version, parent_ids, expected_sha1, mpdiff in records:
-            versions.append(version)
-            mpvf.add_diff(mpdiff, version, parent_ids)
-        needed_parents = set()
-        for version, parent_ids, expected_sha1, mpdiff in records:
-            needed_parents.update(p for p in parent_ids
-                                  if not mpvf.has_version(p))
-        # It seems likely that adding all the present parents as fulltexts can
-        # easily exhaust memory.
-        split_lines = osutils.split_lines
-        for record in self.get_record_stream(needed_parents, 'unordered',
-            True):
-            if record.storage_kind == 'absent':
-                continue
-            mpvf.add_version(split_lines(record.get_bytes_as('fulltext')),
-                record.key, [])
-        for (key, parent_keys, expected_sha1, mpdiff), lines in\
-            zip(records, mpvf.get_line_list(versions)):
-            if len(parent_keys) == 1:
-                left_matching_blocks = list(mpdiff.get_matching_blocks(0,
-                    mpvf.get_diff(parent_keys[0]).num_lines()))
-            else:
-                left_matching_blocks = None
-            version_sha1, _, version_text = self.add_lines(key,
-                parent_keys, lines, vf_parents,
-                left_matching_blocks=left_matching_blocks)
-            if version_sha1 != expected_sha1:
-                raise errors.VersionedFileInvalidChecksum(version)
-            vf_parents[key] = version_text
-
-    def annotate(self, key):
-        """Return a list of (version-key, line) tuples for the text of key.
-
-        :raise RevisionNotPresent: If the key is not present.
-        """
-        raise NotImplementedError(self.annotate)
-
-    def check(self, progress_bar=None):
-        """Check this object for integrity."""
-        raise NotImplementedError(self.check)
-
-    @staticmethod
-    def check_not_reserved_id(version_id):
-        revision.check_not_reserved_id(version_id)
-
-    def _check_lines_not_unicode(self, lines):
-        """Check that lines being added to a versioned file are not unicode."""
-        for line in lines:
-            if line.__class__ is not str:
-                raise errors.BzrBadParameterUnicode("lines")
-
-    def _check_lines_are_lines(self, lines):
-        """Check that the lines really are full lines without inline EOL."""
-        for line in lines:
-            if '\n' in line[:-1]:
-                raise errors.BzrBadParameterContainsNewline("lines")
-
-    def get_parent_map(self, keys):
-        """Get a map of the parents of keys.
-
-        :param keys: The keys to look up parents for.
-        :return: A mapping from keys to parents. Absent keys are absent from
-            the mapping.
-        """
-        raise NotImplementedError(self.get_parent_map)
-
-    def get_record_stream(self, keys, ordering, include_delta_closure):
-        """Get a stream of records for keys.
-
-        :param keys: The keys to include.
-        :param ordering: Either 'unordered' or 'topological'. A topologically
-            sorted stream has compression parents strictly before their
-            children.
-        :param include_delta_closure: If True then the closure across any
-            compression parents will be included (in the opaque data).
-        :return: An iterator of ContentFactory objects, each of which is only
-            valid until the iterator is advanced.
-        """
-        raise NotImplementedError(self.get_record_stream)
-
-    def get_sha1s(self, keys):
-        """Get the sha1's of the texts for the given keys.
-
-        :param keys: The names of the keys to lookup
-        :return: a dict from key to sha1 digest. Keys of texts which are not
-            present in the store are not present in the returned
-            dictionary.
-        """
-        raise NotImplementedError(self.get_sha1s)
-
-    def insert_record_stream(self, stream):
-        """Insert a record stream into this container.
-
-        :param stream: A stream of records to insert. 
-        :return: None
-        :seealso VersionedFile.get_record_stream:
-        """
-        raise NotImplementedError
-
-    def iter_lines_added_or_present_in_keys(self, keys, pb=None):
-        """Iterate over the lines in the versioned files from keys.
-
-        This may return lines from other keys. Each item the returned
-        iterator yields is a tuple of a line and a text version that that line
-        is present in (not introduced in).
-
-        Ordering of results is in whatever order is most suitable for the
-        underlying storage format.
-
-        If a progress bar is supplied, it may be used to indicate progress.
-        The caller is responsible for cleaning up progress bars (because this
-        is an iterator).
-
-        NOTES:
-         * Lines are normalised by the underlying store: they will all have \n
-           terminators.
-         * Lines are returned in arbitrary order.
-
-        :return: An iterator over (line, key).
-        """
-        raise NotImplementedError(self.iter_lines_added_or_present_in_keys)
-
-    def keys(self):
-        """Return a iterable of the keys for all the contained texts."""
-        raise NotImplementedError(self.keys)
-
-    def make_mpdiffs(self, keys):
-        """Create multiparent diffs for specified keys."""
-        keys_order = tuple(keys)
-        keys = frozenset(keys)
-        knit_keys = set(keys)
-        parent_map = self.get_parent_map(keys)
-        for parent_keys in parent_map.itervalues():
-            if parent_keys:
-                knit_keys.update(parent_keys)
-        missing_keys = keys - set(parent_map)
-        if missing_keys:
-            raise errors.RevisionNotPresent(list(missing_keys)[0], self)
-        # We need to filter out ghosts, because we can't diff against them.
-        maybe_ghosts = knit_keys - keys
-        ghosts = maybe_ghosts - set(self.get_parent_map(maybe_ghosts))
-        knit_keys.difference_update(ghosts)
-        lines = {}
-        split_lines = osutils.split_lines
-        for record in self.get_record_stream(knit_keys, 'topological', True):
-            lines[record.key] = split_lines(record.get_bytes_as('fulltext'))
-            # line_block_dict = {}
-            # for parent, blocks in record.extract_line_blocks():
-            #   line_blocks[parent] = blocks
-            # line_blocks[record.key] = line_block_dict
-        diffs = []
-        for key in keys_order:
-            target = lines[key]
-            parents = parent_map[key] or []
-            # Note that filtering knit_keys can lead to a parent difference
-            # between the creation and the application of the mpdiff.
-            parent_lines = [lines[p] for p in parents if p in knit_keys]
-            if len(parent_lines) > 0:
-                left_parent_blocks = self._extract_blocks(key, parent_lines[0],
-                    target)
-            else:
-                left_parent_blocks = None
-            diffs.append(multiparent.MultiParent.from_lines(target,
-                parent_lines, left_parent_blocks))
-        return diffs
-
-    def _extract_blocks(self, version_id, source, target):
-        return None
-
-
-class ThunkedVersionedFiles(VersionedFiles):
-    """Storage for many versioned files thunked onto a 'VersionedFile' class.
-
-    This object allows a single keyspace for accessing the history graph and
-    contents of named bytestrings.
-
-    Currently no implementation allows the graph of different key prefixes to
-    intersect, but the API does allow such implementations in the future.
-    """
-
-    def __init__(self, transport, file_factory, mapper, is_locked):
-        """Create a ThunkedVersionedFiles."""
-        self._transport = transport
-        self._file_factory = file_factory
-        self._mapper = mapper
-        self._is_locked = is_locked
-
-    def add_lines(self, key, parents, lines, parent_texts=None,
-        left_matching_blocks=None, nostore_sha=None, random_id=False,
-        check_content=True):
-        """See VersionedFiles.add_lines()."""
-        path = self._mapper.map(key)
-        version_id = key[-1]
-        parents = [parent[-1] for parent in parents]
-        vf = self._get_vf(path)
-        try:
-            try:
-                return vf.add_lines_with_ghosts(version_id, parents, lines,
-                    parent_texts=parent_texts,
-                    left_matching_blocks=left_matching_blocks,
-                    nostore_sha=nostore_sha, random_id=random_id,
-                    check_content=check_content)
-            except NotImplementedError:
-                return vf.add_lines(version_id, parents, lines,
-                    parent_texts=parent_texts,
-                    left_matching_blocks=left_matching_blocks,
-                    nostore_sha=nostore_sha, random_id=random_id,
-                    check_content=check_content)
-        except errors.NoSuchFile:
-            # parent directory may be missing, try again.
-            self._transport.mkdir(osutils.dirname(path))
-            try:
-                return vf.add_lines_with_ghosts(version_id, parents, lines,
-                    parent_texts=parent_texts,
-                    left_matching_blocks=left_matching_blocks,
-                    nostore_sha=nostore_sha, random_id=random_id,
-                    check_content=check_content)
-            except NotImplementedError:
-                return vf.add_lines(version_id, parents, lines,
-                    parent_texts=parent_texts,
-                    left_matching_blocks=left_matching_blocks,
-                    nostore_sha=nostore_sha, random_id=random_id,
-                    check_content=check_content)
-
-    def annotate(self, key):
-        """Return a list of (version-key, line) tuples for the text of key.
-
-        :raise RevisionNotPresent: If the key is not present.
-        """
-        prefix = key[:-1]
-        path = self._mapper.map(prefix)
-        vf = self._get_vf(path)
-        origins = vf.annotate(key[-1])
-        result = []
-        for origin, line in origins:
-            result.append((prefix + (origin,), line))
-        return result
-
-    def check(self, progress_bar=None):
-        """See VersionedFiles.check()."""
-        for prefix, vf in self._iter_all_components():
-            vf.check()
-
-    def get_parent_map(self, keys):
-        """Get a map of the parents of keys.
-
-        :param keys: The keys to look up parents for.
-        :return: A mapping from keys to parents. Absent keys are absent from
-            the mapping.
-        """
-        prefixes = self._partition_keys(keys)
-        result = {}
-        for prefix, suffixes in prefixes.items():
-            path = self._mapper.map(prefix)
-            vf = self._get_vf(path)
-            parent_map = vf.get_parent_map(suffixes)
-            for key, parents in parent_map.items():
-                result[prefix + (key,)] = tuple(
-                    prefix + (parent,) for parent in parents)
-        return result
-
-    def _get_vf(self, path):
-        if not self._is_locked():
-            raise errors.ObjectNotLocked(self)
-        return self._file_factory(path, self._transport, create=True,
-            get_scope=lambda:None)
-
-    def _partition_keys(self, keys):
-        """Turn keys into a dict of prefix:suffix_list."""
-        result = {}
-        for key in keys:
-            prefix_keys = result.setdefault(key[:-1], [])
-            prefix_keys.append(key[-1])
-        return result
-
-    def _get_all_prefixes(self):
-        # Identify all key prefixes.
-        # XXX: A bit hacky, needs polish.
-        if type(self._mapper) == ConstantMapper:
-            paths = [self._mapper.map(())]
-            prefixes = [()]
-        else:
-            relpaths = set()
-            for quoted_relpath in self._transport.iter_files_recursive():
-                path, ext = os.path.splitext(quoted_relpath)
-                relpaths.add(path)
-            paths = list(relpaths)
-            prefixes = [self._mapper.unmap(path) for path in paths]
-        return zip(paths, prefixes)
-
-    def get_record_stream(self, keys, ordering, include_delta_closure):
-        """See VersionedFiles.get_record_stream()."""
-        # Ordering will be taken care of by each partitioned store; group keys
-        # by partition.
-        keys = sorted(keys)
-        for prefix, suffixes, vf in self._iter_keys_vf(keys):
-            suffixes = [(suffix,) for suffix in suffixes]
-            for record in vf.get_record_stream(suffixes, ordering,
-                include_delta_closure):
-                if record.parents is not None:
-                    record.parents = tuple(
-                        prefix + parent for parent in record.parents)
-                record.key = prefix + record.key
-                yield record
-
-    def _iter_keys_vf(self, keys):
-        prefixes = self._partition_keys(keys)
-        sha1s = {}
-        for prefix, suffixes in prefixes.items():
-            path = self._mapper.map(prefix)
-            vf = self._get_vf(path)
-            yield prefix, suffixes, vf
-
-    def get_sha1s(self, keys):
-        """See VersionedFiles.get_sha1s()."""
-        sha1s = {}
-        for prefix,suffixes, vf in self._iter_keys_vf(keys):
-            vf_sha1s = vf.get_sha1s(suffixes)
-            for suffix, sha1 in vf_sha1s.iteritems():
-                sha1s[prefix + (suffix,)] = sha1
-        return sha1s
-
-    def insert_record_stream(self, stream):
-        """Insert a record stream into this container.
-
-        :param stream: A stream of records to insert. 
-        :return: None
-        :seealso VersionedFile.get_record_stream:
-        """
-        for record in stream:
-            prefix = record.key[:-1]
-            key = record.key[-1:]
-            if record.parents is not None:
-                parents = [parent[-1:] for parent in record.parents]
-            else:
-                parents = None
-            thunk_record = AdapterFactory(key, parents, record)
-            path = self._mapper.map(prefix)
-            # Note that this parses the file many times; we can do better but
-            # as this only impacts weaves in terms of performance, it is
-            # tolerable.
-            vf = self._get_vf(path)
-            vf.insert_record_stream([thunk_record])
-
-    def iter_lines_added_or_present_in_keys(self, keys, pb=None):
-        """Iterate over the lines in the versioned files from keys.
-
-        This may return lines from other keys. Each item the returned
-        iterator yields is a tuple of a line and a text version that that line
-        is present in (not introduced in).
-
-        Ordering of results is in whatever order is most suitable for the
-        underlying storage format.
-
-        If a progress bar is supplied, it may be used to indicate progress.
-        The caller is responsible for cleaning up progress bars (because this
-        is an iterator).
-
-        NOTES:
-         * Lines are normalised by the underlying store: they will all have \n
-           terminators.
-         * Lines are returned in arbitrary order.
-
-        :return: An iterator over (line, key).
-        """
-        for prefix, suffixes, vf in self._iter_keys_vf(keys):
-            for line, version in vf.iter_lines_added_or_present_in_versions(suffixes):
-                yield line, prefix + (version,)
-
-    def _iter_all_components(self):
-        for path, prefix in self._get_all_prefixes():
-            yield prefix, self._get_vf(path)
-
-    def keys(self):
-        """See VersionedFiles.keys()."""
-        result = set()
-        for prefix, vf in self._iter_all_components():
-            for suffix in vf.versions():
-                result.add(prefix + (suffix,))
-        return result
-
-
-class _PlanMergeVersionedFile(VersionedFiles):
-    """A VersionedFile for uncommitted and committed texts.
-
-    It is intended to allow merges to be planned with working tree texts.
-    It implements only the small part of the VersionedFiles interface used by
-    PlanMerge.  It falls back to multiple versionedfiles for data not stored in
-    _PlanMergeVersionedFile itself.
-
-    :ivar: fallback_versionedfiles a list of VersionedFiles objects that can be
-        queried for missing texts.
-    """
-
-    def __init__(self, file_id):
-        """Create a _PlanMergeVersionedFile.
-
-        :param file_id: Used with _PlanMerge code which is not yet fully
-            tuple-keyspace aware.
-        """
-        self._file_id = file_id
-        # fallback locations
-        self.fallback_versionedfiles = []
-        # Parents for locally held keys.
-        self._parents = {}
-        # line data for locally held keys.
-        self._lines = {}
-        # key lookup providers
-        self._providers = [DictParentsProvider(self._parents)]
-
-    def plan_merge(self, ver_a, ver_b, base=None):
-        """See VersionedFile.plan_merge"""
-        from bzrlib.merge import _PlanMerge
-        if base is None:
-            return _PlanMerge(ver_a, ver_b, self, (self._file_id,)).plan_merge()
-        old_plan = list(_PlanMerge(ver_a, base, self, (self._file_id,)).plan_merge())
-        new_plan = list(_PlanMerge(ver_a, ver_b, self, (self._file_id,)).plan_merge())
-        return _PlanMerge._subtract_plans(old_plan, new_plan)
-
-    def plan_lca_merge(self, ver_a, ver_b, base=None):
-        from bzrlib.merge import _PlanLCAMerge
-        graph = Graph(self)
-        new_plan = _PlanLCAMerge(ver_a, ver_b, self, (self._file_id,), graph).plan_merge()
-        if base is None:
-            return new_plan
-        old_plan = _PlanLCAMerge(ver_a, base, self, (self._file_id,), graph).plan_merge()
-        return _PlanLCAMerge._subtract_plans(list(old_plan), list(new_plan))
-
-    def add_lines(self, key, parents, lines):
-        """See VersionedFiles.add_lines
-
-        Lines are added locally, not to fallback versionedfiles.  Also, ghosts
-        are permitted.  Only reserved ids are permitted.
-        """
-        if type(key) is not tuple:
-            raise TypeError(key)
-        if not revision.is_reserved_id(key[-1]):
-            raise ValueError('Only reserved ids may be used')
-        if parents is None:
-            raise ValueError('Parents may not be None')
-        if lines is None:
-            raise ValueError('Lines may not be None')
-        self._parents[key] = tuple(parents)
-        self._lines[key] = lines
-
-    def get_record_stream(self, keys, ordering, include_delta_closure):
-        pending = set(keys)
-        for key in keys:
-            if key in self._lines:
-                lines = self._lines[key]
-                parents = self._parents[key]
-                pending.remove(key)
-                yield FulltextContentFactory(key, parents, None,
-                    ''.join(lines))
-        for versionedfile in self.fallback_versionedfiles:
-            for record in versionedfile.get_record_stream(
-                pending, 'unordered', True):
-                if record.storage_kind == 'absent':
-                    continue
-                else:
-                    pending.remove(record.key)
-                    yield record
-            if not pending:
-                return
-        # report absent entries
-        for key in pending:
-            yield AbsentContentFactory(key)
-
-    def get_parent_map(self, keys):
-        """See VersionedFiles.get_parent_map"""
-        # We create a new provider because a fallback may have been added.
-        # If we make fallbacks private we can update a stack list and avoid
-        # object creation thrashing.
-        keys = set(keys)
-        result = {}
-        if revision.NULL_REVISION in keys:
-            keys.remove(revision.NULL_REVISION)
-            result[revision.NULL_REVISION] = ()
-        self._providers = self._providers[:1] + self.fallback_versionedfiles
-        result.update(
-            _StackedParentsProvider(self._providers).get_parent_map(keys))
-        for key, parents in result.iteritems():
-            if parents == ():
-                result[key] = (revision.NULL_REVISION,)
-        return result
-
-
 class PlanWeaveMerge(TextMerge):
     """Weave merge that takes a plan as its input.
     
@@ -1300,16 +546,9 @@
             elif state == 'new-b':
                 ch_b = True
                 lines_b.append(line)
-            elif state == 'conflicted-a':
-                ch_b = ch_a = True
-                lines_a.append(line)
-            elif state == 'conflicted-b':
-                ch_b = ch_a = True
-                lines_b.append(line)
             else:
-                if state not in ('irrelevant', 'ghost-a', 'ghost-b',
-                        'killed-base', 'killed-both'):
-                    raise AssertionError(state)
+                assert state in ('irrelevant', 'ghost-a', 'ghost-b', 
+                                 'killed-base', 'killed-both'), state
         for struct in outstanding_struct():
             yield struct
 
@@ -1323,67 +562,106 @@
         PlanWeaveMerge.__init__(self, plan, a_marker, b_marker)
 
 
-class VirtualVersionedFiles(VersionedFiles):
-    """Dummy implementation for VersionedFiles that uses other functions for 
-    obtaining fulltexts and parent maps.
-
-    This is always on the bottom of the stack and uses string keys 
-    (rather than tuples) internally.
+class InterVersionedFile(InterObject):
+    """This class represents operations taking place between two VersionedFiles.
+
+    Its instances have methods like join, and contain
+    references to the source and target versionedfiles these operations can be 
+    carried out on.
+
+    Often we will provide convenience methods on 'versionedfile' which carry out
+    operations with another versionedfile - they will always forward to
+    InterVersionedFile.get(other).method_name(parameters).
     """
 
-    def __init__(self, get_parent_map, get_lines):
-        """Create a VirtualVersionedFiles.
-
-        :param get_parent_map: Same signature as Repository.get_parent_map.
-        :param get_lines: Should return lines for specified key or None if 
-                          not available.
-        """
-        super(VirtualVersionedFiles, self).__init__()
-        self._get_parent_map = get_parent_map
-        self._get_lines = get_lines
-        
-    def check(self, progressbar=None):
-        """See VersionedFiles.check.
-
-        :note: Always returns True for VirtualVersionedFiles.
-        """
-        return True
-
-    def add_mpdiffs(self, records):
-        """See VersionedFiles.mpdiffs.
-
-        :note: Not implemented for VirtualVersionedFiles.
-        """
-        raise NotImplementedError(self.add_mpdiffs)
-
-    def get_parent_map(self, keys):
-        """See VersionedFiles.get_parent_map."""
-        return dict([((k,), tuple([(p,) for p in v]))
-            for k,v in self._get_parent_map([k for (k,) in keys]).iteritems()])
-
-    def get_sha1s(self, keys):
-        """See VersionedFiles.get_sha1s."""
-        ret = {}
-        for (k,) in keys:
-            lines = self._get_lines(k)
-            if lines is not None:
-                if not isinstance(lines, list):
-                    raise AssertionError
-                ret[(k,)] = osutils.sha_strings(lines)
-        return ret
-
-    def get_record_stream(self, keys, ordering, include_delta_closure):
-        """See VersionedFiles.get_record_stream."""
-        for (k,) in list(keys):
-            lines = self._get_lines(k)
-            if lines is not None:
-                if not isinstance(lines, list):
-                    raise AssertionError
-                yield FulltextContentFactory((k,), None, 
-                        sha1=osutils.sha_strings(lines),
-                        text=''.join(lines))
-            else:
-                yield AbsentContentFactory((k,))
-
-
-
+    _optimisers = []
+    """The available optimised InterVersionedFile types."""
+
+    def join(self, pb=None, msg=None, version_ids=None, ignore_missing=False):
+        """Integrate versions from self.source into self.target.
+
+        If version_ids is None all versions from source should be
+        incorporated into this versioned file.
+
+        Must raise RevisionNotPresent if any of the specified versions
+        are not present in the other file's history unless ignore_missing is 
+        supplied in which case they are silently skipped.
+        """
+        # the default join: 
+        # - if the target is empty, just add all the versions from 
+        #   source to target, otherwise:
+        # - make a temporary versioned file of type target
+        # - insert the source content into it one at a time
+        # - join them
+        if not self.target.versions():
+            target = self.target
+        else:
+            # Make a new target-format versioned file. 
+            temp_source = self.target.create_empty("temp", MemoryTransport())
+            target = temp_source
+        version_ids = self._get_source_version_ids(version_ids, ignore_missing)
+        graph = self.source.get_graph(version_ids)
+        order = tsort.topo_sort(graph.items())
+        pb = ui.ui_factory.nested_progress_bar()
+        parent_texts = {}
+        try:
+            # TODO for incremental cross-format work:
+            # make a versioned file with the following content:
+            # all revisions we have been asked to join
+            # all their ancestors that are *not* in target already.
+            # the immediate parents of the above two sets, with 
+            # empty parent lists - these versions are in target already
+            # and the incorrect version data will be ignored.
+            # TODO: for all ancestors that are present in target already,
+            # check them for consistent data, this requires moving sha1 from
+            # 
+            # TODO: remove parent texts when they are not relevant any more for 
+            # memory pressure reduction. RBC 20060313
+            # pb.update('Converting versioned data', 0, len(order))
+            total = len(order)
+            for index, version in enumerate(order):
+                pb.update('Converting versioned data', index, total)
+                _, _, parent_text = target.add_lines(version,
+                                               self.source.get_parents(version),
+                                               self.source.get_lines(version),
+                                               parent_texts=parent_texts)
+                parent_texts[version] = parent_text
+            
+            # this should hit the native code path for target
+            if target is not self.target:
+                return self.target.join(temp_source,
+                                        pb,
+                                        msg,
+                                        version_ids,
+                                        ignore_missing)
+            else:
+                return total
+        finally:
+            pb.finished()
+
+    def _get_source_version_ids(self, version_ids, ignore_missing):
+        """Determine the version ids to be used from self.source.
+
+        :param version_ids: The caller-supplied version ids to check. (None 
+                            for all). If None is in version_ids, it is stripped.
+        :param ignore_missing: if True, remove missing ids from the version 
+                               list. If False, raise RevisionNotPresent on
+                               a missing version id.
+        :return: A set of version ids.
+        """
+        if version_ids is None:
+            # None cannot be in source.versions
+            return set(self.source.versions())
+        else:
+            if ignore_missing:
+                return set(self.source.versions()).intersection(set(version_ids))
+            else:
+                new_version_ids = set()
+                for version in version_ids:
+                    if version is None:
+                        continue
+                    if not self.source.has_version(version):
+                        raise errors.RevisionNotPresent(version, str(self.source))
+                    else:
+                        new_version_ids.add(version)
+                return new_version_ids

=== modified file 'bzrlib/weave.py'
--- bzrlib/weave.py	2008-07-16 18:14:23 +0000
+++ bzrlib/weave.py	2007-10-05 05:52:45 +0000
@@ -78,52 +78,21 @@
 from bzrlib import (
     progress,
     )
+from bzrlib.trace import mutter
 from bzrlib.errors import (WeaveError, WeaveFormatError, WeaveParentMismatch,
         RevisionAlreadyPresent,
         RevisionNotPresent,
-        UnavailableRepresentation,
         WeaveRevisionAlreadyPresent,
         WeaveRevisionNotPresent,
         )
 import bzrlib.errors as errors
-from bzrlib.osutils import dirname, sha_strings, split_lines
+from bzrlib.osutils import sha_strings
 import bzrlib.patiencediff
-from bzrlib.revision import NULL_REVISION
-from bzrlib.symbol_versioning import *
-from bzrlib.trace import mutter
 from bzrlib.tsort import topo_sort
-from bzrlib.versionedfile import (
-    AbsentContentFactory,
-    adapter_registry,
-    ContentFactory,
-    VersionedFile,
-    )
+from bzrlib.versionedfile import VersionedFile, InterVersionedFile
 from bzrlib.weavefile import _read_weave_v5, write_weave_v5
 
 
-class WeaveContentFactory(ContentFactory):
-    """Content factory for streaming from weaves.
-
-    :seealso ContentFactory:
-    """
-
-    def __init__(self, version, weave):
-        """Create a WeaveContentFactory for version from weave."""
-        ContentFactory.__init__(self)
-        self.sha1 = weave.get_sha1s([version])[version]
-        self.key = (version,)
-        parents = weave.get_parent_map([version])[version]
-        self.parents = tuple((parent,) for parent in parents)
-        self.storage_kind = 'fulltext'
-        self._weave = weave
-
-    def get_bytes_as(self, storage_kind):
-        if storage_kind == 'fulltext':
-            return self._weave.get_text(self.key[-1])
-        else:
-            raise UnavailableRepresentation(self.key, storage_kind, 'fulltext')
-
-
 class Weave(VersionedFile):
     """weave - versioned text file storage.
     
@@ -214,16 +183,9 @@
     """
 
     __slots__ = ['_weave', '_parents', '_sha1s', '_names', '_name_map',
-                 '_weave_name', '_matcher', '_allow_reserved']
+                 '_weave_name', '_matcher']
     
-    def __init__(self, weave_name=None, access_mode='w', matcher=None,
-                 get_scope=None, allow_reserved=False):
-        """Create a weave.
-
-        :param get_scope: A callable that returns an opaque object to be used
-            for detecting when this weave goes out of scope (should stop
-            answering requests or allowing mutation).
-        """
+    def __init__(self, weave_name=None, access_mode='w', matcher=None):
         super(Weave, self).__init__(access_mode)
         self._weave = []
         self._parents = []
@@ -235,23 +197,10 @@
             self._matcher = bzrlib.patiencediff.PatienceSequenceMatcher
         else:
             self._matcher = matcher
-        if get_scope is None:
-            get_scope = lambda:None
-        self._get_scope = get_scope
-        self._scope = get_scope()
-        self._access_mode = access_mode
-        self._allow_reserved = allow_reserved
 
     def __repr__(self):
         return "Weave(%r)" % self._weave_name
 
-    def _check_write_ok(self):
-        """Is the versioned file marked as 'finished' ? Raise if it is."""
-        if self._get_scope() != self._scope:
-            raise errors.OutSideTransaction()
-        if self._access_mode != 'w':
-            raise errors.ReadOnlyObjectDirtiedError(self)
-
     def copy(self):
         """Return a deep copy of self.
         
@@ -280,8 +229,7 @@
 
     def _lookup(self, name):
         """Convert symbolic version name to index."""
-        if not self._allow_reserved:
-            self.check_not_reserved_id(name)
+        self.check_not_reserved_id(name)
         try:
             return self._name_map[name]
         except KeyError:
@@ -297,81 +245,9 @@
 
     __contains__ = has_version
 
-    def get_record_stream(self, versions, ordering, include_delta_closure):
-        """Get a stream of records for versions.
-
-        :param versions: The versions to include. Each version is a tuple
-            (version,).
-        :param ordering: Either 'unordered' or 'topological'. A topologically
-            sorted stream has compression parents strictly before their
-            children.
-        :param include_delta_closure: If True then the closure across any
-            compression parents will be included (in the opaque data).
-        :return: An iterator of ContentFactory objects, each of which is only
-            valid until the iterator is advanced.
-        """
-        versions = [version[-1] for version in versions]
-        if ordering == 'topological':
-            parents = self.get_parent_map(versions)
-            new_versions = topo_sort(parents)
-            new_versions.extend(set(versions).difference(set(parents)))
-            versions = new_versions
-        for version in versions:
-            if version in self:
-                yield WeaveContentFactory(version, self)
-            else:
-                yield AbsentContentFactory((version,))
-
-    def get_parent_map(self, version_ids):
-        """See VersionedFile.get_parent_map."""
-        result = {}
-        for version_id in version_ids:
-            if version_id == NULL_REVISION:
-                parents = ()
-            else:
-                try:
-                    parents = tuple(
-                        map(self._idx_to_name,
-                            self._parents[self._lookup(version_id)]))
-                except RevisionNotPresent:
-                    continue
-            result[version_id] = parents
-        return result
-
-    def get_parents_with_ghosts(self, version_id):
-        raise NotImplementedError(self.get_parents_with_ghosts)
-
-    def insert_record_stream(self, stream):
-        """Insert a record stream into this versioned file.
-
-        :param stream: A stream of records to insert. 
-        :return: None
-        :seealso VersionedFile.get_record_stream:
-        """
-        adapters = {}
-        for record in stream:
-            # Raise an error when a record is missing.
-            if record.storage_kind == 'absent':
-                raise RevisionNotPresent([record.key[0]], self)
-            # adapt to non-tuple interface
-            parents = [parent[0] for parent in record.parents]
-            if record.storage_kind == 'fulltext':
-                self.add_lines(record.key[0], parents,
-                    split_lines(record.get_bytes_as('fulltext')))
-            else:
-                adapter_key = record.storage_kind, 'fulltext'
-                try:
-                    adapter = adapters[adapter_key]
-                except KeyError:
-                    adapter_factory = adapter_registry.get(adapter_key)
-                    adapter = adapter_factory(self)
-                    adapters[adapter_key] = adapter
-                lines = split_lines(adapter.get_bytes(
-                    record, record.get_bytes_as(record.storage_kind)))
-                try:
-                    self.add_lines(record.key[0], parents, lines)
-                except RevisionAlreadyPresent:
-                    pass
+    def get_parents(self, version_id):
+        """See VersionedFile.get_parent."""
+        return map(self._idx_to_name, self._parents[self._lookup(version_id)])
 
     def _check_repeated_add(self, name, parents, text, sha1):
         """Check that a duplicated add is OK.
@@ -408,6 +284,7 @@
 
         :param nostore_sha: See VersionedFile.add_lines.
         """
+        assert isinstance(version_id, basestring)
         self._check_lines_not_unicode(lines)
         self._check_lines_are_lines(lines)
         if not sha1:
@@ -488,8 +365,14 @@
             #print 'raw match', tag, i1, i2, j1, j2
             if tag == 'equal':
                 continue
+
             i1 = basis_lineno[i1]
             i2 = basis_lineno[i2]
+
+            assert 0 <= j1 <= j2 <= len(lines)
+
+            #print tag, i1, i2, j1, j2
+
             # the deletion and insertion are handled separately.
             # first delete the region.
             if i1 != i2:
@@ -508,6 +391,11 @@
                 offset += 2 + (j2 - j1)
         return new_version
 
+    def _clone_text(self, new_version_id, old_version_id, parents):
+        """See VersionedFile.clone_text."""
+        old_lines = self.get_text(old_version_id)
+        self.add_lines(new_version_id, parents, old_lines)
+
     def _inclusions(self, versions):
         """Return set of all ancestors of given version(s)."""
         if not len(versions):
@@ -555,13 +443,13 @@
         """
         return len(other_parents.difference(my_parents)) == 0
 
-    def annotate(self, version_id):
-        """Return a list of (version-id, line) tuples for version_id.
+    def annotate_iter(self, version_id):
+        """Yield list of (version-id, line) pairs for the specified version.
 
         The index indicates when the line originated in the weave."""
         incls = [self._lookup(version_id)]
-        return [(self._idx_to_name(origin), text) for origin, lineno, text in
-            self._extract(incls)]
+        for origin, lineno, text in self._extract(incls):
+            yield self._idx_to_name(origin), text
 
     def iter_lines_added_or_present_in_versions(self, version_ids=None,
                                                 pb=None):
@@ -575,9 +463,9 @@
             # properly, we do not filter down to that
             # if inserted not in version_ids: continue
             if line[-1] != '\n':
-                yield line + '\n', inserted
+                yield line + '\n'
             else:
-                yield line, inserted
+                yield line
 
     def _walk_internal(self, version_ids=None):
         """Helper method for weave actions."""
@@ -596,12 +484,15 @@
                 elif c == '}':
                     istack.pop()
                 elif c == '[':
+                    assert self._names[v] not in dset
                     dset.add(self._names[v])
                 elif c == ']':
                     dset.remove(self._names[v])
                 else:
                     raise WeaveFormatError('unexpected instruction %r' % v)
             else:
+                assert l.__class__ in (str, unicode)
+                assert istack
                 yield lineno, istack[-1], frozenset(dset), l
             lineno += 1
 
@@ -656,6 +547,8 @@
                 # not in either revision
                 yield 'irrelevant', line
 
+        yield 'unchanged', ''           # terminator
+
     def _extract(self, versions):
         """Yield annotation of lines in included set.
 
@@ -715,19 +608,22 @@
                 c, v = l
                 isactive = None
                 if c == '{':
+                    assert v not in iset
                     istack.append(v)
                     iset.add(v)
                 elif c == '}':
                     iset.remove(istack.pop())
                 elif c == '[':
                     if v in included:
+                        assert v not in dset
                         dset.add(v)
-                elif c == ']':
+                else:
+                    assert c == ']'
                     if v in included:
+                        assert v in dset
                         dset.remove(v)
-                else:
-                    raise AssertionError()
             else:
+                assert l.__class__ in (str, unicode)
                 if isactive is None:
                     isactive = (not dset) and istack and (istack[-1] in included)
                 if isactive:
@@ -764,16 +660,18 @@
                        expected_sha1, measured_sha1))
         return result
 
+    def get_sha1(self, version_id):
+        """See VersionedFile.get_sha1()."""
+        return self._sha1s[self._lookup(version_id)]
+
     def get_sha1s(self, version_ids):
         """See VersionedFile.get_sha1s()."""
-        result = {}
-        for v in version_ids:
-            result[v] = self._sha1s[self._lookup(v)]
-        return result
+        return [self._sha1s[self._lookup(v)] for v in version_ids]
 
     def num_versions(self):
         """How many versions are in this weave?"""
         l = len(self._parents)
+        assert l == len(self._sha1s)
         return l
 
     __len__ = num_versions
@@ -805,10 +703,8 @@
             for p in self._parents[i]:
                 new_inc.update(inclusions[self._idx_to_name(p)])
 
-            if set(new_inc) != set(self.get_ancestry(name)):
-                raise AssertionError(
-                    'failed %s != %s' 
-                    % (set(new_inc), set(self.get_ancestry(name))))
+            assert set(new_inc) == set(self.get_ancestry(name)), \
+                'failed %s != %s' % (set(new_inc), set(self.get_ancestry(name)))
             inclusions[name] = new_inc
 
         nlines = len(self._weave)
@@ -844,6 +740,57 @@
         # no lines outside of insertion blocks, that deletions are
         # properly paired, etc.
 
+    def _join(self, other, pb, msg, version_ids, ignore_missing):
+        """Worker routine for join()."""
+        if not other.versions():
+            return          # nothing to update, easy
+
+        if not version_ids:
+            # versions is never none, InterWeave checks this.
+            return 0
+
+        # two loops so that we do not change ourselves before verifying it
+        # will be ok
+        # work through in index order to make sure we get all dependencies
+        names_to_join = []
+        processed = 0
+        # get the selected versions only that are in other.versions.
+        version_ids = set(other.versions()).intersection(set(version_ids))
+        # pull in the referenced graph.
+        version_ids = other.get_ancestry(version_ids)
+        pending_graph = [(version, other.get_parents(version)) for
+                         version in version_ids]
+        for name in topo_sort(pending_graph):
+            other_idx = other._name_map[name]
+            # returns True if we have it, False if we need it.
+            if not self._check_version_consistent(other, other_idx, name):
+                names_to_join.append((other_idx, name))
+            processed += 1
+
+
+        if pb and not msg:
+            msg = 'weave join'
+
+        merged = 0
+        time0 = time.time()
+        for other_idx, name in names_to_join:
+            # TODO: If all the parents of the other version are already
+            # present then we can avoid some work by just taking the delta
+            # and adjusting the offsets.
+            new_parents = self._imported_parents(other, other_idx)
+            sha1 = other._sha1s[other_idx]
+
+            merged += 1
+
+            if pb:
+                pb.update(msg, merged, len(names_to_join))
+           
+            lines = other.get_lines(other_idx)
+            self._add(name, lines, new_parents, sha1)
+
+        mutter("merged = %d, processed = %d, file_id=%s; deltat=%d"%(
+                merged, processed, self._weave_name, time.time()-time0))
+ 
     def _imported_parents(self, other, other_idx):
         """Return list of parents in self corresponding to indexes in other."""
         new_parents = []
@@ -906,13 +853,12 @@
 
     WEAVE_SUFFIX = '.weave'
     
-    def __init__(self, name, transport, filemode=None, create=False, access_mode='w', get_scope=None):
+    def __init__(self, name, transport, filemode=None, create=False, access_mode='w'):
         """Create a WeaveFile.
         
         :param create: If not True, only open an existing knit.
         """
-        super(WeaveFile, self).__init__(name, access_mode, get_scope=get_scope,
-            allow_reserved=False)
+        super(WeaveFile, self).__init__(name, access_mode)
         self._transport = transport
         self._filemode = filemode
         try:
@@ -933,6 +879,11 @@
         self._save()
         return result
 
+    def _clone_text(self, new_version_id, old_version_id, parents):
+        """See VersionedFile.clone_text."""
+        super(WeaveFile, self)._clone_text(new_version_id, old_version_id, parents)
+        self._save
+
     def copy_to(self, name, transport):
         """See VersionedFile.copy_to()."""
         # as we are all in memory always, just serialise to the new place.
@@ -941,30 +892,24 @@
         sio.seek(0)
         transport.put_file(name + WeaveFile.WEAVE_SUFFIX, sio, self._filemode)
 
+    def create_empty(self, name, transport, filemode=None):
+        return WeaveFile(name, transport, filemode, create=True)
+
     def _save(self):
         """Save the weave."""
         self._check_write_ok()
         sio = StringIO()
         write_weave_v5(self, sio)
         sio.seek(0)
-        bytes = sio.getvalue()
-        path = self._weave_name + WeaveFile.WEAVE_SUFFIX
-        try:
-            self._transport.put_bytes(path, bytes, self._filemode)
-        except errors.NoSuchFile:
-            self._transport.mkdir(dirname(path))
-            self._transport.put_bytes(path, bytes, self._filemode)
+        self._transport.put_file(self._weave_name + WeaveFile.WEAVE_SUFFIX,
+                                 sio,
+                                 self._filemode)
 
     @staticmethod
     def get_suffixes():
         """See VersionedFile.get_suffixes()."""
         return [WeaveFile.WEAVE_SUFFIX]
 
-    def insert_record_stream(self, stream):
-        super(WeaveFile, self).insert_record_stream(stream)
-        self._save()
-
-    @deprecated_method(one_five)
     def join(self, other, pb=None, msg=None, version_ids=None,
              ignore_missing=False):
         """Join other into self and save."""
@@ -1234,3 +1179,30 @@
 if __name__ == '__main__':
     import sys
     sys.exit(main(sys.argv))
+
+
+class InterWeave(InterVersionedFile):
+    """Optimised code paths for weave to weave operations."""
+    
+    _matching_file_from_factory = staticmethod(WeaveFile)
+    _matching_file_to_factory = staticmethod(WeaveFile)
+    
+    @staticmethod
+    def is_compatible(source, target):
+        """Be compatible with weaves."""
+        try:
+            return (isinstance(source, Weave) and
+                    isinstance(target, Weave))
+        except AttributeError:
+            return False
+
+    def join(self, pb=None, msg=None, version_ids=None, ignore_missing=False):
+        """See InterVersionedFile.join."""
+        version_ids = self._get_source_version_ids(version_ids, ignore_missing)
+        if self.target.versions() == [] and version_ids is None:
+            self.target._copy_weave_content(self.source)
+            return
+        self.target._join(self.source, pb, msg, version_ids, ignore_missing)
+
+
+InterVersionedFile.register_optimiser(InterWeave)

=== modified file 'bzrlib/weave_commands.py'
--- bzrlib/weave_commands.py	2008-06-11 04:20:16 +0000
+++ bzrlib/weave_commands.py	2007-06-17 22:39:37 +0000
@@ -36,12 +36,37 @@
         from bzrlib.weavefile import read_weave
         from bzrlib.transport import get_transport
         from bzrlib import osutils
-        vf = read_weave(file(filename, 'rb'))
+        from bzrlib.knit import KnitVersionedFile
+        if filename.endswith('.knit'):
+            transport = get_transport(osutils.dirname(filename))
+            relpath = osutils.basename(filename)[:-len('.knit')]
+            vf = KnitVersionedFile(relpath, transport)
+        else:
+            vf = read_weave(file(filename, 'rb'))
         names = vf.versions()
         names.sort()
         print '\n'.join(names)
 
 
+class cmd_weave_join(Command):
+    """Join the contents of two weave files.
+
+    The resulting weave is sent to stdout.
+
+    This command is only intended for bzr developer use.
+    """
+
+    hidden = True
+    takes_args = ['weave1', 'weave2']
+
+    def run(self, weave1, weave2):
+        from bzrlib.weavefile import read_weave, write_weave
+        w1 = read_weave(file(weave1, 'rb'))
+        w2 = read_weave(file(weave2, 'rb'))
+        w1.join(w2)
+        write_weave(w1, sys.stdout)
+
+
 class cmd_weave_plan_merge(Command):
     """Show the plan for merging two versions within a weave"""
     hidden = True

=== modified file 'bzrlib/weavefile.py'
--- bzrlib/weavefile.py	2008-04-24 07:22:53 +0000
+++ bzrlib/weavefile.py	2007-10-16 18:26:12 +0000
@@ -72,6 +72,7 @@
 
     for l in weave._weave:
         if isinstance(l, tuple):
+            assert l[0] in '{}[]'
             if l[0] == '}':
                 f.write('}\n')
             else:
@@ -80,8 +81,10 @@
             if not l:
                 f.write(', \n')
             elif l[-1] == '\n':
+                assert l.find('\n', 0, -1) == -1
                 f.write('. ' + l)
             else:
+                assert l.find('\n') == -1
                 f.write(', ' + l + '\n')
 
     f.write('W\n')
@@ -137,13 +140,21 @@
                 w._parents.append(map(int, l[2:].split(' ')))
             else:
                 w._parents.append([])
+
             l = lines.next()[:-1]
+            assert '1 ' == l[0:2]
             w._sha1s.append(l[2:])
+                
             l = lines.next()
+            assert 'n ' == l[0:2]
             name = l[2:-1]
+            assert name not in w._name_map
             w._names.append(name)
             w._name_map[name] = ver
+                
             l = lines.next()
+            assert l == '\n'
+
             ver += 1
         elif l == 'w\n':
             break
@@ -162,5 +173,9 @@
         elif l == '}\n':
             w._weave.append(('}', None))
         else:
+            assert l[0] in '{[]', l
+            assert l[1] == ' ', l
             w._weave.append((intern(l[0]), int(l[2:])))
+
     return w
+    

=== modified file 'bzrlib/win32utils.py'
--- bzrlib/win32utils.py	2008-08-19 19:44:10 +0000
+++ bzrlib/win32utils.py	2007-08-11 05:44:04 +0000
@@ -64,16 +64,6 @@
     else:
         create_buffer = ctypes.create_unicode_buffer
         suffix = 'W'
-try:
-    import win32file
-    has_win32file = True
-except ImportError:
-    has_win32file = False
-try:
-    import win32api
-    has_win32api = True
-except ImportError:
-    has_win32api = False
 
 
 # Special Win32 API constants
@@ -207,58 +197,27 @@
     return os.environ.get('USERNAME', None)
 
 
-# 1 == ComputerNameDnsHostname, which returns "The DNS host name of the local
-# computer or the cluster associated with the local computer."
-_WIN32_ComputerNameDnsHostname = 1
-
 def get_host_name():
     """Return host machine name.
     If name cannot be obtained return None.
 
-    :return: A unicode string representing the host name. On win98, this may be
-        a plain string as win32 api doesn't support unicode.
+    Returned value can be unicode or plain sring.
+    To convert plain string to unicode use
+    s.decode(bzrlib.user_encoding)
     """
-    if has_win32api:
-        try:
-            return win32api.GetComputerNameEx(_WIN32_ComputerNameDnsHostname)
-        except (NotImplementedError, win32api.error):
-            # NotImplemented will happen on win9x...
-            pass
     if has_ctypes:
         try:
             kernel32 = ctypes.windll.kernel32
+            GetComputerName = getattr(kernel32, 'GetComputerName'+suffix)
         except AttributeError:
-            pass # Missing the module we need
+            pass
         else:
             buf = create_buffer(MAX_COMPUTERNAME_LENGTH+1)
             n = ctypes.c_int(MAX_COMPUTERNAME_LENGTH+1)
-
-            # Try GetComputerNameEx which gives a proper Unicode hostname
-            GetComputerNameEx = getattr(kernel32, 'GetComputerNameEx'+suffix,
-                                        None)
-            if (GetComputerNameEx is not None
-                and GetComputerNameEx(_WIN32_ComputerNameDnsHostname,
-                                      buf, ctypes.byref(n))):
-                return buf.value
-
-            # Try GetComputerName in case GetComputerNameEx wasn't found
-            # It returns the NETBIOS name, which isn't as good, but still ok.
-            # The first GetComputerNameEx might have changed 'n', so reset it
-            n = ctypes.c_int(MAX_COMPUTERNAME_LENGTH+1)
-            GetComputerName = getattr(kernel32, 'GetComputerName'+suffix,
-                                      None)
-            if (GetComputerName is not None
-                and GetComputerName(buf, ctypes.byref(n))):
-                return buf.value
-    # otherwise try env variables, which will be 'mbcs' encoded
-    # on Windows (Python doesn't expose the native win32 unicode environment)
-    # According to this:
-    # http://msdn.microsoft.com/en-us/library/aa246807.aspx
-    # environment variables should always be encoded in 'mbcs'.
-    try:
-        return os.environ['COMPUTERNAME'].decode("mbcs")
-    except KeyError:
-        return None
+            if GetComputerName(buf, ctypes.byref(n)):
+                return buf.value
+    # otherwise try env variables
+    return os.environ.get('COMPUTERNAME', None)
 
 
 def _ensure_unicode(s):
@@ -266,7 +225,7 @@
         import bzrlib
         s = s.decode(bzrlib.user_encoding)
     return s
-
+    
 
 def get_appdata_location_unicode():
     return _ensure_unicode(get_appdata_location())
@@ -360,9 +319,3 @@
         _winreg.CloseKey(hkey)
 
     return fullpath
-
-
-def set_file_attr_hidden(path):
-    """Set file attributes to hidden if possible"""
-    if has_win32file:
-        win32file.SetFileAttributes(path, win32file.FILE_ATTRIBUTE_HIDDEN)

=== modified file 'bzrlib/workingtree.py'
--- bzrlib/workingtree.py	2008-09-02 15:28:44 +0000
+++ bzrlib/workingtree.py	2007-10-17 17:03:06 +0000
@@ -64,6 +64,7 @@
     hashcache,
     ignores,
     merge,
+    osutils,
     revision as _mod_revision,
     revisiontree,
     repository,
@@ -89,7 +90,6 @@
 from bzrlib.lockdir import LockDir
 import bzrlib.mutabletree
 from bzrlib.mutabletree import needs_tree_write_lock
-from bzrlib import osutils
 from bzrlib.osutils import (
     compact_date,
     file_kind,
@@ -111,6 +111,9 @@
         deprecated_method,
         deprecated_function,
         DEPRECATED_PARAMETER,
+        zero_eight,
+        zero_eleven,
+        zero_thirteen,
         )
 
 
@@ -120,6 +123,24 @@
 ERROR_PATH_NOT_FOUND = 3    # WindowsError errno code, equivalent to ENOENT
 
 
+@deprecated_function(zero_thirteen)
+def gen_file_id(name):
+    """Return new file id for the basename 'name'.
+
+    Use bzrlib.generate_ids.gen_file_id() instead
+    """
+    return generate_ids.gen_file_id(name)
+
+
+@deprecated_function(zero_thirteen)
+def gen_root_id():
+    """Return a new tree-root file id.
+
+    This has been deprecated in favor of bzrlib.generate_ids.gen_root_id()
+    """
+    return generate_ids.gen_root_id()
+
+
 class TreeEntry(object):
     """An entry that implements the minimum interface used by commands.
 
@@ -201,6 +222,8 @@
         if not _internal:
             raise errors.BzrError("Please use bzrdir.open_workingtree or "
                 "WorkingTree.open() to obtain a WorkingTree.")
+        assert isinstance(basedir, basestring), \
+            "base directory %r is not a string" % basedir
         basedir = safe_unicode(basedir)
         mutter("opening working tree %r", basedir)
         if deprecated_passed(branch):
@@ -214,8 +237,10 @@
             self._control_files = self.branch.control_files
         else:
             # assume all other formats have their own control files.
+            assert isinstance(_control_files, LockableFiles), \
+                    "_control_files must be a LockableFiles, not %r" \
+                    % _control_files
             self._control_files = _control_files
-        self._transport = self._control_files._transport
         # update the whole cache up front and write to disk if anything changed;
         # in the future we might want to do this more selectively
         # two possible ways offer themselves : in self._unlock, write the cache
@@ -225,7 +250,7 @@
         wt_trans = self.bzrdir.get_workingtree_transport(None)
         cache_filename = wt_trans.local_abspath('stat-cache')
         self._hashcache = hashcache.HashCache(basedir, cache_filename,
-            self.bzrdir._get_file_mode())
+                                              self._control_files._file_mode)
         hc = self._hashcache
         hc.read()
         # is this scan needed ? it makes things kinda slow.
@@ -245,19 +270,6 @@
             # the Format factory and creation methods that are
             # permitted to do this.
             self._set_inventory(_inventory, dirty=False)
-        self._detect_case_handling()
-        self._rules_searcher = None
-
-    def _detect_case_handling(self):
-        wt_trans = self.bzrdir.get_workingtree_transport(None)
-        try:
-            wt_trans.stat("FoRMaT")
-        except errors.NoSuchFile:
-            self.case_sensitive = True
-        else:
-            self.case_sensitive = False
-
-        self._setup_directory_is_tree_reference()
 
     branch = property(
         fget=lambda self: self._branch,
@@ -294,6 +306,7 @@
             False then the inventory is the same as that on disk and any
             serialisation would be unneeded overhead.
         """
+        assert inv.root is not None
         self._inventory = inv
         self._inventory_is_modified = dirty
 
@@ -334,22 +347,6 @@
         """
         return WorkingTree.open(path, _unsupported=True)
 
-    @staticmethod
-    def find_trees(location):
-        def list_current(transport):
-            return [d for d in transport.list_dir('') if d != '.bzr']
-        def evaluate(bzrdir):
-            try:
-                tree = bzrdir.open_workingtree()
-            except errors.NoWorkingTree:
-                return True, None
-            else:
-                return True, tree
-        transport = get_transport(location)
-        iterator = bzrdir.BzrDir.find_bzrdirs(transport, evaluate=evaluate,
-                                              list_current=list_current)
-        return [t for t in iterator if t is not None]
-
     # should be deprecated - this is slow and in any case treating them as a
     # container is (we now know) bad style -- mbp 20070302
     ## @deprecated_method(zero_fifteen)
@@ -364,10 +361,6 @@
             if osutils.lexists(self.abspath(path)):
                 yield ie.file_id
 
-    def all_file_ids(self):
-        """See Tree.iter_all_file_ids"""
-        return set(self.inventory)
-
     def __repr__(self):
         return "<%s of %s>" % (self.__class__.__name__,
                                getattr(self, 'basedir', None))
@@ -397,7 +390,7 @@
         # at this point ?
         try:
             return self.branch.repository.revision_tree(revision_id)
-        except (errors.RevisionNotPresent, errors.NoSuchRevision):
+        except errors.RevisionNotPresent:
             # the basis tree *may* be a ghost or a low level error may have
             # occured. If the revision is present, its a problem, if its not
             # its a ghost.
@@ -409,6 +402,44 @@
     def _cleanup(self):
         self._flush_ignore_list_cache()
 
+    @staticmethod
+    @deprecated_method(zero_eight)
+    def create(branch, directory):
+        """Create a workingtree for branch at directory.
+
+        If existing_directory already exists it must have a .bzr directory.
+        If it does not exist, it will be created.
+
+        This returns a new WorkingTree object for the new checkout.
+
+        TODO FIXME RBC 20060124 when we have checkout formats in place this
+        should accept an optional revisionid to checkout [and reject this if
+        checking out into the same dir as a pre-checkout-aware branch format.]
+
+        XXX: When BzrDir is present, these should be created through that 
+        interface instead.
+        """
+        warnings.warn('delete WorkingTree.create', stacklevel=3)
+        transport = get_transport(directory)
+        if branch.bzrdir.root_transport.base == transport.base:
+            # same dir 
+            return branch.bzrdir.create_workingtree()
+        # different directory, 
+        # create a branch reference
+        # and now a working tree.
+        raise NotImplementedError
+ 
+    @staticmethod
+    @deprecated_method(zero_eight)
+    def create_standalone(directory):
+        """Create a checkout and a branch and a repo at directory.
+
+        Directory must exist and be empty.
+
+        please use BzrDir.create_standalone_workingtree
+        """
+        return bzrdir.BzrDir.create_standalone_workingtree(directory)
+
     def relpath(self, path):
         """Return the local path portion from a given path.
         
@@ -445,7 +476,7 @@
         basis = self.basis_tree()
         basis.lock_read()
         try:
-            changes = self.iter_changes(basis, True, [self.id2path(file_id)],
+            changes = self._iter_changes(basis, True, [self.id2path(file_id)],
                 require_versioned=True).next()
             changed_content, kind = changes[2], changes[6]
             if not changed_content:
@@ -487,7 +518,7 @@
         else:
             parents = [last_rev]
         try:
-            merges_file = self._transport.get('pending-merges')
+            merges_file = self._control_files.get('pending-merges')
         except errors.NoSuchFile:
             pass
         else:
@@ -520,7 +551,7 @@
             and this one merged in.
         """
         # assumes the target bzr dir format is compatible.
-        result = to_bzrdir.create_workingtree()
+        result = self._format.initialize(to_bzrdir)
         self.copy_content_into(result, revision_id)
         return result
 
@@ -555,14 +586,7 @@
     __contains__ = has_id
 
     def get_file_size(self, file_id):
-        """See Tree.get_file_size"""
-        try:
-            return os.path.getsize(self.id2abspath(file_id))
-        except OSError, e:
-            if e.errno != errno.ENOENT:
-                raise
-            else:
-                return None
+        return os.path.getsize(self.id2abspath(file_id))
 
     @needs_read_lock
     def get_file_sha1(self, file_id, path=None, stat_value=None):
@@ -608,6 +632,7 @@
         # function - they should be part of lock_write and unlock.
         inv = self.inventory
         for f, file_id, kind in zip(files, ids, kinds):
+            assert kind is not None
             if file_id is None:
                 inv.add_path(f, kind=kind)
             else:
@@ -678,7 +703,7 @@
         if updated:
             self.set_parent_ids(parents, allow_leftmost_as_ghost=True)
 
-    def path_content_summary(self, path, _lstat=os.lstat,
+    def path_content_summary(self, path, _lstat=osutils.lstat,
         _mapper=osutils.file_kind_from_stat_mode):
         """See Tree.path_content_summary."""
         abspath = self.abspath(path)
@@ -708,6 +733,19 @@
         else:
             return (kind, None, None, None)
 
+    @deprecated_method(zero_eleven)
+    @needs_read_lock
+    def pending_merges(self):
+        """Return a list of pending merges.
+
+        These are revisions that have been merged into the working
+        directory but not yet committed.
+
+        As of 0.11 this is deprecated. Please see WorkingTree.get_parent_ids()
+        instead - which is available on all tree objects.
+        """
+        return self.get_parent_ids()[1:]
+
     def _check_parents_for_ghosts(self, revision_ids, allow_leftmost_as_ghost):
         """Common ghost checking functionality from set_parent_*.
 
@@ -722,27 +760,7 @@
 
     def _set_merges_from_parent_ids(self, parent_ids):
         merges = parent_ids[1:]
-        self._transport.put_bytes('pending-merges', '\n'.join(merges),
-            mode=self._control_files._file_mode)
-
-    def _filter_parent_ids_by_ancestry(self, revision_ids):
-        """Check that all merged revisions are proper 'heads'.
-
-        This will always return the first revision_id, and any merged revisions
-        which are 
-        """
-        if len(revision_ids) == 0:
-            return revision_ids
-        graph = self.branch.repository.get_graph()
-        heads = graph.heads(revision_ids)
-        new_revision_ids = revision_ids[:1]
-        for revision_id in revision_ids[1:]:
-            if revision_id in heads and revision_id not in new_revision_ids:
-                new_revision_ids.append(revision_id)
-        if new_revision_ids != revision_ids:
-            trace.mutter('requested to set revision_ids = %s,'
-                         ' but filtered to %s', revision_ids, new_revision_ids)
-        return new_revision_ids
+        self._control_files.put_bytes('pending-merges', '\n'.join(merges))
 
     @needs_tree_write_lock
     def set_parent_ids(self, revision_ids, allow_leftmost_as_ghost=False):
@@ -762,8 +780,6 @@
         for revision_id in revision_ids:
             _mod_revision.check_not_reserved_id(revision_id)
 
-        revision_ids = self._filter_parent_ids_by_ancestry(revision_ids)
-
         if len(revision_ids) > 0:
             self.set_last_revision(revision_ids[0])
         else:
@@ -781,8 +797,6 @@
         self._check_parents_for_ghosts(parent_ids,
             allow_leftmost_as_ghost=allow_leftmost_as_ghost)
 
-        parent_ids = self._filter_parent_ids_by_ancestry(parent_ids)
-
         if len(parent_ids) == 0:
             leftmost_parent_id = _mod_revision.NULL_REVISION
             leftmost_parent_tree = None
@@ -828,8 +842,7 @@
     def _put_rio(self, filename, stanzas, header):
         self._must_be_locked()
         my_file = rio_file(stanzas, header)
-        self._transport.put_file(filename, my_file,
-            mode=self._control_files._file_mode)
+        self._control_files.put(filename, my_file)
 
     @needs_write_lock # because merge pulls data into the branch.
     def merge_from_branch(self, branch, to_revision=None, from_revision=None,
@@ -894,7 +907,7 @@
         still in the working inventory and have that text hash.
         """
         try:
-            hashfile = self._transport.get('merge-hashes')
+            hashfile = self._control_files.get('merge-hashes')
         except errors.NoSuchFile:
             return {}
         merge_hashes = {}
@@ -967,18 +980,7 @@
             other_tree.unlock()
         other_tree.bzrdir.retire_bzrdir()
 
-    def _setup_directory_is_tree_reference(self):
-        if self._branch.repository._format.supports_tree_reference:
-            self._directory_is_tree_reference = \
-                self._directory_may_be_tree_reference
-        else:
-            self._directory_is_tree_reference = \
-                self._directory_is_never_tree_reference
-
-    def _directory_is_never_tree_reference(self, relpath):
-        return False
-
-    def _directory_may_be_tree_reference(self, relpath):
+    def _directory_is_tree_reference(self, relpath):
         # as a special case, if a directory contains control files then 
         # it's a tree reference, except that the root of the tree is not
         return relpath and osutils.isdir(self.abspath(relpath) + u"/.bzr")
@@ -1011,15 +1013,17 @@
         sub_path = self.id2path(file_id)
         branch_transport = mkdirs(sub_path)
         if format is None:
-            format = self.bzrdir.cloning_metadir()
+            format = bzrdir.format_registry.make_bzrdir('dirstate-with-subtree')
         branch_transport.ensure_base()
         branch_bzrdir = format.initialize_on_transport(branch_transport)
         try:
             repo = branch_bzrdir.find_repository()
         except errors.NoRepositoryPresent:
             repo = branch_bzrdir.create_repository()
-        if not repo.supports_rich_root():
-            raise errors.RootNotRich()
+            assert repo.supports_rich_root()
+        else:
+            if not repo.supports_rich_root():
+                raise errors.RootNotRich()
         new_branch = branch_bzrdir.create_branch()
         new_branch.pull(self.branch)
         for parent_id in self.get_parent_ids():
@@ -1057,8 +1061,7 @@
         sio = StringIO()
         self._serialize(self._inventory, sio)
         sio.seek(0)
-        self._transport.put_file('inventory', sio,
-            mode=self._control_files._file_mode)
+        self._control_files.put('inventory', sio)
         self._inventory_is_modified = False
 
     def _kind(self, relpath):
@@ -1225,8 +1228,7 @@
                                        DeprecationWarning)
 
         # check destination directory
-        if isinstance(from_paths, basestring):
-            raise ValueError()
+        assert not isinstance(from_paths, basestring)
         inv = self.inventory
         to_abs = self.abspath(to_dir)
         if not isdir(to_abs):
@@ -1316,10 +1318,6 @@
                 only_change_inv = True
             elif self.has_filename(from_rel) and not self.has_filename(to_rel):
                 only_change_inv = False
-            elif (not self.case_sensitive
-                  and from_rel.lower() == to_rel.lower()
-                  and self.has_filename(from_rel)):
-                only_change_inv = False
             else:
                 # something is wrong, so lets determine what exactly
                 if not self.has_filename(from_rel) and \
@@ -1328,7 +1326,8 @@
                         errors.PathsDoNotExist(paths=(str(from_rel),
                         str(to_rel))))
                 else:
-                    raise errors.RenameFailedFilesExist(from_rel, to_rel)
+                    raise errors.RenameFailedFilesExist(from_rel, to_rel,
+                        extra="(Use --after to update the Bazaar id)")
             rename_entry.only_change_inv = only_change_inv
         return rename_entries
 
@@ -1496,6 +1495,12 @@
             # - RBC 20060907
             self._write_inventory(self._inventory)
     
+    @deprecated_method(zero_eight)
+    def iter_conflicts(self):
+        """List all files in the tree that have text or content conflicts.
+        DEPRECATED.  Use conflicts instead."""
+        return self._iter_conflicts()
+
     def _iter_conflicts(self):
         conflicted = set()
         for info in self.list_files():
@@ -1536,7 +1541,7 @@
                                 change_reporter=change_reporter)
                     if (basis_tree.inventory.root is None and
                         new_basis_tree.inventory.root is not None):
-                        self.set_root_id(new_basis_tree.get_root_id())
+                        self.set_root_id(new_basis_tree.inventory.root.file_id)
                 finally:
                     pb.finished()
                     basis_tree.unlock()
@@ -1592,14 +1597,7 @@
                 if subf == '.bzr':
                     continue
                 if subf not in dir_entry.children:
-                    try:
-                        (subf_norm,
-                         can_access) = osutils.normalized_filename(subf)
-                    except UnicodeDecodeError:
-                        path_os_enc = path.encode(osutils._fs_enc)
-                        relpath = path_os_enc + '/' + subf
-                        raise errors.BadFilenameEncoding(relpath,
-                                                         osutils._fs_enc)
+                    subf_norm, can_access = osutils.normalized_filename(subf)
                     if subf_norm != subf and can_access:
                         if subf_norm not in dir_entry.children:
                             fl.append(subf_norm)
@@ -1660,10 +1658,6 @@
     def kind(self, file_id):
         return file_kind(self.id2abspath(file_id))
 
-    def stored_kind(self, file_id):
-        """See Tree.stored_kind"""
-        return self.inventory[file_id].kind
-
     def _comparison_data(self, entry, path):
         abspath = self.abspath(path)
         try:
@@ -1751,7 +1745,7 @@
     def _reset_data(self):
         """Reset transient data that cannot be revalidated."""
         self._inventory_is_modified = False
-        result = self._deserialize(self._transport.get('inventory'))
+        result = self._deserialize(self._control_files.get('inventory'))
         self._set_inventory(result, dirty=False)
 
     @needs_tree_write_lock
@@ -1778,10 +1772,10 @@
 
     def _write_basis_inventory(self, xml):
         """Write the basis inventory XML to the basis-inventory file"""
+        assert isinstance(xml, str), 'serialised xml must be bytestring.'
         path = self._basis_inventory_name()
         sio = StringIO(xml)
-        self._transport.put_file(path, sio,
-            mode=self._control_files._file_mode)
+        self._control_files.put(path, sio)
 
     def _create_basis_xml_from_inventory(self, revision_id, inventory):
         """Create the text that will be saved in basis-inventory"""
@@ -1818,7 +1812,7 @@
     def read_basis_inventory(self):
         """Read the cached basis inventory."""
         path = self._basis_inventory_name()
-        return self._transport.get_bytes(path)
+        return self._control_files.get(path).read()
         
     @needs_read_lock
     def read_working_inventory(self):
@@ -1833,7 +1827,7 @@
         # binary.
         if self._inventory_is_modified:
             raise errors.InventoryModified(self)
-        result = self._deserialize(self._transport.get('inventory'))
+        result = self._deserialize(self._control_files.get('inventory'))
         self._set_inventory(result, dirty=False)
         return result
 
@@ -1859,8 +1853,9 @@
             # Recurse directory and add all files
             # so we can check if they have changed.
             for parent_info, file_infos in\
-                self.walkdirs(directory):
-                for relpath, basename, kind, lstat, fileid, kind in file_infos:
+                osutils.walkdirs(self.abspath(directory),
+                    directory):
+                for relpath, basename, kind, lstat, abspath in file_infos:
                     # Is it versioned or ignored?
                     if self.path2id(relpath) or self.is_ignored(relpath):
                         # Add nested content for deletion.
@@ -1876,7 +1871,8 @@
             filename = self.relpath(abspath)
             if len(filename) > 0:
                 new_files.add(filename)
-                recurse_directory_to_add_files(filename)
+                if osutils.isdir(abspath):
+                    recurse_directory_to_add_files(filename)
 
         files = list(new_files)
 
@@ -1891,17 +1887,14 @@
             has_changed_files = len(unknown_nested_files) > 0
             if not has_changed_files:
                 for (file_id, path, content_change, versioned, parent_id, name,
-                     kind, executable) in self.iter_changes(self.basis_tree(),
+                     kind, executable) in self._iter_changes(self.basis_tree(),
                          include_unchanged=True, require_versioned=False,
                          want_unversioned=True, specific_files=files):
-                    if versioned == (False, False):
-                        # The record is unknown ...
-                        if not self.is_ignored(path[1]):
-                            # ... but not ignored
-                            has_changed_files = True
-                            break
-                    elif content_change and (kind[1] is not None):
-                        # Versioned and changed, but not deleted
+                    # Check if it's an unknown (but not ignored) OR
+                    # changed (but not deleted) :
+                    if not self.is_ignored(path[1]) and (
+                        versioned == (False, False) or
+                        content_change and kind[1] != None):
                         has_changed_files = True
                         break
 
@@ -1967,29 +1960,14 @@
                 ' as of bzr 0.91.  Please use None (the default) instead.',
                 DeprecationWarning, stacklevel=2)
         if old_tree is None:
-            basis_tree = self.basis_tree()
-            basis_tree.lock_read()
-            old_tree = basis_tree
+            old_tree = self.basis_tree()
+        conflicts = transform.revert(self, old_tree, filenames, backups, pb,
+                                     report_changes)
+        if filenames is None:
+            self.set_parent_ids(self.get_parent_ids()[:1])
+            resolve(self)
         else:
-            basis_tree = None
-        try:
-            conflicts = transform.revert(self, old_tree, filenames, backups, pb,
-                                         report_changes)
-            if filenames is None and len(self.get_parent_ids()) > 1:
-                parent_trees = []
-                last_revision = self.last_revision()
-                if last_revision != NULL_REVISION:
-                    if basis_tree is None:
-                        basis_tree = self.basis_tree()
-                        basis_tree.lock_read()
-                    parent_trees.append((last_revision, basis_tree))
-                self.set_parent_trees(parent_trees)
-                resolve(self)
-            else:
-                resolve(self, filenames, ignore_misses=True, recursive=True)
-        finally:
-            if basis_tree is not None:
-                basis_tree.unlock()
+            resolve(self, filenames, ignore_misses=True)
         return conflicts
 
     def revision_tree(self, revision_id):
@@ -2046,9 +2024,13 @@
         """Set the root id for this tree."""
         # for compatability 
         if file_id is None:
-            raise ValueError(
-                'WorkingTree.set_root_id with fileid=None')
-        file_id = osutils.safe_file_id(file_id)
+            symbol_versioning.warn(symbol_versioning.zero_twelve
+                % 'WorkingTree.set_root_id with fileid=None',
+                DeprecationWarning,
+                stacklevel=3)
+            file_id = ROOT_ID
+        else:
+            file_id = osutils.safe_file_id(file_id)
         self._set_root_id(file_id)
 
     def _set_root_id(self, file_id):
@@ -2113,7 +2095,7 @@
           basis.
         - Do a 'normal' merge of the old branch basis if it is relevant.
         """
-        if self.branch.get_bound_location() is not None:
+        if self.branch.get_master_branch(possible_transports) is not None:
             self.lock_write()
             update_branch = True
         else:
@@ -2157,7 +2139,7 @@
             try:
                 to_tree = self.branch.basis_tree()
                 if basis.inventory.root is None:
-                    self.set_root_id(to_tree.get_root_id())
+                    self.set_root_id(to_tree.inventory.root.file_id)
                     self.flush()
                 result += merge.merge_inner(
                                       self.branch,
@@ -2305,24 +2287,16 @@
             current_inv = None
             inv_finished = True
         while not inv_finished or not disk_finished:
-            if current_disk:
-                ((cur_disk_dir_relpath, cur_disk_dir_path_from_top),
-                    cur_disk_dir_content) = current_disk
-            else:
-                ((cur_disk_dir_relpath, cur_disk_dir_path_from_top),
-                    cur_disk_dir_content) = ((None, None), None)
             if not disk_finished:
                 # strip out .bzr dirs
-                if (cur_disk_dir_path_from_top[top_strip_len:] == '' and
-                    len(cur_disk_dir_content) > 0):
-                    # osutils.walkdirs can be made nicer -
+                if current_disk[0][1][top_strip_len:] == '':
+                    # osutils.walkdirs can be made nicer - 
                     # yield the path-from-prefix rather than the pathjoined
                     # value.
-                    bzrdir_loc = bisect_left(cur_disk_dir_content,
-                        ('.bzr', '.bzr'))
-                    if cur_disk_dir_content[bzrdir_loc][0] == '.bzr':
+                    bzrdir_loc = bisect_left(current_disk[1], ('.bzr', '.bzr'))
+                    if current_disk[1][bzrdir_loc][0] == '.bzr':
                         # we dont yield the contents of, or, .bzr itself.
-                        del cur_disk_dir_content[bzrdir_loc]
+                        del current_disk[1][bzrdir_loc]
             if inv_finished:
                 # everything is unknown
                 direction = 1
@@ -2330,13 +2304,12 @@
                 # everything is missing
                 direction = -1
             else:
-                direction = cmp(current_inv[0][0], cur_disk_dir_relpath)
+                direction = cmp(current_inv[0][0], current_disk[0][0])
             if direction > 0:
                 # disk is before inventory - unknown
                 dirblock = [(relpath, basename, kind, stat, None, None) for
-                    relpath, basename, kind, stat, top_path in
-                    cur_disk_dir_content]
-                yield (cur_disk_dir_relpath, None), dirblock
+                    relpath, basename, kind, stat, top_path in current_disk[1]]
+                yield (current_disk[0][0], None), dirblock
                 try:
                     current_disk = disk_iterator.next()
                 except StopIteration:
@@ -2344,7 +2317,7 @@
             elif direction < 0:
                 # inventory is before disk - missing.
                 dirblock = [(relpath, basename, 'unknown', None, fileid, kind)
-                    for relpath, basename, dkind, stat, fileid, kind in
+                    for relpath, basename, dkind, stat, fileid, kind in 
                     current_inv[1]]
                 yield (current_inv[0][0], current_inv[0][1]), dirblock
                 try:
@@ -2356,8 +2329,7 @@
                 # merge the inventory and disk data together
                 dirblock = []
                 for relpath, subiterator in itertools.groupby(sorted(
-                    current_inv[1] + cur_disk_dir_content,
-                    key=operator.itemgetter(0)), operator.itemgetter(1)):
+                    current_inv[1] + current_disk[1], key=operator.itemgetter(0)), operator.itemgetter(1)):
                     path_elements = list(subiterator)
                     if len(path_elements) == 2:
                         inv_row, disk_row = path_elements
@@ -2416,11 +2388,10 @@
                 relroot = ""
             # FIXME: stash the node in pending
             entry = inv[top_id]
-            if entry.kind == 'directory':
-                for name, child in entry.sorted_children():
-                    dirblock.append((relroot + name, name, child.kind, None,
-                        child.file_id, child.kind
-                        ))
+            for name, child in entry.sorted_children():
+                dirblock.append((relroot + name, name, child.kind, None,
+                    child.file_id, child.kind
+                    ))
             yield (currentdir[0], entry.file_id), dirblock
             # push the user specified dirs from dirblock
             for dir in reversed(dirblock):
@@ -2459,20 +2430,6 @@
         self.set_conflicts(un_resolved)
         return un_resolved, resolved
 
-    @needs_read_lock
-    def _check(self):
-        tree_basis = self.basis_tree()
-        tree_basis.lock_read()
-        try:
-            repo_basis = self.branch.repository.revision_tree(
-                self.last_revision())
-            if len(list(repo_basis.iter_changes(tree_basis))) > 0:
-                raise errors.BzrCheckError(
-                    "Mismatched basis inventory content.")
-            self._validate()
-        finally:
-            tree_basis.unlock()
-
     def _validate(self):
         """Validate internal structures.
 
@@ -2484,14 +2441,6 @@
         """
         return
 
-    @needs_read_lock
-    def _get_rules_searcher(self, default_searcher):
-        """See Tree._get_rules_searcher."""
-        if self._rules_searcher is None:
-            self._rules_searcher = super(WorkingTree,
-                self)._get_rules_searcher(default_searcher)
-        return self._rules_searcher
-
 
 class WorkingTree2(WorkingTree):
     """This is the Format 2 working tree.
@@ -2557,7 +2506,7 @@
     def _last_revision(self):
         """See Mutable.last_revision."""
         try:
-            return self._transport.get_bytes('last-revision')
+            return self._control_files.get('last-revision').read()
         except errors.NoSuchFile:
             return _mod_revision.NULL_REVISION
 
@@ -2565,13 +2514,12 @@
         """See WorkingTree._change_last_revision."""
         if revision_id is None or revision_id == NULL_REVISION:
             try:
-                self._transport.delete('last-revision')
+                self._control_files._transport.delete('last-revision')
             except errors.NoSuchFile:
                 pass
             return False
         else:
-            self._transport.put_bytes('last-revision', revision_id,
-                mode=self._control_files._file_mode)
+            self._control_files.put_bytes('last-revision', revision_id)
             return True
 
     @needs_tree_write_lock
@@ -2589,7 +2537,7 @@
     @needs_read_lock
     def conflicts(self):
         try:
-            confile = self._transport.get('conflicts')
+            confile = self._control_files.get('conflicts')
         except errors.NoSuchFile:
             return _mod_conflicts.ConflictList()
         try:
@@ -2620,6 +2568,22 @@
             return path[:-len(suffix)]
 
 
+@deprecated_function(zero_eight)
+def is_control_file(filename):
+    """See WorkingTree.is_control_filename(filename)."""
+    ## FIXME: better check
+    filename = normpath(filename)
+    while filename != '':
+        head, tail = os.path.split(filename)
+        ## mutter('check %r for control file' % ((head, tail),))
+        if tail == '.bzr':
+            return True
+        if filename == head:
+            break
+        filename = head
+    return False
+
+
 class WorkingTreeFormat(object):
     """An encapsulation of the initialization and open routines for a format.
 
@@ -2658,8 +2622,7 @@
         except errors.NoSuchFile:
             raise errors.NoWorkingTree(base=transport.base)
         except KeyError:
-            raise errors.UnknownFormatError(format=format_string,
-                                            kind="working tree")
+            raise errors.UnknownFormatError(format=format_string)
 
     def __eq__(self, other):
         return self.__class__ is other.__class__
@@ -2699,6 +2662,7 @@
 
     @classmethod
     def unregister_format(klass, format):
+        assert klass._formats[format.get_format_string()] is format
         del klass._formats[format.get_format_string()]
 
 
@@ -2714,29 +2678,27 @@
         """See WorkingTreeFormat.get_format_description()."""
         return "Working tree format 2"
 
-    def _stub_initialize_on_transport(self, transport, file_mode):
-        """Workaround: create control files for a remote working tree.
-
+    def stub_initialize_remote(self, control_files):
+        """As a special workaround create critical control files for a remote working tree
+        
         This ensures that it can later be updated and dealt with locally,
-        since BzrDirFormat6 and BzrDirFormat5 cannot represent dirs with
+        since BzrDirFormat6 and BzrDirFormat5 cannot represent dirs with 
         no working tree.  (See bug #43064).
         """
         sio = StringIO()
         inv = Inventory()
         xml5.serializer_v5.write_inventory(inv, sio, working=True)
         sio.seek(0)
-        transport.put_file('inventory', sio, file_mode)
-        transport.put_bytes('pending-merges', '', file_mode)
-
-    def initialize(self, a_bzrdir, revision_id=None, from_branch=None,
-                   accelerator_tree=None, hardlink=False):
+        control_files.put('inventory', sio)
+
+        control_files.put_bytes('pending-merges', '')
+        
+
+    def initialize(self, a_bzrdir, revision_id=None):
         """See WorkingTreeFormat.initialize()."""
         if not isinstance(a_bzrdir.transport, LocalTransport):
             raise errors.NotLocalUrl(a_bzrdir.transport.base)
-        if from_branch is not None:
-            branch = from_branch
-        else:
-            branch = a_bzrdir.open_branch()
+        branch = a_bzrdir.open_branch()
         if revision_id is None:
             revision_id = _mod_revision.ensure_null(branch.last_revision())
         branch.lock_write()
@@ -2753,7 +2715,7 @@
                          _bzrdir=a_bzrdir)
         basis_tree = branch.repository.revision_tree(revision_id)
         if basis_tree.inventory.root is not None:
-            wt.set_root_id(basis_tree.get_root_id())
+            wt.set_root_id(basis_tree.inventory.root.file_id)
         # set the parent list and cache the basis tree.
         if _mod_revision.is_null(revision_id):
             parent_trees = []
@@ -2821,18 +2783,11 @@
         return LockableFiles(transport, self._lock_file_name, 
                              self._lock_class)
 
-    def initialize(self, a_bzrdir, revision_id=None, from_branch=None,
-                   accelerator_tree=None, hardlink=False):
+    def initialize(self, a_bzrdir, revision_id=None):
         """See WorkingTreeFormat.initialize().
         
-        :param revision_id: if supplied, create a working tree at a different
-            revision than the branch is at.
-        :param accelerator_tree: A tree which can be used for retrieving file
-            contents more quickly than the revision tree, i.e. a workingtree.
-            The revision tree will be used for cases where accelerator_tree's
-            content is different.
-        :param hardlink: If true, hard-link files from accelerator_tree,
-            where possible.
+        revision_id allows creating a working tree at a different
+        revision than the branch is at.
         """
         if not isinstance(a_bzrdir.transport, LocalTransport):
             raise errors.NotLocalUrl(a_bzrdir.transport.base)
@@ -2840,12 +2795,8 @@
         control_files = self._open_control_files(a_bzrdir)
         control_files.create_lock()
         control_files.lock_write()
-        transport.put_bytes('format', self.get_format_string(),
-            mode=control_files._file_mode)
-        if from_branch is not None:
-            branch = from_branch
-        else:
-            branch = a_bzrdir.open_branch()
+        control_files.put_utf8('format', self.get_format_string())
+        branch = a_bzrdir.open_branch()
         if revision_id is None:
             revision_id = _mod_revision.ensure_null(branch.last_revision())
         # WorkingTree3 can handle an inventory which has a unique root id.
@@ -2866,7 +2817,7 @@
             basis_tree = branch.repository.revision_tree(revision_id)
             # only set an explicit root id if there is one to set.
             if basis_tree.inventory.root is not None:
-                wt.set_root_id(basis_tree.get_root_id())
+                wt.set_root_id(basis_tree.inventory.root.file_id)
             if revision_id == NULL_REVISION:
                 wt.set_parent_trees([])
             else:

=== modified file 'bzrlib/workingtree_4.py'
--- bzrlib/workingtree_4.py	2008-08-13 03:21:19 +0000
+++ bzrlib/workingtree_4.py	2007-10-17 17:03:06 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2008 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -131,14 +131,19 @@
         """
         self._format = _format
         self.bzrdir = _bzrdir
+        assert isinstance(basedir, basestring), \
+            "base directory %r is not a string" % basedir
         basedir = safe_unicode(basedir)
         mutter("opening working tree %r", basedir)
         self._branch = branch
+        assert isinstance(self.branch, bzrlib.branch.Branch), \
+            "branch %r is not a Branch" % self.branch
         self.basedir = realpath(basedir)
         # if branch is at our basedir and is a format 6 or less
         # assume all other formats have their own control files.
+        assert isinstance(_control_files, LockableFiles), \
+            "_control_files must be a LockableFiles, not %r" % _control_files
         self._control_files = _control_files
-        self._transport = self._control_files._transport
         self._dirty = None
         #-------------
         # during a read or write lock these objects are set, and are
@@ -146,9 +151,6 @@
         self._dirstate = None
         self._inventory = None
         #-------------
-        self._setup_directory_is_tree_reference()
-        self._detect_case_handling()
-        self._rules_searcher = None
 
     @needs_tree_write_lock
     def _add(self, files, ids, kinds):
@@ -313,8 +315,7 @@
         state._read_dirblocks_if_needed()
         root_key, current_entry = self._get_entry(path='')
         current_id = root_key[2]
-        if not (current_entry[0][0] == 'd'): # directory
-            raise AssertionError(current_entry)
+        assert current_entry[0][0] == 'd' # directory
         inv = Inventory(root_id=current_id)
         # Turn some things into local variables
         minikind_to_kind = dirstate.DirState._minikind_to_kind
@@ -353,22 +354,18 @@
                     # add this entry to the parent map.
                     parent_ies[(dirname + '/' + name).strip('/')] = inv_entry
                 elif kind == 'tree-reference':
-                    if not self._repo_supports_tree_reference:
-                        raise AssertionError(
-                            "repository of %r "
-                            "doesn't support tree references "
-                            "required by entry %r"
-                            % (self, name))
+                    assert self._repo_supports_tree_reference, \
+                        "repository of %r " \
+                        "doesn't support tree references " \
+                        "required by entry %r" \
+                        % (self, name)
                     inv_entry.reference_revision = link_or_sha1 or None
                 elif kind != 'symlink':
                     raise AssertionError("unknown kind %r" % kind)
                 # These checks cost us around 40ms on a 55k entry tree
-                if file_id in inv_byid:
-                    raise AssertionError('file_id %s already in'
-                        ' inventory as %s' % (file_id, inv_byid[file_id]))
-                if name_unicode in parent_ie.children:
-                    raise AssertionError('name %r already in parent'
-                        % (name_unicode,))
+                assert file_id not in inv_byid, ('file_id %s already in'
+                    ' inventory as %s' % (file_id, inv_byid[file_id]))
+                assert name_unicode not in parent_ie.children
                 inv_byid[file_id] = inv_entry
                 parent_ie.children[name_unicode] = inv_entry
         self._inventory = inv
@@ -495,22 +492,11 @@
 
             Note: The caller is expected to take a read-lock before calling this.
             """
-            self._must_be_locked()
             if not path:
                 path = self.id2path(file_id)
             mode = os.lstat(self.abspath(path)).st_mode
             return bool(stat.S_ISREG(mode) and stat.S_IEXEC & mode)
 
-    def all_file_ids(self):
-        """See Tree.iter_all_file_ids"""
-        self._must_be_locked()
-        result = set()
-        for key, tree_details in self.current_dirstate()._iter_entries():
-            if tree_details[0][0] in ('a', 'r'): # relocated
-                continue
-            result.add(key[2])
-        return result
-
     @needs_read_lock
     def __iter__(self):
         """Iterate through file_ids for this tree.
@@ -529,10 +515,6 @@
         return iter(result)
 
     def iter_references(self):
-        if not self._repo_supports_tree_reference:
-            # When the repo doesn't support references, we will have nothing to
-            # return
-            return
         for key, tree_details in self.current_dirstate()._iter_entries():
             if tree_details[0][0] in ('a', 'r'): # absent, relocated
                 # not relevant to the working tree
@@ -540,10 +522,10 @@
             if not key[1]:
                 # the root is not a reference.
                 continue
-            relpath = pathjoin(key[0].decode('utf8'), key[1].decode('utf8'))
+            path = pathjoin(self.basedir, key[0].decode('utf8'), key[1].decode('utf8'))
             try:
-                if self._kind(relpath) == 'tree-reference':
-                    yield relpath, key[2]
+                if self._kind(path) == 'tree-reference':
+                    yield path, key[2]
             except errors.NoSuchFile:
                 # path is missing on disk.
                 continue
@@ -557,9 +539,8 @@
         Note: The caller is expected to take a read-lock before calling this.
         """
         relpath = self.id2path(file_id)
-        if relpath is None:
-            raise AssertionError(
-                "path for id {%s} is None!" % file_id)
+        assert relpath != None, \
+            "path for id {%s} is None!" % file_id
         return self._kind(relpath)
 
     def _kind(self, relpath):
@@ -637,9 +618,10 @@
         result = []
         if not from_paths:
             return result
+
         state = self.current_dirstate()
-        if isinstance(from_paths, basestring):
-            raise ValueError()
+
+        assert not isinstance(from_paths, basestring)
         to_dir_utf8 = to_dir.encode('utf8')
         to_entry_dirname, to_basename = os.path.split(to_dir_utf8)
         id_index = state._get_id_index()
@@ -667,8 +649,8 @@
         if self._inventory is not None:
             update_inventory = True
             inv = self.inventory
+            to_dir_ie = inv[to_dir_id]
             to_dir_id = to_entry[0][2]
-            to_dir_ie = inv[to_dir_id]
         else:
             update_inventory = False
 
@@ -738,7 +720,8 @@
                 if from_missing: # implicitly just update our path mapping
                     move_file = False
                 elif not after:
-                    raise errors.RenameFailedFilesExist(from_rel, to_rel)
+                    raise errors.RenameFailedFilesExist(from_rel, to_rel,
+                        extra="(Use --after to update the Bazaar id)")
 
             rollbacks = []
             def rollback_rename():
@@ -800,8 +783,7 @@
                 if minikind == 'd':
                     def update_dirblock(from_dir, to_key, to_dir_utf8):
                         """Recursively update all entries in this dirblock."""
-                        if from_dir == '':
-                            raise AssertionError("renaming root not supported")
+                        assert from_dir != '', "renaming root not supported"
                         from_key = (from_dir, '')
                         from_block_idx, present = \
                             state._find_block_index_from_key(from_key)
@@ -820,8 +802,7 @@
 
                         # Grab a copy since move_one may update the list.
                         for entry in from_block[1][:]:
-                            if not (entry[0][0] == from_dir):
-                                raise AssertionError()
+                            assert entry[0][0] == from_dir
                             cur_details = entry[1][0]
                             to_key = (to_dir_utf8, entry[0][1], entry[0][2])
                             from_path_utf8 = osutils.pathjoin(entry[0][0], entry[0][1])
@@ -1040,10 +1021,9 @@
         """Change the last revision in the working tree."""
         parents = self.get_parent_ids()
         if new_revision in (NULL_REVISION, None):
-            if len(parents) >= 2:
-                raise AssertionError(
-                    "setting the last parent to none with a pending merge is "
-                    "unsupported.")
+            assert len(parents) < 2, (
+                "setting the last parent to none with a pending merge is "
+                "unsupported.")
             self.set_parent_ids([])
         else:
             self.set_parent_ids([new_revision] + parents[1:],
@@ -1090,21 +1070,9 @@
                 raise errors.GhostRevisionUnusableHere(parents_list[0][0])
         real_trees = []
         ghosts = []
-
-        parent_ids = [rev_id for rev_id, tree in parents_list]
-        graph = self.branch.repository.get_graph()
-        heads = graph.heads(parent_ids)
-        accepted_revisions = set()
-
         # convert absent trees to the null tree, which we convert back to
         # missing on access.
         for rev_id, tree in parents_list:
-            if len(accepted_revisions) > 0:
-                # we always accept the first tree
-                if rev_id in accepted_revisions or rev_id not in heads:
-                    # We have already included either this tree, or its
-                    # descendent, so we skip it.
-                    continue
             _mod_revision.check_not_reserved_id(rev_id)
             if tree is not None:
                 real_trees.append((rev_id, tree))
@@ -1112,7 +1080,6 @@
                 real_trees.append((rev_id,
                     self.branch.repository.revision_tree(None)))
                 ghosts.append(rev_id)
-            accepted_revisions.add(rev_id)
         dirstate.set_parent_trees(real_trees, ghosts=ghosts)
         self._make_dirty(reset_inventory=False)
 
@@ -1131,7 +1098,15 @@
         :param path: The path.
         :param stat_result: The stat result being looked up.
         """
-        return self.current_dirstate().sha1_from_stat(path, stat_result)
+        state = self.current_dirstate()
+        # XXX: should we make the path be passed in as utf8 ?
+        entry = state._get_entry(0, path_utf8=cache_utf8.encode(path))
+        tree_details = entry[1][0]
+        packed_stat = dirstate.pack_stat(stat_result)
+        if tree_details[4] == packed_stat:
+            return tree_details[1]
+        else:
+            return None
 
     @needs_read_lock
     def supports_tree_reference(self):
@@ -1214,8 +1189,7 @@
                     # Mark this file id as having been removed
                     entry = block[1][entry_index]
                     ids_to_unversion.discard(entry[0][2])
-                    if (entry[1][0][0] in 'ar' # don't remove absent or renamed
-                                               # entries
+                    if (entry[1][0][0] == 'a'
                         or not state._make_absent(entry)):
                         entry_index += 1
                 # go to the next block. (At the moment we dont delete empty
@@ -1246,25 +1220,6 @@
             for file_id in file_ids:
                 self._inventory.remove_recursive_id(file_id)
 
-    @needs_tree_write_lock
-    def rename_one(self, from_rel, to_rel, after=False):
-        """See WorkingTree.rename_one"""
-        self.flush()
-        WorkingTree.rename_one(self, from_rel, to_rel, after)
-
-    @needs_tree_write_lock
-    def apply_inventory_delta(self, changes):
-        """See MutableTree.apply_inventory_delta"""
-        state = self.current_dirstate()
-        state.update_by_delta(changes)
-        self._make_dirty(reset_inventory=True)
-
-    def update_basis_by_delta(self, new_revid, delta):
-        """See MutableTree.update_basis_by_delta."""
-        if self.last_revision() == new_revid:
-            raise AssertionError()
-        self.current_dirstate().update_basis_by_delta(delta, new_revid)
-
     @needs_read_lock
     def _validate(self):
         self._dirstate._validate()
@@ -1272,9 +1227,7 @@
     @needs_tree_write_lock
     def _write_inventory(self, inv):
         """Write inventory as the current inventory."""
-        if self._dirty:
-            raise AssertionError("attempting to write an inventory when the "
-                "dirstate is dirty will lose pending changes")
+        assert not self._dirty, "attempting to write an inventory when the dirstate is dirty will cause data loss"
         self.current_dirstate().set_state_from_inventory(inv)
         self._make_dirty(reset_inventory=False)
         if self._inventory is not None:
@@ -1296,8 +1249,6 @@
 
     upgrade_recommended = False
 
-    _tree_class = WorkingTree4
-
     def get_format_string(self):
         """See WorkingTreeFormat.get_format_string()."""
         return "Bazaar Working Tree Format 4 (bzr 0.15)\n"
@@ -1306,18 +1257,11 @@
         """See WorkingTreeFormat.get_format_description()."""
         return "Working tree format 4"
 
-    def initialize(self, a_bzrdir, revision_id=None, from_branch=None,
-                   accelerator_tree=None, hardlink=False):
+    def initialize(self, a_bzrdir, revision_id=None):
         """See WorkingTreeFormat.initialize().
 
         :param revision_id: allows creating a working tree at a different
         revision than the branch is at.
-        :param accelerator_tree: A tree which can be used for retrieving file
-            contents more quickly than the revision tree, i.e. a workingtree.
-            The revision tree will be used for cases where accelerator_tree's
-            content is different.
-        :param hardlink: If true, hard-link files from accelerator_tree,
-            where possible.
 
         These trees get an initial random root id, if their repository supports
         rich root data, TREE_ROOT otherwise.
@@ -1328,12 +1272,8 @@
         control_files = self._open_control_files(a_bzrdir)
         control_files.create_lock()
         control_files.lock_write()
-        transport.put_bytes('format', self.get_format_string(),
-            mode=a_bzrdir._get_file_mode())
-        if from_branch is not None:
-            branch = from_branch
-        else:
-            branch = a_bzrdir.open_branch()
+        control_files.put_utf8('format', self.get_format_string())
+        branch = a_bzrdir.open_branch()
         if revision_id is None:
             revision_id = branch.last_revision()
         local_path = transport.local_abspath('dirstate')
@@ -1341,7 +1281,7 @@
         state = dirstate.DirState.initialize(local_path)
         state.unlock()
         del state
-        wt = self._tree_class(a_bzrdir.root_transport.local_abspath('.'),
+        wt = WorkingTree4(a_bzrdir.root_transport.local_abspath('.'),
                          branch,
                          _format=self,
                          _bzrdir=a_bzrdir,
@@ -1349,66 +1289,36 @@
         wt._new_tree()
         wt.lock_tree_write()
         try:
-            self._init_custom_control_files(wt)
             if revision_id in (None, NULL_REVISION):
                 if branch.repository.supports_rich_root():
                     wt._set_root_id(generate_ids.gen_root_id())
                 else:
                     wt._set_root_id(ROOT_ID)
                 wt.flush()
-            basis = None
-            # frequently, we will get here due to branching.  The accelerator
-            # tree will be the tree from the branch, so the desired basis
-            # tree will often be a parent of the accelerator tree.
-            if accelerator_tree is not None:
-                try:
-                    basis = accelerator_tree.revision_tree(revision_id)
-                except errors.NoSuchRevision:
-                    pass
-            if basis is None:
-                basis = branch.repository.revision_tree(revision_id)
-            if revision_id == NULL_REVISION:
-                parents_list = []
-            else:
-                parents_list = [(revision_id, basis)]
+            wt.set_last_revision(revision_id)
+            wt.flush()
+            basis = wt.basis_tree()
             basis.lock_read()
-            try:
-                wt.set_parent_trees(parents_list, allow_leftmost_as_ghost=True)
+            # if the basis has a root id we have to use that; otherwise we use
+            # a new random one
+            basis_root_id = basis.get_root_id()
+            if basis_root_id is not None:
+                wt._set_root_id(basis_root_id)
                 wt.flush()
-                # if the basis has a root id we have to use that; otherwise we
-                # use a new random one
-                basis_root_id = basis.get_root_id()
-                if basis_root_id is not None:
-                    wt._set_root_id(basis_root_id)
-                    wt.flush()
-                # delta_from_tree is safe even for DirStateRevisionTrees,
-                # because wt4.apply_inventory_delta does not mutate the input
-                # inventory entries.
-                transform.build_tree(basis, wt, accelerator_tree,
-                                     hardlink=hardlink, delta_from_tree=True)
-            finally:
-                basis.unlock()
+            transform.build_tree(basis, wt)
+            basis.unlock()
         finally:
             control_files.unlock()
             wt.unlock()
         return wt
 
-    def _init_custom_control_files(self, wt):
-        """Subclasses with custom control files should override this method.
-        
-        The working tree and control files are locked for writing when this
-        method is called.
-        
-        :param wt: the WorkingTree object
-        """
-
     def _open(self, a_bzrdir, control_files):
         """Open the tree itself.
 
         :param a_bzrdir: the dir for the tree.
         :param control_files: the control files for the tree.
         """
-        return self._tree_class(a_bzrdir.root_transport.local_abspath('.'),
+        return WorkingTree4(a_bzrdir.root_transport.local_abspath('.'),
                            branch=a_bzrdir.open_branch(),
                            _format=self,
                            _bzrdir=a_bzrdir,
@@ -1432,9 +1342,6 @@
         self._inventory = None
         self._locked = 0
         self._dirstate_locked = False
-        self._repo_supports_tree_reference = getattr(
-            repository._format, "supports_tree_reference",
-            False)
 
     def __repr__(self):
         return "<%s of %s in %s>" % \
@@ -1443,9 +1350,8 @@
     def annotate_iter(self, file_id,
                       default_revision=_mod_revision.CURRENT_REVISION):
         """See Tree.annotate_iter"""
-        text_key = (file_id, self.inventory[file_id].revision)
-        annotations = self._repository.texts.annotate(text_key)
-        return [(key[-1], line) for (key, line) in annotations]
+        w = self._get_weave(file_id)
+        return w.annotate_iter(self.inventory[file_id].revision)
 
     def _get_ancestors(self, default_revision):
         return set(self._repository.get_ancestry(self._revision_id,
@@ -1472,22 +1378,6 @@
     def get_root_id(self):
         return self.path2id('')
 
-    def id2path(self, file_id):
-        "Convert a file-id to a path."
-        entry = self._get_entry(file_id=file_id)
-        if entry == (None, None):
-            raise errors.NoSuchId(tree=self, file_id=file_id)
-        path_utf8 = osutils.pathjoin(entry[0][0], entry[0][1])
-        return path_utf8.decode('utf8')
-
-    def iter_references(self):
-        if not self._repo_supports_tree_reference:
-            # When the repo doesn't support references, we will have nothing to
-            # return
-            return iter([])
-        # Otherwise, fall back to the default implementation
-        return super(DirStateRevisionTree, self).iter_references()
-
     def _get_parent_index(self):
         """Return the index in the dirstate referenced by this tree."""
         return self._dirstate.get_parent_ids().index(self._revision_id) + 1
@@ -1518,23 +1408,19 @@
 
         This is relatively expensive: we have to walk the entire dirstate.
         """
-        if not self._locked:
-            raise AssertionError(
-                'cannot generate inventory of an unlocked '
-                'dirstate revision tree')
+        assert self._locked, 'cannot generate inventory of an unlocked '\
+            'dirstate revision tree'
         # separate call for profiling - makes it clear where the costs are.
         self._dirstate._read_dirblocks_if_needed()
-        if self._revision_id not in self._dirstate.get_parent_ids():
-            raise AssertionError(
-                'parent %s has disappeared from %s' % (
-                self._revision_id, self._dirstate.get_parent_ids()))
+        assert self._revision_id in self._dirstate.get_parent_ids(), \
+            'parent %s has disappeared from %s' % (
+            self._revision_id, self._dirstate.get_parent_ids())
         parent_index = self._dirstate.get_parent_ids().index(self._revision_id) + 1
         # This is identical now to the WorkingTree _generate_inventory except
         # for the tree index use.
         root_key, current_entry = self._dirstate._get_entry(parent_index, path_utf8='')
         current_id = root_key[2]
-        if current_entry[parent_index][0] != 'd':
-            raise AssertionError()
+        assert current_entry[parent_index][0] == 'd'
         inv = Inventory(root_id=current_id, revision_id=self._revision_id)
         inv.root.revision = current_entry[parent_index][4]
         # Turn some things into local variables
@@ -1580,12 +1466,8 @@
                     raise AssertionError("cannot convert entry %r into an InventoryEntry"
                             % entry)
                 # These checks cost us around 40ms on a 55k entry tree
-                if file_id in inv_byid:
-                    raise AssertionError('file_id %s already in'
-                        ' inventory as %s' % (file_id, inv_byid[file_id]))
-                if name_unicode in parent_ie.children:
-                    raise AssertionError('name %r already in parent'
-                        % (name_unicode,))
+                assert file_id not in inv_byid
+                assert name_unicode not in parent_ie.children
                 inv_byid[file_id] = inv_entry
                 parent_ie.children[name_unicode] = inv_entry
         self._inventory = inv
@@ -1611,18 +1493,26 @@
             return parent_details[1]
         return None
 
+    @symbol_versioning.deprecated_method(symbol_versioning.zero_ninety)
+    def get_weave(self, file_id):
+        return self._get_weave(file_id)
+
+    def _get_weave(self, file_id):
+        return self._repository.weave_store.get_weave(file_id,
+                self._repository.get_transaction())
+
     def get_file(self, file_id, path=None):
         return StringIO(self.get_file_text(file_id))
 
     def get_file_lines(self, file_id):
-        return osutils.split_lines(self.get_file_text(file_id))
+        ie = self.inventory[file_id]
+        return self._get_weave(file_id).get_lines(ie.revision)
 
     def get_file_size(self, file_id):
-        """See Tree.get_file_size"""
         return self.inventory[file_id].text_size
 
     def get_file_text(self, file_id):
-        return list(self.iter_files_bytes([(file_id, None)]))[0][1]
+        return ''.join(self.get_file_lines(file_id))
 
     def get_reference_revision(self, file_id, path=None):
         return self.inventory[file_id].reference_revision
@@ -1674,14 +1564,7 @@
         return bool(self.path2id(filename))
 
     def kind(self, file_id):
-        entry = self._get_entry(file_id=file_id)[1]
-        if entry is None:
-            raise errors.NoSuchId(tree=self, file_id=file_id)
-        return dirstate.DirState._minikind_to_kind[entry[1][0]]
-
-    def stored_kind(self, file_id):
-        """See Tree.stored_kind"""
-        return self.kind(file_id)
+        return self.inventory[file_id].kind
 
     def path_content_summary(self, path):
         """See Tree.path_content_summary."""
@@ -1747,10 +1630,6 @@
                 self._dirstate_locked = False
             self._repository.unlock()
 
-    @needs_read_lock
-    def supports_tree_reference(self):
-        return self._repo_supports_tree_reference
-
     def walkdirs(self, prefix=""):
         # TODO: jam 20070215 This is the lazy way by using the RevisionTree
         # implementation based on an inventory.  
@@ -1813,12 +1692,12 @@
     _matching_to_tree_format = WorkingTreeFormat4()
     _test_mutable_trees_to_test_trees = make_source_parent_tree
 
-    def iter_changes(self, include_unchanged=False,
+    def _iter_changes(self, include_unchanged=False,
                       specific_files=None, pb=None, extra_trees=[],
                       require_versioned=True, want_unversioned=False):
         """Return the changes from source to target.
 
-        :return: An iterator that yields tuples. See InterTree.iter_changes
+        :return: An iterator that yields tuples. See InterTree._iter_changes
             for details.
         :param specific_files: An optional list of file paths to restrict the
             comparison to. When mapping filenames to ids, all matches in all
@@ -1841,31 +1720,31 @@
         # NB: show_status depends on being able to pass in non-versioned files
         # and report them as unknown
         # TODO: handle extra trees in the dirstate.
-        if (extra_trees or specific_files == []):
+        # TODO: handle comparisons as an empty tree as a different special
+        # case? mbp 20070226
+        if (extra_trees or (self.source._revision_id == NULL_REVISION)
+            or specific_files == []):
             # we can't fast-path these cases (yet)
-            for f in super(InterDirStateTree, self).iter_changes(
+            for f in super(InterDirStateTree, self)._iter_changes(
                 include_unchanged, specific_files, pb, extra_trees,
                 require_versioned, want_unversioned=want_unversioned):
                 yield f
             return
         parent_ids = self.target.get_parent_ids()
-        if not (self.source._revision_id in parent_ids
-                or self.source._revision_id == NULL_REVISION):
-            raise AssertionError(
-                "revision {%s} is not stored in {%s}, but %s "
-                "can only be used for trees stored in the dirstate"
-                % (self.source._revision_id, self.target, self.iter_changes))
+        assert (self.source._revision_id in parent_ids), \
+                "revision {%s} is not stored in {%s}, but %s " \
+                "can only be used for trees stored in the dirstate" \
+                % (self.source._revision_id, self.target, self._iter_changes)
         target_index = 0
         if self.source._revision_id == NULL_REVISION:
             source_index = None
             indices = (target_index,)
         else:
-            if not (self.source._revision_id in parent_ids):
-                raise AssertionError(
-                    "Failure: source._revision_id: %s not in target.parent_ids(%s)" % (
-                    self.source._revision_id, parent_ids))
+            assert (self.source._revision_id in parent_ids), \
+                "Failure: source._revision_id: %s not in target.parent_ids(%s)" % (
+                self.source._revision_id, parent_ids)
             source_index = 1 + parent_ids.index(self.source._revision_id)
-            indices = (source_index, target_index)
+            indices = (source_index,target_index)
         # -- make all specific_files utf8 --
         if specific_files:
             specific_files_utf8 = set()
@@ -1980,6 +1859,7 @@
         # record is handled, but isn't interesting to process (unchanged)
         uninteresting = object()
 
+
         old_dirname_to_file_id = {}
         new_dirname_to_file_id = {}
         # TODO: jam 20070516 - Avoid the _get_entry lookup overhead by
@@ -2006,8 +1886,7 @@
             target_details = entry[1][target_index]
             target_minikind = target_details[0]
             if path_info is not None and target_minikind in 'fdlt':
-                if not (target_index == 0):
-                    raise AssertionError()
+                assert target_index == 0
                 link_or_sha1 = state.update_entry(entry, abspath=path_info[4],
                                                   stat_value=path_info[3])
                 # The entry may have been modified by update_entry
@@ -2038,11 +1917,6 @@
                                                  path_utf8=old_path)
                     # update the source details variable to be the real
                     # location.
-                    if old_entry == (None, None):
-                        raise errors.CorruptDirstate(state._filename,
-                            "entry '%s/%s' is considered renamed from %r"
-                            " but source does not exist\n"
-                            "entry: %s" % (entry[0][0], entry[0][1], old_path, entry))
                     source_details = old_entry[1][source_index]
                     source_minikind = source_details[0]
                 else:
@@ -2126,10 +2000,9 @@
                         #       parent entry will be the same as the source entry.
                         target_parent_entry = state._get_entry(target_index,
                                                                path_utf8=new_dirname)
-                        if target_parent_entry == (None, None):
-                            raise AssertionError(
-                                "Could not find target parent in wt: %s\nparent of: %s"
-                                % (new_dirname, entry))
+                        assert target_parent_entry != (None, None), (
+                            "Could not find target parent in wt: %s\nparent of: %s"
+                            % (new_dirname, entry))
                         target_parent_id = target_parent_entry[0][2]
                     if target_parent_id == entry[0][2]:
                         # This is the root, so the parent is None
@@ -2168,15 +2041,14 @@
                     return uninteresting
             elif source_minikind in 'a' and target_minikind in 'fdlt':
                 # looks like a new file
-                path = pathjoin(entry[0][0], entry[0][1])
-                # parent id is the entry for the path in the target tree
-                # TODO: these are the same for an entire directory: cache em.
-                parent_id = state._get_entry(target_index,
-                                             path_utf8=entry[0][0])[0][2]
-                if parent_id == entry[0][2]:
-                    parent_id = None
                 if path_info is not None:
-                    # Present on disk:
+                    path = pathjoin(entry[0][0], entry[0][1])
+                    # parent id is the entry for the path in the target tree
+                    # TODO: these are the same for an entire directory: cache em.
+                    parent_id = state._get_entry(target_index,
+                                                 path_utf8=entry[0][0])[0][2]
+                    if parent_id == entry[0][2]:
+                        parent_id = None
                     if use_filesystem_for_exec:
                         # We need S_ISREG here, because we aren't sure if this
                         # is a file or not.
@@ -2194,15 +2066,9 @@
                            (None, path_info[2]),
                            (None, target_exec))
                 else:
-                    # Its a missing file, report it as such.
-                    return (entry[0][2],
-                           (None, utf8_decode(path)[0]),
-                           False,
-                           (False, True),
-                           (None, parent_id),
-                           (None, utf8_decode(entry[0][1])[0]),
-                           (None, None),
-                           (None, False))
+                    # but its not on disk: we deliberately treat this as just
+                    # never-present. (Why ?! - RBC 20070224)
+                    pass
             elif source_minikind in 'fdlt' and target_minikind in 'a':
                 # unversioned, possibly, or possibly not deleted: we dont care.
                 # if its still on disk, *and* theres no other entry at this
@@ -2325,8 +2191,7 @@
                     if current_dir_info[0][0] == '':
                         # remove .bzr from iteration
                         bzr_index = bisect_left(current_dir_info[1], ('.bzr',))
-                        if current_dir_info[1][bzr_index][0] != '.bzr':
-                            raise AssertionError()
+                        assert current_dir_info[1][bzr_index][0] == '.bzr'
                         del current_dir_info[1][bzr_index]
             # walk until both the directory listing and the versioned metadata
             # are exhausted. 
@@ -2478,13 +2343,8 @@
                                 new_executable = bool(
                                     stat.S_ISREG(current_path_info[3].st_mode)
                                     and stat.S_IEXEC & current_path_info[3].st_mode)
-                                try:
-                                    relpath_unicode = utf8_decode(current_path_info[0])[0]
-                                except UnicodeDecodeError:
-                                    raise errors.BadFilenameEncoding(
-                                        current_path_info[0], osutils._fs_enc)
                                 yield (None,
-                                    (None, relpath_unicode),
+                                    (None, utf8_decode(current_path_info[0])[0]),
                                     True,
                                     (False, False),
                                     (None, None),
@@ -2527,6 +2387,7 @@
                     except StopIteration:
                         current_dir_info = None
 
+
     @staticmethod
     def is_compatible(source, target):
         # the target must be a dirstate working tree
@@ -2587,6 +2448,5 @@
 
     def update_format(self, tree):
         """Change the format marker."""
-        tree._transport.put_bytes('format',
-            self.target_format.get_format_string(),
-            mode=tree.bzrdir._get_file_mode())
+        tree._control_files.put_utf8('format',
+            self.target_format.get_format_string())

=== modified file 'bzrlib/xml4.py'
--- bzrlib/xml4.py	2008-04-24 07:22:53 +0000
+++ bzrlib/xml4.py	2007-10-05 02:41:37 +0000
@@ -50,6 +50,7 @@
         # for now, leaving them as null in the xml form.  in a future
         # version it will be implied by nested elements.
         if ie.parent_id != ROOT_ID:
+            assert isinstance(ie.parent_id, basestring)
             e.set('parent_id', ie.parent_id)
 
         e.tail = '\n'
@@ -62,6 +63,7 @@
 
         :param revision_id: Ignored parameter used by xml5.
         """
+        assert elt.tag == 'inventory'
         root_id = elt.get('file_id') or ROOT_ID
         inv = Inventory(root_id)
         for e in elt:
@@ -73,6 +75,8 @@
 
 
     def _unpack_entry(self, elt):
+        assert elt.tag == 'entry'
+
         ## original format inventories don't have a parent_id for
         ## nodes in the root directory, but it's cleaner to use one
         ## internally.
@@ -129,6 +133,7 @@
             for i, parent_id in enumerate(rev.parents):
                 p = SubElement(pelts, 'revision_ref')
                 p.tail = '\n'
+                assert parent_id
                 p.set('revision_id', parent_id)
                 if i < len(rev.parent_sha1s):
                     p.set('revision_sha1', rev.parent_sha1s[i])
@@ -156,11 +161,14 @@
 
         if pelts:
             for p in pelts:
+                assert p.tag == 'revision_ref', \
+                       "bad parent node tag %r" % p.tag
                 rev.parent_ids.append(p.get('revision_id'))
                 rev.parent_sha1s.append(p.get('revision_sha1'))
             if precursor:
                 # must be consistent
                 prec_parent = rev.parent_ids[0]
+                assert prec_parent == precursor
         elif precursor:
             # revisions written prior to 0.0.5 have a single precursor
             # give as an attribute

=== renamed file 'bzrlib/xml8.py' => 'bzrlib/xml5.py'
--- bzrlib/xml8.py	2008-04-24 07:22:53 +0000
+++ bzrlib/xml5.py	2007-10-19 17:14:33 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2008 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -138,33 +138,30 @@
     _to_escaped_map.clear()
 
 
-class Serializer_v8(Serializer):
-    """This serialiser adds rich roots.
+class Serializer_v5(Serializer):
+    """Version 5 serializer
 
-    Its revision format number matches its inventory number.
+    Packs objects into XML and vice versa.
     """
-
+    
     __slots__ = []
 
-    root_id = None
+    root_id = ROOT_ID
     support_altered_by_hack = True
     # This format supports the altered-by hack that reads file ids directly out
     # of the versionedfile, without doing XML parsing.
 
     supported_kinds = set(['file', 'directory', 'symlink'])
-    format_num = '8'
-    revision_format_num = None
+    format_num = '5'
 
     def _check_revisions(self, inv):
         """Extension point for subclasses to check during serialisation.
 
+        By default no checking is done.
+
         :param inv: An inventory about to be serialised, to be checked.
         :raises: AssertionError if an error has occured.
         """
-        if inv.revision_id is None:
-            raise AssertionError()
-        if inv.root.revision is None:
-            raise AssertionError()
 
     def write_inventory_to_lines(self, inv):
         """Return a list of lines with the encoded inventory."""
@@ -276,19 +273,21 @@
 
     def _append_inventory_root(self, append, inv):
         """Append the inventory root to output."""
+        if inv.root.file_id not in (None, ROOT_ID):
+            fileid1 = ' file_id="'
+            fileid2 = _encode_and_escape(inv.root.file_id)
+        else:
+            fileid1 = ""
+            fileid2 = ""
         if inv.revision_id is not None:
             revid1 = ' revision_id="'
             revid2 = _encode_and_escape(inv.revision_id)
         else:
             revid1 = ""
             revid2 = ""
-        append('<inventory format="%s"%s%s>\n' % (
-            self.format_num, revid1, revid2))
-        append('<directory file_id="%s name="%s revision="%s />\n' % (
-            _encode_and_escape(inv.root.file_id),
-            _encode_and_escape(inv.root.name),
-            _encode_and_escape(inv.root.revision)))
-
+        append('<inventory%s%s format="5"%s%s>\n' % (
+            fileid1, fileid2, revid1, revid2))
+        
     def _pack_revision(self, rev):
         """Revision object -> xml tree"""
         # For the XML format, we need to write them as Unicode rather than as
@@ -298,15 +297,12 @@
         revision_id = rev.revision_id
         if isinstance(revision_id, str):
             revision_id = decode_utf8(revision_id)
-        format_num = self.format_num
-        if self.revision_format_num is not None:
-            format_num = self.revision_format_num
         root = Element('revision',
                        committer = rev.committer,
                        timestamp = '%.3f' % rev.timestamp,
                        revision_id = revision_id,
                        inventory_sha1 = rev.inventory_sha1,
-                       format=format_num,
+                       format='5',
                        )
         if rev.timezone is not None:
             root.set('timezone', str(rev.timezone))
@@ -318,6 +314,7 @@
             pelts = SubElement(root, 'parents')
             pelts.tail = pelts.text = '\n'
             for parent_id in rev.parent_ids:
+                assert isinstance(parent_id, basestring)
                 _mod_revision.check_not_reserved_id(parent_id)
                 p = SubElement(pelts, 'revision_ref')
                 p.tail = '\n'
@@ -331,27 +328,37 @@
     def _pack_revision_properties(self, rev, under_element):
         top_elt = SubElement(under_element, 'properties')
         for prop_name, prop_value in sorted(rev.properties.items()):
+            assert isinstance(prop_name, basestring) 
+            assert isinstance(prop_value, basestring) 
             prop_elt = SubElement(top_elt, 'property')
             prop_elt.set('name', prop_name)
             prop_elt.text = prop_value
             prop_elt.tail = '\n'
         top_elt.tail = '\n'
 
-    def _unpack_inventory(self, elt, revision_id=None):
-        """Construct from XML Element"""
-        if elt.tag != 'inventory':
-            raise errors.UnexpectedInventoryFormat('Root tag is %r' % elt.tag)
+    def _unpack_inventory(self, elt, revision_id):
+        """Construct from XML Element
+        """
+        assert elt.tag == 'inventory'
+        root_id = elt.get('file_id') or ROOT_ID
+        root_id = _get_utf8_or_ascii(root_id)
+
         format = elt.get('format')
-        if format != self.format_num:
-            raise errors.UnexpectedInventoryFormat('Invalid format version %r'
-                                                   % format)
-        revision_id = elt.get('revision_id')
-        if revision_id is not None:
-            revision_id = cache_utf8.encode(revision_id)
-        inv = inventory.Inventory(root_id=None, revision_id=revision_id)
+        if format is not None:
+            if format != '5':
+                raise BzrError("invalid format version %r on inventory"
+                                % format)
+        data_revision_id = elt.get('revision_id')
+        if data_revision_id is not None:
+            revision_id = cache_utf8.encode(data_revision_id)
+        inv = Inventory(root_id, revision_id=revision_id)
         for e in elt:
             ie = self._unpack_entry(e)
+            if ie.parent_id is None:
+                ie.parent_id = root_id
             inv.add(ie)
+        if revision_id is not None:
+            inv.root.revision = revision_id
         return inv
 
     def _unpack_entry(self, elt):
@@ -395,13 +402,11 @@
 
     def _unpack_revision(self, elt):
         """XML Element -> Revision object"""
+        assert elt.tag == 'revision'
         format = elt.get('format')
-        format_num = self.format_num
-        if self.revision_format_num is not None:
-            format_num = self.revision_format_num
         if format is not None:
-            if format != format_num:
-                raise BzrError("invalid format version %r on revision"
+            if format != '5':
+                raise BzrError("invalid format version %r on inventory"
                                 % format)
         get_cached = _get_utf8_or_ascii
         rev = Revision(committer = elt.get('committer'),
@@ -411,6 +416,8 @@
                        )
         parents = elt.find('parents') or []
         for p in parents:
+            assert p.tag == 'revision_ref', \
+                   "bad parent node tag %r" % p.tag
             rev.parent_ids.append(get_cached(p.get('revision_id')))
         self._unpack_revision_properties(elt, rev)
         v = elt.get('timezone')
@@ -424,12 +431,12 @@
     def _unpack_revision_properties(self, elt, rev):
         """Unpack properties onto a revision."""
         props_elt = elt.find('properties')
+        assert len(rev.properties) == 0
         if not props_elt:
             return
         for prop_elt in props_elt:
-            if prop_elt.tag != 'property':
-                raise AssertionError(
-                    "bad tag under properties list: %r" % prop_elt.tag)
+            assert prop_elt.tag == 'property', \
+                "bad tag under properties list: %r" % prop_elt.tag
             name = prop_elt.get('name')
             value = prop_elt.text
             # If a property had an empty value ('') cElementTree reads
@@ -437,9 +444,9 @@
             # properties have string values
             if value is None:
                 value = ''
-            if name in rev.properties:
-                raise AssertionError("repeated property %r" % name)
+            assert name not in rev.properties, \
+                "repeated property %r" % name
             rev.properties[name] = value
 
 
-serializer_v8 = Serializer_v8()
+serializer_v5 = Serializer_v5()

=== removed file 'bzrlib/xml5.py'
--- bzrlib/xml5.py	2008-04-24 07:22:53 +0000
+++ bzrlib/xml5.py	1970-01-01 00:00:00 +0000
@@ -1,83 +0,0 @@
-# Copyright (C) 2005, 2006, 2007, 2008 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-from bzrlib import (
-    cache_utf8,
-    inventory,
-    xml6,
-    xml8,
-    )
-
-class Serializer_v5(xml6.Serializer_v6):
-    """Version 5 serializer
-
-    Packs objects into XML and vice versa.
-    """
-    format_num = '5'
-    root_id = inventory.ROOT_ID
-
-    def _unpack_inventory(self, elt, revision_id):
-        """Construct from XML Element
-        """
-        root_id = elt.get('file_id') or inventory.ROOT_ID
-        root_id = xml8._get_utf8_or_ascii(root_id)
-
-        format = elt.get('format')
-        if format is not None:
-            if format != '5':
-                raise BzrError("invalid format version %r on inventory"
-                                % format)
-        data_revision_id = elt.get('revision_id')
-        if data_revision_id is not None:
-            revision_id = cache_utf8.encode(data_revision_id)
-        inv = inventory.Inventory(root_id, revision_id=revision_id)
-        for e in elt:
-            ie = self._unpack_entry(e)
-            if ie.parent_id is None:
-                ie.parent_id = root_id
-            inv.add(ie)
-        if revision_id is not None:
-            inv.root.revision = revision_id
-        return inv
-
-    def _check_revisions(self, inv):
-        """Extension point for subclasses to check during serialisation.
-
-        In this version, no checking is done.
-
-        :param inv: An inventory about to be serialised, to be checked.
-        :raises: AssertionError if an error has occured.
-        """
-
-    def _append_inventory_root(self, append, inv):
-        """Append the inventory root to output."""
-        if inv.root.file_id not in (None, inventory.ROOT_ID):
-            fileid1 = ' file_id="'
-            fileid2 = xml8._encode_and_escape(inv.root.file_id)
-        else:
-            fileid1 = ""
-            fileid2 = ""
-        if inv.revision_id is not None:
-            revid1 = ' revision_id="'
-            revid2 = xml8._encode_and_escape(inv.revision_id)
-        else:
-            revid1 = ""
-            revid2 = ""
-        append('<inventory%s%s format="5"%s%s>\n' % (
-            fileid1, fileid2, revid1, revid2))
-
-
-serializer_v5 = Serializer_v5()

=== removed file 'bzrlib/xml6.py'
--- bzrlib/xml6.py	2008-03-28 02:28:52 +0000
+++ bzrlib/xml6.py	1970-01-01 00:00:00 +0000
@@ -1,33 +0,0 @@
-# Copyright (C) 2008 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-from bzrlib import xml8
-
-
-class Serializer_v6(xml8.Serializer_v8):
-    """This serialiser supports rich roots.
-
-    While its inventory format number is 6, its revision format is 5.
-    Its inventory_sha1 may be inaccurate-- the inventory may have been
-    converted from format 5 or 7 without updating the sha1.
-    """
-
-    format_num = '6'
-    # Format 6 & 7 reported their revision format as 5.
-    revision_format_num = '5'
-
-
-serializer_v6 = Serializer_v6()

=== added file 'bzrlib/xml6.py'
--- bzrlib/xml6.py	1970-01-01 00:00:00 +0000
+++ bzrlib/xml6.py	2007-10-05 02:41:37 +0000
@@ -0,0 +1,71 @@
+# Copyright (C) 2005, 2006, 2007 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+from bzrlib import cache_utf8, inventory, errors, xml5
+
+
+class Serializer_v6(xml5.Serializer_v5):
+    """This serialiser adds rich roots."""
+
+    format_num = '6'
+    root_id = None
+
+    def _append_inventory_root(self, append, inv):
+        """Append the inventory root to output."""
+        if inv.revision_id is not None:
+            revid1 = ' revision_id="'
+            revid2 = xml5._encode_and_escape(inv.revision_id)
+        else:
+            revid1 = ""
+            revid2 = ""
+        append('<inventory format="%s"%s%s>\n' % (
+            self.format_num, revid1, revid2))
+        append('<directory file_id="%s name="%s revision="%s />\n' % (
+            xml5._encode_and_escape(inv.root.file_id),
+            xml5._encode_and_escape(inv.root.name),
+            xml5._encode_and_escape(inv.root.revision)))
+
+    def _check_revisions(self, inv):
+        """Extension point for subclasses to check during serialisation.
+
+        By default no checking is done.
+
+        :param inv: An inventory about to be serialised, to be checked.
+        :raises: AssertionError if an error has occured.
+        """
+        assert inv.revision_id is not None
+        assert inv.root.revision is not None
+
+    def _unpack_inventory(self, elt, revision_id=None):
+        """Construct from XML Element"""
+        if elt.tag != 'inventory':
+            raise errors.UnexpectedInventoryFormat('Root tag is %r' % elt.tag)
+        format = elt.get('format')
+        if format != self.format_num:
+            raise errors.UnexpectedInventoryFormat('Invalid format version %r'
+                                                   % format)
+        revision_id = elt.get('revision_id')
+        if revision_id is not None:
+            revision_id = cache_utf8.encode(revision_id)
+        inv = inventory.Inventory(root_id=None, revision_id=revision_id)
+        for e in elt:
+            ie = self._unpack_entry(e)
+            inv.add(ie)
+        assert inv.root.revision is not None
+        return inv
+
+
+serializer_v6 = Serializer_v6()

=== modified file 'bzrlib/xml_serializer.py'
--- bzrlib/xml_serializer.py	2008-06-12 15:51:15 +0000
+++ bzrlib/xml_serializer.py	2007-10-05 02:41:37 +0000
@@ -34,7 +34,7 @@
     except ImportError:
         from cElementTree import (ElementTree, SubElement, Element,
                                   XMLTreeBuilder, fromstring, tostring)
-        import elementtree.ElementTree
+        import elementtree
     ParseError = SyntaxError
 except ImportError:
     mutter('WARNING: using slower ElementTree; consider installing cElementTree'
@@ -65,11 +65,7 @@
         :param xml_string: The xml to read.
         :param revision_id: If not-None, the expected revision id of the
             inventory. Some serialisers use this to set the results' root
-            revision. This should be supplied for deserialising all
-            from-repository inventories so that xml5 inventories that were
-            serialised without a revision identifier can be given the right
-            revision id (but not for working tree inventories where users can
-            edit the data without triggering checksum errors or anything).
+            revision.
         """
         try:
             return self._unpack_inventory(fromstring(xml_string), revision_id)
@@ -179,4 +175,3 @@
 format_registry.register_lazy('5', 'bzrlib.xml5', 'serializer_v5')
 format_registry.register_lazy('6', 'bzrlib.xml6', 'serializer_v6')
 format_registry.register_lazy('7', 'bzrlib.xml7', 'serializer_v7')
-format_registry.register_lazy('8', 'bzrlib.xml8', 'serializer_v8')

=== removed file 'contrib/bash/bzrbashprompt.sh'
--- contrib/bash/bzrbashprompt.sh	2008-07-08 15:58:12 +0000
+++ contrib/bash/bzrbashprompt.sh	1970-01-01 00:00:00 +0000
@@ -1,14 +0,0 @@
-# modify PS1 to your preference and include this file in your bashrc
-# or copy to /etc/bash_completions.d.
-
-function __prompt_bzr()
-{
-	local revno nick;
-	revno=$(bzr revno 2>/dev/null) || return
-	nick=$(bzr nick 2>/dev/null) || return
-	echo "[bzr://$revno@$nick]"
-}
-
-if [ "$PS1" ]; then
-	PS1='\u@\h:$(__prompt_bzr)\W\$ '
-fi

=== removed file 'contrib/bzr_access'
--- contrib/bzr_access	2008-06-05 12:13:14 +0000
+++ contrib/bzr_access	1970-01-01 00:00:00 +0000
@@ -1,232 +0,0 @@
-#!/usr/bin/env python
-###############################################################################
-#
-#  bzr_access:
-#    Simple access control for shared bazaar repository accessed over ssh.
-#
-# Copyright (C) 2007 Balint Aradi
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-#
-###############################################################################
-"""
-Invocation: bzr_access <bzr_executable> <repo_collection> <user>
-
-The script extracts from the SSH_ORIGINAL_COMMAND environment variable the
-repository, which bazaar tries to access through the bzr+ssh protocol. The
-repository is assumed to be relative to <repo_collection>. Based
-on the configuration file <repo_collection>/bzr_access.conf it determines
-the access rights (denied, read-only, read-write) for the specified user.
-If the user has read-only or read-write access a bazaar smart server is
-started for it in read-only or in read-write mode, rsp., using the specified
-bzr executable.
-
-Config file: INI format, pretty much similar to the authfile of subversion.
-
-Groups can be defined in the [groups] section. The options in this block are
-the names of the groups to be defined, the corresponding values the lists of
-the users belonging to the given groups. (User names must be separated by
-commas.)
-
-Right now only one section is supported [/], defining the permissions for the
-repository. The options in those sections are user names or group references
-(group name with a leading '@'), the corresponding values are the 
-permissions: 'rw', 'r' and '' (without the quotes)
-for read-write, read-only and no access, respectively.
-
-Sample bzr_access.conf::
-
-   [groups]
-   admins = alpha
-   devels = beta, gamma, delta
-   
-   [/]
-   @admins = rw
-   @devels = r
-
-This allows you to set up a single SSH user, and customize the access based on
-ssh key. Your ``.ssh/authorized_key`` file should look something like this::
-
-   command="/path/to/bzr_access /path/to/bzr /path/to/repository <username>",no-port-forwarding,no-X11-forwarding,no-agent-forwarding ssh-<type> <key>
-"""
-
-import ConfigParser
-import os
-import re
-import subprocess
-import sys
-
-CONFIG_FILE = "bzr_access.conf"
-SCRIPT_NAME = os.path.basename(sys.argv[0])
-
-# Permission constants
-PERM_DENIED = 0
-PERM_READ = 1
-PERM_READWRITE = 2
-PERM_DICT = { "r": PERM_READ, "rw": PERM_READWRITE }
-
-# Exit codes
-EXIT_BAD_NR_ARG = 1
-EXIT_BZR_NOEXEC = 2
-EXIT_REPO_NOREAD = 3
-EXIT_BADENV = 4
-EXIT_BADDIR = 5
-EXIT_NOCONF = 6
-EXIT_NOACCESS = 7
-EXIT_BADUSERNAME = 8
-
-# pattern for the bzr command passed to ssh
-PAT_SSH_COMMAND = re.compile(r"""^bzr\s+
-                             serve\s+
-                             --inet\s+
-                             --directory=(?P<dir>\S+)\s+
-                             --allow-writes\s*$""", re.VERBOSE)
-
-# Command line for starting bzr
-BZR_OPTIONS = ['serve', '--inet', '--directory']
-BZR_READWRITE_FLAGS = ['--allow-writes']
-
-
-
-def error(msg, exit_code):
-    """Prints error message to stdout and exits with given error code."""
-    
-    print >>sys.stderr, "%s::error: %s" % (SCRIPT_NAME, msg)
-    sys.exit(exit_code)
-  
-
-
-class AccessManager(object):
-    """Manages the permissions, can be queried for a specific user and path."""
-    
-    def __init__(self, fp):
-        """:param fp: File like object, containing the configuration options.
-        """
-        # TODO: jam 20071211 Consider switching to bzrlib.util.configobj
-        self.config = ConfigParser.ConfigParser()
-        self.config.readfp(fp)
-        self.groups = {}
-        if self.config.has_section("groups"):
-            for group, users in self.config.items("groups"):
-                self.groups[group] = set([ s.strip() for s in users.split(",")])
-        
-
-    def permission(self, user):
-        """Determines the permission for a given user and a given path
-        :param user: user to look for.
-        :return: permission.
-        """
-        configSection = "/"
-        perm = PERM_DENIED
-        pathFound = self.config.has_section(configSection)
-        if (pathFound):
-            options = reversed(self.config.options(configSection))
-            for option in options:
-                value = PERM_DICT.get(self.config.get(configSection, option),
-                                      PERM_DENIED)
-                if self._is_relevant(option, user):
-                    perm = value
-        return perm
-
-      
-    def _is_relevant(self, option, user):
-        """Decides if a certain option is relevant for a given user.
-      
-        An option is relevant if it is identical with the user or with a
-        reference to a group including the user.
-      
-        :param option: Option to check.
-        :param user: User
-        :return: True if option is relevant for the user, False otherwise.
-        """
-        if option.startswith("@"):
-            result = (user in self.groups.get(option[1:], set()))
-        else:
-            result = (option == user)
-        return result
-
-
-
-def get_directory(command):
-    """Extracts the directory name from the command pass to ssh.
-    :param command: command to parse.
-    :return: Directory name or empty string, if directory was not found or if it
-    does not start with '/'.
-    """
-    match = PAT_SSH_COMMAND.match(command)
-    if not match:
-        return ""
-    directory = match.group("dir")
-    return os.path.normpath(directory)
-
-
-
-############################################################################
-# Main program
-############################################################################
-def main():
-    # Read arguments
-    if len(sys.argv) != 4:
-        error("Invalid number or arguments.", EXIT_BAD_NR_ARG)
-    (bzrExec, repoRoot, user) = sys.argv[1:4]
-    
-    # Sanity checks
-    if not os.access(bzrExec, os.X_OK):
-        error("bzr is not executable.", EXIT_BZR_NOEXEC)
-    if not os.access(repoRoot, os.R_OK):
-        error("Path to repository not readable.", EXIT_REPO_NOREAD)
-    
-    # Extract the repository path from the command passed to ssh.
-    if not os.environ.has_key("SSH_ORIGINAL_COMMAND"):
-        error("Environment variable SSH_ORIGINAL_COMMAND missing.", EXIT_BADENV)
-    directory = get_directory(os.environ["SSH_ORIGINAL_COMMAND"])
-    if len(directory) == 0:
-        error("Bad directory name.", EXIT_BADDIR)
-
-    # Control user name
-    if not user.isalnum():
-        error("Invalid user name", EXIT_BADUSERNAME)
-    
-    # Read in config file.
-    try:
-        fp = open(os.path.join(repoRoot, CONFIG_FILE), "r")
-        try:
-            accessMan = AccessManager(fp)
-        finally:
-            fp.close()
-    except IOError:
-        error("Can't read config file.", EXIT_NOCONF)
-    
-    # Determine permission and execute bzr with appropriate options
-    perm = accessMan.permission(user)
-    command = [bzrExec] + BZR_OPTIONS + [repoRoot]
-    if perm == PERM_READ:
-        # Nothing extra needed for readonly operations
-        pass
-    elif perm == PERM_READWRITE:
-        # Add the write flags
-        command.extend(BZR_READWRITE_FLAGS)
-    else:
-        error("Access denied.", EXIT_NOACCESS)
-    return subprocess.call(command)
-
-
-if __name__ == "__main__":
-  main()
-
-
-### Local Variables:
-### mode:python
-### End:

=== modified file 'doc/default.css'
--- doc/default.css	2008-02-07 07:05:13 +0000
+++ doc/default.css	2007-08-07 14:56:50 +0000
@@ -35,21 +35,6 @@
   color: inherit;
   }
 
-/* Format ".. note:" sections nicely */
-div.note {
-  margin-left: 5em;
-  margin-right: 5em;
-  color: #000000;
-  background-color: #c1d1ff;
-  border: 1px solid #888888;
-  padding-left: 1em;
-  padding-right: 1em;
-  }
-
-div.note .first {
-  font-weight: bold;
-  }
-
 h1 {
   color: #b52b2b; 
   /* DKREDcolor: #966b72; */
@@ -139,6 +124,7 @@
   margin-right: 5em;
   color: #000000;
   font-weight: normal;
+  background-color: #c1d1ff;
   background-color: #e5ecf9;
   border: 1px solid #888888;
   padding: 1em;

=== modified file 'doc/developers/HACKING.txt'
--- doc/developers/HACKING.txt	2008-08-20 02:07:36 +0000
+++ doc/developers/HACKING.txt	2007-10-02 06:13:56 +0000
@@ -2,23 +2,11 @@
 Bazaar Developer Guide
 ======================
 
-This document describes the Bazaar internals and the development process.  
-It's meant for people interested in developing Bazaar, and some parts will
-also be useful to people developing Bazaar plugins.
-
-If you have any questions or something seems to be incorrect, unclear or
-missing, please talk to us in ``irc://irc.freenode.net/#bzr``, or write to
-the Bazaar mailing list.  To propose a correction or addition to this
-document, send a merge request or new text to the mailing list.
-
-The current version of this document is available in the file 
+.. contents::
+
+(The current version of this document is available in the file 
 ``doc/developers/HACKING.txt`` in the source tree, or at
-http://doc.bazaar-vcs.org/bzr.dev/en/developer-guide/HACKING.html
-
-See also:
-`Bazaar Developer Documentation Catalog <../../developers/index.html>`_.
-
-.. contents::
+http://doc.bazaar-vcs.org/bzr.dev/en/developer-guide/HACKING.html)
 
 
 Getting Started
@@ -215,57 +203,323 @@
 Navigating the Code Base
 ========================
 
-.. Was at <http://bazaar-vcs.org/NewDeveloperIntroduction>
-
-Some of the key files in this directory are:
-
-bzr
-    The command you run to start Bazaar itself.  This script is pretty
-    short and just does some checks then jumps into bzrlib.
-
-README
-    This file covers a brief introduction to Bazaar and lists some of its
-    key features. 
-
-NEWS
-    Summary of changes in each Bazaar release that can affect users or 
-    plugin developers.
-
-setup.py
-    Installs Bazaar system-wide or to your home directory.  To perform
-    development work on Bazaar it is not required to run this file - you
-    can simply run the bzr command from the top level directory of your
-    development copy. Note: That if you run setup.py this will create a
-    'build' directory in your development branch. There's nothing wrong
-    with this but don't be confused by it. The build process puts a copy
-    of the main code base into this build directory, along with some other
-    files. You don't need to go in here for anything discussed in this
-    guide. 
-
-bzrlib
-    Possibly the most exciting folder of all, bzrlib holds the main code
-    base. This is where you will go to edit python files and contribute to
-    Bazaar.
-
-doc
-    Holds documentation on a whole range of things on Bazaar from the
-    origination of ideas within the project to information on Bazaar
-    features and use cases.  Within this directory there is a subdirectory
-    for each translation into a human language.  All the documentation 
-    is in the ReStructuredText markup language.
-
-doc/developers 
-    Documentation specifically targetted at Bazaar and plugin developers.
-    (Including this document.)
-    
-        
-
-Automatically-generated API reference information is available at 
-<http://starship.python.net/crew/mwh/bzrlibapi/>.  
-(There is an experimental editable version at 
-<http://starship.python.net/crew/mwh/bzrlibapi-oe/>.)
-See also the `Essential Domain Classes`_
-section of this guide.
+TODO: List and describe in one line the purpose of each directory
+inside an installation of bzr.
+
+TODO: Refer to a central location holding an up to date copy of the API
+documentation generated by epydoc, e.g. something like
+http://starship.python.net/crew/mwh/bzrlibapi/bzrlib.html.
+
+
+Testing Bazaar
+##############
+
+The Importance of Testing
+=========================
+
+Reliability is a critical success factor for any Version Control System.
+We want Bazaar to be highly reliable across multiple platforms while
+evolving over time to meet the needs of its community. 
+
+In a nutshell, this is want we expect and encourage:
+
+* New functionality should have test cases.  Preferably write the
+  test before writing the code.
+
+  In general, you can test at either the command-line level or the
+  internal API level.  See Writing tests below for more detail.
+
+* Try to practice Test-Driven Development: before fixing a bug, write a
+  test case so that it does not regress.  Similarly for adding a new
+  feature: write a test case for a small version of the new feature before
+  starting on the code itself.  Check the test fails on the old code, then
+  add the feature or fix and check it passes.
+
+By doing these things, the Bazaar team gets increased confidence that
+changes do what they claim to do, whether provided by the core team or
+by community members. Equally importantly, we can be surer that changes
+down the track do not break new features or bug fixes that you are
+contributing today.
+
+As of May 2007, Bazaar ships with a test suite containing over 6000 tests
+and growing. We are proud of it and want to remain so. As community
+members, we all benefit from it. Would you trust version control on
+your project to a product *without* a test suite like Bazaar has?
+
+
+Running the Test Suite
+======================
+
+Currently, bzr selftest is used to invoke tests.
+You can provide a pattern argument to run a subset. For example, 
+to run just the blackbox tests, run::
+
+  ./bzr selftest -v blackbox
+
+To skip a particular test (or set of tests), use the --exclude option
+(shorthand -x) like so::
+
+  ./bzr selftest -v -x blackbox  
+
+To ensure that all tests are being run and succeeding, you can use the
+--strict option which will fail if there are any missing features or known
+failures, like so::
+
+  ./bzr selftest --strict
+
+To list tests without running them, use the --list-only option like so::
+
+  ./bzr selftest --list-only
+
+This option can be combined with other selftest options (like -x) and
+filter patterns to understand their effect.
+
+
+Writing Tests
+=============
+
+In general tests should be placed in a file named test_FOO.py where 
+FOO is the logical thing under test. That file should be placed in the
+tests subdirectory under the package being tested.
+
+For example, tests for merge3 in bzrlib belong in bzrlib/tests/test_merge3.py.
+See bzrlib/tests/test_sampler.py for a template test script.
+
+Tests can be written for the UI or for individual areas of the library.
+Choose whichever is appropriate: if adding a new command, or a new command 
+option, then you should be writing a UI test.  If you are both adding UI
+functionality and library functionality, you will want to write tests for 
+both the UI and the core behaviours.  We call UI tests 'blackbox' tests
+and they are found in ``bzrlib/tests/blackbox/*.py``. 
+
+When writing blackbox tests please honour the following conventions:
+
+ 1. Place the tests for the command 'name' in
+    bzrlib/tests/blackbox/test_name.py. This makes it easy for developers
+    to locate the test script for a faulty command.
+
+ 2. Use the 'self.run_bzr("name")' utility function to invoke the command
+    rather than running bzr in a subprocess or invoking the
+    cmd_object.run() method directly. This is a lot faster than
+    subprocesses and generates the same logging output as running it in a
+    subprocess (which invoking the method directly does not).
+ 
+ 3. Only test the one command in a single test script. Use the bzrlib 
+    library when setting up tests and when evaluating the side-effects of
+    the command. We do this so that the library api has continual pressure
+    on it to be as functional as the command line in a simple manner, and
+    to isolate knock-on effects throughout the blackbox test suite when a
+    command changes its name or signature. Ideally only the tests for a
+    given command are affected when a given command is changed.
+
+ 4. If you have a test which does actually require running bzr in a
+    subprocess you can use ``run_bzr_subprocess``. By default the spawned
+    process will not load plugins unless ``--allow-plugins`` is supplied.
+
+
+Doctests
+--------
+
+We make selective use of doctests__.  In general they should provide 
+*examples* within the API documentation which can incidentally be tested.  We 
+don't try to test every important case using doctests -- regular Python
+tests are generally a better solution.
+
+Most of these are in ``bzrlib/doc/api``.  More additions are welcome.
+
+  __ http://docs.python.org/lib/module-doctest.html
+
+
+Skipping tests and test requirements
+------------------------------------
+
+In our enhancements to unittest we allow for some addition results beyond
+just success or failure.
+
+If a test can't be run, it can say that it's skipped.  This is typically
+used in parameterized tests - for example if a transport doesn't support
+setting permissions, we'll skip the tests that relating to that.  ::
+
+    try:
+        return self.branch_format.initialize(repo.bzrdir)
+    except errors.UninitializableFormat:
+        raise tests.TestSkipped('Uninitializable branch format')
+
+Raising TestSkipped is a good idea when you want to make it clear that the
+test was not run, rather than just returning which makes it look as if it
+was run and passed.
+
+Several different cases are distinguished:
+
+TestSkipped
+        Generic skip; the only type that was present up to bzr 0.18.
+
+TestNotApplicable
+        The test doesn't apply to the parameters with which it was run.
+        This is typically used when the test is being applied to all
+        implementations of an interface, but some aspects of the interface
+        are optional and not present in particular concrete
+        implementations.  (Some tests that should raise this currently
+        either silently return or raise TestSkipped.)  Another option is
+        to use more precise parameterization to avoid generating the test
+        at all.
+
+TestPlatformLimit
+        **(Not implemented yet)**
+        The test can't be run because of an inherent limitation of the
+        environment, such as not having symlinks or not supporting
+        unicode.
+
+UnavailableFeature
+        The test can't be run because a dependency (typically a Python
+        library) is not available in the test environment.  These
+        are in general things that the person running the test could fix 
+        by installing the library.  It's OK if some of these occur when 
+        an end user runs the tests or if we're specifically testing in a
+        limited environment, but a full test should never see them.
+
+KnownFailure
+        The test exists but is known to fail, for example because the 
+        code to fix it hasn't been run yet.  Raising this allows 
+        you to distinguish these failures from the ones that are not 
+        expected to fail.  This could be conditionally raised if something
+        is broken on some platforms but not on others.
+
+We plan to support three modes for running the test suite to control the
+interpretation of these results.  Strict mode is for use in situations
+like merges to the mainline and releases where we want to make sure that
+everything that can be tested has been tested.  Lax mode is for use by
+developers who want to temporarily tolerate some known failures.  The
+default behaviour is obtained by ``bzr selftest`` with no options, and
+also (if possible) by running under another unittest harness.
+
+======================= ======= ======= ========
+result                  strict  default lax
+======================= ======= ======= ========
+TestSkipped             pass    pass    pass
+TestNotApplicable       pass    pass    pass
+TestPlatformLimit       pass    pass    pass
+TestDependencyMissing   fail    pass    pass
+KnownFailure            fail    pass    pass
+======================= ======= ======= ========
+     
+
+Test feature dependencies
+-------------------------
+
+Rather than manually checking the environment in each test, a test class
+can declare its dependence on some test features.  The feature objects are
+checked only once for each run of the whole test suite.
+
+For historical reasons, as of May 2007 many cases that should depend on
+features currently raise TestSkipped.)
+
+::
+
+    class TestStrace(TestCaseWithTransport):
+
+        _test_needs_features = [StraceFeature]
+
+This means all tests in this class need the feature.  The feature itself
+should provide a ``_probe`` method which is called once to determine if
+it's available.
+
+These should generally be equivalent to either TestDependencyMissing or
+sometimes TestPlatformLimit.
+
+
+Known failures
+--------------
+
+Known failures are when a test exists but we know it currently doesn't
+work, allowing the test suite to still pass.  These should be used with
+care, we don't want a proliferation of quietly broken tests.  It might be
+appropriate to use them if you've committed a test for a bug but not the
+fix for it, or if something works on Unix but not on Windows.
+
+
+Testing exceptions and errors
+-----------------------------
+
+It's important to test handling of errors and exceptions.  Because this
+code is often not hit in ad-hoc testing it can often have hidden bugs --
+it's particularly common to get NameError because the exception code
+references a variable that has since been renamed.
+
+.. TODO: Something about how to provoke errors in the right way?
+
+In general we want to test errors at two levels:
+
+1. A test in ``test_errors.py`` checking that when the exception object is
+   constructed with known parameters it produces an expected string form.
+   This guards against mistakes in writing the format string, or in the
+   ``str`` representations of its parameters.  There should be one for
+   each exception class.
+
+2. Tests that when an api is called in a particular situation, it raises
+   an error of the expected class.  You should typically use
+   ``assertRaises``, which in the Bazaar test suite returns the exception
+   object to allow you to examine its parameters.  
+
+In some cases blackbox tests will also want to check error reporting.  But
+it can be difficult to provoke every error through the commandline
+interface, so those tests are only done as needed -- eg in response to a
+particular bug or if the error is reported in an unusual way(?)  Blackbox
+tests should mostly be testing how the command-line interface works, so
+should only test errors if there is something particular to the cli in how
+they're displayed or handled.
+
+
+Interface implementation testing and test scenarios
+---------------------------------------------------
+
+There are several cases in Bazaar of multiple implementations of a common 
+conceptual interface.  ("Conceptual" because 
+it's not necessary for all the implementations to share a base class,
+though they often do.)  Examples include transports and the working tree,
+branch and repository classes. 
+
+In these cases we want to make sure that every implementation correctly
+fulfils the interface requirements.  For example, every Transport should
+support the ``has()`` and ``get()`` and ``clone()`` methods.  We have a
+sub-suite of tests in ``test_transport_implementations``.  (Most
+per-implementation tests are in submodules of ``bzrlib.tests``, but not
+the transport tests at the moment.)  
+
+These tests are repeated for each registered Transport, by generating a
+new TestCase instance for the cross product of test methods and transport
+implementations.  As each test runs, it has ``transport_class`` and
+``transport_server`` set to the class it should test.  Most tests don't
+access these directly, but rather use ``self.get_transport`` which returns
+a transport of the appropriate type.
+
+The goal is to run per-implementation only tests that relate to that
+particular interface.  Sometimes we discover a bug elsewhere that happens
+with only one particular transport.  Once it's isolated, we can consider 
+whether a test should be added for that particular implementation,
+or for all implementations of the interface.
+
+The multiplication of tests for different implementations is normally 
+accomplished by overriding the ``test_suite`` function used to load 
+tests from a module.  This function typically loads all the tests,
+then applies a TestProviderAdapter to them, which generates a longer 
+suite containing all the test variations.
+
+
+Test scenarios
+--------------
+
+Some utilities are provided for generating variations of tests.  This can
+be used for per-implementation tests, or other cases where the same test
+code needs to run several times on different scenarios.
+
+The general approach is to define a class that provides test methods,
+which depend on attributes of the test object being pre-set with the
+values to which the test should be applied.  The test suite should then
+also provide a list of scenarios in which to run the tests.
+
+Typically ``multiply_tests_from_modules`` should be called from the test
+module's ``test_suite`` function.
 
 
 Essential Domain Classes
@@ -337,20 +591,62 @@
 the form of URL components.
 
 
+Core Topics
+###########
+
+Evolving Interfaces
+===================
+
+We have a commitment to 6 months API stability - any supported symbol in a
+release of bzr MUST NOT be altered in any way that would result in
+breaking existing code that uses it. That means that method names,
+parameter ordering, parameter names, variable and attribute names etc must
+not be changed without leaving a 'deprecated forwarder' behind. This even
+applies to modules and classes.
+
+If you wish to change the behaviour of a supported API in an incompatible
+way, you need to change its name as well. For instance, if I add an optional keyword
+parameter to branch.commit - that's fine. On the other hand, if I add a
+keyword parameter to branch.commit which is a *required* transaction
+object, I should rename the API - i.e. to 'branch.commit_transaction'. 
+
+When renaming such supported API's, be sure to leave a deprecated_method (or
+_function or ...) behind which forwards to the new API. See the
+bzrlib.symbol_versioning module for decorators that take care of the
+details for you - such as updating the docstring, and issuing a warning
+when the old api is used.
+
+For unsupported API's, it does not hurt to follow this discipline, but it's
+not required. Minimally though, please try to rename things so that
+callers will at least get an AttributeError rather than weird results.
+
+
+Deprecation decorators
+----------------------
+
+``bzrlib.symbol_versioning`` provides decorators that can be attached to
+methods, functions, and other interfaces to indicate that they should no
+longer be used.
+
+To deprecate a static method you must call ``deprecated_function``
+(**not** method), after the staticmethod call::
+
+    @staticmethod
+    @deprecated_function(zero_ninetyone)
+    def create_repository(base, shared=False, format=None):
+
+When you deprecate an API, you should not just delete its tests, because
+then we might introduce bugs in them.  If the API is still present at all,
+it should still work.  The basic approach is to use
+``TestCase.applyDeprecated`` which in one step checks that the API gives
+the expected deprecation message, and also returns the real result from
+the method, so that tests can keep running.
+
 Coding Style Guidelines
-#######################
-
-hasattr and getattr
-===================
-
-``hasattr`` should not be used because it swallows exceptions including
-``KeyboardInterrupt``.  Instead, say something like ::
-
-  if getattr(thing, 'name', None) is None
-
+=======================
 
 Code layout
-===========
+-----------
 
 Please write PEP-8__ compliant code.  
 
@@ -439,7 +735,7 @@
 
 
 Module Imports
-==============
+--------------
 
 * Imports should be done at the top-level of the file, unless there is
   a strong reason to have them lazily loaded when a particular
@@ -451,7 +747,7 @@
 
 
 Naming
-======
+------
 
 Functions, methods or members that are "private" to bzrlib are given
 a leading underscore prefix.  Names without a leading underscore are
@@ -474,7 +770,7 @@
 
 
 Standard Names
-==============
+--------------
 
 ``revision_id`` not ``rev_id`` or ``revid``
 
@@ -483,7 +779,7 @@
 
 
 Destructors
-===========
+-----------
 
 Python destructors (``__del__``) work differently to those of other
 languages.  In particular, bear in mind that destructors may be called
@@ -491,9 +787,7 @@
 later time, or possibly never at all.  Therefore we have restrictions on
 what can be done inside them.
 
- 0. If you think you need to use a ``__del__`` method ask another
-    developer for alternatives.  If you do need to use one, explain
-    why in a comment.
+ 0. Never use a __del__ method without asking Martin/Robert first.
 
  1. Never rely on a ``__del__`` method running.  If there is code that
     must run, do it from a ``finally`` block instead.
@@ -507,7 +801,7 @@
 
 
 Factories
-=========
+---------
 
 In some places we have variables which point to callables that construct
 new instances.  That is to say, they can be used a lot like class objects,
@@ -522,7 +816,7 @@
 
 
 Registries
-==========
+----------
 
 Several places in Bazaar use (or will use) a registry, which is a 
 mapping from names to objects or classes.  The registry allows for 
@@ -530,31 +824,8 @@
 associated information such as a help string or description.
 
 
-InterObject and multiple dispatch
-=================================
-
-The ``InterObject`` provides for two-way `multiple dispatch`__: matching
-up for example a source and destination repository to find the right way
-to transfer data between them. 
-
-.. __: http://en.wikipedia.org/wiki/Multiple_dispatch
-
-There is a subclass ``InterObject`` classes for each type of object that is
-dispatched this way, e.g. ``InterRepository``.  Calling ``.get()`` on this
-class will return an ``InterObject`` instance providing the best match for 
-those parameters, and this instance then has methods for operations
-between the objects.
-
-  inter = InterRepository.get(source_repo, target_repo)
-  inter.fetch(revision_id)
-
-``InterRepository`` also acts as a registry-like object for its
-subclasses, and they can be added through ``.register_optimizer``.  The
-right one to run is selected by asking each class, in reverse order of
-registration, whether it ``.is_compatible`` with the relevant objects.
-
 Lazy Imports
-============
+------------
 
 To make startup time faster, we use the ``bzrlib.lazy_import`` module to
 delay importing modules until they are actually used. ``lazy_import`` uses
@@ -584,6 +855,10 @@
 the variable is a module, and these object should be hidden anyway, since
 they shouldn't be imported into other namespaces.
 
+
+Modules versus Members
+~~~~~~~~~~~~~~~~~~~~~~
+
 While it is possible for ``lazy_import()`` to import members of a module
 when using the ``from module import member`` syntax, it is recommended to
 only use that syntax to load sub modules ``from module import submodule``.
@@ -600,6 +875,10 @@
 This will incorrectly fail, because ``MyClass`` is a ``ImportReplacer``
 object, rather than the real class.
 
+
+Passing to Other Variables
+~~~~~~~~~~~~~~~~~~~~~~~~~~
+
 It also is incorrect to assign ``ImportReplacer`` objects to other variables.
 Because the replacer only knows about the original name, it is unable to
 replace other variables. The ``ImportReplacer`` class will raise an
@@ -609,7 +888,7 @@
 
 
 The Null revision
-=================
+-----------------
 
 The null revision is the ancestor of all revisions.  Its revno is 0, its
 revision-id is ``null:``, and its tree is the empty tree.  When referring
@@ -618,123 +897,6 @@
 being phased out.
 
 
-Object string representations
-=============================
-
-Python prints objects using their ``__repr__`` method when they are
-written to logs, exception tracebacks, or the debugger.  We want
-objects to have useful representations to help in determining what went
-wrong.
-
-If you add a new class you should generally add a ``__repr__`` method
-unless there is an adequate method in a parent class.  There should be a
-test for the repr.  
-
-Representations should typically look like Python constructor syntax, but
-they don't need to include every value in the object and they don't need
-to be able to actually execute.  They're to be read by humans, not
-machines.  Don't hardcode the classname in the format, so that we get the
-correct value if the method is inherited by a subclass.  If you're
-printing attributes of the object, including strings, you should normally
-use ``%r`` syntax (to call their repr in turn).
-
-Try to avoid the representation becoming more than one or two lines long.
-(But balance this against including useful information, and simplicity of
-implementation.)
-
-Because repr methods are often called when something has already gone
-wrong, they should be written somewhat more defensively than most code.
-The object may be half-initialized or in some other way in an illegal
-state.  The repr method shouldn't raise an exception, or it may hide the
-(probably more useful) underlying exception.
-
-Example::
-
-    def __repr__(self):
-        return '%s(%r)' % (self.__class__.__name__,
-                           self._transport)
-
-
-Exception handling
-==================
-
-A bare ``except`` statement will catch all exceptions, including ones that
-really should terminate the program such as ``MemoryError`` and
-``KeyboardInterrupt``.  They should rarely be used unless the exception is
-later re-raised.  Even then, think about whether catching just
-``Exception`` (which excludes system errors in Python2.5 and later) would
-be better.
-
-
-Test coverage
-=============
-
-All code should be exercised by the test suite.  See `Guide to Testing
-Bazaar <testing.html>`_ for detailed information about writing tests.
-
-
-Core Topics
-###########
-
-Evolving Interfaces
-===================
-
-We have a commitment to 6 months API stability - any supported symbol in a
-release of bzr MUST NOT be altered in any way that would result in
-breaking existing code that uses it. That means that method names,
-parameter ordering, parameter names, variable and attribute names etc must
-not be changed without leaving a 'deprecated forwarder' behind. This even
-applies to modules and classes.
-
-If you wish to change the behaviour of a supported API in an incompatible
-way, you need to change its name as well. For instance, if I add an optional keyword
-parameter to branch.commit - that's fine. On the other hand, if I add a
-keyword parameter to branch.commit which is a *required* transaction
-object, I should rename the API - i.e. to 'branch.commit_transaction'. 
-
-When renaming such supported API's, be sure to leave a deprecated_method (or
-_function or ...) behind which forwards to the new API. See the
-bzrlib.symbol_versioning module for decorators that take care of the
-details for you - such as updating the docstring, and issuing a warning
-when the old api is used.
-
-For unsupported API's, it does not hurt to follow this discipline, but it's
-not required. Minimally though, please try to rename things so that
-callers will at least get an AttributeError rather than weird results.
-
-
-Deprecation decorators
-----------------------
-
-``bzrlib.symbol_versioning`` provides decorators that can be attached to
-methods, functions, and other interfaces to indicate that they should no
-longer be used.  For example::
-
-   @deprecated_method(deprecated_in((0, 1, 4)))
-   def foo(self):
-        return self._new_foo()
-
-To deprecate a static method you must call ``deprecated_function``
-(**not** method), after the staticmethod call::
-
-    @staticmethod
-    @deprecated_function(deprecated_in((0, 1, 4)))
-    def create_repository(base, shared=False, format=None):
-
-When you deprecate an API, you should not just delete its tests, because
-then we might introduce bugs in them.  If the API is still present at all,
-it should still work.  The basic approach is to use
-``TestCase.applyDeprecated`` which in one step checks that the API gives
-the expected deprecation message, and also returns the real result from
-the method, so that tests can keep running.
-
-Deprecation warnings will be suppressed for final releases, but not for
-development versions or release candidates, or when running ``bzr
-selftest``. This gives developers information about whether their code is
-using deprecated functions, but avoids confusing users about things they
-can't fix.
-
-
 Getting Input
 =============
 
@@ -813,6 +975,118 @@
 sentences.
 
 
+Writing tests
+=============
+
+In general tests should be placed in a file named test_FOO.py where 
+FOO is the logical thing under test. That file should be placed in the
+tests subdirectory under the package being tested.
+
+For example, tests for merge3 in bzrlib belong in bzrlib/tests/test_merge3.py.
+See bzrlib/tests/test_sampler.py for a template test script.
+
+Tests can be written for the UI or for individual areas of the library.
+Choose whichever is appropriate: if adding a new command, or a new command 
+option, then you should be writing a UI test.  If you are both adding UI
+functionality and library functionality, you will want to write tests for 
+both the UI and the core behaviours.  We call UI tests 'blackbox' tests
+and they are found in ``bzrlib/tests/blackbox/*.py``. 
+
+When writing blackbox tests please honour the following conventions:
+
+ 1. Place the tests for the command 'name' in
+    bzrlib/tests/blackbox/test_name.py. This makes it easy for developers
+    to locate the test script for a faulty command.
+
+ 2. Use the 'self.run_bzr("name")' utility function to invoke the command
+    rather than running bzr in a subprocess or invoking the
+    cmd_object.run() method directly. This is a lot faster than
+    subprocesses and generates the same logging output as running it in a
+    subprocess (which invoking the method directly does not).
+ 
+ 3. Only test the one command in a single test script. Use the bzrlib 
+    library when setting up tests and when evaluating the side-effects of
+    the command. We do this so that the library api has continual pressure
+    on it to be as functional as the command line in a simple manner, and
+    to isolate knock-on effects throughout the blackbox test suite when a
+    command changes its name or signature. Ideally only the tests for a
+    given command are affected when a given command is changed.
+
+ 4. If you have a test which does actually require running bzr in a
+    subprocess you can use ``run_bzr_subprocess``. By default the spawned
+    process will not load plugins unless ``--allow-plugins`` is supplied.
+
+
+Test support
+------------
+
+We have a rich collection of tools to support writing tests. Please use
+them in preference to ad-hoc solutions as they provide portability and
+performance benefits.
+
+TreeBuilder
+~~~~~~~~~~~
+
+The ``TreeBuilder`` interface allows the construction of arbitrary trees
+with a declarative interface. A sample session might look like::
+
+  tree = self.make_branch_and_tree('path')
+  builder = TreeBuilder()
+  builder.start_tree(tree)
+  builder.build(['foo', "bar/", "bar/file"])
+  tree.commit('commit the tree')
+  builder.finish_tree()
+
+Please see bzrlib.treebuilder for more details.
+
+BranchBuilder
+~~~~~~~~~~~~~
+
+The ``BranchBuilder`` interface allows the creation of test branches in a
+quick and easy manner. A sample session::
+
+  builder = BranchBuilder(self.get_transport().clone('relpath'))
+  builder.build_commit()
+  builder.build_commit()
+  builder.build_commit()
+  branch = builder.get_branch()
+
+Please see bzrlib.branchbuilder for more details.
+
+Doctests
+--------
+
+We make selective use of doctests__.  In general they should provide 
+*examples* within the API documentation which can incidentally be tested.  We 
+don't try to test every important case using doctests -- regular Python
+tests are generally a better solution.
+
+Most of these are in ``bzrlib/doc/api``.  More additions are welcome.
+
+  __ http://docs.python.org/lib/module-doctest.html
+
+
+Running tests
+=============
+Currently, bzr selftest is used to invoke tests.
+You can provide a pattern argument to run a subset. For example, 
+to run just the blackbox tests, run::
+
+  ./bzr selftest -v blackbox
+
+To skip a particular test (or set of tests), use the --exclude option
+(shorthand -x) like so::
+
+  ./bzr selftest -v -x blackbox  
+
+To list tests without running them, use the --list-only option like so::
+
+  ./bzr selftest --list-only
+
+This option can be combined with other selftest options (like -x) and
+filter patterns to understand their effect.
+
+
 Handling Errors and Exceptions
 ==============================
 
@@ -865,36 +1139,6 @@
 final fullstop.  If long, they may contain newlines to break the text.
 
 
-Assertions
-==========
-
-Do not use the Python ``assert`` statement, either in tests or elsewhere.
-A source test checks that it is not used.  It is ok to explicitly raise
-AssertionError.
-
-Rationale:
-
- * It makes the behaviour vary depending on whether bzr is run with -O
-   or not, therefore giving a chance for bugs that occur in one case or
-   the other, several of which have already occurred: assertions with
-   side effects, code which can't continue unless the assertion passes,
-   cases where we should give the user a proper message rather than an
-   assertion failure.
- * It's not that much shorter than an explicit if/raise.
- * It tends to lead to fuzzy thinking about whether the check is
-   actually needed or not, and whether it's an internal error or not
- * It tends to cause look-before-you-leap patterns.
- * It's unsafe if the check is needed to protect the integrity of the
-   user's data.
- * It tends to give poor messages since the developer can get by with
-   no explanatory text at all.
- * We can't rely on people always running with -O in normal use, so we
-   can't use it for tests that are actually expensive.
- * Expensive checks that help developers are better turned on from the
-   test suite or a -D flag.
- * If used instead of ``self.assert*()`` in tests it makes them falsely pass with -O.
-
-
 Documenting Changes
 ===================
 
@@ -1163,7 +1407,7 @@
 * reviewing changes
 * reviewing blueprints
 * planning releases
-* managing releases (see the `Releasing Bazaar <../../developers/releasing.html>`_)
+* managing releases.
 
 .. note::
   Removing barriers to community participation is a key reason for adopting
@@ -1174,6 +1418,28 @@
   differences between core and non-core contributors to a minimum.
 
 
+The Development Lifecycle
+-------------------------
+
+As a rule, Bazaar development follows a 4 week cycle:
+
+* 2 weeks - general changes
+* 1 week - feature freeze
+* 1 week+ - Release Candidate stabilization
+
+During the FeatureFreeze week, the trunk (bzr.dev) is open in a limited
+way: only low risk changes, critical and high priority fixes are accepted
+during this time. At the end of FeatureFreeze, a branch is created for the
+first Release Candidate and the trunk is reopened for general development
+on the *next* release. A week or so later, the final release is packaged
+assuming no serious problems were encountered with the one or more Release
+Candidates.
+
+.. note::
+  There is a one week overlap between the start of one release and
+  the end of the previous one.
+
+
 Communicating and Coordinating
 ------------------------------
 
@@ -1454,8 +1720,53 @@
 .. note::
   As well as prioritizing bugs and nominating them against a
   target milestone, Launchpad lets core developers offer to mentor others in
-  fixing them. 
-
+  fixing them. Nice.
+
+
+Managing a Release
+==================
+
+Starting a Release
+------------------
+
+TODO: Things to cover:
+
+* RFI on release objectives
+* RFI on higher risk things that are best done early, e.g. changes to file
+  format defaults
+* Communication of proposed dates
+
+
+Weekly Status Updates
+---------------------
+
+TODO: Things to cover:
+
+* Early communication to downstream teams (e.g. Launchpad) about changes in dependencies.
+* Reminder re lifecycle and where we're up to right now
+* Summary of recent successes and pending work
+* Reminder re release objectives
+* Reminder re things needing attention, e.g. bug triage, reviews, testing of certain things, etc.
+
+
+Feature Freeze
+--------------
+
+TODO: Get material from http://bazaar-vcs.org/FeatureFreeze.
+
+
+Release Candidates
+------------------
+
+TODO: Get material from http://bazaar-vcs.org/ReleaseChecklist and clean
+it up to make it clearer what the RC vs final vs both tasks are.
+
+
+The Final Release
+-----------------
+
+TODO: Get material from http://bazaar-vcs.org/ReleaseChecklist and clean
+it up to make it clearer what the RC vs final vs both tasks are.
 
 ..
    vim: ft=rst tw=74 ai

=== modified file 'doc/developers/authentication-ring.txt'
--- doc/developers/authentication-ring.txt	2008-05-09 16:40:21 +0000
+++ doc/developers/authentication-ring.txt	2007-11-04 15:24:27 +0000
@@ -63,9 +63,9 @@
 
 Note that ssh servers can be configured to use keys instead of (``user``,
 ``password``) and, when used with appropriate agents, provide the same kind of
-comfort this specification aims to provide for all other schemes. Since ssh
-agents provide a safer way to secure the passwords, this specification is
-restricted to providing ``user`` but does not provide ``password``.
+comfort this specification aims to provide for all other schemes. These
+specification do not try to cover these configurations by providing
+pass-phrases, but the mechanisms presented *can* be used to provide users.
 
 Authentication definitions
 --------------------------
@@ -120,8 +120,7 @@
   * ``password``: can be empty (for security reasons, a user may use the
     definitions without storing the passwords but want to be prompted ; or the
     password will be provided by an external plugin via the
-    ``password_encoding`` mechanism decribed below). Must be left empty for
-    ``ssh``.
+    ``password_encoding`` mechanism decribed below).
 
   * ``password_encoding``: can be empty (default is ``plaintext``).
 

=== modified file 'doc/developers/bundles.txt'
--- doc/developers/bundles.txt	2007-12-05 19:55:07 +0000
+++ doc/developers/bundles.txt	2007-08-02 10:28:36 +0000
@@ -81,5 +81,5 @@
 the Branch level to gain access to that.
 
 
-..
    vim: ft=rst tw=74 ai
+

=== removed file 'doc/developers/development-repo.txt'
--- doc/developers/development-repo.txt	2008-08-28 06:26:43 +0000
+++ doc/developers/development-repo.txt	1970-01-01 00:00:00 +0000
@@ -1,243 +0,0 @@
-==============================
-Development repository formats
-==============================
-
-.. contents::
-
-Using development repository formats
-====================================
-
-Motivation
-----------
-
-We believe that we can continue to gain substantial performance benefits
-by altering the repository storage in bzr. The more feedback we can get
-on the changes during the development process the better.
-
-To make it possible to get more feedback we are going to expose the
-current development formats to the users of our development trunk
-'bzr.dev'. The technical details of the individual formats are at the
-end of this document.
-
-Format names
-------------
-
-The current development format will be called 'development'. Each time
-the development format changes, the prior development format will be
-renamed to e.g. 'development0', 'development1' etc.
-
-When a release of bzr is done, all the older numbered development
-formats will be removed from 'bzr.dev', so we will not be carrying the
-code for them around indefinately. 
-
-Support for upgrade and migration
----------------------------------
-
-The preservation and renaming policy makes it quite safe for users to
-test out development formats (though we cannot guarantee bugs of course
-- it is development code):
-
- - users of a given development format can always get back onto regular
-   formats by switching to the next bzr released version which is
-   guaranteed to be able to upgrade from that development format.
- - users that routinely use bzr.dev should upgrade to the most recent 
-   development version available before pulling in bzr.dev changes
-   around release time, as that is when old format cleanups will occur.
-
-We cannot guarantee backwards compatability though, because some of the
-planned work may be 'upgrade only'. Please see ``bzr help formats`` for
-the text of the 'development' format which will indicate its
-compatability with other formats if you need to interoperate with
-users or services that do not have bzr.dev.
-
-Before converting to a development format
------------------------------------------
-
-Run a ``bzr check`` with the version of bzr that you will be using.
-``bzr check`` gets updated as we find new things that are inconsistent
-with existing repositories. While only a small number of repositories
-are likely to have any given error, it is best to check just in case.
-
-If ``bzr check`` reports a problem, run this command::
-
-  bzr reconcile
-
-Note that reconcile can take many hours, particularly if you are
-reconciling one of the 'knit' or 'dirstate' format repositories. If you
-have such a repository, consider upgrading it to 'pack-0.92' first,
-which will perform reconcile significantly faster.
-
-Creating a new development format branch
-----------------------------------------
-
-If you're starting a project from scratch, it's easy to make it a
-``development`` one. Here's how::
-
-  cd my-stuff
-  bzr init --development
-  bzr add
-  bzr commit -m "initial import"
-
-In other words, use the normal sequence of commands but add the
-``--development`` option to the ``init`` command.
-
-
-Creating a new development format repository
---------------------------------------------
-
-If you're starting a project from scratch and wish to use a shared repository
-for branches, you can make it a ``development`` repository like this::
-
-  cd my-repo
-  bzr init-repo --development .
-  cd my-stuff
-  bzr init
-  bzr add
-  bzr commit -m "initial import"
-
-In other words, use the normal sequence of commands but add the
-``--development`` option to the ``init-repo`` command.
-
-Upgrading an existing branch or repository to development
----------------------------------------------------------
-
-If you have an existing branch and wish to migrate it to
-a ``development`` format, use the ``upgrade`` command like this::
-
-  bzr upgrade --development path-to-my-branch
-
-If you are using a shared repository, run::
-
-  bzr upgrade --development ROOT_OF_REPOSITORY
-
-to upgrade the history database. Note that this will not
-alter the branch format of each branch, so
-you will need to also upgrade each branch individually
-if you are upgrading from an old (e.g. < 0.17) bzr.
-More modern bzr's will already have the branch format at
-our latest branch format which adds support for tags.
-
-Starting a new development format branch from one in an older format
---------------------------------------------------------------------
-
-This can be done in one of several ways:
-
-1. Create a new branch and pull into it
-2. Create a standalone branch and upgrade its format
-3. Create a knitpack shared repository and branch into it
-
-Here are the commands for using the ``pull`` approach::
-
-    bzr init --development my-new-branch
-    cd my-new-branch
-    bzr pull my-source-branch
-
-Here are the commands for using the ``upgrade`` approach::
-
-    bzr branch my-source-branch my-new-branch
-    cd my-new-branch
-    bzr upgrade --development .
-
-Here are the commands for the shared repository approach::
-
-  cd my-repo
-  bzr init-repo --development .
-  bzr branch my-source-branch my-new-branch
-  cd my-new-branch
-
-As a reminder, any of the above approaches can fail if the source branch
-has inconsistent data within it and hasn't been reconciled yet. Please
-be sure to check that before reporting problems.
-
-Develoment formats for bzr-svn users
-------------------------------------
-
-If you are using ``bzr-svn`` or are testing the prototype subtree support,
-you can still use and assist in testing the development formats. The
-commands to use are identical to the ones given above except that the
-name of the format to use is ``development-subtree``.
-
-**WARNING**: Note that bzr only supports one-way conversion **to** the
-subtree format ``development-subtree``. Once you are using
-``development-subtree`` you cannot pull or merge back into a regular
-format such as ``pack-0.92``, ``development`` etc.
-
-The ``development-subtree`` format is required for the bzr-svn
-plug-in but should otherwise not be used until the subtree feature is
-complete within bzr.
-
-Reporting problems
-------------------
-
-If you need any help or encounter any problems, please contact the developers
-via the usual ways, i.e. chat to us on IRC or send a message to our mailing
-list. See http://bazaar-vcs.org/BzrSupport for contact details.
-
-
-Technical notes
-===============
-
-When to create a new development format
----------------------------------------
-
-Whenever a code change will result in incorrect behaviour with existing
-``development`` repositories. Changes in push/pull/init/commit/merge
-have all been known to do this in the past.
-
-How to create a new development format
---------------------------------------
-
-1. Register two new formats with the next available sequence number.
-   e.g. ``development1`` and ``development1-subtree``. (You can see the
-   current development format for an example.
-   These should:
-
-   * Use your new development repository/branch/tree classes
-   * Have really bare bones help - something like 'changes X to be Y
-     see ...developers/development-repo.html'
-   * Be hidden and experimental.
-2. Change the repository class (or branch or tree) in the
-   ``development`` and ``development-subtree`` formats to point to the
-   new class you are creating.
-3. Add a new development format (and tests!). Repository formats are in
-   ``bzrlib.repofmt``. You probably want to reproduce the current
-   development format from ``bzrlib.repofmt.pack_repo`` with just new
-   disk format strings, ``_get_matching_bzrdir`` and help.
-4. Alter any other things that do class based tests. The easiest way
-   to find these is a grep for Development in bzrlib - and please
-   refactor as you find these to reduce the relevance this step has,
-   as it should not need to exist.
-5. Now subclass/create from scratch/whatever the live object code you
-   need to change to introduce your new format. Keep in mind that
-   eventually it will become the default format, so please don't keep
-   subclassing the last releases code, rather consider making the last
-   releases code a subclass of your new code (if there is a lot in
-   common) so that we can eventually remove that format once it becomes
-   ancient (or relegate it to a plugin).
-6. Once you have made the changes that required a new disk format, you
-   should submit the resulting branch to be merged. Other changes - to
-   take advantage of whatever new feature you have added - should be
-   sent in separately, because the disk level changes are a contention
-   point between multiple developers.
-
-Format Details
-==============
-
-development
------------
-
-Currently an alias for Development1
-
-development-subtree
--------------------
-
-Currently an alias for Development1Subtree
-
-Development1[Subtree]
----------------------
-
-These formats were introduced during the development of branch stacking.
-
-
-..
-   vim: tw=72 ft=rst expandtab

=== modified file 'doc/developers/index.txt'
--- doc/developers/index.txt	2008-08-28 07:11:13 +0000
+++ doc/developers/index.txt	2007-08-13 10:20:11 +0000
@@ -2,37 +2,12 @@
 Bazaar Developer Document Catalog
 =================================
 
-Bazaar user documentation is in the 
-`Main Document Catalog <../index.html>`_.
-
-Overall developer documentation
-===============================
-
-* `Developer Guide <../en/developer-guide/HACKING.html>`_
-
-* `bzrlib API reference <http://starship.python.net/crew/mwh/bzrlibapi-oe/>`_ 
-  (external link)
-  |--| automatically generated API reference information
-
-* `Integrating with Bazaar <http://bazaar-vcs.org/Integrating_with_Bazaar>`_
-  (wiki) |--| a guide for writing Python programs that work with Bazaar.
-
-* `Testing <testing.html>`_ |--| Testing bzr.
-
-* `Writing plugins <http://bazaar-vcs.org/WritingPlugins>`_ (wiki) 
-  |--| specific advice on writing Bazaar plugins.
+See the `Main Document Catalog <../index.html>`_ for additional documents
+including the Bazaar Developer Guide and bzrlib API reference.
 
 Process
 =======
 
-* `Releasing Bazaar <releasing.html>`_ |--| How to make a release of Bazaar,
-  and how to coordinate the monthly development cycle.
-
-* `Managing the Bazaar PPA <ppa.html>`_ |--| Packaging Bazaar for Ubuntu.
-
-* `Giving back <http://bazaar-vcs.org/BzrGivingBack>`_ (wiki) |--| How to get
-  your changes to Bazaar integrated into a release.
-
 * `Profiling notes <profiling.html>`_ |--| Instructions on how to profile 
   bzr code and visualize the results.
 
@@ -47,40 +22,14 @@
 
 * `API versioning <api-versioning.html>`_ |--| bzrlib API versioning.
 
-* `Authentication ring <authentication-ring.html>`_ |--| Configuring
-  authentication.
-
 * `Bundles <bundles.html>`_ |--| All about bzr bundles.
 
 * `Container format <container-format.html>`_ |--| Notes on a container format
   for streaming and storing Bazaar data.
 
-* `Repository stream <repository-stream.html>`_ |--| Notes on streaming data
-  for repositories (a layer above the container format).
-
 * `Indices <indices.html>`_ |--| The index facilities available within bzrlib.
 
-* `Inventories <inventory.html>`_ |--| Tree shape abstraction.
-
-* `LCA merge <lca-merge.html>`_ |--| A nice new merge algorithm.
-
-* `Network protocol <network-protocol.html>`_ |--| Custom network protocol.
-
-* `Plugin APIs <plugin-api.html>`_ |--| APIs plugins should use.
-
 * `Repositories <repository.html>`_ |--| What repositories do and are used for.
 
-* `Integration Guide <integration.html>`_ |--| A guide to integrate bzrlib into
-  any python application.
-
-Data formats
-============
-
-* `Knit pack repositories <packrepo.html>`_ |--| KnitPack repositories 
-  (new in Bazaar 0.92).
-
 
 .. |--| unicode:: U+2014
-
-..
-   vim: ft=rst tw=74 ai

=== removed file 'doc/developers/integration.txt'
--- doc/developers/integration.txt	2008-04-08 10:55:41 +0000
+++ doc/developers/integration.txt	1970-01-01 00:00:00 +0000
@@ -1,304 +0,0 @@
-=======================
-Integrating with Bazaar
-=======================
-
-This page should hopefully become a quick guide to integrating other
-(Python-based) software with Bazaar.
-
-Manipulating the Working Tree
-=============================
-Most objects in Bazaar are in files, named after the class they contain.
-To manipulate the Working Tree we need a valid WorkingTree object, which
-is loaded from the workingtree.py file, eg::
-
-  from bzrlib import workingtree
-  wt = workingtree.WorkingTree.open('/home/jebw/bzrtest')
-
-
-This gives us a WorkingTree object, which has various methods spread over
-itself, and its parent classes MutableTree and Tree - its worth having a
-look through these three files (workingtree.py, mutabletree.py and tree.py)
-to see which methods are available.
-
-Compare trees
-===============
-There are two methods for comparing trees: ``changes_from`` and
-``iter_changes``.  ``iter_changes`` is more regular and precise, but it is
-somewhat harder to work with.  See the API documentation for more details.
-
-``changes_from`` creates a Delta object showing changes::
-
-  from bzrlib import delta
-  changes = wt.changes_from(wt.basis_tree())
-
-This gives us a Delta object, which has several lists of files for each type of
-change, eg changes.added is a list of added files, changes.removed is list
-of removed files, changes.modified is a list of modified files. The contents
-of the lists aren't just filenames, but include other information as well.
-To grab just the filename we want the first value, eg::
-
-  print("list of newly added files")
-  for filename in changes.added:
-    print("%s has been added" % filename[0])
-
-
-The exception to this is changes.renamed, where the list returned for each
-renamed files contains both the old and new names -- one or both may interest
-you, depending on what you're doing.
-
-For example::
-
-  print("list of renamed files")
-  for filename in changes.renamed:
-    print("%s has been renamed to %s" % (filename[0], filename[1]))
-
-
-Adding Files
-============
-
-If you want to add files the same way ``bzr add`` does, you can use
-MutableTree.smart_add.  By default, this is recursive. Paths can either be
-absolute or relative to the workingtree::
-
-  wt.smart_add(['dir1/filea.txt', 'fileb.txt',
-                '/home/jebw/bzrtesttree/filec.txt'])
-
-
-For more precise control over which files to add, use MutableTree.add::
-
-  wt.add(['dir1/filea.txt', 'fileb.txt', '/home/jebw/bzrtesttree/filec.txt'])
-
-
-Removing Files
-==============
-
-You can remove multiple files at once.  The file paths need to be relative
-to the workingtree::
-
-  wt.remove(['filea.txt', 'fileb.txt', 'dir1'])
-
-
-By default, the files are not deleted, just removed from the inventory.
-To delete them from the filesystem as well::
-
-  wt.remove(['filea.txt', 'fileb.txt', 'dir1'], keep_files=False)
-
-
-Renaming a File
-===============
-
-You can rename one file to a different name using WorkingTree.rename_one.
-You just provide the old and new names, eg::
-
-  wt.rename_one('oldfile.txt','newfile.txt')
-
-
-Moving Files
-============
-
-You can move multiple files from one directory into another using
-WorkingTree.move::
-
-  wt.move(['olddir/file.txt'], 'newdir')
-
-
-More complicated renames/moves can be done with transform.TreeTransform,
-which is outside the scope of this document.
-
-
-Committing Changes
-==================
-
-To commit _all_ the changes to our working tree we can just call the
-WorkingTree's commit method, giving it a commit message, eg::
-
-  wt.commit('this is my commit message')
-
-
-To commit only certain files, we need to provide a list of filenames which we
-want committing, eg::
-
-  wt.commit(message='this is my commit message', specific_files=['fileA.txt',
-            'dir2/fileB.txt', 'fileD.txt'])
-
-
-Generating a Log for a File
-===========================
-
-Generating a log is, in itself, simple.  Grab a branch (see below) and pass
-it to show_log together with a log formatter, eg::
-
-  from bzrlib import log
-  from bzrlib import branch
-
-  b = branch.Branch.open('/path/to/bazaar/branch')
-  lf = log.LongLogFormatter(to_file=sys.stdout)
-  log.show_log(b, lf)
-
-
-Three log formatters are included with bzrlib: LongLogFormatter,
-ShortLogFormatter and LineLogFormatter.  These provide long, short and
-single-line log output formats. It's also possible to write your own in
-very little code.
-
-Annotating a File
-=================
-
-To annotate a file, we want to walk every line of a file, retrieving the
-revision which last modified/created that line and then retrieving the
-information for that revision.
-
-First we get an annotation iterator for the file we are interested in::
-
-  tree, relpath = workingtree.WorkingTree.open_containing('/path/to/file.txt')
-  fileid = tree.path2id(relpath)
-  annotation = list(tree.annotate_iter(fileid))
-
-
-To avoid repeatedly retrieving the same revisions we grab all revisions
-associated with the file at once and build up a map of id to revision
-information. We also build an map of revision numbers, again indexed
-by the revision id::
-
-  revision_ids = set(revision_id for revision_id, text in annotation)
-  revisions = tree.branch.repository.get_revisions(revision_ids)
-  revision_map = dict(izip(revision_ids, revisions))
-  revno_map = tree.branch.get_revision_id_to_revno_map()
-
-
-Finally, we use our annotation iterator to walk the lines of the file,
-displaying the information from our revision maps as we go::
-
-  for revision_id, text in annotation :
-      rev = revision_map[revision_id]
-      revno = revno_map[revision_id]
-      revno_string = '.'.join(str(i) for i in revno)
-      print "%s, %s: %s" % (revno_string, rev.committer, text)
-
-
-Working with branches
-=====================
-
-To work with a branch you need a branch object, created from your branch::
-
-  from bzrlib import branch
-
-  b = branch.Branch.open('/home/jebw/bzrtest')
-
-
-Branching from an existing branch
-=================================
-
-To branch you create a branch object representing the branch you are
-branching from, and supply a path/url to the new branch location.
-The following code clones the bzr.dev branch (the latest copy of the Bazaar
-source code) - be warned it has to download 60meg so takes a while to run
-with no feedback::
-
-  from bzrlib import branch
-
-  b = branch.Branch.open('http://bazaar-vcs.org/bzr/bzr.dev')
-  nb = b.bzrdir.sprout('/tmp/newBzrBranch').open_branch()
-
-
-This provides no feedback, since Bazaar automatically uses the 'silent' UI.
-
-
-Pushing and pulling branches
-============================
-
-To push a branch you need to open the source and destination branches, then
-just call push with the other branch as a parameter::
-
-  from bzrlib import branch
-
-  b1 = branch.Branch.open('file:///home/user/mybranch')
-  b2 = branch.Branch.open('http://bazaar-vcs.org/bzr/bzr.dev')
-  b1.push(b2)
-
-
-Pulling is much the same::
-
-  b1.pull(b2)
-
-
-If you have a working tree, as well as a branch, you should use
-WorkingTree.pull, not Branch.pull.
-
-This won't handle conflicts automatically though, so any conflicts will be
-left in the working tree for the user to resolve.
-
-
-Checkout from an existing branch
-================================
-
-This performs a Lightweight checkout from an existing Branch::
-
-  from bzrlib import bzrdir
-
-  accelerator_tree, source = bzrdir.BzrDir.open_tree_or_branch('http:URL')
-  source.create_checkout('/tmp/newBzrCheckout', None, True, accelerator_tree)
-
-
-To make a heavyweight checkout, change the last line to::
-
-  source.create_checkout('/tmp/newBzrCheckout', None, False, accelerator_tree
-
-==================
-History Operations
-==================
-
-Finding the last revision number or id
-======================================
-
-To get the last revision number and id of a branch use::
-
-  revision_number, revision_id = branch.last_revision_info()
-
-
-If all you care about is the revision_id there is also the
-method::
-
-  revision_id = branch.last_revision()
-
-
-Getting the list of revision ids that make up a branch
-======================================================
-
-IMPORTANT: This should be avoided wherever possible, as it scales with the
-length of history::
-
-  revisions = branch.revision_history()
-
-now revisions[0] is the revision id of the first commit, and revs[-1] is the
-revision id of the most recent. Note that if all you want is the last
-revision then you should use branch.last_revision() as described above, as
-it is vastly more efficient.
-
-
-Getting a Revision object from a revision id
-============================================
-
-The Revision object has attributes like "message" to get the information
-about the revision::
-
-  repo = branch.repository
-  revision = repo.get_revision(rev_id)
-
-
-Accessing the files from a revision
-===================================
-
-To get the file contents and tree shape for a specific revision you need
-a RevisionTree. These are supplied by the repository for a specific
-revision id::
-
-  revtree = repo.revision_tree(rev_id)
-
-RevisionTrees, like all trees, can be compared as described in "Comparing
-Trees" above.
-
-The most common way to list files in a tree is ``Tree.iter_entries()``.
-The simplest way to get file content is ``Tree.get_file()``.  The best way
-to retrieve file content for large numbers of files `Tree.iter_files_bytes()``
-

=== removed file 'doc/developers/inventory.txt'
--- doc/developers/inventory.txt	2008-01-03 01:40:16 +0000
+++ doc/developers/inventory.txt	1970-01-01 00:00:00 +0000
@@ -1,47 +0,0 @@
-===========
-Inventories
-===========
-
-.. contents::
-
-Overview
-========
-
-Inventories provide an abstraction for talking about the shape of a tree.
-Generally only tree object implementors should be concerned about inventories.
-
-In memory inventories
-=====================
-
-In memory inventories are often used in diff and status operations between
-trees. We are working to reduce the number of times this occurs with 'full
-tree' inventory objects, and instead use more custom tailored data structures
-that allow operations on only a small amount of data regardless of the size of
-the tree.
-
-
-Serialization
-=============
-
-There are several variants of serialised tree shape in use by bzr. To date
-these have been mostly xml based, though plugins have offered non-xml versions.
-
-dirstate
---------
-
-The dirstate file in a working tree includes many different tree shapes - one
-for the working tree and one for each parent tree, interleaved to allow
-efficient diff and status operations.
-
-xml
----
-
-All the xml serialized forms write to and read from a single byte string, whose
-hash is then the inventory validator for the commit object.
-
-journalled
-----------
-
-The in development journalled inventory serializer generates a single byte
-string during serialization, but may require many byte strings to deserialize,
-and these are discovered recursively.

=== removed file 'doc/developers/lca-merge.txt'
--- doc/developers/lca-merge.txt	2008-03-11 14:29:08 +0000
+++ doc/developers/lca-merge.txt	1970-01-01 00:00:00 +0000
@@ -1,175 +0,0 @@
-LCA Merge
-=========
-
-by Aaron Bentley
-
-Essential characteristics
--------------------------
-
-In the general case (no criss-cross), it is a three-way merge.  When
-there is a criss-cross at the tree level, but not for the particular
-file, it is still a three-way merge.  When there's a file-level
-criss-cross, it's superior to a three-way merge.
-
-Algorithm
----------
-
-First, we compare the files we are trying to merge, and find the lines
-that differ.  Next, we try to determine why they differ; this is
-essential to the merge operation, because it affects how we resolve the
-differences.  In this merger, there are three possible outcomes:
-
-1. The line was added in this version: "new-this"
-2. The line was deleted in the other version: "killed-other"
-3. The line was preserved as part of merge resolution in this version,
-   but deleted in the other version: "conflicted-this"
-
-Option 3 is new, but I believe it is essential.  When each side has made
-a conflicting merge resolution, we should let the user decide how to
-combine the two resolutions, i.e. we should emit a conflict.  We cannot
-silently drop the line, or silently keep the line, which can happen if
-we choose options 1 or 2.  If we choose options 1 or 2, there's also a
-possibility that a conflict will be produced, but no guarantee.  We need
-a guarantee, which is why we need a new possible outcome.
-
-To decide whether a line is "new-this", "killed-other" or
-"conflicted-this", we compare this version against the versions from
-each "least common ancestor" (LCA), in graph terminology.  For each LCA
-version, if the line is not present in the LCA version, we add it to the
-"new" set.  If the line is present in the LCA version, we add it to the
-"killed" set.
-
-When we are done going through each LCA version, each unique line will
-be in at least one of the sets.  If it is only in the "new" set, it's
-handled as "new-this".  If it is only in the "killed" set, it's handled
-as "killed-other".  If it is in both sets, it's handled as
-"conflicted-this".
-
-The logic here is a bit tricky: first, we know that the line is present
-in some, but not all, LCAs.  We can assume that all LCAs were produced
-by merges of the same sets of revisions.  That means that in those LCAs,
-there were different merge resolutions.  Since THIS and OTHER disagree
-about whether the line is present, those differences have propogated
-into THIS and OTHER.  Therefore, we should declare that the lines are in
-conflict, and let the user handle the issue.
-
-LCA merge and Three-way merge
------------------------------
-
-Now, in the common case, there's a single LCA, and LCA merge behaves as
-a three-way merge.  Since there's only one LCA, we cannot get the
-"conflicted-this" outcome, only "new-this" or "killed-other.  Let's look
-at the typical description of three-way merges:
-
-+-----+------+-------+------------+
-|THIS | BASE | OTHER | OUT        |
-+-----+------+-------+------------+
-|A    | A    | A     | A          |
-+-----+------+-------+------------+
-|A    | B    | A     | A          |
-+-----+------+-------+------------+
-|A    | B    | B     | A          |
-+-----+------+-------+------------+
-|A    | A    | B     | B          |
-+-----+------+-------+------------+
-|A    | B    | C     |\*conflict\*|
-+-----+------+-------+------------+
-
-Now, let's assume that BASE is a common ancestor, as is typically the
-case.  In fact, for best-case merges, BASE is the sole LCA.
-
-We always pick the version that represents a change from BASE, if there
-is one.  For the AAAA line, there is no change, so the output is
-rightfully BASE/THIS/OTHER.  For ABAA, the THIS and OTHER are changes
-from BASE, and they are the same change so they both win.  (This case is
-sometimes called convergence.)  For ABBA, THIS is a change from BASE, so
-THIS wins.  For AABB, OTHER is a change from BASE, so OTHER wins.  For
-ABC*, THIS and OTHER are both changes to BASE, but they are different
-changes, so they can't both win cleanly.  Instead, we have a conflict.
-
-Now in three-way merging, we typically talk about regions of text.  In
-weave/knit/newness/lca merge, we also have regions.  Each contiguous
-group of "unchanged" lines is a region, and the areas between them are
-also regions.
-
-Let's assign a to THIS and b to OTHER.  "unchanged" regions represent
-the AAAA or ABAA cases; it doesn't matter which, because the outcome is
-the same regardless.  Regions which consist of only "new-a" or
-"killed-a" represent the ABBA case.  Regions which consist of only
-"new-b" or "killed-b" represent the AABB case.  Regions which have
-(new-a or killed-a) AND (new-b or killed-b) are the ABC* case-- both
-sides have made changes, and they are different changes, so a conflict
-must be emitted.
-
-This is what I mean when I say that it is a three-way merge in the
-common case; if there is only one LCA, then it is merely an alternative
-implementation of three-way.  (One that happens to automatically do
-``--reprocess``, ftw).
-
-Exception to three-way behavior
--------------------------------
-There is a special case of three-way merge which LCA merge handles differently
-from our default "merge3" algorithm:
-BASE has content X, THIS deletes the content, and OTHER changes X to Y.  In
-this case, LCA merge emits Y in its output and does not indicate a conflict.
-merge3 would output Y, but would also indicate a conflict.  (This is also the
-behavior in the inverse case where OTHER has nothing and THIS has Y.)
-
-This behavior is due the way LCA determines basic conflicts; they
-can only be emitted when THIS and OTHER each have unique lines between common
-lines.  If THIS does not have unique lines in this position, conflicts will not
-be emitted, even if its (lack of) content is unique.
-
-This behavior difference is shared with "weave" merge.  I hope that a future
-revision of LCA merge will handle this case as merge3 would.
-
-Why a new name
---------------
-
-1. It was time.  Although knit / annotate merge and newness merge have
-   tried to emulate the behavior of the original weave merge algorithm,
-   ``--merge-type=weave`` hasn't been based on weaves for a long time.
-2. Behavior differences.  This algorithm should behave like a three-way
-   merge in the common case, while its predecessors did not.  It also has
-   explicit support for handling conflicting merge resolutions, so it
-   should behave better in criss-cross merge scenarios.
-
-Performance
------------
-
-Unlike the current "weave" merge implementation, lca merge does not
-perform any whole-history operations.  LCA selection should scale with
-the number of uncommon revisions.  Text comparison time should scale
-mO(n\ :sup:`2`\ ), where m is the number of LCAs, and n is the number of lines
-in the file.  The current weave merge compares each uncommon ancestor,
-potentially several times, so it is >= kO(n\ :sup:`2`\ ), where k is the
-number of uncommon ancestors.  So "lca" should beat "weave" both in history
-analysis time and in text comparison time.
-
-Possible flaws
-==============
-
-1. Inaccurate LCA selection.  Our current LCA algorithm uses
-   ``Graph.heads()``, which is known to be flawed.  It may occasionally give
-   bad results.  This risk is mitigated by the fact that the per-file graphs
-   tend to be simpler than the revision graph.  And since we're already using
-   this LCA algorithm, this is not an additional risk.  I hope that John Meinel
-   will soon have a fixed version of ``Graph.heads`` for us.
-2. False matches.  Weaves have a concept of line identity, but knits and
-   later formats do not.  So a line may appear to be common to two files, when
-   in fact it was introduced separately into each for entirely different
-   reasons.  This risk is the same for three-way merging.  It is mitigated by
-   using Patience sequence matching, which a longest-common-subsequence match.
-
-Acknowledgements
-================
-
-I think this could be a great merge algorithm, and a candidate to make
-our default, but this work would not have been possible without the work
-of others, especially:
-
-- Martin Pool's weave merge and knit/annotate merge algorithms.
-- Bram Cohen's discussions of merge algorithms
-- Andrew Tridgell's dissection of BitKeeper merge
-- Nathaniel Smith's analysis of why criss-cross histories necessarily
-  produce poor three-way merges.

=== removed file 'doc/developers/network-protocol.txt'
--- doc/developers/network-protocol.txt	2008-05-16 07:15:57 +0000
+++ doc/developers/network-protocol.txt	1970-01-01 00:00:00 +0000
@@ -1,349 +0,0 @@
-================
-Network Protocol
-================
-
-:Date: 2007-09-03
-
-
-.. contents::
-
-
-Overview
-========
-
-The smart protocol provides a way to send a requests and corresponding
-responses to communicate with a remote bzr process.
-
-Layering
-========
-
-Medium
-------
-
-At the bottom level there is either a socket, pipes, or an HTTP
-request/response.  We call this layer the *medium*.  It is responsible for
-carrying bytes between a client and server.  For sockets, we have the idea
-that you have multiple requests and get a read error because the other
-side did shutdown.  For pipes we have read pipe which will have a zero
-read which marks end-of-file.  For HTTP server environment there is no
-end-of-stream because each request coming into the server is independent.
-
-So we need a wrapper around pipes and sockets to seperate out requests
-from substrate and this will give us a single model which is consistent
-for HTTP, sockets and pipes.
-
-Protocol
---------
-
-On top of the medium is the *protocol*.  This is the layer that
-deserialises bytes into the structured data that requests and responses
-consist of.
-
-Request/Response processing
----------------------------
-
-On top of the protocol is the logic for processing requests (on the
-server) or responses (on the client).
-
-Server-side
------------
-
-Sketch::
-
- MEDIUM  (factory for protocol, reads bytes & pushes to protocol,
-          uses protocol to detect end-of-request, sends written
-          bytes to client) e.g. socket, pipe, HTTP request handler.
-  ^
-  | bytes.
-  v
-
- PROTOCOL(serialization, deserialization)  accepts bytes for one
-          request, decodes according to internal state, pushes
-          structured data to handler.  accepts structured data from
-          handler and encodes and writes to the medium.  factory for
-          handler.
-  ^
-  | structured data
-  v
-
- HANDLER  (domain logic) accepts structured data, operates state
-          machine until the request can be satisfied,
-          sends structured data to the protocol.
-
-Request handlers are registered in the `bzrlib.smart.request` module.
-
-
-Client-side
------------
-
-Sketch::
-
- CLIENT   domain logic, accepts domain requests, generated structured
-          data, reads structured data from responses and turns into
-          domain data.  Sends structured data to the protocol.
-          Operates state machines until the request can be delivered
-          (e.g. reading from a bundle generated in bzrlib to deliver a
-          complete request).
-
-          This is RemoteBzrDir, RemoteRepository, etc.
-  ^
-  | structured data
-  v
-
- PROTOCOL  (serialization, deserialization)  accepts structured data for one
-          request, encodes and writes to the medium.  Reads bytes from the
-          medium, decodes and allows the client to read structured data.
-  ^
-  | bytes.
-  v
-
- MEDIUM   accepts bytes from the protocol & delivers to the remote server.
-          Allows the protocol to read bytes e.g. socket, pipe, HTTP request.
-
-The domain logic is in `bzrlib.remote`: `RemoteBzrDir`, `RemoteBranch`,
-and so on.
-
-There is also an plain file-level transport that calls remote methods to
-manipulate files on the server in `bzrlib.transport.remote`.
-
-Protocol description
-====================
-
-Version one
------------
-
-Version one of the protocol was introduced in Bazaar 0.11.
-
-The protocol (for both requests and responses) is described by::
-
-  REQUEST := MESSAGE_V1
-  RESPONSE := MESSAGE_V1
-  MESSAGE_V1 := ARGS [BODY]
-
-  ARGS := ARG [MORE_ARGS] NEWLINE
-  MORE_ARGS := SEP ARG [MORE_ARGS]
-  SEP := 0x01
-
-  BODY := LENGTH NEWLINE BODY_BYTES TRAILER
-  LENGTH := decimal integer
-  TRAILER := "done" NEWLINE
-
-That is, a tuple of arguments separated by Ctrl-A and terminated with a
-newline, followed by length prefixed body with a constant trailer.  Note
-that although arguments are not 8-bit safe (they cannot include 0x01 or
-0x0a bytes without breaking the protocol encoding), the body is.
-
-Version two
------------
-
-Version two was introduced in Bazaar 0.16.
-
-The request protocol is::
-
-  REQUEST_V2 := "bzr request 2" NEWLINE MESSAGE_V2
-
-The response protocol is::
-
-  RESPONSE_V2 := "bzr response 2" NEWLINE RESPONSE_STATUS NEWLINE MESSAGE_V2
-  RESPONSE_STATUS := "success" | "failed"
-
-Future versions should follow this structure, like version two does::
-
-  FUTURE_MESSAGE := VERSION_STRING NEWLINE REST_OF_MESSAGE
-
-This is so that clients and servers can read bytes up to the first newline
-byte to determine what version a message is.
-
-For compatibility will all versions (past and future) of bzr clients,
-servers that receive a request in an unknown protocol version should
-respond with a single-line error terminated with 0x0a (NEWLINE), rather
-than structured response prefixed with a version string.
-
-Version two of the message protocol is::
-
-  MESSAGE_V2 := ARGS [BODY_V2]
-  BODY_V2 := BODY | STREAMED_BODY
-
-That is, a version one length-prefixed body, or a version two streamed
-body.
-
-Version two with streamed bodies
---------------------------------
-
-An extension to version two allows streamed bodies.  A streamed body looks
-a lot like HTTP's chunked encoding::
- 
-  STREAMED_BODY := "chunked" NEWLINE CHUNKS TERMINATOR
-  CHUNKS := CHUNK [CHUNKS]
-  CHUNK := HEX_LENGTH CHUNK_CONTENT
-  HEX_LENGTH := HEX_DIGITS NEWLINE
-  CHUNK_CONTENT := bytes
-  
-  TERMINATOR := SUCCESS_TERMINATOR | ERROR_TERMINATOR
-  SUCCESS_TERMINATOR := 'END' NEWLINE
-  ERROR_TERMINATOR := 'ERR' NEWLINE CHUNKS SUCCESS_TERMINATOR
-
-That is, the body consists of a series of chunks.  Each chunk starts with
-a length prefix in hexadecimal digits, followed by an ASCII newline byte.
-The end of the body is signaled by '``END\\n``', or by '``ERR\\n``'
-followed by error args, one per chunk.  Note that these args are 8-bit
-safe, unlike request args.
-
-A streamed body starts with the string "chunked" so that legacy clients
-and servers will not mistake the first chunk as the start of a version one
-body.
-
-The type of body (length-prefixed or chunked) in a response is always the
-same for a given request method.  Only new request methods introduced in
-Bazaar 0.91 and later use streamed bodies.
-
-Version three
--------------
-
-.. note::
-  
-  For some discussion of the requirements that led to this new protocol
-  version, see `bug #83935`_.
-
-.. _bug #83935: https://bugs.launchpad.net/bzr/+bug/83935
-
-Version three has bencoding of most protocol structures, to make parsing
-simpler.  For extra parsing convenience, these structures are length
-prefixed::
-
-  LENGTH_PREFIX := 32-bit unsigned integer in network byte order
-
-Unlike earlier versions, clients and servers are no longer required to
-know which request verbs and responses will have bodies attached.  Because
-of length-prefixing and other changes, it is always possible to know when
-a complete request or response has been read, even if the server
-implements no verbs.
-
-The underlying message format is::
-
-  MESSAGE := "bzr message 3 (bzr 1.6)" NEWLINE HEADERS MESSAGE_PARTS
-  HEADERS := LENGTH_PREFIX bencoded_dict
-  MESSAGE_PARTS := MESSAGE_PART [MORE_MESSAGE_PARTS]
-  MORE_MESSAGE_PARTS := END_MESSAGE_PARTS | MESSAGE_PARTS
-  END_MESSAGE_PARTS := "e"
-
-  MESSAGE_PART := ONE_BYTE | STRUCTURE | BYTES
-  ONE_BYTE := "o" byte
-  STRUCTURE := "s" LENGTH_PREFIX bencoded_structure
-  BYTES := "b" LENGTH_PREFIX bytes
-
-This format allows an arbitrary sequence of message parts to be encoded
-in a single message.
-
-Headers
-~~~~~~~
-
-Each request and response will have “headers”, a dictionary of key-value pairs.
-The keys must be strings, not any other type of value.
-
-Currently, the only defined header is “Software version”.  Both the client and
-the server should include a “Software version” header, with a value of a
-free-form string such as “bzrlib 1.5”, to aid debugging and logging.  Clients
-and servers **should not** vary behaviour based on this string.
-
-Conventional requests and responses
-~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-
-By convention, most requests and responses have a simple “arguments plus
-optional body” structure, as in earlier protocol versions.  This section
-describes how such messages are encoded.  All requests and responses
-defined by earlier protocol versions must be encoded in this way.
-
-Conventional requests will send a sequence of:
-
-* Arguments (a STRUCTURE of a tuple)
-
-* (Optional) body
-
-  * Single body (BYTES), or
-
-  * Streamed body (multiple BYTES parts), followed by a status (ONE_BYTE)
-
-    * if status is "E", followed by an Error (STRUCTURE)
-
-Conventional responses will send a sequence of:
-
-* Status (ONE_BYTE)
-
-* Arguments (a STRUCTURE of a tuple)
-
-* (Optional) body
-
-  * Single body (BYTES), or
-
-  * Streamed body (multiple BYTES parts), followed by a status (ONE_BYTE)
-
-    * if status is "E", followed by an Error (STRUCTURE)
-
-In all cases, the ONE_BYTE status is either "S" for Success or "E" for
-Error.  Note that the streamed body from version two is now just multiple
-BYTES parts.
-
-For new methods, these sequences are just a convention and may be varied
-if appropriate for a particular request or response.  However, each
-request should at least start with a STRUCTURE encoding the arguments
-tuple.  The first element of that tuple must be a string that names the
-request method.  (Note that arguments in this protocol version are
-bencoded.  As a result, unlike previous protocol versions, arguments in
-this version are 8-bit clean.)
-
-For errors (where the Status byte of a response or a streamed body is
-"E"), the situation is analagous to requests.  The first item in the
-encoded sequence must be a string of the error name.  The other arguments
-supply details about the error, and their number and types will depend on
-the type of error (as identified by the error name).
-
-Paths
-=====
-
-Paths are passed across the network.  The client needs to see a namespace
-that includes any repository that might need to be referenced, and the
-client needs to know about a root directory beyond which it cannot ascend.
-
-Servers run over ssh will typically want to be able to access any path the
-user can access.  Public servers on the other hand (which might be over
-http, ssh or tcp) will typically want to restrict access to only a
-particular directory and its children, so will want to do a software
-virtual root at that level.  In other words they'll want to rewrite
-incoming paths to be under that level (and prevent escaping using ../
-tricks).  The default implementation in bzrlib does this using the
-`bzrlib.transport.chroot` module.
-
-URLs that include ~ should probably be passed across to the server
-verbatim and the server can expand them.  This will proably not be
-meaningful when limited to a directory?  See `bug 109143`_.
-
-.. _bug 109143: https://bugs.launchpad.net/bzr/+bug/109143
-
-
-Requests
-========
-
-The first argument of a request specifies the request method.
-
-The available request methods are registered in `bzrlib.smart.request`.
-
-**XXX**: ideally the request methods should be documented here.
-Contributions welcome!
-
-
-Recognised errors
-=================
-
-The first argument of an error response specifies the error type.
-
-One possible error name is ``UnknownMethod``, which means the server does
-not recognise the verb used by the client's request.  This error was
-introduced in version three.
-
-**XXX**: ideally the error types should be documented here.  Contributions
-welcome!
-
-..
-   vim: ft=rst tw=74 ai
-

=== removed file 'doc/developers/packrepo.txt'
--- doc/developers/packrepo.txt	2007-12-05 19:55:07 +0000
+++ doc/developers/packrepo.txt	1970-01-01 00:00:00 +0000
@@ -1,287 +0,0 @@
-==========================
-KnitPack repository format
-==========================
-
-.. contents::
-
-Using KnitPack repositories
-===========================
-
-Motivation
-----------
-
-KnitPack is a new repository format for Bazaar, which is expected to be
-faster both locally and over the network, is usually more compact, and
-will work with more FTP servers.
-
-Our benchmarking results to date have been very promising. We fully expect
-to make a pack-based format the default in the near future.  We would
-therefore like as many people as possible using KnitPack repositories,
-benchmarking the results and telling us where improvements are still needed.
-
-Preparation
------------
-
-A small percentage of existing repositories may have some inconsistent
-data within them. It's is a good idea to check the integrity of your
-repositories before migrating them to knitpack format. To do this, run::
-
-  bzr check
-
-If that reports a problem, run this command::
-
-  bzr reconcile
-
-Note that this can take many hours for repositories with deep history
-so be sure to set aside some time for this if it is required.
-
-Creating a new knitpack branch
-------------------------------
-
-If you're starting a project from scratch, it's easy to make it a
-``knitpack`` one. Here's how::
-
-  cd my-stuff
-  bzr init --pack-0.92
-  bzr add
-  bzr commit -m "initial import"
-
-In other words, use the normal sequence of commands but add the
-``--pack-0.92`` option to the ``init`` command.
-
-**Note:** In bzr 0.92, this format was called ``knitpack-experimental``.
-
-Creating a new knitpack repository
-----------------------------------
-
-If you're starting a project from scratch and wish to use a shared repository
-for branches, you can make it a ``knitpack`` repository like this::
-
-  cd my-repo
-  bzr init-repo --pack-0.92 .
-  cd my-stuff
-  bzr init
-  bzr add
-  bzr commit -m "initial import"
-
-In other words, use the normal sequence of commands but add the
-``--pack-0.92`` option to the ``init-repo`` command.
-
-Upgrading an existing branch or repository to knitpack format
--------------------------------------------------------------
-
-If you have an existing branch and wish to migrate it to
-a ``knitpack`` format, use the ``upgrade`` command like this::
-
-  bzr upgrade --pack-0.92 path-to-my-branch
-
-If you are using a shared repository, run::
-
-  bzr upgrade --pack-0.92 ROOT_OF_REPOSITORY
-
-to upgrade the history database. Note that this will not
-alter the branch format of each branch, so
-you will need to also upgrade each branch individually
-if you are upgrading from an old (e.g. < 0.17) bzr.
-More modern bzr's will already have the branch format at
-our latest branch format which adds support for tags.
-
-Starting a new knitpack branch from one in an older format
-----------------------------------------------------------
-
-This can be done in one of several ways:
-
-1. Create a new branch and pull into it
-2. Create a standalone branch and upgrade its format
-3. Create a knitpack shared repository and branch into it
-
-Here are the commands for using the ``pull`` approach::
-
-    bzr init --pack-0.92 my-new-branch
-    cd my-new-branch
-    bzr pull my-source-branch
-
-Here are the commands for using the ``upgrade`` approach::
-
-    bzr branch my-source-branch my-new-branch
-    cd my-new-branch
-    bzr upgrade --pack-0.92 .
-
-Here are the commands for the shared repository approach::
-
-  cd my-repo
-  bzr init-repo --pack-0.92 .
-  bzr branch my-source-branch my-new-branch
-  cd my-new-branch
-
-As a reminder, any of the above approaches can fail if the source branch
-has inconsistent data within it and hasn't been reconciled yet. Please
-be sure to check that before reporting problems.
-
-Testing packs for bzr-svn users
--------------------------------
-
-If you are using ``bzr-svn`` or are testing the prototype subtree support,
-you can still use and assist in testing KnitPacks. The commands to use
-are identical to the ones given above except that the name of the format
-to use is ``knitpack-subtree-experimental``.
-
-WARNING: Note that the subtree formats, ``dirstate-subtree`` and
-``knitpack-subtree-experimental``, are **not** production strength yet and
-may cause unexpected problems. They are required for the bzr-svn
-plug-in but should otherwise only be used by people happy to live on the
-bleeding edge. If you are using bzr-svn, you're on the bleeding edge anyway.
-:-)
-
-Reporting problems
-------------------
-
-If you need any help or encounter any problems, please contact the developers
-via the usual ways, i.e. chat to us on IRC or send a message to our mailing
-list. See http://bazaar-vcs.org/BzrSupport for contact details.
-
-
-Technical notes
-===============
-
-Bazaar 0.92 adds a new format (experimental at first) implemented in
-``bzrlib.repofmt.pack_repo.py``.
-
-This format provides a knit-like interface which is quite compatible
-with knit format repositories: you can get a VersionedFile for a
-particular file-id, or for revisions, or for the inventory, even though
-these do not correspond to single files on disk.
-
-The on-disk format is that the repository directory contains these
-files and subdirectories:
-
-==================== =============================================
-packs/               completed readonly packs
-indices/             indices for completed packs
-upload/              temporary files for packs currently being
-                     written
-obsolete_packs/      packs that have been repacked and are no
-                     longer normally needed
-pack-names           index of all live packs
-lock/                lockdir
-==================== =============================================
-
-Note that for consistency we always write "indices" not "indexes".
-
-This is implemented on top of pack files, which are written once from
-start to end, then left alone.  A pack consists of a body file, plus
-several index files.  There are four index files for each pack, which
-have the same basename and an extension indicating the purpose of the
-index:
-
-======== ========== ======================== ==========================
-extn     Purpose    Key                      References
-======== ========== ======================== ==========================
-``.tix`` File texts ``file_id, revision_id`` per-file parents,
-                                             compression basis
-                                             per-file parents
-``.six`` Signatures ``revision_id,``         -
-``.rix`` Revisions  ``revision_id,``         revision parents
-``.iix`` Inventory  ``revision_id,``         revision parents,
-                                             compression base
-======== ========== ======================== ==========================
-
-Indices are accessed through the ``bzrlib.index.GraphIndex`` class.
-Indices are stored as sorted files on disk.  Each line is one record,
-and contains:
-
- * key fields
- * a value string - for all these indices, this is an ascii decimal pair
-   of "offset length" giving the position of the referenced data within
-   the pack body file
- * a list of zero or more reference lists
-
-The reference lists let a graph be stored within the index.  Each
-reference list entry points to another entry in the same index.  The
-references are represented as a byte offset for the target within the
-index file.
-
-When a compression base is given, it indicates that the body of the text
-or inventory is a forward delta from the referenced revision.  The
-compression base list must have length 0 or 1.
-
-Like packs, indexes are written only once and then unmodified.  A
-GraphIndex builder is a mutable in-memory graph that can be sorted,
-cross-referenced and written out when the write group completes.
-
-There can also be index entries with a value of 'a' for absent.  These
-records exist just to be pointed to in a graph.  This is used, for
-example, to give the revision-parent pointer when the parent revision is
-in a previous pack.
-
-The data content for each record is a knit data chunk.  The knits are
-always unannotated - the annotations must be generated when needed.
-(We'd like to cache/memoize the annotations.)  The data hunks can be
-moved between packs without needing to recompress them.
-
-It is not possible to regenerate an index from the body file, because it
-contains information stored in the knit index that's not in the body.
-(In particular, the per-file graph is only stored in the index.)
-We would like to change this in a future format.
-
-The lock is a regular LockDir lock.  The lock is only held for a much
-reduced scope, while updating the pack-names file.  The bulk of the
-insertion can be done without the repository locked.  This is an
-implementation detail; the repository user should still call
-``repository.lock_write`` at the regular time but be aware this does not
-correspond to a physical mutex.
-
-Read locks control caching but do not affect writers.
-
-The newly-added repository write group concept is very important to
-KnitPack repositories.  When ``start_write_group`` is called, a new
-temporary pack is created and all modifications to the repository will
-go into it until either ``commit_write_group`` or ``abort_write_group``
-is called, at which time it is either finished and moved into place or
-discarded respectively.  Write groups cannot be nested, only one can be
-underway at a time on a Repository instance and they must occur within a
-write lock.
-
-Normally the data for each revision will be entirely within a single
-pack but this is not required.
-
-When a pack is finished, it gets a final name based on the md5 of all
-the data written into the pack body file.
-
-The ``pack-names`` file gives the list of all finished non-obsolete
-packs.  (This should always be the same as the list of files in the
-``packs/`` directory, but the file is needed for readonly http clients
-that can't easily list directories, and it includes other information.)
-The constraint on the ``pack-names`` list is that every file mentioned
-must exist in the ``packs/`` directory.
-
-In rare cases, when a writer is interrupted, about-to-be-removed packs
-may still be present in the directory but removed from the list.
-
-As well as the list of names, the pack-names file also contains the
-size, in bytes, of each of the four indices.  This is used to bootstrap
-bisection search within the indices.
-
-In normal use, one pack will be created for each commit to a repository.
-This would build up to an inefficient number of files over time, so a
-``repack`` operation is available to recombine them, by producing larger
-files containing data on multiple revisions.  This can be done manually
-by running ``bzr pack``, and it also may happen automatically when a
-write group is committed.
-
-The repacking strategy used at the moment tries to balance not doing too
-much work during commit with not having too many small files left in the
-repository.  The algorithm is roughly this: the total number of
-revisions in the repository is expressed as a decimal number, e.g.
-"532".  Then we'll repack until we have five packs containing a hundred
-revisions each, three packs containing ten revisions each, and two packs
-with single revisions.  This means that each revision will normally
-initially be created in a single-revision pack, then moved to a
-ten-revision pack, then to a 100-pack, and so on.
-
-As with other repositories, in normal use data is only inserted.
-However, in some circumstances we may want to garbage-collect or prune
-existing data, or reconcile indexes.
-
-..
-   vim: tw=72 ft=rst expandtab

=== modified file 'doc/developers/performance-contributing.txt'
--- doc/developers/performance-contributing.txt	2007-11-27 19:51:08 +0000
+++ doc/developers/performance-contributing.txt	2007-08-20 03:43:40 +0000
@@ -11,7 +11,7 @@
 pointing at it that is also BLUE, and start working on that.
 
 Adhoc performance work can also be done. One useful tool is the 'evil' debug
-flag. For instance running ``bzr -Devil commit -m "test"`` will log a backtrace
+flag. For instance running ``bzr -Devil commit -m 'test'`` will log a backtrace
 to the bzr log file for every method call which triggers a slow or non-scalable
 part of the bzr library. So checking that a given command with ``-Devil`` has
 no backtraces logged to the log file is a good way to find problem function

=== removed file 'doc/developers/plugin-api.txt'
--- doc/developers/plugin-api.txt	2008-04-06 23:37:06 +0000
+++ doc/developers/plugin-api.txt	1970-01-01 00:00:00 +0000
@@ -1,173 +0,0 @@
-==========
-Plugin API
-==========
-
-Status
-======
-
-:Date: 2008-02-29
-
-bzrlib has a very flexible internal structure allowing plugins for many
-operations. Plugins can add commands, new storage formats, diff and merge
-features and more. This document provides an overview of the API and
-conventions for plugin authors.
-
-.. contents::
-
-
-Structure of a plugin
-=====================
-
-Plugins are Python modules under ``bzrlib.plugins``. They can be installed
-either into the PYTHONPATH in that location, or in ~/.bazaar/plugins.
-
-Plugins should have a setup.py.
-
-As for other Python modules, the name of the directory must match the
-expected name of the plugin.
-
-
-Plugin metadata before installation
-===================================
-
-Plugins can export a summary of what they provide, and what versions of bzrlib
-they are compatible with. This allows tools to be written to work with plugins,
-such as to generate a directory of plugins, or install them via a
-symlink/checkout to ~/.bazaar/plugins.
-
-This interface allows bzr to interrogate a plugin without actually loading
-it. This is useful because loading a plugin may have side effects such
-as registering or overriding commands, or the plugin may raise an error,
-if for example a prerequisite is not present.
-
-
-Metadata protocol
------------------
-
-A plugin that supports the bzr plugin metadata protocol will do two
-things. Firstly, the ``setup.py`` for the plugin will guard the call to
-``setup()``::
-
-  if __name__ == 'main':
-      setup(...)
-
-Secondly, the setup module will have one or more of the following variables
-present at module scope. Any variables that are missing will be given the
-defaults from the table. An example of every variable is provided after
-the full list.
-
-+------------------------+---------+----------------------------------------+
-| Variable               | Default | Definition                             |
-+========================+=========+========================================+
-| bzr_plugin_name        | None    | The name the plugin package should be  |
-|                        |         | given on disk. The plugin is then      |
-|                        |         | available to python at                 |
-|                        |         | bzrlib.plugins.NAME                    |
-+------------------------+---------+----------------------------------------+
-| bzr_commands           | []      | A list of the commands that the plugin |
-|                        |         | provides. Commands that already exist  |
-|                        |         | in bzr and are decorated by the plugin |
-|                        |         | do not need to be listed (but it is not|
-|                        |         | harmful if you do list them).          |
-+------------------------+---------+----------------------------------------+
-| bzr_plugin_version     | None    | A version_info 5-tuple with the plugins|
-|                        |         | version.                               |
-+------------------------+---------+----------------------------------------+
-| bzr_minimum_version    | None    | A version_info 3-tuple for comparison  |
-|                        |         | with the bzrlib minimum and current    |
-|                        |         | version, for determining likely        |
-|                        |         | compatibility.                         |
-+------------------------+---------+----------------------------------------+
-| bzr_maximum_version    | None    | A version_info 3-tuple like            |
-|                        |         | bzr_minimum_version but checking the   |
-|                        |         | upper limits supported.                |
-+------------------------+---------+----------------------------------------+
-| bzr_control_formats    | {}      | A dictionary of descriptions of version|
-|                        |         | control directories. See               |
-|                        |         | `Control Formats` below.               |
-+------------------------+---------+----------------------------------------+
-| bzr_checkout_formats   | {}      | A dictionary of tree_format_string ->  |
-|                        |         | human description strings, for tree    |
-|                        |         | formats that drop into the             |
-|                        |         | ``.bzr/checkout`` metadir system.      |
-+------------------------+---------+----------------------------------------+
-| bzr_branch_formats     | {}      | As bzr_checkout_formats but for        |
-|                        |         | branches.                              |
-+------------------------+---------+----------------------------------------+
-| bzr_repository_formats | {}      | As bzr_checkout_formats but for        |
-|                        |         | repositories.                          |
-+------------------------+---------+----------------------------------------+
-
-Control Formats
----------------
-
-Because disk format detection for formats that bzr does not understand at
-all can be useful, we allow a declarative description of the shape of a
-control directory. Each description has a name for showing to users, and a
-dictonary of relative paths, and the content needed at each path. Paths
-that end in '/' are required to be directories and the value for that key
-is ignored. Other paths are required to be regular files, and the value
-for that key is either None, in which case the file is statted but the
-content is ignored, or a literal string which is compared against for
-the content of the file. Thus::
-
-  # (look for a .hg directory)
-  bzr_control_formats = {"Mercurial":{'.hg/': None}}
-  
-  # (look for a file called .svn/format with contents 4\n).
-  bzr_control_formats = {"Subversion":{'.svn/format': '4\n'}}
-
-
-Example
--------
-
-An example setup.py follows::
-  
-  #!/usr/bin/env python2.4
-  from distutils.core import setup
-  
-  bzr_plugin_name = 'demo'
-  bzr_commands = [
-      'new-command',
-      ]
-  
-  bzr_branch_formats = {
-      "Branch label on disk\n":"demo branch",
-      }
-
-  bzr_control_formats = {"Subversion":{'.svn/format': '4\n'}}
-  
-  bzr_plugin_version = (1, 3, 0, 'dev', 0)
-  bzr_minimum_version = (1, 0, 0)
-  
-  if __name__ == 'main':
-      setup(name="Demo",
-            version="1.3.0dev0",
-            description="Demo plugin for plugin metadata.",
-            author="Canonical Ltd",
-            author_email="bazaar@lists.canonical.com",
-            license = "GNU GPL v2",
-            url="https://launchpad.net/bzr-demo",
-            packages=['bzrlib.plugins.demo',
-                      'bzrlib.plugins.demo.tests',
-                      ],
-            package_dir={'bzrlib.plugins.demo': '.'})
-
-
-Plugin metadata after installation
-==================================
-
-After a plugin has been installed, metadata can be more easily obtained.
-Currently the only metadata used is for API versioning.
-
-API version
------------
-
-Please see `API versioning <api-versioning.html>`_ for details on the API
-metadata protocol used by bzrlib.
-
-
-..
-   vim: ft=rst tw=74 ai
-
-

=== removed file 'doc/developers/ppa.txt'
--- doc/developers/ppa.txt	2008-08-25 21:50:11 +0000
+++ doc/developers/ppa.txt	1970-01-01 00:00:00 +0000
@@ -1,224 +0,0 @@
-Managing the Bazaar PPA
-=======================
-
-See also: `Bazaar Developer Document Catalog <index.html>`_.
-
-
-Background
-----------
-
-We build Ubuntu ``.deb`` packages for Bazaar as an important part of the release
-process.  These packages are hosted in a few `Personal Package Archives (PPA)`__ on
-Launchpad.
-
-  __ https://help.launchpad.net/PPAQuickStart
-
-As of June 2008, there are two PPAs:
-
-<https://launchpad.net/~bzr/+archive>
-    Final released versions.
-
-<https://launchpad.net/~bzr-beta-ppa/+archive>
-    Releases and release candidates.    
-
-We build packages for every supported Ubuntu release
-<https://wiki.ubuntu.com/Releases>.  Packages need no longer be updated
-when the release passes end-of-life because all users should
-have upgraded by then.  (As of May 2008, Edgy Eft is no longer supported.)
-
-We build a distinct package for each distrorelease.  As of bzr 1.5, Dapper
-uses ``python-support`` and later distributions use ``python-central``.
-If you upload a release-specific version, you should add a suffix to the
-package version, e.g. ``bzr.1.3-1~bazaar1~dapper1``.
-
-Every package is first uploaded into the beta ppa.  For final release
-versions it is also copied to the main PPA.
-
-The ``debian/`` directory containing the packaging information is kept in
-branches on Launchpad, named like 
-<https://code.launchpad.net/~bzr/bzr/packaging-hardy>.
-or
-<lp:~bzr/bzr/packaging-hardy>.
-
-Preconditions
--------------
-  
-* You must have a Launchpad account and be a member of the teams 
-  that own these PPAs (``~bzr``, ``~bzr-beta-ppa``).
-
-* You must have a GPG key registered to your Launchpad account.
-
-* Configure ``dput`` to upload to our PPA with this section in your
-  ``~/.dput.cf``::
-
-    [bzr-beta-ppa]
-    fqdn = ppa.launchpad.net
-    method = ftp
-    incoming = ~bzr-beta-ppa/ubuntu
-    login = anonymous
-    allow_unsigned_uploads = 0
-
-    [bzr-ppa]
-    fqdn = ppa.launchpad.net
-    method = ftp
-    incoming = ~bzr/ubuntu
-    login = anonymous
-    allow_unsigned_uploads = 0
-
-  You may also want to add these lines to prevent inadvertently attempting
-  to upload into Ubuntu or Debian, which will give a somewhat unclear
-  error::
-
-    [DEFAULT]
-    default_host_main = notspecified
-  
-* You need a Ubuntu (or probably Debian) machine, and ::
-
-    sudo apt-get install build-essential devscripts dput quilt patch
-
-* You will also want to have the ``bzr-builddeb`` plugin installed.
-
-
-Packaging Bazaar
-----------------
-
-Short form
-~~~~~~~~~~
-
-For people who have already set up everything they need, building the
-release packages is as simple as::
-
-  cd ~/dev/bzr/releases/packaging
-  export UBUNTU_RELEASES="dapper feisty gutsy hardy intrepid"
-  ~/dev/bzr/bzr.dev/tools/packaging/update-packaging-branches.sh
-  ~/dev/bzr/bzr.dev/tools/packaging/update-changelogs.sh 1.6~beta3-1~bazaar1
-  ~/dev/bzr/bzr.dev/tools/packaging/build-packages
-  dput bzr-beta-ppa build-area/bzr_1.6~beta3~bazaar1*.changes
-
-Long Form
-~~~~~~~~~
-
-#. You will end up checking out a separate directory for each supported
-   release. Such as ``~/dev/bzr/releases/packaging/hardy``
-
-#. Decide on the final version number.  It should be of this form::
-
-     bzr-1.6~beta3-1~bazaar1~hardy1
-
-   There are three hyphen-separated parts: the *package name*, the *upstream
-   version*, and the *packaging version*.
-
-   **Caution:** Upstream betas or release candidates must insert a tilde
-   to make them sort before the final release, like this:
-   ``bzr-1.6~beta3-1~bazaar1~hardy1``.
-
-   Final releases will use a release string of the form:
-   ``bzr-1.6-1~bazaar1~hardy1``
-
-#. Export the distroreleases that you will be packaging for::
-
-      export UBUNTU_RELEASES="dapper feisty gutsy hardy intrepid"
-
-#. Checkout (or update) the packaging branch for each supported release::
-
-      bzr co lp:~bzr/bzr/packaging-hardy
-
-   There is a script available to help::
-
-      tools/packaging/update-packaging-branches.sh
-
-#. The ``bzr-builddeb`` step will download the original tarball if you do
-   not already have it. Putting it into a ``tarballs`` directory.
-
-#. For Bazaar plugins, change the ``debian/control`` file to express a
-   dependency on the correct version of ``bzr``.
-
-   For bzrtools this is typically::
-
-      Build-Depends-Indep: bzr (>= 1.6~), rsync
-      Depends: ${python:Depends}, bzr (>= 1.6~), bzr (<< 1.7~), patch
-
-#. Make a new ``debian/changelog`` entry for the new release,
-   either by using ``dch`` or just editing the file::
-
-      dch -v '1.6~beta3-1~bazaar1~hardy1' -D hardy
-
-   dch will default to the distro you're working in and this isn't checked
-   against the version number (which is just our convention), so make sure 
-   to specify it.
-
-   Make sure you have the correct email address for yourself, version
-   number, and distribution.  It should look something like this::
-
-       bzr (1.6~beta3-1~bazaar1~hardy1) hardy; urgency=low
-     
-        * New upstream release.
-     
-       -- John Sample <sample@example.com>  Mon, 31 Mar 2008 12:36:27 +1100
-
-   If you need to upload the package again to fix a problem, normally you
-   should increment the last number in the version number, following the
-   distro name.  Make sure not to omit the initial ``-1``, and make sure
-   that the distro name in the version is consistent with the target name
-   outside the parenthesis.
-
-   You will also want to commit these changes into the packaging branch.
-
-   There is a helper script which will update the changelog and commit it
-   for all of your ``$UBUNTU_RELEASES``. It is available as::
-
-      tools/packaging/update-changelogs.sh
-
-   You must supply the release string, such as::
-
-      tools/packaging/update-changelogs.sh 1.6~beta3-1~bazaar1
-
-   It will automatically append the distro numbering on the end.
-
-#. Build the source packages::
-
-      cd packaging-$DISTRO; bzr builddeb -S
-
-   This will create a ``.changes`` file in ``build-area``. You will need
-   to sign it with::
-
-      debsign -m$UID build-area/*.changes
-
-   Where ``$UID`` is the gpg key you want to use to sign the changes.
-   Alternatively, you can configure ``~/.bazaar/builddeb.conf`` with::
-
-      [BUILDDEB]
-      builder = dpkg-buildpackage -rfakeroot
-      source-builder= dpkg-buildpackage -rfakeroot -S -sa
-
-   Which tells ``bzr builddeb`` to automatically sign the package with the
-   key associated with the user who created the changelog entry.
-     
-#. Upload into the beta PPA for each release::
-
-     dput bzr-beta-ppa build-area/*.changes
-
-#. For final release versions, also copy it into the ``~bzr`` PPA::
-
-     dput bzr-ppa ../bzr__1.6-1\~bazaar1\~hardy1\_source.changes
-
-   Alternatively, you can use Launchpad's "copy" feature to copy the
-   packages between repositories.
-
-#. You should soon get an "upload accepted" mail from Launchpad, which
-   means that your package is waiting to be built.  You can then track its
-   progress in <https://launchpad.net/~bzr-beta-ppa/+archive> and
-   <https://launchpad.net/~bzr-beta-ppa/+archive/+builds>.
-
-
-Monitoring the contents of PPAs
--------------------------------
-
-If you add all the bzr PPAs to your ``sources.list`` then you can see a
-summary of current package versions with::
-
-  apt-cache madison bzr
-
-
-..
-   vim: filetype=rst textwidth=74 ai shiftwidth=4

=== removed file 'doc/developers/releasing.txt'
--- doc/developers/releasing.txt	2008-07-23 04:35:09 +0000
+++ doc/developers/releasing.txt	1970-01-01 00:00:00 +0000
@@ -1,272 +0,0 @@
-Releasing Bazaar
-================
-
-This document describes the processes for making and announcing a Bazaar
-release, and managing the release process.
-
-We normally have one person acting as the release manager, who 
-organizes development for the release and also actually makes the release
-tarball and posts announcements.  It can be a different person from one
-release to the next.
-
-See also: `Bazaar Developer Document Catalog <index.html>`_.
-
-
-.. contents::
-
-General process
----------------
-
-Our usual process is that one week before release we will make a release
-branch from the trunk.  We do one commit to that branch to change the
-version number to 'rc1', and advance the trunk version to 'dev' for the
-next release.
-
-We then publish and announce this release candidate according to the
-process below.  We then have a week of general testing of the rc,
-including some time for plugin authors to update their code for any
-changes.
-
-Normally no changes will be made on the release branch unless serious bugs
-or regressions are found, and the release manager decides they should be
-merged in.  After one week, the release branch's version number is updated
-and it's published as the final release.  If regressions or serious
-problems are discovered after the final release we may make an additional
-point release from that branch.
-
-The process or timing can vary if that seems appropriate in a particular
-case but we try to release on a regular four week cycle.
-
-The net effect is that the code gets some extra testing before release,
-and the trunk is always open for general development.
-
-
-
-
-Starting a Release
-------------------
-
-To start a new release cycle:
-
-#. Send mail to the list with the key dates, who will be the release
-   manager, and the main themes or targetted bugs.  Ask people to nominate
-   objectives, or point out any high-risk things that are best done early,
-   or that interact with other changes.
-
-#. Add a new "series" in Launchpad at <https://launchpad.net/bzr/+addseries>.  There is one 
-   series for every *x.y* release.
-
-
-Weekly Metronome Mail
----------------------
-
-Every week the release manager should send a mail to the Bazaar list
-covering these points (as appropriate):
-
-* Early communication about changing dependencies or defaults
-
-* Reminder re lifecycle and where we're up to right now, in particular the 
-  dates for the next release and/or candidate.
-
-* Summary of recent successes and pending work.
-
-* Reminder re release objectives
-
-* Reminder re things needing attention, e.g. bug triage, reviews, testing of certain things, etc.
-
-
-Preparing the tree for release
-------------------------------
-
-.. Was previously at http://bazaar-vcs.org/ReleaseChecklist
-
-.. TODO: Still needs more clarity on what's in a RC versus a final
-.. release?
-
-This is the procedure for making a new bzr release:
-
-#. If the release is the first candidate, make a new branch in PQM. 
-   (Contact Robert Collins for this step).
-
-   Register the branch at https://launchpad.net/products/bzr/+addbranch
-
-#. Make a local branch for preparing this release.  (Only for the first 
-   release in a series, otherwise you should already have a branch.) ::
-
-     bzr branch trunk prepare-1.6
-
-#. Configure pqm-submit for this branch, with a section like this in
-   ``~/.bazaar/locations.conf``::
-
-	[/home/mbp/bzr/prepare-1.4]
-	pqm_email = Canonical PQM <pqm@bazaar-vcs.org>
-	submit_branch = http://bazaar-vcs.org/bzr/bzr.1.4
-	submit_to = bazaar@lists.canonical.com
-
-#. In the release branch, update  ``version_info`` in
-   ``./bzrlib/__init__.py``.  
-   (This must match ``_script_version`` in the ``bzr`` script, but 
-   that is updated at the start of the release cycle, and
-   doesn't need to say if it's an rc or final release.)
-
-   Run this command and check the output::
-
-     ./bzr --version
-
-#. Add the date and release number to ``./NEWS``, and a one-paragraph
-   summary of changes in this release.
-
-#. Commit these changes to the release branch, using a command like::
-    
-     bzr commit -m "Release 0.12rc1." 
-   
-   The diff before you commit will be something like::
-
-       === modified file 'NEWS'
-       --- NEWS        2006-10-23 13:11:17 +0000
-       +++ NEWS        2006-10-23 22:50:50 +0000
-       @@ -1,4 +1,4 @@
-       -IN DEVELOPMENT
-       +bzr 0.12rc1  2006-10-23
-
-          IMPROVEMENTS:
-
-
-       === modified file 'bzrlib/__init__.py'
-       --- bzrlib/__init__.py  2006-10-16 01:47:43 +0000
-       +++ bzrlib/__init__.py  2006-10-23 22:49:46 +0000
-       @@ -35,7 +35,7 @@
-        # Python version 2.0 is (2, 0, 0, 'final', 0)."  Additionally we use a
-        # releaselevel of 'dev' for unreleased under-development code.
-
-       -version_info = (0, 12, 0, 'dev', 0)
-       +version_info = (0, 12, 0, 'candidate', 1)
-
-        if version_info[3] == 'final':
-            version_string = '%d.%d.%d' % version_info[:3]
-
-#. Submit those changes to PQM for merge into the appropriate release
-   branch::
- 
-     bzr push
-     bzr pqm-submit -m "(mbp) prepare 1.6"
-
-#. When PQM succeeds, pull down the master release branch.
-
-
-Making the source tarball
--------------------------
-
-#. Change into the source directory and run ::
-  
-     make dist
-
-#. Now we'll try expanding this tarball and running the test suite
-   to check for packaging problems::
- 
-     make check-dist-tarball
-
-
-Publishing the release
-----------------------
-
-Now you have the releasable product.  The next step is making it
-available to the world.
-
-#. In <https://launchpad.net/bzr/> click the "Release series" for this
-   series, to take you to e.g. <https://launchpad.net/bzr/1.1>.  Then
-   click "Register a release", and add information about this release.
-
-#. Within that release, upload the source tarball and the GPG signature.
-
-#. Link from http://bazaar-vcs.org/Download to the tarball and signature.
-
-#. Update http://doc.bazaar-vcs.org/ to have a directory of documentation
-   for this release.  (Controlled by the ``update-bzr-docs`` script on
-   escudero, and also update the ``latest`` symlink in
-   ``/srv/bazaar.canonical.com/doc/``.)
-
-#. Announce on the `Bazaar home page`__.
-   
- __ http://bazaar-vcs.org/
-
-
-Announcing the release
-----------------------
-
-Now that the release is publicly available, tell people about it.
-
-#. Announce to ``bazaar-announce`` and ``bazaar`` mailing lists. 
-   The announce mail will look something like this:
-   
-    | Subject: bzr 0.11 release candidate 1
-    | 
-    | INTRO HERE. Mention the release number and date, and why the release. (i.e. release candidate for testing, final release of a version, backport/bugfix etc).
-    | 
-    | Tarballs:
-    | http://bazaar-vcs.org/releases/src/bzr-VERSION.tar.gz
-    | and GPG signature:
-    | http://bazaar-vcs.org/releases/src/bzr-VERSION.tar.gz.sig
-    | 
-    | DESCRIBE-CHANGES-IN-OVERVIEW-HERE
-    | 
-    | DESCRIBE-when the next release will be (if there is another - i.e. this is a release candidate)
-    | 
-    | Many thanks to all the contributors to this release! I've included the
-    | contents of NEWS for VERSION below:
-
-   To generate the data from NEWS, just copy and paste the relevant news section and clean it up as appropriate. The main clean-up task is to confirm that all major changes are indeed covered. This can be done by running ``bzr log`` back to the point when the branch was opened and cross checking the changes against the NEWS entries.
-
-   (RC announcements should remind plugin maintainers to update their plugins.)
-
-     * For point releases (i.e. a release candidate, or an incremental fix
-       to a released version) take everything in the relevant NEWS section.  For
-       example, for 0.11rc2 take everything in NEWS from the bzr 0.11rc2 line to the bzr 0.11rc1 line further down.
-
-     * For major releases (i.e. 0.11, 0.12 etc), take all the combined NEWS sections from within that version: for 0.11 take all of the 0.11 specific section, plus 0.11rc2, plus 0.11rc1 etc.
-
-#. Update the IRC channel topic. Use the ``/topic`` command to do this, ensuring the new topic text keeps the project name, web site link, etc.
-
-#. Announce on http://freshmeat.net/projects/bzr/
-   
-   This should be done for both release candidates and final releases. If you do not have a Freshmeat account yet, ask one of the existing admins.
-
-#. Update http://en.wikipedia.org/wiki/Bzr -- this should be done for final releases but not for Release Candidates.
-
-#. Package maintainers should update packages when they see the
-   announcement.
-
-#. For final releases, also send the announcement mail to
-   info-gnu@gnu.org and python-announce-list@python.org.
-
-#. Also send a GNU directory update to bug-directory@gnu.org.
-
-#. Update the python package index: <http://pypi.python.org/pypi/bzr> - best
-   done by running ::
-
-       python setup.py register
-
-   Remember to check the results afterwards.
-
-   To be able to register the release you must create an account on
-   <http://pypi.python.org/pypi> and have one of the existing owners of
-   the project add you to the group.
-
-
-Merging the released code back to trunk
----------------------------------------
-
-Merge the release branch back into the trunk.  Check that changes in NEWS
-were merged into the right sections.  If it's not already done, advance
-the version number in ``bzr`` and ``bzrlib/__init__.py``.  Submit this
-back into pqm for bzr.dev.
-
-
-See also
---------
-
- * `Packaging into the bzr PPA <ppa.html>`_ to make and publish Ubuntu
-   packages.
-
-..
-   vim: filetype=rst textwidth=74 ai shiftwidth=4

=== removed file 'doc/developers/repository-stream.txt'
--- doc/developers/repository-stream.txt	2008-04-16 04:07:40 +0000
+++ doc/developers/repository-stream.txt	1970-01-01 00:00:00 +0000
@@ -1,200 +0,0 @@
-==================
-Repository Streams
-==================
-
-Status
-======
-
-:Date: 2008-04-11
-
-This document describes the proposed programming interface for streaming
-data from and into repositories. This programming interface should allow
-a single interface for pulling data from and inserting data into a Bazaar
-repository.
-
-.. contents::
-
-
-Motivation
-==========
-
-To eliminate the current requirement that extracting data from a
-repository requires either using a slow format, or knowing the format of
-both the source repository and the target repository.
-
-
-Use Cases
-=========
-
-Here's a brief description of use cases this interface is intended to
-support.
-
-Fetch operations
-----------------
-
-We fetch data between repositories as part of push/pull/branch operations.
-Fetching data is currently an very interactive process with lots of
-requests. For performance having the data be supplied in a stream will
-improve push and pull to remote servers. For purely local operations the
-streaming logic should help reduce memory pressure. In fetch operations
-we always know the formats of both the source and target.
-
-Smart server operations
-~~~~~~~~~~~~~~~~~~~~~~~
-
-With the smart server we support one streaming format, but this is only
-usable when both the client and server have the same model of data, and
-requires non-optimal IO ordering for pack to pack operations. Ideally we
-can both provide optimal IO ordering the pack to pack case, and correct
-ordering for pack to knits.
-
-Bundles
--------
-
-Bundles also create a stream of data for revisions from a repository.
-Unlike fetch operations we do not know the format of the target at the
-time the stream is created. It would be good to be able to treat bundles
-as frozen branches and repositories, so a serialised stream should be
-suitable for this.
-
-Data conversion
----------------
-
-At this point we are not trying to integrate data conversion into this
-interface, though it is likely possible.
-
-
-Characteristics
-===============
-
-Some key aspects of the described interface are discussed in this section.
-
-Single round trip
------------------
-
-All users of this should be able to create an appropriate stream from a
-single round trip.
-
-Forward-only reads
-------------------
-
-There should be no need to seek in a stream when inserting data from it
-into a repository. This places an ordering constraint on streams which
-some repositories do not need.
-
-
-Serialisation
-=============
-
-At this point serialisation of a repository stream has not been specified.
-Some considerations to bear in mind about serialisation are worth noting
-however.
-
-Weaves
-------
-
-While there shouldn't be too many users of weave repositories anymore,
-avoiding pathological behaviour when a weave is being read is a good idea.
-Having the weave itself embedded in the stream is very straight forward
-and does not need expensive on the fly extraction and re-diffing to take
-place.
-
-Bundles
--------
-
-Being able to perform random reads from a repository stream which is a
-bundle would allow stacking a bundle and a real repository together. This
-will need the pack container format to be used in such a way that we can
-avoid reading more data than needed within the pack container's readv
-interface.
-
-
-Specification
-=============
-
-This describes the interface for requesting a stream, and the programming
-interface a stream must provide. Streams that have been serialised should
-expose the same interface.
-
-Requesting a stream
--------------------
-
-To request a stream, three parameters are needed:
-
- * A revision search to select the revisions to include.
- * A data ordering flag. There are two values for this - 'unordered' and
-   'topological'. 'unordered' streams are useful when inserting into
-   repositories that have the ability to perform atomic insertions.
-   'topological' streams are useful when converting data, or when
-   inserting into repositories that cannot perform atomic insertions (such
-   as knit or weave based repositories).
- * A complete_inventory flag. When provided this flag signals the stream
-   generator to include all the data needed to construct the inventory of
-   each revision included in the stream, rather than just deltas. This is
-   useful when converting data from a repository with a different
-   inventory serialisation, as pure deltas would not be able to be
-   reconstructed.
-
-
-Structure of a stream
----------------------
-
-A stream is an object. It can be consistency checked via the ``check``
-method (which consumes the stream). The ``iter_contents`` method can be
-used to iterate the contents of the stream. The contents of the stream are
-a series of top level records, each of which contains one or more
-bytestrings (potentially as a delta against another item in the
-repository) and some optional metadata.
-
-
-Consuming a stream
-------------------
-
-To consume a stream, obtain an iterator from the streams
-``iter_contents`` method. This iterator will yield the top level records.
-Each record has two attributes. One is ``key_prefix`` which is a tuple key
-prefix for the names of each of the bytestrings in the record. The other
-attribute is ``entries``, an iterator of the individual items in the
-record. Each item that the iterator yields is a factory which has metadata
-about the entry and the ability to return the compressed bytes. This
-factory can be decorated to allow obtaining different representations (for
-example from a compressed knit fulltext to a plain fulltext). 
-
-In pseudocode::
-
-  stream = repository.get_repository_stream(search, UNORDERED, False)
-  for record in stream.iter_contents():
-      for factory in record.entries:
-          compression = factory.storage_kind
-          print "Object %s, compression type %s, %d bytes long." % (
-              record.key_prefix + factory.key,
-              compression, len(factory.get_bytes_as(compression)))
-
-This structure should allow stream adapters to be written which can coerce
-all records to the type of compression that a particular client needs. For
-instance, inserting into weaves requires fulltexts, so a stream would be
-adapted for weaves by an adapter that takes a stream, and the target
-weave, and then uses the target weave to reconstruct full texts (which is
-all that the weave inserter would ask for). In a similar approach, a
-stream could internally delta compress many fulltexts and be able to
-answer both fulltext and compressed record requests without extra IO.
-
-factory metadata
-~~~~~~~~~~~~~~~~
-
-Valid attributes on the factory are:
- * sha1: Optional ascii representation of the sha1 of the bytestring (after
-   delta reconstruction).
- * storage_kind: Required kind of storage compression that has been used
-   on the bytestring. One of ``mpdiff``, ``knit-annotated-ft``,
-   ``knit-annotated-delta``, ``knit-ft``, ``knit-delta``, ``fulltext``.
- * parents: Required graph parents to associate with this bytestring.
- * compressor_data: Required opaque data relevant to the storage_kind.
-   (This is set to None when the compressor has no special state needed)
- * key: The key for this bytestring. Like each parent this is a tuple that
-   should have the key_prefix prepended to it to give the unified
-   repository key name.
-
-..
-   vim: ft=rst tw=74 ai
-

=== modified file 'doc/developers/repository.txt'
--- doc/developers/repository.txt	2008-03-19 09:41:24 +0000
+++ doc/developers/repository.txt	2007-08-01 00:20:37 +0000
@@ -8,7 +8,7 @@
 :Date: 2007-07-08
 
 This document describes the services repositories offer and need to offer
-within bzrlib.
+within brlib.
 
 
 .. contents::
@@ -271,9 +271,7 @@
 interesting to have it be deterministic based on content, but there are no
 specific problems we have solved by doing that, and doing so would require
 hashing the full file. OTOH hashing the full file is a cheap way to detect
-bit-errors in transfer (such as windows corruption). Non-reused file names
-are required for data integrity, as clients having read an index will
-readv at arbitrary times later. 
+bit-errors in transfer (such as windows corruption).
 
 Discovery of files
 ~~~~~~~~~~~~~~~~~~
@@ -300,6 +298,7 @@
 Choosing compression/delta support
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
+
 Caching and writeing of data
 ============================
 

=== removed file 'doc/developers/testing.txt'
--- doc/developers/testing.txt	2008-08-28 07:11:13 +0000
+++ doc/developers/testing.txt	1970-01-01 00:00:00 +0000
@@ -1,543 +0,0 @@
-=======================
-Guide to Testing Bazaar
-=======================
-
-.. contents::
-
-Testing Bazaar
-##############
-
-The Importance of Testing
-=========================
-
-Reliability is a critical success factor for any Version Control System.
-We want Bazaar to be highly reliable across multiple platforms while
-evolving over time to meet the needs of its community.
-
-In a nutshell, this is what we expect and encourage:
-
-* New functionality should have test cases.  Preferably write the
-  test before writing the code.
-
-  In general, you can test at either the command-line level or the
-  internal API level.  See `Writing tests`_ below for more detail.
-
-* Try to practice Test-Driven Development: before fixing a bug, write a
-  test case so that it does not regress.  Similarly for adding a new
-  feature: write a test case for a small version of the new feature before
-  starting on the code itself.  Check the test fails on the old code, then
-  add the feature or fix and check it passes.
-
-By doing these things, the Bazaar team gets increased confidence that
-changes do what they claim to do, whether provided by the core team or
-by community members. Equally importantly, we can be surer that changes
-down the track do not break new features or bug fixes that you are
-contributing today.
-
-As of May 2008, Bazaar ships with a test suite containing over 12000 tests
-and growing. We are proud of it and want to remain so. As community
-members, we all benefit from it. Would you trust version control on
-your project to a product *without* a test suite like Bazaar has?
-
-
-Running the Test Suite
-======================
-
-Currently, bzr selftest is used to invoke tests.
-You can provide a pattern argument to run a subset. For example,
-to run just the blackbox tests, run::
-
-  ./bzr selftest -v blackbox
-
-To skip a particular test (or set of tests), use the --exclude option
-(shorthand -x) like so::
-
-  ./bzr selftest -v -x blackbox
-
-To ensure that all tests are being run and succeeding, you can use the
---strict option which will fail if there are any missing features or known
-failures, like so::
-
-  ./bzr selftest --strict
-
-To list tests without running them, use the --list-only option like so::
-
-  ./bzr selftest --list-only
-
-This option can be combined with other selftest options (like -x) and
-filter patterns to understand their effect.
-
-Once you understand how to create a list of tests, you can use the --load-list
-option to run only a restricted set of tests that you kept in a file, one test
-id by line. Keep in mind that this will never be sufficient to validate your
-modifications, you still need to run the full test suite for that, but using it
-can help in some cases (like running only the failed tests for some time)::
-
-  ./bzr selftest -- load-list my_failing_tests
-
-This option can also be combined with other selftest options, including
-patterns. It has some drawbacks though, the list can become out of date pretty
-quick when doing Test Driven Development.
-
-To address this concern, there is another way to run a restricted set of tests:
-the --starting-with option will run only the tests whose name starts with the
-specified string. It will also avoid loading the other tests and as a
-consequence starts running your tests quicker::
-
-  ./bzr selftest --starting-with bzrlib.blackbox
-
-This option can be combined with all the other selftest options including
---load-list. The later is rarely used but allows to run a subset of a list of
-failing tests for example.
-
-
-Test suite debug flags
-----------------------
-
-Similar to the global ``-Dfoo`` debug options, bzr selftest accepts
-``-E=foo`` debug flags.  These flags are:
-
-:allow_debug: do *not* clear the global debug flags when running a test.
-  This can provide useful logging to help debug test failures when used
-  with e.g. ``bzr -Dhpss selftest -E=allow_debug``
-
-
-Writing Tests
-=============
-
-Where should I put a new test?
-------------------------------
-
-Bzrlib's tests are organised by the type of test.  Most of the tests in
-bzr's test suite belong to one of these categories:
-
- - Unit tests
- - Blackbox (UI) tests
- - Per-implementation tests
- - Doctests
-
-A quick description of these test types and where they belong in bzrlib's
-source follows.  Not all tests fall neatly into one of these categories;
-in those cases use your judgement.
-
-
-Unit tests
-~~~~~~~~~~
-
-Unit tests make up the bulk of our test suite.  These are tests that are
-focused on exercising a single, specific unit of the code as directly
-as possible.  Each unit test is generally fairly short and runs very
-quickly.
-
-They are found in ``bzrlib/tests/test_*.py``.  So in general tests should
-be placed in a file named test_FOO.py where FOO is the logical thing under
-test.
-
-For example, tests for merge3 in bzrlib belong in bzrlib/tests/test_merge3.py.
-See bzrlib/tests/test_sampler.py for a template test script.
-
-
-Blackbox (UI) tests
-~~~~~~~~~~~~~~~~~~~
-
-Tests can be written for the UI or for individual areas of the library.
-Choose whichever is appropriate: if adding a new command, or a new command
-option, then you should be writing a UI test.  If you are both adding UI
-functionality and library functionality, you will want to write tests for
-both the UI and the core behaviours.  We call UI tests 'blackbox' tests
-and they belong in ``bzrlib/tests/blackbox/*.py``.
-
-When writing blackbox tests please honour the following conventions:
-
- 1. Place the tests for the command 'name' in
-    bzrlib/tests/blackbox/test_name.py. This makes it easy for developers
-    to locate the test script for a faulty command.
-
- 2. Use the 'self.run_bzr("name")' utility function to invoke the command
-    rather than running bzr in a subprocess or invoking the
-    cmd_object.run() method directly. This is a lot faster than
-    subprocesses and generates the same logging output as running it in a
-    subprocess (which invoking the method directly does not).
- 
- 3. Only test the one command in a single test script. Use the bzrlib
-    library when setting up tests and when evaluating the side-effects of
-    the command. We do this so that the library api has continual pressure
-    on it to be as functional as the command line in a simple manner, and
-    to isolate knock-on effects throughout the blackbox test suite when a
-    command changes its name or signature. Ideally only the tests for a
-    given command are affected when a given command is changed.
-
- 4. If you have a test which does actually require running bzr in a
-    subprocess you can use ``run_bzr_subprocess``. By default the spawned
-    process will not load plugins unless ``--allow-plugins`` is supplied.
-
-
-Per-implementation tests
-~~~~~~~~~~~~~~~~~~~~~~~~
-
-Per-implementation tests are tests that are defined once and then run
-against multiple implementations of an interface.  For example,
-``test_transport_implementations.py`` defines tests that all Transport
-implementations (local filesystem, HTTP, and so on) must pass.
-
-They are found in ``bzrlib/tests/*_implementations/test_*.py``,
-``bzrlib/tests/per_*/*.py``, and
-``bzrlib/tests/test_*_implementations.py``.
-
-These are really a sub-category of unit tests, but an important one.
-
-
-Doctests
-~~~~~~~~
-
-We make selective use of doctests__.  In general they should provide
-*examples* within the API documentation which can incidentally be tested.  We
-don't try to test every important case using doctests |--| regular Python
-tests are generally a better solution.  That is, we just use doctests to
-make our documentation testable, rather than as a way to make tests.
-
-Most of these are in ``bzrlib/doc/api``.  More additions are welcome.
-
-  __ http://docs.python.org/lib/module-doctest.html
-
-
-.. Effort tests
-.. ~~~~~~~~~~~~
-
-
-
-Skipping tests
---------------
-
-In our enhancements to unittest we allow for some addition results beyond
-just success or failure.
-
-If a test can't be run, it can say that it's skipped by raising a special
-exception.  This is typically used in parameterized tests |--| for example
-if a transport doesn't support setting permissions, we'll skip the tests
-that relating to that.  ::
-
-    try:
-        return self.branch_format.initialize(repo.bzrdir)
-    except errors.UninitializableFormat:
-        raise tests.TestSkipped('Uninitializable branch format')
-
-Raising TestSkipped is a good idea when you want to make it clear that the
-test was not run, rather than just returning which makes it look as if it
-was run and passed.
-
-Several different cases are distinguished:
-
-TestSkipped
-        Generic skip; the only type that was present up to bzr 0.18.
-
-TestNotApplicable
-        The test doesn't apply to the parameters with which it was run.
-        This is typically used when the test is being applied to all
-        implementations of an interface, but some aspects of the interface
-        are optional and not present in particular concrete
-        implementations.  (Some tests that should raise this currently
-        either silently return or raise TestSkipped.)  Another option is
-        to use more precise parameterization to avoid generating the test
-        at all.
-
-UnavailableFeature
-        The test can't be run because a dependency (typically a Python
-        library) is not available in the test environment.  These
-        are in general things that the person running the test could fix
-        by installing the library.  It's OK if some of these occur when
-        an end user runs the tests or if we're specifically testing in a
-        limited environment, but a full test should never see them.
-
-        See `Test feature dependencies`_ below.
-
-KnownFailure
-        The test exists but is known to fail, for example this might be
-        appropriate to raise if you've committed a test for a bug but not
-        the fix for it, or if something works on Unix but not on Windows.
-        
-        Raising this allows you to distinguish these failures from the
-        ones that are not expected to fail.  If the test would fail
-        because of something we don't expect or intend to fix,
-        KnownFailure is not appropriate, and TestNotApplicable might be
-        better.
-
-        KnownFailure should be used with care as we don't want a
-        proliferation of quietly broken tests.
-
-We plan to support three modes for running the test suite to control the
-interpretation of these results.  Strict mode is for use in situations
-like merges to the mainline and releases where we want to make sure that
-everything that can be tested has been tested.  Lax mode is for use by
-developers who want to temporarily tolerate some known failures.  The
-default behaviour is obtained by ``bzr selftest`` with no options, and
-also (if possible) by running under another unittest harness.
-
-======================= ======= ======= ========
-result                  strict  default lax
-======================= ======= ======= ========
-TestSkipped             pass    pass    pass
-TestNotApplicable       pass    pass    pass
-UnavailableFeature      fail    pass    pass
-KnownFailure            fail    pass    pass
-======================= ======= ======= ========
-     
-
-Test feature dependencies
--------------------------
-
-Writing tests that require a feature
-~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-
-Rather than manually checking the environment in each test, a test class
-can declare its dependence on some test features.  The feature objects are
-checked only once for each run of the whole test suite.
-
-(For historical reasons, as of May 2007 many cases that should depend on
-features currently raise TestSkipped.)
-
-For example::
-
-    class TestStrace(TestCaseWithTransport):
-
-        _test_needs_features = [StraceFeature]
-
-This means all tests in this class need the feature.  If the feature is
-not available the test will be skipped using UnavailableFeature.
-
-Individual tests can also require a feature using the ``requireFeature``
-method::
-
-    self.requireFeature(StraceFeature)
-
-Features already defined in bzrlib.tests include:
-
- - SymlinkFeature,
- - HardlinkFeature,
- - OsFifoFeature,
- - UnicodeFilenameFeature,
- - FTPServerFeature, and
- - CaseInsensitiveFilesystemFeature.
-
-
-Defining a new feature that tests can require
-~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-
-New features for use with ``_test_needs_features`` or ``requireFeature``
-are defined by subclassing ``bzrlib.tests.Feature`` and overriding the
-``_probe`` and ``feature_name`` methods.  For example::
-
-    class _SymlinkFeature(Feature):
-    
-        def _probe(self):
-            return osutils.has_symlinks()
-    
-        def feature_name(self):
-            return 'symlinks'
-    
-    SymlinkFeature = _SymlinkFeature()
-
-
-Testing exceptions and errors
------------------------------
-
-It's important to test handling of errors and exceptions.  Because this
-code is often not hit in ad-hoc testing it can often have hidden bugs --
-it's particularly common to get NameError because the exception code
-references a variable that has since been renamed.
-
-.. TODO: Something about how to provoke errors in the right way?
-
-In general we want to test errors at two levels:
-
-1. A test in ``test_errors.py`` checking that when the exception object is
-   constructed with known parameters it produces an expected string form.
-   This guards against mistakes in writing the format string, or in the
-   ``str`` representations of its parameters.  There should be one for
-   each exception class.
-
-2. Tests that when an api is called in a particular situation, it raises
-   an error of the expected class.  You should typically use
-   ``assertRaises``, which in the Bazaar test suite returns the exception
-   object to allow you to examine its parameters.
-
-In some cases blackbox tests will also want to check error reporting.  But
-it can be difficult to provoke every error through the commandline
-interface, so those tests are only done as needed |--| eg in response to a
-particular bug or if the error is reported in an unusual way(?)  Blackbox
-tests should mostly be testing how the command-line interface works, so
-should only test errors if there is something particular to the cli in how
-they're displayed or handled.
-
-
-Testing warnings
-----------------
-
-The Python ``warnings`` module is used to indicate a non-fatal code
-problem.  Code that's expected to raise a warning can be tested through
-callCatchWarnings.
-
-The test suite can be run with ``-Werror`` to check no unexpected errors
-occur.
-
-However, warnings should be used with discretion.  It's not an appropriate
-way to give messages to the user, because the warning is normally shown
-only once per source line that causes the problem.  You should also think
-about whether the warning is serious enought that it should be visible to
-users who may not be able to fix it.
-
-
-Interface implementation testing and test scenarios
----------------------------------------------------
-
-There are several cases in Bazaar of multiple implementations of a common
-conceptual interface.  ("Conceptual" because it's not necessary for all
-the implementations to share a base class, though they often do.)
-Examples include transports and the working tree, branch and repository
-classes.
-
-In these cases we want to make sure that every implementation correctly
-fulfils the interface requirements.  For example, every Transport should
-support the ``has()`` and ``get()`` and ``clone()`` methods.  We have a
-sub-suite of tests in ``test_transport_implementations``.  (Most
-per-implementation tests are in submodules of ``bzrlib.tests``, but not
-the transport tests at the moment.)
-
-These tests are repeated for each registered Transport, by generating a
-new TestCase instance for the cross product of test methods and transport
-implementations.  As each test runs, it has ``transport_class`` and
-``transport_server`` set to the class it should test.  Most tests don't
-access these directly, but rather use ``self.get_transport`` which returns
-a transport of the appropriate type.
-
-The goal is to run per-implementation only the tests that relate to that
-particular interface.  Sometimes we discover a bug elsewhere that happens
-with only one particular transport.  Once it's isolated, we can consider
-whether a test should be added for that particular implementation,
-or for all implementations of the interface.
-
-The multiplication of tests for different implementations is normally
-accomplished by overriding the ``load_tests`` function used to load tests
-from a module.  This function typically loads all the tests, then applies
-a TestProviderAdapter to them, which generates a longer suite containing
-all the test variations.
-
-See also `Per-implementation tests`_ (above).
-
-
-Test scenarios
---------------
-
-Some utilities are provided for generating variations of tests.  This can
-be used for per-implementation tests, or other cases where the same test
-code needs to run several times on different scenarios.
-
-The general approach is to define a class that provides test methods,
-which depend on attributes of the test object being pre-set with the
-values to which the test should be applied.  The test suite should then
-also provide a list of scenarios in which to run the tests.
-
-Typically ``multiply_tests_from_modules`` should be called from the test
-module's ``load_tests`` function.
-
-
-Test support
-------------
-
-We have a rich collection of tools to support writing tests. Please use
-them in preference to ad-hoc solutions as they provide portability and
-performance benefits.
-
-
-TestCase and its subclasses
-~~~~~~~~~~~~~~~~~~~~~~~~~~~
-
-The ``bzrlib.tests`` module defines many TestCase classes to help you
-write your tests.
-
-TestCase
-    A base TestCase that extends the Python standard library's
-    TestCase in several ways.  It adds more assertion methods (e.g.
-    ``assertContainsRe``), ``addCleanup``, and other features (see its API
-    docs for details).  It also has a ``setUp`` that makes sure that
-    global state like registered hooks and loggers won't interfere with
-    your test.  All tests should use this base class (whether directly or
-    via a subclass).
-
-TestCaseWithMemoryTransport
-    Extends TestCase and adds methods like ``get_transport``,
-    ``make_branch`` and ``make_branch_builder``.  The files created are
-    stored in a MemoryTransport that is discarded at the end of the test.
-    This class is good for tests that need to make branches or use
-    transports, but that don't require storing things on disk.  All tests
-    that create bzrdirs should use this base class (either directly or via
-    a subclass) as it ensures that the test won't accidentally operate on
-    real branches in your filesystem.
-
-TestCaseInTempDir
-    Extends TestCaseWithMemoryTransport.  For tests that really do need
-    files to be stored on disk, e.g. because a subprocess uses a file, or
-    for testing functionality that accesses the filesystem directly rather
-    than via the Transport layer (such as dirstate).
-
-TestCaseWithTransport
-    Extends TestCaseInTempDir.  Provides ``get_url`` and
-    ``get_readonly_url`` facilities.  Subclasses can control the
-    transports used by setting ``vfs_transport_factory``,
-    ``transport_server`` and/or ``transport_readonly_server``.
-
-
-See the API docs for more details.
-
-
-BranchBuilder
-~~~~~~~~~~~~~
-
-When writing a test for a feature, it is often necessary to set up a
-branch with a certain history.  The ``BranchBuilder`` interface allows the
-creation of test branches in a quick and easy manner.  Here's a sample
-session::
-
-  builder = self.make_branch_builder('relpath')
-  builder.build_commit()
-  builder.build_commit()
-  builder.build_commit()
-  branch = builder.get_branch()
-
-``make_branch_builder`` is a method of ``TestCaseWithMemoryTransport``.
-
-Note that many current tests create test branches by inheriting from
-``TestCaseWithTransport`` and using the ``make_branch_and_tree`` helper to
-give them a ``WorkingTree`` that they can commit to. However, using the
-newer ``make_branch_builder`` helper is preferred, because it can build
-the changes in memory, rather than on disk. Tests that are explictly
-testing how we work with disk objects should, of course, use a real
-``WorkingTree``.
-
-Please see bzrlib.branchbuilder for more details.
-
-
-TreeBuilder
-~~~~~~~~~~~
-
-The ``TreeBuilder`` interface allows the construction of arbitrary trees
-with a declarative interface. A sample session might look like::
-
-  tree = self.make_branch_and_tree('path')
-  builder = TreeBuilder()
-  builder.start_tree(tree)
-  builder.build(['foo', "bar/", "bar/file"])
-  tree.commit('commit the tree')
-  builder.finish_tree()
-
-Usually a test will create a tree using ``make_branch_and_memory_tree`` (a
-method of ``TestCaseWithMemoryTransport``) or ``make_branch_and_tree`` (a
-method of ``TestCaseWithTransport``).
-
-Please see bzrlib.treebuilder for more details.
-
-
-.. |--| unicode:: U+2014
-
-..
-   vim: ft=rst tw=74 ai

=== removed file 'doc/developers/tortoise-strategy.txt'
--- doc/developers/tortoise-strategy.txt	2008-05-21 06:33:35 +0000
+++ doc/developers/tortoise-strategy.txt	1970-01-01 00:00:00 +0000
@@ -1,463 +0,0 @@
-Bazaar Windows Shell Extension Options
-======================================
-
-.. contents:: :local:
-
-Introduction
-------------
-
-This document details the implementation strategy chosen for the
-Bazaar Windows Shell Extensions, otherwise known as TortoiseBzr, or TBZR.
-As justification for the strategy, it also describes the general architecture
-of Windows Shell Extensions, then looks at the C++ implemented TortoiseSvn
-and the Python implemented TortoiseBzr, and discusses alternative
-implementation strategies, and the reasons they were not chosen.
-
-The following points summarize the  strategy:
-
-* Main shell extension code will be implemented in C++, and be as thin as
-  possible.  It will not directly do any VCS work, but instead will perform
-  all operations via either external applications or an RPC server.
-
-* Most VCS operations will be performed by external applications.  For
-  example, committing changes or viewing history will spawn a child
-  process that provides its own UI.
-
-* For operations where spawning a child process is not practical, an
-  external RPC server will be implemented in Python and will directly use
-  the VCS library. In the short term, there will be no attempt to create a
-  general purpose RPC mechanism, but instead will be focused on keeping the
-  C++ RPC client as thin, fast and dumb as possible.
-
-Background Information
-----------------------
-
-The facts about shell extensions
-~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-
-Well - the facts as I understand them :)
-
-Shell Extensions are COM objects. They are implemented as DLLs which are
-loaded by the Windows shell. There is no facility for shell extensions to
-exist in a separate process - DLLs are the only option, and they are loaded
-into other processes which take advantage of the Windows shell (although
-obviously this DLL is free to do whatever it likes).
- 
-For the sake of this discussion, there are 2 categories of shell extensions:
- 
-* Ones that create a new "namespace". The file-system itself is an example of
-  such a namespace, as is the "Recycle Bin". For a user-created example,
-  picture a new tree under "My Computer" which allows you to browse a remote
-  server - it creates a new, stand-alone tree that doesn't really interact
-  with the existing namespaces.
- 
-* Ones that enhance existing namespaces, including the filesystem. An example
-  would be an extension which uses Icon Overlays to modify how existing files
-  on disk are displayed or add items to their context menu, for example.
-
-The latter category is the kind of shell extension relevant for TortoiseBzr,
-and it has an important implication - it will be pulled into any process
-which uses the shell to display a list of files. While this is somewhat
-obvious for Windows Explorer (which many people consider the shell), every
-other process that shows a FileOpen/FileSave dialog will have these shell
-extensions loaded into its process space. This may surprise many people - the
-simple fact of allowing the user to select a filename will result in an
-unknown number of DLLs being loaded into your process. For a concrete
-example, when notepad.exe first starts with an empty file it is using around
-3.5MB of RAM. As soon as the FileOpen dialog is loaded, TortoiseSvn loads
-well over 20 additional DLLs, including the MSVC8 runtime, into the Notepad
-process causing its memory usage (as reported by task manager) to more than
-double - all without doing anything tortoise specific at all. (In fairness,
-this illustration is contrived - the code from these DLLs are already in
-memory and there is no reason to suggest TSVN adds any other unreasonable
-burden - but the general point remains valid.)
- 
-This has wide-ranging implications. It means that such shell extensions
-should be developed using a tool which can never cause conflict with
-arbitrary processes. For this very reason, MS recommend against using .NET
-to write shell extensions[1], as there is a significant risk of being loaded
-into a process that uses a different version of the .NET runtime, and this
-will kill the process. Similarly, Python implemented shell extension may well
-conflict badly with other Python implemented applications (and will certainly
-kill them in some situations). A similar issue exists with GUI toolkits used
-- using (say) PyGTK directly in the shell extension would need to be avoided
-(which it currently is best I can tell). It should also be obvious that the
-shell extension will be in many processes simultaneously, meaning use of a
-simple log-file (for example) is problematic.
-
-In practice, there is only 1 truly safe option - a low-level language (such
-as C/C++) which makes use of only the win32 API, and a static version of the
-C runtime library if necessary. Obviously, this sucks from our POV. :)
-
-[1]: http://blogs.msdn.com/oldnewthing/archive/2006/12/18/1317290.aspx
-
-Analysis of TortoiseSVN code
-~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-
-TortoiseSVN is implemented in C++. It relies on an external process to
-perform most UI (such as diff, log, commit etc.) commands, but it appears to
-directly embed the SVN C libraries for the purposes of obtaining status for
-icon overlays, context menu, drag&drop, etc.
-
-The use of an external process to perform commands is fairly simplistic in
-terms of parent and modal windows. For example, when selecting "Commit", a
-new process starts and *usually* ends up as the foreground window, but it may
-occasionally be lost underneath the window which created it, and the user may
-accidently start many processes when they only need 1. Best I can tell, this
-isn't necessarily a limitation of the approach, just the implementation.
-
-Advantages of using the external process is that it keeps all the UI code
-outside Windows explorer - only the minimum needed to perform operations
-directly needed by the shell are part of the "shell extension" and the rest
-of TortoiseSvn is "just" a fairly large GUI application implementing many
-commands. The command-line to the app has even been documented for people who
-wish to automate tasks using that GUI. This GUI is also implemented in C++
-using Windows resource files.
- 
-TortoiseSvn has an option (enabled by default) which enabled a cache using a
-separate process, aptly named TSVNCache.exe. It uses a named pipe to accept
-connections from other processes for various operations. When enabled, TSVN
-fetches most (all?) status information from this process, but it also has the
-option to talk directly to the VCS, along with options to disable functionality
-in various cases.
-
-There doesn't seem to be a good story for logging or debugging - which is
-what you expect from C++ based apps. :( Most of the heavy lifting is done by
-the external application, which might offer better facilities.
-
-Analysis of existing TortoiseBzr code
-~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-
-The existing code is actually quite cool given its history (SoC student,
-etc), so this should not be taken as criticism of the implementer nor of the
-implementation. Indeed, many criticisms are also true of the TortoiseSvn
-implementation - see above. However, I have attempted to list the bad things
-rather than the good things so a clear future strategy can be agreed, with
-all limitations understood.
-
-The existing TortoiseBzr code has been ported into Python from other tortoise
-implementations (probably svn). This means it is very nice to implement and
-develop, but suffers the problems described above - it is likely to conflict
-with other Python based processes, and it means the entire CPython runtime
-and libraries are pulled into many arbitrary processes.
-
-The existing TortoiseBzr code pulls in the bzrlib library to determine the
-path of the bzr library, and also to determine the status of files, but uses
-an external process for most GUI commands - ie, very similar to TortoiseSvn
-as described above - and as such, all comments above apply equally here - but
-note that the bzr library *is* pulled into the shell, and therefore every
-application using the shell. The GUI in the external application is written
-in PyGTK, which may not offer the best Windows "look and feel", but that
-discussion is beyond the scope of this document.
- 
-It has a better story for logging and debugging for the developer - but not
-for diagnosing issues in the field - although again, much of the heavy
-lifting remains done by the external application.
- 
-It uses a rudimentary in-memory cache for the status of files and
-directories, the implementation of which isn't really suitable (ie, no
-theoretical upper bound on cache size), and also means that there is no
-sharing of cached information between processes, which is unfortunate (eg,
-imagine a user using Windows explorer, then switching back to their editor)
-and also error prone (it's possible the editor will check the file in,
-meaning Windows explorer will be showing stale data). This may be possible to
-address via file-system notifications, but a shared cache would be preferred
-(although clearly more difficult to implement).
-
-One tortoise port recently announced a technique for all tortoise ports to
-share the same icon overlays to help work around a limitation in Windows on
-the total number of overlays (it's limited to 15, due to the number of bits
-reserved in a 32bit int for overlays). TBZR needs to take advantage of that
-(but to be fair, this overlay sharing technique was probably done after the
-TBZR implementation).
-
-The current code appears to recursively walk a tree to check if *any* file in
-the tree has changed, so it can reflect this in the parent directory status.
-This is almost certainly an evil thing to do (Shell Extensions are optimized
-so that a folder doesn't even need to look in its direct children for another
-folder, let alone recurse for any reason at all. It may be a network mounted
-drive that doesn't perform at all.)
-
-Although somewhat dependent on bzr itself, we need a strategy for binary
-releases (ie, it assumes python.exe, etc) and integration into an existing
-"blessed" installer.
-
-Trivially, the code is not PEP8 compliant and was written by someone fairly
-inexperienced with the language.
-
-Detailed Implementation Strategy
---------------------------------
-
-We will create a hybrid Python and C++ implementation.  In this model, we
-would still use something like TSVNCache.exe (this external
-process doesn't have the same restrictions as the shell extension itself) but
-go one step further - use this remote process for *all* interactions with
-bzr, including status and other "must be fast" operations. This would allow
-the shell extension itself to be implemented in C++, but still take advantage
-of Python for much of the logic.
-
-A pragmatic implementation strategy will be used to work towards the above
-infrastructure - we will keep the shell extension implemented in Python - but
-without using bzrlib. This allows us to focus on this
-shared-cache/remote-process infrastructure without immediately
-re-implementing a shell extension in C++. Longer term, once the
-infrastructure is in place and as optimized as possible, we can move to C++
-code in the shell calling our remote Python process. This port should try and
-share as much code as possible from TortoiseSvn, including overlay handlers.
-
-External Command Processor
-~~~~~~~~~~~~~~~~~~~~~~~~~~
-
-The external command application (ie, the app invoked by the shell extension
-to perform commands) can remain as-is, and remain a "shell" for other
-external commands. The implementation of this application is not particularly
-relevant to the shell extension, just the interface to the application (ie,
-its command-line) is. In the short term this will remain PyGTK and will only
-change if there is compelling reason - cross-platform GUI tools are a better
-for bazaar than Windows specific ones, although native look-and-feel is
-important. Either way, this can change independently from the shell
-extension.
-
-Performance considerations
-~~~~~~~~~~~~~~~~~~~~~~~~~~
-
-As discussed above, the model used by Tortoise is that most "interesting"
-things are done by external applications. Most Tortoise implementations
-show read-only columns in the "detail" view, and shows a few read only
-properties in the "Properties" dialog - but most of these properties are
-"state" related (eg, revision number), or editing of others is done by
-launching an external application. This means that the shell extension itself
-really has 2 basic requirements WRT RPC: 1) get the local state of a file and
-2) get some named state-related "properties" for a file. Everything else can
-be built on that.
-
-There are 2 aspects of the shell integration which are performance critical -
-the "icon overlays" and "column providers".
-
-The short-story with Icon Overlays is that we need to register 12 global
-"overlay providers" - one for each state we show. Each provider is called for
-every icon ever shown in Windows explorer or in any application's FileOpen
-dialog. While most versions of Windows update icons in the background, we
-still need to perform well. On the positive side, this just needs the simple
-"local state" of a file - information that can probably be carried in a
-single byte. On the negative side, it is the shell which makes a synchronous
-call to us with a single filename as an arg, which makes it difficult to
-"batch" multiple status requests into a single RPC call.
-
-The story with columns is messier - these have changed significantly for
-Vista and the new system may not work with the VCS model (see below).
-However, if we implement this, it will be fairly critical to have
-high-performance name/value pairs implemented, as described above.
-
-Note that the nature of the shell implementation means we will have a large
-number of "unrelated" handlers, each called somewhat independently by the
-shell, often for information about the same file (eg, imagine each of our
-overlay providers all called in turn with the same filename, followed by our
-column providers called in turn with the same filename. However, that isn't
-exactly what happens!). This means we will need a kind of cache, geared
-towards reducing the number of status or property requests we make to the RPC
-server.
-
-We will also allow all of the above to be disabled via user preferences.
-Thus, Icon Overlays could be disabled if it did cause a problem for some
-people, for example.
- 
-RPC options
-~~~~~~~~~~~
-
-Due to the high number of calls for icon overlays, the RPC overhead must be
-kept as low as possible. Due to the client side being implemented in C++,
-reducing complexity is also a goal. Our requirements are quite simple and no
-existing RPC options exist we can leverage. It does not seen prudent to build
-an XMLRPC solution for tbzr - which is not to preclude the use of such a
-server in the future, but tbzr need not become the "pilot" project for an
-XMLRPC server given these constraints.
-
-I propose that a custom RPC mechanism, built initially using windows-specific
-named-pipes, be used. A binary format, designed with an eye towards
-implementation speed and C++ simplicity, will be used. If we succeed here, we
-can build on that infrastructure, and even replace it should other more
-general frameworks materialize.
-
-FWIW, with a Python process at each end, my P4 2.4G machine can achieve
-around 25000 "calls" per-second across an open named pipe. C++ at one end
-should increase this a little, but obviously any real work done by the Python
-side of the process will be the bottle-neck. However, this throughput would
-appear sufficient to implement a prototype.
-
-Vista versus XP
-~~~~~~~~~~~~~~~
-
-Let's try and avoid an OS advocacy debate :) But it is probably true that
-TBZR will, over its life, be used by more Vista computers than XP ones. In
-short, Vista has changed a number of shell related interfaces, and while TSVN
-is slowly catching up (http://tortoisesvn.net/vistaproblems) they are a pain.
-
-XP has IColumnProvider (as implemented by Tortoise), but Vista changes this
-model. The new model is based around "file types" (eg, .jpg files) and it
-appears each file type can only have 1 provider! TSVN also seems to think the
-Vista model isn't going to work (see previous link). It's not clear how much
-effort we should expend on a column system that has already been abandoned by
-MS. I would argue we spend effort on other parts of the system (ie, the
-external GUI apps themselves, etc) and see if a path forward does emerge for
-Vista. We can re-evaluate this based on user feedback and more information
-about features of the Vista property system.
-
-Reuse of TSVNCache?
-~~~~~~~~~~~~~~~~~~~
-
-The RPC mechanism and the tasks performed by the RPC server (rpc, file system
-crawling and watching, device notifications, caching) are very similar to
-those already implemented for TSVN and analysis of that code shows that
-it is not particularly tied to any VCS model.  As a result, consideration
-should be given to making the best use of this existing debugged and
-optimized technology.
-
-Discussions with the TSVN developers have indicated that they would prefer us
-to fork their code rather than introduce complexity and instability into
-their code by attempting to share it. See the follow-ups to
-http://thread.gmane.org/gmane.comp.version-control.subversion.tortoisesvn.devel/32635/focus=32651
-for details.
-
-For background, the TSVNCache process is fairly sophisticated - but mainly in
-areas not related to source control. It has had various performance tweaks
-and is smart in terms of minimizing its use of resources when possible. The
-'cloc' utility counts ~5000 lines of C++ code and weighs in just under 200KB
-on disk (not including headers), so this is not a trivial application.
-However, the code that is of most interest (the crawlers, watchers and cache)
-are roughly ~2500 lines of C++. Most of the source files only depend lightly
-on SVN specifics, so it would not be a huge job to make the existing code
-talk to Bazaar. The code is thread-safe, but not particularly thread-friendly
-(ie, fairly coarse-grained locks are taken in most cases).
-
-In practice, this give us 2 options - "fork" or "port":
-
-* Fork the existing C++ code, replacing the existing source-control code with
-  code that talks to Bazaar. This would involve introducing a Python layer,
-  but only at the layers where we need to talk to bzrlib. The bulk of the
-  code would remain in C++.
-
-  This would have the following benefits:
-
-  - May offer significant performance advantages in some cases (eg, a
-    cache-hit would never enter Python at all.)
-
-  - Quickest time to a prototype working - the existing working code can be
-    used quicker.
-
-  And the following drawbacks:
-
-  - More complex to develop. People wishing to hack on it must be on Windows,
-    know C++ and own the most recent MSVC8.
-
-  - More complex to build and package: people making binaries must be on
-    Windows and have the most recent MSVC8.
-
-  - Is tied to Windows - it would be impractical for this to be
-    cross-platform, even just for test purposes (although parts of it
-    obviously could).
-
-* Port the existing C++ code to Python. We would do this almost
-  "line-for-line", and attempt to keep many optimizations in place (or at
-  least document what the optimizations were for ones we consider dubious).
-  For the windows versions, pywin32 and ctypes would be leaned on - there
-  would be no C++ at all.
-
-  This would have the following benefits:
-
-  - Only need Python and Python skills to hack on it.
-
-  - No C++ compiler needed means easier to cut releases
-
-  - Python makes it easier to understand and maintain - it should appear much
-    less complex than the C++ version.
-
-  And the following drawbacks:
-
-  - Will be slower in some cases - eg, a cache-hit will involve executing
-    Python code.
-
-  - Will take longer to get a minimal system working. In practice this
-    probably means the initial versions will not be as sophisticated.
-
-Given the above, there are two issues which prevent Python being the clear
-winner: (1) will it perform OK? (2) How much longer to a prototype?
-
-My gut feeling on (1) is that it will perform fine, given a suitable Python
-implementation. For example, Python code that simply looked up a dictionary
-would be fast enough - so it all depends on how fast we can make our cache.
-Re (2), it should be possible to have a "stub" process (did almost nothing in
-terms of caching or crawling, but could be connected to by the shell) in a 8
-hours, and some crawling and caching in 40. Note that this is separate from
-the work included for the shell extension itself (the implementation of which
-is largely independent of the TBZRCache implementation). So given the lack of
-a deadline for any particular feature and the better long-term fit of using
-Python, the conclusion is that we should "port" TSVN for bazaar.
-
-Reuse of this code by Mercurial or other Python based VCS systems?
-~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-
-Incidentally, the hope is that this work can be picked up by the Mercurial
-project (or anyone else who thinks it is of use). However, we will limit
-ourselves to attempting to find a clean abstraction for the parts that talk
-to the VCS (as good design would dictate regardless) and then try and assist
-other projects in providing patches which work for both of us. In other
-words, supporting multiple VCS systems is not an explicit goal at this stage,
-but we would hope it is possible in the future.
-
-Implementation plan
--------------------
-
-The following is a high-level set of milestones for the implementation:
-
-* Design the RPC mechanism used for icon overlays (ie, binary format used for
-  communication).
-
-* Create Python prototype of the C++ "shim": modify the existing TBZR Python
-  code so that all references to "bzrlib" are removed. Implement the client
-  side of the RPC mechanism and implement icon overlays using this RPC
-  mechanism.
-
-* Create initial implementation of RPC server in Python. This will use
-  bzrlib, but will also maintain a local cache to achieve the required
-  performance. File crawling and watching will not be implemented at this
-  stage, but caching will (although cache persistence might be skipped).
-
-* Analyze performance of prototype. Verify that technique is feasible and
-  will offer reasonable performance and user experience.
-
-* Implement file watching, crawling etc by "porting" TSVNCache code to
-  Python, as described above.
-
-* Implement C++ shim: replace the Python prototype with a light-weight C++
-  version. We will fork the current TSVN sources, including its new
-  support for sharing icon overlays (although advice on how to setup this
-  fork is needed!)
- 
-* Implement property pages and context menus in C++. Expand RPC server as
-  necessary.
-
-* Create binary for alpha releases, then go round-and-round until its baked.
-
-Alternative Implementation Strategies
--------------------------------------
-
-Only one credible alternative strategy was identified, as discussed below. No
-languages other than Python and C++ were considered; Python as the bzr
-library and existing extensions are written in Python and otherwise only C++
-for reasons outlined in the background on shell extensions above.
-
-Implement Completely in Python
-~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-
-This would keep the basic structure of the existing TBZR code, with the
-shell extension continuing to pull in Python and all libraries used by Bzr
-into various processes.
-
-Although implementation simplicity is a key benefit to this option, it was
-not chosen for various reasons, e.g. the use of Python means that there is a
-larger chance of conflicting with existing applications, or even existing
-Python implemented shell extensions. It will also increase the memory usage
-of all applications which use the shell. While this may create problems for a
-small number of users, it may create a wider perception of instability or
-resource hogging.

=== removed directory 'doc/en/admin-guide'
=== removed file 'doc/en/admin-guide/index.txt'
--- doc/en/admin-guide/index.txt	2008-03-05 16:38:20 +0000
+++ doc/en/admin-guide/index.txt	1970-01-01 00:00:00 +0000
@@ -1,114 +0,0 @@
-==========================
-Bazaar Administrator Guide
-==========================
-
-Note: this is a work in progress!
-
-.. contents:: Table of contents
-   :depth: 2
-
-Introduction
-============
-
-Introduction to administering a Bazaar server installation.
-
-Scope of this guide
--------------------
-
-What you need to run a Bazaar server
-------------------------------------
-
-Platform requirements etc
-
-
-Simple setup
-============
-
-Smart server
-------------
-
-Recommended tools
------------------
-
-
-Migration
-=========
-
-Migrating from another VCS.
-
-Legacy VCS to bzr sync.
-
-
-Hooks
-=====
-
-
-Web-based code browsing
-=======================
-
-Loggerhead etc.
-
-
-Integration with other tools
-============================
-
-PQM
----
-
-Bug trackers
-------------
-
-Continuous integration tools
-----------------------------
-
-e.g. Cruise Control
-
-Bundle Buggy
-------------
-
-
-Security
-========
-
-Authentication
---------------
-
-ACLs
-----
-
-
-Back-up and restore
-===================
-
-
-Upgrades
-========
-
-Software upgrades
------------------
-
-Disk format upgrades
---------------------
-
-Plugin upgrades
----------------
-
-
-System monitoring
-=================
-
-
-Capacity planning tips
-======================
-
-Disk management etc.
-
-
-Advanced topics
-===============
-
-Clustering
-----------
-
-Multi-site setups
------------------

=== modified file 'doc/en/mini-tutorial/index.txt'
--- doc/en/mini-tutorial/index.txt	2008-08-02 17:10:50 +0000
+++ doc/en/mini-tutorial/index.txt	2007-11-04 15:24:27 +0000
@@ -25,16 +25,16 @@
 easy. You can find installation instructions at:
 
 - **GNU/Linux:** Bazaar is probably in your GNU/Linux distribution already.
-- **Windows:** `installation instructions for Windows`_.
-- **Mac OS X:** `installation instructions for Mac OS X`_.
+- **Windows:** `installation instructions`_.
+- **Mac OS X:** `install using MacPorts`_.
 
-For other platforms and to install from source code, see the Download_
+For other platforms and to install from source code, see the Downloads_
 and Installation_ pages.
 
-.. _installation instructions for Windows: http://bazaar-vcs.org/WindowsDownloads
-.. _installation instructions for Mac OS X: http://bazaar-vcs.org/MacOSXBundle
-.. _Download: http://bazaar-vcs.org/Download
-.. _Installation: http://bazaar-vcs.org/InstallationFaq
+.. _installation instructions: http://bazaar-vcs.org/WindowsDownloads
+.. _install using MacPorts: http://bazaar-vcs.org/MacPorts
+.. _Downloads: http://bazaar-vcs.org/Download
+.. _Installation: http://bazaar-vcs.org/InstallationFAQ
 
 
 Introducing yourself
@@ -103,7 +103,7 @@
 Making changes to your files
 ============================
 
-Let's change a file and commit that change to your branch.
+Let's change a file and commit those changes to your branch.
 
 Edit ``test1.txt`` in your favourite editor, then check what have you done::
 
@@ -116,7 +116,7 @@
 
 Commit your work to the Bazaar branch::
 
-  $ bzr commit -m "Added first line of text"
+  $ bzr commit -m 'Added first line of text'
   Committed revision 2.
 
 
@@ -162,13 +162,13 @@
 Bazaar will create a ``myproject`` directory on the remote server and
 push your branch to it.
  
+**Note:** to use sftp, you may need to install ``paramiko`` and
+``pyCrypto``. See http://bazaar-vcs.org/InstallationFaq for details.
+
 Now anyone can create their own copy of your branch by typing::
 
  $ bzr branch http://www.example.com/myproject
  
-**Note:** to use sftp, you may need to install ``paramiko`` and
-``pyCrypto``. See http://bazaar-vcs.org/InstallationFaq for details.
-
 
 Publishing your branch with Launchpad
 =====================================
@@ -225,7 +225,7 @@
 the parent into your personal branch::
 
   $ bzr merge
-  Merging from saved parent location: http://bazaar.launchpad.net/~bzr/bzr-gtk/trunk
+  Using saved location: http://bazaar.launchpad.net/~bzr/bzr-gtk/trunk
   All changes applied successfully.
             
 Check what has changed::
@@ -235,7 +235,7 @@
 If you're happy with the changes, you can commit them to your personal
 branch::
 
-  $ bzr commit -m "Merge from main branch"
+  $ bzr commit -m 'Merge from main branch'
   Committed revision 295.
 
 
@@ -254,7 +254,7 @@
 Replacing ``mycode.patch``, create your merge directive::
 
  $ bzr send -o mycode.patch
- Using saved parent location: http://bazaar.launchpad.net/~bzr/bzr-gtk/trunk
+ Using saved location: http://bazaar.launchpad.net/~bzr/bzr-gtk/trunk
  
 You can now email the merge directive to the bzr-gtk project who, if
 they choose, can use it merge your work back into the parent branch.
@@ -263,8 +263,7 @@
 Learning more
 =============
 
-You can find out more about Bazaar in the
-`Bazaar User Guide <../user-guide/index.html>`_.
+You can find out more about Bazaar in the `Bazaar user guide <../../index.html>`_.
 
 To learn about Bazaar on the command-line::
 

=== removed file 'doc/en/quick-reference/quick-start-summary.pdf'
Binary files doc/en/quick-reference/quick-start-summary.pdf and doc/en/quick-reference/quick-start-summary.pdf differ
=== removed file 'doc/en/quick-reference/quick-start-summary.png'
Binary files doc/en/quick-reference/quick-start-summary.png and doc/en/quick-reference/quick-start-summary.png differ
=== modified file 'doc/en/quick-reference/quick-start-summary.svg'
--- doc/en/quick-reference/quick-start-summary.svg	2007-12-03 14:31:08 +0000
+++ doc/en/quick-reference/quick-start-summary.svg	2007-08-13 14:33:10 +0000
@@ -15,8 +15,8 @@
    sodipodi:version="0.32"
    inkscape:version="0.45.1"
    version="1.0"
-   sodipodi:docbase="/home/ian/bzr/repo.packs/bzr.quick-start-tweaks/doc/en/quick-reference"
-   sodipodi:docname="quick-start-summary.svg"
+   sodipodi:docbase="/home/iacobs/work/pers/bzr-quickref"
+   sodipodi:docname="bzr-quickref.svg"
    inkscape:output_extension="org.inkscape.output.svg.inkscape"
    inkscape:export-filename="/home/iacobs/work/pers/bzr-quickref.png"
    inkscape:export-xdpi="300"
@@ -192,17 +192,17 @@
      inkscape:pageshadow="2"
      inkscape:zoom="0.70710678"
      inkscape:cx="800.64614"
-     inkscape:cy="357.97261"
+     inkscape:cy="357.91315"
      inkscape:document-units="px"
-     inkscape:current-layer="g3488"
+     inkscape:current-layer="layer1"
      width="1052.3622px"
      height="744.09449px"
      inkscape:showpageshadow="false"
-     showgrid="false"
+     showgrid="true"
      inkscape:window-width="1280"
      inkscape:window-height="752"
      inkscape:window-x="0"
-     inkscape:window-y="25" />
+     inkscape:window-y="48" />
   <metadata
      id="metadata2771">
     <rdf:RDF>
@@ -1173,13 +1173,17 @@
            y="505.56467"
            id="text4467"
            sodipodi:linespacing="110%"><tspan
+             id="tspan4471"
+             sodipodi:role="line"
+             x="782.40674"
+             y="505.56467">bzr bundle ../myproject-base \</tspan><tspan
              id="tspan8805"
              sodipodi:role="line"
              x="782.40674"
-             y="505.56467">bzr send</tspan><tspan
+             y="516.638"> --output ../base.patch</tspan><tspan
              sodipodi:role="line"
              x="782.40674"
-             y="516.638"
+             y="527.71133"
              id="tspan4473" /></text>
         <text
            xml:space="preserve"
@@ -1191,10 +1195,10 @@
              id="tspan4608"
              sodipodi:role="line"
              x="776.13232"
-             y="494.69229">Email a merge directive</tspan></text>
+             y="494.69229">Create a revision bundle</tspan></text>
       </g>
       <g
-         transform="translate(1e-4,31.004958)"
+         transform="translate(1e-4,1.0049582)"
          id="g3339">
         <text
            xml:space="preserve"
@@ -1224,7 +1228,7 @@
              y="549.18048">directory</tspan></text>
       </g>
       <g
-         transform="translate(1e-4,33.600285)"
+         transform="translate(1e-4,1.6002853)"
          id="g3332">
         <text
            xml:space="preserve"
@@ -1253,36 +1257,6 @@
              x="776.32574"
              y="595.03461">archive</tspan></text>
       </g>
-      <g
-         transform="translate(-1.4135726,38.47762)"
-         id="g2446">
-        <text
-           xml:space="preserve"
-           style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
-           x="782.40674"
-           y="505.56467"
-           id="text2448"
-           sodipodi:linespacing="110%"><tspan
-             id="tspan2450"
-             sodipodi:role="line"
-             x="782.40674"
-             y="505.56467">bzr send -o ../base.patch</tspan><tspan
-             sodipodi:role="line"
-             x="782.40674"
-             y="516.638"
-             id="tspan2452" /></text>
-        <text
-           xml:space="preserve"
-           style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
-           x="776.13232"
-           y="494.69229"
-           id="text2454"
-           sodipodi:linespacing="100%"><tspan
-             id="tspan2456"
-             sodipodi:role="line"
-             x="776.13232"
-             y="494.69229">Create a merge directive</tspan></text>
-      </g>
     </g>
     <text
        xml:space="preserve"
@@ -1329,7 +1303,7 @@
          sodipodi:role="line"
          id="tspan3411"
          x="146.57143"
-         y="97.808769">Quick Start Card</tspan></text>
+         y="97.808769">Quick Start Guide</tspan></text>
     <g
        id="g12314"
        transform="translate(17.946423,1.7472534)"

=== removed directory 'doc/en/tutorials'
=== removed file 'doc/en/tutorials/using_bazaar_with_launchpad.txt'
--- doc/en/tutorials/using_bazaar_with_launchpad.txt	2008-01-04 19:22:40 +0000
+++ doc/en/tutorials/using_bazaar_with_launchpad.txt	1970-01-01 00:00:00 +0000
@@ -1,456 +0,0 @@
-===========================
-Using Bazaar with Launchpad
-===========================
-
-.. contents::
-.. sectnum::
-
-Motivation
-==========
-
-Communities are different to teams
-----------------------------------
-
-The team of people required to create the initial release
-of a piece of software may vary in size from one person
-to several thousand people. Depending on the requirements,
-the challenges involved, both technical and managerial,
-can be immense. As explained in the Bazaar User Guide, selecting
-"just right" processes and using tools like Bazaar to support
-matching workflows can greatly help.
-
-Success with software though requires more than a great team - it
-requires a healthy, active *community*. This group is typically
-far larger than the team as it includes everyone interested in
-the software: the team, users, training partners, support partners,
-third-party developers and so on.
-
-Great communities are well understood in the open source world.
-Their applicability extends well beyond that though: most
-successful commercial software vendors are well skilled at
-building and managing the communities that grow up around
-their flagship products.
-
-Like great teams, great communities don't just happen.
-Good policies and guidelines are essential for
-fostering the right sort of behaviour and healthy
-relationships between participants. For a deeper look at
-this topic, see Karl Fogel's landmark book:
-`Producing Open Source Software <http://www.producingoss.com/>`_.
-
-
-The need for Collaborative Development Environments
----------------------------------------------------
-
-An intelligent toolset is also important for tracking and managing
-community information and workflows. These tools are called
-Collaborative Development Environments (CDEs). These toolsets are
-typically web-based and manage things such as announcements,
-issues/bugs, questions and answers, downloads, documents and
-source code. Some examples of CDEs include
-`Launchpad <https://launchpad.net>`_,
-`SourceForge <http://sourceforge.net>`_,
-`java.net <http://java.net>`_ and
-`SAP Community Network <https://www.sdn.sap.com/irj/sdn>`_.
-
-
-Helping communities work with related communities
--------------------------------------------------
-
-Many successful products have a huge number of downstream dependencies.
-In other words, a new challenge arises with success: dealing with other
-communities and understanding how your changes will impact them. This is
-most obvious for projects like:
-
-* software languages, e.g. Python, PHP, Ruby, Java, Perl, etc.
-* compilers, e.g. gcc, JDK, etc.
-* libraries, e.g. zlib, openssl, etc.
-* frameworks, e.g. Zope, Ruby on Rails, Spring, etc.
-
-However it applies equally for popular applications on which add-ons are
-built, e.g. Firefox, Thunderbird, OpenOffice.org, Drupal, Wordpress, Joomla,
-etc.
-
-Tools that assist communities work together to track and manage
-issues and fixes across community boundaries are required. These
-tools help people at both ends of the spectrum:
-
-* users can report problems in their terms, e.g. rendering of image
-  type X is broken in application Y on operating system Z
-
-* developers can better appreciate the downstream impact of making a
-  change or fix, e.g. fixing this bug in a graphics library will
-  make the users of these 5 applications on these 10 operating
-  systems happy.
-
-People in the middle play the essential role of *joining the dots* and
-communicating up and down the line. In many cases, they may also fix the
-problem for end users, releasing a patch and pushing a suggested fix
-to the upstream development team. Keeping track of all that over time
-in a sustainable way is no easy task.
-
-
-Launchpad: More development, less friction
-------------------------------------------
-
-As well as sponsoring `Ubuntu <http://www.ubuntu.com>`_ and
-`Bazaar <http://bazaar-vcs.org>`_ development, Canonical
-provides Launchpad, https://launchpad.net, as a free service
-for the open source community. Launchpad is one of the most
-exciting CDEs around for several notable reasons:
-
-* it models relationships between many of things tracked, e.g.
-  source code branches can be associated with bug fixes
-
-* as well are managing historical knowledge,
-  it supports future development planning and tracking by providing
-  features such as roadmaps, milestones and blueprints
-
-* it provides translation tools and packaging services so that
-  barriers are reduced for translators and testers wishing to
-  join your community and help out
-
-* it provides a nexus for different communities to work
-  together on related issues and roadmaps.
-
-In other words, Launchpad has been designed to help your
-comunity grow and to reduce the workflow friction both
-*within* your community and *between* communities. Ultimately,
-that means less time on mechanical tasks and more time for
-interesting development.
-
-
-Bazaar: Launchpad's VCS client
-------------------------------
-
-This tutorial looks at how Bazaar and Launchpad can be used together
-and how they complement each other. It is important to remember that:
-
-1. Bazaar can be used without Launchpad
-2. Launchpad can be used without Bazaar.
-
-By design though, their sum is greater than the individual
-parts.
-
-
-Finding and browsing branches using Launchpad
-=============================================
-
-Finding available branches
---------------------------
-
-While there are many advantages in adopting distributed version
-control, one of the things that disappears is the all-knowing
-central server with knowledge about all available branches. Indeed
-in a distributed environment, interesting branches can literally
-exist in 100s of locations across the Internet (or within an
-Intranet for that matter).
-
-Launchpad fills this gap by providing a registry of branches.
-
-
-Registering branches
---------------------
-
-Branches can be uploaded to Launchpad or simply registered
-as being available in an external location. Branches can also
-be given a Status such as *New*, *Development*, *Mature* or
-*Abandoned*.
-
-Note: External branches can even be hosted in legacy version control
-tools, i.e. CVS and Subversion. Code in these systems will be
-scanned and converted to Bazaar branches on a periodic basis.
-For maximum fidelity of course, it is preferable for external
-branches to be hosted in Bazaar.
-
-
-Browsing branches
------------------
-
-Branches can be listed, filtered and sorted by numerous
-attributes including Name, Registrant, Author, Status, Age and
-time of last commit. Browsing of branches is also provided making
-it easy to see things such as:
-
-* where the branch can be downloaded from
-* how to upload changes
-* recent commits and the changes made by each
-* the source code of individual files for a given version.
-
-
-Accessing code in Launchpad using Bazaar
-========================================
-
-Getting the code for an open source project
--------------------------------------------
-
-As Launchpad keeps track of thousands of open source projects
-and their latest code whether it be managed by Bazaar, CVS or Subversion,
-Bazaar users can grab that code as easily as this::
-
-  bzr branch lp:project-name
-
-where `project-name` is the Launchpad project ID. Here are some examples::
-
-  bzr branch lp:inkscape
-  bzr branch lp:amarok
-  bzr branch lp:python
-  bzr branch lp:rails
-  bzr branch lp:java-gnome
-
-You can then browse the code locally using your favorite editor or IDE and
-change the code if you wish.
-
-If a project has multiple series registered (e.g. a development series and a
-maintenance series), the latest code for a given series can be fetched using::
-
-  bzr branch lp:project-name/series
-
-Publishing your changes
------------------------
-
-Having fixed that annoying bug or added that cool feature you've always
-wanted, it's time to impress your friends and make the world a better
-place by making your code available to others. As explained earlier,
-Launchpad is a free Bazaar code hosting service so you can push your
-branch to it and others can access your code from there. For example,
-assuming you are a member of the relevant team, login to launchpad like this::
-
-  bzr launchpad-login userid
-
-where `userid` is your Launchpad user ID.
-You can then push your changes to a team branch like this::
-
-  bzr push lp:~team-name/project-name/branch-name
-
-Others can then download your code like this::
-
-  bzr branch lp:~team-name/project-name/branch-name
-
-
-Personal branches
------------------
-
-Even if you are not a member of a team, Launchpad can be used to publish
-your changes. In this case, simply create a personal branch like this::
-
-  bzr push lp:~userid/project-name/branch-name
-
-Others can then download your code like this::
-
-  bzr branch lp:~userid/project-name/branch-name
-
-Note: Even when publishing to a personal branch, it is polite to notify the
-upstream developers about your branch so they can pull your changes from
-it if they are generally applicable to all users and meet the project's
-quality standards.
-
-
-Linking branches using Launchpad
-================================
-
-Associating a branch with a bug
--------------------------------
-
-After registering a branch, you can associate it to a bug so that
-people interested in that bug can track and download the fix as
-it becomes available.
-
-To do this, the steps are:
-
-1. Navigate to the bug in question.
-
-2. Select `Add branch` under `Actions`.
-
-3. Select the branch.
-
-4. Optionally set the State of the relationship. This is
-   *Fix In Progress* by default but you may wish to set it
-   to another state such as *Fix Available* if the branch already
-   addresses the issue.
-
-If you wish, you can also provide some arbitrary comments about
-the relationship between the bug and the branch.
-
-
-Changing the state in Launchpad while committing in Bazaar
-----------------------------------------------------------
-
-Bazaar and Launchpad can work together to reduce some of
-the status housekeeping for you. When you commit using Bazaar,
-use the --fixes option like this::
-
-  bzr commit --fixes lp:1234 -m "..."
-
-where 1234 is the bug ID. This will changes the State of the
-bug-branch relationship to *Fix Available*. If the one commit
-fixes multiple issues, the --fixes option can be specified multiple
-times.
-
-One of the cool things about this feature is that Launchpad does
-not need to be accessible when making the commit. The ``--fixes``
-option works by storing metadata which Launchpad will detect next
-time the branch is pushed to it or scanned once online again.
-
-Note: Launchpad will not implicitly close a bug just because a
-branch is available that fixes it. There are several reasons for this.
-Firstly, the branch usually needs to be merged into the trunk
-(main development branch) before most teams consider it fixed.
-Secondly, many teams have a separate process for confirming
-bugs are fixed over and above a developer saying so.
-
-As explained later, merge control features are currently under
-development in Launchpad and automatically changing the status of
-bugs to *Fix Committed* will be more appropriate once those features
-are in place.
-
-
-Associating a branch with a blueprint
--------------------------------------
-
-After registering a branch, you can associate it to a blueprint so that
-people interested in that blueprint can track and test the feature as
-it develops.
-
-To do this, the steps are:
-
-1. Navigate to the blueprint in question.
-
-2. Select `Link branch` under `Actions`.
-
-3. Select the branch.
-
-If you wish, you can also provide some arbitrary comments about
-the relationship between the blueprint and the branch.
-
-
-Managing releases using Launchpad
-=================================
-
-Integrating changes
--------------------
-
-Once a branch has been developed and published, communities
-typically go through a rigorous process before those changes
-are integrated into the core product and rolled out to end users.
-Some of the steps involved may include:
-
-* peer review of the changes
-
-* deciding which releases to include the changes in, e.g. the
-  next maintenance release, the next major release, or both
-
-* running functional regression tests
-
-* benchmarking to ensure performance remains acceptable
-
-* packaging into early access releases for end user testing
-
-* documentation updates, e.g. Release Notes for the targeted
-  releases
-
-* translation of the user interface and documentation into
-  multiple languages.
-
-This section briefly looks at some of the features in Launchpad that
-help get good quality code into production. Strong integration with
-Bazaar is core to making this happen smoothly.
-
-Note: Where indicated, some of the features below are still under
-development. If one or more of these features interest you, please
-consider joining the Launchpad beta test team at this link:
-https://help.launchpad.net/JoiningLaunchpadBetaTesters. You can
-then get early access to features and provide feedback to the
-developers before wider roll-out.
-
-
-Branch merge proposals
-----------------------
-
-After navigating to a branch in Launchpad, one of the available actions
-is *Propose for merging*. This lets you nominate which branch this code
-ought to be merged into.
-
-Tracking the knowledge about which branches are proposed to be merged
-into a codeline helps Release Managers keep on top of what still needs
-to be completed, or can be completed, before a ship date. Using this
-information, they can ensure branches are merged after completing any
-necessary reviews. In the simple case, the Release Manager may manually
-merge branches. In more advanced cases, the merging could be automatically
-done by a robot (like `PQM`_) when the branch reaches the right state
-(e.g. *Review completed*).
-
-.. _PQM: https://launchpad.net/pqm
-
-
-Code review tracking
---------------------
-
-A number of feature are under development in Launchpad to track the
-states, conversations and outcomes of code reviews. These features are
-expected to be integrated with branch merge proposals and branch
-browsing features.
-
-
-Personal Package Archives (PPAs)
---------------------------------
-
-PPAs help developers and development teams get custom builds into the
-hands of users for early testing and feedback. In other words, a PPA
-allows a developer to form a community of testers who are interested
-in their changes. The testing community can install the packages,
-run them for the test period and then remove them cleanly from their
-system.
-
-See https://help.launchpad.net/PPAQuickStart for further details.
-
-
-Translations
-------------
-
-The Translations module in Launchpad is designed to make it easy for
-anyone to get involved translating applications to languages they know.
-Translators are shielded from the low level details.
-
-Launchpad keeps track of the translations for each major version of a
-project separately, allowing translators to continue to improve the
-translations of your stable releases while others start work on newer
-versions that are still in development. Translation speed in reduced
-by sharing resources across projects. Automatic suggestions, from a
-library of 750,000 translated strings, and a community of 19,000
-registered translators can radically cut the time required to
-localise your project into many languages.
-
-
-Summary
-=======
-
-The communities we join, whether off-line or on-line, 
-say a lot about the sort of people we are. The flip-side
-to this is that the tools you choose for your community - particularly
-the CDE and version control tool - can have a large impact on who
-joins and how easily they can contribute.
-
-In their own right, Launchpad and Bazaar are highly useful tools.
-Together, they can:
-
-* help your community track major assets such as source code and knowledge
-* help it grow by reducing barriers to entry
-* help it interact with related communities.
-
-In particular, Launchpad is a free code hosting service for your Bazaar
-branches, branches can be browsed online, branches can be linked to bugs
-and blueprints, and the status of bug-branch relationships can be
-automatically managed by mentioning the bug while commiting in Bazaar.
-Further integration is under development with the aim of streamlining
-the process from *great idea* to *running code in the hands of end users*.
-
-If you have any feedback on how you'd like to see Bazaar and Launchpad
-further integrated, please contact us on the Bazaar mailing list,
-bazaar@lists.canonical.com.
-
-While designed as a free service to support open source projects,
-Canonical may make Launchpad available to commercial software developers
-depending on their requirements. We would be happy to hear from you
-if you think Launchpad would be useful for managing your community,
-open source or otherwise.

=== removed file 'doc/en/user-guide/adv_merging.txt'
--- doc/en/user-guide/adv_merging.txt	2007-12-14 07:35:49 +0000
+++ doc/en/user-guide/adv_merging.txt	1970-01-01 00:00:00 +0000
@@ -1,113 +0,0 @@
-Pseudo merging
-==============
-
-Cherrypicking
--------------
-
-At times, it can be useful to selectively merge some of the changes
-in a branch, but not all of them. This is commonly referred to as
-*cherrypicking*. Here are some examples of where cherrypicking is
-useful:
-
-* selectively taking fixes from the main development branch into
-  a release branch
-
-* selectively taking improvements out of an experimental branch into
-  a feature branch.
-
-To merge only the changes made by revision X in branch ``foo``,
-the command is::
-
-  bzr merge -c X foo
-
-To merge only the changes up to revision X in branch ``foo``,
-the command is::
-
-  bzr merge -r X foo
-
-To merge only the changes since revision X in branch ``foo``,
-the command is::
-
-  bzr merge -r X.. foo
-
-To merge only the changes from revision X to revision Y in branch ``foo``,
-the command is::
-
-  bzr merge -r X..Y foo
-
-Like a normal merge, you must explicitly commit a cherrypick. You may wish
-to see the changes made using ``bzr diff``, and run your test suite if any,
-before doing this.
-
-Unlike a normal merge, Bazaar does not currently track cherrypicks.
-In particular, the changes look like a normal commit and the (internal)
-revision history of the changes from the other branch is lost.
-In many cases where they are useful (see above), this is not a major
-problem because there are good reasons why a full merge should never
-be done at a later time. In other cases, additional conflicts will need
-to be resolved when the changes are merged again.
-
-
-Reverse cherrypicking
----------------------
-
-Cherrypicking can be used to reverse a set of changes made by giving an
-upper bound in the revision range which is *below* the lower bound.
-For example, to back-out changes made in revision 10, the command is::
-
-  bzr merge -r 10..9
-
-If you want to take most changes, but not all, from somewhere else, you
-may wish to do a normal merge followed by a few reverse cherrypicks.
-
-
-Merging uncommitted changes
----------------------------
-
-If you have several branches and you accidently start making changes in the
-wrong one, here are the steps to take to correct this. Assuming you began
-working in branch ``foo`` when you meant to work in branch ``bar``:
-
-1. Change into branch ``bar``.
-2. Run ``bzr merge --uncommitted foo``
-3. Check the changes came across (``bzr diff``)
-4. Change into branch ``foo``
-5. Run ``bzr revert``.
-
-.. TODO Selective file merging?
-
-
-Rebasing
---------
-
-Another option to normal merging is *rebasing*, i.e. making it look like
-the current branch originated from a different point than it did.
-Rebasing is supported in Bazaar by the ``rebase`` command provided by
-the ``rebase`` plugin.
-
-The ``rebase`` command takes the location of another branch on which
-the branch in the current working directory will be rebased. If a branch
-is not specified then the parent branch is used, and this is usually the
-desired result.
-
-The first step identifies the revisions that are in the current branch
-that are not in the parent branch. The current branch is then set to be
-at the same revision as the target branch, and each revision is replayed
-on top of the branch. At the end of the process it will appear as though
-your current branch was branched off the current last revision of the target.
-
-Each revision that is replayed may cause conflicts in the tree. If this
-happens the command will stop and allow you to fix them up. Resolve the
-commits as you would for a ``merge``, and then run ``bzr resolve`` to
-marked them as resolved. Once you have resolved all the conflicts, you
-should run ``bzr rebase-continue`` to continue the rebase operation.
-If conflicts are encountered and you decide not to continue,
-you can run ``bzr rebase-abort``. You can also use ``rebase-todo`` to
-show the list of commits still to be replayed.
-
-Note: Some users coming from central VCS tools with poor merge tracking
-like rebasing because it's similar to how they are use to working in older
-tools, or because "perfectly clean" history seems important. Before rebasing
-in Bazaar, think about whether a normal merge is a better choice. In
-particular, rebasing a private branch before sharing it is OK but
-rebasing after sharing a branch with someone else is **strongly** discouraged.

=== removed file 'doc/en/user-guide/annotating_changes.txt'
--- doc/en/user-guide/annotating_changes.txt	2008-03-27 07:51:10 +0000
+++ doc/en/user-guide/annotating_changes.txt	1970-01-01 00:00:00 +0000
@@ -1,35 +0,0 @@
-Annotating changes
-==================
-
-Seeing the origin of content
-----------------------------
-
-When two or more people are working on files, it can be highly
-useful at times to see who created or last changed certain content.
-To do this, using the annotate command like this::
-
-  bzr annotate readme.txt
-
-If you are a pessimist or an optimist, you might prefer to use
-one of built-in aliases for ``annotate``: ``blame`` or ``praise``.
-Either way, this displays each line of the file together with
-information such as:
-
- * who changed it last
- * when it was last changed
- * the commit message.
-
-GUI tools
----------
-
-The various GUI plugins for Bazaar provide graphical tools for
-viewing annotation information. For example, the bzr-gtk plugin
-provides a GUI tool for this that can be launched using the
-``gannotate`` command::
-
-  bzr gannotate readme.txt
-
-The GUI tools typically provide a much richer display of
-interesting information (e.g. all the changes in each commit)
-so you may prefer them over the text-based command.
-

=== renamed file 'bzrlib/help_topics/en/authentication.txt' => 'doc/en/user-guide/authentication_conf.txt'
--- bzrlib/help_topics/en/authentication.txt	2008-05-09 16:40:21 +0000
+++ doc/en/user-guide/authentication_conf.txt	2007-11-04 15:24:27 +0000
@@ -1,14 +1,15 @@
-Authentication Settings
-=======================
+=================================
+Authentication configuration file
+=================================
 
 
 Intent
-------
+======
 
 Many different authentication policies can be described in the
-``authentication.conf`` file but a particular user should need only a few
-definitions to cover his needs without having to specify a user and a password
-for every branch he uses.
+``$HOME/.bazaar/authentication.conf`` file but a particular user should need
+only a few definitions to cover his needs without having to specify a user and
+a password for every branch he uses.
 
 The definitions found in this file are used to find the credentials to use for
 a given url. The same credentials can generally be used for as many branches as
@@ -40,17 +41,16 @@
   
 
 Authentication definitions
---------------------------
+==========================
 
 There are two kinds of authentication used by the various schemes supported by
 bzr:
 
 1. user and password
 
-``FTP`` needs a (``user``, ``password``) to authenticate against a ``host``
-``SFTP`` can use either a password or a host key to authenticate. However,
-ssh agents are a better, more secure solution. So we have chosen to not provide
-our own less secure method.
+``FTP`` and ``SFTP`` needs a (``user``, ``password``) to authenticate against a
+``host`` (SFTP can use ssh keys too, but we don't talk about that here as ssh
+agents provide a better solution).
 
 2. user, realm and password
 
@@ -108,12 +108,12 @@
 
 
 File format
------------
+===========
 
 The general rules for `configuration files`_ apply except for the variable
 policies.
 
-.. _configuration files: #configuration-settings
+.. _configuration files: configuration.html
 
 Each section describes an authentication definition.
 
@@ -136,11 +136,11 @@
 
 
 Examples
---------
+========
 
 
 Personal projects hosted outside
-~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+--------------------------------
 
 All connections are done with the same ``user`` (the remote one for which the
 default bzr one is not appropriate) and the password is always prompted with
@@ -165,7 +165,7 @@
 
 
 Source hosting provider
-~~~~~~~~~~~~~~~~~~~~~~~
+-----------------------
 
 In the shp.net (fictious) domain, each project has its own site::
 
@@ -175,15 +175,13 @@
         # The leading '.' ensures that 'shp.net' alone doesn't match
         host=.shp.net
         user=joe
-        # bzr don't support supplying a password for sftp,
-        # consider using an ssh agent if you don't want to supply
-        # a password interactively. (pageant, ssh-agent, etc)
+        password=precious
 
 HTTPS, SFTP servers and their proxy
-~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+-----------------------------------
 
-At company.com, the server hosting release and integration branches is behind a
-proxy, and the two branches use different authentication policies::
+At company.com, the server hosting released and integration code is behind a
+proxy, the two servers use different authentication policies::
 
         [reference code]
         scheme=https
@@ -198,6 +196,7 @@
         host=dev.company.com
         path=/dev/integration
         user=user2
+        password=pass2
         
         # proxy
         [proxy]
@@ -209,7 +208,7 @@
 
 
 Planned enhancements
---------------------
+====================
 
 The following are not yet implemented but planned as parts of a work in
 progress:
@@ -225,4 +224,4 @@
 * add a ``verify_certificates`` field for ``HTTPS``.
 
 The ``password_encoding`` and ``verify_certificates`` fields are recognized but
-ignored in the actual implementation.
+ignored in the actual implementation.
\ No newline at end of file

=== removed file 'doc/en/user-guide/bazaar_workflows.txt'
--- doc/en/user-guide/bazaar_workflows.txt	2008-03-27 07:51:10 +0000
+++ doc/en/user-guide/bazaar_workflows.txt	1970-01-01 00:00:00 +0000
@@ -1,171 +0,0 @@
-Workflows
-=========
-
-Bazaar is just a tool
----------------------
-
-Bazaar supports many different ways of working together.
-This means that you can
-start with one workflow and adapt it over time as circumstances
-change. There is no "one true way" that always makes sense and
-there never will be. This section provides a brief overview of
-some popular workflows supported by Bazaar.
-
-Keep in mind that these workflow are just *some* examples of how
-Bazaar can be used. You may want to use a workflow not listed here,
-perhaps building on the ideas below.
-
-Solo
-----
-
-Whether developing software, editing documents or changing configuration files,
-having an easy-to-use VCS tool can help. A single user can use this workflow
-effectively for managing projects where they are the only contributor.
-
-.. image:: images/workflows_single.png
-
-Advantages of this workflow over not using version control at all include:
-
- * backup of old versions
- * rollback to an earlier state
- * tracking of history.
-
-The key features of Bazaar appropriate for this workflow are low administration
-(no server setup) and ease of use.
-
-
-Partner
--------
-
-Sometimes two people need to work together sharing changes as they go. This
-commonly starts off as a *Solo* workflow (see above) or a team-oriented
-workflow (see below). At some point, the second person takes a branch (copy
-including history) of what the first person has done. They can then work in
-parallel exchanging changes by merging when appropriate.
-
-.. image:: images/workflows_peer.png
-
-Advantages over *Solo* are:
-
- * easier sharing of changes
- * each line of each text file can be attributed to a particular change
-   including who changed it, when and why.
-
-When implementing this workflow, Bazaar's advantages over CVS and Subversion include:
-
- * no server to setup
- * intelligent merging means merging multiple times isn't painful.
-
-
-Centralized
------------
-
-Also known as *lock-step*, this is essentially the same as the workflow
-encouraged/enforced by CVS and Subversion. All developers work on the same
-branch (or branches). They run ``bzr update`` to get their checkout up-to-date,
-then ``bzr commit`` to publish their changes to the central location.
-
-.. image:: images/workflows_centralized.png
-
-Subversion and CVS are good choices for implementing this workflow because they
-make it easy. Bazaar directly supports it as well while providing some
-important advantages over CVS and Subversion:
-
- * better branching and merging
- * better renaming support.
-
-
-Centralized with local commits
-------------------------------
-
-This is essentially the same as the *Centralized* model, except that when
-developers are making a series of changes, they do ``commit --local`` or unbind
-their checkout. When it is complete, they commit their work to the shared
-mainline.
-
-.. image:: images/workflows_localcommit.png
-
-Advantages over *Centralized*:
-
- * Can work offline, e.g. when disconnected during travel
- * Less chance for a bad commit to interfere with everyone else's work
-
-Subversion and CVS do not support this model. Other distributed VCS tools can
-support it but do so less directly than Bazaar does.
-
-
-Decentralized with shared mainline
-----------------------------------
-
-In this workflow, each developer has their own branch or branches, plus commit
-rights to the main branch. They do their work in their personal branch, then
-merge it into the mainline when it is ready.
-
-.. image:: images/workflows_shared.png
-
-Advantage over *Centralized with local commits*:
-
- * Easier organization of work - separate changes can be developed in their own branches
- * Developers can merge one another's personal branches when working on something together.
-
-Subversion and CVS do not support this model. Other distributed VCS
-tools support it. Many features of Bazaar are good for this workflow
-including ease of use, shared repositories, integrated merging and
-rich metadata (including directory rename tracking).
-
-
-Decentralized with human gatekeeper
------------------------------------
-
-In this workflow, each developer has their own branch or branches, plus
-read-only access to the main branch. One developer (the gatekeeper) has commit
-rights to the main branch. When a developer wants their work merged, they ask
-the gatekeeper to merge it. The gatekeeper does code review, and merges the
-work into the main branch if it meets the necessary standards.
-
-.. image:: images/workflows_gatekeeper.png
-
-Advantage over *Decentralized with shared mainline*:
-
- * Code is always reviewed before it enters the mainline
- * Tighter control over when changes get incorporated into the mainline.
-
-A companion tool of Bazaar's called Bundle Buggy can be very useful for
-tracking what changes are up for review, their status and reviewer comments.
-
-
-Decentralized with automatic gatekeeper
----------------------------------------
-
-In this workflow, each developer has their own branch or branches, plus
-read-only access to the mainline. A software gatekeeper has commit rights to
-the main branch. When a developer wants their work merged, they request another
-person to review it. Once it has passed review, either the original author or
-the reviewer asks the gatekeeper software to merge it, depending on team
-policies. The gatekeeper software does a merge, a compile, and runs the test
-suite. If and only if the code passes, it is merged into the mainline.
-
-Note: As an alternative, the review step can be skipped and the author can
-submit the change to the automatic gatekeeper without it. (This is particularly
-appropriate when using practices such as Pair Programming that effectively
-promote just-in-time reviews instead of reviewing code as a separate step.)
-
-.. image:: images/workflows_pqm.png
-
-Advantages over *Decentralized with human gatekeeper*:
-
- * Code is always tested before it enters the mainline (so the integrity of the
-   mainline is higher)
- * Scales better as teams grow.
-
-A companion tool of Bazaar's called Patch Queue Manager (PQM) can provide the
-automated gatekeeper capability.
-
-
-Implementing a workflow
------------------------
-
-For an in-depth look at how to implement each of the workflows above,
-see chapters 3 to 6 in this manual. First though, chapter 2
-explains some important pre-requisites including installation, general
-usage instructions and configuration tips.

=== removed file 'doc/en/user-guide/branching_a_project.txt'
--- doc/en/user-guide/branching_a_project.txt	2008-05-29 18:42:07 +0000
+++ doc/en/user-guide/branching_a_project.txt	1970-01-01 00:00:00 +0000
@@ -1,107 +0,0 @@
-Branching a project
-===================
-
-Branch URLs
------------
-
-Before someone else can get a copy of your work, you need to
-agree on a transfer technology.
-You may decide to make the top level directory of your branch
-a network share, an approach familiar to Windows users.
-Linux and OS X users might prefer access to be
-via SFTP, a secure protocol built-in to most SSH servers.
-Bazaar is *very* flexible in this regard with support for
-lots of protocols some of which are given below.
-
-  ===========         ======================================================
-  Prefix              Description
-  ===========         ======================================================
-  file://             Access using the standard filesystem (default)
-  sftp://             Access using SFTP (most SSH servers provide SFTP).
-  bzr://              Fast access using the Bazaar smart server.
-  ftp://              Access using passive FTP.
-  http://             Read-only access to branches exported by a web server.
-  ===========         ======================================================
-
-As indicated above, branches are identified using URLs with the
-prefix indicating the transfer technology. If no prefix is given,
-normal filenames are assumed. For a complete list of supported
-protocols, see the ``urlspec`` online help topic or the
-`URL Identifiers <../user-reference/bzr_man.html#url-identifiers>`_
-section of the Bazaar User Reference.
-
-A reminder about shared repositories
-------------------------------------
-
-Before getting a copy of a branch, have a quick think about
-where to put it on your filesystem. For maximum storage
-efficiency down the track, it is recommended that branches
-be created somewhere under a directory that has been set up
-as a shared repository. For example::
-
-  bzr init-repo my-repo
-  cd my-repo
-
-You are now ready to grab a branch from someone else and
-hack away.
-
-The branch command
-------------------
-
-To get a branch based on an existing branch, use the ``branch`` command.
-The syntax is::
-
-  bzr branch URL [directory]
-
-If a directory is not given, one is created based on the last part of
-the URL. Here are some examples showing a drive qualified path (M:/) and an
-sftp URL respectively::
-
-  bzr branch M:/cool-trunk
-  bzr branch sftp://bill@mary-laptop/cool-repo/cool-trunk
-
-This example shows explicitly giving the directory name to use for the
-new branch::
-
-  bzr branch /home/mary/cool-repo/cool-trunk cool
-
-Time and space considerations
------------------------------
-
-Depending on the size of the branch being transferred and the
-speed and latency of the network between your computer and the
-source branch, this initial transfer might take some time.
-Subsequent updates should be much faster as only the
-changes are transferred then.
-
-Keep in mind that Bazaar is transferring the
-complete history of the branch, not just the latest snapshot.
-As a consequence, you can be off the network (or disconnected
-from the network share) after ``branch`` completes but you'll
-still be able to ``log`` and ``diff`` the history of the
-branch as much as you want. Furthermore, these operations
-are quick as the history is stored locally.
-
-Note that Bazaar uses smart compression technology to
-minimize the amount of disk space required to store version
-history. In many cases, the complete history of a project
-will take up less disk space than the working copy of
-the latest version.
-
-As explained in later chapters, Bazaar also has support for
-lightweight checkouts of a branch, i.e. working trees with
-no local storage of history. Of course, disconnected usage
-is not available then but that's a tradeoff you can decide
-to make if local disk space is really tight for you. Support for
-limited lookback into history - *history horizons* - is
-currently under development as well.
-
-Viewing branch information
---------------------------
-
-If you wish to see information about a branch including where it came from,
-use the ``info`` command. For example::
-
-  bzr info cool
-
-If no branch is given, information on the current branch is displayed.

=== removed file 'doc/en/user-guide/browsing_history.txt'
--- doc/en/user-guide/browsing_history.txt	2008-07-16 00:25:44 +0000
+++ doc/en/user-guide/browsing_history.txt	1970-01-01 00:00:00 +0000
@@ -1,93 +0,0 @@
-Browsing history
-================
-
-bzr log
--------
-
-The ``bzr log`` command shows a list of previous revisions.
-
-As with ``bzr diff``, ``bzr log`` supports the ``-r`` argument::
-
-    % bzr log -r 1000..          # Revision 1000 and everything after it
-    % bzr log -r ..1000          # Everything up to and including r1000
-    % bzr log -r 1000..1100      # changes from 1000 to 1100
-    % bzr log -r 1000            # The changes in only revision 1000
-
-Viewing the mainline
---------------------
-
-As distributed VCS tools like Bazaar make merging much easier than
-it is in central VCS tools, the history of a branch may often show
-lines of development splitting off the mainline and merging back
-in at a later time. Technically, the relationship between the
-numerous revision nodes is known as a Directed Acyclic Graph or
-DAG for short.
-
-In many cases though, you may only be interested in seeing the *mainline*
-for a branch, namely the primary line of development within the DAG.
-To do this, use the following command::
-
-  bzr log --short
-
-If you do this commonly, you may even wish to create an alias for it
-as explained in `Using aliases`_.
-
-Tuning the output
------------------
-
-The ``log`` command has several options that are useful for tuning
-the output. These include:
-
- * ``--forward`` presents the log in chronological order, i.e. the
-   most recent revisions are displayed last.
-
- * the ``--limit`` option controls the maximum number of revisions displayed.
-
-See the online help for the log command or the User Reference for more
-information on tuning the output.
-
-Viewing the history for a file
-------------------------------
-
-It is often useful to filter the history so that it only
-applies to a given file. To do this, provide the filename
-to the ``log`` command like this::
-
-  bzr log foo.py
-
-Viewing an old version of a file
---------------------------------
-
-To get the contents of a file at a given version, use the
-``cat`` command like this::
-
-  bzr cat -r X file
-
-where ``X`` is the revision identifier and ``file`` is
-the filename. This will send output to the standard output
-stream so you'll typically want to pipe the output through
-a viewing tool (like ``less`` or ``more``) or redirect it
-like this::
-
-  bzr cat -r -2 foo.py | less
-  bzr cat -r 1 foo.py > /tmp/foo-1st-version.py
-
-Graphical history viewers
--------------------------
-
-History browsing is one area where GUI tools really make life easier.
-Bazaar has numerous plug-ins that provide this capability including
-QBzr and bzr-gtk. See `Using plugins`_ for details on how to install
-these if they are not already installed.
-
-To use the graphical viewer from QBzr::
-
-  bzr qlog
-
-To use the graphical viewer from bzr-gtk::
-
-  bzr viz
-
-``viz`` is actually a built-in alias for ``visualize`` so use the longer
-command name if you prefer.
-

=== modified file 'doc/en/user-guide/bug_trackers.txt'
--- doc/en/user-guide/bug_trackers.txt	2008-05-16 21:00:25 +0000
+++ doc/en/user-guide/bug_trackers.txt	2007-08-10 05:17:09 +0000
@@ -1,56 +1,78 @@
-Bug trackers
+============
+Bug Trackers
 ============
 
 Bazaar has a facility that allows you to associate a commit with a bug
-in the project's bug tracker. Other tools (or hooks) can then use this
-information to generate hyperlinks between the commit and the bug, or to
-automatically mark the bug closed in the branches that contain the commit.
-
-Associating commits and bugs
-----------------------------
-
-When you make a commit, you can associate it with a bug by using the
+in the project's bug tracker. Other tools can then use this information
+to link between the commit and the bug, or to automatically mark the bug
+closed in the branches that contain the commit.
+
+Associating Commits and Bugs
+============================
+
+When you make a commit you can assiociate it with a bug by using the
 ``--fixes`` option of ``commit``. For example::
 
-    $ bzr commit --fixes lp:12345 -m "Properly close the connection"
-
-This records metadata in Bazaar linking the commit with bug 12345 in
-Launchpad. If you use a different bug tracker, it can be given its own
-tracker code (instead of ``lp``) and used instead. For details on how
-to configure this for Bugzilla, Trac, Roundup and other bug/issue trackers,
-refer to `Bug Tracker Settings`_ in the Bazaar User Reference.
-
-.. _Bug Tracker Settings: ../user-reference/bzr_man.html#bug-tracker-settings
-
-Metadata recording vs bug tracker updating
-------------------------------------------
-
-Recording metadata about bugs fixed at commit time is only
-one of the features needed for complete bug tracker integration.
-As Bazaar is a distributed VCS, users may be offline while committing
-so accessing the bug tracker itself at that time may not be possible.
-Instead, it is recommended that a hook be installed to update
-the bug tracker when changes are pushed to a central location
-appropriate for your project's workflow.
-
-Note: This second processing stage is part of the integration provided
-by Launchpad when it scans external or hosted branches.
-
-Making corrections
-------------------
+    $ bzr commit --fixes 12345 -m 'Properly close the connection on errors'
+
+This will set a revision property on the revision that is committed
+which contains the URI at which more information on the bug can be found.
+Bazaar itself does no more than this, but once the information is recorded
+other tools can make use of it.
+
+Configuration of the Bug Tracker
+================================
+
+As each project has it's own bug tracker, and there are many different
+bug tracking systems you must first do some configuration before you
+can use this system.
+
+Bazaar currently implements support for projects that use Bugzilla or
+Trac to manage their bugs. If your project uses a different system it
+is easy to add support for the system, perhaps through a plugin.
+
+If you do use Bugzilla or Trac then you only need to set a configuration
+variable which contains the base URL of the bug tracker. These options
+can go into ``bazaar.conf``, ``branch.conf`` or into a branch-specific
+configuration section in ``locations.conf``.
+
+You can set up these values for each of the projects you work on in
+``bazaar.conf``, as you specify a short name for each so that you
+can specify which you mean at commit time.
+
+bugzilla_<tracker_abbreviation>_url
+-----------------------------------
+If present, the location of the Bugzilla bug tracker referred to by
+<tracker_abbreviation>. This option can then be used together with ``bzr commit
+--fixes`` to mark bugs in that tracker as being fixed by that commit. For
+example::
+
+    bugzilla_squid_url = http://www.squid-cache.org/bugs
+
+would allow ``bzr commit --fixes squid:1234`` to mark Squid's bug 1234 as
+fixed.
+
+trac_<tracker_abbrevation>_url
+------------------------------
+If present, the location of the Trac instance referred to by
+<tracker_abbreviation>. This option can then be used together with ``bzr commit
+--fixes`` to mark bugs in that tracker as being fixed by that commit. For
+example::
+
+    trac_twisted_url = http://www.twistedmatrix.com/trac
+
+would allow ``bzr commit --fixes twisted:1234`` to mark Twisted's bug 1234 as
+fixed.
+
+Limitations of the system
+=========================
 
 This method of associating revisions and bugs does have some limitations. The
 first is that the association can only be made at commit time. This means that
 if you forget to make the association when you commit, or the bug is reported
-after you fix it, you generally cannot go back and add the link later.
+after you fix it you cannot go back and add the link later.
 
 Related to this is the fact that the association is immutable. If a bug is
-marked as fixed by one commit but that revision does not fully solve the
-bug, or there is a later regression, you cannot go back and remove the link.
-
-Of course, ``bzr uncommit`` can always be used to undo the last commit in
-order to make it again with the correct options. This is commonly done
-to correct a bad commit message and it equally applies to correcting
-metadata recorded (via ``--fixes`` for example) on the last commit.
-
-Note: ``uncommit`` is best done before incorrect revisions become public.
+marked as fixed by one commit, but that revision does not fully solve the
+bug, or there is a later regression you cannot go back and remove the link.
+

=== removed file 'doc/en/user-guide/bzrtools_plugin.txt'
--- doc/en/user-guide/bzrtools_plugin.txt	2008-05-16 21:00:25 +0000
+++ doc/en/user-guide/bzrtools_plugin.txt	1970-01-01 00:00:00 +0000
@@ -1,151 +0,0 @@
-BzrTools
-========
-
-Overview
---------
-
-BzrTools is a collection of useful enhancements to Bazaar.
-For installation instructions, see the BzrTools home page:
-http://bazaar-vcs.org/BzrTools.
-Here is a sample of the frequently used commands it provides.
-
-
-shelve, shelf, unshelve
------------------------
-
-These commands provide a fine-grained (patch-hunk level) undo facility.
-This allows you to put aside some of your changes, commit,
-and get back to where you were before.
-
-For example, consider a working tree with one or more changes made ... ::
-
-  $ bzr diff
-  === modified file 'description.txt'
-  --- description.txt
-  +++ description.txt
-  @@ -2,7 +2,7 @@
-   ===============
-   
-   These plugins
-  -by Michael Ellerman
-  +written by Michael Ellerman
-   provide a very
-   fine-grained 'undo'
-   facility
-  @@ -11,6 +11,6 @@
-   This allows you to 
-   undo some of
-   your changes,
-  -commit, and get
-  +perform a commit, and get
-   back to where you
-   were before.
-
-The ``shelve`` command interactively asks which changes
-you want to retain in the working tree::
-
-  $ bzr shelve
-  --- description.txt
-  +++ description.txt
-  @@ -2,7 +2,7 @@
-   ===============
-   
-   These plugins
-  -by Michael Ellerman
-  +written by Michael Ellerman
-   provide a very
-   fine-grained 'undo'
-   facility
-
-  Keep this change? (1 of 2) [nydisq?] (n): y
-  --- description.txt
-  +++ description.txt
-  @@ -11,6 +11,6 @@
-   This allows you to 
-   undo some of
-   your changes,
-  -commit, and get
-  +perform a commit, and get
-   back to where you
-   were before.
-
-  Keep this change? (2 of 2) [nydisq?] (n): n
-
-  Status:
-    description.txt
-      1 hunks to be shelved
-      1 hunks to be kept
-
-  Shelve these changes, or restart? [yrsiq?] (y): y
-  Saving shelved patches to /tmp/proj/.bzr-shelf
-  Reverting shelved patches
-  Diff status is now:
-   description.txt | 2 +-
-   1 files changes, 1 insertions(+), 1 deletions(-)
-
-If there are lots of changes in the working tree, you
-can provide the ``shelve`` command with a list of files
-and you will only be asked about changes in those files.
-After shelving changes, it's a good idea to use ``diff``
-to confirm the tree has just the changes you expect::
-
-  $ bzr diff
-  === modified file 'description.txt'
-  --- description.txt
-  +++ description.txt
-  @@ -2,7 +2,7 @@
-   ===============
-   
-   These plugins
-  -by Michael Ellerman
-  +written by Michael Ellerman
-   provide a very
-   fine-grained 'undo'
-   facility
-
-Great - you're ready to commit::
-
-  $ bzr commit -m "improve first sentence"
-
-At some later time, you can bring the shelved changes back into the
-working tree using ``unshelve``::
-
-  $ bzr unshelve
-  Reapplying shelved patches 
-  Diff status is now:
-   description.txt | 4 ++--
-   1 files changes, 2 insertions(+), 2 deletions(-)
-
-If you want to, you can put multiple items on the shelf.
-Normally each time you run ``unshelve`` the most recently
-shelved changes will be reinstated. However, you can also
-unshelve changes in a different order by explicitly
-specifying which changes to unshelve. (This works best
-when the changes don't depend on each other.)
-  
-While you have patches on the shelf you can view and manipulate them
-with the ``shelf`` command. Run ``bzr shelf -h`` for more information
-about how to do this.
-
-
-shell
------
-
-``bzr shell`` starts up a command interpreter than understands
-Bazaar commands natively. This has several advantages:
-
- * There's no need to type ``bzr`` at the front of every command.
-
- * Intelligent auto-completion is provided.
-
- * Commands run slightly faster as there's no need to load Bazaar's
-   libraries each time.
-
-
-cdiff
------
-
-``bzr cdiff`` provides a colored version of ``bzr diff`` output.
-On GNU/Linux, UNIX and OS X, this is often used like this::
-
-  bzr cdiff | less -R

=== removed file 'doc/en/user-guide/central_intro.txt'
--- doc/en/user-guide/central_intro.txt	2007-11-23 05:52:03 +0000
+++ doc/en/user-guide/central_intro.txt	1970-01-01 00:00:00 +0000
@@ -1,32 +0,0 @@
-Centralized development
-=======================
-
-Motivation
-----------
-
-Rather than working in parallel and occasionally merging, it can be
-useful at times to work in lockstep, i.e. for multiple people to
-be continuously committing changes to a central location, merging
-their work with the latest content before every commit.
-
-This workflow is very familiar to users of central VCS tools like
-Subversion and CVS. It is also applicable to a single developer
-who works on multiple machines, e.g. someone who normally works
-on a desktop computer but travels with a laptop, or someone who
-uses their (Internet connected) home computer to complete office
-work out of hours.
-
-If centralized development works well for your team already, that's
-great. Many teams begin using Bazaar this way and experiment with
-alternative workflows later.
-
-Centralized workflow
---------------------
-
-The diagram below provides an overview of the *centralized workflow*.
-
-.. image:: images/workflows_centralized.png
-
-Even if your team is planning to use a more distributed workflow, many
-of the tasks covered in this chapter may be useful to you, particularly
-how to publish branches.

=== renamed file 'doc/en/tutorials/centralized_workflow.txt' => 'doc/en/user-guide/centralized_workflow.txt'
=== renamed file 'bzrlib/help_topics/en/configuration.txt' => 'doc/en/user-guide/configuration.txt'
--- bzrlib/help_topics/en/configuration.txt	2008-04-16 02:23:01 +0000
+++ doc/en/user-guide/configuration.txt	2007-11-04 15:24:27 +0000
@@ -1,19 +1,20 @@
-Configuration Settings
-=======================
+====================
+Bazaar configuration
+====================
+
+Information on how to configure Bazaar.
 
 .. TODO: Should have some explanation of why you'd want things in
 .. branch.conf.
 
 
-Environment settings
----------------------
-
+Environment variables
+=====================
 While most configuration is handled by configuration files, some options
 which may be semi-permanent can also be controlled through the environment.
 
 BZR_EMAIL
-~~~~~~~~~
-
+---------
 Override the email id used by Bazaar.  Typical format::
 
   "John Doe <jdoe@example.com>"
@@ -21,71 +22,56 @@
 See also the ``email`` configuration value.
 
 BZR_PROGRESS_BAR
-~~~~~~~~~~~~~~~~
-
+----------------
 Override the progress display.  Possible values are "none", "dots", "tty"
 
 BZR_SIGQUIT_PDB
-~~~~~~~~~~~~~~~
-
+---------------
 Control whether SIGQUIT behaves normally or invokes a breakin debugger.
-
-* 0 = Standard SIGQUIT behavior (normally, exit with a core dump)
-* 1 = Invoke breakin debugger (default)
+0 = Standard SIGQUIT behavior
+1 = Invoke breakin debugger (default)
 
 BZR_HOME
-~~~~~~~~
-
+--------
 Override the home directory used by Bazaar.
 
 BZR_SSH
-~~~~~~~
-
+-------
 Select a different SSH implementation.
 
 BZR_PDB
-~~~~~~~
-
+-------
 Control whether to launch a debugger on error.
-
-* 0 = Standard behavior
-* 1 = Launch debugger
+0 = Standard behavior
+1 = Launch debugger
 
 BZR_REMOTE_PATH
-~~~~~~~~~~~~~~~
-
+---------------
 Path to the Bazaar executable to use when using the bzr+ssh protocol.
 
-See also the ``bzr_remote_path`` configuration value.
+See also the ``bzr_remote_path`` configuration value
 
 BZR_EDITOR
-~~~~~~~~~~
-
+----------
 Path to the editor Bazaar should use for commit messages, etc.
 
 BZR_PLUGIN_PATH
-~~~~~~~~~~~~~~~
-
+---------------
 The path to the plugins directory that Bazaar should use.
 
 BZRPATH
-~~~~~~~
-
+-------
 The path where Bazaar should look for shell plugin external commands.
 
 
 Configuration files
--------------------
+===================
 
 Location
-~~~~~~~~
-
-Configuration files are located in ``$HOME/.bazaar`` on Linux/Unix and
-``C:\Documents and Settings\<username>\Application Data\Bazaar\2.0`` on
-Windows. (You can check the location for your system by using
-``bzr version``.)
-
-There are three primary configuration files in this location:
+--------
+
+Configuration files are located in ``$HOME/.bazaar`` and are
+sometimes referred to as ``ini files``:
 
 * ``bazaar.conf`` describes default configuration options,
 
@@ -101,30 +87,28 @@
 one of the values for a branch with a setting that is specific to you then you
 can do so in ``locations.conf``.
 
-General format
-~~~~~~~~~~~~~~
+General Format
+--------------
 
 An ini file has three types of contructs: section headers, section
 variables and comments.
 
 Comments
-^^^^^^^^
-
+~~~~~~~~
 A comment is any line that starts with a "#" (sometimes called a "hash
 mark", "pound sign" or "number sign"). Comment lines are ignored by
 Bazaar when parsing ini files.
 
-Section headers
-^^^^^^^^^^^^^^^
-
+Section Headers
+~~~~~~~~~~~~~~~
 A section header is a word enclosed in brackets that starts at the begining
 of a line.  A typical section header looks like this::
 
     [DEFAULT]
 
-The only valid section headers for bazaar.conf currently are [DEFAULT] and
-[ALIASES].  Section headers are case sensitive. The default section provides for
-setting variables which can be overridden with the branch config file.
+The only valid section header for bazaar.conf is [DEFAULT], which is
+case sensitive. The default section provides for setting variables
+which can be overridden with the branch config file.
 
 For ``locations.conf``, the variables from the section with the
 longest matching section header are used to the exclusion of other
@@ -135,8 +119,8 @@
     [/home/jdoe/branches/]
 
 
-Section variables
-^^^^^^^^^^^^^^^^^
+Section Variables
+~~~~~~~~~~~~~~~~~
 
 A section variable resides within a section. A section variable contains a
 variable name, an equals sign and a value.  For example::
@@ -145,8 +129,8 @@
     check_signatures = require
 
 
-Variable policies
-^^^^^^^^^^^^^^^^^
+Variable Policies
+~~~~~~~~~~~~~~~~~
 
 Variables defined in a section affect the named directory or URL plus
 any locations they contain.  Policies can be used to change how a
@@ -176,9 +160,9 @@
 
 
 The main configuration file, bazaar.conf
-~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+----------------------------------------
 
-``bazaar.conf`` only allows one
+The main configuration file, ``$HOME/.bazaar/bazaar.conf``, only allows one
 section called ``[DEFAULT]``. This default section contains the default
 configuration options for all branches. The default section can be
 overriden by providing a branch-specific section in ``locations.conf``.
@@ -193,9 +177,9 @@
 
 
 The branch location configuration file, locations.conf
-~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+------------------------------------------------------
 
-``locations.conf`` allows one to specify overriding settings for
+``$HOME/.bazaar/locations.conf`` allows one to specify overriding settings for
 a specific branch. The format is almost identical to the default section in
 bazaar.conf with one significant change: The section header, instead of saying
 default, will be the path to a branch that you wish to override a value
@@ -212,9 +196,9 @@
     check_signatures  = require
 
 The authentication configuration file, authentication.conf
-~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+----------------------------------------------------------
 
-``authentication.conf`` allows one to specify credentials for
+``$HOME/.bazaar/authentication.conf`` allows one to specify credentials for
 remote servers. This can be used for all the supported transports and any part
 of bzr that requires authentication (smtp for example).
 
@@ -222,31 +206,28 @@
 variable policies which don't apply.
 
 For more information on the possible uses of the authentication configuration
-file see `Authentication Settings`_.
-
-
-Common variable options
------------------------
+file see the `authentication configuration file documentation`_.
+
+.. _authentication configuration file documentation: authentication_conf.html
+
+Common Variable Options
+=======================
 
 email
-~~~~~
-
+-----
 The email address to use when committing a branch. Typically takes the form
 of::
 
     email = Full Name <account@hostname.tld>
 
 editor
-~~~~~~
-
+------
 The path of the editor that you wish to use if *bzr commit* is run without
 a commit message. This setting is trumped by the environment variable
-``BZR_EDITOR``, and overrides the ``VISUAL`` and ``EDITOR`` environment
-variables.
+``$BZR_EDITOR``, and overrides ``$VISUAL`` and ``$EDITOR``.
 
 check_signatures
-~~~~~~~~~~~~~~~~
-
+----------------
 Defines the behavior for signatures.
 
 require
@@ -261,8 +242,7 @@
     no signature is present.
 
 create_signatures
-~~~~~~~~~~~~~~~~~
-
+-----------------
 Defines the behaviour of signing revisions.
 
 always
@@ -277,8 +257,7 @@
     requires signatures.
 
 recurse
-~~~~~~~
-
+-------
 Only useful in ``locations.conf``. Defines whether or not the
 configuration for this section applies to subdirectories:
 
@@ -290,16 +269,14 @@
     branches below it.
 
 gpg_signing_command
-~~~~~~~~~~~~~~~~~~~
-
+-------------------
 (Default: "gpg"). Which program should be used to sign and check revisions.
 For example::
 
     gpg_signing_command = /usr/bin/gnpg
 
 bzr_remote_path
-~~~~~~~~~~~~~~~
-
+---------------
 (Default: "bzr").  The path to the command that should be used to run the smart
 server for bzr.  This value may only be specified in locations.conf, because:
 
@@ -310,22 +287,19 @@
 It is overridden by the BZR_REMOTE_PATH environment variable.
 
 smtp_server
-~~~~~~~~~~~
-
+-----------
 (Default: "localhost"). SMTP server to use when Bazaar needs to send
 email, eg. with ``merge-directive --mail-to``, or the bzr-email plugin.
 
 smtp_username, smtp_password
-~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-
+----------------------------
 User and password to authenticate to the SMTP server. If smtp_username
 is set, and smtp_password is not, Bazaar will prompt for a password.
 These settings are only needed if the SMTP server requires authentication
 to send mail.
 
 mail_client
-~~~~~~~~~~~
-
+-----------
 A mail client to use for sending merge requests.
 By default, bzr will try to use ``mapi`` on Windows.  On other platforms, it
 will try ``xdg-email``. If either of these fails, it will fall back to
@@ -349,56 +323,49 @@
 :xdg-email: Use xdg-email to run your preferred mail program
 
 submit_branch
-~~~~~~~~~~~~~
-
+-------------
 The branch you intend to submit your current work to.  This is automatically
 set by ``bzr send``, and is also used by the ``submit:`` revision spec.  This
 should usually be set on a per-branch or per-location basis.
 
 public_branch
-~~~~~~~~~~~~~
-
+-------------
 A publically-accessible version of this branch (implying that this version is
 not publically-accessible).  Used (and set) by ``bzr send``.
 
 
-Branch type specific options
-----------------------------
+Branch 6 Options
+================
 
-These options apply only to branches that use the ``dirstate-tags`` or
-later format.  They
+These options apply only to branches that use the "dirstate-tags" format.  They
 are usually set in ``.bzr/branch/branch.conf`` automatically, but may be
 manually set in ``locations.conf`` or ``bazaar.conf``.
 
 append_revisions_only
-~~~~~~~~~~~~~~~~~~~~~
-
+---------------------
 If set to "True" then revisions can only be appended to the log, not
 removed.  A branch with this setting enabled can only pull from
 another branch if the other branch's log is a longer version of its
 own.  This is normally set by ``bzr init --append-revisions-only``.
 
 parent_location
-~~~~~~~~~~~~~~~
-
+---------------
 If present, the location of the default branch for pull or merge.
 This option is normally set by ``pull --remember`` or ``merge
 --remember``.
 
 push_location
-~~~~~~~~~~~~~
-
+-------------
 If present, the location of the default branch for push.  This option
 is normally set by ``push --remember``.
 
 bound_location
-~~~~~~~~~~~~~~
-
+--------------
 The location that commits should go to when acting as a checkout.
 This option is normally set by ``bind``.
 
 bound
-~~~~~
-
+-----
 If set to "True", the branch should act as a checkout, and push each commit to
 the bound_location.  This option is normally set by ``bind``/``unbind``.
+

=== removed file 'doc/en/user-guide/configuring_bazaar.txt'
--- doc/en/user-guide/configuring_bazaar.txt	2008-08-14 17:25:43 +0000
+++ doc/en/user-guide/configuring_bazaar.txt	1970-01-01 00:00:00 +0000
@@ -1,60 +0,0 @@
-Configuring Bazaar
-==================
-
-Telling Bazaar about yourself
------------------------------
-
-One function of a version control system is to keep track of who changed
-what.  In a decentralized system, that requires an identifier for each
-author that is globally unique.  Most people already have one of these: an
-email address. Bazaar is smart enough to automatically generate an email
-address by looking up your username and hostname. If you don't like the
-guess that Bazaar makes, then use the ``whoami`` command to set the
-identifier you want::
-
-    % bzr whoami "Your Name <email@example.com>"
- 
-If ``whoami`` is used without an argument, the current value is displayed.
-
-Configuration files
--------------------
-
-Configuration files are located in ``$HOME/.bazaar`` on Linux/Unix and
-``C:\Documents and Settings\<username>\Application Data\Bazaar\2.0`` on
-Windows. There are three primary configuration files in this location:
-
-* ``bazaar.conf`` describes default configuration options,
-
-* ``locations.conf`` describes configuration information for
-  specific branch locations,
-
-* ``authentication.conf`` describes credential information for
-  remote servers.
-
-Each branch can also contain a configuration file that sets values specific
-to that branch. This file is found at ``.bzr/branch/branch.conf`` within the
-branch. This file is visible to **all users of a branch**. If you wish to
-override one of the values for a branch with a setting that is specific to you,
-then you can do so in ``locations.conf``.
-
-Here is sample content of ``bazaar.conf`` after setting an email address using
-the ``whoami`` command::
-
-  [DEFAULT]
-  email = Your Name <email@example.com>
-
-For further details on the syntax and configuration settings supported, see
-`Configuration Settings <../user-reference/bzr_man.html#configuration-settings>`_
-in the Bazaar User Reference.
-
-
-Rule-based preferences
-----------------------
-
-Some commands and plugins provide custom processing on files matching
-certain patterns. Per-user rule-based preferences are defined in
-``BZR_HOME/rules``.
-
-For further information on how rules are searched and the detailed syntax of
-the relevant files, see `Rules <../user-reference/bzr_man.html#rules>`_
-in the Bazaar User Reference.

=== renamed file 'bzrlib/help_topics/en/conflicts.txt' => 'doc/en/user-guide/conflicts.txt'
--- bzrlib/help_topics/en/conflicts.txt	2007-12-25 04:17:50 +0000
+++ doc/en/user-guide/conflicts.txt	2007-08-10 05:17:09 +0000
@@ -1,5 +1,6 @@
-Conflicts Types
-===============
+=================
+Conflict handling
+=================
 
 Some operations, like merge, revert and pull, modify the contents of your
 working tree.  These modifications are programmatically generated, and so they
@@ -15,8 +16,7 @@
 
 
 Text conflicts
---------------
-
+==============
 Typical message::
 
   Text conflict in FILE
@@ -58,8 +58,7 @@
 auto-detect which conflicts you have resolved.
 
 Content conflicts
------------------
-
+=================
 Typical message::
 
   Contents conflict in FILE
@@ -79,9 +78,8 @@
 FILE".  Bazaar cannot auto-detect when conflicts of this kind have been
 resolved.
 
-Duplicate paths
----------------
-
+Duplicate Paths
+===============
 Typical message::
 
   Conflict adding file FILE.  Moved existing file to FILE.moved.
@@ -92,9 +90,8 @@
 When you are satisfied, you can run "bzr resolve FILE" to mark the conflict as
 resolved.
 
-Unversioned parent
-------------------
-
+Unversioned Parent
+==================
 Typical message::
 
     Conflict because FILE is not versioned, but has versioned children.
@@ -107,9 +104,8 @@
 the file or the directory.  When you are satisfied, you can run "bzr resolve
 FILE" to mark the conflict as resolved.
 
-Missing parent
---------------
-
+Missing Parent
+==============
 Typical message::
 
   Conflict adding files to FILE.  Created directory.
@@ -122,9 +118,8 @@
 either the file or the directory.  When you are satisfied, you can run "bzr
 resolve FILE" to mark the conflict as resolved.
 
-Deleting parent
----------------
-
+Deleting Parent
+===============
 Typical message::
 
   Conflict: can't delete FILE because it is not empty.  Not deleting.
@@ -135,9 +130,8 @@
 wish to rename or delete either the file or the directory.  When you are
 satisfied, you can run "bzr resolve FILE" to mark the conflict as resolved.
 
-Path conflict
--------------
-
+Path Conflict
+=============
 Typical message::
 
   Path conflict: PATH1 / PATH2
@@ -147,9 +141,8 @@
 can rename the file, and once you have, run "bzr resolve FILE" to mark the
 conflict as resolved.
 
-Parent loop
------------
-
+Parent Loop
+===========
 Typical message::
 
   Conflict moving FILE into DIRECTORY.  Cancelled move.
@@ -173,33 +166,9 @@
 You can rename the directories if you like, and once you have, run "bzr resolve
 FILE" to mark the conflict as resolved.
 
-Non-directory parent
---------------------
-
-Typical message::
-
-  Conflict: FILE.new is not a directory, but has files in it.
-  Created directory.
-
-This happens when one side has added files to a directory, and the othe side
-has changed the directory into a file or symlink.  For example::
-
-  $ bzr init
-  $ bzr mkdir a
-  $ bzr commit -m "BASE"
-  $ bzr branch . ../other
-  $ rmdir a
-  $ touch a
-  $ bzr commit -m "THIS"
-  $ bzr mkdir ../other/a/b
-  $ bzr commit ../other -m "OTHER"
-  $ bzr merge ../other
-
-
 MalformedTransform
-------------------
-
+==================
 It is possible (though very rare) for Bazaar to raise a MalformedTransform
-exception.  This means that Bazaar encountered a filesystem conflict that it was
+exception.  This means that Bazaar encounted a filesystem conflict that it was
 unable to resolve.  This usually indicates a bug.  Please let us know if you
 encounter this.  Our bug tracker is at https://launchpad.net/bzr/+bugs

=== removed file 'doc/en/user-guide/controlling_registration.txt'
--- doc/en/user-guide/controlling_registration.txt	2008-04-18 01:06:17 +0000
+++ doc/en/user-guide/controlling_registration.txt	1970-01-01 00:00:00 +0000
@@ -1,106 +0,0 @@
-Controlling file registration
-=============================
-
-What does Bazaar track?
------------------------
-
-As explained earlier, ``bzr add`` finds and registers all the things in
-and under the current directory that Bazaar thinks ought to be
-version controlled. These things may be:
-
- * files
- * directories
- * symbolic links.
-
-Bazaar has default rules for deciding which files are
-interesting and which ones are not. You can tune those rules as
-explained in `Ignoring files`_ below.
-
-Unlike many other VCS tools, Bazaar tracks directories as first class
-items. As a consequence, empty directories are correctly supported -
-you don't need to create a dummy file inside a directory just to
-ensure it gets tracked and included in project exports.
-
-For symbolic links, the value of the symbolic link is tracked,
-not the content of the thing the symbolic link is pointing to.
-
-Note: Support for tracking projects-within-projects ("nested trees")
-is currently under development. Please contact the Bazaar developers
-if you are interested in helping develop or test this functionality.
-
-Selective registration
-----------------------
-
-In some cases, you may want or need to explicitly nominate the things
-to register rather than leave it up to Bazaar to find things. To do this,
-simply provide paths as arguments to the ``add`` command like this::
-
-  bzr add fileX dirY/
-
-Adding a directory implicitly adds all interesting things
-underneath it.
-
-Ignoring files
---------------
-
-Many source trees contain some files that do not need to be versioned,
-such as editor backups, object or bytecode files, and built programs.  You
-can simply not add them, but then they'll always crop up as unknown files.
-You can also tell Bazaar to ignore these files by adding them to a file
-called ``.bzrignore`` at the top of the tree.
-
-This file contains a list of file wildcards (or "globs"), one per line.
-Typical contents are like this::
-
-    *.o
-    *~
-    *.tmp
-    *.py[co]
-
-If a glob contains a slash, it is matched against the whole path from the
-top of the tree; otherwise it is matched against only the filename.  So
-the previous example ignores files with extension ``.o`` in all
-subdirectories, but this example ignores only ``config.h`` at the top level
-and HTML files in ``doc/``::
-
-    ./config.h
-    doc/*.html
-
-To get a list of which files are ignored and what pattern they matched,
-use ``bzr ignored``::
-
-    % bzr ignored
-    config.h                 ./config.h
-    configure.in~            *~
-
-Note that ignore patterns are only matched against non-versioned files,
-and control whether they are treated as "unknown" or "ignored".  If a file
-is explicitly added, it remains versioned regardless of whether it matches
-an ignore pattern.
-
-The ``.bzrignore`` file should normally be versioned, so that new copies
-of the branch see the same patterns::
-
-    % bzr add .bzrignore
-    % bzr commit -m "Add ignore patterns"
-
-The command ``bzr ignore PATTERN`` can be used to easily add PATTERN to
-the ``.bzrignore file`` (creating it if necessary and registering it to
-be tracked by Bazaar).  Removing and modifying patterns are done by
-directly editing the ``.bzrignore`` file.
-
-Global ignores
---------------
-
-There are some ignored files which are not project specific, but more user
-specific. Things like editor temporary files, or personal temporary files.
-Rather than add these ignores to every project, bzr supports a global
-ignore file in ``~/.bazaar/ignore`` [#]_. It has the same syntax as the
-per-project ignore file.
-
-.. [#] On Windows, the users configuration files can be found in the
-   application data directory. So instead of ``~/.bazaar/branch.conf``
-   the configuration file can be found as: 
-   ``C:\Documents and Settings\<username>\Application Data\Bazaar\2.0\branch.conf``.
-   The same is true for ``locations.conf``, ``ignore``, and the
-   ``plugins`` directory.

=== removed file 'doc/en/user-guide/core_concepts.txt'
--- doc/en/user-guide/core_concepts.txt	2008-05-09 14:59:31 +0000
+++ doc/en/user-guide/core_concepts.txt	1970-01-01 00:00:00 +0000
@@ -1,118 +0,0 @@
-Core concepts
-=============
-
-A simple user model
--------------------
-
-To use Bazaar you need to understand four core concepts:
-
-* **Revision** - a snapshot of the files you're working with.
-
-* **Working tree** - the directory containing your version-controlled
-  files and sub-directories.
-
-* **Branch** - an ordered set of revisions that describe the history of a
-  set of files.
-
-* **Repository** - a store of revisions.
-
-Let's look at each in more detail.
-
-Revision
---------
-
-A revision is a *snapshot* of the state of a tree of files and directories,
-including their content and shape. A revision also has some metadata
-associated with it, including:
-
-* Who committed it
-* When it was committed
-* A commit message
-* Parent revisions from which it was derived
-
-Revisions are immutable and can be globally, uniquely identified
-by a *revision-id*. An example revision-id is::
-
- pqm@pqm.ubuntu.com-20071129184101-u9506rihe4zbzyyz
-
-Revision-ids are generated at commit time or, for imports from other
-systems, at the time of import. While revision-ids are necessary
-for internal use and external tool integration, branch-specific
-*revision numbers* are the preferred interface for humans.
-
-Revision numbers are dotted decimal identifiers like 1, 42 and 2977.1.59
-that trace a path through the revision number graph for a branch.
-Revision numbers are generally shorter than revision-ids and,
-within a single branch, can be compared with each other to get a sense
-of their relationship. For example, revision 10 is the mainline (see below)
-revision immediately after revision 9. Revision numbers
-are generated on the fly when commands are executing, because they
-depend on which revision is the tip (i.e. most recent revision)
-in the branch.
-
-See `Specifying revisions`_ in the appendices for a closer look at
-the numerous ways that revisions and ranges of revisions can be specified
-in Bazaar, and `Understanding Revision Numbers`_ for a more detailed
-description of revision numbering.
-
-.. *TODO: add diagram*
-
-Working Tree
-------------
-
-A working tree is a *version-controlled directory* holding files the user
-can edit. A working tree is associated with a *branch*.
-
-Many commands use the working tree as their context, e.g. ``commit`` makes
-a new revision using the current content of files in the working tree.
-
-.. *TODO: add diagram*
-
-Branch
-------
-
-In the simplest case, a branch is an *ordered series of revisions*.
-The last revision is known as the *tip*.
-
-Branches may split apart and be *merged* back together, forming a
-*graph* of revisions. Technically, the graph shows directed relationships
-(between parent and child revisions) and there are no loops, so
-you may hear some people refer to it as a *directed acyclic graph* or DAG.
-
-If this name sounds scary, don't worry. The important things
-to remember are:
-
-* The primary line of development within the DAG is called
-  the *mainline*, *trunk*, or simply the *left hand side* (LHS).
-
-* A branch might have other lines of development and if it does,
-  these other lines of development begin at some point and end at
-  another point.
-
-.. *TODO: add diagram*
-
-Repository
-----------
-
-A repository is simply a *store of revisions*. In the simplest case,
-each branch has its own repository. In other cases, it makes sense for
-branches to share a repository in order to optimize disk usage.
-
-.. *TODO: add diagram*
-
-Putting the concepts together
------------------------------
-
-Once you have grasped the concepts above, the various ways of using Bazaar
-should become easier to understand. The simplest way of using Bazaar is
-to use a *standalone tree*, which has a working tree, branch, and repository
-all in a single location. Other common scenarios include:
-
-* *Shared repositories* - working tree and branch are colocated, but the
-  repository is in a higher level directory.
-
-* *Lightweight checkouts* - branch is stored is a different location
-  to the working tree.
-
-The best way to use Bazaar, however, depends on your needs. Let's take a
-look at some common workflows next.

=== removed file 'doc/en/user-guide/distributed_intro.txt'
--- doc/en/user-guide/distributed_intro.txt	2008-05-06 14:34:57 +0000
+++ doc/en/user-guide/distributed_intro.txt	1970-01-01 00:00:00 +0000
@@ -1,23 +0,0 @@
-Distributed development
-=======================
-
-Motivation
-----------
-
-Distributed VCS tools offer new ways of working together,
-ways that better reflect the modern world we live in and
-ways that enable higher quality outcomes.
-
-The decentralized with shared mainline workflow
------------------------------------------------
-
-In this workflow, each developer has their own branch or branches, plus
-a checkout of the main branch. They do their work in their personal
-branch, then merge it into the mainline when it is ready.
-
-.. image:: images/workflows_shared.png
-
-Other distributed workflows are explored later in this chapter.
-
-.. 
-   vim: tw=74 ft=rst

=== removed file 'doc/en/user-guide/entering_commands.txt'
--- doc/en/user-guide/entering_commands.txt	2007-11-30 04:28:32 +0000
+++ doc/en/user-guide/entering_commands.txt	1970-01-01 00:00:00 +0000
@@ -1,41 +0,0 @@
-Entering commands
-=================
-
-User interfaces
----------------
-
-There are numerous user interfaces available for Bazaar.
-The core package provides a command line tool called **bzr** and
-graphical user interfaces (GUIs) are available as plug-ins.
-
-Using bzr
----------
-
-The syntax is::
-
-  bzr [global-options] command [options and arguments]
-
-Global options affect how Bazaar operates and can appear either
-before or after ``command``. Command specific options must appear
-after the command but may be given either before, during or after any
-command-specific arguments.
-
-Common options
---------------
-
-Some options are legal for all commands as shown below.
-
-  ==========  =========  =================
-  Short form  Long form  Description
-  ==========  =========  =================
-  -h          --help     get help
-  -v          --verbose  be more verbose
-  -q          --quiet    be more quiet
-  ==========  =========  =================
-
-Quiet mode implies that only errors and warnings are displayed.
-This can be useful in scripts.
-
-Note: Most commands typically only support one level of verbosity though
-that may change in the future. To ask for a higher level of verbosity,
-simply specify the -v option multiple times.

=== removed file 'doc/en/user-guide/getting_help.txt'
--- doc/en/user-guide/getting_help.txt	2007-11-28 00:07:56 +0000
+++ doc/en/user-guide/getting_help.txt	1970-01-01 00:00:00 +0000
@@ -1,19 +0,0 @@
-Getting help
-============
-
-Bazaar comes with a built-in on-line help system. To see the list of topics,
-the command is::
-
-  bzr help
-
-To see the list of commands, the command is::
-
-  bzr help commands
-
-To get help on topic xxx or command xxx, the command is::
-
-  bzr help xxx
-
-If you wish to search the help or read it as a larger document, the
-information is also available in the Bazaar User Reference.
-

=== modified file 'doc/en/user-guide/hooks.txt'
--- doc/en/user-guide/hooks.txt	2008-05-07 06:49:50 +0000
+++ doc/en/user-guide/hooks.txt	2007-08-30 15:55:36 +0000
@@ -1,17 +1,14 @@
+###########
 Using hooks
-===========
-
-What is a hook?
----------------
+###########
 
 One way to customize Bazaar's behaviour is with *hooks*.  Hooks allow you to
 perform actions before or after certain Bazaar operations.  The operations
 include ``commit``, ``push``, ``pull``, and ``uncommit``.
 
-Using hooks
------------
-
-To use a hook, you should `write a plugin <#writing-a-plugin>`_.  Instead of
+Using Hooks
+###########
+To use a hook, you should write a `plugin <plugins.html>`_.  Instead of
 creating a new command, this plugin will define and install the hook.  Here's
 an example::
 
@@ -22,8 +19,8 @@
         print "The new revno is %d" % push_result.new_revno
 
 
-    branch.Branch.hooks.install_named_hook('post_push', post_push_hook,
-                                     'My post_push hook')
+    branch.Branch.hooks.install_hook('post_push', post_push_hook)
+    branch.Branch.hooks.name_hook(post_push_hook, 'My post_push hook')
 
 To use this example, create a file named ``push_hook.py``, and stick it in
 ``plugins`` subdirectory of your configuration directory.  (If you have never
@@ -34,24 +31,15 @@
 single argument, the ``push_result``.
 
 Next, we install the hook.  ``'post_push'`` identifies where we want to install
-the hook, and the second parameter is the hook itself.  We also give the hook a
-name 'My post_push hook', which can be used in progress messages and error
-messages.
+the hook, and the second parameter is the hook itself.
+
+Finally, we name the hook.  This is optional, but it means the hook name can
+be used in progress messages and error messages.
 
 That's it!  The next time you push, it should show "The new revno is...".
 Of course, hooks can be much more elaborate than this, because you have the
 full power of Python at your disposal.  Now that you know how to use hooks,
 what you do with them is up to you.
 
-Standard hooks
---------------
-
-For a complete list of hooks and their parameters, see `Hooks
-<../user-reference/bzr_man.html#hooks>`_ in the User Reference.
-
-Debugging hooks
----------------
-
-To get a list of installed hooks, use the hidden ``hooks`` command::
-
-    bzr hooks
+For a complete list of hooks and their parameters, see the `Hooks Reference
+<../user-reference/hooks.html>`_.

=== modified file 'doc/en/user-guide/http_smart_server.txt'
--- doc/en/user-guide/http_smart_server.txt	2008-01-04 03:12:11 +0000
+++ doc/en/user-guide/http_smart_server.txt	2007-08-22 23:59:17 +0000
@@ -1,16 +1,20 @@
+===========================
 Serving Bazaar with FastCGI
 ===========================
 
+**This feature is EXPERIMENTAL and is NOT SECURE.  It will allow access to
+arbitrary files on your server.**
+
 This document describes one way to set up a Bazaar HTTP smart server,
 using Apache 2.0 and FastCGI or mod_python.
 
 For more information on the smart server, and other ways to configure it
 see the main `smart server documentation`_.
 
-.. _smart server documentation: #running-a-smart-server
+.. _smart server documentation: server.html
 
 Example
--------
+=======
 
 You have a webserver already publishing `/srv/example.com/www/code` as
 `http://example.com/code/...` with plain HTTP.  It contains bzr branches and
@@ -186,7 +190,7 @@
 
 
 Advanced configuration
-----------------------
+======================
 
 Because the Bazaar HTTP smart server is a WSGI application, it can be used with
 any 3rd-party WSGI middleware or server that conforms the WSGI standard.  The
@@ -213,7 +217,7 @@
 
 
 Pushing over ``bzr+http://``
-~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+----------------------------
 
 It is possible to allow pushing data over the http smart server. The
 easiest way to do this, is to just supply ``readonly=False`` to the

=== removed directory 'doc/en/user-guide/images'
=== removed file 'doc/en/user-guide/images/workflows_centralized.png'
Binary files doc/en/user-guide/images/workflows_centralized.png and doc/en/user-guide/images/workflows_centralized.png differ
=== removed file 'doc/en/user-guide/images/workflows_centralized.svg'
--- doc/en/user-guide/images/workflows_centralized.svg	2007-11-30 04:34:08 +0000
+++ doc/en/user-guide/images/workflows_centralized.svg	1970-01-01 00:00:00 +0000
@@ -1,1542 +0,0 @@
-<?xml version="1.0" encoding="UTF-8" standalone="no"?>
-<!-- Created with Inkscape (http://www.inkscape.org/) -->
-<svg
-   xmlns:dc="http://purl.org/dc/elements/1.1/"
-   xmlns:cc="http://web.resource.org/cc/"
-   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
-   xmlns:svg="http://www.w3.org/2000/svg"
-   xmlns="http://www.w3.org/2000/svg"
-   xmlns:xlink="http://www.w3.org/1999/xlink"
-   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"
-   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"
-   width="1052.3622"
-   height="744.09448"
-   id="svg2"
-   sodipodi:version="0.32"
-   inkscape:version="0.45.1"
-   version="1.0"
-   sodipodi:docbase="/home/ian/Desktop/talk/workflows"
-   sodipodi:docname="workflows_centralized.svg"
-   inkscape:output_extension="org.inkscape.output.svg.inkscape"
-   inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_centralized.png"
-   inkscape:export-xdpi="90"
-   inkscape:export-ydpi="90">
-  <defs
-     id="defs4">
-    <radialGradient
-       xlink:href="#linearGradient5992"
-       r="33.156250"
-       inkscape:collect="always"
-       id="radialGradient6000"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(1.000000,0.000000,0.000000,1.693685,0.000000,-197.9515)"
-       fy="285.36218"
-       fx="495.50000"
-       cy="285.36218"
-       cx="495.50000" />
-    <linearGradient
-       y2="187.57059"
-       y1="225.40080"
-       xlink:href="#linearGradient5963"
-       x2="458.91232"
-       x1="383.95898"
-       inkscape:collect="always"
-       id="linearGradient5969"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       id="linearGradient3586">
-      <stop
-         style="stop-color:#000000;stop-opacity:1.0000000;"
-         offset="0.0000000"
-         id="stop3588" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0;"
-         offset="1"
-         id="stop3590" />
-    </linearGradient>
-    <linearGradient
-       inkscape:collect="always"
-       id="linearGradient5963">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:1;"
-         offset="0"
-         id="stop5965" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0;"
-         offset="1"
-         id="stop5967" />
-    </linearGradient>
-    <linearGradient
-       inkscape:collect="always"
-       id="linearGradient5992">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:1;"
-         offset="0"
-         id="stop5994" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0;"
-         offset="1"
-         id="stop5996" />
-    </linearGradient>
-    <linearGradient
-       y2="-0.45783132"
-       y1="3.3012049"
-       xlink:href="#linearGradient893"
-       x2="0.92957747"
-       x1="-2.3960868e-17"
-       id="linearGradient4284" />
-    <linearGradient
-       y2="-0.033519555"
-       y1="2.0837989"
-       xlink:href="#linearGradient893"
-       x2="0.99074072"
-       x1="-0.77314812"
-       id="linearGradient4283" />
-    <linearGradient
-       y2="1.8771822"
-       y1="-0.033741195"
-       xlink:href="#linearGradient902"
-       x2="0.48453596"
-       x1="0.47041038"
-       id="linearGradient2740"
-       gradientTransform="scale(0.997153,1.002855)" />
-    <linearGradient
-       y2="1.9025002"
-       y1="-0.043652620"
-       xlink:href="#linearGradient902"
-       x2="0.48481107"
-       x1="0.47042510"
-       id="linearGradient1506"
-       gradientTransform="scale(0.995847,1.004170)" />
-    <linearGradient
-       y2="1.8570156"
-       y1="-0.024853170"
-       xlink:href="#linearGradient902"
-       x2="0.48548824"
-       x1="0.47157744"
-       id="linearGradient1505"
-       gradientTransform="scale(0.997825,1.002180)" />
-    <linearGradient
-       y2="182.99154"
-       y1="169.09755"
-       xlink:href="#linearGradient892"
-       x2="88.996957"
-       x1="88.755695"
-       id="linearGradient1404"
-       gradientTransform="scale(1.3695887,0.7301462)"
-       gradientUnits="userSpaceOnUse" />
-    <radialGradient
-       xlink:href="#linearGradient1317"
-       r="0.34964636"
-       id="radialGradient1316"
-       fy="0.18269235"
-       fx="0.50352114"
-       cy="0.50000006"
-       cx="0.50000000" />
-    <radialGradient
-       xlink:href="#linearGradient1317"
-       r="0.41197181"
-       id="radialGradient1315"
-       fy="0.26666668"
-       fx="0.47535211"
-       cy="0.53333336"
-       cx="0.47887325" />
-    <linearGradient
-       y2="173.03153"
-       y1="177.77768"
-       xlink:href="#linearGradient902"
-       x2="95.100155"
-       x1="101.10657"
-       id="linearGradient1171"
-       gradientTransform="scale(1.3601783,0.7351977)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="1.8378206"
-       y1="-0.016295359"
-       xlink:href="#linearGradient902"
-       x2="0.48655096"
-       x1="0.47284532"
-       id="linearGradient1170"
-       gradientTransform="scale(0.998371,1.001632)" />
-    <linearGradient
-       y2="81.477602"
-       y1="224.57898"
-       xlink:href="#linearGradient893"
-       x2="74.533693"
-       x1="146.69923"
-       id="linearGradient1169"
-       gradientTransform="scale(1.1870691,0.842411)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="133.54711"
-       y1="228.39311"
-       xlink:href="#linearGradient888"
-       x2="88.447016"
-       x1="141.60217"
-       id="linearGradient1167"
-       gradientTransform="scale(1.1838753,0.8446836)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="148.78619"
-       y1="131.25248"
-       xlink:href="#linearGradient1317"
-       x2="107.04918"
-       x1="111.49758"
-       id="linearGradient1166"
-       gradientTransform="scale(1.223869,0.8170809)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="176.28694"
-       y1="269.85831"
-       xlink:href="#linearGradient888"
-       x2="-16.224496"
-       x1="51.460928"
-       id="linearGradient1157"
-       gradientTransform="scale(2.4217071,0.4129318)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="234.26866"
-       y1="178.48862"
-       xlink:href="#linearGradient888"
-       x2="25.220815"
-       x1="25.220815"
-       id="linearGradient1156"
-       gradientTransform="scale(2.4217071,0.4129318)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="105.42543"
-       y1="76.277559"
-       xlink:href="#linearGradient892"
-       x2="8.346058"
-       x1="35.190362"
-       id="linearGradient1150"
-       gradientTransform="scale(1.3283861,0.7527932)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="20.481863"
-       y1="49.507656"
-       xlink:href="#linearGradient892"
-       x2="70.224305"
-       x1="39.690614"
-       id="linearGradient1148"
-       gradientTransform="scale(1.329144,0.7523639)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="113.71949"
-       y1="90.197025"
-       xlink:href="#linearGradient892"
-       x2="17.876529"
-       x1="39.810948"
-       id="linearGradient1146"
-       gradientTransform="scale(1.3207392,0.7571517)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="251.21892"
-       y1="203.499"
-       xlink:href="#linearGradient892"
-       x2="31.617281"
-       x1="31.449743"
-       id="linearGradient1144"
-       gradientTransform="scale(2.1051174,0.4750329)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="-0.45783132"
-       y1="3.3012049"
-       xlink:href="#linearGradient888"
-       x2="0.92957747"
-       x1="0.00000000"
-       id="linearGradient1141" />
-    <linearGradient
-       y2="232.24952"
-       y1="110.4447"
-       xlink:href="#linearGradient888"
-       x2="41.967061"
-       x1="45.685757"
-       id="linearGradient1140"
-       gradientTransform="scale(1.9102155,0.5235012)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="75.912531"
-       y1="375.92199"
-       xlink:href="#linearGradient1806"
-       x2="-268.25407"
-       x1="-249.72067"
-       id="linearGradient1138"
-       gradientTransform="scale(1.087146,0.9198397)"
-       gradientUnits="userSpaceOnUse" />
-    <radialGradient
-       xlink:href="#linearGradient1133"
-       r="68.589222"
-       id="radialGradient1132"
-       fy="39.288476"
-       fx="72.107883"
-       cy="56.485935"
-       cx="60.004654"
-       gradientTransform="scale(1.2267534,0.8151598)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="11.699047"
-       y1="208.43991"
-       xlink:href="#linearGradient888"
-       x2="95.644441"
-       x1="-77.726178"
-       id="linearGradient905"
-       gradientTransform="scale(1.0964158,0.9120627)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       xlink:href="#linearGradient1806"
-       id="linearGradient901" />
-    <linearGradient
-       y2="91.07699"
-       y1="-3.9104078"
-       xlink:href="#linearGradient888"
-       x2="27.674331"
-       x1="92.437968"
-       id="linearGradient891"
-       gradientTransform="scale(1.2267534,0.8151598)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       id="linearGradient888">
-      <stop
-         style="stop-color:#626262;stop-opacity:1.0000000;"
-         offset="0.0000000"
-         id="stop889" />
-      <stop
-         style="stop-color:#fff;stop-opacity:1;"
-         offset="1"
-         id="stop890" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient892">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.00000000;"
-         offset="0.00000000"
-         id="stop893" />
-      <stop
-         style="stop-color:#fff;stop-opacity:1;"
-         offset="1"
-         id="stop894" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient902">
-      <stop
-         style="stop-color:#000000;stop-opacity:0.00000000;"
-         offset="0.00000000"
-         id="stop903" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0.22000000;"
-         offset="1.0000000"
-         id="stop904" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient1098">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:1.0000000;"
-         offset="0.00000000"
-         id="stop1099" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.22314049;"
-         offset="0.50000000"
-         id="stop1101" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.00000000;"
-         offset="0.59930235"
-         id="stop1102" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.60330576;"
-         offset="1.0000000"
-         id="stop1100" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient1133">
-      <stop
-         style="stop-color:#8bb7df;stop-opacity:1.0000000;"
-         offset="0.00000000"
-         id="stop1134" />
-      <stop
-         style="stop-color:#2a6092;stop-opacity:1.0000000;"
-         offset="0.76209301"
-         id="stop1136" />
-      <stop
-         style="stop-color:#375e82;stop-opacity:1.0000000;"
-         offset="1.0000000"
-         id="stop1135" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient1317">
-      <stop
-         style="stop-color:#000000;stop-opacity:0.52892560;"
-         offset="0.00000000"
-         id="stop1318" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0.17355372;"
-         offset="0.50000000"
-         id="stop1320" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0.00000000;"
-         offset="1.0000000"
-         id="stop1319" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient893">
-      <stop
-         style="stop-color:#000;stop-opacity:1;"
-         offset="0"
-         id="stop895" />
-      <stop
-         style="stop-color:#fff;stop-opacity:1;"
-         offset="1"
-         id="stop896" />
-    </linearGradient>
-    <radialGradient
-       xlink:href="#linearGradient1806"
-       r="11.574221"
-       id="radialGradient1977"
-       fy="39.410465"
-       fx="42.280806"
-       cy="39.007645"
-       cx="42.007257"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       id="linearGradient1806">
-      <stop
-         style="stop-color:#000000;stop-opacity:0.35051546;"
-         offset="0.0000000"
-         id="stop1807" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0.13402061;"
-         offset="0.64999998"
-         id="stop3276" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop1808" />
-    </linearGradient>
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient5281"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient5283"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient5285"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <radialGradient
-       xlink:href="#linearGradient4362"
-       r="5.5130484"
-       inkscape:collect="always"
-       id="radialGradient1828"
-       fy="61.38567"
-       fx="86.542037"
-       cy="61.38567"
-       cx="86.542037"
-       gradientTransform="matrix(-0.8164966,0,0,1.2247449,262.80373,-280)"
-       gradientUnits="userSpaceOnUse" />
-    <radialGradient
-       xlink:href="#linearGradient4362"
-       r="11.123441"
-       inkscape:collect="always"
-       id="radialGradient1824"
-       fy="58.887858"
-       fx="118.06427"
-       cy="58.54025"
-       cx="117.17439"
-       gradientTransform="matrix(-0.6229142,0,0,1.6053575,262.80373,-280)"
-       gradientUnits="userSpaceOnUse" />
-    <radialGradient
-       xlink:href="#linearGradient4362"
-       r="22.00904"
-       inkscape:collect="always"
-       id="radialGradient1822"
-       fy="87.892895"
-       fx="45.50637"
-       cy="88.322677"
-       cx="45.139623"
-       gradientTransform="matrix(-1.0914815,0,0,0.9161859,262.80373,-280)"
-       gradientUnits="userSpaceOnUse" />
-    <radialGradient
-       xlink:href="#linearGradient4362"
-       r="18.836343"
-       inkscape:collect="always"
-       id="radialGradient1818"
-       fy="33.351633"
-       fx="48.40165"
-       cy="32.467054"
-       cx="48.40165"
-       gradientTransform="matrix(-1.1146027,0,0,0.8971807,262.80373,-280)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="74.834393"
-       y1="57.093738"
-       xlink:href="#linearGradient4376"
-       x2="50.203204"
-       x1="50.52668"
-       inkscape:collect="always"
-       id="linearGradient1815"
-       gradientTransform="matrix(-1.3516689,0,0,0.7398261,262.80373,-280)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       id="linearGradient4384">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.77513230;"
-         offset="0.0000000"
-         id="stop4385" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop4386" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient4376">
-      <stop
-         style="stop-color:#000000;stop-opacity:0.52645504;"
-         offset="0.0000000"
-         id="stop4377" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop4378" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient4362">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.66666669;"
-         offset="0.0000000"
-         id="stop4363" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop4364" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient4358">
-      <stop
-         style="stop-color:#000;stop-opacity:1;"
-         offset="0"
-         id="stop4359" />
-      <stop
-         style="stop-color:#fff;stop-opacity:1;"
-         offset="1"
-         id="stop4360" />
-    </linearGradient>
-    <radialGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="radialGradient5536"
-       gradientUnits="userSpaceOnUse"
-       cx="42.007257"
-       cy="39.007645"
-       fx="42.280806"
-       fy="39.410465"
-       r="11.574221" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient5538"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient5540"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient5542"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient5544"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient888"
-       id="linearGradient5546"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(2.4217071,0.4129318)"
-       x1="25.220815"
-       y1="178.48862"
-       x2="25.220815"
-       y2="234.26866" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient888"
-       id="linearGradient5548"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(2.4217071,0.4129318)"
-       x1="51.460928"
-       y1="269.85831"
-       x2="-16.224496"
-       y2="176.28694" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient893"
-       id="linearGradient5550"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.1870691,0.842411)"
-       x1="146.69923"
-       y1="224.57898"
-       x2="74.533693"
-       y2="81.477602" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient888"
-       id="linearGradient5552"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.9102155,0.5235012)"
-       x1="45.685757"
-       y1="110.4447"
-       x2="41.967061"
-       y2="232.24952" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient888"
-       id="linearGradient5554"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.0964158,0.9120627)"
-       x1="-77.726178"
-       y1="208.43991"
-       x2="95.644441"
-       y2="11.699047" />
-    <radialGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1133"
-       id="radialGradient5556"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.2267534,0.8151598)"
-       cx="60.004654"
-       cy="56.485935"
-       fx="72.107883"
-       fy="39.288476"
-       r="68.589222" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient888"
-       id="linearGradient5558"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.2267534,0.8151598)"
-       x1="92.437968"
-       y1="-3.9104078"
-       x2="27.674331"
-       y2="91.07699" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient892"
-       id="linearGradient5560"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.3207392,0.7571517)"
-       x1="39.810948"
-       y1="90.197025"
-       x2="17.876529"
-       y2="113.71949" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient892"
-       id="linearGradient5562"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.329144,0.7523639)"
-       x1="39.690614"
-       y1="49.507656"
-       x2="70.224305"
-       y2="20.481863" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient892"
-       id="linearGradient5564"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.3283861,0.7527932)"
-       x1="35.190362"
-       y1="76.277559"
-       x2="8.346058"
-       y2="105.42543" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient888"
-       id="linearGradient5566"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.1838753,0.8446836)"
-       x1="141.60217"
-       y1="228.39311"
-       x2="88.447016"
-       y2="133.54711" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient902"
-       id="linearGradient5568"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.3601783,0.7351977)"
-       x1="101.10657"
-       y1="177.77768"
-       x2="95.100155"
-       y2="173.03153" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient892"
-       id="linearGradient5570"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.3695887,0.7301462)"
-       x1="88.755695"
-       y1="169.09755"
-       x2="88.996957"
-       y2="182.99154" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1317"
-       id="linearGradient5572"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.223869,0.8170809)"
-       x1="111.49758"
-       y1="131.25248"
-       x2="107.04918"
-       y2="148.78619" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient892"
-       id="linearGradient5574"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(2.1051174,0.4750329)"
-       x1="31.449743"
-       y1="203.499"
-       x2="31.617281"
-       y2="251.21892" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient5714"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <radialGradient
-       xlink:href="#linearGradient4362"
-       r="39.648127"
-       inkscape:collect="always"
-       id="radialGradient2797"
-       fy="101.92288"
-       fx="50.092871"
-       cy="102.70191"
-       cx="49.760482"
-       gradientTransform="scale(1.1222336,0.8910801)"
-       gradientUnits="userSpaceOnUse" />
-    <radialGradient
-       xlink:href="#linearGradient4362"
-       r="35.284406"
-       inkscape:collect="always"
-       id="radialGradient2791"
-       fy="32.061308"
-       fx="81.553592"
-       cy="33.402904"
-       cx="80.599566"
-       gradientTransform="scale(0.8352269,1.1972794)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="67.164412"
-       y1="53.505203"
-       xlink:href="#linearGradient4376"
-       x2="63.804663"
-       x1="64.786456"
-       inkscape:collect="always"
-       id="linearGradient2789"
-       gradientTransform="scale(1.1424512,0.8753109)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       id="linearGradient6015">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.77513230;"
-         offset="0.0000000"
-         id="stop6017" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop6019" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient6009">
-      <stop
-         style="stop-color:#000000;stop-opacity:0.52645504;"
-         offset="0.0000000"
-         id="stop6011" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop6013" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient6003">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.66666669;"
-         offset="0.0000000"
-         id="stop6005" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop6007" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient5997">
-      <stop
-         style="stop-color:#000;stop-opacity:1;"
-         offset="0"
-         id="stop5999" />
-      <stop
-         style="stop-color:#fff;stop-opacity:1;"
-         offset="1"
-         id="stop6001" />
-    </linearGradient>
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient6037"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <linearGradient
-       y2="0.46093750"
-       y1="0.46093750"
-       xlink:href="#linearGradient650"
-       x2="1.16666818"
-       x1="1.22222710"
-       spreadMethod="repeat"
-       id="linearGradient654"
-       gradientUnits="objectBoundingBox" />
-    <linearGradient
-       y2="0.53906250"
-       y1="0.53125000"
-       xlink:href="#linearGradient650"
-       x2="1.16666901"
-       x1="1.00000548"
-       spreadMethod="repeat"
-       id="linearGradient653"
-       gradientUnits="objectBoundingBox" />
-    <linearGradient
-       id="linearGradient650">
-      <stop
-         style="stop-color:#000;stop-opacity:1;"
-         offset="0"
-         id="stop651" />
-      <stop
-         style="stop-color:#fff;stop-opacity:1;"
-         offset="1"
-         id="stop652" />
-    </linearGradient>
-    <linearGradient
-       y2="0.46093750"
-       y1="0.46093750"
-       xlink:href="#linearGradient650"
-       x2="1.16666818"
-       x1="1.22222710"
-       spreadMethod="repeat"
-       id="linearGradient9648"
-       gradientUnits="objectBoundingBox" />
-    <linearGradient
-       y2="0.53906250"
-       y1="0.53125000"
-       xlink:href="#linearGradient650"
-       x2="1.16666901"
-       x1="1.00000548"
-       spreadMethod="repeat"
-       id="linearGradient9646"
-       gradientUnits="objectBoundingBox" />
-    <linearGradient
-       id="linearGradient9640">
-      <stop
-         style="stop-color:#000;stop-opacity:1;"
-         offset="0"
-         id="stop9642" />
-      <stop
-         style="stop-color:#fff;stop-opacity:1;"
-         offset="1"
-         id="stop9644" />
-    </linearGradient>
-  </defs>
-  <sodipodi:namedview
-     id="base"
-     pagecolor="#ffffff"
-     bordercolor="#666666"
-     borderopacity="1.0"
-     gridtolerance="10000"
-     guidetolerance="10"
-     objecttolerance="10"
-     inkscape:pageopacity="0.0"
-     inkscape:pageshadow="2"
-     inkscape:zoom="1.4142136"
-     inkscape:cx="536.99132"
-     inkscape:cy="369.73871"
-     inkscape:document-units="px"
-     inkscape:current-layer="layer1"
-     width="1052.3622px"
-     height="744.09448px"
-     showgrid="true"
-     inkscape:window-width="1024"
-     inkscape:window-height="712"
-     inkscape:window-x="-4"
-     inkscape:window-y="-4" />
-  <metadata
-     id="metadata7">
-    <rdf:RDF>
-      <cc:Work
-         rdf:about="">
-        <dc:format>image/svg+xml</dc:format>
-        <dc:type
-           rdf:resource="http://purl.org/dc/dcmitype/StillImage" />
-      </cc:Work>
-    </rdf:RDF>
-  </metadata>
-  <g
-     inkscape:label="Layer 1"
-     inkscape:groupmode="layer"
-     id="layer1">
-    <g
-       inkscape:label="Layer 1"
-       id="g4996"
-       transform="matrix(0.331077,0,0,0.2676656,75.992157,230.68349)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157">
-      <g
-         transform="matrix(2.674162,0,0,2.674162,-826.248,-323.8239)"
-         id="g6052">
-        <path
-           style="fill:#c7c7c7;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:6.11299896;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
-           sodipodi:nodetypes="czcczzz"
-           id="path1306"
-           d="M 362.77592,187.283 C 360.50343,190.98677 361.20593,367.68763 364.14011,374.65173 C 366.46268,380.1642 441.02381,442.12988 444.93699,443.78694 C 495.35017,443.444 529.34176,425.0858 534.99109,415.38735 C 537.14042,403.1889 535.31621,215.19709 533.25552,211.25359 C 531.47859,207.85312 436.04893,173.6386 432.71615,172.86054 C 429.71763,172.16052 365.30189,183.1661 362.77592,187.283 z " />
-        <path
-           style="fill:#ffffff;fill-opacity:0.54385968;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
-           sodipodi:nodetypes="ccccccc"
-           id="path2066"
-           d="M 366.42857,190.93361 C 391.19048,201.4098 418.60601,218.30739 446.22506,231.64072 C 472.394,225.42153 510.2022,217.10972 529.24981,213.77639 C 504.726,221.39543 472.52022,228.51448 447.99641,236.13353 C 446.56784,293.51448 447.257,380.45861 445.82843,437.83956 C 445.11414,379.98242 443.14285,291.6479 442.42856,233.79075 C 415.99999,219.50504 390,206.64789 366.42857,190.93361 z " />
-        <path
-           style="fill:#000000;fill-opacity:0.16228069;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
-           sodipodi:nodetypes="ccc"
-           id="path4356"
-           d="M 519.99794,379.97737 C 510.93834,392.99882 482.41849,399.43361 468.8726,394.16864 C 471.21835,393.5424 516.96143,380.96883 519.99794,379.97737 z " />
-        <g
-           transform="translate(2.035534,15.20712)"
-           id="g4374">
-          <path
-             style="fill:#ffffff;fill-opacity:0.39473685;fill-rule:evenodd;stroke:none;stroke-width:1.01199996;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
-             sodipodi:nodetypes="cccccc"
-             id="path4362"
-             d="M 471.29127,340.59039 L 513.55921,324.30516 C 517.9002,325.84805 517.04588,332.27818 517.04588,332.27818 L 510.46155,334.58088 C 510.46155,334.58088 501.26764,349.01224 484.93096,343.36795 C 484.93096,343.36795 472.7787,345.52605 471.29127,340.59039 z " />
-          <path
-             style="fill:#606060;fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:1.11199999;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
-             sodipodi:nodetypes="ccccccc"
-             id="path2826"
-             d="M 471.66824,335.10501 C 485.70133,331.45482 499.73443,327.80464 513.76752,324.15445 C 514.30594,326.13864 514.34437,328.99782 513.50779,330.48201 C 511.36566,331.50652 507.10221,332.35425 504.96008,333.37876 C 498.80357,339.27354 493.45917,339.80363 483.65919,338.95243 C 479.87505,339.74603 476.0909,340.36284 472.30676,341.15644 C 471.15285,338.85897 470.82215,337.90248 471.66824,335.10501 z " />
-        </g>
-        <path
-           style="fill:#ffffff;fill-opacity:0.40350874;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
-           sodipodi:nodetypes="ccccc"
-           id="path4423"
-           d="M 364.8671,189.69191 L 446.71991,235.61832 L 446.39149,441.00771 L 366.28132,373.53968 L 364.8671,189.69191 z " />
-        <path
-           style="fill:#000000;fill-opacity:0.16228069;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
-           sodipodi:nodetypes="ccc"
-           id="path5957"
-           d="M 515.24794,392.97737 C 505.81506,405.42036 486.94113,407.56087 476.3726,403.76831 C 478.1563,403.29212 512.93901,393.73127 515.24794,392.97737 z " />
-        <path
-           style="fill:#000000;fill-opacity:0.16228069;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
-           sodipodi:nodetypes="ccc"
-           id="path5959"
-           d="M 508.24794,405.72737 C 502.79158,413.09279 492.2492,415.37141 483.8726,412.49343 C 484.991,412.19485 506.80021,406.20008 508.24794,405.72737 z " />
-        <path
-           style="fill:#fcfcfc;fill-opacity:0.44298245;fill-rule:evenodd;stroke:none;stroke-width:0.31200001;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
-           sodipodi:nodetypes="ccccccc"
-           id="path5973"
-           d="M 522.875,227.86218 L 527.04289,228.4302 L 527.79289,326.56929 L 463.46862,344.54896 L 461.88388,339.34073 L 523.68934,322.86218 L 522.875,227.86218 z " />
-        <path
-           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
-           sodipodi:nodetypes="cccc"
-           id="path6026"
-           d="M 462.21967,264.23013 L 462.31434,266.99086 L 522.7929,249.54632 L 462.21967,264.23013 z " />
-        <path
-           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
-           sodipodi:nodetypes="cccc"
-           id="path6036"
-           d="M 461.33579,284.2059 L 461.43046,286.96663 L 521.90902,269.52209 L 461.33579,284.2059 z " />
-        <path
-           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
-           sodipodi:nodetypes="cccc"
-           id="path6038"
-           d="M 462.21967,302.64613 L 462.31434,305.40686 L 522.7929,287.96232 L 462.21967,302.64613 z " />
-        <path
-           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
-           sodipodi:nodetypes="cccc"
-           id="path6040"
-           d="M 462.21967,320.79868 L 462.31434,323.55941 L 522.7929,306.11487 L 462.21967,320.79868 z " />
-        <path
-           style="opacity:1;color:#000000;fill:none;fill-opacity:0.75;fill-rule:evenodd;stroke:#9e9e9e;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
-           sodipodi:nodetypes="ccc"
-           id="path5988"
-           d="M 522.55191,229.64344 L 462.03362,244.76045 L 462.53549,344.35813" />
-      </g>
-    </g>
-    <g
-       id="g5256"
-       transform="translate(601.5744,207.49165)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157">
-      <path
-         transform="matrix(6.392368,0.545409,-0.130014,2.864752,-184.6606,-38.15109)"
-         style="fill:url(#radialGradient1977);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:type="arc"
-         sodipodi:ry="12.562782"
-         sodipodi:rx="12.562782"
-         sodipodi:cy="37.865574"
-         sodipodi:cx="41.875938"
-         id="path1976"
-         d="M 54.438721 37.865574 A 12.562782 12.562782 0 1 1  29.313156,37.865574 A 12.562782 12.562782 0 1 1  54.438721 37.865574 z" />
-      <g
-         transform="matrix(1,0,0,1.036969,356.8306,-11.4294)"
-         style="fill:url(#linearGradient6037);fill-opacity:1"
-         id="g4293">
-        <path
-           style="fill:url(#linearGradient5281);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
-           id="path2720"
-           d="M -270.85787,33.814995 C -289.35564,33.925992 -307.93321,33.592782 -326.38104,33.981747 C -331.43469,35.696391 -331.02221,41.899652 -330.68524,46.15332 C -330.75782,60.227303 -330.53537,74.298225 -330.21167,88.36826 C -328.21297,91.039611 -323.21766,90.618387 -322.68469,94.539015 C -320.78054,96.259426 -317.05071,94.88215 -314.4389,95.333237 C -298.54999,95.360274 -282.66107,95.387302 -266.77215,95.414339 C -266.35587,90.465192 -260.12609,88.824447 -255.81783,89.540255 C -256.01688,89.058389 -261.69557,87.939375 -259.61591,84.491525 C -259.45681,68.72727 -259.19734,52.882199 -259.82064,37.168229 C -261.19394,32.980583 -267.34179,33.83368 -270.85787,33.814995 z M -236.65184,97.260473 C -234.79025,100.12642 -237.08724,103.09386 -239.92892,104.16357 C -242.6311,105.91539 -245.59105,107.62992 -248.52894,108.76804 C -253.1773,108.19079 -251.42424,101.88475 -255.01281,99.896645 C -260.33594,96.447012 -267.21045,98.43943 -273.23329,97.939231 C -291.8249,97.94887 -310.41651,97.958519 -329.00813,97.968158 C -335.45898,103.56578 -339.16595,111.40269 -341.55034,119.32178 C -337.25147,124.2061 -329.89606,122.27575 -324.10438,122.40002 C -298.64553,122.23171 -273.11679,122.61546 -247.69897,122.24542 C -243.40174,121.14669 -247.44685,114.84894 -243.58488,113.04441 C -242.73865,112.73374 -247.81245,114.4382 -247.26205,111.62955 C -245.49117,106.66028 -239.14113,105.99595 -235.92338,102.36811 C -234.39131,99.755669 -236.26958,96.922488 -238.33047,95.260495 C -237.77093,95.927151 -237.21138,96.593817 -236.65184,97.260473 z M -240.64255,111.75263 C -243.64086,113.13223 -237.02792,110.69536 -235.55512,111.97369 C -229.71113,112.74417 -224.16461,117.19625 -218.12358,115.22951 C -225.97639,116.31604 -232.799,109.03014 -240.64255,111.75263 z M -212.01083,112.33724 C -215.98173,113.85021 -208.21543,112.17765 -210.07883,115.87566 C -212.50961,119.93855 -206.99008,113.8662 -209.61436,112.54677 C -210.16198,111.94632 -211.27989,112.47663 -212.01083,112.33724 z M -213.97451,120.82946 C -220.13871,124.32615 -228.37873,119.08124 -233.85995,124.39439 C -238.36465,128.00055 -244.57099,130.35185 -247.0433,135.75122 C -247.65922,139.60202 -243.25109,141.90251 -240.44565,143.71808 C -235.60127,146.54512 -228.8227,145.75388 -225.20082,141.42836 C -220.62679,137.96117 -216.44182,134.08489 -212.48592,129.96782 C -212.82701,126.95048 -214.43694,123.63971 -213.97451,120.82946 z " />
-        <path
-           style="fill:url(#linearGradient5283);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
-           id="path2723"
-           d="M -269.68453,32.256957 C -288.76965,32.351184 -307.87514,32.249603 -326.94796,32.349264 C -332.63884,33.663474 -333.90446,40.291305 -333.21597,45.149113 C -333.11996,59.896901 -333.07471,74.659754 -332.61729,89.39481 C -331.88583,93.310348 -324.86009,92.098674 -325.11097,96.44089 C -328.07184,96.184706 -331.5534,96.317135 -333.07248,99.246492 C -338.92562,104.98392 -341.99312,112.66465 -344.27268,120.28679 C -340.22572,125.96631 -332.26467,125.31453 -326.02946,124.71751 C -300.16629,124.7277 -274.28316,124.82043 -248.43245,124.77905 C -244.42424,124.78686 -243.30672,120.35609 -243.96666,117.2099 C -242.88598,112.93536 -237.04086,113.94554 -233.80717,114.98513 C -228.01851,116.64297 -221.26418,120.43074 -215.57982,116.37592 C -211.36091,113.71809 -213.05678,118.4029 -215.77936,119.43344 C -220.82539,122.25797 -227.09125,118.98178 -232.39677,121.20855 C -236.53238,123.88957 -240.74707,126.85249 -244.76678,129.74666 C -248.34219,132.01467 -251.90947,137.38626 -248.13747,140.97315 C -243.79274,146.02948 -236.37425,149.4527 -229.68248,147.08651 C -225.09383,144.85973 -221.79206,140.75401 -217.61535,137.88661 C -215.10454,135.69469 -212.49235,133.26839 -210.83749,130.50207 C -210.86477,126.92195 -214.68529,121.91303 -210.252,119.57013 C -207.25619,117.95208 -205.81053,112.12098 -209.75314,110.87946 C -214.16982,109.44692 -216.95156,115.09837 -221.43751,113.68608 C -228.47365,112.76758 -235.5565,107.20489 -242.69931,110.72434 C -246.89551,113.06547 -243.47174,109.4356 -241.45524,108.56544 C -237.85613,106.84628 -232.73147,104.36798 -233.94637,99.617708 C -234.27189,95.083838 -239.22223,93.197522 -242.95318,91.723135 C -247.61613,89.074942 -253.27003,89.345117 -258.06082,86.933298 C -257.89248,70.385101 -257.58805,53.76423 -258.26571,37.261116 C -259.2092,32.393288 -265.59824,31.96057 -269.68453,32.256957 z M -258.66259,91.764016 C -251.5059,92.239344 -243.21163,93.474137 -238.58238,99.271629 C -238.96251,103.06003 -244.00295,103.80224 -246.52821,106.14082 C -248.92267,108.48087 -251.12372,105.80503 -251.02958,103.27159 C -252.70852,98.336432 -258.20582,95.710815 -263.31841,96.533197 C -267.00561,96.7255 -263.71935,91.937514 -261.395,92.380192 C -260.48382,92.178338 -259.57521,91.953759 -258.66259,91.764016 z " />
-        <path
-           style="fill:url(#linearGradient5285);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
-           sodipodi:nodetypes="ccccczccccccccccccccccccczccccc"
-           id="path2737"
-           d="M -324.0398,30.70877 C -336.3492,30.820231 -335.15663,39.652507 -334.79476,45.313268 C -334.5469,60.436643 -334.38614,75.599009 -334.01234,90.698281 C -333.20516,93.057424 -330.71249,93.985661 -328.75475,95.252079 C -334.4553,96.476239 -336.96996,102.43195 -340.11175,106.59303 C -342.33294,111.36531 -347.84019,115.92868 -345.92111,121.43642 C -344.00204,126.94416 -332.21757,127.68181 -324.95408,127.12866 C -299.06901,127.09789 -273.17022,127.14905 -247.29372,127.06713 C -243.29961,126.16956 -240.99668,122.03601 -241.4977,118.23645 C -238.30082,114.95371 -233.32521,118.03039 -229.53292,118.63002 C -225.71641,119.31313 -232.5646,119.27527 -233.19362,120.54849 C -238.23604,122.95799 -242.6166,126.65447 -246.90973,130.10509 C -250.44674,132.97354 -252.4229,138.10741 -249.57412,142.08235 C -246.21315,145.92284 -241.41489,148.84284 -236.30395,149.79628 C -230.65487,150.83779 -225.57101,147.82678 -221.6157,144.24077 C -216.87391,140.59839 -212.0873,136.78287 -208.84361,131.80554 C -207.76302,128.26399 -211.47449,123.86671 -208.08348,121.09796 C -204.93438,118.46115 -204.06893,113.02076 -207.41836,110.2673 C -212.81988,106.81278 -218.36682,114.55112 -223.89705,111.29128 C -227.94209,110.1659 -231.91311,108.52596 -236.17676,108.45194 C -231.52711,105.88023 -229.62903,98.782331 -234.08944,95.153402 C -239.61551,89.404431 -248.455,88.793917 -255.40182,85.744487 C -255.86992,78.940296 -255.53665,71.972758 -255.70928,65.098797 C -255.80747,55.730822 -255.73864,46.312632 -255.94025,36.975777 C -258.03631,31.236293 -265.34014,30.439522 -270.76286,30.729689 C -289.40725,30.770714 -311.88665,30.597309 -324.0398,30.70877 z M -255.46516,94.482857 C -250.34561,95.62106 -244.69322,96.21649 -240.83258,100.05203 C -242.37635,102.55028 -245.27573,103.64481 -247.80048,104.97505 C -249.71506,99.684643 -254.39847,94.970039 -260.51378,95.138259 C -260.66903,94.131274 -256.73261,94.551178 -255.46516,94.482857 z " />
-      </g>
-      <rect
-         y="78.658051"
-         x="33.326111"
-         width="57.567924"
-         style="fill:url(#linearGradient1156);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient1157);stroke-width:1.44734821pt"
-         id="rect1155"
-         height="8.3153667" />
-      <path
-         style="fill:url(#linearGradient1169);fill-rule:evenodd;stroke-width:0.90459263;stroke-opacity:0.07438019"
-         sodipodi:nodetypes="czzczczzzzzzzc"
-         id="path2676"
-         d="M 98.723806,78.927818 C 95.18666,77.759681 93.50122,82.555591 98.766686,81.004087 C 104.03217,79.452583 120.13123,85.906451 120.37383,89.795491 C 120.61643,93.905503 101.5003,98.581154 106.74108,104.42426 C 111.62816,110.70149 115.35468,100.13868 123.54696,104.21261 C 131.73923,108.17607 136.26048,109.72394 142.25488,104.94185 C 149.10027,101.9342 145.04599,107.07658 139.57918,113.60451 C 134.11237,120.13244 144.00251,115.08156 147.91225,105.31962 C 151.93248,95.557673 139.13128,107.33503 133.66268,105.40571 C 128.19408,103.47639 119.73678,97.849788 113.27625,102.55563 C 106.81572,107.26147 109.62894,99.493003 114.85637,97.90307 C 120.0838,96.092166 122.81363,93.045722 122.85597,90.161522 C 122.89831,87.498293 117.92629,84.811803 112.94229,82.402852 C 107.73732,79.993901 100.49788,78.588966 98.723806,78.927818 z " />
-      <path
-         style="fill:url(#linearGradient1140);fill-opacity:1;fill-rule:evenodd;stroke-width:1.44734821pt"
-         sodipodi:nodetypes="czzzzzzzz"
-         id="path1139"
-         d="M 15.102732,106.80712 C 13.80355,109.23224 17.148847,113.52338 19.900059,113.52338 L 107.85106,113.52338 C 110.18914,113.52338 113.70766,110.4906 112.64839,108.40622 L 102.7339,88.897093 C 101.97024,87.394398 100.26184,86.65834 98.576216,86.65834 L 28.215425,86.658339 C 26.825434,86.658339 25.353768,87.671846 24.697385,88.897093 L 15.102732,106.80712 z " />
-      <rect
-         y="22.413721"
-         x="26.015469"
-         width="72.279724"
-         style="fill:url(#linearGradient905);fill-opacity:1;fill-rule:evenodd;stroke-width:1.62826681"
-         ry="5.4369707"
-         rx="5.4369707"
-         id="rect1137"
-         height="60.126495" />
-      <rect
-         y="31.695871"
-         x="33.386066"
-         width="58.178177"
-         style="fill:url(#radialGradient1132);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient891);stroke-width:1.4649456pt"
-         id="rect1131"
-         height="38.044163" />
-      <path
-         style="fill:url(#linearGradient1146);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="czzccccc"
-         id="path1145"
-         d="M 27.690431,52.841444 L 27.370609,74.749236 C 27.319624,78.241665 29.310209,80.477938 32.807578,80.506029 L 72.625393,80.825852 L 76.463254,71.87084 L 32.008024,71.55102 L 31.688202,52.681533 L 27.690431,52.841444 z " />
-      <g
-         transform="matrix(-1,0,0,1,125.4301,0)"
-         id="g1791">
-        <path
-           style="fill:url(#linearGradient1148);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-           sodipodi:nodetypes="czzccc"
-           id="path1147"
-           d="M 42.062098,33.460351 L 77.341205,33.008055 C 82.787126,32.938235 89.553204,38.416797 89.553204,43.863165 L 89.553204,60.14583 L 41.609801,59.693534 L 42.062098,33.460351 z " />
-        <path
-           style="fill:url(#linearGradient1150);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-           sodipodi:nodetypes="czzccc"
-           id="path1149"
-           d="M 78.337784,67.629235 L 46.723745,67.724544 C 41.843589,67.739257 35.829319,62.771024 35.877168,57.891081 L 36.020221,43.301821 L 78.973514,44.128288 L 78.337784,67.629235 z " />
-      </g>
-      <path
-         style="fill:url(#linearGradient1167);fill-opacity:1;fill-rule:evenodd;stroke-width:0.72367412;stroke-opacity:0.34710741"
-         sodipodi:nodetypes="cczzzzzzc"
-         id="path1159"
-         d="M 137.39107,112.02341 C 137.39107,112.02341 129.0757,110.26438 123.63872,113.62251 C 118.20176,116.98064 109.96635,123.21719 108.76702,124.81628 C 107.40777,126.57531 107.42036,130.22796 109.24674,131.53253 L 114.84364,135.53031 C 118.31797,138.01198 124.86218,139.25396 128.11624,136.48978 L 142.98795,123.85681 C 144.79792,122.3193 145.72732,118.27921 144.10733,116.82073 C 142.95609,115.04975 140.4892,112.91939 137.39107,112.02341 z " />
-      <path
-         style="fill:url(#linearGradient1171);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="czzzzzc"
-         id="path1160"
-         d="M 142.3483,121.13833 L 125.91043,133.59673 C 122.97154,135.82414 118.65484,134.11775 116.28283,133.77129 C 113.9108,133.42481 111.88528,131.87901 112.12516,132.33209 C 112.36503,132.78517 115.08349,135.71687 117.72203,136.48978 C 120.36055,137.26267 124.9543,138.89307 127.50953,136.15531 C 130.06477,133.41755 145.2267,123.53699 142.3483,121.13833 z " />
-      <path
-         style="fill:url(#linearGradient1404);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="cczc"
-         id="path1403"
-         d="M 132.11225,127.51984 C 135.31047,122.88242 120.11893,113.12786 109.08509,127.0401 C 110.20446,130.71805 116.80662,132.5992 121.82304,132.33547 C 126.68363,132.07993 129.50037,129.97181 132.11225,127.51984 z " />
-      <path
-         style="fill:url(#linearGradient1166);fill-opacity:1;fill-rule:evenodd;stroke-width:1.08551121"
-         sodipodi:nodetypes="cccccccc"
-         id="path1519"
-         d="M 138.63464,112.68306 C 135.9958,113.22749 132.31739,114.43079 129.87534,116.38362 C 128.77009,115.68011 125.32759,114.5677 123.66767,113.84494 L 123.24572,114.10517 C 129.67287,117.23476 136.43512,117.91249 135.88192,122.87668 C 136.33675,122.98575 137.05589,123.09702 136.73191,122.38863 C 136.41775,118.90392 132.50587,117.23351 131.02697,116.81532 C 133.17224,114.26602 136.255,113.70892 138.63464,112.68306 z " />
-      <path
-         style="fill:url(#linearGradient1144);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="czzzzzzzz"
-         id="path1143"
-         d="M 18.891612,106.48414 C 17.978451,108.31614 19.173914,111.55774 22.263529,111.55774 L 105.0195,111.55774 C 106.66288,111.55774 109.13595,109.26672 108.39142,107.69215 L 101.42279,92.954575 C 100.88602,91.819403 99.685232,91.263378 98.500462,91.263378 L 28.108183,91.263369 C 27.131195,91.263369 26.0968,92.028994 25.635445,92.954575 L 18.891612,106.48414 z " />
-      <text
-         y="-14.660837"
-         xml:space="preserve"
-         x="6.147172"
-         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
-         id="text1232"><tspan
-           id="tspan1233">Computer</tspan></text>
-      <text
-         y="-34.951134"
-         xml:space="preserve"
-         x="84.564949"
-         transform="scale(0.246729,0.246729)"
-         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
-         id="text1235"><tspan
-           id="tspan1236">Created by Andrew Fitzsimon</tspan></text>
-    </g>
-    <g
-       id="g5474"
-       transform="translate(633.63525,501.49239)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157">
-      <path
-         style="fill:#ffffff;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="cccc"
-         id="path9383"
-         d="M 203.47051,-209.74941 C 198.72111,-204.56585 195.69876,-195.27863 189.00642,-195.27863 C 182.52997,-197.07848 181.66644,-212.48518 180.80291,-215.7969 C 188.1429,-210.75732 195.69876,-207.87757 203.47051,-209.74941 z " />
-      <path
-         transform="matrix(-0.440859,0,0,0.441062,265.52775,-266.17138)"
-         style="fill:#f1bb96;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:type="arc"
-         sodipodi:ry="57.825485"
-         sodipodi:rx="60.94183"
-         sodipodi:cy="70.290855"
-         sodipodi:cx="150.27701"
-         id="path3713"
-         d="M 211.21884 70.290855 A 60.94183 57.825485 0 1 1  89.335178,70.290855 A 60.94183 57.825485 0 1 1  211.21884 70.290855 z" />
-      <path
-         style="fill:#233e6a;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="ccssssc"
-         id="path4369"
-         d="M 232.46888,-182.94274 C 232.85952,-157.74648 168.23012,-154.86512 168.38642,-182.94274 C 166.84164,-205.27149 177.94687,-217.96719 180.70654,-215.80872 C 182.10778,-214.71274 182.62841,-190.37295 192.09635,-195.9716 C 196.69923,-198.69339 201.84768,-209.14846 204.10029,-209.49532 C 207.49937,-210.01873 214.00811,-212.77083 219.98583,-217.92153 C 221.55412,-219.27285 231.93943,-205.38255 232.46888,-182.94274 z " />
-      <path
-         style="fill:#513624;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="ccccc"
-         id="path11309"
-         d="M 204.55432,-273.85152 C 222.46413,-271.53047 237.32676,-259.28175 231.38357,-231.42099 C 229.66954,-221.67743 222.12426,-217.60887 219.35537,-236.36962 C 211.4578,-233.88387 177.25785,-223.92576 170.54948,-241.26677 C 166.55631,-248.43407 174.86257,-276.23329 204.55432,-273.85152 z " />
-      <path
-         style="fill:#1f4eb3;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="cccc"
-         id="path11942"
-         d="M 191.92173,-167.75448 C 192.06919,-184.44566 194.18855,-193.73288 188.47558,-194.95709 C 182.9785,-195.85052 179.91138,-176.52634 179.04785,-173.21462 C 175.85958,-157.19769 189.53653,-154.44605 191.92173,-167.75448 z " />
-      <path
-         style="fill:url(#linearGradient1815);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         id="path1811"
-         d="M 172.67812,-237.76056 C 182.56217,-225.58826 212.09549,-234.15979 219.36562,-236.44806 C 220.33459,-229.88278 221.90014,-226.25074 223.58437,-224.54181 C 219.31219,-215.8234 210.06249,-209.76056 199.27187,-209.76056 C 184.44142,-209.76056 172.42812,-221.18201 172.42812,-235.26056 C 172.42812,-236.11869 172.59078,-236.92413 172.67812,-237.76056 z " />
-      <path
-         style="fill:url(#radialGradient1818);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="ccccc"
-         id="path1817"
-         d="M 203.17522,-273.74212 C 221.08504,-271.42107 235.94766,-259.17235 230.00448,-231.31159 C 228.29044,-221.56803 220.74517,-217.49946 217.97627,-236.26022 C 210.0787,-233.77447 175.87876,-223.81635 169.17039,-241.15737 C 165.17722,-248.32467 173.48348,-276.12389 203.17522,-273.74212 z " />
-      <path
-         style="fill:url(#radialGradient1822);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         id="path1819"
-         d="M 220.74123,-214.1875 C 227.87764,-203.73841 231.28831,-190.18836 229.45998,-177.71875 C 222.3997,-165.39834 205.93726,-163.52328 193.05373,-164.75 C 194.11526,-173.29796 194.69425,-182.39807 193.51876,-190.98978 C 191.02311,-195.41909 199.33209,-197.29913 200.39748,-201.6875 C 203.70655,-208.92744 212.80427,-208.10966 218.04988,-213.3696 C 218.9201,-213.57294 220.00051,-215.94141 220.74123,-214.1875 z M 179.55373,-210.28125 C 180.69974,-204.97453 181.23339,-199.24919 184.58498,-194.75 C 179.40159,-187.81847 178.05976,-178.63643 176.67873,-170.28125 C 167.10271,-177.01707 169.81568,-190.62142 172.02963,-200.39411 C 173.03008,-204.26346 176.36728,-212.34166 179.19382,-211.77772 C 179.27177,-211.45363 179.5117,-210.45598 179.55373,-210.28125 z " />
-      <path
-         style="fill:url(#radialGradient1824);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="cccc"
-         id="path1823"
-         d="M 192.35803,-167.43887 C 192.50549,-184.13006 194.62485,-193.41727 188.91188,-194.64149 C 183.4148,-195.53491 180.34768,-176.21073 179.48415,-172.89901 C 176.29589,-156.88208 189.97283,-154.13044 192.35803,-167.43887 z " />
-      <path
-         style="fill:#1f4eb3;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
-         sodipodi:nodetypes="ccccc"
-         id="path1825"
-         d="M 185.2414,-200.53324 C 185.2414,-197.95291 187.25802,-195.85872 189.74278,-195.85872 C 192.22755,-195.85872 194.24417,-197.95291 194.24417,-200.53324 C 194.24417,-203.11357 193.61259,-209.36288 191.12783,-209.36288 C 188.64306,-209.36288 185.2414,-203.11357 185.2414,-200.53324 z " />
-      <path
-         style="fill:url(#radialGradient1828);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="ccccc"
-         id="path1827"
-         d="M 186.28018,-201.05263 C 186.28018,-198.4723 188.2968,-196.37811 190.78156,-196.37811 C 193.26633,-196.37811 195.28295,-198.4723 195.28295,-201.05263 C 195.28295,-203.63296 194.65137,-209.88227 192.16661,-209.88227 C 189.68184,-209.88227 186.28018,-203.63296 186.28018,-201.05263 z " />
-    </g>
-    <g
-       id="g5488"
-       transform="translate(601.5744,407.49165)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157">
-      <path
-         transform="matrix(6.392368,0.545409,-0.130014,2.864752,-184.6606,-38.15109)"
-         style="fill:url(#radialGradient5536);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:type="arc"
-         sodipodi:ry="12.562782"
-         sodipodi:rx="12.562782"
-         sodipodi:cy="37.865574"
-         sodipodi:cx="41.875938"
-         id="path5490"
-         d="M 54.438721 37.865574 A 12.562782 12.562782 0 1 1  29.313156,37.865574 A 12.562782 12.562782 0 1 1  54.438721 37.865574 z" />
-      <g
-         transform="matrix(1,0,0,1.036969,356.8306,-11.4294)"
-         style="fill:url(#linearGradient5538);fill-opacity:1"
-         id="g5492">
-        <path
-           style="fill:url(#linearGradient5540);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
-           id="path5494"
-           d="M -270.85787,33.814995 C -289.35564,33.925992 -307.93321,33.592782 -326.38104,33.981747 C -331.43469,35.696391 -331.02221,41.899652 -330.68524,46.15332 C -330.75782,60.227303 -330.53537,74.298225 -330.21167,88.36826 C -328.21297,91.039611 -323.21766,90.618387 -322.68469,94.539015 C -320.78054,96.259426 -317.05071,94.88215 -314.4389,95.333237 C -298.54999,95.360274 -282.66107,95.387302 -266.77215,95.414339 C -266.35587,90.465192 -260.12609,88.824447 -255.81783,89.540255 C -256.01688,89.058389 -261.69557,87.939375 -259.61591,84.491525 C -259.45681,68.72727 -259.19734,52.882199 -259.82064,37.168229 C -261.19394,32.980583 -267.34179,33.83368 -270.85787,33.814995 z M -236.65184,97.260473 C -234.79025,100.12642 -237.08724,103.09386 -239.92892,104.16357 C -242.6311,105.91539 -245.59105,107.62992 -248.52894,108.76804 C -253.1773,108.19079 -251.42424,101.88475 -255.01281,99.896645 C -260.33594,96.447012 -267.21045,98.43943 -273.23329,97.939231 C -291.8249,97.94887 -310.41651,97.958519 -329.00813,97.968158 C -335.45898,103.56578 -339.16595,111.40269 -341.55034,119.32178 C -337.25147,124.2061 -329.89606,122.27575 -324.10438,122.40002 C -298.64553,122.23171 -273.11679,122.61546 -247.69897,122.24542 C -243.40174,121.14669 -247.44685,114.84894 -243.58488,113.04441 C -242.73865,112.73374 -247.81245,114.4382 -247.26205,111.62955 C -245.49117,106.66028 -239.14113,105.99595 -235.92338,102.36811 C -234.39131,99.755669 -236.26958,96.922488 -238.33047,95.260495 C -237.77093,95.927151 -237.21138,96.593817 -236.65184,97.260473 z M -240.64255,111.75263 C -243.64086,113.13223 -237.02792,110.69536 -235.55512,111.97369 C -229.71113,112.74417 -224.16461,117.19625 -218.12358,115.22951 C -225.97639,116.31604 -232.799,109.03014 -240.64255,111.75263 z M -212.01083,112.33724 C -215.98173,113.85021 -208.21543,112.17765 -210.07883,115.87566 C -212.50961,119.93855 -206.99008,113.8662 -209.61436,112.54677 C -210.16198,111.94632 -211.27989,112.47663 -212.01083,112.33724 z M -213.97451,120.82946 C -220.13871,124.32615 -228.37873,119.08124 -233.85995,124.39439 C -238.36465,128.00055 -244.57099,130.35185 -247.0433,135.75122 C -247.65922,139.60202 -243.25109,141.90251 -240.44565,143.71808 C -235.60127,146.54512 -228.8227,145.75388 -225.20082,141.42836 C -220.62679,137.96117 -216.44182,134.08489 -212.48592,129.96782 C -212.82701,126.95048 -214.43694,123.63971 -213.97451,120.82946 z " />
-        <path
-           style="fill:url(#linearGradient5542);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
-           id="path5496"
-           d="M -269.68453,32.256957 C -288.76965,32.351184 -307.87514,32.249603 -326.94796,32.349264 C -332.63884,33.663474 -333.90446,40.291305 -333.21597,45.149113 C -333.11996,59.896901 -333.07471,74.659754 -332.61729,89.39481 C -331.88583,93.310348 -324.86009,92.098674 -325.11097,96.44089 C -328.07184,96.184706 -331.5534,96.317135 -333.07248,99.246492 C -338.92562,104.98392 -341.99312,112.66465 -344.27268,120.28679 C -340.22572,125.96631 -332.26467,125.31453 -326.02946,124.71751 C -300.16629,124.7277 -274.28316,124.82043 -248.43245,124.77905 C -244.42424,124.78686 -243.30672,120.35609 -243.96666,117.2099 C -242.88598,112.93536 -237.04086,113.94554 -233.80717,114.98513 C -228.01851,116.64297 -221.26418,120.43074 -215.57982,116.37592 C -211.36091,113.71809 -213.05678,118.4029 -215.77936,119.43344 C -220.82539,122.25797 -227.09125,118.98178 -232.39677,121.20855 C -236.53238,123.88957 -240.74707,126.85249 -244.76678,129.74666 C -248.34219,132.01467 -251.90947,137.38626 -248.13747,140.97315 C -243.79274,146.02948 -236.37425,149.4527 -229.68248,147.08651 C -225.09383,144.85973 -221.79206,140.75401 -217.61535,137.88661 C -215.10454,135.69469 -212.49235,133.26839 -210.83749,130.50207 C -210.86477,126.92195 -214.68529,121.91303 -210.252,119.57013 C -207.25619,117.95208 -205.81053,112.12098 -209.75314,110.87946 C -214.16982,109.44692 -216.95156,115.09837 -221.43751,113.68608 C -228.47365,112.76758 -235.5565,107.20489 -242.69931,110.72434 C -246.89551,113.06547 -243.47174,109.4356 -241.45524,108.56544 C -237.85613,106.84628 -232.73147,104.36798 -233.94637,99.617708 C -234.27189,95.083838 -239.22223,93.197522 -242.95318,91.723135 C -247.61613,89.074942 -253.27003,89.345117 -258.06082,86.933298 C -257.89248,70.385101 -257.58805,53.76423 -258.26571,37.261116 C -259.2092,32.393288 -265.59824,31.96057 -269.68453,32.256957 z M -258.66259,91.764016 C -251.5059,92.239344 -243.21163,93.474137 -238.58238,99.271629 C -238.96251,103.06003 -244.00295,103.80224 -246.52821,106.14082 C -248.92267,108.48087 -251.12372,105.80503 -251.02958,103.27159 C -252.70852,98.336432 -258.20582,95.710815 -263.31841,96.533197 C -267.00561,96.7255 -263.71935,91.937514 -261.395,92.380192 C -260.48382,92.178338 -259.57521,91.953759 -258.66259,91.764016 z " />
-        <path
-           style="fill:url(#linearGradient5544);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
-           sodipodi:nodetypes="ccccczccccccccccccccccccczccccc"
-           id="path5498"
-           d="M -324.0398,30.70877 C -336.3492,30.820231 -335.15663,39.652507 -334.79476,45.313268 C -334.5469,60.436643 -334.38614,75.599009 -334.01234,90.698281 C -333.20516,93.057424 -330.71249,93.985661 -328.75475,95.252079 C -334.4553,96.476239 -336.96996,102.43195 -340.11175,106.59303 C -342.33294,111.36531 -347.84019,115.92868 -345.92111,121.43642 C -344.00204,126.94416 -332.21757,127.68181 -324.95408,127.12866 C -299.06901,127.09789 -273.17022,127.14905 -247.29372,127.06713 C -243.29961,126.16956 -240.99668,122.03601 -241.4977,118.23645 C -238.30082,114.95371 -233.32521,118.03039 -229.53292,118.63002 C -225.71641,119.31313 -232.5646,119.27527 -233.19362,120.54849 C -238.23604,122.95799 -242.6166,126.65447 -246.90973,130.10509 C -250.44674,132.97354 -252.4229,138.10741 -249.57412,142.08235 C -246.21315,145.92284 -241.41489,148.84284 -236.30395,149.79628 C -230.65487,150.83779 -225.57101,147.82678 -221.6157,144.24077 C -216.87391,140.59839 -212.0873,136.78287 -208.84361,131.80554 C -207.76302,128.26399 -211.47449,123.86671 -208.08348,121.09796 C -204.93438,118.46115 -204.06893,113.02076 -207.41836,110.2673 C -212.81988,106.81278 -218.36682,114.55112 -223.89705,111.29128 C -227.94209,110.1659 -231.91311,108.52596 -236.17676,108.45194 C -231.52711,105.88023 -229.62903,98.782331 -234.08944,95.153402 C -239.61551,89.404431 -248.455,88.793917 -255.40182,85.744487 C -255.86992,78.940296 -255.53665,71.972758 -255.70928,65.098797 C -255.80747,55.730822 -255.73864,46.312632 -255.94025,36.975777 C -258.03631,31.236293 -265.34014,30.439522 -270.76286,30.729689 C -289.40725,30.770714 -311.88665,30.597309 -324.0398,30.70877 z M -255.46516,94.482857 C -250.34561,95.62106 -244.69322,96.21649 -240.83258,100.05203 C -242.37635,102.55028 -245.27573,103.64481 -247.80048,104.97505 C -249.71506,99.684643 -254.39847,94.970039 -260.51378,95.138259 C -260.66903,94.131274 -256.73261,94.551178 -255.46516,94.482857 z " />
-      </g>
-      <rect
-         y="78.658051"
-         x="33.326111"
-         width="57.567924"
-         style="fill:url(#linearGradient5546);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient5548);stroke-width:1.44734821pt"
-         id="rect5500"
-         height="8.3153667" />
-      <path
-         style="fill:url(#linearGradient5550);fill-rule:evenodd;stroke-width:0.90459263;stroke-opacity:0.07438019"
-         sodipodi:nodetypes="czzczczzzzzzzc"
-         id="path5502"
-         d="M 98.723806,78.927818 C 95.18666,77.759681 93.50122,82.555591 98.766686,81.004087 C 104.03217,79.452583 120.13123,85.906451 120.37383,89.795491 C 120.61643,93.905503 101.5003,98.581154 106.74108,104.42426 C 111.62816,110.70149 115.35468,100.13868 123.54696,104.21261 C 131.73923,108.17607 136.26048,109.72394 142.25488,104.94185 C 149.10027,101.9342 145.04599,107.07658 139.57918,113.60451 C 134.11237,120.13244 144.00251,115.08156 147.91225,105.31962 C 151.93248,95.557673 139.13128,107.33503 133.66268,105.40571 C 128.19408,103.47639 119.73678,97.849788 113.27625,102.55563 C 106.81572,107.26147 109.62894,99.493003 114.85637,97.90307 C 120.0838,96.092166 122.81363,93.045722 122.85597,90.161522 C 122.89831,87.498293 117.92629,84.811803 112.94229,82.402852 C 107.73732,79.993901 100.49788,78.588966 98.723806,78.927818 z " />
-      <path
-         style="fill:url(#linearGradient5552);fill-opacity:1;fill-rule:evenodd;stroke-width:1.44734821pt"
-         sodipodi:nodetypes="czzzzzzzz"
-         id="path5504"
-         d="M 15.102732,106.80712 C 13.80355,109.23224 17.148847,113.52338 19.900059,113.52338 L 107.85106,113.52338 C 110.18914,113.52338 113.70766,110.4906 112.64839,108.40622 L 102.7339,88.897093 C 101.97024,87.394398 100.26184,86.65834 98.576216,86.65834 L 28.215425,86.658339 C 26.825434,86.658339 25.353768,87.671846 24.697385,88.897093 L 15.102732,106.80712 z " />
-      <rect
-         y="22.413721"
-         x="26.015469"
-         width="72.279724"
-         style="fill:url(#linearGradient5554);fill-opacity:1;fill-rule:evenodd;stroke-width:1.62826681"
-         ry="5.4369707"
-         rx="5.4369707"
-         id="rect5506"
-         height="60.126495" />
-      <rect
-         y="31.695871"
-         x="33.386066"
-         width="58.178177"
-         style="fill:url(#radialGradient5556);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient5558);stroke-width:1.4649456pt"
-         id="rect5508"
-         height="38.044163" />
-      <path
-         style="fill:url(#linearGradient5560);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="czzccccc"
-         id="path5510"
-         d="M 27.690431,52.841444 L 27.370609,74.749236 C 27.319624,78.241665 29.310209,80.477938 32.807578,80.506029 L 72.625393,80.825852 L 76.463254,71.87084 L 32.008024,71.55102 L 31.688202,52.681533 L 27.690431,52.841444 z " />
-      <g
-         transform="matrix(-1,0,0,1,125.4301,0)"
-         id="g5512">
-        <path
-           style="fill:url(#linearGradient5562);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-           sodipodi:nodetypes="czzccc"
-           id="path5514"
-           d="M 42.062098,33.460351 L 77.341205,33.008055 C 82.787126,32.938235 89.553204,38.416797 89.553204,43.863165 L 89.553204,60.14583 L 41.609801,59.693534 L 42.062098,33.460351 z " />
-        <path
-           style="fill:url(#linearGradient5564);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-           sodipodi:nodetypes="czzccc"
-           id="path5516"
-           d="M 78.337784,67.629235 L 46.723745,67.724544 C 41.843589,67.739257 35.829319,62.771024 35.877168,57.891081 L 36.020221,43.301821 L 78.973514,44.128288 L 78.337784,67.629235 z " />
-      </g>
-      <path
-         style="fill:url(#linearGradient5566);fill-opacity:1;fill-rule:evenodd;stroke-width:0.72367412;stroke-opacity:0.34710741"
-         sodipodi:nodetypes="cczzzzzzc"
-         id="path5518"
-         d="M 137.39107,112.02341 C 137.39107,112.02341 129.0757,110.26438 123.63872,113.62251 C 118.20176,116.98064 109.96635,123.21719 108.76702,124.81628 C 107.40777,126.57531 107.42036,130.22796 109.24674,131.53253 L 114.84364,135.53031 C 118.31797,138.01198 124.86218,139.25396 128.11624,136.48978 L 142.98795,123.85681 C 144.79792,122.3193 145.72732,118.27921 144.10733,116.82073 C 142.95609,115.04975 140.4892,112.91939 137.39107,112.02341 z " />
-      <path
-         style="fill:url(#linearGradient5568);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="czzzzzc"
-         id="path5520"
-         d="M 142.3483,121.13833 L 125.91043,133.59673 C 122.97154,135.82414 118.65484,134.11775 116.28283,133.77129 C 113.9108,133.42481 111.88528,131.87901 112.12516,132.33209 C 112.36503,132.78517 115.08349,135.71687 117.72203,136.48978 C 120.36055,137.26267 124.9543,138.89307 127.50953,136.15531 C 130.06477,133.41755 145.2267,123.53699 142.3483,121.13833 z " />
-      <path
-         style="fill:url(#linearGradient5570);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="cczc"
-         id="path5522"
-         d="M 132.11225,127.51984 C 135.31047,122.88242 120.11893,113.12786 109.08509,127.0401 C 110.20446,130.71805 116.80662,132.5992 121.82304,132.33547 C 126.68363,132.07993 129.50037,129.97181 132.11225,127.51984 z " />
-      <path
-         style="fill:url(#linearGradient5572);fill-opacity:1;fill-rule:evenodd;stroke-width:1.08551121"
-         sodipodi:nodetypes="cccccccc"
-         id="path5524"
-         d="M 138.63464,112.68306 C 135.9958,113.22749 132.31739,114.43079 129.87534,116.38362 C 128.77009,115.68011 125.32759,114.5677 123.66767,113.84494 L 123.24572,114.10517 C 129.67287,117.23476 136.43512,117.91249 135.88192,122.87668 C 136.33675,122.98575 137.05589,123.09702 136.73191,122.38863 C 136.41775,118.90392 132.50587,117.23351 131.02697,116.81532 C 133.17224,114.26602 136.255,113.70892 138.63464,112.68306 z " />
-      <path
-         style="fill:url(#linearGradient5574);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="czzzzzzzz"
-         id="path5526"
-         d="M 18.891612,106.48414 C 17.978451,108.31614 19.173914,111.55774 22.263529,111.55774 L 105.0195,111.55774 C 106.66288,111.55774 109.13595,109.26672 108.39142,107.69215 L 101.42279,92.954575 C 100.88602,91.819403 99.685232,91.263378 98.500462,91.263378 L 28.108183,91.263369 C 27.131195,91.263369 26.0968,92.028994 25.635445,92.954575 L 18.891612,106.48414 z " />
-      <text
-         y="-14.660837"
-         xml:space="preserve"
-         x="6.147172"
-         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
-         id="text5528"><tspan
-           id="tspan5530">Computer</tspan></text>
-      <text
-         y="-34.951134"
-         xml:space="preserve"
-         x="84.564949"
-         transform="scale(0.246729,0.246729)"
-         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
-         id="text5532"><tspan
-           id="tspan5534">Created by Andrew Fitzsimon</tspan></text>
-    </g>
-    <g
-       id="g6024"
-       transform="matrix(-1,0,0,1,900.16045,422.61731)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157">
-      <path
-         transform="translate(2.509562,-4.432856e-2)"
-         style="fill:#ffffff;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="cccc"
-         id="path6027"
-         d="M 60.545133,72.847539 C 65.294534,78.031101 68.316881,87.318315 75.00922,87.318316 C 81.485677,85.518467 82.349205,70.11177 83.212732,66.800051 C 75.872748,71.839624 68.316882,74.71938 60.545133,72.847539 z " />
-      <path
-         transform="translate(2.509562,-4.432856e-2)"
-         style="fill:#d20000;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="ccssssc"
-         id="path6029"
-         d="M 31.546762,99.654209 C 31.156121,124.85047 95.78552,127.73183 95.62922,99.654209 C 97.174007,77.325462 86.068776,64.629762 83.309105,66.788232 C 81.907864,67.884209 81.387229,92.223995 71.919297,86.625353 C 67.316417,83.903554 62.167959,73.44849 59.915352,73.101625 C 56.516277,72.578221 50.007529,69.826123 44.029815,64.675414 C 42.461522,63.324094 32.076211,77.214403 31.546762,99.654209 z " />
-      <path
-         style="fill:url(#radialGradient2797);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         id="path2796"
-         d="M 43.53125,77.3125 C 40.353026,86.016409 37.202011,96.366079 40.377303,105.23542 C 48.984655,117.18204 66.049398,117.25223 79.222417,115.04972 C 88.094278,113.47345 96.636121,105.87972 94.744454,96.188658 C 94.751182,88.561019 93.319573,80.643142 89.09375,74.1875 C 87.954705,81.120157 85.706152,92.347929 76.686643,91.786583 C 66.841974,89.84774 65.058803,76.33878 54.747596,75.105769 C 49.945701,71.530053 45.566465,69.110698 43.783935,76.852875 L 43.53125,77.3125 z " />
-      <path
-         transform="matrix(0.440859,0,0,0.441062,0.997459,16.38124)"
-         style="fill:#efd7c7;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:type="arc"
-         sodipodi:ry="57.825485"
-         sodipodi:rx="60.94183"
-         sodipodi:cy="70.290855"
-         sodipodi:cx="150.27701"
-         id="path6032"
-         d="M 211.21884 70.290855 A 60.94183 57.825485 0 1 1  89.335178,70.290855 A 60.94183 57.825485 0 1 1  211.21884 70.290855 z" />
-      <path
-         transform="translate(2.509562,-4.432856e-2)"
-         style="fill:#000000;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="cccccc"
-         id="path3720"
-         d="M 56.980881,5.8426527 C 39.420698,8.0166254 30.552872,16.206245 24.211446,49.532095 C 14.512196,98.076517 21.871677,115.5525 32.990311,115.56714 C 17.54932,102.40769 63.877625,86.740105 56.295103,44.070713 C 68.4508,48.712358 94.51097,54.349644 95.164349,41.718703 C 97.176702,29.219492 88.64173,4.4775042 56.980881,5.8426527 z " />
-      <path
-         style="fill:url(#linearGradient2789);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         id="path2164"
-         d="M 60.687242,45.028999 C 62.530882,55.403773 61.180052,64.151015 58.312242,71.685249 C 61.630122,73.07804 65.296862,73.904 69.155992,73.903999 C 83.975322,73.903999 95.981712,62.468019 95.999742,48.403999 C 88.357632,52.885439 70.244092,48.678277 60.687242,45.028999 z " />
-      <path
-         style="fill:url(#radialGradient2791);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         id="path2790"
-         d="M 52.174948,8.1325312 C 35.846775,12.141346 31.110158,30.475875 28.060647,44.840387 C 24.465246,64.767005 19.485139,85.90438 25.518698,105.82003 C 29.863591,114.87216 28.026452,106.52571 31.049538,102.11795 C 41.311249,87.323083 56.256862,73.307418 55.936774,53.886064 C 56.647391,49.398848 52.34734,38.640985 60.701717,42.254379 C 70.683443,45.202557 82.078811,49.011247 92.143698,44.632531 C 96.945103,37.45042 93.288237,27.137344 88.876323,20.399742 C 81.135092,8.5919962 65.300885,5.0194752 52.174948,8.1325312 z " />
-    </g>
-    <path
-       style="fill:none;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:4.63842154;stroke-linecap:butt;stroke-linejoin:round;stroke-dasharray:none;stroke-opacity:1"
-       sodipodi:nodetypes="cccccccccccc"
-       id="path699"
-       d="M 319.16674,325.66524 L 432.27399,313.12251 L 422.57906,332.08242 L 484.9028,325.95688 C 484.9028,325.95688 494.59773,306.41369 495.05931,306.41369 C 495.52148,306.41369 517.68079,331.79078 517.68079,331.79078 C 517.68079,331.79078 465.51355,358.33479 465.05197,358.33479 C 465.51355,358.91808 474.74689,339.66616 474.74689,339.37453 L 402.72705,345.79207 L 412.42255,326.24852 L 309.01023,338.4996 L 319.16674,325.66524 z "
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157" />
-    <text
-       xml:space="preserve"
-       style="font-size:48px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont;font-stretch:normal;font-variant:normal;text-anchor:start;text-align:start;writing-mode:lr;line-height:125%"
-       x="140"
-       y="521.23737"
-       id="text7612"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157"><tspan
-         sodipodi:role="line"
-         id="tspan7614"
-         x="140"
-         y="521.23737">Server</tspan></text>
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="359.5625"
-       y="261.21948"
-       id="text7877"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157"><tspan
-         sodipodi:role="line"
-         id="tspan7879"
-         x="359.5625"
-         y="261.21948">bzr checkout</tspan></text>
-    <path
-       sodipodi:type="arc"
-       style="fill:#000000"
-       id="path9548"
-       sodipodi:cx="292.14285"
-       sodipodi:cy="181.95163"
-       sodipodi:rx="15"
-       sodipodi:ry="15"
-       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
-       transform="translate(42.857147,67.142853)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157" />
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="325.71429"
-       y="259.52307"
-       id="text9550"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157"><tspan
-         sodipodi:role="line"
-         id="tspan9552"
-         x="325.71429"
-         y="259.52307">1</tspan></text>
-    <path
-       sodipodi:type="arc"
-       style="fill:#000000"
-       id="path9554"
-       sodipodi:cx="292.14285"
-       sodipodi:cy="181.95163"
-       sodipodi:rx="15"
-       sodipodi:ry="15"
-       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
-       transform="translate(492.85715,-2.8571472)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157" />
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="777.71429"
-       y="191.52307"
-       id="text9556"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157"><tspan
-         sodipodi:role="line"
-         id="tspan9558"
-         x="777.71429"
-         y="191.52307">2</tspan></text>
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="819.5625"
-       y="191.21948"
-       id="text9566"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157"><tspan
-         sodipodi:role="line"
-         id="tspan9568"
-         x="819.5625"
-         y="191.21948">bzr update</tspan></text>
-    <path
-       style="fill:none;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:4.29065037;stroke-linecap:butt;stroke-linejoin:round;stroke-dasharray:none;stroke-opacity:1"
-       sodipodi:nodetypes="cccccccccccc"
-       id="path9650"
-       d="M 539.95542,466.93556 L 415.85387,476.71718 L 426.49116,461.93102 L 358.1094,466.70812 C 358.1094,466.70812 347.47211,481.94916 346.96566,481.94916 C 346.45858,481.94916 322.14533,462.15846 322.14533,462.15846 C 322.14533,462.15846 379.38334,441.45772 379.88978,441.45772 C 379.38334,441.00284 369.25249,456.01673 369.25249,456.24417 L 448.27282,451.23935 L 437.63489,466.48068 L 551.09912,456.92649 L 539.95542,466.93556 z "
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157" />
-    <path
-       sodipodi:type="arc"
-       style="fill:#000000"
-       id="path9652"
-       sodipodi:cx="292.14285"
-       sodipodi:cy="181.95163"
-       sodipodi:rx="15"
-       sodipodi:ry="15"
-       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
-       transform="translate(51.511043,348.5966)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157" />
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="334.36819"
-       y="540.97681"
-       id="text9654"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157"><tspan
-         sodipodi:role="line"
-         id="tspan9656"
-         x="334.36819"
-         y="540.97681">3</tspan></text>
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="369.5625"
-       y="544.09448"
-       id="text9658"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157"><tspan
-         sodipodi:role="line"
-         id="tspan9660"
-         x="369.5625"
-         y="544.09448">bzr commit</tspan></text>
-  </g>
-</svg>

=== removed file 'doc/en/user-guide/images/workflows_gatekeeper.png'
Binary files doc/en/user-guide/images/workflows_gatekeeper.png and doc/en/user-guide/images/workflows_gatekeeper.png differ
=== removed file 'doc/en/user-guide/images/workflows_gatekeeper.svg'
--- doc/en/user-guide/images/workflows_gatekeeper.svg	2007-11-30 04:34:08 +0000
+++ doc/en/user-guide/images/workflows_gatekeeper.svg	1970-01-01 00:00:00 +0000
@@ -1,2137 +0,0 @@
-<?xml version="1.0" encoding="UTF-8" standalone="no"?>
-<!-- Created with Inkscape (http://www.inkscape.org/) -->
-<svg
-   xmlns:dc="http://purl.org/dc/elements/1.1/"
-   xmlns:cc="http://web.resource.org/cc/"
-   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
-   xmlns:svg="http://www.w3.org/2000/svg"
-   xmlns="http://www.w3.org/2000/svg"
-   xmlns:xlink="http://www.w3.org/1999/xlink"
-   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"
-   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"
-   width="1052.3622"
-   height="744.09448"
-   id="svg2"
-   sodipodi:version="0.32"
-   inkscape:version="0.45.1"
-   version="1.0"
-   sodipodi:docbase="/home/ian/Desktop/talk/workflows"
-   sodipodi:docname="workflows_gatekeeper.svg"
-   inkscape:output_extension="org.inkscape.output.svg.inkscape"
-   inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_manualpqm.png"
-   inkscape:export-xdpi="90"
-   inkscape:export-ydpi="90">
-  <defs
-     id="defs4">
-    <radialGradient
-       xlink:href="#linearGradient5992"
-       r="33.156250"
-       inkscape:collect="always"
-       id="radialGradient6000"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(1.000000,0.000000,0.000000,1.693685,0.000000,-197.9515)"
-       fy="285.36218"
-       fx="495.50000"
-       cy="285.36218"
-       cx="495.50000" />
-    <linearGradient
-       y2="187.57059"
-       y1="225.40080"
-       xlink:href="#linearGradient5963"
-       x2="458.91232"
-       x1="383.95898"
-       inkscape:collect="always"
-       id="linearGradient5969"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       id="linearGradient3586">
-      <stop
-         style="stop-color:#000000;stop-opacity:1.0000000;"
-         offset="0.0000000"
-         id="stop3588" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0;"
-         offset="1"
-         id="stop3590" />
-    </linearGradient>
-    <linearGradient
-       inkscape:collect="always"
-       id="linearGradient5963">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:1;"
-         offset="0"
-         id="stop5965" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0;"
-         offset="1"
-         id="stop5967" />
-    </linearGradient>
-    <linearGradient
-       inkscape:collect="always"
-       id="linearGradient5992">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:1;"
-         offset="0"
-         id="stop5994" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0;"
-         offset="1"
-         id="stop5996" />
-    </linearGradient>
-    <linearGradient
-       y2="-0.45783132"
-       y1="3.3012049"
-       xlink:href="#linearGradient893"
-       x2="0.92957747"
-       x1="-2.3960868e-17"
-       id="linearGradient4284" />
-    <linearGradient
-       y2="-0.033519555"
-       y1="2.0837989"
-       xlink:href="#linearGradient893"
-       x2="0.99074072"
-       x1="-0.77314812"
-       id="linearGradient4283" />
-    <linearGradient
-       y2="1.8771822"
-       y1="-0.033741195"
-       xlink:href="#linearGradient902"
-       x2="0.48453596"
-       x1="0.47041038"
-       id="linearGradient2740"
-       gradientTransform="scale(0.997153,1.002855)" />
-    <linearGradient
-       y2="1.9025002"
-       y1="-0.043652620"
-       xlink:href="#linearGradient902"
-       x2="0.48481107"
-       x1="0.47042510"
-       id="linearGradient1506"
-       gradientTransform="scale(0.995847,1.004170)" />
-    <linearGradient
-       y2="1.8570156"
-       y1="-0.024853170"
-       xlink:href="#linearGradient902"
-       x2="0.48548824"
-       x1="0.47157744"
-       id="linearGradient1505"
-       gradientTransform="scale(0.997825,1.002180)" />
-    <linearGradient
-       y2="182.99154"
-       y1="169.09755"
-       xlink:href="#linearGradient892"
-       x2="88.996957"
-       x1="88.755695"
-       id="linearGradient1404"
-       gradientTransform="scale(1.3695887,0.7301462)"
-       gradientUnits="userSpaceOnUse" />
-    <radialGradient
-       xlink:href="#linearGradient1317"
-       r="0.34964636"
-       id="radialGradient1316"
-       fy="0.18269235"
-       fx="0.50352114"
-       cy="0.50000006"
-       cx="0.50000000" />
-    <radialGradient
-       xlink:href="#linearGradient1317"
-       r="0.41197181"
-       id="radialGradient1315"
-       fy="0.26666668"
-       fx="0.47535211"
-       cy="0.53333336"
-       cx="0.47887325" />
-    <linearGradient
-       y2="173.03153"
-       y1="177.77768"
-       xlink:href="#linearGradient902"
-       x2="95.100155"
-       x1="101.10657"
-       id="linearGradient1171"
-       gradientTransform="scale(1.3601783,0.7351977)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="1.8378206"
-       y1="-0.016295359"
-       xlink:href="#linearGradient902"
-       x2="0.48655096"
-       x1="0.47284532"
-       id="linearGradient1170"
-       gradientTransform="scale(0.998371,1.001632)" />
-    <linearGradient
-       y2="81.477602"
-       y1="224.57898"
-       xlink:href="#linearGradient893"
-       x2="74.533693"
-       x1="146.69923"
-       id="linearGradient1169"
-       gradientTransform="scale(1.1870691,0.842411)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="133.54711"
-       y1="228.39311"
-       xlink:href="#linearGradient888"
-       x2="88.447016"
-       x1="141.60217"
-       id="linearGradient1167"
-       gradientTransform="scale(1.1838753,0.8446836)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="148.78619"
-       y1="131.25248"
-       xlink:href="#linearGradient1317"
-       x2="107.04918"
-       x1="111.49758"
-       id="linearGradient1166"
-       gradientTransform="scale(1.223869,0.8170809)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="176.28694"
-       y1="269.85831"
-       xlink:href="#linearGradient888"
-       x2="-16.224496"
-       x1="51.460928"
-       id="linearGradient1157"
-       gradientTransform="scale(2.4217071,0.4129318)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="234.26866"
-       y1="178.48862"
-       xlink:href="#linearGradient888"
-       x2="25.220815"
-       x1="25.220815"
-       id="linearGradient1156"
-       gradientTransform="scale(2.4217071,0.4129318)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="105.42543"
-       y1="76.277559"
-       xlink:href="#linearGradient892"
-       x2="8.346058"
-       x1="35.190362"
-       id="linearGradient1150"
-       gradientTransform="scale(1.3283861,0.7527932)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="20.481863"
-       y1="49.507656"
-       xlink:href="#linearGradient892"
-       x2="70.224305"
-       x1="39.690614"
-       id="linearGradient1148"
-       gradientTransform="scale(1.329144,0.7523639)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="113.71949"
-       y1="90.197025"
-       xlink:href="#linearGradient892"
-       x2="17.876529"
-       x1="39.810948"
-       id="linearGradient1146"
-       gradientTransform="scale(1.3207392,0.7571517)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="251.21892"
-       y1="203.499"
-       xlink:href="#linearGradient892"
-       x2="31.617281"
-       x1="31.449743"
-       id="linearGradient1144"
-       gradientTransform="scale(2.1051174,0.4750329)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="-0.45783132"
-       y1="3.3012049"
-       xlink:href="#linearGradient888"
-       x2="0.92957747"
-       x1="0.00000000"
-       id="linearGradient1141" />
-    <linearGradient
-       y2="232.24952"
-       y1="110.4447"
-       xlink:href="#linearGradient888"
-       x2="41.967061"
-       x1="45.685757"
-       id="linearGradient1140"
-       gradientTransform="scale(1.9102155,0.5235012)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="75.912531"
-       y1="375.92199"
-       xlink:href="#linearGradient1806"
-       x2="-268.25407"
-       x1="-249.72067"
-       id="linearGradient1138"
-       gradientTransform="scale(1.087146,0.9198397)"
-       gradientUnits="userSpaceOnUse" />
-    <radialGradient
-       xlink:href="#linearGradient1133"
-       r="68.589222"
-       id="radialGradient1132"
-       fy="39.288476"
-       fx="72.107883"
-       cy="56.485935"
-       cx="60.004654"
-       gradientTransform="scale(1.2267534,0.8151598)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="11.699047"
-       y1="208.43991"
-       xlink:href="#linearGradient888"
-       x2="95.644441"
-       x1="-77.726178"
-       id="linearGradient905"
-       gradientTransform="scale(1.0964158,0.9120627)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       xlink:href="#linearGradient1806"
-       id="linearGradient901" />
-    <linearGradient
-       y2="91.07699"
-       y1="-3.9104078"
-       xlink:href="#linearGradient888"
-       x2="27.674331"
-       x1="92.437968"
-       id="linearGradient891"
-       gradientTransform="scale(1.2267534,0.8151598)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       id="linearGradient888">
-      <stop
-         style="stop-color:#626262;stop-opacity:1.0000000;"
-         offset="0.0000000"
-         id="stop889" />
-      <stop
-         style="stop-color:#fff;stop-opacity:1;"
-         offset="1"
-         id="stop890" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient892">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.00000000;"
-         offset="0.00000000"
-         id="stop893" />
-      <stop
-         style="stop-color:#fff;stop-opacity:1;"
-         offset="1"
-         id="stop894" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient902">
-      <stop
-         style="stop-color:#000000;stop-opacity:0.00000000;"
-         offset="0.00000000"
-         id="stop903" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0.22000000;"
-         offset="1.0000000"
-         id="stop904" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient1098">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:1.0000000;"
-         offset="0.00000000"
-         id="stop1099" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.22314049;"
-         offset="0.50000000"
-         id="stop1101" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.00000000;"
-         offset="0.59930235"
-         id="stop1102" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.60330576;"
-         offset="1.0000000"
-         id="stop1100" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient1133">
-      <stop
-         style="stop-color:#8bb7df;stop-opacity:1.0000000;"
-         offset="0.00000000"
-         id="stop1134" />
-      <stop
-         style="stop-color:#2a6092;stop-opacity:1.0000000;"
-         offset="0.76209301"
-         id="stop1136" />
-      <stop
-         style="stop-color:#375e82;stop-opacity:1.0000000;"
-         offset="1.0000000"
-         id="stop1135" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient1317">
-      <stop
-         style="stop-color:#000000;stop-opacity:0.52892560;"
-         offset="0.00000000"
-         id="stop1318" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0.17355372;"
-         offset="0.50000000"
-         id="stop1320" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0.00000000;"
-         offset="1.0000000"
-         id="stop1319" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient893">
-      <stop
-         style="stop-color:#000;stop-opacity:1;"
-         offset="0"
-         id="stop895" />
-      <stop
-         style="stop-color:#fff;stop-opacity:1;"
-         offset="1"
-         id="stop896" />
-    </linearGradient>
-    <radialGradient
-       xlink:href="#linearGradient1806"
-       r="11.574221"
-       id="radialGradient1977"
-       fy="39.410465"
-       fx="42.280806"
-       cy="39.007645"
-       cx="42.007257"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       id="linearGradient1806">
-      <stop
-         style="stop-color:#000000;stop-opacity:0.35051546;"
-         offset="0.0000000"
-         id="stop1807" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0.13402061;"
-         offset="0.64999998"
-         id="stop3276" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop1808" />
-    </linearGradient>
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient5281"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient5283"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient5285"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <radialGradient
-       xlink:href="#linearGradient4362"
-       r="5.5130484"
-       inkscape:collect="always"
-       id="radialGradient1828"
-       fy="61.38567"
-       fx="86.542037"
-       cy="61.38567"
-       cx="86.542037"
-       gradientTransform="matrix(-0.8164966,0,0,1.2247449,262.80373,-280)"
-       gradientUnits="userSpaceOnUse" />
-    <radialGradient
-       xlink:href="#linearGradient4362"
-       r="11.123441"
-       inkscape:collect="always"
-       id="radialGradient1824"
-       fy="58.887858"
-       fx="118.06427"
-       cy="58.54025"
-       cx="117.17439"
-       gradientTransform="matrix(-0.6229142,0,0,1.6053575,262.80373,-280)"
-       gradientUnits="userSpaceOnUse" />
-    <radialGradient
-       xlink:href="#linearGradient4362"
-       r="22.00904"
-       inkscape:collect="always"
-       id="radialGradient1822"
-       fy="87.892895"
-       fx="45.50637"
-       cy="88.322677"
-       cx="45.139623"
-       gradientTransform="matrix(-1.0914815,0,0,0.9161859,262.80373,-280)"
-       gradientUnits="userSpaceOnUse" />
-    <radialGradient
-       xlink:href="#linearGradient4362"
-       r="18.836343"
-       inkscape:collect="always"
-       id="radialGradient1818"
-       fy="33.351633"
-       fx="48.40165"
-       cy="32.467054"
-       cx="48.40165"
-       gradientTransform="matrix(-1.1146027,0,0,0.8971807,262.80373,-280)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="74.834393"
-       y1="57.093738"
-       xlink:href="#linearGradient4376"
-       x2="50.203204"
-       x1="50.52668"
-       inkscape:collect="always"
-       id="linearGradient1815"
-       gradientTransform="matrix(-1.3516689,0,0,0.7398261,262.80373,-280)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       id="linearGradient4384">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.77513230;"
-         offset="0.0000000"
-         id="stop4385" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop4386" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient4376">
-      <stop
-         style="stop-color:#000000;stop-opacity:0.52645504;"
-         offset="0.0000000"
-         id="stop4377" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop4378" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient4362">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.66666669;"
-         offset="0.0000000"
-         id="stop4363" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop4364" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient4358">
-      <stop
-         style="stop-color:#000;stop-opacity:1;"
-         offset="0"
-         id="stop4359" />
-      <stop
-         style="stop-color:#fff;stop-opacity:1;"
-         offset="1"
-         id="stop4360" />
-    </linearGradient>
-    <radialGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="radialGradient5536"
-       gradientUnits="userSpaceOnUse"
-       cx="42.007257"
-       cy="39.007645"
-       fx="42.280806"
-       fy="39.410465"
-       r="11.574221" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient5538"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient5540"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient5542"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient5544"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient888"
-       id="linearGradient5546"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(2.4217071,0.4129318)"
-       x1="25.220815"
-       y1="178.48862"
-       x2="25.220815"
-       y2="234.26866" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient888"
-       id="linearGradient5548"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(2.4217071,0.4129318)"
-       x1="51.460928"
-       y1="269.85831"
-       x2="-16.224496"
-       y2="176.28694" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient893"
-       id="linearGradient5550"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.1870691,0.842411)"
-       x1="146.69923"
-       y1="224.57898"
-       x2="74.533693"
-       y2="81.477602" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient888"
-       id="linearGradient5552"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.9102155,0.5235012)"
-       x1="45.685757"
-       y1="110.4447"
-       x2="41.967061"
-       y2="232.24952" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient888"
-       id="linearGradient5554"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.0964158,0.9120627)"
-       x1="-77.726178"
-       y1="208.43991"
-       x2="95.644441"
-       y2="11.699047" />
-    <radialGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1133"
-       id="radialGradient5556"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.2267534,0.8151598)"
-       cx="60.004654"
-       cy="56.485935"
-       fx="72.107883"
-       fy="39.288476"
-       r="68.589222" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient888"
-       id="linearGradient5558"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.2267534,0.8151598)"
-       x1="92.437968"
-       y1="-3.9104078"
-       x2="27.674331"
-       y2="91.07699" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient892"
-       id="linearGradient5560"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.3207392,0.7571517)"
-       x1="39.810948"
-       y1="90.197025"
-       x2="17.876529"
-       y2="113.71949" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient892"
-       id="linearGradient5562"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.329144,0.7523639)"
-       x1="39.690614"
-       y1="49.507656"
-       x2="70.224305"
-       y2="20.481863" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient892"
-       id="linearGradient5564"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.3283861,0.7527932)"
-       x1="35.190362"
-       y1="76.277559"
-       x2="8.346058"
-       y2="105.42543" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient888"
-       id="linearGradient5566"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.1838753,0.8446836)"
-       x1="141.60217"
-       y1="228.39311"
-       x2="88.447016"
-       y2="133.54711" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient902"
-       id="linearGradient5568"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.3601783,0.7351977)"
-       x1="101.10657"
-       y1="177.77768"
-       x2="95.100155"
-       y2="173.03153" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient892"
-       id="linearGradient5570"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.3695887,0.7301462)"
-       x1="88.755695"
-       y1="169.09755"
-       x2="88.996957"
-       y2="182.99154" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1317"
-       id="linearGradient5572"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.223869,0.8170809)"
-       x1="111.49758"
-       y1="131.25248"
-       x2="107.04918"
-       y2="148.78619" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient892"
-       id="linearGradient5574"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(2.1051174,0.4750329)"
-       x1="31.449743"
-       y1="203.499"
-       x2="31.617281"
-       y2="251.21892" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient5714"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <radialGradient
-       xlink:href="#linearGradient4362"
-       r="39.648127"
-       inkscape:collect="always"
-       id="radialGradient2797"
-       fy="101.92288"
-       fx="50.092871"
-       cy="102.70191"
-       cx="49.760482"
-       gradientTransform="scale(1.1222336,0.8910801)"
-       gradientUnits="userSpaceOnUse" />
-    <radialGradient
-       xlink:href="#linearGradient4362"
-       r="35.284406"
-       inkscape:collect="always"
-       id="radialGradient2791"
-       fy="32.061308"
-       fx="81.553592"
-       cy="33.402904"
-       cx="80.599566"
-       gradientTransform="scale(0.8352269,1.1972794)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="67.164412"
-       y1="53.505203"
-       xlink:href="#linearGradient4376"
-       x2="63.804663"
-       x1="64.786456"
-       inkscape:collect="always"
-       id="linearGradient2789"
-       gradientTransform="scale(1.1424512,0.8753109)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       id="linearGradient6015">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.77513230;"
-         offset="0.0000000"
-         id="stop6017" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop6019" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient6009">
-      <stop
-         style="stop-color:#000000;stop-opacity:0.52645504;"
-         offset="0.0000000"
-         id="stop6011" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop6013" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient6003">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.66666669;"
-         offset="0.0000000"
-         id="stop6005" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop6007" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient5997">
-      <stop
-         style="stop-color:#000;stop-opacity:1;"
-         offset="0"
-         id="stop5999" />
-      <stop
-         style="stop-color:#fff;stop-opacity:1;"
-         offset="1"
-         id="stop6001" />
-    </linearGradient>
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient6037"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <linearGradient
-       y2="0.46093750"
-       y1="0.46093750"
-       xlink:href="#linearGradient650"
-       x2="1.16666818"
-       x1="1.22222710"
-       spreadMethod="repeat"
-       id="linearGradient654"
-       gradientUnits="objectBoundingBox" />
-    <linearGradient
-       y2="0.53906250"
-       y1="0.53125000"
-       xlink:href="#linearGradient650"
-       x2="1.16666901"
-       x1="1.00000548"
-       spreadMethod="repeat"
-       id="linearGradient653"
-       gradientUnits="objectBoundingBox" />
-    <linearGradient
-       id="linearGradient650">
-      <stop
-         style="stop-color:#000;stop-opacity:1;"
-         offset="0"
-         id="stop651" />
-      <stop
-         style="stop-color:#fff;stop-opacity:1;"
-         offset="1"
-         id="stop652" />
-    </linearGradient>
-    <linearGradient
-       y2="0.46093750"
-       y1="0.46093750"
-       xlink:href="#linearGradient650"
-       x2="1.16666818"
-       x1="1.22222710"
-       spreadMethod="repeat"
-       id="linearGradient9648"
-       gradientUnits="objectBoundingBox" />
-    <linearGradient
-       y2="0.53906250"
-       y1="0.53125000"
-       xlink:href="#linearGradient650"
-       x2="1.16666901"
-       x1="1.00000548"
-       spreadMethod="repeat"
-       id="linearGradient9646"
-       gradientUnits="objectBoundingBox" />
-    <linearGradient
-       id="linearGradient9640">
-      <stop
-         style="stop-color:#000;stop-opacity:1;"
-         offset="0"
-         id="stop9642" />
-      <stop
-         style="stop-color:#fff;stop-opacity:1;"
-         offset="1"
-         id="stop9644" />
-    </linearGradient>
-    <radialGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="radialGradient7932"
-       gradientUnits="userSpaceOnUse"
-       cx="42.007257"
-       cy="39.007645"
-       fx="42.280806"
-       fy="39.410465"
-       r="11.574221" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient7934"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient7936"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient7938"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient7940"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient888"
-       id="linearGradient7942"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(2.4217071,0.4129318)"
-       x1="25.220815"
-       y1="178.48862"
-       x2="25.220815"
-       y2="234.26866" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient888"
-       id="linearGradient7944"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(2.4217071,0.4129318)"
-       x1="51.460928"
-       y1="269.85831"
-       x2="-16.224496"
-       y2="176.28694" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient893"
-       id="linearGradient7946"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.1870691,0.842411)"
-       x1="146.69923"
-       y1="224.57898"
-       x2="74.533693"
-       y2="81.477602" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient888"
-       id="linearGradient7948"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.9102155,0.5235012)"
-       x1="45.685757"
-       y1="110.4447"
-       x2="41.967061"
-       y2="232.24952" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient888"
-       id="linearGradient7950"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.0964158,0.9120627)"
-       x1="-77.726178"
-       y1="208.43991"
-       x2="95.644441"
-       y2="11.699047" />
-    <radialGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1133"
-       id="radialGradient7952"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.2267534,0.8151598)"
-       cx="60.004654"
-       cy="56.485935"
-       fx="72.107883"
-       fy="39.288476"
-       r="68.589222" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient888"
-       id="linearGradient7954"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.2267534,0.8151598)"
-       x1="92.437968"
-       y1="-3.9104078"
-       x2="27.674331"
-       y2="91.07699" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient892"
-       id="linearGradient7956"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.3207392,0.7571517)"
-       x1="39.810948"
-       y1="90.197025"
-       x2="17.876529"
-       y2="113.71949" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient892"
-       id="linearGradient7958"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.329144,0.7523639)"
-       x1="39.690614"
-       y1="49.507656"
-       x2="70.224305"
-       y2="20.481863" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient892"
-       id="linearGradient7960"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.3283861,0.7527932)"
-       x1="35.190362"
-       y1="76.277559"
-       x2="8.346058"
-       y2="105.42543" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient888"
-       id="linearGradient7962"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.1838753,0.8446836)"
-       x1="141.60217"
-       y1="228.39311"
-       x2="88.447016"
-       y2="133.54711" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient902"
-       id="linearGradient7964"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.3601783,0.7351977)"
-       x1="101.10657"
-       y1="177.77768"
-       x2="95.100155"
-       y2="173.03153" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient892"
-       id="linearGradient7966"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.3695887,0.7301462)"
-       x1="88.755695"
-       y1="169.09755"
-       x2="88.996957"
-       y2="182.99154" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1317"
-       id="linearGradient7968"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.223869,0.8170809)"
-       x1="111.49758"
-       y1="131.25248"
-       x2="107.04918"
-       y2="148.78619" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient892"
-       id="linearGradient7990"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(2.1051174,0.4750329)"
-       x1="31.449743"
-       y1="203.499"
-       x2="31.617281"
-       y2="251.21892" />
-    <radialGradient
-       xlink:href="#linearGradient1861"
-       r="26.285225"
-       inkscape:collect="always"
-       id="radialGradient1887"
-       fy="44.906904"
-       fx="34.609807"
-       cy="45.317611"
-       cx="33.865884"
-       gradientTransform="scale(1.3025634,0.767717)"
-       gradientUnits="userSpaceOnUse" />
-    <radialGradient
-       xlink:href="#linearGradient1861"
-       r="27.313507"
-       inkscape:collect="always"
-       id="radialGradient1885"
-       fy="96.522109"
-       fx="44.745902"
-       cy="96.948882"
-       cx="45.838441"
-       gradientTransform="scale(1.0963096,0.9121511)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="69.990188"
-       y1="60.176033"
-       xlink:href="#linearGradient1864"
-       x2="54.084046"
-       x1="51.210938"
-       inkscape:collect="always"
-       id="linearGradient1883"
-       gradientTransform="scale(1.2343409,0.8101489)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       id="linearGradient1858">
-      <stop
-         style="stop-color:#000;stop-opacity:1;"
-         offset="0"
-         id="stop1859" />
-      <stop
-         style="stop-color:#fff;stop-opacity:1;"
-         offset="1"
-         id="stop1860" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient1861">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.66666669;"
-         offset="0.0000000"
-         id="stop1862" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop1863" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient1864">
-      <stop
-         style="stop-color:#000000;stop-opacity:0.52645504;"
-         offset="0.0000000"
-         id="stop1865" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop1866" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient1867">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.77513230;"
-         offset="0.0000000"
-         id="stop1868" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop1869" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient11180">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.77513230;"
-         offset="0.0000000"
-         id="stop11182" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop11184" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient11174">
-      <stop
-         style="stop-color:#000000;stop-opacity:0.52645504;"
-         offset="0.0000000"
-         id="stop11176" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop11178" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient11168">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.66666669;"
-         offset="0.0000000"
-         id="stop11170" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop11172" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient11162">
-      <stop
-         style="stop-color:#000;stop-opacity:1;"
-         offset="0"
-         id="stop11164" />
-      <stop
-         style="stop-color:#fff;stop-opacity:1;"
-         offset="1"
-         id="stop11166" />
-    </linearGradient>
-  </defs>
-  <sodipodi:namedview
-     id="base"
-     pagecolor="#ffffff"
-     bordercolor="#666666"
-     borderopacity="1.0"
-     gridtolerance="10000"
-     guidetolerance="10"
-     objecttolerance="10"
-     inkscape:pageopacity="0.0"
-     inkscape:pageshadow="2"
-     inkscape:zoom="1"
-     inkscape:cx="559.94128"
-     inkscape:cy="472.46874"
-     inkscape:document-units="px"
-     inkscape:current-layer="layer1"
-     width="1052.3622px"
-     height="744.09448px"
-     showgrid="true"
-     inkscape:window-width="1416"
-     inkscape:window-height="825"
-     inkscape:window-x="0"
-     inkscape:window-y="25" />
-  <metadata
-     id="metadata7">
-    <rdf:RDF>
-      <cc:Work
-         rdf:about="">
-        <dc:format>image/svg+xml</dc:format>
-        <dc:type
-           rdf:resource="http://purl.org/dc/dcmitype/StillImage" />
-      </cc:Work>
-    </rdf:RDF>
-  </metadata>
-  <g
-     inkscape:label="Layer 1"
-     inkscape:groupmode="layer"
-     id="layer1">
-    <g
-       inkscape:label="Layer 1"
-       id="g4996"
-       transform="matrix(0.331077,0,0,0.2676656,39.992157,230.68349)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644">
-      <g
-         transform="matrix(2.674162,0,0,2.674162,-826.248,-323.8239)"
-         id="g6052">
-        <path
-           style="fill:#c7c7c7;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:6.11299896;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
-           sodipodi:nodetypes="czcczzz"
-           id="path1306"
-           d="M 362.77592,187.283 C 360.50343,190.98677 361.20593,367.68763 364.14011,374.65173 C 366.46268,380.1642 441.02381,442.12988 444.93699,443.78694 C 495.35017,443.444 529.34176,425.0858 534.99109,415.38735 C 537.14042,403.1889 535.31621,215.19709 533.25552,211.25359 C 531.47859,207.85312 436.04893,173.6386 432.71615,172.86054 C 429.71763,172.16052 365.30189,183.1661 362.77592,187.283 z " />
-        <path
-           style="fill:#ffffff;fill-opacity:0.54385968;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
-           sodipodi:nodetypes="ccccccc"
-           id="path2066"
-           d="M 366.42857,190.93361 C 391.19048,201.4098 418.60601,218.30739 446.22506,231.64072 C 472.394,225.42153 510.2022,217.10972 529.24981,213.77639 C 504.726,221.39543 472.52022,228.51448 447.99641,236.13353 C 446.56784,293.51448 447.257,380.45861 445.82843,437.83956 C 445.11414,379.98242 443.14285,291.6479 442.42856,233.79075 C 415.99999,219.50504 390,206.64789 366.42857,190.93361 z " />
-        <path
-           style="fill:#000000;fill-opacity:0.16228069;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
-           sodipodi:nodetypes="ccc"
-           id="path4356"
-           d="M 519.99794,379.97737 C 510.93834,392.99882 482.41849,399.43361 468.8726,394.16864 C 471.21835,393.5424 516.96143,380.96883 519.99794,379.97737 z " />
-        <g
-           transform="translate(2.035534,15.20712)"
-           id="g4374">
-          <path
-             style="fill:#ffffff;fill-opacity:0.39473685;fill-rule:evenodd;stroke:none;stroke-width:1.01199996;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
-             sodipodi:nodetypes="cccccc"
-             id="path4362"
-             d="M 471.29127,340.59039 L 513.55921,324.30516 C 517.9002,325.84805 517.04588,332.27818 517.04588,332.27818 L 510.46155,334.58088 C 510.46155,334.58088 501.26764,349.01224 484.93096,343.36795 C 484.93096,343.36795 472.7787,345.52605 471.29127,340.59039 z " />
-          <path
-             style="fill:#606060;fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:1.11199999;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
-             sodipodi:nodetypes="ccccccc"
-             id="path2826"
-             d="M 471.66824,335.10501 C 485.70133,331.45482 499.73443,327.80464 513.76752,324.15445 C 514.30594,326.13864 514.34437,328.99782 513.50779,330.48201 C 511.36566,331.50652 507.10221,332.35425 504.96008,333.37876 C 498.80357,339.27354 493.45917,339.80363 483.65919,338.95243 C 479.87505,339.74603 476.0909,340.36284 472.30676,341.15644 C 471.15285,338.85897 470.82215,337.90248 471.66824,335.10501 z " />
-        </g>
-        <path
-           style="fill:#ffffff;fill-opacity:0.40350874;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
-           sodipodi:nodetypes="ccccc"
-           id="path4423"
-           d="M 364.8671,189.69191 L 446.71991,235.61832 L 446.39149,441.00771 L 366.28132,373.53968 L 364.8671,189.69191 z " />
-        <path
-           style="fill:#000000;fill-opacity:0.16228069;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
-           sodipodi:nodetypes="ccc"
-           id="path5957"
-           d="M 515.24794,392.97737 C 505.81506,405.42036 486.94113,407.56087 476.3726,403.76831 C 478.1563,403.29212 512.93901,393.73127 515.24794,392.97737 z " />
-        <path
-           style="fill:#000000;fill-opacity:0.16228069;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
-           sodipodi:nodetypes="ccc"
-           id="path5959"
-           d="M 508.24794,405.72737 C 502.79158,413.09279 492.2492,415.37141 483.8726,412.49343 C 484.991,412.19485 506.80021,406.20008 508.24794,405.72737 z " />
-        <path
-           style="fill:#fcfcfc;fill-opacity:0.44298245;fill-rule:evenodd;stroke:none;stroke-width:0.31200001;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
-           sodipodi:nodetypes="ccccccc"
-           id="path5973"
-           d="M 522.875,227.86218 L 527.04289,228.4302 L 527.79289,326.56929 L 463.46862,344.54896 L 461.88388,339.34073 L 523.68934,322.86218 L 522.875,227.86218 z " />
-        <path
-           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
-           sodipodi:nodetypes="cccc"
-           id="path6026"
-           d="M 462.21967,264.23013 L 462.31434,266.99086 L 522.7929,249.54632 L 462.21967,264.23013 z " />
-        <path
-           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
-           sodipodi:nodetypes="cccc"
-           id="path6036"
-           d="M 461.33579,284.2059 L 461.43046,286.96663 L 521.90902,269.52209 L 461.33579,284.2059 z " />
-        <path
-           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
-           sodipodi:nodetypes="cccc"
-           id="path6038"
-           d="M 462.21967,302.64613 L 462.31434,305.40686 L 522.7929,287.96232 L 462.21967,302.64613 z " />
-        <path
-           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
-           sodipodi:nodetypes="cccc"
-           id="path6040"
-           d="M 462.21967,320.79868 L 462.31434,323.55941 L 522.7929,306.11487 L 462.21967,320.79868 z " />
-        <path
-           style="opacity:1;color:#000000;fill:none;fill-opacity:0.75;fill-rule:evenodd;stroke:#9e9e9e;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
-           sodipodi:nodetypes="ccc"
-           id="path5988"
-           d="M 522.55191,229.64344 L 462.03362,244.76045 L 462.53549,344.35813" />
-      </g>
-    </g>
-    <g
-       id="g5256"
-       transform="translate(601.5744,227.66157)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644">
-      <path
-         transform="matrix(6.392368,0.545409,-0.130014,2.864752,-184.6606,-38.15109)"
-         style="fill:url(#radialGradient1977);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:type="arc"
-         sodipodi:ry="12.562782"
-         sodipodi:rx="12.562782"
-         sodipodi:cy="37.865574"
-         sodipodi:cx="41.875938"
-         id="path1976"
-         d="M 54.438721 37.865574 A 12.562782 12.562782 0 1 1  29.313156,37.865574 A 12.562782 12.562782 0 1 1  54.438721 37.865574 z" />
-      <g
-         transform="matrix(1,0,0,1.036969,356.8306,-11.4294)"
-         style="fill:url(#linearGradient6037);fill-opacity:1"
-         id="g4293">
-        <path
-           style="fill:url(#linearGradient5281);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
-           id="path2720"
-           d="M -270.85787,33.814995 C -289.35564,33.925992 -307.93321,33.592782 -326.38104,33.981747 C -331.43469,35.696391 -331.02221,41.899652 -330.68524,46.15332 C -330.75782,60.227303 -330.53537,74.298225 -330.21167,88.36826 C -328.21297,91.039611 -323.21766,90.618387 -322.68469,94.539015 C -320.78054,96.259426 -317.05071,94.88215 -314.4389,95.333237 C -298.54999,95.360274 -282.66107,95.387302 -266.77215,95.414339 C -266.35587,90.465192 -260.12609,88.824447 -255.81783,89.540255 C -256.01688,89.058389 -261.69557,87.939375 -259.61591,84.491525 C -259.45681,68.72727 -259.19734,52.882199 -259.82064,37.168229 C -261.19394,32.980583 -267.34179,33.83368 -270.85787,33.814995 z M -236.65184,97.260473 C -234.79025,100.12642 -237.08724,103.09386 -239.92892,104.16357 C -242.6311,105.91539 -245.59105,107.62992 -248.52894,108.76804 C -253.1773,108.19079 -251.42424,101.88475 -255.01281,99.896645 C -260.33594,96.447012 -267.21045,98.43943 -273.23329,97.939231 C -291.8249,97.94887 -310.41651,97.958519 -329.00813,97.968158 C -335.45898,103.56578 -339.16595,111.40269 -341.55034,119.32178 C -337.25147,124.2061 -329.89606,122.27575 -324.10438,122.40002 C -298.64553,122.23171 -273.11679,122.61546 -247.69897,122.24542 C -243.40174,121.14669 -247.44685,114.84894 -243.58488,113.04441 C -242.73865,112.73374 -247.81245,114.4382 -247.26205,111.62955 C -245.49117,106.66028 -239.14113,105.99595 -235.92338,102.36811 C -234.39131,99.755669 -236.26958,96.922488 -238.33047,95.260495 C -237.77093,95.927151 -237.21138,96.593817 -236.65184,97.260473 z M -240.64255,111.75263 C -243.64086,113.13223 -237.02792,110.69536 -235.55512,111.97369 C -229.71113,112.74417 -224.16461,117.19625 -218.12358,115.22951 C -225.97639,116.31604 -232.799,109.03014 -240.64255,111.75263 z M -212.01083,112.33724 C -215.98173,113.85021 -208.21543,112.17765 -210.07883,115.87566 C -212.50961,119.93855 -206.99008,113.8662 -209.61436,112.54677 C -210.16198,111.94632 -211.27989,112.47663 -212.01083,112.33724 z M -213.97451,120.82946 C -220.13871,124.32615 -228.37873,119.08124 -233.85995,124.39439 C -238.36465,128.00055 -244.57099,130.35185 -247.0433,135.75122 C -247.65922,139.60202 -243.25109,141.90251 -240.44565,143.71808 C -235.60127,146.54512 -228.8227,145.75388 -225.20082,141.42836 C -220.62679,137.96117 -216.44182,134.08489 -212.48592,129.96782 C -212.82701,126.95048 -214.43694,123.63971 -213.97451,120.82946 z " />
-        <path
-           style="fill:url(#linearGradient5283);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
-           id="path2723"
-           d="M -269.68453,32.256957 C -288.76965,32.351184 -307.87514,32.249603 -326.94796,32.349264 C -332.63884,33.663474 -333.90446,40.291305 -333.21597,45.149113 C -333.11996,59.896901 -333.07471,74.659754 -332.61729,89.39481 C -331.88583,93.310348 -324.86009,92.098674 -325.11097,96.44089 C -328.07184,96.184706 -331.5534,96.317135 -333.07248,99.246492 C -338.92562,104.98392 -341.99312,112.66465 -344.27268,120.28679 C -340.22572,125.96631 -332.26467,125.31453 -326.02946,124.71751 C -300.16629,124.7277 -274.28316,124.82043 -248.43245,124.77905 C -244.42424,124.78686 -243.30672,120.35609 -243.96666,117.2099 C -242.88598,112.93536 -237.04086,113.94554 -233.80717,114.98513 C -228.01851,116.64297 -221.26418,120.43074 -215.57982,116.37592 C -211.36091,113.71809 -213.05678,118.4029 -215.77936,119.43344 C -220.82539,122.25797 -227.09125,118.98178 -232.39677,121.20855 C -236.53238,123.88957 -240.74707,126.85249 -244.76678,129.74666 C -248.34219,132.01467 -251.90947,137.38626 -248.13747,140.97315 C -243.79274,146.02948 -236.37425,149.4527 -229.68248,147.08651 C -225.09383,144.85973 -221.79206,140.75401 -217.61535,137.88661 C -215.10454,135.69469 -212.49235,133.26839 -210.83749,130.50207 C -210.86477,126.92195 -214.68529,121.91303 -210.252,119.57013 C -207.25619,117.95208 -205.81053,112.12098 -209.75314,110.87946 C -214.16982,109.44692 -216.95156,115.09837 -221.43751,113.68608 C -228.47365,112.76758 -235.5565,107.20489 -242.69931,110.72434 C -246.89551,113.06547 -243.47174,109.4356 -241.45524,108.56544 C -237.85613,106.84628 -232.73147,104.36798 -233.94637,99.617708 C -234.27189,95.083838 -239.22223,93.197522 -242.95318,91.723135 C -247.61613,89.074942 -253.27003,89.345117 -258.06082,86.933298 C -257.89248,70.385101 -257.58805,53.76423 -258.26571,37.261116 C -259.2092,32.393288 -265.59824,31.96057 -269.68453,32.256957 z M -258.66259,91.764016 C -251.5059,92.239344 -243.21163,93.474137 -238.58238,99.271629 C -238.96251,103.06003 -244.00295,103.80224 -246.52821,106.14082 C -248.92267,108.48087 -251.12372,105.80503 -251.02958,103.27159 C -252.70852,98.336432 -258.20582,95.710815 -263.31841,96.533197 C -267.00561,96.7255 -263.71935,91.937514 -261.395,92.380192 C -260.48382,92.178338 -259.57521,91.953759 -258.66259,91.764016 z " />
-        <path
-           style="fill:url(#linearGradient5285);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
-           sodipodi:nodetypes="ccccczccccccccccccccccccczccccc"
-           id="path2737"
-           d="M -324.0398,30.70877 C -336.3492,30.820231 -335.15663,39.652507 -334.79476,45.313268 C -334.5469,60.436643 -334.38614,75.599009 -334.01234,90.698281 C -333.20516,93.057424 -330.71249,93.985661 -328.75475,95.252079 C -334.4553,96.476239 -336.96996,102.43195 -340.11175,106.59303 C -342.33294,111.36531 -347.84019,115.92868 -345.92111,121.43642 C -344.00204,126.94416 -332.21757,127.68181 -324.95408,127.12866 C -299.06901,127.09789 -273.17022,127.14905 -247.29372,127.06713 C -243.29961,126.16956 -240.99668,122.03601 -241.4977,118.23645 C -238.30082,114.95371 -233.32521,118.03039 -229.53292,118.63002 C -225.71641,119.31313 -232.5646,119.27527 -233.19362,120.54849 C -238.23604,122.95799 -242.6166,126.65447 -246.90973,130.10509 C -250.44674,132.97354 -252.4229,138.10741 -249.57412,142.08235 C -246.21315,145.92284 -241.41489,148.84284 -236.30395,149.79628 C -230.65487,150.83779 -225.57101,147.82678 -221.6157,144.24077 C -216.87391,140.59839 -212.0873,136.78287 -208.84361,131.80554 C -207.76302,128.26399 -211.47449,123.86671 -208.08348,121.09796 C -204.93438,118.46115 -204.06893,113.02076 -207.41836,110.2673 C -212.81988,106.81278 -218.36682,114.55112 -223.89705,111.29128 C -227.94209,110.1659 -231.91311,108.52596 -236.17676,108.45194 C -231.52711,105.88023 -229.62903,98.782331 -234.08944,95.153402 C -239.61551,89.404431 -248.455,88.793917 -255.40182,85.744487 C -255.86992,78.940296 -255.53665,71.972758 -255.70928,65.098797 C -255.80747,55.730822 -255.73864,46.312632 -255.94025,36.975777 C -258.03631,31.236293 -265.34014,30.439522 -270.76286,30.729689 C -289.40725,30.770714 -311.88665,30.597309 -324.0398,30.70877 z M -255.46516,94.482857 C -250.34561,95.62106 -244.69322,96.21649 -240.83258,100.05203 C -242.37635,102.55028 -245.27573,103.64481 -247.80048,104.97505 C -249.71506,99.684643 -254.39847,94.970039 -260.51378,95.138259 C -260.66903,94.131274 -256.73261,94.551178 -255.46516,94.482857 z " />
-      </g>
-      <rect
-         y="78.658051"
-         x="33.326111"
-         width="57.567924"
-         style="fill:url(#linearGradient1156);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient1157);stroke-width:1.44734821pt"
-         id="rect1155"
-         height="8.3153667" />
-      <path
-         style="fill:url(#linearGradient1169);fill-rule:evenodd;stroke-width:0.90459263;stroke-opacity:0.07438019"
-         sodipodi:nodetypes="czzczczzzzzzzc"
-         id="path2676"
-         d="M 98.723806,78.927818 C 95.18666,77.759681 93.50122,82.555591 98.766686,81.004087 C 104.03217,79.452583 120.13123,85.906451 120.37383,89.795491 C 120.61643,93.905503 101.5003,98.581154 106.74108,104.42426 C 111.62816,110.70149 115.35468,100.13868 123.54696,104.21261 C 131.73923,108.17607 136.26048,109.72394 142.25488,104.94185 C 149.10027,101.9342 145.04599,107.07658 139.57918,113.60451 C 134.11237,120.13244 144.00251,115.08156 147.91225,105.31962 C 151.93248,95.557673 139.13128,107.33503 133.66268,105.40571 C 128.19408,103.47639 119.73678,97.849788 113.27625,102.55563 C 106.81572,107.26147 109.62894,99.493003 114.85637,97.90307 C 120.0838,96.092166 122.81363,93.045722 122.85597,90.161522 C 122.89831,87.498293 117.92629,84.811803 112.94229,82.402852 C 107.73732,79.993901 100.49788,78.588966 98.723806,78.927818 z " />
-      <path
-         style="fill:url(#linearGradient1140);fill-opacity:1;fill-rule:evenodd;stroke-width:1.44734821pt"
-         sodipodi:nodetypes="czzzzzzzz"
-         id="path1139"
-         d="M 15.102732,106.80712 C 13.80355,109.23224 17.148847,113.52338 19.900059,113.52338 L 107.85106,113.52338 C 110.18914,113.52338 113.70766,110.4906 112.64839,108.40622 L 102.7339,88.897093 C 101.97024,87.394398 100.26184,86.65834 98.576216,86.65834 L 28.215425,86.658339 C 26.825434,86.658339 25.353768,87.671846 24.697385,88.897093 L 15.102732,106.80712 z " />
-      <rect
-         y="22.413721"
-         x="26.015469"
-         width="72.279724"
-         style="fill:url(#linearGradient905);fill-opacity:1;fill-rule:evenodd;stroke-width:1.62826681"
-         ry="5.4369707"
-         rx="5.4369707"
-         id="rect1137"
-         height="60.126495" />
-      <rect
-         y="31.695871"
-         x="33.386066"
-         width="58.178177"
-         style="fill:url(#radialGradient1132);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient891);stroke-width:1.4649456pt"
-         id="rect1131"
-         height="38.044163" />
-      <path
-         style="fill:url(#linearGradient1146);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="czzccccc"
-         id="path1145"
-         d="M 27.690431,52.841444 L 27.370609,74.749236 C 27.319624,78.241665 29.310209,80.477938 32.807578,80.506029 L 72.625393,80.825852 L 76.463254,71.87084 L 32.008024,71.55102 L 31.688202,52.681533 L 27.690431,52.841444 z " />
-      <g
-         transform="matrix(-1,0,0,1,125.4301,0)"
-         id="g1791">
-        <path
-           style="fill:url(#linearGradient1148);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-           sodipodi:nodetypes="czzccc"
-           id="path1147"
-           d="M 42.062098,33.460351 L 77.341205,33.008055 C 82.787126,32.938235 89.553204,38.416797 89.553204,43.863165 L 89.553204,60.14583 L 41.609801,59.693534 L 42.062098,33.460351 z " />
-        <path
-           style="fill:url(#linearGradient1150);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-           sodipodi:nodetypes="czzccc"
-           id="path1149"
-           d="M 78.337784,67.629235 L 46.723745,67.724544 C 41.843589,67.739257 35.829319,62.771024 35.877168,57.891081 L 36.020221,43.301821 L 78.973514,44.128288 L 78.337784,67.629235 z " />
-      </g>
-      <path
-         style="fill:url(#linearGradient1167);fill-opacity:1;fill-rule:evenodd;stroke-width:0.72367412;stroke-opacity:0.34710741"
-         sodipodi:nodetypes="cczzzzzzc"
-         id="path1159"
-         d="M 137.39107,112.02341 C 137.39107,112.02341 129.0757,110.26438 123.63872,113.62251 C 118.20176,116.98064 109.96635,123.21719 108.76702,124.81628 C 107.40777,126.57531 107.42036,130.22796 109.24674,131.53253 L 114.84364,135.53031 C 118.31797,138.01198 124.86218,139.25396 128.11624,136.48978 L 142.98795,123.85681 C 144.79792,122.3193 145.72732,118.27921 144.10733,116.82073 C 142.95609,115.04975 140.4892,112.91939 137.39107,112.02341 z " />
-      <path
-         style="fill:url(#linearGradient1171);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="czzzzzc"
-         id="path1160"
-         d="M 142.3483,121.13833 L 125.91043,133.59673 C 122.97154,135.82414 118.65484,134.11775 116.28283,133.77129 C 113.9108,133.42481 111.88528,131.87901 112.12516,132.33209 C 112.36503,132.78517 115.08349,135.71687 117.72203,136.48978 C 120.36055,137.26267 124.9543,138.89307 127.50953,136.15531 C 130.06477,133.41755 145.2267,123.53699 142.3483,121.13833 z " />
-      <path
-         style="fill:url(#linearGradient1404);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="cczc"
-         id="path1403"
-         d="M 132.11225,127.51984 C 135.31047,122.88242 120.11893,113.12786 109.08509,127.0401 C 110.20446,130.71805 116.80662,132.5992 121.82304,132.33547 C 126.68363,132.07993 129.50037,129.97181 132.11225,127.51984 z " />
-      <path
-         style="fill:url(#linearGradient1166);fill-opacity:1;fill-rule:evenodd;stroke-width:1.08551121"
-         sodipodi:nodetypes="cccccccc"
-         id="path1519"
-         d="M 138.63464,112.68306 C 135.9958,113.22749 132.31739,114.43079 129.87534,116.38362 C 128.77009,115.68011 125.32759,114.5677 123.66767,113.84494 L 123.24572,114.10517 C 129.67287,117.23476 136.43512,117.91249 135.88192,122.87668 C 136.33675,122.98575 137.05589,123.09702 136.73191,122.38863 C 136.41775,118.90392 132.50587,117.23351 131.02697,116.81532 C 133.17224,114.26602 136.255,113.70892 138.63464,112.68306 z " />
-      <path
-         style="fill:url(#linearGradient1144);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="czzzzzzzz"
-         id="path1143"
-         d="M 18.891612,106.48414 C 17.978451,108.31614 19.173914,111.55774 22.263529,111.55774 L 105.0195,111.55774 C 106.66288,111.55774 109.13595,109.26672 108.39142,107.69215 L 101.42279,92.954575 C 100.88602,91.819403 99.685232,91.263378 98.500462,91.263378 L 28.108183,91.263369 C 27.131195,91.263369 26.0968,92.028994 25.635445,92.954575 L 18.891612,106.48414 z " />
-      <text
-         y="-14.660837"
-         xml:space="preserve"
-         x="6.147172"
-         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
-         id="text1232"><tspan
-           id="tspan1233">Computer</tspan></text>
-      <text
-         y="-34.951134"
-         xml:space="preserve"
-         x="84.564949"
-         transform="scale(0.246729,0.246729)"
-         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
-         id="text1235"><tspan
-           id="tspan1236">Created by Andrew Fitzsimon</tspan></text>
-    </g>
-    <g
-       id="g5474"
-       transform="translate(635.63525,491.49239)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644">
-      <path
-         style="fill:#ffffff;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="cccc"
-         id="path9383"
-         d="M 203.47051,-209.74941 C 198.72111,-204.56585 195.69876,-195.27863 189.00642,-195.27863 C 182.52997,-197.07848 181.66644,-212.48518 180.80291,-215.7969 C 188.1429,-210.75732 195.69876,-207.87757 203.47051,-209.74941 z " />
-      <path
-         transform="matrix(-0.440859,0,0,0.441062,265.52775,-266.17138)"
-         style="fill:#f1bb96;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:type="arc"
-         sodipodi:ry="57.825485"
-         sodipodi:rx="60.94183"
-         sodipodi:cy="70.290855"
-         sodipodi:cx="150.27701"
-         id="path3713"
-         d="M 211.21884 70.290855 A 60.94183 57.825485 0 1 1  89.335178,70.290855 A 60.94183 57.825485 0 1 1  211.21884 70.290855 z" />
-      <path
-         style="fill:#233e6a;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="ccssssc"
-         id="path4369"
-         d="M 232.46888,-182.94274 C 232.85952,-157.74648 168.23012,-154.86512 168.38642,-182.94274 C 166.84164,-205.27149 177.94687,-217.96719 180.70654,-215.80872 C 182.10778,-214.71274 182.62841,-190.37295 192.09635,-195.9716 C 196.69923,-198.69339 201.84768,-209.14846 204.10029,-209.49532 C 207.49937,-210.01873 214.00811,-212.77083 219.98583,-217.92153 C 221.55412,-219.27285 231.93943,-205.38255 232.46888,-182.94274 z " />
-      <path
-         style="fill:#513624;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="ccccc"
-         id="path11309"
-         d="M 204.55432,-273.85152 C 222.46413,-271.53047 237.32676,-259.28175 231.38357,-231.42099 C 229.66954,-221.67743 222.12426,-217.60887 219.35537,-236.36962 C 211.4578,-233.88387 177.25785,-223.92576 170.54948,-241.26677 C 166.55631,-248.43407 174.86257,-276.23329 204.55432,-273.85152 z " />
-      <path
-         style="fill:#1f4eb3;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="cccc"
-         id="path11942"
-         d="M 191.92173,-167.75448 C 192.06919,-184.44566 194.18855,-193.73288 188.47558,-194.95709 C 182.9785,-195.85052 179.91138,-176.52634 179.04785,-173.21462 C 175.85958,-157.19769 189.53653,-154.44605 191.92173,-167.75448 z " />
-      <path
-         style="fill:url(#linearGradient1815);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         id="path1811"
-         d="M 172.67812,-237.76056 C 182.56217,-225.58826 212.09549,-234.15979 219.36562,-236.44806 C 220.33459,-229.88278 221.90014,-226.25074 223.58437,-224.54181 C 219.31219,-215.8234 210.06249,-209.76056 199.27187,-209.76056 C 184.44142,-209.76056 172.42812,-221.18201 172.42812,-235.26056 C 172.42812,-236.11869 172.59078,-236.92413 172.67812,-237.76056 z " />
-      <path
-         style="fill:url(#radialGradient1818);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="ccccc"
-         id="path1817"
-         d="M 203.17522,-273.74212 C 221.08504,-271.42107 235.94766,-259.17235 230.00448,-231.31159 C 228.29044,-221.56803 220.74517,-217.49946 217.97627,-236.26022 C 210.0787,-233.77447 175.87876,-223.81635 169.17039,-241.15737 C 165.17722,-248.32467 173.48348,-276.12389 203.17522,-273.74212 z " />
-      <path
-         style="fill:url(#radialGradient1822);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         id="path1819"
-         d="M 220.74123,-214.1875 C 227.87764,-203.73841 231.28831,-190.18836 229.45998,-177.71875 C 222.3997,-165.39834 205.93726,-163.52328 193.05373,-164.75 C 194.11526,-173.29796 194.69425,-182.39807 193.51876,-190.98978 C 191.02311,-195.41909 199.33209,-197.29913 200.39748,-201.6875 C 203.70655,-208.92744 212.80427,-208.10966 218.04988,-213.3696 C 218.9201,-213.57294 220.00051,-215.94141 220.74123,-214.1875 z M 179.55373,-210.28125 C 180.69974,-204.97453 181.23339,-199.24919 184.58498,-194.75 C 179.40159,-187.81847 178.05976,-178.63643 176.67873,-170.28125 C 167.10271,-177.01707 169.81568,-190.62142 172.02963,-200.39411 C 173.03008,-204.26346 176.36728,-212.34166 179.19382,-211.77772 C 179.27177,-211.45363 179.5117,-210.45598 179.55373,-210.28125 z " />
-      <path
-         style="fill:url(#radialGradient1824);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="cccc"
-         id="path1823"
-         d="M 192.35803,-167.43887 C 192.50549,-184.13006 194.62485,-193.41727 188.91188,-194.64149 C 183.4148,-195.53491 180.34768,-176.21073 179.48415,-172.89901 C 176.29589,-156.88208 189.97283,-154.13044 192.35803,-167.43887 z " />
-      <path
-         style="fill:#1f4eb3;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
-         sodipodi:nodetypes="ccccc"
-         id="path1825"
-         d="M 185.2414,-200.53324 C 185.2414,-197.95291 187.25802,-195.85872 189.74278,-195.85872 C 192.22755,-195.85872 194.24417,-197.95291 194.24417,-200.53324 C 194.24417,-203.11357 193.61259,-209.36288 191.12783,-209.36288 C 188.64306,-209.36288 185.2414,-203.11357 185.2414,-200.53324 z " />
-      <path
-         style="fill:url(#radialGradient1828);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="ccccc"
-         id="path1827"
-         d="M 186.28018,-201.05263 C 186.28018,-198.4723 188.2968,-196.37811 190.78156,-196.37811 C 193.26633,-196.37811 195.28295,-198.4723 195.28295,-201.05263 C 195.28295,-203.63296 194.65137,-209.88227 192.16661,-209.88227 C 189.68184,-209.88227 186.28018,-203.63296 186.28018,-201.05263 z " />
-    </g>
-    <g
-       id="g5488"
-       transform="translate(601.5744,407.49165)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644">
-      <path
-         transform="matrix(6.392368,0.545409,-0.130014,2.864752,-184.6606,-38.15109)"
-         style="fill:url(#radialGradient5536);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:type="arc"
-         sodipodi:ry="12.562782"
-         sodipodi:rx="12.562782"
-         sodipodi:cy="37.865574"
-         sodipodi:cx="41.875938"
-         id="path5490"
-         d="M 54.438721 37.865574 A 12.562782 12.562782 0 1 1  29.313156,37.865574 A 12.562782 12.562782 0 1 1  54.438721 37.865574 z" />
-      <g
-         transform="matrix(1,0,0,1.036969,356.8306,-11.4294)"
-         style="fill:url(#linearGradient5538);fill-opacity:1"
-         id="g5492">
-        <path
-           style="fill:url(#linearGradient5540);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
-           id="path5494"
-           d="M -270.85787,33.814995 C -289.35564,33.925992 -307.93321,33.592782 -326.38104,33.981747 C -331.43469,35.696391 -331.02221,41.899652 -330.68524,46.15332 C -330.75782,60.227303 -330.53537,74.298225 -330.21167,88.36826 C -328.21297,91.039611 -323.21766,90.618387 -322.68469,94.539015 C -320.78054,96.259426 -317.05071,94.88215 -314.4389,95.333237 C -298.54999,95.360274 -282.66107,95.387302 -266.77215,95.414339 C -266.35587,90.465192 -260.12609,88.824447 -255.81783,89.540255 C -256.01688,89.058389 -261.69557,87.939375 -259.61591,84.491525 C -259.45681,68.72727 -259.19734,52.882199 -259.82064,37.168229 C -261.19394,32.980583 -267.34179,33.83368 -270.85787,33.814995 z M -236.65184,97.260473 C -234.79025,100.12642 -237.08724,103.09386 -239.92892,104.16357 C -242.6311,105.91539 -245.59105,107.62992 -248.52894,108.76804 C -253.1773,108.19079 -251.42424,101.88475 -255.01281,99.896645 C -260.33594,96.447012 -267.21045,98.43943 -273.23329,97.939231 C -291.8249,97.94887 -310.41651,97.958519 -329.00813,97.968158 C -335.45898,103.56578 -339.16595,111.40269 -341.55034,119.32178 C -337.25147,124.2061 -329.89606,122.27575 -324.10438,122.40002 C -298.64553,122.23171 -273.11679,122.61546 -247.69897,122.24542 C -243.40174,121.14669 -247.44685,114.84894 -243.58488,113.04441 C -242.73865,112.73374 -247.81245,114.4382 -247.26205,111.62955 C -245.49117,106.66028 -239.14113,105.99595 -235.92338,102.36811 C -234.39131,99.755669 -236.26958,96.922488 -238.33047,95.260495 C -237.77093,95.927151 -237.21138,96.593817 -236.65184,97.260473 z M -240.64255,111.75263 C -243.64086,113.13223 -237.02792,110.69536 -235.55512,111.97369 C -229.71113,112.74417 -224.16461,117.19625 -218.12358,115.22951 C -225.97639,116.31604 -232.799,109.03014 -240.64255,111.75263 z M -212.01083,112.33724 C -215.98173,113.85021 -208.21543,112.17765 -210.07883,115.87566 C -212.50961,119.93855 -206.99008,113.8662 -209.61436,112.54677 C -210.16198,111.94632 -211.27989,112.47663 -212.01083,112.33724 z M -213.97451,120.82946 C -220.13871,124.32615 -228.37873,119.08124 -233.85995,124.39439 C -238.36465,128.00055 -244.57099,130.35185 -247.0433,135.75122 C -247.65922,139.60202 -243.25109,141.90251 -240.44565,143.71808 C -235.60127,146.54512 -228.8227,145.75388 -225.20082,141.42836 C -220.62679,137.96117 -216.44182,134.08489 -212.48592,129.96782 C -212.82701,126.95048 -214.43694,123.63971 -213.97451,120.82946 z " />
-        <path
-           style="fill:url(#linearGradient5542);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
-           id="path5496"
-           d="M -269.68453,32.256957 C -288.76965,32.351184 -307.87514,32.249603 -326.94796,32.349264 C -332.63884,33.663474 -333.90446,40.291305 -333.21597,45.149113 C -333.11996,59.896901 -333.07471,74.659754 -332.61729,89.39481 C -331.88583,93.310348 -324.86009,92.098674 -325.11097,96.44089 C -328.07184,96.184706 -331.5534,96.317135 -333.07248,99.246492 C -338.92562,104.98392 -341.99312,112.66465 -344.27268,120.28679 C -340.22572,125.96631 -332.26467,125.31453 -326.02946,124.71751 C -300.16629,124.7277 -274.28316,124.82043 -248.43245,124.77905 C -244.42424,124.78686 -243.30672,120.35609 -243.96666,117.2099 C -242.88598,112.93536 -237.04086,113.94554 -233.80717,114.98513 C -228.01851,116.64297 -221.26418,120.43074 -215.57982,116.37592 C -211.36091,113.71809 -213.05678,118.4029 -215.77936,119.43344 C -220.82539,122.25797 -227.09125,118.98178 -232.39677,121.20855 C -236.53238,123.88957 -240.74707,126.85249 -244.76678,129.74666 C -248.34219,132.01467 -251.90947,137.38626 -248.13747,140.97315 C -243.79274,146.02948 -236.37425,149.4527 -229.68248,147.08651 C -225.09383,144.85973 -221.79206,140.75401 -217.61535,137.88661 C -215.10454,135.69469 -212.49235,133.26839 -210.83749,130.50207 C -210.86477,126.92195 -214.68529,121.91303 -210.252,119.57013 C -207.25619,117.95208 -205.81053,112.12098 -209.75314,110.87946 C -214.16982,109.44692 -216.95156,115.09837 -221.43751,113.68608 C -228.47365,112.76758 -235.5565,107.20489 -242.69931,110.72434 C -246.89551,113.06547 -243.47174,109.4356 -241.45524,108.56544 C -237.85613,106.84628 -232.73147,104.36798 -233.94637,99.617708 C -234.27189,95.083838 -239.22223,93.197522 -242.95318,91.723135 C -247.61613,89.074942 -253.27003,89.345117 -258.06082,86.933298 C -257.89248,70.385101 -257.58805,53.76423 -258.26571,37.261116 C -259.2092,32.393288 -265.59824,31.96057 -269.68453,32.256957 z M -258.66259,91.764016 C -251.5059,92.239344 -243.21163,93.474137 -238.58238,99.271629 C -238.96251,103.06003 -244.00295,103.80224 -246.52821,106.14082 C -248.92267,108.48087 -251.12372,105.80503 -251.02958,103.27159 C -252.70852,98.336432 -258.20582,95.710815 -263.31841,96.533197 C -267.00561,96.7255 -263.71935,91.937514 -261.395,92.380192 C -260.48382,92.178338 -259.57521,91.953759 -258.66259,91.764016 z " />
-        <path
-           style="fill:url(#linearGradient5544);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
-           sodipodi:nodetypes="ccccczccccccccccccccccccczccccc"
-           id="path5498"
-           d="M -324.0398,30.70877 C -336.3492,30.820231 -335.15663,39.652507 -334.79476,45.313268 C -334.5469,60.436643 -334.38614,75.599009 -334.01234,90.698281 C -333.20516,93.057424 -330.71249,93.985661 -328.75475,95.252079 C -334.4553,96.476239 -336.96996,102.43195 -340.11175,106.59303 C -342.33294,111.36531 -347.84019,115.92868 -345.92111,121.43642 C -344.00204,126.94416 -332.21757,127.68181 -324.95408,127.12866 C -299.06901,127.09789 -273.17022,127.14905 -247.29372,127.06713 C -243.29961,126.16956 -240.99668,122.03601 -241.4977,118.23645 C -238.30082,114.95371 -233.32521,118.03039 -229.53292,118.63002 C -225.71641,119.31313 -232.5646,119.27527 -233.19362,120.54849 C -238.23604,122.95799 -242.6166,126.65447 -246.90973,130.10509 C -250.44674,132.97354 -252.4229,138.10741 -249.57412,142.08235 C -246.21315,145.92284 -241.41489,148.84284 -236.30395,149.79628 C -230.65487,150.83779 -225.57101,147.82678 -221.6157,144.24077 C -216.87391,140.59839 -212.0873,136.78287 -208.84361,131.80554 C -207.76302,128.26399 -211.47449,123.86671 -208.08348,121.09796 C -204.93438,118.46115 -204.06893,113.02076 -207.41836,110.2673 C -212.81988,106.81278 -218.36682,114.55112 -223.89705,111.29128 C -227.94209,110.1659 -231.91311,108.52596 -236.17676,108.45194 C -231.52711,105.88023 -229.62903,98.782331 -234.08944,95.153402 C -239.61551,89.404431 -248.455,88.793917 -255.40182,85.744487 C -255.86992,78.940296 -255.53665,71.972758 -255.70928,65.098797 C -255.80747,55.730822 -255.73864,46.312632 -255.94025,36.975777 C -258.03631,31.236293 -265.34014,30.439522 -270.76286,30.729689 C -289.40725,30.770714 -311.88665,30.597309 -324.0398,30.70877 z M -255.46516,94.482857 C -250.34561,95.62106 -244.69322,96.21649 -240.83258,100.05203 C -242.37635,102.55028 -245.27573,103.64481 -247.80048,104.97505 C -249.71506,99.684643 -254.39847,94.970039 -260.51378,95.138259 C -260.66903,94.131274 -256.73261,94.551178 -255.46516,94.482857 z " />
-      </g>
-      <rect
-         y="78.658051"
-         x="33.326111"
-         width="57.567924"
-         style="fill:url(#linearGradient5546);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient5548);stroke-width:1.44734821pt"
-         id="rect5500"
-         height="8.3153667" />
-      <path
-         style="fill:url(#linearGradient5550);fill-rule:evenodd;stroke-width:0.90459263;stroke-opacity:0.07438019"
-         sodipodi:nodetypes="czzczczzzzzzzc"
-         id="path5502"
-         d="M 98.723806,78.927818 C 95.18666,77.759681 93.50122,82.555591 98.766686,81.004087 C 104.03217,79.452583 120.13123,85.906451 120.37383,89.795491 C 120.61643,93.905503 101.5003,98.581154 106.74108,104.42426 C 111.62816,110.70149 115.35468,100.13868 123.54696,104.21261 C 131.73923,108.17607 136.26048,109.72394 142.25488,104.94185 C 149.10027,101.9342 145.04599,107.07658 139.57918,113.60451 C 134.11237,120.13244 144.00251,115.08156 147.91225,105.31962 C 151.93248,95.557673 139.13128,107.33503 133.66268,105.40571 C 128.19408,103.47639 119.73678,97.849788 113.27625,102.55563 C 106.81572,107.26147 109.62894,99.493003 114.85637,97.90307 C 120.0838,96.092166 122.81363,93.045722 122.85597,90.161522 C 122.89831,87.498293 117.92629,84.811803 112.94229,82.402852 C 107.73732,79.993901 100.49788,78.588966 98.723806,78.927818 z " />
-      <path
-         style="fill:url(#linearGradient5552);fill-opacity:1;fill-rule:evenodd;stroke-width:1.44734821pt"
-         sodipodi:nodetypes="czzzzzzzz"
-         id="path5504"
-         d="M 15.102732,106.80712 C 13.80355,109.23224 17.148847,113.52338 19.900059,113.52338 L 107.85106,113.52338 C 110.18914,113.52338 113.70766,110.4906 112.64839,108.40622 L 102.7339,88.897093 C 101.97024,87.394398 100.26184,86.65834 98.576216,86.65834 L 28.215425,86.658339 C 26.825434,86.658339 25.353768,87.671846 24.697385,88.897093 L 15.102732,106.80712 z " />
-      <rect
-         y="22.413721"
-         x="26.015469"
-         width="72.279724"
-         style="fill:url(#linearGradient5554);fill-opacity:1;fill-rule:evenodd;stroke-width:1.62826681"
-         ry="5.4369707"
-         rx="5.4369707"
-         id="rect5506"
-         height="60.126495" />
-      <rect
-         y="31.695871"
-         x="33.386066"
-         width="58.178177"
-         style="fill:url(#radialGradient5556);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient5558);stroke-width:1.4649456pt"
-         id="rect5508"
-         height="38.044163" />
-      <path
-         style="fill:url(#linearGradient5560);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="czzccccc"
-         id="path5510"
-         d="M 27.690431,52.841444 L 27.370609,74.749236 C 27.319624,78.241665 29.310209,80.477938 32.807578,80.506029 L 72.625393,80.825852 L 76.463254,71.87084 L 32.008024,71.55102 L 31.688202,52.681533 L 27.690431,52.841444 z " />
-      <g
-         transform="matrix(-1,0,0,1,125.4301,0)"
-         id="g5512">
-        <path
-           style="fill:url(#linearGradient5562);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-           sodipodi:nodetypes="czzccc"
-           id="path5514"
-           d="M 42.062098,33.460351 L 77.341205,33.008055 C 82.787126,32.938235 89.553204,38.416797 89.553204,43.863165 L 89.553204,60.14583 L 41.609801,59.693534 L 42.062098,33.460351 z " />
-        <path
-           style="fill:url(#linearGradient5564);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-           sodipodi:nodetypes="czzccc"
-           id="path5516"
-           d="M 78.337784,67.629235 L 46.723745,67.724544 C 41.843589,67.739257 35.829319,62.771024 35.877168,57.891081 L 36.020221,43.301821 L 78.973514,44.128288 L 78.337784,67.629235 z " />
-      </g>
-      <path
-         style="fill:url(#linearGradient5566);fill-opacity:1;fill-rule:evenodd;stroke-width:0.72367412;stroke-opacity:0.34710741"
-         sodipodi:nodetypes="cczzzzzzc"
-         id="path5518"
-         d="M 137.39107,112.02341 C 137.39107,112.02341 129.0757,110.26438 123.63872,113.62251 C 118.20176,116.98064 109.96635,123.21719 108.76702,124.81628 C 107.40777,126.57531 107.42036,130.22796 109.24674,131.53253 L 114.84364,135.53031 C 118.31797,138.01198 124.86218,139.25396 128.11624,136.48978 L 142.98795,123.85681 C 144.79792,122.3193 145.72732,118.27921 144.10733,116.82073 C 142.95609,115.04975 140.4892,112.91939 137.39107,112.02341 z " />
-      <path
-         style="fill:url(#linearGradient5568);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="czzzzzc"
-         id="path5520"
-         d="M 142.3483,121.13833 L 125.91043,133.59673 C 122.97154,135.82414 118.65484,134.11775 116.28283,133.77129 C 113.9108,133.42481 111.88528,131.87901 112.12516,132.33209 C 112.36503,132.78517 115.08349,135.71687 117.72203,136.48978 C 120.36055,137.26267 124.9543,138.89307 127.50953,136.15531 C 130.06477,133.41755 145.2267,123.53699 142.3483,121.13833 z " />
-      <path
-         style="fill:url(#linearGradient5570);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="cczc"
-         id="path5522"
-         d="M 132.11225,127.51984 C 135.31047,122.88242 120.11893,113.12786 109.08509,127.0401 C 110.20446,130.71805 116.80662,132.5992 121.82304,132.33547 C 126.68363,132.07993 129.50037,129.97181 132.11225,127.51984 z " />
-      <path
-         style="fill:url(#linearGradient5572);fill-opacity:1;fill-rule:evenodd;stroke-width:1.08551121"
-         sodipodi:nodetypes="cccccccc"
-         id="path5524"
-         d="M 138.63464,112.68306 C 135.9958,113.22749 132.31739,114.43079 129.87534,116.38362 C 128.77009,115.68011 125.32759,114.5677 123.66767,113.84494 L 123.24572,114.10517 C 129.67287,117.23476 136.43512,117.91249 135.88192,122.87668 C 136.33675,122.98575 137.05589,123.09702 136.73191,122.38863 C 136.41775,118.90392 132.50587,117.23351 131.02697,116.81532 C 133.17224,114.26602 136.255,113.70892 138.63464,112.68306 z " />
-      <path
-         style="fill:url(#linearGradient5574);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="czzzzzzzz"
-         id="path5526"
-         d="M 18.891612,106.48414 C 17.978451,108.31614 19.173914,111.55774 22.263529,111.55774 L 105.0195,111.55774 C 106.66288,111.55774 109.13595,109.26672 108.39142,107.69215 L 101.42279,92.954575 C 100.88602,91.819403 99.685232,91.263378 98.500462,91.263378 L 28.108183,91.263369 C 27.131195,91.263369 26.0968,92.028994 25.635445,92.954575 L 18.891612,106.48414 z " />
-      <text
-         y="-14.660837"
-         xml:space="preserve"
-         x="6.147172"
-         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
-         id="text5528"><tspan
-           id="tspan5530">Computer</tspan></text>
-      <text
-         y="-34.951134"
-         xml:space="preserve"
-         x="84.564949"
-         transform="scale(0.246729,0.246729)"
-         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
-         id="text5532"><tspan
-           id="tspan5534">Created by Andrew Fitzsimon</tspan></text>
-    </g>
-    <g
-       id="g6024"
-       transform="matrix(-1,0,0,1,900.16045,422.61731)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644">
-      <path
-         transform="translate(2.509562,-4.432856e-2)"
-         style="fill:#ffffff;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="cccc"
-         id="path6027"
-         d="M 60.545133,72.847539 C 65.294534,78.031101 68.316881,87.318315 75.00922,87.318316 C 81.485677,85.518467 82.349205,70.11177 83.212732,66.800051 C 75.872748,71.839624 68.316882,74.71938 60.545133,72.847539 z " />
-      <path
-         transform="translate(2.509562,-4.432856e-2)"
-         style="fill:#d20000;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="ccssssc"
-         id="path6029"
-         d="M 31.546762,99.654209 C 31.156121,124.85047 95.78552,127.73183 95.62922,99.654209 C 97.174007,77.325462 86.068776,64.629762 83.309105,66.788232 C 81.907864,67.884209 81.387229,92.223995 71.919297,86.625353 C 67.316417,83.903554 62.167959,73.44849 59.915352,73.101625 C 56.516277,72.578221 50.007529,69.826123 44.029815,64.675414 C 42.461522,63.324094 32.076211,77.214403 31.546762,99.654209 z " />
-      <path
-         style="fill:url(#radialGradient2797);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         id="path2796"
-         d="M 43.53125,77.3125 C 40.353026,86.016409 37.202011,96.366079 40.377303,105.23542 C 48.984655,117.18204 66.049398,117.25223 79.222417,115.04972 C 88.094278,113.47345 96.636121,105.87972 94.744454,96.188658 C 94.751182,88.561019 93.319573,80.643142 89.09375,74.1875 C 87.954705,81.120157 85.706152,92.347929 76.686643,91.786583 C 66.841974,89.84774 65.058803,76.33878 54.747596,75.105769 C 49.945701,71.530053 45.566465,69.110698 43.783935,76.852875 L 43.53125,77.3125 z " />
-      <path
-         transform="matrix(0.440859,0,0,0.441062,0.997459,16.38124)"
-         style="fill:#efd7c7;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:type="arc"
-         sodipodi:ry="57.825485"
-         sodipodi:rx="60.94183"
-         sodipodi:cy="70.290855"
-         sodipodi:cx="150.27701"
-         id="path6032"
-         d="M 211.21884 70.290855 A 60.94183 57.825485 0 1 1  89.335178,70.290855 A 60.94183 57.825485 0 1 1  211.21884 70.290855 z" />
-      <path
-         transform="translate(2.509562,-4.432856e-2)"
-         style="fill:#000000;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="cccccc"
-         id="path3720"
-         d="M 56.980881,5.8426527 C 39.420698,8.0166254 30.552872,16.206245 24.211446,49.532095 C 14.512196,98.076517 21.871677,115.5525 32.990311,115.56714 C 17.54932,102.40769 63.877625,86.740105 56.295103,44.070713 C 68.4508,48.712358 94.51097,54.349644 95.164349,41.718703 C 97.176702,29.219492 88.64173,4.4775042 56.980881,5.8426527 z " />
-      <path
-         style="fill:url(#linearGradient2789);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         id="path2164"
-         d="M 60.687242,45.028999 C 62.530882,55.403773 61.180052,64.151015 58.312242,71.685249 C 61.630122,73.07804 65.296862,73.904 69.155992,73.903999 C 83.975322,73.903999 95.981712,62.468019 95.999742,48.403999 C 88.357632,52.885439 70.244092,48.678277 60.687242,45.028999 z " />
-      <path
-         style="fill:url(#radialGradient2791);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         id="path2790"
-         d="M 52.174948,8.1325312 C 35.846775,12.141346 31.110158,30.475875 28.060647,44.840387 C 24.465246,64.767005 19.485139,85.90438 25.518698,105.82003 C 29.863591,114.87216 28.026452,106.52571 31.049538,102.11795 C 41.311249,87.323083 56.256862,73.307418 55.936774,53.886064 C 56.647391,49.398848 52.34734,38.640985 60.701717,42.254379 C 70.683443,45.202557 82.078811,49.011247 92.143698,44.632531 C 96.945103,37.45042 93.288237,27.137344 88.876323,20.399742 C 81.135092,8.5919962 65.300885,5.0194752 52.174948,8.1325312 z " />
-    </g>
-    <path
-       style="fill:none;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:4.63842154;stroke-linecap:butt;stroke-linejoin:round;stroke-dasharray:none;stroke-opacity:1"
-       sodipodi:nodetypes="cccccccccccc"
-       id="path699"
-       d="M 319.16674,325.66524 L 432.27399,313.12251 L 422.57906,332.08242 L 484.9028,325.95688 C 484.9028,325.95688 494.59773,306.41369 495.05931,306.41369 C 495.52148,306.41369 517.68079,331.79078 517.68079,331.79078 C 517.68079,331.79078 465.51355,358.33479 465.05197,358.33479 C 465.51355,358.91808 474.74689,339.66616 474.74689,339.37453 L 402.72705,345.79207 L 412.42255,326.24852 L 309.01023,338.4996 L 319.16674,325.66524 z "
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644" />
-    <text
-       xml:space="preserve"
-       style="font-size:48px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="73.4375"
-       y="510.12573"
-       id="text7612"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644"><tspan
-         sodipodi:role="line"
-         id="tspan7614"
-         x="73.4375"
-         y="510.12573">Server</tspan></text>
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="359.5625"
-       y="261.21948"
-       id="text7877"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644"><tspan
-         sodipodi:role="line"
-         id="tspan7879"
-         x="359.5625"
-         y="261.21948">bzr branch</tspan></text>
-    <path
-       sodipodi:type="arc"
-       style="fill:#000000"
-       id="path9548"
-       sodipodi:cx="292.14285"
-       sodipodi:cy="181.95163"
-       sodipodi:rx="15"
-       sodipodi:ry="15"
-       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
-       transform="translate(42.857147,67.142853)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644" />
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="325.71429"
-       y="259.52307"
-       id="text9550"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644"><tspan
-         sodipodi:role="line"
-         id="tspan9552"
-         x="325.71429"
-         y="259.52307">1</tspan></text>
-    <path
-       sodipodi:type="arc"
-       style="fill:#000000"
-       id="path9554"
-       sodipodi:cx="292.14285"
-       sodipodi:cy="181.95163"
-       sodipodi:rx="15"
-       sodipodi:ry="15"
-       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
-       transform="translate(466.18527,201.5491)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644" />
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="751.04242"
-       y="395.37573"
-       id="text9556"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644"><tspan
-         sodipodi:role="line"
-         id="tspan9558"
-         x="751.04242"
-         y="395.37573">2</tspan></text>
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="778.89062"
-       y="392.32886"
-       id="text9566"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644"><tspan
-         sodipodi:role="line"
-         x="778.89062"
-         y="392.32886"
-         id="tspan2963">make changes</tspan></text>
-    <path
-       style="fill:none;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:2.52894235;stroke-linecap:butt;stroke-linejoin:round;stroke-dasharray:none;stroke-opacity:1"
-       sodipodi:nodetypes="cccccccccccc"
-       id="path9650"
-       d="M 578.13978,492.35651 L 518.11306,536.64644 L 515.93459,528.2361 L 482.53728,552.4378 C 482.53728,552.4378 484.9546,560.99862 484.68867,561.16617 C 484.42242,561.33391 461.26447,562.83001 461.26447,562.83001 C 461.26447,562.83001 480.44933,537.04707 480.71524,536.87954 C 480.21048,536.89659 482.77445,545.21473 482.89387,545.28997 L 521.75768,517.49359 L 524.17482,526.05472 L 578.73553,485.35896 L 578.13978,492.35651 z "
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644" />
-    <path
-       sodipodi:type="arc"
-       style="fill:#000000"
-       id="path9652"
-       sodipodi:cx="292.14285"
-       sodipodi:cy="181.95163"
-       sodipodi:rx="15"
-       sodipodi:ry="15"
-       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
-       transform="translate(449.56027,418.37723)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644" />
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="732.41742"
-       y="611.97729"
-       id="text9654"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644"><tspan
-         sodipodi:role="line"
-         id="tspan9656"
-         x="732.41742"
-         y="611.97729">3</tspan></text>
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="768.26562"
-       y="608.23511"
-       id="text9658"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644"><tspan
-         sodipodi:role="line"
-         id="tspan9660"
-         x="768.26562"
-         y="608.23511">request merge</tspan></text>
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="75.5625"
-       y="228.09448"
-       id="text2965"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644"><tspan
-         sodipodi:role="line"
-         id="tspan2967"
-         x="75.5625"
-         y="228.09448">main branch</tspan></text>
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="556.98438"
-       y="165.64139"
-       id="text2969"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644"><tspan
-         sodipodi:role="line"
-         id="tspan2971"
-         x="556.98438"
-         y="165.64139">local branches</tspan></text>
-    <path
-       sodipodi:type="arc"
-       style="fill:none;fill-opacity:1;stroke:#0000ff;stroke-width:5.00006151;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
-       id="path4930"
-       sodipodi:cx="342"
-       sodipodi:cy="171.0945"
-       sodipodi:rx="66"
-       sodipodi:ry="35"
-       d="M 408 171.0945 A 66 35 0 1 1  276,171.0945 A 66 35 0 1 1  408 171.0945 z"
-       transform="matrix(1.9161749,0,0,1.0419298,-477.33182,37.826027)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644" />
-    <path
-       sodipodi:type="arc"
-       style="fill:none;fill-opacity:1;stroke:#0000ff;stroke-width:5.00006151;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
-       id="path7839"
-       sodipodi:cx="342"
-       sodipodi:cy="171.0945"
-       sodipodi:rx="66"
-       sodipodi:ry="35"
-       d="M 408 171.0945 A 66 35 0 1 1  276,171.0945 A 66 35 0 1 1  408 171.0945 z"
-       transform="matrix(2.0657387,0,0,1.0382501,-36.482679,-19.544354)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644" />
-    <path
-       style="fill:none;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:2.27460909;stroke-linecap:butt;stroke-linejoin:round;stroke-dasharray:none;stroke-opacity:1"
-       sodipodi:nodetypes="cccccccccccc"
-       id="path7875"
-       d="M 313.49127,554.98551 L 266.8349,508.88833 L 275.69462,507.21539 L 250.19978,481.56811 C 250.19978,481.56811 241.18156,483.42447 241.00507,483.22026 C 240.82835,483.0158 239.25232,465.23179 239.25232,465.23179 C 239.25232,465.23179 266.41286,479.96469 266.58935,480.16889 C 266.57138,479.78127 257.8088,481.75026 257.72954,481.84196 L 287.01109,511.6872 L 277.99254,513.54344 L 320.8627,555.44302 L 313.49127,554.98551 z "
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644" />
-    <g
-       id="g7884"
-       transform="translate(322.22009,479.97324)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644">
-      <path
-         transform="matrix(6.392368,0.545409,-0.130014,2.864752,-184.6606,-38.15109)"
-         style="fill:url(#radialGradient7932);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:type="arc"
-         sodipodi:ry="12.562782"
-         sodipodi:rx="12.562782"
-         sodipodi:cy="37.865574"
-         sodipodi:cx="41.875938"
-         id="path7886"
-         d="M 54.438721 37.865574 A 12.562782 12.562782 0 1 1  29.313156,37.865574 A 12.562782 12.562782 0 1 1  54.438721 37.865574 z" />
-      <g
-         transform="matrix(1,0,0,1.036969,356.8306,-11.4294)"
-         style="fill:url(#linearGradient7934);fill-opacity:1"
-         id="g7888">
-        <path
-           style="fill:url(#linearGradient7936);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
-           id="path7890"
-           d="M -270.85787,33.814995 C -289.35564,33.925992 -307.93321,33.592782 -326.38104,33.981747 C -331.43469,35.696391 -331.02221,41.899652 -330.68524,46.15332 C -330.75782,60.227303 -330.53537,74.298225 -330.21167,88.36826 C -328.21297,91.039611 -323.21766,90.618387 -322.68469,94.539015 C -320.78054,96.259426 -317.05071,94.88215 -314.4389,95.333237 C -298.54999,95.360274 -282.66107,95.387302 -266.77215,95.414339 C -266.35587,90.465192 -260.12609,88.824447 -255.81783,89.540255 C -256.01688,89.058389 -261.69557,87.939375 -259.61591,84.491525 C -259.45681,68.72727 -259.19734,52.882199 -259.82064,37.168229 C -261.19394,32.980583 -267.34179,33.83368 -270.85787,33.814995 z M -236.65184,97.260473 C -234.79025,100.12642 -237.08724,103.09386 -239.92892,104.16357 C -242.6311,105.91539 -245.59105,107.62992 -248.52894,108.76804 C -253.1773,108.19079 -251.42424,101.88475 -255.01281,99.896645 C -260.33594,96.447012 -267.21045,98.43943 -273.23329,97.939231 C -291.8249,97.94887 -310.41651,97.958519 -329.00813,97.968158 C -335.45898,103.56578 -339.16595,111.40269 -341.55034,119.32178 C -337.25147,124.2061 -329.89606,122.27575 -324.10438,122.40002 C -298.64553,122.23171 -273.11679,122.61546 -247.69897,122.24542 C -243.40174,121.14669 -247.44685,114.84894 -243.58488,113.04441 C -242.73865,112.73374 -247.81245,114.4382 -247.26205,111.62955 C -245.49117,106.66028 -239.14113,105.99595 -235.92338,102.36811 C -234.39131,99.755669 -236.26958,96.922488 -238.33047,95.260495 C -237.77093,95.927151 -237.21138,96.593817 -236.65184,97.260473 z M -240.64255,111.75263 C -243.64086,113.13223 -237.02792,110.69536 -235.55512,111.97369 C -229.71113,112.74417 -224.16461,117.19625 -218.12358,115.22951 C -225.97639,116.31604 -232.799,109.03014 -240.64255,111.75263 z M -212.01083,112.33724 C -215.98173,113.85021 -208.21543,112.17765 -210.07883,115.87566 C -212.50961,119.93855 -206.99008,113.8662 -209.61436,112.54677 C -210.16198,111.94632 -211.27989,112.47663 -212.01083,112.33724 z M -213.97451,120.82946 C -220.13871,124.32615 -228.37873,119.08124 -233.85995,124.39439 C -238.36465,128.00055 -244.57099,130.35185 -247.0433,135.75122 C -247.65922,139.60202 -243.25109,141.90251 -240.44565,143.71808 C -235.60127,146.54512 -228.8227,145.75388 -225.20082,141.42836 C -220.62679,137.96117 -216.44182,134.08489 -212.48592,129.96782 C -212.82701,126.95048 -214.43694,123.63971 -213.97451,120.82946 z " />
-        <path
-           style="fill:url(#linearGradient7938);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
-           id="path7892"
-           d="M -269.68453,32.256957 C -288.76965,32.351184 -307.87514,32.249603 -326.94796,32.349264 C -332.63884,33.663474 -333.90446,40.291305 -333.21597,45.149113 C -333.11996,59.896901 -333.07471,74.659754 -332.61729,89.39481 C -331.88583,93.310348 -324.86009,92.098674 -325.11097,96.44089 C -328.07184,96.184706 -331.5534,96.317135 -333.07248,99.246492 C -338.92562,104.98392 -341.99312,112.66465 -344.27268,120.28679 C -340.22572,125.96631 -332.26467,125.31453 -326.02946,124.71751 C -300.16629,124.7277 -274.28316,124.82043 -248.43245,124.77905 C -244.42424,124.78686 -243.30672,120.35609 -243.96666,117.2099 C -242.88598,112.93536 -237.04086,113.94554 -233.80717,114.98513 C -228.01851,116.64297 -221.26418,120.43074 -215.57982,116.37592 C -211.36091,113.71809 -213.05678,118.4029 -215.77936,119.43344 C -220.82539,122.25797 -227.09125,118.98178 -232.39677,121.20855 C -236.53238,123.88957 -240.74707,126.85249 -244.76678,129.74666 C -248.34219,132.01467 -251.90947,137.38626 -248.13747,140.97315 C -243.79274,146.02948 -236.37425,149.4527 -229.68248,147.08651 C -225.09383,144.85973 -221.79206,140.75401 -217.61535,137.88661 C -215.10454,135.69469 -212.49235,133.26839 -210.83749,130.50207 C -210.86477,126.92195 -214.68529,121.91303 -210.252,119.57013 C -207.25619,117.95208 -205.81053,112.12098 -209.75314,110.87946 C -214.16982,109.44692 -216.95156,115.09837 -221.43751,113.68608 C -228.47365,112.76758 -235.5565,107.20489 -242.69931,110.72434 C -246.89551,113.06547 -243.47174,109.4356 -241.45524,108.56544 C -237.85613,106.84628 -232.73147,104.36798 -233.94637,99.617708 C -234.27189,95.083838 -239.22223,93.197522 -242.95318,91.723135 C -247.61613,89.074942 -253.27003,89.345117 -258.06082,86.933298 C -257.89248,70.385101 -257.58805,53.76423 -258.26571,37.261116 C -259.2092,32.393288 -265.59824,31.96057 -269.68453,32.256957 z M -258.66259,91.764016 C -251.5059,92.239344 -243.21163,93.474137 -238.58238,99.271629 C -238.96251,103.06003 -244.00295,103.80224 -246.52821,106.14082 C -248.92267,108.48087 -251.12372,105.80503 -251.02958,103.27159 C -252.70852,98.336432 -258.20582,95.710815 -263.31841,96.533197 C -267.00561,96.7255 -263.71935,91.937514 -261.395,92.380192 C -260.48382,92.178338 -259.57521,91.953759 -258.66259,91.764016 z " />
-        <path
-           style="fill:url(#linearGradient7940);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
-           sodipodi:nodetypes="ccccczccccccccccccccccccczccccc"
-           id="path7894"
-           d="M -324.0398,30.70877 C -336.3492,30.820231 -335.15663,39.652507 -334.79476,45.313268 C -334.5469,60.436643 -334.38614,75.599009 -334.01234,90.698281 C -333.20516,93.057424 -330.71249,93.985661 -328.75475,95.252079 C -334.4553,96.476239 -336.96996,102.43195 -340.11175,106.59303 C -342.33294,111.36531 -347.84019,115.92868 -345.92111,121.43642 C -344.00204,126.94416 -332.21757,127.68181 -324.95408,127.12866 C -299.06901,127.09789 -273.17022,127.14905 -247.29372,127.06713 C -243.29961,126.16956 -240.99668,122.03601 -241.4977,118.23645 C -238.30082,114.95371 -233.32521,118.03039 -229.53292,118.63002 C -225.71641,119.31313 -232.5646,119.27527 -233.19362,120.54849 C -238.23604,122.95799 -242.6166,126.65447 -246.90973,130.10509 C -250.44674,132.97354 -252.4229,138.10741 -249.57412,142.08235 C -246.21315,145.92284 -241.41489,148.84284 -236.30395,149.79628 C -230.65487,150.83779 -225.57101,147.82678 -221.6157,144.24077 C -216.87391,140.59839 -212.0873,136.78287 -208.84361,131.80554 C -207.76302,128.26399 -211.47449,123.86671 -208.08348,121.09796 C -204.93438,118.46115 -204.06893,113.02076 -207.41836,110.2673 C -212.81988,106.81278 -218.36682,114.55112 -223.89705,111.29128 C -227.94209,110.1659 -231.91311,108.52596 -236.17676,108.45194 C -231.52711,105.88023 -229.62903,98.782331 -234.08944,95.153402 C -239.61551,89.404431 -248.455,88.793917 -255.40182,85.744487 C -255.86992,78.940296 -255.53665,71.972758 -255.70928,65.098797 C -255.80747,55.730822 -255.73864,46.312632 -255.94025,36.975777 C -258.03631,31.236293 -265.34014,30.439522 -270.76286,30.729689 C -289.40725,30.770714 -311.88665,30.597309 -324.0398,30.70877 z M -255.46516,94.482857 C -250.34561,95.62106 -244.69322,96.21649 -240.83258,100.05203 C -242.37635,102.55028 -245.27573,103.64481 -247.80048,104.97505 C -249.71506,99.684643 -254.39847,94.970039 -260.51378,95.138259 C -260.66903,94.131274 -256.73261,94.551178 -255.46516,94.482857 z " />
-      </g>
-      <rect
-         y="78.658051"
-         x="33.326111"
-         width="57.567924"
-         style="fill:url(#linearGradient7942);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient7944);stroke-width:1.44734821pt"
-         id="rect7896"
-         height="8.3153667" />
-      <path
-         style="fill:url(#linearGradient7946);fill-rule:evenodd;stroke-width:0.90459263;stroke-opacity:0.07438019"
-         sodipodi:nodetypes="czzczczzzzzzzc"
-         id="path7898"
-         d="M 98.723806,78.927818 C 95.18666,77.759681 93.50122,82.555591 98.766686,81.004087 C 104.03217,79.452583 120.13123,85.906451 120.37383,89.795491 C 120.61643,93.905503 101.5003,98.581154 106.74108,104.42426 C 111.62816,110.70149 115.35468,100.13868 123.54696,104.21261 C 131.73923,108.17607 136.26048,109.72394 142.25488,104.94185 C 149.10027,101.9342 145.04599,107.07658 139.57918,113.60451 C 134.11237,120.13244 144.00251,115.08156 147.91225,105.31962 C 151.93248,95.557673 139.13128,107.33503 133.66268,105.40571 C 128.19408,103.47639 119.73678,97.849788 113.27625,102.55563 C 106.81572,107.26147 109.62894,99.493003 114.85637,97.90307 C 120.0838,96.092166 122.81363,93.045722 122.85597,90.161522 C 122.89831,87.498293 117.92629,84.811803 112.94229,82.402852 C 107.73732,79.993901 100.49788,78.588966 98.723806,78.927818 z " />
-      <path
-         style="fill:url(#linearGradient7948);fill-opacity:1;fill-rule:evenodd;stroke-width:1.44734821pt"
-         sodipodi:nodetypes="czzzzzzzz"
-         id="path7900"
-         d="M 15.102732,106.80712 C 13.80355,109.23224 17.148847,113.52338 19.900059,113.52338 L 107.85106,113.52338 C 110.18914,113.52338 113.70766,110.4906 112.64839,108.40622 L 102.7339,88.897093 C 101.97024,87.394398 100.26184,86.65834 98.576216,86.65834 L 28.215425,86.658339 C 26.825434,86.658339 25.353768,87.671846 24.697385,88.897093 L 15.102732,106.80712 z " />
-      <rect
-         y="22.413721"
-         x="26.015469"
-         width="72.279724"
-         style="fill:url(#linearGradient7950);fill-opacity:1;fill-rule:evenodd;stroke-width:1.62826681"
-         ry="5.4369707"
-         rx="5.4369707"
-         id="rect7902"
-         height="60.126495" />
-      <rect
-         y="31.695871"
-         x="33.386066"
-         width="58.178177"
-         style="fill:url(#radialGradient7952);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient7954);stroke-width:1.4649456pt"
-         id="rect7904"
-         height="38.044163" />
-      <path
-         style="fill:url(#linearGradient7956);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="czzccccc"
-         id="path7906"
-         d="M 27.690431,52.841444 L 27.370609,74.749236 C 27.319624,78.241665 29.310209,80.477938 32.807578,80.506029 L 72.625393,80.825852 L 76.463254,71.87084 L 32.008024,71.55102 L 31.688202,52.681533 L 27.690431,52.841444 z " />
-      <g
-         transform="matrix(-1,0,0,1,125.4301,0)"
-         id="g7908">
-        <path
-           style="fill:url(#linearGradient7958);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-           sodipodi:nodetypes="czzccc"
-           id="path7910"
-           d="M 42.062098,33.460351 L 77.341205,33.008055 C 82.787126,32.938235 89.553204,38.416797 89.553204,43.863165 L 89.553204,60.14583 L 41.609801,59.693534 L 42.062098,33.460351 z " />
-        <path
-           style="fill:url(#linearGradient7960);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-           sodipodi:nodetypes="czzccc"
-           id="path7912"
-           d="M 78.337784,67.629235 L 46.723745,67.724544 C 41.843589,67.739257 35.829319,62.771024 35.877168,57.891081 L 36.020221,43.301821 L 78.973514,44.128288 L 78.337784,67.629235 z " />
-      </g>
-      <path
-         style="fill:url(#linearGradient7962);fill-opacity:1;fill-rule:evenodd;stroke-width:0.72367412;stroke-opacity:0.34710741"
-         sodipodi:nodetypes="cczzzzzzc"
-         id="path7914"
-         d="M 137.39107,112.02341 C 137.39107,112.02341 129.0757,110.26438 123.63872,113.62251 C 118.20176,116.98064 109.96635,123.21719 108.76702,124.81628 C 107.40777,126.57531 107.42036,130.22796 109.24674,131.53253 L 114.84364,135.53031 C 118.31797,138.01198 124.86218,139.25396 128.11624,136.48978 L 142.98795,123.85681 C 144.79792,122.3193 145.72732,118.27921 144.10733,116.82073 C 142.95609,115.04975 140.4892,112.91939 137.39107,112.02341 z " />
-      <path
-         style="fill:url(#linearGradient7964);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="czzzzzc"
-         id="path7916"
-         d="M 142.3483,121.13833 L 125.91043,133.59673 C 122.97154,135.82414 118.65484,134.11775 116.28283,133.77129 C 113.9108,133.42481 111.88528,131.87901 112.12516,132.33209 C 112.36503,132.78517 115.08349,135.71687 117.72203,136.48978 C 120.36055,137.26267 124.9543,138.89307 127.50953,136.15531 C 130.06477,133.41755 145.2267,123.53699 142.3483,121.13833 z " />
-      <path
-         style="fill:url(#linearGradient7966);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="cczc"
-         id="path7918"
-         d="M 132.11225,127.51984 C 135.31047,122.88242 120.11893,113.12786 109.08509,127.0401 C 110.20446,130.71805 116.80662,132.5992 121.82304,132.33547 C 126.68363,132.07993 129.50037,129.97181 132.11225,127.51984 z " />
-      <path
-         style="fill:url(#linearGradient7968);fill-opacity:1;fill-rule:evenodd;stroke-width:1.08551121"
-         sodipodi:nodetypes="cccccccc"
-         id="path7920"
-         d="M 138.63464,112.68306 C 135.9958,113.22749 132.31739,114.43079 129.87534,116.38362 C 128.77009,115.68011 125.32759,114.5677 123.66767,113.84494 L 123.24572,114.10517 C 129.67287,117.23476 136.43512,117.91249 135.88192,122.87668 C 136.33675,122.98575 137.05589,123.09702 136.73191,122.38863 C 136.41775,118.90392 132.50587,117.23351 131.02697,116.81532 C 133.17224,114.26602 136.255,113.70892 138.63464,112.68306 z " />
-      <path
-         style="fill:url(#linearGradient7990);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="czzzzzzzz"
-         id="path7922"
-         d="M 18.891612,106.48414 C 17.978451,108.31614 19.173914,111.55774 22.263529,111.55774 L 105.0195,111.55774 C 106.66288,111.55774 109.13595,109.26672 108.39142,107.69215 L 101.42279,92.954575 C 100.88602,91.819403 99.685232,91.263378 98.500462,91.263378 L 28.108183,91.263369 C 27.131195,91.263369 26.0968,92.028994 25.635445,92.954575 L 18.891612,106.48414 z " />
-      <text
-         y="-14.660837"
-         xml:space="preserve"
-         x="6.147172"
-         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
-         id="text7924"><tspan
-           id="tspan7926">Computer</tspan></text>
-      <text
-         y="-34.951134"
-         xml:space="preserve"
-         x="84.564949"
-         transform="scale(0.246729,0.246729)"
-         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
-         id="text7928"><tspan
-           id="tspan7930">Created by Andrew Fitzsimon</tspan></text>
-    </g>
-    <g
-       id="g11201"
-       transform="translate(224.98935,560.87966)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644">
-      <path
-         style="fill:#ffffff;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="cccc"
-         id="path11204"
-         d="M 61.208646,74.540863 C 65.958047,79.724425 68.980394,89.011639 75.672733,89.01164 C 82.14919,87.211791 83.012718,71.805094 83.876245,68.493375 C 76.536261,73.532948 68.980395,76.412704 61.208646,74.540863 z " />
-      <path
-         transform="matrix(0.440859,0,0,0.441062,-0.8485902,18.11889)"
-         style="fill:#ebd5bb;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:type="arc"
-         sodipodi:ry="57.825485"
-         sodipodi:rx="60.94183"
-         sodipodi:cy="70.290855"
-         sodipodi:cx="150.27701"
-         id="path11206"
-         d="M 211.21884 70.290855 A 60.94183 57.825485 0 1 1  89.335178,70.290855 A 60.94183 57.825485 0 1 1  211.21884 70.290855 z" />
-      <path
-         style="fill:#354b63;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="ccssssc"
-         id="path11208"
-         d="M 32.210275,101.34753 C 31.819634,126.54379 96.449036,129.42515 96.292736,101.34753 C 97.837516,79.018786 86.732289,66.323086 83.972618,68.481556 C 82.571377,69.577533 82.050742,93.917319 72.58281,88.318677 C 67.97993,85.596878 62.831472,75.141814 60.578865,74.794949 C 57.17979,74.271545 50.671042,71.519447 44.693328,66.368738 C 43.125035,65.017418 32.739724,78.907727 32.210275,101.34753 z " />
-      <path
-         style="fill:#7e5429;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="ccscc"
-         id="path14564"
-         d="M 67.304802,16.686453 C 54.985668,-4.2976037 31.742548,13.847204 34.832083,38.13111 C 28.606909,39.936495 13.38594,55.735942 54.610465,51.217079 C 72.973357,49.204214 127.11969,28.718598 84.679736,22.863615 C 78.797006,1.2972292 67.040662,6.1031815 67.304802,16.686453 z " />
-      <path
-         style="fill:url(#linearGradient1883);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         id="path1879"
-         d="M 89.582928,41.074792 C 78.886738,46.748497 62.561318,51.815798 53.926678,52.762292 C 47.018518,53.519536 42.160188,53.578455 38.114178,53.356042 C 39.550848,66.152312 50.849068,76.168541 64.707928,76.168542 C 79.538378,76.168542 91.582928,64.747093 91.582928,50.668542 C 91.582928,47.276803 90.850878,44.035951 89.582928,41.074792 z " />
-      <path
-         style="fill:url(#radialGradient1885);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         id="path1884"
-         d="M 43.031249,70.1875 C 35.995246,80.448202 32.902215,93.581638 34.156249,105.875 C 40.334493,118.62839 56.831543,120.43683 69.499999,119.875 C 80.494576,119.32475 94.949065,113.14258 93.695531,100.00002 C 93.939855,90.023763 92.261916,78.780004 84.874999,71.5 C 82.650684,78.396104 83.536195,89.443626 74.999999,91.84375 C 65.062996,91.017122 64.05284,76.914438 54.283675,75.750529 C 50.352102,75.051855 46.009593,69.547093 43.031249,70.1875 z " />
-      <path
-         style="fill:url(#radialGradient1887);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         id="path1886"
-         d="M 51.968749,10.15625 C 40.703741,13.843837 36.038494,27.433868 37.531249,38.375 C 35.900906,41.584912 25.71302,45.254989 31.843749,49.03125 C 53.068339,53.154256 75.12687,46.221276 93.715523,36.077723 C 100.42684,33.740896 99.810666,26.846559 92.384918,26.66513 C 86.324151,26.558371 81.674394,23.81643 81.165374,17.307044 C 79.826948,13.582045 74.107596,6.6890987 71.01108,12.623276 C 71.073069,19.511996 65.891703,20.102559 63.230392,14.042893 C 60.468574,10.851605 56.135557,9.1882781 51.968749,10.15625 z " />
-    </g>
-    <path
-       sodipodi:type="arc"
-       style="fill:#000000"
-       id="path2488"
-       sodipodi:cx="292.14285"
-       sodipodi:cy="181.95163"
-       sodipodi:rx="15"
-       sodipodi:ry="15"
-       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
-       transform="translate(82.857147,474.9866)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644" />
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="365.71429"
-       y="668.60229"
-       id="text2490"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644"><tspan
-         sodipodi:role="line"
-         id="tspan2492"
-         x="365.71429"
-         y="668.60229">4</tspan></text>
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="401.5625"
-       y="665.76636"
-       id="text2494"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644"><tspan
-         sodipodi:role="line"
-         id="tspan2496"
-         x="401.5625"
-         y="665.76636">accept or reject</tspan></text>
-  </g>
-</svg>

=== removed file 'doc/en/user-guide/images/workflows_localcommit.png'
Binary files doc/en/user-guide/images/workflows_localcommit.png and doc/en/user-guide/images/workflows_localcommit.png differ
=== removed file 'doc/en/user-guide/images/workflows_localcommit.svg'
--- doc/en/user-guide/images/workflows_localcommit.svg	2007-11-30 04:34:08 +0000
+++ doc/en/user-guide/images/workflows_localcommit.svg	1970-01-01 00:00:00 +0000
@@ -1,1575 +0,0 @@
-<?xml version="1.0" encoding="UTF-8" standalone="no"?>
-<!-- Created with Inkscape (http://www.inkscape.org/) -->
-<svg
-   xmlns:dc="http://purl.org/dc/elements/1.1/"
-   xmlns:cc="http://web.resource.org/cc/"
-   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
-   xmlns:svg="http://www.w3.org/2000/svg"
-   xmlns="http://www.w3.org/2000/svg"
-   xmlns:xlink="http://www.w3.org/1999/xlink"
-   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"
-   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"
-   width="1052.3622"
-   height="744.09448"
-   id="svg2"
-   sodipodi:version="0.32"
-   inkscape:version="0.45.1"
-   version="1.0"
-   sodipodi:docbase="/home/ian/Desktop/talk/workflows"
-   sodipodi:docname="workflows_localcommit.svg"
-   inkscape:output_extension="org.inkscape.output.svg.inkscape"
-   inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_localcommit.png"
-   inkscape:export-xdpi="90"
-   inkscape:export-ydpi="90">
-  <defs
-     id="defs4">
-    <radialGradient
-       xlink:href="#linearGradient5992"
-       r="33.156250"
-       inkscape:collect="always"
-       id="radialGradient6000"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(1.000000,0.000000,0.000000,1.693685,0.000000,-197.9515)"
-       fy="285.36218"
-       fx="495.50000"
-       cy="285.36218"
-       cx="495.50000" />
-    <linearGradient
-       y2="187.57059"
-       y1="225.40080"
-       xlink:href="#linearGradient5963"
-       x2="458.91232"
-       x1="383.95898"
-       inkscape:collect="always"
-       id="linearGradient5969"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       id="linearGradient3586">
-      <stop
-         style="stop-color:#000000;stop-opacity:1.0000000;"
-         offset="0.0000000"
-         id="stop3588" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0;"
-         offset="1"
-         id="stop3590" />
-    </linearGradient>
-    <linearGradient
-       inkscape:collect="always"
-       id="linearGradient5963">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:1;"
-         offset="0"
-         id="stop5965" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0;"
-         offset="1"
-         id="stop5967" />
-    </linearGradient>
-    <linearGradient
-       inkscape:collect="always"
-       id="linearGradient5992">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:1;"
-         offset="0"
-         id="stop5994" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0;"
-         offset="1"
-         id="stop5996" />
-    </linearGradient>
-    <linearGradient
-       y2="-0.45783132"
-       y1="3.3012049"
-       xlink:href="#linearGradient893"
-       x2="0.92957747"
-       x1="-2.3960868e-17"
-       id="linearGradient4284" />
-    <linearGradient
-       y2="-0.033519555"
-       y1="2.0837989"
-       xlink:href="#linearGradient893"
-       x2="0.99074072"
-       x1="-0.77314812"
-       id="linearGradient4283" />
-    <linearGradient
-       y2="1.8771822"
-       y1="-0.033741195"
-       xlink:href="#linearGradient902"
-       x2="0.48453596"
-       x1="0.47041038"
-       id="linearGradient2740"
-       gradientTransform="scale(0.997153,1.002855)" />
-    <linearGradient
-       y2="1.9025002"
-       y1="-0.043652620"
-       xlink:href="#linearGradient902"
-       x2="0.48481107"
-       x1="0.47042510"
-       id="linearGradient1506"
-       gradientTransform="scale(0.995847,1.004170)" />
-    <linearGradient
-       y2="1.8570156"
-       y1="-0.024853170"
-       xlink:href="#linearGradient902"
-       x2="0.48548824"
-       x1="0.47157744"
-       id="linearGradient1505"
-       gradientTransform="scale(0.997825,1.002180)" />
-    <linearGradient
-       y2="182.99154"
-       y1="169.09755"
-       xlink:href="#linearGradient892"
-       x2="88.996957"
-       x1="88.755695"
-       id="linearGradient1404"
-       gradientTransform="scale(1.3695887,0.7301462)"
-       gradientUnits="userSpaceOnUse" />
-    <radialGradient
-       xlink:href="#linearGradient1317"
-       r="0.34964636"
-       id="radialGradient1316"
-       fy="0.18269235"
-       fx="0.50352114"
-       cy="0.50000006"
-       cx="0.50000000" />
-    <radialGradient
-       xlink:href="#linearGradient1317"
-       r="0.41197181"
-       id="radialGradient1315"
-       fy="0.26666668"
-       fx="0.47535211"
-       cy="0.53333336"
-       cx="0.47887325" />
-    <linearGradient
-       y2="173.03153"
-       y1="177.77768"
-       xlink:href="#linearGradient902"
-       x2="95.100155"
-       x1="101.10657"
-       id="linearGradient1171"
-       gradientTransform="scale(1.3601783,0.7351977)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="1.8378206"
-       y1="-0.016295359"
-       xlink:href="#linearGradient902"
-       x2="0.48655096"
-       x1="0.47284532"
-       id="linearGradient1170"
-       gradientTransform="scale(0.998371,1.001632)" />
-    <linearGradient
-       y2="81.477602"
-       y1="224.57898"
-       xlink:href="#linearGradient893"
-       x2="74.533693"
-       x1="146.69923"
-       id="linearGradient1169"
-       gradientTransform="scale(1.1870691,0.842411)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="133.54711"
-       y1="228.39311"
-       xlink:href="#linearGradient888"
-       x2="88.447016"
-       x1="141.60217"
-       id="linearGradient1167"
-       gradientTransform="scale(1.1838753,0.8446836)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="148.78619"
-       y1="131.25248"
-       xlink:href="#linearGradient1317"
-       x2="107.04918"
-       x1="111.49758"
-       id="linearGradient1166"
-       gradientTransform="scale(1.223869,0.8170809)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="176.28694"
-       y1="269.85831"
-       xlink:href="#linearGradient888"
-       x2="-16.224496"
-       x1="51.460928"
-       id="linearGradient1157"
-       gradientTransform="scale(2.4217071,0.4129318)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="234.26866"
-       y1="178.48862"
-       xlink:href="#linearGradient888"
-       x2="25.220815"
-       x1="25.220815"
-       id="linearGradient1156"
-       gradientTransform="scale(2.4217071,0.4129318)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="105.42543"
-       y1="76.277559"
-       xlink:href="#linearGradient892"
-       x2="8.346058"
-       x1="35.190362"
-       id="linearGradient1150"
-       gradientTransform="scale(1.3283861,0.7527932)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="20.481863"
-       y1="49.507656"
-       xlink:href="#linearGradient892"
-       x2="70.224305"
-       x1="39.690614"
-       id="linearGradient1148"
-       gradientTransform="scale(1.329144,0.7523639)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="113.71949"
-       y1="90.197025"
-       xlink:href="#linearGradient892"
-       x2="17.876529"
-       x1="39.810948"
-       id="linearGradient1146"
-       gradientTransform="scale(1.3207392,0.7571517)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="251.21892"
-       y1="203.499"
-       xlink:href="#linearGradient892"
-       x2="31.617281"
-       x1="31.449743"
-       id="linearGradient1144"
-       gradientTransform="scale(2.1051174,0.4750329)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="-0.45783132"
-       y1="3.3012049"
-       xlink:href="#linearGradient888"
-       x2="0.92957747"
-       x1="0.00000000"
-       id="linearGradient1141" />
-    <linearGradient
-       y2="232.24952"
-       y1="110.4447"
-       xlink:href="#linearGradient888"
-       x2="41.967061"
-       x1="45.685757"
-       id="linearGradient1140"
-       gradientTransform="scale(1.9102155,0.5235012)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="75.912531"
-       y1="375.92199"
-       xlink:href="#linearGradient1806"
-       x2="-268.25407"
-       x1="-249.72067"
-       id="linearGradient1138"
-       gradientTransform="scale(1.087146,0.9198397)"
-       gradientUnits="userSpaceOnUse" />
-    <radialGradient
-       xlink:href="#linearGradient1133"
-       r="68.589222"
-       id="radialGradient1132"
-       fy="39.288476"
-       fx="72.107883"
-       cy="56.485935"
-       cx="60.004654"
-       gradientTransform="scale(1.2267534,0.8151598)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="11.699047"
-       y1="208.43991"
-       xlink:href="#linearGradient888"
-       x2="95.644441"
-       x1="-77.726178"
-       id="linearGradient905"
-       gradientTransform="scale(1.0964158,0.9120627)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       xlink:href="#linearGradient1806"
-       id="linearGradient901" />
-    <linearGradient
-       y2="91.07699"
-       y1="-3.9104078"
-       xlink:href="#linearGradient888"
-       x2="27.674331"
-       x1="92.437968"
-       id="linearGradient891"
-       gradientTransform="scale(1.2267534,0.8151598)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       id="linearGradient888">
-      <stop
-         style="stop-color:#626262;stop-opacity:1.0000000;"
-         offset="0.0000000"
-         id="stop889" />
-      <stop
-         style="stop-color:#fff;stop-opacity:1;"
-         offset="1"
-         id="stop890" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient892">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.00000000;"
-         offset="0.00000000"
-         id="stop893" />
-      <stop
-         style="stop-color:#fff;stop-opacity:1;"
-         offset="1"
-         id="stop894" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient902">
-      <stop
-         style="stop-color:#000000;stop-opacity:0.00000000;"
-         offset="0.00000000"
-         id="stop903" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0.22000000;"
-         offset="1.0000000"
-         id="stop904" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient1098">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:1.0000000;"
-         offset="0.00000000"
-         id="stop1099" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.22314049;"
-         offset="0.50000000"
-         id="stop1101" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.00000000;"
-         offset="0.59930235"
-         id="stop1102" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.60330576;"
-         offset="1.0000000"
-         id="stop1100" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient1133">
-      <stop
-         style="stop-color:#8bb7df;stop-opacity:1.0000000;"
-         offset="0.00000000"
-         id="stop1134" />
-      <stop
-         style="stop-color:#2a6092;stop-opacity:1.0000000;"
-         offset="0.76209301"
-         id="stop1136" />
-      <stop
-         style="stop-color:#375e82;stop-opacity:1.0000000;"
-         offset="1.0000000"
-         id="stop1135" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient1317">
-      <stop
-         style="stop-color:#000000;stop-opacity:0.52892560;"
-         offset="0.00000000"
-         id="stop1318" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0.17355372;"
-         offset="0.50000000"
-         id="stop1320" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0.00000000;"
-         offset="1.0000000"
-         id="stop1319" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient893">
-      <stop
-         style="stop-color:#000;stop-opacity:1;"
-         offset="0"
-         id="stop895" />
-      <stop
-         style="stop-color:#fff;stop-opacity:1;"
-         offset="1"
-         id="stop896" />
-    </linearGradient>
-    <radialGradient
-       xlink:href="#linearGradient1806"
-       r="11.574221"
-       id="radialGradient1977"
-       fy="39.410465"
-       fx="42.280806"
-       cy="39.007645"
-       cx="42.007257"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       id="linearGradient1806">
-      <stop
-         style="stop-color:#000000;stop-opacity:0.35051546;"
-         offset="0.0000000"
-         id="stop1807" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0.13402061;"
-         offset="0.64999998"
-         id="stop3276" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop1808" />
-    </linearGradient>
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient5281"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient5283"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient5285"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <radialGradient
-       xlink:href="#linearGradient4362"
-       r="5.5130484"
-       inkscape:collect="always"
-       id="radialGradient1828"
-       fy="61.38567"
-       fx="86.542037"
-       cy="61.38567"
-       cx="86.542037"
-       gradientTransform="matrix(-0.8164966,0,0,1.2247449,262.80373,-280)"
-       gradientUnits="userSpaceOnUse" />
-    <radialGradient
-       xlink:href="#linearGradient4362"
-       r="11.123441"
-       inkscape:collect="always"
-       id="radialGradient1824"
-       fy="58.887858"
-       fx="118.06427"
-       cy="58.54025"
-       cx="117.17439"
-       gradientTransform="matrix(-0.6229142,0,0,1.6053575,262.80373,-280)"
-       gradientUnits="userSpaceOnUse" />
-    <radialGradient
-       xlink:href="#linearGradient4362"
-       r="22.00904"
-       inkscape:collect="always"
-       id="radialGradient1822"
-       fy="87.892895"
-       fx="45.50637"
-       cy="88.322677"
-       cx="45.139623"
-       gradientTransform="matrix(-1.0914815,0,0,0.9161859,262.80373,-280)"
-       gradientUnits="userSpaceOnUse" />
-    <radialGradient
-       xlink:href="#linearGradient4362"
-       r="18.836343"
-       inkscape:collect="always"
-       id="radialGradient1818"
-       fy="33.351633"
-       fx="48.40165"
-       cy="32.467054"
-       cx="48.40165"
-       gradientTransform="matrix(-1.1146027,0,0,0.8971807,262.80373,-280)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="74.834393"
-       y1="57.093738"
-       xlink:href="#linearGradient4376"
-       x2="50.203204"
-       x1="50.52668"
-       inkscape:collect="always"
-       id="linearGradient1815"
-       gradientTransform="matrix(-1.3516689,0,0,0.7398261,262.80373,-280)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       id="linearGradient4384">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.77513230;"
-         offset="0.0000000"
-         id="stop4385" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop4386" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient4376">
-      <stop
-         style="stop-color:#000000;stop-opacity:0.52645504;"
-         offset="0.0000000"
-         id="stop4377" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop4378" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient4362">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.66666669;"
-         offset="0.0000000"
-         id="stop4363" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop4364" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient4358">
-      <stop
-         style="stop-color:#000;stop-opacity:1;"
-         offset="0"
-         id="stop4359" />
-      <stop
-         style="stop-color:#fff;stop-opacity:1;"
-         offset="1"
-         id="stop4360" />
-    </linearGradient>
-    <radialGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="radialGradient5536"
-       gradientUnits="userSpaceOnUse"
-       cx="42.007257"
-       cy="39.007645"
-       fx="42.280806"
-       fy="39.410465"
-       r="11.574221" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient5538"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient5540"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient5542"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient5544"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient888"
-       id="linearGradient5546"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(2.4217071,0.4129318)"
-       x1="25.220815"
-       y1="178.48862"
-       x2="25.220815"
-       y2="234.26866" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient888"
-       id="linearGradient5548"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(2.4217071,0.4129318)"
-       x1="51.460928"
-       y1="269.85831"
-       x2="-16.224496"
-       y2="176.28694" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient893"
-       id="linearGradient5550"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.1870691,0.842411)"
-       x1="146.69923"
-       y1="224.57898"
-       x2="74.533693"
-       y2="81.477602" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient888"
-       id="linearGradient5552"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.9102155,0.5235012)"
-       x1="45.685757"
-       y1="110.4447"
-       x2="41.967061"
-       y2="232.24952" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient888"
-       id="linearGradient5554"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.0964158,0.9120627)"
-       x1="-77.726178"
-       y1="208.43991"
-       x2="95.644441"
-       y2="11.699047" />
-    <radialGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1133"
-       id="radialGradient5556"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.2267534,0.8151598)"
-       cx="60.004654"
-       cy="56.485935"
-       fx="72.107883"
-       fy="39.288476"
-       r="68.589222" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient888"
-       id="linearGradient5558"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.2267534,0.8151598)"
-       x1="92.437968"
-       y1="-3.9104078"
-       x2="27.674331"
-       y2="91.07699" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient892"
-       id="linearGradient5560"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.3207392,0.7571517)"
-       x1="39.810948"
-       y1="90.197025"
-       x2="17.876529"
-       y2="113.71949" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient892"
-       id="linearGradient5562"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.329144,0.7523639)"
-       x1="39.690614"
-       y1="49.507656"
-       x2="70.224305"
-       y2="20.481863" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient892"
-       id="linearGradient5564"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.3283861,0.7527932)"
-       x1="35.190362"
-       y1="76.277559"
-       x2="8.346058"
-       y2="105.42543" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient888"
-       id="linearGradient5566"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.1838753,0.8446836)"
-       x1="141.60217"
-       y1="228.39311"
-       x2="88.447016"
-       y2="133.54711" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient902"
-       id="linearGradient5568"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.3601783,0.7351977)"
-       x1="101.10657"
-       y1="177.77768"
-       x2="95.100155"
-       y2="173.03153" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient892"
-       id="linearGradient5570"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.3695887,0.7301462)"
-       x1="88.755695"
-       y1="169.09755"
-       x2="88.996957"
-       y2="182.99154" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1317"
-       id="linearGradient5572"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.223869,0.8170809)"
-       x1="111.49758"
-       y1="131.25248"
-       x2="107.04918"
-       y2="148.78619" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient892"
-       id="linearGradient5574"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(2.1051174,0.4750329)"
-       x1="31.449743"
-       y1="203.499"
-       x2="31.617281"
-       y2="251.21892" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient5714"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <radialGradient
-       xlink:href="#linearGradient4362"
-       r="39.648127"
-       inkscape:collect="always"
-       id="radialGradient2797"
-       fy="101.92288"
-       fx="50.092871"
-       cy="102.70191"
-       cx="49.760482"
-       gradientTransform="scale(1.1222336,0.8910801)"
-       gradientUnits="userSpaceOnUse" />
-    <radialGradient
-       xlink:href="#linearGradient4362"
-       r="35.284406"
-       inkscape:collect="always"
-       id="radialGradient2791"
-       fy="32.061308"
-       fx="81.553592"
-       cy="33.402904"
-       cx="80.599566"
-       gradientTransform="scale(0.8352269,1.1972794)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="67.164412"
-       y1="53.505203"
-       xlink:href="#linearGradient4376"
-       x2="63.804663"
-       x1="64.786456"
-       inkscape:collect="always"
-       id="linearGradient2789"
-       gradientTransform="scale(1.1424512,0.8753109)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       id="linearGradient6015">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.77513230;"
-         offset="0.0000000"
-         id="stop6017" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop6019" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient6009">
-      <stop
-         style="stop-color:#000000;stop-opacity:0.52645504;"
-         offset="0.0000000"
-         id="stop6011" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop6013" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient6003">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.66666669;"
-         offset="0.0000000"
-         id="stop6005" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop6007" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient5997">
-      <stop
-         style="stop-color:#000;stop-opacity:1;"
-         offset="0"
-         id="stop5999" />
-      <stop
-         style="stop-color:#fff;stop-opacity:1;"
-         offset="1"
-         id="stop6001" />
-    </linearGradient>
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient6037"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <linearGradient
-       y2="0.46093750"
-       y1="0.46093750"
-       xlink:href="#linearGradient650"
-       x2="1.16666818"
-       x1="1.22222710"
-       spreadMethod="repeat"
-       id="linearGradient654"
-       gradientUnits="objectBoundingBox" />
-    <linearGradient
-       y2="0.53906250"
-       y1="0.53125000"
-       xlink:href="#linearGradient650"
-       x2="1.16666901"
-       x1="1.00000548"
-       spreadMethod="repeat"
-       id="linearGradient653"
-       gradientUnits="objectBoundingBox" />
-    <linearGradient
-       id="linearGradient650">
-      <stop
-         style="stop-color:#000;stop-opacity:1;"
-         offset="0"
-         id="stop651" />
-      <stop
-         style="stop-color:#fff;stop-opacity:1;"
-         offset="1"
-         id="stop652" />
-    </linearGradient>
-    <linearGradient
-       y2="0.46093750"
-       y1="0.46093750"
-       xlink:href="#linearGradient650"
-       x2="1.16666818"
-       x1="1.22222710"
-       spreadMethod="repeat"
-       id="linearGradient8493"
-       gradientUnits="objectBoundingBox" />
-    <linearGradient
-       y2="0.53906250"
-       y1="0.53125000"
-       xlink:href="#linearGradient650"
-       x2="1.16666901"
-       x1="1.00000548"
-       spreadMethod="repeat"
-       id="linearGradient8491"
-       gradientUnits="objectBoundingBox" />
-    <linearGradient
-       id="linearGradient8485">
-      <stop
-         style="stop-color:#000;stop-opacity:1;"
-         offset="0"
-         id="stop8487" />
-      <stop
-         style="stop-color:#fff;stop-opacity:1;"
-         offset="1"
-         id="stop8489" />
-    </linearGradient>
-  </defs>
-  <sodipodi:namedview
-     id="base"
-     pagecolor="#ffffff"
-     bordercolor="#666666"
-     borderopacity="1.0"
-     gridtolerance="10000"
-     guidetolerance="10"
-     objecttolerance="10"
-     inkscape:pageopacity="0.0"
-     inkscape:pageshadow="2"
-     inkscape:zoom="0.70710678"
-     inkscape:cx="503.09779"
-     inkscape:cy="201.79714"
-     inkscape:document-units="px"
-     inkscape:current-layer="layer1"
-     width="1052.3622px"
-     height="744.09448px"
-     showgrid="true"
-     inkscape:window-width="1024"
-     inkscape:window-height="712"
-     inkscape:window-x="-4"
-     inkscape:window-y="-4" />
-  <metadata
-     id="metadata7">
-    <rdf:RDF>
-      <cc:Work
-         rdf:about="">
-        <dc:format>image/svg+xml</dc:format>
-        <dc:type
-           rdf:resource="http://purl.org/dc/dcmitype/StillImage" />
-      </cc:Work>
-    </rdf:RDF>
-  </metadata>
-  <g
-     inkscape:label="Layer 1"
-     inkscape:groupmode="layer"
-     id="layer1">
-    <g
-       inkscape:label="Layer 1"
-       id="g4996"
-       transform="matrix(0.331077,0,0,0.2676656,75.992157,230.68349)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
-       inkscape:export-xdpi="35.529999"
-       inkscape:export-ydpi="35.529999">
-      <g
-         transform="matrix(2.674162,0,0,2.674162,-826.248,-323.8239)"
-         id="g6052">
-        <path
-           style="fill:#c7c7c7;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:6.11299896;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
-           sodipodi:nodetypes="czcczzz"
-           id="path1306"
-           d="M 362.77592,187.283 C 360.50343,190.98677 361.20593,367.68763 364.14011,374.65173 C 366.46268,380.1642 441.02381,442.12988 444.93699,443.78694 C 495.35017,443.444 529.34176,425.0858 534.99109,415.38735 C 537.14042,403.1889 535.31621,215.19709 533.25552,211.25359 C 531.47859,207.85312 436.04893,173.6386 432.71615,172.86054 C 429.71763,172.16052 365.30189,183.1661 362.77592,187.283 z " />
-        <path
-           style="fill:#ffffff;fill-opacity:0.54385968;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
-           sodipodi:nodetypes="ccccccc"
-           id="path2066"
-           d="M 366.42857,190.93361 C 391.19048,201.4098 418.60601,218.30739 446.22506,231.64072 C 472.394,225.42153 510.2022,217.10972 529.24981,213.77639 C 504.726,221.39543 472.52022,228.51448 447.99641,236.13353 C 446.56784,293.51448 447.257,380.45861 445.82843,437.83956 C 445.11414,379.98242 443.14285,291.6479 442.42856,233.79075 C 415.99999,219.50504 390,206.64789 366.42857,190.93361 z " />
-        <path
-           style="fill:#000000;fill-opacity:0.16228069;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
-           sodipodi:nodetypes="ccc"
-           id="path4356"
-           d="M 519.99794,379.97737 C 510.93834,392.99882 482.41849,399.43361 468.8726,394.16864 C 471.21835,393.5424 516.96143,380.96883 519.99794,379.97737 z " />
-        <g
-           transform="translate(2.035534,15.20712)"
-           id="g4374">
-          <path
-             style="fill:#ffffff;fill-opacity:0.39473685;fill-rule:evenodd;stroke:none;stroke-width:1.01199996;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
-             sodipodi:nodetypes="cccccc"
-             id="path4362"
-             d="M 471.29127,340.59039 L 513.55921,324.30516 C 517.9002,325.84805 517.04588,332.27818 517.04588,332.27818 L 510.46155,334.58088 C 510.46155,334.58088 501.26764,349.01224 484.93096,343.36795 C 484.93096,343.36795 472.7787,345.52605 471.29127,340.59039 z " />
-          <path
-             style="fill:#606060;fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:1.11199999;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
-             sodipodi:nodetypes="ccccccc"
-             id="path2826"
-             d="M 471.66824,335.10501 C 485.70133,331.45482 499.73443,327.80464 513.76752,324.15445 C 514.30594,326.13864 514.34437,328.99782 513.50779,330.48201 C 511.36566,331.50652 507.10221,332.35425 504.96008,333.37876 C 498.80357,339.27354 493.45917,339.80363 483.65919,338.95243 C 479.87505,339.74603 476.0909,340.36284 472.30676,341.15644 C 471.15285,338.85897 470.82215,337.90248 471.66824,335.10501 z " />
-        </g>
-        <path
-           style="fill:#ffffff;fill-opacity:0.40350874;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
-           sodipodi:nodetypes="ccccc"
-           id="path4423"
-           d="M 364.8671,189.69191 L 446.71991,235.61832 L 446.39149,441.00771 L 366.28132,373.53968 L 364.8671,189.69191 z " />
-        <path
-           style="fill:#000000;fill-opacity:0.16228069;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
-           sodipodi:nodetypes="ccc"
-           id="path5957"
-           d="M 515.24794,392.97737 C 505.81506,405.42036 486.94113,407.56087 476.3726,403.76831 C 478.1563,403.29212 512.93901,393.73127 515.24794,392.97737 z " />
-        <path
-           style="fill:#000000;fill-opacity:0.16228069;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
-           sodipodi:nodetypes="ccc"
-           id="path5959"
-           d="M 508.24794,405.72737 C 502.79158,413.09279 492.2492,415.37141 483.8726,412.49343 C 484.991,412.19485 506.80021,406.20008 508.24794,405.72737 z " />
-        <path
-           style="fill:#fcfcfc;fill-opacity:0.44298245;fill-rule:evenodd;stroke:none;stroke-width:0.31200001;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
-           sodipodi:nodetypes="ccccccc"
-           id="path5973"
-           d="M 522.875,227.86218 L 527.04289,228.4302 L 527.79289,326.56929 L 463.46862,344.54896 L 461.88388,339.34073 L 523.68934,322.86218 L 522.875,227.86218 z " />
-        <path
-           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
-           sodipodi:nodetypes="cccc"
-           id="path6026"
-           d="M 462.21967,264.23013 L 462.31434,266.99086 L 522.7929,249.54632 L 462.21967,264.23013 z " />
-        <path
-           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
-           sodipodi:nodetypes="cccc"
-           id="path6036"
-           d="M 461.33579,284.2059 L 461.43046,286.96663 L 521.90902,269.52209 L 461.33579,284.2059 z " />
-        <path
-           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
-           sodipodi:nodetypes="cccc"
-           id="path6038"
-           d="M 462.21967,302.64613 L 462.31434,305.40686 L 522.7929,287.96232 L 462.21967,302.64613 z " />
-        <path
-           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
-           sodipodi:nodetypes="cccc"
-           id="path6040"
-           d="M 462.21967,320.79868 L 462.31434,323.55941 L 522.7929,306.11487 L 462.21967,320.79868 z " />
-        <path
-           style="opacity:1;color:#000000;fill:none;fill-opacity:0.75;fill-rule:evenodd;stroke:#9e9e9e;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
-           sodipodi:nodetypes="ccc"
-           id="path5988"
-           d="M 522.55191,229.64344 L 462.03362,244.76045 L 462.53549,344.35813" />
-      </g>
-    </g>
-    <g
-       id="g5256"
-       transform="translate(601.5744,207.49165)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
-       inkscape:export-xdpi="35.529999"
-       inkscape:export-ydpi="35.529999">
-      <path
-         transform="matrix(6.392368,0.545409,-0.130014,2.864752,-184.6606,-38.15109)"
-         style="fill:url(#radialGradient1977);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:type="arc"
-         sodipodi:ry="12.562782"
-         sodipodi:rx="12.562782"
-         sodipodi:cy="37.865574"
-         sodipodi:cx="41.875938"
-         id="path1976"
-         d="M 54.438721 37.865574 A 12.562782 12.562782 0 1 1  29.313156,37.865574 A 12.562782 12.562782 0 1 1  54.438721 37.865574 z" />
-      <g
-         transform="matrix(1,0,0,1.036969,356.8306,-11.4294)"
-         style="fill:url(#linearGradient6037);fill-opacity:1"
-         id="g4293">
-        <path
-           style="fill:url(#linearGradient5281);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
-           id="path2720"
-           d="M -270.85787,33.814995 C -289.35564,33.925992 -307.93321,33.592782 -326.38104,33.981747 C -331.43469,35.696391 -331.02221,41.899652 -330.68524,46.15332 C -330.75782,60.227303 -330.53537,74.298225 -330.21167,88.36826 C -328.21297,91.039611 -323.21766,90.618387 -322.68469,94.539015 C -320.78054,96.259426 -317.05071,94.88215 -314.4389,95.333237 C -298.54999,95.360274 -282.66107,95.387302 -266.77215,95.414339 C -266.35587,90.465192 -260.12609,88.824447 -255.81783,89.540255 C -256.01688,89.058389 -261.69557,87.939375 -259.61591,84.491525 C -259.45681,68.72727 -259.19734,52.882199 -259.82064,37.168229 C -261.19394,32.980583 -267.34179,33.83368 -270.85787,33.814995 z M -236.65184,97.260473 C -234.79025,100.12642 -237.08724,103.09386 -239.92892,104.16357 C -242.6311,105.91539 -245.59105,107.62992 -248.52894,108.76804 C -253.1773,108.19079 -251.42424,101.88475 -255.01281,99.896645 C -260.33594,96.447012 -267.21045,98.43943 -273.23329,97.939231 C -291.8249,97.94887 -310.41651,97.958519 -329.00813,97.968158 C -335.45898,103.56578 -339.16595,111.40269 -341.55034,119.32178 C -337.25147,124.2061 -329.89606,122.27575 -324.10438,122.40002 C -298.64553,122.23171 -273.11679,122.61546 -247.69897,122.24542 C -243.40174,121.14669 -247.44685,114.84894 -243.58488,113.04441 C -242.73865,112.73374 -247.81245,114.4382 -247.26205,111.62955 C -245.49117,106.66028 -239.14113,105.99595 -235.92338,102.36811 C -234.39131,99.755669 -236.26958,96.922488 -238.33047,95.260495 C -237.77093,95.927151 -237.21138,96.593817 -236.65184,97.260473 z M -240.64255,111.75263 C -243.64086,113.13223 -237.02792,110.69536 -235.55512,111.97369 C -229.71113,112.74417 -224.16461,117.19625 -218.12358,115.22951 C -225.97639,116.31604 -232.799,109.03014 -240.64255,111.75263 z M -212.01083,112.33724 C -215.98173,113.85021 -208.21543,112.17765 -210.07883,115.87566 C -212.50961,119.93855 -206.99008,113.8662 -209.61436,112.54677 C -210.16198,111.94632 -211.27989,112.47663 -212.01083,112.33724 z M -213.97451,120.82946 C -220.13871,124.32615 -228.37873,119.08124 -233.85995,124.39439 C -238.36465,128.00055 -244.57099,130.35185 -247.0433,135.75122 C -247.65922,139.60202 -243.25109,141.90251 -240.44565,143.71808 C -235.60127,146.54512 -228.8227,145.75388 -225.20082,141.42836 C -220.62679,137.96117 -216.44182,134.08489 -212.48592,129.96782 C -212.82701,126.95048 -214.43694,123.63971 -213.97451,120.82946 z " />
-        <path
-           style="fill:url(#linearGradient5283);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
-           id="path2723"
-           d="M -269.68453,32.256957 C -288.76965,32.351184 -307.87514,32.249603 -326.94796,32.349264 C -332.63884,33.663474 -333.90446,40.291305 -333.21597,45.149113 C -333.11996,59.896901 -333.07471,74.659754 -332.61729,89.39481 C -331.88583,93.310348 -324.86009,92.098674 -325.11097,96.44089 C -328.07184,96.184706 -331.5534,96.317135 -333.07248,99.246492 C -338.92562,104.98392 -341.99312,112.66465 -344.27268,120.28679 C -340.22572,125.96631 -332.26467,125.31453 -326.02946,124.71751 C -300.16629,124.7277 -274.28316,124.82043 -248.43245,124.77905 C -244.42424,124.78686 -243.30672,120.35609 -243.96666,117.2099 C -242.88598,112.93536 -237.04086,113.94554 -233.80717,114.98513 C -228.01851,116.64297 -221.26418,120.43074 -215.57982,116.37592 C -211.36091,113.71809 -213.05678,118.4029 -215.77936,119.43344 C -220.82539,122.25797 -227.09125,118.98178 -232.39677,121.20855 C -236.53238,123.88957 -240.74707,126.85249 -244.76678,129.74666 C -248.34219,132.01467 -251.90947,137.38626 -248.13747,140.97315 C -243.79274,146.02948 -236.37425,149.4527 -229.68248,147.08651 C -225.09383,144.85973 -221.79206,140.75401 -217.61535,137.88661 C -215.10454,135.69469 -212.49235,133.26839 -210.83749,130.50207 C -210.86477,126.92195 -214.68529,121.91303 -210.252,119.57013 C -207.25619,117.95208 -205.81053,112.12098 -209.75314,110.87946 C -214.16982,109.44692 -216.95156,115.09837 -221.43751,113.68608 C -228.47365,112.76758 -235.5565,107.20489 -242.69931,110.72434 C -246.89551,113.06547 -243.47174,109.4356 -241.45524,108.56544 C -237.85613,106.84628 -232.73147,104.36798 -233.94637,99.617708 C -234.27189,95.083838 -239.22223,93.197522 -242.95318,91.723135 C -247.61613,89.074942 -253.27003,89.345117 -258.06082,86.933298 C -257.89248,70.385101 -257.58805,53.76423 -258.26571,37.261116 C -259.2092,32.393288 -265.59824,31.96057 -269.68453,32.256957 z M -258.66259,91.764016 C -251.5059,92.239344 -243.21163,93.474137 -238.58238,99.271629 C -238.96251,103.06003 -244.00295,103.80224 -246.52821,106.14082 C -248.92267,108.48087 -251.12372,105.80503 -251.02958,103.27159 C -252.70852,98.336432 -258.20582,95.710815 -263.31841,96.533197 C -267.00561,96.7255 -263.71935,91.937514 -261.395,92.380192 C -260.48382,92.178338 -259.57521,91.953759 -258.66259,91.764016 z " />
-        <path
-           style="fill:url(#linearGradient5285);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
-           sodipodi:nodetypes="ccccczccccccccccccccccccczccccc"
-           id="path2737"
-           d="M -324.0398,30.70877 C -336.3492,30.820231 -335.15663,39.652507 -334.79476,45.313268 C -334.5469,60.436643 -334.38614,75.599009 -334.01234,90.698281 C -333.20516,93.057424 -330.71249,93.985661 -328.75475,95.252079 C -334.4553,96.476239 -336.96996,102.43195 -340.11175,106.59303 C -342.33294,111.36531 -347.84019,115.92868 -345.92111,121.43642 C -344.00204,126.94416 -332.21757,127.68181 -324.95408,127.12866 C -299.06901,127.09789 -273.17022,127.14905 -247.29372,127.06713 C -243.29961,126.16956 -240.99668,122.03601 -241.4977,118.23645 C -238.30082,114.95371 -233.32521,118.03039 -229.53292,118.63002 C -225.71641,119.31313 -232.5646,119.27527 -233.19362,120.54849 C -238.23604,122.95799 -242.6166,126.65447 -246.90973,130.10509 C -250.44674,132.97354 -252.4229,138.10741 -249.57412,142.08235 C -246.21315,145.92284 -241.41489,148.84284 -236.30395,149.79628 C -230.65487,150.83779 -225.57101,147.82678 -221.6157,144.24077 C -216.87391,140.59839 -212.0873,136.78287 -208.84361,131.80554 C -207.76302,128.26399 -211.47449,123.86671 -208.08348,121.09796 C -204.93438,118.46115 -204.06893,113.02076 -207.41836,110.2673 C -212.81988,106.81278 -218.36682,114.55112 -223.89705,111.29128 C -227.94209,110.1659 -231.91311,108.52596 -236.17676,108.45194 C -231.52711,105.88023 -229.62903,98.782331 -234.08944,95.153402 C -239.61551,89.404431 -248.455,88.793917 -255.40182,85.744487 C -255.86992,78.940296 -255.53665,71.972758 -255.70928,65.098797 C -255.80747,55.730822 -255.73864,46.312632 -255.94025,36.975777 C -258.03631,31.236293 -265.34014,30.439522 -270.76286,30.729689 C -289.40725,30.770714 -311.88665,30.597309 -324.0398,30.70877 z M -255.46516,94.482857 C -250.34561,95.62106 -244.69322,96.21649 -240.83258,100.05203 C -242.37635,102.55028 -245.27573,103.64481 -247.80048,104.97505 C -249.71506,99.684643 -254.39847,94.970039 -260.51378,95.138259 C -260.66903,94.131274 -256.73261,94.551178 -255.46516,94.482857 z " />
-      </g>
-      <rect
-         y="78.658051"
-         x="33.326111"
-         width="57.567924"
-         style="fill:url(#linearGradient1156);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient1157);stroke-width:1.44734821pt"
-         id="rect1155"
-         height="8.3153667" />
-      <path
-         style="fill:url(#linearGradient1169);fill-rule:evenodd;stroke-width:0.90459263;stroke-opacity:0.07438019"
-         sodipodi:nodetypes="czzczczzzzzzzc"
-         id="path2676"
-         d="M 98.723806,78.927818 C 95.18666,77.759681 93.50122,82.555591 98.766686,81.004087 C 104.03217,79.452583 120.13123,85.906451 120.37383,89.795491 C 120.61643,93.905503 101.5003,98.581154 106.74108,104.42426 C 111.62816,110.70149 115.35468,100.13868 123.54696,104.21261 C 131.73923,108.17607 136.26048,109.72394 142.25488,104.94185 C 149.10027,101.9342 145.04599,107.07658 139.57918,113.60451 C 134.11237,120.13244 144.00251,115.08156 147.91225,105.31962 C 151.93248,95.557673 139.13128,107.33503 133.66268,105.40571 C 128.19408,103.47639 119.73678,97.849788 113.27625,102.55563 C 106.81572,107.26147 109.62894,99.493003 114.85637,97.90307 C 120.0838,96.092166 122.81363,93.045722 122.85597,90.161522 C 122.89831,87.498293 117.92629,84.811803 112.94229,82.402852 C 107.73732,79.993901 100.49788,78.588966 98.723806,78.927818 z " />
-      <path
-         style="fill:url(#linearGradient1140);fill-opacity:1;fill-rule:evenodd;stroke-width:1.44734821pt"
-         sodipodi:nodetypes="czzzzzzzz"
-         id="path1139"
-         d="M 15.102732,106.80712 C 13.80355,109.23224 17.148847,113.52338 19.900059,113.52338 L 107.85106,113.52338 C 110.18914,113.52338 113.70766,110.4906 112.64839,108.40622 L 102.7339,88.897093 C 101.97024,87.394398 100.26184,86.65834 98.576216,86.65834 L 28.215425,86.658339 C 26.825434,86.658339 25.353768,87.671846 24.697385,88.897093 L 15.102732,106.80712 z " />
-      <rect
-         y="22.413721"
-         x="26.015469"
-         width="72.279724"
-         style="fill:url(#linearGradient905);fill-opacity:1;fill-rule:evenodd;stroke-width:1.62826681"
-         ry="5.4369707"
-         rx="5.4369707"
-         id="rect1137"
-         height="60.126495" />
-      <rect
-         y="31.695871"
-         x="33.386066"
-         width="58.178177"
-         style="fill:url(#radialGradient1132);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient891);stroke-width:1.4649456pt"
-         id="rect1131"
-         height="38.044163" />
-      <path
-         style="fill:url(#linearGradient1146);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="czzccccc"
-         id="path1145"
-         d="M 27.690431,52.841444 L 27.370609,74.749236 C 27.319624,78.241665 29.310209,80.477938 32.807578,80.506029 L 72.625393,80.825852 L 76.463254,71.87084 L 32.008024,71.55102 L 31.688202,52.681533 L 27.690431,52.841444 z " />
-      <g
-         transform="matrix(-1,0,0,1,125.4301,0)"
-         id="g1791">
-        <path
-           style="fill:url(#linearGradient1148);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-           sodipodi:nodetypes="czzccc"
-           id="path1147"
-           d="M 42.062098,33.460351 L 77.341205,33.008055 C 82.787126,32.938235 89.553204,38.416797 89.553204,43.863165 L 89.553204,60.14583 L 41.609801,59.693534 L 42.062098,33.460351 z " />
-        <path
-           style="fill:url(#linearGradient1150);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-           sodipodi:nodetypes="czzccc"
-           id="path1149"
-           d="M 78.337784,67.629235 L 46.723745,67.724544 C 41.843589,67.739257 35.829319,62.771024 35.877168,57.891081 L 36.020221,43.301821 L 78.973514,44.128288 L 78.337784,67.629235 z " />
-      </g>
-      <path
-         style="fill:url(#linearGradient1167);fill-opacity:1;fill-rule:evenodd;stroke-width:0.72367412;stroke-opacity:0.34710741"
-         sodipodi:nodetypes="cczzzzzzc"
-         id="path1159"
-         d="M 137.39107,112.02341 C 137.39107,112.02341 129.0757,110.26438 123.63872,113.62251 C 118.20176,116.98064 109.96635,123.21719 108.76702,124.81628 C 107.40777,126.57531 107.42036,130.22796 109.24674,131.53253 L 114.84364,135.53031 C 118.31797,138.01198 124.86218,139.25396 128.11624,136.48978 L 142.98795,123.85681 C 144.79792,122.3193 145.72732,118.27921 144.10733,116.82073 C 142.95609,115.04975 140.4892,112.91939 137.39107,112.02341 z " />
-      <path
-         style="fill:url(#linearGradient1171);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="czzzzzc"
-         id="path1160"
-         d="M 142.3483,121.13833 L 125.91043,133.59673 C 122.97154,135.82414 118.65484,134.11775 116.28283,133.77129 C 113.9108,133.42481 111.88528,131.87901 112.12516,132.33209 C 112.36503,132.78517 115.08349,135.71687 117.72203,136.48978 C 120.36055,137.26267 124.9543,138.89307 127.50953,136.15531 C 130.06477,133.41755 145.2267,123.53699 142.3483,121.13833 z " />
-      <path
-         style="fill:url(#linearGradient1404);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="cczc"
-         id="path1403"
-         d="M 132.11225,127.51984 C 135.31047,122.88242 120.11893,113.12786 109.08509,127.0401 C 110.20446,130.71805 116.80662,132.5992 121.82304,132.33547 C 126.68363,132.07993 129.50037,129.97181 132.11225,127.51984 z " />
-      <path
-         style="fill:url(#linearGradient1166);fill-opacity:1;fill-rule:evenodd;stroke-width:1.08551121"
-         sodipodi:nodetypes="cccccccc"
-         id="path1519"
-         d="M 138.63464,112.68306 C 135.9958,113.22749 132.31739,114.43079 129.87534,116.38362 C 128.77009,115.68011 125.32759,114.5677 123.66767,113.84494 L 123.24572,114.10517 C 129.67287,117.23476 136.43512,117.91249 135.88192,122.87668 C 136.33675,122.98575 137.05589,123.09702 136.73191,122.38863 C 136.41775,118.90392 132.50587,117.23351 131.02697,116.81532 C 133.17224,114.26602 136.255,113.70892 138.63464,112.68306 z " />
-      <path
-         style="fill:url(#linearGradient1144);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="czzzzzzzz"
-         id="path1143"
-         d="M 18.891612,106.48414 C 17.978451,108.31614 19.173914,111.55774 22.263529,111.55774 L 105.0195,111.55774 C 106.66288,111.55774 109.13595,109.26672 108.39142,107.69215 L 101.42279,92.954575 C 100.88602,91.819403 99.685232,91.263378 98.500462,91.263378 L 28.108183,91.263369 C 27.131195,91.263369 26.0968,92.028994 25.635445,92.954575 L 18.891612,106.48414 z " />
-      <text
-         y="-14.660837"
-         xml:space="preserve"
-         x="6.147172"
-         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
-         id="text1232"><tspan
-           id="tspan1233">Computer</tspan></text>
-      <text
-         y="-34.951134"
-         xml:space="preserve"
-         x="84.564949"
-         transform="scale(0.246729,0.246729)"
-         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
-         id="text1235"><tspan
-           id="tspan1236">Created by Andrew Fitzsimon</tspan></text>
-    </g>
-    <g
-       id="g5474"
-       transform="translate(633.63525,501.49239)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
-       inkscape:export-xdpi="35.529999"
-       inkscape:export-ydpi="35.529999">
-      <path
-         style="fill:#ffffff;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="cccc"
-         id="path9383"
-         d="M 203.47051,-209.74941 C 198.72111,-204.56585 195.69876,-195.27863 189.00642,-195.27863 C 182.52997,-197.07848 181.66644,-212.48518 180.80291,-215.7969 C 188.1429,-210.75732 195.69876,-207.87757 203.47051,-209.74941 z " />
-      <path
-         transform="matrix(-0.440859,0,0,0.441062,265.52775,-266.17138)"
-         style="fill:#f1bb96;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:type="arc"
-         sodipodi:ry="57.825485"
-         sodipodi:rx="60.94183"
-         sodipodi:cy="70.290855"
-         sodipodi:cx="150.27701"
-         id="path3713"
-         d="M 211.21884 70.290855 A 60.94183 57.825485 0 1 1  89.335178,70.290855 A 60.94183 57.825485 0 1 1  211.21884 70.290855 z" />
-      <path
-         style="fill:#233e6a;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="ccssssc"
-         id="path4369"
-         d="M 232.46888,-182.94274 C 232.85952,-157.74648 168.23012,-154.86512 168.38642,-182.94274 C 166.84164,-205.27149 177.94687,-217.96719 180.70654,-215.80872 C 182.10778,-214.71274 182.62841,-190.37295 192.09635,-195.9716 C 196.69923,-198.69339 201.84768,-209.14846 204.10029,-209.49532 C 207.49937,-210.01873 214.00811,-212.77083 219.98583,-217.92153 C 221.55412,-219.27285 231.93943,-205.38255 232.46888,-182.94274 z " />
-      <path
-         style="fill:#513624;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="ccccc"
-         id="path11309"
-         d="M 204.55432,-273.85152 C 222.46413,-271.53047 237.32676,-259.28175 231.38357,-231.42099 C 229.66954,-221.67743 222.12426,-217.60887 219.35537,-236.36962 C 211.4578,-233.88387 177.25785,-223.92576 170.54948,-241.26677 C 166.55631,-248.43407 174.86257,-276.23329 204.55432,-273.85152 z " />
-      <path
-         style="fill:#1f4eb3;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="cccc"
-         id="path11942"
-         d="M 191.92173,-167.75448 C 192.06919,-184.44566 194.18855,-193.73288 188.47558,-194.95709 C 182.9785,-195.85052 179.91138,-176.52634 179.04785,-173.21462 C 175.85958,-157.19769 189.53653,-154.44605 191.92173,-167.75448 z " />
-      <path
-         style="fill:url(#linearGradient1815);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         id="path1811"
-         d="M 172.67812,-237.76056 C 182.56217,-225.58826 212.09549,-234.15979 219.36562,-236.44806 C 220.33459,-229.88278 221.90014,-226.25074 223.58437,-224.54181 C 219.31219,-215.8234 210.06249,-209.76056 199.27187,-209.76056 C 184.44142,-209.76056 172.42812,-221.18201 172.42812,-235.26056 C 172.42812,-236.11869 172.59078,-236.92413 172.67812,-237.76056 z " />
-      <path
-         style="fill:url(#radialGradient1818);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="ccccc"
-         id="path1817"
-         d="M 203.17522,-273.74212 C 221.08504,-271.42107 235.94766,-259.17235 230.00448,-231.31159 C 228.29044,-221.56803 220.74517,-217.49946 217.97627,-236.26022 C 210.0787,-233.77447 175.87876,-223.81635 169.17039,-241.15737 C 165.17722,-248.32467 173.48348,-276.12389 203.17522,-273.74212 z " />
-      <path
-         style="fill:url(#radialGradient1822);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         id="path1819"
-         d="M 220.74123,-214.1875 C 227.87764,-203.73841 231.28831,-190.18836 229.45998,-177.71875 C 222.3997,-165.39834 205.93726,-163.52328 193.05373,-164.75 C 194.11526,-173.29796 194.69425,-182.39807 193.51876,-190.98978 C 191.02311,-195.41909 199.33209,-197.29913 200.39748,-201.6875 C 203.70655,-208.92744 212.80427,-208.10966 218.04988,-213.3696 C 218.9201,-213.57294 220.00051,-215.94141 220.74123,-214.1875 z M 179.55373,-210.28125 C 180.69974,-204.97453 181.23339,-199.24919 184.58498,-194.75 C 179.40159,-187.81847 178.05976,-178.63643 176.67873,-170.28125 C 167.10271,-177.01707 169.81568,-190.62142 172.02963,-200.39411 C 173.03008,-204.26346 176.36728,-212.34166 179.19382,-211.77772 C 179.27177,-211.45363 179.5117,-210.45598 179.55373,-210.28125 z " />
-      <path
-         style="fill:url(#radialGradient1824);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="cccc"
-         id="path1823"
-         d="M 192.35803,-167.43887 C 192.50549,-184.13006 194.62485,-193.41727 188.91188,-194.64149 C 183.4148,-195.53491 180.34768,-176.21073 179.48415,-172.89901 C 176.29589,-156.88208 189.97283,-154.13044 192.35803,-167.43887 z " />
-      <path
-         style="fill:#1f4eb3;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
-         sodipodi:nodetypes="ccccc"
-         id="path1825"
-         d="M 185.2414,-200.53324 C 185.2414,-197.95291 187.25802,-195.85872 189.74278,-195.85872 C 192.22755,-195.85872 194.24417,-197.95291 194.24417,-200.53324 C 194.24417,-203.11357 193.61259,-209.36288 191.12783,-209.36288 C 188.64306,-209.36288 185.2414,-203.11357 185.2414,-200.53324 z " />
-      <path
-         style="fill:url(#radialGradient1828);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="ccccc"
-         id="path1827"
-         d="M 186.28018,-201.05263 C 186.28018,-198.4723 188.2968,-196.37811 190.78156,-196.37811 C 193.26633,-196.37811 195.28295,-198.4723 195.28295,-201.05263 C 195.28295,-203.63296 194.65137,-209.88227 192.16661,-209.88227 C 189.68184,-209.88227 186.28018,-203.63296 186.28018,-201.05263 z " />
-    </g>
-    <g
-       id="g5488"
-       transform="translate(601.5744,407.49165)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
-       inkscape:export-xdpi="35.529999"
-       inkscape:export-ydpi="35.529999">
-      <path
-         transform="matrix(6.392368,0.545409,-0.130014,2.864752,-184.6606,-38.15109)"
-         style="fill:url(#radialGradient5536);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:type="arc"
-         sodipodi:ry="12.562782"
-         sodipodi:rx="12.562782"
-         sodipodi:cy="37.865574"
-         sodipodi:cx="41.875938"
-         id="path5490"
-         d="M 54.438721 37.865574 A 12.562782 12.562782 0 1 1  29.313156,37.865574 A 12.562782 12.562782 0 1 1  54.438721 37.865574 z" />
-      <g
-         transform="matrix(1,0,0,1.036969,356.8306,-11.4294)"
-         style="fill:url(#linearGradient5538);fill-opacity:1"
-         id="g5492">
-        <path
-           style="fill:url(#linearGradient5540);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
-           id="path5494"
-           d="M -270.85787,33.814995 C -289.35564,33.925992 -307.93321,33.592782 -326.38104,33.981747 C -331.43469,35.696391 -331.02221,41.899652 -330.68524,46.15332 C -330.75782,60.227303 -330.53537,74.298225 -330.21167,88.36826 C -328.21297,91.039611 -323.21766,90.618387 -322.68469,94.539015 C -320.78054,96.259426 -317.05071,94.88215 -314.4389,95.333237 C -298.54999,95.360274 -282.66107,95.387302 -266.77215,95.414339 C -266.35587,90.465192 -260.12609,88.824447 -255.81783,89.540255 C -256.01688,89.058389 -261.69557,87.939375 -259.61591,84.491525 C -259.45681,68.72727 -259.19734,52.882199 -259.82064,37.168229 C -261.19394,32.980583 -267.34179,33.83368 -270.85787,33.814995 z M -236.65184,97.260473 C -234.79025,100.12642 -237.08724,103.09386 -239.92892,104.16357 C -242.6311,105.91539 -245.59105,107.62992 -248.52894,108.76804 C -253.1773,108.19079 -251.42424,101.88475 -255.01281,99.896645 C -260.33594,96.447012 -267.21045,98.43943 -273.23329,97.939231 C -291.8249,97.94887 -310.41651,97.958519 -329.00813,97.968158 C -335.45898,103.56578 -339.16595,111.40269 -341.55034,119.32178 C -337.25147,124.2061 -329.89606,122.27575 -324.10438,122.40002 C -298.64553,122.23171 -273.11679,122.61546 -247.69897,122.24542 C -243.40174,121.14669 -247.44685,114.84894 -243.58488,113.04441 C -242.73865,112.73374 -247.81245,114.4382 -247.26205,111.62955 C -245.49117,106.66028 -239.14113,105.99595 -235.92338,102.36811 C -234.39131,99.755669 -236.26958,96.922488 -238.33047,95.260495 C -237.77093,95.927151 -237.21138,96.593817 -236.65184,97.260473 z M -240.64255,111.75263 C -243.64086,113.13223 -237.02792,110.69536 -235.55512,111.97369 C -229.71113,112.74417 -224.16461,117.19625 -218.12358,115.22951 C -225.97639,116.31604 -232.799,109.03014 -240.64255,111.75263 z M -212.01083,112.33724 C -215.98173,113.85021 -208.21543,112.17765 -210.07883,115.87566 C -212.50961,119.93855 -206.99008,113.8662 -209.61436,112.54677 C -210.16198,111.94632 -211.27989,112.47663 -212.01083,112.33724 z M -213.97451,120.82946 C -220.13871,124.32615 -228.37873,119.08124 -233.85995,124.39439 C -238.36465,128.00055 -244.57099,130.35185 -247.0433,135.75122 C -247.65922,139.60202 -243.25109,141.90251 -240.44565,143.71808 C -235.60127,146.54512 -228.8227,145.75388 -225.20082,141.42836 C -220.62679,137.96117 -216.44182,134.08489 -212.48592,129.96782 C -212.82701,126.95048 -214.43694,123.63971 -213.97451,120.82946 z " />
-        <path
-           style="fill:url(#linearGradient5542);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
-           id="path5496"
-           d="M -269.68453,32.256957 C -288.76965,32.351184 -307.87514,32.249603 -326.94796,32.349264 C -332.63884,33.663474 -333.90446,40.291305 -333.21597,45.149113 C -333.11996,59.896901 -333.07471,74.659754 -332.61729,89.39481 C -331.88583,93.310348 -324.86009,92.098674 -325.11097,96.44089 C -328.07184,96.184706 -331.5534,96.317135 -333.07248,99.246492 C -338.92562,104.98392 -341.99312,112.66465 -344.27268,120.28679 C -340.22572,125.96631 -332.26467,125.31453 -326.02946,124.71751 C -300.16629,124.7277 -274.28316,124.82043 -248.43245,124.77905 C -244.42424,124.78686 -243.30672,120.35609 -243.96666,117.2099 C -242.88598,112.93536 -237.04086,113.94554 -233.80717,114.98513 C -228.01851,116.64297 -221.26418,120.43074 -215.57982,116.37592 C -211.36091,113.71809 -213.05678,118.4029 -215.77936,119.43344 C -220.82539,122.25797 -227.09125,118.98178 -232.39677,121.20855 C -236.53238,123.88957 -240.74707,126.85249 -244.76678,129.74666 C -248.34219,132.01467 -251.90947,137.38626 -248.13747,140.97315 C -243.79274,146.02948 -236.37425,149.4527 -229.68248,147.08651 C -225.09383,144.85973 -221.79206,140.75401 -217.61535,137.88661 C -215.10454,135.69469 -212.49235,133.26839 -210.83749,130.50207 C -210.86477,126.92195 -214.68529,121.91303 -210.252,119.57013 C -207.25619,117.95208 -205.81053,112.12098 -209.75314,110.87946 C -214.16982,109.44692 -216.95156,115.09837 -221.43751,113.68608 C -228.47365,112.76758 -235.5565,107.20489 -242.69931,110.72434 C -246.89551,113.06547 -243.47174,109.4356 -241.45524,108.56544 C -237.85613,106.84628 -232.73147,104.36798 -233.94637,99.617708 C -234.27189,95.083838 -239.22223,93.197522 -242.95318,91.723135 C -247.61613,89.074942 -253.27003,89.345117 -258.06082,86.933298 C -257.89248,70.385101 -257.58805,53.76423 -258.26571,37.261116 C -259.2092,32.393288 -265.59824,31.96057 -269.68453,32.256957 z M -258.66259,91.764016 C -251.5059,92.239344 -243.21163,93.474137 -238.58238,99.271629 C -238.96251,103.06003 -244.00295,103.80224 -246.52821,106.14082 C -248.92267,108.48087 -251.12372,105.80503 -251.02958,103.27159 C -252.70852,98.336432 -258.20582,95.710815 -263.31841,96.533197 C -267.00561,96.7255 -263.71935,91.937514 -261.395,92.380192 C -260.48382,92.178338 -259.57521,91.953759 -258.66259,91.764016 z " />
-        <path
-           style="fill:url(#linearGradient5544);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
-           sodipodi:nodetypes="ccccczccccccccccccccccccczccccc"
-           id="path5498"
-           d="M -324.0398,30.70877 C -336.3492,30.820231 -335.15663,39.652507 -334.79476,45.313268 C -334.5469,60.436643 -334.38614,75.599009 -334.01234,90.698281 C -333.20516,93.057424 -330.71249,93.985661 -328.75475,95.252079 C -334.4553,96.476239 -336.96996,102.43195 -340.11175,106.59303 C -342.33294,111.36531 -347.84019,115.92868 -345.92111,121.43642 C -344.00204,126.94416 -332.21757,127.68181 -324.95408,127.12866 C -299.06901,127.09789 -273.17022,127.14905 -247.29372,127.06713 C -243.29961,126.16956 -240.99668,122.03601 -241.4977,118.23645 C -238.30082,114.95371 -233.32521,118.03039 -229.53292,118.63002 C -225.71641,119.31313 -232.5646,119.27527 -233.19362,120.54849 C -238.23604,122.95799 -242.6166,126.65447 -246.90973,130.10509 C -250.44674,132.97354 -252.4229,138.10741 -249.57412,142.08235 C -246.21315,145.92284 -241.41489,148.84284 -236.30395,149.79628 C -230.65487,150.83779 -225.57101,147.82678 -221.6157,144.24077 C -216.87391,140.59839 -212.0873,136.78287 -208.84361,131.80554 C -207.76302,128.26399 -211.47449,123.86671 -208.08348,121.09796 C -204.93438,118.46115 -204.06893,113.02076 -207.41836,110.2673 C -212.81988,106.81278 -218.36682,114.55112 -223.89705,111.29128 C -227.94209,110.1659 -231.91311,108.52596 -236.17676,108.45194 C -231.52711,105.88023 -229.62903,98.782331 -234.08944,95.153402 C -239.61551,89.404431 -248.455,88.793917 -255.40182,85.744487 C -255.86992,78.940296 -255.53665,71.972758 -255.70928,65.098797 C -255.80747,55.730822 -255.73864,46.312632 -255.94025,36.975777 C -258.03631,31.236293 -265.34014,30.439522 -270.76286,30.729689 C -289.40725,30.770714 -311.88665,30.597309 -324.0398,30.70877 z M -255.46516,94.482857 C -250.34561,95.62106 -244.69322,96.21649 -240.83258,100.05203 C -242.37635,102.55028 -245.27573,103.64481 -247.80048,104.97505 C -249.71506,99.684643 -254.39847,94.970039 -260.51378,95.138259 C -260.66903,94.131274 -256.73261,94.551178 -255.46516,94.482857 z " />
-      </g>
-      <rect
-         y="78.658051"
-         x="33.326111"
-         width="57.567924"
-         style="fill:url(#linearGradient5546);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient5548);stroke-width:1.44734821pt"
-         id="rect5500"
-         height="8.3153667" />
-      <path
-         style="fill:url(#linearGradient5550);fill-rule:evenodd;stroke-width:0.90459263;stroke-opacity:0.07438019"
-         sodipodi:nodetypes="czzczczzzzzzzc"
-         id="path5502"
-         d="M 98.723806,78.927818 C 95.18666,77.759681 93.50122,82.555591 98.766686,81.004087 C 104.03217,79.452583 120.13123,85.906451 120.37383,89.795491 C 120.61643,93.905503 101.5003,98.581154 106.74108,104.42426 C 111.62816,110.70149 115.35468,100.13868 123.54696,104.21261 C 131.73923,108.17607 136.26048,109.72394 142.25488,104.94185 C 149.10027,101.9342 145.04599,107.07658 139.57918,113.60451 C 134.11237,120.13244 144.00251,115.08156 147.91225,105.31962 C 151.93248,95.557673 139.13128,107.33503 133.66268,105.40571 C 128.19408,103.47639 119.73678,97.849788 113.27625,102.55563 C 106.81572,107.26147 109.62894,99.493003 114.85637,97.90307 C 120.0838,96.092166 122.81363,93.045722 122.85597,90.161522 C 122.89831,87.498293 117.92629,84.811803 112.94229,82.402852 C 107.73732,79.993901 100.49788,78.588966 98.723806,78.927818 z " />
-      <path
-         style="fill:url(#linearGradient5552);fill-opacity:1;fill-rule:evenodd;stroke-width:1.44734821pt"
-         sodipodi:nodetypes="czzzzzzzz"
-         id="path5504"
-         d="M 15.102732,106.80712 C 13.80355,109.23224 17.148847,113.52338 19.900059,113.52338 L 107.85106,113.52338 C 110.18914,113.52338 113.70766,110.4906 112.64839,108.40622 L 102.7339,88.897093 C 101.97024,87.394398 100.26184,86.65834 98.576216,86.65834 L 28.215425,86.658339 C 26.825434,86.658339 25.353768,87.671846 24.697385,88.897093 L 15.102732,106.80712 z " />
-      <rect
-         y="22.413721"
-         x="26.015469"
-         width="72.279724"
-         style="fill:url(#linearGradient5554);fill-opacity:1;fill-rule:evenodd;stroke-width:1.62826681"
-         ry="5.4369707"
-         rx="5.4369707"
-         id="rect5506"
-         height="60.126495" />
-      <rect
-         y="31.695871"
-         x="33.386066"
-         width="58.178177"
-         style="fill:url(#radialGradient5556);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient5558);stroke-width:1.4649456pt"
-         id="rect5508"
-         height="38.044163" />
-      <path
-         style="fill:url(#linearGradient5560);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="czzccccc"
-         id="path5510"
-         d="M 27.690431,52.841444 L 27.370609,74.749236 C 27.319624,78.241665 29.310209,80.477938 32.807578,80.506029 L 72.625393,80.825852 L 76.463254,71.87084 L 32.008024,71.55102 L 31.688202,52.681533 L 27.690431,52.841444 z " />
-      <g
-         transform="matrix(-1,0,0,1,125.4301,0)"
-         id="g5512">
-        <path
-           style="fill:url(#linearGradient5562);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-           sodipodi:nodetypes="czzccc"
-           id="path5514"
-           d="M 42.062098,33.460351 L 77.341205,33.008055 C 82.787126,32.938235 89.553204,38.416797 89.553204,43.863165 L 89.553204,60.14583 L 41.609801,59.693534 L 42.062098,33.460351 z " />
-        <path
-           style="fill:url(#linearGradient5564);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-           sodipodi:nodetypes="czzccc"
-           id="path5516"
-           d="M 78.337784,67.629235 L 46.723745,67.724544 C 41.843589,67.739257 35.829319,62.771024 35.877168,57.891081 L 36.020221,43.301821 L 78.973514,44.128288 L 78.337784,67.629235 z " />
-      </g>
-      <path
-         style="fill:url(#linearGradient5566);fill-opacity:1;fill-rule:evenodd;stroke-width:0.72367412;stroke-opacity:0.34710741"
-         sodipodi:nodetypes="cczzzzzzc"
-         id="path5518"
-         d="M 137.39107,112.02341 C 137.39107,112.02341 129.0757,110.26438 123.63872,113.62251 C 118.20176,116.98064 109.96635,123.21719 108.76702,124.81628 C 107.40777,126.57531 107.42036,130.22796 109.24674,131.53253 L 114.84364,135.53031 C 118.31797,138.01198 124.86218,139.25396 128.11624,136.48978 L 142.98795,123.85681 C 144.79792,122.3193 145.72732,118.27921 144.10733,116.82073 C 142.95609,115.04975 140.4892,112.91939 137.39107,112.02341 z " />
-      <path
-         style="fill:url(#linearGradient5568);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="czzzzzc"
-         id="path5520"
-         d="M 142.3483,121.13833 L 125.91043,133.59673 C 122.97154,135.82414 118.65484,134.11775 116.28283,133.77129 C 113.9108,133.42481 111.88528,131.87901 112.12516,132.33209 C 112.36503,132.78517 115.08349,135.71687 117.72203,136.48978 C 120.36055,137.26267 124.9543,138.89307 127.50953,136.15531 C 130.06477,133.41755 145.2267,123.53699 142.3483,121.13833 z " />
-      <path
-         style="fill:url(#linearGradient5570);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="cczc"
-         id="path5522"
-         d="M 132.11225,127.51984 C 135.31047,122.88242 120.11893,113.12786 109.08509,127.0401 C 110.20446,130.71805 116.80662,132.5992 121.82304,132.33547 C 126.68363,132.07993 129.50037,129.97181 132.11225,127.51984 z " />
-      <path
-         style="fill:url(#linearGradient5572);fill-opacity:1;fill-rule:evenodd;stroke-width:1.08551121"
-         sodipodi:nodetypes="cccccccc"
-         id="path5524"
-         d="M 138.63464,112.68306 C 135.9958,113.22749 132.31739,114.43079 129.87534,116.38362 C 128.77009,115.68011 125.32759,114.5677 123.66767,113.84494 L 123.24572,114.10517 C 129.67287,117.23476 136.43512,117.91249 135.88192,122.87668 C 136.33675,122.98575 137.05589,123.09702 136.73191,122.38863 C 136.41775,118.90392 132.50587,117.23351 131.02697,116.81532 C 133.17224,114.26602 136.255,113.70892 138.63464,112.68306 z " />
-      <path
-         style="fill:url(#linearGradient5574);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="czzzzzzzz"
-         id="path5526"
-         d="M 18.891612,106.48414 C 17.978451,108.31614 19.173914,111.55774 22.263529,111.55774 L 105.0195,111.55774 C 106.66288,111.55774 109.13595,109.26672 108.39142,107.69215 L 101.42279,92.954575 C 100.88602,91.819403 99.685232,91.263378 98.500462,91.263378 L 28.108183,91.263369 C 27.131195,91.263369 26.0968,92.028994 25.635445,92.954575 L 18.891612,106.48414 z " />
-      <text
-         y="-14.660837"
-         xml:space="preserve"
-         x="6.147172"
-         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
-         id="text5528"><tspan
-           id="tspan5530">Computer</tspan></text>
-      <text
-         y="-34.951134"
-         xml:space="preserve"
-         x="84.564949"
-         transform="scale(0.246729,0.246729)"
-         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
-         id="text5532"><tspan
-           id="tspan5534">Created by Andrew Fitzsimon</tspan></text>
-    </g>
-    <g
-       id="g6024"
-       transform="matrix(-1,0,0,1,900.16045,422.61731)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
-       inkscape:export-xdpi="35.529999"
-       inkscape:export-ydpi="35.529999">
-      <path
-         transform="translate(2.509562,-4.432856e-2)"
-         style="fill:#ffffff;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="cccc"
-         id="path6027"
-         d="M 60.545133,72.847539 C 65.294534,78.031101 68.316881,87.318315 75.00922,87.318316 C 81.485677,85.518467 82.349205,70.11177 83.212732,66.800051 C 75.872748,71.839624 68.316882,74.71938 60.545133,72.847539 z " />
-      <path
-         transform="translate(2.509562,-4.432856e-2)"
-         style="fill:#d20000;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="ccssssc"
-         id="path6029"
-         d="M 31.546762,99.654209 C 31.156121,124.85047 95.78552,127.73183 95.62922,99.654209 C 97.174007,77.325462 86.068776,64.629762 83.309105,66.788232 C 81.907864,67.884209 81.387229,92.223995 71.919297,86.625353 C 67.316417,83.903554 62.167959,73.44849 59.915352,73.101625 C 56.516277,72.578221 50.007529,69.826123 44.029815,64.675414 C 42.461522,63.324094 32.076211,77.214403 31.546762,99.654209 z " />
-      <path
-         style="fill:url(#radialGradient2797);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         id="path2796"
-         d="M 43.53125,77.3125 C 40.353026,86.016409 37.202011,96.366079 40.377303,105.23542 C 48.984655,117.18204 66.049398,117.25223 79.222417,115.04972 C 88.094278,113.47345 96.636121,105.87972 94.744454,96.188658 C 94.751182,88.561019 93.319573,80.643142 89.09375,74.1875 C 87.954705,81.120157 85.706152,92.347929 76.686643,91.786583 C 66.841974,89.84774 65.058803,76.33878 54.747596,75.105769 C 49.945701,71.530053 45.566465,69.110698 43.783935,76.852875 L 43.53125,77.3125 z " />
-      <path
-         transform="matrix(0.440859,0,0,0.441062,0.997459,16.38124)"
-         style="fill:#efd7c7;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:type="arc"
-         sodipodi:ry="57.825485"
-         sodipodi:rx="60.94183"
-         sodipodi:cy="70.290855"
-         sodipodi:cx="150.27701"
-         id="path6032"
-         d="M 211.21884 70.290855 A 60.94183 57.825485 0 1 1  89.335178,70.290855 A 60.94183 57.825485 0 1 1  211.21884 70.290855 z" />
-      <path
-         transform="translate(2.509562,-4.432856e-2)"
-         style="fill:#000000;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="cccccc"
-         id="path3720"
-         d="M 56.980881,5.8426527 C 39.420698,8.0166254 30.552872,16.206245 24.211446,49.532095 C 14.512196,98.076517 21.871677,115.5525 32.990311,115.56714 C 17.54932,102.40769 63.877625,86.740105 56.295103,44.070713 C 68.4508,48.712358 94.51097,54.349644 95.164349,41.718703 C 97.176702,29.219492 88.64173,4.4775042 56.980881,5.8426527 z " />
-      <path
-         style="fill:url(#linearGradient2789);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         id="path2164"
-         d="M 60.687242,45.028999 C 62.530882,55.403773 61.180052,64.151015 58.312242,71.685249 C 61.630122,73.07804 65.296862,73.904 69.155992,73.903999 C 83.975322,73.903999 95.981712,62.468019 95.999742,48.403999 C 88.357632,52.885439 70.244092,48.678277 60.687242,45.028999 z " />
-      <path
-         style="fill:url(#radialGradient2791);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         id="path2790"
-         d="M 52.174948,8.1325312 C 35.846775,12.141346 31.110158,30.475875 28.060647,44.840387 C 24.465246,64.767005 19.485139,85.90438 25.518698,105.82003 C 29.863591,114.87216 28.026452,106.52571 31.049538,102.11795 C 41.311249,87.323083 56.256862,73.307418 55.936774,53.886064 C 56.647391,49.398848 52.34734,38.640985 60.701717,42.254379 C 70.683443,45.202557 82.078811,49.011247 92.143698,44.632531 C 96.945103,37.45042 93.288237,27.137344 88.876323,20.399742 C 81.135092,8.5919962 65.300885,5.0194752 52.174948,8.1325312 z " />
-    </g>
-    <path
-       style="fill:none;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:4.63842154;stroke-linecap:butt;stroke-linejoin:round;stroke-dasharray:none;stroke-opacity:1"
-       sodipodi:nodetypes="cccccccccccc"
-       id="path699"
-       d="M 319.16674,325.66524 L 432.27399,313.12251 L 422.57906,332.08242 L 484.9028,325.95688 C 484.9028,325.95688 494.59773,306.41369 495.05931,306.41369 C 495.52148,306.41369 517.68079,331.79078 517.68079,331.79078 C 517.68079,331.79078 465.51355,358.33479 465.05197,358.33479 C 465.51355,358.91808 474.74689,339.66616 474.74689,339.37453 L 402.72705,345.79207 L 412.42255,326.24852 L 309.01023,338.4996 L 319.16674,325.66524 z "
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
-       inkscape:export-xdpi="35.529999"
-       inkscape:export-ydpi="35.529999" />
-    <text
-       xml:space="preserve"
-       style="font-size:48px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont;font-stretch:normal;font-variant:normal;text-anchor:start;text-align:start;writing-mode:lr;line-height:125%"
-       x="140"
-       y="521.23737"
-       id="text7612"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
-       inkscape:export-xdpi="35.529999"
-       inkscape:export-ydpi="35.529999"><tspan
-         sodipodi:role="line"
-         id="tspan7614"
-         x="140"
-         y="521.23737">Server</tspan></text>
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="763.75"
-       y="188.09448"
-       id="text7877"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
-       inkscape:export-xdpi="35.529999"
-       inkscape:export-ydpi="35.529999"><tspan
-         sodipodi:role="line"
-         id="tspan7879"
-         x="763.75"
-         y="188.09448">bzr commit --local</tspan><tspan
-         sodipodi:role="line"
-         x="763.75"
-         y="228.09448"
-         id="tspan7922" /></text>
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="801.4375"
-       y="609.46948"
-       id="text7881"
-       sodipodi:linespacing="100%"><tspan
-         sodipodi:role="line"
-         id="tspan7883"
-         x="801.4375"
-         y="609.46948">bzr unbind</tspan><tspan
-         sodipodi:role="line"
-         x="801.4375"
-         y="641.46948"
-         id="tspan8507">bzr commit</tspan><tspan
-         sodipodi:role="line"
-         x="801.4375"
-         y="673.46948"
-         id="tspan8511">bzr bind</tspan></text>
-    <g
-       id="g7903"
-       transform="translate(21.8125,50.285718)">
-      <path
-         transform="matrix(0.5652174,0,0,0.5909091,121.25465,81.649039)"
-         d="M 340 221.23734 A 32.857143 31.428572 0 1 1  274.28571,221.23734 A 32.857143 31.428572 0 1 1  340 221.23734 z"
-         sodipodi:ry="31.428572"
-         sodipodi:rx="32.857143"
-         sodipodi:cy="221.23734"
-         sodipodi:cx="307.14285"
-         id="path7897"
-         style="fill:#000000"
-         sodipodi:type="arc" />
-      <text
-         sodipodi:linespacing="125%"
-         id="text7899"
-         y="225.53198"
-         x="286.3125"
-         style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-         xml:space="preserve"><tspan
-           y="225.53198"
-           x="286.3125"
-           id="tspan7901"
-           sodipodi:role="line">1</tspan></text>
-    </g>
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="351.375"
-       y="272.69269"
-       id="text7908"
-       sodipodi:linespacing="100%"><tspan
-         sodipodi:role="line"
-         id="tspan7910"
-         x="351.375"
-         y="272.69269">bzr checkout</tspan></text>
-    <g
-       id="g7912"
-       transform="translate(438.71429,-31.85714)">
-      <path
-         transform="matrix(0.5652174,0,0,0.5909091,121.25465,81.649039)"
-         d="M 340 221.23734 A 32.857143 31.428572 0 1 1  274.28571,221.23734 A 32.857143 31.428572 0 1 1  340 221.23734 z"
-         sodipodi:ry="31.428572"
-         sodipodi:rx="32.857143"
-         sodipodi:cy="221.23734"
-         sodipodi:cx="307.14285"
-         id="path7914"
-         style="fill:#000000"
-         sodipodi:type="arc" />
-      <text
-         sodipodi:linespacing="125%"
-         id="text7916"
-         y="225.53198"
-         x="286.3125"
-         style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-         xml:space="preserve"><tspan
-           y="225.53198"
-           x="286.3125"
-           id="tspan7918"
-           sodipodi:role="line">2</tspan></text>
-    </g>
-    <path
-       style="fill:none;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:4.58159733;stroke-linecap:butt;stroke-linejoin:round;stroke-dasharray:none;stroke-opacity:1"
-       sodipodi:nodetypes="cccccccccccc"
-       id="path8495"
-       d="M 530.64409,443.90791 L 411.93077,455.56731 L 422.10621,437.94266 L 356.69344,443.63682 C 356.69344,443.63682 346.51796,461.80368 346.0335,461.80368 C 345.54844,461.80368 322.2908,438.21377 322.2908,438.21377 C 322.2908,438.21377 377.0437,413.53911 377.52817,413.53911 C 377.0437,412.99691 367.35272,430.89301 367.35272,431.16411 L 442.94217,425.19852 L 432.76613,443.36572 L 541.30393,431.97742 L 530.64409,443.90791 z " />
-    <g
-       id="g8497"
-       transform="translate(446.57144,390.28572)">
-      <path
-         transform="matrix(0.5652174,0,0,0.5909091,121.25465,81.649039)"
-         d="M 340 221.23734 A 32.857143 31.428572 0 1 1  274.28571,221.23734 A 32.857143 31.428572 0 1 1  340 221.23734 z"
-         sodipodi:ry="31.428572"
-         sodipodi:rx="32.857143"
-         sodipodi:cy="221.23734"
-         sodipodi:cx="307.14285"
-         id="path8499"
-         style="fill:#000000"
-         sodipodi:type="arc" />
-      <text
-         sodipodi:linespacing="125%"
-         id="text8501"
-         y="225.53198"
-         x="286.3125"
-         style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-         xml:space="preserve"><tspan
-           y="225.53198"
-           x="286.3125"
-           id="tspan8503"
-           sodipodi:role="line">2</tspan></text>
-    </g>
-    <g
-       id="g8513"
-       transform="translate(59.142865,311.71429)">
-      <path
-         transform="matrix(0.5652174,0,0,0.5909091,121.25465,81.649039)"
-         d="M 340 221.23734 A 32.857143 31.428572 0 1 1  274.28571,221.23734 A 32.857143 31.428572 0 1 1  340 221.23734 z"
-         sodipodi:ry="31.428572"
-         sodipodi:rx="32.857143"
-         sodipodi:cy="221.23734"
-         sodipodi:cx="307.14285"
-         id="path8515"
-         style="fill:#000000"
-         sodipodi:type="arc" />
-      <text
-         sodipodi:linespacing="125%"
-         id="text8517"
-         y="225.53198"
-         x="286.3125"
-         style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-         xml:space="preserve"><tspan
-           y="225.53198"
-           x="286.3125"
-           id="tspan8519"
-           sodipodi:role="line">3</tspan></text>
-    </g>
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="389.375"
-       y="534.40698"
-       id="text8525"
-       sodipodi:linespacing="100%"><tspan
-         sodipodi:role="line"
-         id="tspan8527"
-         x="389.375"
-         y="534.40698">bzr commit</tspan></text>
-  </g>
-</svg>

=== removed file 'doc/en/user-guide/images/workflows_peer.png'
Binary files doc/en/user-guide/images/workflows_peer.png and doc/en/user-guide/images/workflows_peer.png differ
=== removed file 'doc/en/user-guide/images/workflows_peer.svg'
--- doc/en/user-guide/images/workflows_peer.svg	2007-11-30 04:34:08 +0000
+++ doc/en/user-guide/images/workflows_peer.svg	1970-01-01 00:00:00 +0000
@@ -1,1589 +0,0 @@
-<?xml version="1.0" encoding="UTF-8" standalone="no"?>
-<!-- Created with Inkscape (http://www.inkscape.org/) -->
-<svg
-   xmlns:dc="http://purl.org/dc/elements/1.1/"
-   xmlns:cc="http://web.resource.org/cc/"
-   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
-   xmlns:svg="http://www.w3.org/2000/svg"
-   xmlns="http://www.w3.org/2000/svg"
-   xmlns:xlink="http://www.w3.org/1999/xlink"
-   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"
-   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"
-   width="1052.3622"
-   height="744.09448"
-   id="svg2"
-   sodipodi:version="0.32"
-   inkscape:version="0.45.1"
-   version="1.0"
-   sodipodi:docbase="/home/ian/Desktop/talk/workflows"
-   sodipodi:docname="workflows_peer.svg"
-   inkscape:output_extension="org.inkscape.output.svg.inkscape"
-   inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_peer.png"
-   inkscape:export-xdpi="90"
-   inkscape:export-ydpi="90">
-  <defs
-     id="defs4">
-    <radialGradient
-       xlink:href="#linearGradient5992"
-       r="33.156250"
-       inkscape:collect="always"
-       id="radialGradient6000"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(1.000000,0.000000,0.000000,1.693685,0.000000,-197.9515)"
-       fy="285.36218"
-       fx="495.50000"
-       cy="285.36218"
-       cx="495.50000" />
-    <linearGradient
-       y2="187.57059"
-       y1="225.40080"
-       xlink:href="#linearGradient5963"
-       x2="458.91232"
-       x1="383.95898"
-       inkscape:collect="always"
-       id="linearGradient5969"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       id="linearGradient3586">
-      <stop
-         style="stop-color:#000000;stop-opacity:1.0000000;"
-         offset="0.0000000"
-         id="stop3588" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0;"
-         offset="1"
-         id="stop3590" />
-    </linearGradient>
-    <linearGradient
-       inkscape:collect="always"
-       id="linearGradient5963">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:1;"
-         offset="0"
-         id="stop5965" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0;"
-         offset="1"
-         id="stop5967" />
-    </linearGradient>
-    <linearGradient
-       inkscape:collect="always"
-       id="linearGradient5992">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:1;"
-         offset="0"
-         id="stop5994" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0;"
-         offset="1"
-         id="stop5996" />
-    </linearGradient>
-    <linearGradient
-       y2="-0.45783132"
-       y1="3.3012049"
-       xlink:href="#linearGradient893"
-       x2="0.92957747"
-       x1="-2.3960868e-17"
-       id="linearGradient4284" />
-    <linearGradient
-       y2="-0.033519555"
-       y1="2.0837989"
-       xlink:href="#linearGradient893"
-       x2="0.99074072"
-       x1="-0.77314812"
-       id="linearGradient4283" />
-    <linearGradient
-       y2="1.8771822"
-       y1="-0.033741195"
-       xlink:href="#linearGradient902"
-       x2="0.48453596"
-       x1="0.47041038"
-       id="linearGradient2740"
-       gradientTransform="scale(0.997153,1.002855)" />
-    <linearGradient
-       y2="1.9025002"
-       y1="-0.043652620"
-       xlink:href="#linearGradient902"
-       x2="0.48481107"
-       x1="0.47042510"
-       id="linearGradient1506"
-       gradientTransform="scale(0.995847,1.004170)" />
-    <linearGradient
-       y2="1.8570156"
-       y1="-0.024853170"
-       xlink:href="#linearGradient902"
-       x2="0.48548824"
-       x1="0.47157744"
-       id="linearGradient1505"
-       gradientTransform="scale(0.997825,1.002180)" />
-    <linearGradient
-       y2="182.99154"
-       y1="169.09755"
-       xlink:href="#linearGradient892"
-       x2="88.996957"
-       x1="88.755695"
-       id="linearGradient1404"
-       gradientTransform="scale(1.3695887,0.7301462)"
-       gradientUnits="userSpaceOnUse" />
-    <radialGradient
-       xlink:href="#linearGradient1317"
-       r="0.34964636"
-       id="radialGradient1316"
-       fy="0.18269235"
-       fx="0.50352114"
-       cy="0.50000006"
-       cx="0.50000000" />
-    <radialGradient
-       xlink:href="#linearGradient1317"
-       r="0.41197181"
-       id="radialGradient1315"
-       fy="0.26666668"
-       fx="0.47535211"
-       cy="0.53333336"
-       cx="0.47887325" />
-    <linearGradient
-       y2="173.03153"
-       y1="177.77768"
-       xlink:href="#linearGradient902"
-       x2="95.100155"
-       x1="101.10657"
-       id="linearGradient1171"
-       gradientTransform="scale(1.3601783,0.7351977)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="1.8378206"
-       y1="-0.016295359"
-       xlink:href="#linearGradient902"
-       x2="0.48655096"
-       x1="0.47284532"
-       id="linearGradient1170"
-       gradientTransform="scale(0.998371,1.001632)" />
-    <linearGradient
-       y2="81.477602"
-       y1="224.57898"
-       xlink:href="#linearGradient893"
-       x2="74.533693"
-       x1="146.69923"
-       id="linearGradient1169"
-       gradientTransform="scale(1.1870691,0.842411)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="133.54711"
-       y1="228.39311"
-       xlink:href="#linearGradient888"
-       x2="88.447016"
-       x1="141.60217"
-       id="linearGradient1167"
-       gradientTransform="scale(1.1838753,0.8446836)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="148.78619"
-       y1="131.25248"
-       xlink:href="#linearGradient1317"
-       x2="107.04918"
-       x1="111.49758"
-       id="linearGradient1166"
-       gradientTransform="scale(1.223869,0.8170809)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="176.28694"
-       y1="269.85831"
-       xlink:href="#linearGradient888"
-       x2="-16.224496"
-       x1="51.460928"
-       id="linearGradient1157"
-       gradientTransform="scale(2.4217071,0.4129318)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="234.26866"
-       y1="178.48862"
-       xlink:href="#linearGradient888"
-       x2="25.220815"
-       x1="25.220815"
-       id="linearGradient1156"
-       gradientTransform="scale(2.4217071,0.4129318)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="105.42543"
-       y1="76.277559"
-       xlink:href="#linearGradient892"
-       x2="8.346058"
-       x1="35.190362"
-       id="linearGradient1150"
-       gradientTransform="scale(1.3283861,0.7527932)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="20.481863"
-       y1="49.507656"
-       xlink:href="#linearGradient892"
-       x2="70.224305"
-       x1="39.690614"
-       id="linearGradient1148"
-       gradientTransform="scale(1.329144,0.7523639)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="113.71949"
-       y1="90.197025"
-       xlink:href="#linearGradient892"
-       x2="17.876529"
-       x1="39.810948"
-       id="linearGradient1146"
-       gradientTransform="scale(1.3207392,0.7571517)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="251.21892"
-       y1="203.499"
-       xlink:href="#linearGradient892"
-       x2="31.617281"
-       x1="31.449743"
-       id="linearGradient1144"
-       gradientTransform="scale(2.1051174,0.4750329)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="-0.45783132"
-       y1="3.3012049"
-       xlink:href="#linearGradient888"
-       x2="0.92957747"
-       x1="0.00000000"
-       id="linearGradient1141" />
-    <linearGradient
-       y2="232.24952"
-       y1="110.4447"
-       xlink:href="#linearGradient888"
-       x2="41.967061"
-       x1="45.685757"
-       id="linearGradient1140"
-       gradientTransform="scale(1.9102155,0.5235012)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="75.912531"
-       y1="375.92199"
-       xlink:href="#linearGradient1806"
-       x2="-268.25407"
-       x1="-249.72067"
-       id="linearGradient1138"
-       gradientTransform="scale(1.087146,0.9198397)"
-       gradientUnits="userSpaceOnUse" />
-    <radialGradient
-       xlink:href="#linearGradient1133"
-       r="68.589222"
-       id="radialGradient1132"
-       fy="39.288476"
-       fx="72.107883"
-       cy="56.485935"
-       cx="60.004654"
-       gradientTransform="scale(1.2267534,0.8151598)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="11.699047"
-       y1="208.43991"
-       xlink:href="#linearGradient888"
-       x2="95.644441"
-       x1="-77.726178"
-       id="linearGradient905"
-       gradientTransform="scale(1.0964158,0.9120627)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       xlink:href="#linearGradient1806"
-       id="linearGradient901" />
-    <linearGradient
-       y2="91.07699"
-       y1="-3.9104078"
-       xlink:href="#linearGradient888"
-       x2="27.674331"
-       x1="92.437968"
-       id="linearGradient891"
-       gradientTransform="scale(1.2267534,0.8151598)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       id="linearGradient888">
-      <stop
-         style="stop-color:#626262;stop-opacity:1.0000000;"
-         offset="0.0000000"
-         id="stop889" />
-      <stop
-         style="stop-color:#fff;stop-opacity:1;"
-         offset="1"
-         id="stop890" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient892">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.00000000;"
-         offset="0.00000000"
-         id="stop893" />
-      <stop
-         style="stop-color:#fff;stop-opacity:1;"
-         offset="1"
-         id="stop894" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient902">
-      <stop
-         style="stop-color:#000000;stop-opacity:0.00000000;"
-         offset="0.00000000"
-         id="stop903" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0.22000000;"
-         offset="1.0000000"
-         id="stop904" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient1098">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:1.0000000;"
-         offset="0.00000000"
-         id="stop1099" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.22314049;"
-         offset="0.50000000"
-         id="stop1101" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.00000000;"
-         offset="0.59930235"
-         id="stop1102" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.60330576;"
-         offset="1.0000000"
-         id="stop1100" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient1133">
-      <stop
-         style="stop-color:#8bb7df;stop-opacity:1.0000000;"
-         offset="0.00000000"
-         id="stop1134" />
-      <stop
-         style="stop-color:#2a6092;stop-opacity:1.0000000;"
-         offset="0.76209301"
-         id="stop1136" />
-      <stop
-         style="stop-color:#375e82;stop-opacity:1.0000000;"
-         offset="1.0000000"
-         id="stop1135" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient1317">
-      <stop
-         style="stop-color:#000000;stop-opacity:0.52892560;"
-         offset="0.00000000"
-         id="stop1318" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0.17355372;"
-         offset="0.50000000"
-         id="stop1320" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0.00000000;"
-         offset="1.0000000"
-         id="stop1319" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient893">
-      <stop
-         style="stop-color:#000;stop-opacity:1;"
-         offset="0"
-         id="stop895" />
-      <stop
-         style="stop-color:#fff;stop-opacity:1;"
-         offset="1"
-         id="stop896" />
-    </linearGradient>
-    <radialGradient
-       xlink:href="#linearGradient1806"
-       r="11.574221"
-       id="radialGradient1977"
-       fy="39.410465"
-       fx="42.280806"
-       cy="39.007645"
-       cx="42.007257"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       id="linearGradient1806">
-      <stop
-         style="stop-color:#000000;stop-opacity:0.35051546;"
-         offset="0.0000000"
-         id="stop1807" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0.13402061;"
-         offset="0.64999998"
-         id="stop3276" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop1808" />
-    </linearGradient>
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient5281"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient5283"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient5285"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <radialGradient
-       xlink:href="#linearGradient4362"
-       r="5.5130484"
-       inkscape:collect="always"
-       id="radialGradient1828"
-       fy="61.38567"
-       fx="86.542037"
-       cy="61.38567"
-       cx="86.542037"
-       gradientTransform="matrix(-0.8164966,0,0,1.2247449,262.80373,-280)"
-       gradientUnits="userSpaceOnUse" />
-    <radialGradient
-       xlink:href="#linearGradient4362"
-       r="11.123441"
-       inkscape:collect="always"
-       id="radialGradient1824"
-       fy="58.887858"
-       fx="118.06427"
-       cy="58.54025"
-       cx="117.17439"
-       gradientTransform="matrix(-0.6229142,0,0,1.6053575,262.80373,-280)"
-       gradientUnits="userSpaceOnUse" />
-    <radialGradient
-       xlink:href="#linearGradient4362"
-       r="22.00904"
-       inkscape:collect="always"
-       id="radialGradient1822"
-       fy="87.892895"
-       fx="45.50637"
-       cy="88.322677"
-       cx="45.139623"
-       gradientTransform="matrix(-1.0914815,0,0,0.9161859,262.80373,-280)"
-       gradientUnits="userSpaceOnUse" />
-    <radialGradient
-       xlink:href="#linearGradient4362"
-       r="18.836343"
-       inkscape:collect="always"
-       id="radialGradient1818"
-       fy="33.351633"
-       fx="48.40165"
-       cy="32.467054"
-       cx="48.40165"
-       gradientTransform="matrix(-1.1146027,0,0,0.8971807,262.80373,-280)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="74.834393"
-       y1="57.093738"
-       xlink:href="#linearGradient4376"
-       x2="50.203204"
-       x1="50.52668"
-       inkscape:collect="always"
-       id="linearGradient1815"
-       gradientTransform="matrix(-1.3516689,0,0,0.7398261,262.80373,-280)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       id="linearGradient4384">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.77513230;"
-         offset="0.0000000"
-         id="stop4385" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop4386" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient4376">
-      <stop
-         style="stop-color:#000000;stop-opacity:0.52645504;"
-         offset="0.0000000"
-         id="stop4377" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop4378" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient4362">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.66666669;"
-         offset="0.0000000"
-         id="stop4363" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop4364" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient4358">
-      <stop
-         style="stop-color:#000;stop-opacity:1;"
-         offset="0"
-         id="stop4359" />
-      <stop
-         style="stop-color:#fff;stop-opacity:1;"
-         offset="1"
-         id="stop4360" />
-    </linearGradient>
-    <radialGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="radialGradient5536"
-       gradientUnits="userSpaceOnUse"
-       cx="42.007257"
-       cy="39.007645"
-       fx="42.280806"
-       fy="39.410465"
-       r="11.574221" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient5538"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient5540"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient5542"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient5544"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient888"
-       id="linearGradient5546"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(2.4217071,0.4129318)"
-       x1="25.220815"
-       y1="178.48862"
-       x2="25.220815"
-       y2="234.26866" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient888"
-       id="linearGradient5548"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(2.4217071,0.4129318)"
-       x1="51.460928"
-       y1="269.85831"
-       x2="-16.224496"
-       y2="176.28694" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient893"
-       id="linearGradient5550"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.1870691,0.842411)"
-       x1="146.69923"
-       y1="224.57898"
-       x2="74.533693"
-       y2="81.477602" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient888"
-       id="linearGradient5552"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.9102155,0.5235012)"
-       x1="45.685757"
-       y1="110.4447"
-       x2="41.967061"
-       y2="232.24952" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient888"
-       id="linearGradient5554"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.0964158,0.9120627)"
-       x1="-77.726178"
-       y1="208.43991"
-       x2="95.644441"
-       y2="11.699047" />
-    <radialGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1133"
-       id="radialGradient5556"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.2267534,0.8151598)"
-       cx="60.004654"
-       cy="56.485935"
-       fx="72.107883"
-       fy="39.288476"
-       r="68.589222" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient888"
-       id="linearGradient5558"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.2267534,0.8151598)"
-       x1="92.437968"
-       y1="-3.9104078"
-       x2="27.674331"
-       y2="91.07699" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient892"
-       id="linearGradient5560"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.3207392,0.7571517)"
-       x1="39.810948"
-       y1="90.197025"
-       x2="17.876529"
-       y2="113.71949" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient892"
-       id="linearGradient5562"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.329144,0.7523639)"
-       x1="39.690614"
-       y1="49.507656"
-       x2="70.224305"
-       y2="20.481863" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient892"
-       id="linearGradient5564"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.3283861,0.7527932)"
-       x1="35.190362"
-       y1="76.277559"
-       x2="8.346058"
-       y2="105.42543" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient888"
-       id="linearGradient5566"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.1838753,0.8446836)"
-       x1="141.60217"
-       y1="228.39311"
-       x2="88.447016"
-       y2="133.54711" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient902"
-       id="linearGradient5568"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.3601783,0.7351977)"
-       x1="101.10657"
-       y1="177.77768"
-       x2="95.100155"
-       y2="173.03153" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient892"
-       id="linearGradient5570"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.3695887,0.7301462)"
-       x1="88.755695"
-       y1="169.09755"
-       x2="88.996957"
-       y2="182.99154" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1317"
-       id="linearGradient5572"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.223869,0.8170809)"
-       x1="111.49758"
-       y1="131.25248"
-       x2="107.04918"
-       y2="148.78619" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient892"
-       id="linearGradient5574"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(2.1051174,0.4750329)"
-       x1="31.449743"
-       y1="203.499"
-       x2="31.617281"
-       y2="251.21892" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient5714"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <radialGradient
-       xlink:href="#linearGradient4362"
-       r="39.648127"
-       inkscape:collect="always"
-       id="radialGradient2797"
-       fy="101.92288"
-       fx="50.092871"
-       cy="102.70191"
-       cx="49.760482"
-       gradientTransform="scale(1.1222336,0.8910801)"
-       gradientUnits="userSpaceOnUse" />
-    <radialGradient
-       xlink:href="#linearGradient4362"
-       r="35.284406"
-       inkscape:collect="always"
-       id="radialGradient2791"
-       fy="32.061308"
-       fx="81.553592"
-       cy="33.402904"
-       cx="80.599566"
-       gradientTransform="scale(0.8352269,1.1972794)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="67.164412"
-       y1="53.505203"
-       xlink:href="#linearGradient4376"
-       x2="63.804663"
-       x1="64.786456"
-       inkscape:collect="always"
-       id="linearGradient2789"
-       gradientTransform="scale(1.1424512,0.8753109)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       id="linearGradient6015">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.77513230;"
-         offset="0.0000000"
-         id="stop6017" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop6019" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient6009">
-      <stop
-         style="stop-color:#000000;stop-opacity:0.52645504;"
-         offset="0.0000000"
-         id="stop6011" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop6013" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient6003">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.66666669;"
-         offset="0.0000000"
-         id="stop6005" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop6007" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient5997">
-      <stop
-         style="stop-color:#000;stop-opacity:1;"
-         offset="0"
-         id="stop5999" />
-      <stop
-         style="stop-color:#fff;stop-opacity:1;"
-         offset="1"
-         id="stop6001" />
-    </linearGradient>
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient6037"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <linearGradient
-       y2="0.46093750"
-       y1="0.46093750"
-       xlink:href="#linearGradient650"
-       x2="1.16666818"
-       x1="1.22222710"
-       spreadMethod="repeat"
-       id="linearGradient654"
-       gradientUnits="objectBoundingBox" />
-    <linearGradient
-       y2="0.53906250"
-       y1="0.53125000"
-       xlink:href="#linearGradient650"
-       x2="1.16666901"
-       x1="1.00000548"
-       spreadMethod="repeat"
-       id="linearGradient653"
-       gradientUnits="objectBoundingBox" />
-    <linearGradient
-       id="linearGradient650">
-      <stop
-         style="stop-color:#000;stop-opacity:1;"
-         offset="0"
-         id="stop651" />
-      <stop
-         style="stop-color:#fff;stop-opacity:1;"
-         offset="1"
-         id="stop652" />
-    </linearGradient>
-    <linearGradient
-       y2="0.46093750"
-       y1="0.46093750"
-       xlink:href="#linearGradient650"
-       x2="1.16666818"
-       x1="1.22222710"
-       spreadMethod="repeat"
-       id="linearGradient9648"
-       gradientUnits="objectBoundingBox" />
-    <linearGradient
-       y2="0.53906250"
-       y1="0.53125000"
-       xlink:href="#linearGradient650"
-       x2="1.16666901"
-       x1="1.00000548"
-       spreadMethod="repeat"
-       id="linearGradient9646"
-       gradientUnits="objectBoundingBox" />
-    <linearGradient
-       id="linearGradient9640">
-      <stop
-         style="stop-color:#000;stop-opacity:1;"
-         offset="0"
-         id="stop9642" />
-      <stop
-         style="stop-color:#fff;stop-opacity:1;"
-         offset="1"
-         id="stop9644" />
-    </linearGradient>
-  </defs>
-  <sodipodi:namedview
-     id="base"
-     pagecolor="#ffffff"
-     bordercolor="#666666"
-     borderopacity="1.0"
-     gridtolerance="10000"
-     guidetolerance="10"
-     objecttolerance="10"
-     inkscape:pageopacity="0.0"
-     inkscape:pageshadow="2"
-     inkscape:zoom="1"
-     inkscape:cx="536.99132"
-     inkscape:cy="369.73871"
-     inkscape:document-units="px"
-     inkscape:current-layer="layer1"
-     width="1052.3622px"
-     height="744.09448px"
-     showgrid="true"
-     inkscape:window-width="1759"
-     inkscape:window-height="875"
-     inkscape:window-x="0"
-     inkscape:window-y="25" />
-  <metadata
-     id="metadata7">
-    <rdf:RDF>
-      <cc:Work
-         rdf:about="">
-        <dc:format>image/svg+xml</dc:format>
-        <dc:type
-           rdf:resource="http://purl.org/dc/dcmitype/StillImage" />
-      </cc:Work>
-    </rdf:RDF>
-  </metadata>
-  <g
-     inkscape:label="Layer 1"
-     inkscape:groupmode="layer"
-     id="layer1">
-    <g
-       id="g5256"
-       transform="translate(601.5744,309.49165)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157">
-      <path
-         transform="matrix(6.392368,0.545409,-0.130014,2.864752,-184.6606,-38.15109)"
-         style="fill:url(#radialGradient1977);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:type="arc"
-         sodipodi:ry="12.562782"
-         sodipodi:rx="12.562782"
-         sodipodi:cy="37.865574"
-         sodipodi:cx="41.875938"
-         id="path1976"
-         d="M 54.438721 37.865574 A 12.562782 12.562782 0 1 1  29.313156,37.865574 A 12.562782 12.562782 0 1 1  54.438721 37.865574 z" />
-      <g
-         transform="matrix(1,0,0,1.036969,356.8306,-11.4294)"
-         style="fill:url(#linearGradient6037);fill-opacity:1"
-         id="g4293">
-        <path
-           style="fill:url(#linearGradient5281);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
-           id="path2720"
-           d="M -270.85787,33.814995 C -289.35564,33.925992 -307.93321,33.592782 -326.38104,33.981747 C -331.43469,35.696391 -331.02221,41.899652 -330.68524,46.15332 C -330.75782,60.227303 -330.53537,74.298225 -330.21167,88.36826 C -328.21297,91.039611 -323.21766,90.618387 -322.68469,94.539015 C -320.78054,96.259426 -317.05071,94.88215 -314.4389,95.333237 C -298.54999,95.360274 -282.66107,95.387302 -266.77215,95.414339 C -266.35587,90.465192 -260.12609,88.824447 -255.81783,89.540255 C -256.01688,89.058389 -261.69557,87.939375 -259.61591,84.491525 C -259.45681,68.72727 -259.19734,52.882199 -259.82064,37.168229 C -261.19394,32.980583 -267.34179,33.83368 -270.85787,33.814995 z M -236.65184,97.260473 C -234.79025,100.12642 -237.08724,103.09386 -239.92892,104.16357 C -242.6311,105.91539 -245.59105,107.62992 -248.52894,108.76804 C -253.1773,108.19079 -251.42424,101.88475 -255.01281,99.896645 C -260.33594,96.447012 -267.21045,98.43943 -273.23329,97.939231 C -291.8249,97.94887 -310.41651,97.958519 -329.00813,97.968158 C -335.45898,103.56578 -339.16595,111.40269 -341.55034,119.32178 C -337.25147,124.2061 -329.89606,122.27575 -324.10438,122.40002 C -298.64553,122.23171 -273.11679,122.61546 -247.69897,122.24542 C -243.40174,121.14669 -247.44685,114.84894 -243.58488,113.04441 C -242.73865,112.73374 -247.81245,114.4382 -247.26205,111.62955 C -245.49117,106.66028 -239.14113,105.99595 -235.92338,102.36811 C -234.39131,99.755669 -236.26958,96.922488 -238.33047,95.260495 C -237.77093,95.927151 -237.21138,96.593817 -236.65184,97.260473 z M -240.64255,111.75263 C -243.64086,113.13223 -237.02792,110.69536 -235.55512,111.97369 C -229.71113,112.74417 -224.16461,117.19625 -218.12358,115.22951 C -225.97639,116.31604 -232.799,109.03014 -240.64255,111.75263 z M -212.01083,112.33724 C -215.98173,113.85021 -208.21543,112.17765 -210.07883,115.87566 C -212.50961,119.93855 -206.99008,113.8662 -209.61436,112.54677 C -210.16198,111.94632 -211.27989,112.47663 -212.01083,112.33724 z M -213.97451,120.82946 C -220.13871,124.32615 -228.37873,119.08124 -233.85995,124.39439 C -238.36465,128.00055 -244.57099,130.35185 -247.0433,135.75122 C -247.65922,139.60202 -243.25109,141.90251 -240.44565,143.71808 C -235.60127,146.54512 -228.8227,145.75388 -225.20082,141.42836 C -220.62679,137.96117 -216.44182,134.08489 -212.48592,129.96782 C -212.82701,126.95048 -214.43694,123.63971 -213.97451,120.82946 z " />
-        <path
-           style="fill:url(#linearGradient5283);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
-           id="path2723"
-           d="M -269.68453,32.256957 C -288.76965,32.351184 -307.87514,32.249603 -326.94796,32.349264 C -332.63884,33.663474 -333.90446,40.291305 -333.21597,45.149113 C -333.11996,59.896901 -333.07471,74.659754 -332.61729,89.39481 C -331.88583,93.310348 -324.86009,92.098674 -325.11097,96.44089 C -328.07184,96.184706 -331.5534,96.317135 -333.07248,99.246492 C -338.92562,104.98392 -341.99312,112.66465 -344.27268,120.28679 C -340.22572,125.96631 -332.26467,125.31453 -326.02946,124.71751 C -300.16629,124.7277 -274.28316,124.82043 -248.43245,124.77905 C -244.42424,124.78686 -243.30672,120.35609 -243.96666,117.2099 C -242.88598,112.93536 -237.04086,113.94554 -233.80717,114.98513 C -228.01851,116.64297 -221.26418,120.43074 -215.57982,116.37592 C -211.36091,113.71809 -213.05678,118.4029 -215.77936,119.43344 C -220.82539,122.25797 -227.09125,118.98178 -232.39677,121.20855 C -236.53238,123.88957 -240.74707,126.85249 -244.76678,129.74666 C -248.34219,132.01467 -251.90947,137.38626 -248.13747,140.97315 C -243.79274,146.02948 -236.37425,149.4527 -229.68248,147.08651 C -225.09383,144.85973 -221.79206,140.75401 -217.61535,137.88661 C -215.10454,135.69469 -212.49235,133.26839 -210.83749,130.50207 C -210.86477,126.92195 -214.68529,121.91303 -210.252,119.57013 C -207.25619,117.95208 -205.81053,112.12098 -209.75314,110.87946 C -214.16982,109.44692 -216.95156,115.09837 -221.43751,113.68608 C -228.47365,112.76758 -235.5565,107.20489 -242.69931,110.72434 C -246.89551,113.06547 -243.47174,109.4356 -241.45524,108.56544 C -237.85613,106.84628 -232.73147,104.36798 -233.94637,99.617708 C -234.27189,95.083838 -239.22223,93.197522 -242.95318,91.723135 C -247.61613,89.074942 -253.27003,89.345117 -258.06082,86.933298 C -257.89248,70.385101 -257.58805,53.76423 -258.26571,37.261116 C -259.2092,32.393288 -265.59824,31.96057 -269.68453,32.256957 z M -258.66259,91.764016 C -251.5059,92.239344 -243.21163,93.474137 -238.58238,99.271629 C -238.96251,103.06003 -244.00295,103.80224 -246.52821,106.14082 C -248.92267,108.48087 -251.12372,105.80503 -251.02958,103.27159 C -252.70852,98.336432 -258.20582,95.710815 -263.31841,96.533197 C -267.00561,96.7255 -263.71935,91.937514 -261.395,92.380192 C -260.48382,92.178338 -259.57521,91.953759 -258.66259,91.764016 z " />
-        <path
-           style="fill:url(#linearGradient5285);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
-           sodipodi:nodetypes="ccccczccccccccccccccccccczccccc"
-           id="path2737"
-           d="M -324.0398,30.70877 C -336.3492,30.820231 -335.15663,39.652507 -334.79476,45.313268 C -334.5469,60.436643 -334.38614,75.599009 -334.01234,90.698281 C -333.20516,93.057424 -330.71249,93.985661 -328.75475,95.252079 C -334.4553,96.476239 -336.96996,102.43195 -340.11175,106.59303 C -342.33294,111.36531 -347.84019,115.92868 -345.92111,121.43642 C -344.00204,126.94416 -332.21757,127.68181 -324.95408,127.12866 C -299.06901,127.09789 -273.17022,127.14905 -247.29372,127.06713 C -243.29961,126.16956 -240.99668,122.03601 -241.4977,118.23645 C -238.30082,114.95371 -233.32521,118.03039 -229.53292,118.63002 C -225.71641,119.31313 -232.5646,119.27527 -233.19362,120.54849 C -238.23604,122.95799 -242.6166,126.65447 -246.90973,130.10509 C -250.44674,132.97354 -252.4229,138.10741 -249.57412,142.08235 C -246.21315,145.92284 -241.41489,148.84284 -236.30395,149.79628 C -230.65487,150.83779 -225.57101,147.82678 -221.6157,144.24077 C -216.87391,140.59839 -212.0873,136.78287 -208.84361,131.80554 C -207.76302,128.26399 -211.47449,123.86671 -208.08348,121.09796 C -204.93438,118.46115 -204.06893,113.02076 -207.41836,110.2673 C -212.81988,106.81278 -218.36682,114.55112 -223.89705,111.29128 C -227.94209,110.1659 -231.91311,108.52596 -236.17676,108.45194 C -231.52711,105.88023 -229.62903,98.782331 -234.08944,95.153402 C -239.61551,89.404431 -248.455,88.793917 -255.40182,85.744487 C -255.86992,78.940296 -255.53665,71.972758 -255.70928,65.098797 C -255.80747,55.730822 -255.73864,46.312632 -255.94025,36.975777 C -258.03631,31.236293 -265.34014,30.439522 -270.76286,30.729689 C -289.40725,30.770714 -311.88665,30.597309 -324.0398,30.70877 z M -255.46516,94.482857 C -250.34561,95.62106 -244.69322,96.21649 -240.83258,100.05203 C -242.37635,102.55028 -245.27573,103.64481 -247.80048,104.97505 C -249.71506,99.684643 -254.39847,94.970039 -260.51378,95.138259 C -260.66903,94.131274 -256.73261,94.551178 -255.46516,94.482857 z " />
-      </g>
-      <rect
-         y="78.658051"
-         x="33.326111"
-         width="57.567924"
-         style="fill:url(#linearGradient1156);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient1157);stroke-width:1.44734821pt"
-         id="rect1155"
-         height="8.3153667" />
-      <path
-         style="fill:url(#linearGradient1169);fill-rule:evenodd;stroke-width:0.90459263;stroke-opacity:0.07438019"
-         sodipodi:nodetypes="czzczczzzzzzzc"
-         id="path2676"
-         d="M 98.723806,78.927818 C 95.18666,77.759681 93.50122,82.555591 98.766686,81.004087 C 104.03217,79.452583 120.13123,85.906451 120.37383,89.795491 C 120.61643,93.905503 101.5003,98.581154 106.74108,104.42426 C 111.62816,110.70149 115.35468,100.13868 123.54696,104.21261 C 131.73923,108.17607 136.26048,109.72394 142.25488,104.94185 C 149.10027,101.9342 145.04599,107.07658 139.57918,113.60451 C 134.11237,120.13244 144.00251,115.08156 147.91225,105.31962 C 151.93248,95.557673 139.13128,107.33503 133.66268,105.40571 C 128.19408,103.47639 119.73678,97.849788 113.27625,102.55563 C 106.81572,107.26147 109.62894,99.493003 114.85637,97.90307 C 120.0838,96.092166 122.81363,93.045722 122.85597,90.161522 C 122.89831,87.498293 117.92629,84.811803 112.94229,82.402852 C 107.73732,79.993901 100.49788,78.588966 98.723806,78.927818 z " />
-      <path
-         style="fill:url(#linearGradient1140);fill-opacity:1;fill-rule:evenodd;stroke-width:1.44734821pt"
-         sodipodi:nodetypes="czzzzzzzz"
-         id="path1139"
-         d="M 15.102732,106.80712 C 13.80355,109.23224 17.148847,113.52338 19.900059,113.52338 L 107.85106,113.52338 C 110.18914,113.52338 113.70766,110.4906 112.64839,108.40622 L 102.7339,88.897093 C 101.97024,87.394398 100.26184,86.65834 98.576216,86.65834 L 28.215425,86.658339 C 26.825434,86.658339 25.353768,87.671846 24.697385,88.897093 L 15.102732,106.80712 z " />
-      <rect
-         y="22.413721"
-         x="26.015469"
-         width="72.279724"
-         style="fill:url(#linearGradient905);fill-opacity:1;fill-rule:evenodd;stroke-width:1.62826681"
-         ry="5.4369707"
-         rx="5.4369707"
-         id="rect1137"
-         height="60.126495" />
-      <rect
-         y="31.695871"
-         x="33.386066"
-         width="58.178177"
-         style="fill:url(#radialGradient1132);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient891);stroke-width:1.4649456pt"
-         id="rect1131"
-         height="38.044163" />
-      <path
-         style="fill:url(#linearGradient1146);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="czzccccc"
-         id="path1145"
-         d="M 27.690431,52.841444 L 27.370609,74.749236 C 27.319624,78.241665 29.310209,80.477938 32.807578,80.506029 L 72.625393,80.825852 L 76.463254,71.87084 L 32.008024,71.55102 L 31.688202,52.681533 L 27.690431,52.841444 z " />
-      <g
-         transform="matrix(-1,0,0,1,125.4301,0)"
-         id="g1791">
-        <path
-           style="fill:url(#linearGradient1148);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-           sodipodi:nodetypes="czzccc"
-           id="path1147"
-           d="M 42.062098,33.460351 L 77.341205,33.008055 C 82.787126,32.938235 89.553204,38.416797 89.553204,43.863165 L 89.553204,60.14583 L 41.609801,59.693534 L 42.062098,33.460351 z " />
-        <path
-           style="fill:url(#linearGradient1150);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-           sodipodi:nodetypes="czzccc"
-           id="path1149"
-           d="M 78.337784,67.629235 L 46.723745,67.724544 C 41.843589,67.739257 35.829319,62.771024 35.877168,57.891081 L 36.020221,43.301821 L 78.973514,44.128288 L 78.337784,67.629235 z " />
-      </g>
-      <path
-         style="fill:url(#linearGradient1167);fill-opacity:1;fill-rule:evenodd;stroke-width:0.72367412;stroke-opacity:0.34710741"
-         sodipodi:nodetypes="cczzzzzzc"
-         id="path1159"
-         d="M 137.39107,112.02341 C 137.39107,112.02341 129.0757,110.26438 123.63872,113.62251 C 118.20176,116.98064 109.96635,123.21719 108.76702,124.81628 C 107.40777,126.57531 107.42036,130.22796 109.24674,131.53253 L 114.84364,135.53031 C 118.31797,138.01198 124.86218,139.25396 128.11624,136.48978 L 142.98795,123.85681 C 144.79792,122.3193 145.72732,118.27921 144.10733,116.82073 C 142.95609,115.04975 140.4892,112.91939 137.39107,112.02341 z " />
-      <path
-         style="fill:url(#linearGradient1171);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="czzzzzc"
-         id="path1160"
-         d="M 142.3483,121.13833 L 125.91043,133.59673 C 122.97154,135.82414 118.65484,134.11775 116.28283,133.77129 C 113.9108,133.42481 111.88528,131.87901 112.12516,132.33209 C 112.36503,132.78517 115.08349,135.71687 117.72203,136.48978 C 120.36055,137.26267 124.9543,138.89307 127.50953,136.15531 C 130.06477,133.41755 145.2267,123.53699 142.3483,121.13833 z " />
-      <path
-         style="fill:url(#linearGradient1404);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="cczc"
-         id="path1403"
-         d="M 132.11225,127.51984 C 135.31047,122.88242 120.11893,113.12786 109.08509,127.0401 C 110.20446,130.71805 116.80662,132.5992 121.82304,132.33547 C 126.68363,132.07993 129.50037,129.97181 132.11225,127.51984 z " />
-      <path
-         style="fill:url(#linearGradient1166);fill-opacity:1;fill-rule:evenodd;stroke-width:1.08551121"
-         sodipodi:nodetypes="cccccccc"
-         id="path1519"
-         d="M 138.63464,112.68306 C 135.9958,113.22749 132.31739,114.43079 129.87534,116.38362 C 128.77009,115.68011 125.32759,114.5677 123.66767,113.84494 L 123.24572,114.10517 C 129.67287,117.23476 136.43512,117.91249 135.88192,122.87668 C 136.33675,122.98575 137.05589,123.09702 136.73191,122.38863 C 136.41775,118.90392 132.50587,117.23351 131.02697,116.81532 C 133.17224,114.26602 136.255,113.70892 138.63464,112.68306 z " />
-      <path
-         style="fill:url(#linearGradient1144);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="czzzzzzzz"
-         id="path1143"
-         d="M 18.891612,106.48414 C 17.978451,108.31614 19.173914,111.55774 22.263529,111.55774 L 105.0195,111.55774 C 106.66288,111.55774 109.13595,109.26672 108.39142,107.69215 L 101.42279,92.954575 C 100.88602,91.819403 99.685232,91.263378 98.500462,91.263378 L 28.108183,91.263369 C 27.131195,91.263369 26.0968,92.028994 25.635445,92.954575 L 18.891612,106.48414 z " />
-      <text
-         y="-14.660837"
-         xml:space="preserve"
-         x="6.147172"
-         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
-         id="text1232"><tspan
-           id="tspan1233">Computer</tspan></text>
-      <text
-         y="-34.951134"
-         xml:space="preserve"
-         x="84.564949"
-         transform="scale(0.246729,0.246729)"
-         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
-         id="text1235"><tspan
-           id="tspan1236">Created by Andrew Fitzsimon</tspan></text>
-    </g>
-    <g
-       id="g5474"
-       transform="translate(541.63525,501.49239)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157">
-      <path
-         style="fill:#ffffff;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="cccc"
-         id="path9383"
-         d="M 203.47051,-209.74941 C 198.72111,-204.56585 195.69876,-195.27863 189.00642,-195.27863 C 182.52997,-197.07848 181.66644,-212.48518 180.80291,-215.7969 C 188.1429,-210.75732 195.69876,-207.87757 203.47051,-209.74941 z " />
-      <path
-         transform="matrix(-0.440859,0,0,0.441062,265.52775,-266.17138)"
-         style="fill:#f1bb96;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:type="arc"
-         sodipodi:ry="57.825485"
-         sodipodi:rx="60.94183"
-         sodipodi:cy="70.290855"
-         sodipodi:cx="150.27701"
-         id="path3713"
-         d="M 211.21884 70.290855 A 60.94183 57.825485 0 1 1  89.335178,70.290855 A 60.94183 57.825485 0 1 1  211.21884 70.290855 z" />
-      <path
-         style="fill:#233e6a;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="ccssssc"
-         id="path4369"
-         d="M 232.46888,-182.94274 C 232.85952,-157.74648 168.23012,-154.86512 168.38642,-182.94274 C 166.84164,-205.27149 177.94687,-217.96719 180.70654,-215.80872 C 182.10778,-214.71274 182.62841,-190.37295 192.09635,-195.9716 C 196.69923,-198.69339 201.84768,-209.14846 204.10029,-209.49532 C 207.49937,-210.01873 214.00811,-212.77083 219.98583,-217.92153 C 221.55412,-219.27285 231.93943,-205.38255 232.46888,-182.94274 z " />
-      <path
-         style="fill:#513624;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="ccccc"
-         id="path11309"
-         d="M 204.55432,-273.85152 C 222.46413,-271.53047 237.32676,-259.28175 231.38357,-231.42099 C 229.66954,-221.67743 222.12426,-217.60887 219.35537,-236.36962 C 211.4578,-233.88387 177.25785,-223.92576 170.54948,-241.26677 C 166.55631,-248.43407 174.86257,-276.23329 204.55432,-273.85152 z " />
-      <path
-         style="fill:#1f4eb3;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="cccc"
-         id="path11942"
-         d="M 191.92173,-167.75448 C 192.06919,-184.44566 194.18855,-193.73288 188.47558,-194.95709 C 182.9785,-195.85052 179.91138,-176.52634 179.04785,-173.21462 C 175.85958,-157.19769 189.53653,-154.44605 191.92173,-167.75448 z " />
-      <path
-         style="fill:url(#linearGradient1815);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         id="path1811"
-         d="M 172.67812,-237.76056 C 182.56217,-225.58826 212.09549,-234.15979 219.36562,-236.44806 C 220.33459,-229.88278 221.90014,-226.25074 223.58437,-224.54181 C 219.31219,-215.8234 210.06249,-209.76056 199.27187,-209.76056 C 184.44142,-209.76056 172.42812,-221.18201 172.42812,-235.26056 C 172.42812,-236.11869 172.59078,-236.92413 172.67812,-237.76056 z " />
-      <path
-         style="fill:url(#radialGradient1818);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="ccccc"
-         id="path1817"
-         d="M 203.17522,-273.74212 C 221.08504,-271.42107 235.94766,-259.17235 230.00448,-231.31159 C 228.29044,-221.56803 220.74517,-217.49946 217.97627,-236.26022 C 210.0787,-233.77447 175.87876,-223.81635 169.17039,-241.15737 C 165.17722,-248.32467 173.48348,-276.12389 203.17522,-273.74212 z " />
-      <path
-         style="fill:url(#radialGradient1822);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         id="path1819"
-         d="M 220.74123,-214.1875 C 227.87764,-203.73841 231.28831,-190.18836 229.45998,-177.71875 C 222.3997,-165.39834 205.93726,-163.52328 193.05373,-164.75 C 194.11526,-173.29796 194.69425,-182.39807 193.51876,-190.98978 C 191.02311,-195.41909 199.33209,-197.29913 200.39748,-201.6875 C 203.70655,-208.92744 212.80427,-208.10966 218.04988,-213.3696 C 218.9201,-213.57294 220.00051,-215.94141 220.74123,-214.1875 z M 179.55373,-210.28125 C 180.69974,-204.97453 181.23339,-199.24919 184.58498,-194.75 C 179.40159,-187.81847 178.05976,-178.63643 176.67873,-170.28125 C 167.10271,-177.01707 169.81568,-190.62142 172.02963,-200.39411 C 173.03008,-204.26346 176.36728,-212.34166 179.19382,-211.77772 C 179.27177,-211.45363 179.5117,-210.45598 179.55373,-210.28125 z " />
-      <path
-         style="fill:url(#radialGradient1824);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="cccc"
-         id="path1823"
-         d="M 192.35803,-167.43887 C 192.50549,-184.13006 194.62485,-193.41727 188.91188,-194.64149 C 183.4148,-195.53491 180.34768,-176.21073 179.48415,-172.89901 C 176.29589,-156.88208 189.97283,-154.13044 192.35803,-167.43887 z " />
-      <path
-         style="fill:#1f4eb3;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
-         sodipodi:nodetypes="ccccc"
-         id="path1825"
-         d="M 185.2414,-200.53324 C 185.2414,-197.95291 187.25802,-195.85872 189.74278,-195.85872 C 192.22755,-195.85872 194.24417,-197.95291 194.24417,-200.53324 C 194.24417,-203.11357 193.61259,-209.36288 191.12783,-209.36288 C 188.64306,-209.36288 185.2414,-203.11357 185.2414,-200.53324 z " />
-      <path
-         style="fill:url(#radialGradient1828);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="ccccc"
-         id="path1827"
-         d="M 186.28018,-201.05263 C 186.28018,-198.4723 188.2968,-196.37811 190.78156,-196.37811 C 193.26633,-196.37811 195.28295,-198.4723 195.28295,-201.05263 C 195.28295,-203.63296 194.65137,-209.88227 192.16661,-209.88227 C 189.68184,-209.88227 186.28018,-203.63296 186.28018,-201.05263 z " />
-    </g>
-    <g
-       id="g5488"
-       transform="translate(111.5744,317.66157)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157">
-      <path
-         transform="matrix(6.392368,0.545409,-0.130014,2.864752,-184.6606,-38.15109)"
-         style="fill:url(#radialGradient5536);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:type="arc"
-         sodipodi:ry="12.562782"
-         sodipodi:rx="12.562782"
-         sodipodi:cy="37.865574"
-         sodipodi:cx="41.875938"
-         id="path5490"
-         d="M 54.438721 37.865574 A 12.562782 12.562782 0 1 1  29.313156,37.865574 A 12.562782 12.562782 0 1 1  54.438721 37.865574 z" />
-      <g
-         transform="matrix(1,0,0,1.036969,356.8306,-11.4294)"
-         style="fill:url(#linearGradient5538);fill-opacity:1"
-         id="g5492">
-        <path
-           style="fill:url(#linearGradient5540);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
-           id="path5494"
-           d="M -270.85787,33.814995 C -289.35564,33.925992 -307.93321,33.592782 -326.38104,33.981747 C -331.43469,35.696391 -331.02221,41.899652 -330.68524,46.15332 C -330.75782,60.227303 -330.53537,74.298225 -330.21167,88.36826 C -328.21297,91.039611 -323.21766,90.618387 -322.68469,94.539015 C -320.78054,96.259426 -317.05071,94.88215 -314.4389,95.333237 C -298.54999,95.360274 -282.66107,95.387302 -266.77215,95.414339 C -266.35587,90.465192 -260.12609,88.824447 -255.81783,89.540255 C -256.01688,89.058389 -261.69557,87.939375 -259.61591,84.491525 C -259.45681,68.72727 -259.19734,52.882199 -259.82064,37.168229 C -261.19394,32.980583 -267.34179,33.83368 -270.85787,33.814995 z M -236.65184,97.260473 C -234.79025,100.12642 -237.08724,103.09386 -239.92892,104.16357 C -242.6311,105.91539 -245.59105,107.62992 -248.52894,108.76804 C -253.1773,108.19079 -251.42424,101.88475 -255.01281,99.896645 C -260.33594,96.447012 -267.21045,98.43943 -273.23329,97.939231 C -291.8249,97.94887 -310.41651,97.958519 -329.00813,97.968158 C -335.45898,103.56578 -339.16595,111.40269 -341.55034,119.32178 C -337.25147,124.2061 -329.89606,122.27575 -324.10438,122.40002 C -298.64553,122.23171 -273.11679,122.61546 -247.69897,122.24542 C -243.40174,121.14669 -247.44685,114.84894 -243.58488,113.04441 C -242.73865,112.73374 -247.81245,114.4382 -247.26205,111.62955 C -245.49117,106.66028 -239.14113,105.99595 -235.92338,102.36811 C -234.39131,99.755669 -236.26958,96.922488 -238.33047,95.260495 C -237.77093,95.927151 -237.21138,96.593817 -236.65184,97.260473 z M -240.64255,111.75263 C -243.64086,113.13223 -237.02792,110.69536 -235.55512,111.97369 C -229.71113,112.74417 -224.16461,117.19625 -218.12358,115.22951 C -225.97639,116.31604 -232.799,109.03014 -240.64255,111.75263 z M -212.01083,112.33724 C -215.98173,113.85021 -208.21543,112.17765 -210.07883,115.87566 C -212.50961,119.93855 -206.99008,113.8662 -209.61436,112.54677 C -210.16198,111.94632 -211.27989,112.47663 -212.01083,112.33724 z M -213.97451,120.82946 C -220.13871,124.32615 -228.37873,119.08124 -233.85995,124.39439 C -238.36465,128.00055 -244.57099,130.35185 -247.0433,135.75122 C -247.65922,139.60202 -243.25109,141.90251 -240.44565,143.71808 C -235.60127,146.54512 -228.8227,145.75388 -225.20082,141.42836 C -220.62679,137.96117 -216.44182,134.08489 -212.48592,129.96782 C -212.82701,126.95048 -214.43694,123.63971 -213.97451,120.82946 z " />
-        <path
-           style="fill:url(#linearGradient5542);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
-           id="path5496"
-           d="M -269.68453,32.256957 C -288.76965,32.351184 -307.87514,32.249603 -326.94796,32.349264 C -332.63884,33.663474 -333.90446,40.291305 -333.21597,45.149113 C -333.11996,59.896901 -333.07471,74.659754 -332.61729,89.39481 C -331.88583,93.310348 -324.86009,92.098674 -325.11097,96.44089 C -328.07184,96.184706 -331.5534,96.317135 -333.07248,99.246492 C -338.92562,104.98392 -341.99312,112.66465 -344.27268,120.28679 C -340.22572,125.96631 -332.26467,125.31453 -326.02946,124.71751 C -300.16629,124.7277 -274.28316,124.82043 -248.43245,124.77905 C -244.42424,124.78686 -243.30672,120.35609 -243.96666,117.2099 C -242.88598,112.93536 -237.04086,113.94554 -233.80717,114.98513 C -228.01851,116.64297 -221.26418,120.43074 -215.57982,116.37592 C -211.36091,113.71809 -213.05678,118.4029 -215.77936,119.43344 C -220.82539,122.25797 -227.09125,118.98178 -232.39677,121.20855 C -236.53238,123.88957 -240.74707,126.85249 -244.76678,129.74666 C -248.34219,132.01467 -251.90947,137.38626 -248.13747,140.97315 C -243.79274,146.02948 -236.37425,149.4527 -229.68248,147.08651 C -225.09383,144.85973 -221.79206,140.75401 -217.61535,137.88661 C -215.10454,135.69469 -212.49235,133.26839 -210.83749,130.50207 C -210.86477,126.92195 -214.68529,121.91303 -210.252,119.57013 C -207.25619,117.95208 -205.81053,112.12098 -209.75314,110.87946 C -214.16982,109.44692 -216.95156,115.09837 -221.43751,113.68608 C -228.47365,112.76758 -235.5565,107.20489 -242.69931,110.72434 C -246.89551,113.06547 -243.47174,109.4356 -241.45524,108.56544 C -237.85613,106.84628 -232.73147,104.36798 -233.94637,99.617708 C -234.27189,95.083838 -239.22223,93.197522 -242.95318,91.723135 C -247.61613,89.074942 -253.27003,89.345117 -258.06082,86.933298 C -257.89248,70.385101 -257.58805,53.76423 -258.26571,37.261116 C -259.2092,32.393288 -265.59824,31.96057 -269.68453,32.256957 z M -258.66259,91.764016 C -251.5059,92.239344 -243.21163,93.474137 -238.58238,99.271629 C -238.96251,103.06003 -244.00295,103.80224 -246.52821,106.14082 C -248.92267,108.48087 -251.12372,105.80503 -251.02958,103.27159 C -252.70852,98.336432 -258.20582,95.710815 -263.31841,96.533197 C -267.00561,96.7255 -263.71935,91.937514 -261.395,92.380192 C -260.48382,92.178338 -259.57521,91.953759 -258.66259,91.764016 z " />
-        <path
-           style="fill:url(#linearGradient5544);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
-           sodipodi:nodetypes="ccccczccccccccccccccccccczccccc"
-           id="path5498"
-           d="M -324.0398,30.70877 C -336.3492,30.820231 -335.15663,39.652507 -334.79476,45.313268 C -334.5469,60.436643 -334.38614,75.599009 -334.01234,90.698281 C -333.20516,93.057424 -330.71249,93.985661 -328.75475,95.252079 C -334.4553,96.476239 -336.96996,102.43195 -340.11175,106.59303 C -342.33294,111.36531 -347.84019,115.92868 -345.92111,121.43642 C -344.00204,126.94416 -332.21757,127.68181 -324.95408,127.12866 C -299.06901,127.09789 -273.17022,127.14905 -247.29372,127.06713 C -243.29961,126.16956 -240.99668,122.03601 -241.4977,118.23645 C -238.30082,114.95371 -233.32521,118.03039 -229.53292,118.63002 C -225.71641,119.31313 -232.5646,119.27527 -233.19362,120.54849 C -238.23604,122.95799 -242.6166,126.65447 -246.90973,130.10509 C -250.44674,132.97354 -252.4229,138.10741 -249.57412,142.08235 C -246.21315,145.92284 -241.41489,148.84284 -236.30395,149.79628 C -230.65487,150.83779 -225.57101,147.82678 -221.6157,144.24077 C -216.87391,140.59839 -212.0873,136.78287 -208.84361,131.80554 C -207.76302,128.26399 -211.47449,123.86671 -208.08348,121.09796 C -204.93438,118.46115 -204.06893,113.02076 -207.41836,110.2673 C -212.81988,106.81278 -218.36682,114.55112 -223.89705,111.29128 C -227.94209,110.1659 -231.91311,108.52596 -236.17676,108.45194 C -231.52711,105.88023 -229.62903,98.782331 -234.08944,95.153402 C -239.61551,89.404431 -248.455,88.793917 -255.40182,85.744487 C -255.86992,78.940296 -255.53665,71.972758 -255.70928,65.098797 C -255.80747,55.730822 -255.73864,46.312632 -255.94025,36.975777 C -258.03631,31.236293 -265.34014,30.439522 -270.76286,30.729689 C -289.40725,30.770714 -311.88665,30.597309 -324.0398,30.70877 z M -255.46516,94.482857 C -250.34561,95.62106 -244.69322,96.21649 -240.83258,100.05203 C -242.37635,102.55028 -245.27573,103.64481 -247.80048,104.97505 C -249.71506,99.684643 -254.39847,94.970039 -260.51378,95.138259 C -260.66903,94.131274 -256.73261,94.551178 -255.46516,94.482857 z " />
-      </g>
-      <rect
-         y="78.658051"
-         x="33.326111"
-         width="57.567924"
-         style="fill:url(#linearGradient5546);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient5548);stroke-width:1.44734821pt"
-         id="rect5500"
-         height="8.3153667" />
-      <path
-         style="fill:url(#linearGradient5550);fill-rule:evenodd;stroke-width:0.90459263;stroke-opacity:0.07438019"
-         sodipodi:nodetypes="czzczczzzzzzzc"
-         id="path5502"
-         d="M 98.723806,78.927818 C 95.18666,77.759681 93.50122,82.555591 98.766686,81.004087 C 104.03217,79.452583 120.13123,85.906451 120.37383,89.795491 C 120.61643,93.905503 101.5003,98.581154 106.74108,104.42426 C 111.62816,110.70149 115.35468,100.13868 123.54696,104.21261 C 131.73923,108.17607 136.26048,109.72394 142.25488,104.94185 C 149.10027,101.9342 145.04599,107.07658 139.57918,113.60451 C 134.11237,120.13244 144.00251,115.08156 147.91225,105.31962 C 151.93248,95.557673 139.13128,107.33503 133.66268,105.40571 C 128.19408,103.47639 119.73678,97.849788 113.27625,102.55563 C 106.81572,107.26147 109.62894,99.493003 114.85637,97.90307 C 120.0838,96.092166 122.81363,93.045722 122.85597,90.161522 C 122.89831,87.498293 117.92629,84.811803 112.94229,82.402852 C 107.73732,79.993901 100.49788,78.588966 98.723806,78.927818 z " />
-      <path
-         style="fill:url(#linearGradient5552);fill-opacity:1;fill-rule:evenodd;stroke-width:1.44734821pt"
-         sodipodi:nodetypes="czzzzzzzz"
-         id="path5504"
-         d="M 15.102732,106.80712 C 13.80355,109.23224 17.148847,113.52338 19.900059,113.52338 L 107.85106,113.52338 C 110.18914,113.52338 113.70766,110.4906 112.64839,108.40622 L 102.7339,88.897093 C 101.97024,87.394398 100.26184,86.65834 98.576216,86.65834 L 28.215425,86.658339 C 26.825434,86.658339 25.353768,87.671846 24.697385,88.897093 L 15.102732,106.80712 z " />
-      <rect
-         y="22.413721"
-         x="26.015469"
-         width="72.279724"
-         style="fill:url(#linearGradient5554);fill-opacity:1;fill-rule:evenodd;stroke-width:1.62826681"
-         ry="5.4369707"
-         rx="5.4369707"
-         id="rect5506"
-         height="60.126495" />
-      <rect
-         y="31.695871"
-         x="33.386066"
-         width="58.178177"
-         style="fill:url(#radialGradient5556);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient5558);stroke-width:1.4649456pt"
-         id="rect5508"
-         height="38.044163" />
-      <path
-         style="fill:url(#linearGradient5560);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="czzccccc"
-         id="path5510"
-         d="M 27.690431,52.841444 L 27.370609,74.749236 C 27.319624,78.241665 29.310209,80.477938 32.807578,80.506029 L 72.625393,80.825852 L 76.463254,71.87084 L 32.008024,71.55102 L 31.688202,52.681533 L 27.690431,52.841444 z " />
-      <g
-         transform="matrix(-1,0,0,1,125.4301,0)"
-         id="g5512">
-        <path
-           style="fill:url(#linearGradient5562);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-           sodipodi:nodetypes="czzccc"
-           id="path5514"
-           d="M 42.062098,33.460351 L 77.341205,33.008055 C 82.787126,32.938235 89.553204,38.416797 89.553204,43.863165 L 89.553204,60.14583 L 41.609801,59.693534 L 42.062098,33.460351 z " />
-        <path
-           style="fill:url(#linearGradient5564);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-           sodipodi:nodetypes="czzccc"
-           id="path5516"
-           d="M 78.337784,67.629235 L 46.723745,67.724544 C 41.843589,67.739257 35.829319,62.771024 35.877168,57.891081 L 36.020221,43.301821 L 78.973514,44.128288 L 78.337784,67.629235 z " />
-      </g>
-      <path
-         style="fill:url(#linearGradient5566);fill-opacity:1;fill-rule:evenodd;stroke-width:0.72367412;stroke-opacity:0.34710741"
-         sodipodi:nodetypes="cczzzzzzc"
-         id="path5518"
-         d="M 137.39107,112.02341 C 137.39107,112.02341 129.0757,110.26438 123.63872,113.62251 C 118.20176,116.98064 109.96635,123.21719 108.76702,124.81628 C 107.40777,126.57531 107.42036,130.22796 109.24674,131.53253 L 114.84364,135.53031 C 118.31797,138.01198 124.86218,139.25396 128.11624,136.48978 L 142.98795,123.85681 C 144.79792,122.3193 145.72732,118.27921 144.10733,116.82073 C 142.95609,115.04975 140.4892,112.91939 137.39107,112.02341 z " />
-      <path
-         style="fill:url(#linearGradient5568);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="czzzzzc"
-         id="path5520"
-         d="M 142.3483,121.13833 L 125.91043,133.59673 C 122.97154,135.82414 118.65484,134.11775 116.28283,133.77129 C 113.9108,133.42481 111.88528,131.87901 112.12516,132.33209 C 112.36503,132.78517 115.08349,135.71687 117.72203,136.48978 C 120.36055,137.26267 124.9543,138.89307 127.50953,136.15531 C 130.06477,133.41755 145.2267,123.53699 142.3483,121.13833 z " />
-      <path
-         style="fill:url(#linearGradient5570);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="cczc"
-         id="path5522"
-         d="M 132.11225,127.51984 C 135.31047,122.88242 120.11893,113.12786 109.08509,127.0401 C 110.20446,130.71805 116.80662,132.5992 121.82304,132.33547 C 126.68363,132.07993 129.50037,129.97181 132.11225,127.51984 z " />
-      <path
-         style="fill:url(#linearGradient5572);fill-opacity:1;fill-rule:evenodd;stroke-width:1.08551121"
-         sodipodi:nodetypes="cccccccc"
-         id="path5524"
-         d="M 138.63464,112.68306 C 135.9958,113.22749 132.31739,114.43079 129.87534,116.38362 C 128.77009,115.68011 125.32759,114.5677 123.66767,113.84494 L 123.24572,114.10517 C 129.67287,117.23476 136.43512,117.91249 135.88192,122.87668 C 136.33675,122.98575 137.05589,123.09702 136.73191,122.38863 C 136.41775,118.90392 132.50587,117.23351 131.02697,116.81532 C 133.17224,114.26602 136.255,113.70892 138.63464,112.68306 z " />
-      <path
-         style="fill:url(#linearGradient5574);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="czzzzzzzz"
-         id="path5526"
-         d="M 18.891612,106.48414 C 17.978451,108.31614 19.173914,111.55774 22.263529,111.55774 L 105.0195,111.55774 C 106.66288,111.55774 109.13595,109.26672 108.39142,107.69215 L 101.42279,92.954575 C 100.88602,91.819403 99.685232,91.263378 98.500462,91.263378 L 28.108183,91.263369 C 27.131195,91.263369 26.0968,92.028994 25.635445,92.954575 L 18.891612,106.48414 z " />
-      <text
-         y="-14.660837"
-         xml:space="preserve"
-         x="6.147172"
-         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
-         id="text5528"><tspan
-           id="tspan5530">Computer</tspan></text>
-      <text
-         y="-34.951134"
-         xml:space="preserve"
-         x="84.564949"
-         transform="scale(0.246729,0.246729)"
-         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
-         id="text5532"><tspan
-           id="tspan5534">Created by Andrew Fitzsimon</tspan></text>
-    </g>
-    <g
-       id="g6024"
-       transform="matrix(-1,0,0,1,300.80614,215.0989)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157">
-      <path
-         transform="translate(2.509562,-4.432856e-2)"
-         style="fill:#ffffff;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="cccc"
-         id="path6027"
-         d="M 60.545133,72.847539 C 65.294534,78.031101 68.316881,87.318315 75.00922,87.318316 C 81.485677,85.518467 82.349205,70.11177 83.212732,66.800051 C 75.872748,71.839624 68.316882,74.71938 60.545133,72.847539 z " />
-      <path
-         transform="translate(2.509562,-4.432856e-2)"
-         style="fill:#d20000;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="ccssssc"
-         id="path6029"
-         d="M 31.546762,99.654209 C 31.156121,124.85047 95.78552,127.73183 95.62922,99.654209 C 97.174007,77.325462 86.068776,64.629762 83.309105,66.788232 C 81.907864,67.884209 81.387229,92.223995 71.919297,86.625353 C 67.316417,83.903554 62.167959,73.44849 59.915352,73.101625 C 56.516277,72.578221 50.007529,69.826123 44.029815,64.675414 C 42.461522,63.324094 32.076211,77.214403 31.546762,99.654209 z " />
-      <path
-         style="fill:url(#radialGradient2797);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         id="path2796"
-         d="M 43.53125,77.3125 C 40.353026,86.016409 37.202011,96.366079 40.377303,105.23542 C 48.984655,117.18204 66.049398,117.25223 79.222417,115.04972 C 88.094278,113.47345 96.636121,105.87972 94.744454,96.188658 C 94.751182,88.561019 93.319573,80.643142 89.09375,74.1875 C 87.954705,81.120157 85.706152,92.347929 76.686643,91.786583 C 66.841974,89.84774 65.058803,76.33878 54.747596,75.105769 C 49.945701,71.530053 45.566465,69.110698 43.783935,76.852875 L 43.53125,77.3125 z " />
-      <path
-         transform="matrix(0.440859,0,0,0.441062,0.997459,16.38124)"
-         style="fill:#efd7c7;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:type="arc"
-         sodipodi:ry="57.825485"
-         sodipodi:rx="60.94183"
-         sodipodi:cy="70.290855"
-         sodipodi:cx="150.27701"
-         id="path6032"
-         d="M 211.21884 70.290855 A 60.94183 57.825485 0 1 1  89.335178,70.290855 A 60.94183 57.825485 0 1 1  211.21884 70.290855 z" />
-      <path
-         transform="translate(2.509562,-4.432856e-2)"
-         style="fill:#000000;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="cccccc"
-         id="path3720"
-         d="M 56.980881,5.8426527 C 39.420698,8.0166254 30.552872,16.206245 24.211446,49.532095 C 14.512196,98.076517 21.871677,115.5525 32.990311,115.56714 C 17.54932,102.40769 63.877625,86.740105 56.295103,44.070713 C 68.4508,48.712358 94.51097,54.349644 95.164349,41.718703 C 97.176702,29.219492 88.64173,4.4775042 56.980881,5.8426527 z " />
-      <path
-         style="fill:url(#linearGradient2789);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         id="path2164"
-         d="M 60.687242,45.028999 C 62.530882,55.403773 61.180052,64.151015 58.312242,71.685249 C 61.630122,73.07804 65.296862,73.904 69.155992,73.903999 C 83.975322,73.903999 95.981712,62.468019 95.999742,48.403999 C 88.357632,52.885439 70.244092,48.678277 60.687242,45.028999 z " />
-      <path
-         style="fill:url(#radialGradient2791);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         id="path2790"
-         d="M 52.174948,8.1325312 C 35.846775,12.141346 31.110158,30.475875 28.060647,44.840387 C 24.465246,64.767005 19.485139,85.90438 25.518698,105.82003 C 29.863591,114.87216 28.026452,106.52571 31.049538,102.11795 C 41.311249,87.323083 56.256862,73.307418 55.936774,53.886064 C 56.647391,49.398848 52.34734,38.640985 60.701717,42.254379 C 70.683443,45.202557 82.078811,49.011247 92.143698,44.632531 C 96.945103,37.45042 93.288237,27.137344 88.876323,20.399742 C 81.135092,8.5919962 65.300885,5.0194752 52.174948,8.1325312 z " />
-    </g>
-    <path
-       style="fill:none;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:4.63842154;stroke-linecap:butt;stroke-linejoin:round;stroke-dasharray:none;stroke-opacity:1"
-       sodipodi:nodetypes="cccccccccccc"
-       id="path699"
-       d="M 357.16674,263.66524 L 470.27399,251.12251 L 460.57906,270.08242 L 522.9028,263.95688 C 522.9028,263.95688 532.59773,244.41369 533.05931,244.41369 C 533.52148,244.41369 555.68079,269.79078 555.68079,269.79078 C 555.68079,269.79078 503.51355,296.33479 503.05197,296.33479 C 503.51355,296.91808 512.74689,277.66616 512.74689,277.37453 L 440.72705,283.79207 L 450.42255,264.24852 L 347.01023,276.4996 L 357.16674,263.66524 z "
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157" />
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="635.5625"
-       y="201.21948"
-       id="text7877"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157"><tspan
-         sodipodi:role="line"
-         id="tspan7879"
-         x="635.5625"
-         y="201.21948">bzr branch</tspan></text>
-    <path
-       sodipodi:type="arc"
-       style="fill:#000000"
-       id="path9548"
-       sodipodi:cx="292.14285"
-       sodipodi:cy="181.95163"
-       sodipodi:rx="15"
-       sodipodi:ry="15"
-       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
-       transform="translate(318.85715,7.142853)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157" />
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="601.71429"
-       y="199.52307"
-       id="text9550"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157"><tspan
-         sodipodi:role="line"
-         id="tspan9552"
-         x="601.71429"
-         y="199.52307">2</tspan></text>
-    <path
-       style="fill:none;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:2.49513507;stroke-linecap:butt;stroke-linejoin:round;stroke-dasharray:none;stroke-opacity:1"
-       sodipodi:nodetypes="cccccccccccc"
-       id="path9650"
-       d="M 426.28539,558.28183 L 482.38891,565.59894 L 477.58003,554.5382 L 508.49388,558.1117 C 508.49388,558.1117 513.30276,569.51271 513.53172,569.51271 C 513.76096,569.51271 524.75243,554.70834 524.75243,554.70834 C 524.75243,554.70834 498.87641,539.22321 498.64746,539.22321 C 498.87641,538.88294 503.45634,550.11403 503.45634,550.28417 L 467.73303,546.54033 L 472.54219,557.94156 L 421.24757,550.79458 L 426.28539,558.28183 z "
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157" />
-    <path
-       sodipodi:type="arc"
-       style="fill:#000000"
-       id="path9652"
-       sodipodi:cx="292.14285"
-       sodipodi:cy="181.95163"
-       sodipodi:rx="15"
-       sodipodi:ry="15"
-       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
-       transform="translate(-194.48896,372.41254)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157" />
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="87.591393"
-       y="566.02826"
-       id="text9654"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157"><tspan
-         sodipodi:role="line"
-         id="tspan9656"
-         x="87.591393"
-         y="566.02826">4</tspan></text>
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="119.03906"
-       y="543.19232"
-       id="text9658"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157"><tspan
-         sodipodi:role="line"
-         id="tspan9660"
-         x="119.03906"
-         y="543.19232">merge changes</tspan><tspan
-         sodipodi:role="line"
-         x="119.03906"
-         y="583.19232"
-         id="tspan2716">from peer</tspan></text>
-    <path
-       sodipodi:type="arc"
-       style="fill:#000000"
-       id="path2670"
-       sodipodi:cx="292.14285"
-       sodipodi:cy="181.95163"
-       sodipodi:rx="15"
-       sodipodi:ry="15"
-       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
-       transform="translate(-187.14285,5.361605)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157" />
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="94.539062"
-       y="198.97729"
-       id="text2672"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157"><tspan
-         sodipodi:role="line"
-         id="tspan2674"
-         x="94.539062"
-         y="198.97729">1</tspan></text>
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="129.5625"
-       y="195.43823"
-       id="text2676"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157"><tspan
-         sodipodi:role="line"
-         id="tspan2678"
-         x="129.5625"
-         y="195.43823">start project</tspan></text>
-    <path
-       sodipodi:type="arc"
-       style="fill:#000000"
-       id="path2680"
-       sodipodi:cx="292.14285"
-       sodipodi:cy="181.95163"
-       sodipodi:rx="15"
-       sodipodi:ry="15"
-       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
-       transform="translate(-20.189728,217.62723)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157" />
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="261.83594"
-       y="411.22729"
-       id="text2682"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157"><tspan
-         sodipodi:role="line"
-         id="tspan2684"
-         x="261.83594"
-         y="411.22729">3</tspan></text>
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="294.51562"
-       y="388.40698"
-       id="text2686"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157"><tspan
-         sodipodi:role="line"
-         id="tspan2688"
-         x="294.51562"
-         y="388.40698">record</tspan><tspan
-         sodipodi:role="line"
-         x="294.51562"
-         y="428.40698"
-         id="tspan2712">changes</tspan></text>
-    <path
-       sodipodi:type="arc"
-       style="fill:#000000"
-       id="path2690"
-       sodipodi:cx="292.14285"
-       sodipodi:cy="181.95163"
-       sodipodi:rx="15"
-       sodipodi:ry="15"
-       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
-       transform="translate(321.8001,372.41254)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157" />
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="603.88049"
-       y="566.02826"
-       id="text2692"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157"><tspan
-         sodipodi:role="line"
-         id="tspan2694"
-         x="603.88049"
-         y="566.02826">4</tspan></text>
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="635.32812"
-       y="543.19232"
-       id="text2696"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157"><tspan
-         sodipodi:role="line"
-         id="tspan2698"
-         x="635.32812"
-         y="543.19232">merge changes</tspan><tspan
-         sodipodi:role="line"
-         x="635.32812"
-         y="583.19232"
-         id="tspan2718">from peer</tspan></text>
-    <path
-       sodipodi:type="arc"
-       style="fill:#000000"
-       id="path2700"
-       sodipodi:cx="292.14285"
-       sodipodi:cy="181.95163"
-       sodipodi:rx="15"
-       sodipodi:ry="15"
-       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
-       transform="translate(462.85715,216.65848)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157" />
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="744.88281"
-       y="410.25854"
-       id="text2702"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157"><tspan
-         sodipodi:role="line"
-         id="tspan2704"
-         x="744.88281"
-         y="410.25854">3</tspan></text>
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="777.5625"
-       y="387.43823"
-       id="text2706"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157"><tspan
-         sodipodi:role="line"
-         id="tspan2708"
-         x="777.5625"
-         y="387.43823">record</tspan><tspan
-         sodipodi:role="line"
-         x="777.5625"
-         y="427.43823"
-         id="tspan2714">changes</tspan></text>
-    <path
-       inkscape:export-ydpi="41.964157"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
-       d="M 515.71461,505.61603 L 459.61109,512.93314 L 464.41997,501.8724 L 433.50612,505.4459 C 433.50612,505.4459 428.69724,516.84691 428.46828,516.84691 C 428.23904,516.84691 417.24757,502.04254 417.24757,502.04254 C 417.24757,502.04254 443.12359,486.55741 443.35254,486.55741 C 443.12359,486.21714 438.54366,497.44823 438.54366,497.61837 L 474.26697,493.87453 L 469.45781,505.27576 L 520.75243,498.12878 L 515.71461,505.61603 z "
-       id="path2710"
-       sodipodi:nodetypes="cccccccccccc"
-       style="fill:none;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:2.49513507;stroke-linecap:butt;stroke-linejoin:round;stroke-dasharray:none;stroke-opacity:1" />
-  </g>
-</svg>

=== removed file 'doc/en/user-guide/images/workflows_pqm.png'
Binary files doc/en/user-guide/images/workflows_pqm.png and doc/en/user-guide/images/workflows_pqm.png differ
=== removed file 'doc/en/user-guide/images/workflows_pqm.svg'
--- doc/en/user-guide/images/workflows_pqm.svg	2007-11-30 04:34:08 +0000
+++ doc/en/user-guide/images/workflows_pqm.svg	1970-01-01 00:00:00 +0000
@@ -1,1794 +0,0 @@
-<?xml version="1.0" encoding="UTF-8" standalone="no"?>
-<!-- Created with Inkscape (http://www.inkscape.org/) -->
-<svg
-   xmlns:dc="http://purl.org/dc/elements/1.1/"
-   xmlns:cc="http://web.resource.org/cc/"
-   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
-   xmlns:svg="http://www.w3.org/2000/svg"
-   xmlns="http://www.w3.org/2000/svg"
-   xmlns:xlink="http://www.w3.org/1999/xlink"
-   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"
-   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"
-   width="1052.3622"
-   height="744.09448"
-   id="svg2"
-   sodipodi:version="0.32"
-   inkscape:version="0.45.1"
-   version="1.0"
-   sodipodi:docbase="/home/ian/Desktop/talk/workflows"
-   sodipodi:docname="workflows_pqm.svg"
-   inkscape:output_extension="org.inkscape.output.svg.inkscape"
-   inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_pqm.png"
-   inkscape:export-xdpi="90"
-   inkscape:export-ydpi="90">
-  <defs
-     id="defs4">
-    <radialGradient
-       xlink:href="#linearGradient5992"
-       r="33.156250"
-       inkscape:collect="always"
-       id="radialGradient6000"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(1.000000,0.000000,0.000000,1.693685,0.000000,-197.9515)"
-       fy="285.36218"
-       fx="495.50000"
-       cy="285.36218"
-       cx="495.50000" />
-    <linearGradient
-       y2="187.57059"
-       y1="225.40080"
-       xlink:href="#linearGradient5963"
-       x2="458.91232"
-       x1="383.95898"
-       inkscape:collect="always"
-       id="linearGradient5969"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       id="linearGradient3586">
-      <stop
-         style="stop-color:#000000;stop-opacity:1.0000000;"
-         offset="0.0000000"
-         id="stop3588" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0;"
-         offset="1"
-         id="stop3590" />
-    </linearGradient>
-    <linearGradient
-       inkscape:collect="always"
-       id="linearGradient5963">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:1;"
-         offset="0"
-         id="stop5965" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0;"
-         offset="1"
-         id="stop5967" />
-    </linearGradient>
-    <linearGradient
-       inkscape:collect="always"
-       id="linearGradient5992">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:1;"
-         offset="0"
-         id="stop5994" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0;"
-         offset="1"
-         id="stop5996" />
-    </linearGradient>
-    <linearGradient
-       y2="-0.45783132"
-       y1="3.3012049"
-       xlink:href="#linearGradient893"
-       x2="0.92957747"
-       x1="-2.3960868e-17"
-       id="linearGradient4284" />
-    <linearGradient
-       y2="-0.033519555"
-       y1="2.0837989"
-       xlink:href="#linearGradient893"
-       x2="0.99074072"
-       x1="-0.77314812"
-       id="linearGradient4283" />
-    <linearGradient
-       y2="1.8771822"
-       y1="-0.033741195"
-       xlink:href="#linearGradient902"
-       x2="0.48453596"
-       x1="0.47041038"
-       id="linearGradient2740"
-       gradientTransform="scale(0.997153,1.002855)" />
-    <linearGradient
-       y2="1.9025002"
-       y1="-0.043652620"
-       xlink:href="#linearGradient902"
-       x2="0.48481107"
-       x1="0.47042510"
-       id="linearGradient1506"
-       gradientTransform="scale(0.995847,1.004170)" />
-    <linearGradient
-       y2="1.8570156"
-       y1="-0.024853170"
-       xlink:href="#linearGradient902"
-       x2="0.48548824"
-       x1="0.47157744"
-       id="linearGradient1505"
-       gradientTransform="scale(0.997825,1.002180)" />
-    <linearGradient
-       y2="182.99154"
-       y1="169.09755"
-       xlink:href="#linearGradient892"
-       x2="88.996957"
-       x1="88.755695"
-       id="linearGradient1404"
-       gradientTransform="scale(1.3695887,0.7301462)"
-       gradientUnits="userSpaceOnUse" />
-    <radialGradient
-       xlink:href="#linearGradient1317"
-       r="0.34964636"
-       id="radialGradient1316"
-       fy="0.18269235"
-       fx="0.50352114"
-       cy="0.50000006"
-       cx="0.50000000" />
-    <radialGradient
-       xlink:href="#linearGradient1317"
-       r="0.41197181"
-       id="radialGradient1315"
-       fy="0.26666668"
-       fx="0.47535211"
-       cy="0.53333336"
-       cx="0.47887325" />
-    <linearGradient
-       y2="173.03153"
-       y1="177.77768"
-       xlink:href="#linearGradient902"
-       x2="95.100155"
-       x1="101.10657"
-       id="linearGradient1171"
-       gradientTransform="scale(1.3601783,0.7351977)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="1.8378206"
-       y1="-0.016295359"
-       xlink:href="#linearGradient902"
-       x2="0.48655096"
-       x1="0.47284532"
-       id="linearGradient1170"
-       gradientTransform="scale(0.998371,1.001632)" />
-    <linearGradient
-       y2="81.477602"
-       y1="224.57898"
-       xlink:href="#linearGradient893"
-       x2="74.533693"
-       x1="146.69923"
-       id="linearGradient1169"
-       gradientTransform="scale(1.1870691,0.842411)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="133.54711"
-       y1="228.39311"
-       xlink:href="#linearGradient888"
-       x2="88.447016"
-       x1="141.60217"
-       id="linearGradient1167"
-       gradientTransform="scale(1.1838753,0.8446836)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="148.78619"
-       y1="131.25248"
-       xlink:href="#linearGradient1317"
-       x2="107.04918"
-       x1="111.49758"
-       id="linearGradient1166"
-       gradientTransform="scale(1.223869,0.8170809)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="176.28694"
-       y1="269.85831"
-       xlink:href="#linearGradient888"
-       x2="-16.224496"
-       x1="51.460928"
-       id="linearGradient1157"
-       gradientTransform="scale(2.4217071,0.4129318)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="234.26866"
-       y1="178.48862"
-       xlink:href="#linearGradient888"
-       x2="25.220815"
-       x1="25.220815"
-       id="linearGradient1156"
-       gradientTransform="scale(2.4217071,0.4129318)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="105.42543"
-       y1="76.277559"
-       xlink:href="#linearGradient892"
-       x2="8.346058"
-       x1="35.190362"
-       id="linearGradient1150"
-       gradientTransform="scale(1.3283861,0.7527932)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="20.481863"
-       y1="49.507656"
-       xlink:href="#linearGradient892"
-       x2="70.224305"
-       x1="39.690614"
-       id="linearGradient1148"
-       gradientTransform="scale(1.329144,0.7523639)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="113.71949"
-       y1="90.197025"
-       xlink:href="#linearGradient892"
-       x2="17.876529"
-       x1="39.810948"
-       id="linearGradient1146"
-       gradientTransform="scale(1.3207392,0.7571517)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="251.21892"
-       y1="203.499"
-       xlink:href="#linearGradient892"
-       x2="31.617281"
-       x1="31.449743"
-       id="linearGradient1144"
-       gradientTransform="scale(2.1051174,0.4750329)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="-0.45783132"
-       y1="3.3012049"
-       xlink:href="#linearGradient888"
-       x2="0.92957747"
-       x1="0.00000000"
-       id="linearGradient1141" />
-    <linearGradient
-       y2="232.24952"
-       y1="110.4447"
-       xlink:href="#linearGradient888"
-       x2="41.967061"
-       x1="45.685757"
-       id="linearGradient1140"
-       gradientTransform="scale(1.9102155,0.5235012)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="75.912531"
-       y1="375.92199"
-       xlink:href="#linearGradient1806"
-       x2="-268.25407"
-       x1="-249.72067"
-       id="linearGradient1138"
-       gradientTransform="scale(1.087146,0.9198397)"
-       gradientUnits="userSpaceOnUse" />
-    <radialGradient
-       xlink:href="#linearGradient1133"
-       r="68.589222"
-       id="radialGradient1132"
-       fy="39.288476"
-       fx="72.107883"
-       cy="56.485935"
-       cx="60.004654"
-       gradientTransform="scale(1.2267534,0.8151598)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="11.699047"
-       y1="208.43991"
-       xlink:href="#linearGradient888"
-       x2="95.644441"
-       x1="-77.726178"
-       id="linearGradient905"
-       gradientTransform="scale(1.0964158,0.9120627)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       xlink:href="#linearGradient1806"
-       id="linearGradient901" />
-    <linearGradient
-       y2="91.07699"
-       y1="-3.9104078"
-       xlink:href="#linearGradient888"
-       x2="27.674331"
-       x1="92.437968"
-       id="linearGradient891"
-       gradientTransform="scale(1.2267534,0.8151598)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       id="linearGradient888">
-      <stop
-         style="stop-color:#626262;stop-opacity:1.0000000;"
-         offset="0.0000000"
-         id="stop889" />
-      <stop
-         style="stop-color:#fff;stop-opacity:1;"
-         offset="1"
-         id="stop890" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient892">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.00000000;"
-         offset="0.00000000"
-         id="stop893" />
-      <stop
-         style="stop-color:#fff;stop-opacity:1;"
-         offset="1"
-         id="stop894" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient902">
-      <stop
-         style="stop-color:#000000;stop-opacity:0.00000000;"
-         offset="0.00000000"
-         id="stop903" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0.22000000;"
-         offset="1.0000000"
-         id="stop904" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient1098">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:1.0000000;"
-         offset="0.00000000"
-         id="stop1099" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.22314049;"
-         offset="0.50000000"
-         id="stop1101" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.00000000;"
-         offset="0.59930235"
-         id="stop1102" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.60330576;"
-         offset="1.0000000"
-         id="stop1100" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient1133">
-      <stop
-         style="stop-color:#8bb7df;stop-opacity:1.0000000;"
-         offset="0.00000000"
-         id="stop1134" />
-      <stop
-         style="stop-color:#2a6092;stop-opacity:1.0000000;"
-         offset="0.76209301"
-         id="stop1136" />
-      <stop
-         style="stop-color:#375e82;stop-opacity:1.0000000;"
-         offset="1.0000000"
-         id="stop1135" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient1317">
-      <stop
-         style="stop-color:#000000;stop-opacity:0.52892560;"
-         offset="0.00000000"
-         id="stop1318" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0.17355372;"
-         offset="0.50000000"
-         id="stop1320" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0.00000000;"
-         offset="1.0000000"
-         id="stop1319" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient893">
-      <stop
-         style="stop-color:#000;stop-opacity:1;"
-         offset="0"
-         id="stop895" />
-      <stop
-         style="stop-color:#fff;stop-opacity:1;"
-         offset="1"
-         id="stop896" />
-    </linearGradient>
-    <radialGradient
-       xlink:href="#linearGradient1806"
-       r="11.574221"
-       id="radialGradient1977"
-       fy="39.410465"
-       fx="42.280806"
-       cy="39.007645"
-       cx="42.007257"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       id="linearGradient1806">
-      <stop
-         style="stop-color:#000000;stop-opacity:0.35051546;"
-         offset="0.0000000"
-         id="stop1807" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0.13402061;"
-         offset="0.64999998"
-         id="stop3276" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop1808" />
-    </linearGradient>
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient5281"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient5283"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient5285"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <radialGradient
-       xlink:href="#linearGradient4362"
-       r="5.5130484"
-       inkscape:collect="always"
-       id="radialGradient1828"
-       fy="61.38567"
-       fx="86.542037"
-       cy="61.38567"
-       cx="86.542037"
-       gradientTransform="matrix(-0.8164966,0,0,1.2247449,262.80373,-280)"
-       gradientUnits="userSpaceOnUse" />
-    <radialGradient
-       xlink:href="#linearGradient4362"
-       r="11.123441"
-       inkscape:collect="always"
-       id="radialGradient1824"
-       fy="58.887858"
-       fx="118.06427"
-       cy="58.54025"
-       cx="117.17439"
-       gradientTransform="matrix(-0.6229142,0,0,1.6053575,262.80373,-280)"
-       gradientUnits="userSpaceOnUse" />
-    <radialGradient
-       xlink:href="#linearGradient4362"
-       r="22.00904"
-       inkscape:collect="always"
-       id="radialGradient1822"
-       fy="87.892895"
-       fx="45.50637"
-       cy="88.322677"
-       cx="45.139623"
-       gradientTransform="matrix(-1.0914815,0,0,0.9161859,262.80373,-280)"
-       gradientUnits="userSpaceOnUse" />
-    <radialGradient
-       xlink:href="#linearGradient4362"
-       r="18.836343"
-       inkscape:collect="always"
-       id="radialGradient1818"
-       fy="33.351633"
-       fx="48.40165"
-       cy="32.467054"
-       cx="48.40165"
-       gradientTransform="matrix(-1.1146027,0,0,0.8971807,262.80373,-280)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="74.834393"
-       y1="57.093738"
-       xlink:href="#linearGradient4376"
-       x2="50.203204"
-       x1="50.52668"
-       inkscape:collect="always"
-       id="linearGradient1815"
-       gradientTransform="matrix(-1.3516689,0,0,0.7398261,262.80373,-280)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       id="linearGradient4384">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.77513230;"
-         offset="0.0000000"
-         id="stop4385" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop4386" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient4376">
-      <stop
-         style="stop-color:#000000;stop-opacity:0.52645504;"
-         offset="0.0000000"
-         id="stop4377" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop4378" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient4362">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.66666669;"
-         offset="0.0000000"
-         id="stop4363" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop4364" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient4358">
-      <stop
-         style="stop-color:#000;stop-opacity:1;"
-         offset="0"
-         id="stop4359" />
-      <stop
-         style="stop-color:#fff;stop-opacity:1;"
-         offset="1"
-         id="stop4360" />
-    </linearGradient>
-    <radialGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="radialGradient5536"
-       gradientUnits="userSpaceOnUse"
-       cx="42.007257"
-       cy="39.007645"
-       fx="42.280806"
-       fy="39.410465"
-       r="11.574221" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient5538"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient5540"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient5542"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient5544"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient888"
-       id="linearGradient5546"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(2.4217071,0.4129318)"
-       x1="25.220815"
-       y1="178.48862"
-       x2="25.220815"
-       y2="234.26866" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient888"
-       id="linearGradient5548"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(2.4217071,0.4129318)"
-       x1="51.460928"
-       y1="269.85831"
-       x2="-16.224496"
-       y2="176.28694" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient893"
-       id="linearGradient5550"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.1870691,0.842411)"
-       x1="146.69923"
-       y1="224.57898"
-       x2="74.533693"
-       y2="81.477602" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient888"
-       id="linearGradient5552"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.9102155,0.5235012)"
-       x1="45.685757"
-       y1="110.4447"
-       x2="41.967061"
-       y2="232.24952" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient888"
-       id="linearGradient5554"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.0964158,0.9120627)"
-       x1="-77.726178"
-       y1="208.43991"
-       x2="95.644441"
-       y2="11.699047" />
-    <radialGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1133"
-       id="radialGradient5556"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.2267534,0.8151598)"
-       cx="60.004654"
-       cy="56.485935"
-       fx="72.107883"
-       fy="39.288476"
-       r="68.589222" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient888"
-       id="linearGradient5558"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.2267534,0.8151598)"
-       x1="92.437968"
-       y1="-3.9104078"
-       x2="27.674331"
-       y2="91.07699" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient892"
-       id="linearGradient5560"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.3207392,0.7571517)"
-       x1="39.810948"
-       y1="90.197025"
-       x2="17.876529"
-       y2="113.71949" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient892"
-       id="linearGradient5562"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.329144,0.7523639)"
-       x1="39.690614"
-       y1="49.507656"
-       x2="70.224305"
-       y2="20.481863" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient892"
-       id="linearGradient5564"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.3283861,0.7527932)"
-       x1="35.190362"
-       y1="76.277559"
-       x2="8.346058"
-       y2="105.42543" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient888"
-       id="linearGradient5566"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.1838753,0.8446836)"
-       x1="141.60217"
-       y1="228.39311"
-       x2="88.447016"
-       y2="133.54711" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient902"
-       id="linearGradient5568"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.3601783,0.7351977)"
-       x1="101.10657"
-       y1="177.77768"
-       x2="95.100155"
-       y2="173.03153" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient892"
-       id="linearGradient5570"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.3695887,0.7301462)"
-       x1="88.755695"
-       y1="169.09755"
-       x2="88.996957"
-       y2="182.99154" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1317"
-       id="linearGradient5572"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.223869,0.8170809)"
-       x1="111.49758"
-       y1="131.25248"
-       x2="107.04918"
-       y2="148.78619" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient892"
-       id="linearGradient5574"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(2.1051174,0.4750329)"
-       x1="31.449743"
-       y1="203.499"
-       x2="31.617281"
-       y2="251.21892" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient5714"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <radialGradient
-       xlink:href="#linearGradient4362"
-       r="39.648127"
-       inkscape:collect="always"
-       id="radialGradient2797"
-       fy="101.92288"
-       fx="50.092871"
-       cy="102.70191"
-       cx="49.760482"
-       gradientTransform="scale(1.1222336,0.8910801)"
-       gradientUnits="userSpaceOnUse" />
-    <radialGradient
-       xlink:href="#linearGradient4362"
-       r="35.284406"
-       inkscape:collect="always"
-       id="radialGradient2791"
-       fy="32.061308"
-       fx="81.553592"
-       cy="33.402904"
-       cx="80.599566"
-       gradientTransform="scale(0.8352269,1.1972794)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="67.164412"
-       y1="53.505203"
-       xlink:href="#linearGradient4376"
-       x2="63.804663"
-       x1="64.786456"
-       inkscape:collect="always"
-       id="linearGradient2789"
-       gradientTransform="scale(1.1424512,0.8753109)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       id="linearGradient6015">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.77513230;"
-         offset="0.0000000"
-         id="stop6017" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop6019" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient6009">
-      <stop
-         style="stop-color:#000000;stop-opacity:0.52645504;"
-         offset="0.0000000"
-         id="stop6011" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop6013" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient6003">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.66666669;"
-         offset="0.0000000"
-         id="stop6005" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop6007" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient5997">
-      <stop
-         style="stop-color:#000;stop-opacity:1;"
-         offset="0"
-         id="stop5999" />
-      <stop
-         style="stop-color:#fff;stop-opacity:1;"
-         offset="1"
-         id="stop6001" />
-    </linearGradient>
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient6037"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <linearGradient
-       y2="0.46093750"
-       y1="0.46093750"
-       xlink:href="#linearGradient650"
-       x2="1.16666818"
-       x1="1.22222710"
-       spreadMethod="repeat"
-       id="linearGradient654"
-       gradientUnits="objectBoundingBox" />
-    <linearGradient
-       y2="0.53906250"
-       y1="0.53125000"
-       xlink:href="#linearGradient650"
-       x2="1.16666901"
-       x1="1.00000548"
-       spreadMethod="repeat"
-       id="linearGradient653"
-       gradientUnits="objectBoundingBox" />
-    <linearGradient
-       id="linearGradient650">
-      <stop
-         style="stop-color:#000;stop-opacity:1;"
-         offset="0"
-         id="stop651" />
-      <stop
-         style="stop-color:#fff;stop-opacity:1;"
-         offset="1"
-         id="stop652" />
-    </linearGradient>
-    <linearGradient
-       y2="0.46093750"
-       y1="0.46093750"
-       xlink:href="#linearGradient650"
-       x2="1.16666818"
-       x1="1.22222710"
-       spreadMethod="repeat"
-       id="linearGradient9648"
-       gradientUnits="objectBoundingBox" />
-    <linearGradient
-       y2="0.53906250"
-       y1="0.53125000"
-       xlink:href="#linearGradient650"
-       x2="1.16666901"
-       x1="1.00000548"
-       spreadMethod="repeat"
-       id="linearGradient9646"
-       gradientUnits="objectBoundingBox" />
-    <linearGradient
-       id="linearGradient9640">
-      <stop
-         style="stop-color:#000;stop-opacity:1;"
-         offset="0"
-         id="stop9642" />
-      <stop
-         style="stop-color:#fff;stop-opacity:1;"
-         offset="1"
-         id="stop9644" />
-    </linearGradient>
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient7934"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <linearGradient
-       id="linearGradient1858">
-      <stop
-         style="stop-color:#000;stop-opacity:1;"
-         offset="0"
-         id="stop1859" />
-      <stop
-         style="stop-color:#fff;stop-opacity:1;"
-         offset="1"
-         id="stop1860" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient1861">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.66666669;"
-         offset="0.0000000"
-         id="stop1862" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop1863" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient1864">
-      <stop
-         style="stop-color:#000000;stop-opacity:0.52645504;"
-         offset="0.0000000"
-         id="stop1865" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop1866" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient1867">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.77513230;"
-         offset="0.0000000"
-         id="stop1868" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop1869" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient11180">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.77513230;"
-         offset="0.0000000"
-         id="stop11182" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop11184" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient11174">
-      <stop
-         style="stop-color:#000000;stop-opacity:0.52645504;"
-         offset="0.0000000"
-         id="stop11176" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop11178" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient11168">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.66666669;"
-         offset="0.0000000"
-         id="stop11170" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop11172" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient11162">
-      <stop
-         style="stop-color:#000;stop-opacity:1;"
-         offset="0"
-         id="stop11164" />
-      <stop
-         style="stop-color:#fff;stop-opacity:1;"
-         offset="1"
-         id="stop11166" />
-    </linearGradient>
-  </defs>
-  <sodipodi:namedview
-     id="base"
-     pagecolor="#ffffff"
-     bordercolor="#666666"
-     borderopacity="1.0"
-     gridtolerance="10000"
-     guidetolerance="10"
-     objecttolerance="10"
-     inkscape:pageopacity="0.0"
-     inkscape:pageshadow="2"
-     inkscape:zoom="1"
-     inkscape:cx="559.94128"
-     inkscape:cy="392.13154"
-     inkscape:document-units="px"
-     inkscape:current-layer="layer1"
-     width="1052.3622px"
-     height="744.09448px"
-     showgrid="true"
-     inkscape:window-width="1416"
-     inkscape:window-height="825"
-     inkscape:window-x="0"
-     inkscape:window-y="25" />
-  <metadata
-     id="metadata7">
-    <rdf:RDF>
-      <cc:Work
-         rdf:about="">
-        <dc:format>image/svg+xml</dc:format>
-        <dc:type
-           rdf:resource="http://purl.org/dc/dcmitype/StillImage" />
-      </cc:Work>
-    </rdf:RDF>
-  </metadata>
-  <g
-     inkscape:label="Layer 1"
-     inkscape:groupmode="layer"
-     id="layer1">
-    <path
-       sodipodi:type="arc"
-       style="fill:#000000"
-       id="path2791"
-       sodipodi:cx="292.14285"
-       sodipodi:cy="181.95163"
-       sodipodi:rx="15"
-       sodipodi:ry="15"
-       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
-       transform="translate(562.85715,227.14285)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644" />
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="844.88281"
-       y="420.74292"
-       id="text2793"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644"><tspan
-         sodipodi:role="line"
-         id="tspan2795"
-         x="844.88281"
-         y="420.74292">3</tspan></text>
-    <g
-       inkscape:label="Layer 1"
-       id="g4996"
-       transform="matrix(0.331077,0,0,0.2676656,39.992157,230.68349)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644">
-      <g
-         transform="matrix(2.674162,0,0,2.674162,-826.248,-323.8239)"
-         id="g6052">
-        <path
-           style="fill:#c7c7c7;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:6.11299896;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
-           sodipodi:nodetypes="czcczzz"
-           id="path1306"
-           d="M 362.77592,187.283 C 360.50343,190.98677 361.20593,367.68763 364.14011,374.65173 C 366.46268,380.1642 441.02381,442.12988 444.93699,443.78694 C 495.35017,443.444 529.34176,425.0858 534.99109,415.38735 C 537.14042,403.1889 535.31621,215.19709 533.25552,211.25359 C 531.47859,207.85312 436.04893,173.6386 432.71615,172.86054 C 429.71763,172.16052 365.30189,183.1661 362.77592,187.283 z " />
-        <path
-           style="fill:#ffffff;fill-opacity:0.54385968;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
-           sodipodi:nodetypes="ccccccc"
-           id="path2066"
-           d="M 366.42857,190.93361 C 391.19048,201.4098 418.60601,218.30739 446.22506,231.64072 C 472.394,225.42153 510.2022,217.10972 529.24981,213.77639 C 504.726,221.39543 472.52022,228.51448 447.99641,236.13353 C 446.56784,293.51448 447.257,380.45861 445.82843,437.83956 C 445.11414,379.98242 443.14285,291.6479 442.42856,233.79075 C 415.99999,219.50504 390,206.64789 366.42857,190.93361 z " />
-        <path
-           style="fill:#000000;fill-opacity:0.16228069;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
-           sodipodi:nodetypes="ccc"
-           id="path4356"
-           d="M 519.99794,379.97737 C 510.93834,392.99882 482.41849,399.43361 468.8726,394.16864 C 471.21835,393.5424 516.96143,380.96883 519.99794,379.97737 z " />
-        <g
-           transform="translate(2.035534,15.20712)"
-           id="g4374">
-          <path
-             style="fill:#ffffff;fill-opacity:0.39473685;fill-rule:evenodd;stroke:none;stroke-width:1.01199996;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
-             sodipodi:nodetypes="cccccc"
-             id="path4362"
-             d="M 471.29127,340.59039 L 513.55921,324.30516 C 517.9002,325.84805 517.04588,332.27818 517.04588,332.27818 L 510.46155,334.58088 C 510.46155,334.58088 501.26764,349.01224 484.93096,343.36795 C 484.93096,343.36795 472.7787,345.52605 471.29127,340.59039 z " />
-          <path
-             style="fill:#606060;fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:1.11199999;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
-             sodipodi:nodetypes="ccccccc"
-             id="path2826"
-             d="M 471.66824,335.10501 C 485.70133,331.45482 499.73443,327.80464 513.76752,324.15445 C 514.30594,326.13864 514.34437,328.99782 513.50779,330.48201 C 511.36566,331.50652 507.10221,332.35425 504.96008,333.37876 C 498.80357,339.27354 493.45917,339.80363 483.65919,338.95243 C 479.87505,339.74603 476.0909,340.36284 472.30676,341.15644 C 471.15285,338.85897 470.82215,337.90248 471.66824,335.10501 z " />
-        </g>
-        <path
-           style="fill:#ffffff;fill-opacity:0.40350874;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
-           sodipodi:nodetypes="ccccc"
-           id="path4423"
-           d="M 364.8671,189.69191 L 446.71991,235.61832 L 446.39149,441.00771 L 366.28132,373.53968 L 364.8671,189.69191 z " />
-        <path
-           style="fill:#000000;fill-opacity:0.16228069;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
-           sodipodi:nodetypes="ccc"
-           id="path5957"
-           d="M 515.24794,392.97737 C 505.81506,405.42036 486.94113,407.56087 476.3726,403.76831 C 478.1563,403.29212 512.93901,393.73127 515.24794,392.97737 z " />
-        <path
-           style="fill:#000000;fill-opacity:0.16228069;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
-           sodipodi:nodetypes="ccc"
-           id="path5959"
-           d="M 508.24794,405.72737 C 502.79158,413.09279 492.2492,415.37141 483.8726,412.49343 C 484.991,412.19485 506.80021,406.20008 508.24794,405.72737 z " />
-        <path
-           style="fill:#fcfcfc;fill-opacity:0.44298245;fill-rule:evenodd;stroke:none;stroke-width:0.31200001;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
-           sodipodi:nodetypes="ccccccc"
-           id="path5973"
-           d="M 522.875,227.86218 L 527.04289,228.4302 L 527.79289,326.56929 L 463.46862,344.54896 L 461.88388,339.34073 L 523.68934,322.86218 L 522.875,227.86218 z " />
-        <path
-           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
-           sodipodi:nodetypes="cccc"
-           id="path6026"
-           d="M 462.21967,264.23013 L 462.31434,266.99086 L 522.7929,249.54632 L 462.21967,264.23013 z " />
-        <path
-           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
-           sodipodi:nodetypes="cccc"
-           id="path6036"
-           d="M 461.33579,284.2059 L 461.43046,286.96663 L 521.90902,269.52209 L 461.33579,284.2059 z " />
-        <path
-           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
-           sodipodi:nodetypes="cccc"
-           id="path6038"
-           d="M 462.21967,302.64613 L 462.31434,305.40686 L 522.7929,287.96232 L 462.21967,302.64613 z " />
-        <path
-           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
-           sodipodi:nodetypes="cccc"
-           id="path6040"
-           d="M 462.21967,320.79868 L 462.31434,323.55941 L 522.7929,306.11487 L 462.21967,320.79868 z " />
-        <path
-           style="opacity:1;color:#000000;fill:none;fill-opacity:0.75;fill-rule:evenodd;stroke:#9e9e9e;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
-           sodipodi:nodetypes="ccc"
-           id="path5988"
-           d="M 522.55191,229.64344 L 462.03362,244.76045 L 462.53549,344.35813" />
-      </g>
-    </g>
-    <g
-       id="g5256"
-       transform="translate(601.5744,227.66157)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644">
-      <path
-         transform="matrix(6.392368,0.545409,-0.130014,2.864752,-184.6606,-38.15109)"
-         style="fill:url(#radialGradient1977);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:type="arc"
-         sodipodi:ry="12.562782"
-         sodipodi:rx="12.562782"
-         sodipodi:cy="37.865574"
-         sodipodi:cx="41.875938"
-         id="path1976"
-         d="M 54.438721 37.865574 A 12.562782 12.562782 0 1 1  29.313156,37.865574 A 12.562782 12.562782 0 1 1  54.438721 37.865574 z" />
-      <g
-         transform="matrix(1,0,0,1.036969,356.8306,-11.4294)"
-         style="fill:url(#linearGradient6037);fill-opacity:1"
-         id="g4293">
-        <path
-           style="fill:url(#linearGradient5281);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
-           id="path2720"
-           d="M -270.85787,33.814995 C -289.35564,33.925992 -307.93321,33.592782 -326.38104,33.981747 C -331.43469,35.696391 -331.02221,41.899652 -330.68524,46.15332 C -330.75782,60.227303 -330.53537,74.298225 -330.21167,88.36826 C -328.21297,91.039611 -323.21766,90.618387 -322.68469,94.539015 C -320.78054,96.259426 -317.05071,94.88215 -314.4389,95.333237 C -298.54999,95.360274 -282.66107,95.387302 -266.77215,95.414339 C -266.35587,90.465192 -260.12609,88.824447 -255.81783,89.540255 C -256.01688,89.058389 -261.69557,87.939375 -259.61591,84.491525 C -259.45681,68.72727 -259.19734,52.882199 -259.82064,37.168229 C -261.19394,32.980583 -267.34179,33.83368 -270.85787,33.814995 z M -236.65184,97.260473 C -234.79025,100.12642 -237.08724,103.09386 -239.92892,104.16357 C -242.6311,105.91539 -245.59105,107.62992 -248.52894,108.76804 C -253.1773,108.19079 -251.42424,101.88475 -255.01281,99.896645 C -260.33594,96.447012 -267.21045,98.43943 -273.23329,97.939231 C -291.8249,97.94887 -310.41651,97.958519 -329.00813,97.968158 C -335.45898,103.56578 -339.16595,111.40269 -341.55034,119.32178 C -337.25147,124.2061 -329.89606,122.27575 -324.10438,122.40002 C -298.64553,122.23171 -273.11679,122.61546 -247.69897,122.24542 C -243.40174,121.14669 -247.44685,114.84894 -243.58488,113.04441 C -242.73865,112.73374 -247.81245,114.4382 -247.26205,111.62955 C -245.49117,106.66028 -239.14113,105.99595 -235.92338,102.36811 C -234.39131,99.755669 -236.26958,96.922488 -238.33047,95.260495 C -237.77093,95.927151 -237.21138,96.593817 -236.65184,97.260473 z M -240.64255,111.75263 C -243.64086,113.13223 -237.02792,110.69536 -235.55512,111.97369 C -229.71113,112.74417 -224.16461,117.19625 -218.12358,115.22951 C -225.97639,116.31604 -232.799,109.03014 -240.64255,111.75263 z M -212.01083,112.33724 C -215.98173,113.85021 -208.21543,112.17765 -210.07883,115.87566 C -212.50961,119.93855 -206.99008,113.8662 -209.61436,112.54677 C -210.16198,111.94632 -211.27989,112.47663 -212.01083,112.33724 z M -213.97451,120.82946 C -220.13871,124.32615 -228.37873,119.08124 -233.85995,124.39439 C -238.36465,128.00055 -244.57099,130.35185 -247.0433,135.75122 C -247.65922,139.60202 -243.25109,141.90251 -240.44565,143.71808 C -235.60127,146.54512 -228.8227,145.75388 -225.20082,141.42836 C -220.62679,137.96117 -216.44182,134.08489 -212.48592,129.96782 C -212.82701,126.95048 -214.43694,123.63971 -213.97451,120.82946 z " />
-        <path
-           style="fill:url(#linearGradient5283);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
-           id="path2723"
-           d="M -269.68453,32.256957 C -288.76965,32.351184 -307.87514,32.249603 -326.94796,32.349264 C -332.63884,33.663474 -333.90446,40.291305 -333.21597,45.149113 C -333.11996,59.896901 -333.07471,74.659754 -332.61729,89.39481 C -331.88583,93.310348 -324.86009,92.098674 -325.11097,96.44089 C -328.07184,96.184706 -331.5534,96.317135 -333.07248,99.246492 C -338.92562,104.98392 -341.99312,112.66465 -344.27268,120.28679 C -340.22572,125.96631 -332.26467,125.31453 -326.02946,124.71751 C -300.16629,124.7277 -274.28316,124.82043 -248.43245,124.77905 C -244.42424,124.78686 -243.30672,120.35609 -243.96666,117.2099 C -242.88598,112.93536 -237.04086,113.94554 -233.80717,114.98513 C -228.01851,116.64297 -221.26418,120.43074 -215.57982,116.37592 C -211.36091,113.71809 -213.05678,118.4029 -215.77936,119.43344 C -220.82539,122.25797 -227.09125,118.98178 -232.39677,121.20855 C -236.53238,123.88957 -240.74707,126.85249 -244.76678,129.74666 C -248.34219,132.01467 -251.90947,137.38626 -248.13747,140.97315 C -243.79274,146.02948 -236.37425,149.4527 -229.68248,147.08651 C -225.09383,144.85973 -221.79206,140.75401 -217.61535,137.88661 C -215.10454,135.69469 -212.49235,133.26839 -210.83749,130.50207 C -210.86477,126.92195 -214.68529,121.91303 -210.252,119.57013 C -207.25619,117.95208 -205.81053,112.12098 -209.75314,110.87946 C -214.16982,109.44692 -216.95156,115.09837 -221.43751,113.68608 C -228.47365,112.76758 -235.5565,107.20489 -242.69931,110.72434 C -246.89551,113.06547 -243.47174,109.4356 -241.45524,108.56544 C -237.85613,106.84628 -232.73147,104.36798 -233.94637,99.617708 C -234.27189,95.083838 -239.22223,93.197522 -242.95318,91.723135 C -247.61613,89.074942 -253.27003,89.345117 -258.06082,86.933298 C -257.89248,70.385101 -257.58805,53.76423 -258.26571,37.261116 C -259.2092,32.393288 -265.59824,31.96057 -269.68453,32.256957 z M -258.66259,91.764016 C -251.5059,92.239344 -243.21163,93.474137 -238.58238,99.271629 C -238.96251,103.06003 -244.00295,103.80224 -246.52821,106.14082 C -248.92267,108.48087 -251.12372,105.80503 -251.02958,103.27159 C -252.70852,98.336432 -258.20582,95.710815 -263.31841,96.533197 C -267.00561,96.7255 -263.71935,91.937514 -261.395,92.380192 C -260.48382,92.178338 -259.57521,91.953759 -258.66259,91.764016 z " />
-        <path
-           style="fill:url(#linearGradient5285);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
-           sodipodi:nodetypes="ccccczccccccccccccccccccczccccc"
-           id="path2737"
-           d="M -324.0398,30.70877 C -336.3492,30.820231 -335.15663,39.652507 -334.79476,45.313268 C -334.5469,60.436643 -334.38614,75.599009 -334.01234,90.698281 C -333.20516,93.057424 -330.71249,93.985661 -328.75475,95.252079 C -334.4553,96.476239 -336.96996,102.43195 -340.11175,106.59303 C -342.33294,111.36531 -347.84019,115.92868 -345.92111,121.43642 C -344.00204,126.94416 -332.21757,127.68181 -324.95408,127.12866 C -299.06901,127.09789 -273.17022,127.14905 -247.29372,127.06713 C -243.29961,126.16956 -240.99668,122.03601 -241.4977,118.23645 C -238.30082,114.95371 -233.32521,118.03039 -229.53292,118.63002 C -225.71641,119.31313 -232.5646,119.27527 -233.19362,120.54849 C -238.23604,122.95799 -242.6166,126.65447 -246.90973,130.10509 C -250.44674,132.97354 -252.4229,138.10741 -249.57412,142.08235 C -246.21315,145.92284 -241.41489,148.84284 -236.30395,149.79628 C -230.65487,150.83779 -225.57101,147.82678 -221.6157,144.24077 C -216.87391,140.59839 -212.0873,136.78287 -208.84361,131.80554 C -207.76302,128.26399 -211.47449,123.86671 -208.08348,121.09796 C -204.93438,118.46115 -204.06893,113.02076 -207.41836,110.2673 C -212.81988,106.81278 -218.36682,114.55112 -223.89705,111.29128 C -227.94209,110.1659 -231.91311,108.52596 -236.17676,108.45194 C -231.52711,105.88023 -229.62903,98.782331 -234.08944,95.153402 C -239.61551,89.404431 -248.455,88.793917 -255.40182,85.744487 C -255.86992,78.940296 -255.53665,71.972758 -255.70928,65.098797 C -255.80747,55.730822 -255.73864,46.312632 -255.94025,36.975777 C -258.03631,31.236293 -265.34014,30.439522 -270.76286,30.729689 C -289.40725,30.770714 -311.88665,30.597309 -324.0398,30.70877 z M -255.46516,94.482857 C -250.34561,95.62106 -244.69322,96.21649 -240.83258,100.05203 C -242.37635,102.55028 -245.27573,103.64481 -247.80048,104.97505 C -249.71506,99.684643 -254.39847,94.970039 -260.51378,95.138259 C -260.66903,94.131274 -256.73261,94.551178 -255.46516,94.482857 z " />
-      </g>
-      <rect
-         y="78.658051"
-         x="33.326111"
-         width="57.567924"
-         style="fill:url(#linearGradient1156);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient1157);stroke-width:1.44734821pt"
-         id="rect1155"
-         height="8.3153667" />
-      <path
-         style="fill:url(#linearGradient1169);fill-rule:evenodd;stroke-width:0.90459263;stroke-opacity:0.07438019"
-         sodipodi:nodetypes="czzczczzzzzzzc"
-         id="path2676"
-         d="M 98.723806,78.927818 C 95.18666,77.759681 93.50122,82.555591 98.766686,81.004087 C 104.03217,79.452583 120.13123,85.906451 120.37383,89.795491 C 120.61643,93.905503 101.5003,98.581154 106.74108,104.42426 C 111.62816,110.70149 115.35468,100.13868 123.54696,104.21261 C 131.73923,108.17607 136.26048,109.72394 142.25488,104.94185 C 149.10027,101.9342 145.04599,107.07658 139.57918,113.60451 C 134.11237,120.13244 144.00251,115.08156 147.91225,105.31962 C 151.93248,95.557673 139.13128,107.33503 133.66268,105.40571 C 128.19408,103.47639 119.73678,97.849788 113.27625,102.55563 C 106.81572,107.26147 109.62894,99.493003 114.85637,97.90307 C 120.0838,96.092166 122.81363,93.045722 122.85597,90.161522 C 122.89831,87.498293 117.92629,84.811803 112.94229,82.402852 C 107.73732,79.993901 100.49788,78.588966 98.723806,78.927818 z " />
-      <path
-         style="fill:url(#linearGradient1140);fill-opacity:1;fill-rule:evenodd;stroke-width:1.44734821pt"
-         sodipodi:nodetypes="czzzzzzzz"
-         id="path1139"
-         d="M 15.102732,106.80712 C 13.80355,109.23224 17.148847,113.52338 19.900059,113.52338 L 107.85106,113.52338 C 110.18914,113.52338 113.70766,110.4906 112.64839,108.40622 L 102.7339,88.897093 C 101.97024,87.394398 100.26184,86.65834 98.576216,86.65834 L 28.215425,86.658339 C 26.825434,86.658339 25.353768,87.671846 24.697385,88.897093 L 15.102732,106.80712 z " />
-      <rect
-         y="22.413721"
-         x="26.015469"
-         width="72.279724"
-         style="fill:url(#linearGradient905);fill-opacity:1;fill-rule:evenodd;stroke-width:1.62826681"
-         ry="5.4369707"
-         rx="5.4369707"
-         id="rect1137"
-         height="60.126495" />
-      <rect
-         y="31.695871"
-         x="33.386066"
-         width="58.178177"
-         style="fill:url(#radialGradient1132);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient891);stroke-width:1.4649456pt"
-         id="rect1131"
-         height="38.044163" />
-      <path
-         style="fill:url(#linearGradient1146);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="czzccccc"
-         id="path1145"
-         d="M 27.690431,52.841444 L 27.370609,74.749236 C 27.319624,78.241665 29.310209,80.477938 32.807578,80.506029 L 72.625393,80.825852 L 76.463254,71.87084 L 32.008024,71.55102 L 31.688202,52.681533 L 27.690431,52.841444 z " />
-      <g
-         transform="matrix(-1,0,0,1,125.4301,0)"
-         id="g1791">
-        <path
-           style="fill:url(#linearGradient1148);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-           sodipodi:nodetypes="czzccc"
-           id="path1147"
-           d="M 42.062098,33.460351 L 77.341205,33.008055 C 82.787126,32.938235 89.553204,38.416797 89.553204,43.863165 L 89.553204,60.14583 L 41.609801,59.693534 L 42.062098,33.460351 z " />
-        <path
-           style="fill:url(#linearGradient1150);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-           sodipodi:nodetypes="czzccc"
-           id="path1149"
-           d="M 78.337784,67.629235 L 46.723745,67.724544 C 41.843589,67.739257 35.829319,62.771024 35.877168,57.891081 L 36.020221,43.301821 L 78.973514,44.128288 L 78.337784,67.629235 z " />
-      </g>
-      <path
-         style="fill:url(#linearGradient1167);fill-opacity:1;fill-rule:evenodd;stroke-width:0.72367412;stroke-opacity:0.34710741"
-         sodipodi:nodetypes="cczzzzzzc"
-         id="path1159"
-         d="M 137.39107,112.02341 C 137.39107,112.02341 129.0757,110.26438 123.63872,113.62251 C 118.20176,116.98064 109.96635,123.21719 108.76702,124.81628 C 107.40777,126.57531 107.42036,130.22796 109.24674,131.53253 L 114.84364,135.53031 C 118.31797,138.01198 124.86218,139.25396 128.11624,136.48978 L 142.98795,123.85681 C 144.79792,122.3193 145.72732,118.27921 144.10733,116.82073 C 142.95609,115.04975 140.4892,112.91939 137.39107,112.02341 z " />
-      <path
-         style="fill:url(#linearGradient1171);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="czzzzzc"
-         id="path1160"
-         d="M 142.3483,121.13833 L 125.91043,133.59673 C 122.97154,135.82414 118.65484,134.11775 116.28283,133.77129 C 113.9108,133.42481 111.88528,131.87901 112.12516,132.33209 C 112.36503,132.78517 115.08349,135.71687 117.72203,136.48978 C 120.36055,137.26267 124.9543,138.89307 127.50953,136.15531 C 130.06477,133.41755 145.2267,123.53699 142.3483,121.13833 z " />
-      <path
-         style="fill:url(#linearGradient1404);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="cczc"
-         id="path1403"
-         d="M 132.11225,127.51984 C 135.31047,122.88242 120.11893,113.12786 109.08509,127.0401 C 110.20446,130.71805 116.80662,132.5992 121.82304,132.33547 C 126.68363,132.07993 129.50037,129.97181 132.11225,127.51984 z " />
-      <path
-         style="fill:url(#linearGradient1166);fill-opacity:1;fill-rule:evenodd;stroke-width:1.08551121"
-         sodipodi:nodetypes="cccccccc"
-         id="path1519"
-         d="M 138.63464,112.68306 C 135.9958,113.22749 132.31739,114.43079 129.87534,116.38362 C 128.77009,115.68011 125.32759,114.5677 123.66767,113.84494 L 123.24572,114.10517 C 129.67287,117.23476 136.43512,117.91249 135.88192,122.87668 C 136.33675,122.98575 137.05589,123.09702 136.73191,122.38863 C 136.41775,118.90392 132.50587,117.23351 131.02697,116.81532 C 133.17224,114.26602 136.255,113.70892 138.63464,112.68306 z " />
-      <path
-         style="fill:url(#linearGradient1144);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="czzzzzzzz"
-         id="path1143"
-         d="M 18.891612,106.48414 C 17.978451,108.31614 19.173914,111.55774 22.263529,111.55774 L 105.0195,111.55774 C 106.66288,111.55774 109.13595,109.26672 108.39142,107.69215 L 101.42279,92.954575 C 100.88602,91.819403 99.685232,91.263378 98.500462,91.263378 L 28.108183,91.263369 C 27.131195,91.263369 26.0968,92.028994 25.635445,92.954575 L 18.891612,106.48414 z " />
-      <text
-         y="-14.660837"
-         xml:space="preserve"
-         x="6.147172"
-         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
-         id="text1232"><tspan
-           id="tspan1233">Computer</tspan></text>
-      <text
-         y="-34.951134"
-         xml:space="preserve"
-         x="84.564949"
-         transform="scale(0.246729,0.246729)"
-         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
-         id="text1235"><tspan
-           id="tspan1236">Created by Andrew Fitzsimon</tspan></text>
-    </g>
-    <g
-       id="g5474"
-       transform="translate(593.63525,509.49239)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644">
-      <path
-         style="fill:#ffffff;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="cccc"
-         id="path9383"
-         d="M 203.47051,-209.74941 C 198.72111,-204.56585 195.69876,-195.27863 189.00642,-195.27863 C 182.52997,-197.07848 181.66644,-212.48518 180.80291,-215.7969 C 188.1429,-210.75732 195.69876,-207.87757 203.47051,-209.74941 z " />
-      <path
-         transform="matrix(-0.440859,0,0,0.441062,265.52775,-266.17138)"
-         style="fill:#f1bb96;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:type="arc"
-         sodipodi:ry="57.825485"
-         sodipodi:rx="60.94183"
-         sodipodi:cy="70.290855"
-         sodipodi:cx="150.27701"
-         id="path3713"
-         d="M 211.21884 70.290855 A 60.94183 57.825485 0 1 1  89.335178,70.290855 A 60.94183 57.825485 0 1 1  211.21884 70.290855 z" />
-      <path
-         style="fill:#233e6a;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="ccssssc"
-         id="path4369"
-         d="M 232.46888,-182.94274 C 232.85952,-157.74648 168.23012,-154.86512 168.38642,-182.94274 C 166.84164,-205.27149 177.94687,-217.96719 180.70654,-215.80872 C 182.10778,-214.71274 182.62841,-190.37295 192.09635,-195.9716 C 196.69923,-198.69339 201.84768,-209.14846 204.10029,-209.49532 C 207.49937,-210.01873 214.00811,-212.77083 219.98583,-217.92153 C 221.55412,-219.27285 231.93943,-205.38255 232.46888,-182.94274 z " />
-      <path
-         style="fill:#513624;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="ccccc"
-         id="path11309"
-         d="M 204.55432,-273.85152 C 222.46413,-271.53047 237.32676,-259.28175 231.38357,-231.42099 C 229.66954,-221.67743 222.12426,-217.60887 219.35537,-236.36962 C 211.4578,-233.88387 177.25785,-223.92576 170.54948,-241.26677 C 166.55631,-248.43407 174.86257,-276.23329 204.55432,-273.85152 z " />
-      <path
-         style="fill:#1f4eb3;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="cccc"
-         id="path11942"
-         d="M 191.92173,-167.75448 C 192.06919,-184.44566 194.18855,-193.73288 188.47558,-194.95709 C 182.9785,-195.85052 179.91138,-176.52634 179.04785,-173.21462 C 175.85958,-157.19769 189.53653,-154.44605 191.92173,-167.75448 z " />
-      <path
-         style="fill:url(#linearGradient1815);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         id="path1811"
-         d="M 172.67812,-237.76056 C 182.56217,-225.58826 212.09549,-234.15979 219.36562,-236.44806 C 220.33459,-229.88278 221.90014,-226.25074 223.58437,-224.54181 C 219.31219,-215.8234 210.06249,-209.76056 199.27187,-209.76056 C 184.44142,-209.76056 172.42812,-221.18201 172.42812,-235.26056 C 172.42812,-236.11869 172.59078,-236.92413 172.67812,-237.76056 z " />
-      <path
-         style="fill:url(#radialGradient1818);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="ccccc"
-         id="path1817"
-         d="M 203.17522,-273.74212 C 221.08504,-271.42107 235.94766,-259.17235 230.00448,-231.31159 C 228.29044,-221.56803 220.74517,-217.49946 217.97627,-236.26022 C 210.0787,-233.77447 175.87876,-223.81635 169.17039,-241.15737 C 165.17722,-248.32467 173.48348,-276.12389 203.17522,-273.74212 z " />
-      <path
-         style="fill:url(#radialGradient1822);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         id="path1819"
-         d="M 220.74123,-214.1875 C 227.87764,-203.73841 231.28831,-190.18836 229.45998,-177.71875 C 222.3997,-165.39834 205.93726,-163.52328 193.05373,-164.75 C 194.11526,-173.29796 194.69425,-182.39807 193.51876,-190.98978 C 191.02311,-195.41909 199.33209,-197.29913 200.39748,-201.6875 C 203.70655,-208.92744 212.80427,-208.10966 218.04988,-213.3696 C 218.9201,-213.57294 220.00051,-215.94141 220.74123,-214.1875 z M 179.55373,-210.28125 C 180.69974,-204.97453 181.23339,-199.24919 184.58498,-194.75 C 179.40159,-187.81847 178.05976,-178.63643 176.67873,-170.28125 C 167.10271,-177.01707 169.81568,-190.62142 172.02963,-200.39411 C 173.03008,-204.26346 176.36728,-212.34166 179.19382,-211.77772 C 179.27177,-211.45363 179.5117,-210.45598 179.55373,-210.28125 z " />
-      <path
-         style="fill:url(#radialGradient1824);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="cccc"
-         id="path1823"
-         d="M 192.35803,-167.43887 C 192.50549,-184.13006 194.62485,-193.41727 188.91188,-194.64149 C 183.4148,-195.53491 180.34768,-176.21073 179.48415,-172.89901 C 176.29589,-156.88208 189.97283,-154.13044 192.35803,-167.43887 z " />
-      <path
-         style="fill:#1f4eb3;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
-         sodipodi:nodetypes="ccccc"
-         id="path1825"
-         d="M 185.2414,-200.53324 C 185.2414,-197.95291 187.25802,-195.85872 189.74278,-195.85872 C 192.22755,-195.85872 194.24417,-197.95291 194.24417,-200.53324 C 194.24417,-203.11357 193.61259,-209.36288 191.12783,-209.36288 C 188.64306,-209.36288 185.2414,-203.11357 185.2414,-200.53324 z " />
-      <path
-         style="fill:url(#radialGradient1828);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="ccccc"
-         id="path1827"
-         d="M 186.28018,-201.05263 C 186.28018,-198.4723 188.2968,-196.37811 190.78156,-196.37811 C 193.26633,-196.37811 195.28295,-198.4723 195.28295,-201.05263 C 195.28295,-203.63296 194.65137,-209.88227 192.16661,-209.88227 C 189.68184,-209.88227 186.28018,-203.63296 186.28018,-201.05263 z " />
-    </g>
-    <g
-       id="g5488"
-       transform="translate(601.5744,417.49165)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644">
-      <path
-         transform="matrix(6.392368,0.545409,-0.130014,2.864752,-184.6606,-38.15109)"
-         style="fill:url(#radialGradient5536);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:type="arc"
-         sodipodi:ry="12.562782"
-         sodipodi:rx="12.562782"
-         sodipodi:cy="37.865574"
-         sodipodi:cx="41.875938"
-         id="path5490"
-         d="M 54.438721 37.865574 A 12.562782 12.562782 0 1 1  29.313156,37.865574 A 12.562782 12.562782 0 1 1  54.438721 37.865574 z" />
-      <g
-         transform="matrix(1,0,0,1.036969,356.8306,-11.4294)"
-         style="fill:url(#linearGradient5538);fill-opacity:1"
-         id="g5492">
-        <path
-           style="fill:url(#linearGradient5540);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
-           id="path5494"
-           d="M -270.85787,33.814995 C -289.35564,33.925992 -307.93321,33.592782 -326.38104,33.981747 C -331.43469,35.696391 -331.02221,41.899652 -330.68524,46.15332 C -330.75782,60.227303 -330.53537,74.298225 -330.21167,88.36826 C -328.21297,91.039611 -323.21766,90.618387 -322.68469,94.539015 C -320.78054,96.259426 -317.05071,94.88215 -314.4389,95.333237 C -298.54999,95.360274 -282.66107,95.387302 -266.77215,95.414339 C -266.35587,90.465192 -260.12609,88.824447 -255.81783,89.540255 C -256.01688,89.058389 -261.69557,87.939375 -259.61591,84.491525 C -259.45681,68.72727 -259.19734,52.882199 -259.82064,37.168229 C -261.19394,32.980583 -267.34179,33.83368 -270.85787,33.814995 z M -236.65184,97.260473 C -234.79025,100.12642 -237.08724,103.09386 -239.92892,104.16357 C -242.6311,105.91539 -245.59105,107.62992 -248.52894,108.76804 C -253.1773,108.19079 -251.42424,101.88475 -255.01281,99.896645 C -260.33594,96.447012 -267.21045,98.43943 -273.23329,97.939231 C -291.8249,97.94887 -310.41651,97.958519 -329.00813,97.968158 C -335.45898,103.56578 -339.16595,111.40269 -341.55034,119.32178 C -337.25147,124.2061 -329.89606,122.27575 -324.10438,122.40002 C -298.64553,122.23171 -273.11679,122.61546 -247.69897,122.24542 C -243.40174,121.14669 -247.44685,114.84894 -243.58488,113.04441 C -242.73865,112.73374 -247.81245,114.4382 -247.26205,111.62955 C -245.49117,106.66028 -239.14113,105.99595 -235.92338,102.36811 C -234.39131,99.755669 -236.26958,96.922488 -238.33047,95.260495 C -237.77093,95.927151 -237.21138,96.593817 -236.65184,97.260473 z M -240.64255,111.75263 C -243.64086,113.13223 -237.02792,110.69536 -235.55512,111.97369 C -229.71113,112.74417 -224.16461,117.19625 -218.12358,115.22951 C -225.97639,116.31604 -232.799,109.03014 -240.64255,111.75263 z M -212.01083,112.33724 C -215.98173,113.85021 -208.21543,112.17765 -210.07883,115.87566 C -212.50961,119.93855 -206.99008,113.8662 -209.61436,112.54677 C -210.16198,111.94632 -211.27989,112.47663 -212.01083,112.33724 z M -213.97451,120.82946 C -220.13871,124.32615 -228.37873,119.08124 -233.85995,124.39439 C -238.36465,128.00055 -244.57099,130.35185 -247.0433,135.75122 C -247.65922,139.60202 -243.25109,141.90251 -240.44565,143.71808 C -235.60127,146.54512 -228.8227,145.75388 -225.20082,141.42836 C -220.62679,137.96117 -216.44182,134.08489 -212.48592,129.96782 C -212.82701,126.95048 -214.43694,123.63971 -213.97451,120.82946 z " />
-        <path
-           style="fill:url(#linearGradient5542);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
-           id="path5496"
-           d="M -269.68453,32.256957 C -288.76965,32.351184 -307.87514,32.249603 -326.94796,32.349264 C -332.63884,33.663474 -333.90446,40.291305 -333.21597,45.149113 C -333.11996,59.896901 -333.07471,74.659754 -332.61729,89.39481 C -331.88583,93.310348 -324.86009,92.098674 -325.11097,96.44089 C -328.07184,96.184706 -331.5534,96.317135 -333.07248,99.246492 C -338.92562,104.98392 -341.99312,112.66465 -344.27268,120.28679 C -340.22572,125.96631 -332.26467,125.31453 -326.02946,124.71751 C -300.16629,124.7277 -274.28316,124.82043 -248.43245,124.77905 C -244.42424,124.78686 -243.30672,120.35609 -243.96666,117.2099 C -242.88598,112.93536 -237.04086,113.94554 -233.80717,114.98513 C -228.01851,116.64297 -221.26418,120.43074 -215.57982,116.37592 C -211.36091,113.71809 -213.05678,118.4029 -215.77936,119.43344 C -220.82539,122.25797 -227.09125,118.98178 -232.39677,121.20855 C -236.53238,123.88957 -240.74707,126.85249 -244.76678,129.74666 C -248.34219,132.01467 -251.90947,137.38626 -248.13747,140.97315 C -243.79274,146.02948 -236.37425,149.4527 -229.68248,147.08651 C -225.09383,144.85973 -221.79206,140.75401 -217.61535,137.88661 C -215.10454,135.69469 -212.49235,133.26839 -210.83749,130.50207 C -210.86477,126.92195 -214.68529,121.91303 -210.252,119.57013 C -207.25619,117.95208 -205.81053,112.12098 -209.75314,110.87946 C -214.16982,109.44692 -216.95156,115.09837 -221.43751,113.68608 C -228.47365,112.76758 -235.5565,107.20489 -242.69931,110.72434 C -246.89551,113.06547 -243.47174,109.4356 -241.45524,108.56544 C -237.85613,106.84628 -232.73147,104.36798 -233.94637,99.617708 C -234.27189,95.083838 -239.22223,93.197522 -242.95318,91.723135 C -247.61613,89.074942 -253.27003,89.345117 -258.06082,86.933298 C -257.89248,70.385101 -257.58805,53.76423 -258.26571,37.261116 C -259.2092,32.393288 -265.59824,31.96057 -269.68453,32.256957 z M -258.66259,91.764016 C -251.5059,92.239344 -243.21163,93.474137 -238.58238,99.271629 C -238.96251,103.06003 -244.00295,103.80224 -246.52821,106.14082 C -248.92267,108.48087 -251.12372,105.80503 -251.02958,103.27159 C -252.70852,98.336432 -258.20582,95.710815 -263.31841,96.533197 C -267.00561,96.7255 -263.71935,91.937514 -261.395,92.380192 C -260.48382,92.178338 -259.57521,91.953759 -258.66259,91.764016 z " />
-        <path
-           style="fill:url(#linearGradient5544);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
-           sodipodi:nodetypes="ccccczccccccccccccccccccczccccc"
-           id="path5498"
-           d="M -324.0398,30.70877 C -336.3492,30.820231 -335.15663,39.652507 -334.79476,45.313268 C -334.5469,60.436643 -334.38614,75.599009 -334.01234,90.698281 C -333.20516,93.057424 -330.71249,93.985661 -328.75475,95.252079 C -334.4553,96.476239 -336.96996,102.43195 -340.11175,106.59303 C -342.33294,111.36531 -347.84019,115.92868 -345.92111,121.43642 C -344.00204,126.94416 -332.21757,127.68181 -324.95408,127.12866 C -299.06901,127.09789 -273.17022,127.14905 -247.29372,127.06713 C -243.29961,126.16956 -240.99668,122.03601 -241.4977,118.23645 C -238.30082,114.95371 -233.32521,118.03039 -229.53292,118.63002 C -225.71641,119.31313 -232.5646,119.27527 -233.19362,120.54849 C -238.23604,122.95799 -242.6166,126.65447 -246.90973,130.10509 C -250.44674,132.97354 -252.4229,138.10741 -249.57412,142.08235 C -246.21315,145.92284 -241.41489,148.84284 -236.30395,149.79628 C -230.65487,150.83779 -225.57101,147.82678 -221.6157,144.24077 C -216.87391,140.59839 -212.0873,136.78287 -208.84361,131.80554 C -207.76302,128.26399 -211.47449,123.86671 -208.08348,121.09796 C -204.93438,118.46115 -204.06893,113.02076 -207.41836,110.2673 C -212.81988,106.81278 -218.36682,114.55112 -223.89705,111.29128 C -227.94209,110.1659 -231.91311,108.52596 -236.17676,108.45194 C -231.52711,105.88023 -229.62903,98.782331 -234.08944,95.153402 C -239.61551,89.404431 -248.455,88.793917 -255.40182,85.744487 C -255.86992,78.940296 -255.53665,71.972758 -255.70928,65.098797 C -255.80747,55.730822 -255.73864,46.312632 -255.94025,36.975777 C -258.03631,31.236293 -265.34014,30.439522 -270.76286,30.729689 C -289.40725,30.770714 -311.88665,30.597309 -324.0398,30.70877 z M -255.46516,94.482857 C -250.34561,95.62106 -244.69322,96.21649 -240.83258,100.05203 C -242.37635,102.55028 -245.27573,103.64481 -247.80048,104.97505 C -249.71506,99.684643 -254.39847,94.970039 -260.51378,95.138259 C -260.66903,94.131274 -256.73261,94.551178 -255.46516,94.482857 z " />
-      </g>
-      <rect
-         y="78.658051"
-         x="33.326111"
-         width="57.567924"
-         style="fill:url(#linearGradient5546);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient5548);stroke-width:1.44734821pt"
-         id="rect5500"
-         height="8.3153667" />
-      <path
-         style="fill:url(#linearGradient5550);fill-rule:evenodd;stroke-width:0.90459263;stroke-opacity:0.07438019"
-         sodipodi:nodetypes="czzczczzzzzzzc"
-         id="path5502"
-         d="M 98.723806,78.927818 C 95.18666,77.759681 93.50122,82.555591 98.766686,81.004087 C 104.03217,79.452583 120.13123,85.906451 120.37383,89.795491 C 120.61643,93.905503 101.5003,98.581154 106.74108,104.42426 C 111.62816,110.70149 115.35468,100.13868 123.54696,104.21261 C 131.73923,108.17607 136.26048,109.72394 142.25488,104.94185 C 149.10027,101.9342 145.04599,107.07658 139.57918,113.60451 C 134.11237,120.13244 144.00251,115.08156 147.91225,105.31962 C 151.93248,95.557673 139.13128,107.33503 133.66268,105.40571 C 128.19408,103.47639 119.73678,97.849788 113.27625,102.55563 C 106.81572,107.26147 109.62894,99.493003 114.85637,97.90307 C 120.0838,96.092166 122.81363,93.045722 122.85597,90.161522 C 122.89831,87.498293 117.92629,84.811803 112.94229,82.402852 C 107.73732,79.993901 100.49788,78.588966 98.723806,78.927818 z " />
-      <path
-         style="fill:url(#linearGradient5552);fill-opacity:1;fill-rule:evenodd;stroke-width:1.44734821pt"
-         sodipodi:nodetypes="czzzzzzzz"
-         id="path5504"
-         d="M 15.102732,106.80712 C 13.80355,109.23224 17.148847,113.52338 19.900059,113.52338 L 107.85106,113.52338 C 110.18914,113.52338 113.70766,110.4906 112.64839,108.40622 L 102.7339,88.897093 C 101.97024,87.394398 100.26184,86.65834 98.576216,86.65834 L 28.215425,86.658339 C 26.825434,86.658339 25.353768,87.671846 24.697385,88.897093 L 15.102732,106.80712 z " />
-      <rect
-         y="22.413721"
-         x="26.015469"
-         width="72.279724"
-         style="fill:url(#linearGradient5554);fill-opacity:1;fill-rule:evenodd;stroke-width:1.62826681"
-         ry="5.4369707"
-         rx="5.4369707"
-         id="rect5506"
-         height="60.126495" />
-      <rect
-         y="31.695871"
-         x="33.386066"
-         width="58.178177"
-         style="fill:url(#radialGradient5556);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient5558);stroke-width:1.4649456pt"
-         id="rect5508"
-         height="38.044163" />
-      <path
-         style="fill:url(#linearGradient5560);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="czzccccc"
-         id="path5510"
-         d="M 27.690431,52.841444 L 27.370609,74.749236 C 27.319624,78.241665 29.310209,80.477938 32.807578,80.506029 L 72.625393,80.825852 L 76.463254,71.87084 L 32.008024,71.55102 L 31.688202,52.681533 L 27.690431,52.841444 z " />
-      <g
-         transform="matrix(-1,0,0,1,125.4301,0)"
-         id="g5512">
-        <path
-           style="fill:url(#linearGradient5562);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-           sodipodi:nodetypes="czzccc"
-           id="path5514"
-           d="M 42.062098,33.460351 L 77.341205,33.008055 C 82.787126,32.938235 89.553204,38.416797 89.553204,43.863165 L 89.553204,60.14583 L 41.609801,59.693534 L 42.062098,33.460351 z " />
-        <path
-           style="fill:url(#linearGradient5564);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-           sodipodi:nodetypes="czzccc"
-           id="path5516"
-           d="M 78.337784,67.629235 L 46.723745,67.724544 C 41.843589,67.739257 35.829319,62.771024 35.877168,57.891081 L 36.020221,43.301821 L 78.973514,44.128288 L 78.337784,67.629235 z " />
-      </g>
-      <path
-         style="fill:url(#linearGradient5566);fill-opacity:1;fill-rule:evenodd;stroke-width:0.72367412;stroke-opacity:0.34710741"
-         sodipodi:nodetypes="cczzzzzzc"
-         id="path5518"
-         d="M 137.39107,112.02341 C 137.39107,112.02341 129.0757,110.26438 123.63872,113.62251 C 118.20176,116.98064 109.96635,123.21719 108.76702,124.81628 C 107.40777,126.57531 107.42036,130.22796 109.24674,131.53253 L 114.84364,135.53031 C 118.31797,138.01198 124.86218,139.25396 128.11624,136.48978 L 142.98795,123.85681 C 144.79792,122.3193 145.72732,118.27921 144.10733,116.82073 C 142.95609,115.04975 140.4892,112.91939 137.39107,112.02341 z " />
-      <path
-         style="fill:url(#linearGradient5568);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="czzzzzc"
-         id="path5520"
-         d="M 142.3483,121.13833 L 125.91043,133.59673 C 122.97154,135.82414 118.65484,134.11775 116.28283,133.77129 C 113.9108,133.42481 111.88528,131.87901 112.12516,132.33209 C 112.36503,132.78517 115.08349,135.71687 117.72203,136.48978 C 120.36055,137.26267 124.9543,138.89307 127.50953,136.15531 C 130.06477,133.41755 145.2267,123.53699 142.3483,121.13833 z " />
-      <path
-         style="fill:url(#linearGradient5570);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="cczc"
-         id="path5522"
-         d="M 132.11225,127.51984 C 135.31047,122.88242 120.11893,113.12786 109.08509,127.0401 C 110.20446,130.71805 116.80662,132.5992 121.82304,132.33547 C 126.68363,132.07993 129.50037,129.97181 132.11225,127.51984 z " />
-      <path
-         style="fill:url(#linearGradient5572);fill-opacity:1;fill-rule:evenodd;stroke-width:1.08551121"
-         sodipodi:nodetypes="cccccccc"
-         id="path5524"
-         d="M 138.63464,112.68306 C 135.9958,113.22749 132.31739,114.43079 129.87534,116.38362 C 128.77009,115.68011 125.32759,114.5677 123.66767,113.84494 L 123.24572,114.10517 C 129.67287,117.23476 136.43512,117.91249 135.88192,122.87668 C 136.33675,122.98575 137.05589,123.09702 136.73191,122.38863 C 136.41775,118.90392 132.50587,117.23351 131.02697,116.81532 C 133.17224,114.26602 136.255,113.70892 138.63464,112.68306 z " />
-      <path
-         style="fill:url(#linearGradient5574);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="czzzzzzzz"
-         id="path5526"
-         d="M 18.891612,106.48414 C 17.978451,108.31614 19.173914,111.55774 22.263529,111.55774 L 105.0195,111.55774 C 106.66288,111.55774 109.13595,109.26672 108.39142,107.69215 L 101.42279,92.954575 C 100.88602,91.819403 99.685232,91.263378 98.500462,91.263378 L 28.108183,91.263369 C 27.131195,91.263369 26.0968,92.028994 25.635445,92.954575 L 18.891612,106.48414 z " />
-      <text
-         y="-14.660837"
-         xml:space="preserve"
-         x="6.147172"
-         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
-         id="text5528"><tspan
-           id="tspan5530">Computer</tspan></text>
-      <text
-         y="-34.951134"
-         xml:space="preserve"
-         x="84.564949"
-         transform="scale(0.246729,0.246729)"
-         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
-         id="text5532"><tspan
-           id="tspan5534">Created by Andrew Fitzsimon</tspan></text>
-    </g>
-    <g
-       id="g6024"
-       transform="matrix(-1,0,0,1,874.16045,452.61731)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644">
-      <path
-         transform="translate(2.509562,-4.432856e-2)"
-         style="fill:#ffffff;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="cccc"
-         id="path6027"
-         d="M 60.545133,72.847539 C 65.294534,78.031101 68.316881,87.318315 75.00922,87.318316 C 81.485677,85.518467 82.349205,70.11177 83.212732,66.800051 C 75.872748,71.839624 68.316882,74.71938 60.545133,72.847539 z " />
-      <path
-         transform="translate(2.509562,-4.432856e-2)"
-         style="fill:#d20000;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="ccssssc"
-         id="path6029"
-         d="M 31.546762,99.654209 C 31.156121,124.85047 95.78552,127.73183 95.62922,99.654209 C 97.174007,77.325462 86.068776,64.629762 83.309105,66.788232 C 81.907864,67.884209 81.387229,92.223995 71.919297,86.625353 C 67.316417,83.903554 62.167959,73.44849 59.915352,73.101625 C 56.516277,72.578221 50.007529,69.826123 44.029815,64.675414 C 42.461522,63.324094 32.076211,77.214403 31.546762,99.654209 z " />
-      <path
-         style="fill:url(#radialGradient2797);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         id="path2796"
-         d="M 43.53125,77.3125 C 40.353026,86.016409 37.202011,96.366079 40.377303,105.23542 C 48.984655,117.18204 66.049398,117.25223 79.222417,115.04972 C 88.094278,113.47345 96.636121,105.87972 94.744454,96.188658 C 94.751182,88.561019 93.319573,80.643142 89.09375,74.1875 C 87.954705,81.120157 85.706152,92.347929 76.686643,91.786583 C 66.841974,89.84774 65.058803,76.33878 54.747596,75.105769 C 49.945701,71.530053 45.566465,69.110698 43.783935,76.852875 L 43.53125,77.3125 z " />
-      <path
-         transform="matrix(0.440859,0,0,0.441062,0.997459,16.38124)"
-         style="fill:#efd7c7;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:type="arc"
-         sodipodi:ry="57.825485"
-         sodipodi:rx="60.94183"
-         sodipodi:cy="70.290855"
-         sodipodi:cx="150.27701"
-         id="path6032"
-         d="M 211.21884 70.290855 A 60.94183 57.825485 0 1 1  89.335178,70.290855 A 60.94183 57.825485 0 1 1  211.21884 70.290855 z" />
-      <path
-         transform="translate(2.509562,-4.432856e-2)"
-         style="fill:#000000;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="cccccc"
-         id="path3720"
-         d="M 56.980881,5.8426527 C 39.420698,8.0166254 30.552872,16.206245 24.211446,49.532095 C 14.512196,98.076517 21.871677,115.5525 32.990311,115.56714 C 17.54932,102.40769 63.877625,86.740105 56.295103,44.070713 C 68.4508,48.712358 94.51097,54.349644 95.164349,41.718703 C 97.176702,29.219492 88.64173,4.4775042 56.980881,5.8426527 z " />
-      <path
-         style="fill:url(#linearGradient2789);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         id="path2164"
-         d="M 60.687242,45.028999 C 62.530882,55.403773 61.180052,64.151015 58.312242,71.685249 C 61.630122,73.07804 65.296862,73.904 69.155992,73.903999 C 83.975322,73.903999 95.981712,62.468019 95.999742,48.403999 C 88.357632,52.885439 70.244092,48.678277 60.687242,45.028999 z " />
-      <path
-         style="fill:url(#radialGradient2791);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         id="path2790"
-         d="M 52.174948,8.1325312 C 35.846775,12.141346 31.110158,30.475875 28.060647,44.840387 C 24.465246,64.767005 19.485139,85.90438 25.518698,105.82003 C 29.863591,114.87216 28.026452,106.52571 31.049538,102.11795 C 41.311249,87.323083 56.256862,73.307418 55.936774,53.886064 C 56.647391,49.398848 52.34734,38.640985 60.701717,42.254379 C 70.683443,45.202557 82.078811,49.011247 92.143698,44.632531 C 96.945103,37.45042 93.288237,27.137344 88.876323,20.399742 C 81.135092,8.5919962 65.300885,5.0194752 52.174948,8.1325312 z " />
-    </g>
-    <path
-       style="fill:none;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:4.63842154;stroke-linecap:butt;stroke-linejoin:round;stroke-dasharray:none;stroke-opacity:1"
-       sodipodi:nodetypes="cccccccccccc"
-       id="path699"
-       d="M 319.16674,325.66524 L 432.27399,313.12251 L 422.57906,332.08242 L 484.9028,325.95688 C 484.9028,325.95688 494.59773,306.41369 495.05931,306.41369 C 495.52148,306.41369 517.68079,331.79078 517.68079,331.79078 C 517.68079,331.79078 465.51355,358.33479 465.05197,358.33479 C 465.51355,358.91808 474.74689,339.66616 474.74689,339.37453 L 402.72705,345.79207 L 412.42255,326.24852 L 309.01023,338.4996 L 319.16674,325.66524 z "
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644" />
-    <text
-       xml:space="preserve"
-       style="font-size:48px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="92.546875"
-       y="509.71948"
-       id="text7612"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644"><tspan
-         sodipodi:role="line"
-         id="tspan7614"
-         x="92.546875"
-         y="509.71948">Server</tspan><tspan
-         sodipodi:role="line"
-         x="92.546875"
-         y="569.71948"
-         id="tspan2803">(PQM)</tspan></text>
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="359.5625"
-       y="261.21948"
-       id="text7877"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644"><tspan
-         sodipodi:role="line"
-         id="tspan7879"
-         x="359.5625"
-         y="261.21948">bzr branch</tspan></text>
-    <path
-       sodipodi:type="arc"
-       style="fill:#000000"
-       id="path9548"
-       sodipodi:cx="292.14285"
-       sodipodi:cy="181.95163"
-       sodipodi:rx="15"
-       sodipodi:ry="15"
-       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
-       transform="translate(42.857147,67.142853)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644" />
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="325.71429"
-       y="259.52307"
-       id="text9550"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644"><tspan
-         sodipodi:role="line"
-         id="tspan9552"
-         x="325.71429"
-         y="259.52307">1</tspan></text>
-    <path
-       sodipodi:type="arc"
-       style="fill:#000000"
-       id="path9554"
-       sodipodi:cx="292.14285"
-       sodipodi:cy="181.95163"
-       sodipodi:rx="15"
-       sodipodi:ry="15"
-       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
-       transform="translate(558.85715,89.5491)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644" />
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="841.25"
-       y="283.37573"
-       id="text9556"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644"><tspan
-         sodipodi:role="line"
-         id="tspan9558"
-         x="841.25"
-         y="283.37573">2</tspan></text>
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="874.89062"
-       y="264.32886"
-       id="text9566"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644"><tspan
-         sodipodi:role="line"
-         x="874.89062"
-         y="264.32886"
-         id="tspan2788">make</tspan><tspan
-         sodipodi:role="line"
-         x="874.89062"
-         y="304.32886"
-         id="tspan2815">changes</tspan></text>
-    <path
-       sodipodi:type="arc"
-       style="fill:#000000"
-       id="path9652"
-       sodipodi:cx="292.14285"
-       sodipodi:cy="181.95163"
-       sodipodi:rx="15"
-       sodipodi:ry="15"
-       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
-       transform="translate(449.56027,432.37723)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644" />
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="732.41742"
-       y="625.97729"
-       id="text9654"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644"><tspan
-         sodipodi:role="line"
-         id="tspan9656"
-         x="732.41742"
-         y="625.97729">4</tspan></text>
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="768.26562"
-       y="622.23511"
-       id="text9658"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644"><tspan
-         sodipodi:role="line"
-         id="tspan9660"
-         x="768.26562"
-         y="622.23511">accept or reject</tspan></text>
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="75.5625"
-       y="228.09448"
-       id="text2965"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644"><tspan
-         sodipodi:role="line"
-         id="tspan2967"
-         x="75.5625"
-         y="228.09448">main branch</tspan></text>
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="556.98438"
-       y="165.64139"
-       id="text2969"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644"><tspan
-         sodipodi:role="line"
-         id="tspan2971"
-         x="556.98438"
-         y="165.64139">local branches</tspan></text>
-    <path
-       sodipodi:type="arc"
-       style="fill:none;fill-opacity:1;stroke:#0000ff;stroke-width:5.00006151;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
-       id="path4930"
-       sodipodi:cx="342"
-       sodipodi:cy="171.0945"
-       sodipodi:rx="66"
-       sodipodi:ry="35"
-       d="M 408 171.0945 A 66 35 0 1 1  276,171.0945 A 66 35 0 1 1  408 171.0945 z"
-       transform="matrix(1.9161749,0,0,1.0419298,-477.33182,37.826027)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644" />
-    <path
-       sodipodi:type="arc"
-       style="fill:none;fill-opacity:1;stroke:#0000ff;stroke-width:5.00006151;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
-       id="path7839"
-       sodipodi:cx="342"
-       sodipodi:cy="171.0945"
-       sodipodi:rx="66"
-       sodipodi:ry="35"
-       d="M 408 171.0945 A 66 35 0 1 1  276,171.0945 A 66 35 0 1 1  408 171.0945 z"
-       transform="matrix(2.0657387,0,0,1.0382501,-36.482679,-19.544354)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644" />
-    <g
-       id="g11201"
-       transform="translate(224.98935,560.87966)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644" />
-    <path
-       sodipodi:type="arc"
-       style="fill:#000000"
-       id="path2488"
-       sodipodi:cx="292.14285"
-       sodipodi:cy="181.95163"
-       sodipodi:rx="15"
-       sodipodi:ry="15"
-       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
-       transform="translate(44.857147,386.9866)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644" />
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="327.71429"
-       y="580.60229"
-       id="text2490"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644"><tspan
-         sodipodi:role="line"
-         id="tspan2492"
-         x="327.71429"
-         y="580.60229">5</tspan></text>
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="363.5625"
-       y="577.76636"
-       id="text2494"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644"><tspan
-         sodipodi:role="line"
-         id="tspan2496"
-         x="363.5625"
-         y="577.76636">request merge</tspan></text>
-    <path
-       style="fill:none;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:4.63842154;stroke-linecap:butt;stroke-linejoin:round;stroke-dasharray:none;stroke-opacity:1"
-       sodipodi:nodetypes="cccccccccccc"
-       id="path2801"
-       d="M 530.83326,472.52373 L 417.72601,485.06646 L 427.42094,466.10655 L 365.0972,472.23209 C 365.0972,472.23209 355.40227,491.77528 354.94069,491.77528 C 354.47852,491.77528 332.31921,466.39819 332.31921,466.39819 C 332.31921,466.39819 384.48645,439.85418 384.94803,439.85418 C 384.48645,439.27089 375.25311,458.52281 375.25311,458.81444 L 447.27295,452.3969 L 437.57745,471.94045 L 540.98977,459.68937 L 530.83326,472.52373 z "
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644" />
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="878.89062"
-       y="396.40698"
-       id="text2811"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
-       inkscape:export-xdpi="38.384644"
-       inkscape:export-ydpi="38.384644"><tspan
-         sodipodi:role="line"
-         x="878.89062"
-         y="396.40698"
-         id="tspan2813">request</tspan><tspan
-         sodipodi:role="line"
-         x="878.89062"
-         y="436.40698"
-         id="tspan2817">review</tspan></text>
-  </g>
-</svg>

=== removed file 'doc/en/user-guide/images/workflows_shared.png'
Binary files doc/en/user-guide/images/workflows_shared.png and doc/en/user-guide/images/workflows_shared.png differ
=== removed file 'doc/en/user-guide/images/workflows_shared.svg'
--- doc/en/user-guide/images/workflows_shared.svg	2007-11-30 04:34:08 +0000
+++ doc/en/user-guide/images/workflows_shared.svg	1970-01-01 00:00:00 +0000
@@ -1,1594 +0,0 @@
-<?xml version="1.0" encoding="UTF-8" standalone="no"?>
-<!-- Created with Inkscape (http://www.inkscape.org/) -->
-<svg
-   xmlns:dc="http://purl.org/dc/elements/1.1/"
-   xmlns:cc="http://web.resource.org/cc/"
-   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
-   xmlns:svg="http://www.w3.org/2000/svg"
-   xmlns="http://www.w3.org/2000/svg"
-   xmlns:xlink="http://www.w3.org/1999/xlink"
-   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"
-   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"
-   width="1052.3622"
-   height="744.09448"
-   id="svg2"
-   sodipodi:version="0.32"
-   inkscape:version="0.45.1"
-   version="1.0"
-   sodipodi:docbase="/home/ian/Desktop/talk/workflows"
-   sodipodi:docname="workflows_shared.svg"
-   inkscape:output_extension="org.inkscape.output.svg.inkscape"
-   inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_shared.png"
-   inkscape:export-xdpi="49.419998"
-   inkscape:export-ydpi="49.419998">
-  <defs
-     id="defs4">
-    <radialGradient
-       xlink:href="#linearGradient5992"
-       r="33.156250"
-       inkscape:collect="always"
-       id="radialGradient6000"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(1.000000,0.000000,0.000000,1.693685,0.000000,-197.9515)"
-       fy="285.36218"
-       fx="495.50000"
-       cy="285.36218"
-       cx="495.50000" />
-    <linearGradient
-       y2="187.57059"
-       y1="225.40080"
-       xlink:href="#linearGradient5963"
-       x2="458.91232"
-       x1="383.95898"
-       inkscape:collect="always"
-       id="linearGradient5969"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       id="linearGradient3586">
-      <stop
-         style="stop-color:#000000;stop-opacity:1.0000000;"
-         offset="0.0000000"
-         id="stop3588" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0;"
-         offset="1"
-         id="stop3590" />
-    </linearGradient>
-    <linearGradient
-       inkscape:collect="always"
-       id="linearGradient5963">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:1;"
-         offset="0"
-         id="stop5965" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0;"
-         offset="1"
-         id="stop5967" />
-    </linearGradient>
-    <linearGradient
-       inkscape:collect="always"
-       id="linearGradient5992">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:1;"
-         offset="0"
-         id="stop5994" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0;"
-         offset="1"
-         id="stop5996" />
-    </linearGradient>
-    <linearGradient
-       y2="-0.45783132"
-       y1="3.3012049"
-       xlink:href="#linearGradient893"
-       x2="0.92957747"
-       x1="-2.3960868e-17"
-       id="linearGradient4284" />
-    <linearGradient
-       y2="-0.033519555"
-       y1="2.0837989"
-       xlink:href="#linearGradient893"
-       x2="0.99074072"
-       x1="-0.77314812"
-       id="linearGradient4283" />
-    <linearGradient
-       y2="1.8771822"
-       y1="-0.033741195"
-       xlink:href="#linearGradient902"
-       x2="0.48453596"
-       x1="0.47041038"
-       id="linearGradient2740"
-       gradientTransform="scale(0.997153,1.002855)" />
-    <linearGradient
-       y2="1.9025002"
-       y1="-0.043652620"
-       xlink:href="#linearGradient902"
-       x2="0.48481107"
-       x1="0.47042510"
-       id="linearGradient1506"
-       gradientTransform="scale(0.995847,1.004170)" />
-    <linearGradient
-       y2="1.8570156"
-       y1="-0.024853170"
-       xlink:href="#linearGradient902"
-       x2="0.48548824"
-       x1="0.47157744"
-       id="linearGradient1505"
-       gradientTransform="scale(0.997825,1.002180)" />
-    <linearGradient
-       y2="182.99154"
-       y1="169.09755"
-       xlink:href="#linearGradient892"
-       x2="88.996957"
-       x1="88.755695"
-       id="linearGradient1404"
-       gradientTransform="scale(1.3695887,0.7301462)"
-       gradientUnits="userSpaceOnUse" />
-    <radialGradient
-       xlink:href="#linearGradient1317"
-       r="0.34964636"
-       id="radialGradient1316"
-       fy="0.18269235"
-       fx="0.50352114"
-       cy="0.50000006"
-       cx="0.50000000" />
-    <radialGradient
-       xlink:href="#linearGradient1317"
-       r="0.41197181"
-       id="radialGradient1315"
-       fy="0.26666668"
-       fx="0.47535211"
-       cy="0.53333336"
-       cx="0.47887325" />
-    <linearGradient
-       y2="173.03153"
-       y1="177.77768"
-       xlink:href="#linearGradient902"
-       x2="95.100155"
-       x1="101.10657"
-       id="linearGradient1171"
-       gradientTransform="scale(1.3601783,0.7351977)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="1.8378206"
-       y1="-0.016295359"
-       xlink:href="#linearGradient902"
-       x2="0.48655096"
-       x1="0.47284532"
-       id="linearGradient1170"
-       gradientTransform="scale(0.998371,1.001632)" />
-    <linearGradient
-       y2="81.477602"
-       y1="224.57898"
-       xlink:href="#linearGradient893"
-       x2="74.533693"
-       x1="146.69923"
-       id="linearGradient1169"
-       gradientTransform="scale(1.1870691,0.842411)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="133.54711"
-       y1="228.39311"
-       xlink:href="#linearGradient888"
-       x2="88.447016"
-       x1="141.60217"
-       id="linearGradient1167"
-       gradientTransform="scale(1.1838753,0.8446836)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="148.78619"
-       y1="131.25248"
-       xlink:href="#linearGradient1317"
-       x2="107.04918"
-       x1="111.49758"
-       id="linearGradient1166"
-       gradientTransform="scale(1.223869,0.8170809)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="176.28694"
-       y1="269.85831"
-       xlink:href="#linearGradient888"
-       x2="-16.224496"
-       x1="51.460928"
-       id="linearGradient1157"
-       gradientTransform="scale(2.4217071,0.4129318)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="234.26866"
-       y1="178.48862"
-       xlink:href="#linearGradient888"
-       x2="25.220815"
-       x1="25.220815"
-       id="linearGradient1156"
-       gradientTransform="scale(2.4217071,0.4129318)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="105.42543"
-       y1="76.277559"
-       xlink:href="#linearGradient892"
-       x2="8.346058"
-       x1="35.190362"
-       id="linearGradient1150"
-       gradientTransform="scale(1.3283861,0.7527932)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="20.481863"
-       y1="49.507656"
-       xlink:href="#linearGradient892"
-       x2="70.224305"
-       x1="39.690614"
-       id="linearGradient1148"
-       gradientTransform="scale(1.329144,0.7523639)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="113.71949"
-       y1="90.197025"
-       xlink:href="#linearGradient892"
-       x2="17.876529"
-       x1="39.810948"
-       id="linearGradient1146"
-       gradientTransform="scale(1.3207392,0.7571517)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="251.21892"
-       y1="203.499"
-       xlink:href="#linearGradient892"
-       x2="31.617281"
-       x1="31.449743"
-       id="linearGradient1144"
-       gradientTransform="scale(2.1051174,0.4750329)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="-0.45783132"
-       y1="3.3012049"
-       xlink:href="#linearGradient888"
-       x2="0.92957747"
-       x1="0.00000000"
-       id="linearGradient1141" />
-    <linearGradient
-       y2="232.24952"
-       y1="110.4447"
-       xlink:href="#linearGradient888"
-       x2="41.967061"
-       x1="45.685757"
-       id="linearGradient1140"
-       gradientTransform="scale(1.9102155,0.5235012)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="75.912531"
-       y1="375.92199"
-       xlink:href="#linearGradient1806"
-       x2="-268.25407"
-       x1="-249.72067"
-       id="linearGradient1138"
-       gradientTransform="scale(1.087146,0.9198397)"
-       gradientUnits="userSpaceOnUse" />
-    <radialGradient
-       xlink:href="#linearGradient1133"
-       r="68.589222"
-       id="radialGradient1132"
-       fy="39.288476"
-       fx="72.107883"
-       cy="56.485935"
-       cx="60.004654"
-       gradientTransform="scale(1.2267534,0.8151598)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="11.699047"
-       y1="208.43991"
-       xlink:href="#linearGradient888"
-       x2="95.644441"
-       x1="-77.726178"
-       id="linearGradient905"
-       gradientTransform="scale(1.0964158,0.9120627)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       xlink:href="#linearGradient1806"
-       id="linearGradient901" />
-    <linearGradient
-       y2="91.07699"
-       y1="-3.9104078"
-       xlink:href="#linearGradient888"
-       x2="27.674331"
-       x1="92.437968"
-       id="linearGradient891"
-       gradientTransform="scale(1.2267534,0.8151598)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       id="linearGradient888">
-      <stop
-         style="stop-color:#626262;stop-opacity:1.0000000;"
-         offset="0.0000000"
-         id="stop889" />
-      <stop
-         style="stop-color:#fff;stop-opacity:1;"
-         offset="1"
-         id="stop890" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient892">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.00000000;"
-         offset="0.00000000"
-         id="stop893" />
-      <stop
-         style="stop-color:#fff;stop-opacity:1;"
-         offset="1"
-         id="stop894" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient902">
-      <stop
-         style="stop-color:#000000;stop-opacity:0.00000000;"
-         offset="0.00000000"
-         id="stop903" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0.22000000;"
-         offset="1.0000000"
-         id="stop904" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient1098">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:1.0000000;"
-         offset="0.00000000"
-         id="stop1099" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.22314049;"
-         offset="0.50000000"
-         id="stop1101" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.00000000;"
-         offset="0.59930235"
-         id="stop1102" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.60330576;"
-         offset="1.0000000"
-         id="stop1100" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient1133">
-      <stop
-         style="stop-color:#8bb7df;stop-opacity:1.0000000;"
-         offset="0.00000000"
-         id="stop1134" />
-      <stop
-         style="stop-color:#2a6092;stop-opacity:1.0000000;"
-         offset="0.76209301"
-         id="stop1136" />
-      <stop
-         style="stop-color:#375e82;stop-opacity:1.0000000;"
-         offset="1.0000000"
-         id="stop1135" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient1317">
-      <stop
-         style="stop-color:#000000;stop-opacity:0.52892560;"
-         offset="0.00000000"
-         id="stop1318" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0.17355372;"
-         offset="0.50000000"
-         id="stop1320" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0.00000000;"
-         offset="1.0000000"
-         id="stop1319" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient893">
-      <stop
-         style="stop-color:#000;stop-opacity:1;"
-         offset="0"
-         id="stop895" />
-      <stop
-         style="stop-color:#fff;stop-opacity:1;"
-         offset="1"
-         id="stop896" />
-    </linearGradient>
-    <radialGradient
-       xlink:href="#linearGradient1806"
-       r="11.574221"
-       id="radialGradient1977"
-       fy="39.410465"
-       fx="42.280806"
-       cy="39.007645"
-       cx="42.007257"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       id="linearGradient1806">
-      <stop
-         style="stop-color:#000000;stop-opacity:0.35051546;"
-         offset="0.0000000"
-         id="stop1807" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0.13402061;"
-         offset="0.64999998"
-         id="stop3276" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop1808" />
-    </linearGradient>
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient5281"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient5283"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient5285"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <radialGradient
-       xlink:href="#linearGradient4362"
-       r="5.5130484"
-       inkscape:collect="always"
-       id="radialGradient1828"
-       fy="61.38567"
-       fx="86.542037"
-       cy="61.38567"
-       cx="86.542037"
-       gradientTransform="matrix(-0.8164966,0,0,1.2247449,262.80373,-280)"
-       gradientUnits="userSpaceOnUse" />
-    <radialGradient
-       xlink:href="#linearGradient4362"
-       r="11.123441"
-       inkscape:collect="always"
-       id="radialGradient1824"
-       fy="58.887858"
-       fx="118.06427"
-       cy="58.54025"
-       cx="117.17439"
-       gradientTransform="matrix(-0.6229142,0,0,1.6053575,262.80373,-280)"
-       gradientUnits="userSpaceOnUse" />
-    <radialGradient
-       xlink:href="#linearGradient4362"
-       r="22.00904"
-       inkscape:collect="always"
-       id="radialGradient1822"
-       fy="87.892895"
-       fx="45.50637"
-       cy="88.322677"
-       cx="45.139623"
-       gradientTransform="matrix(-1.0914815,0,0,0.9161859,262.80373,-280)"
-       gradientUnits="userSpaceOnUse" />
-    <radialGradient
-       xlink:href="#linearGradient4362"
-       r="18.836343"
-       inkscape:collect="always"
-       id="radialGradient1818"
-       fy="33.351633"
-       fx="48.40165"
-       cy="32.467054"
-       cx="48.40165"
-       gradientTransform="matrix(-1.1146027,0,0,0.8971807,262.80373,-280)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="74.834393"
-       y1="57.093738"
-       xlink:href="#linearGradient4376"
-       x2="50.203204"
-       x1="50.52668"
-       inkscape:collect="always"
-       id="linearGradient1815"
-       gradientTransform="matrix(-1.3516689,0,0,0.7398261,262.80373,-280)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       id="linearGradient4384">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.77513230;"
-         offset="0.0000000"
-         id="stop4385" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop4386" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient4376">
-      <stop
-         style="stop-color:#000000;stop-opacity:0.52645504;"
-         offset="0.0000000"
-         id="stop4377" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop4378" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient4362">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.66666669;"
-         offset="0.0000000"
-         id="stop4363" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop4364" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient4358">
-      <stop
-         style="stop-color:#000;stop-opacity:1;"
-         offset="0"
-         id="stop4359" />
-      <stop
-         style="stop-color:#fff;stop-opacity:1;"
-         offset="1"
-         id="stop4360" />
-    </linearGradient>
-    <radialGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="radialGradient5536"
-       gradientUnits="userSpaceOnUse"
-       cx="42.007257"
-       cy="39.007645"
-       fx="42.280806"
-       fy="39.410465"
-       r="11.574221" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient5538"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient5540"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient5542"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient5544"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient888"
-       id="linearGradient5546"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(2.4217071,0.4129318)"
-       x1="25.220815"
-       y1="178.48862"
-       x2="25.220815"
-       y2="234.26866" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient888"
-       id="linearGradient5548"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(2.4217071,0.4129318)"
-       x1="51.460928"
-       y1="269.85831"
-       x2="-16.224496"
-       y2="176.28694" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient893"
-       id="linearGradient5550"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.1870691,0.842411)"
-       x1="146.69923"
-       y1="224.57898"
-       x2="74.533693"
-       y2="81.477602" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient888"
-       id="linearGradient5552"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.9102155,0.5235012)"
-       x1="45.685757"
-       y1="110.4447"
-       x2="41.967061"
-       y2="232.24952" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient888"
-       id="linearGradient5554"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.0964158,0.9120627)"
-       x1="-77.726178"
-       y1="208.43991"
-       x2="95.644441"
-       y2="11.699047" />
-    <radialGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1133"
-       id="radialGradient5556"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.2267534,0.8151598)"
-       cx="60.004654"
-       cy="56.485935"
-       fx="72.107883"
-       fy="39.288476"
-       r="68.589222" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient888"
-       id="linearGradient5558"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.2267534,0.8151598)"
-       x1="92.437968"
-       y1="-3.9104078"
-       x2="27.674331"
-       y2="91.07699" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient892"
-       id="linearGradient5560"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.3207392,0.7571517)"
-       x1="39.810948"
-       y1="90.197025"
-       x2="17.876529"
-       y2="113.71949" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient892"
-       id="linearGradient5562"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.329144,0.7523639)"
-       x1="39.690614"
-       y1="49.507656"
-       x2="70.224305"
-       y2="20.481863" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient892"
-       id="linearGradient5564"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.3283861,0.7527932)"
-       x1="35.190362"
-       y1="76.277559"
-       x2="8.346058"
-       y2="105.42543" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient888"
-       id="linearGradient5566"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.1838753,0.8446836)"
-       x1="141.60217"
-       y1="228.39311"
-       x2="88.447016"
-       y2="133.54711" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient902"
-       id="linearGradient5568"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.3601783,0.7351977)"
-       x1="101.10657"
-       y1="177.77768"
-       x2="95.100155"
-       y2="173.03153" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient892"
-       id="linearGradient5570"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.3695887,0.7301462)"
-       x1="88.755695"
-       y1="169.09755"
-       x2="88.996957"
-       y2="182.99154" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1317"
-       id="linearGradient5572"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.223869,0.8170809)"
-       x1="111.49758"
-       y1="131.25248"
-       x2="107.04918"
-       y2="148.78619" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient892"
-       id="linearGradient5574"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(2.1051174,0.4750329)"
-       x1="31.449743"
-       y1="203.499"
-       x2="31.617281"
-       y2="251.21892" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient5714"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <radialGradient
-       xlink:href="#linearGradient4362"
-       r="39.648127"
-       inkscape:collect="always"
-       id="radialGradient2797"
-       fy="101.92288"
-       fx="50.092871"
-       cy="102.70191"
-       cx="49.760482"
-       gradientTransform="scale(1.1222336,0.8910801)"
-       gradientUnits="userSpaceOnUse" />
-    <radialGradient
-       xlink:href="#linearGradient4362"
-       r="35.284406"
-       inkscape:collect="always"
-       id="radialGradient2791"
-       fy="32.061308"
-       fx="81.553592"
-       cy="33.402904"
-       cx="80.599566"
-       gradientTransform="scale(0.8352269,1.1972794)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="67.164412"
-       y1="53.505203"
-       xlink:href="#linearGradient4376"
-       x2="63.804663"
-       x1="64.786456"
-       inkscape:collect="always"
-       id="linearGradient2789"
-       gradientTransform="scale(1.1424512,0.8753109)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       id="linearGradient6015">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.77513230;"
-         offset="0.0000000"
-         id="stop6017" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop6019" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient6009">
-      <stop
-         style="stop-color:#000000;stop-opacity:0.52645504;"
-         offset="0.0000000"
-         id="stop6011" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop6013" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient6003">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.66666669;"
-         offset="0.0000000"
-         id="stop6005" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop6007" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient5997">
-      <stop
-         style="stop-color:#000;stop-opacity:1;"
-         offset="0"
-         id="stop5999" />
-      <stop
-         style="stop-color:#fff;stop-opacity:1;"
-         offset="1"
-         id="stop6001" />
-    </linearGradient>
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient6037"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <linearGradient
-       y2="0.46093750"
-       y1="0.46093750"
-       xlink:href="#linearGradient650"
-       x2="1.16666818"
-       x1="1.22222710"
-       spreadMethod="repeat"
-       id="linearGradient654"
-       gradientUnits="objectBoundingBox" />
-    <linearGradient
-       y2="0.53906250"
-       y1="0.53125000"
-       xlink:href="#linearGradient650"
-       x2="1.16666901"
-       x1="1.00000548"
-       spreadMethod="repeat"
-       id="linearGradient653"
-       gradientUnits="objectBoundingBox" />
-    <linearGradient
-       id="linearGradient650">
-      <stop
-         style="stop-color:#000;stop-opacity:1;"
-         offset="0"
-         id="stop651" />
-      <stop
-         style="stop-color:#fff;stop-opacity:1;"
-         offset="1"
-         id="stop652" />
-    </linearGradient>
-    <linearGradient
-       y2="0.46093750"
-       y1="0.46093750"
-       xlink:href="#linearGradient650"
-       x2="1.16666818"
-       x1="1.22222710"
-       spreadMethod="repeat"
-       id="linearGradient9648"
-       gradientUnits="objectBoundingBox" />
-    <linearGradient
-       y2="0.53906250"
-       y1="0.53125000"
-       xlink:href="#linearGradient650"
-       x2="1.16666901"
-       x1="1.00000548"
-       spreadMethod="repeat"
-       id="linearGradient9646"
-       gradientUnits="objectBoundingBox" />
-    <linearGradient
-       id="linearGradient9640">
-      <stop
-         style="stop-color:#000;stop-opacity:1;"
-         offset="0"
-         id="stop9642" />
-      <stop
-         style="stop-color:#fff;stop-opacity:1;"
-         offset="1"
-         id="stop9644" />
-    </linearGradient>
-  </defs>
-  <sodipodi:namedview
-     id="base"
-     pagecolor="#ffffff"
-     bordercolor="#666666"
-     borderopacity="1.0"
-     gridtolerance="10000"
-     guidetolerance="10"
-     objecttolerance="10"
-     inkscape:pageopacity="0.0"
-     inkscape:pageshadow="2"
-     inkscape:zoom="0.8"
-     inkscape:cx="578.40513"
-     inkscape:cy="404.22798"
-     inkscape:document-units="px"
-     inkscape:current-layer="layer1"
-     width="1052.3622px"
-     height="744.09448px"
-     showgrid="true"
-     inkscape:window-width="1405"
-     inkscape:window-height="869"
-     inkscape:window-x="0"
-     inkscape:window-y="25" />
-  <metadata
-     id="metadata7">
-    <rdf:RDF>
-      <cc:Work
-         rdf:about="">
-        <dc:format>image/svg+xml</dc:format>
-        <dc:type
-           rdf:resource="http://purl.org/dc/dcmitype/StillImage" />
-      </cc:Work>
-    </rdf:RDF>
-  </metadata>
-  <g
-     inkscape:label="Layer 1"
-     inkscape:groupmode="layer"
-     id="layer1">
-    <g
-       inkscape:label="Layer 1"
-       id="g4996"
-       transform="matrix(0.331077,0,0,0.2676656,75.992157,230.68349)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
-       inkscape:export-xdpi="42.227192"
-       inkscape:export-ydpi="42.227192">
-      <g
-         transform="matrix(2.674162,0,0,2.674162,-826.248,-323.8239)"
-         id="g6052">
-        <path
-           style="fill:#c7c7c7;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:6.11299896;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
-           sodipodi:nodetypes="czcczzz"
-           id="path1306"
-           d="M 362.77592,187.283 C 360.50343,190.98677 361.20593,367.68763 364.14011,374.65173 C 366.46268,380.1642 441.02381,442.12988 444.93699,443.78694 C 495.35017,443.444 529.34176,425.0858 534.99109,415.38735 C 537.14042,403.1889 535.31621,215.19709 533.25552,211.25359 C 531.47859,207.85312 436.04893,173.6386 432.71615,172.86054 C 429.71763,172.16052 365.30189,183.1661 362.77592,187.283 z " />
-        <path
-           style="fill:#ffffff;fill-opacity:0.54385968;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
-           sodipodi:nodetypes="ccccccc"
-           id="path2066"
-           d="M 366.42857,190.93361 C 391.19048,201.4098 418.60601,218.30739 446.22506,231.64072 C 472.394,225.42153 510.2022,217.10972 529.24981,213.77639 C 504.726,221.39543 472.52022,228.51448 447.99641,236.13353 C 446.56784,293.51448 447.257,380.45861 445.82843,437.83956 C 445.11414,379.98242 443.14285,291.6479 442.42856,233.79075 C 415.99999,219.50504 390,206.64789 366.42857,190.93361 z " />
-        <path
-           style="fill:#000000;fill-opacity:0.16228069;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
-           sodipodi:nodetypes="ccc"
-           id="path4356"
-           d="M 519.99794,379.97737 C 510.93834,392.99882 482.41849,399.43361 468.8726,394.16864 C 471.21835,393.5424 516.96143,380.96883 519.99794,379.97737 z " />
-        <g
-           transform="translate(2.035534,15.20712)"
-           id="g4374">
-          <path
-             style="fill:#ffffff;fill-opacity:0.39473685;fill-rule:evenodd;stroke:none;stroke-width:1.01199996;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
-             sodipodi:nodetypes="cccccc"
-             id="path4362"
-             d="M 471.29127,340.59039 L 513.55921,324.30516 C 517.9002,325.84805 517.04588,332.27818 517.04588,332.27818 L 510.46155,334.58088 C 510.46155,334.58088 501.26764,349.01224 484.93096,343.36795 C 484.93096,343.36795 472.7787,345.52605 471.29127,340.59039 z " />
-          <path
-             style="fill:#606060;fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:1.11199999;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
-             sodipodi:nodetypes="ccccccc"
-             id="path2826"
-             d="M 471.66824,335.10501 C 485.70133,331.45482 499.73443,327.80464 513.76752,324.15445 C 514.30594,326.13864 514.34437,328.99782 513.50779,330.48201 C 511.36566,331.50652 507.10221,332.35425 504.96008,333.37876 C 498.80357,339.27354 493.45917,339.80363 483.65919,338.95243 C 479.87505,339.74603 476.0909,340.36284 472.30676,341.15644 C 471.15285,338.85897 470.82215,337.90248 471.66824,335.10501 z " />
-        </g>
-        <path
-           style="fill:#ffffff;fill-opacity:0.40350874;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
-           sodipodi:nodetypes="ccccc"
-           id="path4423"
-           d="M 364.8671,189.69191 L 446.71991,235.61832 L 446.39149,441.00771 L 366.28132,373.53968 L 364.8671,189.69191 z " />
-        <path
-           style="fill:#000000;fill-opacity:0.16228069;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
-           sodipodi:nodetypes="ccc"
-           id="path5957"
-           d="M 515.24794,392.97737 C 505.81506,405.42036 486.94113,407.56087 476.3726,403.76831 C 478.1563,403.29212 512.93901,393.73127 515.24794,392.97737 z " />
-        <path
-           style="fill:#000000;fill-opacity:0.16228069;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
-           sodipodi:nodetypes="ccc"
-           id="path5959"
-           d="M 508.24794,405.72737 C 502.79158,413.09279 492.2492,415.37141 483.8726,412.49343 C 484.991,412.19485 506.80021,406.20008 508.24794,405.72737 z " />
-        <path
-           style="fill:#fcfcfc;fill-opacity:0.44298245;fill-rule:evenodd;stroke:none;stroke-width:0.31200001;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
-           sodipodi:nodetypes="ccccccc"
-           id="path5973"
-           d="M 522.875,227.86218 L 527.04289,228.4302 L 527.79289,326.56929 L 463.46862,344.54896 L 461.88388,339.34073 L 523.68934,322.86218 L 522.875,227.86218 z " />
-        <path
-           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
-           sodipodi:nodetypes="cccc"
-           id="path6026"
-           d="M 462.21967,264.23013 L 462.31434,266.99086 L 522.7929,249.54632 L 462.21967,264.23013 z " />
-        <path
-           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
-           sodipodi:nodetypes="cccc"
-           id="path6036"
-           d="M 461.33579,284.2059 L 461.43046,286.96663 L 521.90902,269.52209 L 461.33579,284.2059 z " />
-        <path
-           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
-           sodipodi:nodetypes="cccc"
-           id="path6038"
-           d="M 462.21967,302.64613 L 462.31434,305.40686 L 522.7929,287.96232 L 462.21967,302.64613 z " />
-        <path
-           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
-           sodipodi:nodetypes="cccc"
-           id="path6040"
-           d="M 462.21967,320.79868 L 462.31434,323.55941 L 522.7929,306.11487 L 462.21967,320.79868 z " />
-        <path
-           style="opacity:1;color:#000000;fill:none;fill-opacity:0.75;fill-rule:evenodd;stroke:#9e9e9e;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
-           sodipodi:nodetypes="ccc"
-           id="path5988"
-           d="M 522.55191,229.64344 L 462.03362,244.76045 L 462.53549,344.35813" />
-      </g>
-    </g>
-    <g
-       id="g5256"
-       transform="translate(601.5744,207.49165)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
-       inkscape:export-xdpi="42.227192"
-       inkscape:export-ydpi="42.227192">
-      <path
-         transform="matrix(6.392368,0.545409,-0.130014,2.864752,-184.6606,-38.15109)"
-         style="fill:url(#radialGradient1977);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:type="arc"
-         sodipodi:ry="12.562782"
-         sodipodi:rx="12.562782"
-         sodipodi:cy="37.865574"
-         sodipodi:cx="41.875938"
-         id="path1976"
-         d="M 54.438721 37.865574 A 12.562782 12.562782 0 1 1  29.313156,37.865574 A 12.562782 12.562782 0 1 1  54.438721 37.865574 z" />
-      <g
-         transform="matrix(1,0,0,1.036969,356.8306,-11.4294)"
-         style="fill:url(#linearGradient6037);fill-opacity:1"
-         id="g4293">
-        <path
-           style="fill:url(#linearGradient5281);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
-           id="path2720"
-           d="M -270.85787,33.814995 C -289.35564,33.925992 -307.93321,33.592782 -326.38104,33.981747 C -331.43469,35.696391 -331.02221,41.899652 -330.68524,46.15332 C -330.75782,60.227303 -330.53537,74.298225 -330.21167,88.36826 C -328.21297,91.039611 -323.21766,90.618387 -322.68469,94.539015 C -320.78054,96.259426 -317.05071,94.88215 -314.4389,95.333237 C -298.54999,95.360274 -282.66107,95.387302 -266.77215,95.414339 C -266.35587,90.465192 -260.12609,88.824447 -255.81783,89.540255 C -256.01688,89.058389 -261.69557,87.939375 -259.61591,84.491525 C -259.45681,68.72727 -259.19734,52.882199 -259.82064,37.168229 C -261.19394,32.980583 -267.34179,33.83368 -270.85787,33.814995 z M -236.65184,97.260473 C -234.79025,100.12642 -237.08724,103.09386 -239.92892,104.16357 C -242.6311,105.91539 -245.59105,107.62992 -248.52894,108.76804 C -253.1773,108.19079 -251.42424,101.88475 -255.01281,99.896645 C -260.33594,96.447012 -267.21045,98.43943 -273.23329,97.939231 C -291.8249,97.94887 -310.41651,97.958519 -329.00813,97.968158 C -335.45898,103.56578 -339.16595,111.40269 -341.55034,119.32178 C -337.25147,124.2061 -329.89606,122.27575 -324.10438,122.40002 C -298.64553,122.23171 -273.11679,122.61546 -247.69897,122.24542 C -243.40174,121.14669 -247.44685,114.84894 -243.58488,113.04441 C -242.73865,112.73374 -247.81245,114.4382 -247.26205,111.62955 C -245.49117,106.66028 -239.14113,105.99595 -235.92338,102.36811 C -234.39131,99.755669 -236.26958,96.922488 -238.33047,95.260495 C -237.77093,95.927151 -237.21138,96.593817 -236.65184,97.260473 z M -240.64255,111.75263 C -243.64086,113.13223 -237.02792,110.69536 -235.55512,111.97369 C -229.71113,112.74417 -224.16461,117.19625 -218.12358,115.22951 C -225.97639,116.31604 -232.799,109.03014 -240.64255,111.75263 z M -212.01083,112.33724 C -215.98173,113.85021 -208.21543,112.17765 -210.07883,115.87566 C -212.50961,119.93855 -206.99008,113.8662 -209.61436,112.54677 C -210.16198,111.94632 -211.27989,112.47663 -212.01083,112.33724 z M -213.97451,120.82946 C -220.13871,124.32615 -228.37873,119.08124 -233.85995,124.39439 C -238.36465,128.00055 -244.57099,130.35185 -247.0433,135.75122 C -247.65922,139.60202 -243.25109,141.90251 -240.44565,143.71808 C -235.60127,146.54512 -228.8227,145.75388 -225.20082,141.42836 C -220.62679,137.96117 -216.44182,134.08489 -212.48592,129.96782 C -212.82701,126.95048 -214.43694,123.63971 -213.97451,120.82946 z " />
-        <path
-           style="fill:url(#linearGradient5283);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
-           id="path2723"
-           d="M -269.68453,32.256957 C -288.76965,32.351184 -307.87514,32.249603 -326.94796,32.349264 C -332.63884,33.663474 -333.90446,40.291305 -333.21597,45.149113 C -333.11996,59.896901 -333.07471,74.659754 -332.61729,89.39481 C -331.88583,93.310348 -324.86009,92.098674 -325.11097,96.44089 C -328.07184,96.184706 -331.5534,96.317135 -333.07248,99.246492 C -338.92562,104.98392 -341.99312,112.66465 -344.27268,120.28679 C -340.22572,125.96631 -332.26467,125.31453 -326.02946,124.71751 C -300.16629,124.7277 -274.28316,124.82043 -248.43245,124.77905 C -244.42424,124.78686 -243.30672,120.35609 -243.96666,117.2099 C -242.88598,112.93536 -237.04086,113.94554 -233.80717,114.98513 C -228.01851,116.64297 -221.26418,120.43074 -215.57982,116.37592 C -211.36091,113.71809 -213.05678,118.4029 -215.77936,119.43344 C -220.82539,122.25797 -227.09125,118.98178 -232.39677,121.20855 C -236.53238,123.88957 -240.74707,126.85249 -244.76678,129.74666 C -248.34219,132.01467 -251.90947,137.38626 -248.13747,140.97315 C -243.79274,146.02948 -236.37425,149.4527 -229.68248,147.08651 C -225.09383,144.85973 -221.79206,140.75401 -217.61535,137.88661 C -215.10454,135.69469 -212.49235,133.26839 -210.83749,130.50207 C -210.86477,126.92195 -214.68529,121.91303 -210.252,119.57013 C -207.25619,117.95208 -205.81053,112.12098 -209.75314,110.87946 C -214.16982,109.44692 -216.95156,115.09837 -221.43751,113.68608 C -228.47365,112.76758 -235.5565,107.20489 -242.69931,110.72434 C -246.89551,113.06547 -243.47174,109.4356 -241.45524,108.56544 C -237.85613,106.84628 -232.73147,104.36798 -233.94637,99.617708 C -234.27189,95.083838 -239.22223,93.197522 -242.95318,91.723135 C -247.61613,89.074942 -253.27003,89.345117 -258.06082,86.933298 C -257.89248,70.385101 -257.58805,53.76423 -258.26571,37.261116 C -259.2092,32.393288 -265.59824,31.96057 -269.68453,32.256957 z M -258.66259,91.764016 C -251.5059,92.239344 -243.21163,93.474137 -238.58238,99.271629 C -238.96251,103.06003 -244.00295,103.80224 -246.52821,106.14082 C -248.92267,108.48087 -251.12372,105.80503 -251.02958,103.27159 C -252.70852,98.336432 -258.20582,95.710815 -263.31841,96.533197 C -267.00561,96.7255 -263.71935,91.937514 -261.395,92.380192 C -260.48382,92.178338 -259.57521,91.953759 -258.66259,91.764016 z " />
-        <path
-           style="fill:url(#linearGradient5285);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
-           sodipodi:nodetypes="ccccczccccccccccccccccccczccccc"
-           id="path2737"
-           d="M -324.0398,30.70877 C -336.3492,30.820231 -335.15663,39.652507 -334.79476,45.313268 C -334.5469,60.436643 -334.38614,75.599009 -334.01234,90.698281 C -333.20516,93.057424 -330.71249,93.985661 -328.75475,95.252079 C -334.4553,96.476239 -336.96996,102.43195 -340.11175,106.59303 C -342.33294,111.36531 -347.84019,115.92868 -345.92111,121.43642 C -344.00204,126.94416 -332.21757,127.68181 -324.95408,127.12866 C -299.06901,127.09789 -273.17022,127.14905 -247.29372,127.06713 C -243.29961,126.16956 -240.99668,122.03601 -241.4977,118.23645 C -238.30082,114.95371 -233.32521,118.03039 -229.53292,118.63002 C -225.71641,119.31313 -232.5646,119.27527 -233.19362,120.54849 C -238.23604,122.95799 -242.6166,126.65447 -246.90973,130.10509 C -250.44674,132.97354 -252.4229,138.10741 -249.57412,142.08235 C -246.21315,145.92284 -241.41489,148.84284 -236.30395,149.79628 C -230.65487,150.83779 -225.57101,147.82678 -221.6157,144.24077 C -216.87391,140.59839 -212.0873,136.78287 -208.84361,131.80554 C -207.76302,128.26399 -211.47449,123.86671 -208.08348,121.09796 C -204.93438,118.46115 -204.06893,113.02076 -207.41836,110.2673 C -212.81988,106.81278 -218.36682,114.55112 -223.89705,111.29128 C -227.94209,110.1659 -231.91311,108.52596 -236.17676,108.45194 C -231.52711,105.88023 -229.62903,98.782331 -234.08944,95.153402 C -239.61551,89.404431 -248.455,88.793917 -255.40182,85.744487 C -255.86992,78.940296 -255.53665,71.972758 -255.70928,65.098797 C -255.80747,55.730822 -255.73864,46.312632 -255.94025,36.975777 C -258.03631,31.236293 -265.34014,30.439522 -270.76286,30.729689 C -289.40725,30.770714 -311.88665,30.597309 -324.0398,30.70877 z M -255.46516,94.482857 C -250.34561,95.62106 -244.69322,96.21649 -240.83258,100.05203 C -242.37635,102.55028 -245.27573,103.64481 -247.80048,104.97505 C -249.71506,99.684643 -254.39847,94.970039 -260.51378,95.138259 C -260.66903,94.131274 -256.73261,94.551178 -255.46516,94.482857 z " />
-      </g>
-      <rect
-         y="78.658051"
-         x="33.326111"
-         width="57.567924"
-         style="fill:url(#linearGradient1156);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient1157);stroke-width:1.44734821pt"
-         id="rect1155"
-         height="8.3153667" />
-      <path
-         style="fill:url(#linearGradient1169);fill-rule:evenodd;stroke-width:0.90459263;stroke-opacity:0.07438019"
-         sodipodi:nodetypes="czzczczzzzzzzc"
-         id="path2676"
-         d="M 98.723806,78.927818 C 95.18666,77.759681 93.50122,82.555591 98.766686,81.004087 C 104.03217,79.452583 120.13123,85.906451 120.37383,89.795491 C 120.61643,93.905503 101.5003,98.581154 106.74108,104.42426 C 111.62816,110.70149 115.35468,100.13868 123.54696,104.21261 C 131.73923,108.17607 136.26048,109.72394 142.25488,104.94185 C 149.10027,101.9342 145.04599,107.07658 139.57918,113.60451 C 134.11237,120.13244 144.00251,115.08156 147.91225,105.31962 C 151.93248,95.557673 139.13128,107.33503 133.66268,105.40571 C 128.19408,103.47639 119.73678,97.849788 113.27625,102.55563 C 106.81572,107.26147 109.62894,99.493003 114.85637,97.90307 C 120.0838,96.092166 122.81363,93.045722 122.85597,90.161522 C 122.89831,87.498293 117.92629,84.811803 112.94229,82.402852 C 107.73732,79.993901 100.49788,78.588966 98.723806,78.927818 z " />
-      <path
-         style="fill:url(#linearGradient1140);fill-opacity:1;fill-rule:evenodd;stroke-width:1.44734821pt"
-         sodipodi:nodetypes="czzzzzzzz"
-         id="path1139"
-         d="M 15.102732,106.80712 C 13.80355,109.23224 17.148847,113.52338 19.900059,113.52338 L 107.85106,113.52338 C 110.18914,113.52338 113.70766,110.4906 112.64839,108.40622 L 102.7339,88.897093 C 101.97024,87.394398 100.26184,86.65834 98.576216,86.65834 L 28.215425,86.658339 C 26.825434,86.658339 25.353768,87.671846 24.697385,88.897093 L 15.102732,106.80712 z " />
-      <rect
-         y="22.413721"
-         x="26.015469"
-         width="72.279724"
-         style="fill:url(#linearGradient905);fill-opacity:1;fill-rule:evenodd;stroke-width:1.62826681"
-         ry="5.4369707"
-         rx="5.4369707"
-         id="rect1137"
-         height="60.126495" />
-      <rect
-         y="31.695871"
-         x="33.386066"
-         width="58.178177"
-         style="fill:url(#radialGradient1132);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient891);stroke-width:1.4649456pt"
-         id="rect1131"
-         height="38.044163" />
-      <path
-         style="fill:url(#linearGradient1146);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="czzccccc"
-         id="path1145"
-         d="M 27.690431,52.841444 L 27.370609,74.749236 C 27.319624,78.241665 29.310209,80.477938 32.807578,80.506029 L 72.625393,80.825852 L 76.463254,71.87084 L 32.008024,71.55102 L 31.688202,52.681533 L 27.690431,52.841444 z " />
-      <g
-         transform="matrix(-1,0,0,1,125.4301,0)"
-         id="g1791">
-        <path
-           style="fill:url(#linearGradient1148);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-           sodipodi:nodetypes="czzccc"
-           id="path1147"
-           d="M 42.062098,33.460351 L 77.341205,33.008055 C 82.787126,32.938235 89.553204,38.416797 89.553204,43.863165 L 89.553204,60.14583 L 41.609801,59.693534 L 42.062098,33.460351 z " />
-        <path
-           style="fill:url(#linearGradient1150);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-           sodipodi:nodetypes="czzccc"
-           id="path1149"
-           d="M 78.337784,67.629235 L 46.723745,67.724544 C 41.843589,67.739257 35.829319,62.771024 35.877168,57.891081 L 36.020221,43.301821 L 78.973514,44.128288 L 78.337784,67.629235 z " />
-      </g>
-      <path
-         style="fill:url(#linearGradient1167);fill-opacity:1;fill-rule:evenodd;stroke-width:0.72367412;stroke-opacity:0.34710741"
-         sodipodi:nodetypes="cczzzzzzc"
-         id="path1159"
-         d="M 137.39107,112.02341 C 137.39107,112.02341 129.0757,110.26438 123.63872,113.62251 C 118.20176,116.98064 109.96635,123.21719 108.76702,124.81628 C 107.40777,126.57531 107.42036,130.22796 109.24674,131.53253 L 114.84364,135.53031 C 118.31797,138.01198 124.86218,139.25396 128.11624,136.48978 L 142.98795,123.85681 C 144.79792,122.3193 145.72732,118.27921 144.10733,116.82073 C 142.95609,115.04975 140.4892,112.91939 137.39107,112.02341 z " />
-      <path
-         style="fill:url(#linearGradient1171);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="czzzzzc"
-         id="path1160"
-         d="M 142.3483,121.13833 L 125.91043,133.59673 C 122.97154,135.82414 118.65484,134.11775 116.28283,133.77129 C 113.9108,133.42481 111.88528,131.87901 112.12516,132.33209 C 112.36503,132.78517 115.08349,135.71687 117.72203,136.48978 C 120.36055,137.26267 124.9543,138.89307 127.50953,136.15531 C 130.06477,133.41755 145.2267,123.53699 142.3483,121.13833 z " />
-      <path
-         style="fill:url(#linearGradient1404);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="cczc"
-         id="path1403"
-         d="M 132.11225,127.51984 C 135.31047,122.88242 120.11893,113.12786 109.08509,127.0401 C 110.20446,130.71805 116.80662,132.5992 121.82304,132.33547 C 126.68363,132.07993 129.50037,129.97181 132.11225,127.51984 z " />
-      <path
-         style="fill:url(#linearGradient1166);fill-opacity:1;fill-rule:evenodd;stroke-width:1.08551121"
-         sodipodi:nodetypes="cccccccc"
-         id="path1519"
-         d="M 138.63464,112.68306 C 135.9958,113.22749 132.31739,114.43079 129.87534,116.38362 C 128.77009,115.68011 125.32759,114.5677 123.66767,113.84494 L 123.24572,114.10517 C 129.67287,117.23476 136.43512,117.91249 135.88192,122.87668 C 136.33675,122.98575 137.05589,123.09702 136.73191,122.38863 C 136.41775,118.90392 132.50587,117.23351 131.02697,116.81532 C 133.17224,114.26602 136.255,113.70892 138.63464,112.68306 z " />
-      <path
-         style="fill:url(#linearGradient1144);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="czzzzzzzz"
-         id="path1143"
-         d="M 18.891612,106.48414 C 17.978451,108.31614 19.173914,111.55774 22.263529,111.55774 L 105.0195,111.55774 C 106.66288,111.55774 109.13595,109.26672 108.39142,107.69215 L 101.42279,92.954575 C 100.88602,91.819403 99.685232,91.263378 98.500462,91.263378 L 28.108183,91.263369 C 27.131195,91.263369 26.0968,92.028994 25.635445,92.954575 L 18.891612,106.48414 z " />
-      <text
-         y="-14.660837"
-         xml:space="preserve"
-         x="6.147172"
-         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
-         id="text1232"><tspan
-           id="tspan1233">Computer</tspan></text>
-      <text
-         y="-34.951134"
-         xml:space="preserve"
-         x="84.564949"
-         transform="scale(0.246729,0.246729)"
-         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
-         id="text1235"><tspan
-           id="tspan1236">Created by Andrew Fitzsimon</tspan></text>
-    </g>
-    <g
-       id="g5474"
-       transform="translate(633.63525,501.49239)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
-       inkscape:export-xdpi="42.227192"
-       inkscape:export-ydpi="42.227192">
-      <path
-         style="fill:#ffffff;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="cccc"
-         id="path9383"
-         d="M 203.47051,-209.74941 C 198.72111,-204.56585 195.69876,-195.27863 189.00642,-195.27863 C 182.52997,-197.07848 181.66644,-212.48518 180.80291,-215.7969 C 188.1429,-210.75732 195.69876,-207.87757 203.47051,-209.74941 z " />
-      <path
-         transform="matrix(-0.440859,0,0,0.441062,265.52775,-266.17138)"
-         style="fill:#f1bb96;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:type="arc"
-         sodipodi:ry="57.825485"
-         sodipodi:rx="60.94183"
-         sodipodi:cy="70.290855"
-         sodipodi:cx="150.27701"
-         id="path3713"
-         d="M 211.21884 70.290855 A 60.94183 57.825485 0 1 1  89.335178,70.290855 A 60.94183 57.825485 0 1 1  211.21884 70.290855 z" />
-      <path
-         style="fill:#233e6a;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="ccssssc"
-         id="path4369"
-         d="M 232.46888,-182.94274 C 232.85952,-157.74648 168.23012,-154.86512 168.38642,-182.94274 C 166.84164,-205.27149 177.94687,-217.96719 180.70654,-215.80872 C 182.10778,-214.71274 182.62841,-190.37295 192.09635,-195.9716 C 196.69923,-198.69339 201.84768,-209.14846 204.10029,-209.49532 C 207.49937,-210.01873 214.00811,-212.77083 219.98583,-217.92153 C 221.55412,-219.27285 231.93943,-205.38255 232.46888,-182.94274 z " />
-      <path
-         style="fill:#513624;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="ccccc"
-         id="path11309"
-         d="M 204.55432,-273.85152 C 222.46413,-271.53047 237.32676,-259.28175 231.38357,-231.42099 C 229.66954,-221.67743 222.12426,-217.60887 219.35537,-236.36962 C 211.4578,-233.88387 177.25785,-223.92576 170.54948,-241.26677 C 166.55631,-248.43407 174.86257,-276.23329 204.55432,-273.85152 z " />
-      <path
-         style="fill:#1f4eb3;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="cccc"
-         id="path11942"
-         d="M 191.92173,-167.75448 C 192.06919,-184.44566 194.18855,-193.73288 188.47558,-194.95709 C 182.9785,-195.85052 179.91138,-176.52634 179.04785,-173.21462 C 175.85958,-157.19769 189.53653,-154.44605 191.92173,-167.75448 z " />
-      <path
-         style="fill:url(#linearGradient1815);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         id="path1811"
-         d="M 172.67812,-237.76056 C 182.56217,-225.58826 212.09549,-234.15979 219.36562,-236.44806 C 220.33459,-229.88278 221.90014,-226.25074 223.58437,-224.54181 C 219.31219,-215.8234 210.06249,-209.76056 199.27187,-209.76056 C 184.44142,-209.76056 172.42812,-221.18201 172.42812,-235.26056 C 172.42812,-236.11869 172.59078,-236.92413 172.67812,-237.76056 z " />
-      <path
-         style="fill:url(#radialGradient1818);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="ccccc"
-         id="path1817"
-         d="M 203.17522,-273.74212 C 221.08504,-271.42107 235.94766,-259.17235 230.00448,-231.31159 C 228.29044,-221.56803 220.74517,-217.49946 217.97627,-236.26022 C 210.0787,-233.77447 175.87876,-223.81635 169.17039,-241.15737 C 165.17722,-248.32467 173.48348,-276.12389 203.17522,-273.74212 z " />
-      <path
-         style="fill:url(#radialGradient1822);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         id="path1819"
-         d="M 220.74123,-214.1875 C 227.87764,-203.73841 231.28831,-190.18836 229.45998,-177.71875 C 222.3997,-165.39834 205.93726,-163.52328 193.05373,-164.75 C 194.11526,-173.29796 194.69425,-182.39807 193.51876,-190.98978 C 191.02311,-195.41909 199.33209,-197.29913 200.39748,-201.6875 C 203.70655,-208.92744 212.80427,-208.10966 218.04988,-213.3696 C 218.9201,-213.57294 220.00051,-215.94141 220.74123,-214.1875 z M 179.55373,-210.28125 C 180.69974,-204.97453 181.23339,-199.24919 184.58498,-194.75 C 179.40159,-187.81847 178.05976,-178.63643 176.67873,-170.28125 C 167.10271,-177.01707 169.81568,-190.62142 172.02963,-200.39411 C 173.03008,-204.26346 176.36728,-212.34166 179.19382,-211.77772 C 179.27177,-211.45363 179.5117,-210.45598 179.55373,-210.28125 z " />
-      <path
-         style="fill:url(#radialGradient1824);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="cccc"
-         id="path1823"
-         d="M 192.35803,-167.43887 C 192.50549,-184.13006 194.62485,-193.41727 188.91188,-194.64149 C 183.4148,-195.53491 180.34768,-176.21073 179.48415,-172.89901 C 176.29589,-156.88208 189.97283,-154.13044 192.35803,-167.43887 z " />
-      <path
-         style="fill:#1f4eb3;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
-         sodipodi:nodetypes="ccccc"
-         id="path1825"
-         d="M 185.2414,-200.53324 C 185.2414,-197.95291 187.25802,-195.85872 189.74278,-195.85872 C 192.22755,-195.85872 194.24417,-197.95291 194.24417,-200.53324 C 194.24417,-203.11357 193.61259,-209.36288 191.12783,-209.36288 C 188.64306,-209.36288 185.2414,-203.11357 185.2414,-200.53324 z " />
-      <path
-         style="fill:url(#radialGradient1828);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="ccccc"
-         id="path1827"
-         d="M 186.28018,-201.05263 C 186.28018,-198.4723 188.2968,-196.37811 190.78156,-196.37811 C 193.26633,-196.37811 195.28295,-198.4723 195.28295,-201.05263 C 195.28295,-203.63296 194.65137,-209.88227 192.16661,-209.88227 C 189.68184,-209.88227 186.28018,-203.63296 186.28018,-201.05263 z " />
-    </g>
-    <g
-       id="g5488"
-       transform="translate(601.5744,407.49165)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
-       inkscape:export-xdpi="42.227192"
-       inkscape:export-ydpi="42.227192">
-      <path
-         transform="matrix(6.392368,0.545409,-0.130014,2.864752,-184.6606,-38.15109)"
-         style="fill:url(#radialGradient5536);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:type="arc"
-         sodipodi:ry="12.562782"
-         sodipodi:rx="12.562782"
-         sodipodi:cy="37.865574"
-         sodipodi:cx="41.875938"
-         id="path5490"
-         d="M 54.438721 37.865574 A 12.562782 12.562782 0 1 1  29.313156,37.865574 A 12.562782 12.562782 0 1 1  54.438721 37.865574 z" />
-      <g
-         transform="matrix(1,0,0,1.036969,356.8306,-11.4294)"
-         style="fill:url(#linearGradient5538);fill-opacity:1"
-         id="g5492">
-        <path
-           style="fill:url(#linearGradient5540);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
-           id="path5494"
-           d="M -270.85787,33.814995 C -289.35564,33.925992 -307.93321,33.592782 -326.38104,33.981747 C -331.43469,35.696391 -331.02221,41.899652 -330.68524,46.15332 C -330.75782,60.227303 -330.53537,74.298225 -330.21167,88.36826 C -328.21297,91.039611 -323.21766,90.618387 -322.68469,94.539015 C -320.78054,96.259426 -317.05071,94.88215 -314.4389,95.333237 C -298.54999,95.360274 -282.66107,95.387302 -266.77215,95.414339 C -266.35587,90.465192 -260.12609,88.824447 -255.81783,89.540255 C -256.01688,89.058389 -261.69557,87.939375 -259.61591,84.491525 C -259.45681,68.72727 -259.19734,52.882199 -259.82064,37.168229 C -261.19394,32.980583 -267.34179,33.83368 -270.85787,33.814995 z M -236.65184,97.260473 C -234.79025,100.12642 -237.08724,103.09386 -239.92892,104.16357 C -242.6311,105.91539 -245.59105,107.62992 -248.52894,108.76804 C -253.1773,108.19079 -251.42424,101.88475 -255.01281,99.896645 C -260.33594,96.447012 -267.21045,98.43943 -273.23329,97.939231 C -291.8249,97.94887 -310.41651,97.958519 -329.00813,97.968158 C -335.45898,103.56578 -339.16595,111.40269 -341.55034,119.32178 C -337.25147,124.2061 -329.89606,122.27575 -324.10438,122.40002 C -298.64553,122.23171 -273.11679,122.61546 -247.69897,122.24542 C -243.40174,121.14669 -247.44685,114.84894 -243.58488,113.04441 C -242.73865,112.73374 -247.81245,114.4382 -247.26205,111.62955 C -245.49117,106.66028 -239.14113,105.99595 -235.92338,102.36811 C -234.39131,99.755669 -236.26958,96.922488 -238.33047,95.260495 C -237.77093,95.927151 -237.21138,96.593817 -236.65184,97.260473 z M -240.64255,111.75263 C -243.64086,113.13223 -237.02792,110.69536 -235.55512,111.97369 C -229.71113,112.74417 -224.16461,117.19625 -218.12358,115.22951 C -225.97639,116.31604 -232.799,109.03014 -240.64255,111.75263 z M -212.01083,112.33724 C -215.98173,113.85021 -208.21543,112.17765 -210.07883,115.87566 C -212.50961,119.93855 -206.99008,113.8662 -209.61436,112.54677 C -210.16198,111.94632 -211.27989,112.47663 -212.01083,112.33724 z M -213.97451,120.82946 C -220.13871,124.32615 -228.37873,119.08124 -233.85995,124.39439 C -238.36465,128.00055 -244.57099,130.35185 -247.0433,135.75122 C -247.65922,139.60202 -243.25109,141.90251 -240.44565,143.71808 C -235.60127,146.54512 -228.8227,145.75388 -225.20082,141.42836 C -220.62679,137.96117 -216.44182,134.08489 -212.48592,129.96782 C -212.82701,126.95048 -214.43694,123.63971 -213.97451,120.82946 z " />
-        <path
-           style="fill:url(#linearGradient5542);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
-           id="path5496"
-           d="M -269.68453,32.256957 C -288.76965,32.351184 -307.87514,32.249603 -326.94796,32.349264 C -332.63884,33.663474 -333.90446,40.291305 -333.21597,45.149113 C -333.11996,59.896901 -333.07471,74.659754 -332.61729,89.39481 C -331.88583,93.310348 -324.86009,92.098674 -325.11097,96.44089 C -328.07184,96.184706 -331.5534,96.317135 -333.07248,99.246492 C -338.92562,104.98392 -341.99312,112.66465 -344.27268,120.28679 C -340.22572,125.96631 -332.26467,125.31453 -326.02946,124.71751 C -300.16629,124.7277 -274.28316,124.82043 -248.43245,124.77905 C -244.42424,124.78686 -243.30672,120.35609 -243.96666,117.2099 C -242.88598,112.93536 -237.04086,113.94554 -233.80717,114.98513 C -228.01851,116.64297 -221.26418,120.43074 -215.57982,116.37592 C -211.36091,113.71809 -213.05678,118.4029 -215.77936,119.43344 C -220.82539,122.25797 -227.09125,118.98178 -232.39677,121.20855 C -236.53238,123.88957 -240.74707,126.85249 -244.76678,129.74666 C -248.34219,132.01467 -251.90947,137.38626 -248.13747,140.97315 C -243.79274,146.02948 -236.37425,149.4527 -229.68248,147.08651 C -225.09383,144.85973 -221.79206,140.75401 -217.61535,137.88661 C -215.10454,135.69469 -212.49235,133.26839 -210.83749,130.50207 C -210.86477,126.92195 -214.68529,121.91303 -210.252,119.57013 C -207.25619,117.95208 -205.81053,112.12098 -209.75314,110.87946 C -214.16982,109.44692 -216.95156,115.09837 -221.43751,113.68608 C -228.47365,112.76758 -235.5565,107.20489 -242.69931,110.72434 C -246.89551,113.06547 -243.47174,109.4356 -241.45524,108.56544 C -237.85613,106.84628 -232.73147,104.36798 -233.94637,99.617708 C -234.27189,95.083838 -239.22223,93.197522 -242.95318,91.723135 C -247.61613,89.074942 -253.27003,89.345117 -258.06082,86.933298 C -257.89248,70.385101 -257.58805,53.76423 -258.26571,37.261116 C -259.2092,32.393288 -265.59824,31.96057 -269.68453,32.256957 z M -258.66259,91.764016 C -251.5059,92.239344 -243.21163,93.474137 -238.58238,99.271629 C -238.96251,103.06003 -244.00295,103.80224 -246.52821,106.14082 C -248.92267,108.48087 -251.12372,105.80503 -251.02958,103.27159 C -252.70852,98.336432 -258.20582,95.710815 -263.31841,96.533197 C -267.00561,96.7255 -263.71935,91.937514 -261.395,92.380192 C -260.48382,92.178338 -259.57521,91.953759 -258.66259,91.764016 z " />
-        <path
-           style="fill:url(#linearGradient5544);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
-           sodipodi:nodetypes="ccccczccccccccccccccccccczccccc"
-           id="path5498"
-           d="M -324.0398,30.70877 C -336.3492,30.820231 -335.15663,39.652507 -334.79476,45.313268 C -334.5469,60.436643 -334.38614,75.599009 -334.01234,90.698281 C -333.20516,93.057424 -330.71249,93.985661 -328.75475,95.252079 C -334.4553,96.476239 -336.96996,102.43195 -340.11175,106.59303 C -342.33294,111.36531 -347.84019,115.92868 -345.92111,121.43642 C -344.00204,126.94416 -332.21757,127.68181 -324.95408,127.12866 C -299.06901,127.09789 -273.17022,127.14905 -247.29372,127.06713 C -243.29961,126.16956 -240.99668,122.03601 -241.4977,118.23645 C -238.30082,114.95371 -233.32521,118.03039 -229.53292,118.63002 C -225.71641,119.31313 -232.5646,119.27527 -233.19362,120.54849 C -238.23604,122.95799 -242.6166,126.65447 -246.90973,130.10509 C -250.44674,132.97354 -252.4229,138.10741 -249.57412,142.08235 C -246.21315,145.92284 -241.41489,148.84284 -236.30395,149.79628 C -230.65487,150.83779 -225.57101,147.82678 -221.6157,144.24077 C -216.87391,140.59839 -212.0873,136.78287 -208.84361,131.80554 C -207.76302,128.26399 -211.47449,123.86671 -208.08348,121.09796 C -204.93438,118.46115 -204.06893,113.02076 -207.41836,110.2673 C -212.81988,106.81278 -218.36682,114.55112 -223.89705,111.29128 C -227.94209,110.1659 -231.91311,108.52596 -236.17676,108.45194 C -231.52711,105.88023 -229.62903,98.782331 -234.08944,95.153402 C -239.61551,89.404431 -248.455,88.793917 -255.40182,85.744487 C -255.86992,78.940296 -255.53665,71.972758 -255.70928,65.098797 C -255.80747,55.730822 -255.73864,46.312632 -255.94025,36.975777 C -258.03631,31.236293 -265.34014,30.439522 -270.76286,30.729689 C -289.40725,30.770714 -311.88665,30.597309 -324.0398,30.70877 z M -255.46516,94.482857 C -250.34561,95.62106 -244.69322,96.21649 -240.83258,100.05203 C -242.37635,102.55028 -245.27573,103.64481 -247.80048,104.97505 C -249.71506,99.684643 -254.39847,94.970039 -260.51378,95.138259 C -260.66903,94.131274 -256.73261,94.551178 -255.46516,94.482857 z " />
-      </g>
-      <rect
-         y="78.658051"
-         x="33.326111"
-         width="57.567924"
-         style="fill:url(#linearGradient5546);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient5548);stroke-width:1.44734821pt"
-         id="rect5500"
-         height="8.3153667" />
-      <path
-         style="fill:url(#linearGradient5550);fill-rule:evenodd;stroke-width:0.90459263;stroke-opacity:0.07438019"
-         sodipodi:nodetypes="czzczczzzzzzzc"
-         id="path5502"
-         d="M 98.723806,78.927818 C 95.18666,77.759681 93.50122,82.555591 98.766686,81.004087 C 104.03217,79.452583 120.13123,85.906451 120.37383,89.795491 C 120.61643,93.905503 101.5003,98.581154 106.74108,104.42426 C 111.62816,110.70149 115.35468,100.13868 123.54696,104.21261 C 131.73923,108.17607 136.26048,109.72394 142.25488,104.94185 C 149.10027,101.9342 145.04599,107.07658 139.57918,113.60451 C 134.11237,120.13244 144.00251,115.08156 147.91225,105.31962 C 151.93248,95.557673 139.13128,107.33503 133.66268,105.40571 C 128.19408,103.47639 119.73678,97.849788 113.27625,102.55563 C 106.81572,107.26147 109.62894,99.493003 114.85637,97.90307 C 120.0838,96.092166 122.81363,93.045722 122.85597,90.161522 C 122.89831,87.498293 117.92629,84.811803 112.94229,82.402852 C 107.73732,79.993901 100.49788,78.588966 98.723806,78.927818 z " />
-      <path
-         style="fill:url(#linearGradient5552);fill-opacity:1;fill-rule:evenodd;stroke-width:1.44734821pt"
-         sodipodi:nodetypes="czzzzzzzz"
-         id="path5504"
-         d="M 15.102732,106.80712 C 13.80355,109.23224 17.148847,113.52338 19.900059,113.52338 L 107.85106,113.52338 C 110.18914,113.52338 113.70766,110.4906 112.64839,108.40622 L 102.7339,88.897093 C 101.97024,87.394398 100.26184,86.65834 98.576216,86.65834 L 28.215425,86.658339 C 26.825434,86.658339 25.353768,87.671846 24.697385,88.897093 L 15.102732,106.80712 z " />
-      <rect
-         y="22.413721"
-         x="26.015469"
-         width="72.279724"
-         style="fill:url(#linearGradient5554);fill-opacity:1;fill-rule:evenodd;stroke-width:1.62826681"
-         ry="5.4369707"
-         rx="5.4369707"
-         id="rect5506"
-         height="60.126495" />
-      <rect
-         y="31.695871"
-         x="33.386066"
-         width="58.178177"
-         style="fill:url(#radialGradient5556);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient5558);stroke-width:1.4649456pt"
-         id="rect5508"
-         height="38.044163" />
-      <path
-         style="fill:url(#linearGradient5560);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="czzccccc"
-         id="path5510"
-         d="M 27.690431,52.841444 L 27.370609,74.749236 C 27.319624,78.241665 29.310209,80.477938 32.807578,80.506029 L 72.625393,80.825852 L 76.463254,71.87084 L 32.008024,71.55102 L 31.688202,52.681533 L 27.690431,52.841444 z " />
-      <g
-         transform="matrix(-1,0,0,1,125.4301,0)"
-         id="g5512">
-        <path
-           style="fill:url(#linearGradient5562);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-           sodipodi:nodetypes="czzccc"
-           id="path5514"
-           d="M 42.062098,33.460351 L 77.341205,33.008055 C 82.787126,32.938235 89.553204,38.416797 89.553204,43.863165 L 89.553204,60.14583 L 41.609801,59.693534 L 42.062098,33.460351 z " />
-        <path
-           style="fill:url(#linearGradient5564);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-           sodipodi:nodetypes="czzccc"
-           id="path5516"
-           d="M 78.337784,67.629235 L 46.723745,67.724544 C 41.843589,67.739257 35.829319,62.771024 35.877168,57.891081 L 36.020221,43.301821 L 78.973514,44.128288 L 78.337784,67.629235 z " />
-      </g>
-      <path
-         style="fill:url(#linearGradient5566);fill-opacity:1;fill-rule:evenodd;stroke-width:0.72367412;stroke-opacity:0.34710741"
-         sodipodi:nodetypes="cczzzzzzc"
-         id="path5518"
-         d="M 137.39107,112.02341 C 137.39107,112.02341 129.0757,110.26438 123.63872,113.62251 C 118.20176,116.98064 109.96635,123.21719 108.76702,124.81628 C 107.40777,126.57531 107.42036,130.22796 109.24674,131.53253 L 114.84364,135.53031 C 118.31797,138.01198 124.86218,139.25396 128.11624,136.48978 L 142.98795,123.85681 C 144.79792,122.3193 145.72732,118.27921 144.10733,116.82073 C 142.95609,115.04975 140.4892,112.91939 137.39107,112.02341 z " />
-      <path
-         style="fill:url(#linearGradient5568);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="czzzzzc"
-         id="path5520"
-         d="M 142.3483,121.13833 L 125.91043,133.59673 C 122.97154,135.82414 118.65484,134.11775 116.28283,133.77129 C 113.9108,133.42481 111.88528,131.87901 112.12516,132.33209 C 112.36503,132.78517 115.08349,135.71687 117.72203,136.48978 C 120.36055,137.26267 124.9543,138.89307 127.50953,136.15531 C 130.06477,133.41755 145.2267,123.53699 142.3483,121.13833 z " />
-      <path
-         style="fill:url(#linearGradient5570);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="cczc"
-         id="path5522"
-         d="M 132.11225,127.51984 C 135.31047,122.88242 120.11893,113.12786 109.08509,127.0401 C 110.20446,130.71805 116.80662,132.5992 121.82304,132.33547 C 126.68363,132.07993 129.50037,129.97181 132.11225,127.51984 z " />
-      <path
-         style="fill:url(#linearGradient5572);fill-opacity:1;fill-rule:evenodd;stroke-width:1.08551121"
-         sodipodi:nodetypes="cccccccc"
-         id="path5524"
-         d="M 138.63464,112.68306 C 135.9958,113.22749 132.31739,114.43079 129.87534,116.38362 C 128.77009,115.68011 125.32759,114.5677 123.66767,113.84494 L 123.24572,114.10517 C 129.67287,117.23476 136.43512,117.91249 135.88192,122.87668 C 136.33675,122.98575 137.05589,123.09702 136.73191,122.38863 C 136.41775,118.90392 132.50587,117.23351 131.02697,116.81532 C 133.17224,114.26602 136.255,113.70892 138.63464,112.68306 z " />
-      <path
-         style="fill:url(#linearGradient5574);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="czzzzzzzz"
-         id="path5526"
-         d="M 18.891612,106.48414 C 17.978451,108.31614 19.173914,111.55774 22.263529,111.55774 L 105.0195,111.55774 C 106.66288,111.55774 109.13595,109.26672 108.39142,107.69215 L 101.42279,92.954575 C 100.88602,91.819403 99.685232,91.263378 98.500462,91.263378 L 28.108183,91.263369 C 27.131195,91.263369 26.0968,92.028994 25.635445,92.954575 L 18.891612,106.48414 z " />
-      <text
-         y="-14.660837"
-         xml:space="preserve"
-         x="6.147172"
-         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
-         id="text5528"><tspan
-           id="tspan5530">Computer</tspan></text>
-      <text
-         y="-34.951134"
-         xml:space="preserve"
-         x="84.564949"
-         transform="scale(0.246729,0.246729)"
-         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
-         id="text5532"><tspan
-           id="tspan5534">Created by Andrew Fitzsimon</tspan></text>
-    </g>
-    <g
-       id="g6024"
-       transform="matrix(-1,0,0,1,900.16045,422.61731)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
-       inkscape:export-xdpi="42.227192"
-       inkscape:export-ydpi="42.227192">
-      <path
-         transform="translate(2.509562,-4.432856e-2)"
-         style="fill:#ffffff;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="cccc"
-         id="path6027"
-         d="M 60.545133,72.847539 C 65.294534,78.031101 68.316881,87.318315 75.00922,87.318316 C 81.485677,85.518467 82.349205,70.11177 83.212732,66.800051 C 75.872748,71.839624 68.316882,74.71938 60.545133,72.847539 z " />
-      <path
-         transform="translate(2.509562,-4.432856e-2)"
-         style="fill:#d20000;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="ccssssc"
-         id="path6029"
-         d="M 31.546762,99.654209 C 31.156121,124.85047 95.78552,127.73183 95.62922,99.654209 C 97.174007,77.325462 86.068776,64.629762 83.309105,66.788232 C 81.907864,67.884209 81.387229,92.223995 71.919297,86.625353 C 67.316417,83.903554 62.167959,73.44849 59.915352,73.101625 C 56.516277,72.578221 50.007529,69.826123 44.029815,64.675414 C 42.461522,63.324094 32.076211,77.214403 31.546762,99.654209 z " />
-      <path
-         style="fill:url(#radialGradient2797);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         id="path2796"
-         d="M 43.53125,77.3125 C 40.353026,86.016409 37.202011,96.366079 40.377303,105.23542 C 48.984655,117.18204 66.049398,117.25223 79.222417,115.04972 C 88.094278,113.47345 96.636121,105.87972 94.744454,96.188658 C 94.751182,88.561019 93.319573,80.643142 89.09375,74.1875 C 87.954705,81.120157 85.706152,92.347929 76.686643,91.786583 C 66.841974,89.84774 65.058803,76.33878 54.747596,75.105769 C 49.945701,71.530053 45.566465,69.110698 43.783935,76.852875 L 43.53125,77.3125 z " />
-      <path
-         transform="matrix(0.440859,0,0,0.441062,0.997459,16.38124)"
-         style="fill:#efd7c7;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:type="arc"
-         sodipodi:ry="57.825485"
-         sodipodi:rx="60.94183"
-         sodipodi:cy="70.290855"
-         sodipodi:cx="150.27701"
-         id="path6032"
-         d="M 211.21884 70.290855 A 60.94183 57.825485 0 1 1  89.335178,70.290855 A 60.94183 57.825485 0 1 1  211.21884 70.290855 z" />
-      <path
-         transform="translate(2.509562,-4.432856e-2)"
-         style="fill:#000000;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="cccccc"
-         id="path3720"
-         d="M 56.980881,5.8426527 C 39.420698,8.0166254 30.552872,16.206245 24.211446,49.532095 C 14.512196,98.076517 21.871677,115.5525 32.990311,115.56714 C 17.54932,102.40769 63.877625,86.740105 56.295103,44.070713 C 68.4508,48.712358 94.51097,54.349644 95.164349,41.718703 C 97.176702,29.219492 88.64173,4.4775042 56.980881,5.8426527 z " />
-      <path
-         style="fill:url(#linearGradient2789);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         id="path2164"
-         d="M 60.687242,45.028999 C 62.530882,55.403773 61.180052,64.151015 58.312242,71.685249 C 61.630122,73.07804 65.296862,73.904 69.155992,73.903999 C 83.975322,73.903999 95.981712,62.468019 95.999742,48.403999 C 88.357632,52.885439 70.244092,48.678277 60.687242,45.028999 z " />
-      <path
-         style="fill:url(#radialGradient2791);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         id="path2790"
-         d="M 52.174948,8.1325312 C 35.846775,12.141346 31.110158,30.475875 28.060647,44.840387 C 24.465246,64.767005 19.485139,85.90438 25.518698,105.82003 C 29.863591,114.87216 28.026452,106.52571 31.049538,102.11795 C 41.311249,87.323083 56.256862,73.307418 55.936774,53.886064 C 56.647391,49.398848 52.34734,38.640985 60.701717,42.254379 C 70.683443,45.202557 82.078811,49.011247 92.143698,44.632531 C 96.945103,37.45042 93.288237,27.137344 88.876323,20.399742 C 81.135092,8.5919962 65.300885,5.0194752 52.174948,8.1325312 z " />
-    </g>
-    <path
-       style="fill:none;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:4.63842154;stroke-linecap:butt;stroke-linejoin:round;stroke-dasharray:none;stroke-opacity:1"
-       sodipodi:nodetypes="cccccccccccc"
-       id="path699"
-       d="M 319.16674,325.66524 L 432.27399,313.12251 L 422.57906,332.08242 L 484.9028,325.95688 C 484.9028,325.95688 494.59773,306.41369 495.05931,306.41369 C 495.52148,306.41369 517.68079,331.79078 517.68079,331.79078 C 517.68079,331.79078 465.51355,358.33479 465.05197,358.33479 C 465.51355,358.91808 474.74689,339.66616 474.74689,339.37453 L 402.72705,345.79207 L 412.42255,326.24852 L 309.01023,338.4996 L 319.16674,325.66524 z "
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
-       inkscape:export-xdpi="42.227192"
-       inkscape:export-ydpi="42.227192" />
-    <text
-       xml:space="preserve"
-       style="font-size:48px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont;font-stretch:normal;font-variant:normal;text-anchor:start;text-align:start;writing-mode:lr;line-height:125%"
-       x="140"
-       y="521.23737"
-       id="text7612"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
-       inkscape:export-xdpi="42.227192"
-       inkscape:export-ydpi="42.227192"><tspan
-         sodipodi:role="line"
-         id="tspan7614"
-         x="140"
-         y="521.23737">Server</tspan></text>
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="359.5625"
-       y="261.21948"
-       id="text7877"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
-       inkscape:export-xdpi="42.227192"
-       inkscape:export-ydpi="42.227192"><tspan
-         sodipodi:role="line"
-         id="tspan7879"
-         x="359.5625"
-         y="261.21948">bzr branch</tspan></text>
-    <path
-       sodipodi:type="arc"
-       style="fill:#000000"
-       id="path9548"
-       sodipodi:cx="292.14285"
-       sodipodi:cy="181.95163"
-       sodipodi:rx="15"
-       sodipodi:ry="15"
-       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
-       transform="translate(42.857147,67.142853)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
-       inkscape:export-xdpi="42.227192"
-       inkscape:export-ydpi="42.227192" />
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="325.71429"
-       y="259.52307"
-       id="text9550"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
-       inkscape:export-xdpi="42.227192"
-       inkscape:export-ydpi="42.227192"><tspan
-         sodipodi:role="line"
-         id="tspan9552"
-         x="325.71429"
-         y="259.52307">1</tspan></text>
-    <path
-       sodipodi:type="arc"
-       style="fill:#000000"
-       id="path9554"
-       sodipodi:cx="292.14285"
-       sodipodi:cy="181.95163"
-       sodipodi:rx="15"
-       sodipodi:ry="15"
-       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
-       transform="translate(492.85715,-2.8571472)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
-       inkscape:export-xdpi="42.227192"
-       inkscape:export-ydpi="42.227192" />
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="777.71429"
-       y="191.52307"
-       id="text9556"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
-       inkscape:export-xdpi="42.227192"
-       inkscape:export-ydpi="42.227192"><tspan
-         sodipodi:role="line"
-         id="tspan9558"
-         x="777.71429"
-         y="191.52307">2</tspan></text>
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="819.5625"
-       y="179.59448"
-       id="text9566"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
-       inkscape:export-xdpi="42.227192"
-       inkscape:export-ydpi="42.227192"><tspan
-         sodipodi:role="line"
-         id="tspan9568"
-         x="819.5625"
-         y="179.59448">bzr pull</tspan><tspan
-         sodipodi:role="line"
-         x="819.5625"
-         y="219.59448"
-         id="tspan2963">bzr merge</tspan></text>
-    <path
-       style="fill:none;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:4.29065037;stroke-linecap:butt;stroke-linejoin:round;stroke-dasharray:none;stroke-opacity:1"
-       sodipodi:nodetypes="cccccccccccc"
-       id="path9650"
-       d="M 539.95542,466.93556 L 415.85387,476.71718 L 426.49116,461.93102 L 358.1094,466.70812 C 358.1094,466.70812 347.47211,481.94916 346.96566,481.94916 C 346.45858,481.94916 322.14533,462.15846 322.14533,462.15846 C 322.14533,462.15846 379.38334,441.45772 379.88978,441.45772 C 379.38334,441.00284 369.25249,456.01673 369.25249,456.24417 L 448.27282,451.23935 L 437.63489,466.48068 L 551.09912,456.92649 L 539.95542,466.93556 z "
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
-       inkscape:export-xdpi="42.227192"
-       inkscape:export-ydpi="42.227192" />
-    <path
-       sodipodi:type="arc"
-       style="fill:#000000"
-       id="path9652"
-       sodipodi:cx="292.14285"
-       sodipodi:cy="181.95163"
-       sodipodi:rx="15"
-       sodipodi:ry="15"
-       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
-       transform="translate(51.511043,348.5966)"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
-       inkscape:export-xdpi="42.227192"
-       inkscape:export-ydpi="42.227192" />
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="334.36819"
-       y="540.97681"
-       id="text9654"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
-       inkscape:export-xdpi="42.227192"
-       inkscape:export-ydpi="42.227192"><tspan
-         sodipodi:role="line"
-         id="tspan9656"
-         x="334.36819"
-         y="540.97681">3</tspan></text>
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="369.5625"
-       y="544.09448"
-       id="text9658"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
-       inkscape:export-xdpi="42.227192"
-       inkscape:export-ydpi="42.227192"><tspan
-         sodipodi:role="line"
-         id="tspan9660"
-         x="369.5625"
-         y="544.09448">bzr commit</tspan></text>
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="61.5625"
-       y="240.09448"
-       id="text2965"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
-       inkscape:export-xdpi="42.227192"
-       inkscape:export-ydpi="42.227192"><tspan
-         sodipodi:role="line"
-         id="tspan2967"
-         x="61.5625"
-         y="240.09448">main branch</tspan></text>
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="563.43756"
-       y="582.09442"
-       id="text2969"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
-       inkscape:export-xdpi="42.227192"
-       inkscape:export-ydpi="42.227192"><tspan
-         sodipodi:role="line"
-         id="tspan2971"
-         x="563.43756"
-         y="582.09442">local branches</tspan></text>
-    <path
-       sodipodi:type="arc"
-       style="fill:none;fill-opacity:1;stroke:#0000ff;stroke-width:5.00006169;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
-       id="path4930"
-       sodipodi:cx="342"
-       sodipodi:cy="171.0945"
-       sodipodi:rx="66"
-       sodipodi:ry="35"
-       d="M 408 171.0945 A 66 35 0 1 1  276,171.0945 A 66 35 0 1 1  408 171.0945 z"
-       transform="matrix(1.9161749,0,0,1.0419298,-501.33182,49.826027)" />
-    <path
-       sodipodi:type="arc"
-       style="fill:none;fill-opacity:1;stroke:#0000ff;stroke-width:5.00006151;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
-       id="path7839"
-       sodipodi:cx="342"
-       sodipodi:cy="171.0945"
-       sodipodi:rx="66"
-       sodipodi:ry="35"
-       d="M 408 171.0945 A 66 35 0 1 1  276,171.0945 A 66 35 0 1 1  408 171.0945 z"
-       transform="matrix(2.1405493,0,0,1.0364644,-57.067817,396.76108)" />
-  </g>
-</svg>

=== removed file 'doc/en/user-guide/images/workflows_single.png'
Binary files doc/en/user-guide/images/workflows_single.png and doc/en/user-guide/images/workflows_single.png differ
=== removed file 'doc/en/user-guide/images/workflows_single.svg'
--- doc/en/user-guide/images/workflows_single.svg	2007-11-30 04:34:08 +0000
+++ doc/en/user-guide/images/workflows_single.svg	1970-01-01 00:00:00 +0000
@@ -1,1079 +0,0 @@
-<?xml version="1.0" encoding="UTF-8" standalone="no"?>
-<!-- Created with Inkscape (http://www.inkscape.org/) -->
-<svg
-   xmlns:dc="http://purl.org/dc/elements/1.1/"
-   xmlns:cc="http://web.resource.org/cc/"
-   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
-   xmlns:svg="http://www.w3.org/2000/svg"
-   xmlns="http://www.w3.org/2000/svg"
-   xmlns:xlink="http://www.w3.org/1999/xlink"
-   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"
-   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"
-   width="1052.3622"
-   height="744.09448"
-   id="svg2"
-   sodipodi:version="0.32"
-   inkscape:version="0.45.1"
-   version="1.0"
-   sodipodi:docbase="/home/ian/Desktop/talk/workflows"
-   sodipodi:docname="workflows_single.svg"
-   inkscape:output_extension="org.inkscape.output.svg.inkscape"
-   inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_single.png"
-   inkscape:export-xdpi="90"
-   inkscape:export-ydpi="90">
-  <defs
-     id="defs4">
-    <radialGradient
-       xlink:href="#linearGradient5992"
-       r="33.156250"
-       inkscape:collect="always"
-       id="radialGradient6000"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(1.000000,0.000000,0.000000,1.693685,0.000000,-197.9515)"
-       fy="285.36218"
-       fx="495.50000"
-       cy="285.36218"
-       cx="495.50000" />
-    <linearGradient
-       y2="187.57059"
-       y1="225.40080"
-       xlink:href="#linearGradient5963"
-       x2="458.91232"
-       x1="383.95898"
-       inkscape:collect="always"
-       id="linearGradient5969"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       id="linearGradient3586">
-      <stop
-         style="stop-color:#000000;stop-opacity:1.0000000;"
-         offset="0.0000000"
-         id="stop3588" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0;"
-         offset="1"
-         id="stop3590" />
-    </linearGradient>
-    <linearGradient
-       inkscape:collect="always"
-       id="linearGradient5963">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:1;"
-         offset="0"
-         id="stop5965" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0;"
-         offset="1"
-         id="stop5967" />
-    </linearGradient>
-    <linearGradient
-       inkscape:collect="always"
-       id="linearGradient5992">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:1;"
-         offset="0"
-         id="stop5994" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0;"
-         offset="1"
-         id="stop5996" />
-    </linearGradient>
-    <linearGradient
-       y2="-0.45783132"
-       y1="3.3012049"
-       xlink:href="#linearGradient893"
-       x2="0.92957747"
-       x1="-2.3960868e-17"
-       id="linearGradient4284" />
-    <linearGradient
-       y2="-0.033519555"
-       y1="2.0837989"
-       xlink:href="#linearGradient893"
-       x2="0.99074072"
-       x1="-0.77314812"
-       id="linearGradient4283" />
-    <linearGradient
-       y2="1.8771822"
-       y1="-0.033741195"
-       xlink:href="#linearGradient902"
-       x2="0.48453596"
-       x1="0.47041038"
-       id="linearGradient2740"
-       gradientTransform="scale(0.997153,1.002855)" />
-    <linearGradient
-       y2="1.9025002"
-       y1="-0.043652620"
-       xlink:href="#linearGradient902"
-       x2="0.48481107"
-       x1="0.47042510"
-       id="linearGradient1506"
-       gradientTransform="scale(0.995847,1.004170)" />
-    <linearGradient
-       y2="1.8570156"
-       y1="-0.024853170"
-       xlink:href="#linearGradient902"
-       x2="0.48548824"
-       x1="0.47157744"
-       id="linearGradient1505"
-       gradientTransform="scale(0.997825,1.002180)" />
-    <linearGradient
-       y2="182.99154"
-       y1="169.09755"
-       xlink:href="#linearGradient892"
-       x2="88.996957"
-       x1="88.755695"
-       id="linearGradient1404"
-       gradientTransform="scale(1.3695887,0.7301462)"
-       gradientUnits="userSpaceOnUse" />
-    <radialGradient
-       xlink:href="#linearGradient1317"
-       r="0.34964636"
-       id="radialGradient1316"
-       fy="0.18269235"
-       fx="0.50352114"
-       cy="0.50000006"
-       cx="0.50000000" />
-    <radialGradient
-       xlink:href="#linearGradient1317"
-       r="0.41197181"
-       id="radialGradient1315"
-       fy="0.26666668"
-       fx="0.47535211"
-       cy="0.53333336"
-       cx="0.47887325" />
-    <linearGradient
-       y2="173.03153"
-       y1="177.77768"
-       xlink:href="#linearGradient902"
-       x2="95.100155"
-       x1="101.10657"
-       id="linearGradient1171"
-       gradientTransform="scale(1.3601783,0.7351977)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="1.8378206"
-       y1="-0.016295359"
-       xlink:href="#linearGradient902"
-       x2="0.48655096"
-       x1="0.47284532"
-       id="linearGradient1170"
-       gradientTransform="scale(0.998371,1.001632)" />
-    <linearGradient
-       y2="81.477602"
-       y1="224.57898"
-       xlink:href="#linearGradient893"
-       x2="74.533693"
-       x1="146.69923"
-       id="linearGradient1169"
-       gradientTransform="scale(1.1870691,0.842411)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="133.54711"
-       y1="228.39311"
-       xlink:href="#linearGradient888"
-       x2="88.447016"
-       x1="141.60217"
-       id="linearGradient1167"
-       gradientTransform="scale(1.1838753,0.8446836)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="148.78619"
-       y1="131.25248"
-       xlink:href="#linearGradient1317"
-       x2="107.04918"
-       x1="111.49758"
-       id="linearGradient1166"
-       gradientTransform="scale(1.223869,0.8170809)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="176.28694"
-       y1="269.85831"
-       xlink:href="#linearGradient888"
-       x2="-16.224496"
-       x1="51.460928"
-       id="linearGradient1157"
-       gradientTransform="scale(2.4217071,0.4129318)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="234.26866"
-       y1="178.48862"
-       xlink:href="#linearGradient888"
-       x2="25.220815"
-       x1="25.220815"
-       id="linearGradient1156"
-       gradientTransform="scale(2.4217071,0.4129318)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="105.42543"
-       y1="76.277559"
-       xlink:href="#linearGradient892"
-       x2="8.346058"
-       x1="35.190362"
-       id="linearGradient1150"
-       gradientTransform="scale(1.3283861,0.7527932)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="20.481863"
-       y1="49.507656"
-       xlink:href="#linearGradient892"
-       x2="70.224305"
-       x1="39.690614"
-       id="linearGradient1148"
-       gradientTransform="scale(1.329144,0.7523639)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="113.71949"
-       y1="90.197025"
-       xlink:href="#linearGradient892"
-       x2="17.876529"
-       x1="39.810948"
-       id="linearGradient1146"
-       gradientTransform="scale(1.3207392,0.7571517)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="251.21892"
-       y1="203.499"
-       xlink:href="#linearGradient892"
-       x2="31.617281"
-       x1="31.449743"
-       id="linearGradient1144"
-       gradientTransform="scale(2.1051174,0.4750329)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="-0.45783132"
-       y1="3.3012049"
-       xlink:href="#linearGradient888"
-       x2="0.92957747"
-       x1="0.00000000"
-       id="linearGradient1141" />
-    <linearGradient
-       y2="232.24952"
-       y1="110.4447"
-       xlink:href="#linearGradient888"
-       x2="41.967061"
-       x1="45.685757"
-       id="linearGradient1140"
-       gradientTransform="scale(1.9102155,0.5235012)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="75.912531"
-       y1="375.92199"
-       xlink:href="#linearGradient1806"
-       x2="-268.25407"
-       x1="-249.72067"
-       id="linearGradient1138"
-       gradientTransform="scale(1.087146,0.9198397)"
-       gradientUnits="userSpaceOnUse" />
-    <radialGradient
-       xlink:href="#linearGradient1133"
-       r="68.589222"
-       id="radialGradient1132"
-       fy="39.288476"
-       fx="72.107883"
-       cy="56.485935"
-       cx="60.004654"
-       gradientTransform="scale(1.2267534,0.8151598)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="11.699047"
-       y1="208.43991"
-       xlink:href="#linearGradient888"
-       x2="95.644441"
-       x1="-77.726178"
-       id="linearGradient905"
-       gradientTransform="scale(1.0964158,0.9120627)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       xlink:href="#linearGradient1806"
-       id="linearGradient901" />
-    <linearGradient
-       y2="91.07699"
-       y1="-3.9104078"
-       xlink:href="#linearGradient888"
-       x2="27.674331"
-       x1="92.437968"
-       id="linearGradient891"
-       gradientTransform="scale(1.2267534,0.8151598)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       id="linearGradient888">
-      <stop
-         style="stop-color:#626262;stop-opacity:1.0000000;"
-         offset="0.0000000"
-         id="stop889" />
-      <stop
-         style="stop-color:#fff;stop-opacity:1;"
-         offset="1"
-         id="stop890" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient892">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.00000000;"
-         offset="0.00000000"
-         id="stop893" />
-      <stop
-         style="stop-color:#fff;stop-opacity:1;"
-         offset="1"
-         id="stop894" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient902">
-      <stop
-         style="stop-color:#000000;stop-opacity:0.00000000;"
-         offset="0.00000000"
-         id="stop903" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0.22000000;"
-         offset="1.0000000"
-         id="stop904" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient1098">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:1.0000000;"
-         offset="0.00000000"
-         id="stop1099" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.22314049;"
-         offset="0.50000000"
-         id="stop1101" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.00000000;"
-         offset="0.59930235"
-         id="stop1102" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.60330576;"
-         offset="1.0000000"
-         id="stop1100" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient1133">
-      <stop
-         style="stop-color:#8bb7df;stop-opacity:1.0000000;"
-         offset="0.00000000"
-         id="stop1134" />
-      <stop
-         style="stop-color:#2a6092;stop-opacity:1.0000000;"
-         offset="0.76209301"
-         id="stop1136" />
-      <stop
-         style="stop-color:#375e82;stop-opacity:1.0000000;"
-         offset="1.0000000"
-         id="stop1135" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient1317">
-      <stop
-         style="stop-color:#000000;stop-opacity:0.52892560;"
-         offset="0.00000000"
-         id="stop1318" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0.17355372;"
-         offset="0.50000000"
-         id="stop1320" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0.00000000;"
-         offset="1.0000000"
-         id="stop1319" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient893">
-      <stop
-         style="stop-color:#000;stop-opacity:1;"
-         offset="0"
-         id="stop895" />
-      <stop
-         style="stop-color:#fff;stop-opacity:1;"
-         offset="1"
-         id="stop896" />
-    </linearGradient>
-    <radialGradient
-       xlink:href="#linearGradient1806"
-       r="11.574221"
-       id="radialGradient1977"
-       fy="39.410465"
-       fx="42.280806"
-       cy="39.007645"
-       cx="42.007257"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       id="linearGradient1806">
-      <stop
-         style="stop-color:#000000;stop-opacity:0.35051546;"
-         offset="0.0000000"
-         id="stop1807" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0.13402061;"
-         offset="0.64999998"
-         id="stop3276" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop1808" />
-    </linearGradient>
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient5281"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient5283"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient5285"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <radialGradient
-       xlink:href="#linearGradient4362"
-       r="5.5130484"
-       inkscape:collect="always"
-       id="radialGradient1828"
-       fy="61.38567"
-       fx="86.542037"
-       cy="61.38567"
-       cx="86.542037"
-       gradientTransform="matrix(-0.8164966,0,0,1.2247449,262.80373,-280)"
-       gradientUnits="userSpaceOnUse" />
-    <radialGradient
-       xlink:href="#linearGradient4362"
-       r="11.123441"
-       inkscape:collect="always"
-       id="radialGradient1824"
-       fy="58.887858"
-       fx="118.06427"
-       cy="58.54025"
-       cx="117.17439"
-       gradientTransform="matrix(-0.6229142,0,0,1.6053575,262.80373,-280)"
-       gradientUnits="userSpaceOnUse" />
-    <radialGradient
-       xlink:href="#linearGradient4362"
-       r="22.00904"
-       inkscape:collect="always"
-       id="radialGradient1822"
-       fy="87.892895"
-       fx="45.50637"
-       cy="88.322677"
-       cx="45.139623"
-       gradientTransform="matrix(-1.0914815,0,0,0.9161859,262.80373,-280)"
-       gradientUnits="userSpaceOnUse" />
-    <radialGradient
-       xlink:href="#linearGradient4362"
-       r="18.836343"
-       inkscape:collect="always"
-       id="radialGradient1818"
-       fy="33.351633"
-       fx="48.40165"
-       cy="32.467054"
-       cx="48.40165"
-       gradientTransform="matrix(-1.1146027,0,0,0.8971807,262.80373,-280)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       y2="74.834393"
-       y1="57.093738"
-       xlink:href="#linearGradient4376"
-       x2="50.203204"
-       x1="50.52668"
-       inkscape:collect="always"
-       id="linearGradient1815"
-       gradientTransform="matrix(-1.3516689,0,0,0.7398261,262.80373,-280)"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       id="linearGradient4384">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.77513230;"
-         offset="0.0000000"
-         id="stop4385" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop4386" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient4376">
-      <stop
-         style="stop-color:#000000;stop-opacity:0.52645504;"
-         offset="0.0000000"
-         id="stop4377" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop4378" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient4362">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.66666669;"
-         offset="0.0000000"
-         id="stop4363" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop4364" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient4358">
-      <stop
-         style="stop-color:#000;stop-opacity:1;"
-         offset="0"
-         id="stop4359" />
-      <stop
-         style="stop-color:#fff;stop-opacity:1;"
-         offset="1"
-         id="stop4360" />
-    </linearGradient>
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient5538"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient5714"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <linearGradient
-       id="linearGradient6015">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.77513230;"
-         offset="0.0000000"
-         id="stop6017" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop6019" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient6009">
-      <stop
-         style="stop-color:#000000;stop-opacity:0.52645504;"
-         offset="0.0000000"
-         id="stop6011" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop6013" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient6003">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.66666669;"
-         offset="0.0000000"
-         id="stop6005" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0.0000000;"
-         offset="1.0000000"
-         id="stop6007" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient5997">
-      <stop
-         style="stop-color:#000;stop-opacity:1;"
-         offset="0"
-         id="stop5999" />
-      <stop
-         style="stop-color:#fff;stop-opacity:1;"
-         offset="1"
-         id="stop6001" />
-    </linearGradient>
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1806"
-       id="linearGradient6037"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="scale(1.087146,0.9198397)"
-       x1="-249.72067"
-       y1="375.92199"
-       x2="-268.25407"
-       y2="75.912531" />
-    <linearGradient
-       y2="0.46093750"
-       y1="0.46093750"
-       xlink:href="#linearGradient650"
-       x2="1.16666818"
-       x1="1.22222710"
-       spreadMethod="repeat"
-       id="linearGradient654"
-       gradientUnits="objectBoundingBox" />
-    <linearGradient
-       y2="0.53906250"
-       y1="0.53125000"
-       xlink:href="#linearGradient650"
-       x2="1.16666901"
-       x1="1.00000548"
-       spreadMethod="repeat"
-       id="linearGradient653"
-       gradientUnits="objectBoundingBox" />
-    <linearGradient
-       id="linearGradient650">
-      <stop
-         style="stop-color:#000;stop-opacity:1;"
-         offset="0"
-         id="stop651" />
-      <stop
-         style="stop-color:#fff;stop-opacity:1;"
-         offset="1"
-         id="stop652" />
-    </linearGradient>
-    <linearGradient
-       y2="0.46093750"
-       y1="0.46093750"
-       xlink:href="#linearGradient650"
-       x2="1.16666818"
-       x1="1.22222710"
-       spreadMethod="repeat"
-       id="linearGradient9648"
-       gradientUnits="objectBoundingBox" />
-    <linearGradient
-       y2="0.53906250"
-       y1="0.53125000"
-       xlink:href="#linearGradient650"
-       x2="1.16666901"
-       x1="1.00000548"
-       spreadMethod="repeat"
-       id="linearGradient9646"
-       gradientUnits="objectBoundingBox" />
-    <linearGradient
-       id="linearGradient9640">
-      <stop
-         style="stop-color:#000;stop-opacity:1;"
-         offset="0"
-         id="stop9642" />
-      <stop
-         style="stop-color:#fff;stop-opacity:1;"
-         offset="1"
-         id="stop9644" />
-    </linearGradient>
-  </defs>
-  <sodipodi:namedview
-     id="base"
-     pagecolor="#ffffff"
-     bordercolor="#666666"
-     borderopacity="1.0"
-     gridtolerance="10000"
-     guidetolerance="10"
-     objecttolerance="10"
-     inkscape:pageopacity="0.0"
-     inkscape:pageshadow="2"
-     inkscape:zoom="1.4142136"
-     inkscape:cx="536.99132"
-     inkscape:cy="529.01021"
-     inkscape:document-units="px"
-     inkscape:current-layer="layer1"
-     width="1052.3622px"
-     height="744.09448px"
-     showgrid="true"
-     inkscape:window-width="1465"
-     inkscape:window-height="896"
-     inkscape:window-x="0"
-     inkscape:window-y="25" />
-  <metadata
-     id="metadata7">
-    <rdf:RDF>
-      <cc:Work
-         rdf:about="">
-        <dc:format>image/svg+xml</dc:format>
-        <dc:type
-           rdf:resource="http://purl.org/dc/dcmitype/StillImage" />
-      </cc:Work>
-    </rdf:RDF>
-  </metadata>
-  <g
-     inkscape:label="Layer 1"
-     inkscape:groupmode="layer"
-     id="layer1">
-    <g
-       id="g5256"
-       transform="translate(631.5744,227.66157)"
-       inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_single.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157">
-      <path
-         transform="matrix(6.392368,0.545409,-0.130014,2.864752,-184.6606,-38.15109)"
-         style="fill:url(#radialGradient1977);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:type="arc"
-         sodipodi:ry="12.562782"
-         sodipodi:rx="12.562782"
-         sodipodi:cy="37.865574"
-         sodipodi:cx="41.875938"
-         id="path1976"
-         d="M 54.438721 37.865574 A 12.562782 12.562782 0 1 1  29.313156,37.865574 A 12.562782 12.562782 0 1 1  54.438721 37.865574 z" />
-      <g
-         transform="matrix(1,0,0,1.036969,356.8306,-11.4294)"
-         style="fill:url(#linearGradient6037);fill-opacity:1"
-         id="g4293">
-        <path
-           style="fill:url(#linearGradient5281);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
-           id="path2720"
-           d="M -270.85787,33.814995 C -289.35564,33.925992 -307.93321,33.592782 -326.38104,33.981747 C -331.43469,35.696391 -331.02221,41.899652 -330.68524,46.15332 C -330.75782,60.227303 -330.53537,74.298225 -330.21167,88.36826 C -328.21297,91.039611 -323.21766,90.618387 -322.68469,94.539015 C -320.78054,96.259426 -317.05071,94.88215 -314.4389,95.333237 C -298.54999,95.360274 -282.66107,95.387302 -266.77215,95.414339 C -266.35587,90.465192 -260.12609,88.824447 -255.81783,89.540255 C -256.01688,89.058389 -261.69557,87.939375 -259.61591,84.491525 C -259.45681,68.72727 -259.19734,52.882199 -259.82064,37.168229 C -261.19394,32.980583 -267.34179,33.83368 -270.85787,33.814995 z M -236.65184,97.260473 C -234.79025,100.12642 -237.08724,103.09386 -239.92892,104.16357 C -242.6311,105.91539 -245.59105,107.62992 -248.52894,108.76804 C -253.1773,108.19079 -251.42424,101.88475 -255.01281,99.896645 C -260.33594,96.447012 -267.21045,98.43943 -273.23329,97.939231 C -291.8249,97.94887 -310.41651,97.958519 -329.00813,97.968158 C -335.45898,103.56578 -339.16595,111.40269 -341.55034,119.32178 C -337.25147,124.2061 -329.89606,122.27575 -324.10438,122.40002 C -298.64553,122.23171 -273.11679,122.61546 -247.69897,122.24542 C -243.40174,121.14669 -247.44685,114.84894 -243.58488,113.04441 C -242.73865,112.73374 -247.81245,114.4382 -247.26205,111.62955 C -245.49117,106.66028 -239.14113,105.99595 -235.92338,102.36811 C -234.39131,99.755669 -236.26958,96.922488 -238.33047,95.260495 C -237.77093,95.927151 -237.21138,96.593817 -236.65184,97.260473 z M -240.64255,111.75263 C -243.64086,113.13223 -237.02792,110.69536 -235.55512,111.97369 C -229.71113,112.74417 -224.16461,117.19625 -218.12358,115.22951 C -225.97639,116.31604 -232.799,109.03014 -240.64255,111.75263 z M -212.01083,112.33724 C -215.98173,113.85021 -208.21543,112.17765 -210.07883,115.87566 C -212.50961,119.93855 -206.99008,113.8662 -209.61436,112.54677 C -210.16198,111.94632 -211.27989,112.47663 -212.01083,112.33724 z M -213.97451,120.82946 C -220.13871,124.32615 -228.37873,119.08124 -233.85995,124.39439 C -238.36465,128.00055 -244.57099,130.35185 -247.0433,135.75122 C -247.65922,139.60202 -243.25109,141.90251 -240.44565,143.71808 C -235.60127,146.54512 -228.8227,145.75388 -225.20082,141.42836 C -220.62679,137.96117 -216.44182,134.08489 -212.48592,129.96782 C -212.82701,126.95048 -214.43694,123.63971 -213.97451,120.82946 z " />
-        <path
-           style="fill:url(#linearGradient5283);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
-           id="path2723"
-           d="M -269.68453,32.256957 C -288.76965,32.351184 -307.87514,32.249603 -326.94796,32.349264 C -332.63884,33.663474 -333.90446,40.291305 -333.21597,45.149113 C -333.11996,59.896901 -333.07471,74.659754 -332.61729,89.39481 C -331.88583,93.310348 -324.86009,92.098674 -325.11097,96.44089 C -328.07184,96.184706 -331.5534,96.317135 -333.07248,99.246492 C -338.92562,104.98392 -341.99312,112.66465 -344.27268,120.28679 C -340.22572,125.96631 -332.26467,125.31453 -326.02946,124.71751 C -300.16629,124.7277 -274.28316,124.82043 -248.43245,124.77905 C -244.42424,124.78686 -243.30672,120.35609 -243.96666,117.2099 C -242.88598,112.93536 -237.04086,113.94554 -233.80717,114.98513 C -228.01851,116.64297 -221.26418,120.43074 -215.57982,116.37592 C -211.36091,113.71809 -213.05678,118.4029 -215.77936,119.43344 C -220.82539,122.25797 -227.09125,118.98178 -232.39677,121.20855 C -236.53238,123.88957 -240.74707,126.85249 -244.76678,129.74666 C -248.34219,132.01467 -251.90947,137.38626 -248.13747,140.97315 C -243.79274,146.02948 -236.37425,149.4527 -229.68248,147.08651 C -225.09383,144.85973 -221.79206,140.75401 -217.61535,137.88661 C -215.10454,135.69469 -212.49235,133.26839 -210.83749,130.50207 C -210.86477,126.92195 -214.68529,121.91303 -210.252,119.57013 C -207.25619,117.95208 -205.81053,112.12098 -209.75314,110.87946 C -214.16982,109.44692 -216.95156,115.09837 -221.43751,113.68608 C -228.47365,112.76758 -235.5565,107.20489 -242.69931,110.72434 C -246.89551,113.06547 -243.47174,109.4356 -241.45524,108.56544 C -237.85613,106.84628 -232.73147,104.36798 -233.94637,99.617708 C -234.27189,95.083838 -239.22223,93.197522 -242.95318,91.723135 C -247.61613,89.074942 -253.27003,89.345117 -258.06082,86.933298 C -257.89248,70.385101 -257.58805,53.76423 -258.26571,37.261116 C -259.2092,32.393288 -265.59824,31.96057 -269.68453,32.256957 z M -258.66259,91.764016 C -251.5059,92.239344 -243.21163,93.474137 -238.58238,99.271629 C -238.96251,103.06003 -244.00295,103.80224 -246.52821,106.14082 C -248.92267,108.48087 -251.12372,105.80503 -251.02958,103.27159 C -252.70852,98.336432 -258.20582,95.710815 -263.31841,96.533197 C -267.00561,96.7255 -263.71935,91.937514 -261.395,92.380192 C -260.48382,92.178338 -259.57521,91.953759 -258.66259,91.764016 z " />
-        <path
-           style="fill:url(#linearGradient5285);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
-           sodipodi:nodetypes="ccccczccccccccccccccccccczccccc"
-           id="path2737"
-           d="M -324.0398,30.70877 C -336.3492,30.820231 -335.15663,39.652507 -334.79476,45.313268 C -334.5469,60.436643 -334.38614,75.599009 -334.01234,90.698281 C -333.20516,93.057424 -330.71249,93.985661 -328.75475,95.252079 C -334.4553,96.476239 -336.96996,102.43195 -340.11175,106.59303 C -342.33294,111.36531 -347.84019,115.92868 -345.92111,121.43642 C -344.00204,126.94416 -332.21757,127.68181 -324.95408,127.12866 C -299.06901,127.09789 -273.17022,127.14905 -247.29372,127.06713 C -243.29961,126.16956 -240.99668,122.03601 -241.4977,118.23645 C -238.30082,114.95371 -233.32521,118.03039 -229.53292,118.63002 C -225.71641,119.31313 -232.5646,119.27527 -233.19362,120.54849 C -238.23604,122.95799 -242.6166,126.65447 -246.90973,130.10509 C -250.44674,132.97354 -252.4229,138.10741 -249.57412,142.08235 C -246.21315,145.92284 -241.41489,148.84284 -236.30395,149.79628 C -230.65487,150.83779 -225.57101,147.82678 -221.6157,144.24077 C -216.87391,140.59839 -212.0873,136.78287 -208.84361,131.80554 C -207.76302,128.26399 -211.47449,123.86671 -208.08348,121.09796 C -204.93438,118.46115 -204.06893,113.02076 -207.41836,110.2673 C -212.81988,106.81278 -218.36682,114.55112 -223.89705,111.29128 C -227.94209,110.1659 -231.91311,108.52596 -236.17676,108.45194 C -231.52711,105.88023 -229.62903,98.782331 -234.08944,95.153402 C -239.61551,89.404431 -248.455,88.793917 -255.40182,85.744487 C -255.86992,78.940296 -255.53665,71.972758 -255.70928,65.098797 C -255.80747,55.730822 -255.73864,46.312632 -255.94025,36.975777 C -258.03631,31.236293 -265.34014,30.439522 -270.76286,30.729689 C -289.40725,30.770714 -311.88665,30.597309 -324.0398,30.70877 z M -255.46516,94.482857 C -250.34561,95.62106 -244.69322,96.21649 -240.83258,100.05203 C -242.37635,102.55028 -245.27573,103.64481 -247.80048,104.97505 C -249.71506,99.684643 -254.39847,94.970039 -260.51378,95.138259 C -260.66903,94.131274 -256.73261,94.551178 -255.46516,94.482857 z " />
-      </g>
-      <rect
-         y="78.658051"
-         x="33.326111"
-         width="57.567924"
-         style="fill:url(#linearGradient1156);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient1157);stroke-width:1.44734821pt"
-         id="rect1155"
-         height="8.3153667" />
-      <path
-         style="fill:url(#linearGradient1169);fill-rule:evenodd;stroke-width:0.90459263;stroke-opacity:0.07438019"
-         sodipodi:nodetypes="czzczczzzzzzzc"
-         id="path2676"
-         d="M 98.723806,78.927818 C 95.18666,77.759681 93.50122,82.555591 98.766686,81.004087 C 104.03217,79.452583 120.13123,85.906451 120.37383,89.795491 C 120.61643,93.905503 101.5003,98.581154 106.74108,104.42426 C 111.62816,110.70149 115.35468,100.13868 123.54696,104.21261 C 131.73923,108.17607 136.26048,109.72394 142.25488,104.94185 C 149.10027,101.9342 145.04599,107.07658 139.57918,113.60451 C 134.11237,120.13244 144.00251,115.08156 147.91225,105.31962 C 151.93248,95.557673 139.13128,107.33503 133.66268,105.40571 C 128.19408,103.47639 119.73678,97.849788 113.27625,102.55563 C 106.81572,107.26147 109.62894,99.493003 114.85637,97.90307 C 120.0838,96.092166 122.81363,93.045722 122.85597,90.161522 C 122.89831,87.498293 117.92629,84.811803 112.94229,82.402852 C 107.73732,79.993901 100.49788,78.588966 98.723806,78.927818 z " />
-      <path
-         style="fill:url(#linearGradient1140);fill-opacity:1;fill-rule:evenodd;stroke-width:1.44734821pt"
-         sodipodi:nodetypes="czzzzzzzz"
-         id="path1139"
-         d="M 15.102732,106.80712 C 13.80355,109.23224 17.148847,113.52338 19.900059,113.52338 L 107.85106,113.52338 C 110.18914,113.52338 113.70766,110.4906 112.64839,108.40622 L 102.7339,88.897093 C 101.97024,87.394398 100.26184,86.65834 98.576216,86.65834 L 28.215425,86.658339 C 26.825434,86.658339 25.353768,87.671846 24.697385,88.897093 L 15.102732,106.80712 z " />
-      <rect
-         y="22.413721"
-         x="26.015469"
-         width="72.279724"
-         style="fill:url(#linearGradient905);fill-opacity:1;fill-rule:evenodd;stroke-width:1.62826681"
-         ry="5.4369707"
-         rx="5.4369707"
-         id="rect1137"
-         height="60.126495" />
-      <rect
-         y="31.695871"
-         x="33.386066"
-         width="58.178177"
-         style="fill:url(#radialGradient1132);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient891);stroke-width:1.4649456pt"
-         id="rect1131"
-         height="38.044163" />
-      <path
-         style="fill:url(#linearGradient1146);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="czzccccc"
-         id="path1145"
-         d="M 27.690431,52.841444 L 27.370609,74.749236 C 27.319624,78.241665 29.310209,80.477938 32.807578,80.506029 L 72.625393,80.825852 L 76.463254,71.87084 L 32.008024,71.55102 L 31.688202,52.681533 L 27.690431,52.841444 z " />
-      <g
-         transform="matrix(-1,0,0,1,125.4301,0)"
-         id="g1791">
-        <path
-           style="fill:url(#linearGradient1148);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-           sodipodi:nodetypes="czzccc"
-           id="path1147"
-           d="M 42.062098,33.460351 L 77.341205,33.008055 C 82.787126,32.938235 89.553204,38.416797 89.553204,43.863165 L 89.553204,60.14583 L 41.609801,59.693534 L 42.062098,33.460351 z " />
-        <path
-           style="fill:url(#linearGradient1150);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-           sodipodi:nodetypes="czzccc"
-           id="path1149"
-           d="M 78.337784,67.629235 L 46.723745,67.724544 C 41.843589,67.739257 35.829319,62.771024 35.877168,57.891081 L 36.020221,43.301821 L 78.973514,44.128288 L 78.337784,67.629235 z " />
-      </g>
-      <path
-         style="fill:url(#linearGradient1167);fill-opacity:1;fill-rule:evenodd;stroke-width:0.72367412;stroke-opacity:0.34710741"
-         sodipodi:nodetypes="cczzzzzzc"
-         id="path1159"
-         d="M 137.39107,112.02341 C 137.39107,112.02341 129.0757,110.26438 123.63872,113.62251 C 118.20176,116.98064 109.96635,123.21719 108.76702,124.81628 C 107.40777,126.57531 107.42036,130.22796 109.24674,131.53253 L 114.84364,135.53031 C 118.31797,138.01198 124.86218,139.25396 128.11624,136.48978 L 142.98795,123.85681 C 144.79792,122.3193 145.72732,118.27921 144.10733,116.82073 C 142.95609,115.04975 140.4892,112.91939 137.39107,112.02341 z " />
-      <path
-         style="fill:url(#linearGradient1171);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="czzzzzc"
-         id="path1160"
-         d="M 142.3483,121.13833 L 125.91043,133.59673 C 122.97154,135.82414 118.65484,134.11775 116.28283,133.77129 C 113.9108,133.42481 111.88528,131.87901 112.12516,132.33209 C 112.36503,132.78517 115.08349,135.71687 117.72203,136.48978 C 120.36055,137.26267 124.9543,138.89307 127.50953,136.15531 C 130.06477,133.41755 145.2267,123.53699 142.3483,121.13833 z " />
-      <path
-         style="fill:url(#linearGradient1404);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="cczc"
-         id="path1403"
-         d="M 132.11225,127.51984 C 135.31047,122.88242 120.11893,113.12786 109.08509,127.0401 C 110.20446,130.71805 116.80662,132.5992 121.82304,132.33547 C 126.68363,132.07993 129.50037,129.97181 132.11225,127.51984 z " />
-      <path
-         style="fill:url(#linearGradient1166);fill-opacity:1;fill-rule:evenodd;stroke-width:1.08551121"
-         sodipodi:nodetypes="cccccccc"
-         id="path1519"
-         d="M 138.63464,112.68306 C 135.9958,113.22749 132.31739,114.43079 129.87534,116.38362 C 128.77009,115.68011 125.32759,114.5677 123.66767,113.84494 L 123.24572,114.10517 C 129.67287,117.23476 136.43512,117.91249 135.88192,122.87668 C 136.33675,122.98575 137.05589,123.09702 136.73191,122.38863 C 136.41775,118.90392 132.50587,117.23351 131.02697,116.81532 C 133.17224,114.26602 136.255,113.70892 138.63464,112.68306 z " />
-      <path
-         style="fill:url(#linearGradient1144);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
-         sodipodi:nodetypes="czzzzzzzz"
-         id="path1143"
-         d="M 18.891612,106.48414 C 17.978451,108.31614 19.173914,111.55774 22.263529,111.55774 L 105.0195,111.55774 C 106.66288,111.55774 109.13595,109.26672 108.39142,107.69215 L 101.42279,92.954575 C 100.88602,91.819403 99.685232,91.263378 98.500462,91.263378 L 28.108183,91.263369 C 27.131195,91.263369 26.0968,92.028994 25.635445,92.954575 L 18.891612,106.48414 z " />
-      <text
-         y="-14.660837"
-         xml:space="preserve"
-         x="6.147172"
-         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
-         id="text1232"><tspan
-           id="tspan1233">Computer</tspan></text>
-      <text
-         y="-34.951134"
-         xml:space="preserve"
-         x="84.564949"
-         transform="scale(0.246729,0.246729)"
-         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
-         id="text1235"><tspan
-           id="tspan1236">Created by Andrew Fitzsimon</tspan></text>
-    </g>
-    <g
-       id="g5474"
-       transform="translate(633.63525,501.49239)"
-       inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_single.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157">
-      <path
-         style="fill:#ffffff;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="cccc"
-         id="path9383"
-         d="M 203.47051,-209.74941 C 198.72111,-204.56585 195.69876,-195.27863 189.00642,-195.27863 C 182.52997,-197.07848 181.66644,-212.48518 180.80291,-215.7969 C 188.1429,-210.75732 195.69876,-207.87757 203.47051,-209.74941 z " />
-      <path
-         transform="matrix(-0.440859,0,0,0.441062,265.52775,-266.17138)"
-         style="fill:#f1bb96;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:type="arc"
-         sodipodi:ry="57.825485"
-         sodipodi:rx="60.94183"
-         sodipodi:cy="70.290855"
-         sodipodi:cx="150.27701"
-         id="path3713"
-         d="M 211.21884 70.290855 A 60.94183 57.825485 0 1 1  89.335178,70.290855 A 60.94183 57.825485 0 1 1  211.21884 70.290855 z" />
-      <path
-         style="fill:#233e6a;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="ccssssc"
-         id="path4369"
-         d="M 232.46888,-182.94274 C 232.85952,-157.74648 168.23012,-154.86512 168.38642,-182.94274 C 166.84164,-205.27149 177.94687,-217.96719 180.70654,-215.80872 C 182.10778,-214.71274 182.62841,-190.37295 192.09635,-195.9716 C 196.69923,-198.69339 201.84768,-209.14846 204.10029,-209.49532 C 207.49937,-210.01873 214.00811,-212.77083 219.98583,-217.92153 C 221.55412,-219.27285 231.93943,-205.38255 232.46888,-182.94274 z " />
-      <path
-         style="fill:#513624;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="ccccc"
-         id="path11309"
-         d="M 204.55432,-273.85152 C 222.46413,-271.53047 237.32676,-259.28175 231.38357,-231.42099 C 229.66954,-221.67743 222.12426,-217.60887 219.35537,-236.36962 C 211.4578,-233.88387 177.25785,-223.92576 170.54948,-241.26677 C 166.55631,-248.43407 174.86257,-276.23329 204.55432,-273.85152 z " />
-      <path
-         style="fill:#1f4eb3;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="cccc"
-         id="path11942"
-         d="M 191.92173,-167.75448 C 192.06919,-184.44566 194.18855,-193.73288 188.47558,-194.95709 C 182.9785,-195.85052 179.91138,-176.52634 179.04785,-173.21462 C 175.85958,-157.19769 189.53653,-154.44605 191.92173,-167.75448 z " />
-      <path
-         style="fill:url(#linearGradient1815);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         id="path1811"
-         d="M 172.67812,-237.76056 C 182.56217,-225.58826 212.09549,-234.15979 219.36562,-236.44806 C 220.33459,-229.88278 221.90014,-226.25074 223.58437,-224.54181 C 219.31219,-215.8234 210.06249,-209.76056 199.27187,-209.76056 C 184.44142,-209.76056 172.42812,-221.18201 172.42812,-235.26056 C 172.42812,-236.11869 172.59078,-236.92413 172.67812,-237.76056 z " />
-      <path
-         style="fill:url(#radialGradient1818);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="ccccc"
-         id="path1817"
-         d="M 203.17522,-273.74212 C 221.08504,-271.42107 235.94766,-259.17235 230.00448,-231.31159 C 228.29044,-221.56803 220.74517,-217.49946 217.97627,-236.26022 C 210.0787,-233.77447 175.87876,-223.81635 169.17039,-241.15737 C 165.17722,-248.32467 173.48348,-276.12389 203.17522,-273.74212 z " />
-      <path
-         style="fill:url(#radialGradient1822);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         id="path1819"
-         d="M 220.74123,-214.1875 C 227.87764,-203.73841 231.28831,-190.18836 229.45998,-177.71875 C 222.3997,-165.39834 205.93726,-163.52328 193.05373,-164.75 C 194.11526,-173.29796 194.69425,-182.39807 193.51876,-190.98978 C 191.02311,-195.41909 199.33209,-197.29913 200.39748,-201.6875 C 203.70655,-208.92744 212.80427,-208.10966 218.04988,-213.3696 C 218.9201,-213.57294 220.00051,-215.94141 220.74123,-214.1875 z M 179.55373,-210.28125 C 180.69974,-204.97453 181.23339,-199.24919 184.58498,-194.75 C 179.40159,-187.81847 178.05976,-178.63643 176.67873,-170.28125 C 167.10271,-177.01707 169.81568,-190.62142 172.02963,-200.39411 C 173.03008,-204.26346 176.36728,-212.34166 179.19382,-211.77772 C 179.27177,-211.45363 179.5117,-210.45598 179.55373,-210.28125 z " />
-      <path
-         style="fill:url(#radialGradient1824);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="cccc"
-         id="path1823"
-         d="M 192.35803,-167.43887 C 192.50549,-184.13006 194.62485,-193.41727 188.91188,-194.64149 C 183.4148,-195.53491 180.34768,-176.21073 179.48415,-172.89901 C 176.29589,-156.88208 189.97283,-154.13044 192.35803,-167.43887 z " />
-      <path
-         style="fill:#1f4eb3;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
-         sodipodi:nodetypes="ccccc"
-         id="path1825"
-         d="M 185.2414,-200.53324 C 185.2414,-197.95291 187.25802,-195.85872 189.74278,-195.85872 C 192.22755,-195.85872 194.24417,-197.95291 194.24417,-200.53324 C 194.24417,-203.11357 193.61259,-209.36288 191.12783,-209.36288 C 188.64306,-209.36288 185.2414,-203.11357 185.2414,-200.53324 z " />
-      <path
-         style="fill:url(#radialGradient1828);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
-         sodipodi:nodetypes="ccccc"
-         id="path1827"
-         d="M 186.28018,-201.05263 C 186.28018,-198.4723 188.2968,-196.37811 190.78156,-196.37811 C 193.26633,-196.37811 195.28295,-198.4723 195.28295,-201.05263 C 195.28295,-203.63296 194.65137,-209.88227 192.16661,-209.88227 C 189.68184,-209.88227 186.28018,-203.63296 186.28018,-201.05263 z " />
-    </g>
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="345.5625"
-       y="218.05542"
-       id="text7877"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_single.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157"><tspan
-         sodipodi:role="line"
-         x="345.5625"
-         y="218.05542"
-         id="tspan2399">create project</tspan></text>
-    <path
-       sodipodi:type="arc"
-       style="fill:#000000"
-       id="path9548"
-       sodipodi:cx="292.14285"
-       sodipodi:cy="181.95163"
-       sodipodi:rx="15"
-       sodipodi:ry="15"
-       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
-       transform="translate(32.857147,24.174103)"
-       inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_single.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157" />
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="314.53906"
-       y="217.78979"
-       id="text9550"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_single.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157"><tspan
-         sodipodi:role="line"
-         id="tspan9552"
-         x="314.53906"
-         y="217.78979">1</tspan></text>
-    <path
-       sodipodi:type="arc"
-       style="fill:#000000"
-       id="path9554"
-       sodipodi:cx="292.14285"
-       sodipodi:cy="181.95163"
-       sodipodi:rx="15"
-       sodipodi:ry="15"
-       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
-       transform="translate(33.388397,76.658478)"
-       inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_single.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157" />
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="315.78125"
-       y="270.48511"
-       id="text9556"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_single.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157"><tspan
-         sodipodi:role="line"
-         id="tspan9558"
-         x="315.78125"
-         y="270.48511">2</tspan></text>
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="344.92188"
-       y="267.43823"
-       id="text9566"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_single.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157"><tspan
-         sodipodi:role="line"
-         id="tspan9568"
-         x="344.92188"
-         y="267.43823">record changes</tspan></text>
-    <path
-       sodipodi:type="arc"
-       style="fill:#000000"
-       id="path9652"
-       sodipodi:cx="292.14285"
-       sodipodi:cy="181.95163"
-       sodipodi:rx="15"
-       sodipodi:ry="15"
-       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
-       transform="translate(32.857147,128.5416)"
-       inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_single.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157" />
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="314.88281"
-       y="322.14166"
-       id="text9654"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_single.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157"><tspan
-         sodipodi:role="line"
-         id="tspan9656"
-         x="314.88281"
-         y="322.14166">3</tspan></text>
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="346.9086"
-       y="319.32135"
-       id="text9658"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_single.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157"><tspan
-         sodipodi:role="line"
-         id="tspan9660"
-         x="346.9086"
-         y="319.32135">browse history</tspan></text>
-    <flowRoot
-       xml:space="preserve"
-       id="flowRoot2405"><flowRegion
-         id="flowRegion2407"><rect
-           id="rect2409"
-           width="274.35742"
-           height="94.045197"
-           x="293.44931"
-           y="485.2934" /></flowRegion><flowPara
-         id="flowPara2411"></flowPara></flowRoot>    <path
-       sodipodi:type="arc"
-       style="fill:#000000"
-       id="path2427"
-       sodipodi:cx="292.14285"
-       sodipodi:cy="181.95163"
-       sodipodi:rx="15"
-       sodipodi:ry="15"
-       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
-       transform="translate(32.857147,180.5416)"
-       inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_single.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157" />
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="314.9375"
-       y="374.15729"
-       id="text2429"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_single.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157"><tspan
-         sodipodi:role="line"
-         id="tspan2431"
-         x="314.9375"
-         y="374.15729">4</tspan></text>
-    <text
-       xml:space="preserve"
-       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
-       x="346.9086"
-       y="371.32135"
-       id="text2433"
-       sodipodi:linespacing="125%"
-       inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_single.png"
-       inkscape:export-xdpi="41.964157"
-       inkscape:export-ydpi="41.964157"><tspan
-         sodipodi:role="line"
-         id="tspan2435"
-         x="346.9086"
-         y="371.32135">package release</tspan></text>
-  </g>
-</svg>

=== modified file 'doc/en/user-guide/index.txt'
--- doc/en/user-guide/index.txt	2008-07-11 02:33:29 +0000
+++ doc/en/user-guide/index.txt	2007-08-29 20:06:09 +0000
@@ -1,6 +1,6 @@
-#################
+=================
 Bazaar User Guide
-#################
+=================
 
 .. Files are currently links but will become includes once the
 .. content makes more sense as a whole.
@@ -10,109 +10,86 @@
 ..   level 3 ~~~~~~~~
 ..   level 4 ^^^^^^^^ (it is better not to use nesting deeper than 3 levels)
 
-.. contents:: :depth: 2
-.. sectnum::
-
-
-Introduction
+.. later contents::
+.. later sectnum::
+
+
+.. later Introduction
+.. later ############
+
+.. later include:: introducing_bazaar.txt
+.. later include:: workflows.txt
+
+
+Setting Up Bazaar
+#################
+
+.. later include:: download.txt
+
+* `Introducing yourself <setting_up_email.html>`_ |--| The various ways that exist
+  to tell Bazaar your email address for commits.
+
+* `Using configuration files <configuration.html>`_ |--| Information on how to configure
+  Bazaar.
+
+
+Basic Topics
 ############
 
-.. include:: introducing_bazaar.txt
-.. include:: core_concepts.txt
-.. include:: bazaar_workflows.txt
-
-
-Getting started
+* `Tutorial <tutorial.html>`_ |--| Explains how to use bzr.
+  Loaded with examples.
+
+* `Specifying revision identifiers <specifying_revisions.html>`_ |--| Description 
+  of the subarguments for ``-r`` as used by commands such as
+  **bzr log** and **bzr merge**.
+
+* `Running a Bazaar server <server.html>`_ |--| How to run a server 
+  to allow remote access to Bazaar branches.
+
+
+Advanced Topics
 ###############
 
-.. include:: installing_bazaar.txt
-.. include:: entering_commands.txt
-.. include:: getting_help.txt
-.. include:: configuring_bazaar.txt
-.. include:: using_aliases.txt
-.. include:: plugins.txt
-.. include:: zen.txt
-
-
-Personal version control
-########################
-
-.. include:: solo_intro.txt
-.. include:: starting_a_project.txt
-.. include:: controlling_registration.txt
-.. include:: reviewing_changes.txt
-.. include:: recording_changes.txt
-.. include:: browsing_history.txt
-.. include:: releasing_a_project.txt
-.. include:: undoing_mistakes.txt
-
-
-Sharing with peers
-##################
-
-.. include:: partner_intro.txt
-.. include:: branching_a_project.txt
-.. include:: merging_changes.txt
-.. include:: resolving_conflicts.txt
-.. include:: annotating_changes.txt
-
-
-Team collaboration, central style
-#################################
-
-.. include:: central_intro.txt
-.. include:: publishing_a_branch.txt
-.. include:: using_checkouts.txt
-.. include:: working_offline_central.txt
-.. include:: reusing_a_checkout.txt
-
-
-Team collaboration, distributed style
+* `Conflict handling <conflicts.html>`_ |--| The various kind of conflicts
+  you may encounter, and how to handle them.
+
+* `Centralized workflow <centralized_workflow.html>`_ |--| How to use Bazaar in
+  a centralized way like CVS or Subversion.
+
+.. later include:: using_bound_branches.txt
+.. later include:: shared_repositories.txt
+
+
+Best Practices
+##############
+
+* `Running a Bazaar smart server <http_smart_server.html>`_ |--| How to run 
+  a smart HTTP server to allow remote access to Bazaar branches.
+
+* `Shared repositories layouts <shared_repository_layouts.html>`_ |--| The
+  pros and cons of various repository layouts.
+
+.. later include:: tracking_upstream.txt
+.. later include:: useful_tips.txt
+ 
+
+Extending Bazaar
+################
+
+* `Plugins <plugins.html>`_ |--| Information on how to use plugins in Bazaar.
+
+* `Hooks <hooks.html>`_ |--| How to set up hooks that are executed on certain
+  Bazaar operations.
+
+* `Using aliases <using_aliases.html>`_ |--| How to set up 
+  and use command aliases.
+
+
+Integrating Bazaar With Other Systems
 #####################################
 
-.. include:: distributed_intro.txt
-.. include:: organizing_branches.txt
-.. include:: using_gatekeepers.txt
-.. include:: sending_changes.txt
-
-
-Miscellaneous topics
-####################
-
-.. include:: part2_intro.txt
-.. include:: adv_merging.txt
-.. include:: stacked.txt
-.. include:: server.txt
-.. include:: hooks.txt
-.. include:: version_info.txt
- 
-
-A brief tour of some popular plugins
-####################################
-
-.. include:: bzrtools_plugin.txt
-.. include:: svn_plugin.txt
-.. include later looms_plugin.txt
-
-
-Integrating Bazaar into your environment
-########################################
-
-.. include:: web_browsing.txt
-.. include later - file_explorers.txt
-.. include later - desktop_integration.txt
-.. include later - editors_and_ides.txt
-.. include later - email.txt
-.. include:: bug_trackers.txt
-
-
-Appendices
-##########
-
-.. include:: specifying_revisions.txt
-.. include:: shared_repository_layouts.txt
-.. include:: setting_up_email.txt
-.. include:: http_smart_server.txt
-.. include:: writing_a_plugin.txt
+* `Bug trackers <bug_trackers.html>`_ |--| Information on how to integrate with bug trackers.
+
+* `Exporting version information <version_info.html>`_ |--| How to export version numbers to a build system.
 
 .. |--| unicode:: U+2014

=== removed file 'doc/en/user-guide/installing_bazaar.txt'
--- doc/en/user-guide/installing_bazaar.txt	2008-03-27 07:51:10 +0000
+++ doc/en/user-guide/installing_bazaar.txt	1970-01-01 00:00:00 +0000
@@ -1,92 +0,0 @@
-Installing Bazaar
-=================
-
-Linux
------
-
-Bazaar packages are available for most popular Linux distributions
-including Ubuntu/Debian, Red Hat and Gentoo.
-See http://bazaar-vcs.org/Download for the latest instructions.
-
-Windows
--------
-
-For Windows users, an installer is available that includes
-the core Bazaar package together with necessary pre-requisites
-and some useful plug-ins.
-See http://bazaar-vcs.org/Download for the latest instructions.
-
-Note: If you are running Cygwin on Windows, a Bazaar for Cygwin package
-is available and ought to be used instead of the Windows version.
-
-Other operating systems
------------------------
-
-Beyond Linux and Windows, Bazaar packages are available for a large
-range of other operating systems include Mac OS X, FreeBSD and Solaris.
-See http://bazaar-vcs.org/Download for the latest instructions.
-
-
-Installing from scratch
------------------------
-
-If you wish to install Bazaar from scratch rather than using a
-pre-built package, the steps are:
-
-  1. If it is not installed already, install Python 2.4 or later.
-
-  2. Download the ``bazaar-xxx.tar.gz`` file (where xxx is the version
-     number) from http://bazaar-vcs.org/Download or from Launchpad
-     (https://launchpad.net/~bzr/).
-
-  3. Unpack the archive using tar, WinZip or equivalent.
-
-  4. Put the created directory on your PATH.
-
-To test the installation, try running the **bzr** command like this::
-
-  bzr version
-
-This will display the version of Bazaar you have installed. If this
-doesn't work, please contact us via email or IRC so we can help you
-get things working.
-
-
-Running the development version
--------------------------------
-
-You may wish to always be using the very latest development version of
-Bazaar. Note that this is not recommended for
-the majority of users as there is an increased risk of bugs. On the other
-hand, the development version is remarkably solid (thanks to the processes
-we follow) and running it makes it easier for you to send us changes for
-bugs and improvements. It also helps us by having more people testing
-the latest software.
-
-Here are the steps to follow:
-
-  1. Install Bazaar using one of the methods given above.
-
-  2. Get a copy of the development version like this::
-
-       bzr branch http://bazaar-vcs.org/bzr/bzr.dev
-
-  3. Put the created directory (bzr.dev) on your PATH.
-
-Advanced users may also wish to build the optional C extensions for greater
-speed. This can be done using ``make`` and requires ``pyrex`` and a C compiler.
-Please contact us on email or IRC if you need assistance with this.
-
-
-Running multiple versions
--------------------------
-
-It's easy to have multiple versions of Bazaar installed and to switch
-between them. To do this,
-simply provide the full pathname to the **bzr** command you wish to run.
-The relevant libraries will be automatically detected and used. Of course,
-if you do not provide a pathname, then the **bzr** used will be the one
-found on your system path as normal.
-
-Note that this capability is particularly useful if you wish to run
-(or test) both the latest released version and the development version say.

=== removed file 'doc/en/user-guide/introducing_bazaar.txt'
--- doc/en/user-guide/introducing_bazaar.txt	2008-05-09 06:52:35 +0000
+++ doc/en/user-guide/introducing_bazaar.txt	1970-01-01 00:00:00 +0000
@@ -1,142 +0,0 @@
-Introducing Bazaar
-==================
-
-What is Bazaar?
----------------
-
-Bazaar is a tool for helping people collaborate. It tracks the changes
-that you and other people make to a group of files - such as software
-source code - to give you snapshots of each stage of their evolution.
-Using that information, Bazaar can effortlessly merge your work with
-other people's.
-
-Tools like Bazaar are called version control systems (VCS) and have
-long been popular with software developers. Bazaar's ease of use,
-flexibility and simple setup make it ideal not only for software
-developers but also for other groups who work together on files and
-documents, such as technical writers, web designers and translators.
-
-This guide takes you through installing Bazaar and how to use it,
-whether on your own or with a team of other people. If you're already
-familiar with distributed version control and want to dive straight in, 
-you may wish to skim this section and jump straight to
-`Learning more`_.
-
-A brief history of version control systems
-------------------------------------------
-
-Version control tools have been evolving for several decades now. In
-simple terms, there have been 4 generations of tools:
-
- 1. file versioning tools, e.g. SCCS, RCS
- 2. tree versioning tools - central style, e.g. CVS
- 3. tree versioning tools - central style, take two, e.g. Subversion
- 4. tree versioning tools - distributed style, e.g. Bazaar.
-
-The design and implementation of Bazaar builds on the lessons learned
-from all the previous generations of tools. In particular, Bazaar
-cleanly supports both the central and the distributed version
-control models so you can change models as it makes sense, without
-needing to change tools.
-
-Central vs distributed VCS
---------------------------
-
-Many traditional VCS tools require a central server which provides the
-change history or *repository* for a tree of files. To work on the files,
-users need to connect to the server and *checkout* the files. This gives
-them a directory or *working tree* in which a person can make changes.
-To record or *commit* these changes, the user needs access to the central
-server and they need to ensure they have merged their work with the latest
-version stored before trying to commit. This approach is known as the
-centralized model. 
-
-The centralized model has proven useful over time but it can have some notable
-drawbacks. Firstly, a centralized VCS requires that one is able to connect
-to the server whenever one wants to do version control work. Secondly, the
-centralized model tightly links the act of **snapshotting** changes with the act
-of **publishing** those changes. This can be good in some circumstances but
-it has a negative influence on quality in others.
-
-Distributed VCS tools let users and teams have multiple repositories
-rather than just a single central one. In Bazaar's case, the history is
-normally kept in the same place as the code that is being version controlled.
-This allows the user to commit their changes whenever it makes sense, even
-when offline. Network access is only required when publishing changes or
-when accessing changes in another location.
-
-In fact, using distributed VCS tools wisely can have advantages well
-beyond the obvious one of disconnected operations for developers.
-Other advantages include:
-
- * easier for developers to create experimental branches
- * easier ad-hoc collaboration with peers
- * less time required on mechanical tasks - more time for creativity
-
- * increased release management flexibility through the use of
-   "feature-wide" commits
-
- * trunk quality and stability can be kept higher, making everyone's
-   job less stressful
-
- * in open source communities:
-
-   * easier for non-core developers to create and maintain changes
-
-   * easier for core developers to work with non-core developers and
-     move them into the core
-
- * in companies, easier to work with distributed and outsourced teams.
-   
-For a detailed look at the advantages of distributed VCS tools over
-centralized VCS tools, see http://bazaar-vcs.org/BzrWhy.
-
-
-Key features of Bazaar
-----------------------
-
-While Bazaar is not the only distributed VCS tool around, it does have some
-notable features that make it an excellent choice for many teams and
-communities. A summary of these and comparisons with other VCS tools
-can be found on the Bazaar Wiki, http://bazaar-vcs.org.
-
-Of the many features, one in particular is worth highlighting:
-Bazaar is completely free software written in Python. As a result,
-it is easy to contribute improvements. If you wish to get involved,
-please see http://bazaar-vcs.org/BzrSupport.
-
-
-Learning more
--------------
-
-This manual provides an easy to read introduction to Bazaar and how to use
-it effectively.  It is recommended that all users read at least the rest of
-this chapter as it:
-
- * explains the core concepts users need to know
- * introduces some popular ways of using Bazaar to collaborate.
-
-Chapters 2-6 provide a closer look at how to use Bazaar to complete
-various tasks. It is recommended that most users read these in first-to-last
-order shortly after starting to use Bazaar. Chapter 7 and beyond provide
-additional information that helps you make the most of Bazaar once the core
-functionality is understood. This material can be read when required and in
-any order.
-
-If you are already familar with other version control tools,
-you may wish to get started quickly by reading the following documents:
-
- * `Bazaar in five minutes`_ - a mini-tutorial
-
- * `Bazaar Quick Start Card`_ - a one page summary of commonly used commands.
-
-In addition, the online help and `Bazaar User Reference`_ provide all the
-details on the commands and options available.
-
-.. _Bazaar in five minutes: ../mini-tutorial/index.html
-.. _Bazaar Quick Start Card: ../quick-reference/quick-start-summary.svg
-.. _Bazaar User Reference: ../user-reference/bzr_man.html
-
-We hope you find this manual useful. If you have suggestions on how it
-or the rest of Bazaar's documentation can be improved, please contact
-us on the mailing list, bazaar@lists.canonical.com.

=== removed file 'doc/en/user-guide/merging_changes.txt'
--- doc/en/user-guide/merging_changes.txt	2007-12-04 12:56:31 +0000
+++ doc/en/user-guide/merging_changes.txt	1970-01-01 00:00:00 +0000
@@ -1,91 +0,0 @@
-Merging changes
-===============
-
-Parallel development
---------------------
-
-Once someone has their own branch of a project, they can make
-and commit changes in parallel to any development proceeding
-on the original branch. Pretty soon though, these independent
-lines of development will need to be combined again. This
-process is known as *merging*.
-
-The merge command
------------------
-
-To incorporate changes from another branch, use the ``merge`` command.
-Its syntax is::
-
-  bzr merge [URL]
-
-If no URL is given, a default is used, initially the branch this branch
-originated from.
-For example, if Bill made a branch from Mary's work, he can merge her
-subsequent changes by simply typing this::
-
-  bzr merge
-
-On the other hand, Mary might want to merge into her branch the work Bill
-has done in his. In this case, she needs to explicitly give the URL the
-first time, e.g.::
-
-  bzr merge sftp://mary@bill-laptop/cool-repo/cool-trunk
-
-This sets the default merge branch if one is not already set. To change the
-default after it is set, use the ``--remember`` option.
-
-How does merging work?
-----------------------
-
-A variety of algorithms exist for merging changes. Bazaar's
-default algorithm is a variation of *3-way merging* which
-works as follows. Given an ancestor A and two branches B and C,
-the following table provides the rules used.
-
-  === === === ====== =================
-   A   B   C  Result Comment
-  === === === ====== =================
-   x   x   x  x      unchanged
-   x   x   y  y      line from C
-   x   y   x  y      line from B
-   x   y   z  ?      conflict
-  === === === ====== =================
-
-Note that some merges can only be completed with the assistance
-of a human. Details on how to resolve these are given in
-`Resolving conflicts`_.
-
-Recording a merge
------------------
-
-After any conflicts are resolved, the merge needs to be committed.
-For example::
-
-  bzr commit -m "Merged Mary's changes"
-
-Even if there are no conflicts, an explicit commit is still required.
-Unlike some other tools, this is considered a feature in Bazaar.
-A clean merge is not necessarily a good merge so making the commit
-a separate explicit step allows you to run your test suite first to
-verify all is good. If problems are found, you should correct them
-before committing the merge or throw the merge away using ``revert``.
-
-Merge tracking
---------------
-
-One of the most important features of Bazaar is distributed,
-high quality *merge tracking*.
-In other words, Bazaar remembers what has been merged already and
-uses that information to intelligently choose the best ancestor for
-a merge, minimizing the number and size of conflicts.
-
-If you are a refugee from many other VCS tools, it can be really
-hard to "unlearn" the *please-let-me-avoid-merging-at-any-cost* habit.
-Bazaar lets you safely merge as often as you like with other people.
-By working in a peer-to-peer manner when it makes sense to do so, you
-also avoid using a central branch as an "integration swamp", keeping
-its quality higher. When the change you're collaborating on is
-truly ready for wider sharing, that's the time to merge and commit
-it to a central branch, not before.
-
-Merging that Just Works truly can change how developers work together.

=== removed file 'doc/en/user-guide/organizing_branches.txt'
--- doc/en/user-guide/organizing_branches.txt	2008-07-14 17:26:07 +0000
+++ doc/en/user-guide/organizing_branches.txt	1970-01-01 00:00:00 +0000
@@ -1,100 +0,0 @@
-Organizing branches
-===================
-
-Mirror branches
----------------
-
-A primary difference when using distributed workflows to
-develop is that your main local branch is not the place
-to make changes. Instead, it is kept as a pristine copy
-of the central branch, i.e. it's a *mirror branch*.
-
-To create a mirror branch, set-up a shared repository
-(if you haven't already) and then use the ``branch``
-(or ``checkout``) command to create the mirror.
-For example::
-
-  bzr init-repo X-repo
-  cd X-repo
-  bzr branch sftp://centralhost/srv/bzr/X-repo/X-trunk
-
-Task branches
--------------
-
-Each new feature or fix is developed in its own branch.
-These branches are referred to as *feature branches* or
-*task branches* - the terms are used interchangably.
-
-To create a task branch, use the ``branch`` command
-against your mirror branch. For example::
-
-  bzr branch X-trunk X-fix-123
-  cd X-fix-123
-  (hack, hack, hack)
-
-There are numerous advantages to this approach:
-
- 1. You can work on multiple changes in parallel
- 2. There is reduced coupling between changes
- 3. Multiple people can work in a peer-to-peer mode
-    on a branch until it is ready to go.
-
-In particular, some changes take longer to cook than others
-so you can ask for reviews, apply feedback, ask for another
-review, etc. By completing work to sufficient quality in
-separate branches before merging into a central branch, the
-quality and stability of the central branch are maintained
-at higher level than they otherwise would be.
-
-Refreshing a mirror branch
---------------------------
-
-Use the ``pull`` command to do this::
-
-  cd X-trunk
-  bzr pull
-
-Merging the latest trunk into a feature branch
-----------------------------------------------
-
-Use the ``merge`` command to do this::
-
-  cd X-fix-123
-  bzr merge
-  (resolve any conflicts)
-  bzr commit -m "merged X-trunk"
-
-Merging a feature into the trunk
---------------------------------
-
-The policies for different distributed workflows vary here.
-The simple case where all developers have commit rights to
-the main trunk are shown below.
-
-If your mirror is a checkout::
-
-  cd X-trunk
-  bzr update
-  bzr merge ../X-fix-123
-  (resolve any conflicts)
-  bzr commit -m "Fixed bug #123"
-
-If your mirror is a branch::
-
-  cd X-trunk
-  bzr pull
-  bzr merge ../X-fix-123
-  (resolve any conflicts)
-  bzr commit -m "Fixed bug #123"
-  bzr push
-
-Backing up task branches
-------------------------
-
-One of the side effects of centralized workflows is that changes
-get frequently committed to a central location which is backed up as
-part of normal IT operations. When developing on task branches,
-it is a good idea to publish your work to a central location
-(but not necessarily a shared location) that will be backed up.
-You may even wish to bind local task branches to remote ones
-established on a backup server just for this purpose.

=== removed file 'doc/en/user-guide/part2_intro.txt'
--- doc/en/user-guide/part2_intro.txt	2008-05-16 21:00:25 +0000
+++ doc/en/user-guide/part2_intro.txt	1970-01-01 00:00:00 +0000
@@ -1,16 +0,0 @@
-The journey ahead
-=================
-
-We hope that earlier chapters have given you a solid
-understanding of how Bazaar can assist you in being productive
-on your own and working effectively with others.
-If you are learning Bazaar for the first time, it might be
-good to try the procedures covered already for a while,
-coming back to this manual once you have mastered them.
-
-Remaining chapters
-covers various topics to guide you in further optimizing how you
-use Bazaar. Unless stated otherwise, the topics in this and
-remaining chapters are independent of each other and can therefore
-be read in whichever order you wish.
-

=== removed file 'doc/en/user-guide/partner_intro.txt'
--- doc/en/user-guide/partner_intro.txt	2008-05-19 00:16:24 +0000
+++ doc/en/user-guide/partner_intro.txt	1970-01-01 00:00:00 +0000
@@ -1,39 +0,0 @@
-Working with another
-====================
-
-Peer-to-peer rocks
-------------------
-
-In many cases, two minds can be better than one. You may be the one
-who started a project and someone wishes to help, or perhaps it's you
-who wants to help another. Perhaps you are both members of a larger
-team that have been assigned a task together as pair programmers.
-Either way, two people need to agree on a process, a set of
-guidelines and a toolset in order to work together effectively.
-
-Imagine if you were not allowed to call someone on the phone directly
-and the only way to talk to them was by registering a conference call first?
-Companies and communities that only share code via a central VCS
-repository are living with a similar straitjacket to that every day.
-There are times when central control makes a lot of sense and times
-when peer-to-peer rocks. Either way, Bazaar is designed to help.
-
-The partner workflow
---------------------
-
-While it's certainly not the only way to do it, the *partner workflow*
-below is a good starting point for a pair of people who wish to
-collaborate using Bazaar.
-
-.. image:: images/workflows_peer.png
-
-Over and above the tasks covered in the previous chapter, this
-chapter introduces two essential collaboration activities:
-
- * getting a copy of a branch
- * merging changes between branches.
-
-Even when it's just you working on a code base, it can be very useful
-to keep multiple branches around (for different releases say) and
-to merge changes between them as appropriate. Your "partner" may indeed
-be yourself.

=== modified file 'doc/en/user-guide/plugins.txt'
--- doc/en/user-guide/plugins.txt	2007-12-14 07:35:49 +0000
+++ doc/en/user-guide/plugins.txt	2007-08-10 05:17:09 +0000
@@ -1,109 +1,80 @@
-Using plugins
-=============
-
-.. Information on how to use plugins in Bazaar.
-
-What is a plugin?
------------------
-
+==============
+Bazaar plugins
+==============
+
+Information on how to use plugins in Bazaar.
+
+What is a Plugin
+================
 A plugin is an external component for Bazaar that is typically made by
 third parties. A plugin is capable of augmenting Bazaar by adding new
 functionality.  A plugin can also change current Bazaar behavior by
-replacing current functionality. Sample applications of plugins are:
-
-* overriding commands
-* adding new commands
-* providing additional network transports
-* customizing log output.
-  
-The sky is the limit for the customization that can be done through plugins.
-In fact, plugins often work as a way for developers to test new features for
-Bazaar prior to inclusion in the official codebase. Plugins are helpful
-at feature retirement time as well, e.g. deprecated file formats may one
-day be removed from the Bazaar core and be made available as a plugin instead.
-
-Plugins are good for users, good for external developers and good for
-Bazaar itself.
-
-Where to find plugins 
----------------------
-
+replacing current functionality. Plugins often work as a way for
+developers to test new features for Bazaar prior to inclusion in the
+official codebase. Plugins can do a variety of things, including
+overriding commands, adding new commands, providing additional network
+transports, or customizing log output. The sky is the limit for the
+customization that can be done through plugins.
+
+Where to find Plugins 
+=====================
 We keep our list of plugins on the http://bazaar-vcs.org/BzrPlugins page.
 
-How to install a plugin 
------------------------
-
-Installing a plugin is very easy! If not already created, create a
-``plugins`` directory under your Bazaar configuration directory,
-``~/.bazaar/`` on Linux and
-``C:\Documents and Settings\<username>\Application Data\Bazaar\2.0\``
-on Windows. Within this directory (referred to as $BZR_HOME below),
-each plugin is placed in its own subdirectory.
+How to Install a plugin 
+=======================
+Installing a plugin is very easy! One can either install a plugin
+system-wide or on a per user basis. Both methods involve creating a
+``plugins`` directory. Within this directory one can place plugins in
+subdirectories. For example, ``plugins/bzrtools/``.
+
+Two locations are currently checked:  the bzrlib/plugins directory
+(typically found in ``/usr/lib/python2.4/site-packages/bzrlib/plugins/``) and
+``$HOME/.bazaar/plugins/``.
+
+One can additionally override the home plugins by setting the environment
+variable ``BZR_PLUGIN_PATH`` to a directory that contains plugins. The
+installation of a plugin can be checked by running ``bzr plugins`` at
+any time. New commands can be seen by running ``bzr help commands``.
+The commands provided by a plugin are shown followed by the name of the
+plugin in brackets.
 
 Plugins work particularly well with Bazaar branches. For example, to
-install the bzrtools plugins for your main user account on Linux,
-one can perform the following:: 
+install the bzrtools plugins for your main user account, one can perform
+the following:: 
 
     bzr branch http://panoramicfeedback.com/opensource/bzr/bzrtools
     ~/.bazaar/plugins/bzrtools
 
-When installing plugins, the directories that you install them in must
+When installing plugins the directories that you install them in must
 be valid python identifiers. This means that they can only contain
 certain characters, notably they cannot contain hyphens (``-``). Rather
-than installing ``bzr-gtk`` to ``$BZR_HOME/plugins/bzr-gtk``, install it
-to ``$BZR_HOME/plugins/gtk``.
-
-Alternative plugin locations
-----------------------------
-
-If you have the necessary permissions, plugins can also be installed on
-a system-wide basis. Two locations are currently checked for plugins:
-
- 1. the system location - bzrlib/plugins
- 2. the personal location - $BZR_HOME/plugins.
-
-On a Linux installation, these locations are typically
-``/usr/lib/python2.4/site-packages/bzrlib/plugins/`` and
-``$HOME/.bazaar/plugins/``.
-On a Windows installation, the system location might be
-``C:\\Program Files\\Bazaar\\plugins``
-while the personal location might be
-``C:\Documents and Settings\<username>\Application Data\Bazaar\2.0\plugins``.
-
-One can additionally override the personal plugins location
-by setting the environment variable ``BZR_PLUGIN_PATH``
-to a directory that contains plugins.
-
-Listing the installed plugins
------------------------------
-
-To do this, use the plugins command like this::
-
-    bzr plugins
-
-The name, location and version of each plugin installed will be displayed.
-
-New commands added by plugins can be seen by running ``bzr help commands``.
-The commands provided by a plugin are shown followed by the name of the
-plugin in brackets.
-
-Popular plugins
----------------
-
-Here is a sample of some of the more popular plugins.
-
-  ================ ================= ==================================
-  Category         Name              Description
-  ================ ================= ==================================
-  GUI              QBzr              Qt-based GUI tools
-  GUI              bzr-gtk           GTK-based GUI tools
-  GUI              bzr-eclipse       Eclipse integration
-  General          bzrtools          misc. enhancements including shelf
-  General          difftools         external diff tool helper
-  General          extmerge          external merge tool helper
-  Integration      bzr-svn           use Subversion as a repository
-  Migration        cvsps             migrate CVS patch-sets
-  ================ ================= ==================================
-
-If you wish to write your own plugins, it is not difficult to do.
-See `Writing a plugin`_ in the appendices to get started.
+than installing ``bzr-gtk`` to ``~/.bazaar/plugins/bzr-gtk``, install it
+to ``~/.bazaar/plugins/gtk``.
+
+Writing a plugin
+================
+Plugins are very similar to bzr core functionality.  They can import
+anything in bzrlib.  A plugin may simply override standard functionality,
+but most plugins supply new commands.
+
+To create a command, make a new object that derives from
+``bzrlib.commands.Command``, and name it ``cmd_foo``, where foo is the name of
+your command.  If you create a command whose name contains an underscore,
+it will appear in the UI with the underscore turned into a hyphen.  For
+example, `cmd_baz_import` will appear as `baz-import`.  For examples of how
+to write commands, please see ``builtins.py``.
+
+Once you've created a command you must register the command with
+``bzrlib.commands.register_command(cmd_foo)``.  You must register the
+command when your file is imported, otherwise bzr will not see it.
+
+Bzr will scan ``bzrlib/plugins`` and ``~/.bazaar/plugins`` for plugins
+by default.  You can override this with ``BZR_PLUGIN_PATH``.  Plugins
+may be either modules or packages.  If your plugin is a single file,
+you can structure it as a module.  If it has multiple files, or if you
+want to distribute it as a bzr branch, you should structure it as a
+package, i.e. a directory with an ``__init__.py`` file.
+
+Please feel free to contribute your plugin to BzrTools, if you think it
+would be useful to other people.
+

=== removed file 'doc/en/user-guide/publishing_a_branch.txt'
--- doc/en/user-guide/publishing_a_branch.txt	2007-12-14 07:35:49 +0000
+++ doc/en/user-guide/publishing_a_branch.txt	1970-01-01 00:00:00 +0000
@@ -1,65 +0,0 @@
-Publishing a branch
-===================
-
-Setting up a central repository
--------------------------------
-
-While the centralized workflow can be used by socially nominating
-any branch on any computer as the central one, in practice most
-teams have a dedicated server for hosting central branches.
-
-Just as it's best practice to use a shared repository locally,
-it's advisable to put central branches in a shared repository.
-Note that central shared branches typically only want to
-store history, not working copies of files, so their enclosing
-repository is usually creating using the ``no-trees`` option, e.g.::
-
-  bzr init-repo --no-trees sftp://centralhost/srv/bzr/X-repo/
-
-You can think of this step as similar to setting up a new cvsroot or
-Subversion repository. However, Bazaar gives you more flexibility
-in how branches may be organised in your repository. See
-`Choosing a shared repository layout`_ in the appendices for
-guidelines and examples.
-
-
-Starting a central branch
--------------------------
-
-There are two ways of populating a central branch with some initial
-content:
-
- 1. Making a local branch and pushing it to a central location
- 2. Making an empty central branch then committing content to it.
-
-Here is an example of the first way::
-
-  bzr init-repo X-repo
-  bzr init X-repo/X-trunk
-  cd X-repo/X-trunk
-  cp -ar ~/X .     (copy files in using OS-specific tools)
-  bzr add
-  bzr commit -m "Initial import"
-  (local branch has content - publish it centrally now)
-  bzr push sftp://centralhost/srv/bzr/X-repo/X-trunk
-
-Here is an example of the second way::
-
-  bzr init-repo X-repo
-  cd X-repo
-  bzr init sftp://centralhost/srv/bzr/X-repo/X-trunk
-  bzr checkout sftp://centralhost/srv/bzr/X-repo/X-trunk
-  cd X-trunk
-  cp -ar ~/X .     (copy files in using OS-specific tools)
-  bzr add
-  bzr commit -m "Initial import"
-
-Note that committing inside a working tree created using
-the ``checkout`` command implicitly commits the content to
-the central location as well as locally. Had we used the
-``branch`` command instead of ``checkout`` above, the
-content would have only been committed locally.
-
-Working trees that are tightly bound to a central location
-like this are called *checkouts*. The rest of this chapter
-explains their numerous features in more detail.

=== removed file 'doc/en/user-guide/recording_changes.txt'
--- doc/en/user-guide/recording_changes.txt	2007-11-21 07:39:16 +0000
+++ doc/en/user-guide/recording_changes.txt	1970-01-01 00:00:00 +0000
@@ -1,62 +0,0 @@
-Recording changes
-=================
-
-bzr commit
-----------
-
-When the working tree state is satisfactory, it can be **committed** to
-the branch, creating a new revision holding a snapshot of that state.  
-
-The **commit** command takes a message describing the changes in the
-revision.  It also records your userid, the current time and timezone, and
-the inventory and contents of the tree.  The commit message is specified
-by the ``-m`` or ``--message`` option. You can enter a multi-line commit
-message; in most shells you can enter this just by leaving the quotes open
-at the end of the line.
-
-::
-
-    % bzr commit -m "added my first file"
-
-You can also use the ``-F`` option to take the message from a file.  Some
-people like to make notes for a commit message while they work, then
-review the diff to make sure they did what they said they did.  (This file
-can also be useful when you pick up your work after a break.)
-
-Message from an editor
-----------------------
-
-If you use neither the ``-m`` nor the ``-F`` option then bzr will open an
-editor for you to enter a message.  The editor to run is controlled by
-your ``$VISUAL`` or ``$EDITOR`` environment variable, which can be overridden
-by the ``editor`` setting in ``~/.bazaar/bazaar.conf``; ``$BZR_EDITOR`` will
-override either of the above mentioned editor options.  If you quit the
-editor without making any changes, the commit will be cancelled.
-
-The file that is opened in the editor contains a horizontal line. The part
-of the file below this line is included for information only, and will not
-form part of the commit message. Below the separator is shown the list of
-files that are changed in the commit. You should write your message above
-the line, and then save the file and exit.
-
-If you would like to see the diff that will be committed as you edit the
-message you can use the ``--show-diff`` option to ``commit``. This will include
-the diff in the editor when it is opened, below the separator and the
-information about the files that will be committed. This means that you can
-read it as you write the message, but the diff itself wont be seen in the
-commit message when you have finished. If you would like parts to be
-included in the message you can copy and paste them above the separator.
-
-Selective commit
-----------------
-
-If you give file or directory names on the commit command line then only
-the changes to those files will be committed.  For example::
-
-    % bzr commit -m "documentation fix" commit.py
-
-By default bzr always commits all changes to the tree, even if run from a
-subdirectory.  To commit from only the current directory down, use::
-
-    % bzr commit .
-

=== removed file 'doc/en/user-guide/releasing_a_project.txt'
--- doc/en/user-guide/releasing_a_project.txt	2008-05-19 00:05:28 +0000
+++ doc/en/user-guide/releasing_a_project.txt	1970-01-01 00:00:00 +0000
@@ -1,48 +0,0 @@
-Releasing a project
-===================
-
-Packaging a release
--------------------
-
-The ``export`` command is used to package a release, i.e. to
-take a copy of the files and directories in a branch and
-package them into a fresh directory or archive. For example,
-this command will package the last committed version into
-a ``tar.gz`` archive file::
-
-  bzr export ../releases/my-stuff-1.5.tar.gz
-
-The ``export`` command uses the suffix of the archive file
-to work out the type of archive to create as shown below.
-
-      =================       =========================
-      Supported formats       Autodetected by extension
-      =================       =========================
-         dir                         (none)
-         tar                          .tar
-         tbz2                    .tar.bz2, .tbz2
-         tgz                      .tar.gz, .tgz
-         zip                          .zip
-      =================       =========================
-
-If you wish to package a revision other than the last one, use
-the ``-r`` option. If you wish to tune the root directory inside
-the archive, use the ``--root`` option. See the online help or
-User Reference for further details on the options supported by
-``export``.
-
-Tagging a release
------------------
-
-Rather than remembering which version was used to package a release,
-it's useful to define a symbolic name for a version using the ``tag``
-command like this::
-
-  bzr tag version-1-5
-
-That tag can be be used later whenever a revision identifier is
-required, e.g.::
-
-  bzr diff -r tag:version-1-5
-
-To see the list of tags defined in a branch, use the ``tags`` command.

=== removed file 'doc/en/user-guide/resolving_conflicts.txt'
--- doc/en/user-guide/resolving_conflicts.txt	2008-03-05 10:26:17 +0000
+++ doc/en/user-guide/resolving_conflicts.txt	1970-01-01 00:00:00 +0000
@@ -1,83 +0,0 @@
-Resolving conflicts
-===================
-
-Workflow
---------
-
-Unlike some other tools that force you to resolve each conflict during
-the merge process, Bazaar merges as much as it can and then reports the
-conflicts. This can make conflict resolution easier because the contents
-of the whole post-merge tree are available to help you decide how things
-ought to be resolved. You may also wish to selectively run tests as you go
-to confirm each resolution or group or resolutions is good.
-
-Listing conflicts
------------------
-
-As well as being reported by the ``merge`` command, the list of outstanding
-conflicts may be displayed at any time by using the ``conflicts``
-command. It is also included as part of the output from the ``status``
-command.
-
-Resolving a conflict
---------------------
-
-When a conflict is encountered, the ``merge`` command puts embedded
-markers in each file showing the areas it couldn't resolve. It also
-creates 3 files for each file with a conflict:
-
- * foo.BASE
- * foo.THIS
- * foo.OTHER
-
-where ``foo`` is the name of the conflicted file.
-In many cases, you can resolve conflicts by simply manually editing
-each file in question, fixing the relevant areas and removing the
-conflict markers as you go.
-
-After fixing all the files in conflict, and removing the markers, 
-ask Bazaar to mark them as resolved using the ``resolve`` command like this::
-
-  bzr resolve
-
-Alternatively, after fixing each file, you can mark it as resolved
-like this::
-
-  bzr resolve foo
-
-Among other things, the ``resolve`` command cleans up the BASE,
-THIS and OTHER files from your working tree.
-
-Using the remerge command
--------------------------
-
-In some cases, you may wish to try a different merge algorithm on a
-given file. To do this, use the ``remerge`` command nominating
-the file like this::
-
-  bzr remerge --weave foo
-
-where ``foo`` is the file and ``weave`` is one of the available
-merge algorithms. This algorithm is particularly useful when a
-so-called ``criss-cross`` merge is detected, e.g. when two branches
-merge the same thing then merge each other. See the online help for
-``criss-cross`` and ``remerge`` for further details.
-
-Using external tools to resolve conflicts
------------------------------------------
-
-If you have a GUI tool you like using to resolve conflicts, be sure
-to install the *extmerge* plugin. Once installed, it can be used
-like this::
-
-  bzr extmerge foo
-
-where ``foo`` is the conflicted file. Rather than provide a list of
-files to resolve, you can give the ``--all`` option to implicitly
-specify all conflicted files.
-
-The ``extmerge`` command uses the tool specified by the
-``external_merge`` setting in your ``bazaar.conf`` file.
-If not set, it will look for some popular merge tools such
-as ``kdiff3`` or ``opendiff``, the latter being a command
-line interface to the FileMerge utility in OS X.

=== removed file 'doc/en/user-guide/reusing_a_checkout.txt'
--- doc/en/user-guide/reusing_a_checkout.txt	2007-12-14 07:35:49 +0000
+++ doc/en/user-guide/reusing_a_checkout.txt	1970-01-01 00:00:00 +0000
@@ -1,86 +0,0 @@
-Reusing a checkout
-==================
-
-Motivation
-----------
-
-At times, it can be useful to have a single checkout as your
-sandbox for working on multiple branches. Some possible reasons
-for this include:
-
- * saving disk space when the working tree is large
- * developing in a fixed location.
-
-In many cases, working tree disk usage swamps the size of the
-``.bzr`` directory. If you want to work on multiple branches
-but can't afford the overhead of a full working tree for each,
-reusing a checkout across multiples branches is the way to go.
-
-On other occasions, the location of your sandbox might be
-configured into numerous development and testing tools. Once
-again, reusing a checkout across multiple branches can help.
-
-
-Changing where a branch is bound to
------------------------------------
-
-To change where a checkout is bound to, follow these steps:
-
- 1. Make sure that any local changes have been committed
-    centrally so that no work is lost.
-
- 2. Use the ``bind`` command giving the URL of the new
-    remote branch you wish to work on.
-
- 3. Make your checkout a copy of the desired branch by using
-    the ``update`` command followed by the ``revert`` command.
-
-Note that simply binding to a new branch and running ``update``
-merges in your local changes, both committed and uncommitted. You need
-to decide whether to keep them or not by running either ``revert``
-or ``commit``.
-
-An alternative to the bind+update recipe is using the ``switch``
-command. This is basically the same as removing the existing
-branch and running ``checkout`` again on the new location, except
-that any uncommitted changes in your tree are merged in.
-
-Note: As ``switch`` can potentially throw away committed changes in
-order to make a checkout an accurate cache of a different bound branch,
-it will fail by design if there are changes which have been committed
-locally but are not yet committed to the most recently bound branch.
-To truly abandon these changes, use the ``--force`` option.
-
-
-Switching a lightweight checkout
---------------------------------
-
-With a lightweight checkout, there are no local commits and ``switch``
-effectively changes which branch the working tree is associated with.
-One possible setup is to use a lightweight checkout in combination
-with a local tree-less repository. This lets you switch what you
-are working on with ease. For example::
-
-  bzr init-repo --no-trees X-repo
-  cd X-repo
-  bzr branch sftp://centralhost/srv/bzr/X-repo/X-trunk
-  bzr checkout --lightweight X-trunk my-sandbox
-  cd my-sandbox
-  (hack away)
-
-Note that X-trunk in this example will have a ``.bzr`` directory within it
-but there will be no working tree there as the branch was created in
-a tree-less repository. You can grab or create as many branches as you
-need there and switch between them as required. For example::
-
-  (assuming in my-sandbox)
-  bzr branch sftp://centralhost/srv/bzr/X-repo/X-1.0 ../X-1.0
-  bzr switch ../X-1.0
-  (fix bug in 1.0)
-  bzr commit -m "blah, blah blah"
-  bzr switch ../X-trunk
-  (go back to working on the trunk)
-
-Note: The branches may be local only or they may be bound to
-remote ones (by creating them with ``checkout`` or by using ``bind``
-after creating them with ``branch``).

=== removed file 'doc/en/user-guide/reviewing_changes.txt'
--- doc/en/user-guide/reviewing_changes.txt	2007-11-21 07:39:16 +0000
+++ doc/en/user-guide/reviewing_changes.txt	1970-01-01 00:00:00 +0000
@@ -1,58 +0,0 @@
-Reviewing changes
-=================
-
-Looking before you leap
------------------------
-
-Once you have completed some work, it's a good idea to review your changes
-prior to permanently recording it. This way, you can make sure you'll be
-committing what you intend to.
-
-Two bzr commands are particularly useful here: **status** and **diff**.  
-
-bzr status
-----------
-
-The **status** command tells you what changes have been made to the
-working directory since the last revision::
-
-    % bzr status
-    modified:
-       foo
-
-``bzr status`` hides "boring" files that are either unchanged or ignored.
-The status command can optionally be given the name of some files or
-directories to check.
-
-bzr diff
---------
-
-The **diff** command shows the full text of changes to all files as a
-standard unified diff.  This can be piped through many programs such as
-''patch'', ''diffstat'', ''filterdiff'' and ''colordiff''::
-
-    % bzr diff
-    === added file 'hello.txt'
-    --- hello.txt   1970-01-01 00:00:00 +0000
-    +++ hello.txt   2005-10-18 14:23:29 +0000
-    @@ -0,0 +1,1 @@
-    +hello world
-
-
-With the ``-r`` option, the tree is compared to an earlier revision, or
-the differences between two versions are shown::
-
-    % bzr diff -r 1000..          # everything since r1000
-    % bzr diff -r 1000..1100      # changes from 1000 to 1100
-
-The ``--diff-options`` option causes bzr to run the external diff program,
-passing options.  For example::
-
-    % bzr diff --diff-options --side-by-side foo
-
-Some projects prefer patches to show a prefix at the start of the path
-for old and new files.  The ``--prefix`` option can be used to provide
-such a prefix.
-As a shortcut, ``bzr diff -p1`` produces a form that works with the 
-command ``patch -p1``.
-

=== removed file 'doc/en/user-guide/sending_changes.txt'
--- doc/en/user-guide/sending_changes.txt	2008-04-24 01:27:26 +0000
+++ doc/en/user-guide/sending_changes.txt	1970-01-01 00:00:00 +0000
@@ -1,71 +0,0 @@
-Sending changes
-===============
-
-Motivation
-----------
-
-In many distributed development scenarios, it isn't always feasible for
-developers to share task branches by advertising their URLs.
-For example, a developer working on a laptop might take it home overnight
-so his/her task branches could well be inaccessible when a gatekeeper
-in another timezone wants to review or merge it.
-
-Bazaar provides a neat feature to assist here: *merge directives*.
-
-Understanding merge directives
-------------------------------
-
-You can think of a merge directive as a "mini branch" - just the
-new growth on a branch since it was created. It's a software
-patch showing what's new but with added intelligence: metadata
-like interim commits, renames and digital signatures.
-
-Another useful metaphor is a packet cake: a merge directive has a recipe
-together with the ingredients you need bundled inside it.
-To stretch the metaphor, the ingredients are all the metadata on the
-changes made to the branch; the recipe is instructions on how those
-changes ought to be merged, i.e. information for the ``merge`` command
-to use in selecting common ancestors.
-
-Regardless of how you think of them, merge directives are neat.
-They are easy to create, suitable for mailing around as attachments
-and can be processed much like branches can on the receiving end.
-
-Creating a merge directive
---------------------------
-
-To create and optionally send a merge directive, use the ``send`` command. 
-
-By default, ``send`` will email the merge directive to the "submission
-address" for the branch, which is typically the lead developer or the
-development mailing list.  
-``send`` without options will create a merge directive, fire up your email
-tool and attach it, ready for you to add the explanatory text bit.
-(See the online help for ``send`` and
-`Configuration Settings <../user-reference/bzr_man.html#configuration-settings>`_
-in the User Reference for further details on how to configure this.)
-
-Most projects like people to add some explanation to the mail along with
-the patch, explaining the reason for the patch, and why it is done the way
-it is.  This gives a reviewer some context before going into the
-line-by-line diff.
-
-Alternatively, if the ``--output`` (or ``-o``) option is given, ``send``
-will write the merge directive to a file, so you can mail it yourself,
-examine it, or save it for later use.  If an output file of ``-`` is
-given, the directive is written to stdout.  For example::
-
-  cd X-fix-123
-  bzr send -o ../fix-123.patch
-
-
-Applying a merge directive
---------------------------
-
-Merge directives can be applied in much the same way as branches: by
-using the ``merge`` and ``pull`` commands.
-
-They can also be useful when communicating with upstream projects
-that don't use Bazaar. In particular, the preview of the overall
-change in a merge directive looks like a vanilla software patch, so
-they can be applied using ``patch -p0`` for example.

=== modified file 'doc/en/user-guide/server.txt'
--- doc/en/user-guide/server.txt	2007-12-14 07:35:49 +0000
+++ doc/en/user-guide/server.txt	2007-08-29 09:06:07 +0000
@@ -1,12 +1,13 @@
-Running a smart server
-======================
+=======================
+Running a Bazaar Server
+=======================
 
 Bazaar does not require a specialised server because it operates over HTTP, FTP
 or SFTP.  There is an optional smart server that can be invoked over SSH, from
 inetd, or in a dedicated mode.
 
 Dumb servers
-------------
+============
 
 We describe HTTP, FTP, SFTP and HTTP-WebDAV as "dumb" servers because they do
 not offer any assistance to Bazaar.  If you make a Bazaar repository available
@@ -17,24 +18,25 @@
 
 Bazaar supports writing over FTP, SFTP and (via a plugin) over HTTP-WebDAV.
 
-High-performance smart server
------------------------------
+High-performance server
+=======================
 
-The high-performance smart server (hpss) performs certain operations much faster
-than dumb servers are capable of.  In future releases, the range of operations
-that are improved by using the smart server will increase as we continue to
-tune performance.
+The high-performance server is currently in development.  It provides a dumb
+server facility as well as additional capabilities which allow the version of
+bzr that accompanies this documentation to perform some operations much faster
+than via dumb servers.  In future releases of bzr the range of operations that
+are improved by using the high-performance server will increase.
 
 To maintain the highest security possible, the current
-smart server provides read-only access by default.  To
+high-performance server provides read-only access by default.  To
 enable read-write access, run it with ``--allow-writes``. When using
 the SSH access method, bzr automatically runs with with the
 ``--allow-writes`` option.
 
-The alternative ways of configuring a smart server are explained below.
+The server can be configured to run in three different ways:
 
 SSH
-~~~
+---
 
 Using Bazaar over SSH requires no special configuration on the server::
 
@@ -50,7 +52,7 @@
 (https://bugs.launchpad.net/bzr/+bug/109143).
 
 inetd
-~~~~~
+-----
 
 This example shows how to run `bzr` with a dedicated user `bzruser`
 for a shared repository in ``/srv/bzr/repo`` which has a branch at
@@ -66,7 +68,7 @@
     bzr log bzr://host/branchname
 
 Dedicated
-~~~~~~~~~
+---------
 
 This mode has the same path and URL behaviour as the inetd mode.  To
 run as a specific user, you should use ``su`` or login as that user.

=== modified file 'doc/en/user-guide/setting_up_email.txt'
--- doc/en/user-guide/setting_up_email.txt	2007-12-17 01:45:32 +0000
+++ doc/en/user-guide/setting_up_email.txt	2007-08-10 05:17:09 +0000
@@ -1,11 +1,12 @@
-Configuring email
-=================
+================
+Setting up email
+================
 
-.. Description of the various ways to specify to Bazaar your email address for commits.
+Description of the various ways to specify to Bazaar your email address for
+commits.
 
 Why set up an email address with Bazaar?
-----------------------------------------
-
+========================================
 Bazaar stores the specified email address in revisions when they're
 created so that people can tell who commited which revisions.  The
 email addresses are not verified, therefore they could be bogus, so
@@ -14,8 +15,7 @@
 author of a revision for credit and/or blame.  :)
 
 How to set up your email address 
---------------------------------
-
+================================
 Bazaar will try to guess an email address based on your username and the
 hostname if none is set.  This will probably not be what you want, so three
 ways exist to tell Bazaar what email to use:
@@ -30,13 +30,13 @@
 
 The order of precedence is
 
- 1. If the ``BZR_EMAIL`` environment variable is set.
+ 1. If the ``$BZR_EMAIL`` environment variable is set.
  #. If an email is set for your current branch in the ``locations.conf``
     file.
  #. If an email is set four your current branch in the
     ``.bzr/branch/branch.conf`` file.
  #. If an email is set in the ``bazaar.conf`` default configuration file.
- #. If the `EMAIL` environment variable is set.
+ #. If the `$EMAIL` environment variable is set.
  #. Bazaar will try to guess based on your username and the hostname.
 
 To check on what Bazaar thinks your current email is, use the ``whoami``
@@ -46,41 +46,37 @@
     Joe Cool <joe@example.com>
     
 Setting email via the 'whoami' command
---------------------------------------
-
+======================================
 You can use the whoami command to set your email globally::
 
-    % bzr whoami "Joe Cool <joe@example.com>"
+    % bzr whoami 'Joe Cool <joe@example.com>'
 
 or only for the current branch::
 
-    % bzr whoami --branch "Joe Cool <joe@example.com>"
+    % bzr whoami --branch 'Joe Cool <joe@example.com>'
 
 These modify your global ``bazaar.conf`` or branch ``branch.conf`` file, respectively.
 
 Setting email via default configuration file
---------------------------------------------
-
-To use the default ini file, create or edit the ``bazaar.conf`` file (in
-``~/.bazaar/`` on Linix and in ``%APPDATA%\bazaar\2.0\`` in Windows)
-and set an email address as shown below.  Please note that the word DEFAULT
-is case sensitive, and must be in upper-case.
+============================================
+To use the default ini file, create the file ``$HOME/.bazaar/bazaar.conf`` (on
+Windows this is ``%APPDATA%\bazaar\2.0\bazaar.conf``) and set an email address
+as shown below.  Please note that the word DEFAULT is case sensitive, and
+must be in upper-case.
 ::
 
     [DEFAULT]
     email=Your Name <name@isp.com>
 
 
-For more information on the ini file format, see `Configuration Settings`_ in
-the Bazaar User Reference.
-
-.. _Configuration Settings: ../user-reference/bzr_man.html#configuration-settings
+For more information on the ini file format, see ConfiguringBzr.
 
 Setting email on a per-branch basis
------------------------------------
+===================================
 
 The second approach is to set email on a branch by branch basis by
-using the ``locations.conf`` configuration file like this::
+using the ``$HOME/.bazaar/locations.conf`` configuration file,
+thusly::
 
     [/some/branch/location]
     email=Your Name <name@other-isp.com>
@@ -90,13 +86,13 @@
 
 Setting email via environment variable
 --------------------------------------
-The final method Bazaar will use is checking for the ``BZR_EMAIL``
-and ``EMAIL`` environment variables.  Generally, you would use this
+The final method Bazaar will use is checking for the ``$BZR_EMAIL``
+and ``$EMAIL`` environment variables.  Generally, you would use this
 method to override the email in a script context.  If you would like
 to set a general default, then please see the ini methods above.
 
 Concerns about spam
--------------------
+===================
 Some people want to avoid sharing their email address so as not to get
 spam.  Bazaar will never disclose your email address, unless you publish
 a branch or changeset in a public location.  It's recommended that you

=== modified file 'doc/en/user-guide/shared_repository_layouts.txt'
--- doc/en/user-guide/shared_repository_layouts.txt	2007-11-14 03:50:56 +0000
+++ doc/en/user-guide/shared_repository_layouts.txt	2007-08-10 05:17:09 +0000
@@ -1,5 +1,8 @@
-Choosing a shared repository layout
-===================================
+=======================
+SharedRepositoryLayouts
+=======================
+
+.. sectnum::
 
 Bazaar is designed to give you flexibility in how you layout branches inside a shared repository. 
 This flexibility allows users to tailor Bazaar to their workflow,
@@ -11,9 +14,11 @@
 and in most of the layouts this naming convention is preserved. Some would call this
 "``mainline``" or "``dev``", and people from CVS often refer to this as "``HEAD``".
 
+.. contents::
+
 
 "SVN-Style" (``trunk/``, ``branches/``)
----------------------------------------
+=======================================
 
 Most people coming from SVN will be familiar with their "standard" project layout. 
 Which is to layout the repository as::
@@ -125,7 +130,7 @@
 
 
 Nested Style (``project/branch/sub-branch/``)
----------------------------------------------
+=============================================
 
 Another style with Bazaar, which is not generally possible in SVN
 is to have branches nested within each-other.
@@ -197,7 +202,7 @@
 
 
 Sorted by Status (``dev/``, ``merged/``, ``experimental/``)
------------------------------------------------------------
+===========================================================
 
 One other way to break up branches is to sort them by their current status.
 So you would end up with a layout something like::
@@ -244,7 +249,7 @@
 
 
 Sorted by date/release/etc (``2006-06/``, ``2006-07/``, ``0.8/``, ``0.9``)
---------------------------------------------------------------------------
+==========================================================================
 
 Another method of allowing some scalability while also allowing the
 browsing of "current" branches. Basically, this works on the assumption 
@@ -297,7 +302,7 @@
 
 
 Simple developer naming (``project/joe/foo``, ``project/barry/bar``)
---------------------------------------------------------------------
+====================================================================
 
 Another possibly layout is to give each developer a directory, and then
 have a single sub-directory for branches. Something like::
@@ -347,7 +352,7 @@
 
 
 Summary
--------
+=======
 
 In the end, no single naming scheme will work for everyone. It depends a lot on
 the number of developers, how often you create a new branch, what sort of

=== removed file 'doc/en/user-guide/solo_intro.txt'
--- doc/en/user-guide/solo_intro.txt	2007-11-23 05:52:03 +0000
+++ doc/en/user-guide/solo_intro.txt	1970-01-01 00:00:00 +0000
@@ -1,28 +0,0 @@
-Going solo
-==========
-
-A personal productivity tool
-----------------------------
-
-Some tools are designed to make individuals productive (e.g. editors)
-while other tools (e.g. back-end services) are focussed on making teams
-or whole companies more productive. Version control tools have
-traditionally been in the latter camp.
-
-One of the cool things about Bazaar is that it is so easy to setup
-that version control can now be treated as a personal productivity tool.
-If you wish to record changes to files for the purposes of checkpointing
-good known states or tracking history, it is now easy to do so. This
-chapter explains how.
-
-The solo workflow
------------------
-
-If you are creating your own masterpiece, whether that be a software
-project or a set of related documents, the typical workflow looks like this:
-
-.. image:: images/workflows_single.png
-
-Even if you will always be working as part of a team, the tasks covered
-in this chapter will be the basis of what you'll be doing so it's a good
-place to start.

=== modified file 'doc/en/user-guide/specifying_revisions.txt'
--- doc/en/user-guide/specifying_revisions.txt	2007-12-14 07:35:49 +0000
+++ doc/en/user-guide/specifying_revisions.txt	2007-08-10 05:17:09 +0000
@@ -1,12 +1,19 @@
-Specifying revisions
-====================
-
-Revision identifiers and ranges
--------------------------------
-
-Bazaar has a very expressive way to specify a revision or a range of revisions.
-To specify a range of revisions, the upper and lower bounds are separated by the
-``..`` symbol. For example::
+=============================
+Specifying revision in Bazaar
+=============================
+
+Description of the subarguments for ``-r`` as used by commands such as
+``bzr log`` and ``bzr merge``.
+
+You can get the online documentation with ``bzr help revisionspec``.
+
+Revision specs and ranges
+=========================
+
+``bzr`` has a very expressive way to specify a revision, or a range of revisions.
+We'll take the example of the ``log`` command.
+
+To specify a range of revisions, use for example::
 
     $ bzr log -r 1..4
 
@@ -15,21 +22,17 @@
     $ bzr log -r 1..
     $ bzr log -r ..4
 
-Some commands take only one revision, not a range. For example::
+Note:
+    Omitting the lower bound doesn't work on versions of ``bzr`` prior to 0.14.
+
+Other commands, like ``bzr cat`` take only one revision, not a range, like::
 
     $ bzr cat -r 42 foo.c
 
-In other cases, a range is required but you want the length of the range to
-be one. For commands where this is relevant, the ``-c`` option is used like this::
-
-    $ bzr diff -c 42
-
-
-Available revision identifiers
-------------------------------
-
-The revision, or the bounds of the range, can be given using
-different format specifications as shown below.
+Available revision specs
+========================
+
+The revision, or the bounds of the range, can be one of
 
  +----------------------+------------------------------------+
  |  argument type       | description                        |
@@ -46,23 +49,13 @@
  +----------------------+------------------------------------+
  | **date**:*value*     | first entry after a given date     |
  +----------------------+------------------------------------+
- | **tag**:*value*      | revision matching a given tag      |
- +----------------------+------------------------------------+
  | **ancestor**:*path*  | last merged revision from a branch |
  +----------------------+------------------------------------+
  | **branch**:*path*    | latest revision on another branch  |
  +----------------------+------------------------------------+
- | **submit**:*path*    | common ancestor with submit branch |
- +----------------------+------------------------------------+
-
-A brief introduction to some of these formats is given below.
-For complete details, see `Revision Identifiers`_ in the
-Bazaar User Reference.
-
-.. _Revision Identifiers: ../user-reference/bzr_man.html#revision-identifiers
 
 Numbers
-~~~~~~~
+-------
 
 Positive numbers denote revision numbers in the current branch. Revision
 numbers are labelled as "revno" in the output of ``bzr log``.  To display
@@ -77,8 +70,17 @@
 
     $ bzr log -r -10..
 
+revno, last
+-----------
+
+**revno**:*number*
+    The same as *number*, except that negative numbers are not allowed.
+
+**last**:*number*
+    The same as -''number''. **last:1** means the last commited revision.
+
 revid
-~~~~~
+-----
 
 **revid** allows specifying a an internal revision ID, as shown by ``bzr
 log`` and some other commands.
@@ -87,8 +89,9 @@
 
     $ bzr log -r revid:Matthieu.Moy@imag.fr-20051026185030-93c7cad63ee570df
 
+
 before
-~~~~~~
+------
 
 **before**
     ''rev'' specifies the leftmost parent of ''rev'', that is the revision
@@ -105,7 +108,7 @@
     ...
 
 date
-~~~~
+----
 
 **date**
     ''value'' matches the first history entry after a given date, either at
@@ -125,7 +128,7 @@
     $ bzr log -r date:yesterday..date:today
 
 Ancestor
-~~~~~~~~
+--------
 
 **ancestor**:*path*
     specifies the common ancestor between the current branch and a 
@@ -140,7 +143,7 @@
     $ bzr diff -r ancestor:../parent
 
 Branch
-~~~~~~
+------
 
 branch
    ``path`` specifies the latest revision in another branch.

=== removed file 'doc/en/user-guide/stacked.txt'
--- doc/en/user-guide/stacked.txt	2008-07-17 06:00:08 +0000
+++ doc/en/user-guide/stacked.txt	1970-01-01 00:00:00 +0000
@@ -1,85 +0,0 @@
-Using stacked branches
-======================
-
-What is a stacked branch?
--------------------------
-
-A stacked branch is a branch that knows how to find revisions
-in another branch. Stacked branches store just the
-unique revisions, making them faster to create and more
-storage efficient. In these respects, stacked branches are
-similar to shared repositories. However, stacked branches have
-additional benefits:
-
-* The new branch can be in a completely different location to the
-  branch being stacked on.
-
-* Deleting the stacked branch really deletes the revisions (rather
-  than leaving them in a shared repository).
-
-* Security is improved over shared repositories, because the stacked-on
-  repository can be physically readonly to developers committing to stacked 
-  branches.
-
-These benefits make stacked branches ideal for various scenarios
-including experimental branches and code hosting sites.
-
-
-Creating a stacked branch
--------------------------
-
-To create a stacked branch, use the ``stacked`` option of the branch command.
-For example::
-
-  bzr branch --stacked source-url my-dir
-
-This will create ``my-dir`` as a stacked branch with no local revisions.
-If it is defined, the public branch associated with ``source-url`` will be
-used as the *stacked-on* location. Otherwise, ``source-url`` will be the
-*stacked-on* location.
-
-
-Creating a stacked checkout
----------------------------
-
-Direct creation of a stacked checkout is expected to be supported soon.
-In the meantime, a two step process is required:
-
-1. Create a stacked branch as shown above.
-
-2. Convert the branch into a checkout using either the ``reconfigure``
-   or ``bind`` command.
-
-
-Pushing a stacked branch
-------------------------
-
-Most changes on most projects build on an existing branch such as the
-*development trunk* or *current stable* branch. Creating a new
-branch stacked on one of these is easy to do using the ``push``
-command like this::
-
-  bzr push --stacked-on reference-url my-url
-
-This creates a new branch at ``my-url`` that is stacked on ``reference-url``
-and only contains the revisions in the current branch that are not already
-in the branch at ``reference-url``.
-
-If the local branch was created as a stacked branch, then you can
-use the ``--stacked`` option to ``push`` and the *stacked-on* location
-will be implicit. For example::
-
-  bzr branch --stacked source-url my-dir
-  cd my-dir
-  (hack, hack, hack)
-  bzr commit -m "fix bug"
-  bzr push --stacked
-
-
-Limitations of stacked branches
--------------------------------
-
-The important thing to remember about a stacked branch is that the
-stacked-on branch needs to be available for almost all operations. This is
-not an issue when both branches are local or both branches are on the
-same server.

=== removed file 'doc/en/user-guide/starting_a_project.txt'
--- doc/en/user-guide/starting_a_project.txt	2007-11-27 21:17:06 +0000
+++ doc/en/user-guide/starting_a_project.txt	1970-01-01 00:00:00 +0000
@@ -1,55 +0,0 @@
-Starting a project
-==================
-
-Putting an existing project under version control
--------------------------------------------------
-
-If you already have a tree of source code (or directory of documents) you
-wish to put under version control, here are the commands to use::
-
-  cd my-stuff
-  bzr init
-  bzr add
-  bzr commit -m "Initial import"
-
-``bzr init`` creates a ``.bzr`` directory in the top level directory
-(``my-stuff`` in the example above). Note that:
-
- * Bazaar has everything it needs in that directory - you do
-   **not** need to setup a database, web server or special service
-   to use it
-
- * Bazaar is polite enough to only create one ``.bzr`` in the
-   directory given, not one in every subdirectory thereof.
-
-``bzr add`` then finds all the files and directories it thinks
-ought to be version controlled and registers them internally.
-``bzr commit`` then records a snapshot of the content of these
-and records that information, together with a commit message.
-
-More information on ``init``, ``add`` and ``commit`` will be provided
-later. For now, the important thing to remember is the recipe above.
-
-Starting a new project
-----------------------
-
-If you are starting a project from scratch, you can also use the recipe
-above, after creating an empty directory first of course. For efficiency
-reasons that will be explored more in later chapters though, it is a good
-idea to create a repository for the project at the top level and to nest
-a *main* branch within it like this::
-
-  bzr init-repo my.repo
-  cd my.repo
-  bzr init my.main
-  cd my.main
-  hack, hack, hack
-  bzr add
-  bzr commit -m "Initial import"
-
-Some users prefer a name like *trunk* or *dev* to *main*. Choose
-whichever name makes the most sense to you.
-
-Note that the ``init-repo`` and ``init`` commands both take a path as an
-argument and will create that path if it doesn't already exist.
-

=== removed file 'doc/en/user-guide/svn_plugin.txt'
--- doc/en/user-guide/svn_plugin.txt	2008-05-19 12:41:38 +0000
+++ doc/en/user-guide/svn_plugin.txt	1970-01-01 00:00:00 +0000
@@ -1,123 +0,0 @@
-bzr-svn
-=======
-
-Overview
---------
-
-bzr-svn lets developers use Bazaar as their VCS client on projects
-still using a central Subversion repository. Access to Subversion
-repositories is largely transparent, i.e. you can use most ``bzr``
-commands directly on Subversion repositories exactly the same
-as if you were using ``bzr`` on native Bazaar branches.
-
-Many bzr-svn users create a local mirror of the central Subversion
-trunk, work in local feature branches, and submit their
-overall change back to Subversion when it is ready
-to go. This lets them gain many of the advantages of distributed
-VCS tools without interrupting existing team-wide processes and
-tool integration hooks currently built on top of Subversion. Indeed,
-this is a common interim step for teams looking to adopt Bazaar but
-who are unable to do so yet for timing or non-technical reasons.
-
-For installation instructions, see the bzr-svn home page:
-http://bazaar-vcs.org/BzrForeignBranches/Subversion.
-
-
-A simple example
-----------------
-
-Here's a simple example of how you can use bzr-svn to hack on a
-GNOME project like **beagle**. Firstly, setup a local shared repository
-for storing your branches in and checkout the trunk::
-
-  bzr init-repo --rich-root-pack beagle-repo
-  cd beagle-repo
-  bzr checkout svn+ssh://svn.gnome.org/svn/beagle/trunk beagle-trunk
-
-Note that using the ``rich-root-pack`` option to ``init-repo`` is
-important as bzr-svn requires some extra metadata not yet supported in Bazaar's
-default repository format. Next, create a feature branch and hack away::
-
-  bzr branch beagle-trunk beagle-feature1
-  cd beagle-feature1
-  *changes*
-  bzr commit -m "blah blah blah"
-  *changes*
-  bzr commit -m "blah blah blah"
-
-When the feature is cooked, refresh your trunk mirror and merge
-your change::
-
-  cd ../beagle-trunk
-  bzr update
-  bzr merge ../beagle-feature1
-  bzr commit -m "Complete comment for SVN commit"
-
-As your trunk mirror is a checkout, committing to it implicitly
-commits to the real Subversion trunk. That's it!
-
-
-Using a central repository mirror
----------------------------------
-
-For large projects, it often makes sense to tweak the recipe given above.
-In particular, the initial checkout can get quite slow so you may wish
-to import the Subversion repository into a Bazaar one once and for all
-for your project, and then branch from that native Bazaar repository
-instead. bzr-svn provides the ``svn-import`` command for doing this
-repository-to-repository conversion. Here's an example of how to use it::
-
-  bzr init-repo --rich-root-pack beagle.bzr
-  cd beagle.bzr
-  bzr svn-import svn+ssh://svn.gnome.org/svn/beagle
-
-Here's the recipe from above updated to use a central Bazaar mirror::
-
-  bzr init-repo --rich-root-pack beagle-repo
-  cd beagle-repo
-  bzr branch bzr+ssh://bzr.gnome.org/beagle.bzr/trunk beagle-trunk
-  bzr branch beagle-trunk beagle-feature1
-  cd beagle-feature1
-  *changes*
-  bzr commit -m "blah blah blah"
-  *changes*
-  bzr commit -m "blah blah blah"
-  cd ../beagle-trunk
-  bzr pull
-  bzr merge ../beagle-feature1
-  bzr commit -m "Complete comment for SVN commit"
-  bzr push
-
-In this case, committing to the trunk only commits the merge locally.
-To commit back to the master Subversion trunk, an additional command
-(``bzr push``) is required.
-
-Note: You'll need to give ``pull`` and ``push`` the relevant URLs
-the first time you use those commands in the trunk branch. After that,
-bzr remembers them.
-
-The final piece of the puzzle in this setup is to put scripts in
-place to keep the central Bazaar mirror synchronized with the Subversion
-one. This can be done by adding a cron job, using a Subversion hook,
-or whatever makes sense in your environment.
-
-
-Limitations of bzr-svn
-----------------------
-
-Bazaar and Subversion are different tools with different capabilities
-so there will always be some limited interoperability issues.
-Here are some examples current as of bzr-svn 0.4.10:
-
- * Bazaar doesn't support versioned properties
-
- * Bazaar doesn't support tracking of file copies.
-
- * ``bzr push`` to an existing Subversion branch works but 
-   ``bzr push`` to a new Subversion branch doesn't. Until
-   the relevant bug is fixed (#121875), you need to use
-   ``bzr svn-push`` in the latter case.
-
-See the bzr-svn web page,
-http://bazaar-vcs.org/BzrForeignBranches/Subversion,
-for the current list of constraints.

=== renamed file 'doc/en/tutorials/tutorial.txt' => 'doc/en/user-guide/tutorial.txt'
--- doc/en/tutorials/tutorial.txt	2007-11-28 00:07:56 +0000
+++ doc/en/user-guide/tutorial.txt	2007-08-24 16:49:00 +0000
@@ -109,11 +109,12 @@
 Bazaar installs a single new command, **bzr**.  Everything else is a
 subcommand of this.  You can get some help with ``bzr help``. Some arguments 
 are grouped in topics: ``bzr help topics`` to see which topics are available.
+There will be more in the future.
 
 One function of a version control system is to keep track of who changed
 what.  In a decentralized system, that requires an identifier for each
 author that is globally unique.  Most people already have one of these: an
-email address. Bazaar is smart enough to automatically generate an email
+email address. Bzr is smart enough to automatically generate an email
 address by looking up your username and hostname. If you don't like the
 guess that Bazaar makes, then three options exist:
 
@@ -159,9 +160,8 @@
 
 History is by default stored in the .bzr directory of the branch. In a
 future version of Bazaar, there will be a facility to store it in a
-separate repository, which may be remote.
-
-We create a new branch by running ``bzr init`` in an existing directory::
+separate repository, which may be remote.  We create a new branch by
+running ``bzr init`` in an existing directory::
 
     % mkdir tutorial
     % cd tutorial

=== removed file 'doc/en/user-guide/undoing_mistakes.txt'
--- doc/en/user-guide/undoing_mistakes.txt	2008-09-03 21:29:15 +0000
+++ doc/en/user-guide/undoing_mistakes.txt	1970-01-01 00:00:00 +0000
@@ -1,163 +0,0 @@
-Undoing mistakes
-================
-
-Mistakes happen
----------------
-
-Bazaar has been designed to make it easy to
-recover from mistakes as explained below.
-
-Dropping the revision history for a project
--------------------------------------------
-
-If you accidently put the wrong tree under version control, simply
-delete the ``.bzr`` directory.
-
-Deregistering a file or directory
----------------------------------
-
-If you accidently register a file using ``add`` that you
-don't want version controlled, you can use the ``remove``
-command to tell Bazaar to forget about it.
-
-``remove`` has been designed to *Do the Safe Thing* in
-that it will not delete a modified file. For example::
-
-  bzr add foo.html
-  (oops - didn't mean that)
-  bzr remove foo.html
-
-This will complain about the file being modified or unknown.
-If you want to keep the file, use the ``--keep`` option.
-Alternatively, if you want to delete the file, use the ``--force`` option.
-For example::
-
-  bzr add foo.html
-  (oops - didn't mean that)
-  bzr remove --keep foo.html
-  (foo.html left on disk, but deregistered)
-
-On the other hand, the unchanged ``TODO`` file is deregistered and
-removed from disk without complaint in this example::
-
-  bzr add TODO
-  bzr commit -m "added TODO"
-  (hack, hack, hack - but don't change TODO)
-  bzr remove TODO
-  (TODO file deleted)
-
-Note: If you delete a file using your file manager, IDE or via an operating
-system command, the ``commit`` command will implicitly treat it as removed.
-
-Undoing changes since the last commit
--------------------------------------
-
-One of the reasons for using a version control tool is that it
-lets you easily checkpoint good tree states while working. If you
-decide that the changes you have made since the last ``commit`` ought
-to be thrown away, the command to use is ``revert`` like this::
-
-  bzr revert
-
-As a precaution, it is good practice to use ``bzr status`` and
-``bzr diff`` first to check that everything being thrown away
-really ought to be.
-
-Undoing changes to a file since the last commit
------------------------------------------------
-
-If you want to undo changes to a particular file since the last commit but
-keep all the other changes in the tree, pass the filename as an argument
-to ``revert`` like this::
-
-  bzr revert foo.py
-
-Undoing the last commit
------------------------
-
-If you make a commit and really didn't mean to, use the ``uncommit`` command
-to undo it like this::
-
-  bzr uncommit
-
-Unlike ``revert``, ``uncommit`` leaves the content of your working tree
-exactly as it is. That's really handy if you make a commit and accidently
-provide the wrong error message. For example::
-
-  bzr commit -m "Fix bug #11"
-  (damn - wrong bug number)
-  bzr uncommit
-  bzr commit -m "Fix bug #1"
-
-Another common reason for undoing a commit is because you forgot to add
-one or more files. Some users like to alias ``commit`` to ``commit --strict``
-so that commits fail if unknown files are found in the tree.
-
-Note: While the ``merge`` command is not introduced until the next
-chapter, it is worth noting now that ``uncommit`` restores any pending
-merges. (Running ``bzr status`` after ``uncommit`` will show these.)
-``merge`` can also be used to effectively undo just a selected commit
-earlier in history. For more information on ``merge``, see `Merging changes`_
-in the next chapter and the Bazaar User Reference.
-
-Undoing multiple commits
-------------------------
-
-You can use the -r option to undo several commits like this::
-
-  bzr uncommit -r -3
-
-If your reason for doing this is that you really want to
-back out several changes, then be sure to remember that ``uncommit``
-does not change your working tree: you'll probably need to run the
-``revert`` command as well to complete the task. In many cases though,
-it's arguably better to leave your history alone and add a new
-revision reflecting the content of the last good state.
-
-Reverting to the state of an earlier version
---------------------------------------------
-
-If you make an unwanted change but it doesn't make sense to uncommit
-it (because that code has been released to users say), you can use
-``revert`` to take your working tree back to the desired state.
-For example::
-
-  % bzr commit "Fix bug #5"
-  Committed revision 20.
-  (release the code)
-  (hmm - bad fix)
-  bzr revert -r 19
-  bzr commit -m "Backout fix for bug #5"
-
-This will change your entire tree back to the state as of revision 19,
-which is probably only what you want if you haven't made any new commits
-since then. If you have, the ``revert`` would wipe them out as well. In that
-case, you probably want to use `Reverse cherrypicking`_ instead to
-back out the bad fix.
-
-Note: As an alternative to using an absolute revision number (like 19), you can
-specify one relative to the tip (-1) using a negative number like this::
-
-  bzr revert -r -2
-
-Correcting a tag
-----------------
-
-If you have defined a tag prematurely, use the ``--force`` option of
-the ``tag`` command to redefine it. For example::
-
-  bzr tag 2.0-beta-1
-  (oops, we're not yet ready for that)
-  (make more commits to include more fixes)
-  bzr tag 2.0-beta-1 --force
-
-Clearing a tag
---------------
-
-If you have defined a tag and no longer want it defined, use the
-``--delete`` option of the ``tag`` command to remove it. For example::
-
-  bzr tag 2.0-beta-4
-  (oops, we're not releasing a 4th beta)
-  bzr tag 2.0-beta-4 --delete
-

=== modified file 'doc/en/user-guide/using_aliases.txt'
--- doc/en/user-guide/using_aliases.txt	2007-11-30 04:28:32 +0000
+++ doc/en/user-guide/using_aliases.txt	2007-08-10 05:17:09 +0000
@@ -1,18 +1,18 @@
-Using aliases
-=============
-
-What are aliases?
------------------
-
-Aliases are an easy way to create shortcuts for commonly-typed commands, or to set
+=================================
+Using aliases for Bazaar commands
+=================================
+
+Command aliases are an easy way to customize the behaviour of Bazaar. Aliases
+are an easy way to create shortcuts for commonly-typed commands, or to set
 defaults for commands.
 
-Defining aliases
-----------------
-
 Command aliases can be defined in the ``[ALIASES]`` section of your
-``bazaar.conf`` file. Aliases start with the alias name, then an
-equal sign, then a command fragment.  Here's an example ALIASES section::
+``.bazaar/bazaar.conf`` file. Aliases start with the alias name, then an
+equal sign, then a command fragment.  Here's an example ALIASES section:
+
+Examples
+========
+A typical example::
 
     [ALIASES]
     recentlog=log -r-3..-1
@@ -20,7 +20,8 @@
     commit=commit --strict
     diff=diff --diff-options -p
 
-Here are the explanations of the examples above:
+Explanation of examples
+=======================
 
  * The first alias makes a new ``recentlog`` command that shows the logs for the
    last three revisions
@@ -29,9 +30,8 @@
    files in the tree are not recognized.
  * the ``diff`` alias adds the coveted -p option to diff
 
-Using the aliases
------------------
-
+Using the Aliases
+=================
 The aliases defined above would be used like so: ::
 
    % bzr recentlog
@@ -39,8 +39,8 @@
    % bzr commit
    % bzr diff
 
-Rules for aliases
------------------
+Rules for Aliases
+=================
 
  * You can override a portion of the options given in an alias by
    specifying the new part on the command-line.  For example, if
@@ -52,12 +52,10 @@
  * Aliases can override the standard behaviour of existing commands by giving
    an alias name that is the same as the orignal command. For example, default
    commit is changed with ``commit=commit --strict``.
-
  * Aliases cannot refer to other aliases. In other words making a
    ``lastlog`` alias and referring to it with a ``ll`` alias will not work.
-   This includes aliases that override standard commands.
-
- * Giving the ``--no-aliases`` option to the bzr command will tell it to ignore aliases
+   This includes aliases that override standard commands
+ * Giving the ``--no-aliases`` to the bzr command will tell it to ignore aliases
    for that run. For example, running ``bzr --no-aliases commit`` will perform a
-   standard commit instead, not do a ``commit --strict``.
+   standard commit instead not do a ``commit --strict``.
 

=== removed file 'doc/en/user-guide/using_checkouts.txt'
--- doc/en/user-guide/using_checkouts.txt	2007-11-23 05:52:03 +0000
+++ doc/en/user-guide/using_checkouts.txt	1970-01-01 00:00:00 +0000
@@ -1,93 +0,0 @@
-Using checkouts
-===============
-
-Turning a branch into a checkout
---------------------------------
-
-If you have a local branch and wish to make it a checkout, use the
-``bind`` command like this::
-
-  bzr bind sftp://centralhost/srv/bzr/X-repo/X-trunk
-
-This is necessary, for example, after creating a central branch using
-``push`` as illustrated in the previous section.
-
-After this, commits will be applied to the bound branch before
-being applied locally.
-
-Turning a checkout into a branch
---------------------------------
-
-If you have a checkout and wish to make it a normal branch, use the
-``unbind`` command like this::
-
-  bzr unbind
-
-After this, commits will only be applied locally.
-
-Getting a checkout
-------------------
-
-When working in a team using a central branch, one person needs
-to provide some initial content as shown in the previous section.
-After that, each person should use the ``checkout`` command to
-create their local checkout, i.e. the sandbox in which they
-will make their changes.
-
-Unlike Subversion and CVS, in Bazaar the ``checkout`` command creates a
-local full copy of history in addition to creating a working tree holding
-the latest content. This means that operations such as ``diff`` and ``log``
-are fast and can still be used when disconnected from the central location.
-
-Getting a lightweight checkout
-------------------------------
-
-While Bazaar does its best to efficiently store version history, there
-are occasions when the history is simply not wanted. For example, if your
-team is managing the content of a web site using Bazaar with a
-central repository, then your release process might be as simple as
-updating a checkout of the content on the public web server. In this
-case, you probably don't want the history downloaded to that location
-as doing so:
-
- * wastes disk space holding history that isn't needed there
- * exposes a Bazaar branch that you may want kept private.
-
-To get a history-less checkout in Bazaar, use the ``--lightweight``
-option like this::
-
-  bzr checkout --lightweight sftp://centralhost/srv/bzr/X-repo/X-trunk
-
-Of course, many of the benefits of a normal checkout are lost by doing
-this but that's a tradeoff you can make if and when it makes sense.
-
-Note: If your code base is really large and disk space on your computer
-is limited, lightweight checkouts may be the right choice for you.
-Be sure to consider all your options though including shared repositories
-and `Reusing a checkout`_ as explained later.
-
-Updating to the latest content
-------------------------------
-
-One of the important aspects of working in lockstep with others is
-keeping your checkout up to date with the latest changes made to
-the central branch. Just as you would in Subversion or CVS, you do
-this in Bazaar by using the ``update`` command like this::
-
-  bzr update
-
-This gets any new revisions available in the bound branch and
-merges your local changes, if any.
-
-Handling commit failures
-------------------------
-
-Note that your checkout *must* be up to date with the bound branch
-before running ``commit``. Bazaar is actually stricter about this
-than Subversion or CVS - you need to be up to date with the full
-tree, not just for the files you've changed. Bazaar will ask you
-to run ``update`` if it detects that a revision has been added to
-the central location since you last updated.
-
-If the network connection to the bound branch is lost, the commit will
-fail. Some alternative ways of working around that are outlined next.

=== removed file 'doc/en/user-guide/using_gatekeepers.txt'
--- doc/en/user-guide/using_gatekeepers.txt	2007-11-23 15:45:20 +0000
+++ doc/en/user-guide/using_gatekeepers.txt	1970-01-01 00:00:00 +0000
@@ -1,44 +0,0 @@
-Using gatekeepers
-=================
-
-The decentralized with human gatekeeper workflow
-------------------------------------------------
-
-In this workflow, one developer (the gatekeeper) has commit rights
-to the main branch while other developers have read-only access.
-All developers make their changes in task branches.
-
-.. image:: images/workflows_gatekeeper.png
-
-When a developer wants their work merged, they ask the gatekeeper
-to review their change and merge it if acceptable. If a change fails
-review, further development proceeds in the relevant task branch
-until it is good to go.
-
-Note that a key aspect of this approach is the inversion of control
-that is implied: developers no longer decide when to "commit/push"
-changes into the central branch: the code base evolves by gatekeepers
-"merging/pulling" changes in a controlled manner. It's perfectly
-acceptable, indeed common, to have multiple central branches with
-different gatekeepers, e.g. one branch for the current production
-release and another for the next release. In this case, a task branch
-holding a bug fix will most likely be advertized to both gatekeepers.
-
-One of the great things about this workflow is that it is hugely
-scalable. Large projects can be broken into teams and each
-team can have a *local master branch* managed by a gatekeeper.
-Someone can be appointed as the primary gatekeeper to merge
-changes from the team master branches into the primary master
-branch when team leaders request it.
-
-The decentralized with automatic gatekeeper workflow
-----------------------------------------------------
-
-To obtain even higher quality, all developers can be required to
-submit changes to an automated gatekeeper that only merges and
-commits a change if it passes a regression test suite. One
-such gatekeeper is a software tool called PQM.
-
-.. image:: images/workflows_pqm.png
-
-For further information on PQM, see https://launchpad.net/pqm.

=== modified file 'doc/en/user-guide/version_info.txt'
--- doc/en/user-guide/version_info.txt	2008-03-13 18:51:13 +0000
+++ doc/en/user-guide/version_info.txt	2007-08-10 05:17:09 +0000
@@ -1,51 +1,25 @@
-Exporting version information
-=============================
-
-Getting the last revision number
---------------------------------
-
-If you only need the last revision number in your build scripts, you can
-use the ``revno`` command to get that value like this::
-
-  $ bzr revno
-  3104
-
-
-Getting more version information
---------------------------------
-
-The ``version-info`` command can be used to output more information
-about the latest version like this::
-
-  $ bzr version-info
-  revision-id: pqm@pqm.ubuntu.com-20071211175118-s94sizduj201hrs5
-  date: 2007-12-11 17:51:18 +0000
-  build-date: 2007-12-13 13:14:51 +1000
-  revno: 3104
-  branch-nick: bzr.dev
-
-You can easily filter that output using operating system tools or
-scripts. For example (on Linux/Unix)::
-
-  $ bzr version-info | grep ^date
-  date: 2007-12-11 17:51:18 +0000
-
-The ``--all`` option will actually dump version information about
-every revision if you need that information for more advanced
-post-processing.
-
-
-Python projects
----------------
-
-.. TODO: Figure out how to attach into ``setup.py``
+==========================
+Using ``bzr version-info``
+==========================
+
+Overview
+========
+
+This document describes ways of using ``bzr version-info`` as part of a
+build process to embed version information into a final project.
+
+
+Python Project
+==============
+
+TODO: Figure out how to attach into ``setup.py``
 
 
 If using a Makefile to build your project, you can generate the version
 information file as simply as::
 
   library/_version.py:
-        bzr version-info --format python > library/_version.py
+        bzr version-info --format=python > library/_version.py
 
 This generates a file which contains 3 dictionaries:
 
@@ -66,35 +40,8 @@
     map. This is also empty by default, and enabled only by ``--all``
     or ``--include-file-revisions``.
 
-
-Getting version info in other formats
--------------------------------------
-
-Bazaar supports a template-based method for getting version information in
-arbitrary formats.  The ``--custom`` option to ``version-info`` can be
-used by providing a ``--template`` argument that contains variables that
-will be expanded based on the status of the working tree.  For example, to
-generate a C header file with a formatted string containing the current
-revision number::
-
- bzr version-info --custom \
-      --template="#define VERSION_INFO \"Project 1.2.3 (r{revno})\"\n" \
-      > version_info.h
-
-where the ``{revno}`` will be replaced by the revision number of the
-working tree.  (If the example above doesn't work on your OS, try
-entering the command all on one line.) For more information on the
-variables that can be used in templates, see `Version Info`_ in the
-Bazaar User Reference.
-
-.. _Version Info: ../user-reference/bzr_man.html#version-info
-
-Predefined formats for dumping version information in specific languages
-are currently in development. Please contact us on the mailing list about
-your requirements in this area.
-
-Check clean
------------
+Check Clean
+===========
 
 Most information about the contents of the project can be cheaply
 determined by just reading the revision entry. However, it can be useful

=== removed file 'doc/en/user-guide/web_browsing.txt'
--- doc/en/user-guide/web_browsing.txt	2008-05-16 21:00:25 +0000
+++ doc/en/user-guide/web_browsing.txt	1970-01-01 00:00:00 +0000
@@ -1,20 +0,0 @@
-Web browsing
-============
-
-Overview
---------
-
-There are a range of options available for providing a web view of a
-Bazaar repository. In increasing order of complexity, these are:
-
-* bzrweb
-* webserve
-* Loggerhead
-
-The first two tools are lightweight and easy to install.
-Loggerhead takes more effort to setup but provides more functionality.
-See http://bazaar-vcs.org/WebInterface for the latest information on
-these packages including download links.
-
-Note: If your project is hosted or mirrored on Launchpad,
-Loggerhead code browsing is provided as part of the service.

=== removed file 'doc/en/user-guide/working_offline_central.txt'
--- doc/en/user-guide/working_offline_central.txt	2007-12-04 12:56:31 +0000
+++ doc/en/user-guide/working_offline_central.txt	1970-01-01 00:00:00 +0000
@@ -1,54 +0,0 @@
-Working offline on a central branch
-===================================
-
-The centralized with local commits workflow
--------------------------------------------
-
-If you lose your network connection because you are travelling, the central
-server goes down, or you simply want to snapshot changes locally without
-publishing them centrally just yet, this workflow is for you.
-
-.. image:: images/workflows_localcommit.png
-
-Committing locally
-------------------
-
-If you're working in a checkout and need/wish to commit locally only,
-add the ``--local`` option to the ``commit`` command like this::
-
-  bzr commit --local
-
-Being disconnected for long time periods
-----------------------------------------
-
-If you will be or want to be disconnected from the bound branch for
-a while, then remembering to add ``--local`` to every ``commit`` command
-can be annoying. An alternative is to use the ``unbind`` command to
-make the checkout temporarily into a normal branch followed by the
-``bind`` command at some later point in time when you want to
-keep in lockstep again.
-
-Note that the ``bind`` command remembers where you were bound to
-last time this branch was a checkout so it isn't necessary to enter
-the URL of the remote branch when you use ``bind`` after an earlier
-``unbind``.
-
-Merging a series of local commits
----------------------------------
-
-When you make commits locally independent of ongoing development
-on a central branch, then Bazaar treats these as two lines of
-development next time you ``update``. In this case, ``update``
-does the following:
-
- * it brings the latest revisions from the bound branch down and
-   makes that the mainline of development within your checkout
-
- * it moves your local changes since you last updated into a logical
-   parallel branch
-
- * it merges these together so that your local changes are reported
-   as a pending merge by ``status``.
-
-As always, you will need to run ``commit`` after this to send your
-work to the central branch.

=== removed file 'doc/en/user-guide/writing_a_plugin.txt'
--- doc/en/user-guide/writing_a_plugin.txt	2007-11-14 03:50:56 +0000
+++ doc/en/user-guide/writing_a_plugin.txt	1970-01-01 00:00:00 +0000
@@ -1,44 +0,0 @@
-Writing a plugin
-================
-
-Introduction
-------------
-
-Plugins are very similar to bzr core functionality.  They can import
-anything in bzrlib.  A plugin may simply override standard functionality,
-but most plugins supply new commands.
-
-Creating a new command
-----------------------
-
-To create a command, make a new object that derives from
-``bzrlib.commands.Command``, and name it ``cmd_foo``, where foo is the name of
-your command.  If you create a command whose name contains an underscore,
-it will appear in the UI with the underscore turned into a hyphen.  For
-example, `cmd_baz_import` will appear as `baz-import`.  For examples of how
-to write commands, please see ``builtins.py``.
-
-Once you've created a command you must register the command with
-``bzrlib.commands.register_command(cmd_foo)``.  You must register the
-command when your file is imported, otherwise bzr will not see it.
-
-Plugin searching rules
-----------------------
-
-Bzr will scan ``bzrlib/plugins`` and ``~/.bazaar/plugins`` for plugins
-by default.  You can override this with ``BZR_PLUGIN_PATH``.  Plugins
-may be either modules or packages.  If your plugin is a single file,
-you can structure it as a module.  If it has multiple files, or if you
-want to distribute it as a bzr branch, you should structure it as a
-package, i.e. a directory with an ``__init__.py`` file.
-
-More information
-----------------
-
-Please feel free to contribute your plugin to BzrTools, if you think it
-would be useful to other people.
-
-See the `Bazaar Developer Guide`_ for details on Bazaar's development
-guidelines and policies.
-
-.. _Bazaar Developer Guide: ../developer-guide/HACKING.html

=== removed file 'doc/en/user-guide/zen.txt'
--- doc/en/user-guide/zen.txt	2008-06-06 11:55:58 +0000
+++ doc/en/user-guide/zen.txt	1970-01-01 00:00:00 +0000
@@ -1,216 +0,0 @@
-Bazaar Zen
-==========
-
-Grokking Bazaar
----------------
-
-While Bazaar is similar to other VCS tools in many ways, there are
-some important differences that are not necessarily obvious at first
-glance.  This section attempts
-to explain some of the things users need to know in order to "grok" Bazaar,
-i.e. to deeply understand it.
-
-Note: It isn't necessary to fully understand this section to use Bazaar.
-You may wish to skim this section now and come back to it at a later time.
-
-Understanding revision numbers
-------------------------------
-
-All revisions in the mainline of a branch have a simple increasing
-integer. (First commit gets 1, 10th commit gets 10, etc.) This makes them
-fairly natural to use when you want to say "grab the 10th revision from my
-branch", or "fixed in revision 3050".
-
-For revisions which have been merged into a branch, a dotted notation is used
-(e.g., 3112.1.5). Dotted revision numbers have three numbers [#]_. The first
-number indicates what mainline revision change is derived from. The second
-number is the branch counter. There can be many branches derived from the
-same revision, so they all get a unique number. The third number is the
-number of revisions since the branch started. For example, 3112.1.5 is the
-first branch from revision 3112, the fifth revision on that branch.
-
-.. [#] Versions prior to bzr 1.2 used a slightly different algorithm.
-   Some nested branches would get extra numbers (such as 1.1.1.1.1)
-   rather than the simpler 3-number system.
-
-Hierarchical history is good
-----------------------------
-
-Imagine a project with multiple developers contributing changes where
-many changes consist of a series of commits. To give a concrete example,
-consider the case where:
-
- * The tip of the project's trunk is revision 100.
- * Mary makes 3 changes to deliver feature X.
- * Bill makes 4 changes to deliver feature Y.
-
-If the developers are working in parallel and using a traditional
-centralized VCS approach, the project history will most likely be linear
-with Mary's changes and Bill's changes interleaved. It might look like this::
-
-  107: Add documentation for Y
-  106: Fix bug found in testing Y
-  105: Fix bug found in testing X
-  104: Add code for Y
-  103: Add documentation for X
-  102: Add code and tests for X
-  101: Add tests for Y
-  100: ...
-  
-Many teams use this approach because their tools make branching and merging
-difficult. As a consequence, developers update from and commit to the trunk
-frequently, minimizing integration pain by spreading it over every commit.
-If you wish, you can use Bazaar exactly like this. Bazaar does offer other
-ways though that you ought to consider.
-
-An alternative approach encouraged by distributed VCS tools is to create
-feature branches and to integrate those when they are ready. In this case,
-Mary's feature branch would look like this::
-
-  103: Fix bug found in testing X
-  102: Add documentation for X
-  101: Add code and tests for X
-  100: ...
-
-And Bill's would look like this::
-
-  104: Add documentation for Y
-  103: Fix bug found in testing Y
-  102: Add code for Y
-  101: Add tests for Y
-  100: ...
-
-If the features were independent and you wanted to keep linear history,
-the changes could be pushed back into the trunk in batches. (Technically,
-there are several ways of doing that but that's beyond the scope of
-this discussion.) The resulting history might look like this::
-
-  107: Fix bug found in testing X
-  106: Add documentation for X
-  105: Add code and tests for X
-  104: Add documentation for Y
-  103: Fix bug found in testing Y
-  102: Add code for Y
-  101: Add tests for Y
-  100: ...
-
-While this takes a bit more effort to achieve, it has some advantages over
-having revisions randomly intermixed. Better still though, branches can
-be merged together forming a non-linear history. The result might look
-like this::
-
-  102: Merge feature X
-       100.2.3: Fix bug found in testing X
-       100.2.2: Add documentation for X
-       100.2.1: Add code and tests for X
-  101: Merge feature Y
-       100.1.4: Add documentation for Y
-       100.1.3: Fix bug found in testing Y
-       100.1.2: Add code for Y
-       100.1.1: Add tests for Y
-  100: ...
-
-Or more likely this::
-
-  102: Merge feature X
-       100.2.3: Fix bug
-       100.2.2: Add documentation
-       100.2.1: Add code and tests
-  101: Merge feature Y
-       100.1.4: Add documentation
-       100.1.3: Fix bug found in testing
-       100.1.2: Add code
-       100.1.1: Add tests
-  100: ...
-
-This is considered good for many reasons:
-
- * It makes it easier to understand the history of a project.
-   Related changes are clustered together and clearly partitioned.
-
- * You can easily collapse history to see just the commits on the mainline
-   of a branch. When viewing the trunk history like this, you only see
-   high level commits (instead of a large number of commits uninteresting
-   at this level).
-
- * If required, it makes backing out a feature much easier.
-
- * Continuous integration tools can be used to ensure that
-   all tests still pass before committing a merge to the mainline.
-   (In many cases, it isn't appropriate to trigger CI tools after
-   every single commit as some tests will fail during development.
-   In fact, adding the tests first - TDD style - will guarantee it!)
-
-In summary, the important points are:
-
-  *Organize your work using branches.*
-
-  *Integrate changes using merge.*
-
-  *Ordered revision numbers and hierarchy make history easier to follow.*
-
-
-Each branch has its own view of history
----------------------------------------
-
-As explained above, Bazaar makes the distinction between:
-
- * mainline revisions, i.e. ones you committed in your branch, and
-
- * merged revisions, i.e. ones added as ancestors by committing a merge.
-
-Each branch effectively has its own view of history, i.e. different
-branches can give the same revision a different "local" revision number.
-Mainline revisions always get allocated single number revision numbers
-while merged revisions always get allocated dotted revision numbers.
-
-To extend the example above, here's what the revision history of
-Mary's branch would look like had she decided to merge the project
-trunk into her branch after completing her changes::
-
-  104: Merge mainline
-       100.2.1: Merge feature Y
-       100.1.4: Add documentation
-       100.1.3: Fix bug found in testing
-       100.1.2: Add code
-       100.1.1: Add tests
-  103: Fix bug found in testing X
-  102: Add documentation for X
-  101: Add code and tests for X
-  100: ...
-
-Once again, it's easy for Mary to look at just *her* top level of history
-to see the steps she has taken to develop this change. In this context,
-merging the trunk (and resolving any conflicts caused by doing that) is
-just one step as far as the history of this branch is concerned.
-
-It's important to remember that Bazaar is not changing history here, nor
-is it changing the global revision identifiers. You can always use the
-latter if you really want to. In fact, you can use the branch specific
-revision numbers when communicating *as long as* you provide the branch
-URL as context. (In many Bazaar projects, developers imply the central
-trunk branch if they exchange a revision number without a branch URL.)
-
-Merges do not change revision numbers in a branch, though they do
-allocate local revision numbers to newly merged revisions. The only time
-Bazaar will change revision numbers in a branch is when you explicitly
-ask it to mirror another branch.
-
-Note: Revisions are numbered in a stable way: if two branches have
-the same revision in their mainline, all revisions in the ancestry of that
-revision will have the same revision numbers. For example, if Alice and Bob's
-branches agree on revision 10, they will agree on all revisions before
-that.
-
-Summary
--------
-
-In general, if you follow the advice given earlier - organise
-your work in branches and use merge to collaborate - you'll find Bazaar
-generally does what you expect.
-
-In coming chapters, we examine various ways of using Bazaar beginning with
-the simplest: using Bazaar for personal projects.
-
-..
-   vim: ft=rst tw=74 ai

=== renamed file 'bzrlib/help_topics/en/hooks.txt' => 'doc/en/user-reference/hooks.txt'
--- bzrlib/help_topics/en/hooks.txt	2008-07-04 03:19:47 +0000
+++ doc/en/user-reference/hooks.txt	2007-09-02 05:37:08 +0000
@@ -1,58 +1,22 @@
-Hooks
-=====
-
-Introduction
-------------
-
-A hook of type *xxx* of class *yyy* needs to be registered using::
-
-  yyy.hooks.install_named_hook("xxx", ...)
-
-See `Using hooks`_ in the User Guide for examples.
-
-.. _Using hooks: ../user-guide/index.html#using-hooks
-
-The class of each hook is given immediately after each hook type below.
-
-
-post_push (Branch)
-------------------
+###############
+Hooks Reference 
+###############
+
+post_push
+#########
 
 Run after ``push`` has completed.
 
 The hook signature is (push_result), containing the members
-
-  source_branch
-    Where the data is being pushed from (read locked).
-    This should be the lowest latency branch.
-
-  target_branch
-    The direct location where data is being sent (write locked).
-
-  master_branch
-    Either target_branch, or if the target is a bound branch, it
-    will be the master location (write locked).
-
-  local_branch
-    If the target is a bound branch, this will be the target
-    branch, else it will be None.
-
-  old_revno
-    The revision number (eg 10) of the branch before the push.
-
-  old_revid
-    The revision id (eg joe@foo.com-1234234-aoeua34) before the push.
-
-  new_revno
-    The revision number (eg 12) of the branch after the push.
-
-  new_revid
-    The revision id (eg joe@foo.com-5676566-boa234a) after the push.
-
-
-post_pull (Branch)
-------------------
-
+(source, local, master, old_revno, old_revid, new_revno, new_revid)
+where local is the local target branch or None, master is the target 
+master branch, and the rest should be self-explanatory. The source
+is read-locked and the target branches are write-locked. Source will
+be the local low-latency branch.
+
+
+post_pull
+#########
 Run after ``pull`` has completed.
 
 The hook signature is (push_result) containing the members
@@ -62,21 +26,9 @@
 is read-locked and the target branches are write-locked. Source will
 be the local low-latency branch.
 
-
-start_commit (MutableTree)
---------------------------
-
-Run on the working tree before ``commit`` starts processing it.
-Unlike the ``pre_commit`` hook (see below), the ``start_commit`` hook
-can safely change the working tree.
-
-The hook signature is (tree) where tree is a MutableTree object.
-
-
-pre_commit (Branch)
--------------------
-
-Run before ``commit`` has completed.
+pre_commit
+##########
+Run prefore ``commit`` has completed.
 
 The hook signature is (local, master, old_revno, old_revid, future_revno,
 future_revid, tree_delta, future_tree) where old_revno is NULL_REVISION for
@@ -85,104 +37,27 @@
 obtained from CommitBuilder.revision_tree(). Hooks MUST NOT modify tree_delta
 and future_tree.
 
-
-post_commit (Branch)
---------------------
-
+post_commit
+###########
 Run after ``commit`` has completed.
 
 The hook signature is (local, master, old_revno, old_revid, new_revno,
 new_revid) old_revid is NULL_REVISION for the first commit to a branch.
 
-
-post_uncommit (Branch)
-----------------------
-
+post_uncommit
+#############
 Run after ``uncommit`` has completed.
 
 The api signature is (local, master, old_revno, old_revid, new_revno,
 new_revid) where local is the local branch or None, master is the target
 branch, and an empty branch receives new_revno of 0, new_revid of None.
 
-
-pre_change_branch_tip (Branch)
--------------------------------
-
-Run before a branch tip has been changed, while the branch is write-locked.
-Note that push, pull, commit and uncommit all invoke this hook.
-
-The hook signature is (params), where params is an object containing
-the members
-
-  branch
-    The branch whose tip has been changed.
-
-  old_revno
-    The revision number (eg 10) of the branch before the change.
-
-  old_revid
-    The revision id (eg joe@foo.com-1234234-aoeua34) before the change.
-
-  new_revno
-    The revision number (eg 12) of the branch after the change.
-
-  new_revid
-    The revision id (eg joe@foo.com-5676566-boa234a) after the change.
-
-The old_revno and new_revno members are integers, as the head
-revision never has a dotted revision number.
-
-
-post_change_branch_tip (Branch)
--------------------------------
-
-Run after a branch tip has been changed but while the branch is still
-write-locked. Note that push, pull, commit and uncommit all invoke this hook.
-
-The hook signature is (params), where params is an object containing
-the members
-
-  branch
-    The branch whose tip has been changed.
-
-  old_revno
-    The revision number (eg 10) of the branch before the change.
-
-  old_revid
-    The revision id (eg joe@foo.com-1234234-aoeua34) before the change.
-
-  new_revno
-    The revision number (eg 12) of the branch after the change.
-
-  new_revid
-    The revision id (eg joe@foo.com-5676566-boa234a) after the change.
-
-The old_revno and new_revno members are integers, as the head
-revision never has a dotted revision number.
-
-
-set_rh (Branch)
----------------
-
-Note: This hook is now deprecated and will be removed in the near future.
-Please use the ``post_change_branch_tip`` hook instead.
-
-
-server_started (SmartTCPServer)
--------------------------------
-
-Invoked whenever the server starts serving a directory.
-The hook signature is (backing urls, public url), where:
-
-  backing_url
-    A list of (string) URLs giving the server-specific directory locations.
-
-  public_url
-    The public URL for the directory.
-
-
-server_stopped (SmartTCPServer)
--------------------------------
-
-Invoked whenever the server stops serving a directory.
-The hook signature is the same as ``server_started``.
+set_rh
+######
+Run after the branch's revision history has been modified (push, pull, commit
+and uncommit can all modify the revision history).
+
+The hook signature is (branch, revision_history), and the branch will be
+write-locked.
+
+See also `Using Hooks <../user-guide/hooks.html>`_.

=== added file 'doc/en/user-reference/index.txt'
--- doc/en/user-reference/index.txt	1970-01-01 00:00:00 +0000
+++ doc/en/user-reference/index.txt	2007-08-30 03:36:01 +0000
@@ -0,0 +1,8 @@
+#####################
+Bazaar User Reference
+#####################
+
+* `Hooks Reference <hooks.html>`_ |--| The various operations that Bazaar
+  lets you hook into
+
+.. |--| unicode:: U+2014

=== removed file 'doc/en/user-reference/readme.txt'
--- doc/en/user-reference/readme.txt	2007-12-11 13:40:18 +0000
+++ doc/en/user-reference/readme.txt	1970-01-01 00:00:00 +0000
@@ -1,8 +0,0 @@
-Note: The contents of the User Reference are fully generated from
-Bazaar's online help topics. If you wish to edit this material,
-most of it can be found under bzrlib/help_topics/. In some cases
-though, the material is built by probing various internal
-registries, e.g. the set of available file formats. If you're
-not sure where to find the source content you're looking for,
-please contact the developers on the mailing list or IRC.
-See http://bazaar-vcs.org/BzrSupport for contact details.

=== removed directory 'doc/es'
=== removed directory 'doc/es/guia-desarrollador'
=== removed directory 'doc/es/guia-usuario'
=== removed file 'doc/es/guia-usuario/index.txt'
--- doc/es/guia-usuario/index.txt	2008-05-12 00:59:13 +0000
+++ doc/es/guia-usuario/index.txt	1970-01-01 00:00:00 +0000
@@ -1,117 +0,0 @@
-##########################
-Guia de Usuarios de Bazaar
-##########################
-
-.. Files are currently links but will become includes once the
-.. content makes more sense as a whole.
-.. Please mark sections in linked/included files as following:
-..   level 1 ========
-..   level 2 --------
-..   level 3 ~~~~~~~~
-..   level 4 ^^^^^^^^ (it is better not to use nesting deeper than 3 levels)
-
-.. contents:: :depth: 2
-.. sectnum::
-
-
-Introducción
-############
-
-.. include later - introducing_bazaar.txt
-.. include later - core_concepts.txt
-.. include later - bazaar_workflows.txt
-
-
-Empezando
-#########
-
-.. include later - installing_bazaar.txt
-.. include later -  entering_commands.txt
-.. include later - revnos.txt
-.. include later - getting_help.txt
-.. include later - configuring_bazaar.txt
-.. include later - using_aliases.txt
-.. include later - plugins.txt
-
-
-Control de Versionamiento Personal
-##################################
-
-.. include later - solo_intro.txt
-.. include later - starting_a_project.txt
-.. include later - controlling_registration.txt
-.. include later - reviewing_changes.txt
-.. include later - recording_changes.txt
-.. include later - browsing_history.txt
-.. include later - releasing_a_project.txt
-.. include later - undoing_mistakes.txt
-
-
-Compartiendo con tus pares
-##########################
-
-.. include later - partner_intro.txt
-.. include later - branching_a_project.txt
-.. include later - merging_changes.txt
-.. include:: resolving_conflicts.txt
-.. include later - annotating_changes.txt
-
-
-Colaboración en equipo, modo centralizado
-#########################################
-
-.. include later - central_intro.txt
-.. include later - publishing_a_branch.txt
-.. include later - using_checkouts.txt
-.. include later - working_offline_central.txt
-.. include later - reusing_a_checkout.txt
-
-
-Colaboracion en equipo, modo distribuido
-########################################
-
-.. include later - distributed_intro.txt
-.. include later - organizing_branches.txt
-.. include later - using_gatekeepers.txt
-.. include later - sending_changes.txt
-
-
-Un tour breve de los plugins mas populares
-##########################################
-
-.. include later - part2_intro.txt
-.. include later - bzrtools_plugin.txt
-.. include later - svn_plugin.txt
-.. include later looms_plugin.txt
-
-
-Integrando Bazaar en tu entorno
-###############################
-
-.. include later - web_browsing.txt
-.. include later - file_explorers.txt
-.. include later - desktop_integration.txt
-.. include later - editors_and_ides.txt
-.. include later - email.txt
-.. include later - bug_trackers.txt
-
-
-Temas varios
-############
-
-.. include later - adv_merging.txt
-.. include later - server.txt
-.. include later - hooks.txt
-.. include:: version_info.txt
- 
-
-Apéndice
-########
-
-.. include later - specifying_revisions.txt
-.. include later - shared_repository_layouts.txt
-.. include later - setting_up_email.txt
-.. include later - http_smart_server.txt
-.. include later - writing_a_plugin.txt
-
-.. |--| unicode:: U+2014

=== removed file 'doc/es/guia-usuario/resolving_conflicts.txt'
--- doc/es/guia-usuario/resolving_conflicts.txt	2008-05-12 00:59:13 +0000
+++ doc/es/guia-usuario/resolving_conflicts.txt	1970-01-01 00:00:00 +0000
@@ -1,185 +0,0 @@
-=====================
-Manejo de Conflictos
-=====================
-
-Algunas operaciones, como merge, revert y pull, modifican el contenido de su
-working tree. Estas modificaciones son generadas automaticamente, con lo cual
-pueden tener conflictos con el estado actual de su working tree.  Muchos tipos
-de cambios pueden ser combinados automaticamentem pero a veces solo algunos 
-humanos pueden determinar la decision correcta a tomar.  Cuando esto sucede,
-Bazaar lo informara que hay un conflict y pedira que lo resuelva. El comando
-para resolverlo es ``resolve``, pero debe realizar alguna accion antes de
-ejecutarlo.
-
-Cada tipo de conflicto esta explicado a continuacion, y la accion que se debe
-realizar para resolver el conflicto esta detallada.
-
-
-Conflictos de Texto (Text conflicts)
-=====================================
-Mensaje comun::
-
-  Text conflict in ARCHIVO
-
-Estos se producen cuando el texto a unificar no puede ser completamente
-reconciliado entre dos cambios. Bazaar emitira archivos para cada version con
-extensiones THIS, OTHER, y BASE.  THIS es la version del archivo del tree
-de destino, por ejemplo, el tree al que estan unificando los cambios. OTHER
-es la version que estan uniendo al tree de destino. BASE es la version 
-anterior que es usado como base para la comparacion.
-
-En la copia principal del archivo, Bazaar incluira los cambios que puede
-reconciliar, y cualquier cambio sin reconciliar son rodeados con marcadores
-"herringbone" como ``<<<<<<<``.
-
-Digamos que el texto inicial es "El lider del proyecto lo lanzo.", y THIS lo
-modifica a "Martin Pool lo lanzo.", mientras que OTHER lo modifica a "El lider 
-del proyecto lanzo Bazaar."  Un conflicto se veria asi::
-
-  <<<<<<< TREE
-  Martin Pool lo lanzo.
-  =======
-  El lider del proyecto lanzo Bazaar.
-  >>>>>>> MERGE-SOURCE
-
-La resulucion correcta seria "Martin Pool lanzo Bazaar."
-
-Puede manejar conflictos de texto o editando la copia principal del archivo,
-o invocando herramientas externas on las versiones THIS, OTHER y BASE. Vale 
-la pena mencionar que resolver conflictos de texto rara vez involucra elegir
-un conjunto de cambios u otros. Los mas comun es que tenga que combinar 
-inteligentemente.
-
-Si modifica la copia principal, asegurese de sacar los marcadores "herringbone".
-Cuando termino de modificar, el archivo debe estar como si nunca hubiese estado 
-con conflictos, y estar listo para hacer commit.
-
-Cuando resolvio los conflictos de texto, solo ejecute "bzr resolve", y Bazaar 
-detectera automaticamente que resolvio.
-
-
-Conflictos de contenido (Content conflicts)
-============================================
-Mensaje comun::
-
-  Contents conflict in ARCHIVO
-
-Este conflicto sucede cuando hay cambios que crean conflictos en el tree de 
-destino y el fuente a unificar, pero los items con conflictos no son archivos 
-de texto.  Pueden ser archivos binarios, symlinks o directorios.  Pueden suceder 
-con archivos que fueron eliminados en un lado, y modificados en el otro.
-
-Como los conflictos de texto, Bazaar creara archivos THIS, OTHER y BASE.
-(pueden ser archivos normales, symlinks o directorios).  Esto no incluira 
-la "copia principal" del archivo con marcadores "herringbone".  Parecera que la 
-"copia principal" fue renombrado a THIS o OTHER.
-
-Para resolver esto, utilice "bzr mv" para renombrar el archivo a su nombre 
-original, y combine los cambios manualmente. Cuando este satisfecho, ejecute 
-"bzr resolve ARCHIVO".  Bazaar no puede detectar cuando cambios de este tipo 
-fueron resueltos.
-
-
-Rutas Duplicadas (Duplicate Paths)
-==================================
-Mensaje comun::
-
-  Conflict adding file ARCHIVO.  Moved existing file to ARCHIVO.moved.
-
-Bazaar a veces intentara crear un archivo usando la ruta que ya fue usada.
-El archivo existente ser renombrado a "ARCHIVO.moved".  Si lo desea, puede 
-renombrar cualquiera de estos archivos, o combinar su contenido. Cuando 
-este satisfecho, puede ejecutar "bzr resolve ARCHIVO" para marcar que el 
-conflicto fue resuelto.
-
-
-Padre sin versionar (Unversioned Parent)
-========================================
-Mensajes comunes::
-
-    Conflict because ARCHIVO no esta versionado, pero tiene hijos versionados.
-
-A veces Bazaar intentara crear un archivo cuyo directorio padre no esta 
-versionado. Esto sucede cuando el directorio fue eliminado en el destino, 
-pero tiene un hijo nuevo en origen, o vice versa. En esta situacion, Bazaar 
-versionara al directorio padre tambien.  Resolver este tema depende mucho 
-en el escenario particular.  Puede que quiera renombrar o eliminar o renombrar 
-cualquier archivo o directorio.  Cuando esta satisfecho, puede ejecutar "bzr 
-resolve ARCHIVO" para marcar el conflicto como resuelto.
-
-
-Padre faltante (Missing Parent)
-===============================
-Mensaje comun::
-
-  Conflict adding files to ARCHIVO.  Created directory.
-
-Esto sucede cuando un archivo fue eliminado en el destino, pero tiene hijos 
-en el origen.  Esto es similar al conflicto "Padre sin versionar", excepto 
-que el directorio padre *no existe*, en vez de no estar versionado. En esta 
-situacion, Bazaar creara al padre faltante.  Resolver estos temas depende 
-mucho de cada caso particular. Usted puede querer renombrar o eliminar 
-cualquiera de los archivos o directorios.  Cuando este satisfecho, puede 
-ejecutar "bzr resolve ARCHIVO" para marcar al archivo resuelto.
-
-
-Borrando al Padre (Deleting Parent)
-===================================
-Mensaje comun::
-
-  Conflict: can't delete ARCHIVO because it is not empty.  Not deleting.
-
-Esto es el opuesto a "Padre faltante".  Un directorio es eliminado en el 
-origen, pero tiene hijos en el destino.  Bazaar mantiene el directorio.
-Resolver este tema depende mucho de cada escenario particular.  Quizas quiera 
-renombrar o eliminar cualquiera de los archivos o directorios.  Cuando esta 
-satisfecho, puede ejecutar "bzr resolver ARCHIVO" para marcar al conflicto 
-como resuelto.
-
-
-Conflicto de Ruta (Path Conflict)
-=================================
-Mensaje comun::
-
-  Path conflict: RUTA1 / RUTA2
-
-Esto sucede cuando en el origen y el destino han sido modificados el nombre 
-o directorio padre de un archivo. Bazaar usara la ruta de los elementos del 
-origen. Puede renombrar el archivo, y una vez que lo ha hecho, ejecutar 
-"bzr resolve ARCHIVO" para marcarl el conflicto como resuelto.
-
-
-Bucle Padre (Parent Loop)
-=========================
-Mensaje comun::
-
-  Conflict moving ARCHIVO into DIRECTORIO.  Cancelled move.
-
-Esto sucede cuando en el origen y el destino se han movido directorios, de 
-tal forma que, si se aplicaran los cambios, el directorios se contendria a 
-si mismo.
-Por ejemplo::
-
-  $ bzr init
-  $ bzr mkdir a
-  $ bzr mkdir b
-  $ bzr commit -m "BASE"
-  $ bzr branch . ../other
-  $ bzr mv a b
-  $ bzr commit -m "THIS"
-  $ bzr mv ../other/b ../other/a
-  $ bzr commit ../other -m "OTHER"
-  $ bzr merge ../other
-
-En esta situacion, Bazaar cancelara el movimiento, y dejara "a" en "b".
-Puede renombrar los directorios como desee, y una vez que lo ha hecho, 
-ejecute "bzr resolve ARCHIVO" para marcar el conflicto como resuelto.
-
-
-MalformedTransform
-==================
-Es posible (aunque muy raro) que Bazaar de una excepcion MalformedTransform.
-Esto quiere decir que Bazaar encontro un conflicto en el sistema de archivos 
-que no le fue posible resolver.  Esto usualmente indica un bug.  Por favor 
-haganoslo saber si se encuentra en esta situacion. Nuestro sistema de bugs 
-se encuentra en https://launchpad.net/bzr/+bugs

=== removed file 'doc/es/guia-usuario/version_info.txt'
--- doc/es/guia-usuario/version_info.txt	2008-05-04 18:17:45 +0000
+++ doc/es/guia-usuario/version_info.txt	1970-01-01 00:00:00 +0000
@@ -1,53 +0,0 @@
-===========================
-Usando ``bzr version-info``
-===========================
-
-Repaso General
-==============
-
-Este documento describe las formas de usar ``bzr version-info`` como 
-parte del proceso de embeber la informacion de vesion a un proyecto.
-
-
-Projecto Python
-===============
-
-TODO: Figure out how to attach into ``setup.py``
-
-Si usa un archivo Makefile para construir su proyecto, puede generar un 
-archivo on la informacion de version tan simple como::
-
-  library/_version.py:
-        bzr version-info --format=python > library/_version.py
-
-Eso genera un archivo que contiene 3 diccionarios:
-
-  * `version_info`: Un diccionario conteniendo informacion basica sobre el
-    estado actual
-
-  * `revisions`: Un diccionario listando todas las revisiones en 
-    el historial del tree, junto con los tiempos y los mensajes de 
-    los commits. Esto por defecto esta en blanco salvi que use ``--all`` 
-    o `--include-history`` es provisto. Esto es util si quiere seguir 
-    que bugs arregla el lanzamiento de esa version. Para muchos proyectos 
-    es mas informacion de la que se va a necesitar.
-
-  * `file_revisions`: Un diccionario listando la revision que modifico
-    por ultima vez todos los archivos del proyecto. Esto puede ser usado 
-    similarmente a como se usan las palabras claves ``$Id$`` en los 
-    archivos controlados en CVS. La ultima fecha de modificacion puede 
-    ser determinada mirando en el mapa de ``revisions``. Esto tambien 
-    esta vacio por defecto, y habilitado solo por ``--all`` o
-    ``--include-file-revisions``.
-    
-
-Check Clean
-===========
-
-La mayoria de la informacion sobre el contenido del proyecto puede 
-ser determinada a muy bajo costo con solo leer las entradas de revisiones.
-Sin embargo, puede ser util si el working tree fue actualizado completamente 
-cuando fue empaquetado, o si hubo alguna modificacion local. Al proveer 
-``--all`` o ``--check-clean``, ``bzr`` va a inspeccionar el working tree, 
-y definir el ``clean`` flag en ``version_info``, al igual que definir 
-entradas en ``file_revisions`` como ``modified`` donde es apropiado.

=== removed directory 'doc/es/mini-tutorial'
=== removed file 'doc/es/mini-tutorial/index.txt'
--- doc/es/mini-tutorial/index.txt	2008-08-02 17:10:50 +0000
+++ doc/es/mini-tutorial/index.txt	1970-01-01 00:00:00 +0000
@@ -1,283 +0,0 @@
-=======================
-Bazaar en cinco minutos
-=======================
-
-.. contents:: Contenidos
-
-Introducción
-============
-
-Bazaar es un sistema de control de versiones distribuido que facilita que
-varias personas puedan trabajar de forma conjunta en proyectos de software.
-
-A lo largo de los próximos cinco minutos, aprenderá cómo poner sus archivos 
-bajo control de versiones, como registrar cambios en ellos, examinar su 
-trabajo, publicarlo y enviar su trabajo para que sea integrado en el trunk de 
-un proyecto.
-
-Si prefiere una introducción más detallada, eche un vistazo a
-`Aprendiendo Más`_.
-
-
-Instalación
-===========
-
-Esta guía no describe cómo instalar Bazaar pero normalmente es muy
-sencillo. Puede encontrar intrucciones de instalación en:
-
-- **GNU/Linux:** Bazaar, probablemente, ya esté en su distribución GNU/Linux.
-- **Windows:** `instrucciones de instalación para Windows`_.
-- **Mac OS X:** `instrucciones de instalación para Mac OS X`_.
-
-Para otras plataformas y para instalar desde el código fuente, vea las
-páginas de Descarga_ e Instalación_.
-
-.. _instrucciones de instalación para Windows: http://bazaar-vcs.org/WindowsDownloads
-.. _instrucciones de instalación para Mac OS X: http://bazaar-vcs.org/MacOSXBundle
-.. _Descarga: http://bazaar-vcs.org/Download
-.. _Instalación: http://bazaar-vcs.org/InstallationFaq
-
-
-Preséntese
-==========
-
-Antes de empezar a trabajar, es conveniente que le diga a Bazaar quién es 
-usted. De ese modo su trabajo será identificando correctamente en los logs 
-de revisión.
-
-Utilice su nombre y dirección de email en lugar de John Doe, teclee::
-
-  $ bzr whoami "John Doe <john.doe@gmail.com>"
-  
-Bazaar creará o modificará ahora un archivo de configuración, incluyendo su
-nombre y dirección de email.
-
-Ahora compruebe que su nombre y dirección de email se han registrado correctamente::
-
-  $ bzr whoami
-  John Doe <john.doe@gmail.com>
-
-
-Ponga archivos bajo control de versiones
-========================================
-
-Vamos a crear un directorio y algunos archivos para utilizar con Bazaar::
-
- $ mkdir miproyecto
- $ cd miproyecto
- $ mkdir subdirectorio
- $ touch test1.txt test2.txt test3.txt subdirectorio/test4.txt
- 
-**Nota para usuarios de Windows:** utilice Windows Explorer para crear sus
-directorios, luego haga click derecho en dichos directorios y seleccione
-``Nuevo archivo`` para crear sus archivos.
-
-Ahora vamos a hacer que Bazaar se inicialize en el directorio de su proyecto::
-
-  $ bzr init
-  
-Si parece que no ha ocurrido nada no se preocupe. Bazaar ha creado un
-branch_ dónde guardará sus archivos y su histórico de revisiones.
-
-.. _branch: http://bazaar-vcs.org/Branch
-
-El siguiente paso es decirle a Bazaar a que archivos desea seguirles la pista.
-Ejecutando ``bzr add`` agregará recursivamente todos los elementos dentro del 
-proyecto::
-
- $ bzr add
- added subdirectorio
- added test1.txt
- added test2.txt
- added test3.txt
- added subdirectorio/test4.txt
-
-A continuación tome una instantánea de sus archivos agregándolos a su branch. 
-Agregue un mensaje para explicar por qué hace el commit::
-
-  $ bzr commit -m "Importación inicial"
-  
-Como Bazaar es un sistema de control de versiones distribuido, no necesita
-conectar con un servidor central para hacer el commit. Bazaar guarda su
-branch y todos sus commits dentro del directorio con el que está trabajando,
-busque el subdirectorio ``.bzr``.
-
-
-Haciendo cambios en sus archivos
-================================
-
-Vamos a cambiar un archivo e introduzcamos ese cambio  en su branch.
-
-Edite ``test1.txt`` en su editor favorito y luego compruebe qué ha hecho::
-
- $ bzr diff
- === modified file 'test1.txt'
- --- test1.txt   2007-10-08 17:56:14 +0000
- +++ test1.txt   2007-10-08 17:46:22 +0000
- @@ -0,0 +1,1 @@
- +test test test
-
-Añada su trabajo al branch de Bazaar::
-
-  $ bzr commit -m "Añadida la primera línea de texto"
-  Committed revision 2.
-
-
-Viendo el log de revisiones
-===========================
-
-Puede ver el histórico de su branch navegando su log::
-
-  $ bzr log
-  ------------------------------------------------------------
-  revno: 2
-  committer: John Doe <john.doe@gmail.com>
-  branch nick: miproyecto
-  timestamp: Mon 2007-10-08 17:56:14 +0000
-  message:
-    Añadida la primera línea de texto
-  ------------------------------------------------------------
-  revno: 1
-  committer: John Doe <john.doe@gmail.com>
-  branch nick: miproyecto
-  timestamp: Mon 2006-10-08 17:46:22 +0000
-  message:
-    Importación inicial
-
-
-Publicando su branch con sftp
-=============================
-
-Hay un par de maneras para publicar su branch. Si ya tiene un servidor
-SFTP o se siente cómodo configurando uno, puede publicar su branch con el.
-
-Sino salte a la siguiente sección para publicar con Launchpad_, un
-servicio de hosting gratuito para Bazaar.
-
-.. _Launchpad: https://launchpad.net/
-
-Vamos a suponer que desea publicar su branch en ``www.example.com/miproyecto``::
-
- $ bzr push --create-prefix sftp://su.nombre@example.com/~/public_html/miproyecto
- 2 revision(s) pushed.
- 
-Bazaar creará un directorio ``miproyecto`` en el servidor remoto e
-introducirá su branch en él.
- 
-Ahora cualquiera podrá crear su propia copia de su branch tecleando::
-
- $ bzr branch http://www.example.com/miproyecto
- 
-**Nota:** para utilizar sftp deberá instalar ``paramiko`` y
-``pyCrypto``. Vea http://bazaar-vcs.org/InstallationFaq para más información.
-
-
-Publicando su branch con Launchpad
-==================================
-
-Launchpad es una suite de herramientas de desarrollo y hosting
-para proyectos de software libre. Puede utilizarlo para publicar su branch.
-
-Si no dispone de una cuenta de Launchpad, siga la `guia de registro de cuentas`_
-y `registre una clave SSH`_ en su nueva cuenta de Launchpad.
-
-.. _guia de registro de cuentas: https://help.launchpad.net/CreatingYourLaunchpadAccount
-.. _registre una clave SSH: https://launchpad.net/people/+me/+editsshkeys
-
-Cambie ``john.doe`` por su nombre de usuario de Launchpad, teclee::
-
- $ bzr push bzr+ssh://john.doe@bazaar.launchpad.net/~john.doe/+junk/miproyecto
-
-**Nota:** ``+junk`` significa que este branch no está asociado con ningún proyecto 
-concreto en Launchpad.
-
-Ahora cualquiera podrá crear su propia copia de su branch tecleando::
-
- $ bzr branch http://bazaar.launchpad.net/~john.doe/+junk/miproyecto
- 
-También puede ver información sobre su branch, histórico de revisiones
-incluido, en https://code.launchpad.net/people/+me/+junk/miproyecto
-
-
-Creando su propia copia de otro branch
-======================================
-
-Para trabajar con el código de otra persona, tendrá que hacer su propia
-copia de su branch. Vamos a coger un ejemplo real, la interfaz GTK de Bazaar::
-
-  $ bzr branch http://bazaar.launchpad.net/~bzr/bzr-gtk/trunk bzr-gtk.john
-  Branched 292 revision(s).                                                        
-
-Bazaar descargará todos los archivos y el histórico de revisiones completo
-del trunk branch del proyecto bzr-gtk y creará una copia llamada
-bzr-gtk.john.
-
-Ahora dispone de su propia copia del branch y puede enviar cambios con
-o sin una conexión de red. Puede compartir su branch en cualquier momento
-publicándola y, si el equipo de bzr-gtk desea utilizar su trabajo, Bazaar
-les facilita integrar su branch dentro de su trunk branch.
-
-
-Actualizando su branch desde el branch principal
-================================================
-
-Mientras envía cambios a su branch, es probable que otras personas también
-sigan enviando código al branch principal.
-
-Para asegurarse de que su branch está al dia debería integrar los cambios
-desde el principal dentro de su branch personal::
-
-  $ bzr merge
-  Merging from saved parent location: http://bazaar.launchpad.net/~bzr/bzr-gtk/trunk
-  All changes applied successfully.
-            
-Compruebe qué ha cambiado::
-
-  $ bzr diff
- 
-Si está contento con los cambios puede añadirlos en su branch personal::
-
-  $ bzr commit -m "Integración desde el branch principal"
-  Committed revision 295.
-
-
-Integrando su trabajo en el branch principal
-============================================
-
-Después de haber trabajado en su branch personal de bzr-gtk puede que
-quiera enviar sus cambios de vuelta al proyecto. La manera más fácil
-es utilizando una instrucción merge.
-
-Una instrucción merge es una petición de lectura mecánica para
-llevar a cabo una integración concreta. Por lo general contiene un
-parche de vista previa de la integración y, o bien contiene las
-revisiones necesarias, o proporciona un branch donde pueden encontrarse.
-
-Sustituyendo ``mycode.patch``, cree su instrucción merge::
-
- $ bzr send -o mycode.patch
- Using saved parent location: http://bazaar.launchpad.net/~bzr/bzr-gtk/trunk
- 
-Ahora puede enviar por email la instruccion merge al proyecto bzr-gtk
-quien, si así lo quieren, pueden utilizarla para integrar su trabajo
-dentro del branch principal.
- 
- 
-Aprendiendo más
-===============
-
-Puede encontrar más sobre Bazaar en la
-`Guía de Usuario de Bazaar <../guia-usuario/index.html>`_.
-
-Para aprender sobre Bazaar por línea de comandos::
-
-  $ bzr help
-
-Para aprender sobre comandos de Bazaar::
-
-  $ bzr help commands
-
-Para aprender acerca del tema o comando ''foo''::
-
-  $ bzr help foo
-

=== removed directory 'doc/es/notas-version'
=== removed directory 'doc/es/referencia'
=== removed directory 'doc/es/referencia-rapida'
=== removed file 'doc/es/referencia-rapida/Makefile'
--- doc/es/referencia-rapida/Makefile	2008-05-06 00:26:30 +0000
+++ doc/es/referencia-rapida/Makefile	1970-01-01 00:00:00 +0000
@@ -1,19 +0,0 @@
-TARGETS=referencia-rapida.png referencia-rapida.pdf
-OBJECTS=referencia-rapida.svg Makefile
-
-all: $(TARGETS)
-
-.SUFFIXES: .svg .png .pdf
-
-.svg.pdf:
-	rsvg-convert -d 300 -p 300 -f pdf -o $@ $<
-
-.svg.png:
-	rsvg-convert -d 300 -p 300 -z 3.3346 -f png -o $@ $<
-
-bzr-quickref.png: $(OBJECTS)
-
-bzr-quickref.pdf: $(OBJECTS)
-
-clean:
-	rm -f $(TARGETS)

=== removed file 'doc/es/referencia-rapida/referencia-rapida.svg'
--- doc/es/referencia-rapida/referencia-rapida.svg	2008-05-06 00:26:30 +0000
+++ doc/es/referencia-rapida/referencia-rapida.svg	1970-01-01 00:00:00 +0000
@@ -1,1691 +0,0 @@
-<?xml version="1.0" encoding="UTF-8" standalone="no"?>
-<!-- Created with Inkscape (http://www.inkscape.org/) -->
-<svg
-   xmlns:dc="http://purl.org/dc/elements/1.1/"
-   xmlns:cc="http://creativecommons.org/ns#"
-   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
-   xmlns:svg="http://www.w3.org/2000/svg"
-   xmlns="http://www.w3.org/2000/svg"
-   xmlns:xlink="http://www.w3.org/1999/xlink"
-   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"
-   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"
-   width="1052.3622"
-   height="744.09448"
-   id="svg2766"
-   sodipodi:version="0.32"
-   inkscape:version="0.46"
-   version="1.0"
-   sodipodi:docbase="/home/ian/bzr/repo.packs/bzr.quick-start-tweaks/doc/en/quick-reference"
-   sodipodi:docname="referencia-rapida.svg"
-   inkscape:output_extension="org.inkscape.output.svg.inkscape"
-   inkscape:export-filename="/home/iacobs/work/pers/bzr-quickref.png"
-   inkscape:export-xdpi="300"
-   inkscape:export-ydpi="300">
-  <defs
-     id="defs2768">
-    <inkscape:perspective
-       sodipodi:type="inkscape:persp3d"
-       inkscape:vp_x="0 : 372.04724 : 1"
-       inkscape:vp_y="0 : 1000 : 0"
-       inkscape:vp_z="1052.3622 : 372.04724 : 1"
-       inkscape:persp3d-origin="526.18109 : 248.03149 : 1"
-       id="perspective2680" />
-    <linearGradient
-       id="linearGradient3382">
-      <stop
-         style="stop-color:#2753b0;stop-opacity:1;"
-         offset="0"
-         id="stop3384" />
-      <stop
-         style="stop-color:#cecece;stop-opacity:1;"
-         offset="1"
-         id="stop3386" />
-    </linearGradient>
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient3382"
-       id="linearGradient5465"
-       x1="164.4165"
-       y1="380.09448"
-       x2="164.4165"
-       y2="436.59479"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient3382"
-       id="linearGradient5473"
-       x1="164.4165"
-       y1="380.09448"
-       x2="164.4165"
-       y2="436.59479"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient3382"
-       id="linearGradient5603"
-       gradientUnits="userSpaceOnUse"
-       x1="150.39197"
-       y1="104.09448"
-       x2="151.10625"
-       y2="155.92776"
-       gradientTransform="translate(0,26)" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient3382"
-       id="linearGradient5605"
-       gradientUnits="userSpaceOnUse"
-       x1="165.19594"
-       y1="104.09448"
-       x2="165.19594"
-       y2="156.84296"
-       gradientTransform="translate(0,26)" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient3382"
-       id="linearGradient8696"
-       x1="814.96497"
-       y1="364.08444"
-       x2="814.96497"
-       y2="412.09879"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient3382"
-       id="linearGradient8704"
-       x1="814.96497"
-       y1="364.08444"
-       x2="814.96497"
-       y2="412.09879"
-       gradientUnits="userSpaceOnUse" />
-    <linearGradient
-       gradientTransform="matrix(1.027169,0,0,1,118.6039,77.1455)"
-       gradientUnits="userSpaceOnUse"
-       y2="0"
-       x2="372.24512"
-       y1="69.037941"
-       x1="372.24512"
-       id="linearGradient2200"
-       xlink:href="#linearGradient5444"
-       inkscape:collect="always" />
-    <linearGradient
-       id="linearGradient5444">
-      <stop
-         style="stop-color:#729fcf;stop-opacity:1;"
-         offset="0"
-         id="stop5446" />
-      <stop
-         id="stop4547"
-         offset="0.5"
-         style="stop-color:#3465a4;stop-opacity:1;" />
-      <stop
-         style="stop-color:#204ab7;stop-opacity:1;"
-         offset="1"
-         id="stop5448" />
-    </linearGradient>
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient5444"
-       id="linearGradient3338"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(1.027169,0,0,1,417.31189,-41.4259)"
-       x1="372.24512"
-       y1="69.037941"
-       x2="372.24512"
-       y2="0" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient3382"
-       id="linearGradient3769"
-       gradientUnits="userSpaceOnUse"
-       x1="401.62418"
-       y1="104.09448"
-       x2="402.0069"
-       y2="152.69125"
-       gradientTransform="matrix(1.0959218,0,0,0.9988328,-30.458554,26.145213)" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient3382"
-       id="linearGradient3771"
-       gradientUnits="userSpaceOnUse"
-       x1="401.62418"
-       y1="104.09448"
-       x2="402.0069"
-       y2="152.69125"
-       gradientTransform="matrix(1.0959218,0,0,0.9988328,-30.458554,26.145213)" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient3382"
-       id="linearGradient3824"
-       gradientUnits="userSpaceOnUse"
-       x1="625.15149"
-       y1="104.09448"
-       x2="625.15149"
-       y2="154.2104"
-       gradientTransform="matrix(1.0902791,0,0,0.9988999,-49.120159,26.136854)" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient3382"
-       id="linearGradient3826"
-       gradientUnits="userSpaceOnUse"
-       x1="625.15149"
-       y1="104.09448"
-       x2="625.15149"
-       y2="154.2104"
-       gradientTransform="matrix(1.0902791,0,0,0.9988999,-49.120159,26.136854)" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient3382"
-       id="linearGradient3956"
-       gradientUnits="userSpaceOnUse"
-       x1="852.71942"
-       y1="104.09448"
-       x2="852.71942"
-       y2="153.842"
-       gradientTransform="matrix(1.0836855,0,0,0.9989026,-64.492287,26.135003)" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient3382"
-       id="linearGradient3958"
-       gradientUnits="userSpaceOnUse"
-       x1="852.71942"
-       y1="104.09448"
-       x2="852.71942"
-       y2="153.842"
-       gradientTransform="matrix(1.0836855,0,0,0.9989026,-64.492287,26.135003)" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient3382"
-       id="linearGradient4035"
-       gradientUnits="userSpaceOnUse"
-       x1="814.96497"
-       y1="364.08444"
-       x2="814.96497"
-       y2="412.09879" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient3382"
-       id="linearGradient4037"
-       gradientUnits="userSpaceOnUse"
-       x1="814.96497"
-       y1="364.08444"
-       x2="814.96497"
-       y2="412.09879" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient3382"
-       id="linearGradient4042"
-       gradientUnits="userSpaceOnUse"
-       x1="814.96497"
-       y1="364.08444"
-       x2="814.96497"
-       y2="412.09879"
-       gradientTransform="matrix(1.073884,0,0,0.9990288,-56.948006,16.382016)" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient3382"
-       id="linearGradient4044"
-       gradientUnits="userSpaceOnUse"
-       x1="814.96497"
-       y1="364.08444"
-       x2="814.96497"
-       y2="412.09879"
-       gradientTransform="matrix(1.073884,0,0,0.9990288,-56.948006,16.382016)" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient3382"
-       id="linearGradient2734"
-       gradientUnits="userSpaceOnUse"
-       x1="164.4165"
-       y1="380.09448"
-       x2="164.4165"
-       y2="436.59479" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient3382"
-       id="linearGradient2736"
-       gradientUnits="userSpaceOnUse"
-       x1="164.4165"
-       y1="380.09448"
-       x2="164.4165"
-       y2="436.59479" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient3382"
-       id="linearGradient2741"
-       gradientUnits="userSpaceOnUse"
-       x1="164.4165"
-       y1="380.09448"
-       x2="164.4165"
-       y2="436.59479" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient3382"
-       id="linearGradient2743"
-       gradientUnits="userSpaceOnUse"
-       x1="164.4165"
-       y1="380.09448"
-       x2="164.4165"
-       y2="436.59479" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient3382"
-       id="linearGradient2723"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(1.073884,0,0,0.9990288,-56.948006,16.382016)"
-       x1="814.96497"
-       y1="364.08444"
-       x2="814.96497"
-       y2="412.09879" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient3382"
-       id="linearGradient2725"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(1.073884,0,0,0.9990288,-56.948006,16.382016)"
-       x1="814.96497"
-       y1="364.08444"
-       x2="814.96497"
-       y2="412.09879" />
-  </defs>
-  <sodipodi:namedview
-     id="base"
-     pagecolor="#ffffff"
-     bordercolor="#666666"
-     borderopacity="1.0"
-     gridtolerance="10000"
-     guidetolerance="10"
-     objecttolerance="10"
-     inkscape:pageopacity="0.0"
-     inkscape:pageshadow="2"
-     inkscape:zoom="0.93888816"
-     inkscape:cx="632.57173"
-     inkscape:cy="82.468477"
-     inkscape:document-units="px"
-     inkscape:current-layer="layer1"
-     width="1052.3622px"
-     height="744.09449px"
-     inkscape:showpageshadow="false"
-     showgrid="false"
-     inkscape:window-width="1023"
-     inkscape:window-height="719"
-     inkscape:window-x="1"
-     inkscape:window-y="24" />
-  <metadata
-     id="metadata2771">
-    <rdf:RDF>
-      <cc:Work
-         rdf:about="">
-        <dc:format>image/svg+xml</dc:format>
-        <dc:type
-           rdf:resource="http://purl.org/dc/dcmitype/StillImage" />
-        <cc:license
-           rdf:resource="http://creativecommons.org/licenses/GPL/2.0/" />
-        <dc:title>Bazaar-NG quick reference</dc:title>
-        <dc:date>2007-07-23</dc:date>
-        <dc:creator>
-          <cc:Agent>
-            <dc:title>Sabin Iacob</dc:title>
-          </cc:Agent>
-        </dc:creator>
-        <dc:language>en</dc:language>
-        <dc:subject>
-          <rdf:Bag>
-            <rdf:li>bzr</rdf:li>
-            <rdf:li>bazaar</rdf:li>
-            <rdf:li>reference</rdf:li>
-          </rdf:Bag>
-        </dc:subject>
-      </cc:Work>
-      <cc:License
-         rdf:about="http://creativecommons.org/licenses/GPL/2.0/">
-        <cc:permits
-           rdf:resource="http://web.resource.org/cc/Reproduction" />
-        <cc:permits
-           rdf:resource="http://web.resource.org/cc/Distribution" />
-        <cc:requires
-           rdf:resource="http://web.resource.org/cc/Notice" />
-        <cc:permits
-           rdf:resource="http://web.resource.org/cc/DerivativeWorks" />
-        <cc:requires
-           rdf:resource="http://web.resource.org/cc/ShareAlike" />
-        <cc:requires
-           rdf:resource="http://web.resource.org/cc/SourceCode" />
-      </cc:License>
-    </rdf:RDF>
-  </metadata>
-  <g
-     inkscape:label="Layer 1"
-     inkscape:groupmode="layer"
-     id="layer1">
-    <rect
-       style="opacity:1;fill:none;fill-opacity:0;fill-rule:nonzero;stroke:none;stroke-width:1;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1"
-       id="rect2983"
-       width="1052.1749"
-       height="744"
-       x="0"
-       y="0.094482422"
-       ry="0" />
-    <g
-       id="g3762">
-      <g
-         id="g8706">
-        <rect
-           style="fill:none;fill-opacity:0;fill-rule:nonzero;stroke:#cecece;stroke-width:1;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1"
-           id="rect2190"
-           width="228.60797"
-           height="216.41451"
-           x="50.891964"
-           y="144.31995"
-           ry="8.1168776" />
-        <path
-           style="fill:url(#linearGradient5603);fill-opacity:1;fill-rule:nonzero;stroke:url(#linearGradient5605);stroke-width:1;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1"
-           d="M 59.296663,130.59448 C 54.644771,130.59448 50.891959,134.22213 50.891959,138.71888 L 50.891959,167.43551 C 50.891959,162.93876 54.644771,159.31111 59.296663,159.31111 L 271.12755,159.31111 C 275.77946,159.31111 279.49993,162.93876 279.49993,167.43551 L 279.49993,138.71888 C 279.49993,134.22213 275.77946,130.59448 271.12755,130.59448 L 59.296663,130.59448 z "
-           id="rect3430" />
-        <text
-           xml:space="preserve"
-           style="font-size:16px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
-           x="108.32876"
-           y="150.97269"
-           id="text3164"
-           sodipodi:linespacing="100%"><tspan
-             sodipodi:role="line"
-             id="tspan3166"
-             x="108.32876"
-             y="150.97269">Inicialización</tspan></text>
-      </g>
-      <g
-         transform="translate(1e-4,-2.2095387)"
-         id="g3209">
-        <text
-           xml:space="preserve"
-           style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
-           x="63.794312"
-           y="193.07361"
-           id="text2167"
-           sodipodi:linespacing="110%"><tspan
-             sodipodi:role="line"
-             x="63.794312"
-             y="193.07361"
-             id="tspan2171">bzr init miproyecto</tspan></text>
-        <text
-           xml:space="preserve"
-           style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
-           x="58.209351"
-           y="179.83536"
-           id="text3168"
-           sodipodi:linespacing="100%"><tspan
-             sodipodi:role="line"
-             id="tspan3170"
-             x="58.209351"
-             y="179.83536">Proyecto nuevo</tspan></text>
-      </g>
-      <g
-         transform="translate(1e-4,-1.1449276)"
-         id="g3215">
-        <text
-           xml:space="preserve"
-           style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
-           x="64.448624"
-           y="226.45848"
-           id="text2175"
-           sodipodi:linespacing="110%"><tspan
-             sodipodi:role="line"
-             id="tspan2177"
-             x="64.448624"
-             y="226.45848">cd miproyecto</tspan><tspan
-             sodipodi:role="line"
-             x="64.448624"
-             y="237.53181"
-             id="tspan2179">bzr init</tspan><tspan
-             sodipodi:role="line"
-             x="64.448624"
-             y="248.60515"
-             id="tspan2181">bzr add .</tspan><tspan
-             sodipodi:role="line"
-             x="64.448624"
-             y="259.67847"
-             id="tspan2183" /></text>
-        <text
-           xml:space="preserve"
-           style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
-           x="58.174194"
-           y="213.22023"
-           id="text3172"
-           sodipodi:linespacing="100%"><tspan
-             sodipodi:role="line"
-             id="tspan3174"
-             x="58.174194"
-             y="213.22023">Proyecto existente</tspan></text>
-      </g>
-      <g
-         transform="translate(1e-4,5.3457864e-2)"
-         id="g3224">
-        <text
-           xml:space="preserve"
-           style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
-           x="64.448624"
-           y="277.48495"
-           id="text2185"
-           sodipodi:linespacing="110%"><tspan
-             sodipodi:role="line"
-             id="tspan2187"
-             x="64.448624"
-             y="277.48495">bzr branch mp miproyecto</tspan></text>
-        <text
-           xml:space="preserve"
-           style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
-           x="58.209351"
-           y="266.6666"
-           id="text3176"
-           sodipodi:linespacing="100%"><tspan
-             sodipodi:role="line"
-             id="tspan3178"
-             x="58.209351"
-             y="266.6666">Nuevo branch</tspan></text>
-      </g>
-      <g
-         transform="translate(1e-4,1.1181147)"
-         id="g3230">
-        <text
-           xml:space="preserve"
-           style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
-           x="64.448624"
-           y="308.44989"
-           id="text3404"
-           sodipodi:linespacing="110%"><tspan
-             sodipodi:role="line"
-             id="tspan3406"
-             x="64.448624"
-             y="308.44989">bzr checkout mp miproyecto</tspan></text>
-        <text
-           xml:space="preserve"
-           style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
-           x="58.209351"
-           y="297.63153"
-           id="text3408"
-           sodipodi:linespacing="100%"><tspan
-             sodipodi:role="line"
-             id="tspan3410"
-             x="58.209351"
-             y="297.63153">Nuevo checkout</tspan></text>
-      </g>
-      <g
-         transform="translate(1e-4,2.1828937)"
-         id="g3236">
-        <text
-           xml:space="preserve"
-           style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
-           x="64.448624"
-           y="341.88864"
-           id="text3414"
-           sodipodi:linespacing="110%"><tspan
-             id="tspan3424"
-             sodipodi:role="line"
-             x="64.448624"
-             y="341.88864">bzr checkout --lightweight mp \</tspan><tspan
-             sodipodi:role="line"
-             x="64.448624"
-             y="352.96198"
-             id="tspan2780"> miproyecto</tspan></text>
-        <text
-           xml:space="preserve"
-           style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
-           x="58.209351"
-           y="328.59634"
-           id="text3418"
-           sodipodi:linespacing="100%"><tspan
-             id="tspan3422"
-             sodipodi:role="line"
-             x="58.209351"
-             y="328.59634">Nuevo checkout &quot;ligero&quot;</tspan></text>
-      </g>
-    </g>
-    <g
-       id="g3774">
-      <rect
-         ry="9.6319456"
-         y="145.57634"
-         x="317.80582"
-         height="135.65298"
-         width="206.32903"
-         id="rect3658"
-         style="fill:none;fill-opacity:0;fill-rule:nonzero;stroke:#cecece;stroke-width:1.0466845;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1" />
-      <path
-         id="rect3648"
-         d="M 328.38206,130.61761 C 322.53211,130.61761 317.79957,134.89967 317.79957,140.23137 L 317.79957,170.19635 C 317.79957,164.86465 322.53211,160.58259 328.38206,160.58259 L 513.59284,160.58259 C 519.4428,160.58259 524.14109,164.86465 524.14109,170.19635 L 524.14109,140.23137 C 524.14109,134.89967 519.4428,130.61761 513.59284,130.61761 L 328.38206,130.61761 z"
-         style="fill:url(#linearGradient3769);fill-opacity:1;fill-rule:nonzero;stroke:url(#linearGradient3771);stroke-width:1.04625165;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1" />
-      <text
-         sodipodi:linespacing="100%"
-         id="text3563"
-         y="150.94995"
-         x="333.44049"
-         style="font-size:16px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
-         xml:space="preserve"><tspan
-           y="150.94995"
-           x="333.44049"
-           id="tspan3565"
-           sodipodi:role="line">Manipular Archivos</tspan></text>
-      <g
-         transform="translate(1e-4,-1.9729054)"
-         id="g3243">
-        <text
-           xml:space="preserve"
-           style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
-           x="332.47345"
-           y="191.36041"
-           id="text3610"
-           sodipodi:linespacing="110%"><tspan
-             sodipodi:role="line"
-             x="332.47345"
-             y="191.36041"
-             id="tspan3612">bzr add foo.py</tspan><tspan
-             id="tspan3618"
-             sodipodi:role="line"
-             x="332.47345"
-             y="202.43375">bzr add bar/</tspan></text>
-        <text
-           xml:space="preserve"
-           style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
-           x="326.88849"
-           y="179.59872"
-           id="text3614"
-           sodipodi:linespacing="110%"><tspan
-             sodipodi:role="line"
-             id="tspan3616"
-             x="326.88849"
-             y="179.59872">Añadir/&quot;versionar&quot; archivos</tspan></text>
-      </g>
-      <g
-         transform="translate(1e-4,-0.9323495)"
-         id="g3250">
-        <text
-           xml:space="preserve"
-           style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
-           x="331.78732"
-           y="233.11641"
-           id="text3622"
-           sodipodi:linespacing="110%"><tspan
-             sodipodi:role="line"
-             x="331.78732"
-             y="233.11641"
-             id="tspan3624">bzr remove --keep foo.py</tspan></text>
-        <text
-           xml:space="preserve"
-           style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
-           x="326.20236"
-           y="221.35472"
-           id="text3626"
-           sodipodi:linespacing="100%"><tspan
-             sodipodi:role="line"
-             id="tspan3628"
-             x="326.20236"
-             y="221.35472">Eliminar archivos</tspan></text>
-      </g>
-      <g
-         transform="translate(1e-4,0.1322158)"
-         id="g3256">
-        <text
-           xml:space="preserve"
-           style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
-           x="331.81714"
-           y="264.08142"
-           id="text3632"
-           sodipodi:linespacing="110%"><tspan
-             sodipodi:role="line"
-             x="331.81714"
-             y="264.08142"
-             id="tspan3634">bzr remove --force foo.py</tspan></text>
-        <text
-           xml:space="preserve"
-           style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
-           x="326.23218"
-           y="253.26308"
-           id="text3636"
-           sodipodi:linespacing="100%"><tspan
-             sodipodi:role="line"
-             id="tspan3638"
-             x="326.23218"
-             y="253.26308">Eliminar y borrar archivos</tspan></text>
-      </g>
-    </g>
-    <rect
-       style="fill:none;fill-opacity:0;fill-rule:nonzero;stroke:#cecece;stroke-width:1.02624357;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1"
-       id="rect3780"
-       width="229.91788"
-       height="336.27368"
-       x="49.457561"
-       y="394.44012"
-       ry="10.484502" />
-    <path
-       style="fill:url(#linearGradient2741);fill-opacity:1;fill-rule:nonzero;stroke:url(#linearGradient2743);stroke-width:1;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1"
-       d="M 57.795026,380.59448 C 53.111409,380.59448 49.333004,384.22215 49.333004,388.71892 L 49.333004,417.43572 C 49.333004,412.93894 53.111409,409.31127 57.795026,409.31127 L 271.07052,409.31127 C 275.75416,409.31127 279.5,412.93894 279.5,417.43572 L 279.5,388.71892 C 279.5,384.22215 275.75416,380.59448 271.07052,380.59448 L 57.795026,380.59448 z"
-       id="path3784" />
-    <text
-       xml:space="preserve"
-       style="font-size:16px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
-       x="111.15869"
-       y="400.96985"
-       id="text3786"
-       sodipodi:linespacing="100%"><tspan
-         sodipodi:role="line"
-         id="tspan3788"
-         x="111.15869"
-         y="400.96985">Información</tspan></text>
-    <g
-       id="g3281"
-       transform="translate(1e-4,0.4441055)">
-      <text
-         sodipodi:linespacing="110%"
-         id="text3234"
-         y="441.34354"
-         x="62.69976"
-         style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
-         xml:space="preserve"><tspan
-           id="tspan3236"
-           y="441.34354"
-           x="62.69976"
-           sodipodi:role="line">bzr status</tspan></text>
-      <text
-         sodipodi:linespacing="100%"
-         id="text3238"
-         y="428.10529"
-         x="57.114799"
-         style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
-         xml:space="preserve"><tspan
-           y="428.10529"
-           x="57.114799"
-           id="tspan3240"
-           sodipodi:role="line">Estado del árbol de trabajo</tspan></text>
-    </g>
-    <g
-       id="g3287"
-       transform="translate(1e-4,1.4958392)">
-      <text
-         sodipodi:linespacing="110%"
-         id="text3244"
-         y="472.84393"
-         x="62.721241"
-         style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
-         xml:space="preserve"><tspan
-           id="tspan3250"
-           y="472.84393"
-           x="62.721241"
-           sodipodi:role="line">bzr log</tspan><tspan
-           y="483.91727"
-           x="62.721241"
-           sodipodi:role="line"
-           id="tspan3294">bzr log foo.py</tspan><tspan
-           id="tspan3252"
-           y="494.9906"
-           x="62.721241"
-           sodipodi:role="line" /></text>
-      <text
-         sodipodi:linespacing="100%"
-         id="text3254"
-         y="459.55164"
-         x="56.446827"
-         style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
-         xml:space="preserve"><tspan
-           y="459.55164"
-           x="56.446827"
-           id="tspan3256"
-           sodipodi:role="line">Log de revisión</tspan></text>
-    </g>
-    <g
-       id="g3295"
-       transform="translate(1e-4,2.6343158)">
-      <text
-         sodipodi:linespacing="110%"
-         id="text3260"
-         y="517.29712"
-         x="63.354061"
-         style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
-         xml:space="preserve"><tspan
-           y="517.29712"
-           x="63.354061"
-           id="tspan3262"
-           sodipodi:role="line">bzr diff</tspan></text>
-      <text
-         sodipodi:linespacing="100%"
-         id="text3264"
-         y="504.05884"
-         x="57.114803"
-         style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
-         xml:space="preserve"><tspan
-           y="504.05884"
-           x="57.114803"
-           id="tspan3266"
-           sodipodi:role="line">Cambios en el árbol de trabajo</tspan></text>
-    </g>
-    <g
-       id="g3314"
-       transform="translate(1e-4,5.8149666)">
-      <text
-         sodipodi:linespacing="110%"
-         id="text3298"
-         y="625.09357"
-         x="62.744678"
-         style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
-         xml:space="preserve"><tspan
-           y="625.09357"
-           x="62.744678"
-           id="tspan3300"
-           sodipodi:role="line">bzr missing</tspan></text>
-      <text
-         sodipodi:linespacing="100%"
-         id="text3302"
-         y="611.85535"
-         x="56.505421"
-         style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
-         xml:space="preserve"><tspan
-           y="611.85535"
-           x="56.505421"
-           id="tspan3304"
-           sodipodi:role="line">Revisiones perdidas</tspan></text>
-    </g>
-    <text
-       xml:space="preserve"
-       style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
-       x="62.7565"
-       y="707.22107"
-       id="text3308"
-       sodipodi:linespacing="110%"><tspan
-         sodipodi:role="line"
-         id="tspan3310"
-         x="62.7565"
-         y="707.22107">bzr cat -r3 foo.py</tspan></text>
-    <text
-       xml:space="preserve"
-       style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
-       x="56.517242"
-       y="682.26678"
-       id="text3312"
-       sodipodi:linespacing="100%"><tspan
-         sodipodi:role="line"
-         x="56.517242"
-         y="682.26678"
-         id="tspan3625">Contenidos de foo.py en la </tspan><tspan
-         sodipodi:role="line"
-         x="56.517242"
-         y="694.26678"
-         id="tspan3681">revisión 3</tspan></text>
-    <g
-       id="g3320"
-       transform="translate(1e-4,6.8799266)">
-      <text
-         sodipodi:linespacing="110%"
-         id="text3318"
-         y="656.12701"
-         x="62.686089"
-         style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
-         xml:space="preserve"><tspan
-           y="656.12701"
-           x="62.686089"
-           id="tspan3320"
-           sodipodi:role="line">bzr info</tspan></text>
-      <text
-         sodipodi:linespacing="100%"
-         id="text3322"
-         y="645.30865"
-         x="56.446831"
-         style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
-         xml:space="preserve"><tspan
-           y="645.30865"
-           x="56.446831"
-           id="tspan3324"
-           sodipodi:role="line">Información del branch</tspan></text>
-    </g>
-    <g
-       id="g3301"
-       transform="translate(1e-4,3.685897)">
-      <text
-         sodipodi:linespacing="110%"
-         id="text3330"
-         y="548.74365"
-         x="62.879452"
-         style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
-         xml:space="preserve"><tspan
-           y="548.74365"
-           x="62.879452"
-           id="tspan3332"
-           sodipodi:role="line">bzr diff foo.py</tspan></text>
-      <text
-         sodipodi:linespacing="100%"
-         id="text3334"
-         y="535.50537"
-         x="56.640194"
-         style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
-         xml:space="preserve"><tspan
-           y="535.50537"
-           x="56.640194"
-           id="tspan3336"
-           sodipodi:role="line">Cambios en foo.py </tspan></text>
-    </g>
-    <g
-       id="g3307"
-       transform="translate(1e-4,4.7504623)">
-      <text
-         sodipodi:linespacing="110%"
-         id="text3699"
-         y="591.70862"
-         x="62.000679"
-         style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
-         xml:space="preserve"><tspan
-           y="591.70862"
-           x="62.000679"
-           id="tspan3701"
-           sodipodi:role="line">bzr diff -r1..3 foo.py</tspan></text>
-      <text
-         sodipodi:linespacing="100%"
-         id="text3703"
-         y="568.89032"
-         x="55.761421"
-         style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
-         xml:space="preserve"><tspan
-           y="568.89032"
-           x="55.761421"
-           id="tspan3705"
-           sodipodi:role="line">Cambios en foo.py entre las</tspan><tspan
-           y="580.89032"
-           x="55.761421"
-           sodipodi:role="line"
-           id="tspan3707">revisiones 1 y 3</tspan></text>
-    </g>
-    <g
-       id="g3829">
-      <rect
-         ry="9.6321363"
-         y="145.575"
-         x="544.36224"
-         height="135.65567"
-         width="205.26662"
-         id="rect4132"
-         style="fill:none;fill-opacity:0;fill-rule:nonzero;stroke:#cecece;stroke-width:1.04399669;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1" />
-      <path
-         id="path4130"
-         d="M 554.88401,130.61628 C 549.06418,130.61628 544.35601,134.89863 544.35601,140.23069 L 544.35601,170.19768 C 544.35601,164.86563 549.06418,160.58327 554.88401,160.58327 L 739.14116,160.58327 C 744.96101,160.58327 749.6351,164.86563 749.6351,170.19768 L 749.6351,140.23069 C 749.6351,134.89863 744.96101,130.61628 739.14116,130.61628 L 554.88401,130.61628 z"
-         style="fill:url(#linearGradient3824);fill-opacity:1;fill-rule:nonzero;stroke:url(#linearGradient3826);stroke-width:1.04358983;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1" />
-      <text
-         sodipodi:linespacing="100%"
-         id="text4134"
-         y="152.01505"
-         x="554.46985"
-         style="font-size:16px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
-         xml:space="preserve"><tspan
-           y="152.01505"
-           x="554.46985"
-           id="tspan4136"
-           sodipodi:role="line">Control de Versiones</tspan></text>
-      <g
-         transform="translate(1e-4,-2.4445851)"
-         id="g3262">
-        <text
-           xml:space="preserve"
-           style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
-           x="559.03162"
-           y="190.88873"
-           id="text4140"
-           sodipodi:linespacing="110%"><tspan
-             sodipodi:role="line"
-             x="559.03162"
-             y="190.88873"
-             id="tspan4142">bzr commit foo.py -m &quot;foo&quot;</tspan><tspan
-             id="tspan4144"
-             sodipodi:role="line"
-             x="559.03162"
-             y="201.96207">bzr commit -m &quot;el resto&quot;</tspan></text>
-        <text
-           xml:space="preserve"
-           style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
-           x="553.44666"
-           y="180.0704"
-           id="text4146"
-           sodipodi:linespacing="100%"><tspan
-             sodipodi:role="line"
-             id="tspan4148"
-             x="553.44666"
-             y="180.0704">Commit</tspan></text>
-      </g>
-      <g
-         transform="translate(1e-4,-2.6967609)"
-         id="g3269">
-        <text
-           xml:space="preserve"
-           style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
-           x="558.37482"
-           y="232.2924"
-           id="text4152"
-           sodipodi:linespacing="110%"><tspan
-             sodipodi:role="line"
-             x="558.37482"
-             y="232.2924"
-             id="tspan4154">bzr uncommit</tspan></text>
-        <text
-           xml:space="preserve"
-           style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
-           x="552.78986"
-           y="221.47408"
-           id="text4156"
-           sodipodi:linespacing="100%"><tspan
-             sodipodi:role="line"
-             id="tspan4158"
-             x="552.78986"
-             y="221.47408">Deshacer último commit</tspan></text>
-      </g>
-      <g
-         transform="translate(1e-4,-1.6451646)"
-         id="g3275">
-        <text
-           xml:space="preserve"
-           style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
-           x="558.37488"
-           y="263.73889"
-           id="text4162"
-           sodipodi:linespacing="110%"><tspan
-             sodipodi:role="line"
-             x="558.37488"
-             y="263.73889"
-             id="tspan4164">bzr revert</tspan></text>
-        <text
-           xml:space="preserve"
-           style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
-           x="552.78992"
-           y="250.50064"
-           id="text4166"
-           sodipodi:linespacing="100%"><tspan
-             sodipodi:role="line"
-             id="tspan4168"
-             x="552.78992"
-             y="250.50064">Revertir los cambios</tspan></text>
-      </g>
-    </g>
-    <g
-       id="g3961">
-      <rect
-         ry="8.1153431"
-         y="144.34038"
-         x="770.91241"
-         height="216.37361"
-         width="247.73869"
-         id="rect4232"
-         style="fill:none;fill-opacity:0;fill-rule:nonzero;stroke:#cecece;stroke-width:1.04090285;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1" />
-      <path
-         id="path4234"
-         d="M 780.02026,130.6147 C 774.97907,130.6147 770.91221,134.23836 770.91221,138.73017 L 770.91221,167.41528 C 770.91221,162.92347 774.97907,159.2998 780.02026,159.2998 L 1009.5783,159.2998 C 1014.6195,159.2998 1018.6514,162.92347 1018.6514,167.41528 L 1018.6514,138.73017 C 1018.6514,134.23836 1014.6195,130.6147 1009.5783,130.6147 L 780.02026,130.6147 z"
-         style="fill:url(#linearGradient3956);fill-opacity:1;fill-rule:nonzero;stroke:url(#linearGradient3958);stroke-width:1.04043078;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1" />
-      <text
-         sodipodi:linespacing="100%"
-         id="text4236"
-         y="149.90759"
-         x="796.75134"
-         style="font-size:16px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
-         xml:space="preserve"><tspan
-           y="149.90759"
-           x="796.75134"
-           id="tspan4238"
-           sodipodi:role="line">Merging / Integrando</tspan></text>
-      <g
-         transform="translate(1e-4,-1.0888417)"
-         id="g3392">
-        <text
-           xml:space="preserve"
-           style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
-           x="783.75751"
-           y="191.95291"
-           id="text4242"
-           sodipodi:linespacing="110%"><tspan
-             sodipodi:role="line"
-             x="783.75751"
-             y="191.95291"
-             id="tspan4244">cd miproyecto</tspan><tspan
-             sodipodi:role="line"
-             x="783.75751"
-             y="203.02625"
-             id="tspan4296">bzr merge ../miproyecto-foo</tspan><tspan
-             sodipodi:role="line"
-             x="783.75751"
-             y="214.09958"
-             id="tspan4298">bzr commit</tspan></text>
-        <text
-           xml:space="preserve"
-           style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
-           x="778.17255"
-           y="178.71466"
-           id="text4246"
-           sodipodi:linespacing="100%"><tspan
-             sodipodi:role="line"
-             id="tspan4248"
-             x="778.17255"
-             y="178.71466">Integrar dos branches</tspan></text>
-      </g>
-      <g
-         transform="translate(1e-4,0.1095133)"
-         id="g3384">
-        <text
-           xml:space="preserve"
-           style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
-           x="784.44696"
-           y="245.39931"
-           id="text4252"
-           sodipodi:linespacing="110%"><tspan
-             sodipodi:role="line"
-             id="tspan4254"
-             x="784.44696"
-             y="245.39931">cd miproyecto-foo</tspan><tspan
-             sodipodi:role="line"
-             x="784.44696"
-             y="256.47263"
-             id="tspan4258">bzr pull ../miproyecto</tspan><tspan
-             sodipodi:role="line"
-             x="784.44696"
-             y="267.54596"
-             id="tspan4260" /></text>
-        <text
-           xml:space="preserve"
-           style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
-           x="778.17255"
-           y="232.16106"
-           id="text4262"
-           sodipodi:linespacing="100%"><tspan
-             sodipodi:role="line"
-             id="tspan4264"
-             x="778.17255"
-             y="232.16106">Pull de cambios desde miproyecto</tspan></text>
-      </g>
-      <g
-         transform="translate(1e-4,1.2474884)"
-         id="g3378">
-        <text
-           xml:space="preserve"
-           style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
-           x="784.4118"
-           y="289.69043"
-           id="text4268"
-           sodipodi:linespacing="110%"><tspan
-             sodipodi:role="line"
-             id="tspan4270"
-             x="784.4118"
-             y="289.69043">bzr update</tspan></text>
-        <text
-           xml:space="preserve"
-           style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
-           x="778.17255"
-           y="276.5459"
-           id="text4272"
-           sodipodi:linespacing="100%"><tspan
-             sodipodi:role="line"
-             id="tspan4274"
-             x="778.17255"
-             y="276.5459">Actualizar un checkout</tspan></text>
-      </g>
-      <g
-         transform="translate(1e-4,2.3122978)"
-         id="g3372">
-        <text
-           xml:space="preserve"
-           style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
-           x="785.45477"
-           y="320.70923"
-           id="text4278"
-           sodipodi:linespacing="110%"><tspan
-             sodipodi:role="line"
-             id="tspan4280"
-             x="785.45477"
-             y="320.70923">bzr resolve</tspan></text>
-        <text
-           xml:space="preserve"
-           style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
-           x="779.21552"
-           y="309.83685"
-           id="text4282"
-           sodipodi:linespacing="100%"><tspan
-             sodipodi:role="line"
-             id="tspan4284"
-             x="779.21552"
-             y="309.83685">Autodetectar conflictos resueltos</tspan></text>
-      </g>
-      <g
-         transform="translate(1e-4,3.3643062)"
-         id="g3366">
-        <text
-           xml:space="preserve"
-           style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
-           x="784.65204"
-           y="352.20935"
-           id="text4288"
-           sodipodi:linespacing="110%"><tspan
-             id="tspan4290"
-             sodipodi:role="line"
-             x="784.65204"
-             y="352.20935">bzr resolve foo.py</tspan></text>
-        <text
-           xml:space="preserve"
-           style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
-           x="778.41278"
-           y="338.91705"
-           id="text4292"
-           sodipodi:linespacing="100%"><tspan
-             id="tspan4294"
-             sodipodi:role="line"
-             x="778.41278"
-             y="338.91705">Especificar un conflicto resuelto</tspan></text>
-      </g>
-    </g>
-    <rect
-       style="fill:none;fill-opacity:0;fill-rule:nonzero;stroke:#cecece;stroke-width:1.06177783;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1"
-       id="rect4531"
-       width="246.92378"
-       height="335.17307"
-       x="771.16052"
-       y="394.45789"
-       ry="10.450186" />
-    <path
-       style="fill:url(#linearGradient2723);fill-opacity:1;fill-rule:nonzero;stroke:url(#linearGradient2725);stroke-width:1.03578043;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1"
-       d="M 780.12335,380.61237 C 775.09368,380.61237 771.03611,384.23652 771.03611,388.72892 L 771.03611,417.41783 C 771.03611,412.92542 775.09368,409.30127 780.12335,409.30127 L 1009.1565,409.30127 C 1014.1862,409.30127 1018.2087,412.92542 1018.2087,417.41783 L 1018.2087,388.72892 C 1018.2087,384.23652 1014.1862,380.61237 1009.1565,380.61237 L 780.12335,380.61237 z"
-       id="path4533" />
-    <text
-       xml:space="preserve"
-       style="font-size:16px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
-       x="844.98444"
-       y="399.90475"
-       id="text4535"
-       sodipodi:linespacing="100%"><tspan
-         sodipodi:role="line"
-         id="tspan4537"
-         x="844.98444"
-         y="399.90475">Publicando</tspan></text>
-    <g
-       id="g3354"
-       transform="translate(1e-4,-1.7634544)">
-      <text
-         sodipodi:linespacing="110%"
-         id="text4616"
-         y="475.58072"
-         x="781.75745"
-         style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
-         xml:space="preserve"><tspan
-           id="tspan4618"
-           y="475.58072"
-           x="781.75745"
-           sodipodi:role="line">bzr push sftp://host/miproyecto-fo1</tspan></text>
-      <text
-         sodipodi:linespacing="100%"
-         id="text4620"
-         y="462.34244"
-         x="776.17249"
-         style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
-         xml:space="preserve"><tspan
-           y="462.34244"
-           x="776.17249"
-           id="tspan4622"
-           sodipodi:role="line">Empujar revisiones remotamente</tspan></text>
-    </g>
-    <g
-       id="g3360"
-       transform="translate(1e-4,-1.1779953)">
-      <text
-         sodipodi:linespacing="110%"
-         id="text4457"
-         y="440.54575"
-         x="782.38519"
-         style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
-         xml:space="preserve"><tspan
-           id="tspan4459"
-           y="440.54575"
-           x="782.38519"
-           sodipodi:role="line">bzr push ../miproyecto-fo1</tspan></text>
-      <text
-         sodipodi:linespacing="100%"
-         id="text4461"
-         y="429.72739"
-         x="776.80023"
-         style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
-         xml:space="preserve"><tspan
-           y="429.72739"
-           x="776.80023"
-           id="tspan4463"
-           sodipodi:role="line">Push de revisiones</tspan></text>
-    </g>
-    <g
-       id="g3346"
-       transform="translate(1e-4,0.3362061)">
-      <text
-         sodipodi:linespacing="110%"
-         id="text4467"
-         y="505.56467"
-         x="782.40674"
-         style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
-         xml:space="preserve"><tspan
-           y="505.56467"
-           x="782.40674"
-           sodipodi:role="line"
-           id="tspan8805">bzr send</tspan><tspan
-           id="tspan4473"
-           y="516.638"
-           x="782.40674"
-           sodipodi:role="line" /></text>
-      <text
-         sodipodi:linespacing="100%"
-         id="text4475"
-         y="494.69229"
-         x="776.13232"
-         style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
-         xml:space="preserve"><tspan
-           y="494.69229"
-           x="776.13232"
-           sodipodi:role="line"
-           id="tspan4608">Enviar por Email directriz merge</tspan></text>
-    </g>
-    <g
-       id="g3339"
-       transform="translate(1e-4,31.004958)">
-      <text
-         sodipodi:linespacing="110%"
-         id="text4481"
-         y="562.4187"
-         x="783.03955"
-         style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
-         xml:space="preserve"><tspan
-           y="562.4187"
-           x="783.03955"
-           id="tspan4483"
-           sodipodi:role="line">bzr export ../miproyecto-dist/</tspan></text>
-      <text
-         sodipodi:linespacing="100%"
-         id="text4485"
-         y="537.18048"
-         x="776.80029"
-         style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
-         xml:space="preserve"><tspan
-           y="537.18048"
-           x="776.80029"
-           id="tspan4487"
-           sodipodi:role="line">Exportar la revisión actual como</tspan><tspan
-           y="549.18048"
-           x="776.80029"
-           sodipodi:role="line"
-           id="tspan4610">un directorio</tspan></text>
-    </g>
-    <g
-       id="g3332"
-       transform="translate(1e-4,33.600285)">
-      <text
-         sodipodi:linespacing="110%"
-         id="text4521"
-         y="605.85291"
-         x="782.565"
-         style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
-         xml:space="preserve"><tspan
-           y="605.85291"
-           x="782.565"
-           id="tspan4523"
-           sodipodi:role="line">bzr export ../miproyecto-dist.zip</tspan></text>
-      <text
-         sodipodi:linespacing="100%"
-         id="text4525"
-         y="583.03461"
-         x="776.32574"
-         style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
-         xml:space="preserve"><tspan
-           y="583.03461"
-           x="776.32574"
-           id="tspan4527"
-           sodipodi:role="line">Exportar la revisión actual como</tspan><tspan
-           y="595.03461"
-           x="776.32574"
-           sodipodi:role="line"
-           id="tspan4612">un archivo</tspan></text>
-    </g>
-    <g
-       id="g2446"
-       transform="translate(-1.4135726,38.47762)">
-      <text
-         sodipodi:linespacing="110%"
-         id="text2448"
-         y="505.56467"
-         x="782.40674"
-         style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
-         xml:space="preserve"><tspan
-           y="505.56467"
-           x="782.40674"
-           sodipodi:role="line"
-           id="tspan2450">bzr send -o ../base.patch</tspan><tspan
-           id="tspan2452"
-           y="516.638"
-           x="782.40674"
-           sodipodi:role="line" /></text>
-      <text
-         sodipodi:linespacing="100%"
-         id="text2454"
-         y="494.69229"
-         x="776.13232"
-         style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
-         xml:space="preserve"><tspan
-           y="494.69229"
-           x="776.13232"
-           sodipodi:role="line"
-           id="tspan2456">Crear una directriz merge</tspan></text>
-    </g>
-    <text
-       xml:space="preserve"
-       style="font-size:40px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
-       x="144.32812"
-       y="64.254639"
-       id="text2774"
-       sodipodi:linespacing="100%"><tspan
-         sodipodi:role="line"
-         id="tspan2776"
-         x="144.32812"
-         y="64.254639">Bazaar </tspan></text>
-    <g
-       style="display:inline"
-       id="g3653"
-       transform="matrix(0.6461515,0,0,0.6526216,160.93614,144.01237)"
-       inkscape:export-filename="/home/matt/Projects/Ubuntu/Bazaar Website/bzr icon 64.png"
-       inkscape:export-xdpi="45.012665"
-       inkscape:export-ydpi="45.012665">
-      <path
-         id="path2749"
-         d="M -143.51431,-75.4275 C -158.48768,-90.57687 -171.17625,-103.66019 -171.7111,-104.50153 C -174.63909,-109.10738 -172.34363,-112.16647 -143.7155,-141.81059 C -119.96256,-166.4065 -114.08422,-171.84722 -111.26302,-171.84722 C -108.45655,-171.84722 -102.57922,-166.49332 -79.566158,-142.97326 C -59.704508,-122.67403 -51.314608,-113.24681 -51.314608,-111.22876 C -51.314608,-107.03298 -109.21126,-47.88319 -113.31814,-47.88319 C -115.49463,-47.88319 -123.57621,-55.25503 -143.51431,-75.4275 z "
-         style="opacity:1;fill:#fce94f;fill-opacity:1;stroke:#fce94f;stroke-width:4;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1;display:inline" />
-      <path
-         id="path2721"
-         d="M -118.75152,-74.850683 C -119.22012,-75.319283 -119.60352,-85.958443 -119.60352,-98.493313 L -119.60352,-121.28395 L -124.85215,-121.28395 C -131.2088,-121.28395 -131.22918,-121.19503 -121.27316,-136.90004 C -116.77235,-143.99978 -113.38241,-148.09169 -112.19584,-147.85705 C -110.34853,-147.49175 -95.321883,-124.90849 -95.321883,-122.4975 C -95.321883,-121.83004 -97.640303,-121.28395 -100.47393,-121.28395 C -103.84689,-121.28395 -105.87693,-120.6299 -106.35276,-119.38989 C -107.55959,-116.24495 -103.45251,-106.32746 -97.296233,-97.520823 C -90.988133,-88.497013 -90.461803,-86.665103 -93.461883,-84.175253 C -95.128693,-82.791933 -96.185063,-83.268713 -100.25177,-87.239733 C -102.90055,-89.826193 -105.46285,-91.547323 -105.94572,-91.064423 C -106.42862,-90.581523 -106.8237,-86.544203 -106.8237,-82.092573 L -106.8237,-73.998703 L -112.36162,-73.998703 C -115.40746,-73.998703 -118.28294,-74.382103 -118.75152,-74.850683 z "
-         style="opacity:1;fill:#c4a000;fill-opacity:1;stroke:#c4a000;display:inline" />
-      <path
-         id="path2727"
-         d="M -120.75152,-76.85072 C -121.22012,-77.31932 -121.60352,-87.95848 -121.60352,-100.49335 L -121.60352,-123.28399 L -126.85215,-123.28399 C -133.2088,-123.28399 -133.22918,-123.19507 -123.27316,-138.90007 C -118.77235,-145.99981 -115.38241,-150.09172 -114.19584,-149.85708 C -112.34853,-149.49178 -97.321888,-126.90852 -97.321888,-124.49754 C -97.321888,-123.83008 -99.640308,-123.28399 -102.47393,-123.28399 C -105.84689,-123.28399 -107.87693,-122.62994 -108.35276,-121.38993 C -109.55959,-118.24499 -105.45251,-108.3275 -99.296238,-99.52086 C -92.988138,-90.49705 -92.461808,-88.66514 -95.461888,-86.17529 C -97.128698,-84.79197 -98.185068,-85.26875 -102.25177,-89.23977 C -104.90055,-91.82623 -107.46285,-93.54736 -107.94572,-93.06446 C -108.42862,-92.58156 -108.8237,-88.54424 -108.8237,-84.09261 L -108.8237,-75.99874 L -114.36162,-75.99874 C -117.40746,-75.99874 -120.28294,-76.38214 -120.75152,-76.85072 z "
-         style="opacity:1;fill:#555753;fill-opacity:1;stroke:#2e3436;stroke-opacity:1;display:inline" />
-      <path
-         d="M -143.51431,-75.4275 C -158.48768,-90.57687 -171.17625,-103.66019 -171.7111,-104.50153 C -174.63909,-109.10738 -172.34363,-112.16647 -143.7155,-141.81059 C -119.96256,-166.4065 -114.08422,-171.84722 -111.26302,-171.84722 C -108.45655,-171.84722 -102.57922,-166.49332 -79.566162,-142.97326 C -59.704512,-122.67403 -51.314612,-113.24681 -51.314612,-111.22876 C -51.314612,-107.03298 -109.21126,-47.88319 -113.31814,-47.88319 C -115.49463,-47.88319 -123.57621,-55.25503 -143.51431,-75.4275 z M -82.734602,-78.80831 C -63.284082,-98.78654 -53.870592,-109.3496 -53.870592,-111.19708 C -53.870592,-114.35673 -108.28764,-170.68595 -111.26979,-170.61328 C -113.31427,-170.56346 -167.39892,-115.6112 -169.81635,-111.12752 C -171.82156,-107.40842 -170.53236,-105.76188 -145.24612,-79.74648 C -117.66227,-51.36719 -115.36413,-49.16116 -113.38369,-49.16116 C -112.40192,-49.16116 -98.609822,-62.50237 -82.734602,-78.80831 z "
-         style="opacity:1;fill:#555753;fill-opacity:1;stroke:#2e3436;stroke-width:2;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1;display:inline"
-         id="path2736" />
-    </g>
-    <text
-       xml:space="preserve"
-       style="font-size:20px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:1;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
-       x="146.57143"
-       y="97.808769"
-       id="text3409"
-       sodipodi:linespacing="100%"><tspan
-         sodipodi:role="line"
-         id="tspan3411"
-         x="146.57143"
-         y="97.808769">Tarjeta de Referencia Rápida</tspan></text>
-    <g
-       id="g12314"
-       transform="translate(17.946423,1.7472534)"
-       style="fill:#333333;fill-opacity:1">
-      <text
-         sodipodi:linespacing="100%"
-         id="text8833"
-         y="527.43823"
-         x="297.99408"
-         style="font-size:20px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:#333333;stroke-width:1;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
-         xml:space="preserve"><tspan
-           style="font-size:20px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;font-family:Bitstream Vera Sans"
-           y="527.43823"
-           x="297.99408"
-           id="tspan8835"
-           sodipodi:role="line">Prefijos URL Soportados</tspan></text>
-      <g
-         id="g12288"
-         style="fill:#333333;fill-opacity:1">
-        <text
-           xml:space="preserve"
-           style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:150%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:1;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
-           x="299.33002"
-           y="547.94214"
-           id="text8837"
-           sodipodi:linespacing="150%"><tspan
-             sodipodi:role="line"
-             id="tspan8841"
-             x="299.33002"
-             y="547.94214">aftp://</tspan><tspan
-             sodipodi:role="line"
-             id="tspan8843"
-             x="299.33002"
-             y="565.94214">bzr://</tspan><tspan
-             sodipodi:role="line"
-             x="299.33002"
-             y="583.94214"
-             id="tspan10799">bzr+ssh://</tspan><tspan
-             sodipodi:role="line"
-             x="299.33002"
-             y="583.94214"
-             id="tspan3911" /><tspan
-             sodipodi:role="line"
-             id="tspan8847"
-             x="299.33002"
-             y="601.94214">file:// </tspan><tspan
-             sodipodi:role="line"
-             id="tspan8849"
-             x="299.33002"
-             y="619.94214">ftp:// </tspan><tspan
-             sodipodi:role="line"
-             id="tspan8851"
-             x="299.33002"
-             y="637.94214">http://</tspan><tspan
-             sodipodi:role="line"
-             id="tspan8853"
-             x="299.33002"
-             y="655.94214">https://</tspan><tspan
-             sodipodi:role="line"
-             x="299.33002"
-             y="673.94214"
-             id="tspan10797" /><tspan
-             sodipodi:role="line"
-             id="tspan8855"
-             x="299.33002"
-             y="691.94214">sftp://</tspan><tspan
-             sodipodi:role="line"
-             id="tspan8857"
-             x="299.33002"
-             y="709.94214" /></text>
-        <text
-           xml:space="preserve"
-           style="font-size:12px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:150%;writing-mode:lr-tb;text-anchor:start;opacity:1;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:1;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
-           x="379.22845"
-           y="547.94214"
-           id="text12260"
-           sodipodi:linespacing="150%"><tspan
-             sodipodi:role="line"
-             id="tspan12262"
-             x="379.22845"
-             y="547.94214">Acceso usando FTP activo.</tspan><tspan
-             sodipodi:role="line"
-             x="379.22845"
-             y="565.94214"
-             id="tspan12264">Acceso rápido usando el servidor inteligente de Bazaar.</tspan><tspan
-             sodipodi:role="line"
-             x="379.22845"
-             y="583.94214"
-             id="tspan12270">Acceso rápido usando el servidor inteligente de Bazaar</tspan><tspan
-             sodipodi:role="line"
-             x="379.22845"
-             y="601.94214"
-             id="tspan3909">sobre SSH.</tspan><tspan
-             sodipodi:role="line"
-             x="379.22845"
-             y="619.94214"
-             id="tspan12286">Accesos usando el sistema de archivos estándar (defecto).</tspan><tspan
-             sodipodi:role="line"
-             x="379.22845"
-             y="637.94214"
-             id="tspan12272">Acceso usando FTP pasivo.</tspan><tspan
-             sodipodi:role="line"
-             x="379.22845"
-             y="655.94214"
-             id="tspan12274">Acceso de solo lectura de branches exportadas en la web.</tspan><tspan
-             sodipodi:role="line"
-             x="379.22845"
-             y="673.94214"
-             id="tspan12276">Acceso de solo lectura de branches exportadas en la web</tspan><tspan
-             sodipodi:role="line"
-             x="379.22845"
-             y="691.94214"
-             id="tspan12278">utilizando SSL.</tspan><tspan
-             sodipodi:role="line"
-             x="379.22845"
-             y="709.94214"
-             id="tspan12280">Acceso usando SFTP (la mayoría de los servidores SSH</tspan><tspan
-             sodipodi:role="line"
-             x="379.22845"
-             y="727.94214"
-             id="tspan3913">proporcionan SFTP).</tspan><tspan
-             sodipodi:role="line"
-             x="379.22845"
-             y="745.94214"
-             id="tspan12282" /></text>
-      </g>
-    </g>
-    <g
-       id="g3885">
-      <text
-         sodipodi:linespacing="100%"
-         id="text4624"
-         y="320.09448"
-         x="316.78033"
-         style="font-size:20px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:#333333;stroke-width:1;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
-         xml:space="preserve"><tspan
-           style="font-size:20px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;font-family:Bitstream Vera Sans"
-           y="320.09448"
-           x="316.78033"
-           id="tspan4626"
-           sodipodi:role="line">Conceptos</tspan></text>
-      <text
-         sodipodi:linespacing="150%"
-         id="text12146"
-         y="341.21167"
-         x="477.7457"
-         style="font-size:12px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:150%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:1;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
-         xml:space="preserve"><tspan
-           y="341.21167"
-           x="477.7457"
-           id="tspan12148"
-           sodipodi:role="line">línea de desarrollo para un proyecto</tspan><tspan
-           id="tspan12150"
-           y="359.21167"
-           x="477.7457"
-           sodipodi:role="line">directorio bajo control de versiones</tspan><tspan
-           id="tspan12152"
-           y="377.21167"
-           x="477.7457"
-           sodipodi:role="line">almacén para revisiones de Bazaar</tspan><tspan
-           id="tspan12156"
-           y="395.21167"
-           x="477.7457"
-           sodipodi:role="line">versión del código fuente añadido al</tspan><tspan
-           y="413.21167"
-           x="477.7457"
-           sodipodi:role="line"
-           id="tspan3853">repositorio</tspan><tspan
-           id="tspan12158"
-           y="431.21167"
-           x="477.7457"
-           sodipodi:role="line">revisión con nombre</tspan><tspan
-           id="tspan12160"
-           y="449.21167"
-           x="477.7457"
-           sodipodi:role="line">branches que tienen un ancestro común</tspan><tspan
-           y="467.21167"
-           x="477.7457"
-           sodipodi:role="line"
-           id="tspan3857">la operación de aplicar a un branch todos los </tspan><tspan
-           y="485.21167"
-           x="477.7457"
-           sodipodi:role="line"
-           id="tspan3861">cambios introducidos por otra persona</tspan></text>
-      <text
-         sodipodi:linespacing="150%"
-         id="text12400"
-         y="341.21167"
-         x="317.27643"
-         style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:150%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:1;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
-         xml:space="preserve"><tspan
-           y="341.21167"
-           x="317.27643"
-           id="tspan12402"
-           sodipodi:role="line">Branch:</tspan><tspan
-           id="tspan12404"
-           y="359.21167"
-           x="317.27643"
-           sodipodi:role="line">Árbol de trabajo:</tspan><tspan
-           id="tspan12406"
-           y="377.21167"
-           x="317.27643"
-           sodipodi:role="line">Repositorio:</tspan><tspan
-           id="tspan12408"
-           y="395.21167"
-           x="317.27643"
-           sodipodi:role="line">Revisión:</tspan><tspan
-           id="tspan12410"
-           y="413.21167"
-           x="317.27643"
-           sodipodi:role="line" /><tspan
-           id="tspan12412"
-           y="431.21167"
-           x="317.27643"
-           sodipodi:role="line">Tag:</tspan><tspan
-           id="tspan12414"
-           y="449.21167"
-           x="317.27643"
-           sodipodi:role="line">Branches relacionadas:</tspan><tspan
-           id="tspan12416"
-           y="467.21167"
-           x="317.27643"
-           sodipodi:role="line">Merge / Integración:</tspan><tspan
-           id="tspan12418"
-           y="485.21167"
-           x="317.27643"
-           sodipodi:role="line"> </tspan></text>
-    </g>
-    <g
-       id="g6327"
-       transform="translate(6.5601196,0)"
-       style="fill:#333333;fill-opacity:1">
-      <text
-         sodipodi:linespacing="100%"
-         id="text6294"
-         y="50.289795"
-         x="775.77582"
-         style="font-size:20px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;opacity:1;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:1;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
-         xml:space="preserve"><tspan
-           y="50.289795"
-           x="775.77582"
-           id="tspan6296"
-           sodipodi:role="line">Más Información</tspan></text>
-      <g
-         id="g6320"
-         style="fill:#333333;fill-opacity:1">
-        <text
-           xml:space="preserve"
-           style="font-size:20px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:1;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
-           x="787.72699"
-           y="76.095581"
-           id="text6298"
-           sodipodi:linespacing="100%"><tspan
-             sodipodi:role="line"
-             id="tspan6300"
-             x="787.72699"
-             y="76.095581">bzr help</tspan></text>
-        <a
-           id="a6316"
-           style="fill:#333333;fill-opacity:1"
-           xlink:href="http://bazaar-vcs.org">
-          <text
-             sodipodi:linespacing="100%"
-             id="text6302"
-             y="97.901367"
-             x="787.79535"
-             style="font-size:20px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:1;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
-             xml:space="preserve"><tspan
-               y="97.901367"
-               x="787.79535"
-               id="tspan6304"
-               sodipodi:role="line">http://bazaar-vcs.org</tspan></text>
-        </a>
-      </g>
-    </g>
-  </g>
-</svg>

=== removed file 'doc/index.es.txt'
--- doc/index.es.txt	2008-05-06 00:21:18 +0000
+++ doc/index.es.txt	1970-01-01 00:00:00 +0000
@@ -1,46 +0,0 @@
-==================================
-Indice de Documentacion de Bazaar
-==================================
-
-Las ultimas versiones de estos documentos se encuentran disponibles
-en la pagina de  Bazaar, http://doc.bazaar-vcs.org.
-
-Documentacion Principal
-=======================
-
-* `Mini Tutorial <es/mini-tutorial/index.html>`_ 
-
-* `Referencia Rapida <es/referencia-rapida/referencia-rapida.svg>`_
-
-* `Guia de Usuario <es/guia-usuario/index.html>`_ 
-
-* `Referencia <es/referencia/bzr_man.html>`_ 
-
-* `Notas sobre la Version <es/notas-version/NOTICIAS.html>`_
-
-* `Guia del Desarrollador <es/guia-desarrollador/HACKING.html>`_
-
-
-Otra Documentacion
-===================
-
-Mudandose a Bazaar (enlances web):
-
-* `Guias de Mudanzas <http://bazaar-vcs.org/BzrSwitching>`_ 
-  - para los usuarios que se mudan de otros SCV
-
-* `Guias de Migracion <http://bazaar-vcs.org/BzrMigration>`_
-  - para equipos que mudan el historial de otros SCV
-
-Otros Documentos (enlances web):
-
-* `Glosario <http://bazaar-vcs.org/BzrGlossary>`_
-
-* `Preguntas Frecuentes <http://bazaar-vcs.org/FAQ>`_
-
-* `Referencia del API bzrlib <http://bazaar-vcs.org/BzrLib>`_
-
-Especificaciones tecnicas, planes a futuro y varias
-notas tecnicas varias en Ingles:
-
-* `Catalogo de Documentos para Desarrolladores <developers/index.html>`_

=== modified file 'doc/index.txt'
--- doc/index.txt	2008-06-05 03:27:37 +0000
+++ doc/index.txt	2007-10-16 11:06:30 +0000
@@ -3,58 +3,44 @@
 ============================
 
 The latest version of these documents are available from Bazaar's
-documentation site, <http://doc.bazaar-vcs.org/>, and more documentation
-may be linked from <http://bazaar-vcs.org/Documentation>.
+documentation site, http://doc.bazaar-vcs.org.
 
 Core Documentation
 ==================
 
+* `Bazaar in five minutes <en/mini-tutorial/index.html>`_ 
+
+* `Quick Start Summary <en/quick-reference/quick-start-summary.svg>`_
+
 * `User Guide <en/user-guide/index.html>`_ 
 
 * `User Reference <en/user-reference/bzr_man.html>`_ 
 
-* `Quick Start Card <en/quick-reference/quick-start-summary.svg>`_
-  (`PDF <en/quick-reference/quick-start-summary.pdf>`_,
-  `PNG <en/quick-reference/quick-start-summary.png>`_)
-
 * `Release Notes <en/release-notes/NEWS.html>`_
 
-* `Developer Document Catalog <developers/index.html>`_ |--| for developers
-  of Bazaar and plugins
-
-
-Tutorials
-=========
-
-* `Bazaar in five minutes <en/mini-tutorial/index.html>`_ 
-
-* `A longer tutorial <en/tutorials/tutorial.html>`_ 
-
-* `Using Bazaar with Launchpad <en/tutorials/using_bazaar_with_launchpad.html>`_ 
-
-* `Centralized workflow <en/tutorials/centralized_workflow.html>`_ 
-
-
-Web links
-=========
+* `Developer Guide <en/developer-guide/HACKING.html>`_
+
+
+Other Documentation
+===================
+
+Moving to Bazaar (Web links):
 
 * `Switching Guides <http://bazaar-vcs.org/BzrSwitching>`_ 
-  |--| for users moving from another VCS tool
+  - for users moving from another VCS tool
 
 * `Migration Guide <http://bazaar-vcs.org/BzrMigration>`_
-  |--| for teams migrating history from another VCS tool
+  - for teams migrating history from another VCS tool
+
+Other Documents (Web links):
 
 * `Glossary <http://bazaar-vcs.org/BzrGlossary>`_
 
 * `Frequently Asked Questions <http://bazaar-vcs.org/FAQ>`_
 
-
-Other Languages
-===============
-
-* `Spanish Documentation <index.es.html>`_
-
-.. |--| unicode:: U+2014
-
-..
-   vim: ft=rst tw=74 ai
+* `bzrlib API reference <http://bazaar-vcs.org/BzrLib>`_
+
+Technical specifications, roadmaps and various
+technical notes are available in English below:
+
+* `Developer Document Catalog <developers/index.html>`_

=== modified file 'setup.py'
--- setup.py	2008-09-04 12:03:01 +0000
+++ setup.py	2007-10-16 16:02:01 +0000
@@ -7,55 +7,21 @@
 """
 
 import os
-import os.path
 import sys
 
-if sys.version_info < (2, 4):
-    sys.stderr.write("[ERROR] Not a supported Python version. Need 2.4+\n")
-    sys.exit(1)
-
-# NOTE: The directory containing setup.py, whether run by 'python setup.py' or
-# './setup.py' or the equivalent with another path, should always be at the
-# start of the path, so this should find the right one...
 import bzrlib
 
-def get_long_description():
-    dirname = os.path.dirname(__file__)
-    readme = os.path.join(dirname, 'README')
-    f = open(readme, 'rb')
-    try:
-        return f.read()
-    finally:
-        f.close()
-
-
 ##
 # META INFORMATION FOR SETUP
-# see http://docs.python.org/dist/meta-data.html
-META_INFO = {
-    'name':         'bzr',
-    'version':      bzrlib.__version__,
-    'author':       'Canonical Ltd',
-    'author_email': 'bazaar@lists.canonical.com',
-    'url':          'http://www.bazaar-vcs.org/',
-    'description':  'Friendly distributed version control system',
-    'license':      'GNU GPL v2',
-    'download_url': 'http://bazaar-vcs.org/Download',
-    'long_description': get_long_description(),
-    'classifiers': [
-        'Development Status :: 6 - Mature',
-        'Environment :: Console',
-        'Intended Audience :: Developers',
-        'Intended Audience :: System Administrators',
-        'License :: OSI Approved :: GNU General Public License (GPL)',
-        'Operating System :: Microsoft :: Windows',
-        'Operating System :: OS Independent',
-        'Operating System :: POSIX',
-        'Programming Language :: Python',
-        'Programming Language :: C',
-        'Topic :: Software Development :: Version Control',
-        ],
-    }
+
+META_INFO = {'name':         'bzr',
+             'version':      bzrlib.__version__,
+             'author':       'Canonical Ltd',
+             'author_email': 'bazaar@lists.canonical.com',
+             'url':          'http://www.bazaar-vcs.org/',
+             'description':  'Friendly distributed version control system',
+             'license':      'GNU GPL v2',
+            }
 
 # The list of packages is automatically generated later. Add other things
 # that are part of BZRLIB here.
@@ -64,10 +30,38 @@
 PKG_DATA = {# install files from selftest suite
             'package_data': {'bzrlib': ['doc/api/*.txt',
                                         'tests/test_patches_data/*',
-                                        'help_topics/en/*.txt',
                                        ]},
            }
 
+######################################################################
+# Reinvocation stolen from bzr, we need python2.4 by virtue of bzr_man
+# including bzrlib.help
+
+try:
+    version_info = sys.version_info
+except AttributeError:
+    version_info = 1, 5 # 1.5 or older
+
+REINVOKE = "__BZR_REINVOKE"
+NEED_VERS = (2, 4)
+KNOWN_PYTHONS = ('python2.4',)
+
+if version_info < NEED_VERS:
+    if not os.environ.has_key(REINVOKE):
+        # mutating os.environ doesn't work in old Pythons
+        os.putenv(REINVOKE, "1")
+        for python in KNOWN_PYTHONS:
+            try:
+                os.execvp(python, [python] + sys.argv)
+            except OSError:
+                pass
+    sys.stderr.write("bzr: error: cannot find a suitable python interpreter\n")
+    sys.stderr.write("  (need %d.%d or later)" % NEED_VERS)
+    sys.stderr.write('\n')
+    sys.exit(1)
+if getattr(os, "unsetenv", None) is not None:
+    os.unsetenv(REINVOKE)
+
 
 def get_bzrlib_packages():
     """Recurse through the bzrlib directory, and extract the package names"""
@@ -95,7 +89,6 @@
 
 from distutils.core import setup
 from distutils.command.install_scripts import install_scripts
-from distutils.command.install_data import install_data
 from distutils.command.build import build
 
 ###############################
@@ -217,24 +210,16 @@
     pyrex_name = path + '.pyx'
     c_name = path + '.c'
     if have_pyrex:
-        ext_modules.append(Extension(module_name, [pyrex_name], **kwargs))
+        ext_modules.append(Extension(module_name, [pyrex_name]))
     else:
         if not os.path.isfile(c_name):
             unavailable_files.append(c_name)
         else:
-            ext_modules.append(Extension(module_name, [c_name], **kwargs))
-
-
-add_pyrex_extension('bzrlib._btree_serializer_c')
+            ext_modules.append(Extension(module_name, [c_name]))
+
+
 add_pyrex_extension('bzrlib._dirstate_helpers_c')
 add_pyrex_extension('bzrlib._knit_load_data_c')
-add_pyrex_extension('bzrlib._readdir_pyx')
-if sys.platform == 'win32':
-    # pyrex uses the macro WIN32 to detect the platform, even though it should
-    # be using something like _WIN32 or MS_WINDOWS, oh well, we can give it the
-    # right value.
-    add_pyrex_extension('bzrlib._walkdirs_win32',
-                        define_macros=[('WIN32', None)])
 ext_modules.append(Extension('bzrlib._patiencediff_c', ['bzrlib/_patiencediff_c.c']))
 
 
@@ -245,133 +230,13 @@
     print
 
 
-def get_tbzr_py2exe_info(includes, excludes, packages, console_targets,
-                         gui_targets):
-    packages.append('tbzrcommands')
-
-    # ModuleFinder can't handle runtime changes to __path__, but
-    # win32com uses them.  Hook this in so win32com.shell is found.
-    import modulefinder
-    import win32com
-    import cPickle as pickle
-    for p in win32com.__path__[1:]:
-        modulefinder.AddPackagePath("win32com", p)
-    for extra in ["win32com.shell"]:
-        __import__(extra)
-        m = sys.modules[extra]
-        for p in m.__path__[1:]:
-            modulefinder.AddPackagePath(extra, p)
-
-    # TBZR points to the TBZR directory
-    tbzr_root = os.environ["TBZR"]
-
-    # Ensure tbzrlib itself is on sys.path
-    sys.path.append(tbzr_root)
-
-    # Ensure our COM "entry-point" is on sys.path
-    sys.path.append(os.path.join(tbzr_root, "shellext", "python"))
-
-    packages.append("tbzrlib")
-
-    # collect up our icons.
-    cwd = os.getcwd()
-    ico_root = os.path.join(tbzr_root, 'tbzrlib', 'resources')
-    icos = [] # list of (path_root, relative_ico_path)
-    # First always bzr's icon and its in the root of the bzr tree.
-    icos.append(('', 'bzr.ico'))
-    for root, dirs, files in os.walk(ico_root):
-        icos.extend([(ico_root, os.path.join(root, f)[len(ico_root)+1:])
-                     for f in files if f.endswith('.ico')])
-    # allocate an icon ID for each file and the full path to the ico
-    icon_resources = [(rid, os.path.join(ico_dir, ico_name))
-                      for rid, (ico_dir, ico_name) in enumerate(icos)]
-    # create a string resource with the mapping.  Might as well save the
-    # runtime some effort and write a pickle.
-    # Runtime expects unicode objects with forward-slash seps.
-    fse = sys.getfilesystemencoding()
-    map_items = [(f.replace('\\', '/').decode(fse), rid)
-                 for rid, (_, f) in enumerate(icos)]
-    ico_map = dict(map_items)
-    # Create a new resource type of 'ICON_MAP', and use ID=1
-    other_resources = [ ("ICON_MAP", 1, pickle.dumps(ico_map))]
-
-    excludes.extend("""pywin pywin.dialogs pywin.dialogs.list
-                       win32ui crawler.Crawler""".split())
-
-    tbzr = dict(
-        modules=["tbzr"],
-        create_exe = False, # we only want a .dll
-    )
-    com_targets.append(tbzr)
-
-    # tbzrcache executables - a "console" version for debugging and a
-    # GUI version that is generally used.
-    tbzrcache = dict(
-        script = os.path.join(tbzr_root, "Scripts", "tbzrcache.py"),
-        icon_resources = icon_resources,
-        other_resources = other_resources,
-    )
-    console_targets.append(tbzrcache)
-
-    # Make a windows version which is the same except for the base name.
-    tbzrcachew = tbzrcache.copy()
-    tbzrcachew["dest_base"]="tbzrcachew"
-    gui_targets.append(tbzrcachew)
-
-    # ditto for the tbzrcommand tool
-    tbzrcommand = dict(
-        script = os.path.join(tbzr_root, "Scripts", "tbzrcommand.py"),
-        icon_resources = [(0,'bzr.ico')],
-    )
-    console_targets.append(tbzrcommand)
-    tbzrcommandw = tbzrcommand.copy()
-    tbzrcommandw["dest_base"]="tbzrcommandw"
-    gui_targets.append(tbzrcommandw)
-    
-    # tbzr tests
-    tbzrtest = dict(
-        script = os.path.join(tbzr_root, "Scripts", "tbzrtest.py"),
-    )
-    console_targets.append(tbzrtest)
-
-    # A utility to see python output from the shell extension - this will
-    # die when we get a c++ extension
-    # any .py file from pywin32's win32 lib will do (other than
-    # win32traceutil itself that is)
-    import winerror
-    win32_lib_dir = os.path.dirname(winerror.__file__)
-    tracer = dict(script = os.path.join(win32_lib_dir, "win32traceutil.py"),
-                  dest_base="tbzr_tracer")
-    console_targets.append(tracer)
-
-
-def get_qbzr_py2exe_info(includes, excludes, packages):
-    # PyQt4 itself still escapes the plugin detection code for some reason...
-    packages.append('PyQt4')
-    excludes.append('PyQt4.elementtree.ElementTree')
-    includes.append('sip') # extension module required for Qt.
-    packages.append('pygments') # colorizer for qbzr
-    # but we can avoid many Qt4 Dlls.
-    dll_excludes.extend(
-        """QtAssistantClient4.dll QtCLucene4.dll QtDesigner4.dll
-        QtHelp4.dll QtNetwork4.dll QtOpenGL4.dll QtScript4.dll
-        QtSql4.dll QtTest4.dll QtWebKit4.dll QtXml4.dll
-        qscintilla2.dll""".split())
-    # the qt binaries might not be on PATH...
-    qt_dir = os.path.join(sys.prefix, "PyQt4", "bin")
-    path = os.environ.get("PATH","")
-    if qt_dir.lower() not in [p.lower() for p in path.split(os.pathsep)]:
-        os.environ["PATH"] = path + os.pathsep + qt_dir
-
-
 if 'bdist_wininst' in sys.argv:
     def find_docs():
         docs = []
         for root, dirs, files in os.walk('doc'):
             r = []
             for f in files:
-                if (os.path.splitext(f)[1] in ('.html','.css','.png','.pdf')
-                    or f == 'quick-start-summary.svg'):
+                if os.path.splitext(f)[1] in ('.html', '.css'):
                     r.append(os.path.join(root, f))
             if r:
                 relative = root[4:]
@@ -398,7 +263,6 @@
     setup(**ARGS)
 
 elif 'py2exe' in sys.argv:
-    import glob
     # py2exe setup
     import py2exe
 
@@ -414,30 +278,6 @@
         version_number.append(str(i))
     version_str = '.'.join(version_number)
 
-    # An override to install_data used only by py2exe builds, which arranges
-    # to byte-compile any .py files in data_files (eg, our plugins)
-    # Necessary as we can't rely on the user having the relevant permissions
-    # to the "Program Files" directory to generate them on the fly.
-    class install_data_with_bytecompile(install_data):
-        def run(self):
-            from distutils.util import byte_compile
-
-            install_data.run(self)
-
-            py2exe = self.distribution.get_command_obj('py2exe', False)
-            optimize = py2exe.optimize
-            compile_names = [f for f in self.outfiles if f.endswith('.py')]
-            byte_compile(compile_names,
-                         optimize=optimize,
-                         force=self.force, prefix=self.install_dir,
-                         dry_run=self.dry_run)
-            if optimize:
-                suffix = 'o'
-            else:
-                suffix = 'c'
-            self.outfiles.extend([f + suffix for f in compile_names])
-    # end of class install_data_with_bytecompile
-
     target = py2exe.build_exe.Target(script = "bzr",
                                      dest_base = "bzr",
                                      icon_resources = [(0,'bzr.ico')],
@@ -450,129 +290,31 @@
                                      comments = META_INFO['description'],
                                     )
 
-    packages = BZRLIB['packages']
-    packages.remove('bzrlib')
-    packages = [i for i in packages if not i.startswith('bzrlib.plugins')]
-    includes = []
-    for i in glob.glob('bzrlib\\*.py'):
-        module = i[:-3].replace('\\', '.')
-        if module.endswith('__init__'):
-            module = module[:-len('__init__')]
-        includes.append(module)
-
-    additional_packages = set()
+    additional_packages =  []
     if sys.version.startswith('2.4'):
         # adding elementtree package
-        additional_packages.add('elementtree')
+        additional_packages.append('elementtree')
     elif sys.version.startswith('2.5'):
-        additional_packages.add('xml.etree')
+        additional_packages.append('xml.etree')
     else:
         import warnings
         warnings.warn('Unknown Python version.\n'
                       'Please check setup.py script for compatibility.')
-
-    # Although we currently can't enforce it, we consider it an error for
-    # py2exe to report any files are "missing".  Such modules we know aren't
-    # used should be listed here.
-    excludes = """Tkinter psyco ElementPath r_hmac
-                  ImaginaryModule cElementTree elementtree.ElementTree
-                  Crypto.PublicKey._fastmath
-                  medusa medusa.filesys medusa.ftp_server
-                  tools tools.doc_generate
-                  resource validate""".split()
-    dll_excludes = []
-
     # email package from std python library use lazy import,
     # so we need to explicitly add all package
-    additional_packages.add('email')
-    # And it uses funky mappings to conver to 'Oldname' to 'newname'.  As
-    # a result, packages like 'email.Parser' show as missing.  Tell py2exe
-    # to exclude them.
-    import email
-    for oldname in getattr(email, '_LOWERNAMES', []):
-        excludes.append("email." + oldname)
-    for oldname in getattr(email, '_MIMENAMES', []):
-        excludes.append("email.MIME" + oldname)
-
-    # text files for help topis
-    text_topics = glob.glob('bzrlib/help_topics/en/*.txt')
-    topics_files = [('lib/help_topics/en', text_topics)]
-
-    # built-in plugins
-    plugins_files = []
-    # XXX - should we consider having the concept of an 'official' build,
-    # which hard-codes the list of plugins, gets more upset if modules are
-    # missing, etc?
-    plugins = None # will be a set after plugin sniffing...
-    for root, dirs, files in os.walk('bzrlib/plugins'):
-        if root == 'bzrlib/plugins':
-            plugins = set(dirs)
-        x = []
-        for i in files:
-            if os.path.splitext(i)[1] not in [".py", ".pyd", ".dll"]:
-                continue
-            if i == '__init__.py' and root == 'bzrlib/plugins':
-                continue
-            x.append(os.path.join(root, i))
-        if x:
-            target_dir = root[len('bzrlib/'):]  # install to 'plugins/...'
-            plugins_files.append((target_dir, x))
-    # find modules for built-in plugins
-    import tools.package_mf
-    mf = tools.package_mf.CustomModuleFinder()
-    mf.run_package('bzrlib/plugins')
-    packs, mods = mf.get_result()
-    additional_packages.update(packs)
-    includes.extend(mods)
-
-    console_targets = [target,
-                       'tools/win32/bzr_postinstall.py',
-                       ]
-    gui_targets = []
-    com_targets = []
-
-    if 'qbzr' in plugins:
-        get_qbzr_py2exe_info(includes, excludes, packages)
-
-    if "TBZR" in os.environ:
-        # TORTOISE_OVERLAYS_MSI_WIN32 must be set to the location of the
-        # TortoiseOverlays MSI installer file. It is in the TSVN svn repo and
-        # can be downloaded from (username=guest, blank password):
-        # http://tortoisesvn.tigris.org/svn/tortoisesvn/TortoiseOverlays/version-1.0.4/bin/TortoiseOverlays-1.0.4.11886-win32.msi
-        if not os.path.isfile(os.environ.get('TORTOISE_OVERLAYS_MSI_WIN32',
-                                             '<nofile>')):
-            raise RuntimeError("Please set TORTOISE_OVERLAYS_MSI_WIN32 to the"
-                               " location of the Win32 TortoiseOverlays .msi"
-                               " installer file")
-        get_tbzr_py2exe_info(includes, excludes, packages, console_targets,
-                             gui_targets)
-    else:
-        # print this warning to stderr as output is redirected, so it is seen
-        # at build time.  Also to stdout so it appears in the log
-        for f in (sys.stderr, sys.stdout):
-            print >> f, \
-                "Skipping TBZR binaries - please set TBZR to a directory to enable"
-
-    # MSWSOCK.dll is a system-specific library, which py2exe accidentally pulls
-    # in on Vista.
-    dll_excludes.append("MSWSOCK.dll")
-    options_list = {"py2exe": {"packages": packages + list(additional_packages),
-                               "includes": includes,
-                               "excludes": excludes,
-                               "dll_excludes": dll_excludes,
+    additional_packages.append('email')
+
+    options_list = {"py2exe": {"packages": BZRLIB['packages'] +
+                                           additional_packages,
+                               "excludes": ["Tkinter", "medusa", "tools"],
                                "dist_dir": "win32_bzr.exe",
-                               "optimize": 1,
                               },
                    }
-
     setup(options=options_list,
-          console=console_targets,
-          windows=gui_targets,
-          com_server=com_targets,
-          zipfile='lib/library.zip',
-          data_files=topics_files + plugins_files,
-          cmdclass={'install_data': install_data_with_bytecompile},
-          )
+          console=[target,
+                   'tools/win32/bzr_postinstall.py',
+                  ],
+          zipfile='lib/library.zip')
 
 else:
     # ad-hoc for easy_install

=== modified file 'tools/doc_generate/autodoc_rstx.py'
--- tools/doc_generate/autodoc_rstx.py	2008-07-19 15:00:27 +0000
+++ tools/doc_generate/autodoc_rstx.py	2007-08-07 19:18:38 +0000
@@ -29,7 +29,6 @@
 import bzrlib.help
 import bzrlib.help_topics
 import bzrlib.commands
-import bzrlib.osutils
 
 
 def get_filename(options):
@@ -47,38 +46,26 @@
              "timestamp": time.strftime("%Y-%m-%d %H:%M:%S +0000",tt),
              "version": bzrlib.__version__,
              }
-    nominated_filename = getattr(options, 'filename', None)
-    if nominated_filename is None:
-        topic_dir = None
-    else:
-        topic_dir = bzrlib.osutils.dirname(nominated_filename)
     outfile.write(rstx_preamble % params)
     outfile.write(rstx_head % params)
-    outfile.write(_get_body(params, topic_dir))
+    outfile.write(_get_body(params))
     outfile.write(rstx_foot % params)
 
 
-def _get_body(params, topic_dir):
+def _get_body(params):
     """Build the manual content."""
     from bzrlib.help_topics import SECT_CONCEPT, SECT_LIST, SECT_PLUGIN
     registry = bzrlib.help_topics.topic_registry
     result = []
-    result.append(_get_section(registry, SECT_CONCEPT, "Concepts",
-        output_dir=topic_dir))
-    result.append(_get_section(registry, SECT_LIST, "Lists",
-        output_dir=topic_dir))
+    result.append(_get_section(registry, SECT_CONCEPT, "Concepts"))
+    result.append(_get_section(registry, SECT_LIST, "Lists"))
     result.append(_get_commands_section(registry))
-    #result.append(_get_section(registry, SECT_PLUGIN, "Standard Plug-ins"))
+    #result.append(_get_section(registry, SECT_PLUGIN, "Core Plug-ins"))
     return "\n".join(result)
 
 
-def _get_section(registry, section, title, hdg_level1="#", hdg_level2="=",
-        output_dir=None):
-    """Build the manual part from topics matching that section.
-    
-    If output_dir is not None, topics are dumped into text files there
-    during processing, as well as being included in the return result.
-    """
+def _get_section(registry, section, title, hdg_level1="=", hdg_level2="-"):
+    """Build the manual part from topics matching that section."""
     topics = sorted(registry.get_topics_for_section(section))
     lines = [title, hdg_level1 * len(title), ""]
 
@@ -99,17 +86,12 @@
         help = registry.get_detail(topic)
         heading,text = help.split("\n", 1)
         lines.append(heading)
-        if not text.startswith(hdg_level2):
-            lines.append(hdg_level2 * len(heading))
+        lines.append(hdg_level2 * len(heading))
         lines.append(text)
         lines.append('')
         # check that topic match heading
         if topic != heading.lower():
             links_glue.append((topic, heading))
-        # dump the text if requested
-        if output_dir is not None:
-            out_file = bzrlib.osutils.pathjoin(output_dir, topic + ".txt")
-            _dump_text(out_file, help)
 
     # provide links glue for topics that don't match headings
     lines.extend([".. _%s: `%s`_" % i for i in links_glue])
@@ -118,16 +100,9 @@
     return "\n" + "\n".join(lines) + "\n"
 
 
-def _dump_text(filename, text):
-    """Dump text to filename."""
-    f =  open(filename, "w")
-    f.writelines(text)
-    f.close()
-
-
-def _get_commands_section(registry, title="Commands", hdg_level1="#",
-                          hdg_level2="="):
-    """Build the commands reference section of the manual."""
+def _get_commands_section(registry, title="Commands", hdg_level1="=",
+                          hdg_level2="-"):
+    """Build the comands reference section of the manual."""
     lines = [title, hdg_level1 * len(title), ""]
     cmds = sorted(bzrlib.commands.builtin_command_names())
     for cmd_name in cmds:
@@ -157,19 +132,19 @@
 
 
 rstx_head = """\
-#####################
+=====================
 Bazaar User Reference
-#####################
+=====================
 
 :Version:   %(version)s
 :Generated: %(datestamp)s
 
-.. contents:: :depth: 2
+.. contents::
 
 -----
 
 About This Manual
-#################
+=================
 
 This manual is generated from Bazaar's online help. To use
 the online help system, try the following commands.

=== removed file 'tools/package_mf.py'
--- tools/package_mf.py	2008-02-07 07:53:19 +0000
+++ tools/package_mf.py	1970-01-01 00:00:00 +0000
@@ -1,89 +0,0 @@
-# Copyright (C) 2008 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Custom module finder for entire package"""
-
-import modulefinder
-import os
-import sys
-
-
-class CustomModuleFinder(modulefinder.ModuleFinder):
-    """Custom module finder for processing python packages,
-    e.g. bzr plugins packages.
-
-    :param  path:   list of directories to search for modules;
-                    if not specified, python standard library only is used.
-    """
-
-    def __init__(self, path=None, debug=0, excludes=[], replace_paths=[]):
-        if path is None:
-            path = [os.path.dirname(os.__file__)]    # only python std lib
-        modulefinder.ModuleFinder.__init__(self, path, debug, excludes,
-            replace_paths)
-
-    def run_package(self, package_path):
-        """Recursively process each module in package with run_script method.
-
-        :param  package_path:   path to package directory.
-        """
-        stack = [package_path]
-        while stack:
-            curdir = stack.pop(0)
-            py = os.listdir(curdir)
-            for i in py:
-                full = os.path.join(curdir, i)
-                if os.path.isdir(full):
-                    init = os.path.join(full, '__init__.py')
-                    if os.path.isfile(init):
-                        stack.append(full)
-                    continue
-                if not i.endswith('.py'):
-                    continue
-                if i == 'setup.py':     # skip
-                    continue
-                self.run_script(full)
-
-    def get_result(self):
-        """Return 2-tuple: (list of packages, list of modules)"""
-        keys = self.modules.keys()
-        keys.sort()
-        mods = []
-        packs = []
-        for key in keys:
-            m = self.modules[key]
-            if not m.__file__:      # skip builtins
-                continue
-            if m.__path__:
-                packs.append(key)
-            elif key != '__main__':
-                mods.append(key)
-        return (packs, mods)
-
-
-if __name__ == '__main__':
-    package = sys.argv[1]
-
-    mf = CustomModuleFinder()
-    mf.run_package(package)
-
-    packs, mods = mf.get_result()
-
-    print 'Packages:'
-    print packs
-
-    print 'Modules:'
-    print mods

=== removed directory 'tools/packaging'
=== removed file 'tools/packaging/build-packages.sh'
--- tools/packaging/build-packages.sh	2008-08-25 21:50:11 +0000
+++ tools/packaging/build-packages.sh	1970-01-01 00:00:00 +0000
@@ -1,6 +0,0 @@
-#!/bin/bash
-# A helper script to build packages for the various distributions
-
-for DISTRO in $UBUNTU_RELEASES; do
-    (cd "packaging-$DISTRO" && bzr builddeb -S)
-done

=== removed file 'tools/packaging/update-changelogs.sh'
--- tools/packaging/update-changelogs.sh	2008-08-25 21:50:11 +0000
+++ tools/packaging/update-changelogs.sh	1970-01-01 00:00:00 +0000
@@ -1,21 +0,0 @@
-#!/bin/bash
-
-if [ "x$1" = "x" ]; then
-    echo "Missing version"
-    echo "You want something like:"
-    echo "  update-changelogs.sh 1.6~rc1-1~bazaar1"
-    echo "or"
-    echo "  update-changelogs.sh 1.6-1~bazaar1"
-    exit
-fi
-VERSION=$1
-
-for DISTRO in $UBUNTU_RELEASES; do
-    PPAVERSION="$VERSION~${DISTRO}1"
-    (
-        echo "Updating changelog for $DISTRO"
-	cd "packaging-$DISTRO" &&
-	dch -v $PPAVERSION -D $DISTRO -c changelog 'New upstream release.' &&
-	bzr commit -m "New upstream release: $PPAVERSION"
-    )
-done

=== removed file 'tools/packaging/update-packaging-branches.sh'
--- tools/packaging/update-packaging-branches.sh	2008-08-25 21:50:11 +0000
+++ tools/packaging/update-packaging-branches.sh	1970-01-01 00:00:00 +0000
@@ -1,20 +0,0 @@
-#!/bin/bash
-# Helper for updating all of the packaging branches
-
-if [ -z "$UBUNTU_RELEASES" ]; then
-    echo "Configure the distro platforms that you want to"
-    echo "build with a line like:"
-    echo '  export UBUNTU_RELEASES="dapper feisty gutsy hardy intrepid"'
-    exit 1
-fi
-
-for DISTRO in $UBUNTU_RELEASES; do
-    if [ -d "packaging-$DISTRO" ] ; then
-        echo "Updating packaging-$DISTRO"
-        bzr update packaging-$DISTRO
-    else
-        echo "Checking out lp:~bzr/bzr/packaging-$DISTRO"
-        bzr co lp:~bzr/bzr/packaging-$DISTRO
-    fi
-done
-

=== modified file 'tools/rst2html.py'
--- tools/rst2html.py	2008-07-17 01:08:21 +0000
+++ tools/rst2html.py	2007-08-07 14:56:50 +0000
@@ -1,10 +1,10 @@
-#! /usr/bin/env python
+#!/usr/bin/env python
 
-# Originally by Dave Goodger, from the docutils, distribution.
-#
-# Modified for Bazaar to accommodate options containing dots
-#
-# This file is in the public domain.
+# Author: David Goodger
+# Contact: goodger@python.org
+# Revision: $Revision: 3901 $
+# Date: $Date: 2005-09-25 17:49:54 +0200 (Sun, 25 Sep 2005) $
+# Copyright: This module has been placed in the public domain.
 
 """
 A minimal front end to the Docutils Publisher, producing HTML.
@@ -16,20 +16,8 @@
 except:
     pass
 
-import docutils
 from docutils.core import publish_cmdline, default_description
 
-if True: # this is still required in the distutils trunk as-at June 2008.
-    from docutils.parsers.rst.states import Body
-    # we have some option names that contain dot; which is not allowed by
-    # python-docutils 0.4-4 -- so monkeypatch in a better pattern
-    #
-    # This is a bit gross to patch because all this is built up at load time.
-    Body.pats['optname'] = r'[a-zA-Z0-9][a-zA-Z0-9._-]*'    
-    Body.pats['longopt'] = r'(--|/)%(optname)s([ =]%(optarg)s)?' % Body.pats
-    Body.pats['option'] = r'(%(shortopt)s|%(longopt)s)' % Body.pats
-    Body.patterns['option_marker'] = r'%(option)s(, %(option)s)*(  +| ?$)' % Body.pats
-
 
 description = ('Generates (X)HTML documents from standalone reStructuredText '
                'sources.  ' + default_description)

=== modified file 'tools/win32/bzr-win32-bdist-postinstall.py'
--- tools/win32/bzr-win32-bdist-postinstall.py	2007-10-26 21:49:15 +0000
+++ tools/win32/bzr-win32-bdist-postinstall.py	2007-08-02 10:28:36 +0000
@@ -132,14 +132,3 @@
                     args,
                     os.path.join(sys.exec_prefix, 'Scripts'))
     file_created(dst)
-
-    # uninstall shortcut
-    uninst = os.path.join(sys.exec_prefix, 'Removebzr.exe')
-    dst = os.path.join(fldr, 'Uninstall Bazaar.lnk')
-    create_shortcut(uninst,
-                    'Uninstall Bazaar',
-                    dst,
-                    '-u bzr-wininst.log',
-                    sys.exec_prefix,
-                    )
-    file_created(dst)

=== modified file 'tools/win32/bzr.iss.cog'
--- tools/win32/bzr.iss.cog	2008-08-18 09:29:36 +0000
+++ tools/win32/bzr.iss.cog	2007-08-09 08:04:32 +0000
@@ -42,10 +42,11 @@
 
 SetupIconFile="..\bzr.ico"
 InfoBeforeFile="..\tools\win32\info.txt"
+InfoAfterFile="..\tools\win32\survey.txt"
 
 VersionInfoCompany="Canonical Ltd."
-VersionInfoCopyright="Canonical Ltd., 2005-2008"
-VersionInfoDescription="Windows installer for Bazaar"
+VersionInfoCopyright="Canonical Ltd., 2005-2007"
+VersionInfoDescription="Installer for stand-alone bzr.exe"
 ; [[[cog
 ; import bzrlib
 ; version_number = []
@@ -78,43 +79,13 @@
 ; [[[end]]]
 
 ChangesEnvironment=yes
-; MARKH: PrivilegesRequired=none means it can't be installed by a non-admin
-; user - but sadly we still need admin - eg, tortoise overlays, installing
-; into "\Program Files", installing COM objects etc all must be done by an
-; admin.
-PrivilegesRequired=admin
+PrivilegesRequired=none
+
 
 [Files]
-; Tortoise files - these are at the top as we use 'ExtractTemporaryFile' on
-; the TortoiseOverlays MSI, and inno documents such files should be at the
-; start for best performance.
-; [[[cog
-; if "TBZR" in os.environ: # we need a more formal way of controlling this...
-;     tovmsi = os.environ["TORTOISE_OVERLAYS_MSI_WIN32"] # point at TortoiseOverlays .msi
-;     cog.outl('Source: "%s"; Flags: dontcopy ignoreversion ; Components: tortoise' % tovmsi)
-;     cog.outl('Source: "tbzrcache.exe"; DestDir: "{app}"; Flags: ignoreversion restartreplace uninsrestartdelete; Components: tortoise')
-;     cog.outl('Source: "tbzrcachew.exe"; DestDir: "{app}"; Flags: ignoreversion restartreplace uninsrestartdelete; Components: tortoise')
-;     cog.outl('Source: "tbzrcommand.exe"; DestDir: "{app}"; Flags: ignoreversion restartreplace uninsrestartdelete; Components: tortoise')
-;     cog.outl('Source: "tbzrcommandw.exe"; DestDir: "{app}"; Flags: ignoreversion restartreplace uninsrestartdelete; Components: tortoise')
-;     cog.outl('Source: "tbzr_tracer.exe"; DestDir: "{app}"; Flags: ignoreversion restartreplace uninsrestartdelete; Components: debug')
-;     # Note 'regserver' here appears to run regsvr32 without elevation, which
-;     # is no good for us - so we have a [run] entry below.
-;     cog.outl('Source: "tbzr.dll"; DestDir: "{app}"; Flags: ignoreversion regserver restartreplace uninsrestartdelete; Components: tortoise')
-;     cog.outl(r'Source: "plugins\qbzr\*"; DestDir: "{app}\plugins\qbzr"; Flags: createallsubdirs ignoreversion recursesubdirs restartreplace uninsrestartdelete; Components: tortoise')
-;
-;     cog.outl('Source: "%s\\doc\\index.html"; DestDir: "{app}\\doc\\tbzr"; Flags: ignoreversion; Components: tortoise' % os.environ['TBZR'])
-; ]]]
-; [[[end]]]
-
-; We can't say '*.*' due to optional components.
-Source: "plugins\*.*"; DestDir: "{app}\\plugins"; Flags: createallsubdirs ignoreversion recursesubdirs restartreplace uninsrestartdelete; Components: plugins
-Source: "*.bat"; DestDir: "{app}"; Flags: ignoreversion restartreplace uninsrestartdelete;
-Source: "*.url"; DestDir: "{app}"; Flags: ignoreversion restartreplace uninsrestartdelete;
-Source: "msvc*.dll"; DestDir: "{app}"; Flags: ignoreversion restartreplace uninsrestartdelete;
-Source: "bz*.exe"; DestDir: "{app}"; Flags: ignoreversion restartreplace uninsrestartdelete;
-Source: "Python*.dll"; DestDir: "{app}"; Flags: ignoreversion restartreplace uninsrestartdelete;
-Source: "lib\*.*"; DestDir: "{app}\lib"; Flags: createallsubdirs ignoreversion recursesubdirs restartreplace uninsrestartdelete;
-Source: "doc\*.*"; DestDir: "{app}\doc"; Flags: createallsubdirs ignoreversion recursesubdirs restartreplace uninsrestartdelete;
+Source: "*.*"; DestDir: "{app}"; Flags: ignoreversion;
+Source: "lib\*.*"; DestDir: "{app}\lib"; Flags: createallsubdirs ignoreversion recursesubdirs;
+Source: "doc\*.*"; DestDir: "{app}\doc"; Flags: createallsubdirs ignoreversion recursesubdirs;
 ; [[[cog
 ; try:
 ;     import pycurl
@@ -133,151 +104,47 @@
 ; ]]]
 ; [[[end]]]
 
-[Types]
-Name: "typical"; Description: "A typical installation"
-Name: "full"; Description: "Full Installation (typical installation plus test utilities)"
-Name: "compact"; Description: "Compact installation"
-Name: "custom"; Description: "Custom installation"; Flags: iscustom
 
 [Components]
-Name: "main"; Description: "Main Files"; Types: full typical compact custom; Flags: fixed
-Name: "plugins"; Description: "Default plugins"; Types: full typical custom;
+Name: "main"; Description: "Main Files"; Types: full compact custom; Flags: fixed
 ; [[[cog
 ; if ca_path:
 ;     cog.outl('Name: "cabundle"; '
 ;              'Description: "CA certificates for SSL support"; '
-;              'Types: full typical custom')
-; if "TBZR" in os.environ: # we need a more formal way of controlling this...
-;     cog.outl('Name: "tortoise"; Description: "Windows Shell Extensions (TortoiseBZR) - EXPERIMENTAL"; Types: full typical custom;')
-;     cog.outl('Name: "debug"; Description: "Test, diagnostic and debugging utilities"; Types: full custom;')
-;
+;              'Types: full custom')
 ; ]]]
 ; [[[end]]]
 
+
 [Dirs]
 Name: "{userappdata}\bazaar\2.0"
-Name: "{app}\plugins"; Flags: uninsalwaysuninstall
 
 
 [Icons]
 Name: "{group}\Documentation index"; Filename: "{app}\doc\index.html"; WorkingDir: "{app}\doc";
 Name: "{group}\Bazaar Home Page"; Filename: "{app}\bazaar.url"; Comment: "http://www.bazaar-vcs.org";
 Name: "{group}\Start Bzr in cmd shell"; Filename: "{cmd}"; Parameters: "/K start_bzr.bat"; WorkingDir: "{app}"; IconFilename: "{app}\bzr.exe"; Comment: "Open new Bzr session";
-; NOTE: Intent is to change the log file location - the line below will need to change to reflect that.
-Name: "{group}\Open Bzr log file"; Filename: "notepad.exe"; Parameters: "{userdocs}\.bzr.log"; Comment: "Launch notepad to view the bzr log file";
-
-; [[[cog
-; if "TBZR" in os.environ:
-;     cog.outl(r'Name: "{group}\TortoiseBZR documentation"; Filename: "{app}\doc\tbzr\index.html"; Comment: "Launch TortoiseBZR documentation";')
-; ]]]
-; [[[end]]]
-; No Uninstall here - Control Panel will do
+Name: "{group}\Uninstall Bazaar"; Filename: "{uninstallexe}"; IconFileName: "{sys}\shell32.dll"; IconIndex: 101; Comment: "Remove Bzr completely";
 
 
 [Tasks]
-Name: Path; Description: "Add {app} directory to PATH environment variable"
-; [[[cog
-; if "TBZR" in os.environ:
-;     cog.outl('Name: TBZRReadme; Description: "View the TortoiseBZR Readme"; Components: tortoise')
-; ]]]
-; [[[end]]]
-
-
-[Registry]
-Root: HKLM; Subkey: "SOFTWARE\Bazaar"; Flags: noerror uninsdeletekey
-Root: HKLM; Subkey: "SOFTWARE\Bazaar"; ValueName: "InstallPath"; ValueType: string; ValueData: "{app}"; Flags: noerror
-; Don't write stuff that can be implied
-;Root: HKLM; Subkey: "SOFTWARE\Bazaar"; ValueName: "BzrlibPath"; ValueType: string; ValueData: "{app}\lib\library.zip\bzrlib"; Flags: noerror
-;Root: HKLM; Subkey: "SOFTWARE\Bazaar"; ValueName: "PluginsPath"; ValueType: string; ValueData: "{app}\plugins"; Flags: noerror
-;Root: HKLM; Subkey: "SOFTWARE\Bazaar"; ValueName: "PythonPath"; ValueType: string; ValueData: "{app}\lib\library.zip"; Flags: noerror
-; [[[cog cog.outl('Root: HKLM; Subkey: "SOFTWARE\Bazaar"; ValueName: "Version"; ValueType: string; ValueData: "%s"; Flags: noerror' % VERSION) ]]]
-; [[[end]]]
+Name: Path; Description: "Add {app} directory to PATH environment variable";
+Name: Shell; Description: "Add Bzr context menu to shell"; Flags: unchecked
 
 
 [Run]
 Filename: "{app}\bzr_postinstall.exe"; Parameters: "--start-bzr"; Flags: skipifdoesntexist runhidden;
+; [[[cog
+; import os
+; if os.path.isfile('win32_bzr.exe/lib/win32ui.pyd'):	# pywin32 mfc wrapper
+;     cog.outl('Filename: "{app}\bzr_postinstall.exe"; '
+;              'Parameters: "--check-mfc71"; '
+;              'Flags: skipifdoesntexist skipifsilent runhidden;')
+; ]]]
+; [[[end]]]
 Filename: "{app}\bzr_postinstall.exe"; Parameters: "--add-path"; Tasks: Path; Flags: skipifdoesntexist skipifsilent runhidden;
-; [[[cog
-; if "TBZR" in os.environ:
-;     cog.outl('Filename: "regsvr32.exe"; Parameters: "/s tbzr.dll"; WorkingDir: "{app}"; Components: tortoise; Description: "Registering Tortoise"; StatusMsg: "Registering Tortoise"')
-;     cog.outl(r'Filename: "{app}\doc\tbzr\index.html"; Tasks: TBZRReadme; Flags: shellexec')
-; ]]]
-; [[[end]]]
+Filename: "{app}\bzr_postinstall.exe"; Parameters: "--add-shell-menu"; Tasks: Shell; Flags: skipifdoesntexist skipifsilent runhidden;
 
 
 [UninstallRun]
 Filename: "{app}\bzr_postinstall.exe"; Parameters: "--delete-path --delete-shell-menu --silent"; Flags: skipifdoesntexist runhidden; 
-; [[[cog
-; if "TBZR" in os.environ:
-;     cog.outl('Filename: "regsvr32.exe"; Parameters: "/u /s tbzr.dll"; WorkingDir: "{app}"; Components: tortoise; StatusMsg: "Unregistering Tortoise"; Flags: skipifdoesntexist')
-; ]]]
-; [[[end]]]
-
-
-[Code]
-const
-  SHCNF_IDLIST = $0000;
-  SHCNE_ASSOCCHANGED = $08000000;
-  WM_QUIT = 18;
-
-procedure SHChangeNotify(wEventId, uFlags, dwItem1, dwItem2: Integer);
- external 'SHChangeNotify@shell32.dll stdcall';
-
-procedure ShutdownTBZR;
-var
-    hwnd: HWND;
-begin
-// [[[cog
-// if "TBZR" not in os.environ:
-//     cog.outl('        Exit;  // No TSVN set - exit this procedure.')
-// ]]]
-// [[[end]]]
-    // ask the cache process to shut-down.
-    hwnd := FindWindowByClassName('TBZRCache_Taskbar');
-    if hwnd <> 0 then
-        PostMessage(hwnd, WM_QUIT, 1, 0);
-end;
-
-procedure CurStepChanged(CurStep: TSetupStep);
-var
-    S, tovmsi, fqtovmsi, params: String;
-    ErrorCode: Integer;
-begin
-    if CurStep=ssInstall then begin
-        ShutdownTBZR;
-    end;
-
-    if CurStep=ssPostInstall then begin
-        // a couple of post-install tasks
-        if IsComponentSelected('tortoise') then begin
-            // Need to execute:
-            // msiexec /i TortoiseOverlays-1.X.X.XXXX-win32.msi /qn /norestart
-// [[[cog
-// if "TBZR" in os.environ:
-//     import os
-//     cog.outl("tovmsi := '%s';" % os.path.basename(os.environ["TORTOISE_OVERLAYS_MSI_WIN32"]))
-// else:
-//     cog.outl("tovmsi := '';")
-// ]]]
-// [[[end]]]
-            ExtractTemporaryFile(tovmsi);
-            fqtovmsi := AddBackslash(ExpandConstant('{tmp}')) + tovmsi;
-            params := '/i "' + fqtovmsi + '" /qn /norestart';
-            if not ShellExec('', 'msiexec.exe', params, '', SW_HIDE,
-                             ewWaitUntilTerminated, ErrorCode) then
-                MsgBox('Failed to install TortoiseOverlays: ' + SysErrorMessage(ErrorCode),
-                        mbInformation, MB_OK);
-            // Ideally we could be bzr_postinstall.exe this way too, but
-            // its needed at uninstall time.
-        end;
-        // cause explorer to re-fetch handlers.
-        SHChangeNotify(SHCNE_ASSOCCHANGED, SHCNF_IDLIST, 0, 0);
-    end;
-end;
-
-
-function InitializeUninstall(): Boolean; 
-begin
-    ShutdownTBZR;
-    result := True;
-end;

=== removed file 'tools/win32/run_script.py'
--- tools/win32/run_script.py	2008-07-17 00:41:25 +0000
+++ tools/win32/run_script.py	1970-01-01 00:00:00 +0000
@@ -1,16 +0,0 @@
-# A utility that executes a script from our %PYTHON%\Scripts directory.
-# Example usage:
-# 'python run_script.py cog.py arg1 arg2'
-# which will locate %PYTHON_HOME%/Scripts/cog.py and execute it with the args.
-# This is only necessary for Windows, and only when the build process is
-# executed via a cygwin/*nix based make utility, which doesn't honor the
-# PATHEXT environment variable.
-import sys
-import os
-
-if __name__ == '__main__':
-    # clobber me, new sys.argv[0] is the script to run.
-    del sys.argv[0]
-    assert not os.path.isabs(sys.argv[0]), "If you know the FQ path, just use it!"
-    sys.argv[0] = os.path.join(sys.prefix, "Scripts", sys.argv[0])
-    execfile(sys.argv[0])

=== added file 'tools/win32/survey.txt'
--- tools/win32/survey.txt	1970-01-01 00:00:00 +0000
+++ tools/win32/survey.txt	2007-08-10 09:04:38 +0000
@@ -0,0 +1,6 @@
+
+If you would like to help us improve Bazaar by telling us about
+yourself and what we could do better, please register and 
+complete the online survey here: 
+http://www.surveymonkey.com/s.aspx?sm=L94RvLswhKdktrxiHWiX3g_3d_3d
+

